module UnicodeCsv exposing (blocks, text)

{-| -}


{-| Blocks-14.0.0.txt
Date: 2021-01-22, 23:29:00 GMT [KW]
© 2021 Unicode®, Inc.
For terms of use, see <http://www.unicode.org/terms_of_use.html>

Unicode Character Database
For documentation, see <http://www.unicode.org/reports/tr44/>

Format:
Start Code..End Code; Block Name

================================================

Note: When comparing block names, casing, whitespace, hyphens,
and underbars are ignored.
For example, "Latin Extended-A" and "latin extended a" are equivalent.
For more information on the comparison of property values,
see UAX #44: <http://www.unicode.org/reports/tr44/>

All block ranges start with a value where (cp MOD 16) = 0,
and end with a value where (cp MOD 16) = 15. In other words,
the last hexadecimal digit of the start of range is ...0
and the last hexadecimal digit of the end of range is ...F.
This constraint on block ranges guarantees that allocations
are done in terms of whole columns, and that code chart display
never involves splitting columns in the charts.

All code points not explicitly listed for Block
have the value No\_Block.

Property:\\tBlock

@missing: 0000..10FFFF; No\_Block

-}
blocks : String
blocks =
    """0000..007F; Basic Latin
0080..00FF; Latin-1 Supplement
0100..017F; Latin Extended-A
0180..024F; Latin Extended-B
0250..02AF; IPA Extensions
02B0..02FF; Spacing Modifier Letters
0300..036F; Combining Diacritical Marks
0370..03FF; Greek and Coptic
0400..04FF; Cyrillic
0500..052F; Cyrillic Supplement
0530..058F; Armenian
0590..05FF; Hebrew
0600..06FF; Arabic
0700..074F; Syriac
0750..077F; Arabic Supplement
0780..07BF; Thaana
07C0..07FF; NKo
0800..083F; Samaritan
0840..085F; Mandaic
0860..086F; Syriac Supplement
0870..089F; Arabic Extended-B
08A0..08FF; Arabic Extended-A
0900..097F; Devanagari
0980..09FF; Bengali
0A00..0A7F; Gurmukhi
0A80..0AFF; Gujarati
0B00..0B7F; Oriya
0B80..0BFF; Tamil
0C00..0C7F; Telugu
0C80..0CFF; Kannada
0D00..0D7F; Malayalam
0D80..0DFF; Sinhala
0E00..0E7F; Thai
0E80..0EFF; Lao
0F00..0FFF; Tibetan
1000..109F; Myanmar
10A0..10FF; Georgian
1100..11FF; Hangul Jamo
1200..137F; Ethiopic
1380..139F; Ethiopic Supplement
13A0..13FF; Cherokee
1400..167F; Unified Canadian Aboriginal Syllabics
1680..169F; Ogham
16A0..16FF; Runic
1700..171F; Tagalog
1720..173F; Hanunoo
1740..175F; Buhid
1760..177F; Tagbanwa
1780..17FF; Khmer
1800..18AF; Mongolian
18B0..18FF; Unified Canadian Aboriginal Syllabics Extended
1900..194F; Limbu
1950..197F; Tai Le
1980..19DF; New Tai Lue
19E0..19FF; Khmer Symbols
1A00..1A1F; Buginese
1A20..1AAF; Tai Tham
1AB0..1AFF; Combining Diacritical Marks Extended
1B00..1B7F; Balinese
1B80..1BBF; Sundanese
1BC0..1BFF; Batak
1C00..1C4F; Lepcha
1C50..1C7F; Ol Chiki
1C80..1C8F; Cyrillic Extended-C
1C90..1CBF; Georgian Extended
1CC0..1CCF; Sundanese Supplement
1CD0..1CFF; Vedic Extensions
1D00..1D7F; Phonetic Extensions
1D80..1DBF; Phonetic Extensions Supplement
1DC0..1DFF; Combining Diacritical Marks Supplement
1E00..1EFF; Latin Extended Additional
1F00..1FFF; Greek Extended
2000..206F; General Punctuation
2070..209F; Superscripts and Subscripts
20A0..20CF; Currency Symbols
20D0..20FF; Combining Diacritical Marks for Symbols
2100..214F; Letterlike Symbols
2150..218F; Number Forms
2190..21FF; Arrows
2200..22FF; Mathematical Operators
2300..23FF; Miscellaneous Technical
2400..243F; Control Pictures
2440..245F; Optical Character Recognition
2460..24FF; Enclosed Alphanumerics
2500..257F; Box Drawing
2580..259F; Block Elements
25A0..25FF; Geometric Shapes
2600..26FF; Miscellaneous Symbols
2700..27BF; Dingbats
27C0..27EF; Miscellaneous Mathematical Symbols-A
27F0..27FF; Supplemental Arrows-A
2800..28FF; Braille Patterns
2900..297F; Supplemental Arrows-B
2980..29FF; Miscellaneous Mathematical Symbols-B
2A00..2AFF; Supplemental Mathematical Operators
2B00..2BFF; Miscellaneous Symbols and Arrows
2C00..2C5F; Glagolitic
2C60..2C7F; Latin Extended-C
2C80..2CFF; Coptic
2D00..2D2F; Georgian Supplement
2D30..2D7F; Tifinagh
2D80..2DDF; Ethiopic Extended
2DE0..2DFF; Cyrillic Extended-A
2E00..2E7F; Supplemental Punctuation
2E80..2EFF; CJK Radicals Supplement
2F00..2FDF; Kangxi Radicals
2FF0..2FFF; Ideographic Description Characters
3000..303F; CJK Symbols and Punctuation
3040..309F; Hiragana
30A0..30FF; Katakana
3100..312F; Bopomofo
3130..318F; Hangul Compatibility Jamo
3190..319F; Kanbun
31A0..31BF; Bopomofo Extended
31C0..31EF; CJK Strokes
31F0..31FF; Katakana Phonetic Extensions
3200..32FF; Enclosed CJK Letters and Months
3300..33FF; CJK Compatibility
3400..4DBF; CJK Unified Ideographs Extension A
4DC0..4DFF; Yijing Hexagram Symbols
4E00..9FFF; CJK Unified Ideographs
A000..A48F; Yi Syllables
A490..A4CF; Yi Radicals
A4D0..A4FF; Lisu
A500..A63F; Vai
A640..A69F; Cyrillic Extended-B
A6A0..A6FF; Bamum
A700..A71F; Modifier Tone Letters
A720..A7FF; Latin Extended-D
A800..A82F; Syloti Nagri
A830..A83F; Common Indic Number Forms
A840..A87F; Phags-pa
A880..A8DF; Saurashtra
A8E0..A8FF; Devanagari Extended
A900..A92F; Kayah Li
A930..A95F; Rejang
A960..A97F; Hangul Jamo Extended-A
A980..A9DF; Javanese
A9E0..A9FF; Myanmar Extended-B
AA00..AA5F; Cham
AA60..AA7F; Myanmar Extended-A
AA80..AADF; Tai Viet
AAE0..AAFF; Meetei Mayek Extensions
AB00..AB2F; Ethiopic Extended-A
AB30..AB6F; Latin Extended-E
AB70..ABBF; Cherokee Supplement
ABC0..ABFF; Meetei Mayek
AC00..D7AF; Hangul Syllables
D7B0..D7FF; Hangul Jamo Extended-B
D800..DB7F; High Surrogates
DB80..DBFF; High Private Use Surrogates
DC00..DFFF; Low Surrogates
E000..F8FF; Private Use Area
F900..FAFF; CJK Compatibility Ideographs
FB00..FB4F; Alphabetic Presentation Forms
FB50..FDFF; Arabic Presentation Forms-A
FE00..FE0F; Variation Selectors
FE10..FE1F; Vertical Forms
FE20..FE2F; Combining Half Marks
FE30..FE4F; CJK Compatibility Forms
FE50..FE6F; Small Form Variants
FE70..FEFF; Arabic Presentation Forms-B
FF00..FFEF; Halfwidth and Fullwidth Forms
FFF0..FFFF; Specials
10000..1007F; Linear B Syllabary
10080..100FF; Linear B Ideograms
10100..1013F; Aegean Numbers
10140..1018F; Ancient Greek Numbers
10190..101CF; Ancient Symbols
101D0..101FF; Phaistos Disc
10280..1029F; Lycian
102A0..102DF; Carian
102E0..102FF; Coptic Epact Numbers
10300..1032F; Old Italic
10330..1034F; Gothic
10350..1037F; Old Permic
10380..1039F; Ugaritic
103A0..103DF; Old Persian
10400..1044F; Deseret
10450..1047F; Shavian
10480..104AF; Osmanya
104B0..104FF; Osage
10500..1052F; Elbasan
10530..1056F; Caucasian Albanian
10570..105BF; Vithkuqi
10600..1077F; Linear A
10780..107BF; Latin Extended-F
10800..1083F; Cypriot Syllabary
10840..1085F; Imperial Aramaic
10860..1087F; Palmyrene
10880..108AF; Nabataean
108E0..108FF; Hatran
10900..1091F; Phoenician
10920..1093F; Lydian
10980..1099F; Meroitic Hieroglyphs
109A0..109FF; Meroitic Cursive
10A00..10A5F; Kharoshthi
10A60..10A7F; Old South Arabian
10A80..10A9F; Old North Arabian
10AC0..10AFF; Manichaean
10B00..10B3F; Avestan
10B40..10B5F; Inscriptional Parthian
10B60..10B7F; Inscriptional Pahlavi
10B80..10BAF; Psalter Pahlavi
10C00..10C4F; Old Turkic
10C80..10CFF; Old Hungarian
10D00..10D3F; Hanifi Rohingya
10E60..10E7F; Rumi Numeral Symbols
10E80..10EBF; Yezidi
10F00..10F2F; Old Sogdian
10F30..10F6F; Sogdian
10F70..10FAF; Old Uyghur
10FB0..10FDF; Chorasmian
10FE0..10FFF; Elymaic
11000..1107F; Brahmi
11080..110CF; Kaithi
110D0..110FF; Sora Sompeng
11100..1114F; Chakma
11150..1117F; Mahajani
11180..111DF; Sharada
111E0..111FF; Sinhala Archaic Numbers
11200..1124F; Khojki
11280..112AF; Multani
112B0..112FF; Khudawadi
11300..1137F; Grantha
11400..1147F; Newa
11480..114DF; Tirhuta
11580..115FF; Siddham
11600..1165F; Modi
11660..1167F; Mongolian Supplement
11680..116CF; Takri
11700..1174F; Ahom
11800..1184F; Dogra
118A0..118FF; Warang Citi
11900..1195F; Dives Akuru
119A0..119FF; Nandinagari
11A00..11A4F; Zanabazar Square
11A50..11AAF; Soyombo
11AB0..11ABF; Unified Canadian Aboriginal Syllabics Extended-A
11AC0..11AFF; Pau Cin Hau
11C00..11C6F; Bhaiksuki
11C70..11CBF; Marchen
11D00..11D5F; Masaram Gondi
11D60..11DAF; Gunjala Gondi
11EE0..11EFF; Makasar
11FB0..11FBF; Lisu Supplement
11FC0..11FFF; Tamil Supplement
12000..123FF; Cuneiform
12400..1247F; Cuneiform Numbers and Punctuation
12480..1254F; Early Dynastic Cuneiform
12F90..12FFF; Cypro-Minoan
13000..1342F; Egyptian Hieroglyphs
13430..1343F; Egyptian Hieroglyph Format Controls
14400..1467F; Anatolian Hieroglyphs
16800..16A3F; Bamum Supplement
16A40..16A6F; Mro
16A70..16ACF; Tangsa
16AD0..16AFF; Bassa Vah
16B00..16B8F; Pahawh Hmong
16E40..16E9F; Medefaidrin
16F00..16F9F; Miao
16FE0..16FFF; Ideographic Symbols and Punctuation
17000..187FF; Tangut
18800..18AFF; Tangut Components
18B00..18CFF; Khitan Small Script
18D00..18D7F; Tangut Supplement
1AFF0..1AFFF; Kana Extended-B
1B000..1B0FF; Kana Supplement
1B100..1B12F; Kana Extended-A
1B130..1B16F; Small Kana Extension
1B170..1B2FF; Nushu
1BC00..1BC9F; Duployan
1BCA0..1BCAF; Shorthand Format Controls
1CF00..1CFCF; Znamenny Musical Notation
1D000..1D0FF; Byzantine Musical Symbols
1D100..1D1FF; Musical Symbols
1D200..1D24F; Ancient Greek Musical Notation
1D2E0..1D2FF; Mayan Numerals
1D300..1D35F; Tai Xuan Jing Symbols
1D360..1D37F; Counting Rod Numerals
1D400..1D7FF; Mathematical Alphanumeric Symbols
1D800..1DAAF; Sutton SignWriting
1DF00..1DFFF; Latin Extended-G
1E000..1E02F; Glagolitic Supplement
1E100..1E14F; Nyiakeng Puachue Hmong
1E290..1E2BF; Toto
1E2C0..1E2FF; Wancho
1E7E0..1E7FF; Ethiopic Extended-B
1E800..1E8DF; Mende Kikakui
1E900..1E95F; Adlam
1EC70..1ECBF; Indic Siyaq Numbers
1ED00..1ED4F; Ottoman Siyaq Numbers
1EE00..1EEFF; Arabic Mathematical Alphabetic Symbols
1F000..1F02F; Mahjong Tiles
1F030..1F09F; Domino Tiles
1F0A0..1F0FF; Playing Cards
1F100..1F1FF; Enclosed Alphanumeric Supplement
1F200..1F2FF; Enclosed Ideographic Supplement
1F300..1F5FF; Miscellaneous Symbols and Pictographs
1F600..1F64F; Emoticons
1F650..1F67F; Ornamental Dingbats
1F680..1F6FF; Transport and Map Symbols
1F700..1F77F; Alchemical Symbols
1F780..1F7FF; Geometric Shapes Extended
1F800..1F8FF; Supplemental Arrows-C
1F900..1F9FF; Supplemental Symbols and Pictographs
1FA00..1FA6F; Chess Symbols
1FA70..1FAFF; Symbols and Pictographs Extended-A
1FB00..1FBFF; Symbols for Legacy Computing
20000..2A6DF; CJK Unified Ideographs Extension B
2A700..2B73F; CJK Unified Ideographs Extension C
2B740..2B81F; CJK Unified Ideographs Extension D
2B820..2CEAF; CJK Unified Ideographs Extension E
2CEB0..2EBEF; CJK Unified Ideographs Extension F
2F800..2FA1F; CJK Compatibility Ideographs Supplement
30000..3134F; CJK Unified Ideographs Extension G
E0000..E007F; Tags
E0100..E01EF; Variation Selectors Supplement
F0000..FFFFF; Supplementary Private Use Area-A
100000..10FFFF; Supplementary Private Use Area-B
"""


{-| Downloaded from <https://www.unicode.org/Public/UCD/latest/ucd/UnicodeData.txt>
-}
text : String
text =
    """0000;<control>;Cc;0;BN;;;;;N;NULL;;;;
0001;<control>;Cc;0;BN;;;;;N;START OF HEADING;;;;
0002;<control>;Cc;0;BN;;;;;N;START OF TEXT;;;;
0003;<control>;Cc;0;BN;;;;;N;END OF TEXT;;;;
0004;<control>;Cc;0;BN;;;;;N;END OF TRANSMISSION;;;;
0005;<control>;Cc;0;BN;;;;;N;ENQUIRY;;;;
0006;<control>;Cc;0;BN;;;;;N;ACKNOWLEDGE;;;;
0007;<control>;Cc;0;BN;;;;;N;BELL;;;;
0008;<control>;Cc;0;BN;;;;;N;BACKSPACE;;;;
0009;<control>;Cc;0;S;;;;;N;CHARACTER TABULATION;;;;
000A;<control>;Cc;0;B;;;;;N;LINE FEED (LF);;;;
000B;<control>;Cc;0;S;;;;;N;LINE TABULATION;;;;
000C;<control>;Cc;0;WS;;;;;N;FORM FEED (FF);;;;
000D;<control>;Cc;0;B;;;;;N;CARRIAGE RETURN (CR);;;;
000E;<control>;Cc;0;BN;;;;;N;SHIFT OUT;;;;
000F;<control>;Cc;0;BN;;;;;N;SHIFT IN;;;;
0010;<control>;Cc;0;BN;;;;;N;DATA LINK ESCAPE;;;;
0011;<control>;Cc;0;BN;;;;;N;DEVICE CONTROL ONE;;;;
0012;<control>;Cc;0;BN;;;;;N;DEVICE CONTROL TWO;;;;
0013;<control>;Cc;0;BN;;;;;N;DEVICE CONTROL THREE;;;;
0014;<control>;Cc;0;BN;;;;;N;DEVICE CONTROL FOUR;;;;
0015;<control>;Cc;0;BN;;;;;N;NEGATIVE ACKNOWLEDGE;;;;
0016;<control>;Cc;0;BN;;;;;N;SYNCHRONOUS IDLE;;;;
0017;<control>;Cc;0;BN;;;;;N;END OF TRANSMISSION BLOCK;;;;
0018;<control>;Cc;0;BN;;;;;N;CANCEL;;;;
0019;<control>;Cc;0;BN;;;;;N;END OF MEDIUM;;;;
001A;<control>;Cc;0;BN;;;;;N;SUBSTITUTE;;;;
001B;<control>;Cc;0;BN;;;;;N;ESCAPE;;;;
001C;<control>;Cc;0;B;;;;;N;INFORMATION SEPARATOR FOUR;;;;
001D;<control>;Cc;0;B;;;;;N;INFORMATION SEPARATOR THREE;;;;
001E;<control>;Cc;0;B;;;;;N;INFORMATION SEPARATOR TWO;;;;
001F;<control>;Cc;0;S;;;;;N;INFORMATION SEPARATOR ONE;;;;
0020;SPACE;Zs;0;WS;;;;;N;;;;;
0021;EXCLAMATION MARK;Po;0;ON;;;;;N;;;;;
0022;QUOTATION MARK;Po;0;ON;;;;;N;;;;;
0023;NUMBER SIGN;Po;0;ET;;;;;N;;;;;
0024;DOLLAR SIGN;Sc;0;ET;;;;;N;;;;;
0025;PERCENT SIGN;Po;0;ET;;;;;N;;;;;
0026;AMPERSAND;Po;0;ON;;;;;N;;;;;
0027;APOSTROPHE;Po;0;ON;;;;;N;APOSTROPHE-QUOTE;;;;
0028;LEFT PARENTHESIS;Ps;0;ON;;;;;Y;OPENING PARENTHESIS;;;;
0029;RIGHT PARENTHESIS;Pe;0;ON;;;;;Y;CLOSING PARENTHESIS;;;;
002A;ASTERISK;Po;0;ON;;;;;N;;;;;
002B;PLUS SIGN;Sm;0;ES;;;;;N;;;;;
002C;COMMA;Po;0;CS;;;;;N;;;;;
002D;HYPHEN-MINUS;Pd;0;ES;;;;;N;;;;;
002E;FULL STOP;Po;0;CS;;;;;N;PERIOD;;;;
002F;SOLIDUS;Po;0;CS;;;;;N;SLASH;;;;
0030;DIGIT ZERO;Nd;0;EN;;0;0;0;N;;;;;
0031;DIGIT ONE;Nd;0;EN;;1;1;1;N;;;;;
0032;DIGIT TWO;Nd;0;EN;;2;2;2;N;;;;;
0033;DIGIT THREE;Nd;0;EN;;3;3;3;N;;;;;
0034;DIGIT FOUR;Nd;0;EN;;4;4;4;N;;;;;
0035;DIGIT FIVE;Nd;0;EN;;5;5;5;N;;;;;
0036;DIGIT SIX;Nd;0;EN;;6;6;6;N;;;;;
0037;DIGIT SEVEN;Nd;0;EN;;7;7;7;N;;;;;
0038;DIGIT EIGHT;Nd;0;EN;;8;8;8;N;;;;;
0039;DIGIT NINE;Nd;0;EN;;9;9;9;N;;;;;
003A;COLON;Po;0;CS;;;;;N;;;;;
003B;SEMICOLON;Po;0;ON;;;;;N;;;;;
003C;LESS-THAN SIGN;Sm;0;ON;;;;;Y;;;;;
003D;EQUALS SIGN;Sm;0;ON;;;;;N;;;;;
003E;GREATER-THAN SIGN;Sm;0;ON;;;;;Y;;;;;
003F;QUESTION MARK;Po;0;ON;;;;;N;;;;;
0040;COMMERCIAL AT;Po;0;ON;;;;;N;;;;;
0041;LATIN CAPITAL LETTER A;Lu;0;L;;;;;N;;;;0061;
0042;LATIN CAPITAL LETTER B;Lu;0;L;;;;;N;;;;0062;
0043;LATIN CAPITAL LETTER C;Lu;0;L;;;;;N;;;;0063;
0044;LATIN CAPITAL LETTER D;Lu;0;L;;;;;N;;;;0064;
0045;LATIN CAPITAL LETTER E;Lu;0;L;;;;;N;;;;0065;
0046;LATIN CAPITAL LETTER F;Lu;0;L;;;;;N;;;;0066;
0047;LATIN CAPITAL LETTER G;Lu;0;L;;;;;N;;;;0067;
0048;LATIN CAPITAL LETTER H;Lu;0;L;;;;;N;;;;0068;
0049;LATIN CAPITAL LETTER I;Lu;0;L;;;;;N;;;;0069;
004A;LATIN CAPITAL LETTER J;Lu;0;L;;;;;N;;;;006A;
004B;LATIN CAPITAL LETTER K;Lu;0;L;;;;;N;;;;006B;
004C;LATIN CAPITAL LETTER L;Lu;0;L;;;;;N;;;;006C;
004D;LATIN CAPITAL LETTER M;Lu;0;L;;;;;N;;;;006D;
004E;LATIN CAPITAL LETTER N;Lu;0;L;;;;;N;;;;006E;
004F;LATIN CAPITAL LETTER O;Lu;0;L;;;;;N;;;;006F;
0050;LATIN CAPITAL LETTER P;Lu;0;L;;;;;N;;;;0070;
0051;LATIN CAPITAL LETTER Q;Lu;0;L;;;;;N;;;;0071;
0052;LATIN CAPITAL LETTER R;Lu;0;L;;;;;N;;;;0072;
0053;LATIN CAPITAL LETTER S;Lu;0;L;;;;;N;;;;0073;
0054;LATIN CAPITAL LETTER T;Lu;0;L;;;;;N;;;;0074;
0055;LATIN CAPITAL LETTER U;Lu;0;L;;;;;N;;;;0075;
0056;LATIN CAPITAL LETTER V;Lu;0;L;;;;;N;;;;0076;
0057;LATIN CAPITAL LETTER W;Lu;0;L;;;;;N;;;;0077;
0058;LATIN CAPITAL LETTER X;Lu;0;L;;;;;N;;;;0078;
0059;LATIN CAPITAL LETTER Y;Lu;0;L;;;;;N;;;;0079;
005A;LATIN CAPITAL LETTER Z;Lu;0;L;;;;;N;;;;007A;
005B;LEFT SQUARE BRACKET;Ps;0;ON;;;;;Y;OPENING SQUARE BRACKET;;;;
005C;REVERSE SOLIDUS;Po;0;ON;;;;;N;BACKSLASH;;;;
005D;RIGHT SQUARE BRACKET;Pe;0;ON;;;;;Y;CLOSING SQUARE BRACKET;;;;
005E;CIRCUMFLEX ACCENT;Sk;0;ON;;;;;N;SPACING CIRCUMFLEX;;;;
005F;LOW LINE;Pc;0;ON;;;;;N;SPACING UNDERSCORE;;;;
0060;GRAVE ACCENT;Sk;0;ON;;;;;N;SPACING GRAVE;;;;
0061;LATIN SMALL LETTER A;Ll;0;L;;;;;N;;;0041;;0041
0062;LATIN SMALL LETTER B;Ll;0;L;;;;;N;;;0042;;0042
0063;LATIN SMALL LETTER C;Ll;0;L;;;;;N;;;0043;;0043
0064;LATIN SMALL LETTER D;Ll;0;L;;;;;N;;;0044;;0044
0065;LATIN SMALL LETTER E;Ll;0;L;;;;;N;;;0045;;0045
0066;LATIN SMALL LETTER F;Ll;0;L;;;;;N;;;0046;;0046
0067;LATIN SMALL LETTER G;Ll;0;L;;;;;N;;;0047;;0047
0068;LATIN SMALL LETTER H;Ll;0;L;;;;;N;;;0048;;0048
0069;LATIN SMALL LETTER I;Ll;0;L;;;;;N;;;0049;;0049
006A;LATIN SMALL LETTER J;Ll;0;L;;;;;N;;;004A;;004A
006B;LATIN SMALL LETTER K;Ll;0;L;;;;;N;;;004B;;004B
006C;LATIN SMALL LETTER L;Ll;0;L;;;;;N;;;004C;;004C
006D;LATIN SMALL LETTER M;Ll;0;L;;;;;N;;;004D;;004D
006E;LATIN SMALL LETTER N;Ll;0;L;;;;;N;;;004E;;004E
006F;LATIN SMALL LETTER O;Ll;0;L;;;;;N;;;004F;;004F
0070;LATIN SMALL LETTER P;Ll;0;L;;;;;N;;;0050;;0050
0071;LATIN SMALL LETTER Q;Ll;0;L;;;;;N;;;0051;;0051
0072;LATIN SMALL LETTER R;Ll;0;L;;;;;N;;;0052;;0052
0073;LATIN SMALL LETTER S;Ll;0;L;;;;;N;;;0053;;0053
0074;LATIN SMALL LETTER T;Ll;0;L;;;;;N;;;0054;;0054
0075;LATIN SMALL LETTER U;Ll;0;L;;;;;N;;;0055;;0055
0076;LATIN SMALL LETTER V;Ll;0;L;;;;;N;;;0056;;0056
0077;LATIN SMALL LETTER W;Ll;0;L;;;;;N;;;0057;;0057
0078;LATIN SMALL LETTER X;Ll;0;L;;;;;N;;;0058;;0058
0079;LATIN SMALL LETTER Y;Ll;0;L;;;;;N;;;0059;;0059
007A;LATIN SMALL LETTER Z;Ll;0;L;;;;;N;;;005A;;005A
007B;LEFT CURLY BRACKET;Ps;0;ON;;;;;Y;OPENING CURLY BRACKET;;;;
007C;VERTICAL LINE;Sm;0;ON;;;;;N;VERTICAL BAR;;;;
007D;RIGHT CURLY BRACKET;Pe;0;ON;;;;;Y;CLOSING CURLY BRACKET;;;;
007E;TILDE;Sm;0;ON;;;;;N;;;;;
007F;<control>;Cc;0;BN;;;;;N;DELETE;;;;
0080;<control>;Cc;0;BN;;;;;N;;;;;
0081;<control>;Cc;0;BN;;;;;N;;;;;
0082;<control>;Cc;0;BN;;;;;N;BREAK PERMITTED HERE;;;;
0083;<control>;Cc;0;BN;;;;;N;NO BREAK HERE;;;;
0084;<control>;Cc;0;BN;;;;;N;;;;;
0085;<control>;Cc;0;B;;;;;N;NEXT LINE (NEL);;;;
0086;<control>;Cc;0;BN;;;;;N;START OF SELECTED AREA;;;;
0087;<control>;Cc;0;BN;;;;;N;END OF SELECTED AREA;;;;
0088;<control>;Cc;0;BN;;;;;N;CHARACTER TABULATION SET;;;;
0089;<control>;Cc;0;BN;;;;;N;CHARACTER TABULATION WITH JUSTIFICATION;;;;
008A;<control>;Cc;0;BN;;;;;N;LINE TABULATION SET;;;;
008B;<control>;Cc;0;BN;;;;;N;PARTIAL LINE FORWARD;;;;
008C;<control>;Cc;0;BN;;;;;N;PARTIAL LINE BACKWARD;;;;
008D;<control>;Cc;0;BN;;;;;N;REVERSE LINE FEED;;;;
008E;<control>;Cc;0;BN;;;;;N;SINGLE SHIFT TWO;;;;
008F;<control>;Cc;0;BN;;;;;N;SINGLE SHIFT THREE;;;;
0090;<control>;Cc;0;BN;;;;;N;DEVICE CONTROL STRING;;;;
0091;<control>;Cc;0;BN;;;;;N;PRIVATE USE ONE;;;;
0092;<control>;Cc;0;BN;;;;;N;PRIVATE USE TWO;;;;
0093;<control>;Cc;0;BN;;;;;N;SET TRANSMIT STATE;;;;
0094;<control>;Cc;0;BN;;;;;N;CANCEL CHARACTER;;;;
0095;<control>;Cc;0;BN;;;;;N;MESSAGE WAITING;;;;
0096;<control>;Cc;0;BN;;;;;N;START OF GUARDED AREA;;;;
0097;<control>;Cc;0;BN;;;;;N;END OF GUARDED AREA;;;;
0098;<control>;Cc;0;BN;;;;;N;START OF STRING;;;;
0099;<control>;Cc;0;BN;;;;;N;;;;;
009A;<control>;Cc;0;BN;;;;;N;SINGLE CHARACTER INTRODUCER;;;;
009B;<control>;Cc;0;BN;;;;;N;CONTROL SEQUENCE INTRODUCER;;;;
009C;<control>;Cc;0;BN;;;;;N;STRING TERMINATOR;;;;
009D;<control>;Cc;0;BN;;;;;N;OPERATING SYSTEM COMMAND;;;;
009E;<control>;Cc;0;BN;;;;;N;PRIVACY MESSAGE;;;;
009F;<control>;Cc;0;BN;;;;;N;APPLICATION PROGRAM COMMAND;;;;
00A0;NO-BREAK SPACE;Zs;0;CS;<noBreak> 0020;;;;N;NON-BREAKING SPACE;;;;
00A1;INVERTED EXCLAMATION MARK;Po;0;ON;;;;;N;;;;;
00A2;CENT SIGN;Sc;0;ET;;;;;N;;;;;
00A3;POUND SIGN;Sc;0;ET;;;;;N;;;;;
00A4;CURRENCY SIGN;Sc;0;ET;;;;;N;;;;;
00A5;YEN SIGN;Sc;0;ET;;;;;N;;;;;
00A6;BROKEN BAR;So;0;ON;;;;;N;BROKEN VERTICAL BAR;;;;
00A7;SECTION SIGN;Po;0;ON;;;;;N;;;;;
00A8;DIAERESIS;Sk;0;ON;<compat> 0020 0308;;;;N;SPACING DIAERESIS;;;;
00A9;COPYRIGHT SIGN;So;0;ON;;;;;N;;;;;
00AA;FEMININE ORDINAL INDICATOR;Lo;0;L;<super> 0061;;;;N;;;;;
00AB;LEFT-POINTING DOUBLE ANGLE QUOTATION MARK;Pi;0;ON;;;;;Y;LEFT POINTING GUILLEMET;;;;
00AC;NOT SIGN;Sm;0;ON;;;;;N;;;;;
00AD;SOFT HYPHEN;Cf;0;BN;;;;;N;;;;;
00AE;REGISTERED SIGN;So;0;ON;;;;;N;REGISTERED TRADE MARK SIGN;;;;
00AF;MACRON;Sk;0;ON;<compat> 0020 0304;;;;N;SPACING MACRON;;;;
00B0;DEGREE SIGN;So;0;ET;;;;;N;;;;;
00B1;PLUS-MINUS SIGN;Sm;0;ET;;;;;N;PLUS-OR-MINUS SIGN;;;;
00B2;SUPERSCRIPT TWO;No;0;EN;<super> 0032;;2;2;N;SUPERSCRIPT DIGIT TWO;;;;
00B3;SUPERSCRIPT THREE;No;0;EN;<super> 0033;;3;3;N;SUPERSCRIPT DIGIT THREE;;;;
00B4;ACUTE ACCENT;Sk;0;ON;<compat> 0020 0301;;;;N;SPACING ACUTE;;;;
00B5;MICRO SIGN;Ll;0;L;<compat> 03BC;;;;N;;;039C;;039C
00B6;PILCROW SIGN;Po;0;ON;;;;;N;PARAGRAPH SIGN;;;;
00B7;MIDDLE DOT;Po;0;ON;;;;;N;;;;;
00B8;CEDILLA;Sk;0;ON;<compat> 0020 0327;;;;N;SPACING CEDILLA;;;;
00B9;SUPERSCRIPT ONE;No;0;EN;<super> 0031;;1;1;N;SUPERSCRIPT DIGIT ONE;;;;
00BA;MASCULINE ORDINAL INDICATOR;Lo;0;L;<super> 006F;;;;N;;;;;
00BB;RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK;Pf;0;ON;;;;;Y;RIGHT POINTING GUILLEMET;;;;
00BC;VULGAR FRACTION ONE QUARTER;No;0;ON;<fraction> 0031 2044 0034;;;1/4;N;FRACTION ONE QUARTER;;;;
00BD;VULGAR FRACTION ONE HALF;No;0;ON;<fraction> 0031 2044 0032;;;1/2;N;FRACTION ONE HALF;;;;
00BE;VULGAR FRACTION THREE QUARTERS;No;0;ON;<fraction> 0033 2044 0034;;;3/4;N;FRACTION THREE QUARTERS;;;;
00BF;INVERTED QUESTION MARK;Po;0;ON;;;;;N;;;;;
00C0;LATIN CAPITAL LETTER A WITH GRAVE;Lu;0;L;0041 0300;;;;N;LATIN CAPITAL LETTER A GRAVE;;;00E0;
00C1;LATIN CAPITAL LETTER A WITH ACUTE;Lu;0;L;0041 0301;;;;N;LATIN CAPITAL LETTER A ACUTE;;;00E1;
00C2;LATIN CAPITAL LETTER A WITH CIRCUMFLEX;Lu;0;L;0041 0302;;;;N;LATIN CAPITAL LETTER A CIRCUMFLEX;;;00E2;
00C3;LATIN CAPITAL LETTER A WITH TILDE;Lu;0;L;0041 0303;;;;N;LATIN CAPITAL LETTER A TILDE;;;00E3;
00C4;LATIN CAPITAL LETTER A WITH DIAERESIS;Lu;0;L;0041 0308;;;;N;LATIN CAPITAL LETTER A DIAERESIS;;;00E4;
00C5;LATIN CAPITAL LETTER A WITH RING ABOVE;Lu;0;L;0041 030A;;;;N;LATIN CAPITAL LETTER A RING;;;00E5;
00C6;LATIN CAPITAL LETTER AE;Lu;0;L;;;;;N;LATIN CAPITAL LETTER A E;;;00E6;
00C7;LATIN CAPITAL LETTER C WITH CEDILLA;Lu;0;L;0043 0327;;;;N;LATIN CAPITAL LETTER C CEDILLA;;;00E7;
00C8;LATIN CAPITAL LETTER E WITH GRAVE;Lu;0;L;0045 0300;;;;N;LATIN CAPITAL LETTER E GRAVE;;;00E8;
00C9;LATIN CAPITAL LETTER E WITH ACUTE;Lu;0;L;0045 0301;;;;N;LATIN CAPITAL LETTER E ACUTE;;;00E9;
00CA;LATIN CAPITAL LETTER E WITH CIRCUMFLEX;Lu;0;L;0045 0302;;;;N;LATIN CAPITAL LETTER E CIRCUMFLEX;;;00EA;
00CB;LATIN CAPITAL LETTER E WITH DIAERESIS;Lu;0;L;0045 0308;;;;N;LATIN CAPITAL LETTER E DIAERESIS;;;00EB;
00CC;LATIN CAPITAL LETTER I WITH GRAVE;Lu;0;L;0049 0300;;;;N;LATIN CAPITAL LETTER I GRAVE;;;00EC;
00CD;LATIN CAPITAL LETTER I WITH ACUTE;Lu;0;L;0049 0301;;;;N;LATIN CAPITAL LETTER I ACUTE;;;00ED;
00CE;LATIN CAPITAL LETTER I WITH CIRCUMFLEX;Lu;0;L;0049 0302;;;;N;LATIN CAPITAL LETTER I CIRCUMFLEX;;;00EE;
00CF;LATIN CAPITAL LETTER I WITH DIAERESIS;Lu;0;L;0049 0308;;;;N;LATIN CAPITAL LETTER I DIAERESIS;;;00EF;
00D0;LATIN CAPITAL LETTER ETH;Lu;0;L;;;;;N;;;;00F0;
00D1;LATIN CAPITAL LETTER N WITH TILDE;Lu;0;L;004E 0303;;;;N;LATIN CAPITAL LETTER N TILDE;;;00F1;
00D2;LATIN CAPITAL LETTER O WITH GRAVE;Lu;0;L;004F 0300;;;;N;LATIN CAPITAL LETTER O GRAVE;;;00F2;
00D3;LATIN CAPITAL LETTER O WITH ACUTE;Lu;0;L;004F 0301;;;;N;LATIN CAPITAL LETTER O ACUTE;;;00F3;
00D4;LATIN CAPITAL LETTER O WITH CIRCUMFLEX;Lu;0;L;004F 0302;;;;N;LATIN CAPITAL LETTER O CIRCUMFLEX;;;00F4;
00D5;LATIN CAPITAL LETTER O WITH TILDE;Lu;0;L;004F 0303;;;;N;LATIN CAPITAL LETTER O TILDE;;;00F5;
00D6;LATIN CAPITAL LETTER O WITH DIAERESIS;Lu;0;L;004F 0308;;;;N;LATIN CAPITAL LETTER O DIAERESIS;;;00F6;
00D7;MULTIPLICATION SIGN;Sm;0;ON;;;;;N;;;;;
00D8;LATIN CAPITAL LETTER O WITH STROKE;Lu;0;L;;;;;N;LATIN CAPITAL LETTER O SLASH;;;00F8;
00D9;LATIN CAPITAL LETTER U WITH GRAVE;Lu;0;L;0055 0300;;;;N;LATIN CAPITAL LETTER U GRAVE;;;00F9;
00DA;LATIN CAPITAL LETTER U WITH ACUTE;Lu;0;L;0055 0301;;;;N;LATIN CAPITAL LETTER U ACUTE;;;00FA;
00DB;LATIN CAPITAL LETTER U WITH CIRCUMFLEX;Lu;0;L;0055 0302;;;;N;LATIN CAPITAL LETTER U CIRCUMFLEX;;;00FB;
00DC;LATIN CAPITAL LETTER U WITH DIAERESIS;Lu;0;L;0055 0308;;;;N;LATIN CAPITAL LETTER U DIAERESIS;;;00FC;
00DD;LATIN CAPITAL LETTER Y WITH ACUTE;Lu;0;L;0059 0301;;;;N;LATIN CAPITAL LETTER Y ACUTE;;;00FD;
00DE;LATIN CAPITAL LETTER THORN;Lu;0;L;;;;;N;;;;00FE;
00DF;LATIN SMALL LETTER SHARP S;Ll;0;L;;;;;N;;;;;
00E0;LATIN SMALL LETTER A WITH GRAVE;Ll;0;L;0061 0300;;;;N;LATIN SMALL LETTER A GRAVE;;00C0;;00C0
00E1;LATIN SMALL LETTER A WITH ACUTE;Ll;0;L;0061 0301;;;;N;LATIN SMALL LETTER A ACUTE;;00C1;;00C1
00E2;LATIN SMALL LETTER A WITH CIRCUMFLEX;Ll;0;L;0061 0302;;;;N;LATIN SMALL LETTER A CIRCUMFLEX;;00C2;;00C2
00E3;LATIN SMALL LETTER A WITH TILDE;Ll;0;L;0061 0303;;;;N;LATIN SMALL LETTER A TILDE;;00C3;;00C3
00E4;LATIN SMALL LETTER A WITH DIAERESIS;Ll;0;L;0061 0308;;;;N;LATIN SMALL LETTER A DIAERESIS;;00C4;;00C4
00E5;LATIN SMALL LETTER A WITH RING ABOVE;Ll;0;L;0061 030A;;;;N;LATIN SMALL LETTER A RING;;00C5;;00C5
00E6;LATIN SMALL LETTER AE;Ll;0;L;;;;;N;LATIN SMALL LETTER A E;;00C6;;00C6
00E7;LATIN SMALL LETTER C WITH CEDILLA;Ll;0;L;0063 0327;;;;N;LATIN SMALL LETTER C CEDILLA;;00C7;;00C7
00E8;LATIN SMALL LETTER E WITH GRAVE;Ll;0;L;0065 0300;;;;N;LATIN SMALL LETTER E GRAVE;;00C8;;00C8
00E9;LATIN SMALL LETTER E WITH ACUTE;Ll;0;L;0065 0301;;;;N;LATIN SMALL LETTER E ACUTE;;00C9;;00C9
00EA;LATIN SMALL LETTER E WITH CIRCUMFLEX;Ll;0;L;0065 0302;;;;N;LATIN SMALL LETTER E CIRCUMFLEX;;00CA;;00CA
00EB;LATIN SMALL LETTER E WITH DIAERESIS;Ll;0;L;0065 0308;;;;N;LATIN SMALL LETTER E DIAERESIS;;00CB;;00CB
00EC;LATIN SMALL LETTER I WITH GRAVE;Ll;0;L;0069 0300;;;;N;LATIN SMALL LETTER I GRAVE;;00CC;;00CC
00ED;LATIN SMALL LETTER I WITH ACUTE;Ll;0;L;0069 0301;;;;N;LATIN SMALL LETTER I ACUTE;;00CD;;00CD
00EE;LATIN SMALL LETTER I WITH CIRCUMFLEX;Ll;0;L;0069 0302;;;;N;LATIN SMALL LETTER I CIRCUMFLEX;;00CE;;00CE
00EF;LATIN SMALL LETTER I WITH DIAERESIS;Ll;0;L;0069 0308;;;;N;LATIN SMALL LETTER I DIAERESIS;;00CF;;00CF
00F0;LATIN SMALL LETTER ETH;Ll;0;L;;;;;N;;;00D0;;00D0
00F1;LATIN SMALL LETTER N WITH TILDE;Ll;0;L;006E 0303;;;;N;LATIN SMALL LETTER N TILDE;;00D1;;00D1
00F2;LATIN SMALL LETTER O WITH GRAVE;Ll;0;L;006F 0300;;;;N;LATIN SMALL LETTER O GRAVE;;00D2;;00D2
00F3;LATIN SMALL LETTER O WITH ACUTE;Ll;0;L;006F 0301;;;;N;LATIN SMALL LETTER O ACUTE;;00D3;;00D3
00F4;LATIN SMALL LETTER O WITH CIRCUMFLEX;Ll;0;L;006F 0302;;;;N;LATIN SMALL LETTER O CIRCUMFLEX;;00D4;;00D4
00F5;LATIN SMALL LETTER O WITH TILDE;Ll;0;L;006F 0303;;;;N;LATIN SMALL LETTER O TILDE;;00D5;;00D5
00F6;LATIN SMALL LETTER O WITH DIAERESIS;Ll;0;L;006F 0308;;;;N;LATIN SMALL LETTER O DIAERESIS;;00D6;;00D6
00F7;DIVISION SIGN;Sm;0;ON;;;;;N;;;;;
00F8;LATIN SMALL LETTER O WITH STROKE;Ll;0;L;;;;;N;LATIN SMALL LETTER O SLASH;;00D8;;00D8
00F9;LATIN SMALL LETTER U WITH GRAVE;Ll;0;L;0075 0300;;;;N;LATIN SMALL LETTER U GRAVE;;00D9;;00D9
00FA;LATIN SMALL LETTER U WITH ACUTE;Ll;0;L;0075 0301;;;;N;LATIN SMALL LETTER U ACUTE;;00DA;;00DA
00FB;LATIN SMALL LETTER U WITH CIRCUMFLEX;Ll;0;L;0075 0302;;;;N;LATIN SMALL LETTER U CIRCUMFLEX;;00DB;;00DB
00FC;LATIN SMALL LETTER U WITH DIAERESIS;Ll;0;L;0075 0308;;;;N;LATIN SMALL LETTER U DIAERESIS;;00DC;;00DC
00FD;LATIN SMALL LETTER Y WITH ACUTE;Ll;0;L;0079 0301;;;;N;LATIN SMALL LETTER Y ACUTE;;00DD;;00DD
00FE;LATIN SMALL LETTER THORN;Ll;0;L;;;;;N;;;00DE;;00DE
00FF;LATIN SMALL LETTER Y WITH DIAERESIS;Ll;0;L;0079 0308;;;;N;LATIN SMALL LETTER Y DIAERESIS;;0178;;0178
0100;LATIN CAPITAL LETTER A WITH MACRON;Lu;0;L;0041 0304;;;;N;LATIN CAPITAL LETTER A MACRON;;;0101;
0101;LATIN SMALL LETTER A WITH MACRON;Ll;0;L;0061 0304;;;;N;LATIN SMALL LETTER A MACRON;;0100;;0100
0102;LATIN CAPITAL LETTER A WITH BREVE;Lu;0;L;0041 0306;;;;N;LATIN CAPITAL LETTER A BREVE;;;0103;
0103;LATIN SMALL LETTER A WITH BREVE;Ll;0;L;0061 0306;;;;N;LATIN SMALL LETTER A BREVE;;0102;;0102
0104;LATIN CAPITAL LETTER A WITH OGONEK;Lu;0;L;0041 0328;;;;N;LATIN CAPITAL LETTER A OGONEK;;;0105;
0105;LATIN SMALL LETTER A WITH OGONEK;Ll;0;L;0061 0328;;;;N;LATIN SMALL LETTER A OGONEK;;0104;;0104
0106;LATIN CAPITAL LETTER C WITH ACUTE;Lu;0;L;0043 0301;;;;N;LATIN CAPITAL LETTER C ACUTE;;;0107;
0107;LATIN SMALL LETTER C WITH ACUTE;Ll;0;L;0063 0301;;;;N;LATIN SMALL LETTER C ACUTE;;0106;;0106
0108;LATIN CAPITAL LETTER C WITH CIRCUMFLEX;Lu;0;L;0043 0302;;;;N;LATIN CAPITAL LETTER C CIRCUMFLEX;;;0109;
0109;LATIN SMALL LETTER C WITH CIRCUMFLEX;Ll;0;L;0063 0302;;;;N;LATIN SMALL LETTER C CIRCUMFLEX;;0108;;0108
010A;LATIN CAPITAL LETTER C WITH DOT ABOVE;Lu;0;L;0043 0307;;;;N;LATIN CAPITAL LETTER C DOT;;;010B;
010B;LATIN SMALL LETTER C WITH DOT ABOVE;Ll;0;L;0063 0307;;;;N;LATIN SMALL LETTER C DOT;;010A;;010A
010C;LATIN CAPITAL LETTER C WITH CARON;Lu;0;L;0043 030C;;;;N;LATIN CAPITAL LETTER C HACEK;;;010D;
010D;LATIN SMALL LETTER C WITH CARON;Ll;0;L;0063 030C;;;;N;LATIN SMALL LETTER C HACEK;;010C;;010C
010E;LATIN CAPITAL LETTER D WITH CARON;Lu;0;L;0044 030C;;;;N;LATIN CAPITAL LETTER D HACEK;;;010F;
010F;LATIN SMALL LETTER D WITH CARON;Ll;0;L;0064 030C;;;;N;LATIN SMALL LETTER D HACEK;;010E;;010E
0110;LATIN CAPITAL LETTER D WITH STROKE;Lu;0;L;;;;;N;LATIN CAPITAL LETTER D BAR;;;0111;
0111;LATIN SMALL LETTER D WITH STROKE;Ll;0;L;;;;;N;LATIN SMALL LETTER D BAR;;0110;;0110
0112;LATIN CAPITAL LETTER E WITH MACRON;Lu;0;L;0045 0304;;;;N;LATIN CAPITAL LETTER E MACRON;;;0113;
0113;LATIN SMALL LETTER E WITH MACRON;Ll;0;L;0065 0304;;;;N;LATIN SMALL LETTER E MACRON;;0112;;0112
0114;LATIN CAPITAL LETTER E WITH BREVE;Lu;0;L;0045 0306;;;;N;LATIN CAPITAL LETTER E BREVE;;;0115;
0115;LATIN SMALL LETTER E WITH BREVE;Ll;0;L;0065 0306;;;;N;LATIN SMALL LETTER E BREVE;;0114;;0114
0116;LATIN CAPITAL LETTER E WITH DOT ABOVE;Lu;0;L;0045 0307;;;;N;LATIN CAPITAL LETTER E DOT;;;0117;
0117;LATIN SMALL LETTER E WITH DOT ABOVE;Ll;0;L;0065 0307;;;;N;LATIN SMALL LETTER E DOT;;0116;;0116
0118;LATIN CAPITAL LETTER E WITH OGONEK;Lu;0;L;0045 0328;;;;N;LATIN CAPITAL LETTER E OGONEK;;;0119;
0119;LATIN SMALL LETTER E WITH OGONEK;Ll;0;L;0065 0328;;;;N;LATIN SMALL LETTER E OGONEK;;0118;;0118
011A;LATIN CAPITAL LETTER E WITH CARON;Lu;0;L;0045 030C;;;;N;LATIN CAPITAL LETTER E HACEK;;;011B;
011B;LATIN SMALL LETTER E WITH CARON;Ll;0;L;0065 030C;;;;N;LATIN SMALL LETTER E HACEK;;011A;;011A
011C;LATIN CAPITAL LETTER G WITH CIRCUMFLEX;Lu;0;L;0047 0302;;;;N;LATIN CAPITAL LETTER G CIRCUMFLEX;;;011D;
011D;LATIN SMALL LETTER G WITH CIRCUMFLEX;Ll;0;L;0067 0302;;;;N;LATIN SMALL LETTER G CIRCUMFLEX;;011C;;011C
011E;LATIN CAPITAL LETTER G WITH BREVE;Lu;0;L;0047 0306;;;;N;LATIN CAPITAL LETTER G BREVE;;;011F;
011F;LATIN SMALL LETTER G WITH BREVE;Ll;0;L;0067 0306;;;;N;LATIN SMALL LETTER G BREVE;;011E;;011E
0120;LATIN CAPITAL LETTER G WITH DOT ABOVE;Lu;0;L;0047 0307;;;;N;LATIN CAPITAL LETTER G DOT;;;0121;
0121;LATIN SMALL LETTER G WITH DOT ABOVE;Ll;0;L;0067 0307;;;;N;LATIN SMALL LETTER G DOT;;0120;;0120
0122;LATIN CAPITAL LETTER G WITH CEDILLA;Lu;0;L;0047 0327;;;;N;LATIN CAPITAL LETTER G CEDILLA;;;0123;
0123;LATIN SMALL LETTER G WITH CEDILLA;Ll;0;L;0067 0327;;;;N;LATIN SMALL LETTER G CEDILLA;;0122;;0122
0124;LATIN CAPITAL LETTER H WITH CIRCUMFLEX;Lu;0;L;0048 0302;;;;N;LATIN CAPITAL LETTER H CIRCUMFLEX;;;0125;
0125;LATIN SMALL LETTER H WITH CIRCUMFLEX;Ll;0;L;0068 0302;;;;N;LATIN SMALL LETTER H CIRCUMFLEX;;0124;;0124
0126;LATIN CAPITAL LETTER H WITH STROKE;Lu;0;L;;;;;N;LATIN CAPITAL LETTER H BAR;;;0127;
0127;LATIN SMALL LETTER H WITH STROKE;Ll;0;L;;;;;N;LATIN SMALL LETTER H BAR;;0126;;0126
0128;LATIN CAPITAL LETTER I WITH TILDE;Lu;0;L;0049 0303;;;;N;LATIN CAPITAL LETTER I TILDE;;;0129;
0129;LATIN SMALL LETTER I WITH TILDE;Ll;0;L;0069 0303;;;;N;LATIN SMALL LETTER I TILDE;;0128;;0128
012A;LATIN CAPITAL LETTER I WITH MACRON;Lu;0;L;0049 0304;;;;N;LATIN CAPITAL LETTER I MACRON;;;012B;
012B;LATIN SMALL LETTER I WITH MACRON;Ll;0;L;0069 0304;;;;N;LATIN SMALL LETTER I MACRON;;012A;;012A
012C;LATIN CAPITAL LETTER I WITH BREVE;Lu;0;L;0049 0306;;;;N;LATIN CAPITAL LETTER I BREVE;;;012D;
012D;LATIN SMALL LETTER I WITH BREVE;Ll;0;L;0069 0306;;;;N;LATIN SMALL LETTER I BREVE;;012C;;012C
012E;LATIN CAPITAL LETTER I WITH OGONEK;Lu;0;L;0049 0328;;;;N;LATIN CAPITAL LETTER I OGONEK;;;012F;
012F;LATIN SMALL LETTER I WITH OGONEK;Ll;0;L;0069 0328;;;;N;LATIN SMALL LETTER I OGONEK;;012E;;012E
0130;LATIN CAPITAL LETTER I WITH DOT ABOVE;Lu;0;L;0049 0307;;;;N;LATIN CAPITAL LETTER I DOT;;;0069;
0131;LATIN SMALL LETTER DOTLESS I;Ll;0;L;;;;;N;;;0049;;0049
0132;LATIN CAPITAL LIGATURE IJ;Lu;0;L;<compat> 0049 004A;;;;N;LATIN CAPITAL LETTER I J;;;0133;
0133;LATIN SMALL LIGATURE IJ;Ll;0;L;<compat> 0069 006A;;;;N;LATIN SMALL LETTER I J;;0132;;0132
0134;LATIN CAPITAL LETTER J WITH CIRCUMFLEX;Lu;0;L;004A 0302;;;;N;LATIN CAPITAL LETTER J CIRCUMFLEX;;;0135;
0135;LATIN SMALL LETTER J WITH CIRCUMFLEX;Ll;0;L;006A 0302;;;;N;LATIN SMALL LETTER J CIRCUMFLEX;;0134;;0134
0136;LATIN CAPITAL LETTER K WITH CEDILLA;Lu;0;L;004B 0327;;;;N;LATIN CAPITAL LETTER K CEDILLA;;;0137;
0137;LATIN SMALL LETTER K WITH CEDILLA;Ll;0;L;006B 0327;;;;N;LATIN SMALL LETTER K CEDILLA;;0136;;0136
0138;LATIN SMALL LETTER KRA;Ll;0;L;;;;;N;;;;;
0139;LATIN CAPITAL LETTER L WITH ACUTE;Lu;0;L;004C 0301;;;;N;LATIN CAPITAL LETTER L ACUTE;;;013A;
013A;LATIN SMALL LETTER L WITH ACUTE;Ll;0;L;006C 0301;;;;N;LATIN SMALL LETTER L ACUTE;;0139;;0139
013B;LATIN CAPITAL LETTER L WITH CEDILLA;Lu;0;L;004C 0327;;;;N;LATIN CAPITAL LETTER L CEDILLA;;;013C;
013C;LATIN SMALL LETTER L WITH CEDILLA;Ll;0;L;006C 0327;;;;N;LATIN SMALL LETTER L CEDILLA;;013B;;013B
013D;LATIN CAPITAL LETTER L WITH CARON;Lu;0;L;004C 030C;;;;N;LATIN CAPITAL LETTER L HACEK;;;013E;
013E;LATIN SMALL LETTER L WITH CARON;Ll;0;L;006C 030C;;;;N;LATIN SMALL LETTER L HACEK;;013D;;013D
013F;LATIN CAPITAL LETTER L WITH MIDDLE DOT;Lu;0;L;<compat> 004C 00B7;;;;N;;;;0140;
0140;LATIN SMALL LETTER L WITH MIDDLE DOT;Ll;0;L;<compat> 006C 00B7;;;;N;;;013F;;013F
0141;LATIN CAPITAL LETTER L WITH STROKE;Lu;0;L;;;;;N;LATIN CAPITAL LETTER L SLASH;;;0142;
0142;LATIN SMALL LETTER L WITH STROKE;Ll;0;L;;;;;N;LATIN SMALL LETTER L SLASH;;0141;;0141
0143;LATIN CAPITAL LETTER N WITH ACUTE;Lu;0;L;004E 0301;;;;N;LATIN CAPITAL LETTER N ACUTE;;;0144;
0144;LATIN SMALL LETTER N WITH ACUTE;Ll;0;L;006E 0301;;;;N;LATIN SMALL LETTER N ACUTE;;0143;;0143
0145;LATIN CAPITAL LETTER N WITH CEDILLA;Lu;0;L;004E 0327;;;;N;LATIN CAPITAL LETTER N CEDILLA;;;0146;
0146;LATIN SMALL LETTER N WITH CEDILLA;Ll;0;L;006E 0327;;;;N;LATIN SMALL LETTER N CEDILLA;;0145;;0145
0147;LATIN CAPITAL LETTER N WITH CARON;Lu;0;L;004E 030C;;;;N;LATIN CAPITAL LETTER N HACEK;;;0148;
0148;LATIN SMALL LETTER N WITH CARON;Ll;0;L;006E 030C;;;;N;LATIN SMALL LETTER N HACEK;;0147;;0147
0149;LATIN SMALL LETTER N PRECEDED BY APOSTROPHE;Ll;0;L;<compat> 02BC 006E;;;;N;LATIN SMALL LETTER APOSTROPHE N;;;;
014A;LATIN CAPITAL LETTER ENG;Lu;0;L;;;;;N;;;;014B;
014B;LATIN SMALL LETTER ENG;Ll;0;L;;;;;N;;;014A;;014A
014C;LATIN CAPITAL LETTER O WITH MACRON;Lu;0;L;004F 0304;;;;N;LATIN CAPITAL LETTER O MACRON;;;014D;
014D;LATIN SMALL LETTER O WITH MACRON;Ll;0;L;006F 0304;;;;N;LATIN SMALL LETTER O MACRON;;014C;;014C
014E;LATIN CAPITAL LETTER O WITH BREVE;Lu;0;L;004F 0306;;;;N;LATIN CAPITAL LETTER O BREVE;;;014F;
014F;LATIN SMALL LETTER O WITH BREVE;Ll;0;L;006F 0306;;;;N;LATIN SMALL LETTER O BREVE;;014E;;014E
0150;LATIN CAPITAL LETTER O WITH DOUBLE ACUTE;Lu;0;L;004F 030B;;;;N;LATIN CAPITAL LETTER O DOUBLE ACUTE;;;0151;
0151;LATIN SMALL LETTER O WITH DOUBLE ACUTE;Ll;0;L;006F 030B;;;;N;LATIN SMALL LETTER O DOUBLE ACUTE;;0150;;0150
0152;LATIN CAPITAL LIGATURE OE;Lu;0;L;;;;;N;LATIN CAPITAL LETTER O E;;;0153;
0153;LATIN SMALL LIGATURE OE;Ll;0;L;;;;;N;LATIN SMALL LETTER O E;;0152;;0152
0154;LATIN CAPITAL LETTER R WITH ACUTE;Lu;0;L;0052 0301;;;;N;LATIN CAPITAL LETTER R ACUTE;;;0155;
0155;LATIN SMALL LETTER R WITH ACUTE;Ll;0;L;0072 0301;;;;N;LATIN SMALL LETTER R ACUTE;;0154;;0154
0156;LATIN CAPITAL LETTER R WITH CEDILLA;Lu;0;L;0052 0327;;;;N;LATIN CAPITAL LETTER R CEDILLA;;;0157;
0157;LATIN SMALL LETTER R WITH CEDILLA;Ll;0;L;0072 0327;;;;N;LATIN SMALL LETTER R CEDILLA;;0156;;0156
0158;LATIN CAPITAL LETTER R WITH CARON;Lu;0;L;0052 030C;;;;N;LATIN CAPITAL LETTER R HACEK;;;0159;
0159;LATIN SMALL LETTER R WITH CARON;Ll;0;L;0072 030C;;;;N;LATIN SMALL LETTER R HACEK;;0158;;0158
015A;LATIN CAPITAL LETTER S WITH ACUTE;Lu;0;L;0053 0301;;;;N;LATIN CAPITAL LETTER S ACUTE;;;015B;
015B;LATIN SMALL LETTER S WITH ACUTE;Ll;0;L;0073 0301;;;;N;LATIN SMALL LETTER S ACUTE;;015A;;015A
015C;LATIN CAPITAL LETTER S WITH CIRCUMFLEX;Lu;0;L;0053 0302;;;;N;LATIN CAPITAL LETTER S CIRCUMFLEX;;;015D;
015D;LATIN SMALL LETTER S WITH CIRCUMFLEX;Ll;0;L;0073 0302;;;;N;LATIN SMALL LETTER S CIRCUMFLEX;;015C;;015C
015E;LATIN CAPITAL LETTER S WITH CEDILLA;Lu;0;L;0053 0327;;;;N;LATIN CAPITAL LETTER S CEDILLA;;;015F;
015F;LATIN SMALL LETTER S WITH CEDILLA;Ll;0;L;0073 0327;;;;N;LATIN SMALL LETTER S CEDILLA;;015E;;015E
0160;LATIN CAPITAL LETTER S WITH CARON;Lu;0;L;0053 030C;;;;N;LATIN CAPITAL LETTER S HACEK;;;0161;
0161;LATIN SMALL LETTER S WITH CARON;Ll;0;L;0073 030C;;;;N;LATIN SMALL LETTER S HACEK;;0160;;0160
0162;LATIN CAPITAL LETTER T WITH CEDILLA;Lu;0;L;0054 0327;;;;N;LATIN CAPITAL LETTER T CEDILLA;;;0163;
0163;LATIN SMALL LETTER T WITH CEDILLA;Ll;0;L;0074 0327;;;;N;LATIN SMALL LETTER T CEDILLA;;0162;;0162
0164;LATIN CAPITAL LETTER T WITH CARON;Lu;0;L;0054 030C;;;;N;LATIN CAPITAL LETTER T HACEK;;;0165;
0165;LATIN SMALL LETTER T WITH CARON;Ll;0;L;0074 030C;;;;N;LATIN SMALL LETTER T HACEK;;0164;;0164
0166;LATIN CAPITAL LETTER T WITH STROKE;Lu;0;L;;;;;N;LATIN CAPITAL LETTER T BAR;;;0167;
0167;LATIN SMALL LETTER T WITH STROKE;Ll;0;L;;;;;N;LATIN SMALL LETTER T BAR;;0166;;0166
0168;LATIN CAPITAL LETTER U WITH TILDE;Lu;0;L;0055 0303;;;;N;LATIN CAPITAL LETTER U TILDE;;;0169;
0169;LATIN SMALL LETTER U WITH TILDE;Ll;0;L;0075 0303;;;;N;LATIN SMALL LETTER U TILDE;;0168;;0168
016A;LATIN CAPITAL LETTER U WITH MACRON;Lu;0;L;0055 0304;;;;N;LATIN CAPITAL LETTER U MACRON;;;016B;
016B;LATIN SMALL LETTER U WITH MACRON;Ll;0;L;0075 0304;;;;N;LATIN SMALL LETTER U MACRON;;016A;;016A
016C;LATIN CAPITAL LETTER U WITH BREVE;Lu;0;L;0055 0306;;;;N;LATIN CAPITAL LETTER U BREVE;;;016D;
016D;LATIN SMALL LETTER U WITH BREVE;Ll;0;L;0075 0306;;;;N;LATIN SMALL LETTER U BREVE;;016C;;016C
016E;LATIN CAPITAL LETTER U WITH RING ABOVE;Lu;0;L;0055 030A;;;;N;LATIN CAPITAL LETTER U RING;;;016F;
016F;LATIN SMALL LETTER U WITH RING ABOVE;Ll;0;L;0075 030A;;;;N;LATIN SMALL LETTER U RING;;016E;;016E
0170;LATIN CAPITAL LETTER U WITH DOUBLE ACUTE;Lu;0;L;0055 030B;;;;N;LATIN CAPITAL LETTER U DOUBLE ACUTE;;;0171;
0171;LATIN SMALL LETTER U WITH DOUBLE ACUTE;Ll;0;L;0075 030B;;;;N;LATIN SMALL LETTER U DOUBLE ACUTE;;0170;;0170
0172;LATIN CAPITAL LETTER U WITH OGONEK;Lu;0;L;0055 0328;;;;N;LATIN CAPITAL LETTER U OGONEK;;;0173;
0173;LATIN SMALL LETTER U WITH OGONEK;Ll;0;L;0075 0328;;;;N;LATIN SMALL LETTER U OGONEK;;0172;;0172
0174;LATIN CAPITAL LETTER W WITH CIRCUMFLEX;Lu;0;L;0057 0302;;;;N;LATIN CAPITAL LETTER W CIRCUMFLEX;;;0175;
0175;LATIN SMALL LETTER W WITH CIRCUMFLEX;Ll;0;L;0077 0302;;;;N;LATIN SMALL LETTER W CIRCUMFLEX;;0174;;0174
0176;LATIN CAPITAL LETTER Y WITH CIRCUMFLEX;Lu;0;L;0059 0302;;;;N;LATIN CAPITAL LETTER Y CIRCUMFLEX;;;0177;
0177;LATIN SMALL LETTER Y WITH CIRCUMFLEX;Ll;0;L;0079 0302;;;;N;LATIN SMALL LETTER Y CIRCUMFLEX;;0176;;0176
0178;LATIN CAPITAL LETTER Y WITH DIAERESIS;Lu;0;L;0059 0308;;;;N;LATIN CAPITAL LETTER Y DIAERESIS;;;00FF;
0179;LATIN CAPITAL LETTER Z WITH ACUTE;Lu;0;L;005A 0301;;;;N;LATIN CAPITAL LETTER Z ACUTE;;;017A;
017A;LATIN SMALL LETTER Z WITH ACUTE;Ll;0;L;007A 0301;;;;N;LATIN SMALL LETTER Z ACUTE;;0179;;0179
017B;LATIN CAPITAL LETTER Z WITH DOT ABOVE;Lu;0;L;005A 0307;;;;N;LATIN CAPITAL LETTER Z DOT;;;017C;
017C;LATIN SMALL LETTER Z WITH DOT ABOVE;Ll;0;L;007A 0307;;;;N;LATIN SMALL LETTER Z DOT;;017B;;017B
017D;LATIN CAPITAL LETTER Z WITH CARON;Lu;0;L;005A 030C;;;;N;LATIN CAPITAL LETTER Z HACEK;;;017E;
017E;LATIN SMALL LETTER Z WITH CARON;Ll;0;L;007A 030C;;;;N;LATIN SMALL LETTER Z HACEK;;017D;;017D
017F;LATIN SMALL LETTER LONG S;Ll;0;L;<compat> 0073;;;;N;;;0053;;0053
0180;LATIN SMALL LETTER B WITH STROKE;Ll;0;L;;;;;N;LATIN SMALL LETTER B BAR;;0243;;0243
0181;LATIN CAPITAL LETTER B WITH HOOK;Lu;0;L;;;;;N;LATIN CAPITAL LETTER B HOOK;;;0253;
0182;LATIN CAPITAL LETTER B WITH TOPBAR;Lu;0;L;;;;;N;LATIN CAPITAL LETTER B TOPBAR;;;0183;
0183;LATIN SMALL LETTER B WITH TOPBAR;Ll;0;L;;;;;N;LATIN SMALL LETTER B TOPBAR;;0182;;0182
0184;LATIN CAPITAL LETTER TONE SIX;Lu;0;L;;;;;N;;;;0185;
0185;LATIN SMALL LETTER TONE SIX;Ll;0;L;;;;;N;;;0184;;0184
0186;LATIN CAPITAL LETTER OPEN O;Lu;0;L;;;;;N;;;;0254;
0187;LATIN CAPITAL LETTER C WITH HOOK;Lu;0;L;;;;;N;LATIN CAPITAL LETTER C HOOK;;;0188;
0188;LATIN SMALL LETTER C WITH HOOK;Ll;0;L;;;;;N;LATIN SMALL LETTER C HOOK;;0187;;0187
0189;LATIN CAPITAL LETTER AFRICAN D;Lu;0;L;;;;;N;;;;0256;
018A;LATIN CAPITAL LETTER D WITH HOOK;Lu;0;L;;;;;N;LATIN CAPITAL LETTER D HOOK;;;0257;
018B;LATIN CAPITAL LETTER D WITH TOPBAR;Lu;0;L;;;;;N;LATIN CAPITAL LETTER D TOPBAR;;;018C;
018C;LATIN SMALL LETTER D WITH TOPBAR;Ll;0;L;;;;;N;LATIN SMALL LETTER D TOPBAR;;018B;;018B
018D;LATIN SMALL LETTER TURNED DELTA;Ll;0;L;;;;;N;;;;;
018E;LATIN CAPITAL LETTER REVERSED E;Lu;0;L;;;;;N;LATIN CAPITAL LETTER TURNED E;;;01DD;
018F;LATIN CAPITAL LETTER SCHWA;Lu;0;L;;;;;N;;;;0259;
0190;LATIN CAPITAL LETTER OPEN E;Lu;0;L;;;;;N;LATIN CAPITAL LETTER EPSILON;;;025B;
0191;LATIN CAPITAL LETTER F WITH HOOK;Lu;0;L;;;;;N;LATIN CAPITAL LETTER F HOOK;;;0192;
0192;LATIN SMALL LETTER F WITH HOOK;Ll;0;L;;;;;N;LATIN SMALL LETTER SCRIPT F;;0191;;0191
0193;LATIN CAPITAL LETTER G WITH HOOK;Lu;0;L;;;;;N;LATIN CAPITAL LETTER G HOOK;;;0260;
0194;LATIN CAPITAL LETTER GAMMA;Lu;0;L;;;;;N;;;;0263;
0195;LATIN SMALL LETTER HV;Ll;0;L;;;;;N;LATIN SMALL LETTER H V;;01F6;;01F6
0196;LATIN CAPITAL LETTER IOTA;Lu;0;L;;;;;N;;;;0269;
0197;LATIN CAPITAL LETTER I WITH STROKE;Lu;0;L;;;;;N;LATIN CAPITAL LETTER BARRED I;;;0268;
0198;LATIN CAPITAL LETTER K WITH HOOK;Lu;0;L;;;;;N;LATIN CAPITAL LETTER K HOOK;;;0199;
0199;LATIN SMALL LETTER K WITH HOOK;Ll;0;L;;;;;N;LATIN SMALL LETTER K HOOK;;0198;;0198
019A;LATIN SMALL LETTER L WITH BAR;Ll;0;L;;;;;N;LATIN SMALL LETTER BARRED L;;023D;;023D
019B;LATIN SMALL LETTER LAMBDA WITH STROKE;Ll;0;L;;;;;N;LATIN SMALL LETTER BARRED LAMBDA;;;;
019C;LATIN CAPITAL LETTER TURNED M;Lu;0;L;;;;;N;;;;026F;
019D;LATIN CAPITAL LETTER N WITH LEFT HOOK;Lu;0;L;;;;;N;LATIN CAPITAL LETTER N HOOK;;;0272;
019E;LATIN SMALL LETTER N WITH LONG RIGHT LEG;Ll;0;L;;;;;N;;;0220;;0220
019F;LATIN CAPITAL LETTER O WITH MIDDLE TILDE;Lu;0;L;;;;;N;LATIN CAPITAL LETTER BARRED O;;;0275;
01A0;LATIN CAPITAL LETTER O WITH HORN;Lu;0;L;004F 031B;;;;N;LATIN CAPITAL LETTER O HORN;;;01A1;
01A1;LATIN SMALL LETTER O WITH HORN;Ll;0;L;006F 031B;;;;N;LATIN SMALL LETTER O HORN;;01A0;;01A0
01A2;LATIN CAPITAL LETTER OI;Lu;0;L;;;;;N;LATIN CAPITAL LETTER O I;;;01A3;
01A3;LATIN SMALL LETTER OI;Ll;0;L;;;;;N;LATIN SMALL LETTER O I;;01A2;;01A2
01A4;LATIN CAPITAL LETTER P WITH HOOK;Lu;0;L;;;;;N;LATIN CAPITAL LETTER P HOOK;;;01A5;
01A5;LATIN SMALL LETTER P WITH HOOK;Ll;0;L;;;;;N;LATIN SMALL LETTER P HOOK;;01A4;;01A4
01A6;LATIN LETTER YR;Lu;0;L;;;;;N;LATIN LETTER Y R;;;0280;
01A7;LATIN CAPITAL LETTER TONE TWO;Lu;0;L;;;;;N;;;;01A8;
01A8;LATIN SMALL LETTER TONE TWO;Ll;0;L;;;;;N;;;01A7;;01A7
01A9;LATIN CAPITAL LETTER ESH;Lu;0;L;;;;;N;;;;0283;
01AA;LATIN LETTER REVERSED ESH LOOP;Ll;0;L;;;;;N;;;;;
01AB;LATIN SMALL LETTER T WITH PALATAL HOOK;Ll;0;L;;;;;N;LATIN SMALL LETTER T PALATAL HOOK;;;;
01AC;LATIN CAPITAL LETTER T WITH HOOK;Lu;0;L;;;;;N;LATIN CAPITAL LETTER T HOOK;;;01AD;
01AD;LATIN SMALL LETTER T WITH HOOK;Ll;0;L;;;;;N;LATIN SMALL LETTER T HOOK;;01AC;;01AC
01AE;LATIN CAPITAL LETTER T WITH RETROFLEX HOOK;Lu;0;L;;;;;N;LATIN CAPITAL LETTER T RETROFLEX HOOK;;;0288;
01AF;LATIN CAPITAL LETTER U WITH HORN;Lu;0;L;0055 031B;;;;N;LATIN CAPITAL LETTER U HORN;;;01B0;
01B0;LATIN SMALL LETTER U WITH HORN;Ll;0;L;0075 031B;;;;N;LATIN SMALL LETTER U HORN;;01AF;;01AF
01B1;LATIN CAPITAL LETTER UPSILON;Lu;0;L;;;;;N;;;;028A;
01B2;LATIN CAPITAL LETTER V WITH HOOK;Lu;0;L;;;;;N;LATIN CAPITAL LETTER SCRIPT V;;;028B;
01B3;LATIN CAPITAL LETTER Y WITH HOOK;Lu;0;L;;;;;N;LATIN CAPITAL LETTER Y HOOK;;;01B4;
01B4;LATIN SMALL LETTER Y WITH HOOK;Ll;0;L;;;;;N;LATIN SMALL LETTER Y HOOK;;01B3;;01B3
01B5;LATIN CAPITAL LETTER Z WITH STROKE;Lu;0;L;;;;;N;LATIN CAPITAL LETTER Z BAR;;;01B6;
01B6;LATIN SMALL LETTER Z WITH STROKE;Ll;0;L;;;;;N;LATIN SMALL LETTER Z BAR;;01B5;;01B5
01B7;LATIN CAPITAL LETTER EZH;Lu;0;L;;;;;N;LATIN CAPITAL LETTER YOGH;;;0292;
01B8;LATIN CAPITAL LETTER EZH REVERSED;Lu;0;L;;;;;N;LATIN CAPITAL LETTER REVERSED YOGH;;;01B9;
01B9;LATIN SMALL LETTER EZH REVERSED;Ll;0;L;;;;;N;LATIN SMALL LETTER REVERSED YOGH;;01B8;;01B8
01BA;LATIN SMALL LETTER EZH WITH TAIL;Ll;0;L;;;;;N;LATIN SMALL LETTER YOGH WITH TAIL;;;;
01BB;LATIN LETTER TWO WITH STROKE;Lo;0;L;;;;;N;LATIN LETTER TWO BAR;;;;
01BC;LATIN CAPITAL LETTER TONE FIVE;Lu;0;L;;;;;N;;;;01BD;
01BD;LATIN SMALL LETTER TONE FIVE;Ll;0;L;;;;;N;;;01BC;;01BC
01BE;LATIN LETTER INVERTED GLOTTAL STOP WITH STROKE;Ll;0;L;;;;;N;LATIN LETTER INVERTED GLOTTAL STOP BAR;;;;
01BF;LATIN LETTER WYNN;Ll;0;L;;;;;N;;;01F7;;01F7
01C0;LATIN LETTER DENTAL CLICK;Lo;0;L;;;;;N;LATIN LETTER PIPE;;;;
01C1;LATIN LETTER LATERAL CLICK;Lo;0;L;;;;;N;LATIN LETTER DOUBLE PIPE;;;;
01C2;LATIN LETTER ALVEOLAR CLICK;Lo;0;L;;;;;N;LATIN LETTER PIPE DOUBLE BAR;;;;
01C3;LATIN LETTER RETROFLEX CLICK;Lo;0;L;;;;;N;LATIN LETTER EXCLAMATION MARK;;;;
01C4;LATIN CAPITAL LETTER DZ WITH CARON;Lu;0;L;<compat> 0044 017D;;;;N;LATIN CAPITAL LETTER D Z HACEK;;;01C6;01C5
01C5;LATIN CAPITAL LETTER D WITH SMALL LETTER Z WITH CARON;Lt;0;L;<compat> 0044 017E;;;;N;LATIN LETTER CAPITAL D SMALL Z HACEK;;01C4;01C6;01C5
01C6;LATIN SMALL LETTER DZ WITH CARON;Ll;0;L;<compat> 0064 017E;;;;N;LATIN SMALL LETTER D Z HACEK;;01C4;;01C5
01C7;LATIN CAPITAL LETTER LJ;Lu;0;L;<compat> 004C 004A;;;;N;LATIN CAPITAL LETTER L J;;;01C9;01C8
01C8;LATIN CAPITAL LETTER L WITH SMALL LETTER J;Lt;0;L;<compat> 004C 006A;;;;N;LATIN LETTER CAPITAL L SMALL J;;01C7;01C9;01C8
01C9;LATIN SMALL LETTER LJ;Ll;0;L;<compat> 006C 006A;;;;N;LATIN SMALL LETTER L J;;01C7;;01C8
01CA;LATIN CAPITAL LETTER NJ;Lu;0;L;<compat> 004E 004A;;;;N;LATIN CAPITAL LETTER N J;;;01CC;01CB
01CB;LATIN CAPITAL LETTER N WITH SMALL LETTER J;Lt;0;L;<compat> 004E 006A;;;;N;LATIN LETTER CAPITAL N SMALL J;;01CA;01CC;01CB
01CC;LATIN SMALL LETTER NJ;Ll;0;L;<compat> 006E 006A;;;;N;LATIN SMALL LETTER N J;;01CA;;01CB
01CD;LATIN CAPITAL LETTER A WITH CARON;Lu;0;L;0041 030C;;;;N;LATIN CAPITAL LETTER A HACEK;;;01CE;
01CE;LATIN SMALL LETTER A WITH CARON;Ll;0;L;0061 030C;;;;N;LATIN SMALL LETTER A HACEK;;01CD;;01CD
01CF;LATIN CAPITAL LETTER I WITH CARON;Lu;0;L;0049 030C;;;;N;LATIN CAPITAL LETTER I HACEK;;;01D0;
01D0;LATIN SMALL LETTER I WITH CARON;Ll;0;L;0069 030C;;;;N;LATIN SMALL LETTER I HACEK;;01CF;;01CF
01D1;LATIN CAPITAL LETTER O WITH CARON;Lu;0;L;004F 030C;;;;N;LATIN CAPITAL LETTER O HACEK;;;01D2;
01D2;LATIN SMALL LETTER O WITH CARON;Ll;0;L;006F 030C;;;;N;LATIN SMALL LETTER O HACEK;;01D1;;01D1
01D3;LATIN CAPITAL LETTER U WITH CARON;Lu;0;L;0055 030C;;;;N;LATIN CAPITAL LETTER U HACEK;;;01D4;
01D4;LATIN SMALL LETTER U WITH CARON;Ll;0;L;0075 030C;;;;N;LATIN SMALL LETTER U HACEK;;01D3;;01D3
01D5;LATIN CAPITAL LETTER U WITH DIAERESIS AND MACRON;Lu;0;L;00DC 0304;;;;N;LATIN CAPITAL LETTER U DIAERESIS MACRON;;;01D6;
01D6;LATIN SMALL LETTER U WITH DIAERESIS AND MACRON;Ll;0;L;00FC 0304;;;;N;LATIN SMALL LETTER U DIAERESIS MACRON;;01D5;;01D5
01D7;LATIN CAPITAL LETTER U WITH DIAERESIS AND ACUTE;Lu;0;L;00DC 0301;;;;N;LATIN CAPITAL LETTER U DIAERESIS ACUTE;;;01D8;
01D8;LATIN SMALL LETTER U WITH DIAERESIS AND ACUTE;Ll;0;L;00FC 0301;;;;N;LATIN SMALL LETTER U DIAERESIS ACUTE;;01D7;;01D7
01D9;LATIN CAPITAL LETTER U WITH DIAERESIS AND CARON;Lu;0;L;00DC 030C;;;;N;LATIN CAPITAL LETTER U DIAERESIS HACEK;;;01DA;
01DA;LATIN SMALL LETTER U WITH DIAERESIS AND CARON;Ll;0;L;00FC 030C;;;;N;LATIN SMALL LETTER U DIAERESIS HACEK;;01D9;;01D9
01DB;LATIN CAPITAL LETTER U WITH DIAERESIS AND GRAVE;Lu;0;L;00DC 0300;;;;N;LATIN CAPITAL LETTER U DIAERESIS GRAVE;;;01DC;
01DC;LATIN SMALL LETTER U WITH DIAERESIS AND GRAVE;Ll;0;L;00FC 0300;;;;N;LATIN SMALL LETTER U DIAERESIS GRAVE;;01DB;;01DB
01DD;LATIN SMALL LETTER TURNED E;Ll;0;L;;;;;N;;;018E;;018E
01DE;LATIN CAPITAL LETTER A WITH DIAERESIS AND MACRON;Lu;0;L;00C4 0304;;;;N;LATIN CAPITAL LETTER A DIAERESIS MACRON;;;01DF;
01DF;LATIN SMALL LETTER A WITH DIAERESIS AND MACRON;Ll;0;L;00E4 0304;;;;N;LATIN SMALL LETTER A DIAERESIS MACRON;;01DE;;01DE
01E0;LATIN CAPITAL LETTER A WITH DOT ABOVE AND MACRON;Lu;0;L;0226 0304;;;;N;LATIN CAPITAL LETTER A DOT MACRON;;;01E1;
01E1;LATIN SMALL LETTER A WITH DOT ABOVE AND MACRON;Ll;0;L;0227 0304;;;;N;LATIN SMALL LETTER A DOT MACRON;;01E0;;01E0
01E2;LATIN CAPITAL LETTER AE WITH MACRON;Lu;0;L;00C6 0304;;;;N;LATIN CAPITAL LETTER A E MACRON;;;01E3;
01E3;LATIN SMALL LETTER AE WITH MACRON;Ll;0;L;00E6 0304;;;;N;LATIN SMALL LETTER A E MACRON;;01E2;;01E2
01E4;LATIN CAPITAL LETTER G WITH STROKE;Lu;0;L;;;;;N;LATIN CAPITAL LETTER G BAR;;;01E5;
01E5;LATIN SMALL LETTER G WITH STROKE;Ll;0;L;;;;;N;LATIN SMALL LETTER G BAR;;01E4;;01E4
01E6;LATIN CAPITAL LETTER G WITH CARON;Lu;0;L;0047 030C;;;;N;LATIN CAPITAL LETTER G HACEK;;;01E7;
01E7;LATIN SMALL LETTER G WITH CARON;Ll;0;L;0067 030C;;;;N;LATIN SMALL LETTER G HACEK;;01E6;;01E6
01E8;LATIN CAPITAL LETTER K WITH CARON;Lu;0;L;004B 030C;;;;N;LATIN CAPITAL LETTER K HACEK;;;01E9;
01E9;LATIN SMALL LETTER K WITH CARON;Ll;0;L;006B 030C;;;;N;LATIN SMALL LETTER K HACEK;;01E8;;01E8
01EA;LATIN CAPITAL LETTER O WITH OGONEK;Lu;0;L;004F 0328;;;;N;LATIN CAPITAL LETTER O OGONEK;;;01EB;
01EB;LATIN SMALL LETTER O WITH OGONEK;Ll;0;L;006F 0328;;;;N;LATIN SMALL LETTER O OGONEK;;01EA;;01EA
01EC;LATIN CAPITAL LETTER O WITH OGONEK AND MACRON;Lu;0;L;01EA 0304;;;;N;LATIN CAPITAL LETTER O OGONEK MACRON;;;01ED;
01ED;LATIN SMALL LETTER O WITH OGONEK AND MACRON;Ll;0;L;01EB 0304;;;;N;LATIN SMALL LETTER O OGONEK MACRON;;01EC;;01EC
01EE;LATIN CAPITAL LETTER EZH WITH CARON;Lu;0;L;01B7 030C;;;;N;LATIN CAPITAL LETTER YOGH HACEK;;;01EF;
01EF;LATIN SMALL LETTER EZH WITH CARON;Ll;0;L;0292 030C;;;;N;LATIN SMALL LETTER YOGH HACEK;;01EE;;01EE
01F0;LATIN SMALL LETTER J WITH CARON;Ll;0;L;006A 030C;;;;N;LATIN SMALL LETTER J HACEK;;;;
01F1;LATIN CAPITAL LETTER DZ;Lu;0;L;<compat> 0044 005A;;;;N;;;;01F3;01F2
01F2;LATIN CAPITAL LETTER D WITH SMALL LETTER Z;Lt;0;L;<compat> 0044 007A;;;;N;;;01F1;01F3;01F2
01F3;LATIN SMALL LETTER DZ;Ll;0;L;<compat> 0064 007A;;;;N;;;01F1;;01F2
01F4;LATIN CAPITAL LETTER G WITH ACUTE;Lu;0;L;0047 0301;;;;N;;;;01F5;
01F5;LATIN SMALL LETTER G WITH ACUTE;Ll;0;L;0067 0301;;;;N;;;01F4;;01F4
01F6;LATIN CAPITAL LETTER HWAIR;Lu;0;L;;;;;N;;;;0195;
01F7;LATIN CAPITAL LETTER WYNN;Lu;0;L;;;;;N;;;;01BF;
01F8;LATIN CAPITAL LETTER N WITH GRAVE;Lu;0;L;004E 0300;;;;N;;;;01F9;
01F9;LATIN SMALL LETTER N WITH GRAVE;Ll;0;L;006E 0300;;;;N;;;01F8;;01F8
01FA;LATIN CAPITAL LETTER A WITH RING ABOVE AND ACUTE;Lu;0;L;00C5 0301;;;;N;;;;01FB;
01FB;LATIN SMALL LETTER A WITH RING ABOVE AND ACUTE;Ll;0;L;00E5 0301;;;;N;;;01FA;;01FA
01FC;LATIN CAPITAL LETTER AE WITH ACUTE;Lu;0;L;00C6 0301;;;;N;;;;01FD;
01FD;LATIN SMALL LETTER AE WITH ACUTE;Ll;0;L;00E6 0301;;;;N;;;01FC;;01FC
01FE;LATIN CAPITAL LETTER O WITH STROKE AND ACUTE;Lu;0;L;00D8 0301;;;;N;;;;01FF;
01FF;LATIN SMALL LETTER O WITH STROKE AND ACUTE;Ll;0;L;00F8 0301;;;;N;;;01FE;;01FE
0200;LATIN CAPITAL LETTER A WITH DOUBLE GRAVE;Lu;0;L;0041 030F;;;;N;;;;0201;
0201;LATIN SMALL LETTER A WITH DOUBLE GRAVE;Ll;0;L;0061 030F;;;;N;;;0200;;0200
0202;LATIN CAPITAL LETTER A WITH INVERTED BREVE;Lu;0;L;0041 0311;;;;N;;;;0203;
0203;LATIN SMALL LETTER A WITH INVERTED BREVE;Ll;0;L;0061 0311;;;;N;;;0202;;0202
0204;LATIN CAPITAL LETTER E WITH DOUBLE GRAVE;Lu;0;L;0045 030F;;;;N;;;;0205;
0205;LATIN SMALL LETTER E WITH DOUBLE GRAVE;Ll;0;L;0065 030F;;;;N;;;0204;;0204
0206;LATIN CAPITAL LETTER E WITH INVERTED BREVE;Lu;0;L;0045 0311;;;;N;;;;0207;
0207;LATIN SMALL LETTER E WITH INVERTED BREVE;Ll;0;L;0065 0311;;;;N;;;0206;;0206
0208;LATIN CAPITAL LETTER I WITH DOUBLE GRAVE;Lu;0;L;0049 030F;;;;N;;;;0209;
0209;LATIN SMALL LETTER I WITH DOUBLE GRAVE;Ll;0;L;0069 030F;;;;N;;;0208;;0208
020A;LATIN CAPITAL LETTER I WITH INVERTED BREVE;Lu;0;L;0049 0311;;;;N;;;;020B;
020B;LATIN SMALL LETTER I WITH INVERTED BREVE;Ll;0;L;0069 0311;;;;N;;;020A;;020A
020C;LATIN CAPITAL LETTER O WITH DOUBLE GRAVE;Lu;0;L;004F 030F;;;;N;;;;020D;
020D;LATIN SMALL LETTER O WITH DOUBLE GRAVE;Ll;0;L;006F 030F;;;;N;;;020C;;020C
020E;LATIN CAPITAL LETTER O WITH INVERTED BREVE;Lu;0;L;004F 0311;;;;N;;;;020F;
020F;LATIN SMALL LETTER O WITH INVERTED BREVE;Ll;0;L;006F 0311;;;;N;;;020E;;020E
0210;LATIN CAPITAL LETTER R WITH DOUBLE GRAVE;Lu;0;L;0052 030F;;;;N;;;;0211;
0211;LATIN SMALL LETTER R WITH DOUBLE GRAVE;Ll;0;L;0072 030F;;;;N;;;0210;;0210
0212;LATIN CAPITAL LETTER R WITH INVERTED BREVE;Lu;0;L;0052 0311;;;;N;;;;0213;
0213;LATIN SMALL LETTER R WITH INVERTED BREVE;Ll;0;L;0072 0311;;;;N;;;0212;;0212
0214;LATIN CAPITAL LETTER U WITH DOUBLE GRAVE;Lu;0;L;0055 030F;;;;N;;;;0215;
0215;LATIN SMALL LETTER U WITH DOUBLE GRAVE;Ll;0;L;0075 030F;;;;N;;;0214;;0214
0216;LATIN CAPITAL LETTER U WITH INVERTED BREVE;Lu;0;L;0055 0311;;;;N;;;;0217;
0217;LATIN SMALL LETTER U WITH INVERTED BREVE;Ll;0;L;0075 0311;;;;N;;;0216;;0216
0218;LATIN CAPITAL LETTER S WITH COMMA BELOW;Lu;0;L;0053 0326;;;;N;;;;0219;
0219;LATIN SMALL LETTER S WITH COMMA BELOW;Ll;0;L;0073 0326;;;;N;;;0218;;0218
021A;LATIN CAPITAL LETTER T WITH COMMA BELOW;Lu;0;L;0054 0326;;;;N;;;;021B;
021B;LATIN SMALL LETTER T WITH COMMA BELOW;Ll;0;L;0074 0326;;;;N;;;021A;;021A
021C;LATIN CAPITAL LETTER YOGH;Lu;0;L;;;;;N;;;;021D;
021D;LATIN SMALL LETTER YOGH;Ll;0;L;;;;;N;;;021C;;021C
021E;LATIN CAPITAL LETTER H WITH CARON;Lu;0;L;0048 030C;;;;N;;;;021F;
021F;LATIN SMALL LETTER H WITH CARON;Ll;0;L;0068 030C;;;;N;;;021E;;021E
0220;LATIN CAPITAL LETTER N WITH LONG RIGHT LEG;Lu;0;L;;;;;N;;;;019E;
0221;LATIN SMALL LETTER D WITH CURL;Ll;0;L;;;;;N;;;;;
0222;LATIN CAPITAL LETTER OU;Lu;0;L;;;;;N;;;;0223;
0223;LATIN SMALL LETTER OU;Ll;0;L;;;;;N;;;0222;;0222
0224;LATIN CAPITAL LETTER Z WITH HOOK;Lu;0;L;;;;;N;;;;0225;
0225;LATIN SMALL LETTER Z WITH HOOK;Ll;0;L;;;;;N;;;0224;;0224
0226;LATIN CAPITAL LETTER A WITH DOT ABOVE;Lu;0;L;0041 0307;;;;N;;;;0227;
0227;LATIN SMALL LETTER A WITH DOT ABOVE;Ll;0;L;0061 0307;;;;N;;;0226;;0226
0228;LATIN CAPITAL LETTER E WITH CEDILLA;Lu;0;L;0045 0327;;;;N;;;;0229;
0229;LATIN SMALL LETTER E WITH CEDILLA;Ll;0;L;0065 0327;;;;N;;;0228;;0228
022A;LATIN CAPITAL LETTER O WITH DIAERESIS AND MACRON;Lu;0;L;00D6 0304;;;;N;;;;022B;
022B;LATIN SMALL LETTER O WITH DIAERESIS AND MACRON;Ll;0;L;00F6 0304;;;;N;;;022A;;022A
022C;LATIN CAPITAL LETTER O WITH TILDE AND MACRON;Lu;0;L;00D5 0304;;;;N;;;;022D;
022D;LATIN SMALL LETTER O WITH TILDE AND MACRON;Ll;0;L;00F5 0304;;;;N;;;022C;;022C
022E;LATIN CAPITAL LETTER O WITH DOT ABOVE;Lu;0;L;004F 0307;;;;N;;;;022F;
022F;LATIN SMALL LETTER O WITH DOT ABOVE;Ll;0;L;006F 0307;;;;N;;;022E;;022E
0230;LATIN CAPITAL LETTER O WITH DOT ABOVE AND MACRON;Lu;0;L;022E 0304;;;;N;;;;0231;
0231;LATIN SMALL LETTER O WITH DOT ABOVE AND MACRON;Ll;0;L;022F 0304;;;;N;;;0230;;0230
0232;LATIN CAPITAL LETTER Y WITH MACRON;Lu;0;L;0059 0304;;;;N;;;;0233;
0233;LATIN SMALL LETTER Y WITH MACRON;Ll;0;L;0079 0304;;;;N;;;0232;;0232
0234;LATIN SMALL LETTER L WITH CURL;Ll;0;L;;;;;N;;;;;
0235;LATIN SMALL LETTER N WITH CURL;Ll;0;L;;;;;N;;;;;
0236;LATIN SMALL LETTER T WITH CURL;Ll;0;L;;;;;N;;;;;
0237;LATIN SMALL LETTER DOTLESS J;Ll;0;L;;;;;N;;;;;
0238;LATIN SMALL LETTER DB DIGRAPH;Ll;0;L;;;;;N;;;;;
0239;LATIN SMALL LETTER QP DIGRAPH;Ll;0;L;;;;;N;;;;;
023A;LATIN CAPITAL LETTER A WITH STROKE;Lu;0;L;;;;;N;;;;2C65;
023B;LATIN CAPITAL LETTER C WITH STROKE;Lu;0;L;;;;;N;;;;023C;
023C;LATIN SMALL LETTER C WITH STROKE;Ll;0;L;;;;;N;;;023B;;023B
023D;LATIN CAPITAL LETTER L WITH BAR;Lu;0;L;;;;;N;;;;019A;
023E;LATIN CAPITAL LETTER T WITH DIAGONAL STROKE;Lu;0;L;;;;;N;;;;2C66;
023F;LATIN SMALL LETTER S WITH SWASH TAIL;Ll;0;L;;;;;N;;;2C7E;;2C7E
0240;LATIN SMALL LETTER Z WITH SWASH TAIL;Ll;0;L;;;;;N;;;2C7F;;2C7F
0241;LATIN CAPITAL LETTER GLOTTAL STOP;Lu;0;L;;;;;N;;;;0242;
0242;LATIN SMALL LETTER GLOTTAL STOP;Ll;0;L;;;;;N;;;0241;;0241
0243;LATIN CAPITAL LETTER B WITH STROKE;Lu;0;L;;;;;N;;;;0180;
0244;LATIN CAPITAL LETTER U BAR;Lu;0;L;;;;;N;;;;0289;
0245;LATIN CAPITAL LETTER TURNED V;Lu;0;L;;;;;N;;;;028C;
0246;LATIN CAPITAL LETTER E WITH STROKE;Lu;0;L;;;;;N;;;;0247;
0247;LATIN SMALL LETTER E WITH STROKE;Ll;0;L;;;;;N;;;0246;;0246
0248;LATIN CAPITAL LETTER J WITH STROKE;Lu;0;L;;;;;N;;;;0249;
0249;LATIN SMALL LETTER J WITH STROKE;Ll;0;L;;;;;N;;;0248;;0248
024A;LATIN CAPITAL LETTER SMALL Q WITH HOOK TAIL;Lu;0;L;;;;;N;;;;024B;
024B;LATIN SMALL LETTER Q WITH HOOK TAIL;Ll;0;L;;;;;N;;;024A;;024A
024C;LATIN CAPITAL LETTER R WITH STROKE;Lu;0;L;;;;;N;;;;024D;
024D;LATIN SMALL LETTER R WITH STROKE;Ll;0;L;;;;;N;;;024C;;024C
024E;LATIN CAPITAL LETTER Y WITH STROKE;Lu;0;L;;;;;N;;;;024F;
024F;LATIN SMALL LETTER Y WITH STROKE;Ll;0;L;;;;;N;;;024E;;024E
0250;LATIN SMALL LETTER TURNED A;Ll;0;L;;;;;N;;;2C6F;;2C6F
0251;LATIN SMALL LETTER ALPHA;Ll;0;L;;;;;N;LATIN SMALL LETTER SCRIPT A;;2C6D;;2C6D
0252;LATIN SMALL LETTER TURNED ALPHA;Ll;0;L;;;;;N;LATIN SMALL LETTER TURNED SCRIPT A;;2C70;;2C70
0253;LATIN SMALL LETTER B WITH HOOK;Ll;0;L;;;;;N;LATIN SMALL LETTER B HOOK;;0181;;0181
0254;LATIN SMALL LETTER OPEN O;Ll;0;L;;;;;N;;;0186;;0186
0255;LATIN SMALL LETTER C WITH CURL;Ll;0;L;;;;;N;LATIN SMALL LETTER C CURL;;;;
0256;LATIN SMALL LETTER D WITH TAIL;Ll;0;L;;;;;N;LATIN SMALL LETTER D RETROFLEX HOOK;;0189;;0189
0257;LATIN SMALL LETTER D WITH HOOK;Ll;0;L;;;;;N;LATIN SMALL LETTER D HOOK;;018A;;018A
0258;LATIN SMALL LETTER REVERSED E;Ll;0;L;;;;;N;;;;;
0259;LATIN SMALL LETTER SCHWA;Ll;0;L;;;;;N;;;018F;;018F
025A;LATIN SMALL LETTER SCHWA WITH HOOK;Ll;0;L;;;;;N;LATIN SMALL LETTER SCHWA HOOK;;;;
025B;LATIN SMALL LETTER OPEN E;Ll;0;L;;;;;N;LATIN SMALL LETTER EPSILON;;0190;;0190
025C;LATIN SMALL LETTER REVERSED OPEN E;Ll;0;L;;;;;N;LATIN SMALL LETTER REVERSED EPSILON;;A7AB;;A7AB
025D;LATIN SMALL LETTER REVERSED OPEN E WITH HOOK;Ll;0;L;;;;;N;LATIN SMALL LETTER REVERSED EPSILON HOOK;;;;
025E;LATIN SMALL LETTER CLOSED REVERSED OPEN E;Ll;0;L;;;;;N;LATIN SMALL LETTER CLOSED REVERSED EPSILON;;;;
025F;LATIN SMALL LETTER DOTLESS J WITH STROKE;Ll;0;L;;;;;N;LATIN SMALL LETTER DOTLESS J BAR;;;;
0260;LATIN SMALL LETTER G WITH HOOK;Ll;0;L;;;;;N;LATIN SMALL LETTER G HOOK;;0193;;0193
0261;LATIN SMALL LETTER SCRIPT G;Ll;0;L;;;;;N;;;A7AC;;A7AC
0262;LATIN LETTER SMALL CAPITAL G;Ll;0;L;;;;;N;;;;;
0263;LATIN SMALL LETTER GAMMA;Ll;0;L;;;;;N;;;0194;;0194
0264;LATIN SMALL LETTER RAMS HORN;Ll;0;L;;;;;N;LATIN SMALL LETTER BABY GAMMA;;;;
0265;LATIN SMALL LETTER TURNED H;Ll;0;L;;;;;N;;;A78D;;A78D
0266;LATIN SMALL LETTER H WITH HOOK;Ll;0;L;;;;;N;LATIN SMALL LETTER H HOOK;;A7AA;;A7AA
0267;LATIN SMALL LETTER HENG WITH HOOK;Ll;0;L;;;;;N;LATIN SMALL LETTER HENG HOOK;;;;
0268;LATIN SMALL LETTER I WITH STROKE;Ll;0;L;;;;;N;LATIN SMALL LETTER BARRED I;;0197;;0197
0269;LATIN SMALL LETTER IOTA;Ll;0;L;;;;;N;;;0196;;0196
026A;LATIN LETTER SMALL CAPITAL I;Ll;0;L;;;;;N;;;A7AE;;A7AE
026B;LATIN SMALL LETTER L WITH MIDDLE TILDE;Ll;0;L;;;;;N;;;2C62;;2C62
026C;LATIN SMALL LETTER L WITH BELT;Ll;0;L;;;;;N;LATIN SMALL LETTER L BELT;;A7AD;;A7AD
026D;LATIN SMALL LETTER L WITH RETROFLEX HOOK;Ll;0;L;;;;;N;LATIN SMALL LETTER L RETROFLEX HOOK;;;;
026E;LATIN SMALL LETTER LEZH;Ll;0;L;;;;;N;LATIN SMALL LETTER L YOGH;;;;
026F;LATIN SMALL LETTER TURNED M;Ll;0;L;;;;;N;;;019C;;019C
0270;LATIN SMALL LETTER TURNED M WITH LONG LEG;Ll;0;L;;;;;N;;;;;
0271;LATIN SMALL LETTER M WITH HOOK;Ll;0;L;;;;;N;LATIN SMALL LETTER M HOOK;;2C6E;;2C6E
0272;LATIN SMALL LETTER N WITH LEFT HOOK;Ll;0;L;;;;;N;LATIN SMALL LETTER N HOOK;;019D;;019D
0273;LATIN SMALL LETTER N WITH RETROFLEX HOOK;Ll;0;L;;;;;N;LATIN SMALL LETTER N RETROFLEX HOOK;;;;
0274;LATIN LETTER SMALL CAPITAL N;Ll;0;L;;;;;N;;;;;
0275;LATIN SMALL LETTER BARRED O;Ll;0;L;;;;;N;;;019F;;019F
0276;LATIN LETTER SMALL CAPITAL OE;Ll;0;L;;;;;N;LATIN LETTER SMALL CAPITAL O E;;;;
0277;LATIN SMALL LETTER CLOSED OMEGA;Ll;0;L;;;;;N;;;;;
0278;LATIN SMALL LETTER PHI;Ll;0;L;;;;;N;;;;;
0279;LATIN SMALL LETTER TURNED R;Ll;0;L;;;;;N;;;;;
027A;LATIN SMALL LETTER TURNED R WITH LONG LEG;Ll;0;L;;;;;N;;;;;
027B;LATIN SMALL LETTER TURNED R WITH HOOK;Ll;0;L;;;;;N;LATIN SMALL LETTER TURNED R HOOK;;;;
027C;LATIN SMALL LETTER R WITH LONG LEG;Ll;0;L;;;;;N;;;;;
027D;LATIN SMALL LETTER R WITH TAIL;Ll;0;L;;;;;N;LATIN SMALL LETTER R HOOK;;2C64;;2C64
027E;LATIN SMALL LETTER R WITH FISHHOOK;Ll;0;L;;;;;N;LATIN SMALL LETTER FISHHOOK R;;;;
027F;LATIN SMALL LETTER REVERSED R WITH FISHHOOK;Ll;0;L;;;;;N;LATIN SMALL LETTER REVERSED FISHHOOK R;;;;
0280;LATIN LETTER SMALL CAPITAL R;Ll;0;L;;;;;N;;;01A6;;01A6
0281;LATIN LETTER SMALL CAPITAL INVERTED R;Ll;0;L;;;;;N;;;;;
0282;LATIN SMALL LETTER S WITH HOOK;Ll;0;L;;;;;N;LATIN SMALL LETTER S HOOK;;A7C5;;A7C5
0283;LATIN SMALL LETTER ESH;Ll;0;L;;;;;N;;;01A9;;01A9
0284;LATIN SMALL LETTER DOTLESS J WITH STROKE AND HOOK;Ll;0;L;;;;;N;LATIN SMALL LETTER DOTLESS J BAR HOOK;;;;
0285;LATIN SMALL LETTER SQUAT REVERSED ESH;Ll;0;L;;;;;N;;;;;
0286;LATIN SMALL LETTER ESH WITH CURL;Ll;0;L;;;;;N;LATIN SMALL LETTER ESH CURL;;;;
0287;LATIN SMALL LETTER TURNED T;Ll;0;L;;;;;N;;;A7B1;;A7B1
0288;LATIN SMALL LETTER T WITH RETROFLEX HOOK;Ll;0;L;;;;;N;LATIN SMALL LETTER T RETROFLEX HOOK;;01AE;;01AE
0289;LATIN SMALL LETTER U BAR;Ll;0;L;;;;;N;;;0244;;0244
028A;LATIN SMALL LETTER UPSILON;Ll;0;L;;;;;N;;;01B1;;01B1
028B;LATIN SMALL LETTER V WITH HOOK;Ll;0;L;;;;;N;LATIN SMALL LETTER SCRIPT V;;01B2;;01B2
028C;LATIN SMALL LETTER TURNED V;Ll;0;L;;;;;N;;;0245;;0245
028D;LATIN SMALL LETTER TURNED W;Ll;0;L;;;;;N;;;;;
028E;LATIN SMALL LETTER TURNED Y;Ll;0;L;;;;;N;;;;;
028F;LATIN LETTER SMALL CAPITAL Y;Ll;0;L;;;;;N;;;;;
0290;LATIN SMALL LETTER Z WITH RETROFLEX HOOK;Ll;0;L;;;;;N;LATIN SMALL LETTER Z RETROFLEX HOOK;;;;
0291;LATIN SMALL LETTER Z WITH CURL;Ll;0;L;;;;;N;LATIN SMALL LETTER Z CURL;;;;
0292;LATIN SMALL LETTER EZH;Ll;0;L;;;;;N;LATIN SMALL LETTER YOGH;;01B7;;01B7
0293;LATIN SMALL LETTER EZH WITH CURL;Ll;0;L;;;;;N;LATIN SMALL LETTER YOGH CURL;;;;
0294;LATIN LETTER GLOTTAL STOP;Lo;0;L;;;;;N;;;;;
0295;LATIN LETTER PHARYNGEAL VOICED FRICATIVE;Ll;0;L;;;;;N;LATIN LETTER REVERSED GLOTTAL STOP;;;;
0296;LATIN LETTER INVERTED GLOTTAL STOP;Ll;0;L;;;;;N;;;;;
0297;LATIN LETTER STRETCHED C;Ll;0;L;;;;;N;;;;;
0298;LATIN LETTER BILABIAL CLICK;Ll;0;L;;;;;N;LATIN LETTER BULLSEYE;;;;
0299;LATIN LETTER SMALL CAPITAL B;Ll;0;L;;;;;N;;;;;
029A;LATIN SMALL LETTER CLOSED OPEN E;Ll;0;L;;;;;N;LATIN SMALL LETTER CLOSED EPSILON;;;;
029B;LATIN LETTER SMALL CAPITAL G WITH HOOK;Ll;0;L;;;;;N;LATIN LETTER SMALL CAPITAL G HOOK;;;;
029C;LATIN LETTER SMALL CAPITAL H;Ll;0;L;;;;;N;;;;;
029D;LATIN SMALL LETTER J WITH CROSSED-TAIL;Ll;0;L;;;;;N;LATIN SMALL LETTER CROSSED-TAIL J;;A7B2;;A7B2
029E;LATIN SMALL LETTER TURNED K;Ll;0;L;;;;;N;;;A7B0;;A7B0
029F;LATIN LETTER SMALL CAPITAL L;Ll;0;L;;;;;N;;;;;
02A0;LATIN SMALL LETTER Q WITH HOOK;Ll;0;L;;;;;N;LATIN SMALL LETTER Q HOOK;;;;
02A1;LATIN LETTER GLOTTAL STOP WITH STROKE;Ll;0;L;;;;;N;LATIN LETTER GLOTTAL STOP BAR;;;;
02A2;LATIN LETTER REVERSED GLOTTAL STOP WITH STROKE;Ll;0;L;;;;;N;LATIN LETTER REVERSED GLOTTAL STOP BAR;;;;
02A3;LATIN SMALL LETTER DZ DIGRAPH;Ll;0;L;;;;;N;LATIN SMALL LETTER D Z;;;;
02A4;LATIN SMALL LETTER DEZH DIGRAPH;Ll;0;L;;;;;N;LATIN SMALL LETTER D YOGH;;;;
02A5;LATIN SMALL LETTER DZ DIGRAPH WITH CURL;Ll;0;L;;;;;N;LATIN SMALL LETTER D Z CURL;;;;
02A6;LATIN SMALL LETTER TS DIGRAPH;Ll;0;L;;;;;N;LATIN SMALL LETTER T S;;;;
02A7;LATIN SMALL LETTER TESH DIGRAPH;Ll;0;L;;;;;N;LATIN SMALL LETTER T ESH;;;;
02A8;LATIN SMALL LETTER TC DIGRAPH WITH CURL;Ll;0;L;;;;;N;LATIN SMALL LETTER T C CURL;;;;
02A9;LATIN SMALL LETTER FENG DIGRAPH;Ll;0;L;;;;;N;;;;;
02AA;LATIN SMALL LETTER LS DIGRAPH;Ll;0;L;;;;;N;;;;;
02AB;LATIN SMALL LETTER LZ DIGRAPH;Ll;0;L;;;;;N;;;;;
02AC;LATIN LETTER BILABIAL PERCUSSIVE;Ll;0;L;;;;;N;;;;;
02AD;LATIN LETTER BIDENTAL PERCUSSIVE;Ll;0;L;;;;;N;;;;;
02AE;LATIN SMALL LETTER TURNED H WITH FISHHOOK;Ll;0;L;;;;;N;;;;;
02AF;LATIN SMALL LETTER TURNED H WITH FISHHOOK AND TAIL;Ll;0;L;;;;;N;;;;;
02B0;MODIFIER LETTER SMALL H;Lm;0;L;<super> 0068;;;;N;;;;;
02B1;MODIFIER LETTER SMALL H WITH HOOK;Lm;0;L;<super> 0266;;;;N;MODIFIER LETTER SMALL H HOOK;;;;
02B2;MODIFIER LETTER SMALL J;Lm;0;L;<super> 006A;;;;N;;;;;
02B3;MODIFIER LETTER SMALL R;Lm;0;L;<super> 0072;;;;N;;;;;
02B4;MODIFIER LETTER SMALL TURNED R;Lm;0;L;<super> 0279;;;;N;;;;;
02B5;MODIFIER LETTER SMALL TURNED R WITH HOOK;Lm;0;L;<super> 027B;;;;N;MODIFIER LETTER SMALL TURNED R HOOK;;;;
02B6;MODIFIER LETTER SMALL CAPITAL INVERTED R;Lm;0;L;<super> 0281;;;;N;;;;;
02B7;MODIFIER LETTER SMALL W;Lm;0;L;<super> 0077;;;;N;;;;;
02B8;MODIFIER LETTER SMALL Y;Lm;0;L;<super> 0079;;;;N;;;;;
02B9;MODIFIER LETTER PRIME;Lm;0;ON;;;;;N;;;;;
02BA;MODIFIER LETTER DOUBLE PRIME;Lm;0;ON;;;;;N;;;;;
02BB;MODIFIER LETTER TURNED COMMA;Lm;0;L;;;;;N;;;;;
02BC;MODIFIER LETTER APOSTROPHE;Lm;0;L;;;;;N;;;;;
02BD;MODIFIER LETTER REVERSED COMMA;Lm;0;L;;;;;N;;;;;
02BE;MODIFIER LETTER RIGHT HALF RING;Lm;0;L;;;;;N;;;;;
02BF;MODIFIER LETTER LEFT HALF RING;Lm;0;L;;;;;N;;;;;
02C0;MODIFIER LETTER GLOTTAL STOP;Lm;0;L;;;;;N;;;;;
02C1;MODIFIER LETTER REVERSED GLOTTAL STOP;Lm;0;L;;;;;N;;;;;
02C2;MODIFIER LETTER LEFT ARROWHEAD;Sk;0;ON;;;;;N;;;;;
02C3;MODIFIER LETTER RIGHT ARROWHEAD;Sk;0;ON;;;;;N;;;;;
02C4;MODIFIER LETTER UP ARROWHEAD;Sk;0;ON;;;;;N;;;;;
02C5;MODIFIER LETTER DOWN ARROWHEAD;Sk;0;ON;;;;;N;;;;;
02C6;MODIFIER LETTER CIRCUMFLEX ACCENT;Lm;0;ON;;;;;N;MODIFIER LETTER CIRCUMFLEX;;;;
02C7;CARON;Lm;0;ON;;;;;N;MODIFIER LETTER HACEK;;;;
02C8;MODIFIER LETTER VERTICAL LINE;Lm;0;ON;;;;;N;;;;;
02C9;MODIFIER LETTER MACRON;Lm;0;ON;;;;;N;;;;;
02CA;MODIFIER LETTER ACUTE ACCENT;Lm;0;ON;;;;;N;MODIFIER LETTER ACUTE;;;;
02CB;MODIFIER LETTER GRAVE ACCENT;Lm;0;ON;;;;;N;MODIFIER LETTER GRAVE;;;;
02CC;MODIFIER LETTER LOW VERTICAL LINE;Lm;0;ON;;;;;N;;;;;
02CD;MODIFIER LETTER LOW MACRON;Lm;0;ON;;;;;N;;;;;
02CE;MODIFIER LETTER LOW GRAVE ACCENT;Lm;0;ON;;;;;N;MODIFIER LETTER LOW GRAVE;;;;
02CF;MODIFIER LETTER LOW ACUTE ACCENT;Lm;0;ON;;;;;N;MODIFIER LETTER LOW ACUTE;;;;
02D0;MODIFIER LETTER TRIANGULAR COLON;Lm;0;L;;;;;N;;;;;
02D1;MODIFIER LETTER HALF TRIANGULAR COLON;Lm;0;L;;;;;N;;;;;
02D2;MODIFIER LETTER CENTRED RIGHT HALF RING;Sk;0;ON;;;;;N;MODIFIER LETTER CENTERED RIGHT HALF RING;;;;
02D3;MODIFIER LETTER CENTRED LEFT HALF RING;Sk;0;ON;;;;;N;MODIFIER LETTER CENTERED LEFT HALF RING;;;;
02D4;MODIFIER LETTER UP TACK;Sk;0;ON;;;;;N;;;;;
02D5;MODIFIER LETTER DOWN TACK;Sk;0;ON;;;;;N;;;;;
02D6;MODIFIER LETTER PLUS SIGN;Sk;0;ON;;;;;N;;;;;
02D7;MODIFIER LETTER MINUS SIGN;Sk;0;ON;;;;;N;;;;;
02D8;BREVE;Sk;0;ON;<compat> 0020 0306;;;;N;SPACING BREVE;;;;
02D9;DOT ABOVE;Sk;0;ON;<compat> 0020 0307;;;;N;SPACING DOT ABOVE;;;;
02DA;RING ABOVE;Sk;0;ON;<compat> 0020 030A;;;;N;SPACING RING ABOVE;;;;
02DB;OGONEK;Sk;0;ON;<compat> 0020 0328;;;;N;SPACING OGONEK;;;;
02DC;SMALL TILDE;Sk;0;ON;<compat> 0020 0303;;;;N;SPACING TILDE;;;;
02DD;DOUBLE ACUTE ACCENT;Sk;0;ON;<compat> 0020 030B;;;;N;SPACING DOUBLE ACUTE;;;;
02DE;MODIFIER LETTER RHOTIC HOOK;Sk;0;ON;;;;;N;;;;;
02DF;MODIFIER LETTER CROSS ACCENT;Sk;0;ON;;;;;N;;;;;
02E0;MODIFIER LETTER SMALL GAMMA;Lm;0;L;<super> 0263;;;;N;;;;;
02E1;MODIFIER LETTER SMALL L;Lm;0;L;<super> 006C;;;;N;;;;;
02E2;MODIFIER LETTER SMALL S;Lm;0;L;<super> 0073;;;;N;;;;;
02E3;MODIFIER LETTER SMALL X;Lm;0;L;<super> 0078;;;;N;;;;;
02E4;MODIFIER LETTER SMALL REVERSED GLOTTAL STOP;Lm;0;L;<super> 0295;;;;N;;;;;
02E5;MODIFIER LETTER EXTRA-HIGH TONE BAR;Sk;0;ON;;;;;N;;;;;
02E6;MODIFIER LETTER HIGH TONE BAR;Sk;0;ON;;;;;N;;;;;
02E7;MODIFIER LETTER MID TONE BAR;Sk;0;ON;;;;;N;;;;;
02E8;MODIFIER LETTER LOW TONE BAR;Sk;0;ON;;;;;N;;;;;
02E9;MODIFIER LETTER EXTRA-LOW TONE BAR;Sk;0;ON;;;;;N;;;;;
02EA;MODIFIER LETTER YIN DEPARTING TONE MARK;Sk;0;ON;;;;;N;;;;;
02EB;MODIFIER LETTER YANG DEPARTING TONE MARK;Sk;0;ON;;;;;N;;;;;
02EC;MODIFIER LETTER VOICING;Lm;0;ON;;;;;N;;;;;
02ED;MODIFIER LETTER UNASPIRATED;Sk;0;ON;;;;;N;;;;;
02EE;MODIFIER LETTER DOUBLE APOSTROPHE;Lm;0;L;;;;;N;;;;;
02EF;MODIFIER LETTER LOW DOWN ARROWHEAD;Sk;0;ON;;;;;N;;;;;
02F0;MODIFIER LETTER LOW UP ARROWHEAD;Sk;0;ON;;;;;N;;;;;
02F1;MODIFIER LETTER LOW LEFT ARROWHEAD;Sk;0;ON;;;;;N;;;;;
02F2;MODIFIER LETTER LOW RIGHT ARROWHEAD;Sk;0;ON;;;;;N;;;;;
02F3;MODIFIER LETTER LOW RING;Sk;0;ON;;;;;N;;;;;
02F4;MODIFIER LETTER MIDDLE GRAVE ACCENT;Sk;0;ON;;;;;N;;;;;
02F5;MODIFIER LETTER MIDDLE DOUBLE GRAVE ACCENT;Sk;0;ON;;;;;N;;;;;
02F6;MODIFIER LETTER MIDDLE DOUBLE ACUTE ACCENT;Sk;0;ON;;;;;N;;;;;
02F7;MODIFIER LETTER LOW TILDE;Sk;0;ON;;;;;N;;;;;
02F8;MODIFIER LETTER RAISED COLON;Sk;0;ON;;;;;N;;;;;
02F9;MODIFIER LETTER BEGIN HIGH TONE;Sk;0;ON;;;;;N;;;;;
02FA;MODIFIER LETTER END HIGH TONE;Sk;0;ON;;;;;N;;;;;
02FB;MODIFIER LETTER BEGIN LOW TONE;Sk;0;ON;;;;;N;;;;;
02FC;MODIFIER LETTER END LOW TONE;Sk;0;ON;;;;;N;;;;;
02FD;MODIFIER LETTER SHELF;Sk;0;ON;;;;;N;;;;;
02FE;MODIFIER LETTER OPEN SHELF;Sk;0;ON;;;;;N;;;;;
02FF;MODIFIER LETTER LOW LEFT ARROW;Sk;0;ON;;;;;N;;;;;
0300;COMBINING GRAVE ACCENT;Mn;230;NSM;;;;;N;NON-SPACING GRAVE;;;;
0301;COMBINING ACUTE ACCENT;Mn;230;NSM;;;;;N;NON-SPACING ACUTE;;;;
0302;COMBINING CIRCUMFLEX ACCENT;Mn;230;NSM;;;;;N;NON-SPACING CIRCUMFLEX;;;;
0303;COMBINING TILDE;Mn;230;NSM;;;;;N;NON-SPACING TILDE;;;;
0304;COMBINING MACRON;Mn;230;NSM;;;;;N;NON-SPACING MACRON;;;;
0305;COMBINING OVERLINE;Mn;230;NSM;;;;;N;NON-SPACING OVERSCORE;;;;
0306;COMBINING BREVE;Mn;230;NSM;;;;;N;NON-SPACING BREVE;;;;
0307;COMBINING DOT ABOVE;Mn;230;NSM;;;;;N;NON-SPACING DOT ABOVE;;;;
0308;COMBINING DIAERESIS;Mn;230;NSM;;;;;N;NON-SPACING DIAERESIS;;;;
0309;COMBINING HOOK ABOVE;Mn;230;NSM;;;;;N;NON-SPACING HOOK ABOVE;;;;
030A;COMBINING RING ABOVE;Mn;230;NSM;;;;;N;NON-SPACING RING ABOVE;;;;
030B;COMBINING DOUBLE ACUTE ACCENT;Mn;230;NSM;;;;;N;NON-SPACING DOUBLE ACUTE;;;;
030C;COMBINING CARON;Mn;230;NSM;;;;;N;NON-SPACING HACEK;;;;
030D;COMBINING VERTICAL LINE ABOVE;Mn;230;NSM;;;;;N;NON-SPACING VERTICAL LINE ABOVE;;;;
030E;COMBINING DOUBLE VERTICAL LINE ABOVE;Mn;230;NSM;;;;;N;NON-SPACING DOUBLE VERTICAL LINE ABOVE;;;;
030F;COMBINING DOUBLE GRAVE ACCENT;Mn;230;NSM;;;;;N;NON-SPACING DOUBLE GRAVE;;;;
0310;COMBINING CANDRABINDU;Mn;230;NSM;;;;;N;NON-SPACING CANDRABINDU;;;;
0311;COMBINING INVERTED BREVE;Mn;230;NSM;;;;;N;NON-SPACING INVERTED BREVE;;;;
0312;COMBINING TURNED COMMA ABOVE;Mn;230;NSM;;;;;N;NON-SPACING TURNED COMMA ABOVE;;;;
0313;COMBINING COMMA ABOVE;Mn;230;NSM;;;;;N;NON-SPACING COMMA ABOVE;;;;
0314;COMBINING REVERSED COMMA ABOVE;Mn;230;NSM;;;;;N;NON-SPACING REVERSED COMMA ABOVE;;;;
0315;COMBINING COMMA ABOVE RIGHT;Mn;232;NSM;;;;;N;NON-SPACING COMMA ABOVE RIGHT;;;;
0316;COMBINING GRAVE ACCENT BELOW;Mn;220;NSM;;;;;N;NON-SPACING GRAVE BELOW;;;;
0317;COMBINING ACUTE ACCENT BELOW;Mn;220;NSM;;;;;N;NON-SPACING ACUTE BELOW;;;;
0318;COMBINING LEFT TACK BELOW;Mn;220;NSM;;;;;N;NON-SPACING LEFT TACK BELOW;;;;
0319;COMBINING RIGHT TACK BELOW;Mn;220;NSM;;;;;N;NON-SPACING RIGHT TACK BELOW;;;;
031A;COMBINING LEFT ANGLE ABOVE;Mn;232;NSM;;;;;N;NON-SPACING LEFT ANGLE ABOVE;;;;
031B;COMBINING HORN;Mn;216;NSM;;;;;N;NON-SPACING HORN;;;;
031C;COMBINING LEFT HALF RING BELOW;Mn;220;NSM;;;;;N;NON-SPACING LEFT HALF RING BELOW;;;;
031D;COMBINING UP TACK BELOW;Mn;220;NSM;;;;;N;NON-SPACING UP TACK BELOW;;;;
031E;COMBINING DOWN TACK BELOW;Mn;220;NSM;;;;;N;NON-SPACING DOWN TACK BELOW;;;;
031F;COMBINING PLUS SIGN BELOW;Mn;220;NSM;;;;;N;NON-SPACING PLUS SIGN BELOW;;;;
0320;COMBINING MINUS SIGN BELOW;Mn;220;NSM;;;;;N;NON-SPACING MINUS SIGN BELOW;;;;
0321;COMBINING PALATALIZED HOOK BELOW;Mn;202;NSM;;;;;N;NON-SPACING PALATALIZED HOOK BELOW;;;;
0322;COMBINING RETROFLEX HOOK BELOW;Mn;202;NSM;;;;;N;NON-SPACING RETROFLEX HOOK BELOW;;;;
0323;COMBINING DOT BELOW;Mn;220;NSM;;;;;N;NON-SPACING DOT BELOW;;;;
0324;COMBINING DIAERESIS BELOW;Mn;220;NSM;;;;;N;NON-SPACING DOUBLE DOT BELOW;;;;
0325;COMBINING RING BELOW;Mn;220;NSM;;;;;N;NON-SPACING RING BELOW;;;;
0326;COMBINING COMMA BELOW;Mn;220;NSM;;;;;N;NON-SPACING COMMA BELOW;;;;
0327;COMBINING CEDILLA;Mn;202;NSM;;;;;N;NON-SPACING CEDILLA;;;;
0328;COMBINING OGONEK;Mn;202;NSM;;;;;N;NON-SPACING OGONEK;;;;
0329;COMBINING VERTICAL LINE BELOW;Mn;220;NSM;;;;;N;NON-SPACING VERTICAL LINE BELOW;;;;
032A;COMBINING BRIDGE BELOW;Mn;220;NSM;;;;;N;NON-SPACING BRIDGE BELOW;;;;
032B;COMBINING INVERTED DOUBLE ARCH BELOW;Mn;220;NSM;;;;;N;NON-SPACING INVERTED DOUBLE ARCH BELOW;;;;
032C;COMBINING CARON BELOW;Mn;220;NSM;;;;;N;NON-SPACING HACEK BELOW;;;;
032D;COMBINING CIRCUMFLEX ACCENT BELOW;Mn;220;NSM;;;;;N;NON-SPACING CIRCUMFLEX BELOW;;;;
032E;COMBINING BREVE BELOW;Mn;220;NSM;;;;;N;NON-SPACING BREVE BELOW;;;;
032F;COMBINING INVERTED BREVE BELOW;Mn;220;NSM;;;;;N;NON-SPACING INVERTED BREVE BELOW;;;;
0330;COMBINING TILDE BELOW;Mn;220;NSM;;;;;N;NON-SPACING TILDE BELOW;;;;
0331;COMBINING MACRON BELOW;Mn;220;NSM;;;;;N;NON-SPACING MACRON BELOW;;;;
0332;COMBINING LOW LINE;Mn;220;NSM;;;;;N;NON-SPACING UNDERSCORE;;;;
0333;COMBINING DOUBLE LOW LINE;Mn;220;NSM;;;;;N;NON-SPACING DOUBLE UNDERSCORE;;;;
0334;COMBINING TILDE OVERLAY;Mn;1;NSM;;;;;N;NON-SPACING TILDE OVERLAY;;;;
0335;COMBINING SHORT STROKE OVERLAY;Mn;1;NSM;;;;;N;NON-SPACING SHORT BAR OVERLAY;;;;
0336;COMBINING LONG STROKE OVERLAY;Mn;1;NSM;;;;;N;NON-SPACING LONG BAR OVERLAY;;;;
0337;COMBINING SHORT SOLIDUS OVERLAY;Mn;1;NSM;;;;;N;NON-SPACING SHORT SLASH OVERLAY;;;;
0338;COMBINING LONG SOLIDUS OVERLAY;Mn;1;NSM;;;;;N;NON-SPACING LONG SLASH OVERLAY;;;;
0339;COMBINING RIGHT HALF RING BELOW;Mn;220;NSM;;;;;N;NON-SPACING RIGHT HALF RING BELOW;;;;
033A;COMBINING INVERTED BRIDGE BELOW;Mn;220;NSM;;;;;N;NON-SPACING INVERTED BRIDGE BELOW;;;;
033B;COMBINING SQUARE BELOW;Mn;220;NSM;;;;;N;NON-SPACING SQUARE BELOW;;;;
033C;COMBINING SEAGULL BELOW;Mn;220;NSM;;;;;N;NON-SPACING SEAGULL BELOW;;;;
033D;COMBINING X ABOVE;Mn;230;NSM;;;;;N;NON-SPACING X ABOVE;;;;
033E;COMBINING VERTICAL TILDE;Mn;230;NSM;;;;;N;NON-SPACING VERTICAL TILDE;;;;
033F;COMBINING DOUBLE OVERLINE;Mn;230;NSM;;;;;N;NON-SPACING DOUBLE OVERSCORE;;;;
0340;COMBINING GRAVE TONE MARK;Mn;230;NSM;0300;;;;N;NON-SPACING GRAVE TONE MARK;;;;
0341;COMBINING ACUTE TONE MARK;Mn;230;NSM;0301;;;;N;NON-SPACING ACUTE TONE MARK;;;;
0342;COMBINING GREEK PERISPOMENI;Mn;230;NSM;;;;;N;;;;;
0343;COMBINING GREEK KORONIS;Mn;230;NSM;0313;;;;N;;;;;
0344;COMBINING GREEK DIALYTIKA TONOS;Mn;230;NSM;0308 0301;;;;N;GREEK NON-SPACING DIAERESIS TONOS;;;;
0345;COMBINING GREEK YPOGEGRAMMENI;Mn;240;NSM;;;;;N;GREEK NON-SPACING IOTA BELOW;;0399;;0399
0346;COMBINING BRIDGE ABOVE;Mn;230;NSM;;;;;N;;;;;
0347;COMBINING EQUALS SIGN BELOW;Mn;220;NSM;;;;;N;;;;;
0348;COMBINING DOUBLE VERTICAL LINE BELOW;Mn;220;NSM;;;;;N;;;;;
0349;COMBINING LEFT ANGLE BELOW;Mn;220;NSM;;;;;N;;;;;
034A;COMBINING NOT TILDE ABOVE;Mn;230;NSM;;;;;N;;;;;
034B;COMBINING HOMOTHETIC ABOVE;Mn;230;NSM;;;;;N;;;;;
034C;COMBINING ALMOST EQUAL TO ABOVE;Mn;230;NSM;;;;;N;;;;;
034D;COMBINING LEFT RIGHT ARROW BELOW;Mn;220;NSM;;;;;N;;;;;
034E;COMBINING UPWARDS ARROW BELOW;Mn;220;NSM;;;;;N;;;;;
034F;COMBINING GRAPHEME JOINER;Mn;0;NSM;;;;;N;;;;;
0350;COMBINING RIGHT ARROWHEAD ABOVE;Mn;230;NSM;;;;;N;;;;;
0351;COMBINING LEFT HALF RING ABOVE;Mn;230;NSM;;;;;N;;;;;
0352;COMBINING FERMATA;Mn;230;NSM;;;;;N;;;;;
0353;COMBINING X BELOW;Mn;220;NSM;;;;;N;;;;;
0354;COMBINING LEFT ARROWHEAD BELOW;Mn;220;NSM;;;;;N;;;;;
0355;COMBINING RIGHT ARROWHEAD BELOW;Mn;220;NSM;;;;;N;;;;;
0356;COMBINING RIGHT ARROWHEAD AND UP ARROWHEAD BELOW;Mn;220;NSM;;;;;N;;;;;
0357;COMBINING RIGHT HALF RING ABOVE;Mn;230;NSM;;;;;N;;;;;
0358;COMBINING DOT ABOVE RIGHT;Mn;232;NSM;;;;;N;;;;;
0359;COMBINING ASTERISK BELOW;Mn;220;NSM;;;;;N;;;;;
035A;COMBINING DOUBLE RING BELOW;Mn;220;NSM;;;;;N;;;;;
035B;COMBINING ZIGZAG ABOVE;Mn;230;NSM;;;;;N;;;;;
035C;COMBINING DOUBLE BREVE BELOW;Mn;233;NSM;;;;;N;;;;;
035D;COMBINING DOUBLE BREVE;Mn;234;NSM;;;;;N;;;;;
035E;COMBINING DOUBLE MACRON;Mn;234;NSM;;;;;N;;;;;
035F;COMBINING DOUBLE MACRON BELOW;Mn;233;NSM;;;;;N;;;;;
0360;COMBINING DOUBLE TILDE;Mn;234;NSM;;;;;N;;;;;
0361;COMBINING DOUBLE INVERTED BREVE;Mn;234;NSM;;;;;N;;;;;
0362;COMBINING DOUBLE RIGHTWARDS ARROW BELOW;Mn;233;NSM;;;;;N;;;;;
0363;COMBINING LATIN SMALL LETTER A;Mn;230;NSM;;;;;N;;;;;
0364;COMBINING LATIN SMALL LETTER E;Mn;230;NSM;;;;;N;;;;;
0365;COMBINING LATIN SMALL LETTER I;Mn;230;NSM;;;;;N;;;;;
0366;COMBINING LATIN SMALL LETTER O;Mn;230;NSM;;;;;N;;;;;
0367;COMBINING LATIN SMALL LETTER U;Mn;230;NSM;;;;;N;;;;;
0368;COMBINING LATIN SMALL LETTER C;Mn;230;NSM;;;;;N;;;;;
0369;COMBINING LATIN SMALL LETTER D;Mn;230;NSM;;;;;N;;;;;
036A;COMBINING LATIN SMALL LETTER H;Mn;230;NSM;;;;;N;;;;;
036B;COMBINING LATIN SMALL LETTER M;Mn;230;NSM;;;;;N;;;;;
036C;COMBINING LATIN SMALL LETTER R;Mn;230;NSM;;;;;N;;;;;
036D;COMBINING LATIN SMALL LETTER T;Mn;230;NSM;;;;;N;;;;;
036E;COMBINING LATIN SMALL LETTER V;Mn;230;NSM;;;;;N;;;;;
036F;COMBINING LATIN SMALL LETTER X;Mn;230;NSM;;;;;N;;;;;
0370;GREEK CAPITAL LETTER HETA;Lu;0;L;;;;;N;;;;0371;
0371;GREEK SMALL LETTER HETA;Ll;0;L;;;;;N;;;0370;;0370
0372;GREEK CAPITAL LETTER ARCHAIC SAMPI;Lu;0;L;;;;;N;;;;0373;
0373;GREEK SMALL LETTER ARCHAIC SAMPI;Ll;0;L;;;;;N;;;0372;;0372
0374;GREEK NUMERAL SIGN;Lm;0;ON;02B9;;;;N;GREEK UPPER NUMERAL SIGN;;;;
0375;GREEK LOWER NUMERAL SIGN;Sk;0;ON;;;;;N;;;;;
0376;GREEK CAPITAL LETTER PAMPHYLIAN DIGAMMA;Lu;0;L;;;;;N;;;;0377;
0377;GREEK SMALL LETTER PAMPHYLIAN DIGAMMA;Ll;0;L;;;;;N;;;0376;;0376
037A;GREEK YPOGEGRAMMENI;Lm;0;L;<compat> 0020 0345;;;;N;GREEK SPACING IOTA BELOW;;;;
037B;GREEK SMALL REVERSED LUNATE SIGMA SYMBOL;Ll;0;L;;;;;N;;;03FD;;03FD
037C;GREEK SMALL DOTTED LUNATE SIGMA SYMBOL;Ll;0;L;;;;;N;;;03FE;;03FE
037D;GREEK SMALL REVERSED DOTTED LUNATE SIGMA SYMBOL;Ll;0;L;;;;;N;;;03FF;;03FF
037E;GREEK QUESTION MARK;Po;0;ON;003B;;;;N;;;;;
037F;GREEK CAPITAL LETTER YOT;Lu;0;L;;;;;N;;;;03F3;
0384;GREEK TONOS;Sk;0;ON;<compat> 0020 0301;;;;N;GREEK SPACING TONOS;;;;
0385;GREEK DIALYTIKA TONOS;Sk;0;ON;00A8 0301;;;;N;GREEK SPACING DIAERESIS TONOS;;;;
0386;GREEK CAPITAL LETTER ALPHA WITH TONOS;Lu;0;L;0391 0301;;;;N;GREEK CAPITAL LETTER ALPHA TONOS;;;03AC;
0387;GREEK ANO TELEIA;Po;0;ON;00B7;;;;N;;;;;
0388;GREEK CAPITAL LETTER EPSILON WITH TONOS;Lu;0;L;0395 0301;;;;N;GREEK CAPITAL LETTER EPSILON TONOS;;;03AD;
0389;GREEK CAPITAL LETTER ETA WITH TONOS;Lu;0;L;0397 0301;;;;N;GREEK CAPITAL LETTER ETA TONOS;;;03AE;
038A;GREEK CAPITAL LETTER IOTA WITH TONOS;Lu;0;L;0399 0301;;;;N;GREEK CAPITAL LETTER IOTA TONOS;;;03AF;
038C;GREEK CAPITAL LETTER OMICRON WITH TONOS;Lu;0;L;039F 0301;;;;N;GREEK CAPITAL LETTER OMICRON TONOS;;;03CC;
038E;GREEK CAPITAL LETTER UPSILON WITH TONOS;Lu;0;L;03A5 0301;;;;N;GREEK CAPITAL LETTER UPSILON TONOS;;;03CD;
038F;GREEK CAPITAL LETTER OMEGA WITH TONOS;Lu;0;L;03A9 0301;;;;N;GREEK CAPITAL LETTER OMEGA TONOS;;;03CE;
0390;GREEK SMALL LETTER IOTA WITH DIALYTIKA AND TONOS;Ll;0;L;03CA 0301;;;;N;GREEK SMALL LETTER IOTA DIAERESIS TONOS;;;;
0391;GREEK CAPITAL LETTER ALPHA;Lu;0;L;;;;;N;;;;03B1;
0392;GREEK CAPITAL LETTER BETA;Lu;0;L;;;;;N;;;;03B2;
0393;GREEK CAPITAL LETTER GAMMA;Lu;0;L;;;;;N;;;;03B3;
0394;GREEK CAPITAL LETTER DELTA;Lu;0;L;;;;;N;;;;03B4;
0395;GREEK CAPITAL LETTER EPSILON;Lu;0;L;;;;;N;;;;03B5;
0396;GREEK CAPITAL LETTER ZETA;Lu;0;L;;;;;N;;;;03B6;
0397;GREEK CAPITAL LETTER ETA;Lu;0;L;;;;;N;;;;03B7;
0398;GREEK CAPITAL LETTER THETA;Lu;0;L;;;;;N;;;;03B8;
0399;GREEK CAPITAL LETTER IOTA;Lu;0;L;;;;;N;;;;03B9;
039A;GREEK CAPITAL LETTER KAPPA;Lu;0;L;;;;;N;;;;03BA;
039B;GREEK CAPITAL LETTER LAMDA;Lu;0;L;;;;;N;GREEK CAPITAL LETTER LAMBDA;;;03BB;
039C;GREEK CAPITAL LETTER MU;Lu;0;L;;;;;N;;;;03BC;
039D;GREEK CAPITAL LETTER NU;Lu;0;L;;;;;N;;;;03BD;
039E;GREEK CAPITAL LETTER XI;Lu;0;L;;;;;N;;;;03BE;
039F;GREEK CAPITAL LETTER OMICRON;Lu;0;L;;;;;N;;;;03BF;
03A0;GREEK CAPITAL LETTER PI;Lu;0;L;;;;;N;;;;03C0;
03A1;GREEK CAPITAL LETTER RHO;Lu;0;L;;;;;N;;;;03C1;
03A3;GREEK CAPITAL LETTER SIGMA;Lu;0;L;;;;;N;;;;03C3;
03A4;GREEK CAPITAL LETTER TAU;Lu;0;L;;;;;N;;;;03C4;
03A5;GREEK CAPITAL LETTER UPSILON;Lu;0;L;;;;;N;;;;03C5;
03A6;GREEK CAPITAL LETTER PHI;Lu;0;L;;;;;N;;;;03C6;
03A7;GREEK CAPITAL LETTER CHI;Lu;0;L;;;;;N;;;;03C7;
03A8;GREEK CAPITAL LETTER PSI;Lu;0;L;;;;;N;;;;03C8;
03A9;GREEK CAPITAL LETTER OMEGA;Lu;0;L;;;;;N;;;;03C9;
03AA;GREEK CAPITAL LETTER IOTA WITH DIALYTIKA;Lu;0;L;0399 0308;;;;N;GREEK CAPITAL LETTER IOTA DIAERESIS;;;03CA;
03AB;GREEK CAPITAL LETTER UPSILON WITH DIALYTIKA;Lu;0;L;03A5 0308;;;;N;GREEK CAPITAL LETTER UPSILON DIAERESIS;;;03CB;
03AC;GREEK SMALL LETTER ALPHA WITH TONOS;Ll;0;L;03B1 0301;;;;N;GREEK SMALL LETTER ALPHA TONOS;;0386;;0386
03AD;GREEK SMALL LETTER EPSILON WITH TONOS;Ll;0;L;03B5 0301;;;;N;GREEK SMALL LETTER EPSILON TONOS;;0388;;0388
03AE;GREEK SMALL LETTER ETA WITH TONOS;Ll;0;L;03B7 0301;;;;N;GREEK SMALL LETTER ETA TONOS;;0389;;0389
03AF;GREEK SMALL LETTER IOTA WITH TONOS;Ll;0;L;03B9 0301;;;;N;GREEK SMALL LETTER IOTA TONOS;;038A;;038A
03B0;GREEK SMALL LETTER UPSILON WITH DIALYTIKA AND TONOS;Ll;0;L;03CB 0301;;;;N;GREEK SMALL LETTER UPSILON DIAERESIS TONOS;;;;
03B1;GREEK SMALL LETTER ALPHA;Ll;0;L;;;;;N;;;0391;;0391
03B2;GREEK SMALL LETTER BETA;Ll;0;L;;;;;N;;;0392;;0392
03B3;GREEK SMALL LETTER GAMMA;Ll;0;L;;;;;N;;;0393;;0393
03B4;GREEK SMALL LETTER DELTA;Ll;0;L;;;;;N;;;0394;;0394
03B5;GREEK SMALL LETTER EPSILON;Ll;0;L;;;;;N;;;0395;;0395
03B6;GREEK SMALL LETTER ZETA;Ll;0;L;;;;;N;;;0396;;0396
03B7;GREEK SMALL LETTER ETA;Ll;0;L;;;;;N;;;0397;;0397
03B8;GREEK SMALL LETTER THETA;Ll;0;L;;;;;N;;;0398;;0398
03B9;GREEK SMALL LETTER IOTA;Ll;0;L;;;;;N;;;0399;;0399
03BA;GREEK SMALL LETTER KAPPA;Ll;0;L;;;;;N;;;039A;;039A
03BB;GREEK SMALL LETTER LAMDA;Ll;0;L;;;;;N;GREEK SMALL LETTER LAMBDA;;039B;;039B
03BC;GREEK SMALL LETTER MU;Ll;0;L;;;;;N;;;039C;;039C
03BD;GREEK SMALL LETTER NU;Ll;0;L;;;;;N;;;039D;;039D
03BE;GREEK SMALL LETTER XI;Ll;0;L;;;;;N;;;039E;;039E
03BF;GREEK SMALL LETTER OMICRON;Ll;0;L;;;;;N;;;039F;;039F
03C0;GREEK SMALL LETTER PI;Ll;0;L;;;;;N;;;03A0;;03A0
03C1;GREEK SMALL LETTER RHO;Ll;0;L;;;;;N;;;03A1;;03A1
03C2;GREEK SMALL LETTER FINAL SIGMA;Ll;0;L;;;;;N;;;03A3;;03A3
03C3;GREEK SMALL LETTER SIGMA;Ll;0;L;;;;;N;;;03A3;;03A3
03C4;GREEK SMALL LETTER TAU;Ll;0;L;;;;;N;;;03A4;;03A4
03C5;GREEK SMALL LETTER UPSILON;Ll;0;L;;;;;N;;;03A5;;03A5
03C6;GREEK SMALL LETTER PHI;Ll;0;L;;;;;N;;;03A6;;03A6
03C7;GREEK SMALL LETTER CHI;Ll;0;L;;;;;N;;;03A7;;03A7
03C8;GREEK SMALL LETTER PSI;Ll;0;L;;;;;N;;;03A8;;03A8
03C9;GREEK SMALL LETTER OMEGA;Ll;0;L;;;;;N;;;03A9;;03A9
03CA;GREEK SMALL LETTER IOTA WITH DIALYTIKA;Ll;0;L;03B9 0308;;;;N;GREEK SMALL LETTER IOTA DIAERESIS;;03AA;;03AA
03CB;GREEK SMALL LETTER UPSILON WITH DIALYTIKA;Ll;0;L;03C5 0308;;;;N;GREEK SMALL LETTER UPSILON DIAERESIS;;03AB;;03AB
03CC;GREEK SMALL LETTER OMICRON WITH TONOS;Ll;0;L;03BF 0301;;;;N;GREEK SMALL LETTER OMICRON TONOS;;038C;;038C
03CD;GREEK SMALL LETTER UPSILON WITH TONOS;Ll;0;L;03C5 0301;;;;N;GREEK SMALL LETTER UPSILON TONOS;;038E;;038E
03CE;GREEK SMALL LETTER OMEGA WITH TONOS;Ll;0;L;03C9 0301;;;;N;GREEK SMALL LETTER OMEGA TONOS;;038F;;038F
03CF;GREEK CAPITAL KAI SYMBOL;Lu;0;L;;;;;N;;;;03D7;
03D0;GREEK BETA SYMBOL;Ll;0;L;<compat> 03B2;;;;N;GREEK SMALL LETTER CURLED BETA;;0392;;0392
03D1;GREEK THETA SYMBOL;Ll;0;L;<compat> 03B8;;;;N;GREEK SMALL LETTER SCRIPT THETA;;0398;;0398
03D2;GREEK UPSILON WITH HOOK SYMBOL;Lu;0;L;<compat> 03A5;;;;N;GREEK CAPITAL LETTER UPSILON HOOK;;;;
03D3;GREEK UPSILON WITH ACUTE AND HOOK SYMBOL;Lu;0;L;03D2 0301;;;;N;GREEK CAPITAL LETTER UPSILON HOOK TONOS;;;;
03D4;GREEK UPSILON WITH DIAERESIS AND HOOK SYMBOL;Lu;0;L;03D2 0308;;;;N;GREEK CAPITAL LETTER UPSILON HOOK DIAERESIS;;;;
03D5;GREEK PHI SYMBOL;Ll;0;L;<compat> 03C6;;;;N;GREEK SMALL LETTER SCRIPT PHI;;03A6;;03A6
03D6;GREEK PI SYMBOL;Ll;0;L;<compat> 03C0;;;;N;GREEK SMALL LETTER OMEGA PI;;03A0;;03A0
03D7;GREEK KAI SYMBOL;Ll;0;L;;;;;N;;;03CF;;03CF
03D8;GREEK LETTER ARCHAIC KOPPA;Lu;0;L;;;;;N;;;;03D9;
03D9;GREEK SMALL LETTER ARCHAIC KOPPA;Ll;0;L;;;;;N;;;03D8;;03D8
03DA;GREEK LETTER STIGMA;Lu;0;L;;;;;N;GREEK CAPITAL LETTER STIGMA;;;03DB;
03DB;GREEK SMALL LETTER STIGMA;Ll;0;L;;;;;N;;;03DA;;03DA
03DC;GREEK LETTER DIGAMMA;Lu;0;L;;;;;N;GREEK CAPITAL LETTER DIGAMMA;;;03DD;
03DD;GREEK SMALL LETTER DIGAMMA;Ll;0;L;;;;;N;;;03DC;;03DC
03DE;GREEK LETTER KOPPA;Lu;0;L;;;;;N;GREEK CAPITAL LETTER KOPPA;;;03DF;
03DF;GREEK SMALL LETTER KOPPA;Ll;0;L;;;;;N;;;03DE;;03DE
03E0;GREEK LETTER SAMPI;Lu;0;L;;;;;N;GREEK CAPITAL LETTER SAMPI;;;03E1;
03E1;GREEK SMALL LETTER SAMPI;Ll;0;L;;;;;N;;;03E0;;03E0
03E2;COPTIC CAPITAL LETTER SHEI;Lu;0;L;;;;;N;GREEK CAPITAL LETTER SHEI;;;03E3;
03E3;COPTIC SMALL LETTER SHEI;Ll;0;L;;;;;N;GREEK SMALL LETTER SHEI;;03E2;;03E2
03E4;COPTIC CAPITAL LETTER FEI;Lu;0;L;;;;;N;GREEK CAPITAL LETTER FEI;;;03E5;
03E5;COPTIC SMALL LETTER FEI;Ll;0;L;;;;;N;GREEK SMALL LETTER FEI;;03E4;;03E4
03E6;COPTIC CAPITAL LETTER KHEI;Lu;0;L;;;;;N;GREEK CAPITAL LETTER KHEI;;;03E7;
03E7;COPTIC SMALL LETTER KHEI;Ll;0;L;;;;;N;GREEK SMALL LETTER KHEI;;03E6;;03E6
03E8;COPTIC CAPITAL LETTER HORI;Lu;0;L;;;;;N;GREEK CAPITAL LETTER HORI;;;03E9;
03E9;COPTIC SMALL LETTER HORI;Ll;0;L;;;;;N;GREEK SMALL LETTER HORI;;03E8;;03E8
03EA;COPTIC CAPITAL LETTER GANGIA;Lu;0;L;;;;;N;GREEK CAPITAL LETTER GANGIA;;;03EB;
03EB;COPTIC SMALL LETTER GANGIA;Ll;0;L;;;;;N;GREEK SMALL LETTER GANGIA;;03EA;;03EA
03EC;COPTIC CAPITAL LETTER SHIMA;Lu;0;L;;;;;N;GREEK CAPITAL LETTER SHIMA;;;03ED;
03ED;COPTIC SMALL LETTER SHIMA;Ll;0;L;;;;;N;GREEK SMALL LETTER SHIMA;;03EC;;03EC
03EE;COPTIC CAPITAL LETTER DEI;Lu;0;L;;;;;N;GREEK CAPITAL LETTER DEI;;;03EF;
03EF;COPTIC SMALL LETTER DEI;Ll;0;L;;;;;N;GREEK SMALL LETTER DEI;;03EE;;03EE
03F0;GREEK KAPPA SYMBOL;Ll;0;L;<compat> 03BA;;;;N;GREEK SMALL LETTER SCRIPT KAPPA;;039A;;039A
03F1;GREEK RHO SYMBOL;Ll;0;L;<compat> 03C1;;;;N;GREEK SMALL LETTER TAILED RHO;;03A1;;03A1
03F2;GREEK LUNATE SIGMA SYMBOL;Ll;0;L;<compat> 03C2;;;;N;GREEK SMALL LETTER LUNATE SIGMA;;03F9;;03F9
03F3;GREEK LETTER YOT;Ll;0;L;;;;;N;;;037F;;037F
03F4;GREEK CAPITAL THETA SYMBOL;Lu;0;L;<compat> 0398;;;;N;;;;03B8;
03F5;GREEK LUNATE EPSILON SYMBOL;Ll;0;L;<compat> 03B5;;;;N;;;0395;;0395
03F6;GREEK REVERSED LUNATE EPSILON SYMBOL;Sm;0;ON;;;;;N;;;;;
03F7;GREEK CAPITAL LETTER SHO;Lu;0;L;;;;;N;;;;03F8;
03F8;GREEK SMALL LETTER SHO;Ll;0;L;;;;;N;;;03F7;;03F7
03F9;GREEK CAPITAL LUNATE SIGMA SYMBOL;Lu;0;L;<compat> 03A3;;;;N;;;;03F2;
03FA;GREEK CAPITAL LETTER SAN;Lu;0;L;;;;;N;;;;03FB;
03FB;GREEK SMALL LETTER SAN;Ll;0;L;;;;;N;;;03FA;;03FA
03FC;GREEK RHO WITH STROKE SYMBOL;Ll;0;L;;;;;N;;;;;
03FD;GREEK CAPITAL REVERSED LUNATE SIGMA SYMBOL;Lu;0;L;;;;;N;;;;037B;
03FE;GREEK CAPITAL DOTTED LUNATE SIGMA SYMBOL;Lu;0;L;;;;;N;;;;037C;
03FF;GREEK CAPITAL REVERSED DOTTED LUNATE SIGMA SYMBOL;Lu;0;L;;;;;N;;;;037D;
0400;CYRILLIC CAPITAL LETTER IE WITH GRAVE;Lu;0;L;0415 0300;;;;N;;;;0450;
0401;CYRILLIC CAPITAL LETTER IO;Lu;0;L;0415 0308;;;;N;;;;0451;
0402;CYRILLIC CAPITAL LETTER DJE;Lu;0;L;;;;;N;;;;0452;
0403;CYRILLIC CAPITAL LETTER GJE;Lu;0;L;0413 0301;;;;N;;;;0453;
0404;CYRILLIC CAPITAL LETTER UKRAINIAN IE;Lu;0;L;;;;;N;CYRILLIC CAPITAL LETTER E;;;0454;
0405;CYRILLIC CAPITAL LETTER DZE;Lu;0;L;;;;;N;;;;0455;
0406;CYRILLIC CAPITAL LETTER BYELORUSSIAN-UKRAINIAN I;Lu;0;L;;;;;N;CYRILLIC CAPITAL LETTER I;;;0456;
0407;CYRILLIC CAPITAL LETTER YI;Lu;0;L;0406 0308;;;;N;;;;0457;
0408;CYRILLIC CAPITAL LETTER JE;Lu;0;L;;;;;N;;;;0458;
0409;CYRILLIC CAPITAL LETTER LJE;Lu;0;L;;;;;N;;;;0459;
040A;CYRILLIC CAPITAL LETTER NJE;Lu;0;L;;;;;N;;;;045A;
040B;CYRILLIC CAPITAL LETTER TSHE;Lu;0;L;;;;;N;;;;045B;
040C;CYRILLIC CAPITAL LETTER KJE;Lu;0;L;041A 0301;;;;N;;;;045C;
040D;CYRILLIC CAPITAL LETTER I WITH GRAVE;Lu;0;L;0418 0300;;;;N;;;;045D;
040E;CYRILLIC CAPITAL LETTER SHORT U;Lu;0;L;0423 0306;;;;N;;;;045E;
040F;CYRILLIC CAPITAL LETTER DZHE;Lu;0;L;;;;;N;;;;045F;
0410;CYRILLIC CAPITAL LETTER A;Lu;0;L;;;;;N;;;;0430;
0411;CYRILLIC CAPITAL LETTER BE;Lu;0;L;;;;;N;;;;0431;
0412;CYRILLIC CAPITAL LETTER VE;Lu;0;L;;;;;N;;;;0432;
0413;CYRILLIC CAPITAL LETTER GHE;Lu;0;L;;;;;N;CYRILLIC CAPITAL LETTER GE;;;0433;
0414;CYRILLIC CAPITAL LETTER DE;Lu;0;L;;;;;N;;;;0434;
0415;CYRILLIC CAPITAL LETTER IE;Lu;0;L;;;;;N;;;;0435;
0416;CYRILLIC CAPITAL LETTER ZHE;Lu;0;L;;;;;N;;;;0436;
0417;CYRILLIC CAPITAL LETTER ZE;Lu;0;L;;;;;N;;;;0437;
0418;CYRILLIC CAPITAL LETTER I;Lu;0;L;;;;;N;CYRILLIC CAPITAL LETTER II;;;0438;
0419;CYRILLIC CAPITAL LETTER SHORT I;Lu;0;L;0418 0306;;;;N;CYRILLIC CAPITAL LETTER SHORT II;;;0439;
041A;CYRILLIC CAPITAL LETTER KA;Lu;0;L;;;;;N;;;;043A;
041B;CYRILLIC CAPITAL LETTER EL;Lu;0;L;;;;;N;;;;043B;
041C;CYRILLIC CAPITAL LETTER EM;Lu;0;L;;;;;N;;;;043C;
041D;CYRILLIC CAPITAL LETTER EN;Lu;0;L;;;;;N;;;;043D;
041E;CYRILLIC CAPITAL LETTER O;Lu;0;L;;;;;N;;;;043E;
041F;CYRILLIC CAPITAL LETTER PE;Lu;0;L;;;;;N;;;;043F;
0420;CYRILLIC CAPITAL LETTER ER;Lu;0;L;;;;;N;;;;0440;
0421;CYRILLIC CAPITAL LETTER ES;Lu;0;L;;;;;N;;;;0441;
0422;CYRILLIC CAPITAL LETTER TE;Lu;0;L;;;;;N;;;;0442;
0423;CYRILLIC CAPITAL LETTER U;Lu;0;L;;;;;N;;;;0443;
0424;CYRILLIC CAPITAL LETTER EF;Lu;0;L;;;;;N;;;;0444;
0425;CYRILLIC CAPITAL LETTER HA;Lu;0;L;;;;;N;CYRILLIC CAPITAL LETTER KHA;;;0445;
0426;CYRILLIC CAPITAL LETTER TSE;Lu;0;L;;;;;N;;;;0446;
0427;CYRILLIC CAPITAL LETTER CHE;Lu;0;L;;;;;N;;;;0447;
0428;CYRILLIC CAPITAL LETTER SHA;Lu;0;L;;;;;N;;;;0448;
0429;CYRILLIC CAPITAL LETTER SHCHA;Lu;0;L;;;;;N;;;;0449;
042A;CYRILLIC CAPITAL LETTER HARD SIGN;Lu;0;L;;;;;N;;;;044A;
042B;CYRILLIC CAPITAL LETTER YERU;Lu;0;L;;;;;N;CYRILLIC CAPITAL LETTER YERI;;;044B;
042C;CYRILLIC CAPITAL LETTER SOFT SIGN;Lu;0;L;;;;;N;;;;044C;
042D;CYRILLIC CAPITAL LETTER E;Lu;0;L;;;;;N;CYRILLIC CAPITAL LETTER REVERSED E;;;044D;
042E;CYRILLIC CAPITAL LETTER YU;Lu;0;L;;;;;N;CYRILLIC CAPITAL LETTER IU;;;044E;
042F;CYRILLIC CAPITAL LETTER YA;Lu;0;L;;;;;N;CYRILLIC CAPITAL LETTER IA;;;044F;
0430;CYRILLIC SMALL LETTER A;Ll;0;L;;;;;N;;;0410;;0410
0431;CYRILLIC SMALL LETTER BE;Ll;0;L;;;;;N;;;0411;;0411
0432;CYRILLIC SMALL LETTER VE;Ll;0;L;;;;;N;;;0412;;0412
0433;CYRILLIC SMALL LETTER GHE;Ll;0;L;;;;;N;CYRILLIC SMALL LETTER GE;;0413;;0413
0434;CYRILLIC SMALL LETTER DE;Ll;0;L;;;;;N;;;0414;;0414
0435;CYRILLIC SMALL LETTER IE;Ll;0;L;;;;;N;;;0415;;0415
0436;CYRILLIC SMALL LETTER ZHE;Ll;0;L;;;;;N;;;0416;;0416
0437;CYRILLIC SMALL LETTER ZE;Ll;0;L;;;;;N;;;0417;;0417
0438;CYRILLIC SMALL LETTER I;Ll;0;L;;;;;N;CYRILLIC SMALL LETTER II;;0418;;0418
0439;CYRILLIC SMALL LETTER SHORT I;Ll;0;L;0438 0306;;;;N;CYRILLIC SMALL LETTER SHORT II;;0419;;0419
043A;CYRILLIC SMALL LETTER KA;Ll;0;L;;;;;N;;;041A;;041A
043B;CYRILLIC SMALL LETTER EL;Ll;0;L;;;;;N;;;041B;;041B
043C;CYRILLIC SMALL LETTER EM;Ll;0;L;;;;;N;;;041C;;041C
043D;CYRILLIC SMALL LETTER EN;Ll;0;L;;;;;N;;;041D;;041D
043E;CYRILLIC SMALL LETTER O;Ll;0;L;;;;;N;;;041E;;041E
043F;CYRILLIC SMALL LETTER PE;Ll;0;L;;;;;N;;;041F;;041F
0440;CYRILLIC SMALL LETTER ER;Ll;0;L;;;;;N;;;0420;;0420
0441;CYRILLIC SMALL LETTER ES;Ll;0;L;;;;;N;;;0421;;0421
0442;CYRILLIC SMALL LETTER TE;Ll;0;L;;;;;N;;;0422;;0422
0443;CYRILLIC SMALL LETTER U;Ll;0;L;;;;;N;;;0423;;0423
0444;CYRILLIC SMALL LETTER EF;Ll;0;L;;;;;N;;;0424;;0424
0445;CYRILLIC SMALL LETTER HA;Ll;0;L;;;;;N;CYRILLIC SMALL LETTER KHA;;0425;;0425
0446;CYRILLIC SMALL LETTER TSE;Ll;0;L;;;;;N;;;0426;;0426
0447;CYRILLIC SMALL LETTER CHE;Ll;0;L;;;;;N;;;0427;;0427
0448;CYRILLIC SMALL LETTER SHA;Ll;0;L;;;;;N;;;0428;;0428
0449;CYRILLIC SMALL LETTER SHCHA;Ll;0;L;;;;;N;;;0429;;0429
044A;CYRILLIC SMALL LETTER HARD SIGN;Ll;0;L;;;;;N;;;042A;;042A
044B;CYRILLIC SMALL LETTER YERU;Ll;0;L;;;;;N;CYRILLIC SMALL LETTER YERI;;042B;;042B
044C;CYRILLIC SMALL LETTER SOFT SIGN;Ll;0;L;;;;;N;;;042C;;042C
044D;CYRILLIC SMALL LETTER E;Ll;0;L;;;;;N;CYRILLIC SMALL LETTER REVERSED E;;042D;;042D
044E;CYRILLIC SMALL LETTER YU;Ll;0;L;;;;;N;CYRILLIC SMALL LETTER IU;;042E;;042E
044F;CYRILLIC SMALL LETTER YA;Ll;0;L;;;;;N;CYRILLIC SMALL LETTER IA;;042F;;042F
0450;CYRILLIC SMALL LETTER IE WITH GRAVE;Ll;0;L;0435 0300;;;;N;;;0400;;0400
0451;CYRILLIC SMALL LETTER IO;Ll;0;L;0435 0308;;;;N;;;0401;;0401
0452;CYRILLIC SMALL LETTER DJE;Ll;0;L;;;;;N;;;0402;;0402
0453;CYRILLIC SMALL LETTER GJE;Ll;0;L;0433 0301;;;;N;;;0403;;0403
0454;CYRILLIC SMALL LETTER UKRAINIAN IE;Ll;0;L;;;;;N;CYRILLIC SMALL LETTER E;;0404;;0404
0455;CYRILLIC SMALL LETTER DZE;Ll;0;L;;;;;N;;;0405;;0405
0456;CYRILLIC SMALL LETTER BYELORUSSIAN-UKRAINIAN I;Ll;0;L;;;;;N;CYRILLIC SMALL LETTER I;;0406;;0406
0457;CYRILLIC SMALL LETTER YI;Ll;0;L;0456 0308;;;;N;;;0407;;0407
0458;CYRILLIC SMALL LETTER JE;Ll;0;L;;;;;N;;;0408;;0408
0459;CYRILLIC SMALL LETTER LJE;Ll;0;L;;;;;N;;;0409;;0409
045A;CYRILLIC SMALL LETTER NJE;Ll;0;L;;;;;N;;;040A;;040A
045B;CYRILLIC SMALL LETTER TSHE;Ll;0;L;;;;;N;;;040B;;040B
045C;CYRILLIC SMALL LETTER KJE;Ll;0;L;043A 0301;;;;N;;;040C;;040C
045D;CYRILLIC SMALL LETTER I WITH GRAVE;Ll;0;L;0438 0300;;;;N;;;040D;;040D
045E;CYRILLIC SMALL LETTER SHORT U;Ll;0;L;0443 0306;;;;N;;;040E;;040E
045F;CYRILLIC SMALL LETTER DZHE;Ll;0;L;;;;;N;;;040F;;040F
0460;CYRILLIC CAPITAL LETTER OMEGA;Lu;0;L;;;;;N;;;;0461;
0461;CYRILLIC SMALL LETTER OMEGA;Ll;0;L;;;;;N;;;0460;;0460
0462;CYRILLIC CAPITAL LETTER YAT;Lu;0;L;;;;;N;;;;0463;
0463;CYRILLIC SMALL LETTER YAT;Ll;0;L;;;;;N;;;0462;;0462
0464;CYRILLIC CAPITAL LETTER IOTIFIED E;Lu;0;L;;;;;N;;;;0465;
0465;CYRILLIC SMALL LETTER IOTIFIED E;Ll;0;L;;;;;N;;;0464;;0464
0466;CYRILLIC CAPITAL LETTER LITTLE YUS;Lu;0;L;;;;;N;;;;0467;
0467;CYRILLIC SMALL LETTER LITTLE YUS;Ll;0;L;;;;;N;;;0466;;0466
0468;CYRILLIC CAPITAL LETTER IOTIFIED LITTLE YUS;Lu;0;L;;;;;N;;;;0469;
0469;CYRILLIC SMALL LETTER IOTIFIED LITTLE YUS;Ll;0;L;;;;;N;;;0468;;0468
046A;CYRILLIC CAPITAL LETTER BIG YUS;Lu;0;L;;;;;N;;;;046B;
046B;CYRILLIC SMALL LETTER BIG YUS;Ll;0;L;;;;;N;;;046A;;046A
046C;CYRILLIC CAPITAL LETTER IOTIFIED BIG YUS;Lu;0;L;;;;;N;;;;046D;
046D;CYRILLIC SMALL LETTER IOTIFIED BIG YUS;Ll;0;L;;;;;N;;;046C;;046C
046E;CYRILLIC CAPITAL LETTER KSI;Lu;0;L;;;;;N;;;;046F;
046F;CYRILLIC SMALL LETTER KSI;Ll;0;L;;;;;N;;;046E;;046E
0470;CYRILLIC CAPITAL LETTER PSI;Lu;0;L;;;;;N;;;;0471;
0471;CYRILLIC SMALL LETTER PSI;Ll;0;L;;;;;N;;;0470;;0470
0472;CYRILLIC CAPITAL LETTER FITA;Lu;0;L;;;;;N;;;;0473;
0473;CYRILLIC SMALL LETTER FITA;Ll;0;L;;;;;N;;;0472;;0472
0474;CYRILLIC CAPITAL LETTER IZHITSA;Lu;0;L;;;;;N;;;;0475;
0475;CYRILLIC SMALL LETTER IZHITSA;Ll;0;L;;;;;N;;;0474;;0474
0476;CYRILLIC CAPITAL LETTER IZHITSA WITH DOUBLE GRAVE ACCENT;Lu;0;L;0474 030F;;;;N;CYRILLIC CAPITAL LETTER IZHITSA DOUBLE GRAVE;;;0477;
0477;CYRILLIC SMALL LETTER IZHITSA WITH DOUBLE GRAVE ACCENT;Ll;0;L;0475 030F;;;;N;CYRILLIC SMALL LETTER IZHITSA DOUBLE GRAVE;;0476;;0476
0478;CYRILLIC CAPITAL LETTER UK;Lu;0;L;;;;;N;CYRILLIC CAPITAL LETTER UK DIGRAPH;;;0479;
0479;CYRILLIC SMALL LETTER UK;Ll;0;L;;;;;N;CYRILLIC SMALL LETTER UK DIGRAPH;;0478;;0478
047A;CYRILLIC CAPITAL LETTER ROUND OMEGA;Lu;0;L;;;;;N;;;;047B;
047B;CYRILLIC SMALL LETTER ROUND OMEGA;Ll;0;L;;;;;N;;;047A;;047A
047C;CYRILLIC CAPITAL LETTER OMEGA WITH TITLO;Lu;0;L;;;;;N;CYRILLIC CAPITAL LETTER OMEGA TITLO;;;047D;
047D;CYRILLIC SMALL LETTER OMEGA WITH TITLO;Ll;0;L;;;;;N;CYRILLIC SMALL LETTER OMEGA TITLO;;047C;;047C
047E;CYRILLIC CAPITAL LETTER OT;Lu;0;L;;;;;N;;;;047F;
047F;CYRILLIC SMALL LETTER OT;Ll;0;L;;;;;N;;;047E;;047E
0480;CYRILLIC CAPITAL LETTER KOPPA;Lu;0;L;;;;;N;;;;0481;
0481;CYRILLIC SMALL LETTER KOPPA;Ll;0;L;;;;;N;;;0480;;0480
0482;CYRILLIC THOUSANDS SIGN;So;0;L;;;;;N;;;;;
0483;COMBINING CYRILLIC TITLO;Mn;230;NSM;;;;;N;CYRILLIC NON-SPACING TITLO;;;;
0484;COMBINING CYRILLIC PALATALIZATION;Mn;230;NSM;;;;;N;CYRILLIC NON-SPACING PALATALIZATION;;;;
0485;COMBINING CYRILLIC DASIA PNEUMATA;Mn;230;NSM;;;;;N;CYRILLIC NON-SPACING DASIA PNEUMATA;;;;
0486;COMBINING CYRILLIC PSILI PNEUMATA;Mn;230;NSM;;;;;N;CYRILLIC NON-SPACING PSILI PNEUMATA;;;;
0487;COMBINING CYRILLIC POKRYTIE;Mn;230;NSM;;;;;N;;;;;
0488;COMBINING CYRILLIC HUNDRED THOUSANDS SIGN;Me;0;NSM;;;;;N;;;;;
0489;COMBINING CYRILLIC MILLIONS SIGN;Me;0;NSM;;;;;N;;;;;
048A;CYRILLIC CAPITAL LETTER SHORT I WITH TAIL;Lu;0;L;;;;;N;;;;048B;
048B;CYRILLIC SMALL LETTER SHORT I WITH TAIL;Ll;0;L;;;;;N;;;048A;;048A
048C;CYRILLIC CAPITAL LETTER SEMISOFT SIGN;Lu;0;L;;;;;N;;;;048D;
048D;CYRILLIC SMALL LETTER SEMISOFT SIGN;Ll;0;L;;;;;N;;;048C;;048C
048E;CYRILLIC CAPITAL LETTER ER WITH TICK;Lu;0;L;;;;;N;;;;048F;
048F;CYRILLIC SMALL LETTER ER WITH TICK;Ll;0;L;;;;;N;;;048E;;048E
0490;CYRILLIC CAPITAL LETTER GHE WITH UPTURN;Lu;0;L;;;;;N;CYRILLIC CAPITAL LETTER GE WITH UPTURN;;;0491;
0491;CYRILLIC SMALL LETTER GHE WITH UPTURN;Ll;0;L;;;;;N;CYRILLIC SMALL LETTER GE WITH UPTURN;;0490;;0490
0492;CYRILLIC CAPITAL LETTER GHE WITH STROKE;Lu;0;L;;;;;N;CYRILLIC CAPITAL LETTER GE BAR;;;0493;
0493;CYRILLIC SMALL LETTER GHE WITH STROKE;Ll;0;L;;;;;N;CYRILLIC SMALL LETTER GE BAR;;0492;;0492
0494;CYRILLIC CAPITAL LETTER GHE WITH MIDDLE HOOK;Lu;0;L;;;;;N;CYRILLIC CAPITAL LETTER GE HOOK;;;0495;
0495;CYRILLIC SMALL LETTER GHE WITH MIDDLE HOOK;Ll;0;L;;;;;N;CYRILLIC SMALL LETTER GE HOOK;;0494;;0494
0496;CYRILLIC CAPITAL LETTER ZHE WITH DESCENDER;Lu;0;L;;;;;N;CYRILLIC CAPITAL LETTER ZHE WITH RIGHT DESCENDER;;;0497;
0497;CYRILLIC SMALL LETTER ZHE WITH DESCENDER;Ll;0;L;;;;;N;CYRILLIC SMALL LETTER ZHE WITH RIGHT DESCENDER;;0496;;0496
0498;CYRILLIC CAPITAL LETTER ZE WITH DESCENDER;Lu;0;L;;;;;N;CYRILLIC CAPITAL LETTER ZE CEDILLA;;;0499;
0499;CYRILLIC SMALL LETTER ZE WITH DESCENDER;Ll;0;L;;;;;N;CYRILLIC SMALL LETTER ZE CEDILLA;;0498;;0498
049A;CYRILLIC CAPITAL LETTER KA WITH DESCENDER;Lu;0;L;;;;;N;CYRILLIC CAPITAL LETTER KA WITH RIGHT DESCENDER;;;049B;
049B;CYRILLIC SMALL LETTER KA WITH DESCENDER;Ll;0;L;;;;;N;CYRILLIC SMALL LETTER KA WITH RIGHT DESCENDER;;049A;;049A
049C;CYRILLIC CAPITAL LETTER KA WITH VERTICAL STROKE;Lu;0;L;;;;;N;CYRILLIC CAPITAL LETTER KA VERTICAL BAR;;;049D;
049D;CYRILLIC SMALL LETTER KA WITH VERTICAL STROKE;Ll;0;L;;;;;N;CYRILLIC SMALL LETTER KA VERTICAL BAR;;049C;;049C
049E;CYRILLIC CAPITAL LETTER KA WITH STROKE;Lu;0;L;;;;;N;CYRILLIC CAPITAL LETTER KA BAR;;;049F;
049F;CYRILLIC SMALL LETTER KA WITH STROKE;Ll;0;L;;;;;N;CYRILLIC SMALL LETTER KA BAR;;049E;;049E
04A0;CYRILLIC CAPITAL LETTER BASHKIR KA;Lu;0;L;;;;;N;CYRILLIC CAPITAL LETTER REVERSED GE KA;;;04A1;
04A1;CYRILLIC SMALL LETTER BASHKIR KA;Ll;0;L;;;;;N;CYRILLIC SMALL LETTER REVERSED GE KA;;04A0;;04A0
04A2;CYRILLIC CAPITAL LETTER EN WITH DESCENDER;Lu;0;L;;;;;N;CYRILLIC CAPITAL LETTER EN WITH RIGHT DESCENDER;;;04A3;
04A3;CYRILLIC SMALL LETTER EN WITH DESCENDER;Ll;0;L;;;;;N;CYRILLIC SMALL LETTER EN WITH RIGHT DESCENDER;;04A2;;04A2
04A4;CYRILLIC CAPITAL LIGATURE EN GHE;Lu;0;L;;;;;N;CYRILLIC CAPITAL LETTER EN GE;;;04A5;
04A5;CYRILLIC SMALL LIGATURE EN GHE;Ll;0;L;;;;;N;CYRILLIC SMALL LETTER EN GE;;04A4;;04A4
04A6;CYRILLIC CAPITAL LETTER PE WITH MIDDLE HOOK;Lu;0;L;;;;;N;CYRILLIC CAPITAL LETTER PE HOOK;;;04A7;
04A7;CYRILLIC SMALL LETTER PE WITH MIDDLE HOOK;Ll;0;L;;;;;N;CYRILLIC SMALL LETTER PE HOOK;;04A6;;04A6
04A8;CYRILLIC CAPITAL LETTER ABKHASIAN HA;Lu;0;L;;;;;N;CYRILLIC CAPITAL LETTER O HOOK;;;04A9;
04A9;CYRILLIC SMALL LETTER ABKHASIAN HA;Ll;0;L;;;;;N;CYRILLIC SMALL LETTER O HOOK;;04A8;;04A8
04AA;CYRILLIC CAPITAL LETTER ES WITH DESCENDER;Lu;0;L;;;;;N;CYRILLIC CAPITAL LETTER ES CEDILLA;;;04AB;
04AB;CYRILLIC SMALL LETTER ES WITH DESCENDER;Ll;0;L;;;;;N;CYRILLIC SMALL LETTER ES CEDILLA;;04AA;;04AA
04AC;CYRILLIC CAPITAL LETTER TE WITH DESCENDER;Lu;0;L;;;;;N;CYRILLIC CAPITAL LETTER TE WITH RIGHT DESCENDER;;;04AD;
04AD;CYRILLIC SMALL LETTER TE WITH DESCENDER;Ll;0;L;;;;;N;CYRILLIC SMALL LETTER TE WITH RIGHT DESCENDER;;04AC;;04AC
04AE;CYRILLIC CAPITAL LETTER STRAIGHT U;Lu;0;L;;;;;N;;;;04AF;
04AF;CYRILLIC SMALL LETTER STRAIGHT U;Ll;0;L;;;;;N;;;04AE;;04AE
04B0;CYRILLIC CAPITAL LETTER STRAIGHT U WITH STROKE;Lu;0;L;;;;;N;CYRILLIC CAPITAL LETTER STRAIGHT U BAR;;;04B1;
04B1;CYRILLIC SMALL LETTER STRAIGHT U WITH STROKE;Ll;0;L;;;;;N;CYRILLIC SMALL LETTER STRAIGHT U BAR;;04B0;;04B0
04B2;CYRILLIC CAPITAL LETTER HA WITH DESCENDER;Lu;0;L;;;;;N;CYRILLIC CAPITAL LETTER KHA WITH RIGHT DESCENDER;;;04B3;
04B3;CYRILLIC SMALL LETTER HA WITH DESCENDER;Ll;0;L;;;;;N;CYRILLIC SMALL LETTER KHA WITH RIGHT DESCENDER;;04B2;;04B2
04B4;CYRILLIC CAPITAL LIGATURE TE TSE;Lu;0;L;;;;;N;CYRILLIC CAPITAL LETTER TE TSE;;;04B5;
04B5;CYRILLIC SMALL LIGATURE TE TSE;Ll;0;L;;;;;N;CYRILLIC SMALL LETTER TE TSE;;04B4;;04B4
04B6;CYRILLIC CAPITAL LETTER CHE WITH DESCENDER;Lu;0;L;;;;;N;CYRILLIC CAPITAL LETTER CHE WITH RIGHT DESCENDER;;;04B7;
04B7;CYRILLIC SMALL LETTER CHE WITH DESCENDER;Ll;0;L;;;;;N;CYRILLIC SMALL LETTER CHE WITH RIGHT DESCENDER;;04B6;;04B6
04B8;CYRILLIC CAPITAL LETTER CHE WITH VERTICAL STROKE;Lu;0;L;;;;;N;CYRILLIC CAPITAL LETTER CHE VERTICAL BAR;;;04B9;
04B9;CYRILLIC SMALL LETTER CHE WITH VERTICAL STROKE;Ll;0;L;;;;;N;CYRILLIC SMALL LETTER CHE VERTICAL BAR;;04B8;;04B8
04BA;CYRILLIC CAPITAL LETTER SHHA;Lu;0;L;;;;;N;CYRILLIC CAPITAL LETTER H;;;04BB;
04BB;CYRILLIC SMALL LETTER SHHA;Ll;0;L;;;;;N;CYRILLIC SMALL LETTER H;;04BA;;04BA
04BC;CYRILLIC CAPITAL LETTER ABKHASIAN CHE;Lu;0;L;;;;;N;CYRILLIC CAPITAL LETTER IE HOOK;;;04BD;
04BD;CYRILLIC SMALL LETTER ABKHASIAN CHE;Ll;0;L;;;;;N;CYRILLIC SMALL LETTER IE HOOK;;04BC;;04BC
04BE;CYRILLIC CAPITAL LETTER ABKHASIAN CHE WITH DESCENDER;Lu;0;L;;;;;N;CYRILLIC CAPITAL LETTER IE HOOK OGONEK;;;04BF;
04BF;CYRILLIC SMALL LETTER ABKHASIAN CHE WITH DESCENDER;Ll;0;L;;;;;N;CYRILLIC SMALL LETTER IE HOOK OGONEK;;04BE;;04BE
04C0;CYRILLIC LETTER PALOCHKA;Lu;0;L;;;;;N;CYRILLIC LETTER I;;;04CF;
04C1;CYRILLIC CAPITAL LETTER ZHE WITH BREVE;Lu;0;L;0416 0306;;;;N;CYRILLIC CAPITAL LETTER SHORT ZHE;;;04C2;
04C2;CYRILLIC SMALL LETTER ZHE WITH BREVE;Ll;0;L;0436 0306;;;;N;CYRILLIC SMALL LETTER SHORT ZHE;;04C1;;04C1
04C3;CYRILLIC CAPITAL LETTER KA WITH HOOK;Lu;0;L;;;;;N;CYRILLIC CAPITAL LETTER KA HOOK;;;04C4;
04C4;CYRILLIC SMALL LETTER KA WITH HOOK;Ll;0;L;;;;;N;CYRILLIC SMALL LETTER KA HOOK;;04C3;;04C3
04C5;CYRILLIC CAPITAL LETTER EL WITH TAIL;Lu;0;L;;;;;N;;;;04C6;
04C6;CYRILLIC SMALL LETTER EL WITH TAIL;Ll;0;L;;;;;N;;;04C5;;04C5
04C7;CYRILLIC CAPITAL LETTER EN WITH HOOK;Lu;0;L;;;;;N;CYRILLIC CAPITAL LETTER EN HOOK;;;04C8;
04C8;CYRILLIC SMALL LETTER EN WITH HOOK;Ll;0;L;;;;;N;CYRILLIC SMALL LETTER EN HOOK;;04C7;;04C7
04C9;CYRILLIC CAPITAL LETTER EN WITH TAIL;Lu;0;L;;;;;N;;;;04CA;
04CA;CYRILLIC SMALL LETTER EN WITH TAIL;Ll;0;L;;;;;N;;;04C9;;04C9
04CB;CYRILLIC CAPITAL LETTER KHAKASSIAN CHE;Lu;0;L;;;;;N;CYRILLIC CAPITAL LETTER CHE WITH LEFT DESCENDER;;;04CC;
04CC;CYRILLIC SMALL LETTER KHAKASSIAN CHE;Ll;0;L;;;;;N;CYRILLIC SMALL LETTER CHE WITH LEFT DESCENDER;;04CB;;04CB
04CD;CYRILLIC CAPITAL LETTER EM WITH TAIL;Lu;0;L;;;;;N;;;;04CE;
04CE;CYRILLIC SMALL LETTER EM WITH TAIL;Ll;0;L;;;;;N;;;04CD;;04CD
04CF;CYRILLIC SMALL LETTER PALOCHKA;Ll;0;L;;;;;N;;;04C0;;04C0
04D0;CYRILLIC CAPITAL LETTER A WITH BREVE;Lu;0;L;0410 0306;;;;N;;;;04D1;
04D1;CYRILLIC SMALL LETTER A WITH BREVE;Ll;0;L;0430 0306;;;;N;;;04D0;;04D0
04D2;CYRILLIC CAPITAL LETTER A WITH DIAERESIS;Lu;0;L;0410 0308;;;;N;;;;04D3;
04D3;CYRILLIC SMALL LETTER A WITH DIAERESIS;Ll;0;L;0430 0308;;;;N;;;04D2;;04D2
04D4;CYRILLIC CAPITAL LIGATURE A IE;Lu;0;L;;;;;N;;;;04D5;
04D5;CYRILLIC SMALL LIGATURE A IE;Ll;0;L;;;;;N;;;04D4;;04D4
04D6;CYRILLIC CAPITAL LETTER IE WITH BREVE;Lu;0;L;0415 0306;;;;N;;;;04D7;
04D7;CYRILLIC SMALL LETTER IE WITH BREVE;Ll;0;L;0435 0306;;;;N;;;04D6;;04D6
04D8;CYRILLIC CAPITAL LETTER SCHWA;Lu;0;L;;;;;N;;;;04D9;
04D9;CYRILLIC SMALL LETTER SCHWA;Ll;0;L;;;;;N;;;04D8;;04D8
04DA;CYRILLIC CAPITAL LETTER SCHWA WITH DIAERESIS;Lu;0;L;04D8 0308;;;;N;;;;04DB;
04DB;CYRILLIC SMALL LETTER SCHWA WITH DIAERESIS;Ll;0;L;04D9 0308;;;;N;;;04DA;;04DA
04DC;CYRILLIC CAPITAL LETTER ZHE WITH DIAERESIS;Lu;0;L;0416 0308;;;;N;;;;04DD;
04DD;CYRILLIC SMALL LETTER ZHE WITH DIAERESIS;Ll;0;L;0436 0308;;;;N;;;04DC;;04DC
04DE;CYRILLIC CAPITAL LETTER ZE WITH DIAERESIS;Lu;0;L;0417 0308;;;;N;;;;04DF;
04DF;CYRILLIC SMALL LETTER ZE WITH DIAERESIS;Ll;0;L;0437 0308;;;;N;;;04DE;;04DE
04E0;CYRILLIC CAPITAL LETTER ABKHASIAN DZE;Lu;0;L;;;;;N;;;;04E1;
04E1;CYRILLIC SMALL LETTER ABKHASIAN DZE;Ll;0;L;;;;;N;;;04E0;;04E0
04E2;CYRILLIC CAPITAL LETTER I WITH MACRON;Lu;0;L;0418 0304;;;;N;;;;04E3;
04E3;CYRILLIC SMALL LETTER I WITH MACRON;Ll;0;L;0438 0304;;;;N;;;04E2;;04E2
04E4;CYRILLIC CAPITAL LETTER I WITH DIAERESIS;Lu;0;L;0418 0308;;;;N;;;;04E5;
04E5;CYRILLIC SMALL LETTER I WITH DIAERESIS;Ll;0;L;0438 0308;;;;N;;;04E4;;04E4
04E6;CYRILLIC CAPITAL LETTER O WITH DIAERESIS;Lu;0;L;041E 0308;;;;N;;;;04E7;
04E7;CYRILLIC SMALL LETTER O WITH DIAERESIS;Ll;0;L;043E 0308;;;;N;;;04E6;;04E6
04E8;CYRILLIC CAPITAL LETTER BARRED O;Lu;0;L;;;;;N;;;;04E9;
04E9;CYRILLIC SMALL LETTER BARRED O;Ll;0;L;;;;;N;;;04E8;;04E8
04EA;CYRILLIC CAPITAL LETTER BARRED O WITH DIAERESIS;Lu;0;L;04E8 0308;;;;N;;;;04EB;
04EB;CYRILLIC SMALL LETTER BARRED O WITH DIAERESIS;Ll;0;L;04E9 0308;;;;N;;;04EA;;04EA
04EC;CYRILLIC CAPITAL LETTER E WITH DIAERESIS;Lu;0;L;042D 0308;;;;N;;;;04ED;
04ED;CYRILLIC SMALL LETTER E WITH DIAERESIS;Ll;0;L;044D 0308;;;;N;;;04EC;;04EC
04EE;CYRILLIC CAPITAL LETTER U WITH MACRON;Lu;0;L;0423 0304;;;;N;;;;04EF;
04EF;CYRILLIC SMALL LETTER U WITH MACRON;Ll;0;L;0443 0304;;;;N;;;04EE;;04EE
04F0;CYRILLIC CAPITAL LETTER U WITH DIAERESIS;Lu;0;L;0423 0308;;;;N;;;;04F1;
04F1;CYRILLIC SMALL LETTER U WITH DIAERESIS;Ll;0;L;0443 0308;;;;N;;;04F0;;04F0
04F2;CYRILLIC CAPITAL LETTER U WITH DOUBLE ACUTE;Lu;0;L;0423 030B;;;;N;;;;04F3;
04F3;CYRILLIC SMALL LETTER U WITH DOUBLE ACUTE;Ll;0;L;0443 030B;;;;N;;;04F2;;04F2
04F4;CYRILLIC CAPITAL LETTER CHE WITH DIAERESIS;Lu;0;L;0427 0308;;;;N;;;;04F5;
04F5;CYRILLIC SMALL LETTER CHE WITH DIAERESIS;Ll;0;L;0447 0308;;;;N;;;04F4;;04F4
04F6;CYRILLIC CAPITAL LETTER GHE WITH DESCENDER;Lu;0;L;;;;;N;;;;04F7;
04F7;CYRILLIC SMALL LETTER GHE WITH DESCENDER;Ll;0;L;;;;;N;;;04F6;;04F6
04F8;CYRILLIC CAPITAL LETTER YERU WITH DIAERESIS;Lu;0;L;042B 0308;;;;N;;;;04F9;
04F9;CYRILLIC SMALL LETTER YERU WITH DIAERESIS;Ll;0;L;044B 0308;;;;N;;;04F8;;04F8
04FA;CYRILLIC CAPITAL LETTER GHE WITH STROKE AND HOOK;Lu;0;L;;;;;N;;;;04FB;
04FB;CYRILLIC SMALL LETTER GHE WITH STROKE AND HOOK;Ll;0;L;;;;;N;;;04FA;;04FA
04FC;CYRILLIC CAPITAL LETTER HA WITH HOOK;Lu;0;L;;;;;N;;;;04FD;
04FD;CYRILLIC SMALL LETTER HA WITH HOOK;Ll;0;L;;;;;N;;;04FC;;04FC
04FE;CYRILLIC CAPITAL LETTER HA WITH STROKE;Lu;0;L;;;;;N;;;;04FF;
04FF;CYRILLIC SMALL LETTER HA WITH STROKE;Ll;0;L;;;;;N;;;04FE;;04FE
0500;CYRILLIC CAPITAL LETTER KOMI DE;Lu;0;L;;;;;N;;;;0501;
0501;CYRILLIC SMALL LETTER KOMI DE;Ll;0;L;;;;;N;;;0500;;0500
0502;CYRILLIC CAPITAL LETTER KOMI DJE;Lu;0;L;;;;;N;;;;0503;
0503;CYRILLIC SMALL LETTER KOMI DJE;Ll;0;L;;;;;N;;;0502;;0502
0504;CYRILLIC CAPITAL LETTER KOMI ZJE;Lu;0;L;;;;;N;;;;0505;
0505;CYRILLIC SMALL LETTER KOMI ZJE;Ll;0;L;;;;;N;;;0504;;0504
0506;CYRILLIC CAPITAL LETTER KOMI DZJE;Lu;0;L;;;;;N;;;;0507;
0507;CYRILLIC SMALL LETTER KOMI DZJE;Ll;0;L;;;;;N;;;0506;;0506
0508;CYRILLIC CAPITAL LETTER KOMI LJE;Lu;0;L;;;;;N;;;;0509;
0509;CYRILLIC SMALL LETTER KOMI LJE;Ll;0;L;;;;;N;;;0508;;0508
050A;CYRILLIC CAPITAL LETTER KOMI NJE;Lu;0;L;;;;;N;;;;050B;
050B;CYRILLIC SMALL LETTER KOMI NJE;Ll;0;L;;;;;N;;;050A;;050A
050C;CYRILLIC CAPITAL LETTER KOMI SJE;Lu;0;L;;;;;N;;;;050D;
050D;CYRILLIC SMALL LETTER KOMI SJE;Ll;0;L;;;;;N;;;050C;;050C
050E;CYRILLIC CAPITAL LETTER KOMI TJE;Lu;0;L;;;;;N;;;;050F;
050F;CYRILLIC SMALL LETTER KOMI TJE;Ll;0;L;;;;;N;;;050E;;050E
0510;CYRILLIC CAPITAL LETTER REVERSED ZE;Lu;0;L;;;;;N;;;;0511;
0511;CYRILLIC SMALL LETTER REVERSED ZE;Ll;0;L;;;;;N;;;0510;;0510
0512;CYRILLIC CAPITAL LETTER EL WITH HOOK;Lu;0;L;;;;;N;;;;0513;
0513;CYRILLIC SMALL LETTER EL WITH HOOK;Ll;0;L;;;;;N;;;0512;;0512
0514;CYRILLIC CAPITAL LETTER LHA;Lu;0;L;;;;;N;;;;0515;
0515;CYRILLIC SMALL LETTER LHA;Ll;0;L;;;;;N;;;0514;;0514
0516;CYRILLIC CAPITAL LETTER RHA;Lu;0;L;;;;;N;;;;0517;
0517;CYRILLIC SMALL LETTER RHA;Ll;0;L;;;;;N;;;0516;;0516
0518;CYRILLIC CAPITAL LETTER YAE;Lu;0;L;;;;;N;;;;0519;
0519;CYRILLIC SMALL LETTER YAE;Ll;0;L;;;;;N;;;0518;;0518
051A;CYRILLIC CAPITAL LETTER QA;Lu;0;L;;;;;N;;;;051B;
051B;CYRILLIC SMALL LETTER QA;Ll;0;L;;;;;N;;;051A;;051A
051C;CYRILLIC CAPITAL LETTER WE;Lu;0;L;;;;;N;;;;051D;
051D;CYRILLIC SMALL LETTER WE;Ll;0;L;;;;;N;;;051C;;051C
051E;CYRILLIC CAPITAL LETTER ALEUT KA;Lu;0;L;;;;;N;;;;051F;
051F;CYRILLIC SMALL LETTER ALEUT KA;Ll;0;L;;;;;N;;;051E;;051E
0520;CYRILLIC CAPITAL LETTER EL WITH MIDDLE HOOK;Lu;0;L;;;;;N;;;;0521;
0521;CYRILLIC SMALL LETTER EL WITH MIDDLE HOOK;Ll;0;L;;;;;N;;;0520;;0520
0522;CYRILLIC CAPITAL LETTER EN WITH MIDDLE HOOK;Lu;0;L;;;;;N;;;;0523;
0523;CYRILLIC SMALL LETTER EN WITH MIDDLE HOOK;Ll;0;L;;;;;N;;;0522;;0522
0524;CYRILLIC CAPITAL LETTER PE WITH DESCENDER;Lu;0;L;;;;;N;;;;0525;
0525;CYRILLIC SMALL LETTER PE WITH DESCENDER;Ll;0;L;;;;;N;;;0524;;0524
0526;CYRILLIC CAPITAL LETTER SHHA WITH DESCENDER;Lu;0;L;;;;;N;;;;0527;
0527;CYRILLIC SMALL LETTER SHHA WITH DESCENDER;Ll;0;L;;;;;N;;;0526;;0526
0528;CYRILLIC CAPITAL LETTER EN WITH LEFT HOOK;Lu;0;L;;;;;N;;;;0529;
0529;CYRILLIC SMALL LETTER EN WITH LEFT HOOK;Ll;0;L;;;;;N;;;0528;;0528
052A;CYRILLIC CAPITAL LETTER DZZHE;Lu;0;L;;;;;N;;;;052B;
052B;CYRILLIC SMALL LETTER DZZHE;Ll;0;L;;;;;N;;;052A;;052A
052C;CYRILLIC CAPITAL LETTER DCHE;Lu;0;L;;;;;N;;;;052D;
052D;CYRILLIC SMALL LETTER DCHE;Ll;0;L;;;;;N;;;052C;;052C
052E;CYRILLIC CAPITAL LETTER EL WITH DESCENDER;Lu;0;L;;;;;N;;;;052F;
052F;CYRILLIC SMALL LETTER EL WITH DESCENDER;Ll;0;L;;;;;N;;;052E;;052E
0531;ARMENIAN CAPITAL LETTER AYB;Lu;0;L;;;;;N;;;;0561;
0532;ARMENIAN CAPITAL LETTER BEN;Lu;0;L;;;;;N;;;;0562;
0533;ARMENIAN CAPITAL LETTER GIM;Lu;0;L;;;;;N;;;;0563;
0534;ARMENIAN CAPITAL LETTER DA;Lu;0;L;;;;;N;;;;0564;
0535;ARMENIAN CAPITAL LETTER ECH;Lu;0;L;;;;;N;;;;0565;
0536;ARMENIAN CAPITAL LETTER ZA;Lu;0;L;;;;;N;;;;0566;
0537;ARMENIAN CAPITAL LETTER EH;Lu;0;L;;;;;N;;;;0567;
0538;ARMENIAN CAPITAL LETTER ET;Lu;0;L;;;;;N;;;;0568;
0539;ARMENIAN CAPITAL LETTER TO;Lu;0;L;;;;;N;;;;0569;
053A;ARMENIAN CAPITAL LETTER ZHE;Lu;0;L;;;;;N;;;;056A;
053B;ARMENIAN CAPITAL LETTER INI;Lu;0;L;;;;;N;;;;056B;
053C;ARMENIAN CAPITAL LETTER LIWN;Lu;0;L;;;;;N;;;;056C;
053D;ARMENIAN CAPITAL LETTER XEH;Lu;0;L;;;;;N;;;;056D;
053E;ARMENIAN CAPITAL LETTER CA;Lu;0;L;;;;;N;;;;056E;
053F;ARMENIAN CAPITAL LETTER KEN;Lu;0;L;;;;;N;;;;056F;
0540;ARMENIAN CAPITAL LETTER HO;Lu;0;L;;;;;N;;;;0570;
0541;ARMENIAN CAPITAL LETTER JA;Lu;0;L;;;;;N;;;;0571;
0542;ARMENIAN CAPITAL LETTER GHAD;Lu;0;L;;;;;N;ARMENIAN CAPITAL LETTER LAD;;;0572;
0543;ARMENIAN CAPITAL LETTER CHEH;Lu;0;L;;;;;N;;;;0573;
0544;ARMENIAN CAPITAL LETTER MEN;Lu;0;L;;;;;N;;;;0574;
0545;ARMENIAN CAPITAL LETTER YI;Lu;0;L;;;;;N;;;;0575;
0546;ARMENIAN CAPITAL LETTER NOW;Lu;0;L;;;;;N;;;;0576;
0547;ARMENIAN CAPITAL LETTER SHA;Lu;0;L;;;;;N;;;;0577;
0548;ARMENIAN CAPITAL LETTER VO;Lu;0;L;;;;;N;;;;0578;
0549;ARMENIAN CAPITAL LETTER CHA;Lu;0;L;;;;;N;;;;0579;
054A;ARMENIAN CAPITAL LETTER PEH;Lu;0;L;;;;;N;;;;057A;
054B;ARMENIAN CAPITAL LETTER JHEH;Lu;0;L;;;;;N;;;;057B;
054C;ARMENIAN CAPITAL LETTER RA;Lu;0;L;;;;;N;;;;057C;
054D;ARMENIAN CAPITAL LETTER SEH;Lu;0;L;;;;;N;;;;057D;
054E;ARMENIAN CAPITAL LETTER VEW;Lu;0;L;;;;;N;;;;057E;
054F;ARMENIAN CAPITAL LETTER TIWN;Lu;0;L;;;;;N;;;;057F;
0550;ARMENIAN CAPITAL LETTER REH;Lu;0;L;;;;;N;;;;0580;
0551;ARMENIAN CAPITAL LETTER CO;Lu;0;L;;;;;N;;;;0581;
0552;ARMENIAN CAPITAL LETTER YIWN;Lu;0;L;;;;;N;;;;0582;
0553;ARMENIAN CAPITAL LETTER PIWR;Lu;0;L;;;;;N;;;;0583;
0554;ARMENIAN CAPITAL LETTER KEH;Lu;0;L;;;;;N;;;;0584;
0555;ARMENIAN CAPITAL LETTER OH;Lu;0;L;;;;;N;;;;0585;
0556;ARMENIAN CAPITAL LETTER FEH;Lu;0;L;;;;;N;;;;0586;
0559;ARMENIAN MODIFIER LETTER LEFT HALF RING;Lm;0;L;;;;;N;;;;;
055A;ARMENIAN APOSTROPHE;Po;0;L;;;;;N;ARMENIAN MODIFIER LETTER RIGHT HALF RING;;;;
055B;ARMENIAN EMPHASIS MARK;Po;0;L;;;;;N;;;;;
055C;ARMENIAN EXCLAMATION MARK;Po;0;L;;;;;N;;;;;
055D;ARMENIAN COMMA;Po;0;L;;;;;N;;;;;
055E;ARMENIAN QUESTION MARK;Po;0;L;;;;;N;;;;;
055F;ARMENIAN ABBREVIATION MARK;Po;0;L;;;;;N;;;;;
0560;ARMENIAN SMALL LETTER TURNED AYB;Ll;0;L;;;;;N;;;;;
0561;ARMENIAN SMALL LETTER AYB;Ll;0;L;;;;;N;;;0531;;0531
0562;ARMENIAN SMALL LETTER BEN;Ll;0;L;;;;;N;;;0532;;0532
0563;ARMENIAN SMALL LETTER GIM;Ll;0;L;;;;;N;;;0533;;0533
0564;ARMENIAN SMALL LETTER DA;Ll;0;L;;;;;N;;;0534;;0534
0565;ARMENIAN SMALL LETTER ECH;Ll;0;L;;;;;N;;;0535;;0535
0566;ARMENIAN SMALL LETTER ZA;Ll;0;L;;;;;N;;;0536;;0536
0567;ARMENIAN SMALL LETTER EH;Ll;0;L;;;;;N;;;0537;;0537
0568;ARMENIAN SMALL LETTER ET;Ll;0;L;;;;;N;;;0538;;0538
0569;ARMENIAN SMALL LETTER TO;Ll;0;L;;;;;N;;;0539;;0539
056A;ARMENIAN SMALL LETTER ZHE;Ll;0;L;;;;;N;;;053A;;053A
056B;ARMENIAN SMALL LETTER INI;Ll;0;L;;;;;N;;;053B;;053B
056C;ARMENIAN SMALL LETTER LIWN;Ll;0;L;;;;;N;;;053C;;053C
056D;ARMENIAN SMALL LETTER XEH;Ll;0;L;;;;;N;;;053D;;053D
056E;ARMENIAN SMALL LETTER CA;Ll;0;L;;;;;N;;;053E;;053E
056F;ARMENIAN SMALL LETTER KEN;Ll;0;L;;;;;N;;;053F;;053F
0570;ARMENIAN SMALL LETTER HO;Ll;0;L;;;;;N;;;0540;;0540
0571;ARMENIAN SMALL LETTER JA;Ll;0;L;;;;;N;;;0541;;0541
0572;ARMENIAN SMALL LETTER GHAD;Ll;0;L;;;;;N;ARMENIAN SMALL LETTER LAD;;0542;;0542
0573;ARMENIAN SMALL LETTER CHEH;Ll;0;L;;;;;N;;;0543;;0543
0574;ARMENIAN SMALL LETTER MEN;Ll;0;L;;;;;N;;;0544;;0544
0575;ARMENIAN SMALL LETTER YI;Ll;0;L;;;;;N;;;0545;;0545
0576;ARMENIAN SMALL LETTER NOW;Ll;0;L;;;;;N;;;0546;;0546
0577;ARMENIAN SMALL LETTER SHA;Ll;0;L;;;;;N;;;0547;;0547
0578;ARMENIAN SMALL LETTER VO;Ll;0;L;;;;;N;;;0548;;0548
0579;ARMENIAN SMALL LETTER CHA;Ll;0;L;;;;;N;;;0549;;0549
057A;ARMENIAN SMALL LETTER PEH;Ll;0;L;;;;;N;;;054A;;054A
057B;ARMENIAN SMALL LETTER JHEH;Ll;0;L;;;;;N;;;054B;;054B
057C;ARMENIAN SMALL LETTER RA;Ll;0;L;;;;;N;;;054C;;054C
057D;ARMENIAN SMALL LETTER SEH;Ll;0;L;;;;;N;;;054D;;054D
057E;ARMENIAN SMALL LETTER VEW;Ll;0;L;;;;;N;;;054E;;054E
057F;ARMENIAN SMALL LETTER TIWN;Ll;0;L;;;;;N;;;054F;;054F
0580;ARMENIAN SMALL LETTER REH;Ll;0;L;;;;;N;;;0550;;0550
0581;ARMENIAN SMALL LETTER CO;Ll;0;L;;;;;N;;;0551;;0551
0582;ARMENIAN SMALL LETTER YIWN;Ll;0;L;;;;;N;;;0552;;0552
0583;ARMENIAN SMALL LETTER PIWR;Ll;0;L;;;;;N;;;0553;;0553
0584;ARMENIAN SMALL LETTER KEH;Ll;0;L;;;;;N;;;0554;;0554
0585;ARMENIAN SMALL LETTER OH;Ll;0;L;;;;;N;;;0555;;0555
0586;ARMENIAN SMALL LETTER FEH;Ll;0;L;;;;;N;;;0556;;0556
0587;ARMENIAN SMALL LIGATURE ECH YIWN;Ll;0;L;<compat> 0565 0582;;;;N;;;;;
0588;ARMENIAN SMALL LETTER YI WITH STROKE;Ll;0;L;;;;;N;;;;;
0589;ARMENIAN FULL STOP;Po;0;L;;;;;N;ARMENIAN PERIOD;;;;
058A;ARMENIAN HYPHEN;Pd;0;ON;;;;;N;;;;;
058D;RIGHT-FACING ARMENIAN ETERNITY SIGN;So;0;ON;;;;;N;;;;;
058E;LEFT-FACING ARMENIAN ETERNITY SIGN;So;0;ON;;;;;N;;;;;
058F;ARMENIAN DRAM SIGN;Sc;0;ET;;;;;N;;;;;
0591;HEBREW ACCENT ETNAHTA;Mn;220;NSM;;;;;N;;;;;
0592;HEBREW ACCENT SEGOL;Mn;230;NSM;;;;;N;;;;;
0593;HEBREW ACCENT SHALSHELET;Mn;230;NSM;;;;;N;;;;;
0594;HEBREW ACCENT ZAQEF QATAN;Mn;230;NSM;;;;;N;;;;;
0595;HEBREW ACCENT ZAQEF GADOL;Mn;230;NSM;;;;;N;;;;;
0596;HEBREW ACCENT TIPEHA;Mn;220;NSM;;;;;N;;;;;
0597;HEBREW ACCENT REVIA;Mn;230;NSM;;;;;N;;;;;
0598;HEBREW ACCENT ZARQA;Mn;230;NSM;;;;;N;;;;;
0599;HEBREW ACCENT PASHTA;Mn;230;NSM;;;;;N;;;;;
059A;HEBREW ACCENT YETIV;Mn;222;NSM;;;;;N;;;;;
059B;HEBREW ACCENT TEVIR;Mn;220;NSM;;;;;N;;;;;
059C;HEBREW ACCENT GERESH;Mn;230;NSM;;;;;N;;;;;
059D;HEBREW ACCENT GERESH MUQDAM;Mn;230;NSM;;;;;N;;;;;
059E;HEBREW ACCENT GERSHAYIM;Mn;230;NSM;;;;;N;;;;;
059F;HEBREW ACCENT QARNEY PARA;Mn;230;NSM;;;;;N;;;;;
05A0;HEBREW ACCENT TELISHA GEDOLA;Mn;230;NSM;;;;;N;;;;;
05A1;HEBREW ACCENT PAZER;Mn;230;NSM;;;;;N;;;;;
05A2;HEBREW ACCENT ATNAH HAFUKH;Mn;220;NSM;;;;;N;;;;;
05A3;HEBREW ACCENT MUNAH;Mn;220;NSM;;;;;N;;;;;
05A4;HEBREW ACCENT MAHAPAKH;Mn;220;NSM;;;;;N;;;;;
05A5;HEBREW ACCENT MERKHA;Mn;220;NSM;;;;;N;;;;;
05A6;HEBREW ACCENT MERKHA KEFULA;Mn;220;NSM;;;;;N;;;;;
05A7;HEBREW ACCENT DARGA;Mn;220;NSM;;;;;N;;;;;
05A8;HEBREW ACCENT QADMA;Mn;230;NSM;;;;;N;;;;;
05A9;HEBREW ACCENT TELISHA QETANA;Mn;230;NSM;;;;;N;;;;;
05AA;HEBREW ACCENT YERAH BEN YOMO;Mn;220;NSM;;;;;N;;;;;
05AB;HEBREW ACCENT OLE;Mn;230;NSM;;;;;N;;;;;
05AC;HEBREW ACCENT ILUY;Mn;230;NSM;;;;;N;;;;;
05AD;HEBREW ACCENT DEHI;Mn;222;NSM;;;;;N;;;;;
05AE;HEBREW ACCENT ZINOR;Mn;228;NSM;;;;;N;;;;;
05AF;HEBREW MARK MASORA CIRCLE;Mn;230;NSM;;;;;N;;;;;
05B0;HEBREW POINT SHEVA;Mn;10;NSM;;;;;N;;;;;
05B1;HEBREW POINT HATAF SEGOL;Mn;11;NSM;;;;;N;;;;;
05B2;HEBREW POINT HATAF PATAH;Mn;12;NSM;;;;;N;;;;;
05B3;HEBREW POINT HATAF QAMATS;Mn;13;NSM;;;;;N;;;;;
05B4;HEBREW POINT HIRIQ;Mn;14;NSM;;;;;N;;;;;
05B5;HEBREW POINT TSERE;Mn;15;NSM;;;;;N;;;;;
05B6;HEBREW POINT SEGOL;Mn;16;NSM;;;;;N;;;;;
05B7;HEBREW POINT PATAH;Mn;17;NSM;;;;;N;;;;;
05B8;HEBREW POINT QAMATS;Mn;18;NSM;;;;;N;;;;;
05B9;HEBREW POINT HOLAM;Mn;19;NSM;;;;;N;;;;;
05BA;HEBREW POINT HOLAM HASER FOR VAV;Mn;19;NSM;;;;;N;;;;;
05BB;HEBREW POINT QUBUTS;Mn;20;NSM;;;;;N;;;;;
05BC;HEBREW POINT DAGESH OR MAPIQ;Mn;21;NSM;;;;;N;HEBREW POINT DAGESH;;;;
05BD;HEBREW POINT METEG;Mn;22;NSM;;;;;N;;;;;
05BE;HEBREW PUNCTUATION MAQAF;Pd;0;R;;;;;N;;;;;
05BF;HEBREW POINT RAFE;Mn;23;NSM;;;;;N;;;;;
05C0;HEBREW PUNCTUATION PASEQ;Po;0;R;;;;;N;HEBREW POINT PASEQ;;;;
05C1;HEBREW POINT SHIN DOT;Mn;24;NSM;;;;;N;;;;;
05C2;HEBREW POINT SIN DOT;Mn;25;NSM;;;;;N;;;;;
05C3;HEBREW PUNCTUATION SOF PASUQ;Po;0;R;;;;;N;;;;;
05C4;HEBREW MARK UPPER DOT;Mn;230;NSM;;;;;N;;;;;
05C5;HEBREW MARK LOWER DOT;Mn;220;NSM;;;;;N;;;;;
05C6;HEBREW PUNCTUATION NUN HAFUKHA;Po;0;R;;;;;N;;;;;
05C7;HEBREW POINT QAMATS QATAN;Mn;18;NSM;;;;;N;;;;;
05D0;HEBREW LETTER ALEF;Lo;0;R;;;;;N;;;;;
05D1;HEBREW LETTER BET;Lo;0;R;;;;;N;;;;;
05D2;HEBREW LETTER GIMEL;Lo;0;R;;;;;N;;;;;
05D3;HEBREW LETTER DALET;Lo;0;R;;;;;N;;;;;
05D4;HEBREW LETTER HE;Lo;0;R;;;;;N;;;;;
05D5;HEBREW LETTER VAV;Lo;0;R;;;;;N;;;;;
05D6;HEBREW LETTER ZAYIN;Lo;0;R;;;;;N;;;;;
05D7;HEBREW LETTER HET;Lo;0;R;;;;;N;;;;;
05D8;HEBREW LETTER TET;Lo;0;R;;;;;N;;;;;
05D9;HEBREW LETTER YOD;Lo;0;R;;;;;N;;;;;
05DA;HEBREW LETTER FINAL KAF;Lo;0;R;;;;;N;;;;;
05DB;HEBREW LETTER KAF;Lo;0;R;;;;;N;;;;;
05DC;HEBREW LETTER LAMED;Lo;0;R;;;;;N;;;;;
05DD;HEBREW LETTER FINAL MEM;Lo;0;R;;;;;N;;;;;
05DE;HEBREW LETTER MEM;Lo;0;R;;;;;N;;;;;
05DF;HEBREW LETTER FINAL NUN;Lo;0;R;;;;;N;;;;;
05E0;HEBREW LETTER NUN;Lo;0;R;;;;;N;;;;;
05E1;HEBREW LETTER SAMEKH;Lo;0;R;;;;;N;;;;;
05E2;HEBREW LETTER AYIN;Lo;0;R;;;;;N;;;;;
05E3;HEBREW LETTER FINAL PE;Lo;0;R;;;;;N;;;;;
05E4;HEBREW LETTER PE;Lo;0;R;;;;;N;;;;;
05E5;HEBREW LETTER FINAL TSADI;Lo;0;R;;;;;N;;;;;
05E6;HEBREW LETTER TSADI;Lo;0;R;;;;;N;;;;;
05E7;HEBREW LETTER QOF;Lo;0;R;;;;;N;;;;;
05E8;HEBREW LETTER RESH;Lo;0;R;;;;;N;;;;;
05E9;HEBREW LETTER SHIN;Lo;0;R;;;;;N;;;;;
05EA;HEBREW LETTER TAV;Lo;0;R;;;;;N;;;;;
05EF;HEBREW YOD TRIANGLE;Lo;0;R;;;;;N;;;;;
05F0;HEBREW LIGATURE YIDDISH DOUBLE VAV;Lo;0;R;;;;;N;HEBREW LETTER DOUBLE VAV;;;;
05F1;HEBREW LIGATURE YIDDISH VAV YOD;Lo;0;R;;;;;N;HEBREW LETTER VAV YOD;;;;
05F2;HEBREW LIGATURE YIDDISH DOUBLE YOD;Lo;0;R;;;;;N;HEBREW LETTER DOUBLE YOD;;;;
05F3;HEBREW PUNCTUATION GERESH;Po;0;R;;;;;N;;;;;
05F4;HEBREW PUNCTUATION GERSHAYIM;Po;0;R;;;;;N;;;;;
0600;ARABIC NUMBER SIGN;Cf;0;AN;;;;;N;;;;;
0601;ARABIC SIGN SANAH;Cf;0;AN;;;;;N;;;;;
0602;ARABIC FOOTNOTE MARKER;Cf;0;AN;;;;;N;;;;;
0603;ARABIC SIGN SAFHA;Cf;0;AN;;;;;N;;;;;
0604;ARABIC SIGN SAMVAT;Cf;0;AN;;;;;N;;;;;
0605;ARABIC NUMBER MARK ABOVE;Cf;0;AN;;;;;N;;;;;
0606;ARABIC-INDIC CUBE ROOT;Sm;0;ON;;;;;N;;;;;
0607;ARABIC-INDIC FOURTH ROOT;Sm;0;ON;;;;;N;;;;;
0608;ARABIC RAY;Sm;0;AL;;;;;N;;;;;
0609;ARABIC-INDIC PER MILLE SIGN;Po;0;ET;;;;;N;;;;;
060A;ARABIC-INDIC PER TEN THOUSAND SIGN;Po;0;ET;;;;;N;;;;;
060B;AFGHANI SIGN;Sc;0;AL;;;;;N;;;;;
060C;ARABIC COMMA;Po;0;CS;;;;;N;;;;;
060D;ARABIC DATE SEPARATOR;Po;0;AL;;;;;N;;;;;
060E;ARABIC POETIC VERSE SIGN;So;0;ON;;;;;N;;;;;
060F;ARABIC SIGN MISRA;So;0;ON;;;;;N;;;;;
0610;ARABIC SIGN SALLALLAHOU ALAYHE WASSALLAM;Mn;230;NSM;;;;;N;;;;;
0611;ARABIC SIGN ALAYHE ASSALLAM;Mn;230;NSM;;;;;N;;;;;
0612;ARABIC SIGN RAHMATULLAH ALAYHE;Mn;230;NSM;;;;;N;;;;;
0613;ARABIC SIGN RADI ALLAHOU ANHU;Mn;230;NSM;;;;;N;;;;;
0614;ARABIC SIGN TAKHALLUS;Mn;230;NSM;;;;;N;;;;;
0615;ARABIC SMALL HIGH TAH;Mn;230;NSM;;;;;N;;;;;
0616;ARABIC SMALL HIGH LIGATURE ALEF WITH LAM WITH YEH;Mn;230;NSM;;;;;N;;;;;
0617;ARABIC SMALL HIGH ZAIN;Mn;230;NSM;;;;;N;;;;;
0618;ARABIC SMALL FATHA;Mn;30;NSM;;;;;N;;;;;
0619;ARABIC SMALL DAMMA;Mn;31;NSM;;;;;N;;;;;
061A;ARABIC SMALL KASRA;Mn;32;NSM;;;;;N;;;;;
061B;ARABIC SEMICOLON;Po;0;AL;;;;;N;;;;;
061C;ARABIC LETTER MARK;Cf;0;AL;;;;;N;;;;;
061D;ARABIC END OF TEXT MARK;Po;0;AL;;;;;N;;;;;
061E;ARABIC TRIPLE DOT PUNCTUATION MARK;Po;0;AL;;;;;N;;;;;
061F;ARABIC QUESTION MARK;Po;0;AL;;;;;N;;;;;
0620;ARABIC LETTER KASHMIRI YEH;Lo;0;AL;;;;;N;;;;;
0621;ARABIC LETTER HAMZA;Lo;0;AL;;;;;N;ARABIC LETTER HAMZAH;;;;
0622;ARABIC LETTER ALEF WITH MADDA ABOVE;Lo;0;AL;0627 0653;;;;N;ARABIC LETTER MADDAH ON ALEF;;;;
0623;ARABIC LETTER ALEF WITH HAMZA ABOVE;Lo;0;AL;0627 0654;;;;N;ARABIC LETTER HAMZAH ON ALEF;;;;
0624;ARABIC LETTER WAW WITH HAMZA ABOVE;Lo;0;AL;0648 0654;;;;N;ARABIC LETTER HAMZAH ON WAW;;;;
0625;ARABIC LETTER ALEF WITH HAMZA BELOW;Lo;0;AL;0627 0655;;;;N;ARABIC LETTER HAMZAH UNDER ALEF;;;;
0626;ARABIC LETTER YEH WITH HAMZA ABOVE;Lo;0;AL;064A 0654;;;;N;ARABIC LETTER HAMZAH ON YA;;;;
0627;ARABIC LETTER ALEF;Lo;0;AL;;;;;N;;;;;
0628;ARABIC LETTER BEH;Lo;0;AL;;;;;N;ARABIC LETTER BAA;;;;
0629;ARABIC LETTER TEH MARBUTA;Lo;0;AL;;;;;N;ARABIC LETTER TAA MARBUTAH;;;;
062A;ARABIC LETTER TEH;Lo;0;AL;;;;;N;ARABIC LETTER TAA;;;;
062B;ARABIC LETTER THEH;Lo;0;AL;;;;;N;ARABIC LETTER THAA;;;;
062C;ARABIC LETTER JEEM;Lo;0;AL;;;;;N;;;;;
062D;ARABIC LETTER HAH;Lo;0;AL;;;;;N;ARABIC LETTER HAA;;;;
062E;ARABIC LETTER KHAH;Lo;0;AL;;;;;N;ARABIC LETTER KHAA;;;;
062F;ARABIC LETTER DAL;Lo;0;AL;;;;;N;;;;;
0630;ARABIC LETTER THAL;Lo;0;AL;;;;;N;;;;;
0631;ARABIC LETTER REH;Lo;0;AL;;;;;N;ARABIC LETTER RA;;;;
0632;ARABIC LETTER ZAIN;Lo;0;AL;;;;;N;;;;;
0633;ARABIC LETTER SEEN;Lo;0;AL;;;;;N;;;;;
0634;ARABIC LETTER SHEEN;Lo;0;AL;;;;;N;;;;;
0635;ARABIC LETTER SAD;Lo;0;AL;;;;;N;;;;;
0636;ARABIC LETTER DAD;Lo;0;AL;;;;;N;;;;;
0637;ARABIC LETTER TAH;Lo;0;AL;;;;;N;;;;;
0638;ARABIC LETTER ZAH;Lo;0;AL;;;;;N;ARABIC LETTER DHAH;;;;
0639;ARABIC LETTER AIN;Lo;0;AL;;;;;N;;;;;
063A;ARABIC LETTER GHAIN;Lo;0;AL;;;;;N;;;;;
063B;ARABIC LETTER KEHEH WITH TWO DOTS ABOVE;Lo;0;AL;;;;;N;;;;;
063C;ARABIC LETTER KEHEH WITH THREE DOTS BELOW;Lo;0;AL;;;;;N;;;;;
063D;ARABIC LETTER FARSI YEH WITH INVERTED V;Lo;0;AL;;;;;N;;;;;
063E;ARABIC LETTER FARSI YEH WITH TWO DOTS ABOVE;Lo;0;AL;;;;;N;;;;;
063F;ARABIC LETTER FARSI YEH WITH THREE DOTS ABOVE;Lo;0;AL;;;;;N;;;;;
0640;ARABIC TATWEEL;Lm;0;AL;;;;;N;;;;;
0641;ARABIC LETTER FEH;Lo;0;AL;;;;;N;ARABIC LETTER FA;;;;
0642;ARABIC LETTER QAF;Lo;0;AL;;;;;N;;;;;
0643;ARABIC LETTER KAF;Lo;0;AL;;;;;N;ARABIC LETTER CAF;;;;
0644;ARABIC LETTER LAM;Lo;0;AL;;;;;N;;;;;
0645;ARABIC LETTER MEEM;Lo;0;AL;;;;;N;;;;;
0646;ARABIC LETTER NOON;Lo;0;AL;;;;;N;;;;;
0647;ARABIC LETTER HEH;Lo;0;AL;;;;;N;ARABIC LETTER HA;;;;
0648;ARABIC LETTER WAW;Lo;0;AL;;;;;N;;;;;
0649;ARABIC LETTER ALEF MAKSURA;Lo;0;AL;;;;;N;ARABIC LETTER ALEF MAQSURAH;;;;
064A;ARABIC LETTER YEH;Lo;0;AL;;;;;N;ARABIC LETTER YA;;;;
064B;ARABIC FATHATAN;Mn;27;NSM;;;;;N;;;;;
064C;ARABIC DAMMATAN;Mn;28;NSM;;;;;N;;;;;
064D;ARABIC KASRATAN;Mn;29;NSM;;;;;N;;;;;
064E;ARABIC FATHA;Mn;30;NSM;;;;;N;ARABIC FATHAH;;;;
064F;ARABIC DAMMA;Mn;31;NSM;;;;;N;ARABIC DAMMAH;;;;
0650;ARABIC KASRA;Mn;32;NSM;;;;;N;ARABIC KASRAH;;;;
0651;ARABIC SHADDA;Mn;33;NSM;;;;;N;ARABIC SHADDAH;;;;
0652;ARABIC SUKUN;Mn;34;NSM;;;;;N;;;;;
0653;ARABIC MADDAH ABOVE;Mn;230;NSM;;;;;N;;;;;
0654;ARABIC HAMZA ABOVE;Mn;230;NSM;;;;;N;;;;;
0655;ARABIC HAMZA BELOW;Mn;220;NSM;;;;;N;;;;;
0656;ARABIC SUBSCRIPT ALEF;Mn;220;NSM;;;;;N;;;;;
0657;ARABIC INVERTED DAMMA;Mn;230;NSM;;;;;N;;;;;
0658;ARABIC MARK NOON GHUNNA;Mn;230;NSM;;;;;N;;;;;
0659;ARABIC ZWARAKAY;Mn;230;NSM;;;;;N;;;;;
065A;ARABIC VOWEL SIGN SMALL V ABOVE;Mn;230;NSM;;;;;N;;;;;
065B;ARABIC VOWEL SIGN INVERTED SMALL V ABOVE;Mn;230;NSM;;;;;N;;;;;
065C;ARABIC VOWEL SIGN DOT BELOW;Mn;220;NSM;;;;;N;;;;;
065D;ARABIC REVERSED DAMMA;Mn;230;NSM;;;;;N;;;;;
065E;ARABIC FATHA WITH TWO DOTS;Mn;230;NSM;;;;;N;;;;;
065F;ARABIC WAVY HAMZA BELOW;Mn;220;NSM;;;;;N;;;;;
0660;ARABIC-INDIC DIGIT ZERO;Nd;0;AN;;0;0;0;N;;;;;
0661;ARABIC-INDIC DIGIT ONE;Nd;0;AN;;1;1;1;N;;;;;
0662;ARABIC-INDIC DIGIT TWO;Nd;0;AN;;2;2;2;N;;;;;
0663;ARABIC-INDIC DIGIT THREE;Nd;0;AN;;3;3;3;N;;;;;
0664;ARABIC-INDIC DIGIT FOUR;Nd;0;AN;;4;4;4;N;;;;;
0665;ARABIC-INDIC DIGIT FIVE;Nd;0;AN;;5;5;5;N;;;;;
0666;ARABIC-INDIC DIGIT SIX;Nd;0;AN;;6;6;6;N;;;;;
0667;ARABIC-INDIC DIGIT SEVEN;Nd;0;AN;;7;7;7;N;;;;;
0668;ARABIC-INDIC DIGIT EIGHT;Nd;0;AN;;8;8;8;N;;;;;
0669;ARABIC-INDIC DIGIT NINE;Nd;0;AN;;9;9;9;N;;;;;
066A;ARABIC PERCENT SIGN;Po;0;ET;;;;;N;;;;;
066B;ARABIC DECIMAL SEPARATOR;Po;0;AN;;;;;N;;;;;
066C;ARABIC THOUSANDS SEPARATOR;Po;0;AN;;;;;N;;;;;
066D;ARABIC FIVE POINTED STAR;Po;0;AL;;;;;N;;;;;
066E;ARABIC LETTER DOTLESS BEH;Lo;0;AL;;;;;N;;;;;
066F;ARABIC LETTER DOTLESS QAF;Lo;0;AL;;;;;N;;;;;
0670;ARABIC LETTER SUPERSCRIPT ALEF;Mn;35;NSM;;;;;N;ARABIC ALEF ABOVE;;;;
0671;ARABIC LETTER ALEF WASLA;Lo;0;AL;;;;;N;ARABIC LETTER HAMZAT WASL ON ALEF;;;;
0672;ARABIC LETTER ALEF WITH WAVY HAMZA ABOVE;Lo;0;AL;;;;;N;ARABIC LETTER WAVY HAMZAH ON ALEF;;;;
0673;ARABIC LETTER ALEF WITH WAVY HAMZA BELOW;Lo;0;AL;;;;;N;ARABIC LETTER WAVY HAMZAH UNDER ALEF;;;;
0674;ARABIC LETTER HIGH HAMZA;Lo;0;AL;;;;;N;ARABIC LETTER HIGH HAMZAH;;;;
0675;ARABIC LETTER HIGH HAMZA ALEF;Lo;0;AL;<compat> 0627 0674;;;;N;ARABIC LETTER HIGH HAMZAH ALEF;;;;
0676;ARABIC LETTER HIGH HAMZA WAW;Lo;0;AL;<compat> 0648 0674;;;;N;ARABIC LETTER HIGH HAMZAH WAW;;;;
0677;ARABIC LETTER U WITH HAMZA ABOVE;Lo;0;AL;<compat> 06C7 0674;;;;N;ARABIC LETTER HIGH HAMZAH WAW WITH DAMMAH;;;;
0678;ARABIC LETTER HIGH HAMZA YEH;Lo;0;AL;<compat> 064A 0674;;;;N;ARABIC LETTER HIGH HAMZAH YA;;;;
0679;ARABIC LETTER TTEH;Lo;0;AL;;;;;N;ARABIC LETTER TAA WITH SMALL TAH;;;;
067A;ARABIC LETTER TTEHEH;Lo;0;AL;;;;;N;ARABIC LETTER TAA WITH TWO DOTS VERTICAL ABOVE;;;;
067B;ARABIC LETTER BEEH;Lo;0;AL;;;;;N;ARABIC LETTER BAA WITH TWO DOTS VERTICAL BELOW;;;;
067C;ARABIC LETTER TEH WITH RING;Lo;0;AL;;;;;N;ARABIC LETTER TAA WITH RING;;;;
067D;ARABIC LETTER TEH WITH THREE DOTS ABOVE DOWNWARDS;Lo;0;AL;;;;;N;ARABIC LETTER TAA WITH THREE DOTS ABOVE DOWNWARD;;;;
067E;ARABIC LETTER PEH;Lo;0;AL;;;;;N;ARABIC LETTER TAA WITH THREE DOTS BELOW;;;;
067F;ARABIC LETTER TEHEH;Lo;0;AL;;;;;N;ARABIC LETTER TAA WITH FOUR DOTS ABOVE;;;;
0680;ARABIC LETTER BEHEH;Lo;0;AL;;;;;N;ARABIC LETTER BAA WITH FOUR DOTS BELOW;;;;
0681;ARABIC LETTER HAH WITH HAMZA ABOVE;Lo;0;AL;;;;;N;ARABIC LETTER HAMZAH ON HAA;;;;
0682;ARABIC LETTER HAH WITH TWO DOTS VERTICAL ABOVE;Lo;0;AL;;;;;N;ARABIC LETTER HAA WITH TWO DOTS VERTICAL ABOVE;;;;
0683;ARABIC LETTER NYEH;Lo;0;AL;;;;;N;ARABIC LETTER HAA WITH MIDDLE TWO DOTS;;;;
0684;ARABIC LETTER DYEH;Lo;0;AL;;;;;N;ARABIC LETTER HAA WITH MIDDLE TWO DOTS VERTICAL;;;;
0685;ARABIC LETTER HAH WITH THREE DOTS ABOVE;Lo;0;AL;;;;;N;ARABIC LETTER HAA WITH THREE DOTS ABOVE;;;;
0686;ARABIC LETTER TCHEH;Lo;0;AL;;;;;N;ARABIC LETTER HAA WITH MIDDLE THREE DOTS DOWNWARD;;;;
0687;ARABIC LETTER TCHEHEH;Lo;0;AL;;;;;N;ARABIC LETTER HAA WITH MIDDLE FOUR DOTS;;;;
0688;ARABIC LETTER DDAL;Lo;0;AL;;;;;N;ARABIC LETTER DAL WITH SMALL TAH;;;;
0689;ARABIC LETTER DAL WITH RING;Lo;0;AL;;;;;N;;;;;
068A;ARABIC LETTER DAL WITH DOT BELOW;Lo;0;AL;;;;;N;;;;;
068B;ARABIC LETTER DAL WITH DOT BELOW AND SMALL TAH;Lo;0;AL;;;;;N;;;;;
068C;ARABIC LETTER DAHAL;Lo;0;AL;;;;;N;ARABIC LETTER DAL WITH TWO DOTS ABOVE;;;;
068D;ARABIC LETTER DDAHAL;Lo;0;AL;;;;;N;ARABIC LETTER DAL WITH TWO DOTS BELOW;;;;
068E;ARABIC LETTER DUL;Lo;0;AL;;;;;N;ARABIC LETTER DAL WITH THREE DOTS ABOVE;;;;
068F;ARABIC LETTER DAL WITH THREE DOTS ABOVE DOWNWARDS;Lo;0;AL;;;;;N;ARABIC LETTER DAL WITH THREE DOTS ABOVE DOWNWARD;;;;
0690;ARABIC LETTER DAL WITH FOUR DOTS ABOVE;Lo;0;AL;;;;;N;;;;;
0691;ARABIC LETTER RREH;Lo;0;AL;;;;;N;ARABIC LETTER RA WITH SMALL TAH;;;;
0692;ARABIC LETTER REH WITH SMALL V;Lo;0;AL;;;;;N;ARABIC LETTER RA WITH SMALL V;;;;
0693;ARABIC LETTER REH WITH RING;Lo;0;AL;;;;;N;ARABIC LETTER RA WITH RING;;;;
0694;ARABIC LETTER REH WITH DOT BELOW;Lo;0;AL;;;;;N;ARABIC LETTER RA WITH DOT BELOW;;;;
0695;ARABIC LETTER REH WITH SMALL V BELOW;Lo;0;AL;;;;;N;ARABIC LETTER RA WITH SMALL V BELOW;;;;
0696;ARABIC LETTER REH WITH DOT BELOW AND DOT ABOVE;Lo;0;AL;;;;;N;ARABIC LETTER RA WITH DOT BELOW AND DOT ABOVE;;;;
0697;ARABIC LETTER REH WITH TWO DOTS ABOVE;Lo;0;AL;;;;;N;ARABIC LETTER RA WITH TWO DOTS ABOVE;;;;
0698;ARABIC LETTER JEH;Lo;0;AL;;;;;N;ARABIC LETTER RA WITH THREE DOTS ABOVE;;;;
0699;ARABIC LETTER REH WITH FOUR DOTS ABOVE;Lo;0;AL;;;;;N;ARABIC LETTER RA WITH FOUR DOTS ABOVE;;;;
069A;ARABIC LETTER SEEN WITH DOT BELOW AND DOT ABOVE;Lo;0;AL;;;;;N;;;;;
069B;ARABIC LETTER SEEN WITH THREE DOTS BELOW;Lo;0;AL;;;;;N;;;;;
069C;ARABIC LETTER SEEN WITH THREE DOTS BELOW AND THREE DOTS ABOVE;Lo;0;AL;;;;;N;;;;;
069D;ARABIC LETTER SAD WITH TWO DOTS BELOW;Lo;0;AL;;;;;N;;;;;
069E;ARABIC LETTER SAD WITH THREE DOTS ABOVE;Lo;0;AL;;;;;N;;;;;
069F;ARABIC LETTER TAH WITH THREE DOTS ABOVE;Lo;0;AL;;;;;N;;;;;
06A0;ARABIC LETTER AIN WITH THREE DOTS ABOVE;Lo;0;AL;;;;;N;;;;;
06A1;ARABIC LETTER DOTLESS FEH;Lo;0;AL;;;;;N;ARABIC LETTER DOTLESS FA;;;;
06A2;ARABIC LETTER FEH WITH DOT MOVED BELOW;Lo;0;AL;;;;;N;ARABIC LETTER FA WITH DOT MOVED BELOW;;;;
06A3;ARABIC LETTER FEH WITH DOT BELOW;Lo;0;AL;;;;;N;ARABIC LETTER FA WITH DOT BELOW;;;;
06A4;ARABIC LETTER VEH;Lo;0;AL;;;;;N;ARABIC LETTER FA WITH THREE DOTS ABOVE;;;;
06A5;ARABIC LETTER FEH WITH THREE DOTS BELOW;Lo;0;AL;;;;;N;ARABIC LETTER FA WITH THREE DOTS BELOW;;;;
06A6;ARABIC LETTER PEHEH;Lo;0;AL;;;;;N;ARABIC LETTER FA WITH FOUR DOTS ABOVE;;;;
06A7;ARABIC LETTER QAF WITH DOT ABOVE;Lo;0;AL;;;;;N;;;;;
06A8;ARABIC LETTER QAF WITH THREE DOTS ABOVE;Lo;0;AL;;;;;N;;;;;
06A9;ARABIC LETTER KEHEH;Lo;0;AL;;;;;N;ARABIC LETTER OPEN CAF;;;;
06AA;ARABIC LETTER SWASH KAF;Lo;0;AL;;;;;N;ARABIC LETTER SWASH CAF;;;;
06AB;ARABIC LETTER KAF WITH RING;Lo;0;AL;;;;;N;ARABIC LETTER CAF WITH RING;;;;
06AC;ARABIC LETTER KAF WITH DOT ABOVE;Lo;0;AL;;;;;N;ARABIC LETTER CAF WITH DOT ABOVE;;;;
06AD;ARABIC LETTER NG;Lo;0;AL;;;;;N;ARABIC LETTER CAF WITH THREE DOTS ABOVE;;;;
06AE;ARABIC LETTER KAF WITH THREE DOTS BELOW;Lo;0;AL;;;;;N;ARABIC LETTER CAF WITH THREE DOTS BELOW;;;;
06AF;ARABIC LETTER GAF;Lo;0;AL;;;;;N;;;;;
06B0;ARABIC LETTER GAF WITH RING;Lo;0;AL;;;;;N;;;;;
06B1;ARABIC LETTER NGOEH;Lo;0;AL;;;;;N;ARABIC LETTER GAF WITH TWO DOTS ABOVE;;;;
06B2;ARABIC LETTER GAF WITH TWO DOTS BELOW;Lo;0;AL;;;;;N;;;;;
06B3;ARABIC LETTER GUEH;Lo;0;AL;;;;;N;ARABIC LETTER GAF WITH TWO DOTS VERTICAL BELOW;;;;
06B4;ARABIC LETTER GAF WITH THREE DOTS ABOVE;Lo;0;AL;;;;;N;;;;;
06B5;ARABIC LETTER LAM WITH SMALL V;Lo;0;AL;;;;;N;;;;;
06B6;ARABIC LETTER LAM WITH DOT ABOVE;Lo;0;AL;;;;;N;;;;;
06B7;ARABIC LETTER LAM WITH THREE DOTS ABOVE;Lo;0;AL;;;;;N;;;;;
06B8;ARABIC LETTER LAM WITH THREE DOTS BELOW;Lo;0;AL;;;;;N;;;;;
06B9;ARABIC LETTER NOON WITH DOT BELOW;Lo;0;AL;;;;;N;;;;;
06BA;ARABIC LETTER NOON GHUNNA;Lo;0;AL;;;;;N;ARABIC LETTER DOTLESS NOON;;;;
06BB;ARABIC LETTER RNOON;Lo;0;AL;;;;;N;ARABIC LETTER DOTLESS NOON WITH SMALL TAH;;;;
06BC;ARABIC LETTER NOON WITH RING;Lo;0;AL;;;;;N;;;;;
06BD;ARABIC LETTER NOON WITH THREE DOTS ABOVE;Lo;0;AL;;;;;N;;;;;
06BE;ARABIC LETTER HEH DOACHASHMEE;Lo;0;AL;;;;;N;ARABIC LETTER KNOTTED HA;;;;
06BF;ARABIC LETTER TCHEH WITH DOT ABOVE;Lo;0;AL;;;;;N;;;;;
06C0;ARABIC LETTER HEH WITH YEH ABOVE;Lo;0;AL;06D5 0654;;;;N;ARABIC LETTER HAMZAH ON HA;;;;
06C1;ARABIC LETTER HEH GOAL;Lo;0;AL;;;;;N;ARABIC LETTER HA GOAL;;;;
06C2;ARABIC LETTER HEH GOAL WITH HAMZA ABOVE;Lo;0;AL;06C1 0654;;;;N;ARABIC LETTER HAMZAH ON HA GOAL;;;;
06C3;ARABIC LETTER TEH MARBUTA GOAL;Lo;0;AL;;;;;N;ARABIC LETTER TAA MARBUTAH GOAL;;;;
06C4;ARABIC LETTER WAW WITH RING;Lo;0;AL;;;;;N;;;;;
06C5;ARABIC LETTER KIRGHIZ OE;Lo;0;AL;;;;;N;ARABIC LETTER WAW WITH BAR;;;;
06C6;ARABIC LETTER OE;Lo;0;AL;;;;;N;ARABIC LETTER WAW WITH SMALL V;;;;
06C7;ARABIC LETTER U;Lo;0;AL;;;;;N;ARABIC LETTER WAW WITH DAMMAH;;;;
06C8;ARABIC LETTER YU;Lo;0;AL;;;;;N;ARABIC LETTER WAW WITH ALEF ABOVE;;;;
06C9;ARABIC LETTER KIRGHIZ YU;Lo;0;AL;;;;;N;ARABIC LETTER WAW WITH INVERTED SMALL V;;;;
06CA;ARABIC LETTER WAW WITH TWO DOTS ABOVE;Lo;0;AL;;;;;N;;;;;
06CB;ARABIC LETTER VE;Lo;0;AL;;;;;N;ARABIC LETTER WAW WITH THREE DOTS ABOVE;;;;
06CC;ARABIC LETTER FARSI YEH;Lo;0;AL;;;;;N;ARABIC LETTER DOTLESS YA;;;;
06CD;ARABIC LETTER YEH WITH TAIL;Lo;0;AL;;;;;N;ARABIC LETTER YA WITH TAIL;;;;
06CE;ARABIC LETTER YEH WITH SMALL V;Lo;0;AL;;;;;N;ARABIC LETTER YA WITH SMALL V;;;;
06CF;ARABIC LETTER WAW WITH DOT ABOVE;Lo;0;AL;;;;;N;;;;;
06D0;ARABIC LETTER E;Lo;0;AL;;;;;N;ARABIC LETTER YA WITH TWO DOTS VERTICAL BELOW;;;;
06D1;ARABIC LETTER YEH WITH THREE DOTS BELOW;Lo;0;AL;;;;;N;ARABIC LETTER YA WITH THREE DOTS BELOW;;;;
06D2;ARABIC LETTER YEH BARREE;Lo;0;AL;;;;;N;ARABIC LETTER YA BARREE;;;;
06D3;ARABIC LETTER YEH BARREE WITH HAMZA ABOVE;Lo;0;AL;06D2 0654;;;;N;ARABIC LETTER HAMZAH ON YA BARREE;;;;
06D4;ARABIC FULL STOP;Po;0;AL;;;;;N;ARABIC PERIOD;;;;
06D5;ARABIC LETTER AE;Lo;0;AL;;;;;N;;;;;
06D6;ARABIC SMALL HIGH LIGATURE SAD WITH LAM WITH ALEF MAKSURA;Mn;230;NSM;;;;;N;;;;;
06D7;ARABIC SMALL HIGH LIGATURE QAF WITH LAM WITH ALEF MAKSURA;Mn;230;NSM;;;;;N;;;;;
06D8;ARABIC SMALL HIGH MEEM INITIAL FORM;Mn;230;NSM;;;;;N;;;;;
06D9;ARABIC SMALL HIGH LAM ALEF;Mn;230;NSM;;;;;N;;;;;
06DA;ARABIC SMALL HIGH JEEM;Mn;230;NSM;;;;;N;;;;;
06DB;ARABIC SMALL HIGH THREE DOTS;Mn;230;NSM;;;;;N;;;;;
06DC;ARABIC SMALL HIGH SEEN;Mn;230;NSM;;;;;N;;;;;
06DD;ARABIC END OF AYAH;Cf;0;AN;;;;;N;;;;;
06DE;ARABIC START OF RUB EL HIZB;So;0;ON;;;;;N;;;;;
06DF;ARABIC SMALL HIGH ROUNDED ZERO;Mn;230;NSM;;;;;N;;;;;
06E0;ARABIC SMALL HIGH UPRIGHT RECTANGULAR ZERO;Mn;230;NSM;;;;;N;;;;;
06E1;ARABIC SMALL HIGH DOTLESS HEAD OF KHAH;Mn;230;NSM;;;;;N;;;;;
06E2;ARABIC SMALL HIGH MEEM ISOLATED FORM;Mn;230;NSM;;;;;N;;;;;
06E3;ARABIC SMALL LOW SEEN;Mn;220;NSM;;;;;N;;;;;
06E4;ARABIC SMALL HIGH MADDA;Mn;230;NSM;;;;;N;;;;;
06E5;ARABIC SMALL WAW;Lm;0;AL;;;;;N;;;;;
06E6;ARABIC SMALL YEH;Lm;0;AL;;;;;N;;;;;
06E7;ARABIC SMALL HIGH YEH;Mn;230;NSM;;;;;N;;;;;
06E8;ARABIC SMALL HIGH NOON;Mn;230;NSM;;;;;N;;;;;
06E9;ARABIC PLACE OF SAJDAH;So;0;ON;;;;;N;;;;;
06EA;ARABIC EMPTY CENTRE LOW STOP;Mn;220;NSM;;;;;N;;;;;
06EB;ARABIC EMPTY CENTRE HIGH STOP;Mn;230;NSM;;;;;N;;;;;
06EC;ARABIC ROUNDED HIGH STOP WITH FILLED CENTRE;Mn;230;NSM;;;;;N;;;;;
06ED;ARABIC SMALL LOW MEEM;Mn;220;NSM;;;;;N;;;;;
06EE;ARABIC LETTER DAL WITH INVERTED V;Lo;0;AL;;;;;N;;;;;
06EF;ARABIC LETTER REH WITH INVERTED V;Lo;0;AL;;;;;N;;;;;
06F0;EXTENDED ARABIC-INDIC DIGIT ZERO;Nd;0;EN;;0;0;0;N;EASTERN ARABIC-INDIC DIGIT ZERO;;;;
06F1;EXTENDED ARABIC-INDIC DIGIT ONE;Nd;0;EN;;1;1;1;N;EASTERN ARABIC-INDIC DIGIT ONE;;;;
06F2;EXTENDED ARABIC-INDIC DIGIT TWO;Nd;0;EN;;2;2;2;N;EASTERN ARABIC-INDIC DIGIT TWO;;;;
06F3;EXTENDED ARABIC-INDIC DIGIT THREE;Nd;0;EN;;3;3;3;N;EASTERN ARABIC-INDIC DIGIT THREE;;;;
06F4;EXTENDED ARABIC-INDIC DIGIT FOUR;Nd;0;EN;;4;4;4;N;EASTERN ARABIC-INDIC DIGIT FOUR;;;;
06F5;EXTENDED ARABIC-INDIC DIGIT FIVE;Nd;0;EN;;5;5;5;N;EASTERN ARABIC-INDIC DIGIT FIVE;;;;
06F6;EXTENDED ARABIC-INDIC DIGIT SIX;Nd;0;EN;;6;6;6;N;EASTERN ARABIC-INDIC DIGIT SIX;;;;
06F7;EXTENDED ARABIC-INDIC DIGIT SEVEN;Nd;0;EN;;7;7;7;N;EASTERN ARABIC-INDIC DIGIT SEVEN;;;;
06F8;EXTENDED ARABIC-INDIC DIGIT EIGHT;Nd;0;EN;;8;8;8;N;EASTERN ARABIC-INDIC DIGIT EIGHT;;;;
06F9;EXTENDED ARABIC-INDIC DIGIT NINE;Nd;0;EN;;9;9;9;N;EASTERN ARABIC-INDIC DIGIT NINE;;;;
06FA;ARABIC LETTER SHEEN WITH DOT BELOW;Lo;0;AL;;;;;N;;;;;
06FB;ARABIC LETTER DAD WITH DOT BELOW;Lo;0;AL;;;;;N;;;;;
06FC;ARABIC LETTER GHAIN WITH DOT BELOW;Lo;0;AL;;;;;N;;;;;
06FD;ARABIC SIGN SINDHI AMPERSAND;So;0;AL;;;;;N;;;;;
06FE;ARABIC SIGN SINDHI POSTPOSITION MEN;So;0;AL;;;;;N;;;;;
06FF;ARABIC LETTER HEH WITH INVERTED V;Lo;0;AL;;;;;N;;;;;
0700;SYRIAC END OF PARAGRAPH;Po;0;AL;;;;;N;;;;;
0701;SYRIAC SUPRALINEAR FULL STOP;Po;0;AL;;;;;N;;;;;
0702;SYRIAC SUBLINEAR FULL STOP;Po;0;AL;;;;;N;;;;;
0703;SYRIAC SUPRALINEAR COLON;Po;0;AL;;;;;N;;;;;
0704;SYRIAC SUBLINEAR COLON;Po;0;AL;;;;;N;;;;;
0705;SYRIAC HORIZONTAL COLON;Po;0;AL;;;;;N;;;;;
0706;SYRIAC COLON SKEWED LEFT;Po;0;AL;;;;;N;;;;;
0707;SYRIAC COLON SKEWED RIGHT;Po;0;AL;;;;;N;;;;;
0708;SYRIAC SUPRALINEAR COLON SKEWED LEFT;Po;0;AL;;;;;N;;;;;
0709;SYRIAC SUBLINEAR COLON SKEWED RIGHT;Po;0;AL;;;;;N;;;;;
070A;SYRIAC CONTRACTION;Po;0;AL;;;;;N;;;;;
070B;SYRIAC HARKLEAN OBELUS;Po;0;AL;;;;;N;;;;;
070C;SYRIAC HARKLEAN METOBELUS;Po;0;AL;;;;;N;;;;;
070D;SYRIAC HARKLEAN ASTERISCUS;Po;0;AL;;;;;N;;;;;
070F;SYRIAC ABBREVIATION MARK;Cf;0;AL;;;;;N;;;;;
0710;SYRIAC LETTER ALAPH;Lo;0;AL;;;;;N;;;;;
0711;SYRIAC LETTER SUPERSCRIPT ALAPH;Mn;36;NSM;;;;;N;;;;;
0712;SYRIAC LETTER BETH;Lo;0;AL;;;;;N;;;;;
0713;SYRIAC LETTER GAMAL;Lo;0;AL;;;;;N;;;;;
0714;SYRIAC LETTER GAMAL GARSHUNI;Lo;0;AL;;;;;N;;;;;
0715;SYRIAC LETTER DALATH;Lo;0;AL;;;;;N;;;;;
0716;SYRIAC LETTER DOTLESS DALATH RISH;Lo;0;AL;;;;;N;;;;;
0717;SYRIAC LETTER HE;Lo;0;AL;;;;;N;;;;;
0718;SYRIAC LETTER WAW;Lo;0;AL;;;;;N;;;;;
0719;SYRIAC LETTER ZAIN;Lo;0;AL;;;;;N;;;;;
071A;SYRIAC LETTER HETH;Lo;0;AL;;;;;N;;;;;
071B;SYRIAC LETTER TETH;Lo;0;AL;;;;;N;;;;;
071C;SYRIAC LETTER TETH GARSHUNI;Lo;0;AL;;;;;N;;;;;
071D;SYRIAC LETTER YUDH;Lo;0;AL;;;;;N;;;;;
071E;SYRIAC LETTER YUDH HE;Lo;0;AL;;;;;N;;;;;
071F;SYRIAC LETTER KAPH;Lo;0;AL;;;;;N;;;;;
0720;SYRIAC LETTER LAMADH;Lo;0;AL;;;;;N;;;;;
0721;SYRIAC LETTER MIM;Lo;0;AL;;;;;N;;;;;
0722;SYRIAC LETTER NUN;Lo;0;AL;;;;;N;;;;;
0723;SYRIAC LETTER SEMKATH;Lo;0;AL;;;;;N;;;;;
0724;SYRIAC LETTER FINAL SEMKATH;Lo;0;AL;;;;;N;;;;;
0725;SYRIAC LETTER E;Lo;0;AL;;;;;N;;;;;
0726;SYRIAC LETTER PE;Lo;0;AL;;;;;N;;;;;
0727;SYRIAC LETTER REVERSED PE;Lo;0;AL;;;;;N;;;;;
0728;SYRIAC LETTER SADHE;Lo;0;AL;;;;;N;;;;;
0729;SYRIAC LETTER QAPH;Lo;0;AL;;;;;N;;;;;
072A;SYRIAC LETTER RISH;Lo;0;AL;;;;;N;;;;;
072B;SYRIAC LETTER SHIN;Lo;0;AL;;;;;N;;;;;
072C;SYRIAC LETTER TAW;Lo;0;AL;;;;;N;;;;;
072D;SYRIAC LETTER PERSIAN BHETH;Lo;0;AL;;;;;N;;;;;
072E;SYRIAC LETTER PERSIAN GHAMAL;Lo;0;AL;;;;;N;;;;;
072F;SYRIAC LETTER PERSIAN DHALATH;Lo;0;AL;;;;;N;;;;;
0730;SYRIAC PTHAHA ABOVE;Mn;230;NSM;;;;;N;;;;;
0731;SYRIAC PTHAHA BELOW;Mn;220;NSM;;;;;N;;;;;
0732;SYRIAC PTHAHA DOTTED;Mn;230;NSM;;;;;N;;;;;
0733;SYRIAC ZQAPHA ABOVE;Mn;230;NSM;;;;;N;;;;;
0734;SYRIAC ZQAPHA BELOW;Mn;220;NSM;;;;;N;;;;;
0735;SYRIAC ZQAPHA DOTTED;Mn;230;NSM;;;;;N;;;;;
0736;SYRIAC RBASA ABOVE;Mn;230;NSM;;;;;N;;;;;
0737;SYRIAC RBASA BELOW;Mn;220;NSM;;;;;N;;;;;
0738;SYRIAC DOTTED ZLAMA HORIZONTAL;Mn;220;NSM;;;;;N;;;;;
0739;SYRIAC DOTTED ZLAMA ANGULAR;Mn;220;NSM;;;;;N;;;;;
073A;SYRIAC HBASA ABOVE;Mn;230;NSM;;;;;N;;;;;
073B;SYRIAC HBASA BELOW;Mn;220;NSM;;;;;N;;;;;
073C;SYRIAC HBASA-ESASA DOTTED;Mn;220;NSM;;;;;N;;;;;
073D;SYRIAC ESASA ABOVE;Mn;230;NSM;;;;;N;;;;;
073E;SYRIAC ESASA BELOW;Mn;220;NSM;;;;;N;;;;;
073F;SYRIAC RWAHA;Mn;230;NSM;;;;;N;;;;;
0740;SYRIAC FEMININE DOT;Mn;230;NSM;;;;;N;;;;;
0741;SYRIAC QUSHSHAYA;Mn;230;NSM;;;;;N;;;;;
0742;SYRIAC RUKKAKHA;Mn;220;NSM;;;;;N;;;;;
0743;SYRIAC TWO VERTICAL DOTS ABOVE;Mn;230;NSM;;;;;N;;;;;
0744;SYRIAC TWO VERTICAL DOTS BELOW;Mn;220;NSM;;;;;N;;;;;
0745;SYRIAC THREE DOTS ABOVE;Mn;230;NSM;;;;;N;;;;;
0746;SYRIAC THREE DOTS BELOW;Mn;220;NSM;;;;;N;;;;;
0747;SYRIAC OBLIQUE LINE ABOVE;Mn;230;NSM;;;;;N;;;;;
0748;SYRIAC OBLIQUE LINE BELOW;Mn;220;NSM;;;;;N;;;;;
0749;SYRIAC MUSIC;Mn;230;NSM;;;;;N;;;;;
074A;SYRIAC BARREKH;Mn;230;NSM;;;;;N;;;;;
074D;SYRIAC LETTER SOGDIAN ZHAIN;Lo;0;AL;;;;;N;;;;;
074E;SYRIAC LETTER SOGDIAN KHAPH;Lo;0;AL;;;;;N;;;;;
074F;SYRIAC LETTER SOGDIAN FE;Lo;0;AL;;;;;N;;;;;
0750;ARABIC LETTER BEH WITH THREE DOTS HORIZONTALLY BELOW;Lo;0;AL;;;;;N;;;;;
0751;ARABIC LETTER BEH WITH DOT BELOW AND THREE DOTS ABOVE;Lo;0;AL;;;;;N;;;;;
0752;ARABIC LETTER BEH WITH THREE DOTS POINTING UPWARDS BELOW;Lo;0;AL;;;;;N;;;;;
0753;ARABIC LETTER BEH WITH THREE DOTS POINTING UPWARDS BELOW AND TWO DOTS ABOVE;Lo;0;AL;;;;;N;;;;;
0754;ARABIC LETTER BEH WITH TWO DOTS BELOW AND DOT ABOVE;Lo;0;AL;;;;;N;;;;;
0755;ARABIC LETTER BEH WITH INVERTED SMALL V BELOW;Lo;0;AL;;;;;N;;;;;
0756;ARABIC LETTER BEH WITH SMALL V;Lo;0;AL;;;;;N;;;;;
0757;ARABIC LETTER HAH WITH TWO DOTS ABOVE;Lo;0;AL;;;;;N;;;;;
0758;ARABIC LETTER HAH WITH THREE DOTS POINTING UPWARDS BELOW;Lo;0;AL;;;;;N;;;;;
0759;ARABIC LETTER DAL WITH TWO DOTS VERTICALLY BELOW AND SMALL TAH;Lo;0;AL;;;;;N;;;;;
075A;ARABIC LETTER DAL WITH INVERTED SMALL V BELOW;Lo;0;AL;;;;;N;;;;;
075B;ARABIC LETTER REH WITH STROKE;Lo;0;AL;;;;;N;;;;;
075C;ARABIC LETTER SEEN WITH FOUR DOTS ABOVE;Lo;0;AL;;;;;N;;;;;
075D;ARABIC LETTER AIN WITH TWO DOTS ABOVE;Lo;0;AL;;;;;N;;;;;
075E;ARABIC LETTER AIN WITH THREE DOTS POINTING DOWNWARDS ABOVE;Lo;0;AL;;;;;N;;;;;
075F;ARABIC LETTER AIN WITH TWO DOTS VERTICALLY ABOVE;Lo;0;AL;;;;;N;;;;;
0760;ARABIC LETTER FEH WITH TWO DOTS BELOW;Lo;0;AL;;;;;N;;;;;
0761;ARABIC LETTER FEH WITH THREE DOTS POINTING UPWARDS BELOW;Lo;0;AL;;;;;N;;;;;
0762;ARABIC LETTER KEHEH WITH DOT ABOVE;Lo;0;AL;;;;;N;;;;;
0763;ARABIC LETTER KEHEH WITH THREE DOTS ABOVE;Lo;0;AL;;;;;N;;;;;
0764;ARABIC LETTER KEHEH WITH THREE DOTS POINTING UPWARDS BELOW;Lo;0;AL;;;;;N;;;;;
0765;ARABIC LETTER MEEM WITH DOT ABOVE;Lo;0;AL;;;;;N;;;;;
0766;ARABIC LETTER MEEM WITH DOT BELOW;Lo;0;AL;;;;;N;;;;;
0767;ARABIC LETTER NOON WITH TWO DOTS BELOW;Lo;0;AL;;;;;N;;;;;
0768;ARABIC LETTER NOON WITH SMALL TAH;Lo;0;AL;;;;;N;;;;;
0769;ARABIC LETTER NOON WITH SMALL V;Lo;0;AL;;;;;N;;;;;
076A;ARABIC LETTER LAM WITH BAR;Lo;0;AL;;;;;N;;;;;
076B;ARABIC LETTER REH WITH TWO DOTS VERTICALLY ABOVE;Lo;0;AL;;;;;N;;;;;
076C;ARABIC LETTER REH WITH HAMZA ABOVE;Lo;0;AL;;;;;N;;;;;
076D;ARABIC LETTER SEEN WITH TWO DOTS VERTICALLY ABOVE;Lo;0;AL;;;;;N;;;;;
076E;ARABIC LETTER HAH WITH SMALL ARABIC LETTER TAH BELOW;Lo;0;AL;;;;;N;;;;;
076F;ARABIC LETTER HAH WITH SMALL ARABIC LETTER TAH AND TWO DOTS;Lo;0;AL;;;;;N;;;;;
0770;ARABIC LETTER SEEN WITH SMALL ARABIC LETTER TAH AND TWO DOTS;Lo;0;AL;;;;;N;;;;;
0771;ARABIC LETTER REH WITH SMALL ARABIC LETTER TAH AND TWO DOTS;Lo;0;AL;;;;;N;;;;;
0772;ARABIC LETTER HAH WITH SMALL ARABIC LETTER TAH ABOVE;Lo;0;AL;;;;;N;;;;;
0773;ARABIC LETTER ALEF WITH EXTENDED ARABIC-INDIC DIGIT TWO ABOVE;Lo;0;AL;;;;;N;;;;;
0774;ARABIC LETTER ALEF WITH EXTENDED ARABIC-INDIC DIGIT THREE ABOVE;Lo;0;AL;;;;;N;;;;;
0775;ARABIC LETTER FARSI YEH WITH EXTENDED ARABIC-INDIC DIGIT TWO ABOVE;Lo;0;AL;;;;;N;;;;;
0776;ARABIC LETTER FARSI YEH WITH EXTENDED ARABIC-INDIC DIGIT THREE ABOVE;Lo;0;AL;;;;;N;;;;;
0777;ARABIC LETTER FARSI YEH WITH EXTENDED ARABIC-INDIC DIGIT FOUR BELOW;Lo;0;AL;;;;;N;;;;;
0778;ARABIC LETTER WAW WITH EXTENDED ARABIC-INDIC DIGIT TWO ABOVE;Lo;0;AL;;;;;N;;;;;
0779;ARABIC LETTER WAW WITH EXTENDED ARABIC-INDIC DIGIT THREE ABOVE;Lo;0;AL;;;;;N;;;;;
077A;ARABIC LETTER YEH BARREE WITH EXTENDED ARABIC-INDIC DIGIT TWO ABOVE;Lo;0;AL;;;;;N;;;;;
077B;ARABIC LETTER YEH BARREE WITH EXTENDED ARABIC-INDIC DIGIT THREE ABOVE;Lo;0;AL;;;;;N;;;;;
077C;ARABIC LETTER HAH WITH EXTENDED ARABIC-INDIC DIGIT FOUR BELOW;Lo;0;AL;;;;;N;;;;;
077D;ARABIC LETTER SEEN WITH EXTENDED ARABIC-INDIC DIGIT FOUR ABOVE;Lo;0;AL;;;;;N;;;;;
077E;ARABIC LETTER SEEN WITH INVERTED V;Lo;0;AL;;;;;N;;;;;
077F;ARABIC LETTER KAF WITH TWO DOTS ABOVE;Lo;0;AL;;;;;N;;;;;
0780;THAANA LETTER HAA;Lo;0;AL;;;;;N;;;;;
0781;THAANA LETTER SHAVIYANI;Lo;0;AL;;;;;N;;;;;
0782;THAANA LETTER NOONU;Lo;0;AL;;;;;N;;;;;
0783;THAANA LETTER RAA;Lo;0;AL;;;;;N;;;;;
0784;THAANA LETTER BAA;Lo;0;AL;;;;;N;;;;;
0785;THAANA LETTER LHAVIYANI;Lo;0;AL;;;;;N;;;;;
0786;THAANA LETTER KAAFU;Lo;0;AL;;;;;N;;;;;
0787;THAANA LETTER ALIFU;Lo;0;AL;;;;;N;;;;;
0788;THAANA LETTER VAAVU;Lo;0;AL;;;;;N;;;;;
0789;THAANA LETTER MEEMU;Lo;0;AL;;;;;N;;;;;
078A;THAANA LETTER FAAFU;Lo;0;AL;;;;;N;;;;;
078B;THAANA LETTER DHAALU;Lo;0;AL;;;;;N;;;;;
078C;THAANA LETTER THAA;Lo;0;AL;;;;;N;;;;;
078D;THAANA LETTER LAAMU;Lo;0;AL;;;;;N;;;;;
078E;THAANA LETTER GAAFU;Lo;0;AL;;;;;N;;;;;
078F;THAANA LETTER GNAVIYANI;Lo;0;AL;;;;;N;;;;;
0790;THAANA LETTER SEENU;Lo;0;AL;;;;;N;;;;;
0791;THAANA LETTER DAVIYANI;Lo;0;AL;;;;;N;;;;;
0792;THAANA LETTER ZAVIYANI;Lo;0;AL;;;;;N;;;;;
0793;THAANA LETTER TAVIYANI;Lo;0;AL;;;;;N;;;;;
0794;THAANA LETTER YAA;Lo;0;AL;;;;;N;;;;;
0795;THAANA LETTER PAVIYANI;Lo;0;AL;;;;;N;;;;;
0796;THAANA LETTER JAVIYANI;Lo;0;AL;;;;;N;;;;;
0797;THAANA LETTER CHAVIYANI;Lo;0;AL;;;;;N;;;;;
0798;THAANA LETTER TTAA;Lo;0;AL;;;;;N;;;;;
0799;THAANA LETTER HHAA;Lo;0;AL;;;;;N;;;;;
079A;THAANA LETTER KHAA;Lo;0;AL;;;;;N;;;;;
079B;THAANA LETTER THAALU;Lo;0;AL;;;;;N;;;;;
079C;THAANA LETTER ZAA;Lo;0;AL;;;;;N;;;;;
079D;THAANA LETTER SHEENU;Lo;0;AL;;;;;N;;;;;
079E;THAANA LETTER SAADHU;Lo;0;AL;;;;;N;;;;;
079F;THAANA LETTER DAADHU;Lo;0;AL;;;;;N;;;;;
07A0;THAANA LETTER TO;Lo;0;AL;;;;;N;;;;;
07A1;THAANA LETTER ZO;Lo;0;AL;;;;;N;;;;;
07A2;THAANA LETTER AINU;Lo;0;AL;;;;;N;;;;;
07A3;THAANA LETTER GHAINU;Lo;0;AL;;;;;N;;;;;
07A4;THAANA LETTER QAAFU;Lo;0;AL;;;;;N;;;;;
07A5;THAANA LETTER WAAVU;Lo;0;AL;;;;;N;;;;;
07A6;THAANA ABAFILI;Mn;0;NSM;;;;;N;;;;;
07A7;THAANA AABAAFILI;Mn;0;NSM;;;;;N;;;;;
07A8;THAANA IBIFILI;Mn;0;NSM;;;;;N;;;;;
07A9;THAANA EEBEEFILI;Mn;0;NSM;;;;;N;;;;;
07AA;THAANA UBUFILI;Mn;0;NSM;;;;;N;;;;;
07AB;THAANA OOBOOFILI;Mn;0;NSM;;;;;N;;;;;
07AC;THAANA EBEFILI;Mn;0;NSM;;;;;N;;;;;
07AD;THAANA EYBEYFILI;Mn;0;NSM;;;;;N;;;;;
07AE;THAANA OBOFILI;Mn;0;NSM;;;;;N;;;;;
07AF;THAANA OABOAFILI;Mn;0;NSM;;;;;N;;;;;
07B0;THAANA SUKUN;Mn;0;NSM;;;;;N;;;;;
07B1;THAANA LETTER NAA;Lo;0;AL;;;;;N;;;;;
07C0;NKO DIGIT ZERO;Nd;0;R;;0;0;0;N;;;;;
07C1;NKO DIGIT ONE;Nd;0;R;;1;1;1;N;;;;;
07C2;NKO DIGIT TWO;Nd;0;R;;2;2;2;N;;;;;
07C3;NKO DIGIT THREE;Nd;0;R;;3;3;3;N;;;;;
07C4;NKO DIGIT FOUR;Nd;0;R;;4;4;4;N;;;;;
07C5;NKO DIGIT FIVE;Nd;0;R;;5;5;5;N;;;;;
07C6;NKO DIGIT SIX;Nd;0;R;;6;6;6;N;;;;;
07C7;NKO DIGIT SEVEN;Nd;0;R;;7;7;7;N;;;;;
07C8;NKO DIGIT EIGHT;Nd;0;R;;8;8;8;N;;;;;
07C9;NKO DIGIT NINE;Nd;0;R;;9;9;9;N;;;;;
07CA;NKO LETTER A;Lo;0;R;;;;;N;;;;;
07CB;NKO LETTER EE;Lo;0;R;;;;;N;;;;;
07CC;NKO LETTER I;Lo;0;R;;;;;N;;;;;
07CD;NKO LETTER E;Lo;0;R;;;;;N;;;;;
07CE;NKO LETTER U;Lo;0;R;;;;;N;;;;;
07CF;NKO LETTER OO;Lo;0;R;;;;;N;;;;;
07D0;NKO LETTER O;Lo;0;R;;;;;N;;;;;
07D1;NKO LETTER DAGBASINNA;Lo;0;R;;;;;N;;;;;
07D2;NKO LETTER N;Lo;0;R;;;;;N;;;;;
07D3;NKO LETTER BA;Lo;0;R;;;;;N;;;;;
07D4;NKO LETTER PA;Lo;0;R;;;;;N;;;;;
07D5;NKO LETTER TA;Lo;0;R;;;;;N;;;;;
07D6;NKO LETTER JA;Lo;0;R;;;;;N;;;;;
07D7;NKO LETTER CHA;Lo;0;R;;;;;N;;;;;
07D8;NKO LETTER DA;Lo;0;R;;;;;N;;;;;
07D9;NKO LETTER RA;Lo;0;R;;;;;N;;;;;
07DA;NKO LETTER RRA;Lo;0;R;;;;;N;;;;;
07DB;NKO LETTER SA;Lo;0;R;;;;;N;;;;;
07DC;NKO LETTER GBA;Lo;0;R;;;;;N;;;;;
07DD;NKO LETTER FA;Lo;0;R;;;;;N;;;;;
07DE;NKO LETTER KA;Lo;0;R;;;;;N;;;;;
07DF;NKO LETTER LA;Lo;0;R;;;;;N;;;;;
07E0;NKO LETTER NA WOLOSO;Lo;0;R;;;;;N;;;;;
07E1;NKO LETTER MA;Lo;0;R;;;;;N;;;;;
07E2;NKO LETTER NYA;Lo;0;R;;;;;N;;;;;
07E3;NKO LETTER NA;Lo;0;R;;;;;N;;;;;
07E4;NKO LETTER HA;Lo;0;R;;;;;N;;;;;
07E5;NKO LETTER WA;Lo;0;R;;;;;N;;;;;
07E6;NKO LETTER YA;Lo;0;R;;;;;N;;;;;
07E7;NKO LETTER NYA WOLOSO;Lo;0;R;;;;;N;;;;;
07E8;NKO LETTER JONA JA;Lo;0;R;;;;;N;;;;;
07E9;NKO LETTER JONA CHA;Lo;0;R;;;;;N;;;;;
07EA;NKO LETTER JONA RA;Lo;0;R;;;;;N;;;;;
07EB;NKO COMBINING SHORT HIGH TONE;Mn;230;NSM;;;;;N;;;;;
07EC;NKO COMBINING SHORT LOW TONE;Mn;230;NSM;;;;;N;;;;;
07ED;NKO COMBINING SHORT RISING TONE;Mn;230;NSM;;;;;N;;;;;
07EE;NKO COMBINING LONG DESCENDING TONE;Mn;230;NSM;;;;;N;;;;;
07EF;NKO COMBINING LONG HIGH TONE;Mn;230;NSM;;;;;N;;;;;
07F0;NKO COMBINING LONG LOW TONE;Mn;230;NSM;;;;;N;;;;;
07F1;NKO COMBINING LONG RISING TONE;Mn;230;NSM;;;;;N;;;;;
07F2;NKO COMBINING NASALIZATION MARK;Mn;220;NSM;;;;;N;;;;;
07F3;NKO COMBINING DOUBLE DOT ABOVE;Mn;230;NSM;;;;;N;;;;;
07F4;NKO HIGH TONE APOSTROPHE;Lm;0;R;;;;;N;;;;;
07F5;NKO LOW TONE APOSTROPHE;Lm;0;R;;;;;N;;;;;
07F6;NKO SYMBOL OO DENNEN;So;0;ON;;;;;N;;;;;
07F7;NKO SYMBOL GBAKURUNEN;Po;0;ON;;;;;N;;;;;
07F8;NKO COMMA;Po;0;ON;;;;;N;;;;;
07F9;NKO EXCLAMATION MARK;Po;0;ON;;;;;N;;;;;
07FA;NKO LAJANYALAN;Lm;0;R;;;;;N;;;;;
07FD;NKO DANTAYALAN;Mn;220;NSM;;;;;N;;;;;
07FE;NKO DOROME SIGN;Sc;0;R;;;;;N;;;;;
07FF;NKO TAMAN SIGN;Sc;0;R;;;;;N;;;;;
0800;SAMARITAN LETTER ALAF;Lo;0;R;;;;;N;;;;;
0801;SAMARITAN LETTER BIT;Lo;0;R;;;;;N;;;;;
0802;SAMARITAN LETTER GAMAN;Lo;0;R;;;;;N;;;;;
0803;SAMARITAN LETTER DALAT;Lo;0;R;;;;;N;;;;;
0804;SAMARITAN LETTER IY;Lo;0;R;;;;;N;;;;;
0805;SAMARITAN LETTER BAA;Lo;0;R;;;;;N;;;;;
0806;SAMARITAN LETTER ZEN;Lo;0;R;;;;;N;;;;;
0807;SAMARITAN LETTER IT;Lo;0;R;;;;;N;;;;;
0808;SAMARITAN LETTER TIT;Lo;0;R;;;;;N;;;;;
0809;SAMARITAN LETTER YUT;Lo;0;R;;;;;N;;;;;
080A;SAMARITAN LETTER KAAF;Lo;0;R;;;;;N;;;;;
080B;SAMARITAN LETTER LABAT;Lo;0;R;;;;;N;;;;;
080C;SAMARITAN LETTER MIM;Lo;0;R;;;;;N;;;;;
080D;SAMARITAN LETTER NUN;Lo;0;R;;;;;N;;;;;
080E;SAMARITAN LETTER SINGAAT;Lo;0;R;;;;;N;;;;;
080F;SAMARITAN LETTER IN;Lo;0;R;;;;;N;;;;;
0810;SAMARITAN LETTER FI;Lo;0;R;;;;;N;;;;;
0811;SAMARITAN LETTER TSAADIY;Lo;0;R;;;;;N;;;;;
0812;SAMARITAN LETTER QUF;Lo;0;R;;;;;N;;;;;
0813;SAMARITAN LETTER RISH;Lo;0;R;;;;;N;;;;;
0814;SAMARITAN LETTER SHAN;Lo;0;R;;;;;N;;;;;
0815;SAMARITAN LETTER TAAF;Lo;0;R;;;;;N;;;;;
0816;SAMARITAN MARK IN;Mn;230;NSM;;;;;N;;;;;
0817;SAMARITAN MARK IN-ALAF;Mn;230;NSM;;;;;N;;;;;
0818;SAMARITAN MARK OCCLUSION;Mn;230;NSM;;;;;N;;;;;
0819;SAMARITAN MARK DAGESH;Mn;230;NSM;;;;;N;;;;;
081A;SAMARITAN MODIFIER LETTER EPENTHETIC YUT;Lm;0;R;;;;;N;;;;;
081B;SAMARITAN MARK EPENTHETIC YUT;Mn;230;NSM;;;;;N;;;;;
081C;SAMARITAN VOWEL SIGN LONG E;Mn;230;NSM;;;;;N;;;;;
081D;SAMARITAN VOWEL SIGN E;Mn;230;NSM;;;;;N;;;;;
081E;SAMARITAN VOWEL SIGN OVERLONG AA;Mn;230;NSM;;;;;N;;;;;
081F;SAMARITAN VOWEL SIGN LONG AA;Mn;230;NSM;;;;;N;;;;;
0820;SAMARITAN VOWEL SIGN AA;Mn;230;NSM;;;;;N;;;;;
0821;SAMARITAN VOWEL SIGN OVERLONG A;Mn;230;NSM;;;;;N;;;;;
0822;SAMARITAN VOWEL SIGN LONG A;Mn;230;NSM;;;;;N;;;;;
0823;SAMARITAN VOWEL SIGN A;Mn;230;NSM;;;;;N;;;;;
0824;SAMARITAN MODIFIER LETTER SHORT A;Lm;0;R;;;;;N;;;;;
0825;SAMARITAN VOWEL SIGN SHORT A;Mn;230;NSM;;;;;N;;;;;
0826;SAMARITAN VOWEL SIGN LONG U;Mn;230;NSM;;;;;N;;;;;
0827;SAMARITAN VOWEL SIGN U;Mn;230;NSM;;;;;N;;;;;
0828;SAMARITAN MODIFIER LETTER I;Lm;0;R;;;;;N;;;;;
0829;SAMARITAN VOWEL SIGN LONG I;Mn;230;NSM;;;;;N;;;;;
082A;SAMARITAN VOWEL SIGN I;Mn;230;NSM;;;;;N;;;;;
082B;SAMARITAN VOWEL SIGN O;Mn;230;NSM;;;;;N;;;;;
082C;SAMARITAN VOWEL SIGN SUKUN;Mn;230;NSM;;;;;N;;;;;
082D;SAMARITAN MARK NEQUDAA;Mn;230;NSM;;;;;N;;;;;
0830;SAMARITAN PUNCTUATION NEQUDAA;Po;0;R;;;;;N;;;;;
0831;SAMARITAN PUNCTUATION AFSAAQ;Po;0;R;;;;;N;;;;;
0832;SAMARITAN PUNCTUATION ANGED;Po;0;R;;;;;N;;;;;
0833;SAMARITAN PUNCTUATION BAU;Po;0;R;;;;;N;;;;;
0834;SAMARITAN PUNCTUATION ATMAAU;Po;0;R;;;;;N;;;;;
0835;SAMARITAN PUNCTUATION SHIYYAALAA;Po;0;R;;;;;N;;;;;
0836;SAMARITAN ABBREVIATION MARK;Po;0;R;;;;;N;;;;;
0837;SAMARITAN PUNCTUATION MELODIC QITSA;Po;0;R;;;;;N;;;;;
0838;SAMARITAN PUNCTUATION ZIQAA;Po;0;R;;;;;N;;;;;
0839;SAMARITAN PUNCTUATION QITSA;Po;0;R;;;;;N;;;;;
083A;SAMARITAN PUNCTUATION ZAEF;Po;0;R;;;;;N;;;;;
083B;SAMARITAN PUNCTUATION TURU;Po;0;R;;;;;N;;;;;
083C;SAMARITAN PUNCTUATION ARKAANU;Po;0;R;;;;;N;;;;;
083D;SAMARITAN PUNCTUATION SOF MASHFAAT;Po;0;R;;;;;N;;;;;
083E;SAMARITAN PUNCTUATION ANNAAU;Po;0;R;;;;;N;;;;;
0840;MANDAIC LETTER HALQA;Lo;0;R;;;;;N;;;;;
0841;MANDAIC LETTER AB;Lo;0;R;;;;;N;;;;;
0842;MANDAIC LETTER AG;Lo;0;R;;;;;N;;;;;
0843;MANDAIC LETTER AD;Lo;0;R;;;;;N;;;;;
0844;MANDAIC LETTER AH;Lo;0;R;;;;;N;;;;;
0845;MANDAIC LETTER USHENNA;Lo;0;R;;;;;N;;;;;
0846;MANDAIC LETTER AZ;Lo;0;R;;;;;N;;;;;
0847;MANDAIC LETTER IT;Lo;0;R;;;;;N;;;;;
0848;MANDAIC LETTER ATT;Lo;0;R;;;;;N;;;;;
0849;MANDAIC LETTER AKSA;Lo;0;R;;;;;N;;;;;
084A;MANDAIC LETTER AK;Lo;0;R;;;;;N;;;;;
084B;MANDAIC LETTER AL;Lo;0;R;;;;;N;;;;;
084C;MANDAIC LETTER AM;Lo;0;R;;;;;N;;;;;
084D;MANDAIC LETTER AN;Lo;0;R;;;;;N;;;;;
084E;MANDAIC LETTER AS;Lo;0;R;;;;;N;;;;;
084F;MANDAIC LETTER IN;Lo;0;R;;;;;N;;;;;
0850;MANDAIC LETTER AP;Lo;0;R;;;;;N;;;;;
0851;MANDAIC LETTER ASZ;Lo;0;R;;;;;N;;;;;
0852;MANDAIC LETTER AQ;Lo;0;R;;;;;N;;;;;
0853;MANDAIC LETTER AR;Lo;0;R;;;;;N;;;;;
0854;MANDAIC LETTER ASH;Lo;0;R;;;;;N;;;;;
0855;MANDAIC LETTER AT;Lo;0;R;;;;;N;;;;;
0856;MANDAIC LETTER DUSHENNA;Lo;0;R;;;;;N;;;;;
0857;MANDAIC LETTER KAD;Lo;0;R;;;;;N;;;;;
0858;MANDAIC LETTER AIN;Lo;0;R;;;;;N;;;;;
0859;MANDAIC AFFRICATION MARK;Mn;220;NSM;;;;;N;;;;;
085A;MANDAIC VOCALIZATION MARK;Mn;220;NSM;;;;;N;;;;;
085B;MANDAIC GEMINATION MARK;Mn;220;NSM;;;;;N;;;;;
085E;MANDAIC PUNCTUATION;Po;0;R;;;;;N;;;;;
0860;SYRIAC LETTER MALAYALAM NGA;Lo;0;AL;;;;;N;;;;;
0861;SYRIAC LETTER MALAYALAM JA;Lo;0;AL;;;;;N;;;;;
0862;SYRIAC LETTER MALAYALAM NYA;Lo;0;AL;;;;;N;;;;;
0863;SYRIAC LETTER MALAYALAM TTA;Lo;0;AL;;;;;N;;;;;
0864;SYRIAC LETTER MALAYALAM NNA;Lo;0;AL;;;;;N;;;;;
0865;SYRIAC LETTER MALAYALAM NNNA;Lo;0;AL;;;;;N;;;;;
0866;SYRIAC LETTER MALAYALAM BHA;Lo;0;AL;;;;;N;;;;;
0867;SYRIAC LETTER MALAYALAM RA;Lo;0;AL;;;;;N;;;;;
0868;SYRIAC LETTER MALAYALAM LLA;Lo;0;AL;;;;;N;;;;;
0869;SYRIAC LETTER MALAYALAM LLLA;Lo;0;AL;;;;;N;;;;;
086A;SYRIAC LETTER MALAYALAM SSA;Lo;0;AL;;;;;N;;;;;
0870;ARABIC LETTER ALEF WITH ATTACHED FATHA;Lo;0;AL;;;;;N;;;;;
0871;ARABIC LETTER ALEF WITH ATTACHED TOP RIGHT FATHA;Lo;0;AL;;;;;N;;;;;
0872;ARABIC LETTER ALEF WITH RIGHT MIDDLE STROKE;Lo;0;AL;;;;;N;;;;;
0873;ARABIC LETTER ALEF WITH LEFT MIDDLE STROKE;Lo;0;AL;;;;;N;;;;;
0874;ARABIC LETTER ALEF WITH ATTACHED KASRA;Lo;0;AL;;;;;N;;;;;
0875;ARABIC LETTER ALEF WITH ATTACHED BOTTOM RIGHT KASRA;Lo;0;AL;;;;;N;;;;;
0876;ARABIC LETTER ALEF WITH ATTACHED ROUND DOT ABOVE;Lo;0;AL;;;;;N;;;;;
0877;ARABIC LETTER ALEF WITH ATTACHED RIGHT ROUND DOT;Lo;0;AL;;;;;N;;;;;
0878;ARABIC LETTER ALEF WITH ATTACHED LEFT ROUND DOT;Lo;0;AL;;;;;N;;;;;
0879;ARABIC LETTER ALEF WITH ATTACHED ROUND DOT BELOW;Lo;0;AL;;;;;N;;;;;
087A;ARABIC LETTER ALEF WITH DOT ABOVE;Lo;0;AL;;;;;N;;;;;
087B;ARABIC LETTER ALEF WITH ATTACHED TOP RIGHT FATHA AND DOT ABOVE;Lo;0;AL;;;;;N;;;;;
087C;ARABIC LETTER ALEF WITH RIGHT MIDDLE STROKE AND DOT ABOVE;Lo;0;AL;;;;;N;;;;;
087D;ARABIC LETTER ALEF WITH ATTACHED BOTTOM RIGHT KASRA AND DOT ABOVE;Lo;0;AL;;;;;N;;;;;
087E;ARABIC LETTER ALEF WITH ATTACHED TOP RIGHT FATHA AND LEFT RING;Lo;0;AL;;;;;N;;;;;
087F;ARABIC LETTER ALEF WITH RIGHT MIDDLE STROKE AND LEFT RING;Lo;0;AL;;;;;N;;;;;
0880;ARABIC LETTER ALEF WITH ATTACHED BOTTOM RIGHT KASRA AND LEFT RING;Lo;0;AL;;;;;N;;;;;
0881;ARABIC LETTER ALEF WITH ATTACHED RIGHT HAMZA;Lo;0;AL;;;;;N;;;;;
0882;ARABIC LETTER ALEF WITH ATTACHED LEFT HAMZA;Lo;0;AL;;;;;N;;;;;
0883;ARABIC TATWEEL WITH OVERSTRUCK HAMZA;Lo;0;AL;;;;;N;;;;;
0884;ARABIC TATWEEL WITH OVERSTRUCK WAW;Lo;0;AL;;;;;N;;;;;
0885;ARABIC TATWEEL WITH TWO DOTS BELOW;Lo;0;AL;;;;;N;;;;;
0886;ARABIC LETTER THIN YEH;Lo;0;AL;;;;;N;;;;;
0887;ARABIC BASELINE ROUND DOT;Lo;0;AL;;;;;N;;;;;
0888;ARABIC RAISED ROUND DOT;Sk;0;AL;;;;;N;;;;;
0889;ARABIC LETTER NOON WITH INVERTED SMALL V;Lo;0;AL;;;;;N;;;;;
088A;ARABIC LETTER HAH WITH INVERTED SMALL V BELOW;Lo;0;AL;;;;;N;;;;;
088B;ARABIC LETTER TAH WITH DOT BELOW;Lo;0;AL;;;;;N;;;;;
088C;ARABIC LETTER TAH WITH THREE DOTS BELOW;Lo;0;AL;;;;;N;;;;;
088D;ARABIC LETTER KEHEH WITH TWO DOTS VERTICALLY BELOW;Lo;0;AL;;;;;N;;;;;
088E;ARABIC VERTICAL TAIL;Lo;0;AL;;;;;N;;;;;
0890;ARABIC POUND MARK ABOVE;Cf;0;AN;;;;;N;;;;;
0891;ARABIC PIASTRE MARK ABOVE;Cf;0;AN;;;;;N;;;;;
0898;ARABIC SMALL HIGH WORD AL-JUZ;Mn;230;NSM;;;;;N;;;;;
0899;ARABIC SMALL LOW WORD ISHMAAM;Mn;220;NSM;;;;;N;;;;;
089A;ARABIC SMALL LOW WORD IMAALA;Mn;220;NSM;;;;;N;;;;;
089B;ARABIC SMALL LOW WORD TASHEEL;Mn;220;NSM;;;;;N;;;;;
089C;ARABIC MADDA WAAJIB;Mn;230;NSM;;;;;N;;;;;
089D;ARABIC SUPERSCRIPT ALEF MOKHASSAS;Mn;230;NSM;;;;;N;;;;;
089E;ARABIC DOUBLED MADDA;Mn;230;NSM;;;;;N;;;;;
089F;ARABIC HALF MADDA OVER MADDA;Mn;230;NSM;;;;;N;;;;;
08A0;ARABIC LETTER BEH WITH SMALL V BELOW;Lo;0;AL;;;;;N;;;;;
08A1;ARABIC LETTER BEH WITH HAMZA ABOVE;Lo;0;AL;;;;;N;;;;;
08A2;ARABIC LETTER JEEM WITH TWO DOTS ABOVE;Lo;0;AL;;;;;N;;;;;
08A3;ARABIC LETTER TAH WITH TWO DOTS ABOVE;Lo;0;AL;;;;;N;;;;;
08A4;ARABIC LETTER FEH WITH DOT BELOW AND THREE DOTS ABOVE;Lo;0;AL;;;;;N;;;;;
08A5;ARABIC LETTER QAF WITH DOT BELOW;Lo;0;AL;;;;;N;;;;;
08A6;ARABIC LETTER LAM WITH DOUBLE BAR;Lo;0;AL;;;;;N;;;;;
08A7;ARABIC LETTER MEEM WITH THREE DOTS ABOVE;Lo;0;AL;;;;;N;;;;;
08A8;ARABIC LETTER YEH WITH TWO DOTS BELOW AND HAMZA ABOVE;Lo;0;AL;;;;;N;;;;;
08A9;ARABIC LETTER YEH WITH TWO DOTS BELOW AND DOT ABOVE;Lo;0;AL;;;;;N;;;;;
08AA;ARABIC LETTER REH WITH LOOP;Lo;0;AL;;;;;N;;;;;
08AB;ARABIC LETTER WAW WITH DOT WITHIN;Lo;0;AL;;;;;N;;;;;
08AC;ARABIC LETTER ROHINGYA YEH;Lo;0;AL;;;;;N;;;;;
08AD;ARABIC LETTER LOW ALEF;Lo;0;AL;;;;;N;;;;;
08AE;ARABIC LETTER DAL WITH THREE DOTS BELOW;Lo;0;AL;;;;;N;;;;;
08AF;ARABIC LETTER SAD WITH THREE DOTS BELOW;Lo;0;AL;;;;;N;;;;;
08B0;ARABIC LETTER GAF WITH INVERTED STROKE;Lo;0;AL;;;;;N;;;;;
08B1;ARABIC LETTER STRAIGHT WAW;Lo;0;AL;;;;;N;;;;;
08B2;ARABIC LETTER ZAIN WITH INVERTED V ABOVE;Lo;0;AL;;;;;N;;;;;
08B3;ARABIC LETTER AIN WITH THREE DOTS BELOW;Lo;0;AL;;;;;N;;;;;
08B4;ARABIC LETTER KAF WITH DOT BELOW;Lo;0;AL;;;;;N;;;;;
08B5;ARABIC LETTER QAF WITH DOT BELOW AND NO DOTS ABOVE;Lo;0;AL;;;;;N;;;;;
08B6;ARABIC LETTER BEH WITH SMALL MEEM ABOVE;Lo;0;AL;;;;;N;;;;;
08B7;ARABIC LETTER PEH WITH SMALL MEEM ABOVE;Lo;0;AL;;;;;N;;;;;
08B8;ARABIC LETTER TEH WITH SMALL TEH ABOVE;Lo;0;AL;;;;;N;;;;;
08B9;ARABIC LETTER REH WITH SMALL NOON ABOVE;Lo;0;AL;;;;;N;;;;;
08BA;ARABIC LETTER YEH WITH TWO DOTS BELOW AND SMALL NOON ABOVE;Lo;0;AL;;;;;N;;;;;
08BB;ARABIC LETTER AFRICAN FEH;Lo;0;AL;;;;;N;;;;;
08BC;ARABIC LETTER AFRICAN QAF;Lo;0;AL;;;;;N;;;;;
08BD;ARABIC LETTER AFRICAN NOON;Lo;0;AL;;;;;N;;;;;
08BE;ARABIC LETTER PEH WITH SMALL V;Lo;0;AL;;;;;N;;;;;
08BF;ARABIC LETTER TEH WITH SMALL V;Lo;0;AL;;;;;N;;;;;
08C0;ARABIC LETTER TTEH WITH SMALL V;Lo;0;AL;;;;;N;;;;;
08C1;ARABIC LETTER TCHEH WITH SMALL V;Lo;0;AL;;;;;N;;;;;
08C2;ARABIC LETTER KEHEH WITH SMALL V;Lo;0;AL;;;;;N;;;;;
08C3;ARABIC LETTER GHAIN WITH THREE DOTS ABOVE;Lo;0;AL;;;;;N;;;;;
08C4;ARABIC LETTER AFRICAN QAF WITH THREE DOTS ABOVE;Lo;0;AL;;;;;N;;;;;
08C5;ARABIC LETTER JEEM WITH THREE DOTS ABOVE;Lo;0;AL;;;;;N;;;;;
08C6;ARABIC LETTER JEEM WITH THREE DOTS BELOW;Lo;0;AL;;;;;N;;;;;
08C7;ARABIC LETTER LAM WITH SMALL ARABIC LETTER TAH ABOVE;Lo;0;AL;;;;;N;;;;;
08C8;ARABIC LETTER GRAF;Lo;0;AL;;;;;N;;;;;
08C9;ARABIC SMALL FARSI YEH;Lm;0;AL;;;;;N;;;;;
08CA;ARABIC SMALL HIGH FARSI YEH;Mn;230;NSM;;;;;N;;;;;
08CB;ARABIC SMALL HIGH YEH BARREE WITH TWO DOTS BELOW;Mn;230;NSM;;;;;N;;;;;
08CC;ARABIC SMALL HIGH WORD SAH;Mn;230;NSM;;;;;N;;;;;
08CD;ARABIC SMALL HIGH ZAH;Mn;230;NSM;;;;;N;;;;;
08CE;ARABIC LARGE ROUND DOT ABOVE;Mn;230;NSM;;;;;N;;;;;
08CF;ARABIC LARGE ROUND DOT BELOW;Mn;220;NSM;;;;;N;;;;;
08D0;ARABIC SUKUN BELOW;Mn;220;NSM;;;;;N;;;;;
08D1;ARABIC LARGE CIRCLE BELOW;Mn;220;NSM;;;;;N;;;;;
08D2;ARABIC LARGE ROUND DOT INSIDE CIRCLE BELOW;Mn;220;NSM;;;;;N;;;;;
08D3;ARABIC SMALL LOW WAW;Mn;220;NSM;;;;;N;;;;;
08D4;ARABIC SMALL HIGH WORD AR-RUB;Mn;230;NSM;;;;;N;;;;;
08D5;ARABIC SMALL HIGH SAD;Mn;230;NSM;;;;;N;;;;;
08D6;ARABIC SMALL HIGH AIN;Mn;230;NSM;;;;;N;;;;;
08D7;ARABIC SMALL HIGH QAF;Mn;230;NSM;;;;;N;;;;;
08D8;ARABIC SMALL HIGH NOON WITH KASRA;Mn;230;NSM;;;;;N;;;;;
08D9;ARABIC SMALL LOW NOON WITH KASRA;Mn;230;NSM;;;;;N;;;;;
08DA;ARABIC SMALL HIGH WORD ATH-THALATHA;Mn;230;NSM;;;;;N;;;;;
08DB;ARABIC SMALL HIGH WORD AS-SAJDA;Mn;230;NSM;;;;;N;;;;;
08DC;ARABIC SMALL HIGH WORD AN-NISF;Mn;230;NSM;;;;;N;;;;;
08DD;ARABIC SMALL HIGH WORD SAKTA;Mn;230;NSM;;;;;N;;;;;
08DE;ARABIC SMALL HIGH WORD QIF;Mn;230;NSM;;;;;N;;;;;
08DF;ARABIC SMALL HIGH WORD WAQFA;Mn;230;NSM;;;;;N;;;;;
08E0;ARABIC SMALL HIGH FOOTNOTE MARKER;Mn;230;NSM;;;;;N;;;;;
08E1;ARABIC SMALL HIGH SIGN SAFHA;Mn;230;NSM;;;;;N;;;;;
08E2;ARABIC DISPUTED END OF AYAH;Cf;0;AN;;;;;N;;;;;
08E3;ARABIC TURNED DAMMA BELOW;Mn;220;NSM;;;;;N;;;;;
08E4;ARABIC CURLY FATHA;Mn;230;NSM;;;;;N;;;;;
08E5;ARABIC CURLY DAMMA;Mn;230;NSM;;;;;N;;;;;
08E6;ARABIC CURLY KASRA;Mn;220;NSM;;;;;N;;;;;
08E7;ARABIC CURLY FATHATAN;Mn;230;NSM;;;;;N;;;;;
08E8;ARABIC CURLY DAMMATAN;Mn;230;NSM;;;;;N;;;;;
08E9;ARABIC CURLY KASRATAN;Mn;220;NSM;;;;;N;;;;;
08EA;ARABIC TONE ONE DOT ABOVE;Mn;230;NSM;;;;;N;;;;;
08EB;ARABIC TONE TWO DOTS ABOVE;Mn;230;NSM;;;;;N;;;;;
08EC;ARABIC TONE LOOP ABOVE;Mn;230;NSM;;;;;N;;;;;
08ED;ARABIC TONE ONE DOT BELOW;Mn;220;NSM;;;;;N;;;;;
08EE;ARABIC TONE TWO DOTS BELOW;Mn;220;NSM;;;;;N;;;;;
08EF;ARABIC TONE LOOP BELOW;Mn;220;NSM;;;;;N;;;;;
08F0;ARABIC OPEN FATHATAN;Mn;27;NSM;;;;;N;;;;;
08F1;ARABIC OPEN DAMMATAN;Mn;28;NSM;;;;;N;;;;;
08F2;ARABIC OPEN KASRATAN;Mn;29;NSM;;;;;N;;;;;
08F3;ARABIC SMALL HIGH WAW;Mn;230;NSM;;;;;N;;;;;
08F4;ARABIC FATHA WITH RING;Mn;230;NSM;;;;;N;;;;;
08F5;ARABIC FATHA WITH DOT ABOVE;Mn;230;NSM;;;;;N;;;;;
08F6;ARABIC KASRA WITH DOT BELOW;Mn;220;NSM;;;;;N;;;;;
08F7;ARABIC LEFT ARROWHEAD ABOVE;Mn;230;NSM;;;;;N;;;;;
08F8;ARABIC RIGHT ARROWHEAD ABOVE;Mn;230;NSM;;;;;N;;;;;
08F9;ARABIC LEFT ARROWHEAD BELOW;Mn;220;NSM;;;;;N;;;;;
08FA;ARABIC RIGHT ARROWHEAD BELOW;Mn;220;NSM;;;;;N;;;;;
08FB;ARABIC DOUBLE RIGHT ARROWHEAD ABOVE;Mn;230;NSM;;;;;N;;;;;
08FC;ARABIC DOUBLE RIGHT ARROWHEAD ABOVE WITH DOT;Mn;230;NSM;;;;;N;;;;;
08FD;ARABIC RIGHT ARROWHEAD ABOVE WITH DOT;Mn;230;NSM;;;;;N;;;;;
08FE;ARABIC DAMMA WITH DOT;Mn;230;NSM;;;;;N;;;;;
08FF;ARABIC MARK SIDEWAYS NOON GHUNNA;Mn;230;NSM;;;;;N;;;;;
0900;DEVANAGARI SIGN INVERTED CANDRABINDU;Mn;0;NSM;;;;;N;;;;;
0901;DEVANAGARI SIGN CANDRABINDU;Mn;0;NSM;;;;;N;;;;;
0902;DEVANAGARI SIGN ANUSVARA;Mn;0;NSM;;;;;N;;;;;
0903;DEVANAGARI SIGN VISARGA;Mc;0;L;;;;;N;;;;;
0904;DEVANAGARI LETTER SHORT A;Lo;0;L;;;;;N;;;;;
0905;DEVANAGARI LETTER A;Lo;0;L;;;;;N;;;;;
0906;DEVANAGARI LETTER AA;Lo;0;L;;;;;N;;;;;
0907;DEVANAGARI LETTER I;Lo;0;L;;;;;N;;;;;
0908;DEVANAGARI LETTER II;Lo;0;L;;;;;N;;;;;
0909;DEVANAGARI LETTER U;Lo;0;L;;;;;N;;;;;
090A;DEVANAGARI LETTER UU;Lo;0;L;;;;;N;;;;;
090B;DEVANAGARI LETTER VOCALIC R;Lo;0;L;;;;;N;;;;;
090C;DEVANAGARI LETTER VOCALIC L;Lo;0;L;;;;;N;;;;;
090D;DEVANAGARI LETTER CANDRA E;Lo;0;L;;;;;N;;;;;
090E;DEVANAGARI LETTER SHORT E;Lo;0;L;;;;;N;;;;;
090F;DEVANAGARI LETTER E;Lo;0;L;;;;;N;;;;;
0910;DEVANAGARI LETTER AI;Lo;0;L;;;;;N;;;;;
0911;DEVANAGARI LETTER CANDRA O;Lo;0;L;;;;;N;;;;;
0912;DEVANAGARI LETTER SHORT O;Lo;0;L;;;;;N;;;;;
0913;DEVANAGARI LETTER O;Lo;0;L;;;;;N;;;;;
0914;DEVANAGARI LETTER AU;Lo;0;L;;;;;N;;;;;
0915;DEVANAGARI LETTER KA;Lo;0;L;;;;;N;;;;;
0916;DEVANAGARI LETTER KHA;Lo;0;L;;;;;N;;;;;
0917;DEVANAGARI LETTER GA;Lo;0;L;;;;;N;;;;;
0918;DEVANAGARI LETTER GHA;Lo;0;L;;;;;N;;;;;
0919;DEVANAGARI LETTER NGA;Lo;0;L;;;;;N;;;;;
091A;DEVANAGARI LETTER CA;Lo;0;L;;;;;N;;;;;
091B;DEVANAGARI LETTER CHA;Lo;0;L;;;;;N;;;;;
091C;DEVANAGARI LETTER JA;Lo;0;L;;;;;N;;;;;
091D;DEVANAGARI LETTER JHA;Lo;0;L;;;;;N;;;;;
091E;DEVANAGARI LETTER NYA;Lo;0;L;;;;;N;;;;;
091F;DEVANAGARI LETTER TTA;Lo;0;L;;;;;N;;;;;
0920;DEVANAGARI LETTER TTHA;Lo;0;L;;;;;N;;;;;
0921;DEVANAGARI LETTER DDA;Lo;0;L;;;;;N;;;;;
0922;DEVANAGARI LETTER DDHA;Lo;0;L;;;;;N;;;;;
0923;DEVANAGARI LETTER NNA;Lo;0;L;;;;;N;;;;;
0924;DEVANAGARI LETTER TA;Lo;0;L;;;;;N;;;;;
0925;DEVANAGARI LETTER THA;Lo;0;L;;;;;N;;;;;
0926;DEVANAGARI LETTER DA;Lo;0;L;;;;;N;;;;;
0927;DEVANAGARI LETTER DHA;Lo;0;L;;;;;N;;;;;
0928;DEVANAGARI LETTER NA;Lo;0;L;;;;;N;;;;;
0929;DEVANAGARI LETTER NNNA;Lo;0;L;0928 093C;;;;N;;;;;
092A;DEVANAGARI LETTER PA;Lo;0;L;;;;;N;;;;;
092B;DEVANAGARI LETTER PHA;Lo;0;L;;;;;N;;;;;
092C;DEVANAGARI LETTER BA;Lo;0;L;;;;;N;;;;;
092D;DEVANAGARI LETTER BHA;Lo;0;L;;;;;N;;;;;
092E;DEVANAGARI LETTER MA;Lo;0;L;;;;;N;;;;;
092F;DEVANAGARI LETTER YA;Lo;0;L;;;;;N;;;;;
0930;DEVANAGARI LETTER RA;Lo;0;L;;;;;N;;;;;
0931;DEVANAGARI LETTER RRA;Lo;0;L;0930 093C;;;;N;;;;;
0932;DEVANAGARI LETTER LA;Lo;0;L;;;;;N;;;;;
0933;DEVANAGARI LETTER LLA;Lo;0;L;;;;;N;;;;;
0934;DEVANAGARI LETTER LLLA;Lo;0;L;0933 093C;;;;N;;;;;
0935;DEVANAGARI LETTER VA;Lo;0;L;;;;;N;;;;;
0936;DEVANAGARI LETTER SHA;Lo;0;L;;;;;N;;;;;
0937;DEVANAGARI LETTER SSA;Lo;0;L;;;;;N;;;;;
0938;DEVANAGARI LETTER SA;Lo;0;L;;;;;N;;;;;
0939;DEVANAGARI LETTER HA;Lo;0;L;;;;;N;;;;;
093A;DEVANAGARI VOWEL SIGN OE;Mn;0;NSM;;;;;N;;;;;
093B;DEVANAGARI VOWEL SIGN OOE;Mc;0;L;;;;;N;;;;;
093C;DEVANAGARI SIGN NUKTA;Mn;7;NSM;;;;;N;;;;;
093D;DEVANAGARI SIGN AVAGRAHA;Lo;0;L;;;;;N;;;;;
093E;DEVANAGARI VOWEL SIGN AA;Mc;0;L;;;;;N;;;;;
093F;DEVANAGARI VOWEL SIGN I;Mc;0;L;;;;;N;;;;;
0940;DEVANAGARI VOWEL SIGN II;Mc;0;L;;;;;N;;;;;
0941;DEVANAGARI VOWEL SIGN U;Mn;0;NSM;;;;;N;;;;;
0942;DEVANAGARI VOWEL SIGN UU;Mn;0;NSM;;;;;N;;;;;
0943;DEVANAGARI VOWEL SIGN VOCALIC R;Mn;0;NSM;;;;;N;;;;;
0944;DEVANAGARI VOWEL SIGN VOCALIC RR;Mn;0;NSM;;;;;N;;;;;
0945;DEVANAGARI VOWEL SIGN CANDRA E;Mn;0;NSM;;;;;N;;;;;
0946;DEVANAGARI VOWEL SIGN SHORT E;Mn;0;NSM;;;;;N;;;;;
0947;DEVANAGARI VOWEL SIGN E;Mn;0;NSM;;;;;N;;;;;
0948;DEVANAGARI VOWEL SIGN AI;Mn;0;NSM;;;;;N;;;;;
0949;DEVANAGARI VOWEL SIGN CANDRA O;Mc;0;L;;;;;N;;;;;
094A;DEVANAGARI VOWEL SIGN SHORT O;Mc;0;L;;;;;N;;;;;
094B;DEVANAGARI VOWEL SIGN O;Mc;0;L;;;;;N;;;;;
094C;DEVANAGARI VOWEL SIGN AU;Mc;0;L;;;;;N;;;;;
094D;DEVANAGARI SIGN VIRAMA;Mn;9;NSM;;;;;N;;;;;
094E;DEVANAGARI VOWEL SIGN PRISHTHAMATRA E;Mc;0;L;;;;;N;;;;;
094F;DEVANAGARI VOWEL SIGN AW;Mc;0;L;;;;;N;;;;;
0950;DEVANAGARI OM;Lo;0;L;;;;;N;;;;;
0951;DEVANAGARI STRESS SIGN UDATTA;Mn;230;NSM;;;;;N;;;;;
0952;DEVANAGARI STRESS SIGN ANUDATTA;Mn;220;NSM;;;;;N;;;;;
0953;DEVANAGARI GRAVE ACCENT;Mn;230;NSM;;;;;N;;;;;
0954;DEVANAGARI ACUTE ACCENT;Mn;230;NSM;;;;;N;;;;;
0955;DEVANAGARI VOWEL SIGN CANDRA LONG E;Mn;0;NSM;;;;;N;;;;;
0956;DEVANAGARI VOWEL SIGN UE;Mn;0;NSM;;;;;N;;;;;
0957;DEVANAGARI VOWEL SIGN UUE;Mn;0;NSM;;;;;N;;;;;
0958;DEVANAGARI LETTER QA;Lo;0;L;0915 093C;;;;N;;;;;
0959;DEVANAGARI LETTER KHHA;Lo;0;L;0916 093C;;;;N;;;;;
095A;DEVANAGARI LETTER GHHA;Lo;0;L;0917 093C;;;;N;;;;;
095B;DEVANAGARI LETTER ZA;Lo;0;L;091C 093C;;;;N;;;;;
095C;DEVANAGARI LETTER DDDHA;Lo;0;L;0921 093C;;;;N;;;;;
095D;DEVANAGARI LETTER RHA;Lo;0;L;0922 093C;;;;N;;;;;
095E;DEVANAGARI LETTER FA;Lo;0;L;092B 093C;;;;N;;;;;
095F;DEVANAGARI LETTER YYA;Lo;0;L;092F 093C;;;;N;;;;;
0960;DEVANAGARI LETTER VOCALIC RR;Lo;0;L;;;;;N;;;;;
0961;DEVANAGARI LETTER VOCALIC LL;Lo;0;L;;;;;N;;;;;
0962;DEVANAGARI VOWEL SIGN VOCALIC L;Mn;0;NSM;;;;;N;;;;;
0963;DEVANAGARI VOWEL SIGN VOCALIC LL;Mn;0;NSM;;;;;N;;;;;
0964;DEVANAGARI DANDA;Po;0;L;;;;;N;;;;;
0965;DEVANAGARI DOUBLE DANDA;Po;0;L;;;;;N;;;;;
0966;DEVANAGARI DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
0967;DEVANAGARI DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
0968;DEVANAGARI DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
0969;DEVANAGARI DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
096A;DEVANAGARI DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
096B;DEVANAGARI DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
096C;DEVANAGARI DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
096D;DEVANAGARI DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
096E;DEVANAGARI DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
096F;DEVANAGARI DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
0970;DEVANAGARI ABBREVIATION SIGN;Po;0;L;;;;;N;;;;;
0971;DEVANAGARI SIGN HIGH SPACING DOT;Lm;0;L;;;;;N;;;;;
0972;DEVANAGARI LETTER CANDRA A;Lo;0;L;;;;;N;;;;;
0973;DEVANAGARI LETTER OE;Lo;0;L;;;;;N;;;;;
0974;DEVANAGARI LETTER OOE;Lo;0;L;;;;;N;;;;;
0975;DEVANAGARI LETTER AW;Lo;0;L;;;;;N;;;;;
0976;DEVANAGARI LETTER UE;Lo;0;L;;;;;N;;;;;
0977;DEVANAGARI LETTER UUE;Lo;0;L;;;;;N;;;;;
0978;DEVANAGARI LETTER MARWARI DDA;Lo;0;L;;;;;N;;;;;
0979;DEVANAGARI LETTER ZHA;Lo;0;L;;;;;N;;;;;
097A;DEVANAGARI LETTER HEAVY YA;Lo;0;L;;;;;N;;;;;
097B;DEVANAGARI LETTER GGA;Lo;0;L;;;;;N;;;;;
097C;DEVANAGARI LETTER JJA;Lo;0;L;;;;;N;;;;;
097D;DEVANAGARI LETTER GLOTTAL STOP;Lo;0;L;;;;;N;;;;;
097E;DEVANAGARI LETTER DDDA;Lo;0;L;;;;;N;;;;;
097F;DEVANAGARI LETTER BBA;Lo;0;L;;;;;N;;;;;
0980;BENGALI ANJI;Lo;0;L;;;;;N;;;;;
0981;BENGALI SIGN CANDRABINDU;Mn;0;NSM;;;;;N;;;;;
0982;BENGALI SIGN ANUSVARA;Mc;0;L;;;;;N;;;;;
0983;BENGALI SIGN VISARGA;Mc;0;L;;;;;N;;;;;
0985;BENGALI LETTER A;Lo;0;L;;;;;N;;;;;
0986;BENGALI LETTER AA;Lo;0;L;;;;;N;;;;;
0987;BENGALI LETTER I;Lo;0;L;;;;;N;;;;;
0988;BENGALI LETTER II;Lo;0;L;;;;;N;;;;;
0989;BENGALI LETTER U;Lo;0;L;;;;;N;;;;;
098A;BENGALI LETTER UU;Lo;0;L;;;;;N;;;;;
098B;BENGALI LETTER VOCALIC R;Lo;0;L;;;;;N;;;;;
098C;BENGALI LETTER VOCALIC L;Lo;0;L;;;;;N;;;;;
098F;BENGALI LETTER E;Lo;0;L;;;;;N;;;;;
0990;BENGALI LETTER AI;Lo;0;L;;;;;N;;;;;
0993;BENGALI LETTER O;Lo;0;L;;;;;N;;;;;
0994;BENGALI LETTER AU;Lo;0;L;;;;;N;;;;;
0995;BENGALI LETTER KA;Lo;0;L;;;;;N;;;;;
0996;BENGALI LETTER KHA;Lo;0;L;;;;;N;;;;;
0997;BENGALI LETTER GA;Lo;0;L;;;;;N;;;;;
0998;BENGALI LETTER GHA;Lo;0;L;;;;;N;;;;;
0999;BENGALI LETTER NGA;Lo;0;L;;;;;N;;;;;
099A;BENGALI LETTER CA;Lo;0;L;;;;;N;;;;;
099B;BENGALI LETTER CHA;Lo;0;L;;;;;N;;;;;
099C;BENGALI LETTER JA;Lo;0;L;;;;;N;;;;;
099D;BENGALI LETTER JHA;Lo;0;L;;;;;N;;;;;
099E;BENGALI LETTER NYA;Lo;0;L;;;;;N;;;;;
099F;BENGALI LETTER TTA;Lo;0;L;;;;;N;;;;;
09A0;BENGALI LETTER TTHA;Lo;0;L;;;;;N;;;;;
09A1;BENGALI LETTER DDA;Lo;0;L;;;;;N;;;;;
09A2;BENGALI LETTER DDHA;Lo;0;L;;;;;N;;;;;
09A3;BENGALI LETTER NNA;Lo;0;L;;;;;N;;;;;
09A4;BENGALI LETTER TA;Lo;0;L;;;;;N;;;;;
09A5;BENGALI LETTER THA;Lo;0;L;;;;;N;;;;;
09A6;BENGALI LETTER DA;Lo;0;L;;;;;N;;;;;
09A7;BENGALI LETTER DHA;Lo;0;L;;;;;N;;;;;
09A8;BENGALI LETTER NA;Lo;0;L;;;;;N;;;;;
09AA;BENGALI LETTER PA;Lo;0;L;;;;;N;;;;;
09AB;BENGALI LETTER PHA;Lo;0;L;;;;;N;;;;;
09AC;BENGALI LETTER BA;Lo;0;L;;;;;N;;;;;
09AD;BENGALI LETTER BHA;Lo;0;L;;;;;N;;;;;
09AE;BENGALI LETTER MA;Lo;0;L;;;;;N;;;;;
09AF;BENGALI LETTER YA;Lo;0;L;;;;;N;;;;;
09B0;BENGALI LETTER RA;Lo;0;L;;;;;N;;;;;
09B2;BENGALI LETTER LA;Lo;0;L;;;;;N;;;;;
09B6;BENGALI LETTER SHA;Lo;0;L;;;;;N;;;;;
09B7;BENGALI LETTER SSA;Lo;0;L;;;;;N;;;;;
09B8;BENGALI LETTER SA;Lo;0;L;;;;;N;;;;;
09B9;BENGALI LETTER HA;Lo;0;L;;;;;N;;;;;
09BC;BENGALI SIGN NUKTA;Mn;7;NSM;;;;;N;;;;;
09BD;BENGALI SIGN AVAGRAHA;Lo;0;L;;;;;N;;;;;
09BE;BENGALI VOWEL SIGN AA;Mc;0;L;;;;;N;;;;;
09BF;BENGALI VOWEL SIGN I;Mc;0;L;;;;;N;;;;;
09C0;BENGALI VOWEL SIGN II;Mc;0;L;;;;;N;;;;;
09C1;BENGALI VOWEL SIGN U;Mn;0;NSM;;;;;N;;;;;
09C2;BENGALI VOWEL SIGN UU;Mn;0;NSM;;;;;N;;;;;
09C3;BENGALI VOWEL SIGN VOCALIC R;Mn;0;NSM;;;;;N;;;;;
09C4;BENGALI VOWEL SIGN VOCALIC RR;Mn;0;NSM;;;;;N;;;;;
09C7;BENGALI VOWEL SIGN E;Mc;0;L;;;;;N;;;;;
09C8;BENGALI VOWEL SIGN AI;Mc;0;L;;;;;N;;;;;
09CB;BENGALI VOWEL SIGN O;Mc;0;L;09C7 09BE;;;;N;;;;;
09CC;BENGALI VOWEL SIGN AU;Mc;0;L;09C7 09D7;;;;N;;;;;
09CD;BENGALI SIGN VIRAMA;Mn;9;NSM;;;;;N;;;;;
09CE;BENGALI LETTER KHANDA TA;Lo;0;L;;;;;N;;;;;
09D7;BENGALI AU LENGTH MARK;Mc;0;L;;;;;N;;;;;
09DC;BENGALI LETTER RRA;Lo;0;L;09A1 09BC;;;;N;;;;;
09DD;BENGALI LETTER RHA;Lo;0;L;09A2 09BC;;;;N;;;;;
09DF;BENGALI LETTER YYA;Lo;0;L;09AF 09BC;;;;N;;;;;
09E0;BENGALI LETTER VOCALIC RR;Lo;0;L;;;;;N;;;;;
09E1;BENGALI LETTER VOCALIC LL;Lo;0;L;;;;;N;;;;;
09E2;BENGALI VOWEL SIGN VOCALIC L;Mn;0;NSM;;;;;N;;;;;
09E3;BENGALI VOWEL SIGN VOCALIC LL;Mn;0;NSM;;;;;N;;;;;
09E6;BENGALI DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
09E7;BENGALI DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
09E8;BENGALI DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
09E9;BENGALI DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
09EA;BENGALI DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
09EB;BENGALI DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
09EC;BENGALI DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
09ED;BENGALI DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
09EE;BENGALI DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
09EF;BENGALI DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
09F0;BENGALI LETTER RA WITH MIDDLE DIAGONAL;Lo;0;L;;;;;N;;;;;
09F1;BENGALI LETTER RA WITH LOWER DIAGONAL;Lo;0;L;;;;;N;BENGALI LETTER VA WITH LOWER DIAGONAL;;;;
09F2;BENGALI RUPEE MARK;Sc;0;ET;;;;;N;;;;;
09F3;BENGALI RUPEE SIGN;Sc;0;ET;;;;;N;;;;;
09F4;BENGALI CURRENCY NUMERATOR ONE;No;0;L;;;;1/16;N;;;;;
09F5;BENGALI CURRENCY NUMERATOR TWO;No;0;L;;;;1/8;N;;;;;
09F6;BENGALI CURRENCY NUMERATOR THREE;No;0;L;;;;3/16;N;;;;;
09F7;BENGALI CURRENCY NUMERATOR FOUR;No;0;L;;;;1/4;N;;;;;
09F8;BENGALI CURRENCY NUMERATOR ONE LESS THAN THE DENOMINATOR;No;0;L;;;;3/4;N;;;;;
09F9;BENGALI CURRENCY DENOMINATOR SIXTEEN;No;0;L;;;;16;N;;;;;
09FA;BENGALI ISSHAR;So;0;L;;;;;N;;;;;
09FB;BENGALI GANDA MARK;Sc;0;ET;;;;;N;;;;;
09FC;BENGALI LETTER VEDIC ANUSVARA;Lo;0;L;;;;;N;;;;;
09FD;BENGALI ABBREVIATION SIGN;Po;0;L;;;;;N;;;;;
09FE;BENGALI SANDHI MARK;Mn;230;NSM;;;;;N;;;;;
0A01;GURMUKHI SIGN ADAK BINDI;Mn;0;NSM;;;;;N;;;;;
0A02;GURMUKHI SIGN BINDI;Mn;0;NSM;;;;;N;;;;;
0A03;GURMUKHI SIGN VISARGA;Mc;0;L;;;;;N;;;;;
0A05;GURMUKHI LETTER A;Lo;0;L;;;;;N;;;;;
0A06;GURMUKHI LETTER AA;Lo;0;L;;;;;N;;;;;
0A07;GURMUKHI LETTER I;Lo;0;L;;;;;N;;;;;
0A08;GURMUKHI LETTER II;Lo;0;L;;;;;N;;;;;
0A09;GURMUKHI LETTER U;Lo;0;L;;;;;N;;;;;
0A0A;GURMUKHI LETTER UU;Lo;0;L;;;;;N;;;;;
0A0F;GURMUKHI LETTER EE;Lo;0;L;;;;;N;;;;;
0A10;GURMUKHI LETTER AI;Lo;0;L;;;;;N;;;;;
0A13;GURMUKHI LETTER OO;Lo;0;L;;;;;N;;;;;
0A14;GURMUKHI LETTER AU;Lo;0;L;;;;;N;;;;;
0A15;GURMUKHI LETTER KA;Lo;0;L;;;;;N;;;;;
0A16;GURMUKHI LETTER KHA;Lo;0;L;;;;;N;;;;;
0A17;GURMUKHI LETTER GA;Lo;0;L;;;;;N;;;;;
0A18;GURMUKHI LETTER GHA;Lo;0;L;;;;;N;;;;;
0A19;GURMUKHI LETTER NGA;Lo;0;L;;;;;N;;;;;
0A1A;GURMUKHI LETTER CA;Lo;0;L;;;;;N;;;;;
0A1B;GURMUKHI LETTER CHA;Lo;0;L;;;;;N;;;;;
0A1C;GURMUKHI LETTER JA;Lo;0;L;;;;;N;;;;;
0A1D;GURMUKHI LETTER JHA;Lo;0;L;;;;;N;;;;;
0A1E;GURMUKHI LETTER NYA;Lo;0;L;;;;;N;;;;;
0A1F;GURMUKHI LETTER TTA;Lo;0;L;;;;;N;;;;;
0A20;GURMUKHI LETTER TTHA;Lo;0;L;;;;;N;;;;;
0A21;GURMUKHI LETTER DDA;Lo;0;L;;;;;N;;;;;
0A22;GURMUKHI LETTER DDHA;Lo;0;L;;;;;N;;;;;
0A23;GURMUKHI LETTER NNA;Lo;0;L;;;;;N;;;;;
0A24;GURMUKHI LETTER TA;Lo;0;L;;;;;N;;;;;
0A25;GURMUKHI LETTER THA;Lo;0;L;;;;;N;;;;;
0A26;GURMUKHI LETTER DA;Lo;0;L;;;;;N;;;;;
0A27;GURMUKHI LETTER DHA;Lo;0;L;;;;;N;;;;;
0A28;GURMUKHI LETTER NA;Lo;0;L;;;;;N;;;;;
0A2A;GURMUKHI LETTER PA;Lo;0;L;;;;;N;;;;;
0A2B;GURMUKHI LETTER PHA;Lo;0;L;;;;;N;;;;;
0A2C;GURMUKHI LETTER BA;Lo;0;L;;;;;N;;;;;
0A2D;GURMUKHI LETTER BHA;Lo;0;L;;;;;N;;;;;
0A2E;GURMUKHI LETTER MA;Lo;0;L;;;;;N;;;;;
0A2F;GURMUKHI LETTER YA;Lo;0;L;;;;;N;;;;;
0A30;GURMUKHI LETTER RA;Lo;0;L;;;;;N;;;;;
0A32;GURMUKHI LETTER LA;Lo;0;L;;;;;N;;;;;
0A33;GURMUKHI LETTER LLA;Lo;0;L;0A32 0A3C;;;;N;;;;;
0A35;GURMUKHI LETTER VA;Lo;0;L;;;;;N;;;;;
0A36;GURMUKHI LETTER SHA;Lo;0;L;0A38 0A3C;;;;N;;;;;
0A38;GURMUKHI LETTER SA;Lo;0;L;;;;;N;;;;;
0A39;GURMUKHI LETTER HA;Lo;0;L;;;;;N;;;;;
0A3C;GURMUKHI SIGN NUKTA;Mn;7;NSM;;;;;N;;;;;
0A3E;GURMUKHI VOWEL SIGN AA;Mc;0;L;;;;;N;;;;;
0A3F;GURMUKHI VOWEL SIGN I;Mc;0;L;;;;;N;;;;;
0A40;GURMUKHI VOWEL SIGN II;Mc;0;L;;;;;N;;;;;
0A41;GURMUKHI VOWEL SIGN U;Mn;0;NSM;;;;;N;;;;;
0A42;GURMUKHI VOWEL SIGN UU;Mn;0;NSM;;;;;N;;;;;
0A47;GURMUKHI VOWEL SIGN EE;Mn;0;NSM;;;;;N;;;;;
0A48;GURMUKHI VOWEL SIGN AI;Mn;0;NSM;;;;;N;;;;;
0A4B;GURMUKHI VOWEL SIGN OO;Mn;0;NSM;;;;;N;;;;;
0A4C;GURMUKHI VOWEL SIGN AU;Mn;0;NSM;;;;;N;;;;;
0A4D;GURMUKHI SIGN VIRAMA;Mn;9;NSM;;;;;N;;;;;
0A51;GURMUKHI SIGN UDAAT;Mn;0;NSM;;;;;N;;;;;
0A59;GURMUKHI LETTER KHHA;Lo;0;L;0A16 0A3C;;;;N;;;;;
0A5A;GURMUKHI LETTER GHHA;Lo;0;L;0A17 0A3C;;;;N;;;;;
0A5B;GURMUKHI LETTER ZA;Lo;0;L;0A1C 0A3C;;;;N;;;;;
0A5C;GURMUKHI LETTER RRA;Lo;0;L;;;;;N;;;;;
0A5E;GURMUKHI LETTER FA;Lo;0;L;0A2B 0A3C;;;;N;;;;;
0A66;GURMUKHI DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
0A67;GURMUKHI DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
0A68;GURMUKHI DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
0A69;GURMUKHI DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
0A6A;GURMUKHI DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
0A6B;GURMUKHI DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
0A6C;GURMUKHI DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
0A6D;GURMUKHI DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
0A6E;GURMUKHI DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
0A6F;GURMUKHI DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
0A70;GURMUKHI TIPPI;Mn;0;NSM;;;;;N;;;;;
0A71;GURMUKHI ADDAK;Mn;0;NSM;;;;;N;;;;;
0A72;GURMUKHI IRI;Lo;0;L;;;;;N;;;;;
0A73;GURMUKHI URA;Lo;0;L;;;;;N;;;;;
0A74;GURMUKHI EK ONKAR;Lo;0;L;;;;;N;;;;;
0A75;GURMUKHI SIGN YAKASH;Mn;0;NSM;;;;;N;;;;;
0A76;GURMUKHI ABBREVIATION SIGN;Po;0;L;;;;;N;;;;;
0A81;GUJARATI SIGN CANDRABINDU;Mn;0;NSM;;;;;N;;;;;
0A82;GUJARATI SIGN ANUSVARA;Mn;0;NSM;;;;;N;;;;;
0A83;GUJARATI SIGN VISARGA;Mc;0;L;;;;;N;;;;;
0A85;GUJARATI LETTER A;Lo;0;L;;;;;N;;;;;
0A86;GUJARATI LETTER AA;Lo;0;L;;;;;N;;;;;
0A87;GUJARATI LETTER I;Lo;0;L;;;;;N;;;;;
0A88;GUJARATI LETTER II;Lo;0;L;;;;;N;;;;;
0A89;GUJARATI LETTER U;Lo;0;L;;;;;N;;;;;
0A8A;GUJARATI LETTER UU;Lo;0;L;;;;;N;;;;;
0A8B;GUJARATI LETTER VOCALIC R;Lo;0;L;;;;;N;;;;;
0A8C;GUJARATI LETTER VOCALIC L;Lo;0;L;;;;;N;;;;;
0A8D;GUJARATI VOWEL CANDRA E;Lo;0;L;;;;;N;;;;;
0A8F;GUJARATI LETTER E;Lo;0;L;;;;;N;;;;;
0A90;GUJARATI LETTER AI;Lo;0;L;;;;;N;;;;;
0A91;GUJARATI VOWEL CANDRA O;Lo;0;L;;;;;N;;;;;
0A93;GUJARATI LETTER O;Lo;0;L;;;;;N;;;;;
0A94;GUJARATI LETTER AU;Lo;0;L;;;;;N;;;;;
0A95;GUJARATI LETTER KA;Lo;0;L;;;;;N;;;;;
0A96;GUJARATI LETTER KHA;Lo;0;L;;;;;N;;;;;
0A97;GUJARATI LETTER GA;Lo;0;L;;;;;N;;;;;
0A98;GUJARATI LETTER GHA;Lo;0;L;;;;;N;;;;;
0A99;GUJARATI LETTER NGA;Lo;0;L;;;;;N;;;;;
0A9A;GUJARATI LETTER CA;Lo;0;L;;;;;N;;;;;
0A9B;GUJARATI LETTER CHA;Lo;0;L;;;;;N;;;;;
0A9C;GUJARATI LETTER JA;Lo;0;L;;;;;N;;;;;
0A9D;GUJARATI LETTER JHA;Lo;0;L;;;;;N;;;;;
0A9E;GUJARATI LETTER NYA;Lo;0;L;;;;;N;;;;;
0A9F;GUJARATI LETTER TTA;Lo;0;L;;;;;N;;;;;
0AA0;GUJARATI LETTER TTHA;Lo;0;L;;;;;N;;;;;
0AA1;GUJARATI LETTER DDA;Lo;0;L;;;;;N;;;;;
0AA2;GUJARATI LETTER DDHA;Lo;0;L;;;;;N;;;;;
0AA3;GUJARATI LETTER NNA;Lo;0;L;;;;;N;;;;;
0AA4;GUJARATI LETTER TA;Lo;0;L;;;;;N;;;;;
0AA5;GUJARATI LETTER THA;Lo;0;L;;;;;N;;;;;
0AA6;GUJARATI LETTER DA;Lo;0;L;;;;;N;;;;;
0AA7;GUJARATI LETTER DHA;Lo;0;L;;;;;N;;;;;
0AA8;GUJARATI LETTER NA;Lo;0;L;;;;;N;;;;;
0AAA;GUJARATI LETTER PA;Lo;0;L;;;;;N;;;;;
0AAB;GUJARATI LETTER PHA;Lo;0;L;;;;;N;;;;;
0AAC;GUJARATI LETTER BA;Lo;0;L;;;;;N;;;;;
0AAD;GUJARATI LETTER BHA;Lo;0;L;;;;;N;;;;;
0AAE;GUJARATI LETTER MA;Lo;0;L;;;;;N;;;;;
0AAF;GUJARATI LETTER YA;Lo;0;L;;;;;N;;;;;
0AB0;GUJARATI LETTER RA;Lo;0;L;;;;;N;;;;;
0AB2;GUJARATI LETTER LA;Lo;0;L;;;;;N;;;;;
0AB3;GUJARATI LETTER LLA;Lo;0;L;;;;;N;;;;;
0AB5;GUJARATI LETTER VA;Lo;0;L;;;;;N;;;;;
0AB6;GUJARATI LETTER SHA;Lo;0;L;;;;;N;;;;;
0AB7;GUJARATI LETTER SSA;Lo;0;L;;;;;N;;;;;
0AB8;GUJARATI LETTER SA;Lo;0;L;;;;;N;;;;;
0AB9;GUJARATI LETTER HA;Lo;0;L;;;;;N;;;;;
0ABC;GUJARATI SIGN NUKTA;Mn;7;NSM;;;;;N;;;;;
0ABD;GUJARATI SIGN AVAGRAHA;Lo;0;L;;;;;N;;;;;
0ABE;GUJARATI VOWEL SIGN AA;Mc;0;L;;;;;N;;;;;
0ABF;GUJARATI VOWEL SIGN I;Mc;0;L;;;;;N;;;;;
0AC0;GUJARATI VOWEL SIGN II;Mc;0;L;;;;;N;;;;;
0AC1;GUJARATI VOWEL SIGN U;Mn;0;NSM;;;;;N;;;;;
0AC2;GUJARATI VOWEL SIGN UU;Mn;0;NSM;;;;;N;;;;;
0AC3;GUJARATI VOWEL SIGN VOCALIC R;Mn;0;NSM;;;;;N;;;;;
0AC4;GUJARATI VOWEL SIGN VOCALIC RR;Mn;0;NSM;;;;;N;;;;;
0AC5;GUJARATI VOWEL SIGN CANDRA E;Mn;0;NSM;;;;;N;;;;;
0AC7;GUJARATI VOWEL SIGN E;Mn;0;NSM;;;;;N;;;;;
0AC8;GUJARATI VOWEL SIGN AI;Mn;0;NSM;;;;;N;;;;;
0AC9;GUJARATI VOWEL SIGN CANDRA O;Mc;0;L;;;;;N;;;;;
0ACB;GUJARATI VOWEL SIGN O;Mc;0;L;;;;;N;;;;;
0ACC;GUJARATI VOWEL SIGN AU;Mc;0;L;;;;;N;;;;;
0ACD;GUJARATI SIGN VIRAMA;Mn;9;NSM;;;;;N;;;;;
0AD0;GUJARATI OM;Lo;0;L;;;;;N;;;;;
0AE0;GUJARATI LETTER VOCALIC RR;Lo;0;L;;;;;N;;;;;
0AE1;GUJARATI LETTER VOCALIC LL;Lo;0;L;;;;;N;;;;;
0AE2;GUJARATI VOWEL SIGN VOCALIC L;Mn;0;NSM;;;;;N;;;;;
0AE3;GUJARATI VOWEL SIGN VOCALIC LL;Mn;0;NSM;;;;;N;;;;;
0AE6;GUJARATI DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
0AE7;GUJARATI DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
0AE8;GUJARATI DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
0AE9;GUJARATI DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
0AEA;GUJARATI DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
0AEB;GUJARATI DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
0AEC;GUJARATI DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
0AED;GUJARATI DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
0AEE;GUJARATI DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
0AEF;GUJARATI DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
0AF0;GUJARATI ABBREVIATION SIGN;Po;0;L;;;;;N;;;;;
0AF1;GUJARATI RUPEE SIGN;Sc;0;ET;;;;;N;;;;;
0AF9;GUJARATI LETTER ZHA;Lo;0;L;;;;;N;;;;;
0AFA;GUJARATI SIGN SUKUN;Mn;0;NSM;;;;;N;;;;;
0AFB;GUJARATI SIGN SHADDA;Mn;0;NSM;;;;;N;;;;;
0AFC;GUJARATI SIGN MADDAH;Mn;0;NSM;;;;;N;;;;;
0AFD;GUJARATI SIGN THREE-DOT NUKTA ABOVE;Mn;0;NSM;;;;;N;;;;;
0AFE;GUJARATI SIGN CIRCLE NUKTA ABOVE;Mn;0;NSM;;;;;N;;;;;
0AFF;GUJARATI SIGN TWO-CIRCLE NUKTA ABOVE;Mn;0;NSM;;;;;N;;;;;
0B01;ORIYA SIGN CANDRABINDU;Mn;0;NSM;;;;;N;;;;;
0B02;ORIYA SIGN ANUSVARA;Mc;0;L;;;;;N;;;;;
0B03;ORIYA SIGN VISARGA;Mc;0;L;;;;;N;;;;;
0B05;ORIYA LETTER A;Lo;0;L;;;;;N;;;;;
0B06;ORIYA LETTER AA;Lo;0;L;;;;;N;;;;;
0B07;ORIYA LETTER I;Lo;0;L;;;;;N;;;;;
0B08;ORIYA LETTER II;Lo;0;L;;;;;N;;;;;
0B09;ORIYA LETTER U;Lo;0;L;;;;;N;;;;;
0B0A;ORIYA LETTER UU;Lo;0;L;;;;;N;;;;;
0B0B;ORIYA LETTER VOCALIC R;Lo;0;L;;;;;N;;;;;
0B0C;ORIYA LETTER VOCALIC L;Lo;0;L;;;;;N;;;;;
0B0F;ORIYA LETTER E;Lo;0;L;;;;;N;;;;;
0B10;ORIYA LETTER AI;Lo;0;L;;;;;N;;;;;
0B13;ORIYA LETTER O;Lo;0;L;;;;;N;;;;;
0B14;ORIYA LETTER AU;Lo;0;L;;;;;N;;;;;
0B15;ORIYA LETTER KA;Lo;0;L;;;;;N;;;;;
0B16;ORIYA LETTER KHA;Lo;0;L;;;;;N;;;;;
0B17;ORIYA LETTER GA;Lo;0;L;;;;;N;;;;;
0B18;ORIYA LETTER GHA;Lo;0;L;;;;;N;;;;;
0B19;ORIYA LETTER NGA;Lo;0;L;;;;;N;;;;;
0B1A;ORIYA LETTER CA;Lo;0;L;;;;;N;;;;;
0B1B;ORIYA LETTER CHA;Lo;0;L;;;;;N;;;;;
0B1C;ORIYA LETTER JA;Lo;0;L;;;;;N;;;;;
0B1D;ORIYA LETTER JHA;Lo;0;L;;;;;N;;;;;
0B1E;ORIYA LETTER NYA;Lo;0;L;;;;;N;;;;;
0B1F;ORIYA LETTER TTA;Lo;0;L;;;;;N;;;;;
0B20;ORIYA LETTER TTHA;Lo;0;L;;;;;N;;;;;
0B21;ORIYA LETTER DDA;Lo;0;L;;;;;N;;;;;
0B22;ORIYA LETTER DDHA;Lo;0;L;;;;;N;;;;;
0B23;ORIYA LETTER NNA;Lo;0;L;;;;;N;;;;;
0B24;ORIYA LETTER TA;Lo;0;L;;;;;N;;;;;
0B25;ORIYA LETTER THA;Lo;0;L;;;;;N;;;;;
0B26;ORIYA LETTER DA;Lo;0;L;;;;;N;;;;;
0B27;ORIYA LETTER DHA;Lo;0;L;;;;;N;;;;;
0B28;ORIYA LETTER NA;Lo;0;L;;;;;N;;;;;
0B2A;ORIYA LETTER PA;Lo;0;L;;;;;N;;;;;
0B2B;ORIYA LETTER PHA;Lo;0;L;;;;;N;;;;;
0B2C;ORIYA LETTER BA;Lo;0;L;;;;;N;;;;;
0B2D;ORIYA LETTER BHA;Lo;0;L;;;;;N;;;;;
0B2E;ORIYA LETTER MA;Lo;0;L;;;;;N;;;;;
0B2F;ORIYA LETTER YA;Lo;0;L;;;;;N;;;;;
0B30;ORIYA LETTER RA;Lo;0;L;;;;;N;;;;;
0B32;ORIYA LETTER LA;Lo;0;L;;;;;N;;;;;
0B33;ORIYA LETTER LLA;Lo;0;L;;;;;N;;;;;
0B35;ORIYA LETTER VA;Lo;0;L;;;;;N;;;;;
0B36;ORIYA LETTER SHA;Lo;0;L;;;;;N;;;;;
0B37;ORIYA LETTER SSA;Lo;0;L;;;;;N;;;;;
0B38;ORIYA LETTER SA;Lo;0;L;;;;;N;;;;;
0B39;ORIYA LETTER HA;Lo;0;L;;;;;N;;;;;
0B3C;ORIYA SIGN NUKTA;Mn;7;NSM;;;;;N;;;;;
0B3D;ORIYA SIGN AVAGRAHA;Lo;0;L;;;;;N;;;;;
0B3E;ORIYA VOWEL SIGN AA;Mc;0;L;;;;;N;;;;;
0B3F;ORIYA VOWEL SIGN I;Mn;0;NSM;;;;;N;;;;;
0B40;ORIYA VOWEL SIGN II;Mc;0;L;;;;;N;;;;;
0B41;ORIYA VOWEL SIGN U;Mn;0;NSM;;;;;N;;;;;
0B42;ORIYA VOWEL SIGN UU;Mn;0;NSM;;;;;N;;;;;
0B43;ORIYA VOWEL SIGN VOCALIC R;Mn;0;NSM;;;;;N;;;;;
0B44;ORIYA VOWEL SIGN VOCALIC RR;Mn;0;NSM;;;;;N;;;;;
0B47;ORIYA VOWEL SIGN E;Mc;0;L;;;;;N;;;;;
0B48;ORIYA VOWEL SIGN AI;Mc;0;L;0B47 0B56;;;;N;;;;;
0B4B;ORIYA VOWEL SIGN O;Mc;0;L;0B47 0B3E;;;;N;;;;;
0B4C;ORIYA VOWEL SIGN AU;Mc;0;L;0B47 0B57;;;;N;;;;;
0B4D;ORIYA SIGN VIRAMA;Mn;9;NSM;;;;;N;;;;;
0B55;ORIYA SIGN OVERLINE;Mn;0;NSM;;;;;N;;;;;
0B56;ORIYA AI LENGTH MARK;Mn;0;NSM;;;;;N;;;;;
0B57;ORIYA AU LENGTH MARK;Mc;0;L;;;;;N;;;;;
0B5C;ORIYA LETTER RRA;Lo;0;L;0B21 0B3C;;;;N;;;;;
0B5D;ORIYA LETTER RHA;Lo;0;L;0B22 0B3C;;;;N;;;;;
0B5F;ORIYA LETTER YYA;Lo;0;L;;;;;N;;;;;
0B60;ORIYA LETTER VOCALIC RR;Lo;0;L;;;;;N;;;;;
0B61;ORIYA LETTER VOCALIC LL;Lo;0;L;;;;;N;;;;;
0B62;ORIYA VOWEL SIGN VOCALIC L;Mn;0;NSM;;;;;N;;;;;
0B63;ORIYA VOWEL SIGN VOCALIC LL;Mn;0;NSM;;;;;N;;;;;
0B66;ORIYA DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
0B67;ORIYA DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
0B68;ORIYA DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
0B69;ORIYA DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
0B6A;ORIYA DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
0B6B;ORIYA DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
0B6C;ORIYA DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
0B6D;ORIYA DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
0B6E;ORIYA DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
0B6F;ORIYA DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
0B70;ORIYA ISSHAR;So;0;L;;;;;N;;;;;
0B71;ORIYA LETTER WA;Lo;0;L;;;;;N;;;;;
0B72;ORIYA FRACTION ONE QUARTER;No;0;L;;;;1/4;N;;;;;
0B73;ORIYA FRACTION ONE HALF;No;0;L;;;;1/2;N;;;;;
0B74;ORIYA FRACTION THREE QUARTERS;No;0;L;;;;3/4;N;;;;;
0B75;ORIYA FRACTION ONE SIXTEENTH;No;0;L;;;;1/16;N;;;;;
0B76;ORIYA FRACTION ONE EIGHTH;No;0;L;;;;1/8;N;;;;;
0B77;ORIYA FRACTION THREE SIXTEENTHS;No;0;L;;;;3/16;N;;;;;
0B82;TAMIL SIGN ANUSVARA;Mn;0;NSM;;;;;N;;;;;
0B83;TAMIL SIGN VISARGA;Lo;0;L;;;;;N;;;;;
0B85;TAMIL LETTER A;Lo;0;L;;;;;N;;;;;
0B86;TAMIL LETTER AA;Lo;0;L;;;;;N;;;;;
0B87;TAMIL LETTER I;Lo;0;L;;;;;N;;;;;
0B88;TAMIL LETTER II;Lo;0;L;;;;;N;;;;;
0B89;TAMIL LETTER U;Lo;0;L;;;;;N;;;;;
0B8A;TAMIL LETTER UU;Lo;0;L;;;;;N;;;;;
0B8E;TAMIL LETTER E;Lo;0;L;;;;;N;;;;;
0B8F;TAMIL LETTER EE;Lo;0;L;;;;;N;;;;;
0B90;TAMIL LETTER AI;Lo;0;L;;;;;N;;;;;
0B92;TAMIL LETTER O;Lo;0;L;;;;;N;;;;;
0B93;TAMIL LETTER OO;Lo;0;L;;;;;N;;;;;
0B94;TAMIL LETTER AU;Lo;0;L;0B92 0BD7;;;;N;;;;;
0B95;TAMIL LETTER KA;Lo;0;L;;;;;N;;;;;
0B99;TAMIL LETTER NGA;Lo;0;L;;;;;N;;;;;
0B9A;TAMIL LETTER CA;Lo;0;L;;;;;N;;;;;
0B9C;TAMIL LETTER JA;Lo;0;L;;;;;N;;;;;
0B9E;TAMIL LETTER NYA;Lo;0;L;;;;;N;;;;;
0B9F;TAMIL LETTER TTA;Lo;0;L;;;;;N;;;;;
0BA3;TAMIL LETTER NNA;Lo;0;L;;;;;N;;;;;
0BA4;TAMIL LETTER TA;Lo;0;L;;;;;N;;;;;
0BA8;TAMIL LETTER NA;Lo;0;L;;;;;N;;;;;
0BA9;TAMIL LETTER NNNA;Lo;0;L;;;;;N;;;;;
0BAA;TAMIL LETTER PA;Lo;0;L;;;;;N;;;;;
0BAE;TAMIL LETTER MA;Lo;0;L;;;;;N;;;;;
0BAF;TAMIL LETTER YA;Lo;0;L;;;;;N;;;;;
0BB0;TAMIL LETTER RA;Lo;0;L;;;;;N;;;;;
0BB1;TAMIL LETTER RRA;Lo;0;L;;;;;N;;;;;
0BB2;TAMIL LETTER LA;Lo;0;L;;;;;N;;;;;
0BB3;TAMIL LETTER LLA;Lo;0;L;;;;;N;;;;;
0BB4;TAMIL LETTER LLLA;Lo;0;L;;;;;N;;;;;
0BB5;TAMIL LETTER VA;Lo;0;L;;;;;N;;;;;
0BB6;TAMIL LETTER SHA;Lo;0;L;;;;;N;;;;;
0BB7;TAMIL LETTER SSA;Lo;0;L;;;;;N;;;;;
0BB8;TAMIL LETTER SA;Lo;0;L;;;;;N;;;;;
0BB9;TAMIL LETTER HA;Lo;0;L;;;;;N;;;;;
0BBE;TAMIL VOWEL SIGN AA;Mc;0;L;;;;;N;;;;;
0BBF;TAMIL VOWEL SIGN I;Mc;0;L;;;;;N;;;;;
0BC0;TAMIL VOWEL SIGN II;Mn;0;NSM;;;;;N;;;;;
0BC1;TAMIL VOWEL SIGN U;Mc;0;L;;;;;N;;;;;
0BC2;TAMIL VOWEL SIGN UU;Mc;0;L;;;;;N;;;;;
0BC6;TAMIL VOWEL SIGN E;Mc;0;L;;;;;N;;;;;
0BC7;TAMIL VOWEL SIGN EE;Mc;0;L;;;;;N;;;;;
0BC8;TAMIL VOWEL SIGN AI;Mc;0;L;;;;;N;;;;;
0BCA;TAMIL VOWEL SIGN O;Mc;0;L;0BC6 0BBE;;;;N;;;;;
0BCB;TAMIL VOWEL SIGN OO;Mc;0;L;0BC7 0BBE;;;;N;;;;;
0BCC;TAMIL VOWEL SIGN AU;Mc;0;L;0BC6 0BD7;;;;N;;;;;
0BCD;TAMIL SIGN VIRAMA;Mn;9;NSM;;;;;N;;;;;
0BD0;TAMIL OM;Lo;0;L;;;;;N;;;;;
0BD7;TAMIL AU LENGTH MARK;Mc;0;L;;;;;N;;;;;
0BE6;TAMIL DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
0BE7;TAMIL DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
0BE8;TAMIL DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
0BE9;TAMIL DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
0BEA;TAMIL DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
0BEB;TAMIL DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
0BEC;TAMIL DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
0BED;TAMIL DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
0BEE;TAMIL DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
0BEF;TAMIL DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
0BF0;TAMIL NUMBER TEN;No;0;L;;;;10;N;;;;;
0BF1;TAMIL NUMBER ONE HUNDRED;No;0;L;;;;100;N;;;;;
0BF2;TAMIL NUMBER ONE THOUSAND;No;0;L;;;;1000;N;;;;;
0BF3;TAMIL DAY SIGN;So;0;ON;;;;;N;;;;;
0BF4;TAMIL MONTH SIGN;So;0;ON;;;;;N;;;;;
0BF5;TAMIL YEAR SIGN;So;0;ON;;;;;N;;;;;
0BF6;TAMIL DEBIT SIGN;So;0;ON;;;;;N;;;;;
0BF7;TAMIL CREDIT SIGN;So;0;ON;;;;;N;;;;;
0BF8;TAMIL AS ABOVE SIGN;So;0;ON;;;;;N;;;;;
0BF9;TAMIL RUPEE SIGN;Sc;0;ET;;;;;N;;;;;
0BFA;TAMIL NUMBER SIGN;So;0;ON;;;;;N;;;;;
0C00;TELUGU SIGN COMBINING CANDRABINDU ABOVE;Mn;0;NSM;;;;;N;;;;;
0C01;TELUGU SIGN CANDRABINDU;Mc;0;L;;;;;N;;;;;
0C02;TELUGU SIGN ANUSVARA;Mc;0;L;;;;;N;;;;;
0C03;TELUGU SIGN VISARGA;Mc;0;L;;;;;N;;;;;
0C04;TELUGU SIGN COMBINING ANUSVARA ABOVE;Mn;0;NSM;;;;;N;;;;;
0C05;TELUGU LETTER A;Lo;0;L;;;;;N;;;;;
0C06;TELUGU LETTER AA;Lo;0;L;;;;;N;;;;;
0C07;TELUGU LETTER I;Lo;0;L;;;;;N;;;;;
0C08;TELUGU LETTER II;Lo;0;L;;;;;N;;;;;
0C09;TELUGU LETTER U;Lo;0;L;;;;;N;;;;;
0C0A;TELUGU LETTER UU;Lo;0;L;;;;;N;;;;;
0C0B;TELUGU LETTER VOCALIC R;Lo;0;L;;;;;N;;;;;
0C0C;TELUGU LETTER VOCALIC L;Lo;0;L;;;;;N;;;;;
0C0E;TELUGU LETTER E;Lo;0;L;;;;;N;;;;;
0C0F;TELUGU LETTER EE;Lo;0;L;;;;;N;;;;;
0C10;TELUGU LETTER AI;Lo;0;L;;;;;N;;;;;
0C12;TELUGU LETTER O;Lo;0;L;;;;;N;;;;;
0C13;TELUGU LETTER OO;Lo;0;L;;;;;N;;;;;
0C14;TELUGU LETTER AU;Lo;0;L;;;;;N;;;;;
0C15;TELUGU LETTER KA;Lo;0;L;;;;;N;;;;;
0C16;TELUGU LETTER KHA;Lo;0;L;;;;;N;;;;;
0C17;TELUGU LETTER GA;Lo;0;L;;;;;N;;;;;
0C18;TELUGU LETTER GHA;Lo;0;L;;;;;N;;;;;
0C19;TELUGU LETTER NGA;Lo;0;L;;;;;N;;;;;
0C1A;TELUGU LETTER CA;Lo;0;L;;;;;N;;;;;
0C1B;TELUGU LETTER CHA;Lo;0;L;;;;;N;;;;;
0C1C;TELUGU LETTER JA;Lo;0;L;;;;;N;;;;;
0C1D;TELUGU LETTER JHA;Lo;0;L;;;;;N;;;;;
0C1E;TELUGU LETTER NYA;Lo;0;L;;;;;N;;;;;
0C1F;TELUGU LETTER TTA;Lo;0;L;;;;;N;;;;;
0C20;TELUGU LETTER TTHA;Lo;0;L;;;;;N;;;;;
0C21;TELUGU LETTER DDA;Lo;0;L;;;;;N;;;;;
0C22;TELUGU LETTER DDHA;Lo;0;L;;;;;N;;;;;
0C23;TELUGU LETTER NNA;Lo;0;L;;;;;N;;;;;
0C24;TELUGU LETTER TA;Lo;0;L;;;;;N;;;;;
0C25;TELUGU LETTER THA;Lo;0;L;;;;;N;;;;;
0C26;TELUGU LETTER DA;Lo;0;L;;;;;N;;;;;
0C27;TELUGU LETTER DHA;Lo;0;L;;;;;N;;;;;
0C28;TELUGU LETTER NA;Lo;0;L;;;;;N;;;;;
0C2A;TELUGU LETTER PA;Lo;0;L;;;;;N;;;;;
0C2B;TELUGU LETTER PHA;Lo;0;L;;;;;N;;;;;
0C2C;TELUGU LETTER BA;Lo;0;L;;;;;N;;;;;
0C2D;TELUGU LETTER BHA;Lo;0;L;;;;;N;;;;;
0C2E;TELUGU LETTER MA;Lo;0;L;;;;;N;;;;;
0C2F;TELUGU LETTER YA;Lo;0;L;;;;;N;;;;;
0C30;TELUGU LETTER RA;Lo;0;L;;;;;N;;;;;
0C31;TELUGU LETTER RRA;Lo;0;L;;;;;N;;;;;
0C32;TELUGU LETTER LA;Lo;0;L;;;;;N;;;;;
0C33;TELUGU LETTER LLA;Lo;0;L;;;;;N;;;;;
0C34;TELUGU LETTER LLLA;Lo;0;L;;;;;N;;;;;
0C35;TELUGU LETTER VA;Lo;0;L;;;;;N;;;;;
0C36;TELUGU LETTER SHA;Lo;0;L;;;;;N;;;;;
0C37;TELUGU LETTER SSA;Lo;0;L;;;;;N;;;;;
0C38;TELUGU LETTER SA;Lo;0;L;;;;;N;;;;;
0C39;TELUGU LETTER HA;Lo;0;L;;;;;N;;;;;
0C3C;TELUGU SIGN NUKTA;Mn;7;NSM;;;;;N;;;;;
0C3D;TELUGU SIGN AVAGRAHA;Lo;0;L;;;;;N;;;;;
0C3E;TELUGU VOWEL SIGN AA;Mn;0;NSM;;;;;N;;;;;
0C3F;TELUGU VOWEL SIGN I;Mn;0;NSM;;;;;N;;;;;
0C40;TELUGU VOWEL SIGN II;Mn;0;NSM;;;;;N;;;;;
0C41;TELUGU VOWEL SIGN U;Mc;0;L;;;;;N;;;;;
0C42;TELUGU VOWEL SIGN UU;Mc;0;L;;;;;N;;;;;
0C43;TELUGU VOWEL SIGN VOCALIC R;Mc;0;L;;;;;N;;;;;
0C44;TELUGU VOWEL SIGN VOCALIC RR;Mc;0;L;;;;;N;;;;;
0C46;TELUGU VOWEL SIGN E;Mn;0;NSM;;;;;N;;;;;
0C47;TELUGU VOWEL SIGN EE;Mn;0;NSM;;;;;N;;;;;
0C48;TELUGU VOWEL SIGN AI;Mn;0;NSM;0C46 0C56;;;;N;;;;;
0C4A;TELUGU VOWEL SIGN O;Mn;0;NSM;;;;;N;;;;;
0C4B;TELUGU VOWEL SIGN OO;Mn;0;NSM;;;;;N;;;;;
0C4C;TELUGU VOWEL SIGN AU;Mn;0;NSM;;;;;N;;;;;
0C4D;TELUGU SIGN VIRAMA;Mn;9;NSM;;;;;N;;;;;
0C55;TELUGU LENGTH MARK;Mn;84;NSM;;;;;N;;;;;
0C56;TELUGU AI LENGTH MARK;Mn;91;NSM;;;;;N;;;;;
0C58;TELUGU LETTER TSA;Lo;0;L;;;;;N;;;;;
0C59;TELUGU LETTER DZA;Lo;0;L;;;;;N;;;;;
0C5A;TELUGU LETTER RRRA;Lo;0;L;;;;;N;;;;;
0C5D;TELUGU LETTER NAKAARA POLLU;Lo;0;L;;;;;N;;;;;
0C60;TELUGU LETTER VOCALIC RR;Lo;0;L;;;;;N;;;;;
0C61;TELUGU LETTER VOCALIC LL;Lo;0;L;;;;;N;;;;;
0C62;TELUGU VOWEL SIGN VOCALIC L;Mn;0;NSM;;;;;N;;;;;
0C63;TELUGU VOWEL SIGN VOCALIC LL;Mn;0;NSM;;;;;N;;;;;
0C66;TELUGU DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
0C67;TELUGU DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
0C68;TELUGU DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
0C69;TELUGU DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
0C6A;TELUGU DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
0C6B;TELUGU DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
0C6C;TELUGU DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
0C6D;TELUGU DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
0C6E;TELUGU DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
0C6F;TELUGU DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
0C77;TELUGU SIGN SIDDHAM;Po;0;L;;;;;N;;;;;
0C78;TELUGU FRACTION DIGIT ZERO FOR ODD POWERS OF FOUR;No;0;ON;;;;0;N;;;;;
0C79;TELUGU FRACTION DIGIT ONE FOR ODD POWERS OF FOUR;No;0;ON;;;;1;N;;;;;
0C7A;TELUGU FRACTION DIGIT TWO FOR ODD POWERS OF FOUR;No;0;ON;;;;2;N;;;;;
0C7B;TELUGU FRACTION DIGIT THREE FOR ODD POWERS OF FOUR;No;0;ON;;;;3;N;;;;;
0C7C;TELUGU FRACTION DIGIT ONE FOR EVEN POWERS OF FOUR;No;0;ON;;;;1;N;;;;;
0C7D;TELUGU FRACTION DIGIT TWO FOR EVEN POWERS OF FOUR;No;0;ON;;;;2;N;;;;;
0C7E;TELUGU FRACTION DIGIT THREE FOR EVEN POWERS OF FOUR;No;0;ON;;;;3;N;;;;;
0C7F;TELUGU SIGN TUUMU;So;0;L;;;;;N;;;;;
0C80;KANNADA SIGN SPACING CANDRABINDU;Lo;0;L;;;;;N;;;;;
0C81;KANNADA SIGN CANDRABINDU;Mn;0;NSM;;;;;N;;;;;
0C82;KANNADA SIGN ANUSVARA;Mc;0;L;;;;;N;;;;;
0C83;KANNADA SIGN VISARGA;Mc;0;L;;;;;N;;;;;
0C84;KANNADA SIGN SIDDHAM;Po;0;L;;;;;N;;;;;
0C85;KANNADA LETTER A;Lo;0;L;;;;;N;;;;;
0C86;KANNADA LETTER AA;Lo;0;L;;;;;N;;;;;
0C87;KANNADA LETTER I;Lo;0;L;;;;;N;;;;;
0C88;KANNADA LETTER II;Lo;0;L;;;;;N;;;;;
0C89;KANNADA LETTER U;Lo;0;L;;;;;N;;;;;
0C8A;KANNADA LETTER UU;Lo;0;L;;;;;N;;;;;
0C8B;KANNADA LETTER VOCALIC R;Lo;0;L;;;;;N;;;;;
0C8C;KANNADA LETTER VOCALIC L;Lo;0;L;;;;;N;;;;;
0C8E;KANNADA LETTER E;Lo;0;L;;;;;N;;;;;
0C8F;KANNADA LETTER EE;Lo;0;L;;;;;N;;;;;
0C90;KANNADA LETTER AI;Lo;0;L;;;;;N;;;;;
0C92;KANNADA LETTER O;Lo;0;L;;;;;N;;;;;
0C93;KANNADA LETTER OO;Lo;0;L;;;;;N;;;;;
0C94;KANNADA LETTER AU;Lo;0;L;;;;;N;;;;;
0C95;KANNADA LETTER KA;Lo;0;L;;;;;N;;;;;
0C96;KANNADA LETTER KHA;Lo;0;L;;;;;N;;;;;
0C97;KANNADA LETTER GA;Lo;0;L;;;;;N;;;;;
0C98;KANNADA LETTER GHA;Lo;0;L;;;;;N;;;;;
0C99;KANNADA LETTER NGA;Lo;0;L;;;;;N;;;;;
0C9A;KANNADA LETTER CA;Lo;0;L;;;;;N;;;;;
0C9B;KANNADA LETTER CHA;Lo;0;L;;;;;N;;;;;
0C9C;KANNADA LETTER JA;Lo;0;L;;;;;N;;;;;
0C9D;KANNADA LETTER JHA;Lo;0;L;;;;;N;;;;;
0C9E;KANNADA LETTER NYA;Lo;0;L;;;;;N;;;;;
0C9F;KANNADA LETTER TTA;Lo;0;L;;;;;N;;;;;
0CA0;KANNADA LETTER TTHA;Lo;0;L;;;;;N;;;;;
0CA1;KANNADA LETTER DDA;Lo;0;L;;;;;N;;;;;
0CA2;KANNADA LETTER DDHA;Lo;0;L;;;;;N;;;;;
0CA3;KANNADA LETTER NNA;Lo;0;L;;;;;N;;;;;
0CA4;KANNADA LETTER TA;Lo;0;L;;;;;N;;;;;
0CA5;KANNADA LETTER THA;Lo;0;L;;;;;N;;;;;
0CA6;KANNADA LETTER DA;Lo;0;L;;;;;N;;;;;
0CA7;KANNADA LETTER DHA;Lo;0;L;;;;;N;;;;;
0CA8;KANNADA LETTER NA;Lo;0;L;;;;;N;;;;;
0CAA;KANNADA LETTER PA;Lo;0;L;;;;;N;;;;;
0CAB;KANNADA LETTER PHA;Lo;0;L;;;;;N;;;;;
0CAC;KANNADA LETTER BA;Lo;0;L;;;;;N;;;;;
0CAD;KANNADA LETTER BHA;Lo;0;L;;;;;N;;;;;
0CAE;KANNADA LETTER MA;Lo;0;L;;;;;N;;;;;
0CAF;KANNADA LETTER YA;Lo;0;L;;;;;N;;;;;
0CB0;KANNADA LETTER RA;Lo;0;L;;;;;N;;;;;
0CB1;KANNADA LETTER RRA;Lo;0;L;;;;;N;;;;;
0CB2;KANNADA LETTER LA;Lo;0;L;;;;;N;;;;;
0CB3;KANNADA LETTER LLA;Lo;0;L;;;;;N;;;;;
0CB5;KANNADA LETTER VA;Lo;0;L;;;;;N;;;;;
0CB6;KANNADA LETTER SHA;Lo;0;L;;;;;N;;;;;
0CB7;KANNADA LETTER SSA;Lo;0;L;;;;;N;;;;;
0CB8;KANNADA LETTER SA;Lo;0;L;;;;;N;;;;;
0CB9;KANNADA LETTER HA;Lo;0;L;;;;;N;;;;;
0CBC;KANNADA SIGN NUKTA;Mn;7;NSM;;;;;N;;;;;
0CBD;KANNADA SIGN AVAGRAHA;Lo;0;L;;;;;N;;;;;
0CBE;KANNADA VOWEL SIGN AA;Mc;0;L;;;;;N;;;;;
0CBF;KANNADA VOWEL SIGN I;Mn;0;L;;;;;N;;;;;
0CC0;KANNADA VOWEL SIGN II;Mc;0;L;0CBF 0CD5;;;;N;;;;;
0CC1;KANNADA VOWEL SIGN U;Mc;0;L;;;;;N;;;;;
0CC2;KANNADA VOWEL SIGN UU;Mc;0;L;;;;;N;;;;;
0CC3;KANNADA VOWEL SIGN VOCALIC R;Mc;0;L;;;;;N;;;;;
0CC4;KANNADA VOWEL SIGN VOCALIC RR;Mc;0;L;;;;;N;;;;;
0CC6;KANNADA VOWEL SIGN E;Mn;0;L;;;;;N;;;;;
0CC7;KANNADA VOWEL SIGN EE;Mc;0;L;0CC6 0CD5;;;;N;;;;;
0CC8;KANNADA VOWEL SIGN AI;Mc;0;L;0CC6 0CD6;;;;N;;;;;
0CCA;KANNADA VOWEL SIGN O;Mc;0;L;0CC6 0CC2;;;;N;;;;;
0CCB;KANNADA VOWEL SIGN OO;Mc;0;L;0CCA 0CD5;;;;N;;;;;
0CCC;KANNADA VOWEL SIGN AU;Mn;0;NSM;;;;;N;;;;;
0CCD;KANNADA SIGN VIRAMA;Mn;9;NSM;;;;;N;;;;;
0CD5;KANNADA LENGTH MARK;Mc;0;L;;;;;N;;;;;
0CD6;KANNADA AI LENGTH MARK;Mc;0;L;;;;;N;;;;;
0CDD;KANNADA LETTER NAKAARA POLLU;Lo;0;L;;;;;N;;;;;
0CDE;KANNADA LETTER FA;Lo;0;L;;;;;N;;;;;
0CE0;KANNADA LETTER VOCALIC RR;Lo;0;L;;;;;N;;;;;
0CE1;KANNADA LETTER VOCALIC LL;Lo;0;L;;;;;N;;;;;
0CE2;KANNADA VOWEL SIGN VOCALIC L;Mn;0;NSM;;;;;N;;;;;
0CE3;KANNADA VOWEL SIGN VOCALIC LL;Mn;0;NSM;;;;;N;;;;;
0CE6;KANNADA DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
0CE7;KANNADA DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
0CE8;KANNADA DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
0CE9;KANNADA DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
0CEA;KANNADA DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
0CEB;KANNADA DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
0CEC;KANNADA DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
0CED;KANNADA DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
0CEE;KANNADA DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
0CEF;KANNADA DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
0CF1;KANNADA SIGN JIHVAMULIYA;Lo;0;L;;;;;N;;;;;
0CF2;KANNADA SIGN UPADHMANIYA;Lo;0;L;;;;;N;;;;;
0D00;MALAYALAM SIGN COMBINING ANUSVARA ABOVE;Mn;0;NSM;;;;;N;;;;;
0D01;MALAYALAM SIGN CANDRABINDU;Mn;0;NSM;;;;;N;;;;;
0D02;MALAYALAM SIGN ANUSVARA;Mc;0;L;;;;;N;;;;;
0D03;MALAYALAM SIGN VISARGA;Mc;0;L;;;;;N;;;;;
0D04;MALAYALAM LETTER VEDIC ANUSVARA;Lo;0;L;;;;;N;;;;;
0D05;MALAYALAM LETTER A;Lo;0;L;;;;;N;;;;;
0D06;MALAYALAM LETTER AA;Lo;0;L;;;;;N;;;;;
0D07;MALAYALAM LETTER I;Lo;0;L;;;;;N;;;;;
0D08;MALAYALAM LETTER II;Lo;0;L;;;;;N;;;;;
0D09;MALAYALAM LETTER U;Lo;0;L;;;;;N;;;;;
0D0A;MALAYALAM LETTER UU;Lo;0;L;;;;;N;;;;;
0D0B;MALAYALAM LETTER VOCALIC R;Lo;0;L;;;;;N;;;;;
0D0C;MALAYALAM LETTER VOCALIC L;Lo;0;L;;;;;N;;;;;
0D0E;MALAYALAM LETTER E;Lo;0;L;;;;;N;;;;;
0D0F;MALAYALAM LETTER EE;Lo;0;L;;;;;N;;;;;
0D10;MALAYALAM LETTER AI;Lo;0;L;;;;;N;;;;;
0D12;MALAYALAM LETTER O;Lo;0;L;;;;;N;;;;;
0D13;MALAYALAM LETTER OO;Lo;0;L;;;;;N;;;;;
0D14;MALAYALAM LETTER AU;Lo;0;L;;;;;N;;;;;
0D15;MALAYALAM LETTER KA;Lo;0;L;;;;;N;;;;;
0D16;MALAYALAM LETTER KHA;Lo;0;L;;;;;N;;;;;
0D17;MALAYALAM LETTER GA;Lo;0;L;;;;;N;;;;;
0D18;MALAYALAM LETTER GHA;Lo;0;L;;;;;N;;;;;
0D19;MALAYALAM LETTER NGA;Lo;0;L;;;;;N;;;;;
0D1A;MALAYALAM LETTER CA;Lo;0;L;;;;;N;;;;;
0D1B;MALAYALAM LETTER CHA;Lo;0;L;;;;;N;;;;;
0D1C;MALAYALAM LETTER JA;Lo;0;L;;;;;N;;;;;
0D1D;MALAYALAM LETTER JHA;Lo;0;L;;;;;N;;;;;
0D1E;MALAYALAM LETTER NYA;Lo;0;L;;;;;N;;;;;
0D1F;MALAYALAM LETTER TTA;Lo;0;L;;;;;N;;;;;
0D20;MALAYALAM LETTER TTHA;Lo;0;L;;;;;N;;;;;
0D21;MALAYALAM LETTER DDA;Lo;0;L;;;;;N;;;;;
0D22;MALAYALAM LETTER DDHA;Lo;0;L;;;;;N;;;;;
0D23;MALAYALAM LETTER NNA;Lo;0;L;;;;;N;;;;;
0D24;MALAYALAM LETTER TA;Lo;0;L;;;;;N;;;;;
0D25;MALAYALAM LETTER THA;Lo;0;L;;;;;N;;;;;
0D26;MALAYALAM LETTER DA;Lo;0;L;;;;;N;;;;;
0D27;MALAYALAM LETTER DHA;Lo;0;L;;;;;N;;;;;
0D28;MALAYALAM LETTER NA;Lo;0;L;;;;;N;;;;;
0D29;MALAYALAM LETTER NNNA;Lo;0;L;;;;;N;;;;;
0D2A;MALAYALAM LETTER PA;Lo;0;L;;;;;N;;;;;
0D2B;MALAYALAM LETTER PHA;Lo;0;L;;;;;N;;;;;
0D2C;MALAYALAM LETTER BA;Lo;0;L;;;;;N;;;;;
0D2D;MALAYALAM LETTER BHA;Lo;0;L;;;;;N;;;;;
0D2E;MALAYALAM LETTER MA;Lo;0;L;;;;;N;;;;;
0D2F;MALAYALAM LETTER YA;Lo;0;L;;;;;N;;;;;
0D30;MALAYALAM LETTER RA;Lo;0;L;;;;;N;;;;;
0D31;MALAYALAM LETTER RRA;Lo;0;L;;;;;N;;;;;
0D32;MALAYALAM LETTER LA;Lo;0;L;;;;;N;;;;;
0D33;MALAYALAM LETTER LLA;Lo;0;L;;;;;N;;;;;
0D34;MALAYALAM LETTER LLLA;Lo;0;L;;;;;N;;;;;
0D35;MALAYALAM LETTER VA;Lo;0;L;;;;;N;;;;;
0D36;MALAYALAM LETTER SHA;Lo;0;L;;;;;N;;;;;
0D37;MALAYALAM LETTER SSA;Lo;0;L;;;;;N;;;;;
0D38;MALAYALAM LETTER SA;Lo;0;L;;;;;N;;;;;
0D39;MALAYALAM LETTER HA;Lo;0;L;;;;;N;;;;;
0D3A;MALAYALAM LETTER TTTA;Lo;0;L;;;;;N;;;;;
0D3B;MALAYALAM SIGN VERTICAL BAR VIRAMA;Mn;9;NSM;;;;;N;;;;;
0D3C;MALAYALAM SIGN CIRCULAR VIRAMA;Mn;9;NSM;;;;;N;;;;;
0D3D;MALAYALAM SIGN AVAGRAHA;Lo;0;L;;;;;N;;;;;
0D3E;MALAYALAM VOWEL SIGN AA;Mc;0;L;;;;;N;;;;;
0D3F;MALAYALAM VOWEL SIGN I;Mc;0;L;;;;;N;;;;;
0D40;MALAYALAM VOWEL SIGN II;Mc;0;L;;;;;N;;;;;
0D41;MALAYALAM VOWEL SIGN U;Mn;0;NSM;;;;;N;;;;;
0D42;MALAYALAM VOWEL SIGN UU;Mn;0;NSM;;;;;N;;;;;
0D43;MALAYALAM VOWEL SIGN VOCALIC R;Mn;0;NSM;;;;;N;;;;;
0D44;MALAYALAM VOWEL SIGN VOCALIC RR;Mn;0;NSM;;;;;N;;;;;
0D46;MALAYALAM VOWEL SIGN E;Mc;0;L;;;;;N;;;;;
0D47;MALAYALAM VOWEL SIGN EE;Mc;0;L;;;;;N;;;;;
0D48;MALAYALAM VOWEL SIGN AI;Mc;0;L;;;;;N;;;;;
0D4A;MALAYALAM VOWEL SIGN O;Mc;0;L;0D46 0D3E;;;;N;;;;;
0D4B;MALAYALAM VOWEL SIGN OO;Mc;0;L;0D47 0D3E;;;;N;;;;;
0D4C;MALAYALAM VOWEL SIGN AU;Mc;0;L;0D46 0D57;;;;N;;;;;
0D4D;MALAYALAM SIGN VIRAMA;Mn;9;NSM;;;;;N;;;;;
0D4E;MALAYALAM LETTER DOT REPH;Lo;0;L;;;;;N;;;;;
0D4F;MALAYALAM SIGN PARA;So;0;L;;;;;N;;;;;
0D54;MALAYALAM LETTER CHILLU M;Lo;0;L;;;;;N;;;;;
0D55;MALAYALAM LETTER CHILLU Y;Lo;0;L;;;;;N;;;;;
0D56;MALAYALAM LETTER CHILLU LLL;Lo;0;L;;;;;N;;;;;
0D57;MALAYALAM AU LENGTH MARK;Mc;0;L;;;;;N;;;;;
0D58;MALAYALAM FRACTION ONE ONE-HUNDRED-AND-SIXTIETH;No;0;L;;;;1/160;N;;;;;
0D59;MALAYALAM FRACTION ONE FORTIETH;No;0;L;;;;1/40;N;;;;;
0D5A;MALAYALAM FRACTION THREE EIGHTIETHS;No;0;L;;;;3/80;N;;;;;
0D5B;MALAYALAM FRACTION ONE TWENTIETH;No;0;L;;;;1/20;N;;;;;
0D5C;MALAYALAM FRACTION ONE TENTH;No;0;L;;;;1/10;N;;;;;
0D5D;MALAYALAM FRACTION THREE TWENTIETHS;No;0;L;;;;3/20;N;;;;;
0D5E;MALAYALAM FRACTION ONE FIFTH;No;0;L;;;;1/5;N;;;;;
0D5F;MALAYALAM LETTER ARCHAIC II;Lo;0;L;;;;;N;;;;;
0D60;MALAYALAM LETTER VOCALIC RR;Lo;0;L;;;;;N;;;;;
0D61;MALAYALAM LETTER VOCALIC LL;Lo;0;L;;;;;N;;;;;
0D62;MALAYALAM VOWEL SIGN VOCALIC L;Mn;0;NSM;;;;;N;;;;;
0D63;MALAYALAM VOWEL SIGN VOCALIC LL;Mn;0;NSM;;;;;N;;;;;
0D66;MALAYALAM DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
0D67;MALAYALAM DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
0D68;MALAYALAM DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
0D69;MALAYALAM DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
0D6A;MALAYALAM DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
0D6B;MALAYALAM DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
0D6C;MALAYALAM DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
0D6D;MALAYALAM DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
0D6E;MALAYALAM DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
0D6F;MALAYALAM DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
0D70;MALAYALAM NUMBER TEN;No;0;L;;;;10;N;;;;;
0D71;MALAYALAM NUMBER ONE HUNDRED;No;0;L;;;;100;N;;;;;
0D72;MALAYALAM NUMBER ONE THOUSAND;No;0;L;;;;1000;N;;;;;
0D73;MALAYALAM FRACTION ONE QUARTER;No;0;L;;;;1/4;N;;;;;
0D74;MALAYALAM FRACTION ONE HALF;No;0;L;;;;1/2;N;;;;;
0D75;MALAYALAM FRACTION THREE QUARTERS;No;0;L;;;;3/4;N;;;;;
0D76;MALAYALAM FRACTION ONE SIXTEENTH;No;0;L;;;;1/16;N;;;;;
0D77;MALAYALAM FRACTION ONE EIGHTH;No;0;L;;;;1/8;N;;;;;
0D78;MALAYALAM FRACTION THREE SIXTEENTHS;No;0;L;;;;3/16;N;;;;;
0D79;MALAYALAM DATE MARK;So;0;L;;;;;N;;;;;
0D7A;MALAYALAM LETTER CHILLU NN;Lo;0;L;;;;;N;;;;;
0D7B;MALAYALAM LETTER CHILLU N;Lo;0;L;;;;;N;;;;;
0D7C;MALAYALAM LETTER CHILLU RR;Lo;0;L;;;;;N;;;;;
0D7D;MALAYALAM LETTER CHILLU L;Lo;0;L;;;;;N;;;;;
0D7E;MALAYALAM LETTER CHILLU LL;Lo;0;L;;;;;N;;;;;
0D7F;MALAYALAM LETTER CHILLU K;Lo;0;L;;;;;N;;;;;
0D81;SINHALA SIGN CANDRABINDU;Mn;0;NSM;;;;;N;;;;;
0D82;SINHALA SIGN ANUSVARAYA;Mc;0;L;;;;;N;;;;;
0D83;SINHALA SIGN VISARGAYA;Mc;0;L;;;;;N;;;;;
0D85;SINHALA LETTER AYANNA;Lo;0;L;;;;;N;;;;;
0D86;SINHALA LETTER AAYANNA;Lo;0;L;;;;;N;;;;;
0D87;SINHALA LETTER AEYANNA;Lo;0;L;;;;;N;;;;;
0D88;SINHALA LETTER AEEYANNA;Lo;0;L;;;;;N;;;;;
0D89;SINHALA LETTER IYANNA;Lo;0;L;;;;;N;;;;;
0D8A;SINHALA LETTER IIYANNA;Lo;0;L;;;;;N;;;;;
0D8B;SINHALA LETTER UYANNA;Lo;0;L;;;;;N;;;;;
0D8C;SINHALA LETTER UUYANNA;Lo;0;L;;;;;N;;;;;
0D8D;SINHALA LETTER IRUYANNA;Lo;0;L;;;;;N;;;;;
0D8E;SINHALA LETTER IRUUYANNA;Lo;0;L;;;;;N;;;;;
0D8F;SINHALA LETTER ILUYANNA;Lo;0;L;;;;;N;;;;;
0D90;SINHALA LETTER ILUUYANNA;Lo;0;L;;;;;N;;;;;
0D91;SINHALA LETTER EYANNA;Lo;0;L;;;;;N;;;;;
0D92;SINHALA LETTER EEYANNA;Lo;0;L;;;;;N;;;;;
0D93;SINHALA LETTER AIYANNA;Lo;0;L;;;;;N;;;;;
0D94;SINHALA LETTER OYANNA;Lo;0;L;;;;;N;;;;;
0D95;SINHALA LETTER OOYANNA;Lo;0;L;;;;;N;;;;;
0D96;SINHALA LETTER AUYANNA;Lo;0;L;;;;;N;;;;;
0D9A;SINHALA LETTER ALPAPRAANA KAYANNA;Lo;0;L;;;;;N;;;;;
0D9B;SINHALA LETTER MAHAAPRAANA KAYANNA;Lo;0;L;;;;;N;;;;;
0D9C;SINHALA LETTER ALPAPRAANA GAYANNA;Lo;0;L;;;;;N;;;;;
0D9D;SINHALA LETTER MAHAAPRAANA GAYANNA;Lo;0;L;;;;;N;;;;;
0D9E;SINHALA LETTER KANTAJA NAASIKYAYA;Lo;0;L;;;;;N;;;;;
0D9F;SINHALA LETTER SANYAKA GAYANNA;Lo;0;L;;;;;N;;;;;
0DA0;SINHALA LETTER ALPAPRAANA CAYANNA;Lo;0;L;;;;;N;;;;;
0DA1;SINHALA LETTER MAHAAPRAANA CAYANNA;Lo;0;L;;;;;N;;;;;
0DA2;SINHALA LETTER ALPAPRAANA JAYANNA;Lo;0;L;;;;;N;;;;;
0DA3;SINHALA LETTER MAHAAPRAANA JAYANNA;Lo;0;L;;;;;N;;;;;
0DA4;SINHALA LETTER TAALUJA NAASIKYAYA;Lo;0;L;;;;;N;;;;;
0DA5;SINHALA LETTER TAALUJA SANYOOGA NAAKSIKYAYA;Lo;0;L;;;;;N;;;;;
0DA6;SINHALA LETTER SANYAKA JAYANNA;Lo;0;L;;;;;N;;;;;
0DA7;SINHALA LETTER ALPAPRAANA TTAYANNA;Lo;0;L;;;;;N;;;;;
0DA8;SINHALA LETTER MAHAAPRAANA TTAYANNA;Lo;0;L;;;;;N;;;;;
0DA9;SINHALA LETTER ALPAPRAANA DDAYANNA;Lo;0;L;;;;;N;;;;;
0DAA;SINHALA LETTER MAHAAPRAANA DDAYANNA;Lo;0;L;;;;;N;;;;;
0DAB;SINHALA LETTER MUURDHAJA NAYANNA;Lo;0;L;;;;;N;;;;;
0DAC;SINHALA LETTER SANYAKA DDAYANNA;Lo;0;L;;;;;N;;;;;
0DAD;SINHALA LETTER ALPAPRAANA TAYANNA;Lo;0;L;;;;;N;;;;;
0DAE;SINHALA LETTER MAHAAPRAANA TAYANNA;Lo;0;L;;;;;N;;;;;
0DAF;SINHALA LETTER ALPAPRAANA DAYANNA;Lo;0;L;;;;;N;;;;;
0DB0;SINHALA LETTER MAHAAPRAANA DAYANNA;Lo;0;L;;;;;N;;;;;
0DB1;SINHALA LETTER DANTAJA NAYANNA;Lo;0;L;;;;;N;;;;;
0DB3;SINHALA LETTER SANYAKA DAYANNA;Lo;0;L;;;;;N;;;;;
0DB4;SINHALA LETTER ALPAPRAANA PAYANNA;Lo;0;L;;;;;N;;;;;
0DB5;SINHALA LETTER MAHAAPRAANA PAYANNA;Lo;0;L;;;;;N;;;;;
0DB6;SINHALA LETTER ALPAPRAANA BAYANNA;Lo;0;L;;;;;N;;;;;
0DB7;SINHALA LETTER MAHAAPRAANA BAYANNA;Lo;0;L;;;;;N;;;;;
0DB8;SINHALA LETTER MAYANNA;Lo;0;L;;;;;N;;;;;
0DB9;SINHALA LETTER AMBA BAYANNA;Lo;0;L;;;;;N;;;;;
0DBA;SINHALA LETTER YAYANNA;Lo;0;L;;;;;N;;;;;
0DBB;SINHALA LETTER RAYANNA;Lo;0;L;;;;;N;;;;;
0DBD;SINHALA LETTER DANTAJA LAYANNA;Lo;0;L;;;;;N;;;;;
0DC0;SINHALA LETTER VAYANNA;Lo;0;L;;;;;N;;;;;
0DC1;SINHALA LETTER TAALUJA SAYANNA;Lo;0;L;;;;;N;;;;;
0DC2;SINHALA LETTER MUURDHAJA SAYANNA;Lo;0;L;;;;;N;;;;;
0DC3;SINHALA LETTER DANTAJA SAYANNA;Lo;0;L;;;;;N;;;;;
0DC4;SINHALA LETTER HAYANNA;Lo;0;L;;;;;N;;;;;
0DC5;SINHALA LETTER MUURDHAJA LAYANNA;Lo;0;L;;;;;N;;;;;
0DC6;SINHALA LETTER FAYANNA;Lo;0;L;;;;;N;;;;;
0DCA;SINHALA SIGN AL-LAKUNA;Mn;9;NSM;;;;;N;;;;;
0DCF;SINHALA VOWEL SIGN AELA-PILLA;Mc;0;L;;;;;N;;;;;
0DD0;SINHALA VOWEL SIGN KETTI AEDA-PILLA;Mc;0;L;;;;;N;;;;;
0DD1;SINHALA VOWEL SIGN DIGA AEDA-PILLA;Mc;0;L;;;;;N;;;;;
0DD2;SINHALA VOWEL SIGN KETTI IS-PILLA;Mn;0;NSM;;;;;N;;;;;
0DD3;SINHALA VOWEL SIGN DIGA IS-PILLA;Mn;0;NSM;;;;;N;;;;;
0DD4;SINHALA VOWEL SIGN KETTI PAA-PILLA;Mn;0;NSM;;;;;N;;;;;
0DD6;SINHALA VOWEL SIGN DIGA PAA-PILLA;Mn;0;NSM;;;;;N;;;;;
0DD8;SINHALA VOWEL SIGN GAETTA-PILLA;Mc;0;L;;;;;N;;;;;
0DD9;SINHALA VOWEL SIGN KOMBUVA;Mc;0;L;;;;;N;;;;;
0DDA;SINHALA VOWEL SIGN DIGA KOMBUVA;Mc;0;L;0DD9 0DCA;;;;N;;;;;
0DDB;SINHALA VOWEL SIGN KOMBU DEKA;Mc;0;L;;;;;N;;;;;
0DDC;SINHALA VOWEL SIGN KOMBUVA HAA AELA-PILLA;Mc;0;L;0DD9 0DCF;;;;N;;;;;
0DDD;SINHALA VOWEL SIGN KOMBUVA HAA DIGA AELA-PILLA;Mc;0;L;0DDC 0DCA;;;;N;;;;;
0DDE;SINHALA VOWEL SIGN KOMBUVA HAA GAYANUKITTA;Mc;0;L;0DD9 0DDF;;;;N;;;;;
0DDF;SINHALA VOWEL SIGN GAYANUKITTA;Mc;0;L;;;;;N;;;;;
0DE6;SINHALA LITH DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
0DE7;SINHALA LITH DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
0DE8;SINHALA LITH DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
0DE9;SINHALA LITH DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
0DEA;SINHALA LITH DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
0DEB;SINHALA LITH DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
0DEC;SINHALA LITH DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
0DED;SINHALA LITH DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
0DEE;SINHALA LITH DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
0DEF;SINHALA LITH DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
0DF2;SINHALA VOWEL SIGN DIGA GAETTA-PILLA;Mc;0;L;;;;;N;;;;;
0DF3;SINHALA VOWEL SIGN DIGA GAYANUKITTA;Mc;0;L;;;;;N;;;;;
0DF4;SINHALA PUNCTUATION KUNDDALIYA;Po;0;L;;;;;N;;;;;
0E01;THAI CHARACTER KO KAI;Lo;0;L;;;;;N;THAI LETTER KO KAI;;;;
0E02;THAI CHARACTER KHO KHAI;Lo;0;L;;;;;N;THAI LETTER KHO KHAI;;;;
0E03;THAI CHARACTER KHO KHUAT;Lo;0;L;;;;;N;THAI LETTER KHO KHUAT;;;;
0E04;THAI CHARACTER KHO KHWAI;Lo;0;L;;;;;N;THAI LETTER KHO KHWAI;;;;
0E05;THAI CHARACTER KHO KHON;Lo;0;L;;;;;N;THAI LETTER KHO KHON;;;;
0E06;THAI CHARACTER KHO RAKHANG;Lo;0;L;;;;;N;THAI LETTER KHO RAKHANG;;;;
0E07;THAI CHARACTER NGO NGU;Lo;0;L;;;;;N;THAI LETTER NGO NGU;;;;
0E08;THAI CHARACTER CHO CHAN;Lo;0;L;;;;;N;THAI LETTER CHO CHAN;;;;
0E09;THAI CHARACTER CHO CHING;Lo;0;L;;;;;N;THAI LETTER CHO CHING;;;;
0E0A;THAI CHARACTER CHO CHANG;Lo;0;L;;;;;N;THAI LETTER CHO CHANG;;;;
0E0B;THAI CHARACTER SO SO;Lo;0;L;;;;;N;THAI LETTER SO SO;;;;
0E0C;THAI CHARACTER CHO CHOE;Lo;0;L;;;;;N;THAI LETTER CHO CHOE;;;;
0E0D;THAI CHARACTER YO YING;Lo;0;L;;;;;N;THAI LETTER YO YING;;;;
0E0E;THAI CHARACTER DO CHADA;Lo;0;L;;;;;N;THAI LETTER DO CHADA;;;;
0E0F;THAI CHARACTER TO PATAK;Lo;0;L;;;;;N;THAI LETTER TO PATAK;;;;
0E10;THAI CHARACTER THO THAN;Lo;0;L;;;;;N;THAI LETTER THO THAN;;;;
0E11;THAI CHARACTER THO NANGMONTHO;Lo;0;L;;;;;N;THAI LETTER THO NANGMONTHO;;;;
0E12;THAI CHARACTER THO PHUTHAO;Lo;0;L;;;;;N;THAI LETTER THO PHUTHAO;;;;
0E13;THAI CHARACTER NO NEN;Lo;0;L;;;;;N;THAI LETTER NO NEN;;;;
0E14;THAI CHARACTER DO DEK;Lo;0;L;;;;;N;THAI LETTER DO DEK;;;;
0E15;THAI CHARACTER TO TAO;Lo;0;L;;;;;N;THAI LETTER TO TAO;;;;
0E16;THAI CHARACTER THO THUNG;Lo;0;L;;;;;N;THAI LETTER THO THUNG;;;;
0E17;THAI CHARACTER THO THAHAN;Lo;0;L;;;;;N;THAI LETTER THO THAHAN;;;;
0E18;THAI CHARACTER THO THONG;Lo;0;L;;;;;N;THAI LETTER THO THONG;;;;
0E19;THAI CHARACTER NO NU;Lo;0;L;;;;;N;THAI LETTER NO NU;;;;
0E1A;THAI CHARACTER BO BAIMAI;Lo;0;L;;;;;N;THAI LETTER BO BAIMAI;;;;
0E1B;THAI CHARACTER PO PLA;Lo;0;L;;;;;N;THAI LETTER PO PLA;;;;
0E1C;THAI CHARACTER PHO PHUNG;Lo;0;L;;;;;N;THAI LETTER PHO PHUNG;;;;
0E1D;THAI CHARACTER FO FA;Lo;0;L;;;;;N;THAI LETTER FO FA;;;;
0E1E;THAI CHARACTER PHO PHAN;Lo;0;L;;;;;N;THAI LETTER PHO PHAN;;;;
0E1F;THAI CHARACTER FO FAN;Lo;0;L;;;;;N;THAI LETTER FO FAN;;;;
0E20;THAI CHARACTER PHO SAMPHAO;Lo;0;L;;;;;N;THAI LETTER PHO SAMPHAO;;;;
0E21;THAI CHARACTER MO MA;Lo;0;L;;;;;N;THAI LETTER MO MA;;;;
0E22;THAI CHARACTER YO YAK;Lo;0;L;;;;;N;THAI LETTER YO YAK;;;;
0E23;THAI CHARACTER RO RUA;Lo;0;L;;;;;N;THAI LETTER RO RUA;;;;
0E24;THAI CHARACTER RU;Lo;0;L;;;;;N;THAI LETTER RU;;;;
0E25;THAI CHARACTER LO LING;Lo;0;L;;;;;N;THAI LETTER LO LING;;;;
0E26;THAI CHARACTER LU;Lo;0;L;;;;;N;THAI LETTER LU;;;;
0E27;THAI CHARACTER WO WAEN;Lo;0;L;;;;;N;THAI LETTER WO WAEN;;;;
0E28;THAI CHARACTER SO SALA;Lo;0;L;;;;;N;THAI LETTER SO SALA;;;;
0E29;THAI CHARACTER SO RUSI;Lo;0;L;;;;;N;THAI LETTER SO RUSI;;;;
0E2A;THAI CHARACTER SO SUA;Lo;0;L;;;;;N;THAI LETTER SO SUA;;;;
0E2B;THAI CHARACTER HO HIP;Lo;0;L;;;;;N;THAI LETTER HO HIP;;;;
0E2C;THAI CHARACTER LO CHULA;Lo;0;L;;;;;N;THAI LETTER LO CHULA;;;;
0E2D;THAI CHARACTER O ANG;Lo;0;L;;;;;N;THAI LETTER O ANG;;;;
0E2E;THAI CHARACTER HO NOKHUK;Lo;0;L;;;;;N;THAI LETTER HO NOK HUK;;;;
0E2F;THAI CHARACTER PAIYANNOI;Lo;0;L;;;;;N;THAI PAI YAN NOI;;;;
0E30;THAI CHARACTER SARA A;Lo;0;L;;;;;N;THAI VOWEL SIGN SARA A;;;;
0E31;THAI CHARACTER MAI HAN-AKAT;Mn;0;NSM;;;;;N;THAI VOWEL SIGN MAI HAN-AKAT;;;;
0E32;THAI CHARACTER SARA AA;Lo;0;L;;;;;N;THAI VOWEL SIGN SARA AA;;;;
0E33;THAI CHARACTER SARA AM;Lo;0;L;<compat> 0E4D 0E32;;;;N;THAI VOWEL SIGN SARA AM;;;;
0E34;THAI CHARACTER SARA I;Mn;0;NSM;;;;;N;THAI VOWEL SIGN SARA I;;;;
0E35;THAI CHARACTER SARA II;Mn;0;NSM;;;;;N;THAI VOWEL SIGN SARA II;;;;
0E36;THAI CHARACTER SARA UE;Mn;0;NSM;;;;;N;THAI VOWEL SIGN SARA UE;;;;
0E37;THAI CHARACTER SARA UEE;Mn;0;NSM;;;;;N;THAI VOWEL SIGN SARA UEE;;;;
0E38;THAI CHARACTER SARA U;Mn;103;NSM;;;;;N;THAI VOWEL SIGN SARA U;;;;
0E39;THAI CHARACTER SARA UU;Mn;103;NSM;;;;;N;THAI VOWEL SIGN SARA UU;;;;
0E3A;THAI CHARACTER PHINTHU;Mn;9;NSM;;;;;N;THAI VOWEL SIGN PHINTHU;;;;
0E3F;THAI CURRENCY SYMBOL BAHT;Sc;0;ET;;;;;N;THAI BAHT SIGN;;;;
0E40;THAI CHARACTER SARA E;Lo;0;L;;;;;N;THAI VOWEL SIGN SARA E;;;;
0E41;THAI CHARACTER SARA AE;Lo;0;L;;;;;N;THAI VOWEL SIGN SARA AE;;;;
0E42;THAI CHARACTER SARA O;Lo;0;L;;;;;N;THAI VOWEL SIGN SARA O;;;;
0E43;THAI CHARACTER SARA AI MAIMUAN;Lo;0;L;;;;;N;THAI VOWEL SIGN SARA MAI MUAN;;;;
0E44;THAI CHARACTER SARA AI MAIMALAI;Lo;0;L;;;;;N;THAI VOWEL SIGN SARA MAI MALAI;;;;
0E45;THAI CHARACTER LAKKHANGYAO;Lo;0;L;;;;;N;THAI LAK KHANG YAO;;;;
0E46;THAI CHARACTER MAIYAMOK;Lm;0;L;;;;;N;THAI MAI YAMOK;;;;
0E47;THAI CHARACTER MAITAIKHU;Mn;0;NSM;;;;;N;THAI VOWEL SIGN MAI TAI KHU;;;;
0E48;THAI CHARACTER MAI EK;Mn;107;NSM;;;;;N;THAI TONE MAI EK;;;;
0E49;THAI CHARACTER MAI THO;Mn;107;NSM;;;;;N;THAI TONE MAI THO;;;;
0E4A;THAI CHARACTER MAI TRI;Mn;107;NSM;;;;;N;THAI TONE MAI TRI;;;;
0E4B;THAI CHARACTER MAI CHATTAWA;Mn;107;NSM;;;;;N;THAI TONE MAI CHATTAWA;;;;
0E4C;THAI CHARACTER THANTHAKHAT;Mn;0;NSM;;;;;N;THAI THANTHAKHAT;;;;
0E4D;THAI CHARACTER NIKHAHIT;Mn;0;NSM;;;;;N;THAI NIKKHAHIT;;;;
0E4E;THAI CHARACTER YAMAKKAN;Mn;0;NSM;;;;;N;THAI YAMAKKAN;;;;
0E4F;THAI CHARACTER FONGMAN;Po;0;L;;;;;N;THAI FONGMAN;;;;
0E50;THAI DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
0E51;THAI DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
0E52;THAI DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
0E53;THAI DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
0E54;THAI DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
0E55;THAI DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
0E56;THAI DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
0E57;THAI DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
0E58;THAI DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
0E59;THAI DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
0E5A;THAI CHARACTER ANGKHANKHU;Po;0;L;;;;;N;THAI ANGKHANKHU;;;;
0E5B;THAI CHARACTER KHOMUT;Po;0;L;;;;;N;THAI KHOMUT;;;;
0E81;LAO LETTER KO;Lo;0;L;;;;;N;;;;;
0E82;LAO LETTER KHO SUNG;Lo;0;L;;;;;N;;;;;
0E84;LAO LETTER KHO TAM;Lo;0;L;;;;;N;;;;;
0E86;LAO LETTER PALI GHA;Lo;0;L;;;;;N;;;;;
0E87;LAO LETTER NGO;Lo;0;L;;;;;N;;;;;
0E88;LAO LETTER CO;Lo;0;L;;;;;N;;;;;
0E89;LAO LETTER PALI CHA;Lo;0;L;;;;;N;;;;;
0E8A;LAO LETTER SO TAM;Lo;0;L;;;;;N;;;;;
0E8C;LAO LETTER PALI JHA;Lo;0;L;;;;;N;;;;;
0E8D;LAO LETTER NYO;Lo;0;L;;;;;N;;;;;
0E8E;LAO LETTER PALI NYA;Lo;0;L;;;;;N;;;;;
0E8F;LAO LETTER PALI TTA;Lo;0;L;;;;;N;;;;;
0E90;LAO LETTER PALI TTHA;Lo;0;L;;;;;N;;;;;
0E91;LAO LETTER PALI DDA;Lo;0;L;;;;;N;;;;;
0E92;LAO LETTER PALI DDHA;Lo;0;L;;;;;N;;;;;
0E93;LAO LETTER PALI NNA;Lo;0;L;;;;;N;;;;;
0E94;LAO LETTER DO;Lo;0;L;;;;;N;;;;;
0E95;LAO LETTER TO;Lo;0;L;;;;;N;;;;;
0E96;LAO LETTER THO SUNG;Lo;0;L;;;;;N;;;;;
0E97;LAO LETTER THO TAM;Lo;0;L;;;;;N;;;;;
0E98;LAO LETTER PALI DHA;Lo;0;L;;;;;N;;;;;
0E99;LAO LETTER NO;Lo;0;L;;;;;N;;;;;
0E9A;LAO LETTER BO;Lo;0;L;;;;;N;;;;;
0E9B;LAO LETTER PO;Lo;0;L;;;;;N;;;;;
0E9C;LAO LETTER PHO SUNG;Lo;0;L;;;;;N;;;;;
0E9D;LAO LETTER FO TAM;Lo;0;L;;;;;N;;;;;
0E9E;LAO LETTER PHO TAM;Lo;0;L;;;;;N;;;;;
0E9F;LAO LETTER FO SUNG;Lo;0;L;;;;;N;;;;;
0EA0;LAO LETTER PALI BHA;Lo;0;L;;;;;N;;;;;
0EA1;LAO LETTER MO;Lo;0;L;;;;;N;;;;;
0EA2;LAO LETTER YO;Lo;0;L;;;;;N;;;;;
0EA3;LAO LETTER LO LING;Lo;0;L;;;;;N;;;;;
0EA5;LAO LETTER LO LOOT;Lo;0;L;;;;;N;;;;;
0EA7;LAO LETTER WO;Lo;0;L;;;;;N;;;;;
0EA8;LAO LETTER SANSKRIT SHA;Lo;0;L;;;;;N;;;;;
0EA9;LAO LETTER SANSKRIT SSA;Lo;0;L;;;;;N;;;;;
0EAA;LAO LETTER SO SUNG;Lo;0;L;;;;;N;;;;;
0EAB;LAO LETTER HO SUNG;Lo;0;L;;;;;N;;;;;
0EAC;LAO LETTER PALI LLA;Lo;0;L;;;;;N;;;;;
0EAD;LAO LETTER O;Lo;0;L;;;;;N;;;;;
0EAE;LAO LETTER HO TAM;Lo;0;L;;;;;N;;;;;
0EAF;LAO ELLIPSIS;Lo;0;L;;;;;N;;;;;
0EB0;LAO VOWEL SIGN A;Lo;0;L;;;;;N;;;;;
0EB1;LAO VOWEL SIGN MAI KAN;Mn;0;NSM;;;;;N;;;;;
0EB2;LAO VOWEL SIGN AA;Lo;0;L;;;;;N;;;;;
0EB3;LAO VOWEL SIGN AM;Lo;0;L;<compat> 0ECD 0EB2;;;;N;;;;;
0EB4;LAO VOWEL SIGN I;Mn;0;NSM;;;;;N;;;;;
0EB5;LAO VOWEL SIGN II;Mn;0;NSM;;;;;N;;;;;
0EB6;LAO VOWEL SIGN Y;Mn;0;NSM;;;;;N;;;;;
0EB7;LAO VOWEL SIGN YY;Mn;0;NSM;;;;;N;;;;;
0EB8;LAO VOWEL SIGN U;Mn;118;NSM;;;;;N;;;;;
0EB9;LAO VOWEL SIGN UU;Mn;118;NSM;;;;;N;;;;;
0EBA;LAO SIGN PALI VIRAMA;Mn;9;NSM;;;;;N;;;;;
0EBB;LAO VOWEL SIGN MAI KON;Mn;0;NSM;;;;;N;;;;;
0EBC;LAO SEMIVOWEL SIGN LO;Mn;0;NSM;;;;;N;;;;;
0EBD;LAO SEMIVOWEL SIGN NYO;Lo;0;L;;;;;N;;;;;
0EC0;LAO VOWEL SIGN E;Lo;0;L;;;;;N;;;;;
0EC1;LAO VOWEL SIGN EI;Lo;0;L;;;;;N;;;;;
0EC2;LAO VOWEL SIGN O;Lo;0;L;;;;;N;;;;;
0EC3;LAO VOWEL SIGN AY;Lo;0;L;;;;;N;;;;;
0EC4;LAO VOWEL SIGN AI;Lo;0;L;;;;;N;;;;;
0EC6;LAO KO LA;Lm;0;L;;;;;N;;;;;
0EC8;LAO TONE MAI EK;Mn;122;NSM;;;;;N;;;;;
0EC9;LAO TONE MAI THO;Mn;122;NSM;;;;;N;;;;;
0ECA;LAO TONE MAI TI;Mn;122;NSM;;;;;N;;;;;
0ECB;LAO TONE MAI CATAWA;Mn;122;NSM;;;;;N;;;;;
0ECC;LAO CANCELLATION MARK;Mn;0;NSM;;;;;N;;;;;
0ECD;LAO NIGGAHITA;Mn;0;NSM;;;;;N;;;;;
0ED0;LAO DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
0ED1;LAO DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
0ED2;LAO DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
0ED3;LAO DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
0ED4;LAO DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
0ED5;LAO DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
0ED6;LAO DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
0ED7;LAO DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
0ED8;LAO DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
0ED9;LAO DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
0EDC;LAO HO NO;Lo;0;L;<compat> 0EAB 0E99;;;;N;;;;;
0EDD;LAO HO MO;Lo;0;L;<compat> 0EAB 0EA1;;;;N;;;;;
0EDE;LAO LETTER KHMU GO;Lo;0;L;;;;;N;;;;;
0EDF;LAO LETTER KHMU NYO;Lo;0;L;;;;;N;;;;;
0F00;TIBETAN SYLLABLE OM;Lo;0;L;;;;;N;;;;;
0F01;TIBETAN MARK GTER YIG MGO TRUNCATED A;So;0;L;;;;;N;;;;;
0F02;TIBETAN MARK GTER YIG MGO -UM RNAM BCAD MA;So;0;L;;;;;N;;;;;
0F03;TIBETAN MARK GTER YIG MGO -UM GTER TSHEG MA;So;0;L;;;;;N;;;;;
0F04;TIBETAN MARK INITIAL YIG MGO MDUN MA;Po;0;L;;;;;N;TIBETAN SINGLE ORNAMENT;;;;
0F05;TIBETAN MARK CLOSING YIG MGO SGAB MA;Po;0;L;;;;;N;;;;;
0F06;TIBETAN MARK CARET YIG MGO PHUR SHAD MA;Po;0;L;;;;;N;;;;;
0F07;TIBETAN MARK YIG MGO TSHEG SHAD MA;Po;0;L;;;;;N;;;;;
0F08;TIBETAN MARK SBRUL SHAD;Po;0;L;;;;;N;TIBETAN RGYANSHAD;;;;
0F09;TIBETAN MARK BSKUR YIG MGO;Po;0;L;;;;;N;;;;;
0F0A;TIBETAN MARK BKA- SHOG YIG MGO;Po;0;L;;;;;N;;;;;
0F0B;TIBETAN MARK INTERSYLLABIC TSHEG;Po;0;L;;;;;N;TIBETAN TSEG;;;;
0F0C;TIBETAN MARK DELIMITER TSHEG BSTAR;Po;0;L;<noBreak> 0F0B;;;;N;;;;;
0F0D;TIBETAN MARK SHAD;Po;0;L;;;;;N;TIBETAN SHAD;;;;
0F0E;TIBETAN MARK NYIS SHAD;Po;0;L;;;;;N;TIBETAN DOUBLE SHAD;;;;
0F0F;TIBETAN MARK TSHEG SHAD;Po;0;L;;;;;N;;;;;
0F10;TIBETAN MARK NYIS TSHEG SHAD;Po;0;L;;;;;N;;;;;
0F11;TIBETAN MARK RIN CHEN SPUNGS SHAD;Po;0;L;;;;;N;TIBETAN RINCHANPHUNGSHAD;;;;
0F12;TIBETAN MARK RGYA GRAM SHAD;Po;0;L;;;;;N;;;;;
0F13;TIBETAN MARK CARET -DZUD RTAGS ME LONG CAN;So;0;L;;;;;N;;;;;
0F14;TIBETAN MARK GTER TSHEG;Po;0;L;;;;;N;TIBETAN COMMA;;;;
0F15;TIBETAN LOGOTYPE SIGN CHAD RTAGS;So;0;L;;;;;N;;;;;
0F16;TIBETAN LOGOTYPE SIGN LHAG RTAGS;So;0;L;;;;;N;;;;;
0F17;TIBETAN ASTROLOGICAL SIGN SGRA GCAN -CHAR RTAGS;So;0;L;;;;;N;;;;;
0F18;TIBETAN ASTROLOGICAL SIGN -KHYUD PA;Mn;220;NSM;;;;;N;;;;;
0F19;TIBETAN ASTROLOGICAL SIGN SDONG TSHUGS;Mn;220;NSM;;;;;N;;;;;
0F1A;TIBETAN SIGN RDEL DKAR GCIG;So;0;L;;;;;N;;;;;
0F1B;TIBETAN SIGN RDEL DKAR GNYIS;So;0;L;;;;;N;;;;;
0F1C;TIBETAN SIGN RDEL DKAR GSUM;So;0;L;;;;;N;;;;;
0F1D;TIBETAN SIGN RDEL NAG GCIG;So;0;L;;;;;N;;;;;
0F1E;TIBETAN SIGN RDEL NAG GNYIS;So;0;L;;;;;N;;;;;
0F1F;TIBETAN SIGN RDEL DKAR RDEL NAG;So;0;L;;;;;N;;;;;
0F20;TIBETAN DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
0F21;TIBETAN DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
0F22;TIBETAN DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
0F23;TIBETAN DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
0F24;TIBETAN DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
0F25;TIBETAN DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
0F26;TIBETAN DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
0F27;TIBETAN DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
0F28;TIBETAN DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
0F29;TIBETAN DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
0F2A;TIBETAN DIGIT HALF ONE;No;0;L;;;;1/2;N;;;;;
0F2B;TIBETAN DIGIT HALF TWO;No;0;L;;;;3/2;N;;;;;
0F2C;TIBETAN DIGIT HALF THREE;No;0;L;;;;5/2;N;;;;;
0F2D;TIBETAN DIGIT HALF FOUR;No;0;L;;;;7/2;N;;;;;
0F2E;TIBETAN DIGIT HALF FIVE;No;0;L;;;;9/2;N;;;;;
0F2F;TIBETAN DIGIT HALF SIX;No;0;L;;;;11/2;N;;;;;
0F30;TIBETAN DIGIT HALF SEVEN;No;0;L;;;;13/2;N;;;;;
0F31;TIBETAN DIGIT HALF EIGHT;No;0;L;;;;15/2;N;;;;;
0F32;TIBETAN DIGIT HALF NINE;No;0;L;;;;17/2;N;;;;;
0F33;TIBETAN DIGIT HALF ZERO;No;0;L;;;;-1/2;N;;;;;
0F34;TIBETAN MARK BSDUS RTAGS;So;0;L;;;;;N;;;;;
0F35;TIBETAN MARK NGAS BZUNG NYI ZLA;Mn;220;NSM;;;;;N;TIBETAN HONORIFIC UNDER RING;;;;
0F36;TIBETAN MARK CARET -DZUD RTAGS BZHI MIG CAN;So;0;L;;;;;N;;;;;
0F37;TIBETAN MARK NGAS BZUNG SGOR RTAGS;Mn;220;NSM;;;;;N;TIBETAN UNDER RING;;;;
0F38;TIBETAN MARK CHE MGO;So;0;L;;;;;N;;;;;
0F39;TIBETAN MARK TSA -PHRU;Mn;216;NSM;;;;;N;TIBETAN LENITION MARK;;;;
0F3A;TIBETAN MARK GUG RTAGS GYON;Ps;0;ON;;;;;Y;;;;;
0F3B;TIBETAN MARK GUG RTAGS GYAS;Pe;0;ON;;;;;Y;;;;;
0F3C;TIBETAN MARK ANG KHANG GYON;Ps;0;ON;;;;;Y;TIBETAN LEFT BRACE;;;;
0F3D;TIBETAN MARK ANG KHANG GYAS;Pe;0;ON;;;;;Y;TIBETAN RIGHT BRACE;;;;
0F3E;TIBETAN SIGN YAR TSHES;Mc;0;L;;;;;N;;;;;
0F3F;TIBETAN SIGN MAR TSHES;Mc;0;L;;;;;N;;;;;
0F40;TIBETAN LETTER KA;Lo;0;L;;;;;N;;;;;
0F41;TIBETAN LETTER KHA;Lo;0;L;;;;;N;;;;;
0F42;TIBETAN LETTER GA;Lo;0;L;;;;;N;;;;;
0F43;TIBETAN LETTER GHA;Lo;0;L;0F42 0FB7;;;;N;;;;;
0F44;TIBETAN LETTER NGA;Lo;0;L;;;;;N;;;;;
0F45;TIBETAN LETTER CA;Lo;0;L;;;;;N;;;;;
0F46;TIBETAN LETTER CHA;Lo;0;L;;;;;N;;;;;
0F47;TIBETAN LETTER JA;Lo;0;L;;;;;N;;;;;
0F49;TIBETAN LETTER NYA;Lo;0;L;;;;;N;;;;;
0F4A;TIBETAN LETTER TTA;Lo;0;L;;;;;N;TIBETAN LETTER REVERSED TA;;;;
0F4B;TIBETAN LETTER TTHA;Lo;0;L;;;;;N;TIBETAN LETTER REVERSED THA;;;;
0F4C;TIBETAN LETTER DDA;Lo;0;L;;;;;N;TIBETAN LETTER REVERSED DA;;;;
0F4D;TIBETAN LETTER DDHA;Lo;0;L;0F4C 0FB7;;;;N;;;;;
0F4E;TIBETAN LETTER NNA;Lo;0;L;;;;;N;TIBETAN LETTER REVERSED NA;;;;
0F4F;TIBETAN LETTER TA;Lo;0;L;;;;;N;;;;;
0F50;TIBETAN LETTER THA;Lo;0;L;;;;;N;;;;;
0F51;TIBETAN LETTER DA;Lo;0;L;;;;;N;;;;;
0F52;TIBETAN LETTER DHA;Lo;0;L;0F51 0FB7;;;;N;;;;;
0F53;TIBETAN LETTER NA;Lo;0;L;;;;;N;;;;;
0F54;TIBETAN LETTER PA;Lo;0;L;;;;;N;;;;;
0F55;TIBETAN LETTER PHA;Lo;0;L;;;;;N;;;;;
0F56;TIBETAN LETTER BA;Lo;0;L;;;;;N;;;;;
0F57;TIBETAN LETTER BHA;Lo;0;L;0F56 0FB7;;;;N;;;;;
0F58;TIBETAN LETTER MA;Lo;0;L;;;;;N;;;;;
0F59;TIBETAN LETTER TSA;Lo;0;L;;;;;N;;;;;
0F5A;TIBETAN LETTER TSHA;Lo;0;L;;;;;N;;;;;
0F5B;TIBETAN LETTER DZA;Lo;0;L;;;;;N;;;;;
0F5C;TIBETAN LETTER DZHA;Lo;0;L;0F5B 0FB7;;;;N;;;;;
0F5D;TIBETAN LETTER WA;Lo;0;L;;;;;N;;;;;
0F5E;TIBETAN LETTER ZHA;Lo;0;L;;;;;N;;;;;
0F5F;TIBETAN LETTER ZA;Lo;0;L;;;;;N;;;;;
0F60;TIBETAN LETTER -A;Lo;0;L;;;;;N;TIBETAN LETTER AA;;;;
0F61;TIBETAN LETTER YA;Lo;0;L;;;;;N;;;;;
0F62;TIBETAN LETTER RA;Lo;0;L;;;;;N;;;;;
0F63;TIBETAN LETTER LA;Lo;0;L;;;;;N;;;;;
0F64;TIBETAN LETTER SHA;Lo;0;L;;;;;N;;;;;
0F65;TIBETAN LETTER SSA;Lo;0;L;;;;;N;TIBETAN LETTER REVERSED SHA;;;;
0F66;TIBETAN LETTER SA;Lo;0;L;;;;;N;;;;;
0F67;TIBETAN LETTER HA;Lo;0;L;;;;;N;;;;;
0F68;TIBETAN LETTER A;Lo;0;L;;;;;N;;;;;
0F69;TIBETAN LETTER KSSA;Lo;0;L;0F40 0FB5;;;;N;;;;;
0F6A;TIBETAN LETTER FIXED-FORM RA;Lo;0;L;;;;;N;;;;;
0F6B;TIBETAN LETTER KKA;Lo;0;L;;;;;N;;;;;
0F6C;TIBETAN LETTER RRA;Lo;0;L;;;;;N;;;;;
0F71;TIBETAN VOWEL SIGN AA;Mn;129;NSM;;;;;N;;;;;
0F72;TIBETAN VOWEL SIGN I;Mn;130;NSM;;;;;N;;;;;
0F73;TIBETAN VOWEL SIGN II;Mn;0;NSM;0F71 0F72;;;;N;;;;;
0F74;TIBETAN VOWEL SIGN U;Mn;132;NSM;;;;;N;;;;;
0F75;TIBETAN VOWEL SIGN UU;Mn;0;NSM;0F71 0F74;;;;N;;;;;
0F76;TIBETAN VOWEL SIGN VOCALIC R;Mn;0;NSM;0FB2 0F80;;;;N;;;;;
0F77;TIBETAN VOWEL SIGN VOCALIC RR;Mn;0;NSM;<compat> 0FB2 0F81;;;;N;;;;;
0F78;TIBETAN VOWEL SIGN VOCALIC L;Mn;0;NSM;0FB3 0F80;;;;N;;;;;
0F79;TIBETAN VOWEL SIGN VOCALIC LL;Mn;0;NSM;<compat> 0FB3 0F81;;;;N;;;;;
0F7A;TIBETAN VOWEL SIGN E;Mn;130;NSM;;;;;N;;;;;
0F7B;TIBETAN VOWEL SIGN EE;Mn;130;NSM;;;;;N;TIBETAN VOWEL SIGN AI;;;;
0F7C;TIBETAN VOWEL SIGN O;Mn;130;NSM;;;;;N;;;;;
0F7D;TIBETAN VOWEL SIGN OO;Mn;130;NSM;;;;;N;TIBETAN VOWEL SIGN AU;;;;
0F7E;TIBETAN SIGN RJES SU NGA RO;Mn;0;NSM;;;;;N;TIBETAN ANUSVARA;;;;
0F7F;TIBETAN SIGN RNAM BCAD;Mc;0;L;;;;;N;TIBETAN VISARGA;;;;
0F80;TIBETAN VOWEL SIGN REVERSED I;Mn;130;NSM;;;;;N;TIBETAN VOWEL SIGN SHORT I;;;;
0F81;TIBETAN VOWEL SIGN REVERSED II;Mn;0;NSM;0F71 0F80;;;;N;;;;;
0F82;TIBETAN SIGN NYI ZLA NAA DA;Mn;230;NSM;;;;;N;TIBETAN CANDRABINDU WITH ORNAMENT;;;;
0F83;TIBETAN SIGN SNA LDAN;Mn;230;NSM;;;;;N;TIBETAN CANDRABINDU;;;;
0F84;TIBETAN MARK HALANTA;Mn;9;NSM;;;;;N;TIBETAN VIRAMA;;;;
0F85;TIBETAN MARK PALUTA;Po;0;L;;;;;N;TIBETAN CHUCHENYIGE;;;;
0F86;TIBETAN SIGN LCI RTAGS;Mn;230;NSM;;;;;N;;;;;
0F87;TIBETAN SIGN YANG RTAGS;Mn;230;NSM;;;;;N;;;;;
0F88;TIBETAN SIGN LCE TSA CAN;Lo;0;L;;;;;N;;;;;
0F89;TIBETAN SIGN MCHU CAN;Lo;0;L;;;;;N;;;;;
0F8A;TIBETAN SIGN GRU CAN RGYINGS;Lo;0;L;;;;;N;;;;;
0F8B;TIBETAN SIGN GRU MED RGYINGS;Lo;0;L;;;;;N;;;;;
0F8C;TIBETAN SIGN INVERTED MCHU CAN;Lo;0;L;;;;;N;;;;;
0F8D;TIBETAN SUBJOINED SIGN LCE TSA CAN;Mn;0;NSM;;;;;N;;;;;
0F8E;TIBETAN SUBJOINED SIGN MCHU CAN;Mn;0;NSM;;;;;N;;;;;
0F8F;TIBETAN SUBJOINED SIGN INVERTED MCHU CAN;Mn;0;NSM;;;;;N;;;;;
0F90;TIBETAN SUBJOINED LETTER KA;Mn;0;NSM;;;;;N;;;;;
0F91;TIBETAN SUBJOINED LETTER KHA;Mn;0;NSM;;;;;N;;;;;
0F92;TIBETAN SUBJOINED LETTER GA;Mn;0;NSM;;;;;N;;;;;
0F93;TIBETAN SUBJOINED LETTER GHA;Mn;0;NSM;0F92 0FB7;;;;N;;;;;
0F94;TIBETAN SUBJOINED LETTER NGA;Mn;0;NSM;;;;;N;;;;;
0F95;TIBETAN SUBJOINED LETTER CA;Mn;0;NSM;;;;;N;;;;;
0F96;TIBETAN SUBJOINED LETTER CHA;Mn;0;NSM;;;;;N;;;;;
0F97;TIBETAN SUBJOINED LETTER JA;Mn;0;NSM;;;;;N;;;;;
0F99;TIBETAN SUBJOINED LETTER NYA;Mn;0;NSM;;;;;N;;;;;
0F9A;TIBETAN SUBJOINED LETTER TTA;Mn;0;NSM;;;;;N;;;;;
0F9B;TIBETAN SUBJOINED LETTER TTHA;Mn;0;NSM;;;;;N;;;;;
0F9C;TIBETAN SUBJOINED LETTER DDA;Mn;0;NSM;;;;;N;;;;;
0F9D;TIBETAN SUBJOINED LETTER DDHA;Mn;0;NSM;0F9C 0FB7;;;;N;;;;;
0F9E;TIBETAN SUBJOINED LETTER NNA;Mn;0;NSM;;;;;N;;;;;
0F9F;TIBETAN SUBJOINED LETTER TA;Mn;0;NSM;;;;;N;;;;;
0FA0;TIBETAN SUBJOINED LETTER THA;Mn;0;NSM;;;;;N;;;;;
0FA1;TIBETAN SUBJOINED LETTER DA;Mn;0;NSM;;;;;N;;;;;
0FA2;TIBETAN SUBJOINED LETTER DHA;Mn;0;NSM;0FA1 0FB7;;;;N;;;;;
0FA3;TIBETAN SUBJOINED LETTER NA;Mn;0;NSM;;;;;N;;;;;
0FA4;TIBETAN SUBJOINED LETTER PA;Mn;0;NSM;;;;;N;;;;;
0FA5;TIBETAN SUBJOINED LETTER PHA;Mn;0;NSM;;;;;N;;;;;
0FA6;TIBETAN SUBJOINED LETTER BA;Mn;0;NSM;;;;;N;;;;;
0FA7;TIBETAN SUBJOINED LETTER BHA;Mn;0;NSM;0FA6 0FB7;;;;N;;;;;
0FA8;TIBETAN SUBJOINED LETTER MA;Mn;0;NSM;;;;;N;;;;;
0FA9;TIBETAN SUBJOINED LETTER TSA;Mn;0;NSM;;;;;N;;;;;
0FAA;TIBETAN SUBJOINED LETTER TSHA;Mn;0;NSM;;;;;N;;;;;
0FAB;TIBETAN SUBJOINED LETTER DZA;Mn;0;NSM;;;;;N;;;;;
0FAC;TIBETAN SUBJOINED LETTER DZHA;Mn;0;NSM;0FAB 0FB7;;;;N;;;;;
0FAD;TIBETAN SUBJOINED LETTER WA;Mn;0;NSM;;;;;N;;;;;
0FAE;TIBETAN SUBJOINED LETTER ZHA;Mn;0;NSM;;;;;N;;;;;
0FAF;TIBETAN SUBJOINED LETTER ZA;Mn;0;NSM;;;;;N;;;;;
0FB0;TIBETAN SUBJOINED LETTER -A;Mn;0;NSM;;;;;N;;;;;
0FB1;TIBETAN SUBJOINED LETTER YA;Mn;0;NSM;;;;;N;;;;;
0FB2;TIBETAN SUBJOINED LETTER RA;Mn;0;NSM;;;;;N;;;;;
0FB3;TIBETAN SUBJOINED LETTER LA;Mn;0;NSM;;;;;N;;;;;
0FB4;TIBETAN SUBJOINED LETTER SHA;Mn;0;NSM;;;;;N;;;;;
0FB5;TIBETAN SUBJOINED LETTER SSA;Mn;0;NSM;;;;;N;;;;;
0FB6;TIBETAN SUBJOINED LETTER SA;Mn;0;NSM;;;;;N;;;;;
0FB7;TIBETAN SUBJOINED LETTER HA;Mn;0;NSM;;;;;N;;;;;
0FB8;TIBETAN SUBJOINED LETTER A;Mn;0;NSM;;;;;N;;;;;
0FB9;TIBETAN SUBJOINED LETTER KSSA;Mn;0;NSM;0F90 0FB5;;;;N;;;;;
0FBA;TIBETAN SUBJOINED LETTER FIXED-FORM WA;Mn;0;NSM;;;;;N;;;;;
0FBB;TIBETAN SUBJOINED LETTER FIXED-FORM YA;Mn;0;NSM;;;;;N;;;;;
0FBC;TIBETAN SUBJOINED LETTER FIXED-FORM RA;Mn;0;NSM;;;;;N;;;;;
0FBE;TIBETAN KU RU KHA;So;0;L;;;;;N;;;;;
0FBF;TIBETAN KU RU KHA BZHI MIG CAN;So;0;L;;;;;N;;;;;
0FC0;TIBETAN CANTILLATION SIGN HEAVY BEAT;So;0;L;;;;;N;;;;;
0FC1;TIBETAN CANTILLATION SIGN LIGHT BEAT;So;0;L;;;;;N;;;;;
0FC2;TIBETAN CANTILLATION SIGN CANG TE-U;So;0;L;;;;;N;;;;;
0FC3;TIBETAN CANTILLATION SIGN SBUB -CHAL;So;0;L;;;;;N;;;;;
0FC4;TIBETAN SYMBOL DRIL BU;So;0;L;;;;;N;;;;;
0FC5;TIBETAN SYMBOL RDO RJE;So;0;L;;;;;N;;;;;
0FC6;TIBETAN SYMBOL PADMA GDAN;Mn;220;NSM;;;;;N;;;;;
0FC7;TIBETAN SYMBOL RDO RJE RGYA GRAM;So;0;L;;;;;N;;;;;
0FC8;TIBETAN SYMBOL PHUR PA;So;0;L;;;;;N;;;;;
0FC9;TIBETAN SYMBOL NOR BU;So;0;L;;;;;N;;;;;
0FCA;TIBETAN SYMBOL NOR BU NYIS -KHYIL;So;0;L;;;;;N;;;;;
0FCB;TIBETAN SYMBOL NOR BU GSUM -KHYIL;So;0;L;;;;;N;;;;;
0FCC;TIBETAN SYMBOL NOR BU BZHI -KHYIL;So;0;L;;;;;N;;;;;
0FCE;TIBETAN SIGN RDEL NAG RDEL DKAR;So;0;L;;;;;N;;;;;
0FCF;TIBETAN SIGN RDEL NAG GSUM;So;0;L;;;;;N;;;;;
0FD0;TIBETAN MARK BSKA- SHOG GI MGO RGYAN;Po;0;L;;;;;N;;;;;
0FD1;TIBETAN MARK MNYAM YIG GI MGO RGYAN;Po;0;L;;;;;N;;;;;
0FD2;TIBETAN MARK NYIS TSHEG;Po;0;L;;;;;N;;;;;
0FD3;TIBETAN MARK INITIAL BRDA RNYING YIG MGO MDUN MA;Po;0;L;;;;;N;;;;;
0FD4;TIBETAN MARK CLOSING BRDA RNYING YIG MGO SGAB MA;Po;0;L;;;;;N;;;;;
0FD5;RIGHT-FACING SVASTI SIGN;So;0;L;;;;;N;;;;;
0FD6;LEFT-FACING SVASTI SIGN;So;0;L;;;;;N;;;;;
0FD7;RIGHT-FACING SVASTI SIGN WITH DOTS;So;0;L;;;;;N;;;;;
0FD8;LEFT-FACING SVASTI SIGN WITH DOTS;So;0;L;;;;;N;;;;;
0FD9;TIBETAN MARK LEADING MCHAN RTAGS;Po;0;L;;;;;N;;;;;
0FDA;TIBETAN MARK TRAILING MCHAN RTAGS;Po;0;L;;;;;N;;;;;
1000;MYANMAR LETTER KA;Lo;0;L;;;;;N;;;;;
1001;MYANMAR LETTER KHA;Lo;0;L;;;;;N;;;;;
1002;MYANMAR LETTER GA;Lo;0;L;;;;;N;;;;;
1003;MYANMAR LETTER GHA;Lo;0;L;;;;;N;;;;;
1004;MYANMAR LETTER NGA;Lo;0;L;;;;;N;;;;;
1005;MYANMAR LETTER CA;Lo;0;L;;;;;N;;;;;
1006;MYANMAR LETTER CHA;Lo;0;L;;;;;N;;;;;
1007;MYANMAR LETTER JA;Lo;0;L;;;;;N;;;;;
1008;MYANMAR LETTER JHA;Lo;0;L;;;;;N;;;;;
1009;MYANMAR LETTER NYA;Lo;0;L;;;;;N;;;;;
100A;MYANMAR LETTER NNYA;Lo;0;L;;;;;N;;;;;
100B;MYANMAR LETTER TTA;Lo;0;L;;;;;N;;;;;
100C;MYANMAR LETTER TTHA;Lo;0;L;;;;;N;;;;;
100D;MYANMAR LETTER DDA;Lo;0;L;;;;;N;;;;;
100E;MYANMAR LETTER DDHA;Lo;0;L;;;;;N;;;;;
100F;MYANMAR LETTER NNA;Lo;0;L;;;;;N;;;;;
1010;MYANMAR LETTER TA;Lo;0;L;;;;;N;;;;;
1011;MYANMAR LETTER THA;Lo;0;L;;;;;N;;;;;
1012;MYANMAR LETTER DA;Lo;0;L;;;;;N;;;;;
1013;MYANMAR LETTER DHA;Lo;0;L;;;;;N;;;;;
1014;MYANMAR LETTER NA;Lo;0;L;;;;;N;;;;;
1015;MYANMAR LETTER PA;Lo;0;L;;;;;N;;;;;
1016;MYANMAR LETTER PHA;Lo;0;L;;;;;N;;;;;
1017;MYANMAR LETTER BA;Lo;0;L;;;;;N;;;;;
1018;MYANMAR LETTER BHA;Lo;0;L;;;;;N;;;;;
1019;MYANMAR LETTER MA;Lo;0;L;;;;;N;;;;;
101A;MYANMAR LETTER YA;Lo;0;L;;;;;N;;;;;
101B;MYANMAR LETTER RA;Lo;0;L;;;;;N;;;;;
101C;MYANMAR LETTER LA;Lo;0;L;;;;;N;;;;;
101D;MYANMAR LETTER WA;Lo;0;L;;;;;N;;;;;
101E;MYANMAR LETTER SA;Lo;0;L;;;;;N;;;;;
101F;MYANMAR LETTER HA;Lo;0;L;;;;;N;;;;;
1020;MYANMAR LETTER LLA;Lo;0;L;;;;;N;;;;;
1021;MYANMAR LETTER A;Lo;0;L;;;;;N;;;;;
1022;MYANMAR LETTER SHAN A;Lo;0;L;;;;;N;;;;;
1023;MYANMAR LETTER I;Lo;0;L;;;;;N;;;;;
1024;MYANMAR LETTER II;Lo;0;L;;;;;N;;;;;
1025;MYANMAR LETTER U;Lo;0;L;;;;;N;;;;;
1026;MYANMAR LETTER UU;Lo;0;L;1025 102E;;;;N;;;;;
1027;MYANMAR LETTER E;Lo;0;L;;;;;N;;;;;
1028;MYANMAR LETTER MON E;Lo;0;L;;;;;N;;;;;
1029;MYANMAR LETTER O;Lo;0;L;;;;;N;;;;;
102A;MYANMAR LETTER AU;Lo;0;L;;;;;N;;;;;
102B;MYANMAR VOWEL SIGN TALL AA;Mc;0;L;;;;;N;;;;;
102C;MYANMAR VOWEL SIGN AA;Mc;0;L;;;;;N;;;;;
102D;MYANMAR VOWEL SIGN I;Mn;0;NSM;;;;;N;;;;;
102E;MYANMAR VOWEL SIGN II;Mn;0;NSM;;;;;N;;;;;
102F;MYANMAR VOWEL SIGN U;Mn;0;NSM;;;;;N;;;;;
1030;MYANMAR VOWEL SIGN UU;Mn;0;NSM;;;;;N;;;;;
1031;MYANMAR VOWEL SIGN E;Mc;0;L;;;;;N;;;;;
1032;MYANMAR VOWEL SIGN AI;Mn;0;NSM;;;;;N;;;;;
1033;MYANMAR VOWEL SIGN MON II;Mn;0;NSM;;;;;N;;;;;
1034;MYANMAR VOWEL SIGN MON O;Mn;0;NSM;;;;;N;;;;;
1035;MYANMAR VOWEL SIGN E ABOVE;Mn;0;NSM;;;;;N;;;;;
1036;MYANMAR SIGN ANUSVARA;Mn;0;NSM;;;;;N;;;;;
1037;MYANMAR SIGN DOT BELOW;Mn;7;NSM;;;;;N;;;;;
1038;MYANMAR SIGN VISARGA;Mc;0;L;;;;;N;;;;;
1039;MYANMAR SIGN VIRAMA;Mn;9;NSM;;;;;N;;;;;
103A;MYANMAR SIGN ASAT;Mn;9;NSM;;;;;N;;;;;
103B;MYANMAR CONSONANT SIGN MEDIAL YA;Mc;0;L;;;;;N;;;;;
103C;MYANMAR CONSONANT SIGN MEDIAL RA;Mc;0;L;;;;;N;;;;;
103D;MYANMAR CONSONANT SIGN MEDIAL WA;Mn;0;NSM;;;;;N;;;;;
103E;MYANMAR CONSONANT SIGN MEDIAL HA;Mn;0;NSM;;;;;N;;;;;
103F;MYANMAR LETTER GREAT SA;Lo;0;L;;;;;N;;;;;
1040;MYANMAR DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
1041;MYANMAR DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
1042;MYANMAR DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
1043;MYANMAR DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
1044;MYANMAR DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
1045;MYANMAR DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
1046;MYANMAR DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
1047;MYANMAR DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
1048;MYANMAR DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
1049;MYANMAR DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
104A;MYANMAR SIGN LITTLE SECTION;Po;0;L;;;;;N;;;;;
104B;MYANMAR SIGN SECTION;Po;0;L;;;;;N;;;;;
104C;MYANMAR SYMBOL LOCATIVE;Po;0;L;;;;;N;;;;;
104D;MYANMAR SYMBOL COMPLETED;Po;0;L;;;;;N;;;;;
104E;MYANMAR SYMBOL AFOREMENTIONED;Po;0;L;;;;;N;;;;;
104F;MYANMAR SYMBOL GENITIVE;Po;0;L;;;;;N;;;;;
1050;MYANMAR LETTER SHA;Lo;0;L;;;;;N;;;;;
1051;MYANMAR LETTER SSA;Lo;0;L;;;;;N;;;;;
1052;MYANMAR LETTER VOCALIC R;Lo;0;L;;;;;N;;;;;
1053;MYANMAR LETTER VOCALIC RR;Lo;0;L;;;;;N;;;;;
1054;MYANMAR LETTER VOCALIC L;Lo;0;L;;;;;N;;;;;
1055;MYANMAR LETTER VOCALIC LL;Lo;0;L;;;;;N;;;;;
1056;MYANMAR VOWEL SIGN VOCALIC R;Mc;0;L;;;;;N;;;;;
1057;MYANMAR VOWEL SIGN VOCALIC RR;Mc;0;L;;;;;N;;;;;
1058;MYANMAR VOWEL SIGN VOCALIC L;Mn;0;NSM;;;;;N;;;;;
1059;MYANMAR VOWEL SIGN VOCALIC LL;Mn;0;NSM;;;;;N;;;;;
105A;MYANMAR LETTER MON NGA;Lo;0;L;;;;;N;;;;;
105B;MYANMAR LETTER MON JHA;Lo;0;L;;;;;N;;;;;
105C;MYANMAR LETTER MON BBA;Lo;0;L;;;;;N;;;;;
105D;MYANMAR LETTER MON BBE;Lo;0;L;;;;;N;;;;;
105E;MYANMAR CONSONANT SIGN MON MEDIAL NA;Mn;0;NSM;;;;;N;;;;;
105F;MYANMAR CONSONANT SIGN MON MEDIAL MA;Mn;0;NSM;;;;;N;;;;;
1060;MYANMAR CONSONANT SIGN MON MEDIAL LA;Mn;0;NSM;;;;;N;;;;;
1061;MYANMAR LETTER SGAW KAREN SHA;Lo;0;L;;;;;N;;;;;
1062;MYANMAR VOWEL SIGN SGAW KAREN EU;Mc;0;L;;;;;N;;;;;
1063;MYANMAR TONE MARK SGAW KAREN HATHI;Mc;0;L;;;;;N;;;;;
1064;MYANMAR TONE MARK SGAW KAREN KE PHO;Mc;0;L;;;;;N;;;;;
1065;MYANMAR LETTER WESTERN PWO KAREN THA;Lo;0;L;;;;;N;;;;;
1066;MYANMAR LETTER WESTERN PWO KAREN PWA;Lo;0;L;;;;;N;;;;;
1067;MYANMAR VOWEL SIGN WESTERN PWO KAREN EU;Mc;0;L;;;;;N;;;;;
1068;MYANMAR VOWEL SIGN WESTERN PWO KAREN UE;Mc;0;L;;;;;N;;;;;
1069;MYANMAR SIGN WESTERN PWO KAREN TONE-1;Mc;0;L;;;;;N;;;;;
106A;MYANMAR SIGN WESTERN PWO KAREN TONE-2;Mc;0;L;;;;;N;;;;;
106B;MYANMAR SIGN WESTERN PWO KAREN TONE-3;Mc;0;L;;;;;N;;;;;
106C;MYANMAR SIGN WESTERN PWO KAREN TONE-4;Mc;0;L;;;;;N;;;;;
106D;MYANMAR SIGN WESTERN PWO KAREN TONE-5;Mc;0;L;;;;;N;;;;;
106E;MYANMAR LETTER EASTERN PWO KAREN NNA;Lo;0;L;;;;;N;;;;;
106F;MYANMAR LETTER EASTERN PWO KAREN YWA;Lo;0;L;;;;;N;;;;;
1070;MYANMAR LETTER EASTERN PWO KAREN GHWA;Lo;0;L;;;;;N;;;;;
1071;MYANMAR VOWEL SIGN GEBA KAREN I;Mn;0;NSM;;;;;N;;;;;
1072;MYANMAR VOWEL SIGN KAYAH OE;Mn;0;NSM;;;;;N;;;;;
1073;MYANMAR VOWEL SIGN KAYAH U;Mn;0;NSM;;;;;N;;;;;
1074;MYANMAR VOWEL SIGN KAYAH EE;Mn;0;NSM;;;;;N;;;;;
1075;MYANMAR LETTER SHAN KA;Lo;0;L;;;;;N;;;;;
1076;MYANMAR LETTER SHAN KHA;Lo;0;L;;;;;N;;;;;
1077;MYANMAR LETTER SHAN GA;Lo;0;L;;;;;N;;;;;
1078;MYANMAR LETTER SHAN CA;Lo;0;L;;;;;N;;;;;
1079;MYANMAR LETTER SHAN ZA;Lo;0;L;;;;;N;;;;;
107A;MYANMAR LETTER SHAN NYA;Lo;0;L;;;;;N;;;;;
107B;MYANMAR LETTER SHAN DA;Lo;0;L;;;;;N;;;;;
107C;MYANMAR LETTER SHAN NA;Lo;0;L;;;;;N;;;;;
107D;MYANMAR LETTER SHAN PHA;Lo;0;L;;;;;N;;;;;
107E;MYANMAR LETTER SHAN FA;Lo;0;L;;;;;N;;;;;
107F;MYANMAR LETTER SHAN BA;Lo;0;L;;;;;N;;;;;
1080;MYANMAR LETTER SHAN THA;Lo;0;L;;;;;N;;;;;
1081;MYANMAR LETTER SHAN HA;Lo;0;L;;;;;N;;;;;
1082;MYANMAR CONSONANT SIGN SHAN MEDIAL WA;Mn;0;NSM;;;;;N;;;;;
1083;MYANMAR VOWEL SIGN SHAN AA;Mc;0;L;;;;;N;;;;;
1084;MYANMAR VOWEL SIGN SHAN E;Mc;0;L;;;;;N;;;;;
1085;MYANMAR VOWEL SIGN SHAN E ABOVE;Mn;0;NSM;;;;;N;;;;;
1086;MYANMAR VOWEL SIGN SHAN FINAL Y;Mn;0;NSM;;;;;N;;;;;
1087;MYANMAR SIGN SHAN TONE-2;Mc;0;L;;;;;N;;;;;
1088;MYANMAR SIGN SHAN TONE-3;Mc;0;L;;;;;N;;;;;
1089;MYANMAR SIGN SHAN TONE-5;Mc;0;L;;;;;N;;;;;
108A;MYANMAR SIGN SHAN TONE-6;Mc;0;L;;;;;N;;;;;
108B;MYANMAR SIGN SHAN COUNCIL TONE-2;Mc;0;L;;;;;N;;;;;
108C;MYANMAR SIGN SHAN COUNCIL TONE-3;Mc;0;L;;;;;N;;;;;
108D;MYANMAR SIGN SHAN COUNCIL EMPHATIC TONE;Mn;220;NSM;;;;;N;;;;;
108E;MYANMAR LETTER RUMAI PALAUNG FA;Lo;0;L;;;;;N;;;;;
108F;MYANMAR SIGN RUMAI PALAUNG TONE-5;Mc;0;L;;;;;N;;;;;
1090;MYANMAR SHAN DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
1091;MYANMAR SHAN DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
1092;MYANMAR SHAN DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
1093;MYANMAR SHAN DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
1094;MYANMAR SHAN DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
1095;MYANMAR SHAN DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
1096;MYANMAR SHAN DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
1097;MYANMAR SHAN DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
1098;MYANMAR SHAN DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
1099;MYANMAR SHAN DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
109A;MYANMAR SIGN KHAMTI TONE-1;Mc;0;L;;;;;N;;;;;
109B;MYANMAR SIGN KHAMTI TONE-3;Mc;0;L;;;;;N;;;;;
109C;MYANMAR VOWEL SIGN AITON A;Mc;0;L;;;;;N;;;;;
109D;MYANMAR VOWEL SIGN AITON AI;Mn;0;NSM;;;;;N;;;;;
109E;MYANMAR SYMBOL SHAN ONE;So;0;L;;;;;N;;;;;
109F;MYANMAR SYMBOL SHAN EXCLAMATION;So;0;L;;;;;N;;;;;
10A0;GEORGIAN CAPITAL LETTER AN;Lu;0;L;;;;;N;;;;2D00;
10A1;GEORGIAN CAPITAL LETTER BAN;Lu;0;L;;;;;N;;;;2D01;
10A2;GEORGIAN CAPITAL LETTER GAN;Lu;0;L;;;;;N;;;;2D02;
10A3;GEORGIAN CAPITAL LETTER DON;Lu;0;L;;;;;N;;;;2D03;
10A4;GEORGIAN CAPITAL LETTER EN;Lu;0;L;;;;;N;;;;2D04;
10A5;GEORGIAN CAPITAL LETTER VIN;Lu;0;L;;;;;N;;;;2D05;
10A6;GEORGIAN CAPITAL LETTER ZEN;Lu;0;L;;;;;N;;;;2D06;
10A7;GEORGIAN CAPITAL LETTER TAN;Lu;0;L;;;;;N;;;;2D07;
10A8;GEORGIAN CAPITAL LETTER IN;Lu;0;L;;;;;N;;;;2D08;
10A9;GEORGIAN CAPITAL LETTER KAN;Lu;0;L;;;;;N;;;;2D09;
10AA;GEORGIAN CAPITAL LETTER LAS;Lu;0;L;;;;;N;;;;2D0A;
10AB;GEORGIAN CAPITAL LETTER MAN;Lu;0;L;;;;;N;;;;2D0B;
10AC;GEORGIAN CAPITAL LETTER NAR;Lu;0;L;;;;;N;;;;2D0C;
10AD;GEORGIAN CAPITAL LETTER ON;Lu;0;L;;;;;N;;;;2D0D;
10AE;GEORGIAN CAPITAL LETTER PAR;Lu;0;L;;;;;N;;;;2D0E;
10AF;GEORGIAN CAPITAL LETTER ZHAR;Lu;0;L;;;;;N;;;;2D0F;
10B0;GEORGIAN CAPITAL LETTER RAE;Lu;0;L;;;;;N;;;;2D10;
10B1;GEORGIAN CAPITAL LETTER SAN;Lu;0;L;;;;;N;;;;2D11;
10B2;GEORGIAN CAPITAL LETTER TAR;Lu;0;L;;;;;N;;;;2D12;
10B3;GEORGIAN CAPITAL LETTER UN;Lu;0;L;;;;;N;;;;2D13;
10B4;GEORGIAN CAPITAL LETTER PHAR;Lu;0;L;;;;;N;;;;2D14;
10B5;GEORGIAN CAPITAL LETTER KHAR;Lu;0;L;;;;;N;;;;2D15;
10B6;GEORGIAN CAPITAL LETTER GHAN;Lu;0;L;;;;;N;;;;2D16;
10B7;GEORGIAN CAPITAL LETTER QAR;Lu;0;L;;;;;N;;;;2D17;
10B8;GEORGIAN CAPITAL LETTER SHIN;Lu;0;L;;;;;N;;;;2D18;
10B9;GEORGIAN CAPITAL LETTER CHIN;Lu;0;L;;;;;N;;;;2D19;
10BA;GEORGIAN CAPITAL LETTER CAN;Lu;0;L;;;;;N;;;;2D1A;
10BB;GEORGIAN CAPITAL LETTER JIL;Lu;0;L;;;;;N;;;;2D1B;
10BC;GEORGIAN CAPITAL LETTER CIL;Lu;0;L;;;;;N;;;;2D1C;
10BD;GEORGIAN CAPITAL LETTER CHAR;Lu;0;L;;;;;N;;;;2D1D;
10BE;GEORGIAN CAPITAL LETTER XAN;Lu;0;L;;;;;N;;;;2D1E;
10BF;GEORGIAN CAPITAL LETTER JHAN;Lu;0;L;;;;;N;;;;2D1F;
10C0;GEORGIAN CAPITAL LETTER HAE;Lu;0;L;;;;;N;;;;2D20;
10C1;GEORGIAN CAPITAL LETTER HE;Lu;0;L;;;;;N;;;;2D21;
10C2;GEORGIAN CAPITAL LETTER HIE;Lu;0;L;;;;;N;;;;2D22;
10C3;GEORGIAN CAPITAL LETTER WE;Lu;0;L;;;;;N;;;;2D23;
10C4;GEORGIAN CAPITAL LETTER HAR;Lu;0;L;;;;;N;;;;2D24;
10C5;GEORGIAN CAPITAL LETTER HOE;Lu;0;L;;;;;N;;;;2D25;
10C7;GEORGIAN CAPITAL LETTER YN;Lu;0;L;;;;;N;;;;2D27;
10CD;GEORGIAN CAPITAL LETTER AEN;Lu;0;L;;;;;N;;;;2D2D;
10D0;GEORGIAN LETTER AN;Ll;0;L;;;;;N;GEORGIAN SMALL LETTER AN;;1C90;;10D0
10D1;GEORGIAN LETTER BAN;Ll;0;L;;;;;N;GEORGIAN SMALL LETTER BAN;;1C91;;10D1
10D2;GEORGIAN LETTER GAN;Ll;0;L;;;;;N;GEORGIAN SMALL LETTER GAN;;1C92;;10D2
10D3;GEORGIAN LETTER DON;Ll;0;L;;;;;N;GEORGIAN SMALL LETTER DON;;1C93;;10D3
10D4;GEORGIAN LETTER EN;Ll;0;L;;;;;N;GEORGIAN SMALL LETTER EN;;1C94;;10D4
10D5;GEORGIAN LETTER VIN;Ll;0;L;;;;;N;GEORGIAN SMALL LETTER VIN;;1C95;;10D5
10D6;GEORGIAN LETTER ZEN;Ll;0;L;;;;;N;GEORGIAN SMALL LETTER ZEN;;1C96;;10D6
10D7;GEORGIAN LETTER TAN;Ll;0;L;;;;;N;GEORGIAN SMALL LETTER TAN;;1C97;;10D7
10D8;GEORGIAN LETTER IN;Ll;0;L;;;;;N;GEORGIAN SMALL LETTER IN;;1C98;;10D8
10D9;GEORGIAN LETTER KAN;Ll;0;L;;;;;N;GEORGIAN SMALL LETTER KAN;;1C99;;10D9
10DA;GEORGIAN LETTER LAS;Ll;0;L;;;;;N;GEORGIAN SMALL LETTER LAS;;1C9A;;10DA
10DB;GEORGIAN LETTER MAN;Ll;0;L;;;;;N;GEORGIAN SMALL LETTER MAN;;1C9B;;10DB
10DC;GEORGIAN LETTER NAR;Ll;0;L;;;;;N;GEORGIAN SMALL LETTER NAR;;1C9C;;10DC
10DD;GEORGIAN LETTER ON;Ll;0;L;;;;;N;GEORGIAN SMALL LETTER ON;;1C9D;;10DD
10DE;GEORGIAN LETTER PAR;Ll;0;L;;;;;N;GEORGIAN SMALL LETTER PAR;;1C9E;;10DE
10DF;GEORGIAN LETTER ZHAR;Ll;0;L;;;;;N;GEORGIAN SMALL LETTER ZHAR;;1C9F;;10DF
10E0;GEORGIAN LETTER RAE;Ll;0;L;;;;;N;GEORGIAN SMALL LETTER RAE;;1CA0;;10E0
10E1;GEORGIAN LETTER SAN;Ll;0;L;;;;;N;GEORGIAN SMALL LETTER SAN;;1CA1;;10E1
10E2;GEORGIAN LETTER TAR;Ll;0;L;;;;;N;GEORGIAN SMALL LETTER TAR;;1CA2;;10E2
10E3;GEORGIAN LETTER UN;Ll;0;L;;;;;N;GEORGIAN SMALL LETTER UN;;1CA3;;10E3
10E4;GEORGIAN LETTER PHAR;Ll;0;L;;;;;N;GEORGIAN SMALL LETTER PHAR;;1CA4;;10E4
10E5;GEORGIAN LETTER KHAR;Ll;0;L;;;;;N;GEORGIAN SMALL LETTER KHAR;;1CA5;;10E5
10E6;GEORGIAN LETTER GHAN;Ll;0;L;;;;;N;GEORGIAN SMALL LETTER GHAN;;1CA6;;10E6
10E7;GEORGIAN LETTER QAR;Ll;0;L;;;;;N;GEORGIAN SMALL LETTER QAR;;1CA7;;10E7
10E8;GEORGIAN LETTER SHIN;Ll;0;L;;;;;N;GEORGIAN SMALL LETTER SHIN;;1CA8;;10E8
10E9;GEORGIAN LETTER CHIN;Ll;0;L;;;;;N;GEORGIAN SMALL LETTER CHIN;;1CA9;;10E9
10EA;GEORGIAN LETTER CAN;Ll;0;L;;;;;N;GEORGIAN SMALL LETTER CAN;;1CAA;;10EA
10EB;GEORGIAN LETTER JIL;Ll;0;L;;;;;N;GEORGIAN SMALL LETTER JIL;;1CAB;;10EB
10EC;GEORGIAN LETTER CIL;Ll;0;L;;;;;N;GEORGIAN SMALL LETTER CIL;;1CAC;;10EC
10ED;GEORGIAN LETTER CHAR;Ll;0;L;;;;;N;GEORGIAN SMALL LETTER CHAR;;1CAD;;10ED
10EE;GEORGIAN LETTER XAN;Ll;0;L;;;;;N;GEORGIAN SMALL LETTER XAN;;1CAE;;10EE
10EF;GEORGIAN LETTER JHAN;Ll;0;L;;;;;N;GEORGIAN SMALL LETTER JHAN;;1CAF;;10EF
10F0;GEORGIAN LETTER HAE;Ll;0;L;;;;;N;GEORGIAN SMALL LETTER HAE;;1CB0;;10F0
10F1;GEORGIAN LETTER HE;Ll;0;L;;;;;N;GEORGIAN SMALL LETTER HE;;1CB1;;10F1
10F2;GEORGIAN LETTER HIE;Ll;0;L;;;;;N;GEORGIAN SMALL LETTER HIE;;1CB2;;10F2
10F3;GEORGIAN LETTER WE;Ll;0;L;;;;;N;GEORGIAN SMALL LETTER WE;;1CB3;;10F3
10F4;GEORGIAN LETTER HAR;Ll;0;L;;;;;N;GEORGIAN SMALL LETTER HAR;;1CB4;;10F4
10F5;GEORGIAN LETTER HOE;Ll;0;L;;;;;N;GEORGIAN SMALL LETTER HOE;;1CB5;;10F5
10F6;GEORGIAN LETTER FI;Ll;0;L;;;;;N;GEORGIAN SMALL LETTER FI;;1CB6;;10F6
10F7;GEORGIAN LETTER YN;Ll;0;L;;;;;N;;;1CB7;;10F7
10F8;GEORGIAN LETTER ELIFI;Ll;0;L;;;;;N;;;1CB8;;10F8
10F9;GEORGIAN LETTER TURNED GAN;Ll;0;L;;;;;N;;;1CB9;;10F9
10FA;GEORGIAN LETTER AIN;Ll;0;L;;;;;N;;;1CBA;;10FA
10FB;GEORGIAN PARAGRAPH SEPARATOR;Po;0;L;;;;;N;;;;;
10FC;MODIFIER LETTER GEORGIAN NAR;Lm;0;L;<super> 10DC;;;;N;;;;;
10FD;GEORGIAN LETTER AEN;Ll;0;L;;;;;N;;;1CBD;;10FD
10FE;GEORGIAN LETTER HARD SIGN;Ll;0;L;;;;;N;;;1CBE;;10FE
10FF;GEORGIAN LETTER LABIAL SIGN;Ll;0;L;;;;;N;;;1CBF;;10FF
1100;HANGUL CHOSEONG KIYEOK;Lo;0;L;;;;;N;;;;;
1101;HANGUL CHOSEONG SSANGKIYEOK;Lo;0;L;;;;;N;;;;;
1102;HANGUL CHOSEONG NIEUN;Lo;0;L;;;;;N;;;;;
1103;HANGUL CHOSEONG TIKEUT;Lo;0;L;;;;;N;;;;;
1104;HANGUL CHOSEONG SSANGTIKEUT;Lo;0;L;;;;;N;;;;;
1105;HANGUL CHOSEONG RIEUL;Lo;0;L;;;;;N;;;;;
1106;HANGUL CHOSEONG MIEUM;Lo;0;L;;;;;N;;;;;
1107;HANGUL CHOSEONG PIEUP;Lo;0;L;;;;;N;;;;;
1108;HANGUL CHOSEONG SSANGPIEUP;Lo;0;L;;;;;N;;;;;
1109;HANGUL CHOSEONG SIOS;Lo;0;L;;;;;N;;;;;
110A;HANGUL CHOSEONG SSANGSIOS;Lo;0;L;;;;;N;;;;;
110B;HANGUL CHOSEONG IEUNG;Lo;0;L;;;;;N;;;;;
110C;HANGUL CHOSEONG CIEUC;Lo;0;L;;;;;N;;;;;
110D;HANGUL CHOSEONG SSANGCIEUC;Lo;0;L;;;;;N;;;;;
110E;HANGUL CHOSEONG CHIEUCH;Lo;0;L;;;;;N;;;;;
110F;HANGUL CHOSEONG KHIEUKH;Lo;0;L;;;;;N;;;;;
1110;HANGUL CHOSEONG THIEUTH;Lo;0;L;;;;;N;;;;;
1111;HANGUL CHOSEONG PHIEUPH;Lo;0;L;;;;;N;;;;;
1112;HANGUL CHOSEONG HIEUH;Lo;0;L;;;;;N;;;;;
1113;HANGUL CHOSEONG NIEUN-KIYEOK;Lo;0;L;;;;;N;;;;;
1114;HANGUL CHOSEONG SSANGNIEUN;Lo;0;L;;;;;N;;;;;
1115;HANGUL CHOSEONG NIEUN-TIKEUT;Lo;0;L;;;;;N;;;;;
1116;HANGUL CHOSEONG NIEUN-PIEUP;Lo;0;L;;;;;N;;;;;
1117;HANGUL CHOSEONG TIKEUT-KIYEOK;Lo;0;L;;;;;N;;;;;
1118;HANGUL CHOSEONG RIEUL-NIEUN;Lo;0;L;;;;;N;;;;;
1119;HANGUL CHOSEONG SSANGRIEUL;Lo;0;L;;;;;N;;;;;
111A;HANGUL CHOSEONG RIEUL-HIEUH;Lo;0;L;;;;;N;;;;;
111B;HANGUL CHOSEONG KAPYEOUNRIEUL;Lo;0;L;;;;;N;;;;;
111C;HANGUL CHOSEONG MIEUM-PIEUP;Lo;0;L;;;;;N;;;;;
111D;HANGUL CHOSEONG KAPYEOUNMIEUM;Lo;0;L;;;;;N;;;;;
111E;HANGUL CHOSEONG PIEUP-KIYEOK;Lo;0;L;;;;;N;;;;;
111F;HANGUL CHOSEONG PIEUP-NIEUN;Lo;0;L;;;;;N;;;;;
1120;HANGUL CHOSEONG PIEUP-TIKEUT;Lo;0;L;;;;;N;;;;;
1121;HANGUL CHOSEONG PIEUP-SIOS;Lo;0;L;;;;;N;;;;;
1122;HANGUL CHOSEONG PIEUP-SIOS-KIYEOK;Lo;0;L;;;;;N;;;;;
1123;HANGUL CHOSEONG PIEUP-SIOS-TIKEUT;Lo;0;L;;;;;N;;;;;
1124;HANGUL CHOSEONG PIEUP-SIOS-PIEUP;Lo;0;L;;;;;N;;;;;
1125;HANGUL CHOSEONG PIEUP-SSANGSIOS;Lo;0;L;;;;;N;;;;;
1126;HANGUL CHOSEONG PIEUP-SIOS-CIEUC;Lo;0;L;;;;;N;;;;;
1127;HANGUL CHOSEONG PIEUP-CIEUC;Lo;0;L;;;;;N;;;;;
1128;HANGUL CHOSEONG PIEUP-CHIEUCH;Lo;0;L;;;;;N;;;;;
1129;HANGUL CHOSEONG PIEUP-THIEUTH;Lo;0;L;;;;;N;;;;;
112A;HANGUL CHOSEONG PIEUP-PHIEUPH;Lo;0;L;;;;;N;;;;;
112B;HANGUL CHOSEONG KAPYEOUNPIEUP;Lo;0;L;;;;;N;;;;;
112C;HANGUL CHOSEONG KAPYEOUNSSANGPIEUP;Lo;0;L;;;;;N;;;;;
112D;HANGUL CHOSEONG SIOS-KIYEOK;Lo;0;L;;;;;N;;;;;
112E;HANGUL CHOSEONG SIOS-NIEUN;Lo;0;L;;;;;N;;;;;
112F;HANGUL CHOSEONG SIOS-TIKEUT;Lo;0;L;;;;;N;;;;;
1130;HANGUL CHOSEONG SIOS-RIEUL;Lo;0;L;;;;;N;;;;;
1131;HANGUL CHOSEONG SIOS-MIEUM;Lo;0;L;;;;;N;;;;;
1132;HANGUL CHOSEONG SIOS-PIEUP;Lo;0;L;;;;;N;;;;;
1133;HANGUL CHOSEONG SIOS-PIEUP-KIYEOK;Lo;0;L;;;;;N;;;;;
1134;HANGUL CHOSEONG SIOS-SSANGSIOS;Lo;0;L;;;;;N;;;;;
1135;HANGUL CHOSEONG SIOS-IEUNG;Lo;0;L;;;;;N;;;;;
1136;HANGUL CHOSEONG SIOS-CIEUC;Lo;0;L;;;;;N;;;;;
1137;HANGUL CHOSEONG SIOS-CHIEUCH;Lo;0;L;;;;;N;;;;;
1138;HANGUL CHOSEONG SIOS-KHIEUKH;Lo;0;L;;;;;N;;;;;
1139;HANGUL CHOSEONG SIOS-THIEUTH;Lo;0;L;;;;;N;;;;;
113A;HANGUL CHOSEONG SIOS-PHIEUPH;Lo;0;L;;;;;N;;;;;
113B;HANGUL CHOSEONG SIOS-HIEUH;Lo;0;L;;;;;N;;;;;
113C;HANGUL CHOSEONG CHITUEUMSIOS;Lo;0;L;;;;;N;;;;;
113D;HANGUL CHOSEONG CHITUEUMSSANGSIOS;Lo;0;L;;;;;N;;;;;
113E;HANGUL CHOSEONG CEONGCHIEUMSIOS;Lo;0;L;;;;;N;;;;;
113F;HANGUL CHOSEONG CEONGCHIEUMSSANGSIOS;Lo;0;L;;;;;N;;;;;
1140;HANGUL CHOSEONG PANSIOS;Lo;0;L;;;;;N;;;;;
1141;HANGUL CHOSEONG IEUNG-KIYEOK;Lo;0;L;;;;;N;;;;;
1142;HANGUL CHOSEONG IEUNG-TIKEUT;Lo;0;L;;;;;N;;;;;
1143;HANGUL CHOSEONG IEUNG-MIEUM;Lo;0;L;;;;;N;;;;;
1144;HANGUL CHOSEONG IEUNG-PIEUP;Lo;0;L;;;;;N;;;;;
1145;HANGUL CHOSEONG IEUNG-SIOS;Lo;0;L;;;;;N;;;;;
1146;HANGUL CHOSEONG IEUNG-PANSIOS;Lo;0;L;;;;;N;;;;;
1147;HANGUL CHOSEONG SSANGIEUNG;Lo;0;L;;;;;N;;;;;
1148;HANGUL CHOSEONG IEUNG-CIEUC;Lo;0;L;;;;;N;;;;;
1149;HANGUL CHOSEONG IEUNG-CHIEUCH;Lo;0;L;;;;;N;;;;;
114A;HANGUL CHOSEONG IEUNG-THIEUTH;Lo;0;L;;;;;N;;;;;
114B;HANGUL CHOSEONG IEUNG-PHIEUPH;Lo;0;L;;;;;N;;;;;
114C;HANGUL CHOSEONG YESIEUNG;Lo;0;L;;;;;N;;;;;
114D;HANGUL CHOSEONG CIEUC-IEUNG;Lo;0;L;;;;;N;;;;;
114E;HANGUL CHOSEONG CHITUEUMCIEUC;Lo;0;L;;;;;N;;;;;
114F;HANGUL CHOSEONG CHITUEUMSSANGCIEUC;Lo;0;L;;;;;N;;;;;
1150;HANGUL CHOSEONG CEONGCHIEUMCIEUC;Lo;0;L;;;;;N;;;;;
1151;HANGUL CHOSEONG CEONGCHIEUMSSANGCIEUC;Lo;0;L;;;;;N;;;;;
1152;HANGUL CHOSEONG CHIEUCH-KHIEUKH;Lo;0;L;;;;;N;;;;;
1153;HANGUL CHOSEONG CHIEUCH-HIEUH;Lo;0;L;;;;;N;;;;;
1154;HANGUL CHOSEONG CHITUEUMCHIEUCH;Lo;0;L;;;;;N;;;;;
1155;HANGUL CHOSEONG CEONGCHIEUMCHIEUCH;Lo;0;L;;;;;N;;;;;
1156;HANGUL CHOSEONG PHIEUPH-PIEUP;Lo;0;L;;;;;N;;;;;
1157;HANGUL CHOSEONG KAPYEOUNPHIEUPH;Lo;0;L;;;;;N;;;;;
1158;HANGUL CHOSEONG SSANGHIEUH;Lo;0;L;;;;;N;;;;;
1159;HANGUL CHOSEONG YEORINHIEUH;Lo;0;L;;;;;N;;;;;
115A;HANGUL CHOSEONG KIYEOK-TIKEUT;Lo;0;L;;;;;N;;;;;
115B;HANGUL CHOSEONG NIEUN-SIOS;Lo;0;L;;;;;N;;;;;
115C;HANGUL CHOSEONG NIEUN-CIEUC;Lo;0;L;;;;;N;;;;;
115D;HANGUL CHOSEONG NIEUN-HIEUH;Lo;0;L;;;;;N;;;;;
115E;HANGUL CHOSEONG TIKEUT-RIEUL;Lo;0;L;;;;;N;;;;;
115F;HANGUL CHOSEONG FILLER;Lo;0;L;;;;;N;;;;;
1160;HANGUL JUNGSEONG FILLER;Lo;0;L;;;;;N;;;;;
1161;HANGUL JUNGSEONG A;Lo;0;L;;;;;N;;;;;
1162;HANGUL JUNGSEONG AE;Lo;0;L;;;;;N;;;;;
1163;HANGUL JUNGSEONG YA;Lo;0;L;;;;;N;;;;;
1164;HANGUL JUNGSEONG YAE;Lo;0;L;;;;;N;;;;;
1165;HANGUL JUNGSEONG EO;Lo;0;L;;;;;N;;;;;
1166;HANGUL JUNGSEONG E;Lo;0;L;;;;;N;;;;;
1167;HANGUL JUNGSEONG YEO;Lo;0;L;;;;;N;;;;;
1168;HANGUL JUNGSEONG YE;Lo;0;L;;;;;N;;;;;
1169;HANGUL JUNGSEONG O;Lo;0;L;;;;;N;;;;;
116A;HANGUL JUNGSEONG WA;Lo;0;L;;;;;N;;;;;
116B;HANGUL JUNGSEONG WAE;Lo;0;L;;;;;N;;;;;
116C;HANGUL JUNGSEONG OE;Lo;0;L;;;;;N;;;;;
116D;HANGUL JUNGSEONG YO;Lo;0;L;;;;;N;;;;;
116E;HANGUL JUNGSEONG U;Lo;0;L;;;;;N;;;;;
116F;HANGUL JUNGSEONG WEO;Lo;0;L;;;;;N;;;;;
1170;HANGUL JUNGSEONG WE;Lo;0;L;;;;;N;;;;;
1171;HANGUL JUNGSEONG WI;Lo;0;L;;;;;N;;;;;
1172;HANGUL JUNGSEONG YU;Lo;0;L;;;;;N;;;;;
1173;HANGUL JUNGSEONG EU;Lo;0;L;;;;;N;;;;;
1174;HANGUL JUNGSEONG YI;Lo;0;L;;;;;N;;;;;
1175;HANGUL JUNGSEONG I;Lo;0;L;;;;;N;;;;;
1176;HANGUL JUNGSEONG A-O;Lo;0;L;;;;;N;;;;;
1177;HANGUL JUNGSEONG A-U;Lo;0;L;;;;;N;;;;;
1178;HANGUL JUNGSEONG YA-O;Lo;0;L;;;;;N;;;;;
1179;HANGUL JUNGSEONG YA-YO;Lo;0;L;;;;;N;;;;;
117A;HANGUL JUNGSEONG EO-O;Lo;0;L;;;;;N;;;;;
117B;HANGUL JUNGSEONG EO-U;Lo;0;L;;;;;N;;;;;
117C;HANGUL JUNGSEONG EO-EU;Lo;0;L;;;;;N;;;;;
117D;HANGUL JUNGSEONG YEO-O;Lo;0;L;;;;;N;;;;;
117E;HANGUL JUNGSEONG YEO-U;Lo;0;L;;;;;N;;;;;
117F;HANGUL JUNGSEONG O-EO;Lo;0;L;;;;;N;;;;;
1180;HANGUL JUNGSEONG O-E;Lo;0;L;;;;;N;;;;;
1181;HANGUL JUNGSEONG O-YE;Lo;0;L;;;;;N;;;;;
1182;HANGUL JUNGSEONG O-O;Lo;0;L;;;;;N;;;;;
1183;HANGUL JUNGSEONG O-U;Lo;0;L;;;;;N;;;;;
1184;HANGUL JUNGSEONG YO-YA;Lo;0;L;;;;;N;;;;;
1185;HANGUL JUNGSEONG YO-YAE;Lo;0;L;;;;;N;;;;;
1186;HANGUL JUNGSEONG YO-YEO;Lo;0;L;;;;;N;;;;;
1187;HANGUL JUNGSEONG YO-O;Lo;0;L;;;;;N;;;;;
1188;HANGUL JUNGSEONG YO-I;Lo;0;L;;;;;N;;;;;
1189;HANGUL JUNGSEONG U-A;Lo;0;L;;;;;N;;;;;
118A;HANGUL JUNGSEONG U-AE;Lo;0;L;;;;;N;;;;;
118B;HANGUL JUNGSEONG U-EO-EU;Lo;0;L;;;;;N;;;;;
118C;HANGUL JUNGSEONG U-YE;Lo;0;L;;;;;N;;;;;
118D;HANGUL JUNGSEONG U-U;Lo;0;L;;;;;N;;;;;
118E;HANGUL JUNGSEONG YU-A;Lo;0;L;;;;;N;;;;;
118F;HANGUL JUNGSEONG YU-EO;Lo;0;L;;;;;N;;;;;
1190;HANGUL JUNGSEONG YU-E;Lo;0;L;;;;;N;;;;;
1191;HANGUL JUNGSEONG YU-YEO;Lo;0;L;;;;;N;;;;;
1192;HANGUL JUNGSEONG YU-YE;Lo;0;L;;;;;N;;;;;
1193;HANGUL JUNGSEONG YU-U;Lo;0;L;;;;;N;;;;;
1194;HANGUL JUNGSEONG YU-I;Lo;0;L;;;;;N;;;;;
1195;HANGUL JUNGSEONG EU-U;Lo;0;L;;;;;N;;;;;
1196;HANGUL JUNGSEONG EU-EU;Lo;0;L;;;;;N;;;;;
1197;HANGUL JUNGSEONG YI-U;Lo;0;L;;;;;N;;;;;
1198;HANGUL JUNGSEONG I-A;Lo;0;L;;;;;N;;;;;
1199;HANGUL JUNGSEONG I-YA;Lo;0;L;;;;;N;;;;;
119A;HANGUL JUNGSEONG I-O;Lo;0;L;;;;;N;;;;;
119B;HANGUL JUNGSEONG I-U;Lo;0;L;;;;;N;;;;;
119C;HANGUL JUNGSEONG I-EU;Lo;0;L;;;;;N;;;;;
119D;HANGUL JUNGSEONG I-ARAEA;Lo;0;L;;;;;N;;;;;
119E;HANGUL JUNGSEONG ARAEA;Lo;0;L;;;;;N;;;;;
119F;HANGUL JUNGSEONG ARAEA-EO;Lo;0;L;;;;;N;;;;;
11A0;HANGUL JUNGSEONG ARAEA-U;Lo;0;L;;;;;N;;;;;
11A1;HANGUL JUNGSEONG ARAEA-I;Lo;0;L;;;;;N;;;;;
11A2;HANGUL JUNGSEONG SSANGARAEA;Lo;0;L;;;;;N;;;;;
11A3;HANGUL JUNGSEONG A-EU;Lo;0;L;;;;;N;;;;;
11A4;HANGUL JUNGSEONG YA-U;Lo;0;L;;;;;N;;;;;
11A5;HANGUL JUNGSEONG YEO-YA;Lo;0;L;;;;;N;;;;;
11A6;HANGUL JUNGSEONG O-YA;Lo;0;L;;;;;N;;;;;
11A7;HANGUL JUNGSEONG O-YAE;Lo;0;L;;;;;N;;;;;
11A8;HANGUL JONGSEONG KIYEOK;Lo;0;L;;;;;N;;;;;
11A9;HANGUL JONGSEONG SSANGKIYEOK;Lo;0;L;;;;;N;;;;;
11AA;HANGUL JONGSEONG KIYEOK-SIOS;Lo;0;L;;;;;N;;;;;
11AB;HANGUL JONGSEONG NIEUN;Lo;0;L;;;;;N;;;;;
11AC;HANGUL JONGSEONG NIEUN-CIEUC;Lo;0;L;;;;;N;;;;;
11AD;HANGUL JONGSEONG NIEUN-HIEUH;Lo;0;L;;;;;N;;;;;
11AE;HANGUL JONGSEONG TIKEUT;Lo;0;L;;;;;N;;;;;
11AF;HANGUL JONGSEONG RIEUL;Lo;0;L;;;;;N;;;;;
11B0;HANGUL JONGSEONG RIEUL-KIYEOK;Lo;0;L;;;;;N;;;;;
11B1;HANGUL JONGSEONG RIEUL-MIEUM;Lo;0;L;;;;;N;;;;;
11B2;HANGUL JONGSEONG RIEUL-PIEUP;Lo;0;L;;;;;N;;;;;
11B3;HANGUL JONGSEONG RIEUL-SIOS;Lo;0;L;;;;;N;;;;;
11B4;HANGUL JONGSEONG RIEUL-THIEUTH;Lo;0;L;;;;;N;;;;;
11B5;HANGUL JONGSEONG RIEUL-PHIEUPH;Lo;0;L;;;;;N;;;;;
11B6;HANGUL JONGSEONG RIEUL-HIEUH;Lo;0;L;;;;;N;;;;;
11B7;HANGUL JONGSEONG MIEUM;Lo;0;L;;;;;N;;;;;
11B8;HANGUL JONGSEONG PIEUP;Lo;0;L;;;;;N;;;;;
11B9;HANGUL JONGSEONG PIEUP-SIOS;Lo;0;L;;;;;N;;;;;
11BA;HANGUL JONGSEONG SIOS;Lo;0;L;;;;;N;;;;;
11BB;HANGUL JONGSEONG SSANGSIOS;Lo;0;L;;;;;N;;;;;
11BC;HANGUL JONGSEONG IEUNG;Lo;0;L;;;;;N;;;;;
11BD;HANGUL JONGSEONG CIEUC;Lo;0;L;;;;;N;;;;;
11BE;HANGUL JONGSEONG CHIEUCH;Lo;0;L;;;;;N;;;;;
11BF;HANGUL JONGSEONG KHIEUKH;Lo;0;L;;;;;N;;;;;
11C0;HANGUL JONGSEONG THIEUTH;Lo;0;L;;;;;N;;;;;
11C1;HANGUL JONGSEONG PHIEUPH;Lo;0;L;;;;;N;;;;;
11C2;HANGUL JONGSEONG HIEUH;Lo;0;L;;;;;N;;;;;
11C3;HANGUL JONGSEONG KIYEOK-RIEUL;Lo;0;L;;;;;N;;;;;
11C4;HANGUL JONGSEONG KIYEOK-SIOS-KIYEOK;Lo;0;L;;;;;N;;;;;
11C5;HANGUL JONGSEONG NIEUN-KIYEOK;Lo;0;L;;;;;N;;;;;
11C6;HANGUL JONGSEONG NIEUN-TIKEUT;Lo;0;L;;;;;N;;;;;
11C7;HANGUL JONGSEONG NIEUN-SIOS;Lo;0;L;;;;;N;;;;;
11C8;HANGUL JONGSEONG NIEUN-PANSIOS;Lo;0;L;;;;;N;;;;;
11C9;HANGUL JONGSEONG NIEUN-THIEUTH;Lo;0;L;;;;;N;;;;;
11CA;HANGUL JONGSEONG TIKEUT-KIYEOK;Lo;0;L;;;;;N;;;;;
11CB;HANGUL JONGSEONG TIKEUT-RIEUL;Lo;0;L;;;;;N;;;;;
11CC;HANGUL JONGSEONG RIEUL-KIYEOK-SIOS;Lo;0;L;;;;;N;;;;;
11CD;HANGUL JONGSEONG RIEUL-NIEUN;Lo;0;L;;;;;N;;;;;
11CE;HANGUL JONGSEONG RIEUL-TIKEUT;Lo;0;L;;;;;N;;;;;
11CF;HANGUL JONGSEONG RIEUL-TIKEUT-HIEUH;Lo;0;L;;;;;N;;;;;
11D0;HANGUL JONGSEONG SSANGRIEUL;Lo;0;L;;;;;N;;;;;
11D1;HANGUL JONGSEONG RIEUL-MIEUM-KIYEOK;Lo;0;L;;;;;N;;;;;
11D2;HANGUL JONGSEONG RIEUL-MIEUM-SIOS;Lo;0;L;;;;;N;;;;;
11D3;HANGUL JONGSEONG RIEUL-PIEUP-SIOS;Lo;0;L;;;;;N;;;;;
11D4;HANGUL JONGSEONG RIEUL-PIEUP-HIEUH;Lo;0;L;;;;;N;;;;;
11D5;HANGUL JONGSEONG RIEUL-KAPYEOUNPIEUP;Lo;0;L;;;;;N;;;;;
11D6;HANGUL JONGSEONG RIEUL-SSANGSIOS;Lo;0;L;;;;;N;;;;;
11D7;HANGUL JONGSEONG RIEUL-PANSIOS;Lo;0;L;;;;;N;;;;;
11D8;HANGUL JONGSEONG RIEUL-KHIEUKH;Lo;0;L;;;;;N;;;;;
11D9;HANGUL JONGSEONG RIEUL-YEORINHIEUH;Lo;0;L;;;;;N;;;;;
11DA;HANGUL JONGSEONG MIEUM-KIYEOK;Lo;0;L;;;;;N;;;;;
11DB;HANGUL JONGSEONG MIEUM-RIEUL;Lo;0;L;;;;;N;;;;;
11DC;HANGUL JONGSEONG MIEUM-PIEUP;Lo;0;L;;;;;N;;;;;
11DD;HANGUL JONGSEONG MIEUM-SIOS;Lo;0;L;;;;;N;;;;;
11DE;HANGUL JONGSEONG MIEUM-SSANGSIOS;Lo;0;L;;;;;N;;;;;
11DF;HANGUL JONGSEONG MIEUM-PANSIOS;Lo;0;L;;;;;N;;;;;
11E0;HANGUL JONGSEONG MIEUM-CHIEUCH;Lo;0;L;;;;;N;;;;;
11E1;HANGUL JONGSEONG MIEUM-HIEUH;Lo;0;L;;;;;N;;;;;
11E2;HANGUL JONGSEONG KAPYEOUNMIEUM;Lo;0;L;;;;;N;;;;;
11E3;HANGUL JONGSEONG PIEUP-RIEUL;Lo;0;L;;;;;N;;;;;
11E4;HANGUL JONGSEONG PIEUP-PHIEUPH;Lo;0;L;;;;;N;;;;;
11E5;HANGUL JONGSEONG PIEUP-HIEUH;Lo;0;L;;;;;N;;;;;
11E6;HANGUL JONGSEONG KAPYEOUNPIEUP;Lo;0;L;;;;;N;;;;;
11E7;HANGUL JONGSEONG SIOS-KIYEOK;Lo;0;L;;;;;N;;;;;
11E8;HANGUL JONGSEONG SIOS-TIKEUT;Lo;0;L;;;;;N;;;;;
11E9;HANGUL JONGSEONG SIOS-RIEUL;Lo;0;L;;;;;N;;;;;
11EA;HANGUL JONGSEONG SIOS-PIEUP;Lo;0;L;;;;;N;;;;;
11EB;HANGUL JONGSEONG PANSIOS;Lo;0;L;;;;;N;;;;;
11EC;HANGUL JONGSEONG IEUNG-KIYEOK;Lo;0;L;;;;;N;;;;;
11ED;HANGUL JONGSEONG IEUNG-SSANGKIYEOK;Lo;0;L;;;;;N;;;;;
11EE;HANGUL JONGSEONG SSANGIEUNG;Lo;0;L;;;;;N;;;;;
11EF;HANGUL JONGSEONG IEUNG-KHIEUKH;Lo;0;L;;;;;N;;;;;
11F0;HANGUL JONGSEONG YESIEUNG;Lo;0;L;;;;;N;;;;;
11F1;HANGUL JONGSEONG YESIEUNG-SIOS;Lo;0;L;;;;;N;;;;;
11F2;HANGUL JONGSEONG YESIEUNG-PANSIOS;Lo;0;L;;;;;N;;;;;
11F3;HANGUL JONGSEONG PHIEUPH-PIEUP;Lo;0;L;;;;;N;;;;;
11F4;HANGUL JONGSEONG KAPYEOUNPHIEUPH;Lo;0;L;;;;;N;;;;;
11F5;HANGUL JONGSEONG HIEUH-NIEUN;Lo;0;L;;;;;N;;;;;
11F6;HANGUL JONGSEONG HIEUH-RIEUL;Lo;0;L;;;;;N;;;;;
11F7;HANGUL JONGSEONG HIEUH-MIEUM;Lo;0;L;;;;;N;;;;;
11F8;HANGUL JONGSEONG HIEUH-PIEUP;Lo;0;L;;;;;N;;;;;
11F9;HANGUL JONGSEONG YEORINHIEUH;Lo;0;L;;;;;N;;;;;
11FA;HANGUL JONGSEONG KIYEOK-NIEUN;Lo;0;L;;;;;N;;;;;
11FB;HANGUL JONGSEONG KIYEOK-PIEUP;Lo;0;L;;;;;N;;;;;
11FC;HANGUL JONGSEONG KIYEOK-CHIEUCH;Lo;0;L;;;;;N;;;;;
11FD;HANGUL JONGSEONG KIYEOK-KHIEUKH;Lo;0;L;;;;;N;;;;;
11FE;HANGUL JONGSEONG KIYEOK-HIEUH;Lo;0;L;;;;;N;;;;;
11FF;HANGUL JONGSEONG SSANGNIEUN;Lo;0;L;;;;;N;;;;;
1200;ETHIOPIC SYLLABLE HA;Lo;0;L;;;;;N;;;;;
1201;ETHIOPIC SYLLABLE HU;Lo;0;L;;;;;N;;;;;
1202;ETHIOPIC SYLLABLE HI;Lo;0;L;;;;;N;;;;;
1203;ETHIOPIC SYLLABLE HAA;Lo;0;L;;;;;N;;;;;
1204;ETHIOPIC SYLLABLE HEE;Lo;0;L;;;;;N;;;;;
1205;ETHIOPIC SYLLABLE HE;Lo;0;L;;;;;N;;;;;
1206;ETHIOPIC SYLLABLE HO;Lo;0;L;;;;;N;;;;;
1207;ETHIOPIC SYLLABLE HOA;Lo;0;L;;;;;N;;;;;
1208;ETHIOPIC SYLLABLE LA;Lo;0;L;;;;;N;;;;;
1209;ETHIOPIC SYLLABLE LU;Lo;0;L;;;;;N;;;;;
120A;ETHIOPIC SYLLABLE LI;Lo;0;L;;;;;N;;;;;
120B;ETHIOPIC SYLLABLE LAA;Lo;0;L;;;;;N;;;;;
120C;ETHIOPIC SYLLABLE LEE;Lo;0;L;;;;;N;;;;;
120D;ETHIOPIC SYLLABLE LE;Lo;0;L;;;;;N;;;;;
120E;ETHIOPIC SYLLABLE LO;Lo;0;L;;;;;N;;;;;
120F;ETHIOPIC SYLLABLE LWA;Lo;0;L;;;;;N;;;;;
1210;ETHIOPIC SYLLABLE HHA;Lo;0;L;;;;;N;;;;;
1211;ETHIOPIC SYLLABLE HHU;Lo;0;L;;;;;N;;;;;
1212;ETHIOPIC SYLLABLE HHI;Lo;0;L;;;;;N;;;;;
1213;ETHIOPIC SYLLABLE HHAA;Lo;0;L;;;;;N;;;;;
1214;ETHIOPIC SYLLABLE HHEE;Lo;0;L;;;;;N;;;;;
1215;ETHIOPIC SYLLABLE HHE;Lo;0;L;;;;;N;;;;;
1216;ETHIOPIC SYLLABLE HHO;Lo;0;L;;;;;N;;;;;
1217;ETHIOPIC SYLLABLE HHWA;Lo;0;L;;;;;N;;;;;
1218;ETHIOPIC SYLLABLE MA;Lo;0;L;;;;;N;;;;;
1219;ETHIOPIC SYLLABLE MU;Lo;0;L;;;;;N;;;;;
121A;ETHIOPIC SYLLABLE MI;Lo;0;L;;;;;N;;;;;
121B;ETHIOPIC SYLLABLE MAA;Lo;0;L;;;;;N;;;;;
121C;ETHIOPIC SYLLABLE MEE;Lo;0;L;;;;;N;;;;;
121D;ETHIOPIC SYLLABLE ME;Lo;0;L;;;;;N;;;;;
121E;ETHIOPIC SYLLABLE MO;Lo;0;L;;;;;N;;;;;
121F;ETHIOPIC SYLLABLE MWA;Lo;0;L;;;;;N;;;;;
1220;ETHIOPIC SYLLABLE SZA;Lo;0;L;;;;;N;;;;;
1221;ETHIOPIC SYLLABLE SZU;Lo;0;L;;;;;N;;;;;
1222;ETHIOPIC SYLLABLE SZI;Lo;0;L;;;;;N;;;;;
1223;ETHIOPIC SYLLABLE SZAA;Lo;0;L;;;;;N;;;;;
1224;ETHIOPIC SYLLABLE SZEE;Lo;0;L;;;;;N;;;;;
1225;ETHIOPIC SYLLABLE SZE;Lo;0;L;;;;;N;;;;;
1226;ETHIOPIC SYLLABLE SZO;Lo;0;L;;;;;N;;;;;
1227;ETHIOPIC SYLLABLE SZWA;Lo;0;L;;;;;N;;;;;
1228;ETHIOPIC SYLLABLE RA;Lo;0;L;;;;;N;;;;;
1229;ETHIOPIC SYLLABLE RU;Lo;0;L;;;;;N;;;;;
122A;ETHIOPIC SYLLABLE RI;Lo;0;L;;;;;N;;;;;
122B;ETHIOPIC SYLLABLE RAA;Lo;0;L;;;;;N;;;;;
122C;ETHIOPIC SYLLABLE REE;Lo;0;L;;;;;N;;;;;
122D;ETHIOPIC SYLLABLE RE;Lo;0;L;;;;;N;;;;;
122E;ETHIOPIC SYLLABLE RO;Lo;0;L;;;;;N;;;;;
122F;ETHIOPIC SYLLABLE RWA;Lo;0;L;;;;;N;;;;;
1230;ETHIOPIC SYLLABLE SA;Lo;0;L;;;;;N;;;;;
1231;ETHIOPIC SYLLABLE SU;Lo;0;L;;;;;N;;;;;
1232;ETHIOPIC SYLLABLE SI;Lo;0;L;;;;;N;;;;;
1233;ETHIOPIC SYLLABLE SAA;Lo;0;L;;;;;N;;;;;
1234;ETHIOPIC SYLLABLE SEE;Lo;0;L;;;;;N;;;;;
1235;ETHIOPIC SYLLABLE SE;Lo;0;L;;;;;N;;;;;
1236;ETHIOPIC SYLLABLE SO;Lo;0;L;;;;;N;;;;;
1237;ETHIOPIC SYLLABLE SWA;Lo;0;L;;;;;N;;;;;
1238;ETHIOPIC SYLLABLE SHA;Lo;0;L;;;;;N;;;;;
1239;ETHIOPIC SYLLABLE SHU;Lo;0;L;;;;;N;;;;;
123A;ETHIOPIC SYLLABLE SHI;Lo;0;L;;;;;N;;;;;
123B;ETHIOPIC SYLLABLE SHAA;Lo;0;L;;;;;N;;;;;
123C;ETHIOPIC SYLLABLE SHEE;Lo;0;L;;;;;N;;;;;
123D;ETHIOPIC SYLLABLE SHE;Lo;0;L;;;;;N;;;;;
123E;ETHIOPIC SYLLABLE SHO;Lo;0;L;;;;;N;;;;;
123F;ETHIOPIC SYLLABLE SHWA;Lo;0;L;;;;;N;;;;;
1240;ETHIOPIC SYLLABLE QA;Lo;0;L;;;;;N;;;;;
1241;ETHIOPIC SYLLABLE QU;Lo;0;L;;;;;N;;;;;
1242;ETHIOPIC SYLLABLE QI;Lo;0;L;;;;;N;;;;;
1243;ETHIOPIC SYLLABLE QAA;Lo;0;L;;;;;N;;;;;
1244;ETHIOPIC SYLLABLE QEE;Lo;0;L;;;;;N;;;;;
1245;ETHIOPIC SYLLABLE QE;Lo;0;L;;;;;N;;;;;
1246;ETHIOPIC SYLLABLE QO;Lo;0;L;;;;;N;;;;;
1247;ETHIOPIC SYLLABLE QOA;Lo;0;L;;;;;N;;;;;
1248;ETHIOPIC SYLLABLE QWA;Lo;0;L;;;;;N;;;;;
124A;ETHIOPIC SYLLABLE QWI;Lo;0;L;;;;;N;;;;;
124B;ETHIOPIC SYLLABLE QWAA;Lo;0;L;;;;;N;;;;;
124C;ETHIOPIC SYLLABLE QWEE;Lo;0;L;;;;;N;;;;;
124D;ETHIOPIC SYLLABLE QWE;Lo;0;L;;;;;N;;;;;
1250;ETHIOPIC SYLLABLE QHA;Lo;0;L;;;;;N;;;;;
1251;ETHIOPIC SYLLABLE QHU;Lo;0;L;;;;;N;;;;;
1252;ETHIOPIC SYLLABLE QHI;Lo;0;L;;;;;N;;;;;
1253;ETHIOPIC SYLLABLE QHAA;Lo;0;L;;;;;N;;;;;
1254;ETHIOPIC SYLLABLE QHEE;Lo;0;L;;;;;N;;;;;
1255;ETHIOPIC SYLLABLE QHE;Lo;0;L;;;;;N;;;;;
1256;ETHIOPIC SYLLABLE QHO;Lo;0;L;;;;;N;;;;;
1258;ETHIOPIC SYLLABLE QHWA;Lo;0;L;;;;;N;;;;;
125A;ETHIOPIC SYLLABLE QHWI;Lo;0;L;;;;;N;;;;;
125B;ETHIOPIC SYLLABLE QHWAA;Lo;0;L;;;;;N;;;;;
125C;ETHIOPIC SYLLABLE QHWEE;Lo;0;L;;;;;N;;;;;
125D;ETHIOPIC SYLLABLE QHWE;Lo;0;L;;;;;N;;;;;
1260;ETHIOPIC SYLLABLE BA;Lo;0;L;;;;;N;;;;;
1261;ETHIOPIC SYLLABLE BU;Lo;0;L;;;;;N;;;;;
1262;ETHIOPIC SYLLABLE BI;Lo;0;L;;;;;N;;;;;
1263;ETHIOPIC SYLLABLE BAA;Lo;0;L;;;;;N;;;;;
1264;ETHIOPIC SYLLABLE BEE;Lo;0;L;;;;;N;;;;;
1265;ETHIOPIC SYLLABLE BE;Lo;0;L;;;;;N;;;;;
1266;ETHIOPIC SYLLABLE BO;Lo;0;L;;;;;N;;;;;
1267;ETHIOPIC SYLLABLE BWA;Lo;0;L;;;;;N;;;;;
1268;ETHIOPIC SYLLABLE VA;Lo;0;L;;;;;N;;;;;
1269;ETHIOPIC SYLLABLE VU;Lo;0;L;;;;;N;;;;;
126A;ETHIOPIC SYLLABLE VI;Lo;0;L;;;;;N;;;;;
126B;ETHIOPIC SYLLABLE VAA;Lo;0;L;;;;;N;;;;;
126C;ETHIOPIC SYLLABLE VEE;Lo;0;L;;;;;N;;;;;
126D;ETHIOPIC SYLLABLE VE;Lo;0;L;;;;;N;;;;;
126E;ETHIOPIC SYLLABLE VO;Lo;0;L;;;;;N;;;;;
126F;ETHIOPIC SYLLABLE VWA;Lo;0;L;;;;;N;;;;;
1270;ETHIOPIC SYLLABLE TA;Lo;0;L;;;;;N;;;;;
1271;ETHIOPIC SYLLABLE TU;Lo;0;L;;;;;N;;;;;
1272;ETHIOPIC SYLLABLE TI;Lo;0;L;;;;;N;;;;;
1273;ETHIOPIC SYLLABLE TAA;Lo;0;L;;;;;N;;;;;
1274;ETHIOPIC SYLLABLE TEE;Lo;0;L;;;;;N;;;;;
1275;ETHIOPIC SYLLABLE TE;Lo;0;L;;;;;N;;;;;
1276;ETHIOPIC SYLLABLE TO;Lo;0;L;;;;;N;;;;;
1277;ETHIOPIC SYLLABLE TWA;Lo;0;L;;;;;N;;;;;
1278;ETHIOPIC SYLLABLE CA;Lo;0;L;;;;;N;;;;;
1279;ETHIOPIC SYLLABLE CU;Lo;0;L;;;;;N;;;;;
127A;ETHIOPIC SYLLABLE CI;Lo;0;L;;;;;N;;;;;
127B;ETHIOPIC SYLLABLE CAA;Lo;0;L;;;;;N;;;;;
127C;ETHIOPIC SYLLABLE CEE;Lo;0;L;;;;;N;;;;;
127D;ETHIOPIC SYLLABLE CE;Lo;0;L;;;;;N;;;;;
127E;ETHIOPIC SYLLABLE CO;Lo;0;L;;;;;N;;;;;
127F;ETHIOPIC SYLLABLE CWA;Lo;0;L;;;;;N;;;;;
1280;ETHIOPIC SYLLABLE XA;Lo;0;L;;;;;N;;;;;
1281;ETHIOPIC SYLLABLE XU;Lo;0;L;;;;;N;;;;;
1282;ETHIOPIC SYLLABLE XI;Lo;0;L;;;;;N;;;;;
1283;ETHIOPIC SYLLABLE XAA;Lo;0;L;;;;;N;;;;;
1284;ETHIOPIC SYLLABLE XEE;Lo;0;L;;;;;N;;;;;
1285;ETHIOPIC SYLLABLE XE;Lo;0;L;;;;;N;;;;;
1286;ETHIOPIC SYLLABLE XO;Lo;0;L;;;;;N;;;;;
1287;ETHIOPIC SYLLABLE XOA;Lo;0;L;;;;;N;;;;;
1288;ETHIOPIC SYLLABLE XWA;Lo;0;L;;;;;N;;;;;
128A;ETHIOPIC SYLLABLE XWI;Lo;0;L;;;;;N;;;;;
128B;ETHIOPIC SYLLABLE XWAA;Lo;0;L;;;;;N;;;;;
128C;ETHIOPIC SYLLABLE XWEE;Lo;0;L;;;;;N;;;;;
128D;ETHIOPIC SYLLABLE XWE;Lo;0;L;;;;;N;;;;;
1290;ETHIOPIC SYLLABLE NA;Lo;0;L;;;;;N;;;;;
1291;ETHIOPIC SYLLABLE NU;Lo;0;L;;;;;N;;;;;
1292;ETHIOPIC SYLLABLE NI;Lo;0;L;;;;;N;;;;;
1293;ETHIOPIC SYLLABLE NAA;Lo;0;L;;;;;N;;;;;
1294;ETHIOPIC SYLLABLE NEE;Lo;0;L;;;;;N;;;;;
1295;ETHIOPIC SYLLABLE NE;Lo;0;L;;;;;N;;;;;
1296;ETHIOPIC SYLLABLE NO;Lo;0;L;;;;;N;;;;;
1297;ETHIOPIC SYLLABLE NWA;Lo;0;L;;;;;N;;;;;
1298;ETHIOPIC SYLLABLE NYA;Lo;0;L;;;;;N;;;;;
1299;ETHIOPIC SYLLABLE NYU;Lo;0;L;;;;;N;;;;;
129A;ETHIOPIC SYLLABLE NYI;Lo;0;L;;;;;N;;;;;
129B;ETHIOPIC SYLLABLE NYAA;Lo;0;L;;;;;N;;;;;
129C;ETHIOPIC SYLLABLE NYEE;Lo;0;L;;;;;N;;;;;
129D;ETHIOPIC SYLLABLE NYE;Lo;0;L;;;;;N;;;;;
129E;ETHIOPIC SYLLABLE NYO;Lo;0;L;;;;;N;;;;;
129F;ETHIOPIC SYLLABLE NYWA;Lo;0;L;;;;;N;;;;;
12A0;ETHIOPIC SYLLABLE GLOTTAL A;Lo;0;L;;;;;N;;;;;
12A1;ETHIOPIC SYLLABLE GLOTTAL U;Lo;0;L;;;;;N;;;;;
12A2;ETHIOPIC SYLLABLE GLOTTAL I;Lo;0;L;;;;;N;;;;;
12A3;ETHIOPIC SYLLABLE GLOTTAL AA;Lo;0;L;;;;;N;;;;;
12A4;ETHIOPIC SYLLABLE GLOTTAL EE;Lo;0;L;;;;;N;;;;;
12A5;ETHIOPIC SYLLABLE GLOTTAL E;Lo;0;L;;;;;N;;;;;
12A6;ETHIOPIC SYLLABLE GLOTTAL O;Lo;0;L;;;;;N;;;;;
12A7;ETHIOPIC SYLLABLE GLOTTAL WA;Lo;0;L;;;;;N;;;;;
12A8;ETHIOPIC SYLLABLE KA;Lo;0;L;;;;;N;;;;;
12A9;ETHIOPIC SYLLABLE KU;Lo;0;L;;;;;N;;;;;
12AA;ETHIOPIC SYLLABLE KI;Lo;0;L;;;;;N;;;;;
12AB;ETHIOPIC SYLLABLE KAA;Lo;0;L;;;;;N;;;;;
12AC;ETHIOPIC SYLLABLE KEE;Lo;0;L;;;;;N;;;;;
12AD;ETHIOPIC SYLLABLE KE;Lo;0;L;;;;;N;;;;;
12AE;ETHIOPIC SYLLABLE KO;Lo;0;L;;;;;N;;;;;
12AF;ETHIOPIC SYLLABLE KOA;Lo;0;L;;;;;N;;;;;
12B0;ETHIOPIC SYLLABLE KWA;Lo;0;L;;;;;N;;;;;
12B2;ETHIOPIC SYLLABLE KWI;Lo;0;L;;;;;N;;;;;
12B3;ETHIOPIC SYLLABLE KWAA;Lo;0;L;;;;;N;;;;;
12B4;ETHIOPIC SYLLABLE KWEE;Lo;0;L;;;;;N;;;;;
12B5;ETHIOPIC SYLLABLE KWE;Lo;0;L;;;;;N;;;;;
12B8;ETHIOPIC SYLLABLE KXA;Lo;0;L;;;;;N;;;;;
12B9;ETHIOPIC SYLLABLE KXU;Lo;0;L;;;;;N;;;;;
12BA;ETHIOPIC SYLLABLE KXI;Lo;0;L;;;;;N;;;;;
12BB;ETHIOPIC SYLLABLE KXAA;Lo;0;L;;;;;N;;;;;
12BC;ETHIOPIC SYLLABLE KXEE;Lo;0;L;;;;;N;;;;;
12BD;ETHIOPIC SYLLABLE KXE;Lo;0;L;;;;;N;;;;;
12BE;ETHIOPIC SYLLABLE KXO;Lo;0;L;;;;;N;;;;;
12C0;ETHIOPIC SYLLABLE KXWA;Lo;0;L;;;;;N;;;;;
12C2;ETHIOPIC SYLLABLE KXWI;Lo;0;L;;;;;N;;;;;
12C3;ETHIOPIC SYLLABLE KXWAA;Lo;0;L;;;;;N;;;;;
12C4;ETHIOPIC SYLLABLE KXWEE;Lo;0;L;;;;;N;;;;;
12C5;ETHIOPIC SYLLABLE KXWE;Lo;0;L;;;;;N;;;;;
12C8;ETHIOPIC SYLLABLE WA;Lo;0;L;;;;;N;;;;;
12C9;ETHIOPIC SYLLABLE WU;Lo;0;L;;;;;N;;;;;
12CA;ETHIOPIC SYLLABLE WI;Lo;0;L;;;;;N;;;;;
12CB;ETHIOPIC SYLLABLE WAA;Lo;0;L;;;;;N;;;;;
12CC;ETHIOPIC SYLLABLE WEE;Lo;0;L;;;;;N;;;;;
12CD;ETHIOPIC SYLLABLE WE;Lo;0;L;;;;;N;;;;;
12CE;ETHIOPIC SYLLABLE WO;Lo;0;L;;;;;N;;;;;
12CF;ETHIOPIC SYLLABLE WOA;Lo;0;L;;;;;N;;;;;
12D0;ETHIOPIC SYLLABLE PHARYNGEAL A;Lo;0;L;;;;;N;;;;;
12D1;ETHIOPIC SYLLABLE PHARYNGEAL U;Lo;0;L;;;;;N;;;;;
12D2;ETHIOPIC SYLLABLE PHARYNGEAL I;Lo;0;L;;;;;N;;;;;
12D3;ETHIOPIC SYLLABLE PHARYNGEAL AA;Lo;0;L;;;;;N;;;;;
12D4;ETHIOPIC SYLLABLE PHARYNGEAL EE;Lo;0;L;;;;;N;;;;;
12D5;ETHIOPIC SYLLABLE PHARYNGEAL E;Lo;0;L;;;;;N;;;;;
12D6;ETHIOPIC SYLLABLE PHARYNGEAL O;Lo;0;L;;;;;N;;;;;
12D8;ETHIOPIC SYLLABLE ZA;Lo;0;L;;;;;N;;;;;
12D9;ETHIOPIC SYLLABLE ZU;Lo;0;L;;;;;N;;;;;
12DA;ETHIOPIC SYLLABLE ZI;Lo;0;L;;;;;N;;;;;
12DB;ETHIOPIC SYLLABLE ZAA;Lo;0;L;;;;;N;;;;;
12DC;ETHIOPIC SYLLABLE ZEE;Lo;0;L;;;;;N;;;;;
12DD;ETHIOPIC SYLLABLE ZE;Lo;0;L;;;;;N;;;;;
12DE;ETHIOPIC SYLLABLE ZO;Lo;0;L;;;;;N;;;;;
12DF;ETHIOPIC SYLLABLE ZWA;Lo;0;L;;;;;N;;;;;
12E0;ETHIOPIC SYLLABLE ZHA;Lo;0;L;;;;;N;;;;;
12E1;ETHIOPIC SYLLABLE ZHU;Lo;0;L;;;;;N;;;;;
12E2;ETHIOPIC SYLLABLE ZHI;Lo;0;L;;;;;N;;;;;
12E3;ETHIOPIC SYLLABLE ZHAA;Lo;0;L;;;;;N;;;;;
12E4;ETHIOPIC SYLLABLE ZHEE;Lo;0;L;;;;;N;;;;;
12E5;ETHIOPIC SYLLABLE ZHE;Lo;0;L;;;;;N;;;;;
12E6;ETHIOPIC SYLLABLE ZHO;Lo;0;L;;;;;N;;;;;
12E7;ETHIOPIC SYLLABLE ZHWA;Lo;0;L;;;;;N;;;;;
12E8;ETHIOPIC SYLLABLE YA;Lo;0;L;;;;;N;;;;;
12E9;ETHIOPIC SYLLABLE YU;Lo;0;L;;;;;N;;;;;
12EA;ETHIOPIC SYLLABLE YI;Lo;0;L;;;;;N;;;;;
12EB;ETHIOPIC SYLLABLE YAA;Lo;0;L;;;;;N;;;;;
12EC;ETHIOPIC SYLLABLE YEE;Lo;0;L;;;;;N;;;;;
12ED;ETHIOPIC SYLLABLE YE;Lo;0;L;;;;;N;;;;;
12EE;ETHIOPIC SYLLABLE YO;Lo;0;L;;;;;N;;;;;
12EF;ETHIOPIC SYLLABLE YOA;Lo;0;L;;;;;N;;;;;
12F0;ETHIOPIC SYLLABLE DA;Lo;0;L;;;;;N;;;;;
12F1;ETHIOPIC SYLLABLE DU;Lo;0;L;;;;;N;;;;;
12F2;ETHIOPIC SYLLABLE DI;Lo;0;L;;;;;N;;;;;
12F3;ETHIOPIC SYLLABLE DAA;Lo;0;L;;;;;N;;;;;
12F4;ETHIOPIC SYLLABLE DEE;Lo;0;L;;;;;N;;;;;
12F5;ETHIOPIC SYLLABLE DE;Lo;0;L;;;;;N;;;;;
12F6;ETHIOPIC SYLLABLE DO;Lo;0;L;;;;;N;;;;;
12F7;ETHIOPIC SYLLABLE DWA;Lo;0;L;;;;;N;;;;;
12F8;ETHIOPIC SYLLABLE DDA;Lo;0;L;;;;;N;;;;;
12F9;ETHIOPIC SYLLABLE DDU;Lo;0;L;;;;;N;;;;;
12FA;ETHIOPIC SYLLABLE DDI;Lo;0;L;;;;;N;;;;;
12FB;ETHIOPIC SYLLABLE DDAA;Lo;0;L;;;;;N;;;;;
12FC;ETHIOPIC SYLLABLE DDEE;Lo;0;L;;;;;N;;;;;
12FD;ETHIOPIC SYLLABLE DDE;Lo;0;L;;;;;N;;;;;
12FE;ETHIOPIC SYLLABLE DDO;Lo;0;L;;;;;N;;;;;
12FF;ETHIOPIC SYLLABLE DDWA;Lo;0;L;;;;;N;;;;;
1300;ETHIOPIC SYLLABLE JA;Lo;0;L;;;;;N;;;;;
1301;ETHIOPIC SYLLABLE JU;Lo;0;L;;;;;N;;;;;
1302;ETHIOPIC SYLLABLE JI;Lo;0;L;;;;;N;;;;;
1303;ETHIOPIC SYLLABLE JAA;Lo;0;L;;;;;N;;;;;
1304;ETHIOPIC SYLLABLE JEE;Lo;0;L;;;;;N;;;;;
1305;ETHIOPIC SYLLABLE JE;Lo;0;L;;;;;N;;;;;
1306;ETHIOPIC SYLLABLE JO;Lo;0;L;;;;;N;;;;;
1307;ETHIOPIC SYLLABLE JWA;Lo;0;L;;;;;N;;;;;
1308;ETHIOPIC SYLLABLE GA;Lo;0;L;;;;;N;;;;;
1309;ETHIOPIC SYLLABLE GU;Lo;0;L;;;;;N;;;;;
130A;ETHIOPIC SYLLABLE GI;Lo;0;L;;;;;N;;;;;
130B;ETHIOPIC SYLLABLE GAA;Lo;0;L;;;;;N;;;;;
130C;ETHIOPIC SYLLABLE GEE;Lo;0;L;;;;;N;;;;;
130D;ETHIOPIC SYLLABLE GE;Lo;0;L;;;;;N;;;;;
130E;ETHIOPIC SYLLABLE GO;Lo;0;L;;;;;N;;;;;
130F;ETHIOPIC SYLLABLE GOA;Lo;0;L;;;;;N;;;;;
1310;ETHIOPIC SYLLABLE GWA;Lo;0;L;;;;;N;;;;;
1312;ETHIOPIC SYLLABLE GWI;Lo;0;L;;;;;N;;;;;
1313;ETHIOPIC SYLLABLE GWAA;Lo;0;L;;;;;N;;;;;
1314;ETHIOPIC SYLLABLE GWEE;Lo;0;L;;;;;N;;;;;
1315;ETHIOPIC SYLLABLE GWE;Lo;0;L;;;;;N;;;;;
1318;ETHIOPIC SYLLABLE GGA;Lo;0;L;;;;;N;;;;;
1319;ETHIOPIC SYLLABLE GGU;Lo;0;L;;;;;N;;;;;
131A;ETHIOPIC SYLLABLE GGI;Lo;0;L;;;;;N;;;;;
131B;ETHIOPIC SYLLABLE GGAA;Lo;0;L;;;;;N;;;;;
131C;ETHIOPIC SYLLABLE GGEE;Lo;0;L;;;;;N;;;;;
131D;ETHIOPIC SYLLABLE GGE;Lo;0;L;;;;;N;;;;;
131E;ETHIOPIC SYLLABLE GGO;Lo;0;L;;;;;N;;;;;
131F;ETHIOPIC SYLLABLE GGWAA;Lo;0;L;;;;;N;;;;;
1320;ETHIOPIC SYLLABLE THA;Lo;0;L;;;;;N;;;;;
1321;ETHIOPIC SYLLABLE THU;Lo;0;L;;;;;N;;;;;
1322;ETHIOPIC SYLLABLE THI;Lo;0;L;;;;;N;;;;;
1323;ETHIOPIC SYLLABLE THAA;Lo;0;L;;;;;N;;;;;
1324;ETHIOPIC SYLLABLE THEE;Lo;0;L;;;;;N;;;;;
1325;ETHIOPIC SYLLABLE THE;Lo;0;L;;;;;N;;;;;
1326;ETHIOPIC SYLLABLE THO;Lo;0;L;;;;;N;;;;;
1327;ETHIOPIC SYLLABLE THWA;Lo;0;L;;;;;N;;;;;
1328;ETHIOPIC SYLLABLE CHA;Lo;0;L;;;;;N;;;;;
1329;ETHIOPIC SYLLABLE CHU;Lo;0;L;;;;;N;;;;;
132A;ETHIOPIC SYLLABLE CHI;Lo;0;L;;;;;N;;;;;
132B;ETHIOPIC SYLLABLE CHAA;Lo;0;L;;;;;N;;;;;
132C;ETHIOPIC SYLLABLE CHEE;Lo;0;L;;;;;N;;;;;
132D;ETHIOPIC SYLLABLE CHE;Lo;0;L;;;;;N;;;;;
132E;ETHIOPIC SYLLABLE CHO;Lo;0;L;;;;;N;;;;;
132F;ETHIOPIC SYLLABLE CHWA;Lo;0;L;;;;;N;;;;;
1330;ETHIOPIC SYLLABLE PHA;Lo;0;L;;;;;N;;;;;
1331;ETHIOPIC SYLLABLE PHU;Lo;0;L;;;;;N;;;;;
1332;ETHIOPIC SYLLABLE PHI;Lo;0;L;;;;;N;;;;;
1333;ETHIOPIC SYLLABLE PHAA;Lo;0;L;;;;;N;;;;;
1334;ETHIOPIC SYLLABLE PHEE;Lo;0;L;;;;;N;;;;;
1335;ETHIOPIC SYLLABLE PHE;Lo;0;L;;;;;N;;;;;
1336;ETHIOPIC SYLLABLE PHO;Lo;0;L;;;;;N;;;;;
1337;ETHIOPIC SYLLABLE PHWA;Lo;0;L;;;;;N;;;;;
1338;ETHIOPIC SYLLABLE TSA;Lo;0;L;;;;;N;;;;;
1339;ETHIOPIC SYLLABLE TSU;Lo;0;L;;;;;N;;;;;
133A;ETHIOPIC SYLLABLE TSI;Lo;0;L;;;;;N;;;;;
133B;ETHIOPIC SYLLABLE TSAA;Lo;0;L;;;;;N;;;;;
133C;ETHIOPIC SYLLABLE TSEE;Lo;0;L;;;;;N;;;;;
133D;ETHIOPIC SYLLABLE TSE;Lo;0;L;;;;;N;;;;;
133E;ETHIOPIC SYLLABLE TSO;Lo;0;L;;;;;N;;;;;
133F;ETHIOPIC SYLLABLE TSWA;Lo;0;L;;;;;N;;;;;
1340;ETHIOPIC SYLLABLE TZA;Lo;0;L;;;;;N;;;;;
1341;ETHIOPIC SYLLABLE TZU;Lo;0;L;;;;;N;;;;;
1342;ETHIOPIC SYLLABLE TZI;Lo;0;L;;;;;N;;;;;
1343;ETHIOPIC SYLLABLE TZAA;Lo;0;L;;;;;N;;;;;
1344;ETHIOPIC SYLLABLE TZEE;Lo;0;L;;;;;N;;;;;
1345;ETHIOPIC SYLLABLE TZE;Lo;0;L;;;;;N;;;;;
1346;ETHIOPIC SYLLABLE TZO;Lo;0;L;;;;;N;;;;;
1347;ETHIOPIC SYLLABLE TZOA;Lo;0;L;;;;;N;;;;;
1348;ETHIOPIC SYLLABLE FA;Lo;0;L;;;;;N;;;;;
1349;ETHIOPIC SYLLABLE FU;Lo;0;L;;;;;N;;;;;
134A;ETHIOPIC SYLLABLE FI;Lo;0;L;;;;;N;;;;;
134B;ETHIOPIC SYLLABLE FAA;Lo;0;L;;;;;N;;;;;
134C;ETHIOPIC SYLLABLE FEE;Lo;0;L;;;;;N;;;;;
134D;ETHIOPIC SYLLABLE FE;Lo;0;L;;;;;N;;;;;
134E;ETHIOPIC SYLLABLE FO;Lo;0;L;;;;;N;;;;;
134F;ETHIOPIC SYLLABLE FWA;Lo;0;L;;;;;N;;;;;
1350;ETHIOPIC SYLLABLE PA;Lo;0;L;;;;;N;;;;;
1351;ETHIOPIC SYLLABLE PU;Lo;0;L;;;;;N;;;;;
1352;ETHIOPIC SYLLABLE PI;Lo;0;L;;;;;N;;;;;
1353;ETHIOPIC SYLLABLE PAA;Lo;0;L;;;;;N;;;;;
1354;ETHIOPIC SYLLABLE PEE;Lo;0;L;;;;;N;;;;;
1355;ETHIOPIC SYLLABLE PE;Lo;0;L;;;;;N;;;;;
1356;ETHIOPIC SYLLABLE PO;Lo;0;L;;;;;N;;;;;
1357;ETHIOPIC SYLLABLE PWA;Lo;0;L;;;;;N;;;;;
1358;ETHIOPIC SYLLABLE RYA;Lo;0;L;;;;;N;;;;;
1359;ETHIOPIC SYLLABLE MYA;Lo;0;L;;;;;N;;;;;
135A;ETHIOPIC SYLLABLE FYA;Lo;0;L;;;;;N;;;;;
135D;ETHIOPIC COMBINING GEMINATION AND VOWEL LENGTH MARK;Mn;230;NSM;;;;;N;;;;;
135E;ETHIOPIC COMBINING VOWEL LENGTH MARK;Mn;230;NSM;;;;;N;;;;;
135F;ETHIOPIC COMBINING GEMINATION MARK;Mn;230;NSM;;;;;N;;;;;
1360;ETHIOPIC SECTION MARK;Po;0;L;;;;;N;;;;;
1361;ETHIOPIC WORDSPACE;Po;0;L;;;;;N;;;;;
1362;ETHIOPIC FULL STOP;Po;0;L;;;;;N;;;;;
1363;ETHIOPIC COMMA;Po;0;L;;;;;N;;;;;
1364;ETHIOPIC SEMICOLON;Po;0;L;;;;;N;;;;;
1365;ETHIOPIC COLON;Po;0;L;;;;;N;;;;;
1366;ETHIOPIC PREFACE COLON;Po;0;L;;;;;N;;;;;
1367;ETHIOPIC QUESTION MARK;Po;0;L;;;;;N;;;;;
1368;ETHIOPIC PARAGRAPH SEPARATOR;Po;0;L;;;;;N;;;;;
1369;ETHIOPIC DIGIT ONE;No;0;L;;;1;1;N;;;;;
136A;ETHIOPIC DIGIT TWO;No;0;L;;;2;2;N;;;;;
136B;ETHIOPIC DIGIT THREE;No;0;L;;;3;3;N;;;;;
136C;ETHIOPIC DIGIT FOUR;No;0;L;;;4;4;N;;;;;
136D;ETHIOPIC DIGIT FIVE;No;0;L;;;5;5;N;;;;;
136E;ETHIOPIC DIGIT SIX;No;0;L;;;6;6;N;;;;;
136F;ETHIOPIC DIGIT SEVEN;No;0;L;;;7;7;N;;;;;
1370;ETHIOPIC DIGIT EIGHT;No;0;L;;;8;8;N;;;;;
1371;ETHIOPIC DIGIT NINE;No;0;L;;;9;9;N;;;;;
1372;ETHIOPIC NUMBER TEN;No;0;L;;;;10;N;;;;;
1373;ETHIOPIC NUMBER TWENTY;No;0;L;;;;20;N;;;;;
1374;ETHIOPIC NUMBER THIRTY;No;0;L;;;;30;N;;;;;
1375;ETHIOPIC NUMBER FORTY;No;0;L;;;;40;N;;;;;
1376;ETHIOPIC NUMBER FIFTY;No;0;L;;;;50;N;;;;;
1377;ETHIOPIC NUMBER SIXTY;No;0;L;;;;60;N;;;;;
1378;ETHIOPIC NUMBER SEVENTY;No;0;L;;;;70;N;;;;;
1379;ETHIOPIC NUMBER EIGHTY;No;0;L;;;;80;N;;;;;
137A;ETHIOPIC NUMBER NINETY;No;0;L;;;;90;N;;;;;
137B;ETHIOPIC NUMBER HUNDRED;No;0;L;;;;100;N;;;;;
137C;ETHIOPIC NUMBER TEN THOUSAND;No;0;L;;;;10000;N;;;;;
1380;ETHIOPIC SYLLABLE SEBATBEIT MWA;Lo;0;L;;;;;N;;;;;
1381;ETHIOPIC SYLLABLE MWI;Lo;0;L;;;;;N;;;;;
1382;ETHIOPIC SYLLABLE MWEE;Lo;0;L;;;;;N;;;;;
1383;ETHIOPIC SYLLABLE MWE;Lo;0;L;;;;;N;;;;;
1384;ETHIOPIC SYLLABLE SEBATBEIT BWA;Lo;0;L;;;;;N;;;;;
1385;ETHIOPIC SYLLABLE BWI;Lo;0;L;;;;;N;;;;;
1386;ETHIOPIC SYLLABLE BWEE;Lo;0;L;;;;;N;;;;;
1387;ETHIOPIC SYLLABLE BWE;Lo;0;L;;;;;N;;;;;
1388;ETHIOPIC SYLLABLE SEBATBEIT FWA;Lo;0;L;;;;;N;;;;;
1389;ETHIOPIC SYLLABLE FWI;Lo;0;L;;;;;N;;;;;
138A;ETHIOPIC SYLLABLE FWEE;Lo;0;L;;;;;N;;;;;
138B;ETHIOPIC SYLLABLE FWE;Lo;0;L;;;;;N;;;;;
138C;ETHIOPIC SYLLABLE SEBATBEIT PWA;Lo;0;L;;;;;N;;;;;
138D;ETHIOPIC SYLLABLE PWI;Lo;0;L;;;;;N;;;;;
138E;ETHIOPIC SYLLABLE PWEE;Lo;0;L;;;;;N;;;;;
138F;ETHIOPIC SYLLABLE PWE;Lo;0;L;;;;;N;;;;;
1390;ETHIOPIC TONAL MARK YIZET;So;0;ON;;;;;N;;;;;
1391;ETHIOPIC TONAL MARK DERET;So;0;ON;;;;;N;;;;;
1392;ETHIOPIC TONAL MARK RIKRIK;So;0;ON;;;;;N;;;;;
1393;ETHIOPIC TONAL MARK SHORT RIKRIK;So;0;ON;;;;;N;;;;;
1394;ETHIOPIC TONAL MARK DIFAT;So;0;ON;;;;;N;;;;;
1395;ETHIOPIC TONAL MARK KENAT;So;0;ON;;;;;N;;;;;
1396;ETHIOPIC TONAL MARK CHIRET;So;0;ON;;;;;N;;;;;
1397;ETHIOPIC TONAL MARK HIDET;So;0;ON;;;;;N;;;;;
1398;ETHIOPIC TONAL MARK DERET-HIDET;So;0;ON;;;;;N;;;;;
1399;ETHIOPIC TONAL MARK KURT;So;0;ON;;;;;N;;;;;
13A0;CHEROKEE LETTER A;Lu;0;L;;;;;N;;;;AB70;
13A1;CHEROKEE LETTER E;Lu;0;L;;;;;N;;;;AB71;
13A2;CHEROKEE LETTER I;Lu;0;L;;;;;N;;;;AB72;
13A3;CHEROKEE LETTER O;Lu;0;L;;;;;N;;;;AB73;
13A4;CHEROKEE LETTER U;Lu;0;L;;;;;N;;;;AB74;
13A5;CHEROKEE LETTER V;Lu;0;L;;;;;N;;;;AB75;
13A6;CHEROKEE LETTER GA;Lu;0;L;;;;;N;;;;AB76;
13A7;CHEROKEE LETTER KA;Lu;0;L;;;;;N;;;;AB77;
13A8;CHEROKEE LETTER GE;Lu;0;L;;;;;N;;;;AB78;
13A9;CHEROKEE LETTER GI;Lu;0;L;;;;;N;;;;AB79;
13AA;CHEROKEE LETTER GO;Lu;0;L;;;;;N;;;;AB7A;
13AB;CHEROKEE LETTER GU;Lu;0;L;;;;;N;;;;AB7B;
13AC;CHEROKEE LETTER GV;Lu;0;L;;;;;N;;;;AB7C;
13AD;CHEROKEE LETTER HA;Lu;0;L;;;;;N;;;;AB7D;
13AE;CHEROKEE LETTER HE;Lu;0;L;;;;;N;;;;AB7E;
13AF;CHEROKEE LETTER HI;Lu;0;L;;;;;N;;;;AB7F;
13B0;CHEROKEE LETTER HO;Lu;0;L;;;;;N;;;;AB80;
13B1;CHEROKEE LETTER HU;Lu;0;L;;;;;N;;;;AB81;
13B2;CHEROKEE LETTER HV;Lu;0;L;;;;;N;;;;AB82;
13B3;CHEROKEE LETTER LA;Lu;0;L;;;;;N;;;;AB83;
13B4;CHEROKEE LETTER LE;Lu;0;L;;;;;N;;;;AB84;
13B5;CHEROKEE LETTER LI;Lu;0;L;;;;;N;;;;AB85;
13B6;CHEROKEE LETTER LO;Lu;0;L;;;;;N;;;;AB86;
13B7;CHEROKEE LETTER LU;Lu;0;L;;;;;N;;;;AB87;
13B8;CHEROKEE LETTER LV;Lu;0;L;;;;;N;;;;AB88;
13B9;CHEROKEE LETTER MA;Lu;0;L;;;;;N;;;;AB89;
13BA;CHEROKEE LETTER ME;Lu;0;L;;;;;N;;;;AB8A;
13BB;CHEROKEE LETTER MI;Lu;0;L;;;;;N;;;;AB8B;
13BC;CHEROKEE LETTER MO;Lu;0;L;;;;;N;;;;AB8C;
13BD;CHEROKEE LETTER MU;Lu;0;L;;;;;N;;;;AB8D;
13BE;CHEROKEE LETTER NA;Lu;0;L;;;;;N;;;;AB8E;
13BF;CHEROKEE LETTER HNA;Lu;0;L;;;;;N;;;;AB8F;
13C0;CHEROKEE LETTER NAH;Lu;0;L;;;;;N;;;;AB90;
13C1;CHEROKEE LETTER NE;Lu;0;L;;;;;N;;;;AB91;
13C2;CHEROKEE LETTER NI;Lu;0;L;;;;;N;;;;AB92;
13C3;CHEROKEE LETTER NO;Lu;0;L;;;;;N;;;;AB93;
13C4;CHEROKEE LETTER NU;Lu;0;L;;;;;N;;;;AB94;
13C5;CHEROKEE LETTER NV;Lu;0;L;;;;;N;;;;AB95;
13C6;CHEROKEE LETTER QUA;Lu;0;L;;;;;N;;;;AB96;
13C7;CHEROKEE LETTER QUE;Lu;0;L;;;;;N;;;;AB97;
13C8;CHEROKEE LETTER QUI;Lu;0;L;;;;;N;;;;AB98;
13C9;CHEROKEE LETTER QUO;Lu;0;L;;;;;N;;;;AB99;
13CA;CHEROKEE LETTER QUU;Lu;0;L;;;;;N;;;;AB9A;
13CB;CHEROKEE LETTER QUV;Lu;0;L;;;;;N;;;;AB9B;
13CC;CHEROKEE LETTER SA;Lu;0;L;;;;;N;;;;AB9C;
13CD;CHEROKEE LETTER S;Lu;0;L;;;;;N;;;;AB9D;
13CE;CHEROKEE LETTER SE;Lu;0;L;;;;;N;;;;AB9E;
13CF;CHEROKEE LETTER SI;Lu;0;L;;;;;N;;;;AB9F;
13D0;CHEROKEE LETTER SO;Lu;0;L;;;;;N;;;;ABA0;
13D1;CHEROKEE LETTER SU;Lu;0;L;;;;;N;;;;ABA1;
13D2;CHEROKEE LETTER SV;Lu;0;L;;;;;N;;;;ABA2;
13D3;CHEROKEE LETTER DA;Lu;0;L;;;;;N;;;;ABA3;
13D4;CHEROKEE LETTER TA;Lu;0;L;;;;;N;;;;ABA4;
13D5;CHEROKEE LETTER DE;Lu;0;L;;;;;N;;;;ABA5;
13D6;CHEROKEE LETTER TE;Lu;0;L;;;;;N;;;;ABA6;
13D7;CHEROKEE LETTER DI;Lu;0;L;;;;;N;;;;ABA7;
13D8;CHEROKEE LETTER TI;Lu;0;L;;;;;N;;;;ABA8;
13D9;CHEROKEE LETTER DO;Lu;0;L;;;;;N;;;;ABA9;
13DA;CHEROKEE LETTER DU;Lu;0;L;;;;;N;;;;ABAA;
13DB;CHEROKEE LETTER DV;Lu;0;L;;;;;N;;;;ABAB;
13DC;CHEROKEE LETTER DLA;Lu;0;L;;;;;N;;;;ABAC;
13DD;CHEROKEE LETTER TLA;Lu;0;L;;;;;N;;;;ABAD;
13DE;CHEROKEE LETTER TLE;Lu;0;L;;;;;N;;;;ABAE;
13DF;CHEROKEE LETTER TLI;Lu;0;L;;;;;N;;;;ABAF;
13E0;CHEROKEE LETTER TLO;Lu;0;L;;;;;N;;;;ABB0;
13E1;CHEROKEE LETTER TLU;Lu;0;L;;;;;N;;;;ABB1;
13E2;CHEROKEE LETTER TLV;Lu;0;L;;;;;N;;;;ABB2;
13E3;CHEROKEE LETTER TSA;Lu;0;L;;;;;N;;;;ABB3;
13E4;CHEROKEE LETTER TSE;Lu;0;L;;;;;N;;;;ABB4;
13E5;CHEROKEE LETTER TSI;Lu;0;L;;;;;N;;;;ABB5;
13E6;CHEROKEE LETTER TSO;Lu;0;L;;;;;N;;;;ABB6;
13E7;CHEROKEE LETTER TSU;Lu;0;L;;;;;N;;;;ABB7;
13E8;CHEROKEE LETTER TSV;Lu;0;L;;;;;N;;;;ABB8;
13E9;CHEROKEE LETTER WA;Lu;0;L;;;;;N;;;;ABB9;
13EA;CHEROKEE LETTER WE;Lu;0;L;;;;;N;;;;ABBA;
13EB;CHEROKEE LETTER WI;Lu;0;L;;;;;N;;;;ABBB;
13EC;CHEROKEE LETTER WO;Lu;0;L;;;;;N;;;;ABBC;
13ED;CHEROKEE LETTER WU;Lu;0;L;;;;;N;;;;ABBD;
13EE;CHEROKEE LETTER WV;Lu;0;L;;;;;N;;;;ABBE;
13EF;CHEROKEE LETTER YA;Lu;0;L;;;;;N;;;;ABBF;
13F0;CHEROKEE LETTER YE;Lu;0;L;;;;;N;;;;13F8;
13F1;CHEROKEE LETTER YI;Lu;0;L;;;;;N;;;;13F9;
13F2;CHEROKEE LETTER YO;Lu;0;L;;;;;N;;;;13FA;
13F3;CHEROKEE LETTER YU;Lu;0;L;;;;;N;;;;13FB;
13F4;CHEROKEE LETTER YV;Lu;0;L;;;;;N;;;;13FC;
13F5;CHEROKEE LETTER MV;Lu;0;L;;;;;N;;;;13FD;
13F8;CHEROKEE SMALL LETTER YE;Ll;0;L;;;;;N;;;13F0;;13F0
13F9;CHEROKEE SMALL LETTER YI;Ll;0;L;;;;;N;;;13F1;;13F1
13FA;CHEROKEE SMALL LETTER YO;Ll;0;L;;;;;N;;;13F2;;13F2
13FB;CHEROKEE SMALL LETTER YU;Ll;0;L;;;;;N;;;13F3;;13F3
13FC;CHEROKEE SMALL LETTER YV;Ll;0;L;;;;;N;;;13F4;;13F4
13FD;CHEROKEE SMALL LETTER MV;Ll;0;L;;;;;N;;;13F5;;13F5
1400;CANADIAN SYLLABICS HYPHEN;Pd;0;ON;;;;;N;;;;;
1401;CANADIAN SYLLABICS E;Lo;0;L;;;;;N;;;;;
1402;CANADIAN SYLLABICS AAI;Lo;0;L;;;;;N;;;;;
1403;CANADIAN SYLLABICS I;Lo;0;L;;;;;N;;;;;
1404;CANADIAN SYLLABICS II;Lo;0;L;;;;;N;;;;;
1405;CANADIAN SYLLABICS O;Lo;0;L;;;;;N;;;;;
1406;CANADIAN SYLLABICS OO;Lo;0;L;;;;;N;;;;;
1407;CANADIAN SYLLABICS Y-CREE OO;Lo;0;L;;;;;N;;;;;
1408;CANADIAN SYLLABICS CARRIER EE;Lo;0;L;;;;;N;;;;;
1409;CANADIAN SYLLABICS CARRIER I;Lo;0;L;;;;;N;;;;;
140A;CANADIAN SYLLABICS A;Lo;0;L;;;;;N;;;;;
140B;CANADIAN SYLLABICS AA;Lo;0;L;;;;;N;;;;;
140C;CANADIAN SYLLABICS WE;Lo;0;L;;;;;N;;;;;
140D;CANADIAN SYLLABICS WEST-CREE WE;Lo;0;L;;;;;N;;;;;
140E;CANADIAN SYLLABICS WI;Lo;0;L;;;;;N;;;;;
140F;CANADIAN SYLLABICS WEST-CREE WI;Lo;0;L;;;;;N;;;;;
1410;CANADIAN SYLLABICS WII;Lo;0;L;;;;;N;;;;;
1411;CANADIAN SYLLABICS WEST-CREE WII;Lo;0;L;;;;;N;;;;;
1412;CANADIAN SYLLABICS WO;Lo;0;L;;;;;N;;;;;
1413;CANADIAN SYLLABICS WEST-CREE WO;Lo;0;L;;;;;N;;;;;
1414;CANADIAN SYLLABICS WOO;Lo;0;L;;;;;N;;;;;
1415;CANADIAN SYLLABICS WEST-CREE WOO;Lo;0;L;;;;;N;;;;;
1416;CANADIAN SYLLABICS NASKAPI WOO;Lo;0;L;;;;;N;;;;;
1417;CANADIAN SYLLABICS WA;Lo;0;L;;;;;N;;;;;
1418;CANADIAN SYLLABICS WEST-CREE WA;Lo;0;L;;;;;N;;;;;
1419;CANADIAN SYLLABICS WAA;Lo;0;L;;;;;N;;;;;
141A;CANADIAN SYLLABICS WEST-CREE WAA;Lo;0;L;;;;;N;;;;;
141B;CANADIAN SYLLABICS NASKAPI WAA;Lo;0;L;;;;;N;;;;;
141C;CANADIAN SYLLABICS AI;Lo;0;L;;;;;N;;;;;
141D;CANADIAN SYLLABICS Y-CREE W;Lo;0;L;;;;;N;;;;;
141E;CANADIAN SYLLABICS GLOTTAL STOP;Lo;0;L;;;;;N;;;;;
141F;CANADIAN SYLLABICS FINAL ACUTE;Lo;0;L;;;;;N;;;;;
1420;CANADIAN SYLLABICS FINAL GRAVE;Lo;0;L;;;;;N;;;;;
1421;CANADIAN SYLLABICS FINAL BOTTOM HALF RING;Lo;0;L;;;;;N;;;;;
1422;CANADIAN SYLLABICS FINAL TOP HALF RING;Lo;0;L;;;;;N;;;;;
1423;CANADIAN SYLLABICS FINAL RIGHT HALF RING;Lo;0;L;;;;;N;;;;;
1424;CANADIAN SYLLABICS FINAL RING;Lo;0;L;;;;;N;;;;;
1425;CANADIAN SYLLABICS FINAL DOUBLE ACUTE;Lo;0;L;;;;;N;;;;;
1426;CANADIAN SYLLABICS FINAL DOUBLE SHORT VERTICAL STROKES;Lo;0;L;;;;;N;;;;;
1427;CANADIAN SYLLABICS FINAL MIDDLE DOT;Lo;0;L;;;;;N;;;;;
1428;CANADIAN SYLLABICS FINAL SHORT HORIZONTAL STROKE;Lo;0;L;;;;;N;;;;;
1429;CANADIAN SYLLABICS FINAL PLUS;Lo;0;L;;;;;N;;;;;
142A;CANADIAN SYLLABICS FINAL DOWN TACK;Lo;0;L;;;;;N;;;;;
142B;CANADIAN SYLLABICS EN;Lo;0;L;;;;;N;;;;;
142C;CANADIAN SYLLABICS IN;Lo;0;L;;;;;N;;;;;
142D;CANADIAN SYLLABICS ON;Lo;0;L;;;;;N;;;;;
142E;CANADIAN SYLLABICS AN;Lo;0;L;;;;;N;;;;;
142F;CANADIAN SYLLABICS PE;Lo;0;L;;;;;N;;;;;
1430;CANADIAN SYLLABICS PAAI;Lo;0;L;;;;;N;;;;;
1431;CANADIAN SYLLABICS PI;Lo;0;L;;;;;N;;;;;
1432;CANADIAN SYLLABICS PII;Lo;0;L;;;;;N;;;;;
1433;CANADIAN SYLLABICS PO;Lo;0;L;;;;;N;;;;;
1434;CANADIAN SYLLABICS POO;Lo;0;L;;;;;N;;;;;
1435;CANADIAN SYLLABICS Y-CREE POO;Lo;0;L;;;;;N;;;;;
1436;CANADIAN SYLLABICS CARRIER HEE;Lo;0;L;;;;;N;;;;;
1437;CANADIAN SYLLABICS CARRIER HI;Lo;0;L;;;;;N;;;;;
1438;CANADIAN SYLLABICS PA;Lo;0;L;;;;;N;;;;;
1439;CANADIAN SYLLABICS PAA;Lo;0;L;;;;;N;;;;;
143A;CANADIAN SYLLABICS PWE;Lo;0;L;;;;;N;;;;;
143B;CANADIAN SYLLABICS WEST-CREE PWE;Lo;0;L;;;;;N;;;;;
143C;CANADIAN SYLLABICS PWI;Lo;0;L;;;;;N;;;;;
143D;CANADIAN SYLLABICS WEST-CREE PWI;Lo;0;L;;;;;N;;;;;
143E;CANADIAN SYLLABICS PWII;Lo;0;L;;;;;N;;;;;
143F;CANADIAN SYLLABICS WEST-CREE PWII;Lo;0;L;;;;;N;;;;;
1440;CANADIAN SYLLABICS PWO;Lo;0;L;;;;;N;;;;;
1441;CANADIAN SYLLABICS WEST-CREE PWO;Lo;0;L;;;;;N;;;;;
1442;CANADIAN SYLLABICS PWOO;Lo;0;L;;;;;N;;;;;
1443;CANADIAN SYLLABICS WEST-CREE PWOO;Lo;0;L;;;;;N;;;;;
1444;CANADIAN SYLLABICS PWA;Lo;0;L;;;;;N;;;;;
1445;CANADIAN SYLLABICS WEST-CREE PWA;Lo;0;L;;;;;N;;;;;
1446;CANADIAN SYLLABICS PWAA;Lo;0;L;;;;;N;;;;;
1447;CANADIAN SYLLABICS WEST-CREE PWAA;Lo;0;L;;;;;N;;;;;
1448;CANADIAN SYLLABICS Y-CREE PWAA;Lo;0;L;;;;;N;;;;;
1449;CANADIAN SYLLABICS P;Lo;0;L;;;;;N;;;;;
144A;CANADIAN SYLLABICS WEST-CREE P;Lo;0;L;;;;;N;;;;;
144B;CANADIAN SYLLABICS CARRIER H;Lo;0;L;;;;;N;;;;;
144C;CANADIAN SYLLABICS TE;Lo;0;L;;;;;N;;;;;
144D;CANADIAN SYLLABICS TAAI;Lo;0;L;;;;;N;;;;;
144E;CANADIAN SYLLABICS TI;Lo;0;L;;;;;N;;;;;
144F;CANADIAN SYLLABICS TII;Lo;0;L;;;;;N;;;;;
1450;CANADIAN SYLLABICS TO;Lo;0;L;;;;;N;;;;;
1451;CANADIAN SYLLABICS TOO;Lo;0;L;;;;;N;;;;;
1452;CANADIAN SYLLABICS Y-CREE TOO;Lo;0;L;;;;;N;;;;;
1453;CANADIAN SYLLABICS CARRIER DEE;Lo;0;L;;;;;N;;;;;
1454;CANADIAN SYLLABICS CARRIER DI;Lo;0;L;;;;;N;;;;;
1455;CANADIAN SYLLABICS TA;Lo;0;L;;;;;N;;;;;
1456;CANADIAN SYLLABICS TAA;Lo;0;L;;;;;N;;;;;
1457;CANADIAN SYLLABICS TWE;Lo;0;L;;;;;N;;;;;
1458;CANADIAN SYLLABICS WEST-CREE TWE;Lo;0;L;;;;;N;;;;;
1459;CANADIAN SYLLABICS TWI;Lo;0;L;;;;;N;;;;;
145A;CANADIAN SYLLABICS WEST-CREE TWI;Lo;0;L;;;;;N;;;;;
145B;CANADIAN SYLLABICS TWII;Lo;0;L;;;;;N;;;;;
145C;CANADIAN SYLLABICS WEST-CREE TWII;Lo;0;L;;;;;N;;;;;
145D;CANADIAN SYLLABICS TWO;Lo;0;L;;;;;N;;;;;
145E;CANADIAN SYLLABICS WEST-CREE TWO;Lo;0;L;;;;;N;;;;;
145F;CANADIAN SYLLABICS TWOO;Lo;0;L;;;;;N;;;;;
1460;CANADIAN SYLLABICS WEST-CREE TWOO;Lo;0;L;;;;;N;;;;;
1461;CANADIAN SYLLABICS TWA;Lo;0;L;;;;;N;;;;;
1462;CANADIAN SYLLABICS WEST-CREE TWA;Lo;0;L;;;;;N;;;;;
1463;CANADIAN SYLLABICS TWAA;Lo;0;L;;;;;N;;;;;
1464;CANADIAN SYLLABICS WEST-CREE TWAA;Lo;0;L;;;;;N;;;;;
1465;CANADIAN SYLLABICS NASKAPI TWAA;Lo;0;L;;;;;N;;;;;
1466;CANADIAN SYLLABICS T;Lo;0;L;;;;;N;;;;;
1467;CANADIAN SYLLABICS TTE;Lo;0;L;;;;;N;;;;;
1468;CANADIAN SYLLABICS TTI;Lo;0;L;;;;;N;;;;;
1469;CANADIAN SYLLABICS TTO;Lo;0;L;;;;;N;;;;;
146A;CANADIAN SYLLABICS TTA;Lo;0;L;;;;;N;;;;;
146B;CANADIAN SYLLABICS KE;Lo;0;L;;;;;N;;;;;
146C;CANADIAN SYLLABICS KAAI;Lo;0;L;;;;;N;;;;;
146D;CANADIAN SYLLABICS KI;Lo;0;L;;;;;N;;;;;
146E;CANADIAN SYLLABICS KII;Lo;0;L;;;;;N;;;;;
146F;CANADIAN SYLLABICS KO;Lo;0;L;;;;;N;;;;;
1470;CANADIAN SYLLABICS KOO;Lo;0;L;;;;;N;;;;;
1471;CANADIAN SYLLABICS Y-CREE KOO;Lo;0;L;;;;;N;;;;;
1472;CANADIAN SYLLABICS KA;Lo;0;L;;;;;N;;;;;
1473;CANADIAN SYLLABICS KAA;Lo;0;L;;;;;N;;;;;
1474;CANADIAN SYLLABICS KWE;Lo;0;L;;;;;N;;;;;
1475;CANADIAN SYLLABICS WEST-CREE KWE;Lo;0;L;;;;;N;;;;;
1476;CANADIAN SYLLABICS KWI;Lo;0;L;;;;;N;;;;;
1477;CANADIAN SYLLABICS WEST-CREE KWI;Lo;0;L;;;;;N;;;;;
1478;CANADIAN SYLLABICS KWII;Lo;0;L;;;;;N;;;;;
1479;CANADIAN SYLLABICS WEST-CREE KWII;Lo;0;L;;;;;N;;;;;
147A;CANADIAN SYLLABICS KWO;Lo;0;L;;;;;N;;;;;
147B;CANADIAN SYLLABICS WEST-CREE KWO;Lo;0;L;;;;;N;;;;;
147C;CANADIAN SYLLABICS KWOO;Lo;0;L;;;;;N;;;;;
147D;CANADIAN SYLLABICS WEST-CREE KWOO;Lo;0;L;;;;;N;;;;;
147E;CANADIAN SYLLABICS KWA;Lo;0;L;;;;;N;;;;;
147F;CANADIAN SYLLABICS WEST-CREE KWA;Lo;0;L;;;;;N;;;;;
1480;CANADIAN SYLLABICS KWAA;Lo;0;L;;;;;N;;;;;
1481;CANADIAN SYLLABICS WEST-CREE KWAA;Lo;0;L;;;;;N;;;;;
1482;CANADIAN SYLLABICS NASKAPI KWAA;Lo;0;L;;;;;N;;;;;
1483;CANADIAN SYLLABICS K;Lo;0;L;;;;;N;;;;;
1484;CANADIAN SYLLABICS KW;Lo;0;L;;;;;N;;;;;
1485;CANADIAN SYLLABICS SOUTH-SLAVEY KEH;Lo;0;L;;;;;N;;;;;
1486;CANADIAN SYLLABICS SOUTH-SLAVEY KIH;Lo;0;L;;;;;N;;;;;
1487;CANADIAN SYLLABICS SOUTH-SLAVEY KOH;Lo;0;L;;;;;N;;;;;
1488;CANADIAN SYLLABICS SOUTH-SLAVEY KAH;Lo;0;L;;;;;N;;;;;
1489;CANADIAN SYLLABICS CE;Lo;0;L;;;;;N;;;;;
148A;CANADIAN SYLLABICS CAAI;Lo;0;L;;;;;N;;;;;
148B;CANADIAN SYLLABICS CI;Lo;0;L;;;;;N;;;;;
148C;CANADIAN SYLLABICS CII;Lo;0;L;;;;;N;;;;;
148D;CANADIAN SYLLABICS CO;Lo;0;L;;;;;N;;;;;
148E;CANADIAN SYLLABICS COO;Lo;0;L;;;;;N;;;;;
148F;CANADIAN SYLLABICS Y-CREE COO;Lo;0;L;;;;;N;;;;;
1490;CANADIAN SYLLABICS CA;Lo;0;L;;;;;N;;;;;
1491;CANADIAN SYLLABICS CAA;Lo;0;L;;;;;N;;;;;
1492;CANADIAN SYLLABICS CWE;Lo;0;L;;;;;N;;;;;
1493;CANADIAN SYLLABICS WEST-CREE CWE;Lo;0;L;;;;;N;;;;;
1494;CANADIAN SYLLABICS CWI;Lo;0;L;;;;;N;;;;;
1495;CANADIAN SYLLABICS WEST-CREE CWI;Lo;0;L;;;;;N;;;;;
1496;CANADIAN SYLLABICS CWII;Lo;0;L;;;;;N;;;;;
1497;CANADIAN SYLLABICS WEST-CREE CWII;Lo;0;L;;;;;N;;;;;
1498;CANADIAN SYLLABICS CWO;Lo;0;L;;;;;N;;;;;
1499;CANADIAN SYLLABICS WEST-CREE CWO;Lo;0;L;;;;;N;;;;;
149A;CANADIAN SYLLABICS CWOO;Lo;0;L;;;;;N;;;;;
149B;CANADIAN SYLLABICS WEST-CREE CWOO;Lo;0;L;;;;;N;;;;;
149C;CANADIAN SYLLABICS CWA;Lo;0;L;;;;;N;;;;;
149D;CANADIAN SYLLABICS WEST-CREE CWA;Lo;0;L;;;;;N;;;;;
149E;CANADIAN SYLLABICS CWAA;Lo;0;L;;;;;N;;;;;
149F;CANADIAN SYLLABICS WEST-CREE CWAA;Lo;0;L;;;;;N;;;;;
14A0;CANADIAN SYLLABICS NASKAPI CWAA;Lo;0;L;;;;;N;;;;;
14A1;CANADIAN SYLLABICS C;Lo;0;L;;;;;N;;;;;
14A2;CANADIAN SYLLABICS SAYISI TH;Lo;0;L;;;;;N;;;;;
14A3;CANADIAN SYLLABICS ME;Lo;0;L;;;;;N;;;;;
14A4;CANADIAN SYLLABICS MAAI;Lo;0;L;;;;;N;;;;;
14A5;CANADIAN SYLLABICS MI;Lo;0;L;;;;;N;;;;;
14A6;CANADIAN SYLLABICS MII;Lo;0;L;;;;;N;;;;;
14A7;CANADIAN SYLLABICS MO;Lo;0;L;;;;;N;;;;;
14A8;CANADIAN SYLLABICS MOO;Lo;0;L;;;;;N;;;;;
14A9;CANADIAN SYLLABICS Y-CREE MOO;Lo;0;L;;;;;N;;;;;
14AA;CANADIAN SYLLABICS MA;Lo;0;L;;;;;N;;;;;
14AB;CANADIAN SYLLABICS MAA;Lo;0;L;;;;;N;;;;;
14AC;CANADIAN SYLLABICS MWE;Lo;0;L;;;;;N;;;;;
14AD;CANADIAN SYLLABICS WEST-CREE MWE;Lo;0;L;;;;;N;;;;;
14AE;CANADIAN SYLLABICS MWI;Lo;0;L;;;;;N;;;;;
14AF;CANADIAN SYLLABICS WEST-CREE MWI;Lo;0;L;;;;;N;;;;;
14B0;CANADIAN SYLLABICS MWII;Lo;0;L;;;;;N;;;;;
14B1;CANADIAN SYLLABICS WEST-CREE MWII;Lo;0;L;;;;;N;;;;;
14B2;CANADIAN SYLLABICS MWO;Lo;0;L;;;;;N;;;;;
14B3;CANADIAN SYLLABICS WEST-CREE MWO;Lo;0;L;;;;;N;;;;;
14B4;CANADIAN SYLLABICS MWOO;Lo;0;L;;;;;N;;;;;
14B5;CANADIAN SYLLABICS WEST-CREE MWOO;Lo;0;L;;;;;N;;;;;
14B6;CANADIAN SYLLABICS MWA;Lo;0;L;;;;;N;;;;;
14B7;CANADIAN SYLLABICS WEST-CREE MWA;Lo;0;L;;;;;N;;;;;
14B8;CANADIAN SYLLABICS MWAA;Lo;0;L;;;;;N;;;;;
14B9;CANADIAN SYLLABICS WEST-CREE MWAA;Lo;0;L;;;;;N;;;;;
14BA;CANADIAN SYLLABICS NASKAPI MWAA;Lo;0;L;;;;;N;;;;;
14BB;CANADIAN SYLLABICS M;Lo;0;L;;;;;N;;;;;
14BC;CANADIAN SYLLABICS WEST-CREE M;Lo;0;L;;;;;N;;;;;
14BD;CANADIAN SYLLABICS MH;Lo;0;L;;;;;N;;;;;
14BE;CANADIAN SYLLABICS ATHAPASCAN M;Lo;0;L;;;;;N;;;;;
14BF;CANADIAN SYLLABICS SAYISI M;Lo;0;L;;;;;N;;;;;
14C0;CANADIAN SYLLABICS NE;Lo;0;L;;;;;N;;;;;
14C1;CANADIAN SYLLABICS NAAI;Lo;0;L;;;;;N;;;;;
14C2;CANADIAN SYLLABICS NI;Lo;0;L;;;;;N;;;;;
14C3;CANADIAN SYLLABICS NII;Lo;0;L;;;;;N;;;;;
14C4;CANADIAN SYLLABICS NO;Lo;0;L;;;;;N;;;;;
14C5;CANADIAN SYLLABICS NOO;Lo;0;L;;;;;N;;;;;
14C6;CANADIAN SYLLABICS Y-CREE NOO;Lo;0;L;;;;;N;;;;;
14C7;CANADIAN SYLLABICS NA;Lo;0;L;;;;;N;;;;;
14C8;CANADIAN SYLLABICS NAA;Lo;0;L;;;;;N;;;;;
14C9;CANADIAN SYLLABICS NWE;Lo;0;L;;;;;N;;;;;
14CA;CANADIAN SYLLABICS WEST-CREE NWE;Lo;0;L;;;;;N;;;;;
14CB;CANADIAN SYLLABICS NWA;Lo;0;L;;;;;N;;;;;
14CC;CANADIAN SYLLABICS WEST-CREE NWA;Lo;0;L;;;;;N;;;;;
14CD;CANADIAN SYLLABICS NWAA;Lo;0;L;;;;;N;;;;;
14CE;CANADIAN SYLLABICS WEST-CREE NWAA;Lo;0;L;;;;;N;;;;;
14CF;CANADIAN SYLLABICS NASKAPI NWAA;Lo;0;L;;;;;N;;;;;
14D0;CANADIAN SYLLABICS N;Lo;0;L;;;;;N;;;;;
14D1;CANADIAN SYLLABICS CARRIER NG;Lo;0;L;;;;;N;;;;;
14D2;CANADIAN SYLLABICS NH;Lo;0;L;;;;;N;;;;;
14D3;CANADIAN SYLLABICS LE;Lo;0;L;;;;;N;;;;;
14D4;CANADIAN SYLLABICS LAAI;Lo;0;L;;;;;N;;;;;
14D5;CANADIAN SYLLABICS LI;Lo;0;L;;;;;N;;;;;
14D6;CANADIAN SYLLABICS LII;Lo;0;L;;;;;N;;;;;
14D7;CANADIAN SYLLABICS LO;Lo;0;L;;;;;N;;;;;
14D8;CANADIAN SYLLABICS LOO;Lo;0;L;;;;;N;;;;;
14D9;CANADIAN SYLLABICS Y-CREE LOO;Lo;0;L;;;;;N;;;;;
14DA;CANADIAN SYLLABICS LA;Lo;0;L;;;;;N;;;;;
14DB;CANADIAN SYLLABICS LAA;Lo;0;L;;;;;N;;;;;
14DC;CANADIAN SYLLABICS LWE;Lo;0;L;;;;;N;;;;;
14DD;CANADIAN SYLLABICS WEST-CREE LWE;Lo;0;L;;;;;N;;;;;
14DE;CANADIAN SYLLABICS LWI;Lo;0;L;;;;;N;;;;;
14DF;CANADIAN SYLLABICS WEST-CREE LWI;Lo;0;L;;;;;N;;;;;
14E0;CANADIAN SYLLABICS LWII;Lo;0;L;;;;;N;;;;;
14E1;CANADIAN SYLLABICS WEST-CREE LWII;Lo;0;L;;;;;N;;;;;
14E2;CANADIAN SYLLABICS LWO;Lo;0;L;;;;;N;;;;;
14E3;CANADIAN SYLLABICS WEST-CREE LWO;Lo;0;L;;;;;N;;;;;
14E4;CANADIAN SYLLABICS LWOO;Lo;0;L;;;;;N;;;;;
14E5;CANADIAN SYLLABICS WEST-CREE LWOO;Lo;0;L;;;;;N;;;;;
14E6;CANADIAN SYLLABICS LWA;Lo;0;L;;;;;N;;;;;
14E7;CANADIAN SYLLABICS WEST-CREE LWA;Lo;0;L;;;;;N;;;;;
14E8;CANADIAN SYLLABICS LWAA;Lo;0;L;;;;;N;;;;;
14E9;CANADIAN SYLLABICS WEST-CREE LWAA;Lo;0;L;;;;;N;;;;;
14EA;CANADIAN SYLLABICS L;Lo;0;L;;;;;N;;;;;
14EB;CANADIAN SYLLABICS WEST-CREE L;Lo;0;L;;;;;N;;;;;
14EC;CANADIAN SYLLABICS MEDIAL L;Lo;0;L;;;;;N;;;;;
14ED;CANADIAN SYLLABICS SE;Lo;0;L;;;;;N;;;;;
14EE;CANADIAN SYLLABICS SAAI;Lo;0;L;;;;;N;;;;;
14EF;CANADIAN SYLLABICS SI;Lo;0;L;;;;;N;;;;;
14F0;CANADIAN SYLLABICS SII;Lo;0;L;;;;;N;;;;;
14F1;CANADIAN SYLLABICS SO;Lo;0;L;;;;;N;;;;;
14F2;CANADIAN SYLLABICS SOO;Lo;0;L;;;;;N;;;;;
14F3;CANADIAN SYLLABICS Y-CREE SOO;Lo;0;L;;;;;N;;;;;
14F4;CANADIAN SYLLABICS SA;Lo;0;L;;;;;N;;;;;
14F5;CANADIAN SYLLABICS SAA;Lo;0;L;;;;;N;;;;;
14F6;CANADIAN SYLLABICS SWE;Lo;0;L;;;;;N;;;;;
14F7;CANADIAN SYLLABICS WEST-CREE SWE;Lo;0;L;;;;;N;;;;;
14F8;CANADIAN SYLLABICS SWI;Lo;0;L;;;;;N;;;;;
14F9;CANADIAN SYLLABICS WEST-CREE SWI;Lo;0;L;;;;;N;;;;;
14FA;CANADIAN SYLLABICS SWII;Lo;0;L;;;;;N;;;;;
14FB;CANADIAN SYLLABICS WEST-CREE SWII;Lo;0;L;;;;;N;;;;;
14FC;CANADIAN SYLLABICS SWO;Lo;0;L;;;;;N;;;;;
14FD;CANADIAN SYLLABICS WEST-CREE SWO;Lo;0;L;;;;;N;;;;;
14FE;CANADIAN SYLLABICS SWOO;Lo;0;L;;;;;N;;;;;
14FF;CANADIAN SYLLABICS WEST-CREE SWOO;Lo;0;L;;;;;N;;;;;
1500;CANADIAN SYLLABICS SWA;Lo;0;L;;;;;N;;;;;
1501;CANADIAN SYLLABICS WEST-CREE SWA;Lo;0;L;;;;;N;;;;;
1502;CANADIAN SYLLABICS SWAA;Lo;0;L;;;;;N;;;;;
1503;CANADIAN SYLLABICS WEST-CREE SWAA;Lo;0;L;;;;;N;;;;;
1504;CANADIAN SYLLABICS NASKAPI SWAA;Lo;0;L;;;;;N;;;;;
1505;CANADIAN SYLLABICS S;Lo;0;L;;;;;N;;;;;
1506;CANADIAN SYLLABICS ATHAPASCAN S;Lo;0;L;;;;;N;;;;;
1507;CANADIAN SYLLABICS SW;Lo;0;L;;;;;N;;;;;
1508;CANADIAN SYLLABICS BLACKFOOT S;Lo;0;L;;;;;N;;;;;
1509;CANADIAN SYLLABICS MOOSE-CREE SK;Lo;0;L;;;;;N;;;;;
150A;CANADIAN SYLLABICS NASKAPI SKW;Lo;0;L;;;;;N;;;;;
150B;CANADIAN SYLLABICS NASKAPI S-W;Lo;0;L;;;;;N;;;;;
150C;CANADIAN SYLLABICS NASKAPI SPWA;Lo;0;L;;;;;N;;;;;
150D;CANADIAN SYLLABICS NASKAPI STWA;Lo;0;L;;;;;N;;;;;
150E;CANADIAN SYLLABICS NASKAPI SKWA;Lo;0;L;;;;;N;;;;;
150F;CANADIAN SYLLABICS NASKAPI SCWA;Lo;0;L;;;;;N;;;;;
1510;CANADIAN SYLLABICS SHE;Lo;0;L;;;;;N;;;;;
1511;CANADIAN SYLLABICS SHI;Lo;0;L;;;;;N;;;;;
1512;CANADIAN SYLLABICS SHII;Lo;0;L;;;;;N;;;;;
1513;CANADIAN SYLLABICS SHO;Lo;0;L;;;;;N;;;;;
1514;CANADIAN SYLLABICS SHOO;Lo;0;L;;;;;N;;;;;
1515;CANADIAN SYLLABICS SHA;Lo;0;L;;;;;N;;;;;
1516;CANADIAN SYLLABICS SHAA;Lo;0;L;;;;;N;;;;;
1517;CANADIAN SYLLABICS SHWE;Lo;0;L;;;;;N;;;;;
1518;CANADIAN SYLLABICS WEST-CREE SHWE;Lo;0;L;;;;;N;;;;;
1519;CANADIAN SYLLABICS SHWI;Lo;0;L;;;;;N;;;;;
151A;CANADIAN SYLLABICS WEST-CREE SHWI;Lo;0;L;;;;;N;;;;;
151B;CANADIAN SYLLABICS SHWII;Lo;0;L;;;;;N;;;;;
151C;CANADIAN SYLLABICS WEST-CREE SHWII;Lo;0;L;;;;;N;;;;;
151D;CANADIAN SYLLABICS SHWO;Lo;0;L;;;;;N;;;;;
151E;CANADIAN SYLLABICS WEST-CREE SHWO;Lo;0;L;;;;;N;;;;;
151F;CANADIAN SYLLABICS SHWOO;Lo;0;L;;;;;N;;;;;
1520;CANADIAN SYLLABICS WEST-CREE SHWOO;Lo;0;L;;;;;N;;;;;
1521;CANADIAN SYLLABICS SHWA;Lo;0;L;;;;;N;;;;;
1522;CANADIAN SYLLABICS WEST-CREE SHWA;Lo;0;L;;;;;N;;;;;
1523;CANADIAN SYLLABICS SHWAA;Lo;0;L;;;;;N;;;;;
1524;CANADIAN SYLLABICS WEST-CREE SHWAA;Lo;0;L;;;;;N;;;;;
1525;CANADIAN SYLLABICS SH;Lo;0;L;;;;;N;;;;;
1526;CANADIAN SYLLABICS YE;Lo;0;L;;;;;N;;;;;
1527;CANADIAN SYLLABICS YAAI;Lo;0;L;;;;;N;;;;;
1528;CANADIAN SYLLABICS YI;Lo;0;L;;;;;N;;;;;
1529;CANADIAN SYLLABICS YII;Lo;0;L;;;;;N;;;;;
152A;CANADIAN SYLLABICS YO;Lo;0;L;;;;;N;;;;;
152B;CANADIAN SYLLABICS YOO;Lo;0;L;;;;;N;;;;;
152C;CANADIAN SYLLABICS Y-CREE YOO;Lo;0;L;;;;;N;;;;;
152D;CANADIAN SYLLABICS YA;Lo;0;L;;;;;N;;;;;
152E;CANADIAN SYLLABICS YAA;Lo;0;L;;;;;N;;;;;
152F;CANADIAN SYLLABICS YWE;Lo;0;L;;;;;N;;;;;
1530;CANADIAN SYLLABICS WEST-CREE YWE;Lo;0;L;;;;;N;;;;;
1531;CANADIAN SYLLABICS YWI;Lo;0;L;;;;;N;;;;;
1532;CANADIAN SYLLABICS WEST-CREE YWI;Lo;0;L;;;;;N;;;;;
1533;CANADIAN SYLLABICS YWII;Lo;0;L;;;;;N;;;;;
1534;CANADIAN SYLLABICS WEST-CREE YWII;Lo;0;L;;;;;N;;;;;
1535;CANADIAN SYLLABICS YWO;Lo;0;L;;;;;N;;;;;
1536;CANADIAN SYLLABICS WEST-CREE YWO;Lo;0;L;;;;;N;;;;;
1537;CANADIAN SYLLABICS YWOO;Lo;0;L;;;;;N;;;;;
1538;CANADIAN SYLLABICS WEST-CREE YWOO;Lo;0;L;;;;;N;;;;;
1539;CANADIAN SYLLABICS YWA;Lo;0;L;;;;;N;;;;;
153A;CANADIAN SYLLABICS WEST-CREE YWA;Lo;0;L;;;;;N;;;;;
153B;CANADIAN SYLLABICS YWAA;Lo;0;L;;;;;N;;;;;
153C;CANADIAN SYLLABICS WEST-CREE YWAA;Lo;0;L;;;;;N;;;;;
153D;CANADIAN SYLLABICS NASKAPI YWAA;Lo;0;L;;;;;N;;;;;
153E;CANADIAN SYLLABICS Y;Lo;0;L;;;;;N;;;;;
153F;CANADIAN SYLLABICS BIBLE-CREE Y;Lo;0;L;;;;;N;;;;;
1540;CANADIAN SYLLABICS WEST-CREE Y;Lo;0;L;;;;;N;;;;;
1541;CANADIAN SYLLABICS SAYISI YI;Lo;0;L;;;;;N;;;;;
1542;CANADIAN SYLLABICS RE;Lo;0;L;;;;;N;;;;;
1543;CANADIAN SYLLABICS R-CREE RE;Lo;0;L;;;;;N;;;;;
1544;CANADIAN SYLLABICS WEST-CREE LE;Lo;0;L;;;;;N;;;;;
1545;CANADIAN SYLLABICS RAAI;Lo;0;L;;;;;N;;;;;
1546;CANADIAN SYLLABICS RI;Lo;0;L;;;;;N;;;;;
1547;CANADIAN SYLLABICS RII;Lo;0;L;;;;;N;;;;;
1548;CANADIAN SYLLABICS RO;Lo;0;L;;;;;N;;;;;
1549;CANADIAN SYLLABICS ROO;Lo;0;L;;;;;N;;;;;
154A;CANADIAN SYLLABICS WEST-CREE LO;Lo;0;L;;;;;N;;;;;
154B;CANADIAN SYLLABICS RA;Lo;0;L;;;;;N;;;;;
154C;CANADIAN SYLLABICS RAA;Lo;0;L;;;;;N;;;;;
154D;CANADIAN SYLLABICS WEST-CREE LA;Lo;0;L;;;;;N;;;;;
154E;CANADIAN SYLLABICS RWAA;Lo;0;L;;;;;N;;;;;
154F;CANADIAN SYLLABICS WEST-CREE RWAA;Lo;0;L;;;;;N;;;;;
1550;CANADIAN SYLLABICS R;Lo;0;L;;;;;N;;;;;
1551;CANADIAN SYLLABICS WEST-CREE R;Lo;0;L;;;;;N;;;;;
1552;CANADIAN SYLLABICS MEDIAL R;Lo;0;L;;;;;N;;;;;
1553;CANADIAN SYLLABICS FE;Lo;0;L;;;;;N;;;;;
1554;CANADIAN SYLLABICS FAAI;Lo;0;L;;;;;N;;;;;
1555;CANADIAN SYLLABICS FI;Lo;0;L;;;;;N;;;;;
1556;CANADIAN SYLLABICS FII;Lo;0;L;;;;;N;;;;;
1557;CANADIAN SYLLABICS FO;Lo;0;L;;;;;N;;;;;
1558;CANADIAN SYLLABICS FOO;Lo;0;L;;;;;N;;;;;
1559;CANADIAN SYLLABICS FA;Lo;0;L;;;;;N;;;;;
155A;CANADIAN SYLLABICS FAA;Lo;0;L;;;;;N;;;;;
155B;CANADIAN SYLLABICS FWAA;Lo;0;L;;;;;N;;;;;
155C;CANADIAN SYLLABICS WEST-CREE FWAA;Lo;0;L;;;;;N;;;;;
155D;CANADIAN SYLLABICS F;Lo;0;L;;;;;N;;;;;
155E;CANADIAN SYLLABICS THE;Lo;0;L;;;;;N;;;;;
155F;CANADIAN SYLLABICS N-CREE THE;Lo;0;L;;;;;N;;;;;
1560;CANADIAN SYLLABICS THI;Lo;0;L;;;;;N;;;;;
1561;CANADIAN SYLLABICS N-CREE THI;Lo;0;L;;;;;N;;;;;
1562;CANADIAN SYLLABICS THII;Lo;0;L;;;;;N;;;;;
1563;CANADIAN SYLLABICS N-CREE THII;Lo;0;L;;;;;N;;;;;
1564;CANADIAN SYLLABICS THO;Lo;0;L;;;;;N;;;;;
1565;CANADIAN SYLLABICS THOO;Lo;0;L;;;;;N;;;;;
1566;CANADIAN SYLLABICS THA;Lo;0;L;;;;;N;;;;;
1567;CANADIAN SYLLABICS THAA;Lo;0;L;;;;;N;;;;;
1568;CANADIAN SYLLABICS THWAA;Lo;0;L;;;;;N;;;;;
1569;CANADIAN SYLLABICS WEST-CREE THWAA;Lo;0;L;;;;;N;;;;;
156A;CANADIAN SYLLABICS TH;Lo;0;L;;;;;N;;;;;
156B;CANADIAN SYLLABICS TTHE;Lo;0;L;;;;;N;;;;;
156C;CANADIAN SYLLABICS TTHI;Lo;0;L;;;;;N;;;;;
156D;CANADIAN SYLLABICS TTHO;Lo;0;L;;;;;N;;;;;
156E;CANADIAN SYLLABICS TTHA;Lo;0;L;;;;;N;;;;;
156F;CANADIAN SYLLABICS TTH;Lo;0;L;;;;;N;;;;;
1570;CANADIAN SYLLABICS TYE;Lo;0;L;;;;;N;;;;;
1571;CANADIAN SYLLABICS TYI;Lo;0;L;;;;;N;;;;;
1572;CANADIAN SYLLABICS TYO;Lo;0;L;;;;;N;;;;;
1573;CANADIAN SYLLABICS TYA;Lo;0;L;;;;;N;;;;;
1574;CANADIAN SYLLABICS NUNAVIK HE;Lo;0;L;;;;;N;;;;;
1575;CANADIAN SYLLABICS NUNAVIK HI;Lo;0;L;;;;;N;;;;;
1576;CANADIAN SYLLABICS NUNAVIK HII;Lo;0;L;;;;;N;;;;;
1577;CANADIAN SYLLABICS NUNAVIK HO;Lo;0;L;;;;;N;;;;;
1578;CANADIAN SYLLABICS NUNAVIK HOO;Lo;0;L;;;;;N;;;;;
1579;CANADIAN SYLLABICS NUNAVIK HA;Lo;0;L;;;;;N;;;;;
157A;CANADIAN SYLLABICS NUNAVIK HAA;Lo;0;L;;;;;N;;;;;
157B;CANADIAN SYLLABICS NUNAVIK H;Lo;0;L;;;;;N;;;;;
157C;CANADIAN SYLLABICS NUNAVUT H;Lo;0;L;;;;;N;;;;;
157D;CANADIAN SYLLABICS HK;Lo;0;L;;;;;N;;;;;
157E;CANADIAN SYLLABICS QAAI;Lo;0;L;;;;;N;;;;;
157F;CANADIAN SYLLABICS QI;Lo;0;L;;;;;N;;;;;
1580;CANADIAN SYLLABICS QII;Lo;0;L;;;;;N;;;;;
1581;CANADIAN SYLLABICS QO;Lo;0;L;;;;;N;;;;;
1582;CANADIAN SYLLABICS QOO;Lo;0;L;;;;;N;;;;;
1583;CANADIAN SYLLABICS QA;Lo;0;L;;;;;N;;;;;
1584;CANADIAN SYLLABICS QAA;Lo;0;L;;;;;N;;;;;
1585;CANADIAN SYLLABICS Q;Lo;0;L;;;;;N;;;;;
1586;CANADIAN SYLLABICS TLHE;Lo;0;L;;;;;N;;;;;
1587;CANADIAN SYLLABICS TLHI;Lo;0;L;;;;;N;;;;;
1588;CANADIAN SYLLABICS TLHO;Lo;0;L;;;;;N;;;;;
1589;CANADIAN SYLLABICS TLHA;Lo;0;L;;;;;N;;;;;
158A;CANADIAN SYLLABICS WEST-CREE RE;Lo;0;L;;;;;N;;;;;
158B;CANADIAN SYLLABICS WEST-CREE RI;Lo;0;L;;;;;N;;;;;
158C;CANADIAN SYLLABICS WEST-CREE RO;Lo;0;L;;;;;N;;;;;
158D;CANADIAN SYLLABICS WEST-CREE RA;Lo;0;L;;;;;N;;;;;
158E;CANADIAN SYLLABICS NGAAI;Lo;0;L;;;;;N;;;;;
158F;CANADIAN SYLLABICS NGI;Lo;0;L;;;;;N;;;;;
1590;CANADIAN SYLLABICS NGII;Lo;0;L;;;;;N;;;;;
1591;CANADIAN SYLLABICS NGO;Lo;0;L;;;;;N;;;;;
1592;CANADIAN SYLLABICS NGOO;Lo;0;L;;;;;N;;;;;
1593;CANADIAN SYLLABICS NGA;Lo;0;L;;;;;N;;;;;
1594;CANADIAN SYLLABICS NGAA;Lo;0;L;;;;;N;;;;;
1595;CANADIAN SYLLABICS NG;Lo;0;L;;;;;N;;;;;
1596;CANADIAN SYLLABICS NNG;Lo;0;L;;;;;N;;;;;
1597;CANADIAN SYLLABICS SAYISI SHE;Lo;0;L;;;;;N;;;;;
1598;CANADIAN SYLLABICS SAYISI SHI;Lo;0;L;;;;;N;;;;;
1599;CANADIAN SYLLABICS SAYISI SHO;Lo;0;L;;;;;N;;;;;
159A;CANADIAN SYLLABICS SAYISI SHA;Lo;0;L;;;;;N;;;;;
159B;CANADIAN SYLLABICS WOODS-CREE THE;Lo;0;L;;;;;N;;;;;
159C;CANADIAN SYLLABICS WOODS-CREE THI;Lo;0;L;;;;;N;;;;;
159D;CANADIAN SYLLABICS WOODS-CREE THO;Lo;0;L;;;;;N;;;;;
159E;CANADIAN SYLLABICS WOODS-CREE THA;Lo;0;L;;;;;N;;;;;
159F;CANADIAN SYLLABICS WOODS-CREE TH;Lo;0;L;;;;;N;;;;;
15A0;CANADIAN SYLLABICS LHI;Lo;0;L;;;;;N;;;;;
15A1;CANADIAN SYLLABICS LHII;Lo;0;L;;;;;N;;;;;
15A2;CANADIAN SYLLABICS LHO;Lo;0;L;;;;;N;;;;;
15A3;CANADIAN SYLLABICS LHOO;Lo;0;L;;;;;N;;;;;
15A4;CANADIAN SYLLABICS LHA;Lo;0;L;;;;;N;;;;;
15A5;CANADIAN SYLLABICS LHAA;Lo;0;L;;;;;N;;;;;
15A6;CANADIAN SYLLABICS LH;Lo;0;L;;;;;N;;;;;
15A7;CANADIAN SYLLABICS TH-CREE THE;Lo;0;L;;;;;N;;;;;
15A8;CANADIAN SYLLABICS TH-CREE THI;Lo;0;L;;;;;N;;;;;
15A9;CANADIAN SYLLABICS TH-CREE THII;Lo;0;L;;;;;N;;;;;
15AA;CANADIAN SYLLABICS TH-CREE THO;Lo;0;L;;;;;N;;;;;
15AB;CANADIAN SYLLABICS TH-CREE THOO;Lo;0;L;;;;;N;;;;;
15AC;CANADIAN SYLLABICS TH-CREE THA;Lo;0;L;;;;;N;;;;;
15AD;CANADIAN SYLLABICS TH-CREE THAA;Lo;0;L;;;;;N;;;;;
15AE;CANADIAN SYLLABICS TH-CREE TH;Lo;0;L;;;;;N;;;;;
15AF;CANADIAN SYLLABICS AIVILIK B;Lo;0;L;;;;;N;;;;;
15B0;CANADIAN SYLLABICS BLACKFOOT E;Lo;0;L;;;;;N;;;;;
15B1;CANADIAN SYLLABICS BLACKFOOT I;Lo;0;L;;;;;N;;;;;
15B2;CANADIAN SYLLABICS BLACKFOOT O;Lo;0;L;;;;;N;;;;;
15B3;CANADIAN SYLLABICS BLACKFOOT A;Lo;0;L;;;;;N;;;;;
15B4;CANADIAN SYLLABICS BLACKFOOT WE;Lo;0;L;;;;;N;;;;;
15B5;CANADIAN SYLLABICS BLACKFOOT WI;Lo;0;L;;;;;N;;;;;
15B6;CANADIAN SYLLABICS BLACKFOOT WO;Lo;0;L;;;;;N;;;;;
15B7;CANADIAN SYLLABICS BLACKFOOT WA;Lo;0;L;;;;;N;;;;;
15B8;CANADIAN SYLLABICS BLACKFOOT NE;Lo;0;L;;;;;N;;;;;
15B9;CANADIAN SYLLABICS BLACKFOOT NI;Lo;0;L;;;;;N;;;;;
15BA;CANADIAN SYLLABICS BLACKFOOT NO;Lo;0;L;;;;;N;;;;;
15BB;CANADIAN SYLLABICS BLACKFOOT NA;Lo;0;L;;;;;N;;;;;
15BC;CANADIAN SYLLABICS BLACKFOOT KE;Lo;0;L;;;;;N;;;;;
15BD;CANADIAN SYLLABICS BLACKFOOT KI;Lo;0;L;;;;;N;;;;;
15BE;CANADIAN SYLLABICS BLACKFOOT KO;Lo;0;L;;;;;N;;;;;
15BF;CANADIAN SYLLABICS BLACKFOOT KA;Lo;0;L;;;;;N;;;;;
15C0;CANADIAN SYLLABICS SAYISI HE;Lo;0;L;;;;;N;;;;;
15C1;CANADIAN SYLLABICS SAYISI HI;Lo;0;L;;;;;N;;;;;
15C2;CANADIAN SYLLABICS SAYISI HO;Lo;0;L;;;;;N;;;;;
15C3;CANADIAN SYLLABICS SAYISI HA;Lo;0;L;;;;;N;;;;;
15C4;CANADIAN SYLLABICS CARRIER GHU;Lo;0;L;;;;;N;;;;;
15C5;CANADIAN SYLLABICS CARRIER GHO;Lo;0;L;;;;;N;;;;;
15C6;CANADIAN SYLLABICS CARRIER GHE;Lo;0;L;;;;;N;;;;;
15C7;CANADIAN SYLLABICS CARRIER GHEE;Lo;0;L;;;;;N;;;;;
15C8;CANADIAN SYLLABICS CARRIER GHI;Lo;0;L;;;;;N;;;;;
15C9;CANADIAN SYLLABICS CARRIER GHA;Lo;0;L;;;;;N;;;;;
15CA;CANADIAN SYLLABICS CARRIER RU;Lo;0;L;;;;;N;;;;;
15CB;CANADIAN SYLLABICS CARRIER RO;Lo;0;L;;;;;N;;;;;
15CC;CANADIAN SYLLABICS CARRIER RE;Lo;0;L;;;;;N;;;;;
15CD;CANADIAN SYLLABICS CARRIER REE;Lo;0;L;;;;;N;;;;;
15CE;CANADIAN SYLLABICS CARRIER RI;Lo;0;L;;;;;N;;;;;
15CF;CANADIAN SYLLABICS CARRIER RA;Lo;0;L;;;;;N;;;;;
15D0;CANADIAN SYLLABICS CARRIER WU;Lo;0;L;;;;;N;;;;;
15D1;CANADIAN SYLLABICS CARRIER WO;Lo;0;L;;;;;N;;;;;
15D2;CANADIAN SYLLABICS CARRIER WE;Lo;0;L;;;;;N;;;;;
15D3;CANADIAN SYLLABICS CARRIER WEE;Lo;0;L;;;;;N;;;;;
15D4;CANADIAN SYLLABICS CARRIER WI;Lo;0;L;;;;;N;;;;;
15D5;CANADIAN SYLLABICS CARRIER WA;Lo;0;L;;;;;N;;;;;
15D6;CANADIAN SYLLABICS CARRIER HWU;Lo;0;L;;;;;N;;;;;
15D7;CANADIAN SYLLABICS CARRIER HWO;Lo;0;L;;;;;N;;;;;
15D8;CANADIAN SYLLABICS CARRIER HWE;Lo;0;L;;;;;N;;;;;
15D9;CANADIAN SYLLABICS CARRIER HWEE;Lo;0;L;;;;;N;;;;;
15DA;CANADIAN SYLLABICS CARRIER HWI;Lo;0;L;;;;;N;;;;;
15DB;CANADIAN SYLLABICS CARRIER HWA;Lo;0;L;;;;;N;;;;;
15DC;CANADIAN SYLLABICS CARRIER THU;Lo;0;L;;;;;N;;;;;
15DD;CANADIAN SYLLABICS CARRIER THO;Lo;0;L;;;;;N;;;;;
15DE;CANADIAN SYLLABICS CARRIER THE;Lo;0;L;;;;;N;;;;;
15DF;CANADIAN SYLLABICS CARRIER THEE;Lo;0;L;;;;;N;;;;;
15E0;CANADIAN SYLLABICS CARRIER THI;Lo;0;L;;;;;N;;;;;
15E1;CANADIAN SYLLABICS CARRIER THA;Lo;0;L;;;;;N;;;;;
15E2;CANADIAN SYLLABICS CARRIER TTU;Lo;0;L;;;;;N;;;;;
15E3;CANADIAN SYLLABICS CARRIER TTO;Lo;0;L;;;;;N;;;;;
15E4;CANADIAN SYLLABICS CARRIER TTE;Lo;0;L;;;;;N;;;;;
15E5;CANADIAN SYLLABICS CARRIER TTEE;Lo;0;L;;;;;N;;;;;
15E6;CANADIAN SYLLABICS CARRIER TTI;Lo;0;L;;;;;N;;;;;
15E7;CANADIAN SYLLABICS CARRIER TTA;Lo;0;L;;;;;N;;;;;
15E8;CANADIAN SYLLABICS CARRIER PU;Lo;0;L;;;;;N;;;;;
15E9;CANADIAN SYLLABICS CARRIER PO;Lo;0;L;;;;;N;;;;;
15EA;CANADIAN SYLLABICS CARRIER PE;Lo;0;L;;;;;N;;;;;
15EB;CANADIAN SYLLABICS CARRIER PEE;Lo;0;L;;;;;N;;;;;
15EC;CANADIAN SYLLABICS CARRIER PI;Lo;0;L;;;;;N;;;;;
15ED;CANADIAN SYLLABICS CARRIER PA;Lo;0;L;;;;;N;;;;;
15EE;CANADIAN SYLLABICS CARRIER P;Lo;0;L;;;;;N;;;;;
15EF;CANADIAN SYLLABICS CARRIER GU;Lo;0;L;;;;;N;;;;;
15F0;CANADIAN SYLLABICS CARRIER GO;Lo;0;L;;;;;N;;;;;
15F1;CANADIAN SYLLABICS CARRIER GE;Lo;0;L;;;;;N;;;;;
15F2;CANADIAN SYLLABICS CARRIER GEE;Lo;0;L;;;;;N;;;;;
15F3;CANADIAN SYLLABICS CARRIER GI;Lo;0;L;;;;;N;;;;;
15F4;CANADIAN SYLLABICS CARRIER GA;Lo;0;L;;;;;N;;;;;
15F5;CANADIAN SYLLABICS CARRIER KHU;Lo;0;L;;;;;N;;;;;
15F6;CANADIAN SYLLABICS CARRIER KHO;Lo;0;L;;;;;N;;;;;
15F7;CANADIAN SYLLABICS CARRIER KHE;Lo;0;L;;;;;N;;;;;
15F8;CANADIAN SYLLABICS CARRIER KHEE;Lo;0;L;;;;;N;;;;;
15F9;CANADIAN SYLLABICS CARRIER KHI;Lo;0;L;;;;;N;;;;;
15FA;CANADIAN SYLLABICS CARRIER KHA;Lo;0;L;;;;;N;;;;;
15FB;CANADIAN SYLLABICS CARRIER KKU;Lo;0;L;;;;;N;;;;;
15FC;CANADIAN SYLLABICS CARRIER KKO;Lo;0;L;;;;;N;;;;;
15FD;CANADIAN SYLLABICS CARRIER KKE;Lo;0;L;;;;;N;;;;;
15FE;CANADIAN SYLLABICS CARRIER KKEE;Lo;0;L;;;;;N;;;;;
15FF;CANADIAN SYLLABICS CARRIER KKI;Lo;0;L;;;;;N;;;;;
1600;CANADIAN SYLLABICS CARRIER KKA;Lo;0;L;;;;;N;;;;;
1601;CANADIAN SYLLABICS CARRIER KK;Lo;0;L;;;;;N;;;;;
1602;CANADIAN SYLLABICS CARRIER NU;Lo;0;L;;;;;N;;;;;
1603;CANADIAN SYLLABICS CARRIER NO;Lo;0;L;;;;;N;;;;;
1604;CANADIAN SYLLABICS CARRIER NE;Lo;0;L;;;;;N;;;;;
1605;CANADIAN SYLLABICS CARRIER NEE;Lo;0;L;;;;;N;;;;;
1606;CANADIAN SYLLABICS CARRIER NI;Lo;0;L;;;;;N;;;;;
1607;CANADIAN SYLLABICS CARRIER NA;Lo;0;L;;;;;N;;;;;
1608;CANADIAN SYLLABICS CARRIER MU;Lo;0;L;;;;;N;;;;;
1609;CANADIAN SYLLABICS CARRIER MO;Lo;0;L;;;;;N;;;;;
160A;CANADIAN SYLLABICS CARRIER ME;Lo;0;L;;;;;N;;;;;
160B;CANADIAN SYLLABICS CARRIER MEE;Lo;0;L;;;;;N;;;;;
160C;CANADIAN SYLLABICS CARRIER MI;Lo;0;L;;;;;N;;;;;
160D;CANADIAN SYLLABICS CARRIER MA;Lo;0;L;;;;;N;;;;;
160E;CANADIAN SYLLABICS CARRIER YU;Lo;0;L;;;;;N;;;;;
160F;CANADIAN SYLLABICS CARRIER YO;Lo;0;L;;;;;N;;;;;
1610;CANADIAN SYLLABICS CARRIER YE;Lo;0;L;;;;;N;;;;;
1611;CANADIAN SYLLABICS CARRIER YEE;Lo;0;L;;;;;N;;;;;
1612;CANADIAN SYLLABICS CARRIER YI;Lo;0;L;;;;;N;;;;;
1613;CANADIAN SYLLABICS CARRIER YA;Lo;0;L;;;;;N;;;;;
1614;CANADIAN SYLLABICS CARRIER JU;Lo;0;L;;;;;N;;;;;
1615;CANADIAN SYLLABICS SAYISI JU;Lo;0;L;;;;;N;;;;;
1616;CANADIAN SYLLABICS CARRIER JO;Lo;0;L;;;;;N;;;;;
1617;CANADIAN SYLLABICS CARRIER JE;Lo;0;L;;;;;N;;;;;
1618;CANADIAN SYLLABICS CARRIER JEE;Lo;0;L;;;;;N;;;;;
1619;CANADIAN SYLLABICS CARRIER JI;Lo;0;L;;;;;N;;;;;
161A;CANADIAN SYLLABICS SAYISI JI;Lo;0;L;;;;;N;;;;;
161B;CANADIAN SYLLABICS CARRIER JA;Lo;0;L;;;;;N;;;;;
161C;CANADIAN SYLLABICS CARRIER JJU;Lo;0;L;;;;;N;;;;;
161D;CANADIAN SYLLABICS CARRIER JJO;Lo;0;L;;;;;N;;;;;
161E;CANADIAN SYLLABICS CARRIER JJE;Lo;0;L;;;;;N;;;;;
161F;CANADIAN SYLLABICS CARRIER JJEE;Lo;0;L;;;;;N;;;;;
1620;CANADIAN SYLLABICS CARRIER JJI;Lo;0;L;;;;;N;;;;;
1621;CANADIAN SYLLABICS CARRIER JJA;Lo;0;L;;;;;N;;;;;
1622;CANADIAN SYLLABICS CARRIER LU;Lo;0;L;;;;;N;;;;;
1623;CANADIAN SYLLABICS CARRIER LO;Lo;0;L;;;;;N;;;;;
1624;CANADIAN SYLLABICS CARRIER LE;Lo;0;L;;;;;N;;;;;
1625;CANADIAN SYLLABICS CARRIER LEE;Lo;0;L;;;;;N;;;;;
1626;CANADIAN SYLLABICS CARRIER LI;Lo;0;L;;;;;N;;;;;
1627;CANADIAN SYLLABICS CARRIER LA;Lo;0;L;;;;;N;;;;;
1628;CANADIAN SYLLABICS CARRIER DLU;Lo;0;L;;;;;N;;;;;
1629;CANADIAN SYLLABICS CARRIER DLO;Lo;0;L;;;;;N;;;;;
162A;CANADIAN SYLLABICS CARRIER DLE;Lo;0;L;;;;;N;;;;;
162B;CANADIAN SYLLABICS CARRIER DLEE;Lo;0;L;;;;;N;;;;;
162C;CANADIAN SYLLABICS CARRIER DLI;Lo;0;L;;;;;N;;;;;
162D;CANADIAN SYLLABICS CARRIER DLA;Lo;0;L;;;;;N;;;;;
162E;CANADIAN SYLLABICS CARRIER LHU;Lo;0;L;;;;;N;;;;;
162F;CANADIAN SYLLABICS CARRIER LHO;Lo;0;L;;;;;N;;;;;
1630;CANADIAN SYLLABICS CARRIER LHE;Lo;0;L;;;;;N;;;;;
1631;CANADIAN SYLLABICS CARRIER LHEE;Lo;0;L;;;;;N;;;;;
1632;CANADIAN SYLLABICS CARRIER LHI;Lo;0;L;;;;;N;;;;;
1633;CANADIAN SYLLABICS CARRIER LHA;Lo;0;L;;;;;N;;;;;
1634;CANADIAN SYLLABICS CARRIER TLHU;Lo;0;L;;;;;N;;;;;
1635;CANADIAN SYLLABICS CARRIER TLHO;Lo;0;L;;;;;N;;;;;
1636;CANADIAN SYLLABICS CARRIER TLHE;Lo;0;L;;;;;N;;;;;
1637;CANADIAN SYLLABICS CARRIER TLHEE;Lo;0;L;;;;;N;;;;;
1638;CANADIAN SYLLABICS CARRIER TLHI;Lo;0;L;;;;;N;;;;;
1639;CANADIAN SYLLABICS CARRIER TLHA;Lo;0;L;;;;;N;;;;;
163A;CANADIAN SYLLABICS CARRIER TLU;Lo;0;L;;;;;N;;;;;
163B;CANADIAN SYLLABICS CARRIER TLO;Lo;0;L;;;;;N;;;;;
163C;CANADIAN SYLLABICS CARRIER TLE;Lo;0;L;;;;;N;;;;;
163D;CANADIAN SYLLABICS CARRIER TLEE;Lo;0;L;;;;;N;;;;;
163E;CANADIAN SYLLABICS CARRIER TLI;Lo;0;L;;;;;N;;;;;
163F;CANADIAN SYLLABICS CARRIER TLA;Lo;0;L;;;;;N;;;;;
1640;CANADIAN SYLLABICS CARRIER ZU;Lo;0;L;;;;;N;;;;;
1641;CANADIAN SYLLABICS CARRIER ZO;Lo;0;L;;;;;N;;;;;
1642;CANADIAN SYLLABICS CARRIER ZE;Lo;0;L;;;;;N;;;;;
1643;CANADIAN SYLLABICS CARRIER ZEE;Lo;0;L;;;;;N;;;;;
1644;CANADIAN SYLLABICS CARRIER ZI;Lo;0;L;;;;;N;;;;;
1645;CANADIAN SYLLABICS CARRIER ZA;Lo;0;L;;;;;N;;;;;
1646;CANADIAN SYLLABICS CARRIER Z;Lo;0;L;;;;;N;;;;;
1647;CANADIAN SYLLABICS CARRIER INITIAL Z;Lo;0;L;;;;;N;;;;;
1648;CANADIAN SYLLABICS CARRIER DZU;Lo;0;L;;;;;N;;;;;
1649;CANADIAN SYLLABICS CARRIER DZO;Lo;0;L;;;;;N;;;;;
164A;CANADIAN SYLLABICS CARRIER DZE;Lo;0;L;;;;;N;;;;;
164B;CANADIAN SYLLABICS CARRIER DZEE;Lo;0;L;;;;;N;;;;;
164C;CANADIAN SYLLABICS CARRIER DZI;Lo;0;L;;;;;N;;;;;
164D;CANADIAN SYLLABICS CARRIER DZA;Lo;0;L;;;;;N;;;;;
164E;CANADIAN SYLLABICS CARRIER SU;Lo;0;L;;;;;N;;;;;
164F;CANADIAN SYLLABICS CARRIER SO;Lo;0;L;;;;;N;;;;;
1650;CANADIAN SYLLABICS CARRIER SE;Lo;0;L;;;;;N;;;;;
1651;CANADIAN SYLLABICS CARRIER SEE;Lo;0;L;;;;;N;;;;;
1652;CANADIAN SYLLABICS CARRIER SI;Lo;0;L;;;;;N;;;;;
1653;CANADIAN SYLLABICS CARRIER SA;Lo;0;L;;;;;N;;;;;
1654;CANADIAN SYLLABICS CARRIER SHU;Lo;0;L;;;;;N;;;;;
1655;CANADIAN SYLLABICS CARRIER SHO;Lo;0;L;;;;;N;;;;;
1656;CANADIAN SYLLABICS CARRIER SHE;Lo;0;L;;;;;N;;;;;
1657;CANADIAN SYLLABICS CARRIER SHEE;Lo;0;L;;;;;N;;;;;
1658;CANADIAN SYLLABICS CARRIER SHI;Lo;0;L;;;;;N;;;;;
1659;CANADIAN SYLLABICS CARRIER SHA;Lo;0;L;;;;;N;;;;;
165A;CANADIAN SYLLABICS CARRIER SH;Lo;0;L;;;;;N;;;;;
165B;CANADIAN SYLLABICS CARRIER TSU;Lo;0;L;;;;;N;;;;;
165C;CANADIAN SYLLABICS CARRIER TSO;Lo;0;L;;;;;N;;;;;
165D;CANADIAN SYLLABICS CARRIER TSE;Lo;0;L;;;;;N;;;;;
165E;CANADIAN SYLLABICS CARRIER TSEE;Lo;0;L;;;;;N;;;;;
165F;CANADIAN SYLLABICS CARRIER TSI;Lo;0;L;;;;;N;;;;;
1660;CANADIAN SYLLABICS CARRIER TSA;Lo;0;L;;;;;N;;;;;
1661;CANADIAN SYLLABICS CARRIER CHU;Lo;0;L;;;;;N;;;;;
1662;CANADIAN SYLLABICS CARRIER CHO;Lo;0;L;;;;;N;;;;;
1663;CANADIAN SYLLABICS CARRIER CHE;Lo;0;L;;;;;N;;;;;
1664;CANADIAN SYLLABICS CARRIER CHEE;Lo;0;L;;;;;N;;;;;
1665;CANADIAN SYLLABICS CARRIER CHI;Lo;0;L;;;;;N;;;;;
1666;CANADIAN SYLLABICS CARRIER CHA;Lo;0;L;;;;;N;;;;;
1667;CANADIAN SYLLABICS CARRIER TTSU;Lo;0;L;;;;;N;;;;;
1668;CANADIAN SYLLABICS CARRIER TTSO;Lo;0;L;;;;;N;;;;;
1669;CANADIAN SYLLABICS CARRIER TTSE;Lo;0;L;;;;;N;;;;;
166A;CANADIAN SYLLABICS CARRIER TTSEE;Lo;0;L;;;;;N;;;;;
166B;CANADIAN SYLLABICS CARRIER TTSI;Lo;0;L;;;;;N;;;;;
166C;CANADIAN SYLLABICS CARRIER TTSA;Lo;0;L;;;;;N;;;;;
166D;CANADIAN SYLLABICS CHI SIGN;So;0;L;;;;;N;;;;;
166E;CANADIAN SYLLABICS FULL STOP;Po;0;L;;;;;N;;;;;
166F;CANADIAN SYLLABICS QAI;Lo;0;L;;;;;N;;;;;
1670;CANADIAN SYLLABICS NGAI;Lo;0;L;;;;;N;;;;;
1671;CANADIAN SYLLABICS NNGI;Lo;0;L;;;;;N;;;;;
1672;CANADIAN SYLLABICS NNGII;Lo;0;L;;;;;N;;;;;
1673;CANADIAN SYLLABICS NNGO;Lo;0;L;;;;;N;;;;;
1674;CANADIAN SYLLABICS NNGOO;Lo;0;L;;;;;N;;;;;
1675;CANADIAN SYLLABICS NNGA;Lo;0;L;;;;;N;;;;;
1676;CANADIAN SYLLABICS NNGAA;Lo;0;L;;;;;N;;;;;
1677;CANADIAN SYLLABICS WOODS-CREE THWEE;Lo;0;L;;;;;N;;;;;
1678;CANADIAN SYLLABICS WOODS-CREE THWI;Lo;0;L;;;;;N;;;;;
1679;CANADIAN SYLLABICS WOODS-CREE THWII;Lo;0;L;;;;;N;;;;;
167A;CANADIAN SYLLABICS WOODS-CREE THWO;Lo;0;L;;;;;N;;;;;
167B;CANADIAN SYLLABICS WOODS-CREE THWOO;Lo;0;L;;;;;N;;;;;
167C;CANADIAN SYLLABICS WOODS-CREE THWA;Lo;0;L;;;;;N;;;;;
167D;CANADIAN SYLLABICS WOODS-CREE THWAA;Lo;0;L;;;;;N;;;;;
167E;CANADIAN SYLLABICS WOODS-CREE FINAL TH;Lo;0;L;;;;;N;;;;;
167F;CANADIAN SYLLABICS BLACKFOOT W;Lo;0;L;;;;;N;;;;;
1680;OGHAM SPACE MARK;Zs;0;WS;;;;;N;;;;;
1681;OGHAM LETTER BEITH;Lo;0;L;;;;;N;;;;;
1682;OGHAM LETTER LUIS;Lo;0;L;;;;;N;;;;;
1683;OGHAM LETTER FEARN;Lo;0;L;;;;;N;;;;;
1684;OGHAM LETTER SAIL;Lo;0;L;;;;;N;;;;;
1685;OGHAM LETTER NION;Lo;0;L;;;;;N;;;;;
1686;OGHAM LETTER UATH;Lo;0;L;;;;;N;;;;;
1687;OGHAM LETTER DAIR;Lo;0;L;;;;;N;;;;;
1688;OGHAM LETTER TINNE;Lo;0;L;;;;;N;;;;;
1689;OGHAM LETTER COLL;Lo;0;L;;;;;N;;;;;
168A;OGHAM LETTER CEIRT;Lo;0;L;;;;;N;;;;;
168B;OGHAM LETTER MUIN;Lo;0;L;;;;;N;;;;;
168C;OGHAM LETTER GORT;Lo;0;L;;;;;N;;;;;
168D;OGHAM LETTER NGEADAL;Lo;0;L;;;;;N;;;;;
168E;OGHAM LETTER STRAIF;Lo;0;L;;;;;N;;;;;
168F;OGHAM LETTER RUIS;Lo;0;L;;;;;N;;;;;
1690;OGHAM LETTER AILM;Lo;0;L;;;;;N;;;;;
1691;OGHAM LETTER ONN;Lo;0;L;;;;;N;;;;;
1692;OGHAM LETTER UR;Lo;0;L;;;;;N;;;;;
1693;OGHAM LETTER EADHADH;Lo;0;L;;;;;N;;;;;
1694;OGHAM LETTER IODHADH;Lo;0;L;;;;;N;;;;;
1695;OGHAM LETTER EABHADH;Lo;0;L;;;;;N;;;;;
1696;OGHAM LETTER OR;Lo;0;L;;;;;N;;;;;
1697;OGHAM LETTER UILLEANN;Lo;0;L;;;;;N;;;;;
1698;OGHAM LETTER IFIN;Lo;0;L;;;;;N;;;;;
1699;OGHAM LETTER EAMHANCHOLL;Lo;0;L;;;;;N;;;;;
169A;OGHAM LETTER PEITH;Lo;0;L;;;;;N;;;;;
169B;OGHAM FEATHER MARK;Ps;0;ON;;;;;Y;;;;;
169C;OGHAM REVERSED FEATHER MARK;Pe;0;ON;;;;;Y;;;;;
16A0;RUNIC LETTER FEHU FEOH FE F;Lo;0;L;;;;;N;;;;;
16A1;RUNIC LETTER V;Lo;0;L;;;;;N;;;;;
16A2;RUNIC LETTER URUZ UR U;Lo;0;L;;;;;N;;;;;
16A3;RUNIC LETTER YR;Lo;0;L;;;;;N;;;;;
16A4;RUNIC LETTER Y;Lo;0;L;;;;;N;;;;;
16A5;RUNIC LETTER W;Lo;0;L;;;;;N;;;;;
16A6;RUNIC LETTER THURISAZ THURS THORN;Lo;0;L;;;;;N;;;;;
16A7;RUNIC LETTER ETH;Lo;0;L;;;;;N;;;;;
16A8;RUNIC LETTER ANSUZ A;Lo;0;L;;;;;N;;;;;
16A9;RUNIC LETTER OS O;Lo;0;L;;;;;N;;;;;
16AA;RUNIC LETTER AC A;Lo;0;L;;;;;N;;;;;
16AB;RUNIC LETTER AESC;Lo;0;L;;;;;N;;;;;
16AC;RUNIC LETTER LONG-BRANCH-OSS O;Lo;0;L;;;;;N;;;;;
16AD;RUNIC LETTER SHORT-TWIG-OSS O;Lo;0;L;;;;;N;;;;;
16AE;RUNIC LETTER O;Lo;0;L;;;;;N;;;;;
16AF;RUNIC LETTER OE;Lo;0;L;;;;;N;;;;;
16B0;RUNIC LETTER ON;Lo;0;L;;;;;N;;;;;
16B1;RUNIC LETTER RAIDO RAD REID R;Lo;0;L;;;;;N;;;;;
16B2;RUNIC LETTER KAUNA;Lo;0;L;;;;;N;;;;;
16B3;RUNIC LETTER CEN;Lo;0;L;;;;;N;;;;;
16B4;RUNIC LETTER KAUN K;Lo;0;L;;;;;N;;;;;
16B5;RUNIC LETTER G;Lo;0;L;;;;;N;;;;;
16B6;RUNIC LETTER ENG;Lo;0;L;;;;;N;;;;;
16B7;RUNIC LETTER GEBO GYFU G;Lo;0;L;;;;;N;;;;;
16B8;RUNIC LETTER GAR;Lo;0;L;;;;;N;;;;;
16B9;RUNIC LETTER WUNJO WYNN W;Lo;0;L;;;;;N;;;;;
16BA;RUNIC LETTER HAGLAZ H;Lo;0;L;;;;;N;;;;;
16BB;RUNIC LETTER HAEGL H;Lo;0;L;;;;;N;;;;;
16BC;RUNIC LETTER LONG-BRANCH-HAGALL H;Lo;0;L;;;;;N;;;;;
16BD;RUNIC LETTER SHORT-TWIG-HAGALL H;Lo;0;L;;;;;N;;;;;
16BE;RUNIC LETTER NAUDIZ NYD NAUD N;Lo;0;L;;;;;N;;;;;
16BF;RUNIC LETTER SHORT-TWIG-NAUD N;Lo;0;L;;;;;N;;;;;
16C0;RUNIC LETTER DOTTED-N;Lo;0;L;;;;;N;;;;;
16C1;RUNIC LETTER ISAZ IS ISS I;Lo;0;L;;;;;N;;;;;
16C2;RUNIC LETTER E;Lo;0;L;;;;;N;;;;;
16C3;RUNIC LETTER JERAN J;Lo;0;L;;;;;N;;;;;
16C4;RUNIC LETTER GER;Lo;0;L;;;;;N;;;;;
16C5;RUNIC LETTER LONG-BRANCH-AR AE;Lo;0;L;;;;;N;;;;;
16C6;RUNIC LETTER SHORT-TWIG-AR A;Lo;0;L;;;;;N;;;;;
16C7;RUNIC LETTER IWAZ EOH;Lo;0;L;;;;;N;;;;;
16C8;RUNIC LETTER PERTHO PEORTH P;Lo;0;L;;;;;N;;;;;
16C9;RUNIC LETTER ALGIZ EOLHX;Lo;0;L;;;;;N;;;;;
16CA;RUNIC LETTER SOWILO S;Lo;0;L;;;;;N;;;;;
16CB;RUNIC LETTER SIGEL LONG-BRANCH-SOL S;Lo;0;L;;;;;N;;;;;
16CC;RUNIC LETTER SHORT-TWIG-SOL S;Lo;0;L;;;;;N;;;;;
16CD;RUNIC LETTER C;Lo;0;L;;;;;N;;;;;
16CE;RUNIC LETTER Z;Lo;0;L;;;;;N;;;;;
16CF;RUNIC LETTER TIWAZ TIR TYR T;Lo;0;L;;;;;N;;;;;
16D0;RUNIC LETTER SHORT-TWIG-TYR T;Lo;0;L;;;;;N;;;;;
16D1;RUNIC LETTER D;Lo;0;L;;;;;N;;;;;
16D2;RUNIC LETTER BERKANAN BEORC BJARKAN B;Lo;0;L;;;;;N;;;;;
16D3;RUNIC LETTER SHORT-TWIG-BJARKAN B;Lo;0;L;;;;;N;;;;;
16D4;RUNIC LETTER DOTTED-P;Lo;0;L;;;;;N;;;;;
16D5;RUNIC LETTER OPEN-P;Lo;0;L;;;;;N;;;;;
16D6;RUNIC LETTER EHWAZ EH E;Lo;0;L;;;;;N;;;;;
16D7;RUNIC LETTER MANNAZ MAN M;Lo;0;L;;;;;N;;;;;
16D8;RUNIC LETTER LONG-BRANCH-MADR M;Lo;0;L;;;;;N;;;;;
16D9;RUNIC LETTER SHORT-TWIG-MADR M;Lo;0;L;;;;;N;;;;;
16DA;RUNIC LETTER LAUKAZ LAGU LOGR L;Lo;0;L;;;;;N;;;;;
16DB;RUNIC LETTER DOTTED-L;Lo;0;L;;;;;N;;;;;
16DC;RUNIC LETTER INGWAZ;Lo;0;L;;;;;N;;;;;
16DD;RUNIC LETTER ING;Lo;0;L;;;;;N;;;;;
16DE;RUNIC LETTER DAGAZ DAEG D;Lo;0;L;;;;;N;;;;;
16DF;RUNIC LETTER OTHALAN ETHEL O;Lo;0;L;;;;;N;;;;;
16E0;RUNIC LETTER EAR;Lo;0;L;;;;;N;;;;;
16E1;RUNIC LETTER IOR;Lo;0;L;;;;;N;;;;;
16E2;RUNIC LETTER CWEORTH;Lo;0;L;;;;;N;;;;;
16E3;RUNIC LETTER CALC;Lo;0;L;;;;;N;;;;;
16E4;RUNIC LETTER CEALC;Lo;0;L;;;;;N;;;;;
16E5;RUNIC LETTER STAN;Lo;0;L;;;;;N;;;;;
16E6;RUNIC LETTER LONG-BRANCH-YR;Lo;0;L;;;;;N;;;;;
16E7;RUNIC LETTER SHORT-TWIG-YR;Lo;0;L;;;;;N;;;;;
16E8;RUNIC LETTER ICELANDIC-YR;Lo;0;L;;;;;N;;;;;
16E9;RUNIC LETTER Q;Lo;0;L;;;;;N;;;;;
16EA;RUNIC LETTER X;Lo;0;L;;;;;N;;;;;
16EB;RUNIC SINGLE PUNCTUATION;Po;0;L;;;;;N;;;;;
16EC;RUNIC MULTIPLE PUNCTUATION;Po;0;L;;;;;N;;;;;
16ED;RUNIC CROSS PUNCTUATION;Po;0;L;;;;;N;;;;;
16EE;RUNIC ARLAUG SYMBOL;Nl;0;L;;;;17;N;;;;;
16EF;RUNIC TVIMADUR SYMBOL;Nl;0;L;;;;18;N;;;;;
16F0;RUNIC BELGTHOR SYMBOL;Nl;0;L;;;;19;N;;;;;
16F1;RUNIC LETTER K;Lo;0;L;;;;;N;;;;;
16F2;RUNIC LETTER SH;Lo;0;L;;;;;N;;;;;
16F3;RUNIC LETTER OO;Lo;0;L;;;;;N;;;;;
16F4;RUNIC LETTER FRANKS CASKET OS;Lo;0;L;;;;;N;;;;;
16F5;RUNIC LETTER FRANKS CASKET IS;Lo;0;L;;;;;N;;;;;
16F6;RUNIC LETTER FRANKS CASKET EH;Lo;0;L;;;;;N;;;;;
16F7;RUNIC LETTER FRANKS CASKET AC;Lo;0;L;;;;;N;;;;;
16F8;RUNIC LETTER FRANKS CASKET AESC;Lo;0;L;;;;;N;;;;;
1700;TAGALOG LETTER A;Lo;0;L;;;;;N;;;;;
1701;TAGALOG LETTER I;Lo;0;L;;;;;N;;;;;
1702;TAGALOG LETTER U;Lo;0;L;;;;;N;;;;;
1703;TAGALOG LETTER KA;Lo;0;L;;;;;N;;;;;
1704;TAGALOG LETTER GA;Lo;0;L;;;;;N;;;;;
1705;TAGALOG LETTER NGA;Lo;0;L;;;;;N;;;;;
1706;TAGALOG LETTER TA;Lo;0;L;;;;;N;;;;;
1707;TAGALOG LETTER DA;Lo;0;L;;;;;N;;;;;
1708;TAGALOG LETTER NA;Lo;0;L;;;;;N;;;;;
1709;TAGALOG LETTER PA;Lo;0;L;;;;;N;;;;;
170A;TAGALOG LETTER BA;Lo;0;L;;;;;N;;;;;
170B;TAGALOG LETTER MA;Lo;0;L;;;;;N;;;;;
170C;TAGALOG LETTER YA;Lo;0;L;;;;;N;;;;;
170D;TAGALOG LETTER RA;Lo;0;L;;;;;N;;;;;
170E;TAGALOG LETTER LA;Lo;0;L;;;;;N;;;;;
170F;TAGALOG LETTER WA;Lo;0;L;;;;;N;;;;;
1710;TAGALOG LETTER SA;Lo;0;L;;;;;N;;;;;
1711;TAGALOG LETTER HA;Lo;0;L;;;;;N;;;;;
1712;TAGALOG VOWEL SIGN I;Mn;0;NSM;;;;;N;;;;;
1713;TAGALOG VOWEL SIGN U;Mn;0;NSM;;;;;N;;;;;
1714;TAGALOG SIGN VIRAMA;Mn;9;NSM;;;;;N;;;;;
1715;TAGALOG SIGN PAMUDPOD;Mc;9;L;;;;;N;;;;;
171F;TAGALOG LETTER ARCHAIC RA;Lo;0;L;;;;;N;;;;;
1720;HANUNOO LETTER A;Lo;0;L;;;;;N;;;;;
1721;HANUNOO LETTER I;Lo;0;L;;;;;N;;;;;
1722;HANUNOO LETTER U;Lo;0;L;;;;;N;;;;;
1723;HANUNOO LETTER KA;Lo;0;L;;;;;N;;;;;
1724;HANUNOO LETTER GA;Lo;0;L;;;;;N;;;;;
1725;HANUNOO LETTER NGA;Lo;0;L;;;;;N;;;;;
1726;HANUNOO LETTER TA;Lo;0;L;;;;;N;;;;;
1727;HANUNOO LETTER DA;Lo;0;L;;;;;N;;;;;
1728;HANUNOO LETTER NA;Lo;0;L;;;;;N;;;;;
1729;HANUNOO LETTER PA;Lo;0;L;;;;;N;;;;;
172A;HANUNOO LETTER BA;Lo;0;L;;;;;N;;;;;
172B;HANUNOO LETTER MA;Lo;0;L;;;;;N;;;;;
172C;HANUNOO LETTER YA;Lo;0;L;;;;;N;;;;;
172D;HANUNOO LETTER RA;Lo;0;L;;;;;N;;;;;
172E;HANUNOO LETTER LA;Lo;0;L;;;;;N;;;;;
172F;HANUNOO LETTER WA;Lo;0;L;;;;;N;;;;;
1730;HANUNOO LETTER SA;Lo;0;L;;;;;N;;;;;
1731;HANUNOO LETTER HA;Lo;0;L;;;;;N;;;;;
1732;HANUNOO VOWEL SIGN I;Mn;0;NSM;;;;;N;;;;;
1733;HANUNOO VOWEL SIGN U;Mn;0;NSM;;;;;N;;;;;
1734;HANUNOO SIGN PAMUDPOD;Mc;9;L;;;;;N;;;;;
1735;PHILIPPINE SINGLE PUNCTUATION;Po;0;L;;;;;N;;;;;
1736;PHILIPPINE DOUBLE PUNCTUATION;Po;0;L;;;;;N;;;;;
1740;BUHID LETTER A;Lo;0;L;;;;;N;;;;;
1741;BUHID LETTER I;Lo;0;L;;;;;N;;;;;
1742;BUHID LETTER U;Lo;0;L;;;;;N;;;;;
1743;BUHID LETTER KA;Lo;0;L;;;;;N;;;;;
1744;BUHID LETTER GA;Lo;0;L;;;;;N;;;;;
1745;BUHID LETTER NGA;Lo;0;L;;;;;N;;;;;
1746;BUHID LETTER TA;Lo;0;L;;;;;N;;;;;
1747;BUHID LETTER DA;Lo;0;L;;;;;N;;;;;
1748;BUHID LETTER NA;Lo;0;L;;;;;N;;;;;
1749;BUHID LETTER PA;Lo;0;L;;;;;N;;;;;
174A;BUHID LETTER BA;Lo;0;L;;;;;N;;;;;
174B;BUHID LETTER MA;Lo;0;L;;;;;N;;;;;
174C;BUHID LETTER YA;Lo;0;L;;;;;N;;;;;
174D;BUHID LETTER RA;Lo;0;L;;;;;N;;;;;
174E;BUHID LETTER LA;Lo;0;L;;;;;N;;;;;
174F;BUHID LETTER WA;Lo;0;L;;;;;N;;;;;
1750;BUHID LETTER SA;Lo;0;L;;;;;N;;;;;
1751;BUHID LETTER HA;Lo;0;L;;;;;N;;;;;
1752;BUHID VOWEL SIGN I;Mn;0;NSM;;;;;N;;;;;
1753;BUHID VOWEL SIGN U;Mn;0;NSM;;;;;N;;;;;
1760;TAGBANWA LETTER A;Lo;0;L;;;;;N;;;;;
1761;TAGBANWA LETTER I;Lo;0;L;;;;;N;;;;;
1762;TAGBANWA LETTER U;Lo;0;L;;;;;N;;;;;
1763;TAGBANWA LETTER KA;Lo;0;L;;;;;N;;;;;
1764;TAGBANWA LETTER GA;Lo;0;L;;;;;N;;;;;
1765;TAGBANWA LETTER NGA;Lo;0;L;;;;;N;;;;;
1766;TAGBANWA LETTER TA;Lo;0;L;;;;;N;;;;;
1767;TAGBANWA LETTER DA;Lo;0;L;;;;;N;;;;;
1768;TAGBANWA LETTER NA;Lo;0;L;;;;;N;;;;;
1769;TAGBANWA LETTER PA;Lo;0;L;;;;;N;;;;;
176A;TAGBANWA LETTER BA;Lo;0;L;;;;;N;;;;;
176B;TAGBANWA LETTER MA;Lo;0;L;;;;;N;;;;;
176C;TAGBANWA LETTER YA;Lo;0;L;;;;;N;;;;;
176E;TAGBANWA LETTER LA;Lo;0;L;;;;;N;;;;;
176F;TAGBANWA LETTER WA;Lo;0;L;;;;;N;;;;;
1770;TAGBANWA LETTER SA;Lo;0;L;;;;;N;;;;;
1772;TAGBANWA VOWEL SIGN I;Mn;0;NSM;;;;;N;;;;;
1773;TAGBANWA VOWEL SIGN U;Mn;0;NSM;;;;;N;;;;;
1780;KHMER LETTER KA;Lo;0;L;;;;;N;;;;;
1781;KHMER LETTER KHA;Lo;0;L;;;;;N;;;;;
1782;KHMER LETTER KO;Lo;0;L;;;;;N;;;;;
1783;KHMER LETTER KHO;Lo;0;L;;;;;N;;;;;
1784;KHMER LETTER NGO;Lo;0;L;;;;;N;;;;;
1785;KHMER LETTER CA;Lo;0;L;;;;;N;;;;;
1786;KHMER LETTER CHA;Lo;0;L;;;;;N;;;;;
1787;KHMER LETTER CO;Lo;0;L;;;;;N;;;;;
1788;KHMER LETTER CHO;Lo;0;L;;;;;N;;;;;
1789;KHMER LETTER NYO;Lo;0;L;;;;;N;;;;;
178A;KHMER LETTER DA;Lo;0;L;;;;;N;;;;;
178B;KHMER LETTER TTHA;Lo;0;L;;;;;N;;;;;
178C;KHMER LETTER DO;Lo;0;L;;;;;N;;;;;
178D;KHMER LETTER TTHO;Lo;0;L;;;;;N;;;;;
178E;KHMER LETTER NNO;Lo;0;L;;;;;N;;;;;
178F;KHMER LETTER TA;Lo;0;L;;;;;N;;;;;
1790;KHMER LETTER THA;Lo;0;L;;;;;N;;;;;
1791;KHMER LETTER TO;Lo;0;L;;;;;N;;;;;
1792;KHMER LETTER THO;Lo;0;L;;;;;N;;;;;
1793;KHMER LETTER NO;Lo;0;L;;;;;N;;;;;
1794;KHMER LETTER BA;Lo;0;L;;;;;N;;;;;
1795;KHMER LETTER PHA;Lo;0;L;;;;;N;;;;;
1796;KHMER LETTER PO;Lo;0;L;;;;;N;;;;;
1797;KHMER LETTER PHO;Lo;0;L;;;;;N;;;;;
1798;KHMER LETTER MO;Lo;0;L;;;;;N;;;;;
1799;KHMER LETTER YO;Lo;0;L;;;;;N;;;;;
179A;KHMER LETTER RO;Lo;0;L;;;;;N;;;;;
179B;KHMER LETTER LO;Lo;0;L;;;;;N;;;;;
179C;KHMER LETTER VO;Lo;0;L;;;;;N;;;;;
179D;KHMER LETTER SHA;Lo;0;L;;;;;N;;;;;
179E;KHMER LETTER SSO;Lo;0;L;;;;;N;;;;;
179F;KHMER LETTER SA;Lo;0;L;;;;;N;;;;;
17A0;KHMER LETTER HA;Lo;0;L;;;;;N;;;;;
17A1;KHMER LETTER LA;Lo;0;L;;;;;N;;;;;
17A2;KHMER LETTER QA;Lo;0;L;;;;;N;;;;;
17A3;KHMER INDEPENDENT VOWEL QAQ;Lo;0;L;;;;;N;;;;;
17A4;KHMER INDEPENDENT VOWEL QAA;Lo;0;L;;;;;N;;;;;
17A5;KHMER INDEPENDENT VOWEL QI;Lo;0;L;;;;;N;;;;;
17A6;KHMER INDEPENDENT VOWEL QII;Lo;0;L;;;;;N;;;;;
17A7;KHMER INDEPENDENT VOWEL QU;Lo;0;L;;;;;N;;;;;
17A8;KHMER INDEPENDENT VOWEL QUK;Lo;0;L;;;;;N;;;;;
17A9;KHMER INDEPENDENT VOWEL QUU;Lo;0;L;;;;;N;;;;;
17AA;KHMER INDEPENDENT VOWEL QUUV;Lo;0;L;;;;;N;;;;;
17AB;KHMER INDEPENDENT VOWEL RY;Lo;0;L;;;;;N;;;;;
17AC;KHMER INDEPENDENT VOWEL RYY;Lo;0;L;;;;;N;;;;;
17AD;KHMER INDEPENDENT VOWEL LY;Lo;0;L;;;;;N;;;;;
17AE;KHMER INDEPENDENT VOWEL LYY;Lo;0;L;;;;;N;;;;;
17AF;KHMER INDEPENDENT VOWEL QE;Lo;0;L;;;;;N;;;;;
17B0;KHMER INDEPENDENT VOWEL QAI;Lo;0;L;;;;;N;;;;;
17B1;KHMER INDEPENDENT VOWEL QOO TYPE ONE;Lo;0;L;;;;;N;;;;;
17B2;KHMER INDEPENDENT VOWEL QOO TYPE TWO;Lo;0;L;;;;;N;;;;;
17B3;KHMER INDEPENDENT VOWEL QAU;Lo;0;L;;;;;N;;;;;
17B4;KHMER VOWEL INHERENT AQ;Mn;0;NSM;;;;;N;;;;;
17B5;KHMER VOWEL INHERENT AA;Mn;0;NSM;;;;;N;;;;;
17B6;KHMER VOWEL SIGN AA;Mc;0;L;;;;;N;;;;;
17B7;KHMER VOWEL SIGN I;Mn;0;NSM;;;;;N;;;;;
17B8;KHMER VOWEL SIGN II;Mn;0;NSM;;;;;N;;;;;
17B9;KHMER VOWEL SIGN Y;Mn;0;NSM;;;;;N;;;;;
17BA;KHMER VOWEL SIGN YY;Mn;0;NSM;;;;;N;;;;;
17BB;KHMER VOWEL SIGN U;Mn;0;NSM;;;;;N;;;;;
17BC;KHMER VOWEL SIGN UU;Mn;0;NSM;;;;;N;;;;;
17BD;KHMER VOWEL SIGN UA;Mn;0;NSM;;;;;N;;;;;
17BE;KHMER VOWEL SIGN OE;Mc;0;L;;;;;N;;;;;
17BF;KHMER VOWEL SIGN YA;Mc;0;L;;;;;N;;;;;
17C0;KHMER VOWEL SIGN IE;Mc;0;L;;;;;N;;;;;
17C1;KHMER VOWEL SIGN E;Mc;0;L;;;;;N;;;;;
17C2;KHMER VOWEL SIGN AE;Mc;0;L;;;;;N;;;;;
17C3;KHMER VOWEL SIGN AI;Mc;0;L;;;;;N;;;;;
17C4;KHMER VOWEL SIGN OO;Mc;0;L;;;;;N;;;;;
17C5;KHMER VOWEL SIGN AU;Mc;0;L;;;;;N;;;;;
17C6;KHMER SIGN NIKAHIT;Mn;0;NSM;;;;;N;;;;;
17C7;KHMER SIGN REAHMUK;Mc;0;L;;;;;N;;;;;
17C8;KHMER SIGN YUUKALEAPINTU;Mc;0;L;;;;;N;;;;;
17C9;KHMER SIGN MUUSIKATOAN;Mn;0;NSM;;;;;N;;;;;
17CA;KHMER SIGN TRIISAP;Mn;0;NSM;;;;;N;;;;;
17CB;KHMER SIGN BANTOC;Mn;0;NSM;;;;;N;;;;;
17CC;KHMER SIGN ROBAT;Mn;0;NSM;;;;;N;;;;;
17CD;KHMER SIGN TOANDAKHIAT;Mn;0;NSM;;;;;N;;;;;
17CE;KHMER SIGN KAKABAT;Mn;0;NSM;;;;;N;;;;;
17CF;KHMER SIGN AHSDA;Mn;0;NSM;;;;;N;;;;;
17D0;KHMER SIGN SAMYOK SANNYA;Mn;0;NSM;;;;;N;;;;;
17D1;KHMER SIGN VIRIAM;Mn;0;NSM;;;;;N;;;;;
17D2;KHMER SIGN COENG;Mn;9;NSM;;;;;N;;;;;
17D3;KHMER SIGN BATHAMASAT;Mn;0;NSM;;;;;N;;;;;
17D4;KHMER SIGN KHAN;Po;0;L;;;;;N;;;;;
17D5;KHMER SIGN BARIYOOSAN;Po;0;L;;;;;N;;;;;
17D6;KHMER SIGN CAMNUC PII KUUH;Po;0;L;;;;;N;;;;;
17D7;KHMER SIGN LEK TOO;Lm;0;L;;;;;N;;;;;
17D8;KHMER SIGN BEYYAL;Po;0;L;;;;;N;;;;;
17D9;KHMER SIGN PHNAEK MUAN;Po;0;L;;;;;N;;;;;
17DA;KHMER SIGN KOOMUUT;Po;0;L;;;;;N;;;;;
17DB;KHMER CURRENCY SYMBOL RIEL;Sc;0;ET;;;;;N;;;;;
17DC;KHMER SIGN AVAKRAHASANYA;Lo;0;L;;;;;N;;;;;
17DD;KHMER SIGN ATTHACAN;Mn;230;NSM;;;;;N;;;;;
17E0;KHMER DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
17E1;KHMER DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
17E2;KHMER DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
17E3;KHMER DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
17E4;KHMER DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
17E5;KHMER DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
17E6;KHMER DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
17E7;KHMER DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
17E8;KHMER DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
17E9;KHMER DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
17F0;KHMER SYMBOL LEK ATTAK SON;No;0;ON;;;;0;N;;;;;
17F1;KHMER SYMBOL LEK ATTAK MUOY;No;0;ON;;;;1;N;;;;;
17F2;KHMER SYMBOL LEK ATTAK PII;No;0;ON;;;;2;N;;;;;
17F3;KHMER SYMBOL LEK ATTAK BEI;No;0;ON;;;;3;N;;;;;
17F4;KHMER SYMBOL LEK ATTAK BUON;No;0;ON;;;;4;N;;;;;
17F5;KHMER SYMBOL LEK ATTAK PRAM;No;0;ON;;;;5;N;;;;;
17F6;KHMER SYMBOL LEK ATTAK PRAM-MUOY;No;0;ON;;;;6;N;;;;;
17F7;KHMER SYMBOL LEK ATTAK PRAM-PII;No;0;ON;;;;7;N;;;;;
17F8;KHMER SYMBOL LEK ATTAK PRAM-BEI;No;0;ON;;;;8;N;;;;;
17F9;KHMER SYMBOL LEK ATTAK PRAM-BUON;No;0;ON;;;;9;N;;;;;
1800;MONGOLIAN BIRGA;Po;0;ON;;;;;N;;;;;
1801;MONGOLIAN ELLIPSIS;Po;0;ON;;;;;N;;;;;
1802;MONGOLIAN COMMA;Po;0;ON;;;;;N;;;;;
1803;MONGOLIAN FULL STOP;Po;0;ON;;;;;N;;;;;
1804;MONGOLIAN COLON;Po;0;ON;;;;;N;;;;;
1805;MONGOLIAN FOUR DOTS;Po;0;ON;;;;;N;;;;;
1806;MONGOLIAN TODO SOFT HYPHEN;Pd;0;ON;;;;;N;;;;;
1807;MONGOLIAN SIBE SYLLABLE BOUNDARY MARKER;Po;0;ON;;;;;N;;;;;
1808;MONGOLIAN MANCHU COMMA;Po;0;ON;;;;;N;;;;;
1809;MONGOLIAN MANCHU FULL STOP;Po;0;ON;;;;;N;;;;;
180A;MONGOLIAN NIRUGU;Po;0;ON;;;;;N;;;;;
180B;MONGOLIAN FREE VARIATION SELECTOR ONE;Mn;0;NSM;;;;;N;;;;;
180C;MONGOLIAN FREE VARIATION SELECTOR TWO;Mn;0;NSM;;;;;N;;;;;
180D;MONGOLIAN FREE VARIATION SELECTOR THREE;Mn;0;NSM;;;;;N;;;;;
180E;MONGOLIAN VOWEL SEPARATOR;Cf;0;BN;;;;;N;;;;;
180F;MONGOLIAN FREE VARIATION SELECTOR FOUR;Mn;0;NSM;;;;;N;;;;;
1810;MONGOLIAN DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
1811;MONGOLIAN DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
1812;MONGOLIAN DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
1813;MONGOLIAN DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
1814;MONGOLIAN DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
1815;MONGOLIAN DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
1816;MONGOLIAN DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
1817;MONGOLIAN DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
1818;MONGOLIAN DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
1819;MONGOLIAN DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
1820;MONGOLIAN LETTER A;Lo;0;L;;;;;N;;;;;
1821;MONGOLIAN LETTER E;Lo;0;L;;;;;N;;;;;
1822;MONGOLIAN LETTER I;Lo;0;L;;;;;N;;;;;
1823;MONGOLIAN LETTER O;Lo;0;L;;;;;N;;;;;
1824;MONGOLIAN LETTER U;Lo;0;L;;;;;N;;;;;
1825;MONGOLIAN LETTER OE;Lo;0;L;;;;;N;;;;;
1826;MONGOLIAN LETTER UE;Lo;0;L;;;;;N;;;;;
1827;MONGOLIAN LETTER EE;Lo;0;L;;;;;N;;;;;
1828;MONGOLIAN LETTER NA;Lo;0;L;;;;;N;;;;;
1829;MONGOLIAN LETTER ANG;Lo;0;L;;;;;N;;;;;
182A;MONGOLIAN LETTER BA;Lo;0;L;;;;;N;;;;;
182B;MONGOLIAN LETTER PA;Lo;0;L;;;;;N;;;;;
182C;MONGOLIAN LETTER QA;Lo;0;L;;;;;N;;;;;
182D;MONGOLIAN LETTER GA;Lo;0;L;;;;;N;;;;;
182E;MONGOLIAN LETTER MA;Lo;0;L;;;;;N;;;;;
182F;MONGOLIAN LETTER LA;Lo;0;L;;;;;N;;;;;
1830;MONGOLIAN LETTER SA;Lo;0;L;;;;;N;;;;;
1831;MONGOLIAN LETTER SHA;Lo;0;L;;;;;N;;;;;
1832;MONGOLIAN LETTER TA;Lo;0;L;;;;;N;;;;;
1833;MONGOLIAN LETTER DA;Lo;0;L;;;;;N;;;;;
1834;MONGOLIAN LETTER CHA;Lo;0;L;;;;;N;;;;;
1835;MONGOLIAN LETTER JA;Lo;0;L;;;;;N;;;;;
1836;MONGOLIAN LETTER YA;Lo;0;L;;;;;N;;;;;
1837;MONGOLIAN LETTER RA;Lo;0;L;;;;;N;;;;;
1838;MONGOLIAN LETTER WA;Lo;0;L;;;;;N;;;;;
1839;MONGOLIAN LETTER FA;Lo;0;L;;;;;N;;;;;
183A;MONGOLIAN LETTER KA;Lo;0;L;;;;;N;;;;;
183B;MONGOLIAN LETTER KHA;Lo;0;L;;;;;N;;;;;
183C;MONGOLIAN LETTER TSA;Lo;0;L;;;;;N;;;;;
183D;MONGOLIAN LETTER ZA;Lo;0;L;;;;;N;;;;;
183E;MONGOLIAN LETTER HAA;Lo;0;L;;;;;N;;;;;
183F;MONGOLIAN LETTER ZRA;Lo;0;L;;;;;N;;;;;
1840;MONGOLIAN LETTER LHA;Lo;0;L;;;;;N;;;;;
1841;MONGOLIAN LETTER ZHI;Lo;0;L;;;;;N;;;;;
1842;MONGOLIAN LETTER CHI;Lo;0;L;;;;;N;;;;;
1843;MONGOLIAN LETTER TODO LONG VOWEL SIGN;Lm;0;L;;;;;N;;;;;
1844;MONGOLIAN LETTER TODO E;Lo;0;L;;;;;N;;;;;
1845;MONGOLIAN LETTER TODO I;Lo;0;L;;;;;N;;;;;
1846;MONGOLIAN LETTER TODO O;Lo;0;L;;;;;N;;;;;
1847;MONGOLIAN LETTER TODO U;Lo;0;L;;;;;N;;;;;
1848;MONGOLIAN LETTER TODO OE;Lo;0;L;;;;;N;;;;;
1849;MONGOLIAN LETTER TODO UE;Lo;0;L;;;;;N;;;;;
184A;MONGOLIAN LETTER TODO ANG;Lo;0;L;;;;;N;;;;;
184B;MONGOLIAN LETTER TODO BA;Lo;0;L;;;;;N;;;;;
184C;MONGOLIAN LETTER TODO PA;Lo;0;L;;;;;N;;;;;
184D;MONGOLIAN LETTER TODO QA;Lo;0;L;;;;;N;;;;;
184E;MONGOLIAN LETTER TODO GA;Lo;0;L;;;;;N;;;;;
184F;MONGOLIAN LETTER TODO MA;Lo;0;L;;;;;N;;;;;
1850;MONGOLIAN LETTER TODO TA;Lo;0;L;;;;;N;;;;;
1851;MONGOLIAN LETTER TODO DA;Lo;0;L;;;;;N;;;;;
1852;MONGOLIAN LETTER TODO CHA;Lo;0;L;;;;;N;;;;;
1853;MONGOLIAN LETTER TODO JA;Lo;0;L;;;;;N;;;;;
1854;MONGOLIAN LETTER TODO TSA;Lo;0;L;;;;;N;;;;;
1855;MONGOLIAN LETTER TODO YA;Lo;0;L;;;;;N;;;;;
1856;MONGOLIAN LETTER TODO WA;Lo;0;L;;;;;N;;;;;
1857;MONGOLIAN LETTER TODO KA;Lo;0;L;;;;;N;;;;;
1858;MONGOLIAN LETTER TODO GAA;Lo;0;L;;;;;N;;;;;
1859;MONGOLIAN LETTER TODO HAA;Lo;0;L;;;;;N;;;;;
185A;MONGOLIAN LETTER TODO JIA;Lo;0;L;;;;;N;;;;;
185B;MONGOLIAN LETTER TODO NIA;Lo;0;L;;;;;N;;;;;
185C;MONGOLIAN LETTER TODO DZA;Lo;0;L;;;;;N;;;;;
185D;MONGOLIAN LETTER SIBE E;Lo;0;L;;;;;N;;;;;
185E;MONGOLIAN LETTER SIBE I;Lo;0;L;;;;;N;;;;;
185F;MONGOLIAN LETTER SIBE IY;Lo;0;L;;;;;N;;;;;
1860;MONGOLIAN LETTER SIBE UE;Lo;0;L;;;;;N;;;;;
1861;MONGOLIAN LETTER SIBE U;Lo;0;L;;;;;N;;;;;
1862;MONGOLIAN LETTER SIBE ANG;Lo;0;L;;;;;N;;;;;
1863;MONGOLIAN LETTER SIBE KA;Lo;0;L;;;;;N;;;;;
1864;MONGOLIAN LETTER SIBE GA;Lo;0;L;;;;;N;;;;;
1865;MONGOLIAN LETTER SIBE HA;Lo;0;L;;;;;N;;;;;
1866;MONGOLIAN LETTER SIBE PA;Lo;0;L;;;;;N;;;;;
1867;MONGOLIAN LETTER SIBE SHA;Lo;0;L;;;;;N;;;;;
1868;MONGOLIAN LETTER SIBE TA;Lo;0;L;;;;;N;;;;;
1869;MONGOLIAN LETTER SIBE DA;Lo;0;L;;;;;N;;;;;
186A;MONGOLIAN LETTER SIBE JA;Lo;0;L;;;;;N;;;;;
186B;MONGOLIAN LETTER SIBE FA;Lo;0;L;;;;;N;;;;;
186C;MONGOLIAN LETTER SIBE GAA;Lo;0;L;;;;;N;;;;;
186D;MONGOLIAN LETTER SIBE HAA;Lo;0;L;;;;;N;;;;;
186E;MONGOLIAN LETTER SIBE TSA;Lo;0;L;;;;;N;;;;;
186F;MONGOLIAN LETTER SIBE ZA;Lo;0;L;;;;;N;;;;;
1870;MONGOLIAN LETTER SIBE RAA;Lo;0;L;;;;;N;;;;;
1871;MONGOLIAN LETTER SIBE CHA;Lo;0;L;;;;;N;;;;;
1872;MONGOLIAN LETTER SIBE ZHA;Lo;0;L;;;;;N;;;;;
1873;MONGOLIAN LETTER MANCHU I;Lo;0;L;;;;;N;;;;;
1874;MONGOLIAN LETTER MANCHU KA;Lo;0;L;;;;;N;;;;;
1875;MONGOLIAN LETTER MANCHU RA;Lo;0;L;;;;;N;;;;;
1876;MONGOLIAN LETTER MANCHU FA;Lo;0;L;;;;;N;;;;;
1877;MONGOLIAN LETTER MANCHU ZHA;Lo;0;L;;;;;N;;;;;
1878;MONGOLIAN LETTER CHA WITH TWO DOTS;Lo;0;L;;;;;N;;;;;
1880;MONGOLIAN LETTER ALI GALI ANUSVARA ONE;Lo;0;L;;;;;N;;;;;
1881;MONGOLIAN LETTER ALI GALI VISARGA ONE;Lo;0;L;;;;;N;;;;;
1882;MONGOLIAN LETTER ALI GALI DAMARU;Lo;0;L;;;;;N;;;;;
1883;MONGOLIAN LETTER ALI GALI UBADAMA;Lo;0;L;;;;;N;;;;;
1884;MONGOLIAN LETTER ALI GALI INVERTED UBADAMA;Lo;0;L;;;;;N;;;;;
1885;MONGOLIAN LETTER ALI GALI BALUDA;Mn;0;NSM;;;;;N;;;;;
1886;MONGOLIAN LETTER ALI GALI THREE BALUDA;Mn;0;NSM;;;;;N;;;;;
1887;MONGOLIAN LETTER ALI GALI A;Lo;0;L;;;;;N;;;;;
1888;MONGOLIAN LETTER ALI GALI I;Lo;0;L;;;;;N;;;;;
1889;MONGOLIAN LETTER ALI GALI KA;Lo;0;L;;;;;N;;;;;
188A;MONGOLIAN LETTER ALI GALI NGA;Lo;0;L;;;;;N;;;;;
188B;MONGOLIAN LETTER ALI GALI CA;Lo;0;L;;;;;N;;;;;
188C;MONGOLIAN LETTER ALI GALI TTA;Lo;0;L;;;;;N;;;;;
188D;MONGOLIAN LETTER ALI GALI TTHA;Lo;0;L;;;;;N;;;;;
188E;MONGOLIAN LETTER ALI GALI DDA;Lo;0;L;;;;;N;;;;;
188F;MONGOLIAN LETTER ALI GALI NNA;Lo;0;L;;;;;N;;;;;
1890;MONGOLIAN LETTER ALI GALI TA;Lo;0;L;;;;;N;;;;;
1891;MONGOLIAN LETTER ALI GALI DA;Lo;0;L;;;;;N;;;;;
1892;MONGOLIAN LETTER ALI GALI PA;Lo;0;L;;;;;N;;;;;
1893;MONGOLIAN LETTER ALI GALI PHA;Lo;0;L;;;;;N;;;;;
1894;MONGOLIAN LETTER ALI GALI SSA;Lo;0;L;;;;;N;;;;;
1895;MONGOLIAN LETTER ALI GALI ZHA;Lo;0;L;;;;;N;;;;;
1896;MONGOLIAN LETTER ALI GALI ZA;Lo;0;L;;;;;N;;;;;
1897;MONGOLIAN LETTER ALI GALI AH;Lo;0;L;;;;;N;;;;;
1898;MONGOLIAN LETTER TODO ALI GALI TA;Lo;0;L;;;;;N;;;;;
1899;MONGOLIAN LETTER TODO ALI GALI ZHA;Lo;0;L;;;;;N;;;;;
189A;MONGOLIAN LETTER MANCHU ALI GALI GHA;Lo;0;L;;;;;N;;;;;
189B;MONGOLIAN LETTER MANCHU ALI GALI NGA;Lo;0;L;;;;;N;;;;;
189C;MONGOLIAN LETTER MANCHU ALI GALI CA;Lo;0;L;;;;;N;;;;;
189D;MONGOLIAN LETTER MANCHU ALI GALI JHA;Lo;0;L;;;;;N;;;;;
189E;MONGOLIAN LETTER MANCHU ALI GALI TTA;Lo;0;L;;;;;N;;;;;
189F;MONGOLIAN LETTER MANCHU ALI GALI DDHA;Lo;0;L;;;;;N;;;;;
18A0;MONGOLIAN LETTER MANCHU ALI GALI TA;Lo;0;L;;;;;N;;;;;
18A1;MONGOLIAN LETTER MANCHU ALI GALI DHA;Lo;0;L;;;;;N;;;;;
18A2;MONGOLIAN LETTER MANCHU ALI GALI SSA;Lo;0;L;;;;;N;;;;;
18A3;MONGOLIAN LETTER MANCHU ALI GALI CYA;Lo;0;L;;;;;N;;;;;
18A4;MONGOLIAN LETTER MANCHU ALI GALI ZHA;Lo;0;L;;;;;N;;;;;
18A5;MONGOLIAN LETTER MANCHU ALI GALI ZA;Lo;0;L;;;;;N;;;;;
18A6;MONGOLIAN LETTER ALI GALI HALF U;Lo;0;L;;;;;N;;;;;
18A7;MONGOLIAN LETTER ALI GALI HALF YA;Lo;0;L;;;;;N;;;;;
18A8;MONGOLIAN LETTER MANCHU ALI GALI BHA;Lo;0;L;;;;;N;;;;;
18A9;MONGOLIAN LETTER ALI GALI DAGALGA;Mn;228;NSM;;;;;N;;;;;
18AA;MONGOLIAN LETTER MANCHU ALI GALI LHA;Lo;0;L;;;;;N;;;;;
18B0;CANADIAN SYLLABICS OY;Lo;0;L;;;;;N;;;;;
18B1;CANADIAN SYLLABICS AY;Lo;0;L;;;;;N;;;;;
18B2;CANADIAN SYLLABICS AAY;Lo;0;L;;;;;N;;;;;
18B3;CANADIAN SYLLABICS WAY;Lo;0;L;;;;;N;;;;;
18B4;CANADIAN SYLLABICS POY;Lo;0;L;;;;;N;;;;;
18B5;CANADIAN SYLLABICS PAY;Lo;0;L;;;;;N;;;;;
18B6;CANADIAN SYLLABICS PWOY;Lo;0;L;;;;;N;;;;;
18B7;CANADIAN SYLLABICS TAY;Lo;0;L;;;;;N;;;;;
18B8;CANADIAN SYLLABICS KAY;Lo;0;L;;;;;N;;;;;
18B9;CANADIAN SYLLABICS KWAY;Lo;0;L;;;;;N;;;;;
18BA;CANADIAN SYLLABICS MAY;Lo;0;L;;;;;N;;;;;
18BB;CANADIAN SYLLABICS NOY;Lo;0;L;;;;;N;;;;;
18BC;CANADIAN SYLLABICS NAY;Lo;0;L;;;;;N;;;;;
18BD;CANADIAN SYLLABICS LAY;Lo;0;L;;;;;N;;;;;
18BE;CANADIAN SYLLABICS SOY;Lo;0;L;;;;;N;;;;;
18BF;CANADIAN SYLLABICS SAY;Lo;0;L;;;;;N;;;;;
18C0;CANADIAN SYLLABICS SHOY;Lo;0;L;;;;;N;;;;;
18C1;CANADIAN SYLLABICS SHAY;Lo;0;L;;;;;N;;;;;
18C2;CANADIAN SYLLABICS SHWOY;Lo;0;L;;;;;N;;;;;
18C3;CANADIAN SYLLABICS YOY;Lo;0;L;;;;;N;;;;;
18C4;CANADIAN SYLLABICS YAY;Lo;0;L;;;;;N;;;;;
18C5;CANADIAN SYLLABICS RAY;Lo;0;L;;;;;N;;;;;
18C6;CANADIAN SYLLABICS NWI;Lo;0;L;;;;;N;;;;;
18C7;CANADIAN SYLLABICS OJIBWAY NWI;Lo;0;L;;;;;N;;;;;
18C8;CANADIAN SYLLABICS NWII;Lo;0;L;;;;;N;;;;;
18C9;CANADIAN SYLLABICS OJIBWAY NWII;Lo;0;L;;;;;N;;;;;
18CA;CANADIAN SYLLABICS NWO;Lo;0;L;;;;;N;;;;;
18CB;CANADIAN SYLLABICS OJIBWAY NWO;Lo;0;L;;;;;N;;;;;
18CC;CANADIAN SYLLABICS NWOO;Lo;0;L;;;;;N;;;;;
18CD;CANADIAN SYLLABICS OJIBWAY NWOO;Lo;0;L;;;;;N;;;;;
18CE;CANADIAN SYLLABICS RWEE;Lo;0;L;;;;;N;;;;;
18CF;CANADIAN SYLLABICS RWI;Lo;0;L;;;;;N;;;;;
18D0;CANADIAN SYLLABICS RWII;Lo;0;L;;;;;N;;;;;
18D1;CANADIAN SYLLABICS RWO;Lo;0;L;;;;;N;;;;;
18D2;CANADIAN SYLLABICS RWOO;Lo;0;L;;;;;N;;;;;
18D3;CANADIAN SYLLABICS RWA;Lo;0;L;;;;;N;;;;;
18D4;CANADIAN SYLLABICS OJIBWAY P;Lo;0;L;;;;;N;;;;;
18D5;CANADIAN SYLLABICS OJIBWAY T;Lo;0;L;;;;;N;;;;;
18D6;CANADIAN SYLLABICS OJIBWAY K;Lo;0;L;;;;;N;;;;;
18D7;CANADIAN SYLLABICS OJIBWAY C;Lo;0;L;;;;;N;;;;;
18D8;CANADIAN SYLLABICS OJIBWAY M;Lo;0;L;;;;;N;;;;;
18D9;CANADIAN SYLLABICS OJIBWAY N;Lo;0;L;;;;;N;;;;;
18DA;CANADIAN SYLLABICS OJIBWAY S;Lo;0;L;;;;;N;;;;;
18DB;CANADIAN SYLLABICS OJIBWAY SH;Lo;0;L;;;;;N;;;;;
18DC;CANADIAN SYLLABICS EASTERN W;Lo;0;L;;;;;N;;;;;
18DD;CANADIAN SYLLABICS WESTERN W;Lo;0;L;;;;;N;;;;;
18DE;CANADIAN SYLLABICS FINAL SMALL RING;Lo;0;L;;;;;N;;;;;
18DF;CANADIAN SYLLABICS FINAL RAISED DOT;Lo;0;L;;;;;N;;;;;
18E0;CANADIAN SYLLABICS R-CREE RWE;Lo;0;L;;;;;N;;;;;
18E1;CANADIAN SYLLABICS WEST-CREE LOO;Lo;0;L;;;;;N;;;;;
18E2;CANADIAN SYLLABICS WEST-CREE LAA;Lo;0;L;;;;;N;;;;;
18E3;CANADIAN SYLLABICS THWE;Lo;0;L;;;;;N;;;;;
18E4;CANADIAN SYLLABICS THWA;Lo;0;L;;;;;N;;;;;
18E5;CANADIAN SYLLABICS TTHWE;Lo;0;L;;;;;N;;;;;
18E6;CANADIAN SYLLABICS TTHOO;Lo;0;L;;;;;N;;;;;
18E7;CANADIAN SYLLABICS TTHAA;Lo;0;L;;;;;N;;;;;
18E8;CANADIAN SYLLABICS TLHWE;Lo;0;L;;;;;N;;;;;
18E9;CANADIAN SYLLABICS TLHOO;Lo;0;L;;;;;N;;;;;
18EA;CANADIAN SYLLABICS SAYISI SHWE;Lo;0;L;;;;;N;;;;;
18EB;CANADIAN SYLLABICS SAYISI SHOO;Lo;0;L;;;;;N;;;;;
18EC;CANADIAN SYLLABICS SAYISI HOO;Lo;0;L;;;;;N;;;;;
18ED;CANADIAN SYLLABICS CARRIER GWU;Lo;0;L;;;;;N;;;;;
18EE;CANADIAN SYLLABICS CARRIER DENE GEE;Lo;0;L;;;;;N;;;;;
18EF;CANADIAN SYLLABICS CARRIER GAA;Lo;0;L;;;;;N;;;;;
18F0;CANADIAN SYLLABICS CARRIER GWA;Lo;0;L;;;;;N;;;;;
18F1;CANADIAN SYLLABICS SAYISI JUU;Lo;0;L;;;;;N;;;;;
18F2;CANADIAN SYLLABICS CARRIER JWA;Lo;0;L;;;;;N;;;;;
18F3;CANADIAN SYLLABICS BEAVER DENE L;Lo;0;L;;;;;N;;;;;
18F4;CANADIAN SYLLABICS BEAVER DENE R;Lo;0;L;;;;;N;;;;;
18F5;CANADIAN SYLLABICS CARRIER DENTAL S;Lo;0;L;;;;;N;;;;;
1900;LIMBU VOWEL-CARRIER LETTER;Lo;0;L;;;;;N;;;;;
1901;LIMBU LETTER KA;Lo;0;L;;;;;N;;;;;
1902;LIMBU LETTER KHA;Lo;0;L;;;;;N;;;;;
1903;LIMBU LETTER GA;Lo;0;L;;;;;N;;;;;
1904;LIMBU LETTER GHA;Lo;0;L;;;;;N;;;;;
1905;LIMBU LETTER NGA;Lo;0;L;;;;;N;;;;;
1906;LIMBU LETTER CA;Lo;0;L;;;;;N;;;;;
1907;LIMBU LETTER CHA;Lo;0;L;;;;;N;;;;;
1908;LIMBU LETTER JA;Lo;0;L;;;;;N;;;;;
1909;LIMBU LETTER JHA;Lo;0;L;;;;;N;;;;;
190A;LIMBU LETTER YAN;Lo;0;L;;;;;N;;;;;
190B;LIMBU LETTER TA;Lo;0;L;;;;;N;;;;;
190C;LIMBU LETTER THA;Lo;0;L;;;;;N;;;;;
190D;LIMBU LETTER DA;Lo;0;L;;;;;N;;;;;
190E;LIMBU LETTER DHA;Lo;0;L;;;;;N;;;;;
190F;LIMBU LETTER NA;Lo;0;L;;;;;N;;;;;
1910;LIMBU LETTER PA;Lo;0;L;;;;;N;;;;;
1911;LIMBU LETTER PHA;Lo;0;L;;;;;N;;;;;
1912;LIMBU LETTER BA;Lo;0;L;;;;;N;;;;;
1913;LIMBU LETTER BHA;Lo;0;L;;;;;N;;;;;
1914;LIMBU LETTER MA;Lo;0;L;;;;;N;;;;;
1915;LIMBU LETTER YA;Lo;0;L;;;;;N;;;;;
1916;LIMBU LETTER RA;Lo;0;L;;;;;N;;;;;
1917;LIMBU LETTER LA;Lo;0;L;;;;;N;;;;;
1918;LIMBU LETTER WA;Lo;0;L;;;;;N;;;;;
1919;LIMBU LETTER SHA;Lo;0;L;;;;;N;;;;;
191A;LIMBU LETTER SSA;Lo;0;L;;;;;N;;;;;
191B;LIMBU LETTER SA;Lo;0;L;;;;;N;;;;;
191C;LIMBU LETTER HA;Lo;0;L;;;;;N;;;;;
191D;LIMBU LETTER GYAN;Lo;0;L;;;;;N;;;;;
191E;LIMBU LETTER TRA;Lo;0;L;;;;;N;;;;;
1920;LIMBU VOWEL SIGN A;Mn;0;NSM;;;;;N;;;;;
1921;LIMBU VOWEL SIGN I;Mn;0;NSM;;;;;N;;;;;
1922;LIMBU VOWEL SIGN U;Mn;0;NSM;;;;;N;;;;;
1923;LIMBU VOWEL SIGN EE;Mc;0;L;;;;;N;;;;;
1924;LIMBU VOWEL SIGN AI;Mc;0;L;;;;;N;;;;;
1925;LIMBU VOWEL SIGN OO;Mc;0;L;;;;;N;;;;;
1926;LIMBU VOWEL SIGN AU;Mc;0;L;;;;;N;;;;;
1927;LIMBU VOWEL SIGN E;Mn;0;NSM;;;;;N;;;;;
1928;LIMBU VOWEL SIGN O;Mn;0;NSM;;;;;N;;;;;
1929;LIMBU SUBJOINED LETTER YA;Mc;0;L;;;;;N;;;;;
192A;LIMBU SUBJOINED LETTER RA;Mc;0;L;;;;;N;;;;;
192B;LIMBU SUBJOINED LETTER WA;Mc;0;L;;;;;N;;;;;
1930;LIMBU SMALL LETTER KA;Mc;0;L;;;;;N;;;;;
1931;LIMBU SMALL LETTER NGA;Mc;0;L;;;;;N;;;;;
1932;LIMBU SMALL LETTER ANUSVARA;Mn;0;NSM;;;;;N;;;;;
1933;LIMBU SMALL LETTER TA;Mc;0;L;;;;;N;;;;;
1934;LIMBU SMALL LETTER NA;Mc;0;L;;;;;N;;;;;
1935;LIMBU SMALL LETTER PA;Mc;0;L;;;;;N;;;;;
1936;LIMBU SMALL LETTER MA;Mc;0;L;;;;;N;;;;;
1937;LIMBU SMALL LETTER RA;Mc;0;L;;;;;N;;;;;
1938;LIMBU SMALL LETTER LA;Mc;0;L;;;;;N;;;;;
1939;LIMBU SIGN MUKPHRENG;Mn;222;NSM;;;;;N;;;;;
193A;LIMBU SIGN KEMPHRENG;Mn;230;NSM;;;;;N;;;;;
193B;LIMBU SIGN SA-I;Mn;220;NSM;;;;;N;;;;;
1940;LIMBU SIGN LOO;So;0;ON;;;;;N;;;;;
1944;LIMBU EXCLAMATION MARK;Po;0;ON;;;;;N;;;;;
1945;LIMBU QUESTION MARK;Po;0;ON;;;;;N;;;;;
1946;LIMBU DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
1947;LIMBU DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
1948;LIMBU DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
1949;LIMBU DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
194A;LIMBU DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
194B;LIMBU DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
194C;LIMBU DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
194D;LIMBU DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
194E;LIMBU DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
194F;LIMBU DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
1950;TAI LE LETTER KA;Lo;0;L;;;;;N;;;;;
1951;TAI LE LETTER XA;Lo;0;L;;;;;N;;;;;
1952;TAI LE LETTER NGA;Lo;0;L;;;;;N;;;;;
1953;TAI LE LETTER TSA;Lo;0;L;;;;;N;;;;;
1954;TAI LE LETTER SA;Lo;0;L;;;;;N;;;;;
1955;TAI LE LETTER YA;Lo;0;L;;;;;N;;;;;
1956;TAI LE LETTER TA;Lo;0;L;;;;;N;;;;;
1957;TAI LE LETTER THA;Lo;0;L;;;;;N;;;;;
1958;TAI LE LETTER LA;Lo;0;L;;;;;N;;;;;
1959;TAI LE LETTER PA;Lo;0;L;;;;;N;;;;;
195A;TAI LE LETTER PHA;Lo;0;L;;;;;N;;;;;
195B;TAI LE LETTER MA;Lo;0;L;;;;;N;;;;;
195C;TAI LE LETTER FA;Lo;0;L;;;;;N;;;;;
195D;TAI LE LETTER VA;Lo;0;L;;;;;N;;;;;
195E;TAI LE LETTER HA;Lo;0;L;;;;;N;;;;;
195F;TAI LE LETTER QA;Lo;0;L;;;;;N;;;;;
1960;TAI LE LETTER KHA;Lo;0;L;;;;;N;;;;;
1961;TAI LE LETTER TSHA;Lo;0;L;;;;;N;;;;;
1962;TAI LE LETTER NA;Lo;0;L;;;;;N;;;;;
1963;TAI LE LETTER A;Lo;0;L;;;;;N;;;;;
1964;TAI LE LETTER I;Lo;0;L;;;;;N;;;;;
1965;TAI LE LETTER EE;Lo;0;L;;;;;N;;;;;
1966;TAI LE LETTER EH;Lo;0;L;;;;;N;;;;;
1967;TAI LE LETTER U;Lo;0;L;;;;;N;;;;;
1968;TAI LE LETTER OO;Lo;0;L;;;;;N;;;;;
1969;TAI LE LETTER O;Lo;0;L;;;;;N;;;;;
196A;TAI LE LETTER UE;Lo;0;L;;;;;N;;;;;
196B;TAI LE LETTER E;Lo;0;L;;;;;N;;;;;
196C;TAI LE LETTER AUE;Lo;0;L;;;;;N;;;;;
196D;TAI LE LETTER AI;Lo;0;L;;;;;N;;;;;
1970;TAI LE LETTER TONE-2;Lo;0;L;;;;;N;;;;;
1971;TAI LE LETTER TONE-3;Lo;0;L;;;;;N;;;;;
1972;TAI LE LETTER TONE-4;Lo;0;L;;;;;N;;;;;
1973;TAI LE LETTER TONE-5;Lo;0;L;;;;;N;;;;;
1974;TAI LE LETTER TONE-6;Lo;0;L;;;;;N;;;;;
1980;NEW TAI LUE LETTER HIGH QA;Lo;0;L;;;;;N;;;;;
1981;NEW TAI LUE LETTER LOW QA;Lo;0;L;;;;;N;;;;;
1982;NEW TAI LUE LETTER HIGH KA;Lo;0;L;;;;;N;;;;;
1983;NEW TAI LUE LETTER HIGH XA;Lo;0;L;;;;;N;;;;;
1984;NEW TAI LUE LETTER HIGH NGA;Lo;0;L;;;;;N;;;;;
1985;NEW TAI LUE LETTER LOW KA;Lo;0;L;;;;;N;;;;;
1986;NEW TAI LUE LETTER LOW XA;Lo;0;L;;;;;N;;;;;
1987;NEW TAI LUE LETTER LOW NGA;Lo;0;L;;;;;N;;;;;
1988;NEW TAI LUE LETTER HIGH TSA;Lo;0;L;;;;;N;;;;;
1989;NEW TAI LUE LETTER HIGH SA;Lo;0;L;;;;;N;;;;;
198A;NEW TAI LUE LETTER HIGH YA;Lo;0;L;;;;;N;;;;;
198B;NEW TAI LUE LETTER LOW TSA;Lo;0;L;;;;;N;;;;;
198C;NEW TAI LUE LETTER LOW SA;Lo;0;L;;;;;N;;;;;
198D;NEW TAI LUE LETTER LOW YA;Lo;0;L;;;;;N;;;;;
198E;NEW TAI LUE LETTER HIGH TA;Lo;0;L;;;;;N;;;;;
198F;NEW TAI LUE LETTER HIGH THA;Lo;0;L;;;;;N;;;;;
1990;NEW TAI LUE LETTER HIGH NA;Lo;0;L;;;;;N;;;;;
1991;NEW TAI LUE LETTER LOW TA;Lo;0;L;;;;;N;;;;;
1992;NEW TAI LUE LETTER LOW THA;Lo;0;L;;;;;N;;;;;
1993;NEW TAI LUE LETTER LOW NA;Lo;0;L;;;;;N;;;;;
1994;NEW TAI LUE LETTER HIGH PA;Lo;0;L;;;;;N;;;;;
1995;NEW TAI LUE LETTER HIGH PHA;Lo;0;L;;;;;N;;;;;
1996;NEW TAI LUE LETTER HIGH MA;Lo;0;L;;;;;N;;;;;
1997;NEW TAI LUE LETTER LOW PA;Lo;0;L;;;;;N;;;;;
1998;NEW TAI LUE LETTER LOW PHA;Lo;0;L;;;;;N;;;;;
1999;NEW TAI LUE LETTER LOW MA;Lo;0;L;;;;;N;;;;;
199A;NEW TAI LUE LETTER HIGH FA;Lo;0;L;;;;;N;;;;;
199B;NEW TAI LUE LETTER HIGH VA;Lo;0;L;;;;;N;;;;;
199C;NEW TAI LUE LETTER HIGH LA;Lo;0;L;;;;;N;;;;;
199D;NEW TAI LUE LETTER LOW FA;Lo;0;L;;;;;N;;;;;
199E;NEW TAI LUE LETTER LOW VA;Lo;0;L;;;;;N;;;;;
199F;NEW TAI LUE LETTER LOW LA;Lo;0;L;;;;;N;;;;;
19A0;NEW TAI LUE LETTER HIGH HA;Lo;0;L;;;;;N;;;;;
19A1;NEW TAI LUE LETTER HIGH DA;Lo;0;L;;;;;N;;;;;
19A2;NEW TAI LUE LETTER HIGH BA;Lo;0;L;;;;;N;;;;;
19A3;NEW TAI LUE LETTER LOW HA;Lo;0;L;;;;;N;;;;;
19A4;NEW TAI LUE LETTER LOW DA;Lo;0;L;;;;;N;;;;;
19A5;NEW TAI LUE LETTER LOW BA;Lo;0;L;;;;;N;;;;;
19A6;NEW TAI LUE LETTER HIGH KVA;Lo;0;L;;;;;N;;;;;
19A7;NEW TAI LUE LETTER HIGH XVA;Lo;0;L;;;;;N;;;;;
19A8;NEW TAI LUE LETTER LOW KVA;Lo;0;L;;;;;N;;;;;
19A9;NEW TAI LUE LETTER LOW XVA;Lo;0;L;;;;;N;;;;;
19AA;NEW TAI LUE LETTER HIGH SUA;Lo;0;L;;;;;N;;;;;
19AB;NEW TAI LUE LETTER LOW SUA;Lo;0;L;;;;;N;;;;;
19B0;NEW TAI LUE VOWEL SIGN VOWEL SHORTENER;Lo;0;L;;;;;N;;;;;
19B1;NEW TAI LUE VOWEL SIGN AA;Lo;0;L;;;;;N;;;;;
19B2;NEW TAI LUE VOWEL SIGN II;Lo;0;L;;;;;N;;;;;
19B3;NEW TAI LUE VOWEL SIGN U;Lo;0;L;;;;;N;;;;;
19B4;NEW TAI LUE VOWEL SIGN UU;Lo;0;L;;;;;N;;;;;
19B5;NEW TAI LUE VOWEL SIGN E;Lo;0;L;;;;;N;;;;;
19B6;NEW TAI LUE VOWEL SIGN AE;Lo;0;L;;;;;N;;;;;
19B7;NEW TAI LUE VOWEL SIGN O;Lo;0;L;;;;;N;;;;;
19B8;NEW TAI LUE VOWEL SIGN OA;Lo;0;L;;;;;N;;;;;
19B9;NEW TAI LUE VOWEL SIGN UE;Lo;0;L;;;;;N;;;;;
19BA;NEW TAI LUE VOWEL SIGN AY;Lo;0;L;;;;;N;;;;;
19BB;NEW TAI LUE VOWEL SIGN AAY;Lo;0;L;;;;;N;;;;;
19BC;NEW TAI LUE VOWEL SIGN UY;Lo;0;L;;;;;N;;;;;
19BD;NEW TAI LUE VOWEL SIGN OY;Lo;0;L;;;;;N;;;;;
19BE;NEW TAI LUE VOWEL SIGN OAY;Lo;0;L;;;;;N;;;;;
19BF;NEW TAI LUE VOWEL SIGN UEY;Lo;0;L;;;;;N;;;;;
19C0;NEW TAI LUE VOWEL SIGN IY;Lo;0;L;;;;;N;;;;;
19C1;NEW TAI LUE LETTER FINAL V;Lo;0;L;;;;;N;;;;;
19C2;NEW TAI LUE LETTER FINAL NG;Lo;0;L;;;;;N;;;;;
19C3;NEW TAI LUE LETTER FINAL N;Lo;0;L;;;;;N;;;;;
19C4;NEW TAI LUE LETTER FINAL M;Lo;0;L;;;;;N;;;;;
19C5;NEW TAI LUE LETTER FINAL K;Lo;0;L;;;;;N;;;;;
19C6;NEW TAI LUE LETTER FINAL D;Lo;0;L;;;;;N;;;;;
19C7;NEW TAI LUE LETTER FINAL B;Lo;0;L;;;;;N;;;;;
19C8;NEW TAI LUE TONE MARK-1;Lo;0;L;;;;;N;;;;;
19C9;NEW TAI LUE TONE MARK-2;Lo;0;L;;;;;N;;;;;
19D0;NEW TAI LUE DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
19D1;NEW TAI LUE DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
19D2;NEW TAI LUE DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
19D3;NEW TAI LUE DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
19D4;NEW TAI LUE DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
19D5;NEW TAI LUE DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
19D6;NEW TAI LUE DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
19D7;NEW TAI LUE DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
19D8;NEW TAI LUE DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
19D9;NEW TAI LUE DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
19DA;NEW TAI LUE THAM DIGIT ONE;No;0;L;;;1;1;N;;;;;
19DE;NEW TAI LUE SIGN LAE;So;0;ON;;;;;N;;;;;
19DF;NEW TAI LUE SIGN LAEV;So;0;ON;;;;;N;;;;;
19E0;KHMER SYMBOL PATHAMASAT;So;0;ON;;;;;N;;;;;
19E1;KHMER SYMBOL MUOY KOET;So;0;ON;;;;;N;;;;;
19E2;KHMER SYMBOL PII KOET;So;0;ON;;;;;N;;;;;
19E3;KHMER SYMBOL BEI KOET;So;0;ON;;;;;N;;;;;
19E4;KHMER SYMBOL BUON KOET;So;0;ON;;;;;N;;;;;
19E5;KHMER SYMBOL PRAM KOET;So;0;ON;;;;;N;;;;;
19E6;KHMER SYMBOL PRAM-MUOY KOET;So;0;ON;;;;;N;;;;;
19E7;KHMER SYMBOL PRAM-PII KOET;So;0;ON;;;;;N;;;;;
19E8;KHMER SYMBOL PRAM-BEI KOET;So;0;ON;;;;;N;;;;;
19E9;KHMER SYMBOL PRAM-BUON KOET;So;0;ON;;;;;N;;;;;
19EA;KHMER SYMBOL DAP KOET;So;0;ON;;;;;N;;;;;
19EB;KHMER SYMBOL DAP-MUOY KOET;So;0;ON;;;;;N;;;;;
19EC;KHMER SYMBOL DAP-PII KOET;So;0;ON;;;;;N;;;;;
19ED;KHMER SYMBOL DAP-BEI KOET;So;0;ON;;;;;N;;;;;
19EE;KHMER SYMBOL DAP-BUON KOET;So;0;ON;;;;;N;;;;;
19EF;KHMER SYMBOL DAP-PRAM KOET;So;0;ON;;;;;N;;;;;
19F0;KHMER SYMBOL TUTEYASAT;So;0;ON;;;;;N;;;;;
19F1;KHMER SYMBOL MUOY ROC;So;0;ON;;;;;N;;;;;
19F2;KHMER SYMBOL PII ROC;So;0;ON;;;;;N;;;;;
19F3;KHMER SYMBOL BEI ROC;So;0;ON;;;;;N;;;;;
19F4;KHMER SYMBOL BUON ROC;So;0;ON;;;;;N;;;;;
19F5;KHMER SYMBOL PRAM ROC;So;0;ON;;;;;N;;;;;
19F6;KHMER SYMBOL PRAM-MUOY ROC;So;0;ON;;;;;N;;;;;
19F7;KHMER SYMBOL PRAM-PII ROC;So;0;ON;;;;;N;;;;;
19F8;KHMER SYMBOL PRAM-BEI ROC;So;0;ON;;;;;N;;;;;
19F9;KHMER SYMBOL PRAM-BUON ROC;So;0;ON;;;;;N;;;;;
19FA;KHMER SYMBOL DAP ROC;So;0;ON;;;;;N;;;;;
19FB;KHMER SYMBOL DAP-MUOY ROC;So;0;ON;;;;;N;;;;;
19FC;KHMER SYMBOL DAP-PII ROC;So;0;ON;;;;;N;;;;;
19FD;KHMER SYMBOL DAP-BEI ROC;So;0;ON;;;;;N;;;;;
19FE;KHMER SYMBOL DAP-BUON ROC;So;0;ON;;;;;N;;;;;
19FF;KHMER SYMBOL DAP-PRAM ROC;So;0;ON;;;;;N;;;;;
1A00;BUGINESE LETTER KA;Lo;0;L;;;;;N;;;;;
1A01;BUGINESE LETTER GA;Lo;0;L;;;;;N;;;;;
1A02;BUGINESE LETTER NGA;Lo;0;L;;;;;N;;;;;
1A03;BUGINESE LETTER NGKA;Lo;0;L;;;;;N;;;;;
1A04;BUGINESE LETTER PA;Lo;0;L;;;;;N;;;;;
1A05;BUGINESE LETTER BA;Lo;0;L;;;;;N;;;;;
1A06;BUGINESE LETTER MA;Lo;0;L;;;;;N;;;;;
1A07;BUGINESE LETTER MPA;Lo;0;L;;;;;N;;;;;
1A08;BUGINESE LETTER TA;Lo;0;L;;;;;N;;;;;
1A09;BUGINESE LETTER DA;Lo;0;L;;;;;N;;;;;
1A0A;BUGINESE LETTER NA;Lo;0;L;;;;;N;;;;;
1A0B;BUGINESE LETTER NRA;Lo;0;L;;;;;N;;;;;
1A0C;BUGINESE LETTER CA;Lo;0;L;;;;;N;;;;;
1A0D;BUGINESE LETTER JA;Lo;0;L;;;;;N;;;;;
1A0E;BUGINESE LETTER NYA;Lo;0;L;;;;;N;;;;;
1A0F;BUGINESE LETTER NYCA;Lo;0;L;;;;;N;;;;;
1A10;BUGINESE LETTER YA;Lo;0;L;;;;;N;;;;;
1A11;BUGINESE LETTER RA;Lo;0;L;;;;;N;;;;;
1A12;BUGINESE LETTER LA;Lo;0;L;;;;;N;;;;;
1A13;BUGINESE LETTER VA;Lo;0;L;;;;;N;;;;;
1A14;BUGINESE LETTER SA;Lo;0;L;;;;;N;;;;;
1A15;BUGINESE LETTER A;Lo;0;L;;;;;N;;;;;
1A16;BUGINESE LETTER HA;Lo;0;L;;;;;N;;;;;
1A17;BUGINESE VOWEL SIGN I;Mn;230;NSM;;;;;N;;;;;
1A18;BUGINESE VOWEL SIGN U;Mn;220;NSM;;;;;N;;;;;
1A19;BUGINESE VOWEL SIGN E;Mc;0;L;;;;;N;;;;;
1A1A;BUGINESE VOWEL SIGN O;Mc;0;L;;;;;N;;;;;
1A1B;BUGINESE VOWEL SIGN AE;Mn;0;NSM;;;;;N;;;;;
1A1E;BUGINESE PALLAWA;Po;0;L;;;;;N;;;;;
1A1F;BUGINESE END OF SECTION;Po;0;L;;;;;N;;;;;
1A20;TAI THAM LETTER HIGH KA;Lo;0;L;;;;;N;;;;;
1A21;TAI THAM LETTER HIGH KHA;Lo;0;L;;;;;N;;;;;
1A22;TAI THAM LETTER HIGH KXA;Lo;0;L;;;;;N;;;;;
1A23;TAI THAM LETTER LOW KA;Lo;0;L;;;;;N;;;;;
1A24;TAI THAM LETTER LOW KXA;Lo;0;L;;;;;N;;;;;
1A25;TAI THAM LETTER LOW KHA;Lo;0;L;;;;;N;;;;;
1A26;TAI THAM LETTER NGA;Lo;0;L;;;;;N;;;;;
1A27;TAI THAM LETTER HIGH CA;Lo;0;L;;;;;N;;;;;
1A28;TAI THAM LETTER HIGH CHA;Lo;0;L;;;;;N;;;;;
1A29;TAI THAM LETTER LOW CA;Lo;0;L;;;;;N;;;;;
1A2A;TAI THAM LETTER LOW SA;Lo;0;L;;;;;N;;;;;
1A2B;TAI THAM LETTER LOW CHA;Lo;0;L;;;;;N;;;;;
1A2C;TAI THAM LETTER NYA;Lo;0;L;;;;;N;;;;;
1A2D;TAI THAM LETTER RATA;Lo;0;L;;;;;N;;;;;
1A2E;TAI THAM LETTER HIGH RATHA;Lo;0;L;;;;;N;;;;;
1A2F;TAI THAM LETTER DA;Lo;0;L;;;;;N;;;;;
1A30;TAI THAM LETTER LOW RATHA;Lo;0;L;;;;;N;;;;;
1A31;TAI THAM LETTER RANA;Lo;0;L;;;;;N;;;;;
1A32;TAI THAM LETTER HIGH TA;Lo;0;L;;;;;N;;;;;
1A33;TAI THAM LETTER HIGH THA;Lo;0;L;;;;;N;;;;;
1A34;TAI THAM LETTER LOW TA;Lo;0;L;;;;;N;;;;;
1A35;TAI THAM LETTER LOW THA;Lo;0;L;;;;;N;;;;;
1A36;TAI THAM LETTER NA;Lo;0;L;;;;;N;;;;;
1A37;TAI THAM LETTER BA;Lo;0;L;;;;;N;;;;;
1A38;TAI THAM LETTER HIGH PA;Lo;0;L;;;;;N;;;;;
1A39;TAI THAM LETTER HIGH PHA;Lo;0;L;;;;;N;;;;;
1A3A;TAI THAM LETTER HIGH FA;Lo;0;L;;;;;N;;;;;
1A3B;TAI THAM LETTER LOW PA;Lo;0;L;;;;;N;;;;;
1A3C;TAI THAM LETTER LOW FA;Lo;0;L;;;;;N;;;;;
1A3D;TAI THAM LETTER LOW PHA;Lo;0;L;;;;;N;;;;;
1A3E;TAI THAM LETTER MA;Lo;0;L;;;;;N;;;;;
1A3F;TAI THAM LETTER LOW YA;Lo;0;L;;;;;N;;;;;
1A40;TAI THAM LETTER HIGH YA;Lo;0;L;;;;;N;;;;;
1A41;TAI THAM LETTER RA;Lo;0;L;;;;;N;;;;;
1A42;TAI THAM LETTER RUE;Lo;0;L;;;;;N;;;;;
1A43;TAI THAM LETTER LA;Lo;0;L;;;;;N;;;;;
1A44;TAI THAM LETTER LUE;Lo;0;L;;;;;N;;;;;
1A45;TAI THAM LETTER WA;Lo;0;L;;;;;N;;;;;
1A46;TAI THAM LETTER HIGH SHA;Lo;0;L;;;;;N;;;;;
1A47;TAI THAM LETTER HIGH SSA;Lo;0;L;;;;;N;;;;;
1A48;TAI THAM LETTER HIGH SA;Lo;0;L;;;;;N;;;;;
1A49;TAI THAM LETTER HIGH HA;Lo;0;L;;;;;N;;;;;
1A4A;TAI THAM LETTER LLA;Lo;0;L;;;;;N;;;;;
1A4B;TAI THAM LETTER A;Lo;0;L;;;;;N;;;;;
1A4C;TAI THAM LETTER LOW HA;Lo;0;L;;;;;N;;;;;
1A4D;TAI THAM LETTER I;Lo;0;L;;;;;N;;;;;
1A4E;TAI THAM LETTER II;Lo;0;L;;;;;N;;;;;
1A4F;TAI THAM LETTER U;Lo;0;L;;;;;N;;;;;
1A50;TAI THAM LETTER UU;Lo;0;L;;;;;N;;;;;
1A51;TAI THAM LETTER EE;Lo;0;L;;;;;N;;;;;
1A52;TAI THAM LETTER OO;Lo;0;L;;;;;N;;;;;
1A53;TAI THAM LETTER LAE;Lo;0;L;;;;;N;;;;;
1A54;TAI THAM LETTER GREAT SA;Lo;0;L;;;;;N;;;;;
1A55;TAI THAM CONSONANT SIGN MEDIAL RA;Mc;0;L;;;;;N;;;;;
1A56;TAI THAM CONSONANT SIGN MEDIAL LA;Mn;0;NSM;;;;;N;;;;;
1A57;TAI THAM CONSONANT SIGN LA TANG LAI;Mc;0;L;;;;;N;;;;;
1A58;TAI THAM SIGN MAI KANG LAI;Mn;0;NSM;;;;;N;;;;;
1A59;TAI THAM CONSONANT SIGN FINAL NGA;Mn;0;NSM;;;;;N;;;;;
1A5A;TAI THAM CONSONANT SIGN LOW PA;Mn;0;NSM;;;;;N;;;;;
1A5B;TAI THAM CONSONANT SIGN HIGH RATHA OR LOW PA;Mn;0;NSM;;;;;N;;;;;
1A5C;TAI THAM CONSONANT SIGN MA;Mn;0;NSM;;;;;N;;;;;
1A5D;TAI THAM CONSONANT SIGN BA;Mn;0;NSM;;;;;N;;;;;
1A5E;TAI THAM CONSONANT SIGN SA;Mn;0;NSM;;;;;N;;;;;
1A60;TAI THAM SIGN SAKOT;Mn;9;NSM;;;;;N;;;;;
1A61;TAI THAM VOWEL SIGN A;Mc;0;L;;;;;N;;;;;
1A62;TAI THAM VOWEL SIGN MAI SAT;Mn;0;NSM;;;;;N;;;;;
1A63;TAI THAM VOWEL SIGN AA;Mc;0;L;;;;;N;;;;;
1A64;TAI THAM VOWEL SIGN TALL AA;Mc;0;L;;;;;N;;;;;
1A65;TAI THAM VOWEL SIGN I;Mn;0;NSM;;;;;N;;;;;
1A66;TAI THAM VOWEL SIGN II;Mn;0;NSM;;;;;N;;;;;
1A67;TAI THAM VOWEL SIGN UE;Mn;0;NSM;;;;;N;;;;;
1A68;TAI THAM VOWEL SIGN UUE;Mn;0;NSM;;;;;N;;;;;
1A69;TAI THAM VOWEL SIGN U;Mn;0;NSM;;;;;N;;;;;
1A6A;TAI THAM VOWEL SIGN UU;Mn;0;NSM;;;;;N;;;;;
1A6B;TAI THAM VOWEL SIGN O;Mn;0;NSM;;;;;N;;;;;
1A6C;TAI THAM VOWEL SIGN OA BELOW;Mn;0;NSM;;;;;N;;;;;
1A6D;TAI THAM VOWEL SIGN OY;Mc;0;L;;;;;N;;;;;
1A6E;TAI THAM VOWEL SIGN E;Mc;0;L;;;;;N;;;;;
1A6F;TAI THAM VOWEL SIGN AE;Mc;0;L;;;;;N;;;;;
1A70;TAI THAM VOWEL SIGN OO;Mc;0;L;;;;;N;;;;;
1A71;TAI THAM VOWEL SIGN AI;Mc;0;L;;;;;N;;;;;
1A72;TAI THAM VOWEL SIGN THAM AI;Mc;0;L;;;;;N;;;;;
1A73;TAI THAM VOWEL SIGN OA ABOVE;Mn;0;NSM;;;;;N;;;;;
1A74;TAI THAM SIGN MAI KANG;Mn;0;NSM;;;;;N;;;;;
1A75;TAI THAM SIGN TONE-1;Mn;230;NSM;;;;;N;;;;;
1A76;TAI THAM SIGN TONE-2;Mn;230;NSM;;;;;N;;;;;
1A77;TAI THAM SIGN KHUEN TONE-3;Mn;230;NSM;;;;;N;;;;;
1A78;TAI THAM SIGN KHUEN TONE-4;Mn;230;NSM;;;;;N;;;;;
1A79;TAI THAM SIGN KHUEN TONE-5;Mn;230;NSM;;;;;N;;;;;
1A7A;TAI THAM SIGN RA HAAM;Mn;230;NSM;;;;;N;;;;;
1A7B;TAI THAM SIGN MAI SAM;Mn;230;NSM;;;;;N;;;;;
1A7C;TAI THAM SIGN KHUEN-LUE KARAN;Mn;230;NSM;;;;;N;;;;;
1A7F;TAI THAM COMBINING CRYPTOGRAMMIC DOT;Mn;220;NSM;;;;;N;;;;;
1A80;TAI THAM HORA DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
1A81;TAI THAM HORA DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
1A82;TAI THAM HORA DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
1A83;TAI THAM HORA DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
1A84;TAI THAM HORA DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
1A85;TAI THAM HORA DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
1A86;TAI THAM HORA DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
1A87;TAI THAM HORA DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
1A88;TAI THAM HORA DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
1A89;TAI THAM HORA DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
1A90;TAI THAM THAM DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
1A91;TAI THAM THAM DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
1A92;TAI THAM THAM DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
1A93;TAI THAM THAM DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
1A94;TAI THAM THAM DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
1A95;TAI THAM THAM DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
1A96;TAI THAM THAM DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
1A97;TAI THAM THAM DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
1A98;TAI THAM THAM DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
1A99;TAI THAM THAM DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
1AA0;TAI THAM SIGN WIANG;Po;0;L;;;;;N;;;;;
1AA1;TAI THAM SIGN WIANGWAAK;Po;0;L;;;;;N;;;;;
1AA2;TAI THAM SIGN SAWAN;Po;0;L;;;;;N;;;;;
1AA3;TAI THAM SIGN KEOW;Po;0;L;;;;;N;;;;;
1AA4;TAI THAM SIGN HOY;Po;0;L;;;;;N;;;;;
1AA5;TAI THAM SIGN DOKMAI;Po;0;L;;;;;N;;;;;
1AA6;TAI THAM SIGN REVERSED ROTATED RANA;Po;0;L;;;;;N;;;;;
1AA7;TAI THAM SIGN MAI YAMOK;Lm;0;L;;;;;N;;;;;
1AA8;TAI THAM SIGN KAAN;Po;0;L;;;;;N;;;;;
1AA9;TAI THAM SIGN KAANKUU;Po;0;L;;;;;N;;;;;
1AAA;TAI THAM SIGN SATKAAN;Po;0;L;;;;;N;;;;;
1AAB;TAI THAM SIGN SATKAANKUU;Po;0;L;;;;;N;;;;;
1AAC;TAI THAM SIGN HANG;Po;0;L;;;;;N;;;;;
1AAD;TAI THAM SIGN CAANG;Po;0;L;;;;;N;;;;;
1AB0;COMBINING DOUBLED CIRCUMFLEX ACCENT;Mn;230;NSM;;;;;N;;;;;
1AB1;COMBINING DIAERESIS-RING;Mn;230;NSM;;;;;N;;;;;
1AB2;COMBINING INFINITY;Mn;230;NSM;;;;;N;;;;;
1AB3;COMBINING DOWNWARDS ARROW;Mn;230;NSM;;;;;N;;;;;
1AB4;COMBINING TRIPLE DOT;Mn;230;NSM;;;;;N;;;;;
1AB5;COMBINING X-X BELOW;Mn;220;NSM;;;;;N;;;;;
1AB6;COMBINING WIGGLY LINE BELOW;Mn;220;NSM;;;;;N;;;;;
1AB7;COMBINING OPEN MARK BELOW;Mn;220;NSM;;;;;N;;;;;
1AB8;COMBINING DOUBLE OPEN MARK BELOW;Mn;220;NSM;;;;;N;;;;;
1AB9;COMBINING LIGHT CENTRALIZATION STROKE BELOW;Mn;220;NSM;;;;;N;;;;;
1ABA;COMBINING STRONG CENTRALIZATION STROKE BELOW;Mn;220;NSM;;;;;N;;;;;
1ABB;COMBINING PARENTHESES ABOVE;Mn;230;NSM;;;;;N;;;;;
1ABC;COMBINING DOUBLE PARENTHESES ABOVE;Mn;230;NSM;;;;;N;;;;;
1ABD;COMBINING PARENTHESES BELOW;Mn;220;NSM;;;;;N;;;;;
1ABE;COMBINING PARENTHESES OVERLAY;Me;0;NSM;;;;;N;;;;;
1ABF;COMBINING LATIN SMALL LETTER W BELOW;Mn;220;NSM;;;;;N;;;;;
1AC0;COMBINING LATIN SMALL LETTER TURNED W BELOW;Mn;220;NSM;;;;;N;;;;;
1AC1;COMBINING LEFT PARENTHESIS ABOVE LEFT;Mn;230;NSM;;;;;N;;;;;
1AC2;COMBINING RIGHT PARENTHESIS ABOVE RIGHT;Mn;230;NSM;;;;;N;;;;;
1AC3;COMBINING LEFT PARENTHESIS BELOW LEFT;Mn;220;NSM;;;;;N;;;;;
1AC4;COMBINING RIGHT PARENTHESIS BELOW RIGHT;Mn;220;NSM;;;;;N;;;;;
1AC5;COMBINING SQUARE BRACKETS ABOVE;Mn;230;NSM;;;;;N;;;;;
1AC6;COMBINING NUMBER SIGN ABOVE;Mn;230;NSM;;;;;N;;;;;
1AC7;COMBINING INVERTED DOUBLE ARCH ABOVE;Mn;230;NSM;;;;;N;;;;;
1AC8;COMBINING PLUS SIGN ABOVE;Mn;230;NSM;;;;;N;;;;;
1AC9;COMBINING DOUBLE PLUS SIGN ABOVE;Mn;230;NSM;;;;;N;;;;;
1ACA;COMBINING DOUBLE PLUS SIGN BELOW;Mn;220;NSM;;;;;N;;;;;
1ACB;COMBINING TRIPLE ACUTE ACCENT;Mn;230;NSM;;;;;N;;;;;
1ACC;COMBINING LATIN SMALL LETTER INSULAR G;Mn;230;NSM;;;;;N;;;;;
1ACD;COMBINING LATIN SMALL LETTER INSULAR R;Mn;230;NSM;;;;;N;;;;;
1ACE;COMBINING LATIN SMALL LETTER INSULAR T;Mn;230;NSM;;;;;N;;;;;
1B00;BALINESE SIGN ULU RICEM;Mn;0;NSM;;;;;N;;;;;
1B01;BALINESE SIGN ULU CANDRA;Mn;0;NSM;;;;;N;;;;;
1B02;BALINESE SIGN CECEK;Mn;0;NSM;;;;;N;;;;;
1B03;BALINESE SIGN SURANG;Mn;0;NSM;;;;;N;;;;;
1B04;BALINESE SIGN BISAH;Mc;0;L;;;;;N;;;;;
1B05;BALINESE LETTER AKARA;Lo;0;L;;;;;N;;;;;
1B06;BALINESE LETTER AKARA TEDUNG;Lo;0;L;1B05 1B35;;;;N;;;;;
1B07;BALINESE LETTER IKARA;Lo;0;L;;;;;N;;;;;
1B08;BALINESE LETTER IKARA TEDUNG;Lo;0;L;1B07 1B35;;;;N;;;;;
1B09;BALINESE LETTER UKARA;Lo;0;L;;;;;N;;;;;
1B0A;BALINESE LETTER UKARA TEDUNG;Lo;0;L;1B09 1B35;;;;N;;;;;
1B0B;BALINESE LETTER RA REPA;Lo;0;L;;;;;N;;;;;
1B0C;BALINESE LETTER RA REPA TEDUNG;Lo;0;L;1B0B 1B35;;;;N;;;;;
1B0D;BALINESE LETTER LA LENGA;Lo;0;L;;;;;N;;;;;
1B0E;BALINESE LETTER LA LENGA TEDUNG;Lo;0;L;1B0D 1B35;;;;N;;;;;
1B0F;BALINESE LETTER EKARA;Lo;0;L;;;;;N;;;;;
1B10;BALINESE LETTER AIKARA;Lo;0;L;;;;;N;;;;;
1B11;BALINESE LETTER OKARA;Lo;0;L;;;;;N;;;;;
1B12;BALINESE LETTER OKARA TEDUNG;Lo;0;L;1B11 1B35;;;;N;;;;;
1B13;BALINESE LETTER KA;Lo;0;L;;;;;N;;;;;
1B14;BALINESE LETTER KA MAHAPRANA;Lo;0;L;;;;;N;;;;;
1B15;BALINESE LETTER GA;Lo;0;L;;;;;N;;;;;
1B16;BALINESE LETTER GA GORA;Lo;0;L;;;;;N;;;;;
1B17;BALINESE LETTER NGA;Lo;0;L;;;;;N;;;;;
1B18;BALINESE LETTER CA;Lo;0;L;;;;;N;;;;;
1B19;BALINESE LETTER CA LACA;Lo;0;L;;;;;N;;;;;
1B1A;BALINESE LETTER JA;Lo;0;L;;;;;N;;;;;
1B1B;BALINESE LETTER JA JERA;Lo;0;L;;;;;N;;;;;
1B1C;BALINESE LETTER NYA;Lo;0;L;;;;;N;;;;;
1B1D;BALINESE LETTER TA LATIK;Lo;0;L;;;;;N;;;;;
1B1E;BALINESE LETTER TA MURDA MAHAPRANA;Lo;0;L;;;;;N;;;;;
1B1F;BALINESE LETTER DA MURDA ALPAPRANA;Lo;0;L;;;;;N;;;;;
1B20;BALINESE LETTER DA MURDA MAHAPRANA;Lo;0;L;;;;;N;;;;;
1B21;BALINESE LETTER NA RAMBAT;Lo;0;L;;;;;N;;;;;
1B22;BALINESE LETTER TA;Lo;0;L;;;;;N;;;;;
1B23;BALINESE LETTER TA TAWA;Lo;0;L;;;;;N;;;;;
1B24;BALINESE LETTER DA;Lo;0;L;;;;;N;;;;;
1B25;BALINESE LETTER DA MADU;Lo;0;L;;;;;N;;;;;
1B26;BALINESE LETTER NA;Lo;0;L;;;;;N;;;;;
1B27;BALINESE LETTER PA;Lo;0;L;;;;;N;;;;;
1B28;BALINESE LETTER PA KAPAL;Lo;0;L;;;;;N;;;;;
1B29;BALINESE LETTER BA;Lo;0;L;;;;;N;;;;;
1B2A;BALINESE LETTER BA KEMBANG;Lo;0;L;;;;;N;;;;;
1B2B;BALINESE LETTER MA;Lo;0;L;;;;;N;;;;;
1B2C;BALINESE LETTER YA;Lo;0;L;;;;;N;;;;;
1B2D;BALINESE LETTER RA;Lo;0;L;;;;;N;;;;;
1B2E;BALINESE LETTER LA;Lo;0;L;;;;;N;;;;;
1B2F;BALINESE LETTER WA;Lo;0;L;;;;;N;;;;;
1B30;BALINESE LETTER SA SAGA;Lo;0;L;;;;;N;;;;;
1B31;BALINESE LETTER SA SAPA;Lo;0;L;;;;;N;;;;;
1B32;BALINESE LETTER SA;Lo;0;L;;;;;N;;;;;
1B33;BALINESE LETTER HA;Lo;0;L;;;;;N;;;;;
1B34;BALINESE SIGN REREKAN;Mn;7;NSM;;;;;N;;;;;
1B35;BALINESE VOWEL SIGN TEDUNG;Mc;0;L;;;;;N;;;;;
1B36;BALINESE VOWEL SIGN ULU;Mn;0;NSM;;;;;N;;;;;
1B37;BALINESE VOWEL SIGN ULU SARI;Mn;0;NSM;;;;;N;;;;;
1B38;BALINESE VOWEL SIGN SUKU;Mn;0;NSM;;;;;N;;;;;
1B39;BALINESE VOWEL SIGN SUKU ILUT;Mn;0;NSM;;;;;N;;;;;
1B3A;BALINESE VOWEL SIGN RA REPA;Mn;0;NSM;;;;;N;;;;;
1B3B;BALINESE VOWEL SIGN RA REPA TEDUNG;Mc;0;L;1B3A 1B35;;;;N;;;;;
1B3C;BALINESE VOWEL SIGN LA LENGA;Mn;0;NSM;;;;;N;;;;;
1B3D;BALINESE VOWEL SIGN LA LENGA TEDUNG;Mc;0;L;1B3C 1B35;;;;N;;;;;
1B3E;BALINESE VOWEL SIGN TALING;Mc;0;L;;;;;N;;;;;
1B3F;BALINESE VOWEL SIGN TALING REPA;Mc;0;L;;;;;N;;;;;
1B40;BALINESE VOWEL SIGN TALING TEDUNG;Mc;0;L;1B3E 1B35;;;;N;;;;;
1B41;BALINESE VOWEL SIGN TALING REPA TEDUNG;Mc;0;L;1B3F 1B35;;;;N;;;;;
1B42;BALINESE VOWEL SIGN PEPET;Mn;0;NSM;;;;;N;;;;;
1B43;BALINESE VOWEL SIGN PEPET TEDUNG;Mc;0;L;1B42 1B35;;;;N;;;;;
1B44;BALINESE ADEG ADEG;Mc;9;L;;;;;N;;;;;
1B45;BALINESE LETTER KAF SASAK;Lo;0;L;;;;;N;;;;;
1B46;BALINESE LETTER KHOT SASAK;Lo;0;L;;;;;N;;;;;
1B47;BALINESE LETTER TZIR SASAK;Lo;0;L;;;;;N;;;;;
1B48;BALINESE LETTER EF SASAK;Lo;0;L;;;;;N;;;;;
1B49;BALINESE LETTER VE SASAK;Lo;0;L;;;;;N;;;;;
1B4A;BALINESE LETTER ZAL SASAK;Lo;0;L;;;;;N;;;;;
1B4B;BALINESE LETTER ASYURA SASAK;Lo;0;L;;;;;N;;;;;
1B4C;BALINESE LETTER ARCHAIC JNYA;Lo;0;L;;;;;N;;;;;
1B50;BALINESE DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
1B51;BALINESE DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
1B52;BALINESE DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
1B53;BALINESE DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
1B54;BALINESE DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
1B55;BALINESE DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
1B56;BALINESE DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
1B57;BALINESE DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
1B58;BALINESE DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
1B59;BALINESE DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
1B5A;BALINESE PANTI;Po;0;L;;;;;N;;;;;
1B5B;BALINESE PAMADA;Po;0;L;;;;;N;;;;;
1B5C;BALINESE WINDU;Po;0;L;;;;;N;;;;;
1B5D;BALINESE CARIK PAMUNGKAH;Po;0;L;;;;;N;;;;;
1B5E;BALINESE CARIK SIKI;Po;0;L;;;;;N;;;;;
1B5F;BALINESE CARIK PAREREN;Po;0;L;;;;;N;;;;;
1B60;BALINESE PAMENENG;Po;0;L;;;;;N;;;;;
1B61;BALINESE MUSICAL SYMBOL DONG;So;0;L;;;;;N;;;;;
1B62;BALINESE MUSICAL SYMBOL DENG;So;0;L;;;;;N;;;;;
1B63;BALINESE MUSICAL SYMBOL DUNG;So;0;L;;;;;N;;;;;
1B64;BALINESE MUSICAL SYMBOL DANG;So;0;L;;;;;N;;;;;
1B65;BALINESE MUSICAL SYMBOL DANG SURANG;So;0;L;;;;;N;;;;;
1B66;BALINESE MUSICAL SYMBOL DING;So;0;L;;;;;N;;;;;
1B67;BALINESE MUSICAL SYMBOL DAENG;So;0;L;;;;;N;;;;;
1B68;BALINESE MUSICAL SYMBOL DEUNG;So;0;L;;;;;N;;;;;
1B69;BALINESE MUSICAL SYMBOL DAING;So;0;L;;;;;N;;;;;
1B6A;BALINESE MUSICAL SYMBOL DANG GEDE;So;0;L;;;;;N;;;;;
1B6B;BALINESE MUSICAL SYMBOL COMBINING TEGEH;Mn;230;NSM;;;;;N;;;;;
1B6C;BALINESE MUSICAL SYMBOL COMBINING ENDEP;Mn;220;NSM;;;;;N;;;;;
1B6D;BALINESE MUSICAL SYMBOL COMBINING KEMPUL;Mn;230;NSM;;;;;N;;;;;
1B6E;BALINESE MUSICAL SYMBOL COMBINING KEMPLI;Mn;230;NSM;;;;;N;;;;;
1B6F;BALINESE MUSICAL SYMBOL COMBINING JEGOGAN;Mn;230;NSM;;;;;N;;;;;
1B70;BALINESE MUSICAL SYMBOL COMBINING KEMPUL WITH JEGOGAN;Mn;230;NSM;;;;;N;;;;;
1B71;BALINESE MUSICAL SYMBOL COMBINING KEMPLI WITH JEGOGAN;Mn;230;NSM;;;;;N;;;;;
1B72;BALINESE MUSICAL SYMBOL COMBINING BENDE;Mn;230;NSM;;;;;N;;;;;
1B73;BALINESE MUSICAL SYMBOL COMBINING GONG;Mn;230;NSM;;;;;N;;;;;
1B74;BALINESE MUSICAL SYMBOL RIGHT-HAND OPEN DUG;So;0;L;;;;;N;;;;;
1B75;BALINESE MUSICAL SYMBOL RIGHT-HAND OPEN DAG;So;0;L;;;;;N;;;;;
1B76;BALINESE MUSICAL SYMBOL RIGHT-HAND CLOSED TUK;So;0;L;;;;;N;;;;;
1B77;BALINESE MUSICAL SYMBOL RIGHT-HAND CLOSED TAK;So;0;L;;;;;N;;;;;
1B78;BALINESE MUSICAL SYMBOL LEFT-HAND OPEN PANG;So;0;L;;;;;N;;;;;
1B79;BALINESE MUSICAL SYMBOL LEFT-HAND OPEN PUNG;So;0;L;;;;;N;;;;;
1B7A;BALINESE MUSICAL SYMBOL LEFT-HAND CLOSED PLAK;So;0;L;;;;;N;;;;;
1B7B;BALINESE MUSICAL SYMBOL LEFT-HAND CLOSED PLUK;So;0;L;;;;;N;;;;;
1B7C;BALINESE MUSICAL SYMBOL LEFT-HAND OPEN PING;So;0;L;;;;;N;;;;;
1B7D;BALINESE PANTI LANTANG;Po;0;L;;;;;N;;;;;
1B7E;BALINESE PAMADA LANTANG;Po;0;L;;;;;N;;;;;
1B80;SUNDANESE SIGN PANYECEK;Mn;0;NSM;;;;;N;;;;;
1B81;SUNDANESE SIGN PANGLAYAR;Mn;0;NSM;;;;;N;;;;;
1B82;SUNDANESE SIGN PANGWISAD;Mc;0;L;;;;;N;;;;;
1B83;SUNDANESE LETTER A;Lo;0;L;;;;;N;;;;;
1B84;SUNDANESE LETTER I;Lo;0;L;;;;;N;;;;;
1B85;SUNDANESE LETTER U;Lo;0;L;;;;;N;;;;;
1B86;SUNDANESE LETTER AE;Lo;0;L;;;;;N;;;;;
1B87;SUNDANESE LETTER O;Lo;0;L;;;;;N;;;;;
1B88;SUNDANESE LETTER E;Lo;0;L;;;;;N;;;;;
1B89;SUNDANESE LETTER EU;Lo;0;L;;;;;N;;;;;
1B8A;SUNDANESE LETTER KA;Lo;0;L;;;;;N;;;;;
1B8B;SUNDANESE LETTER QA;Lo;0;L;;;;;N;;;;;
1B8C;SUNDANESE LETTER GA;Lo;0;L;;;;;N;;;;;
1B8D;SUNDANESE LETTER NGA;Lo;0;L;;;;;N;;;;;
1B8E;SUNDANESE LETTER CA;Lo;0;L;;;;;N;;;;;
1B8F;SUNDANESE LETTER JA;Lo;0;L;;;;;N;;;;;
1B90;SUNDANESE LETTER ZA;Lo;0;L;;;;;N;;;;;
1B91;SUNDANESE LETTER NYA;Lo;0;L;;;;;N;;;;;
1B92;SUNDANESE LETTER TA;Lo;0;L;;;;;N;;;;;
1B93;SUNDANESE LETTER DA;Lo;0;L;;;;;N;;;;;
1B94;SUNDANESE LETTER NA;Lo;0;L;;;;;N;;;;;
1B95;SUNDANESE LETTER PA;Lo;0;L;;;;;N;;;;;
1B96;SUNDANESE LETTER FA;Lo;0;L;;;;;N;;;;;
1B97;SUNDANESE LETTER VA;Lo;0;L;;;;;N;;;;;
1B98;SUNDANESE LETTER BA;Lo;0;L;;;;;N;;;;;
1B99;SUNDANESE LETTER MA;Lo;0;L;;;;;N;;;;;
1B9A;SUNDANESE LETTER YA;Lo;0;L;;;;;N;;;;;
1B9B;SUNDANESE LETTER RA;Lo;0;L;;;;;N;;;;;
1B9C;SUNDANESE LETTER LA;Lo;0;L;;;;;N;;;;;
1B9D;SUNDANESE LETTER WA;Lo;0;L;;;;;N;;;;;
1B9E;SUNDANESE LETTER SA;Lo;0;L;;;;;N;;;;;
1B9F;SUNDANESE LETTER XA;Lo;0;L;;;;;N;;;;;
1BA0;SUNDANESE LETTER HA;Lo;0;L;;;;;N;;;;;
1BA1;SUNDANESE CONSONANT SIGN PAMINGKAL;Mc;0;L;;;;;N;;;;;
1BA2;SUNDANESE CONSONANT SIGN PANYAKRA;Mn;0;NSM;;;;;N;;;;;
1BA3;SUNDANESE CONSONANT SIGN PANYIKU;Mn;0;NSM;;;;;N;;;;;
1BA4;SUNDANESE VOWEL SIGN PANGHULU;Mn;0;NSM;;;;;N;;;;;
1BA5;SUNDANESE VOWEL SIGN PANYUKU;Mn;0;NSM;;;;;N;;;;;
1BA6;SUNDANESE VOWEL SIGN PANAELAENG;Mc;0;L;;;;;N;;;;;
1BA7;SUNDANESE VOWEL SIGN PANOLONG;Mc;0;L;;;;;N;;;;;
1BA8;SUNDANESE VOWEL SIGN PAMEPET;Mn;0;NSM;;;;;N;;;;;
1BA9;SUNDANESE VOWEL SIGN PANEULEUNG;Mn;0;NSM;;;;;N;;;;;
1BAA;SUNDANESE SIGN PAMAAEH;Mc;9;L;;;;;N;;;;;
1BAB;SUNDANESE SIGN VIRAMA;Mn;9;NSM;;;;;N;;;;;
1BAC;SUNDANESE CONSONANT SIGN PASANGAN MA;Mn;0;NSM;;;;;N;;;;;
1BAD;SUNDANESE CONSONANT SIGN PASANGAN WA;Mn;0;NSM;;;;;N;;;;;
1BAE;SUNDANESE LETTER KHA;Lo;0;L;;;;;N;;;;;
1BAF;SUNDANESE LETTER SYA;Lo;0;L;;;;;N;;;;;
1BB0;SUNDANESE DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
1BB1;SUNDANESE DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
1BB2;SUNDANESE DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
1BB3;SUNDANESE DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
1BB4;SUNDANESE DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
1BB5;SUNDANESE DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
1BB6;SUNDANESE DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
1BB7;SUNDANESE DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
1BB8;SUNDANESE DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
1BB9;SUNDANESE DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
1BBA;SUNDANESE AVAGRAHA;Lo;0;L;;;;;N;;;;;
1BBB;SUNDANESE LETTER REU;Lo;0;L;;;;;N;;;;;
1BBC;SUNDANESE LETTER LEU;Lo;0;L;;;;;N;;;;;
1BBD;SUNDANESE LETTER BHA;Lo;0;L;;;;;N;;;;;
1BBE;SUNDANESE LETTER FINAL K;Lo;0;L;;;;;N;;;;;
1BBF;SUNDANESE LETTER FINAL M;Lo;0;L;;;;;N;;;;;
1BC0;BATAK LETTER A;Lo;0;L;;;;;N;;;;;
1BC1;BATAK LETTER SIMALUNGUN A;Lo;0;L;;;;;N;;;;;
1BC2;BATAK LETTER HA;Lo;0;L;;;;;N;;;;;
1BC3;BATAK LETTER SIMALUNGUN HA;Lo;0;L;;;;;N;;;;;
1BC4;BATAK LETTER MANDAILING HA;Lo;0;L;;;;;N;;;;;
1BC5;BATAK LETTER BA;Lo;0;L;;;;;N;;;;;
1BC6;BATAK LETTER KARO BA;Lo;0;L;;;;;N;;;;;
1BC7;BATAK LETTER PA;Lo;0;L;;;;;N;;;;;
1BC8;BATAK LETTER SIMALUNGUN PA;Lo;0;L;;;;;N;;;;;
1BC9;BATAK LETTER NA;Lo;0;L;;;;;N;;;;;
1BCA;BATAK LETTER MANDAILING NA;Lo;0;L;;;;;N;;;;;
1BCB;BATAK LETTER WA;Lo;0;L;;;;;N;;;;;
1BCC;BATAK LETTER SIMALUNGUN WA;Lo;0;L;;;;;N;;;;;
1BCD;BATAK LETTER PAKPAK WA;Lo;0;L;;;;;N;;;;;
1BCE;BATAK LETTER GA;Lo;0;L;;;;;N;;;;;
1BCF;BATAK LETTER SIMALUNGUN GA;Lo;0;L;;;;;N;;;;;
1BD0;BATAK LETTER JA;Lo;0;L;;;;;N;;;;;
1BD1;BATAK LETTER DA;Lo;0;L;;;;;N;;;;;
1BD2;BATAK LETTER RA;Lo;0;L;;;;;N;;;;;
1BD3;BATAK LETTER SIMALUNGUN RA;Lo;0;L;;;;;N;;;;;
1BD4;BATAK LETTER MA;Lo;0;L;;;;;N;;;;;
1BD5;BATAK LETTER SIMALUNGUN MA;Lo;0;L;;;;;N;;;;;
1BD6;BATAK LETTER SOUTHERN TA;Lo;0;L;;;;;N;;;;;
1BD7;BATAK LETTER NORTHERN TA;Lo;0;L;;;;;N;;;;;
1BD8;BATAK LETTER SA;Lo;0;L;;;;;N;;;;;
1BD9;BATAK LETTER SIMALUNGUN SA;Lo;0;L;;;;;N;;;;;
1BDA;BATAK LETTER MANDAILING SA;Lo;0;L;;;;;N;;;;;
1BDB;BATAK LETTER YA;Lo;0;L;;;;;N;;;;;
1BDC;BATAK LETTER SIMALUNGUN YA;Lo;0;L;;;;;N;;;;;
1BDD;BATAK LETTER NGA;Lo;0;L;;;;;N;;;;;
1BDE;BATAK LETTER LA;Lo;0;L;;;;;N;;;;;
1BDF;BATAK LETTER SIMALUNGUN LA;Lo;0;L;;;;;N;;;;;
1BE0;BATAK LETTER NYA;Lo;0;L;;;;;N;;;;;
1BE1;BATAK LETTER CA;Lo;0;L;;;;;N;;;;;
1BE2;BATAK LETTER NDA;Lo;0;L;;;;;N;;;;;
1BE3;BATAK LETTER MBA;Lo;0;L;;;;;N;;;;;
1BE4;BATAK LETTER I;Lo;0;L;;;;;N;;;;;
1BE5;BATAK LETTER U;Lo;0;L;;;;;N;;;;;
1BE6;BATAK SIGN TOMPI;Mn;7;NSM;;;;;N;;;;;
1BE7;BATAK VOWEL SIGN E;Mc;0;L;;;;;N;;;;;
1BE8;BATAK VOWEL SIGN PAKPAK E;Mn;0;NSM;;;;;N;;;;;
1BE9;BATAK VOWEL SIGN EE;Mn;0;NSM;;;;;N;;;;;
1BEA;BATAK VOWEL SIGN I;Mc;0;L;;;;;N;;;;;
1BEB;BATAK VOWEL SIGN KARO I;Mc;0;L;;;;;N;;;;;
1BEC;BATAK VOWEL SIGN O;Mc;0;L;;;;;N;;;;;
1BED;BATAK VOWEL SIGN KARO O;Mn;0;NSM;;;;;N;;;;;
1BEE;BATAK VOWEL SIGN U;Mc;0;L;;;;;N;;;;;
1BEF;BATAK VOWEL SIGN U FOR SIMALUNGUN SA;Mn;0;NSM;;;;;N;;;;;
1BF0;BATAK CONSONANT SIGN NG;Mn;0;NSM;;;;;N;;;;;
1BF1;BATAK CONSONANT SIGN H;Mn;0;NSM;;;;;N;;;;;
1BF2;BATAK PANGOLAT;Mc;9;L;;;;;N;;;;;
1BF3;BATAK PANONGONAN;Mc;9;L;;;;;N;;;;;
1BFC;BATAK SYMBOL BINDU NA METEK;Po;0;L;;;;;N;;;;;
1BFD;BATAK SYMBOL BINDU PINARBORAS;Po;0;L;;;;;N;;;;;
1BFE;BATAK SYMBOL BINDU JUDUL;Po;0;L;;;;;N;;;;;
1BFF;BATAK SYMBOL BINDU PANGOLAT;Po;0;L;;;;;N;;;;;
1C00;LEPCHA LETTER KA;Lo;0;L;;;;;N;;;;;
1C01;LEPCHA LETTER KLA;Lo;0;L;;;;;N;;;;;
1C02;LEPCHA LETTER KHA;Lo;0;L;;;;;N;;;;;
1C03;LEPCHA LETTER GA;Lo;0;L;;;;;N;;;;;
1C04;LEPCHA LETTER GLA;Lo;0;L;;;;;N;;;;;
1C05;LEPCHA LETTER NGA;Lo;0;L;;;;;N;;;;;
1C06;LEPCHA LETTER CA;Lo;0;L;;;;;N;;;;;
1C07;LEPCHA LETTER CHA;Lo;0;L;;;;;N;;;;;
1C08;LEPCHA LETTER JA;Lo;0;L;;;;;N;;;;;
1C09;LEPCHA LETTER NYA;Lo;0;L;;;;;N;;;;;
1C0A;LEPCHA LETTER TA;Lo;0;L;;;;;N;;;;;
1C0B;LEPCHA LETTER THA;Lo;0;L;;;;;N;;;;;
1C0C;LEPCHA LETTER DA;Lo;0;L;;;;;N;;;;;
1C0D;LEPCHA LETTER NA;Lo;0;L;;;;;N;;;;;
1C0E;LEPCHA LETTER PA;Lo;0;L;;;;;N;;;;;
1C0F;LEPCHA LETTER PLA;Lo;0;L;;;;;N;;;;;
1C10;LEPCHA LETTER PHA;Lo;0;L;;;;;N;;;;;
1C11;LEPCHA LETTER FA;Lo;0;L;;;;;N;;;;;
1C12;LEPCHA LETTER FLA;Lo;0;L;;;;;N;;;;;
1C13;LEPCHA LETTER BA;Lo;0;L;;;;;N;;;;;
1C14;LEPCHA LETTER BLA;Lo;0;L;;;;;N;;;;;
1C15;LEPCHA LETTER MA;Lo;0;L;;;;;N;;;;;
1C16;LEPCHA LETTER MLA;Lo;0;L;;;;;N;;;;;
1C17;LEPCHA LETTER TSA;Lo;0;L;;;;;N;;;;;
1C18;LEPCHA LETTER TSHA;Lo;0;L;;;;;N;;;;;
1C19;LEPCHA LETTER DZA;Lo;0;L;;;;;N;;;;;
1C1A;LEPCHA LETTER YA;Lo;0;L;;;;;N;;;;;
1C1B;LEPCHA LETTER RA;Lo;0;L;;;;;N;;;;;
1C1C;LEPCHA LETTER LA;Lo;0;L;;;;;N;;;;;
1C1D;LEPCHA LETTER HA;Lo;0;L;;;;;N;;;;;
1C1E;LEPCHA LETTER HLA;Lo;0;L;;;;;N;;;;;
1C1F;LEPCHA LETTER VA;Lo;0;L;;;;;N;;;;;
1C20;LEPCHA LETTER SA;Lo;0;L;;;;;N;;;;;
1C21;LEPCHA LETTER SHA;Lo;0;L;;;;;N;;;;;
1C22;LEPCHA LETTER WA;Lo;0;L;;;;;N;;;;;
1C23;LEPCHA LETTER A;Lo;0;L;;;;;N;;;;;
1C24;LEPCHA SUBJOINED LETTER YA;Mc;0;L;;;;;N;;;;;
1C25;LEPCHA SUBJOINED LETTER RA;Mc;0;L;;;;;N;;;;;
1C26;LEPCHA VOWEL SIGN AA;Mc;0;L;;;;;N;;;;;
1C27;LEPCHA VOWEL SIGN I;Mc;0;L;;;;;N;;;;;
1C28;LEPCHA VOWEL SIGN O;Mc;0;L;;;;;N;;;;;
1C29;LEPCHA VOWEL SIGN OO;Mc;0;L;;;;;N;;;;;
1C2A;LEPCHA VOWEL SIGN U;Mc;0;L;;;;;N;;;;;
1C2B;LEPCHA VOWEL SIGN UU;Mc;0;L;;;;;N;;;;;
1C2C;LEPCHA VOWEL SIGN E;Mn;0;NSM;;;;;N;;;;;
1C2D;LEPCHA CONSONANT SIGN K;Mn;0;NSM;;;;;N;;;;;
1C2E;LEPCHA CONSONANT SIGN M;Mn;0;NSM;;;;;N;;;;;
1C2F;LEPCHA CONSONANT SIGN L;Mn;0;NSM;;;;;N;;;;;
1C30;LEPCHA CONSONANT SIGN N;Mn;0;NSM;;;;;N;;;;;
1C31;LEPCHA CONSONANT SIGN P;Mn;0;NSM;;;;;N;;;;;
1C32;LEPCHA CONSONANT SIGN R;Mn;0;NSM;;;;;N;;;;;
1C33;LEPCHA CONSONANT SIGN T;Mn;0;NSM;;;;;N;;;;;
1C34;LEPCHA CONSONANT SIGN NYIN-DO;Mc;0;L;;;;;N;;;;;
1C35;LEPCHA CONSONANT SIGN KANG;Mc;0;L;;;;;N;;;;;
1C36;LEPCHA SIGN RAN;Mn;0;NSM;;;;;N;;;;;
1C37;LEPCHA SIGN NUKTA;Mn;7;NSM;;;;;N;;;;;
1C3B;LEPCHA PUNCTUATION TA-ROL;Po;0;L;;;;;N;;;;;
1C3C;LEPCHA PUNCTUATION NYET THYOOM TA-ROL;Po;0;L;;;;;N;;;;;
1C3D;LEPCHA PUNCTUATION CER-WA;Po;0;L;;;;;N;;;;;
1C3E;LEPCHA PUNCTUATION TSHOOK CER-WA;Po;0;L;;;;;N;;;;;
1C3F;LEPCHA PUNCTUATION TSHOOK;Po;0;L;;;;;N;;;;;
1C40;LEPCHA DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
1C41;LEPCHA DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
1C42;LEPCHA DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
1C43;LEPCHA DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
1C44;LEPCHA DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
1C45;LEPCHA DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
1C46;LEPCHA DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
1C47;LEPCHA DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
1C48;LEPCHA DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
1C49;LEPCHA DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
1C4D;LEPCHA LETTER TTA;Lo;0;L;;;;;N;;;;;
1C4E;LEPCHA LETTER TTHA;Lo;0;L;;;;;N;;;;;
1C4F;LEPCHA LETTER DDA;Lo;0;L;;;;;N;;;;;
1C50;OL CHIKI DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
1C51;OL CHIKI DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
1C52;OL CHIKI DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
1C53;OL CHIKI DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
1C54;OL CHIKI DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
1C55;OL CHIKI DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
1C56;OL CHIKI DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
1C57;OL CHIKI DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
1C58;OL CHIKI DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
1C59;OL CHIKI DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
1C5A;OL CHIKI LETTER LA;Lo;0;L;;;;;N;;;;;
1C5B;OL CHIKI LETTER AT;Lo;0;L;;;;;N;;;;;
1C5C;OL CHIKI LETTER AG;Lo;0;L;;;;;N;;;;;
1C5D;OL CHIKI LETTER ANG;Lo;0;L;;;;;N;;;;;
1C5E;OL CHIKI LETTER AL;Lo;0;L;;;;;N;;;;;
1C5F;OL CHIKI LETTER LAA;Lo;0;L;;;;;N;;;;;
1C60;OL CHIKI LETTER AAK;Lo;0;L;;;;;N;;;;;
1C61;OL CHIKI LETTER AAJ;Lo;0;L;;;;;N;;;;;
1C62;OL CHIKI LETTER AAM;Lo;0;L;;;;;N;;;;;
1C63;OL CHIKI LETTER AAW;Lo;0;L;;;;;N;;;;;
1C64;OL CHIKI LETTER LI;Lo;0;L;;;;;N;;;;;
1C65;OL CHIKI LETTER IS;Lo;0;L;;;;;N;;;;;
1C66;OL CHIKI LETTER IH;Lo;0;L;;;;;N;;;;;
1C67;OL CHIKI LETTER INY;Lo;0;L;;;;;N;;;;;
1C68;OL CHIKI LETTER IR;Lo;0;L;;;;;N;;;;;
1C69;OL CHIKI LETTER LU;Lo;0;L;;;;;N;;;;;
1C6A;OL CHIKI LETTER UC;Lo;0;L;;;;;N;;;;;
1C6B;OL CHIKI LETTER UD;Lo;0;L;;;;;N;;;;;
1C6C;OL CHIKI LETTER UNN;Lo;0;L;;;;;N;;;;;
1C6D;OL CHIKI LETTER UY;Lo;0;L;;;;;N;;;;;
1C6E;OL CHIKI LETTER LE;Lo;0;L;;;;;N;;;;;
1C6F;OL CHIKI LETTER EP;Lo;0;L;;;;;N;;;;;
1C70;OL CHIKI LETTER EDD;Lo;0;L;;;;;N;;;;;
1C71;OL CHIKI LETTER EN;Lo;0;L;;;;;N;;;;;
1C72;OL CHIKI LETTER ERR;Lo;0;L;;;;;N;;;;;
1C73;OL CHIKI LETTER LO;Lo;0;L;;;;;N;;;;;
1C74;OL CHIKI LETTER OTT;Lo;0;L;;;;;N;;;;;
1C75;OL CHIKI LETTER OB;Lo;0;L;;;;;N;;;;;
1C76;OL CHIKI LETTER OV;Lo;0;L;;;;;N;;;;;
1C77;OL CHIKI LETTER OH;Lo;0;L;;;;;N;;;;;
1C78;OL CHIKI MU TTUDDAG;Lm;0;L;;;;;N;;;;;
1C79;OL CHIKI GAAHLAA TTUDDAAG;Lm;0;L;;;;;N;;;;;
1C7A;OL CHIKI MU-GAAHLAA TTUDDAAG;Lm;0;L;;;;;N;;;;;
1C7B;OL CHIKI RELAA;Lm;0;L;;;;;N;;;;;
1C7C;OL CHIKI PHAARKAA;Lm;0;L;;;;;N;;;;;
1C7D;OL CHIKI AHAD;Lm;0;L;;;;;N;;;;;
1C7E;OL CHIKI PUNCTUATION MUCAAD;Po;0;L;;;;;N;;;;;
1C7F;OL CHIKI PUNCTUATION DOUBLE MUCAAD;Po;0;L;;;;;N;;;;;
1C80;CYRILLIC SMALL LETTER ROUNDED VE;Ll;0;L;;;;;N;;;0412;;0412
1C81;CYRILLIC SMALL LETTER LONG-LEGGED DE;Ll;0;L;;;;;N;;;0414;;0414
1C82;CYRILLIC SMALL LETTER NARROW O;Ll;0;L;;;;;N;;;041E;;041E
1C83;CYRILLIC SMALL LETTER WIDE ES;Ll;0;L;;;;;N;;;0421;;0421
1C84;CYRILLIC SMALL LETTER TALL TE;Ll;0;L;;;;;N;;;0422;;0422
1C85;CYRILLIC SMALL LETTER THREE-LEGGED TE;Ll;0;L;;;;;N;;;0422;;0422
1C86;CYRILLIC SMALL LETTER TALL HARD SIGN;Ll;0;L;;;;;N;;;042A;;042A
1C87;CYRILLIC SMALL LETTER TALL YAT;Ll;0;L;;;;;N;;;0462;;0462
1C88;CYRILLIC SMALL LETTER UNBLENDED UK;Ll;0;L;;;;;N;;;A64A;;A64A
1C90;GEORGIAN MTAVRULI CAPITAL LETTER AN;Lu;0;L;;;;;N;;;;10D0;
1C91;GEORGIAN MTAVRULI CAPITAL LETTER BAN;Lu;0;L;;;;;N;;;;10D1;
1C92;GEORGIAN MTAVRULI CAPITAL LETTER GAN;Lu;0;L;;;;;N;;;;10D2;
1C93;GEORGIAN MTAVRULI CAPITAL LETTER DON;Lu;0;L;;;;;N;;;;10D3;
1C94;GEORGIAN MTAVRULI CAPITAL LETTER EN;Lu;0;L;;;;;N;;;;10D4;
1C95;GEORGIAN MTAVRULI CAPITAL LETTER VIN;Lu;0;L;;;;;N;;;;10D5;
1C96;GEORGIAN MTAVRULI CAPITAL LETTER ZEN;Lu;0;L;;;;;N;;;;10D6;
1C97;GEORGIAN MTAVRULI CAPITAL LETTER TAN;Lu;0;L;;;;;N;;;;10D7;
1C98;GEORGIAN MTAVRULI CAPITAL LETTER IN;Lu;0;L;;;;;N;;;;10D8;
1C99;GEORGIAN MTAVRULI CAPITAL LETTER KAN;Lu;0;L;;;;;N;;;;10D9;
1C9A;GEORGIAN MTAVRULI CAPITAL LETTER LAS;Lu;0;L;;;;;N;;;;10DA;
1C9B;GEORGIAN MTAVRULI CAPITAL LETTER MAN;Lu;0;L;;;;;N;;;;10DB;
1C9C;GEORGIAN MTAVRULI CAPITAL LETTER NAR;Lu;0;L;;;;;N;;;;10DC;
1C9D;GEORGIAN MTAVRULI CAPITAL LETTER ON;Lu;0;L;;;;;N;;;;10DD;
1C9E;GEORGIAN MTAVRULI CAPITAL LETTER PAR;Lu;0;L;;;;;N;;;;10DE;
1C9F;GEORGIAN MTAVRULI CAPITAL LETTER ZHAR;Lu;0;L;;;;;N;;;;10DF;
1CA0;GEORGIAN MTAVRULI CAPITAL LETTER RAE;Lu;0;L;;;;;N;;;;10E0;
1CA1;GEORGIAN MTAVRULI CAPITAL LETTER SAN;Lu;0;L;;;;;N;;;;10E1;
1CA2;GEORGIAN MTAVRULI CAPITAL LETTER TAR;Lu;0;L;;;;;N;;;;10E2;
1CA3;GEORGIAN MTAVRULI CAPITAL LETTER UN;Lu;0;L;;;;;N;;;;10E3;
1CA4;GEORGIAN MTAVRULI CAPITAL LETTER PHAR;Lu;0;L;;;;;N;;;;10E4;
1CA5;GEORGIAN MTAVRULI CAPITAL LETTER KHAR;Lu;0;L;;;;;N;;;;10E5;
1CA6;GEORGIAN MTAVRULI CAPITAL LETTER GHAN;Lu;0;L;;;;;N;;;;10E6;
1CA7;GEORGIAN MTAVRULI CAPITAL LETTER QAR;Lu;0;L;;;;;N;;;;10E7;
1CA8;GEORGIAN MTAVRULI CAPITAL LETTER SHIN;Lu;0;L;;;;;N;;;;10E8;
1CA9;GEORGIAN MTAVRULI CAPITAL LETTER CHIN;Lu;0;L;;;;;N;;;;10E9;
1CAA;GEORGIAN MTAVRULI CAPITAL LETTER CAN;Lu;0;L;;;;;N;;;;10EA;
1CAB;GEORGIAN MTAVRULI CAPITAL LETTER JIL;Lu;0;L;;;;;N;;;;10EB;
1CAC;GEORGIAN MTAVRULI CAPITAL LETTER CIL;Lu;0;L;;;;;N;;;;10EC;
1CAD;GEORGIAN MTAVRULI CAPITAL LETTER CHAR;Lu;0;L;;;;;N;;;;10ED;
1CAE;GEORGIAN MTAVRULI CAPITAL LETTER XAN;Lu;0;L;;;;;N;;;;10EE;
1CAF;GEORGIAN MTAVRULI CAPITAL LETTER JHAN;Lu;0;L;;;;;N;;;;10EF;
1CB0;GEORGIAN MTAVRULI CAPITAL LETTER HAE;Lu;0;L;;;;;N;;;;10F0;
1CB1;GEORGIAN MTAVRULI CAPITAL LETTER HE;Lu;0;L;;;;;N;;;;10F1;
1CB2;GEORGIAN MTAVRULI CAPITAL LETTER HIE;Lu;0;L;;;;;N;;;;10F2;
1CB3;GEORGIAN MTAVRULI CAPITAL LETTER WE;Lu;0;L;;;;;N;;;;10F3;
1CB4;GEORGIAN MTAVRULI CAPITAL LETTER HAR;Lu;0;L;;;;;N;;;;10F4;
1CB5;GEORGIAN MTAVRULI CAPITAL LETTER HOE;Lu;0;L;;;;;N;;;;10F5;
1CB6;GEORGIAN MTAVRULI CAPITAL LETTER FI;Lu;0;L;;;;;N;;;;10F6;
1CB7;GEORGIAN MTAVRULI CAPITAL LETTER YN;Lu;0;L;;;;;N;;;;10F7;
1CB8;GEORGIAN MTAVRULI CAPITAL LETTER ELIFI;Lu;0;L;;;;;N;;;;10F8;
1CB9;GEORGIAN MTAVRULI CAPITAL LETTER TURNED GAN;Lu;0;L;;;;;N;;;;10F9;
1CBA;GEORGIAN MTAVRULI CAPITAL LETTER AIN;Lu;0;L;;;;;N;;;;10FA;
1CBD;GEORGIAN MTAVRULI CAPITAL LETTER AEN;Lu;0;L;;;;;N;;;;10FD;
1CBE;GEORGIAN MTAVRULI CAPITAL LETTER HARD SIGN;Lu;0;L;;;;;N;;;;10FE;
1CBF;GEORGIAN MTAVRULI CAPITAL LETTER LABIAL SIGN;Lu;0;L;;;;;N;;;;10FF;
1CC0;SUNDANESE PUNCTUATION BINDU SURYA;Po;0;L;;;;;N;;;;;
1CC1;SUNDANESE PUNCTUATION BINDU PANGLONG;Po;0;L;;;;;N;;;;;
1CC2;SUNDANESE PUNCTUATION BINDU PURNAMA;Po;0;L;;;;;N;;;;;
1CC3;SUNDANESE PUNCTUATION BINDU CAKRA;Po;0;L;;;;;N;;;;;
1CC4;SUNDANESE PUNCTUATION BINDU LEU SATANGA;Po;0;L;;;;;N;;;;;
1CC5;SUNDANESE PUNCTUATION BINDU KA SATANGA;Po;0;L;;;;;N;;;;;
1CC6;SUNDANESE PUNCTUATION BINDU DA SATANGA;Po;0;L;;;;;N;;;;;
1CC7;SUNDANESE PUNCTUATION BINDU BA SATANGA;Po;0;L;;;;;N;;;;;
1CD0;VEDIC TONE KARSHANA;Mn;230;NSM;;;;;N;;;;;
1CD1;VEDIC TONE SHARA;Mn;230;NSM;;;;;N;;;;;
1CD2;VEDIC TONE PRENKHA;Mn;230;NSM;;;;;N;;;;;
1CD3;VEDIC SIGN NIHSHVASA;Po;0;L;;;;;N;;;;;
1CD4;VEDIC SIGN YAJURVEDIC MIDLINE SVARITA;Mn;1;NSM;;;;;N;;;;;
1CD5;VEDIC TONE YAJURVEDIC AGGRAVATED INDEPENDENT SVARITA;Mn;220;NSM;;;;;N;;;;;
1CD6;VEDIC TONE YAJURVEDIC INDEPENDENT SVARITA;Mn;220;NSM;;;;;N;;;;;
1CD7;VEDIC TONE YAJURVEDIC KATHAKA INDEPENDENT SVARITA;Mn;220;NSM;;;;;N;;;;;
1CD8;VEDIC TONE CANDRA BELOW;Mn;220;NSM;;;;;N;;;;;
1CD9;VEDIC TONE YAJURVEDIC KATHAKA INDEPENDENT SVARITA SCHROEDER;Mn;220;NSM;;;;;N;;;;;
1CDA;VEDIC TONE DOUBLE SVARITA;Mn;230;NSM;;;;;N;;;;;
1CDB;VEDIC TONE TRIPLE SVARITA;Mn;230;NSM;;;;;N;;;;;
1CDC;VEDIC TONE KATHAKA ANUDATTA;Mn;220;NSM;;;;;N;;;;;
1CDD;VEDIC TONE DOT BELOW;Mn;220;NSM;;;;;N;;;;;
1CDE;VEDIC TONE TWO DOTS BELOW;Mn;220;NSM;;;;;N;;;;;
1CDF;VEDIC TONE THREE DOTS BELOW;Mn;220;NSM;;;;;N;;;;;
1CE0;VEDIC TONE RIGVEDIC KASHMIRI INDEPENDENT SVARITA;Mn;230;NSM;;;;;N;;;;;
1CE1;VEDIC TONE ATHARVAVEDIC INDEPENDENT SVARITA;Mc;0;L;;;;;N;;;;;
1CE2;VEDIC SIGN VISARGA SVARITA;Mn;1;NSM;;;;;N;;;;;
1CE3;VEDIC SIGN VISARGA UDATTA;Mn;1;NSM;;;;;N;;;;;
1CE4;VEDIC SIGN REVERSED VISARGA UDATTA;Mn;1;NSM;;;;;N;;;;;
1CE5;VEDIC SIGN VISARGA ANUDATTA;Mn;1;NSM;;;;;N;;;;;
1CE6;VEDIC SIGN REVERSED VISARGA ANUDATTA;Mn;1;NSM;;;;;N;;;;;
1CE7;VEDIC SIGN VISARGA UDATTA WITH TAIL;Mn;1;NSM;;;;;N;;;;;
1CE8;VEDIC SIGN VISARGA ANUDATTA WITH TAIL;Mn;1;NSM;;;;;N;;;;;
1CE9;VEDIC SIGN ANUSVARA ANTARGOMUKHA;Lo;0;L;;;;;N;;;;;
1CEA;VEDIC SIGN ANUSVARA BAHIRGOMUKHA;Lo;0;L;;;;;N;;;;;
1CEB;VEDIC SIGN ANUSVARA VAMAGOMUKHA;Lo;0;L;;;;;N;;;;;
1CEC;VEDIC SIGN ANUSVARA VAMAGOMUKHA WITH TAIL;Lo;0;L;;;;;N;;;;;
1CED;VEDIC SIGN TIRYAK;Mn;220;NSM;;;;;N;;;;;
1CEE;VEDIC SIGN HEXIFORM LONG ANUSVARA;Lo;0;L;;;;;N;;;;;
1CEF;VEDIC SIGN LONG ANUSVARA;Lo;0;L;;;;;N;;;;;
1CF0;VEDIC SIGN RTHANG LONG ANUSVARA;Lo;0;L;;;;;N;;;;;
1CF1;VEDIC SIGN ANUSVARA UBHAYATO MUKHA;Lo;0;L;;;;;N;;;;;
1CF2;VEDIC SIGN ARDHAVISARGA;Lo;0;L;;;;;N;;;;;
1CF3;VEDIC SIGN ROTATED ARDHAVISARGA;Lo;0;L;;;;;N;;;;;
1CF4;VEDIC TONE CANDRA ABOVE;Mn;230;NSM;;;;;N;;;;;
1CF5;VEDIC SIGN JIHVAMULIYA;Lo;0;L;;;;;N;;;;;
1CF6;VEDIC SIGN UPADHMANIYA;Lo;0;L;;;;;N;;;;;
1CF7;VEDIC SIGN ATIKRAMA;Mc;0;L;;;;;N;;;;;
1CF8;VEDIC TONE RING ABOVE;Mn;230;NSM;;;;;N;;;;;
1CF9;VEDIC TONE DOUBLE RING ABOVE;Mn;230;NSM;;;;;N;;;;;
1CFA;VEDIC SIGN DOUBLE ANUSVARA ANTARGOMUKHA;Lo;0;L;;;;;N;;;;;
1D00;LATIN LETTER SMALL CAPITAL A;Ll;0;L;;;;;N;;;;;
1D01;LATIN LETTER SMALL CAPITAL AE;Ll;0;L;;;;;N;;;;;
1D02;LATIN SMALL LETTER TURNED AE;Ll;0;L;;;;;N;;;;;
1D03;LATIN LETTER SMALL CAPITAL BARRED B;Ll;0;L;;;;;N;;;;;
1D04;LATIN LETTER SMALL CAPITAL C;Ll;0;L;;;;;N;;;;;
1D05;LATIN LETTER SMALL CAPITAL D;Ll;0;L;;;;;N;;;;;
1D06;LATIN LETTER SMALL CAPITAL ETH;Ll;0;L;;;;;N;;;;;
1D07;LATIN LETTER SMALL CAPITAL E;Ll;0;L;;;;;N;;;;;
1D08;LATIN SMALL LETTER TURNED OPEN E;Ll;0;L;;;;;N;;;;;
1D09;LATIN SMALL LETTER TURNED I;Ll;0;L;;;;;N;;;;;
1D0A;LATIN LETTER SMALL CAPITAL J;Ll;0;L;;;;;N;;;;;
1D0B;LATIN LETTER SMALL CAPITAL K;Ll;0;L;;;;;N;;;;;
1D0C;LATIN LETTER SMALL CAPITAL L WITH STROKE;Ll;0;L;;;;;N;;;;;
1D0D;LATIN LETTER SMALL CAPITAL M;Ll;0;L;;;;;N;;;;;
1D0E;LATIN LETTER SMALL CAPITAL REVERSED N;Ll;0;L;;;;;N;;;;;
1D0F;LATIN LETTER SMALL CAPITAL O;Ll;0;L;;;;;N;;;;;
1D10;LATIN LETTER SMALL CAPITAL OPEN O;Ll;0;L;;;;;N;;;;;
1D11;LATIN SMALL LETTER SIDEWAYS O;Ll;0;L;;;;;N;;;;;
1D12;LATIN SMALL LETTER SIDEWAYS OPEN O;Ll;0;L;;;;;N;;;;;
1D13;LATIN SMALL LETTER SIDEWAYS O WITH STROKE;Ll;0;L;;;;;N;;;;;
1D14;LATIN SMALL LETTER TURNED OE;Ll;0;L;;;;;N;;;;;
1D15;LATIN LETTER SMALL CAPITAL OU;Ll;0;L;;;;;N;;;;;
1D16;LATIN SMALL LETTER TOP HALF O;Ll;0;L;;;;;N;;;;;
1D17;LATIN SMALL LETTER BOTTOM HALF O;Ll;0;L;;;;;N;;;;;
1D18;LATIN LETTER SMALL CAPITAL P;Ll;0;L;;;;;N;;;;;
1D19;LATIN LETTER SMALL CAPITAL REVERSED R;Ll;0;L;;;;;N;;;;;
1D1A;LATIN LETTER SMALL CAPITAL TURNED R;Ll;0;L;;;;;N;;;;;
1D1B;LATIN LETTER SMALL CAPITAL T;Ll;0;L;;;;;N;;;;;
1D1C;LATIN LETTER SMALL CAPITAL U;Ll;0;L;;;;;N;;;;;
1D1D;LATIN SMALL LETTER SIDEWAYS U;Ll;0;L;;;;;N;;;;;
1D1E;LATIN SMALL LETTER SIDEWAYS DIAERESIZED U;Ll;0;L;;;;;N;;;;;
1D1F;LATIN SMALL LETTER SIDEWAYS TURNED M;Ll;0;L;;;;;N;;;;;
1D20;LATIN LETTER SMALL CAPITAL V;Ll;0;L;;;;;N;;;;;
1D21;LATIN LETTER SMALL CAPITAL W;Ll;0;L;;;;;N;;;;;
1D22;LATIN LETTER SMALL CAPITAL Z;Ll;0;L;;;;;N;;;;;
1D23;LATIN LETTER SMALL CAPITAL EZH;Ll;0;L;;;;;N;;;;;
1D24;LATIN LETTER VOICED LARYNGEAL SPIRANT;Ll;0;L;;;;;N;;;;;
1D25;LATIN LETTER AIN;Ll;0;L;;;;;N;;;;;
1D26;GREEK LETTER SMALL CAPITAL GAMMA;Ll;0;L;;;;;N;;;;;
1D27;GREEK LETTER SMALL CAPITAL LAMDA;Ll;0;L;;;;;N;;;;;
1D28;GREEK LETTER SMALL CAPITAL PI;Ll;0;L;;;;;N;;;;;
1D29;GREEK LETTER SMALL CAPITAL RHO;Ll;0;L;;;;;N;;;;;
1D2A;GREEK LETTER SMALL CAPITAL PSI;Ll;0;L;;;;;N;;;;;
1D2B;CYRILLIC LETTER SMALL CAPITAL EL;Ll;0;L;;;;;N;;;;;
1D2C;MODIFIER LETTER CAPITAL A;Lm;0;L;<super> 0041;;;;N;;;;;
1D2D;MODIFIER LETTER CAPITAL AE;Lm;0;L;<super> 00C6;;;;N;;;;;
1D2E;MODIFIER LETTER CAPITAL B;Lm;0;L;<super> 0042;;;;N;;;;;
1D2F;MODIFIER LETTER CAPITAL BARRED B;Lm;0;L;;;;;N;;;;;
1D30;MODIFIER LETTER CAPITAL D;Lm;0;L;<super> 0044;;;;N;;;;;
1D31;MODIFIER LETTER CAPITAL E;Lm;0;L;<super> 0045;;;;N;;;;;
1D32;MODIFIER LETTER CAPITAL REVERSED E;Lm;0;L;<super> 018E;;;;N;;;;;
1D33;MODIFIER LETTER CAPITAL G;Lm;0;L;<super> 0047;;;;N;;;;;
1D34;MODIFIER LETTER CAPITAL H;Lm;0;L;<super> 0048;;;;N;;;;;
1D35;MODIFIER LETTER CAPITAL I;Lm;0;L;<super> 0049;;;;N;;;;;
1D36;MODIFIER LETTER CAPITAL J;Lm;0;L;<super> 004A;;;;N;;;;;
1D37;MODIFIER LETTER CAPITAL K;Lm;0;L;<super> 004B;;;;N;;;;;
1D38;MODIFIER LETTER CAPITAL L;Lm;0;L;<super> 004C;;;;N;;;;;
1D39;MODIFIER LETTER CAPITAL M;Lm;0;L;<super> 004D;;;;N;;;;;
1D3A;MODIFIER LETTER CAPITAL N;Lm;0;L;<super> 004E;;;;N;;;;;
1D3B;MODIFIER LETTER CAPITAL REVERSED N;Lm;0;L;;;;;N;;;;;
1D3C;MODIFIER LETTER CAPITAL O;Lm;0;L;<super> 004F;;;;N;;;;;
1D3D;MODIFIER LETTER CAPITAL OU;Lm;0;L;<super> 0222;;;;N;;;;;
1D3E;MODIFIER LETTER CAPITAL P;Lm;0;L;<super> 0050;;;;N;;;;;
1D3F;MODIFIER LETTER CAPITAL R;Lm;0;L;<super> 0052;;;;N;;;;;
1D40;MODIFIER LETTER CAPITAL T;Lm;0;L;<super> 0054;;;;N;;;;;
1D41;MODIFIER LETTER CAPITAL U;Lm;0;L;<super> 0055;;;;N;;;;;
1D42;MODIFIER LETTER CAPITAL W;Lm;0;L;<super> 0057;;;;N;;;;;
1D43;MODIFIER LETTER SMALL A;Lm;0;L;<super> 0061;;;;N;;;;;
1D44;MODIFIER LETTER SMALL TURNED A;Lm;0;L;<super> 0250;;;;N;;;;;
1D45;MODIFIER LETTER SMALL ALPHA;Lm;0;L;<super> 0251;;;;N;;;;;
1D46;MODIFIER LETTER SMALL TURNED AE;Lm;0;L;<super> 1D02;;;;N;;;;;
1D47;MODIFIER LETTER SMALL B;Lm;0;L;<super> 0062;;;;N;;;;;
1D48;MODIFIER LETTER SMALL D;Lm;0;L;<super> 0064;;;;N;;;;;
1D49;MODIFIER LETTER SMALL E;Lm;0;L;<super> 0065;;;;N;;;;;
1D4A;MODIFIER LETTER SMALL SCHWA;Lm;0;L;<super> 0259;;;;N;;;;;
1D4B;MODIFIER LETTER SMALL OPEN E;Lm;0;L;<super> 025B;;;;N;;;;;
1D4C;MODIFIER LETTER SMALL TURNED OPEN E;Lm;0;L;<super> 025C;;;;N;;;;;
1D4D;MODIFIER LETTER SMALL G;Lm;0;L;<super> 0067;;;;N;;;;;
1D4E;MODIFIER LETTER SMALL TURNED I;Lm;0;L;;;;;N;;;;;
1D4F;MODIFIER LETTER SMALL K;Lm;0;L;<super> 006B;;;;N;;;;;
1D50;MODIFIER LETTER SMALL M;Lm;0;L;<super> 006D;;;;N;;;;;
1D51;MODIFIER LETTER SMALL ENG;Lm;0;L;<super> 014B;;;;N;;;;;
1D52;MODIFIER LETTER SMALL O;Lm;0;L;<super> 006F;;;;N;;;;;
1D53;MODIFIER LETTER SMALL OPEN O;Lm;0;L;<super> 0254;;;;N;;;;;
1D54;MODIFIER LETTER SMALL TOP HALF O;Lm;0;L;<super> 1D16;;;;N;;;;;
1D55;MODIFIER LETTER SMALL BOTTOM HALF O;Lm;0;L;<super> 1D17;;;;N;;;;;
1D56;MODIFIER LETTER SMALL P;Lm;0;L;<super> 0070;;;;N;;;;;
1D57;MODIFIER LETTER SMALL T;Lm;0;L;<super> 0074;;;;N;;;;;
1D58;MODIFIER LETTER SMALL U;Lm;0;L;<super> 0075;;;;N;;;;;
1D59;MODIFIER LETTER SMALL SIDEWAYS U;Lm;0;L;<super> 1D1D;;;;N;;;;;
1D5A;MODIFIER LETTER SMALL TURNED M;Lm;0;L;<super> 026F;;;;N;;;;;
1D5B;MODIFIER LETTER SMALL V;Lm;0;L;<super> 0076;;;;N;;;;;
1D5C;MODIFIER LETTER SMALL AIN;Lm;0;L;<super> 1D25;;;;N;;;;;
1D5D;MODIFIER LETTER SMALL BETA;Lm;0;L;<super> 03B2;;;;N;;;;;
1D5E;MODIFIER LETTER SMALL GREEK GAMMA;Lm;0;L;<super> 03B3;;;;N;;;;;
1D5F;MODIFIER LETTER SMALL DELTA;Lm;0;L;<super> 03B4;;;;N;;;;;
1D60;MODIFIER LETTER SMALL GREEK PHI;Lm;0;L;<super> 03C6;;;;N;;;;;
1D61;MODIFIER LETTER SMALL CHI;Lm;0;L;<super> 03C7;;;;N;;;;;
1D62;LATIN SUBSCRIPT SMALL LETTER I;Lm;0;L;<sub> 0069;;;;N;;;;;
1D63;LATIN SUBSCRIPT SMALL LETTER R;Lm;0;L;<sub> 0072;;;;N;;;;;
1D64;LATIN SUBSCRIPT SMALL LETTER U;Lm;0;L;<sub> 0075;;;;N;;;;;
1D65;LATIN SUBSCRIPT SMALL LETTER V;Lm;0;L;<sub> 0076;;;;N;;;;;
1D66;GREEK SUBSCRIPT SMALL LETTER BETA;Lm;0;L;<sub> 03B2;;;;N;;;;;
1D67;GREEK SUBSCRIPT SMALL LETTER GAMMA;Lm;0;L;<sub> 03B3;;;;N;;;;;
1D68;GREEK SUBSCRIPT SMALL LETTER RHO;Lm;0;L;<sub> 03C1;;;;N;;;;;
1D69;GREEK SUBSCRIPT SMALL LETTER PHI;Lm;0;L;<sub> 03C6;;;;N;;;;;
1D6A;GREEK SUBSCRIPT SMALL LETTER CHI;Lm;0;L;<sub> 03C7;;;;N;;;;;
1D6B;LATIN SMALL LETTER UE;Ll;0;L;;;;;N;;;;;
1D6C;LATIN SMALL LETTER B WITH MIDDLE TILDE;Ll;0;L;;;;;N;;;;;
1D6D;LATIN SMALL LETTER D WITH MIDDLE TILDE;Ll;0;L;;;;;N;;;;;
1D6E;LATIN SMALL LETTER F WITH MIDDLE TILDE;Ll;0;L;;;;;N;;;;;
1D6F;LATIN SMALL LETTER M WITH MIDDLE TILDE;Ll;0;L;;;;;N;;;;;
1D70;LATIN SMALL LETTER N WITH MIDDLE TILDE;Ll;0;L;;;;;N;;;;;
1D71;LATIN SMALL LETTER P WITH MIDDLE TILDE;Ll;0;L;;;;;N;;;;;
1D72;LATIN SMALL LETTER R WITH MIDDLE TILDE;Ll;0;L;;;;;N;;;;;
1D73;LATIN SMALL LETTER R WITH FISHHOOK AND MIDDLE TILDE;Ll;0;L;;;;;N;;;;;
1D74;LATIN SMALL LETTER S WITH MIDDLE TILDE;Ll;0;L;;;;;N;;;;;
1D75;LATIN SMALL LETTER T WITH MIDDLE TILDE;Ll;0;L;;;;;N;;;;;
1D76;LATIN SMALL LETTER Z WITH MIDDLE TILDE;Ll;0;L;;;;;N;;;;;
1D77;LATIN SMALL LETTER TURNED G;Ll;0;L;;;;;N;;;;;
1D78;MODIFIER LETTER CYRILLIC EN;Lm;0;L;<super> 043D;;;;N;;;;;
1D79;LATIN SMALL LETTER INSULAR G;Ll;0;L;;;;;N;;;A77D;;A77D
1D7A;LATIN SMALL LETTER TH WITH STRIKETHROUGH;Ll;0;L;;;;;N;;;;;
1D7B;LATIN SMALL CAPITAL LETTER I WITH STROKE;Ll;0;L;;;;;N;;;;;
1D7C;LATIN SMALL LETTER IOTA WITH STROKE;Ll;0;L;;;;;N;;;;;
1D7D;LATIN SMALL LETTER P WITH STROKE;Ll;0;L;;;;;N;;;2C63;;2C63
1D7E;LATIN SMALL CAPITAL LETTER U WITH STROKE;Ll;0;L;;;;;N;;;;;
1D7F;LATIN SMALL LETTER UPSILON WITH STROKE;Ll;0;L;;;;;N;;;;;
1D80;LATIN SMALL LETTER B WITH PALATAL HOOK;Ll;0;L;;;;;N;;;;;
1D81;LATIN SMALL LETTER D WITH PALATAL HOOK;Ll;0;L;;;;;N;;;;;
1D82;LATIN SMALL LETTER F WITH PALATAL HOOK;Ll;0;L;;;;;N;;;;;
1D83;LATIN SMALL LETTER G WITH PALATAL HOOK;Ll;0;L;;;;;N;;;;;
1D84;LATIN SMALL LETTER K WITH PALATAL HOOK;Ll;0;L;;;;;N;;;;;
1D85;LATIN SMALL LETTER L WITH PALATAL HOOK;Ll;0;L;;;;;N;;;;;
1D86;LATIN SMALL LETTER M WITH PALATAL HOOK;Ll;0;L;;;;;N;;;;;
1D87;LATIN SMALL LETTER N WITH PALATAL HOOK;Ll;0;L;;;;;N;;;;;
1D88;LATIN SMALL LETTER P WITH PALATAL HOOK;Ll;0;L;;;;;N;;;;;
1D89;LATIN SMALL LETTER R WITH PALATAL HOOK;Ll;0;L;;;;;N;;;;;
1D8A;LATIN SMALL LETTER S WITH PALATAL HOOK;Ll;0;L;;;;;N;;;;;
1D8B;LATIN SMALL LETTER ESH WITH PALATAL HOOK;Ll;0;L;;;;;N;;;;;
1D8C;LATIN SMALL LETTER V WITH PALATAL HOOK;Ll;0;L;;;;;N;;;;;
1D8D;LATIN SMALL LETTER X WITH PALATAL HOOK;Ll;0;L;;;;;N;;;;;
1D8E;LATIN SMALL LETTER Z WITH PALATAL HOOK;Ll;0;L;;;;;N;;;A7C6;;A7C6
1D8F;LATIN SMALL LETTER A WITH RETROFLEX HOOK;Ll;0;L;;;;;N;;;;;
1D90;LATIN SMALL LETTER ALPHA WITH RETROFLEX HOOK;Ll;0;L;;;;;N;;;;;
1D91;LATIN SMALL LETTER D WITH HOOK AND TAIL;Ll;0;L;;;;;N;;;;;
1D92;LATIN SMALL LETTER E WITH RETROFLEX HOOK;Ll;0;L;;;;;N;;;;;
1D93;LATIN SMALL LETTER OPEN E WITH RETROFLEX HOOK;Ll;0;L;;;;;N;;;;;
1D94;LATIN SMALL LETTER REVERSED OPEN E WITH RETROFLEX HOOK;Ll;0;L;;;;;N;;;;;
1D95;LATIN SMALL LETTER SCHWA WITH RETROFLEX HOOK;Ll;0;L;;;;;N;;;;;
1D96;LATIN SMALL LETTER I WITH RETROFLEX HOOK;Ll;0;L;;;;;N;;;;;
1D97;LATIN SMALL LETTER OPEN O WITH RETROFLEX HOOK;Ll;0;L;;;;;N;;;;;
1D98;LATIN SMALL LETTER ESH WITH RETROFLEX HOOK;Ll;0;L;;;;;N;;;;;
1D99;LATIN SMALL LETTER U WITH RETROFLEX HOOK;Ll;0;L;;;;;N;;;;;
1D9A;LATIN SMALL LETTER EZH WITH RETROFLEX HOOK;Ll;0;L;;;;;N;;;;;
1D9B;MODIFIER LETTER SMALL TURNED ALPHA;Lm;0;L;<super> 0252;;;;N;;;;;
1D9C;MODIFIER LETTER SMALL C;Lm;0;L;<super> 0063;;;;N;;;;;
1D9D;MODIFIER LETTER SMALL C WITH CURL;Lm;0;L;<super> 0255;;;;N;;;;;
1D9E;MODIFIER LETTER SMALL ETH;Lm;0;L;<super> 00F0;;;;N;;;;;
1D9F;MODIFIER LETTER SMALL REVERSED OPEN E;Lm;0;L;<super> 025C;;;;N;;;;;
1DA0;MODIFIER LETTER SMALL F;Lm;0;L;<super> 0066;;;;N;;;;;
1DA1;MODIFIER LETTER SMALL DOTLESS J WITH STROKE;Lm;0;L;<super> 025F;;;;N;;;;;
1DA2;MODIFIER LETTER SMALL SCRIPT G;Lm;0;L;<super> 0261;;;;N;;;;;
1DA3;MODIFIER LETTER SMALL TURNED H;Lm;0;L;<super> 0265;;;;N;;;;;
1DA4;MODIFIER LETTER SMALL I WITH STROKE;Lm;0;L;<super> 0268;;;;N;;;;;
1DA5;MODIFIER LETTER SMALL IOTA;Lm;0;L;<super> 0269;;;;N;;;;;
1DA6;MODIFIER LETTER SMALL CAPITAL I;Lm;0;L;<super> 026A;;;;N;;;;;
1DA7;MODIFIER LETTER SMALL CAPITAL I WITH STROKE;Lm;0;L;<super> 1D7B;;;;N;;;;;
1DA8;MODIFIER LETTER SMALL J WITH CROSSED-TAIL;Lm;0;L;<super> 029D;;;;N;;;;;
1DA9;MODIFIER LETTER SMALL L WITH RETROFLEX HOOK;Lm;0;L;<super> 026D;;;;N;;;;;
1DAA;MODIFIER LETTER SMALL L WITH PALATAL HOOK;Lm;0;L;<super> 1D85;;;;N;;;;;
1DAB;MODIFIER LETTER SMALL CAPITAL L;Lm;0;L;<super> 029F;;;;N;;;;;
1DAC;MODIFIER LETTER SMALL M WITH HOOK;Lm;0;L;<super> 0271;;;;N;;;;;
1DAD;MODIFIER LETTER SMALL TURNED M WITH LONG LEG;Lm;0;L;<super> 0270;;;;N;;;;;
1DAE;MODIFIER LETTER SMALL N WITH LEFT HOOK;Lm;0;L;<super> 0272;;;;N;;;;;
1DAF;MODIFIER LETTER SMALL N WITH RETROFLEX HOOK;Lm;0;L;<super> 0273;;;;N;;;;;
1DB0;MODIFIER LETTER SMALL CAPITAL N;Lm;0;L;<super> 0274;;;;N;;;;;
1DB1;MODIFIER LETTER SMALL BARRED O;Lm;0;L;<super> 0275;;;;N;;;;;
1DB2;MODIFIER LETTER SMALL PHI;Lm;0;L;<super> 0278;;;;N;;;;;
1DB3;MODIFIER LETTER SMALL S WITH HOOK;Lm;0;L;<super> 0282;;;;N;;;;;
1DB4;MODIFIER LETTER SMALL ESH;Lm;0;L;<super> 0283;;;;N;;;;;
1DB5;MODIFIER LETTER SMALL T WITH PALATAL HOOK;Lm;0;L;<super> 01AB;;;;N;;;;;
1DB6;MODIFIER LETTER SMALL U BAR;Lm;0;L;<super> 0289;;;;N;;;;;
1DB7;MODIFIER LETTER SMALL UPSILON;Lm;0;L;<super> 028A;;;;N;;;;;
1DB8;MODIFIER LETTER SMALL CAPITAL U;Lm;0;L;<super> 1D1C;;;;N;;;;;
1DB9;MODIFIER LETTER SMALL V WITH HOOK;Lm;0;L;<super> 028B;;;;N;;;;;
1DBA;MODIFIER LETTER SMALL TURNED V;Lm;0;L;<super> 028C;;;;N;;;;;
1DBB;MODIFIER LETTER SMALL Z;Lm;0;L;<super> 007A;;;;N;;;;;
1DBC;MODIFIER LETTER SMALL Z WITH RETROFLEX HOOK;Lm;0;L;<super> 0290;;;;N;;;;;
1DBD;MODIFIER LETTER SMALL Z WITH CURL;Lm;0;L;<super> 0291;;;;N;;;;;
1DBE;MODIFIER LETTER SMALL EZH;Lm;0;L;<super> 0292;;;;N;;;;;
1DBF;MODIFIER LETTER SMALL THETA;Lm;0;L;<super> 03B8;;;;N;;;;;
1DC0;COMBINING DOTTED GRAVE ACCENT;Mn;230;NSM;;;;;N;;;;;
1DC1;COMBINING DOTTED ACUTE ACCENT;Mn;230;NSM;;;;;N;;;;;
1DC2;COMBINING SNAKE BELOW;Mn;220;NSM;;;;;N;;;;;
1DC3;COMBINING SUSPENSION MARK;Mn;230;NSM;;;;;N;;;;;
1DC4;COMBINING MACRON-ACUTE;Mn;230;NSM;;;;;N;;;;;
1DC5;COMBINING GRAVE-MACRON;Mn;230;NSM;;;;;N;;;;;
1DC6;COMBINING MACRON-GRAVE;Mn;230;NSM;;;;;N;;;;;
1DC7;COMBINING ACUTE-MACRON;Mn;230;NSM;;;;;N;;;;;
1DC8;COMBINING GRAVE-ACUTE-GRAVE;Mn;230;NSM;;;;;N;;;;;
1DC9;COMBINING ACUTE-GRAVE-ACUTE;Mn;230;NSM;;;;;N;;;;;
1DCA;COMBINING LATIN SMALL LETTER R BELOW;Mn;220;NSM;;;;;N;;;;;
1DCB;COMBINING BREVE-MACRON;Mn;230;NSM;;;;;N;;;;;
1DCC;COMBINING MACRON-BREVE;Mn;230;NSM;;;;;N;;;;;
1DCD;COMBINING DOUBLE CIRCUMFLEX ABOVE;Mn;234;NSM;;;;;N;;;;;
1DCE;COMBINING OGONEK ABOVE;Mn;214;NSM;;;;;N;;;;;
1DCF;COMBINING ZIGZAG BELOW;Mn;220;NSM;;;;;N;;;;;
1DD0;COMBINING IS BELOW;Mn;202;NSM;;;;;N;;;;;
1DD1;COMBINING UR ABOVE;Mn;230;NSM;;;;;N;;;;;
1DD2;COMBINING US ABOVE;Mn;230;NSM;;;;;N;;;;;
1DD3;COMBINING LATIN SMALL LETTER FLATTENED OPEN A ABOVE;Mn;230;NSM;;;;;N;;;;;
1DD4;COMBINING LATIN SMALL LETTER AE;Mn;230;NSM;;;;;N;;;;;
1DD5;COMBINING LATIN SMALL LETTER AO;Mn;230;NSM;;;;;N;;;;;
1DD6;COMBINING LATIN SMALL LETTER AV;Mn;230;NSM;;;;;N;;;;;
1DD7;COMBINING LATIN SMALL LETTER C CEDILLA;Mn;230;NSM;;;;;N;;;;;
1DD8;COMBINING LATIN SMALL LETTER INSULAR D;Mn;230;NSM;;;;;N;;;;;
1DD9;COMBINING LATIN SMALL LETTER ETH;Mn;230;NSM;;;;;N;;;;;
1DDA;COMBINING LATIN SMALL LETTER G;Mn;230;NSM;;;;;N;;;;;
1DDB;COMBINING LATIN LETTER SMALL CAPITAL G;Mn;230;NSM;;;;;N;;;;;
1DDC;COMBINING LATIN SMALL LETTER K;Mn;230;NSM;;;;;N;;;;;
1DDD;COMBINING LATIN SMALL LETTER L;Mn;230;NSM;;;;;N;;;;;
1DDE;COMBINING LATIN LETTER SMALL CAPITAL L;Mn;230;NSM;;;;;N;;;;;
1DDF;COMBINING LATIN LETTER SMALL CAPITAL M;Mn;230;NSM;;;;;N;;;;;
1DE0;COMBINING LATIN SMALL LETTER N;Mn;230;NSM;;;;;N;;;;;
1DE1;COMBINING LATIN LETTER SMALL CAPITAL N;Mn;230;NSM;;;;;N;;;;;
1DE2;COMBINING LATIN LETTER SMALL CAPITAL R;Mn;230;NSM;;;;;N;;;;;
1DE3;COMBINING LATIN SMALL LETTER R ROTUNDA;Mn;230;NSM;;;;;N;;;;;
1DE4;COMBINING LATIN SMALL LETTER S;Mn;230;NSM;;;;;N;;;;;
1DE5;COMBINING LATIN SMALL LETTER LONG S;Mn;230;NSM;;;;;N;;;;;
1DE6;COMBINING LATIN SMALL LETTER Z;Mn;230;NSM;;;;;N;;;;;
1DE7;COMBINING LATIN SMALL LETTER ALPHA;Mn;230;NSM;;;;;N;;;;;
1DE8;COMBINING LATIN SMALL LETTER B;Mn;230;NSM;;;;;N;;;;;
1DE9;COMBINING LATIN SMALL LETTER BETA;Mn;230;NSM;;;;;N;;;;;
1DEA;COMBINING LATIN SMALL LETTER SCHWA;Mn;230;NSM;;;;;N;;;;;
1DEB;COMBINING LATIN SMALL LETTER F;Mn;230;NSM;;;;;N;;;;;
1DEC;COMBINING LATIN SMALL LETTER L WITH DOUBLE MIDDLE TILDE;Mn;230;NSM;;;;;N;;;;;
1DED;COMBINING LATIN SMALL LETTER O WITH LIGHT CENTRALIZATION STROKE;Mn;230;NSM;;;;;N;;;;;
1DEE;COMBINING LATIN SMALL LETTER P;Mn;230;NSM;;;;;N;;;;;
1DEF;COMBINING LATIN SMALL LETTER ESH;Mn;230;NSM;;;;;N;;;;;
1DF0;COMBINING LATIN SMALL LETTER U WITH LIGHT CENTRALIZATION STROKE;Mn;230;NSM;;;;;N;;;;;
1DF1;COMBINING LATIN SMALL LETTER W;Mn;230;NSM;;;;;N;;;;;
1DF2;COMBINING LATIN SMALL LETTER A WITH DIAERESIS;Mn;230;NSM;;;;;N;;;;;
1DF3;COMBINING LATIN SMALL LETTER O WITH DIAERESIS;Mn;230;NSM;;;;;N;;;;;
1DF4;COMBINING LATIN SMALL LETTER U WITH DIAERESIS;Mn;230;NSM;;;;;N;;;;;
1DF5;COMBINING UP TACK ABOVE;Mn;230;NSM;;;;;N;;;;;
1DF6;COMBINING KAVYKA ABOVE RIGHT;Mn;232;NSM;;;;;N;;;;;
1DF7;COMBINING KAVYKA ABOVE LEFT;Mn;228;NSM;;;;;N;;;;;
1DF8;COMBINING DOT ABOVE LEFT;Mn;228;NSM;;;;;N;;;;;
1DF9;COMBINING WIDE INVERTED BRIDGE BELOW;Mn;220;NSM;;;;;N;;;;;
1DFA;COMBINING DOT BELOW LEFT;Mn;218;NSM;;;;;N;;;;;
1DFB;COMBINING DELETION MARK;Mn;230;NSM;;;;;N;;;;;
1DFC;COMBINING DOUBLE INVERTED BREVE BELOW;Mn;233;NSM;;;;;N;;;;;
1DFD;COMBINING ALMOST EQUAL TO BELOW;Mn;220;NSM;;;;;N;;;;;
1DFE;COMBINING LEFT ARROWHEAD ABOVE;Mn;230;NSM;;;;;N;;;;;
1DFF;COMBINING RIGHT ARROWHEAD AND DOWN ARROWHEAD BELOW;Mn;220;NSM;;;;;N;;;;;
1E00;LATIN CAPITAL LETTER A WITH RING BELOW;Lu;0;L;0041 0325;;;;N;;;;1E01;
1E01;LATIN SMALL LETTER A WITH RING BELOW;Ll;0;L;0061 0325;;;;N;;;1E00;;1E00
1E02;LATIN CAPITAL LETTER B WITH DOT ABOVE;Lu;0;L;0042 0307;;;;N;;;;1E03;
1E03;LATIN SMALL LETTER B WITH DOT ABOVE;Ll;0;L;0062 0307;;;;N;;;1E02;;1E02
1E04;LATIN CAPITAL LETTER B WITH DOT BELOW;Lu;0;L;0042 0323;;;;N;;;;1E05;
1E05;LATIN SMALL LETTER B WITH DOT BELOW;Ll;0;L;0062 0323;;;;N;;;1E04;;1E04
1E06;LATIN CAPITAL LETTER B WITH LINE BELOW;Lu;0;L;0042 0331;;;;N;;;;1E07;
1E07;LATIN SMALL LETTER B WITH LINE BELOW;Ll;0;L;0062 0331;;;;N;;;1E06;;1E06
1E08;LATIN CAPITAL LETTER C WITH CEDILLA AND ACUTE;Lu;0;L;00C7 0301;;;;N;;;;1E09;
1E09;LATIN SMALL LETTER C WITH CEDILLA AND ACUTE;Ll;0;L;00E7 0301;;;;N;;;1E08;;1E08
1E0A;LATIN CAPITAL LETTER D WITH DOT ABOVE;Lu;0;L;0044 0307;;;;N;;;;1E0B;
1E0B;LATIN SMALL LETTER D WITH DOT ABOVE;Ll;0;L;0064 0307;;;;N;;;1E0A;;1E0A
1E0C;LATIN CAPITAL LETTER D WITH DOT BELOW;Lu;0;L;0044 0323;;;;N;;;;1E0D;
1E0D;LATIN SMALL LETTER D WITH DOT BELOW;Ll;0;L;0064 0323;;;;N;;;1E0C;;1E0C
1E0E;LATIN CAPITAL LETTER D WITH LINE BELOW;Lu;0;L;0044 0331;;;;N;;;;1E0F;
1E0F;LATIN SMALL LETTER D WITH LINE BELOW;Ll;0;L;0064 0331;;;;N;;;1E0E;;1E0E
1E10;LATIN CAPITAL LETTER D WITH CEDILLA;Lu;0;L;0044 0327;;;;N;;;;1E11;
1E11;LATIN SMALL LETTER D WITH CEDILLA;Ll;0;L;0064 0327;;;;N;;;1E10;;1E10
1E12;LATIN CAPITAL LETTER D WITH CIRCUMFLEX BELOW;Lu;0;L;0044 032D;;;;N;;;;1E13;
1E13;LATIN SMALL LETTER D WITH CIRCUMFLEX BELOW;Ll;0;L;0064 032D;;;;N;;;1E12;;1E12
1E14;LATIN CAPITAL LETTER E WITH MACRON AND GRAVE;Lu;0;L;0112 0300;;;;N;;;;1E15;
1E15;LATIN SMALL LETTER E WITH MACRON AND GRAVE;Ll;0;L;0113 0300;;;;N;;;1E14;;1E14
1E16;LATIN CAPITAL LETTER E WITH MACRON AND ACUTE;Lu;0;L;0112 0301;;;;N;;;;1E17;
1E17;LATIN SMALL LETTER E WITH MACRON AND ACUTE;Ll;0;L;0113 0301;;;;N;;;1E16;;1E16
1E18;LATIN CAPITAL LETTER E WITH CIRCUMFLEX BELOW;Lu;0;L;0045 032D;;;;N;;;;1E19;
1E19;LATIN SMALL LETTER E WITH CIRCUMFLEX BELOW;Ll;0;L;0065 032D;;;;N;;;1E18;;1E18
1E1A;LATIN CAPITAL LETTER E WITH TILDE BELOW;Lu;0;L;0045 0330;;;;N;;;;1E1B;
1E1B;LATIN SMALL LETTER E WITH TILDE BELOW;Ll;0;L;0065 0330;;;;N;;;1E1A;;1E1A
1E1C;LATIN CAPITAL LETTER E WITH CEDILLA AND BREVE;Lu;0;L;0228 0306;;;;N;;;;1E1D;
1E1D;LATIN SMALL LETTER E WITH CEDILLA AND BREVE;Ll;0;L;0229 0306;;;;N;;;1E1C;;1E1C
1E1E;LATIN CAPITAL LETTER F WITH DOT ABOVE;Lu;0;L;0046 0307;;;;N;;;;1E1F;
1E1F;LATIN SMALL LETTER F WITH DOT ABOVE;Ll;0;L;0066 0307;;;;N;;;1E1E;;1E1E
1E20;LATIN CAPITAL LETTER G WITH MACRON;Lu;0;L;0047 0304;;;;N;;;;1E21;
1E21;LATIN SMALL LETTER G WITH MACRON;Ll;0;L;0067 0304;;;;N;;;1E20;;1E20
1E22;LATIN CAPITAL LETTER H WITH DOT ABOVE;Lu;0;L;0048 0307;;;;N;;;;1E23;
1E23;LATIN SMALL LETTER H WITH DOT ABOVE;Ll;0;L;0068 0307;;;;N;;;1E22;;1E22
1E24;LATIN CAPITAL LETTER H WITH DOT BELOW;Lu;0;L;0048 0323;;;;N;;;;1E25;
1E25;LATIN SMALL LETTER H WITH DOT BELOW;Ll;0;L;0068 0323;;;;N;;;1E24;;1E24
1E26;LATIN CAPITAL LETTER H WITH DIAERESIS;Lu;0;L;0048 0308;;;;N;;;;1E27;
1E27;LATIN SMALL LETTER H WITH DIAERESIS;Ll;0;L;0068 0308;;;;N;;;1E26;;1E26
1E28;LATIN CAPITAL LETTER H WITH CEDILLA;Lu;0;L;0048 0327;;;;N;;;;1E29;
1E29;LATIN SMALL LETTER H WITH CEDILLA;Ll;0;L;0068 0327;;;;N;;;1E28;;1E28
1E2A;LATIN CAPITAL LETTER H WITH BREVE BELOW;Lu;0;L;0048 032E;;;;N;;;;1E2B;
1E2B;LATIN SMALL LETTER H WITH BREVE BELOW;Ll;0;L;0068 032E;;;;N;;;1E2A;;1E2A
1E2C;LATIN CAPITAL LETTER I WITH TILDE BELOW;Lu;0;L;0049 0330;;;;N;;;;1E2D;
1E2D;LATIN SMALL LETTER I WITH TILDE BELOW;Ll;0;L;0069 0330;;;;N;;;1E2C;;1E2C
1E2E;LATIN CAPITAL LETTER I WITH DIAERESIS AND ACUTE;Lu;0;L;00CF 0301;;;;N;;;;1E2F;
1E2F;LATIN SMALL LETTER I WITH DIAERESIS AND ACUTE;Ll;0;L;00EF 0301;;;;N;;;1E2E;;1E2E
1E30;LATIN CAPITAL LETTER K WITH ACUTE;Lu;0;L;004B 0301;;;;N;;;;1E31;
1E31;LATIN SMALL LETTER K WITH ACUTE;Ll;0;L;006B 0301;;;;N;;;1E30;;1E30
1E32;LATIN CAPITAL LETTER K WITH DOT BELOW;Lu;0;L;004B 0323;;;;N;;;;1E33;
1E33;LATIN SMALL LETTER K WITH DOT BELOW;Ll;0;L;006B 0323;;;;N;;;1E32;;1E32
1E34;LATIN CAPITAL LETTER K WITH LINE BELOW;Lu;0;L;004B 0331;;;;N;;;;1E35;
1E35;LATIN SMALL LETTER K WITH LINE BELOW;Ll;0;L;006B 0331;;;;N;;;1E34;;1E34
1E36;LATIN CAPITAL LETTER L WITH DOT BELOW;Lu;0;L;004C 0323;;;;N;;;;1E37;
1E37;LATIN SMALL LETTER L WITH DOT BELOW;Ll;0;L;006C 0323;;;;N;;;1E36;;1E36
1E38;LATIN CAPITAL LETTER L WITH DOT BELOW AND MACRON;Lu;0;L;1E36 0304;;;;N;;;;1E39;
1E39;LATIN SMALL LETTER L WITH DOT BELOW AND MACRON;Ll;0;L;1E37 0304;;;;N;;;1E38;;1E38
1E3A;LATIN CAPITAL LETTER L WITH LINE BELOW;Lu;0;L;004C 0331;;;;N;;;;1E3B;
1E3B;LATIN SMALL LETTER L WITH LINE BELOW;Ll;0;L;006C 0331;;;;N;;;1E3A;;1E3A
1E3C;LATIN CAPITAL LETTER L WITH CIRCUMFLEX BELOW;Lu;0;L;004C 032D;;;;N;;;;1E3D;
1E3D;LATIN SMALL LETTER L WITH CIRCUMFLEX BELOW;Ll;0;L;006C 032D;;;;N;;;1E3C;;1E3C
1E3E;LATIN CAPITAL LETTER M WITH ACUTE;Lu;0;L;004D 0301;;;;N;;;;1E3F;
1E3F;LATIN SMALL LETTER M WITH ACUTE;Ll;0;L;006D 0301;;;;N;;;1E3E;;1E3E
1E40;LATIN CAPITAL LETTER M WITH DOT ABOVE;Lu;0;L;004D 0307;;;;N;;;;1E41;
1E41;LATIN SMALL LETTER M WITH DOT ABOVE;Ll;0;L;006D 0307;;;;N;;;1E40;;1E40
1E42;LATIN CAPITAL LETTER M WITH DOT BELOW;Lu;0;L;004D 0323;;;;N;;;;1E43;
1E43;LATIN SMALL LETTER M WITH DOT BELOW;Ll;0;L;006D 0323;;;;N;;;1E42;;1E42
1E44;LATIN CAPITAL LETTER N WITH DOT ABOVE;Lu;0;L;004E 0307;;;;N;;;;1E45;
1E45;LATIN SMALL LETTER N WITH DOT ABOVE;Ll;0;L;006E 0307;;;;N;;;1E44;;1E44
1E46;LATIN CAPITAL LETTER N WITH DOT BELOW;Lu;0;L;004E 0323;;;;N;;;;1E47;
1E47;LATIN SMALL LETTER N WITH DOT BELOW;Ll;0;L;006E 0323;;;;N;;;1E46;;1E46
1E48;LATIN CAPITAL LETTER N WITH LINE BELOW;Lu;0;L;004E 0331;;;;N;;;;1E49;
1E49;LATIN SMALL LETTER N WITH LINE BELOW;Ll;0;L;006E 0331;;;;N;;;1E48;;1E48
1E4A;LATIN CAPITAL LETTER N WITH CIRCUMFLEX BELOW;Lu;0;L;004E 032D;;;;N;;;;1E4B;
1E4B;LATIN SMALL LETTER N WITH CIRCUMFLEX BELOW;Ll;0;L;006E 032D;;;;N;;;1E4A;;1E4A
1E4C;LATIN CAPITAL LETTER O WITH TILDE AND ACUTE;Lu;0;L;00D5 0301;;;;N;;;;1E4D;
1E4D;LATIN SMALL LETTER O WITH TILDE AND ACUTE;Ll;0;L;00F5 0301;;;;N;;;1E4C;;1E4C
1E4E;LATIN CAPITAL LETTER O WITH TILDE AND DIAERESIS;Lu;0;L;00D5 0308;;;;N;;;;1E4F;
1E4F;LATIN SMALL LETTER O WITH TILDE AND DIAERESIS;Ll;0;L;00F5 0308;;;;N;;;1E4E;;1E4E
1E50;LATIN CAPITAL LETTER O WITH MACRON AND GRAVE;Lu;0;L;014C 0300;;;;N;;;;1E51;
1E51;LATIN SMALL LETTER O WITH MACRON AND GRAVE;Ll;0;L;014D 0300;;;;N;;;1E50;;1E50
1E52;LATIN CAPITAL LETTER O WITH MACRON AND ACUTE;Lu;0;L;014C 0301;;;;N;;;;1E53;
1E53;LATIN SMALL LETTER O WITH MACRON AND ACUTE;Ll;0;L;014D 0301;;;;N;;;1E52;;1E52
1E54;LATIN CAPITAL LETTER P WITH ACUTE;Lu;0;L;0050 0301;;;;N;;;;1E55;
1E55;LATIN SMALL LETTER P WITH ACUTE;Ll;0;L;0070 0301;;;;N;;;1E54;;1E54
1E56;LATIN CAPITAL LETTER P WITH DOT ABOVE;Lu;0;L;0050 0307;;;;N;;;;1E57;
1E57;LATIN SMALL LETTER P WITH DOT ABOVE;Ll;0;L;0070 0307;;;;N;;;1E56;;1E56
1E58;LATIN CAPITAL LETTER R WITH DOT ABOVE;Lu;0;L;0052 0307;;;;N;;;;1E59;
1E59;LATIN SMALL LETTER R WITH DOT ABOVE;Ll;0;L;0072 0307;;;;N;;;1E58;;1E58
1E5A;LATIN CAPITAL LETTER R WITH DOT BELOW;Lu;0;L;0052 0323;;;;N;;;;1E5B;
1E5B;LATIN SMALL LETTER R WITH DOT BELOW;Ll;0;L;0072 0323;;;;N;;;1E5A;;1E5A
1E5C;LATIN CAPITAL LETTER R WITH DOT BELOW AND MACRON;Lu;0;L;1E5A 0304;;;;N;;;;1E5D;
1E5D;LATIN SMALL LETTER R WITH DOT BELOW AND MACRON;Ll;0;L;1E5B 0304;;;;N;;;1E5C;;1E5C
1E5E;LATIN CAPITAL LETTER R WITH LINE BELOW;Lu;0;L;0052 0331;;;;N;;;;1E5F;
1E5F;LATIN SMALL LETTER R WITH LINE BELOW;Ll;0;L;0072 0331;;;;N;;;1E5E;;1E5E
1E60;LATIN CAPITAL LETTER S WITH DOT ABOVE;Lu;0;L;0053 0307;;;;N;;;;1E61;
1E61;LATIN SMALL LETTER S WITH DOT ABOVE;Ll;0;L;0073 0307;;;;N;;;1E60;;1E60
1E62;LATIN CAPITAL LETTER S WITH DOT BELOW;Lu;0;L;0053 0323;;;;N;;;;1E63;
1E63;LATIN SMALL LETTER S WITH DOT BELOW;Ll;0;L;0073 0323;;;;N;;;1E62;;1E62
1E64;LATIN CAPITAL LETTER S WITH ACUTE AND DOT ABOVE;Lu;0;L;015A 0307;;;;N;;;;1E65;
1E65;LATIN SMALL LETTER S WITH ACUTE AND DOT ABOVE;Ll;0;L;015B 0307;;;;N;;;1E64;;1E64
1E66;LATIN CAPITAL LETTER S WITH CARON AND DOT ABOVE;Lu;0;L;0160 0307;;;;N;;;;1E67;
1E67;LATIN SMALL LETTER S WITH CARON AND DOT ABOVE;Ll;0;L;0161 0307;;;;N;;;1E66;;1E66
1E68;LATIN CAPITAL LETTER S WITH DOT BELOW AND DOT ABOVE;Lu;0;L;1E62 0307;;;;N;;;;1E69;
1E69;LATIN SMALL LETTER S WITH DOT BELOW AND DOT ABOVE;Ll;0;L;1E63 0307;;;;N;;;1E68;;1E68
1E6A;LATIN CAPITAL LETTER T WITH DOT ABOVE;Lu;0;L;0054 0307;;;;N;;;;1E6B;
1E6B;LATIN SMALL LETTER T WITH DOT ABOVE;Ll;0;L;0074 0307;;;;N;;;1E6A;;1E6A
1E6C;LATIN CAPITAL LETTER T WITH DOT BELOW;Lu;0;L;0054 0323;;;;N;;;;1E6D;
1E6D;LATIN SMALL LETTER T WITH DOT BELOW;Ll;0;L;0074 0323;;;;N;;;1E6C;;1E6C
1E6E;LATIN CAPITAL LETTER T WITH LINE BELOW;Lu;0;L;0054 0331;;;;N;;;;1E6F;
1E6F;LATIN SMALL LETTER T WITH LINE BELOW;Ll;0;L;0074 0331;;;;N;;;1E6E;;1E6E
1E70;LATIN CAPITAL LETTER T WITH CIRCUMFLEX BELOW;Lu;0;L;0054 032D;;;;N;;;;1E71;
1E71;LATIN SMALL LETTER T WITH CIRCUMFLEX BELOW;Ll;0;L;0074 032D;;;;N;;;1E70;;1E70
1E72;LATIN CAPITAL LETTER U WITH DIAERESIS BELOW;Lu;0;L;0055 0324;;;;N;;;;1E73;
1E73;LATIN SMALL LETTER U WITH DIAERESIS BELOW;Ll;0;L;0075 0324;;;;N;;;1E72;;1E72
1E74;LATIN CAPITAL LETTER U WITH TILDE BELOW;Lu;0;L;0055 0330;;;;N;;;;1E75;
1E75;LATIN SMALL LETTER U WITH TILDE BELOW;Ll;0;L;0075 0330;;;;N;;;1E74;;1E74
1E76;LATIN CAPITAL LETTER U WITH CIRCUMFLEX BELOW;Lu;0;L;0055 032D;;;;N;;;;1E77;
1E77;LATIN SMALL LETTER U WITH CIRCUMFLEX BELOW;Ll;0;L;0075 032D;;;;N;;;1E76;;1E76
1E78;LATIN CAPITAL LETTER U WITH TILDE AND ACUTE;Lu;0;L;0168 0301;;;;N;;;;1E79;
1E79;LATIN SMALL LETTER U WITH TILDE AND ACUTE;Ll;0;L;0169 0301;;;;N;;;1E78;;1E78
1E7A;LATIN CAPITAL LETTER U WITH MACRON AND DIAERESIS;Lu;0;L;016A 0308;;;;N;;;;1E7B;
1E7B;LATIN SMALL LETTER U WITH MACRON AND DIAERESIS;Ll;0;L;016B 0308;;;;N;;;1E7A;;1E7A
1E7C;LATIN CAPITAL LETTER V WITH TILDE;Lu;0;L;0056 0303;;;;N;;;;1E7D;
1E7D;LATIN SMALL LETTER V WITH TILDE;Ll;0;L;0076 0303;;;;N;;;1E7C;;1E7C
1E7E;LATIN CAPITAL LETTER V WITH DOT BELOW;Lu;0;L;0056 0323;;;;N;;;;1E7F;
1E7F;LATIN SMALL LETTER V WITH DOT BELOW;Ll;0;L;0076 0323;;;;N;;;1E7E;;1E7E
1E80;LATIN CAPITAL LETTER W WITH GRAVE;Lu;0;L;0057 0300;;;;N;;;;1E81;
1E81;LATIN SMALL LETTER W WITH GRAVE;Ll;0;L;0077 0300;;;;N;;;1E80;;1E80
1E82;LATIN CAPITAL LETTER W WITH ACUTE;Lu;0;L;0057 0301;;;;N;;;;1E83;
1E83;LATIN SMALL LETTER W WITH ACUTE;Ll;0;L;0077 0301;;;;N;;;1E82;;1E82
1E84;LATIN CAPITAL LETTER W WITH DIAERESIS;Lu;0;L;0057 0308;;;;N;;;;1E85;
1E85;LATIN SMALL LETTER W WITH DIAERESIS;Ll;0;L;0077 0308;;;;N;;;1E84;;1E84
1E86;LATIN CAPITAL LETTER W WITH DOT ABOVE;Lu;0;L;0057 0307;;;;N;;;;1E87;
1E87;LATIN SMALL LETTER W WITH DOT ABOVE;Ll;0;L;0077 0307;;;;N;;;1E86;;1E86
1E88;LATIN CAPITAL LETTER W WITH DOT BELOW;Lu;0;L;0057 0323;;;;N;;;;1E89;
1E89;LATIN SMALL LETTER W WITH DOT BELOW;Ll;0;L;0077 0323;;;;N;;;1E88;;1E88
1E8A;LATIN CAPITAL LETTER X WITH DOT ABOVE;Lu;0;L;0058 0307;;;;N;;;;1E8B;
1E8B;LATIN SMALL LETTER X WITH DOT ABOVE;Ll;0;L;0078 0307;;;;N;;;1E8A;;1E8A
1E8C;LATIN CAPITAL LETTER X WITH DIAERESIS;Lu;0;L;0058 0308;;;;N;;;;1E8D;
1E8D;LATIN SMALL LETTER X WITH DIAERESIS;Ll;0;L;0078 0308;;;;N;;;1E8C;;1E8C
1E8E;LATIN CAPITAL LETTER Y WITH DOT ABOVE;Lu;0;L;0059 0307;;;;N;;;;1E8F;
1E8F;LATIN SMALL LETTER Y WITH DOT ABOVE;Ll;0;L;0079 0307;;;;N;;;1E8E;;1E8E
1E90;LATIN CAPITAL LETTER Z WITH CIRCUMFLEX;Lu;0;L;005A 0302;;;;N;;;;1E91;
1E91;LATIN SMALL LETTER Z WITH CIRCUMFLEX;Ll;0;L;007A 0302;;;;N;;;1E90;;1E90
1E92;LATIN CAPITAL LETTER Z WITH DOT BELOW;Lu;0;L;005A 0323;;;;N;;;;1E93;
1E93;LATIN SMALL LETTER Z WITH DOT BELOW;Ll;0;L;007A 0323;;;;N;;;1E92;;1E92
1E94;LATIN CAPITAL LETTER Z WITH LINE BELOW;Lu;0;L;005A 0331;;;;N;;;;1E95;
1E95;LATIN SMALL LETTER Z WITH LINE BELOW;Ll;0;L;007A 0331;;;;N;;;1E94;;1E94
1E96;LATIN SMALL LETTER H WITH LINE BELOW;Ll;0;L;0068 0331;;;;N;;;;;
1E97;LATIN SMALL LETTER T WITH DIAERESIS;Ll;0;L;0074 0308;;;;N;;;;;
1E98;LATIN SMALL LETTER W WITH RING ABOVE;Ll;0;L;0077 030A;;;;N;;;;;
1E99;LATIN SMALL LETTER Y WITH RING ABOVE;Ll;0;L;0079 030A;;;;N;;;;;
1E9A;LATIN SMALL LETTER A WITH RIGHT HALF RING;Ll;0;L;<compat> 0061 02BE;;;;N;;;;;
1E9B;LATIN SMALL LETTER LONG S WITH DOT ABOVE;Ll;0;L;017F 0307;;;;N;;;1E60;;1E60
1E9C;LATIN SMALL LETTER LONG S WITH DIAGONAL STROKE;Ll;0;L;;;;;N;;;;;
1E9D;LATIN SMALL LETTER LONG S WITH HIGH STROKE;Ll;0;L;;;;;N;;;;;
1E9E;LATIN CAPITAL LETTER SHARP S;Lu;0;L;;;;;N;;;;00DF;
1E9F;LATIN SMALL LETTER DELTA;Ll;0;L;;;;;N;;;;;
1EA0;LATIN CAPITAL LETTER A WITH DOT BELOW;Lu;0;L;0041 0323;;;;N;;;;1EA1;
1EA1;LATIN SMALL LETTER A WITH DOT BELOW;Ll;0;L;0061 0323;;;;N;;;1EA0;;1EA0
1EA2;LATIN CAPITAL LETTER A WITH HOOK ABOVE;Lu;0;L;0041 0309;;;;N;;;;1EA3;
1EA3;LATIN SMALL LETTER A WITH HOOK ABOVE;Ll;0;L;0061 0309;;;;N;;;1EA2;;1EA2
1EA4;LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND ACUTE;Lu;0;L;00C2 0301;;;;N;;;;1EA5;
1EA5;LATIN SMALL LETTER A WITH CIRCUMFLEX AND ACUTE;Ll;0;L;00E2 0301;;;;N;;;1EA4;;1EA4
1EA6;LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND GRAVE;Lu;0;L;00C2 0300;;;;N;;;;1EA7;
1EA7;LATIN SMALL LETTER A WITH CIRCUMFLEX AND GRAVE;Ll;0;L;00E2 0300;;;;N;;;1EA6;;1EA6
1EA8;LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND HOOK ABOVE;Lu;0;L;00C2 0309;;;;N;;;;1EA9;
1EA9;LATIN SMALL LETTER A WITH CIRCUMFLEX AND HOOK ABOVE;Ll;0;L;00E2 0309;;;;N;;;1EA8;;1EA8
1EAA;LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND TILDE;Lu;0;L;00C2 0303;;;;N;;;;1EAB;
1EAB;LATIN SMALL LETTER A WITH CIRCUMFLEX AND TILDE;Ll;0;L;00E2 0303;;;;N;;;1EAA;;1EAA
1EAC;LATIN CAPITAL LETTER A WITH CIRCUMFLEX AND DOT BELOW;Lu;0;L;1EA0 0302;;;;N;;;;1EAD;
1EAD;LATIN SMALL LETTER A WITH CIRCUMFLEX AND DOT BELOW;Ll;0;L;1EA1 0302;;;;N;;;1EAC;;1EAC
1EAE;LATIN CAPITAL LETTER A WITH BREVE AND ACUTE;Lu;0;L;0102 0301;;;;N;;;;1EAF;
1EAF;LATIN SMALL LETTER A WITH BREVE AND ACUTE;Ll;0;L;0103 0301;;;;N;;;1EAE;;1EAE
1EB0;LATIN CAPITAL LETTER A WITH BREVE AND GRAVE;Lu;0;L;0102 0300;;;;N;;;;1EB1;
1EB1;LATIN SMALL LETTER A WITH BREVE AND GRAVE;Ll;0;L;0103 0300;;;;N;;;1EB0;;1EB0
1EB2;LATIN CAPITAL LETTER A WITH BREVE AND HOOK ABOVE;Lu;0;L;0102 0309;;;;N;;;;1EB3;
1EB3;LATIN SMALL LETTER A WITH BREVE AND HOOK ABOVE;Ll;0;L;0103 0309;;;;N;;;1EB2;;1EB2
1EB4;LATIN CAPITAL LETTER A WITH BREVE AND TILDE;Lu;0;L;0102 0303;;;;N;;;;1EB5;
1EB5;LATIN SMALL LETTER A WITH BREVE AND TILDE;Ll;0;L;0103 0303;;;;N;;;1EB4;;1EB4
1EB6;LATIN CAPITAL LETTER A WITH BREVE AND DOT BELOW;Lu;0;L;1EA0 0306;;;;N;;;;1EB7;
1EB7;LATIN SMALL LETTER A WITH BREVE AND DOT BELOW;Ll;0;L;1EA1 0306;;;;N;;;1EB6;;1EB6
1EB8;LATIN CAPITAL LETTER E WITH DOT BELOW;Lu;0;L;0045 0323;;;;N;;;;1EB9;
1EB9;LATIN SMALL LETTER E WITH DOT BELOW;Ll;0;L;0065 0323;;;;N;;;1EB8;;1EB8
1EBA;LATIN CAPITAL LETTER E WITH HOOK ABOVE;Lu;0;L;0045 0309;;;;N;;;;1EBB;
1EBB;LATIN SMALL LETTER E WITH HOOK ABOVE;Ll;0;L;0065 0309;;;;N;;;1EBA;;1EBA
1EBC;LATIN CAPITAL LETTER E WITH TILDE;Lu;0;L;0045 0303;;;;N;;;;1EBD;
1EBD;LATIN SMALL LETTER E WITH TILDE;Ll;0;L;0065 0303;;;;N;;;1EBC;;1EBC
1EBE;LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND ACUTE;Lu;0;L;00CA 0301;;;;N;;;;1EBF;
1EBF;LATIN SMALL LETTER E WITH CIRCUMFLEX AND ACUTE;Ll;0;L;00EA 0301;;;;N;;;1EBE;;1EBE
1EC0;LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND GRAVE;Lu;0;L;00CA 0300;;;;N;;;;1EC1;
1EC1;LATIN SMALL LETTER E WITH CIRCUMFLEX AND GRAVE;Ll;0;L;00EA 0300;;;;N;;;1EC0;;1EC0
1EC2;LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND HOOK ABOVE;Lu;0;L;00CA 0309;;;;N;;;;1EC3;
1EC3;LATIN SMALL LETTER E WITH CIRCUMFLEX AND HOOK ABOVE;Ll;0;L;00EA 0309;;;;N;;;1EC2;;1EC2
1EC4;LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND TILDE;Lu;0;L;00CA 0303;;;;N;;;;1EC5;
1EC5;LATIN SMALL LETTER E WITH CIRCUMFLEX AND TILDE;Ll;0;L;00EA 0303;;;;N;;;1EC4;;1EC4
1EC6;LATIN CAPITAL LETTER E WITH CIRCUMFLEX AND DOT BELOW;Lu;0;L;1EB8 0302;;;;N;;;;1EC7;
1EC7;LATIN SMALL LETTER E WITH CIRCUMFLEX AND DOT BELOW;Ll;0;L;1EB9 0302;;;;N;;;1EC6;;1EC6
1EC8;LATIN CAPITAL LETTER I WITH HOOK ABOVE;Lu;0;L;0049 0309;;;;N;;;;1EC9;
1EC9;LATIN SMALL LETTER I WITH HOOK ABOVE;Ll;0;L;0069 0309;;;;N;;;1EC8;;1EC8
1ECA;LATIN CAPITAL LETTER I WITH DOT BELOW;Lu;0;L;0049 0323;;;;N;;;;1ECB;
1ECB;LATIN SMALL LETTER I WITH DOT BELOW;Ll;0;L;0069 0323;;;;N;;;1ECA;;1ECA
1ECC;LATIN CAPITAL LETTER O WITH DOT BELOW;Lu;0;L;004F 0323;;;;N;;;;1ECD;
1ECD;LATIN SMALL LETTER O WITH DOT BELOW;Ll;0;L;006F 0323;;;;N;;;1ECC;;1ECC
1ECE;LATIN CAPITAL LETTER O WITH HOOK ABOVE;Lu;0;L;004F 0309;;;;N;;;;1ECF;
1ECF;LATIN SMALL LETTER O WITH HOOK ABOVE;Ll;0;L;006F 0309;;;;N;;;1ECE;;1ECE
1ED0;LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND ACUTE;Lu;0;L;00D4 0301;;;;N;;;;1ED1;
1ED1;LATIN SMALL LETTER O WITH CIRCUMFLEX AND ACUTE;Ll;0;L;00F4 0301;;;;N;;;1ED0;;1ED0
1ED2;LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND GRAVE;Lu;0;L;00D4 0300;;;;N;;;;1ED3;
1ED3;LATIN SMALL LETTER O WITH CIRCUMFLEX AND GRAVE;Ll;0;L;00F4 0300;;;;N;;;1ED2;;1ED2
1ED4;LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND HOOK ABOVE;Lu;0;L;00D4 0309;;;;N;;;;1ED5;
1ED5;LATIN SMALL LETTER O WITH CIRCUMFLEX AND HOOK ABOVE;Ll;0;L;00F4 0309;;;;N;;;1ED4;;1ED4
1ED6;LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND TILDE;Lu;0;L;00D4 0303;;;;N;;;;1ED7;
1ED7;LATIN SMALL LETTER O WITH CIRCUMFLEX AND TILDE;Ll;0;L;00F4 0303;;;;N;;;1ED6;;1ED6
1ED8;LATIN CAPITAL LETTER O WITH CIRCUMFLEX AND DOT BELOW;Lu;0;L;1ECC 0302;;;;N;;;;1ED9;
1ED9;LATIN SMALL LETTER O WITH CIRCUMFLEX AND DOT BELOW;Ll;0;L;1ECD 0302;;;;N;;;1ED8;;1ED8
1EDA;LATIN CAPITAL LETTER O WITH HORN AND ACUTE;Lu;0;L;01A0 0301;;;;N;;;;1EDB;
1EDB;LATIN SMALL LETTER O WITH HORN AND ACUTE;Ll;0;L;01A1 0301;;;;N;;;1EDA;;1EDA
1EDC;LATIN CAPITAL LETTER O WITH HORN AND GRAVE;Lu;0;L;01A0 0300;;;;N;;;;1EDD;
1EDD;LATIN SMALL LETTER O WITH HORN AND GRAVE;Ll;0;L;01A1 0300;;;;N;;;1EDC;;1EDC
1EDE;LATIN CAPITAL LETTER O WITH HORN AND HOOK ABOVE;Lu;0;L;01A0 0309;;;;N;;;;1EDF;
1EDF;LATIN SMALL LETTER O WITH HORN AND HOOK ABOVE;Ll;0;L;01A1 0309;;;;N;;;1EDE;;1EDE
1EE0;LATIN CAPITAL LETTER O WITH HORN AND TILDE;Lu;0;L;01A0 0303;;;;N;;;;1EE1;
1EE1;LATIN SMALL LETTER O WITH HORN AND TILDE;Ll;0;L;01A1 0303;;;;N;;;1EE0;;1EE0
1EE2;LATIN CAPITAL LETTER O WITH HORN AND DOT BELOW;Lu;0;L;01A0 0323;;;;N;;;;1EE3;
1EE3;LATIN SMALL LETTER O WITH HORN AND DOT BELOW;Ll;0;L;01A1 0323;;;;N;;;1EE2;;1EE2
1EE4;LATIN CAPITAL LETTER U WITH DOT BELOW;Lu;0;L;0055 0323;;;;N;;;;1EE5;
1EE5;LATIN SMALL LETTER U WITH DOT BELOW;Ll;0;L;0075 0323;;;;N;;;1EE4;;1EE4
1EE6;LATIN CAPITAL LETTER U WITH HOOK ABOVE;Lu;0;L;0055 0309;;;;N;;;;1EE7;
1EE7;LATIN SMALL LETTER U WITH HOOK ABOVE;Ll;0;L;0075 0309;;;;N;;;1EE6;;1EE6
1EE8;LATIN CAPITAL LETTER U WITH HORN AND ACUTE;Lu;0;L;01AF 0301;;;;N;;;;1EE9;
1EE9;LATIN SMALL LETTER U WITH HORN AND ACUTE;Ll;0;L;01B0 0301;;;;N;;;1EE8;;1EE8
1EEA;LATIN CAPITAL LETTER U WITH HORN AND GRAVE;Lu;0;L;01AF 0300;;;;N;;;;1EEB;
1EEB;LATIN SMALL LETTER U WITH HORN AND GRAVE;Ll;0;L;01B0 0300;;;;N;;;1EEA;;1EEA
1EEC;LATIN CAPITAL LETTER U WITH HORN AND HOOK ABOVE;Lu;0;L;01AF 0309;;;;N;;;;1EED;
1EED;LATIN SMALL LETTER U WITH HORN AND HOOK ABOVE;Ll;0;L;01B0 0309;;;;N;;;1EEC;;1EEC
1EEE;LATIN CAPITAL LETTER U WITH HORN AND TILDE;Lu;0;L;01AF 0303;;;;N;;;;1EEF;
1EEF;LATIN SMALL LETTER U WITH HORN AND TILDE;Ll;0;L;01B0 0303;;;;N;;;1EEE;;1EEE
1EF0;LATIN CAPITAL LETTER U WITH HORN AND DOT BELOW;Lu;0;L;01AF 0323;;;;N;;;;1EF1;
1EF1;LATIN SMALL LETTER U WITH HORN AND DOT BELOW;Ll;0;L;01B0 0323;;;;N;;;1EF0;;1EF0
1EF2;LATIN CAPITAL LETTER Y WITH GRAVE;Lu;0;L;0059 0300;;;;N;;;;1EF3;
1EF3;LATIN SMALL LETTER Y WITH GRAVE;Ll;0;L;0079 0300;;;;N;;;1EF2;;1EF2
1EF4;LATIN CAPITAL LETTER Y WITH DOT BELOW;Lu;0;L;0059 0323;;;;N;;;;1EF5;
1EF5;LATIN SMALL LETTER Y WITH DOT BELOW;Ll;0;L;0079 0323;;;;N;;;1EF4;;1EF4
1EF6;LATIN CAPITAL LETTER Y WITH HOOK ABOVE;Lu;0;L;0059 0309;;;;N;;;;1EF7;
1EF7;LATIN SMALL LETTER Y WITH HOOK ABOVE;Ll;0;L;0079 0309;;;;N;;;1EF6;;1EF6
1EF8;LATIN CAPITAL LETTER Y WITH TILDE;Lu;0;L;0059 0303;;;;N;;;;1EF9;
1EF9;LATIN SMALL LETTER Y WITH TILDE;Ll;0;L;0079 0303;;;;N;;;1EF8;;1EF8
1EFA;LATIN CAPITAL LETTER MIDDLE-WELSH LL;Lu;0;L;;;;;N;;;;1EFB;
1EFB;LATIN SMALL LETTER MIDDLE-WELSH LL;Ll;0;L;;;;;N;;;1EFA;;1EFA
1EFC;LATIN CAPITAL LETTER MIDDLE-WELSH V;Lu;0;L;;;;;N;;;;1EFD;
1EFD;LATIN SMALL LETTER MIDDLE-WELSH V;Ll;0;L;;;;;N;;;1EFC;;1EFC
1EFE;LATIN CAPITAL LETTER Y WITH LOOP;Lu;0;L;;;;;N;;;;1EFF;
1EFF;LATIN SMALL LETTER Y WITH LOOP;Ll;0;L;;;;;N;;;1EFE;;1EFE
1F00;GREEK SMALL LETTER ALPHA WITH PSILI;Ll;0;L;03B1 0313;;;;N;;;1F08;;1F08
1F01;GREEK SMALL LETTER ALPHA WITH DASIA;Ll;0;L;03B1 0314;;;;N;;;1F09;;1F09
1F02;GREEK SMALL LETTER ALPHA WITH PSILI AND VARIA;Ll;0;L;1F00 0300;;;;N;;;1F0A;;1F0A
1F03;GREEK SMALL LETTER ALPHA WITH DASIA AND VARIA;Ll;0;L;1F01 0300;;;;N;;;1F0B;;1F0B
1F04;GREEK SMALL LETTER ALPHA WITH PSILI AND OXIA;Ll;0;L;1F00 0301;;;;N;;;1F0C;;1F0C
1F05;GREEK SMALL LETTER ALPHA WITH DASIA AND OXIA;Ll;0;L;1F01 0301;;;;N;;;1F0D;;1F0D
1F06;GREEK SMALL LETTER ALPHA WITH PSILI AND PERISPOMENI;Ll;0;L;1F00 0342;;;;N;;;1F0E;;1F0E
1F07;GREEK SMALL LETTER ALPHA WITH DASIA AND PERISPOMENI;Ll;0;L;1F01 0342;;;;N;;;1F0F;;1F0F
1F08;GREEK CAPITAL LETTER ALPHA WITH PSILI;Lu;0;L;0391 0313;;;;N;;;;1F00;
1F09;GREEK CAPITAL LETTER ALPHA WITH DASIA;Lu;0;L;0391 0314;;;;N;;;;1F01;
1F0A;GREEK CAPITAL LETTER ALPHA WITH PSILI AND VARIA;Lu;0;L;1F08 0300;;;;N;;;;1F02;
1F0B;GREEK CAPITAL LETTER ALPHA WITH DASIA AND VARIA;Lu;0;L;1F09 0300;;;;N;;;;1F03;
1F0C;GREEK CAPITAL LETTER ALPHA WITH PSILI AND OXIA;Lu;0;L;1F08 0301;;;;N;;;;1F04;
1F0D;GREEK CAPITAL LETTER ALPHA WITH DASIA AND OXIA;Lu;0;L;1F09 0301;;;;N;;;;1F05;
1F0E;GREEK CAPITAL LETTER ALPHA WITH PSILI AND PERISPOMENI;Lu;0;L;1F08 0342;;;;N;;;;1F06;
1F0F;GREEK CAPITAL LETTER ALPHA WITH DASIA AND PERISPOMENI;Lu;0;L;1F09 0342;;;;N;;;;1F07;
1F10;GREEK SMALL LETTER EPSILON WITH PSILI;Ll;0;L;03B5 0313;;;;N;;;1F18;;1F18
1F11;GREEK SMALL LETTER EPSILON WITH DASIA;Ll;0;L;03B5 0314;;;;N;;;1F19;;1F19
1F12;GREEK SMALL LETTER EPSILON WITH PSILI AND VARIA;Ll;0;L;1F10 0300;;;;N;;;1F1A;;1F1A
1F13;GREEK SMALL LETTER EPSILON WITH DASIA AND VARIA;Ll;0;L;1F11 0300;;;;N;;;1F1B;;1F1B
1F14;GREEK SMALL LETTER EPSILON WITH PSILI AND OXIA;Ll;0;L;1F10 0301;;;;N;;;1F1C;;1F1C
1F15;GREEK SMALL LETTER EPSILON WITH DASIA AND OXIA;Ll;0;L;1F11 0301;;;;N;;;1F1D;;1F1D
1F18;GREEK CAPITAL LETTER EPSILON WITH PSILI;Lu;0;L;0395 0313;;;;N;;;;1F10;
1F19;GREEK CAPITAL LETTER EPSILON WITH DASIA;Lu;0;L;0395 0314;;;;N;;;;1F11;
1F1A;GREEK CAPITAL LETTER EPSILON WITH PSILI AND VARIA;Lu;0;L;1F18 0300;;;;N;;;;1F12;
1F1B;GREEK CAPITAL LETTER EPSILON WITH DASIA AND VARIA;Lu;0;L;1F19 0300;;;;N;;;;1F13;
1F1C;GREEK CAPITAL LETTER EPSILON WITH PSILI AND OXIA;Lu;0;L;1F18 0301;;;;N;;;;1F14;
1F1D;GREEK CAPITAL LETTER EPSILON WITH DASIA AND OXIA;Lu;0;L;1F19 0301;;;;N;;;;1F15;
1F20;GREEK SMALL LETTER ETA WITH PSILI;Ll;0;L;03B7 0313;;;;N;;;1F28;;1F28
1F21;GREEK SMALL LETTER ETA WITH DASIA;Ll;0;L;03B7 0314;;;;N;;;1F29;;1F29
1F22;GREEK SMALL LETTER ETA WITH PSILI AND VARIA;Ll;0;L;1F20 0300;;;;N;;;1F2A;;1F2A
1F23;GREEK SMALL LETTER ETA WITH DASIA AND VARIA;Ll;0;L;1F21 0300;;;;N;;;1F2B;;1F2B
1F24;GREEK SMALL LETTER ETA WITH PSILI AND OXIA;Ll;0;L;1F20 0301;;;;N;;;1F2C;;1F2C
1F25;GREEK SMALL LETTER ETA WITH DASIA AND OXIA;Ll;0;L;1F21 0301;;;;N;;;1F2D;;1F2D
1F26;GREEK SMALL LETTER ETA WITH PSILI AND PERISPOMENI;Ll;0;L;1F20 0342;;;;N;;;1F2E;;1F2E
1F27;GREEK SMALL LETTER ETA WITH DASIA AND PERISPOMENI;Ll;0;L;1F21 0342;;;;N;;;1F2F;;1F2F
1F28;GREEK CAPITAL LETTER ETA WITH PSILI;Lu;0;L;0397 0313;;;;N;;;;1F20;
1F29;GREEK CAPITAL LETTER ETA WITH DASIA;Lu;0;L;0397 0314;;;;N;;;;1F21;
1F2A;GREEK CAPITAL LETTER ETA WITH PSILI AND VARIA;Lu;0;L;1F28 0300;;;;N;;;;1F22;
1F2B;GREEK CAPITAL LETTER ETA WITH DASIA AND VARIA;Lu;0;L;1F29 0300;;;;N;;;;1F23;
1F2C;GREEK CAPITAL LETTER ETA WITH PSILI AND OXIA;Lu;0;L;1F28 0301;;;;N;;;;1F24;
1F2D;GREEK CAPITAL LETTER ETA WITH DASIA AND OXIA;Lu;0;L;1F29 0301;;;;N;;;;1F25;
1F2E;GREEK CAPITAL LETTER ETA WITH PSILI AND PERISPOMENI;Lu;0;L;1F28 0342;;;;N;;;;1F26;
1F2F;GREEK CAPITAL LETTER ETA WITH DASIA AND PERISPOMENI;Lu;0;L;1F29 0342;;;;N;;;;1F27;
1F30;GREEK SMALL LETTER IOTA WITH PSILI;Ll;0;L;03B9 0313;;;;N;;;1F38;;1F38
1F31;GREEK SMALL LETTER IOTA WITH DASIA;Ll;0;L;03B9 0314;;;;N;;;1F39;;1F39
1F32;GREEK SMALL LETTER IOTA WITH PSILI AND VARIA;Ll;0;L;1F30 0300;;;;N;;;1F3A;;1F3A
1F33;GREEK SMALL LETTER IOTA WITH DASIA AND VARIA;Ll;0;L;1F31 0300;;;;N;;;1F3B;;1F3B
1F34;GREEK SMALL LETTER IOTA WITH PSILI AND OXIA;Ll;0;L;1F30 0301;;;;N;;;1F3C;;1F3C
1F35;GREEK SMALL LETTER IOTA WITH DASIA AND OXIA;Ll;0;L;1F31 0301;;;;N;;;1F3D;;1F3D
1F36;GREEK SMALL LETTER IOTA WITH PSILI AND PERISPOMENI;Ll;0;L;1F30 0342;;;;N;;;1F3E;;1F3E
1F37;GREEK SMALL LETTER IOTA WITH DASIA AND PERISPOMENI;Ll;0;L;1F31 0342;;;;N;;;1F3F;;1F3F
1F38;GREEK CAPITAL LETTER IOTA WITH PSILI;Lu;0;L;0399 0313;;;;N;;;;1F30;
1F39;GREEK CAPITAL LETTER IOTA WITH DASIA;Lu;0;L;0399 0314;;;;N;;;;1F31;
1F3A;GREEK CAPITAL LETTER IOTA WITH PSILI AND VARIA;Lu;0;L;1F38 0300;;;;N;;;;1F32;
1F3B;GREEK CAPITAL LETTER IOTA WITH DASIA AND VARIA;Lu;0;L;1F39 0300;;;;N;;;;1F33;
1F3C;GREEK CAPITAL LETTER IOTA WITH PSILI AND OXIA;Lu;0;L;1F38 0301;;;;N;;;;1F34;
1F3D;GREEK CAPITAL LETTER IOTA WITH DASIA AND OXIA;Lu;0;L;1F39 0301;;;;N;;;;1F35;
1F3E;GREEK CAPITAL LETTER IOTA WITH PSILI AND PERISPOMENI;Lu;0;L;1F38 0342;;;;N;;;;1F36;
1F3F;GREEK CAPITAL LETTER IOTA WITH DASIA AND PERISPOMENI;Lu;0;L;1F39 0342;;;;N;;;;1F37;
1F40;GREEK SMALL LETTER OMICRON WITH PSILI;Ll;0;L;03BF 0313;;;;N;;;1F48;;1F48
1F41;GREEK SMALL LETTER OMICRON WITH DASIA;Ll;0;L;03BF 0314;;;;N;;;1F49;;1F49
1F42;GREEK SMALL LETTER OMICRON WITH PSILI AND VARIA;Ll;0;L;1F40 0300;;;;N;;;1F4A;;1F4A
1F43;GREEK SMALL LETTER OMICRON WITH DASIA AND VARIA;Ll;0;L;1F41 0300;;;;N;;;1F4B;;1F4B
1F44;GREEK SMALL LETTER OMICRON WITH PSILI AND OXIA;Ll;0;L;1F40 0301;;;;N;;;1F4C;;1F4C
1F45;GREEK SMALL LETTER OMICRON WITH DASIA AND OXIA;Ll;0;L;1F41 0301;;;;N;;;1F4D;;1F4D
1F48;GREEK CAPITAL LETTER OMICRON WITH PSILI;Lu;0;L;039F 0313;;;;N;;;;1F40;
1F49;GREEK CAPITAL LETTER OMICRON WITH DASIA;Lu;0;L;039F 0314;;;;N;;;;1F41;
1F4A;GREEK CAPITAL LETTER OMICRON WITH PSILI AND VARIA;Lu;0;L;1F48 0300;;;;N;;;;1F42;
1F4B;GREEK CAPITAL LETTER OMICRON WITH DASIA AND VARIA;Lu;0;L;1F49 0300;;;;N;;;;1F43;
1F4C;GREEK CAPITAL LETTER OMICRON WITH PSILI AND OXIA;Lu;0;L;1F48 0301;;;;N;;;;1F44;
1F4D;GREEK CAPITAL LETTER OMICRON WITH DASIA AND OXIA;Lu;0;L;1F49 0301;;;;N;;;;1F45;
1F50;GREEK SMALL LETTER UPSILON WITH PSILI;Ll;0;L;03C5 0313;;;;N;;;;;
1F51;GREEK SMALL LETTER UPSILON WITH DASIA;Ll;0;L;03C5 0314;;;;N;;;1F59;;1F59
1F52;GREEK SMALL LETTER UPSILON WITH PSILI AND VARIA;Ll;0;L;1F50 0300;;;;N;;;;;
1F53;GREEK SMALL LETTER UPSILON WITH DASIA AND VARIA;Ll;0;L;1F51 0300;;;;N;;;1F5B;;1F5B
1F54;GREEK SMALL LETTER UPSILON WITH PSILI AND OXIA;Ll;0;L;1F50 0301;;;;N;;;;;
1F55;GREEK SMALL LETTER UPSILON WITH DASIA AND OXIA;Ll;0;L;1F51 0301;;;;N;;;1F5D;;1F5D
1F56;GREEK SMALL LETTER UPSILON WITH PSILI AND PERISPOMENI;Ll;0;L;1F50 0342;;;;N;;;;;
1F57;GREEK SMALL LETTER UPSILON WITH DASIA AND PERISPOMENI;Ll;0;L;1F51 0342;;;;N;;;1F5F;;1F5F
1F59;GREEK CAPITAL LETTER UPSILON WITH DASIA;Lu;0;L;03A5 0314;;;;N;;;;1F51;
1F5B;GREEK CAPITAL LETTER UPSILON WITH DASIA AND VARIA;Lu;0;L;1F59 0300;;;;N;;;;1F53;
1F5D;GREEK CAPITAL LETTER UPSILON WITH DASIA AND OXIA;Lu;0;L;1F59 0301;;;;N;;;;1F55;
1F5F;GREEK CAPITAL LETTER UPSILON WITH DASIA AND PERISPOMENI;Lu;0;L;1F59 0342;;;;N;;;;1F57;
1F60;GREEK SMALL LETTER OMEGA WITH PSILI;Ll;0;L;03C9 0313;;;;N;;;1F68;;1F68
1F61;GREEK SMALL LETTER OMEGA WITH DASIA;Ll;0;L;03C9 0314;;;;N;;;1F69;;1F69
1F62;GREEK SMALL LETTER OMEGA WITH PSILI AND VARIA;Ll;0;L;1F60 0300;;;;N;;;1F6A;;1F6A
1F63;GREEK SMALL LETTER OMEGA WITH DASIA AND VARIA;Ll;0;L;1F61 0300;;;;N;;;1F6B;;1F6B
1F64;GREEK SMALL LETTER OMEGA WITH PSILI AND OXIA;Ll;0;L;1F60 0301;;;;N;;;1F6C;;1F6C
1F65;GREEK SMALL LETTER OMEGA WITH DASIA AND OXIA;Ll;0;L;1F61 0301;;;;N;;;1F6D;;1F6D
1F66;GREEK SMALL LETTER OMEGA WITH PSILI AND PERISPOMENI;Ll;0;L;1F60 0342;;;;N;;;1F6E;;1F6E
1F67;GREEK SMALL LETTER OMEGA WITH DASIA AND PERISPOMENI;Ll;0;L;1F61 0342;;;;N;;;1F6F;;1F6F
1F68;GREEK CAPITAL LETTER OMEGA WITH PSILI;Lu;0;L;03A9 0313;;;;N;;;;1F60;
1F69;GREEK CAPITAL LETTER OMEGA WITH DASIA;Lu;0;L;03A9 0314;;;;N;;;;1F61;
1F6A;GREEK CAPITAL LETTER OMEGA WITH PSILI AND VARIA;Lu;0;L;1F68 0300;;;;N;;;;1F62;
1F6B;GREEK CAPITAL LETTER OMEGA WITH DASIA AND VARIA;Lu;0;L;1F69 0300;;;;N;;;;1F63;
1F6C;GREEK CAPITAL LETTER OMEGA WITH PSILI AND OXIA;Lu;0;L;1F68 0301;;;;N;;;;1F64;
1F6D;GREEK CAPITAL LETTER OMEGA WITH DASIA AND OXIA;Lu;0;L;1F69 0301;;;;N;;;;1F65;
1F6E;GREEK CAPITAL LETTER OMEGA WITH PSILI AND PERISPOMENI;Lu;0;L;1F68 0342;;;;N;;;;1F66;
1F6F;GREEK CAPITAL LETTER OMEGA WITH DASIA AND PERISPOMENI;Lu;0;L;1F69 0342;;;;N;;;;1F67;
1F70;GREEK SMALL LETTER ALPHA WITH VARIA;Ll;0;L;03B1 0300;;;;N;;;1FBA;;1FBA
1F71;GREEK SMALL LETTER ALPHA WITH OXIA;Ll;0;L;03AC;;;;N;;;1FBB;;1FBB
1F72;GREEK SMALL LETTER EPSILON WITH VARIA;Ll;0;L;03B5 0300;;;;N;;;1FC8;;1FC8
1F73;GREEK SMALL LETTER EPSILON WITH OXIA;Ll;0;L;03AD;;;;N;;;1FC9;;1FC9
1F74;GREEK SMALL LETTER ETA WITH VARIA;Ll;0;L;03B7 0300;;;;N;;;1FCA;;1FCA
1F75;GREEK SMALL LETTER ETA WITH OXIA;Ll;0;L;03AE;;;;N;;;1FCB;;1FCB
1F76;GREEK SMALL LETTER IOTA WITH VARIA;Ll;0;L;03B9 0300;;;;N;;;1FDA;;1FDA
1F77;GREEK SMALL LETTER IOTA WITH OXIA;Ll;0;L;03AF;;;;N;;;1FDB;;1FDB
1F78;GREEK SMALL LETTER OMICRON WITH VARIA;Ll;0;L;03BF 0300;;;;N;;;1FF8;;1FF8
1F79;GREEK SMALL LETTER OMICRON WITH OXIA;Ll;0;L;03CC;;;;N;;;1FF9;;1FF9
1F7A;GREEK SMALL LETTER UPSILON WITH VARIA;Ll;0;L;03C5 0300;;;;N;;;1FEA;;1FEA
1F7B;GREEK SMALL LETTER UPSILON WITH OXIA;Ll;0;L;03CD;;;;N;;;1FEB;;1FEB
1F7C;GREEK SMALL LETTER OMEGA WITH VARIA;Ll;0;L;03C9 0300;;;;N;;;1FFA;;1FFA
1F7D;GREEK SMALL LETTER OMEGA WITH OXIA;Ll;0;L;03CE;;;;N;;;1FFB;;1FFB
1F80;GREEK SMALL LETTER ALPHA WITH PSILI AND YPOGEGRAMMENI;Ll;0;L;1F00 0345;;;;N;;;1F88;;1F88
1F81;GREEK SMALL LETTER ALPHA WITH DASIA AND YPOGEGRAMMENI;Ll;0;L;1F01 0345;;;;N;;;1F89;;1F89
1F82;GREEK SMALL LETTER ALPHA WITH PSILI AND VARIA AND YPOGEGRAMMENI;Ll;0;L;1F02 0345;;;;N;;;1F8A;;1F8A
1F83;GREEK SMALL LETTER ALPHA WITH DASIA AND VARIA AND YPOGEGRAMMENI;Ll;0;L;1F03 0345;;;;N;;;1F8B;;1F8B
1F84;GREEK SMALL LETTER ALPHA WITH PSILI AND OXIA AND YPOGEGRAMMENI;Ll;0;L;1F04 0345;;;;N;;;1F8C;;1F8C
1F85;GREEK SMALL LETTER ALPHA WITH DASIA AND OXIA AND YPOGEGRAMMENI;Ll;0;L;1F05 0345;;;;N;;;1F8D;;1F8D
1F86;GREEK SMALL LETTER ALPHA WITH PSILI AND PERISPOMENI AND YPOGEGRAMMENI;Ll;0;L;1F06 0345;;;;N;;;1F8E;;1F8E
1F87;GREEK SMALL LETTER ALPHA WITH DASIA AND PERISPOMENI AND YPOGEGRAMMENI;Ll;0;L;1F07 0345;;;;N;;;1F8F;;1F8F
1F88;GREEK CAPITAL LETTER ALPHA WITH PSILI AND PROSGEGRAMMENI;Lt;0;L;1F08 0345;;;;N;;;;1F80;
1F89;GREEK CAPITAL LETTER ALPHA WITH DASIA AND PROSGEGRAMMENI;Lt;0;L;1F09 0345;;;;N;;;;1F81;
1F8A;GREEK CAPITAL LETTER ALPHA WITH PSILI AND VARIA AND PROSGEGRAMMENI;Lt;0;L;1F0A 0345;;;;N;;;;1F82;
1F8B;GREEK CAPITAL LETTER ALPHA WITH DASIA AND VARIA AND PROSGEGRAMMENI;Lt;0;L;1F0B 0345;;;;N;;;;1F83;
1F8C;GREEK CAPITAL LETTER ALPHA WITH PSILI AND OXIA AND PROSGEGRAMMENI;Lt;0;L;1F0C 0345;;;;N;;;;1F84;
1F8D;GREEK CAPITAL LETTER ALPHA WITH DASIA AND OXIA AND PROSGEGRAMMENI;Lt;0;L;1F0D 0345;;;;N;;;;1F85;
1F8E;GREEK CAPITAL LETTER ALPHA WITH PSILI AND PERISPOMENI AND PROSGEGRAMMENI;Lt;0;L;1F0E 0345;;;;N;;;;1F86;
1F8F;GREEK CAPITAL LETTER ALPHA WITH DASIA AND PERISPOMENI AND PROSGEGRAMMENI;Lt;0;L;1F0F 0345;;;;N;;;;1F87;
1F90;GREEK SMALL LETTER ETA WITH PSILI AND YPOGEGRAMMENI;Ll;0;L;1F20 0345;;;;N;;;1F98;;1F98
1F91;GREEK SMALL LETTER ETA WITH DASIA AND YPOGEGRAMMENI;Ll;0;L;1F21 0345;;;;N;;;1F99;;1F99
1F92;GREEK SMALL LETTER ETA WITH PSILI AND VARIA AND YPOGEGRAMMENI;Ll;0;L;1F22 0345;;;;N;;;1F9A;;1F9A
1F93;GREEK SMALL LETTER ETA WITH DASIA AND VARIA AND YPOGEGRAMMENI;Ll;0;L;1F23 0345;;;;N;;;1F9B;;1F9B
1F94;GREEK SMALL LETTER ETA WITH PSILI AND OXIA AND YPOGEGRAMMENI;Ll;0;L;1F24 0345;;;;N;;;1F9C;;1F9C
1F95;GREEK SMALL LETTER ETA WITH DASIA AND OXIA AND YPOGEGRAMMENI;Ll;0;L;1F25 0345;;;;N;;;1F9D;;1F9D
1F96;GREEK SMALL LETTER ETA WITH PSILI AND PERISPOMENI AND YPOGEGRAMMENI;Ll;0;L;1F26 0345;;;;N;;;1F9E;;1F9E
1F97;GREEK SMALL LETTER ETA WITH DASIA AND PERISPOMENI AND YPOGEGRAMMENI;Ll;0;L;1F27 0345;;;;N;;;1F9F;;1F9F
1F98;GREEK CAPITAL LETTER ETA WITH PSILI AND PROSGEGRAMMENI;Lt;0;L;1F28 0345;;;;N;;;;1F90;
1F99;GREEK CAPITAL LETTER ETA WITH DASIA AND PROSGEGRAMMENI;Lt;0;L;1F29 0345;;;;N;;;;1F91;
1F9A;GREEK CAPITAL LETTER ETA WITH PSILI AND VARIA AND PROSGEGRAMMENI;Lt;0;L;1F2A 0345;;;;N;;;;1F92;
1F9B;GREEK CAPITAL LETTER ETA WITH DASIA AND VARIA AND PROSGEGRAMMENI;Lt;0;L;1F2B 0345;;;;N;;;;1F93;
1F9C;GREEK CAPITAL LETTER ETA WITH PSILI AND OXIA AND PROSGEGRAMMENI;Lt;0;L;1F2C 0345;;;;N;;;;1F94;
1F9D;GREEK CAPITAL LETTER ETA WITH DASIA AND OXIA AND PROSGEGRAMMENI;Lt;0;L;1F2D 0345;;;;N;;;;1F95;
1F9E;GREEK CAPITAL LETTER ETA WITH PSILI AND PERISPOMENI AND PROSGEGRAMMENI;Lt;0;L;1F2E 0345;;;;N;;;;1F96;
1F9F;GREEK CAPITAL LETTER ETA WITH DASIA AND PERISPOMENI AND PROSGEGRAMMENI;Lt;0;L;1F2F 0345;;;;N;;;;1F97;
1FA0;GREEK SMALL LETTER OMEGA WITH PSILI AND YPOGEGRAMMENI;Ll;0;L;1F60 0345;;;;N;;;1FA8;;1FA8
1FA1;GREEK SMALL LETTER OMEGA WITH DASIA AND YPOGEGRAMMENI;Ll;0;L;1F61 0345;;;;N;;;1FA9;;1FA9
1FA2;GREEK SMALL LETTER OMEGA WITH PSILI AND VARIA AND YPOGEGRAMMENI;Ll;0;L;1F62 0345;;;;N;;;1FAA;;1FAA
1FA3;GREEK SMALL LETTER OMEGA WITH DASIA AND VARIA AND YPOGEGRAMMENI;Ll;0;L;1F63 0345;;;;N;;;1FAB;;1FAB
1FA4;GREEK SMALL LETTER OMEGA WITH PSILI AND OXIA AND YPOGEGRAMMENI;Ll;0;L;1F64 0345;;;;N;;;1FAC;;1FAC
1FA5;GREEK SMALL LETTER OMEGA WITH DASIA AND OXIA AND YPOGEGRAMMENI;Ll;0;L;1F65 0345;;;;N;;;1FAD;;1FAD
1FA6;GREEK SMALL LETTER OMEGA WITH PSILI AND PERISPOMENI AND YPOGEGRAMMENI;Ll;0;L;1F66 0345;;;;N;;;1FAE;;1FAE
1FA7;GREEK SMALL LETTER OMEGA WITH DASIA AND PERISPOMENI AND YPOGEGRAMMENI;Ll;0;L;1F67 0345;;;;N;;;1FAF;;1FAF
1FA8;GREEK CAPITAL LETTER OMEGA WITH PSILI AND PROSGEGRAMMENI;Lt;0;L;1F68 0345;;;;N;;;;1FA0;
1FA9;GREEK CAPITAL LETTER OMEGA WITH DASIA AND PROSGEGRAMMENI;Lt;0;L;1F69 0345;;;;N;;;;1FA1;
1FAA;GREEK CAPITAL LETTER OMEGA WITH PSILI AND VARIA AND PROSGEGRAMMENI;Lt;0;L;1F6A 0345;;;;N;;;;1FA2;
1FAB;GREEK CAPITAL LETTER OMEGA WITH DASIA AND VARIA AND PROSGEGRAMMENI;Lt;0;L;1F6B 0345;;;;N;;;;1FA3;
1FAC;GREEK CAPITAL LETTER OMEGA WITH PSILI AND OXIA AND PROSGEGRAMMENI;Lt;0;L;1F6C 0345;;;;N;;;;1FA4;
1FAD;GREEK CAPITAL LETTER OMEGA WITH DASIA AND OXIA AND PROSGEGRAMMENI;Lt;0;L;1F6D 0345;;;;N;;;;1FA5;
1FAE;GREEK CAPITAL LETTER OMEGA WITH PSILI AND PERISPOMENI AND PROSGEGRAMMENI;Lt;0;L;1F6E 0345;;;;N;;;;1FA6;
1FAF;GREEK CAPITAL LETTER OMEGA WITH DASIA AND PERISPOMENI AND PROSGEGRAMMENI;Lt;0;L;1F6F 0345;;;;N;;;;1FA7;
1FB0;GREEK SMALL LETTER ALPHA WITH VRACHY;Ll;0;L;03B1 0306;;;;N;;;1FB8;;1FB8
1FB1;GREEK SMALL LETTER ALPHA WITH MACRON;Ll;0;L;03B1 0304;;;;N;;;1FB9;;1FB9
1FB2;GREEK SMALL LETTER ALPHA WITH VARIA AND YPOGEGRAMMENI;Ll;0;L;1F70 0345;;;;N;;;;;
1FB3;GREEK SMALL LETTER ALPHA WITH YPOGEGRAMMENI;Ll;0;L;03B1 0345;;;;N;;;1FBC;;1FBC
1FB4;GREEK SMALL LETTER ALPHA WITH OXIA AND YPOGEGRAMMENI;Ll;0;L;03AC 0345;;;;N;;;;;
1FB6;GREEK SMALL LETTER ALPHA WITH PERISPOMENI;Ll;0;L;03B1 0342;;;;N;;;;;
1FB7;GREEK SMALL LETTER ALPHA WITH PERISPOMENI AND YPOGEGRAMMENI;Ll;0;L;1FB6 0345;;;;N;;;;;
1FB8;GREEK CAPITAL LETTER ALPHA WITH VRACHY;Lu;0;L;0391 0306;;;;N;;;;1FB0;
1FB9;GREEK CAPITAL LETTER ALPHA WITH MACRON;Lu;0;L;0391 0304;;;;N;;;;1FB1;
1FBA;GREEK CAPITAL LETTER ALPHA WITH VARIA;Lu;0;L;0391 0300;;;;N;;;;1F70;
1FBB;GREEK CAPITAL LETTER ALPHA WITH OXIA;Lu;0;L;0386;;;;N;;;;1F71;
1FBC;GREEK CAPITAL LETTER ALPHA WITH PROSGEGRAMMENI;Lt;0;L;0391 0345;;;;N;;;;1FB3;
1FBD;GREEK KORONIS;Sk;0;ON;<compat> 0020 0313;;;;N;;;;;
1FBE;GREEK PROSGEGRAMMENI;Ll;0;L;03B9;;;;N;;;0399;;0399
1FBF;GREEK PSILI;Sk;0;ON;<compat> 0020 0313;;;;N;;;;;
1FC0;GREEK PERISPOMENI;Sk;0;ON;<compat> 0020 0342;;;;N;;;;;
1FC1;GREEK DIALYTIKA AND PERISPOMENI;Sk;0;ON;00A8 0342;;;;N;;;;;
1FC2;GREEK SMALL LETTER ETA WITH VARIA AND YPOGEGRAMMENI;Ll;0;L;1F74 0345;;;;N;;;;;
1FC3;GREEK SMALL LETTER ETA WITH YPOGEGRAMMENI;Ll;0;L;03B7 0345;;;;N;;;1FCC;;1FCC
1FC4;GREEK SMALL LETTER ETA WITH OXIA AND YPOGEGRAMMENI;Ll;0;L;03AE 0345;;;;N;;;;;
1FC6;GREEK SMALL LETTER ETA WITH PERISPOMENI;Ll;0;L;03B7 0342;;;;N;;;;;
1FC7;GREEK SMALL LETTER ETA WITH PERISPOMENI AND YPOGEGRAMMENI;Ll;0;L;1FC6 0345;;;;N;;;;;
1FC8;GREEK CAPITAL LETTER EPSILON WITH VARIA;Lu;0;L;0395 0300;;;;N;;;;1F72;
1FC9;GREEK CAPITAL LETTER EPSILON WITH OXIA;Lu;0;L;0388;;;;N;;;;1F73;
1FCA;GREEK CAPITAL LETTER ETA WITH VARIA;Lu;0;L;0397 0300;;;;N;;;;1F74;
1FCB;GREEK CAPITAL LETTER ETA WITH OXIA;Lu;0;L;0389;;;;N;;;;1F75;
1FCC;GREEK CAPITAL LETTER ETA WITH PROSGEGRAMMENI;Lt;0;L;0397 0345;;;;N;;;;1FC3;
1FCD;GREEK PSILI AND VARIA;Sk;0;ON;1FBF 0300;;;;N;;;;;
1FCE;GREEK PSILI AND OXIA;Sk;0;ON;1FBF 0301;;;;N;;;;;
1FCF;GREEK PSILI AND PERISPOMENI;Sk;0;ON;1FBF 0342;;;;N;;;;;
1FD0;GREEK SMALL LETTER IOTA WITH VRACHY;Ll;0;L;03B9 0306;;;;N;;;1FD8;;1FD8
1FD1;GREEK SMALL LETTER IOTA WITH MACRON;Ll;0;L;03B9 0304;;;;N;;;1FD9;;1FD9
1FD2;GREEK SMALL LETTER IOTA WITH DIALYTIKA AND VARIA;Ll;0;L;03CA 0300;;;;N;;;;;
1FD3;GREEK SMALL LETTER IOTA WITH DIALYTIKA AND OXIA;Ll;0;L;0390;;;;N;;;;;
1FD6;GREEK SMALL LETTER IOTA WITH PERISPOMENI;Ll;0;L;03B9 0342;;;;N;;;;;
1FD7;GREEK SMALL LETTER IOTA WITH DIALYTIKA AND PERISPOMENI;Ll;0;L;03CA 0342;;;;N;;;;;
1FD8;GREEK CAPITAL LETTER IOTA WITH VRACHY;Lu;0;L;0399 0306;;;;N;;;;1FD0;
1FD9;GREEK CAPITAL LETTER IOTA WITH MACRON;Lu;0;L;0399 0304;;;;N;;;;1FD1;
1FDA;GREEK CAPITAL LETTER IOTA WITH VARIA;Lu;0;L;0399 0300;;;;N;;;;1F76;
1FDB;GREEK CAPITAL LETTER IOTA WITH OXIA;Lu;0;L;038A;;;;N;;;;1F77;
1FDD;GREEK DASIA AND VARIA;Sk;0;ON;1FFE 0300;;;;N;;;;;
1FDE;GREEK DASIA AND OXIA;Sk;0;ON;1FFE 0301;;;;N;;;;;
1FDF;GREEK DASIA AND PERISPOMENI;Sk;0;ON;1FFE 0342;;;;N;;;;;
1FE0;GREEK SMALL LETTER UPSILON WITH VRACHY;Ll;0;L;03C5 0306;;;;N;;;1FE8;;1FE8
1FE1;GREEK SMALL LETTER UPSILON WITH MACRON;Ll;0;L;03C5 0304;;;;N;;;1FE9;;1FE9
1FE2;GREEK SMALL LETTER UPSILON WITH DIALYTIKA AND VARIA;Ll;0;L;03CB 0300;;;;N;;;;;
1FE3;GREEK SMALL LETTER UPSILON WITH DIALYTIKA AND OXIA;Ll;0;L;03B0;;;;N;;;;;
1FE4;GREEK SMALL LETTER RHO WITH PSILI;Ll;0;L;03C1 0313;;;;N;;;;;
1FE5;GREEK SMALL LETTER RHO WITH DASIA;Ll;0;L;03C1 0314;;;;N;;;1FEC;;1FEC
1FE6;GREEK SMALL LETTER UPSILON WITH PERISPOMENI;Ll;0;L;03C5 0342;;;;N;;;;;
1FE7;GREEK SMALL LETTER UPSILON WITH DIALYTIKA AND PERISPOMENI;Ll;0;L;03CB 0342;;;;N;;;;;
1FE8;GREEK CAPITAL LETTER UPSILON WITH VRACHY;Lu;0;L;03A5 0306;;;;N;;;;1FE0;
1FE9;GREEK CAPITAL LETTER UPSILON WITH MACRON;Lu;0;L;03A5 0304;;;;N;;;;1FE1;
1FEA;GREEK CAPITAL LETTER UPSILON WITH VARIA;Lu;0;L;03A5 0300;;;;N;;;;1F7A;
1FEB;GREEK CAPITAL LETTER UPSILON WITH OXIA;Lu;0;L;038E;;;;N;;;;1F7B;
1FEC;GREEK CAPITAL LETTER RHO WITH DASIA;Lu;0;L;03A1 0314;;;;N;;;;1FE5;
1FED;GREEK DIALYTIKA AND VARIA;Sk;0;ON;00A8 0300;;;;N;;;;;
1FEE;GREEK DIALYTIKA AND OXIA;Sk;0;ON;0385;;;;N;;;;;
1FEF;GREEK VARIA;Sk;0;ON;0060;;;;N;;;;;
1FF2;GREEK SMALL LETTER OMEGA WITH VARIA AND YPOGEGRAMMENI;Ll;0;L;1F7C 0345;;;;N;;;;;
1FF3;GREEK SMALL LETTER OMEGA WITH YPOGEGRAMMENI;Ll;0;L;03C9 0345;;;;N;;;1FFC;;1FFC
1FF4;GREEK SMALL LETTER OMEGA WITH OXIA AND YPOGEGRAMMENI;Ll;0;L;03CE 0345;;;;N;;;;;
1FF6;GREEK SMALL LETTER OMEGA WITH PERISPOMENI;Ll;0;L;03C9 0342;;;;N;;;;;
1FF7;GREEK SMALL LETTER OMEGA WITH PERISPOMENI AND YPOGEGRAMMENI;Ll;0;L;1FF6 0345;;;;N;;;;;
1FF8;GREEK CAPITAL LETTER OMICRON WITH VARIA;Lu;0;L;039F 0300;;;;N;;;;1F78;
1FF9;GREEK CAPITAL LETTER OMICRON WITH OXIA;Lu;0;L;038C;;;;N;;;;1F79;
1FFA;GREEK CAPITAL LETTER OMEGA WITH VARIA;Lu;0;L;03A9 0300;;;;N;;;;1F7C;
1FFB;GREEK CAPITAL LETTER OMEGA WITH OXIA;Lu;0;L;038F;;;;N;;;;1F7D;
1FFC;GREEK CAPITAL LETTER OMEGA WITH PROSGEGRAMMENI;Lt;0;L;03A9 0345;;;;N;;;;1FF3;
1FFD;GREEK OXIA;Sk;0;ON;00B4;;;;N;;;;;
1FFE;GREEK DASIA;Sk;0;ON;<compat> 0020 0314;;;;N;;;;;
2000;EN QUAD;Zs;0;WS;2002;;;;N;;;;;
2001;EM QUAD;Zs;0;WS;2003;;;;N;;;;;
2002;EN SPACE;Zs;0;WS;<compat> 0020;;;;N;;;;;
2003;EM SPACE;Zs;0;WS;<compat> 0020;;;;N;;;;;
2004;THREE-PER-EM SPACE;Zs;0;WS;<compat> 0020;;;;N;;;;;
2005;FOUR-PER-EM SPACE;Zs;0;WS;<compat> 0020;;;;N;;;;;
2006;SIX-PER-EM SPACE;Zs;0;WS;<compat> 0020;;;;N;;;;;
2007;FIGURE SPACE;Zs;0;WS;<noBreak> 0020;;;;N;;;;;
2008;PUNCTUATION SPACE;Zs;0;WS;<compat> 0020;;;;N;;;;;
2009;THIN SPACE;Zs;0;WS;<compat> 0020;;;;N;;;;;
200A;HAIR SPACE;Zs;0;WS;<compat> 0020;;;;N;;;;;
200B;ZERO WIDTH SPACE;Cf;0;BN;;;;;N;;;;;
200C;ZERO WIDTH NON-JOINER;Cf;0;BN;;;;;N;;;;;
200D;ZERO WIDTH JOINER;Cf;0;BN;;;;;N;;;;;
200E;LEFT-TO-RIGHT MARK;Cf;0;L;;;;;N;;;;;
200F;RIGHT-TO-LEFT MARK;Cf;0;R;;;;;N;;;;;
2010;HYPHEN;Pd;0;ON;;;;;N;;;;;
2011;NON-BREAKING HYPHEN;Pd;0;ON;<noBreak> 2010;;;;N;;;;;
2012;FIGURE DASH;Pd;0;ON;;;;;N;;;;;
2013;EN DASH;Pd;0;ON;;;;;N;;;;;
2014;EM DASH;Pd;0;ON;;;;;N;;;;;
2015;HORIZONTAL BAR;Pd;0;ON;;;;;N;QUOTATION DASH;;;;
2016;DOUBLE VERTICAL LINE;Po;0;ON;;;;;N;DOUBLE VERTICAL BAR;;;;
2017;DOUBLE LOW LINE;Po;0;ON;<compat> 0020 0333;;;;N;SPACING DOUBLE UNDERSCORE;;;;
2018;LEFT SINGLE QUOTATION MARK;Pi;0;ON;;;;;N;SINGLE TURNED COMMA QUOTATION MARK;;;;
2019;RIGHT SINGLE QUOTATION MARK;Pf;0;ON;;;;;N;SINGLE COMMA QUOTATION MARK;;;;
201A;SINGLE LOW-9 QUOTATION MARK;Ps;0;ON;;;;;N;LOW SINGLE COMMA QUOTATION MARK;;;;
201B;SINGLE HIGH-REVERSED-9 QUOTATION MARK;Pi;0;ON;;;;;N;SINGLE REVERSED COMMA QUOTATION MARK;;;;
201C;LEFT DOUBLE QUOTATION MARK;Pi;0;ON;;;;;N;DOUBLE TURNED COMMA QUOTATION MARK;;;;
201D;RIGHT DOUBLE QUOTATION MARK;Pf;0;ON;;;;;N;DOUBLE COMMA QUOTATION MARK;;;;
201E;DOUBLE LOW-9 QUOTATION MARK;Ps;0;ON;;;;;N;LOW DOUBLE COMMA QUOTATION MARK;;;;
201F;DOUBLE HIGH-REVERSED-9 QUOTATION MARK;Pi;0;ON;;;;;N;DOUBLE REVERSED COMMA QUOTATION MARK;;;;
2020;DAGGER;Po;0;ON;;;;;N;;;;;
2021;DOUBLE DAGGER;Po;0;ON;;;;;N;;;;;
2022;BULLET;Po;0;ON;;;;;N;;;;;
2023;TRIANGULAR BULLET;Po;0;ON;;;;;N;;;;;
2024;ONE DOT LEADER;Po;0;ON;<compat> 002E;;;;N;;;;;
2025;TWO DOT LEADER;Po;0;ON;<compat> 002E 002E;;;;N;;;;;
2026;HORIZONTAL ELLIPSIS;Po;0;ON;<compat> 002E 002E 002E;;;;N;;;;;
2027;HYPHENATION POINT;Po;0;ON;;;;;N;;;;;
2028;LINE SEPARATOR;Zl;0;WS;;;;;N;;;;;
2029;PARAGRAPH SEPARATOR;Zp;0;B;;;;;N;;;;;
202A;LEFT-TO-RIGHT EMBEDDING;Cf;0;LRE;;;;;N;;;;;
202B;RIGHT-TO-LEFT EMBEDDING;Cf;0;RLE;;;;;N;;;;;
202C;POP DIRECTIONAL FORMATTING;Cf;0;PDF;;;;;N;;;;;
202D;LEFT-TO-RIGHT OVERRIDE;Cf;0;LRO;;;;;N;;;;;
202E;RIGHT-TO-LEFT OVERRIDE;Cf;0;RLO;;;;;N;;;;;
202F;NARROW NO-BREAK SPACE;Zs;0;CS;<noBreak> 0020;;;;N;;;;;
2030;PER MILLE SIGN;Po;0;ET;;;;;N;;;;;
2031;PER TEN THOUSAND SIGN;Po;0;ET;;;;;N;;;;;
2032;PRIME;Po;0;ET;;;;;N;;;;;
2033;DOUBLE PRIME;Po;0;ET;<compat> 2032 2032;;;;N;;;;;
2034;TRIPLE PRIME;Po;0;ET;<compat> 2032 2032 2032;;;;N;;;;;
2035;REVERSED PRIME;Po;0;ON;;;;;N;;;;;
2036;REVERSED DOUBLE PRIME;Po;0;ON;<compat> 2035 2035;;;;N;;;;;
2037;REVERSED TRIPLE PRIME;Po;0;ON;<compat> 2035 2035 2035;;;;N;;;;;
2038;CARET;Po;0;ON;;;;;N;;;;;
2039;SINGLE LEFT-POINTING ANGLE QUOTATION MARK;Pi;0;ON;;;;;Y;LEFT POINTING SINGLE GUILLEMET;;;;
203A;SINGLE RIGHT-POINTING ANGLE QUOTATION MARK;Pf;0;ON;;;;;Y;RIGHT POINTING SINGLE GUILLEMET;;;;
203B;REFERENCE MARK;Po;0;ON;;;;;N;;;;;
203C;DOUBLE EXCLAMATION MARK;Po;0;ON;<compat> 0021 0021;;;;N;;;;;
203D;INTERROBANG;Po;0;ON;;;;;N;;;;;
203E;OVERLINE;Po;0;ON;<compat> 0020 0305;;;;N;SPACING OVERSCORE;;;;
203F;UNDERTIE;Pc;0;ON;;;;;N;;;;;
2040;CHARACTER TIE;Pc;0;ON;;;;;N;;;;;
2041;CARET INSERTION POINT;Po;0;ON;;;;;N;;;;;
2042;ASTERISM;Po;0;ON;;;;;N;;;;;
2043;HYPHEN BULLET;Po;0;ON;;;;;N;;;;;
2044;FRACTION SLASH;Sm;0;CS;;;;;N;;;;;
2045;LEFT SQUARE BRACKET WITH QUILL;Ps;0;ON;;;;;Y;;;;;
2046;RIGHT SQUARE BRACKET WITH QUILL;Pe;0;ON;;;;;Y;;;;;
2047;DOUBLE QUESTION MARK;Po;0;ON;<compat> 003F 003F;;;;N;;;;;
2048;QUESTION EXCLAMATION MARK;Po;0;ON;<compat> 003F 0021;;;;N;;;;;
2049;EXCLAMATION QUESTION MARK;Po;0;ON;<compat> 0021 003F;;;;N;;;;;
204A;TIRONIAN SIGN ET;Po;0;ON;;;;;N;;;;;
204B;REVERSED PILCROW SIGN;Po;0;ON;;;;;N;;;;;
204C;BLACK LEFTWARDS BULLET;Po;0;ON;;;;;N;;;;;
204D;BLACK RIGHTWARDS BULLET;Po;0;ON;;;;;N;;;;;
204E;LOW ASTERISK;Po;0;ON;;;;;N;;;;;
204F;REVERSED SEMICOLON;Po;0;ON;;;;;N;;;;;
2050;CLOSE UP;Po;0;ON;;;;;N;;;;;
2051;TWO ASTERISKS ALIGNED VERTICALLY;Po;0;ON;;;;;N;;;;;
2052;COMMERCIAL MINUS SIGN;Sm;0;ON;;;;;N;;;;;
2053;SWUNG DASH;Po;0;ON;;;;;N;;;;;
2054;INVERTED UNDERTIE;Pc;0;ON;;;;;N;;;;;
2055;FLOWER PUNCTUATION MARK;Po;0;ON;;;;;N;;;;;
2056;THREE DOT PUNCTUATION;Po;0;ON;;;;;N;;;;;
2057;QUADRUPLE PRIME;Po;0;ON;<compat> 2032 2032 2032 2032;;;;N;;;;;
2058;FOUR DOT PUNCTUATION;Po;0;ON;;;;;N;;;;;
2059;FIVE DOT PUNCTUATION;Po;0;ON;;;;;N;;;;;
205A;TWO DOT PUNCTUATION;Po;0;ON;;;;;N;;;;;
205B;FOUR DOT MARK;Po;0;ON;;;;;N;;;;;
205C;DOTTED CROSS;Po;0;ON;;;;;N;;;;;
205D;TRICOLON;Po;0;ON;;;;;N;;;;;
205E;VERTICAL FOUR DOTS;Po;0;ON;;;;;N;;;;;
205F;MEDIUM MATHEMATICAL SPACE;Zs;0;WS;<compat> 0020;;;;N;;;;;
2060;WORD JOINER;Cf;0;BN;;;;;N;;;;;
2061;FUNCTION APPLICATION;Cf;0;BN;;;;;N;;;;;
2062;INVISIBLE TIMES;Cf;0;BN;;;;;N;;;;;
2063;INVISIBLE SEPARATOR;Cf;0;BN;;;;;N;;;;;
2064;INVISIBLE PLUS;Cf;0;BN;;;;;N;;;;;
2066;LEFT-TO-RIGHT ISOLATE;Cf;0;LRI;;;;;N;;;;;
2067;RIGHT-TO-LEFT ISOLATE;Cf;0;RLI;;;;;N;;;;;
2068;FIRST STRONG ISOLATE;Cf;0;FSI;;;;;N;;;;;
2069;POP DIRECTIONAL ISOLATE;Cf;0;PDI;;;;;N;;;;;
206A;INHIBIT SYMMETRIC SWAPPING;Cf;0;BN;;;;;N;;;;;
206B;ACTIVATE SYMMETRIC SWAPPING;Cf;0;BN;;;;;N;;;;;
206C;INHIBIT ARABIC FORM SHAPING;Cf;0;BN;;;;;N;;;;;
206D;ACTIVATE ARABIC FORM SHAPING;Cf;0;BN;;;;;N;;;;;
206E;NATIONAL DIGIT SHAPES;Cf;0;BN;;;;;N;;;;;
206F;NOMINAL DIGIT SHAPES;Cf;0;BN;;;;;N;;;;;
2070;SUPERSCRIPT ZERO;No;0;EN;<super> 0030;;0;0;N;SUPERSCRIPT DIGIT ZERO;;;;
2071;SUPERSCRIPT LATIN SMALL LETTER I;Lm;0;L;<super> 0069;;;;N;;;;;
2074;SUPERSCRIPT FOUR;No;0;EN;<super> 0034;;4;4;N;SUPERSCRIPT DIGIT FOUR;;;;
2075;SUPERSCRIPT FIVE;No;0;EN;<super> 0035;;5;5;N;SUPERSCRIPT DIGIT FIVE;;;;
2076;SUPERSCRIPT SIX;No;0;EN;<super> 0036;;6;6;N;SUPERSCRIPT DIGIT SIX;;;;
2077;SUPERSCRIPT SEVEN;No;0;EN;<super> 0037;;7;7;N;SUPERSCRIPT DIGIT SEVEN;;;;
2078;SUPERSCRIPT EIGHT;No;0;EN;<super> 0038;;8;8;N;SUPERSCRIPT DIGIT EIGHT;;;;
2079;SUPERSCRIPT NINE;No;0;EN;<super> 0039;;9;9;N;SUPERSCRIPT DIGIT NINE;;;;
207A;SUPERSCRIPT PLUS SIGN;Sm;0;ES;<super> 002B;;;;N;;;;;
207B;SUPERSCRIPT MINUS;Sm;0;ES;<super> 2212;;;;N;SUPERSCRIPT HYPHEN-MINUS;;;;
207C;SUPERSCRIPT EQUALS SIGN;Sm;0;ON;<super> 003D;;;;N;;;;;
207D;SUPERSCRIPT LEFT PARENTHESIS;Ps;0;ON;<super> 0028;;;;Y;SUPERSCRIPT OPENING PARENTHESIS;;;;
207E;SUPERSCRIPT RIGHT PARENTHESIS;Pe;0;ON;<super> 0029;;;;Y;SUPERSCRIPT CLOSING PARENTHESIS;;;;
207F;SUPERSCRIPT LATIN SMALL LETTER N;Lm;0;L;<super> 006E;;;;N;;;;;
2080;SUBSCRIPT ZERO;No;0;EN;<sub> 0030;;0;0;N;SUBSCRIPT DIGIT ZERO;;;;
2081;SUBSCRIPT ONE;No;0;EN;<sub> 0031;;1;1;N;SUBSCRIPT DIGIT ONE;;;;
2082;SUBSCRIPT TWO;No;0;EN;<sub> 0032;;2;2;N;SUBSCRIPT DIGIT TWO;;;;
2083;SUBSCRIPT THREE;No;0;EN;<sub> 0033;;3;3;N;SUBSCRIPT DIGIT THREE;;;;
2084;SUBSCRIPT FOUR;No;0;EN;<sub> 0034;;4;4;N;SUBSCRIPT DIGIT FOUR;;;;
2085;SUBSCRIPT FIVE;No;0;EN;<sub> 0035;;5;5;N;SUBSCRIPT DIGIT FIVE;;;;
2086;SUBSCRIPT SIX;No;0;EN;<sub> 0036;;6;6;N;SUBSCRIPT DIGIT SIX;;;;
2087;SUBSCRIPT SEVEN;No;0;EN;<sub> 0037;;7;7;N;SUBSCRIPT DIGIT SEVEN;;;;
2088;SUBSCRIPT EIGHT;No;0;EN;<sub> 0038;;8;8;N;SUBSCRIPT DIGIT EIGHT;;;;
2089;SUBSCRIPT NINE;No;0;EN;<sub> 0039;;9;9;N;SUBSCRIPT DIGIT NINE;;;;
208A;SUBSCRIPT PLUS SIGN;Sm;0;ES;<sub> 002B;;;;N;;;;;
208B;SUBSCRIPT MINUS;Sm;0;ES;<sub> 2212;;;;N;SUBSCRIPT HYPHEN-MINUS;;;;
208C;SUBSCRIPT EQUALS SIGN;Sm;0;ON;<sub> 003D;;;;N;;;;;
208D;SUBSCRIPT LEFT PARENTHESIS;Ps;0;ON;<sub> 0028;;;;Y;SUBSCRIPT OPENING PARENTHESIS;;;;
208E;SUBSCRIPT RIGHT PARENTHESIS;Pe;0;ON;<sub> 0029;;;;Y;SUBSCRIPT CLOSING PARENTHESIS;;;;
2090;LATIN SUBSCRIPT SMALL LETTER A;Lm;0;L;<sub> 0061;;;;N;;;;;
2091;LATIN SUBSCRIPT SMALL LETTER E;Lm;0;L;<sub> 0065;;;;N;;;;;
2092;LATIN SUBSCRIPT SMALL LETTER O;Lm;0;L;<sub> 006F;;;;N;;;;;
2093;LATIN SUBSCRIPT SMALL LETTER X;Lm;0;L;<sub> 0078;;;;N;;;;;
2094;LATIN SUBSCRIPT SMALL LETTER SCHWA;Lm;0;L;<sub> 0259;;;;N;;;;;
2095;LATIN SUBSCRIPT SMALL LETTER H;Lm;0;L;<sub> 0068;;;;N;;;;;
2096;LATIN SUBSCRIPT SMALL LETTER K;Lm;0;L;<sub> 006B;;;;N;;;;;
2097;LATIN SUBSCRIPT SMALL LETTER L;Lm;0;L;<sub> 006C;;;;N;;;;;
2098;LATIN SUBSCRIPT SMALL LETTER M;Lm;0;L;<sub> 006D;;;;N;;;;;
2099;LATIN SUBSCRIPT SMALL LETTER N;Lm;0;L;<sub> 006E;;;;N;;;;;
209A;LATIN SUBSCRIPT SMALL LETTER P;Lm;0;L;<sub> 0070;;;;N;;;;;
209B;LATIN SUBSCRIPT SMALL LETTER S;Lm;0;L;<sub> 0073;;;;N;;;;;
209C;LATIN SUBSCRIPT SMALL LETTER T;Lm;0;L;<sub> 0074;;;;N;;;;;
20A0;EURO-CURRENCY SIGN;Sc;0;ET;;;;;N;;;;;
20A1;COLON SIGN;Sc;0;ET;;;;;N;;;;;
20A2;CRUZEIRO SIGN;Sc;0;ET;;;;;N;;;;;
20A3;FRENCH FRANC SIGN;Sc;0;ET;;;;;N;;;;;
20A4;LIRA SIGN;Sc;0;ET;;;;;N;;;;;
20A5;MILL SIGN;Sc;0;ET;;;;;N;;;;;
20A6;NAIRA SIGN;Sc;0;ET;;;;;N;;;;;
20A7;PESETA SIGN;Sc;0;ET;;;;;N;;;;;
20A8;RUPEE SIGN;Sc;0;ET;<compat> 0052 0073;;;;N;;;;;
20A9;WON SIGN;Sc;0;ET;;;;;N;;;;;
20AA;NEW SHEQEL SIGN;Sc;0;ET;;;;;N;;;;;
20AB;DONG SIGN;Sc;0;ET;;;;;N;;;;;
20AC;EURO SIGN;Sc;0;ET;;;;;N;;;;;
20AD;KIP SIGN;Sc;0;ET;;;;;N;;;;;
20AE;TUGRIK SIGN;Sc;0;ET;;;;;N;;;;;
20AF;DRACHMA SIGN;Sc;0;ET;;;;;N;;;;;
20B0;GERMAN PENNY SIGN;Sc;0;ET;;;;;N;;;;;
20B1;PESO SIGN;Sc;0;ET;;;;;N;;;;;
20B2;GUARANI SIGN;Sc;0;ET;;;;;N;;;;;
20B3;AUSTRAL SIGN;Sc;0;ET;;;;;N;;;;;
20B4;HRYVNIA SIGN;Sc;0;ET;;;;;N;;;;;
20B5;CEDI SIGN;Sc;0;ET;;;;;N;;;;;
20B6;LIVRE TOURNOIS SIGN;Sc;0;ET;;;;;N;;;;;
20B7;SPESMILO SIGN;Sc;0;ET;;;;;N;;;;;
20B8;TENGE SIGN;Sc;0;ET;;;;;N;;;;;
20B9;INDIAN RUPEE SIGN;Sc;0;ET;;;;;N;;;;;
20BA;TURKISH LIRA SIGN;Sc;0;ET;;;;;N;;;;;
20BB;NORDIC MARK SIGN;Sc;0;ET;;;;;N;;;;;
20BC;MANAT SIGN;Sc;0;ET;;;;;N;;;;;
20BD;RUBLE SIGN;Sc;0;ET;;;;;N;;;;;
20BE;LARI SIGN;Sc;0;ET;;;;;N;;;;;
20BF;BITCOIN SIGN;Sc;0;ET;;;;;N;;;;;
20C0;SOM SIGN;Sc;0;ET;;;;;N;;;;;
20D0;COMBINING LEFT HARPOON ABOVE;Mn;230;NSM;;;;;N;NON-SPACING LEFT HARPOON ABOVE;;;;
20D1;COMBINING RIGHT HARPOON ABOVE;Mn;230;NSM;;;;;N;NON-SPACING RIGHT HARPOON ABOVE;;;;
20D2;COMBINING LONG VERTICAL LINE OVERLAY;Mn;1;NSM;;;;;N;NON-SPACING LONG VERTICAL BAR OVERLAY;;;;
20D3;COMBINING SHORT VERTICAL LINE OVERLAY;Mn;1;NSM;;;;;N;NON-SPACING SHORT VERTICAL BAR OVERLAY;;;;
20D4;COMBINING ANTICLOCKWISE ARROW ABOVE;Mn;230;NSM;;;;;N;NON-SPACING ANTICLOCKWISE ARROW ABOVE;;;;
20D5;COMBINING CLOCKWISE ARROW ABOVE;Mn;230;NSM;;;;;N;NON-SPACING CLOCKWISE ARROW ABOVE;;;;
20D6;COMBINING LEFT ARROW ABOVE;Mn;230;NSM;;;;;N;NON-SPACING LEFT ARROW ABOVE;;;;
20D7;COMBINING RIGHT ARROW ABOVE;Mn;230;NSM;;;;;N;NON-SPACING RIGHT ARROW ABOVE;;;;
20D8;COMBINING RING OVERLAY;Mn;1;NSM;;;;;N;NON-SPACING RING OVERLAY;;;;
20D9;COMBINING CLOCKWISE RING OVERLAY;Mn;1;NSM;;;;;N;NON-SPACING CLOCKWISE RING OVERLAY;;;;
20DA;COMBINING ANTICLOCKWISE RING OVERLAY;Mn;1;NSM;;;;;N;NON-SPACING ANTICLOCKWISE RING OVERLAY;;;;
20DB;COMBINING THREE DOTS ABOVE;Mn;230;NSM;;;;;N;NON-SPACING THREE DOTS ABOVE;;;;
20DC;COMBINING FOUR DOTS ABOVE;Mn;230;NSM;;;;;N;NON-SPACING FOUR DOTS ABOVE;;;;
20DD;COMBINING ENCLOSING CIRCLE;Me;0;NSM;;;;;N;ENCLOSING CIRCLE;;;;
20DE;COMBINING ENCLOSING SQUARE;Me;0;NSM;;;;;N;ENCLOSING SQUARE;;;;
20DF;COMBINING ENCLOSING DIAMOND;Me;0;NSM;;;;;N;ENCLOSING DIAMOND;;;;
20E0;COMBINING ENCLOSING CIRCLE BACKSLASH;Me;0;NSM;;;;;N;ENCLOSING CIRCLE SLASH;;;;
20E1;COMBINING LEFT RIGHT ARROW ABOVE;Mn;230;NSM;;;;;N;NON-SPACING LEFT RIGHT ARROW ABOVE;;;;
20E2;COMBINING ENCLOSING SCREEN;Me;0;NSM;;;;;N;;;;;
20E3;COMBINING ENCLOSING KEYCAP;Me;0;NSM;;;;;N;;;;;
20E4;COMBINING ENCLOSING UPWARD POINTING TRIANGLE;Me;0;NSM;;;;;N;;;;;
20E5;COMBINING REVERSE SOLIDUS OVERLAY;Mn;1;NSM;;;;;N;;;;;
20E6;COMBINING DOUBLE VERTICAL STROKE OVERLAY;Mn;1;NSM;;;;;N;;;;;
20E7;COMBINING ANNUITY SYMBOL;Mn;230;NSM;;;;;N;;;;;
20E8;COMBINING TRIPLE UNDERDOT;Mn;220;NSM;;;;;N;;;;;
20E9;COMBINING WIDE BRIDGE ABOVE;Mn;230;NSM;;;;;N;;;;;
20EA;COMBINING LEFTWARDS ARROW OVERLAY;Mn;1;NSM;;;;;N;;;;;
20EB;COMBINING LONG DOUBLE SOLIDUS OVERLAY;Mn;1;NSM;;;;;N;;;;;
20EC;COMBINING RIGHTWARDS HARPOON WITH BARB DOWNWARDS;Mn;220;NSM;;;;;N;;;;;
20ED;COMBINING LEFTWARDS HARPOON WITH BARB DOWNWARDS;Mn;220;NSM;;;;;N;;;;;
20EE;COMBINING LEFT ARROW BELOW;Mn;220;NSM;;;;;N;;;;;
20EF;COMBINING RIGHT ARROW BELOW;Mn;220;NSM;;;;;N;;;;;
20F0;COMBINING ASTERISK ABOVE;Mn;230;NSM;;;;;N;;;;;
2100;ACCOUNT OF;So;0;ON;<compat> 0061 002F 0063;;;;N;;;;;
2101;ADDRESSED TO THE SUBJECT;So;0;ON;<compat> 0061 002F 0073;;;;N;;;;;
2102;DOUBLE-STRUCK CAPITAL C;Lu;0;L;<font> 0043;;;;N;DOUBLE-STRUCK C;;;;
2103;DEGREE CELSIUS;So;0;ON;<compat> 00B0 0043;;;;N;DEGREES CENTIGRADE;;;;
2104;CENTRE LINE SYMBOL;So;0;ON;;;;;N;C L SYMBOL;;;;
2105;CARE OF;So;0;ON;<compat> 0063 002F 006F;;;;N;;;;;
2106;CADA UNA;So;0;ON;<compat> 0063 002F 0075;;;;N;;;;;
2107;EULER CONSTANT;Lu;0;L;<compat> 0190;;;;N;EULERS;;;;
2108;SCRUPLE;So;0;ON;;;;;N;;;;;
2109;DEGREE FAHRENHEIT;So;0;ON;<compat> 00B0 0046;;;;N;DEGREES FAHRENHEIT;;;;
210A;SCRIPT SMALL G;Ll;0;L;<font> 0067;;;;N;;;;;
210B;SCRIPT CAPITAL H;Lu;0;L;<font> 0048;;;;N;SCRIPT H;;;;
210C;BLACK-LETTER CAPITAL H;Lu;0;L;<font> 0048;;;;N;BLACK-LETTER H;;;;
210D;DOUBLE-STRUCK CAPITAL H;Lu;0;L;<font> 0048;;;;N;DOUBLE-STRUCK H;;;;
210E;PLANCK CONSTANT;Ll;0;L;<font> 0068;;;;N;;;;;
210F;PLANCK CONSTANT OVER TWO PI;Ll;0;L;<font> 0127;;;;N;PLANCK CONSTANT OVER 2 PI;;;;
2110;SCRIPT CAPITAL I;Lu;0;L;<font> 0049;;;;N;SCRIPT I;;;;
2111;BLACK-LETTER CAPITAL I;Lu;0;L;<font> 0049;;;;N;BLACK-LETTER I;;;;
2112;SCRIPT CAPITAL L;Lu;0;L;<font> 004C;;;;N;SCRIPT L;;;;
2113;SCRIPT SMALL L;Ll;0;L;<font> 006C;;;;N;;;;;
2114;L B BAR SYMBOL;So;0;ON;;;;;N;;;;;
2115;DOUBLE-STRUCK CAPITAL N;Lu;0;L;<font> 004E;;;;N;DOUBLE-STRUCK N;;;;
2116;NUMERO SIGN;So;0;ON;<compat> 004E 006F;;;;N;NUMERO;;;;
2117;SOUND RECORDING COPYRIGHT;So;0;ON;;;;;N;;;;;
2118;SCRIPT CAPITAL P;Sm;0;ON;;;;;N;SCRIPT P;;;;
2119;DOUBLE-STRUCK CAPITAL P;Lu;0;L;<font> 0050;;;;N;DOUBLE-STRUCK P;;;;
211A;DOUBLE-STRUCK CAPITAL Q;Lu;0;L;<font> 0051;;;;N;DOUBLE-STRUCK Q;;;;
211B;SCRIPT CAPITAL R;Lu;0;L;<font> 0052;;;;N;SCRIPT R;;;;
211C;BLACK-LETTER CAPITAL R;Lu;0;L;<font> 0052;;;;N;BLACK-LETTER R;;;;
211D;DOUBLE-STRUCK CAPITAL R;Lu;0;L;<font> 0052;;;;N;DOUBLE-STRUCK R;;;;
211E;PRESCRIPTION TAKE;So;0;ON;;;;;N;;;;;
211F;RESPONSE;So;0;ON;;;;;N;;;;;
2120;SERVICE MARK;So;0;ON;<super> 0053 004D;;;;N;;;;;
2121;TELEPHONE SIGN;So;0;ON;<compat> 0054 0045 004C;;;;N;T E L SYMBOL;;;;
2122;TRADE MARK SIGN;So;0;ON;<super> 0054 004D;;;;N;TRADEMARK;;;;
2123;VERSICLE;So;0;ON;;;;;N;;;;;
2124;DOUBLE-STRUCK CAPITAL Z;Lu;0;L;<font> 005A;;;;N;DOUBLE-STRUCK Z;;;;
2125;OUNCE SIGN;So;0;ON;;;;;N;OUNCE;;;;
2126;OHM SIGN;Lu;0;L;03A9;;;;N;OHM;;;03C9;
2127;INVERTED OHM SIGN;So;0;ON;;;;;N;MHO;;;;
2128;BLACK-LETTER CAPITAL Z;Lu;0;L;<font> 005A;;;;N;BLACK-LETTER Z;;;;
2129;TURNED GREEK SMALL LETTER IOTA;So;0;ON;;;;;N;;;;;
212A;KELVIN SIGN;Lu;0;L;004B;;;;N;DEGREES KELVIN;;;006B;
212B;ANGSTROM SIGN;Lu;0;L;00C5;;;;N;ANGSTROM UNIT;;;00E5;
212C;SCRIPT CAPITAL B;Lu;0;L;<font> 0042;;;;N;SCRIPT B;;;;
212D;BLACK-LETTER CAPITAL C;Lu;0;L;<font> 0043;;;;N;BLACK-LETTER C;;;;
212E;ESTIMATED SYMBOL;So;0;ET;;;;;N;;;;;
212F;SCRIPT SMALL E;Ll;0;L;<font> 0065;;;;N;;;;;
2130;SCRIPT CAPITAL E;Lu;0;L;<font> 0045;;;;N;SCRIPT E;;;;
2131;SCRIPT CAPITAL F;Lu;0;L;<font> 0046;;;;N;SCRIPT F;;;;
2132;TURNED CAPITAL F;Lu;0;L;;;;;N;TURNED F;;;214E;
2133;SCRIPT CAPITAL M;Lu;0;L;<font> 004D;;;;N;SCRIPT M;;;;
2134;SCRIPT SMALL O;Ll;0;L;<font> 006F;;;;N;;;;;
2135;ALEF SYMBOL;Lo;0;L;<compat> 05D0;;;;N;FIRST TRANSFINITE CARDINAL;;;;
2136;BET SYMBOL;Lo;0;L;<compat> 05D1;;;;N;SECOND TRANSFINITE CARDINAL;;;;
2137;GIMEL SYMBOL;Lo;0;L;<compat> 05D2;;;;N;THIRD TRANSFINITE CARDINAL;;;;
2138;DALET SYMBOL;Lo;0;L;<compat> 05D3;;;;N;FOURTH TRANSFINITE CARDINAL;;;;
2139;INFORMATION SOURCE;Ll;0;L;<font> 0069;;;;N;;;;;
213A;ROTATED CAPITAL Q;So;0;ON;;;;;N;;;;;
213B;FACSIMILE SIGN;So;0;ON;<compat> 0046 0041 0058;;;;N;;;;;
213C;DOUBLE-STRUCK SMALL PI;Ll;0;L;<font> 03C0;;;;N;;;;;
213D;DOUBLE-STRUCK SMALL GAMMA;Ll;0;L;<font> 03B3;;;;N;;;;;
213E;DOUBLE-STRUCK CAPITAL GAMMA;Lu;0;L;<font> 0393;;;;N;;;;;
213F;DOUBLE-STRUCK CAPITAL PI;Lu;0;L;<font> 03A0;;;;N;;;;;
2140;DOUBLE-STRUCK N-ARY SUMMATION;Sm;0;ON;<font> 2211;;;;Y;;;;;
2141;TURNED SANS-SERIF CAPITAL G;Sm;0;ON;;;;;N;;;;;
2142;TURNED SANS-SERIF CAPITAL L;Sm;0;ON;;;;;N;;;;;
2143;REVERSED SANS-SERIF CAPITAL L;Sm;0;ON;;;;;N;;;;;
2144;TURNED SANS-SERIF CAPITAL Y;Sm;0;ON;;;;;N;;;;;
2145;DOUBLE-STRUCK ITALIC CAPITAL D;Lu;0;L;<font> 0044;;;;N;;;;;
2146;DOUBLE-STRUCK ITALIC SMALL D;Ll;0;L;<font> 0064;;;;N;;;;;
2147;DOUBLE-STRUCK ITALIC SMALL E;Ll;0;L;<font> 0065;;;;N;;;;;
2148;DOUBLE-STRUCK ITALIC SMALL I;Ll;0;L;<font> 0069;;;;N;;;;;
2149;DOUBLE-STRUCK ITALIC SMALL J;Ll;0;L;<font> 006A;;;;N;;;;;
214A;PROPERTY LINE;So;0;ON;;;;;N;;;;;
214B;TURNED AMPERSAND;Sm;0;ON;;;;;N;;;;;
214C;PER SIGN;So;0;ON;;;;;N;;;;;
214D;AKTIESELSKAB;So;0;ON;;;;;N;;;;;
214E;TURNED SMALL F;Ll;0;L;;;;;N;;;2132;;2132
214F;SYMBOL FOR SAMARITAN SOURCE;So;0;L;;;;;N;;;;;
2150;VULGAR FRACTION ONE SEVENTH;No;0;ON;<fraction> 0031 2044 0037;;;1/7;N;;;;;
2151;VULGAR FRACTION ONE NINTH;No;0;ON;<fraction> 0031 2044 0039;;;1/9;N;;;;;
2152;VULGAR FRACTION ONE TENTH;No;0;ON;<fraction> 0031 2044 0031 0030;;;1/10;N;;;;;
2153;VULGAR FRACTION ONE THIRD;No;0;ON;<fraction> 0031 2044 0033;;;1/3;N;FRACTION ONE THIRD;;;;
2154;VULGAR FRACTION TWO THIRDS;No;0;ON;<fraction> 0032 2044 0033;;;2/3;N;FRACTION TWO THIRDS;;;;
2155;VULGAR FRACTION ONE FIFTH;No;0;ON;<fraction> 0031 2044 0035;;;1/5;N;FRACTION ONE FIFTH;;;;
2156;VULGAR FRACTION TWO FIFTHS;No;0;ON;<fraction> 0032 2044 0035;;;2/5;N;FRACTION TWO FIFTHS;;;;
2157;VULGAR FRACTION THREE FIFTHS;No;0;ON;<fraction> 0033 2044 0035;;;3/5;N;FRACTION THREE FIFTHS;;;;
2158;VULGAR FRACTION FOUR FIFTHS;No;0;ON;<fraction> 0034 2044 0035;;;4/5;N;FRACTION FOUR FIFTHS;;;;
2159;VULGAR FRACTION ONE SIXTH;No;0;ON;<fraction> 0031 2044 0036;;;1/6;N;FRACTION ONE SIXTH;;;;
215A;VULGAR FRACTION FIVE SIXTHS;No;0;ON;<fraction> 0035 2044 0036;;;5/6;N;FRACTION FIVE SIXTHS;;;;
215B;VULGAR FRACTION ONE EIGHTH;No;0;ON;<fraction> 0031 2044 0038;;;1/8;N;FRACTION ONE EIGHTH;;;;
215C;VULGAR FRACTION THREE EIGHTHS;No;0;ON;<fraction> 0033 2044 0038;;;3/8;N;FRACTION THREE EIGHTHS;;;;
215D;VULGAR FRACTION FIVE EIGHTHS;No;0;ON;<fraction> 0035 2044 0038;;;5/8;N;FRACTION FIVE EIGHTHS;;;;
215E;VULGAR FRACTION SEVEN EIGHTHS;No;0;ON;<fraction> 0037 2044 0038;;;7/8;N;FRACTION SEVEN EIGHTHS;;;;
215F;FRACTION NUMERATOR ONE;No;0;ON;<fraction> 0031 2044;;;1;N;;;;;
2160;ROMAN NUMERAL ONE;Nl;0;L;<compat> 0049;;;1;N;;;;2170;
2161;ROMAN NUMERAL TWO;Nl;0;L;<compat> 0049 0049;;;2;N;;;;2171;
2162;ROMAN NUMERAL THREE;Nl;0;L;<compat> 0049 0049 0049;;;3;N;;;;2172;
2163;ROMAN NUMERAL FOUR;Nl;0;L;<compat> 0049 0056;;;4;N;;;;2173;
2164;ROMAN NUMERAL FIVE;Nl;0;L;<compat> 0056;;;5;N;;;;2174;
2165;ROMAN NUMERAL SIX;Nl;0;L;<compat> 0056 0049;;;6;N;;;;2175;
2166;ROMAN NUMERAL SEVEN;Nl;0;L;<compat> 0056 0049 0049;;;7;N;;;;2176;
2167;ROMAN NUMERAL EIGHT;Nl;0;L;<compat> 0056 0049 0049 0049;;;8;N;;;;2177;
2168;ROMAN NUMERAL NINE;Nl;0;L;<compat> 0049 0058;;;9;N;;;;2178;
2169;ROMAN NUMERAL TEN;Nl;0;L;<compat> 0058;;;10;N;;;;2179;
216A;ROMAN NUMERAL ELEVEN;Nl;0;L;<compat> 0058 0049;;;11;N;;;;217A;
216B;ROMAN NUMERAL TWELVE;Nl;0;L;<compat> 0058 0049 0049;;;12;N;;;;217B;
216C;ROMAN NUMERAL FIFTY;Nl;0;L;<compat> 004C;;;50;N;;;;217C;
216D;ROMAN NUMERAL ONE HUNDRED;Nl;0;L;<compat> 0043;;;100;N;;;;217D;
216E;ROMAN NUMERAL FIVE HUNDRED;Nl;0;L;<compat> 0044;;;500;N;;;;217E;
216F;ROMAN NUMERAL ONE THOUSAND;Nl;0;L;<compat> 004D;;;1000;N;;;;217F;
2170;SMALL ROMAN NUMERAL ONE;Nl;0;L;<compat> 0069;;;1;N;;;2160;;2160
2171;SMALL ROMAN NUMERAL TWO;Nl;0;L;<compat> 0069 0069;;;2;N;;;2161;;2161
2172;SMALL ROMAN NUMERAL THREE;Nl;0;L;<compat> 0069 0069 0069;;;3;N;;;2162;;2162
2173;SMALL ROMAN NUMERAL FOUR;Nl;0;L;<compat> 0069 0076;;;4;N;;;2163;;2163
2174;SMALL ROMAN NUMERAL FIVE;Nl;0;L;<compat> 0076;;;5;N;;;2164;;2164
2175;SMALL ROMAN NUMERAL SIX;Nl;0;L;<compat> 0076 0069;;;6;N;;;2165;;2165
2176;SMALL ROMAN NUMERAL SEVEN;Nl;0;L;<compat> 0076 0069 0069;;;7;N;;;2166;;2166
2177;SMALL ROMAN NUMERAL EIGHT;Nl;0;L;<compat> 0076 0069 0069 0069;;;8;N;;;2167;;2167
2178;SMALL ROMAN NUMERAL NINE;Nl;0;L;<compat> 0069 0078;;;9;N;;;2168;;2168
2179;SMALL ROMAN NUMERAL TEN;Nl;0;L;<compat> 0078;;;10;N;;;2169;;2169
217A;SMALL ROMAN NUMERAL ELEVEN;Nl;0;L;<compat> 0078 0069;;;11;N;;;216A;;216A
217B;SMALL ROMAN NUMERAL TWELVE;Nl;0;L;<compat> 0078 0069 0069;;;12;N;;;216B;;216B
217C;SMALL ROMAN NUMERAL FIFTY;Nl;0;L;<compat> 006C;;;50;N;;;216C;;216C
217D;SMALL ROMAN NUMERAL ONE HUNDRED;Nl;0;L;<compat> 0063;;;100;N;;;216D;;216D
217E;SMALL ROMAN NUMERAL FIVE HUNDRED;Nl;0;L;<compat> 0064;;;500;N;;;216E;;216E
217F;SMALL ROMAN NUMERAL ONE THOUSAND;Nl;0;L;<compat> 006D;;;1000;N;;;216F;;216F
2180;ROMAN NUMERAL ONE THOUSAND C D;Nl;0;L;;;;1000;N;;;;;
2181;ROMAN NUMERAL FIVE THOUSAND;Nl;0;L;;;;5000;N;;;;;
2182;ROMAN NUMERAL TEN THOUSAND;Nl;0;L;;;;10000;N;;;;;
2183;ROMAN NUMERAL REVERSED ONE HUNDRED;Lu;0;L;;;;;N;;;;2184;
2184;LATIN SMALL LETTER REVERSED C;Ll;0;L;;;;;N;;;2183;;2183
2185;ROMAN NUMERAL SIX LATE FORM;Nl;0;L;;;;6;N;;;;;
2186;ROMAN NUMERAL FIFTY EARLY FORM;Nl;0;L;;;;50;N;;;;;
2187;ROMAN NUMERAL FIFTY THOUSAND;Nl;0;L;;;;50000;N;;;;;
2188;ROMAN NUMERAL ONE HUNDRED THOUSAND;Nl;0;L;;;;100000;N;;;;;
2189;VULGAR FRACTION ZERO THIRDS;No;0;ON;<fraction> 0030 2044 0033;;;0;N;;;;;
218A;TURNED DIGIT TWO;So;0;ON;;;;;N;;;;;
218B;TURNED DIGIT THREE;So;0;ON;;;;;N;;;;;
2190;LEFTWARDS ARROW;Sm;0;ON;;;;;N;LEFT ARROW;;;;
2191;UPWARDS ARROW;Sm;0;ON;;;;;N;UP ARROW;;;;
2192;RIGHTWARDS ARROW;Sm;0;ON;;;;;N;RIGHT ARROW;;;;
2193;DOWNWARDS ARROW;Sm;0;ON;;;;;N;DOWN ARROW;;;;
2194;LEFT RIGHT ARROW;Sm;0;ON;;;;;N;;;;;
2195;UP DOWN ARROW;So;0;ON;;;;;N;;;;;
2196;NORTH WEST ARROW;So;0;ON;;;;;N;UPPER LEFT ARROW;;;;
2197;NORTH EAST ARROW;So;0;ON;;;;;N;UPPER RIGHT ARROW;;;;
2198;SOUTH EAST ARROW;So;0;ON;;;;;N;LOWER RIGHT ARROW;;;;
2199;SOUTH WEST ARROW;So;0;ON;;;;;N;LOWER LEFT ARROW;;;;
219A;LEFTWARDS ARROW WITH STROKE;Sm;0;ON;2190 0338;;;;N;LEFT ARROW WITH STROKE;;;;
219B;RIGHTWARDS ARROW WITH STROKE;Sm;0;ON;2192 0338;;;;N;RIGHT ARROW WITH STROKE;;;;
219C;LEFTWARDS WAVE ARROW;So;0;ON;;;;;N;LEFT WAVE ARROW;;;;
219D;RIGHTWARDS WAVE ARROW;So;0;ON;;;;;N;RIGHT WAVE ARROW;;;;
219E;LEFTWARDS TWO HEADED ARROW;So;0;ON;;;;;N;LEFT TWO HEADED ARROW;;;;
219F;UPWARDS TWO HEADED ARROW;So;0;ON;;;;;N;UP TWO HEADED ARROW;;;;
21A0;RIGHTWARDS TWO HEADED ARROW;Sm;0;ON;;;;;N;RIGHT TWO HEADED ARROW;;;;
21A1;DOWNWARDS TWO HEADED ARROW;So;0;ON;;;;;N;DOWN TWO HEADED ARROW;;;;
21A2;LEFTWARDS ARROW WITH TAIL;So;0;ON;;;;;N;LEFT ARROW WITH TAIL;;;;
21A3;RIGHTWARDS ARROW WITH TAIL;Sm;0;ON;;;;;N;RIGHT ARROW WITH TAIL;;;;
21A4;LEFTWARDS ARROW FROM BAR;So;0;ON;;;;;N;LEFT ARROW FROM BAR;;;;
21A5;UPWARDS ARROW FROM BAR;So;0;ON;;;;;N;UP ARROW FROM BAR;;;;
21A6;RIGHTWARDS ARROW FROM BAR;Sm;0;ON;;;;;N;RIGHT ARROW FROM BAR;;;;
21A7;DOWNWARDS ARROW FROM BAR;So;0;ON;;;;;N;DOWN ARROW FROM BAR;;;;
21A8;UP DOWN ARROW WITH BASE;So;0;ON;;;;;N;;;;;
21A9;LEFTWARDS ARROW WITH HOOK;So;0;ON;;;;;N;LEFT ARROW WITH HOOK;;;;
21AA;RIGHTWARDS ARROW WITH HOOK;So;0;ON;;;;;N;RIGHT ARROW WITH HOOK;;;;
21AB;LEFTWARDS ARROW WITH LOOP;So;0;ON;;;;;N;LEFT ARROW WITH LOOP;;;;
21AC;RIGHTWARDS ARROW WITH LOOP;So;0;ON;;;;;N;RIGHT ARROW WITH LOOP;;;;
21AD;LEFT RIGHT WAVE ARROW;So;0;ON;;;;;N;;;;;
21AE;LEFT RIGHT ARROW WITH STROKE;Sm;0;ON;2194 0338;;;;N;;;;;
21AF;DOWNWARDS ZIGZAG ARROW;So;0;ON;;;;;N;DOWN ZIGZAG ARROW;;;;
21B0;UPWARDS ARROW WITH TIP LEFTWARDS;So;0;ON;;;;;N;UP ARROW WITH TIP LEFT;;;;
21B1;UPWARDS ARROW WITH TIP RIGHTWARDS;So;0;ON;;;;;N;UP ARROW WITH TIP RIGHT;;;;
21B2;DOWNWARDS ARROW WITH TIP LEFTWARDS;So;0;ON;;;;;N;DOWN ARROW WITH TIP LEFT;;;;
21B3;DOWNWARDS ARROW WITH TIP RIGHTWARDS;So;0;ON;;;;;N;DOWN ARROW WITH TIP RIGHT;;;;
21B4;RIGHTWARDS ARROW WITH CORNER DOWNWARDS;So;0;ON;;;;;N;RIGHT ARROW WITH CORNER DOWN;;;;
21B5;DOWNWARDS ARROW WITH CORNER LEFTWARDS;So;0;ON;;;;;N;DOWN ARROW WITH CORNER LEFT;;;;
21B6;ANTICLOCKWISE TOP SEMICIRCLE ARROW;So;0;ON;;;;;N;;;;;
21B7;CLOCKWISE TOP SEMICIRCLE ARROW;So;0;ON;;;;;N;;;;;
21B8;NORTH WEST ARROW TO LONG BAR;So;0;ON;;;;;N;UPPER LEFT ARROW TO LONG BAR;;;;
21B9;LEFTWARDS ARROW TO BAR OVER RIGHTWARDS ARROW TO BAR;So;0;ON;;;;;N;LEFT ARROW TO BAR OVER RIGHT ARROW TO BAR;;;;
21BA;ANTICLOCKWISE OPEN CIRCLE ARROW;So;0;ON;;;;;N;;;;;
21BB;CLOCKWISE OPEN CIRCLE ARROW;So;0;ON;;;;;N;;;;;
21BC;LEFTWARDS HARPOON WITH BARB UPWARDS;So;0;ON;;;;;N;LEFT HARPOON WITH BARB UP;;;;
21BD;LEFTWARDS HARPOON WITH BARB DOWNWARDS;So;0;ON;;;;;N;LEFT HARPOON WITH BARB DOWN;;;;
21BE;UPWARDS HARPOON WITH BARB RIGHTWARDS;So;0;ON;;;;;N;UP HARPOON WITH BARB RIGHT;;;;
21BF;UPWARDS HARPOON WITH BARB LEFTWARDS;So;0;ON;;;;;N;UP HARPOON WITH BARB LEFT;;;;
21C0;RIGHTWARDS HARPOON WITH BARB UPWARDS;So;0;ON;;;;;N;RIGHT HARPOON WITH BARB UP;;;;
21C1;RIGHTWARDS HARPOON WITH BARB DOWNWARDS;So;0;ON;;;;;N;RIGHT HARPOON WITH BARB DOWN;;;;
21C2;DOWNWARDS HARPOON WITH BARB RIGHTWARDS;So;0;ON;;;;;N;DOWN HARPOON WITH BARB RIGHT;;;;
21C3;DOWNWARDS HARPOON WITH BARB LEFTWARDS;So;0;ON;;;;;N;DOWN HARPOON WITH BARB LEFT;;;;
21C4;RIGHTWARDS ARROW OVER LEFTWARDS ARROW;So;0;ON;;;;;N;RIGHT ARROW OVER LEFT ARROW;;;;
21C5;UPWARDS ARROW LEFTWARDS OF DOWNWARDS ARROW;So;0;ON;;;;;N;UP ARROW LEFT OF DOWN ARROW;;;;
21C6;LEFTWARDS ARROW OVER RIGHTWARDS ARROW;So;0;ON;;;;;N;LEFT ARROW OVER RIGHT ARROW;;;;
21C7;LEFTWARDS PAIRED ARROWS;So;0;ON;;;;;N;LEFT PAIRED ARROWS;;;;
21C8;UPWARDS PAIRED ARROWS;So;0;ON;;;;;N;UP PAIRED ARROWS;;;;
21C9;RIGHTWARDS PAIRED ARROWS;So;0;ON;;;;;N;RIGHT PAIRED ARROWS;;;;
21CA;DOWNWARDS PAIRED ARROWS;So;0;ON;;;;;N;DOWN PAIRED ARROWS;;;;
21CB;LEFTWARDS HARPOON OVER RIGHTWARDS HARPOON;So;0;ON;;;;;N;LEFT HARPOON OVER RIGHT HARPOON;;;;
21CC;RIGHTWARDS HARPOON OVER LEFTWARDS HARPOON;So;0;ON;;;;;N;RIGHT HARPOON OVER LEFT HARPOON;;;;
21CD;LEFTWARDS DOUBLE ARROW WITH STROKE;So;0;ON;21D0 0338;;;;N;LEFT DOUBLE ARROW WITH STROKE;;;;
21CE;LEFT RIGHT DOUBLE ARROW WITH STROKE;Sm;0;ON;21D4 0338;;;;N;;;;;
21CF;RIGHTWARDS DOUBLE ARROW WITH STROKE;Sm;0;ON;21D2 0338;;;;N;RIGHT DOUBLE ARROW WITH STROKE;;;;
21D0;LEFTWARDS DOUBLE ARROW;So;0;ON;;;;;N;LEFT DOUBLE ARROW;;;;
21D1;UPWARDS DOUBLE ARROW;So;0;ON;;;;;N;UP DOUBLE ARROW;;;;
21D2;RIGHTWARDS DOUBLE ARROW;Sm;0;ON;;;;;N;RIGHT DOUBLE ARROW;;;;
21D3;DOWNWARDS DOUBLE ARROW;So;0;ON;;;;;N;DOWN DOUBLE ARROW;;;;
21D4;LEFT RIGHT DOUBLE ARROW;Sm;0;ON;;;;;N;;;;;
21D5;UP DOWN DOUBLE ARROW;So;0;ON;;;;;N;;;;;
21D6;NORTH WEST DOUBLE ARROW;So;0;ON;;;;;N;UPPER LEFT DOUBLE ARROW;;;;
21D7;NORTH EAST DOUBLE ARROW;So;0;ON;;;;;N;UPPER RIGHT DOUBLE ARROW;;;;
21D8;SOUTH EAST DOUBLE ARROW;So;0;ON;;;;;N;LOWER RIGHT DOUBLE ARROW;;;;
21D9;SOUTH WEST DOUBLE ARROW;So;0;ON;;;;;N;LOWER LEFT DOUBLE ARROW;;;;
21DA;LEFTWARDS TRIPLE ARROW;So;0;ON;;;;;N;LEFT TRIPLE ARROW;;;;
21DB;RIGHTWARDS TRIPLE ARROW;So;0;ON;;;;;N;RIGHT TRIPLE ARROW;;;;
21DC;LEFTWARDS SQUIGGLE ARROW;So;0;ON;;;;;N;LEFT SQUIGGLE ARROW;;;;
21DD;RIGHTWARDS SQUIGGLE ARROW;So;0;ON;;;;;N;RIGHT SQUIGGLE ARROW;;;;
21DE;UPWARDS ARROW WITH DOUBLE STROKE;So;0;ON;;;;;N;UP ARROW WITH DOUBLE STROKE;;;;
21DF;DOWNWARDS ARROW WITH DOUBLE STROKE;So;0;ON;;;;;N;DOWN ARROW WITH DOUBLE STROKE;;;;
21E0;LEFTWARDS DASHED ARROW;So;0;ON;;;;;N;LEFT DASHED ARROW;;;;
21E1;UPWARDS DASHED ARROW;So;0;ON;;;;;N;UP DASHED ARROW;;;;
21E2;RIGHTWARDS DASHED ARROW;So;0;ON;;;;;N;RIGHT DASHED ARROW;;;;
21E3;DOWNWARDS DASHED ARROW;So;0;ON;;;;;N;DOWN DASHED ARROW;;;;
21E4;LEFTWARDS ARROW TO BAR;So;0;ON;;;;;N;LEFT ARROW TO BAR;;;;
21E5;RIGHTWARDS ARROW TO BAR;So;0;ON;;;;;N;RIGHT ARROW TO BAR;;;;
21E6;LEFTWARDS WHITE ARROW;So;0;ON;;;;;N;WHITE LEFT ARROW;;;;
21E7;UPWARDS WHITE ARROW;So;0;ON;;;;;N;WHITE UP ARROW;;;;
21E8;RIGHTWARDS WHITE ARROW;So;0;ON;;;;;N;WHITE RIGHT ARROW;;;;
21E9;DOWNWARDS WHITE ARROW;So;0;ON;;;;;N;WHITE DOWN ARROW;;;;
21EA;UPWARDS WHITE ARROW FROM BAR;So;0;ON;;;;;N;WHITE UP ARROW FROM BAR;;;;
21EB;UPWARDS WHITE ARROW ON PEDESTAL;So;0;ON;;;;;N;;;;;
21EC;UPWARDS WHITE ARROW ON PEDESTAL WITH HORIZONTAL BAR;So;0;ON;;;;;N;;;;;
21ED;UPWARDS WHITE ARROW ON PEDESTAL WITH VERTICAL BAR;So;0;ON;;;;;N;;;;;
21EE;UPWARDS WHITE DOUBLE ARROW;So;0;ON;;;;;N;;;;;
21EF;UPWARDS WHITE DOUBLE ARROW ON PEDESTAL;So;0;ON;;;;;N;;;;;
21F0;RIGHTWARDS WHITE ARROW FROM WALL;So;0;ON;;;;;N;;;;;
21F1;NORTH WEST ARROW TO CORNER;So;0;ON;;;;;N;;;;;
21F2;SOUTH EAST ARROW TO CORNER;So;0;ON;;;;;N;;;;;
21F3;UP DOWN WHITE ARROW;So;0;ON;;;;;N;;;;;
21F4;RIGHT ARROW WITH SMALL CIRCLE;Sm;0;ON;;;;;N;;;;;
21F5;DOWNWARDS ARROW LEFTWARDS OF UPWARDS ARROW;Sm;0;ON;;;;;N;;;;;
21F6;THREE RIGHTWARDS ARROWS;Sm;0;ON;;;;;N;;;;;
21F7;LEFTWARDS ARROW WITH VERTICAL STROKE;Sm;0;ON;;;;;N;;;;;
21F8;RIGHTWARDS ARROW WITH VERTICAL STROKE;Sm;0;ON;;;;;N;;;;;
21F9;LEFT RIGHT ARROW WITH VERTICAL STROKE;Sm;0;ON;;;;;N;;;;;
21FA;LEFTWARDS ARROW WITH DOUBLE VERTICAL STROKE;Sm;0;ON;;;;;N;;;;;
21FB;RIGHTWARDS ARROW WITH DOUBLE VERTICAL STROKE;Sm;0;ON;;;;;N;;;;;
21FC;LEFT RIGHT ARROW WITH DOUBLE VERTICAL STROKE;Sm;0;ON;;;;;N;;;;;
21FD;LEFTWARDS OPEN-HEADED ARROW;Sm;0;ON;;;;;N;;;;;
21FE;RIGHTWARDS OPEN-HEADED ARROW;Sm;0;ON;;;;;N;;;;;
21FF;LEFT RIGHT OPEN-HEADED ARROW;Sm;0;ON;;;;;N;;;;;
2200;FOR ALL;Sm;0;ON;;;;;N;;;;;
2201;COMPLEMENT;Sm;0;ON;;;;;Y;;;;;
2202;PARTIAL DIFFERENTIAL;Sm;0;ON;;;;;Y;;;;;
2203;THERE EXISTS;Sm;0;ON;;;;;Y;;;;;
2204;THERE DOES NOT EXIST;Sm;0;ON;2203 0338;;;;Y;;;;;
2205;EMPTY SET;Sm;0;ON;;;;;N;;;;;
2206;INCREMENT;Sm;0;ON;;;;;N;;;;;
2207;NABLA;Sm;0;ON;;;;;N;;;;;
2208;ELEMENT OF;Sm;0;ON;;;;;Y;;;;;
2209;NOT AN ELEMENT OF;Sm;0;ON;2208 0338;;;;Y;;;;;
220A;SMALL ELEMENT OF;Sm;0;ON;;;;;Y;;;;;
220B;CONTAINS AS MEMBER;Sm;0;ON;;;;;Y;;;;;
220C;DOES NOT CONTAIN AS MEMBER;Sm;0;ON;220B 0338;;;;Y;;;;;
220D;SMALL CONTAINS AS MEMBER;Sm;0;ON;;;;;Y;;;;;
220E;END OF PROOF;Sm;0;ON;;;;;N;;;;;
220F;N-ARY PRODUCT;Sm;0;ON;;;;;N;;;;;
2210;N-ARY COPRODUCT;Sm;0;ON;;;;;N;;;;;
2211;N-ARY SUMMATION;Sm;0;ON;;;;;Y;;;;;
2212;MINUS SIGN;Sm;0;ES;;;;;N;;;;;
2213;MINUS-OR-PLUS SIGN;Sm;0;ET;;;;;N;;;;;
2214;DOT PLUS;Sm;0;ON;;;;;N;;;;;
2215;DIVISION SLASH;Sm;0;ON;;;;;Y;;;;;
2216;SET MINUS;Sm;0;ON;;;;;Y;;;;;
2217;ASTERISK OPERATOR;Sm;0;ON;;;;;N;;;;;
2218;RING OPERATOR;Sm;0;ON;;;;;N;;;;;
2219;BULLET OPERATOR;Sm;0;ON;;;;;N;;;;;
221A;SQUARE ROOT;Sm;0;ON;;;;;Y;;;;;
221B;CUBE ROOT;Sm;0;ON;;;;;Y;;;;;
221C;FOURTH ROOT;Sm;0;ON;;;;;Y;;;;;
221D;PROPORTIONAL TO;Sm;0;ON;;;;;Y;;;;;
221E;INFINITY;Sm;0;ON;;;;;N;;;;;
221F;RIGHT ANGLE;Sm;0;ON;;;;;Y;;;;;
2220;ANGLE;Sm;0;ON;;;;;Y;;;;;
2221;MEASURED ANGLE;Sm;0;ON;;;;;Y;;;;;
2222;SPHERICAL ANGLE;Sm;0;ON;;;;;Y;;;;;
2223;DIVIDES;Sm;0;ON;;;;;N;;;;;
2224;DOES NOT DIVIDE;Sm;0;ON;2223 0338;;;;Y;;;;;
2225;PARALLEL TO;Sm;0;ON;;;;;N;;;;;
2226;NOT PARALLEL TO;Sm;0;ON;2225 0338;;;;Y;;;;;
2227;LOGICAL AND;Sm;0;ON;;;;;N;;;;;
2228;LOGICAL OR;Sm;0;ON;;;;;N;;;;;
2229;INTERSECTION;Sm;0;ON;;;;;N;;;;;
222A;UNION;Sm;0;ON;;;;;N;;;;;
222B;INTEGRAL;Sm;0;ON;;;;;Y;;;;;
222C;DOUBLE INTEGRAL;Sm;0;ON;<compat> 222B 222B;;;;Y;;;;;
222D;TRIPLE INTEGRAL;Sm;0;ON;<compat> 222B 222B 222B;;;;Y;;;;;
222E;CONTOUR INTEGRAL;Sm;0;ON;;;;;Y;;;;;
222F;SURFACE INTEGRAL;Sm;0;ON;<compat> 222E 222E;;;;Y;;;;;
2230;VOLUME INTEGRAL;Sm;0;ON;<compat> 222E 222E 222E;;;;Y;;;;;
2231;CLOCKWISE INTEGRAL;Sm;0;ON;;;;;Y;;;;;
2232;CLOCKWISE CONTOUR INTEGRAL;Sm;0;ON;;;;;Y;;;;;
2233;ANTICLOCKWISE CONTOUR INTEGRAL;Sm;0;ON;;;;;Y;;;;;
2234;THEREFORE;Sm;0;ON;;;;;N;;;;;
2235;BECAUSE;Sm;0;ON;;;;;N;;;;;
2236;RATIO;Sm;0;ON;;;;;N;;;;;
2237;PROPORTION;Sm;0;ON;;;;;N;;;;;
2238;DOT MINUS;Sm;0;ON;;;;;N;;;;;
2239;EXCESS;Sm;0;ON;;;;;Y;;;;;
223A;GEOMETRIC PROPORTION;Sm;0;ON;;;;;N;;;;;
223B;HOMOTHETIC;Sm;0;ON;;;;;Y;;;;;
223C;TILDE OPERATOR;Sm;0;ON;;;;;Y;;;;;
223D;REVERSED TILDE;Sm;0;ON;;;;;Y;;;;;
223E;INVERTED LAZY S;Sm;0;ON;;;;;Y;;;;;
223F;SINE WAVE;Sm;0;ON;;;;;Y;;;;;
2240;WREATH PRODUCT;Sm;0;ON;;;;;Y;;;;;
2241;NOT TILDE;Sm;0;ON;223C 0338;;;;Y;;;;;
2242;MINUS TILDE;Sm;0;ON;;;;;Y;;;;;
2243;ASYMPTOTICALLY EQUAL TO;Sm;0;ON;;;;;Y;;;;;
2244;NOT ASYMPTOTICALLY EQUAL TO;Sm;0;ON;2243 0338;;;;Y;;;;;
2245;APPROXIMATELY EQUAL TO;Sm;0;ON;;;;;Y;;;;;
2246;APPROXIMATELY BUT NOT ACTUALLY EQUAL TO;Sm;0;ON;;;;;Y;;;;;
2247;NEITHER APPROXIMATELY NOR ACTUALLY EQUAL TO;Sm;0;ON;2245 0338;;;;Y;;;;;
2248;ALMOST EQUAL TO;Sm;0;ON;;;;;Y;;;;;
2249;NOT ALMOST EQUAL TO;Sm;0;ON;2248 0338;;;;Y;;;;;
224A;ALMOST EQUAL OR EQUAL TO;Sm;0;ON;;;;;Y;;;;;
224B;TRIPLE TILDE;Sm;0;ON;;;;;Y;;;;;
224C;ALL EQUAL TO;Sm;0;ON;;;;;Y;;;;;
224D;EQUIVALENT TO;Sm;0;ON;;;;;N;;;;;
224E;GEOMETRICALLY EQUIVALENT TO;Sm;0;ON;;;;;N;;;;;
224F;DIFFERENCE BETWEEN;Sm;0;ON;;;;;N;;;;;
2250;APPROACHES THE LIMIT;Sm;0;ON;;;;;N;;;;;
2251;GEOMETRICALLY EQUAL TO;Sm;0;ON;;;;;N;;;;;
2252;APPROXIMATELY EQUAL TO OR THE IMAGE OF;Sm;0;ON;;;;;Y;;;;;
2253;IMAGE OF OR APPROXIMATELY EQUAL TO;Sm;0;ON;;;;;Y;;;;;
2254;COLON EQUALS;Sm;0;ON;;;;;Y;COLON EQUAL;;;;
2255;EQUALS COLON;Sm;0;ON;;;;;Y;EQUAL COLON;;;;
2256;RING IN EQUAL TO;Sm;0;ON;;;;;N;;;;;
2257;RING EQUAL TO;Sm;0;ON;;;;;N;;;;;
2258;CORRESPONDS TO;Sm;0;ON;;;;;N;;;;;
2259;ESTIMATES;Sm;0;ON;;;;;N;;;;;
225A;EQUIANGULAR TO;Sm;0;ON;;;;;N;;;;;
225B;STAR EQUALS;Sm;0;ON;;;;;N;;;;;
225C;DELTA EQUAL TO;Sm;0;ON;;;;;N;;;;;
225D;EQUAL TO BY DEFINITION;Sm;0;ON;;;;;N;;;;;
225E;MEASURED BY;Sm;0;ON;;;;;N;;;;;
225F;QUESTIONED EQUAL TO;Sm;0;ON;;;;;Y;;;;;
2260;NOT EQUAL TO;Sm;0;ON;003D 0338;;;;Y;;;;;
2261;IDENTICAL TO;Sm;0;ON;;;;;N;;;;;
2262;NOT IDENTICAL TO;Sm;0;ON;2261 0338;;;;Y;;;;;
2263;STRICTLY EQUIVALENT TO;Sm;0;ON;;;;;N;;;;;
2264;LESS-THAN OR EQUAL TO;Sm;0;ON;;;;;Y;LESS THAN OR EQUAL TO;;;;
2265;GREATER-THAN OR EQUAL TO;Sm;0;ON;;;;;Y;GREATER THAN OR EQUAL TO;;;;
2266;LESS-THAN OVER EQUAL TO;Sm;0;ON;;;;;Y;LESS THAN OVER EQUAL TO;;;;
2267;GREATER-THAN OVER EQUAL TO;Sm;0;ON;;;;;Y;GREATER THAN OVER EQUAL TO;;;;
2268;LESS-THAN BUT NOT EQUAL TO;Sm;0;ON;;;;;Y;LESS THAN BUT NOT EQUAL TO;;;;
2269;GREATER-THAN BUT NOT EQUAL TO;Sm;0;ON;;;;;Y;GREATER THAN BUT NOT EQUAL TO;;;;
226A;MUCH LESS-THAN;Sm;0;ON;;;;;Y;MUCH LESS THAN;;;;
226B;MUCH GREATER-THAN;Sm;0;ON;;;;;Y;MUCH GREATER THAN;;;;
226C;BETWEEN;Sm;0;ON;;;;;N;;;;;
226D;NOT EQUIVALENT TO;Sm;0;ON;224D 0338;;;;N;;;;;
226E;NOT LESS-THAN;Sm;0;ON;003C 0338;;;;Y;NOT LESS THAN;;;;
226F;NOT GREATER-THAN;Sm;0;ON;003E 0338;;;;Y;NOT GREATER THAN;;;;
2270;NEITHER LESS-THAN NOR EQUAL TO;Sm;0;ON;2264 0338;;;;Y;NEITHER LESS THAN NOR EQUAL TO;;;;
2271;NEITHER GREATER-THAN NOR EQUAL TO;Sm;0;ON;2265 0338;;;;Y;NEITHER GREATER THAN NOR EQUAL TO;;;;
2272;LESS-THAN OR EQUIVALENT TO;Sm;0;ON;;;;;Y;LESS THAN OR EQUIVALENT TO;;;;
2273;GREATER-THAN OR EQUIVALENT TO;Sm;0;ON;;;;;Y;GREATER THAN OR EQUIVALENT TO;;;;
2274;NEITHER LESS-THAN NOR EQUIVALENT TO;Sm;0;ON;2272 0338;;;;Y;NEITHER LESS THAN NOR EQUIVALENT TO;;;;
2275;NEITHER GREATER-THAN NOR EQUIVALENT TO;Sm;0;ON;2273 0338;;;;Y;NEITHER GREATER THAN NOR EQUIVALENT TO;;;;
2276;LESS-THAN OR GREATER-THAN;Sm;0;ON;;;;;Y;LESS THAN OR GREATER THAN;;;;
2277;GREATER-THAN OR LESS-THAN;Sm;0;ON;;;;;Y;GREATER THAN OR LESS THAN;;;;
2278;NEITHER LESS-THAN NOR GREATER-THAN;Sm;0;ON;2276 0338;;;;Y;NEITHER LESS THAN NOR GREATER THAN;;;;
2279;NEITHER GREATER-THAN NOR LESS-THAN;Sm;0;ON;2277 0338;;;;Y;NEITHER GREATER THAN NOR LESS THAN;;;;
227A;PRECEDES;Sm;0;ON;;;;;Y;;;;;
227B;SUCCEEDS;Sm;0;ON;;;;;Y;;;;;
227C;PRECEDES OR EQUAL TO;Sm;0;ON;;;;;Y;;;;;
227D;SUCCEEDS OR EQUAL TO;Sm;0;ON;;;;;Y;;;;;
227E;PRECEDES OR EQUIVALENT TO;Sm;0;ON;;;;;Y;;;;;
227F;SUCCEEDS OR EQUIVALENT TO;Sm;0;ON;;;;;Y;;;;;
2280;DOES NOT PRECEDE;Sm;0;ON;227A 0338;;;;Y;;;;;
2281;DOES NOT SUCCEED;Sm;0;ON;227B 0338;;;;Y;;;;;
2282;SUBSET OF;Sm;0;ON;;;;;Y;;;;;
2283;SUPERSET OF;Sm;0;ON;;;;;Y;;;;;
2284;NOT A SUBSET OF;Sm;0;ON;2282 0338;;;;Y;;;;;
2285;NOT A SUPERSET OF;Sm;0;ON;2283 0338;;;;Y;;;;;
2286;SUBSET OF OR EQUAL TO;Sm;0;ON;;;;;Y;;;;;
2287;SUPERSET OF OR EQUAL TO;Sm;0;ON;;;;;Y;;;;;
2288;NEITHER A SUBSET OF NOR EQUAL TO;Sm;0;ON;2286 0338;;;;Y;;;;;
2289;NEITHER A SUPERSET OF NOR EQUAL TO;Sm;0;ON;2287 0338;;;;Y;;;;;
228A;SUBSET OF WITH NOT EQUAL TO;Sm;0;ON;;;;;Y;SUBSET OF OR NOT EQUAL TO;;;;
228B;SUPERSET OF WITH NOT EQUAL TO;Sm;0;ON;;;;;Y;SUPERSET OF OR NOT EQUAL TO;;;;
228C;MULTISET;Sm;0;ON;;;;;Y;;;;;
228D;MULTISET MULTIPLICATION;Sm;0;ON;;;;;N;;;;;
228E;MULTISET UNION;Sm;0;ON;;;;;N;;;;;
228F;SQUARE IMAGE OF;Sm;0;ON;;;;;Y;;;;;
2290;SQUARE ORIGINAL OF;Sm;0;ON;;;;;Y;;;;;
2291;SQUARE IMAGE OF OR EQUAL TO;Sm;0;ON;;;;;Y;;;;;
2292;SQUARE ORIGINAL OF OR EQUAL TO;Sm;0;ON;;;;;Y;;;;;
2293;SQUARE CAP;Sm;0;ON;;;;;N;;;;;
2294;SQUARE CUP;Sm;0;ON;;;;;N;;;;;
2295;CIRCLED PLUS;Sm;0;ON;;;;;N;;;;;
2296;CIRCLED MINUS;Sm;0;ON;;;;;N;;;;;
2297;CIRCLED TIMES;Sm;0;ON;;;;;N;;;;;
2298;CIRCLED DIVISION SLASH;Sm;0;ON;;;;;Y;;;;;
2299;CIRCLED DOT OPERATOR;Sm;0;ON;;;;;N;;;;;
229A;CIRCLED RING OPERATOR;Sm;0;ON;;;;;N;;;;;
229B;CIRCLED ASTERISK OPERATOR;Sm;0;ON;;;;;N;;;;;
229C;CIRCLED EQUALS;Sm;0;ON;;;;;N;;;;;
229D;CIRCLED DASH;Sm;0;ON;;;;;N;;;;;
229E;SQUARED PLUS;Sm;0;ON;;;;;N;;;;;
229F;SQUARED MINUS;Sm;0;ON;;;;;N;;;;;
22A0;SQUARED TIMES;Sm;0;ON;;;;;N;;;;;
22A1;SQUARED DOT OPERATOR;Sm;0;ON;;;;;N;;;;;
22A2;RIGHT TACK;Sm;0;ON;;;;;Y;;;;;
22A3;LEFT TACK;Sm;0;ON;;;;;Y;;;;;
22A4;DOWN TACK;Sm;0;ON;;;;;N;;;;;
22A5;UP TACK;Sm;0;ON;;;;;N;;;;;
22A6;ASSERTION;Sm;0;ON;;;;;Y;;;;;
22A7;MODELS;Sm;0;ON;;;;;Y;;;;;
22A8;TRUE;Sm;0;ON;;;;;Y;;;;;
22A9;FORCES;Sm;0;ON;;;;;Y;;;;;
22AA;TRIPLE VERTICAL BAR RIGHT TURNSTILE;Sm;0;ON;;;;;Y;;;;;
22AB;DOUBLE VERTICAL BAR DOUBLE RIGHT TURNSTILE;Sm;0;ON;;;;;Y;;;;;
22AC;DOES NOT PROVE;Sm;0;ON;22A2 0338;;;;Y;;;;;
22AD;NOT TRUE;Sm;0;ON;22A8 0338;;;;Y;;;;;
22AE;DOES NOT FORCE;Sm;0;ON;22A9 0338;;;;Y;;;;;
22AF;NEGATED DOUBLE VERTICAL BAR DOUBLE RIGHT TURNSTILE;Sm;0;ON;22AB 0338;;;;Y;;;;;
22B0;PRECEDES UNDER RELATION;Sm;0;ON;;;;;Y;;;;;
22B1;SUCCEEDS UNDER RELATION;Sm;0;ON;;;;;Y;;;;;
22B2;NORMAL SUBGROUP OF;Sm;0;ON;;;;;Y;;;;;
22B3;CONTAINS AS NORMAL SUBGROUP;Sm;0;ON;;;;;Y;;;;;
22B4;NORMAL SUBGROUP OF OR EQUAL TO;Sm;0;ON;;;;;Y;;;;;
22B5;CONTAINS AS NORMAL SUBGROUP OR EQUAL TO;Sm;0;ON;;;;;Y;;;;;
22B6;ORIGINAL OF;Sm;0;ON;;;;;Y;;;;;
22B7;IMAGE OF;Sm;0;ON;;;;;Y;;;;;
22B8;MULTIMAP;Sm;0;ON;;;;;Y;;;;;
22B9;HERMITIAN CONJUGATE MATRIX;Sm;0;ON;;;;;N;;;;;
22BA;INTERCALATE;Sm;0;ON;;;;;N;;;;;
22BB;XOR;Sm;0;ON;;;;;N;;;;;
22BC;NAND;Sm;0;ON;;;;;N;;;;;
22BD;NOR;Sm;0;ON;;;;;N;;;;;
22BE;RIGHT ANGLE WITH ARC;Sm;0;ON;;;;;Y;;;;;
22BF;RIGHT TRIANGLE;Sm;0;ON;;;;;Y;;;;;
22C0;N-ARY LOGICAL AND;Sm;0;ON;;;;;N;;;;;
22C1;N-ARY LOGICAL OR;Sm;0;ON;;;;;N;;;;;
22C2;N-ARY INTERSECTION;Sm;0;ON;;;;;N;;;;;
22C3;N-ARY UNION;Sm;0;ON;;;;;N;;;;;
22C4;DIAMOND OPERATOR;Sm;0;ON;;;;;N;;;;;
22C5;DOT OPERATOR;Sm;0;ON;;;;;N;;;;;
22C6;STAR OPERATOR;Sm;0;ON;;;;;N;;;;;
22C7;DIVISION TIMES;Sm;0;ON;;;;;N;;;;;
22C8;BOWTIE;Sm;0;ON;;;;;N;;;;;
22C9;LEFT NORMAL FACTOR SEMIDIRECT PRODUCT;Sm;0;ON;;;;;Y;;;;;
22CA;RIGHT NORMAL FACTOR SEMIDIRECT PRODUCT;Sm;0;ON;;;;;Y;;;;;
22CB;LEFT SEMIDIRECT PRODUCT;Sm;0;ON;;;;;Y;;;;;
22CC;RIGHT SEMIDIRECT PRODUCT;Sm;0;ON;;;;;Y;;;;;
22CD;REVERSED TILDE EQUALS;Sm;0;ON;;;;;Y;;;;;
22CE;CURLY LOGICAL OR;Sm;0;ON;;;;;N;;;;;
22CF;CURLY LOGICAL AND;Sm;0;ON;;;;;N;;;;;
22D0;DOUBLE SUBSET;Sm;0;ON;;;;;Y;;;;;
22D1;DOUBLE SUPERSET;Sm;0;ON;;;;;Y;;;;;
22D2;DOUBLE INTERSECTION;Sm;0;ON;;;;;N;;;;;
22D3;DOUBLE UNION;Sm;0;ON;;;;;N;;;;;
22D4;PITCHFORK;Sm;0;ON;;;;;N;;;;;
22D5;EQUAL AND PARALLEL TO;Sm;0;ON;;;;;N;;;;;
22D6;LESS-THAN WITH DOT;Sm;0;ON;;;;;Y;LESS THAN WITH DOT;;;;
22D7;GREATER-THAN WITH DOT;Sm;0;ON;;;;;Y;GREATER THAN WITH DOT;;;;
22D8;VERY MUCH LESS-THAN;Sm;0;ON;;;;;Y;VERY MUCH LESS THAN;;;;
22D9;VERY MUCH GREATER-THAN;Sm;0;ON;;;;;Y;VERY MUCH GREATER THAN;;;;
22DA;LESS-THAN EQUAL TO OR GREATER-THAN;Sm;0;ON;;;;;Y;LESS THAN EQUAL TO OR GREATER THAN;;;;
22DB;GREATER-THAN EQUAL TO OR LESS-THAN;Sm;0;ON;;;;;Y;GREATER THAN EQUAL TO OR LESS THAN;;;;
22DC;EQUAL TO OR LESS-THAN;Sm;0;ON;;;;;Y;EQUAL TO OR LESS THAN;;;;
22DD;EQUAL TO OR GREATER-THAN;Sm;0;ON;;;;;Y;EQUAL TO OR GREATER THAN;;;;
22DE;EQUAL TO OR PRECEDES;Sm;0;ON;;;;;Y;;;;;
22DF;EQUAL TO OR SUCCEEDS;Sm;0;ON;;;;;Y;;;;;
22E0;DOES NOT PRECEDE OR EQUAL;Sm;0;ON;227C 0338;;;;Y;;;;;
22E1;DOES NOT SUCCEED OR EQUAL;Sm;0;ON;227D 0338;;;;Y;;;;;
22E2;NOT SQUARE IMAGE OF OR EQUAL TO;Sm;0;ON;2291 0338;;;;Y;;;;;
22E3;NOT SQUARE ORIGINAL OF OR EQUAL TO;Sm;0;ON;2292 0338;;;;Y;;;;;
22E4;SQUARE IMAGE OF OR NOT EQUAL TO;Sm;0;ON;;;;;Y;;;;;
22E5;SQUARE ORIGINAL OF OR NOT EQUAL TO;Sm;0;ON;;;;;Y;;;;;
22E6;LESS-THAN BUT NOT EQUIVALENT TO;Sm;0;ON;;;;;Y;LESS THAN BUT NOT EQUIVALENT TO;;;;
22E7;GREATER-THAN BUT NOT EQUIVALENT TO;Sm;0;ON;;;;;Y;GREATER THAN BUT NOT EQUIVALENT TO;;;;
22E8;PRECEDES BUT NOT EQUIVALENT TO;Sm;0;ON;;;;;Y;;;;;
22E9;SUCCEEDS BUT NOT EQUIVALENT TO;Sm;0;ON;;;;;Y;;;;;
22EA;NOT NORMAL SUBGROUP OF;Sm;0;ON;22B2 0338;;;;Y;;;;;
22EB;DOES NOT CONTAIN AS NORMAL SUBGROUP;Sm;0;ON;22B3 0338;;;;Y;;;;;
22EC;NOT NORMAL SUBGROUP OF OR EQUAL TO;Sm;0;ON;22B4 0338;;;;Y;;;;;
22ED;DOES NOT CONTAIN AS NORMAL SUBGROUP OR EQUAL;Sm;0;ON;22B5 0338;;;;Y;;;;;
22EE;VERTICAL ELLIPSIS;Sm;0;ON;;;;;N;;;;;
22EF;MIDLINE HORIZONTAL ELLIPSIS;Sm;0;ON;;;;;N;;;;;
22F0;UP RIGHT DIAGONAL ELLIPSIS;Sm;0;ON;;;;;Y;;;;;
22F1;DOWN RIGHT DIAGONAL ELLIPSIS;Sm;0;ON;;;;;Y;;;;;
22F2;ELEMENT OF WITH LONG HORIZONTAL STROKE;Sm;0;ON;;;;;Y;;;;;
22F3;ELEMENT OF WITH VERTICAL BAR AT END OF HORIZONTAL STROKE;Sm;0;ON;;;;;Y;;;;;
22F4;SMALL ELEMENT OF WITH VERTICAL BAR AT END OF HORIZONTAL STROKE;Sm;0;ON;;;;;Y;;;;;
22F5;ELEMENT OF WITH DOT ABOVE;Sm;0;ON;;;;;Y;;;;;
22F6;ELEMENT OF WITH OVERBAR;Sm;0;ON;;;;;Y;;;;;
22F7;SMALL ELEMENT OF WITH OVERBAR;Sm;0;ON;;;;;Y;;;;;
22F8;ELEMENT OF WITH UNDERBAR;Sm;0;ON;;;;;Y;;;;;
22F9;ELEMENT OF WITH TWO HORIZONTAL STROKES;Sm;0;ON;;;;;Y;;;;;
22FA;CONTAINS WITH LONG HORIZONTAL STROKE;Sm;0;ON;;;;;Y;;;;;
22FB;CONTAINS WITH VERTICAL BAR AT END OF HORIZONTAL STROKE;Sm;0;ON;;;;;Y;;;;;
22FC;SMALL CONTAINS WITH VERTICAL BAR AT END OF HORIZONTAL STROKE;Sm;0;ON;;;;;Y;;;;;
22FD;CONTAINS WITH OVERBAR;Sm;0;ON;;;;;Y;;;;;
22FE;SMALL CONTAINS WITH OVERBAR;Sm;0;ON;;;;;Y;;;;;
22FF;Z NOTATION BAG MEMBERSHIP;Sm;0;ON;;;;;Y;;;;;
2300;DIAMETER SIGN;So;0;ON;;;;;N;;;;;
2301;ELECTRIC ARROW;So;0;ON;;;;;N;;;;;
2302;HOUSE;So;0;ON;;;;;N;;;;;
2303;UP ARROWHEAD;So;0;ON;;;;;N;;;;;
2304;DOWN ARROWHEAD;So;0;ON;;;;;N;;;;;
2305;PROJECTIVE;So;0;ON;;;;;N;;;;;
2306;PERSPECTIVE;So;0;ON;;;;;N;;;;;
2307;WAVY LINE;So;0;ON;;;;;N;;;;;
2308;LEFT CEILING;Ps;0;ON;;;;;Y;;;;;
2309;RIGHT CEILING;Pe;0;ON;;;;;Y;;;;;
230A;LEFT FLOOR;Ps;0;ON;;;;;Y;;;;;
230B;RIGHT FLOOR;Pe;0;ON;;;;;Y;;;;;
230C;BOTTOM RIGHT CROP;So;0;ON;;;;;N;;;;;
230D;BOTTOM LEFT CROP;So;0;ON;;;;;N;;;;;
230E;TOP RIGHT CROP;So;0;ON;;;;;N;;;;;
230F;TOP LEFT CROP;So;0;ON;;;;;N;;;;;
2310;REVERSED NOT SIGN;So;0;ON;;;;;N;;;;;
2311;SQUARE LOZENGE;So;0;ON;;;;;N;;;;;
2312;ARC;So;0;ON;;;;;N;;;;;
2313;SEGMENT;So;0;ON;;;;;N;;;;;
2314;SECTOR;So;0;ON;;;;;N;;;;;
2315;TELEPHONE RECORDER;So;0;ON;;;;;N;;;;;
2316;POSITION INDICATOR;So;0;ON;;;;;N;;;;;
2317;VIEWDATA SQUARE;So;0;ON;;;;;N;;;;;
2318;PLACE OF INTEREST SIGN;So;0;ON;;;;;N;COMMAND KEY;;;;
2319;TURNED NOT SIGN;So;0;ON;;;;;N;;;;;
231A;WATCH;So;0;ON;;;;;N;;;;;
231B;HOURGLASS;So;0;ON;;;;;N;;;;;
231C;TOP LEFT CORNER;So;0;ON;;;;;N;;;;;
231D;TOP RIGHT CORNER;So;0;ON;;;;;N;;;;;
231E;BOTTOM LEFT CORNER;So;0;ON;;;;;N;;;;;
231F;BOTTOM RIGHT CORNER;So;0;ON;;;;;N;;;;;
2320;TOP HALF INTEGRAL;Sm;0;ON;;;;;Y;;;;;
2321;BOTTOM HALF INTEGRAL;Sm;0;ON;;;;;Y;;;;;
2322;FROWN;So;0;ON;;;;;N;;;;;
2323;SMILE;So;0;ON;;;;;N;;;;;
2324;UP ARROWHEAD BETWEEN TWO HORIZONTAL BARS;So;0;ON;;;;;N;ENTER KEY;;;;
2325;OPTION KEY;So;0;ON;;;;;N;;;;;
2326;ERASE TO THE RIGHT;So;0;ON;;;;;N;DELETE TO THE RIGHT KEY;;;;
2327;X IN A RECTANGLE BOX;So;0;ON;;;;;N;CLEAR KEY;;;;
2328;KEYBOARD;So;0;ON;;;;;N;;;;;
2329;LEFT-POINTING ANGLE BRACKET;Ps;0;ON;3008;;;;Y;BRA;;;;
232A;RIGHT-POINTING ANGLE BRACKET;Pe;0;ON;3009;;;;Y;KET;;;;
232B;ERASE TO THE LEFT;So;0;ON;;;;;N;DELETE TO THE LEFT KEY;;;;
232C;BENZENE RING;So;0;ON;;;;;N;;;;;
232D;CYLINDRICITY;So;0;ON;;;;;N;;;;;
232E;ALL AROUND-PROFILE;So;0;ON;;;;;N;;;;;
232F;SYMMETRY;So;0;ON;;;;;N;;;;;
2330;TOTAL RUNOUT;So;0;ON;;;;;N;;;;;
2331;DIMENSION ORIGIN;So;0;ON;;;;;N;;;;;
2332;CONICAL TAPER;So;0;ON;;;;;N;;;;;
2333;SLOPE;So;0;ON;;;;;N;;;;;
2334;COUNTERBORE;So;0;ON;;;;;N;;;;;
2335;COUNTERSINK;So;0;ON;;;;;N;;;;;
2336;APL FUNCTIONAL SYMBOL I-BEAM;So;0;L;;;;;N;;;;;
2337;APL FUNCTIONAL SYMBOL SQUISH QUAD;So;0;L;;;;;N;;;;;
2338;APL FUNCTIONAL SYMBOL QUAD EQUAL;So;0;L;;;;;N;;;;;
2339;APL FUNCTIONAL SYMBOL QUAD DIVIDE;So;0;L;;;;;N;;;;;
233A;APL FUNCTIONAL SYMBOL QUAD DIAMOND;So;0;L;;;;;N;;;;;
233B;APL FUNCTIONAL SYMBOL QUAD JOT;So;0;L;;;;;N;;;;;
233C;APL FUNCTIONAL SYMBOL QUAD CIRCLE;So;0;L;;;;;N;;;;;
233D;APL FUNCTIONAL SYMBOL CIRCLE STILE;So;0;L;;;;;N;;;;;
233E;APL FUNCTIONAL SYMBOL CIRCLE JOT;So;0;L;;;;;N;;;;;
233F;APL FUNCTIONAL SYMBOL SLASH BAR;So;0;L;;;;;N;;;;;
2340;APL FUNCTIONAL SYMBOL BACKSLASH BAR;So;0;L;;;;;N;;;;;
2341;APL FUNCTIONAL SYMBOL QUAD SLASH;So;0;L;;;;;N;;;;;
2342;APL FUNCTIONAL SYMBOL QUAD BACKSLASH;So;0;L;;;;;N;;;;;
2343;APL FUNCTIONAL SYMBOL QUAD LESS-THAN;So;0;L;;;;;N;;;;;
2344;APL FUNCTIONAL SYMBOL QUAD GREATER-THAN;So;0;L;;;;;N;;;;;
2345;APL FUNCTIONAL SYMBOL LEFTWARDS VANE;So;0;L;;;;;N;;;;;
2346;APL FUNCTIONAL SYMBOL RIGHTWARDS VANE;So;0;L;;;;;N;;;;;
2347;APL FUNCTIONAL SYMBOL QUAD LEFTWARDS ARROW;So;0;L;;;;;N;;;;;
2348;APL FUNCTIONAL SYMBOL QUAD RIGHTWARDS ARROW;So;0;L;;;;;N;;;;;
2349;APL FUNCTIONAL SYMBOL CIRCLE BACKSLASH;So;0;L;;;;;N;;;;;
234A;APL FUNCTIONAL SYMBOL DOWN TACK UNDERBAR;So;0;L;;;;;N;;;;;
234B;APL FUNCTIONAL SYMBOL DELTA STILE;So;0;L;;;;;N;;;;;
234C;APL FUNCTIONAL SYMBOL QUAD DOWN CARET;So;0;L;;;;;N;;;;;
234D;APL FUNCTIONAL SYMBOL QUAD DELTA;So;0;L;;;;;N;;;;;
234E;APL FUNCTIONAL SYMBOL DOWN TACK JOT;So;0;L;;;;;N;;;;;
234F;APL FUNCTIONAL SYMBOL UPWARDS VANE;So;0;L;;;;;N;;;;;
2350;APL FUNCTIONAL SYMBOL QUAD UPWARDS ARROW;So;0;L;;;;;N;;;;;
2351;APL FUNCTIONAL SYMBOL UP TACK OVERBAR;So;0;L;;;;;N;;;;;
2352;APL FUNCTIONAL SYMBOL DEL STILE;So;0;L;;;;;N;;;;;
2353;APL FUNCTIONAL SYMBOL QUAD UP CARET;So;0;L;;;;;N;;;;;
2354;APL FUNCTIONAL SYMBOL QUAD DEL;So;0;L;;;;;N;;;;;
2355;APL FUNCTIONAL SYMBOL UP TACK JOT;So;0;L;;;;;N;;;;;
2356;APL FUNCTIONAL SYMBOL DOWNWARDS VANE;So;0;L;;;;;N;;;;;
2357;APL FUNCTIONAL SYMBOL QUAD DOWNWARDS ARROW;So;0;L;;;;;N;;;;;
2358;APL FUNCTIONAL SYMBOL QUOTE UNDERBAR;So;0;L;;;;;N;;;;;
2359;APL FUNCTIONAL SYMBOL DELTA UNDERBAR;So;0;L;;;;;N;;;;;
235A;APL FUNCTIONAL SYMBOL DIAMOND UNDERBAR;So;0;L;;;;;N;;;;;
235B;APL FUNCTIONAL SYMBOL JOT UNDERBAR;So;0;L;;;;;N;;;;;
235C;APL FUNCTIONAL SYMBOL CIRCLE UNDERBAR;So;0;L;;;;;N;;;;;
235D;APL FUNCTIONAL SYMBOL UP SHOE JOT;So;0;L;;;;;N;;;;;
235E;APL FUNCTIONAL SYMBOL QUOTE QUAD;So;0;L;;;;;N;;;;;
235F;APL FUNCTIONAL SYMBOL CIRCLE STAR;So;0;L;;;;;N;;;;;
2360;APL FUNCTIONAL SYMBOL QUAD COLON;So;0;L;;;;;N;;;;;
2361;APL FUNCTIONAL SYMBOL UP TACK DIAERESIS;So;0;L;;;;;N;;;;;
2362;APL FUNCTIONAL SYMBOL DEL DIAERESIS;So;0;L;;;;;N;;;;;
2363;APL FUNCTIONAL SYMBOL STAR DIAERESIS;So;0;L;;;;;N;;;;;
2364;APL FUNCTIONAL SYMBOL JOT DIAERESIS;So;0;L;;;;;N;;;;;
2365;APL FUNCTIONAL SYMBOL CIRCLE DIAERESIS;So;0;L;;;;;N;;;;;
2366;APL FUNCTIONAL SYMBOL DOWN SHOE STILE;So;0;L;;;;;N;;;;;
2367;APL FUNCTIONAL SYMBOL LEFT SHOE STILE;So;0;L;;;;;N;;;;;
2368;APL FUNCTIONAL SYMBOL TILDE DIAERESIS;So;0;L;;;;;N;;;;;
2369;APL FUNCTIONAL SYMBOL GREATER-THAN DIAERESIS;So;0;L;;;;;N;;;;;
236A;APL FUNCTIONAL SYMBOL COMMA BAR;So;0;L;;;;;N;;;;;
236B;APL FUNCTIONAL SYMBOL DEL TILDE;So;0;L;;;;;N;;;;;
236C;APL FUNCTIONAL SYMBOL ZILDE;So;0;L;;;;;N;;;;;
236D;APL FUNCTIONAL SYMBOL STILE TILDE;So;0;L;;;;;N;;;;;
236E;APL FUNCTIONAL SYMBOL SEMICOLON UNDERBAR;So;0;L;;;;;N;;;;;
236F;APL FUNCTIONAL SYMBOL QUAD NOT EQUAL;So;0;L;;;;;N;;;;;
2370;APL FUNCTIONAL SYMBOL QUAD QUESTION;So;0;L;;;;;N;;;;;
2371;APL FUNCTIONAL SYMBOL DOWN CARET TILDE;So;0;L;;;;;N;;;;;
2372;APL FUNCTIONAL SYMBOL UP CARET TILDE;So;0;L;;;;;N;;;;;
2373;APL FUNCTIONAL SYMBOL IOTA;So;0;L;;;;;N;;;;;
2374;APL FUNCTIONAL SYMBOL RHO;So;0;L;;;;;N;;;;;
2375;APL FUNCTIONAL SYMBOL OMEGA;So;0;L;;;;;N;;;;;
2376;APL FUNCTIONAL SYMBOL ALPHA UNDERBAR;So;0;L;;;;;N;;;;;
2377;APL FUNCTIONAL SYMBOL EPSILON UNDERBAR;So;0;L;;;;;N;;;;;
2378;APL FUNCTIONAL SYMBOL IOTA UNDERBAR;So;0;L;;;;;N;;;;;
2379;APL FUNCTIONAL SYMBOL OMEGA UNDERBAR;So;0;L;;;;;N;;;;;
237A;APL FUNCTIONAL SYMBOL ALPHA;So;0;L;;;;;N;;;;;
237B;NOT CHECK MARK;So;0;ON;;;;;N;;;;;
237C;RIGHT ANGLE WITH DOWNWARDS ZIGZAG ARROW;Sm;0;ON;;;;;N;;;;;
237D;SHOULDERED OPEN BOX;So;0;ON;;;;;N;;;;;
237E;BELL SYMBOL;So;0;ON;;;;;N;;;;;
237F;VERTICAL LINE WITH MIDDLE DOT;So;0;ON;;;;;N;;;;;
2380;INSERTION SYMBOL;So;0;ON;;;;;N;;;;;
2381;CONTINUOUS UNDERLINE SYMBOL;So;0;ON;;;;;N;;;;;
2382;DISCONTINUOUS UNDERLINE SYMBOL;So;0;ON;;;;;N;;;;;
2383;EMPHASIS SYMBOL;So;0;ON;;;;;N;;;;;
2384;COMPOSITION SYMBOL;So;0;ON;;;;;N;;;;;
2385;WHITE SQUARE WITH CENTRE VERTICAL LINE;So;0;ON;;;;;N;;;;;
2386;ENTER SYMBOL;So;0;ON;;;;;N;;;;;
2387;ALTERNATIVE KEY SYMBOL;So;0;ON;;;;;N;;;;;
2388;HELM SYMBOL;So;0;ON;;;;;N;;;;;
2389;CIRCLED HORIZONTAL BAR WITH NOTCH;So;0;ON;;;;;N;;;;;
238A;CIRCLED TRIANGLE DOWN;So;0;ON;;;;;N;;;;;
238B;BROKEN CIRCLE WITH NORTHWEST ARROW;So;0;ON;;;;;N;;;;;
238C;UNDO SYMBOL;So;0;ON;;;;;N;;;;;
238D;MONOSTABLE SYMBOL;So;0;ON;;;;;N;;;;;
238E;HYSTERESIS SYMBOL;So;0;ON;;;;;N;;;;;
238F;OPEN-CIRCUIT-OUTPUT H-TYPE SYMBOL;So;0;ON;;;;;N;;;;;
2390;OPEN-CIRCUIT-OUTPUT L-TYPE SYMBOL;So;0;ON;;;;;N;;;;;
2391;PASSIVE-PULL-DOWN-OUTPUT SYMBOL;So;0;ON;;;;;N;;;;;
2392;PASSIVE-PULL-UP-OUTPUT SYMBOL;So;0;ON;;;;;N;;;;;
2393;DIRECT CURRENT SYMBOL FORM TWO;So;0;ON;;;;;N;;;;;
2394;SOFTWARE-FUNCTION SYMBOL;So;0;ON;;;;;N;;;;;
2395;APL FUNCTIONAL SYMBOL QUAD;So;0;L;;;;;N;;;;;
2396;DECIMAL SEPARATOR KEY SYMBOL;So;0;ON;;;;;N;;;;;
2397;PREVIOUS PAGE;So;0;ON;;;;;N;;;;;
2398;NEXT PAGE;So;0;ON;;;;;N;;;;;
2399;PRINT SCREEN SYMBOL;So;0;ON;;;;;N;;;;;
239A;CLEAR SCREEN SYMBOL;So;0;ON;;;;;N;;;;;
239B;LEFT PARENTHESIS UPPER HOOK;Sm;0;ON;;;;;N;;;;;
239C;LEFT PARENTHESIS EXTENSION;Sm;0;ON;;;;;N;;;;;
239D;LEFT PARENTHESIS LOWER HOOK;Sm;0;ON;;;;;N;;;;;
239E;RIGHT PARENTHESIS UPPER HOOK;Sm;0;ON;;;;;N;;;;;
239F;RIGHT PARENTHESIS EXTENSION;Sm;0;ON;;;;;N;;;;;
23A0;RIGHT PARENTHESIS LOWER HOOK;Sm;0;ON;;;;;N;;;;;
23A1;LEFT SQUARE BRACKET UPPER CORNER;Sm;0;ON;;;;;N;;;;;
23A2;LEFT SQUARE BRACKET EXTENSION;Sm;0;ON;;;;;N;;;;;
23A3;LEFT SQUARE BRACKET LOWER CORNER;Sm;0;ON;;;;;N;;;;;
23A4;RIGHT SQUARE BRACKET UPPER CORNER;Sm;0;ON;;;;;N;;;;;
23A5;RIGHT SQUARE BRACKET EXTENSION;Sm;0;ON;;;;;N;;;;;
23A6;RIGHT SQUARE BRACKET LOWER CORNER;Sm;0;ON;;;;;N;;;;;
23A7;LEFT CURLY BRACKET UPPER HOOK;Sm;0;ON;;;;;N;;;;;
23A8;LEFT CURLY BRACKET MIDDLE PIECE;Sm;0;ON;;;;;N;;;;;
23A9;LEFT CURLY BRACKET LOWER HOOK;Sm;0;ON;;;;;N;;;;;
23AA;CURLY BRACKET EXTENSION;Sm;0;ON;;;;;N;;;;;
23AB;RIGHT CURLY BRACKET UPPER HOOK;Sm;0;ON;;;;;N;;;;;
23AC;RIGHT CURLY BRACKET MIDDLE PIECE;Sm;0;ON;;;;;N;;;;;
23AD;RIGHT CURLY BRACKET LOWER HOOK;Sm;0;ON;;;;;N;;;;;
23AE;INTEGRAL EXTENSION;Sm;0;ON;;;;;N;;;;;
23AF;HORIZONTAL LINE EXTENSION;Sm;0;ON;;;;;N;;;;;
23B0;UPPER LEFT OR LOWER RIGHT CURLY BRACKET SECTION;Sm;0;ON;;;;;N;;;;;
23B1;UPPER RIGHT OR LOWER LEFT CURLY BRACKET SECTION;Sm;0;ON;;;;;N;;;;;
23B2;SUMMATION TOP;Sm;0;ON;;;;;N;;;;;
23B3;SUMMATION BOTTOM;Sm;0;ON;;;;;N;;;;;
23B4;TOP SQUARE BRACKET;So;0;ON;;;;;N;;;;;
23B5;BOTTOM SQUARE BRACKET;So;0;ON;;;;;N;;;;;
23B6;BOTTOM SQUARE BRACKET OVER TOP SQUARE BRACKET;So;0;ON;;;;;N;;;;;
23B7;RADICAL SYMBOL BOTTOM;So;0;ON;;;;;N;;;;;
23B8;LEFT VERTICAL BOX LINE;So;0;ON;;;;;N;;;;;
23B9;RIGHT VERTICAL BOX LINE;So;0;ON;;;;;N;;;;;
23BA;HORIZONTAL SCAN LINE-1;So;0;ON;;;;;N;;;;;
23BB;HORIZONTAL SCAN LINE-3;So;0;ON;;;;;N;;;;;
23BC;HORIZONTAL SCAN LINE-7;So;0;ON;;;;;N;;;;;
23BD;HORIZONTAL SCAN LINE-9;So;0;ON;;;;;N;;;;;
23BE;DENTISTRY SYMBOL LIGHT VERTICAL AND TOP RIGHT;So;0;ON;;;;;N;;;;;
23BF;DENTISTRY SYMBOL LIGHT VERTICAL AND BOTTOM RIGHT;So;0;ON;;;;;N;;;;;
23C0;DENTISTRY SYMBOL LIGHT VERTICAL WITH CIRCLE;So;0;ON;;;;;N;;;;;
23C1;DENTISTRY SYMBOL LIGHT DOWN AND HORIZONTAL WITH CIRCLE;So;0;ON;;;;;N;;;;;
23C2;DENTISTRY SYMBOL LIGHT UP AND HORIZONTAL WITH CIRCLE;So;0;ON;;;;;N;;;;;
23C3;DENTISTRY SYMBOL LIGHT VERTICAL WITH TRIANGLE;So;0;ON;;;;;N;;;;;
23C4;DENTISTRY SYMBOL LIGHT DOWN AND HORIZONTAL WITH TRIANGLE;So;0;ON;;;;;N;;;;;
23C5;DENTISTRY SYMBOL LIGHT UP AND HORIZONTAL WITH TRIANGLE;So;0;ON;;;;;N;;;;;
23C6;DENTISTRY SYMBOL LIGHT VERTICAL AND WAVE;So;0;ON;;;;;N;;;;;
23C7;DENTISTRY SYMBOL LIGHT DOWN AND HORIZONTAL WITH WAVE;So;0;ON;;;;;N;;;;;
23C8;DENTISTRY SYMBOL LIGHT UP AND HORIZONTAL WITH WAVE;So;0;ON;;;;;N;;;;;
23C9;DENTISTRY SYMBOL LIGHT DOWN AND HORIZONTAL;So;0;ON;;;;;N;;;;;
23CA;DENTISTRY SYMBOL LIGHT UP AND HORIZONTAL;So;0;ON;;;;;N;;;;;
23CB;DENTISTRY SYMBOL LIGHT VERTICAL AND TOP LEFT;So;0;ON;;;;;N;;;;;
23CC;DENTISTRY SYMBOL LIGHT VERTICAL AND BOTTOM LEFT;So;0;ON;;;;;N;;;;;
23CD;SQUARE FOOT;So;0;ON;;;;;N;;;;;
23CE;RETURN SYMBOL;So;0;ON;;;;;N;;;;;
23CF;EJECT SYMBOL;So;0;ON;;;;;N;;;;;
23D0;VERTICAL LINE EXTENSION;So;0;ON;;;;;N;;;;;
23D1;METRICAL BREVE;So;0;ON;;;;;N;;;;;
23D2;METRICAL LONG OVER SHORT;So;0;ON;;;;;N;;;;;
23D3;METRICAL SHORT OVER LONG;So;0;ON;;;;;N;;;;;
23D4;METRICAL LONG OVER TWO SHORTS;So;0;ON;;;;;N;;;;;
23D5;METRICAL TWO SHORTS OVER LONG;So;0;ON;;;;;N;;;;;
23D6;METRICAL TWO SHORTS JOINED;So;0;ON;;;;;N;;;;;
23D7;METRICAL TRISEME;So;0;ON;;;;;N;;;;;
23D8;METRICAL TETRASEME;So;0;ON;;;;;N;;;;;
23D9;METRICAL PENTASEME;So;0;ON;;;;;N;;;;;
23DA;EARTH GROUND;So;0;ON;;;;;N;;;;;
23DB;FUSE;So;0;ON;;;;;N;;;;;
23DC;TOP PARENTHESIS;Sm;0;ON;;;;;N;;;;;
23DD;BOTTOM PARENTHESIS;Sm;0;ON;;;;;N;;;;;
23DE;TOP CURLY BRACKET;Sm;0;ON;;;;;N;;;;;
23DF;BOTTOM CURLY BRACKET;Sm;0;ON;;;;;N;;;;;
23E0;TOP TORTOISE SHELL BRACKET;Sm;0;ON;;;;;N;;;;;
23E1;BOTTOM TORTOISE SHELL BRACKET;Sm;0;ON;;;;;N;;;;;
23E2;WHITE TRAPEZIUM;So;0;ON;;;;;N;;;;;
23E3;BENZENE RING WITH CIRCLE;So;0;ON;;;;;N;;;;;
23E4;STRAIGHTNESS;So;0;ON;;;;;N;;;;;
23E5;FLATNESS;So;0;ON;;;;;N;;;;;
23E6;AC CURRENT;So;0;ON;;;;;N;;;;;
23E7;ELECTRICAL INTERSECTION;So;0;ON;;;;;N;;;;;
23E8;DECIMAL EXPONENT SYMBOL;So;0;ON;;;;;N;;;;;
23E9;BLACK RIGHT-POINTING DOUBLE TRIANGLE;So;0;ON;;;;;N;;;;;
23EA;BLACK LEFT-POINTING DOUBLE TRIANGLE;So;0;ON;;;;;N;;;;;
23EB;BLACK UP-POINTING DOUBLE TRIANGLE;So;0;ON;;;;;N;;;;;
23EC;BLACK DOWN-POINTING DOUBLE TRIANGLE;So;0;ON;;;;;N;;;;;
23ED;BLACK RIGHT-POINTING DOUBLE TRIANGLE WITH VERTICAL BAR;So;0;ON;;;;;N;;;;;
23EE;BLACK LEFT-POINTING DOUBLE TRIANGLE WITH VERTICAL BAR;So;0;ON;;;;;N;;;;;
23EF;BLACK RIGHT-POINTING TRIANGLE WITH DOUBLE VERTICAL BAR;So;0;ON;;;;;N;;;;;
23F0;ALARM CLOCK;So;0;ON;;;;;N;;;;;
23F1;STOPWATCH;So;0;ON;;;;;N;;;;;
23F2;TIMER CLOCK;So;0;ON;;;;;N;;;;;
23F3;HOURGLASS WITH FLOWING SAND;So;0;ON;;;;;N;;;;;
23F4;BLACK MEDIUM LEFT-POINTING TRIANGLE;So;0;ON;;;;;N;;;;;
23F5;BLACK MEDIUM RIGHT-POINTING TRIANGLE;So;0;ON;;;;;N;;;;;
23F6;BLACK MEDIUM UP-POINTING TRIANGLE;So;0;ON;;;;;N;;;;;
23F7;BLACK MEDIUM DOWN-POINTING TRIANGLE;So;0;ON;;;;;N;;;;;
23F8;DOUBLE VERTICAL BAR;So;0;ON;;;;;N;;;;;
23F9;BLACK SQUARE FOR STOP;So;0;ON;;;;;N;;;;;
23FA;BLACK CIRCLE FOR RECORD;So;0;ON;;;;;N;;;;;
23FB;POWER SYMBOL;So;0;ON;;;;;N;;;;;
23FC;POWER ON-OFF SYMBOL;So;0;ON;;;;;N;;;;;
23FD;POWER ON SYMBOL;So;0;ON;;;;;N;;;;;
23FE;POWER SLEEP SYMBOL;So;0;ON;;;;;N;;;;;
23FF;OBSERVER EYE SYMBOL;So;0;ON;;;;;N;;;;;
2400;SYMBOL FOR NULL;So;0;ON;;;;;N;GRAPHIC FOR NULL;;;;
2401;SYMBOL FOR START OF HEADING;So;0;ON;;;;;N;GRAPHIC FOR START OF HEADING;;;;
2402;SYMBOL FOR START OF TEXT;So;0;ON;;;;;N;GRAPHIC FOR START OF TEXT;;;;
2403;SYMBOL FOR END OF TEXT;So;0;ON;;;;;N;GRAPHIC FOR END OF TEXT;;;;
2404;SYMBOL FOR END OF TRANSMISSION;So;0;ON;;;;;N;GRAPHIC FOR END OF TRANSMISSION;;;;
2405;SYMBOL FOR ENQUIRY;So;0;ON;;;;;N;GRAPHIC FOR ENQUIRY;;;;
2406;SYMBOL FOR ACKNOWLEDGE;So;0;ON;;;;;N;GRAPHIC FOR ACKNOWLEDGE;;;;
2407;SYMBOL FOR BELL;So;0;ON;;;;;N;GRAPHIC FOR BELL;;;;
2408;SYMBOL FOR BACKSPACE;So;0;ON;;;;;N;GRAPHIC FOR BACKSPACE;;;;
2409;SYMBOL FOR HORIZONTAL TABULATION;So;0;ON;;;;;N;GRAPHIC FOR HORIZONTAL TABULATION;;;;
240A;SYMBOL FOR LINE FEED;So;0;ON;;;;;N;GRAPHIC FOR LINE FEED;;;;
240B;SYMBOL FOR VERTICAL TABULATION;So;0;ON;;;;;N;GRAPHIC FOR VERTICAL TABULATION;;;;
240C;SYMBOL FOR FORM FEED;So;0;ON;;;;;N;GRAPHIC FOR FORM FEED;;;;
240D;SYMBOL FOR CARRIAGE RETURN;So;0;ON;;;;;N;GRAPHIC FOR CARRIAGE RETURN;;;;
240E;SYMBOL FOR SHIFT OUT;So;0;ON;;;;;N;GRAPHIC FOR SHIFT OUT;;;;
240F;SYMBOL FOR SHIFT IN;So;0;ON;;;;;N;GRAPHIC FOR SHIFT IN;;;;
2410;SYMBOL FOR DATA LINK ESCAPE;So;0;ON;;;;;N;GRAPHIC FOR DATA LINK ESCAPE;;;;
2411;SYMBOL FOR DEVICE CONTROL ONE;So;0;ON;;;;;N;GRAPHIC FOR DEVICE CONTROL ONE;;;;
2412;SYMBOL FOR DEVICE CONTROL TWO;So;0;ON;;;;;N;GRAPHIC FOR DEVICE CONTROL TWO;;;;
2413;SYMBOL FOR DEVICE CONTROL THREE;So;0;ON;;;;;N;GRAPHIC FOR DEVICE CONTROL THREE;;;;
2414;SYMBOL FOR DEVICE CONTROL FOUR;So;0;ON;;;;;N;GRAPHIC FOR DEVICE CONTROL FOUR;;;;
2415;SYMBOL FOR NEGATIVE ACKNOWLEDGE;So;0;ON;;;;;N;GRAPHIC FOR NEGATIVE ACKNOWLEDGE;;;;
2416;SYMBOL FOR SYNCHRONOUS IDLE;So;0;ON;;;;;N;GRAPHIC FOR SYNCHRONOUS IDLE;;;;
2417;SYMBOL FOR END OF TRANSMISSION BLOCK;So;0;ON;;;;;N;GRAPHIC FOR END OF TRANSMISSION BLOCK;;;;
2418;SYMBOL FOR CANCEL;So;0;ON;;;;;N;GRAPHIC FOR CANCEL;;;;
2419;SYMBOL FOR END OF MEDIUM;So;0;ON;;;;;N;GRAPHIC FOR END OF MEDIUM;;;;
241A;SYMBOL FOR SUBSTITUTE;So;0;ON;;;;;N;GRAPHIC FOR SUBSTITUTE;;;;
241B;SYMBOL FOR ESCAPE;So;0;ON;;;;;N;GRAPHIC FOR ESCAPE;;;;
241C;SYMBOL FOR FILE SEPARATOR;So;0;ON;;;;;N;GRAPHIC FOR FILE SEPARATOR;;;;
241D;SYMBOL FOR GROUP SEPARATOR;So;0;ON;;;;;N;GRAPHIC FOR GROUP SEPARATOR;;;;
241E;SYMBOL FOR RECORD SEPARATOR;So;0;ON;;;;;N;GRAPHIC FOR RECORD SEPARATOR;;;;
241F;SYMBOL FOR UNIT SEPARATOR;So;0;ON;;;;;N;GRAPHIC FOR UNIT SEPARATOR;;;;
2420;SYMBOL FOR SPACE;So;0;ON;;;;;N;GRAPHIC FOR SPACE;;;;
2421;SYMBOL FOR DELETE;So;0;ON;;;;;N;GRAPHIC FOR DELETE;;;;
2422;BLANK SYMBOL;So;0;ON;;;;;N;BLANK;;;;
2423;OPEN BOX;So;0;ON;;;;;N;;;;;
2424;SYMBOL FOR NEWLINE;So;0;ON;;;;;N;GRAPHIC FOR NEWLINE;;;;
2425;SYMBOL FOR DELETE FORM TWO;So;0;ON;;;;;N;;;;;
2426;SYMBOL FOR SUBSTITUTE FORM TWO;So;0;ON;;;;;N;;;;;
2440;OCR HOOK;So;0;ON;;;;;N;;;;;
2441;OCR CHAIR;So;0;ON;;;;;N;;;;;
2442;OCR FORK;So;0;ON;;;;;N;;;;;
2443;OCR INVERTED FORK;So;0;ON;;;;;N;;;;;
2444;OCR BELT BUCKLE;So;0;ON;;;;;N;;;;;
2445;OCR BOW TIE;So;0;ON;;;;;N;;;;;
2446;OCR BRANCH BANK IDENTIFICATION;So;0;ON;;;;;N;;;;;
2447;OCR AMOUNT OF CHECK;So;0;ON;;;;;N;;;;;
2448;OCR DASH;So;0;ON;;;;;N;;;;;
2449;OCR CUSTOMER ACCOUNT NUMBER;So;0;ON;;;;;N;;;;;
244A;OCR DOUBLE BACKSLASH;So;0;ON;;;;;N;;;;;
2460;CIRCLED DIGIT ONE;No;0;ON;<circle> 0031;;1;1;N;;;;;
2461;CIRCLED DIGIT TWO;No;0;ON;<circle> 0032;;2;2;N;;;;;
2462;CIRCLED DIGIT THREE;No;0;ON;<circle> 0033;;3;3;N;;;;;
2463;CIRCLED DIGIT FOUR;No;0;ON;<circle> 0034;;4;4;N;;;;;
2464;CIRCLED DIGIT FIVE;No;0;ON;<circle> 0035;;5;5;N;;;;;
2465;CIRCLED DIGIT SIX;No;0;ON;<circle> 0036;;6;6;N;;;;;
2466;CIRCLED DIGIT SEVEN;No;0;ON;<circle> 0037;;7;7;N;;;;;
2467;CIRCLED DIGIT EIGHT;No;0;ON;<circle> 0038;;8;8;N;;;;;
2468;CIRCLED DIGIT NINE;No;0;ON;<circle> 0039;;9;9;N;;;;;
2469;CIRCLED NUMBER TEN;No;0;ON;<circle> 0031 0030;;;10;N;;;;;
246A;CIRCLED NUMBER ELEVEN;No;0;ON;<circle> 0031 0031;;;11;N;;;;;
246B;CIRCLED NUMBER TWELVE;No;0;ON;<circle> 0031 0032;;;12;N;;;;;
246C;CIRCLED NUMBER THIRTEEN;No;0;ON;<circle> 0031 0033;;;13;N;;;;;
246D;CIRCLED NUMBER FOURTEEN;No;0;ON;<circle> 0031 0034;;;14;N;;;;;
246E;CIRCLED NUMBER FIFTEEN;No;0;ON;<circle> 0031 0035;;;15;N;;;;;
246F;CIRCLED NUMBER SIXTEEN;No;0;ON;<circle> 0031 0036;;;16;N;;;;;
2470;CIRCLED NUMBER SEVENTEEN;No;0;ON;<circle> 0031 0037;;;17;N;;;;;
2471;CIRCLED NUMBER EIGHTEEN;No;0;ON;<circle> 0031 0038;;;18;N;;;;;
2472;CIRCLED NUMBER NINETEEN;No;0;ON;<circle> 0031 0039;;;19;N;;;;;
2473;CIRCLED NUMBER TWENTY;No;0;ON;<circle> 0032 0030;;;20;N;;;;;
2474;PARENTHESIZED DIGIT ONE;No;0;ON;<compat> 0028 0031 0029;;1;1;N;;;;;
2475;PARENTHESIZED DIGIT TWO;No;0;ON;<compat> 0028 0032 0029;;2;2;N;;;;;
2476;PARENTHESIZED DIGIT THREE;No;0;ON;<compat> 0028 0033 0029;;3;3;N;;;;;
2477;PARENTHESIZED DIGIT FOUR;No;0;ON;<compat> 0028 0034 0029;;4;4;N;;;;;
2478;PARENTHESIZED DIGIT FIVE;No;0;ON;<compat> 0028 0035 0029;;5;5;N;;;;;
2479;PARENTHESIZED DIGIT SIX;No;0;ON;<compat> 0028 0036 0029;;6;6;N;;;;;
247A;PARENTHESIZED DIGIT SEVEN;No;0;ON;<compat> 0028 0037 0029;;7;7;N;;;;;
247B;PARENTHESIZED DIGIT EIGHT;No;0;ON;<compat> 0028 0038 0029;;8;8;N;;;;;
247C;PARENTHESIZED DIGIT NINE;No;0;ON;<compat> 0028 0039 0029;;9;9;N;;;;;
247D;PARENTHESIZED NUMBER TEN;No;0;ON;<compat> 0028 0031 0030 0029;;;10;N;;;;;
247E;PARENTHESIZED NUMBER ELEVEN;No;0;ON;<compat> 0028 0031 0031 0029;;;11;N;;;;;
247F;PARENTHESIZED NUMBER TWELVE;No;0;ON;<compat> 0028 0031 0032 0029;;;12;N;;;;;
2480;PARENTHESIZED NUMBER THIRTEEN;No;0;ON;<compat> 0028 0031 0033 0029;;;13;N;;;;;
2481;PARENTHESIZED NUMBER FOURTEEN;No;0;ON;<compat> 0028 0031 0034 0029;;;14;N;;;;;
2482;PARENTHESIZED NUMBER FIFTEEN;No;0;ON;<compat> 0028 0031 0035 0029;;;15;N;;;;;
2483;PARENTHESIZED NUMBER SIXTEEN;No;0;ON;<compat> 0028 0031 0036 0029;;;16;N;;;;;
2484;PARENTHESIZED NUMBER SEVENTEEN;No;0;ON;<compat> 0028 0031 0037 0029;;;17;N;;;;;
2485;PARENTHESIZED NUMBER EIGHTEEN;No;0;ON;<compat> 0028 0031 0038 0029;;;18;N;;;;;
2486;PARENTHESIZED NUMBER NINETEEN;No;0;ON;<compat> 0028 0031 0039 0029;;;19;N;;;;;
2487;PARENTHESIZED NUMBER TWENTY;No;0;ON;<compat> 0028 0032 0030 0029;;;20;N;;;;;
2488;DIGIT ONE FULL STOP;No;0;EN;<compat> 0031 002E;;1;1;N;DIGIT ONE PERIOD;;;;
2489;DIGIT TWO FULL STOP;No;0;EN;<compat> 0032 002E;;2;2;N;DIGIT TWO PERIOD;;;;
248A;DIGIT THREE FULL STOP;No;0;EN;<compat> 0033 002E;;3;3;N;DIGIT THREE PERIOD;;;;
248B;DIGIT FOUR FULL STOP;No;0;EN;<compat> 0034 002E;;4;4;N;DIGIT FOUR PERIOD;;;;
248C;DIGIT FIVE FULL STOP;No;0;EN;<compat> 0035 002E;;5;5;N;DIGIT FIVE PERIOD;;;;
248D;DIGIT SIX FULL STOP;No;0;EN;<compat> 0036 002E;;6;6;N;DIGIT SIX PERIOD;;;;
248E;DIGIT SEVEN FULL STOP;No;0;EN;<compat> 0037 002E;;7;7;N;DIGIT SEVEN PERIOD;;;;
248F;DIGIT EIGHT FULL STOP;No;0;EN;<compat> 0038 002E;;8;8;N;DIGIT EIGHT PERIOD;;;;
2490;DIGIT NINE FULL STOP;No;0;EN;<compat> 0039 002E;;9;9;N;DIGIT NINE PERIOD;;;;
2491;NUMBER TEN FULL STOP;No;0;EN;<compat> 0031 0030 002E;;;10;N;NUMBER TEN PERIOD;;;;
2492;NUMBER ELEVEN FULL STOP;No;0;EN;<compat> 0031 0031 002E;;;11;N;NUMBER ELEVEN PERIOD;;;;
2493;NUMBER TWELVE FULL STOP;No;0;EN;<compat> 0031 0032 002E;;;12;N;NUMBER TWELVE PERIOD;;;;
2494;NUMBER THIRTEEN FULL STOP;No;0;EN;<compat> 0031 0033 002E;;;13;N;NUMBER THIRTEEN PERIOD;;;;
2495;NUMBER FOURTEEN FULL STOP;No;0;EN;<compat> 0031 0034 002E;;;14;N;NUMBER FOURTEEN PERIOD;;;;
2496;NUMBER FIFTEEN FULL STOP;No;0;EN;<compat> 0031 0035 002E;;;15;N;NUMBER FIFTEEN PERIOD;;;;
2497;NUMBER SIXTEEN FULL STOP;No;0;EN;<compat> 0031 0036 002E;;;16;N;NUMBER SIXTEEN PERIOD;;;;
2498;NUMBER SEVENTEEN FULL STOP;No;0;EN;<compat> 0031 0037 002E;;;17;N;NUMBER SEVENTEEN PERIOD;;;;
2499;NUMBER EIGHTEEN FULL STOP;No;0;EN;<compat> 0031 0038 002E;;;18;N;NUMBER EIGHTEEN PERIOD;;;;
249A;NUMBER NINETEEN FULL STOP;No;0;EN;<compat> 0031 0039 002E;;;19;N;NUMBER NINETEEN PERIOD;;;;
249B;NUMBER TWENTY FULL STOP;No;0;EN;<compat> 0032 0030 002E;;;20;N;NUMBER TWENTY PERIOD;;;;
249C;PARENTHESIZED LATIN SMALL LETTER A;So;0;L;<compat> 0028 0061 0029;;;;N;;;;;
249D;PARENTHESIZED LATIN SMALL LETTER B;So;0;L;<compat> 0028 0062 0029;;;;N;;;;;
249E;PARENTHESIZED LATIN SMALL LETTER C;So;0;L;<compat> 0028 0063 0029;;;;N;;;;;
249F;PARENTHESIZED LATIN SMALL LETTER D;So;0;L;<compat> 0028 0064 0029;;;;N;;;;;
24A0;PARENTHESIZED LATIN SMALL LETTER E;So;0;L;<compat> 0028 0065 0029;;;;N;;;;;
24A1;PARENTHESIZED LATIN SMALL LETTER F;So;0;L;<compat> 0028 0066 0029;;;;N;;;;;
24A2;PARENTHESIZED LATIN SMALL LETTER G;So;0;L;<compat> 0028 0067 0029;;;;N;;;;;
24A3;PARENTHESIZED LATIN SMALL LETTER H;So;0;L;<compat> 0028 0068 0029;;;;N;;;;;
24A4;PARENTHESIZED LATIN SMALL LETTER I;So;0;L;<compat> 0028 0069 0029;;;;N;;;;;
24A5;PARENTHESIZED LATIN SMALL LETTER J;So;0;L;<compat> 0028 006A 0029;;;;N;;;;;
24A6;PARENTHESIZED LATIN SMALL LETTER K;So;0;L;<compat> 0028 006B 0029;;;;N;;;;;
24A7;PARENTHESIZED LATIN SMALL LETTER L;So;0;L;<compat> 0028 006C 0029;;;;N;;;;;
24A8;PARENTHESIZED LATIN SMALL LETTER M;So;0;L;<compat> 0028 006D 0029;;;;N;;;;;
24A9;PARENTHESIZED LATIN SMALL LETTER N;So;0;L;<compat> 0028 006E 0029;;;;N;;;;;
24AA;PARENTHESIZED LATIN SMALL LETTER O;So;0;L;<compat> 0028 006F 0029;;;;N;;;;;
24AB;PARENTHESIZED LATIN SMALL LETTER P;So;0;L;<compat> 0028 0070 0029;;;;N;;;;;
24AC;PARENTHESIZED LATIN SMALL LETTER Q;So;0;L;<compat> 0028 0071 0029;;;;N;;;;;
24AD;PARENTHESIZED LATIN SMALL LETTER R;So;0;L;<compat> 0028 0072 0029;;;;N;;;;;
24AE;PARENTHESIZED LATIN SMALL LETTER S;So;0;L;<compat> 0028 0073 0029;;;;N;;;;;
24AF;PARENTHESIZED LATIN SMALL LETTER T;So;0;L;<compat> 0028 0074 0029;;;;N;;;;;
24B0;PARENTHESIZED LATIN SMALL LETTER U;So;0;L;<compat> 0028 0075 0029;;;;N;;;;;
24B1;PARENTHESIZED LATIN SMALL LETTER V;So;0;L;<compat> 0028 0076 0029;;;;N;;;;;
24B2;PARENTHESIZED LATIN SMALL LETTER W;So;0;L;<compat> 0028 0077 0029;;;;N;;;;;
24B3;PARENTHESIZED LATIN SMALL LETTER X;So;0;L;<compat> 0028 0078 0029;;;;N;;;;;
24B4;PARENTHESIZED LATIN SMALL LETTER Y;So;0;L;<compat> 0028 0079 0029;;;;N;;;;;
24B5;PARENTHESIZED LATIN SMALL LETTER Z;So;0;L;<compat> 0028 007A 0029;;;;N;;;;;
24B6;CIRCLED LATIN CAPITAL LETTER A;So;0;L;<circle> 0041;;;;N;;;;24D0;
24B7;CIRCLED LATIN CAPITAL LETTER B;So;0;L;<circle> 0042;;;;N;;;;24D1;
24B8;CIRCLED LATIN CAPITAL LETTER C;So;0;L;<circle> 0043;;;;N;;;;24D2;
24B9;CIRCLED LATIN CAPITAL LETTER D;So;0;L;<circle> 0044;;;;N;;;;24D3;
24BA;CIRCLED LATIN CAPITAL LETTER E;So;0;L;<circle> 0045;;;;N;;;;24D4;
24BB;CIRCLED LATIN CAPITAL LETTER F;So;0;L;<circle> 0046;;;;N;;;;24D5;
24BC;CIRCLED LATIN CAPITAL LETTER G;So;0;L;<circle> 0047;;;;N;;;;24D6;
24BD;CIRCLED LATIN CAPITAL LETTER H;So;0;L;<circle> 0048;;;;N;;;;24D7;
24BE;CIRCLED LATIN CAPITAL LETTER I;So;0;L;<circle> 0049;;;;N;;;;24D8;
24BF;CIRCLED LATIN CAPITAL LETTER J;So;0;L;<circle> 004A;;;;N;;;;24D9;
24C0;CIRCLED LATIN CAPITAL LETTER K;So;0;L;<circle> 004B;;;;N;;;;24DA;
24C1;CIRCLED LATIN CAPITAL LETTER L;So;0;L;<circle> 004C;;;;N;;;;24DB;
24C2;CIRCLED LATIN CAPITAL LETTER M;So;0;L;<circle> 004D;;;;N;;;;24DC;
24C3;CIRCLED LATIN CAPITAL LETTER N;So;0;L;<circle> 004E;;;;N;;;;24DD;
24C4;CIRCLED LATIN CAPITAL LETTER O;So;0;L;<circle> 004F;;;;N;;;;24DE;
24C5;CIRCLED LATIN CAPITAL LETTER P;So;0;L;<circle> 0050;;;;N;;;;24DF;
24C6;CIRCLED LATIN CAPITAL LETTER Q;So;0;L;<circle> 0051;;;;N;;;;24E0;
24C7;CIRCLED LATIN CAPITAL LETTER R;So;0;L;<circle> 0052;;;;N;;;;24E1;
24C8;CIRCLED LATIN CAPITAL LETTER S;So;0;L;<circle> 0053;;;;N;;;;24E2;
24C9;CIRCLED LATIN CAPITAL LETTER T;So;0;L;<circle> 0054;;;;N;;;;24E3;
24CA;CIRCLED LATIN CAPITAL LETTER U;So;0;L;<circle> 0055;;;;N;;;;24E4;
24CB;CIRCLED LATIN CAPITAL LETTER V;So;0;L;<circle> 0056;;;;N;;;;24E5;
24CC;CIRCLED LATIN CAPITAL LETTER W;So;0;L;<circle> 0057;;;;N;;;;24E6;
24CD;CIRCLED LATIN CAPITAL LETTER X;So;0;L;<circle> 0058;;;;N;;;;24E7;
24CE;CIRCLED LATIN CAPITAL LETTER Y;So;0;L;<circle> 0059;;;;N;;;;24E8;
24CF;CIRCLED LATIN CAPITAL LETTER Z;So;0;L;<circle> 005A;;;;N;;;;24E9;
24D0;CIRCLED LATIN SMALL LETTER A;So;0;L;<circle> 0061;;;;N;;;24B6;;24B6
24D1;CIRCLED LATIN SMALL LETTER B;So;0;L;<circle> 0062;;;;N;;;24B7;;24B7
24D2;CIRCLED LATIN SMALL LETTER C;So;0;L;<circle> 0063;;;;N;;;24B8;;24B8
24D3;CIRCLED LATIN SMALL LETTER D;So;0;L;<circle> 0064;;;;N;;;24B9;;24B9
24D4;CIRCLED LATIN SMALL LETTER E;So;0;L;<circle> 0065;;;;N;;;24BA;;24BA
24D5;CIRCLED LATIN SMALL LETTER F;So;0;L;<circle> 0066;;;;N;;;24BB;;24BB
24D6;CIRCLED LATIN SMALL LETTER G;So;0;L;<circle> 0067;;;;N;;;24BC;;24BC
24D7;CIRCLED LATIN SMALL LETTER H;So;0;L;<circle> 0068;;;;N;;;24BD;;24BD
24D8;CIRCLED LATIN SMALL LETTER I;So;0;L;<circle> 0069;;;;N;;;24BE;;24BE
24D9;CIRCLED LATIN SMALL LETTER J;So;0;L;<circle> 006A;;;;N;;;24BF;;24BF
24DA;CIRCLED LATIN SMALL LETTER K;So;0;L;<circle> 006B;;;;N;;;24C0;;24C0
24DB;CIRCLED LATIN SMALL LETTER L;So;0;L;<circle> 006C;;;;N;;;24C1;;24C1
24DC;CIRCLED LATIN SMALL LETTER M;So;0;L;<circle> 006D;;;;N;;;24C2;;24C2
24DD;CIRCLED LATIN SMALL LETTER N;So;0;L;<circle> 006E;;;;N;;;24C3;;24C3
24DE;CIRCLED LATIN SMALL LETTER O;So;0;L;<circle> 006F;;;;N;;;24C4;;24C4
24DF;CIRCLED LATIN SMALL LETTER P;So;0;L;<circle> 0070;;;;N;;;24C5;;24C5
24E0;CIRCLED LATIN SMALL LETTER Q;So;0;L;<circle> 0071;;;;N;;;24C6;;24C6
24E1;CIRCLED LATIN SMALL LETTER R;So;0;L;<circle> 0072;;;;N;;;24C7;;24C7
24E2;CIRCLED LATIN SMALL LETTER S;So;0;L;<circle> 0073;;;;N;;;24C8;;24C8
24E3;CIRCLED LATIN SMALL LETTER T;So;0;L;<circle> 0074;;;;N;;;24C9;;24C9
24E4;CIRCLED LATIN SMALL LETTER U;So;0;L;<circle> 0075;;;;N;;;24CA;;24CA
24E5;CIRCLED LATIN SMALL LETTER V;So;0;L;<circle> 0076;;;;N;;;24CB;;24CB
24E6;CIRCLED LATIN SMALL LETTER W;So;0;L;<circle> 0077;;;;N;;;24CC;;24CC
24E7;CIRCLED LATIN SMALL LETTER X;So;0;L;<circle> 0078;;;;N;;;24CD;;24CD
24E8;CIRCLED LATIN SMALL LETTER Y;So;0;L;<circle> 0079;;;;N;;;24CE;;24CE
24E9;CIRCLED LATIN SMALL LETTER Z;So;0;L;<circle> 007A;;;;N;;;24CF;;24CF
24EA;CIRCLED DIGIT ZERO;No;0;ON;<circle> 0030;;0;0;N;;;;;
24EB;NEGATIVE CIRCLED NUMBER ELEVEN;No;0;ON;;;;11;N;;;;;
24EC;NEGATIVE CIRCLED NUMBER TWELVE;No;0;ON;;;;12;N;;;;;
24ED;NEGATIVE CIRCLED NUMBER THIRTEEN;No;0;ON;;;;13;N;;;;;
24EE;NEGATIVE CIRCLED NUMBER FOURTEEN;No;0;ON;;;;14;N;;;;;
24EF;NEGATIVE CIRCLED NUMBER FIFTEEN;No;0;ON;;;;15;N;;;;;
24F0;NEGATIVE CIRCLED NUMBER SIXTEEN;No;0;ON;;;;16;N;;;;;
24F1;NEGATIVE CIRCLED NUMBER SEVENTEEN;No;0;ON;;;;17;N;;;;;
24F2;NEGATIVE CIRCLED NUMBER EIGHTEEN;No;0;ON;;;;18;N;;;;;
24F3;NEGATIVE CIRCLED NUMBER NINETEEN;No;0;ON;;;;19;N;;;;;
24F4;NEGATIVE CIRCLED NUMBER TWENTY;No;0;ON;;;;20;N;;;;;
24F5;DOUBLE CIRCLED DIGIT ONE;No;0;ON;;;1;1;N;;;;;
24F6;DOUBLE CIRCLED DIGIT TWO;No;0;ON;;;2;2;N;;;;;
24F7;DOUBLE CIRCLED DIGIT THREE;No;0;ON;;;3;3;N;;;;;
24F8;DOUBLE CIRCLED DIGIT FOUR;No;0;ON;;;4;4;N;;;;;
24F9;DOUBLE CIRCLED DIGIT FIVE;No;0;ON;;;5;5;N;;;;;
24FA;DOUBLE CIRCLED DIGIT SIX;No;0;ON;;;6;6;N;;;;;
24FB;DOUBLE CIRCLED DIGIT SEVEN;No;0;ON;;;7;7;N;;;;;
24FC;DOUBLE CIRCLED DIGIT EIGHT;No;0;ON;;;8;8;N;;;;;
24FD;DOUBLE CIRCLED DIGIT NINE;No;0;ON;;;9;9;N;;;;;
24FE;DOUBLE CIRCLED NUMBER TEN;No;0;ON;;;;10;N;;;;;
24FF;NEGATIVE CIRCLED DIGIT ZERO;No;0;ON;;;0;0;N;;;;;
2500;BOX DRAWINGS LIGHT HORIZONTAL;So;0;ON;;;;;N;FORMS LIGHT HORIZONTAL;;;;
2501;BOX DRAWINGS HEAVY HORIZONTAL;So;0;ON;;;;;N;FORMS HEAVY HORIZONTAL;;;;
2502;BOX DRAWINGS LIGHT VERTICAL;So;0;ON;;;;;N;FORMS LIGHT VERTICAL;;;;
2503;BOX DRAWINGS HEAVY VERTICAL;So;0;ON;;;;;N;FORMS HEAVY VERTICAL;;;;
2504;BOX DRAWINGS LIGHT TRIPLE DASH HORIZONTAL;So;0;ON;;;;;N;FORMS LIGHT TRIPLE DASH HORIZONTAL;;;;
2505;BOX DRAWINGS HEAVY TRIPLE DASH HORIZONTAL;So;0;ON;;;;;N;FORMS HEAVY TRIPLE DASH HORIZONTAL;;;;
2506;BOX DRAWINGS LIGHT TRIPLE DASH VERTICAL;So;0;ON;;;;;N;FORMS LIGHT TRIPLE DASH VERTICAL;;;;
2507;BOX DRAWINGS HEAVY TRIPLE DASH VERTICAL;So;0;ON;;;;;N;FORMS HEAVY TRIPLE DASH VERTICAL;;;;
2508;BOX DRAWINGS LIGHT QUADRUPLE DASH HORIZONTAL;So;0;ON;;;;;N;FORMS LIGHT QUADRUPLE DASH HORIZONTAL;;;;
2509;BOX DRAWINGS HEAVY QUADRUPLE DASH HORIZONTAL;So;0;ON;;;;;N;FORMS HEAVY QUADRUPLE DASH HORIZONTAL;;;;
250A;BOX DRAWINGS LIGHT QUADRUPLE DASH VERTICAL;So;0;ON;;;;;N;FORMS LIGHT QUADRUPLE DASH VERTICAL;;;;
250B;BOX DRAWINGS HEAVY QUADRUPLE DASH VERTICAL;So;0;ON;;;;;N;FORMS HEAVY QUADRUPLE DASH VERTICAL;;;;
250C;BOX DRAWINGS LIGHT DOWN AND RIGHT;So;0;ON;;;;;N;FORMS LIGHT DOWN AND RIGHT;;;;
250D;BOX DRAWINGS DOWN LIGHT AND RIGHT HEAVY;So;0;ON;;;;;N;FORMS DOWN LIGHT AND RIGHT HEAVY;;;;
250E;BOX DRAWINGS DOWN HEAVY AND RIGHT LIGHT;So;0;ON;;;;;N;FORMS DOWN HEAVY AND RIGHT LIGHT;;;;
250F;BOX DRAWINGS HEAVY DOWN AND RIGHT;So;0;ON;;;;;N;FORMS HEAVY DOWN AND RIGHT;;;;
2510;BOX DRAWINGS LIGHT DOWN AND LEFT;So;0;ON;;;;;N;FORMS LIGHT DOWN AND LEFT;;;;
2511;BOX DRAWINGS DOWN LIGHT AND LEFT HEAVY;So;0;ON;;;;;N;FORMS DOWN LIGHT AND LEFT HEAVY;;;;
2512;BOX DRAWINGS DOWN HEAVY AND LEFT LIGHT;So;0;ON;;;;;N;FORMS DOWN HEAVY AND LEFT LIGHT;;;;
2513;BOX DRAWINGS HEAVY DOWN AND LEFT;So;0;ON;;;;;N;FORMS HEAVY DOWN AND LEFT;;;;
2514;BOX DRAWINGS LIGHT UP AND RIGHT;So;0;ON;;;;;N;FORMS LIGHT UP AND RIGHT;;;;
2515;BOX DRAWINGS UP LIGHT AND RIGHT HEAVY;So;0;ON;;;;;N;FORMS UP LIGHT AND RIGHT HEAVY;;;;
2516;BOX DRAWINGS UP HEAVY AND RIGHT LIGHT;So;0;ON;;;;;N;FORMS UP HEAVY AND RIGHT LIGHT;;;;
2517;BOX DRAWINGS HEAVY UP AND RIGHT;So;0;ON;;;;;N;FORMS HEAVY UP AND RIGHT;;;;
2518;BOX DRAWINGS LIGHT UP AND LEFT;So;0;ON;;;;;N;FORMS LIGHT UP AND LEFT;;;;
2519;BOX DRAWINGS UP LIGHT AND LEFT HEAVY;So;0;ON;;;;;N;FORMS UP LIGHT AND LEFT HEAVY;;;;
251A;BOX DRAWINGS UP HEAVY AND LEFT LIGHT;So;0;ON;;;;;N;FORMS UP HEAVY AND LEFT LIGHT;;;;
251B;BOX DRAWINGS HEAVY UP AND LEFT;So;0;ON;;;;;N;FORMS HEAVY UP AND LEFT;;;;
251C;BOX DRAWINGS LIGHT VERTICAL AND RIGHT;So;0;ON;;;;;N;FORMS LIGHT VERTICAL AND RIGHT;;;;
251D;BOX DRAWINGS VERTICAL LIGHT AND RIGHT HEAVY;So;0;ON;;;;;N;FORMS VERTICAL LIGHT AND RIGHT HEAVY;;;;
251E;BOX DRAWINGS UP HEAVY AND RIGHT DOWN LIGHT;So;0;ON;;;;;N;FORMS UP HEAVY AND RIGHT DOWN LIGHT;;;;
251F;BOX DRAWINGS DOWN HEAVY AND RIGHT UP LIGHT;So;0;ON;;;;;N;FORMS DOWN HEAVY AND RIGHT UP LIGHT;;;;
2520;BOX DRAWINGS VERTICAL HEAVY AND RIGHT LIGHT;So;0;ON;;;;;N;FORMS VERTICAL HEAVY AND RIGHT LIGHT;;;;
2521;BOX DRAWINGS DOWN LIGHT AND RIGHT UP HEAVY;So;0;ON;;;;;N;FORMS DOWN LIGHT AND RIGHT UP HEAVY;;;;
2522;BOX DRAWINGS UP LIGHT AND RIGHT DOWN HEAVY;So;0;ON;;;;;N;FORMS UP LIGHT AND RIGHT DOWN HEAVY;;;;
2523;BOX DRAWINGS HEAVY VERTICAL AND RIGHT;So;0;ON;;;;;N;FORMS HEAVY VERTICAL AND RIGHT;;;;
2524;BOX DRAWINGS LIGHT VERTICAL AND LEFT;So;0;ON;;;;;N;FORMS LIGHT VERTICAL AND LEFT;;;;
2525;BOX DRAWINGS VERTICAL LIGHT AND LEFT HEAVY;So;0;ON;;;;;N;FORMS VERTICAL LIGHT AND LEFT HEAVY;;;;
2526;BOX DRAWINGS UP HEAVY AND LEFT DOWN LIGHT;So;0;ON;;;;;N;FORMS UP HEAVY AND LEFT DOWN LIGHT;;;;
2527;BOX DRAWINGS DOWN HEAVY AND LEFT UP LIGHT;So;0;ON;;;;;N;FORMS DOWN HEAVY AND LEFT UP LIGHT;;;;
2528;BOX DRAWINGS VERTICAL HEAVY AND LEFT LIGHT;So;0;ON;;;;;N;FORMS VERTICAL HEAVY AND LEFT LIGHT;;;;
2529;BOX DRAWINGS DOWN LIGHT AND LEFT UP HEAVY;So;0;ON;;;;;N;FORMS DOWN LIGHT AND LEFT UP HEAVY;;;;
252A;BOX DRAWINGS UP LIGHT AND LEFT DOWN HEAVY;So;0;ON;;;;;N;FORMS UP LIGHT AND LEFT DOWN HEAVY;;;;
252B;BOX DRAWINGS HEAVY VERTICAL AND LEFT;So;0;ON;;;;;N;FORMS HEAVY VERTICAL AND LEFT;;;;
252C;BOX DRAWINGS LIGHT DOWN AND HORIZONTAL;So;0;ON;;;;;N;FORMS LIGHT DOWN AND HORIZONTAL;;;;
252D;BOX DRAWINGS LEFT HEAVY AND RIGHT DOWN LIGHT;So;0;ON;;;;;N;FORMS LEFT HEAVY AND RIGHT DOWN LIGHT;;;;
252E;BOX DRAWINGS RIGHT HEAVY AND LEFT DOWN LIGHT;So;0;ON;;;;;N;FORMS RIGHT HEAVY AND LEFT DOWN LIGHT;;;;
252F;BOX DRAWINGS DOWN LIGHT AND HORIZONTAL HEAVY;So;0;ON;;;;;N;FORMS DOWN LIGHT AND HORIZONTAL HEAVY;;;;
2530;BOX DRAWINGS DOWN HEAVY AND HORIZONTAL LIGHT;So;0;ON;;;;;N;FORMS DOWN HEAVY AND HORIZONTAL LIGHT;;;;
2531;BOX DRAWINGS RIGHT LIGHT AND LEFT DOWN HEAVY;So;0;ON;;;;;N;FORMS RIGHT LIGHT AND LEFT DOWN HEAVY;;;;
2532;BOX DRAWINGS LEFT LIGHT AND RIGHT DOWN HEAVY;So;0;ON;;;;;N;FORMS LEFT LIGHT AND RIGHT DOWN HEAVY;;;;
2533;BOX DRAWINGS HEAVY DOWN AND HORIZONTAL;So;0;ON;;;;;N;FORMS HEAVY DOWN AND HORIZONTAL;;;;
2534;BOX DRAWINGS LIGHT UP AND HORIZONTAL;So;0;ON;;;;;N;FORMS LIGHT UP AND HORIZONTAL;;;;
2535;BOX DRAWINGS LEFT HEAVY AND RIGHT UP LIGHT;So;0;ON;;;;;N;FORMS LEFT HEAVY AND RIGHT UP LIGHT;;;;
2536;BOX DRAWINGS RIGHT HEAVY AND LEFT UP LIGHT;So;0;ON;;;;;N;FORMS RIGHT HEAVY AND LEFT UP LIGHT;;;;
2537;BOX DRAWINGS UP LIGHT AND HORIZONTAL HEAVY;So;0;ON;;;;;N;FORMS UP LIGHT AND HORIZONTAL HEAVY;;;;
2538;BOX DRAWINGS UP HEAVY AND HORIZONTAL LIGHT;So;0;ON;;;;;N;FORMS UP HEAVY AND HORIZONTAL LIGHT;;;;
2539;BOX DRAWINGS RIGHT LIGHT AND LEFT UP HEAVY;So;0;ON;;;;;N;FORMS RIGHT LIGHT AND LEFT UP HEAVY;;;;
253A;BOX DRAWINGS LEFT LIGHT AND RIGHT UP HEAVY;So;0;ON;;;;;N;FORMS LEFT LIGHT AND RIGHT UP HEAVY;;;;
253B;BOX DRAWINGS HEAVY UP AND HORIZONTAL;So;0;ON;;;;;N;FORMS HEAVY UP AND HORIZONTAL;;;;
253C;BOX DRAWINGS LIGHT VERTICAL AND HORIZONTAL;So;0;ON;;;;;N;FORMS LIGHT VERTICAL AND HORIZONTAL;;;;
253D;BOX DRAWINGS LEFT HEAVY AND RIGHT VERTICAL LIGHT;So;0;ON;;;;;N;FORMS LEFT HEAVY AND RIGHT VERTICAL LIGHT;;;;
253E;BOX DRAWINGS RIGHT HEAVY AND LEFT VERTICAL LIGHT;So;0;ON;;;;;N;FORMS RIGHT HEAVY AND LEFT VERTICAL LIGHT;;;;
253F;BOX DRAWINGS VERTICAL LIGHT AND HORIZONTAL HEAVY;So;0;ON;;;;;N;FORMS VERTICAL LIGHT AND HORIZONTAL HEAVY;;;;
2540;BOX DRAWINGS UP HEAVY AND DOWN HORIZONTAL LIGHT;So;0;ON;;;;;N;FORMS UP HEAVY AND DOWN HORIZONTAL LIGHT;;;;
2541;BOX DRAWINGS DOWN HEAVY AND UP HORIZONTAL LIGHT;So;0;ON;;;;;N;FORMS DOWN HEAVY AND UP HORIZONTAL LIGHT;;;;
2542;BOX DRAWINGS VERTICAL HEAVY AND HORIZONTAL LIGHT;So;0;ON;;;;;N;FORMS VERTICAL HEAVY AND HORIZONTAL LIGHT;;;;
2543;BOX DRAWINGS LEFT UP HEAVY AND RIGHT DOWN LIGHT;So;0;ON;;;;;N;FORMS LEFT UP HEAVY AND RIGHT DOWN LIGHT;;;;
2544;BOX DRAWINGS RIGHT UP HEAVY AND LEFT DOWN LIGHT;So;0;ON;;;;;N;FORMS RIGHT UP HEAVY AND LEFT DOWN LIGHT;;;;
2545;BOX DRAWINGS LEFT DOWN HEAVY AND RIGHT UP LIGHT;So;0;ON;;;;;N;FORMS LEFT DOWN HEAVY AND RIGHT UP LIGHT;;;;
2546;BOX DRAWINGS RIGHT DOWN HEAVY AND LEFT UP LIGHT;So;0;ON;;;;;N;FORMS RIGHT DOWN HEAVY AND LEFT UP LIGHT;;;;
2547;BOX DRAWINGS DOWN LIGHT AND UP HORIZONTAL HEAVY;So;0;ON;;;;;N;FORMS DOWN LIGHT AND UP HORIZONTAL HEAVY;;;;
2548;BOX DRAWINGS UP LIGHT AND DOWN HORIZONTAL HEAVY;So;0;ON;;;;;N;FORMS UP LIGHT AND DOWN HORIZONTAL HEAVY;;;;
2549;BOX DRAWINGS RIGHT LIGHT AND LEFT VERTICAL HEAVY;So;0;ON;;;;;N;FORMS RIGHT LIGHT AND LEFT VERTICAL HEAVY;;;;
254A;BOX DRAWINGS LEFT LIGHT AND RIGHT VERTICAL HEAVY;So;0;ON;;;;;N;FORMS LEFT LIGHT AND RIGHT VERTICAL HEAVY;;;;
254B;BOX DRAWINGS HEAVY VERTICAL AND HORIZONTAL;So;0;ON;;;;;N;FORMS HEAVY VERTICAL AND HORIZONTAL;;;;
254C;BOX DRAWINGS LIGHT DOUBLE DASH HORIZONTAL;So;0;ON;;;;;N;FORMS LIGHT DOUBLE DASH HORIZONTAL;;;;
254D;BOX DRAWINGS HEAVY DOUBLE DASH HORIZONTAL;So;0;ON;;;;;N;FORMS HEAVY DOUBLE DASH HORIZONTAL;;;;
254E;BOX DRAWINGS LIGHT DOUBLE DASH VERTICAL;So;0;ON;;;;;N;FORMS LIGHT DOUBLE DASH VERTICAL;;;;
254F;BOX DRAWINGS HEAVY DOUBLE DASH VERTICAL;So;0;ON;;;;;N;FORMS HEAVY DOUBLE DASH VERTICAL;;;;
2550;BOX DRAWINGS DOUBLE HORIZONTAL;So;0;ON;;;;;N;FORMS DOUBLE HORIZONTAL;;;;
2551;BOX DRAWINGS DOUBLE VERTICAL;So;0;ON;;;;;N;FORMS DOUBLE VERTICAL;;;;
2552;BOX DRAWINGS DOWN SINGLE AND RIGHT DOUBLE;So;0;ON;;;;;N;FORMS DOWN SINGLE AND RIGHT DOUBLE;;;;
2553;BOX DRAWINGS DOWN DOUBLE AND RIGHT SINGLE;So;0;ON;;;;;N;FORMS DOWN DOUBLE AND RIGHT SINGLE;;;;
2554;BOX DRAWINGS DOUBLE DOWN AND RIGHT;So;0;ON;;;;;N;FORMS DOUBLE DOWN AND RIGHT;;;;
2555;BOX DRAWINGS DOWN SINGLE AND LEFT DOUBLE;So;0;ON;;;;;N;FORMS DOWN SINGLE AND LEFT DOUBLE;;;;
2556;BOX DRAWINGS DOWN DOUBLE AND LEFT SINGLE;So;0;ON;;;;;N;FORMS DOWN DOUBLE AND LEFT SINGLE;;;;
2557;BOX DRAWINGS DOUBLE DOWN AND LEFT;So;0;ON;;;;;N;FORMS DOUBLE DOWN AND LEFT;;;;
2558;BOX DRAWINGS UP SINGLE AND RIGHT DOUBLE;So;0;ON;;;;;N;FORMS UP SINGLE AND RIGHT DOUBLE;;;;
2559;BOX DRAWINGS UP DOUBLE AND RIGHT SINGLE;So;0;ON;;;;;N;FORMS UP DOUBLE AND RIGHT SINGLE;;;;
255A;BOX DRAWINGS DOUBLE UP AND RIGHT;So;0;ON;;;;;N;FORMS DOUBLE UP AND RIGHT;;;;
255B;BOX DRAWINGS UP SINGLE AND LEFT DOUBLE;So;0;ON;;;;;N;FORMS UP SINGLE AND LEFT DOUBLE;;;;
255C;BOX DRAWINGS UP DOUBLE AND LEFT SINGLE;So;0;ON;;;;;N;FORMS UP DOUBLE AND LEFT SINGLE;;;;
255D;BOX DRAWINGS DOUBLE UP AND LEFT;So;0;ON;;;;;N;FORMS DOUBLE UP AND LEFT;;;;
255E;BOX DRAWINGS VERTICAL SINGLE AND RIGHT DOUBLE;So;0;ON;;;;;N;FORMS VERTICAL SINGLE AND RIGHT DOUBLE;;;;
255F;BOX DRAWINGS VERTICAL DOUBLE AND RIGHT SINGLE;So;0;ON;;;;;N;FORMS VERTICAL DOUBLE AND RIGHT SINGLE;;;;
2560;BOX DRAWINGS DOUBLE VERTICAL AND RIGHT;So;0;ON;;;;;N;FORMS DOUBLE VERTICAL AND RIGHT;;;;
2561;BOX DRAWINGS VERTICAL SINGLE AND LEFT DOUBLE;So;0;ON;;;;;N;FORMS VERTICAL SINGLE AND LEFT DOUBLE;;;;
2562;BOX DRAWINGS VERTICAL DOUBLE AND LEFT SINGLE;So;0;ON;;;;;N;FORMS VERTICAL DOUBLE AND LEFT SINGLE;;;;
2563;BOX DRAWINGS DOUBLE VERTICAL AND LEFT;So;0;ON;;;;;N;FORMS DOUBLE VERTICAL AND LEFT;;;;
2564;BOX DRAWINGS DOWN SINGLE AND HORIZONTAL DOUBLE;So;0;ON;;;;;N;FORMS DOWN SINGLE AND HORIZONTAL DOUBLE;;;;
2565;BOX DRAWINGS DOWN DOUBLE AND HORIZONTAL SINGLE;So;0;ON;;;;;N;FORMS DOWN DOUBLE AND HORIZONTAL SINGLE;;;;
2566;BOX DRAWINGS DOUBLE DOWN AND HORIZONTAL;So;0;ON;;;;;N;FORMS DOUBLE DOWN AND HORIZONTAL;;;;
2567;BOX DRAWINGS UP SINGLE AND HORIZONTAL DOUBLE;So;0;ON;;;;;N;FORMS UP SINGLE AND HORIZONTAL DOUBLE;;;;
2568;BOX DRAWINGS UP DOUBLE AND HORIZONTAL SINGLE;So;0;ON;;;;;N;FORMS UP DOUBLE AND HORIZONTAL SINGLE;;;;
2569;BOX DRAWINGS DOUBLE UP AND HORIZONTAL;So;0;ON;;;;;N;FORMS DOUBLE UP AND HORIZONTAL;;;;
256A;BOX DRAWINGS VERTICAL SINGLE AND HORIZONTAL DOUBLE;So;0;ON;;;;;N;FORMS VERTICAL SINGLE AND HORIZONTAL DOUBLE;;;;
256B;BOX DRAWINGS VERTICAL DOUBLE AND HORIZONTAL SINGLE;So;0;ON;;;;;N;FORMS VERTICAL DOUBLE AND HORIZONTAL SINGLE;;;;
256C;BOX DRAWINGS DOUBLE VERTICAL AND HORIZONTAL;So;0;ON;;;;;N;FORMS DOUBLE VERTICAL AND HORIZONTAL;;;;
256D;BOX DRAWINGS LIGHT ARC DOWN AND RIGHT;So;0;ON;;;;;N;FORMS LIGHT ARC DOWN AND RIGHT;;;;
256E;BOX DRAWINGS LIGHT ARC DOWN AND LEFT;So;0;ON;;;;;N;FORMS LIGHT ARC DOWN AND LEFT;;;;
256F;BOX DRAWINGS LIGHT ARC UP AND LEFT;So;0;ON;;;;;N;FORMS LIGHT ARC UP AND LEFT;;;;
2570;BOX DRAWINGS LIGHT ARC UP AND RIGHT;So;0;ON;;;;;N;FORMS LIGHT ARC UP AND RIGHT;;;;
2571;BOX DRAWINGS LIGHT DIAGONAL UPPER RIGHT TO LOWER LEFT;So;0;ON;;;;;N;FORMS LIGHT DIAGONAL UPPER RIGHT TO LOWER LEFT;;;;
2572;BOX DRAWINGS LIGHT DIAGONAL UPPER LEFT TO LOWER RIGHT;So;0;ON;;;;;N;FORMS LIGHT DIAGONAL UPPER LEFT TO LOWER RIGHT;;;;
2573;BOX DRAWINGS LIGHT DIAGONAL CROSS;So;0;ON;;;;;N;FORMS LIGHT DIAGONAL CROSS;;;;
2574;BOX DRAWINGS LIGHT LEFT;So;0;ON;;;;;N;FORMS LIGHT LEFT;;;;
2575;BOX DRAWINGS LIGHT UP;So;0;ON;;;;;N;FORMS LIGHT UP;;;;
2576;BOX DRAWINGS LIGHT RIGHT;So;0;ON;;;;;N;FORMS LIGHT RIGHT;;;;
2577;BOX DRAWINGS LIGHT DOWN;So;0;ON;;;;;N;FORMS LIGHT DOWN;;;;
2578;BOX DRAWINGS HEAVY LEFT;So;0;ON;;;;;N;FORMS HEAVY LEFT;;;;
2579;BOX DRAWINGS HEAVY UP;So;0;ON;;;;;N;FORMS HEAVY UP;;;;
257A;BOX DRAWINGS HEAVY RIGHT;So;0;ON;;;;;N;FORMS HEAVY RIGHT;;;;
257B;BOX DRAWINGS HEAVY DOWN;So;0;ON;;;;;N;FORMS HEAVY DOWN;;;;
257C;BOX DRAWINGS LIGHT LEFT AND HEAVY RIGHT;So;0;ON;;;;;N;FORMS LIGHT LEFT AND HEAVY RIGHT;;;;
257D;BOX DRAWINGS LIGHT UP AND HEAVY DOWN;So;0;ON;;;;;N;FORMS LIGHT UP AND HEAVY DOWN;;;;
257E;BOX DRAWINGS HEAVY LEFT AND LIGHT RIGHT;So;0;ON;;;;;N;FORMS HEAVY LEFT AND LIGHT RIGHT;;;;
257F;BOX DRAWINGS HEAVY UP AND LIGHT DOWN;So;0;ON;;;;;N;FORMS HEAVY UP AND LIGHT DOWN;;;;
2580;UPPER HALF BLOCK;So;0;ON;;;;;N;;;;;
2581;LOWER ONE EIGHTH BLOCK;So;0;ON;;;;;N;;;;;
2582;LOWER ONE QUARTER BLOCK;So;0;ON;;;;;N;;;;;
2583;LOWER THREE EIGHTHS BLOCK;So;0;ON;;;;;N;;;;;
2584;LOWER HALF BLOCK;So;0;ON;;;;;N;;;;;
2585;LOWER FIVE EIGHTHS BLOCK;So;0;ON;;;;;N;;;;;
2586;LOWER THREE QUARTERS BLOCK;So;0;ON;;;;;N;LOWER THREE QUARTER BLOCK;;;;
2587;LOWER SEVEN EIGHTHS BLOCK;So;0;ON;;;;;N;;;;;
2588;FULL BLOCK;So;0;ON;;;;;N;;;;;
2589;LEFT SEVEN EIGHTHS BLOCK;So;0;ON;;;;;N;;;;;
258A;LEFT THREE QUARTERS BLOCK;So;0;ON;;;;;N;LEFT THREE QUARTER BLOCK;;;;
258B;LEFT FIVE EIGHTHS BLOCK;So;0;ON;;;;;N;;;;;
258C;LEFT HALF BLOCK;So;0;ON;;;;;N;;;;;
258D;LEFT THREE EIGHTHS BLOCK;So;0;ON;;;;;N;;;;;
258E;LEFT ONE QUARTER BLOCK;So;0;ON;;;;;N;;;;;
258F;LEFT ONE EIGHTH BLOCK;So;0;ON;;;;;N;;;;;
2590;RIGHT HALF BLOCK;So;0;ON;;;;;N;;;;;
2591;LIGHT SHADE;So;0;ON;;;;;N;;;;;
2592;MEDIUM SHADE;So;0;ON;;;;;N;;;;;
2593;DARK SHADE;So;0;ON;;;;;N;;;;;
2594;UPPER ONE EIGHTH BLOCK;So;0;ON;;;;;N;;;;;
2595;RIGHT ONE EIGHTH BLOCK;So;0;ON;;;;;N;;;;;
2596;QUADRANT LOWER LEFT;So;0;ON;;;;;N;;;;;
2597;QUADRANT LOWER RIGHT;So;0;ON;;;;;N;;;;;
2598;QUADRANT UPPER LEFT;So;0;ON;;;;;N;;;;;
2599;QUADRANT UPPER LEFT AND LOWER LEFT AND LOWER RIGHT;So;0;ON;;;;;N;;;;;
259A;QUADRANT UPPER LEFT AND LOWER RIGHT;So;0;ON;;;;;N;;;;;
259B;QUADRANT UPPER LEFT AND UPPER RIGHT AND LOWER LEFT;So;0;ON;;;;;N;;;;;
259C;QUADRANT UPPER LEFT AND UPPER RIGHT AND LOWER RIGHT;So;0;ON;;;;;N;;;;;
259D;QUADRANT UPPER RIGHT;So;0;ON;;;;;N;;;;;
259E;QUADRANT UPPER RIGHT AND LOWER LEFT;So;0;ON;;;;;N;;;;;
259F;QUADRANT UPPER RIGHT AND LOWER LEFT AND LOWER RIGHT;So;0;ON;;;;;N;;;;;
25A0;BLACK SQUARE;So;0;ON;;;;;N;;;;;
25A1;WHITE SQUARE;So;0;ON;;;;;N;;;;;
25A2;WHITE SQUARE WITH ROUNDED CORNERS;So;0;ON;;;;;N;;;;;
25A3;WHITE SQUARE CONTAINING BLACK SMALL SQUARE;So;0;ON;;;;;N;;;;;
25A4;SQUARE WITH HORIZONTAL FILL;So;0;ON;;;;;N;;;;;
25A5;SQUARE WITH VERTICAL FILL;So;0;ON;;;;;N;;;;;
25A6;SQUARE WITH ORTHOGONAL CROSSHATCH FILL;So;0;ON;;;;;N;;;;;
25A7;SQUARE WITH UPPER LEFT TO LOWER RIGHT FILL;So;0;ON;;;;;N;;;;;
25A8;SQUARE WITH UPPER RIGHT TO LOWER LEFT FILL;So;0;ON;;;;;N;;;;;
25A9;SQUARE WITH DIAGONAL CROSSHATCH FILL;So;0;ON;;;;;N;;;;;
25AA;BLACK SMALL SQUARE;So;0;ON;;;;;N;;;;;
25AB;WHITE SMALL SQUARE;So;0;ON;;;;;N;;;;;
25AC;BLACK RECTANGLE;So;0;ON;;;;;N;;;;;
25AD;WHITE RECTANGLE;So;0;ON;;;;;N;;;;;
25AE;BLACK VERTICAL RECTANGLE;So;0;ON;;;;;N;;;;;
25AF;WHITE VERTICAL RECTANGLE;So;0;ON;;;;;N;;;;;
25B0;BLACK PARALLELOGRAM;So;0;ON;;;;;N;;;;;
25B1;WHITE PARALLELOGRAM;So;0;ON;;;;;N;;;;;
25B2;BLACK UP-POINTING TRIANGLE;So;0;ON;;;;;N;BLACK UP POINTING TRIANGLE;;;;
25B3;WHITE UP-POINTING TRIANGLE;So;0;ON;;;;;N;WHITE UP POINTING TRIANGLE;;;;
25B4;BLACK UP-POINTING SMALL TRIANGLE;So;0;ON;;;;;N;BLACK UP POINTING SMALL TRIANGLE;;;;
25B5;WHITE UP-POINTING SMALL TRIANGLE;So;0;ON;;;;;N;WHITE UP POINTING SMALL TRIANGLE;;;;
25B6;BLACK RIGHT-POINTING TRIANGLE;So;0;ON;;;;;N;BLACK RIGHT POINTING TRIANGLE;;;;
25B7;WHITE RIGHT-POINTING TRIANGLE;Sm;0;ON;;;;;N;WHITE RIGHT POINTING TRIANGLE;;;;
25B8;BLACK RIGHT-POINTING SMALL TRIANGLE;So;0;ON;;;;;N;BLACK RIGHT POINTING SMALL TRIANGLE;;;;
25B9;WHITE RIGHT-POINTING SMALL TRIANGLE;So;0;ON;;;;;N;WHITE RIGHT POINTING SMALL TRIANGLE;;;;
25BA;BLACK RIGHT-POINTING POINTER;So;0;ON;;;;;N;BLACK RIGHT POINTING POINTER;;;;
25BB;WHITE RIGHT-POINTING POINTER;So;0;ON;;;;;N;WHITE RIGHT POINTING POINTER;;;;
25BC;BLACK DOWN-POINTING TRIANGLE;So;0;ON;;;;;N;BLACK DOWN POINTING TRIANGLE;;;;
25BD;WHITE DOWN-POINTING TRIANGLE;So;0;ON;;;;;N;WHITE DOWN POINTING TRIANGLE;;;;
25BE;BLACK DOWN-POINTING SMALL TRIANGLE;So;0;ON;;;;;N;BLACK DOWN POINTING SMALL TRIANGLE;;;;
25BF;WHITE DOWN-POINTING SMALL TRIANGLE;So;0;ON;;;;;N;WHITE DOWN POINTING SMALL TRIANGLE;;;;
25C0;BLACK LEFT-POINTING TRIANGLE;So;0;ON;;;;;N;BLACK LEFT POINTING TRIANGLE;;;;
25C1;WHITE LEFT-POINTING TRIANGLE;Sm;0;ON;;;;;N;WHITE LEFT POINTING TRIANGLE;;;;
25C2;BLACK LEFT-POINTING SMALL TRIANGLE;So;0;ON;;;;;N;BLACK LEFT POINTING SMALL TRIANGLE;;;;
25C3;WHITE LEFT-POINTING SMALL TRIANGLE;So;0;ON;;;;;N;WHITE LEFT POINTING SMALL TRIANGLE;;;;
25C4;BLACK LEFT-POINTING POINTER;So;0;ON;;;;;N;BLACK LEFT POINTING POINTER;;;;
25C5;WHITE LEFT-POINTING POINTER;So;0;ON;;;;;N;WHITE LEFT POINTING POINTER;;;;
25C6;BLACK DIAMOND;So;0;ON;;;;;N;;;;;
25C7;WHITE DIAMOND;So;0;ON;;;;;N;;;;;
25C8;WHITE DIAMOND CONTAINING BLACK SMALL DIAMOND;So;0;ON;;;;;N;;;;;
25C9;FISHEYE;So;0;ON;;;;;N;;;;;
25CA;LOZENGE;So;0;ON;;;;;N;;;;;
25CB;WHITE CIRCLE;So;0;ON;;;;;N;;;;;
25CC;DOTTED CIRCLE;So;0;ON;;;;;N;;;;;
25CD;CIRCLE WITH VERTICAL FILL;So;0;ON;;;;;N;;;;;
25CE;BULLSEYE;So;0;ON;;;;;N;;;;;
25CF;BLACK CIRCLE;So;0;ON;;;;;N;;;;;
25D0;CIRCLE WITH LEFT HALF BLACK;So;0;ON;;;;;N;;;;;
25D1;CIRCLE WITH RIGHT HALF BLACK;So;0;ON;;;;;N;;;;;
25D2;CIRCLE WITH LOWER HALF BLACK;So;0;ON;;;;;N;;;;;
25D3;CIRCLE WITH UPPER HALF BLACK;So;0;ON;;;;;N;;;;;
25D4;CIRCLE WITH UPPER RIGHT QUADRANT BLACK;So;0;ON;;;;;N;;;;;
25D5;CIRCLE WITH ALL BUT UPPER LEFT QUADRANT BLACK;So;0;ON;;;;;N;;;;;
25D6;LEFT HALF BLACK CIRCLE;So;0;ON;;;;;N;;;;;
25D7;RIGHT HALF BLACK CIRCLE;So;0;ON;;;;;N;;;;;
25D8;INVERSE BULLET;So;0;ON;;;;;N;;;;;
25D9;INVERSE WHITE CIRCLE;So;0;ON;;;;;N;;;;;
25DA;UPPER HALF INVERSE WHITE CIRCLE;So;0;ON;;;;;N;;;;;
25DB;LOWER HALF INVERSE WHITE CIRCLE;So;0;ON;;;;;N;;;;;
25DC;UPPER LEFT QUADRANT CIRCULAR ARC;So;0;ON;;;;;N;;;;;
25DD;UPPER RIGHT QUADRANT CIRCULAR ARC;So;0;ON;;;;;N;;;;;
25DE;LOWER RIGHT QUADRANT CIRCULAR ARC;So;0;ON;;;;;N;;;;;
25DF;LOWER LEFT QUADRANT CIRCULAR ARC;So;0;ON;;;;;N;;;;;
25E0;UPPER HALF CIRCLE;So;0;ON;;;;;N;;;;;
25E1;LOWER HALF CIRCLE;So;0;ON;;;;;N;;;;;
25E2;BLACK LOWER RIGHT TRIANGLE;So;0;ON;;;;;N;;;;;
25E3;BLACK LOWER LEFT TRIANGLE;So;0;ON;;;;;N;;;;;
25E4;BLACK UPPER LEFT TRIANGLE;So;0;ON;;;;;N;;;;;
25E5;BLACK UPPER RIGHT TRIANGLE;So;0;ON;;;;;N;;;;;
25E6;WHITE BULLET;So;0;ON;;;;;N;;;;;
25E7;SQUARE WITH LEFT HALF BLACK;So;0;ON;;;;;N;;;;;
25E8;SQUARE WITH RIGHT HALF BLACK;So;0;ON;;;;;N;;;;;
25E9;SQUARE WITH UPPER LEFT DIAGONAL HALF BLACK;So;0;ON;;;;;N;;;;;
25EA;SQUARE WITH LOWER RIGHT DIAGONAL HALF BLACK;So;0;ON;;;;;N;;;;;
25EB;WHITE SQUARE WITH VERTICAL BISECTING LINE;So;0;ON;;;;;N;;;;;
25EC;WHITE UP-POINTING TRIANGLE WITH DOT;So;0;ON;;;;;N;WHITE UP POINTING TRIANGLE WITH DOT;;;;
25ED;UP-POINTING TRIANGLE WITH LEFT HALF BLACK;So;0;ON;;;;;N;UP POINTING TRIANGLE WITH LEFT HALF BLACK;;;;
25EE;UP-POINTING TRIANGLE WITH RIGHT HALF BLACK;So;0;ON;;;;;N;UP POINTING TRIANGLE WITH RIGHT HALF BLACK;;;;
25EF;LARGE CIRCLE;So;0;ON;;;;;N;;;;;
25F0;WHITE SQUARE WITH UPPER LEFT QUADRANT;So;0;ON;;;;;N;;;;;
25F1;WHITE SQUARE WITH LOWER LEFT QUADRANT;So;0;ON;;;;;N;;;;;
25F2;WHITE SQUARE WITH LOWER RIGHT QUADRANT;So;0;ON;;;;;N;;;;;
25F3;WHITE SQUARE WITH UPPER RIGHT QUADRANT;So;0;ON;;;;;N;;;;;
25F4;WHITE CIRCLE WITH UPPER LEFT QUADRANT;So;0;ON;;;;;N;;;;;
25F5;WHITE CIRCLE WITH LOWER LEFT QUADRANT;So;0;ON;;;;;N;;;;;
25F6;WHITE CIRCLE WITH LOWER RIGHT QUADRANT;So;0;ON;;;;;N;;;;;
25F7;WHITE CIRCLE WITH UPPER RIGHT QUADRANT;So;0;ON;;;;;N;;;;;
25F8;UPPER LEFT TRIANGLE;Sm;0;ON;;;;;N;;;;;
25F9;UPPER RIGHT TRIANGLE;Sm;0;ON;;;;;N;;;;;
25FA;LOWER LEFT TRIANGLE;Sm;0;ON;;;;;N;;;;;
25FB;WHITE MEDIUM SQUARE;Sm;0;ON;;;;;N;;;;;
25FC;BLACK MEDIUM SQUARE;Sm;0;ON;;;;;N;;;;;
25FD;WHITE MEDIUM SMALL SQUARE;Sm;0;ON;;;;;N;;;;;
25FE;BLACK MEDIUM SMALL SQUARE;Sm;0;ON;;;;;N;;;;;
25FF;LOWER RIGHT TRIANGLE;Sm;0;ON;;;;;N;;;;;
2600;BLACK SUN WITH RAYS;So;0;ON;;;;;N;;;;;
2601;CLOUD;So;0;ON;;;;;N;;;;;
2602;UMBRELLA;So;0;ON;;;;;N;;;;;
2603;SNOWMAN;So;0;ON;;;;;N;;;;;
2604;COMET;So;0;ON;;;;;N;;;;;
2605;BLACK STAR;So;0;ON;;;;;N;;;;;
2606;WHITE STAR;So;0;ON;;;;;N;;;;;
2607;LIGHTNING;So;0;ON;;;;;N;;;;;
2608;THUNDERSTORM;So;0;ON;;;;;N;;;;;
2609;SUN;So;0;ON;;;;;N;;;;;
260A;ASCENDING NODE;So;0;ON;;;;;N;;;;;
260B;DESCENDING NODE;So;0;ON;;;;;N;;;;;
260C;CONJUNCTION;So;0;ON;;;;;N;;;;;
260D;OPPOSITION;So;0;ON;;;;;N;;;;;
260E;BLACK TELEPHONE;So;0;ON;;;;;N;;;;;
260F;WHITE TELEPHONE;So;0;ON;;;;;N;;;;;
2610;BALLOT BOX;So;0;ON;;;;;N;;;;;
2611;BALLOT BOX WITH CHECK;So;0;ON;;;;;N;;;;;
2612;BALLOT BOX WITH X;So;0;ON;;;;;N;;;;;
2613;SALTIRE;So;0;ON;;;;;N;;;;;
2614;UMBRELLA WITH RAIN DROPS;So;0;ON;;;;;N;;;;;
2615;HOT BEVERAGE;So;0;ON;;;;;N;;;;;
2616;WHITE SHOGI PIECE;So;0;ON;;;;;N;;;;;
2617;BLACK SHOGI PIECE;So;0;ON;;;;;N;;;;;
2618;SHAMROCK;So;0;ON;;;;;N;;;;;
2619;REVERSED ROTATED FLORAL HEART BULLET;So;0;ON;;;;;N;;;;;
261A;BLACK LEFT POINTING INDEX;So;0;ON;;;;;N;;;;;
261B;BLACK RIGHT POINTING INDEX;So;0;ON;;;;;N;;;;;
261C;WHITE LEFT POINTING INDEX;So;0;ON;;;;;N;;;;;
261D;WHITE UP POINTING INDEX;So;0;ON;;;;;N;;;;;
261E;WHITE RIGHT POINTING INDEX;So;0;ON;;;;;N;;;;;
261F;WHITE DOWN POINTING INDEX;So;0;ON;;;;;N;;;;;
2620;SKULL AND CROSSBONES;So;0;ON;;;;;N;;;;;
2621;CAUTION SIGN;So;0;ON;;;;;N;;;;;
2622;RADIOACTIVE SIGN;So;0;ON;;;;;N;;;;;
2623;BIOHAZARD SIGN;So;0;ON;;;;;N;;;;;
2624;CADUCEUS;So;0;ON;;;;;N;;;;;
2625;ANKH;So;0;ON;;;;;N;;;;;
2626;ORTHODOX CROSS;So;0;ON;;;;;N;;;;;
2627;CHI RHO;So;0;ON;;;;;N;;;;;
2628;CROSS OF LORRAINE;So;0;ON;;;;;N;;;;;
2629;CROSS OF JERUSALEM;So;0;ON;;;;;N;;;;;
262A;STAR AND CRESCENT;So;0;ON;;;;;N;;;;;
262B;FARSI SYMBOL;So;0;ON;;;;;N;SYMBOL OF IRAN;;;;
262C;ADI SHAKTI;So;0;ON;;;;;N;;;;;
262D;HAMMER AND SICKLE;So;0;ON;;;;;N;;;;;
262E;PEACE SYMBOL;So;0;ON;;;;;N;;;;;
262F;YIN YANG;So;0;ON;;;;;N;;;;;
2630;TRIGRAM FOR HEAVEN;So;0;ON;;;;;N;;;;;
2631;TRIGRAM FOR LAKE;So;0;ON;;;;;N;;;;;
2632;TRIGRAM FOR FIRE;So;0;ON;;;;;N;;;;;
2633;TRIGRAM FOR THUNDER;So;0;ON;;;;;N;;;;;
2634;TRIGRAM FOR WIND;So;0;ON;;;;;N;;;;;
2635;TRIGRAM FOR WATER;So;0;ON;;;;;N;;;;;
2636;TRIGRAM FOR MOUNTAIN;So;0;ON;;;;;N;;;;;
2637;TRIGRAM FOR EARTH;So;0;ON;;;;;N;;;;;
2638;WHEEL OF DHARMA;So;0;ON;;;;;N;;;;;
2639;WHITE FROWNING FACE;So;0;ON;;;;;N;;;;;
263A;WHITE SMILING FACE;So;0;ON;;;;;N;;;;;
263B;BLACK SMILING FACE;So;0;ON;;;;;N;;;;;
263C;WHITE SUN WITH RAYS;So;0;ON;;;;;N;;;;;
263D;FIRST QUARTER MOON;So;0;ON;;;;;N;;;;;
263E;LAST QUARTER MOON;So;0;ON;;;;;N;;;;;
263F;MERCURY;So;0;ON;;;;;N;;;;;
2640;FEMALE SIGN;So;0;ON;;;;;N;;;;;
2641;EARTH;So;0;ON;;;;;N;;;;;
2642;MALE SIGN;So;0;ON;;;;;N;;;;;
2643;JUPITER;So;0;ON;;;;;N;;;;;
2644;SATURN;So;0;ON;;;;;N;;;;;
2645;URANUS;So;0;ON;;;;;N;;;;;
2646;NEPTUNE;So;0;ON;;;;;N;;;;;
2647;PLUTO;So;0;ON;;;;;N;;;;;
2648;ARIES;So;0;ON;;;;;N;;;;;
2649;TAURUS;So;0;ON;;;;;N;;;;;
264A;GEMINI;So;0;ON;;;;;N;;;;;
264B;CANCER;So;0;ON;;;;;N;;;;;
264C;LEO;So;0;ON;;;;;N;;;;;
264D;VIRGO;So;0;ON;;;;;N;;;;;
264E;LIBRA;So;0;ON;;;;;N;;;;;
264F;SCORPIUS;So;0;ON;;;;;N;;;;;
2650;SAGITTARIUS;So;0;ON;;;;;N;;;;;
2651;CAPRICORN;So;0;ON;;;;;N;;;;;
2652;AQUARIUS;So;0;ON;;;;;N;;;;;
2653;PISCES;So;0;ON;;;;;N;;;;;
2654;WHITE CHESS KING;So;0;ON;;;;;N;;;;;
2655;WHITE CHESS QUEEN;So;0;ON;;;;;N;;;;;
2656;WHITE CHESS ROOK;So;0;ON;;;;;N;;;;;
2657;WHITE CHESS BISHOP;So;0;ON;;;;;N;;;;;
2658;WHITE CHESS KNIGHT;So;0;ON;;;;;N;;;;;
2659;WHITE CHESS PAWN;So;0;ON;;;;;N;;;;;
265A;BLACK CHESS KING;So;0;ON;;;;;N;;;;;
265B;BLACK CHESS QUEEN;So;0;ON;;;;;N;;;;;
265C;BLACK CHESS ROOK;So;0;ON;;;;;N;;;;;
265D;BLACK CHESS BISHOP;So;0;ON;;;;;N;;;;;
265E;BLACK CHESS KNIGHT;So;0;ON;;;;;N;;;;;
265F;BLACK CHESS PAWN;So;0;ON;;;;;N;;;;;
2660;BLACK SPADE SUIT;So;0;ON;;;;;N;;;;;
2661;WHITE HEART SUIT;So;0;ON;;;;;N;;;;;
2662;WHITE DIAMOND SUIT;So;0;ON;;;;;N;;;;;
2663;BLACK CLUB SUIT;So;0;ON;;;;;N;;;;;
2664;WHITE SPADE SUIT;So;0;ON;;;;;N;;;;;
2665;BLACK HEART SUIT;So;0;ON;;;;;N;;;;;
2666;BLACK DIAMOND SUIT;So;0;ON;;;;;N;;;;;
2667;WHITE CLUB SUIT;So;0;ON;;;;;N;;;;;
2668;HOT SPRINGS;So;0;ON;;;;;N;;;;;
2669;QUARTER NOTE;So;0;ON;;;;;N;;;;;
266A;EIGHTH NOTE;So;0;ON;;;;;N;;;;;
266B;BEAMED EIGHTH NOTES;So;0;ON;;;;;N;BARRED EIGHTH NOTES;;;;
266C;BEAMED SIXTEENTH NOTES;So;0;ON;;;;;N;BARRED SIXTEENTH NOTES;;;;
266D;MUSIC FLAT SIGN;So;0;ON;;;;;N;FLAT;;;;
266E;MUSIC NATURAL SIGN;So;0;ON;;;;;N;NATURAL;;;;
266F;MUSIC SHARP SIGN;Sm;0;ON;;;;;N;SHARP;;;;
2670;WEST SYRIAC CROSS;So;0;ON;;;;;N;;;;;
2671;EAST SYRIAC CROSS;So;0;ON;;;;;N;;;;;
2672;UNIVERSAL RECYCLING SYMBOL;So;0;ON;;;;;N;;;;;
2673;RECYCLING SYMBOL FOR TYPE-1 PLASTICS;So;0;ON;;;;;N;;;;;
2674;RECYCLING SYMBOL FOR TYPE-2 PLASTICS;So;0;ON;;;;;N;;;;;
2675;RECYCLING SYMBOL FOR TYPE-3 PLASTICS;So;0;ON;;;;;N;;;;;
2676;RECYCLING SYMBOL FOR TYPE-4 PLASTICS;So;0;ON;;;;;N;;;;;
2677;RECYCLING SYMBOL FOR TYPE-5 PLASTICS;So;0;ON;;;;;N;;;;;
2678;RECYCLING SYMBOL FOR TYPE-6 PLASTICS;So;0;ON;;;;;N;;;;;
2679;RECYCLING SYMBOL FOR TYPE-7 PLASTICS;So;0;ON;;;;;N;;;;;
267A;RECYCLING SYMBOL FOR GENERIC MATERIALS;So;0;ON;;;;;N;;;;;
267B;BLACK UNIVERSAL RECYCLING SYMBOL;So;0;ON;;;;;N;;;;;
267C;RECYCLED PAPER SYMBOL;So;0;ON;;;;;N;;;;;
267D;PARTIALLY-RECYCLED PAPER SYMBOL;So;0;ON;;;;;N;;;;;
267E;PERMANENT PAPER SIGN;So;0;ON;;;;;N;;;;;
267F;WHEELCHAIR SYMBOL;So;0;ON;;;;;N;;;;;
2680;DIE FACE-1;So;0;ON;;;;;N;;;;;
2681;DIE FACE-2;So;0;ON;;;;;N;;;;;
2682;DIE FACE-3;So;0;ON;;;;;N;;;;;
2683;DIE FACE-4;So;0;ON;;;;;N;;;;;
2684;DIE FACE-5;So;0;ON;;;;;N;;;;;
2685;DIE FACE-6;So;0;ON;;;;;N;;;;;
2686;WHITE CIRCLE WITH DOT RIGHT;So;0;ON;;;;;N;;;;;
2687;WHITE CIRCLE WITH TWO DOTS;So;0;ON;;;;;N;;;;;
2688;BLACK CIRCLE WITH WHITE DOT RIGHT;So;0;ON;;;;;N;;;;;
2689;BLACK CIRCLE WITH TWO WHITE DOTS;So;0;ON;;;;;N;;;;;
268A;MONOGRAM FOR YANG;So;0;ON;;;;;N;;;;;
268B;MONOGRAM FOR YIN;So;0;ON;;;;;N;;;;;
268C;DIGRAM FOR GREATER YANG;So;0;ON;;;;;N;;;;;
268D;DIGRAM FOR LESSER YIN;So;0;ON;;;;;N;;;;;
268E;DIGRAM FOR LESSER YANG;So;0;ON;;;;;N;;;;;
268F;DIGRAM FOR GREATER YIN;So;0;ON;;;;;N;;;;;
2690;WHITE FLAG;So;0;ON;;;;;N;;;;;
2691;BLACK FLAG;So;0;ON;;;;;N;;;;;
2692;HAMMER AND PICK;So;0;ON;;;;;N;;;;;
2693;ANCHOR;So;0;ON;;;;;N;;;;;
2694;CROSSED SWORDS;So;0;ON;;;;;N;;;;;
2695;STAFF OF AESCULAPIUS;So;0;ON;;;;;N;;;;;
2696;SCALES;So;0;ON;;;;;N;;;;;
2697;ALEMBIC;So;0;ON;;;;;N;;;;;
2698;FLOWER;So;0;ON;;;;;N;;;;;
2699;GEAR;So;0;ON;;;;;N;;;;;
269A;STAFF OF HERMES;So;0;ON;;;;;N;;;;;
269B;ATOM SYMBOL;So;0;ON;;;;;N;;;;;
269C;FLEUR-DE-LIS;So;0;ON;;;;;N;;;;;
269D;OUTLINED WHITE STAR;So;0;ON;;;;;N;;;;;
269E;THREE LINES CONVERGING RIGHT;So;0;ON;;;;;N;;;;;
269F;THREE LINES CONVERGING LEFT;So;0;ON;;;;;N;;;;;
26A0;WARNING SIGN;So;0;ON;;;;;N;;;;;
26A1;HIGH VOLTAGE SIGN;So;0;ON;;;;;N;;;;;
26A2;DOUBLED FEMALE SIGN;So;0;ON;;;;;N;;;;;
26A3;DOUBLED MALE SIGN;So;0;ON;;;;;N;;;;;
26A4;INTERLOCKED FEMALE AND MALE SIGN;So;0;ON;;;;;N;;;;;
26A5;MALE AND FEMALE SIGN;So;0;ON;;;;;N;;;;;
26A6;MALE WITH STROKE SIGN;So;0;ON;;;;;N;;;;;
26A7;MALE WITH STROKE AND MALE AND FEMALE SIGN;So;0;ON;;;;;N;;;;;
26A8;VERTICAL MALE WITH STROKE SIGN;So;0;ON;;;;;N;;;;;
26A9;HORIZONTAL MALE WITH STROKE SIGN;So;0;ON;;;;;N;;;;;
26AA;MEDIUM WHITE CIRCLE;So;0;ON;;;;;N;;;;;
26AB;MEDIUM BLACK CIRCLE;So;0;ON;;;;;N;;;;;
26AC;MEDIUM SMALL WHITE CIRCLE;So;0;L;;;;;N;;;;;
26AD;MARRIAGE SYMBOL;So;0;ON;;;;;N;;;;;
26AE;DIVORCE SYMBOL;So;0;ON;;;;;N;;;;;
26AF;UNMARRIED PARTNERSHIP SYMBOL;So;0;ON;;;;;N;;;;;
26B0;COFFIN;So;0;ON;;;;;N;;;;;
26B1;FUNERAL URN;So;0;ON;;;;;N;;;;;
26B2;NEUTER;So;0;ON;;;;;N;;;;;
26B3;CERES;So;0;ON;;;;;N;;;;;
26B4;PALLAS;So;0;ON;;;;;N;;;;;
26B5;JUNO;So;0;ON;;;;;N;;;;;
26B6;VESTA;So;0;ON;;;;;N;;;;;
26B7;CHIRON;So;0;ON;;;;;N;;;;;
26B8;BLACK MOON LILITH;So;0;ON;;;;;N;;;;;
26B9;SEXTILE;So;0;ON;;;;;N;;;;;
26BA;SEMISEXTILE;So;0;ON;;;;;N;;;;;
26BB;QUINCUNX;So;0;ON;;;;;N;;;;;
26BC;SESQUIQUADRATE;So;0;ON;;;;;N;;;;;
26BD;SOCCER BALL;So;0;ON;;;;;N;;;;;
26BE;BASEBALL;So;0;ON;;;;;N;;;;;
26BF;SQUARED KEY;So;0;ON;;;;;N;;;;;
26C0;WHITE DRAUGHTS MAN;So;0;ON;;;;;N;;;;;
26C1;WHITE DRAUGHTS KING;So;0;ON;;;;;N;;;;;
26C2;BLACK DRAUGHTS MAN;So;0;ON;;;;;N;;;;;
26C3;BLACK DRAUGHTS KING;So;0;ON;;;;;N;;;;;
26C4;SNOWMAN WITHOUT SNOW;So;0;ON;;;;;N;;;;;
26C5;SUN BEHIND CLOUD;So;0;ON;;;;;N;;;;;
26C6;RAIN;So;0;ON;;;;;N;;;;;
26C7;BLACK SNOWMAN;So;0;ON;;;;;N;;;;;
26C8;THUNDER CLOUD AND RAIN;So;0;ON;;;;;N;;;;;
26C9;TURNED WHITE SHOGI PIECE;So;0;ON;;;;;N;;;;;
26CA;TURNED BLACK SHOGI PIECE;So;0;ON;;;;;N;;;;;
26CB;WHITE DIAMOND IN SQUARE;So;0;ON;;;;;N;;;;;
26CC;CROSSING LANES;So;0;ON;;;;;N;;;;;
26CD;DISABLED CAR;So;0;ON;;;;;N;;;;;
26CE;OPHIUCHUS;So;0;ON;;;;;N;;;;;
26CF;PICK;So;0;ON;;;;;N;;;;;
26D0;CAR SLIDING;So;0;ON;;;;;N;;;;;
26D1;HELMET WITH WHITE CROSS;So;0;ON;;;;;N;;;;;
26D2;CIRCLED CROSSING LANES;So;0;ON;;;;;N;;;;;
26D3;CHAINS;So;0;ON;;;;;N;;;;;
26D4;NO ENTRY;So;0;ON;;;;;N;;;;;
26D5;ALTERNATE ONE-WAY LEFT WAY TRAFFIC;So;0;ON;;;;;N;;;;;
26D6;BLACK TWO-WAY LEFT WAY TRAFFIC;So;0;ON;;;;;N;;;;;
26D7;WHITE TWO-WAY LEFT WAY TRAFFIC;So;0;ON;;;;;N;;;;;
26D8;BLACK LEFT LANE MERGE;So;0;ON;;;;;N;;;;;
26D9;WHITE LEFT LANE MERGE;So;0;ON;;;;;N;;;;;
26DA;DRIVE SLOW SIGN;So;0;ON;;;;;N;;;;;
26DB;HEAVY WHITE DOWN-POINTING TRIANGLE;So;0;ON;;;;;N;;;;;
26DC;LEFT CLOSED ENTRY;So;0;ON;;;;;N;;;;;
26DD;SQUARED SALTIRE;So;0;ON;;;;;N;;;;;
26DE;FALLING DIAGONAL IN WHITE CIRCLE IN BLACK SQUARE;So;0;ON;;;;;N;;;;;
26DF;BLACK TRUCK;So;0;ON;;;;;N;;;;;
26E0;RESTRICTED LEFT ENTRY-1;So;0;ON;;;;;N;;;;;
26E1;RESTRICTED LEFT ENTRY-2;So;0;ON;;;;;N;;;;;
26E2;ASTRONOMICAL SYMBOL FOR URANUS;So;0;ON;;;;;N;;;;;
26E3;HEAVY CIRCLE WITH STROKE AND TWO DOTS ABOVE;So;0;ON;;;;;N;;;;;
26E4;PENTAGRAM;So;0;ON;;;;;N;;;;;
26E5;RIGHT-HANDED INTERLACED PENTAGRAM;So;0;ON;;;;;N;;;;;
26E6;LEFT-HANDED INTERLACED PENTAGRAM;So;0;ON;;;;;N;;;;;
26E7;INVERTED PENTAGRAM;So;0;ON;;;;;N;;;;;
26E8;BLACK CROSS ON SHIELD;So;0;ON;;;;;N;;;;;
26E9;SHINTO SHRINE;So;0;ON;;;;;N;;;;;
26EA;CHURCH;So;0;ON;;;;;N;;;;;
26EB;CASTLE;So;0;ON;;;;;N;;;;;
26EC;HISTORIC SITE;So;0;ON;;;;;N;;;;;
26ED;GEAR WITHOUT HUB;So;0;ON;;;;;N;;;;;
26EE;GEAR WITH HANDLES;So;0;ON;;;;;N;;;;;
26EF;MAP SYMBOL FOR LIGHTHOUSE;So;0;ON;;;;;N;;;;;
26F0;MOUNTAIN;So;0;ON;;;;;N;;;;;
26F1;UMBRELLA ON GROUND;So;0;ON;;;;;N;;;;;
26F2;FOUNTAIN;So;0;ON;;;;;N;;;;;
26F3;FLAG IN HOLE;So;0;ON;;;;;N;;;;;
26F4;FERRY;So;0;ON;;;;;N;;;;;
26F5;SAILBOAT;So;0;ON;;;;;N;;;;;
26F6;SQUARE FOUR CORNERS;So;0;ON;;;;;N;;;;;
26F7;SKIER;So;0;ON;;;;;N;;;;;
26F8;ICE SKATE;So;0;ON;;;;;N;;;;;
26F9;PERSON WITH BALL;So;0;ON;;;;;N;;;;;
26FA;TENT;So;0;ON;;;;;N;;;;;
26FB;JAPANESE BANK SYMBOL;So;0;ON;;;;;N;;;;;
26FC;HEADSTONE GRAVEYARD SYMBOL;So;0;ON;;;;;N;;;;;
26FD;FUEL PUMP;So;0;ON;;;;;N;;;;;
26FE;CUP ON BLACK SQUARE;So;0;ON;;;;;N;;;;;
26FF;WHITE FLAG WITH HORIZONTAL MIDDLE BLACK STRIPE;So;0;ON;;;;;N;;;;;
2700;BLACK SAFETY SCISSORS;So;0;ON;;;;;N;;;;;
2701;UPPER BLADE SCISSORS;So;0;ON;;;;;N;;;;;
2702;BLACK SCISSORS;So;0;ON;;;;;N;;;;;
2703;LOWER BLADE SCISSORS;So;0;ON;;;;;N;;;;;
2704;WHITE SCISSORS;So;0;ON;;;;;N;;;;;
2705;WHITE HEAVY CHECK MARK;So;0;ON;;;;;N;;;;;
2706;TELEPHONE LOCATION SIGN;So;0;ON;;;;;N;;;;;
2707;TAPE DRIVE;So;0;ON;;;;;N;;;;;
2708;AIRPLANE;So;0;ON;;;;;N;;;;;
2709;ENVELOPE;So;0;ON;;;;;N;;;;;
270A;RAISED FIST;So;0;ON;;;;;N;;;;;
270B;RAISED HAND;So;0;ON;;;;;N;;;;;
270C;VICTORY HAND;So;0;ON;;;;;N;;;;;
270D;WRITING HAND;So;0;ON;;;;;N;;;;;
270E;LOWER RIGHT PENCIL;So;0;ON;;;;;N;;;;;
270F;PENCIL;So;0;ON;;;;;N;;;;;
2710;UPPER RIGHT PENCIL;So;0;ON;;;;;N;;;;;
2711;WHITE NIB;So;0;ON;;;;;N;;;;;
2712;BLACK NIB;So;0;ON;;;;;N;;;;;
2713;CHECK MARK;So;0;ON;;;;;N;;;;;
2714;HEAVY CHECK MARK;So;0;ON;;;;;N;;;;;
2715;MULTIPLICATION X;So;0;ON;;;;;N;;;;;
2716;HEAVY MULTIPLICATION X;So;0;ON;;;;;N;;;;;
2717;BALLOT X;So;0;ON;;;;;N;;;;;
2718;HEAVY BALLOT X;So;0;ON;;;;;N;;;;;
2719;OUTLINED GREEK CROSS;So;0;ON;;;;;N;;;;;
271A;HEAVY GREEK CROSS;So;0;ON;;;;;N;;;;;
271B;OPEN CENTRE CROSS;So;0;ON;;;;;N;OPEN CENTER CROSS;;;;
271C;HEAVY OPEN CENTRE CROSS;So;0;ON;;;;;N;HEAVY OPEN CENTER CROSS;;;;
271D;LATIN CROSS;So;0;ON;;;;;N;;;;;
271E;SHADOWED WHITE LATIN CROSS;So;0;ON;;;;;N;;;;;
271F;OUTLINED LATIN CROSS;So;0;ON;;;;;N;;;;;
2720;MALTESE CROSS;So;0;ON;;;;;N;;;;;
2721;STAR OF DAVID;So;0;ON;;;;;N;;;;;
2722;FOUR TEARDROP-SPOKED ASTERISK;So;0;ON;;;;;N;;;;;
2723;FOUR BALLOON-SPOKED ASTERISK;So;0;ON;;;;;N;;;;;
2724;HEAVY FOUR BALLOON-SPOKED ASTERISK;So;0;ON;;;;;N;;;;;
2725;FOUR CLUB-SPOKED ASTERISK;So;0;ON;;;;;N;;;;;
2726;BLACK FOUR POINTED STAR;So;0;ON;;;;;N;;;;;
2727;WHITE FOUR POINTED STAR;So;0;ON;;;;;N;;;;;
2728;SPARKLES;So;0;ON;;;;;N;;;;;
2729;STRESS OUTLINED WHITE STAR;So;0;ON;;;;;N;;;;;
272A;CIRCLED WHITE STAR;So;0;ON;;;;;N;;;;;
272B;OPEN CENTRE BLACK STAR;So;0;ON;;;;;N;OPEN CENTER BLACK STAR;;;;
272C;BLACK CENTRE WHITE STAR;So;0;ON;;;;;N;BLACK CENTER WHITE STAR;;;;
272D;OUTLINED BLACK STAR;So;0;ON;;;;;N;;;;;
272E;HEAVY OUTLINED BLACK STAR;So;0;ON;;;;;N;;;;;
272F;PINWHEEL STAR;So;0;ON;;;;;N;;;;;
2730;SHADOWED WHITE STAR;So;0;ON;;;;;N;;;;;
2731;HEAVY ASTERISK;So;0;ON;;;;;N;;;;;
2732;OPEN CENTRE ASTERISK;So;0;ON;;;;;N;OPEN CENTER ASTERISK;;;;
2733;EIGHT SPOKED ASTERISK;So;0;ON;;;;;N;;;;;
2734;EIGHT POINTED BLACK STAR;So;0;ON;;;;;N;;;;;
2735;EIGHT POINTED PINWHEEL STAR;So;0;ON;;;;;N;;;;;
2736;SIX POINTED BLACK STAR;So;0;ON;;;;;N;;;;;
2737;EIGHT POINTED RECTILINEAR BLACK STAR;So;0;ON;;;;;N;;;;;
2738;HEAVY EIGHT POINTED RECTILINEAR BLACK STAR;So;0;ON;;;;;N;;;;;
2739;TWELVE POINTED BLACK STAR;So;0;ON;;;;;N;;;;;
273A;SIXTEEN POINTED ASTERISK;So;0;ON;;;;;N;;;;;
273B;TEARDROP-SPOKED ASTERISK;So;0;ON;;;;;N;;;;;
273C;OPEN CENTRE TEARDROP-SPOKED ASTERISK;So;0;ON;;;;;N;OPEN CENTER TEARDROP-SPOKED ASTERISK;;;;
273D;HEAVY TEARDROP-SPOKED ASTERISK;So;0;ON;;;;;N;;;;;
273E;SIX PETALLED BLACK AND WHITE FLORETTE;So;0;ON;;;;;N;;;;;
273F;BLACK FLORETTE;So;0;ON;;;;;N;;;;;
2740;WHITE FLORETTE;So;0;ON;;;;;N;;;;;
2741;EIGHT PETALLED OUTLINED BLACK FLORETTE;So;0;ON;;;;;N;;;;;
2742;CIRCLED OPEN CENTRE EIGHT POINTED STAR;So;0;ON;;;;;N;CIRCLED OPEN CENTER EIGHT POINTED STAR;;;;
2743;HEAVY TEARDROP-SPOKED PINWHEEL ASTERISK;So;0;ON;;;;;N;;;;;
2744;SNOWFLAKE;So;0;ON;;;;;N;;;;;
2745;TIGHT TRIFOLIATE SNOWFLAKE;So;0;ON;;;;;N;;;;;
2746;HEAVY CHEVRON SNOWFLAKE;So;0;ON;;;;;N;;;;;
2747;SPARKLE;So;0;ON;;;;;N;;;;;
2748;HEAVY SPARKLE;So;0;ON;;;;;N;;;;;
2749;BALLOON-SPOKED ASTERISK;So;0;ON;;;;;N;;;;;
274A;EIGHT TEARDROP-SPOKED PROPELLER ASTERISK;So;0;ON;;;;;N;;;;;
274B;HEAVY EIGHT TEARDROP-SPOKED PROPELLER ASTERISK;So;0;ON;;;;;N;;;;;
274C;CROSS MARK;So;0;ON;;;;;N;;;;;
274D;SHADOWED WHITE CIRCLE;So;0;ON;;;;;N;;;;;
274E;NEGATIVE SQUARED CROSS MARK;So;0;ON;;;;;N;;;;;
274F;LOWER RIGHT DROP-SHADOWED WHITE SQUARE;So;0;ON;;;;;N;;;;;
2750;UPPER RIGHT DROP-SHADOWED WHITE SQUARE;So;0;ON;;;;;N;;;;;
2751;LOWER RIGHT SHADOWED WHITE SQUARE;So;0;ON;;;;;N;;;;;
2752;UPPER RIGHT SHADOWED WHITE SQUARE;So;0;ON;;;;;N;;;;;
2753;BLACK QUESTION MARK ORNAMENT;So;0;ON;;;;;N;;;;;
2754;WHITE QUESTION MARK ORNAMENT;So;0;ON;;;;;N;;;;;
2755;WHITE EXCLAMATION MARK ORNAMENT;So;0;ON;;;;;N;;;;;
2756;BLACK DIAMOND MINUS WHITE X;So;0;ON;;;;;N;;;;;
2757;HEAVY EXCLAMATION MARK SYMBOL;So;0;ON;;;;;N;;;;;
2758;LIGHT VERTICAL BAR;So;0;ON;;;;;N;;;;;
2759;MEDIUM VERTICAL BAR;So;0;ON;;;;;N;;;;;
275A;HEAVY VERTICAL BAR;So;0;ON;;;;;N;;;;;
275B;HEAVY SINGLE TURNED COMMA QUOTATION MARK ORNAMENT;So;0;ON;;;;;N;;;;;
275C;HEAVY SINGLE COMMA QUOTATION MARK ORNAMENT;So;0;ON;;;;;N;;;;;
275D;HEAVY DOUBLE TURNED COMMA QUOTATION MARK ORNAMENT;So;0;ON;;;;;N;;;;;
275E;HEAVY DOUBLE COMMA QUOTATION MARK ORNAMENT;So;0;ON;;;;;N;;;;;
275F;HEAVY LOW SINGLE COMMA QUOTATION MARK ORNAMENT;So;0;ON;;;;;N;;;;;
2760;HEAVY LOW DOUBLE COMMA QUOTATION MARK ORNAMENT;So;0;ON;;;;;N;;;;;
2761;CURVED STEM PARAGRAPH SIGN ORNAMENT;So;0;ON;;;;;N;;;;;
2762;HEAVY EXCLAMATION MARK ORNAMENT;So;0;ON;;;;;N;;;;;
2763;HEAVY HEART EXCLAMATION MARK ORNAMENT;So;0;ON;;;;;N;;;;;
2764;HEAVY BLACK HEART;So;0;ON;;;;;N;;;;;
2765;ROTATED HEAVY BLACK HEART BULLET;So;0;ON;;;;;N;;;;;
2766;FLORAL HEART;So;0;ON;;;;;N;;;;;
2767;ROTATED FLORAL HEART BULLET;So;0;ON;;;;;N;;;;;
2768;MEDIUM LEFT PARENTHESIS ORNAMENT;Ps;0;ON;;;;;Y;;;;;
2769;MEDIUM RIGHT PARENTHESIS ORNAMENT;Pe;0;ON;;;;;Y;;;;;
276A;MEDIUM FLATTENED LEFT PARENTHESIS ORNAMENT;Ps;0;ON;;;;;Y;;;;;
276B;MEDIUM FLATTENED RIGHT PARENTHESIS ORNAMENT;Pe;0;ON;;;;;Y;;;;;
276C;MEDIUM LEFT-POINTING ANGLE BRACKET ORNAMENT;Ps;0;ON;;;;;Y;;;;;
276D;MEDIUM RIGHT-POINTING ANGLE BRACKET ORNAMENT;Pe;0;ON;;;;;Y;;;;;
276E;HEAVY LEFT-POINTING ANGLE QUOTATION MARK ORNAMENT;Ps;0;ON;;;;;Y;;;;;
276F;HEAVY RIGHT-POINTING ANGLE QUOTATION MARK ORNAMENT;Pe;0;ON;;;;;Y;;;;;
2770;HEAVY LEFT-POINTING ANGLE BRACKET ORNAMENT;Ps;0;ON;;;;;Y;;;;;
2771;HEAVY RIGHT-POINTING ANGLE BRACKET ORNAMENT;Pe;0;ON;;;;;Y;;;;;
2772;LIGHT LEFT TORTOISE SHELL BRACKET ORNAMENT;Ps;0;ON;;;;;Y;;;;;
2773;LIGHT RIGHT TORTOISE SHELL BRACKET ORNAMENT;Pe;0;ON;;;;;Y;;;;;
2774;MEDIUM LEFT CURLY BRACKET ORNAMENT;Ps;0;ON;;;;;Y;;;;;
2775;MEDIUM RIGHT CURLY BRACKET ORNAMENT;Pe;0;ON;;;;;Y;;;;;
2776;DINGBAT NEGATIVE CIRCLED DIGIT ONE;No;0;ON;;;1;1;N;INVERSE CIRCLED DIGIT ONE;;;;
2777;DINGBAT NEGATIVE CIRCLED DIGIT TWO;No;0;ON;;;2;2;N;INVERSE CIRCLED DIGIT TWO;;;;
2778;DINGBAT NEGATIVE CIRCLED DIGIT THREE;No;0;ON;;;3;3;N;INVERSE CIRCLED DIGIT THREE;;;;
2779;DINGBAT NEGATIVE CIRCLED DIGIT FOUR;No;0;ON;;;4;4;N;INVERSE CIRCLED DIGIT FOUR;;;;
277A;DINGBAT NEGATIVE CIRCLED DIGIT FIVE;No;0;ON;;;5;5;N;INVERSE CIRCLED DIGIT FIVE;;;;
277B;DINGBAT NEGATIVE CIRCLED DIGIT SIX;No;0;ON;;;6;6;N;INVERSE CIRCLED DIGIT SIX;;;;
277C;DINGBAT NEGATIVE CIRCLED DIGIT SEVEN;No;0;ON;;;7;7;N;INVERSE CIRCLED DIGIT SEVEN;;;;
277D;DINGBAT NEGATIVE CIRCLED DIGIT EIGHT;No;0;ON;;;8;8;N;INVERSE CIRCLED DIGIT EIGHT;;;;
277E;DINGBAT NEGATIVE CIRCLED DIGIT NINE;No;0;ON;;;9;9;N;INVERSE CIRCLED DIGIT NINE;;;;
277F;DINGBAT NEGATIVE CIRCLED NUMBER TEN;No;0;ON;;;;10;N;INVERSE CIRCLED NUMBER TEN;;;;
2780;DINGBAT CIRCLED SANS-SERIF DIGIT ONE;No;0;ON;;;1;1;N;CIRCLED SANS-SERIF DIGIT ONE;;;;
2781;DINGBAT CIRCLED SANS-SERIF DIGIT TWO;No;0;ON;;;2;2;N;CIRCLED SANS-SERIF DIGIT TWO;;;;
2782;DINGBAT CIRCLED SANS-SERIF DIGIT THREE;No;0;ON;;;3;3;N;CIRCLED SANS-SERIF DIGIT THREE;;;;
2783;DINGBAT CIRCLED SANS-SERIF DIGIT FOUR;No;0;ON;;;4;4;N;CIRCLED SANS-SERIF DIGIT FOUR;;;;
2784;DINGBAT CIRCLED SANS-SERIF DIGIT FIVE;No;0;ON;;;5;5;N;CIRCLED SANS-SERIF DIGIT FIVE;;;;
2785;DINGBAT CIRCLED SANS-SERIF DIGIT SIX;No;0;ON;;;6;6;N;CIRCLED SANS-SERIF DIGIT SIX;;;;
2786;DINGBAT CIRCLED SANS-SERIF DIGIT SEVEN;No;0;ON;;;7;7;N;CIRCLED SANS-SERIF DIGIT SEVEN;;;;
2787;DINGBAT CIRCLED SANS-SERIF DIGIT EIGHT;No;0;ON;;;8;8;N;CIRCLED SANS-SERIF DIGIT EIGHT;;;;
2788;DINGBAT CIRCLED SANS-SERIF DIGIT NINE;No;0;ON;;;9;9;N;CIRCLED SANS-SERIF DIGIT NINE;;;;
2789;DINGBAT CIRCLED SANS-SERIF NUMBER TEN;No;0;ON;;;;10;N;CIRCLED SANS-SERIF NUMBER TEN;;;;
278A;DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT ONE;No;0;ON;;;1;1;N;INVERSE CIRCLED SANS-SERIF DIGIT ONE;;;;
278B;DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT TWO;No;0;ON;;;2;2;N;INVERSE CIRCLED SANS-SERIF DIGIT TWO;;;;
278C;DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT THREE;No;0;ON;;;3;3;N;INVERSE CIRCLED SANS-SERIF DIGIT THREE;;;;
278D;DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT FOUR;No;0;ON;;;4;4;N;INVERSE CIRCLED SANS-SERIF DIGIT FOUR;;;;
278E;DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT FIVE;No;0;ON;;;5;5;N;INVERSE CIRCLED SANS-SERIF DIGIT FIVE;;;;
278F;DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT SIX;No;0;ON;;;6;6;N;INVERSE CIRCLED SANS-SERIF DIGIT SIX;;;;
2790;DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT SEVEN;No;0;ON;;;7;7;N;INVERSE CIRCLED SANS-SERIF DIGIT SEVEN;;;;
2791;DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT EIGHT;No;0;ON;;;8;8;N;INVERSE CIRCLED SANS-SERIF DIGIT EIGHT;;;;
2792;DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT NINE;No;0;ON;;;9;9;N;INVERSE CIRCLED SANS-SERIF DIGIT NINE;;;;
2793;DINGBAT NEGATIVE CIRCLED SANS-SERIF NUMBER TEN;No;0;ON;;;;10;N;INVERSE CIRCLED SANS-SERIF NUMBER TEN;;;;
2794;HEAVY WIDE-HEADED RIGHTWARDS ARROW;So;0;ON;;;;;N;HEAVY WIDE-HEADED RIGHT ARROW;;;;
2795;HEAVY PLUS SIGN;So;0;ON;;;;;N;;;;;
2796;HEAVY MINUS SIGN;So;0;ON;;;;;N;;;;;
2797;HEAVY DIVISION SIGN;So;0;ON;;;;;N;;;;;
2798;HEAVY SOUTH EAST ARROW;So;0;ON;;;;;N;HEAVY LOWER RIGHT ARROW;;;;
2799;HEAVY RIGHTWARDS ARROW;So;0;ON;;;;;N;HEAVY RIGHT ARROW;;;;
279A;HEAVY NORTH EAST ARROW;So;0;ON;;;;;N;HEAVY UPPER RIGHT ARROW;;;;
279B;DRAFTING POINT RIGHTWARDS ARROW;So;0;ON;;;;;N;DRAFTING POINT RIGHT ARROW;;;;
279C;HEAVY ROUND-TIPPED RIGHTWARDS ARROW;So;0;ON;;;;;N;HEAVY ROUND-TIPPED RIGHT ARROW;;;;
279D;TRIANGLE-HEADED RIGHTWARDS ARROW;So;0;ON;;;;;N;TRIANGLE-HEADED RIGHT ARROW;;;;
279E;HEAVY TRIANGLE-HEADED RIGHTWARDS ARROW;So;0;ON;;;;;N;HEAVY TRIANGLE-HEADED RIGHT ARROW;;;;
279F;DASHED TRIANGLE-HEADED RIGHTWARDS ARROW;So;0;ON;;;;;N;DASHED TRIANGLE-HEADED RIGHT ARROW;;;;
27A0;HEAVY DASHED TRIANGLE-HEADED RIGHTWARDS ARROW;So;0;ON;;;;;N;HEAVY DASHED TRIANGLE-HEADED RIGHT ARROW;;;;
27A1;BLACK RIGHTWARDS ARROW;So;0;ON;;;;;N;BLACK RIGHT ARROW;;;;
27A2;THREE-D TOP-LIGHTED RIGHTWARDS ARROWHEAD;So;0;ON;;;;;N;THREE-D TOP-LIGHTED RIGHT ARROWHEAD;;;;
27A3;THREE-D BOTTOM-LIGHTED RIGHTWARDS ARROWHEAD;So;0;ON;;;;;N;THREE-D BOTTOM-LIGHTED RIGHT ARROWHEAD;;;;
27A4;BLACK RIGHTWARDS ARROWHEAD;So;0;ON;;;;;N;BLACK RIGHT ARROWHEAD;;;;
27A5;HEAVY BLACK CURVED DOWNWARDS AND RIGHTWARDS ARROW;So;0;ON;;;;;N;HEAVY BLACK CURVED DOWN AND RIGHT ARROW;;;;
27A6;HEAVY BLACK CURVED UPWARDS AND RIGHTWARDS ARROW;So;0;ON;;;;;N;HEAVY BLACK CURVED UP AND RIGHT ARROW;;;;
27A7;SQUAT BLACK RIGHTWARDS ARROW;So;0;ON;;;;;N;SQUAT BLACK RIGHT ARROW;;;;
27A8;HEAVY CONCAVE-POINTED BLACK RIGHTWARDS ARROW;So;0;ON;;;;;N;HEAVY CONCAVE-POINTED BLACK RIGHT ARROW;;;;
27A9;RIGHT-SHADED WHITE RIGHTWARDS ARROW;So;0;ON;;;;;N;RIGHT-SHADED WHITE RIGHT ARROW;;;;
27AA;LEFT-SHADED WHITE RIGHTWARDS ARROW;So;0;ON;;;;;N;LEFT-SHADED WHITE RIGHT ARROW;;;;
27AB;BACK-TILTED SHADOWED WHITE RIGHTWARDS ARROW;So;0;ON;;;;;N;BACK-TILTED SHADOWED WHITE RIGHT ARROW;;;;
27AC;FRONT-TILTED SHADOWED WHITE RIGHTWARDS ARROW;So;0;ON;;;;;N;FRONT-TILTED SHADOWED WHITE RIGHT ARROW;;;;
27AD;HEAVY LOWER RIGHT-SHADOWED WHITE RIGHTWARDS ARROW;So;0;ON;;;;;N;HEAVY LOWER RIGHT-SHADOWED WHITE RIGHT ARROW;;;;
27AE;HEAVY UPPER RIGHT-SHADOWED WHITE RIGHTWARDS ARROW;So;0;ON;;;;;N;HEAVY UPPER RIGHT-SHADOWED WHITE RIGHT ARROW;;;;
27AF;NOTCHED LOWER RIGHT-SHADOWED WHITE RIGHTWARDS ARROW;So;0;ON;;;;;N;NOTCHED LOWER RIGHT-SHADOWED WHITE RIGHT ARROW;;;;
27B0;CURLY LOOP;So;0;ON;;;;;N;;;;;
27B1;NOTCHED UPPER RIGHT-SHADOWED WHITE RIGHTWARDS ARROW;So;0;ON;;;;;N;NOTCHED UPPER RIGHT-SHADOWED WHITE RIGHT ARROW;;;;
27B2;CIRCLED HEAVY WHITE RIGHTWARDS ARROW;So;0;ON;;;;;N;CIRCLED HEAVY WHITE RIGHT ARROW;;;;
27B3;WHITE-FEATHERED RIGHTWARDS ARROW;So;0;ON;;;;;N;WHITE-FEATHERED RIGHT ARROW;;;;
27B4;BLACK-FEATHERED SOUTH EAST ARROW;So;0;ON;;;;;N;BLACK-FEATHERED LOWER RIGHT ARROW;;;;
27B5;BLACK-FEATHERED RIGHTWARDS ARROW;So;0;ON;;;;;N;BLACK-FEATHERED RIGHT ARROW;;;;
27B6;BLACK-FEATHERED NORTH EAST ARROW;So;0;ON;;;;;N;BLACK-FEATHERED UPPER RIGHT ARROW;;;;
27B7;HEAVY BLACK-FEATHERED SOUTH EAST ARROW;So;0;ON;;;;;N;HEAVY BLACK-FEATHERED LOWER RIGHT ARROW;;;;
27B8;HEAVY BLACK-FEATHERED RIGHTWARDS ARROW;So;0;ON;;;;;N;HEAVY BLACK-FEATHERED RIGHT ARROW;;;;
27B9;HEAVY BLACK-FEATHERED NORTH EAST ARROW;So;0;ON;;;;;N;HEAVY BLACK-FEATHERED UPPER RIGHT ARROW;;;;
27BA;TEARDROP-BARBED RIGHTWARDS ARROW;So;0;ON;;;;;N;TEARDROP-BARBED RIGHT ARROW;;;;
27BB;HEAVY TEARDROP-SHANKED RIGHTWARDS ARROW;So;0;ON;;;;;N;HEAVY TEARDROP-SHANKED RIGHT ARROW;;;;
27BC;WEDGE-TAILED RIGHTWARDS ARROW;So;0;ON;;;;;N;WEDGE-TAILED RIGHT ARROW;;;;
27BD;HEAVY WEDGE-TAILED RIGHTWARDS ARROW;So;0;ON;;;;;N;HEAVY WEDGE-TAILED RIGHT ARROW;;;;
27BE;OPEN-OUTLINED RIGHTWARDS ARROW;So;0;ON;;;;;N;OPEN-OUTLINED RIGHT ARROW;;;;
27BF;DOUBLE CURLY LOOP;So;0;ON;;;;;N;;;;;
27C0;THREE DIMENSIONAL ANGLE;Sm;0;ON;;;;;Y;;;;;
27C1;WHITE TRIANGLE CONTAINING SMALL WHITE TRIANGLE;Sm;0;ON;;;;;N;;;;;
27C2;PERPENDICULAR;Sm;0;ON;;;;;N;;;;;
27C3;OPEN SUBSET;Sm;0;ON;;;;;Y;;;;;
27C4;OPEN SUPERSET;Sm;0;ON;;;;;Y;;;;;
27C5;LEFT S-SHAPED BAG DELIMITER;Ps;0;ON;;;;;Y;;;;;
27C6;RIGHT S-SHAPED BAG DELIMITER;Pe;0;ON;;;;;Y;;;;;
27C7;OR WITH DOT INSIDE;Sm;0;ON;;;;;N;;;;;
27C8;REVERSE SOLIDUS PRECEDING SUBSET;Sm;0;ON;;;;;Y;;;;;
27C9;SUPERSET PRECEDING SOLIDUS;Sm;0;ON;;;;;Y;;;;;
27CA;VERTICAL BAR WITH HORIZONTAL STROKE;Sm;0;ON;;;;;N;;;;;
27CB;MATHEMATICAL RISING DIAGONAL;Sm;0;ON;;;;;Y;;;;;
27CC;LONG DIVISION;Sm;0;ON;;;;;Y;;;;;
27CD;MATHEMATICAL FALLING DIAGONAL;Sm;0;ON;;;;;Y;;;;;
27CE;SQUARED LOGICAL AND;Sm;0;ON;;;;;N;;;;;
27CF;SQUARED LOGICAL OR;Sm;0;ON;;;;;N;;;;;
27D0;WHITE DIAMOND WITH CENTRED DOT;Sm;0;ON;;;;;N;;;;;
27D1;AND WITH DOT;Sm;0;ON;;;;;N;;;;;
27D2;ELEMENT OF OPENING UPWARDS;Sm;0;ON;;;;;N;;;;;
27D3;LOWER RIGHT CORNER WITH DOT;Sm;0;ON;;;;;Y;;;;;
27D4;UPPER LEFT CORNER WITH DOT;Sm;0;ON;;;;;Y;;;;;
27D5;LEFT OUTER JOIN;Sm;0;ON;;;;;Y;;;;;
27D6;RIGHT OUTER JOIN;Sm;0;ON;;;;;Y;;;;;
27D7;FULL OUTER JOIN;Sm;0;ON;;;;;N;;;;;
27D8;LARGE UP TACK;Sm;0;ON;;;;;N;;;;;
27D9;LARGE DOWN TACK;Sm;0;ON;;;;;N;;;;;
27DA;LEFT AND RIGHT DOUBLE TURNSTILE;Sm;0;ON;;;;;N;;;;;
27DB;LEFT AND RIGHT TACK;Sm;0;ON;;;;;N;;;;;
27DC;LEFT MULTIMAP;Sm;0;ON;;;;;Y;;;;;
27DD;LONG RIGHT TACK;Sm;0;ON;;;;;Y;;;;;
27DE;LONG LEFT TACK;Sm;0;ON;;;;;Y;;;;;
27DF;UP TACK WITH CIRCLE ABOVE;Sm;0;ON;;;;;N;;;;;
27E0;LOZENGE DIVIDED BY HORIZONTAL RULE;Sm;0;ON;;;;;N;;;;;
27E1;WHITE CONCAVE-SIDED DIAMOND;Sm;0;ON;;;;;N;;;;;
27E2;WHITE CONCAVE-SIDED DIAMOND WITH LEFTWARDS TICK;Sm;0;ON;;;;;Y;;;;;
27E3;WHITE CONCAVE-SIDED DIAMOND WITH RIGHTWARDS TICK;Sm;0;ON;;;;;Y;;;;;
27E4;WHITE SQUARE WITH LEFTWARDS TICK;Sm;0;ON;;;;;Y;;;;;
27E5;WHITE SQUARE WITH RIGHTWARDS TICK;Sm;0;ON;;;;;Y;;;;;
27E6;MATHEMATICAL LEFT WHITE SQUARE BRACKET;Ps;0;ON;;;;;Y;;;;;
27E7;MATHEMATICAL RIGHT WHITE SQUARE BRACKET;Pe;0;ON;;;;;Y;;;;;
27E8;MATHEMATICAL LEFT ANGLE BRACKET;Ps;0;ON;;;;;Y;;;;;
27E9;MATHEMATICAL RIGHT ANGLE BRACKET;Pe;0;ON;;;;;Y;;;;;
27EA;MATHEMATICAL LEFT DOUBLE ANGLE BRACKET;Ps;0;ON;;;;;Y;;;;;
27EB;MATHEMATICAL RIGHT DOUBLE ANGLE BRACKET;Pe;0;ON;;;;;Y;;;;;
27EC;MATHEMATICAL LEFT WHITE TORTOISE SHELL BRACKET;Ps;0;ON;;;;;Y;;;;;
27ED;MATHEMATICAL RIGHT WHITE TORTOISE SHELL BRACKET;Pe;0;ON;;;;;Y;;;;;
27EE;MATHEMATICAL LEFT FLATTENED PARENTHESIS;Ps;0;ON;;;;;Y;;;;;
27EF;MATHEMATICAL RIGHT FLATTENED PARENTHESIS;Pe;0;ON;;;;;Y;;;;;
27F0;UPWARDS QUADRUPLE ARROW;Sm;0;ON;;;;;N;;;;;
27F1;DOWNWARDS QUADRUPLE ARROW;Sm;0;ON;;;;;N;;;;;
27F2;ANTICLOCKWISE GAPPED CIRCLE ARROW;Sm;0;ON;;;;;N;;;;;
27F3;CLOCKWISE GAPPED CIRCLE ARROW;Sm;0;ON;;;;;N;;;;;
27F4;RIGHT ARROW WITH CIRCLED PLUS;Sm;0;ON;;;;;N;;;;;
27F5;LONG LEFTWARDS ARROW;Sm;0;ON;;;;;N;;;;;
27F6;LONG RIGHTWARDS ARROW;Sm;0;ON;;;;;N;;;;;
27F7;LONG LEFT RIGHT ARROW;Sm;0;ON;;;;;N;;;;;
27F8;LONG LEFTWARDS DOUBLE ARROW;Sm;0;ON;;;;;N;;;;;
27F9;LONG RIGHTWARDS DOUBLE ARROW;Sm;0;ON;;;;;N;;;;;
27FA;LONG LEFT RIGHT DOUBLE ARROW;Sm;0;ON;;;;;N;;;;;
27FB;LONG LEFTWARDS ARROW FROM BAR;Sm;0;ON;;;;;N;;;;;
27FC;LONG RIGHTWARDS ARROW FROM BAR;Sm;0;ON;;;;;N;;;;;
27FD;LONG LEFTWARDS DOUBLE ARROW FROM BAR;Sm;0;ON;;;;;N;;;;;
27FE;LONG RIGHTWARDS DOUBLE ARROW FROM BAR;Sm;0;ON;;;;;N;;;;;
27FF;LONG RIGHTWARDS SQUIGGLE ARROW;Sm;0;ON;;;;;N;;;;;
2800;BRAILLE PATTERN BLANK;So;0;L;;;;;N;;;;;
2801;BRAILLE PATTERN DOTS-1;So;0;L;;;;;N;;;;;
2802;BRAILLE PATTERN DOTS-2;So;0;L;;;;;N;;;;;
2803;BRAILLE PATTERN DOTS-12;So;0;L;;;;;N;;;;;
2804;BRAILLE PATTERN DOTS-3;So;0;L;;;;;N;;;;;
2805;BRAILLE PATTERN DOTS-13;So;0;L;;;;;N;;;;;
2806;BRAILLE PATTERN DOTS-23;So;0;L;;;;;N;;;;;
2807;BRAILLE PATTERN DOTS-123;So;0;L;;;;;N;;;;;
2808;BRAILLE PATTERN DOTS-4;So;0;L;;;;;N;;;;;
2809;BRAILLE PATTERN DOTS-14;So;0;L;;;;;N;;;;;
280A;BRAILLE PATTERN DOTS-24;So;0;L;;;;;N;;;;;
280B;BRAILLE PATTERN DOTS-124;So;0;L;;;;;N;;;;;
280C;BRAILLE PATTERN DOTS-34;So;0;L;;;;;N;;;;;
280D;BRAILLE PATTERN DOTS-134;So;0;L;;;;;N;;;;;
280E;BRAILLE PATTERN DOTS-234;So;0;L;;;;;N;;;;;
280F;BRAILLE PATTERN DOTS-1234;So;0;L;;;;;N;;;;;
2810;BRAILLE PATTERN DOTS-5;So;0;L;;;;;N;;;;;
2811;BRAILLE PATTERN DOTS-15;So;0;L;;;;;N;;;;;
2812;BRAILLE PATTERN DOTS-25;So;0;L;;;;;N;;;;;
2813;BRAILLE PATTERN DOTS-125;So;0;L;;;;;N;;;;;
2814;BRAILLE PATTERN DOTS-35;So;0;L;;;;;N;;;;;
2815;BRAILLE PATTERN DOTS-135;So;0;L;;;;;N;;;;;
2816;BRAILLE PATTERN DOTS-235;So;0;L;;;;;N;;;;;
2817;BRAILLE PATTERN DOTS-1235;So;0;L;;;;;N;;;;;
2818;BRAILLE PATTERN DOTS-45;So;0;L;;;;;N;;;;;
2819;BRAILLE PATTERN DOTS-145;So;0;L;;;;;N;;;;;
281A;BRAILLE PATTERN DOTS-245;So;0;L;;;;;N;;;;;
281B;BRAILLE PATTERN DOTS-1245;So;0;L;;;;;N;;;;;
281C;BRAILLE PATTERN DOTS-345;So;0;L;;;;;N;;;;;
281D;BRAILLE PATTERN DOTS-1345;So;0;L;;;;;N;;;;;
281E;BRAILLE PATTERN DOTS-2345;So;0;L;;;;;N;;;;;
281F;BRAILLE PATTERN DOTS-12345;So;0;L;;;;;N;;;;;
2820;BRAILLE PATTERN DOTS-6;So;0;L;;;;;N;;;;;
2821;BRAILLE PATTERN DOTS-16;So;0;L;;;;;N;;;;;
2822;BRAILLE PATTERN DOTS-26;So;0;L;;;;;N;;;;;
2823;BRAILLE PATTERN DOTS-126;So;0;L;;;;;N;;;;;
2824;BRAILLE PATTERN DOTS-36;So;0;L;;;;;N;;;;;
2825;BRAILLE PATTERN DOTS-136;So;0;L;;;;;N;;;;;
2826;BRAILLE PATTERN DOTS-236;So;0;L;;;;;N;;;;;
2827;BRAILLE PATTERN DOTS-1236;So;0;L;;;;;N;;;;;
2828;BRAILLE PATTERN DOTS-46;So;0;L;;;;;N;;;;;
2829;BRAILLE PATTERN DOTS-146;So;0;L;;;;;N;;;;;
282A;BRAILLE PATTERN DOTS-246;So;0;L;;;;;N;;;;;
282B;BRAILLE PATTERN DOTS-1246;So;0;L;;;;;N;;;;;
282C;BRAILLE PATTERN DOTS-346;So;0;L;;;;;N;;;;;
282D;BRAILLE PATTERN DOTS-1346;So;0;L;;;;;N;;;;;
282E;BRAILLE PATTERN DOTS-2346;So;0;L;;;;;N;;;;;
282F;BRAILLE PATTERN DOTS-12346;So;0;L;;;;;N;;;;;
2830;BRAILLE PATTERN DOTS-56;So;0;L;;;;;N;;;;;
2831;BRAILLE PATTERN DOTS-156;So;0;L;;;;;N;;;;;
2832;BRAILLE PATTERN DOTS-256;So;0;L;;;;;N;;;;;
2833;BRAILLE PATTERN DOTS-1256;So;0;L;;;;;N;;;;;
2834;BRAILLE PATTERN DOTS-356;So;0;L;;;;;N;;;;;
2835;BRAILLE PATTERN DOTS-1356;So;0;L;;;;;N;;;;;
2836;BRAILLE PATTERN DOTS-2356;So;0;L;;;;;N;;;;;
2837;BRAILLE PATTERN DOTS-12356;So;0;L;;;;;N;;;;;
2838;BRAILLE PATTERN DOTS-456;So;0;L;;;;;N;;;;;
2839;BRAILLE PATTERN DOTS-1456;So;0;L;;;;;N;;;;;
283A;BRAILLE PATTERN DOTS-2456;So;0;L;;;;;N;;;;;
283B;BRAILLE PATTERN DOTS-12456;So;0;L;;;;;N;;;;;
283C;BRAILLE PATTERN DOTS-3456;So;0;L;;;;;N;;;;;
283D;BRAILLE PATTERN DOTS-13456;So;0;L;;;;;N;;;;;
283E;BRAILLE PATTERN DOTS-23456;So;0;L;;;;;N;;;;;
283F;BRAILLE PATTERN DOTS-123456;So;0;L;;;;;N;;;;;
2840;BRAILLE PATTERN DOTS-7;So;0;L;;;;;N;;;;;
2841;BRAILLE PATTERN DOTS-17;So;0;L;;;;;N;;;;;
2842;BRAILLE PATTERN DOTS-27;So;0;L;;;;;N;;;;;
2843;BRAILLE PATTERN DOTS-127;So;0;L;;;;;N;;;;;
2844;BRAILLE PATTERN DOTS-37;So;0;L;;;;;N;;;;;
2845;BRAILLE PATTERN DOTS-137;So;0;L;;;;;N;;;;;
2846;BRAILLE PATTERN DOTS-237;So;0;L;;;;;N;;;;;
2847;BRAILLE PATTERN DOTS-1237;So;0;L;;;;;N;;;;;
2848;BRAILLE PATTERN DOTS-47;So;0;L;;;;;N;;;;;
2849;BRAILLE PATTERN DOTS-147;So;0;L;;;;;N;;;;;
284A;BRAILLE PATTERN DOTS-247;So;0;L;;;;;N;;;;;
284B;BRAILLE PATTERN DOTS-1247;So;0;L;;;;;N;;;;;
284C;BRAILLE PATTERN DOTS-347;So;0;L;;;;;N;;;;;
284D;BRAILLE PATTERN DOTS-1347;So;0;L;;;;;N;;;;;
284E;BRAILLE PATTERN DOTS-2347;So;0;L;;;;;N;;;;;
284F;BRAILLE PATTERN DOTS-12347;So;0;L;;;;;N;;;;;
2850;BRAILLE PATTERN DOTS-57;So;0;L;;;;;N;;;;;
2851;BRAILLE PATTERN DOTS-157;So;0;L;;;;;N;;;;;
2852;BRAILLE PATTERN DOTS-257;So;0;L;;;;;N;;;;;
2853;BRAILLE PATTERN DOTS-1257;So;0;L;;;;;N;;;;;
2854;BRAILLE PATTERN DOTS-357;So;0;L;;;;;N;;;;;
2855;BRAILLE PATTERN DOTS-1357;So;0;L;;;;;N;;;;;
2856;BRAILLE PATTERN DOTS-2357;So;0;L;;;;;N;;;;;
2857;BRAILLE PATTERN DOTS-12357;So;0;L;;;;;N;;;;;
2858;BRAILLE PATTERN DOTS-457;So;0;L;;;;;N;;;;;
2859;BRAILLE PATTERN DOTS-1457;So;0;L;;;;;N;;;;;
285A;BRAILLE PATTERN DOTS-2457;So;0;L;;;;;N;;;;;
285B;BRAILLE PATTERN DOTS-12457;So;0;L;;;;;N;;;;;
285C;BRAILLE PATTERN DOTS-3457;So;0;L;;;;;N;;;;;
285D;BRAILLE PATTERN DOTS-13457;So;0;L;;;;;N;;;;;
285E;BRAILLE PATTERN DOTS-23457;So;0;L;;;;;N;;;;;
285F;BRAILLE PATTERN DOTS-123457;So;0;L;;;;;N;;;;;
2860;BRAILLE PATTERN DOTS-67;So;0;L;;;;;N;;;;;
2861;BRAILLE PATTERN DOTS-167;So;0;L;;;;;N;;;;;
2862;BRAILLE PATTERN DOTS-267;So;0;L;;;;;N;;;;;
2863;BRAILLE PATTERN DOTS-1267;So;0;L;;;;;N;;;;;
2864;BRAILLE PATTERN DOTS-367;So;0;L;;;;;N;;;;;
2865;BRAILLE PATTERN DOTS-1367;So;0;L;;;;;N;;;;;
2866;BRAILLE PATTERN DOTS-2367;So;0;L;;;;;N;;;;;
2867;BRAILLE PATTERN DOTS-12367;So;0;L;;;;;N;;;;;
2868;BRAILLE PATTERN DOTS-467;So;0;L;;;;;N;;;;;
2869;BRAILLE PATTERN DOTS-1467;So;0;L;;;;;N;;;;;
286A;BRAILLE PATTERN DOTS-2467;So;0;L;;;;;N;;;;;
286B;BRAILLE PATTERN DOTS-12467;So;0;L;;;;;N;;;;;
286C;BRAILLE PATTERN DOTS-3467;So;0;L;;;;;N;;;;;
286D;BRAILLE PATTERN DOTS-13467;So;0;L;;;;;N;;;;;
286E;BRAILLE PATTERN DOTS-23467;So;0;L;;;;;N;;;;;
286F;BRAILLE PATTERN DOTS-123467;So;0;L;;;;;N;;;;;
2870;BRAILLE PATTERN DOTS-567;So;0;L;;;;;N;;;;;
2871;BRAILLE PATTERN DOTS-1567;So;0;L;;;;;N;;;;;
2872;BRAILLE PATTERN DOTS-2567;So;0;L;;;;;N;;;;;
2873;BRAILLE PATTERN DOTS-12567;So;0;L;;;;;N;;;;;
2874;BRAILLE PATTERN DOTS-3567;So;0;L;;;;;N;;;;;
2875;BRAILLE PATTERN DOTS-13567;So;0;L;;;;;N;;;;;
2876;BRAILLE PATTERN DOTS-23567;So;0;L;;;;;N;;;;;
2877;BRAILLE PATTERN DOTS-123567;So;0;L;;;;;N;;;;;
2878;BRAILLE PATTERN DOTS-4567;So;0;L;;;;;N;;;;;
2879;BRAILLE PATTERN DOTS-14567;So;0;L;;;;;N;;;;;
287A;BRAILLE PATTERN DOTS-24567;So;0;L;;;;;N;;;;;
287B;BRAILLE PATTERN DOTS-124567;So;0;L;;;;;N;;;;;
287C;BRAILLE PATTERN DOTS-34567;So;0;L;;;;;N;;;;;
287D;BRAILLE PATTERN DOTS-134567;So;0;L;;;;;N;;;;;
287E;BRAILLE PATTERN DOTS-234567;So;0;L;;;;;N;;;;;
287F;BRAILLE PATTERN DOTS-1234567;So;0;L;;;;;N;;;;;
2880;BRAILLE PATTERN DOTS-8;So;0;L;;;;;N;;;;;
2881;BRAILLE PATTERN DOTS-18;So;0;L;;;;;N;;;;;
2882;BRAILLE PATTERN DOTS-28;So;0;L;;;;;N;;;;;
2883;BRAILLE PATTERN DOTS-128;So;0;L;;;;;N;;;;;
2884;BRAILLE PATTERN DOTS-38;So;0;L;;;;;N;;;;;
2885;BRAILLE PATTERN DOTS-138;So;0;L;;;;;N;;;;;
2886;BRAILLE PATTERN DOTS-238;So;0;L;;;;;N;;;;;
2887;BRAILLE PATTERN DOTS-1238;So;0;L;;;;;N;;;;;
2888;BRAILLE PATTERN DOTS-48;So;0;L;;;;;N;;;;;
2889;BRAILLE PATTERN DOTS-148;So;0;L;;;;;N;;;;;
288A;BRAILLE PATTERN DOTS-248;So;0;L;;;;;N;;;;;
288B;BRAILLE PATTERN DOTS-1248;So;0;L;;;;;N;;;;;
288C;BRAILLE PATTERN DOTS-348;So;0;L;;;;;N;;;;;
288D;BRAILLE PATTERN DOTS-1348;So;0;L;;;;;N;;;;;
288E;BRAILLE PATTERN DOTS-2348;So;0;L;;;;;N;;;;;
288F;BRAILLE PATTERN DOTS-12348;So;0;L;;;;;N;;;;;
2890;BRAILLE PATTERN DOTS-58;So;0;L;;;;;N;;;;;
2891;BRAILLE PATTERN DOTS-158;So;0;L;;;;;N;;;;;
2892;BRAILLE PATTERN DOTS-258;So;0;L;;;;;N;;;;;
2893;BRAILLE PATTERN DOTS-1258;So;0;L;;;;;N;;;;;
2894;BRAILLE PATTERN DOTS-358;So;0;L;;;;;N;;;;;
2895;BRAILLE PATTERN DOTS-1358;So;0;L;;;;;N;;;;;
2896;BRAILLE PATTERN DOTS-2358;So;0;L;;;;;N;;;;;
2897;BRAILLE PATTERN DOTS-12358;So;0;L;;;;;N;;;;;
2898;BRAILLE PATTERN DOTS-458;So;0;L;;;;;N;;;;;
2899;BRAILLE PATTERN DOTS-1458;So;0;L;;;;;N;;;;;
289A;BRAILLE PATTERN DOTS-2458;So;0;L;;;;;N;;;;;
289B;BRAILLE PATTERN DOTS-12458;So;0;L;;;;;N;;;;;
289C;BRAILLE PATTERN DOTS-3458;So;0;L;;;;;N;;;;;
289D;BRAILLE PATTERN DOTS-13458;So;0;L;;;;;N;;;;;
289E;BRAILLE PATTERN DOTS-23458;So;0;L;;;;;N;;;;;
289F;BRAILLE PATTERN DOTS-123458;So;0;L;;;;;N;;;;;
28A0;BRAILLE PATTERN DOTS-68;So;0;L;;;;;N;;;;;
28A1;BRAILLE PATTERN DOTS-168;So;0;L;;;;;N;;;;;
28A2;BRAILLE PATTERN DOTS-268;So;0;L;;;;;N;;;;;
28A3;BRAILLE PATTERN DOTS-1268;So;0;L;;;;;N;;;;;
28A4;BRAILLE PATTERN DOTS-368;So;0;L;;;;;N;;;;;
28A5;BRAILLE PATTERN DOTS-1368;So;0;L;;;;;N;;;;;
28A6;BRAILLE PATTERN DOTS-2368;So;0;L;;;;;N;;;;;
28A7;BRAILLE PATTERN DOTS-12368;So;0;L;;;;;N;;;;;
28A8;BRAILLE PATTERN DOTS-468;So;0;L;;;;;N;;;;;
28A9;BRAILLE PATTERN DOTS-1468;So;0;L;;;;;N;;;;;
28AA;BRAILLE PATTERN DOTS-2468;So;0;L;;;;;N;;;;;
28AB;BRAILLE PATTERN DOTS-12468;So;0;L;;;;;N;;;;;
28AC;BRAILLE PATTERN DOTS-3468;So;0;L;;;;;N;;;;;
28AD;BRAILLE PATTERN DOTS-13468;So;0;L;;;;;N;;;;;
28AE;BRAILLE PATTERN DOTS-23468;So;0;L;;;;;N;;;;;
28AF;BRAILLE PATTERN DOTS-123468;So;0;L;;;;;N;;;;;
28B0;BRAILLE PATTERN DOTS-568;So;0;L;;;;;N;;;;;
28B1;BRAILLE PATTERN DOTS-1568;So;0;L;;;;;N;;;;;
28B2;BRAILLE PATTERN DOTS-2568;So;0;L;;;;;N;;;;;
28B3;BRAILLE PATTERN DOTS-12568;So;0;L;;;;;N;;;;;
28B4;BRAILLE PATTERN DOTS-3568;So;0;L;;;;;N;;;;;
28B5;BRAILLE PATTERN DOTS-13568;So;0;L;;;;;N;;;;;
28B6;BRAILLE PATTERN DOTS-23568;So;0;L;;;;;N;;;;;
28B7;BRAILLE PATTERN DOTS-123568;So;0;L;;;;;N;;;;;
28B8;BRAILLE PATTERN DOTS-4568;So;0;L;;;;;N;;;;;
28B9;BRAILLE PATTERN DOTS-14568;So;0;L;;;;;N;;;;;
28BA;BRAILLE PATTERN DOTS-24568;So;0;L;;;;;N;;;;;
28BB;BRAILLE PATTERN DOTS-124568;So;0;L;;;;;N;;;;;
28BC;BRAILLE PATTERN DOTS-34568;So;0;L;;;;;N;;;;;
28BD;BRAILLE PATTERN DOTS-134568;So;0;L;;;;;N;;;;;
28BE;BRAILLE PATTERN DOTS-234568;So;0;L;;;;;N;;;;;
28BF;BRAILLE PATTERN DOTS-1234568;So;0;L;;;;;N;;;;;
28C0;BRAILLE PATTERN DOTS-78;So;0;L;;;;;N;;;;;
28C1;BRAILLE PATTERN DOTS-178;So;0;L;;;;;N;;;;;
28C2;BRAILLE PATTERN DOTS-278;So;0;L;;;;;N;;;;;
28C3;BRAILLE PATTERN DOTS-1278;So;0;L;;;;;N;;;;;
28C4;BRAILLE PATTERN DOTS-378;So;0;L;;;;;N;;;;;
28C5;BRAILLE PATTERN DOTS-1378;So;0;L;;;;;N;;;;;
28C6;BRAILLE PATTERN DOTS-2378;So;0;L;;;;;N;;;;;
28C7;BRAILLE PATTERN DOTS-12378;So;0;L;;;;;N;;;;;
28C8;BRAILLE PATTERN DOTS-478;So;0;L;;;;;N;;;;;
28C9;BRAILLE PATTERN DOTS-1478;So;0;L;;;;;N;;;;;
28CA;BRAILLE PATTERN DOTS-2478;So;0;L;;;;;N;;;;;
28CB;BRAILLE PATTERN DOTS-12478;So;0;L;;;;;N;;;;;
28CC;BRAILLE PATTERN DOTS-3478;So;0;L;;;;;N;;;;;
28CD;BRAILLE PATTERN DOTS-13478;So;0;L;;;;;N;;;;;
28CE;BRAILLE PATTERN DOTS-23478;So;0;L;;;;;N;;;;;
28CF;BRAILLE PATTERN DOTS-123478;So;0;L;;;;;N;;;;;
28D0;BRAILLE PATTERN DOTS-578;So;0;L;;;;;N;;;;;
28D1;BRAILLE PATTERN DOTS-1578;So;0;L;;;;;N;;;;;
28D2;BRAILLE PATTERN DOTS-2578;So;0;L;;;;;N;;;;;
28D3;BRAILLE PATTERN DOTS-12578;So;0;L;;;;;N;;;;;
28D4;BRAILLE PATTERN DOTS-3578;So;0;L;;;;;N;;;;;
28D5;BRAILLE PATTERN DOTS-13578;So;0;L;;;;;N;;;;;
28D6;BRAILLE PATTERN DOTS-23578;So;0;L;;;;;N;;;;;
28D7;BRAILLE PATTERN DOTS-123578;So;0;L;;;;;N;;;;;
28D8;BRAILLE PATTERN DOTS-4578;So;0;L;;;;;N;;;;;
28D9;BRAILLE PATTERN DOTS-14578;So;0;L;;;;;N;;;;;
28DA;BRAILLE PATTERN DOTS-24578;So;0;L;;;;;N;;;;;
28DB;BRAILLE PATTERN DOTS-124578;So;0;L;;;;;N;;;;;
28DC;BRAILLE PATTERN DOTS-34578;So;0;L;;;;;N;;;;;
28DD;BRAILLE PATTERN DOTS-134578;So;0;L;;;;;N;;;;;
28DE;BRAILLE PATTERN DOTS-234578;So;0;L;;;;;N;;;;;
28DF;BRAILLE PATTERN DOTS-1234578;So;0;L;;;;;N;;;;;
28E0;BRAILLE PATTERN DOTS-678;So;0;L;;;;;N;;;;;
28E1;BRAILLE PATTERN DOTS-1678;So;0;L;;;;;N;;;;;
28E2;BRAILLE PATTERN DOTS-2678;So;0;L;;;;;N;;;;;
28E3;BRAILLE PATTERN DOTS-12678;So;0;L;;;;;N;;;;;
28E4;BRAILLE PATTERN DOTS-3678;So;0;L;;;;;N;;;;;
28E5;BRAILLE PATTERN DOTS-13678;So;0;L;;;;;N;;;;;
28E6;BRAILLE PATTERN DOTS-23678;So;0;L;;;;;N;;;;;
28E7;BRAILLE PATTERN DOTS-123678;So;0;L;;;;;N;;;;;
28E8;BRAILLE PATTERN DOTS-4678;So;0;L;;;;;N;;;;;
28E9;BRAILLE PATTERN DOTS-14678;So;0;L;;;;;N;;;;;
28EA;BRAILLE PATTERN DOTS-24678;So;0;L;;;;;N;;;;;
28EB;BRAILLE PATTERN DOTS-124678;So;0;L;;;;;N;;;;;
28EC;BRAILLE PATTERN DOTS-34678;So;0;L;;;;;N;;;;;
28ED;BRAILLE PATTERN DOTS-134678;So;0;L;;;;;N;;;;;
28EE;BRAILLE PATTERN DOTS-234678;So;0;L;;;;;N;;;;;
28EF;BRAILLE PATTERN DOTS-1234678;So;0;L;;;;;N;;;;;
28F0;BRAILLE PATTERN DOTS-5678;So;0;L;;;;;N;;;;;
28F1;BRAILLE PATTERN DOTS-15678;So;0;L;;;;;N;;;;;
28F2;BRAILLE PATTERN DOTS-25678;So;0;L;;;;;N;;;;;
28F3;BRAILLE PATTERN DOTS-125678;So;0;L;;;;;N;;;;;
28F4;BRAILLE PATTERN DOTS-35678;So;0;L;;;;;N;;;;;
28F5;BRAILLE PATTERN DOTS-135678;So;0;L;;;;;N;;;;;
28F6;BRAILLE PATTERN DOTS-235678;So;0;L;;;;;N;;;;;
28F7;BRAILLE PATTERN DOTS-1235678;So;0;L;;;;;N;;;;;
28F8;BRAILLE PATTERN DOTS-45678;So;0;L;;;;;N;;;;;
28F9;BRAILLE PATTERN DOTS-145678;So;0;L;;;;;N;;;;;
28FA;BRAILLE PATTERN DOTS-245678;So;0;L;;;;;N;;;;;
28FB;BRAILLE PATTERN DOTS-1245678;So;0;L;;;;;N;;;;;
28FC;BRAILLE PATTERN DOTS-345678;So;0;L;;;;;N;;;;;
28FD;BRAILLE PATTERN DOTS-1345678;So;0;L;;;;;N;;;;;
28FE;BRAILLE PATTERN DOTS-2345678;So;0;L;;;;;N;;;;;
28FF;BRAILLE PATTERN DOTS-12345678;So;0;L;;;;;N;;;;;
2900;RIGHTWARDS TWO-HEADED ARROW WITH VERTICAL STROKE;Sm;0;ON;;;;;N;;;;;
2901;RIGHTWARDS TWO-HEADED ARROW WITH DOUBLE VERTICAL STROKE;Sm;0;ON;;;;;N;;;;;
2902;LEFTWARDS DOUBLE ARROW WITH VERTICAL STROKE;Sm;0;ON;;;;;N;;;;;
2903;RIGHTWARDS DOUBLE ARROW WITH VERTICAL STROKE;Sm;0;ON;;;;;N;;;;;
2904;LEFT RIGHT DOUBLE ARROW WITH VERTICAL STROKE;Sm;0;ON;;;;;N;;;;;
2905;RIGHTWARDS TWO-HEADED ARROW FROM BAR;Sm;0;ON;;;;;N;;;;;
2906;LEFTWARDS DOUBLE ARROW FROM BAR;Sm;0;ON;;;;;N;;;;;
2907;RIGHTWARDS DOUBLE ARROW FROM BAR;Sm;0;ON;;;;;N;;;;;
2908;DOWNWARDS ARROW WITH HORIZONTAL STROKE;Sm;0;ON;;;;;N;;;;;
2909;UPWARDS ARROW WITH HORIZONTAL STROKE;Sm;0;ON;;;;;N;;;;;
290A;UPWARDS TRIPLE ARROW;Sm;0;ON;;;;;N;;;;;
290B;DOWNWARDS TRIPLE ARROW;Sm;0;ON;;;;;N;;;;;
290C;LEFTWARDS DOUBLE DASH ARROW;Sm;0;ON;;;;;N;;;;;
290D;RIGHTWARDS DOUBLE DASH ARROW;Sm;0;ON;;;;;N;;;;;
290E;LEFTWARDS TRIPLE DASH ARROW;Sm;0;ON;;;;;N;;;;;
290F;RIGHTWARDS TRIPLE DASH ARROW;Sm;0;ON;;;;;N;;;;;
2910;RIGHTWARDS TWO-HEADED TRIPLE DASH ARROW;Sm;0;ON;;;;;N;;;;;
2911;RIGHTWARDS ARROW WITH DOTTED STEM;Sm;0;ON;;;;;N;;;;;
2912;UPWARDS ARROW TO BAR;Sm;0;ON;;;;;N;;;;;
2913;DOWNWARDS ARROW TO BAR;Sm;0;ON;;;;;N;;;;;
2914;RIGHTWARDS ARROW WITH TAIL WITH VERTICAL STROKE;Sm;0;ON;;;;;N;;;;;
2915;RIGHTWARDS ARROW WITH TAIL WITH DOUBLE VERTICAL STROKE;Sm;0;ON;;;;;N;;;;;
2916;RIGHTWARDS TWO-HEADED ARROW WITH TAIL;Sm;0;ON;;;;;N;;;;;
2917;RIGHTWARDS TWO-HEADED ARROW WITH TAIL WITH VERTICAL STROKE;Sm;0;ON;;;;;N;;;;;
2918;RIGHTWARDS TWO-HEADED ARROW WITH TAIL WITH DOUBLE VERTICAL STROKE;Sm;0;ON;;;;;N;;;;;
2919;LEFTWARDS ARROW-TAIL;Sm;0;ON;;;;;N;;;;;
291A;RIGHTWARDS ARROW-TAIL;Sm;0;ON;;;;;N;;;;;
291B;LEFTWARDS DOUBLE ARROW-TAIL;Sm;0;ON;;;;;N;;;;;
291C;RIGHTWARDS DOUBLE ARROW-TAIL;Sm;0;ON;;;;;N;;;;;
291D;LEFTWARDS ARROW TO BLACK DIAMOND;Sm;0;ON;;;;;N;;;;;
291E;RIGHTWARDS ARROW TO BLACK DIAMOND;Sm;0;ON;;;;;N;;;;;
291F;LEFTWARDS ARROW FROM BAR TO BLACK DIAMOND;Sm;0;ON;;;;;N;;;;;
2920;RIGHTWARDS ARROW FROM BAR TO BLACK DIAMOND;Sm;0;ON;;;;;N;;;;;
2921;NORTH WEST AND SOUTH EAST ARROW;Sm;0;ON;;;;;N;;;;;
2922;NORTH EAST AND SOUTH WEST ARROW;Sm;0;ON;;;;;N;;;;;
2923;NORTH WEST ARROW WITH HOOK;Sm;0;ON;;;;;N;;;;;
2924;NORTH EAST ARROW WITH HOOK;Sm;0;ON;;;;;N;;;;;
2925;SOUTH EAST ARROW WITH HOOK;Sm;0;ON;;;;;N;;;;;
2926;SOUTH WEST ARROW WITH HOOK;Sm;0;ON;;;;;N;;;;;
2927;NORTH WEST ARROW AND NORTH EAST ARROW;Sm;0;ON;;;;;N;;;;;
2928;NORTH EAST ARROW AND SOUTH EAST ARROW;Sm;0;ON;;;;;N;;;;;
2929;SOUTH EAST ARROW AND SOUTH WEST ARROW;Sm;0;ON;;;;;N;;;;;
292A;SOUTH WEST ARROW AND NORTH WEST ARROW;Sm;0;ON;;;;;N;;;;;
292B;RISING DIAGONAL CROSSING FALLING DIAGONAL;Sm;0;ON;;;;;N;;;;;
292C;FALLING DIAGONAL CROSSING RISING DIAGONAL;Sm;0;ON;;;;;N;;;;;
292D;SOUTH EAST ARROW CROSSING NORTH EAST ARROW;Sm;0;ON;;;;;N;;;;;
292E;NORTH EAST ARROW CROSSING SOUTH EAST ARROW;Sm;0;ON;;;;;N;;;;;
292F;FALLING DIAGONAL CROSSING NORTH EAST ARROW;Sm;0;ON;;;;;N;;;;;
2930;RISING DIAGONAL CROSSING SOUTH EAST ARROW;Sm;0;ON;;;;;N;;;;;
2931;NORTH EAST ARROW CROSSING NORTH WEST ARROW;Sm;0;ON;;;;;N;;;;;
2932;NORTH WEST ARROW CROSSING NORTH EAST ARROW;Sm;0;ON;;;;;N;;;;;
2933;WAVE ARROW POINTING DIRECTLY RIGHT;Sm;0;ON;;;;;N;;;;;
2934;ARROW POINTING RIGHTWARDS THEN CURVING UPWARDS;Sm;0;ON;;;;;N;;;;;
2935;ARROW POINTING RIGHTWARDS THEN CURVING DOWNWARDS;Sm;0;ON;;;;;N;;;;;
2936;ARROW POINTING DOWNWARDS THEN CURVING LEFTWARDS;Sm;0;ON;;;;;N;;;;;
2937;ARROW POINTING DOWNWARDS THEN CURVING RIGHTWARDS;Sm;0;ON;;;;;N;;;;;
2938;RIGHT-SIDE ARC CLOCKWISE ARROW;Sm;0;ON;;;;;N;;;;;
2939;LEFT-SIDE ARC ANTICLOCKWISE ARROW;Sm;0;ON;;;;;N;;;;;
293A;TOP ARC ANTICLOCKWISE ARROW;Sm;0;ON;;;;;N;;;;;
293B;BOTTOM ARC ANTICLOCKWISE ARROW;Sm;0;ON;;;;;N;;;;;
293C;TOP ARC CLOCKWISE ARROW WITH MINUS;Sm;0;ON;;;;;N;;;;;
293D;TOP ARC ANTICLOCKWISE ARROW WITH PLUS;Sm;0;ON;;;;;N;;;;;
293E;LOWER RIGHT SEMICIRCULAR CLOCKWISE ARROW;Sm;0;ON;;;;;N;;;;;
293F;LOWER LEFT SEMICIRCULAR ANTICLOCKWISE ARROW;Sm;0;ON;;;;;N;;;;;
2940;ANTICLOCKWISE CLOSED CIRCLE ARROW;Sm;0;ON;;;;;N;;;;;
2941;CLOCKWISE CLOSED CIRCLE ARROW;Sm;0;ON;;;;;N;;;;;
2942;RIGHTWARDS ARROW ABOVE SHORT LEFTWARDS ARROW;Sm;0;ON;;;;;N;;;;;
2943;LEFTWARDS ARROW ABOVE SHORT RIGHTWARDS ARROW;Sm;0;ON;;;;;N;;;;;
2944;SHORT RIGHTWARDS ARROW ABOVE LEFTWARDS ARROW;Sm;0;ON;;;;;N;;;;;
2945;RIGHTWARDS ARROW WITH PLUS BELOW;Sm;0;ON;;;;;N;;;;;
2946;LEFTWARDS ARROW WITH PLUS BELOW;Sm;0;ON;;;;;N;;;;;
2947;RIGHTWARDS ARROW THROUGH X;Sm;0;ON;;;;;N;;;;;
2948;LEFT RIGHT ARROW THROUGH SMALL CIRCLE;Sm;0;ON;;;;;N;;;;;
2949;UPWARDS TWO-HEADED ARROW FROM SMALL CIRCLE;Sm;0;ON;;;;;N;;;;;
294A;LEFT BARB UP RIGHT BARB DOWN HARPOON;Sm;0;ON;;;;;N;;;;;
294B;LEFT BARB DOWN RIGHT BARB UP HARPOON;Sm;0;ON;;;;;N;;;;;
294C;UP BARB RIGHT DOWN BARB LEFT HARPOON;Sm;0;ON;;;;;N;;;;;
294D;UP BARB LEFT DOWN BARB RIGHT HARPOON;Sm;0;ON;;;;;N;;;;;
294E;LEFT BARB UP RIGHT BARB UP HARPOON;Sm;0;ON;;;;;N;;;;;
294F;UP BARB RIGHT DOWN BARB RIGHT HARPOON;Sm;0;ON;;;;;N;;;;;
2950;LEFT BARB DOWN RIGHT BARB DOWN HARPOON;Sm;0;ON;;;;;N;;;;;
2951;UP BARB LEFT DOWN BARB LEFT HARPOON;Sm;0;ON;;;;;N;;;;;
2952;LEFTWARDS HARPOON WITH BARB UP TO BAR;Sm;0;ON;;;;;N;;;;;
2953;RIGHTWARDS HARPOON WITH BARB UP TO BAR;Sm;0;ON;;;;;N;;;;;
2954;UPWARDS HARPOON WITH BARB RIGHT TO BAR;Sm;0;ON;;;;;N;;;;;
2955;DOWNWARDS HARPOON WITH BARB RIGHT TO BAR;Sm;0;ON;;;;;N;;;;;
2956;LEFTWARDS HARPOON WITH BARB DOWN TO BAR;Sm;0;ON;;;;;N;;;;;
2957;RIGHTWARDS HARPOON WITH BARB DOWN TO BAR;Sm;0;ON;;;;;N;;;;;
2958;UPWARDS HARPOON WITH BARB LEFT TO BAR;Sm;0;ON;;;;;N;;;;;
2959;DOWNWARDS HARPOON WITH BARB LEFT TO BAR;Sm;0;ON;;;;;N;;;;;
295A;LEFTWARDS HARPOON WITH BARB UP FROM BAR;Sm;0;ON;;;;;N;;;;;
295B;RIGHTWARDS HARPOON WITH BARB UP FROM BAR;Sm;0;ON;;;;;N;;;;;
295C;UPWARDS HARPOON WITH BARB RIGHT FROM BAR;Sm;0;ON;;;;;N;;;;;
295D;DOWNWARDS HARPOON WITH BARB RIGHT FROM BAR;Sm;0;ON;;;;;N;;;;;
295E;LEFTWARDS HARPOON WITH BARB DOWN FROM BAR;Sm;0;ON;;;;;N;;;;;
295F;RIGHTWARDS HARPOON WITH BARB DOWN FROM BAR;Sm;0;ON;;;;;N;;;;;
2960;UPWARDS HARPOON WITH BARB LEFT FROM BAR;Sm;0;ON;;;;;N;;;;;
2961;DOWNWARDS HARPOON WITH BARB LEFT FROM BAR;Sm;0;ON;;;;;N;;;;;
2962;LEFTWARDS HARPOON WITH BARB UP ABOVE LEFTWARDS HARPOON WITH BARB DOWN;Sm;0;ON;;;;;N;;;;;
2963;UPWARDS HARPOON WITH BARB LEFT BESIDE UPWARDS HARPOON WITH BARB RIGHT;Sm;0;ON;;;;;N;;;;;
2964;RIGHTWARDS HARPOON WITH BARB UP ABOVE RIGHTWARDS HARPOON WITH BARB DOWN;Sm;0;ON;;;;;N;;;;;
2965;DOWNWARDS HARPOON WITH BARB LEFT BESIDE DOWNWARDS HARPOON WITH BARB RIGHT;Sm;0;ON;;;;;N;;;;;
2966;LEFTWARDS HARPOON WITH BARB UP ABOVE RIGHTWARDS HARPOON WITH BARB UP;Sm;0;ON;;;;;N;;;;;
2967;LEFTWARDS HARPOON WITH BARB DOWN ABOVE RIGHTWARDS HARPOON WITH BARB DOWN;Sm;0;ON;;;;;N;;;;;
2968;RIGHTWARDS HARPOON WITH BARB UP ABOVE LEFTWARDS HARPOON WITH BARB UP;Sm;0;ON;;;;;N;;;;;
2969;RIGHTWARDS HARPOON WITH BARB DOWN ABOVE LEFTWARDS HARPOON WITH BARB DOWN;Sm;0;ON;;;;;N;;;;;
296A;LEFTWARDS HARPOON WITH BARB UP ABOVE LONG DASH;Sm;0;ON;;;;;N;;;;;
296B;LEFTWARDS HARPOON WITH BARB DOWN BELOW LONG DASH;Sm;0;ON;;;;;N;;;;;
296C;RIGHTWARDS HARPOON WITH BARB UP ABOVE LONG DASH;Sm;0;ON;;;;;N;;;;;
296D;RIGHTWARDS HARPOON WITH BARB DOWN BELOW LONG DASH;Sm;0;ON;;;;;N;;;;;
296E;UPWARDS HARPOON WITH BARB LEFT BESIDE DOWNWARDS HARPOON WITH BARB RIGHT;Sm;0;ON;;;;;N;;;;;
296F;DOWNWARDS HARPOON WITH BARB LEFT BESIDE UPWARDS HARPOON WITH BARB RIGHT;Sm;0;ON;;;;;N;;;;;
2970;RIGHT DOUBLE ARROW WITH ROUNDED HEAD;Sm;0;ON;;;;;N;;;;;
2971;EQUALS SIGN ABOVE RIGHTWARDS ARROW;Sm;0;ON;;;;;N;;;;;
2972;TILDE OPERATOR ABOVE RIGHTWARDS ARROW;Sm;0;ON;;;;;N;;;;;
2973;LEFTWARDS ARROW ABOVE TILDE OPERATOR;Sm;0;ON;;;;;N;;;;;
2974;RIGHTWARDS ARROW ABOVE TILDE OPERATOR;Sm;0;ON;;;;;N;;;;;
2975;RIGHTWARDS ARROW ABOVE ALMOST EQUAL TO;Sm;0;ON;;;;;N;;;;;
2976;LESS-THAN ABOVE LEFTWARDS ARROW;Sm;0;ON;;;;;N;;;;;
2977;LEFTWARDS ARROW THROUGH LESS-THAN;Sm;0;ON;;;;;N;;;;;
2978;GREATER-THAN ABOVE RIGHTWARDS ARROW;Sm;0;ON;;;;;N;;;;;
2979;SUBSET ABOVE RIGHTWARDS ARROW;Sm;0;ON;;;;;N;;;;;
297A;LEFTWARDS ARROW THROUGH SUBSET;Sm;0;ON;;;;;N;;;;;
297B;SUPERSET ABOVE LEFTWARDS ARROW;Sm;0;ON;;;;;N;;;;;
297C;LEFT FISH TAIL;Sm;0;ON;;;;;N;;;;;
297D;RIGHT FISH TAIL;Sm;0;ON;;;;;N;;;;;
297E;UP FISH TAIL;Sm;0;ON;;;;;N;;;;;
297F;DOWN FISH TAIL;Sm;0;ON;;;;;N;;;;;
2980;TRIPLE VERTICAL BAR DELIMITER;Sm;0;ON;;;;;N;;;;;
2981;Z NOTATION SPOT;Sm;0;ON;;;;;N;;;;;
2982;Z NOTATION TYPE COLON;Sm;0;ON;;;;;N;;;;;
2983;LEFT WHITE CURLY BRACKET;Ps;0;ON;;;;;Y;;;;;
2984;RIGHT WHITE CURLY BRACKET;Pe;0;ON;;;;;Y;;;;;
2985;LEFT WHITE PARENTHESIS;Ps;0;ON;;;;;Y;;;;;
2986;RIGHT WHITE PARENTHESIS;Pe;0;ON;;;;;Y;;;;;
2987;Z NOTATION LEFT IMAGE BRACKET;Ps;0;ON;;;;;Y;;;;;
2988;Z NOTATION RIGHT IMAGE BRACKET;Pe;0;ON;;;;;Y;;;;;
2989;Z NOTATION LEFT BINDING BRACKET;Ps;0;ON;;;;;Y;;;;;
298A;Z NOTATION RIGHT BINDING BRACKET;Pe;0;ON;;;;;Y;;;;;
298B;LEFT SQUARE BRACKET WITH UNDERBAR;Ps;0;ON;;;;;Y;;;;;
298C;RIGHT SQUARE BRACKET WITH UNDERBAR;Pe;0;ON;;;;;Y;;;;;
298D;LEFT SQUARE BRACKET WITH TICK IN TOP CORNER;Ps;0;ON;;;;;Y;;;;;
298E;RIGHT SQUARE BRACKET WITH TICK IN BOTTOM CORNER;Pe;0;ON;;;;;Y;;;;;
298F;LEFT SQUARE BRACKET WITH TICK IN BOTTOM CORNER;Ps;0;ON;;;;;Y;;;;;
2990;RIGHT SQUARE BRACKET WITH TICK IN TOP CORNER;Pe;0;ON;;;;;Y;;;;;
2991;LEFT ANGLE BRACKET WITH DOT;Ps;0;ON;;;;;Y;;;;;
2992;RIGHT ANGLE BRACKET WITH DOT;Pe;0;ON;;;;;Y;;;;;
2993;LEFT ARC LESS-THAN BRACKET;Ps;0;ON;;;;;Y;;;;;
2994;RIGHT ARC GREATER-THAN BRACKET;Pe;0;ON;;;;;Y;;;;;
2995;DOUBLE LEFT ARC GREATER-THAN BRACKET;Ps;0;ON;;;;;Y;;;;;
2996;DOUBLE RIGHT ARC LESS-THAN BRACKET;Pe;0;ON;;;;;Y;;;;;
2997;LEFT BLACK TORTOISE SHELL BRACKET;Ps;0;ON;;;;;Y;;;;;
2998;RIGHT BLACK TORTOISE SHELL BRACKET;Pe;0;ON;;;;;Y;;;;;
2999;DOTTED FENCE;Sm;0;ON;;;;;N;;;;;
299A;VERTICAL ZIGZAG LINE;Sm;0;ON;;;;;N;;;;;
299B;MEASURED ANGLE OPENING LEFT;Sm;0;ON;;;;;Y;;;;;
299C;RIGHT ANGLE VARIANT WITH SQUARE;Sm;0;ON;;;;;Y;;;;;
299D;MEASURED RIGHT ANGLE WITH DOT;Sm;0;ON;;;;;Y;;;;;
299E;ANGLE WITH S INSIDE;Sm;0;ON;;;;;Y;;;;;
299F;ACUTE ANGLE;Sm;0;ON;;;;;Y;;;;;
29A0;SPHERICAL ANGLE OPENING LEFT;Sm;0;ON;;;;;Y;;;;;
29A1;SPHERICAL ANGLE OPENING UP;Sm;0;ON;;;;;N;;;;;
29A2;TURNED ANGLE;Sm;0;ON;;;;;Y;;;;;
29A3;REVERSED ANGLE;Sm;0;ON;;;;;Y;;;;;
29A4;ANGLE WITH UNDERBAR;Sm;0;ON;;;;;Y;;;;;
29A5;REVERSED ANGLE WITH UNDERBAR;Sm;0;ON;;;;;Y;;;;;
29A6;OBLIQUE ANGLE OPENING UP;Sm;0;ON;;;;;Y;;;;;
29A7;OBLIQUE ANGLE OPENING DOWN;Sm;0;ON;;;;;Y;;;;;
29A8;MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING UP AND RIGHT;Sm;0;ON;;;;;Y;;;;;
29A9;MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING UP AND LEFT;Sm;0;ON;;;;;Y;;;;;
29AA;MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING DOWN AND RIGHT;Sm;0;ON;;;;;Y;;;;;
29AB;MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING DOWN AND LEFT;Sm;0;ON;;;;;Y;;;;;
29AC;MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING RIGHT AND UP;Sm;0;ON;;;;;Y;;;;;
29AD;MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING LEFT AND UP;Sm;0;ON;;;;;Y;;;;;
29AE;MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING RIGHT AND DOWN;Sm;0;ON;;;;;Y;;;;;
29AF;MEASURED ANGLE WITH OPEN ARM ENDING IN ARROW POINTING LEFT AND DOWN;Sm;0;ON;;;;;Y;;;;;
29B0;REVERSED EMPTY SET;Sm;0;ON;;;;;N;;;;;
29B1;EMPTY SET WITH OVERBAR;Sm;0;ON;;;;;N;;;;;
29B2;EMPTY SET WITH SMALL CIRCLE ABOVE;Sm;0;ON;;;;;N;;;;;
29B3;EMPTY SET WITH RIGHT ARROW ABOVE;Sm;0;ON;;;;;N;;;;;
29B4;EMPTY SET WITH LEFT ARROW ABOVE;Sm;0;ON;;;;;N;;;;;
29B5;CIRCLE WITH HORIZONTAL BAR;Sm;0;ON;;;;;N;;;;;
29B6;CIRCLED VERTICAL BAR;Sm;0;ON;;;;;N;;;;;
29B7;CIRCLED PARALLEL;Sm;0;ON;;;;;N;;;;;
29B8;CIRCLED REVERSE SOLIDUS;Sm;0;ON;;;;;Y;;;;;
29B9;CIRCLED PERPENDICULAR;Sm;0;ON;;;;;N;;;;;
29BA;CIRCLE DIVIDED BY HORIZONTAL BAR AND TOP HALF DIVIDED BY VERTICAL BAR;Sm;0;ON;;;;;N;;;;;
29BB;CIRCLE WITH SUPERIMPOSED X;Sm;0;ON;;;;;N;;;;;
29BC;CIRCLED ANTICLOCKWISE-ROTATED DIVISION SIGN;Sm;0;ON;;;;;N;;;;;
29BD;UP ARROW THROUGH CIRCLE;Sm;0;ON;;;;;N;;;;;
29BE;CIRCLED WHITE BULLET;Sm;0;ON;;;;;N;;;;;
29BF;CIRCLED BULLET;Sm;0;ON;;;;;N;;;;;
29C0;CIRCLED LESS-THAN;Sm;0;ON;;;;;Y;;;;;
29C1;CIRCLED GREATER-THAN;Sm;0;ON;;;;;Y;;;;;
29C2;CIRCLE WITH SMALL CIRCLE TO THE RIGHT;Sm;0;ON;;;;;Y;;;;;
29C3;CIRCLE WITH TWO HORIZONTAL STROKES TO THE RIGHT;Sm;0;ON;;;;;Y;;;;;
29C4;SQUARED RISING DIAGONAL SLASH;Sm;0;ON;;;;;Y;;;;;
29C5;SQUARED FALLING DIAGONAL SLASH;Sm;0;ON;;;;;Y;;;;;
29C6;SQUARED ASTERISK;Sm;0;ON;;;;;N;;;;;
29C7;SQUARED SMALL CIRCLE;Sm;0;ON;;;;;N;;;;;
29C8;SQUARED SQUARE;Sm;0;ON;;;;;N;;;;;
29C9;TWO JOINED SQUARES;Sm;0;ON;;;;;Y;;;;;
29CA;TRIANGLE WITH DOT ABOVE;Sm;0;ON;;;;;N;;;;;
29CB;TRIANGLE WITH UNDERBAR;Sm;0;ON;;;;;N;;;;;
29CC;S IN TRIANGLE;Sm;0;ON;;;;;N;;;;;
29CD;TRIANGLE WITH SERIFS AT BOTTOM;Sm;0;ON;;;;;N;;;;;
29CE;RIGHT TRIANGLE ABOVE LEFT TRIANGLE;Sm;0;ON;;;;;Y;;;;;
29CF;LEFT TRIANGLE BESIDE VERTICAL BAR;Sm;0;ON;;;;;Y;;;;;
29D0;VERTICAL BAR BESIDE RIGHT TRIANGLE;Sm;0;ON;;;;;Y;;;;;
29D1;BOWTIE WITH LEFT HALF BLACK;Sm;0;ON;;;;;Y;;;;;
29D2;BOWTIE WITH RIGHT HALF BLACK;Sm;0;ON;;;;;Y;;;;;
29D3;BLACK BOWTIE;Sm;0;ON;;;;;N;;;;;
29D4;TIMES WITH LEFT HALF BLACK;Sm;0;ON;;;;;Y;;;;;
29D5;TIMES WITH RIGHT HALF BLACK;Sm;0;ON;;;;;Y;;;;;
29D6;WHITE HOURGLASS;Sm;0;ON;;;;;N;;;;;
29D7;BLACK HOURGLASS;Sm;0;ON;;;;;N;;;;;
29D8;LEFT WIGGLY FENCE;Ps;0;ON;;;;;Y;;;;;
29D9;RIGHT WIGGLY FENCE;Pe;0;ON;;;;;Y;;;;;
29DA;LEFT DOUBLE WIGGLY FENCE;Ps;0;ON;;;;;Y;;;;;
29DB;RIGHT DOUBLE WIGGLY FENCE;Pe;0;ON;;;;;Y;;;;;
29DC;INCOMPLETE INFINITY;Sm;0;ON;;;;;Y;;;;;
29DD;TIE OVER INFINITY;Sm;0;ON;;;;;N;;;;;
29DE;INFINITY NEGATED WITH VERTICAL BAR;Sm;0;ON;;;;;N;;;;;
29DF;DOUBLE-ENDED MULTIMAP;Sm;0;ON;;;;;N;;;;;
29E0;SQUARE WITH CONTOURED OUTLINE;Sm;0;ON;;;;;N;;;;;
29E1;INCREASES AS;Sm;0;ON;;;;;Y;;;;;
29E2;SHUFFLE PRODUCT;Sm;0;ON;;;;;N;;;;;
29E3;EQUALS SIGN AND SLANTED PARALLEL;Sm;0;ON;;;;;Y;;;;;
29E4;EQUALS SIGN AND SLANTED PARALLEL WITH TILDE ABOVE;Sm;0;ON;;;;;Y;;;;;
29E5;IDENTICAL TO AND SLANTED PARALLEL;Sm;0;ON;;;;;Y;;;;;
29E6;GLEICH STARK;Sm;0;ON;;;;;N;;;;;
29E7;THERMODYNAMIC;Sm;0;ON;;;;;N;;;;;
29E8;DOWN-POINTING TRIANGLE WITH LEFT HALF BLACK;Sm;0;ON;;;;;Y;;;;;
29E9;DOWN-POINTING TRIANGLE WITH RIGHT HALF BLACK;Sm;0;ON;;;;;Y;;;;;
29EA;BLACK DIAMOND WITH DOWN ARROW;Sm;0;ON;;;;;N;;;;;
29EB;BLACK LOZENGE;Sm;0;ON;;;;;N;;;;;
29EC;WHITE CIRCLE WITH DOWN ARROW;Sm;0;ON;;;;;N;;;;;
29ED;BLACK CIRCLE WITH DOWN ARROW;Sm;0;ON;;;;;N;;;;;
29EE;ERROR-BARRED WHITE SQUARE;Sm;0;ON;;;;;N;;;;;
29EF;ERROR-BARRED BLACK SQUARE;Sm;0;ON;;;;;N;;;;;
29F0;ERROR-BARRED WHITE DIAMOND;Sm;0;ON;;;;;N;;;;;
29F1;ERROR-BARRED BLACK DIAMOND;Sm;0;ON;;;;;N;;;;;
29F2;ERROR-BARRED WHITE CIRCLE;Sm;0;ON;;;;;N;;;;;
29F3;ERROR-BARRED BLACK CIRCLE;Sm;0;ON;;;;;N;;;;;
29F4;RULE-DELAYED;Sm;0;ON;;;;;Y;;;;;
29F5;REVERSE SOLIDUS OPERATOR;Sm;0;ON;;;;;Y;;;;;
29F6;SOLIDUS WITH OVERBAR;Sm;0;ON;;;;;Y;;;;;
29F7;REVERSE SOLIDUS WITH HORIZONTAL STROKE;Sm;0;ON;;;;;Y;;;;;
29F8;BIG SOLIDUS;Sm;0;ON;;;;;Y;;;;;
29F9;BIG REVERSE SOLIDUS;Sm;0;ON;;;;;Y;;;;;
29FA;DOUBLE PLUS;Sm;0;ON;;;;;N;;;;;
29FB;TRIPLE PLUS;Sm;0;ON;;;;;N;;;;;
29FC;LEFT-POINTING CURVED ANGLE BRACKET;Ps;0;ON;;;;;Y;;;;;
29FD;RIGHT-POINTING CURVED ANGLE BRACKET;Pe;0;ON;;;;;Y;;;;;
29FE;TINY;Sm;0;ON;;;;;N;;;;;
29FF;MINY;Sm;0;ON;;;;;N;;;;;
2A00;N-ARY CIRCLED DOT OPERATOR;Sm;0;ON;;;;;N;;;;;
2A01;N-ARY CIRCLED PLUS OPERATOR;Sm;0;ON;;;;;N;;;;;
2A02;N-ARY CIRCLED TIMES OPERATOR;Sm;0;ON;;;;;N;;;;;
2A03;N-ARY UNION OPERATOR WITH DOT;Sm;0;ON;;;;;N;;;;;
2A04;N-ARY UNION OPERATOR WITH PLUS;Sm;0;ON;;;;;N;;;;;
2A05;N-ARY SQUARE INTERSECTION OPERATOR;Sm;0;ON;;;;;N;;;;;
2A06;N-ARY SQUARE UNION OPERATOR;Sm;0;ON;;;;;N;;;;;
2A07;TWO LOGICAL AND OPERATOR;Sm;0;ON;;;;;N;;;;;
2A08;TWO LOGICAL OR OPERATOR;Sm;0;ON;;;;;N;;;;;
2A09;N-ARY TIMES OPERATOR;Sm;0;ON;;;;;N;;;;;
2A0A;MODULO TWO SUM;Sm;0;ON;;;;;Y;;;;;
2A0B;SUMMATION WITH INTEGRAL;Sm;0;ON;;;;;Y;;;;;
2A0C;QUADRUPLE INTEGRAL OPERATOR;Sm;0;ON;<compat> 222B 222B 222B 222B;;;;Y;;;;;
2A0D;FINITE PART INTEGRAL;Sm;0;ON;;;;;Y;;;;;
2A0E;INTEGRAL WITH DOUBLE STROKE;Sm;0;ON;;;;;Y;;;;;
2A0F;INTEGRAL AVERAGE WITH SLASH;Sm;0;ON;;;;;Y;;;;;
2A10;CIRCULATION FUNCTION;Sm;0;ON;;;;;Y;;;;;
2A11;ANTICLOCKWISE INTEGRATION;Sm;0;ON;;;;;Y;;;;;
2A12;LINE INTEGRATION WITH RECTANGULAR PATH AROUND POLE;Sm;0;ON;;;;;Y;;;;;
2A13;LINE INTEGRATION WITH SEMICIRCULAR PATH AROUND POLE;Sm;0;ON;;;;;Y;;;;;
2A14;LINE INTEGRATION NOT INCLUDING THE POLE;Sm;0;ON;;;;;Y;;;;;
2A15;INTEGRAL AROUND A POINT OPERATOR;Sm;0;ON;;;;;Y;;;;;
2A16;QUATERNION INTEGRAL OPERATOR;Sm;0;ON;;;;;Y;;;;;
2A17;INTEGRAL WITH LEFTWARDS ARROW WITH HOOK;Sm;0;ON;;;;;Y;;;;;
2A18;INTEGRAL WITH TIMES SIGN;Sm;0;ON;;;;;Y;;;;;
2A19;INTEGRAL WITH INTERSECTION;Sm;0;ON;;;;;Y;;;;;
2A1A;INTEGRAL WITH UNION;Sm;0;ON;;;;;Y;;;;;
2A1B;INTEGRAL WITH OVERBAR;Sm;0;ON;;;;;Y;;;;;
2A1C;INTEGRAL WITH UNDERBAR;Sm;0;ON;;;;;Y;;;;;
2A1D;JOIN;Sm;0;ON;;;;;N;;;;;
2A1E;LARGE LEFT TRIANGLE OPERATOR;Sm;0;ON;;;;;Y;;;;;
2A1F;Z NOTATION SCHEMA COMPOSITION;Sm;0;ON;;;;;Y;;;;;
2A20;Z NOTATION SCHEMA PIPING;Sm;0;ON;;;;;Y;;;;;
2A21;Z NOTATION SCHEMA PROJECTION;Sm;0;ON;;;;;Y;;;;;
2A22;PLUS SIGN WITH SMALL CIRCLE ABOVE;Sm;0;ON;;;;;N;;;;;
2A23;PLUS SIGN WITH CIRCUMFLEX ACCENT ABOVE;Sm;0;ON;;;;;N;;;;;
2A24;PLUS SIGN WITH TILDE ABOVE;Sm;0;ON;;;;;Y;;;;;
2A25;PLUS SIGN WITH DOT BELOW;Sm;0;ON;;;;;N;;;;;
2A26;PLUS SIGN WITH TILDE BELOW;Sm;0;ON;;;;;Y;;;;;
2A27;PLUS SIGN WITH SUBSCRIPT TWO;Sm;0;ON;;;;;N;;;;;
2A28;PLUS SIGN WITH BLACK TRIANGLE;Sm;0;ON;;;;;N;;;;;
2A29;MINUS SIGN WITH COMMA ABOVE;Sm;0;ON;;;;;Y;;;;;
2A2A;MINUS SIGN WITH DOT BELOW;Sm;0;ON;;;;;N;;;;;
2A2B;MINUS SIGN WITH FALLING DOTS;Sm;0;ON;;;;;Y;;;;;
2A2C;MINUS SIGN WITH RISING DOTS;Sm;0;ON;;;;;Y;;;;;
2A2D;PLUS SIGN IN LEFT HALF CIRCLE;Sm;0;ON;;;;;Y;;;;;
2A2E;PLUS SIGN IN RIGHT HALF CIRCLE;Sm;0;ON;;;;;Y;;;;;
2A2F;VECTOR OR CROSS PRODUCT;Sm;0;ON;;;;;N;;;;;
2A30;MULTIPLICATION SIGN WITH DOT ABOVE;Sm;0;ON;;;;;N;;;;;
2A31;MULTIPLICATION SIGN WITH UNDERBAR;Sm;0;ON;;;;;N;;;;;
2A32;SEMIDIRECT PRODUCT WITH BOTTOM CLOSED;Sm;0;ON;;;;;N;;;;;
2A33;SMASH PRODUCT;Sm;0;ON;;;;;N;;;;;
2A34;MULTIPLICATION SIGN IN LEFT HALF CIRCLE;Sm;0;ON;;;;;Y;;;;;
2A35;MULTIPLICATION SIGN IN RIGHT HALF CIRCLE;Sm;0;ON;;;;;Y;;;;;
2A36;CIRCLED MULTIPLICATION SIGN WITH CIRCUMFLEX ACCENT;Sm;0;ON;;;;;N;;;;;
2A37;MULTIPLICATION SIGN IN DOUBLE CIRCLE;Sm;0;ON;;;;;N;;;;;
2A38;CIRCLED DIVISION SIGN;Sm;0;ON;;;;;N;;;;;
2A39;PLUS SIGN IN TRIANGLE;Sm;0;ON;;;;;N;;;;;
2A3A;MINUS SIGN IN TRIANGLE;Sm;0;ON;;;;;N;;;;;
2A3B;MULTIPLICATION SIGN IN TRIANGLE;Sm;0;ON;;;;;N;;;;;
2A3C;INTERIOR PRODUCT;Sm;0;ON;;;;;Y;;;;;
2A3D;RIGHTHAND INTERIOR PRODUCT;Sm;0;ON;;;;;Y;;;;;
2A3E;Z NOTATION RELATIONAL COMPOSITION;Sm;0;ON;;;;;Y;;;;;
2A3F;AMALGAMATION OR COPRODUCT;Sm;0;ON;;;;;N;;;;;
2A40;INTERSECTION WITH DOT;Sm;0;ON;;;;;N;;;;;
2A41;UNION WITH MINUS SIGN;Sm;0;ON;;;;;N;;;;;
2A42;UNION WITH OVERBAR;Sm;0;ON;;;;;N;;;;;
2A43;INTERSECTION WITH OVERBAR;Sm;0;ON;;;;;N;;;;;
2A44;INTERSECTION WITH LOGICAL AND;Sm;0;ON;;;;;N;;;;;
2A45;UNION WITH LOGICAL OR;Sm;0;ON;;;;;N;;;;;
2A46;UNION ABOVE INTERSECTION;Sm;0;ON;;;;;N;;;;;
2A47;INTERSECTION ABOVE UNION;Sm;0;ON;;;;;N;;;;;
2A48;UNION ABOVE BAR ABOVE INTERSECTION;Sm;0;ON;;;;;N;;;;;
2A49;INTERSECTION ABOVE BAR ABOVE UNION;Sm;0;ON;;;;;N;;;;;
2A4A;UNION BESIDE AND JOINED WITH UNION;Sm;0;ON;;;;;N;;;;;
2A4B;INTERSECTION BESIDE AND JOINED WITH INTERSECTION;Sm;0;ON;;;;;N;;;;;
2A4C;CLOSED UNION WITH SERIFS;Sm;0;ON;;;;;N;;;;;
2A4D;CLOSED INTERSECTION WITH SERIFS;Sm;0;ON;;;;;N;;;;;
2A4E;DOUBLE SQUARE INTERSECTION;Sm;0;ON;;;;;N;;;;;
2A4F;DOUBLE SQUARE UNION;Sm;0;ON;;;;;N;;;;;
2A50;CLOSED UNION WITH SERIFS AND SMASH PRODUCT;Sm;0;ON;;;;;N;;;;;
2A51;LOGICAL AND WITH DOT ABOVE;Sm;0;ON;;;;;N;;;;;
2A52;LOGICAL OR WITH DOT ABOVE;Sm;0;ON;;;;;N;;;;;
2A53;DOUBLE LOGICAL AND;Sm;0;ON;;;;;N;;;;;
2A54;DOUBLE LOGICAL OR;Sm;0;ON;;;;;N;;;;;
2A55;TWO INTERSECTING LOGICAL AND;Sm;0;ON;;;;;N;;;;;
2A56;TWO INTERSECTING LOGICAL OR;Sm;0;ON;;;;;N;;;;;
2A57;SLOPING LARGE OR;Sm;0;ON;;;;;Y;;;;;
2A58;SLOPING LARGE AND;Sm;0;ON;;;;;Y;;;;;
2A59;LOGICAL OR OVERLAPPING LOGICAL AND;Sm;0;ON;;;;;N;;;;;
2A5A;LOGICAL AND WITH MIDDLE STEM;Sm;0;ON;;;;;N;;;;;
2A5B;LOGICAL OR WITH MIDDLE STEM;Sm;0;ON;;;;;N;;;;;
2A5C;LOGICAL AND WITH HORIZONTAL DASH;Sm;0;ON;;;;;N;;;;;
2A5D;LOGICAL OR WITH HORIZONTAL DASH;Sm;0;ON;;;;;N;;;;;
2A5E;LOGICAL AND WITH DOUBLE OVERBAR;Sm;0;ON;;;;;N;;;;;
2A5F;LOGICAL AND WITH UNDERBAR;Sm;0;ON;;;;;N;;;;;
2A60;LOGICAL AND WITH DOUBLE UNDERBAR;Sm;0;ON;;;;;N;;;;;
2A61;SMALL VEE WITH UNDERBAR;Sm;0;ON;;;;;N;;;;;
2A62;LOGICAL OR WITH DOUBLE OVERBAR;Sm;0;ON;;;;;N;;;;;
2A63;LOGICAL OR WITH DOUBLE UNDERBAR;Sm;0;ON;;;;;N;;;;;
2A64;Z NOTATION DOMAIN ANTIRESTRICTION;Sm;0;ON;;;;;Y;;;;;
2A65;Z NOTATION RANGE ANTIRESTRICTION;Sm;0;ON;;;;;Y;;;;;
2A66;EQUALS SIGN WITH DOT BELOW;Sm;0;ON;;;;;N;;;;;
2A67;IDENTICAL WITH DOT ABOVE;Sm;0;ON;;;;;N;;;;;
2A68;TRIPLE HORIZONTAL BAR WITH DOUBLE VERTICAL STROKE;Sm;0;ON;;;;;N;;;;;
2A69;TRIPLE HORIZONTAL BAR WITH TRIPLE VERTICAL STROKE;Sm;0;ON;;;;;N;;;;;
2A6A;TILDE OPERATOR WITH DOT ABOVE;Sm;0;ON;;;;;Y;;;;;
2A6B;TILDE OPERATOR WITH RISING DOTS;Sm;0;ON;;;;;Y;;;;;
2A6C;SIMILAR MINUS SIMILAR;Sm;0;ON;;;;;Y;;;;;
2A6D;CONGRUENT WITH DOT ABOVE;Sm;0;ON;;;;;Y;;;;;
2A6E;EQUALS WITH ASTERISK;Sm;0;ON;;;;;N;;;;;
2A6F;ALMOST EQUAL TO WITH CIRCUMFLEX ACCENT;Sm;0;ON;;;;;Y;;;;;
2A70;APPROXIMATELY EQUAL OR EQUAL TO;Sm;0;ON;;;;;Y;;;;;
2A71;EQUALS SIGN ABOVE PLUS SIGN;Sm;0;ON;;;;;N;;;;;
2A72;PLUS SIGN ABOVE EQUALS SIGN;Sm;0;ON;;;;;N;;;;;
2A73;EQUALS SIGN ABOVE TILDE OPERATOR;Sm;0;ON;;;;;Y;;;;;
2A74;DOUBLE COLON EQUAL;Sm;0;ON;<compat> 003A 003A 003D;;;;Y;;;;;
2A75;TWO CONSECUTIVE EQUALS SIGNS;Sm;0;ON;<compat> 003D 003D;;;;N;;;;;
2A76;THREE CONSECUTIVE EQUALS SIGNS;Sm;0;ON;<compat> 003D 003D 003D;;;;N;;;;;
2A77;EQUALS SIGN WITH TWO DOTS ABOVE AND TWO DOTS BELOW;Sm;0;ON;;;;;N;;;;;
2A78;EQUIVALENT WITH FOUR DOTS ABOVE;Sm;0;ON;;;;;N;;;;;
2A79;LESS-THAN WITH CIRCLE INSIDE;Sm;0;ON;;;;;Y;;;;;
2A7A;GREATER-THAN WITH CIRCLE INSIDE;Sm;0;ON;;;;;Y;;;;;
2A7B;LESS-THAN WITH QUESTION MARK ABOVE;Sm;0;ON;;;;;Y;;;;;
2A7C;GREATER-THAN WITH QUESTION MARK ABOVE;Sm;0;ON;;;;;Y;;;;;
2A7D;LESS-THAN OR SLANTED EQUAL TO;Sm;0;ON;;;;;Y;;;;;
2A7E;GREATER-THAN OR SLANTED EQUAL TO;Sm;0;ON;;;;;Y;;;;;
2A7F;LESS-THAN OR SLANTED EQUAL TO WITH DOT INSIDE;Sm;0;ON;;;;;Y;;;;;
2A80;GREATER-THAN OR SLANTED EQUAL TO WITH DOT INSIDE;Sm;0;ON;;;;;Y;;;;;
2A81;LESS-THAN OR SLANTED EQUAL TO WITH DOT ABOVE;Sm;0;ON;;;;;Y;;;;;
2A82;GREATER-THAN OR SLANTED EQUAL TO WITH DOT ABOVE;Sm;0;ON;;;;;Y;;;;;
2A83;LESS-THAN OR SLANTED EQUAL TO WITH DOT ABOVE RIGHT;Sm;0;ON;;;;;Y;;;;;
2A84;GREATER-THAN OR SLANTED EQUAL TO WITH DOT ABOVE LEFT;Sm;0;ON;;;;;Y;;;;;
2A85;LESS-THAN OR APPROXIMATE;Sm;0;ON;;;;;Y;;;;;
2A86;GREATER-THAN OR APPROXIMATE;Sm;0;ON;;;;;Y;;;;;
2A87;LESS-THAN AND SINGLE-LINE NOT EQUAL TO;Sm;0;ON;;;;;Y;;;;;
2A88;GREATER-THAN AND SINGLE-LINE NOT EQUAL TO;Sm;0;ON;;;;;Y;;;;;
2A89;LESS-THAN AND NOT APPROXIMATE;Sm;0;ON;;;;;Y;;;;;
2A8A;GREATER-THAN AND NOT APPROXIMATE;Sm;0;ON;;;;;Y;;;;;
2A8B;LESS-THAN ABOVE DOUBLE-LINE EQUAL ABOVE GREATER-THAN;Sm;0;ON;;;;;Y;;;;;
2A8C;GREATER-THAN ABOVE DOUBLE-LINE EQUAL ABOVE LESS-THAN;Sm;0;ON;;;;;Y;;;;;
2A8D;LESS-THAN ABOVE SIMILAR OR EQUAL;Sm;0;ON;;;;;Y;;;;;
2A8E;GREATER-THAN ABOVE SIMILAR OR EQUAL;Sm;0;ON;;;;;Y;;;;;
2A8F;LESS-THAN ABOVE SIMILAR ABOVE GREATER-THAN;Sm;0;ON;;;;;Y;;;;;
2A90;GREATER-THAN ABOVE SIMILAR ABOVE LESS-THAN;Sm;0;ON;;;;;Y;;;;;
2A91;LESS-THAN ABOVE GREATER-THAN ABOVE DOUBLE-LINE EQUAL;Sm;0;ON;;;;;Y;;;;;
2A92;GREATER-THAN ABOVE LESS-THAN ABOVE DOUBLE-LINE EQUAL;Sm;0;ON;;;;;Y;;;;;
2A93;LESS-THAN ABOVE SLANTED EQUAL ABOVE GREATER-THAN ABOVE SLANTED EQUAL;Sm;0;ON;;;;;Y;;;;;
2A94;GREATER-THAN ABOVE SLANTED EQUAL ABOVE LESS-THAN ABOVE SLANTED EQUAL;Sm;0;ON;;;;;Y;;;;;
2A95;SLANTED EQUAL TO OR LESS-THAN;Sm;0;ON;;;;;Y;;;;;
2A96;SLANTED EQUAL TO OR GREATER-THAN;Sm;0;ON;;;;;Y;;;;;
2A97;SLANTED EQUAL TO OR LESS-THAN WITH DOT INSIDE;Sm;0;ON;;;;;Y;;;;;
2A98;SLANTED EQUAL TO OR GREATER-THAN WITH DOT INSIDE;Sm;0;ON;;;;;Y;;;;;
2A99;DOUBLE-LINE EQUAL TO OR LESS-THAN;Sm;0;ON;;;;;Y;;;;;
2A9A;DOUBLE-LINE EQUAL TO OR GREATER-THAN;Sm;0;ON;;;;;Y;;;;;
2A9B;DOUBLE-LINE SLANTED EQUAL TO OR LESS-THAN;Sm;0;ON;;;;;Y;;;;;
2A9C;DOUBLE-LINE SLANTED EQUAL TO OR GREATER-THAN;Sm;0;ON;;;;;Y;;;;;
2A9D;SIMILAR OR LESS-THAN;Sm;0;ON;;;;;Y;;;;;
2A9E;SIMILAR OR GREATER-THAN;Sm;0;ON;;;;;Y;;;;;
2A9F;SIMILAR ABOVE LESS-THAN ABOVE EQUALS SIGN;Sm;0;ON;;;;;Y;;;;;
2AA0;SIMILAR ABOVE GREATER-THAN ABOVE EQUALS SIGN;Sm;0;ON;;;;;Y;;;;;
2AA1;DOUBLE NESTED LESS-THAN;Sm;0;ON;;;;;Y;;;;;
2AA2;DOUBLE NESTED GREATER-THAN;Sm;0;ON;;;;;Y;;;;;
2AA3;DOUBLE NESTED LESS-THAN WITH UNDERBAR;Sm;0;ON;;;;;Y;;;;;
2AA4;GREATER-THAN OVERLAPPING LESS-THAN;Sm;0;ON;;;;;N;;;;;
2AA5;GREATER-THAN BESIDE LESS-THAN;Sm;0;ON;;;;;N;;;;;
2AA6;LESS-THAN CLOSED BY CURVE;Sm;0;ON;;;;;Y;;;;;
2AA7;GREATER-THAN CLOSED BY CURVE;Sm;0;ON;;;;;Y;;;;;
2AA8;LESS-THAN CLOSED BY CURVE ABOVE SLANTED EQUAL;Sm;0;ON;;;;;Y;;;;;
2AA9;GREATER-THAN CLOSED BY CURVE ABOVE SLANTED EQUAL;Sm;0;ON;;;;;Y;;;;;
2AAA;SMALLER THAN;Sm;0;ON;;;;;Y;;;;;
2AAB;LARGER THAN;Sm;0;ON;;;;;Y;;;;;
2AAC;SMALLER THAN OR EQUAL TO;Sm;0;ON;;;;;Y;;;;;
2AAD;LARGER THAN OR EQUAL TO;Sm;0;ON;;;;;Y;;;;;
2AAE;EQUALS SIGN WITH BUMPY ABOVE;Sm;0;ON;;;;;N;;;;;
2AAF;PRECEDES ABOVE SINGLE-LINE EQUALS SIGN;Sm;0;ON;;;;;Y;;;;;
2AB0;SUCCEEDS ABOVE SINGLE-LINE EQUALS SIGN;Sm;0;ON;;;;;Y;;;;;
2AB1;PRECEDES ABOVE SINGLE-LINE NOT EQUAL TO;Sm;0;ON;;;;;Y;;;;;
2AB2;SUCCEEDS ABOVE SINGLE-LINE NOT EQUAL TO;Sm;0;ON;;;;;Y;;;;;
2AB3;PRECEDES ABOVE EQUALS SIGN;Sm;0;ON;;;;;Y;;;;;
2AB4;SUCCEEDS ABOVE EQUALS SIGN;Sm;0;ON;;;;;Y;;;;;
2AB5;PRECEDES ABOVE NOT EQUAL TO;Sm;0;ON;;;;;Y;;;;;
2AB6;SUCCEEDS ABOVE NOT EQUAL TO;Sm;0;ON;;;;;Y;;;;;
2AB7;PRECEDES ABOVE ALMOST EQUAL TO;Sm;0;ON;;;;;Y;;;;;
2AB8;SUCCEEDS ABOVE ALMOST EQUAL TO;Sm;0;ON;;;;;Y;;;;;
2AB9;PRECEDES ABOVE NOT ALMOST EQUAL TO;Sm;0;ON;;;;;Y;;;;;
2ABA;SUCCEEDS ABOVE NOT ALMOST EQUAL TO;Sm;0;ON;;;;;Y;;;;;
2ABB;DOUBLE PRECEDES;Sm;0;ON;;;;;Y;;;;;
2ABC;DOUBLE SUCCEEDS;Sm;0;ON;;;;;Y;;;;;
2ABD;SUBSET WITH DOT;Sm;0;ON;;;;;Y;;;;;
2ABE;SUPERSET WITH DOT;Sm;0;ON;;;;;Y;;;;;
2ABF;SUBSET WITH PLUS SIGN BELOW;Sm;0;ON;;;;;Y;;;;;
2AC0;SUPERSET WITH PLUS SIGN BELOW;Sm;0;ON;;;;;Y;;;;;
2AC1;SUBSET WITH MULTIPLICATION SIGN BELOW;Sm;0;ON;;;;;Y;;;;;
2AC2;SUPERSET WITH MULTIPLICATION SIGN BELOW;Sm;0;ON;;;;;Y;;;;;
2AC3;SUBSET OF OR EQUAL TO WITH DOT ABOVE;Sm;0;ON;;;;;Y;;;;;
2AC4;SUPERSET OF OR EQUAL TO WITH DOT ABOVE;Sm;0;ON;;;;;Y;;;;;
2AC5;SUBSET OF ABOVE EQUALS SIGN;Sm;0;ON;;;;;Y;;;;;
2AC6;SUPERSET OF ABOVE EQUALS SIGN;Sm;0;ON;;;;;Y;;;;;
2AC7;SUBSET OF ABOVE TILDE OPERATOR;Sm;0;ON;;;;;Y;;;;;
2AC8;SUPERSET OF ABOVE TILDE OPERATOR;Sm;0;ON;;;;;Y;;;;;
2AC9;SUBSET OF ABOVE ALMOST EQUAL TO;Sm;0;ON;;;;;Y;;;;;
2ACA;SUPERSET OF ABOVE ALMOST EQUAL TO;Sm;0;ON;;;;;Y;;;;;
2ACB;SUBSET OF ABOVE NOT EQUAL TO;Sm;0;ON;;;;;Y;;;;;
2ACC;SUPERSET OF ABOVE NOT EQUAL TO;Sm;0;ON;;;;;Y;;;;;
2ACD;SQUARE LEFT OPEN BOX OPERATOR;Sm;0;ON;;;;;Y;;;;;
2ACE;SQUARE RIGHT OPEN BOX OPERATOR;Sm;0;ON;;;;;Y;;;;;
2ACF;CLOSED SUBSET;Sm;0;ON;;;;;Y;;;;;
2AD0;CLOSED SUPERSET;Sm;0;ON;;;;;Y;;;;;
2AD1;CLOSED SUBSET OR EQUAL TO;Sm;0;ON;;;;;Y;;;;;
2AD2;CLOSED SUPERSET OR EQUAL TO;Sm;0;ON;;;;;Y;;;;;
2AD3;SUBSET ABOVE SUPERSET;Sm;0;ON;;;;;Y;;;;;
2AD4;SUPERSET ABOVE SUBSET;Sm;0;ON;;;;;Y;;;;;
2AD5;SUBSET ABOVE SUBSET;Sm;0;ON;;;;;Y;;;;;
2AD6;SUPERSET ABOVE SUPERSET;Sm;0;ON;;;;;Y;;;;;
2AD7;SUPERSET BESIDE SUBSET;Sm;0;ON;;;;;N;;;;;
2AD8;SUPERSET BESIDE AND JOINED BY DASH WITH SUBSET;Sm;0;ON;;;;;N;;;;;
2AD9;ELEMENT OF OPENING DOWNWARDS;Sm;0;ON;;;;;N;;;;;
2ADA;PITCHFORK WITH TEE TOP;Sm;0;ON;;;;;N;;;;;
2ADB;TRANSVERSAL INTERSECTION;Sm;0;ON;;;;;N;;;;;
2ADC;FORKING;Sm;0;ON;2ADD 0338;;;;Y;;;;;
2ADD;NONFORKING;Sm;0;ON;;;;;N;;;;;
2ADE;SHORT LEFT TACK;Sm;0;ON;;;;;Y;;;;;
2ADF;SHORT DOWN TACK;Sm;0;ON;;;;;N;;;;;
2AE0;SHORT UP TACK;Sm;0;ON;;;;;N;;;;;
2AE1;PERPENDICULAR WITH S;Sm;0;ON;;;;;N;;;;;
2AE2;VERTICAL BAR TRIPLE RIGHT TURNSTILE;Sm;0;ON;;;;;Y;;;;;
2AE3;DOUBLE VERTICAL BAR LEFT TURNSTILE;Sm;0;ON;;;;;Y;;;;;
2AE4;VERTICAL BAR DOUBLE LEFT TURNSTILE;Sm;0;ON;;;;;Y;;;;;
2AE5;DOUBLE VERTICAL BAR DOUBLE LEFT TURNSTILE;Sm;0;ON;;;;;Y;;;;;
2AE6;LONG DASH FROM LEFT MEMBER OF DOUBLE VERTICAL;Sm;0;ON;;;;;Y;;;;;
2AE7;SHORT DOWN TACK WITH OVERBAR;Sm;0;ON;;;;;N;;;;;
2AE8;SHORT UP TACK WITH UNDERBAR;Sm;0;ON;;;;;N;;;;;
2AE9;SHORT UP TACK ABOVE SHORT DOWN TACK;Sm;0;ON;;;;;N;;;;;
2AEA;DOUBLE DOWN TACK;Sm;0;ON;;;;;N;;;;;
2AEB;DOUBLE UP TACK;Sm;0;ON;;;;;N;;;;;
2AEC;DOUBLE STROKE NOT SIGN;Sm;0;ON;;;;;Y;;;;;
2AED;REVERSED DOUBLE STROKE NOT SIGN;Sm;0;ON;;;;;Y;;;;;
2AEE;DOES NOT DIVIDE WITH REVERSED NEGATION SLASH;Sm;0;ON;;;;;Y;;;;;
2AEF;VERTICAL LINE WITH CIRCLE ABOVE;Sm;0;ON;;;;;N;;;;;
2AF0;VERTICAL LINE WITH CIRCLE BELOW;Sm;0;ON;;;;;N;;;;;
2AF1;DOWN TACK WITH CIRCLE BELOW;Sm;0;ON;;;;;N;;;;;
2AF2;PARALLEL WITH HORIZONTAL STROKE;Sm;0;ON;;;;;N;;;;;
2AF3;PARALLEL WITH TILDE OPERATOR;Sm;0;ON;;;;;Y;;;;;
2AF4;TRIPLE VERTICAL BAR BINARY RELATION;Sm;0;ON;;;;;N;;;;;
2AF5;TRIPLE VERTICAL BAR WITH HORIZONTAL STROKE;Sm;0;ON;;;;;N;;;;;
2AF6;TRIPLE COLON OPERATOR;Sm;0;ON;;;;;N;;;;;
2AF7;TRIPLE NESTED LESS-THAN;Sm;0;ON;;;;;Y;;;;;
2AF8;TRIPLE NESTED GREATER-THAN;Sm;0;ON;;;;;Y;;;;;
2AF9;DOUBLE-LINE SLANTED LESS-THAN OR EQUAL TO;Sm;0;ON;;;;;Y;;;;;
2AFA;DOUBLE-LINE SLANTED GREATER-THAN OR EQUAL TO;Sm;0;ON;;;;;Y;;;;;
2AFB;TRIPLE SOLIDUS BINARY RELATION;Sm;0;ON;;;;;Y;;;;;
2AFC;LARGE TRIPLE VERTICAL BAR OPERATOR;Sm;0;ON;;;;;N;;;;;
2AFD;DOUBLE SOLIDUS OPERATOR;Sm;0;ON;;;;;Y;;;;;
2AFE;WHITE VERTICAL BAR;Sm;0;ON;;;;;N;;;;;
2AFF;N-ARY WHITE VERTICAL BAR;Sm;0;ON;;;;;N;;;;;
2B00;NORTH EAST WHITE ARROW;So;0;ON;;;;;N;;;;;
2B01;NORTH WEST WHITE ARROW;So;0;ON;;;;;N;;;;;
2B02;SOUTH EAST WHITE ARROW;So;0;ON;;;;;N;;;;;
2B03;SOUTH WEST WHITE ARROW;So;0;ON;;;;;N;;;;;
2B04;LEFT RIGHT WHITE ARROW;So;0;ON;;;;;N;;;;;
2B05;LEFTWARDS BLACK ARROW;So;0;ON;;;;;N;;;;;
2B06;UPWARDS BLACK ARROW;So;0;ON;;;;;N;;;;;
2B07;DOWNWARDS BLACK ARROW;So;0;ON;;;;;N;;;;;
2B08;NORTH EAST BLACK ARROW;So;0;ON;;;;;N;;;;;
2B09;NORTH WEST BLACK ARROW;So;0;ON;;;;;N;;;;;
2B0A;SOUTH EAST BLACK ARROW;So;0;ON;;;;;N;;;;;
2B0B;SOUTH WEST BLACK ARROW;So;0;ON;;;;;N;;;;;
2B0C;LEFT RIGHT BLACK ARROW;So;0;ON;;;;;N;;;;;
2B0D;UP DOWN BLACK ARROW;So;0;ON;;;;;N;;;;;
2B0E;RIGHTWARDS ARROW WITH TIP DOWNWARDS;So;0;ON;;;;;N;;;;;
2B0F;RIGHTWARDS ARROW WITH TIP UPWARDS;So;0;ON;;;;;N;;;;;
2B10;LEFTWARDS ARROW WITH TIP DOWNWARDS;So;0;ON;;;;;N;;;;;
2B11;LEFTWARDS ARROW WITH TIP UPWARDS;So;0;ON;;;;;N;;;;;
2B12;SQUARE WITH TOP HALF BLACK;So;0;ON;;;;;N;;;;;
2B13;SQUARE WITH BOTTOM HALF BLACK;So;0;ON;;;;;N;;;;;
2B14;SQUARE WITH UPPER RIGHT DIAGONAL HALF BLACK;So;0;ON;;;;;N;;;;;
2B15;SQUARE WITH LOWER LEFT DIAGONAL HALF BLACK;So;0;ON;;;;;N;;;;;
2B16;DIAMOND WITH LEFT HALF BLACK;So;0;ON;;;;;N;;;;;
2B17;DIAMOND WITH RIGHT HALF BLACK;So;0;ON;;;;;N;;;;;
2B18;DIAMOND WITH TOP HALF BLACK;So;0;ON;;;;;N;;;;;
2B19;DIAMOND WITH BOTTOM HALF BLACK;So;0;ON;;;;;N;;;;;
2B1A;DOTTED SQUARE;So;0;ON;;;;;N;;;;;
2B1B;BLACK LARGE SQUARE;So;0;ON;;;;;N;;;;;
2B1C;WHITE LARGE SQUARE;So;0;ON;;;;;N;;;;;
2B1D;BLACK VERY SMALL SQUARE;So;0;ON;;;;;N;;;;;
2B1E;WHITE VERY SMALL SQUARE;So;0;ON;;;;;N;;;;;
2B1F;BLACK PENTAGON;So;0;ON;;;;;N;;;;;
2B20;WHITE PENTAGON;So;0;ON;;;;;N;;;;;
2B21;WHITE HEXAGON;So;0;ON;;;;;N;;;;;
2B22;BLACK HEXAGON;So;0;ON;;;;;N;;;;;
2B23;HORIZONTAL BLACK HEXAGON;So;0;ON;;;;;N;;;;;
2B24;BLACK LARGE CIRCLE;So;0;ON;;;;;N;;;;;
2B25;BLACK MEDIUM DIAMOND;So;0;ON;;;;;N;;;;;
2B26;WHITE MEDIUM DIAMOND;So;0;ON;;;;;N;;;;;
2B27;BLACK MEDIUM LOZENGE;So;0;ON;;;;;N;;;;;
2B28;WHITE MEDIUM LOZENGE;So;0;ON;;;;;N;;;;;
2B29;BLACK SMALL DIAMOND;So;0;ON;;;;;N;;;;;
2B2A;BLACK SMALL LOZENGE;So;0;ON;;;;;N;;;;;
2B2B;WHITE SMALL LOZENGE;So;0;ON;;;;;N;;;;;
2B2C;BLACK HORIZONTAL ELLIPSE;So;0;ON;;;;;N;;;;;
2B2D;WHITE HORIZONTAL ELLIPSE;So;0;ON;;;;;N;;;;;
2B2E;BLACK VERTICAL ELLIPSE;So;0;ON;;;;;N;;;;;
2B2F;WHITE VERTICAL ELLIPSE;So;0;ON;;;;;N;;;;;
2B30;LEFT ARROW WITH SMALL CIRCLE;Sm;0;ON;;;;;N;;;;;
2B31;THREE LEFTWARDS ARROWS;Sm;0;ON;;;;;N;;;;;
2B32;LEFT ARROW WITH CIRCLED PLUS;Sm;0;ON;;;;;N;;;;;
2B33;LONG LEFTWARDS SQUIGGLE ARROW;Sm;0;ON;;;;;N;;;;;
2B34;LEFTWARDS TWO-HEADED ARROW WITH VERTICAL STROKE;Sm;0;ON;;;;;N;;;;;
2B35;LEFTWARDS TWO-HEADED ARROW WITH DOUBLE VERTICAL STROKE;Sm;0;ON;;;;;N;;;;;
2B36;LEFTWARDS TWO-HEADED ARROW FROM BAR;Sm;0;ON;;;;;N;;;;;
2B37;LEFTWARDS TWO-HEADED TRIPLE DASH ARROW;Sm;0;ON;;;;;N;;;;;
2B38;LEFTWARDS ARROW WITH DOTTED STEM;Sm;0;ON;;;;;N;;;;;
2B39;LEFTWARDS ARROW WITH TAIL WITH VERTICAL STROKE;Sm;0;ON;;;;;N;;;;;
2B3A;LEFTWARDS ARROW WITH TAIL WITH DOUBLE VERTICAL STROKE;Sm;0;ON;;;;;N;;;;;
2B3B;LEFTWARDS TWO-HEADED ARROW WITH TAIL;Sm;0;ON;;;;;N;;;;;
2B3C;LEFTWARDS TWO-HEADED ARROW WITH TAIL WITH VERTICAL STROKE;Sm;0;ON;;;;;N;;;;;
2B3D;LEFTWARDS TWO-HEADED ARROW WITH TAIL WITH DOUBLE VERTICAL STROKE;Sm;0;ON;;;;;N;;;;;
2B3E;LEFTWARDS ARROW THROUGH X;Sm;0;ON;;;;;N;;;;;
2B3F;WAVE ARROW POINTING DIRECTLY LEFT;Sm;0;ON;;;;;N;;;;;
2B40;EQUALS SIGN ABOVE LEFTWARDS ARROW;Sm;0;ON;;;;;N;;;;;
2B41;REVERSE TILDE OPERATOR ABOVE LEFTWARDS ARROW;Sm;0;ON;;;;;N;;;;;
2B42;LEFTWARDS ARROW ABOVE REVERSE ALMOST EQUAL TO;Sm;0;ON;;;;;N;;;;;
2B43;RIGHTWARDS ARROW THROUGH GREATER-THAN;Sm;0;ON;;;;;N;;;;;
2B44;RIGHTWARDS ARROW THROUGH SUPERSET;Sm;0;ON;;;;;N;;;;;
2B45;LEFTWARDS QUADRUPLE ARROW;So;0;ON;;;;;N;;;;;
2B46;RIGHTWARDS QUADRUPLE ARROW;So;0;ON;;;;;N;;;;;
2B47;REVERSE TILDE OPERATOR ABOVE RIGHTWARDS ARROW;Sm;0;ON;;;;;N;;;;;
2B48;RIGHTWARDS ARROW ABOVE REVERSE ALMOST EQUAL TO;Sm;0;ON;;;;;N;;;;;
2B49;TILDE OPERATOR ABOVE LEFTWARDS ARROW;Sm;0;ON;;;;;N;;;;;
2B4A;LEFTWARDS ARROW ABOVE ALMOST EQUAL TO;Sm;0;ON;;;;;N;;;;;
2B4B;LEFTWARDS ARROW ABOVE REVERSE TILDE OPERATOR;Sm;0;ON;;;;;N;;;;;
2B4C;RIGHTWARDS ARROW ABOVE REVERSE TILDE OPERATOR;Sm;0;ON;;;;;N;;;;;
2B4D;DOWNWARDS TRIANGLE-HEADED ZIGZAG ARROW;So;0;ON;;;;;N;;;;;
2B4E;SHORT SLANTED NORTH ARROW;So;0;ON;;;;;N;;;;;
2B4F;SHORT BACKSLANTED SOUTH ARROW;So;0;ON;;;;;N;;;;;
2B50;WHITE MEDIUM STAR;So;0;ON;;;;;N;;;;;
2B51;BLACK SMALL STAR;So;0;ON;;;;;N;;;;;
2B52;WHITE SMALL STAR;So;0;ON;;;;;N;;;;;
2B53;BLACK RIGHT-POINTING PENTAGON;So;0;ON;;;;;N;;;;;
2B54;WHITE RIGHT-POINTING PENTAGON;So;0;ON;;;;;N;;;;;
2B55;HEAVY LARGE CIRCLE;So;0;ON;;;;;N;;;;;
2B56;HEAVY OVAL WITH OVAL INSIDE;So;0;ON;;;;;N;;;;;
2B57;HEAVY CIRCLE WITH CIRCLE INSIDE;So;0;ON;;;;;N;;;;;
2B58;HEAVY CIRCLE;So;0;ON;;;;;N;;;;;
2B59;HEAVY CIRCLED SALTIRE;So;0;ON;;;;;N;;;;;
2B5A;SLANTED NORTH ARROW WITH HOOKED HEAD;So;0;ON;;;;;N;;;;;
2B5B;BACKSLANTED SOUTH ARROW WITH HOOKED TAIL;So;0;ON;;;;;N;;;;;
2B5C;SLANTED NORTH ARROW WITH HORIZONTAL TAIL;So;0;ON;;;;;N;;;;;
2B5D;BACKSLANTED SOUTH ARROW WITH HORIZONTAL TAIL;So;0;ON;;;;;N;;;;;
2B5E;BENT ARROW POINTING DOWNWARDS THEN NORTH EAST;So;0;ON;;;;;N;;;;;
2B5F;SHORT BENT ARROW POINTING DOWNWARDS THEN NORTH EAST;So;0;ON;;;;;N;;;;;
2B60;LEFTWARDS TRIANGLE-HEADED ARROW;So;0;ON;;;;;N;;;;;
2B61;UPWARDS TRIANGLE-HEADED ARROW;So;0;ON;;;;;N;;;;;
2B62;RIGHTWARDS TRIANGLE-HEADED ARROW;So;0;ON;;;;;N;;;;;
2B63;DOWNWARDS TRIANGLE-HEADED ARROW;So;0;ON;;;;;N;;;;;
2B64;LEFT RIGHT TRIANGLE-HEADED ARROW;So;0;ON;;;;;N;;;;;
2B65;UP DOWN TRIANGLE-HEADED ARROW;So;0;ON;;;;;N;;;;;
2B66;NORTH WEST TRIANGLE-HEADED ARROW;So;0;ON;;;;;N;;;;;
2B67;NORTH EAST TRIANGLE-HEADED ARROW;So;0;ON;;;;;N;;;;;
2B68;SOUTH EAST TRIANGLE-HEADED ARROW;So;0;ON;;;;;N;;;;;
2B69;SOUTH WEST TRIANGLE-HEADED ARROW;So;0;ON;;;;;N;;;;;
2B6A;LEFTWARDS TRIANGLE-HEADED DASHED ARROW;So;0;ON;;;;;N;;;;;
2B6B;UPWARDS TRIANGLE-HEADED DASHED ARROW;So;0;ON;;;;;N;;;;;
2B6C;RIGHTWARDS TRIANGLE-HEADED DASHED ARROW;So;0;ON;;;;;N;;;;;
2B6D;DOWNWARDS TRIANGLE-HEADED DASHED ARROW;So;0;ON;;;;;N;;;;;
2B6E;CLOCKWISE TRIANGLE-HEADED OPEN CIRCLE ARROW;So;0;ON;;;;;N;;;;;
2B6F;ANTICLOCKWISE TRIANGLE-HEADED OPEN CIRCLE ARROW;So;0;ON;;;;;N;;;;;
2B70;LEFTWARDS TRIANGLE-HEADED ARROW TO BAR;So;0;ON;;;;;N;;;;;
2B71;UPWARDS TRIANGLE-HEADED ARROW TO BAR;So;0;ON;;;;;N;;;;;
2B72;RIGHTWARDS TRIANGLE-HEADED ARROW TO BAR;So;0;ON;;;;;N;;;;;
2B73;DOWNWARDS TRIANGLE-HEADED ARROW TO BAR;So;0;ON;;;;;N;;;;;
2B76;NORTH WEST TRIANGLE-HEADED ARROW TO BAR;So;0;ON;;;;;N;;;;;
2B77;NORTH EAST TRIANGLE-HEADED ARROW TO BAR;So;0;ON;;;;;N;;;;;
2B78;SOUTH EAST TRIANGLE-HEADED ARROW TO BAR;So;0;ON;;;;;N;;;;;
2B79;SOUTH WEST TRIANGLE-HEADED ARROW TO BAR;So;0;ON;;;;;N;;;;;
2B7A;LEFTWARDS TRIANGLE-HEADED ARROW WITH DOUBLE HORIZONTAL STROKE;So;0;ON;;;;;N;;;;;
2B7B;UPWARDS TRIANGLE-HEADED ARROW WITH DOUBLE HORIZONTAL STROKE;So;0;ON;;;;;N;;;;;
2B7C;RIGHTWARDS TRIANGLE-HEADED ARROW WITH DOUBLE HORIZONTAL STROKE;So;0;ON;;;;;N;;;;;
2B7D;DOWNWARDS TRIANGLE-HEADED ARROW WITH DOUBLE HORIZONTAL STROKE;So;0;ON;;;;;N;;;;;
2B7E;HORIZONTAL TAB KEY;So;0;ON;;;;;N;;;;;
2B7F;VERTICAL TAB KEY;So;0;ON;;;;;N;;;;;
2B80;LEFTWARDS TRIANGLE-HEADED ARROW OVER RIGHTWARDS TRIANGLE-HEADED ARROW;So;0;ON;;;;;N;;;;;
2B81;UPWARDS TRIANGLE-HEADED ARROW LEFTWARDS OF DOWNWARDS TRIANGLE-HEADED ARROW;So;0;ON;;;;;N;;;;;
2B82;RIGHTWARDS TRIANGLE-HEADED ARROW OVER LEFTWARDS TRIANGLE-HEADED ARROW;So;0;ON;;;;;N;;;;;
2B83;DOWNWARDS TRIANGLE-HEADED ARROW LEFTWARDS OF UPWARDS TRIANGLE-HEADED ARROW;So;0;ON;;;;;N;;;;;
2B84;LEFTWARDS TRIANGLE-HEADED PAIRED ARROWS;So;0;ON;;;;;N;;;;;
2B85;UPWARDS TRIANGLE-HEADED PAIRED ARROWS;So;0;ON;;;;;N;;;;;
2B86;RIGHTWARDS TRIANGLE-HEADED PAIRED ARROWS;So;0;ON;;;;;N;;;;;
2B87;DOWNWARDS TRIANGLE-HEADED PAIRED ARROWS;So;0;ON;;;;;N;;;;;
2B88;LEFTWARDS BLACK CIRCLED WHITE ARROW;So;0;ON;;;;;N;;;;;
2B89;UPWARDS BLACK CIRCLED WHITE ARROW;So;0;ON;;;;;N;;;;;
2B8A;RIGHTWARDS BLACK CIRCLED WHITE ARROW;So;0;ON;;;;;N;;;;;
2B8B;DOWNWARDS BLACK CIRCLED WHITE ARROW;So;0;ON;;;;;N;;;;;
2B8C;ANTICLOCKWISE TRIANGLE-HEADED RIGHT U-SHAPED ARROW;So;0;ON;;;;;N;;;;;
2B8D;ANTICLOCKWISE TRIANGLE-HEADED BOTTOM U-SHAPED ARROW;So;0;ON;;;;;N;;;;;
2B8E;ANTICLOCKWISE TRIANGLE-HEADED LEFT U-SHAPED ARROW;So;0;ON;;;;;N;;;;;
2B8F;ANTICLOCKWISE TRIANGLE-HEADED TOP U-SHAPED ARROW;So;0;ON;;;;;N;;;;;
2B90;RETURN LEFT;So;0;ON;;;;;N;;;;;
2B91;RETURN RIGHT;So;0;ON;;;;;N;;;;;
2B92;NEWLINE LEFT;So;0;ON;;;;;N;;;;;
2B93;NEWLINE RIGHT;So;0;ON;;;;;N;;;;;
2B94;FOUR CORNER ARROWS CIRCLING ANTICLOCKWISE;So;0;ON;;;;;N;;;;;
2B95;RIGHTWARDS BLACK ARROW;So;0;ON;;;;;N;;;;;
2B97;SYMBOL FOR TYPE A ELECTRONICS;So;0;ON;;;;;N;;;;;
2B98;THREE-D TOP-LIGHTED LEFTWARDS EQUILATERAL ARROWHEAD;So;0;ON;;;;;N;;;;;
2B99;THREE-D RIGHT-LIGHTED UPWARDS EQUILATERAL ARROWHEAD;So;0;ON;;;;;N;;;;;
2B9A;THREE-D TOP-LIGHTED RIGHTWARDS EQUILATERAL ARROWHEAD;So;0;ON;;;;;N;;;;;
2B9B;THREE-D LEFT-LIGHTED DOWNWARDS EQUILATERAL ARROWHEAD;So;0;ON;;;;;N;;;;;
2B9C;BLACK LEFTWARDS EQUILATERAL ARROWHEAD;So;0;ON;;;;;N;;;;;
2B9D;BLACK UPWARDS EQUILATERAL ARROWHEAD;So;0;ON;;;;;N;;;;;
2B9E;BLACK RIGHTWARDS EQUILATERAL ARROWHEAD;So;0;ON;;;;;N;;;;;
2B9F;BLACK DOWNWARDS EQUILATERAL ARROWHEAD;So;0;ON;;;;;N;;;;;
2BA0;DOWNWARDS TRIANGLE-HEADED ARROW WITH LONG TIP LEFTWARDS;So;0;ON;;;;;N;;;;;
2BA1;DOWNWARDS TRIANGLE-HEADED ARROW WITH LONG TIP RIGHTWARDS;So;0;ON;;;;;N;;;;;
2BA2;UPWARDS TRIANGLE-HEADED ARROW WITH LONG TIP LEFTWARDS;So;0;ON;;;;;N;;;;;
2BA3;UPWARDS TRIANGLE-HEADED ARROW WITH LONG TIP RIGHTWARDS;So;0;ON;;;;;N;;;;;
2BA4;LEFTWARDS TRIANGLE-HEADED ARROW WITH LONG TIP UPWARDS;So;0;ON;;;;;N;;;;;
2BA5;RIGHTWARDS TRIANGLE-HEADED ARROW WITH LONG TIP UPWARDS;So;0;ON;;;;;N;;;;;
2BA6;LEFTWARDS TRIANGLE-HEADED ARROW WITH LONG TIP DOWNWARDS;So;0;ON;;;;;N;;;;;
2BA7;RIGHTWARDS TRIANGLE-HEADED ARROW WITH LONG TIP DOWNWARDS;So;0;ON;;;;;N;;;;;
2BA8;BLACK CURVED DOWNWARDS AND LEFTWARDS ARROW;So;0;ON;;;;;N;;;;;
2BA9;BLACK CURVED DOWNWARDS AND RIGHTWARDS ARROW;So;0;ON;;;;;N;;;;;
2BAA;BLACK CURVED UPWARDS AND LEFTWARDS ARROW;So;0;ON;;;;;N;;;;;
2BAB;BLACK CURVED UPWARDS AND RIGHTWARDS ARROW;So;0;ON;;;;;N;;;;;
2BAC;BLACK CURVED LEFTWARDS AND UPWARDS ARROW;So;0;ON;;;;;N;;;;;
2BAD;BLACK CURVED RIGHTWARDS AND UPWARDS ARROW;So;0;ON;;;;;N;;;;;
2BAE;BLACK CURVED LEFTWARDS AND DOWNWARDS ARROW;So;0;ON;;;;;N;;;;;
2BAF;BLACK CURVED RIGHTWARDS AND DOWNWARDS ARROW;So;0;ON;;;;;N;;;;;
2BB0;RIBBON ARROW DOWN LEFT;So;0;ON;;;;;N;;;;;
2BB1;RIBBON ARROW DOWN RIGHT;So;0;ON;;;;;N;;;;;
2BB2;RIBBON ARROW UP LEFT;So;0;ON;;;;;N;;;;;
2BB3;RIBBON ARROW UP RIGHT;So;0;ON;;;;;N;;;;;
2BB4;RIBBON ARROW LEFT UP;So;0;ON;;;;;N;;;;;
2BB5;RIBBON ARROW RIGHT UP;So;0;ON;;;;;N;;;;;
2BB6;RIBBON ARROW LEFT DOWN;So;0;ON;;;;;N;;;;;
2BB7;RIBBON ARROW RIGHT DOWN;So;0;ON;;;;;N;;;;;
2BB8;UPWARDS WHITE ARROW FROM BAR WITH HORIZONTAL BAR;So;0;ON;;;;;N;;;;;
2BB9;UP ARROWHEAD IN A RECTANGLE BOX;So;0;ON;;;;;N;;;;;
2BBA;OVERLAPPING WHITE SQUARES;So;0;ON;;;;;N;;;;;
2BBB;OVERLAPPING WHITE AND BLACK SQUARES;So;0;ON;;;;;N;;;;;
2BBC;OVERLAPPING BLACK SQUARES;So;0;ON;;;;;N;;;;;
2BBD;BALLOT BOX WITH LIGHT X;So;0;ON;;;;;N;;;;;
2BBE;CIRCLED X;So;0;ON;;;;;N;;;;;
2BBF;CIRCLED BOLD X;So;0;ON;;;;;N;;;;;
2BC0;BLACK SQUARE CENTRED;So;0;ON;;;;;N;;;;;
2BC1;BLACK DIAMOND CENTRED;So;0;ON;;;;;N;;;;;
2BC2;TURNED BLACK PENTAGON;So;0;ON;;;;;N;;;;;
2BC3;HORIZONTAL BLACK OCTAGON;So;0;ON;;;;;N;;;;;
2BC4;BLACK OCTAGON;So;0;ON;;;;;N;;;;;
2BC5;BLACK MEDIUM UP-POINTING TRIANGLE CENTRED;So;0;ON;;;;;N;;;;;
2BC6;BLACK MEDIUM DOWN-POINTING TRIANGLE CENTRED;So;0;ON;;;;;N;;;;;
2BC7;BLACK MEDIUM LEFT-POINTING TRIANGLE CENTRED;So;0;ON;;;;;N;;;;;
2BC8;BLACK MEDIUM RIGHT-POINTING TRIANGLE CENTRED;So;0;ON;;;;;N;;;;;
2BC9;NEPTUNE FORM TWO;So;0;ON;;;;;N;;;;;
2BCA;TOP HALF BLACK CIRCLE;So;0;ON;;;;;N;;;;;
2BCB;BOTTOM HALF BLACK CIRCLE;So;0;ON;;;;;N;;;;;
2BCC;LIGHT FOUR POINTED BLACK CUSP;So;0;ON;;;;;N;;;;;
2BCD;ROTATED LIGHT FOUR POINTED BLACK CUSP;So;0;ON;;;;;N;;;;;
2BCE;WHITE FOUR POINTED CUSP;So;0;ON;;;;;N;;;;;
2BCF;ROTATED WHITE FOUR POINTED CUSP;So;0;ON;;;;;N;;;;;
2BD0;SQUARE POSITION INDICATOR;So;0;ON;;;;;N;;;;;
2BD1;UNCERTAINTY SIGN;So;0;ON;;;;;N;;;;;
2BD2;GROUP MARK;So;0;ON;;;;;N;;;;;
2BD3;PLUTO FORM TWO;So;0;ON;;;;;N;;;;;
2BD4;PLUTO FORM THREE;So;0;ON;;;;;N;;;;;
2BD5;PLUTO FORM FOUR;So;0;ON;;;;;N;;;;;
2BD6;PLUTO FORM FIVE;So;0;ON;;;;;N;;;;;
2BD7;TRANSPLUTO;So;0;ON;;;;;N;;;;;
2BD8;PROSERPINA;So;0;ON;;;;;N;;;;;
2BD9;ASTRAEA;So;0;ON;;;;;N;;;;;
2BDA;HYGIEA;So;0;ON;;;;;N;;;;;
2BDB;PHOLUS;So;0;ON;;;;;N;;;;;
2BDC;NESSUS;So;0;ON;;;;;N;;;;;
2BDD;WHITE MOON SELENA;So;0;ON;;;;;N;;;;;
2BDE;BLACK DIAMOND ON CROSS;So;0;ON;;;;;N;;;;;
2BDF;TRUE LIGHT MOON ARTA;So;0;ON;;;;;N;;;;;
2BE0;CUPIDO;So;0;ON;;;;;N;;;;;
2BE1;HADES;So;0;ON;;;;;N;;;;;
2BE2;ZEUS;So;0;ON;;;;;N;;;;;
2BE3;KRONOS;So;0;ON;;;;;N;;;;;
2BE4;APOLLON;So;0;ON;;;;;N;;;;;
2BE5;ADMETOS;So;0;ON;;;;;N;;;;;
2BE6;VULCANUS;So;0;ON;;;;;N;;;;;
2BE7;POSEIDON;So;0;ON;;;;;N;;;;;
2BE8;LEFT HALF BLACK STAR;So;0;ON;;;;;N;;;;;
2BE9;RIGHT HALF BLACK STAR;So;0;ON;;;;;N;;;;;
2BEA;STAR WITH LEFT HALF BLACK;So;0;ON;;;;;N;;;;;
2BEB;STAR WITH RIGHT HALF BLACK;So;0;ON;;;;;N;;;;;
2BEC;LEFTWARDS TWO-HEADED ARROW WITH TRIANGLE ARROWHEADS;So;0;ON;;;;;N;;;;;
2BED;UPWARDS TWO-HEADED ARROW WITH TRIANGLE ARROWHEADS;So;0;ON;;;;;N;;;;;
2BEE;RIGHTWARDS TWO-HEADED ARROW WITH TRIANGLE ARROWHEADS;So;0;ON;;;;;N;;;;;
2BEF;DOWNWARDS TWO-HEADED ARROW WITH TRIANGLE ARROWHEADS;So;0;ON;;;;;N;;;;;
2BF0;ERIS FORM ONE;So;0;ON;;;;;N;;;;;
2BF1;ERIS FORM TWO;So;0;ON;;;;;N;;;;;
2BF2;SEDNA;So;0;ON;;;;;N;;;;;
2BF3;RUSSIAN ASTROLOGICAL SYMBOL VIGINTILE;So;0;ON;;;;;N;;;;;
2BF4;RUSSIAN ASTROLOGICAL SYMBOL NOVILE;So;0;ON;;;;;N;;;;;
2BF5;RUSSIAN ASTROLOGICAL SYMBOL QUINTILE;So;0;ON;;;;;N;;;;;
2BF6;RUSSIAN ASTROLOGICAL SYMBOL BINOVILE;So;0;ON;;;;;N;;;;;
2BF7;RUSSIAN ASTROLOGICAL SYMBOL SENTAGON;So;0;ON;;;;;N;;;;;
2BF8;RUSSIAN ASTROLOGICAL SYMBOL TREDECILE;So;0;ON;;;;;N;;;;;
2BF9;EQUALS SIGN WITH INFINITY BELOW;So;0;ON;;;;;N;;;;;
2BFA;UNITED SYMBOL;So;0;ON;;;;;N;;;;;
2BFB;SEPARATED SYMBOL;So;0;ON;;;;;N;;;;;
2BFC;DOUBLED SYMBOL;So;0;ON;;;;;N;;;;;
2BFD;PASSED SYMBOL;So;0;ON;;;;;N;;;;;
2BFE;REVERSED RIGHT ANGLE;So;0;ON;;;;;Y;;;;;
2BFF;HELLSCHREIBER PAUSE SYMBOL;So;0;ON;;;;;N;;;;;
2C00;GLAGOLITIC CAPITAL LETTER AZU;Lu;0;L;;;;;N;;;;2C30;
2C01;GLAGOLITIC CAPITAL LETTER BUKY;Lu;0;L;;;;;N;;;;2C31;
2C02;GLAGOLITIC CAPITAL LETTER VEDE;Lu;0;L;;;;;N;;;;2C32;
2C03;GLAGOLITIC CAPITAL LETTER GLAGOLI;Lu;0;L;;;;;N;;;;2C33;
2C04;GLAGOLITIC CAPITAL LETTER DOBRO;Lu;0;L;;;;;N;;;;2C34;
2C05;GLAGOLITIC CAPITAL LETTER YESTU;Lu;0;L;;;;;N;;;;2C35;
2C06;GLAGOLITIC CAPITAL LETTER ZHIVETE;Lu;0;L;;;;;N;;;;2C36;
2C07;GLAGOLITIC CAPITAL LETTER DZELO;Lu;0;L;;;;;N;;;;2C37;
2C08;GLAGOLITIC CAPITAL LETTER ZEMLJA;Lu;0;L;;;;;N;;;;2C38;
2C09;GLAGOLITIC CAPITAL LETTER IZHE;Lu;0;L;;;;;N;;;;2C39;
2C0A;GLAGOLITIC CAPITAL LETTER INITIAL IZHE;Lu;0;L;;;;;N;;;;2C3A;
2C0B;GLAGOLITIC CAPITAL LETTER I;Lu;0;L;;;;;N;;;;2C3B;
2C0C;GLAGOLITIC CAPITAL LETTER DJERVI;Lu;0;L;;;;;N;;;;2C3C;
2C0D;GLAGOLITIC CAPITAL LETTER KAKO;Lu;0;L;;;;;N;;;;2C3D;
2C0E;GLAGOLITIC CAPITAL LETTER LJUDIJE;Lu;0;L;;;;;N;;;;2C3E;
2C0F;GLAGOLITIC CAPITAL LETTER MYSLITE;Lu;0;L;;;;;N;;;;2C3F;
2C10;GLAGOLITIC CAPITAL LETTER NASHI;Lu;0;L;;;;;N;;;;2C40;
2C11;GLAGOLITIC CAPITAL LETTER ONU;Lu;0;L;;;;;N;;;;2C41;
2C12;GLAGOLITIC CAPITAL LETTER POKOJI;Lu;0;L;;;;;N;;;;2C42;
2C13;GLAGOLITIC CAPITAL LETTER RITSI;Lu;0;L;;;;;N;;;;2C43;
2C14;GLAGOLITIC CAPITAL LETTER SLOVO;Lu;0;L;;;;;N;;;;2C44;
2C15;GLAGOLITIC CAPITAL LETTER TVRIDO;Lu;0;L;;;;;N;;;;2C45;
2C16;GLAGOLITIC CAPITAL LETTER UKU;Lu;0;L;;;;;N;;;;2C46;
2C17;GLAGOLITIC CAPITAL LETTER FRITU;Lu;0;L;;;;;N;;;;2C47;
2C18;GLAGOLITIC CAPITAL LETTER HERU;Lu;0;L;;;;;N;;;;2C48;
2C19;GLAGOLITIC CAPITAL LETTER OTU;Lu;0;L;;;;;N;;;;2C49;
2C1A;GLAGOLITIC CAPITAL LETTER PE;Lu;0;L;;;;;N;;;;2C4A;
2C1B;GLAGOLITIC CAPITAL LETTER SHTA;Lu;0;L;;;;;N;;;;2C4B;
2C1C;GLAGOLITIC CAPITAL LETTER TSI;Lu;0;L;;;;;N;;;;2C4C;
2C1D;GLAGOLITIC CAPITAL LETTER CHRIVI;Lu;0;L;;;;;N;;;;2C4D;
2C1E;GLAGOLITIC CAPITAL LETTER SHA;Lu;0;L;;;;;N;;;;2C4E;
2C1F;GLAGOLITIC CAPITAL LETTER YERU;Lu;0;L;;;;;N;;;;2C4F;
2C20;GLAGOLITIC CAPITAL LETTER YERI;Lu;0;L;;;;;N;;;;2C50;
2C21;GLAGOLITIC CAPITAL LETTER YATI;Lu;0;L;;;;;N;;;;2C51;
2C22;GLAGOLITIC CAPITAL LETTER SPIDERY HA;Lu;0;L;;;;;N;;;;2C52;
2C23;GLAGOLITIC CAPITAL LETTER YU;Lu;0;L;;;;;N;;;;2C53;
2C24;GLAGOLITIC CAPITAL LETTER SMALL YUS;Lu;0;L;;;;;N;;;;2C54;
2C25;GLAGOLITIC CAPITAL LETTER SMALL YUS WITH TAIL;Lu;0;L;;;;;N;;;;2C55;
2C26;GLAGOLITIC CAPITAL LETTER YO;Lu;0;L;;;;;N;;;;2C56;
2C27;GLAGOLITIC CAPITAL LETTER IOTATED SMALL YUS;Lu;0;L;;;;;N;;;;2C57;
2C28;GLAGOLITIC CAPITAL LETTER BIG YUS;Lu;0;L;;;;;N;;;;2C58;
2C29;GLAGOLITIC CAPITAL LETTER IOTATED BIG YUS;Lu;0;L;;;;;N;;;;2C59;
2C2A;GLAGOLITIC CAPITAL LETTER FITA;Lu;0;L;;;;;N;;;;2C5A;
2C2B;GLAGOLITIC CAPITAL LETTER IZHITSA;Lu;0;L;;;;;N;;;;2C5B;
2C2C;GLAGOLITIC CAPITAL LETTER SHTAPIC;Lu;0;L;;;;;N;;;;2C5C;
2C2D;GLAGOLITIC CAPITAL LETTER TROKUTASTI A;Lu;0;L;;;;;N;;;;2C5D;
2C2E;GLAGOLITIC CAPITAL LETTER LATINATE MYSLITE;Lu;0;L;;;;;N;;;;2C5E;
2C2F;GLAGOLITIC CAPITAL LETTER CAUDATE CHRIVI;Lu;0;L;;;;;N;;;;2C5F;
2C30;GLAGOLITIC SMALL LETTER AZU;Ll;0;L;;;;;N;;;2C00;;2C00
2C31;GLAGOLITIC SMALL LETTER BUKY;Ll;0;L;;;;;N;;;2C01;;2C01
2C32;GLAGOLITIC SMALL LETTER VEDE;Ll;0;L;;;;;N;;;2C02;;2C02
2C33;GLAGOLITIC SMALL LETTER GLAGOLI;Ll;0;L;;;;;N;;;2C03;;2C03
2C34;GLAGOLITIC SMALL LETTER DOBRO;Ll;0;L;;;;;N;;;2C04;;2C04
2C35;GLAGOLITIC SMALL LETTER YESTU;Ll;0;L;;;;;N;;;2C05;;2C05
2C36;GLAGOLITIC SMALL LETTER ZHIVETE;Ll;0;L;;;;;N;;;2C06;;2C06
2C37;GLAGOLITIC SMALL LETTER DZELO;Ll;0;L;;;;;N;;;2C07;;2C07
2C38;GLAGOLITIC SMALL LETTER ZEMLJA;Ll;0;L;;;;;N;;;2C08;;2C08
2C39;GLAGOLITIC SMALL LETTER IZHE;Ll;0;L;;;;;N;;;2C09;;2C09
2C3A;GLAGOLITIC SMALL LETTER INITIAL IZHE;Ll;0;L;;;;;N;;;2C0A;;2C0A
2C3B;GLAGOLITIC SMALL LETTER I;Ll;0;L;;;;;N;;;2C0B;;2C0B
2C3C;GLAGOLITIC SMALL LETTER DJERVI;Ll;0;L;;;;;N;;;2C0C;;2C0C
2C3D;GLAGOLITIC SMALL LETTER KAKO;Ll;0;L;;;;;N;;;2C0D;;2C0D
2C3E;GLAGOLITIC SMALL LETTER LJUDIJE;Ll;0;L;;;;;N;;;2C0E;;2C0E
2C3F;GLAGOLITIC SMALL LETTER MYSLITE;Ll;0;L;;;;;N;;;2C0F;;2C0F
2C40;GLAGOLITIC SMALL LETTER NASHI;Ll;0;L;;;;;N;;;2C10;;2C10
2C41;GLAGOLITIC SMALL LETTER ONU;Ll;0;L;;;;;N;;;2C11;;2C11
2C42;GLAGOLITIC SMALL LETTER POKOJI;Ll;0;L;;;;;N;;;2C12;;2C12
2C43;GLAGOLITIC SMALL LETTER RITSI;Ll;0;L;;;;;N;;;2C13;;2C13
2C44;GLAGOLITIC SMALL LETTER SLOVO;Ll;0;L;;;;;N;;;2C14;;2C14
2C45;GLAGOLITIC SMALL LETTER TVRIDO;Ll;0;L;;;;;N;;;2C15;;2C15
2C46;GLAGOLITIC SMALL LETTER UKU;Ll;0;L;;;;;N;;;2C16;;2C16
2C47;GLAGOLITIC SMALL LETTER FRITU;Ll;0;L;;;;;N;;;2C17;;2C17
2C48;GLAGOLITIC SMALL LETTER HERU;Ll;0;L;;;;;N;;;2C18;;2C18
2C49;GLAGOLITIC SMALL LETTER OTU;Ll;0;L;;;;;N;;;2C19;;2C19
2C4A;GLAGOLITIC SMALL LETTER PE;Ll;0;L;;;;;N;;;2C1A;;2C1A
2C4B;GLAGOLITIC SMALL LETTER SHTA;Ll;0;L;;;;;N;;;2C1B;;2C1B
2C4C;GLAGOLITIC SMALL LETTER TSI;Ll;0;L;;;;;N;;;2C1C;;2C1C
2C4D;GLAGOLITIC SMALL LETTER CHRIVI;Ll;0;L;;;;;N;;;2C1D;;2C1D
2C4E;GLAGOLITIC SMALL LETTER SHA;Ll;0;L;;;;;N;;;2C1E;;2C1E
2C4F;GLAGOLITIC SMALL LETTER YERU;Ll;0;L;;;;;N;;;2C1F;;2C1F
2C50;GLAGOLITIC SMALL LETTER YERI;Ll;0;L;;;;;N;;;2C20;;2C20
2C51;GLAGOLITIC SMALL LETTER YATI;Ll;0;L;;;;;N;;;2C21;;2C21
2C52;GLAGOLITIC SMALL LETTER SPIDERY HA;Ll;0;L;;;;;N;;;2C22;;2C22
2C53;GLAGOLITIC SMALL LETTER YU;Ll;0;L;;;;;N;;;2C23;;2C23
2C54;GLAGOLITIC SMALL LETTER SMALL YUS;Ll;0;L;;;;;N;;;2C24;;2C24
2C55;GLAGOLITIC SMALL LETTER SMALL YUS WITH TAIL;Ll;0;L;;;;;N;;;2C25;;2C25
2C56;GLAGOLITIC SMALL LETTER YO;Ll;0;L;;;;;N;;;2C26;;2C26
2C57;GLAGOLITIC SMALL LETTER IOTATED SMALL YUS;Ll;0;L;;;;;N;;;2C27;;2C27
2C58;GLAGOLITIC SMALL LETTER BIG YUS;Ll;0;L;;;;;N;;;2C28;;2C28
2C59;GLAGOLITIC SMALL LETTER IOTATED BIG YUS;Ll;0;L;;;;;N;;;2C29;;2C29
2C5A;GLAGOLITIC SMALL LETTER FITA;Ll;0;L;;;;;N;;;2C2A;;2C2A
2C5B;GLAGOLITIC SMALL LETTER IZHITSA;Ll;0;L;;;;;N;;;2C2B;;2C2B
2C5C;GLAGOLITIC SMALL LETTER SHTAPIC;Ll;0;L;;;;;N;;;2C2C;;2C2C
2C5D;GLAGOLITIC SMALL LETTER TROKUTASTI A;Ll;0;L;;;;;N;;;2C2D;;2C2D
2C5E;GLAGOLITIC SMALL LETTER LATINATE MYSLITE;Ll;0;L;;;;;N;;;2C2E;;2C2E
2C5F;GLAGOLITIC SMALL LETTER CAUDATE CHRIVI;Ll;0;L;;;;;N;;;2C2F;;2C2F
2C60;LATIN CAPITAL LETTER L WITH DOUBLE BAR;Lu;0;L;;;;;N;;;;2C61;
2C61;LATIN SMALL LETTER L WITH DOUBLE BAR;Ll;0;L;;;;;N;;;2C60;;2C60
2C62;LATIN CAPITAL LETTER L WITH MIDDLE TILDE;Lu;0;L;;;;;N;;;;026B;
2C63;LATIN CAPITAL LETTER P WITH STROKE;Lu;0;L;;;;;N;;;;1D7D;
2C64;LATIN CAPITAL LETTER R WITH TAIL;Lu;0;L;;;;;N;;;;027D;
2C65;LATIN SMALL LETTER A WITH STROKE;Ll;0;L;;;;;N;;;023A;;023A
2C66;LATIN SMALL LETTER T WITH DIAGONAL STROKE;Ll;0;L;;;;;N;;;023E;;023E
2C67;LATIN CAPITAL LETTER H WITH DESCENDER;Lu;0;L;;;;;N;;;;2C68;
2C68;LATIN SMALL LETTER H WITH DESCENDER;Ll;0;L;;;;;N;;;2C67;;2C67
2C69;LATIN CAPITAL LETTER K WITH DESCENDER;Lu;0;L;;;;;N;;;;2C6A;
2C6A;LATIN SMALL LETTER K WITH DESCENDER;Ll;0;L;;;;;N;;;2C69;;2C69
2C6B;LATIN CAPITAL LETTER Z WITH DESCENDER;Lu;0;L;;;;;N;;;;2C6C;
2C6C;LATIN SMALL LETTER Z WITH DESCENDER;Ll;0;L;;;;;N;;;2C6B;;2C6B
2C6D;LATIN CAPITAL LETTER ALPHA;Lu;0;L;;;;;N;;;;0251;
2C6E;LATIN CAPITAL LETTER M WITH HOOK;Lu;0;L;;;;;N;;;;0271;
2C6F;LATIN CAPITAL LETTER TURNED A;Lu;0;L;;;;;N;;;;0250;
2C70;LATIN CAPITAL LETTER TURNED ALPHA;Lu;0;L;;;;;N;;;;0252;
2C71;LATIN SMALL LETTER V WITH RIGHT HOOK;Ll;0;L;;;;;N;;;;;
2C72;LATIN CAPITAL LETTER W WITH HOOK;Lu;0;L;;;;;N;;;;2C73;
2C73;LATIN SMALL LETTER W WITH HOOK;Ll;0;L;;;;;N;;;2C72;;2C72
2C74;LATIN SMALL LETTER V WITH CURL;Ll;0;L;;;;;N;;;;;
2C75;LATIN CAPITAL LETTER HALF H;Lu;0;L;;;;;N;;;;2C76;
2C76;LATIN SMALL LETTER HALF H;Ll;0;L;;;;;N;;;2C75;;2C75
2C77;LATIN SMALL LETTER TAILLESS PHI;Ll;0;L;;;;;N;;;;;
2C78;LATIN SMALL LETTER E WITH NOTCH;Ll;0;L;;;;;N;;;;;
2C79;LATIN SMALL LETTER TURNED R WITH TAIL;Ll;0;L;;;;;N;;;;;
2C7A;LATIN SMALL LETTER O WITH LOW RING INSIDE;Ll;0;L;;;;;N;;;;;
2C7B;LATIN LETTER SMALL CAPITAL TURNED E;Ll;0;L;;;;;N;;;;;
2C7C;LATIN SUBSCRIPT SMALL LETTER J;Lm;0;L;<sub> 006A;;;;N;;;;;
2C7D;MODIFIER LETTER CAPITAL V;Lm;0;L;<super> 0056;;;;N;;;;;
2C7E;LATIN CAPITAL LETTER S WITH SWASH TAIL;Lu;0;L;;;;;N;;;;023F;
2C7F;LATIN CAPITAL LETTER Z WITH SWASH TAIL;Lu;0;L;;;;;N;;;;0240;
2C80;COPTIC CAPITAL LETTER ALFA;Lu;0;L;;;;;N;;;;2C81;
2C81;COPTIC SMALL LETTER ALFA;Ll;0;L;;;;;N;;;2C80;;2C80
2C82;COPTIC CAPITAL LETTER VIDA;Lu;0;L;;;;;N;;;;2C83;
2C83;COPTIC SMALL LETTER VIDA;Ll;0;L;;;;;N;;;2C82;;2C82
2C84;COPTIC CAPITAL LETTER GAMMA;Lu;0;L;;;;;N;;;;2C85;
2C85;COPTIC SMALL LETTER GAMMA;Ll;0;L;;;;;N;;;2C84;;2C84
2C86;COPTIC CAPITAL LETTER DALDA;Lu;0;L;;;;;N;;;;2C87;
2C87;COPTIC SMALL LETTER DALDA;Ll;0;L;;;;;N;;;2C86;;2C86
2C88;COPTIC CAPITAL LETTER EIE;Lu;0;L;;;;;N;;;;2C89;
2C89;COPTIC SMALL LETTER EIE;Ll;0;L;;;;;N;;;2C88;;2C88
2C8A;COPTIC CAPITAL LETTER SOU;Lu;0;L;;;;;N;;;;2C8B;
2C8B;COPTIC SMALL LETTER SOU;Ll;0;L;;;;;N;;;2C8A;;2C8A
2C8C;COPTIC CAPITAL LETTER ZATA;Lu;0;L;;;;;N;;;;2C8D;
2C8D;COPTIC SMALL LETTER ZATA;Ll;0;L;;;;;N;;;2C8C;;2C8C
2C8E;COPTIC CAPITAL LETTER HATE;Lu;0;L;;;;;N;;;;2C8F;
2C8F;COPTIC SMALL LETTER HATE;Ll;0;L;;;;;N;;;2C8E;;2C8E
2C90;COPTIC CAPITAL LETTER THETHE;Lu;0;L;;;;;N;;;;2C91;
2C91;COPTIC SMALL LETTER THETHE;Ll;0;L;;;;;N;;;2C90;;2C90
2C92;COPTIC CAPITAL LETTER IAUDA;Lu;0;L;;;;;N;;;;2C93;
2C93;COPTIC SMALL LETTER IAUDA;Ll;0;L;;;;;N;;;2C92;;2C92
2C94;COPTIC CAPITAL LETTER KAPA;Lu;0;L;;;;;N;;;;2C95;
2C95;COPTIC SMALL LETTER KAPA;Ll;0;L;;;;;N;;;2C94;;2C94
2C96;COPTIC CAPITAL LETTER LAULA;Lu;0;L;;;;;N;;;;2C97;
2C97;COPTIC SMALL LETTER LAULA;Ll;0;L;;;;;N;;;2C96;;2C96
2C98;COPTIC CAPITAL LETTER MI;Lu;0;L;;;;;N;;;;2C99;
2C99;COPTIC SMALL LETTER MI;Ll;0;L;;;;;N;;;2C98;;2C98
2C9A;COPTIC CAPITAL LETTER NI;Lu;0;L;;;;;N;;;;2C9B;
2C9B;COPTIC SMALL LETTER NI;Ll;0;L;;;;;N;;;2C9A;;2C9A
2C9C;COPTIC CAPITAL LETTER KSI;Lu;0;L;;;;;N;;;;2C9D;
2C9D;COPTIC SMALL LETTER KSI;Ll;0;L;;;;;N;;;2C9C;;2C9C
2C9E;COPTIC CAPITAL LETTER O;Lu;0;L;;;;;N;;;;2C9F;
2C9F;COPTIC SMALL LETTER O;Ll;0;L;;;;;N;;;2C9E;;2C9E
2CA0;COPTIC CAPITAL LETTER PI;Lu;0;L;;;;;N;;;;2CA1;
2CA1;COPTIC SMALL LETTER PI;Ll;0;L;;;;;N;;;2CA0;;2CA0
2CA2;COPTIC CAPITAL LETTER RO;Lu;0;L;;;;;N;;;;2CA3;
2CA3;COPTIC SMALL LETTER RO;Ll;0;L;;;;;N;;;2CA2;;2CA2
2CA4;COPTIC CAPITAL LETTER SIMA;Lu;0;L;;;;;N;;;;2CA5;
2CA5;COPTIC SMALL LETTER SIMA;Ll;0;L;;;;;N;;;2CA4;;2CA4
2CA6;COPTIC CAPITAL LETTER TAU;Lu;0;L;;;;;N;;;;2CA7;
2CA7;COPTIC SMALL LETTER TAU;Ll;0;L;;;;;N;;;2CA6;;2CA6
2CA8;COPTIC CAPITAL LETTER UA;Lu;0;L;;;;;N;;;;2CA9;
2CA9;COPTIC SMALL LETTER UA;Ll;0;L;;;;;N;;;2CA8;;2CA8
2CAA;COPTIC CAPITAL LETTER FI;Lu;0;L;;;;;N;;;;2CAB;
2CAB;COPTIC SMALL LETTER FI;Ll;0;L;;;;;N;;;2CAA;;2CAA
2CAC;COPTIC CAPITAL LETTER KHI;Lu;0;L;;;;;N;;;;2CAD;
2CAD;COPTIC SMALL LETTER KHI;Ll;0;L;;;;;N;;;2CAC;;2CAC
2CAE;COPTIC CAPITAL LETTER PSI;Lu;0;L;;;;;N;;;;2CAF;
2CAF;COPTIC SMALL LETTER PSI;Ll;0;L;;;;;N;;;2CAE;;2CAE
2CB0;COPTIC CAPITAL LETTER OOU;Lu;0;L;;;;;N;;;;2CB1;
2CB1;COPTIC SMALL LETTER OOU;Ll;0;L;;;;;N;;;2CB0;;2CB0
2CB2;COPTIC CAPITAL LETTER DIALECT-P ALEF;Lu;0;L;;;;;N;;;;2CB3;
2CB3;COPTIC SMALL LETTER DIALECT-P ALEF;Ll;0;L;;;;;N;;;2CB2;;2CB2
2CB4;COPTIC CAPITAL LETTER OLD COPTIC AIN;Lu;0;L;;;;;N;;;;2CB5;
2CB5;COPTIC SMALL LETTER OLD COPTIC AIN;Ll;0;L;;;;;N;;;2CB4;;2CB4
2CB6;COPTIC CAPITAL LETTER CRYPTOGRAMMIC EIE;Lu;0;L;;;;;N;;;;2CB7;
2CB7;COPTIC SMALL LETTER CRYPTOGRAMMIC EIE;Ll;0;L;;;;;N;;;2CB6;;2CB6
2CB8;COPTIC CAPITAL LETTER DIALECT-P KAPA;Lu;0;L;;;;;N;;;;2CB9;
2CB9;COPTIC SMALL LETTER DIALECT-P KAPA;Ll;0;L;;;;;N;;;2CB8;;2CB8
2CBA;COPTIC CAPITAL LETTER DIALECT-P NI;Lu;0;L;;;;;N;;;;2CBB;
2CBB;COPTIC SMALL LETTER DIALECT-P NI;Ll;0;L;;;;;N;;;2CBA;;2CBA
2CBC;COPTIC CAPITAL LETTER CRYPTOGRAMMIC NI;Lu;0;L;;;;;N;;;;2CBD;
2CBD;COPTIC SMALL LETTER CRYPTOGRAMMIC NI;Ll;0;L;;;;;N;;;2CBC;;2CBC
2CBE;COPTIC CAPITAL LETTER OLD COPTIC OOU;Lu;0;L;;;;;N;;;;2CBF;
2CBF;COPTIC SMALL LETTER OLD COPTIC OOU;Ll;0;L;;;;;N;;;2CBE;;2CBE
2CC0;COPTIC CAPITAL LETTER SAMPI;Lu;0;L;;;;;N;;;;2CC1;
2CC1;COPTIC SMALL LETTER SAMPI;Ll;0;L;;;;;N;;;2CC0;;2CC0
2CC2;COPTIC CAPITAL LETTER CROSSED SHEI;Lu;0;L;;;;;N;;;;2CC3;
2CC3;COPTIC SMALL LETTER CROSSED SHEI;Ll;0;L;;;;;N;;;2CC2;;2CC2
2CC4;COPTIC CAPITAL LETTER OLD COPTIC SHEI;Lu;0;L;;;;;N;;;;2CC5;
2CC5;COPTIC SMALL LETTER OLD COPTIC SHEI;Ll;0;L;;;;;N;;;2CC4;;2CC4
2CC6;COPTIC CAPITAL LETTER OLD COPTIC ESH;Lu;0;L;;;;;N;;;;2CC7;
2CC7;COPTIC SMALL LETTER OLD COPTIC ESH;Ll;0;L;;;;;N;;;2CC6;;2CC6
2CC8;COPTIC CAPITAL LETTER AKHMIMIC KHEI;Lu;0;L;;;;;N;;;;2CC9;
2CC9;COPTIC SMALL LETTER AKHMIMIC KHEI;Ll;0;L;;;;;N;;;2CC8;;2CC8
2CCA;COPTIC CAPITAL LETTER DIALECT-P HORI;Lu;0;L;;;;;N;;;;2CCB;
2CCB;COPTIC SMALL LETTER DIALECT-P HORI;Ll;0;L;;;;;N;;;2CCA;;2CCA
2CCC;COPTIC CAPITAL LETTER OLD COPTIC HORI;Lu;0;L;;;;;N;;;;2CCD;
2CCD;COPTIC SMALL LETTER OLD COPTIC HORI;Ll;0;L;;;;;N;;;2CCC;;2CCC
2CCE;COPTIC CAPITAL LETTER OLD COPTIC HA;Lu;0;L;;;;;N;;;;2CCF;
2CCF;COPTIC SMALL LETTER OLD COPTIC HA;Ll;0;L;;;;;N;;;2CCE;;2CCE
2CD0;COPTIC CAPITAL LETTER L-SHAPED HA;Lu;0;L;;;;;N;;;;2CD1;
2CD1;COPTIC SMALL LETTER L-SHAPED HA;Ll;0;L;;;;;N;;;2CD0;;2CD0
2CD2;COPTIC CAPITAL LETTER OLD COPTIC HEI;Lu;0;L;;;;;N;;;;2CD3;
2CD3;COPTIC SMALL LETTER OLD COPTIC HEI;Ll;0;L;;;;;N;;;2CD2;;2CD2
2CD4;COPTIC CAPITAL LETTER OLD COPTIC HAT;Lu;0;L;;;;;N;;;;2CD5;
2CD5;COPTIC SMALL LETTER OLD COPTIC HAT;Ll;0;L;;;;;N;;;2CD4;;2CD4
2CD6;COPTIC CAPITAL LETTER OLD COPTIC GANGIA;Lu;0;L;;;;;N;;;;2CD7;
2CD7;COPTIC SMALL LETTER OLD COPTIC GANGIA;Ll;0;L;;;;;N;;;2CD6;;2CD6
2CD8;COPTIC CAPITAL LETTER OLD COPTIC DJA;Lu;0;L;;;;;N;;;;2CD9;
2CD9;COPTIC SMALL LETTER OLD COPTIC DJA;Ll;0;L;;;;;N;;;2CD8;;2CD8
2CDA;COPTIC CAPITAL LETTER OLD COPTIC SHIMA;Lu;0;L;;;;;N;;;;2CDB;
2CDB;COPTIC SMALL LETTER OLD COPTIC SHIMA;Ll;0;L;;;;;N;;;2CDA;;2CDA
2CDC;COPTIC CAPITAL LETTER OLD NUBIAN SHIMA;Lu;0;L;;;;;N;;;;2CDD;
2CDD;COPTIC SMALL LETTER OLD NUBIAN SHIMA;Ll;0;L;;;;;N;;;2CDC;;2CDC
2CDE;COPTIC CAPITAL LETTER OLD NUBIAN NGI;Lu;0;L;;;;;N;;;;2CDF;
2CDF;COPTIC SMALL LETTER OLD NUBIAN NGI;Ll;0;L;;;;;N;;;2CDE;;2CDE
2CE0;COPTIC CAPITAL LETTER OLD NUBIAN NYI;Lu;0;L;;;;;N;;;;2CE1;
2CE1;COPTIC SMALL LETTER OLD NUBIAN NYI;Ll;0;L;;;;;N;;;2CE0;;2CE0
2CE2;COPTIC CAPITAL LETTER OLD NUBIAN WAU;Lu;0;L;;;;;N;;;;2CE3;
2CE3;COPTIC SMALL LETTER OLD NUBIAN WAU;Ll;0;L;;;;;N;;;2CE2;;2CE2
2CE4;COPTIC SYMBOL KAI;Ll;0;L;;;;;N;;;;;
2CE5;COPTIC SYMBOL MI RO;So;0;ON;;;;;N;;;;;
2CE6;COPTIC SYMBOL PI RO;So;0;ON;;;;;N;;;;;
2CE7;COPTIC SYMBOL STAUROS;So;0;ON;;;;;N;;;;;
2CE8;COPTIC SYMBOL TAU RO;So;0;ON;;;;;N;;;;;
2CE9;COPTIC SYMBOL KHI RO;So;0;ON;;;;;N;;;;;
2CEA;COPTIC SYMBOL SHIMA SIMA;So;0;ON;;;;;N;;;;;
2CEB;COPTIC CAPITAL LETTER CRYPTOGRAMMIC SHEI;Lu;0;L;;;;;N;;;;2CEC;
2CEC;COPTIC SMALL LETTER CRYPTOGRAMMIC SHEI;Ll;0;L;;;;;N;;;2CEB;;2CEB
2CED;COPTIC CAPITAL LETTER CRYPTOGRAMMIC GANGIA;Lu;0;L;;;;;N;;;;2CEE;
2CEE;COPTIC SMALL LETTER CRYPTOGRAMMIC GANGIA;Ll;0;L;;;;;N;;;2CED;;2CED
2CEF;COPTIC COMBINING NI ABOVE;Mn;230;NSM;;;;;N;;;;;
2CF0;COPTIC COMBINING SPIRITUS ASPER;Mn;230;NSM;;;;;N;;;;;
2CF1;COPTIC COMBINING SPIRITUS LENIS;Mn;230;NSM;;;;;N;;;;;
2CF2;COPTIC CAPITAL LETTER BOHAIRIC KHEI;Lu;0;L;;;;;N;;;;2CF3;
2CF3;COPTIC SMALL LETTER BOHAIRIC KHEI;Ll;0;L;;;;;N;;;2CF2;;2CF2
2CF9;COPTIC OLD NUBIAN FULL STOP;Po;0;ON;;;;;N;;;;;
2CFA;COPTIC OLD NUBIAN DIRECT QUESTION MARK;Po;0;ON;;;;;N;;;;;
2CFB;COPTIC OLD NUBIAN INDIRECT QUESTION MARK;Po;0;ON;;;;;N;;;;;
2CFC;COPTIC OLD NUBIAN VERSE DIVIDER;Po;0;ON;;;;;N;;;;;
2CFD;COPTIC FRACTION ONE HALF;No;0;ON;;;;1/2;N;;;;;
2CFE;COPTIC FULL STOP;Po;0;ON;;;;;N;;;;;
2CFF;COPTIC MORPHOLOGICAL DIVIDER;Po;0;ON;;;;;N;;;;;
2D00;GEORGIAN SMALL LETTER AN;Ll;0;L;;;;;N;;;10A0;;10A0
2D01;GEORGIAN SMALL LETTER BAN;Ll;0;L;;;;;N;;;10A1;;10A1
2D02;GEORGIAN SMALL LETTER GAN;Ll;0;L;;;;;N;;;10A2;;10A2
2D03;GEORGIAN SMALL LETTER DON;Ll;0;L;;;;;N;;;10A3;;10A3
2D04;GEORGIAN SMALL LETTER EN;Ll;0;L;;;;;N;;;10A4;;10A4
2D05;GEORGIAN SMALL LETTER VIN;Ll;0;L;;;;;N;;;10A5;;10A5
2D06;GEORGIAN SMALL LETTER ZEN;Ll;0;L;;;;;N;;;10A6;;10A6
2D07;GEORGIAN SMALL LETTER TAN;Ll;0;L;;;;;N;;;10A7;;10A7
2D08;GEORGIAN SMALL LETTER IN;Ll;0;L;;;;;N;;;10A8;;10A8
2D09;GEORGIAN SMALL LETTER KAN;Ll;0;L;;;;;N;;;10A9;;10A9
2D0A;GEORGIAN SMALL LETTER LAS;Ll;0;L;;;;;N;;;10AA;;10AA
2D0B;GEORGIAN SMALL LETTER MAN;Ll;0;L;;;;;N;;;10AB;;10AB
2D0C;GEORGIAN SMALL LETTER NAR;Ll;0;L;;;;;N;;;10AC;;10AC
2D0D;GEORGIAN SMALL LETTER ON;Ll;0;L;;;;;N;;;10AD;;10AD
2D0E;GEORGIAN SMALL LETTER PAR;Ll;0;L;;;;;N;;;10AE;;10AE
2D0F;GEORGIAN SMALL LETTER ZHAR;Ll;0;L;;;;;N;;;10AF;;10AF
2D10;GEORGIAN SMALL LETTER RAE;Ll;0;L;;;;;N;;;10B0;;10B0
2D11;GEORGIAN SMALL LETTER SAN;Ll;0;L;;;;;N;;;10B1;;10B1
2D12;GEORGIAN SMALL LETTER TAR;Ll;0;L;;;;;N;;;10B2;;10B2
2D13;GEORGIAN SMALL LETTER UN;Ll;0;L;;;;;N;;;10B3;;10B3
2D14;GEORGIAN SMALL LETTER PHAR;Ll;0;L;;;;;N;;;10B4;;10B4
2D15;GEORGIAN SMALL LETTER KHAR;Ll;0;L;;;;;N;;;10B5;;10B5
2D16;GEORGIAN SMALL LETTER GHAN;Ll;0;L;;;;;N;;;10B6;;10B6
2D17;GEORGIAN SMALL LETTER QAR;Ll;0;L;;;;;N;;;10B7;;10B7
2D18;GEORGIAN SMALL LETTER SHIN;Ll;0;L;;;;;N;;;10B8;;10B8
2D19;GEORGIAN SMALL LETTER CHIN;Ll;0;L;;;;;N;;;10B9;;10B9
2D1A;GEORGIAN SMALL LETTER CAN;Ll;0;L;;;;;N;;;10BA;;10BA
2D1B;GEORGIAN SMALL LETTER JIL;Ll;0;L;;;;;N;;;10BB;;10BB
2D1C;GEORGIAN SMALL LETTER CIL;Ll;0;L;;;;;N;;;10BC;;10BC
2D1D;GEORGIAN SMALL LETTER CHAR;Ll;0;L;;;;;N;;;10BD;;10BD
2D1E;GEORGIAN SMALL LETTER XAN;Ll;0;L;;;;;N;;;10BE;;10BE
2D1F;GEORGIAN SMALL LETTER JHAN;Ll;0;L;;;;;N;;;10BF;;10BF
2D20;GEORGIAN SMALL LETTER HAE;Ll;0;L;;;;;N;;;10C0;;10C0
2D21;GEORGIAN SMALL LETTER HE;Ll;0;L;;;;;N;;;10C1;;10C1
2D22;GEORGIAN SMALL LETTER HIE;Ll;0;L;;;;;N;;;10C2;;10C2
2D23;GEORGIAN SMALL LETTER WE;Ll;0;L;;;;;N;;;10C3;;10C3
2D24;GEORGIAN SMALL LETTER HAR;Ll;0;L;;;;;N;;;10C4;;10C4
2D25;GEORGIAN SMALL LETTER HOE;Ll;0;L;;;;;N;;;10C5;;10C5
2D27;GEORGIAN SMALL LETTER YN;Ll;0;L;;;;;N;;;10C7;;10C7
2D2D;GEORGIAN SMALL LETTER AEN;Ll;0;L;;;;;N;;;10CD;;10CD
2D30;TIFINAGH LETTER YA;Lo;0;L;;;;;N;;;;;
2D31;TIFINAGH LETTER YAB;Lo;0;L;;;;;N;;;;;
2D32;TIFINAGH LETTER YABH;Lo;0;L;;;;;N;;;;;
2D33;TIFINAGH LETTER YAG;Lo;0;L;;;;;N;;;;;
2D34;TIFINAGH LETTER YAGHH;Lo;0;L;;;;;N;;;;;
2D35;TIFINAGH LETTER BERBER ACADEMY YAJ;Lo;0;L;;;;;N;;;;;
2D36;TIFINAGH LETTER YAJ;Lo;0;L;;;;;N;;;;;
2D37;TIFINAGH LETTER YAD;Lo;0;L;;;;;N;;;;;
2D38;TIFINAGH LETTER YADH;Lo;0;L;;;;;N;;;;;
2D39;TIFINAGH LETTER YADD;Lo;0;L;;;;;N;;;;;
2D3A;TIFINAGH LETTER YADDH;Lo;0;L;;;;;N;;;;;
2D3B;TIFINAGH LETTER YEY;Lo;0;L;;;;;N;;;;;
2D3C;TIFINAGH LETTER YAF;Lo;0;L;;;;;N;;;;;
2D3D;TIFINAGH LETTER YAK;Lo;0;L;;;;;N;;;;;
2D3E;TIFINAGH LETTER TUAREG YAK;Lo;0;L;;;;;N;;;;;
2D3F;TIFINAGH LETTER YAKHH;Lo;0;L;;;;;N;;;;;
2D40;TIFINAGH LETTER YAH;Lo;0;L;;;;;N;;;;;
2D41;TIFINAGH LETTER BERBER ACADEMY YAH;Lo;0;L;;;;;N;;;;;
2D42;TIFINAGH LETTER TUAREG YAH;Lo;0;L;;;;;N;;;;;
2D43;TIFINAGH LETTER YAHH;Lo;0;L;;;;;N;;;;;
2D44;TIFINAGH LETTER YAA;Lo;0;L;;;;;N;;;;;
2D45;TIFINAGH LETTER YAKH;Lo;0;L;;;;;N;;;;;
2D46;TIFINAGH LETTER TUAREG YAKH;Lo;0;L;;;;;N;;;;;
2D47;TIFINAGH LETTER YAQ;Lo;0;L;;;;;N;;;;;
2D48;TIFINAGH LETTER TUAREG YAQ;Lo;0;L;;;;;N;;;;;
2D49;TIFINAGH LETTER YI;Lo;0;L;;;;;N;;;;;
2D4A;TIFINAGH LETTER YAZH;Lo;0;L;;;;;N;;;;;
2D4B;TIFINAGH LETTER AHAGGAR YAZH;Lo;0;L;;;;;N;;;;;
2D4C;TIFINAGH LETTER TUAREG YAZH;Lo;0;L;;;;;N;;;;;
2D4D;TIFINAGH LETTER YAL;Lo;0;L;;;;;N;;;;;
2D4E;TIFINAGH LETTER YAM;Lo;0;L;;;;;N;;;;;
2D4F;TIFINAGH LETTER YAN;Lo;0;L;;;;;N;;;;;
2D50;TIFINAGH LETTER TUAREG YAGN;Lo;0;L;;;;;N;;;;;
2D51;TIFINAGH LETTER TUAREG YANG;Lo;0;L;;;;;N;;;;;
2D52;TIFINAGH LETTER YAP;Lo;0;L;;;;;N;;;;;
2D53;TIFINAGH LETTER YU;Lo;0;L;;;;;N;;;;;
2D54;TIFINAGH LETTER YAR;Lo;0;L;;;;;N;;;;;
2D55;TIFINAGH LETTER YARR;Lo;0;L;;;;;N;;;;;
2D56;TIFINAGH LETTER YAGH;Lo;0;L;;;;;N;;;;;
2D57;TIFINAGH LETTER TUAREG YAGH;Lo;0;L;;;;;N;;;;;
2D58;TIFINAGH LETTER AYER YAGH;Lo;0;L;;;;;N;;;;;
2D59;TIFINAGH LETTER YAS;Lo;0;L;;;;;N;;;;;
2D5A;TIFINAGH LETTER YASS;Lo;0;L;;;;;N;;;;;
2D5B;TIFINAGH LETTER YASH;Lo;0;L;;;;;N;;;;;
2D5C;TIFINAGH LETTER YAT;Lo;0;L;;;;;N;;;;;
2D5D;TIFINAGH LETTER YATH;Lo;0;L;;;;;N;;;;;
2D5E;TIFINAGH LETTER YACH;Lo;0;L;;;;;N;;;;;
2D5F;TIFINAGH LETTER YATT;Lo;0;L;;;;;N;;;;;
2D60;TIFINAGH LETTER YAV;Lo;0;L;;;;;N;;;;;
2D61;TIFINAGH LETTER YAW;Lo;0;L;;;;;N;;;;;
2D62;TIFINAGH LETTER YAY;Lo;0;L;;;;;N;;;;;
2D63;TIFINAGH LETTER YAZ;Lo;0;L;;;;;N;;;;;
2D64;TIFINAGH LETTER TAWELLEMET YAZ;Lo;0;L;;;;;N;;;;;
2D65;TIFINAGH LETTER YAZZ;Lo;0;L;;;;;N;;;;;
2D66;TIFINAGH LETTER YE;Lo;0;L;;;;;N;;;;;
2D67;TIFINAGH LETTER YO;Lo;0;L;;;;;N;;;;;
2D6F;TIFINAGH MODIFIER LETTER LABIALIZATION MARK;Lm;0;L;<super> 2D61;;;;N;;;;;
2D70;TIFINAGH SEPARATOR MARK;Po;0;L;;;;;N;;;;;
2D7F;TIFINAGH CONSONANT JOINER;Mn;9;NSM;;;;;N;;;;;
2D80;ETHIOPIC SYLLABLE LOA;Lo;0;L;;;;;N;;;;;
2D81;ETHIOPIC SYLLABLE MOA;Lo;0;L;;;;;N;;;;;
2D82;ETHIOPIC SYLLABLE ROA;Lo;0;L;;;;;N;;;;;
2D83;ETHIOPIC SYLLABLE SOA;Lo;0;L;;;;;N;;;;;
2D84;ETHIOPIC SYLLABLE SHOA;Lo;0;L;;;;;N;;;;;
2D85;ETHIOPIC SYLLABLE BOA;Lo;0;L;;;;;N;;;;;
2D86;ETHIOPIC SYLLABLE TOA;Lo;0;L;;;;;N;;;;;
2D87;ETHIOPIC SYLLABLE COA;Lo;0;L;;;;;N;;;;;
2D88;ETHIOPIC SYLLABLE NOA;Lo;0;L;;;;;N;;;;;
2D89;ETHIOPIC SYLLABLE NYOA;Lo;0;L;;;;;N;;;;;
2D8A;ETHIOPIC SYLLABLE GLOTTAL OA;Lo;0;L;;;;;N;;;;;
2D8B;ETHIOPIC SYLLABLE ZOA;Lo;0;L;;;;;N;;;;;
2D8C;ETHIOPIC SYLLABLE DOA;Lo;0;L;;;;;N;;;;;
2D8D;ETHIOPIC SYLLABLE DDOA;Lo;0;L;;;;;N;;;;;
2D8E;ETHIOPIC SYLLABLE JOA;Lo;0;L;;;;;N;;;;;
2D8F;ETHIOPIC SYLLABLE THOA;Lo;0;L;;;;;N;;;;;
2D90;ETHIOPIC SYLLABLE CHOA;Lo;0;L;;;;;N;;;;;
2D91;ETHIOPIC SYLLABLE PHOA;Lo;0;L;;;;;N;;;;;
2D92;ETHIOPIC SYLLABLE POA;Lo;0;L;;;;;N;;;;;
2D93;ETHIOPIC SYLLABLE GGWA;Lo;0;L;;;;;N;;;;;
2D94;ETHIOPIC SYLLABLE GGWI;Lo;0;L;;;;;N;;;;;
2D95;ETHIOPIC SYLLABLE GGWEE;Lo;0;L;;;;;N;;;;;
2D96;ETHIOPIC SYLLABLE GGWE;Lo;0;L;;;;;N;;;;;
2DA0;ETHIOPIC SYLLABLE SSA;Lo;0;L;;;;;N;;;;;
2DA1;ETHIOPIC SYLLABLE SSU;Lo;0;L;;;;;N;;;;;
2DA2;ETHIOPIC SYLLABLE SSI;Lo;0;L;;;;;N;;;;;
2DA3;ETHIOPIC SYLLABLE SSAA;Lo;0;L;;;;;N;;;;;
2DA4;ETHIOPIC SYLLABLE SSEE;Lo;0;L;;;;;N;;;;;
2DA5;ETHIOPIC SYLLABLE SSE;Lo;0;L;;;;;N;;;;;
2DA6;ETHIOPIC SYLLABLE SSO;Lo;0;L;;;;;N;;;;;
2DA8;ETHIOPIC SYLLABLE CCA;Lo;0;L;;;;;N;;;;;
2DA9;ETHIOPIC SYLLABLE CCU;Lo;0;L;;;;;N;;;;;
2DAA;ETHIOPIC SYLLABLE CCI;Lo;0;L;;;;;N;;;;;
2DAB;ETHIOPIC SYLLABLE CCAA;Lo;0;L;;;;;N;;;;;
2DAC;ETHIOPIC SYLLABLE CCEE;Lo;0;L;;;;;N;;;;;
2DAD;ETHIOPIC SYLLABLE CCE;Lo;0;L;;;;;N;;;;;
2DAE;ETHIOPIC SYLLABLE CCO;Lo;0;L;;;;;N;;;;;
2DB0;ETHIOPIC SYLLABLE ZZA;Lo;0;L;;;;;N;;;;;
2DB1;ETHIOPIC SYLLABLE ZZU;Lo;0;L;;;;;N;;;;;
2DB2;ETHIOPIC SYLLABLE ZZI;Lo;0;L;;;;;N;;;;;
2DB3;ETHIOPIC SYLLABLE ZZAA;Lo;0;L;;;;;N;;;;;
2DB4;ETHIOPIC SYLLABLE ZZEE;Lo;0;L;;;;;N;;;;;
2DB5;ETHIOPIC SYLLABLE ZZE;Lo;0;L;;;;;N;;;;;
2DB6;ETHIOPIC SYLLABLE ZZO;Lo;0;L;;;;;N;;;;;
2DB8;ETHIOPIC SYLLABLE CCHA;Lo;0;L;;;;;N;;;;;
2DB9;ETHIOPIC SYLLABLE CCHU;Lo;0;L;;;;;N;;;;;
2DBA;ETHIOPIC SYLLABLE CCHI;Lo;0;L;;;;;N;;;;;
2DBB;ETHIOPIC SYLLABLE CCHAA;Lo;0;L;;;;;N;;;;;
2DBC;ETHIOPIC SYLLABLE CCHEE;Lo;0;L;;;;;N;;;;;
2DBD;ETHIOPIC SYLLABLE CCHE;Lo;0;L;;;;;N;;;;;
2DBE;ETHIOPIC SYLLABLE CCHO;Lo;0;L;;;;;N;;;;;
2DC0;ETHIOPIC SYLLABLE QYA;Lo;0;L;;;;;N;;;;;
2DC1;ETHIOPIC SYLLABLE QYU;Lo;0;L;;;;;N;;;;;
2DC2;ETHIOPIC SYLLABLE QYI;Lo;0;L;;;;;N;;;;;
2DC3;ETHIOPIC SYLLABLE QYAA;Lo;0;L;;;;;N;;;;;
2DC4;ETHIOPIC SYLLABLE QYEE;Lo;0;L;;;;;N;;;;;
2DC5;ETHIOPIC SYLLABLE QYE;Lo;0;L;;;;;N;;;;;
2DC6;ETHIOPIC SYLLABLE QYO;Lo;0;L;;;;;N;;;;;
2DC8;ETHIOPIC SYLLABLE KYA;Lo;0;L;;;;;N;;;;;
2DC9;ETHIOPIC SYLLABLE KYU;Lo;0;L;;;;;N;;;;;
2DCA;ETHIOPIC SYLLABLE KYI;Lo;0;L;;;;;N;;;;;
2DCB;ETHIOPIC SYLLABLE KYAA;Lo;0;L;;;;;N;;;;;
2DCC;ETHIOPIC SYLLABLE KYEE;Lo;0;L;;;;;N;;;;;
2DCD;ETHIOPIC SYLLABLE KYE;Lo;0;L;;;;;N;;;;;
2DCE;ETHIOPIC SYLLABLE KYO;Lo;0;L;;;;;N;;;;;
2DD0;ETHIOPIC SYLLABLE XYA;Lo;0;L;;;;;N;;;;;
2DD1;ETHIOPIC SYLLABLE XYU;Lo;0;L;;;;;N;;;;;
2DD2;ETHIOPIC SYLLABLE XYI;Lo;0;L;;;;;N;;;;;
2DD3;ETHIOPIC SYLLABLE XYAA;Lo;0;L;;;;;N;;;;;
2DD4;ETHIOPIC SYLLABLE XYEE;Lo;0;L;;;;;N;;;;;
2DD5;ETHIOPIC SYLLABLE XYE;Lo;0;L;;;;;N;;;;;
2DD6;ETHIOPIC SYLLABLE XYO;Lo;0;L;;;;;N;;;;;
2DD8;ETHIOPIC SYLLABLE GYA;Lo;0;L;;;;;N;;;;;
2DD9;ETHIOPIC SYLLABLE GYU;Lo;0;L;;;;;N;;;;;
2DDA;ETHIOPIC SYLLABLE GYI;Lo;0;L;;;;;N;;;;;
2DDB;ETHIOPIC SYLLABLE GYAA;Lo;0;L;;;;;N;;;;;
2DDC;ETHIOPIC SYLLABLE GYEE;Lo;0;L;;;;;N;;;;;
2DDD;ETHIOPIC SYLLABLE GYE;Lo;0;L;;;;;N;;;;;
2DDE;ETHIOPIC SYLLABLE GYO;Lo;0;L;;;;;N;;;;;
2DE0;COMBINING CYRILLIC LETTER BE;Mn;230;NSM;;;;;N;;;;;
2DE1;COMBINING CYRILLIC LETTER VE;Mn;230;NSM;;;;;N;;;;;
2DE2;COMBINING CYRILLIC LETTER GHE;Mn;230;NSM;;;;;N;;;;;
2DE3;COMBINING CYRILLIC LETTER DE;Mn;230;NSM;;;;;N;;;;;
2DE4;COMBINING CYRILLIC LETTER ZHE;Mn;230;NSM;;;;;N;;;;;
2DE5;COMBINING CYRILLIC LETTER ZE;Mn;230;NSM;;;;;N;;;;;
2DE6;COMBINING CYRILLIC LETTER KA;Mn;230;NSM;;;;;N;;;;;
2DE7;COMBINING CYRILLIC LETTER EL;Mn;230;NSM;;;;;N;;;;;
2DE8;COMBINING CYRILLIC LETTER EM;Mn;230;NSM;;;;;N;;;;;
2DE9;COMBINING CYRILLIC LETTER EN;Mn;230;NSM;;;;;N;;;;;
2DEA;COMBINING CYRILLIC LETTER O;Mn;230;NSM;;;;;N;;;;;
2DEB;COMBINING CYRILLIC LETTER PE;Mn;230;NSM;;;;;N;;;;;
2DEC;COMBINING CYRILLIC LETTER ER;Mn;230;NSM;;;;;N;;;;;
2DED;COMBINING CYRILLIC LETTER ES;Mn;230;NSM;;;;;N;;;;;
2DEE;COMBINING CYRILLIC LETTER TE;Mn;230;NSM;;;;;N;;;;;
2DEF;COMBINING CYRILLIC LETTER HA;Mn;230;NSM;;;;;N;;;;;
2DF0;COMBINING CYRILLIC LETTER TSE;Mn;230;NSM;;;;;N;;;;;
2DF1;COMBINING CYRILLIC LETTER CHE;Mn;230;NSM;;;;;N;;;;;
2DF2;COMBINING CYRILLIC LETTER SHA;Mn;230;NSM;;;;;N;;;;;
2DF3;COMBINING CYRILLIC LETTER SHCHA;Mn;230;NSM;;;;;N;;;;;
2DF4;COMBINING CYRILLIC LETTER FITA;Mn;230;NSM;;;;;N;;;;;
2DF5;COMBINING CYRILLIC LETTER ES-TE;Mn;230;NSM;;;;;N;;;;;
2DF6;COMBINING CYRILLIC LETTER A;Mn;230;NSM;;;;;N;;;;;
2DF7;COMBINING CYRILLIC LETTER IE;Mn;230;NSM;;;;;N;;;;;
2DF8;COMBINING CYRILLIC LETTER DJERV;Mn;230;NSM;;;;;N;;;;;
2DF9;COMBINING CYRILLIC LETTER MONOGRAPH UK;Mn;230;NSM;;;;;N;;;;;
2DFA;COMBINING CYRILLIC LETTER YAT;Mn;230;NSM;;;;;N;;;;;
2DFB;COMBINING CYRILLIC LETTER YU;Mn;230;NSM;;;;;N;;;;;
2DFC;COMBINING CYRILLIC LETTER IOTIFIED A;Mn;230;NSM;;;;;N;;;;;
2DFD;COMBINING CYRILLIC LETTER LITTLE YUS;Mn;230;NSM;;;;;N;;;;;
2DFE;COMBINING CYRILLIC LETTER BIG YUS;Mn;230;NSM;;;;;N;;;;;
2DFF;COMBINING CYRILLIC LETTER IOTIFIED BIG YUS;Mn;230;NSM;;;;;N;;;;;
2E00;RIGHT ANGLE SUBSTITUTION MARKER;Po;0;ON;;;;;N;;;;;
2E01;RIGHT ANGLE DOTTED SUBSTITUTION MARKER;Po;0;ON;;;;;N;;;;;
2E02;LEFT SUBSTITUTION BRACKET;Pi;0;ON;;;;;Y;;;;;
2E03;RIGHT SUBSTITUTION BRACKET;Pf;0;ON;;;;;Y;;;;;
2E04;LEFT DOTTED SUBSTITUTION BRACKET;Pi;0;ON;;;;;Y;;;;;
2E05;RIGHT DOTTED SUBSTITUTION BRACKET;Pf;0;ON;;;;;Y;;;;;
2E06;RAISED INTERPOLATION MARKER;Po;0;ON;;;;;N;;;;;
2E07;RAISED DOTTED INTERPOLATION MARKER;Po;0;ON;;;;;N;;;;;
2E08;DOTTED TRANSPOSITION MARKER;Po;0;ON;;;;;N;;;;;
2E09;LEFT TRANSPOSITION BRACKET;Pi;0;ON;;;;;Y;;;;;
2E0A;RIGHT TRANSPOSITION BRACKET;Pf;0;ON;;;;;Y;;;;;
2E0B;RAISED SQUARE;Po;0;ON;;;;;N;;;;;
2E0C;LEFT RAISED OMISSION BRACKET;Pi;0;ON;;;;;Y;;;;;
2E0D;RIGHT RAISED OMISSION BRACKET;Pf;0;ON;;;;;Y;;;;;
2E0E;EDITORIAL CORONIS;Po;0;ON;;;;;N;;;;;
2E0F;PARAGRAPHOS;Po;0;ON;;;;;N;;;;;
2E10;FORKED PARAGRAPHOS;Po;0;ON;;;;;N;;;;;
2E11;REVERSED FORKED PARAGRAPHOS;Po;0;ON;;;;;N;;;;;
2E12;HYPODIASTOLE;Po;0;ON;;;;;N;;;;;
2E13;DOTTED OBELOS;Po;0;ON;;;;;N;;;;;
2E14;DOWNWARDS ANCORA;Po;0;ON;;;;;N;;;;;
2E15;UPWARDS ANCORA;Po;0;ON;;;;;N;;;;;
2E16;DOTTED RIGHT-POINTING ANGLE;Po;0;ON;;;;;N;;;;;
2E17;DOUBLE OBLIQUE HYPHEN;Pd;0;ON;;;;;N;;;;;
2E18;INVERTED INTERROBANG;Po;0;ON;;;;;N;;;;;
2E19;PALM BRANCH;Po;0;ON;;;;;N;;;;;
2E1A;HYPHEN WITH DIAERESIS;Pd;0;ON;;;;;N;;;;;
2E1B;TILDE WITH RING ABOVE;Po;0;ON;;;;;N;;;;;
2E1C;LEFT LOW PARAPHRASE BRACKET;Pi;0;ON;;;;;Y;;;;;
2E1D;RIGHT LOW PARAPHRASE BRACKET;Pf;0;ON;;;;;Y;;;;;
2E1E;TILDE WITH DOT ABOVE;Po;0;ON;;;;;N;;;;;
2E1F;TILDE WITH DOT BELOW;Po;0;ON;;;;;N;;;;;
2E20;LEFT VERTICAL BAR WITH QUILL;Pi;0;ON;;;;;Y;;;;;
2E21;RIGHT VERTICAL BAR WITH QUILL;Pf;0;ON;;;;;Y;;;;;
2E22;TOP LEFT HALF BRACKET;Ps;0;ON;;;;;Y;;;;;
2E23;TOP RIGHT HALF BRACKET;Pe;0;ON;;;;;Y;;;;;
2E24;BOTTOM LEFT HALF BRACKET;Ps;0;ON;;;;;Y;;;;;
2E25;BOTTOM RIGHT HALF BRACKET;Pe;0;ON;;;;;Y;;;;;
2E26;LEFT SIDEWAYS U BRACKET;Ps;0;ON;;;;;Y;;;;;
2E27;RIGHT SIDEWAYS U BRACKET;Pe;0;ON;;;;;Y;;;;;
2E28;LEFT DOUBLE PARENTHESIS;Ps;0;ON;;;;;Y;;;;;
2E29;RIGHT DOUBLE PARENTHESIS;Pe;0;ON;;;;;Y;;;;;
2E2A;TWO DOTS OVER ONE DOT PUNCTUATION;Po;0;ON;;;;;N;;;;;
2E2B;ONE DOT OVER TWO DOTS PUNCTUATION;Po;0;ON;;;;;N;;;;;
2E2C;SQUARED FOUR DOT PUNCTUATION;Po;0;ON;;;;;N;;;;;
2E2D;FIVE DOT MARK;Po;0;ON;;;;;N;;;;;
2E2E;REVERSED QUESTION MARK;Po;0;ON;;;;;N;;;;;
2E2F;VERTICAL TILDE;Lm;0;ON;;;;;N;;;;;
2E30;RING POINT;Po;0;ON;;;;;N;;;;;
2E31;WORD SEPARATOR MIDDLE DOT;Po;0;ON;;;;;N;;;;;
2E32;TURNED COMMA;Po;0;ON;;;;;N;;;;;
2E33;RAISED DOT;Po;0;ON;;;;;N;;;;;
2E34;RAISED COMMA;Po;0;ON;;;;;N;;;;;
2E35;TURNED SEMICOLON;Po;0;ON;;;;;N;;;;;
2E36;DAGGER WITH LEFT GUARD;Po;0;ON;;;;;N;;;;;
2E37;DAGGER WITH RIGHT GUARD;Po;0;ON;;;;;N;;;;;
2E38;TURNED DAGGER;Po;0;ON;;;;;N;;;;;
2E39;TOP HALF SECTION SIGN;Po;0;ON;;;;;N;;;;;
2E3A;TWO-EM DASH;Pd;0;ON;;;;;N;;;;;
2E3B;THREE-EM DASH;Pd;0;ON;;;;;N;;;;;
2E3C;STENOGRAPHIC FULL STOP;Po;0;ON;;;;;N;;;;;
2E3D;VERTICAL SIX DOTS;Po;0;ON;;;;;N;;;;;
2E3E;WIGGLY VERTICAL LINE;Po;0;ON;;;;;N;;;;;
2E3F;CAPITULUM;Po;0;ON;;;;;N;;;;;
2E40;DOUBLE HYPHEN;Pd;0;ON;;;;;N;;;;;
2E41;REVERSED COMMA;Po;0;ON;;;;;N;;;;;
2E42;DOUBLE LOW-REVERSED-9 QUOTATION MARK;Ps;0;ON;;;;;N;;;;;
2E43;DASH WITH LEFT UPTURN;Po;0;ON;;;;;N;;;;;
2E44;DOUBLE SUSPENSION MARK;Po;0;ON;;;;;N;;;;;
2E45;INVERTED LOW KAVYKA;Po;0;ON;;;;;N;;;;;
2E46;INVERTED LOW KAVYKA WITH KAVYKA ABOVE;Po;0;ON;;;;;N;;;;;
2E47;LOW KAVYKA;Po;0;ON;;;;;N;;;;;
2E48;LOW KAVYKA WITH DOT;Po;0;ON;;;;;N;;;;;
2E49;DOUBLE STACKED COMMA;Po;0;ON;;;;;N;;;;;
2E4A;DOTTED SOLIDUS;Po;0;ON;;;;;N;;;;;
2E4B;TRIPLE DAGGER;Po;0;ON;;;;;N;;;;;
2E4C;MEDIEVAL COMMA;Po;0;ON;;;;;N;;;;;
2E4D;PARAGRAPHUS MARK;Po;0;ON;;;;;N;;;;;
2E4E;PUNCTUS ELEVATUS MARK;Po;0;ON;;;;;N;;;;;
2E4F;CORNISH VERSE DIVIDER;Po;0;ON;;;;;N;;;;;
2E50;CROSS PATTY WITH RIGHT CROSSBAR;So;0;ON;;;;;N;;;;;
2E51;CROSS PATTY WITH LEFT CROSSBAR;So;0;ON;;;;;N;;;;;
2E52;TIRONIAN SIGN CAPITAL ET;Po;0;ON;;;;;N;;;;;
2E53;MEDIEVAL EXCLAMATION MARK;Po;0;ON;;;;;N;;;;;
2E54;MEDIEVAL QUESTION MARK;Po;0;ON;;;;;N;;;;;
2E55;LEFT SQUARE BRACKET WITH STROKE;Ps;0;ON;;;;;Y;;;;;
2E56;RIGHT SQUARE BRACKET WITH STROKE;Pe;0;ON;;;;;Y;;;;;
2E57;LEFT SQUARE BRACKET WITH DOUBLE STROKE;Ps;0;ON;;;;;Y;;;;;
2E58;RIGHT SQUARE BRACKET WITH DOUBLE STROKE;Pe;0;ON;;;;;Y;;;;;
2E59;TOP HALF LEFT PARENTHESIS;Ps;0;ON;;;;;Y;;;;;
2E5A;TOP HALF RIGHT PARENTHESIS;Pe;0;ON;;;;;Y;;;;;
2E5B;BOTTOM HALF LEFT PARENTHESIS;Ps;0;ON;;;;;Y;;;;;
2E5C;BOTTOM HALF RIGHT PARENTHESIS;Pe;0;ON;;;;;Y;;;;;
2E5D;OBLIQUE HYPHEN;Pd;0;ON;;;;;N;;;;;
2E80;CJK RADICAL REPEAT;So;0;ON;;;;;N;;;;;
2E81;CJK RADICAL CLIFF;So;0;ON;;;;;N;;;;;
2E82;CJK RADICAL SECOND ONE;So;0;ON;;;;;N;;;;;
2E83;CJK RADICAL SECOND TWO;So;0;ON;;;;;N;;;;;
2E84;CJK RADICAL SECOND THREE;So;0;ON;;;;;N;;;;;
2E85;CJK RADICAL PERSON;So;0;ON;;;;;N;;;;;
2E86;CJK RADICAL BOX;So;0;ON;;;;;N;;;;;
2E87;CJK RADICAL TABLE;So;0;ON;;;;;N;;;;;
2E88;CJK RADICAL KNIFE ONE;So;0;ON;;;;;N;;;;;
2E89;CJK RADICAL KNIFE TWO;So;0;ON;;;;;N;;;;;
2E8A;CJK RADICAL DIVINATION;So;0;ON;;;;;N;;;;;
2E8B;CJK RADICAL SEAL;So;0;ON;;;;;N;;;;;
2E8C;CJK RADICAL SMALL ONE;So;0;ON;;;;;N;;;;;
2E8D;CJK RADICAL SMALL TWO;So;0;ON;;;;;N;;;;;
2E8E;CJK RADICAL LAME ONE;So;0;ON;;;;;N;;;;;
2E8F;CJK RADICAL LAME TWO;So;0;ON;;;;;N;;;;;
2E90;CJK RADICAL LAME THREE;So;0;ON;;;;;N;;;;;
2E91;CJK RADICAL LAME FOUR;So;0;ON;;;;;N;;;;;
2E92;CJK RADICAL SNAKE;So;0;ON;;;;;N;;;;;
2E93;CJK RADICAL THREAD;So;0;ON;;;;;N;;;;;
2E94;CJK RADICAL SNOUT ONE;So;0;ON;;;;;N;;;;;
2E95;CJK RADICAL SNOUT TWO;So;0;ON;;;;;N;;;;;
2E96;CJK RADICAL HEART ONE;So;0;ON;;;;;N;;;;;
2E97;CJK RADICAL HEART TWO;So;0;ON;;;;;N;;;;;
2E98;CJK RADICAL HAND;So;0;ON;;;;;N;;;;;
2E99;CJK RADICAL RAP;So;0;ON;;;;;N;;;;;
2E9B;CJK RADICAL CHOKE;So;0;ON;;;;;N;;;;;
2E9C;CJK RADICAL SUN;So;0;ON;;;;;N;;;;;
2E9D;CJK RADICAL MOON;So;0;ON;;;;;N;;;;;
2E9E;CJK RADICAL DEATH;So;0;ON;;;;;N;;;;;
2E9F;CJK RADICAL MOTHER;So;0;ON;<compat> 6BCD;;;;N;;;;;
2EA0;CJK RADICAL CIVILIAN;So;0;ON;;;;;N;;;;;
2EA1;CJK RADICAL WATER ONE;So;0;ON;;;;;N;;;;;
2EA2;CJK RADICAL WATER TWO;So;0;ON;;;;;N;;;;;
2EA3;CJK RADICAL FIRE;So;0;ON;;;;;N;;;;;
2EA4;CJK RADICAL PAW ONE;So;0;ON;;;;;N;;;;;
2EA5;CJK RADICAL PAW TWO;So;0;ON;;;;;N;;;;;
2EA6;CJK RADICAL SIMPLIFIED HALF TREE TRUNK;So;0;ON;;;;;N;;;;;
2EA7;CJK RADICAL COW;So;0;ON;;;;;N;;;;;
2EA8;CJK RADICAL DOG;So;0;ON;;;;;N;;;;;
2EA9;CJK RADICAL JADE;So;0;ON;;;;;N;;;;;
2EAA;CJK RADICAL BOLT OF CLOTH;So;0;ON;;;;;N;;;;;
2EAB;CJK RADICAL EYE;So;0;ON;;;;;N;;;;;
2EAC;CJK RADICAL SPIRIT ONE;So;0;ON;;;;;N;;;;;
2EAD;CJK RADICAL SPIRIT TWO;So;0;ON;;;;;N;;;;;
2EAE;CJK RADICAL BAMBOO;So;0;ON;;;;;N;;;;;
2EAF;CJK RADICAL SILK;So;0;ON;;;;;N;;;;;
2EB0;CJK RADICAL C-SIMPLIFIED SILK;So;0;ON;;;;;N;;;;;
2EB1;CJK RADICAL NET ONE;So;0;ON;;;;;N;;;;;
2EB2;CJK RADICAL NET TWO;So;0;ON;;;;;N;;;;;
2EB3;CJK RADICAL NET THREE;So;0;ON;;;;;N;;;;;
2EB4;CJK RADICAL NET FOUR;So;0;ON;;;;;N;;;;;
2EB5;CJK RADICAL MESH;So;0;ON;;;;;N;;;;;
2EB6;CJK RADICAL SHEEP;So;0;ON;;;;;N;;;;;
2EB7;CJK RADICAL RAM;So;0;ON;;;;;N;;;;;
2EB8;CJK RADICAL EWE;So;0;ON;;;;;N;;;;;
2EB9;CJK RADICAL OLD;So;0;ON;;;;;N;;;;;
2EBA;CJK RADICAL BRUSH ONE;So;0;ON;;;;;N;;;;;
2EBB;CJK RADICAL BRUSH TWO;So;0;ON;;;;;N;;;;;
2EBC;CJK RADICAL MEAT;So;0;ON;;;;;N;;;;;
2EBD;CJK RADICAL MORTAR;So;0;ON;;;;;N;;;;;
2EBE;CJK RADICAL GRASS ONE;So;0;ON;;;;;N;;;;;
2EBF;CJK RADICAL GRASS TWO;So;0;ON;;;;;N;;;;;
2EC0;CJK RADICAL GRASS THREE;So;0;ON;;;;;N;;;;;
2EC1;CJK RADICAL TIGER;So;0;ON;;;;;N;;;;;
2EC2;CJK RADICAL CLOTHES;So;0;ON;;;;;N;;;;;
2EC3;CJK RADICAL WEST ONE;So;0;ON;;;;;N;;;;;
2EC4;CJK RADICAL WEST TWO;So;0;ON;;;;;N;;;;;
2EC5;CJK RADICAL C-SIMPLIFIED SEE;So;0;ON;;;;;N;;;;;
2EC6;CJK RADICAL SIMPLIFIED HORN;So;0;ON;;;;;N;;;;;
2EC7;CJK RADICAL HORN;So;0;ON;;;;;N;;;;;
2EC8;CJK RADICAL C-SIMPLIFIED SPEECH;So;0;ON;;;;;N;;;;;
2EC9;CJK RADICAL C-SIMPLIFIED SHELL;So;0;ON;;;;;N;;;;;
2ECA;CJK RADICAL FOOT;So;0;ON;;;;;N;;;;;
2ECB;CJK RADICAL C-SIMPLIFIED CART;So;0;ON;;;;;N;;;;;
2ECC;CJK RADICAL SIMPLIFIED WALK;So;0;ON;;;;;N;;;;;
2ECD;CJK RADICAL WALK ONE;So;0;ON;;;;;N;;;;;
2ECE;CJK RADICAL WALK TWO;So;0;ON;;;;;N;;;;;
2ECF;CJK RADICAL CITY;So;0;ON;;;;;N;;;;;
2ED0;CJK RADICAL C-SIMPLIFIED GOLD;So;0;ON;;;;;N;;;;;
2ED1;CJK RADICAL LONG ONE;So;0;ON;;;;;N;;;;;
2ED2;CJK RADICAL LONG TWO;So;0;ON;;;;;N;;;;;
2ED3;CJK RADICAL C-SIMPLIFIED LONG;So;0;ON;;;;;N;;;;;
2ED4;CJK RADICAL C-SIMPLIFIED GATE;So;0;ON;;;;;N;;;;;
2ED5;CJK RADICAL MOUND ONE;So;0;ON;;;;;N;;;;;
2ED6;CJK RADICAL MOUND TWO;So;0;ON;;;;;N;;;;;
2ED7;CJK RADICAL RAIN;So;0;ON;;;;;N;;;;;
2ED8;CJK RADICAL BLUE;So;0;ON;;;;;N;;;;;
2ED9;CJK RADICAL C-SIMPLIFIED TANNED LEATHER;So;0;ON;;;;;N;;;;;
2EDA;CJK RADICAL C-SIMPLIFIED LEAF;So;0;ON;;;;;N;;;;;
2EDB;CJK RADICAL C-SIMPLIFIED WIND;So;0;ON;;;;;N;;;;;
2EDC;CJK RADICAL C-SIMPLIFIED FLY;So;0;ON;;;;;N;;;;;
2EDD;CJK RADICAL EAT ONE;So;0;ON;;;;;N;;;;;
2EDE;CJK RADICAL EAT TWO;So;0;ON;;;;;N;;;;;
2EDF;CJK RADICAL EAT THREE;So;0;ON;;;;;N;;;;;
2EE0;CJK RADICAL C-SIMPLIFIED EAT;So;0;ON;;;;;N;;;;;
2EE1;CJK RADICAL HEAD;So;0;ON;;;;;N;;;;;
2EE2;CJK RADICAL C-SIMPLIFIED HORSE;So;0;ON;;;;;N;;;;;
2EE3;CJK RADICAL BONE;So;0;ON;;;;;N;;;;;
2EE4;CJK RADICAL GHOST;So;0;ON;;;;;N;;;;;
2EE5;CJK RADICAL C-SIMPLIFIED FISH;So;0;ON;;;;;N;;;;;
2EE6;CJK RADICAL C-SIMPLIFIED BIRD;So;0;ON;;;;;N;;;;;
2EE7;CJK RADICAL C-SIMPLIFIED SALT;So;0;ON;;;;;N;;;;;
2EE8;CJK RADICAL SIMPLIFIED WHEAT;So;0;ON;;;;;N;;;;;
2EE9;CJK RADICAL SIMPLIFIED YELLOW;So;0;ON;;;;;N;;;;;
2EEA;CJK RADICAL C-SIMPLIFIED FROG;So;0;ON;;;;;N;;;;;
2EEB;CJK RADICAL J-SIMPLIFIED EVEN;So;0;ON;;;;;N;;;;;
2EEC;CJK RADICAL C-SIMPLIFIED EVEN;So;0;ON;;;;;N;;;;;
2EED;CJK RADICAL J-SIMPLIFIED TOOTH;So;0;ON;;;;;N;;;;;
2EEE;CJK RADICAL C-SIMPLIFIED TOOTH;So;0;ON;;;;;N;;;;;
2EEF;CJK RADICAL J-SIMPLIFIED DRAGON;So;0;ON;;;;;N;;;;;
2EF0;CJK RADICAL C-SIMPLIFIED DRAGON;So;0;ON;;;;;N;;;;;
2EF1;CJK RADICAL TURTLE;So;0;ON;;;;;N;;;;;
2EF2;CJK RADICAL J-SIMPLIFIED TURTLE;So;0;ON;;;;;N;;;;;
2EF3;CJK RADICAL C-SIMPLIFIED TURTLE;So;0;ON;<compat> 9F9F;;;;N;;;;;
2F00;KANGXI RADICAL ONE;So;0;ON;<compat> 4E00;;;;N;;;;;
2F01;KANGXI RADICAL LINE;So;0;ON;<compat> 4E28;;;;N;;;;;
2F02;KANGXI RADICAL DOT;So;0;ON;<compat> 4E36;;;;N;;;;;
2F03;KANGXI RADICAL SLASH;So;0;ON;<compat> 4E3F;;;;N;;;;;
2F04;KANGXI RADICAL SECOND;So;0;ON;<compat> 4E59;;;;N;;;;;
2F05;KANGXI RADICAL HOOK;So;0;ON;<compat> 4E85;;;;N;;;;;
2F06;KANGXI RADICAL TWO;So;0;ON;<compat> 4E8C;;;;N;;;;;
2F07;KANGXI RADICAL LID;So;0;ON;<compat> 4EA0;;;;N;;;;;
2F08;KANGXI RADICAL MAN;So;0;ON;<compat> 4EBA;;;;N;;;;;
2F09;KANGXI RADICAL LEGS;So;0;ON;<compat> 513F;;;;N;;;;;
2F0A;KANGXI RADICAL ENTER;So;0;ON;<compat> 5165;;;;N;;;;;
2F0B;KANGXI RADICAL EIGHT;So;0;ON;<compat> 516B;;;;N;;;;;
2F0C;KANGXI RADICAL DOWN BOX;So;0;ON;<compat> 5182;;;;N;;;;;
2F0D;KANGXI RADICAL COVER;So;0;ON;<compat> 5196;;;;N;;;;;
2F0E;KANGXI RADICAL ICE;So;0;ON;<compat> 51AB;;;;N;;;;;
2F0F;KANGXI RADICAL TABLE;So;0;ON;<compat> 51E0;;;;N;;;;;
2F10;KANGXI RADICAL OPEN BOX;So;0;ON;<compat> 51F5;;;;N;;;;;
2F11;KANGXI RADICAL KNIFE;So;0;ON;<compat> 5200;;;;N;;;;;
2F12;KANGXI RADICAL POWER;So;0;ON;<compat> 529B;;;;N;;;;;
2F13;KANGXI RADICAL WRAP;So;0;ON;<compat> 52F9;;;;N;;;;;
2F14;KANGXI RADICAL SPOON;So;0;ON;<compat> 5315;;;;N;;;;;
2F15;KANGXI RADICAL RIGHT OPEN BOX;So;0;ON;<compat> 531A;;;;N;;;;;
2F16;KANGXI RADICAL HIDING ENCLOSURE;So;0;ON;<compat> 5338;;;;N;;;;;
2F17;KANGXI RADICAL TEN;So;0;ON;<compat> 5341;;;;N;;;;;
2F18;KANGXI RADICAL DIVINATION;So;0;ON;<compat> 535C;;;;N;;;;;
2F19;KANGXI RADICAL SEAL;So;0;ON;<compat> 5369;;;;N;;;;;
2F1A;KANGXI RADICAL CLIFF;So;0;ON;<compat> 5382;;;;N;;;;;
2F1B;KANGXI RADICAL PRIVATE;So;0;ON;<compat> 53B6;;;;N;;;;;
2F1C;KANGXI RADICAL AGAIN;So;0;ON;<compat> 53C8;;;;N;;;;;
2F1D;KANGXI RADICAL MOUTH;So;0;ON;<compat> 53E3;;;;N;;;;;
2F1E;KANGXI RADICAL ENCLOSURE;So;0;ON;<compat> 56D7;;;;N;;;;;
2F1F;KANGXI RADICAL EARTH;So;0;ON;<compat> 571F;;;;N;;;;;
2F20;KANGXI RADICAL SCHOLAR;So;0;ON;<compat> 58EB;;;;N;;;;;
2F21;KANGXI RADICAL GO;So;0;ON;<compat> 5902;;;;N;;;;;
2F22;KANGXI RADICAL GO SLOWLY;So;0;ON;<compat> 590A;;;;N;;;;;
2F23;KANGXI RADICAL EVENING;So;0;ON;<compat> 5915;;;;N;;;;;
2F24;KANGXI RADICAL BIG;So;0;ON;<compat> 5927;;;;N;;;;;
2F25;KANGXI RADICAL WOMAN;So;0;ON;<compat> 5973;;;;N;;;;;
2F26;KANGXI RADICAL CHILD;So;0;ON;<compat> 5B50;;;;N;;;;;
2F27;KANGXI RADICAL ROOF;So;0;ON;<compat> 5B80;;;;N;;;;;
2F28;KANGXI RADICAL INCH;So;0;ON;<compat> 5BF8;;;;N;;;;;
2F29;KANGXI RADICAL SMALL;So;0;ON;<compat> 5C0F;;;;N;;;;;
2F2A;KANGXI RADICAL LAME;So;0;ON;<compat> 5C22;;;;N;;;;;
2F2B;KANGXI RADICAL CORPSE;So;0;ON;<compat> 5C38;;;;N;;;;;
2F2C;KANGXI RADICAL SPROUT;So;0;ON;<compat> 5C6E;;;;N;;;;;
2F2D;KANGXI RADICAL MOUNTAIN;So;0;ON;<compat> 5C71;;;;N;;;;;
2F2E;KANGXI RADICAL RIVER;So;0;ON;<compat> 5DDB;;;;N;;;;;
2F2F;KANGXI RADICAL WORK;So;0;ON;<compat> 5DE5;;;;N;;;;;
2F30;KANGXI RADICAL ONESELF;So;0;ON;<compat> 5DF1;;;;N;;;;;
2F31;KANGXI RADICAL TURBAN;So;0;ON;<compat> 5DFE;;;;N;;;;;
2F32;KANGXI RADICAL DRY;So;0;ON;<compat> 5E72;;;;N;;;;;
2F33;KANGXI RADICAL SHORT THREAD;So;0;ON;<compat> 5E7A;;;;N;;;;;
2F34;KANGXI RADICAL DOTTED CLIFF;So;0;ON;<compat> 5E7F;;;;N;;;;;
2F35;KANGXI RADICAL LONG STRIDE;So;0;ON;<compat> 5EF4;;;;N;;;;;
2F36;KANGXI RADICAL TWO HANDS;So;0;ON;<compat> 5EFE;;;;N;;;;;
2F37;KANGXI RADICAL SHOOT;So;0;ON;<compat> 5F0B;;;;N;;;;;
2F38;KANGXI RADICAL BOW;So;0;ON;<compat> 5F13;;;;N;;;;;
2F39;KANGXI RADICAL SNOUT;So;0;ON;<compat> 5F50;;;;N;;;;;
2F3A;KANGXI RADICAL BRISTLE;So;0;ON;<compat> 5F61;;;;N;;;;;
2F3B;KANGXI RADICAL STEP;So;0;ON;<compat> 5F73;;;;N;;;;;
2F3C;KANGXI RADICAL HEART;So;0;ON;<compat> 5FC3;;;;N;;;;;
2F3D;KANGXI RADICAL HALBERD;So;0;ON;<compat> 6208;;;;N;;;;;
2F3E;KANGXI RADICAL DOOR;So;0;ON;<compat> 6236;;;;N;;;;;
2F3F;KANGXI RADICAL HAND;So;0;ON;<compat> 624B;;;;N;;;;;
2F40;KANGXI RADICAL BRANCH;So;0;ON;<compat> 652F;;;;N;;;;;
2F41;KANGXI RADICAL RAP;So;0;ON;<compat> 6534;;;;N;;;;;
2F42;KANGXI RADICAL SCRIPT;So;0;ON;<compat> 6587;;;;N;;;;;
2F43;KANGXI RADICAL DIPPER;So;0;ON;<compat> 6597;;;;N;;;;;
2F44;KANGXI RADICAL AXE;So;0;ON;<compat> 65A4;;;;N;;;;;
2F45;KANGXI RADICAL SQUARE;So;0;ON;<compat> 65B9;;;;N;;;;;
2F46;KANGXI RADICAL NOT;So;0;ON;<compat> 65E0;;;;N;;;;;
2F47;KANGXI RADICAL SUN;So;0;ON;<compat> 65E5;;;;N;;;;;
2F48;KANGXI RADICAL SAY;So;0;ON;<compat> 66F0;;;;N;;;;;
2F49;KANGXI RADICAL MOON;So;0;ON;<compat> 6708;;;;N;;;;;
2F4A;KANGXI RADICAL TREE;So;0;ON;<compat> 6728;;;;N;;;;;
2F4B;KANGXI RADICAL LACK;So;0;ON;<compat> 6B20;;;;N;;;;;
2F4C;KANGXI RADICAL STOP;So;0;ON;<compat> 6B62;;;;N;;;;;
2F4D;KANGXI RADICAL DEATH;So;0;ON;<compat> 6B79;;;;N;;;;;
2F4E;KANGXI RADICAL WEAPON;So;0;ON;<compat> 6BB3;;;;N;;;;;
2F4F;KANGXI RADICAL DO NOT;So;0;ON;<compat> 6BCB;;;;N;;;;;
2F50;KANGXI RADICAL COMPARE;So;0;ON;<compat> 6BD4;;;;N;;;;;
2F51;KANGXI RADICAL FUR;So;0;ON;<compat> 6BDB;;;;N;;;;;
2F52;KANGXI RADICAL CLAN;So;0;ON;<compat> 6C0F;;;;N;;;;;
2F53;KANGXI RADICAL STEAM;So;0;ON;<compat> 6C14;;;;N;;;;;
2F54;KANGXI RADICAL WATER;So;0;ON;<compat> 6C34;;;;N;;;;;
2F55;KANGXI RADICAL FIRE;So;0;ON;<compat> 706B;;;;N;;;;;
2F56;KANGXI RADICAL CLAW;So;0;ON;<compat> 722A;;;;N;;;;;
2F57;KANGXI RADICAL FATHER;So;0;ON;<compat> 7236;;;;N;;;;;
2F58;KANGXI RADICAL DOUBLE X;So;0;ON;<compat> 723B;;;;N;;;;;
2F59;KANGXI RADICAL HALF TREE TRUNK;So;0;ON;<compat> 723F;;;;N;;;;;
2F5A;KANGXI RADICAL SLICE;So;0;ON;<compat> 7247;;;;N;;;;;
2F5B;KANGXI RADICAL FANG;So;0;ON;<compat> 7259;;;;N;;;;;
2F5C;KANGXI RADICAL COW;So;0;ON;<compat> 725B;;;;N;;;;;
2F5D;KANGXI RADICAL DOG;So;0;ON;<compat> 72AC;;;;N;;;;;
2F5E;KANGXI RADICAL PROFOUND;So;0;ON;<compat> 7384;;;;N;;;;;
2F5F;KANGXI RADICAL JADE;So;0;ON;<compat> 7389;;;;N;;;;;
2F60;KANGXI RADICAL MELON;So;0;ON;<compat> 74DC;;;;N;;;;;
2F61;KANGXI RADICAL TILE;So;0;ON;<compat> 74E6;;;;N;;;;;
2F62;KANGXI RADICAL SWEET;So;0;ON;<compat> 7518;;;;N;;;;;
2F63;KANGXI RADICAL LIFE;So;0;ON;<compat> 751F;;;;N;;;;;
2F64;KANGXI RADICAL USE;So;0;ON;<compat> 7528;;;;N;;;;;
2F65;KANGXI RADICAL FIELD;So;0;ON;<compat> 7530;;;;N;;;;;
2F66;KANGXI RADICAL BOLT OF CLOTH;So;0;ON;<compat> 758B;;;;N;;;;;
2F67;KANGXI RADICAL SICKNESS;So;0;ON;<compat> 7592;;;;N;;;;;
2F68;KANGXI RADICAL DOTTED TENT;So;0;ON;<compat> 7676;;;;N;;;;;
2F69;KANGXI RADICAL WHITE;So;0;ON;<compat> 767D;;;;N;;;;;
2F6A;KANGXI RADICAL SKIN;So;0;ON;<compat> 76AE;;;;N;;;;;
2F6B;KANGXI RADICAL DISH;So;0;ON;<compat> 76BF;;;;N;;;;;
2F6C;KANGXI RADICAL EYE;So;0;ON;<compat> 76EE;;;;N;;;;;
2F6D;KANGXI RADICAL SPEAR;So;0;ON;<compat> 77DB;;;;N;;;;;
2F6E;KANGXI RADICAL ARROW;So;0;ON;<compat> 77E2;;;;N;;;;;
2F6F;KANGXI RADICAL STONE;So;0;ON;<compat> 77F3;;;;N;;;;;
2F70;KANGXI RADICAL SPIRIT;So;0;ON;<compat> 793A;;;;N;;;;;
2F71;KANGXI RADICAL TRACK;So;0;ON;<compat> 79B8;;;;N;;;;;
2F72;KANGXI RADICAL GRAIN;So;0;ON;<compat> 79BE;;;;N;;;;;
2F73;KANGXI RADICAL CAVE;So;0;ON;<compat> 7A74;;;;N;;;;;
2F74;KANGXI RADICAL STAND;So;0;ON;<compat> 7ACB;;;;N;;;;;
2F75;KANGXI RADICAL BAMBOO;So;0;ON;<compat> 7AF9;;;;N;;;;;
2F76;KANGXI RADICAL RICE;So;0;ON;<compat> 7C73;;;;N;;;;;
2F77;KANGXI RADICAL SILK;So;0;ON;<compat> 7CF8;;;;N;;;;;
2F78;KANGXI RADICAL JAR;So;0;ON;<compat> 7F36;;;;N;;;;;
2F79;KANGXI RADICAL NET;So;0;ON;<compat> 7F51;;;;N;;;;;
2F7A;KANGXI RADICAL SHEEP;So;0;ON;<compat> 7F8A;;;;N;;;;;
2F7B;KANGXI RADICAL FEATHER;So;0;ON;<compat> 7FBD;;;;N;;;;;
2F7C;KANGXI RADICAL OLD;So;0;ON;<compat> 8001;;;;N;;;;;
2F7D;KANGXI RADICAL AND;So;0;ON;<compat> 800C;;;;N;;;;;
2F7E;KANGXI RADICAL PLOW;So;0;ON;<compat> 8012;;;;N;;;;;
2F7F;KANGXI RADICAL EAR;So;0;ON;<compat> 8033;;;;N;;;;;
2F80;KANGXI RADICAL BRUSH;So;0;ON;<compat> 807F;;;;N;;;;;
2F81;KANGXI RADICAL MEAT;So;0;ON;<compat> 8089;;;;N;;;;;
2F82;KANGXI RADICAL MINISTER;So;0;ON;<compat> 81E3;;;;N;;;;;
2F83;KANGXI RADICAL SELF;So;0;ON;<compat> 81EA;;;;N;;;;;
2F84;KANGXI RADICAL ARRIVE;So;0;ON;<compat> 81F3;;;;N;;;;;
2F85;KANGXI RADICAL MORTAR;So;0;ON;<compat> 81FC;;;;N;;;;;
2F86;KANGXI RADICAL TONGUE;So;0;ON;<compat> 820C;;;;N;;;;;
2F87;KANGXI RADICAL OPPOSE;So;0;ON;<compat> 821B;;;;N;;;;;
2F88;KANGXI RADICAL BOAT;So;0;ON;<compat> 821F;;;;N;;;;;
2F89;KANGXI RADICAL STOPPING;So;0;ON;<compat> 826E;;;;N;;;;;
2F8A;KANGXI RADICAL COLOR;So;0;ON;<compat> 8272;;;;N;;;;;
2F8B;KANGXI RADICAL GRASS;So;0;ON;<compat> 8278;;;;N;;;;;
2F8C;KANGXI RADICAL TIGER;So;0;ON;<compat> 864D;;;;N;;;;;
2F8D;KANGXI RADICAL INSECT;So;0;ON;<compat> 866B;;;;N;;;;;
2F8E;KANGXI RADICAL BLOOD;So;0;ON;<compat> 8840;;;;N;;;;;
2F8F;KANGXI RADICAL WALK ENCLOSURE;So;0;ON;<compat> 884C;;;;N;;;;;
2F90;KANGXI RADICAL CLOTHES;So;0;ON;<compat> 8863;;;;N;;;;;
2F91;KANGXI RADICAL WEST;So;0;ON;<compat> 897E;;;;N;;;;;
2F92;KANGXI RADICAL SEE;So;0;ON;<compat> 898B;;;;N;;;;;
2F93;KANGXI RADICAL HORN;So;0;ON;<compat> 89D2;;;;N;;;;;
2F94;KANGXI RADICAL SPEECH;So;0;ON;<compat> 8A00;;;;N;;;;;
2F95;KANGXI RADICAL VALLEY;So;0;ON;<compat> 8C37;;;;N;;;;;
2F96;KANGXI RADICAL BEAN;So;0;ON;<compat> 8C46;;;;N;;;;;
2F97;KANGXI RADICAL PIG;So;0;ON;<compat> 8C55;;;;N;;;;;
2F98;KANGXI RADICAL BADGER;So;0;ON;<compat> 8C78;;;;N;;;;;
2F99;KANGXI RADICAL SHELL;So;0;ON;<compat> 8C9D;;;;N;;;;;
2F9A;KANGXI RADICAL RED;So;0;ON;<compat> 8D64;;;;N;;;;;
2F9B;KANGXI RADICAL RUN;So;0;ON;<compat> 8D70;;;;N;;;;;
2F9C;KANGXI RADICAL FOOT;So;0;ON;<compat> 8DB3;;;;N;;;;;
2F9D;KANGXI RADICAL BODY;So;0;ON;<compat> 8EAB;;;;N;;;;;
2F9E;KANGXI RADICAL CART;So;0;ON;<compat> 8ECA;;;;N;;;;;
2F9F;KANGXI RADICAL BITTER;So;0;ON;<compat> 8F9B;;;;N;;;;;
2FA0;KANGXI RADICAL MORNING;So;0;ON;<compat> 8FB0;;;;N;;;;;
2FA1;KANGXI RADICAL WALK;So;0;ON;<compat> 8FB5;;;;N;;;;;
2FA2;KANGXI RADICAL CITY;So;0;ON;<compat> 9091;;;;N;;;;;
2FA3;KANGXI RADICAL WINE;So;0;ON;<compat> 9149;;;;N;;;;;
2FA4;KANGXI RADICAL DISTINGUISH;So;0;ON;<compat> 91C6;;;;N;;;;;
2FA5;KANGXI RADICAL VILLAGE;So;0;ON;<compat> 91CC;;;;N;;;;;
2FA6;KANGXI RADICAL GOLD;So;0;ON;<compat> 91D1;;;;N;;;;;
2FA7;KANGXI RADICAL LONG;So;0;ON;<compat> 9577;;;;N;;;;;
2FA8;KANGXI RADICAL GATE;So;0;ON;<compat> 9580;;;;N;;;;;
2FA9;KANGXI RADICAL MOUND;So;0;ON;<compat> 961C;;;;N;;;;;
2FAA;KANGXI RADICAL SLAVE;So;0;ON;<compat> 96B6;;;;N;;;;;
2FAB;KANGXI RADICAL SHORT TAILED BIRD;So;0;ON;<compat> 96B9;;;;N;;;;;
2FAC;KANGXI RADICAL RAIN;So;0;ON;<compat> 96E8;;;;N;;;;;
2FAD;KANGXI RADICAL BLUE;So;0;ON;<compat> 9751;;;;N;;;;;
2FAE;KANGXI RADICAL WRONG;So;0;ON;<compat> 975E;;;;N;;;;;
2FAF;KANGXI RADICAL FACE;So;0;ON;<compat> 9762;;;;N;;;;;
2FB0;KANGXI RADICAL LEATHER;So;0;ON;<compat> 9769;;;;N;;;;;
2FB1;KANGXI RADICAL TANNED LEATHER;So;0;ON;<compat> 97CB;;;;N;;;;;
2FB2;KANGXI RADICAL LEEK;So;0;ON;<compat> 97ED;;;;N;;;;;
2FB3;KANGXI RADICAL SOUND;So;0;ON;<compat> 97F3;;;;N;;;;;
2FB4;KANGXI RADICAL LEAF;So;0;ON;<compat> 9801;;;;N;;;;;
2FB5;KANGXI RADICAL WIND;So;0;ON;<compat> 98A8;;;;N;;;;;
2FB6;KANGXI RADICAL FLY;So;0;ON;<compat> 98DB;;;;N;;;;;
2FB7;KANGXI RADICAL EAT;So;0;ON;<compat> 98DF;;;;N;;;;;
2FB8;KANGXI RADICAL HEAD;So;0;ON;<compat> 9996;;;;N;;;;;
2FB9;KANGXI RADICAL FRAGRANT;So;0;ON;<compat> 9999;;;;N;;;;;
2FBA;KANGXI RADICAL HORSE;So;0;ON;<compat> 99AC;;;;N;;;;;
2FBB;KANGXI RADICAL BONE;So;0;ON;<compat> 9AA8;;;;N;;;;;
2FBC;KANGXI RADICAL TALL;So;0;ON;<compat> 9AD8;;;;N;;;;;
2FBD;KANGXI RADICAL HAIR;So;0;ON;<compat> 9ADF;;;;N;;;;;
2FBE;KANGXI RADICAL FIGHT;So;0;ON;<compat> 9B25;;;;N;;;;;
2FBF;KANGXI RADICAL SACRIFICIAL WINE;So;0;ON;<compat> 9B2F;;;;N;;;;;
2FC0;KANGXI RADICAL CAULDRON;So;0;ON;<compat> 9B32;;;;N;;;;;
2FC1;KANGXI RADICAL GHOST;So;0;ON;<compat> 9B3C;;;;N;;;;;
2FC2;KANGXI RADICAL FISH;So;0;ON;<compat> 9B5A;;;;N;;;;;
2FC3;KANGXI RADICAL BIRD;So;0;ON;<compat> 9CE5;;;;N;;;;;
2FC4;KANGXI RADICAL SALT;So;0;ON;<compat> 9E75;;;;N;;;;;
2FC5;KANGXI RADICAL DEER;So;0;ON;<compat> 9E7F;;;;N;;;;;
2FC6;KANGXI RADICAL WHEAT;So;0;ON;<compat> 9EA5;;;;N;;;;;
2FC7;KANGXI RADICAL HEMP;So;0;ON;<compat> 9EBB;;;;N;;;;;
2FC8;KANGXI RADICAL YELLOW;So;0;ON;<compat> 9EC3;;;;N;;;;;
2FC9;KANGXI RADICAL MILLET;So;0;ON;<compat> 9ECD;;;;N;;;;;
2FCA;KANGXI RADICAL BLACK;So;0;ON;<compat> 9ED1;;;;N;;;;;
2FCB;KANGXI RADICAL EMBROIDERY;So;0;ON;<compat> 9EF9;;;;N;;;;;
2FCC;KANGXI RADICAL FROG;So;0;ON;<compat> 9EFD;;;;N;;;;;
2FCD;KANGXI RADICAL TRIPOD;So;0;ON;<compat> 9F0E;;;;N;;;;;
2FCE;KANGXI RADICAL DRUM;So;0;ON;<compat> 9F13;;;;N;;;;;
2FCF;KANGXI RADICAL RAT;So;0;ON;<compat> 9F20;;;;N;;;;;
2FD0;KANGXI RADICAL NOSE;So;0;ON;<compat> 9F3B;;;;N;;;;;
2FD1;KANGXI RADICAL EVEN;So;0;ON;<compat> 9F4A;;;;N;;;;;
2FD2;KANGXI RADICAL TOOTH;So;0;ON;<compat> 9F52;;;;N;;;;;
2FD3;KANGXI RADICAL DRAGON;So;0;ON;<compat> 9F8D;;;;N;;;;;
2FD4;KANGXI RADICAL TURTLE;So;0;ON;<compat> 9F9C;;;;N;;;;;
2FD5;KANGXI RADICAL FLUTE;So;0;ON;<compat> 9FA0;;;;N;;;;;
2FF0;IDEOGRAPHIC DESCRIPTION CHARACTER LEFT TO RIGHT;So;0;ON;;;;;N;;;;;
2FF1;IDEOGRAPHIC DESCRIPTION CHARACTER ABOVE TO BELOW;So;0;ON;;;;;N;;;;;
2FF2;IDEOGRAPHIC DESCRIPTION CHARACTER LEFT TO MIDDLE AND RIGHT;So;0;ON;;;;;N;;;;;
2FF3;IDEOGRAPHIC DESCRIPTION CHARACTER ABOVE TO MIDDLE AND BELOW;So;0;ON;;;;;N;;;;;
2FF4;IDEOGRAPHIC DESCRIPTION CHARACTER FULL SURROUND;So;0;ON;;;;;N;;;;;
2FF5;IDEOGRAPHIC DESCRIPTION CHARACTER SURROUND FROM ABOVE;So;0;ON;;;;;N;;;;;
2FF6;IDEOGRAPHIC DESCRIPTION CHARACTER SURROUND FROM BELOW;So;0;ON;;;;;N;;;;;
2FF7;IDEOGRAPHIC DESCRIPTION CHARACTER SURROUND FROM LEFT;So;0;ON;;;;;N;;;;;
2FF8;IDEOGRAPHIC DESCRIPTION CHARACTER SURROUND FROM UPPER LEFT;So;0;ON;;;;;N;;;;;
2FF9;IDEOGRAPHIC DESCRIPTION CHARACTER SURROUND FROM UPPER RIGHT;So;0;ON;;;;;N;;;;;
2FFA;IDEOGRAPHIC DESCRIPTION CHARACTER SURROUND FROM LOWER LEFT;So;0;ON;;;;;N;;;;;
2FFB;IDEOGRAPHIC DESCRIPTION CHARACTER OVERLAID;So;0;ON;;;;;N;;;;;
3000;IDEOGRAPHIC SPACE;Zs;0;WS;<wide> 0020;;;;N;;;;;
3001;IDEOGRAPHIC COMMA;Po;0;ON;;;;;N;;;;;
3002;IDEOGRAPHIC FULL STOP;Po;0;ON;;;;;N;IDEOGRAPHIC PERIOD;;;;
3003;DITTO MARK;Po;0;ON;;;;;N;;;;;
3004;JAPANESE INDUSTRIAL STANDARD SYMBOL;So;0;ON;;;;;N;;;;;
3005;IDEOGRAPHIC ITERATION MARK;Lm;0;L;;;;;N;;;;;
3006;IDEOGRAPHIC CLOSING MARK;Lo;0;L;;;;;N;;;;;
3007;IDEOGRAPHIC NUMBER ZERO;Nl;0;L;;;;0;N;;;;;
3008;LEFT ANGLE BRACKET;Ps;0;ON;;;;;Y;OPENING ANGLE BRACKET;;;;
3009;RIGHT ANGLE BRACKET;Pe;0;ON;;;;;Y;CLOSING ANGLE BRACKET;;;;
300A;LEFT DOUBLE ANGLE BRACKET;Ps;0;ON;;;;;Y;OPENING DOUBLE ANGLE BRACKET;;;;
300B;RIGHT DOUBLE ANGLE BRACKET;Pe;0;ON;;;;;Y;CLOSING DOUBLE ANGLE BRACKET;;;;
300C;LEFT CORNER BRACKET;Ps;0;ON;;;;;Y;OPENING CORNER BRACKET;;;;
300D;RIGHT CORNER BRACKET;Pe;0;ON;;;;;Y;CLOSING CORNER BRACKET;;;;
300E;LEFT WHITE CORNER BRACKET;Ps;0;ON;;;;;Y;OPENING WHITE CORNER BRACKET;;;;
300F;RIGHT WHITE CORNER BRACKET;Pe;0;ON;;;;;Y;CLOSING WHITE CORNER BRACKET;;;;
3010;LEFT BLACK LENTICULAR BRACKET;Ps;0;ON;;;;;Y;OPENING BLACK LENTICULAR BRACKET;;;;
3011;RIGHT BLACK LENTICULAR BRACKET;Pe;0;ON;;;;;Y;CLOSING BLACK LENTICULAR BRACKET;;;;
3012;POSTAL MARK;So;0;ON;;;;;N;;;;;
3013;GETA MARK;So;0;ON;;;;;N;;;;;
3014;LEFT TORTOISE SHELL BRACKET;Ps;0;ON;;;;;Y;OPENING TORTOISE SHELL BRACKET;;;;
3015;RIGHT TORTOISE SHELL BRACKET;Pe;0;ON;;;;;Y;CLOSING TORTOISE SHELL BRACKET;;;;
3016;LEFT WHITE LENTICULAR BRACKET;Ps;0;ON;;;;;Y;OPENING WHITE LENTICULAR BRACKET;;;;
3017;RIGHT WHITE LENTICULAR BRACKET;Pe;0;ON;;;;;Y;CLOSING WHITE LENTICULAR BRACKET;;;;
3018;LEFT WHITE TORTOISE SHELL BRACKET;Ps;0;ON;;;;;Y;OPENING WHITE TORTOISE SHELL BRACKET;;;;
3019;RIGHT WHITE TORTOISE SHELL BRACKET;Pe;0;ON;;;;;Y;CLOSING WHITE TORTOISE SHELL BRACKET;;;;
301A;LEFT WHITE SQUARE BRACKET;Ps;0;ON;;;;;Y;OPENING WHITE SQUARE BRACKET;;;;
301B;RIGHT WHITE SQUARE BRACKET;Pe;0;ON;;;;;Y;CLOSING WHITE SQUARE BRACKET;;;;
301C;WAVE DASH;Pd;0;ON;;;;;N;;;;;
301D;REVERSED DOUBLE PRIME QUOTATION MARK;Ps;0;ON;;;;;N;;;;;
301E;DOUBLE PRIME QUOTATION MARK;Pe;0;ON;;;;;N;;;;;
301F;LOW DOUBLE PRIME QUOTATION MARK;Pe;0;ON;;;;;N;;;;;
3020;POSTAL MARK FACE;So;0;ON;;;;;N;;;;;
3021;HANGZHOU NUMERAL ONE;Nl;0;L;;;;1;N;;;;;
3022;HANGZHOU NUMERAL TWO;Nl;0;L;;;;2;N;;;;;
3023;HANGZHOU NUMERAL THREE;Nl;0;L;;;;3;N;;;;;
3024;HANGZHOU NUMERAL FOUR;Nl;0;L;;;;4;N;;;;;
3025;HANGZHOU NUMERAL FIVE;Nl;0;L;;;;5;N;;;;;
3026;HANGZHOU NUMERAL SIX;Nl;0;L;;;;6;N;;;;;
3027;HANGZHOU NUMERAL SEVEN;Nl;0;L;;;;7;N;;;;;
3028;HANGZHOU NUMERAL EIGHT;Nl;0;L;;;;8;N;;;;;
3029;HANGZHOU NUMERAL NINE;Nl;0;L;;;;9;N;;;;;
302A;IDEOGRAPHIC LEVEL TONE MARK;Mn;218;NSM;;;;;N;;;;;
302B;IDEOGRAPHIC RISING TONE MARK;Mn;228;NSM;;;;;N;;;;;
302C;IDEOGRAPHIC DEPARTING TONE MARK;Mn;232;NSM;;;;;N;;;;;
302D;IDEOGRAPHIC ENTERING TONE MARK;Mn;222;NSM;;;;;N;;;;;
302E;HANGUL SINGLE DOT TONE MARK;Mc;224;L;;;;;N;;;;;
302F;HANGUL DOUBLE DOT TONE MARK;Mc;224;L;;;;;N;;;;;
3030;WAVY DASH;Pd;0;ON;;;;;N;;;;;
3031;VERTICAL KANA REPEAT MARK;Lm;0;L;;;;;N;;;;;
3032;VERTICAL KANA REPEAT WITH VOICED SOUND MARK;Lm;0;L;;;;;N;;;;;
3033;VERTICAL KANA REPEAT MARK UPPER HALF;Lm;0;L;;;;;N;;;;;
3034;VERTICAL KANA REPEAT WITH VOICED SOUND MARK UPPER HALF;Lm;0;L;;;;;N;;;;;
3035;VERTICAL KANA REPEAT MARK LOWER HALF;Lm;0;L;;;;;N;;;;;
3036;CIRCLED POSTAL MARK;So;0;ON;<compat> 3012;;;;N;;;;;
3037;IDEOGRAPHIC TELEGRAPH LINE FEED SEPARATOR SYMBOL;So;0;ON;;;;;N;;;;;
3038;HANGZHOU NUMERAL TEN;Nl;0;L;<compat> 5341;;;10;N;;;;;
3039;HANGZHOU NUMERAL TWENTY;Nl;0;L;<compat> 5344;;;20;N;;;;;
303A;HANGZHOU NUMERAL THIRTY;Nl;0;L;<compat> 5345;;;30;N;;;;;
303B;VERTICAL IDEOGRAPHIC ITERATION MARK;Lm;0;L;;;;;N;;;;;
303C;MASU MARK;Lo;0;L;;;;;N;;;;;
303D;PART ALTERNATION MARK;Po;0;ON;;;;;N;;;;;
303E;IDEOGRAPHIC VARIATION INDICATOR;So;0;ON;;;;;N;;;;;
303F;IDEOGRAPHIC HALF FILL SPACE;So;0;ON;;;;;N;;;;;
3041;HIRAGANA LETTER SMALL A;Lo;0;L;;;;;N;;;;;
3042;HIRAGANA LETTER A;Lo;0;L;;;;;N;;;;;
3043;HIRAGANA LETTER SMALL I;Lo;0;L;;;;;N;;;;;
3044;HIRAGANA LETTER I;Lo;0;L;;;;;N;;;;;
3045;HIRAGANA LETTER SMALL U;Lo;0;L;;;;;N;;;;;
3046;HIRAGANA LETTER U;Lo;0;L;;;;;N;;;;;
3047;HIRAGANA LETTER SMALL E;Lo;0;L;;;;;N;;;;;
3048;HIRAGANA LETTER E;Lo;0;L;;;;;N;;;;;
3049;HIRAGANA LETTER SMALL O;Lo;0;L;;;;;N;;;;;
304A;HIRAGANA LETTER O;Lo;0;L;;;;;N;;;;;
304B;HIRAGANA LETTER KA;Lo;0;L;;;;;N;;;;;
304C;HIRAGANA LETTER GA;Lo;0;L;304B 3099;;;;N;;;;;
304D;HIRAGANA LETTER KI;Lo;0;L;;;;;N;;;;;
304E;HIRAGANA LETTER GI;Lo;0;L;304D 3099;;;;N;;;;;
304F;HIRAGANA LETTER KU;Lo;0;L;;;;;N;;;;;
3050;HIRAGANA LETTER GU;Lo;0;L;304F 3099;;;;N;;;;;
3051;HIRAGANA LETTER KE;Lo;0;L;;;;;N;;;;;
3052;HIRAGANA LETTER GE;Lo;0;L;3051 3099;;;;N;;;;;
3053;HIRAGANA LETTER KO;Lo;0;L;;;;;N;;;;;
3054;HIRAGANA LETTER GO;Lo;0;L;3053 3099;;;;N;;;;;
3055;HIRAGANA LETTER SA;Lo;0;L;;;;;N;;;;;
3056;HIRAGANA LETTER ZA;Lo;0;L;3055 3099;;;;N;;;;;
3057;HIRAGANA LETTER SI;Lo;0;L;;;;;N;;;;;
3058;HIRAGANA LETTER ZI;Lo;0;L;3057 3099;;;;N;;;;;
3059;HIRAGANA LETTER SU;Lo;0;L;;;;;N;;;;;
305A;HIRAGANA LETTER ZU;Lo;0;L;3059 3099;;;;N;;;;;
305B;HIRAGANA LETTER SE;Lo;0;L;;;;;N;;;;;
305C;HIRAGANA LETTER ZE;Lo;0;L;305B 3099;;;;N;;;;;
305D;HIRAGANA LETTER SO;Lo;0;L;;;;;N;;;;;
305E;HIRAGANA LETTER ZO;Lo;0;L;305D 3099;;;;N;;;;;
305F;HIRAGANA LETTER TA;Lo;0;L;;;;;N;;;;;
3060;HIRAGANA LETTER DA;Lo;0;L;305F 3099;;;;N;;;;;
3061;HIRAGANA LETTER TI;Lo;0;L;;;;;N;;;;;
3062;HIRAGANA LETTER DI;Lo;0;L;3061 3099;;;;N;;;;;
3063;HIRAGANA LETTER SMALL TU;Lo;0;L;;;;;N;;;;;
3064;HIRAGANA LETTER TU;Lo;0;L;;;;;N;;;;;
3065;HIRAGANA LETTER DU;Lo;0;L;3064 3099;;;;N;;;;;
3066;HIRAGANA LETTER TE;Lo;0;L;;;;;N;;;;;
3067;HIRAGANA LETTER DE;Lo;0;L;3066 3099;;;;N;;;;;
3068;HIRAGANA LETTER TO;Lo;0;L;;;;;N;;;;;
3069;HIRAGANA LETTER DO;Lo;0;L;3068 3099;;;;N;;;;;
306A;HIRAGANA LETTER NA;Lo;0;L;;;;;N;;;;;
306B;HIRAGANA LETTER NI;Lo;0;L;;;;;N;;;;;
306C;HIRAGANA LETTER NU;Lo;0;L;;;;;N;;;;;
306D;HIRAGANA LETTER NE;Lo;0;L;;;;;N;;;;;
306E;HIRAGANA LETTER NO;Lo;0;L;;;;;N;;;;;
306F;HIRAGANA LETTER HA;Lo;0;L;;;;;N;;;;;
3070;HIRAGANA LETTER BA;Lo;0;L;306F 3099;;;;N;;;;;
3071;HIRAGANA LETTER PA;Lo;0;L;306F 309A;;;;N;;;;;
3072;HIRAGANA LETTER HI;Lo;0;L;;;;;N;;;;;
3073;HIRAGANA LETTER BI;Lo;0;L;3072 3099;;;;N;;;;;
3074;HIRAGANA LETTER PI;Lo;0;L;3072 309A;;;;N;;;;;
3075;HIRAGANA LETTER HU;Lo;0;L;;;;;N;;;;;
3076;HIRAGANA LETTER BU;Lo;0;L;3075 3099;;;;N;;;;;
3077;HIRAGANA LETTER PU;Lo;0;L;3075 309A;;;;N;;;;;
3078;HIRAGANA LETTER HE;Lo;0;L;;;;;N;;;;;
3079;HIRAGANA LETTER BE;Lo;0;L;3078 3099;;;;N;;;;;
307A;HIRAGANA LETTER PE;Lo;0;L;3078 309A;;;;N;;;;;
307B;HIRAGANA LETTER HO;Lo;0;L;;;;;N;;;;;
307C;HIRAGANA LETTER BO;Lo;0;L;307B 3099;;;;N;;;;;
307D;HIRAGANA LETTER PO;Lo;0;L;307B 309A;;;;N;;;;;
307E;HIRAGANA LETTER MA;Lo;0;L;;;;;N;;;;;
307F;HIRAGANA LETTER MI;Lo;0;L;;;;;N;;;;;
3080;HIRAGANA LETTER MU;Lo;0;L;;;;;N;;;;;
3081;HIRAGANA LETTER ME;Lo;0;L;;;;;N;;;;;
3082;HIRAGANA LETTER MO;Lo;0;L;;;;;N;;;;;
3083;HIRAGANA LETTER SMALL YA;Lo;0;L;;;;;N;;;;;
3084;HIRAGANA LETTER YA;Lo;0;L;;;;;N;;;;;
3085;HIRAGANA LETTER SMALL YU;Lo;0;L;;;;;N;;;;;
3086;HIRAGANA LETTER YU;Lo;0;L;;;;;N;;;;;
3087;HIRAGANA LETTER SMALL YO;Lo;0;L;;;;;N;;;;;
3088;HIRAGANA LETTER YO;Lo;0;L;;;;;N;;;;;
3089;HIRAGANA LETTER RA;Lo;0;L;;;;;N;;;;;
308A;HIRAGANA LETTER RI;Lo;0;L;;;;;N;;;;;
308B;HIRAGANA LETTER RU;Lo;0;L;;;;;N;;;;;
308C;HIRAGANA LETTER RE;Lo;0;L;;;;;N;;;;;
308D;HIRAGANA LETTER RO;Lo;0;L;;;;;N;;;;;
308E;HIRAGANA LETTER SMALL WA;Lo;0;L;;;;;N;;;;;
308F;HIRAGANA LETTER WA;Lo;0;L;;;;;N;;;;;
3090;HIRAGANA LETTER WI;Lo;0;L;;;;;N;;;;;
3091;HIRAGANA LETTER WE;Lo;0;L;;;;;N;;;;;
3092;HIRAGANA LETTER WO;Lo;0;L;;;;;N;;;;;
3093;HIRAGANA LETTER N;Lo;0;L;;;;;N;;;;;
3094;HIRAGANA LETTER VU;Lo;0;L;3046 3099;;;;N;;;;;
3095;HIRAGANA LETTER SMALL KA;Lo;0;L;;;;;N;;;;;
3096;HIRAGANA LETTER SMALL KE;Lo;0;L;;;;;N;;;;;
3099;COMBINING KATAKANA-HIRAGANA VOICED SOUND MARK;Mn;8;NSM;;;;;N;NON-SPACING KATAKANA-HIRAGANA VOICED SOUND MARK;;;;
309A;COMBINING KATAKANA-HIRAGANA SEMI-VOICED SOUND MARK;Mn;8;NSM;;;;;N;NON-SPACING KATAKANA-HIRAGANA SEMI-VOICED SOUND MARK;;;;
309B;KATAKANA-HIRAGANA VOICED SOUND MARK;Sk;0;ON;<compat> 0020 3099;;;;N;;;;;
309C;KATAKANA-HIRAGANA SEMI-VOICED SOUND MARK;Sk;0;ON;<compat> 0020 309A;;;;N;;;;;
309D;HIRAGANA ITERATION MARK;Lm;0;L;;;;;N;;;;;
309E;HIRAGANA VOICED ITERATION MARK;Lm;0;L;309D 3099;;;;N;;;;;
309F;HIRAGANA DIGRAPH YORI;Lo;0;L;<vertical> 3088 308A;;;;N;;;;;
30A0;KATAKANA-HIRAGANA DOUBLE HYPHEN;Pd;0;ON;;;;;N;;;;;
30A1;KATAKANA LETTER SMALL A;Lo;0;L;;;;;N;;;;;
30A2;KATAKANA LETTER A;Lo;0;L;;;;;N;;;;;
30A3;KATAKANA LETTER SMALL I;Lo;0;L;;;;;N;;;;;
30A4;KATAKANA LETTER I;Lo;0;L;;;;;N;;;;;
30A5;KATAKANA LETTER SMALL U;Lo;0;L;;;;;N;;;;;
30A6;KATAKANA LETTER U;Lo;0;L;;;;;N;;;;;
30A7;KATAKANA LETTER SMALL E;Lo;0;L;;;;;N;;;;;
30A8;KATAKANA LETTER E;Lo;0;L;;;;;N;;;;;
30A9;KATAKANA LETTER SMALL O;Lo;0;L;;;;;N;;;;;
30AA;KATAKANA LETTER O;Lo;0;L;;;;;N;;;;;
30AB;KATAKANA LETTER KA;Lo;0;L;;;;;N;;;;;
30AC;KATAKANA LETTER GA;Lo;0;L;30AB 3099;;;;N;;;;;
30AD;KATAKANA LETTER KI;Lo;0;L;;;;;N;;;;;
30AE;KATAKANA LETTER GI;Lo;0;L;30AD 3099;;;;N;;;;;
30AF;KATAKANA LETTER KU;Lo;0;L;;;;;N;;;;;
30B0;KATAKANA LETTER GU;Lo;0;L;30AF 3099;;;;N;;;;;
30B1;KATAKANA LETTER KE;Lo;0;L;;;;;N;;;;;
30B2;KATAKANA LETTER GE;Lo;0;L;30B1 3099;;;;N;;;;;
30B3;KATAKANA LETTER KO;Lo;0;L;;;;;N;;;;;
30B4;KATAKANA LETTER GO;Lo;0;L;30B3 3099;;;;N;;;;;
30B5;KATAKANA LETTER SA;Lo;0;L;;;;;N;;;;;
30B6;KATAKANA LETTER ZA;Lo;0;L;30B5 3099;;;;N;;;;;
30B7;KATAKANA LETTER SI;Lo;0;L;;;;;N;;;;;
30B8;KATAKANA LETTER ZI;Lo;0;L;30B7 3099;;;;N;;;;;
30B9;KATAKANA LETTER SU;Lo;0;L;;;;;N;;;;;
30BA;KATAKANA LETTER ZU;Lo;0;L;30B9 3099;;;;N;;;;;
30BB;KATAKANA LETTER SE;Lo;0;L;;;;;N;;;;;
30BC;KATAKANA LETTER ZE;Lo;0;L;30BB 3099;;;;N;;;;;
30BD;KATAKANA LETTER SO;Lo;0;L;;;;;N;;;;;
30BE;KATAKANA LETTER ZO;Lo;0;L;30BD 3099;;;;N;;;;;
30BF;KATAKANA LETTER TA;Lo;0;L;;;;;N;;;;;
30C0;KATAKANA LETTER DA;Lo;0;L;30BF 3099;;;;N;;;;;
30C1;KATAKANA LETTER TI;Lo;0;L;;;;;N;;;;;
30C2;KATAKANA LETTER DI;Lo;0;L;30C1 3099;;;;N;;;;;
30C3;KATAKANA LETTER SMALL TU;Lo;0;L;;;;;N;;;;;
30C4;KATAKANA LETTER TU;Lo;0;L;;;;;N;;;;;
30C5;KATAKANA LETTER DU;Lo;0;L;30C4 3099;;;;N;;;;;
30C6;KATAKANA LETTER TE;Lo;0;L;;;;;N;;;;;
30C7;KATAKANA LETTER DE;Lo;0;L;30C6 3099;;;;N;;;;;
30C8;KATAKANA LETTER TO;Lo;0;L;;;;;N;;;;;
30C9;KATAKANA LETTER DO;Lo;0;L;30C8 3099;;;;N;;;;;
30CA;KATAKANA LETTER NA;Lo;0;L;;;;;N;;;;;
30CB;KATAKANA LETTER NI;Lo;0;L;;;;;N;;;;;
30CC;KATAKANA LETTER NU;Lo;0;L;;;;;N;;;;;
30CD;KATAKANA LETTER NE;Lo;0;L;;;;;N;;;;;
30CE;KATAKANA LETTER NO;Lo;0;L;;;;;N;;;;;
30CF;KATAKANA LETTER HA;Lo;0;L;;;;;N;;;;;
30D0;KATAKANA LETTER BA;Lo;0;L;30CF 3099;;;;N;;;;;
30D1;KATAKANA LETTER PA;Lo;0;L;30CF 309A;;;;N;;;;;
30D2;KATAKANA LETTER HI;Lo;0;L;;;;;N;;;;;
30D3;KATAKANA LETTER BI;Lo;0;L;30D2 3099;;;;N;;;;;
30D4;KATAKANA LETTER PI;Lo;0;L;30D2 309A;;;;N;;;;;
30D5;KATAKANA LETTER HU;Lo;0;L;;;;;N;;;;;
30D6;KATAKANA LETTER BU;Lo;0;L;30D5 3099;;;;N;;;;;
30D7;KATAKANA LETTER PU;Lo;0;L;30D5 309A;;;;N;;;;;
30D8;KATAKANA LETTER HE;Lo;0;L;;;;;N;;;;;
30D9;KATAKANA LETTER BE;Lo;0;L;30D8 3099;;;;N;;;;;
30DA;KATAKANA LETTER PE;Lo;0;L;30D8 309A;;;;N;;;;;
30DB;KATAKANA LETTER HO;Lo;0;L;;;;;N;;;;;
30DC;KATAKANA LETTER BO;Lo;0;L;30DB 3099;;;;N;;;;;
30DD;KATAKANA LETTER PO;Lo;0;L;30DB 309A;;;;N;;;;;
30DE;KATAKANA LETTER MA;Lo;0;L;;;;;N;;;;;
30DF;KATAKANA LETTER MI;Lo;0;L;;;;;N;;;;;
30E0;KATAKANA LETTER MU;Lo;0;L;;;;;N;;;;;
30E1;KATAKANA LETTER ME;Lo;0;L;;;;;N;;;;;
30E2;KATAKANA LETTER MO;Lo;0;L;;;;;N;;;;;
30E3;KATAKANA LETTER SMALL YA;Lo;0;L;;;;;N;;;;;
30E4;KATAKANA LETTER YA;Lo;0;L;;;;;N;;;;;
30E5;KATAKANA LETTER SMALL YU;Lo;0;L;;;;;N;;;;;
30E6;KATAKANA LETTER YU;Lo;0;L;;;;;N;;;;;
30E7;KATAKANA LETTER SMALL YO;Lo;0;L;;;;;N;;;;;
30E8;KATAKANA LETTER YO;Lo;0;L;;;;;N;;;;;
30E9;KATAKANA LETTER RA;Lo;0;L;;;;;N;;;;;
30EA;KATAKANA LETTER RI;Lo;0;L;;;;;N;;;;;
30EB;KATAKANA LETTER RU;Lo;0;L;;;;;N;;;;;
30EC;KATAKANA LETTER RE;Lo;0;L;;;;;N;;;;;
30ED;KATAKANA LETTER RO;Lo;0;L;;;;;N;;;;;
30EE;KATAKANA LETTER SMALL WA;Lo;0;L;;;;;N;;;;;
30EF;KATAKANA LETTER WA;Lo;0;L;;;;;N;;;;;
30F0;KATAKANA LETTER WI;Lo;0;L;;;;;N;;;;;
30F1;KATAKANA LETTER WE;Lo;0;L;;;;;N;;;;;
30F2;KATAKANA LETTER WO;Lo;0;L;;;;;N;;;;;
30F3;KATAKANA LETTER N;Lo;0;L;;;;;N;;;;;
30F4;KATAKANA LETTER VU;Lo;0;L;30A6 3099;;;;N;;;;;
30F5;KATAKANA LETTER SMALL KA;Lo;0;L;;;;;N;;;;;
30F6;KATAKANA LETTER SMALL KE;Lo;0;L;;;;;N;;;;;
30F7;KATAKANA LETTER VA;Lo;0;L;30EF 3099;;;;N;;;;;
30F8;KATAKANA LETTER VI;Lo;0;L;30F0 3099;;;;N;;;;;
30F9;KATAKANA LETTER VE;Lo;0;L;30F1 3099;;;;N;;;;;
30FA;KATAKANA LETTER VO;Lo;0;L;30F2 3099;;;;N;;;;;
30FB;KATAKANA MIDDLE DOT;Po;0;ON;;;;;N;;;;;
30FC;KATAKANA-HIRAGANA PROLONGED SOUND MARK;Lm;0;L;;;;;N;;;;;
30FD;KATAKANA ITERATION MARK;Lm;0;L;;;;;N;;;;;
30FE;KATAKANA VOICED ITERATION MARK;Lm;0;L;30FD 3099;;;;N;;;;;
30FF;KATAKANA DIGRAPH KOTO;Lo;0;L;<vertical> 30B3 30C8;;;;N;;;;;
3105;BOPOMOFO LETTER B;Lo;0;L;;;;;N;;;;;
3106;BOPOMOFO LETTER P;Lo;0;L;;;;;N;;;;;
3107;BOPOMOFO LETTER M;Lo;0;L;;;;;N;;;;;
3108;BOPOMOFO LETTER F;Lo;0;L;;;;;N;;;;;
3109;BOPOMOFO LETTER D;Lo;0;L;;;;;N;;;;;
310A;BOPOMOFO LETTER T;Lo;0;L;;;;;N;;;;;
310B;BOPOMOFO LETTER N;Lo;0;L;;;;;N;;;;;
310C;BOPOMOFO LETTER L;Lo;0;L;;;;;N;;;;;
310D;BOPOMOFO LETTER G;Lo;0;L;;;;;N;;;;;
310E;BOPOMOFO LETTER K;Lo;0;L;;;;;N;;;;;
310F;BOPOMOFO LETTER H;Lo;0;L;;;;;N;;;;;
3110;BOPOMOFO LETTER J;Lo;0;L;;;;;N;;;;;
3111;BOPOMOFO LETTER Q;Lo;0;L;;;;;N;;;;;
3112;BOPOMOFO LETTER X;Lo;0;L;;;;;N;;;;;
3113;BOPOMOFO LETTER ZH;Lo;0;L;;;;;N;;;;;
3114;BOPOMOFO LETTER CH;Lo;0;L;;;;;N;;;;;
3115;BOPOMOFO LETTER SH;Lo;0;L;;;;;N;;;;;
3116;BOPOMOFO LETTER R;Lo;0;L;;;;;N;;;;;
3117;BOPOMOFO LETTER Z;Lo;0;L;;;;;N;;;;;
3118;BOPOMOFO LETTER C;Lo;0;L;;;;;N;;;;;
3119;BOPOMOFO LETTER S;Lo;0;L;;;;;N;;;;;
311A;BOPOMOFO LETTER A;Lo;0;L;;;;;N;;;;;
311B;BOPOMOFO LETTER O;Lo;0;L;;;;;N;;;;;
311C;BOPOMOFO LETTER E;Lo;0;L;;;;;N;;;;;
311D;BOPOMOFO LETTER EH;Lo;0;L;;;;;N;;;;;
311E;BOPOMOFO LETTER AI;Lo;0;L;;;;;N;;;;;
311F;BOPOMOFO LETTER EI;Lo;0;L;;;;;N;;;;;
3120;BOPOMOFO LETTER AU;Lo;0;L;;;;;N;;;;;
3121;BOPOMOFO LETTER OU;Lo;0;L;;;;;N;;;;;
3122;BOPOMOFO LETTER AN;Lo;0;L;;;;;N;;;;;
3123;BOPOMOFO LETTER EN;Lo;0;L;;;;;N;;;;;
3124;BOPOMOFO LETTER ANG;Lo;0;L;;;;;N;;;;;
3125;BOPOMOFO LETTER ENG;Lo;0;L;;;;;N;;;;;
3126;BOPOMOFO LETTER ER;Lo;0;L;;;;;N;;;;;
3127;BOPOMOFO LETTER I;Lo;0;L;;;;;N;;;;;
3128;BOPOMOFO LETTER U;Lo;0;L;;;;;N;;;;;
3129;BOPOMOFO LETTER IU;Lo;0;L;;;;;N;;;;;
312A;BOPOMOFO LETTER V;Lo;0;L;;;;;N;;;;;
312B;BOPOMOFO LETTER NG;Lo;0;L;;;;;N;;;;;
312C;BOPOMOFO LETTER GN;Lo;0;L;;;;;N;;;;;
312D;BOPOMOFO LETTER IH;Lo;0;L;;;;;N;;;;;
312E;BOPOMOFO LETTER O WITH DOT ABOVE;Lo;0;L;;;;;N;;;;;
312F;BOPOMOFO LETTER NN;Lo;0;L;;;;;N;;;;;
3131;HANGUL LETTER KIYEOK;Lo;0;L;<compat> 1100;;;;N;HANGUL LETTER GIYEOG;;;;
3132;HANGUL LETTER SSANGKIYEOK;Lo;0;L;<compat> 1101;;;;N;HANGUL LETTER SSANG GIYEOG;;;;
3133;HANGUL LETTER KIYEOK-SIOS;Lo;0;L;<compat> 11AA;;;;N;HANGUL LETTER GIYEOG SIOS;;;;
3134;HANGUL LETTER NIEUN;Lo;0;L;<compat> 1102;;;;N;;;;;
3135;HANGUL LETTER NIEUN-CIEUC;Lo;0;L;<compat> 11AC;;;;N;HANGUL LETTER NIEUN JIEUJ;;;;
3136;HANGUL LETTER NIEUN-HIEUH;Lo;0;L;<compat> 11AD;;;;N;HANGUL LETTER NIEUN HIEUH;;;;
3137;HANGUL LETTER TIKEUT;Lo;0;L;<compat> 1103;;;;N;HANGUL LETTER DIGEUD;;;;
3138;HANGUL LETTER SSANGTIKEUT;Lo;0;L;<compat> 1104;;;;N;HANGUL LETTER SSANG DIGEUD;;;;
3139;HANGUL LETTER RIEUL;Lo;0;L;<compat> 1105;;;;N;HANGUL LETTER LIEUL;;;;
313A;HANGUL LETTER RIEUL-KIYEOK;Lo;0;L;<compat> 11B0;;;;N;HANGUL LETTER LIEUL GIYEOG;;;;
313B;HANGUL LETTER RIEUL-MIEUM;Lo;0;L;<compat> 11B1;;;;N;HANGUL LETTER LIEUL MIEUM;;;;
313C;HANGUL LETTER RIEUL-PIEUP;Lo;0;L;<compat> 11B2;;;;N;HANGUL LETTER LIEUL BIEUB;;;;
313D;HANGUL LETTER RIEUL-SIOS;Lo;0;L;<compat> 11B3;;;;N;HANGUL LETTER LIEUL SIOS;;;;
313E;HANGUL LETTER RIEUL-THIEUTH;Lo;0;L;<compat> 11B4;;;;N;HANGUL LETTER LIEUL TIEUT;;;;
313F;HANGUL LETTER RIEUL-PHIEUPH;Lo;0;L;<compat> 11B5;;;;N;HANGUL LETTER LIEUL PIEUP;;;;
3140;HANGUL LETTER RIEUL-HIEUH;Lo;0;L;<compat> 111A;;;;N;HANGUL LETTER LIEUL HIEUH;;;;
3141;HANGUL LETTER MIEUM;Lo;0;L;<compat> 1106;;;;N;;;;;
3142;HANGUL LETTER PIEUP;Lo;0;L;<compat> 1107;;;;N;HANGUL LETTER BIEUB;;;;
3143;HANGUL LETTER SSANGPIEUP;Lo;0;L;<compat> 1108;;;;N;HANGUL LETTER SSANG BIEUB;;;;
3144;HANGUL LETTER PIEUP-SIOS;Lo;0;L;<compat> 1121;;;;N;HANGUL LETTER BIEUB SIOS;;;;
3145;HANGUL LETTER SIOS;Lo;0;L;<compat> 1109;;;;N;;;;;
3146;HANGUL LETTER SSANGSIOS;Lo;0;L;<compat> 110A;;;;N;HANGUL LETTER SSANG SIOS;;;;
3147;HANGUL LETTER IEUNG;Lo;0;L;<compat> 110B;;;;N;;;;;
3148;HANGUL LETTER CIEUC;Lo;0;L;<compat> 110C;;;;N;HANGUL LETTER JIEUJ;;;;
3149;HANGUL LETTER SSANGCIEUC;Lo;0;L;<compat> 110D;;;;N;HANGUL LETTER SSANG JIEUJ;;;;
314A;HANGUL LETTER CHIEUCH;Lo;0;L;<compat> 110E;;;;N;HANGUL LETTER CIEUC;;;;
314B;HANGUL LETTER KHIEUKH;Lo;0;L;<compat> 110F;;;;N;HANGUL LETTER KIYEOK;;;;
314C;HANGUL LETTER THIEUTH;Lo;0;L;<compat> 1110;;;;N;HANGUL LETTER TIEUT;;;;
314D;HANGUL LETTER PHIEUPH;Lo;0;L;<compat> 1111;;;;N;HANGUL LETTER PIEUP;;;;
314E;HANGUL LETTER HIEUH;Lo;0;L;<compat> 1112;;;;N;;;;;
314F;HANGUL LETTER A;Lo;0;L;<compat> 1161;;;;N;;;;;
3150;HANGUL LETTER AE;Lo;0;L;<compat> 1162;;;;N;;;;;
3151;HANGUL LETTER YA;Lo;0;L;<compat> 1163;;;;N;;;;;
3152;HANGUL LETTER YAE;Lo;0;L;<compat> 1164;;;;N;;;;;
3153;HANGUL LETTER EO;Lo;0;L;<compat> 1165;;;;N;;;;;
3154;HANGUL LETTER E;Lo;0;L;<compat> 1166;;;;N;;;;;
3155;HANGUL LETTER YEO;Lo;0;L;<compat> 1167;;;;N;;;;;
3156;HANGUL LETTER YE;Lo;0;L;<compat> 1168;;;;N;;;;;
3157;HANGUL LETTER O;Lo;0;L;<compat> 1169;;;;N;;;;;
3158;HANGUL LETTER WA;Lo;0;L;<compat> 116A;;;;N;;;;;
3159;HANGUL LETTER WAE;Lo;0;L;<compat> 116B;;;;N;;;;;
315A;HANGUL LETTER OE;Lo;0;L;<compat> 116C;;;;N;;;;;
315B;HANGUL LETTER YO;Lo;0;L;<compat> 116D;;;;N;;;;;
315C;HANGUL LETTER U;Lo;0;L;<compat> 116E;;;;N;;;;;
315D;HANGUL LETTER WEO;Lo;0;L;<compat> 116F;;;;N;;;;;
315E;HANGUL LETTER WE;Lo;0;L;<compat> 1170;;;;N;;;;;
315F;HANGUL LETTER WI;Lo;0;L;<compat> 1171;;;;N;;;;;
3160;HANGUL LETTER YU;Lo;0;L;<compat> 1172;;;;N;;;;;
3161;HANGUL LETTER EU;Lo;0;L;<compat> 1173;;;;N;;;;;
3162;HANGUL LETTER YI;Lo;0;L;<compat> 1174;;;;N;;;;;
3163;HANGUL LETTER I;Lo;0;L;<compat> 1175;;;;N;;;;;
3164;HANGUL FILLER;Lo;0;L;<compat> 1160;;;;N;HANGUL CAE OM;;;;
3165;HANGUL LETTER SSANGNIEUN;Lo;0;L;<compat> 1114;;;;N;HANGUL LETTER SSANG NIEUN;;;;
3166;HANGUL LETTER NIEUN-TIKEUT;Lo;0;L;<compat> 1115;;;;N;HANGUL LETTER NIEUN DIGEUD;;;;
3167;HANGUL LETTER NIEUN-SIOS;Lo;0;L;<compat> 11C7;;;;N;HANGUL LETTER NIEUN SIOS;;;;
3168;HANGUL LETTER NIEUN-PANSIOS;Lo;0;L;<compat> 11C8;;;;N;HANGUL LETTER NIEUN BAN CHI EUM;;;;
3169;HANGUL LETTER RIEUL-KIYEOK-SIOS;Lo;0;L;<compat> 11CC;;;;N;HANGUL LETTER LIEUL GIYEOG SIOS;;;;
316A;HANGUL LETTER RIEUL-TIKEUT;Lo;0;L;<compat> 11CE;;;;N;HANGUL LETTER LIEUL DIGEUD;;;;
316B;HANGUL LETTER RIEUL-PIEUP-SIOS;Lo;0;L;<compat> 11D3;;;;N;HANGUL LETTER LIEUL BIEUB SIOS;;;;
316C;HANGUL LETTER RIEUL-PANSIOS;Lo;0;L;<compat> 11D7;;;;N;HANGUL LETTER LIEUL BAN CHI EUM;;;;
316D;HANGUL LETTER RIEUL-YEORINHIEUH;Lo;0;L;<compat> 11D9;;;;N;HANGUL LETTER LIEUL YEOLIN HIEUH;;;;
316E;HANGUL LETTER MIEUM-PIEUP;Lo;0;L;<compat> 111C;;;;N;HANGUL LETTER MIEUM BIEUB;;;;
316F;HANGUL LETTER MIEUM-SIOS;Lo;0;L;<compat> 11DD;;;;N;HANGUL LETTER MIEUM SIOS;;;;
3170;HANGUL LETTER MIEUM-PANSIOS;Lo;0;L;<compat> 11DF;;;;N;HANGUL LETTER BIEUB BAN CHI EUM;;;;
3171;HANGUL LETTER KAPYEOUNMIEUM;Lo;0;L;<compat> 111D;;;;N;HANGUL LETTER MIEUM SUN GYEONG EUM;;;;
3172;HANGUL LETTER PIEUP-KIYEOK;Lo;0;L;<compat> 111E;;;;N;HANGUL LETTER BIEUB GIYEOG;;;;
3173;HANGUL LETTER PIEUP-TIKEUT;Lo;0;L;<compat> 1120;;;;N;HANGUL LETTER BIEUB DIGEUD;;;;
3174;HANGUL LETTER PIEUP-SIOS-KIYEOK;Lo;0;L;<compat> 1122;;;;N;HANGUL LETTER BIEUB SIOS GIYEOG;;;;
3175;HANGUL LETTER PIEUP-SIOS-TIKEUT;Lo;0;L;<compat> 1123;;;;N;HANGUL LETTER BIEUB SIOS DIGEUD;;;;
3176;HANGUL LETTER PIEUP-CIEUC;Lo;0;L;<compat> 1127;;;;N;HANGUL LETTER BIEUB JIEUJ;;;;
3177;HANGUL LETTER PIEUP-THIEUTH;Lo;0;L;<compat> 1129;;;;N;HANGUL LETTER BIEUB TIEUT;;;;
3178;HANGUL LETTER KAPYEOUNPIEUP;Lo;0;L;<compat> 112B;;;;N;HANGUL LETTER BIEUB SUN GYEONG EUM;;;;
3179;HANGUL LETTER KAPYEOUNSSANGPIEUP;Lo;0;L;<compat> 112C;;;;N;HANGUL LETTER SSANG BIEUB SUN GYEONG EUM;;;;
317A;HANGUL LETTER SIOS-KIYEOK;Lo;0;L;<compat> 112D;;;;N;HANGUL LETTER SIOS GIYEOG;;;;
317B;HANGUL LETTER SIOS-NIEUN;Lo;0;L;<compat> 112E;;;;N;HANGUL LETTER SIOS NIEUN;;;;
317C;HANGUL LETTER SIOS-TIKEUT;Lo;0;L;<compat> 112F;;;;N;HANGUL LETTER SIOS DIGEUD;;;;
317D;HANGUL LETTER SIOS-PIEUP;Lo;0;L;<compat> 1132;;;;N;HANGUL LETTER SIOS BIEUB;;;;
317E;HANGUL LETTER SIOS-CIEUC;Lo;0;L;<compat> 1136;;;;N;HANGUL LETTER SIOS JIEUJ;;;;
317F;HANGUL LETTER PANSIOS;Lo;0;L;<compat> 1140;;;;N;HANGUL LETTER BAN CHI EUM;;;;
3180;HANGUL LETTER SSANGIEUNG;Lo;0;L;<compat> 1147;;;;N;HANGUL LETTER SSANG IEUNG;;;;
3181;HANGUL LETTER YESIEUNG;Lo;0;L;<compat> 114C;;;;N;HANGUL LETTER NGIEUNG;;;;
3182;HANGUL LETTER YESIEUNG-SIOS;Lo;0;L;<compat> 11F1;;;;N;HANGUL LETTER NGIEUNG SIOS;;;;
3183;HANGUL LETTER YESIEUNG-PANSIOS;Lo;0;L;<compat> 11F2;;;;N;HANGUL LETTER NGIEUNG BAN CHI EUM;;;;
3184;HANGUL LETTER KAPYEOUNPHIEUPH;Lo;0;L;<compat> 1157;;;;N;HANGUL LETTER PIEUP SUN GYEONG EUM;;;;
3185;HANGUL LETTER SSANGHIEUH;Lo;0;L;<compat> 1158;;;;N;HANGUL LETTER SSANG HIEUH;;;;
3186;HANGUL LETTER YEORINHIEUH;Lo;0;L;<compat> 1159;;;;N;HANGUL LETTER YEOLIN HIEUH;;;;
3187;HANGUL LETTER YO-YA;Lo;0;L;<compat> 1184;;;;N;HANGUL LETTER YOYA;;;;
3188;HANGUL LETTER YO-YAE;Lo;0;L;<compat> 1185;;;;N;HANGUL LETTER YOYAE;;;;
3189;HANGUL LETTER YO-I;Lo;0;L;<compat> 1188;;;;N;HANGUL LETTER YOI;;;;
318A;HANGUL LETTER YU-YEO;Lo;0;L;<compat> 1191;;;;N;HANGUL LETTER YUYEO;;;;
318B;HANGUL LETTER YU-YE;Lo;0;L;<compat> 1192;;;;N;HANGUL LETTER YUYE;;;;
318C;HANGUL LETTER YU-I;Lo;0;L;<compat> 1194;;;;N;HANGUL LETTER YUI;;;;
318D;HANGUL LETTER ARAEA;Lo;0;L;<compat> 119E;;;;N;HANGUL LETTER ALAE A;;;;
318E;HANGUL LETTER ARAEAE;Lo;0;L;<compat> 11A1;;;;N;HANGUL LETTER ALAE AE;;;;
3190;IDEOGRAPHIC ANNOTATION LINKING MARK;So;0;L;;;;;N;KANBUN TATETEN;;;;
3191;IDEOGRAPHIC ANNOTATION REVERSE MARK;So;0;L;;;;;N;KAERITEN RE;;;;
3192;IDEOGRAPHIC ANNOTATION ONE MARK;No;0;L;<super> 4E00;;;1;N;KAERITEN ITI;;;;
3193;IDEOGRAPHIC ANNOTATION TWO MARK;No;0;L;<super> 4E8C;;;2;N;KAERITEN NI;;;;
3194;IDEOGRAPHIC ANNOTATION THREE MARK;No;0;L;<super> 4E09;;;3;N;KAERITEN SAN;;;;
3195;IDEOGRAPHIC ANNOTATION FOUR MARK;No;0;L;<super> 56DB;;;4;N;KAERITEN SI;;;;
3196;IDEOGRAPHIC ANNOTATION TOP MARK;So;0;L;<super> 4E0A;;;;N;KAERITEN ZYOU;;;;
3197;IDEOGRAPHIC ANNOTATION MIDDLE MARK;So;0;L;<super> 4E2D;;;;N;KAERITEN TYUU;;;;
3198;IDEOGRAPHIC ANNOTATION BOTTOM MARK;So;0;L;<super> 4E0B;;;;N;KAERITEN GE;;;;
3199;IDEOGRAPHIC ANNOTATION FIRST MARK;So;0;L;<super> 7532;;;;N;KAERITEN KOU;;;;
319A;IDEOGRAPHIC ANNOTATION SECOND MARK;So;0;L;<super> 4E59;;;;N;KAERITEN OTU;;;;
319B;IDEOGRAPHIC ANNOTATION THIRD MARK;So;0;L;<super> 4E19;;;;N;KAERITEN HEI;;;;
319C;IDEOGRAPHIC ANNOTATION FOURTH MARK;So;0;L;<super> 4E01;;;;N;KAERITEN TEI;;;;
319D;IDEOGRAPHIC ANNOTATION HEAVEN MARK;So;0;L;<super> 5929;;;;N;KAERITEN TEN;;;;
319E;IDEOGRAPHIC ANNOTATION EARTH MARK;So;0;L;<super> 5730;;;;N;KAERITEN TI;;;;
319F;IDEOGRAPHIC ANNOTATION MAN MARK;So;0;L;<super> 4EBA;;;;N;KAERITEN ZIN;;;;
31A0;BOPOMOFO LETTER BU;Lo;0;L;;;;;N;;;;;
31A1;BOPOMOFO LETTER ZI;Lo;0;L;;;;;N;;;;;
31A2;BOPOMOFO LETTER JI;Lo;0;L;;;;;N;;;;;
31A3;BOPOMOFO LETTER GU;Lo;0;L;;;;;N;;;;;
31A4;BOPOMOFO LETTER EE;Lo;0;L;;;;;N;;;;;
31A5;BOPOMOFO LETTER ENN;Lo;0;L;;;;;N;;;;;
31A6;BOPOMOFO LETTER OO;Lo;0;L;;;;;N;;;;;
31A7;BOPOMOFO LETTER ONN;Lo;0;L;;;;;N;;;;;
31A8;BOPOMOFO LETTER IR;Lo;0;L;;;;;N;;;;;
31A9;BOPOMOFO LETTER ANN;Lo;0;L;;;;;N;;;;;
31AA;BOPOMOFO LETTER INN;Lo;0;L;;;;;N;;;;;
31AB;BOPOMOFO LETTER UNN;Lo;0;L;;;;;N;;;;;
31AC;BOPOMOFO LETTER IM;Lo;0;L;;;;;N;;;;;
31AD;BOPOMOFO LETTER NGG;Lo;0;L;;;;;N;;;;;
31AE;BOPOMOFO LETTER AINN;Lo;0;L;;;;;N;;;;;
31AF;BOPOMOFO LETTER AUNN;Lo;0;L;;;;;N;;;;;
31B0;BOPOMOFO LETTER AM;Lo;0;L;;;;;N;;;;;
31B1;BOPOMOFO LETTER OM;Lo;0;L;;;;;N;;;;;
31B2;BOPOMOFO LETTER ONG;Lo;0;L;;;;;N;;;;;
31B3;BOPOMOFO LETTER INNN;Lo;0;L;;;;;N;;;;;
31B4;BOPOMOFO FINAL LETTER P;Lo;0;L;;;;;N;;;;;
31B5;BOPOMOFO FINAL LETTER T;Lo;0;L;;;;;N;;;;;
31B6;BOPOMOFO FINAL LETTER K;Lo;0;L;;;;;N;;;;;
31B7;BOPOMOFO FINAL LETTER H;Lo;0;L;;;;;N;;;;;
31B8;BOPOMOFO LETTER GH;Lo;0;L;;;;;N;;;;;
31B9;BOPOMOFO LETTER LH;Lo;0;L;;;;;N;;;;;
31BA;BOPOMOFO LETTER ZY;Lo;0;L;;;;;N;;;;;
31BB;BOPOMOFO FINAL LETTER G;Lo;0;L;;;;;N;;;;;
31BC;BOPOMOFO LETTER GW;Lo;0;L;;;;;N;;;;;
31BD;BOPOMOFO LETTER KW;Lo;0;L;;;;;N;;;;;
31BE;BOPOMOFO LETTER OE;Lo;0;L;;;;;N;;;;;
31BF;BOPOMOFO LETTER AH;Lo;0;L;;;;;N;;;;;
31C0;CJK STROKE T;So;0;ON;;;;;N;;;;;
31C1;CJK STROKE WG;So;0;ON;;;;;N;;;;;
31C2;CJK STROKE XG;So;0;ON;;;;;N;;;;;
31C3;CJK STROKE BXG;So;0;ON;;;;;N;;;;;
31C4;CJK STROKE SW;So;0;ON;;;;;N;;;;;
31C5;CJK STROKE HZZ;So;0;ON;;;;;N;;;;;
31C6;CJK STROKE HZG;So;0;ON;;;;;N;;;;;
31C7;CJK STROKE HP;So;0;ON;;;;;N;;;;;
31C8;CJK STROKE HZWG;So;0;ON;;;;;N;;;;;
31C9;CJK STROKE SZWG;So;0;ON;;;;;N;;;;;
31CA;CJK STROKE HZT;So;0;ON;;;;;N;;;;;
31CB;CJK STROKE HZZP;So;0;ON;;;;;N;;;;;
31CC;CJK STROKE HPWG;So;0;ON;;;;;N;;;;;
31CD;CJK STROKE HZW;So;0;ON;;;;;N;;;;;
31CE;CJK STROKE HZZZ;So;0;ON;;;;;N;;;;;
31CF;CJK STROKE N;So;0;ON;;;;;N;;;;;
31D0;CJK STROKE H;So;0;ON;;;;;N;;;;;
31D1;CJK STROKE S;So;0;ON;;;;;N;;;;;
31D2;CJK STROKE P;So;0;ON;;;;;N;;;;;
31D3;CJK STROKE SP;So;0;ON;;;;;N;;;;;
31D4;CJK STROKE D;So;0;ON;;;;;N;;;;;
31D5;CJK STROKE HZ;So;0;ON;;;;;N;;;;;
31D6;CJK STROKE HG;So;0;ON;;;;;N;;;;;
31D7;CJK STROKE SZ;So;0;ON;;;;;N;;;;;
31D8;CJK STROKE SWZ;So;0;ON;;;;;N;;;;;
31D9;CJK STROKE ST;So;0;ON;;;;;N;;;;;
31DA;CJK STROKE SG;So;0;ON;;;;;N;;;;;
31DB;CJK STROKE PD;So;0;ON;;;;;N;;;;;
31DC;CJK STROKE PZ;So;0;ON;;;;;N;;;;;
31DD;CJK STROKE TN;So;0;ON;;;;;N;;;;;
31DE;CJK STROKE SZZ;So;0;ON;;;;;N;;;;;
31DF;CJK STROKE SWG;So;0;ON;;;;;N;;;;;
31E0;CJK STROKE HXWG;So;0;ON;;;;;N;;;;;
31E1;CJK STROKE HZZZG;So;0;ON;;;;;N;;;;;
31E2;CJK STROKE PG;So;0;ON;;;;;N;;;;;
31E3;CJK STROKE Q;So;0;ON;;;;;N;;;;;
31F0;KATAKANA LETTER SMALL KU;Lo;0;L;;;;;N;;;;;
31F1;KATAKANA LETTER SMALL SI;Lo;0;L;;;;;N;;;;;
31F2;KATAKANA LETTER SMALL SU;Lo;0;L;;;;;N;;;;;
31F3;KATAKANA LETTER SMALL TO;Lo;0;L;;;;;N;;;;;
31F4;KATAKANA LETTER SMALL NU;Lo;0;L;;;;;N;;;;;
31F5;KATAKANA LETTER SMALL HA;Lo;0;L;;;;;N;;;;;
31F6;KATAKANA LETTER SMALL HI;Lo;0;L;;;;;N;;;;;
31F7;KATAKANA LETTER SMALL HU;Lo;0;L;;;;;N;;;;;
31F8;KATAKANA LETTER SMALL HE;Lo;0;L;;;;;N;;;;;
31F9;KATAKANA LETTER SMALL HO;Lo;0;L;;;;;N;;;;;
31FA;KATAKANA LETTER SMALL MU;Lo;0;L;;;;;N;;;;;
31FB;KATAKANA LETTER SMALL RA;Lo;0;L;;;;;N;;;;;
31FC;KATAKANA LETTER SMALL RI;Lo;0;L;;;;;N;;;;;
31FD;KATAKANA LETTER SMALL RU;Lo;0;L;;;;;N;;;;;
31FE;KATAKANA LETTER SMALL RE;Lo;0;L;;;;;N;;;;;
31FF;KATAKANA LETTER SMALL RO;Lo;0;L;;;;;N;;;;;
3200;PARENTHESIZED HANGUL KIYEOK;So;0;L;<compat> 0028 1100 0029;;;;N;PARENTHESIZED HANGUL GIYEOG;;;;
3201;PARENTHESIZED HANGUL NIEUN;So;0;L;<compat> 0028 1102 0029;;;;N;;;;;
3202;PARENTHESIZED HANGUL TIKEUT;So;0;L;<compat> 0028 1103 0029;;;;N;PARENTHESIZED HANGUL DIGEUD;;;;
3203;PARENTHESIZED HANGUL RIEUL;So;0;L;<compat> 0028 1105 0029;;;;N;PARENTHESIZED HANGUL LIEUL;;;;
3204;PARENTHESIZED HANGUL MIEUM;So;0;L;<compat> 0028 1106 0029;;;;N;;;;;
3205;PARENTHESIZED HANGUL PIEUP;So;0;L;<compat> 0028 1107 0029;;;;N;PARENTHESIZED HANGUL BIEUB;;;;
3206;PARENTHESIZED HANGUL SIOS;So;0;L;<compat> 0028 1109 0029;;;;N;;;;;
3207;PARENTHESIZED HANGUL IEUNG;So;0;L;<compat> 0028 110B 0029;;;;N;;;;;
3208;PARENTHESIZED HANGUL CIEUC;So;0;L;<compat> 0028 110C 0029;;;;N;PARENTHESIZED HANGUL JIEUJ;;;;
3209;PARENTHESIZED HANGUL CHIEUCH;So;0;L;<compat> 0028 110E 0029;;;;N;PARENTHESIZED HANGUL CIEUC;;;;
320A;PARENTHESIZED HANGUL KHIEUKH;So;0;L;<compat> 0028 110F 0029;;;;N;PARENTHESIZED HANGUL KIYEOK;;;;
320B;PARENTHESIZED HANGUL THIEUTH;So;0;L;<compat> 0028 1110 0029;;;;N;PARENTHESIZED HANGUL TIEUT;;;;
320C;PARENTHESIZED HANGUL PHIEUPH;So;0;L;<compat> 0028 1111 0029;;;;N;PARENTHESIZED HANGUL PIEUP;;;;
320D;PARENTHESIZED HANGUL HIEUH;So;0;L;<compat> 0028 1112 0029;;;;N;;;;;
320E;PARENTHESIZED HANGUL KIYEOK A;So;0;L;<compat> 0028 1100 1161 0029;;;;N;PARENTHESIZED HANGUL GA;;;;
320F;PARENTHESIZED HANGUL NIEUN A;So;0;L;<compat> 0028 1102 1161 0029;;;;N;PARENTHESIZED HANGUL NA;;;;
3210;PARENTHESIZED HANGUL TIKEUT A;So;0;L;<compat> 0028 1103 1161 0029;;;;N;PARENTHESIZED HANGUL DA;;;;
3211;PARENTHESIZED HANGUL RIEUL A;So;0;L;<compat> 0028 1105 1161 0029;;;;N;PARENTHESIZED HANGUL LA;;;;
3212;PARENTHESIZED HANGUL MIEUM A;So;0;L;<compat> 0028 1106 1161 0029;;;;N;PARENTHESIZED HANGUL MA;;;;
3213;PARENTHESIZED HANGUL PIEUP A;So;0;L;<compat> 0028 1107 1161 0029;;;;N;PARENTHESIZED HANGUL BA;;;;
3214;PARENTHESIZED HANGUL SIOS A;So;0;L;<compat> 0028 1109 1161 0029;;;;N;PARENTHESIZED HANGUL SA;;;;
3215;PARENTHESIZED HANGUL IEUNG A;So;0;L;<compat> 0028 110B 1161 0029;;;;N;PARENTHESIZED HANGUL A;;;;
3216;PARENTHESIZED HANGUL CIEUC A;So;0;L;<compat> 0028 110C 1161 0029;;;;N;PARENTHESIZED HANGUL JA;;;;
3217;PARENTHESIZED HANGUL CHIEUCH A;So;0;L;<compat> 0028 110E 1161 0029;;;;N;PARENTHESIZED HANGUL CA;;;;
3218;PARENTHESIZED HANGUL KHIEUKH A;So;0;L;<compat> 0028 110F 1161 0029;;;;N;PARENTHESIZED HANGUL KA;;;;
3219;PARENTHESIZED HANGUL THIEUTH A;So;0;L;<compat> 0028 1110 1161 0029;;;;N;PARENTHESIZED HANGUL TA;;;;
321A;PARENTHESIZED HANGUL PHIEUPH A;So;0;L;<compat> 0028 1111 1161 0029;;;;N;PARENTHESIZED HANGUL PA;;;;
321B;PARENTHESIZED HANGUL HIEUH A;So;0;L;<compat> 0028 1112 1161 0029;;;;N;PARENTHESIZED HANGUL HA;;;;
321C;PARENTHESIZED HANGUL CIEUC U;So;0;L;<compat> 0028 110C 116E 0029;;;;N;PARENTHESIZED HANGUL JU;;;;
321D;PARENTHESIZED KOREAN CHARACTER OJEON;So;0;ON;<compat> 0028 110B 1169 110C 1165 11AB 0029;;;;N;;;;;
321E;PARENTHESIZED KOREAN CHARACTER O HU;So;0;ON;<compat> 0028 110B 1169 1112 116E 0029;;;;N;;;;;
3220;PARENTHESIZED IDEOGRAPH ONE;No;0;L;<compat> 0028 4E00 0029;;;1;N;;;;;
3221;PARENTHESIZED IDEOGRAPH TWO;No;0;L;<compat> 0028 4E8C 0029;;;2;N;;;;;
3222;PARENTHESIZED IDEOGRAPH THREE;No;0;L;<compat> 0028 4E09 0029;;;3;N;;;;;
3223;PARENTHESIZED IDEOGRAPH FOUR;No;0;L;<compat> 0028 56DB 0029;;;4;N;;;;;
3224;PARENTHESIZED IDEOGRAPH FIVE;No;0;L;<compat> 0028 4E94 0029;;;5;N;;;;;
3225;PARENTHESIZED IDEOGRAPH SIX;No;0;L;<compat> 0028 516D 0029;;;6;N;;;;;
3226;PARENTHESIZED IDEOGRAPH SEVEN;No;0;L;<compat> 0028 4E03 0029;;;7;N;;;;;
3227;PARENTHESIZED IDEOGRAPH EIGHT;No;0;L;<compat> 0028 516B 0029;;;8;N;;;;;
3228;PARENTHESIZED IDEOGRAPH NINE;No;0;L;<compat> 0028 4E5D 0029;;;9;N;;;;;
3229;PARENTHESIZED IDEOGRAPH TEN;No;0;L;<compat> 0028 5341 0029;;;10;N;;;;;
322A;PARENTHESIZED IDEOGRAPH MOON;So;0;L;<compat> 0028 6708 0029;;;;N;;;;;
322B;PARENTHESIZED IDEOGRAPH FIRE;So;0;L;<compat> 0028 706B 0029;;;;N;;;;;
322C;PARENTHESIZED IDEOGRAPH WATER;So;0;L;<compat> 0028 6C34 0029;;;;N;;;;;
322D;PARENTHESIZED IDEOGRAPH WOOD;So;0;L;<compat> 0028 6728 0029;;;;N;;;;;
322E;PARENTHESIZED IDEOGRAPH METAL;So;0;L;<compat> 0028 91D1 0029;;;;N;;;;;
322F;PARENTHESIZED IDEOGRAPH EARTH;So;0;L;<compat> 0028 571F 0029;;;;N;;;;;
3230;PARENTHESIZED IDEOGRAPH SUN;So;0;L;<compat> 0028 65E5 0029;;;;N;;;;;
3231;PARENTHESIZED IDEOGRAPH STOCK;So;0;L;<compat> 0028 682A 0029;;;;N;;;;;
3232;PARENTHESIZED IDEOGRAPH HAVE;So;0;L;<compat> 0028 6709 0029;;;;N;;;;;
3233;PARENTHESIZED IDEOGRAPH SOCIETY;So;0;L;<compat> 0028 793E 0029;;;;N;;;;;
3234;PARENTHESIZED IDEOGRAPH NAME;So;0;L;<compat> 0028 540D 0029;;;;N;;;;;
3235;PARENTHESIZED IDEOGRAPH SPECIAL;So;0;L;<compat> 0028 7279 0029;;;;N;;;;;
3236;PARENTHESIZED IDEOGRAPH FINANCIAL;So;0;L;<compat> 0028 8CA1 0029;;;;N;;;;;
3237;PARENTHESIZED IDEOGRAPH CONGRATULATION;So;0;L;<compat> 0028 795D 0029;;;;N;;;;;
3238;PARENTHESIZED IDEOGRAPH LABOR;So;0;L;<compat> 0028 52B4 0029;;;;N;;;;;
3239;PARENTHESIZED IDEOGRAPH REPRESENT;So;0;L;<compat> 0028 4EE3 0029;;;;N;;;;;
323A;PARENTHESIZED IDEOGRAPH CALL;So;0;L;<compat> 0028 547C 0029;;;;N;;;;;
323B;PARENTHESIZED IDEOGRAPH STUDY;So;0;L;<compat> 0028 5B66 0029;;;;N;;;;;
323C;PARENTHESIZED IDEOGRAPH SUPERVISE;So;0;L;<compat> 0028 76E3 0029;;;;N;;;;;
323D;PARENTHESIZED IDEOGRAPH ENTERPRISE;So;0;L;<compat> 0028 4F01 0029;;;;N;;;;;
323E;PARENTHESIZED IDEOGRAPH RESOURCE;So;0;L;<compat> 0028 8CC7 0029;;;;N;;;;;
323F;PARENTHESIZED IDEOGRAPH ALLIANCE;So;0;L;<compat> 0028 5354 0029;;;;N;;;;;
3240;PARENTHESIZED IDEOGRAPH FESTIVAL;So;0;L;<compat> 0028 796D 0029;;;;N;;;;;
3241;PARENTHESIZED IDEOGRAPH REST;So;0;L;<compat> 0028 4F11 0029;;;;N;;;;;
3242;PARENTHESIZED IDEOGRAPH SELF;So;0;L;<compat> 0028 81EA 0029;;;;N;;;;;
3243;PARENTHESIZED IDEOGRAPH REACH;So;0;L;<compat> 0028 81F3 0029;;;;N;;;;;
3244;CIRCLED IDEOGRAPH QUESTION;So;0;L;<circle> 554F;;;;N;;;;;
3245;CIRCLED IDEOGRAPH KINDERGARTEN;So;0;L;<circle> 5E7C;;;;N;;;;;
3246;CIRCLED IDEOGRAPH SCHOOL;So;0;L;<circle> 6587;;;;N;;;;;
3247;CIRCLED IDEOGRAPH KOTO;So;0;L;<circle> 7B8F;;;;N;;;;;
3248;CIRCLED NUMBER TEN ON BLACK SQUARE;No;0;L;;;;10;N;;;;;
3249;CIRCLED NUMBER TWENTY ON BLACK SQUARE;No;0;L;;;;20;N;;;;;
324A;CIRCLED NUMBER THIRTY ON BLACK SQUARE;No;0;L;;;;30;N;;;;;
324B;CIRCLED NUMBER FORTY ON BLACK SQUARE;No;0;L;;;;40;N;;;;;
324C;CIRCLED NUMBER FIFTY ON BLACK SQUARE;No;0;L;;;;50;N;;;;;
324D;CIRCLED NUMBER SIXTY ON BLACK SQUARE;No;0;L;;;;60;N;;;;;
324E;CIRCLED NUMBER SEVENTY ON BLACK SQUARE;No;0;L;;;;70;N;;;;;
324F;CIRCLED NUMBER EIGHTY ON BLACK SQUARE;No;0;L;;;;80;N;;;;;
3250;PARTNERSHIP SIGN;So;0;ON;<square> 0050 0054 0045;;;;N;;;;;
3251;CIRCLED NUMBER TWENTY ONE;No;0;ON;<circle> 0032 0031;;;21;N;;;;;
3252;CIRCLED NUMBER TWENTY TWO;No;0;ON;<circle> 0032 0032;;;22;N;;;;;
3253;CIRCLED NUMBER TWENTY THREE;No;0;ON;<circle> 0032 0033;;;23;N;;;;;
3254;CIRCLED NUMBER TWENTY FOUR;No;0;ON;<circle> 0032 0034;;;24;N;;;;;
3255;CIRCLED NUMBER TWENTY FIVE;No;0;ON;<circle> 0032 0035;;;25;N;;;;;
3256;CIRCLED NUMBER TWENTY SIX;No;0;ON;<circle> 0032 0036;;;26;N;;;;;
3257;CIRCLED NUMBER TWENTY SEVEN;No;0;ON;<circle> 0032 0037;;;27;N;;;;;
3258;CIRCLED NUMBER TWENTY EIGHT;No;0;ON;<circle> 0032 0038;;;28;N;;;;;
3259;CIRCLED NUMBER TWENTY NINE;No;0;ON;<circle> 0032 0039;;;29;N;;;;;
325A;CIRCLED NUMBER THIRTY;No;0;ON;<circle> 0033 0030;;;30;N;;;;;
325B;CIRCLED NUMBER THIRTY ONE;No;0;ON;<circle> 0033 0031;;;31;N;;;;;
325C;CIRCLED NUMBER THIRTY TWO;No;0;ON;<circle> 0033 0032;;;32;N;;;;;
325D;CIRCLED NUMBER THIRTY THREE;No;0;ON;<circle> 0033 0033;;;33;N;;;;;
325E;CIRCLED NUMBER THIRTY FOUR;No;0;ON;<circle> 0033 0034;;;34;N;;;;;
325F;CIRCLED NUMBER THIRTY FIVE;No;0;ON;<circle> 0033 0035;;;35;N;;;;;
3260;CIRCLED HANGUL KIYEOK;So;0;L;<circle> 1100;;;;N;CIRCLED HANGUL GIYEOG;;;;
3261;CIRCLED HANGUL NIEUN;So;0;L;<circle> 1102;;;;N;;;;;
3262;CIRCLED HANGUL TIKEUT;So;0;L;<circle> 1103;;;;N;CIRCLED HANGUL DIGEUD;;;;
3263;CIRCLED HANGUL RIEUL;So;0;L;<circle> 1105;;;;N;CIRCLED HANGUL LIEUL;;;;
3264;CIRCLED HANGUL MIEUM;So;0;L;<circle> 1106;;;;N;;;;;
3265;CIRCLED HANGUL PIEUP;So;0;L;<circle> 1107;;;;N;CIRCLED HANGUL BIEUB;;;;
3266;CIRCLED HANGUL SIOS;So;0;L;<circle> 1109;;;;N;;;;;
3267;CIRCLED HANGUL IEUNG;So;0;L;<circle> 110B;;;;N;;;;;
3268;CIRCLED HANGUL CIEUC;So;0;L;<circle> 110C;;;;N;CIRCLED HANGUL JIEUJ;;;;
3269;CIRCLED HANGUL CHIEUCH;So;0;L;<circle> 110E;;;;N;CIRCLED HANGUL CIEUC;;;;
326A;CIRCLED HANGUL KHIEUKH;So;0;L;<circle> 110F;;;;N;CIRCLED HANGUL KIYEOK;;;;
326B;CIRCLED HANGUL THIEUTH;So;0;L;<circle> 1110;;;;N;CIRCLED HANGUL TIEUT;;;;
326C;CIRCLED HANGUL PHIEUPH;So;0;L;<circle> 1111;;;;N;CIRCLED HANGUL PIEUP;;;;
326D;CIRCLED HANGUL HIEUH;So;0;L;<circle> 1112;;;;N;;;;;
326E;CIRCLED HANGUL KIYEOK A;So;0;L;<circle> 1100 1161;;;;N;CIRCLED HANGUL GA;;;;
326F;CIRCLED HANGUL NIEUN A;So;0;L;<circle> 1102 1161;;;;N;CIRCLED HANGUL NA;;;;
3270;CIRCLED HANGUL TIKEUT A;So;0;L;<circle> 1103 1161;;;;N;CIRCLED HANGUL DA;;;;
3271;CIRCLED HANGUL RIEUL A;So;0;L;<circle> 1105 1161;;;;N;CIRCLED HANGUL LA;;;;
3272;CIRCLED HANGUL MIEUM A;So;0;L;<circle> 1106 1161;;;;N;CIRCLED HANGUL MA;;;;
3273;CIRCLED HANGUL PIEUP A;So;0;L;<circle> 1107 1161;;;;N;CIRCLED HANGUL BA;;;;
3274;CIRCLED HANGUL SIOS A;So;0;L;<circle> 1109 1161;;;;N;CIRCLED HANGUL SA;;;;
3275;CIRCLED HANGUL IEUNG A;So;0;L;<circle> 110B 1161;;;;N;CIRCLED HANGUL A;;;;
3276;CIRCLED HANGUL CIEUC A;So;0;L;<circle> 110C 1161;;;;N;CIRCLED HANGUL JA;;;;
3277;CIRCLED HANGUL CHIEUCH A;So;0;L;<circle> 110E 1161;;;;N;CIRCLED HANGUL CA;;;;
3278;CIRCLED HANGUL KHIEUKH A;So;0;L;<circle> 110F 1161;;;;N;CIRCLED HANGUL KA;;;;
3279;CIRCLED HANGUL THIEUTH A;So;0;L;<circle> 1110 1161;;;;N;CIRCLED HANGUL TA;;;;
327A;CIRCLED HANGUL PHIEUPH A;So;0;L;<circle> 1111 1161;;;;N;CIRCLED HANGUL PA;;;;
327B;CIRCLED HANGUL HIEUH A;So;0;L;<circle> 1112 1161;;;;N;CIRCLED HANGUL HA;;;;
327C;CIRCLED KOREAN CHARACTER CHAMKO;So;0;ON;<circle> 110E 1161 11B7 1100 1169;;;;N;;;;;
327D;CIRCLED KOREAN CHARACTER JUEUI;So;0;ON;<circle> 110C 116E 110B 1174;;;;N;;;;;
327E;CIRCLED HANGUL IEUNG U;So;0;ON;<circle> 110B 116E;;;;N;;;;;
327F;KOREAN STANDARD SYMBOL;So;0;L;;;;;N;;;;;
3280;CIRCLED IDEOGRAPH ONE;No;0;L;<circle> 4E00;;;1;N;;;;;
3281;CIRCLED IDEOGRAPH TWO;No;0;L;<circle> 4E8C;;;2;N;;;;;
3282;CIRCLED IDEOGRAPH THREE;No;0;L;<circle> 4E09;;;3;N;;;;;
3283;CIRCLED IDEOGRAPH FOUR;No;0;L;<circle> 56DB;;;4;N;;;;;
3284;CIRCLED IDEOGRAPH FIVE;No;0;L;<circle> 4E94;;;5;N;;;;;
3285;CIRCLED IDEOGRAPH SIX;No;0;L;<circle> 516D;;;6;N;;;;;
3286;CIRCLED IDEOGRAPH SEVEN;No;0;L;<circle> 4E03;;;7;N;;;;;
3287;CIRCLED IDEOGRAPH EIGHT;No;0;L;<circle> 516B;;;8;N;;;;;
3288;CIRCLED IDEOGRAPH NINE;No;0;L;<circle> 4E5D;;;9;N;;;;;
3289;CIRCLED IDEOGRAPH TEN;No;0;L;<circle> 5341;;;10;N;;;;;
328A;CIRCLED IDEOGRAPH MOON;So;0;L;<circle> 6708;;;;N;;;;;
328B;CIRCLED IDEOGRAPH FIRE;So;0;L;<circle> 706B;;;;N;;;;;
328C;CIRCLED IDEOGRAPH WATER;So;0;L;<circle> 6C34;;;;N;;;;;
328D;CIRCLED IDEOGRAPH WOOD;So;0;L;<circle> 6728;;;;N;;;;;
328E;CIRCLED IDEOGRAPH METAL;So;0;L;<circle> 91D1;;;;N;;;;;
328F;CIRCLED IDEOGRAPH EARTH;So;0;L;<circle> 571F;;;;N;;;;;
3290;CIRCLED IDEOGRAPH SUN;So;0;L;<circle> 65E5;;;;N;;;;;
3291;CIRCLED IDEOGRAPH STOCK;So;0;L;<circle> 682A;;;;N;;;;;
3292;CIRCLED IDEOGRAPH HAVE;So;0;L;<circle> 6709;;;;N;;;;;
3293;CIRCLED IDEOGRAPH SOCIETY;So;0;L;<circle> 793E;;;;N;;;;;
3294;CIRCLED IDEOGRAPH NAME;So;0;L;<circle> 540D;;;;N;;;;;
3295;CIRCLED IDEOGRAPH SPECIAL;So;0;L;<circle> 7279;;;;N;;;;;
3296;CIRCLED IDEOGRAPH FINANCIAL;So;0;L;<circle> 8CA1;;;;N;;;;;
3297;CIRCLED IDEOGRAPH CONGRATULATION;So;0;L;<circle> 795D;;;;N;;;;;
3298;CIRCLED IDEOGRAPH LABOR;So;0;L;<circle> 52B4;;;;N;;;;;
3299;CIRCLED IDEOGRAPH SECRET;So;0;L;<circle> 79D8;;;;N;;;;;
329A;CIRCLED IDEOGRAPH MALE;So;0;L;<circle> 7537;;;;N;;;;;
329B;CIRCLED IDEOGRAPH FEMALE;So;0;L;<circle> 5973;;;;N;;;;;
329C;CIRCLED IDEOGRAPH SUITABLE;So;0;L;<circle> 9069;;;;N;;;;;
329D;CIRCLED IDEOGRAPH EXCELLENT;So;0;L;<circle> 512A;;;;N;;;;;
329E;CIRCLED IDEOGRAPH PRINT;So;0;L;<circle> 5370;;;;N;;;;;
329F;CIRCLED IDEOGRAPH ATTENTION;So;0;L;<circle> 6CE8;;;;N;;;;;
32A0;CIRCLED IDEOGRAPH ITEM;So;0;L;<circle> 9805;;;;N;;;;;
32A1;CIRCLED IDEOGRAPH REST;So;0;L;<circle> 4F11;;;;N;;;;;
32A2;CIRCLED IDEOGRAPH COPY;So;0;L;<circle> 5199;;;;N;;;;;
32A3;CIRCLED IDEOGRAPH CORRECT;So;0;L;<circle> 6B63;;;;N;;;;;
32A4;CIRCLED IDEOGRAPH HIGH;So;0;L;<circle> 4E0A;;;;N;;;;;
32A5;CIRCLED IDEOGRAPH CENTRE;So;0;L;<circle> 4E2D;;;;N;CIRCLED IDEOGRAPH CENTER;;;;
32A6;CIRCLED IDEOGRAPH LOW;So;0;L;<circle> 4E0B;;;;N;;;;;
32A7;CIRCLED IDEOGRAPH LEFT;So;0;L;<circle> 5DE6;;;;N;;;;;
32A8;CIRCLED IDEOGRAPH RIGHT;So;0;L;<circle> 53F3;;;;N;;;;;
32A9;CIRCLED IDEOGRAPH MEDICINE;So;0;L;<circle> 533B;;;;N;;;;;
32AA;CIRCLED IDEOGRAPH RELIGION;So;0;L;<circle> 5B97;;;;N;;;;;
32AB;CIRCLED IDEOGRAPH STUDY;So;0;L;<circle> 5B66;;;;N;;;;;
32AC;CIRCLED IDEOGRAPH SUPERVISE;So;0;L;<circle> 76E3;;;;N;;;;;
32AD;CIRCLED IDEOGRAPH ENTERPRISE;So;0;L;<circle> 4F01;;;;N;;;;;
32AE;CIRCLED IDEOGRAPH RESOURCE;So;0;L;<circle> 8CC7;;;;N;;;;;
32AF;CIRCLED IDEOGRAPH ALLIANCE;So;0;L;<circle> 5354;;;;N;;;;;
32B0;CIRCLED IDEOGRAPH NIGHT;So;0;L;<circle> 591C;;;;N;;;;;
32B1;CIRCLED NUMBER THIRTY SIX;No;0;ON;<circle> 0033 0036;;;36;N;;;;;
32B2;CIRCLED NUMBER THIRTY SEVEN;No;0;ON;<circle> 0033 0037;;;37;N;;;;;
32B3;CIRCLED NUMBER THIRTY EIGHT;No;0;ON;<circle> 0033 0038;;;38;N;;;;;
32B4;CIRCLED NUMBER THIRTY NINE;No;0;ON;<circle> 0033 0039;;;39;N;;;;;
32B5;CIRCLED NUMBER FORTY;No;0;ON;<circle> 0034 0030;;;40;N;;;;;
32B6;CIRCLED NUMBER FORTY ONE;No;0;ON;<circle> 0034 0031;;;41;N;;;;;
32B7;CIRCLED NUMBER FORTY TWO;No;0;ON;<circle> 0034 0032;;;42;N;;;;;
32B8;CIRCLED NUMBER FORTY THREE;No;0;ON;<circle> 0034 0033;;;43;N;;;;;
32B9;CIRCLED NUMBER FORTY FOUR;No;0;ON;<circle> 0034 0034;;;44;N;;;;;
32BA;CIRCLED NUMBER FORTY FIVE;No;0;ON;<circle> 0034 0035;;;45;N;;;;;
32BB;CIRCLED NUMBER FORTY SIX;No;0;ON;<circle> 0034 0036;;;46;N;;;;;
32BC;CIRCLED NUMBER FORTY SEVEN;No;0;ON;<circle> 0034 0037;;;47;N;;;;;
32BD;CIRCLED NUMBER FORTY EIGHT;No;0;ON;<circle> 0034 0038;;;48;N;;;;;
32BE;CIRCLED NUMBER FORTY NINE;No;0;ON;<circle> 0034 0039;;;49;N;;;;;
32BF;CIRCLED NUMBER FIFTY;No;0;ON;<circle> 0035 0030;;;50;N;;;;;
32C0;IDEOGRAPHIC TELEGRAPH SYMBOL FOR JANUARY;So;0;L;<compat> 0031 6708;;;;N;;;;;
32C1;IDEOGRAPHIC TELEGRAPH SYMBOL FOR FEBRUARY;So;0;L;<compat> 0032 6708;;;;N;;;;;
32C2;IDEOGRAPHIC TELEGRAPH SYMBOL FOR MARCH;So;0;L;<compat> 0033 6708;;;;N;;;;;
32C3;IDEOGRAPHIC TELEGRAPH SYMBOL FOR APRIL;So;0;L;<compat> 0034 6708;;;;N;;;;;
32C4;IDEOGRAPHIC TELEGRAPH SYMBOL FOR MAY;So;0;L;<compat> 0035 6708;;;;N;;;;;
32C5;IDEOGRAPHIC TELEGRAPH SYMBOL FOR JUNE;So;0;L;<compat> 0036 6708;;;;N;;;;;
32C6;IDEOGRAPHIC TELEGRAPH SYMBOL FOR JULY;So;0;L;<compat> 0037 6708;;;;N;;;;;
32C7;IDEOGRAPHIC TELEGRAPH SYMBOL FOR AUGUST;So;0;L;<compat> 0038 6708;;;;N;;;;;
32C8;IDEOGRAPHIC TELEGRAPH SYMBOL FOR SEPTEMBER;So;0;L;<compat> 0039 6708;;;;N;;;;;
32C9;IDEOGRAPHIC TELEGRAPH SYMBOL FOR OCTOBER;So;0;L;<compat> 0031 0030 6708;;;;N;;;;;
32CA;IDEOGRAPHIC TELEGRAPH SYMBOL FOR NOVEMBER;So;0;L;<compat> 0031 0031 6708;;;;N;;;;;
32CB;IDEOGRAPHIC TELEGRAPH SYMBOL FOR DECEMBER;So;0;L;<compat> 0031 0032 6708;;;;N;;;;;
32CC;SQUARE HG;So;0;ON;<square> 0048 0067;;;;N;;;;;
32CD;SQUARE ERG;So;0;ON;<square> 0065 0072 0067;;;;N;;;;;
32CE;SQUARE EV;So;0;ON;<square> 0065 0056;;;;N;;;;;
32CF;LIMITED LIABILITY SIGN;So;0;ON;<square> 004C 0054 0044;;;;N;;;;;
32D0;CIRCLED KATAKANA A;So;0;L;<circle> 30A2;;;;N;;;;;
32D1;CIRCLED KATAKANA I;So;0;L;<circle> 30A4;;;;N;;;;;
32D2;CIRCLED KATAKANA U;So;0;L;<circle> 30A6;;;;N;;;;;
32D3;CIRCLED KATAKANA E;So;0;L;<circle> 30A8;;;;N;;;;;
32D4;CIRCLED KATAKANA O;So;0;L;<circle> 30AA;;;;N;;;;;
32D5;CIRCLED KATAKANA KA;So;0;L;<circle> 30AB;;;;N;;;;;
32D6;CIRCLED KATAKANA KI;So;0;L;<circle> 30AD;;;;N;;;;;
32D7;CIRCLED KATAKANA KU;So;0;L;<circle> 30AF;;;;N;;;;;
32D8;CIRCLED KATAKANA KE;So;0;L;<circle> 30B1;;;;N;;;;;
32D9;CIRCLED KATAKANA KO;So;0;L;<circle> 30B3;;;;N;;;;;
32DA;CIRCLED KATAKANA SA;So;0;L;<circle> 30B5;;;;N;;;;;
32DB;CIRCLED KATAKANA SI;So;0;L;<circle> 30B7;;;;N;;;;;
32DC;CIRCLED KATAKANA SU;So;0;L;<circle> 30B9;;;;N;;;;;
32DD;CIRCLED KATAKANA SE;So;0;L;<circle> 30BB;;;;N;;;;;
32DE;CIRCLED KATAKANA SO;So;0;L;<circle> 30BD;;;;N;;;;;
32DF;CIRCLED KATAKANA TA;So;0;L;<circle> 30BF;;;;N;;;;;
32E0;CIRCLED KATAKANA TI;So;0;L;<circle> 30C1;;;;N;;;;;
32E1;CIRCLED KATAKANA TU;So;0;L;<circle> 30C4;;;;N;;;;;
32E2;CIRCLED KATAKANA TE;So;0;L;<circle> 30C6;;;;N;;;;;
32E3;CIRCLED KATAKANA TO;So;0;L;<circle> 30C8;;;;N;;;;;
32E4;CIRCLED KATAKANA NA;So;0;L;<circle> 30CA;;;;N;;;;;
32E5;CIRCLED KATAKANA NI;So;0;L;<circle> 30CB;;;;N;;;;;
32E6;CIRCLED KATAKANA NU;So;0;L;<circle> 30CC;;;;N;;;;;
32E7;CIRCLED KATAKANA NE;So;0;L;<circle> 30CD;;;;N;;;;;
32E8;CIRCLED KATAKANA NO;So;0;L;<circle> 30CE;;;;N;;;;;
32E9;CIRCLED KATAKANA HA;So;0;L;<circle> 30CF;;;;N;;;;;
32EA;CIRCLED KATAKANA HI;So;0;L;<circle> 30D2;;;;N;;;;;
32EB;CIRCLED KATAKANA HU;So;0;L;<circle> 30D5;;;;N;;;;;
32EC;CIRCLED KATAKANA HE;So;0;L;<circle> 30D8;;;;N;;;;;
32ED;CIRCLED KATAKANA HO;So;0;L;<circle> 30DB;;;;N;;;;;
32EE;CIRCLED KATAKANA MA;So;0;L;<circle> 30DE;;;;N;;;;;
32EF;CIRCLED KATAKANA MI;So;0;L;<circle> 30DF;;;;N;;;;;
32F0;CIRCLED KATAKANA MU;So;0;L;<circle> 30E0;;;;N;;;;;
32F1;CIRCLED KATAKANA ME;So;0;L;<circle> 30E1;;;;N;;;;;
32F2;CIRCLED KATAKANA MO;So;0;L;<circle> 30E2;;;;N;;;;;
32F3;CIRCLED KATAKANA YA;So;0;L;<circle> 30E4;;;;N;;;;;
32F4;CIRCLED KATAKANA YU;So;0;L;<circle> 30E6;;;;N;;;;;
32F5;CIRCLED KATAKANA YO;So;0;L;<circle> 30E8;;;;N;;;;;
32F6;CIRCLED KATAKANA RA;So;0;L;<circle> 30E9;;;;N;;;;;
32F7;CIRCLED KATAKANA RI;So;0;L;<circle> 30EA;;;;N;;;;;
32F8;CIRCLED KATAKANA RU;So;0;L;<circle> 30EB;;;;N;;;;;
32F9;CIRCLED KATAKANA RE;So;0;L;<circle> 30EC;;;;N;;;;;
32FA;CIRCLED KATAKANA RO;So;0;L;<circle> 30ED;;;;N;;;;;
32FB;CIRCLED KATAKANA WA;So;0;L;<circle> 30EF;;;;N;;;;;
32FC;CIRCLED KATAKANA WI;So;0;L;<circle> 30F0;;;;N;;;;;
32FD;CIRCLED KATAKANA WE;So;0;L;<circle> 30F1;;;;N;;;;;
32FE;CIRCLED KATAKANA WO;So;0;L;<circle> 30F2;;;;N;;;;;
32FF;SQUARE ERA NAME REIWA;So;0;L;<square> 4EE4 548C;;;;N;;;;;
3300;SQUARE APAATO;So;0;L;<square> 30A2 30D1 30FC 30C8;;;;N;SQUARED APAATO;;;;
3301;SQUARE ARUHUA;So;0;L;<square> 30A2 30EB 30D5 30A1;;;;N;SQUARED ARUHUA;;;;
3302;SQUARE ANPEA;So;0;L;<square> 30A2 30F3 30DA 30A2;;;;N;SQUARED ANPEA;;;;
3303;SQUARE AARU;So;0;L;<square> 30A2 30FC 30EB;;;;N;SQUARED AARU;;;;
3304;SQUARE ININGU;So;0;L;<square> 30A4 30CB 30F3 30B0;;;;N;SQUARED ININGU;;;;
3305;SQUARE INTI;So;0;L;<square> 30A4 30F3 30C1;;;;N;SQUARED INTI;;;;
3306;SQUARE UON;So;0;L;<square> 30A6 30A9 30F3;;;;N;SQUARED UON;;;;
3307;SQUARE ESUKUUDO;So;0;L;<square> 30A8 30B9 30AF 30FC 30C9;;;;N;SQUARED ESUKUUDO;;;;
3308;SQUARE EEKAA;So;0;L;<square> 30A8 30FC 30AB 30FC;;;;N;SQUARED EEKAA;;;;
3309;SQUARE ONSU;So;0;L;<square> 30AA 30F3 30B9;;;;N;SQUARED ONSU;;;;
330A;SQUARE OOMU;So;0;L;<square> 30AA 30FC 30E0;;;;N;SQUARED OOMU;;;;
330B;SQUARE KAIRI;So;0;L;<square> 30AB 30A4 30EA;;;;N;SQUARED KAIRI;;;;
330C;SQUARE KARATTO;So;0;L;<square> 30AB 30E9 30C3 30C8;;;;N;SQUARED KARATTO;;;;
330D;SQUARE KARORII;So;0;L;<square> 30AB 30ED 30EA 30FC;;;;N;SQUARED KARORII;;;;
330E;SQUARE GARON;So;0;L;<square> 30AC 30ED 30F3;;;;N;SQUARED GARON;;;;
330F;SQUARE GANMA;So;0;L;<square> 30AC 30F3 30DE;;;;N;SQUARED GANMA;;;;
3310;SQUARE GIGA;So;0;L;<square> 30AE 30AC;;;;N;SQUARED GIGA;;;;
3311;SQUARE GINII;So;0;L;<square> 30AE 30CB 30FC;;;;N;SQUARED GINII;;;;
3312;SQUARE KYURII;So;0;L;<square> 30AD 30E5 30EA 30FC;;;;N;SQUARED KYURII;;;;
3313;SQUARE GIRUDAA;So;0;L;<square> 30AE 30EB 30C0 30FC;;;;N;SQUARED GIRUDAA;;;;
3314;SQUARE KIRO;So;0;L;<square> 30AD 30ED;;;;N;SQUARED KIRO;;;;
3315;SQUARE KIROGURAMU;So;0;L;<square> 30AD 30ED 30B0 30E9 30E0;;;;N;SQUARED KIROGURAMU;;;;
3316;SQUARE KIROMEETORU;So;0;L;<square> 30AD 30ED 30E1 30FC 30C8 30EB;;;;N;SQUARED KIROMEETORU;;;;
3317;SQUARE KIROWATTO;So;0;L;<square> 30AD 30ED 30EF 30C3 30C8;;;;N;SQUARED KIROWATTO;;;;
3318;SQUARE GURAMU;So;0;L;<square> 30B0 30E9 30E0;;;;N;SQUARED GURAMU;;;;
3319;SQUARE GURAMUTON;So;0;L;<square> 30B0 30E9 30E0 30C8 30F3;;;;N;SQUARED GURAMUTON;;;;
331A;SQUARE KURUZEIRO;So;0;L;<square> 30AF 30EB 30BC 30A4 30ED;;;;N;SQUARED KURUZEIRO;;;;
331B;SQUARE KUROONE;So;0;L;<square> 30AF 30ED 30FC 30CD;;;;N;SQUARED KUROONE;;;;
331C;SQUARE KEESU;So;0;L;<square> 30B1 30FC 30B9;;;;N;SQUARED KEESU;;;;
331D;SQUARE KORUNA;So;0;L;<square> 30B3 30EB 30CA;;;;N;SQUARED KORUNA;;;;
331E;SQUARE KOOPO;So;0;L;<square> 30B3 30FC 30DD;;;;N;SQUARED KOOPO;;;;
331F;SQUARE SAIKURU;So;0;L;<square> 30B5 30A4 30AF 30EB;;;;N;SQUARED SAIKURU;;;;
3320;SQUARE SANTIIMU;So;0;L;<square> 30B5 30F3 30C1 30FC 30E0;;;;N;SQUARED SANTIIMU;;;;
3321;SQUARE SIRINGU;So;0;L;<square> 30B7 30EA 30F3 30B0;;;;N;SQUARED SIRINGU;;;;
3322;SQUARE SENTI;So;0;L;<square> 30BB 30F3 30C1;;;;N;SQUARED SENTI;;;;
3323;SQUARE SENTO;So;0;L;<square> 30BB 30F3 30C8;;;;N;SQUARED SENTO;;;;
3324;SQUARE DAASU;So;0;L;<square> 30C0 30FC 30B9;;;;N;SQUARED DAASU;;;;
3325;SQUARE DESI;So;0;L;<square> 30C7 30B7;;;;N;SQUARED DESI;;;;
3326;SQUARE DORU;So;0;L;<square> 30C9 30EB;;;;N;SQUARED DORU;;;;
3327;SQUARE TON;So;0;L;<square> 30C8 30F3;;;;N;SQUARED TON;;;;
3328;SQUARE NANO;So;0;L;<square> 30CA 30CE;;;;N;SQUARED NANO;;;;
3329;SQUARE NOTTO;So;0;L;<square> 30CE 30C3 30C8;;;;N;SQUARED NOTTO;;;;
332A;SQUARE HAITU;So;0;L;<square> 30CF 30A4 30C4;;;;N;SQUARED HAITU;;;;
332B;SQUARE PAASENTO;So;0;L;<square> 30D1 30FC 30BB 30F3 30C8;;;;N;SQUARED PAASENTO;;;;
332C;SQUARE PAATU;So;0;L;<square> 30D1 30FC 30C4;;;;N;SQUARED PAATU;;;;
332D;SQUARE BAARERU;So;0;L;<square> 30D0 30FC 30EC 30EB;;;;N;SQUARED BAARERU;;;;
332E;SQUARE PIASUTORU;So;0;L;<square> 30D4 30A2 30B9 30C8 30EB;;;;N;SQUARED PIASUTORU;;;;
332F;SQUARE PIKURU;So;0;L;<square> 30D4 30AF 30EB;;;;N;SQUARED PIKURU;;;;
3330;SQUARE PIKO;So;0;L;<square> 30D4 30B3;;;;N;SQUARED PIKO;;;;
3331;SQUARE BIRU;So;0;L;<square> 30D3 30EB;;;;N;SQUARED BIRU;;;;
3332;SQUARE HUARADDO;So;0;L;<square> 30D5 30A1 30E9 30C3 30C9;;;;N;SQUARED HUARADDO;;;;
3333;SQUARE HUIITO;So;0;L;<square> 30D5 30A3 30FC 30C8;;;;N;SQUARED HUIITO;;;;
3334;SQUARE BUSSYERU;So;0;L;<square> 30D6 30C3 30B7 30A7 30EB;;;;N;SQUARED BUSSYERU;;;;
3335;SQUARE HURAN;So;0;L;<square> 30D5 30E9 30F3;;;;N;SQUARED HURAN;;;;
3336;SQUARE HEKUTAARU;So;0;L;<square> 30D8 30AF 30BF 30FC 30EB;;;;N;SQUARED HEKUTAARU;;;;
3337;SQUARE PESO;So;0;L;<square> 30DA 30BD;;;;N;SQUARED PESO;;;;
3338;SQUARE PENIHI;So;0;L;<square> 30DA 30CB 30D2;;;;N;SQUARED PENIHI;;;;
3339;SQUARE HERUTU;So;0;L;<square> 30D8 30EB 30C4;;;;N;SQUARED HERUTU;;;;
333A;SQUARE PENSU;So;0;L;<square> 30DA 30F3 30B9;;;;N;SQUARED PENSU;;;;
333B;SQUARE PEEZI;So;0;L;<square> 30DA 30FC 30B8;;;;N;SQUARED PEEZI;;;;
333C;SQUARE BEETA;So;0;L;<square> 30D9 30FC 30BF;;;;N;SQUARED BEETA;;;;
333D;SQUARE POINTO;So;0;L;<square> 30DD 30A4 30F3 30C8;;;;N;SQUARED POINTO;;;;
333E;SQUARE BORUTO;So;0;L;<square> 30DC 30EB 30C8;;;;N;SQUARED BORUTO;;;;
333F;SQUARE HON;So;0;L;<square> 30DB 30F3;;;;N;SQUARED HON;;;;
3340;SQUARE PONDO;So;0;L;<square> 30DD 30F3 30C9;;;;N;SQUARED PONDO;;;;
3341;SQUARE HOORU;So;0;L;<square> 30DB 30FC 30EB;;;;N;SQUARED HOORU;;;;
3342;SQUARE HOON;So;0;L;<square> 30DB 30FC 30F3;;;;N;SQUARED HOON;;;;
3343;SQUARE MAIKURO;So;0;L;<square> 30DE 30A4 30AF 30ED;;;;N;SQUARED MAIKURO;;;;
3344;SQUARE MAIRU;So;0;L;<square> 30DE 30A4 30EB;;;;N;SQUARED MAIRU;;;;
3345;SQUARE MAHHA;So;0;L;<square> 30DE 30C3 30CF;;;;N;SQUARED MAHHA;;;;
3346;SQUARE MARUKU;So;0;L;<square> 30DE 30EB 30AF;;;;N;SQUARED MARUKU;;;;
3347;SQUARE MANSYON;So;0;L;<square> 30DE 30F3 30B7 30E7 30F3;;;;N;SQUARED MANSYON;;;;
3348;SQUARE MIKURON;So;0;L;<square> 30DF 30AF 30ED 30F3;;;;N;SQUARED MIKURON;;;;
3349;SQUARE MIRI;So;0;L;<square> 30DF 30EA;;;;N;SQUARED MIRI;;;;
334A;SQUARE MIRIBAARU;So;0;L;<square> 30DF 30EA 30D0 30FC 30EB;;;;N;SQUARED MIRIBAARU;;;;
334B;SQUARE MEGA;So;0;L;<square> 30E1 30AC;;;;N;SQUARED MEGA;;;;
334C;SQUARE MEGATON;So;0;L;<square> 30E1 30AC 30C8 30F3;;;;N;SQUARED MEGATON;;;;
334D;SQUARE MEETORU;So;0;L;<square> 30E1 30FC 30C8 30EB;;;;N;SQUARED MEETORU;;;;
334E;SQUARE YAADO;So;0;L;<square> 30E4 30FC 30C9;;;;N;SQUARED YAADO;;;;
334F;SQUARE YAARU;So;0;L;<square> 30E4 30FC 30EB;;;;N;SQUARED YAARU;;;;
3350;SQUARE YUAN;So;0;L;<square> 30E6 30A2 30F3;;;;N;SQUARED YUAN;;;;
3351;SQUARE RITTORU;So;0;L;<square> 30EA 30C3 30C8 30EB;;;;N;SQUARED RITTORU;;;;
3352;SQUARE RIRA;So;0;L;<square> 30EA 30E9;;;;N;SQUARED RIRA;;;;
3353;SQUARE RUPII;So;0;L;<square> 30EB 30D4 30FC;;;;N;SQUARED RUPII;;;;
3354;SQUARE RUUBURU;So;0;L;<square> 30EB 30FC 30D6 30EB;;;;N;SQUARED RUUBURU;;;;
3355;SQUARE REMU;So;0;L;<square> 30EC 30E0;;;;N;SQUARED REMU;;;;
3356;SQUARE RENTOGEN;So;0;L;<square> 30EC 30F3 30C8 30B2 30F3;;;;N;SQUARED RENTOGEN;;;;
3357;SQUARE WATTO;So;0;L;<square> 30EF 30C3 30C8;;;;N;SQUARED WATTO;;;;
3358;IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR ZERO;So;0;L;<compat> 0030 70B9;;;;N;;;;;
3359;IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR ONE;So;0;L;<compat> 0031 70B9;;;;N;;;;;
335A;IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWO;So;0;L;<compat> 0032 70B9;;;;N;;;;;
335B;IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR THREE;So;0;L;<compat> 0033 70B9;;;;N;;;;;
335C;IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR FOUR;So;0;L;<compat> 0034 70B9;;;;N;;;;;
335D;IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR FIVE;So;0;L;<compat> 0035 70B9;;;;N;;;;;
335E;IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR SIX;So;0;L;<compat> 0036 70B9;;;;N;;;;;
335F;IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR SEVEN;So;0;L;<compat> 0037 70B9;;;;N;;;;;
3360;IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR EIGHT;So;0;L;<compat> 0038 70B9;;;;N;;;;;
3361;IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR NINE;So;0;L;<compat> 0039 70B9;;;;N;;;;;
3362;IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TEN;So;0;L;<compat> 0031 0030 70B9;;;;N;;;;;
3363;IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR ELEVEN;So;0;L;<compat> 0031 0031 70B9;;;;N;;;;;
3364;IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWELVE;So;0;L;<compat> 0031 0032 70B9;;;;N;;;;;
3365;IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR THIRTEEN;So;0;L;<compat> 0031 0033 70B9;;;;N;;;;;
3366;IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR FOURTEEN;So;0;L;<compat> 0031 0034 70B9;;;;N;;;;;
3367;IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR FIFTEEN;So;0;L;<compat> 0031 0035 70B9;;;;N;;;;;
3368;IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR SIXTEEN;So;0;L;<compat> 0031 0036 70B9;;;;N;;;;;
3369;IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR SEVENTEEN;So;0;L;<compat> 0031 0037 70B9;;;;N;;;;;
336A;IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR EIGHTEEN;So;0;L;<compat> 0031 0038 70B9;;;;N;;;;;
336B;IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR NINETEEN;So;0;L;<compat> 0031 0039 70B9;;;;N;;;;;
336C;IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWENTY;So;0;L;<compat> 0032 0030 70B9;;;;N;;;;;
336D;IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWENTY-ONE;So;0;L;<compat> 0032 0031 70B9;;;;N;;;;;
336E;IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWENTY-TWO;So;0;L;<compat> 0032 0032 70B9;;;;N;;;;;
336F;IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWENTY-THREE;So;0;L;<compat> 0032 0033 70B9;;;;N;;;;;
3370;IDEOGRAPHIC TELEGRAPH SYMBOL FOR HOUR TWENTY-FOUR;So;0;L;<compat> 0032 0034 70B9;;;;N;;;;;
3371;SQUARE HPA;So;0;L;<square> 0068 0050 0061;;;;N;;;;;
3372;SQUARE DA;So;0;L;<square> 0064 0061;;;;N;;;;;
3373;SQUARE AU;So;0;L;<square> 0041 0055;;;;N;;;;;
3374;SQUARE BAR;So;0;L;<square> 0062 0061 0072;;;;N;;;;;
3375;SQUARE OV;So;0;L;<square> 006F 0056;;;;N;;;;;
3376;SQUARE PC;So;0;L;<square> 0070 0063;;;;N;;;;;
3377;SQUARE DM;So;0;ON;<square> 0064 006D;;;;N;;;;;
3378;SQUARE DM SQUARED;So;0;ON;<square> 0064 006D 00B2;;;;N;;;;;
3379;SQUARE DM CUBED;So;0;ON;<square> 0064 006D 00B3;;;;N;;;;;
337A;SQUARE IU;So;0;ON;<square> 0049 0055;;;;N;;;;;
337B;SQUARE ERA NAME HEISEI;So;0;L;<square> 5E73 6210;;;;N;SQUARED TWO IDEOGRAPHS ERA NAME HEISEI;;;;
337C;SQUARE ERA NAME SYOUWA;So;0;L;<square> 662D 548C;;;;N;SQUARED TWO IDEOGRAPHS ERA NAME SYOUWA;;;;
337D;SQUARE ERA NAME TAISYOU;So;0;L;<square> 5927 6B63;;;;N;SQUARED TWO IDEOGRAPHS ERA NAME TAISYOU;;;;
337E;SQUARE ERA NAME MEIZI;So;0;L;<square> 660E 6CBB;;;;N;SQUARED TWO IDEOGRAPHS ERA NAME MEIZI;;;;
337F;SQUARE CORPORATION;So;0;L;<square> 682A 5F0F 4F1A 793E;;;;N;SQUARED FOUR IDEOGRAPHS CORPORATION;;;;
3380;SQUARE PA AMPS;So;0;L;<square> 0070 0041;;;;N;SQUARED PA AMPS;;;;
3381;SQUARE NA;So;0;L;<square> 006E 0041;;;;N;SQUARED NA;;;;
3382;SQUARE MU A;So;0;L;<square> 03BC 0041;;;;N;SQUARED MU A;;;;
3383;SQUARE MA;So;0;L;<square> 006D 0041;;;;N;SQUARED MA;;;;
3384;SQUARE KA;So;0;L;<square> 006B 0041;;;;N;SQUARED KA;;;;
3385;SQUARE KB;So;0;L;<square> 004B 0042;;;;N;SQUARED KB;;;;
3386;SQUARE MB;So;0;L;<square> 004D 0042;;;;N;SQUARED MB;;;;
3387;SQUARE GB;So;0;L;<square> 0047 0042;;;;N;SQUARED GB;;;;
3388;SQUARE CAL;So;0;L;<square> 0063 0061 006C;;;;N;SQUARED CAL;;;;
3389;SQUARE KCAL;So;0;L;<square> 006B 0063 0061 006C;;;;N;SQUARED KCAL;;;;
338A;SQUARE PF;So;0;L;<square> 0070 0046;;;;N;SQUARED PF;;;;
338B;SQUARE NF;So;0;L;<square> 006E 0046;;;;N;SQUARED NF;;;;
338C;SQUARE MU F;So;0;L;<square> 03BC 0046;;;;N;SQUARED MU F;;;;
338D;SQUARE MU G;So;0;L;<square> 03BC 0067;;;;N;SQUARED MU G;;;;
338E;SQUARE MG;So;0;L;<square> 006D 0067;;;;N;SQUARED MG;;;;
338F;SQUARE KG;So;0;L;<square> 006B 0067;;;;N;SQUARED KG;;;;
3390;SQUARE HZ;So;0;L;<square> 0048 007A;;;;N;SQUARED HZ;;;;
3391;SQUARE KHZ;So;0;L;<square> 006B 0048 007A;;;;N;SQUARED KHZ;;;;
3392;SQUARE MHZ;So;0;L;<square> 004D 0048 007A;;;;N;SQUARED MHZ;;;;
3393;SQUARE GHZ;So;0;L;<square> 0047 0048 007A;;;;N;SQUARED GHZ;;;;
3394;SQUARE THZ;So;0;L;<square> 0054 0048 007A;;;;N;SQUARED THZ;;;;
3395;SQUARE MU L;So;0;L;<square> 03BC 2113;;;;N;SQUARED MU L;;;;
3396;SQUARE ML;So;0;L;<square> 006D 2113;;;;N;SQUARED ML;;;;
3397;SQUARE DL;So;0;L;<square> 0064 2113;;;;N;SQUARED DL;;;;
3398;SQUARE KL;So;0;L;<square> 006B 2113;;;;N;SQUARED KL;;;;
3399;SQUARE FM;So;0;L;<square> 0066 006D;;;;N;SQUARED FM;;;;
339A;SQUARE NM;So;0;L;<square> 006E 006D;;;;N;SQUARED NM;;;;
339B;SQUARE MU M;So;0;L;<square> 03BC 006D;;;;N;SQUARED MU M;;;;
339C;SQUARE MM;So;0;L;<square> 006D 006D;;;;N;SQUARED MM;;;;
339D;SQUARE CM;So;0;L;<square> 0063 006D;;;;N;SQUARED CM;;;;
339E;SQUARE KM;So;0;L;<square> 006B 006D;;;;N;SQUARED KM;;;;
339F;SQUARE MM SQUARED;So;0;L;<square> 006D 006D 00B2;;;;N;SQUARED MM SQUARED;;;;
33A0;SQUARE CM SQUARED;So;0;L;<square> 0063 006D 00B2;;;;N;SQUARED CM SQUARED;;;;
33A1;SQUARE M SQUARED;So;0;L;<square> 006D 00B2;;;;N;SQUARED M SQUARED;;;;
33A2;SQUARE KM SQUARED;So;0;L;<square> 006B 006D 00B2;;;;N;SQUARED KM SQUARED;;;;
33A3;SQUARE MM CUBED;So;0;L;<square> 006D 006D 00B3;;;;N;SQUARED MM CUBED;;;;
33A4;SQUARE CM CUBED;So;0;L;<square> 0063 006D 00B3;;;;N;SQUARED CM CUBED;;;;
33A5;SQUARE M CUBED;So;0;L;<square> 006D 00B3;;;;N;SQUARED M CUBED;;;;
33A6;SQUARE KM CUBED;So;0;L;<square> 006B 006D 00B3;;;;N;SQUARED KM CUBED;;;;
33A7;SQUARE M OVER S;So;0;L;<square> 006D 2215 0073;;;;N;SQUARED M OVER S;;;;
33A8;SQUARE M OVER S SQUARED;So;0;L;<square> 006D 2215 0073 00B2;;;;N;SQUARED M OVER S SQUARED;;;;
33A9;SQUARE PA;So;0;L;<square> 0050 0061;;;;N;SQUARED PA;;;;
33AA;SQUARE KPA;So;0;L;<square> 006B 0050 0061;;;;N;SQUARED KPA;;;;
33AB;SQUARE MPA;So;0;L;<square> 004D 0050 0061;;;;N;SQUARED MPA;;;;
33AC;SQUARE GPA;So;0;L;<square> 0047 0050 0061;;;;N;SQUARED GPA;;;;
33AD;SQUARE RAD;So;0;L;<square> 0072 0061 0064;;;;N;SQUARED RAD;;;;
33AE;SQUARE RAD OVER S;So;0;L;<square> 0072 0061 0064 2215 0073;;;;N;SQUARED RAD OVER S;;;;
33AF;SQUARE RAD OVER S SQUARED;So;0;L;<square> 0072 0061 0064 2215 0073 00B2;;;;N;SQUARED RAD OVER S SQUARED;;;;
33B0;SQUARE PS;So;0;L;<square> 0070 0073;;;;N;SQUARED PS;;;;
33B1;SQUARE NS;So;0;L;<square> 006E 0073;;;;N;SQUARED NS;;;;
33B2;SQUARE MU S;So;0;L;<square> 03BC 0073;;;;N;SQUARED MU S;;;;
33B3;SQUARE MS;So;0;L;<square> 006D 0073;;;;N;SQUARED MS;;;;
33B4;SQUARE PV;So;0;L;<square> 0070 0056;;;;N;SQUARED PV;;;;
33B5;SQUARE NV;So;0;L;<square> 006E 0056;;;;N;SQUARED NV;;;;
33B6;SQUARE MU V;So;0;L;<square> 03BC 0056;;;;N;SQUARED MU V;;;;
33B7;SQUARE MV;So;0;L;<square> 006D 0056;;;;N;SQUARED MV;;;;
33B8;SQUARE KV;So;0;L;<square> 006B 0056;;;;N;SQUARED KV;;;;
33B9;SQUARE MV MEGA;So;0;L;<square> 004D 0056;;;;N;SQUARED MV MEGA;;;;
33BA;SQUARE PW;So;0;L;<square> 0070 0057;;;;N;SQUARED PW;;;;
33BB;SQUARE NW;So;0;L;<square> 006E 0057;;;;N;SQUARED NW;;;;
33BC;SQUARE MU W;So;0;L;<square> 03BC 0057;;;;N;SQUARED MU W;;;;
33BD;SQUARE MW;So;0;L;<square> 006D 0057;;;;N;SQUARED MW;;;;
33BE;SQUARE KW;So;0;L;<square> 006B 0057;;;;N;SQUARED KW;;;;
33BF;SQUARE MW MEGA;So;0;L;<square> 004D 0057;;;;N;SQUARED MW MEGA;;;;
33C0;SQUARE K OHM;So;0;L;<square> 006B 03A9;;;;N;SQUARED K OHM;;;;
33C1;SQUARE M OHM;So;0;L;<square> 004D 03A9;;;;N;SQUARED M OHM;;;;
33C2;SQUARE AM;So;0;L;<square> 0061 002E 006D 002E;;;;N;SQUARED AM;;;;
33C3;SQUARE BQ;So;0;L;<square> 0042 0071;;;;N;SQUARED BQ;;;;
33C4;SQUARE CC;So;0;L;<square> 0063 0063;;;;N;SQUARED CC;;;;
33C5;SQUARE CD;So;0;L;<square> 0063 0064;;;;N;SQUARED CD;;;;
33C6;SQUARE C OVER KG;So;0;L;<square> 0043 2215 006B 0067;;;;N;SQUARED C OVER KG;;;;
33C7;SQUARE CO;So;0;L;<square> 0043 006F 002E;;;;N;SQUARED CO;;;;
33C8;SQUARE DB;So;0;L;<square> 0064 0042;;;;N;SQUARED DB;;;;
33C9;SQUARE GY;So;0;L;<square> 0047 0079;;;;N;SQUARED GY;;;;
33CA;SQUARE HA;So;0;L;<square> 0068 0061;;;;N;SQUARED HA;;;;
33CB;SQUARE HP;So;0;L;<square> 0048 0050;;;;N;SQUARED HP;;;;
33CC;SQUARE IN;So;0;L;<square> 0069 006E;;;;N;SQUARED IN;;;;
33CD;SQUARE KK;So;0;L;<square> 004B 004B;;;;N;SQUARED KK;;;;
33CE;SQUARE KM CAPITAL;So;0;L;<square> 004B 004D;;;;N;SQUARED KM CAPITAL;;;;
33CF;SQUARE KT;So;0;L;<square> 006B 0074;;;;N;SQUARED KT;;;;
33D0;SQUARE LM;So;0;L;<square> 006C 006D;;;;N;SQUARED LM;;;;
33D1;SQUARE LN;So;0;L;<square> 006C 006E;;;;N;SQUARED LN;;;;
33D2;SQUARE LOG;So;0;L;<square> 006C 006F 0067;;;;N;SQUARED LOG;;;;
33D3;SQUARE LX;So;0;L;<square> 006C 0078;;;;N;SQUARED LX;;;;
33D4;SQUARE MB SMALL;So;0;L;<square> 006D 0062;;;;N;SQUARED MB SMALL;;;;
33D5;SQUARE MIL;So;0;L;<square> 006D 0069 006C;;;;N;SQUARED MIL;;;;
33D6;SQUARE MOL;So;0;L;<square> 006D 006F 006C;;;;N;SQUARED MOL;;;;
33D7;SQUARE PH;So;0;L;<square> 0050 0048;;;;N;SQUARED PH;;;;
33D8;SQUARE PM;So;0;L;<square> 0070 002E 006D 002E;;;;N;SQUARED PM;;;;
33D9;SQUARE PPM;So;0;L;<square> 0050 0050 004D;;;;N;SQUARED PPM;;;;
33DA;SQUARE PR;So;0;L;<square> 0050 0052;;;;N;SQUARED PR;;;;
33DB;SQUARE SR;So;0;L;<square> 0073 0072;;;;N;SQUARED SR;;;;
33DC;SQUARE SV;So;0;L;<square> 0053 0076;;;;N;SQUARED SV;;;;
33DD;SQUARE WB;So;0;L;<square> 0057 0062;;;;N;SQUARED WB;;;;
33DE;SQUARE V OVER M;So;0;ON;<square> 0056 2215 006D;;;;N;;;;;
33DF;SQUARE A OVER M;So;0;ON;<square> 0041 2215 006D;;;;N;;;;;
33E0;IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY ONE;So;0;L;<compat> 0031 65E5;;;;N;;;;;
33E1;IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWO;So;0;L;<compat> 0032 65E5;;;;N;;;;;
33E2;IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY THREE;So;0;L;<compat> 0033 65E5;;;;N;;;;;
33E3;IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY FOUR;So;0;L;<compat> 0034 65E5;;;;N;;;;;
33E4;IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY FIVE;So;0;L;<compat> 0035 65E5;;;;N;;;;;
33E5;IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY SIX;So;0;L;<compat> 0036 65E5;;;;N;;;;;
33E6;IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY SEVEN;So;0;L;<compat> 0037 65E5;;;;N;;;;;
33E7;IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY EIGHT;So;0;L;<compat> 0038 65E5;;;;N;;;;;
33E8;IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY NINE;So;0;L;<compat> 0039 65E5;;;;N;;;;;
33E9;IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TEN;So;0;L;<compat> 0031 0030 65E5;;;;N;;;;;
33EA;IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY ELEVEN;So;0;L;<compat> 0031 0031 65E5;;;;N;;;;;
33EB;IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWELVE;So;0;L;<compat> 0031 0032 65E5;;;;N;;;;;
33EC;IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY THIRTEEN;So;0;L;<compat> 0031 0033 65E5;;;;N;;;;;
33ED;IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY FOURTEEN;So;0;L;<compat> 0031 0034 65E5;;;;N;;;;;
33EE;IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY FIFTEEN;So;0;L;<compat> 0031 0035 65E5;;;;N;;;;;
33EF;IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY SIXTEEN;So;0;L;<compat> 0031 0036 65E5;;;;N;;;;;
33F0;IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY SEVENTEEN;So;0;L;<compat> 0031 0037 65E5;;;;N;;;;;
33F1;IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY EIGHTEEN;So;0;L;<compat> 0031 0038 65E5;;;;N;;;;;
33F2;IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY NINETEEN;So;0;L;<compat> 0031 0039 65E5;;;;N;;;;;
33F3;IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY;So;0;L;<compat> 0032 0030 65E5;;;;N;;;;;
33F4;IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-ONE;So;0;L;<compat> 0032 0031 65E5;;;;N;;;;;
33F5;IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-TWO;So;0;L;<compat> 0032 0032 65E5;;;;N;;;;;
33F6;IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-THREE;So;0;L;<compat> 0032 0033 65E5;;;;N;;;;;
33F7;IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-FOUR;So;0;L;<compat> 0032 0034 65E5;;;;N;;;;;
33F8;IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-FIVE;So;0;L;<compat> 0032 0035 65E5;;;;N;;;;;
33F9;IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-SIX;So;0;L;<compat> 0032 0036 65E5;;;;N;;;;;
33FA;IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-SEVEN;So;0;L;<compat> 0032 0037 65E5;;;;N;;;;;
33FB;IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-EIGHT;So;0;L;<compat> 0032 0038 65E5;;;;N;;;;;
33FC;IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY TWENTY-NINE;So;0;L;<compat> 0032 0039 65E5;;;;N;;;;;
33FD;IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY THIRTY;So;0;L;<compat> 0033 0030 65E5;;;;N;;;;;
33FE;IDEOGRAPHIC TELEGRAPH SYMBOL FOR DAY THIRTY-ONE;So;0;L;<compat> 0033 0031 65E5;;;;N;;;;;
33FF;SQUARE GAL;So;0;ON;<square> 0067 0061 006C;;;;N;;;;;
3400;<CJK Ideograph Extension A, First>;Lo;0;L;;;;;N;;;;;
4DBF;<CJK Ideograph Extension A, Last>;Lo;0;L;;;;;N;;;;;
4DC0;HEXAGRAM FOR THE CREATIVE HEAVEN;So;0;ON;;;;;N;;;;;
4DC1;HEXAGRAM FOR THE RECEPTIVE EARTH;So;0;ON;;;;;N;;;;;
4DC2;HEXAGRAM FOR DIFFICULTY AT THE BEGINNING;So;0;ON;;;;;N;;;;;
4DC3;HEXAGRAM FOR YOUTHFUL FOLLY;So;0;ON;;;;;N;;;;;
4DC4;HEXAGRAM FOR WAITING;So;0;ON;;;;;N;;;;;
4DC5;HEXAGRAM FOR CONFLICT;So;0;ON;;;;;N;;;;;
4DC6;HEXAGRAM FOR THE ARMY;So;0;ON;;;;;N;;;;;
4DC7;HEXAGRAM FOR HOLDING TOGETHER;So;0;ON;;;;;N;;;;;
4DC8;HEXAGRAM FOR SMALL TAMING;So;0;ON;;;;;N;;;;;
4DC9;HEXAGRAM FOR TREADING;So;0;ON;;;;;N;;;;;
4DCA;HEXAGRAM FOR PEACE;So;0;ON;;;;;N;;;;;
4DCB;HEXAGRAM FOR STANDSTILL;So;0;ON;;;;;N;;;;;
4DCC;HEXAGRAM FOR FELLOWSHIP;So;0;ON;;;;;N;;;;;
4DCD;HEXAGRAM FOR GREAT POSSESSION;So;0;ON;;;;;N;;;;;
4DCE;HEXAGRAM FOR MODESTY;So;0;ON;;;;;N;;;;;
4DCF;HEXAGRAM FOR ENTHUSIASM;So;0;ON;;;;;N;;;;;
4DD0;HEXAGRAM FOR FOLLOWING;So;0;ON;;;;;N;;;;;
4DD1;HEXAGRAM FOR WORK ON THE DECAYED;So;0;ON;;;;;N;;;;;
4DD2;HEXAGRAM FOR APPROACH;So;0;ON;;;;;N;;;;;
4DD3;HEXAGRAM FOR CONTEMPLATION;So;0;ON;;;;;N;;;;;
4DD4;HEXAGRAM FOR BITING THROUGH;So;0;ON;;;;;N;;;;;
4DD5;HEXAGRAM FOR GRACE;So;0;ON;;;;;N;;;;;
4DD6;HEXAGRAM FOR SPLITTING APART;So;0;ON;;;;;N;;;;;
4DD7;HEXAGRAM FOR RETURN;So;0;ON;;;;;N;;;;;
4DD8;HEXAGRAM FOR INNOCENCE;So;0;ON;;;;;N;;;;;
4DD9;HEXAGRAM FOR GREAT TAMING;So;0;ON;;;;;N;;;;;
4DDA;HEXAGRAM FOR MOUTH CORNERS;So;0;ON;;;;;N;;;;;
4DDB;HEXAGRAM FOR GREAT PREPONDERANCE;So;0;ON;;;;;N;;;;;
4DDC;HEXAGRAM FOR THE ABYSMAL WATER;So;0;ON;;;;;N;;;;;
4DDD;HEXAGRAM FOR THE CLINGING FIRE;So;0;ON;;;;;N;;;;;
4DDE;HEXAGRAM FOR INFLUENCE;So;0;ON;;;;;N;;;;;
4DDF;HEXAGRAM FOR DURATION;So;0;ON;;;;;N;;;;;
4DE0;HEXAGRAM FOR RETREAT;So;0;ON;;;;;N;;;;;
4DE1;HEXAGRAM FOR GREAT POWER;So;0;ON;;;;;N;;;;;
4DE2;HEXAGRAM FOR PROGRESS;So;0;ON;;;;;N;;;;;
4DE3;HEXAGRAM FOR DARKENING OF THE LIGHT;So;0;ON;;;;;N;;;;;
4DE4;HEXAGRAM FOR THE FAMILY;So;0;ON;;;;;N;;;;;
4DE5;HEXAGRAM FOR OPPOSITION;So;0;ON;;;;;N;;;;;
4DE6;HEXAGRAM FOR OBSTRUCTION;So;0;ON;;;;;N;;;;;
4DE7;HEXAGRAM FOR DELIVERANCE;So;0;ON;;;;;N;;;;;
4DE8;HEXAGRAM FOR DECREASE;So;0;ON;;;;;N;;;;;
4DE9;HEXAGRAM FOR INCREASE;So;0;ON;;;;;N;;;;;
4DEA;HEXAGRAM FOR BREAKTHROUGH;So;0;ON;;;;;N;;;;;
4DEB;HEXAGRAM FOR COMING TO MEET;So;0;ON;;;;;N;;;;;
4DEC;HEXAGRAM FOR GATHERING TOGETHER;So;0;ON;;;;;N;;;;;
4DED;HEXAGRAM FOR PUSHING UPWARD;So;0;ON;;;;;N;;;;;
4DEE;HEXAGRAM FOR OPPRESSION;So;0;ON;;;;;N;;;;;
4DEF;HEXAGRAM FOR THE WELL;So;0;ON;;;;;N;;;;;
4DF0;HEXAGRAM FOR REVOLUTION;So;0;ON;;;;;N;;;;;
4DF1;HEXAGRAM FOR THE CAULDRON;So;0;ON;;;;;N;;;;;
4DF2;HEXAGRAM FOR THE AROUSING THUNDER;So;0;ON;;;;;N;;;;;
4DF3;HEXAGRAM FOR THE KEEPING STILL MOUNTAIN;So;0;ON;;;;;N;;;;;
4DF4;HEXAGRAM FOR DEVELOPMENT;So;0;ON;;;;;N;;;;;
4DF5;HEXAGRAM FOR THE MARRYING MAIDEN;So;0;ON;;;;;N;;;;;
4DF6;HEXAGRAM FOR ABUNDANCE;So;0;ON;;;;;N;;;;;
4DF7;HEXAGRAM FOR THE WANDERER;So;0;ON;;;;;N;;;;;
4DF8;HEXAGRAM FOR THE GENTLE WIND;So;0;ON;;;;;N;;;;;
4DF9;HEXAGRAM FOR THE JOYOUS LAKE;So;0;ON;;;;;N;;;;;
4DFA;HEXAGRAM FOR DISPERSION;So;0;ON;;;;;N;;;;;
4DFB;HEXAGRAM FOR LIMITATION;So;0;ON;;;;;N;;;;;
4DFC;HEXAGRAM FOR INNER TRUTH;So;0;ON;;;;;N;;;;;
4DFD;HEXAGRAM FOR SMALL PREPONDERANCE;So;0;ON;;;;;N;;;;;
4DFE;HEXAGRAM FOR AFTER COMPLETION;So;0;ON;;;;;N;;;;;
4DFF;HEXAGRAM FOR BEFORE COMPLETION;So;0;ON;;;;;N;;;;;
4E00;<CJK Ideograph, First>;Lo;0;L;;;;;N;;;;;
9FFF;<CJK Ideograph, Last>;Lo;0;L;;;;;N;;;;;
A000;YI SYLLABLE IT;Lo;0;L;;;;;N;;;;;
A001;YI SYLLABLE IX;Lo;0;L;;;;;N;;;;;
A002;YI SYLLABLE I;Lo;0;L;;;;;N;;;;;
A003;YI SYLLABLE IP;Lo;0;L;;;;;N;;;;;
A004;YI SYLLABLE IET;Lo;0;L;;;;;N;;;;;
A005;YI SYLLABLE IEX;Lo;0;L;;;;;N;;;;;
A006;YI SYLLABLE IE;Lo;0;L;;;;;N;;;;;
A007;YI SYLLABLE IEP;Lo;0;L;;;;;N;;;;;
A008;YI SYLLABLE AT;Lo;0;L;;;;;N;;;;;
A009;YI SYLLABLE AX;Lo;0;L;;;;;N;;;;;
A00A;YI SYLLABLE A;Lo;0;L;;;;;N;;;;;
A00B;YI SYLLABLE AP;Lo;0;L;;;;;N;;;;;
A00C;YI SYLLABLE UOX;Lo;0;L;;;;;N;;;;;
A00D;YI SYLLABLE UO;Lo;0;L;;;;;N;;;;;
A00E;YI SYLLABLE UOP;Lo;0;L;;;;;N;;;;;
A00F;YI SYLLABLE OT;Lo;0;L;;;;;N;;;;;
A010;YI SYLLABLE OX;Lo;0;L;;;;;N;;;;;
A011;YI SYLLABLE O;Lo;0;L;;;;;N;;;;;
A012;YI SYLLABLE OP;Lo;0;L;;;;;N;;;;;
A013;YI SYLLABLE EX;Lo;0;L;;;;;N;;;;;
A014;YI SYLLABLE E;Lo;0;L;;;;;N;;;;;
A015;YI SYLLABLE WU;Lm;0;L;;;;;N;;;;;
A016;YI SYLLABLE BIT;Lo;0;L;;;;;N;;;;;
A017;YI SYLLABLE BIX;Lo;0;L;;;;;N;;;;;
A018;YI SYLLABLE BI;Lo;0;L;;;;;N;;;;;
A019;YI SYLLABLE BIP;Lo;0;L;;;;;N;;;;;
A01A;YI SYLLABLE BIET;Lo;0;L;;;;;N;;;;;
A01B;YI SYLLABLE BIEX;Lo;0;L;;;;;N;;;;;
A01C;YI SYLLABLE BIE;Lo;0;L;;;;;N;;;;;
A01D;YI SYLLABLE BIEP;Lo;0;L;;;;;N;;;;;
A01E;YI SYLLABLE BAT;Lo;0;L;;;;;N;;;;;
A01F;YI SYLLABLE BAX;Lo;0;L;;;;;N;;;;;
A020;YI SYLLABLE BA;Lo;0;L;;;;;N;;;;;
A021;YI SYLLABLE BAP;Lo;0;L;;;;;N;;;;;
A022;YI SYLLABLE BUOX;Lo;0;L;;;;;N;;;;;
A023;YI SYLLABLE BUO;Lo;0;L;;;;;N;;;;;
A024;YI SYLLABLE BUOP;Lo;0;L;;;;;N;;;;;
A025;YI SYLLABLE BOT;Lo;0;L;;;;;N;;;;;
A026;YI SYLLABLE BOX;Lo;0;L;;;;;N;;;;;
A027;YI SYLLABLE BO;Lo;0;L;;;;;N;;;;;
A028;YI SYLLABLE BOP;Lo;0;L;;;;;N;;;;;
A029;YI SYLLABLE BEX;Lo;0;L;;;;;N;;;;;
A02A;YI SYLLABLE BE;Lo;0;L;;;;;N;;;;;
A02B;YI SYLLABLE BEP;Lo;0;L;;;;;N;;;;;
A02C;YI SYLLABLE BUT;Lo;0;L;;;;;N;;;;;
A02D;YI SYLLABLE BUX;Lo;0;L;;;;;N;;;;;
A02E;YI SYLLABLE BU;Lo;0;L;;;;;N;;;;;
A02F;YI SYLLABLE BUP;Lo;0;L;;;;;N;;;;;
A030;YI SYLLABLE BURX;Lo;0;L;;;;;N;;;;;
A031;YI SYLLABLE BUR;Lo;0;L;;;;;N;;;;;
A032;YI SYLLABLE BYT;Lo;0;L;;;;;N;;;;;
A033;YI SYLLABLE BYX;Lo;0;L;;;;;N;;;;;
A034;YI SYLLABLE BY;Lo;0;L;;;;;N;;;;;
A035;YI SYLLABLE BYP;Lo;0;L;;;;;N;;;;;
A036;YI SYLLABLE BYRX;Lo;0;L;;;;;N;;;;;
A037;YI SYLLABLE BYR;Lo;0;L;;;;;N;;;;;
A038;YI SYLLABLE PIT;Lo;0;L;;;;;N;;;;;
A039;YI SYLLABLE PIX;Lo;0;L;;;;;N;;;;;
A03A;YI SYLLABLE PI;Lo;0;L;;;;;N;;;;;
A03B;YI SYLLABLE PIP;Lo;0;L;;;;;N;;;;;
A03C;YI SYLLABLE PIEX;Lo;0;L;;;;;N;;;;;
A03D;YI SYLLABLE PIE;Lo;0;L;;;;;N;;;;;
A03E;YI SYLLABLE PIEP;Lo;0;L;;;;;N;;;;;
A03F;YI SYLLABLE PAT;Lo;0;L;;;;;N;;;;;
A040;YI SYLLABLE PAX;Lo;0;L;;;;;N;;;;;
A041;YI SYLLABLE PA;Lo;0;L;;;;;N;;;;;
A042;YI SYLLABLE PAP;Lo;0;L;;;;;N;;;;;
A043;YI SYLLABLE PUOX;Lo;0;L;;;;;N;;;;;
A044;YI SYLLABLE PUO;Lo;0;L;;;;;N;;;;;
A045;YI SYLLABLE PUOP;Lo;0;L;;;;;N;;;;;
A046;YI SYLLABLE POT;Lo;0;L;;;;;N;;;;;
A047;YI SYLLABLE POX;Lo;0;L;;;;;N;;;;;
A048;YI SYLLABLE PO;Lo;0;L;;;;;N;;;;;
A049;YI SYLLABLE POP;Lo;0;L;;;;;N;;;;;
A04A;YI SYLLABLE PUT;Lo;0;L;;;;;N;;;;;
A04B;YI SYLLABLE PUX;Lo;0;L;;;;;N;;;;;
A04C;YI SYLLABLE PU;Lo;0;L;;;;;N;;;;;
A04D;YI SYLLABLE PUP;Lo;0;L;;;;;N;;;;;
A04E;YI SYLLABLE PURX;Lo;0;L;;;;;N;;;;;
A04F;YI SYLLABLE PUR;Lo;0;L;;;;;N;;;;;
A050;YI SYLLABLE PYT;Lo;0;L;;;;;N;;;;;
A051;YI SYLLABLE PYX;Lo;0;L;;;;;N;;;;;
A052;YI SYLLABLE PY;Lo;0;L;;;;;N;;;;;
A053;YI SYLLABLE PYP;Lo;0;L;;;;;N;;;;;
A054;YI SYLLABLE PYRX;Lo;0;L;;;;;N;;;;;
A055;YI SYLLABLE PYR;Lo;0;L;;;;;N;;;;;
A056;YI SYLLABLE BBIT;Lo;0;L;;;;;N;;;;;
A057;YI SYLLABLE BBIX;Lo;0;L;;;;;N;;;;;
A058;YI SYLLABLE BBI;Lo;0;L;;;;;N;;;;;
A059;YI SYLLABLE BBIP;Lo;0;L;;;;;N;;;;;
A05A;YI SYLLABLE BBIET;Lo;0;L;;;;;N;;;;;
A05B;YI SYLLABLE BBIEX;Lo;0;L;;;;;N;;;;;
A05C;YI SYLLABLE BBIE;Lo;0;L;;;;;N;;;;;
A05D;YI SYLLABLE BBIEP;Lo;0;L;;;;;N;;;;;
A05E;YI SYLLABLE BBAT;Lo;0;L;;;;;N;;;;;
A05F;YI SYLLABLE BBAX;Lo;0;L;;;;;N;;;;;
A060;YI SYLLABLE BBA;Lo;0;L;;;;;N;;;;;
A061;YI SYLLABLE BBAP;Lo;0;L;;;;;N;;;;;
A062;YI SYLLABLE BBUOX;Lo;0;L;;;;;N;;;;;
A063;YI SYLLABLE BBUO;Lo;0;L;;;;;N;;;;;
A064;YI SYLLABLE BBUOP;Lo;0;L;;;;;N;;;;;
A065;YI SYLLABLE BBOT;Lo;0;L;;;;;N;;;;;
A066;YI SYLLABLE BBOX;Lo;0;L;;;;;N;;;;;
A067;YI SYLLABLE BBO;Lo;0;L;;;;;N;;;;;
A068;YI SYLLABLE BBOP;Lo;0;L;;;;;N;;;;;
A069;YI SYLLABLE BBEX;Lo;0;L;;;;;N;;;;;
A06A;YI SYLLABLE BBE;Lo;0;L;;;;;N;;;;;
A06B;YI SYLLABLE BBEP;Lo;0;L;;;;;N;;;;;
A06C;YI SYLLABLE BBUT;Lo;0;L;;;;;N;;;;;
A06D;YI SYLLABLE BBUX;Lo;0;L;;;;;N;;;;;
A06E;YI SYLLABLE BBU;Lo;0;L;;;;;N;;;;;
A06F;YI SYLLABLE BBUP;Lo;0;L;;;;;N;;;;;
A070;YI SYLLABLE BBURX;Lo;0;L;;;;;N;;;;;
A071;YI SYLLABLE BBUR;Lo;0;L;;;;;N;;;;;
A072;YI SYLLABLE BBYT;Lo;0;L;;;;;N;;;;;
A073;YI SYLLABLE BBYX;Lo;0;L;;;;;N;;;;;
A074;YI SYLLABLE BBY;Lo;0;L;;;;;N;;;;;
A075;YI SYLLABLE BBYP;Lo;0;L;;;;;N;;;;;
A076;YI SYLLABLE NBIT;Lo;0;L;;;;;N;;;;;
A077;YI SYLLABLE NBIX;Lo;0;L;;;;;N;;;;;
A078;YI SYLLABLE NBI;Lo;0;L;;;;;N;;;;;
A079;YI SYLLABLE NBIP;Lo;0;L;;;;;N;;;;;
A07A;YI SYLLABLE NBIEX;Lo;0;L;;;;;N;;;;;
A07B;YI SYLLABLE NBIE;Lo;0;L;;;;;N;;;;;
A07C;YI SYLLABLE NBIEP;Lo;0;L;;;;;N;;;;;
A07D;YI SYLLABLE NBAT;Lo;0;L;;;;;N;;;;;
A07E;YI SYLLABLE NBAX;Lo;0;L;;;;;N;;;;;
A07F;YI SYLLABLE NBA;Lo;0;L;;;;;N;;;;;
A080;YI SYLLABLE NBAP;Lo;0;L;;;;;N;;;;;
A081;YI SYLLABLE NBOT;Lo;0;L;;;;;N;;;;;
A082;YI SYLLABLE NBOX;Lo;0;L;;;;;N;;;;;
A083;YI SYLLABLE NBO;Lo;0;L;;;;;N;;;;;
A084;YI SYLLABLE NBOP;Lo;0;L;;;;;N;;;;;
A085;YI SYLLABLE NBUT;Lo;0;L;;;;;N;;;;;
A086;YI SYLLABLE NBUX;Lo;0;L;;;;;N;;;;;
A087;YI SYLLABLE NBU;Lo;0;L;;;;;N;;;;;
A088;YI SYLLABLE NBUP;Lo;0;L;;;;;N;;;;;
A089;YI SYLLABLE NBURX;Lo;0;L;;;;;N;;;;;
A08A;YI SYLLABLE NBUR;Lo;0;L;;;;;N;;;;;
A08B;YI SYLLABLE NBYT;Lo;0;L;;;;;N;;;;;
A08C;YI SYLLABLE NBYX;Lo;0;L;;;;;N;;;;;
A08D;YI SYLLABLE NBY;Lo;0;L;;;;;N;;;;;
A08E;YI SYLLABLE NBYP;Lo;0;L;;;;;N;;;;;
A08F;YI SYLLABLE NBYRX;Lo;0;L;;;;;N;;;;;
A090;YI SYLLABLE NBYR;Lo;0;L;;;;;N;;;;;
A091;YI SYLLABLE HMIT;Lo;0;L;;;;;N;;;;;
A092;YI SYLLABLE HMIX;Lo;0;L;;;;;N;;;;;
A093;YI SYLLABLE HMI;Lo;0;L;;;;;N;;;;;
A094;YI SYLLABLE HMIP;Lo;0;L;;;;;N;;;;;
A095;YI SYLLABLE HMIEX;Lo;0;L;;;;;N;;;;;
A096;YI SYLLABLE HMIE;Lo;0;L;;;;;N;;;;;
A097;YI SYLLABLE HMIEP;Lo;0;L;;;;;N;;;;;
A098;YI SYLLABLE HMAT;Lo;0;L;;;;;N;;;;;
A099;YI SYLLABLE HMAX;Lo;0;L;;;;;N;;;;;
A09A;YI SYLLABLE HMA;Lo;0;L;;;;;N;;;;;
A09B;YI SYLLABLE HMAP;Lo;0;L;;;;;N;;;;;
A09C;YI SYLLABLE HMUOX;Lo;0;L;;;;;N;;;;;
A09D;YI SYLLABLE HMUO;Lo;0;L;;;;;N;;;;;
A09E;YI SYLLABLE HMUOP;Lo;0;L;;;;;N;;;;;
A09F;YI SYLLABLE HMOT;Lo;0;L;;;;;N;;;;;
A0A0;YI SYLLABLE HMOX;Lo;0;L;;;;;N;;;;;
A0A1;YI SYLLABLE HMO;Lo;0;L;;;;;N;;;;;
A0A2;YI SYLLABLE HMOP;Lo;0;L;;;;;N;;;;;
A0A3;YI SYLLABLE HMUT;Lo;0;L;;;;;N;;;;;
A0A4;YI SYLLABLE HMUX;Lo;0;L;;;;;N;;;;;
A0A5;YI SYLLABLE HMU;Lo;0;L;;;;;N;;;;;
A0A6;YI SYLLABLE HMUP;Lo;0;L;;;;;N;;;;;
A0A7;YI SYLLABLE HMURX;Lo;0;L;;;;;N;;;;;
A0A8;YI SYLLABLE HMUR;Lo;0;L;;;;;N;;;;;
A0A9;YI SYLLABLE HMYX;Lo;0;L;;;;;N;;;;;
A0AA;YI SYLLABLE HMY;Lo;0;L;;;;;N;;;;;
A0AB;YI SYLLABLE HMYP;Lo;0;L;;;;;N;;;;;
A0AC;YI SYLLABLE HMYRX;Lo;0;L;;;;;N;;;;;
A0AD;YI SYLLABLE HMYR;Lo;0;L;;;;;N;;;;;
A0AE;YI SYLLABLE MIT;Lo;0;L;;;;;N;;;;;
A0AF;YI SYLLABLE MIX;Lo;0;L;;;;;N;;;;;
A0B0;YI SYLLABLE MI;Lo;0;L;;;;;N;;;;;
A0B1;YI SYLLABLE MIP;Lo;0;L;;;;;N;;;;;
A0B2;YI SYLLABLE MIEX;Lo;0;L;;;;;N;;;;;
A0B3;YI SYLLABLE MIE;Lo;0;L;;;;;N;;;;;
A0B4;YI SYLLABLE MIEP;Lo;0;L;;;;;N;;;;;
A0B5;YI SYLLABLE MAT;Lo;0;L;;;;;N;;;;;
A0B6;YI SYLLABLE MAX;Lo;0;L;;;;;N;;;;;
A0B7;YI SYLLABLE MA;Lo;0;L;;;;;N;;;;;
A0B8;YI SYLLABLE MAP;Lo;0;L;;;;;N;;;;;
A0B9;YI SYLLABLE MUOT;Lo;0;L;;;;;N;;;;;
A0BA;YI SYLLABLE MUOX;Lo;0;L;;;;;N;;;;;
A0BB;YI SYLLABLE MUO;Lo;0;L;;;;;N;;;;;
A0BC;YI SYLLABLE MUOP;Lo;0;L;;;;;N;;;;;
A0BD;YI SYLLABLE MOT;Lo;0;L;;;;;N;;;;;
A0BE;YI SYLLABLE MOX;Lo;0;L;;;;;N;;;;;
A0BF;YI SYLLABLE MO;Lo;0;L;;;;;N;;;;;
A0C0;YI SYLLABLE MOP;Lo;0;L;;;;;N;;;;;
A0C1;YI SYLLABLE MEX;Lo;0;L;;;;;N;;;;;
A0C2;YI SYLLABLE ME;Lo;0;L;;;;;N;;;;;
A0C3;YI SYLLABLE MUT;Lo;0;L;;;;;N;;;;;
A0C4;YI SYLLABLE MUX;Lo;0;L;;;;;N;;;;;
A0C5;YI SYLLABLE MU;Lo;0;L;;;;;N;;;;;
A0C6;YI SYLLABLE MUP;Lo;0;L;;;;;N;;;;;
A0C7;YI SYLLABLE MURX;Lo;0;L;;;;;N;;;;;
A0C8;YI SYLLABLE MUR;Lo;0;L;;;;;N;;;;;
A0C9;YI SYLLABLE MYT;Lo;0;L;;;;;N;;;;;
A0CA;YI SYLLABLE MYX;Lo;0;L;;;;;N;;;;;
A0CB;YI SYLLABLE MY;Lo;0;L;;;;;N;;;;;
A0CC;YI SYLLABLE MYP;Lo;0;L;;;;;N;;;;;
A0CD;YI SYLLABLE FIT;Lo;0;L;;;;;N;;;;;
A0CE;YI SYLLABLE FIX;Lo;0;L;;;;;N;;;;;
A0CF;YI SYLLABLE FI;Lo;0;L;;;;;N;;;;;
A0D0;YI SYLLABLE FIP;Lo;0;L;;;;;N;;;;;
A0D1;YI SYLLABLE FAT;Lo;0;L;;;;;N;;;;;
A0D2;YI SYLLABLE FAX;Lo;0;L;;;;;N;;;;;
A0D3;YI SYLLABLE FA;Lo;0;L;;;;;N;;;;;
A0D4;YI SYLLABLE FAP;Lo;0;L;;;;;N;;;;;
A0D5;YI SYLLABLE FOX;Lo;0;L;;;;;N;;;;;
A0D6;YI SYLLABLE FO;Lo;0;L;;;;;N;;;;;
A0D7;YI SYLLABLE FOP;Lo;0;L;;;;;N;;;;;
A0D8;YI SYLLABLE FUT;Lo;0;L;;;;;N;;;;;
A0D9;YI SYLLABLE FUX;Lo;0;L;;;;;N;;;;;
A0DA;YI SYLLABLE FU;Lo;0;L;;;;;N;;;;;
A0DB;YI SYLLABLE FUP;Lo;0;L;;;;;N;;;;;
A0DC;YI SYLLABLE FURX;Lo;0;L;;;;;N;;;;;
A0DD;YI SYLLABLE FUR;Lo;0;L;;;;;N;;;;;
A0DE;YI SYLLABLE FYT;Lo;0;L;;;;;N;;;;;
A0DF;YI SYLLABLE FYX;Lo;0;L;;;;;N;;;;;
A0E0;YI SYLLABLE FY;Lo;0;L;;;;;N;;;;;
A0E1;YI SYLLABLE FYP;Lo;0;L;;;;;N;;;;;
A0E2;YI SYLLABLE VIT;Lo;0;L;;;;;N;;;;;
A0E3;YI SYLLABLE VIX;Lo;0;L;;;;;N;;;;;
A0E4;YI SYLLABLE VI;Lo;0;L;;;;;N;;;;;
A0E5;YI SYLLABLE VIP;Lo;0;L;;;;;N;;;;;
A0E6;YI SYLLABLE VIET;Lo;0;L;;;;;N;;;;;
A0E7;YI SYLLABLE VIEX;Lo;0;L;;;;;N;;;;;
A0E8;YI SYLLABLE VIE;Lo;0;L;;;;;N;;;;;
A0E9;YI SYLLABLE VIEP;Lo;0;L;;;;;N;;;;;
A0EA;YI SYLLABLE VAT;Lo;0;L;;;;;N;;;;;
A0EB;YI SYLLABLE VAX;Lo;0;L;;;;;N;;;;;
A0EC;YI SYLLABLE VA;Lo;0;L;;;;;N;;;;;
A0ED;YI SYLLABLE VAP;Lo;0;L;;;;;N;;;;;
A0EE;YI SYLLABLE VOT;Lo;0;L;;;;;N;;;;;
A0EF;YI SYLLABLE VOX;Lo;0;L;;;;;N;;;;;
A0F0;YI SYLLABLE VO;Lo;0;L;;;;;N;;;;;
A0F1;YI SYLLABLE VOP;Lo;0;L;;;;;N;;;;;
A0F2;YI SYLLABLE VEX;Lo;0;L;;;;;N;;;;;
A0F3;YI SYLLABLE VEP;Lo;0;L;;;;;N;;;;;
A0F4;YI SYLLABLE VUT;Lo;0;L;;;;;N;;;;;
A0F5;YI SYLLABLE VUX;Lo;0;L;;;;;N;;;;;
A0F6;YI SYLLABLE VU;Lo;0;L;;;;;N;;;;;
A0F7;YI SYLLABLE VUP;Lo;0;L;;;;;N;;;;;
A0F8;YI SYLLABLE VURX;Lo;0;L;;;;;N;;;;;
A0F9;YI SYLLABLE VUR;Lo;0;L;;;;;N;;;;;
A0FA;YI SYLLABLE VYT;Lo;0;L;;;;;N;;;;;
A0FB;YI SYLLABLE VYX;Lo;0;L;;;;;N;;;;;
A0FC;YI SYLLABLE VY;Lo;0;L;;;;;N;;;;;
A0FD;YI SYLLABLE VYP;Lo;0;L;;;;;N;;;;;
A0FE;YI SYLLABLE VYRX;Lo;0;L;;;;;N;;;;;
A0FF;YI SYLLABLE VYR;Lo;0;L;;;;;N;;;;;
A100;YI SYLLABLE DIT;Lo;0;L;;;;;N;;;;;
A101;YI SYLLABLE DIX;Lo;0;L;;;;;N;;;;;
A102;YI SYLLABLE DI;Lo;0;L;;;;;N;;;;;
A103;YI SYLLABLE DIP;Lo;0;L;;;;;N;;;;;
A104;YI SYLLABLE DIEX;Lo;0;L;;;;;N;;;;;
A105;YI SYLLABLE DIE;Lo;0;L;;;;;N;;;;;
A106;YI SYLLABLE DIEP;Lo;0;L;;;;;N;;;;;
A107;YI SYLLABLE DAT;Lo;0;L;;;;;N;;;;;
A108;YI SYLLABLE DAX;Lo;0;L;;;;;N;;;;;
A109;YI SYLLABLE DA;Lo;0;L;;;;;N;;;;;
A10A;YI SYLLABLE DAP;Lo;0;L;;;;;N;;;;;
A10B;YI SYLLABLE DUOX;Lo;0;L;;;;;N;;;;;
A10C;YI SYLLABLE DUO;Lo;0;L;;;;;N;;;;;
A10D;YI SYLLABLE DOT;Lo;0;L;;;;;N;;;;;
A10E;YI SYLLABLE DOX;Lo;0;L;;;;;N;;;;;
A10F;YI SYLLABLE DO;Lo;0;L;;;;;N;;;;;
A110;YI SYLLABLE DOP;Lo;0;L;;;;;N;;;;;
A111;YI SYLLABLE DEX;Lo;0;L;;;;;N;;;;;
A112;YI SYLLABLE DE;Lo;0;L;;;;;N;;;;;
A113;YI SYLLABLE DEP;Lo;0;L;;;;;N;;;;;
A114;YI SYLLABLE DUT;Lo;0;L;;;;;N;;;;;
A115;YI SYLLABLE DUX;Lo;0;L;;;;;N;;;;;
A116;YI SYLLABLE DU;Lo;0;L;;;;;N;;;;;
A117;YI SYLLABLE DUP;Lo;0;L;;;;;N;;;;;
A118;YI SYLLABLE DURX;Lo;0;L;;;;;N;;;;;
A119;YI SYLLABLE DUR;Lo;0;L;;;;;N;;;;;
A11A;YI SYLLABLE TIT;Lo;0;L;;;;;N;;;;;
A11B;YI SYLLABLE TIX;Lo;0;L;;;;;N;;;;;
A11C;YI SYLLABLE TI;Lo;0;L;;;;;N;;;;;
A11D;YI SYLLABLE TIP;Lo;0;L;;;;;N;;;;;
A11E;YI SYLLABLE TIEX;Lo;0;L;;;;;N;;;;;
A11F;YI SYLLABLE TIE;Lo;0;L;;;;;N;;;;;
A120;YI SYLLABLE TIEP;Lo;0;L;;;;;N;;;;;
A121;YI SYLLABLE TAT;Lo;0;L;;;;;N;;;;;
A122;YI SYLLABLE TAX;Lo;0;L;;;;;N;;;;;
A123;YI SYLLABLE TA;Lo;0;L;;;;;N;;;;;
A124;YI SYLLABLE TAP;Lo;0;L;;;;;N;;;;;
A125;YI SYLLABLE TUOT;Lo;0;L;;;;;N;;;;;
A126;YI SYLLABLE TUOX;Lo;0;L;;;;;N;;;;;
A127;YI SYLLABLE TUO;Lo;0;L;;;;;N;;;;;
A128;YI SYLLABLE TUOP;Lo;0;L;;;;;N;;;;;
A129;YI SYLLABLE TOT;Lo;0;L;;;;;N;;;;;
A12A;YI SYLLABLE TOX;Lo;0;L;;;;;N;;;;;
A12B;YI SYLLABLE TO;Lo;0;L;;;;;N;;;;;
A12C;YI SYLLABLE TOP;Lo;0;L;;;;;N;;;;;
A12D;YI SYLLABLE TEX;Lo;0;L;;;;;N;;;;;
A12E;YI SYLLABLE TE;Lo;0;L;;;;;N;;;;;
A12F;YI SYLLABLE TEP;Lo;0;L;;;;;N;;;;;
A130;YI SYLLABLE TUT;Lo;0;L;;;;;N;;;;;
A131;YI SYLLABLE TUX;Lo;0;L;;;;;N;;;;;
A132;YI SYLLABLE TU;Lo;0;L;;;;;N;;;;;
A133;YI SYLLABLE TUP;Lo;0;L;;;;;N;;;;;
A134;YI SYLLABLE TURX;Lo;0;L;;;;;N;;;;;
A135;YI SYLLABLE TUR;Lo;0;L;;;;;N;;;;;
A136;YI SYLLABLE DDIT;Lo;0;L;;;;;N;;;;;
A137;YI SYLLABLE DDIX;Lo;0;L;;;;;N;;;;;
A138;YI SYLLABLE DDI;Lo;0;L;;;;;N;;;;;
A139;YI SYLLABLE DDIP;Lo;0;L;;;;;N;;;;;
A13A;YI SYLLABLE DDIEX;Lo;0;L;;;;;N;;;;;
A13B;YI SYLLABLE DDIE;Lo;0;L;;;;;N;;;;;
A13C;YI SYLLABLE DDIEP;Lo;0;L;;;;;N;;;;;
A13D;YI SYLLABLE DDAT;Lo;0;L;;;;;N;;;;;
A13E;YI SYLLABLE DDAX;Lo;0;L;;;;;N;;;;;
A13F;YI SYLLABLE DDA;Lo;0;L;;;;;N;;;;;
A140;YI SYLLABLE DDAP;Lo;0;L;;;;;N;;;;;
A141;YI SYLLABLE DDUOX;Lo;0;L;;;;;N;;;;;
A142;YI SYLLABLE DDUO;Lo;0;L;;;;;N;;;;;
A143;YI SYLLABLE DDUOP;Lo;0;L;;;;;N;;;;;
A144;YI SYLLABLE DDOT;Lo;0;L;;;;;N;;;;;
A145;YI SYLLABLE DDOX;Lo;0;L;;;;;N;;;;;
A146;YI SYLLABLE DDO;Lo;0;L;;;;;N;;;;;
A147;YI SYLLABLE DDOP;Lo;0;L;;;;;N;;;;;
A148;YI SYLLABLE DDEX;Lo;0;L;;;;;N;;;;;
A149;YI SYLLABLE DDE;Lo;0;L;;;;;N;;;;;
A14A;YI SYLLABLE DDEP;Lo;0;L;;;;;N;;;;;
A14B;YI SYLLABLE DDUT;Lo;0;L;;;;;N;;;;;
A14C;YI SYLLABLE DDUX;Lo;0;L;;;;;N;;;;;
A14D;YI SYLLABLE DDU;Lo;0;L;;;;;N;;;;;
A14E;YI SYLLABLE DDUP;Lo;0;L;;;;;N;;;;;
A14F;YI SYLLABLE DDURX;Lo;0;L;;;;;N;;;;;
A150;YI SYLLABLE DDUR;Lo;0;L;;;;;N;;;;;
A151;YI SYLLABLE NDIT;Lo;0;L;;;;;N;;;;;
A152;YI SYLLABLE NDIX;Lo;0;L;;;;;N;;;;;
A153;YI SYLLABLE NDI;Lo;0;L;;;;;N;;;;;
A154;YI SYLLABLE NDIP;Lo;0;L;;;;;N;;;;;
A155;YI SYLLABLE NDIEX;Lo;0;L;;;;;N;;;;;
A156;YI SYLLABLE NDIE;Lo;0;L;;;;;N;;;;;
A157;YI SYLLABLE NDAT;Lo;0;L;;;;;N;;;;;
A158;YI SYLLABLE NDAX;Lo;0;L;;;;;N;;;;;
A159;YI SYLLABLE NDA;Lo;0;L;;;;;N;;;;;
A15A;YI SYLLABLE NDAP;Lo;0;L;;;;;N;;;;;
A15B;YI SYLLABLE NDOT;Lo;0;L;;;;;N;;;;;
A15C;YI SYLLABLE NDOX;Lo;0;L;;;;;N;;;;;
A15D;YI SYLLABLE NDO;Lo;0;L;;;;;N;;;;;
A15E;YI SYLLABLE NDOP;Lo;0;L;;;;;N;;;;;
A15F;YI SYLLABLE NDEX;Lo;0;L;;;;;N;;;;;
A160;YI SYLLABLE NDE;Lo;0;L;;;;;N;;;;;
A161;YI SYLLABLE NDEP;Lo;0;L;;;;;N;;;;;
A162;YI SYLLABLE NDUT;Lo;0;L;;;;;N;;;;;
A163;YI SYLLABLE NDUX;Lo;0;L;;;;;N;;;;;
A164;YI SYLLABLE NDU;Lo;0;L;;;;;N;;;;;
A165;YI SYLLABLE NDUP;Lo;0;L;;;;;N;;;;;
A166;YI SYLLABLE NDURX;Lo;0;L;;;;;N;;;;;
A167;YI SYLLABLE NDUR;Lo;0;L;;;;;N;;;;;
A168;YI SYLLABLE HNIT;Lo;0;L;;;;;N;;;;;
A169;YI SYLLABLE HNIX;Lo;0;L;;;;;N;;;;;
A16A;YI SYLLABLE HNI;Lo;0;L;;;;;N;;;;;
A16B;YI SYLLABLE HNIP;Lo;0;L;;;;;N;;;;;
A16C;YI SYLLABLE HNIET;Lo;0;L;;;;;N;;;;;
A16D;YI SYLLABLE HNIEX;Lo;0;L;;;;;N;;;;;
A16E;YI SYLLABLE HNIE;Lo;0;L;;;;;N;;;;;
A16F;YI SYLLABLE HNIEP;Lo;0;L;;;;;N;;;;;
A170;YI SYLLABLE HNAT;Lo;0;L;;;;;N;;;;;
A171;YI SYLLABLE HNAX;Lo;0;L;;;;;N;;;;;
A172;YI SYLLABLE HNA;Lo;0;L;;;;;N;;;;;
A173;YI SYLLABLE HNAP;Lo;0;L;;;;;N;;;;;
A174;YI SYLLABLE HNUOX;Lo;0;L;;;;;N;;;;;
A175;YI SYLLABLE HNUO;Lo;0;L;;;;;N;;;;;
A176;YI SYLLABLE HNOT;Lo;0;L;;;;;N;;;;;
A177;YI SYLLABLE HNOX;Lo;0;L;;;;;N;;;;;
A178;YI SYLLABLE HNOP;Lo;0;L;;;;;N;;;;;
A179;YI SYLLABLE HNEX;Lo;0;L;;;;;N;;;;;
A17A;YI SYLLABLE HNE;Lo;0;L;;;;;N;;;;;
A17B;YI SYLLABLE HNEP;Lo;0;L;;;;;N;;;;;
A17C;YI SYLLABLE HNUT;Lo;0;L;;;;;N;;;;;
A17D;YI SYLLABLE NIT;Lo;0;L;;;;;N;;;;;
A17E;YI SYLLABLE NIX;Lo;0;L;;;;;N;;;;;
A17F;YI SYLLABLE NI;Lo;0;L;;;;;N;;;;;
A180;YI SYLLABLE NIP;Lo;0;L;;;;;N;;;;;
A181;YI SYLLABLE NIEX;Lo;0;L;;;;;N;;;;;
A182;YI SYLLABLE NIE;Lo;0;L;;;;;N;;;;;
A183;YI SYLLABLE NIEP;Lo;0;L;;;;;N;;;;;
A184;YI SYLLABLE NAX;Lo;0;L;;;;;N;;;;;
A185;YI SYLLABLE NA;Lo;0;L;;;;;N;;;;;
A186;YI SYLLABLE NAP;Lo;0;L;;;;;N;;;;;
A187;YI SYLLABLE NUOX;Lo;0;L;;;;;N;;;;;
A188;YI SYLLABLE NUO;Lo;0;L;;;;;N;;;;;
A189;YI SYLLABLE NUOP;Lo;0;L;;;;;N;;;;;
A18A;YI SYLLABLE NOT;Lo;0;L;;;;;N;;;;;
A18B;YI SYLLABLE NOX;Lo;0;L;;;;;N;;;;;
A18C;YI SYLLABLE NO;Lo;0;L;;;;;N;;;;;
A18D;YI SYLLABLE NOP;Lo;0;L;;;;;N;;;;;
A18E;YI SYLLABLE NEX;Lo;0;L;;;;;N;;;;;
A18F;YI SYLLABLE NE;Lo;0;L;;;;;N;;;;;
A190;YI SYLLABLE NEP;Lo;0;L;;;;;N;;;;;
A191;YI SYLLABLE NUT;Lo;0;L;;;;;N;;;;;
A192;YI SYLLABLE NUX;Lo;0;L;;;;;N;;;;;
A193;YI SYLLABLE NU;Lo;0;L;;;;;N;;;;;
A194;YI SYLLABLE NUP;Lo;0;L;;;;;N;;;;;
A195;YI SYLLABLE NURX;Lo;0;L;;;;;N;;;;;
A196;YI SYLLABLE NUR;Lo;0;L;;;;;N;;;;;
A197;YI SYLLABLE HLIT;Lo;0;L;;;;;N;;;;;
A198;YI SYLLABLE HLIX;Lo;0;L;;;;;N;;;;;
A199;YI SYLLABLE HLI;Lo;0;L;;;;;N;;;;;
A19A;YI SYLLABLE HLIP;Lo;0;L;;;;;N;;;;;
A19B;YI SYLLABLE HLIEX;Lo;0;L;;;;;N;;;;;
A19C;YI SYLLABLE HLIE;Lo;0;L;;;;;N;;;;;
A19D;YI SYLLABLE HLIEP;Lo;0;L;;;;;N;;;;;
A19E;YI SYLLABLE HLAT;Lo;0;L;;;;;N;;;;;
A19F;YI SYLLABLE HLAX;Lo;0;L;;;;;N;;;;;
A1A0;YI SYLLABLE HLA;Lo;0;L;;;;;N;;;;;
A1A1;YI SYLLABLE HLAP;Lo;0;L;;;;;N;;;;;
A1A2;YI SYLLABLE HLUOX;Lo;0;L;;;;;N;;;;;
A1A3;YI SYLLABLE HLUO;Lo;0;L;;;;;N;;;;;
A1A4;YI SYLLABLE HLUOP;Lo;0;L;;;;;N;;;;;
A1A5;YI SYLLABLE HLOX;Lo;0;L;;;;;N;;;;;
A1A6;YI SYLLABLE HLO;Lo;0;L;;;;;N;;;;;
A1A7;YI SYLLABLE HLOP;Lo;0;L;;;;;N;;;;;
A1A8;YI SYLLABLE HLEX;Lo;0;L;;;;;N;;;;;
A1A9;YI SYLLABLE HLE;Lo;0;L;;;;;N;;;;;
A1AA;YI SYLLABLE HLEP;Lo;0;L;;;;;N;;;;;
A1AB;YI SYLLABLE HLUT;Lo;0;L;;;;;N;;;;;
A1AC;YI SYLLABLE HLUX;Lo;0;L;;;;;N;;;;;
A1AD;YI SYLLABLE HLU;Lo;0;L;;;;;N;;;;;
A1AE;YI SYLLABLE HLUP;Lo;0;L;;;;;N;;;;;
A1AF;YI SYLLABLE HLURX;Lo;0;L;;;;;N;;;;;
A1B0;YI SYLLABLE HLUR;Lo;0;L;;;;;N;;;;;
A1B1;YI SYLLABLE HLYT;Lo;0;L;;;;;N;;;;;
A1B2;YI SYLLABLE HLYX;Lo;0;L;;;;;N;;;;;
A1B3;YI SYLLABLE HLY;Lo;0;L;;;;;N;;;;;
A1B4;YI SYLLABLE HLYP;Lo;0;L;;;;;N;;;;;
A1B5;YI SYLLABLE HLYRX;Lo;0;L;;;;;N;;;;;
A1B6;YI SYLLABLE HLYR;Lo;0;L;;;;;N;;;;;
A1B7;YI SYLLABLE LIT;Lo;0;L;;;;;N;;;;;
A1B8;YI SYLLABLE LIX;Lo;0;L;;;;;N;;;;;
A1B9;YI SYLLABLE LI;Lo;0;L;;;;;N;;;;;
A1BA;YI SYLLABLE LIP;Lo;0;L;;;;;N;;;;;
A1BB;YI SYLLABLE LIET;Lo;0;L;;;;;N;;;;;
A1BC;YI SYLLABLE LIEX;Lo;0;L;;;;;N;;;;;
A1BD;YI SYLLABLE LIE;Lo;0;L;;;;;N;;;;;
A1BE;YI SYLLABLE LIEP;Lo;0;L;;;;;N;;;;;
A1BF;YI SYLLABLE LAT;Lo;0;L;;;;;N;;;;;
A1C0;YI SYLLABLE LAX;Lo;0;L;;;;;N;;;;;
A1C1;YI SYLLABLE LA;Lo;0;L;;;;;N;;;;;
A1C2;YI SYLLABLE LAP;Lo;0;L;;;;;N;;;;;
A1C3;YI SYLLABLE LUOT;Lo;0;L;;;;;N;;;;;
A1C4;YI SYLLABLE LUOX;Lo;0;L;;;;;N;;;;;
A1C5;YI SYLLABLE LUO;Lo;0;L;;;;;N;;;;;
A1C6;YI SYLLABLE LUOP;Lo;0;L;;;;;N;;;;;
A1C7;YI SYLLABLE LOT;Lo;0;L;;;;;N;;;;;
A1C8;YI SYLLABLE LOX;Lo;0;L;;;;;N;;;;;
A1C9;YI SYLLABLE LO;Lo;0;L;;;;;N;;;;;
A1CA;YI SYLLABLE LOP;Lo;0;L;;;;;N;;;;;
A1CB;YI SYLLABLE LEX;Lo;0;L;;;;;N;;;;;
A1CC;YI SYLLABLE LE;Lo;0;L;;;;;N;;;;;
A1CD;YI SYLLABLE LEP;Lo;0;L;;;;;N;;;;;
A1CE;YI SYLLABLE LUT;Lo;0;L;;;;;N;;;;;
A1CF;YI SYLLABLE LUX;Lo;0;L;;;;;N;;;;;
A1D0;YI SYLLABLE LU;Lo;0;L;;;;;N;;;;;
A1D1;YI SYLLABLE LUP;Lo;0;L;;;;;N;;;;;
A1D2;YI SYLLABLE LURX;Lo;0;L;;;;;N;;;;;
A1D3;YI SYLLABLE LUR;Lo;0;L;;;;;N;;;;;
A1D4;YI SYLLABLE LYT;Lo;0;L;;;;;N;;;;;
A1D5;YI SYLLABLE LYX;Lo;0;L;;;;;N;;;;;
A1D6;YI SYLLABLE LY;Lo;0;L;;;;;N;;;;;
A1D7;YI SYLLABLE LYP;Lo;0;L;;;;;N;;;;;
A1D8;YI SYLLABLE LYRX;Lo;0;L;;;;;N;;;;;
A1D9;YI SYLLABLE LYR;Lo;0;L;;;;;N;;;;;
A1DA;YI SYLLABLE GIT;Lo;0;L;;;;;N;;;;;
A1DB;YI SYLLABLE GIX;Lo;0;L;;;;;N;;;;;
A1DC;YI SYLLABLE GI;Lo;0;L;;;;;N;;;;;
A1DD;YI SYLLABLE GIP;Lo;0;L;;;;;N;;;;;
A1DE;YI SYLLABLE GIET;Lo;0;L;;;;;N;;;;;
A1DF;YI SYLLABLE GIEX;Lo;0;L;;;;;N;;;;;
A1E0;YI SYLLABLE GIE;Lo;0;L;;;;;N;;;;;
A1E1;YI SYLLABLE GIEP;Lo;0;L;;;;;N;;;;;
A1E2;YI SYLLABLE GAT;Lo;0;L;;;;;N;;;;;
A1E3;YI SYLLABLE GAX;Lo;0;L;;;;;N;;;;;
A1E4;YI SYLLABLE GA;Lo;0;L;;;;;N;;;;;
A1E5;YI SYLLABLE GAP;Lo;0;L;;;;;N;;;;;
A1E6;YI SYLLABLE GUOT;Lo;0;L;;;;;N;;;;;
A1E7;YI SYLLABLE GUOX;Lo;0;L;;;;;N;;;;;
A1E8;YI SYLLABLE GUO;Lo;0;L;;;;;N;;;;;
A1E9;YI SYLLABLE GUOP;Lo;0;L;;;;;N;;;;;
A1EA;YI SYLLABLE GOT;Lo;0;L;;;;;N;;;;;
A1EB;YI SYLLABLE GOX;Lo;0;L;;;;;N;;;;;
A1EC;YI SYLLABLE GO;Lo;0;L;;;;;N;;;;;
A1ED;YI SYLLABLE GOP;Lo;0;L;;;;;N;;;;;
A1EE;YI SYLLABLE GET;Lo;0;L;;;;;N;;;;;
A1EF;YI SYLLABLE GEX;Lo;0;L;;;;;N;;;;;
A1F0;YI SYLLABLE GE;Lo;0;L;;;;;N;;;;;
A1F1;YI SYLLABLE GEP;Lo;0;L;;;;;N;;;;;
A1F2;YI SYLLABLE GUT;Lo;0;L;;;;;N;;;;;
A1F3;YI SYLLABLE GUX;Lo;0;L;;;;;N;;;;;
A1F4;YI SYLLABLE GU;Lo;0;L;;;;;N;;;;;
A1F5;YI SYLLABLE GUP;Lo;0;L;;;;;N;;;;;
A1F6;YI SYLLABLE GURX;Lo;0;L;;;;;N;;;;;
A1F7;YI SYLLABLE GUR;Lo;0;L;;;;;N;;;;;
A1F8;YI SYLLABLE KIT;Lo;0;L;;;;;N;;;;;
A1F9;YI SYLLABLE KIX;Lo;0;L;;;;;N;;;;;
A1FA;YI SYLLABLE KI;Lo;0;L;;;;;N;;;;;
A1FB;YI SYLLABLE KIP;Lo;0;L;;;;;N;;;;;
A1FC;YI SYLLABLE KIEX;Lo;0;L;;;;;N;;;;;
A1FD;YI SYLLABLE KIE;Lo;0;L;;;;;N;;;;;
A1FE;YI SYLLABLE KIEP;Lo;0;L;;;;;N;;;;;
A1FF;YI SYLLABLE KAT;Lo;0;L;;;;;N;;;;;
A200;YI SYLLABLE KAX;Lo;0;L;;;;;N;;;;;
A201;YI SYLLABLE KA;Lo;0;L;;;;;N;;;;;
A202;YI SYLLABLE KAP;Lo;0;L;;;;;N;;;;;
A203;YI SYLLABLE KUOX;Lo;0;L;;;;;N;;;;;
A204;YI SYLLABLE KUO;Lo;0;L;;;;;N;;;;;
A205;YI SYLLABLE KUOP;Lo;0;L;;;;;N;;;;;
A206;YI SYLLABLE KOT;Lo;0;L;;;;;N;;;;;
A207;YI SYLLABLE KOX;Lo;0;L;;;;;N;;;;;
A208;YI SYLLABLE KO;Lo;0;L;;;;;N;;;;;
A209;YI SYLLABLE KOP;Lo;0;L;;;;;N;;;;;
A20A;YI SYLLABLE KET;Lo;0;L;;;;;N;;;;;
A20B;YI SYLLABLE KEX;Lo;0;L;;;;;N;;;;;
A20C;YI SYLLABLE KE;Lo;0;L;;;;;N;;;;;
A20D;YI SYLLABLE KEP;Lo;0;L;;;;;N;;;;;
A20E;YI SYLLABLE KUT;Lo;0;L;;;;;N;;;;;
A20F;YI SYLLABLE KUX;Lo;0;L;;;;;N;;;;;
A210;YI SYLLABLE KU;Lo;0;L;;;;;N;;;;;
A211;YI SYLLABLE KUP;Lo;0;L;;;;;N;;;;;
A212;YI SYLLABLE KURX;Lo;0;L;;;;;N;;;;;
A213;YI SYLLABLE KUR;Lo;0;L;;;;;N;;;;;
A214;YI SYLLABLE GGIT;Lo;0;L;;;;;N;;;;;
A215;YI SYLLABLE GGIX;Lo;0;L;;;;;N;;;;;
A216;YI SYLLABLE GGI;Lo;0;L;;;;;N;;;;;
A217;YI SYLLABLE GGIEX;Lo;0;L;;;;;N;;;;;
A218;YI SYLLABLE GGIE;Lo;0;L;;;;;N;;;;;
A219;YI SYLLABLE GGIEP;Lo;0;L;;;;;N;;;;;
A21A;YI SYLLABLE GGAT;Lo;0;L;;;;;N;;;;;
A21B;YI SYLLABLE GGAX;Lo;0;L;;;;;N;;;;;
A21C;YI SYLLABLE GGA;Lo;0;L;;;;;N;;;;;
A21D;YI SYLLABLE GGAP;Lo;0;L;;;;;N;;;;;
A21E;YI SYLLABLE GGUOT;Lo;0;L;;;;;N;;;;;
A21F;YI SYLLABLE GGUOX;Lo;0;L;;;;;N;;;;;
A220;YI SYLLABLE GGUO;Lo;0;L;;;;;N;;;;;
A221;YI SYLLABLE GGUOP;Lo;0;L;;;;;N;;;;;
A222;YI SYLLABLE GGOT;Lo;0;L;;;;;N;;;;;
A223;YI SYLLABLE GGOX;Lo;0;L;;;;;N;;;;;
A224;YI SYLLABLE GGO;Lo;0;L;;;;;N;;;;;
A225;YI SYLLABLE GGOP;Lo;0;L;;;;;N;;;;;
A226;YI SYLLABLE GGET;Lo;0;L;;;;;N;;;;;
A227;YI SYLLABLE GGEX;Lo;0;L;;;;;N;;;;;
A228;YI SYLLABLE GGE;Lo;0;L;;;;;N;;;;;
A229;YI SYLLABLE GGEP;Lo;0;L;;;;;N;;;;;
A22A;YI SYLLABLE GGUT;Lo;0;L;;;;;N;;;;;
A22B;YI SYLLABLE GGUX;Lo;0;L;;;;;N;;;;;
A22C;YI SYLLABLE GGU;Lo;0;L;;;;;N;;;;;
A22D;YI SYLLABLE GGUP;Lo;0;L;;;;;N;;;;;
A22E;YI SYLLABLE GGURX;Lo;0;L;;;;;N;;;;;
A22F;YI SYLLABLE GGUR;Lo;0;L;;;;;N;;;;;
A230;YI SYLLABLE MGIEX;Lo;0;L;;;;;N;;;;;
A231;YI SYLLABLE MGIE;Lo;0;L;;;;;N;;;;;
A232;YI SYLLABLE MGAT;Lo;0;L;;;;;N;;;;;
A233;YI SYLLABLE MGAX;Lo;0;L;;;;;N;;;;;
A234;YI SYLLABLE MGA;Lo;0;L;;;;;N;;;;;
A235;YI SYLLABLE MGAP;Lo;0;L;;;;;N;;;;;
A236;YI SYLLABLE MGUOX;Lo;0;L;;;;;N;;;;;
A237;YI SYLLABLE MGUO;Lo;0;L;;;;;N;;;;;
A238;YI SYLLABLE MGUOP;Lo;0;L;;;;;N;;;;;
A239;YI SYLLABLE MGOT;Lo;0;L;;;;;N;;;;;
A23A;YI SYLLABLE MGOX;Lo;0;L;;;;;N;;;;;
A23B;YI SYLLABLE MGO;Lo;0;L;;;;;N;;;;;
A23C;YI SYLLABLE MGOP;Lo;0;L;;;;;N;;;;;
A23D;YI SYLLABLE MGEX;Lo;0;L;;;;;N;;;;;
A23E;YI SYLLABLE MGE;Lo;0;L;;;;;N;;;;;
A23F;YI SYLLABLE MGEP;Lo;0;L;;;;;N;;;;;
A240;YI SYLLABLE MGUT;Lo;0;L;;;;;N;;;;;
A241;YI SYLLABLE MGUX;Lo;0;L;;;;;N;;;;;
A242;YI SYLLABLE MGU;Lo;0;L;;;;;N;;;;;
A243;YI SYLLABLE MGUP;Lo;0;L;;;;;N;;;;;
A244;YI SYLLABLE MGURX;Lo;0;L;;;;;N;;;;;
A245;YI SYLLABLE MGUR;Lo;0;L;;;;;N;;;;;
A246;YI SYLLABLE HXIT;Lo;0;L;;;;;N;;;;;
A247;YI SYLLABLE HXIX;Lo;0;L;;;;;N;;;;;
A248;YI SYLLABLE HXI;Lo;0;L;;;;;N;;;;;
A249;YI SYLLABLE HXIP;Lo;0;L;;;;;N;;;;;
A24A;YI SYLLABLE HXIET;Lo;0;L;;;;;N;;;;;
A24B;YI SYLLABLE HXIEX;Lo;0;L;;;;;N;;;;;
A24C;YI SYLLABLE HXIE;Lo;0;L;;;;;N;;;;;
A24D;YI SYLLABLE HXIEP;Lo;0;L;;;;;N;;;;;
A24E;YI SYLLABLE HXAT;Lo;0;L;;;;;N;;;;;
A24F;YI SYLLABLE HXAX;Lo;0;L;;;;;N;;;;;
A250;YI SYLLABLE HXA;Lo;0;L;;;;;N;;;;;
A251;YI SYLLABLE HXAP;Lo;0;L;;;;;N;;;;;
A252;YI SYLLABLE HXUOT;Lo;0;L;;;;;N;;;;;
A253;YI SYLLABLE HXUOX;Lo;0;L;;;;;N;;;;;
A254;YI SYLLABLE HXUO;Lo;0;L;;;;;N;;;;;
A255;YI SYLLABLE HXUOP;Lo;0;L;;;;;N;;;;;
A256;YI SYLLABLE HXOT;Lo;0;L;;;;;N;;;;;
A257;YI SYLLABLE HXOX;Lo;0;L;;;;;N;;;;;
A258;YI SYLLABLE HXO;Lo;0;L;;;;;N;;;;;
A259;YI SYLLABLE HXOP;Lo;0;L;;;;;N;;;;;
A25A;YI SYLLABLE HXEX;Lo;0;L;;;;;N;;;;;
A25B;YI SYLLABLE HXE;Lo;0;L;;;;;N;;;;;
A25C;YI SYLLABLE HXEP;Lo;0;L;;;;;N;;;;;
A25D;YI SYLLABLE NGIEX;Lo;0;L;;;;;N;;;;;
A25E;YI SYLLABLE NGIE;Lo;0;L;;;;;N;;;;;
A25F;YI SYLLABLE NGIEP;Lo;0;L;;;;;N;;;;;
A260;YI SYLLABLE NGAT;Lo;0;L;;;;;N;;;;;
A261;YI SYLLABLE NGAX;Lo;0;L;;;;;N;;;;;
A262;YI SYLLABLE NGA;Lo;0;L;;;;;N;;;;;
A263;YI SYLLABLE NGAP;Lo;0;L;;;;;N;;;;;
A264;YI SYLLABLE NGUOT;Lo;0;L;;;;;N;;;;;
A265;YI SYLLABLE NGUOX;Lo;0;L;;;;;N;;;;;
A266;YI SYLLABLE NGUO;Lo;0;L;;;;;N;;;;;
A267;YI SYLLABLE NGOT;Lo;0;L;;;;;N;;;;;
A268;YI SYLLABLE NGOX;Lo;0;L;;;;;N;;;;;
A269;YI SYLLABLE NGO;Lo;0;L;;;;;N;;;;;
A26A;YI SYLLABLE NGOP;Lo;0;L;;;;;N;;;;;
A26B;YI SYLLABLE NGEX;Lo;0;L;;;;;N;;;;;
A26C;YI SYLLABLE NGE;Lo;0;L;;;;;N;;;;;
A26D;YI SYLLABLE NGEP;Lo;0;L;;;;;N;;;;;
A26E;YI SYLLABLE HIT;Lo;0;L;;;;;N;;;;;
A26F;YI SYLLABLE HIEX;Lo;0;L;;;;;N;;;;;
A270;YI SYLLABLE HIE;Lo;0;L;;;;;N;;;;;
A271;YI SYLLABLE HAT;Lo;0;L;;;;;N;;;;;
A272;YI SYLLABLE HAX;Lo;0;L;;;;;N;;;;;
A273;YI SYLLABLE HA;Lo;0;L;;;;;N;;;;;
A274;YI SYLLABLE HAP;Lo;0;L;;;;;N;;;;;
A275;YI SYLLABLE HUOT;Lo;0;L;;;;;N;;;;;
A276;YI SYLLABLE HUOX;Lo;0;L;;;;;N;;;;;
A277;YI SYLLABLE HUO;Lo;0;L;;;;;N;;;;;
A278;YI SYLLABLE HUOP;Lo;0;L;;;;;N;;;;;
A279;YI SYLLABLE HOT;Lo;0;L;;;;;N;;;;;
A27A;YI SYLLABLE HOX;Lo;0;L;;;;;N;;;;;
A27B;YI SYLLABLE HO;Lo;0;L;;;;;N;;;;;
A27C;YI SYLLABLE HOP;Lo;0;L;;;;;N;;;;;
A27D;YI SYLLABLE HEX;Lo;0;L;;;;;N;;;;;
A27E;YI SYLLABLE HE;Lo;0;L;;;;;N;;;;;
A27F;YI SYLLABLE HEP;Lo;0;L;;;;;N;;;;;
A280;YI SYLLABLE WAT;Lo;0;L;;;;;N;;;;;
A281;YI SYLLABLE WAX;Lo;0;L;;;;;N;;;;;
A282;YI SYLLABLE WA;Lo;0;L;;;;;N;;;;;
A283;YI SYLLABLE WAP;Lo;0;L;;;;;N;;;;;
A284;YI SYLLABLE WUOX;Lo;0;L;;;;;N;;;;;
A285;YI SYLLABLE WUO;Lo;0;L;;;;;N;;;;;
A286;YI SYLLABLE WUOP;Lo;0;L;;;;;N;;;;;
A287;YI SYLLABLE WOX;Lo;0;L;;;;;N;;;;;
A288;YI SYLLABLE WO;Lo;0;L;;;;;N;;;;;
A289;YI SYLLABLE WOP;Lo;0;L;;;;;N;;;;;
A28A;YI SYLLABLE WEX;Lo;0;L;;;;;N;;;;;
A28B;YI SYLLABLE WE;Lo;0;L;;;;;N;;;;;
A28C;YI SYLLABLE WEP;Lo;0;L;;;;;N;;;;;
A28D;YI SYLLABLE ZIT;Lo;0;L;;;;;N;;;;;
A28E;YI SYLLABLE ZIX;Lo;0;L;;;;;N;;;;;
A28F;YI SYLLABLE ZI;Lo;0;L;;;;;N;;;;;
A290;YI SYLLABLE ZIP;Lo;0;L;;;;;N;;;;;
A291;YI SYLLABLE ZIEX;Lo;0;L;;;;;N;;;;;
A292;YI SYLLABLE ZIE;Lo;0;L;;;;;N;;;;;
A293;YI SYLLABLE ZIEP;Lo;0;L;;;;;N;;;;;
A294;YI SYLLABLE ZAT;Lo;0;L;;;;;N;;;;;
A295;YI SYLLABLE ZAX;Lo;0;L;;;;;N;;;;;
A296;YI SYLLABLE ZA;Lo;0;L;;;;;N;;;;;
A297;YI SYLLABLE ZAP;Lo;0;L;;;;;N;;;;;
A298;YI SYLLABLE ZUOX;Lo;0;L;;;;;N;;;;;
A299;YI SYLLABLE ZUO;Lo;0;L;;;;;N;;;;;
A29A;YI SYLLABLE ZUOP;Lo;0;L;;;;;N;;;;;
A29B;YI SYLLABLE ZOT;Lo;0;L;;;;;N;;;;;
A29C;YI SYLLABLE ZOX;Lo;0;L;;;;;N;;;;;
A29D;YI SYLLABLE ZO;Lo;0;L;;;;;N;;;;;
A29E;YI SYLLABLE ZOP;Lo;0;L;;;;;N;;;;;
A29F;YI SYLLABLE ZEX;Lo;0;L;;;;;N;;;;;
A2A0;YI SYLLABLE ZE;Lo;0;L;;;;;N;;;;;
A2A1;YI SYLLABLE ZEP;Lo;0;L;;;;;N;;;;;
A2A2;YI SYLLABLE ZUT;Lo;0;L;;;;;N;;;;;
A2A3;YI SYLLABLE ZUX;Lo;0;L;;;;;N;;;;;
A2A4;YI SYLLABLE ZU;Lo;0;L;;;;;N;;;;;
A2A5;YI SYLLABLE ZUP;Lo;0;L;;;;;N;;;;;
A2A6;YI SYLLABLE ZURX;Lo;0;L;;;;;N;;;;;
A2A7;YI SYLLABLE ZUR;Lo;0;L;;;;;N;;;;;
A2A8;YI SYLLABLE ZYT;Lo;0;L;;;;;N;;;;;
A2A9;YI SYLLABLE ZYX;Lo;0;L;;;;;N;;;;;
A2AA;YI SYLLABLE ZY;Lo;0;L;;;;;N;;;;;
A2AB;YI SYLLABLE ZYP;Lo;0;L;;;;;N;;;;;
A2AC;YI SYLLABLE ZYRX;Lo;0;L;;;;;N;;;;;
A2AD;YI SYLLABLE ZYR;Lo;0;L;;;;;N;;;;;
A2AE;YI SYLLABLE CIT;Lo;0;L;;;;;N;;;;;
A2AF;YI SYLLABLE CIX;Lo;0;L;;;;;N;;;;;
A2B0;YI SYLLABLE CI;Lo;0;L;;;;;N;;;;;
A2B1;YI SYLLABLE CIP;Lo;0;L;;;;;N;;;;;
A2B2;YI SYLLABLE CIET;Lo;0;L;;;;;N;;;;;
A2B3;YI SYLLABLE CIEX;Lo;0;L;;;;;N;;;;;
A2B4;YI SYLLABLE CIE;Lo;0;L;;;;;N;;;;;
A2B5;YI SYLLABLE CIEP;Lo;0;L;;;;;N;;;;;
A2B6;YI SYLLABLE CAT;Lo;0;L;;;;;N;;;;;
A2B7;YI SYLLABLE CAX;Lo;0;L;;;;;N;;;;;
A2B8;YI SYLLABLE CA;Lo;0;L;;;;;N;;;;;
A2B9;YI SYLLABLE CAP;Lo;0;L;;;;;N;;;;;
A2BA;YI SYLLABLE CUOX;Lo;0;L;;;;;N;;;;;
A2BB;YI SYLLABLE CUO;Lo;0;L;;;;;N;;;;;
A2BC;YI SYLLABLE CUOP;Lo;0;L;;;;;N;;;;;
A2BD;YI SYLLABLE COT;Lo;0;L;;;;;N;;;;;
A2BE;YI SYLLABLE COX;Lo;0;L;;;;;N;;;;;
A2BF;YI SYLLABLE CO;Lo;0;L;;;;;N;;;;;
A2C0;YI SYLLABLE COP;Lo;0;L;;;;;N;;;;;
A2C1;YI SYLLABLE CEX;Lo;0;L;;;;;N;;;;;
A2C2;YI SYLLABLE CE;Lo;0;L;;;;;N;;;;;
A2C3;YI SYLLABLE CEP;Lo;0;L;;;;;N;;;;;
A2C4;YI SYLLABLE CUT;Lo;0;L;;;;;N;;;;;
A2C5;YI SYLLABLE CUX;Lo;0;L;;;;;N;;;;;
A2C6;YI SYLLABLE CU;Lo;0;L;;;;;N;;;;;
A2C7;YI SYLLABLE CUP;Lo;0;L;;;;;N;;;;;
A2C8;YI SYLLABLE CURX;Lo;0;L;;;;;N;;;;;
A2C9;YI SYLLABLE CUR;Lo;0;L;;;;;N;;;;;
A2CA;YI SYLLABLE CYT;Lo;0;L;;;;;N;;;;;
A2CB;YI SYLLABLE CYX;Lo;0;L;;;;;N;;;;;
A2CC;YI SYLLABLE CY;Lo;0;L;;;;;N;;;;;
A2CD;YI SYLLABLE CYP;Lo;0;L;;;;;N;;;;;
A2CE;YI SYLLABLE CYRX;Lo;0;L;;;;;N;;;;;
A2CF;YI SYLLABLE CYR;Lo;0;L;;;;;N;;;;;
A2D0;YI SYLLABLE ZZIT;Lo;0;L;;;;;N;;;;;
A2D1;YI SYLLABLE ZZIX;Lo;0;L;;;;;N;;;;;
A2D2;YI SYLLABLE ZZI;Lo;0;L;;;;;N;;;;;
A2D3;YI SYLLABLE ZZIP;Lo;0;L;;;;;N;;;;;
A2D4;YI SYLLABLE ZZIET;Lo;0;L;;;;;N;;;;;
A2D5;YI SYLLABLE ZZIEX;Lo;0;L;;;;;N;;;;;
A2D6;YI SYLLABLE ZZIE;Lo;0;L;;;;;N;;;;;
A2D7;YI SYLLABLE ZZIEP;Lo;0;L;;;;;N;;;;;
A2D8;YI SYLLABLE ZZAT;Lo;0;L;;;;;N;;;;;
A2D9;YI SYLLABLE ZZAX;Lo;0;L;;;;;N;;;;;
A2DA;YI SYLLABLE ZZA;Lo;0;L;;;;;N;;;;;
A2DB;YI SYLLABLE ZZAP;Lo;0;L;;;;;N;;;;;
A2DC;YI SYLLABLE ZZOX;Lo;0;L;;;;;N;;;;;
A2DD;YI SYLLABLE ZZO;Lo;0;L;;;;;N;;;;;
A2DE;YI SYLLABLE ZZOP;Lo;0;L;;;;;N;;;;;
A2DF;YI SYLLABLE ZZEX;Lo;0;L;;;;;N;;;;;
A2E0;YI SYLLABLE ZZE;Lo;0;L;;;;;N;;;;;
A2E1;YI SYLLABLE ZZEP;Lo;0;L;;;;;N;;;;;
A2E2;YI SYLLABLE ZZUX;Lo;0;L;;;;;N;;;;;
A2E3;YI SYLLABLE ZZU;Lo;0;L;;;;;N;;;;;
A2E4;YI SYLLABLE ZZUP;Lo;0;L;;;;;N;;;;;
A2E5;YI SYLLABLE ZZURX;Lo;0;L;;;;;N;;;;;
A2E6;YI SYLLABLE ZZUR;Lo;0;L;;;;;N;;;;;
A2E7;YI SYLLABLE ZZYT;Lo;0;L;;;;;N;;;;;
A2E8;YI SYLLABLE ZZYX;Lo;0;L;;;;;N;;;;;
A2E9;YI SYLLABLE ZZY;Lo;0;L;;;;;N;;;;;
A2EA;YI SYLLABLE ZZYP;Lo;0;L;;;;;N;;;;;
A2EB;YI SYLLABLE ZZYRX;Lo;0;L;;;;;N;;;;;
A2EC;YI SYLLABLE ZZYR;Lo;0;L;;;;;N;;;;;
A2ED;YI SYLLABLE NZIT;Lo;0;L;;;;;N;;;;;
A2EE;YI SYLLABLE NZIX;Lo;0;L;;;;;N;;;;;
A2EF;YI SYLLABLE NZI;Lo;0;L;;;;;N;;;;;
A2F0;YI SYLLABLE NZIP;Lo;0;L;;;;;N;;;;;
A2F1;YI SYLLABLE NZIEX;Lo;0;L;;;;;N;;;;;
A2F2;YI SYLLABLE NZIE;Lo;0;L;;;;;N;;;;;
A2F3;YI SYLLABLE NZIEP;Lo;0;L;;;;;N;;;;;
A2F4;YI SYLLABLE NZAT;Lo;0;L;;;;;N;;;;;
A2F5;YI SYLLABLE NZAX;Lo;0;L;;;;;N;;;;;
A2F6;YI SYLLABLE NZA;Lo;0;L;;;;;N;;;;;
A2F7;YI SYLLABLE NZAP;Lo;0;L;;;;;N;;;;;
A2F8;YI SYLLABLE NZUOX;Lo;0;L;;;;;N;;;;;
A2F9;YI SYLLABLE NZUO;Lo;0;L;;;;;N;;;;;
A2FA;YI SYLLABLE NZOX;Lo;0;L;;;;;N;;;;;
A2FB;YI SYLLABLE NZOP;Lo;0;L;;;;;N;;;;;
A2FC;YI SYLLABLE NZEX;Lo;0;L;;;;;N;;;;;
A2FD;YI SYLLABLE NZE;Lo;0;L;;;;;N;;;;;
A2FE;YI SYLLABLE NZUX;Lo;0;L;;;;;N;;;;;
A2FF;YI SYLLABLE NZU;Lo;0;L;;;;;N;;;;;
A300;YI SYLLABLE NZUP;Lo;0;L;;;;;N;;;;;
A301;YI SYLLABLE NZURX;Lo;0;L;;;;;N;;;;;
A302;YI SYLLABLE NZUR;Lo;0;L;;;;;N;;;;;
A303;YI SYLLABLE NZYT;Lo;0;L;;;;;N;;;;;
A304;YI SYLLABLE NZYX;Lo;0;L;;;;;N;;;;;
A305;YI SYLLABLE NZY;Lo;0;L;;;;;N;;;;;
A306;YI SYLLABLE NZYP;Lo;0;L;;;;;N;;;;;
A307;YI SYLLABLE NZYRX;Lo;0;L;;;;;N;;;;;
A308;YI SYLLABLE NZYR;Lo;0;L;;;;;N;;;;;
A309;YI SYLLABLE SIT;Lo;0;L;;;;;N;;;;;
A30A;YI SYLLABLE SIX;Lo;0;L;;;;;N;;;;;
A30B;YI SYLLABLE SI;Lo;0;L;;;;;N;;;;;
A30C;YI SYLLABLE SIP;Lo;0;L;;;;;N;;;;;
A30D;YI SYLLABLE SIEX;Lo;0;L;;;;;N;;;;;
A30E;YI SYLLABLE SIE;Lo;0;L;;;;;N;;;;;
A30F;YI SYLLABLE SIEP;Lo;0;L;;;;;N;;;;;
A310;YI SYLLABLE SAT;Lo;0;L;;;;;N;;;;;
A311;YI SYLLABLE SAX;Lo;0;L;;;;;N;;;;;
A312;YI SYLLABLE SA;Lo;0;L;;;;;N;;;;;
A313;YI SYLLABLE SAP;Lo;0;L;;;;;N;;;;;
A314;YI SYLLABLE SUOX;Lo;0;L;;;;;N;;;;;
A315;YI SYLLABLE SUO;Lo;0;L;;;;;N;;;;;
A316;YI SYLLABLE SUOP;Lo;0;L;;;;;N;;;;;
A317;YI SYLLABLE SOT;Lo;0;L;;;;;N;;;;;
A318;YI SYLLABLE SOX;Lo;0;L;;;;;N;;;;;
A319;YI SYLLABLE SO;Lo;0;L;;;;;N;;;;;
A31A;YI SYLLABLE SOP;Lo;0;L;;;;;N;;;;;
A31B;YI SYLLABLE SEX;Lo;0;L;;;;;N;;;;;
A31C;YI SYLLABLE SE;Lo;0;L;;;;;N;;;;;
A31D;YI SYLLABLE SEP;Lo;0;L;;;;;N;;;;;
A31E;YI SYLLABLE SUT;Lo;0;L;;;;;N;;;;;
A31F;YI SYLLABLE SUX;Lo;0;L;;;;;N;;;;;
A320;YI SYLLABLE SU;Lo;0;L;;;;;N;;;;;
A321;YI SYLLABLE SUP;Lo;0;L;;;;;N;;;;;
A322;YI SYLLABLE SURX;Lo;0;L;;;;;N;;;;;
A323;YI SYLLABLE SUR;Lo;0;L;;;;;N;;;;;
A324;YI SYLLABLE SYT;Lo;0;L;;;;;N;;;;;
A325;YI SYLLABLE SYX;Lo;0;L;;;;;N;;;;;
A326;YI SYLLABLE SY;Lo;0;L;;;;;N;;;;;
A327;YI SYLLABLE SYP;Lo;0;L;;;;;N;;;;;
A328;YI SYLLABLE SYRX;Lo;0;L;;;;;N;;;;;
A329;YI SYLLABLE SYR;Lo;0;L;;;;;N;;;;;
A32A;YI SYLLABLE SSIT;Lo;0;L;;;;;N;;;;;
A32B;YI SYLLABLE SSIX;Lo;0;L;;;;;N;;;;;
A32C;YI SYLLABLE SSI;Lo;0;L;;;;;N;;;;;
A32D;YI SYLLABLE SSIP;Lo;0;L;;;;;N;;;;;
A32E;YI SYLLABLE SSIEX;Lo;0;L;;;;;N;;;;;
A32F;YI SYLLABLE SSIE;Lo;0;L;;;;;N;;;;;
A330;YI SYLLABLE SSIEP;Lo;0;L;;;;;N;;;;;
A331;YI SYLLABLE SSAT;Lo;0;L;;;;;N;;;;;
A332;YI SYLLABLE SSAX;Lo;0;L;;;;;N;;;;;
A333;YI SYLLABLE SSA;Lo;0;L;;;;;N;;;;;
A334;YI SYLLABLE SSAP;Lo;0;L;;;;;N;;;;;
A335;YI SYLLABLE SSOT;Lo;0;L;;;;;N;;;;;
A336;YI SYLLABLE SSOX;Lo;0;L;;;;;N;;;;;
A337;YI SYLLABLE SSO;Lo;0;L;;;;;N;;;;;
A338;YI SYLLABLE SSOP;Lo;0;L;;;;;N;;;;;
A339;YI SYLLABLE SSEX;Lo;0;L;;;;;N;;;;;
A33A;YI SYLLABLE SSE;Lo;0;L;;;;;N;;;;;
A33B;YI SYLLABLE SSEP;Lo;0;L;;;;;N;;;;;
A33C;YI SYLLABLE SSUT;Lo;0;L;;;;;N;;;;;
A33D;YI SYLLABLE SSUX;Lo;0;L;;;;;N;;;;;
A33E;YI SYLLABLE SSU;Lo;0;L;;;;;N;;;;;
A33F;YI SYLLABLE SSUP;Lo;0;L;;;;;N;;;;;
A340;YI SYLLABLE SSYT;Lo;0;L;;;;;N;;;;;
A341;YI SYLLABLE SSYX;Lo;0;L;;;;;N;;;;;
A342;YI SYLLABLE SSY;Lo;0;L;;;;;N;;;;;
A343;YI SYLLABLE SSYP;Lo;0;L;;;;;N;;;;;
A344;YI SYLLABLE SSYRX;Lo;0;L;;;;;N;;;;;
A345;YI SYLLABLE SSYR;Lo;0;L;;;;;N;;;;;
A346;YI SYLLABLE ZHAT;Lo;0;L;;;;;N;;;;;
A347;YI SYLLABLE ZHAX;Lo;0;L;;;;;N;;;;;
A348;YI SYLLABLE ZHA;Lo;0;L;;;;;N;;;;;
A349;YI SYLLABLE ZHAP;Lo;0;L;;;;;N;;;;;
A34A;YI SYLLABLE ZHUOX;Lo;0;L;;;;;N;;;;;
A34B;YI SYLLABLE ZHUO;Lo;0;L;;;;;N;;;;;
A34C;YI SYLLABLE ZHUOP;Lo;0;L;;;;;N;;;;;
A34D;YI SYLLABLE ZHOT;Lo;0;L;;;;;N;;;;;
A34E;YI SYLLABLE ZHOX;Lo;0;L;;;;;N;;;;;
A34F;YI SYLLABLE ZHO;Lo;0;L;;;;;N;;;;;
A350;YI SYLLABLE ZHOP;Lo;0;L;;;;;N;;;;;
A351;YI SYLLABLE ZHET;Lo;0;L;;;;;N;;;;;
A352;YI SYLLABLE ZHEX;Lo;0;L;;;;;N;;;;;
A353;YI SYLLABLE ZHE;Lo;0;L;;;;;N;;;;;
A354;YI SYLLABLE ZHEP;Lo;0;L;;;;;N;;;;;
A355;YI SYLLABLE ZHUT;Lo;0;L;;;;;N;;;;;
A356;YI SYLLABLE ZHUX;Lo;0;L;;;;;N;;;;;
A357;YI SYLLABLE ZHU;Lo;0;L;;;;;N;;;;;
A358;YI SYLLABLE ZHUP;Lo;0;L;;;;;N;;;;;
A359;YI SYLLABLE ZHURX;Lo;0;L;;;;;N;;;;;
A35A;YI SYLLABLE ZHUR;Lo;0;L;;;;;N;;;;;
A35B;YI SYLLABLE ZHYT;Lo;0;L;;;;;N;;;;;
A35C;YI SYLLABLE ZHYX;Lo;0;L;;;;;N;;;;;
A35D;YI SYLLABLE ZHY;Lo;0;L;;;;;N;;;;;
A35E;YI SYLLABLE ZHYP;Lo;0;L;;;;;N;;;;;
A35F;YI SYLLABLE ZHYRX;Lo;0;L;;;;;N;;;;;
A360;YI SYLLABLE ZHYR;Lo;0;L;;;;;N;;;;;
A361;YI SYLLABLE CHAT;Lo;0;L;;;;;N;;;;;
A362;YI SYLLABLE CHAX;Lo;0;L;;;;;N;;;;;
A363;YI SYLLABLE CHA;Lo;0;L;;;;;N;;;;;
A364;YI SYLLABLE CHAP;Lo;0;L;;;;;N;;;;;
A365;YI SYLLABLE CHUOT;Lo;0;L;;;;;N;;;;;
A366;YI SYLLABLE CHUOX;Lo;0;L;;;;;N;;;;;
A367;YI SYLLABLE CHUO;Lo;0;L;;;;;N;;;;;
A368;YI SYLLABLE CHUOP;Lo;0;L;;;;;N;;;;;
A369;YI SYLLABLE CHOT;Lo;0;L;;;;;N;;;;;
A36A;YI SYLLABLE CHOX;Lo;0;L;;;;;N;;;;;
A36B;YI SYLLABLE CHO;Lo;0;L;;;;;N;;;;;
A36C;YI SYLLABLE CHOP;Lo;0;L;;;;;N;;;;;
A36D;YI SYLLABLE CHET;Lo;0;L;;;;;N;;;;;
A36E;YI SYLLABLE CHEX;Lo;0;L;;;;;N;;;;;
A36F;YI SYLLABLE CHE;Lo;0;L;;;;;N;;;;;
A370;YI SYLLABLE CHEP;Lo;0;L;;;;;N;;;;;
A371;YI SYLLABLE CHUX;Lo;0;L;;;;;N;;;;;
A372;YI SYLLABLE CHU;Lo;0;L;;;;;N;;;;;
A373;YI SYLLABLE CHUP;Lo;0;L;;;;;N;;;;;
A374;YI SYLLABLE CHURX;Lo;0;L;;;;;N;;;;;
A375;YI SYLLABLE CHUR;Lo;0;L;;;;;N;;;;;
A376;YI SYLLABLE CHYT;Lo;0;L;;;;;N;;;;;
A377;YI SYLLABLE CHYX;Lo;0;L;;;;;N;;;;;
A378;YI SYLLABLE CHY;Lo;0;L;;;;;N;;;;;
A379;YI SYLLABLE CHYP;Lo;0;L;;;;;N;;;;;
A37A;YI SYLLABLE CHYRX;Lo;0;L;;;;;N;;;;;
A37B;YI SYLLABLE CHYR;Lo;0;L;;;;;N;;;;;
A37C;YI SYLLABLE RRAX;Lo;0;L;;;;;N;;;;;
A37D;YI SYLLABLE RRA;Lo;0;L;;;;;N;;;;;
A37E;YI SYLLABLE RRUOX;Lo;0;L;;;;;N;;;;;
A37F;YI SYLLABLE RRUO;Lo;0;L;;;;;N;;;;;
A380;YI SYLLABLE RROT;Lo;0;L;;;;;N;;;;;
A381;YI SYLLABLE RROX;Lo;0;L;;;;;N;;;;;
A382;YI SYLLABLE RRO;Lo;0;L;;;;;N;;;;;
A383;YI SYLLABLE RROP;Lo;0;L;;;;;N;;;;;
A384;YI SYLLABLE RRET;Lo;0;L;;;;;N;;;;;
A385;YI SYLLABLE RREX;Lo;0;L;;;;;N;;;;;
A386;YI SYLLABLE RRE;Lo;0;L;;;;;N;;;;;
A387;YI SYLLABLE RREP;Lo;0;L;;;;;N;;;;;
A388;YI SYLLABLE RRUT;Lo;0;L;;;;;N;;;;;
A389;YI SYLLABLE RRUX;Lo;0;L;;;;;N;;;;;
A38A;YI SYLLABLE RRU;Lo;0;L;;;;;N;;;;;
A38B;YI SYLLABLE RRUP;Lo;0;L;;;;;N;;;;;
A38C;YI SYLLABLE RRURX;Lo;0;L;;;;;N;;;;;
A38D;YI SYLLABLE RRUR;Lo;0;L;;;;;N;;;;;
A38E;YI SYLLABLE RRYT;Lo;0;L;;;;;N;;;;;
A38F;YI SYLLABLE RRYX;Lo;0;L;;;;;N;;;;;
A390;YI SYLLABLE RRY;Lo;0;L;;;;;N;;;;;
A391;YI SYLLABLE RRYP;Lo;0;L;;;;;N;;;;;
A392;YI SYLLABLE RRYRX;Lo;0;L;;;;;N;;;;;
A393;YI SYLLABLE RRYR;Lo;0;L;;;;;N;;;;;
A394;YI SYLLABLE NRAT;Lo;0;L;;;;;N;;;;;
A395;YI SYLLABLE NRAX;Lo;0;L;;;;;N;;;;;
A396;YI SYLLABLE NRA;Lo;0;L;;;;;N;;;;;
A397;YI SYLLABLE NRAP;Lo;0;L;;;;;N;;;;;
A398;YI SYLLABLE NROX;Lo;0;L;;;;;N;;;;;
A399;YI SYLLABLE NRO;Lo;0;L;;;;;N;;;;;
A39A;YI SYLLABLE NROP;Lo;0;L;;;;;N;;;;;
A39B;YI SYLLABLE NRET;Lo;0;L;;;;;N;;;;;
A39C;YI SYLLABLE NREX;Lo;0;L;;;;;N;;;;;
A39D;YI SYLLABLE NRE;Lo;0;L;;;;;N;;;;;
A39E;YI SYLLABLE NREP;Lo;0;L;;;;;N;;;;;
A39F;YI SYLLABLE NRUT;Lo;0;L;;;;;N;;;;;
A3A0;YI SYLLABLE NRUX;Lo;0;L;;;;;N;;;;;
A3A1;YI SYLLABLE NRU;Lo;0;L;;;;;N;;;;;
A3A2;YI SYLLABLE NRUP;Lo;0;L;;;;;N;;;;;
A3A3;YI SYLLABLE NRURX;Lo;0;L;;;;;N;;;;;
A3A4;YI SYLLABLE NRUR;Lo;0;L;;;;;N;;;;;
A3A5;YI SYLLABLE NRYT;Lo;0;L;;;;;N;;;;;
A3A6;YI SYLLABLE NRYX;Lo;0;L;;;;;N;;;;;
A3A7;YI SYLLABLE NRY;Lo;0;L;;;;;N;;;;;
A3A8;YI SYLLABLE NRYP;Lo;0;L;;;;;N;;;;;
A3A9;YI SYLLABLE NRYRX;Lo;0;L;;;;;N;;;;;
A3AA;YI SYLLABLE NRYR;Lo;0;L;;;;;N;;;;;
A3AB;YI SYLLABLE SHAT;Lo;0;L;;;;;N;;;;;
A3AC;YI SYLLABLE SHAX;Lo;0;L;;;;;N;;;;;
A3AD;YI SYLLABLE SHA;Lo;0;L;;;;;N;;;;;
A3AE;YI SYLLABLE SHAP;Lo;0;L;;;;;N;;;;;
A3AF;YI SYLLABLE SHUOX;Lo;0;L;;;;;N;;;;;
A3B0;YI SYLLABLE SHUO;Lo;0;L;;;;;N;;;;;
A3B1;YI SYLLABLE SHUOP;Lo;0;L;;;;;N;;;;;
A3B2;YI SYLLABLE SHOT;Lo;0;L;;;;;N;;;;;
A3B3;YI SYLLABLE SHOX;Lo;0;L;;;;;N;;;;;
A3B4;YI SYLLABLE SHO;Lo;0;L;;;;;N;;;;;
A3B5;YI SYLLABLE SHOP;Lo;0;L;;;;;N;;;;;
A3B6;YI SYLLABLE SHET;Lo;0;L;;;;;N;;;;;
A3B7;YI SYLLABLE SHEX;Lo;0;L;;;;;N;;;;;
A3B8;YI SYLLABLE SHE;Lo;0;L;;;;;N;;;;;
A3B9;YI SYLLABLE SHEP;Lo;0;L;;;;;N;;;;;
A3BA;YI SYLLABLE SHUT;Lo;0;L;;;;;N;;;;;
A3BB;YI SYLLABLE SHUX;Lo;0;L;;;;;N;;;;;
A3BC;YI SYLLABLE SHU;Lo;0;L;;;;;N;;;;;
A3BD;YI SYLLABLE SHUP;Lo;0;L;;;;;N;;;;;
A3BE;YI SYLLABLE SHURX;Lo;0;L;;;;;N;;;;;
A3BF;YI SYLLABLE SHUR;Lo;0;L;;;;;N;;;;;
A3C0;YI SYLLABLE SHYT;Lo;0;L;;;;;N;;;;;
A3C1;YI SYLLABLE SHYX;Lo;0;L;;;;;N;;;;;
A3C2;YI SYLLABLE SHY;Lo;0;L;;;;;N;;;;;
A3C3;YI SYLLABLE SHYP;Lo;0;L;;;;;N;;;;;
A3C4;YI SYLLABLE SHYRX;Lo;0;L;;;;;N;;;;;
A3C5;YI SYLLABLE SHYR;Lo;0;L;;;;;N;;;;;
A3C6;YI SYLLABLE RAT;Lo;0;L;;;;;N;;;;;
A3C7;YI SYLLABLE RAX;Lo;0;L;;;;;N;;;;;
A3C8;YI SYLLABLE RA;Lo;0;L;;;;;N;;;;;
A3C9;YI SYLLABLE RAP;Lo;0;L;;;;;N;;;;;
A3CA;YI SYLLABLE RUOX;Lo;0;L;;;;;N;;;;;
A3CB;YI SYLLABLE RUO;Lo;0;L;;;;;N;;;;;
A3CC;YI SYLLABLE RUOP;Lo;0;L;;;;;N;;;;;
A3CD;YI SYLLABLE ROT;Lo;0;L;;;;;N;;;;;
A3CE;YI SYLLABLE ROX;Lo;0;L;;;;;N;;;;;
A3CF;YI SYLLABLE RO;Lo;0;L;;;;;N;;;;;
A3D0;YI SYLLABLE ROP;Lo;0;L;;;;;N;;;;;
A3D1;YI SYLLABLE REX;Lo;0;L;;;;;N;;;;;
A3D2;YI SYLLABLE RE;Lo;0;L;;;;;N;;;;;
A3D3;YI SYLLABLE REP;Lo;0;L;;;;;N;;;;;
A3D4;YI SYLLABLE RUT;Lo;0;L;;;;;N;;;;;
A3D5;YI SYLLABLE RUX;Lo;0;L;;;;;N;;;;;
A3D6;YI SYLLABLE RU;Lo;0;L;;;;;N;;;;;
A3D7;YI SYLLABLE RUP;Lo;0;L;;;;;N;;;;;
A3D8;YI SYLLABLE RURX;Lo;0;L;;;;;N;;;;;
A3D9;YI SYLLABLE RUR;Lo;0;L;;;;;N;;;;;
A3DA;YI SYLLABLE RYT;Lo;0;L;;;;;N;;;;;
A3DB;YI SYLLABLE RYX;Lo;0;L;;;;;N;;;;;
A3DC;YI SYLLABLE RY;Lo;0;L;;;;;N;;;;;
A3DD;YI SYLLABLE RYP;Lo;0;L;;;;;N;;;;;
A3DE;YI SYLLABLE RYRX;Lo;0;L;;;;;N;;;;;
A3DF;YI SYLLABLE RYR;Lo;0;L;;;;;N;;;;;
A3E0;YI SYLLABLE JIT;Lo;0;L;;;;;N;;;;;
A3E1;YI SYLLABLE JIX;Lo;0;L;;;;;N;;;;;
A3E2;YI SYLLABLE JI;Lo;0;L;;;;;N;;;;;
A3E3;YI SYLLABLE JIP;Lo;0;L;;;;;N;;;;;
A3E4;YI SYLLABLE JIET;Lo;0;L;;;;;N;;;;;
A3E5;YI SYLLABLE JIEX;Lo;0;L;;;;;N;;;;;
A3E6;YI SYLLABLE JIE;Lo;0;L;;;;;N;;;;;
A3E7;YI SYLLABLE JIEP;Lo;0;L;;;;;N;;;;;
A3E8;YI SYLLABLE JUOT;Lo;0;L;;;;;N;;;;;
A3E9;YI SYLLABLE JUOX;Lo;0;L;;;;;N;;;;;
A3EA;YI SYLLABLE JUO;Lo;0;L;;;;;N;;;;;
A3EB;YI SYLLABLE JUOP;Lo;0;L;;;;;N;;;;;
A3EC;YI SYLLABLE JOT;Lo;0;L;;;;;N;;;;;
A3ED;YI SYLLABLE JOX;Lo;0;L;;;;;N;;;;;
A3EE;YI SYLLABLE JO;Lo;0;L;;;;;N;;;;;
A3EF;YI SYLLABLE JOP;Lo;0;L;;;;;N;;;;;
A3F0;YI SYLLABLE JUT;Lo;0;L;;;;;N;;;;;
A3F1;YI SYLLABLE JUX;Lo;0;L;;;;;N;;;;;
A3F2;YI SYLLABLE JU;Lo;0;L;;;;;N;;;;;
A3F3;YI SYLLABLE JUP;Lo;0;L;;;;;N;;;;;
A3F4;YI SYLLABLE JURX;Lo;0;L;;;;;N;;;;;
A3F5;YI SYLLABLE JUR;Lo;0;L;;;;;N;;;;;
A3F6;YI SYLLABLE JYT;Lo;0;L;;;;;N;;;;;
A3F7;YI SYLLABLE JYX;Lo;0;L;;;;;N;;;;;
A3F8;YI SYLLABLE JY;Lo;0;L;;;;;N;;;;;
A3F9;YI SYLLABLE JYP;Lo;0;L;;;;;N;;;;;
A3FA;YI SYLLABLE JYRX;Lo;0;L;;;;;N;;;;;
A3FB;YI SYLLABLE JYR;Lo;0;L;;;;;N;;;;;
A3FC;YI SYLLABLE QIT;Lo;0;L;;;;;N;;;;;
A3FD;YI SYLLABLE QIX;Lo;0;L;;;;;N;;;;;
A3FE;YI SYLLABLE QI;Lo;0;L;;;;;N;;;;;
A3FF;YI SYLLABLE QIP;Lo;0;L;;;;;N;;;;;
A400;YI SYLLABLE QIET;Lo;0;L;;;;;N;;;;;
A401;YI SYLLABLE QIEX;Lo;0;L;;;;;N;;;;;
A402;YI SYLLABLE QIE;Lo;0;L;;;;;N;;;;;
A403;YI SYLLABLE QIEP;Lo;0;L;;;;;N;;;;;
A404;YI SYLLABLE QUOT;Lo;0;L;;;;;N;;;;;
A405;YI SYLLABLE QUOX;Lo;0;L;;;;;N;;;;;
A406;YI SYLLABLE QUO;Lo;0;L;;;;;N;;;;;
A407;YI SYLLABLE QUOP;Lo;0;L;;;;;N;;;;;
A408;YI SYLLABLE QOT;Lo;0;L;;;;;N;;;;;
A409;YI SYLLABLE QOX;Lo;0;L;;;;;N;;;;;
A40A;YI SYLLABLE QO;Lo;0;L;;;;;N;;;;;
A40B;YI SYLLABLE QOP;Lo;0;L;;;;;N;;;;;
A40C;YI SYLLABLE QUT;Lo;0;L;;;;;N;;;;;
A40D;YI SYLLABLE QUX;Lo;0;L;;;;;N;;;;;
A40E;YI SYLLABLE QU;Lo;0;L;;;;;N;;;;;
A40F;YI SYLLABLE QUP;Lo;0;L;;;;;N;;;;;
A410;YI SYLLABLE QURX;Lo;0;L;;;;;N;;;;;
A411;YI SYLLABLE QUR;Lo;0;L;;;;;N;;;;;
A412;YI SYLLABLE QYT;Lo;0;L;;;;;N;;;;;
A413;YI SYLLABLE QYX;Lo;0;L;;;;;N;;;;;
A414;YI SYLLABLE QY;Lo;0;L;;;;;N;;;;;
A415;YI SYLLABLE QYP;Lo;0;L;;;;;N;;;;;
A416;YI SYLLABLE QYRX;Lo;0;L;;;;;N;;;;;
A417;YI SYLLABLE QYR;Lo;0;L;;;;;N;;;;;
A418;YI SYLLABLE JJIT;Lo;0;L;;;;;N;;;;;
A419;YI SYLLABLE JJIX;Lo;0;L;;;;;N;;;;;
A41A;YI SYLLABLE JJI;Lo;0;L;;;;;N;;;;;
A41B;YI SYLLABLE JJIP;Lo;0;L;;;;;N;;;;;
A41C;YI SYLLABLE JJIET;Lo;0;L;;;;;N;;;;;
A41D;YI SYLLABLE JJIEX;Lo;0;L;;;;;N;;;;;
A41E;YI SYLLABLE JJIE;Lo;0;L;;;;;N;;;;;
A41F;YI SYLLABLE JJIEP;Lo;0;L;;;;;N;;;;;
A420;YI SYLLABLE JJUOX;Lo;0;L;;;;;N;;;;;
A421;YI SYLLABLE JJUO;Lo;0;L;;;;;N;;;;;
A422;YI SYLLABLE JJUOP;Lo;0;L;;;;;N;;;;;
A423;YI SYLLABLE JJOT;Lo;0;L;;;;;N;;;;;
A424;YI SYLLABLE JJOX;Lo;0;L;;;;;N;;;;;
A425;YI SYLLABLE JJO;Lo;0;L;;;;;N;;;;;
A426;YI SYLLABLE JJOP;Lo;0;L;;;;;N;;;;;
A427;YI SYLLABLE JJUT;Lo;0;L;;;;;N;;;;;
A428;YI SYLLABLE JJUX;Lo;0;L;;;;;N;;;;;
A429;YI SYLLABLE JJU;Lo;0;L;;;;;N;;;;;
A42A;YI SYLLABLE JJUP;Lo;0;L;;;;;N;;;;;
A42B;YI SYLLABLE JJURX;Lo;0;L;;;;;N;;;;;
A42C;YI SYLLABLE JJUR;Lo;0;L;;;;;N;;;;;
A42D;YI SYLLABLE JJYT;Lo;0;L;;;;;N;;;;;
A42E;YI SYLLABLE JJYX;Lo;0;L;;;;;N;;;;;
A42F;YI SYLLABLE JJY;Lo;0;L;;;;;N;;;;;
A430;YI SYLLABLE JJYP;Lo;0;L;;;;;N;;;;;
A431;YI SYLLABLE NJIT;Lo;0;L;;;;;N;;;;;
A432;YI SYLLABLE NJIX;Lo;0;L;;;;;N;;;;;
A433;YI SYLLABLE NJI;Lo;0;L;;;;;N;;;;;
A434;YI SYLLABLE NJIP;Lo;0;L;;;;;N;;;;;
A435;YI SYLLABLE NJIET;Lo;0;L;;;;;N;;;;;
A436;YI SYLLABLE NJIEX;Lo;0;L;;;;;N;;;;;
A437;YI SYLLABLE NJIE;Lo;0;L;;;;;N;;;;;
A438;YI SYLLABLE NJIEP;Lo;0;L;;;;;N;;;;;
A439;YI SYLLABLE NJUOX;Lo;0;L;;;;;N;;;;;
A43A;YI SYLLABLE NJUO;Lo;0;L;;;;;N;;;;;
A43B;YI SYLLABLE NJOT;Lo;0;L;;;;;N;;;;;
A43C;YI SYLLABLE NJOX;Lo;0;L;;;;;N;;;;;
A43D;YI SYLLABLE NJO;Lo;0;L;;;;;N;;;;;
A43E;YI SYLLABLE NJOP;Lo;0;L;;;;;N;;;;;
A43F;YI SYLLABLE NJUX;Lo;0;L;;;;;N;;;;;
A440;YI SYLLABLE NJU;Lo;0;L;;;;;N;;;;;
A441;YI SYLLABLE NJUP;Lo;0;L;;;;;N;;;;;
A442;YI SYLLABLE NJURX;Lo;0;L;;;;;N;;;;;
A443;YI SYLLABLE NJUR;Lo;0;L;;;;;N;;;;;
A444;YI SYLLABLE NJYT;Lo;0;L;;;;;N;;;;;
A445;YI SYLLABLE NJYX;Lo;0;L;;;;;N;;;;;
A446;YI SYLLABLE NJY;Lo;0;L;;;;;N;;;;;
A447;YI SYLLABLE NJYP;Lo;0;L;;;;;N;;;;;
A448;YI SYLLABLE NJYRX;Lo;0;L;;;;;N;;;;;
A449;YI SYLLABLE NJYR;Lo;0;L;;;;;N;;;;;
A44A;YI SYLLABLE NYIT;Lo;0;L;;;;;N;;;;;
A44B;YI SYLLABLE NYIX;Lo;0;L;;;;;N;;;;;
A44C;YI SYLLABLE NYI;Lo;0;L;;;;;N;;;;;
A44D;YI SYLLABLE NYIP;Lo;0;L;;;;;N;;;;;
A44E;YI SYLLABLE NYIET;Lo;0;L;;;;;N;;;;;
A44F;YI SYLLABLE NYIEX;Lo;0;L;;;;;N;;;;;
A450;YI SYLLABLE NYIE;Lo;0;L;;;;;N;;;;;
A451;YI SYLLABLE NYIEP;Lo;0;L;;;;;N;;;;;
A452;YI SYLLABLE NYUOX;Lo;0;L;;;;;N;;;;;
A453;YI SYLLABLE NYUO;Lo;0;L;;;;;N;;;;;
A454;YI SYLLABLE NYUOP;Lo;0;L;;;;;N;;;;;
A455;YI SYLLABLE NYOT;Lo;0;L;;;;;N;;;;;
A456;YI SYLLABLE NYOX;Lo;0;L;;;;;N;;;;;
A457;YI SYLLABLE NYO;Lo;0;L;;;;;N;;;;;
A458;YI SYLLABLE NYOP;Lo;0;L;;;;;N;;;;;
A459;YI SYLLABLE NYUT;Lo;0;L;;;;;N;;;;;
A45A;YI SYLLABLE NYUX;Lo;0;L;;;;;N;;;;;
A45B;YI SYLLABLE NYU;Lo;0;L;;;;;N;;;;;
A45C;YI SYLLABLE NYUP;Lo;0;L;;;;;N;;;;;
A45D;YI SYLLABLE XIT;Lo;0;L;;;;;N;;;;;
A45E;YI SYLLABLE XIX;Lo;0;L;;;;;N;;;;;
A45F;YI SYLLABLE XI;Lo;0;L;;;;;N;;;;;
A460;YI SYLLABLE XIP;Lo;0;L;;;;;N;;;;;
A461;YI SYLLABLE XIET;Lo;0;L;;;;;N;;;;;
A462;YI SYLLABLE XIEX;Lo;0;L;;;;;N;;;;;
A463;YI SYLLABLE XIE;Lo;0;L;;;;;N;;;;;
A464;YI SYLLABLE XIEP;Lo;0;L;;;;;N;;;;;
A465;YI SYLLABLE XUOX;Lo;0;L;;;;;N;;;;;
A466;YI SYLLABLE XUO;Lo;0;L;;;;;N;;;;;
A467;YI SYLLABLE XOT;Lo;0;L;;;;;N;;;;;
A468;YI SYLLABLE XOX;Lo;0;L;;;;;N;;;;;
A469;YI SYLLABLE XO;Lo;0;L;;;;;N;;;;;
A46A;YI SYLLABLE XOP;Lo;0;L;;;;;N;;;;;
A46B;YI SYLLABLE XYT;Lo;0;L;;;;;N;;;;;
A46C;YI SYLLABLE XYX;Lo;0;L;;;;;N;;;;;
A46D;YI SYLLABLE XY;Lo;0;L;;;;;N;;;;;
A46E;YI SYLLABLE XYP;Lo;0;L;;;;;N;;;;;
A46F;YI SYLLABLE XYRX;Lo;0;L;;;;;N;;;;;
A470;YI SYLLABLE XYR;Lo;0;L;;;;;N;;;;;
A471;YI SYLLABLE YIT;Lo;0;L;;;;;N;;;;;
A472;YI SYLLABLE YIX;Lo;0;L;;;;;N;;;;;
A473;YI SYLLABLE YI;Lo;0;L;;;;;N;;;;;
A474;YI SYLLABLE YIP;Lo;0;L;;;;;N;;;;;
A475;YI SYLLABLE YIET;Lo;0;L;;;;;N;;;;;
A476;YI SYLLABLE YIEX;Lo;0;L;;;;;N;;;;;
A477;YI SYLLABLE YIE;Lo;0;L;;;;;N;;;;;
A478;YI SYLLABLE YIEP;Lo;0;L;;;;;N;;;;;
A479;YI SYLLABLE YUOT;Lo;0;L;;;;;N;;;;;
A47A;YI SYLLABLE YUOX;Lo;0;L;;;;;N;;;;;
A47B;YI SYLLABLE YUO;Lo;0;L;;;;;N;;;;;
A47C;YI SYLLABLE YUOP;Lo;0;L;;;;;N;;;;;
A47D;YI SYLLABLE YOT;Lo;0;L;;;;;N;;;;;
A47E;YI SYLLABLE YOX;Lo;0;L;;;;;N;;;;;
A47F;YI SYLLABLE YO;Lo;0;L;;;;;N;;;;;
A480;YI SYLLABLE YOP;Lo;0;L;;;;;N;;;;;
A481;YI SYLLABLE YUT;Lo;0;L;;;;;N;;;;;
A482;YI SYLLABLE YUX;Lo;0;L;;;;;N;;;;;
A483;YI SYLLABLE YU;Lo;0;L;;;;;N;;;;;
A484;YI SYLLABLE YUP;Lo;0;L;;;;;N;;;;;
A485;YI SYLLABLE YURX;Lo;0;L;;;;;N;;;;;
A486;YI SYLLABLE YUR;Lo;0;L;;;;;N;;;;;
A487;YI SYLLABLE YYT;Lo;0;L;;;;;N;;;;;
A488;YI SYLLABLE YYX;Lo;0;L;;;;;N;;;;;
A489;YI SYLLABLE YY;Lo;0;L;;;;;N;;;;;
A48A;YI SYLLABLE YYP;Lo;0;L;;;;;N;;;;;
A48B;YI SYLLABLE YYRX;Lo;0;L;;;;;N;;;;;
A48C;YI SYLLABLE YYR;Lo;0;L;;;;;N;;;;;
A490;YI RADICAL QOT;So;0;ON;;;;;N;;;;;
A491;YI RADICAL LI;So;0;ON;;;;;N;;;;;
A492;YI RADICAL KIT;So;0;ON;;;;;N;;;;;
A493;YI RADICAL NYIP;So;0;ON;;;;;N;;;;;
A494;YI RADICAL CYP;So;0;ON;;;;;N;;;;;
A495;YI RADICAL SSI;So;0;ON;;;;;N;;;;;
A496;YI RADICAL GGOP;So;0;ON;;;;;N;;;;;
A497;YI RADICAL GEP;So;0;ON;;;;;N;;;;;
A498;YI RADICAL MI;So;0;ON;;;;;N;;;;;
A499;YI RADICAL HXIT;So;0;ON;;;;;N;;;;;
A49A;YI RADICAL LYR;So;0;ON;;;;;N;;;;;
A49B;YI RADICAL BBUT;So;0;ON;;;;;N;;;;;
A49C;YI RADICAL MOP;So;0;ON;;;;;N;;;;;
A49D;YI RADICAL YO;So;0;ON;;;;;N;;;;;
A49E;YI RADICAL PUT;So;0;ON;;;;;N;;;;;
A49F;YI RADICAL HXUO;So;0;ON;;;;;N;;;;;
A4A0;YI RADICAL TAT;So;0;ON;;;;;N;;;;;
A4A1;YI RADICAL GA;So;0;ON;;;;;N;;;;;
A4A2;YI RADICAL ZUP;So;0;ON;;;;;N;;;;;
A4A3;YI RADICAL CYT;So;0;ON;;;;;N;;;;;
A4A4;YI RADICAL DDUR;So;0;ON;;;;;N;;;;;
A4A5;YI RADICAL BUR;So;0;ON;;;;;N;;;;;
A4A6;YI RADICAL GGUO;So;0;ON;;;;;N;;;;;
A4A7;YI RADICAL NYOP;So;0;ON;;;;;N;;;;;
A4A8;YI RADICAL TU;So;0;ON;;;;;N;;;;;
A4A9;YI RADICAL OP;So;0;ON;;;;;N;;;;;
A4AA;YI RADICAL JJUT;So;0;ON;;;;;N;;;;;
A4AB;YI RADICAL ZOT;So;0;ON;;;;;N;;;;;
A4AC;YI RADICAL PYT;So;0;ON;;;;;N;;;;;
A4AD;YI RADICAL HMO;So;0;ON;;;;;N;;;;;
A4AE;YI RADICAL YIT;So;0;ON;;;;;N;;;;;
A4AF;YI RADICAL VUR;So;0;ON;;;;;N;;;;;
A4B0;YI RADICAL SHY;So;0;ON;;;;;N;;;;;
A4B1;YI RADICAL VEP;So;0;ON;;;;;N;;;;;
A4B2;YI RADICAL ZA;So;0;ON;;;;;N;;;;;
A4B3;YI RADICAL JO;So;0;ON;;;;;N;;;;;
A4B4;YI RADICAL NZUP;So;0;ON;;;;;N;;;;;
A4B5;YI RADICAL JJY;So;0;ON;;;;;N;;;;;
A4B6;YI RADICAL GOT;So;0;ON;;;;;N;;;;;
A4B7;YI RADICAL JJIE;So;0;ON;;;;;N;;;;;
A4B8;YI RADICAL WO;So;0;ON;;;;;N;;;;;
A4B9;YI RADICAL DU;So;0;ON;;;;;N;;;;;
A4BA;YI RADICAL SHUR;So;0;ON;;;;;N;;;;;
A4BB;YI RADICAL LIE;So;0;ON;;;;;N;;;;;
A4BC;YI RADICAL CY;So;0;ON;;;;;N;;;;;
A4BD;YI RADICAL CUOP;So;0;ON;;;;;N;;;;;
A4BE;YI RADICAL CIP;So;0;ON;;;;;N;;;;;
A4BF;YI RADICAL HXOP;So;0;ON;;;;;N;;;;;
A4C0;YI RADICAL SHAT;So;0;ON;;;;;N;;;;;
A4C1;YI RADICAL ZUR;So;0;ON;;;;;N;;;;;
A4C2;YI RADICAL SHOP;So;0;ON;;;;;N;;;;;
A4C3;YI RADICAL CHE;So;0;ON;;;;;N;;;;;
A4C4;YI RADICAL ZZIET;So;0;ON;;;;;N;;;;;
A4C5;YI RADICAL NBIE;So;0;ON;;;;;N;;;;;
A4C6;YI RADICAL KE;So;0;ON;;;;;N;;;;;
A4D0;LISU LETTER BA;Lo;0;L;;;;;N;;;;;
A4D1;LISU LETTER PA;Lo;0;L;;;;;N;;;;;
A4D2;LISU LETTER PHA;Lo;0;L;;;;;N;;;;;
A4D3;LISU LETTER DA;Lo;0;L;;;;;N;;;;;
A4D4;LISU LETTER TA;Lo;0;L;;;;;N;;;;;
A4D5;LISU LETTER THA;Lo;0;L;;;;;N;;;;;
A4D6;LISU LETTER GA;Lo;0;L;;;;;N;;;;;
A4D7;LISU LETTER KA;Lo;0;L;;;;;N;;;;;
A4D8;LISU LETTER KHA;Lo;0;L;;;;;N;;;;;
A4D9;LISU LETTER JA;Lo;0;L;;;;;N;;;;;
A4DA;LISU LETTER CA;Lo;0;L;;;;;N;;;;;
A4DB;LISU LETTER CHA;Lo;0;L;;;;;N;;;;;
A4DC;LISU LETTER DZA;Lo;0;L;;;;;N;;;;;
A4DD;LISU LETTER TSA;Lo;0;L;;;;;N;;;;;
A4DE;LISU LETTER TSHA;Lo;0;L;;;;;N;;;;;
A4DF;LISU LETTER MA;Lo;0;L;;;;;N;;;;;
A4E0;LISU LETTER NA;Lo;0;L;;;;;N;;;;;
A4E1;LISU LETTER LA;Lo;0;L;;;;;N;;;;;
A4E2;LISU LETTER SA;Lo;0;L;;;;;N;;;;;
A4E3;LISU LETTER ZHA;Lo;0;L;;;;;N;;;;;
A4E4;LISU LETTER ZA;Lo;0;L;;;;;N;;;;;
A4E5;LISU LETTER NGA;Lo;0;L;;;;;N;;;;;
A4E6;LISU LETTER HA;Lo;0;L;;;;;N;;;;;
A4E7;LISU LETTER XA;Lo;0;L;;;;;N;;;;;
A4E8;LISU LETTER HHA;Lo;0;L;;;;;N;;;;;
A4E9;LISU LETTER FA;Lo;0;L;;;;;N;;;;;
A4EA;LISU LETTER WA;Lo;0;L;;;;;N;;;;;
A4EB;LISU LETTER SHA;Lo;0;L;;;;;N;;;;;
A4EC;LISU LETTER YA;Lo;0;L;;;;;N;;;;;
A4ED;LISU LETTER GHA;Lo;0;L;;;;;N;;;;;
A4EE;LISU LETTER A;Lo;0;L;;;;;N;;;;;
A4EF;LISU LETTER AE;Lo;0;L;;;;;N;;;;;
A4F0;LISU LETTER E;Lo;0;L;;;;;N;;;;;
A4F1;LISU LETTER EU;Lo;0;L;;;;;N;;;;;
A4F2;LISU LETTER I;Lo;0;L;;;;;N;;;;;
A4F3;LISU LETTER O;Lo;0;L;;;;;N;;;;;
A4F4;LISU LETTER U;Lo;0;L;;;;;N;;;;;
A4F5;LISU LETTER UE;Lo;0;L;;;;;N;;;;;
A4F6;LISU LETTER UH;Lo;0;L;;;;;N;;;;;
A4F7;LISU LETTER OE;Lo;0;L;;;;;N;;;;;
A4F8;LISU LETTER TONE MYA TI;Lm;0;L;;;;;N;;;;;
A4F9;LISU LETTER TONE NA PO;Lm;0;L;;;;;N;;;;;
A4FA;LISU LETTER TONE MYA CYA;Lm;0;L;;;;;N;;;;;
A4FB;LISU LETTER TONE MYA BO;Lm;0;L;;;;;N;;;;;
A4FC;LISU LETTER TONE MYA NA;Lm;0;L;;;;;N;;;;;
A4FD;LISU LETTER TONE MYA JEU;Lm;0;L;;;;;N;;;;;
A4FE;LISU PUNCTUATION COMMA;Po;0;L;;;;;N;;;;;
A4FF;LISU PUNCTUATION FULL STOP;Po;0;L;;;;;N;;;;;
A500;VAI SYLLABLE EE;Lo;0;L;;;;;N;;;;;
A501;VAI SYLLABLE EEN;Lo;0;L;;;;;N;;;;;
A502;VAI SYLLABLE HEE;Lo;0;L;;;;;N;;;;;
A503;VAI SYLLABLE WEE;Lo;0;L;;;;;N;;;;;
A504;VAI SYLLABLE WEEN;Lo;0;L;;;;;N;;;;;
A505;VAI SYLLABLE PEE;Lo;0;L;;;;;N;;;;;
A506;VAI SYLLABLE BHEE;Lo;0;L;;;;;N;;;;;
A507;VAI SYLLABLE BEE;Lo;0;L;;;;;N;;;;;
A508;VAI SYLLABLE MBEE;Lo;0;L;;;;;N;;;;;
A509;VAI SYLLABLE KPEE;Lo;0;L;;;;;N;;;;;
A50A;VAI SYLLABLE MGBEE;Lo;0;L;;;;;N;;;;;
A50B;VAI SYLLABLE GBEE;Lo;0;L;;;;;N;;;;;
A50C;VAI SYLLABLE FEE;Lo;0;L;;;;;N;;;;;
A50D;VAI SYLLABLE VEE;Lo;0;L;;;;;N;;;;;
A50E;VAI SYLLABLE TEE;Lo;0;L;;;;;N;;;;;
A50F;VAI SYLLABLE THEE;Lo;0;L;;;;;N;;;;;
A510;VAI SYLLABLE DHEE;Lo;0;L;;;;;N;;;;;
A511;VAI SYLLABLE DHHEE;Lo;0;L;;;;;N;;;;;
A512;VAI SYLLABLE LEE;Lo;0;L;;;;;N;;;;;
A513;VAI SYLLABLE REE;Lo;0;L;;;;;N;;;;;
A514;VAI SYLLABLE DEE;Lo;0;L;;;;;N;;;;;
A515;VAI SYLLABLE NDEE;Lo;0;L;;;;;N;;;;;
A516;VAI SYLLABLE SEE;Lo;0;L;;;;;N;;;;;
A517;VAI SYLLABLE SHEE;Lo;0;L;;;;;N;;;;;
A518;VAI SYLLABLE ZEE;Lo;0;L;;;;;N;;;;;
A519;VAI SYLLABLE ZHEE;Lo;0;L;;;;;N;;;;;
A51A;VAI SYLLABLE CEE;Lo;0;L;;;;;N;;;;;
A51B;VAI SYLLABLE JEE;Lo;0;L;;;;;N;;;;;
A51C;VAI SYLLABLE NJEE;Lo;0;L;;;;;N;;;;;
A51D;VAI SYLLABLE YEE;Lo;0;L;;;;;N;;;;;
A51E;VAI SYLLABLE KEE;Lo;0;L;;;;;N;;;;;
A51F;VAI SYLLABLE NGGEE;Lo;0;L;;;;;N;;;;;
A520;VAI SYLLABLE GEE;Lo;0;L;;;;;N;;;;;
A521;VAI SYLLABLE MEE;Lo;0;L;;;;;N;;;;;
A522;VAI SYLLABLE NEE;Lo;0;L;;;;;N;;;;;
A523;VAI SYLLABLE NYEE;Lo;0;L;;;;;N;;;;;
A524;VAI SYLLABLE I;Lo;0;L;;;;;N;;;;;
A525;VAI SYLLABLE IN;Lo;0;L;;;;;N;;;;;
A526;VAI SYLLABLE HI;Lo;0;L;;;;;N;;;;;
A527;VAI SYLLABLE HIN;Lo;0;L;;;;;N;;;;;
A528;VAI SYLLABLE WI;Lo;0;L;;;;;N;;;;;
A529;VAI SYLLABLE WIN;Lo;0;L;;;;;N;;;;;
A52A;VAI SYLLABLE PI;Lo;0;L;;;;;N;;;;;
A52B;VAI SYLLABLE BHI;Lo;0;L;;;;;N;;;;;
A52C;VAI SYLLABLE BI;Lo;0;L;;;;;N;;;;;
A52D;VAI SYLLABLE MBI;Lo;0;L;;;;;N;;;;;
A52E;VAI SYLLABLE KPI;Lo;0;L;;;;;N;;;;;
A52F;VAI SYLLABLE MGBI;Lo;0;L;;;;;N;;;;;
A530;VAI SYLLABLE GBI;Lo;0;L;;;;;N;;;;;
A531;VAI SYLLABLE FI;Lo;0;L;;;;;N;;;;;
A532;VAI SYLLABLE VI;Lo;0;L;;;;;N;;;;;
A533;VAI SYLLABLE TI;Lo;0;L;;;;;N;;;;;
A534;VAI SYLLABLE THI;Lo;0;L;;;;;N;;;;;
A535;VAI SYLLABLE DHI;Lo;0;L;;;;;N;;;;;
A536;VAI SYLLABLE DHHI;Lo;0;L;;;;;N;;;;;
A537;VAI SYLLABLE LI;Lo;0;L;;;;;N;;;;;
A538;VAI SYLLABLE RI;Lo;0;L;;;;;N;;;;;
A539;VAI SYLLABLE DI;Lo;0;L;;;;;N;;;;;
A53A;VAI SYLLABLE NDI;Lo;0;L;;;;;N;;;;;
A53B;VAI SYLLABLE SI;Lo;0;L;;;;;N;;;;;
A53C;VAI SYLLABLE SHI;Lo;0;L;;;;;N;;;;;
A53D;VAI SYLLABLE ZI;Lo;0;L;;;;;N;;;;;
A53E;VAI SYLLABLE ZHI;Lo;0;L;;;;;N;;;;;
A53F;VAI SYLLABLE CI;Lo;0;L;;;;;N;;;;;
A540;VAI SYLLABLE JI;Lo;0;L;;;;;N;;;;;
A541;VAI SYLLABLE NJI;Lo;0;L;;;;;N;;;;;
A542;VAI SYLLABLE YI;Lo;0;L;;;;;N;;;;;
A543;VAI SYLLABLE KI;Lo;0;L;;;;;N;;;;;
A544;VAI SYLLABLE NGGI;Lo;0;L;;;;;N;;;;;
A545;VAI SYLLABLE GI;Lo;0;L;;;;;N;;;;;
A546;VAI SYLLABLE MI;Lo;0;L;;;;;N;;;;;
A547;VAI SYLLABLE NI;Lo;0;L;;;;;N;;;;;
A548;VAI SYLLABLE NYI;Lo;0;L;;;;;N;;;;;
A549;VAI SYLLABLE A;Lo;0;L;;;;;N;;;;;
A54A;VAI SYLLABLE AN;Lo;0;L;;;;;N;;;;;
A54B;VAI SYLLABLE NGAN;Lo;0;L;;;;;N;;;;;
A54C;VAI SYLLABLE HA;Lo;0;L;;;;;N;;;;;
A54D;VAI SYLLABLE HAN;Lo;0;L;;;;;N;;;;;
A54E;VAI SYLLABLE WA;Lo;0;L;;;;;N;;;;;
A54F;VAI SYLLABLE WAN;Lo;0;L;;;;;N;;;;;
A550;VAI SYLLABLE PA;Lo;0;L;;;;;N;;;;;
A551;VAI SYLLABLE BHA;Lo;0;L;;;;;N;;;;;
A552;VAI SYLLABLE BA;Lo;0;L;;;;;N;;;;;
A553;VAI SYLLABLE MBA;Lo;0;L;;;;;N;;;;;
A554;VAI SYLLABLE KPA;Lo;0;L;;;;;N;;;;;
A555;VAI SYLLABLE KPAN;Lo;0;L;;;;;N;;;;;
A556;VAI SYLLABLE MGBA;Lo;0;L;;;;;N;;;;;
A557;VAI SYLLABLE GBA;Lo;0;L;;;;;N;;;;;
A558;VAI SYLLABLE FA;Lo;0;L;;;;;N;;;;;
A559;VAI SYLLABLE VA;Lo;0;L;;;;;N;;;;;
A55A;VAI SYLLABLE TA;Lo;0;L;;;;;N;;;;;
A55B;VAI SYLLABLE THA;Lo;0;L;;;;;N;;;;;
A55C;VAI SYLLABLE DHA;Lo;0;L;;;;;N;;;;;
A55D;VAI SYLLABLE DHHA;Lo;0;L;;;;;N;;;;;
A55E;VAI SYLLABLE LA;Lo;0;L;;;;;N;;;;;
A55F;VAI SYLLABLE RA;Lo;0;L;;;;;N;;;;;
A560;VAI SYLLABLE DA;Lo;0;L;;;;;N;;;;;
A561;VAI SYLLABLE NDA;Lo;0;L;;;;;N;;;;;
A562;VAI SYLLABLE SA;Lo;0;L;;;;;N;;;;;
A563;VAI SYLLABLE SHA;Lo;0;L;;;;;N;;;;;
A564;VAI SYLLABLE ZA;Lo;0;L;;;;;N;;;;;
A565;VAI SYLLABLE ZHA;Lo;0;L;;;;;N;;;;;
A566;VAI SYLLABLE CA;Lo;0;L;;;;;N;;;;;
A567;VAI SYLLABLE JA;Lo;0;L;;;;;N;;;;;
A568;VAI SYLLABLE NJA;Lo;0;L;;;;;N;;;;;
A569;VAI SYLLABLE YA;Lo;0;L;;;;;N;;;;;
A56A;VAI SYLLABLE KA;Lo;0;L;;;;;N;;;;;
A56B;VAI SYLLABLE KAN;Lo;0;L;;;;;N;;;;;
A56C;VAI SYLLABLE NGGA;Lo;0;L;;;;;N;;;;;
A56D;VAI SYLLABLE GA;Lo;0;L;;;;;N;;;;;
A56E;VAI SYLLABLE MA;Lo;0;L;;;;;N;;;;;
A56F;VAI SYLLABLE NA;Lo;0;L;;;;;N;;;;;
A570;VAI SYLLABLE NYA;Lo;0;L;;;;;N;;;;;
A571;VAI SYLLABLE OO;Lo;0;L;;;;;N;;;;;
A572;VAI SYLLABLE OON;Lo;0;L;;;;;N;;;;;
A573;VAI SYLLABLE HOO;Lo;0;L;;;;;N;;;;;
A574;VAI SYLLABLE WOO;Lo;0;L;;;;;N;;;;;
A575;VAI SYLLABLE WOON;Lo;0;L;;;;;N;;;;;
A576;VAI SYLLABLE POO;Lo;0;L;;;;;N;;;;;
A577;VAI SYLLABLE BHOO;Lo;0;L;;;;;N;;;;;
A578;VAI SYLLABLE BOO;Lo;0;L;;;;;N;;;;;
A579;VAI SYLLABLE MBOO;Lo;0;L;;;;;N;;;;;
A57A;VAI SYLLABLE KPOO;Lo;0;L;;;;;N;;;;;
A57B;VAI SYLLABLE MGBOO;Lo;0;L;;;;;N;;;;;
A57C;VAI SYLLABLE GBOO;Lo;0;L;;;;;N;;;;;
A57D;VAI SYLLABLE FOO;Lo;0;L;;;;;N;;;;;
A57E;VAI SYLLABLE VOO;Lo;0;L;;;;;N;;;;;
A57F;VAI SYLLABLE TOO;Lo;0;L;;;;;N;;;;;
A580;VAI SYLLABLE THOO;Lo;0;L;;;;;N;;;;;
A581;VAI SYLLABLE DHOO;Lo;0;L;;;;;N;;;;;
A582;VAI SYLLABLE DHHOO;Lo;0;L;;;;;N;;;;;
A583;VAI SYLLABLE LOO;Lo;0;L;;;;;N;;;;;
A584;VAI SYLLABLE ROO;Lo;0;L;;;;;N;;;;;
A585;VAI SYLLABLE DOO;Lo;0;L;;;;;N;;;;;
A586;VAI SYLLABLE NDOO;Lo;0;L;;;;;N;;;;;
A587;VAI SYLLABLE SOO;Lo;0;L;;;;;N;;;;;
A588;VAI SYLLABLE SHOO;Lo;0;L;;;;;N;;;;;
A589;VAI SYLLABLE ZOO;Lo;0;L;;;;;N;;;;;
A58A;VAI SYLLABLE ZHOO;Lo;0;L;;;;;N;;;;;
A58B;VAI SYLLABLE COO;Lo;0;L;;;;;N;;;;;
A58C;VAI SYLLABLE JOO;Lo;0;L;;;;;N;;;;;
A58D;VAI SYLLABLE NJOO;Lo;0;L;;;;;N;;;;;
A58E;VAI SYLLABLE YOO;Lo;0;L;;;;;N;;;;;
A58F;VAI SYLLABLE KOO;Lo;0;L;;;;;N;;;;;
A590;VAI SYLLABLE NGGOO;Lo;0;L;;;;;N;;;;;
A591;VAI SYLLABLE GOO;Lo;0;L;;;;;N;;;;;
A592;VAI SYLLABLE MOO;Lo;0;L;;;;;N;;;;;
A593;VAI SYLLABLE NOO;Lo;0;L;;;;;N;;;;;
A594;VAI SYLLABLE NYOO;Lo;0;L;;;;;N;;;;;
A595;VAI SYLLABLE U;Lo;0;L;;;;;N;;;;;
A596;VAI SYLLABLE UN;Lo;0;L;;;;;N;;;;;
A597;VAI SYLLABLE HU;Lo;0;L;;;;;N;;;;;
A598;VAI SYLLABLE HUN;Lo;0;L;;;;;N;;;;;
A599;VAI SYLLABLE WU;Lo;0;L;;;;;N;;;;;
A59A;VAI SYLLABLE WUN;Lo;0;L;;;;;N;;;;;
A59B;VAI SYLLABLE PU;Lo;0;L;;;;;N;;;;;
A59C;VAI SYLLABLE BHU;Lo;0;L;;;;;N;;;;;
A59D;VAI SYLLABLE BU;Lo;0;L;;;;;N;;;;;
A59E;VAI SYLLABLE MBU;Lo;0;L;;;;;N;;;;;
A59F;VAI SYLLABLE KPU;Lo;0;L;;;;;N;;;;;
A5A0;VAI SYLLABLE MGBU;Lo;0;L;;;;;N;;;;;
A5A1;VAI SYLLABLE GBU;Lo;0;L;;;;;N;;;;;
A5A2;VAI SYLLABLE FU;Lo;0;L;;;;;N;;;;;
A5A3;VAI SYLLABLE VU;Lo;0;L;;;;;N;;;;;
A5A4;VAI SYLLABLE TU;Lo;0;L;;;;;N;;;;;
A5A5;VAI SYLLABLE THU;Lo;0;L;;;;;N;;;;;
A5A6;VAI SYLLABLE DHU;Lo;0;L;;;;;N;;;;;
A5A7;VAI SYLLABLE DHHU;Lo;0;L;;;;;N;;;;;
A5A8;VAI SYLLABLE LU;Lo;0;L;;;;;N;;;;;
A5A9;VAI SYLLABLE RU;Lo;0;L;;;;;N;;;;;
A5AA;VAI SYLLABLE DU;Lo;0;L;;;;;N;;;;;
A5AB;VAI SYLLABLE NDU;Lo;0;L;;;;;N;;;;;
A5AC;VAI SYLLABLE SU;Lo;0;L;;;;;N;;;;;
A5AD;VAI SYLLABLE SHU;Lo;0;L;;;;;N;;;;;
A5AE;VAI SYLLABLE ZU;Lo;0;L;;;;;N;;;;;
A5AF;VAI SYLLABLE ZHU;Lo;0;L;;;;;N;;;;;
A5B0;VAI SYLLABLE CU;Lo;0;L;;;;;N;;;;;
A5B1;VAI SYLLABLE JU;Lo;0;L;;;;;N;;;;;
A5B2;VAI SYLLABLE NJU;Lo;0;L;;;;;N;;;;;
A5B3;VAI SYLLABLE YU;Lo;0;L;;;;;N;;;;;
A5B4;VAI SYLLABLE KU;Lo;0;L;;;;;N;;;;;
A5B5;VAI SYLLABLE NGGU;Lo;0;L;;;;;N;;;;;
A5B6;VAI SYLLABLE GU;Lo;0;L;;;;;N;;;;;
A5B7;VAI SYLLABLE MU;Lo;0;L;;;;;N;;;;;
A5B8;VAI SYLLABLE NU;Lo;0;L;;;;;N;;;;;
A5B9;VAI SYLLABLE NYU;Lo;0;L;;;;;N;;;;;
A5BA;VAI SYLLABLE O;Lo;0;L;;;;;N;;;;;
A5BB;VAI SYLLABLE ON;Lo;0;L;;;;;N;;;;;
A5BC;VAI SYLLABLE NGON;Lo;0;L;;;;;N;;;;;
A5BD;VAI SYLLABLE HO;Lo;0;L;;;;;N;;;;;
A5BE;VAI SYLLABLE HON;Lo;0;L;;;;;N;;;;;
A5BF;VAI SYLLABLE WO;Lo;0;L;;;;;N;;;;;
A5C0;VAI SYLLABLE WON;Lo;0;L;;;;;N;;;;;
A5C1;VAI SYLLABLE PO;Lo;0;L;;;;;N;;;;;
A5C2;VAI SYLLABLE BHO;Lo;0;L;;;;;N;;;;;
A5C3;VAI SYLLABLE BO;Lo;0;L;;;;;N;;;;;
A5C4;VAI SYLLABLE MBO;Lo;0;L;;;;;N;;;;;
A5C5;VAI SYLLABLE KPO;Lo;0;L;;;;;N;;;;;
A5C6;VAI SYLLABLE MGBO;Lo;0;L;;;;;N;;;;;
A5C7;VAI SYLLABLE GBO;Lo;0;L;;;;;N;;;;;
A5C8;VAI SYLLABLE GBON;Lo;0;L;;;;;N;;;;;
A5C9;VAI SYLLABLE FO;Lo;0;L;;;;;N;;;;;
A5CA;VAI SYLLABLE VO;Lo;0;L;;;;;N;;;;;
A5CB;VAI SYLLABLE TO;Lo;0;L;;;;;N;;;;;
A5CC;VAI SYLLABLE THO;Lo;0;L;;;;;N;;;;;
A5CD;VAI SYLLABLE DHO;Lo;0;L;;;;;N;;;;;
A5CE;VAI SYLLABLE DHHO;Lo;0;L;;;;;N;;;;;
A5CF;VAI SYLLABLE LO;Lo;0;L;;;;;N;;;;;
A5D0;VAI SYLLABLE RO;Lo;0;L;;;;;N;;;;;
A5D1;VAI SYLLABLE DO;Lo;0;L;;;;;N;;;;;
A5D2;VAI SYLLABLE NDO;Lo;0;L;;;;;N;;;;;
A5D3;VAI SYLLABLE SO;Lo;0;L;;;;;N;;;;;
A5D4;VAI SYLLABLE SHO;Lo;0;L;;;;;N;;;;;
A5D5;VAI SYLLABLE ZO;Lo;0;L;;;;;N;;;;;
A5D6;VAI SYLLABLE ZHO;Lo;0;L;;;;;N;;;;;
A5D7;VAI SYLLABLE CO;Lo;0;L;;;;;N;;;;;
A5D8;VAI SYLLABLE JO;Lo;0;L;;;;;N;;;;;
A5D9;VAI SYLLABLE NJO;Lo;0;L;;;;;N;;;;;
A5DA;VAI SYLLABLE YO;Lo;0;L;;;;;N;;;;;
A5DB;VAI SYLLABLE KO;Lo;0;L;;;;;N;;;;;
A5DC;VAI SYLLABLE NGGO;Lo;0;L;;;;;N;;;;;
A5DD;VAI SYLLABLE GO;Lo;0;L;;;;;N;;;;;
A5DE;VAI SYLLABLE MO;Lo;0;L;;;;;N;;;;;
A5DF;VAI SYLLABLE NO;Lo;0;L;;;;;N;;;;;
A5E0;VAI SYLLABLE NYO;Lo;0;L;;;;;N;;;;;
A5E1;VAI SYLLABLE E;Lo;0;L;;;;;N;;;;;
A5E2;VAI SYLLABLE EN;Lo;0;L;;;;;N;;;;;
A5E3;VAI SYLLABLE NGEN;Lo;0;L;;;;;N;;;;;
A5E4;VAI SYLLABLE HE;Lo;0;L;;;;;N;;;;;
A5E5;VAI SYLLABLE HEN;Lo;0;L;;;;;N;;;;;
A5E6;VAI SYLLABLE WE;Lo;0;L;;;;;N;;;;;
A5E7;VAI SYLLABLE WEN;Lo;0;L;;;;;N;;;;;
A5E8;VAI SYLLABLE PE;Lo;0;L;;;;;N;;;;;
A5E9;VAI SYLLABLE BHE;Lo;0;L;;;;;N;;;;;
A5EA;VAI SYLLABLE BE;Lo;0;L;;;;;N;;;;;
A5EB;VAI SYLLABLE MBE;Lo;0;L;;;;;N;;;;;
A5EC;VAI SYLLABLE KPE;Lo;0;L;;;;;N;;;;;
A5ED;VAI SYLLABLE KPEN;Lo;0;L;;;;;N;;;;;
A5EE;VAI SYLLABLE MGBE;Lo;0;L;;;;;N;;;;;
A5EF;VAI SYLLABLE GBE;Lo;0;L;;;;;N;;;;;
A5F0;VAI SYLLABLE GBEN;Lo;0;L;;;;;N;;;;;
A5F1;VAI SYLLABLE FE;Lo;0;L;;;;;N;;;;;
A5F2;VAI SYLLABLE VE;Lo;0;L;;;;;N;;;;;
A5F3;VAI SYLLABLE TE;Lo;0;L;;;;;N;;;;;
A5F4;VAI SYLLABLE THE;Lo;0;L;;;;;N;;;;;
A5F5;VAI SYLLABLE DHE;Lo;0;L;;;;;N;;;;;
A5F6;VAI SYLLABLE DHHE;Lo;0;L;;;;;N;;;;;
A5F7;VAI SYLLABLE LE;Lo;0;L;;;;;N;;;;;
A5F8;VAI SYLLABLE RE;Lo;0;L;;;;;N;;;;;
A5F9;VAI SYLLABLE DE;Lo;0;L;;;;;N;;;;;
A5FA;VAI SYLLABLE NDE;Lo;0;L;;;;;N;;;;;
A5FB;VAI SYLLABLE SE;Lo;0;L;;;;;N;;;;;
A5FC;VAI SYLLABLE SHE;Lo;0;L;;;;;N;;;;;
A5FD;VAI SYLLABLE ZE;Lo;0;L;;;;;N;;;;;
A5FE;VAI SYLLABLE ZHE;Lo;0;L;;;;;N;;;;;
A5FF;VAI SYLLABLE CE;Lo;0;L;;;;;N;;;;;
A600;VAI SYLLABLE JE;Lo;0;L;;;;;N;;;;;
A601;VAI SYLLABLE NJE;Lo;0;L;;;;;N;;;;;
A602;VAI SYLLABLE YE;Lo;0;L;;;;;N;;;;;
A603;VAI SYLLABLE KE;Lo;0;L;;;;;N;;;;;
A604;VAI SYLLABLE NGGE;Lo;0;L;;;;;N;;;;;
A605;VAI SYLLABLE NGGEN;Lo;0;L;;;;;N;;;;;
A606;VAI SYLLABLE GE;Lo;0;L;;;;;N;;;;;
A607;VAI SYLLABLE GEN;Lo;0;L;;;;;N;;;;;
A608;VAI SYLLABLE ME;Lo;0;L;;;;;N;;;;;
A609;VAI SYLLABLE NE;Lo;0;L;;;;;N;;;;;
A60A;VAI SYLLABLE NYE;Lo;0;L;;;;;N;;;;;
A60B;VAI SYLLABLE NG;Lo;0;L;;;;;N;;;;;
A60C;VAI SYLLABLE LENGTHENER;Lm;0;L;;;;;N;;;;;
A60D;VAI COMMA;Po;0;ON;;;;;N;;;;;
A60E;VAI FULL STOP;Po;0;ON;;;;;N;;;;;
A60F;VAI QUESTION MARK;Po;0;ON;;;;;N;;;;;
A610;VAI SYLLABLE NDOLE FA;Lo;0;L;;;;;N;;;;;
A611;VAI SYLLABLE NDOLE KA;Lo;0;L;;;;;N;;;;;
A612;VAI SYLLABLE NDOLE SOO;Lo;0;L;;;;;N;;;;;
A613;VAI SYMBOL FEENG;Lo;0;L;;;;;N;;;;;
A614;VAI SYMBOL KEENG;Lo;0;L;;;;;N;;;;;
A615;VAI SYMBOL TING;Lo;0;L;;;;;N;;;;;
A616;VAI SYMBOL NII;Lo;0;L;;;;;N;;;;;
A617;VAI SYMBOL BANG;Lo;0;L;;;;;N;;;;;
A618;VAI SYMBOL FAA;Lo;0;L;;;;;N;;;;;
A619;VAI SYMBOL TAA;Lo;0;L;;;;;N;;;;;
A61A;VAI SYMBOL DANG;Lo;0;L;;;;;N;;;;;
A61B;VAI SYMBOL DOONG;Lo;0;L;;;;;N;;;;;
A61C;VAI SYMBOL KUNG;Lo;0;L;;;;;N;;;;;
A61D;VAI SYMBOL TONG;Lo;0;L;;;;;N;;;;;
A61E;VAI SYMBOL DO-O;Lo;0;L;;;;;N;;;;;
A61F;VAI SYMBOL JONG;Lo;0;L;;;;;N;;;;;
A620;VAI DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
A621;VAI DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
A622;VAI DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
A623;VAI DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
A624;VAI DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
A625;VAI DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
A626;VAI DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
A627;VAI DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
A628;VAI DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
A629;VAI DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
A62A;VAI SYLLABLE NDOLE MA;Lo;0;L;;;;;N;;;;;
A62B;VAI SYLLABLE NDOLE DO;Lo;0;L;;;;;N;;;;;
A640;CYRILLIC CAPITAL LETTER ZEMLYA;Lu;0;L;;;;;N;;;;A641;
A641;CYRILLIC SMALL LETTER ZEMLYA;Ll;0;L;;;;;N;;;A640;;A640
A642;CYRILLIC CAPITAL LETTER DZELO;Lu;0;L;;;;;N;;;;A643;
A643;CYRILLIC SMALL LETTER DZELO;Ll;0;L;;;;;N;;;A642;;A642
A644;CYRILLIC CAPITAL LETTER REVERSED DZE;Lu;0;L;;;;;N;;;;A645;
A645;CYRILLIC SMALL LETTER REVERSED DZE;Ll;0;L;;;;;N;;;A644;;A644
A646;CYRILLIC CAPITAL LETTER IOTA;Lu;0;L;;;;;N;;;;A647;
A647;CYRILLIC SMALL LETTER IOTA;Ll;0;L;;;;;N;;;A646;;A646
A648;CYRILLIC CAPITAL LETTER DJERV;Lu;0;L;;;;;N;;;;A649;
A649;CYRILLIC SMALL LETTER DJERV;Ll;0;L;;;;;N;;;A648;;A648
A64A;CYRILLIC CAPITAL LETTER MONOGRAPH UK;Lu;0;L;;;;;N;;;;A64B;
A64B;CYRILLIC SMALL LETTER MONOGRAPH UK;Ll;0;L;;;;;N;;;A64A;;A64A
A64C;CYRILLIC CAPITAL LETTER BROAD OMEGA;Lu;0;L;;;;;N;;;;A64D;
A64D;CYRILLIC SMALL LETTER BROAD OMEGA;Ll;0;L;;;;;N;;;A64C;;A64C
A64E;CYRILLIC CAPITAL LETTER NEUTRAL YER;Lu;0;L;;;;;N;;;;A64F;
A64F;CYRILLIC SMALL LETTER NEUTRAL YER;Ll;0;L;;;;;N;;;A64E;;A64E
A650;CYRILLIC CAPITAL LETTER YERU WITH BACK YER;Lu;0;L;;;;;N;;;;A651;
A651;CYRILLIC SMALL LETTER YERU WITH BACK YER;Ll;0;L;;;;;N;;;A650;;A650
A652;CYRILLIC CAPITAL LETTER IOTIFIED YAT;Lu;0;L;;;;;N;;;;A653;
A653;CYRILLIC SMALL LETTER IOTIFIED YAT;Ll;0;L;;;;;N;;;A652;;A652
A654;CYRILLIC CAPITAL LETTER REVERSED YU;Lu;0;L;;;;;N;;;;A655;
A655;CYRILLIC SMALL LETTER REVERSED YU;Ll;0;L;;;;;N;;;A654;;A654
A656;CYRILLIC CAPITAL LETTER IOTIFIED A;Lu;0;L;;;;;N;;;;A657;
A657;CYRILLIC SMALL LETTER IOTIFIED A;Ll;0;L;;;;;N;;;A656;;A656
A658;CYRILLIC CAPITAL LETTER CLOSED LITTLE YUS;Lu;0;L;;;;;N;;;;A659;
A659;CYRILLIC SMALL LETTER CLOSED LITTLE YUS;Ll;0;L;;;;;N;;;A658;;A658
A65A;CYRILLIC CAPITAL LETTER BLENDED YUS;Lu;0;L;;;;;N;;;;A65B;
A65B;CYRILLIC SMALL LETTER BLENDED YUS;Ll;0;L;;;;;N;;;A65A;;A65A
A65C;CYRILLIC CAPITAL LETTER IOTIFIED CLOSED LITTLE YUS;Lu;0;L;;;;;N;;;;A65D;
A65D;CYRILLIC SMALL LETTER IOTIFIED CLOSED LITTLE YUS;Ll;0;L;;;;;N;;;A65C;;A65C
A65E;CYRILLIC CAPITAL LETTER YN;Lu;0;L;;;;;N;;;;A65F;
A65F;CYRILLIC SMALL LETTER YN;Ll;0;L;;;;;N;;;A65E;;A65E
A660;CYRILLIC CAPITAL LETTER REVERSED TSE;Lu;0;L;;;;;N;;;;A661;
A661;CYRILLIC SMALL LETTER REVERSED TSE;Ll;0;L;;;;;N;;;A660;;A660
A662;CYRILLIC CAPITAL LETTER SOFT DE;Lu;0;L;;;;;N;;;;A663;
A663;CYRILLIC SMALL LETTER SOFT DE;Ll;0;L;;;;;N;;;A662;;A662
A664;CYRILLIC CAPITAL LETTER SOFT EL;Lu;0;L;;;;;N;;;;A665;
A665;CYRILLIC SMALL LETTER SOFT EL;Ll;0;L;;;;;N;;;A664;;A664
A666;CYRILLIC CAPITAL LETTER SOFT EM;Lu;0;L;;;;;N;;;;A667;
A667;CYRILLIC SMALL LETTER SOFT EM;Ll;0;L;;;;;N;;;A666;;A666
A668;CYRILLIC CAPITAL LETTER MONOCULAR O;Lu;0;L;;;;;N;;;;A669;
A669;CYRILLIC SMALL LETTER MONOCULAR O;Ll;0;L;;;;;N;;;A668;;A668
A66A;CYRILLIC CAPITAL LETTER BINOCULAR O;Lu;0;L;;;;;N;;;;A66B;
A66B;CYRILLIC SMALL LETTER BINOCULAR O;Ll;0;L;;;;;N;;;A66A;;A66A
A66C;CYRILLIC CAPITAL LETTER DOUBLE MONOCULAR O;Lu;0;L;;;;;N;;;;A66D;
A66D;CYRILLIC SMALL LETTER DOUBLE MONOCULAR O;Ll;0;L;;;;;N;;;A66C;;A66C
A66E;CYRILLIC LETTER MULTIOCULAR O;Lo;0;L;;;;;N;;;;;
A66F;COMBINING CYRILLIC VZMET;Mn;230;NSM;;;;;N;;;;;
A670;COMBINING CYRILLIC TEN MILLIONS SIGN;Me;0;NSM;;;;;N;;;;;
A671;COMBINING CYRILLIC HUNDRED MILLIONS SIGN;Me;0;NSM;;;;;N;;;;;
A672;COMBINING CYRILLIC THOUSAND MILLIONS SIGN;Me;0;NSM;;;;;N;;;;;
A673;SLAVONIC ASTERISK;Po;0;ON;;;;;N;;;;;
A674;COMBINING CYRILLIC LETTER UKRAINIAN IE;Mn;230;NSM;;;;;N;;;;;
A675;COMBINING CYRILLIC LETTER I;Mn;230;NSM;;;;;N;;;;;
A676;COMBINING CYRILLIC LETTER YI;Mn;230;NSM;;;;;N;;;;;
A677;COMBINING CYRILLIC LETTER U;Mn;230;NSM;;;;;N;;;;;
A678;COMBINING CYRILLIC LETTER HARD SIGN;Mn;230;NSM;;;;;N;;;;;
A679;COMBINING CYRILLIC LETTER YERU;Mn;230;NSM;;;;;N;;;;;
A67A;COMBINING CYRILLIC LETTER SOFT SIGN;Mn;230;NSM;;;;;N;;;;;
A67B;COMBINING CYRILLIC LETTER OMEGA;Mn;230;NSM;;;;;N;;;;;
A67C;COMBINING CYRILLIC KAVYKA;Mn;230;NSM;;;;;N;;;;;
A67D;COMBINING CYRILLIC PAYEROK;Mn;230;NSM;;;;;N;;;;;
A67E;CYRILLIC KAVYKA;Po;0;ON;;;;;N;;;;;
A67F;CYRILLIC PAYEROK;Lm;0;ON;;;;;N;;;;;
A680;CYRILLIC CAPITAL LETTER DWE;Lu;0;L;;;;;N;;;;A681;
A681;CYRILLIC SMALL LETTER DWE;Ll;0;L;;;;;N;;;A680;;A680
A682;CYRILLIC CAPITAL LETTER DZWE;Lu;0;L;;;;;N;;;;A683;
A683;CYRILLIC SMALL LETTER DZWE;Ll;0;L;;;;;N;;;A682;;A682
A684;CYRILLIC CAPITAL LETTER ZHWE;Lu;0;L;;;;;N;;;;A685;
A685;CYRILLIC SMALL LETTER ZHWE;Ll;0;L;;;;;N;;;A684;;A684
A686;CYRILLIC CAPITAL LETTER CCHE;Lu;0;L;;;;;N;;;;A687;
A687;CYRILLIC SMALL LETTER CCHE;Ll;0;L;;;;;N;;;A686;;A686
A688;CYRILLIC CAPITAL LETTER DZZE;Lu;0;L;;;;;N;;;;A689;
A689;CYRILLIC SMALL LETTER DZZE;Ll;0;L;;;;;N;;;A688;;A688
A68A;CYRILLIC CAPITAL LETTER TE WITH MIDDLE HOOK;Lu;0;L;;;;;N;;;;A68B;
A68B;CYRILLIC SMALL LETTER TE WITH MIDDLE HOOK;Ll;0;L;;;;;N;;;A68A;;A68A
A68C;CYRILLIC CAPITAL LETTER TWE;Lu;0;L;;;;;N;;;;A68D;
A68D;CYRILLIC SMALL LETTER TWE;Ll;0;L;;;;;N;;;A68C;;A68C
A68E;CYRILLIC CAPITAL LETTER TSWE;Lu;0;L;;;;;N;;;;A68F;
A68F;CYRILLIC SMALL LETTER TSWE;Ll;0;L;;;;;N;;;A68E;;A68E
A690;CYRILLIC CAPITAL LETTER TSSE;Lu;0;L;;;;;N;;;;A691;
A691;CYRILLIC SMALL LETTER TSSE;Ll;0;L;;;;;N;;;A690;;A690
A692;CYRILLIC CAPITAL LETTER TCHE;Lu;0;L;;;;;N;;;;A693;
A693;CYRILLIC SMALL LETTER TCHE;Ll;0;L;;;;;N;;;A692;;A692
A694;CYRILLIC CAPITAL LETTER HWE;Lu;0;L;;;;;N;;;;A695;
A695;CYRILLIC SMALL LETTER HWE;Ll;0;L;;;;;N;;;A694;;A694
A696;CYRILLIC CAPITAL LETTER SHWE;Lu;0;L;;;;;N;;;;A697;
A697;CYRILLIC SMALL LETTER SHWE;Ll;0;L;;;;;N;;;A696;;A696
A698;CYRILLIC CAPITAL LETTER DOUBLE O;Lu;0;L;;;;;N;;;;A699;
A699;CYRILLIC SMALL LETTER DOUBLE O;Ll;0;L;;;;;N;;;A698;;A698
A69A;CYRILLIC CAPITAL LETTER CROSSED O;Lu;0;L;;;;;N;;;;A69B;
A69B;CYRILLIC SMALL LETTER CROSSED O;Ll;0;L;;;;;N;;;A69A;;A69A
A69C;MODIFIER LETTER CYRILLIC HARD SIGN;Lm;0;L;<super> 044A;;;;N;;;;;
A69D;MODIFIER LETTER CYRILLIC SOFT SIGN;Lm;0;L;<super> 044C;;;;N;;;;;
A69E;COMBINING CYRILLIC LETTER EF;Mn;230;NSM;;;;;N;;;;;
A69F;COMBINING CYRILLIC LETTER IOTIFIED E;Mn;230;NSM;;;;;N;;;;;
A6A0;BAMUM LETTER A;Lo;0;L;;;;;N;;;;;
A6A1;BAMUM LETTER KA;Lo;0;L;;;;;N;;;;;
A6A2;BAMUM LETTER U;Lo;0;L;;;;;N;;;;;
A6A3;BAMUM LETTER KU;Lo;0;L;;;;;N;;;;;
A6A4;BAMUM LETTER EE;Lo;0;L;;;;;N;;;;;
A6A5;BAMUM LETTER REE;Lo;0;L;;;;;N;;;;;
A6A6;BAMUM LETTER TAE;Lo;0;L;;;;;N;;;;;
A6A7;BAMUM LETTER O;Lo;0;L;;;;;N;;;;;
A6A8;BAMUM LETTER NYI;Lo;0;L;;;;;N;;;;;
A6A9;BAMUM LETTER I;Lo;0;L;;;;;N;;;;;
A6AA;BAMUM LETTER LA;Lo;0;L;;;;;N;;;;;
A6AB;BAMUM LETTER PA;Lo;0;L;;;;;N;;;;;
A6AC;BAMUM LETTER RII;Lo;0;L;;;;;N;;;;;
A6AD;BAMUM LETTER RIEE;Lo;0;L;;;;;N;;;;;
A6AE;BAMUM LETTER LEEEE;Lo;0;L;;;;;N;;;;;
A6AF;BAMUM LETTER MEEEE;Lo;0;L;;;;;N;;;;;
A6B0;BAMUM LETTER TAA;Lo;0;L;;;;;N;;;;;
A6B1;BAMUM LETTER NDAA;Lo;0;L;;;;;N;;;;;
A6B2;BAMUM LETTER NJAEM;Lo;0;L;;;;;N;;;;;
A6B3;BAMUM LETTER M;Lo;0;L;;;;;N;;;;;
A6B4;BAMUM LETTER SUU;Lo;0;L;;;;;N;;;;;
A6B5;BAMUM LETTER MU;Lo;0;L;;;;;N;;;;;
A6B6;BAMUM LETTER SHII;Lo;0;L;;;;;N;;;;;
A6B7;BAMUM LETTER SI;Lo;0;L;;;;;N;;;;;
A6B8;BAMUM LETTER SHEUX;Lo;0;L;;;;;N;;;;;
A6B9;BAMUM LETTER SEUX;Lo;0;L;;;;;N;;;;;
A6BA;BAMUM LETTER KYEE;Lo;0;L;;;;;N;;;;;
A6BB;BAMUM LETTER KET;Lo;0;L;;;;;N;;;;;
A6BC;BAMUM LETTER NUAE;Lo;0;L;;;;;N;;;;;
A6BD;BAMUM LETTER NU;Lo;0;L;;;;;N;;;;;
A6BE;BAMUM LETTER NJUAE;Lo;0;L;;;;;N;;;;;
A6BF;BAMUM LETTER YOQ;Lo;0;L;;;;;N;;;;;
A6C0;BAMUM LETTER SHU;Lo;0;L;;;;;N;;;;;
A6C1;BAMUM LETTER YUQ;Lo;0;L;;;;;N;;;;;
A6C2;BAMUM LETTER YA;Lo;0;L;;;;;N;;;;;
A6C3;BAMUM LETTER NSHA;Lo;0;L;;;;;N;;;;;
A6C4;BAMUM LETTER KEUX;Lo;0;L;;;;;N;;;;;
A6C5;BAMUM LETTER PEUX;Lo;0;L;;;;;N;;;;;
A6C6;BAMUM LETTER NJEE;Lo;0;L;;;;;N;;;;;
A6C7;BAMUM LETTER NTEE;Lo;0;L;;;;;N;;;;;
A6C8;BAMUM LETTER PUE;Lo;0;L;;;;;N;;;;;
A6C9;BAMUM LETTER WUE;Lo;0;L;;;;;N;;;;;
A6CA;BAMUM LETTER PEE;Lo;0;L;;;;;N;;;;;
A6CB;BAMUM LETTER FEE;Lo;0;L;;;;;N;;;;;
A6CC;BAMUM LETTER RU;Lo;0;L;;;;;N;;;;;
A6CD;BAMUM LETTER LU;Lo;0;L;;;;;N;;;;;
A6CE;BAMUM LETTER MI;Lo;0;L;;;;;N;;;;;
A6CF;BAMUM LETTER NI;Lo;0;L;;;;;N;;;;;
A6D0;BAMUM LETTER REUX;Lo;0;L;;;;;N;;;;;
A6D1;BAMUM LETTER RAE;Lo;0;L;;;;;N;;;;;
A6D2;BAMUM LETTER KEN;Lo;0;L;;;;;N;;;;;
A6D3;BAMUM LETTER NGKWAEN;Lo;0;L;;;;;N;;;;;
A6D4;BAMUM LETTER NGGA;Lo;0;L;;;;;N;;;;;
A6D5;BAMUM LETTER NGA;Lo;0;L;;;;;N;;;;;
A6D6;BAMUM LETTER SHO;Lo;0;L;;;;;N;;;;;
A6D7;BAMUM LETTER PUAE;Lo;0;L;;;;;N;;;;;
A6D8;BAMUM LETTER FU;Lo;0;L;;;;;N;;;;;
A6D9;BAMUM LETTER FOM;Lo;0;L;;;;;N;;;;;
A6DA;BAMUM LETTER WA;Lo;0;L;;;;;N;;;;;
A6DB;BAMUM LETTER NA;Lo;0;L;;;;;N;;;;;
A6DC;BAMUM LETTER LI;Lo;0;L;;;;;N;;;;;
A6DD;BAMUM LETTER PI;Lo;0;L;;;;;N;;;;;
A6DE;BAMUM LETTER LOQ;Lo;0;L;;;;;N;;;;;
A6DF;BAMUM LETTER KO;Lo;0;L;;;;;N;;;;;
A6E0;BAMUM LETTER MBEN;Lo;0;L;;;;;N;;;;;
A6E1;BAMUM LETTER REN;Lo;0;L;;;;;N;;;;;
A6E2;BAMUM LETTER MEN;Lo;0;L;;;;;N;;;;;
A6E3;BAMUM LETTER MA;Lo;0;L;;;;;N;;;;;
A6E4;BAMUM LETTER TI;Lo;0;L;;;;;N;;;;;
A6E5;BAMUM LETTER KI;Lo;0;L;;;;;N;;;;;
A6E6;BAMUM LETTER MO;Nl;0;L;;;;1;N;;;;;
A6E7;BAMUM LETTER MBAA;Nl;0;L;;;;2;N;;;;;
A6E8;BAMUM LETTER TET;Nl;0;L;;;;3;N;;;;;
A6E9;BAMUM LETTER KPA;Nl;0;L;;;;4;N;;;;;
A6EA;BAMUM LETTER TEN;Nl;0;L;;;;5;N;;;;;
A6EB;BAMUM LETTER NTUU;Nl;0;L;;;;6;N;;;;;
A6EC;BAMUM LETTER SAMBA;Nl;0;L;;;;7;N;;;;;
A6ED;BAMUM LETTER FAAMAE;Nl;0;L;;;;8;N;;;;;
A6EE;BAMUM LETTER KOVUU;Nl;0;L;;;;9;N;;;;;
A6EF;BAMUM LETTER KOGHOM;Nl;0;L;;;;0;N;;;;;
A6F0;BAMUM COMBINING MARK KOQNDON;Mn;230;NSM;;;;;N;;;;;
A6F1;BAMUM COMBINING MARK TUKWENTIS;Mn;230;NSM;;;;;N;;;;;
A6F2;BAMUM NJAEMLI;Po;0;L;;;;;N;;;;;
A6F3;BAMUM FULL STOP;Po;0;L;;;;;N;;;;;
A6F4;BAMUM COLON;Po;0;L;;;;;N;;;;;
A6F5;BAMUM COMMA;Po;0;L;;;;;N;;;;;
A6F6;BAMUM SEMICOLON;Po;0;L;;;;;N;;;;;
A6F7;BAMUM QUESTION MARK;Po;0;L;;;;;N;;;;;
A700;MODIFIER LETTER CHINESE TONE YIN PING;Sk;0;ON;;;;;N;;;;;
A701;MODIFIER LETTER CHINESE TONE YANG PING;Sk;0;ON;;;;;N;;;;;
A702;MODIFIER LETTER CHINESE TONE YIN SHANG;Sk;0;ON;;;;;N;;;;;
A703;MODIFIER LETTER CHINESE TONE YANG SHANG;Sk;0;ON;;;;;N;;;;;
A704;MODIFIER LETTER CHINESE TONE YIN QU;Sk;0;ON;;;;;N;;;;;
A705;MODIFIER LETTER CHINESE TONE YANG QU;Sk;0;ON;;;;;N;;;;;
A706;MODIFIER LETTER CHINESE TONE YIN RU;Sk;0;ON;;;;;N;;;;;
A707;MODIFIER LETTER CHINESE TONE YANG RU;Sk;0;ON;;;;;N;;;;;
A708;MODIFIER LETTER EXTRA-HIGH DOTTED TONE BAR;Sk;0;ON;;;;;N;;;;;
A709;MODIFIER LETTER HIGH DOTTED TONE BAR;Sk;0;ON;;;;;N;;;;;
A70A;MODIFIER LETTER MID DOTTED TONE BAR;Sk;0;ON;;;;;N;;;;;
A70B;MODIFIER LETTER LOW DOTTED TONE BAR;Sk;0;ON;;;;;N;;;;;
A70C;MODIFIER LETTER EXTRA-LOW DOTTED TONE BAR;Sk;0;ON;;;;;N;;;;;
A70D;MODIFIER LETTER EXTRA-HIGH DOTTED LEFT-STEM TONE BAR;Sk;0;ON;;;;;N;;;;;
A70E;MODIFIER LETTER HIGH DOTTED LEFT-STEM TONE BAR;Sk;0;ON;;;;;N;;;;;
A70F;MODIFIER LETTER MID DOTTED LEFT-STEM TONE BAR;Sk;0;ON;;;;;N;;;;;
A710;MODIFIER LETTER LOW DOTTED LEFT-STEM TONE BAR;Sk;0;ON;;;;;N;;;;;
A711;MODIFIER LETTER EXTRA-LOW DOTTED LEFT-STEM TONE BAR;Sk;0;ON;;;;;N;;;;;
A712;MODIFIER LETTER EXTRA-HIGH LEFT-STEM TONE BAR;Sk;0;ON;;;;;N;;;;;
A713;MODIFIER LETTER HIGH LEFT-STEM TONE BAR;Sk;0;ON;;;;;N;;;;;
A714;MODIFIER LETTER MID LEFT-STEM TONE BAR;Sk;0;ON;;;;;N;;;;;
A715;MODIFIER LETTER LOW LEFT-STEM TONE BAR;Sk;0;ON;;;;;N;;;;;
A716;MODIFIER LETTER EXTRA-LOW LEFT-STEM TONE BAR;Sk;0;ON;;;;;N;;;;;
A717;MODIFIER LETTER DOT VERTICAL BAR;Lm;0;ON;;;;;N;;;;;
A718;MODIFIER LETTER DOT SLASH;Lm;0;ON;;;;;N;;;;;
A719;MODIFIER LETTER DOT HORIZONTAL BAR;Lm;0;ON;;;;;N;;;;;
A71A;MODIFIER LETTER LOWER RIGHT CORNER ANGLE;Lm;0;ON;;;;;N;;;;;
A71B;MODIFIER LETTER RAISED UP ARROW;Lm;0;ON;;;;;N;;;;;
A71C;MODIFIER LETTER RAISED DOWN ARROW;Lm;0;ON;;;;;N;;;;;
A71D;MODIFIER LETTER RAISED EXCLAMATION MARK;Lm;0;ON;;;;;N;;;;;
A71E;MODIFIER LETTER RAISED INVERTED EXCLAMATION MARK;Lm;0;ON;;;;;N;;;;;
A71F;MODIFIER LETTER LOW INVERTED EXCLAMATION MARK;Lm;0;ON;;;;;N;;;;;
A720;MODIFIER LETTER STRESS AND HIGH TONE;Sk;0;ON;;;;;N;;;;;
A721;MODIFIER LETTER STRESS AND LOW TONE;Sk;0;ON;;;;;N;;;;;
A722;LATIN CAPITAL LETTER EGYPTOLOGICAL ALEF;Lu;0;L;;;;;N;;;;A723;
A723;LATIN SMALL LETTER EGYPTOLOGICAL ALEF;Ll;0;L;;;;;N;;;A722;;A722
A724;LATIN CAPITAL LETTER EGYPTOLOGICAL AIN;Lu;0;L;;;;;N;;;;A725;
A725;LATIN SMALL LETTER EGYPTOLOGICAL AIN;Ll;0;L;;;;;N;;;A724;;A724
A726;LATIN CAPITAL LETTER HENG;Lu;0;L;;;;;N;;;;A727;
A727;LATIN SMALL LETTER HENG;Ll;0;L;;;;;N;;;A726;;A726
A728;LATIN CAPITAL LETTER TZ;Lu;0;L;;;;;N;;;;A729;
A729;LATIN SMALL LETTER TZ;Ll;0;L;;;;;N;;;A728;;A728
A72A;LATIN CAPITAL LETTER TRESILLO;Lu;0;L;;;;;N;;;;A72B;
A72B;LATIN SMALL LETTER TRESILLO;Ll;0;L;;;;;N;;;A72A;;A72A
A72C;LATIN CAPITAL LETTER CUATRILLO;Lu;0;L;;;;;N;;;;A72D;
A72D;LATIN SMALL LETTER CUATRILLO;Ll;0;L;;;;;N;;;A72C;;A72C
A72E;LATIN CAPITAL LETTER CUATRILLO WITH COMMA;Lu;0;L;;;;;N;;;;A72F;
A72F;LATIN SMALL LETTER CUATRILLO WITH COMMA;Ll;0;L;;;;;N;;;A72E;;A72E
A730;LATIN LETTER SMALL CAPITAL F;Ll;0;L;;;;;N;;;;;
A731;LATIN LETTER SMALL CAPITAL S;Ll;0;L;;;;;N;;;;;
A732;LATIN CAPITAL LETTER AA;Lu;0;L;;;;;N;;;;A733;
A733;LATIN SMALL LETTER AA;Ll;0;L;;;;;N;;;A732;;A732
A734;LATIN CAPITAL LETTER AO;Lu;0;L;;;;;N;;;;A735;
A735;LATIN SMALL LETTER AO;Ll;0;L;;;;;N;;;A734;;A734
A736;LATIN CAPITAL LETTER AU;Lu;0;L;;;;;N;;;;A737;
A737;LATIN SMALL LETTER AU;Ll;0;L;;;;;N;;;A736;;A736
A738;LATIN CAPITAL LETTER AV;Lu;0;L;;;;;N;;;;A739;
A739;LATIN SMALL LETTER AV;Ll;0;L;;;;;N;;;A738;;A738
A73A;LATIN CAPITAL LETTER AV WITH HORIZONTAL BAR;Lu;0;L;;;;;N;;;;A73B;
A73B;LATIN SMALL LETTER AV WITH HORIZONTAL BAR;Ll;0;L;;;;;N;;;A73A;;A73A
A73C;LATIN CAPITAL LETTER AY;Lu;0;L;;;;;N;;;;A73D;
A73D;LATIN SMALL LETTER AY;Ll;0;L;;;;;N;;;A73C;;A73C
A73E;LATIN CAPITAL LETTER REVERSED C WITH DOT;Lu;0;L;;;;;N;;;;A73F;
A73F;LATIN SMALL LETTER REVERSED C WITH DOT;Ll;0;L;;;;;N;;;A73E;;A73E
A740;LATIN CAPITAL LETTER K WITH STROKE;Lu;0;L;;;;;N;;;;A741;
A741;LATIN SMALL LETTER K WITH STROKE;Ll;0;L;;;;;N;;;A740;;A740
A742;LATIN CAPITAL LETTER K WITH DIAGONAL STROKE;Lu;0;L;;;;;N;;;;A743;
A743;LATIN SMALL LETTER K WITH DIAGONAL STROKE;Ll;0;L;;;;;N;;;A742;;A742
A744;LATIN CAPITAL LETTER K WITH STROKE AND DIAGONAL STROKE;Lu;0;L;;;;;N;;;;A745;
A745;LATIN SMALL LETTER K WITH STROKE AND DIAGONAL STROKE;Ll;0;L;;;;;N;;;A744;;A744
A746;LATIN CAPITAL LETTER BROKEN L;Lu;0;L;;;;;N;;;;A747;
A747;LATIN SMALL LETTER BROKEN L;Ll;0;L;;;;;N;;;A746;;A746
A748;LATIN CAPITAL LETTER L WITH HIGH STROKE;Lu;0;L;;;;;N;;;;A749;
A749;LATIN SMALL LETTER L WITH HIGH STROKE;Ll;0;L;;;;;N;;;A748;;A748
A74A;LATIN CAPITAL LETTER O WITH LONG STROKE OVERLAY;Lu;0;L;;;;;N;;;;A74B;
A74B;LATIN SMALL LETTER O WITH LONG STROKE OVERLAY;Ll;0;L;;;;;N;;;A74A;;A74A
A74C;LATIN CAPITAL LETTER O WITH LOOP;Lu;0;L;;;;;N;;;;A74D;
A74D;LATIN SMALL LETTER O WITH LOOP;Ll;0;L;;;;;N;;;A74C;;A74C
A74E;LATIN CAPITAL LETTER OO;Lu;0;L;;;;;N;;;;A74F;
A74F;LATIN SMALL LETTER OO;Ll;0;L;;;;;N;;;A74E;;A74E
A750;LATIN CAPITAL LETTER P WITH STROKE THROUGH DESCENDER;Lu;0;L;;;;;N;;;;A751;
A751;LATIN SMALL LETTER P WITH STROKE THROUGH DESCENDER;Ll;0;L;;;;;N;;;A750;;A750
A752;LATIN CAPITAL LETTER P WITH FLOURISH;Lu;0;L;;;;;N;;;;A753;
A753;LATIN SMALL LETTER P WITH FLOURISH;Ll;0;L;;;;;N;;;A752;;A752
A754;LATIN CAPITAL LETTER P WITH SQUIRREL TAIL;Lu;0;L;;;;;N;;;;A755;
A755;LATIN SMALL LETTER P WITH SQUIRREL TAIL;Ll;0;L;;;;;N;;;A754;;A754
A756;LATIN CAPITAL LETTER Q WITH STROKE THROUGH DESCENDER;Lu;0;L;;;;;N;;;;A757;
A757;LATIN SMALL LETTER Q WITH STROKE THROUGH DESCENDER;Ll;0;L;;;;;N;;;A756;;A756
A758;LATIN CAPITAL LETTER Q WITH DIAGONAL STROKE;Lu;0;L;;;;;N;;;;A759;
A759;LATIN SMALL LETTER Q WITH DIAGONAL STROKE;Ll;0;L;;;;;N;;;A758;;A758
A75A;LATIN CAPITAL LETTER R ROTUNDA;Lu;0;L;;;;;N;;;;A75B;
A75B;LATIN SMALL LETTER R ROTUNDA;Ll;0;L;;;;;N;;;A75A;;A75A
A75C;LATIN CAPITAL LETTER RUM ROTUNDA;Lu;0;L;;;;;N;;;;A75D;
A75D;LATIN SMALL LETTER RUM ROTUNDA;Ll;0;L;;;;;N;;;A75C;;A75C
A75E;LATIN CAPITAL LETTER V WITH DIAGONAL STROKE;Lu;0;L;;;;;N;;;;A75F;
A75F;LATIN SMALL LETTER V WITH DIAGONAL STROKE;Ll;0;L;;;;;N;;;A75E;;A75E
A760;LATIN CAPITAL LETTER VY;Lu;0;L;;;;;N;;;;A761;
A761;LATIN SMALL LETTER VY;Ll;0;L;;;;;N;;;A760;;A760
A762;LATIN CAPITAL LETTER VISIGOTHIC Z;Lu;0;L;;;;;N;;;;A763;
A763;LATIN SMALL LETTER VISIGOTHIC Z;Ll;0;L;;;;;N;;;A762;;A762
A764;LATIN CAPITAL LETTER THORN WITH STROKE;Lu;0;L;;;;;N;;;;A765;
A765;LATIN SMALL LETTER THORN WITH STROKE;Ll;0;L;;;;;N;;;A764;;A764
A766;LATIN CAPITAL LETTER THORN WITH STROKE THROUGH DESCENDER;Lu;0;L;;;;;N;;;;A767;
A767;LATIN SMALL LETTER THORN WITH STROKE THROUGH DESCENDER;Ll;0;L;;;;;N;;;A766;;A766
A768;LATIN CAPITAL LETTER VEND;Lu;0;L;;;;;N;;;;A769;
A769;LATIN SMALL LETTER VEND;Ll;0;L;;;;;N;;;A768;;A768
A76A;LATIN CAPITAL LETTER ET;Lu;0;L;;;;;N;;;;A76B;
A76B;LATIN SMALL LETTER ET;Ll;0;L;;;;;N;;;A76A;;A76A
A76C;LATIN CAPITAL LETTER IS;Lu;0;L;;;;;N;;;;A76D;
A76D;LATIN SMALL LETTER IS;Ll;0;L;;;;;N;;;A76C;;A76C
A76E;LATIN CAPITAL LETTER CON;Lu;0;L;;;;;N;;;;A76F;
A76F;LATIN SMALL LETTER CON;Ll;0;L;;;;;N;;;A76E;;A76E
A770;MODIFIER LETTER US;Lm;0;L;<super> A76F;;;;N;;;;;
A771;LATIN SMALL LETTER DUM;Ll;0;L;;;;;N;;;;;
A772;LATIN SMALL LETTER LUM;Ll;0;L;;;;;N;;;;;
A773;LATIN SMALL LETTER MUM;Ll;0;L;;;;;N;;;;;
A774;LATIN SMALL LETTER NUM;Ll;0;L;;;;;N;;;;;
A775;LATIN SMALL LETTER RUM;Ll;0;L;;;;;N;;;;;
A776;LATIN LETTER SMALL CAPITAL RUM;Ll;0;L;;;;;N;;;;;
A777;LATIN SMALL LETTER TUM;Ll;0;L;;;;;N;;;;;
A778;LATIN SMALL LETTER UM;Ll;0;L;;;;;N;;;;;
A779;LATIN CAPITAL LETTER INSULAR D;Lu;0;L;;;;;N;;;;A77A;
A77A;LATIN SMALL LETTER INSULAR D;Ll;0;L;;;;;N;;;A779;;A779
A77B;LATIN CAPITAL LETTER INSULAR F;Lu;0;L;;;;;N;;;;A77C;
A77C;LATIN SMALL LETTER INSULAR F;Ll;0;L;;;;;N;;;A77B;;A77B
A77D;LATIN CAPITAL LETTER INSULAR G;Lu;0;L;;;;;N;;;;1D79;
A77E;LATIN CAPITAL LETTER TURNED INSULAR G;Lu;0;L;;;;;N;;;;A77F;
A77F;LATIN SMALL LETTER TURNED INSULAR G;Ll;0;L;;;;;N;;;A77E;;A77E
A780;LATIN CAPITAL LETTER TURNED L;Lu;0;L;;;;;N;;;;A781;
A781;LATIN SMALL LETTER TURNED L;Ll;0;L;;;;;N;;;A780;;A780
A782;LATIN CAPITAL LETTER INSULAR R;Lu;0;L;;;;;N;;;;A783;
A783;LATIN SMALL LETTER INSULAR R;Ll;0;L;;;;;N;;;A782;;A782
A784;LATIN CAPITAL LETTER INSULAR S;Lu;0;L;;;;;N;;;;A785;
A785;LATIN SMALL LETTER INSULAR S;Ll;0;L;;;;;N;;;A784;;A784
A786;LATIN CAPITAL LETTER INSULAR T;Lu;0;L;;;;;N;;;;A787;
A787;LATIN SMALL LETTER INSULAR T;Ll;0;L;;;;;N;;;A786;;A786
A788;MODIFIER LETTER LOW CIRCUMFLEX ACCENT;Lm;0;ON;;;;;N;;;;;
A789;MODIFIER LETTER COLON;Sk;0;L;;;;;N;;;;;
A78A;MODIFIER LETTER SHORT EQUALS SIGN;Sk;0;L;;;;;N;;;;;
A78B;LATIN CAPITAL LETTER SALTILLO;Lu;0;L;;;;;N;;;;A78C;
A78C;LATIN SMALL LETTER SALTILLO;Ll;0;L;;;;;N;;;A78B;;A78B
A78D;LATIN CAPITAL LETTER TURNED H;Lu;0;L;;;;;N;;;;0265;
A78E;LATIN SMALL LETTER L WITH RETROFLEX HOOK AND BELT;Ll;0;L;;;;;N;;;;;
A78F;LATIN LETTER SINOLOGICAL DOT;Lo;0;L;;;;;N;;;;;
A790;LATIN CAPITAL LETTER N WITH DESCENDER;Lu;0;L;;;;;N;;;;A791;
A791;LATIN SMALL LETTER N WITH DESCENDER;Ll;0;L;;;;;N;;;A790;;A790
A792;LATIN CAPITAL LETTER C WITH BAR;Lu;0;L;;;;;N;;;;A793;
A793;LATIN SMALL LETTER C WITH BAR;Ll;0;L;;;;;N;;;A792;;A792
A794;LATIN SMALL LETTER C WITH PALATAL HOOK;Ll;0;L;;;;;N;;;A7C4;;A7C4
A795;LATIN SMALL LETTER H WITH PALATAL HOOK;Ll;0;L;;;;;N;;;;;
A796;LATIN CAPITAL LETTER B WITH FLOURISH;Lu;0;L;;;;;N;;;;A797;
A797;LATIN SMALL LETTER B WITH FLOURISH;Ll;0;L;;;;;N;;;A796;;A796
A798;LATIN CAPITAL LETTER F WITH STROKE;Lu;0;L;;;;;N;;;;A799;
A799;LATIN SMALL LETTER F WITH STROKE;Ll;0;L;;;;;N;;;A798;;A798
A79A;LATIN CAPITAL LETTER VOLAPUK AE;Lu;0;L;;;;;N;;;;A79B;
A79B;LATIN SMALL LETTER VOLAPUK AE;Ll;0;L;;;;;N;;;A79A;;A79A
A79C;LATIN CAPITAL LETTER VOLAPUK OE;Lu;0;L;;;;;N;;;;A79D;
A79D;LATIN SMALL LETTER VOLAPUK OE;Ll;0;L;;;;;N;;;A79C;;A79C
A79E;LATIN CAPITAL LETTER VOLAPUK UE;Lu;0;L;;;;;N;;;;A79F;
A79F;LATIN SMALL LETTER VOLAPUK UE;Ll;0;L;;;;;N;;;A79E;;A79E
A7A0;LATIN CAPITAL LETTER G WITH OBLIQUE STROKE;Lu;0;L;;;;;N;;;;A7A1;
A7A1;LATIN SMALL LETTER G WITH OBLIQUE STROKE;Ll;0;L;;;;;N;;;A7A0;;A7A0
A7A2;LATIN CAPITAL LETTER K WITH OBLIQUE STROKE;Lu;0;L;;;;;N;;;;A7A3;
A7A3;LATIN SMALL LETTER K WITH OBLIQUE STROKE;Ll;0;L;;;;;N;;;A7A2;;A7A2
A7A4;LATIN CAPITAL LETTER N WITH OBLIQUE STROKE;Lu;0;L;;;;;N;;;;A7A5;
A7A5;LATIN SMALL LETTER N WITH OBLIQUE STROKE;Ll;0;L;;;;;N;;;A7A4;;A7A4
A7A6;LATIN CAPITAL LETTER R WITH OBLIQUE STROKE;Lu;0;L;;;;;N;;;;A7A7;
A7A7;LATIN SMALL LETTER R WITH OBLIQUE STROKE;Ll;0;L;;;;;N;;;A7A6;;A7A6
A7A8;LATIN CAPITAL LETTER S WITH OBLIQUE STROKE;Lu;0;L;;;;;N;;;;A7A9;
A7A9;LATIN SMALL LETTER S WITH OBLIQUE STROKE;Ll;0;L;;;;;N;;;A7A8;;A7A8
A7AA;LATIN CAPITAL LETTER H WITH HOOK;Lu;0;L;;;;;N;;;;0266;
A7AB;LATIN CAPITAL LETTER REVERSED OPEN E;Lu;0;L;;;;;N;;;;025C;
A7AC;LATIN CAPITAL LETTER SCRIPT G;Lu;0;L;;;;;N;;;;0261;
A7AD;LATIN CAPITAL LETTER L WITH BELT;Lu;0;L;;;;;N;;;;026C;
A7AE;LATIN CAPITAL LETTER SMALL CAPITAL I;Lu;0;L;;;;;N;;;;026A;
A7AF;LATIN LETTER SMALL CAPITAL Q;Ll;0;L;;;;;N;;;;;
A7B0;LATIN CAPITAL LETTER TURNED K;Lu;0;L;;;;;N;;;;029E;
A7B1;LATIN CAPITAL LETTER TURNED T;Lu;0;L;;;;;N;;;;0287;
A7B2;LATIN CAPITAL LETTER J WITH CROSSED-TAIL;Lu;0;L;;;;;N;;;;029D;
A7B3;LATIN CAPITAL LETTER CHI;Lu;0;L;;;;;N;;;;AB53;
A7B4;LATIN CAPITAL LETTER BETA;Lu;0;L;;;;;N;;;;A7B5;
A7B5;LATIN SMALL LETTER BETA;Ll;0;L;;;;;N;;;A7B4;;A7B4
A7B6;LATIN CAPITAL LETTER OMEGA;Lu;0;L;;;;;N;;;;A7B7;
A7B7;LATIN SMALL LETTER OMEGA;Ll;0;L;;;;;N;;;A7B6;;A7B6
A7B8;LATIN CAPITAL LETTER U WITH STROKE;Lu;0;L;;;;;N;;;;A7B9;
A7B9;LATIN SMALL LETTER U WITH STROKE;Ll;0;L;;;;;N;;;A7B8;;A7B8
A7BA;LATIN CAPITAL LETTER GLOTTAL A;Lu;0;L;;;;;N;;;;A7BB;
A7BB;LATIN SMALL LETTER GLOTTAL A;Ll;0;L;;;;;N;;;A7BA;;A7BA
A7BC;LATIN CAPITAL LETTER GLOTTAL I;Lu;0;L;;;;;N;;;;A7BD;
A7BD;LATIN SMALL LETTER GLOTTAL I;Ll;0;L;;;;;N;;;A7BC;;A7BC
A7BE;LATIN CAPITAL LETTER GLOTTAL U;Lu;0;L;;;;;N;;;;A7BF;
A7BF;LATIN SMALL LETTER GLOTTAL U;Ll;0;L;;;;;N;;;A7BE;;A7BE
A7C0;LATIN CAPITAL LETTER OLD POLISH O;Lu;0;L;;;;;N;;;;A7C1;
A7C1;LATIN SMALL LETTER OLD POLISH O;Ll;0;L;;;;;N;;;A7C0;;A7C0
A7C2;LATIN CAPITAL LETTER ANGLICANA W;Lu;0;L;;;;;N;;;;A7C3;
A7C3;LATIN SMALL LETTER ANGLICANA W;Ll;0;L;;;;;N;;;A7C2;;A7C2
A7C4;LATIN CAPITAL LETTER C WITH PALATAL HOOK;Lu;0;L;;;;;N;;;;A794;
A7C5;LATIN CAPITAL LETTER S WITH HOOK;Lu;0;L;;;;;N;;;;0282;
A7C6;LATIN CAPITAL LETTER Z WITH PALATAL HOOK;Lu;0;L;;;;;N;;;;1D8E;
A7C7;LATIN CAPITAL LETTER D WITH SHORT STROKE OVERLAY;Lu;0;L;;;;;N;;;;A7C8;
A7C8;LATIN SMALL LETTER D WITH SHORT STROKE OVERLAY;Ll;0;L;;;;;N;;;A7C7;;A7C7
A7C9;LATIN CAPITAL LETTER S WITH SHORT STROKE OVERLAY;Lu;0;L;;;;;N;;;;A7CA;
A7CA;LATIN SMALL LETTER S WITH SHORT STROKE OVERLAY;Ll;0;L;;;;;N;;;A7C9;;A7C9
A7D0;LATIN CAPITAL LETTER CLOSED INSULAR G;Lu;0;L;;;;;N;;;;A7D1;
A7D1;LATIN SMALL LETTER CLOSED INSULAR G;Ll;0;L;;;;;N;;;A7D0;;A7D0
A7D3;LATIN SMALL LETTER DOUBLE THORN;Ll;0;L;;;;;N;;;;;
A7D5;LATIN SMALL LETTER DOUBLE WYNN;Ll;0;L;;;;;N;;;;;
A7D6;LATIN CAPITAL LETTER MIDDLE SCOTS S;Lu;0;L;;;;;N;;;;A7D7;
A7D7;LATIN SMALL LETTER MIDDLE SCOTS S;Ll;0;L;;;;;N;;;A7D6;;A7D6
A7D8;LATIN CAPITAL LETTER SIGMOID S;Lu;0;L;;;;;N;;;;A7D9;
A7D9;LATIN SMALL LETTER SIGMOID S;Ll;0;L;;;;;N;;;A7D8;;A7D8
A7F2;MODIFIER LETTER CAPITAL C;Lm;0;L;<super> 0043;;;;N;;;;;
A7F3;MODIFIER LETTER CAPITAL F;Lm;0;L;<super> 0046;;;;N;;;;;
A7F4;MODIFIER LETTER CAPITAL Q;Lm;0;L;<super> 0051;;;;N;;;;;
A7F5;LATIN CAPITAL LETTER REVERSED HALF H;Lu;0;L;;;;;N;;;;A7F6;
A7F6;LATIN SMALL LETTER REVERSED HALF H;Ll;0;L;;;;;N;;;A7F5;;A7F5
A7F7;LATIN EPIGRAPHIC LETTER SIDEWAYS I;Lo;0;L;;;;;N;;;;;
A7F8;MODIFIER LETTER CAPITAL H WITH STROKE;Lm;0;L;<super> 0126;;;;N;;;;;
A7F9;MODIFIER LETTER SMALL LIGATURE OE;Lm;0;L;<super> 0153;;;;N;;;;;
A7FA;LATIN LETTER SMALL CAPITAL TURNED M;Ll;0;L;;;;;N;;;;;
A7FB;LATIN EPIGRAPHIC LETTER REVERSED F;Lo;0;L;;;;;N;;;;;
A7FC;LATIN EPIGRAPHIC LETTER REVERSED P;Lo;0;L;;;;;N;;;;;
A7FD;LATIN EPIGRAPHIC LETTER INVERTED M;Lo;0;L;;;;;N;;;;;
A7FE;LATIN EPIGRAPHIC LETTER I LONGA;Lo;0;L;;;;;N;;;;;
A7FF;LATIN EPIGRAPHIC LETTER ARCHAIC M;Lo;0;L;;;;;N;;;;;
A800;SYLOTI NAGRI LETTER A;Lo;0;L;;;;;N;;;;;
A801;SYLOTI NAGRI LETTER I;Lo;0;L;;;;;N;;;;;
A802;SYLOTI NAGRI SIGN DVISVARA;Mn;0;NSM;;;;;N;;;;;
A803;SYLOTI NAGRI LETTER U;Lo;0;L;;;;;N;;;;;
A804;SYLOTI NAGRI LETTER E;Lo;0;L;;;;;N;;;;;
A805;SYLOTI NAGRI LETTER O;Lo;0;L;;;;;N;;;;;
A806;SYLOTI NAGRI SIGN HASANTA;Mn;9;NSM;;;;;N;;;;;
A807;SYLOTI NAGRI LETTER KO;Lo;0;L;;;;;N;;;;;
A808;SYLOTI NAGRI LETTER KHO;Lo;0;L;;;;;N;;;;;
A809;SYLOTI NAGRI LETTER GO;Lo;0;L;;;;;N;;;;;
A80A;SYLOTI NAGRI LETTER GHO;Lo;0;L;;;;;N;;;;;
A80B;SYLOTI NAGRI SIGN ANUSVARA;Mn;0;NSM;;;;;N;;;;;
A80C;SYLOTI NAGRI LETTER CO;Lo;0;L;;;;;N;;;;;
A80D;SYLOTI NAGRI LETTER CHO;Lo;0;L;;;;;N;;;;;
A80E;SYLOTI NAGRI LETTER JO;Lo;0;L;;;;;N;;;;;
A80F;SYLOTI NAGRI LETTER JHO;Lo;0;L;;;;;N;;;;;
A810;SYLOTI NAGRI LETTER TTO;Lo;0;L;;;;;N;;;;;
A811;SYLOTI NAGRI LETTER TTHO;Lo;0;L;;;;;N;;;;;
A812;SYLOTI NAGRI LETTER DDO;Lo;0;L;;;;;N;;;;;
A813;SYLOTI NAGRI LETTER DDHO;Lo;0;L;;;;;N;;;;;
A814;SYLOTI NAGRI LETTER TO;Lo;0;L;;;;;N;;;;;
A815;SYLOTI NAGRI LETTER THO;Lo;0;L;;;;;N;;;;;
A816;SYLOTI NAGRI LETTER DO;Lo;0;L;;;;;N;;;;;
A817;SYLOTI NAGRI LETTER DHO;Lo;0;L;;;;;N;;;;;
A818;SYLOTI NAGRI LETTER NO;Lo;0;L;;;;;N;;;;;
A819;SYLOTI NAGRI LETTER PO;Lo;0;L;;;;;N;;;;;
A81A;SYLOTI NAGRI LETTER PHO;Lo;0;L;;;;;N;;;;;
A81B;SYLOTI NAGRI LETTER BO;Lo;0;L;;;;;N;;;;;
A81C;SYLOTI NAGRI LETTER BHO;Lo;0;L;;;;;N;;;;;
A81D;SYLOTI NAGRI LETTER MO;Lo;0;L;;;;;N;;;;;
A81E;SYLOTI NAGRI LETTER RO;Lo;0;L;;;;;N;;;;;
A81F;SYLOTI NAGRI LETTER LO;Lo;0;L;;;;;N;;;;;
A820;SYLOTI NAGRI LETTER RRO;Lo;0;L;;;;;N;;;;;
A821;SYLOTI NAGRI LETTER SO;Lo;0;L;;;;;N;;;;;
A822;SYLOTI NAGRI LETTER HO;Lo;0;L;;;;;N;;;;;
A823;SYLOTI NAGRI VOWEL SIGN A;Mc;0;L;;;;;N;;;;;
A824;SYLOTI NAGRI VOWEL SIGN I;Mc;0;L;;;;;N;;;;;
A825;SYLOTI NAGRI VOWEL SIGN U;Mn;0;NSM;;;;;N;;;;;
A826;SYLOTI NAGRI VOWEL SIGN E;Mn;0;NSM;;;;;N;;;;;
A827;SYLOTI NAGRI VOWEL SIGN OO;Mc;0;L;;;;;N;;;;;
A828;SYLOTI NAGRI POETRY MARK-1;So;0;ON;;;;;N;;;;;
A829;SYLOTI NAGRI POETRY MARK-2;So;0;ON;;;;;N;;;;;
A82A;SYLOTI NAGRI POETRY MARK-3;So;0;ON;;;;;N;;;;;
A82B;SYLOTI NAGRI POETRY MARK-4;So;0;ON;;;;;N;;;;;
A82C;SYLOTI NAGRI SIGN ALTERNATE HASANTA;Mn;9;NSM;;;;;N;;;;;
A830;NORTH INDIC FRACTION ONE QUARTER;No;0;L;;;;1/4;N;;;;;
A831;NORTH INDIC FRACTION ONE HALF;No;0;L;;;;1/2;N;;;;;
A832;NORTH INDIC FRACTION THREE QUARTERS;No;0;L;;;;3/4;N;;;;;
A833;NORTH INDIC FRACTION ONE SIXTEENTH;No;0;L;;;;1/16;N;;;;;
A834;NORTH INDIC FRACTION ONE EIGHTH;No;0;L;;;;1/8;N;;;;;
A835;NORTH INDIC FRACTION THREE SIXTEENTHS;No;0;L;;;;3/16;N;;;;;
A836;NORTH INDIC QUARTER MARK;So;0;L;;;;;N;;;;;
A837;NORTH INDIC PLACEHOLDER MARK;So;0;L;;;;;N;;;;;
A838;NORTH INDIC RUPEE MARK;Sc;0;ET;;;;;N;;;;;
A839;NORTH INDIC QUANTITY MARK;So;0;ET;;;;;N;;;;;
A840;PHAGS-PA LETTER KA;Lo;0;L;;;;;N;;;;;
A841;PHAGS-PA LETTER KHA;Lo;0;L;;;;;N;;;;;
A842;PHAGS-PA LETTER GA;Lo;0;L;;;;;N;;;;;
A843;PHAGS-PA LETTER NGA;Lo;0;L;;;;;N;;;;;
A844;PHAGS-PA LETTER CA;Lo;0;L;;;;;N;;;;;
A845;PHAGS-PA LETTER CHA;Lo;0;L;;;;;N;;;;;
A846;PHAGS-PA LETTER JA;Lo;0;L;;;;;N;;;;;
A847;PHAGS-PA LETTER NYA;Lo;0;L;;;;;N;;;;;
A848;PHAGS-PA LETTER TA;Lo;0;L;;;;;N;;;;;
A849;PHAGS-PA LETTER THA;Lo;0;L;;;;;N;;;;;
A84A;PHAGS-PA LETTER DA;Lo;0;L;;;;;N;;;;;
A84B;PHAGS-PA LETTER NA;Lo;0;L;;;;;N;;;;;
A84C;PHAGS-PA LETTER PA;Lo;0;L;;;;;N;;;;;
A84D;PHAGS-PA LETTER PHA;Lo;0;L;;;;;N;;;;;
A84E;PHAGS-PA LETTER BA;Lo;0;L;;;;;N;;;;;
A84F;PHAGS-PA LETTER MA;Lo;0;L;;;;;N;;;;;
A850;PHAGS-PA LETTER TSA;Lo;0;L;;;;;N;;;;;
A851;PHAGS-PA LETTER TSHA;Lo;0;L;;;;;N;;;;;
A852;PHAGS-PA LETTER DZA;Lo;0;L;;;;;N;;;;;
A853;PHAGS-PA LETTER WA;Lo;0;L;;;;;N;;;;;
A854;PHAGS-PA LETTER ZHA;Lo;0;L;;;;;N;;;;;
A855;PHAGS-PA LETTER ZA;Lo;0;L;;;;;N;;;;;
A856;PHAGS-PA LETTER SMALL A;Lo;0;L;;;;;N;;;;;
A857;PHAGS-PA LETTER YA;Lo;0;L;;;;;N;;;;;
A858;PHAGS-PA LETTER RA;Lo;0;L;;;;;N;;;;;
A859;PHAGS-PA LETTER LA;Lo;0;L;;;;;N;;;;;
A85A;PHAGS-PA LETTER SHA;Lo;0;L;;;;;N;;;;;
A85B;PHAGS-PA LETTER SA;Lo;0;L;;;;;N;;;;;
A85C;PHAGS-PA LETTER HA;Lo;0;L;;;;;N;;;;;
A85D;PHAGS-PA LETTER A;Lo;0;L;;;;;N;;;;;
A85E;PHAGS-PA LETTER I;Lo;0;L;;;;;N;;;;;
A85F;PHAGS-PA LETTER U;Lo;0;L;;;;;N;;;;;
A860;PHAGS-PA LETTER E;Lo;0;L;;;;;N;;;;;
A861;PHAGS-PA LETTER O;Lo;0;L;;;;;N;;;;;
A862;PHAGS-PA LETTER QA;Lo;0;L;;;;;N;;;;;
A863;PHAGS-PA LETTER XA;Lo;0;L;;;;;N;;;;;
A864;PHAGS-PA LETTER FA;Lo;0;L;;;;;N;;;;;
A865;PHAGS-PA LETTER GGA;Lo;0;L;;;;;N;;;;;
A866;PHAGS-PA LETTER EE;Lo;0;L;;;;;N;;;;;
A867;PHAGS-PA SUBJOINED LETTER WA;Lo;0;L;;;;;N;;;;;
A868;PHAGS-PA SUBJOINED LETTER YA;Lo;0;L;;;;;N;;;;;
A869;PHAGS-PA LETTER TTA;Lo;0;L;;;;;N;;;;;
A86A;PHAGS-PA LETTER TTHA;Lo;0;L;;;;;N;;;;;
A86B;PHAGS-PA LETTER DDA;Lo;0;L;;;;;N;;;;;
A86C;PHAGS-PA LETTER NNA;Lo;0;L;;;;;N;;;;;
A86D;PHAGS-PA LETTER ALTERNATE YA;Lo;0;L;;;;;N;;;;;
A86E;PHAGS-PA LETTER VOICELESS SHA;Lo;0;L;;;;;N;;;;;
A86F;PHAGS-PA LETTER VOICED HA;Lo;0;L;;;;;N;;;;;
A870;PHAGS-PA LETTER ASPIRATED FA;Lo;0;L;;;;;N;;;;;
A871;PHAGS-PA SUBJOINED LETTER RA;Lo;0;L;;;;;N;;;;;
A872;PHAGS-PA SUPERFIXED LETTER RA;Lo;0;L;;;;;N;;;;;
A873;PHAGS-PA LETTER CANDRABINDU;Lo;0;L;;;;;N;;;;;
A874;PHAGS-PA SINGLE HEAD MARK;Po;0;ON;;;;;N;;;;;
A875;PHAGS-PA DOUBLE HEAD MARK;Po;0;ON;;;;;N;;;;;
A876;PHAGS-PA MARK SHAD;Po;0;ON;;;;;N;;;;;
A877;PHAGS-PA MARK DOUBLE SHAD;Po;0;ON;;;;;N;;;;;
A880;SAURASHTRA SIGN ANUSVARA;Mc;0;L;;;;;N;;;;;
A881;SAURASHTRA SIGN VISARGA;Mc;0;L;;;;;N;;;;;
A882;SAURASHTRA LETTER A;Lo;0;L;;;;;N;;;;;
A883;SAURASHTRA LETTER AA;Lo;0;L;;;;;N;;;;;
A884;SAURASHTRA LETTER I;Lo;0;L;;;;;N;;;;;
A885;SAURASHTRA LETTER II;Lo;0;L;;;;;N;;;;;
A886;SAURASHTRA LETTER U;Lo;0;L;;;;;N;;;;;
A887;SAURASHTRA LETTER UU;Lo;0;L;;;;;N;;;;;
A888;SAURASHTRA LETTER VOCALIC R;Lo;0;L;;;;;N;;;;;
A889;SAURASHTRA LETTER VOCALIC RR;Lo;0;L;;;;;N;;;;;
A88A;SAURASHTRA LETTER VOCALIC L;Lo;0;L;;;;;N;;;;;
A88B;SAURASHTRA LETTER VOCALIC LL;Lo;0;L;;;;;N;;;;;
A88C;SAURASHTRA LETTER E;Lo;0;L;;;;;N;;;;;
A88D;SAURASHTRA LETTER EE;Lo;0;L;;;;;N;;;;;
A88E;SAURASHTRA LETTER AI;Lo;0;L;;;;;N;;;;;
A88F;SAURASHTRA LETTER O;Lo;0;L;;;;;N;;;;;
A890;SAURASHTRA LETTER OO;Lo;0;L;;;;;N;;;;;
A891;SAURASHTRA LETTER AU;Lo;0;L;;;;;N;;;;;
A892;SAURASHTRA LETTER KA;Lo;0;L;;;;;N;;;;;
A893;SAURASHTRA LETTER KHA;Lo;0;L;;;;;N;;;;;
A894;SAURASHTRA LETTER GA;Lo;0;L;;;;;N;;;;;
A895;SAURASHTRA LETTER GHA;Lo;0;L;;;;;N;;;;;
A896;SAURASHTRA LETTER NGA;Lo;0;L;;;;;N;;;;;
A897;SAURASHTRA LETTER CA;Lo;0;L;;;;;N;;;;;
A898;SAURASHTRA LETTER CHA;Lo;0;L;;;;;N;;;;;
A899;SAURASHTRA LETTER JA;Lo;0;L;;;;;N;;;;;
A89A;SAURASHTRA LETTER JHA;Lo;0;L;;;;;N;;;;;
A89B;SAURASHTRA LETTER NYA;Lo;0;L;;;;;N;;;;;
A89C;SAURASHTRA LETTER TTA;Lo;0;L;;;;;N;;;;;
A89D;SAURASHTRA LETTER TTHA;Lo;0;L;;;;;N;;;;;
A89E;SAURASHTRA LETTER DDA;Lo;0;L;;;;;N;;;;;
A89F;SAURASHTRA LETTER DDHA;Lo;0;L;;;;;N;;;;;
A8A0;SAURASHTRA LETTER NNA;Lo;0;L;;;;;N;;;;;
A8A1;SAURASHTRA LETTER TA;Lo;0;L;;;;;N;;;;;
A8A2;SAURASHTRA LETTER THA;Lo;0;L;;;;;N;;;;;
A8A3;SAURASHTRA LETTER DA;Lo;0;L;;;;;N;;;;;
A8A4;SAURASHTRA LETTER DHA;Lo;0;L;;;;;N;;;;;
A8A5;SAURASHTRA LETTER NA;Lo;0;L;;;;;N;;;;;
A8A6;SAURASHTRA LETTER PA;Lo;0;L;;;;;N;;;;;
A8A7;SAURASHTRA LETTER PHA;Lo;0;L;;;;;N;;;;;
A8A8;SAURASHTRA LETTER BA;Lo;0;L;;;;;N;;;;;
A8A9;SAURASHTRA LETTER BHA;Lo;0;L;;;;;N;;;;;
A8AA;SAURASHTRA LETTER MA;Lo;0;L;;;;;N;;;;;
A8AB;SAURASHTRA LETTER YA;Lo;0;L;;;;;N;;;;;
A8AC;SAURASHTRA LETTER RA;Lo;0;L;;;;;N;;;;;
A8AD;SAURASHTRA LETTER LA;Lo;0;L;;;;;N;;;;;
A8AE;SAURASHTRA LETTER VA;Lo;0;L;;;;;N;;;;;
A8AF;SAURASHTRA LETTER SHA;Lo;0;L;;;;;N;;;;;
A8B0;SAURASHTRA LETTER SSA;Lo;0;L;;;;;N;;;;;
A8B1;SAURASHTRA LETTER SA;Lo;0;L;;;;;N;;;;;
A8B2;SAURASHTRA LETTER HA;Lo;0;L;;;;;N;;;;;
A8B3;SAURASHTRA LETTER LLA;Lo;0;L;;;;;N;;;;;
A8B4;SAURASHTRA CONSONANT SIGN HAARU;Mc;0;L;;;;;N;;;;;
A8B5;SAURASHTRA VOWEL SIGN AA;Mc;0;L;;;;;N;;;;;
A8B6;SAURASHTRA VOWEL SIGN I;Mc;0;L;;;;;N;;;;;
A8B7;SAURASHTRA VOWEL SIGN II;Mc;0;L;;;;;N;;;;;
A8B8;SAURASHTRA VOWEL SIGN U;Mc;0;L;;;;;N;;;;;
A8B9;SAURASHTRA VOWEL SIGN UU;Mc;0;L;;;;;N;;;;;
A8BA;SAURASHTRA VOWEL SIGN VOCALIC R;Mc;0;L;;;;;N;;;;;
A8BB;SAURASHTRA VOWEL SIGN VOCALIC RR;Mc;0;L;;;;;N;;;;;
A8BC;SAURASHTRA VOWEL SIGN VOCALIC L;Mc;0;L;;;;;N;;;;;
A8BD;SAURASHTRA VOWEL SIGN VOCALIC LL;Mc;0;L;;;;;N;;;;;
A8BE;SAURASHTRA VOWEL SIGN E;Mc;0;L;;;;;N;;;;;
A8BF;SAURASHTRA VOWEL SIGN EE;Mc;0;L;;;;;N;;;;;
A8C0;SAURASHTRA VOWEL SIGN AI;Mc;0;L;;;;;N;;;;;
A8C1;SAURASHTRA VOWEL SIGN O;Mc;0;L;;;;;N;;;;;
A8C2;SAURASHTRA VOWEL SIGN OO;Mc;0;L;;;;;N;;;;;
A8C3;SAURASHTRA VOWEL SIGN AU;Mc;0;L;;;;;N;;;;;
A8C4;SAURASHTRA SIGN VIRAMA;Mn;9;NSM;;;;;N;;;;;
A8C5;SAURASHTRA SIGN CANDRABINDU;Mn;0;NSM;;;;;N;;;;;
A8CE;SAURASHTRA DANDA;Po;0;L;;;;;N;;;;;
A8CF;SAURASHTRA DOUBLE DANDA;Po;0;L;;;;;N;;;;;
A8D0;SAURASHTRA DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
A8D1;SAURASHTRA DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
A8D2;SAURASHTRA DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
A8D3;SAURASHTRA DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
A8D4;SAURASHTRA DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
A8D5;SAURASHTRA DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
A8D6;SAURASHTRA DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
A8D7;SAURASHTRA DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
A8D8;SAURASHTRA DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
A8D9;SAURASHTRA DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
A8E0;COMBINING DEVANAGARI DIGIT ZERO;Mn;230;NSM;;;;;N;;;;;
A8E1;COMBINING DEVANAGARI DIGIT ONE;Mn;230;NSM;;;;;N;;;;;
A8E2;COMBINING DEVANAGARI DIGIT TWO;Mn;230;NSM;;;;;N;;;;;
A8E3;COMBINING DEVANAGARI DIGIT THREE;Mn;230;NSM;;;;;N;;;;;
A8E4;COMBINING DEVANAGARI DIGIT FOUR;Mn;230;NSM;;;;;N;;;;;
A8E5;COMBINING DEVANAGARI DIGIT FIVE;Mn;230;NSM;;;;;N;;;;;
A8E6;COMBINING DEVANAGARI DIGIT SIX;Mn;230;NSM;;;;;N;;;;;
A8E7;COMBINING DEVANAGARI DIGIT SEVEN;Mn;230;NSM;;;;;N;;;;;
A8E8;COMBINING DEVANAGARI DIGIT EIGHT;Mn;230;NSM;;;;;N;;;;;
A8E9;COMBINING DEVANAGARI DIGIT NINE;Mn;230;NSM;;;;;N;;;;;
A8EA;COMBINING DEVANAGARI LETTER A;Mn;230;NSM;;;;;N;;;;;
A8EB;COMBINING DEVANAGARI LETTER U;Mn;230;NSM;;;;;N;;;;;
A8EC;COMBINING DEVANAGARI LETTER KA;Mn;230;NSM;;;;;N;;;;;
A8ED;COMBINING DEVANAGARI LETTER NA;Mn;230;NSM;;;;;N;;;;;
A8EE;COMBINING DEVANAGARI LETTER PA;Mn;230;NSM;;;;;N;;;;;
A8EF;COMBINING DEVANAGARI LETTER RA;Mn;230;NSM;;;;;N;;;;;
A8F0;COMBINING DEVANAGARI LETTER VI;Mn;230;NSM;;;;;N;;;;;
A8F1;COMBINING DEVANAGARI SIGN AVAGRAHA;Mn;230;NSM;;;;;N;;;;;
A8F2;DEVANAGARI SIGN SPACING CANDRABINDU;Lo;0;L;;;;;N;;;;;
A8F3;DEVANAGARI SIGN CANDRABINDU VIRAMA;Lo;0;L;;;;;N;;;;;
A8F4;DEVANAGARI SIGN DOUBLE CANDRABINDU VIRAMA;Lo;0;L;;;;;N;;;;;
A8F5;DEVANAGARI SIGN CANDRABINDU TWO;Lo;0;L;;;;;N;;;;;
A8F6;DEVANAGARI SIGN CANDRABINDU THREE;Lo;0;L;;;;;N;;;;;
A8F7;DEVANAGARI SIGN CANDRABINDU AVAGRAHA;Lo;0;L;;;;;N;;;;;
A8F8;DEVANAGARI SIGN PUSHPIKA;Po;0;L;;;;;N;;;;;
A8F9;DEVANAGARI GAP FILLER;Po;0;L;;;;;N;;;;;
A8FA;DEVANAGARI CARET;Po;0;L;;;;;N;;;;;
A8FB;DEVANAGARI HEADSTROKE;Lo;0;L;;;;;N;;;;;
A8FC;DEVANAGARI SIGN SIDDHAM;Po;0;L;;;;;N;;;;;
A8FD;DEVANAGARI JAIN OM;Lo;0;L;;;;;N;;;;;
A8FE;DEVANAGARI LETTER AY;Lo;0;L;;;;;N;;;;;
A8FF;DEVANAGARI VOWEL SIGN AY;Mn;0;NSM;;;;;N;;;;;
A900;KAYAH LI DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
A901;KAYAH LI DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
A902;KAYAH LI DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
A903;KAYAH LI DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
A904;KAYAH LI DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
A905;KAYAH LI DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
A906;KAYAH LI DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
A907;KAYAH LI DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
A908;KAYAH LI DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
A909;KAYAH LI DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
A90A;KAYAH LI LETTER KA;Lo;0;L;;;;;N;;;;;
A90B;KAYAH LI LETTER KHA;Lo;0;L;;;;;N;;;;;
A90C;KAYAH LI LETTER GA;Lo;0;L;;;;;N;;;;;
A90D;KAYAH LI LETTER NGA;Lo;0;L;;;;;N;;;;;
A90E;KAYAH LI LETTER SA;Lo;0;L;;;;;N;;;;;
A90F;KAYAH LI LETTER SHA;Lo;0;L;;;;;N;;;;;
A910;KAYAH LI LETTER ZA;Lo;0;L;;;;;N;;;;;
A911;KAYAH LI LETTER NYA;Lo;0;L;;;;;N;;;;;
A912;KAYAH LI LETTER TA;Lo;0;L;;;;;N;;;;;
A913;KAYAH LI LETTER HTA;Lo;0;L;;;;;N;;;;;
A914;KAYAH LI LETTER NA;Lo;0;L;;;;;N;;;;;
A915;KAYAH LI LETTER PA;Lo;0;L;;;;;N;;;;;
A916;KAYAH LI LETTER PHA;Lo;0;L;;;;;N;;;;;
A917;KAYAH LI LETTER MA;Lo;0;L;;;;;N;;;;;
A918;KAYAH LI LETTER DA;Lo;0;L;;;;;N;;;;;
A919;KAYAH LI LETTER BA;Lo;0;L;;;;;N;;;;;
A91A;KAYAH LI LETTER RA;Lo;0;L;;;;;N;;;;;
A91B;KAYAH LI LETTER YA;Lo;0;L;;;;;N;;;;;
A91C;KAYAH LI LETTER LA;Lo;0;L;;;;;N;;;;;
A91D;KAYAH LI LETTER WA;Lo;0;L;;;;;N;;;;;
A91E;KAYAH LI LETTER THA;Lo;0;L;;;;;N;;;;;
A91F;KAYAH LI LETTER HA;Lo;0;L;;;;;N;;;;;
A920;KAYAH LI LETTER VA;Lo;0;L;;;;;N;;;;;
A921;KAYAH LI LETTER CA;Lo;0;L;;;;;N;;;;;
A922;KAYAH LI LETTER A;Lo;0;L;;;;;N;;;;;
A923;KAYAH LI LETTER OE;Lo;0;L;;;;;N;;;;;
A924;KAYAH LI LETTER I;Lo;0;L;;;;;N;;;;;
A925;KAYAH LI LETTER OO;Lo;0;L;;;;;N;;;;;
A926;KAYAH LI VOWEL UE;Mn;0;NSM;;;;;N;;;;;
A927;KAYAH LI VOWEL E;Mn;0;NSM;;;;;N;;;;;
A928;KAYAH LI VOWEL U;Mn;0;NSM;;;;;N;;;;;
A929;KAYAH LI VOWEL EE;Mn;0;NSM;;;;;N;;;;;
A92A;KAYAH LI VOWEL O;Mn;0;NSM;;;;;N;;;;;
A92B;KAYAH LI TONE PLOPHU;Mn;220;NSM;;;;;N;;;;;
A92C;KAYAH LI TONE CALYA;Mn;220;NSM;;;;;N;;;;;
A92D;KAYAH LI TONE CALYA PLOPHU;Mn;220;NSM;;;;;N;;;;;
A92E;KAYAH LI SIGN CWI;Po;0;L;;;;;N;;;;;
A92F;KAYAH LI SIGN SHYA;Po;0;L;;;;;N;;;;;
A930;REJANG LETTER KA;Lo;0;L;;;;;N;;;;;
A931;REJANG LETTER GA;Lo;0;L;;;;;N;;;;;
A932;REJANG LETTER NGA;Lo;0;L;;;;;N;;;;;
A933;REJANG LETTER TA;Lo;0;L;;;;;N;;;;;
A934;REJANG LETTER DA;Lo;0;L;;;;;N;;;;;
A935;REJANG LETTER NA;Lo;0;L;;;;;N;;;;;
A936;REJANG LETTER PA;Lo;0;L;;;;;N;;;;;
A937;REJANG LETTER BA;Lo;0;L;;;;;N;;;;;
A938;REJANG LETTER MA;Lo;0;L;;;;;N;;;;;
A939;REJANG LETTER CA;Lo;0;L;;;;;N;;;;;
A93A;REJANG LETTER JA;Lo;0;L;;;;;N;;;;;
A93B;REJANG LETTER NYA;Lo;0;L;;;;;N;;;;;
A93C;REJANG LETTER SA;Lo;0;L;;;;;N;;;;;
A93D;REJANG LETTER RA;Lo;0;L;;;;;N;;;;;
A93E;REJANG LETTER LA;Lo;0;L;;;;;N;;;;;
A93F;REJANG LETTER YA;Lo;0;L;;;;;N;;;;;
A940;REJANG LETTER WA;Lo;0;L;;;;;N;;;;;
A941;REJANG LETTER HA;Lo;0;L;;;;;N;;;;;
A942;REJANG LETTER MBA;Lo;0;L;;;;;N;;;;;
A943;REJANG LETTER NGGA;Lo;0;L;;;;;N;;;;;
A944;REJANG LETTER NDA;Lo;0;L;;;;;N;;;;;
A945;REJANG LETTER NYJA;Lo;0;L;;;;;N;;;;;
A946;REJANG LETTER A;Lo;0;L;;;;;N;;;;;
A947;REJANG VOWEL SIGN I;Mn;0;NSM;;;;;N;;;;;
A948;REJANG VOWEL SIGN U;Mn;0;NSM;;;;;N;;;;;
A949;REJANG VOWEL SIGN E;Mn;0;NSM;;;;;N;;;;;
A94A;REJANG VOWEL SIGN AI;Mn;0;NSM;;;;;N;;;;;
A94B;REJANG VOWEL SIGN O;Mn;0;NSM;;;;;N;;;;;
A94C;REJANG VOWEL SIGN AU;Mn;0;NSM;;;;;N;;;;;
A94D;REJANG VOWEL SIGN EU;Mn;0;NSM;;;;;N;;;;;
A94E;REJANG VOWEL SIGN EA;Mn;0;NSM;;;;;N;;;;;
A94F;REJANG CONSONANT SIGN NG;Mn;0;NSM;;;;;N;;;;;
A950;REJANG CONSONANT SIGN N;Mn;0;NSM;;;;;N;;;;;
A951;REJANG CONSONANT SIGN R;Mn;0;NSM;;;;;N;;;;;
A952;REJANG CONSONANT SIGN H;Mc;0;L;;;;;N;;;;;
A953;REJANG VIRAMA;Mc;9;L;;;;;N;;;;;
A95F;REJANG SECTION MARK;Po;0;L;;;;;N;;;;;
A960;HANGUL CHOSEONG TIKEUT-MIEUM;Lo;0;L;;;;;N;;;;;
A961;HANGUL CHOSEONG TIKEUT-PIEUP;Lo;0;L;;;;;N;;;;;
A962;HANGUL CHOSEONG TIKEUT-SIOS;Lo;0;L;;;;;N;;;;;
A963;HANGUL CHOSEONG TIKEUT-CIEUC;Lo;0;L;;;;;N;;;;;
A964;HANGUL CHOSEONG RIEUL-KIYEOK;Lo;0;L;;;;;N;;;;;
A965;HANGUL CHOSEONG RIEUL-SSANGKIYEOK;Lo;0;L;;;;;N;;;;;
A966;HANGUL CHOSEONG RIEUL-TIKEUT;Lo;0;L;;;;;N;;;;;
A967;HANGUL CHOSEONG RIEUL-SSANGTIKEUT;Lo;0;L;;;;;N;;;;;
A968;HANGUL CHOSEONG RIEUL-MIEUM;Lo;0;L;;;;;N;;;;;
A969;HANGUL CHOSEONG RIEUL-PIEUP;Lo;0;L;;;;;N;;;;;
A96A;HANGUL CHOSEONG RIEUL-SSANGPIEUP;Lo;0;L;;;;;N;;;;;
A96B;HANGUL CHOSEONG RIEUL-KAPYEOUNPIEUP;Lo;0;L;;;;;N;;;;;
A96C;HANGUL CHOSEONG RIEUL-SIOS;Lo;0;L;;;;;N;;;;;
A96D;HANGUL CHOSEONG RIEUL-CIEUC;Lo;0;L;;;;;N;;;;;
A96E;HANGUL CHOSEONG RIEUL-KHIEUKH;Lo;0;L;;;;;N;;;;;
A96F;HANGUL CHOSEONG MIEUM-KIYEOK;Lo;0;L;;;;;N;;;;;
A970;HANGUL CHOSEONG MIEUM-TIKEUT;Lo;0;L;;;;;N;;;;;
A971;HANGUL CHOSEONG MIEUM-SIOS;Lo;0;L;;;;;N;;;;;
A972;HANGUL CHOSEONG PIEUP-SIOS-THIEUTH;Lo;0;L;;;;;N;;;;;
A973;HANGUL CHOSEONG PIEUP-KHIEUKH;Lo;0;L;;;;;N;;;;;
A974;HANGUL CHOSEONG PIEUP-HIEUH;Lo;0;L;;;;;N;;;;;
A975;HANGUL CHOSEONG SSANGSIOS-PIEUP;Lo;0;L;;;;;N;;;;;
A976;HANGUL CHOSEONG IEUNG-RIEUL;Lo;0;L;;;;;N;;;;;
A977;HANGUL CHOSEONG IEUNG-HIEUH;Lo;0;L;;;;;N;;;;;
A978;HANGUL CHOSEONG SSANGCIEUC-HIEUH;Lo;0;L;;;;;N;;;;;
A979;HANGUL CHOSEONG SSANGTHIEUTH;Lo;0;L;;;;;N;;;;;
A97A;HANGUL CHOSEONG PHIEUPH-HIEUH;Lo;0;L;;;;;N;;;;;
A97B;HANGUL CHOSEONG HIEUH-SIOS;Lo;0;L;;;;;N;;;;;
A97C;HANGUL CHOSEONG SSANGYEORINHIEUH;Lo;0;L;;;;;N;;;;;
A980;JAVANESE SIGN PANYANGGA;Mn;0;NSM;;;;;N;;;;;
A981;JAVANESE SIGN CECAK;Mn;0;NSM;;;;;N;;;;;
A982;JAVANESE SIGN LAYAR;Mn;0;NSM;;;;;N;;;;;
A983;JAVANESE SIGN WIGNYAN;Mc;0;L;;;;;N;;;;;
A984;JAVANESE LETTER A;Lo;0;L;;;;;N;;;;;
A985;JAVANESE LETTER I KAWI;Lo;0;L;;;;;N;;;;;
A986;JAVANESE LETTER I;Lo;0;L;;;;;N;;;;;
A987;JAVANESE LETTER II;Lo;0;L;;;;;N;;;;;
A988;JAVANESE LETTER U;Lo;0;L;;;;;N;;;;;
A989;JAVANESE LETTER PA CEREK;Lo;0;L;;;;;N;;;;;
A98A;JAVANESE LETTER NGA LELET;Lo;0;L;;;;;N;;;;;
A98B;JAVANESE LETTER NGA LELET RASWADI;Lo;0;L;;;;;N;;;;;
A98C;JAVANESE LETTER E;Lo;0;L;;;;;N;;;;;
A98D;JAVANESE LETTER AI;Lo;0;L;;;;;N;;;;;
A98E;JAVANESE LETTER O;Lo;0;L;;;;;N;;;;;
A98F;JAVANESE LETTER KA;Lo;0;L;;;;;N;;;;;
A990;JAVANESE LETTER KA SASAK;Lo;0;L;;;;;N;;;;;
A991;JAVANESE LETTER KA MURDA;Lo;0;L;;;;;N;;;;;
A992;JAVANESE LETTER GA;Lo;0;L;;;;;N;;;;;
A993;JAVANESE LETTER GA MURDA;Lo;0;L;;;;;N;;;;;
A994;JAVANESE LETTER NGA;Lo;0;L;;;;;N;;;;;
A995;JAVANESE LETTER CA;Lo;0;L;;;;;N;;;;;
A996;JAVANESE LETTER CA MURDA;Lo;0;L;;;;;N;;;;;
A997;JAVANESE LETTER JA;Lo;0;L;;;;;N;;;;;
A998;JAVANESE LETTER NYA MURDA;Lo;0;L;;;;;N;;;;;
A999;JAVANESE LETTER JA MAHAPRANA;Lo;0;L;;;;;N;;;;;
A99A;JAVANESE LETTER NYA;Lo;0;L;;;;;N;;;;;
A99B;JAVANESE LETTER TTA;Lo;0;L;;;;;N;;;;;
A99C;JAVANESE LETTER TTA MAHAPRANA;Lo;0;L;;;;;N;;;;;
A99D;JAVANESE LETTER DDA;Lo;0;L;;;;;N;;;;;
A99E;JAVANESE LETTER DDA MAHAPRANA;Lo;0;L;;;;;N;;;;;
A99F;JAVANESE LETTER NA MURDA;Lo;0;L;;;;;N;;;;;
A9A0;JAVANESE LETTER TA;Lo;0;L;;;;;N;;;;;
A9A1;JAVANESE LETTER TA MURDA;Lo;0;L;;;;;N;;;;;
A9A2;JAVANESE LETTER DA;Lo;0;L;;;;;N;;;;;
A9A3;JAVANESE LETTER DA MAHAPRANA;Lo;0;L;;;;;N;;;;;
A9A4;JAVANESE LETTER NA;Lo;0;L;;;;;N;;;;;
A9A5;JAVANESE LETTER PA;Lo;0;L;;;;;N;;;;;
A9A6;JAVANESE LETTER PA MURDA;Lo;0;L;;;;;N;;;;;
A9A7;JAVANESE LETTER BA;Lo;0;L;;;;;N;;;;;
A9A8;JAVANESE LETTER BA MURDA;Lo;0;L;;;;;N;;;;;
A9A9;JAVANESE LETTER MA;Lo;0;L;;;;;N;;;;;
A9AA;JAVANESE LETTER YA;Lo;0;L;;;;;N;;;;;
A9AB;JAVANESE LETTER RA;Lo;0;L;;;;;N;;;;;
A9AC;JAVANESE LETTER RA AGUNG;Lo;0;L;;;;;N;;;;;
A9AD;JAVANESE LETTER LA;Lo;0;L;;;;;N;;;;;
A9AE;JAVANESE LETTER WA;Lo;0;L;;;;;N;;;;;
A9AF;JAVANESE LETTER SA MURDA;Lo;0;L;;;;;N;;;;;
A9B0;JAVANESE LETTER SA MAHAPRANA;Lo;0;L;;;;;N;;;;;
A9B1;JAVANESE LETTER SA;Lo;0;L;;;;;N;;;;;
A9B2;JAVANESE LETTER HA;Lo;0;L;;;;;N;;;;;
A9B3;JAVANESE SIGN CECAK TELU;Mn;7;NSM;;;;;N;;;;;
A9B4;JAVANESE VOWEL SIGN TARUNG;Mc;0;L;;;;;N;;;;;
A9B5;JAVANESE VOWEL SIGN TOLONG;Mc;0;L;;;;;N;;;;;
A9B6;JAVANESE VOWEL SIGN WULU;Mn;0;NSM;;;;;N;;;;;
A9B7;JAVANESE VOWEL SIGN WULU MELIK;Mn;0;NSM;;;;;N;;;;;
A9B8;JAVANESE VOWEL SIGN SUKU;Mn;0;NSM;;;;;N;;;;;
A9B9;JAVANESE VOWEL SIGN SUKU MENDUT;Mn;0;NSM;;;;;N;;;;;
A9BA;JAVANESE VOWEL SIGN TALING;Mc;0;L;;;;;N;;;;;
A9BB;JAVANESE VOWEL SIGN DIRGA MURE;Mc;0;L;;;;;N;;;;;
A9BC;JAVANESE VOWEL SIGN PEPET;Mn;0;NSM;;;;;N;;;;;
A9BD;JAVANESE CONSONANT SIGN KERET;Mn;0;NSM;;;;;N;;;;;
A9BE;JAVANESE CONSONANT SIGN PENGKAL;Mc;0;L;;;;;N;;;;;
A9BF;JAVANESE CONSONANT SIGN CAKRA;Mc;0;L;;;;;N;;;;;
A9C0;JAVANESE PANGKON;Mc;9;L;;;;;N;;;;;
A9C1;JAVANESE LEFT RERENGGAN;Po;0;L;;;;;N;;;;;
A9C2;JAVANESE RIGHT RERENGGAN;Po;0;L;;;;;N;;;;;
A9C3;JAVANESE PADA ANDAP;Po;0;L;;;;;N;;;;;
A9C4;JAVANESE PADA MADYA;Po;0;L;;;;;N;;;;;
A9C5;JAVANESE PADA LUHUR;Po;0;L;;;;;N;;;;;
A9C6;JAVANESE PADA WINDU;Po;0;L;;;;;N;;;;;
A9C7;JAVANESE PADA PANGKAT;Po;0;L;;;;;N;;;;;
A9C8;JAVANESE PADA LINGSA;Po;0;L;;;;;N;;;;;
A9C9;JAVANESE PADA LUNGSI;Po;0;L;;;;;N;;;;;
A9CA;JAVANESE PADA ADEG;Po;0;L;;;;;N;;;;;
A9CB;JAVANESE PADA ADEG ADEG;Po;0;L;;;;;N;;;;;
A9CC;JAVANESE PADA PISELEH;Po;0;L;;;;;N;;;;;
A9CD;JAVANESE TURNED PADA PISELEH;Po;0;L;;;;;N;;;;;
A9CF;JAVANESE PANGRANGKEP;Lm;0;L;;;;;N;;;;;
A9D0;JAVANESE DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
A9D1;JAVANESE DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
A9D2;JAVANESE DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
A9D3;JAVANESE DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
A9D4;JAVANESE DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
A9D5;JAVANESE DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
A9D6;JAVANESE DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
A9D7;JAVANESE DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
A9D8;JAVANESE DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
A9D9;JAVANESE DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
A9DE;JAVANESE PADA TIRTA TUMETES;Po;0;L;;;;;N;;;;;
A9DF;JAVANESE PADA ISEN-ISEN;Po;0;L;;;;;N;;;;;
A9E0;MYANMAR LETTER SHAN GHA;Lo;0;L;;;;;N;;;;;
A9E1;MYANMAR LETTER SHAN CHA;Lo;0;L;;;;;N;;;;;
A9E2;MYANMAR LETTER SHAN JHA;Lo;0;L;;;;;N;;;;;
A9E3;MYANMAR LETTER SHAN NNA;Lo;0;L;;;;;N;;;;;
A9E4;MYANMAR LETTER SHAN BHA;Lo;0;L;;;;;N;;;;;
A9E5;MYANMAR SIGN SHAN SAW;Mn;0;NSM;;;;;N;;;;;
A9E6;MYANMAR MODIFIER LETTER SHAN REDUPLICATION;Lm;0;L;;;;;N;;;;;
A9E7;MYANMAR LETTER TAI LAING NYA;Lo;0;L;;;;;N;;;;;
A9E8;MYANMAR LETTER TAI LAING FA;Lo;0;L;;;;;N;;;;;
A9E9;MYANMAR LETTER TAI LAING GA;Lo;0;L;;;;;N;;;;;
A9EA;MYANMAR LETTER TAI LAING GHA;Lo;0;L;;;;;N;;;;;
A9EB;MYANMAR LETTER TAI LAING JA;Lo;0;L;;;;;N;;;;;
A9EC;MYANMAR LETTER TAI LAING JHA;Lo;0;L;;;;;N;;;;;
A9ED;MYANMAR LETTER TAI LAING DDA;Lo;0;L;;;;;N;;;;;
A9EE;MYANMAR LETTER TAI LAING DDHA;Lo;0;L;;;;;N;;;;;
A9EF;MYANMAR LETTER TAI LAING NNA;Lo;0;L;;;;;N;;;;;
A9F0;MYANMAR TAI LAING DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
A9F1;MYANMAR TAI LAING DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
A9F2;MYANMAR TAI LAING DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
A9F3;MYANMAR TAI LAING DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
A9F4;MYANMAR TAI LAING DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
A9F5;MYANMAR TAI LAING DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
A9F6;MYANMAR TAI LAING DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
A9F7;MYANMAR TAI LAING DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
A9F8;MYANMAR TAI LAING DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
A9F9;MYANMAR TAI LAING DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
A9FA;MYANMAR LETTER TAI LAING LLA;Lo;0;L;;;;;N;;;;;
A9FB;MYANMAR LETTER TAI LAING DA;Lo;0;L;;;;;N;;;;;
A9FC;MYANMAR LETTER TAI LAING DHA;Lo;0;L;;;;;N;;;;;
A9FD;MYANMAR LETTER TAI LAING BA;Lo;0;L;;;;;N;;;;;
A9FE;MYANMAR LETTER TAI LAING BHA;Lo;0;L;;;;;N;;;;;
AA00;CHAM LETTER A;Lo;0;L;;;;;N;;;;;
AA01;CHAM LETTER I;Lo;0;L;;;;;N;;;;;
AA02;CHAM LETTER U;Lo;0;L;;;;;N;;;;;
AA03;CHAM LETTER E;Lo;0;L;;;;;N;;;;;
AA04;CHAM LETTER AI;Lo;0;L;;;;;N;;;;;
AA05;CHAM LETTER O;Lo;0;L;;;;;N;;;;;
AA06;CHAM LETTER KA;Lo;0;L;;;;;N;;;;;
AA07;CHAM LETTER KHA;Lo;0;L;;;;;N;;;;;
AA08;CHAM LETTER GA;Lo;0;L;;;;;N;;;;;
AA09;CHAM LETTER GHA;Lo;0;L;;;;;N;;;;;
AA0A;CHAM LETTER NGUE;Lo;0;L;;;;;N;;;;;
AA0B;CHAM LETTER NGA;Lo;0;L;;;;;N;;;;;
AA0C;CHAM LETTER CHA;Lo;0;L;;;;;N;;;;;
AA0D;CHAM LETTER CHHA;Lo;0;L;;;;;N;;;;;
AA0E;CHAM LETTER JA;Lo;0;L;;;;;N;;;;;
AA0F;CHAM LETTER JHA;Lo;0;L;;;;;N;;;;;
AA10;CHAM LETTER NHUE;Lo;0;L;;;;;N;;;;;
AA11;CHAM LETTER NHA;Lo;0;L;;;;;N;;;;;
AA12;CHAM LETTER NHJA;Lo;0;L;;;;;N;;;;;
AA13;CHAM LETTER TA;Lo;0;L;;;;;N;;;;;
AA14;CHAM LETTER THA;Lo;0;L;;;;;N;;;;;
AA15;CHAM LETTER DA;Lo;0;L;;;;;N;;;;;
AA16;CHAM LETTER DHA;Lo;0;L;;;;;N;;;;;
AA17;CHAM LETTER NUE;Lo;0;L;;;;;N;;;;;
AA18;CHAM LETTER NA;Lo;0;L;;;;;N;;;;;
AA19;CHAM LETTER DDA;Lo;0;L;;;;;N;;;;;
AA1A;CHAM LETTER PA;Lo;0;L;;;;;N;;;;;
AA1B;CHAM LETTER PPA;Lo;0;L;;;;;N;;;;;
AA1C;CHAM LETTER PHA;Lo;0;L;;;;;N;;;;;
AA1D;CHAM LETTER BA;Lo;0;L;;;;;N;;;;;
AA1E;CHAM LETTER BHA;Lo;0;L;;;;;N;;;;;
AA1F;CHAM LETTER MUE;Lo;0;L;;;;;N;;;;;
AA20;CHAM LETTER MA;Lo;0;L;;;;;N;;;;;
AA21;CHAM LETTER BBA;Lo;0;L;;;;;N;;;;;
AA22;CHAM LETTER YA;Lo;0;L;;;;;N;;;;;
AA23;CHAM LETTER RA;Lo;0;L;;;;;N;;;;;
AA24;CHAM LETTER LA;Lo;0;L;;;;;N;;;;;
AA25;CHAM LETTER VA;Lo;0;L;;;;;N;;;;;
AA26;CHAM LETTER SSA;Lo;0;L;;;;;N;;;;;
AA27;CHAM LETTER SA;Lo;0;L;;;;;N;;;;;
AA28;CHAM LETTER HA;Lo;0;L;;;;;N;;;;;
AA29;CHAM VOWEL SIGN AA;Mn;0;NSM;;;;;N;;;;;
AA2A;CHAM VOWEL SIGN I;Mn;0;NSM;;;;;N;;;;;
AA2B;CHAM VOWEL SIGN II;Mn;0;NSM;;;;;N;;;;;
AA2C;CHAM VOWEL SIGN EI;Mn;0;NSM;;;;;N;;;;;
AA2D;CHAM VOWEL SIGN U;Mn;0;NSM;;;;;N;;;;;
AA2E;CHAM VOWEL SIGN OE;Mn;0;NSM;;;;;N;;;;;
AA2F;CHAM VOWEL SIGN O;Mc;0;L;;;;;N;;;;;
AA30;CHAM VOWEL SIGN AI;Mc;0;L;;;;;N;;;;;
AA31;CHAM VOWEL SIGN AU;Mn;0;NSM;;;;;N;;;;;
AA32;CHAM VOWEL SIGN UE;Mn;0;NSM;;;;;N;;;;;
AA33;CHAM CONSONANT SIGN YA;Mc;0;L;;;;;N;;;;;
AA34;CHAM CONSONANT SIGN RA;Mc;0;L;;;;;N;;;;;
AA35;CHAM CONSONANT SIGN LA;Mn;0;NSM;;;;;N;;;;;
AA36;CHAM CONSONANT SIGN WA;Mn;0;NSM;;;;;N;;;;;
AA40;CHAM LETTER FINAL K;Lo;0;L;;;;;N;;;;;
AA41;CHAM LETTER FINAL G;Lo;0;L;;;;;N;;;;;
AA42;CHAM LETTER FINAL NG;Lo;0;L;;;;;N;;;;;
AA43;CHAM CONSONANT SIGN FINAL NG;Mn;0;NSM;;;;;N;;;;;
AA44;CHAM LETTER FINAL CH;Lo;0;L;;;;;N;;;;;
AA45;CHAM LETTER FINAL T;Lo;0;L;;;;;N;;;;;
AA46;CHAM LETTER FINAL N;Lo;0;L;;;;;N;;;;;
AA47;CHAM LETTER FINAL P;Lo;0;L;;;;;N;;;;;
AA48;CHAM LETTER FINAL Y;Lo;0;L;;;;;N;;;;;
AA49;CHAM LETTER FINAL R;Lo;0;L;;;;;N;;;;;
AA4A;CHAM LETTER FINAL L;Lo;0;L;;;;;N;;;;;
AA4B;CHAM LETTER FINAL SS;Lo;0;L;;;;;N;;;;;
AA4C;CHAM CONSONANT SIGN FINAL M;Mn;0;NSM;;;;;N;;;;;
AA4D;CHAM CONSONANT SIGN FINAL H;Mc;0;L;;;;;N;;;;;
AA50;CHAM DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
AA51;CHAM DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
AA52;CHAM DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
AA53;CHAM DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
AA54;CHAM DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
AA55;CHAM DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
AA56;CHAM DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
AA57;CHAM DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
AA58;CHAM DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
AA59;CHAM DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
AA5C;CHAM PUNCTUATION SPIRAL;Po;0;L;;;;;N;;;;;
AA5D;CHAM PUNCTUATION DANDA;Po;0;L;;;;;N;;;;;
AA5E;CHAM PUNCTUATION DOUBLE DANDA;Po;0;L;;;;;N;;;;;
AA5F;CHAM PUNCTUATION TRIPLE DANDA;Po;0;L;;;;;N;;;;;
AA60;MYANMAR LETTER KHAMTI GA;Lo;0;L;;;;;N;;;;;
AA61;MYANMAR LETTER KHAMTI CA;Lo;0;L;;;;;N;;;;;
AA62;MYANMAR LETTER KHAMTI CHA;Lo;0;L;;;;;N;;;;;
AA63;MYANMAR LETTER KHAMTI JA;Lo;0;L;;;;;N;;;;;
AA64;MYANMAR LETTER KHAMTI JHA;Lo;0;L;;;;;N;;;;;
AA65;MYANMAR LETTER KHAMTI NYA;Lo;0;L;;;;;N;;;;;
AA66;MYANMAR LETTER KHAMTI TTA;Lo;0;L;;;;;N;;;;;
AA67;MYANMAR LETTER KHAMTI TTHA;Lo;0;L;;;;;N;;;;;
AA68;MYANMAR LETTER KHAMTI DDA;Lo;0;L;;;;;N;;;;;
AA69;MYANMAR LETTER KHAMTI DDHA;Lo;0;L;;;;;N;;;;;
AA6A;MYANMAR LETTER KHAMTI DHA;Lo;0;L;;;;;N;;;;;
AA6B;MYANMAR LETTER KHAMTI NA;Lo;0;L;;;;;N;;;;;
AA6C;MYANMAR LETTER KHAMTI SA;Lo;0;L;;;;;N;;;;;
AA6D;MYANMAR LETTER KHAMTI HA;Lo;0;L;;;;;N;;;;;
AA6E;MYANMAR LETTER KHAMTI HHA;Lo;0;L;;;;;N;;;;;
AA6F;MYANMAR LETTER KHAMTI FA;Lo;0;L;;;;;N;;;;;
AA70;MYANMAR MODIFIER LETTER KHAMTI REDUPLICATION;Lm;0;L;;;;;N;;;;;
AA71;MYANMAR LETTER KHAMTI XA;Lo;0;L;;;;;N;;;;;
AA72;MYANMAR LETTER KHAMTI ZA;Lo;0;L;;;;;N;;;;;
AA73;MYANMAR LETTER KHAMTI RA;Lo;0;L;;;;;N;;;;;
AA74;MYANMAR LOGOGRAM KHAMTI OAY;Lo;0;L;;;;;N;;;;;
AA75;MYANMAR LOGOGRAM KHAMTI QN;Lo;0;L;;;;;N;;;;;
AA76;MYANMAR LOGOGRAM KHAMTI HM;Lo;0;L;;;;;N;;;;;
AA77;MYANMAR SYMBOL AITON EXCLAMATION;So;0;L;;;;;N;;;;;
AA78;MYANMAR SYMBOL AITON ONE;So;0;L;;;;;N;;;;;
AA79;MYANMAR SYMBOL AITON TWO;So;0;L;;;;;N;;;;;
AA7A;MYANMAR LETTER AITON RA;Lo;0;L;;;;;N;;;;;
AA7B;MYANMAR SIGN PAO KAREN TONE;Mc;0;L;;;;;N;;;;;
AA7C;MYANMAR SIGN TAI LAING TONE-2;Mn;0;NSM;;;;;N;;;;;
AA7D;MYANMAR SIGN TAI LAING TONE-5;Mc;0;L;;;;;N;;;;;
AA7E;MYANMAR LETTER SHWE PALAUNG CHA;Lo;0;L;;;;;N;;;;;
AA7F;MYANMAR LETTER SHWE PALAUNG SHA;Lo;0;L;;;;;N;;;;;
AA80;TAI VIET LETTER LOW KO;Lo;0;L;;;;;N;;;;;
AA81;TAI VIET LETTER HIGH KO;Lo;0;L;;;;;N;;;;;
AA82;TAI VIET LETTER LOW KHO;Lo;0;L;;;;;N;;;;;
AA83;TAI VIET LETTER HIGH KHO;Lo;0;L;;;;;N;;;;;
AA84;TAI VIET LETTER LOW KHHO;Lo;0;L;;;;;N;;;;;
AA85;TAI VIET LETTER HIGH KHHO;Lo;0;L;;;;;N;;;;;
AA86;TAI VIET LETTER LOW GO;Lo;0;L;;;;;N;;;;;
AA87;TAI VIET LETTER HIGH GO;Lo;0;L;;;;;N;;;;;
AA88;TAI VIET LETTER LOW NGO;Lo;0;L;;;;;N;;;;;
AA89;TAI VIET LETTER HIGH NGO;Lo;0;L;;;;;N;;;;;
AA8A;TAI VIET LETTER LOW CO;Lo;0;L;;;;;N;;;;;
AA8B;TAI VIET LETTER HIGH CO;Lo;0;L;;;;;N;;;;;
AA8C;TAI VIET LETTER LOW CHO;Lo;0;L;;;;;N;;;;;
AA8D;TAI VIET LETTER HIGH CHO;Lo;0;L;;;;;N;;;;;
AA8E;TAI VIET LETTER LOW SO;Lo;0;L;;;;;N;;;;;
AA8F;TAI VIET LETTER HIGH SO;Lo;0;L;;;;;N;;;;;
AA90;TAI VIET LETTER LOW NYO;Lo;0;L;;;;;N;;;;;
AA91;TAI VIET LETTER HIGH NYO;Lo;0;L;;;;;N;;;;;
AA92;TAI VIET LETTER LOW DO;Lo;0;L;;;;;N;;;;;
AA93;TAI VIET LETTER HIGH DO;Lo;0;L;;;;;N;;;;;
AA94;TAI VIET LETTER LOW TO;Lo;0;L;;;;;N;;;;;
AA95;TAI VIET LETTER HIGH TO;Lo;0;L;;;;;N;;;;;
AA96;TAI VIET LETTER LOW THO;Lo;0;L;;;;;N;;;;;
AA97;TAI VIET LETTER HIGH THO;Lo;0;L;;;;;N;;;;;
AA98;TAI VIET LETTER LOW NO;Lo;0;L;;;;;N;;;;;
AA99;TAI VIET LETTER HIGH NO;Lo;0;L;;;;;N;;;;;
AA9A;TAI VIET LETTER LOW BO;Lo;0;L;;;;;N;;;;;
AA9B;TAI VIET LETTER HIGH BO;Lo;0;L;;;;;N;;;;;
AA9C;TAI VIET LETTER LOW PO;Lo;0;L;;;;;N;;;;;
AA9D;TAI VIET LETTER HIGH PO;Lo;0;L;;;;;N;;;;;
AA9E;TAI VIET LETTER LOW PHO;Lo;0;L;;;;;N;;;;;
AA9F;TAI VIET LETTER HIGH PHO;Lo;0;L;;;;;N;;;;;
AAA0;TAI VIET LETTER LOW FO;Lo;0;L;;;;;N;;;;;
AAA1;TAI VIET LETTER HIGH FO;Lo;0;L;;;;;N;;;;;
AAA2;TAI VIET LETTER LOW MO;Lo;0;L;;;;;N;;;;;
AAA3;TAI VIET LETTER HIGH MO;Lo;0;L;;;;;N;;;;;
AAA4;TAI VIET LETTER LOW YO;Lo;0;L;;;;;N;;;;;
AAA5;TAI VIET LETTER HIGH YO;Lo;0;L;;;;;N;;;;;
AAA6;TAI VIET LETTER LOW RO;Lo;0;L;;;;;N;;;;;
AAA7;TAI VIET LETTER HIGH RO;Lo;0;L;;;;;N;;;;;
AAA8;TAI VIET LETTER LOW LO;Lo;0;L;;;;;N;;;;;
AAA9;TAI VIET LETTER HIGH LO;Lo;0;L;;;;;N;;;;;
AAAA;TAI VIET LETTER LOW VO;Lo;0;L;;;;;N;;;;;
AAAB;TAI VIET LETTER HIGH VO;Lo;0;L;;;;;N;;;;;
AAAC;TAI VIET LETTER LOW HO;Lo;0;L;;;;;N;;;;;
AAAD;TAI VIET LETTER HIGH HO;Lo;0;L;;;;;N;;;;;
AAAE;TAI VIET LETTER LOW O;Lo;0;L;;;;;N;;;;;
AAAF;TAI VIET LETTER HIGH O;Lo;0;L;;;;;N;;;;;
AAB0;TAI VIET MAI KANG;Mn;230;NSM;;;;;N;;;;;
AAB1;TAI VIET VOWEL AA;Lo;0;L;;;;;N;;;;;
AAB2;TAI VIET VOWEL I;Mn;230;NSM;;;;;N;;;;;
AAB3;TAI VIET VOWEL UE;Mn;230;NSM;;;;;N;;;;;
AAB4;TAI VIET VOWEL U;Mn;220;NSM;;;;;N;;;;;
AAB5;TAI VIET VOWEL E;Lo;0;L;;;;;N;;;;;
AAB6;TAI VIET VOWEL O;Lo;0;L;;;;;N;;;;;
AAB7;TAI VIET MAI KHIT;Mn;230;NSM;;;;;N;;;;;
AAB8;TAI VIET VOWEL IA;Mn;230;NSM;;;;;N;;;;;
AAB9;TAI VIET VOWEL UEA;Lo;0;L;;;;;N;;;;;
AABA;TAI VIET VOWEL UA;Lo;0;L;;;;;N;;;;;
AABB;TAI VIET VOWEL AUE;Lo;0;L;;;;;N;;;;;
AABC;TAI VIET VOWEL AY;Lo;0;L;;;;;N;;;;;
AABD;TAI VIET VOWEL AN;Lo;0;L;;;;;N;;;;;
AABE;TAI VIET VOWEL AM;Mn;230;NSM;;;;;N;;;;;
AABF;TAI VIET TONE MAI EK;Mn;230;NSM;;;;;N;;;;;
AAC0;TAI VIET TONE MAI NUENG;Lo;0;L;;;;;N;;;;;
AAC1;TAI VIET TONE MAI THO;Mn;230;NSM;;;;;N;;;;;
AAC2;TAI VIET TONE MAI SONG;Lo;0;L;;;;;N;;;;;
AADB;TAI VIET SYMBOL KON;Lo;0;L;;;;;N;;;;;
AADC;TAI VIET SYMBOL NUENG;Lo;0;L;;;;;N;;;;;
AADD;TAI VIET SYMBOL SAM;Lm;0;L;;;;;N;;;;;
AADE;TAI VIET SYMBOL HO HOI;Po;0;L;;;;;N;;;;;
AADF;TAI VIET SYMBOL KOI KOI;Po;0;L;;;;;N;;;;;
AAE0;MEETEI MAYEK LETTER E;Lo;0;L;;;;;N;;;;;
AAE1;MEETEI MAYEK LETTER O;Lo;0;L;;;;;N;;;;;
AAE2;MEETEI MAYEK LETTER CHA;Lo;0;L;;;;;N;;;;;
AAE3;MEETEI MAYEK LETTER NYA;Lo;0;L;;;;;N;;;;;
AAE4;MEETEI MAYEK LETTER TTA;Lo;0;L;;;;;N;;;;;
AAE5;MEETEI MAYEK LETTER TTHA;Lo;0;L;;;;;N;;;;;
AAE6;MEETEI MAYEK LETTER DDA;Lo;0;L;;;;;N;;;;;
AAE7;MEETEI MAYEK LETTER DDHA;Lo;0;L;;;;;N;;;;;
AAE8;MEETEI MAYEK LETTER NNA;Lo;0;L;;;;;N;;;;;
AAE9;MEETEI MAYEK LETTER SHA;Lo;0;L;;;;;N;;;;;
AAEA;MEETEI MAYEK LETTER SSA;Lo;0;L;;;;;N;;;;;
AAEB;MEETEI MAYEK VOWEL SIGN II;Mc;0;L;;;;;N;;;;;
AAEC;MEETEI MAYEK VOWEL SIGN UU;Mn;0;NSM;;;;;N;;;;;
AAED;MEETEI MAYEK VOWEL SIGN AAI;Mn;0;NSM;;;;;N;;;;;
AAEE;MEETEI MAYEK VOWEL SIGN AU;Mc;0;L;;;;;N;;;;;
AAEF;MEETEI MAYEK VOWEL SIGN AAU;Mc;0;L;;;;;N;;;;;
AAF0;MEETEI MAYEK CHEIKHAN;Po;0;L;;;;;N;;;;;
AAF1;MEETEI MAYEK AHANG KHUDAM;Po;0;L;;;;;N;;;;;
AAF2;MEETEI MAYEK ANJI;Lo;0;L;;;;;N;;;;;
AAF3;MEETEI MAYEK SYLLABLE REPETITION MARK;Lm;0;L;;;;;N;;;;;
AAF4;MEETEI MAYEK WORD REPETITION MARK;Lm;0;L;;;;;N;;;;;
AAF5;MEETEI MAYEK VOWEL SIGN VISARGA;Mc;0;L;;;;;N;;;;;
AAF6;MEETEI MAYEK VIRAMA;Mn;9;NSM;;;;;N;;;;;
AB01;ETHIOPIC SYLLABLE TTHU;Lo;0;L;;;;;N;;;;;
AB02;ETHIOPIC SYLLABLE TTHI;Lo;0;L;;;;;N;;;;;
AB03;ETHIOPIC SYLLABLE TTHAA;Lo;0;L;;;;;N;;;;;
AB04;ETHIOPIC SYLLABLE TTHEE;Lo;0;L;;;;;N;;;;;
AB05;ETHIOPIC SYLLABLE TTHE;Lo;0;L;;;;;N;;;;;
AB06;ETHIOPIC SYLLABLE TTHO;Lo;0;L;;;;;N;;;;;
AB09;ETHIOPIC SYLLABLE DDHU;Lo;0;L;;;;;N;;;;;
AB0A;ETHIOPIC SYLLABLE DDHI;Lo;0;L;;;;;N;;;;;
AB0B;ETHIOPIC SYLLABLE DDHAA;Lo;0;L;;;;;N;;;;;
AB0C;ETHIOPIC SYLLABLE DDHEE;Lo;0;L;;;;;N;;;;;
AB0D;ETHIOPIC SYLLABLE DDHE;Lo;0;L;;;;;N;;;;;
AB0E;ETHIOPIC SYLLABLE DDHO;Lo;0;L;;;;;N;;;;;
AB11;ETHIOPIC SYLLABLE DZU;Lo;0;L;;;;;N;;;;;
AB12;ETHIOPIC SYLLABLE DZI;Lo;0;L;;;;;N;;;;;
AB13;ETHIOPIC SYLLABLE DZAA;Lo;0;L;;;;;N;;;;;
AB14;ETHIOPIC SYLLABLE DZEE;Lo;0;L;;;;;N;;;;;
AB15;ETHIOPIC SYLLABLE DZE;Lo;0;L;;;;;N;;;;;
AB16;ETHIOPIC SYLLABLE DZO;Lo;0;L;;;;;N;;;;;
AB20;ETHIOPIC SYLLABLE CCHHA;Lo;0;L;;;;;N;;;;;
AB21;ETHIOPIC SYLLABLE CCHHU;Lo;0;L;;;;;N;;;;;
AB22;ETHIOPIC SYLLABLE CCHHI;Lo;0;L;;;;;N;;;;;
AB23;ETHIOPIC SYLLABLE CCHHAA;Lo;0;L;;;;;N;;;;;
AB24;ETHIOPIC SYLLABLE CCHHEE;Lo;0;L;;;;;N;;;;;
AB25;ETHIOPIC SYLLABLE CCHHE;Lo;0;L;;;;;N;;;;;
AB26;ETHIOPIC SYLLABLE CCHHO;Lo;0;L;;;;;N;;;;;
AB28;ETHIOPIC SYLLABLE BBA;Lo;0;L;;;;;N;;;;;
AB29;ETHIOPIC SYLLABLE BBU;Lo;0;L;;;;;N;;;;;
AB2A;ETHIOPIC SYLLABLE BBI;Lo;0;L;;;;;N;;;;;
AB2B;ETHIOPIC SYLLABLE BBAA;Lo;0;L;;;;;N;;;;;
AB2C;ETHIOPIC SYLLABLE BBEE;Lo;0;L;;;;;N;;;;;
AB2D;ETHIOPIC SYLLABLE BBE;Lo;0;L;;;;;N;;;;;
AB2E;ETHIOPIC SYLLABLE BBO;Lo;0;L;;;;;N;;;;;
AB30;LATIN SMALL LETTER BARRED ALPHA;Ll;0;L;;;;;N;;;;;
AB31;LATIN SMALL LETTER A REVERSED-SCHWA;Ll;0;L;;;;;N;;;;;
AB32;LATIN SMALL LETTER BLACKLETTER E;Ll;0;L;;;;;N;;;;;
AB33;LATIN SMALL LETTER BARRED E;Ll;0;L;;;;;N;;;;;
AB34;LATIN SMALL LETTER E WITH FLOURISH;Ll;0;L;;;;;N;;;;;
AB35;LATIN SMALL LETTER LENIS F;Ll;0;L;;;;;N;;;;;
AB36;LATIN SMALL LETTER SCRIPT G WITH CROSSED-TAIL;Ll;0;L;;;;;N;;;;;
AB37;LATIN SMALL LETTER L WITH INVERTED LAZY S;Ll;0;L;;;;;N;;;;;
AB38;LATIN SMALL LETTER L WITH DOUBLE MIDDLE TILDE;Ll;0;L;;;;;N;;;;;
AB39;LATIN SMALL LETTER L WITH MIDDLE RING;Ll;0;L;;;;;N;;;;;
AB3A;LATIN SMALL LETTER M WITH CROSSED-TAIL;Ll;0;L;;;;;N;;;;;
AB3B;LATIN SMALL LETTER N WITH CROSSED-TAIL;Ll;0;L;;;;;N;;;;;
AB3C;LATIN SMALL LETTER ENG WITH CROSSED-TAIL;Ll;0;L;;;;;N;;;;;
AB3D;LATIN SMALL LETTER BLACKLETTER O;Ll;0;L;;;;;N;;;;;
AB3E;LATIN SMALL LETTER BLACKLETTER O WITH STROKE;Ll;0;L;;;;;N;;;;;
AB3F;LATIN SMALL LETTER OPEN O WITH STROKE;Ll;0;L;;;;;N;;;;;
AB40;LATIN SMALL LETTER INVERTED OE;Ll;0;L;;;;;N;;;;;
AB41;LATIN SMALL LETTER TURNED OE WITH STROKE;Ll;0;L;;;;;N;;;;;
AB42;LATIN SMALL LETTER TURNED OE WITH HORIZONTAL STROKE;Ll;0;L;;;;;N;;;;;
AB43;LATIN SMALL LETTER TURNED O OPEN-O;Ll;0;L;;;;;N;;;;;
AB44;LATIN SMALL LETTER TURNED O OPEN-O WITH STROKE;Ll;0;L;;;;;N;;;;;
AB45;LATIN SMALL LETTER STIRRUP R;Ll;0;L;;;;;N;;;;;
AB46;LATIN LETTER SMALL CAPITAL R WITH RIGHT LEG;Ll;0;L;;;;;N;;;;;
AB47;LATIN SMALL LETTER R WITHOUT HANDLE;Ll;0;L;;;;;N;;;;;
AB48;LATIN SMALL LETTER DOUBLE R;Ll;0;L;;;;;N;;;;;
AB49;LATIN SMALL LETTER R WITH CROSSED-TAIL;Ll;0;L;;;;;N;;;;;
AB4A;LATIN SMALL LETTER DOUBLE R WITH CROSSED-TAIL;Ll;0;L;;;;;N;;;;;
AB4B;LATIN SMALL LETTER SCRIPT R;Ll;0;L;;;;;N;;;;;
AB4C;LATIN SMALL LETTER SCRIPT R WITH RING;Ll;0;L;;;;;N;;;;;
AB4D;LATIN SMALL LETTER BASELINE ESH;Ll;0;L;;;;;N;;;;;
AB4E;LATIN SMALL LETTER U WITH SHORT RIGHT LEG;Ll;0;L;;;;;N;;;;;
AB4F;LATIN SMALL LETTER U BAR WITH SHORT RIGHT LEG;Ll;0;L;;;;;N;;;;;
AB50;LATIN SMALL LETTER UI;Ll;0;L;;;;;N;;;;;
AB51;LATIN SMALL LETTER TURNED UI;Ll;0;L;;;;;N;;;;;
AB52;LATIN SMALL LETTER U WITH LEFT HOOK;Ll;0;L;;;;;N;;;;;
AB53;LATIN SMALL LETTER CHI;Ll;0;L;;;;;N;;;A7B3;;A7B3
AB54;LATIN SMALL LETTER CHI WITH LOW RIGHT RING;Ll;0;L;;;;;N;;;;;
AB55;LATIN SMALL LETTER CHI WITH LOW LEFT SERIF;Ll;0;L;;;;;N;;;;;
AB56;LATIN SMALL LETTER X WITH LOW RIGHT RING;Ll;0;L;;;;;N;;;;;
AB57;LATIN SMALL LETTER X WITH LONG LEFT LEG;Ll;0;L;;;;;N;;;;;
AB58;LATIN SMALL LETTER X WITH LONG LEFT LEG AND LOW RIGHT RING;Ll;0;L;;;;;N;;;;;
AB59;LATIN SMALL LETTER X WITH LONG LEFT LEG WITH SERIF;Ll;0;L;;;;;N;;;;;
AB5A;LATIN SMALL LETTER Y WITH SHORT RIGHT LEG;Ll;0;L;;;;;N;;;;;
AB5B;MODIFIER BREVE WITH INVERTED BREVE;Sk;0;L;;;;;N;;;;;
AB5C;MODIFIER LETTER SMALL HENG;Lm;0;L;<super> A727;;;;N;;;;;
AB5D;MODIFIER LETTER SMALL L WITH INVERTED LAZY S;Lm;0;L;<super> AB37;;;;N;;;;;
AB5E;MODIFIER LETTER SMALL L WITH MIDDLE TILDE;Lm;0;L;<super> 026B;;;;N;;;;;
AB5F;MODIFIER LETTER SMALL U WITH LEFT HOOK;Lm;0;L;<super> AB52;;;;N;;;;;
AB60;LATIN SMALL LETTER SAKHA YAT;Ll;0;L;;;;;N;;;;;
AB61;LATIN SMALL LETTER IOTIFIED E;Ll;0;L;;;;;N;;;;;
AB62;LATIN SMALL LETTER OPEN OE;Ll;0;L;;;;;N;;;;;
AB63;LATIN SMALL LETTER UO;Ll;0;L;;;;;N;;;;;
AB64;LATIN SMALL LETTER INVERTED ALPHA;Ll;0;L;;;;;N;;;;;
AB65;GREEK LETTER SMALL CAPITAL OMEGA;Ll;0;L;;;;;N;;;;;
AB66;LATIN SMALL LETTER DZ DIGRAPH WITH RETROFLEX HOOK;Ll;0;L;;;;;N;;;;;
AB67;LATIN SMALL LETTER TS DIGRAPH WITH RETROFLEX HOOK;Ll;0;L;;;;;N;;;;;
AB68;LATIN SMALL LETTER TURNED R WITH MIDDLE TILDE;Ll;0;L;;;;;N;;;;;
AB69;MODIFIER LETTER SMALL TURNED W;Lm;0;L;<super> 028D;;;;N;;;;;
AB6A;MODIFIER LETTER LEFT TACK;Sk;0;ON;;;;;N;;;;;
AB6B;MODIFIER LETTER RIGHT TACK;Sk;0;ON;;;;;N;;;;;
AB70;CHEROKEE SMALL LETTER A;Ll;0;L;;;;;N;;;13A0;;13A0
AB71;CHEROKEE SMALL LETTER E;Ll;0;L;;;;;N;;;13A1;;13A1
AB72;CHEROKEE SMALL LETTER I;Ll;0;L;;;;;N;;;13A2;;13A2
AB73;CHEROKEE SMALL LETTER O;Ll;0;L;;;;;N;;;13A3;;13A3
AB74;CHEROKEE SMALL LETTER U;Ll;0;L;;;;;N;;;13A4;;13A4
AB75;CHEROKEE SMALL LETTER V;Ll;0;L;;;;;N;;;13A5;;13A5
AB76;CHEROKEE SMALL LETTER GA;Ll;0;L;;;;;N;;;13A6;;13A6
AB77;CHEROKEE SMALL LETTER KA;Ll;0;L;;;;;N;;;13A7;;13A7
AB78;CHEROKEE SMALL LETTER GE;Ll;0;L;;;;;N;;;13A8;;13A8
AB79;CHEROKEE SMALL LETTER GI;Ll;0;L;;;;;N;;;13A9;;13A9
AB7A;CHEROKEE SMALL LETTER GO;Ll;0;L;;;;;N;;;13AA;;13AA
AB7B;CHEROKEE SMALL LETTER GU;Ll;0;L;;;;;N;;;13AB;;13AB
AB7C;CHEROKEE SMALL LETTER GV;Ll;0;L;;;;;N;;;13AC;;13AC
AB7D;CHEROKEE SMALL LETTER HA;Ll;0;L;;;;;N;;;13AD;;13AD
AB7E;CHEROKEE SMALL LETTER HE;Ll;0;L;;;;;N;;;13AE;;13AE
AB7F;CHEROKEE SMALL LETTER HI;Ll;0;L;;;;;N;;;13AF;;13AF
AB80;CHEROKEE SMALL LETTER HO;Ll;0;L;;;;;N;;;13B0;;13B0
AB81;CHEROKEE SMALL LETTER HU;Ll;0;L;;;;;N;;;13B1;;13B1
AB82;CHEROKEE SMALL LETTER HV;Ll;0;L;;;;;N;;;13B2;;13B2
AB83;CHEROKEE SMALL LETTER LA;Ll;0;L;;;;;N;;;13B3;;13B3
AB84;CHEROKEE SMALL LETTER LE;Ll;0;L;;;;;N;;;13B4;;13B4
AB85;CHEROKEE SMALL LETTER LI;Ll;0;L;;;;;N;;;13B5;;13B5
AB86;CHEROKEE SMALL LETTER LO;Ll;0;L;;;;;N;;;13B6;;13B6
AB87;CHEROKEE SMALL LETTER LU;Ll;0;L;;;;;N;;;13B7;;13B7
AB88;CHEROKEE SMALL LETTER LV;Ll;0;L;;;;;N;;;13B8;;13B8
AB89;CHEROKEE SMALL LETTER MA;Ll;0;L;;;;;N;;;13B9;;13B9
AB8A;CHEROKEE SMALL LETTER ME;Ll;0;L;;;;;N;;;13BA;;13BA
AB8B;CHEROKEE SMALL LETTER MI;Ll;0;L;;;;;N;;;13BB;;13BB
AB8C;CHEROKEE SMALL LETTER MO;Ll;0;L;;;;;N;;;13BC;;13BC
AB8D;CHEROKEE SMALL LETTER MU;Ll;0;L;;;;;N;;;13BD;;13BD
AB8E;CHEROKEE SMALL LETTER NA;Ll;0;L;;;;;N;;;13BE;;13BE
AB8F;CHEROKEE SMALL LETTER HNA;Ll;0;L;;;;;N;;;13BF;;13BF
AB90;CHEROKEE SMALL LETTER NAH;Ll;0;L;;;;;N;;;13C0;;13C0
AB91;CHEROKEE SMALL LETTER NE;Ll;0;L;;;;;N;;;13C1;;13C1
AB92;CHEROKEE SMALL LETTER NI;Ll;0;L;;;;;N;;;13C2;;13C2
AB93;CHEROKEE SMALL LETTER NO;Ll;0;L;;;;;N;;;13C3;;13C3
AB94;CHEROKEE SMALL LETTER NU;Ll;0;L;;;;;N;;;13C4;;13C4
AB95;CHEROKEE SMALL LETTER NV;Ll;0;L;;;;;N;;;13C5;;13C5
AB96;CHEROKEE SMALL LETTER QUA;Ll;0;L;;;;;N;;;13C6;;13C6
AB97;CHEROKEE SMALL LETTER QUE;Ll;0;L;;;;;N;;;13C7;;13C7
AB98;CHEROKEE SMALL LETTER QUI;Ll;0;L;;;;;N;;;13C8;;13C8
AB99;CHEROKEE SMALL LETTER QUO;Ll;0;L;;;;;N;;;13C9;;13C9
AB9A;CHEROKEE SMALL LETTER QUU;Ll;0;L;;;;;N;;;13CA;;13CA
AB9B;CHEROKEE SMALL LETTER QUV;Ll;0;L;;;;;N;;;13CB;;13CB
AB9C;CHEROKEE SMALL LETTER SA;Ll;0;L;;;;;N;;;13CC;;13CC
AB9D;CHEROKEE SMALL LETTER S;Ll;0;L;;;;;N;;;13CD;;13CD
AB9E;CHEROKEE SMALL LETTER SE;Ll;0;L;;;;;N;;;13CE;;13CE
AB9F;CHEROKEE SMALL LETTER SI;Ll;0;L;;;;;N;;;13CF;;13CF
ABA0;CHEROKEE SMALL LETTER SO;Ll;0;L;;;;;N;;;13D0;;13D0
ABA1;CHEROKEE SMALL LETTER SU;Ll;0;L;;;;;N;;;13D1;;13D1
ABA2;CHEROKEE SMALL LETTER SV;Ll;0;L;;;;;N;;;13D2;;13D2
ABA3;CHEROKEE SMALL LETTER DA;Ll;0;L;;;;;N;;;13D3;;13D3
ABA4;CHEROKEE SMALL LETTER TA;Ll;0;L;;;;;N;;;13D4;;13D4
ABA5;CHEROKEE SMALL LETTER DE;Ll;0;L;;;;;N;;;13D5;;13D5
ABA6;CHEROKEE SMALL LETTER TE;Ll;0;L;;;;;N;;;13D6;;13D6
ABA7;CHEROKEE SMALL LETTER DI;Ll;0;L;;;;;N;;;13D7;;13D7
ABA8;CHEROKEE SMALL LETTER TI;Ll;0;L;;;;;N;;;13D8;;13D8
ABA9;CHEROKEE SMALL LETTER DO;Ll;0;L;;;;;N;;;13D9;;13D9
ABAA;CHEROKEE SMALL LETTER DU;Ll;0;L;;;;;N;;;13DA;;13DA
ABAB;CHEROKEE SMALL LETTER DV;Ll;0;L;;;;;N;;;13DB;;13DB
ABAC;CHEROKEE SMALL LETTER DLA;Ll;0;L;;;;;N;;;13DC;;13DC
ABAD;CHEROKEE SMALL LETTER TLA;Ll;0;L;;;;;N;;;13DD;;13DD
ABAE;CHEROKEE SMALL LETTER TLE;Ll;0;L;;;;;N;;;13DE;;13DE
ABAF;CHEROKEE SMALL LETTER TLI;Ll;0;L;;;;;N;;;13DF;;13DF
ABB0;CHEROKEE SMALL LETTER TLO;Ll;0;L;;;;;N;;;13E0;;13E0
ABB1;CHEROKEE SMALL LETTER TLU;Ll;0;L;;;;;N;;;13E1;;13E1
ABB2;CHEROKEE SMALL LETTER TLV;Ll;0;L;;;;;N;;;13E2;;13E2
ABB3;CHEROKEE SMALL LETTER TSA;Ll;0;L;;;;;N;;;13E3;;13E3
ABB4;CHEROKEE SMALL LETTER TSE;Ll;0;L;;;;;N;;;13E4;;13E4
ABB5;CHEROKEE SMALL LETTER TSI;Ll;0;L;;;;;N;;;13E5;;13E5
ABB6;CHEROKEE SMALL LETTER TSO;Ll;0;L;;;;;N;;;13E6;;13E6
ABB7;CHEROKEE SMALL LETTER TSU;Ll;0;L;;;;;N;;;13E7;;13E7
ABB8;CHEROKEE SMALL LETTER TSV;Ll;0;L;;;;;N;;;13E8;;13E8
ABB9;CHEROKEE SMALL LETTER WA;Ll;0;L;;;;;N;;;13E9;;13E9
ABBA;CHEROKEE SMALL LETTER WE;Ll;0;L;;;;;N;;;13EA;;13EA
ABBB;CHEROKEE SMALL LETTER WI;Ll;0;L;;;;;N;;;13EB;;13EB
ABBC;CHEROKEE SMALL LETTER WO;Ll;0;L;;;;;N;;;13EC;;13EC
ABBD;CHEROKEE SMALL LETTER WU;Ll;0;L;;;;;N;;;13ED;;13ED
ABBE;CHEROKEE SMALL LETTER WV;Ll;0;L;;;;;N;;;13EE;;13EE
ABBF;CHEROKEE SMALL LETTER YA;Ll;0;L;;;;;N;;;13EF;;13EF
ABC0;MEETEI MAYEK LETTER KOK;Lo;0;L;;;;;N;;;;;
ABC1;MEETEI MAYEK LETTER SAM;Lo;0;L;;;;;N;;;;;
ABC2;MEETEI MAYEK LETTER LAI;Lo;0;L;;;;;N;;;;;
ABC3;MEETEI MAYEK LETTER MIT;Lo;0;L;;;;;N;;;;;
ABC4;MEETEI MAYEK LETTER PA;Lo;0;L;;;;;N;;;;;
ABC5;MEETEI MAYEK LETTER NA;Lo;0;L;;;;;N;;;;;
ABC6;MEETEI MAYEK LETTER CHIL;Lo;0;L;;;;;N;;;;;
ABC7;MEETEI MAYEK LETTER TIL;Lo;0;L;;;;;N;;;;;
ABC8;MEETEI MAYEK LETTER KHOU;Lo;0;L;;;;;N;;;;;
ABC9;MEETEI MAYEK LETTER NGOU;Lo;0;L;;;;;N;;;;;
ABCA;MEETEI MAYEK LETTER THOU;Lo;0;L;;;;;N;;;;;
ABCB;MEETEI MAYEK LETTER WAI;Lo;0;L;;;;;N;;;;;
ABCC;MEETEI MAYEK LETTER YANG;Lo;0;L;;;;;N;;;;;
ABCD;MEETEI MAYEK LETTER HUK;Lo;0;L;;;;;N;;;;;
ABCE;MEETEI MAYEK LETTER UN;Lo;0;L;;;;;N;;;;;
ABCF;MEETEI MAYEK LETTER I;Lo;0;L;;;;;N;;;;;
ABD0;MEETEI MAYEK LETTER PHAM;Lo;0;L;;;;;N;;;;;
ABD1;MEETEI MAYEK LETTER ATIYA;Lo;0;L;;;;;N;;;;;
ABD2;MEETEI MAYEK LETTER GOK;Lo;0;L;;;;;N;;;;;
ABD3;MEETEI MAYEK LETTER JHAM;Lo;0;L;;;;;N;;;;;
ABD4;MEETEI MAYEK LETTER RAI;Lo;0;L;;;;;N;;;;;
ABD5;MEETEI MAYEK LETTER BA;Lo;0;L;;;;;N;;;;;
ABD6;MEETEI MAYEK LETTER JIL;Lo;0;L;;;;;N;;;;;
ABD7;MEETEI MAYEK LETTER DIL;Lo;0;L;;;;;N;;;;;
ABD8;MEETEI MAYEK LETTER GHOU;Lo;0;L;;;;;N;;;;;
ABD9;MEETEI MAYEK LETTER DHOU;Lo;0;L;;;;;N;;;;;
ABDA;MEETEI MAYEK LETTER BHAM;Lo;0;L;;;;;N;;;;;
ABDB;MEETEI MAYEK LETTER KOK LONSUM;Lo;0;L;;;;;N;;;;;
ABDC;MEETEI MAYEK LETTER LAI LONSUM;Lo;0;L;;;;;N;;;;;
ABDD;MEETEI MAYEK LETTER MIT LONSUM;Lo;0;L;;;;;N;;;;;
ABDE;MEETEI MAYEK LETTER PA LONSUM;Lo;0;L;;;;;N;;;;;
ABDF;MEETEI MAYEK LETTER NA LONSUM;Lo;0;L;;;;;N;;;;;
ABE0;MEETEI MAYEK LETTER TIL LONSUM;Lo;0;L;;;;;N;;;;;
ABE1;MEETEI MAYEK LETTER NGOU LONSUM;Lo;0;L;;;;;N;;;;;
ABE2;MEETEI MAYEK LETTER I LONSUM;Lo;0;L;;;;;N;;;;;
ABE3;MEETEI MAYEK VOWEL SIGN ONAP;Mc;0;L;;;;;N;;;;;
ABE4;MEETEI MAYEK VOWEL SIGN INAP;Mc;0;L;;;;;N;;;;;
ABE5;MEETEI MAYEK VOWEL SIGN ANAP;Mn;0;NSM;;;;;N;;;;;
ABE6;MEETEI MAYEK VOWEL SIGN YENAP;Mc;0;L;;;;;N;;;;;
ABE7;MEETEI MAYEK VOWEL SIGN SOUNAP;Mc;0;L;;;;;N;;;;;
ABE8;MEETEI MAYEK VOWEL SIGN UNAP;Mn;0;NSM;;;;;N;;;;;
ABE9;MEETEI MAYEK VOWEL SIGN CHEINAP;Mc;0;L;;;;;N;;;;;
ABEA;MEETEI MAYEK VOWEL SIGN NUNG;Mc;0;L;;;;;N;;;;;
ABEB;MEETEI MAYEK CHEIKHEI;Po;0;L;;;;;N;;;;;
ABEC;MEETEI MAYEK LUM IYEK;Mc;0;L;;;;;N;;;;;
ABED;MEETEI MAYEK APUN IYEK;Mn;9;NSM;;;;;N;;;;;
ABF0;MEETEI MAYEK DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
ABF1;MEETEI MAYEK DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
ABF2;MEETEI MAYEK DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
ABF3;MEETEI MAYEK DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
ABF4;MEETEI MAYEK DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
ABF5;MEETEI MAYEK DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
ABF6;MEETEI MAYEK DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
ABF7;MEETEI MAYEK DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
ABF8;MEETEI MAYEK DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
ABF9;MEETEI MAYEK DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
AC00;<Hangul Syllable, First>;Lo;0;L;;;;;N;;;;;
D7A3;<Hangul Syllable, Last>;Lo;0;L;;;;;N;;;;;
D7B0;HANGUL JUNGSEONG O-YEO;Lo;0;L;;;;;N;;;;;
D7B1;HANGUL JUNGSEONG O-O-I;Lo;0;L;;;;;N;;;;;
D7B2;HANGUL JUNGSEONG YO-A;Lo;0;L;;;;;N;;;;;
D7B3;HANGUL JUNGSEONG YO-AE;Lo;0;L;;;;;N;;;;;
D7B4;HANGUL JUNGSEONG YO-EO;Lo;0;L;;;;;N;;;;;
D7B5;HANGUL JUNGSEONG U-YEO;Lo;0;L;;;;;N;;;;;
D7B6;HANGUL JUNGSEONG U-I-I;Lo;0;L;;;;;N;;;;;
D7B7;HANGUL JUNGSEONG YU-AE;Lo;0;L;;;;;N;;;;;
D7B8;HANGUL JUNGSEONG YU-O;Lo;0;L;;;;;N;;;;;
D7B9;HANGUL JUNGSEONG EU-A;Lo;0;L;;;;;N;;;;;
D7BA;HANGUL JUNGSEONG EU-EO;Lo;0;L;;;;;N;;;;;
D7BB;HANGUL JUNGSEONG EU-E;Lo;0;L;;;;;N;;;;;
D7BC;HANGUL JUNGSEONG EU-O;Lo;0;L;;;;;N;;;;;
D7BD;HANGUL JUNGSEONG I-YA-O;Lo;0;L;;;;;N;;;;;
D7BE;HANGUL JUNGSEONG I-YAE;Lo;0;L;;;;;N;;;;;
D7BF;HANGUL JUNGSEONG I-YEO;Lo;0;L;;;;;N;;;;;
D7C0;HANGUL JUNGSEONG I-YE;Lo;0;L;;;;;N;;;;;
D7C1;HANGUL JUNGSEONG I-O-I;Lo;0;L;;;;;N;;;;;
D7C2;HANGUL JUNGSEONG I-YO;Lo;0;L;;;;;N;;;;;
D7C3;HANGUL JUNGSEONG I-YU;Lo;0;L;;;;;N;;;;;
D7C4;HANGUL JUNGSEONG I-I;Lo;0;L;;;;;N;;;;;
D7C5;HANGUL JUNGSEONG ARAEA-A;Lo;0;L;;;;;N;;;;;
D7C6;HANGUL JUNGSEONG ARAEA-E;Lo;0;L;;;;;N;;;;;
D7CB;HANGUL JONGSEONG NIEUN-RIEUL;Lo;0;L;;;;;N;;;;;
D7CC;HANGUL JONGSEONG NIEUN-CHIEUCH;Lo;0;L;;;;;N;;;;;
D7CD;HANGUL JONGSEONG SSANGTIKEUT;Lo;0;L;;;;;N;;;;;
D7CE;HANGUL JONGSEONG SSANGTIKEUT-PIEUP;Lo;0;L;;;;;N;;;;;
D7CF;HANGUL JONGSEONG TIKEUT-PIEUP;Lo;0;L;;;;;N;;;;;
D7D0;HANGUL JONGSEONG TIKEUT-SIOS;Lo;0;L;;;;;N;;;;;
D7D1;HANGUL JONGSEONG TIKEUT-SIOS-KIYEOK;Lo;0;L;;;;;N;;;;;
D7D2;HANGUL JONGSEONG TIKEUT-CIEUC;Lo;0;L;;;;;N;;;;;
D7D3;HANGUL JONGSEONG TIKEUT-CHIEUCH;Lo;0;L;;;;;N;;;;;
D7D4;HANGUL JONGSEONG TIKEUT-THIEUTH;Lo;0;L;;;;;N;;;;;
D7D5;HANGUL JONGSEONG RIEUL-SSANGKIYEOK;Lo;0;L;;;;;N;;;;;
D7D6;HANGUL JONGSEONG RIEUL-KIYEOK-HIEUH;Lo;0;L;;;;;N;;;;;
D7D7;HANGUL JONGSEONG SSANGRIEUL-KHIEUKH;Lo;0;L;;;;;N;;;;;
D7D8;HANGUL JONGSEONG RIEUL-MIEUM-HIEUH;Lo;0;L;;;;;N;;;;;
D7D9;HANGUL JONGSEONG RIEUL-PIEUP-TIKEUT;Lo;0;L;;;;;N;;;;;
D7DA;HANGUL JONGSEONG RIEUL-PIEUP-PHIEUPH;Lo;0;L;;;;;N;;;;;
D7DB;HANGUL JONGSEONG RIEUL-YESIEUNG;Lo;0;L;;;;;N;;;;;
D7DC;HANGUL JONGSEONG RIEUL-YEORINHIEUH-HIEUH;Lo;0;L;;;;;N;;;;;
D7DD;HANGUL JONGSEONG KAPYEOUNRIEUL;Lo;0;L;;;;;N;;;;;
D7DE;HANGUL JONGSEONG MIEUM-NIEUN;Lo;0;L;;;;;N;;;;;
D7DF;HANGUL JONGSEONG MIEUM-SSANGNIEUN;Lo;0;L;;;;;N;;;;;
D7E0;HANGUL JONGSEONG SSANGMIEUM;Lo;0;L;;;;;N;;;;;
D7E1;HANGUL JONGSEONG MIEUM-PIEUP-SIOS;Lo;0;L;;;;;N;;;;;
D7E2;HANGUL JONGSEONG MIEUM-CIEUC;Lo;0;L;;;;;N;;;;;
D7E3;HANGUL JONGSEONG PIEUP-TIKEUT;Lo;0;L;;;;;N;;;;;
D7E4;HANGUL JONGSEONG PIEUP-RIEUL-PHIEUPH;Lo;0;L;;;;;N;;;;;
D7E5;HANGUL JONGSEONG PIEUP-MIEUM;Lo;0;L;;;;;N;;;;;
D7E6;HANGUL JONGSEONG SSANGPIEUP;Lo;0;L;;;;;N;;;;;
D7E7;HANGUL JONGSEONG PIEUP-SIOS-TIKEUT;Lo;0;L;;;;;N;;;;;
D7E8;HANGUL JONGSEONG PIEUP-CIEUC;Lo;0;L;;;;;N;;;;;
D7E9;HANGUL JONGSEONG PIEUP-CHIEUCH;Lo;0;L;;;;;N;;;;;
D7EA;HANGUL JONGSEONG SIOS-MIEUM;Lo;0;L;;;;;N;;;;;
D7EB;HANGUL JONGSEONG SIOS-KAPYEOUNPIEUP;Lo;0;L;;;;;N;;;;;
D7EC;HANGUL JONGSEONG SSANGSIOS-KIYEOK;Lo;0;L;;;;;N;;;;;
D7ED;HANGUL JONGSEONG SSANGSIOS-TIKEUT;Lo;0;L;;;;;N;;;;;
D7EE;HANGUL JONGSEONG SIOS-PANSIOS;Lo;0;L;;;;;N;;;;;
D7EF;HANGUL JONGSEONG SIOS-CIEUC;Lo;0;L;;;;;N;;;;;
D7F0;HANGUL JONGSEONG SIOS-CHIEUCH;Lo;0;L;;;;;N;;;;;
D7F1;HANGUL JONGSEONG SIOS-THIEUTH;Lo;0;L;;;;;N;;;;;
D7F2;HANGUL JONGSEONG SIOS-HIEUH;Lo;0;L;;;;;N;;;;;
D7F3;HANGUL JONGSEONG PANSIOS-PIEUP;Lo;0;L;;;;;N;;;;;
D7F4;HANGUL JONGSEONG PANSIOS-KAPYEOUNPIEUP;Lo;0;L;;;;;N;;;;;
D7F5;HANGUL JONGSEONG YESIEUNG-MIEUM;Lo;0;L;;;;;N;;;;;
D7F6;HANGUL JONGSEONG YESIEUNG-HIEUH;Lo;0;L;;;;;N;;;;;
D7F7;HANGUL JONGSEONG CIEUC-PIEUP;Lo;0;L;;;;;N;;;;;
D7F8;HANGUL JONGSEONG CIEUC-SSANGPIEUP;Lo;0;L;;;;;N;;;;;
D7F9;HANGUL JONGSEONG SSANGCIEUC;Lo;0;L;;;;;N;;;;;
D7FA;HANGUL JONGSEONG PHIEUPH-SIOS;Lo;0;L;;;;;N;;;;;
D7FB;HANGUL JONGSEONG PHIEUPH-THIEUTH;Lo;0;L;;;;;N;;;;;
D800;<Non Private Use High Surrogate, First>;Cs;0;L;;;;;N;;;;;
DB7F;<Non Private Use High Surrogate, Last>;Cs;0;L;;;;;N;;;;;
DB80;<Private Use High Surrogate, First>;Cs;0;L;;;;;N;;;;;
DBFF;<Private Use High Surrogate, Last>;Cs;0;L;;;;;N;;;;;
DC00;<Low Surrogate, First>;Cs;0;L;;;;;N;;;;;
DFFF;<Low Surrogate, Last>;Cs;0;L;;;;;N;;;;;
E000;<Private Use, First>;Co;0;L;;;;;N;;;;;
F8FF;<Private Use, Last>;Co;0;L;;;;;N;;;;;
F900;CJK COMPATIBILITY IDEOGRAPH-F900;Lo;0;L;8C48;;;;N;;;;;
F901;CJK COMPATIBILITY IDEOGRAPH-F901;Lo;0;L;66F4;;;;N;;;;;
F902;CJK COMPATIBILITY IDEOGRAPH-F902;Lo;0;L;8ECA;;;;N;;;;;
F903;CJK COMPATIBILITY IDEOGRAPH-F903;Lo;0;L;8CC8;;;;N;;;;;
F904;CJK COMPATIBILITY IDEOGRAPH-F904;Lo;0;L;6ED1;;;;N;;;;;
F905;CJK COMPATIBILITY IDEOGRAPH-F905;Lo;0;L;4E32;;;;N;;;;;
F906;CJK COMPATIBILITY IDEOGRAPH-F906;Lo;0;L;53E5;;;;N;;;;;
F907;CJK COMPATIBILITY IDEOGRAPH-F907;Lo;0;L;9F9C;;;;N;;;;;
F908;CJK COMPATIBILITY IDEOGRAPH-F908;Lo;0;L;9F9C;;;;N;;;;;
F909;CJK COMPATIBILITY IDEOGRAPH-F909;Lo;0;L;5951;;;;N;;;;;
F90A;CJK COMPATIBILITY IDEOGRAPH-F90A;Lo;0;L;91D1;;;;N;;;;;
F90B;CJK COMPATIBILITY IDEOGRAPH-F90B;Lo;0;L;5587;;;;N;;;;;
F90C;CJK COMPATIBILITY IDEOGRAPH-F90C;Lo;0;L;5948;;;;N;;;;;
F90D;CJK COMPATIBILITY IDEOGRAPH-F90D;Lo;0;L;61F6;;;;N;;;;;
F90E;CJK COMPATIBILITY IDEOGRAPH-F90E;Lo;0;L;7669;;;;N;;;;;
F90F;CJK COMPATIBILITY IDEOGRAPH-F90F;Lo;0;L;7F85;;;;N;;;;;
F910;CJK COMPATIBILITY IDEOGRAPH-F910;Lo;0;L;863F;;;;N;;;;;
F911;CJK COMPATIBILITY IDEOGRAPH-F911;Lo;0;L;87BA;;;;N;;;;;
F912;CJK COMPATIBILITY IDEOGRAPH-F912;Lo;0;L;88F8;;;;N;;;;;
F913;CJK COMPATIBILITY IDEOGRAPH-F913;Lo;0;L;908F;;;;N;;;;;
F914;CJK COMPATIBILITY IDEOGRAPH-F914;Lo;0;L;6A02;;;;N;;;;;
F915;CJK COMPATIBILITY IDEOGRAPH-F915;Lo;0;L;6D1B;;;;N;;;;;
F916;CJK COMPATIBILITY IDEOGRAPH-F916;Lo;0;L;70D9;;;;N;;;;;
F917;CJK COMPATIBILITY IDEOGRAPH-F917;Lo;0;L;73DE;;;;N;;;;;
F918;CJK COMPATIBILITY IDEOGRAPH-F918;Lo;0;L;843D;;;;N;;;;;
F919;CJK COMPATIBILITY IDEOGRAPH-F919;Lo;0;L;916A;;;;N;;;;;
F91A;CJK COMPATIBILITY IDEOGRAPH-F91A;Lo;0;L;99F1;;;;N;;;;;
F91B;CJK COMPATIBILITY IDEOGRAPH-F91B;Lo;0;L;4E82;;;;N;;;;;
F91C;CJK COMPATIBILITY IDEOGRAPH-F91C;Lo;0;L;5375;;;;N;;;;;
F91D;CJK COMPATIBILITY IDEOGRAPH-F91D;Lo;0;L;6B04;;;;N;;;;;
F91E;CJK COMPATIBILITY IDEOGRAPH-F91E;Lo;0;L;721B;;;;N;;;;;
F91F;CJK COMPATIBILITY IDEOGRAPH-F91F;Lo;0;L;862D;;;;N;;;;;
F920;CJK COMPATIBILITY IDEOGRAPH-F920;Lo;0;L;9E1E;;;;N;;;;;
F921;CJK COMPATIBILITY IDEOGRAPH-F921;Lo;0;L;5D50;;;;N;;;;;
F922;CJK COMPATIBILITY IDEOGRAPH-F922;Lo;0;L;6FEB;;;;N;;;;;
F923;CJK COMPATIBILITY IDEOGRAPH-F923;Lo;0;L;85CD;;;;N;;;;;
F924;CJK COMPATIBILITY IDEOGRAPH-F924;Lo;0;L;8964;;;;N;;;;;
F925;CJK COMPATIBILITY IDEOGRAPH-F925;Lo;0;L;62C9;;;;N;;;;;
F926;CJK COMPATIBILITY IDEOGRAPH-F926;Lo;0;L;81D8;;;;N;;;;;
F927;CJK COMPATIBILITY IDEOGRAPH-F927;Lo;0;L;881F;;;;N;;;;;
F928;CJK COMPATIBILITY IDEOGRAPH-F928;Lo;0;L;5ECA;;;;N;;;;;
F929;CJK COMPATIBILITY IDEOGRAPH-F929;Lo;0;L;6717;;;;N;;;;;
F92A;CJK COMPATIBILITY IDEOGRAPH-F92A;Lo;0;L;6D6A;;;;N;;;;;
F92B;CJK COMPATIBILITY IDEOGRAPH-F92B;Lo;0;L;72FC;;;;N;;;;;
F92C;CJK COMPATIBILITY IDEOGRAPH-F92C;Lo;0;L;90CE;;;;N;;;;;
F92D;CJK COMPATIBILITY IDEOGRAPH-F92D;Lo;0;L;4F86;;;;N;;;;;
F92E;CJK COMPATIBILITY IDEOGRAPH-F92E;Lo;0;L;51B7;;;;N;;;;;
F92F;CJK COMPATIBILITY IDEOGRAPH-F92F;Lo;0;L;52DE;;;;N;;;;;
F930;CJK COMPATIBILITY IDEOGRAPH-F930;Lo;0;L;64C4;;;;N;;;;;
F931;CJK COMPATIBILITY IDEOGRAPH-F931;Lo;0;L;6AD3;;;;N;;;;;
F932;CJK COMPATIBILITY IDEOGRAPH-F932;Lo;0;L;7210;;;;N;;;;;
F933;CJK COMPATIBILITY IDEOGRAPH-F933;Lo;0;L;76E7;;;;N;;;;;
F934;CJK COMPATIBILITY IDEOGRAPH-F934;Lo;0;L;8001;;;;N;;;;;
F935;CJK COMPATIBILITY IDEOGRAPH-F935;Lo;0;L;8606;;;;N;;;;;
F936;CJK COMPATIBILITY IDEOGRAPH-F936;Lo;0;L;865C;;;;N;;;;;
F937;CJK COMPATIBILITY IDEOGRAPH-F937;Lo;0;L;8DEF;;;;N;;;;;
F938;CJK COMPATIBILITY IDEOGRAPH-F938;Lo;0;L;9732;;;;N;;;;;
F939;CJK COMPATIBILITY IDEOGRAPH-F939;Lo;0;L;9B6F;;;;N;;;;;
F93A;CJK COMPATIBILITY IDEOGRAPH-F93A;Lo;0;L;9DFA;;;;N;;;;;
F93B;CJK COMPATIBILITY IDEOGRAPH-F93B;Lo;0;L;788C;;;;N;;;;;
F93C;CJK COMPATIBILITY IDEOGRAPH-F93C;Lo;0;L;797F;;;;N;;;;;
F93D;CJK COMPATIBILITY IDEOGRAPH-F93D;Lo;0;L;7DA0;;;;N;;;;;
F93E;CJK COMPATIBILITY IDEOGRAPH-F93E;Lo;0;L;83C9;;;;N;;;;;
F93F;CJK COMPATIBILITY IDEOGRAPH-F93F;Lo;0;L;9304;;;;N;;;;;
F940;CJK COMPATIBILITY IDEOGRAPH-F940;Lo;0;L;9E7F;;;;N;;;;;
F941;CJK COMPATIBILITY IDEOGRAPH-F941;Lo;0;L;8AD6;;;;N;;;;;
F942;CJK COMPATIBILITY IDEOGRAPH-F942;Lo;0;L;58DF;;;;N;;;;;
F943;CJK COMPATIBILITY IDEOGRAPH-F943;Lo;0;L;5F04;;;;N;;;;;
F944;CJK COMPATIBILITY IDEOGRAPH-F944;Lo;0;L;7C60;;;;N;;;;;
F945;CJK COMPATIBILITY IDEOGRAPH-F945;Lo;0;L;807E;;;;N;;;;;
F946;CJK COMPATIBILITY IDEOGRAPH-F946;Lo;0;L;7262;;;;N;;;;;
F947;CJK COMPATIBILITY IDEOGRAPH-F947;Lo;0;L;78CA;;;;N;;;;;
F948;CJK COMPATIBILITY IDEOGRAPH-F948;Lo;0;L;8CC2;;;;N;;;;;
F949;CJK COMPATIBILITY IDEOGRAPH-F949;Lo;0;L;96F7;;;;N;;;;;
F94A;CJK COMPATIBILITY IDEOGRAPH-F94A;Lo;0;L;58D8;;;;N;;;;;
F94B;CJK COMPATIBILITY IDEOGRAPH-F94B;Lo;0;L;5C62;;;;N;;;;;
F94C;CJK COMPATIBILITY IDEOGRAPH-F94C;Lo;0;L;6A13;;;;N;;;;;
F94D;CJK COMPATIBILITY IDEOGRAPH-F94D;Lo;0;L;6DDA;;;;N;;;;;
F94E;CJK COMPATIBILITY IDEOGRAPH-F94E;Lo;0;L;6F0F;;;;N;;;;;
F94F;CJK COMPATIBILITY IDEOGRAPH-F94F;Lo;0;L;7D2F;;;;N;;;;;
F950;CJK COMPATIBILITY IDEOGRAPH-F950;Lo;0;L;7E37;;;;N;;;;;
F951;CJK COMPATIBILITY IDEOGRAPH-F951;Lo;0;L;964B;;;;N;;;;;
F952;CJK COMPATIBILITY IDEOGRAPH-F952;Lo;0;L;52D2;;;;N;;;;;
F953;CJK COMPATIBILITY IDEOGRAPH-F953;Lo;0;L;808B;;;;N;;;;;
F954;CJK COMPATIBILITY IDEOGRAPH-F954;Lo;0;L;51DC;;;;N;;;;;
F955;CJK COMPATIBILITY IDEOGRAPH-F955;Lo;0;L;51CC;;;;N;;;;;
F956;CJK COMPATIBILITY IDEOGRAPH-F956;Lo;0;L;7A1C;;;;N;;;;;
F957;CJK COMPATIBILITY IDEOGRAPH-F957;Lo;0;L;7DBE;;;;N;;;;;
F958;CJK COMPATIBILITY IDEOGRAPH-F958;Lo;0;L;83F1;;;;N;;;;;
F959;CJK COMPATIBILITY IDEOGRAPH-F959;Lo;0;L;9675;;;;N;;;;;
F95A;CJK COMPATIBILITY IDEOGRAPH-F95A;Lo;0;L;8B80;;;;N;;;;;
F95B;CJK COMPATIBILITY IDEOGRAPH-F95B;Lo;0;L;62CF;;;;N;;;;;
F95C;CJK COMPATIBILITY IDEOGRAPH-F95C;Lo;0;L;6A02;;;;N;;;;;
F95D;CJK COMPATIBILITY IDEOGRAPH-F95D;Lo;0;L;8AFE;;;;N;;;;;
F95E;CJK COMPATIBILITY IDEOGRAPH-F95E;Lo;0;L;4E39;;;;N;;;;;
F95F;CJK COMPATIBILITY IDEOGRAPH-F95F;Lo;0;L;5BE7;;;;N;;;;;
F960;CJK COMPATIBILITY IDEOGRAPH-F960;Lo;0;L;6012;;;;N;;;;;
F961;CJK COMPATIBILITY IDEOGRAPH-F961;Lo;0;L;7387;;;;N;;;;;
F962;CJK COMPATIBILITY IDEOGRAPH-F962;Lo;0;L;7570;;;;N;;;;;
F963;CJK COMPATIBILITY IDEOGRAPH-F963;Lo;0;L;5317;;;;N;;;;;
F964;CJK COMPATIBILITY IDEOGRAPH-F964;Lo;0;L;78FB;;;;N;;;;;
F965;CJK COMPATIBILITY IDEOGRAPH-F965;Lo;0;L;4FBF;;;;N;;;;;
F966;CJK COMPATIBILITY IDEOGRAPH-F966;Lo;0;L;5FA9;;;;N;;;;;
F967;CJK COMPATIBILITY IDEOGRAPH-F967;Lo;0;L;4E0D;;;;N;;;;;
F968;CJK COMPATIBILITY IDEOGRAPH-F968;Lo;0;L;6CCC;;;;N;;;;;
F969;CJK COMPATIBILITY IDEOGRAPH-F969;Lo;0;L;6578;;;;N;;;;;
F96A;CJK COMPATIBILITY IDEOGRAPH-F96A;Lo;0;L;7D22;;;;N;;;;;
F96B;CJK COMPATIBILITY IDEOGRAPH-F96B;Lo;0;L;53C3;;;3;N;;;;;
F96C;CJK COMPATIBILITY IDEOGRAPH-F96C;Lo;0;L;585E;;;;N;;;;;
F96D;CJK COMPATIBILITY IDEOGRAPH-F96D;Lo;0;L;7701;;;;N;;;;;
F96E;CJK COMPATIBILITY IDEOGRAPH-F96E;Lo;0;L;8449;;;;N;;;;;
F96F;CJK COMPATIBILITY IDEOGRAPH-F96F;Lo;0;L;8AAA;;;;N;;;;;
F970;CJK COMPATIBILITY IDEOGRAPH-F970;Lo;0;L;6BBA;;;;N;;;;;
F971;CJK COMPATIBILITY IDEOGRAPH-F971;Lo;0;L;8FB0;;;;N;;;;;
F972;CJK COMPATIBILITY IDEOGRAPH-F972;Lo;0;L;6C88;;;;N;;;;;
F973;CJK COMPATIBILITY IDEOGRAPH-F973;Lo;0;L;62FE;;;10;N;;;;;
F974;CJK COMPATIBILITY IDEOGRAPH-F974;Lo;0;L;82E5;;;;N;;;;;
F975;CJK COMPATIBILITY IDEOGRAPH-F975;Lo;0;L;63A0;;;;N;;;;;
F976;CJK COMPATIBILITY IDEOGRAPH-F976;Lo;0;L;7565;;;;N;;;;;
F977;CJK COMPATIBILITY IDEOGRAPH-F977;Lo;0;L;4EAE;;;;N;;;;;
F978;CJK COMPATIBILITY IDEOGRAPH-F978;Lo;0;L;5169;;;2;N;;;;;
F979;CJK COMPATIBILITY IDEOGRAPH-F979;Lo;0;L;51C9;;;;N;;;;;
F97A;CJK COMPATIBILITY IDEOGRAPH-F97A;Lo;0;L;6881;;;;N;;;;;
F97B;CJK COMPATIBILITY IDEOGRAPH-F97B;Lo;0;L;7CE7;;;;N;;;;;
F97C;CJK COMPATIBILITY IDEOGRAPH-F97C;Lo;0;L;826F;;;;N;;;;;
F97D;CJK COMPATIBILITY IDEOGRAPH-F97D;Lo;0;L;8AD2;;;;N;;;;;
F97E;CJK COMPATIBILITY IDEOGRAPH-F97E;Lo;0;L;91CF;;;;N;;;;;
F97F;CJK COMPATIBILITY IDEOGRAPH-F97F;Lo;0;L;52F5;;;;N;;;;;
F980;CJK COMPATIBILITY IDEOGRAPH-F980;Lo;0;L;5442;;;;N;;;;;
F981;CJK COMPATIBILITY IDEOGRAPH-F981;Lo;0;L;5973;;;;N;;;;;
F982;CJK COMPATIBILITY IDEOGRAPH-F982;Lo;0;L;5EEC;;;;N;;;;;
F983;CJK COMPATIBILITY IDEOGRAPH-F983;Lo;0;L;65C5;;;;N;;;;;
F984;CJK COMPATIBILITY IDEOGRAPH-F984;Lo;0;L;6FFE;;;;N;;;;;
F985;CJK COMPATIBILITY IDEOGRAPH-F985;Lo;0;L;792A;;;;N;;;;;
F986;CJK COMPATIBILITY IDEOGRAPH-F986;Lo;0;L;95AD;;;;N;;;;;
F987;CJK COMPATIBILITY IDEOGRAPH-F987;Lo;0;L;9A6A;;;;N;;;;;
F988;CJK COMPATIBILITY IDEOGRAPH-F988;Lo;0;L;9E97;;;;N;;;;;
F989;CJK COMPATIBILITY IDEOGRAPH-F989;Lo;0;L;9ECE;;;;N;;;;;
F98A;CJK COMPATIBILITY IDEOGRAPH-F98A;Lo;0;L;529B;;;;N;;;;;
F98B;CJK COMPATIBILITY IDEOGRAPH-F98B;Lo;0;L;66C6;;;;N;;;;;
F98C;CJK COMPATIBILITY IDEOGRAPH-F98C;Lo;0;L;6B77;;;;N;;;;;
F98D;CJK COMPATIBILITY IDEOGRAPH-F98D;Lo;0;L;8F62;;;;N;;;;;
F98E;CJK COMPATIBILITY IDEOGRAPH-F98E;Lo;0;L;5E74;;;;N;;;;;
F98F;CJK COMPATIBILITY IDEOGRAPH-F98F;Lo;0;L;6190;;;;N;;;;;
F990;CJK COMPATIBILITY IDEOGRAPH-F990;Lo;0;L;6200;;;;N;;;;;
F991;CJK COMPATIBILITY IDEOGRAPH-F991;Lo;0;L;649A;;;;N;;;;;
F992;CJK COMPATIBILITY IDEOGRAPH-F992;Lo;0;L;6F23;;;;N;;;;;
F993;CJK COMPATIBILITY IDEOGRAPH-F993;Lo;0;L;7149;;;;N;;;;;
F994;CJK COMPATIBILITY IDEOGRAPH-F994;Lo;0;L;7489;;;;N;;;;;
F995;CJK COMPATIBILITY IDEOGRAPH-F995;Lo;0;L;79CA;;;;N;;;;;
F996;CJK COMPATIBILITY IDEOGRAPH-F996;Lo;0;L;7DF4;;;;N;;;;;
F997;CJK COMPATIBILITY IDEOGRAPH-F997;Lo;0;L;806F;;;;N;;;;;
F998;CJK COMPATIBILITY IDEOGRAPH-F998;Lo;0;L;8F26;;;;N;;;;;
F999;CJK COMPATIBILITY IDEOGRAPH-F999;Lo;0;L;84EE;;;;N;;;;;
F99A;CJK COMPATIBILITY IDEOGRAPH-F99A;Lo;0;L;9023;;;;N;;;;;
F99B;CJK COMPATIBILITY IDEOGRAPH-F99B;Lo;0;L;934A;;;;N;;;;;
F99C;CJK COMPATIBILITY IDEOGRAPH-F99C;Lo;0;L;5217;;;;N;;;;;
F99D;CJK COMPATIBILITY IDEOGRAPH-F99D;Lo;0;L;52A3;;;;N;;;;;
F99E;CJK COMPATIBILITY IDEOGRAPH-F99E;Lo;0;L;54BD;;;;N;;;;;
F99F;CJK COMPATIBILITY IDEOGRAPH-F99F;Lo;0;L;70C8;;;;N;;;;;
F9A0;CJK COMPATIBILITY IDEOGRAPH-F9A0;Lo;0;L;88C2;;;;N;;;;;
F9A1;CJK COMPATIBILITY IDEOGRAPH-F9A1;Lo;0;L;8AAA;;;;N;;;;;
F9A2;CJK COMPATIBILITY IDEOGRAPH-F9A2;Lo;0;L;5EC9;;;;N;;;;;
F9A3;CJK COMPATIBILITY IDEOGRAPH-F9A3;Lo;0;L;5FF5;;;;N;;;;;
F9A4;CJK COMPATIBILITY IDEOGRAPH-F9A4;Lo;0;L;637B;;;;N;;;;;
F9A5;CJK COMPATIBILITY IDEOGRAPH-F9A5;Lo;0;L;6BAE;;;;N;;;;;
F9A6;CJK COMPATIBILITY IDEOGRAPH-F9A6;Lo;0;L;7C3E;;;;N;;;;;
F9A7;CJK COMPATIBILITY IDEOGRAPH-F9A7;Lo;0;L;7375;;;;N;;;;;
F9A8;CJK COMPATIBILITY IDEOGRAPH-F9A8;Lo;0;L;4EE4;;;;N;;;;;
F9A9;CJK COMPATIBILITY IDEOGRAPH-F9A9;Lo;0;L;56F9;;;;N;;;;;
F9AA;CJK COMPATIBILITY IDEOGRAPH-F9AA;Lo;0;L;5BE7;;;;N;;;;;
F9AB;CJK COMPATIBILITY IDEOGRAPH-F9AB;Lo;0;L;5DBA;;;;N;;;;;
F9AC;CJK COMPATIBILITY IDEOGRAPH-F9AC;Lo;0;L;601C;;;;N;;;;;
F9AD;CJK COMPATIBILITY IDEOGRAPH-F9AD;Lo;0;L;73B2;;;;N;;;;;
F9AE;CJK COMPATIBILITY IDEOGRAPH-F9AE;Lo;0;L;7469;;;;N;;;;;
F9AF;CJK COMPATIBILITY IDEOGRAPH-F9AF;Lo;0;L;7F9A;;;;N;;;;;
F9B0;CJK COMPATIBILITY IDEOGRAPH-F9B0;Lo;0;L;8046;;;;N;;;;;
F9B1;CJK COMPATIBILITY IDEOGRAPH-F9B1;Lo;0;L;9234;;;;N;;;;;
F9B2;CJK COMPATIBILITY IDEOGRAPH-F9B2;Lo;0;L;96F6;;;0;N;;;;;
F9B3;CJK COMPATIBILITY IDEOGRAPH-F9B3;Lo;0;L;9748;;;;N;;;;;
F9B4;CJK COMPATIBILITY IDEOGRAPH-F9B4;Lo;0;L;9818;;;;N;;;;;
F9B5;CJK COMPATIBILITY IDEOGRAPH-F9B5;Lo;0;L;4F8B;;;;N;;;;;
F9B6;CJK COMPATIBILITY IDEOGRAPH-F9B6;Lo;0;L;79AE;;;;N;;;;;
F9B7;CJK COMPATIBILITY IDEOGRAPH-F9B7;Lo;0;L;91B4;;;;N;;;;;
F9B8;CJK COMPATIBILITY IDEOGRAPH-F9B8;Lo;0;L;96B8;;;;N;;;;;
F9B9;CJK COMPATIBILITY IDEOGRAPH-F9B9;Lo;0;L;60E1;;;;N;;;;;
F9BA;CJK COMPATIBILITY IDEOGRAPH-F9BA;Lo;0;L;4E86;;;;N;;;;;
F9BB;CJK COMPATIBILITY IDEOGRAPH-F9BB;Lo;0;L;50DA;;;;N;;;;;
F9BC;CJK COMPATIBILITY IDEOGRAPH-F9BC;Lo;0;L;5BEE;;;;N;;;;;
F9BD;CJK COMPATIBILITY IDEOGRAPH-F9BD;Lo;0;L;5C3F;;;;N;;;;;
F9BE;CJK COMPATIBILITY IDEOGRAPH-F9BE;Lo;0;L;6599;;;;N;;;;;
F9BF;CJK COMPATIBILITY IDEOGRAPH-F9BF;Lo;0;L;6A02;;;;N;;;;;
F9C0;CJK COMPATIBILITY IDEOGRAPH-F9C0;Lo;0;L;71CE;;;;N;;;;;
F9C1;CJK COMPATIBILITY IDEOGRAPH-F9C1;Lo;0;L;7642;;;;N;;;;;
F9C2;CJK COMPATIBILITY IDEOGRAPH-F9C2;Lo;0;L;84FC;;;;N;;;;;
F9C3;CJK COMPATIBILITY IDEOGRAPH-F9C3;Lo;0;L;907C;;;;N;;;;;
F9C4;CJK COMPATIBILITY IDEOGRAPH-F9C4;Lo;0;L;9F8D;;;;N;;;;;
F9C5;CJK COMPATIBILITY IDEOGRAPH-F9C5;Lo;0;L;6688;;;;N;;;;;
F9C6;CJK COMPATIBILITY IDEOGRAPH-F9C6;Lo;0;L;962E;;;;N;;;;;
F9C7;CJK COMPATIBILITY IDEOGRAPH-F9C7;Lo;0;L;5289;;;;N;;;;;
F9C8;CJK COMPATIBILITY IDEOGRAPH-F9C8;Lo;0;L;677B;;;;N;;;;;
F9C9;CJK COMPATIBILITY IDEOGRAPH-F9C9;Lo;0;L;67F3;;;;N;;;;;
F9CA;CJK COMPATIBILITY IDEOGRAPH-F9CA;Lo;0;L;6D41;;;;N;;;;;
F9CB;CJK COMPATIBILITY IDEOGRAPH-F9CB;Lo;0;L;6E9C;;;;N;;;;;
F9CC;CJK COMPATIBILITY IDEOGRAPH-F9CC;Lo;0;L;7409;;;;N;;;;;
F9CD;CJK COMPATIBILITY IDEOGRAPH-F9CD;Lo;0;L;7559;;;;N;;;;;
F9CE;CJK COMPATIBILITY IDEOGRAPH-F9CE;Lo;0;L;786B;;;;N;;;;;
F9CF;CJK COMPATIBILITY IDEOGRAPH-F9CF;Lo;0;L;7D10;;;;N;;;;;
F9D0;CJK COMPATIBILITY IDEOGRAPH-F9D0;Lo;0;L;985E;;;;N;;;;;
F9D1;CJK COMPATIBILITY IDEOGRAPH-F9D1;Lo;0;L;516D;;;6;N;;;;;
F9D2;CJK COMPATIBILITY IDEOGRAPH-F9D2;Lo;0;L;622E;;;;N;;;;;
F9D3;CJK COMPATIBILITY IDEOGRAPH-F9D3;Lo;0;L;9678;;;6;N;;;;;
F9D4;CJK COMPATIBILITY IDEOGRAPH-F9D4;Lo;0;L;502B;;;;N;;;;;
F9D5;CJK COMPATIBILITY IDEOGRAPH-F9D5;Lo;0;L;5D19;;;;N;;;;;
F9D6;CJK COMPATIBILITY IDEOGRAPH-F9D6;Lo;0;L;6DEA;;;;N;;;;;
F9D7;CJK COMPATIBILITY IDEOGRAPH-F9D7;Lo;0;L;8F2A;;;;N;;;;;
F9D8;CJK COMPATIBILITY IDEOGRAPH-F9D8;Lo;0;L;5F8B;;;;N;;;;;
F9D9;CJK COMPATIBILITY IDEOGRAPH-F9D9;Lo;0;L;6144;;;;N;;;;;
F9DA;CJK COMPATIBILITY IDEOGRAPH-F9DA;Lo;0;L;6817;;;;N;;;;;
F9DB;CJK COMPATIBILITY IDEOGRAPH-F9DB;Lo;0;L;7387;;;;N;;;;;
F9DC;CJK COMPATIBILITY IDEOGRAPH-F9DC;Lo;0;L;9686;;;;N;;;;;
F9DD;CJK COMPATIBILITY IDEOGRAPH-F9DD;Lo;0;L;5229;;;;N;;;;;
F9DE;CJK COMPATIBILITY IDEOGRAPH-F9DE;Lo;0;L;540F;;;;N;;;;;
F9DF;CJK COMPATIBILITY IDEOGRAPH-F9DF;Lo;0;L;5C65;;;;N;;;;;
F9E0;CJK COMPATIBILITY IDEOGRAPH-F9E0;Lo;0;L;6613;;;;N;;;;;
F9E1;CJK COMPATIBILITY IDEOGRAPH-F9E1;Lo;0;L;674E;;;;N;;;;;
F9E2;CJK COMPATIBILITY IDEOGRAPH-F9E2;Lo;0;L;68A8;;;;N;;;;;
F9E3;CJK COMPATIBILITY IDEOGRAPH-F9E3;Lo;0;L;6CE5;;;;N;;;;;
F9E4;CJK COMPATIBILITY IDEOGRAPH-F9E4;Lo;0;L;7406;;;;N;;;;;
F9E5;CJK COMPATIBILITY IDEOGRAPH-F9E5;Lo;0;L;75E2;;;;N;;;;;
F9E6;CJK COMPATIBILITY IDEOGRAPH-F9E6;Lo;0;L;7F79;;;;N;;;;;
F9E7;CJK COMPATIBILITY IDEOGRAPH-F9E7;Lo;0;L;88CF;;;;N;;;;;
F9E8;CJK COMPATIBILITY IDEOGRAPH-F9E8;Lo;0;L;88E1;;;;N;;;;;
F9E9;CJK COMPATIBILITY IDEOGRAPH-F9E9;Lo;0;L;91CC;;;;N;;;;;
F9EA;CJK COMPATIBILITY IDEOGRAPH-F9EA;Lo;0;L;96E2;;;;N;;;;;
F9EB;CJK COMPATIBILITY IDEOGRAPH-F9EB;Lo;0;L;533F;;;;N;;;;;
F9EC;CJK COMPATIBILITY IDEOGRAPH-F9EC;Lo;0;L;6EBA;;;;N;;;;;
F9ED;CJK COMPATIBILITY IDEOGRAPH-F9ED;Lo;0;L;541D;;;;N;;;;;
F9EE;CJK COMPATIBILITY IDEOGRAPH-F9EE;Lo;0;L;71D0;;;;N;;;;;
F9EF;CJK COMPATIBILITY IDEOGRAPH-F9EF;Lo;0;L;7498;;;;N;;;;;
F9F0;CJK COMPATIBILITY IDEOGRAPH-F9F0;Lo;0;L;85FA;;;;N;;;;;
F9F1;CJK COMPATIBILITY IDEOGRAPH-F9F1;Lo;0;L;96A3;;;;N;;;;;
F9F2;CJK COMPATIBILITY IDEOGRAPH-F9F2;Lo;0;L;9C57;;;;N;;;;;
F9F3;CJK COMPATIBILITY IDEOGRAPH-F9F3;Lo;0;L;9E9F;;;;N;;;;;
F9F4;CJK COMPATIBILITY IDEOGRAPH-F9F4;Lo;0;L;6797;;;;N;;;;;
F9F5;CJK COMPATIBILITY IDEOGRAPH-F9F5;Lo;0;L;6DCB;;;;N;;;;;
F9F6;CJK COMPATIBILITY IDEOGRAPH-F9F6;Lo;0;L;81E8;;;;N;;;;;
F9F7;CJK COMPATIBILITY IDEOGRAPH-F9F7;Lo;0;L;7ACB;;;;N;;;;;
F9F8;CJK COMPATIBILITY IDEOGRAPH-F9F8;Lo;0;L;7B20;;;;N;;;;;
F9F9;CJK COMPATIBILITY IDEOGRAPH-F9F9;Lo;0;L;7C92;;;;N;;;;;
F9FA;CJK COMPATIBILITY IDEOGRAPH-F9FA;Lo;0;L;72C0;;;;N;;;;;
F9FB;CJK COMPATIBILITY IDEOGRAPH-F9FB;Lo;0;L;7099;;;;N;;;;;
F9FC;CJK COMPATIBILITY IDEOGRAPH-F9FC;Lo;0;L;8B58;;;;N;;;;;
F9FD;CJK COMPATIBILITY IDEOGRAPH-F9FD;Lo;0;L;4EC0;;;10;N;;;;;
F9FE;CJK COMPATIBILITY IDEOGRAPH-F9FE;Lo;0;L;8336;;;;N;;;;;
F9FF;CJK COMPATIBILITY IDEOGRAPH-F9FF;Lo;0;L;523A;;;;N;;;;;
FA00;CJK COMPATIBILITY IDEOGRAPH-FA00;Lo;0;L;5207;;;;N;;;;;
FA01;CJK COMPATIBILITY IDEOGRAPH-FA01;Lo;0;L;5EA6;;;;N;;;;;
FA02;CJK COMPATIBILITY IDEOGRAPH-FA02;Lo;0;L;62D3;;;;N;;;;;
FA03;CJK COMPATIBILITY IDEOGRAPH-FA03;Lo;0;L;7CD6;;;;N;;;;;
FA04;CJK COMPATIBILITY IDEOGRAPH-FA04;Lo;0;L;5B85;;;;N;;;;;
FA05;CJK COMPATIBILITY IDEOGRAPH-FA05;Lo;0;L;6D1E;;;;N;;;;;
FA06;CJK COMPATIBILITY IDEOGRAPH-FA06;Lo;0;L;66B4;;;;N;;;;;
FA07;CJK COMPATIBILITY IDEOGRAPH-FA07;Lo;0;L;8F3B;;;;N;;;;;
FA08;CJK COMPATIBILITY IDEOGRAPH-FA08;Lo;0;L;884C;;;;N;;;;;
FA09;CJK COMPATIBILITY IDEOGRAPH-FA09;Lo;0;L;964D;;;;N;;;;;
FA0A;CJK COMPATIBILITY IDEOGRAPH-FA0A;Lo;0;L;898B;;;;N;;;;;
FA0B;CJK COMPATIBILITY IDEOGRAPH-FA0B;Lo;0;L;5ED3;;;;N;;;;;
FA0C;CJK COMPATIBILITY IDEOGRAPH-FA0C;Lo;0;L;5140;;;;N;;;;;
FA0D;CJK COMPATIBILITY IDEOGRAPH-FA0D;Lo;0;L;55C0;;;;N;;;;;
FA0E;CJK COMPATIBILITY IDEOGRAPH-FA0E;Lo;0;L;;;;;N;;;;;
FA0F;CJK COMPATIBILITY IDEOGRAPH-FA0F;Lo;0;L;;;;;N;;;;;
FA10;CJK COMPATIBILITY IDEOGRAPH-FA10;Lo;0;L;585A;;;;N;;;;;
FA11;CJK COMPATIBILITY IDEOGRAPH-FA11;Lo;0;L;;;;;N;;;;;
FA12;CJK COMPATIBILITY IDEOGRAPH-FA12;Lo;0;L;6674;;;;N;;;;;
FA13;CJK COMPATIBILITY IDEOGRAPH-FA13;Lo;0;L;;;;;N;;;;;
FA14;CJK COMPATIBILITY IDEOGRAPH-FA14;Lo;0;L;;;;;N;;;;;
FA15;CJK COMPATIBILITY IDEOGRAPH-FA15;Lo;0;L;51DE;;;;N;;;;;
FA16;CJK COMPATIBILITY IDEOGRAPH-FA16;Lo;0;L;732A;;;;N;;;;;
FA17;CJK COMPATIBILITY IDEOGRAPH-FA17;Lo;0;L;76CA;;;;N;;;;;
FA18;CJK COMPATIBILITY IDEOGRAPH-FA18;Lo;0;L;793C;;;;N;;;;;
FA19;CJK COMPATIBILITY IDEOGRAPH-FA19;Lo;0;L;795E;;;;N;;;;;
FA1A;CJK COMPATIBILITY IDEOGRAPH-FA1A;Lo;0;L;7965;;;;N;;;;;
FA1B;CJK COMPATIBILITY IDEOGRAPH-FA1B;Lo;0;L;798F;;;;N;;;;;
FA1C;CJK COMPATIBILITY IDEOGRAPH-FA1C;Lo;0;L;9756;;;;N;;;;;
FA1D;CJK COMPATIBILITY IDEOGRAPH-FA1D;Lo;0;L;7CBE;;;;N;;;;;
FA1E;CJK COMPATIBILITY IDEOGRAPH-FA1E;Lo;0;L;7FBD;;;;N;;;;;
FA1F;CJK COMPATIBILITY IDEOGRAPH-FA1F;Lo;0;L;;;;;N;;;;;
FA20;CJK COMPATIBILITY IDEOGRAPH-FA20;Lo;0;L;8612;;;;N;;;;;
FA21;CJK COMPATIBILITY IDEOGRAPH-FA21;Lo;0;L;;;;;N;;;;;
FA22;CJK COMPATIBILITY IDEOGRAPH-FA22;Lo;0;L;8AF8;;;;N;;;;;
FA23;CJK COMPATIBILITY IDEOGRAPH-FA23;Lo;0;L;;;;;N;;;;;
FA24;CJK COMPATIBILITY IDEOGRAPH-FA24;Lo;0;L;;;;;N;;;;;
FA25;CJK COMPATIBILITY IDEOGRAPH-FA25;Lo;0;L;9038;;;;N;;;;;
FA26;CJK COMPATIBILITY IDEOGRAPH-FA26;Lo;0;L;90FD;;;;N;;;;;
FA27;CJK COMPATIBILITY IDEOGRAPH-FA27;Lo;0;L;;;;;N;;;;;
FA28;CJK COMPATIBILITY IDEOGRAPH-FA28;Lo;0;L;;;;;N;;;;;
FA29;CJK COMPATIBILITY IDEOGRAPH-FA29;Lo;0;L;;;;;N;;;;;
FA2A;CJK COMPATIBILITY IDEOGRAPH-FA2A;Lo;0;L;98EF;;;;N;;;;;
FA2B;CJK COMPATIBILITY IDEOGRAPH-FA2B;Lo;0;L;98FC;;;;N;;;;;
FA2C;CJK COMPATIBILITY IDEOGRAPH-FA2C;Lo;0;L;9928;;;;N;;;;;
FA2D;CJK COMPATIBILITY IDEOGRAPH-FA2D;Lo;0;L;9DB4;;;;N;;;;;
FA2E;CJK COMPATIBILITY IDEOGRAPH-FA2E;Lo;0;L;90DE;;;;N;;;;;
FA2F;CJK COMPATIBILITY IDEOGRAPH-FA2F;Lo;0;L;96B7;;;;N;;;;;
FA30;CJK COMPATIBILITY IDEOGRAPH-FA30;Lo;0;L;4FAE;;;;N;;;;;
FA31;CJK COMPATIBILITY IDEOGRAPH-FA31;Lo;0;L;50E7;;;;N;;;;;
FA32;CJK COMPATIBILITY IDEOGRAPH-FA32;Lo;0;L;514D;;;;N;;;;;
FA33;CJK COMPATIBILITY IDEOGRAPH-FA33;Lo;0;L;52C9;;;;N;;;;;
FA34;CJK COMPATIBILITY IDEOGRAPH-FA34;Lo;0;L;52E4;;;;N;;;;;
FA35;CJK COMPATIBILITY IDEOGRAPH-FA35;Lo;0;L;5351;;;;N;;;;;
FA36;CJK COMPATIBILITY IDEOGRAPH-FA36;Lo;0;L;559D;;;;N;;;;;
FA37;CJK COMPATIBILITY IDEOGRAPH-FA37;Lo;0;L;5606;;;;N;;;;;
FA38;CJK COMPATIBILITY IDEOGRAPH-FA38;Lo;0;L;5668;;;;N;;;;;
FA39;CJK COMPATIBILITY IDEOGRAPH-FA39;Lo;0;L;5840;;;;N;;;;;
FA3A;CJK COMPATIBILITY IDEOGRAPH-FA3A;Lo;0;L;58A8;;;;N;;;;;
FA3B;CJK COMPATIBILITY IDEOGRAPH-FA3B;Lo;0;L;5C64;;;;N;;;;;
FA3C;CJK COMPATIBILITY IDEOGRAPH-FA3C;Lo;0;L;5C6E;;;;N;;;;;
FA3D;CJK COMPATIBILITY IDEOGRAPH-FA3D;Lo;0;L;6094;;;;N;;;;;
FA3E;CJK COMPATIBILITY IDEOGRAPH-FA3E;Lo;0;L;6168;;;;N;;;;;
FA3F;CJK COMPATIBILITY IDEOGRAPH-FA3F;Lo;0;L;618E;;;;N;;;;;
FA40;CJK COMPATIBILITY IDEOGRAPH-FA40;Lo;0;L;61F2;;;;N;;;;;
FA41;CJK COMPATIBILITY IDEOGRAPH-FA41;Lo;0;L;654F;;;;N;;;;;
FA42;CJK COMPATIBILITY IDEOGRAPH-FA42;Lo;0;L;65E2;;;;N;;;;;
FA43;CJK COMPATIBILITY IDEOGRAPH-FA43;Lo;0;L;6691;;;;N;;;;;
FA44;CJK COMPATIBILITY IDEOGRAPH-FA44;Lo;0;L;6885;;;;N;;;;;
FA45;CJK COMPATIBILITY IDEOGRAPH-FA45;Lo;0;L;6D77;;;;N;;;;;
FA46;CJK COMPATIBILITY IDEOGRAPH-FA46;Lo;0;L;6E1A;;;;N;;;;;
FA47;CJK COMPATIBILITY IDEOGRAPH-FA47;Lo;0;L;6F22;;;;N;;;;;
FA48;CJK COMPATIBILITY IDEOGRAPH-FA48;Lo;0;L;716E;;;;N;;;;;
FA49;CJK COMPATIBILITY IDEOGRAPH-FA49;Lo;0;L;722B;;;;N;;;;;
FA4A;CJK COMPATIBILITY IDEOGRAPH-FA4A;Lo;0;L;7422;;;;N;;;;;
FA4B;CJK COMPATIBILITY IDEOGRAPH-FA4B;Lo;0;L;7891;;;;N;;;;;
FA4C;CJK COMPATIBILITY IDEOGRAPH-FA4C;Lo;0;L;793E;;;;N;;;;;
FA4D;CJK COMPATIBILITY IDEOGRAPH-FA4D;Lo;0;L;7949;;;;N;;;;;
FA4E;CJK COMPATIBILITY IDEOGRAPH-FA4E;Lo;0;L;7948;;;;N;;;;;
FA4F;CJK COMPATIBILITY IDEOGRAPH-FA4F;Lo;0;L;7950;;;;N;;;;;
FA50;CJK COMPATIBILITY IDEOGRAPH-FA50;Lo;0;L;7956;;;;N;;;;;
FA51;CJK COMPATIBILITY IDEOGRAPH-FA51;Lo;0;L;795D;;;;N;;;;;
FA52;CJK COMPATIBILITY IDEOGRAPH-FA52;Lo;0;L;798D;;;;N;;;;;
FA53;CJK COMPATIBILITY IDEOGRAPH-FA53;Lo;0;L;798E;;;;N;;;;;
FA54;CJK COMPATIBILITY IDEOGRAPH-FA54;Lo;0;L;7A40;;;;N;;;;;
FA55;CJK COMPATIBILITY IDEOGRAPH-FA55;Lo;0;L;7A81;;;;N;;;;;
FA56;CJK COMPATIBILITY IDEOGRAPH-FA56;Lo;0;L;7BC0;;;;N;;;;;
FA57;CJK COMPATIBILITY IDEOGRAPH-FA57;Lo;0;L;7DF4;;;;N;;;;;
FA58;CJK COMPATIBILITY IDEOGRAPH-FA58;Lo;0;L;7E09;;;;N;;;;;
FA59;CJK COMPATIBILITY IDEOGRAPH-FA59;Lo;0;L;7E41;;;;N;;;;;
FA5A;CJK COMPATIBILITY IDEOGRAPH-FA5A;Lo;0;L;7F72;;;;N;;;;;
FA5B;CJK COMPATIBILITY IDEOGRAPH-FA5B;Lo;0;L;8005;;;;N;;;;;
FA5C;CJK COMPATIBILITY IDEOGRAPH-FA5C;Lo;0;L;81ED;;;;N;;;;;
FA5D;CJK COMPATIBILITY IDEOGRAPH-FA5D;Lo;0;L;8279;;;;N;;;;;
FA5E;CJK COMPATIBILITY IDEOGRAPH-FA5E;Lo;0;L;8279;;;;N;;;;;
FA5F;CJK COMPATIBILITY IDEOGRAPH-FA5F;Lo;0;L;8457;;;;N;;;;;
FA60;CJK COMPATIBILITY IDEOGRAPH-FA60;Lo;0;L;8910;;;;N;;;;;
FA61;CJK COMPATIBILITY IDEOGRAPH-FA61;Lo;0;L;8996;;;;N;;;;;
FA62;CJK COMPATIBILITY IDEOGRAPH-FA62;Lo;0;L;8B01;;;;N;;;;;
FA63;CJK COMPATIBILITY IDEOGRAPH-FA63;Lo;0;L;8B39;;;;N;;;;;
FA64;CJK COMPATIBILITY IDEOGRAPH-FA64;Lo;0;L;8CD3;;;;N;;;;;
FA65;CJK COMPATIBILITY IDEOGRAPH-FA65;Lo;0;L;8D08;;;;N;;;;;
FA66;CJK COMPATIBILITY IDEOGRAPH-FA66;Lo;0;L;8FB6;;;;N;;;;;
FA67;CJK COMPATIBILITY IDEOGRAPH-FA67;Lo;0;L;9038;;;;N;;;;;
FA68;CJK COMPATIBILITY IDEOGRAPH-FA68;Lo;0;L;96E3;;;;N;;;;;
FA69;CJK COMPATIBILITY IDEOGRAPH-FA69;Lo;0;L;97FF;;;;N;;;;;
FA6A;CJK COMPATIBILITY IDEOGRAPH-FA6A;Lo;0;L;983B;;;;N;;;;;
FA6B;CJK COMPATIBILITY IDEOGRAPH-FA6B;Lo;0;L;6075;;;;N;;;;;
FA6C;CJK COMPATIBILITY IDEOGRAPH-FA6C;Lo;0;L;242EE;;;;N;;;;;
FA6D;CJK COMPATIBILITY IDEOGRAPH-FA6D;Lo;0;L;8218;;;;N;;;;;
FA70;CJK COMPATIBILITY IDEOGRAPH-FA70;Lo;0;L;4E26;;;;N;;;;;
FA71;CJK COMPATIBILITY IDEOGRAPH-FA71;Lo;0;L;51B5;;;;N;;;;;
FA72;CJK COMPATIBILITY IDEOGRAPH-FA72;Lo;0;L;5168;;;;N;;;;;
FA73;CJK COMPATIBILITY IDEOGRAPH-FA73;Lo;0;L;4F80;;;;N;;;;;
FA74;CJK COMPATIBILITY IDEOGRAPH-FA74;Lo;0;L;5145;;;;N;;;;;
FA75;CJK COMPATIBILITY IDEOGRAPH-FA75;Lo;0;L;5180;;;;N;;;;;
FA76;CJK COMPATIBILITY IDEOGRAPH-FA76;Lo;0;L;52C7;;;;N;;;;;
FA77;CJK COMPATIBILITY IDEOGRAPH-FA77;Lo;0;L;52FA;;;;N;;;;;
FA78;CJK COMPATIBILITY IDEOGRAPH-FA78;Lo;0;L;559D;;;;N;;;;;
FA79;CJK COMPATIBILITY IDEOGRAPH-FA79;Lo;0;L;5555;;;;N;;;;;
FA7A;CJK COMPATIBILITY IDEOGRAPH-FA7A;Lo;0;L;5599;;;;N;;;;;
FA7B;CJK COMPATIBILITY IDEOGRAPH-FA7B;Lo;0;L;55E2;;;;N;;;;;
FA7C;CJK COMPATIBILITY IDEOGRAPH-FA7C;Lo;0;L;585A;;;;N;;;;;
FA7D;CJK COMPATIBILITY IDEOGRAPH-FA7D;Lo;0;L;58B3;;;;N;;;;;
FA7E;CJK COMPATIBILITY IDEOGRAPH-FA7E;Lo;0;L;5944;;;;N;;;;;
FA7F;CJK COMPATIBILITY IDEOGRAPH-FA7F;Lo;0;L;5954;;;;N;;;;;
FA80;CJK COMPATIBILITY IDEOGRAPH-FA80;Lo;0;L;5A62;;;;N;;;;;
FA81;CJK COMPATIBILITY IDEOGRAPH-FA81;Lo;0;L;5B28;;;;N;;;;;
FA82;CJK COMPATIBILITY IDEOGRAPH-FA82;Lo;0;L;5ED2;;;;N;;;;;
FA83;CJK COMPATIBILITY IDEOGRAPH-FA83;Lo;0;L;5ED9;;;;N;;;;;
FA84;CJK COMPATIBILITY IDEOGRAPH-FA84;Lo;0;L;5F69;;;;N;;;;;
FA85;CJK COMPATIBILITY IDEOGRAPH-FA85;Lo;0;L;5FAD;;;;N;;;;;
FA86;CJK COMPATIBILITY IDEOGRAPH-FA86;Lo;0;L;60D8;;;;N;;;;;
FA87;CJK COMPATIBILITY IDEOGRAPH-FA87;Lo;0;L;614E;;;;N;;;;;
FA88;CJK COMPATIBILITY IDEOGRAPH-FA88;Lo;0;L;6108;;;;N;;;;;
FA89;CJK COMPATIBILITY IDEOGRAPH-FA89;Lo;0;L;618E;;;;N;;;;;
FA8A;CJK COMPATIBILITY IDEOGRAPH-FA8A;Lo;0;L;6160;;;;N;;;;;
FA8B;CJK COMPATIBILITY IDEOGRAPH-FA8B;Lo;0;L;61F2;;;;N;;;;;
FA8C;CJK COMPATIBILITY IDEOGRAPH-FA8C;Lo;0;L;6234;;;;N;;;;;
FA8D;CJK COMPATIBILITY IDEOGRAPH-FA8D;Lo;0;L;63C4;;;;N;;;;;
FA8E;CJK COMPATIBILITY IDEOGRAPH-FA8E;Lo;0;L;641C;;;;N;;;;;
FA8F;CJK COMPATIBILITY IDEOGRAPH-FA8F;Lo;0;L;6452;;;;N;;;;;
FA90;CJK COMPATIBILITY IDEOGRAPH-FA90;Lo;0;L;6556;;;;N;;;;;
FA91;CJK COMPATIBILITY IDEOGRAPH-FA91;Lo;0;L;6674;;;;N;;;;;
FA92;CJK COMPATIBILITY IDEOGRAPH-FA92;Lo;0;L;6717;;;;N;;;;;
FA93;CJK COMPATIBILITY IDEOGRAPH-FA93;Lo;0;L;671B;;;;N;;;;;
FA94;CJK COMPATIBILITY IDEOGRAPH-FA94;Lo;0;L;6756;;;;N;;;;;
FA95;CJK COMPATIBILITY IDEOGRAPH-FA95;Lo;0;L;6B79;;;;N;;;;;
FA96;CJK COMPATIBILITY IDEOGRAPH-FA96;Lo;0;L;6BBA;;;;N;;;;;
FA97;CJK COMPATIBILITY IDEOGRAPH-FA97;Lo;0;L;6D41;;;;N;;;;;
FA98;CJK COMPATIBILITY IDEOGRAPH-FA98;Lo;0;L;6EDB;;;;N;;;;;
FA99;CJK COMPATIBILITY IDEOGRAPH-FA99;Lo;0;L;6ECB;;;;N;;;;;
FA9A;CJK COMPATIBILITY IDEOGRAPH-FA9A;Lo;0;L;6F22;;;;N;;;;;
FA9B;CJK COMPATIBILITY IDEOGRAPH-FA9B;Lo;0;L;701E;;;;N;;;;;
FA9C;CJK COMPATIBILITY IDEOGRAPH-FA9C;Lo;0;L;716E;;;;N;;;;;
FA9D;CJK COMPATIBILITY IDEOGRAPH-FA9D;Lo;0;L;77A7;;;;N;;;;;
FA9E;CJK COMPATIBILITY IDEOGRAPH-FA9E;Lo;0;L;7235;;;;N;;;;;
FA9F;CJK COMPATIBILITY IDEOGRAPH-FA9F;Lo;0;L;72AF;;;;N;;;;;
FAA0;CJK COMPATIBILITY IDEOGRAPH-FAA0;Lo;0;L;732A;;;;N;;;;;
FAA1;CJK COMPATIBILITY IDEOGRAPH-FAA1;Lo;0;L;7471;;;;N;;;;;
FAA2;CJK COMPATIBILITY IDEOGRAPH-FAA2;Lo;0;L;7506;;;;N;;;;;
FAA3;CJK COMPATIBILITY IDEOGRAPH-FAA3;Lo;0;L;753B;;;;N;;;;;
FAA4;CJK COMPATIBILITY IDEOGRAPH-FAA4;Lo;0;L;761D;;;;N;;;;;
FAA5;CJK COMPATIBILITY IDEOGRAPH-FAA5;Lo;0;L;761F;;;;N;;;;;
FAA6;CJK COMPATIBILITY IDEOGRAPH-FAA6;Lo;0;L;76CA;;;;N;;;;;
FAA7;CJK COMPATIBILITY IDEOGRAPH-FAA7;Lo;0;L;76DB;;;;N;;;;;
FAA8;CJK COMPATIBILITY IDEOGRAPH-FAA8;Lo;0;L;76F4;;;;N;;;;;
FAA9;CJK COMPATIBILITY IDEOGRAPH-FAA9;Lo;0;L;774A;;;;N;;;;;
FAAA;CJK COMPATIBILITY IDEOGRAPH-FAAA;Lo;0;L;7740;;;;N;;;;;
FAAB;CJK COMPATIBILITY IDEOGRAPH-FAAB;Lo;0;L;78CC;;;;N;;;;;
FAAC;CJK COMPATIBILITY IDEOGRAPH-FAAC;Lo;0;L;7AB1;;;;N;;;;;
FAAD;CJK COMPATIBILITY IDEOGRAPH-FAAD;Lo;0;L;7BC0;;;;N;;;;;
FAAE;CJK COMPATIBILITY IDEOGRAPH-FAAE;Lo;0;L;7C7B;;;;N;;;;;
FAAF;CJK COMPATIBILITY IDEOGRAPH-FAAF;Lo;0;L;7D5B;;;;N;;;;;
FAB0;CJK COMPATIBILITY IDEOGRAPH-FAB0;Lo;0;L;7DF4;;;;N;;;;;
FAB1;CJK COMPATIBILITY IDEOGRAPH-FAB1;Lo;0;L;7F3E;;;;N;;;;;
FAB2;CJK COMPATIBILITY IDEOGRAPH-FAB2;Lo;0;L;8005;;;;N;;;;;
FAB3;CJK COMPATIBILITY IDEOGRAPH-FAB3;Lo;0;L;8352;;;;N;;;;;
FAB4;CJK COMPATIBILITY IDEOGRAPH-FAB4;Lo;0;L;83EF;;;;N;;;;;
FAB5;CJK COMPATIBILITY IDEOGRAPH-FAB5;Lo;0;L;8779;;;;N;;;;;
FAB6;CJK COMPATIBILITY IDEOGRAPH-FAB6;Lo;0;L;8941;;;;N;;;;;
FAB7;CJK COMPATIBILITY IDEOGRAPH-FAB7;Lo;0;L;8986;;;;N;;;;;
FAB8;CJK COMPATIBILITY IDEOGRAPH-FAB8;Lo;0;L;8996;;;;N;;;;;
FAB9;CJK COMPATIBILITY IDEOGRAPH-FAB9;Lo;0;L;8ABF;;;;N;;;;;
FABA;CJK COMPATIBILITY IDEOGRAPH-FABA;Lo;0;L;8AF8;;;;N;;;;;
FABB;CJK COMPATIBILITY IDEOGRAPH-FABB;Lo;0;L;8ACB;;;;N;;;;;
FABC;CJK COMPATIBILITY IDEOGRAPH-FABC;Lo;0;L;8B01;;;;N;;;;;
FABD;CJK COMPATIBILITY IDEOGRAPH-FABD;Lo;0;L;8AFE;;;;N;;;;;
FABE;CJK COMPATIBILITY IDEOGRAPH-FABE;Lo;0;L;8AED;;;;N;;;;;
FABF;CJK COMPATIBILITY IDEOGRAPH-FABF;Lo;0;L;8B39;;;;N;;;;;
FAC0;CJK COMPATIBILITY IDEOGRAPH-FAC0;Lo;0;L;8B8A;;;;N;;;;;
FAC1;CJK COMPATIBILITY IDEOGRAPH-FAC1;Lo;0;L;8D08;;;;N;;;;;
FAC2;CJK COMPATIBILITY IDEOGRAPH-FAC2;Lo;0;L;8F38;;;;N;;;;;
FAC3;CJK COMPATIBILITY IDEOGRAPH-FAC3;Lo;0;L;9072;;;;N;;;;;
FAC4;CJK COMPATIBILITY IDEOGRAPH-FAC4;Lo;0;L;9199;;;;N;;;;;
FAC5;CJK COMPATIBILITY IDEOGRAPH-FAC5;Lo;0;L;9276;;;;N;;;;;
FAC6;CJK COMPATIBILITY IDEOGRAPH-FAC6;Lo;0;L;967C;;;;N;;;;;
FAC7;CJK COMPATIBILITY IDEOGRAPH-FAC7;Lo;0;L;96E3;;;;N;;;;;
FAC8;CJK COMPATIBILITY IDEOGRAPH-FAC8;Lo;0;L;9756;;;;N;;;;;
FAC9;CJK COMPATIBILITY IDEOGRAPH-FAC9;Lo;0;L;97DB;;;;N;;;;;
FACA;CJK COMPATIBILITY IDEOGRAPH-FACA;Lo;0;L;97FF;;;;N;;;;;
FACB;CJK COMPATIBILITY IDEOGRAPH-FACB;Lo;0;L;980B;;;;N;;;;;
FACC;CJK COMPATIBILITY IDEOGRAPH-FACC;Lo;0;L;983B;;;;N;;;;;
FACD;CJK COMPATIBILITY IDEOGRAPH-FACD;Lo;0;L;9B12;;;;N;;;;;
FACE;CJK COMPATIBILITY IDEOGRAPH-FACE;Lo;0;L;9F9C;;;;N;;;;;
FACF;CJK COMPATIBILITY IDEOGRAPH-FACF;Lo;0;L;2284A;;;;N;;;;;
FAD0;CJK COMPATIBILITY IDEOGRAPH-FAD0;Lo;0;L;22844;;;;N;;;;;
FAD1;CJK COMPATIBILITY IDEOGRAPH-FAD1;Lo;0;L;233D5;;;;N;;;;;
FAD2;CJK COMPATIBILITY IDEOGRAPH-FAD2;Lo;0;L;3B9D;;;;N;;;;;
FAD3;CJK COMPATIBILITY IDEOGRAPH-FAD3;Lo;0;L;4018;;;;N;;;;;
FAD4;CJK COMPATIBILITY IDEOGRAPH-FAD4;Lo;0;L;4039;;;;N;;;;;
FAD5;CJK COMPATIBILITY IDEOGRAPH-FAD5;Lo;0;L;25249;;;;N;;;;;
FAD6;CJK COMPATIBILITY IDEOGRAPH-FAD6;Lo;0;L;25CD0;;;;N;;;;;
FAD7;CJK COMPATIBILITY IDEOGRAPH-FAD7;Lo;0;L;27ED3;;;;N;;;;;
FAD8;CJK COMPATIBILITY IDEOGRAPH-FAD8;Lo;0;L;9F43;;;;N;;;;;
FAD9;CJK COMPATIBILITY IDEOGRAPH-FAD9;Lo;0;L;9F8E;;;;N;;;;;
FB00;LATIN SMALL LIGATURE FF;Ll;0;L;<compat> 0066 0066;;;;N;;;;;
FB01;LATIN SMALL LIGATURE FI;Ll;0;L;<compat> 0066 0069;;;;N;;;;;
FB02;LATIN SMALL LIGATURE FL;Ll;0;L;<compat> 0066 006C;;;;N;;;;;
FB03;LATIN SMALL LIGATURE FFI;Ll;0;L;<compat> 0066 0066 0069;;;;N;;;;;
FB04;LATIN SMALL LIGATURE FFL;Ll;0;L;<compat> 0066 0066 006C;;;;N;;;;;
FB05;LATIN SMALL LIGATURE LONG S T;Ll;0;L;<compat> 017F 0074;;;;N;;;;;
FB06;LATIN SMALL LIGATURE ST;Ll;0;L;<compat> 0073 0074;;;;N;;;;;
FB13;ARMENIAN SMALL LIGATURE MEN NOW;Ll;0;L;<compat> 0574 0576;;;;N;;;;;
FB14;ARMENIAN SMALL LIGATURE MEN ECH;Ll;0;L;<compat> 0574 0565;;;;N;;;;;
FB15;ARMENIAN SMALL LIGATURE MEN INI;Ll;0;L;<compat> 0574 056B;;;;N;;;;;
FB16;ARMENIAN SMALL LIGATURE VEW NOW;Ll;0;L;<compat> 057E 0576;;;;N;;;;;
FB17;ARMENIAN SMALL LIGATURE MEN XEH;Ll;0;L;<compat> 0574 056D;;;;N;;;;;
FB1D;HEBREW LETTER YOD WITH HIRIQ;Lo;0;R;05D9 05B4;;;;N;;;;;
FB1E;HEBREW POINT JUDEO-SPANISH VARIKA;Mn;26;NSM;;;;;N;HEBREW POINT VARIKA;;;;
FB1F;HEBREW LIGATURE YIDDISH YOD YOD PATAH;Lo;0;R;05F2 05B7;;;;N;;;;;
FB20;HEBREW LETTER ALTERNATIVE AYIN;Lo;0;R;<font> 05E2;;;;N;;;;;
FB21;HEBREW LETTER WIDE ALEF;Lo;0;R;<font> 05D0;;;;N;;;;;
FB22;HEBREW LETTER WIDE DALET;Lo;0;R;<font> 05D3;;;;N;;;;;
FB23;HEBREW LETTER WIDE HE;Lo;0;R;<font> 05D4;;;;N;;;;;
FB24;HEBREW LETTER WIDE KAF;Lo;0;R;<font> 05DB;;;;N;;;;;
FB25;HEBREW LETTER WIDE LAMED;Lo;0;R;<font> 05DC;;;;N;;;;;
FB26;HEBREW LETTER WIDE FINAL MEM;Lo;0;R;<font> 05DD;;;;N;;;;;
FB27;HEBREW LETTER WIDE RESH;Lo;0;R;<font> 05E8;;;;N;;;;;
FB28;HEBREW LETTER WIDE TAV;Lo;0;R;<font> 05EA;;;;N;;;;;
FB29;HEBREW LETTER ALTERNATIVE PLUS SIGN;Sm;0;ES;<font> 002B;;;;N;;;;;
FB2A;HEBREW LETTER SHIN WITH SHIN DOT;Lo;0;R;05E9 05C1;;;;N;;;;;
FB2B;HEBREW LETTER SHIN WITH SIN DOT;Lo;0;R;05E9 05C2;;;;N;;;;;
FB2C;HEBREW LETTER SHIN WITH DAGESH AND SHIN DOT;Lo;0;R;FB49 05C1;;;;N;;;;;
FB2D;HEBREW LETTER SHIN WITH DAGESH AND SIN DOT;Lo;0;R;FB49 05C2;;;;N;;;;;
FB2E;HEBREW LETTER ALEF WITH PATAH;Lo;0;R;05D0 05B7;;;;N;;;;;
FB2F;HEBREW LETTER ALEF WITH QAMATS;Lo;0;R;05D0 05B8;;;;N;;;;;
FB30;HEBREW LETTER ALEF WITH MAPIQ;Lo;0;R;05D0 05BC;;;;N;;;;;
FB31;HEBREW LETTER BET WITH DAGESH;Lo;0;R;05D1 05BC;;;;N;;;;;
FB32;HEBREW LETTER GIMEL WITH DAGESH;Lo;0;R;05D2 05BC;;;;N;;;;;
FB33;HEBREW LETTER DALET WITH DAGESH;Lo;0;R;05D3 05BC;;;;N;;;;;
FB34;HEBREW LETTER HE WITH MAPIQ;Lo;0;R;05D4 05BC;;;;N;;;;;
FB35;HEBREW LETTER VAV WITH DAGESH;Lo;0;R;05D5 05BC;;;;N;;;;;
FB36;HEBREW LETTER ZAYIN WITH DAGESH;Lo;0;R;05D6 05BC;;;;N;;;;;
FB38;HEBREW LETTER TET WITH DAGESH;Lo;0;R;05D8 05BC;;;;N;;;;;
FB39;HEBREW LETTER YOD WITH DAGESH;Lo;0;R;05D9 05BC;;;;N;;;;;
FB3A;HEBREW LETTER FINAL KAF WITH DAGESH;Lo;0;R;05DA 05BC;;;;N;;;;;
FB3B;HEBREW LETTER KAF WITH DAGESH;Lo;0;R;05DB 05BC;;;;N;;;;;
FB3C;HEBREW LETTER LAMED WITH DAGESH;Lo;0;R;05DC 05BC;;;;N;;;;;
FB3E;HEBREW LETTER MEM WITH DAGESH;Lo;0;R;05DE 05BC;;;;N;;;;;
FB40;HEBREW LETTER NUN WITH DAGESH;Lo;0;R;05E0 05BC;;;;N;;;;;
FB41;HEBREW LETTER SAMEKH WITH DAGESH;Lo;0;R;05E1 05BC;;;;N;;;;;
FB43;HEBREW LETTER FINAL PE WITH DAGESH;Lo;0;R;05E3 05BC;;;;N;;;;;
FB44;HEBREW LETTER PE WITH DAGESH;Lo;0;R;05E4 05BC;;;;N;;;;;
FB46;HEBREW LETTER TSADI WITH DAGESH;Lo;0;R;05E6 05BC;;;;N;;;;;
FB47;HEBREW LETTER QOF WITH DAGESH;Lo;0;R;05E7 05BC;;;;N;;;;;
FB48;HEBREW LETTER RESH WITH DAGESH;Lo;0;R;05E8 05BC;;;;N;;;;;
FB49;HEBREW LETTER SHIN WITH DAGESH;Lo;0;R;05E9 05BC;;;;N;;;;;
FB4A;HEBREW LETTER TAV WITH DAGESH;Lo;0;R;05EA 05BC;;;;N;;;;;
FB4B;HEBREW LETTER VAV WITH HOLAM;Lo;0;R;05D5 05B9;;;;N;;;;;
FB4C;HEBREW LETTER BET WITH RAFE;Lo;0;R;05D1 05BF;;;;N;;;;;
FB4D;HEBREW LETTER KAF WITH RAFE;Lo;0;R;05DB 05BF;;;;N;;;;;
FB4E;HEBREW LETTER PE WITH RAFE;Lo;0;R;05E4 05BF;;;;N;;;;;
FB4F;HEBREW LIGATURE ALEF LAMED;Lo;0;R;<compat> 05D0 05DC;;;;N;;;;;
FB50;ARABIC LETTER ALEF WASLA ISOLATED FORM;Lo;0;AL;<isolated> 0671;;;;N;;;;;
FB51;ARABIC LETTER ALEF WASLA FINAL FORM;Lo;0;AL;<final> 0671;;;;N;;;;;
FB52;ARABIC LETTER BEEH ISOLATED FORM;Lo;0;AL;<isolated> 067B;;;;N;;;;;
FB53;ARABIC LETTER BEEH FINAL FORM;Lo;0;AL;<final> 067B;;;;N;;;;;
FB54;ARABIC LETTER BEEH INITIAL FORM;Lo;0;AL;<initial> 067B;;;;N;;;;;
FB55;ARABIC LETTER BEEH MEDIAL FORM;Lo;0;AL;<medial> 067B;;;;N;;;;;
FB56;ARABIC LETTER PEH ISOLATED FORM;Lo;0;AL;<isolated> 067E;;;;N;;;;;
FB57;ARABIC LETTER PEH FINAL FORM;Lo;0;AL;<final> 067E;;;;N;;;;;
FB58;ARABIC LETTER PEH INITIAL FORM;Lo;0;AL;<initial> 067E;;;;N;;;;;
FB59;ARABIC LETTER PEH MEDIAL FORM;Lo;0;AL;<medial> 067E;;;;N;;;;;
FB5A;ARABIC LETTER BEHEH ISOLATED FORM;Lo;0;AL;<isolated> 0680;;;;N;;;;;
FB5B;ARABIC LETTER BEHEH FINAL FORM;Lo;0;AL;<final> 0680;;;;N;;;;;
FB5C;ARABIC LETTER BEHEH INITIAL FORM;Lo;0;AL;<initial> 0680;;;;N;;;;;
FB5D;ARABIC LETTER BEHEH MEDIAL FORM;Lo;0;AL;<medial> 0680;;;;N;;;;;
FB5E;ARABIC LETTER TTEHEH ISOLATED FORM;Lo;0;AL;<isolated> 067A;;;;N;;;;;
FB5F;ARABIC LETTER TTEHEH FINAL FORM;Lo;0;AL;<final> 067A;;;;N;;;;;
FB60;ARABIC LETTER TTEHEH INITIAL FORM;Lo;0;AL;<initial> 067A;;;;N;;;;;
FB61;ARABIC LETTER TTEHEH MEDIAL FORM;Lo;0;AL;<medial> 067A;;;;N;;;;;
FB62;ARABIC LETTER TEHEH ISOLATED FORM;Lo;0;AL;<isolated> 067F;;;;N;;;;;
FB63;ARABIC LETTER TEHEH FINAL FORM;Lo;0;AL;<final> 067F;;;;N;;;;;
FB64;ARABIC LETTER TEHEH INITIAL FORM;Lo;0;AL;<initial> 067F;;;;N;;;;;
FB65;ARABIC LETTER TEHEH MEDIAL FORM;Lo;0;AL;<medial> 067F;;;;N;;;;;
FB66;ARABIC LETTER TTEH ISOLATED FORM;Lo;0;AL;<isolated> 0679;;;;N;;;;;
FB67;ARABIC LETTER TTEH FINAL FORM;Lo;0;AL;<final> 0679;;;;N;;;;;
FB68;ARABIC LETTER TTEH INITIAL FORM;Lo;0;AL;<initial> 0679;;;;N;;;;;
FB69;ARABIC LETTER TTEH MEDIAL FORM;Lo;0;AL;<medial> 0679;;;;N;;;;;
FB6A;ARABIC LETTER VEH ISOLATED FORM;Lo;0;AL;<isolated> 06A4;;;;N;;;;;
FB6B;ARABIC LETTER VEH FINAL FORM;Lo;0;AL;<final> 06A4;;;;N;;;;;
FB6C;ARABIC LETTER VEH INITIAL FORM;Lo;0;AL;<initial> 06A4;;;;N;;;;;
FB6D;ARABIC LETTER VEH MEDIAL FORM;Lo;0;AL;<medial> 06A4;;;;N;;;;;
FB6E;ARABIC LETTER PEHEH ISOLATED FORM;Lo;0;AL;<isolated> 06A6;;;;N;;;;;
FB6F;ARABIC LETTER PEHEH FINAL FORM;Lo;0;AL;<final> 06A6;;;;N;;;;;
FB70;ARABIC LETTER PEHEH INITIAL FORM;Lo;0;AL;<initial> 06A6;;;;N;;;;;
FB71;ARABIC LETTER PEHEH MEDIAL FORM;Lo;0;AL;<medial> 06A6;;;;N;;;;;
FB72;ARABIC LETTER DYEH ISOLATED FORM;Lo;0;AL;<isolated> 0684;;;;N;;;;;
FB73;ARABIC LETTER DYEH FINAL FORM;Lo;0;AL;<final> 0684;;;;N;;;;;
FB74;ARABIC LETTER DYEH INITIAL FORM;Lo;0;AL;<initial> 0684;;;;N;;;;;
FB75;ARABIC LETTER DYEH MEDIAL FORM;Lo;0;AL;<medial> 0684;;;;N;;;;;
FB76;ARABIC LETTER NYEH ISOLATED FORM;Lo;0;AL;<isolated> 0683;;;;N;;;;;
FB77;ARABIC LETTER NYEH FINAL FORM;Lo;0;AL;<final> 0683;;;;N;;;;;
FB78;ARABIC LETTER NYEH INITIAL FORM;Lo;0;AL;<initial> 0683;;;;N;;;;;
FB79;ARABIC LETTER NYEH MEDIAL FORM;Lo;0;AL;<medial> 0683;;;;N;;;;;
FB7A;ARABIC LETTER TCHEH ISOLATED FORM;Lo;0;AL;<isolated> 0686;;;;N;;;;;
FB7B;ARABIC LETTER TCHEH FINAL FORM;Lo;0;AL;<final> 0686;;;;N;;;;;
FB7C;ARABIC LETTER TCHEH INITIAL FORM;Lo;0;AL;<initial> 0686;;;;N;;;;;
FB7D;ARABIC LETTER TCHEH MEDIAL FORM;Lo;0;AL;<medial> 0686;;;;N;;;;;
FB7E;ARABIC LETTER TCHEHEH ISOLATED FORM;Lo;0;AL;<isolated> 0687;;;;N;;;;;
FB7F;ARABIC LETTER TCHEHEH FINAL FORM;Lo;0;AL;<final> 0687;;;;N;;;;;
FB80;ARABIC LETTER TCHEHEH INITIAL FORM;Lo;0;AL;<initial> 0687;;;;N;;;;;
FB81;ARABIC LETTER TCHEHEH MEDIAL FORM;Lo;0;AL;<medial> 0687;;;;N;;;;;
FB82;ARABIC LETTER DDAHAL ISOLATED FORM;Lo;0;AL;<isolated> 068D;;;;N;;;;;
FB83;ARABIC LETTER DDAHAL FINAL FORM;Lo;0;AL;<final> 068D;;;;N;;;;;
FB84;ARABIC LETTER DAHAL ISOLATED FORM;Lo;0;AL;<isolated> 068C;;;;N;;;;;
FB85;ARABIC LETTER DAHAL FINAL FORM;Lo;0;AL;<final> 068C;;;;N;;;;;
FB86;ARABIC LETTER DUL ISOLATED FORM;Lo;0;AL;<isolated> 068E;;;;N;;;;;
FB87;ARABIC LETTER DUL FINAL FORM;Lo;0;AL;<final> 068E;;;;N;;;;;
FB88;ARABIC LETTER DDAL ISOLATED FORM;Lo;0;AL;<isolated> 0688;;;;N;;;;;
FB89;ARABIC LETTER DDAL FINAL FORM;Lo;0;AL;<final> 0688;;;;N;;;;;
FB8A;ARABIC LETTER JEH ISOLATED FORM;Lo;0;AL;<isolated> 0698;;;;N;;;;;
FB8B;ARABIC LETTER JEH FINAL FORM;Lo;0;AL;<final> 0698;;;;N;;;;;
FB8C;ARABIC LETTER RREH ISOLATED FORM;Lo;0;AL;<isolated> 0691;;;;N;;;;;
FB8D;ARABIC LETTER RREH FINAL FORM;Lo;0;AL;<final> 0691;;;;N;;;;;
FB8E;ARABIC LETTER KEHEH ISOLATED FORM;Lo;0;AL;<isolated> 06A9;;;;N;;;;;
FB8F;ARABIC LETTER KEHEH FINAL FORM;Lo;0;AL;<final> 06A9;;;;N;;;;;
FB90;ARABIC LETTER KEHEH INITIAL FORM;Lo;0;AL;<initial> 06A9;;;;N;;;;;
FB91;ARABIC LETTER KEHEH MEDIAL FORM;Lo;0;AL;<medial> 06A9;;;;N;;;;;
FB92;ARABIC LETTER GAF ISOLATED FORM;Lo;0;AL;<isolated> 06AF;;;;N;;;;;
FB93;ARABIC LETTER GAF FINAL FORM;Lo;0;AL;<final> 06AF;;;;N;;;;;
FB94;ARABIC LETTER GAF INITIAL FORM;Lo;0;AL;<initial> 06AF;;;;N;;;;;
FB95;ARABIC LETTER GAF MEDIAL FORM;Lo;0;AL;<medial> 06AF;;;;N;;;;;
FB96;ARABIC LETTER GUEH ISOLATED FORM;Lo;0;AL;<isolated> 06B3;;;;N;;;;;
FB97;ARABIC LETTER GUEH FINAL FORM;Lo;0;AL;<final> 06B3;;;;N;;;;;
FB98;ARABIC LETTER GUEH INITIAL FORM;Lo;0;AL;<initial> 06B3;;;;N;;;;;
FB99;ARABIC LETTER GUEH MEDIAL FORM;Lo;0;AL;<medial> 06B3;;;;N;;;;;
FB9A;ARABIC LETTER NGOEH ISOLATED FORM;Lo;0;AL;<isolated> 06B1;;;;N;;;;;
FB9B;ARABIC LETTER NGOEH FINAL FORM;Lo;0;AL;<final> 06B1;;;;N;;;;;
FB9C;ARABIC LETTER NGOEH INITIAL FORM;Lo;0;AL;<initial> 06B1;;;;N;;;;;
FB9D;ARABIC LETTER NGOEH MEDIAL FORM;Lo;0;AL;<medial> 06B1;;;;N;;;;;
FB9E;ARABIC LETTER NOON GHUNNA ISOLATED FORM;Lo;0;AL;<isolated> 06BA;;;;N;;;;;
FB9F;ARABIC LETTER NOON GHUNNA FINAL FORM;Lo;0;AL;<final> 06BA;;;;N;;;;;
FBA0;ARABIC LETTER RNOON ISOLATED FORM;Lo;0;AL;<isolated> 06BB;;;;N;;;;;
FBA1;ARABIC LETTER RNOON FINAL FORM;Lo;0;AL;<final> 06BB;;;;N;;;;;
FBA2;ARABIC LETTER RNOON INITIAL FORM;Lo;0;AL;<initial> 06BB;;;;N;;;;;
FBA3;ARABIC LETTER RNOON MEDIAL FORM;Lo;0;AL;<medial> 06BB;;;;N;;;;;
FBA4;ARABIC LETTER HEH WITH YEH ABOVE ISOLATED FORM;Lo;0;AL;<isolated> 06C0;;;;N;;;;;
FBA5;ARABIC LETTER HEH WITH YEH ABOVE FINAL FORM;Lo;0;AL;<final> 06C0;;;;N;;;;;
FBA6;ARABIC LETTER HEH GOAL ISOLATED FORM;Lo;0;AL;<isolated> 06C1;;;;N;;;;;
FBA7;ARABIC LETTER HEH GOAL FINAL FORM;Lo;0;AL;<final> 06C1;;;;N;;;;;
FBA8;ARABIC LETTER HEH GOAL INITIAL FORM;Lo;0;AL;<initial> 06C1;;;;N;;;;;
FBA9;ARABIC LETTER HEH GOAL MEDIAL FORM;Lo;0;AL;<medial> 06C1;;;;N;;;;;
FBAA;ARABIC LETTER HEH DOACHASHMEE ISOLATED FORM;Lo;0;AL;<isolated> 06BE;;;;N;;;;;
FBAB;ARABIC LETTER HEH DOACHASHMEE FINAL FORM;Lo;0;AL;<final> 06BE;;;;N;;;;;
FBAC;ARABIC LETTER HEH DOACHASHMEE INITIAL FORM;Lo;0;AL;<initial> 06BE;;;;N;;;;;
FBAD;ARABIC LETTER HEH DOACHASHMEE MEDIAL FORM;Lo;0;AL;<medial> 06BE;;;;N;;;;;
FBAE;ARABIC LETTER YEH BARREE ISOLATED FORM;Lo;0;AL;<isolated> 06D2;;;;N;;;;;
FBAF;ARABIC LETTER YEH BARREE FINAL FORM;Lo;0;AL;<final> 06D2;;;;N;;;;;
FBB0;ARABIC LETTER YEH BARREE WITH HAMZA ABOVE ISOLATED FORM;Lo;0;AL;<isolated> 06D3;;;;N;;;;;
FBB1;ARABIC LETTER YEH BARREE WITH HAMZA ABOVE FINAL FORM;Lo;0;AL;<final> 06D3;;;;N;;;;;
FBB2;ARABIC SYMBOL DOT ABOVE;Sk;0;AL;;;;;N;;;;;
FBB3;ARABIC SYMBOL DOT BELOW;Sk;0;AL;;;;;N;;;;;
FBB4;ARABIC SYMBOL TWO DOTS ABOVE;Sk;0;AL;;;;;N;;;;;
FBB5;ARABIC SYMBOL TWO DOTS BELOW;Sk;0;AL;;;;;N;;;;;
FBB6;ARABIC SYMBOL THREE DOTS ABOVE;Sk;0;AL;;;;;N;;;;;
FBB7;ARABIC SYMBOL THREE DOTS BELOW;Sk;0;AL;;;;;N;;;;;
FBB8;ARABIC SYMBOL THREE DOTS POINTING DOWNWARDS ABOVE;Sk;0;AL;;;;;N;;;;;
FBB9;ARABIC SYMBOL THREE DOTS POINTING DOWNWARDS BELOW;Sk;0;AL;;;;;N;;;;;
FBBA;ARABIC SYMBOL FOUR DOTS ABOVE;Sk;0;AL;;;;;N;;;;;
FBBB;ARABIC SYMBOL FOUR DOTS BELOW;Sk;0;AL;;;;;N;;;;;
FBBC;ARABIC SYMBOL DOUBLE VERTICAL BAR BELOW;Sk;0;AL;;;;;N;;;;;
FBBD;ARABIC SYMBOL TWO DOTS VERTICALLY ABOVE;Sk;0;AL;;;;;N;;;;;
FBBE;ARABIC SYMBOL TWO DOTS VERTICALLY BELOW;Sk;0;AL;;;;;N;;;;;
FBBF;ARABIC SYMBOL RING;Sk;0;AL;;;;;N;;;;;
FBC0;ARABIC SYMBOL SMALL TAH ABOVE;Sk;0;AL;;;;;N;;;;;
FBC1;ARABIC SYMBOL SMALL TAH BELOW;Sk;0;AL;;;;;N;;;;;
FBC2;ARABIC SYMBOL WASLA ABOVE;Sk;0;AL;;;;;N;;;;;
FBD3;ARABIC LETTER NG ISOLATED FORM;Lo;0;AL;<isolated> 06AD;;;;N;;;;;
FBD4;ARABIC LETTER NG FINAL FORM;Lo;0;AL;<final> 06AD;;;;N;;;;;
FBD5;ARABIC LETTER NG INITIAL FORM;Lo;0;AL;<initial> 06AD;;;;N;;;;;
FBD6;ARABIC LETTER NG MEDIAL FORM;Lo;0;AL;<medial> 06AD;;;;N;;;;;
FBD7;ARABIC LETTER U ISOLATED FORM;Lo;0;AL;<isolated> 06C7;;;;N;;;;;
FBD8;ARABIC LETTER U FINAL FORM;Lo;0;AL;<final> 06C7;;;;N;;;;;
FBD9;ARABIC LETTER OE ISOLATED FORM;Lo;0;AL;<isolated> 06C6;;;;N;;;;;
FBDA;ARABIC LETTER OE FINAL FORM;Lo;0;AL;<final> 06C6;;;;N;;;;;
FBDB;ARABIC LETTER YU ISOLATED FORM;Lo;0;AL;<isolated> 06C8;;;;N;;;;;
FBDC;ARABIC LETTER YU FINAL FORM;Lo;0;AL;<final> 06C8;;;;N;;;;;
FBDD;ARABIC LETTER U WITH HAMZA ABOVE ISOLATED FORM;Lo;0;AL;<isolated> 0677;;;;N;;;;;
FBDE;ARABIC LETTER VE ISOLATED FORM;Lo;0;AL;<isolated> 06CB;;;;N;;;;;
FBDF;ARABIC LETTER VE FINAL FORM;Lo;0;AL;<final> 06CB;;;;N;;;;;
FBE0;ARABIC LETTER KIRGHIZ OE ISOLATED FORM;Lo;0;AL;<isolated> 06C5;;;;N;;;;;
FBE1;ARABIC LETTER KIRGHIZ OE FINAL FORM;Lo;0;AL;<final> 06C5;;;;N;;;;;
FBE2;ARABIC LETTER KIRGHIZ YU ISOLATED FORM;Lo;0;AL;<isolated> 06C9;;;;N;;;;;
FBE3;ARABIC LETTER KIRGHIZ YU FINAL FORM;Lo;0;AL;<final> 06C9;;;;N;;;;;
FBE4;ARABIC LETTER E ISOLATED FORM;Lo;0;AL;<isolated> 06D0;;;;N;;;;;
FBE5;ARABIC LETTER E FINAL FORM;Lo;0;AL;<final> 06D0;;;;N;;;;;
FBE6;ARABIC LETTER E INITIAL FORM;Lo;0;AL;<initial> 06D0;;;;N;;;;;
FBE7;ARABIC LETTER E MEDIAL FORM;Lo;0;AL;<medial> 06D0;;;;N;;;;;
FBE8;ARABIC LETTER UIGHUR KAZAKH KIRGHIZ ALEF MAKSURA INITIAL FORM;Lo;0;AL;<initial> 0649;;;;N;;;;;
FBE9;ARABIC LETTER UIGHUR KAZAKH KIRGHIZ ALEF MAKSURA MEDIAL FORM;Lo;0;AL;<medial> 0649;;;;N;;;;;
FBEA;ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH ALEF ISOLATED FORM;Lo;0;AL;<isolated> 0626 0627;;;;N;;;;;
FBEB;ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH ALEF FINAL FORM;Lo;0;AL;<final> 0626 0627;;;;N;;;;;
FBEC;ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH AE ISOLATED FORM;Lo;0;AL;<isolated> 0626 06D5;;;;N;;;;;
FBED;ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH AE FINAL FORM;Lo;0;AL;<final> 0626 06D5;;;;N;;;;;
FBEE;ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH WAW ISOLATED FORM;Lo;0;AL;<isolated> 0626 0648;;;;N;;;;;
FBEF;ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH WAW FINAL FORM;Lo;0;AL;<final> 0626 0648;;;;N;;;;;
FBF0;ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH U ISOLATED FORM;Lo;0;AL;<isolated> 0626 06C7;;;;N;;;;;
FBF1;ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH U FINAL FORM;Lo;0;AL;<final> 0626 06C7;;;;N;;;;;
FBF2;ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH OE ISOLATED FORM;Lo;0;AL;<isolated> 0626 06C6;;;;N;;;;;
FBF3;ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH OE FINAL FORM;Lo;0;AL;<final> 0626 06C6;;;;N;;;;;
FBF4;ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH YU ISOLATED FORM;Lo;0;AL;<isolated> 0626 06C8;;;;N;;;;;
FBF5;ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH YU FINAL FORM;Lo;0;AL;<final> 0626 06C8;;;;N;;;;;
FBF6;ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH E ISOLATED FORM;Lo;0;AL;<isolated> 0626 06D0;;;;N;;;;;
FBF7;ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH E FINAL FORM;Lo;0;AL;<final> 0626 06D0;;;;N;;;;;
FBF8;ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH E INITIAL FORM;Lo;0;AL;<initial> 0626 06D0;;;;N;;;;;
FBF9;ARABIC LIGATURE UIGHUR KIRGHIZ YEH WITH HAMZA ABOVE WITH ALEF MAKSURA ISOLATED FORM;Lo;0;AL;<isolated> 0626 0649;;;;N;;;;;
FBFA;ARABIC LIGATURE UIGHUR KIRGHIZ YEH WITH HAMZA ABOVE WITH ALEF MAKSURA FINAL FORM;Lo;0;AL;<final> 0626 0649;;;;N;;;;;
FBFB;ARABIC LIGATURE UIGHUR KIRGHIZ YEH WITH HAMZA ABOVE WITH ALEF MAKSURA INITIAL FORM;Lo;0;AL;<initial> 0626 0649;;;;N;;;;;
FBFC;ARABIC LETTER FARSI YEH ISOLATED FORM;Lo;0;AL;<isolated> 06CC;;;;N;;;;;
FBFD;ARABIC LETTER FARSI YEH FINAL FORM;Lo;0;AL;<final> 06CC;;;;N;;;;;
FBFE;ARABIC LETTER FARSI YEH INITIAL FORM;Lo;0;AL;<initial> 06CC;;;;N;;;;;
FBFF;ARABIC LETTER FARSI YEH MEDIAL FORM;Lo;0;AL;<medial> 06CC;;;;N;;;;;
FC00;ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH JEEM ISOLATED FORM;Lo;0;AL;<isolated> 0626 062C;;;;N;;;;;
FC01;ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH HAH ISOLATED FORM;Lo;0;AL;<isolated> 0626 062D;;;;N;;;;;
FC02;ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH MEEM ISOLATED FORM;Lo;0;AL;<isolated> 0626 0645;;;;N;;;;;
FC03;ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH ALEF MAKSURA ISOLATED FORM;Lo;0;AL;<isolated> 0626 0649;;;;N;;;;;
FC04;ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH YEH ISOLATED FORM;Lo;0;AL;<isolated> 0626 064A;;;;N;;;;;
FC05;ARABIC LIGATURE BEH WITH JEEM ISOLATED FORM;Lo;0;AL;<isolated> 0628 062C;;;;N;;;;;
FC06;ARABIC LIGATURE BEH WITH HAH ISOLATED FORM;Lo;0;AL;<isolated> 0628 062D;;;;N;;;;;
FC07;ARABIC LIGATURE BEH WITH KHAH ISOLATED FORM;Lo;0;AL;<isolated> 0628 062E;;;;N;;;;;
FC08;ARABIC LIGATURE BEH WITH MEEM ISOLATED FORM;Lo;0;AL;<isolated> 0628 0645;;;;N;;;;;
FC09;ARABIC LIGATURE BEH WITH ALEF MAKSURA ISOLATED FORM;Lo;0;AL;<isolated> 0628 0649;;;;N;;;;;
FC0A;ARABIC LIGATURE BEH WITH YEH ISOLATED FORM;Lo;0;AL;<isolated> 0628 064A;;;;N;;;;;
FC0B;ARABIC LIGATURE TEH WITH JEEM ISOLATED FORM;Lo;0;AL;<isolated> 062A 062C;;;;N;;;;;
FC0C;ARABIC LIGATURE TEH WITH HAH ISOLATED FORM;Lo;0;AL;<isolated> 062A 062D;;;;N;;;;;
FC0D;ARABIC LIGATURE TEH WITH KHAH ISOLATED FORM;Lo;0;AL;<isolated> 062A 062E;;;;N;;;;;
FC0E;ARABIC LIGATURE TEH WITH MEEM ISOLATED FORM;Lo;0;AL;<isolated> 062A 0645;;;;N;;;;;
FC0F;ARABIC LIGATURE TEH WITH ALEF MAKSURA ISOLATED FORM;Lo;0;AL;<isolated> 062A 0649;;;;N;;;;;
FC10;ARABIC LIGATURE TEH WITH YEH ISOLATED FORM;Lo;0;AL;<isolated> 062A 064A;;;;N;;;;;
FC11;ARABIC LIGATURE THEH WITH JEEM ISOLATED FORM;Lo;0;AL;<isolated> 062B 062C;;;;N;;;;;
FC12;ARABIC LIGATURE THEH WITH MEEM ISOLATED FORM;Lo;0;AL;<isolated> 062B 0645;;;;N;;;;;
FC13;ARABIC LIGATURE THEH WITH ALEF MAKSURA ISOLATED FORM;Lo;0;AL;<isolated> 062B 0649;;;;N;;;;;
FC14;ARABIC LIGATURE THEH WITH YEH ISOLATED FORM;Lo;0;AL;<isolated> 062B 064A;;;;N;;;;;
FC15;ARABIC LIGATURE JEEM WITH HAH ISOLATED FORM;Lo;0;AL;<isolated> 062C 062D;;;;N;;;;;
FC16;ARABIC LIGATURE JEEM WITH MEEM ISOLATED FORM;Lo;0;AL;<isolated> 062C 0645;;;;N;;;;;
FC17;ARABIC LIGATURE HAH WITH JEEM ISOLATED FORM;Lo;0;AL;<isolated> 062D 062C;;;;N;;;;;
FC18;ARABIC LIGATURE HAH WITH MEEM ISOLATED FORM;Lo;0;AL;<isolated> 062D 0645;;;;N;;;;;
FC19;ARABIC LIGATURE KHAH WITH JEEM ISOLATED FORM;Lo;0;AL;<isolated> 062E 062C;;;;N;;;;;
FC1A;ARABIC LIGATURE KHAH WITH HAH ISOLATED FORM;Lo;0;AL;<isolated> 062E 062D;;;;N;;;;;
FC1B;ARABIC LIGATURE KHAH WITH MEEM ISOLATED FORM;Lo;0;AL;<isolated> 062E 0645;;;;N;;;;;
FC1C;ARABIC LIGATURE SEEN WITH JEEM ISOLATED FORM;Lo;0;AL;<isolated> 0633 062C;;;;N;;;;;
FC1D;ARABIC LIGATURE SEEN WITH HAH ISOLATED FORM;Lo;0;AL;<isolated> 0633 062D;;;;N;;;;;
FC1E;ARABIC LIGATURE SEEN WITH KHAH ISOLATED FORM;Lo;0;AL;<isolated> 0633 062E;;;;N;;;;;
FC1F;ARABIC LIGATURE SEEN WITH MEEM ISOLATED FORM;Lo;0;AL;<isolated> 0633 0645;;;;N;;;;;
FC20;ARABIC LIGATURE SAD WITH HAH ISOLATED FORM;Lo;0;AL;<isolated> 0635 062D;;;;N;;;;;
FC21;ARABIC LIGATURE SAD WITH MEEM ISOLATED FORM;Lo;0;AL;<isolated> 0635 0645;;;;N;;;;;
FC22;ARABIC LIGATURE DAD WITH JEEM ISOLATED FORM;Lo;0;AL;<isolated> 0636 062C;;;;N;;;;;
FC23;ARABIC LIGATURE DAD WITH HAH ISOLATED FORM;Lo;0;AL;<isolated> 0636 062D;;;;N;;;;;
FC24;ARABIC LIGATURE DAD WITH KHAH ISOLATED FORM;Lo;0;AL;<isolated> 0636 062E;;;;N;;;;;
FC25;ARABIC LIGATURE DAD WITH MEEM ISOLATED FORM;Lo;0;AL;<isolated> 0636 0645;;;;N;;;;;
FC26;ARABIC LIGATURE TAH WITH HAH ISOLATED FORM;Lo;0;AL;<isolated> 0637 062D;;;;N;;;;;
FC27;ARABIC LIGATURE TAH WITH MEEM ISOLATED FORM;Lo;0;AL;<isolated> 0637 0645;;;;N;;;;;
FC28;ARABIC LIGATURE ZAH WITH MEEM ISOLATED FORM;Lo;0;AL;<isolated> 0638 0645;;;;N;;;;;
FC29;ARABIC LIGATURE AIN WITH JEEM ISOLATED FORM;Lo;0;AL;<isolated> 0639 062C;;;;N;;;;;
FC2A;ARABIC LIGATURE AIN WITH MEEM ISOLATED FORM;Lo;0;AL;<isolated> 0639 0645;;;;N;;;;;
FC2B;ARABIC LIGATURE GHAIN WITH JEEM ISOLATED FORM;Lo;0;AL;<isolated> 063A 062C;;;;N;;;;;
FC2C;ARABIC LIGATURE GHAIN WITH MEEM ISOLATED FORM;Lo;0;AL;<isolated> 063A 0645;;;;N;;;;;
FC2D;ARABIC LIGATURE FEH WITH JEEM ISOLATED FORM;Lo;0;AL;<isolated> 0641 062C;;;;N;;;;;
FC2E;ARABIC LIGATURE FEH WITH HAH ISOLATED FORM;Lo;0;AL;<isolated> 0641 062D;;;;N;;;;;
FC2F;ARABIC LIGATURE FEH WITH KHAH ISOLATED FORM;Lo;0;AL;<isolated> 0641 062E;;;;N;;;;;
FC30;ARABIC LIGATURE FEH WITH MEEM ISOLATED FORM;Lo;0;AL;<isolated> 0641 0645;;;;N;;;;;
FC31;ARABIC LIGATURE FEH WITH ALEF MAKSURA ISOLATED FORM;Lo;0;AL;<isolated> 0641 0649;;;;N;;;;;
FC32;ARABIC LIGATURE FEH WITH YEH ISOLATED FORM;Lo;0;AL;<isolated> 0641 064A;;;;N;;;;;
FC33;ARABIC LIGATURE QAF WITH HAH ISOLATED FORM;Lo;0;AL;<isolated> 0642 062D;;;;N;;;;;
FC34;ARABIC LIGATURE QAF WITH MEEM ISOLATED FORM;Lo;0;AL;<isolated> 0642 0645;;;;N;;;;;
FC35;ARABIC LIGATURE QAF WITH ALEF MAKSURA ISOLATED FORM;Lo;0;AL;<isolated> 0642 0649;;;;N;;;;;
FC36;ARABIC LIGATURE QAF WITH YEH ISOLATED FORM;Lo;0;AL;<isolated> 0642 064A;;;;N;;;;;
FC37;ARABIC LIGATURE KAF WITH ALEF ISOLATED FORM;Lo;0;AL;<isolated> 0643 0627;;;;N;;;;;
FC38;ARABIC LIGATURE KAF WITH JEEM ISOLATED FORM;Lo;0;AL;<isolated> 0643 062C;;;;N;;;;;
FC39;ARABIC LIGATURE KAF WITH HAH ISOLATED FORM;Lo;0;AL;<isolated> 0643 062D;;;;N;;;;;
FC3A;ARABIC LIGATURE KAF WITH KHAH ISOLATED FORM;Lo;0;AL;<isolated> 0643 062E;;;;N;;;;;
FC3B;ARABIC LIGATURE KAF WITH LAM ISOLATED FORM;Lo;0;AL;<isolated> 0643 0644;;;;N;;;;;
FC3C;ARABIC LIGATURE KAF WITH MEEM ISOLATED FORM;Lo;0;AL;<isolated> 0643 0645;;;;N;;;;;
FC3D;ARABIC LIGATURE KAF WITH ALEF MAKSURA ISOLATED FORM;Lo;0;AL;<isolated> 0643 0649;;;;N;;;;;
FC3E;ARABIC LIGATURE KAF WITH YEH ISOLATED FORM;Lo;0;AL;<isolated> 0643 064A;;;;N;;;;;
FC3F;ARABIC LIGATURE LAM WITH JEEM ISOLATED FORM;Lo;0;AL;<isolated> 0644 062C;;;;N;;;;;
FC40;ARABIC LIGATURE LAM WITH HAH ISOLATED FORM;Lo;0;AL;<isolated> 0644 062D;;;;N;;;;;
FC41;ARABIC LIGATURE LAM WITH KHAH ISOLATED FORM;Lo;0;AL;<isolated> 0644 062E;;;;N;;;;;
FC42;ARABIC LIGATURE LAM WITH MEEM ISOLATED FORM;Lo;0;AL;<isolated> 0644 0645;;;;N;;;;;
FC43;ARABIC LIGATURE LAM WITH ALEF MAKSURA ISOLATED FORM;Lo;0;AL;<isolated> 0644 0649;;;;N;;;;;
FC44;ARABIC LIGATURE LAM WITH YEH ISOLATED FORM;Lo;0;AL;<isolated> 0644 064A;;;;N;;;;;
FC45;ARABIC LIGATURE MEEM WITH JEEM ISOLATED FORM;Lo;0;AL;<isolated> 0645 062C;;;;N;;;;;
FC46;ARABIC LIGATURE MEEM WITH HAH ISOLATED FORM;Lo;0;AL;<isolated> 0645 062D;;;;N;;;;;
FC47;ARABIC LIGATURE MEEM WITH KHAH ISOLATED FORM;Lo;0;AL;<isolated> 0645 062E;;;;N;;;;;
FC48;ARABIC LIGATURE MEEM WITH MEEM ISOLATED FORM;Lo;0;AL;<isolated> 0645 0645;;;;N;;;;;
FC49;ARABIC LIGATURE MEEM WITH ALEF MAKSURA ISOLATED FORM;Lo;0;AL;<isolated> 0645 0649;;;;N;;;;;
FC4A;ARABIC LIGATURE MEEM WITH YEH ISOLATED FORM;Lo;0;AL;<isolated> 0645 064A;;;;N;;;;;
FC4B;ARABIC LIGATURE NOON WITH JEEM ISOLATED FORM;Lo;0;AL;<isolated> 0646 062C;;;;N;;;;;
FC4C;ARABIC LIGATURE NOON WITH HAH ISOLATED FORM;Lo;0;AL;<isolated> 0646 062D;;;;N;;;;;
FC4D;ARABIC LIGATURE NOON WITH KHAH ISOLATED FORM;Lo;0;AL;<isolated> 0646 062E;;;;N;;;;;
FC4E;ARABIC LIGATURE NOON WITH MEEM ISOLATED FORM;Lo;0;AL;<isolated> 0646 0645;;;;N;;;;;
FC4F;ARABIC LIGATURE NOON WITH ALEF MAKSURA ISOLATED FORM;Lo;0;AL;<isolated> 0646 0649;;;;N;;;;;
FC50;ARABIC LIGATURE NOON WITH YEH ISOLATED FORM;Lo;0;AL;<isolated> 0646 064A;;;;N;;;;;
FC51;ARABIC LIGATURE HEH WITH JEEM ISOLATED FORM;Lo;0;AL;<isolated> 0647 062C;;;;N;;;;;
FC52;ARABIC LIGATURE HEH WITH MEEM ISOLATED FORM;Lo;0;AL;<isolated> 0647 0645;;;;N;;;;;
FC53;ARABIC LIGATURE HEH WITH ALEF MAKSURA ISOLATED FORM;Lo;0;AL;<isolated> 0647 0649;;;;N;;;;;
FC54;ARABIC LIGATURE HEH WITH YEH ISOLATED FORM;Lo;0;AL;<isolated> 0647 064A;;;;N;;;;;
FC55;ARABIC LIGATURE YEH WITH JEEM ISOLATED FORM;Lo;0;AL;<isolated> 064A 062C;;;;N;;;;;
FC56;ARABIC LIGATURE YEH WITH HAH ISOLATED FORM;Lo;0;AL;<isolated> 064A 062D;;;;N;;;;;
FC57;ARABIC LIGATURE YEH WITH KHAH ISOLATED FORM;Lo;0;AL;<isolated> 064A 062E;;;;N;;;;;
FC58;ARABIC LIGATURE YEH WITH MEEM ISOLATED FORM;Lo;0;AL;<isolated> 064A 0645;;;;N;;;;;
FC59;ARABIC LIGATURE YEH WITH ALEF MAKSURA ISOLATED FORM;Lo;0;AL;<isolated> 064A 0649;;;;N;;;;;
FC5A;ARABIC LIGATURE YEH WITH YEH ISOLATED FORM;Lo;0;AL;<isolated> 064A 064A;;;;N;;;;;
FC5B;ARABIC LIGATURE THAL WITH SUPERSCRIPT ALEF ISOLATED FORM;Lo;0;AL;<isolated> 0630 0670;;;;N;;;;;
FC5C;ARABIC LIGATURE REH WITH SUPERSCRIPT ALEF ISOLATED FORM;Lo;0;AL;<isolated> 0631 0670;;;;N;;;;;
FC5D;ARABIC LIGATURE ALEF MAKSURA WITH SUPERSCRIPT ALEF ISOLATED FORM;Lo;0;AL;<isolated> 0649 0670;;;;N;;;;;
FC5E;ARABIC LIGATURE SHADDA WITH DAMMATAN ISOLATED FORM;Lo;0;AL;<isolated> 0020 064C 0651;;;;N;;;;;
FC5F;ARABIC LIGATURE SHADDA WITH KASRATAN ISOLATED FORM;Lo;0;AL;<isolated> 0020 064D 0651;;;;N;;;;;
FC60;ARABIC LIGATURE SHADDA WITH FATHA ISOLATED FORM;Lo;0;AL;<isolated> 0020 064E 0651;;;;N;;;;;
FC61;ARABIC LIGATURE SHADDA WITH DAMMA ISOLATED FORM;Lo;0;AL;<isolated> 0020 064F 0651;;;;N;;;;;
FC62;ARABIC LIGATURE SHADDA WITH KASRA ISOLATED FORM;Lo;0;AL;<isolated> 0020 0650 0651;;;;N;;;;;
FC63;ARABIC LIGATURE SHADDA WITH SUPERSCRIPT ALEF ISOLATED FORM;Lo;0;AL;<isolated> 0020 0651 0670;;;;N;;;;;
FC64;ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH REH FINAL FORM;Lo;0;AL;<final> 0626 0631;;;;N;;;;;
FC65;ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH ZAIN FINAL FORM;Lo;0;AL;<final> 0626 0632;;;;N;;;;;
FC66;ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH MEEM FINAL FORM;Lo;0;AL;<final> 0626 0645;;;;N;;;;;
FC67;ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH NOON FINAL FORM;Lo;0;AL;<final> 0626 0646;;;;N;;;;;
FC68;ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH ALEF MAKSURA FINAL FORM;Lo;0;AL;<final> 0626 0649;;;;N;;;;;
FC69;ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH YEH FINAL FORM;Lo;0;AL;<final> 0626 064A;;;;N;;;;;
FC6A;ARABIC LIGATURE BEH WITH REH FINAL FORM;Lo;0;AL;<final> 0628 0631;;;;N;;;;;
FC6B;ARABIC LIGATURE BEH WITH ZAIN FINAL FORM;Lo;0;AL;<final> 0628 0632;;;;N;;;;;
FC6C;ARABIC LIGATURE BEH WITH MEEM FINAL FORM;Lo;0;AL;<final> 0628 0645;;;;N;;;;;
FC6D;ARABIC LIGATURE BEH WITH NOON FINAL FORM;Lo;0;AL;<final> 0628 0646;;;;N;;;;;
FC6E;ARABIC LIGATURE BEH WITH ALEF MAKSURA FINAL FORM;Lo;0;AL;<final> 0628 0649;;;;N;;;;;
FC6F;ARABIC LIGATURE BEH WITH YEH FINAL FORM;Lo;0;AL;<final> 0628 064A;;;;N;;;;;
FC70;ARABIC LIGATURE TEH WITH REH FINAL FORM;Lo;0;AL;<final> 062A 0631;;;;N;;;;;
FC71;ARABIC LIGATURE TEH WITH ZAIN FINAL FORM;Lo;0;AL;<final> 062A 0632;;;;N;;;;;
FC72;ARABIC LIGATURE TEH WITH MEEM FINAL FORM;Lo;0;AL;<final> 062A 0645;;;;N;;;;;
FC73;ARABIC LIGATURE TEH WITH NOON FINAL FORM;Lo;0;AL;<final> 062A 0646;;;;N;;;;;
FC74;ARABIC LIGATURE TEH WITH ALEF MAKSURA FINAL FORM;Lo;0;AL;<final> 062A 0649;;;;N;;;;;
FC75;ARABIC LIGATURE TEH WITH YEH FINAL FORM;Lo;0;AL;<final> 062A 064A;;;;N;;;;;
FC76;ARABIC LIGATURE THEH WITH REH FINAL FORM;Lo;0;AL;<final> 062B 0631;;;;N;;;;;
FC77;ARABIC LIGATURE THEH WITH ZAIN FINAL FORM;Lo;0;AL;<final> 062B 0632;;;;N;;;;;
FC78;ARABIC LIGATURE THEH WITH MEEM FINAL FORM;Lo;0;AL;<final> 062B 0645;;;;N;;;;;
FC79;ARABIC LIGATURE THEH WITH NOON FINAL FORM;Lo;0;AL;<final> 062B 0646;;;;N;;;;;
FC7A;ARABIC LIGATURE THEH WITH ALEF MAKSURA FINAL FORM;Lo;0;AL;<final> 062B 0649;;;;N;;;;;
FC7B;ARABIC LIGATURE THEH WITH YEH FINAL FORM;Lo;0;AL;<final> 062B 064A;;;;N;;;;;
FC7C;ARABIC LIGATURE FEH WITH ALEF MAKSURA FINAL FORM;Lo;0;AL;<final> 0641 0649;;;;N;;;;;
FC7D;ARABIC LIGATURE FEH WITH YEH FINAL FORM;Lo;0;AL;<final> 0641 064A;;;;N;;;;;
FC7E;ARABIC LIGATURE QAF WITH ALEF MAKSURA FINAL FORM;Lo;0;AL;<final> 0642 0649;;;;N;;;;;
FC7F;ARABIC LIGATURE QAF WITH YEH FINAL FORM;Lo;0;AL;<final> 0642 064A;;;;N;;;;;
FC80;ARABIC LIGATURE KAF WITH ALEF FINAL FORM;Lo;0;AL;<final> 0643 0627;;;;N;;;;;
FC81;ARABIC LIGATURE KAF WITH LAM FINAL FORM;Lo;0;AL;<final> 0643 0644;;;;N;;;;;
FC82;ARABIC LIGATURE KAF WITH MEEM FINAL FORM;Lo;0;AL;<final> 0643 0645;;;;N;;;;;
FC83;ARABIC LIGATURE KAF WITH ALEF MAKSURA FINAL FORM;Lo;0;AL;<final> 0643 0649;;;;N;;;;;
FC84;ARABIC LIGATURE KAF WITH YEH FINAL FORM;Lo;0;AL;<final> 0643 064A;;;;N;;;;;
FC85;ARABIC LIGATURE LAM WITH MEEM FINAL FORM;Lo;0;AL;<final> 0644 0645;;;;N;;;;;
FC86;ARABIC LIGATURE LAM WITH ALEF MAKSURA FINAL FORM;Lo;0;AL;<final> 0644 0649;;;;N;;;;;
FC87;ARABIC LIGATURE LAM WITH YEH FINAL FORM;Lo;0;AL;<final> 0644 064A;;;;N;;;;;
FC88;ARABIC LIGATURE MEEM WITH ALEF FINAL FORM;Lo;0;AL;<final> 0645 0627;;;;N;;;;;
FC89;ARABIC LIGATURE MEEM WITH MEEM FINAL FORM;Lo;0;AL;<final> 0645 0645;;;;N;;;;;
FC8A;ARABIC LIGATURE NOON WITH REH FINAL FORM;Lo;0;AL;<final> 0646 0631;;;;N;;;;;
FC8B;ARABIC LIGATURE NOON WITH ZAIN FINAL FORM;Lo;0;AL;<final> 0646 0632;;;;N;;;;;
FC8C;ARABIC LIGATURE NOON WITH MEEM FINAL FORM;Lo;0;AL;<final> 0646 0645;;;;N;;;;;
FC8D;ARABIC LIGATURE NOON WITH NOON FINAL FORM;Lo;0;AL;<final> 0646 0646;;;;N;;;;;
FC8E;ARABIC LIGATURE NOON WITH ALEF MAKSURA FINAL FORM;Lo;0;AL;<final> 0646 0649;;;;N;;;;;
FC8F;ARABIC LIGATURE NOON WITH YEH FINAL FORM;Lo;0;AL;<final> 0646 064A;;;;N;;;;;
FC90;ARABIC LIGATURE ALEF MAKSURA WITH SUPERSCRIPT ALEF FINAL FORM;Lo;0;AL;<final> 0649 0670;;;;N;;;;;
FC91;ARABIC LIGATURE YEH WITH REH FINAL FORM;Lo;0;AL;<final> 064A 0631;;;;N;;;;;
FC92;ARABIC LIGATURE YEH WITH ZAIN FINAL FORM;Lo;0;AL;<final> 064A 0632;;;;N;;;;;
FC93;ARABIC LIGATURE YEH WITH MEEM FINAL FORM;Lo;0;AL;<final> 064A 0645;;;;N;;;;;
FC94;ARABIC LIGATURE YEH WITH NOON FINAL FORM;Lo;0;AL;<final> 064A 0646;;;;N;;;;;
FC95;ARABIC LIGATURE YEH WITH ALEF MAKSURA FINAL FORM;Lo;0;AL;<final> 064A 0649;;;;N;;;;;
FC96;ARABIC LIGATURE YEH WITH YEH FINAL FORM;Lo;0;AL;<final> 064A 064A;;;;N;;;;;
FC97;ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH JEEM INITIAL FORM;Lo;0;AL;<initial> 0626 062C;;;;N;;;;;
FC98;ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH HAH INITIAL FORM;Lo;0;AL;<initial> 0626 062D;;;;N;;;;;
FC99;ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH KHAH INITIAL FORM;Lo;0;AL;<initial> 0626 062E;;;;N;;;;;
FC9A;ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 0626 0645;;;;N;;;;;
FC9B;ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH HEH INITIAL FORM;Lo;0;AL;<initial> 0626 0647;;;;N;;;;;
FC9C;ARABIC LIGATURE BEH WITH JEEM INITIAL FORM;Lo;0;AL;<initial> 0628 062C;;;;N;;;;;
FC9D;ARABIC LIGATURE BEH WITH HAH INITIAL FORM;Lo;0;AL;<initial> 0628 062D;;;;N;;;;;
FC9E;ARABIC LIGATURE BEH WITH KHAH INITIAL FORM;Lo;0;AL;<initial> 0628 062E;;;;N;;;;;
FC9F;ARABIC LIGATURE BEH WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 0628 0645;;;;N;;;;;
FCA0;ARABIC LIGATURE BEH WITH HEH INITIAL FORM;Lo;0;AL;<initial> 0628 0647;;;;N;;;;;
FCA1;ARABIC LIGATURE TEH WITH JEEM INITIAL FORM;Lo;0;AL;<initial> 062A 062C;;;;N;;;;;
FCA2;ARABIC LIGATURE TEH WITH HAH INITIAL FORM;Lo;0;AL;<initial> 062A 062D;;;;N;;;;;
FCA3;ARABIC LIGATURE TEH WITH KHAH INITIAL FORM;Lo;0;AL;<initial> 062A 062E;;;;N;;;;;
FCA4;ARABIC LIGATURE TEH WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 062A 0645;;;;N;;;;;
FCA5;ARABIC LIGATURE TEH WITH HEH INITIAL FORM;Lo;0;AL;<initial> 062A 0647;;;;N;;;;;
FCA6;ARABIC LIGATURE THEH WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 062B 0645;;;;N;;;;;
FCA7;ARABIC LIGATURE JEEM WITH HAH INITIAL FORM;Lo;0;AL;<initial> 062C 062D;;;;N;;;;;
FCA8;ARABIC LIGATURE JEEM WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 062C 0645;;;;N;;;;;
FCA9;ARABIC LIGATURE HAH WITH JEEM INITIAL FORM;Lo;0;AL;<initial> 062D 062C;;;;N;;;;;
FCAA;ARABIC LIGATURE HAH WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 062D 0645;;;;N;;;;;
FCAB;ARABIC LIGATURE KHAH WITH JEEM INITIAL FORM;Lo;0;AL;<initial> 062E 062C;;;;N;;;;;
FCAC;ARABIC LIGATURE KHAH WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 062E 0645;;;;N;;;;;
FCAD;ARABIC LIGATURE SEEN WITH JEEM INITIAL FORM;Lo;0;AL;<initial> 0633 062C;;;;N;;;;;
FCAE;ARABIC LIGATURE SEEN WITH HAH INITIAL FORM;Lo;0;AL;<initial> 0633 062D;;;;N;;;;;
FCAF;ARABIC LIGATURE SEEN WITH KHAH INITIAL FORM;Lo;0;AL;<initial> 0633 062E;;;;N;;;;;
FCB0;ARABIC LIGATURE SEEN WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 0633 0645;;;;N;;;;;
FCB1;ARABIC LIGATURE SAD WITH HAH INITIAL FORM;Lo;0;AL;<initial> 0635 062D;;;;N;;;;;
FCB2;ARABIC LIGATURE SAD WITH KHAH INITIAL FORM;Lo;0;AL;<initial> 0635 062E;;;;N;;;;;
FCB3;ARABIC LIGATURE SAD WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 0635 0645;;;;N;;;;;
FCB4;ARABIC LIGATURE DAD WITH JEEM INITIAL FORM;Lo;0;AL;<initial> 0636 062C;;;;N;;;;;
FCB5;ARABIC LIGATURE DAD WITH HAH INITIAL FORM;Lo;0;AL;<initial> 0636 062D;;;;N;;;;;
FCB6;ARABIC LIGATURE DAD WITH KHAH INITIAL FORM;Lo;0;AL;<initial> 0636 062E;;;;N;;;;;
FCB7;ARABIC LIGATURE DAD WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 0636 0645;;;;N;;;;;
FCB8;ARABIC LIGATURE TAH WITH HAH INITIAL FORM;Lo;0;AL;<initial> 0637 062D;;;;N;;;;;
FCB9;ARABIC LIGATURE ZAH WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 0638 0645;;;;N;;;;;
FCBA;ARABIC LIGATURE AIN WITH JEEM INITIAL FORM;Lo;0;AL;<initial> 0639 062C;;;;N;;;;;
FCBB;ARABIC LIGATURE AIN WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 0639 0645;;;;N;;;;;
FCBC;ARABIC LIGATURE GHAIN WITH JEEM INITIAL FORM;Lo;0;AL;<initial> 063A 062C;;;;N;;;;;
FCBD;ARABIC LIGATURE GHAIN WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 063A 0645;;;;N;;;;;
FCBE;ARABIC LIGATURE FEH WITH JEEM INITIAL FORM;Lo;0;AL;<initial> 0641 062C;;;;N;;;;;
FCBF;ARABIC LIGATURE FEH WITH HAH INITIAL FORM;Lo;0;AL;<initial> 0641 062D;;;;N;;;;;
FCC0;ARABIC LIGATURE FEH WITH KHAH INITIAL FORM;Lo;0;AL;<initial> 0641 062E;;;;N;;;;;
FCC1;ARABIC LIGATURE FEH WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 0641 0645;;;;N;;;;;
FCC2;ARABIC LIGATURE QAF WITH HAH INITIAL FORM;Lo;0;AL;<initial> 0642 062D;;;;N;;;;;
FCC3;ARABIC LIGATURE QAF WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 0642 0645;;;;N;;;;;
FCC4;ARABIC LIGATURE KAF WITH JEEM INITIAL FORM;Lo;0;AL;<initial> 0643 062C;;;;N;;;;;
FCC5;ARABIC LIGATURE KAF WITH HAH INITIAL FORM;Lo;0;AL;<initial> 0643 062D;;;;N;;;;;
FCC6;ARABIC LIGATURE KAF WITH KHAH INITIAL FORM;Lo;0;AL;<initial> 0643 062E;;;;N;;;;;
FCC7;ARABIC LIGATURE KAF WITH LAM INITIAL FORM;Lo;0;AL;<initial> 0643 0644;;;;N;;;;;
FCC8;ARABIC LIGATURE KAF WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 0643 0645;;;;N;;;;;
FCC9;ARABIC LIGATURE LAM WITH JEEM INITIAL FORM;Lo;0;AL;<initial> 0644 062C;;;;N;;;;;
FCCA;ARABIC LIGATURE LAM WITH HAH INITIAL FORM;Lo;0;AL;<initial> 0644 062D;;;;N;;;;;
FCCB;ARABIC LIGATURE LAM WITH KHAH INITIAL FORM;Lo;0;AL;<initial> 0644 062E;;;;N;;;;;
FCCC;ARABIC LIGATURE LAM WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 0644 0645;;;;N;;;;;
FCCD;ARABIC LIGATURE LAM WITH HEH INITIAL FORM;Lo;0;AL;<initial> 0644 0647;;;;N;;;;;
FCCE;ARABIC LIGATURE MEEM WITH JEEM INITIAL FORM;Lo;0;AL;<initial> 0645 062C;;;;N;;;;;
FCCF;ARABIC LIGATURE MEEM WITH HAH INITIAL FORM;Lo;0;AL;<initial> 0645 062D;;;;N;;;;;
FCD0;ARABIC LIGATURE MEEM WITH KHAH INITIAL FORM;Lo;0;AL;<initial> 0645 062E;;;;N;;;;;
FCD1;ARABIC LIGATURE MEEM WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 0645 0645;;;;N;;;;;
FCD2;ARABIC LIGATURE NOON WITH JEEM INITIAL FORM;Lo;0;AL;<initial> 0646 062C;;;;N;;;;;
FCD3;ARABIC LIGATURE NOON WITH HAH INITIAL FORM;Lo;0;AL;<initial> 0646 062D;;;;N;;;;;
FCD4;ARABIC LIGATURE NOON WITH KHAH INITIAL FORM;Lo;0;AL;<initial> 0646 062E;;;;N;;;;;
FCD5;ARABIC LIGATURE NOON WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 0646 0645;;;;N;;;;;
FCD6;ARABIC LIGATURE NOON WITH HEH INITIAL FORM;Lo;0;AL;<initial> 0646 0647;;;;N;;;;;
FCD7;ARABIC LIGATURE HEH WITH JEEM INITIAL FORM;Lo;0;AL;<initial> 0647 062C;;;;N;;;;;
FCD8;ARABIC LIGATURE HEH WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 0647 0645;;;;N;;;;;
FCD9;ARABIC LIGATURE HEH WITH SUPERSCRIPT ALEF INITIAL FORM;Lo;0;AL;<initial> 0647 0670;;;;N;;;;;
FCDA;ARABIC LIGATURE YEH WITH JEEM INITIAL FORM;Lo;0;AL;<initial> 064A 062C;;;;N;;;;;
FCDB;ARABIC LIGATURE YEH WITH HAH INITIAL FORM;Lo;0;AL;<initial> 064A 062D;;;;N;;;;;
FCDC;ARABIC LIGATURE YEH WITH KHAH INITIAL FORM;Lo;0;AL;<initial> 064A 062E;;;;N;;;;;
FCDD;ARABIC LIGATURE YEH WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 064A 0645;;;;N;;;;;
FCDE;ARABIC LIGATURE YEH WITH HEH INITIAL FORM;Lo;0;AL;<initial> 064A 0647;;;;N;;;;;
FCDF;ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH MEEM MEDIAL FORM;Lo;0;AL;<medial> 0626 0645;;;;N;;;;;
FCE0;ARABIC LIGATURE YEH WITH HAMZA ABOVE WITH HEH MEDIAL FORM;Lo;0;AL;<medial> 0626 0647;;;;N;;;;;
FCE1;ARABIC LIGATURE BEH WITH MEEM MEDIAL FORM;Lo;0;AL;<medial> 0628 0645;;;;N;;;;;
FCE2;ARABIC LIGATURE BEH WITH HEH MEDIAL FORM;Lo;0;AL;<medial> 0628 0647;;;;N;;;;;
FCE3;ARABIC LIGATURE TEH WITH MEEM MEDIAL FORM;Lo;0;AL;<medial> 062A 0645;;;;N;;;;;
FCE4;ARABIC LIGATURE TEH WITH HEH MEDIAL FORM;Lo;0;AL;<medial> 062A 0647;;;;N;;;;;
FCE5;ARABIC LIGATURE THEH WITH MEEM MEDIAL FORM;Lo;0;AL;<medial> 062B 0645;;;;N;;;;;
FCE6;ARABIC LIGATURE THEH WITH HEH MEDIAL FORM;Lo;0;AL;<medial> 062B 0647;;;;N;;;;;
FCE7;ARABIC LIGATURE SEEN WITH MEEM MEDIAL FORM;Lo;0;AL;<medial> 0633 0645;;;;N;;;;;
FCE8;ARABIC LIGATURE SEEN WITH HEH MEDIAL FORM;Lo;0;AL;<medial> 0633 0647;;;;N;;;;;
FCE9;ARABIC LIGATURE SHEEN WITH MEEM MEDIAL FORM;Lo;0;AL;<medial> 0634 0645;;;;N;;;;;
FCEA;ARABIC LIGATURE SHEEN WITH HEH MEDIAL FORM;Lo;0;AL;<medial> 0634 0647;;;;N;;;;;
FCEB;ARABIC LIGATURE KAF WITH LAM MEDIAL FORM;Lo;0;AL;<medial> 0643 0644;;;;N;;;;;
FCEC;ARABIC LIGATURE KAF WITH MEEM MEDIAL FORM;Lo;0;AL;<medial> 0643 0645;;;;N;;;;;
FCED;ARABIC LIGATURE LAM WITH MEEM MEDIAL FORM;Lo;0;AL;<medial> 0644 0645;;;;N;;;;;
FCEE;ARABIC LIGATURE NOON WITH MEEM MEDIAL FORM;Lo;0;AL;<medial> 0646 0645;;;;N;;;;;
FCEF;ARABIC LIGATURE NOON WITH HEH MEDIAL FORM;Lo;0;AL;<medial> 0646 0647;;;;N;;;;;
FCF0;ARABIC LIGATURE YEH WITH MEEM MEDIAL FORM;Lo;0;AL;<medial> 064A 0645;;;;N;;;;;
FCF1;ARABIC LIGATURE YEH WITH HEH MEDIAL FORM;Lo;0;AL;<medial> 064A 0647;;;;N;;;;;
FCF2;ARABIC LIGATURE SHADDA WITH FATHA MEDIAL FORM;Lo;0;AL;<medial> 0640 064E 0651;;;;N;;;;;
FCF3;ARABIC LIGATURE SHADDA WITH DAMMA MEDIAL FORM;Lo;0;AL;<medial> 0640 064F 0651;;;;N;;;;;
FCF4;ARABIC LIGATURE SHADDA WITH KASRA MEDIAL FORM;Lo;0;AL;<medial> 0640 0650 0651;;;;N;;;;;
FCF5;ARABIC LIGATURE TAH WITH ALEF MAKSURA ISOLATED FORM;Lo;0;AL;<isolated> 0637 0649;;;;N;;;;;
FCF6;ARABIC LIGATURE TAH WITH YEH ISOLATED FORM;Lo;0;AL;<isolated> 0637 064A;;;;N;;;;;
FCF7;ARABIC LIGATURE AIN WITH ALEF MAKSURA ISOLATED FORM;Lo;0;AL;<isolated> 0639 0649;;;;N;;;;;
FCF8;ARABIC LIGATURE AIN WITH YEH ISOLATED FORM;Lo;0;AL;<isolated> 0639 064A;;;;N;;;;;
FCF9;ARABIC LIGATURE GHAIN WITH ALEF MAKSURA ISOLATED FORM;Lo;0;AL;<isolated> 063A 0649;;;;N;;;;;
FCFA;ARABIC LIGATURE GHAIN WITH YEH ISOLATED FORM;Lo;0;AL;<isolated> 063A 064A;;;;N;;;;;
FCFB;ARABIC LIGATURE SEEN WITH ALEF MAKSURA ISOLATED FORM;Lo;0;AL;<isolated> 0633 0649;;;;N;;;;;
FCFC;ARABIC LIGATURE SEEN WITH YEH ISOLATED FORM;Lo;0;AL;<isolated> 0633 064A;;;;N;;;;;
FCFD;ARABIC LIGATURE SHEEN WITH ALEF MAKSURA ISOLATED FORM;Lo;0;AL;<isolated> 0634 0649;;;;N;;;;;
FCFE;ARABIC LIGATURE SHEEN WITH YEH ISOLATED FORM;Lo;0;AL;<isolated> 0634 064A;;;;N;;;;;
FCFF;ARABIC LIGATURE HAH WITH ALEF MAKSURA ISOLATED FORM;Lo;0;AL;<isolated> 062D 0649;;;;N;;;;;
FD00;ARABIC LIGATURE HAH WITH YEH ISOLATED FORM;Lo;0;AL;<isolated> 062D 064A;;;;N;;;;;
FD01;ARABIC LIGATURE JEEM WITH ALEF MAKSURA ISOLATED FORM;Lo;0;AL;<isolated> 062C 0649;;;;N;;;;;
FD02;ARABIC LIGATURE JEEM WITH YEH ISOLATED FORM;Lo;0;AL;<isolated> 062C 064A;;;;N;;;;;
FD03;ARABIC LIGATURE KHAH WITH ALEF MAKSURA ISOLATED FORM;Lo;0;AL;<isolated> 062E 0649;;;;N;;;;;
FD04;ARABIC LIGATURE KHAH WITH YEH ISOLATED FORM;Lo;0;AL;<isolated> 062E 064A;;;;N;;;;;
FD05;ARABIC LIGATURE SAD WITH ALEF MAKSURA ISOLATED FORM;Lo;0;AL;<isolated> 0635 0649;;;;N;;;;;
FD06;ARABIC LIGATURE SAD WITH YEH ISOLATED FORM;Lo;0;AL;<isolated> 0635 064A;;;;N;;;;;
FD07;ARABIC LIGATURE DAD WITH ALEF MAKSURA ISOLATED FORM;Lo;0;AL;<isolated> 0636 0649;;;;N;;;;;
FD08;ARABIC LIGATURE DAD WITH YEH ISOLATED FORM;Lo;0;AL;<isolated> 0636 064A;;;;N;;;;;
FD09;ARABIC LIGATURE SHEEN WITH JEEM ISOLATED FORM;Lo;0;AL;<isolated> 0634 062C;;;;N;;;;;
FD0A;ARABIC LIGATURE SHEEN WITH HAH ISOLATED FORM;Lo;0;AL;<isolated> 0634 062D;;;;N;;;;;
FD0B;ARABIC LIGATURE SHEEN WITH KHAH ISOLATED FORM;Lo;0;AL;<isolated> 0634 062E;;;;N;;;;;
FD0C;ARABIC LIGATURE SHEEN WITH MEEM ISOLATED FORM;Lo;0;AL;<isolated> 0634 0645;;;;N;;;;;
FD0D;ARABIC LIGATURE SHEEN WITH REH ISOLATED FORM;Lo;0;AL;<isolated> 0634 0631;;;;N;;;;;
FD0E;ARABIC LIGATURE SEEN WITH REH ISOLATED FORM;Lo;0;AL;<isolated> 0633 0631;;;;N;;;;;
FD0F;ARABIC LIGATURE SAD WITH REH ISOLATED FORM;Lo;0;AL;<isolated> 0635 0631;;;;N;;;;;
FD10;ARABIC LIGATURE DAD WITH REH ISOLATED FORM;Lo;0;AL;<isolated> 0636 0631;;;;N;;;;;
FD11;ARABIC LIGATURE TAH WITH ALEF MAKSURA FINAL FORM;Lo;0;AL;<final> 0637 0649;;;;N;;;;;
FD12;ARABIC LIGATURE TAH WITH YEH FINAL FORM;Lo;0;AL;<final> 0637 064A;;;;N;;;;;
FD13;ARABIC LIGATURE AIN WITH ALEF MAKSURA FINAL FORM;Lo;0;AL;<final> 0639 0649;;;;N;;;;;
FD14;ARABIC LIGATURE AIN WITH YEH FINAL FORM;Lo;0;AL;<final> 0639 064A;;;;N;;;;;
FD15;ARABIC LIGATURE GHAIN WITH ALEF MAKSURA FINAL FORM;Lo;0;AL;<final> 063A 0649;;;;N;;;;;
FD16;ARABIC LIGATURE GHAIN WITH YEH FINAL FORM;Lo;0;AL;<final> 063A 064A;;;;N;;;;;
FD17;ARABIC LIGATURE SEEN WITH ALEF MAKSURA FINAL FORM;Lo;0;AL;<final> 0633 0649;;;;N;;;;;
FD18;ARABIC LIGATURE SEEN WITH YEH FINAL FORM;Lo;0;AL;<final> 0633 064A;;;;N;;;;;
FD19;ARABIC LIGATURE SHEEN WITH ALEF MAKSURA FINAL FORM;Lo;0;AL;<final> 0634 0649;;;;N;;;;;
FD1A;ARABIC LIGATURE SHEEN WITH YEH FINAL FORM;Lo;0;AL;<final> 0634 064A;;;;N;;;;;
FD1B;ARABIC LIGATURE HAH WITH ALEF MAKSURA FINAL FORM;Lo;0;AL;<final> 062D 0649;;;;N;;;;;
FD1C;ARABIC LIGATURE HAH WITH YEH FINAL FORM;Lo;0;AL;<final> 062D 064A;;;;N;;;;;
FD1D;ARABIC LIGATURE JEEM WITH ALEF MAKSURA FINAL FORM;Lo;0;AL;<final> 062C 0649;;;;N;;;;;
FD1E;ARABIC LIGATURE JEEM WITH YEH FINAL FORM;Lo;0;AL;<final> 062C 064A;;;;N;;;;;
FD1F;ARABIC LIGATURE KHAH WITH ALEF MAKSURA FINAL FORM;Lo;0;AL;<final> 062E 0649;;;;N;;;;;
FD20;ARABIC LIGATURE KHAH WITH YEH FINAL FORM;Lo;0;AL;<final> 062E 064A;;;;N;;;;;
FD21;ARABIC LIGATURE SAD WITH ALEF MAKSURA FINAL FORM;Lo;0;AL;<final> 0635 0649;;;;N;;;;;
FD22;ARABIC LIGATURE SAD WITH YEH FINAL FORM;Lo;0;AL;<final> 0635 064A;;;;N;;;;;
FD23;ARABIC LIGATURE DAD WITH ALEF MAKSURA FINAL FORM;Lo;0;AL;<final> 0636 0649;;;;N;;;;;
FD24;ARABIC LIGATURE DAD WITH YEH FINAL FORM;Lo;0;AL;<final> 0636 064A;;;;N;;;;;
FD25;ARABIC LIGATURE SHEEN WITH JEEM FINAL FORM;Lo;0;AL;<final> 0634 062C;;;;N;;;;;
FD26;ARABIC LIGATURE SHEEN WITH HAH FINAL FORM;Lo;0;AL;<final> 0634 062D;;;;N;;;;;
FD27;ARABIC LIGATURE SHEEN WITH KHAH FINAL FORM;Lo;0;AL;<final> 0634 062E;;;;N;;;;;
FD28;ARABIC LIGATURE SHEEN WITH MEEM FINAL FORM;Lo;0;AL;<final> 0634 0645;;;;N;;;;;
FD29;ARABIC LIGATURE SHEEN WITH REH FINAL FORM;Lo;0;AL;<final> 0634 0631;;;;N;;;;;
FD2A;ARABIC LIGATURE SEEN WITH REH FINAL FORM;Lo;0;AL;<final> 0633 0631;;;;N;;;;;
FD2B;ARABIC LIGATURE SAD WITH REH FINAL FORM;Lo;0;AL;<final> 0635 0631;;;;N;;;;;
FD2C;ARABIC LIGATURE DAD WITH REH FINAL FORM;Lo;0;AL;<final> 0636 0631;;;;N;;;;;
FD2D;ARABIC LIGATURE SHEEN WITH JEEM INITIAL FORM;Lo;0;AL;<initial> 0634 062C;;;;N;;;;;
FD2E;ARABIC LIGATURE SHEEN WITH HAH INITIAL FORM;Lo;0;AL;<initial> 0634 062D;;;;N;;;;;
FD2F;ARABIC LIGATURE SHEEN WITH KHAH INITIAL FORM;Lo;0;AL;<initial> 0634 062E;;;;N;;;;;
FD30;ARABIC LIGATURE SHEEN WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 0634 0645;;;;N;;;;;
FD31;ARABIC LIGATURE SEEN WITH HEH INITIAL FORM;Lo;0;AL;<initial> 0633 0647;;;;N;;;;;
FD32;ARABIC LIGATURE SHEEN WITH HEH INITIAL FORM;Lo;0;AL;<initial> 0634 0647;;;;N;;;;;
FD33;ARABIC LIGATURE TAH WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 0637 0645;;;;N;;;;;
FD34;ARABIC LIGATURE SEEN WITH JEEM MEDIAL FORM;Lo;0;AL;<medial> 0633 062C;;;;N;;;;;
FD35;ARABIC LIGATURE SEEN WITH HAH MEDIAL FORM;Lo;0;AL;<medial> 0633 062D;;;;N;;;;;
FD36;ARABIC LIGATURE SEEN WITH KHAH MEDIAL FORM;Lo;0;AL;<medial> 0633 062E;;;;N;;;;;
FD37;ARABIC LIGATURE SHEEN WITH JEEM MEDIAL FORM;Lo;0;AL;<medial> 0634 062C;;;;N;;;;;
FD38;ARABIC LIGATURE SHEEN WITH HAH MEDIAL FORM;Lo;0;AL;<medial> 0634 062D;;;;N;;;;;
FD39;ARABIC LIGATURE SHEEN WITH KHAH MEDIAL FORM;Lo;0;AL;<medial> 0634 062E;;;;N;;;;;
FD3A;ARABIC LIGATURE TAH WITH MEEM MEDIAL FORM;Lo;0;AL;<medial> 0637 0645;;;;N;;;;;
FD3B;ARABIC LIGATURE ZAH WITH MEEM MEDIAL FORM;Lo;0;AL;<medial> 0638 0645;;;;N;;;;;
FD3C;ARABIC LIGATURE ALEF WITH FATHATAN FINAL FORM;Lo;0;AL;<final> 0627 064B;;;;N;;;;;
FD3D;ARABIC LIGATURE ALEF WITH FATHATAN ISOLATED FORM;Lo;0;AL;<isolated> 0627 064B;;;;N;;;;;
FD3E;ORNATE LEFT PARENTHESIS;Pe;0;ON;;;;;N;;;;;
FD3F;ORNATE RIGHT PARENTHESIS;Ps;0;ON;;;;;N;;;;;
FD40;ARABIC LIGATURE RAHIMAHU ALLAAH;So;0;ON;;;;;N;;;;;
FD41;ARABIC LIGATURE RADI ALLAAHU ANH;So;0;ON;;;;;N;;;;;
FD42;ARABIC LIGATURE RADI ALLAAHU ANHAA;So;0;ON;;;;;N;;;;;
FD43;ARABIC LIGATURE RADI ALLAAHU ANHUM;So;0;ON;;;;;N;;;;;
FD44;ARABIC LIGATURE RADI ALLAAHU ANHUMAA;So;0;ON;;;;;N;;;;;
FD45;ARABIC LIGATURE RADI ALLAAHU ANHUNNA;So;0;ON;;;;;N;;;;;
FD46;ARABIC LIGATURE SALLALLAAHU ALAYHI WA-AALIH;So;0;ON;;;;;N;;;;;
FD47;ARABIC LIGATURE ALAYHI AS-SALAAM;So;0;ON;;;;;N;;;;;
FD48;ARABIC LIGATURE ALAYHIM AS-SALAAM;So;0;ON;;;;;N;;;;;
FD49;ARABIC LIGATURE ALAYHIMAA AS-SALAAM;So;0;ON;;;;;N;;;;;
FD4A;ARABIC LIGATURE ALAYHI AS-SALAATU WAS-SALAAM;So;0;ON;;;;;N;;;;;
FD4B;ARABIC LIGATURE QUDDISA SIRRAH;So;0;ON;;;;;N;;;;;
FD4C;ARABIC LIGATURE SALLALLAHU ALAYHI WAAALIHEE WA-SALLAM;So;0;ON;;;;;N;;;;;
FD4D;ARABIC LIGATURE ALAYHAA AS-SALAAM;So;0;ON;;;;;N;;;;;
FD4E;ARABIC LIGATURE TABAARAKA WA-TAAALAA;So;0;ON;;;;;N;;;;;
FD4F;ARABIC LIGATURE RAHIMAHUM ALLAAH;So;0;ON;;;;;N;;;;;
FD50;ARABIC LIGATURE TEH WITH JEEM WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 062A 062C 0645;;;;N;;;;;
FD51;ARABIC LIGATURE TEH WITH HAH WITH JEEM FINAL FORM;Lo;0;AL;<final> 062A 062D 062C;;;;N;;;;;
FD52;ARABIC LIGATURE TEH WITH HAH WITH JEEM INITIAL FORM;Lo;0;AL;<initial> 062A 062D 062C;;;;N;;;;;
FD53;ARABIC LIGATURE TEH WITH HAH WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 062A 062D 0645;;;;N;;;;;
FD54;ARABIC LIGATURE TEH WITH KHAH WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 062A 062E 0645;;;;N;;;;;
FD55;ARABIC LIGATURE TEH WITH MEEM WITH JEEM INITIAL FORM;Lo;0;AL;<initial> 062A 0645 062C;;;;N;;;;;
FD56;ARABIC LIGATURE TEH WITH MEEM WITH HAH INITIAL FORM;Lo;0;AL;<initial> 062A 0645 062D;;;;N;;;;;
FD57;ARABIC LIGATURE TEH WITH MEEM WITH KHAH INITIAL FORM;Lo;0;AL;<initial> 062A 0645 062E;;;;N;;;;;
FD58;ARABIC LIGATURE JEEM WITH MEEM WITH HAH FINAL FORM;Lo;0;AL;<final> 062C 0645 062D;;;;N;;;;;
FD59;ARABIC LIGATURE JEEM WITH MEEM WITH HAH INITIAL FORM;Lo;0;AL;<initial> 062C 0645 062D;;;;N;;;;;
FD5A;ARABIC LIGATURE HAH WITH MEEM WITH YEH FINAL FORM;Lo;0;AL;<final> 062D 0645 064A;;;;N;;;;;
FD5B;ARABIC LIGATURE HAH WITH MEEM WITH ALEF MAKSURA FINAL FORM;Lo;0;AL;<final> 062D 0645 0649;;;;N;;;;;
FD5C;ARABIC LIGATURE SEEN WITH HAH WITH JEEM INITIAL FORM;Lo;0;AL;<initial> 0633 062D 062C;;;;N;;;;;
FD5D;ARABIC LIGATURE SEEN WITH JEEM WITH HAH INITIAL FORM;Lo;0;AL;<initial> 0633 062C 062D;;;;N;;;;;
FD5E;ARABIC LIGATURE SEEN WITH JEEM WITH ALEF MAKSURA FINAL FORM;Lo;0;AL;<final> 0633 062C 0649;;;;N;;;;;
FD5F;ARABIC LIGATURE SEEN WITH MEEM WITH HAH FINAL FORM;Lo;0;AL;<final> 0633 0645 062D;;;;N;;;;;
FD60;ARABIC LIGATURE SEEN WITH MEEM WITH HAH INITIAL FORM;Lo;0;AL;<initial> 0633 0645 062D;;;;N;;;;;
FD61;ARABIC LIGATURE SEEN WITH MEEM WITH JEEM INITIAL FORM;Lo;0;AL;<initial> 0633 0645 062C;;;;N;;;;;
FD62;ARABIC LIGATURE SEEN WITH MEEM WITH MEEM FINAL FORM;Lo;0;AL;<final> 0633 0645 0645;;;;N;;;;;
FD63;ARABIC LIGATURE SEEN WITH MEEM WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 0633 0645 0645;;;;N;;;;;
FD64;ARABIC LIGATURE SAD WITH HAH WITH HAH FINAL FORM;Lo;0;AL;<final> 0635 062D 062D;;;;N;;;;;
FD65;ARABIC LIGATURE SAD WITH HAH WITH HAH INITIAL FORM;Lo;0;AL;<initial> 0635 062D 062D;;;;N;;;;;
FD66;ARABIC LIGATURE SAD WITH MEEM WITH MEEM FINAL FORM;Lo;0;AL;<final> 0635 0645 0645;;;;N;;;;;
FD67;ARABIC LIGATURE SHEEN WITH HAH WITH MEEM FINAL FORM;Lo;0;AL;<final> 0634 062D 0645;;;;N;;;;;
FD68;ARABIC LIGATURE SHEEN WITH HAH WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 0634 062D 0645;;;;N;;;;;
FD69;ARABIC LIGATURE SHEEN WITH JEEM WITH YEH FINAL FORM;Lo;0;AL;<final> 0634 062C 064A;;;;N;;;;;
FD6A;ARABIC LIGATURE SHEEN WITH MEEM WITH KHAH FINAL FORM;Lo;0;AL;<final> 0634 0645 062E;;;;N;;;;;
FD6B;ARABIC LIGATURE SHEEN WITH MEEM WITH KHAH INITIAL FORM;Lo;0;AL;<initial> 0634 0645 062E;;;;N;;;;;
FD6C;ARABIC LIGATURE SHEEN WITH MEEM WITH MEEM FINAL FORM;Lo;0;AL;<final> 0634 0645 0645;;;;N;;;;;
FD6D;ARABIC LIGATURE SHEEN WITH MEEM WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 0634 0645 0645;;;;N;;;;;
FD6E;ARABIC LIGATURE DAD WITH HAH WITH ALEF MAKSURA FINAL FORM;Lo;0;AL;<final> 0636 062D 0649;;;;N;;;;;
FD6F;ARABIC LIGATURE DAD WITH KHAH WITH MEEM FINAL FORM;Lo;0;AL;<final> 0636 062E 0645;;;;N;;;;;
FD70;ARABIC LIGATURE DAD WITH KHAH WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 0636 062E 0645;;;;N;;;;;
FD71;ARABIC LIGATURE TAH WITH MEEM WITH HAH FINAL FORM;Lo;0;AL;<final> 0637 0645 062D;;;;N;;;;;
FD72;ARABIC LIGATURE TAH WITH MEEM WITH HAH INITIAL FORM;Lo;0;AL;<initial> 0637 0645 062D;;;;N;;;;;
FD73;ARABIC LIGATURE TAH WITH MEEM WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 0637 0645 0645;;;;N;;;;;
FD74;ARABIC LIGATURE TAH WITH MEEM WITH YEH FINAL FORM;Lo;0;AL;<final> 0637 0645 064A;;;;N;;;;;
FD75;ARABIC LIGATURE AIN WITH JEEM WITH MEEM FINAL FORM;Lo;0;AL;<final> 0639 062C 0645;;;;N;;;;;
FD76;ARABIC LIGATURE AIN WITH MEEM WITH MEEM FINAL FORM;Lo;0;AL;<final> 0639 0645 0645;;;;N;;;;;
FD77;ARABIC LIGATURE AIN WITH MEEM WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 0639 0645 0645;;;;N;;;;;
FD78;ARABIC LIGATURE AIN WITH MEEM WITH ALEF MAKSURA FINAL FORM;Lo;0;AL;<final> 0639 0645 0649;;;;N;;;;;
FD79;ARABIC LIGATURE GHAIN WITH MEEM WITH MEEM FINAL FORM;Lo;0;AL;<final> 063A 0645 0645;;;;N;;;;;
FD7A;ARABIC LIGATURE GHAIN WITH MEEM WITH YEH FINAL FORM;Lo;0;AL;<final> 063A 0645 064A;;;;N;;;;;
FD7B;ARABIC LIGATURE GHAIN WITH MEEM WITH ALEF MAKSURA FINAL FORM;Lo;0;AL;<final> 063A 0645 0649;;;;N;;;;;
FD7C;ARABIC LIGATURE FEH WITH KHAH WITH MEEM FINAL FORM;Lo;0;AL;<final> 0641 062E 0645;;;;N;;;;;
FD7D;ARABIC LIGATURE FEH WITH KHAH WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 0641 062E 0645;;;;N;;;;;
FD7E;ARABIC LIGATURE QAF WITH MEEM WITH HAH FINAL FORM;Lo;0;AL;<final> 0642 0645 062D;;;;N;;;;;
FD7F;ARABIC LIGATURE QAF WITH MEEM WITH MEEM FINAL FORM;Lo;0;AL;<final> 0642 0645 0645;;;;N;;;;;
FD80;ARABIC LIGATURE LAM WITH HAH WITH MEEM FINAL FORM;Lo;0;AL;<final> 0644 062D 0645;;;;N;;;;;
FD81;ARABIC LIGATURE LAM WITH HAH WITH YEH FINAL FORM;Lo;0;AL;<final> 0644 062D 064A;;;;N;;;;;
FD82;ARABIC LIGATURE LAM WITH HAH WITH ALEF MAKSURA FINAL FORM;Lo;0;AL;<final> 0644 062D 0649;;;;N;;;;;
FD83;ARABIC LIGATURE LAM WITH JEEM WITH JEEM INITIAL FORM;Lo;0;AL;<initial> 0644 062C 062C;;;;N;;;;;
FD84;ARABIC LIGATURE LAM WITH JEEM WITH JEEM FINAL FORM;Lo;0;AL;<final> 0644 062C 062C;;;;N;;;;;
FD85;ARABIC LIGATURE LAM WITH KHAH WITH MEEM FINAL FORM;Lo;0;AL;<final> 0644 062E 0645;;;;N;;;;;
FD86;ARABIC LIGATURE LAM WITH KHAH WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 0644 062E 0645;;;;N;;;;;
FD87;ARABIC LIGATURE LAM WITH MEEM WITH HAH FINAL FORM;Lo;0;AL;<final> 0644 0645 062D;;;;N;;;;;
FD88;ARABIC LIGATURE LAM WITH MEEM WITH HAH INITIAL FORM;Lo;0;AL;<initial> 0644 0645 062D;;;;N;;;;;
FD89;ARABIC LIGATURE MEEM WITH HAH WITH JEEM INITIAL FORM;Lo;0;AL;<initial> 0645 062D 062C;;;;N;;;;;
FD8A;ARABIC LIGATURE MEEM WITH HAH WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 0645 062D 0645;;;;N;;;;;
FD8B;ARABIC LIGATURE MEEM WITH HAH WITH YEH FINAL FORM;Lo;0;AL;<final> 0645 062D 064A;;;;N;;;;;
FD8C;ARABIC LIGATURE MEEM WITH JEEM WITH HAH INITIAL FORM;Lo;0;AL;<initial> 0645 062C 062D;;;;N;;;;;
FD8D;ARABIC LIGATURE MEEM WITH JEEM WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 0645 062C 0645;;;;N;;;;;
FD8E;ARABIC LIGATURE MEEM WITH KHAH WITH JEEM INITIAL FORM;Lo;0;AL;<initial> 0645 062E 062C;;;;N;;;;;
FD8F;ARABIC LIGATURE MEEM WITH KHAH WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 0645 062E 0645;;;;N;;;;;
FD92;ARABIC LIGATURE MEEM WITH JEEM WITH KHAH INITIAL FORM;Lo;0;AL;<initial> 0645 062C 062E;;;;N;;;;;
FD93;ARABIC LIGATURE HEH WITH MEEM WITH JEEM INITIAL FORM;Lo;0;AL;<initial> 0647 0645 062C;;;;N;;;;;
FD94;ARABIC LIGATURE HEH WITH MEEM WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 0647 0645 0645;;;;N;;;;;
FD95;ARABIC LIGATURE NOON WITH HAH WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 0646 062D 0645;;;;N;;;;;
FD96;ARABIC LIGATURE NOON WITH HAH WITH ALEF MAKSURA FINAL FORM;Lo;0;AL;<final> 0646 062D 0649;;;;N;;;;;
FD97;ARABIC LIGATURE NOON WITH JEEM WITH MEEM FINAL FORM;Lo;0;AL;<final> 0646 062C 0645;;;;N;;;;;
FD98;ARABIC LIGATURE NOON WITH JEEM WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 0646 062C 0645;;;;N;;;;;
FD99;ARABIC LIGATURE NOON WITH JEEM WITH ALEF MAKSURA FINAL FORM;Lo;0;AL;<final> 0646 062C 0649;;;;N;;;;;
FD9A;ARABIC LIGATURE NOON WITH MEEM WITH YEH FINAL FORM;Lo;0;AL;<final> 0646 0645 064A;;;;N;;;;;
FD9B;ARABIC LIGATURE NOON WITH MEEM WITH ALEF MAKSURA FINAL FORM;Lo;0;AL;<final> 0646 0645 0649;;;;N;;;;;
FD9C;ARABIC LIGATURE YEH WITH MEEM WITH MEEM FINAL FORM;Lo;0;AL;<final> 064A 0645 0645;;;;N;;;;;
FD9D;ARABIC LIGATURE YEH WITH MEEM WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 064A 0645 0645;;;;N;;;;;
FD9E;ARABIC LIGATURE BEH WITH KHAH WITH YEH FINAL FORM;Lo;0;AL;<final> 0628 062E 064A;;;;N;;;;;
FD9F;ARABIC LIGATURE TEH WITH JEEM WITH YEH FINAL FORM;Lo;0;AL;<final> 062A 062C 064A;;;;N;;;;;
FDA0;ARABIC LIGATURE TEH WITH JEEM WITH ALEF MAKSURA FINAL FORM;Lo;0;AL;<final> 062A 062C 0649;;;;N;;;;;
FDA1;ARABIC LIGATURE TEH WITH KHAH WITH YEH FINAL FORM;Lo;0;AL;<final> 062A 062E 064A;;;;N;;;;;
FDA2;ARABIC LIGATURE TEH WITH KHAH WITH ALEF MAKSURA FINAL FORM;Lo;0;AL;<final> 062A 062E 0649;;;;N;;;;;
FDA3;ARABIC LIGATURE TEH WITH MEEM WITH YEH FINAL FORM;Lo;0;AL;<final> 062A 0645 064A;;;;N;;;;;
FDA4;ARABIC LIGATURE TEH WITH MEEM WITH ALEF MAKSURA FINAL FORM;Lo;0;AL;<final> 062A 0645 0649;;;;N;;;;;
FDA5;ARABIC LIGATURE JEEM WITH MEEM WITH YEH FINAL FORM;Lo;0;AL;<final> 062C 0645 064A;;;;N;;;;;
FDA6;ARABIC LIGATURE JEEM WITH HAH WITH ALEF MAKSURA FINAL FORM;Lo;0;AL;<final> 062C 062D 0649;;;;N;;;;;
FDA7;ARABIC LIGATURE JEEM WITH MEEM WITH ALEF MAKSURA FINAL FORM;Lo;0;AL;<final> 062C 0645 0649;;;;N;;;;;
FDA8;ARABIC LIGATURE SEEN WITH KHAH WITH ALEF MAKSURA FINAL FORM;Lo;0;AL;<final> 0633 062E 0649;;;;N;;;;;
FDA9;ARABIC LIGATURE SAD WITH HAH WITH YEH FINAL FORM;Lo;0;AL;<final> 0635 062D 064A;;;;N;;;;;
FDAA;ARABIC LIGATURE SHEEN WITH HAH WITH YEH FINAL FORM;Lo;0;AL;<final> 0634 062D 064A;;;;N;;;;;
FDAB;ARABIC LIGATURE DAD WITH HAH WITH YEH FINAL FORM;Lo;0;AL;<final> 0636 062D 064A;;;;N;;;;;
FDAC;ARABIC LIGATURE LAM WITH JEEM WITH YEH FINAL FORM;Lo;0;AL;<final> 0644 062C 064A;;;;N;;;;;
FDAD;ARABIC LIGATURE LAM WITH MEEM WITH YEH FINAL FORM;Lo;0;AL;<final> 0644 0645 064A;;;;N;;;;;
FDAE;ARABIC LIGATURE YEH WITH HAH WITH YEH FINAL FORM;Lo;0;AL;<final> 064A 062D 064A;;;;N;;;;;
FDAF;ARABIC LIGATURE YEH WITH JEEM WITH YEH FINAL FORM;Lo;0;AL;<final> 064A 062C 064A;;;;N;;;;;
FDB0;ARABIC LIGATURE YEH WITH MEEM WITH YEH FINAL FORM;Lo;0;AL;<final> 064A 0645 064A;;;;N;;;;;
FDB1;ARABIC LIGATURE MEEM WITH MEEM WITH YEH FINAL FORM;Lo;0;AL;<final> 0645 0645 064A;;;;N;;;;;
FDB2;ARABIC LIGATURE QAF WITH MEEM WITH YEH FINAL FORM;Lo;0;AL;<final> 0642 0645 064A;;;;N;;;;;
FDB3;ARABIC LIGATURE NOON WITH HAH WITH YEH FINAL FORM;Lo;0;AL;<final> 0646 062D 064A;;;;N;;;;;
FDB4;ARABIC LIGATURE QAF WITH MEEM WITH HAH INITIAL FORM;Lo;0;AL;<initial> 0642 0645 062D;;;;N;;;;;
FDB5;ARABIC LIGATURE LAM WITH HAH WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 0644 062D 0645;;;;N;;;;;
FDB6;ARABIC LIGATURE AIN WITH MEEM WITH YEH FINAL FORM;Lo;0;AL;<final> 0639 0645 064A;;;;N;;;;;
FDB7;ARABIC LIGATURE KAF WITH MEEM WITH YEH FINAL FORM;Lo;0;AL;<final> 0643 0645 064A;;;;N;;;;;
FDB8;ARABIC LIGATURE NOON WITH JEEM WITH HAH INITIAL FORM;Lo;0;AL;<initial> 0646 062C 062D;;;;N;;;;;
FDB9;ARABIC LIGATURE MEEM WITH KHAH WITH YEH FINAL FORM;Lo;0;AL;<final> 0645 062E 064A;;;;N;;;;;
FDBA;ARABIC LIGATURE LAM WITH JEEM WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 0644 062C 0645;;;;N;;;;;
FDBB;ARABIC LIGATURE KAF WITH MEEM WITH MEEM FINAL FORM;Lo;0;AL;<final> 0643 0645 0645;;;;N;;;;;
FDBC;ARABIC LIGATURE LAM WITH JEEM WITH MEEM FINAL FORM;Lo;0;AL;<final> 0644 062C 0645;;;;N;;;;;
FDBD;ARABIC LIGATURE NOON WITH JEEM WITH HAH FINAL FORM;Lo;0;AL;<final> 0646 062C 062D;;;;N;;;;;
FDBE;ARABIC LIGATURE JEEM WITH HAH WITH YEH FINAL FORM;Lo;0;AL;<final> 062C 062D 064A;;;;N;;;;;
FDBF;ARABIC LIGATURE HAH WITH JEEM WITH YEH FINAL FORM;Lo;0;AL;<final> 062D 062C 064A;;;;N;;;;;
FDC0;ARABIC LIGATURE MEEM WITH JEEM WITH YEH FINAL FORM;Lo;0;AL;<final> 0645 062C 064A;;;;N;;;;;
FDC1;ARABIC LIGATURE FEH WITH MEEM WITH YEH FINAL FORM;Lo;0;AL;<final> 0641 0645 064A;;;;N;;;;;
FDC2;ARABIC LIGATURE BEH WITH HAH WITH YEH FINAL FORM;Lo;0;AL;<final> 0628 062D 064A;;;;N;;;;;
FDC3;ARABIC LIGATURE KAF WITH MEEM WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 0643 0645 0645;;;;N;;;;;
FDC4;ARABIC LIGATURE AIN WITH JEEM WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 0639 062C 0645;;;;N;;;;;
FDC5;ARABIC LIGATURE SAD WITH MEEM WITH MEEM INITIAL FORM;Lo;0;AL;<initial> 0635 0645 0645;;;;N;;;;;
FDC6;ARABIC LIGATURE SEEN WITH KHAH WITH YEH FINAL FORM;Lo;0;AL;<final> 0633 062E 064A;;;;N;;;;;
FDC7;ARABIC LIGATURE NOON WITH JEEM WITH YEH FINAL FORM;Lo;0;AL;<final> 0646 062C 064A;;;;N;;;;;
FDCF;ARABIC LIGATURE SALAAMUHU ALAYNAA;So;0;ON;;;;;N;;;;;
FDF0;ARABIC LIGATURE SALLA USED AS KORANIC STOP SIGN ISOLATED FORM;Lo;0;AL;<isolated> 0635 0644 06D2;;;;N;;;;;
FDF1;ARABIC LIGATURE QALA USED AS KORANIC STOP SIGN ISOLATED FORM;Lo;0;AL;<isolated> 0642 0644 06D2;;;;N;;;;;
FDF2;ARABIC LIGATURE ALLAH ISOLATED FORM;Lo;0;AL;<isolated> 0627 0644 0644 0647;;;;N;;;;;
FDF3;ARABIC LIGATURE AKBAR ISOLATED FORM;Lo;0;AL;<isolated> 0627 0643 0628 0631;;;;N;;;;;
FDF4;ARABIC LIGATURE MOHAMMAD ISOLATED FORM;Lo;0;AL;<isolated> 0645 062D 0645 062F;;;;N;;;;;
FDF5;ARABIC LIGATURE SALAM ISOLATED FORM;Lo;0;AL;<isolated> 0635 0644 0639 0645;;;;N;;;;;
FDF6;ARABIC LIGATURE RASOUL ISOLATED FORM;Lo;0;AL;<isolated> 0631 0633 0648 0644;;;;N;;;;;
FDF7;ARABIC LIGATURE ALAYHE ISOLATED FORM;Lo;0;AL;<isolated> 0639 0644 064A 0647;;;;N;;;;;
FDF8;ARABIC LIGATURE WASALLAM ISOLATED FORM;Lo;0;AL;<isolated> 0648 0633 0644 0645;;;;N;;;;;
FDF9;ARABIC LIGATURE SALLA ISOLATED FORM;Lo;0;AL;<isolated> 0635 0644 0649;;;;N;;;;;
FDFA;ARABIC LIGATURE SALLALLAHOU ALAYHE WASALLAM;Lo;0;AL;<isolated> 0635 0644 0649 0020 0627 0644 0644 0647 0020 0639 0644 064A 0647 0020 0648 0633 0644 0645;;;;N;ARABIC LETTER SALLALLAHOU ALAYHE WASALLAM;;;;
FDFB;ARABIC LIGATURE JALLAJALALOUHOU;Lo;0;AL;<isolated> 062C 0644 0020 062C 0644 0627 0644 0647;;;;N;ARABIC LETTER JALLAJALALOUHOU;;;;
FDFC;RIAL SIGN;Sc;0;AL;<isolated> 0631 06CC 0627 0644;;;;N;;;;;
FDFD;ARABIC LIGATURE BISMILLAH AR-RAHMAN AR-RAHEEM;So;0;ON;;;;;N;;;;;
FDFE;ARABIC LIGATURE SUBHAANAHU WA TAAALAA;So;0;ON;;;;;N;;;;;
FDFF;ARABIC LIGATURE AZZA WA JALL;So;0;ON;;;;;N;;;;;
FE00;VARIATION SELECTOR-1;Mn;0;NSM;;;;;N;;;;;
FE01;VARIATION SELECTOR-2;Mn;0;NSM;;;;;N;;;;;
FE02;VARIATION SELECTOR-3;Mn;0;NSM;;;;;N;;;;;
FE03;VARIATION SELECTOR-4;Mn;0;NSM;;;;;N;;;;;
FE04;VARIATION SELECTOR-5;Mn;0;NSM;;;;;N;;;;;
FE05;VARIATION SELECTOR-6;Mn;0;NSM;;;;;N;;;;;
FE06;VARIATION SELECTOR-7;Mn;0;NSM;;;;;N;;;;;
FE07;VARIATION SELECTOR-8;Mn;0;NSM;;;;;N;;;;;
FE08;VARIATION SELECTOR-9;Mn;0;NSM;;;;;N;;;;;
FE09;VARIATION SELECTOR-10;Mn;0;NSM;;;;;N;;;;;
FE0A;VARIATION SELECTOR-11;Mn;0;NSM;;;;;N;;;;;
FE0B;VARIATION SELECTOR-12;Mn;0;NSM;;;;;N;;;;;
FE0C;VARIATION SELECTOR-13;Mn;0;NSM;;;;;N;;;;;
FE0D;VARIATION SELECTOR-14;Mn;0;NSM;;;;;N;;;;;
FE0E;VARIATION SELECTOR-15;Mn;0;NSM;;;;;N;;;;;
FE0F;VARIATION SELECTOR-16;Mn;0;NSM;;;;;N;;;;;
FE10;PRESENTATION FORM FOR VERTICAL COMMA;Po;0;ON;<vertical> 002C;;;;N;;;;;
FE11;PRESENTATION FORM FOR VERTICAL IDEOGRAPHIC COMMA;Po;0;ON;<vertical> 3001;;;;N;;;;;
FE12;PRESENTATION FORM FOR VERTICAL IDEOGRAPHIC FULL STOP;Po;0;ON;<vertical> 3002;;;;N;;;;;
FE13;PRESENTATION FORM FOR VERTICAL COLON;Po;0;ON;<vertical> 003A;;;;N;;;;;
FE14;PRESENTATION FORM FOR VERTICAL SEMICOLON;Po;0;ON;<vertical> 003B;;;;N;;;;;
FE15;PRESENTATION FORM FOR VERTICAL EXCLAMATION MARK;Po;0;ON;<vertical> 0021;;;;N;;;;;
FE16;PRESENTATION FORM FOR VERTICAL QUESTION MARK;Po;0;ON;<vertical> 003F;;;;N;;;;;
FE17;PRESENTATION FORM FOR VERTICAL LEFT WHITE LENTICULAR BRACKET;Ps;0;ON;<vertical> 3016;;;;N;;;;;
FE18;PRESENTATION FORM FOR VERTICAL RIGHT WHITE LENTICULAR BRAKCET;Pe;0;ON;<vertical> 3017;;;;N;;;;;
FE19;PRESENTATION FORM FOR VERTICAL HORIZONTAL ELLIPSIS;Po;0;ON;<vertical> 2026;;;;N;;;;;
FE20;COMBINING LIGATURE LEFT HALF;Mn;230;NSM;;;;;N;;;;;
FE21;COMBINING LIGATURE RIGHT HALF;Mn;230;NSM;;;;;N;;;;;
FE22;COMBINING DOUBLE TILDE LEFT HALF;Mn;230;NSM;;;;;N;;;;;
FE23;COMBINING DOUBLE TILDE RIGHT HALF;Mn;230;NSM;;;;;N;;;;;
FE24;COMBINING MACRON LEFT HALF;Mn;230;NSM;;;;;N;;;;;
FE25;COMBINING MACRON RIGHT HALF;Mn;230;NSM;;;;;N;;;;;
FE26;COMBINING CONJOINING MACRON;Mn;230;NSM;;;;;N;;;;;
FE27;COMBINING LIGATURE LEFT HALF BELOW;Mn;220;NSM;;;;;N;;;;;
FE28;COMBINING LIGATURE RIGHT HALF BELOW;Mn;220;NSM;;;;;N;;;;;
FE29;COMBINING TILDE LEFT HALF BELOW;Mn;220;NSM;;;;;N;;;;;
FE2A;COMBINING TILDE RIGHT HALF BELOW;Mn;220;NSM;;;;;N;;;;;
FE2B;COMBINING MACRON LEFT HALF BELOW;Mn;220;NSM;;;;;N;;;;;
FE2C;COMBINING MACRON RIGHT HALF BELOW;Mn;220;NSM;;;;;N;;;;;
FE2D;COMBINING CONJOINING MACRON BELOW;Mn;220;NSM;;;;;N;;;;;
FE2E;COMBINING CYRILLIC TITLO LEFT HALF;Mn;230;NSM;;;;;N;;;;;
FE2F;COMBINING CYRILLIC TITLO RIGHT HALF;Mn;230;NSM;;;;;N;;;;;
FE30;PRESENTATION FORM FOR VERTICAL TWO DOT LEADER;Po;0;ON;<vertical> 2025;;;;N;GLYPH FOR VERTICAL TWO DOT LEADER;;;;
FE31;PRESENTATION FORM FOR VERTICAL EM DASH;Pd;0;ON;<vertical> 2014;;;;N;GLYPH FOR VERTICAL EM DASH;;;;
FE32;PRESENTATION FORM FOR VERTICAL EN DASH;Pd;0;ON;<vertical> 2013;;;;N;GLYPH FOR VERTICAL EN DASH;;;;
FE33;PRESENTATION FORM FOR VERTICAL LOW LINE;Pc;0;ON;<vertical> 005F;;;;N;GLYPH FOR VERTICAL SPACING UNDERSCORE;;;;
FE34;PRESENTATION FORM FOR VERTICAL WAVY LOW LINE;Pc;0;ON;<vertical> 005F;;;;N;GLYPH FOR VERTICAL SPACING WAVY UNDERSCORE;;;;
FE35;PRESENTATION FORM FOR VERTICAL LEFT PARENTHESIS;Ps;0;ON;<vertical> 0028;;;;N;GLYPH FOR VERTICAL OPENING PARENTHESIS;;;;
FE36;PRESENTATION FORM FOR VERTICAL RIGHT PARENTHESIS;Pe;0;ON;<vertical> 0029;;;;N;GLYPH FOR VERTICAL CLOSING PARENTHESIS;;;;
FE37;PRESENTATION FORM FOR VERTICAL LEFT CURLY BRACKET;Ps;0;ON;<vertical> 007B;;;;N;GLYPH FOR VERTICAL OPENING CURLY BRACKET;;;;
FE38;PRESENTATION FORM FOR VERTICAL RIGHT CURLY BRACKET;Pe;0;ON;<vertical> 007D;;;;N;GLYPH FOR VERTICAL CLOSING CURLY BRACKET;;;;
FE39;PRESENTATION FORM FOR VERTICAL LEFT TORTOISE SHELL BRACKET;Ps;0;ON;<vertical> 3014;;;;N;GLYPH FOR VERTICAL OPENING TORTOISE SHELL BRACKET;;;;
FE3A;PRESENTATION FORM FOR VERTICAL RIGHT TORTOISE SHELL BRACKET;Pe;0;ON;<vertical> 3015;;;;N;GLYPH FOR VERTICAL CLOSING TORTOISE SHELL BRACKET;;;;
FE3B;PRESENTATION FORM FOR VERTICAL LEFT BLACK LENTICULAR BRACKET;Ps;0;ON;<vertical> 3010;;;;N;GLYPH FOR VERTICAL OPENING BLACK LENTICULAR BRACKET;;;;
FE3C;PRESENTATION FORM FOR VERTICAL RIGHT BLACK LENTICULAR BRACKET;Pe;0;ON;<vertical> 3011;;;;N;GLYPH FOR VERTICAL CLOSING BLACK LENTICULAR BRACKET;;;;
FE3D;PRESENTATION FORM FOR VERTICAL LEFT DOUBLE ANGLE BRACKET;Ps;0;ON;<vertical> 300A;;;;N;GLYPH FOR VERTICAL OPENING DOUBLE ANGLE BRACKET;;;;
FE3E;PRESENTATION FORM FOR VERTICAL RIGHT DOUBLE ANGLE BRACKET;Pe;0;ON;<vertical> 300B;;;;N;GLYPH FOR VERTICAL CLOSING DOUBLE ANGLE BRACKET;;;;
FE3F;PRESENTATION FORM FOR VERTICAL LEFT ANGLE BRACKET;Ps;0;ON;<vertical> 3008;;;;N;GLYPH FOR VERTICAL OPENING ANGLE BRACKET;;;;
FE40;PRESENTATION FORM FOR VERTICAL RIGHT ANGLE BRACKET;Pe;0;ON;<vertical> 3009;;;;N;GLYPH FOR VERTICAL CLOSING ANGLE BRACKET;;;;
FE41;PRESENTATION FORM FOR VERTICAL LEFT CORNER BRACKET;Ps;0;ON;<vertical> 300C;;;;N;GLYPH FOR VERTICAL OPENING CORNER BRACKET;;;;
FE42;PRESENTATION FORM FOR VERTICAL RIGHT CORNER BRACKET;Pe;0;ON;<vertical> 300D;;;;N;GLYPH FOR VERTICAL CLOSING CORNER BRACKET;;;;
FE43;PRESENTATION FORM FOR VERTICAL LEFT WHITE CORNER BRACKET;Ps;0;ON;<vertical> 300E;;;;N;GLYPH FOR VERTICAL OPENING WHITE CORNER BRACKET;;;;
FE44;PRESENTATION FORM FOR VERTICAL RIGHT WHITE CORNER BRACKET;Pe;0;ON;<vertical> 300F;;;;N;GLYPH FOR VERTICAL CLOSING WHITE CORNER BRACKET;;;;
FE45;SESAME DOT;Po;0;ON;;;;;N;;;;;
FE46;WHITE SESAME DOT;Po;0;ON;;;;;N;;;;;
FE47;PRESENTATION FORM FOR VERTICAL LEFT SQUARE BRACKET;Ps;0;ON;<vertical> 005B;;;;N;;;;;
FE48;PRESENTATION FORM FOR VERTICAL RIGHT SQUARE BRACKET;Pe;0;ON;<vertical> 005D;;;;N;;;;;
FE49;DASHED OVERLINE;Po;0;ON;<compat> 203E;;;;N;SPACING DASHED OVERSCORE;;;;
FE4A;CENTRELINE OVERLINE;Po;0;ON;<compat> 203E;;;;N;SPACING CENTERLINE OVERSCORE;;;;
FE4B;WAVY OVERLINE;Po;0;ON;<compat> 203E;;;;N;SPACING WAVY OVERSCORE;;;;
FE4C;DOUBLE WAVY OVERLINE;Po;0;ON;<compat> 203E;;;;N;SPACING DOUBLE WAVY OVERSCORE;;;;
FE4D;DASHED LOW LINE;Pc;0;ON;<compat> 005F;;;;N;SPACING DASHED UNDERSCORE;;;;
FE4E;CENTRELINE LOW LINE;Pc;0;ON;<compat> 005F;;;;N;SPACING CENTERLINE UNDERSCORE;;;;
FE4F;WAVY LOW LINE;Pc;0;ON;<compat> 005F;;;;N;SPACING WAVY UNDERSCORE;;;;
FE50;SMALL COMMA;Po;0;CS;<small> 002C;;;;N;;;;;
FE51;SMALL IDEOGRAPHIC COMMA;Po;0;ON;<small> 3001;;;;N;;;;;
FE52;SMALL FULL STOP;Po;0;CS;<small> 002E;;;;N;SMALL PERIOD;;;;
FE54;SMALL SEMICOLON;Po;0;ON;<small> 003B;;;;N;;;;;
FE55;SMALL COLON;Po;0;CS;<small> 003A;;;;N;;;;;
FE56;SMALL QUESTION MARK;Po;0;ON;<small> 003F;;;;N;;;;;
FE57;SMALL EXCLAMATION MARK;Po;0;ON;<small> 0021;;;;N;;;;;
FE58;SMALL EM DASH;Pd;0;ON;<small> 2014;;;;N;;;;;
FE59;SMALL LEFT PARENTHESIS;Ps;0;ON;<small> 0028;;;;Y;SMALL OPENING PARENTHESIS;;;;
FE5A;SMALL RIGHT PARENTHESIS;Pe;0;ON;<small> 0029;;;;Y;SMALL CLOSING PARENTHESIS;;;;
FE5B;SMALL LEFT CURLY BRACKET;Ps;0;ON;<small> 007B;;;;Y;SMALL OPENING CURLY BRACKET;;;;
FE5C;SMALL RIGHT CURLY BRACKET;Pe;0;ON;<small> 007D;;;;Y;SMALL CLOSING CURLY BRACKET;;;;
FE5D;SMALL LEFT TORTOISE SHELL BRACKET;Ps;0;ON;<small> 3014;;;;Y;SMALL OPENING TORTOISE SHELL BRACKET;;;;
FE5E;SMALL RIGHT TORTOISE SHELL BRACKET;Pe;0;ON;<small> 3015;;;;Y;SMALL CLOSING TORTOISE SHELL BRACKET;;;;
FE5F;SMALL NUMBER SIGN;Po;0;ET;<small> 0023;;;;N;;;;;
FE60;SMALL AMPERSAND;Po;0;ON;<small> 0026;;;;N;;;;;
FE61;SMALL ASTERISK;Po;0;ON;<small> 002A;;;;N;;;;;
FE62;SMALL PLUS SIGN;Sm;0;ES;<small> 002B;;;;N;;;;;
FE63;SMALL HYPHEN-MINUS;Pd;0;ES;<small> 002D;;;;N;;;;;
FE64;SMALL LESS-THAN SIGN;Sm;0;ON;<small> 003C;;;;Y;;;;;
FE65;SMALL GREATER-THAN SIGN;Sm;0;ON;<small> 003E;;;;Y;;;;;
FE66;SMALL EQUALS SIGN;Sm;0;ON;<small> 003D;;;;N;;;;;
FE68;SMALL REVERSE SOLIDUS;Po;0;ON;<small> 005C;;;;N;SMALL BACKSLASH;;;;
FE69;SMALL DOLLAR SIGN;Sc;0;ET;<small> 0024;;;;N;;;;;
FE6A;SMALL PERCENT SIGN;Po;0;ET;<small> 0025;;;;N;;;;;
FE6B;SMALL COMMERCIAL AT;Po;0;ON;<small> 0040;;;;N;;;;;
FE70;ARABIC FATHATAN ISOLATED FORM;Lo;0;AL;<isolated> 0020 064B;;;;N;ARABIC SPACING FATHATAN;;;;
FE71;ARABIC TATWEEL WITH FATHATAN ABOVE;Lo;0;AL;<medial> 0640 064B;;;;N;ARABIC FATHATAN ON TATWEEL;;;;
FE72;ARABIC DAMMATAN ISOLATED FORM;Lo;0;AL;<isolated> 0020 064C;;;;N;ARABIC SPACING DAMMATAN;;;;
FE73;ARABIC TAIL FRAGMENT;Lo;0;AL;;;;;N;;;;;
FE74;ARABIC KASRATAN ISOLATED FORM;Lo;0;AL;<isolated> 0020 064D;;;;N;ARABIC SPACING KASRATAN;;;;
FE76;ARABIC FATHA ISOLATED FORM;Lo;0;AL;<isolated> 0020 064E;;;;N;ARABIC SPACING FATHAH;;;;
FE77;ARABIC FATHA MEDIAL FORM;Lo;0;AL;<medial> 0640 064E;;;;N;ARABIC FATHAH ON TATWEEL;;;;
FE78;ARABIC DAMMA ISOLATED FORM;Lo;0;AL;<isolated> 0020 064F;;;;N;ARABIC SPACING DAMMAH;;;;
FE79;ARABIC DAMMA MEDIAL FORM;Lo;0;AL;<medial> 0640 064F;;;;N;ARABIC DAMMAH ON TATWEEL;;;;
FE7A;ARABIC KASRA ISOLATED FORM;Lo;0;AL;<isolated> 0020 0650;;;;N;ARABIC SPACING KASRAH;;;;
FE7B;ARABIC KASRA MEDIAL FORM;Lo;0;AL;<medial> 0640 0650;;;;N;ARABIC KASRAH ON TATWEEL;;;;
FE7C;ARABIC SHADDA ISOLATED FORM;Lo;0;AL;<isolated> 0020 0651;;;;N;ARABIC SPACING SHADDAH;;;;
FE7D;ARABIC SHADDA MEDIAL FORM;Lo;0;AL;<medial> 0640 0651;;;;N;ARABIC SHADDAH ON TATWEEL;;;;
FE7E;ARABIC SUKUN ISOLATED FORM;Lo;0;AL;<isolated> 0020 0652;;;;N;ARABIC SPACING SUKUN;;;;
FE7F;ARABIC SUKUN MEDIAL FORM;Lo;0;AL;<medial> 0640 0652;;;;N;ARABIC SUKUN ON TATWEEL;;;;
FE80;ARABIC LETTER HAMZA ISOLATED FORM;Lo;0;AL;<isolated> 0621;;;;N;GLYPH FOR ISOLATE ARABIC HAMZAH;;;;
FE81;ARABIC LETTER ALEF WITH MADDA ABOVE ISOLATED FORM;Lo;0;AL;<isolated> 0622;;;;N;GLYPH FOR ISOLATE ARABIC MADDAH ON ALEF;;;;
FE82;ARABIC LETTER ALEF WITH MADDA ABOVE FINAL FORM;Lo;0;AL;<final> 0622;;;;N;GLYPH FOR FINAL ARABIC MADDAH ON ALEF;;;;
FE83;ARABIC LETTER ALEF WITH HAMZA ABOVE ISOLATED FORM;Lo;0;AL;<isolated> 0623;;;;N;GLYPH FOR ISOLATE ARABIC HAMZAH ON ALEF;;;;
FE84;ARABIC LETTER ALEF WITH HAMZA ABOVE FINAL FORM;Lo;0;AL;<final> 0623;;;;N;GLYPH FOR FINAL ARABIC HAMZAH ON ALEF;;;;
FE85;ARABIC LETTER WAW WITH HAMZA ABOVE ISOLATED FORM;Lo;0;AL;<isolated> 0624;;;;N;GLYPH FOR ISOLATE ARABIC HAMZAH ON WAW;;;;
FE86;ARABIC LETTER WAW WITH HAMZA ABOVE FINAL FORM;Lo;0;AL;<final> 0624;;;;N;GLYPH FOR FINAL ARABIC HAMZAH ON WAW;;;;
FE87;ARABIC LETTER ALEF WITH HAMZA BELOW ISOLATED FORM;Lo;0;AL;<isolated> 0625;;;;N;GLYPH FOR ISOLATE ARABIC HAMZAH UNDER ALEF;;;;
FE88;ARABIC LETTER ALEF WITH HAMZA BELOW FINAL FORM;Lo;0;AL;<final> 0625;;;;N;GLYPH FOR FINAL ARABIC HAMZAH UNDER ALEF;;;;
FE89;ARABIC LETTER YEH WITH HAMZA ABOVE ISOLATED FORM;Lo;0;AL;<isolated> 0626;;;;N;GLYPH FOR ISOLATE ARABIC HAMZAH ON YA;;;;
FE8A;ARABIC LETTER YEH WITH HAMZA ABOVE FINAL FORM;Lo;0;AL;<final> 0626;;;;N;GLYPH FOR FINAL ARABIC HAMZAH ON YA;;;;
FE8B;ARABIC LETTER YEH WITH HAMZA ABOVE INITIAL FORM;Lo;0;AL;<initial> 0626;;;;N;GLYPH FOR INITIAL ARABIC HAMZAH ON YA;;;;
FE8C;ARABIC LETTER YEH WITH HAMZA ABOVE MEDIAL FORM;Lo;0;AL;<medial> 0626;;;;N;GLYPH FOR MEDIAL ARABIC HAMZAH ON YA;;;;
FE8D;ARABIC LETTER ALEF ISOLATED FORM;Lo;0;AL;<isolated> 0627;;;;N;GLYPH FOR ISOLATE ARABIC ALEF;;;;
FE8E;ARABIC LETTER ALEF FINAL FORM;Lo;0;AL;<final> 0627;;;;N;GLYPH FOR FINAL ARABIC ALEF;;;;
FE8F;ARABIC LETTER BEH ISOLATED FORM;Lo;0;AL;<isolated> 0628;;;;N;GLYPH FOR ISOLATE ARABIC BAA;;;;
FE90;ARABIC LETTER BEH FINAL FORM;Lo;0;AL;<final> 0628;;;;N;GLYPH FOR FINAL ARABIC BAA;;;;
FE91;ARABIC LETTER BEH INITIAL FORM;Lo;0;AL;<initial> 0628;;;;N;GLYPH FOR INITIAL ARABIC BAA;;;;
FE92;ARABIC LETTER BEH MEDIAL FORM;Lo;0;AL;<medial> 0628;;;;N;GLYPH FOR MEDIAL ARABIC BAA;;;;
FE93;ARABIC LETTER TEH MARBUTA ISOLATED FORM;Lo;0;AL;<isolated> 0629;;;;N;GLYPH FOR ISOLATE ARABIC TAA MARBUTAH;;;;
FE94;ARABIC LETTER TEH MARBUTA FINAL FORM;Lo;0;AL;<final> 0629;;;;N;GLYPH FOR FINAL ARABIC TAA MARBUTAH;;;;
FE95;ARABIC LETTER TEH ISOLATED FORM;Lo;0;AL;<isolated> 062A;;;;N;GLYPH FOR ISOLATE ARABIC TAA;;;;
FE96;ARABIC LETTER TEH FINAL FORM;Lo;0;AL;<final> 062A;;;;N;GLYPH FOR FINAL ARABIC TAA;;;;
FE97;ARABIC LETTER TEH INITIAL FORM;Lo;0;AL;<initial> 062A;;;;N;GLYPH FOR INITIAL ARABIC TAA;;;;
FE98;ARABIC LETTER TEH MEDIAL FORM;Lo;0;AL;<medial> 062A;;;;N;GLYPH FOR MEDIAL ARABIC TAA;;;;
FE99;ARABIC LETTER THEH ISOLATED FORM;Lo;0;AL;<isolated> 062B;;;;N;GLYPH FOR ISOLATE ARABIC THAA;;;;
FE9A;ARABIC LETTER THEH FINAL FORM;Lo;0;AL;<final> 062B;;;;N;GLYPH FOR FINAL ARABIC THAA;;;;
FE9B;ARABIC LETTER THEH INITIAL FORM;Lo;0;AL;<initial> 062B;;;;N;GLYPH FOR INITIAL ARABIC THAA;;;;
FE9C;ARABIC LETTER THEH MEDIAL FORM;Lo;0;AL;<medial> 062B;;;;N;GLYPH FOR MEDIAL ARABIC THAA;;;;
FE9D;ARABIC LETTER JEEM ISOLATED FORM;Lo;0;AL;<isolated> 062C;;;;N;GLYPH FOR ISOLATE ARABIC JEEM;;;;
FE9E;ARABIC LETTER JEEM FINAL FORM;Lo;0;AL;<final> 062C;;;;N;GLYPH FOR FINAL ARABIC JEEM;;;;
FE9F;ARABIC LETTER JEEM INITIAL FORM;Lo;0;AL;<initial> 062C;;;;N;GLYPH FOR INITIAL ARABIC JEEM;;;;
FEA0;ARABIC LETTER JEEM MEDIAL FORM;Lo;0;AL;<medial> 062C;;;;N;GLYPH FOR MEDIAL ARABIC JEEM;;;;
FEA1;ARABIC LETTER HAH ISOLATED FORM;Lo;0;AL;<isolated> 062D;;;;N;GLYPH FOR ISOLATE ARABIC HAA;;;;
FEA2;ARABIC LETTER HAH FINAL FORM;Lo;0;AL;<final> 062D;;;;N;GLYPH FOR FINAL ARABIC HAA;;;;
FEA3;ARABIC LETTER HAH INITIAL FORM;Lo;0;AL;<initial> 062D;;;;N;GLYPH FOR INITIAL ARABIC HAA;;;;
FEA4;ARABIC LETTER HAH MEDIAL FORM;Lo;0;AL;<medial> 062D;;;;N;GLYPH FOR MEDIAL ARABIC HAA;;;;
FEA5;ARABIC LETTER KHAH ISOLATED FORM;Lo;0;AL;<isolated> 062E;;;;N;GLYPH FOR ISOLATE ARABIC KHAA;;;;
FEA6;ARABIC LETTER KHAH FINAL FORM;Lo;0;AL;<final> 062E;;;;N;GLYPH FOR FINAL ARABIC KHAA;;;;
FEA7;ARABIC LETTER KHAH INITIAL FORM;Lo;0;AL;<initial> 062E;;;;N;GLYPH FOR INITIAL ARABIC KHAA;;;;
FEA8;ARABIC LETTER KHAH MEDIAL FORM;Lo;0;AL;<medial> 062E;;;;N;GLYPH FOR MEDIAL ARABIC KHAA;;;;
FEA9;ARABIC LETTER DAL ISOLATED FORM;Lo;0;AL;<isolated> 062F;;;;N;GLYPH FOR ISOLATE ARABIC DAL;;;;
FEAA;ARABIC LETTER DAL FINAL FORM;Lo;0;AL;<final> 062F;;;;N;GLYPH FOR FINAL ARABIC DAL;;;;
FEAB;ARABIC LETTER THAL ISOLATED FORM;Lo;0;AL;<isolated> 0630;;;;N;GLYPH FOR ISOLATE ARABIC THAL;;;;
FEAC;ARABIC LETTER THAL FINAL FORM;Lo;0;AL;<final> 0630;;;;N;GLYPH FOR FINAL ARABIC THAL;;;;
FEAD;ARABIC LETTER REH ISOLATED FORM;Lo;0;AL;<isolated> 0631;;;;N;GLYPH FOR ISOLATE ARABIC RA;;;;
FEAE;ARABIC LETTER REH FINAL FORM;Lo;0;AL;<final> 0631;;;;N;GLYPH FOR FINAL ARABIC RA;;;;
FEAF;ARABIC LETTER ZAIN ISOLATED FORM;Lo;0;AL;<isolated> 0632;;;;N;GLYPH FOR ISOLATE ARABIC ZAIN;;;;
FEB0;ARABIC LETTER ZAIN FINAL FORM;Lo;0;AL;<final> 0632;;;;N;GLYPH FOR FINAL ARABIC ZAIN;;;;
FEB1;ARABIC LETTER SEEN ISOLATED FORM;Lo;0;AL;<isolated> 0633;;;;N;GLYPH FOR ISOLATE ARABIC SEEN;;;;
FEB2;ARABIC LETTER SEEN FINAL FORM;Lo;0;AL;<final> 0633;;;;N;GLYPH FOR FINAL ARABIC SEEN;;;;
FEB3;ARABIC LETTER SEEN INITIAL FORM;Lo;0;AL;<initial> 0633;;;;N;GLYPH FOR INITIAL ARABIC SEEN;;;;
FEB4;ARABIC LETTER SEEN MEDIAL FORM;Lo;0;AL;<medial> 0633;;;;N;GLYPH FOR MEDIAL ARABIC SEEN;;;;
FEB5;ARABIC LETTER SHEEN ISOLATED FORM;Lo;0;AL;<isolated> 0634;;;;N;GLYPH FOR ISOLATE ARABIC SHEEN;;;;
FEB6;ARABIC LETTER SHEEN FINAL FORM;Lo;0;AL;<final> 0634;;;;N;GLYPH FOR FINAL ARABIC SHEEN;;;;
FEB7;ARABIC LETTER SHEEN INITIAL FORM;Lo;0;AL;<initial> 0634;;;;N;GLYPH FOR INITIAL ARABIC SHEEN;;;;
FEB8;ARABIC LETTER SHEEN MEDIAL FORM;Lo;0;AL;<medial> 0634;;;;N;GLYPH FOR MEDIAL ARABIC SHEEN;;;;
FEB9;ARABIC LETTER SAD ISOLATED FORM;Lo;0;AL;<isolated> 0635;;;;N;GLYPH FOR ISOLATE ARABIC SAD;;;;
FEBA;ARABIC LETTER SAD FINAL FORM;Lo;0;AL;<final> 0635;;;;N;GLYPH FOR FINAL ARABIC SAD;;;;
FEBB;ARABIC LETTER SAD INITIAL FORM;Lo;0;AL;<initial> 0635;;;;N;GLYPH FOR INITIAL ARABIC SAD;;;;
FEBC;ARABIC LETTER SAD MEDIAL FORM;Lo;0;AL;<medial> 0635;;;;N;GLYPH FOR MEDIAL ARABIC SAD;;;;
FEBD;ARABIC LETTER DAD ISOLATED FORM;Lo;0;AL;<isolated> 0636;;;;N;GLYPH FOR ISOLATE ARABIC DAD;;;;
FEBE;ARABIC LETTER DAD FINAL FORM;Lo;0;AL;<final> 0636;;;;N;GLYPH FOR FINAL ARABIC DAD;;;;
FEBF;ARABIC LETTER DAD INITIAL FORM;Lo;0;AL;<initial> 0636;;;;N;GLYPH FOR INITIAL ARABIC DAD;;;;
FEC0;ARABIC LETTER DAD MEDIAL FORM;Lo;0;AL;<medial> 0636;;;;N;GLYPH FOR MEDIAL ARABIC DAD;;;;
FEC1;ARABIC LETTER TAH ISOLATED FORM;Lo;0;AL;<isolated> 0637;;;;N;GLYPH FOR ISOLATE ARABIC TAH;;;;
FEC2;ARABIC LETTER TAH FINAL FORM;Lo;0;AL;<final> 0637;;;;N;GLYPH FOR FINAL ARABIC TAH;;;;
FEC3;ARABIC LETTER TAH INITIAL FORM;Lo;0;AL;<initial> 0637;;;;N;GLYPH FOR INITIAL ARABIC TAH;;;;
FEC4;ARABIC LETTER TAH MEDIAL FORM;Lo;0;AL;<medial> 0637;;;;N;GLYPH FOR MEDIAL ARABIC TAH;;;;
FEC5;ARABIC LETTER ZAH ISOLATED FORM;Lo;0;AL;<isolated> 0638;;;;N;GLYPH FOR ISOLATE ARABIC DHAH;;;;
FEC6;ARABIC LETTER ZAH FINAL FORM;Lo;0;AL;<final> 0638;;;;N;GLYPH FOR FINAL ARABIC DHAH;;;;
FEC7;ARABIC LETTER ZAH INITIAL FORM;Lo;0;AL;<initial> 0638;;;;N;GLYPH FOR INITIAL ARABIC DHAH;;;;
FEC8;ARABIC LETTER ZAH MEDIAL FORM;Lo;0;AL;<medial> 0638;;;;N;GLYPH FOR MEDIAL ARABIC DHAH;;;;
FEC9;ARABIC LETTER AIN ISOLATED FORM;Lo;0;AL;<isolated> 0639;;;;N;GLYPH FOR ISOLATE ARABIC AIN;;;;
FECA;ARABIC LETTER AIN FINAL FORM;Lo;0;AL;<final> 0639;;;;N;GLYPH FOR FINAL ARABIC AIN;;;;
FECB;ARABIC LETTER AIN INITIAL FORM;Lo;0;AL;<initial> 0639;;;;N;GLYPH FOR INITIAL ARABIC AIN;;;;
FECC;ARABIC LETTER AIN MEDIAL FORM;Lo;0;AL;<medial> 0639;;;;N;GLYPH FOR MEDIAL ARABIC AIN;;;;
FECD;ARABIC LETTER GHAIN ISOLATED FORM;Lo;0;AL;<isolated> 063A;;;;N;GLYPH FOR ISOLATE ARABIC GHAIN;;;;
FECE;ARABIC LETTER GHAIN FINAL FORM;Lo;0;AL;<final> 063A;;;;N;GLYPH FOR FINAL ARABIC GHAIN;;;;
FECF;ARABIC LETTER GHAIN INITIAL FORM;Lo;0;AL;<initial> 063A;;;;N;GLYPH FOR INITIAL ARABIC GHAIN;;;;
FED0;ARABIC LETTER GHAIN MEDIAL FORM;Lo;0;AL;<medial> 063A;;;;N;GLYPH FOR MEDIAL ARABIC GHAIN;;;;
FED1;ARABIC LETTER FEH ISOLATED FORM;Lo;0;AL;<isolated> 0641;;;;N;GLYPH FOR ISOLATE ARABIC FA;;;;
FED2;ARABIC LETTER FEH FINAL FORM;Lo;0;AL;<final> 0641;;;;N;GLYPH FOR FINAL ARABIC FA;;;;
FED3;ARABIC LETTER FEH INITIAL FORM;Lo;0;AL;<initial> 0641;;;;N;GLYPH FOR INITIAL ARABIC FA;;;;
FED4;ARABIC LETTER FEH MEDIAL FORM;Lo;0;AL;<medial> 0641;;;;N;GLYPH FOR MEDIAL ARABIC FA;;;;
FED5;ARABIC LETTER QAF ISOLATED FORM;Lo;0;AL;<isolated> 0642;;;;N;GLYPH FOR ISOLATE ARABIC QAF;;;;
FED6;ARABIC LETTER QAF FINAL FORM;Lo;0;AL;<final> 0642;;;;N;GLYPH FOR FINAL ARABIC QAF;;;;
FED7;ARABIC LETTER QAF INITIAL FORM;Lo;0;AL;<initial> 0642;;;;N;GLYPH FOR INITIAL ARABIC QAF;;;;
FED8;ARABIC LETTER QAF MEDIAL FORM;Lo;0;AL;<medial> 0642;;;;N;GLYPH FOR MEDIAL ARABIC QAF;;;;
FED9;ARABIC LETTER KAF ISOLATED FORM;Lo;0;AL;<isolated> 0643;;;;N;GLYPH FOR ISOLATE ARABIC CAF;;;;
FEDA;ARABIC LETTER KAF FINAL FORM;Lo;0;AL;<final> 0643;;;;N;GLYPH FOR FINAL ARABIC CAF;;;;
FEDB;ARABIC LETTER KAF INITIAL FORM;Lo;0;AL;<initial> 0643;;;;N;GLYPH FOR INITIAL ARABIC CAF;;;;
FEDC;ARABIC LETTER KAF MEDIAL FORM;Lo;0;AL;<medial> 0643;;;;N;GLYPH FOR MEDIAL ARABIC CAF;;;;
FEDD;ARABIC LETTER LAM ISOLATED FORM;Lo;0;AL;<isolated> 0644;;;;N;GLYPH FOR ISOLATE ARABIC LAM;;;;
FEDE;ARABIC LETTER LAM FINAL FORM;Lo;0;AL;<final> 0644;;;;N;GLYPH FOR FINAL ARABIC LAM;;;;
FEDF;ARABIC LETTER LAM INITIAL FORM;Lo;0;AL;<initial> 0644;;;;N;GLYPH FOR INITIAL ARABIC LAM;;;;
FEE0;ARABIC LETTER LAM MEDIAL FORM;Lo;0;AL;<medial> 0644;;;;N;GLYPH FOR MEDIAL ARABIC LAM;;;;
FEE1;ARABIC LETTER MEEM ISOLATED FORM;Lo;0;AL;<isolated> 0645;;;;N;GLYPH FOR ISOLATE ARABIC MEEM;;;;
FEE2;ARABIC LETTER MEEM FINAL FORM;Lo;0;AL;<final> 0645;;;;N;GLYPH FOR FINAL ARABIC MEEM;;;;
FEE3;ARABIC LETTER MEEM INITIAL FORM;Lo;0;AL;<initial> 0645;;;;N;GLYPH FOR INITIAL ARABIC MEEM;;;;
FEE4;ARABIC LETTER MEEM MEDIAL FORM;Lo;0;AL;<medial> 0645;;;;N;GLYPH FOR MEDIAL ARABIC MEEM;;;;
FEE5;ARABIC LETTER NOON ISOLATED FORM;Lo;0;AL;<isolated> 0646;;;;N;GLYPH FOR ISOLATE ARABIC NOON;;;;
FEE6;ARABIC LETTER NOON FINAL FORM;Lo;0;AL;<final> 0646;;;;N;GLYPH FOR FINAL ARABIC NOON;;;;
FEE7;ARABIC LETTER NOON INITIAL FORM;Lo;0;AL;<initial> 0646;;;;N;GLYPH FOR INITIAL ARABIC NOON;;;;
FEE8;ARABIC LETTER NOON MEDIAL FORM;Lo;0;AL;<medial> 0646;;;;N;GLYPH FOR MEDIAL ARABIC NOON;;;;
FEE9;ARABIC LETTER HEH ISOLATED FORM;Lo;0;AL;<isolated> 0647;;;;N;GLYPH FOR ISOLATE ARABIC HA;;;;
FEEA;ARABIC LETTER HEH FINAL FORM;Lo;0;AL;<final> 0647;;;;N;GLYPH FOR FINAL ARABIC HA;;;;
FEEB;ARABIC LETTER HEH INITIAL FORM;Lo;0;AL;<initial> 0647;;;;N;GLYPH FOR INITIAL ARABIC HA;;;;
FEEC;ARABIC LETTER HEH MEDIAL FORM;Lo;0;AL;<medial> 0647;;;;N;GLYPH FOR MEDIAL ARABIC HA;;;;
FEED;ARABIC LETTER WAW ISOLATED FORM;Lo;0;AL;<isolated> 0648;;;;N;GLYPH FOR ISOLATE ARABIC WAW;;;;
FEEE;ARABIC LETTER WAW FINAL FORM;Lo;0;AL;<final> 0648;;;;N;GLYPH FOR FINAL ARABIC WAW;;;;
FEEF;ARABIC LETTER ALEF MAKSURA ISOLATED FORM;Lo;0;AL;<isolated> 0649;;;;N;GLYPH FOR ISOLATE ARABIC ALEF MAQSURAH;;;;
FEF0;ARABIC LETTER ALEF MAKSURA FINAL FORM;Lo;0;AL;<final> 0649;;;;N;GLYPH FOR FINAL ARABIC ALEF MAQSURAH;;;;
FEF1;ARABIC LETTER YEH ISOLATED FORM;Lo;0;AL;<isolated> 064A;;;;N;GLYPH FOR ISOLATE ARABIC YA;;;;
FEF2;ARABIC LETTER YEH FINAL FORM;Lo;0;AL;<final> 064A;;;;N;GLYPH FOR FINAL ARABIC YA;;;;
FEF3;ARABIC LETTER YEH INITIAL FORM;Lo;0;AL;<initial> 064A;;;;N;GLYPH FOR INITIAL ARABIC YA;;;;
FEF4;ARABIC LETTER YEH MEDIAL FORM;Lo;0;AL;<medial> 064A;;;;N;GLYPH FOR MEDIAL ARABIC YA;;;;
FEF5;ARABIC LIGATURE LAM WITH ALEF WITH MADDA ABOVE ISOLATED FORM;Lo;0;AL;<isolated> 0644 0622;;;;N;GLYPH FOR ISOLATE ARABIC MADDAH ON LIGATURE LAM ALEF;;;;
FEF6;ARABIC LIGATURE LAM WITH ALEF WITH MADDA ABOVE FINAL FORM;Lo;0;AL;<final> 0644 0622;;;;N;GLYPH FOR FINAL ARABIC MADDAH ON LIGATURE LAM ALEF;;;;
FEF7;ARABIC LIGATURE LAM WITH ALEF WITH HAMZA ABOVE ISOLATED FORM;Lo;0;AL;<isolated> 0644 0623;;;;N;GLYPH FOR ISOLATE ARABIC HAMZAH ON LIGATURE LAM ALEF;;;;
FEF8;ARABIC LIGATURE LAM WITH ALEF WITH HAMZA ABOVE FINAL FORM;Lo;0;AL;<final> 0644 0623;;;;N;GLYPH FOR FINAL ARABIC HAMZAH ON LIGATURE LAM ALEF;;;;
FEF9;ARABIC LIGATURE LAM WITH ALEF WITH HAMZA BELOW ISOLATED FORM;Lo;0;AL;<isolated> 0644 0625;;;;N;GLYPH FOR ISOLATE ARABIC HAMZAH UNDER LIGATURE LAM ALEF;;;;
FEFA;ARABIC LIGATURE LAM WITH ALEF WITH HAMZA BELOW FINAL FORM;Lo;0;AL;<final> 0644 0625;;;;N;GLYPH FOR FINAL ARABIC HAMZAH UNDER LIGATURE LAM ALEF;;;;
FEFB;ARABIC LIGATURE LAM WITH ALEF ISOLATED FORM;Lo;0;AL;<isolated> 0644 0627;;;;N;GLYPH FOR ISOLATE ARABIC LIGATURE LAM ALEF;;;;
FEFC;ARABIC LIGATURE LAM WITH ALEF FINAL FORM;Lo;0;AL;<final> 0644 0627;;;;N;GLYPH FOR FINAL ARABIC LIGATURE LAM ALEF;;;;
FEFF;ZERO WIDTH NO-BREAK SPACE;Cf;0;BN;;;;;N;BYTE ORDER MARK;;;;
FF01;FULLWIDTH EXCLAMATION MARK;Po;0;ON;<wide> 0021;;;;N;;;;;
FF02;FULLWIDTH QUOTATION MARK;Po;0;ON;<wide> 0022;;;;N;;;;;
FF03;FULLWIDTH NUMBER SIGN;Po;0;ET;<wide> 0023;;;;N;;;;;
FF04;FULLWIDTH DOLLAR SIGN;Sc;0;ET;<wide> 0024;;;;N;;;;;
FF05;FULLWIDTH PERCENT SIGN;Po;0;ET;<wide> 0025;;;;N;;;;;
FF06;FULLWIDTH AMPERSAND;Po;0;ON;<wide> 0026;;;;N;;;;;
FF07;FULLWIDTH APOSTROPHE;Po;0;ON;<wide> 0027;;;;N;;;;;
FF08;FULLWIDTH LEFT PARENTHESIS;Ps;0;ON;<wide> 0028;;;;Y;FULLWIDTH OPENING PARENTHESIS;;;;
FF09;FULLWIDTH RIGHT PARENTHESIS;Pe;0;ON;<wide> 0029;;;;Y;FULLWIDTH CLOSING PARENTHESIS;;;;
FF0A;FULLWIDTH ASTERISK;Po;0;ON;<wide> 002A;;;;N;;;;;
FF0B;FULLWIDTH PLUS SIGN;Sm;0;ES;<wide> 002B;;;;N;;;;;
FF0C;FULLWIDTH COMMA;Po;0;CS;<wide> 002C;;;;N;;;;;
FF0D;FULLWIDTH HYPHEN-MINUS;Pd;0;ES;<wide> 002D;;;;N;;;;;
FF0E;FULLWIDTH FULL STOP;Po;0;CS;<wide> 002E;;;;N;FULLWIDTH PERIOD;;;;
FF0F;FULLWIDTH SOLIDUS;Po;0;CS;<wide> 002F;;;;N;FULLWIDTH SLASH;;;;
FF10;FULLWIDTH DIGIT ZERO;Nd;0;EN;<wide> 0030;0;0;0;N;;;;;
FF11;FULLWIDTH DIGIT ONE;Nd;0;EN;<wide> 0031;1;1;1;N;;;;;
FF12;FULLWIDTH DIGIT TWO;Nd;0;EN;<wide> 0032;2;2;2;N;;;;;
FF13;FULLWIDTH DIGIT THREE;Nd;0;EN;<wide> 0033;3;3;3;N;;;;;
FF14;FULLWIDTH DIGIT FOUR;Nd;0;EN;<wide> 0034;4;4;4;N;;;;;
FF15;FULLWIDTH DIGIT FIVE;Nd;0;EN;<wide> 0035;5;5;5;N;;;;;
FF16;FULLWIDTH DIGIT SIX;Nd;0;EN;<wide> 0036;6;6;6;N;;;;;
FF17;FULLWIDTH DIGIT SEVEN;Nd;0;EN;<wide> 0037;7;7;7;N;;;;;
FF18;FULLWIDTH DIGIT EIGHT;Nd;0;EN;<wide> 0038;8;8;8;N;;;;;
FF19;FULLWIDTH DIGIT NINE;Nd;0;EN;<wide> 0039;9;9;9;N;;;;;
FF1A;FULLWIDTH COLON;Po;0;CS;<wide> 003A;;;;N;;;;;
FF1B;FULLWIDTH SEMICOLON;Po;0;ON;<wide> 003B;;;;N;;;;;
FF1C;FULLWIDTH LESS-THAN SIGN;Sm;0;ON;<wide> 003C;;;;Y;;;;;
FF1D;FULLWIDTH EQUALS SIGN;Sm;0;ON;<wide> 003D;;;;N;;;;;
FF1E;FULLWIDTH GREATER-THAN SIGN;Sm;0;ON;<wide> 003E;;;;Y;;;;;
FF1F;FULLWIDTH QUESTION MARK;Po;0;ON;<wide> 003F;;;;N;;;;;
FF20;FULLWIDTH COMMERCIAL AT;Po;0;ON;<wide> 0040;;;;N;;;;;
FF21;FULLWIDTH LATIN CAPITAL LETTER A;Lu;0;L;<wide> 0041;;;;N;;;;FF41;
FF22;FULLWIDTH LATIN CAPITAL LETTER B;Lu;0;L;<wide> 0042;;;;N;;;;FF42;
FF23;FULLWIDTH LATIN CAPITAL LETTER C;Lu;0;L;<wide> 0043;;;;N;;;;FF43;
FF24;FULLWIDTH LATIN CAPITAL LETTER D;Lu;0;L;<wide> 0044;;;;N;;;;FF44;
FF25;FULLWIDTH LATIN CAPITAL LETTER E;Lu;0;L;<wide> 0045;;;;N;;;;FF45;
FF26;FULLWIDTH LATIN CAPITAL LETTER F;Lu;0;L;<wide> 0046;;;;N;;;;FF46;
FF27;FULLWIDTH LATIN CAPITAL LETTER G;Lu;0;L;<wide> 0047;;;;N;;;;FF47;
FF28;FULLWIDTH LATIN CAPITAL LETTER H;Lu;0;L;<wide> 0048;;;;N;;;;FF48;
FF29;FULLWIDTH LATIN CAPITAL LETTER I;Lu;0;L;<wide> 0049;;;;N;;;;FF49;
FF2A;FULLWIDTH LATIN CAPITAL LETTER J;Lu;0;L;<wide> 004A;;;;N;;;;FF4A;
FF2B;FULLWIDTH LATIN CAPITAL LETTER K;Lu;0;L;<wide> 004B;;;;N;;;;FF4B;
FF2C;FULLWIDTH LATIN CAPITAL LETTER L;Lu;0;L;<wide> 004C;;;;N;;;;FF4C;
FF2D;FULLWIDTH LATIN CAPITAL LETTER M;Lu;0;L;<wide> 004D;;;;N;;;;FF4D;
FF2E;FULLWIDTH LATIN CAPITAL LETTER N;Lu;0;L;<wide> 004E;;;;N;;;;FF4E;
FF2F;FULLWIDTH LATIN CAPITAL LETTER O;Lu;0;L;<wide> 004F;;;;N;;;;FF4F;
FF30;FULLWIDTH LATIN CAPITAL LETTER P;Lu;0;L;<wide> 0050;;;;N;;;;FF50;
FF31;FULLWIDTH LATIN CAPITAL LETTER Q;Lu;0;L;<wide> 0051;;;;N;;;;FF51;
FF32;FULLWIDTH LATIN CAPITAL LETTER R;Lu;0;L;<wide> 0052;;;;N;;;;FF52;
FF33;FULLWIDTH LATIN CAPITAL LETTER S;Lu;0;L;<wide> 0053;;;;N;;;;FF53;
FF34;FULLWIDTH LATIN CAPITAL LETTER T;Lu;0;L;<wide> 0054;;;;N;;;;FF54;
FF35;FULLWIDTH LATIN CAPITAL LETTER U;Lu;0;L;<wide> 0055;;;;N;;;;FF55;
FF36;FULLWIDTH LATIN CAPITAL LETTER V;Lu;0;L;<wide> 0056;;;;N;;;;FF56;
FF37;FULLWIDTH LATIN CAPITAL LETTER W;Lu;0;L;<wide> 0057;;;;N;;;;FF57;
FF38;FULLWIDTH LATIN CAPITAL LETTER X;Lu;0;L;<wide> 0058;;;;N;;;;FF58;
FF39;FULLWIDTH LATIN CAPITAL LETTER Y;Lu;0;L;<wide> 0059;;;;N;;;;FF59;
FF3A;FULLWIDTH LATIN CAPITAL LETTER Z;Lu;0;L;<wide> 005A;;;;N;;;;FF5A;
FF3B;FULLWIDTH LEFT SQUARE BRACKET;Ps;0;ON;<wide> 005B;;;;Y;FULLWIDTH OPENING SQUARE BRACKET;;;;
FF3C;FULLWIDTH REVERSE SOLIDUS;Po;0;ON;<wide> 005C;;;;N;FULLWIDTH BACKSLASH;;;;
FF3D;FULLWIDTH RIGHT SQUARE BRACKET;Pe;0;ON;<wide> 005D;;;;Y;FULLWIDTH CLOSING SQUARE BRACKET;;;;
FF3E;FULLWIDTH CIRCUMFLEX ACCENT;Sk;0;ON;<wide> 005E;;;;N;FULLWIDTH SPACING CIRCUMFLEX;;;;
FF3F;FULLWIDTH LOW LINE;Pc;0;ON;<wide> 005F;;;;N;FULLWIDTH SPACING UNDERSCORE;;;;
FF40;FULLWIDTH GRAVE ACCENT;Sk;0;ON;<wide> 0060;;;;N;FULLWIDTH SPACING GRAVE;;;;
FF41;FULLWIDTH LATIN SMALL LETTER A;Ll;0;L;<wide> 0061;;;;N;;;FF21;;FF21
FF42;FULLWIDTH LATIN SMALL LETTER B;Ll;0;L;<wide> 0062;;;;N;;;FF22;;FF22
FF43;FULLWIDTH LATIN SMALL LETTER C;Ll;0;L;<wide> 0063;;;;N;;;FF23;;FF23
FF44;FULLWIDTH LATIN SMALL LETTER D;Ll;0;L;<wide> 0064;;;;N;;;FF24;;FF24
FF45;FULLWIDTH LATIN SMALL LETTER E;Ll;0;L;<wide> 0065;;;;N;;;FF25;;FF25
FF46;FULLWIDTH LATIN SMALL LETTER F;Ll;0;L;<wide> 0066;;;;N;;;FF26;;FF26
FF47;FULLWIDTH LATIN SMALL LETTER G;Ll;0;L;<wide> 0067;;;;N;;;FF27;;FF27
FF48;FULLWIDTH LATIN SMALL LETTER H;Ll;0;L;<wide> 0068;;;;N;;;FF28;;FF28
FF49;FULLWIDTH LATIN SMALL LETTER I;Ll;0;L;<wide> 0069;;;;N;;;FF29;;FF29
FF4A;FULLWIDTH LATIN SMALL LETTER J;Ll;0;L;<wide> 006A;;;;N;;;FF2A;;FF2A
FF4B;FULLWIDTH LATIN SMALL LETTER K;Ll;0;L;<wide> 006B;;;;N;;;FF2B;;FF2B
FF4C;FULLWIDTH LATIN SMALL LETTER L;Ll;0;L;<wide> 006C;;;;N;;;FF2C;;FF2C
FF4D;FULLWIDTH LATIN SMALL LETTER M;Ll;0;L;<wide> 006D;;;;N;;;FF2D;;FF2D
FF4E;FULLWIDTH LATIN SMALL LETTER N;Ll;0;L;<wide> 006E;;;;N;;;FF2E;;FF2E
FF4F;FULLWIDTH LATIN SMALL LETTER O;Ll;0;L;<wide> 006F;;;;N;;;FF2F;;FF2F
FF50;FULLWIDTH LATIN SMALL LETTER P;Ll;0;L;<wide> 0070;;;;N;;;FF30;;FF30
FF51;FULLWIDTH LATIN SMALL LETTER Q;Ll;0;L;<wide> 0071;;;;N;;;FF31;;FF31
FF52;FULLWIDTH LATIN SMALL LETTER R;Ll;0;L;<wide> 0072;;;;N;;;FF32;;FF32
FF53;FULLWIDTH LATIN SMALL LETTER S;Ll;0;L;<wide> 0073;;;;N;;;FF33;;FF33
FF54;FULLWIDTH LATIN SMALL LETTER T;Ll;0;L;<wide> 0074;;;;N;;;FF34;;FF34
FF55;FULLWIDTH LATIN SMALL LETTER U;Ll;0;L;<wide> 0075;;;;N;;;FF35;;FF35
FF56;FULLWIDTH LATIN SMALL LETTER V;Ll;0;L;<wide> 0076;;;;N;;;FF36;;FF36
FF57;FULLWIDTH LATIN SMALL LETTER W;Ll;0;L;<wide> 0077;;;;N;;;FF37;;FF37
FF58;FULLWIDTH LATIN SMALL LETTER X;Ll;0;L;<wide> 0078;;;;N;;;FF38;;FF38
FF59;FULLWIDTH LATIN SMALL LETTER Y;Ll;0;L;<wide> 0079;;;;N;;;FF39;;FF39
FF5A;FULLWIDTH LATIN SMALL LETTER Z;Ll;0;L;<wide> 007A;;;;N;;;FF3A;;FF3A
FF5B;FULLWIDTH LEFT CURLY BRACKET;Ps;0;ON;<wide> 007B;;;;Y;FULLWIDTH OPENING CURLY BRACKET;;;;
FF5C;FULLWIDTH VERTICAL LINE;Sm;0;ON;<wide> 007C;;;;N;FULLWIDTH VERTICAL BAR;;;;
FF5D;FULLWIDTH RIGHT CURLY BRACKET;Pe;0;ON;<wide> 007D;;;;Y;FULLWIDTH CLOSING CURLY BRACKET;;;;
FF5E;FULLWIDTH TILDE;Sm;0;ON;<wide> 007E;;;;N;FULLWIDTH SPACING TILDE;;;;
FF5F;FULLWIDTH LEFT WHITE PARENTHESIS;Ps;0;ON;<wide> 2985;;;;Y;;;;;
FF60;FULLWIDTH RIGHT WHITE PARENTHESIS;Pe;0;ON;<wide> 2986;;;;Y;;;;;
FF61;HALFWIDTH IDEOGRAPHIC FULL STOP;Po;0;ON;<narrow> 3002;;;;N;HALFWIDTH IDEOGRAPHIC PERIOD;;;;
FF62;HALFWIDTH LEFT CORNER BRACKET;Ps;0;ON;<narrow> 300C;;;;Y;HALFWIDTH OPENING CORNER BRACKET;;;;
FF63;HALFWIDTH RIGHT CORNER BRACKET;Pe;0;ON;<narrow> 300D;;;;Y;HALFWIDTH CLOSING CORNER BRACKET;;;;
FF64;HALFWIDTH IDEOGRAPHIC COMMA;Po;0;ON;<narrow> 3001;;;;N;;;;;
FF65;HALFWIDTH KATAKANA MIDDLE DOT;Po;0;ON;<narrow> 30FB;;;;N;;;;;
FF66;HALFWIDTH KATAKANA LETTER WO;Lo;0;L;<narrow> 30F2;;;;N;;;;;
FF67;HALFWIDTH KATAKANA LETTER SMALL A;Lo;0;L;<narrow> 30A1;;;;N;;;;;
FF68;HALFWIDTH KATAKANA LETTER SMALL I;Lo;0;L;<narrow> 30A3;;;;N;;;;;
FF69;HALFWIDTH KATAKANA LETTER SMALL U;Lo;0;L;<narrow> 30A5;;;;N;;;;;
FF6A;HALFWIDTH KATAKANA LETTER SMALL E;Lo;0;L;<narrow> 30A7;;;;N;;;;;
FF6B;HALFWIDTH KATAKANA LETTER SMALL O;Lo;0;L;<narrow> 30A9;;;;N;;;;;
FF6C;HALFWIDTH KATAKANA LETTER SMALL YA;Lo;0;L;<narrow> 30E3;;;;N;;;;;
FF6D;HALFWIDTH KATAKANA LETTER SMALL YU;Lo;0;L;<narrow> 30E5;;;;N;;;;;
FF6E;HALFWIDTH KATAKANA LETTER SMALL YO;Lo;0;L;<narrow> 30E7;;;;N;;;;;
FF6F;HALFWIDTH KATAKANA LETTER SMALL TU;Lo;0;L;<narrow> 30C3;;;;N;;;;;
FF70;HALFWIDTH KATAKANA-HIRAGANA PROLONGED SOUND MARK;Lm;0;L;<narrow> 30FC;;;;N;;;;;
FF71;HALFWIDTH KATAKANA LETTER A;Lo;0;L;<narrow> 30A2;;;;N;;;;;
FF72;HALFWIDTH KATAKANA LETTER I;Lo;0;L;<narrow> 30A4;;;;N;;;;;
FF73;HALFWIDTH KATAKANA LETTER U;Lo;0;L;<narrow> 30A6;;;;N;;;;;
FF74;HALFWIDTH KATAKANA LETTER E;Lo;0;L;<narrow> 30A8;;;;N;;;;;
FF75;HALFWIDTH KATAKANA LETTER O;Lo;0;L;<narrow> 30AA;;;;N;;;;;
FF76;HALFWIDTH KATAKANA LETTER KA;Lo;0;L;<narrow> 30AB;;;;N;;;;;
FF77;HALFWIDTH KATAKANA LETTER KI;Lo;0;L;<narrow> 30AD;;;;N;;;;;
FF78;HALFWIDTH KATAKANA LETTER KU;Lo;0;L;<narrow> 30AF;;;;N;;;;;
FF79;HALFWIDTH KATAKANA LETTER KE;Lo;0;L;<narrow> 30B1;;;;N;;;;;
FF7A;HALFWIDTH KATAKANA LETTER KO;Lo;0;L;<narrow> 30B3;;;;N;;;;;
FF7B;HALFWIDTH KATAKANA LETTER SA;Lo;0;L;<narrow> 30B5;;;;N;;;;;
FF7C;HALFWIDTH KATAKANA LETTER SI;Lo;0;L;<narrow> 30B7;;;;N;;;;;
FF7D;HALFWIDTH KATAKANA LETTER SU;Lo;0;L;<narrow> 30B9;;;;N;;;;;
FF7E;HALFWIDTH KATAKANA LETTER SE;Lo;0;L;<narrow> 30BB;;;;N;;;;;
FF7F;HALFWIDTH KATAKANA LETTER SO;Lo;0;L;<narrow> 30BD;;;;N;;;;;
FF80;HALFWIDTH KATAKANA LETTER TA;Lo;0;L;<narrow> 30BF;;;;N;;;;;
FF81;HALFWIDTH KATAKANA LETTER TI;Lo;0;L;<narrow> 30C1;;;;N;;;;;
FF82;HALFWIDTH KATAKANA LETTER TU;Lo;0;L;<narrow> 30C4;;;;N;;;;;
FF83;HALFWIDTH KATAKANA LETTER TE;Lo;0;L;<narrow> 30C6;;;;N;;;;;
FF84;HALFWIDTH KATAKANA LETTER TO;Lo;0;L;<narrow> 30C8;;;;N;;;;;
FF85;HALFWIDTH KATAKANA LETTER NA;Lo;0;L;<narrow> 30CA;;;;N;;;;;
FF86;HALFWIDTH KATAKANA LETTER NI;Lo;0;L;<narrow> 30CB;;;;N;;;;;
FF87;HALFWIDTH KATAKANA LETTER NU;Lo;0;L;<narrow> 30CC;;;;N;;;;;
FF88;HALFWIDTH KATAKANA LETTER NE;Lo;0;L;<narrow> 30CD;;;;N;;;;;
FF89;HALFWIDTH KATAKANA LETTER NO;Lo;0;L;<narrow> 30CE;;;;N;;;;;
FF8A;HALFWIDTH KATAKANA LETTER HA;Lo;0;L;<narrow> 30CF;;;;N;;;;;
FF8B;HALFWIDTH KATAKANA LETTER HI;Lo;0;L;<narrow> 30D2;;;;N;;;;;
FF8C;HALFWIDTH KATAKANA LETTER HU;Lo;0;L;<narrow> 30D5;;;;N;;;;;
FF8D;HALFWIDTH KATAKANA LETTER HE;Lo;0;L;<narrow> 30D8;;;;N;;;;;
FF8E;HALFWIDTH KATAKANA LETTER HO;Lo;0;L;<narrow> 30DB;;;;N;;;;;
FF8F;HALFWIDTH KATAKANA LETTER MA;Lo;0;L;<narrow> 30DE;;;;N;;;;;
FF90;HALFWIDTH KATAKANA LETTER MI;Lo;0;L;<narrow> 30DF;;;;N;;;;;
FF91;HALFWIDTH KATAKANA LETTER MU;Lo;0;L;<narrow> 30E0;;;;N;;;;;
FF92;HALFWIDTH KATAKANA LETTER ME;Lo;0;L;<narrow> 30E1;;;;N;;;;;
FF93;HALFWIDTH KATAKANA LETTER MO;Lo;0;L;<narrow> 30E2;;;;N;;;;;
FF94;HALFWIDTH KATAKANA LETTER YA;Lo;0;L;<narrow> 30E4;;;;N;;;;;
FF95;HALFWIDTH KATAKANA LETTER YU;Lo;0;L;<narrow> 30E6;;;;N;;;;;
FF96;HALFWIDTH KATAKANA LETTER YO;Lo;0;L;<narrow> 30E8;;;;N;;;;;
FF97;HALFWIDTH KATAKANA LETTER RA;Lo;0;L;<narrow> 30E9;;;;N;;;;;
FF98;HALFWIDTH KATAKANA LETTER RI;Lo;0;L;<narrow> 30EA;;;;N;;;;;
FF99;HALFWIDTH KATAKANA LETTER RU;Lo;0;L;<narrow> 30EB;;;;N;;;;;
FF9A;HALFWIDTH KATAKANA LETTER RE;Lo;0;L;<narrow> 30EC;;;;N;;;;;
FF9B;HALFWIDTH KATAKANA LETTER RO;Lo;0;L;<narrow> 30ED;;;;N;;;;;
FF9C;HALFWIDTH KATAKANA LETTER WA;Lo;0;L;<narrow> 30EF;;;;N;;;;;
FF9D;HALFWIDTH KATAKANA LETTER N;Lo;0;L;<narrow> 30F3;;;;N;;;;;
FF9E;HALFWIDTH KATAKANA VOICED SOUND MARK;Lm;0;L;<narrow> 3099;;;;N;;;;;
FF9F;HALFWIDTH KATAKANA SEMI-VOICED SOUND MARK;Lm;0;L;<narrow> 309A;;;;N;;;;;
FFA0;HALFWIDTH HANGUL FILLER;Lo;0;L;<narrow> 3164;;;;N;HALFWIDTH HANGUL CAE OM;;;;
FFA1;HALFWIDTH HANGUL LETTER KIYEOK;Lo;0;L;<narrow> 3131;;;;N;HALFWIDTH HANGUL LETTER GIYEOG;;;;
FFA2;HALFWIDTH HANGUL LETTER SSANGKIYEOK;Lo;0;L;<narrow> 3132;;;;N;HALFWIDTH HANGUL LETTER SSANG GIYEOG;;;;
FFA3;HALFWIDTH HANGUL LETTER KIYEOK-SIOS;Lo;0;L;<narrow> 3133;;;;N;HALFWIDTH HANGUL LETTER GIYEOG SIOS;;;;
FFA4;HALFWIDTH HANGUL LETTER NIEUN;Lo;0;L;<narrow> 3134;;;;N;;;;;
FFA5;HALFWIDTH HANGUL LETTER NIEUN-CIEUC;Lo;0;L;<narrow> 3135;;;;N;HALFWIDTH HANGUL LETTER NIEUN JIEUJ;;;;
FFA6;HALFWIDTH HANGUL LETTER NIEUN-HIEUH;Lo;0;L;<narrow> 3136;;;;N;HALFWIDTH HANGUL LETTER NIEUN HIEUH;;;;
FFA7;HALFWIDTH HANGUL LETTER TIKEUT;Lo;0;L;<narrow> 3137;;;;N;HALFWIDTH HANGUL LETTER DIGEUD;;;;
FFA8;HALFWIDTH HANGUL LETTER SSANGTIKEUT;Lo;0;L;<narrow> 3138;;;;N;HALFWIDTH HANGUL LETTER SSANG DIGEUD;;;;
FFA9;HALFWIDTH HANGUL LETTER RIEUL;Lo;0;L;<narrow> 3139;;;;N;HALFWIDTH HANGUL LETTER LIEUL;;;;
FFAA;HALFWIDTH HANGUL LETTER RIEUL-KIYEOK;Lo;0;L;<narrow> 313A;;;;N;HALFWIDTH HANGUL LETTER LIEUL GIYEOG;;;;
FFAB;HALFWIDTH HANGUL LETTER RIEUL-MIEUM;Lo;0;L;<narrow> 313B;;;;N;HALFWIDTH HANGUL LETTER LIEUL MIEUM;;;;
FFAC;HALFWIDTH HANGUL LETTER RIEUL-PIEUP;Lo;0;L;<narrow> 313C;;;;N;HALFWIDTH HANGUL LETTER LIEUL BIEUB;;;;
FFAD;HALFWIDTH HANGUL LETTER RIEUL-SIOS;Lo;0;L;<narrow> 313D;;;;N;HALFWIDTH HANGUL LETTER LIEUL SIOS;;;;
FFAE;HALFWIDTH HANGUL LETTER RIEUL-THIEUTH;Lo;0;L;<narrow> 313E;;;;N;HALFWIDTH HANGUL LETTER LIEUL TIEUT;;;;
FFAF;HALFWIDTH HANGUL LETTER RIEUL-PHIEUPH;Lo;0;L;<narrow> 313F;;;;N;HALFWIDTH HANGUL LETTER LIEUL PIEUP;;;;
FFB0;HALFWIDTH HANGUL LETTER RIEUL-HIEUH;Lo;0;L;<narrow> 3140;;;;N;HALFWIDTH HANGUL LETTER LIEUL HIEUH;;;;
FFB1;HALFWIDTH HANGUL LETTER MIEUM;Lo;0;L;<narrow> 3141;;;;N;;;;;
FFB2;HALFWIDTH HANGUL LETTER PIEUP;Lo;0;L;<narrow> 3142;;;;N;HALFWIDTH HANGUL LETTER BIEUB;;;;
FFB3;HALFWIDTH HANGUL LETTER SSANGPIEUP;Lo;0;L;<narrow> 3143;;;;N;HALFWIDTH HANGUL LETTER SSANG BIEUB;;;;
FFB4;HALFWIDTH HANGUL LETTER PIEUP-SIOS;Lo;0;L;<narrow> 3144;;;;N;HALFWIDTH HANGUL LETTER BIEUB SIOS;;;;
FFB5;HALFWIDTH HANGUL LETTER SIOS;Lo;0;L;<narrow> 3145;;;;N;;;;;
FFB6;HALFWIDTH HANGUL LETTER SSANGSIOS;Lo;0;L;<narrow> 3146;;;;N;HALFWIDTH HANGUL LETTER SSANG SIOS;;;;
FFB7;HALFWIDTH HANGUL LETTER IEUNG;Lo;0;L;<narrow> 3147;;;;N;;;;;
FFB8;HALFWIDTH HANGUL LETTER CIEUC;Lo;0;L;<narrow> 3148;;;;N;HALFWIDTH HANGUL LETTER JIEUJ;;;;
FFB9;HALFWIDTH HANGUL LETTER SSANGCIEUC;Lo;0;L;<narrow> 3149;;;;N;HALFWIDTH HANGUL LETTER SSANG JIEUJ;;;;
FFBA;HALFWIDTH HANGUL LETTER CHIEUCH;Lo;0;L;<narrow> 314A;;;;N;HALFWIDTH HANGUL LETTER CIEUC;;;;
FFBB;HALFWIDTH HANGUL LETTER KHIEUKH;Lo;0;L;<narrow> 314B;;;;N;HALFWIDTH HANGUL LETTER KIYEOK;;;;
FFBC;HALFWIDTH HANGUL LETTER THIEUTH;Lo;0;L;<narrow> 314C;;;;N;HALFWIDTH HANGUL LETTER TIEUT;;;;
FFBD;HALFWIDTH HANGUL LETTER PHIEUPH;Lo;0;L;<narrow> 314D;;;;N;HALFWIDTH HANGUL LETTER PIEUP;;;;
FFBE;HALFWIDTH HANGUL LETTER HIEUH;Lo;0;L;<narrow> 314E;;;;N;;;;;
FFC2;HALFWIDTH HANGUL LETTER A;Lo;0;L;<narrow> 314F;;;;N;;;;;
FFC3;HALFWIDTH HANGUL LETTER AE;Lo;0;L;<narrow> 3150;;;;N;;;;;
FFC4;HALFWIDTH HANGUL LETTER YA;Lo;0;L;<narrow> 3151;;;;N;;;;;
FFC5;HALFWIDTH HANGUL LETTER YAE;Lo;0;L;<narrow> 3152;;;;N;;;;;
FFC6;HALFWIDTH HANGUL LETTER EO;Lo;0;L;<narrow> 3153;;;;N;;;;;
FFC7;HALFWIDTH HANGUL LETTER E;Lo;0;L;<narrow> 3154;;;;N;;;;;
FFCA;HALFWIDTH HANGUL LETTER YEO;Lo;0;L;<narrow> 3155;;;;N;;;;;
FFCB;HALFWIDTH HANGUL LETTER YE;Lo;0;L;<narrow> 3156;;;;N;;;;;
FFCC;HALFWIDTH HANGUL LETTER O;Lo;0;L;<narrow> 3157;;;;N;;;;;
FFCD;HALFWIDTH HANGUL LETTER WA;Lo;0;L;<narrow> 3158;;;;N;;;;;
FFCE;HALFWIDTH HANGUL LETTER WAE;Lo;0;L;<narrow> 3159;;;;N;;;;;
FFCF;HALFWIDTH HANGUL LETTER OE;Lo;0;L;<narrow> 315A;;;;N;;;;;
FFD2;HALFWIDTH HANGUL LETTER YO;Lo;0;L;<narrow> 315B;;;;N;;;;;
FFD3;HALFWIDTH HANGUL LETTER U;Lo;0;L;<narrow> 315C;;;;N;;;;;
FFD4;HALFWIDTH HANGUL LETTER WEO;Lo;0;L;<narrow> 315D;;;;N;;;;;
FFD5;HALFWIDTH HANGUL LETTER WE;Lo;0;L;<narrow> 315E;;;;N;;;;;
FFD6;HALFWIDTH HANGUL LETTER WI;Lo;0;L;<narrow> 315F;;;;N;;;;;
FFD7;HALFWIDTH HANGUL LETTER YU;Lo;0;L;<narrow> 3160;;;;N;;;;;
FFDA;HALFWIDTH HANGUL LETTER EU;Lo;0;L;<narrow> 3161;;;;N;;;;;
FFDB;HALFWIDTH HANGUL LETTER YI;Lo;0;L;<narrow> 3162;;;;N;;;;;
FFDC;HALFWIDTH HANGUL LETTER I;Lo;0;L;<narrow> 3163;;;;N;;;;;
FFE0;FULLWIDTH CENT SIGN;Sc;0;ET;<wide> 00A2;;;;N;;;;;
FFE1;FULLWIDTH POUND SIGN;Sc;0;ET;<wide> 00A3;;;;N;;;;;
FFE2;FULLWIDTH NOT SIGN;Sm;0;ON;<wide> 00AC;;;;N;;;;;
FFE3;FULLWIDTH MACRON;Sk;0;ON;<wide> 00AF;;;;N;FULLWIDTH SPACING MACRON;;;;
FFE4;FULLWIDTH BROKEN BAR;So;0;ON;<wide> 00A6;;;;N;FULLWIDTH BROKEN VERTICAL BAR;;;;
FFE5;FULLWIDTH YEN SIGN;Sc;0;ET;<wide> 00A5;;;;N;;;;;
FFE6;FULLWIDTH WON SIGN;Sc;0;ET;<wide> 20A9;;;;N;;;;;
FFE8;HALFWIDTH FORMS LIGHT VERTICAL;So;0;ON;<narrow> 2502;;;;N;;;;;
FFE9;HALFWIDTH LEFTWARDS ARROW;Sm;0;ON;<narrow> 2190;;;;N;;;;;
FFEA;HALFWIDTH UPWARDS ARROW;Sm;0;ON;<narrow> 2191;;;;N;;;;;
FFEB;HALFWIDTH RIGHTWARDS ARROW;Sm;0;ON;<narrow> 2192;;;;N;;;;;
FFEC;HALFWIDTH DOWNWARDS ARROW;Sm;0;ON;<narrow> 2193;;;;N;;;;;
FFED;HALFWIDTH BLACK SQUARE;So;0;ON;<narrow> 25A0;;;;N;;;;;
FFEE;HALFWIDTH WHITE CIRCLE;So;0;ON;<narrow> 25CB;;;;N;;;;;
FFF9;INTERLINEAR ANNOTATION ANCHOR;Cf;0;ON;;;;;N;;;;;
FFFA;INTERLINEAR ANNOTATION SEPARATOR;Cf;0;ON;;;;;N;;;;;
FFFB;INTERLINEAR ANNOTATION TERMINATOR;Cf;0;ON;;;;;N;;;;;
FFFC;OBJECT REPLACEMENT CHARACTER;So;0;ON;;;;;N;;;;;
FFFD;REPLACEMENT CHARACTER;So;0;ON;;;;;N;;;;;
10000;LINEAR B SYLLABLE B008 A;Lo;0;L;;;;;N;;;;;
10001;LINEAR B SYLLABLE B038 E;Lo;0;L;;;;;N;;;;;
10002;LINEAR B SYLLABLE B028 I;Lo;0;L;;;;;N;;;;;
10003;LINEAR B SYLLABLE B061 O;Lo;0;L;;;;;N;;;;;
10004;LINEAR B SYLLABLE B010 U;Lo;0;L;;;;;N;;;;;
10005;LINEAR B SYLLABLE B001 DA;Lo;0;L;;;;;N;;;;;
10006;LINEAR B SYLLABLE B045 DE;Lo;0;L;;;;;N;;;;;
10007;LINEAR B SYLLABLE B007 DI;Lo;0;L;;;;;N;;;;;
10008;LINEAR B SYLLABLE B014 DO;Lo;0;L;;;;;N;;;;;
10009;LINEAR B SYLLABLE B051 DU;Lo;0;L;;;;;N;;;;;
1000A;LINEAR B SYLLABLE B057 JA;Lo;0;L;;;;;N;;;;;
1000B;LINEAR B SYLLABLE B046 JE;Lo;0;L;;;;;N;;;;;
1000D;LINEAR B SYLLABLE B036 JO;Lo;0;L;;;;;N;;;;;
1000E;LINEAR B SYLLABLE B065 JU;Lo;0;L;;;;;N;;;;;
1000F;LINEAR B SYLLABLE B077 KA;Lo;0;L;;;;;N;;;;;
10010;LINEAR B SYLLABLE B044 KE;Lo;0;L;;;;;N;;;;;
10011;LINEAR B SYLLABLE B067 KI;Lo;0;L;;;;;N;;;;;
10012;LINEAR B SYLLABLE B070 KO;Lo;0;L;;;;;N;;;;;
10013;LINEAR B SYLLABLE B081 KU;Lo;0;L;;;;;N;;;;;
10014;LINEAR B SYLLABLE B080 MA;Lo;0;L;;;;;N;;;;;
10015;LINEAR B SYLLABLE B013 ME;Lo;0;L;;;;;N;;;;;
10016;LINEAR B SYLLABLE B073 MI;Lo;0;L;;;;;N;;;;;
10017;LINEAR B SYLLABLE B015 MO;Lo;0;L;;;;;N;;;;;
10018;LINEAR B SYLLABLE B023 MU;Lo;0;L;;;;;N;;;;;
10019;LINEAR B SYLLABLE B006 NA;Lo;0;L;;;;;N;;;;;
1001A;LINEAR B SYLLABLE B024 NE;Lo;0;L;;;;;N;;;;;
1001B;LINEAR B SYLLABLE B030 NI;Lo;0;L;;;;;N;;;;;
1001C;LINEAR B SYLLABLE B052 NO;Lo;0;L;;;;;N;;;;;
1001D;LINEAR B SYLLABLE B055 NU;Lo;0;L;;;;;N;;;;;
1001E;LINEAR B SYLLABLE B003 PA;Lo;0;L;;;;;N;;;;;
1001F;LINEAR B SYLLABLE B072 PE;Lo;0;L;;;;;N;;;;;
10020;LINEAR B SYLLABLE B039 PI;Lo;0;L;;;;;N;;;;;
10021;LINEAR B SYLLABLE B011 PO;Lo;0;L;;;;;N;;;;;
10022;LINEAR B SYLLABLE B050 PU;Lo;0;L;;;;;N;;;;;
10023;LINEAR B SYLLABLE B016 QA;Lo;0;L;;;;;N;;;;;
10024;LINEAR B SYLLABLE B078 QE;Lo;0;L;;;;;N;;;;;
10025;LINEAR B SYLLABLE B021 QI;Lo;0;L;;;;;N;;;;;
10026;LINEAR B SYLLABLE B032 QO;Lo;0;L;;;;;N;;;;;
10028;LINEAR B SYLLABLE B060 RA;Lo;0;L;;;;;N;;;;;
10029;LINEAR B SYLLABLE B027 RE;Lo;0;L;;;;;N;;;;;
1002A;LINEAR B SYLLABLE B053 RI;Lo;0;L;;;;;N;;;;;
1002B;LINEAR B SYLLABLE B002 RO;Lo;0;L;;;;;N;;;;;
1002C;LINEAR B SYLLABLE B026 RU;Lo;0;L;;;;;N;;;;;
1002D;LINEAR B SYLLABLE B031 SA;Lo;0;L;;;;;N;;;;;
1002E;LINEAR B SYLLABLE B009 SE;Lo;0;L;;;;;N;;;;;
1002F;LINEAR B SYLLABLE B041 SI;Lo;0;L;;;;;N;;;;;
10030;LINEAR B SYLLABLE B012 SO;Lo;0;L;;;;;N;;;;;
10031;LINEAR B SYLLABLE B058 SU;Lo;0;L;;;;;N;;;;;
10032;LINEAR B SYLLABLE B059 TA;Lo;0;L;;;;;N;;;;;
10033;LINEAR B SYLLABLE B004 TE;Lo;0;L;;;;;N;;;;;
10034;LINEAR B SYLLABLE B037 TI;Lo;0;L;;;;;N;;;;;
10035;LINEAR B SYLLABLE B005 TO;Lo;0;L;;;;;N;;;;;
10036;LINEAR B SYLLABLE B069 TU;Lo;0;L;;;;;N;;;;;
10037;LINEAR B SYLLABLE B054 WA;Lo;0;L;;;;;N;;;;;
10038;LINEAR B SYLLABLE B075 WE;Lo;0;L;;;;;N;;;;;
10039;LINEAR B SYLLABLE B040 WI;Lo;0;L;;;;;N;;;;;
1003A;LINEAR B SYLLABLE B042 WO;Lo;0;L;;;;;N;;;;;
1003C;LINEAR B SYLLABLE B017 ZA;Lo;0;L;;;;;N;;;;;
1003D;LINEAR B SYLLABLE B074 ZE;Lo;0;L;;;;;N;;;;;
1003F;LINEAR B SYLLABLE B020 ZO;Lo;0;L;;;;;N;;;;;
10040;LINEAR B SYLLABLE B025 A2;Lo;0;L;;;;;N;;;;;
10041;LINEAR B SYLLABLE B043 A3;Lo;0;L;;;;;N;;;;;
10042;LINEAR B SYLLABLE B085 AU;Lo;0;L;;;;;N;;;;;
10043;LINEAR B SYLLABLE B071 DWE;Lo;0;L;;;;;N;;;;;
10044;LINEAR B SYLLABLE B090 DWO;Lo;0;L;;;;;N;;;;;
10045;LINEAR B SYLLABLE B048 NWA;Lo;0;L;;;;;N;;;;;
10046;LINEAR B SYLLABLE B029 PU2;Lo;0;L;;;;;N;;;;;
10047;LINEAR B SYLLABLE B062 PTE;Lo;0;L;;;;;N;;;;;
10048;LINEAR B SYLLABLE B076 RA2;Lo;0;L;;;;;N;;;;;
10049;LINEAR B SYLLABLE B033 RA3;Lo;0;L;;;;;N;;;;;
1004A;LINEAR B SYLLABLE B068 RO2;Lo;0;L;;;;;N;;;;;
1004B;LINEAR B SYLLABLE B066 TA2;Lo;0;L;;;;;N;;;;;
1004C;LINEAR B SYLLABLE B087 TWE;Lo;0;L;;;;;N;;;;;
1004D;LINEAR B SYLLABLE B091 TWO;Lo;0;L;;;;;N;;;;;
10050;LINEAR B SYMBOL B018;Lo;0;L;;;;;N;;;;;
10051;LINEAR B SYMBOL B019;Lo;0;L;;;;;N;;;;;
10052;LINEAR B SYMBOL B022;Lo;0;L;;;;;N;;;;;
10053;LINEAR B SYMBOL B034;Lo;0;L;;;;;N;;;;;
10054;LINEAR B SYMBOL B047;Lo;0;L;;;;;N;;;;;
10055;LINEAR B SYMBOL B049;Lo;0;L;;;;;N;;;;;
10056;LINEAR B SYMBOL B056;Lo;0;L;;;;;N;;;;;
10057;LINEAR B SYMBOL B063;Lo;0;L;;;;;N;;;;;
10058;LINEAR B SYMBOL B064;Lo;0;L;;;;;N;;;;;
10059;LINEAR B SYMBOL B079;Lo;0;L;;;;;N;;;;;
1005A;LINEAR B SYMBOL B082;Lo;0;L;;;;;N;;;;;
1005B;LINEAR B SYMBOL B083;Lo;0;L;;;;;N;;;;;
1005C;LINEAR B SYMBOL B086;Lo;0;L;;;;;N;;;;;
1005D;LINEAR B SYMBOL B089;Lo;0;L;;;;;N;;;;;
10080;LINEAR B IDEOGRAM B100 MAN;Lo;0;L;;;;;N;;;;;
10081;LINEAR B IDEOGRAM B102 WOMAN;Lo;0;L;;;;;N;;;;;
10082;LINEAR B IDEOGRAM B104 DEER;Lo;0;L;;;;;N;;;;;
10083;LINEAR B IDEOGRAM B105 EQUID;Lo;0;L;;;;;N;;;;;
10084;LINEAR B IDEOGRAM B105F MARE;Lo;0;L;;;;;N;;;;;
10085;LINEAR B IDEOGRAM B105M STALLION;Lo;0;L;;;;;N;;;;;
10086;LINEAR B IDEOGRAM B106F EWE;Lo;0;L;;;;;N;;;;;
10087;LINEAR B IDEOGRAM B106M RAM;Lo;0;L;;;;;N;;;;;
10088;LINEAR B IDEOGRAM B107F SHE-GOAT;Lo;0;L;;;;;N;;;;;
10089;LINEAR B IDEOGRAM B107M HE-GOAT;Lo;0;L;;;;;N;;;;;
1008A;LINEAR B IDEOGRAM B108F SOW;Lo;0;L;;;;;N;;;;;
1008B;LINEAR B IDEOGRAM B108M BOAR;Lo;0;L;;;;;N;;;;;
1008C;LINEAR B IDEOGRAM B109F COW;Lo;0;L;;;;;N;;;;;
1008D;LINEAR B IDEOGRAM B109M BULL;Lo;0;L;;;;;N;;;;;
1008E;LINEAR B IDEOGRAM B120 WHEAT;Lo;0;L;;;;;N;;;;;
1008F;LINEAR B IDEOGRAM B121 BARLEY;Lo;0;L;;;;;N;;;;;
10090;LINEAR B IDEOGRAM B122 OLIVE;Lo;0;L;;;;;N;;;;;
10091;LINEAR B IDEOGRAM B123 SPICE;Lo;0;L;;;;;N;;;;;
10092;LINEAR B IDEOGRAM B125 CYPERUS;Lo;0;L;;;;;N;;;;;
10093;LINEAR B MONOGRAM B127 KAPO;Lo;0;L;;;;;N;;;;;
10094;LINEAR B MONOGRAM B128 KANAKO;Lo;0;L;;;;;N;;;;;
10095;LINEAR B IDEOGRAM B130 OIL;Lo;0;L;;;;;N;;;;;
10096;LINEAR B IDEOGRAM B131 WINE;Lo;0;L;;;;;N;;;;;
10097;LINEAR B IDEOGRAM B132;Lo;0;L;;;;;N;;;;;
10098;LINEAR B MONOGRAM B133 AREPA;Lo;0;L;;;;;N;;;;;
10099;LINEAR B MONOGRAM B135 MERI;Lo;0;L;;;;;N;;;;;
1009A;LINEAR B IDEOGRAM B140 BRONZE;Lo;0;L;;;;;N;;;;;
1009B;LINEAR B IDEOGRAM B141 GOLD;Lo;0;L;;;;;N;;;;;
1009C;LINEAR B IDEOGRAM B142;Lo;0;L;;;;;N;;;;;
1009D;LINEAR B IDEOGRAM B145 WOOL;Lo;0;L;;;;;N;;;;;
1009E;LINEAR B IDEOGRAM B146;Lo;0;L;;;;;N;;;;;
1009F;LINEAR B IDEOGRAM B150;Lo;0;L;;;;;N;;;;;
100A0;LINEAR B IDEOGRAM B151 HORN;Lo;0;L;;;;;N;;;;;
100A1;LINEAR B IDEOGRAM B152;Lo;0;L;;;;;N;;;;;
100A2;LINEAR B IDEOGRAM B153;Lo;0;L;;;;;N;;;;;
100A3;LINEAR B IDEOGRAM B154;Lo;0;L;;;;;N;;;;;
100A4;LINEAR B MONOGRAM B156 TURO2;Lo;0;L;;;;;N;;;;;
100A5;LINEAR B IDEOGRAM B157;Lo;0;L;;;;;N;;;;;
100A6;LINEAR B IDEOGRAM B158;Lo;0;L;;;;;N;;;;;
100A7;LINEAR B IDEOGRAM B159 CLOTH;Lo;0;L;;;;;N;;;;;
100A8;LINEAR B IDEOGRAM B160;Lo;0;L;;;;;N;;;;;
100A9;LINEAR B IDEOGRAM B161;Lo;0;L;;;;;N;;;;;
100AA;LINEAR B IDEOGRAM B162 GARMENT;Lo;0;L;;;;;N;;;;;
100AB;LINEAR B IDEOGRAM B163 ARMOUR;Lo;0;L;;;;;N;;;;;
100AC;LINEAR B IDEOGRAM B164;Lo;0;L;;;;;N;;;;;
100AD;LINEAR B IDEOGRAM B165;Lo;0;L;;;;;N;;;;;
100AE;LINEAR B IDEOGRAM B166;Lo;0;L;;;;;N;;;;;
100AF;LINEAR B IDEOGRAM B167;Lo;0;L;;;;;N;;;;;
100B0;LINEAR B IDEOGRAM B168;Lo;0;L;;;;;N;;;;;
100B1;LINEAR B IDEOGRAM B169;Lo;0;L;;;;;N;;;;;
100B2;LINEAR B IDEOGRAM B170;Lo;0;L;;;;;N;;;;;
100B3;LINEAR B IDEOGRAM B171;Lo;0;L;;;;;N;;;;;
100B4;LINEAR B IDEOGRAM B172;Lo;0;L;;;;;N;;;;;
100B5;LINEAR B IDEOGRAM B173 MONTH;Lo;0;L;;;;;N;;;;;
100B6;LINEAR B IDEOGRAM B174;Lo;0;L;;;;;N;;;;;
100B7;LINEAR B IDEOGRAM B176 TREE;Lo;0;L;;;;;N;;;;;
100B8;LINEAR B IDEOGRAM B177;Lo;0;L;;;;;N;;;;;
100B9;LINEAR B IDEOGRAM B178;Lo;0;L;;;;;N;;;;;
100BA;LINEAR B IDEOGRAM B179;Lo;0;L;;;;;N;;;;;
100BB;LINEAR B IDEOGRAM B180;Lo;0;L;;;;;N;;;;;
100BC;LINEAR B IDEOGRAM B181;Lo;0;L;;;;;N;;;;;
100BD;LINEAR B IDEOGRAM B182;Lo;0;L;;;;;N;;;;;
100BE;LINEAR B IDEOGRAM B183;Lo;0;L;;;;;N;;;;;
100BF;LINEAR B IDEOGRAM B184;Lo;0;L;;;;;N;;;;;
100C0;LINEAR B IDEOGRAM B185;Lo;0;L;;;;;N;;;;;
100C1;LINEAR B IDEOGRAM B189;Lo;0;L;;;;;N;;;;;
100C2;LINEAR B IDEOGRAM B190;Lo;0;L;;;;;N;;;;;
100C3;LINEAR B IDEOGRAM B191 HELMET;Lo;0;L;;;;;N;;;;;
100C4;LINEAR B IDEOGRAM B220 FOOTSTOOL;Lo;0;L;;;;;N;;;;;
100C5;LINEAR B IDEOGRAM B225 BATHTUB;Lo;0;L;;;;;N;;;;;
100C6;LINEAR B IDEOGRAM B230 SPEAR;Lo;0;L;;;;;N;;;;;
100C7;LINEAR B IDEOGRAM B231 ARROW;Lo;0;L;;;;;N;;;;;
100C8;LINEAR B IDEOGRAM B232;Lo;0;L;;;;;N;;;;;
100C9;LINEAR B IDEOGRAM B233 SWORD;Lo;0;L;;;;;N;;;;;
100CA;LINEAR B IDEOGRAM B234;Lo;0;L;;;;;N;;;;;
100CB;LINEAR B IDEOGRAM B236;Lo;0;L;;;;;N;;;;;
100CC;LINEAR B IDEOGRAM B240 WHEELED CHARIOT;Lo;0;L;;;;;N;;;;;
100CD;LINEAR B IDEOGRAM B241 CHARIOT;Lo;0;L;;;;;N;;;;;
100CE;LINEAR B IDEOGRAM B242 CHARIOT FRAME;Lo;0;L;;;;;N;;;;;
100CF;LINEAR B IDEOGRAM B243 WHEEL;Lo;0;L;;;;;N;;;;;
100D0;LINEAR B IDEOGRAM B245;Lo;0;L;;;;;N;;;;;
100D1;LINEAR B IDEOGRAM B246;Lo;0;L;;;;;N;;;;;
100D2;LINEAR B MONOGRAM B247 DIPTE;Lo;0;L;;;;;N;;;;;
100D3;LINEAR B IDEOGRAM B248;Lo;0;L;;;;;N;;;;;
100D4;LINEAR B IDEOGRAM B249;Lo;0;L;;;;;N;;;;;
100D5;LINEAR B IDEOGRAM B251;Lo;0;L;;;;;N;;;;;
100D6;LINEAR B IDEOGRAM B252;Lo;0;L;;;;;N;;;;;
100D7;LINEAR B IDEOGRAM B253;Lo;0;L;;;;;N;;;;;
100D8;LINEAR B IDEOGRAM B254 DART;Lo;0;L;;;;;N;;;;;
100D9;LINEAR B IDEOGRAM B255;Lo;0;L;;;;;N;;;;;
100DA;LINEAR B IDEOGRAM B256;Lo;0;L;;;;;N;;;;;
100DB;LINEAR B IDEOGRAM B257;Lo;0;L;;;;;N;;;;;
100DC;LINEAR B IDEOGRAM B258;Lo;0;L;;;;;N;;;;;
100DD;LINEAR B IDEOGRAM B259;Lo;0;L;;;;;N;;;;;
100DE;LINEAR B IDEOGRAM VESSEL B155;Lo;0;L;;;;;N;;;;;
100DF;LINEAR B IDEOGRAM VESSEL B200;Lo;0;L;;;;;N;;;;;
100E0;LINEAR B IDEOGRAM VESSEL B201;Lo;0;L;;;;;N;;;;;
100E1;LINEAR B IDEOGRAM VESSEL B202;Lo;0;L;;;;;N;;;;;
100E2;LINEAR B IDEOGRAM VESSEL B203;Lo;0;L;;;;;N;;;;;
100E3;LINEAR B IDEOGRAM VESSEL B204;Lo;0;L;;;;;N;;;;;
100E4;LINEAR B IDEOGRAM VESSEL B205;Lo;0;L;;;;;N;;;;;
100E5;LINEAR B IDEOGRAM VESSEL B206;Lo;0;L;;;;;N;;;;;
100E6;LINEAR B IDEOGRAM VESSEL B207;Lo;0;L;;;;;N;;;;;
100E7;LINEAR B IDEOGRAM VESSEL B208;Lo;0;L;;;;;N;;;;;
100E8;LINEAR B IDEOGRAM VESSEL B209;Lo;0;L;;;;;N;;;;;
100E9;LINEAR B IDEOGRAM VESSEL B210;Lo;0;L;;;;;N;;;;;
100EA;LINEAR B IDEOGRAM VESSEL B211;Lo;0;L;;;;;N;;;;;
100EB;LINEAR B IDEOGRAM VESSEL B212;Lo;0;L;;;;;N;;;;;
100EC;LINEAR B IDEOGRAM VESSEL B213;Lo;0;L;;;;;N;;;;;
100ED;LINEAR B IDEOGRAM VESSEL B214;Lo;0;L;;;;;N;;;;;
100EE;LINEAR B IDEOGRAM VESSEL B215;Lo;0;L;;;;;N;;;;;
100EF;LINEAR B IDEOGRAM VESSEL B216;Lo;0;L;;;;;N;;;;;
100F0;LINEAR B IDEOGRAM VESSEL B217;Lo;0;L;;;;;N;;;;;
100F1;LINEAR B IDEOGRAM VESSEL B218;Lo;0;L;;;;;N;;;;;
100F2;LINEAR B IDEOGRAM VESSEL B219;Lo;0;L;;;;;N;;;;;
100F3;LINEAR B IDEOGRAM VESSEL B221;Lo;0;L;;;;;N;;;;;
100F4;LINEAR B IDEOGRAM VESSEL B222;Lo;0;L;;;;;N;;;;;
100F5;LINEAR B IDEOGRAM VESSEL B226;Lo;0;L;;;;;N;;;;;
100F6;LINEAR B IDEOGRAM VESSEL B227;Lo;0;L;;;;;N;;;;;
100F7;LINEAR B IDEOGRAM VESSEL B228;Lo;0;L;;;;;N;;;;;
100F8;LINEAR B IDEOGRAM VESSEL B229;Lo;0;L;;;;;N;;;;;
100F9;LINEAR B IDEOGRAM VESSEL B250;Lo;0;L;;;;;N;;;;;
100FA;LINEAR B IDEOGRAM VESSEL B305;Lo;0;L;;;;;N;;;;;
10100;AEGEAN WORD SEPARATOR LINE;Po;0;L;;;;;N;;;;;
10101;AEGEAN WORD SEPARATOR DOT;Po;0;ON;;;;;N;;;;;
10102;AEGEAN CHECK MARK;Po;0;L;;;;;N;;;;;
10107;AEGEAN NUMBER ONE;No;0;L;;;;1;N;;;;;
10108;AEGEAN NUMBER TWO;No;0;L;;;;2;N;;;;;
10109;AEGEAN NUMBER THREE;No;0;L;;;;3;N;;;;;
1010A;AEGEAN NUMBER FOUR;No;0;L;;;;4;N;;;;;
1010B;AEGEAN NUMBER FIVE;No;0;L;;;;5;N;;;;;
1010C;AEGEAN NUMBER SIX;No;0;L;;;;6;N;;;;;
1010D;AEGEAN NUMBER SEVEN;No;0;L;;;;7;N;;;;;
1010E;AEGEAN NUMBER EIGHT;No;0;L;;;;8;N;;;;;
1010F;AEGEAN NUMBER NINE;No;0;L;;;;9;N;;;;;
10110;AEGEAN NUMBER TEN;No;0;L;;;;10;N;;;;;
10111;AEGEAN NUMBER TWENTY;No;0;L;;;;20;N;;;;;
10112;AEGEAN NUMBER THIRTY;No;0;L;;;;30;N;;;;;
10113;AEGEAN NUMBER FORTY;No;0;L;;;;40;N;;;;;
10114;AEGEAN NUMBER FIFTY;No;0;L;;;;50;N;;;;;
10115;AEGEAN NUMBER SIXTY;No;0;L;;;;60;N;;;;;
10116;AEGEAN NUMBER SEVENTY;No;0;L;;;;70;N;;;;;
10117;AEGEAN NUMBER EIGHTY;No;0;L;;;;80;N;;;;;
10118;AEGEAN NUMBER NINETY;No;0;L;;;;90;N;;;;;
10119;AEGEAN NUMBER ONE HUNDRED;No;0;L;;;;100;N;;;;;
1011A;AEGEAN NUMBER TWO HUNDRED;No;0;L;;;;200;N;;;;;
1011B;AEGEAN NUMBER THREE HUNDRED;No;0;L;;;;300;N;;;;;
1011C;AEGEAN NUMBER FOUR HUNDRED;No;0;L;;;;400;N;;;;;
1011D;AEGEAN NUMBER FIVE HUNDRED;No;0;L;;;;500;N;;;;;
1011E;AEGEAN NUMBER SIX HUNDRED;No;0;L;;;;600;N;;;;;
1011F;AEGEAN NUMBER SEVEN HUNDRED;No;0;L;;;;700;N;;;;;
10120;AEGEAN NUMBER EIGHT HUNDRED;No;0;L;;;;800;N;;;;;
10121;AEGEAN NUMBER NINE HUNDRED;No;0;L;;;;900;N;;;;;
10122;AEGEAN NUMBER ONE THOUSAND;No;0;L;;;;1000;N;;;;;
10123;AEGEAN NUMBER TWO THOUSAND;No;0;L;;;;2000;N;;;;;
10124;AEGEAN NUMBER THREE THOUSAND;No;0;L;;;;3000;N;;;;;
10125;AEGEAN NUMBER FOUR THOUSAND;No;0;L;;;;4000;N;;;;;
10126;AEGEAN NUMBER FIVE THOUSAND;No;0;L;;;;5000;N;;;;;
10127;AEGEAN NUMBER SIX THOUSAND;No;0;L;;;;6000;N;;;;;
10128;AEGEAN NUMBER SEVEN THOUSAND;No;0;L;;;;7000;N;;;;;
10129;AEGEAN NUMBER EIGHT THOUSAND;No;0;L;;;;8000;N;;;;;
1012A;AEGEAN NUMBER NINE THOUSAND;No;0;L;;;;9000;N;;;;;
1012B;AEGEAN NUMBER TEN THOUSAND;No;0;L;;;;10000;N;;;;;
1012C;AEGEAN NUMBER TWENTY THOUSAND;No;0;L;;;;20000;N;;;;;
1012D;AEGEAN NUMBER THIRTY THOUSAND;No;0;L;;;;30000;N;;;;;
1012E;AEGEAN NUMBER FORTY THOUSAND;No;0;L;;;;40000;N;;;;;
1012F;AEGEAN NUMBER FIFTY THOUSAND;No;0;L;;;;50000;N;;;;;
10130;AEGEAN NUMBER SIXTY THOUSAND;No;0;L;;;;60000;N;;;;;
10131;AEGEAN NUMBER SEVENTY THOUSAND;No;0;L;;;;70000;N;;;;;
10132;AEGEAN NUMBER EIGHTY THOUSAND;No;0;L;;;;80000;N;;;;;
10133;AEGEAN NUMBER NINETY THOUSAND;No;0;L;;;;90000;N;;;;;
10137;AEGEAN WEIGHT BASE UNIT;So;0;L;;;;;N;;;;;
10138;AEGEAN WEIGHT FIRST SUBUNIT;So;0;L;;;;;N;;;;;
10139;AEGEAN WEIGHT SECOND SUBUNIT;So;0;L;;;;;N;;;;;
1013A;AEGEAN WEIGHT THIRD SUBUNIT;So;0;L;;;;;N;;;;;
1013B;AEGEAN WEIGHT FOURTH SUBUNIT;So;0;L;;;;;N;;;;;
1013C;AEGEAN DRY MEASURE FIRST SUBUNIT;So;0;L;;;;;N;;;;;
1013D;AEGEAN LIQUID MEASURE FIRST SUBUNIT;So;0;L;;;;;N;;;;;
1013E;AEGEAN MEASURE SECOND SUBUNIT;So;0;L;;;;;N;;;;;
1013F;AEGEAN MEASURE THIRD SUBUNIT;So;0;L;;;;;N;;;;;
10140;GREEK ACROPHONIC ATTIC ONE QUARTER;Nl;0;ON;;;;1/4;N;;;;;
10141;GREEK ACROPHONIC ATTIC ONE HALF;Nl;0;ON;;;;1/2;N;;;;;
10142;GREEK ACROPHONIC ATTIC ONE DRACHMA;Nl;0;ON;;;;1;N;;;;;
10143;GREEK ACROPHONIC ATTIC FIVE;Nl;0;ON;;;;5;N;;;;;
10144;GREEK ACROPHONIC ATTIC FIFTY;Nl;0;ON;;;;50;N;;;;;
10145;GREEK ACROPHONIC ATTIC FIVE HUNDRED;Nl;0;ON;;;;500;N;;;;;
10146;GREEK ACROPHONIC ATTIC FIVE THOUSAND;Nl;0;ON;;;;5000;N;;;;;
10147;GREEK ACROPHONIC ATTIC FIFTY THOUSAND;Nl;0;ON;;;;50000;N;;;;;
10148;GREEK ACROPHONIC ATTIC FIVE TALENTS;Nl;0;ON;;;;5;N;;;;;
10149;GREEK ACROPHONIC ATTIC TEN TALENTS;Nl;0;ON;;;;10;N;;;;;
1014A;GREEK ACROPHONIC ATTIC FIFTY TALENTS;Nl;0;ON;;;;50;N;;;;;
1014B;GREEK ACROPHONIC ATTIC ONE HUNDRED TALENTS;Nl;0;ON;;;;100;N;;;;;
1014C;GREEK ACROPHONIC ATTIC FIVE HUNDRED TALENTS;Nl;0;ON;;;;500;N;;;;;
1014D;GREEK ACROPHONIC ATTIC ONE THOUSAND TALENTS;Nl;0;ON;;;;1000;N;;;;;
1014E;GREEK ACROPHONIC ATTIC FIVE THOUSAND TALENTS;Nl;0;ON;;;;5000;N;;;;;
1014F;GREEK ACROPHONIC ATTIC FIVE STATERS;Nl;0;ON;;;;5;N;;;;;
10150;GREEK ACROPHONIC ATTIC TEN STATERS;Nl;0;ON;;;;10;N;;;;;
10151;GREEK ACROPHONIC ATTIC FIFTY STATERS;Nl;0;ON;;;;50;N;;;;;
10152;GREEK ACROPHONIC ATTIC ONE HUNDRED STATERS;Nl;0;ON;;;;100;N;;;;;
10153;GREEK ACROPHONIC ATTIC FIVE HUNDRED STATERS;Nl;0;ON;;;;500;N;;;;;
10154;GREEK ACROPHONIC ATTIC ONE THOUSAND STATERS;Nl;0;ON;;;;1000;N;;;;;
10155;GREEK ACROPHONIC ATTIC TEN THOUSAND STATERS;Nl;0;ON;;;;10000;N;;;;;
10156;GREEK ACROPHONIC ATTIC FIFTY THOUSAND STATERS;Nl;0;ON;;;;50000;N;;;;;
10157;GREEK ACROPHONIC ATTIC TEN MNAS;Nl;0;ON;;;;10;N;;;;;
10158;GREEK ACROPHONIC HERAEUM ONE PLETHRON;Nl;0;ON;;;;1;N;;;;;
10159;GREEK ACROPHONIC THESPIAN ONE;Nl;0;ON;;;;1;N;;;;;
1015A;GREEK ACROPHONIC HERMIONIAN ONE;Nl;0;ON;;;;1;N;;;;;
1015B;GREEK ACROPHONIC EPIDAUREAN TWO;Nl;0;ON;;;;2;N;;;;;
1015C;GREEK ACROPHONIC THESPIAN TWO;Nl;0;ON;;;;2;N;;;;;
1015D;GREEK ACROPHONIC CYRENAIC TWO DRACHMAS;Nl;0;ON;;;;2;N;;;;;
1015E;GREEK ACROPHONIC EPIDAUREAN TWO DRACHMAS;Nl;0;ON;;;;2;N;;;;;
1015F;GREEK ACROPHONIC TROEZENIAN FIVE;Nl;0;ON;;;;5;N;;;;;
10160;GREEK ACROPHONIC TROEZENIAN TEN;Nl;0;ON;;;;10;N;;;;;
10161;GREEK ACROPHONIC TROEZENIAN TEN ALTERNATE FORM;Nl;0;ON;;;;10;N;;;;;
10162;GREEK ACROPHONIC HERMIONIAN TEN;Nl;0;ON;;;;10;N;;;;;
10163;GREEK ACROPHONIC MESSENIAN TEN;Nl;0;ON;;;;10;N;;;;;
10164;GREEK ACROPHONIC THESPIAN TEN;Nl;0;ON;;;;10;N;;;;;
10165;GREEK ACROPHONIC THESPIAN THIRTY;Nl;0;ON;;;;30;N;;;;;
10166;GREEK ACROPHONIC TROEZENIAN FIFTY;Nl;0;ON;;;;50;N;;;;;
10167;GREEK ACROPHONIC TROEZENIAN FIFTY ALTERNATE FORM;Nl;0;ON;;;;50;N;;;;;
10168;GREEK ACROPHONIC HERMIONIAN FIFTY;Nl;0;ON;;;;50;N;;;;;
10169;GREEK ACROPHONIC THESPIAN FIFTY;Nl;0;ON;;;;50;N;;;;;
1016A;GREEK ACROPHONIC THESPIAN ONE HUNDRED;Nl;0;ON;;;;100;N;;;;;
1016B;GREEK ACROPHONIC THESPIAN THREE HUNDRED;Nl;0;ON;;;;300;N;;;;;
1016C;GREEK ACROPHONIC EPIDAUREAN FIVE HUNDRED;Nl;0;ON;;;;500;N;;;;;
1016D;GREEK ACROPHONIC TROEZENIAN FIVE HUNDRED;Nl;0;ON;;;;500;N;;;;;
1016E;GREEK ACROPHONIC THESPIAN FIVE HUNDRED;Nl;0;ON;;;;500;N;;;;;
1016F;GREEK ACROPHONIC CARYSTIAN FIVE HUNDRED;Nl;0;ON;;;;500;N;;;;;
10170;GREEK ACROPHONIC NAXIAN FIVE HUNDRED;Nl;0;ON;;;;500;N;;;;;
10171;GREEK ACROPHONIC THESPIAN ONE THOUSAND;Nl;0;ON;;;;1000;N;;;;;
10172;GREEK ACROPHONIC THESPIAN FIVE THOUSAND;Nl;0;ON;;;;5000;N;;;;;
10173;GREEK ACROPHONIC DELPHIC FIVE MNAS;Nl;0;ON;;;;5;N;;;;;
10174;GREEK ACROPHONIC STRATIAN FIFTY MNAS;Nl;0;ON;;;;50;N;;;;;
10175;GREEK ONE HALF SIGN;No;0;ON;;;;1/2;N;;;;;
10176;GREEK ONE HALF SIGN ALTERNATE FORM;No;0;ON;;;;1/2;N;;;;;
10177;GREEK TWO THIRDS SIGN;No;0;ON;;;;2/3;N;;;;;
10178;GREEK THREE QUARTERS SIGN;No;0;ON;;;;3/4;N;;;;;
10179;GREEK YEAR SIGN;So;0;ON;;;;;N;;;;;
1017A;GREEK TALENT SIGN;So;0;ON;;;;;N;;;;;
1017B;GREEK DRACHMA SIGN;So;0;ON;;;;;N;;;;;
1017C;GREEK OBOL SIGN;So;0;ON;;;;;N;;;;;
1017D;GREEK TWO OBOLS SIGN;So;0;ON;;;;;N;;;;;
1017E;GREEK THREE OBOLS SIGN;So;0;ON;;;;;N;;;;;
1017F;GREEK FOUR OBOLS SIGN;So;0;ON;;;;;N;;;;;
10180;GREEK FIVE OBOLS SIGN;So;0;ON;;;;;N;;;;;
10181;GREEK METRETES SIGN;So;0;ON;;;;;N;;;;;
10182;GREEK KYATHOS BASE SIGN;So;0;ON;;;;;N;;;;;
10183;GREEK LITRA SIGN;So;0;ON;;;;;N;;;;;
10184;GREEK OUNKIA SIGN;So;0;ON;;;;;N;;;;;
10185;GREEK XESTES SIGN;So;0;ON;;;;;N;;;;;
10186;GREEK ARTABE SIGN;So;0;ON;;;;;N;;;;;
10187;GREEK AROURA SIGN;So;0;ON;;;;;N;;;;;
10188;GREEK GRAMMA SIGN;So;0;ON;;;;;N;;;;;
10189;GREEK TRYBLION BASE SIGN;So;0;ON;;;;;N;;;;;
1018A;GREEK ZERO SIGN;No;0;ON;;;;0;N;;;;;
1018B;GREEK ONE QUARTER SIGN;No;0;ON;;;;1/4;N;;;;;
1018C;GREEK SINUSOID SIGN;So;0;ON;;;;;N;;;;;
1018D;GREEK INDICTION SIGN;So;0;L;;;;;N;;;;;
1018E;NOMISMA SIGN;So;0;L;;;;;N;;;;;
10190;ROMAN SEXTANS SIGN;So;0;ON;;;;;N;;;;;
10191;ROMAN UNCIA SIGN;So;0;ON;;;;;N;;;;;
10192;ROMAN SEMUNCIA SIGN;So;0;ON;;;;;N;;;;;
10193;ROMAN SEXTULA SIGN;So;0;ON;;;;;N;;;;;
10194;ROMAN DIMIDIA SEXTULA SIGN;So;0;ON;;;;;N;;;;;
10195;ROMAN SILIQUA SIGN;So;0;ON;;;;;N;;;;;
10196;ROMAN DENARIUS SIGN;So;0;ON;;;;;N;;;;;
10197;ROMAN QUINARIUS SIGN;So;0;ON;;;;;N;;;;;
10198;ROMAN SESTERTIUS SIGN;So;0;ON;;;;;N;;;;;
10199;ROMAN DUPONDIUS SIGN;So;0;ON;;;;;N;;;;;
1019A;ROMAN AS SIGN;So;0;ON;;;;;N;;;;;
1019B;ROMAN CENTURIAL SIGN;So;0;ON;;;;;N;;;;;
1019C;ASCIA SYMBOL;So;0;ON;;;;;N;;;;;
101A0;GREEK SYMBOL TAU RHO;So;0;ON;;;;;N;;;;;
101D0;PHAISTOS DISC SIGN PEDESTRIAN;So;0;L;;;;;N;;;;;
101D1;PHAISTOS DISC SIGN PLUMED HEAD;So;0;L;;;;;N;;;;;
101D2;PHAISTOS DISC SIGN TATTOOED HEAD;So;0;L;;;;;N;;;;;
101D3;PHAISTOS DISC SIGN CAPTIVE;So;0;L;;;;;N;;;;;
101D4;PHAISTOS DISC SIGN CHILD;So;0;L;;;;;N;;;;;
101D5;PHAISTOS DISC SIGN WOMAN;So;0;L;;;;;N;;;;;
101D6;PHAISTOS DISC SIGN HELMET;So;0;L;;;;;N;;;;;
101D7;PHAISTOS DISC SIGN GAUNTLET;So;0;L;;;;;N;;;;;
101D8;PHAISTOS DISC SIGN TIARA;So;0;L;;;;;N;;;;;
101D9;PHAISTOS DISC SIGN ARROW;So;0;L;;;;;N;;;;;
101DA;PHAISTOS DISC SIGN BOW;So;0;L;;;;;N;;;;;
101DB;PHAISTOS DISC SIGN SHIELD;So;0;L;;;;;N;;;;;
101DC;PHAISTOS DISC SIGN CLUB;So;0;L;;;;;N;;;;;
101DD;PHAISTOS DISC SIGN MANACLES;So;0;L;;;;;N;;;;;
101DE;PHAISTOS DISC SIGN MATTOCK;So;0;L;;;;;N;;;;;
101DF;PHAISTOS DISC SIGN SAW;So;0;L;;;;;N;;;;;
101E0;PHAISTOS DISC SIGN LID;So;0;L;;;;;N;;;;;
101E1;PHAISTOS DISC SIGN BOOMERANG;So;0;L;;;;;N;;;;;
101E2;PHAISTOS DISC SIGN CARPENTRY PLANE;So;0;L;;;;;N;;;;;
101E3;PHAISTOS DISC SIGN DOLIUM;So;0;L;;;;;N;;;;;
101E4;PHAISTOS DISC SIGN COMB;So;0;L;;;;;N;;;;;
101E5;PHAISTOS DISC SIGN SLING;So;0;L;;;;;N;;;;;
101E6;PHAISTOS DISC SIGN COLUMN;So;0;L;;;;;N;;;;;
101E7;PHAISTOS DISC SIGN BEEHIVE;So;0;L;;;;;N;;;;;
101E8;PHAISTOS DISC SIGN SHIP;So;0;L;;;;;N;;;;;
101E9;PHAISTOS DISC SIGN HORN;So;0;L;;;;;N;;;;;
101EA;PHAISTOS DISC SIGN HIDE;So;0;L;;;;;N;;;;;
101EB;PHAISTOS DISC SIGN BULLS LEG;So;0;L;;;;;N;;;;;
101EC;PHAISTOS DISC SIGN CAT;So;0;L;;;;;N;;;;;
101ED;PHAISTOS DISC SIGN RAM;So;0;L;;;;;N;;;;;
101EE;PHAISTOS DISC SIGN EAGLE;So;0;L;;;;;N;;;;;
101EF;PHAISTOS DISC SIGN DOVE;So;0;L;;;;;N;;;;;
101F0;PHAISTOS DISC SIGN TUNNY;So;0;L;;;;;N;;;;;
101F1;PHAISTOS DISC SIGN BEE;So;0;L;;;;;N;;;;;
101F2;PHAISTOS DISC SIGN PLANE TREE;So;0;L;;;;;N;;;;;
101F3;PHAISTOS DISC SIGN VINE;So;0;L;;;;;N;;;;;
101F4;PHAISTOS DISC SIGN PAPYRUS;So;0;L;;;;;N;;;;;
101F5;PHAISTOS DISC SIGN ROSETTE;So;0;L;;;;;N;;;;;
101F6;PHAISTOS DISC SIGN LILY;So;0;L;;;;;N;;;;;
101F7;PHAISTOS DISC SIGN OX BACK;So;0;L;;;;;N;;;;;
101F8;PHAISTOS DISC SIGN FLUTE;So;0;L;;;;;N;;;;;
101F9;PHAISTOS DISC SIGN GRATER;So;0;L;;;;;N;;;;;
101FA;PHAISTOS DISC SIGN STRAINER;So;0;L;;;;;N;;;;;
101FB;PHAISTOS DISC SIGN SMALL AXE;So;0;L;;;;;N;;;;;
101FC;PHAISTOS DISC SIGN WAVY BAND;So;0;L;;;;;N;;;;;
101FD;PHAISTOS DISC SIGN COMBINING OBLIQUE STROKE;Mn;220;NSM;;;;;N;;;;;
10280;LYCIAN LETTER A;Lo;0;L;;;;;N;;;;;
10281;LYCIAN LETTER E;Lo;0;L;;;;;N;;;;;
10282;LYCIAN LETTER B;Lo;0;L;;;;;N;;;;;
10283;LYCIAN LETTER BH;Lo;0;L;;;;;N;;;;;
10284;LYCIAN LETTER G;Lo;0;L;;;;;N;;;;;
10285;LYCIAN LETTER D;Lo;0;L;;;;;N;;;;;
10286;LYCIAN LETTER I;Lo;0;L;;;;;N;;;;;
10287;LYCIAN LETTER W;Lo;0;L;;;;;N;;;;;
10288;LYCIAN LETTER Z;Lo;0;L;;;;;N;;;;;
10289;LYCIAN LETTER TH;Lo;0;L;;;;;N;;;;;
1028A;LYCIAN LETTER J;Lo;0;L;;;;;N;;;;;
1028B;LYCIAN LETTER K;Lo;0;L;;;;;N;;;;;
1028C;LYCIAN LETTER Q;Lo;0;L;;;;;N;;;;;
1028D;LYCIAN LETTER L;Lo;0;L;;;;;N;;;;;
1028E;LYCIAN LETTER M;Lo;0;L;;;;;N;;;;;
1028F;LYCIAN LETTER N;Lo;0;L;;;;;N;;;;;
10290;LYCIAN LETTER MM;Lo;0;L;;;;;N;;;;;
10291;LYCIAN LETTER NN;Lo;0;L;;;;;N;;;;;
10292;LYCIAN LETTER U;Lo;0;L;;;;;N;;;;;
10293;LYCIAN LETTER P;Lo;0;L;;;;;N;;;;;
10294;LYCIAN LETTER KK;Lo;0;L;;;;;N;;;;;
10295;LYCIAN LETTER R;Lo;0;L;;;;;N;;;;;
10296;LYCIAN LETTER S;Lo;0;L;;;;;N;;;;;
10297;LYCIAN LETTER T;Lo;0;L;;;;;N;;;;;
10298;LYCIAN LETTER TT;Lo;0;L;;;;;N;;;;;
10299;LYCIAN LETTER AN;Lo;0;L;;;;;N;;;;;
1029A;LYCIAN LETTER EN;Lo;0;L;;;;;N;;;;;
1029B;LYCIAN LETTER H;Lo;0;L;;;;;N;;;;;
1029C;LYCIAN LETTER X;Lo;0;L;;;;;N;;;;;
102A0;CARIAN LETTER A;Lo;0;L;;;;;N;;;;;
102A1;CARIAN LETTER P2;Lo;0;L;;;;;N;;;;;
102A2;CARIAN LETTER D;Lo;0;L;;;;;N;;;;;
102A3;CARIAN LETTER L;Lo;0;L;;;;;N;;;;;
102A4;CARIAN LETTER UUU;Lo;0;L;;;;;N;;;;;
102A5;CARIAN LETTER R;Lo;0;L;;;;;N;;;;;
102A6;CARIAN LETTER LD;Lo;0;L;;;;;N;;;;;
102A7;CARIAN LETTER A2;Lo;0;L;;;;;N;;;;;
102A8;CARIAN LETTER Q;Lo;0;L;;;;;N;;;;;
102A9;CARIAN LETTER B;Lo;0;L;;;;;N;;;;;
102AA;CARIAN LETTER M;Lo;0;L;;;;;N;;;;;
102AB;CARIAN LETTER O;Lo;0;L;;;;;N;;;;;
102AC;CARIAN LETTER D2;Lo;0;L;;;;;N;;;;;
102AD;CARIAN LETTER T;Lo;0;L;;;;;N;;;;;
102AE;CARIAN LETTER SH;Lo;0;L;;;;;N;;;;;
102AF;CARIAN LETTER SH2;Lo;0;L;;;;;N;;;;;
102B0;CARIAN LETTER S;Lo;0;L;;;;;N;;;;;
102B1;CARIAN LETTER C-18;Lo;0;L;;;;;N;;;;;
102B2;CARIAN LETTER U;Lo;0;L;;;;;N;;;;;
102B3;CARIAN LETTER NN;Lo;0;L;;;;;N;;;;;
102B4;CARIAN LETTER X;Lo;0;L;;;;;N;;;;;
102B5;CARIAN LETTER N;Lo;0;L;;;;;N;;;;;
102B6;CARIAN LETTER TT2;Lo;0;L;;;;;N;;;;;
102B7;CARIAN LETTER P;Lo;0;L;;;;;N;;;;;
102B8;CARIAN LETTER SS;Lo;0;L;;;;;N;;;;;
102B9;CARIAN LETTER I;Lo;0;L;;;;;N;;;;;
102BA;CARIAN LETTER E;Lo;0;L;;;;;N;;;;;
102BB;CARIAN LETTER UUUU;Lo;0;L;;;;;N;;;;;
102BC;CARIAN LETTER K;Lo;0;L;;;;;N;;;;;
102BD;CARIAN LETTER K2;Lo;0;L;;;;;N;;;;;
102BE;CARIAN LETTER ND;Lo;0;L;;;;;N;;;;;
102BF;CARIAN LETTER UU;Lo;0;L;;;;;N;;;;;
102C0;CARIAN LETTER G;Lo;0;L;;;;;N;;;;;
102C1;CARIAN LETTER G2;Lo;0;L;;;;;N;;;;;
102C2;CARIAN LETTER ST;Lo;0;L;;;;;N;;;;;
102C3;CARIAN LETTER ST2;Lo;0;L;;;;;N;;;;;
102C4;CARIAN LETTER NG;Lo;0;L;;;;;N;;;;;
102C5;CARIAN LETTER II;Lo;0;L;;;;;N;;;;;
102C6;CARIAN LETTER C-39;Lo;0;L;;;;;N;;;;;
102C7;CARIAN LETTER TT;Lo;0;L;;;;;N;;;;;
102C8;CARIAN LETTER UUU2;Lo;0;L;;;;;N;;;;;
102C9;CARIAN LETTER RR;Lo;0;L;;;;;N;;;;;
102CA;CARIAN LETTER MB;Lo;0;L;;;;;N;;;;;
102CB;CARIAN LETTER MB2;Lo;0;L;;;;;N;;;;;
102CC;CARIAN LETTER MB3;Lo;0;L;;;;;N;;;;;
102CD;CARIAN LETTER MB4;Lo;0;L;;;;;N;;;;;
102CE;CARIAN LETTER LD2;Lo;0;L;;;;;N;;;;;
102CF;CARIAN LETTER E2;Lo;0;L;;;;;N;;;;;
102D0;CARIAN LETTER UUU3;Lo;0;L;;;;;N;;;;;
102E0;COPTIC EPACT THOUSANDS MARK;Mn;220;NSM;;;;;N;;;;;
102E1;COPTIC EPACT DIGIT ONE;No;0;EN;;;;1;N;;;;;
102E2;COPTIC EPACT DIGIT TWO;No;0;EN;;;;2;N;;;;;
102E3;COPTIC EPACT DIGIT THREE;No;0;EN;;;;3;N;;;;;
102E4;COPTIC EPACT DIGIT FOUR;No;0;EN;;;;4;N;;;;;
102E5;COPTIC EPACT DIGIT FIVE;No;0;EN;;;;5;N;;;;;
102E6;COPTIC EPACT DIGIT SIX;No;0;EN;;;;6;N;;;;;
102E7;COPTIC EPACT DIGIT SEVEN;No;0;EN;;;;7;N;;;;;
102E8;COPTIC EPACT DIGIT EIGHT;No;0;EN;;;;8;N;;;;;
102E9;COPTIC EPACT DIGIT NINE;No;0;EN;;;;9;N;;;;;
102EA;COPTIC EPACT NUMBER TEN;No;0;EN;;;;10;N;;;;;
102EB;COPTIC EPACT NUMBER TWENTY;No;0;EN;;;;20;N;;;;;
102EC;COPTIC EPACT NUMBER THIRTY;No;0;EN;;;;30;N;;;;;
102ED;COPTIC EPACT NUMBER FORTY;No;0;EN;;;;40;N;;;;;
102EE;COPTIC EPACT NUMBER FIFTY;No;0;EN;;;;50;N;;;;;
102EF;COPTIC EPACT NUMBER SIXTY;No;0;EN;;;;60;N;;;;;
102F0;COPTIC EPACT NUMBER SEVENTY;No;0;EN;;;;70;N;;;;;
102F1;COPTIC EPACT NUMBER EIGHTY;No;0;EN;;;;80;N;;;;;
102F2;COPTIC EPACT NUMBER NINETY;No;0;EN;;;;90;N;;;;;
102F3;COPTIC EPACT NUMBER ONE HUNDRED;No;0;EN;;;;100;N;;;;;
102F4;COPTIC EPACT NUMBER TWO HUNDRED;No;0;EN;;;;200;N;;;;;
102F5;COPTIC EPACT NUMBER THREE HUNDRED;No;0;EN;;;;300;N;;;;;
102F6;COPTIC EPACT NUMBER FOUR HUNDRED;No;0;EN;;;;400;N;;;;;
102F7;COPTIC EPACT NUMBER FIVE HUNDRED;No;0;EN;;;;500;N;;;;;
102F8;COPTIC EPACT NUMBER SIX HUNDRED;No;0;EN;;;;600;N;;;;;
102F9;COPTIC EPACT NUMBER SEVEN HUNDRED;No;0;EN;;;;700;N;;;;;
102FA;COPTIC EPACT NUMBER EIGHT HUNDRED;No;0;EN;;;;800;N;;;;;
102FB;COPTIC EPACT NUMBER NINE HUNDRED;No;0;EN;;;;900;N;;;;;
10300;OLD ITALIC LETTER A;Lo;0;L;;;;;N;;;;;
10301;OLD ITALIC LETTER BE;Lo;0;L;;;;;N;;;;;
10302;OLD ITALIC LETTER KE;Lo;0;L;;;;;N;;;;;
10303;OLD ITALIC LETTER DE;Lo;0;L;;;;;N;;;;;
10304;OLD ITALIC LETTER E;Lo;0;L;;;;;N;;;;;
10305;OLD ITALIC LETTER VE;Lo;0;L;;;;;N;;;;;
10306;OLD ITALIC LETTER ZE;Lo;0;L;;;;;N;;;;;
10307;OLD ITALIC LETTER HE;Lo;0;L;;;;;N;;;;;
10308;OLD ITALIC LETTER THE;Lo;0;L;;;;;N;;;;;
10309;OLD ITALIC LETTER I;Lo;0;L;;;;;N;;;;;
1030A;OLD ITALIC LETTER KA;Lo;0;L;;;;;N;;;;;
1030B;OLD ITALIC LETTER EL;Lo;0;L;;;;;N;;;;;
1030C;OLD ITALIC LETTER EM;Lo;0;L;;;;;N;;;;;
1030D;OLD ITALIC LETTER EN;Lo;0;L;;;;;N;;;;;
1030E;OLD ITALIC LETTER ESH;Lo;0;L;;;;;N;;;;;
1030F;OLD ITALIC LETTER O;Lo;0;L;;;;;N;;;;;
10310;OLD ITALIC LETTER PE;Lo;0;L;;;;;N;;;;;
10311;OLD ITALIC LETTER SHE;Lo;0;L;;;;;N;;;;;
10312;OLD ITALIC LETTER KU;Lo;0;L;;;;;N;;;;;
10313;OLD ITALIC LETTER ER;Lo;0;L;;;;;N;;;;;
10314;OLD ITALIC LETTER ES;Lo;0;L;;;;;N;;;;;
10315;OLD ITALIC LETTER TE;Lo;0;L;;;;;N;;;;;
10316;OLD ITALIC LETTER U;Lo;0;L;;;;;N;;;;;
10317;OLD ITALIC LETTER EKS;Lo;0;L;;;;;N;;;;;
10318;OLD ITALIC LETTER PHE;Lo;0;L;;;;;N;;;;;
10319;OLD ITALIC LETTER KHE;Lo;0;L;;;;;N;;;;;
1031A;OLD ITALIC LETTER EF;Lo;0;L;;;;;N;;;;;
1031B;OLD ITALIC LETTER ERS;Lo;0;L;;;;;N;;;;;
1031C;OLD ITALIC LETTER CHE;Lo;0;L;;;;;N;;;;;
1031D;OLD ITALIC LETTER II;Lo;0;L;;;;;N;;;;;
1031E;OLD ITALIC LETTER UU;Lo;0;L;;;;;N;;;;;
1031F;OLD ITALIC LETTER ESS;Lo;0;L;;;;;N;;;;;
10320;OLD ITALIC NUMERAL ONE;No;0;L;;;;1;N;;;;;
10321;OLD ITALIC NUMERAL FIVE;No;0;L;;;;5;N;;;;;
10322;OLD ITALIC NUMERAL TEN;No;0;L;;;;10;N;;;;;
10323;OLD ITALIC NUMERAL FIFTY;No;0;L;;;;50;N;;;;;
1032D;OLD ITALIC LETTER YE;Lo;0;L;;;;;N;;;;;
1032E;OLD ITALIC LETTER NORTHERN TSE;Lo;0;L;;;;;N;;;;;
1032F;OLD ITALIC LETTER SOUTHERN TSE;Lo;0;L;;;;;N;;;;;
10330;GOTHIC LETTER AHSA;Lo;0;L;;;;;N;;;;;
10331;GOTHIC LETTER BAIRKAN;Lo;0;L;;;;;N;;;;;
10332;GOTHIC LETTER GIBA;Lo;0;L;;;;;N;;;;;
10333;GOTHIC LETTER DAGS;Lo;0;L;;;;;N;;;;;
10334;GOTHIC LETTER AIHVUS;Lo;0;L;;;;;N;;;;;
10335;GOTHIC LETTER QAIRTHRA;Lo;0;L;;;;;N;;;;;
10336;GOTHIC LETTER IUJA;Lo;0;L;;;;;N;;;;;
10337;GOTHIC LETTER HAGL;Lo;0;L;;;;;N;;;;;
10338;GOTHIC LETTER THIUTH;Lo;0;L;;;;;N;;;;;
10339;GOTHIC LETTER EIS;Lo;0;L;;;;;N;;;;;
1033A;GOTHIC LETTER KUSMA;Lo;0;L;;;;;N;;;;;
1033B;GOTHIC LETTER LAGUS;Lo;0;L;;;;;N;;;;;
1033C;GOTHIC LETTER MANNA;Lo;0;L;;;;;N;;;;;
1033D;GOTHIC LETTER NAUTHS;Lo;0;L;;;;;N;;;;;
1033E;GOTHIC LETTER JER;Lo;0;L;;;;;N;;;;;
1033F;GOTHIC LETTER URUS;Lo;0;L;;;;;N;;;;;
10340;GOTHIC LETTER PAIRTHRA;Lo;0;L;;;;;N;;;;;
10341;GOTHIC LETTER NINETY;Nl;0;L;;;;90;N;;;;;
10342;GOTHIC LETTER RAIDA;Lo;0;L;;;;;N;;;;;
10343;GOTHIC LETTER SAUIL;Lo;0;L;;;;;N;;;;;
10344;GOTHIC LETTER TEIWS;Lo;0;L;;;;;N;;;;;
10345;GOTHIC LETTER WINJA;Lo;0;L;;;;;N;;;;;
10346;GOTHIC LETTER FAIHU;Lo;0;L;;;;;N;;;;;
10347;GOTHIC LETTER IGGWS;Lo;0;L;;;;;N;;;;;
10348;GOTHIC LETTER HWAIR;Lo;0;L;;;;;N;;;;;
10349;GOTHIC LETTER OTHAL;Lo;0;L;;;;;N;;;;;
1034A;GOTHIC LETTER NINE HUNDRED;Nl;0;L;;;;900;N;;;;;
10350;OLD PERMIC LETTER AN;Lo;0;L;;;;;N;;;;;
10351;OLD PERMIC LETTER BUR;Lo;0;L;;;;;N;;;;;
10352;OLD PERMIC LETTER GAI;Lo;0;L;;;;;N;;;;;
10353;OLD PERMIC LETTER DOI;Lo;0;L;;;;;N;;;;;
10354;OLD PERMIC LETTER E;Lo;0;L;;;;;N;;;;;
10355;OLD PERMIC LETTER ZHOI;Lo;0;L;;;;;N;;;;;
10356;OLD PERMIC LETTER DZHOI;Lo;0;L;;;;;N;;;;;
10357;OLD PERMIC LETTER ZATA;Lo;0;L;;;;;N;;;;;
10358;OLD PERMIC LETTER DZITA;Lo;0;L;;;;;N;;;;;
10359;OLD PERMIC LETTER I;Lo;0;L;;;;;N;;;;;
1035A;OLD PERMIC LETTER KOKE;Lo;0;L;;;;;N;;;;;
1035B;OLD PERMIC LETTER LEI;Lo;0;L;;;;;N;;;;;
1035C;OLD PERMIC LETTER MENOE;Lo;0;L;;;;;N;;;;;
1035D;OLD PERMIC LETTER NENOE;Lo;0;L;;;;;N;;;;;
1035E;OLD PERMIC LETTER VOOI;Lo;0;L;;;;;N;;;;;
1035F;OLD PERMIC LETTER PEEI;Lo;0;L;;;;;N;;;;;
10360;OLD PERMIC LETTER REI;Lo;0;L;;;;;N;;;;;
10361;OLD PERMIC LETTER SII;Lo;0;L;;;;;N;;;;;
10362;OLD PERMIC LETTER TAI;Lo;0;L;;;;;N;;;;;
10363;OLD PERMIC LETTER U;Lo;0;L;;;;;N;;;;;
10364;OLD PERMIC LETTER CHERY;Lo;0;L;;;;;N;;;;;
10365;OLD PERMIC LETTER SHOOI;Lo;0;L;;;;;N;;;;;
10366;OLD PERMIC LETTER SHCHOOI;Lo;0;L;;;;;N;;;;;
10367;OLD PERMIC LETTER YRY;Lo;0;L;;;;;N;;;;;
10368;OLD PERMIC LETTER YERU;Lo;0;L;;;;;N;;;;;
10369;OLD PERMIC LETTER O;Lo;0;L;;;;;N;;;;;
1036A;OLD PERMIC LETTER OO;Lo;0;L;;;;;N;;;;;
1036B;OLD PERMIC LETTER EF;Lo;0;L;;;;;N;;;;;
1036C;OLD PERMIC LETTER HA;Lo;0;L;;;;;N;;;;;
1036D;OLD PERMIC LETTER TSIU;Lo;0;L;;;;;N;;;;;
1036E;OLD PERMIC LETTER VER;Lo;0;L;;;;;N;;;;;
1036F;OLD PERMIC LETTER YER;Lo;0;L;;;;;N;;;;;
10370;OLD PERMIC LETTER YERI;Lo;0;L;;;;;N;;;;;
10371;OLD PERMIC LETTER YAT;Lo;0;L;;;;;N;;;;;
10372;OLD PERMIC LETTER IE;Lo;0;L;;;;;N;;;;;
10373;OLD PERMIC LETTER YU;Lo;0;L;;;;;N;;;;;
10374;OLD PERMIC LETTER YA;Lo;0;L;;;;;N;;;;;
10375;OLD PERMIC LETTER IA;Lo;0;L;;;;;N;;;;;
10376;COMBINING OLD PERMIC LETTER AN;Mn;230;NSM;;;;;N;;;;;
10377;COMBINING OLD PERMIC LETTER DOI;Mn;230;NSM;;;;;N;;;;;
10378;COMBINING OLD PERMIC LETTER ZATA;Mn;230;NSM;;;;;N;;;;;
10379;COMBINING OLD PERMIC LETTER NENOE;Mn;230;NSM;;;;;N;;;;;
1037A;COMBINING OLD PERMIC LETTER SII;Mn;230;NSM;;;;;N;;;;;
10380;UGARITIC LETTER ALPA;Lo;0;L;;;;;N;;;;;
10381;UGARITIC LETTER BETA;Lo;0;L;;;;;N;;;;;
10382;UGARITIC LETTER GAMLA;Lo;0;L;;;;;N;;;;;
10383;UGARITIC LETTER KHA;Lo;0;L;;;;;N;;;;;
10384;UGARITIC LETTER DELTA;Lo;0;L;;;;;N;;;;;
10385;UGARITIC LETTER HO;Lo;0;L;;;;;N;;;;;
10386;UGARITIC LETTER WO;Lo;0;L;;;;;N;;;;;
10387;UGARITIC LETTER ZETA;Lo;0;L;;;;;N;;;;;
10388;UGARITIC LETTER HOTA;Lo;0;L;;;;;N;;;;;
10389;UGARITIC LETTER TET;Lo;0;L;;;;;N;;;;;
1038A;UGARITIC LETTER YOD;Lo;0;L;;;;;N;;;;;
1038B;UGARITIC LETTER KAF;Lo;0;L;;;;;N;;;;;
1038C;UGARITIC LETTER SHIN;Lo;0;L;;;;;N;;;;;
1038D;UGARITIC LETTER LAMDA;Lo;0;L;;;;;N;;;;;
1038E;UGARITIC LETTER MEM;Lo;0;L;;;;;N;;;;;
1038F;UGARITIC LETTER DHAL;Lo;0;L;;;;;N;;;;;
10390;UGARITIC LETTER NUN;Lo;0;L;;;;;N;;;;;
10391;UGARITIC LETTER ZU;Lo;0;L;;;;;N;;;;;
10392;UGARITIC LETTER SAMKA;Lo;0;L;;;;;N;;;;;
10393;UGARITIC LETTER AIN;Lo;0;L;;;;;N;;;;;
10394;UGARITIC LETTER PU;Lo;0;L;;;;;N;;;;;
10395;UGARITIC LETTER SADE;Lo;0;L;;;;;N;;;;;
10396;UGARITIC LETTER QOPA;Lo;0;L;;;;;N;;;;;
10397;UGARITIC LETTER RASHA;Lo;0;L;;;;;N;;;;;
10398;UGARITIC LETTER THANNA;Lo;0;L;;;;;N;;;;;
10399;UGARITIC LETTER GHAIN;Lo;0;L;;;;;N;;;;;
1039A;UGARITIC LETTER TO;Lo;0;L;;;;;N;;;;;
1039B;UGARITIC LETTER I;Lo;0;L;;;;;N;;;;;
1039C;UGARITIC LETTER U;Lo;0;L;;;;;N;;;;;
1039D;UGARITIC LETTER SSU;Lo;0;L;;;;;N;;;;;
1039F;UGARITIC WORD DIVIDER;Po;0;L;;;;;N;;;;;
103A0;OLD PERSIAN SIGN A;Lo;0;L;;;;;N;;;;;
103A1;OLD PERSIAN SIGN I;Lo;0;L;;;;;N;;;;;
103A2;OLD PERSIAN SIGN U;Lo;0;L;;;;;N;;;;;
103A3;OLD PERSIAN SIGN KA;Lo;0;L;;;;;N;;;;;
103A4;OLD PERSIAN SIGN KU;Lo;0;L;;;;;N;;;;;
103A5;OLD PERSIAN SIGN GA;Lo;0;L;;;;;N;;;;;
103A6;OLD PERSIAN SIGN GU;Lo;0;L;;;;;N;;;;;
103A7;OLD PERSIAN SIGN XA;Lo;0;L;;;;;N;;;;;
103A8;OLD PERSIAN SIGN CA;Lo;0;L;;;;;N;;;;;
103A9;OLD PERSIAN SIGN JA;Lo;0;L;;;;;N;;;;;
103AA;OLD PERSIAN SIGN JI;Lo;0;L;;;;;N;;;;;
103AB;OLD PERSIAN SIGN TA;Lo;0;L;;;;;N;;;;;
103AC;OLD PERSIAN SIGN TU;Lo;0;L;;;;;N;;;;;
103AD;OLD PERSIAN SIGN DA;Lo;0;L;;;;;N;;;;;
103AE;OLD PERSIAN SIGN DI;Lo;0;L;;;;;N;;;;;
103AF;OLD PERSIAN SIGN DU;Lo;0;L;;;;;N;;;;;
103B0;OLD PERSIAN SIGN THA;Lo;0;L;;;;;N;;;;;
103B1;OLD PERSIAN SIGN PA;Lo;0;L;;;;;N;;;;;
103B2;OLD PERSIAN SIGN BA;Lo;0;L;;;;;N;;;;;
103B3;OLD PERSIAN SIGN FA;Lo;0;L;;;;;N;;;;;
103B4;OLD PERSIAN SIGN NA;Lo;0;L;;;;;N;;;;;
103B5;OLD PERSIAN SIGN NU;Lo;0;L;;;;;N;;;;;
103B6;OLD PERSIAN SIGN MA;Lo;0;L;;;;;N;;;;;
103B7;OLD PERSIAN SIGN MI;Lo;0;L;;;;;N;;;;;
103B8;OLD PERSIAN SIGN MU;Lo;0;L;;;;;N;;;;;
103B9;OLD PERSIAN SIGN YA;Lo;0;L;;;;;N;;;;;
103BA;OLD PERSIAN SIGN VA;Lo;0;L;;;;;N;;;;;
103BB;OLD PERSIAN SIGN VI;Lo;0;L;;;;;N;;;;;
103BC;OLD PERSIAN SIGN RA;Lo;0;L;;;;;N;;;;;
103BD;OLD PERSIAN SIGN RU;Lo;0;L;;;;;N;;;;;
103BE;OLD PERSIAN SIGN LA;Lo;0;L;;;;;N;;;;;
103BF;OLD PERSIAN SIGN SA;Lo;0;L;;;;;N;;;;;
103C0;OLD PERSIAN SIGN ZA;Lo;0;L;;;;;N;;;;;
103C1;OLD PERSIAN SIGN SHA;Lo;0;L;;;;;N;;;;;
103C2;OLD PERSIAN SIGN SSA;Lo;0;L;;;;;N;;;;;
103C3;OLD PERSIAN SIGN HA;Lo;0;L;;;;;N;;;;;
103C8;OLD PERSIAN SIGN AURAMAZDAA;Lo;0;L;;;;;N;;;;;
103C9;OLD PERSIAN SIGN AURAMAZDAA-2;Lo;0;L;;;;;N;;;;;
103CA;OLD PERSIAN SIGN AURAMAZDAAHA;Lo;0;L;;;;;N;;;;;
103CB;OLD PERSIAN SIGN XSHAAYATHIYA;Lo;0;L;;;;;N;;;;;
103CC;OLD PERSIAN SIGN DAHYAAUSH;Lo;0;L;;;;;N;;;;;
103CD;OLD PERSIAN SIGN DAHYAAUSH-2;Lo;0;L;;;;;N;;;;;
103CE;OLD PERSIAN SIGN BAGA;Lo;0;L;;;;;N;;;;;
103CF;OLD PERSIAN SIGN BUUMISH;Lo;0;L;;;;;N;;;;;
103D0;OLD PERSIAN WORD DIVIDER;Po;0;L;;;;;N;;;;;
103D1;OLD PERSIAN NUMBER ONE;Nl;0;L;;;;1;N;;;;;
103D2;OLD PERSIAN NUMBER TWO;Nl;0;L;;;;2;N;;;;;
103D3;OLD PERSIAN NUMBER TEN;Nl;0;L;;;;10;N;;;;;
103D4;OLD PERSIAN NUMBER TWENTY;Nl;0;L;;;;20;N;;;;;
103D5;OLD PERSIAN NUMBER HUNDRED;Nl;0;L;;;;100;N;;;;;
10400;DESERET CAPITAL LETTER LONG I;Lu;0;L;;;;;N;;;;10428;
10401;DESERET CAPITAL LETTER LONG E;Lu;0;L;;;;;N;;;;10429;
10402;DESERET CAPITAL LETTER LONG A;Lu;0;L;;;;;N;;;;1042A;
10403;DESERET CAPITAL LETTER LONG AH;Lu;0;L;;;;;N;;;;1042B;
10404;DESERET CAPITAL LETTER LONG O;Lu;0;L;;;;;N;;;;1042C;
10405;DESERET CAPITAL LETTER LONG OO;Lu;0;L;;;;;N;;;;1042D;
10406;DESERET CAPITAL LETTER SHORT I;Lu;0;L;;;;;N;;;;1042E;
10407;DESERET CAPITAL LETTER SHORT E;Lu;0;L;;;;;N;;;;1042F;
10408;DESERET CAPITAL LETTER SHORT A;Lu;0;L;;;;;N;;;;10430;
10409;DESERET CAPITAL LETTER SHORT AH;Lu;0;L;;;;;N;;;;10431;
1040A;DESERET CAPITAL LETTER SHORT O;Lu;0;L;;;;;N;;;;10432;
1040B;DESERET CAPITAL LETTER SHORT OO;Lu;0;L;;;;;N;;;;10433;
1040C;DESERET CAPITAL LETTER AY;Lu;0;L;;;;;N;;;;10434;
1040D;DESERET CAPITAL LETTER OW;Lu;0;L;;;;;N;;;;10435;
1040E;DESERET CAPITAL LETTER WU;Lu;0;L;;;;;N;;;;10436;
1040F;DESERET CAPITAL LETTER YEE;Lu;0;L;;;;;N;;;;10437;
10410;DESERET CAPITAL LETTER H;Lu;0;L;;;;;N;;;;10438;
10411;DESERET CAPITAL LETTER PEE;Lu;0;L;;;;;N;;;;10439;
10412;DESERET CAPITAL LETTER BEE;Lu;0;L;;;;;N;;;;1043A;
10413;DESERET CAPITAL LETTER TEE;Lu;0;L;;;;;N;;;;1043B;
10414;DESERET CAPITAL LETTER DEE;Lu;0;L;;;;;N;;;;1043C;
10415;DESERET CAPITAL LETTER CHEE;Lu;0;L;;;;;N;;;;1043D;
10416;DESERET CAPITAL LETTER JEE;Lu;0;L;;;;;N;;;;1043E;
10417;DESERET CAPITAL LETTER KAY;Lu;0;L;;;;;N;;;;1043F;
10418;DESERET CAPITAL LETTER GAY;Lu;0;L;;;;;N;;;;10440;
10419;DESERET CAPITAL LETTER EF;Lu;0;L;;;;;N;;;;10441;
1041A;DESERET CAPITAL LETTER VEE;Lu;0;L;;;;;N;;;;10442;
1041B;DESERET CAPITAL LETTER ETH;Lu;0;L;;;;;N;;;;10443;
1041C;DESERET CAPITAL LETTER THEE;Lu;0;L;;;;;N;;;;10444;
1041D;DESERET CAPITAL LETTER ES;Lu;0;L;;;;;N;;;;10445;
1041E;DESERET CAPITAL LETTER ZEE;Lu;0;L;;;;;N;;;;10446;
1041F;DESERET CAPITAL LETTER ESH;Lu;0;L;;;;;N;;;;10447;
10420;DESERET CAPITAL LETTER ZHEE;Lu;0;L;;;;;N;;;;10448;
10421;DESERET CAPITAL LETTER ER;Lu;0;L;;;;;N;;;;10449;
10422;DESERET CAPITAL LETTER EL;Lu;0;L;;;;;N;;;;1044A;
10423;DESERET CAPITAL LETTER EM;Lu;0;L;;;;;N;;;;1044B;
10424;DESERET CAPITAL LETTER EN;Lu;0;L;;;;;N;;;;1044C;
10425;DESERET CAPITAL LETTER ENG;Lu;0;L;;;;;N;;;;1044D;
10426;DESERET CAPITAL LETTER OI;Lu;0;L;;;;;N;;;;1044E;
10427;DESERET CAPITAL LETTER EW;Lu;0;L;;;;;N;;;;1044F;
10428;DESERET SMALL LETTER LONG I;Ll;0;L;;;;;N;;;10400;;10400
10429;DESERET SMALL LETTER LONG E;Ll;0;L;;;;;N;;;10401;;10401
1042A;DESERET SMALL LETTER LONG A;Ll;0;L;;;;;N;;;10402;;10402
1042B;DESERET SMALL LETTER LONG AH;Ll;0;L;;;;;N;;;10403;;10403
1042C;DESERET SMALL LETTER LONG O;Ll;0;L;;;;;N;;;10404;;10404
1042D;DESERET SMALL LETTER LONG OO;Ll;0;L;;;;;N;;;10405;;10405
1042E;DESERET SMALL LETTER SHORT I;Ll;0;L;;;;;N;;;10406;;10406
1042F;DESERET SMALL LETTER SHORT E;Ll;0;L;;;;;N;;;10407;;10407
10430;DESERET SMALL LETTER SHORT A;Ll;0;L;;;;;N;;;10408;;10408
10431;DESERET SMALL LETTER SHORT AH;Ll;0;L;;;;;N;;;10409;;10409
10432;DESERET SMALL LETTER SHORT O;Ll;0;L;;;;;N;;;1040A;;1040A
10433;DESERET SMALL LETTER SHORT OO;Ll;0;L;;;;;N;;;1040B;;1040B
10434;DESERET SMALL LETTER AY;Ll;0;L;;;;;N;;;1040C;;1040C
10435;DESERET SMALL LETTER OW;Ll;0;L;;;;;N;;;1040D;;1040D
10436;DESERET SMALL LETTER WU;Ll;0;L;;;;;N;;;1040E;;1040E
10437;DESERET SMALL LETTER YEE;Ll;0;L;;;;;N;;;1040F;;1040F
10438;DESERET SMALL LETTER H;Ll;0;L;;;;;N;;;10410;;10410
10439;DESERET SMALL LETTER PEE;Ll;0;L;;;;;N;;;10411;;10411
1043A;DESERET SMALL LETTER BEE;Ll;0;L;;;;;N;;;10412;;10412
1043B;DESERET SMALL LETTER TEE;Ll;0;L;;;;;N;;;10413;;10413
1043C;DESERET SMALL LETTER DEE;Ll;0;L;;;;;N;;;10414;;10414
1043D;DESERET SMALL LETTER CHEE;Ll;0;L;;;;;N;;;10415;;10415
1043E;DESERET SMALL LETTER JEE;Ll;0;L;;;;;N;;;10416;;10416
1043F;DESERET SMALL LETTER KAY;Ll;0;L;;;;;N;;;10417;;10417
10440;DESERET SMALL LETTER GAY;Ll;0;L;;;;;N;;;10418;;10418
10441;DESERET SMALL LETTER EF;Ll;0;L;;;;;N;;;10419;;10419
10442;DESERET SMALL LETTER VEE;Ll;0;L;;;;;N;;;1041A;;1041A
10443;DESERET SMALL LETTER ETH;Ll;0;L;;;;;N;;;1041B;;1041B
10444;DESERET SMALL LETTER THEE;Ll;0;L;;;;;N;;;1041C;;1041C
10445;DESERET SMALL LETTER ES;Ll;0;L;;;;;N;;;1041D;;1041D
10446;DESERET SMALL LETTER ZEE;Ll;0;L;;;;;N;;;1041E;;1041E
10447;DESERET SMALL LETTER ESH;Ll;0;L;;;;;N;;;1041F;;1041F
10448;DESERET SMALL LETTER ZHEE;Ll;0;L;;;;;N;;;10420;;10420
10449;DESERET SMALL LETTER ER;Ll;0;L;;;;;N;;;10421;;10421
1044A;DESERET SMALL LETTER EL;Ll;0;L;;;;;N;;;10422;;10422
1044B;DESERET SMALL LETTER EM;Ll;0;L;;;;;N;;;10423;;10423
1044C;DESERET SMALL LETTER EN;Ll;0;L;;;;;N;;;10424;;10424
1044D;DESERET SMALL LETTER ENG;Ll;0;L;;;;;N;;;10425;;10425
1044E;DESERET SMALL LETTER OI;Ll;0;L;;;;;N;;;10426;;10426
1044F;DESERET SMALL LETTER EW;Ll;0;L;;;;;N;;;10427;;10427
10450;SHAVIAN LETTER PEEP;Lo;0;L;;;;;N;;;;;
10451;SHAVIAN LETTER TOT;Lo;0;L;;;;;N;;;;;
10452;SHAVIAN LETTER KICK;Lo;0;L;;;;;N;;;;;
10453;SHAVIAN LETTER FEE;Lo;0;L;;;;;N;;;;;
10454;SHAVIAN LETTER THIGH;Lo;0;L;;;;;N;;;;;
10455;SHAVIAN LETTER SO;Lo;0;L;;;;;N;;;;;
10456;SHAVIAN LETTER SURE;Lo;0;L;;;;;N;;;;;
10457;SHAVIAN LETTER CHURCH;Lo;0;L;;;;;N;;;;;
10458;SHAVIAN LETTER YEA;Lo;0;L;;;;;N;;;;;
10459;SHAVIAN LETTER HUNG;Lo;0;L;;;;;N;;;;;
1045A;SHAVIAN LETTER BIB;Lo;0;L;;;;;N;;;;;
1045B;SHAVIAN LETTER DEAD;Lo;0;L;;;;;N;;;;;
1045C;SHAVIAN LETTER GAG;Lo;0;L;;;;;N;;;;;
1045D;SHAVIAN LETTER VOW;Lo;0;L;;;;;N;;;;;
1045E;SHAVIAN LETTER THEY;Lo;0;L;;;;;N;;;;;
1045F;SHAVIAN LETTER ZOO;Lo;0;L;;;;;N;;;;;
10460;SHAVIAN LETTER MEASURE;Lo;0;L;;;;;N;;;;;
10461;SHAVIAN LETTER JUDGE;Lo;0;L;;;;;N;;;;;
10462;SHAVIAN LETTER WOE;Lo;0;L;;;;;N;;;;;
10463;SHAVIAN LETTER HA-HA;Lo;0;L;;;;;N;;;;;
10464;SHAVIAN LETTER LOLL;Lo;0;L;;;;;N;;;;;
10465;SHAVIAN LETTER MIME;Lo;0;L;;;;;N;;;;;
10466;SHAVIAN LETTER IF;Lo;0;L;;;;;N;;;;;
10467;SHAVIAN LETTER EGG;Lo;0;L;;;;;N;;;;;
10468;SHAVIAN LETTER ASH;Lo;0;L;;;;;N;;;;;
10469;SHAVIAN LETTER ADO;Lo;0;L;;;;;N;;;;;
1046A;SHAVIAN LETTER ON;Lo;0;L;;;;;N;;;;;
1046B;SHAVIAN LETTER WOOL;Lo;0;L;;;;;N;;;;;
1046C;SHAVIAN LETTER OUT;Lo;0;L;;;;;N;;;;;
1046D;SHAVIAN LETTER AH;Lo;0;L;;;;;N;;;;;
1046E;SHAVIAN LETTER ROAR;Lo;0;L;;;;;N;;;;;
1046F;SHAVIAN LETTER NUN;Lo;0;L;;;;;N;;;;;
10470;SHAVIAN LETTER EAT;Lo;0;L;;;;;N;;;;;
10471;SHAVIAN LETTER AGE;Lo;0;L;;;;;N;;;;;
10472;SHAVIAN LETTER ICE;Lo;0;L;;;;;N;;;;;
10473;SHAVIAN LETTER UP;Lo;0;L;;;;;N;;;;;
10474;SHAVIAN LETTER OAK;Lo;0;L;;;;;N;;;;;
10475;SHAVIAN LETTER OOZE;Lo;0;L;;;;;N;;;;;
10476;SHAVIAN LETTER OIL;Lo;0;L;;;;;N;;;;;
10477;SHAVIAN LETTER AWE;Lo;0;L;;;;;N;;;;;
10478;SHAVIAN LETTER ARE;Lo;0;L;;;;;N;;;;;
10479;SHAVIAN LETTER OR;Lo;0;L;;;;;N;;;;;
1047A;SHAVIAN LETTER AIR;Lo;0;L;;;;;N;;;;;
1047B;SHAVIAN LETTER ERR;Lo;0;L;;;;;N;;;;;
1047C;SHAVIAN LETTER ARRAY;Lo;0;L;;;;;N;;;;;
1047D;SHAVIAN LETTER EAR;Lo;0;L;;;;;N;;;;;
1047E;SHAVIAN LETTER IAN;Lo;0;L;;;;;N;;;;;
1047F;SHAVIAN LETTER YEW;Lo;0;L;;;;;N;;;;;
10480;OSMANYA LETTER ALEF;Lo;0;L;;;;;N;;;;;
10481;OSMANYA LETTER BA;Lo;0;L;;;;;N;;;;;
10482;OSMANYA LETTER TA;Lo;0;L;;;;;N;;;;;
10483;OSMANYA LETTER JA;Lo;0;L;;;;;N;;;;;
10484;OSMANYA LETTER XA;Lo;0;L;;;;;N;;;;;
10485;OSMANYA LETTER KHA;Lo;0;L;;;;;N;;;;;
10486;OSMANYA LETTER DEEL;Lo;0;L;;;;;N;;;;;
10487;OSMANYA LETTER RA;Lo;0;L;;;;;N;;;;;
10488;OSMANYA LETTER SA;Lo;0;L;;;;;N;;;;;
10489;OSMANYA LETTER SHIIN;Lo;0;L;;;;;N;;;;;
1048A;OSMANYA LETTER DHA;Lo;0;L;;;;;N;;;;;
1048B;OSMANYA LETTER CAYN;Lo;0;L;;;;;N;;;;;
1048C;OSMANYA LETTER GA;Lo;0;L;;;;;N;;;;;
1048D;OSMANYA LETTER FA;Lo;0;L;;;;;N;;;;;
1048E;OSMANYA LETTER QAAF;Lo;0;L;;;;;N;;;;;
1048F;OSMANYA LETTER KAAF;Lo;0;L;;;;;N;;;;;
10490;OSMANYA LETTER LAAN;Lo;0;L;;;;;N;;;;;
10491;OSMANYA LETTER MIIN;Lo;0;L;;;;;N;;;;;
10492;OSMANYA LETTER NUUN;Lo;0;L;;;;;N;;;;;
10493;OSMANYA LETTER WAW;Lo;0;L;;;;;N;;;;;
10494;OSMANYA LETTER HA;Lo;0;L;;;;;N;;;;;
10495;OSMANYA LETTER YA;Lo;0;L;;;;;N;;;;;
10496;OSMANYA LETTER A;Lo;0;L;;;;;N;;;;;
10497;OSMANYA LETTER E;Lo;0;L;;;;;N;;;;;
10498;OSMANYA LETTER I;Lo;0;L;;;;;N;;;;;
10499;OSMANYA LETTER O;Lo;0;L;;;;;N;;;;;
1049A;OSMANYA LETTER U;Lo;0;L;;;;;N;;;;;
1049B;OSMANYA LETTER AA;Lo;0;L;;;;;N;;;;;
1049C;OSMANYA LETTER EE;Lo;0;L;;;;;N;;;;;
1049D;OSMANYA LETTER OO;Lo;0;L;;;;;N;;;;;
104A0;OSMANYA DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
104A1;OSMANYA DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
104A2;OSMANYA DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
104A3;OSMANYA DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
104A4;OSMANYA DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
104A5;OSMANYA DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
104A6;OSMANYA DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
104A7;OSMANYA DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
104A8;OSMANYA DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
104A9;OSMANYA DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
104B0;OSAGE CAPITAL LETTER A;Lu;0;L;;;;;N;;;;104D8;
104B1;OSAGE CAPITAL LETTER AI;Lu;0;L;;;;;N;;;;104D9;
104B2;OSAGE CAPITAL LETTER AIN;Lu;0;L;;;;;N;;;;104DA;
104B3;OSAGE CAPITAL LETTER AH;Lu;0;L;;;;;N;;;;104DB;
104B4;OSAGE CAPITAL LETTER BRA;Lu;0;L;;;;;N;;;;104DC;
104B5;OSAGE CAPITAL LETTER CHA;Lu;0;L;;;;;N;;;;104DD;
104B6;OSAGE CAPITAL LETTER EHCHA;Lu;0;L;;;;;N;;;;104DE;
104B7;OSAGE CAPITAL LETTER E;Lu;0;L;;;;;N;;;;104DF;
104B8;OSAGE CAPITAL LETTER EIN;Lu;0;L;;;;;N;;;;104E0;
104B9;OSAGE CAPITAL LETTER HA;Lu;0;L;;;;;N;;;;104E1;
104BA;OSAGE CAPITAL LETTER HYA;Lu;0;L;;;;;N;;;;104E2;
104BB;OSAGE CAPITAL LETTER I;Lu;0;L;;;;;N;;;;104E3;
104BC;OSAGE CAPITAL LETTER KA;Lu;0;L;;;;;N;;;;104E4;
104BD;OSAGE CAPITAL LETTER EHKA;Lu;0;L;;;;;N;;;;104E5;
104BE;OSAGE CAPITAL LETTER KYA;Lu;0;L;;;;;N;;;;104E6;
104BF;OSAGE CAPITAL LETTER LA;Lu;0;L;;;;;N;;;;104E7;
104C0;OSAGE CAPITAL LETTER MA;Lu;0;L;;;;;N;;;;104E8;
104C1;OSAGE CAPITAL LETTER NA;Lu;0;L;;;;;N;;;;104E9;
104C2;OSAGE CAPITAL LETTER O;Lu;0;L;;;;;N;;;;104EA;
104C3;OSAGE CAPITAL LETTER OIN;Lu;0;L;;;;;N;;;;104EB;
104C4;OSAGE CAPITAL LETTER PA;Lu;0;L;;;;;N;;;;104EC;
104C5;OSAGE CAPITAL LETTER EHPA;Lu;0;L;;;;;N;;;;104ED;
104C6;OSAGE CAPITAL LETTER SA;Lu;0;L;;;;;N;;;;104EE;
104C7;OSAGE CAPITAL LETTER SHA;Lu;0;L;;;;;N;;;;104EF;
104C8;OSAGE CAPITAL LETTER TA;Lu;0;L;;;;;N;;;;104F0;
104C9;OSAGE CAPITAL LETTER EHTA;Lu;0;L;;;;;N;;;;104F1;
104CA;OSAGE CAPITAL LETTER TSA;Lu;0;L;;;;;N;;;;104F2;
104CB;OSAGE CAPITAL LETTER EHTSA;Lu;0;L;;;;;N;;;;104F3;
104CC;OSAGE CAPITAL LETTER TSHA;Lu;0;L;;;;;N;;;;104F4;
104CD;OSAGE CAPITAL LETTER DHA;Lu;0;L;;;;;N;;;;104F5;
104CE;OSAGE CAPITAL LETTER U;Lu;0;L;;;;;N;;;;104F6;
104CF;OSAGE CAPITAL LETTER WA;Lu;0;L;;;;;N;;;;104F7;
104D0;OSAGE CAPITAL LETTER KHA;Lu;0;L;;;;;N;;;;104F8;
104D1;OSAGE CAPITAL LETTER GHA;Lu;0;L;;;;;N;;;;104F9;
104D2;OSAGE CAPITAL LETTER ZA;Lu;0;L;;;;;N;;;;104FA;
104D3;OSAGE CAPITAL LETTER ZHA;Lu;0;L;;;;;N;;;;104FB;
104D8;OSAGE SMALL LETTER A;Ll;0;L;;;;;N;;;104B0;;104B0
104D9;OSAGE SMALL LETTER AI;Ll;0;L;;;;;N;;;104B1;;104B1
104DA;OSAGE SMALL LETTER AIN;Ll;0;L;;;;;N;;;104B2;;104B2
104DB;OSAGE SMALL LETTER AH;Ll;0;L;;;;;N;;;104B3;;104B3
104DC;OSAGE SMALL LETTER BRA;Ll;0;L;;;;;N;;;104B4;;104B4
104DD;OSAGE SMALL LETTER CHA;Ll;0;L;;;;;N;;;104B5;;104B5
104DE;OSAGE SMALL LETTER EHCHA;Ll;0;L;;;;;N;;;104B6;;104B6
104DF;OSAGE SMALL LETTER E;Ll;0;L;;;;;N;;;104B7;;104B7
104E0;OSAGE SMALL LETTER EIN;Ll;0;L;;;;;N;;;104B8;;104B8
104E1;OSAGE SMALL LETTER HA;Ll;0;L;;;;;N;;;104B9;;104B9
104E2;OSAGE SMALL LETTER HYA;Ll;0;L;;;;;N;;;104BA;;104BA
104E3;OSAGE SMALL LETTER I;Ll;0;L;;;;;N;;;104BB;;104BB
104E4;OSAGE SMALL LETTER KA;Ll;0;L;;;;;N;;;104BC;;104BC
104E5;OSAGE SMALL LETTER EHKA;Ll;0;L;;;;;N;;;104BD;;104BD
104E6;OSAGE SMALL LETTER KYA;Ll;0;L;;;;;N;;;104BE;;104BE
104E7;OSAGE SMALL LETTER LA;Ll;0;L;;;;;N;;;104BF;;104BF
104E8;OSAGE SMALL LETTER MA;Ll;0;L;;;;;N;;;104C0;;104C0
104E9;OSAGE SMALL LETTER NA;Ll;0;L;;;;;N;;;104C1;;104C1
104EA;OSAGE SMALL LETTER O;Ll;0;L;;;;;N;;;104C2;;104C2
104EB;OSAGE SMALL LETTER OIN;Ll;0;L;;;;;N;;;104C3;;104C3
104EC;OSAGE SMALL LETTER PA;Ll;0;L;;;;;N;;;104C4;;104C4
104ED;OSAGE SMALL LETTER EHPA;Ll;0;L;;;;;N;;;104C5;;104C5
104EE;OSAGE SMALL LETTER SA;Ll;0;L;;;;;N;;;104C6;;104C6
104EF;OSAGE SMALL LETTER SHA;Ll;0;L;;;;;N;;;104C7;;104C7
104F0;OSAGE SMALL LETTER TA;Ll;0;L;;;;;N;;;104C8;;104C8
104F1;OSAGE SMALL LETTER EHTA;Ll;0;L;;;;;N;;;104C9;;104C9
104F2;OSAGE SMALL LETTER TSA;Ll;0;L;;;;;N;;;104CA;;104CA
104F3;OSAGE SMALL LETTER EHTSA;Ll;0;L;;;;;N;;;104CB;;104CB
104F4;OSAGE SMALL LETTER TSHA;Ll;0;L;;;;;N;;;104CC;;104CC
104F5;OSAGE SMALL LETTER DHA;Ll;0;L;;;;;N;;;104CD;;104CD
104F6;OSAGE SMALL LETTER U;Ll;0;L;;;;;N;;;104CE;;104CE
104F7;OSAGE SMALL LETTER WA;Ll;0;L;;;;;N;;;104CF;;104CF
104F8;OSAGE SMALL LETTER KHA;Ll;0;L;;;;;N;;;104D0;;104D0
104F9;OSAGE SMALL LETTER GHA;Ll;0;L;;;;;N;;;104D1;;104D1
104FA;OSAGE SMALL LETTER ZA;Ll;0;L;;;;;N;;;104D2;;104D2
104FB;OSAGE SMALL LETTER ZHA;Ll;0;L;;;;;N;;;104D3;;104D3
10500;ELBASAN LETTER A;Lo;0;L;;;;;N;;;;;
10501;ELBASAN LETTER BE;Lo;0;L;;;;;N;;;;;
10502;ELBASAN LETTER CE;Lo;0;L;;;;;N;;;;;
10503;ELBASAN LETTER CHE;Lo;0;L;;;;;N;;;;;
10504;ELBASAN LETTER DE;Lo;0;L;;;;;N;;;;;
10505;ELBASAN LETTER NDE;Lo;0;L;;;;;N;;;;;
10506;ELBASAN LETTER DHE;Lo;0;L;;;;;N;;;;;
10507;ELBASAN LETTER EI;Lo;0;L;;;;;N;;;;;
10508;ELBASAN LETTER E;Lo;0;L;;;;;N;;;;;
10509;ELBASAN LETTER FE;Lo;0;L;;;;;N;;;;;
1050A;ELBASAN LETTER GE;Lo;0;L;;;;;N;;;;;
1050B;ELBASAN LETTER GJE;Lo;0;L;;;;;N;;;;;
1050C;ELBASAN LETTER HE;Lo;0;L;;;;;N;;;;;
1050D;ELBASAN LETTER I;Lo;0;L;;;;;N;;;;;
1050E;ELBASAN LETTER JE;Lo;0;L;;;;;N;;;;;
1050F;ELBASAN LETTER KE;Lo;0;L;;;;;N;;;;;
10510;ELBASAN LETTER LE;Lo;0;L;;;;;N;;;;;
10511;ELBASAN LETTER LLE;Lo;0;L;;;;;N;;;;;
10512;ELBASAN LETTER ME;Lo;0;L;;;;;N;;;;;
10513;ELBASAN LETTER NE;Lo;0;L;;;;;N;;;;;
10514;ELBASAN LETTER NA;Lo;0;L;;;;;N;;;;;
10515;ELBASAN LETTER NJE;Lo;0;L;;;;;N;;;;;
10516;ELBASAN LETTER O;Lo;0;L;;;;;N;;;;;
10517;ELBASAN LETTER PE;Lo;0;L;;;;;N;;;;;
10518;ELBASAN LETTER QE;Lo;0;L;;;;;N;;;;;
10519;ELBASAN LETTER RE;Lo;0;L;;;;;N;;;;;
1051A;ELBASAN LETTER RRE;Lo;0;L;;;;;N;;;;;
1051B;ELBASAN LETTER SE;Lo;0;L;;;;;N;;;;;
1051C;ELBASAN LETTER SHE;Lo;0;L;;;;;N;;;;;
1051D;ELBASAN LETTER TE;Lo;0;L;;;;;N;;;;;
1051E;ELBASAN LETTER THE;Lo;0;L;;;;;N;;;;;
1051F;ELBASAN LETTER U;Lo;0;L;;;;;N;;;;;
10520;ELBASAN LETTER VE;Lo;0;L;;;;;N;;;;;
10521;ELBASAN LETTER XE;Lo;0;L;;;;;N;;;;;
10522;ELBASAN LETTER Y;Lo;0;L;;;;;N;;;;;
10523;ELBASAN LETTER ZE;Lo;0;L;;;;;N;;;;;
10524;ELBASAN LETTER ZHE;Lo;0;L;;;;;N;;;;;
10525;ELBASAN LETTER GHE;Lo;0;L;;;;;N;;;;;
10526;ELBASAN LETTER GHAMMA;Lo;0;L;;;;;N;;;;;
10527;ELBASAN LETTER KHE;Lo;0;L;;;;;N;;;;;
10530;CAUCASIAN ALBANIAN LETTER ALT;Lo;0;L;;;;;N;;;;;
10531;CAUCASIAN ALBANIAN LETTER BET;Lo;0;L;;;;;N;;;;;
10532;CAUCASIAN ALBANIAN LETTER GIM;Lo;0;L;;;;;N;;;;;
10533;CAUCASIAN ALBANIAN LETTER DAT;Lo;0;L;;;;;N;;;;;
10534;CAUCASIAN ALBANIAN LETTER EB;Lo;0;L;;;;;N;;;;;
10535;CAUCASIAN ALBANIAN LETTER ZARL;Lo;0;L;;;;;N;;;;;
10536;CAUCASIAN ALBANIAN LETTER EYN;Lo;0;L;;;;;N;;;;;
10537;CAUCASIAN ALBANIAN LETTER ZHIL;Lo;0;L;;;;;N;;;;;
10538;CAUCASIAN ALBANIAN LETTER TAS;Lo;0;L;;;;;N;;;;;
10539;CAUCASIAN ALBANIAN LETTER CHA;Lo;0;L;;;;;N;;;;;
1053A;CAUCASIAN ALBANIAN LETTER YOWD;Lo;0;L;;;;;N;;;;;
1053B;CAUCASIAN ALBANIAN LETTER ZHA;Lo;0;L;;;;;N;;;;;
1053C;CAUCASIAN ALBANIAN LETTER IRB;Lo;0;L;;;;;N;;;;;
1053D;CAUCASIAN ALBANIAN LETTER SHA;Lo;0;L;;;;;N;;;;;
1053E;CAUCASIAN ALBANIAN LETTER LAN;Lo;0;L;;;;;N;;;;;
1053F;CAUCASIAN ALBANIAN LETTER INYA;Lo;0;L;;;;;N;;;;;
10540;CAUCASIAN ALBANIAN LETTER XEYN;Lo;0;L;;;;;N;;;;;
10541;CAUCASIAN ALBANIAN LETTER DYAN;Lo;0;L;;;;;N;;;;;
10542;CAUCASIAN ALBANIAN LETTER CAR;Lo;0;L;;;;;N;;;;;
10543;CAUCASIAN ALBANIAN LETTER JHOX;Lo;0;L;;;;;N;;;;;
10544;CAUCASIAN ALBANIAN LETTER KAR;Lo;0;L;;;;;N;;;;;
10545;CAUCASIAN ALBANIAN LETTER LYIT;Lo;0;L;;;;;N;;;;;
10546;CAUCASIAN ALBANIAN LETTER HEYT;Lo;0;L;;;;;N;;;;;
10547;CAUCASIAN ALBANIAN LETTER QAY;Lo;0;L;;;;;N;;;;;
10548;CAUCASIAN ALBANIAN LETTER AOR;Lo;0;L;;;;;N;;;;;
10549;CAUCASIAN ALBANIAN LETTER CHOY;Lo;0;L;;;;;N;;;;;
1054A;CAUCASIAN ALBANIAN LETTER CHI;Lo;0;L;;;;;N;;;;;
1054B;CAUCASIAN ALBANIAN LETTER CYAY;Lo;0;L;;;;;N;;;;;
1054C;CAUCASIAN ALBANIAN LETTER MAQ;Lo;0;L;;;;;N;;;;;
1054D;CAUCASIAN ALBANIAN LETTER QAR;Lo;0;L;;;;;N;;;;;
1054E;CAUCASIAN ALBANIAN LETTER NOWC;Lo;0;L;;;;;N;;;;;
1054F;CAUCASIAN ALBANIAN LETTER DZYAY;Lo;0;L;;;;;N;;;;;
10550;CAUCASIAN ALBANIAN LETTER SHAK;Lo;0;L;;;;;N;;;;;
10551;CAUCASIAN ALBANIAN LETTER JAYN;Lo;0;L;;;;;N;;;;;
10552;CAUCASIAN ALBANIAN LETTER ON;Lo;0;L;;;;;N;;;;;
10553;CAUCASIAN ALBANIAN LETTER TYAY;Lo;0;L;;;;;N;;;;;
10554;CAUCASIAN ALBANIAN LETTER FAM;Lo;0;L;;;;;N;;;;;
10555;CAUCASIAN ALBANIAN LETTER DZAY;Lo;0;L;;;;;N;;;;;
10556;CAUCASIAN ALBANIAN LETTER CHAT;Lo;0;L;;;;;N;;;;;
10557;CAUCASIAN ALBANIAN LETTER PEN;Lo;0;L;;;;;N;;;;;
10558;CAUCASIAN ALBANIAN LETTER GHEYS;Lo;0;L;;;;;N;;;;;
10559;CAUCASIAN ALBANIAN LETTER RAT;Lo;0;L;;;;;N;;;;;
1055A;CAUCASIAN ALBANIAN LETTER SEYK;Lo;0;L;;;;;N;;;;;
1055B;CAUCASIAN ALBANIAN LETTER VEYZ;Lo;0;L;;;;;N;;;;;
1055C;CAUCASIAN ALBANIAN LETTER TIWR;Lo;0;L;;;;;N;;;;;
1055D;CAUCASIAN ALBANIAN LETTER SHOY;Lo;0;L;;;;;N;;;;;
1055E;CAUCASIAN ALBANIAN LETTER IWN;Lo;0;L;;;;;N;;;;;
1055F;CAUCASIAN ALBANIAN LETTER CYAW;Lo;0;L;;;;;N;;;;;
10560;CAUCASIAN ALBANIAN LETTER CAYN;Lo;0;L;;;;;N;;;;;
10561;CAUCASIAN ALBANIAN LETTER YAYD;Lo;0;L;;;;;N;;;;;
10562;CAUCASIAN ALBANIAN LETTER PIWR;Lo;0;L;;;;;N;;;;;
10563;CAUCASIAN ALBANIAN LETTER KIW;Lo;0;L;;;;;N;;;;;
1056F;CAUCASIAN ALBANIAN CITATION MARK;Po;0;L;;;;;N;;;;;
10570;VITHKUQI CAPITAL LETTER A;Lu;0;L;;;;;N;;;;10597;
10571;VITHKUQI CAPITAL LETTER BBE;Lu;0;L;;;;;N;;;;10598;
10572;VITHKUQI CAPITAL LETTER BE;Lu;0;L;;;;;N;;;;10599;
10573;VITHKUQI CAPITAL LETTER CE;Lu;0;L;;;;;N;;;;1059A;
10574;VITHKUQI CAPITAL LETTER CHE;Lu;0;L;;;;;N;;;;1059B;
10575;VITHKUQI CAPITAL LETTER DE;Lu;0;L;;;;;N;;;;1059C;
10576;VITHKUQI CAPITAL LETTER DHE;Lu;0;L;;;;;N;;;;1059D;
10577;VITHKUQI CAPITAL LETTER EI;Lu;0;L;;;;;N;;;;1059E;
10578;VITHKUQI CAPITAL LETTER E;Lu;0;L;;;;;N;;;;1059F;
10579;VITHKUQI CAPITAL LETTER FE;Lu;0;L;;;;;N;;;;105A0;
1057A;VITHKUQI CAPITAL LETTER GA;Lu;0;L;;;;;N;;;;105A1;
1057C;VITHKUQI CAPITAL LETTER HA;Lu;0;L;;;;;N;;;;105A3;
1057D;VITHKUQI CAPITAL LETTER HHA;Lu;0;L;;;;;N;;;;105A4;
1057E;VITHKUQI CAPITAL LETTER I;Lu;0;L;;;;;N;;;;105A5;
1057F;VITHKUQI CAPITAL LETTER IJE;Lu;0;L;;;;;N;;;;105A6;
10580;VITHKUQI CAPITAL LETTER JE;Lu;0;L;;;;;N;;;;105A7;
10581;VITHKUQI CAPITAL LETTER KA;Lu;0;L;;;;;N;;;;105A8;
10582;VITHKUQI CAPITAL LETTER LA;Lu;0;L;;;;;N;;;;105A9;
10583;VITHKUQI CAPITAL LETTER LLA;Lu;0;L;;;;;N;;;;105AA;
10584;VITHKUQI CAPITAL LETTER ME;Lu;0;L;;;;;N;;;;105AB;
10585;VITHKUQI CAPITAL LETTER NE;Lu;0;L;;;;;N;;;;105AC;
10586;VITHKUQI CAPITAL LETTER NJE;Lu;0;L;;;;;N;;;;105AD;
10587;VITHKUQI CAPITAL LETTER O;Lu;0;L;;;;;N;;;;105AE;
10588;VITHKUQI CAPITAL LETTER PE;Lu;0;L;;;;;N;;;;105AF;
10589;VITHKUQI CAPITAL LETTER QA;Lu;0;L;;;;;N;;;;105B0;
1058A;VITHKUQI CAPITAL LETTER RE;Lu;0;L;;;;;N;;;;105B1;
1058C;VITHKUQI CAPITAL LETTER SE;Lu;0;L;;;;;N;;;;105B3;
1058D;VITHKUQI CAPITAL LETTER SHE;Lu;0;L;;;;;N;;;;105B4;
1058E;VITHKUQI CAPITAL LETTER TE;Lu;0;L;;;;;N;;;;105B5;
1058F;VITHKUQI CAPITAL LETTER THE;Lu;0;L;;;;;N;;;;105B6;
10590;VITHKUQI CAPITAL LETTER U;Lu;0;L;;;;;N;;;;105B7;
10591;VITHKUQI CAPITAL LETTER VE;Lu;0;L;;;;;N;;;;105B8;
10592;VITHKUQI CAPITAL LETTER XE;Lu;0;L;;;;;N;;;;105B9;
10594;VITHKUQI CAPITAL LETTER Y;Lu;0;L;;;;;N;;;;105BB;
10595;VITHKUQI CAPITAL LETTER ZE;Lu;0;L;;;;;N;;;;105BC;
10597;VITHKUQI SMALL LETTER A;Ll;0;L;;;;;N;;;10570;;10570
10598;VITHKUQI SMALL LETTER BBE;Ll;0;L;;;;;N;;;10571;;10571
10599;VITHKUQI SMALL LETTER BE;Ll;0;L;;;;;N;;;10572;;10572
1059A;VITHKUQI SMALL LETTER CE;Ll;0;L;;;;;N;;;10573;;10573
1059B;VITHKUQI SMALL LETTER CHE;Ll;0;L;;;;;N;;;10574;;10574
1059C;VITHKUQI SMALL LETTER DE;Ll;0;L;;;;;N;;;10575;;10575
1059D;VITHKUQI SMALL LETTER DHE;Ll;0;L;;;;;N;;;10576;;10576
1059E;VITHKUQI SMALL LETTER EI;Ll;0;L;;;;;N;;;10577;;10577
1059F;VITHKUQI SMALL LETTER E;Ll;0;L;;;;;N;;;10578;;10578
105A0;VITHKUQI SMALL LETTER FE;Ll;0;L;;;;;N;;;10579;;10579
105A1;VITHKUQI SMALL LETTER GA;Ll;0;L;;;;;N;;;1057A;;1057A
105A3;VITHKUQI SMALL LETTER HA;Ll;0;L;;;;;N;;;1057C;;1057C
105A4;VITHKUQI SMALL LETTER HHA;Ll;0;L;;;;;N;;;1057D;;1057D
105A5;VITHKUQI SMALL LETTER I;Ll;0;L;;;;;N;;;1057E;;1057E
105A6;VITHKUQI SMALL LETTER IJE;Ll;0;L;;;;;N;;;1057F;;1057F
105A7;VITHKUQI SMALL LETTER JE;Ll;0;L;;;;;N;;;10580;;10580
105A8;VITHKUQI SMALL LETTER KA;Ll;0;L;;;;;N;;;10581;;10581
105A9;VITHKUQI SMALL LETTER LA;Ll;0;L;;;;;N;;;10582;;10582
105AA;VITHKUQI SMALL LETTER LLA;Ll;0;L;;;;;N;;;10583;;10583
105AB;VITHKUQI SMALL LETTER ME;Ll;0;L;;;;;N;;;10584;;10584
105AC;VITHKUQI SMALL LETTER NE;Ll;0;L;;;;;N;;;10585;;10585
105AD;VITHKUQI SMALL LETTER NJE;Ll;0;L;;;;;N;;;10586;;10586
105AE;VITHKUQI SMALL LETTER O;Ll;0;L;;;;;N;;;10587;;10587
105AF;VITHKUQI SMALL LETTER PE;Ll;0;L;;;;;N;;;10588;;10588
105B0;VITHKUQI SMALL LETTER QA;Ll;0;L;;;;;N;;;10589;;10589
105B1;VITHKUQI SMALL LETTER RE;Ll;0;L;;;;;N;;;1058A;;1058A
105B3;VITHKUQI SMALL LETTER SE;Ll;0;L;;;;;N;;;1058C;;1058C
105B4;VITHKUQI SMALL LETTER SHE;Ll;0;L;;;;;N;;;1058D;;1058D
105B5;VITHKUQI SMALL LETTER TE;Ll;0;L;;;;;N;;;1058E;;1058E
105B6;VITHKUQI SMALL LETTER THE;Ll;0;L;;;;;N;;;1058F;;1058F
105B7;VITHKUQI SMALL LETTER U;Ll;0;L;;;;;N;;;10590;;10590
105B8;VITHKUQI SMALL LETTER VE;Ll;0;L;;;;;N;;;10591;;10591
105B9;VITHKUQI SMALL LETTER XE;Ll;0;L;;;;;N;;;10592;;10592
105BB;VITHKUQI SMALL LETTER Y;Ll;0;L;;;;;N;;;10594;;10594
105BC;VITHKUQI SMALL LETTER ZE;Ll;0;L;;;;;N;;;10595;;10595
10600;LINEAR A SIGN AB001;Lo;0;L;;;;;N;;;;;
10601;LINEAR A SIGN AB002;Lo;0;L;;;;;N;;;;;
10602;LINEAR A SIGN AB003;Lo;0;L;;;;;N;;;;;
10603;LINEAR A SIGN AB004;Lo;0;L;;;;;N;;;;;
10604;LINEAR A SIGN AB005;Lo;0;L;;;;;N;;;;;
10605;LINEAR A SIGN AB006;Lo;0;L;;;;;N;;;;;
10606;LINEAR A SIGN AB007;Lo;0;L;;;;;N;;;;;
10607;LINEAR A SIGN AB008;Lo;0;L;;;;;N;;;;;
10608;LINEAR A SIGN AB009;Lo;0;L;;;;;N;;;;;
10609;LINEAR A SIGN AB010;Lo;0;L;;;;;N;;;;;
1060A;LINEAR A SIGN AB011;Lo;0;L;;;;;N;;;;;
1060B;LINEAR A SIGN AB013;Lo;0;L;;;;;N;;;;;
1060C;LINEAR A SIGN AB016;Lo;0;L;;;;;N;;;;;
1060D;LINEAR A SIGN AB017;Lo;0;L;;;;;N;;;;;
1060E;LINEAR A SIGN AB020;Lo;0;L;;;;;N;;;;;
1060F;LINEAR A SIGN AB021;Lo;0;L;;;;;N;;;;;
10610;LINEAR A SIGN AB021F;Lo;0;L;;;;;N;;;;;
10611;LINEAR A SIGN AB021M;Lo;0;L;;;;;N;;;;;
10612;LINEAR A SIGN AB022;Lo;0;L;;;;;N;;;;;
10613;LINEAR A SIGN AB022F;Lo;0;L;;;;;N;;;;;
10614;LINEAR A SIGN AB022M;Lo;0;L;;;;;N;;;;;
10615;LINEAR A SIGN AB023;Lo;0;L;;;;;N;;;;;
10616;LINEAR A SIGN AB023M;Lo;0;L;;;;;N;;;;;
10617;LINEAR A SIGN AB024;Lo;0;L;;;;;N;;;;;
10618;LINEAR A SIGN AB026;Lo;0;L;;;;;N;;;;;
10619;LINEAR A SIGN AB027;Lo;0;L;;;;;N;;;;;
1061A;LINEAR A SIGN AB028;Lo;0;L;;;;;N;;;;;
1061B;LINEAR A SIGN A028B;Lo;0;L;;;;;N;;;;;
1061C;LINEAR A SIGN AB029;Lo;0;L;;;;;N;;;;;
1061D;LINEAR A SIGN AB030;Lo;0;L;;;;;N;;;;;
1061E;LINEAR A SIGN AB031;Lo;0;L;;;;;N;;;;;
1061F;LINEAR A SIGN AB034;Lo;0;L;;;;;N;;;;;
10620;LINEAR A SIGN AB037;Lo;0;L;;;;;N;;;;;
10621;LINEAR A SIGN AB038;Lo;0;L;;;;;N;;;;;
10622;LINEAR A SIGN AB039;Lo;0;L;;;;;N;;;;;
10623;LINEAR A SIGN AB040;Lo;0;L;;;;;N;;;;;
10624;LINEAR A SIGN AB041;Lo;0;L;;;;;N;;;;;
10625;LINEAR A SIGN AB044;Lo;0;L;;;;;N;;;;;
10626;LINEAR A SIGN AB045;Lo;0;L;;;;;N;;;;;
10627;LINEAR A SIGN AB046;Lo;0;L;;;;;N;;;;;
10628;LINEAR A SIGN AB047;Lo;0;L;;;;;N;;;;;
10629;LINEAR A SIGN AB048;Lo;0;L;;;;;N;;;;;
1062A;LINEAR A SIGN AB049;Lo;0;L;;;;;N;;;;;
1062B;LINEAR A SIGN AB050;Lo;0;L;;;;;N;;;;;
1062C;LINEAR A SIGN AB051;Lo;0;L;;;;;N;;;;;
1062D;LINEAR A SIGN AB053;Lo;0;L;;;;;N;;;;;
1062E;LINEAR A SIGN AB054;Lo;0;L;;;;;N;;;;;
1062F;LINEAR A SIGN AB055;Lo;0;L;;;;;N;;;;;
10630;LINEAR A SIGN AB056;Lo;0;L;;;;;N;;;;;
10631;LINEAR A SIGN AB057;Lo;0;L;;;;;N;;;;;
10632;LINEAR A SIGN AB058;Lo;0;L;;;;;N;;;;;
10633;LINEAR A SIGN AB059;Lo;0;L;;;;;N;;;;;
10634;LINEAR A SIGN AB060;Lo;0;L;;;;;N;;;;;
10635;LINEAR A SIGN AB061;Lo;0;L;;;;;N;;;;;
10636;LINEAR A SIGN AB065;Lo;0;L;;;;;N;;;;;
10637;LINEAR A SIGN AB066;Lo;0;L;;;;;N;;;;;
10638;LINEAR A SIGN AB067;Lo;0;L;;;;;N;;;;;
10639;LINEAR A SIGN AB069;Lo;0;L;;;;;N;;;;;
1063A;LINEAR A SIGN AB070;Lo;0;L;;;;;N;;;;;
1063B;LINEAR A SIGN AB073;Lo;0;L;;;;;N;;;;;
1063C;LINEAR A SIGN AB074;Lo;0;L;;;;;N;;;;;
1063D;LINEAR A SIGN AB076;Lo;0;L;;;;;N;;;;;
1063E;LINEAR A SIGN AB077;Lo;0;L;;;;;N;;;;;
1063F;LINEAR A SIGN AB078;Lo;0;L;;;;;N;;;;;
10640;LINEAR A SIGN AB079;Lo;0;L;;;;;N;;;;;
10641;LINEAR A SIGN AB080;Lo;0;L;;;;;N;;;;;
10642;LINEAR A SIGN AB081;Lo;0;L;;;;;N;;;;;
10643;LINEAR A SIGN AB082;Lo;0;L;;;;;N;;;;;
10644;LINEAR A SIGN AB085;Lo;0;L;;;;;N;;;;;
10645;LINEAR A SIGN AB086;Lo;0;L;;;;;N;;;;;
10646;LINEAR A SIGN AB087;Lo;0;L;;;;;N;;;;;
10647;LINEAR A SIGN A100-102;Lo;0;L;;;;;N;;;;;
10648;LINEAR A SIGN AB118;Lo;0;L;;;;;N;;;;;
10649;LINEAR A SIGN AB120;Lo;0;L;;;;;N;;;;;
1064A;LINEAR A SIGN A120B;Lo;0;L;;;;;N;;;;;
1064B;LINEAR A SIGN AB122;Lo;0;L;;;;;N;;;;;
1064C;LINEAR A SIGN AB123;Lo;0;L;;;;;N;;;;;
1064D;LINEAR A SIGN AB131A;Lo;0;L;;;;;N;;;;;
1064E;LINEAR A SIGN AB131B;Lo;0;L;;;;;N;;;;;
1064F;LINEAR A SIGN A131C;Lo;0;L;;;;;N;;;;;
10650;LINEAR A SIGN AB164;Lo;0;L;;;;;N;;;;;
10651;LINEAR A SIGN AB171;Lo;0;L;;;;;N;;;;;
10652;LINEAR A SIGN AB180;Lo;0;L;;;;;N;;;;;
10653;LINEAR A SIGN AB188;Lo;0;L;;;;;N;;;;;
10654;LINEAR A SIGN AB191;Lo;0;L;;;;;N;;;;;
10655;LINEAR A SIGN A301;Lo;0;L;;;;;N;;;;;
10656;LINEAR A SIGN A302;Lo;0;L;;;;;N;;;;;
10657;LINEAR A SIGN A303;Lo;0;L;;;;;N;;;;;
10658;LINEAR A SIGN A304;Lo;0;L;;;;;N;;;;;
10659;LINEAR A SIGN A305;Lo;0;L;;;;;N;;;;;
1065A;LINEAR A SIGN A306;Lo;0;L;;;;;N;;;;;
1065B;LINEAR A SIGN A307;Lo;0;L;;;;;N;;;;;
1065C;LINEAR A SIGN A308;Lo;0;L;;;;;N;;;;;
1065D;LINEAR A SIGN A309A;Lo;0;L;;;;;N;;;;;
1065E;LINEAR A SIGN A309B;Lo;0;L;;;;;N;;;;;
1065F;LINEAR A SIGN A309C;Lo;0;L;;;;;N;;;;;
10660;LINEAR A SIGN A310;Lo;0;L;;;;;N;;;;;
10661;LINEAR A SIGN A311;Lo;0;L;;;;;N;;;;;
10662;LINEAR A SIGN A312;Lo;0;L;;;;;N;;;;;
10663;LINEAR A SIGN A313A;Lo;0;L;;;;;N;;;;;
10664;LINEAR A SIGN A313B;Lo;0;L;;;;;N;;;;;
10665;LINEAR A SIGN A313C;Lo;0;L;;;;;N;;;;;
10666;LINEAR A SIGN A314;Lo;0;L;;;;;N;;;;;
10667;LINEAR A SIGN A315;Lo;0;L;;;;;N;;;;;
10668;LINEAR A SIGN A316;Lo;0;L;;;;;N;;;;;
10669;LINEAR A SIGN A317;Lo;0;L;;;;;N;;;;;
1066A;LINEAR A SIGN A318;Lo;0;L;;;;;N;;;;;
1066B;LINEAR A SIGN A319;Lo;0;L;;;;;N;;;;;
1066C;LINEAR A SIGN A320;Lo;0;L;;;;;N;;;;;
1066D;LINEAR A SIGN A321;Lo;0;L;;;;;N;;;;;
1066E;LINEAR A SIGN A322;Lo;0;L;;;;;N;;;;;
1066F;LINEAR A SIGN A323;Lo;0;L;;;;;N;;;;;
10670;LINEAR A SIGN A324;Lo;0;L;;;;;N;;;;;
10671;LINEAR A SIGN A325;Lo;0;L;;;;;N;;;;;
10672;LINEAR A SIGN A326;Lo;0;L;;;;;N;;;;;
10673;LINEAR A SIGN A327;Lo;0;L;;;;;N;;;;;
10674;LINEAR A SIGN A328;Lo;0;L;;;;;N;;;;;
10675;LINEAR A SIGN A329;Lo;0;L;;;;;N;;;;;
10676;LINEAR A SIGN A330;Lo;0;L;;;;;N;;;;;
10677;LINEAR A SIGN A331;Lo;0;L;;;;;N;;;;;
10678;LINEAR A SIGN A332;Lo;0;L;;;;;N;;;;;
10679;LINEAR A SIGN A333;Lo;0;L;;;;;N;;;;;
1067A;LINEAR A SIGN A334;Lo;0;L;;;;;N;;;;;
1067B;LINEAR A SIGN A335;Lo;0;L;;;;;N;;;;;
1067C;LINEAR A SIGN A336;Lo;0;L;;;;;N;;;;;
1067D;LINEAR A SIGN A337;Lo;0;L;;;;;N;;;;;
1067E;LINEAR A SIGN A338;Lo;0;L;;;;;N;;;;;
1067F;LINEAR A SIGN A339;Lo;0;L;;;;;N;;;;;
10680;LINEAR A SIGN A340;Lo;0;L;;;;;N;;;;;
10681;LINEAR A SIGN A341;Lo;0;L;;;;;N;;;;;
10682;LINEAR A SIGN A342;Lo;0;L;;;;;N;;;;;
10683;LINEAR A SIGN A343;Lo;0;L;;;;;N;;;;;
10684;LINEAR A SIGN A344;Lo;0;L;;;;;N;;;;;
10685;LINEAR A SIGN A345;Lo;0;L;;;;;N;;;;;
10686;LINEAR A SIGN A346;Lo;0;L;;;;;N;;;;;
10687;LINEAR A SIGN A347;Lo;0;L;;;;;N;;;;;
10688;LINEAR A SIGN A348;Lo;0;L;;;;;N;;;;;
10689;LINEAR A SIGN A349;Lo;0;L;;;;;N;;;;;
1068A;LINEAR A SIGN A350;Lo;0;L;;;;;N;;;;;
1068B;LINEAR A SIGN A351;Lo;0;L;;;;;N;;;;;
1068C;LINEAR A SIGN A352;Lo;0;L;;;;;N;;;;;
1068D;LINEAR A SIGN A353;Lo;0;L;;;;;N;;;;;
1068E;LINEAR A SIGN A354;Lo;0;L;;;;;N;;;;;
1068F;LINEAR A SIGN A355;Lo;0;L;;;;;N;;;;;
10690;LINEAR A SIGN A356;Lo;0;L;;;;;N;;;;;
10691;LINEAR A SIGN A357;Lo;0;L;;;;;N;;;;;
10692;LINEAR A SIGN A358;Lo;0;L;;;;;N;;;;;
10693;LINEAR A SIGN A359;Lo;0;L;;;;;N;;;;;
10694;LINEAR A SIGN A360;Lo;0;L;;;;;N;;;;;
10695;LINEAR A SIGN A361;Lo;0;L;;;;;N;;;;;
10696;LINEAR A SIGN A362;Lo;0;L;;;;;N;;;;;
10697;LINEAR A SIGN A363;Lo;0;L;;;;;N;;;;;
10698;LINEAR A SIGN A364;Lo;0;L;;;;;N;;;;;
10699;LINEAR A SIGN A365;Lo;0;L;;;;;N;;;;;
1069A;LINEAR A SIGN A366;Lo;0;L;;;;;N;;;;;
1069B;LINEAR A SIGN A367;Lo;0;L;;;;;N;;;;;
1069C;LINEAR A SIGN A368;Lo;0;L;;;;;N;;;;;
1069D;LINEAR A SIGN A369;Lo;0;L;;;;;N;;;;;
1069E;LINEAR A SIGN A370;Lo;0;L;;;;;N;;;;;
1069F;LINEAR A SIGN A371;Lo;0;L;;;;;N;;;;;
106A0;LINEAR A SIGN A400-VAS;Lo;0;L;;;;;N;;;;;
106A1;LINEAR A SIGN A401-VAS;Lo;0;L;;;;;N;;;;;
106A2;LINEAR A SIGN A402-VAS;Lo;0;L;;;;;N;;;;;
106A3;LINEAR A SIGN A403-VAS;Lo;0;L;;;;;N;;;;;
106A4;LINEAR A SIGN A404-VAS;Lo;0;L;;;;;N;;;;;
106A5;LINEAR A SIGN A405-VAS;Lo;0;L;;;;;N;;;;;
106A6;LINEAR A SIGN A406-VAS;Lo;0;L;;;;;N;;;;;
106A7;LINEAR A SIGN A407-VAS;Lo;0;L;;;;;N;;;;;
106A8;LINEAR A SIGN A408-VAS;Lo;0;L;;;;;N;;;;;
106A9;LINEAR A SIGN A409-VAS;Lo;0;L;;;;;N;;;;;
106AA;LINEAR A SIGN A410-VAS;Lo;0;L;;;;;N;;;;;
106AB;LINEAR A SIGN A411-VAS;Lo;0;L;;;;;N;;;;;
106AC;LINEAR A SIGN A412-VAS;Lo;0;L;;;;;N;;;;;
106AD;LINEAR A SIGN A413-VAS;Lo;0;L;;;;;N;;;;;
106AE;LINEAR A SIGN A414-VAS;Lo;0;L;;;;;N;;;;;
106AF;LINEAR A SIGN A415-VAS;Lo;0;L;;;;;N;;;;;
106B0;LINEAR A SIGN A416-VAS;Lo;0;L;;;;;N;;;;;
106B1;LINEAR A SIGN A417-VAS;Lo;0;L;;;;;N;;;;;
106B2;LINEAR A SIGN A418-VAS;Lo;0;L;;;;;N;;;;;
106B3;LINEAR A SIGN A501;Lo;0;L;;;;;N;;;;;
106B4;LINEAR A SIGN A502;Lo;0;L;;;;;N;;;;;
106B5;LINEAR A SIGN A503;Lo;0;L;;;;;N;;;;;
106B6;LINEAR A SIGN A504;Lo;0;L;;;;;N;;;;;
106B7;LINEAR A SIGN A505;Lo;0;L;;;;;N;;;;;
106B8;LINEAR A SIGN A506;Lo;0;L;;;;;N;;;;;
106B9;LINEAR A SIGN A508;Lo;0;L;;;;;N;;;;;
106BA;LINEAR A SIGN A509;Lo;0;L;;;;;N;;;;;
106BB;LINEAR A SIGN A510;Lo;0;L;;;;;N;;;;;
106BC;LINEAR A SIGN A511;Lo;0;L;;;;;N;;;;;
106BD;LINEAR A SIGN A512;Lo;0;L;;;;;N;;;;;
106BE;LINEAR A SIGN A513;Lo;0;L;;;;;N;;;;;
106BF;LINEAR A SIGN A515;Lo;0;L;;;;;N;;;;;
106C0;LINEAR A SIGN A516;Lo;0;L;;;;;N;;;;;
106C1;LINEAR A SIGN A520;Lo;0;L;;;;;N;;;;;
106C2;LINEAR A SIGN A521;Lo;0;L;;;;;N;;;;;
106C3;LINEAR A SIGN A523;Lo;0;L;;;;;N;;;;;
106C4;LINEAR A SIGN A524;Lo;0;L;;;;;N;;;;;
106C5;LINEAR A SIGN A525;Lo;0;L;;;;;N;;;;;
106C6;LINEAR A SIGN A526;Lo;0;L;;;;;N;;;;;
106C7;LINEAR A SIGN A527;Lo;0;L;;;;;N;;;;;
106C8;LINEAR A SIGN A528;Lo;0;L;;;;;N;;;;;
106C9;LINEAR A SIGN A529;Lo;0;L;;;;;N;;;;;
106CA;LINEAR A SIGN A530;Lo;0;L;;;;;N;;;;;
106CB;LINEAR A SIGN A531;Lo;0;L;;;;;N;;;;;
106CC;LINEAR A SIGN A532;Lo;0;L;;;;;N;;;;;
106CD;LINEAR A SIGN A534;Lo;0;L;;;;;N;;;;;
106CE;LINEAR A SIGN A535;Lo;0;L;;;;;N;;;;;
106CF;LINEAR A SIGN A536;Lo;0;L;;;;;N;;;;;
106D0;LINEAR A SIGN A537;Lo;0;L;;;;;N;;;;;
106D1;LINEAR A SIGN A538;Lo;0;L;;;;;N;;;;;
106D2;LINEAR A SIGN A539;Lo;0;L;;;;;N;;;;;
106D3;LINEAR A SIGN A540;Lo;0;L;;;;;N;;;;;
106D4;LINEAR A SIGN A541;Lo;0;L;;;;;N;;;;;
106D5;LINEAR A SIGN A542;Lo;0;L;;;;;N;;;;;
106D6;LINEAR A SIGN A545;Lo;0;L;;;;;N;;;;;
106D7;LINEAR A SIGN A547;Lo;0;L;;;;;N;;;;;
106D8;LINEAR A SIGN A548;Lo;0;L;;;;;N;;;;;
106D9;LINEAR A SIGN A549;Lo;0;L;;;;;N;;;;;
106DA;LINEAR A SIGN A550;Lo;0;L;;;;;N;;;;;
106DB;LINEAR A SIGN A551;Lo;0;L;;;;;N;;;;;
106DC;LINEAR A SIGN A552;Lo;0;L;;;;;N;;;;;
106DD;LINEAR A SIGN A553;Lo;0;L;;;;;N;;;;;
106DE;LINEAR A SIGN A554;Lo;0;L;;;;;N;;;;;
106DF;LINEAR A SIGN A555;Lo;0;L;;;;;N;;;;;
106E0;LINEAR A SIGN A556;Lo;0;L;;;;;N;;;;;
106E1;LINEAR A SIGN A557;Lo;0;L;;;;;N;;;;;
106E2;LINEAR A SIGN A559;Lo;0;L;;;;;N;;;;;
106E3;LINEAR A SIGN A563;Lo;0;L;;;;;N;;;;;
106E4;LINEAR A SIGN A564;Lo;0;L;;;;;N;;;;;
106E5;LINEAR A SIGN A565;Lo;0;L;;;;;N;;;;;
106E6;LINEAR A SIGN A566;Lo;0;L;;;;;N;;;;;
106E7;LINEAR A SIGN A568;Lo;0;L;;;;;N;;;;;
106E8;LINEAR A SIGN A569;Lo;0;L;;;;;N;;;;;
106E9;LINEAR A SIGN A570;Lo;0;L;;;;;N;;;;;
106EA;LINEAR A SIGN A571;Lo;0;L;;;;;N;;;;;
106EB;LINEAR A SIGN A572;Lo;0;L;;;;;N;;;;;
106EC;LINEAR A SIGN A573;Lo;0;L;;;;;N;;;;;
106ED;LINEAR A SIGN A574;Lo;0;L;;;;;N;;;;;
106EE;LINEAR A SIGN A575;Lo;0;L;;;;;N;;;;;
106EF;LINEAR A SIGN A576;Lo;0;L;;;;;N;;;;;
106F0;LINEAR A SIGN A577;Lo;0;L;;;;;N;;;;;
106F1;LINEAR A SIGN A578;Lo;0;L;;;;;N;;;;;
106F2;LINEAR A SIGN A579;Lo;0;L;;;;;N;;;;;
106F3;LINEAR A SIGN A580;Lo;0;L;;;;;N;;;;;
106F4;LINEAR A SIGN A581;Lo;0;L;;;;;N;;;;;
106F5;LINEAR A SIGN A582;Lo;0;L;;;;;N;;;;;
106F6;LINEAR A SIGN A583;Lo;0;L;;;;;N;;;;;
106F7;LINEAR A SIGN A584;Lo;0;L;;;;;N;;;;;
106F8;LINEAR A SIGN A585;Lo;0;L;;;;;N;;;;;
106F9;LINEAR A SIGN A586;Lo;0;L;;;;;N;;;;;
106FA;LINEAR A SIGN A587;Lo;0;L;;;;;N;;;;;
106FB;LINEAR A SIGN A588;Lo;0;L;;;;;N;;;;;
106FC;LINEAR A SIGN A589;Lo;0;L;;;;;N;;;;;
106FD;LINEAR A SIGN A591;Lo;0;L;;;;;N;;;;;
106FE;LINEAR A SIGN A592;Lo;0;L;;;;;N;;;;;
106FF;LINEAR A SIGN A594;Lo;0;L;;;;;N;;;;;
10700;LINEAR A SIGN A595;Lo;0;L;;;;;N;;;;;
10701;LINEAR A SIGN A596;Lo;0;L;;;;;N;;;;;
10702;LINEAR A SIGN A598;Lo;0;L;;;;;N;;;;;
10703;LINEAR A SIGN A600;Lo;0;L;;;;;N;;;;;
10704;LINEAR A SIGN A601;Lo;0;L;;;;;N;;;;;
10705;LINEAR A SIGN A602;Lo;0;L;;;;;N;;;;;
10706;LINEAR A SIGN A603;Lo;0;L;;;;;N;;;;;
10707;LINEAR A SIGN A604;Lo;0;L;;;;;N;;;;;
10708;LINEAR A SIGN A606;Lo;0;L;;;;;N;;;;;
10709;LINEAR A SIGN A608;Lo;0;L;;;;;N;;;;;
1070A;LINEAR A SIGN A609;Lo;0;L;;;;;N;;;;;
1070B;LINEAR A SIGN A610;Lo;0;L;;;;;N;;;;;
1070C;LINEAR A SIGN A611;Lo;0;L;;;;;N;;;;;
1070D;LINEAR A SIGN A612;Lo;0;L;;;;;N;;;;;
1070E;LINEAR A SIGN A613;Lo;0;L;;;;;N;;;;;
1070F;LINEAR A SIGN A614;Lo;0;L;;;;;N;;;;;
10710;LINEAR A SIGN A615;Lo;0;L;;;;;N;;;;;
10711;LINEAR A SIGN A616;Lo;0;L;;;;;N;;;;;
10712;LINEAR A SIGN A617;Lo;0;L;;;;;N;;;;;
10713;LINEAR A SIGN A618;Lo;0;L;;;;;N;;;;;
10714;LINEAR A SIGN A619;Lo;0;L;;;;;N;;;;;
10715;LINEAR A SIGN A620;Lo;0;L;;;;;N;;;;;
10716;LINEAR A SIGN A621;Lo;0;L;;;;;N;;;;;
10717;LINEAR A SIGN A622;Lo;0;L;;;;;N;;;;;
10718;LINEAR A SIGN A623;Lo;0;L;;;;;N;;;;;
10719;LINEAR A SIGN A624;Lo;0;L;;;;;N;;;;;
1071A;LINEAR A SIGN A626;Lo;0;L;;;;;N;;;;;
1071B;LINEAR A SIGN A627;Lo;0;L;;;;;N;;;;;
1071C;LINEAR A SIGN A628;Lo;0;L;;;;;N;;;;;
1071D;LINEAR A SIGN A629;Lo;0;L;;;;;N;;;;;
1071E;LINEAR A SIGN A634;Lo;0;L;;;;;N;;;;;
1071F;LINEAR A SIGN A637;Lo;0;L;;;;;N;;;;;
10720;LINEAR A SIGN A638;Lo;0;L;;;;;N;;;;;
10721;LINEAR A SIGN A640;Lo;0;L;;;;;N;;;;;
10722;LINEAR A SIGN A642;Lo;0;L;;;;;N;;;;;
10723;LINEAR A SIGN A643;Lo;0;L;;;;;N;;;;;
10724;LINEAR A SIGN A644;Lo;0;L;;;;;N;;;;;
10725;LINEAR A SIGN A645;Lo;0;L;;;;;N;;;;;
10726;LINEAR A SIGN A646;Lo;0;L;;;;;N;;;;;
10727;LINEAR A SIGN A648;Lo;0;L;;;;;N;;;;;
10728;LINEAR A SIGN A649;Lo;0;L;;;;;N;;;;;
10729;LINEAR A SIGN A651;Lo;0;L;;;;;N;;;;;
1072A;LINEAR A SIGN A652;Lo;0;L;;;;;N;;;;;
1072B;LINEAR A SIGN A653;Lo;0;L;;;;;N;;;;;
1072C;LINEAR A SIGN A654;Lo;0;L;;;;;N;;;;;
1072D;LINEAR A SIGN A655;Lo;0;L;;;;;N;;;;;
1072E;LINEAR A SIGN A656;Lo;0;L;;;;;N;;;;;
1072F;LINEAR A SIGN A657;Lo;0;L;;;;;N;;;;;
10730;LINEAR A SIGN A658;Lo;0;L;;;;;N;;;;;
10731;LINEAR A SIGN A659;Lo;0;L;;;;;N;;;;;
10732;LINEAR A SIGN A660;Lo;0;L;;;;;N;;;;;
10733;LINEAR A SIGN A661;Lo;0;L;;;;;N;;;;;
10734;LINEAR A SIGN A662;Lo;0;L;;;;;N;;;;;
10735;LINEAR A SIGN A663;Lo;0;L;;;;;N;;;;;
10736;LINEAR A SIGN A664;Lo;0;L;;;;;N;;;;;
10740;LINEAR A SIGN A701 A;Lo;0;L;;;;;N;;;;;
10741;LINEAR A SIGN A702 B;Lo;0;L;;;;;N;;;;;
10742;LINEAR A SIGN A703 D;Lo;0;L;;;;;N;;;;;
10743;LINEAR A SIGN A704 E;Lo;0;L;;;;;N;;;;;
10744;LINEAR A SIGN A705 F;Lo;0;L;;;;;N;;;;;
10745;LINEAR A SIGN A706 H;Lo;0;L;;;;;N;;;;;
10746;LINEAR A SIGN A707 J;Lo;0;L;;;;;N;;;;;
10747;LINEAR A SIGN A708 K;Lo;0;L;;;;;N;;;;;
10748;LINEAR A SIGN A709 L;Lo;0;L;;;;;N;;;;;
10749;LINEAR A SIGN A709-2 L2;Lo;0;L;;;;;N;;;;;
1074A;LINEAR A SIGN A709-3 L3;Lo;0;L;;;;;N;;;;;
1074B;LINEAR A SIGN A709-4 L4;Lo;0;L;;;;;N;;;;;
1074C;LINEAR A SIGN A709-6 L6;Lo;0;L;;;;;N;;;;;
1074D;LINEAR A SIGN A710 W;Lo;0;L;;;;;N;;;;;
1074E;LINEAR A SIGN A711 X;Lo;0;L;;;;;N;;;;;
1074F;LINEAR A SIGN A712 Y;Lo;0;L;;;;;N;;;;;
10750;LINEAR A SIGN A713 OMEGA;Lo;0;L;;;;;N;;;;;
10751;LINEAR A SIGN A714 ABB;Lo;0;L;;;;;N;;;;;
10752;LINEAR A SIGN A715 BB;Lo;0;L;;;;;N;;;;;
10753;LINEAR A SIGN A717 DD;Lo;0;L;;;;;N;;;;;
10754;LINEAR A SIGN A726 EYYY;Lo;0;L;;;;;N;;;;;
10755;LINEAR A SIGN A732 JE;Lo;0;L;;;;;N;;;;;
10760;LINEAR A SIGN A800;Lo;0;L;;;;;N;;;;;
10761;LINEAR A SIGN A801;Lo;0;L;;;;;N;;;;;
10762;LINEAR A SIGN A802;Lo;0;L;;;;;N;;;;;
10763;LINEAR A SIGN A803;Lo;0;L;;;;;N;;;;;
10764;LINEAR A SIGN A804;Lo;0;L;;;;;N;;;;;
10765;LINEAR A SIGN A805;Lo;0;L;;;;;N;;;;;
10766;LINEAR A SIGN A806;Lo;0;L;;;;;N;;;;;
10767;LINEAR A SIGN A807;Lo;0;L;;;;;N;;;;;
10780;MODIFIER LETTER SMALL CAPITAL AA;Lm;0;L;;;;;N;;;;;
10781;MODIFIER LETTER SUPERSCRIPT TRIANGULAR COLON;Lm;0;L;<super> 02D0;;;;N;;;;;
10782;MODIFIER LETTER SUPERSCRIPT HALF TRIANGULAR COLON;Lm;0;L;<super> 02D1;;;;N;;;;;
10783;MODIFIER LETTER SMALL AE;Lm;0;L;<super> 00E6;;;;N;;;;;
10784;MODIFIER LETTER SMALL CAPITAL B;Lm;0;L;<super> 0299;;;;N;;;;;
10785;MODIFIER LETTER SMALL B WITH HOOK;Lm;0;L;<super> 0253;;;;N;;;;;
10787;MODIFIER LETTER SMALL DZ DIGRAPH;Lm;0;L;<super> 02A3;;;;N;;;;;
10788;MODIFIER LETTER SMALL DZ DIGRAPH WITH RETROFLEX HOOK;Lm;0;L;<super> AB66;;;;N;;;;;
10789;MODIFIER LETTER SMALL DZ DIGRAPH WITH CURL;Lm;0;L;<super> 02A5;;;;N;;;;;
1078A;MODIFIER LETTER SMALL DEZH DIGRAPH;Lm;0;L;<super> 02A4;;;;N;;;;;
1078B;MODIFIER LETTER SMALL D WITH TAIL;Lm;0;L;<super> 0256;;;;N;;;;;
1078C;MODIFIER LETTER SMALL D WITH HOOK;Lm;0;L;<super> 0257;;;;N;;;;;
1078D;MODIFIER LETTER SMALL D WITH HOOK AND TAIL;Lm;0;L;<super> 1D91;;;;N;;;;;
1078E;MODIFIER LETTER SMALL REVERSED E;Lm;0;L;<super> 0258;;;;N;;;;;
1078F;MODIFIER LETTER SMALL CLOSED REVERSED OPEN E;Lm;0;L;<super> 025E;;;;N;;;;;
10790;MODIFIER LETTER SMALL FENG DIGRAPH;Lm;0;L;<super> 02A9;;;;N;;;;;
10791;MODIFIER LETTER SMALL RAMS HORN;Lm;0;L;<super> 0264;;;;N;;;;;
10792;MODIFIER LETTER SMALL CAPITAL G;Lm;0;L;<super> 0262;;;;N;;;;;
10793;MODIFIER LETTER SMALL G WITH HOOK;Lm;0;L;<super> 0260;;;;N;;;;;
10794;MODIFIER LETTER SMALL CAPITAL G WITH HOOK;Lm;0;L;<super> 029B;;;;N;;;;;
10795;MODIFIER LETTER SMALL H WITH STROKE;Lm;0;L;<super> 0127;;;;N;;;;;
10796;MODIFIER LETTER SMALL CAPITAL H;Lm;0;L;<super> 029C;;;;N;;;;;
10797;MODIFIER LETTER SMALL HENG WITH HOOK;Lm;0;L;<super> 0267;;;;N;;;;;
10798;MODIFIER LETTER SMALL DOTLESS J WITH STROKE AND HOOK;Lm;0;L;<super> 0284;;;;N;;;;;
10799;MODIFIER LETTER SMALL LS DIGRAPH;Lm;0;L;<super> 02AA;;;;N;;;;;
1079A;MODIFIER LETTER SMALL LZ DIGRAPH;Lm;0;L;<super> 02AB;;;;N;;;;;
1079B;MODIFIER LETTER SMALL L WITH BELT;Lm;0;L;<super> 026C;;;;N;;;;;
1079C;MODIFIER LETTER SMALL CAPITAL L WITH BELT;Lm;0;L;<super> 1DF04;;;;N;;;;;
1079D;MODIFIER LETTER SMALL L WITH RETROFLEX HOOK AND BELT;Lm;0;L;<super> A78E;;;;N;;;;;
1079E;MODIFIER LETTER SMALL LEZH;Lm;0;L;<super> 026E;;;;N;;;;;
1079F;MODIFIER LETTER SMALL LEZH WITH RETROFLEX HOOK;Lm;0;L;<super> 1DF05;;;;N;;;;;
107A0;MODIFIER LETTER SMALL TURNED Y;Lm;0;L;<super> 028E;;;;N;;;;;
107A1;MODIFIER LETTER SMALL TURNED Y WITH BELT;Lm;0;L;<super> 1DF06;;;;N;;;;;
107A2;MODIFIER LETTER SMALL O WITH STROKE;Lm;0;L;<super> 00F8;;;;N;;;;;
107A3;MODIFIER LETTER SMALL CAPITAL OE;Lm;0;L;<super> 0276;;;;N;;;;;
107A4;MODIFIER LETTER SMALL CLOSED OMEGA;Lm;0;L;<super> 0277;;;;N;;;;;
107A5;MODIFIER LETTER SMALL Q;Lm;0;L;<super> 0071;;;;N;;;;;
107A6;MODIFIER LETTER SMALL TURNED R WITH LONG LEG;Lm;0;L;<super> 027A;;;;N;;;;;
107A7;MODIFIER LETTER SMALL TURNED R WITH LONG LEG AND RETROFLEX HOOK;Lm;0;L;<super> 1DF08;;;;N;;;;;
107A8;MODIFIER LETTER SMALL R WITH TAIL;Lm;0;L;<super> 027D;;;;N;;;;;
107A9;MODIFIER LETTER SMALL R WITH FISHHOOK;Lm;0;L;<super> 027E;;;;N;;;;;
107AA;MODIFIER LETTER SMALL CAPITAL R;Lm;0;L;<super> 0280;;;;N;;;;;
107AB;MODIFIER LETTER SMALL TC DIGRAPH WITH CURL;Lm;0;L;<super> 02A8;;;;N;;;;;
107AC;MODIFIER LETTER SMALL TS DIGRAPH;Lm;0;L;<super> 02A6;;;;N;;;;;
107AD;MODIFIER LETTER SMALL TS DIGRAPH WITH RETROFLEX HOOK;Lm;0;L;<super> AB67;;;;N;;;;;
107AE;MODIFIER LETTER SMALL TESH DIGRAPH;Lm;0;L;<super> 02A7;;;;N;;;;;
107AF;MODIFIER LETTER SMALL T WITH RETROFLEX HOOK;Lm;0;L;<super> 0288;;;;N;;;;;
107B0;MODIFIER LETTER SMALL V WITH RIGHT HOOK;Lm;0;L;<super> 2C71;;;;N;;;;;
107B2;MODIFIER LETTER SMALL CAPITAL Y;Lm;0;L;<super> 028F;;;;N;;;;;
107B3;MODIFIER LETTER GLOTTAL STOP WITH STROKE;Lm;0;L;<super> 02A1;;;;N;;;;;
107B4;MODIFIER LETTER REVERSED GLOTTAL STOP WITH STROKE;Lm;0;L;<super> 02A2;;;;N;;;;;
107B5;MODIFIER LETTER BILABIAL CLICK;Lm;0;L;<super> 0298;;;;N;;;;;
107B6;MODIFIER LETTER DENTAL CLICK;Lm;0;L;<super> 01C0;;;;N;;;;;
107B7;MODIFIER LETTER LATERAL CLICK;Lm;0;L;<super> 01C1;;;;N;;;;;
107B8;MODIFIER LETTER ALVEOLAR CLICK;Lm;0;L;<super> 01C2;;;;N;;;;;
107B9;MODIFIER LETTER RETROFLEX CLICK WITH RETROFLEX HOOK;Lm;0;L;<super> 1DF0A;;;;N;;;;;
107BA;MODIFIER LETTER SMALL S WITH CURL;Lm;0;L;<super> 1DF1E;;;;N;;;;;
10800;CYPRIOT SYLLABLE A;Lo;0;R;;;;;N;;;;;
10801;CYPRIOT SYLLABLE E;Lo;0;R;;;;;N;;;;;
10802;CYPRIOT SYLLABLE I;Lo;0;R;;;;;N;;;;;
10803;CYPRIOT SYLLABLE O;Lo;0;R;;;;;N;;;;;
10804;CYPRIOT SYLLABLE U;Lo;0;R;;;;;N;;;;;
10805;CYPRIOT SYLLABLE JA;Lo;0;R;;;;;N;;;;;
10808;CYPRIOT SYLLABLE JO;Lo;0;R;;;;;N;;;;;
1080A;CYPRIOT SYLLABLE KA;Lo;0;R;;;;;N;;;;;
1080B;CYPRIOT SYLLABLE KE;Lo;0;R;;;;;N;;;;;
1080C;CYPRIOT SYLLABLE KI;Lo;0;R;;;;;N;;;;;
1080D;CYPRIOT SYLLABLE KO;Lo;0;R;;;;;N;;;;;
1080E;CYPRIOT SYLLABLE KU;Lo;0;R;;;;;N;;;;;
1080F;CYPRIOT SYLLABLE LA;Lo;0;R;;;;;N;;;;;
10810;CYPRIOT SYLLABLE LE;Lo;0;R;;;;;N;;;;;
10811;CYPRIOT SYLLABLE LI;Lo;0;R;;;;;N;;;;;
10812;CYPRIOT SYLLABLE LO;Lo;0;R;;;;;N;;;;;
10813;CYPRIOT SYLLABLE LU;Lo;0;R;;;;;N;;;;;
10814;CYPRIOT SYLLABLE MA;Lo;0;R;;;;;N;;;;;
10815;CYPRIOT SYLLABLE ME;Lo;0;R;;;;;N;;;;;
10816;CYPRIOT SYLLABLE MI;Lo;0;R;;;;;N;;;;;
10817;CYPRIOT SYLLABLE MO;Lo;0;R;;;;;N;;;;;
10818;CYPRIOT SYLLABLE MU;Lo;0;R;;;;;N;;;;;
10819;CYPRIOT SYLLABLE NA;Lo;0;R;;;;;N;;;;;
1081A;CYPRIOT SYLLABLE NE;Lo;0;R;;;;;N;;;;;
1081B;CYPRIOT SYLLABLE NI;Lo;0;R;;;;;N;;;;;
1081C;CYPRIOT SYLLABLE NO;Lo;0;R;;;;;N;;;;;
1081D;CYPRIOT SYLLABLE NU;Lo;0;R;;;;;N;;;;;
1081E;CYPRIOT SYLLABLE PA;Lo;0;R;;;;;N;;;;;
1081F;CYPRIOT SYLLABLE PE;Lo;0;R;;;;;N;;;;;
10820;CYPRIOT SYLLABLE PI;Lo;0;R;;;;;N;;;;;
10821;CYPRIOT SYLLABLE PO;Lo;0;R;;;;;N;;;;;
10822;CYPRIOT SYLLABLE PU;Lo;0;R;;;;;N;;;;;
10823;CYPRIOT SYLLABLE RA;Lo;0;R;;;;;N;;;;;
10824;CYPRIOT SYLLABLE RE;Lo;0;R;;;;;N;;;;;
10825;CYPRIOT SYLLABLE RI;Lo;0;R;;;;;N;;;;;
10826;CYPRIOT SYLLABLE RO;Lo;0;R;;;;;N;;;;;
10827;CYPRIOT SYLLABLE RU;Lo;0;R;;;;;N;;;;;
10828;CYPRIOT SYLLABLE SA;Lo;0;R;;;;;N;;;;;
10829;CYPRIOT SYLLABLE SE;Lo;0;R;;;;;N;;;;;
1082A;CYPRIOT SYLLABLE SI;Lo;0;R;;;;;N;;;;;
1082B;CYPRIOT SYLLABLE SO;Lo;0;R;;;;;N;;;;;
1082C;CYPRIOT SYLLABLE SU;Lo;0;R;;;;;N;;;;;
1082D;CYPRIOT SYLLABLE TA;Lo;0;R;;;;;N;;;;;
1082E;CYPRIOT SYLLABLE TE;Lo;0;R;;;;;N;;;;;
1082F;CYPRIOT SYLLABLE TI;Lo;0;R;;;;;N;;;;;
10830;CYPRIOT SYLLABLE TO;Lo;0;R;;;;;N;;;;;
10831;CYPRIOT SYLLABLE TU;Lo;0;R;;;;;N;;;;;
10832;CYPRIOT SYLLABLE WA;Lo;0;R;;;;;N;;;;;
10833;CYPRIOT SYLLABLE WE;Lo;0;R;;;;;N;;;;;
10834;CYPRIOT SYLLABLE WI;Lo;0;R;;;;;N;;;;;
10835;CYPRIOT SYLLABLE WO;Lo;0;R;;;;;N;;;;;
10837;CYPRIOT SYLLABLE XA;Lo;0;R;;;;;N;;;;;
10838;CYPRIOT SYLLABLE XE;Lo;0;R;;;;;N;;;;;
1083C;CYPRIOT SYLLABLE ZA;Lo;0;R;;;;;N;;;;;
1083F;CYPRIOT SYLLABLE ZO;Lo;0;R;;;;;N;;;;;
10840;IMPERIAL ARAMAIC LETTER ALEPH;Lo;0;R;;;;;N;;;;;
10841;IMPERIAL ARAMAIC LETTER BETH;Lo;0;R;;;;;N;;;;;
10842;IMPERIAL ARAMAIC LETTER GIMEL;Lo;0;R;;;;;N;;;;;
10843;IMPERIAL ARAMAIC LETTER DALETH;Lo;0;R;;;;;N;;;;;
10844;IMPERIAL ARAMAIC LETTER HE;Lo;0;R;;;;;N;;;;;
10845;IMPERIAL ARAMAIC LETTER WAW;Lo;0;R;;;;;N;;;;;
10846;IMPERIAL ARAMAIC LETTER ZAYIN;Lo;0;R;;;;;N;;;;;
10847;IMPERIAL ARAMAIC LETTER HETH;Lo;0;R;;;;;N;;;;;
10848;IMPERIAL ARAMAIC LETTER TETH;Lo;0;R;;;;;N;;;;;
10849;IMPERIAL ARAMAIC LETTER YODH;Lo;0;R;;;;;N;;;;;
1084A;IMPERIAL ARAMAIC LETTER KAPH;Lo;0;R;;;;;N;;;;;
1084B;IMPERIAL ARAMAIC LETTER LAMEDH;Lo;0;R;;;;;N;;;;;
1084C;IMPERIAL ARAMAIC LETTER MEM;Lo;0;R;;;;;N;;;;;
1084D;IMPERIAL ARAMAIC LETTER NUN;Lo;0;R;;;;;N;;;;;
1084E;IMPERIAL ARAMAIC LETTER SAMEKH;Lo;0;R;;;;;N;;;;;
1084F;IMPERIAL ARAMAIC LETTER AYIN;Lo;0;R;;;;;N;;;;;
10850;IMPERIAL ARAMAIC LETTER PE;Lo;0;R;;;;;N;;;;;
10851;IMPERIAL ARAMAIC LETTER SADHE;Lo;0;R;;;;;N;;;;;
10852;IMPERIAL ARAMAIC LETTER QOPH;Lo;0;R;;;;;N;;;;;
10853;IMPERIAL ARAMAIC LETTER RESH;Lo;0;R;;;;;N;;;;;
10854;IMPERIAL ARAMAIC LETTER SHIN;Lo;0;R;;;;;N;;;;;
10855;IMPERIAL ARAMAIC LETTER TAW;Lo;0;R;;;;;N;;;;;
10857;IMPERIAL ARAMAIC SECTION SIGN;Po;0;R;;;;;N;;;;;
10858;IMPERIAL ARAMAIC NUMBER ONE;No;0;R;;;;1;N;;;;;
10859;IMPERIAL ARAMAIC NUMBER TWO;No;0;R;;;;2;N;;;;;
1085A;IMPERIAL ARAMAIC NUMBER THREE;No;0;R;;;;3;N;;;;;
1085B;IMPERIAL ARAMAIC NUMBER TEN;No;0;R;;;;10;N;;;;;
1085C;IMPERIAL ARAMAIC NUMBER TWENTY;No;0;R;;;;20;N;;;;;
1085D;IMPERIAL ARAMAIC NUMBER ONE HUNDRED;No;0;R;;;;100;N;;;;;
1085E;IMPERIAL ARAMAIC NUMBER ONE THOUSAND;No;0;R;;;;1000;N;;;;;
1085F;IMPERIAL ARAMAIC NUMBER TEN THOUSAND;No;0;R;;;;10000;N;;;;;
10860;PALMYRENE LETTER ALEPH;Lo;0;R;;;;;N;;;;;
10861;PALMYRENE LETTER BETH;Lo;0;R;;;;;N;;;;;
10862;PALMYRENE LETTER GIMEL;Lo;0;R;;;;;N;;;;;
10863;PALMYRENE LETTER DALETH;Lo;0;R;;;;;N;;;;;
10864;PALMYRENE LETTER HE;Lo;0;R;;;;;N;;;;;
10865;PALMYRENE LETTER WAW;Lo;0;R;;;;;N;;;;;
10866;PALMYRENE LETTER ZAYIN;Lo;0;R;;;;;N;;;;;
10867;PALMYRENE LETTER HETH;Lo;0;R;;;;;N;;;;;
10868;PALMYRENE LETTER TETH;Lo;0;R;;;;;N;;;;;
10869;PALMYRENE LETTER YODH;Lo;0;R;;;;;N;;;;;
1086A;PALMYRENE LETTER KAPH;Lo;0;R;;;;;N;;;;;
1086B;PALMYRENE LETTER LAMEDH;Lo;0;R;;;;;N;;;;;
1086C;PALMYRENE LETTER MEM;Lo;0;R;;;;;N;;;;;
1086D;PALMYRENE LETTER FINAL NUN;Lo;0;R;;;;;N;;;;;
1086E;PALMYRENE LETTER NUN;Lo;0;R;;;;;N;;;;;
1086F;PALMYRENE LETTER SAMEKH;Lo;0;R;;;;;N;;;;;
10870;PALMYRENE LETTER AYIN;Lo;0;R;;;;;N;;;;;
10871;PALMYRENE LETTER PE;Lo;0;R;;;;;N;;;;;
10872;PALMYRENE LETTER SADHE;Lo;0;R;;;;;N;;;;;
10873;PALMYRENE LETTER QOPH;Lo;0;R;;;;;N;;;;;
10874;PALMYRENE LETTER RESH;Lo;0;R;;;;;N;;;;;
10875;PALMYRENE LETTER SHIN;Lo;0;R;;;;;N;;;;;
10876;PALMYRENE LETTER TAW;Lo;0;R;;;;;N;;;;;
10877;PALMYRENE LEFT-POINTING FLEURON;So;0;R;;;;;N;;;;;
10878;PALMYRENE RIGHT-POINTING FLEURON;So;0;R;;;;;N;;;;;
10879;PALMYRENE NUMBER ONE;No;0;R;;;;1;N;;;;;
1087A;PALMYRENE NUMBER TWO;No;0;R;;;;2;N;;;;;
1087B;PALMYRENE NUMBER THREE;No;0;R;;;;3;N;;;;;
1087C;PALMYRENE NUMBER FOUR;No;0;R;;;;4;N;;;;;
1087D;PALMYRENE NUMBER FIVE;No;0;R;;;;5;N;;;;;
1087E;PALMYRENE NUMBER TEN;No;0;R;;;;10;N;;;;;
1087F;PALMYRENE NUMBER TWENTY;No;0;R;;;;20;N;;;;;
10880;NABATAEAN LETTER FINAL ALEPH;Lo;0;R;;;;;N;;;;;
10881;NABATAEAN LETTER ALEPH;Lo;0;R;;;;;N;;;;;
10882;NABATAEAN LETTER FINAL BETH;Lo;0;R;;;;;N;;;;;
10883;NABATAEAN LETTER BETH;Lo;0;R;;;;;N;;;;;
10884;NABATAEAN LETTER GIMEL;Lo;0;R;;;;;N;;;;;
10885;NABATAEAN LETTER DALETH;Lo;0;R;;;;;N;;;;;
10886;NABATAEAN LETTER FINAL HE;Lo;0;R;;;;;N;;;;;
10887;NABATAEAN LETTER HE;Lo;0;R;;;;;N;;;;;
10888;NABATAEAN LETTER WAW;Lo;0;R;;;;;N;;;;;
10889;NABATAEAN LETTER ZAYIN;Lo;0;R;;;;;N;;;;;
1088A;NABATAEAN LETTER HETH;Lo;0;R;;;;;N;;;;;
1088B;NABATAEAN LETTER TETH;Lo;0;R;;;;;N;;;;;
1088C;NABATAEAN LETTER FINAL YODH;Lo;0;R;;;;;N;;;;;
1088D;NABATAEAN LETTER YODH;Lo;0;R;;;;;N;;;;;
1088E;NABATAEAN LETTER FINAL KAPH;Lo;0;R;;;;;N;;;;;
1088F;NABATAEAN LETTER KAPH;Lo;0;R;;;;;N;;;;;
10890;NABATAEAN LETTER FINAL LAMEDH;Lo;0;R;;;;;N;;;;;
10891;NABATAEAN LETTER LAMEDH;Lo;0;R;;;;;N;;;;;
10892;NABATAEAN LETTER FINAL MEM;Lo;0;R;;;;;N;;;;;
10893;NABATAEAN LETTER MEM;Lo;0;R;;;;;N;;;;;
10894;NABATAEAN LETTER FINAL NUN;Lo;0;R;;;;;N;;;;;
10895;NABATAEAN LETTER NUN;Lo;0;R;;;;;N;;;;;
10896;NABATAEAN LETTER SAMEKH;Lo;0;R;;;;;N;;;;;
10897;NABATAEAN LETTER AYIN;Lo;0;R;;;;;N;;;;;
10898;NABATAEAN LETTER PE;Lo;0;R;;;;;N;;;;;
10899;NABATAEAN LETTER SADHE;Lo;0;R;;;;;N;;;;;
1089A;NABATAEAN LETTER QOPH;Lo;0;R;;;;;N;;;;;
1089B;NABATAEAN LETTER RESH;Lo;0;R;;;;;N;;;;;
1089C;NABATAEAN LETTER FINAL SHIN;Lo;0;R;;;;;N;;;;;
1089D;NABATAEAN LETTER SHIN;Lo;0;R;;;;;N;;;;;
1089E;NABATAEAN LETTER TAW;Lo;0;R;;;;;N;;;;;
108A7;NABATAEAN NUMBER ONE;No;0;R;;;;1;N;;;;;
108A8;NABATAEAN NUMBER TWO;No;0;R;;;;2;N;;;;;
108A9;NABATAEAN NUMBER THREE;No;0;R;;;;3;N;;;;;
108AA;NABATAEAN NUMBER FOUR;No;0;R;;;;4;N;;;;;
108AB;NABATAEAN CRUCIFORM NUMBER FOUR;No;0;R;;;;4;N;;;;;
108AC;NABATAEAN NUMBER FIVE;No;0;R;;;;5;N;;;;;
108AD;NABATAEAN NUMBER TEN;No;0;R;;;;10;N;;;;;
108AE;NABATAEAN NUMBER TWENTY;No;0;R;;;;20;N;;;;;
108AF;NABATAEAN NUMBER ONE HUNDRED;No;0;R;;;;100;N;;;;;
108E0;HATRAN LETTER ALEPH;Lo;0;R;;;;;N;;;;;
108E1;HATRAN LETTER BETH;Lo;0;R;;;;;N;;;;;
108E2;HATRAN LETTER GIMEL;Lo;0;R;;;;;N;;;;;
108E3;HATRAN LETTER DALETH-RESH;Lo;0;R;;;;;N;;;;;
108E4;HATRAN LETTER HE;Lo;0;R;;;;;N;;;;;
108E5;HATRAN LETTER WAW;Lo;0;R;;;;;N;;;;;
108E6;HATRAN LETTER ZAYN;Lo;0;R;;;;;N;;;;;
108E7;HATRAN LETTER HETH;Lo;0;R;;;;;N;;;;;
108E8;HATRAN LETTER TETH;Lo;0;R;;;;;N;;;;;
108E9;HATRAN LETTER YODH;Lo;0;R;;;;;N;;;;;
108EA;HATRAN LETTER KAPH;Lo;0;R;;;;;N;;;;;
108EB;HATRAN LETTER LAMEDH;Lo;0;R;;;;;N;;;;;
108EC;HATRAN LETTER MEM;Lo;0;R;;;;;N;;;;;
108ED;HATRAN LETTER NUN;Lo;0;R;;;;;N;;;;;
108EE;HATRAN LETTER SAMEKH;Lo;0;R;;;;;N;;;;;
108EF;HATRAN LETTER AYN;Lo;0;R;;;;;N;;;;;
108F0;HATRAN LETTER PE;Lo;0;R;;;;;N;;;;;
108F1;HATRAN LETTER SADHE;Lo;0;R;;;;;N;;;;;
108F2;HATRAN LETTER QOPH;Lo;0;R;;;;;N;;;;;
108F4;HATRAN LETTER SHIN;Lo;0;R;;;;;N;;;;;
108F5;HATRAN LETTER TAW;Lo;0;R;;;;;N;;;;;
108FB;HATRAN NUMBER ONE;No;0;R;;;;1;N;;;;;
108FC;HATRAN NUMBER FIVE;No;0;R;;;;5;N;;;;;
108FD;HATRAN NUMBER TEN;No;0;R;;;;10;N;;;;;
108FE;HATRAN NUMBER TWENTY;No;0;R;;;;20;N;;;;;
108FF;HATRAN NUMBER ONE HUNDRED;No;0;R;;;;100;N;;;;;
10900;PHOENICIAN LETTER ALF;Lo;0;R;;;;;N;;;;;
10901;PHOENICIAN LETTER BET;Lo;0;R;;;;;N;;;;;
10902;PHOENICIAN LETTER GAML;Lo;0;R;;;;;N;;;;;
10903;PHOENICIAN LETTER DELT;Lo;0;R;;;;;N;;;;;
10904;PHOENICIAN LETTER HE;Lo;0;R;;;;;N;;;;;
10905;PHOENICIAN LETTER WAU;Lo;0;R;;;;;N;;;;;
10906;PHOENICIAN LETTER ZAI;Lo;0;R;;;;;N;;;;;
10907;PHOENICIAN LETTER HET;Lo;0;R;;;;;N;;;;;
10908;PHOENICIAN LETTER TET;Lo;0;R;;;;;N;;;;;
10909;PHOENICIAN LETTER YOD;Lo;0;R;;;;;N;;;;;
1090A;PHOENICIAN LETTER KAF;Lo;0;R;;;;;N;;;;;
1090B;PHOENICIAN LETTER LAMD;Lo;0;R;;;;;N;;;;;
1090C;PHOENICIAN LETTER MEM;Lo;0;R;;;;;N;;;;;
1090D;PHOENICIAN LETTER NUN;Lo;0;R;;;;;N;;;;;
1090E;PHOENICIAN LETTER SEMK;Lo;0;R;;;;;N;;;;;
1090F;PHOENICIAN LETTER AIN;Lo;0;R;;;;;N;;;;;
10910;PHOENICIAN LETTER PE;Lo;0;R;;;;;N;;;;;
10911;PHOENICIAN LETTER SADE;Lo;0;R;;;;;N;;;;;
10912;PHOENICIAN LETTER QOF;Lo;0;R;;;;;N;;;;;
10913;PHOENICIAN LETTER ROSH;Lo;0;R;;;;;N;;;;;
10914;PHOENICIAN LETTER SHIN;Lo;0;R;;;;;N;;;;;
10915;PHOENICIAN LETTER TAU;Lo;0;R;;;;;N;;;;;
10916;PHOENICIAN NUMBER ONE;No;0;R;;;;1;N;;;;;
10917;PHOENICIAN NUMBER TEN;No;0;R;;;;10;N;;;;;
10918;PHOENICIAN NUMBER TWENTY;No;0;R;;;;20;N;;;;;
10919;PHOENICIAN NUMBER ONE HUNDRED;No;0;R;;;;100;N;;;;;
1091A;PHOENICIAN NUMBER TWO;No;0;R;;;;2;N;;;;;
1091B;PHOENICIAN NUMBER THREE;No;0;R;;;;3;N;;;;;
1091F;PHOENICIAN WORD SEPARATOR;Po;0;ON;;;;;N;;;;;
10920;LYDIAN LETTER A;Lo;0;R;;;;;N;;;;;
10921;LYDIAN LETTER B;Lo;0;R;;;;;N;;;;;
10922;LYDIAN LETTER G;Lo;0;R;;;;;N;;;;;
10923;LYDIAN LETTER D;Lo;0;R;;;;;N;;;;;
10924;LYDIAN LETTER E;Lo;0;R;;;;;N;;;;;
10925;LYDIAN LETTER V;Lo;0;R;;;;;N;;;;;
10926;LYDIAN LETTER I;Lo;0;R;;;;;N;;;;;
10927;LYDIAN LETTER Y;Lo;0;R;;;;;N;;;;;
10928;LYDIAN LETTER K;Lo;0;R;;;;;N;;;;;
10929;LYDIAN LETTER L;Lo;0;R;;;;;N;;;;;
1092A;LYDIAN LETTER M;Lo;0;R;;;;;N;;;;;
1092B;LYDIAN LETTER N;Lo;0;R;;;;;N;;;;;
1092C;LYDIAN LETTER O;Lo;0;R;;;;;N;;;;;
1092D;LYDIAN LETTER R;Lo;0;R;;;;;N;;;;;
1092E;LYDIAN LETTER SS;Lo;0;R;;;;;N;;;;;
1092F;LYDIAN LETTER T;Lo;0;R;;;;;N;;;;;
10930;LYDIAN LETTER U;Lo;0;R;;;;;N;;;;;
10931;LYDIAN LETTER F;Lo;0;R;;;;;N;;;;;
10932;LYDIAN LETTER Q;Lo;0;R;;;;;N;;;;;
10933;LYDIAN LETTER S;Lo;0;R;;;;;N;;;;;
10934;LYDIAN LETTER TT;Lo;0;R;;;;;N;;;;;
10935;LYDIAN LETTER AN;Lo;0;R;;;;;N;;;;;
10936;LYDIAN LETTER EN;Lo;0;R;;;;;N;;;;;
10937;LYDIAN LETTER LY;Lo;0;R;;;;;N;;;;;
10938;LYDIAN LETTER NN;Lo;0;R;;;;;N;;;;;
10939;LYDIAN LETTER C;Lo;0;R;;;;;N;;;;;
1093F;LYDIAN TRIANGULAR MARK;Po;0;R;;;;;N;;;;;
10980;MEROITIC HIEROGLYPHIC LETTER A;Lo;0;R;;;;;N;;;;;
10981;MEROITIC HIEROGLYPHIC LETTER E;Lo;0;R;;;;;N;;;;;
10982;MEROITIC HIEROGLYPHIC LETTER I;Lo;0;R;;;;;N;;;;;
10983;MEROITIC HIEROGLYPHIC LETTER O;Lo;0;R;;;;;N;;;;;
10984;MEROITIC HIEROGLYPHIC LETTER YA;Lo;0;R;;;;;N;;;;;
10985;MEROITIC HIEROGLYPHIC LETTER WA;Lo;0;R;;;;;N;;;;;
10986;MEROITIC HIEROGLYPHIC LETTER BA;Lo;0;R;;;;;N;;;;;
10987;MEROITIC HIEROGLYPHIC LETTER BA-2;Lo;0;R;;;;;N;;;;;
10988;MEROITIC HIEROGLYPHIC LETTER PA;Lo;0;R;;;;;N;;;;;
10989;MEROITIC HIEROGLYPHIC LETTER MA;Lo;0;R;;;;;N;;;;;
1098A;MEROITIC HIEROGLYPHIC LETTER NA;Lo;0;R;;;;;N;;;;;
1098B;MEROITIC HIEROGLYPHIC LETTER NA-2;Lo;0;R;;;;;N;;;;;
1098C;MEROITIC HIEROGLYPHIC LETTER NE;Lo;0;R;;;;;N;;;;;
1098D;MEROITIC HIEROGLYPHIC LETTER NE-2;Lo;0;R;;;;;N;;;;;
1098E;MEROITIC HIEROGLYPHIC LETTER RA;Lo;0;R;;;;;N;;;;;
1098F;MEROITIC HIEROGLYPHIC LETTER RA-2;Lo;0;R;;;;;N;;;;;
10990;MEROITIC HIEROGLYPHIC LETTER LA;Lo;0;R;;;;;N;;;;;
10991;MEROITIC HIEROGLYPHIC LETTER KHA;Lo;0;R;;;;;N;;;;;
10992;MEROITIC HIEROGLYPHIC LETTER HHA;Lo;0;R;;;;;N;;;;;
10993;MEROITIC HIEROGLYPHIC LETTER SA;Lo;0;R;;;;;N;;;;;
10994;MEROITIC HIEROGLYPHIC LETTER SA-2;Lo;0;R;;;;;N;;;;;
10995;MEROITIC HIEROGLYPHIC LETTER SE;Lo;0;R;;;;;N;;;;;
10996;MEROITIC HIEROGLYPHIC LETTER KA;Lo;0;R;;;;;N;;;;;
10997;MEROITIC HIEROGLYPHIC LETTER QA;Lo;0;R;;;;;N;;;;;
10998;MEROITIC HIEROGLYPHIC LETTER TA;Lo;0;R;;;;;N;;;;;
10999;MEROITIC HIEROGLYPHIC LETTER TA-2;Lo;0;R;;;;;N;;;;;
1099A;MEROITIC HIEROGLYPHIC LETTER TE;Lo;0;R;;;;;N;;;;;
1099B;MEROITIC HIEROGLYPHIC LETTER TE-2;Lo;0;R;;;;;N;;;;;
1099C;MEROITIC HIEROGLYPHIC LETTER TO;Lo;0;R;;;;;N;;;;;
1099D;MEROITIC HIEROGLYPHIC LETTER DA;Lo;0;R;;;;;N;;;;;
1099E;MEROITIC HIEROGLYPHIC SYMBOL VIDJ;Lo;0;R;;;;;N;;;;;
1099F;MEROITIC HIEROGLYPHIC SYMBOL VIDJ-2;Lo;0;R;;;;;N;;;;;
109A0;MEROITIC CURSIVE LETTER A;Lo;0;R;;;;;N;;;;;
109A1;MEROITIC CURSIVE LETTER E;Lo;0;R;;;;;N;;;;;
109A2;MEROITIC CURSIVE LETTER I;Lo;0;R;;;;;N;;;;;
109A3;MEROITIC CURSIVE LETTER O;Lo;0;R;;;;;N;;;;;
109A4;MEROITIC CURSIVE LETTER YA;Lo;0;R;;;;;N;;;;;
109A5;MEROITIC CURSIVE LETTER WA;Lo;0;R;;;;;N;;;;;
109A6;MEROITIC CURSIVE LETTER BA;Lo;0;R;;;;;N;;;;;
109A7;MEROITIC CURSIVE LETTER PA;Lo;0;R;;;;;N;;;;;
109A8;MEROITIC CURSIVE LETTER MA;Lo;0;R;;;;;N;;;;;
109A9;MEROITIC CURSIVE LETTER NA;Lo;0;R;;;;;N;;;;;
109AA;MEROITIC CURSIVE LETTER NE;Lo;0;R;;;;;N;;;;;
109AB;MEROITIC CURSIVE LETTER RA;Lo;0;R;;;;;N;;;;;
109AC;MEROITIC CURSIVE LETTER LA;Lo;0;R;;;;;N;;;;;
109AD;MEROITIC CURSIVE LETTER KHA;Lo;0;R;;;;;N;;;;;
109AE;MEROITIC CURSIVE LETTER HHA;Lo;0;R;;;;;N;;;;;
109AF;MEROITIC CURSIVE LETTER SA;Lo;0;R;;;;;N;;;;;
109B0;MEROITIC CURSIVE LETTER ARCHAIC SA;Lo;0;R;;;;;N;;;;;
109B1;MEROITIC CURSIVE LETTER SE;Lo;0;R;;;;;N;;;;;
109B2;MEROITIC CURSIVE LETTER KA;Lo;0;R;;;;;N;;;;;
109B3;MEROITIC CURSIVE LETTER QA;Lo;0;R;;;;;N;;;;;
109B4;MEROITIC CURSIVE LETTER TA;Lo;0;R;;;;;N;;;;;
109B5;MEROITIC CURSIVE LETTER TE;Lo;0;R;;;;;N;;;;;
109B6;MEROITIC CURSIVE LETTER TO;Lo;0;R;;;;;N;;;;;
109B7;MEROITIC CURSIVE LETTER DA;Lo;0;R;;;;;N;;;;;
109BC;MEROITIC CURSIVE FRACTION ELEVEN TWELFTHS;No;0;R;;;;11/12;N;;;;;
109BD;MEROITIC CURSIVE FRACTION ONE HALF;No;0;R;;;;1/2;N;;;;;
109BE;MEROITIC CURSIVE LOGOGRAM RMT;Lo;0;R;;;;;N;;;;;
109BF;MEROITIC CURSIVE LOGOGRAM IMN;Lo;0;R;;;;;N;;;;;
109C0;MEROITIC CURSIVE NUMBER ONE;No;0;R;;;;1;N;;;;;
109C1;MEROITIC CURSIVE NUMBER TWO;No;0;R;;;;2;N;;;;;
109C2;MEROITIC CURSIVE NUMBER THREE;No;0;R;;;;3;N;;;;;
109C3;MEROITIC CURSIVE NUMBER FOUR;No;0;R;;;;4;N;;;;;
109C4;MEROITIC CURSIVE NUMBER FIVE;No;0;R;;;;5;N;;;;;
109C5;MEROITIC CURSIVE NUMBER SIX;No;0;R;;;;6;N;;;;;
109C6;MEROITIC CURSIVE NUMBER SEVEN;No;0;R;;;;7;N;;;;;
109C7;MEROITIC CURSIVE NUMBER EIGHT;No;0;R;;;;8;N;;;;;
109C8;MEROITIC CURSIVE NUMBER NINE;No;0;R;;;;9;N;;;;;
109C9;MEROITIC CURSIVE NUMBER TEN;No;0;R;;;;10;N;;;;;
109CA;MEROITIC CURSIVE NUMBER TWENTY;No;0;R;;;;20;N;;;;;
109CB;MEROITIC CURSIVE NUMBER THIRTY;No;0;R;;;;30;N;;;;;
109CC;MEROITIC CURSIVE NUMBER FORTY;No;0;R;;;;40;N;;;;;
109CD;MEROITIC CURSIVE NUMBER FIFTY;No;0;R;;;;50;N;;;;;
109CE;MEROITIC CURSIVE NUMBER SIXTY;No;0;R;;;;60;N;;;;;
109CF;MEROITIC CURSIVE NUMBER SEVENTY;No;0;R;;;;70;N;;;;;
109D2;MEROITIC CURSIVE NUMBER ONE HUNDRED;No;0;R;;;;100;N;;;;;
109D3;MEROITIC CURSIVE NUMBER TWO HUNDRED;No;0;R;;;;200;N;;;;;
109D4;MEROITIC CURSIVE NUMBER THREE HUNDRED;No;0;R;;;;300;N;;;;;
109D5;MEROITIC CURSIVE NUMBER FOUR HUNDRED;No;0;R;;;;400;N;;;;;
109D6;MEROITIC CURSIVE NUMBER FIVE HUNDRED;No;0;R;;;;500;N;;;;;
109D7;MEROITIC CURSIVE NUMBER SIX HUNDRED;No;0;R;;;;600;N;;;;;
109D8;MEROITIC CURSIVE NUMBER SEVEN HUNDRED;No;0;R;;;;700;N;;;;;
109D9;MEROITIC CURSIVE NUMBER EIGHT HUNDRED;No;0;R;;;;800;N;;;;;
109DA;MEROITIC CURSIVE NUMBER NINE HUNDRED;No;0;R;;;;900;N;;;;;
109DB;MEROITIC CURSIVE NUMBER ONE THOUSAND;No;0;R;;;;1000;N;;;;;
109DC;MEROITIC CURSIVE NUMBER TWO THOUSAND;No;0;R;;;;2000;N;;;;;
109DD;MEROITIC CURSIVE NUMBER THREE THOUSAND;No;0;R;;;;3000;N;;;;;
109DE;MEROITIC CURSIVE NUMBER FOUR THOUSAND;No;0;R;;;;4000;N;;;;;
109DF;MEROITIC CURSIVE NUMBER FIVE THOUSAND;No;0;R;;;;5000;N;;;;;
109E0;MEROITIC CURSIVE NUMBER SIX THOUSAND;No;0;R;;;;6000;N;;;;;
109E1;MEROITIC CURSIVE NUMBER SEVEN THOUSAND;No;0;R;;;;7000;N;;;;;
109E2;MEROITIC CURSIVE NUMBER EIGHT THOUSAND;No;0;R;;;;8000;N;;;;;
109E3;MEROITIC CURSIVE NUMBER NINE THOUSAND;No;0;R;;;;9000;N;;;;;
109E4;MEROITIC CURSIVE NUMBER TEN THOUSAND;No;0;R;;;;10000;N;;;;;
109E5;MEROITIC CURSIVE NUMBER TWENTY THOUSAND;No;0;R;;;;20000;N;;;;;
109E6;MEROITIC CURSIVE NUMBER THIRTY THOUSAND;No;0;R;;;;30000;N;;;;;
109E7;MEROITIC CURSIVE NUMBER FORTY THOUSAND;No;0;R;;;;40000;N;;;;;
109E8;MEROITIC CURSIVE NUMBER FIFTY THOUSAND;No;0;R;;;;50000;N;;;;;
109E9;MEROITIC CURSIVE NUMBER SIXTY THOUSAND;No;0;R;;;;60000;N;;;;;
109EA;MEROITIC CURSIVE NUMBER SEVENTY THOUSAND;No;0;R;;;;70000;N;;;;;
109EB;MEROITIC CURSIVE NUMBER EIGHTY THOUSAND;No;0;R;;;;80000;N;;;;;
109EC;MEROITIC CURSIVE NUMBER NINETY THOUSAND;No;0;R;;;;90000;N;;;;;
109ED;MEROITIC CURSIVE NUMBER ONE HUNDRED THOUSAND;No;0;R;;;;100000;N;;;;;
109EE;MEROITIC CURSIVE NUMBER TWO HUNDRED THOUSAND;No;0;R;;;;200000;N;;;;;
109EF;MEROITIC CURSIVE NUMBER THREE HUNDRED THOUSAND;No;0;R;;;;300000;N;;;;;
109F0;MEROITIC CURSIVE NUMBER FOUR HUNDRED THOUSAND;No;0;R;;;;400000;N;;;;;
109F1;MEROITIC CURSIVE NUMBER FIVE HUNDRED THOUSAND;No;0;R;;;;500000;N;;;;;
109F2;MEROITIC CURSIVE NUMBER SIX HUNDRED THOUSAND;No;0;R;;;;600000;N;;;;;
109F3;MEROITIC CURSIVE NUMBER SEVEN HUNDRED THOUSAND;No;0;R;;;;700000;N;;;;;
109F4;MEROITIC CURSIVE NUMBER EIGHT HUNDRED THOUSAND;No;0;R;;;;800000;N;;;;;
109F5;MEROITIC CURSIVE NUMBER NINE HUNDRED THOUSAND;No;0;R;;;;900000;N;;;;;
109F6;MEROITIC CURSIVE FRACTION ONE TWELFTH;No;0;R;;;;1/12;N;;;;;
109F7;MEROITIC CURSIVE FRACTION TWO TWELFTHS;No;0;R;;;;2/12;N;;;;;
109F8;MEROITIC CURSIVE FRACTION THREE TWELFTHS;No;0;R;;;;3/12;N;;;;;
109F9;MEROITIC CURSIVE FRACTION FOUR TWELFTHS;No;0;R;;;;4/12;N;;;;;
109FA;MEROITIC CURSIVE FRACTION FIVE TWELFTHS;No;0;R;;;;5/12;N;;;;;
109FB;MEROITIC CURSIVE FRACTION SIX TWELFTHS;No;0;R;;;;6/12;N;;;;;
109FC;MEROITIC CURSIVE FRACTION SEVEN TWELFTHS;No;0;R;;;;7/12;N;;;;;
109FD;MEROITIC CURSIVE FRACTION EIGHT TWELFTHS;No;0;R;;;;8/12;N;;;;;
109FE;MEROITIC CURSIVE FRACTION NINE TWELFTHS;No;0;R;;;;9/12;N;;;;;
109FF;MEROITIC CURSIVE FRACTION TEN TWELFTHS;No;0;R;;;;10/12;N;;;;;
10A00;KHAROSHTHI LETTER A;Lo;0;R;;;;;N;;;;;
10A01;KHAROSHTHI VOWEL SIGN I;Mn;0;NSM;;;;;N;;;;;
10A02;KHAROSHTHI VOWEL SIGN U;Mn;0;NSM;;;;;N;;;;;
10A03;KHAROSHTHI VOWEL SIGN VOCALIC R;Mn;0;NSM;;;;;N;;;;;
10A05;KHAROSHTHI VOWEL SIGN E;Mn;0;NSM;;;;;N;;;;;
10A06;KHAROSHTHI VOWEL SIGN O;Mn;0;NSM;;;;;N;;;;;
10A0C;KHAROSHTHI VOWEL LENGTH MARK;Mn;0;NSM;;;;;N;;;;;
10A0D;KHAROSHTHI SIGN DOUBLE RING BELOW;Mn;220;NSM;;;;;N;;;;;
10A0E;KHAROSHTHI SIGN ANUSVARA;Mn;0;NSM;;;;;N;;;;;
10A0F;KHAROSHTHI SIGN VISARGA;Mn;230;NSM;;;;;N;;;;;
10A10;KHAROSHTHI LETTER KA;Lo;0;R;;;;;N;;;;;
10A11;KHAROSHTHI LETTER KHA;Lo;0;R;;;;;N;;;;;
10A12;KHAROSHTHI LETTER GA;Lo;0;R;;;;;N;;;;;
10A13;KHAROSHTHI LETTER GHA;Lo;0;R;;;;;N;;;;;
10A15;KHAROSHTHI LETTER CA;Lo;0;R;;;;;N;;;;;
10A16;KHAROSHTHI LETTER CHA;Lo;0;R;;;;;N;;;;;
10A17;KHAROSHTHI LETTER JA;Lo;0;R;;;;;N;;;;;
10A19;KHAROSHTHI LETTER NYA;Lo;0;R;;;;;N;;;;;
10A1A;KHAROSHTHI LETTER TTA;Lo;0;R;;;;;N;;;;;
10A1B;KHAROSHTHI LETTER TTHA;Lo;0;R;;;;;N;;;;;
10A1C;KHAROSHTHI LETTER DDA;Lo;0;R;;;;;N;;;;;
10A1D;KHAROSHTHI LETTER DDHA;Lo;0;R;;;;;N;;;;;
10A1E;KHAROSHTHI LETTER NNA;Lo;0;R;;;;;N;;;;;
10A1F;KHAROSHTHI LETTER TA;Lo;0;R;;;;;N;;;;;
10A20;KHAROSHTHI LETTER THA;Lo;0;R;;;;;N;;;;;
10A21;KHAROSHTHI LETTER DA;Lo;0;R;;;;;N;;;;;
10A22;KHAROSHTHI LETTER DHA;Lo;0;R;;;;;N;;;;;
10A23;KHAROSHTHI LETTER NA;Lo;0;R;;;;;N;;;;;
10A24;KHAROSHTHI LETTER PA;Lo;0;R;;;;;N;;;;;
10A25;KHAROSHTHI LETTER PHA;Lo;0;R;;;;;N;;;;;
10A26;KHAROSHTHI LETTER BA;Lo;0;R;;;;;N;;;;;
10A27;KHAROSHTHI LETTER BHA;Lo;0;R;;;;;N;;;;;
10A28;KHAROSHTHI LETTER MA;Lo;0;R;;;;;N;;;;;
10A29;KHAROSHTHI LETTER YA;Lo;0;R;;;;;N;;;;;
10A2A;KHAROSHTHI LETTER RA;Lo;0;R;;;;;N;;;;;
10A2B;KHAROSHTHI LETTER LA;Lo;0;R;;;;;N;;;;;
10A2C;KHAROSHTHI LETTER VA;Lo;0;R;;;;;N;;;;;
10A2D;KHAROSHTHI LETTER SHA;Lo;0;R;;;;;N;;;;;
10A2E;KHAROSHTHI LETTER SSA;Lo;0;R;;;;;N;;;;;
10A2F;KHAROSHTHI LETTER SA;Lo;0;R;;;;;N;;;;;
10A30;KHAROSHTHI LETTER ZA;Lo;0;R;;;;;N;;;;;
10A31;KHAROSHTHI LETTER HA;Lo;0;R;;;;;N;;;;;
10A32;KHAROSHTHI LETTER KKA;Lo;0;R;;;;;N;;;;;
10A33;KHAROSHTHI LETTER TTTHA;Lo;0;R;;;;;N;;;;;
10A34;KHAROSHTHI LETTER TTTA;Lo;0;R;;;;;N;;;;;
10A35;KHAROSHTHI LETTER VHA;Lo;0;R;;;;;N;;;;;
10A38;KHAROSHTHI SIGN BAR ABOVE;Mn;230;NSM;;;;;N;;;;;
10A39;KHAROSHTHI SIGN CAUDA;Mn;1;NSM;;;;;N;;;;;
10A3A;KHAROSHTHI SIGN DOT BELOW;Mn;220;NSM;;;;;N;;;;;
10A3F;KHAROSHTHI VIRAMA;Mn;9;NSM;;;;;N;;;;;
10A40;KHAROSHTHI DIGIT ONE;No;0;R;;;1;1;N;;;;;
10A41;KHAROSHTHI DIGIT TWO;No;0;R;;;2;2;N;;;;;
10A42;KHAROSHTHI DIGIT THREE;No;0;R;;;3;3;N;;;;;
10A43;KHAROSHTHI DIGIT FOUR;No;0;R;;;4;4;N;;;;;
10A44;KHAROSHTHI NUMBER TEN;No;0;R;;;;10;N;;;;;
10A45;KHAROSHTHI NUMBER TWENTY;No;0;R;;;;20;N;;;;;
10A46;KHAROSHTHI NUMBER ONE HUNDRED;No;0;R;;;;100;N;;;;;
10A47;KHAROSHTHI NUMBER ONE THOUSAND;No;0;R;;;;1000;N;;;;;
10A48;KHAROSHTHI FRACTION ONE HALF;No;0;R;;;;1/2;N;;;;;
10A50;KHAROSHTHI PUNCTUATION DOT;Po;0;R;;;;;N;;;;;
10A51;KHAROSHTHI PUNCTUATION SMALL CIRCLE;Po;0;R;;;;;N;;;;;
10A52;KHAROSHTHI PUNCTUATION CIRCLE;Po;0;R;;;;;N;;;;;
10A53;KHAROSHTHI PUNCTUATION CRESCENT BAR;Po;0;R;;;;;N;;;;;
10A54;KHAROSHTHI PUNCTUATION MANGALAM;Po;0;R;;;;;N;;;;;
10A55;KHAROSHTHI PUNCTUATION LOTUS;Po;0;R;;;;;N;;;;;
10A56;KHAROSHTHI PUNCTUATION DANDA;Po;0;R;;;;;N;;;;;
10A57;KHAROSHTHI PUNCTUATION DOUBLE DANDA;Po;0;R;;;;;N;;;;;
10A58;KHAROSHTHI PUNCTUATION LINES;Po;0;R;;;;;N;;;;;
10A60;OLD SOUTH ARABIAN LETTER HE;Lo;0;R;;;;;N;;;;;
10A61;OLD SOUTH ARABIAN LETTER LAMEDH;Lo;0;R;;;;;N;;;;;
10A62;OLD SOUTH ARABIAN LETTER HETH;Lo;0;R;;;;;N;;;;;
10A63;OLD SOUTH ARABIAN LETTER MEM;Lo;0;R;;;;;N;;;;;
10A64;OLD SOUTH ARABIAN LETTER QOPH;Lo;0;R;;;;;N;;;;;
10A65;OLD SOUTH ARABIAN LETTER WAW;Lo;0;R;;;;;N;;;;;
10A66;OLD SOUTH ARABIAN LETTER SHIN;Lo;0;R;;;;;N;;;;;
10A67;OLD SOUTH ARABIAN LETTER RESH;Lo;0;R;;;;;N;;;;;
10A68;OLD SOUTH ARABIAN LETTER BETH;Lo;0;R;;;;;N;;;;;
10A69;OLD SOUTH ARABIAN LETTER TAW;Lo;0;R;;;;;N;;;;;
10A6A;OLD SOUTH ARABIAN LETTER SAT;Lo;0;R;;;;;N;;;;;
10A6B;OLD SOUTH ARABIAN LETTER KAPH;Lo;0;R;;;;;N;;;;;
10A6C;OLD SOUTH ARABIAN LETTER NUN;Lo;0;R;;;;;N;;;;;
10A6D;OLD SOUTH ARABIAN LETTER KHETH;Lo;0;R;;;;;N;;;;;
10A6E;OLD SOUTH ARABIAN LETTER SADHE;Lo;0;R;;;;;N;;;;;
10A6F;OLD SOUTH ARABIAN LETTER SAMEKH;Lo;0;R;;;;;N;;;;;
10A70;OLD SOUTH ARABIAN LETTER FE;Lo;0;R;;;;;N;;;;;
10A71;OLD SOUTH ARABIAN LETTER ALEF;Lo;0;R;;;;;N;;;;;
10A72;OLD SOUTH ARABIAN LETTER AYN;Lo;0;R;;;;;N;;;;;
10A73;OLD SOUTH ARABIAN LETTER DHADHE;Lo;0;R;;;;;N;;;;;
10A74;OLD SOUTH ARABIAN LETTER GIMEL;Lo;0;R;;;;;N;;;;;
10A75;OLD SOUTH ARABIAN LETTER DALETH;Lo;0;R;;;;;N;;;;;
10A76;OLD SOUTH ARABIAN LETTER GHAYN;Lo;0;R;;;;;N;;;;;
10A77;OLD SOUTH ARABIAN LETTER TETH;Lo;0;R;;;;;N;;;;;
10A78;OLD SOUTH ARABIAN LETTER ZAYN;Lo;0;R;;;;;N;;;;;
10A79;OLD SOUTH ARABIAN LETTER DHALETH;Lo;0;R;;;;;N;;;;;
10A7A;OLD SOUTH ARABIAN LETTER YODH;Lo;0;R;;;;;N;;;;;
10A7B;OLD SOUTH ARABIAN LETTER THAW;Lo;0;R;;;;;N;;;;;
10A7C;OLD SOUTH ARABIAN LETTER THETH;Lo;0;R;;;;;N;;;;;
10A7D;OLD SOUTH ARABIAN NUMBER ONE;No;0;R;;;;1;N;;;;;
10A7E;OLD SOUTH ARABIAN NUMBER FIFTY;No;0;R;;;;50;N;;;;;
10A7F;OLD SOUTH ARABIAN NUMERIC INDICATOR;Po;0;R;;;;;N;;;;;
10A80;OLD NORTH ARABIAN LETTER HEH;Lo;0;R;;;;;N;;;;;
10A81;OLD NORTH ARABIAN LETTER LAM;Lo;0;R;;;;;N;;;;;
10A82;OLD NORTH ARABIAN LETTER HAH;Lo;0;R;;;;;N;;;;;
10A83;OLD NORTH ARABIAN LETTER MEEM;Lo;0;R;;;;;N;;;;;
10A84;OLD NORTH ARABIAN LETTER QAF;Lo;0;R;;;;;N;;;;;
10A85;OLD NORTH ARABIAN LETTER WAW;Lo;0;R;;;;;N;;;;;
10A86;OLD NORTH ARABIAN LETTER ES-2;Lo;0;R;;;;;N;;;;;
10A87;OLD NORTH ARABIAN LETTER REH;Lo;0;R;;;;;N;;;;;
10A88;OLD NORTH ARABIAN LETTER BEH;Lo;0;R;;;;;N;;;;;
10A89;OLD NORTH ARABIAN LETTER TEH;Lo;0;R;;;;;N;;;;;
10A8A;OLD NORTH ARABIAN LETTER ES-1;Lo;0;R;;;;;N;;;;;
10A8B;OLD NORTH ARABIAN LETTER KAF;Lo;0;R;;;;;N;;;;;
10A8C;OLD NORTH ARABIAN LETTER NOON;Lo;0;R;;;;;N;;;;;
10A8D;OLD NORTH ARABIAN LETTER KHAH;Lo;0;R;;;;;N;;;;;
10A8E;OLD NORTH ARABIAN LETTER SAD;Lo;0;R;;;;;N;;;;;
10A8F;OLD NORTH ARABIAN LETTER ES-3;Lo;0;R;;;;;N;;;;;
10A90;OLD NORTH ARABIAN LETTER FEH;Lo;0;R;;;;;N;;;;;
10A91;OLD NORTH ARABIAN LETTER ALEF;Lo;0;R;;;;;N;;;;;
10A92;OLD NORTH ARABIAN LETTER AIN;Lo;0;R;;;;;N;;;;;
10A93;OLD NORTH ARABIAN LETTER DAD;Lo;0;R;;;;;N;;;;;
10A94;OLD NORTH ARABIAN LETTER GEEM;Lo;0;R;;;;;N;;;;;
10A95;OLD NORTH ARABIAN LETTER DAL;Lo;0;R;;;;;N;;;;;
10A96;OLD NORTH ARABIAN LETTER GHAIN;Lo;0;R;;;;;N;;;;;
10A97;OLD NORTH ARABIAN LETTER TAH;Lo;0;R;;;;;N;;;;;
10A98;OLD NORTH ARABIAN LETTER ZAIN;Lo;0;R;;;;;N;;;;;
10A99;OLD NORTH ARABIAN LETTER THAL;Lo;0;R;;;;;N;;;;;
10A9A;OLD NORTH ARABIAN LETTER YEH;Lo;0;R;;;;;N;;;;;
10A9B;OLD NORTH ARABIAN LETTER THEH;Lo;0;R;;;;;N;;;;;
10A9C;OLD NORTH ARABIAN LETTER ZAH;Lo;0;R;;;;;N;;;;;
10A9D;OLD NORTH ARABIAN NUMBER ONE;No;0;R;;;;1;N;;;;;
10A9E;OLD NORTH ARABIAN NUMBER TEN;No;0;R;;;;10;N;;;;;
10A9F;OLD NORTH ARABIAN NUMBER TWENTY;No;0;R;;;;20;N;;;;;
10AC0;MANICHAEAN LETTER ALEPH;Lo;0;R;;;;;N;;;;;
10AC1;MANICHAEAN LETTER BETH;Lo;0;R;;;;;N;;;;;
10AC2;MANICHAEAN LETTER BHETH;Lo;0;R;;;;;N;;;;;
10AC3;MANICHAEAN LETTER GIMEL;Lo;0;R;;;;;N;;;;;
10AC4;MANICHAEAN LETTER GHIMEL;Lo;0;R;;;;;N;;;;;
10AC5;MANICHAEAN LETTER DALETH;Lo;0;R;;;;;N;;;;;
10AC6;MANICHAEAN LETTER HE;Lo;0;R;;;;;N;;;;;
10AC7;MANICHAEAN LETTER WAW;Lo;0;R;;;;;N;;;;;
10AC8;MANICHAEAN SIGN UD;So;0;R;;;;;N;;;;;
10AC9;MANICHAEAN LETTER ZAYIN;Lo;0;R;;;;;N;;;;;
10ACA;MANICHAEAN LETTER ZHAYIN;Lo;0;R;;;;;N;;;;;
10ACB;MANICHAEAN LETTER JAYIN;Lo;0;R;;;;;N;;;;;
10ACC;MANICHAEAN LETTER JHAYIN;Lo;0;R;;;;;N;;;;;
10ACD;MANICHAEAN LETTER HETH;Lo;0;R;;;;;N;;;;;
10ACE;MANICHAEAN LETTER TETH;Lo;0;R;;;;;N;;;;;
10ACF;MANICHAEAN LETTER YODH;Lo;0;R;;;;;N;;;;;
10AD0;MANICHAEAN LETTER KAPH;Lo;0;R;;;;;N;;;;;
10AD1;MANICHAEAN LETTER XAPH;Lo;0;R;;;;;N;;;;;
10AD2;MANICHAEAN LETTER KHAPH;Lo;0;R;;;;;N;;;;;
10AD3;MANICHAEAN LETTER LAMEDH;Lo;0;R;;;;;N;;;;;
10AD4;MANICHAEAN LETTER DHAMEDH;Lo;0;R;;;;;N;;;;;
10AD5;MANICHAEAN LETTER THAMEDH;Lo;0;R;;;;;N;;;;;
10AD6;MANICHAEAN LETTER MEM;Lo;0;R;;;;;N;;;;;
10AD7;MANICHAEAN LETTER NUN;Lo;0;R;;;;;N;;;;;
10AD8;MANICHAEAN LETTER SAMEKH;Lo;0;R;;;;;N;;;;;
10AD9;MANICHAEAN LETTER AYIN;Lo;0;R;;;;;N;;;;;
10ADA;MANICHAEAN LETTER AAYIN;Lo;0;R;;;;;N;;;;;
10ADB;MANICHAEAN LETTER PE;Lo;0;R;;;;;N;;;;;
10ADC;MANICHAEAN LETTER FE;Lo;0;R;;;;;N;;;;;
10ADD;MANICHAEAN LETTER SADHE;Lo;0;R;;;;;N;;;;;
10ADE;MANICHAEAN LETTER QOPH;Lo;0;R;;;;;N;;;;;
10ADF;MANICHAEAN LETTER XOPH;Lo;0;R;;;;;N;;;;;
10AE0;MANICHAEAN LETTER QHOPH;Lo;0;R;;;;;N;;;;;
10AE1;MANICHAEAN LETTER RESH;Lo;0;R;;;;;N;;;;;
10AE2;MANICHAEAN LETTER SHIN;Lo;0;R;;;;;N;;;;;
10AE3;MANICHAEAN LETTER SSHIN;Lo;0;R;;;;;N;;;;;
10AE4;MANICHAEAN LETTER TAW;Lo;0;R;;;;;N;;;;;
10AE5;MANICHAEAN ABBREVIATION MARK ABOVE;Mn;230;NSM;;;;;N;;;;;
10AE6;MANICHAEAN ABBREVIATION MARK BELOW;Mn;220;NSM;;;;;N;;;;;
10AEB;MANICHAEAN NUMBER ONE;No;0;R;;;;1;N;;;;;
10AEC;MANICHAEAN NUMBER FIVE;No;0;R;;;;5;N;;;;;
10AED;MANICHAEAN NUMBER TEN;No;0;R;;;;10;N;;;;;
10AEE;MANICHAEAN NUMBER TWENTY;No;0;R;;;;20;N;;;;;
10AEF;MANICHAEAN NUMBER ONE HUNDRED;No;0;R;;;;100;N;;;;;
10AF0;MANICHAEAN PUNCTUATION STAR;Po;0;R;;;;;N;;;;;
10AF1;MANICHAEAN PUNCTUATION FLEURON;Po;0;R;;;;;N;;;;;
10AF2;MANICHAEAN PUNCTUATION DOUBLE DOT WITHIN DOT;Po;0;R;;;;;N;;;;;
10AF3;MANICHAEAN PUNCTUATION DOT WITHIN DOT;Po;0;R;;;;;N;;;;;
10AF4;MANICHAEAN PUNCTUATION DOT;Po;0;R;;;;;N;;;;;
10AF5;MANICHAEAN PUNCTUATION TWO DOTS;Po;0;R;;;;;N;;;;;
10AF6;MANICHAEAN PUNCTUATION LINE FILLER;Po;0;R;;;;;N;;;;;
10B00;AVESTAN LETTER A;Lo;0;R;;;;;N;;;;;
10B01;AVESTAN LETTER AA;Lo;0;R;;;;;N;;;;;
10B02;AVESTAN LETTER AO;Lo;0;R;;;;;N;;;;;
10B03;AVESTAN LETTER AAO;Lo;0;R;;;;;N;;;;;
10B04;AVESTAN LETTER AN;Lo;0;R;;;;;N;;;;;
10B05;AVESTAN LETTER AAN;Lo;0;R;;;;;N;;;;;
10B06;AVESTAN LETTER AE;Lo;0;R;;;;;N;;;;;
10B07;AVESTAN LETTER AEE;Lo;0;R;;;;;N;;;;;
10B08;AVESTAN LETTER E;Lo;0;R;;;;;N;;;;;
10B09;AVESTAN LETTER EE;Lo;0;R;;;;;N;;;;;
10B0A;AVESTAN LETTER O;Lo;0;R;;;;;N;;;;;
10B0B;AVESTAN LETTER OO;Lo;0;R;;;;;N;;;;;
10B0C;AVESTAN LETTER I;Lo;0;R;;;;;N;;;;;
10B0D;AVESTAN LETTER II;Lo;0;R;;;;;N;;;;;
10B0E;AVESTAN LETTER U;Lo;0;R;;;;;N;;;;;
10B0F;AVESTAN LETTER UU;Lo;0;R;;;;;N;;;;;
10B10;AVESTAN LETTER KE;Lo;0;R;;;;;N;;;;;
10B11;AVESTAN LETTER XE;Lo;0;R;;;;;N;;;;;
10B12;AVESTAN LETTER XYE;Lo;0;R;;;;;N;;;;;
10B13;AVESTAN LETTER XVE;Lo;0;R;;;;;N;;;;;
10B14;AVESTAN LETTER GE;Lo;0;R;;;;;N;;;;;
10B15;AVESTAN LETTER GGE;Lo;0;R;;;;;N;;;;;
10B16;AVESTAN LETTER GHE;Lo;0;R;;;;;N;;;;;
10B17;AVESTAN LETTER CE;Lo;0;R;;;;;N;;;;;
10B18;AVESTAN LETTER JE;Lo;0;R;;;;;N;;;;;
10B19;AVESTAN LETTER TE;Lo;0;R;;;;;N;;;;;
10B1A;AVESTAN LETTER THE;Lo;0;R;;;;;N;;;;;
10B1B;AVESTAN LETTER DE;Lo;0;R;;;;;N;;;;;
10B1C;AVESTAN LETTER DHE;Lo;0;R;;;;;N;;;;;
10B1D;AVESTAN LETTER TTE;Lo;0;R;;;;;N;;;;;
10B1E;AVESTAN LETTER PE;Lo;0;R;;;;;N;;;;;
10B1F;AVESTAN LETTER FE;Lo;0;R;;;;;N;;;;;
10B20;AVESTAN LETTER BE;Lo;0;R;;;;;N;;;;;
10B21;AVESTAN LETTER BHE;Lo;0;R;;;;;N;;;;;
10B22;AVESTAN LETTER NGE;Lo;0;R;;;;;N;;;;;
10B23;AVESTAN LETTER NGYE;Lo;0;R;;;;;N;;;;;
10B24;AVESTAN LETTER NGVE;Lo;0;R;;;;;N;;;;;
10B25;AVESTAN LETTER NE;Lo;0;R;;;;;N;;;;;
10B26;AVESTAN LETTER NYE;Lo;0;R;;;;;N;;;;;
10B27;AVESTAN LETTER NNE;Lo;0;R;;;;;N;;;;;
10B28;AVESTAN LETTER ME;Lo;0;R;;;;;N;;;;;
10B29;AVESTAN LETTER HME;Lo;0;R;;;;;N;;;;;
10B2A;AVESTAN LETTER YYE;Lo;0;R;;;;;N;;;;;
10B2B;AVESTAN LETTER YE;Lo;0;R;;;;;N;;;;;
10B2C;AVESTAN LETTER VE;Lo;0;R;;;;;N;;;;;
10B2D;AVESTAN LETTER RE;Lo;0;R;;;;;N;;;;;
10B2E;AVESTAN LETTER LE;Lo;0;R;;;;;N;;;;;
10B2F;AVESTAN LETTER SE;Lo;0;R;;;;;N;;;;;
10B30;AVESTAN LETTER ZE;Lo;0;R;;;;;N;;;;;
10B31;AVESTAN LETTER SHE;Lo;0;R;;;;;N;;;;;
10B32;AVESTAN LETTER ZHE;Lo;0;R;;;;;N;;;;;
10B33;AVESTAN LETTER SHYE;Lo;0;R;;;;;N;;;;;
10B34;AVESTAN LETTER SSHE;Lo;0;R;;;;;N;;;;;
10B35;AVESTAN LETTER HE;Lo;0;R;;;;;N;;;;;
10B39;AVESTAN ABBREVIATION MARK;Po;0;ON;;;;;N;;;;;
10B3A;TINY TWO DOTS OVER ONE DOT PUNCTUATION;Po;0;ON;;;;;N;;;;;
10B3B;SMALL TWO DOTS OVER ONE DOT PUNCTUATION;Po;0;ON;;;;;N;;;;;
10B3C;LARGE TWO DOTS OVER ONE DOT PUNCTUATION;Po;0;ON;;;;;N;;;;;
10B3D;LARGE ONE DOT OVER TWO DOTS PUNCTUATION;Po;0;ON;;;;;N;;;;;
10B3E;LARGE TWO RINGS OVER ONE RING PUNCTUATION;Po;0;ON;;;;;N;;;;;
10B3F;LARGE ONE RING OVER TWO RINGS PUNCTUATION;Po;0;ON;;;;;N;;;;;
10B40;INSCRIPTIONAL PARTHIAN LETTER ALEPH;Lo;0;R;;;;;N;;;;;
10B41;INSCRIPTIONAL PARTHIAN LETTER BETH;Lo;0;R;;;;;N;;;;;
10B42;INSCRIPTIONAL PARTHIAN LETTER GIMEL;Lo;0;R;;;;;N;;;;;
10B43;INSCRIPTIONAL PARTHIAN LETTER DALETH;Lo;0;R;;;;;N;;;;;
10B44;INSCRIPTIONAL PARTHIAN LETTER HE;Lo;0;R;;;;;N;;;;;
10B45;INSCRIPTIONAL PARTHIAN LETTER WAW;Lo;0;R;;;;;N;;;;;
10B46;INSCRIPTIONAL PARTHIAN LETTER ZAYIN;Lo;0;R;;;;;N;;;;;
10B47;INSCRIPTIONAL PARTHIAN LETTER HETH;Lo;0;R;;;;;N;;;;;
10B48;INSCRIPTIONAL PARTHIAN LETTER TETH;Lo;0;R;;;;;N;;;;;
10B49;INSCRIPTIONAL PARTHIAN LETTER YODH;Lo;0;R;;;;;N;;;;;
10B4A;INSCRIPTIONAL PARTHIAN LETTER KAPH;Lo;0;R;;;;;N;;;;;
10B4B;INSCRIPTIONAL PARTHIAN LETTER LAMEDH;Lo;0;R;;;;;N;;;;;
10B4C;INSCRIPTIONAL PARTHIAN LETTER MEM;Lo;0;R;;;;;N;;;;;
10B4D;INSCRIPTIONAL PARTHIAN LETTER NUN;Lo;0;R;;;;;N;;;;;
10B4E;INSCRIPTIONAL PARTHIAN LETTER SAMEKH;Lo;0;R;;;;;N;;;;;
10B4F;INSCRIPTIONAL PARTHIAN LETTER AYIN;Lo;0;R;;;;;N;;;;;
10B50;INSCRIPTIONAL PARTHIAN LETTER PE;Lo;0;R;;;;;N;;;;;
10B51;INSCRIPTIONAL PARTHIAN LETTER SADHE;Lo;0;R;;;;;N;;;;;
10B52;INSCRIPTIONAL PARTHIAN LETTER QOPH;Lo;0;R;;;;;N;;;;;
10B53;INSCRIPTIONAL PARTHIAN LETTER RESH;Lo;0;R;;;;;N;;;;;
10B54;INSCRIPTIONAL PARTHIAN LETTER SHIN;Lo;0;R;;;;;N;;;;;
10B55;INSCRIPTIONAL PARTHIAN LETTER TAW;Lo;0;R;;;;;N;;;;;
10B58;INSCRIPTIONAL PARTHIAN NUMBER ONE;No;0;R;;;;1;N;;;;;
10B59;INSCRIPTIONAL PARTHIAN NUMBER TWO;No;0;R;;;;2;N;;;;;
10B5A;INSCRIPTIONAL PARTHIAN NUMBER THREE;No;0;R;;;;3;N;;;;;
10B5B;INSCRIPTIONAL PARTHIAN NUMBER FOUR;No;0;R;;;;4;N;;;;;
10B5C;INSCRIPTIONAL PARTHIAN NUMBER TEN;No;0;R;;;;10;N;;;;;
10B5D;INSCRIPTIONAL PARTHIAN NUMBER TWENTY;No;0;R;;;;20;N;;;;;
10B5E;INSCRIPTIONAL PARTHIAN NUMBER ONE HUNDRED;No;0;R;;;;100;N;;;;;
10B5F;INSCRIPTIONAL PARTHIAN NUMBER ONE THOUSAND;No;0;R;;;;1000;N;;;;;
10B60;INSCRIPTIONAL PAHLAVI LETTER ALEPH;Lo;0;R;;;;;N;;;;;
10B61;INSCRIPTIONAL PAHLAVI LETTER BETH;Lo;0;R;;;;;N;;;;;
10B62;INSCRIPTIONAL PAHLAVI LETTER GIMEL;Lo;0;R;;;;;N;;;;;
10B63;INSCRIPTIONAL PAHLAVI LETTER DALETH;Lo;0;R;;;;;N;;;;;
10B64;INSCRIPTIONAL PAHLAVI LETTER HE;Lo;0;R;;;;;N;;;;;
10B65;INSCRIPTIONAL PAHLAVI LETTER WAW-AYIN-RESH;Lo;0;R;;;;;N;;;;;
10B66;INSCRIPTIONAL PAHLAVI LETTER ZAYIN;Lo;0;R;;;;;N;;;;;
10B67;INSCRIPTIONAL PAHLAVI LETTER HETH;Lo;0;R;;;;;N;;;;;
10B68;INSCRIPTIONAL PAHLAVI LETTER TETH;Lo;0;R;;;;;N;;;;;
10B69;INSCRIPTIONAL PAHLAVI LETTER YODH;Lo;0;R;;;;;N;;;;;
10B6A;INSCRIPTIONAL PAHLAVI LETTER KAPH;Lo;0;R;;;;;N;;;;;
10B6B;INSCRIPTIONAL PAHLAVI LETTER LAMEDH;Lo;0;R;;;;;N;;;;;
10B6C;INSCRIPTIONAL PAHLAVI LETTER MEM-QOPH;Lo;0;R;;;;;N;;;;;
10B6D;INSCRIPTIONAL PAHLAVI LETTER NUN;Lo;0;R;;;;;N;;;;;
10B6E;INSCRIPTIONAL PAHLAVI LETTER SAMEKH;Lo;0;R;;;;;N;;;;;
10B6F;INSCRIPTIONAL PAHLAVI LETTER PE;Lo;0;R;;;;;N;;;;;
10B70;INSCRIPTIONAL PAHLAVI LETTER SADHE;Lo;0;R;;;;;N;;;;;
10B71;INSCRIPTIONAL PAHLAVI LETTER SHIN;Lo;0;R;;;;;N;;;;;
10B72;INSCRIPTIONAL PAHLAVI LETTER TAW;Lo;0;R;;;;;N;;;;;
10B78;INSCRIPTIONAL PAHLAVI NUMBER ONE;No;0;R;;;;1;N;;;;;
10B79;INSCRIPTIONAL PAHLAVI NUMBER TWO;No;0;R;;;;2;N;;;;;
10B7A;INSCRIPTIONAL PAHLAVI NUMBER THREE;No;0;R;;;;3;N;;;;;
10B7B;INSCRIPTIONAL PAHLAVI NUMBER FOUR;No;0;R;;;;4;N;;;;;
10B7C;INSCRIPTIONAL PAHLAVI NUMBER TEN;No;0;R;;;;10;N;;;;;
10B7D;INSCRIPTIONAL PAHLAVI NUMBER TWENTY;No;0;R;;;;20;N;;;;;
10B7E;INSCRIPTIONAL PAHLAVI NUMBER ONE HUNDRED;No;0;R;;;;100;N;;;;;
10B7F;INSCRIPTIONAL PAHLAVI NUMBER ONE THOUSAND;No;0;R;;;;1000;N;;;;;
10B80;PSALTER PAHLAVI LETTER ALEPH;Lo;0;R;;;;;N;;;;;
10B81;PSALTER PAHLAVI LETTER BETH;Lo;0;R;;;;;N;;;;;
10B82;PSALTER PAHLAVI LETTER GIMEL;Lo;0;R;;;;;N;;;;;
10B83;PSALTER PAHLAVI LETTER DALETH;Lo;0;R;;;;;N;;;;;
10B84;PSALTER PAHLAVI LETTER HE;Lo;0;R;;;;;N;;;;;
10B85;PSALTER PAHLAVI LETTER WAW-AYIN-RESH;Lo;0;R;;;;;N;;;;;
10B86;PSALTER PAHLAVI LETTER ZAYIN;Lo;0;R;;;;;N;;;;;
10B87;PSALTER PAHLAVI LETTER HETH;Lo;0;R;;;;;N;;;;;
10B88;PSALTER PAHLAVI LETTER YODH;Lo;0;R;;;;;N;;;;;
10B89;PSALTER PAHLAVI LETTER KAPH;Lo;0;R;;;;;N;;;;;
10B8A;PSALTER PAHLAVI LETTER LAMEDH;Lo;0;R;;;;;N;;;;;
10B8B;PSALTER PAHLAVI LETTER MEM-QOPH;Lo;0;R;;;;;N;;;;;
10B8C;PSALTER PAHLAVI LETTER NUN;Lo;0;R;;;;;N;;;;;
10B8D;PSALTER PAHLAVI LETTER SAMEKH;Lo;0;R;;;;;N;;;;;
10B8E;PSALTER PAHLAVI LETTER PE;Lo;0;R;;;;;N;;;;;
10B8F;PSALTER PAHLAVI LETTER SADHE;Lo;0;R;;;;;N;;;;;
10B90;PSALTER PAHLAVI LETTER SHIN;Lo;0;R;;;;;N;;;;;
10B91;PSALTER PAHLAVI LETTER TAW;Lo;0;R;;;;;N;;;;;
10B99;PSALTER PAHLAVI SECTION MARK;Po;0;R;;;;;N;;;;;
10B9A;PSALTER PAHLAVI TURNED SECTION MARK;Po;0;R;;;;;N;;;;;
10B9B;PSALTER PAHLAVI FOUR DOTS WITH CROSS;Po;0;R;;;;;N;;;;;
10B9C;PSALTER PAHLAVI FOUR DOTS WITH DOT;Po;0;R;;;;;N;;;;;
10BA9;PSALTER PAHLAVI NUMBER ONE;No;0;R;;;;1;N;;;;;
10BAA;PSALTER PAHLAVI NUMBER TWO;No;0;R;;;;2;N;;;;;
10BAB;PSALTER PAHLAVI NUMBER THREE;No;0;R;;;;3;N;;;;;
10BAC;PSALTER PAHLAVI NUMBER FOUR;No;0;R;;;;4;N;;;;;
10BAD;PSALTER PAHLAVI NUMBER TEN;No;0;R;;;;10;N;;;;;
10BAE;PSALTER PAHLAVI NUMBER TWENTY;No;0;R;;;;20;N;;;;;
10BAF;PSALTER PAHLAVI NUMBER ONE HUNDRED;No;0;R;;;;100;N;;;;;
10C00;OLD TURKIC LETTER ORKHON A;Lo;0;R;;;;;N;;;;;
10C01;OLD TURKIC LETTER YENISEI A;Lo;0;R;;;;;N;;;;;
10C02;OLD TURKIC LETTER YENISEI AE;Lo;0;R;;;;;N;;;;;
10C03;OLD TURKIC LETTER ORKHON I;Lo;0;R;;;;;N;;;;;
10C04;OLD TURKIC LETTER YENISEI I;Lo;0;R;;;;;N;;;;;
10C05;OLD TURKIC LETTER YENISEI E;Lo;0;R;;;;;N;;;;;
10C06;OLD TURKIC LETTER ORKHON O;Lo;0;R;;;;;N;;;;;
10C07;OLD TURKIC LETTER ORKHON OE;Lo;0;R;;;;;N;;;;;
10C08;OLD TURKIC LETTER YENISEI OE;Lo;0;R;;;;;N;;;;;
10C09;OLD TURKIC LETTER ORKHON AB;Lo;0;R;;;;;N;;;;;
10C0A;OLD TURKIC LETTER YENISEI AB;Lo;0;R;;;;;N;;;;;
10C0B;OLD TURKIC LETTER ORKHON AEB;Lo;0;R;;;;;N;;;;;
10C0C;OLD TURKIC LETTER YENISEI AEB;Lo;0;R;;;;;N;;;;;
10C0D;OLD TURKIC LETTER ORKHON AG;Lo;0;R;;;;;N;;;;;
10C0E;OLD TURKIC LETTER YENISEI AG;Lo;0;R;;;;;N;;;;;
10C0F;OLD TURKIC LETTER ORKHON AEG;Lo;0;R;;;;;N;;;;;
10C10;OLD TURKIC LETTER YENISEI AEG;Lo;0;R;;;;;N;;;;;
10C11;OLD TURKIC LETTER ORKHON AD;Lo;0;R;;;;;N;;;;;
10C12;OLD TURKIC LETTER YENISEI AD;Lo;0;R;;;;;N;;;;;
10C13;OLD TURKIC LETTER ORKHON AED;Lo;0;R;;;;;N;;;;;
10C14;OLD TURKIC LETTER ORKHON EZ;Lo;0;R;;;;;N;;;;;
10C15;OLD TURKIC LETTER YENISEI EZ;Lo;0;R;;;;;N;;;;;
10C16;OLD TURKIC LETTER ORKHON AY;Lo;0;R;;;;;N;;;;;
10C17;OLD TURKIC LETTER YENISEI AY;Lo;0;R;;;;;N;;;;;
10C18;OLD TURKIC LETTER ORKHON AEY;Lo;0;R;;;;;N;;;;;
10C19;OLD TURKIC LETTER YENISEI AEY;Lo;0;R;;;;;N;;;;;
10C1A;OLD TURKIC LETTER ORKHON AEK;Lo;0;R;;;;;N;;;;;
10C1B;OLD TURKIC LETTER YENISEI AEK;Lo;0;R;;;;;N;;;;;
10C1C;OLD TURKIC LETTER ORKHON OEK;Lo;0;R;;;;;N;;;;;
10C1D;OLD TURKIC LETTER YENISEI OEK;Lo;0;R;;;;;N;;;;;
10C1E;OLD TURKIC LETTER ORKHON AL;Lo;0;R;;;;;N;;;;;
10C1F;OLD TURKIC LETTER YENISEI AL;Lo;0;R;;;;;N;;;;;
10C20;OLD TURKIC LETTER ORKHON AEL;Lo;0;R;;;;;N;;;;;
10C21;OLD TURKIC LETTER ORKHON ELT;Lo;0;R;;;;;N;;;;;
10C22;OLD TURKIC LETTER ORKHON EM;Lo;0;R;;;;;N;;;;;
10C23;OLD TURKIC LETTER ORKHON AN;Lo;0;R;;;;;N;;;;;
10C24;OLD TURKIC LETTER ORKHON AEN;Lo;0;R;;;;;N;;;;;
10C25;OLD TURKIC LETTER YENISEI AEN;Lo;0;R;;;;;N;;;;;
10C26;OLD TURKIC LETTER ORKHON ENT;Lo;0;R;;;;;N;;;;;
10C27;OLD TURKIC LETTER YENISEI ENT;Lo;0;R;;;;;N;;;;;
10C28;OLD TURKIC LETTER ORKHON ENC;Lo;0;R;;;;;N;;;;;
10C29;OLD TURKIC LETTER YENISEI ENC;Lo;0;R;;;;;N;;;;;
10C2A;OLD TURKIC LETTER ORKHON ENY;Lo;0;R;;;;;N;;;;;
10C2B;OLD TURKIC LETTER YENISEI ENY;Lo;0;R;;;;;N;;;;;
10C2C;OLD TURKIC LETTER YENISEI ANG;Lo;0;R;;;;;N;;;;;
10C2D;OLD TURKIC LETTER ORKHON ENG;Lo;0;R;;;;;N;;;;;
10C2E;OLD TURKIC LETTER YENISEI AENG;Lo;0;R;;;;;N;;;;;
10C2F;OLD TURKIC LETTER ORKHON EP;Lo;0;R;;;;;N;;;;;
10C30;OLD TURKIC LETTER ORKHON OP;Lo;0;R;;;;;N;;;;;
10C31;OLD TURKIC LETTER ORKHON IC;Lo;0;R;;;;;N;;;;;
10C32;OLD TURKIC LETTER ORKHON EC;Lo;0;R;;;;;N;;;;;
10C33;OLD TURKIC LETTER YENISEI EC;Lo;0;R;;;;;N;;;;;
10C34;OLD TURKIC LETTER ORKHON AQ;Lo;0;R;;;;;N;;;;;
10C35;OLD TURKIC LETTER YENISEI AQ;Lo;0;R;;;;;N;;;;;
10C36;OLD TURKIC LETTER ORKHON IQ;Lo;0;R;;;;;N;;;;;
10C37;OLD TURKIC LETTER YENISEI IQ;Lo;0;R;;;;;N;;;;;
10C38;OLD TURKIC LETTER ORKHON OQ;Lo;0;R;;;;;N;;;;;
10C39;OLD TURKIC LETTER YENISEI OQ;Lo;0;R;;;;;N;;;;;
10C3A;OLD TURKIC LETTER ORKHON AR;Lo;0;R;;;;;N;;;;;
10C3B;OLD TURKIC LETTER YENISEI AR;Lo;0;R;;;;;N;;;;;
10C3C;OLD TURKIC LETTER ORKHON AER;Lo;0;R;;;;;N;;;;;
10C3D;OLD TURKIC LETTER ORKHON AS;Lo;0;R;;;;;N;;;;;
10C3E;OLD TURKIC LETTER ORKHON AES;Lo;0;R;;;;;N;;;;;
10C3F;OLD TURKIC LETTER ORKHON ASH;Lo;0;R;;;;;N;;;;;
10C40;OLD TURKIC LETTER YENISEI ASH;Lo;0;R;;;;;N;;;;;
10C41;OLD TURKIC LETTER ORKHON ESH;Lo;0;R;;;;;N;;;;;
10C42;OLD TURKIC LETTER YENISEI ESH;Lo;0;R;;;;;N;;;;;
10C43;OLD TURKIC LETTER ORKHON AT;Lo;0;R;;;;;N;;;;;
10C44;OLD TURKIC LETTER YENISEI AT;Lo;0;R;;;;;N;;;;;
10C45;OLD TURKIC LETTER ORKHON AET;Lo;0;R;;;;;N;;;;;
10C46;OLD TURKIC LETTER YENISEI AET;Lo;0;R;;;;;N;;;;;
10C47;OLD TURKIC LETTER ORKHON OT;Lo;0;R;;;;;N;;;;;
10C48;OLD TURKIC LETTER ORKHON BASH;Lo;0;R;;;;;N;;;;;
10C80;OLD HUNGARIAN CAPITAL LETTER A;Lu;0;R;;;;;N;;;;10CC0;
10C81;OLD HUNGARIAN CAPITAL LETTER AA;Lu;0;R;;;;;N;;;;10CC1;
10C82;OLD HUNGARIAN CAPITAL LETTER EB;Lu;0;R;;;;;N;;;;10CC2;
10C83;OLD HUNGARIAN CAPITAL LETTER AMB;Lu;0;R;;;;;N;;;;10CC3;
10C84;OLD HUNGARIAN CAPITAL LETTER EC;Lu;0;R;;;;;N;;;;10CC4;
10C85;OLD HUNGARIAN CAPITAL LETTER ENC;Lu;0;R;;;;;N;;;;10CC5;
10C86;OLD HUNGARIAN CAPITAL LETTER ECS;Lu;0;R;;;;;N;;;;10CC6;
10C87;OLD HUNGARIAN CAPITAL LETTER ED;Lu;0;R;;;;;N;;;;10CC7;
10C88;OLD HUNGARIAN CAPITAL LETTER AND;Lu;0;R;;;;;N;;;;10CC8;
10C89;OLD HUNGARIAN CAPITAL LETTER E;Lu;0;R;;;;;N;;;;10CC9;
10C8A;OLD HUNGARIAN CAPITAL LETTER CLOSE E;Lu;0;R;;;;;N;;;;10CCA;
10C8B;OLD HUNGARIAN CAPITAL LETTER EE;Lu;0;R;;;;;N;;;;10CCB;
10C8C;OLD HUNGARIAN CAPITAL LETTER EF;Lu;0;R;;;;;N;;;;10CCC;
10C8D;OLD HUNGARIAN CAPITAL LETTER EG;Lu;0;R;;;;;N;;;;10CCD;
10C8E;OLD HUNGARIAN CAPITAL LETTER EGY;Lu;0;R;;;;;N;;;;10CCE;
10C8F;OLD HUNGARIAN CAPITAL LETTER EH;Lu;0;R;;;;;N;;;;10CCF;
10C90;OLD HUNGARIAN CAPITAL LETTER I;Lu;0;R;;;;;N;;;;10CD0;
10C91;OLD HUNGARIAN CAPITAL LETTER II;Lu;0;R;;;;;N;;;;10CD1;
10C92;OLD HUNGARIAN CAPITAL LETTER EJ;Lu;0;R;;;;;N;;;;10CD2;
10C93;OLD HUNGARIAN CAPITAL LETTER EK;Lu;0;R;;;;;N;;;;10CD3;
10C94;OLD HUNGARIAN CAPITAL LETTER AK;Lu;0;R;;;;;N;;;;10CD4;
10C95;OLD HUNGARIAN CAPITAL LETTER UNK;Lu;0;R;;;;;N;;;;10CD5;
10C96;OLD HUNGARIAN CAPITAL LETTER EL;Lu;0;R;;;;;N;;;;10CD6;
10C97;OLD HUNGARIAN CAPITAL LETTER ELY;Lu;0;R;;;;;N;;;;10CD7;
10C98;OLD HUNGARIAN CAPITAL LETTER EM;Lu;0;R;;;;;N;;;;10CD8;
10C99;OLD HUNGARIAN CAPITAL LETTER EN;Lu;0;R;;;;;N;;;;10CD9;
10C9A;OLD HUNGARIAN CAPITAL LETTER ENY;Lu;0;R;;;;;N;;;;10CDA;
10C9B;OLD HUNGARIAN CAPITAL LETTER O;Lu;0;R;;;;;N;;;;10CDB;
10C9C;OLD HUNGARIAN CAPITAL LETTER OO;Lu;0;R;;;;;N;;;;10CDC;
10C9D;OLD HUNGARIAN CAPITAL LETTER NIKOLSBURG OE;Lu;0;R;;;;;N;;;;10CDD;
10C9E;OLD HUNGARIAN CAPITAL LETTER RUDIMENTA OE;Lu;0;R;;;;;N;;;;10CDE;
10C9F;OLD HUNGARIAN CAPITAL LETTER OEE;Lu;0;R;;;;;N;;;;10CDF;
10CA0;OLD HUNGARIAN CAPITAL LETTER EP;Lu;0;R;;;;;N;;;;10CE0;
10CA1;OLD HUNGARIAN CAPITAL LETTER EMP;Lu;0;R;;;;;N;;;;10CE1;
10CA2;OLD HUNGARIAN CAPITAL LETTER ER;Lu;0;R;;;;;N;;;;10CE2;
10CA3;OLD HUNGARIAN CAPITAL LETTER SHORT ER;Lu;0;R;;;;;N;;;;10CE3;
10CA4;OLD HUNGARIAN CAPITAL LETTER ES;Lu;0;R;;;;;N;;;;10CE4;
10CA5;OLD HUNGARIAN CAPITAL LETTER ESZ;Lu;0;R;;;;;N;;;;10CE5;
10CA6;OLD HUNGARIAN CAPITAL LETTER ET;Lu;0;R;;;;;N;;;;10CE6;
10CA7;OLD HUNGARIAN CAPITAL LETTER ENT;Lu;0;R;;;;;N;;;;10CE7;
10CA8;OLD HUNGARIAN CAPITAL LETTER ETY;Lu;0;R;;;;;N;;;;10CE8;
10CA9;OLD HUNGARIAN CAPITAL LETTER ECH;Lu;0;R;;;;;N;;;;10CE9;
10CAA;OLD HUNGARIAN CAPITAL LETTER U;Lu;0;R;;;;;N;;;;10CEA;
10CAB;OLD HUNGARIAN CAPITAL LETTER UU;Lu;0;R;;;;;N;;;;10CEB;
10CAC;OLD HUNGARIAN CAPITAL LETTER NIKOLSBURG UE;Lu;0;R;;;;;N;;;;10CEC;
10CAD;OLD HUNGARIAN CAPITAL LETTER RUDIMENTA UE;Lu;0;R;;;;;N;;;;10CED;
10CAE;OLD HUNGARIAN CAPITAL LETTER EV;Lu;0;R;;;;;N;;;;10CEE;
10CAF;OLD HUNGARIAN CAPITAL LETTER EZ;Lu;0;R;;;;;N;;;;10CEF;
10CB0;OLD HUNGARIAN CAPITAL LETTER EZS;Lu;0;R;;;;;N;;;;10CF0;
10CB1;OLD HUNGARIAN CAPITAL LETTER ENT-SHAPED SIGN;Lu;0;R;;;;;N;;;;10CF1;
10CB2;OLD HUNGARIAN CAPITAL LETTER US;Lu;0;R;;;;;N;;;;10CF2;
10CC0;OLD HUNGARIAN SMALL LETTER A;Ll;0;R;;;;;N;;;10C80;;10C80
10CC1;OLD HUNGARIAN SMALL LETTER AA;Ll;0;R;;;;;N;;;10C81;;10C81
10CC2;OLD HUNGARIAN SMALL LETTER EB;Ll;0;R;;;;;N;;;10C82;;10C82
10CC3;OLD HUNGARIAN SMALL LETTER AMB;Ll;0;R;;;;;N;;;10C83;;10C83
10CC4;OLD HUNGARIAN SMALL LETTER EC;Ll;0;R;;;;;N;;;10C84;;10C84
10CC5;OLD HUNGARIAN SMALL LETTER ENC;Ll;0;R;;;;;N;;;10C85;;10C85
10CC6;OLD HUNGARIAN SMALL LETTER ECS;Ll;0;R;;;;;N;;;10C86;;10C86
10CC7;OLD HUNGARIAN SMALL LETTER ED;Ll;0;R;;;;;N;;;10C87;;10C87
10CC8;OLD HUNGARIAN SMALL LETTER AND;Ll;0;R;;;;;N;;;10C88;;10C88
10CC9;OLD HUNGARIAN SMALL LETTER E;Ll;0;R;;;;;N;;;10C89;;10C89
10CCA;OLD HUNGARIAN SMALL LETTER CLOSE E;Ll;0;R;;;;;N;;;10C8A;;10C8A
10CCB;OLD HUNGARIAN SMALL LETTER EE;Ll;0;R;;;;;N;;;10C8B;;10C8B
10CCC;OLD HUNGARIAN SMALL LETTER EF;Ll;0;R;;;;;N;;;10C8C;;10C8C
10CCD;OLD HUNGARIAN SMALL LETTER EG;Ll;0;R;;;;;N;;;10C8D;;10C8D
10CCE;OLD HUNGARIAN SMALL LETTER EGY;Ll;0;R;;;;;N;;;10C8E;;10C8E
10CCF;OLD HUNGARIAN SMALL LETTER EH;Ll;0;R;;;;;N;;;10C8F;;10C8F
10CD0;OLD HUNGARIAN SMALL LETTER I;Ll;0;R;;;;;N;;;10C90;;10C90
10CD1;OLD HUNGARIAN SMALL LETTER II;Ll;0;R;;;;;N;;;10C91;;10C91
10CD2;OLD HUNGARIAN SMALL LETTER EJ;Ll;0;R;;;;;N;;;10C92;;10C92
10CD3;OLD HUNGARIAN SMALL LETTER EK;Ll;0;R;;;;;N;;;10C93;;10C93
10CD4;OLD HUNGARIAN SMALL LETTER AK;Ll;0;R;;;;;N;;;10C94;;10C94
10CD5;OLD HUNGARIAN SMALL LETTER UNK;Ll;0;R;;;;;N;;;10C95;;10C95
10CD6;OLD HUNGARIAN SMALL LETTER EL;Ll;0;R;;;;;N;;;10C96;;10C96
10CD7;OLD HUNGARIAN SMALL LETTER ELY;Ll;0;R;;;;;N;;;10C97;;10C97
10CD8;OLD HUNGARIAN SMALL LETTER EM;Ll;0;R;;;;;N;;;10C98;;10C98
10CD9;OLD HUNGARIAN SMALL LETTER EN;Ll;0;R;;;;;N;;;10C99;;10C99
10CDA;OLD HUNGARIAN SMALL LETTER ENY;Ll;0;R;;;;;N;;;10C9A;;10C9A
10CDB;OLD HUNGARIAN SMALL LETTER O;Ll;0;R;;;;;N;;;10C9B;;10C9B
10CDC;OLD HUNGARIAN SMALL LETTER OO;Ll;0;R;;;;;N;;;10C9C;;10C9C
10CDD;OLD HUNGARIAN SMALL LETTER NIKOLSBURG OE;Ll;0;R;;;;;N;;;10C9D;;10C9D
10CDE;OLD HUNGARIAN SMALL LETTER RUDIMENTA OE;Ll;0;R;;;;;N;;;10C9E;;10C9E
10CDF;OLD HUNGARIAN SMALL LETTER OEE;Ll;0;R;;;;;N;;;10C9F;;10C9F
10CE0;OLD HUNGARIAN SMALL LETTER EP;Ll;0;R;;;;;N;;;10CA0;;10CA0
10CE1;OLD HUNGARIAN SMALL LETTER EMP;Ll;0;R;;;;;N;;;10CA1;;10CA1
10CE2;OLD HUNGARIAN SMALL LETTER ER;Ll;0;R;;;;;N;;;10CA2;;10CA2
10CE3;OLD HUNGARIAN SMALL LETTER SHORT ER;Ll;0;R;;;;;N;;;10CA3;;10CA3
10CE4;OLD HUNGARIAN SMALL LETTER ES;Ll;0;R;;;;;N;;;10CA4;;10CA4
10CE5;OLD HUNGARIAN SMALL LETTER ESZ;Ll;0;R;;;;;N;;;10CA5;;10CA5
10CE6;OLD HUNGARIAN SMALL LETTER ET;Ll;0;R;;;;;N;;;10CA6;;10CA6
10CE7;OLD HUNGARIAN SMALL LETTER ENT;Ll;0;R;;;;;N;;;10CA7;;10CA7
10CE8;OLD HUNGARIAN SMALL LETTER ETY;Ll;0;R;;;;;N;;;10CA8;;10CA8
10CE9;OLD HUNGARIAN SMALL LETTER ECH;Ll;0;R;;;;;N;;;10CA9;;10CA9
10CEA;OLD HUNGARIAN SMALL LETTER U;Ll;0;R;;;;;N;;;10CAA;;10CAA
10CEB;OLD HUNGARIAN SMALL LETTER UU;Ll;0;R;;;;;N;;;10CAB;;10CAB
10CEC;OLD HUNGARIAN SMALL LETTER NIKOLSBURG UE;Ll;0;R;;;;;N;;;10CAC;;10CAC
10CED;OLD HUNGARIAN SMALL LETTER RUDIMENTA UE;Ll;0;R;;;;;N;;;10CAD;;10CAD
10CEE;OLD HUNGARIAN SMALL LETTER EV;Ll;0;R;;;;;N;;;10CAE;;10CAE
10CEF;OLD HUNGARIAN SMALL LETTER EZ;Ll;0;R;;;;;N;;;10CAF;;10CAF
10CF0;OLD HUNGARIAN SMALL LETTER EZS;Ll;0;R;;;;;N;;;10CB0;;10CB0
10CF1;OLD HUNGARIAN SMALL LETTER ENT-SHAPED SIGN;Ll;0;R;;;;;N;;;10CB1;;10CB1
10CF2;OLD HUNGARIAN SMALL LETTER US;Ll;0;R;;;;;N;;;10CB2;;10CB2
10CFA;OLD HUNGARIAN NUMBER ONE;No;0;R;;;;1;N;;;;;
10CFB;OLD HUNGARIAN NUMBER FIVE;No;0;R;;;;5;N;;;;;
10CFC;OLD HUNGARIAN NUMBER TEN;No;0;R;;;;10;N;;;;;
10CFD;OLD HUNGARIAN NUMBER FIFTY;No;0;R;;;;50;N;;;;;
10CFE;OLD HUNGARIAN NUMBER ONE HUNDRED;No;0;R;;;;100;N;;;;;
10CFF;OLD HUNGARIAN NUMBER ONE THOUSAND;No;0;R;;;;1000;N;;;;;
10D00;HANIFI ROHINGYA LETTER A;Lo;0;AL;;;;;N;;;;;
10D01;HANIFI ROHINGYA LETTER BA;Lo;0;AL;;;;;N;;;;;
10D02;HANIFI ROHINGYA LETTER PA;Lo;0;AL;;;;;N;;;;;
10D03;HANIFI ROHINGYA LETTER TA;Lo;0;AL;;;;;N;;;;;
10D04;HANIFI ROHINGYA LETTER TTA;Lo;0;AL;;;;;N;;;;;
10D05;HANIFI ROHINGYA LETTER JA;Lo;0;AL;;;;;N;;;;;
10D06;HANIFI ROHINGYA LETTER CA;Lo;0;AL;;;;;N;;;;;
10D07;HANIFI ROHINGYA LETTER HA;Lo;0;AL;;;;;N;;;;;
10D08;HANIFI ROHINGYA LETTER KHA;Lo;0;AL;;;;;N;;;;;
10D09;HANIFI ROHINGYA LETTER FA;Lo;0;AL;;;;;N;;;;;
10D0A;HANIFI ROHINGYA LETTER DA;Lo;0;AL;;;;;N;;;;;
10D0B;HANIFI ROHINGYA LETTER DDA;Lo;0;AL;;;;;N;;;;;
10D0C;HANIFI ROHINGYA LETTER RA;Lo;0;AL;;;;;N;;;;;
10D0D;HANIFI ROHINGYA LETTER RRA;Lo;0;AL;;;;;N;;;;;
10D0E;HANIFI ROHINGYA LETTER ZA;Lo;0;AL;;;;;N;;;;;
10D0F;HANIFI ROHINGYA LETTER SA;Lo;0;AL;;;;;N;;;;;
10D10;HANIFI ROHINGYA LETTER SHA;Lo;0;AL;;;;;N;;;;;
10D11;HANIFI ROHINGYA LETTER KA;Lo;0;AL;;;;;N;;;;;
10D12;HANIFI ROHINGYA LETTER GA;Lo;0;AL;;;;;N;;;;;
10D13;HANIFI ROHINGYA LETTER LA;Lo;0;AL;;;;;N;;;;;
10D14;HANIFI ROHINGYA LETTER MA;Lo;0;AL;;;;;N;;;;;
10D15;HANIFI ROHINGYA LETTER NA;Lo;0;AL;;;;;N;;;;;
10D16;HANIFI ROHINGYA LETTER WA;Lo;0;AL;;;;;N;;;;;
10D17;HANIFI ROHINGYA LETTER KINNA WA;Lo;0;AL;;;;;N;;;;;
10D18;HANIFI ROHINGYA LETTER YA;Lo;0;AL;;;;;N;;;;;
10D19;HANIFI ROHINGYA LETTER KINNA YA;Lo;0;AL;;;;;N;;;;;
10D1A;HANIFI ROHINGYA LETTER NGA;Lo;0;AL;;;;;N;;;;;
10D1B;HANIFI ROHINGYA LETTER NYA;Lo;0;AL;;;;;N;;;;;
10D1C;HANIFI ROHINGYA LETTER VA;Lo;0;AL;;;;;N;;;;;
10D1D;HANIFI ROHINGYA VOWEL A;Lo;0;AL;;;;;N;;;;;
10D1E;HANIFI ROHINGYA VOWEL I;Lo;0;AL;;;;;N;;;;;
10D1F;HANIFI ROHINGYA VOWEL U;Lo;0;AL;;;;;N;;;;;
10D20;HANIFI ROHINGYA VOWEL E;Lo;0;AL;;;;;N;;;;;
10D21;HANIFI ROHINGYA VOWEL O;Lo;0;AL;;;;;N;;;;;
10D22;HANIFI ROHINGYA MARK SAKIN;Lo;0;AL;;;;;N;;;;;
10D23;HANIFI ROHINGYA MARK NA KHONNA;Lo;0;AL;;;;;N;;;;;
10D24;HANIFI ROHINGYA SIGN HARBAHAY;Mn;230;NSM;;;;;N;;;;;
10D25;HANIFI ROHINGYA SIGN TAHALA;Mn;230;NSM;;;;;N;;;;;
10D26;HANIFI ROHINGYA SIGN TANA;Mn;230;NSM;;;;;N;;;;;
10D27;HANIFI ROHINGYA SIGN TASSI;Mn;230;NSM;;;;;N;;;;;
10D30;HANIFI ROHINGYA DIGIT ZERO;Nd;0;AN;;0;0;0;N;;;;;
10D31;HANIFI ROHINGYA DIGIT ONE;Nd;0;AN;;1;1;1;N;;;;;
10D32;HANIFI ROHINGYA DIGIT TWO;Nd;0;AN;;2;2;2;N;;;;;
10D33;HANIFI ROHINGYA DIGIT THREE;Nd;0;AN;;3;3;3;N;;;;;
10D34;HANIFI ROHINGYA DIGIT FOUR;Nd;0;AN;;4;4;4;N;;;;;
10D35;HANIFI ROHINGYA DIGIT FIVE;Nd;0;AN;;5;5;5;N;;;;;
10D36;HANIFI ROHINGYA DIGIT SIX;Nd;0;AN;;6;6;6;N;;;;;
10D37;HANIFI ROHINGYA DIGIT SEVEN;Nd;0;AN;;7;7;7;N;;;;;
10D38;HANIFI ROHINGYA DIGIT EIGHT;Nd;0;AN;;8;8;8;N;;;;;
10D39;HANIFI ROHINGYA DIGIT NINE;Nd;0;AN;;9;9;9;N;;;;;
10E60;RUMI DIGIT ONE;No;0;AN;;;1;1;N;;;;;
10E61;RUMI DIGIT TWO;No;0;AN;;;2;2;N;;;;;
10E62;RUMI DIGIT THREE;No;0;AN;;;3;3;N;;;;;
10E63;RUMI DIGIT FOUR;No;0;AN;;;4;4;N;;;;;
10E64;RUMI DIGIT FIVE;No;0;AN;;;5;5;N;;;;;
10E65;RUMI DIGIT SIX;No;0;AN;;;6;6;N;;;;;
10E66;RUMI DIGIT SEVEN;No;0;AN;;;7;7;N;;;;;
10E67;RUMI DIGIT EIGHT;No;0;AN;;;8;8;N;;;;;
10E68;RUMI DIGIT NINE;No;0;AN;;;9;9;N;;;;;
10E69;RUMI NUMBER TEN;No;0;AN;;;;10;N;;;;;
10E6A;RUMI NUMBER TWENTY;No;0;AN;;;;20;N;;;;;
10E6B;RUMI NUMBER THIRTY;No;0;AN;;;;30;N;;;;;
10E6C;RUMI NUMBER FORTY;No;0;AN;;;;40;N;;;;;
10E6D;RUMI NUMBER FIFTY;No;0;AN;;;;50;N;;;;;
10E6E;RUMI NUMBER SIXTY;No;0;AN;;;;60;N;;;;;
10E6F;RUMI NUMBER SEVENTY;No;0;AN;;;;70;N;;;;;
10E70;RUMI NUMBER EIGHTY;No;0;AN;;;;80;N;;;;;
10E71;RUMI NUMBER NINETY;No;0;AN;;;;90;N;;;;;
10E72;RUMI NUMBER ONE HUNDRED;No;0;AN;;;;100;N;;;;;
10E73;RUMI NUMBER TWO HUNDRED;No;0;AN;;;;200;N;;;;;
10E74;RUMI NUMBER THREE HUNDRED;No;0;AN;;;;300;N;;;;;
10E75;RUMI NUMBER FOUR HUNDRED;No;0;AN;;;;400;N;;;;;
10E76;RUMI NUMBER FIVE HUNDRED;No;0;AN;;;;500;N;;;;;
10E77;RUMI NUMBER SIX HUNDRED;No;0;AN;;;;600;N;;;;;
10E78;RUMI NUMBER SEVEN HUNDRED;No;0;AN;;;;700;N;;;;;
10E79;RUMI NUMBER EIGHT HUNDRED;No;0;AN;;;;800;N;;;;;
10E7A;RUMI NUMBER NINE HUNDRED;No;0;AN;;;;900;N;;;;;
10E7B;RUMI FRACTION ONE HALF;No;0;AN;;;;1/2;N;;;;;
10E7C;RUMI FRACTION ONE QUARTER;No;0;AN;;;;1/4;N;;;;;
10E7D;RUMI FRACTION ONE THIRD;No;0;AN;;;;1/3;N;;;;;
10E7E;RUMI FRACTION TWO THIRDS;No;0;AN;;;;2/3;N;;;;;
10E80;YEZIDI LETTER ELIF;Lo;0;R;;;;;N;;;;;
10E81;YEZIDI LETTER BE;Lo;0;R;;;;;N;;;;;
10E82;YEZIDI LETTER PE;Lo;0;R;;;;;N;;;;;
10E83;YEZIDI LETTER PHE;Lo;0;R;;;;;N;;;;;
10E84;YEZIDI LETTER THE;Lo;0;R;;;;;N;;;;;
10E85;YEZIDI LETTER SE;Lo;0;R;;;;;N;;;;;
10E86;YEZIDI LETTER CIM;Lo;0;R;;;;;N;;;;;
10E87;YEZIDI LETTER CHIM;Lo;0;R;;;;;N;;;;;
10E88;YEZIDI LETTER CHHIM;Lo;0;R;;;;;N;;;;;
10E89;YEZIDI LETTER HHA;Lo;0;R;;;;;N;;;;;
10E8A;YEZIDI LETTER XA;Lo;0;R;;;;;N;;;;;
10E8B;YEZIDI LETTER DAL;Lo;0;R;;;;;N;;;;;
10E8C;YEZIDI LETTER ZAL;Lo;0;R;;;;;N;;;;;
10E8D;YEZIDI LETTER RA;Lo;0;R;;;;;N;;;;;
10E8E;YEZIDI LETTER RHA;Lo;0;R;;;;;N;;;;;
10E8F;YEZIDI LETTER ZA;Lo;0;R;;;;;N;;;;;
10E90;YEZIDI LETTER JA;Lo;0;R;;;;;N;;;;;
10E91;YEZIDI LETTER SIN;Lo;0;R;;;;;N;;;;;
10E92;YEZIDI LETTER SHIN;Lo;0;R;;;;;N;;;;;
10E93;YEZIDI LETTER SAD;Lo;0;R;;;;;N;;;;;
10E94;YEZIDI LETTER DAD;Lo;0;R;;;;;N;;;;;
10E95;YEZIDI LETTER TA;Lo;0;R;;;;;N;;;;;
10E96;YEZIDI LETTER ZE;Lo;0;R;;;;;N;;;;;
10E97;YEZIDI LETTER EYN;Lo;0;R;;;;;N;;;;;
10E98;YEZIDI LETTER XHEYN;Lo;0;R;;;;;N;;;;;
10E99;YEZIDI LETTER FA;Lo;0;R;;;;;N;;;;;
10E9A;YEZIDI LETTER VA;Lo;0;R;;;;;N;;;;;
10E9B;YEZIDI LETTER VA ALTERNATE FORM;Lo;0;R;;;;;N;;;;;
10E9C;YEZIDI LETTER QAF;Lo;0;R;;;;;N;;;;;
10E9D;YEZIDI LETTER KAF;Lo;0;R;;;;;N;;;;;
10E9E;YEZIDI LETTER KHAF;Lo;0;R;;;;;N;;;;;
10E9F;YEZIDI LETTER GAF;Lo;0;R;;;;;N;;;;;
10EA0;YEZIDI LETTER LAM;Lo;0;R;;;;;N;;;;;
10EA1;YEZIDI LETTER MIM;Lo;0;R;;;;;N;;;;;
10EA2;YEZIDI LETTER NUN;Lo;0;R;;;;;N;;;;;
10EA3;YEZIDI LETTER UM;Lo;0;R;;;;;N;;;;;
10EA4;YEZIDI LETTER WAW;Lo;0;R;;;;;N;;;;;
10EA5;YEZIDI LETTER OW;Lo;0;R;;;;;N;;;;;
10EA6;YEZIDI LETTER EW;Lo;0;R;;;;;N;;;;;
10EA7;YEZIDI LETTER HAY;Lo;0;R;;;;;N;;;;;
10EA8;YEZIDI LETTER YOT;Lo;0;R;;;;;N;;;;;
10EA9;YEZIDI LETTER ET;Lo;0;R;;;;;N;;;;;
10EAB;YEZIDI COMBINING HAMZA MARK;Mn;230;NSM;;;;;N;;;;;
10EAC;YEZIDI COMBINING MADDA MARK;Mn;230;NSM;;;;;N;;;;;
10EAD;YEZIDI HYPHENATION MARK;Pd;0;R;;;;;N;;;;;
10EB0;YEZIDI LETTER LAM WITH DOT ABOVE;Lo;0;R;;;;;N;;;;;
10EB1;YEZIDI LETTER YOT WITH CIRCUMFLEX ABOVE;Lo;0;R;;;;;N;;;;;
10F00;OLD SOGDIAN LETTER ALEPH;Lo;0;R;;;;;N;;;;;
10F01;OLD SOGDIAN LETTER FINAL ALEPH;Lo;0;R;;;;;N;;;;;
10F02;OLD SOGDIAN LETTER BETH;Lo;0;R;;;;;N;;;;;
10F03;OLD SOGDIAN LETTER FINAL BETH;Lo;0;R;;;;;N;;;;;
10F04;OLD SOGDIAN LETTER GIMEL;Lo;0;R;;;;;N;;;;;
10F05;OLD SOGDIAN LETTER HE;Lo;0;R;;;;;N;;;;;
10F06;OLD SOGDIAN LETTER FINAL HE;Lo;0;R;;;;;N;;;;;
10F07;OLD SOGDIAN LETTER WAW;Lo;0;R;;;;;N;;;;;
10F08;OLD SOGDIAN LETTER ZAYIN;Lo;0;R;;;;;N;;;;;
10F09;OLD SOGDIAN LETTER HETH;Lo;0;R;;;;;N;;;;;
10F0A;OLD SOGDIAN LETTER YODH;Lo;0;R;;;;;N;;;;;
10F0B;OLD SOGDIAN LETTER KAPH;Lo;0;R;;;;;N;;;;;
10F0C;OLD SOGDIAN LETTER LAMEDH;Lo;0;R;;;;;N;;;;;
10F0D;OLD SOGDIAN LETTER MEM;Lo;0;R;;;;;N;;;;;
10F0E;OLD SOGDIAN LETTER NUN;Lo;0;R;;;;;N;;;;;
10F0F;OLD SOGDIAN LETTER FINAL NUN;Lo;0;R;;;;;N;;;;;
10F10;OLD SOGDIAN LETTER FINAL NUN WITH VERTICAL TAIL;Lo;0;R;;;;;N;;;;;
10F11;OLD SOGDIAN LETTER SAMEKH;Lo;0;R;;;;;N;;;;;
10F12;OLD SOGDIAN LETTER AYIN;Lo;0;R;;;;;N;;;;;
10F13;OLD SOGDIAN LETTER ALTERNATE AYIN;Lo;0;R;;;;;N;;;;;
10F14;OLD SOGDIAN LETTER PE;Lo;0;R;;;;;N;;;;;
10F15;OLD SOGDIAN LETTER SADHE;Lo;0;R;;;;;N;;;;;
10F16;OLD SOGDIAN LETTER FINAL SADHE;Lo;0;R;;;;;N;;;;;
10F17;OLD SOGDIAN LETTER FINAL SADHE WITH VERTICAL TAIL;Lo;0;R;;;;;N;;;;;
10F18;OLD SOGDIAN LETTER RESH-AYIN-DALETH;Lo;0;R;;;;;N;;;;;
10F19;OLD SOGDIAN LETTER SHIN;Lo;0;R;;;;;N;;;;;
10F1A;OLD SOGDIAN LETTER TAW;Lo;0;R;;;;;N;;;;;
10F1B;OLD SOGDIAN LETTER FINAL TAW;Lo;0;R;;;;;N;;;;;
10F1C;OLD SOGDIAN LETTER FINAL TAW WITH VERTICAL TAIL;Lo;0;R;;;;;N;;;;;
10F1D;OLD SOGDIAN NUMBER ONE;No;0;R;;;;1;N;;;;;
10F1E;OLD SOGDIAN NUMBER TWO;No;0;R;;;;2;N;;;;;
10F1F;OLD SOGDIAN NUMBER THREE;No;0;R;;;;3;N;;;;;
10F20;OLD SOGDIAN NUMBER FOUR;No;0;R;;;;4;N;;;;;
10F21;OLD SOGDIAN NUMBER FIVE;No;0;R;;;;5;N;;;;;
10F22;OLD SOGDIAN NUMBER TEN;No;0;R;;;;10;N;;;;;
10F23;OLD SOGDIAN NUMBER TWENTY;No;0;R;;;;20;N;;;;;
10F24;OLD SOGDIAN NUMBER THIRTY;No;0;R;;;;30;N;;;;;
10F25;OLD SOGDIAN NUMBER ONE HUNDRED;No;0;R;;;;100;N;;;;;
10F26;OLD SOGDIAN FRACTION ONE HALF;No;0;R;;;;1/2;N;;;;;
10F27;OLD SOGDIAN LIGATURE AYIN-DALETH;Lo;0;R;;;;;N;;;;;
10F30;SOGDIAN LETTER ALEPH;Lo;0;AL;;;;;N;;;;;
10F31;SOGDIAN LETTER BETH;Lo;0;AL;;;;;N;;;;;
10F32;SOGDIAN LETTER GIMEL;Lo;0;AL;;;;;N;;;;;
10F33;SOGDIAN LETTER HE;Lo;0;AL;;;;;N;;;;;
10F34;SOGDIAN LETTER WAW;Lo;0;AL;;;;;N;;;;;
10F35;SOGDIAN LETTER ZAYIN;Lo;0;AL;;;;;N;;;;;
10F36;SOGDIAN LETTER HETH;Lo;0;AL;;;;;N;;;;;
10F37;SOGDIAN LETTER YODH;Lo;0;AL;;;;;N;;;;;
10F38;SOGDIAN LETTER KAPH;Lo;0;AL;;;;;N;;;;;
10F39;SOGDIAN LETTER LAMEDH;Lo;0;AL;;;;;N;;;;;
10F3A;SOGDIAN LETTER MEM;Lo;0;AL;;;;;N;;;;;
10F3B;SOGDIAN LETTER NUN;Lo;0;AL;;;;;N;;;;;
10F3C;SOGDIAN LETTER SAMEKH;Lo;0;AL;;;;;N;;;;;
10F3D;SOGDIAN LETTER AYIN;Lo;0;AL;;;;;N;;;;;
10F3E;SOGDIAN LETTER PE;Lo;0;AL;;;;;N;;;;;
10F3F;SOGDIAN LETTER SADHE;Lo;0;AL;;;;;N;;;;;
10F40;SOGDIAN LETTER RESH-AYIN;Lo;0;AL;;;;;N;;;;;
10F41;SOGDIAN LETTER SHIN;Lo;0;AL;;;;;N;;;;;
10F42;SOGDIAN LETTER TAW;Lo;0;AL;;;;;N;;;;;
10F43;SOGDIAN LETTER FETH;Lo;0;AL;;;;;N;;;;;
10F44;SOGDIAN LETTER LESH;Lo;0;AL;;;;;N;;;;;
10F45;SOGDIAN INDEPENDENT SHIN;Lo;0;AL;;;;;N;;;;;
10F46;SOGDIAN COMBINING DOT BELOW;Mn;220;NSM;;;;;N;;;;;
10F47;SOGDIAN COMBINING TWO DOTS BELOW;Mn;220;NSM;;;;;N;;;;;
10F48;SOGDIAN COMBINING DOT ABOVE;Mn;230;NSM;;;;;N;;;;;
10F49;SOGDIAN COMBINING TWO DOTS ABOVE;Mn;230;NSM;;;;;N;;;;;
10F4A;SOGDIAN COMBINING CURVE ABOVE;Mn;230;NSM;;;;;N;;;;;
10F4B;SOGDIAN COMBINING CURVE BELOW;Mn;220;NSM;;;;;N;;;;;
10F4C;SOGDIAN COMBINING HOOK ABOVE;Mn;230;NSM;;;;;N;;;;;
10F4D;SOGDIAN COMBINING HOOK BELOW;Mn;220;NSM;;;;;N;;;;;
10F4E;SOGDIAN COMBINING LONG HOOK BELOW;Mn;220;NSM;;;;;N;;;;;
10F4F;SOGDIAN COMBINING RESH BELOW;Mn;220;NSM;;;;;N;;;;;
10F50;SOGDIAN COMBINING STROKE BELOW;Mn;220;NSM;;;;;N;;;;;
10F51;SOGDIAN NUMBER ONE;No;0;AL;;;;1;N;;;;;
10F52;SOGDIAN NUMBER TEN;No;0;AL;;;;10;N;;;;;
10F53;SOGDIAN NUMBER TWENTY;No;0;AL;;;;20;N;;;;;
10F54;SOGDIAN NUMBER ONE HUNDRED;No;0;AL;;;;100;N;;;;;
10F55;SOGDIAN PUNCTUATION TWO VERTICAL BARS;Po;0;AL;;;;;N;;;;;
10F56;SOGDIAN PUNCTUATION TWO VERTICAL BARS WITH DOTS;Po;0;AL;;;;;N;;;;;
10F57;SOGDIAN PUNCTUATION CIRCLE WITH DOT;Po;0;AL;;;;;N;;;;;
10F58;SOGDIAN PUNCTUATION TWO CIRCLES WITH DOTS;Po;0;AL;;;;;N;;;;;
10F59;SOGDIAN PUNCTUATION HALF CIRCLE WITH DOT;Po;0;AL;;;;;N;;;;;
10F70;OLD UYGHUR LETTER ALEPH;Lo;0;R;;;;;N;;;;;
10F71;OLD UYGHUR LETTER BETH;Lo;0;R;;;;;N;;;;;
10F72;OLD UYGHUR LETTER GIMEL-HETH;Lo;0;R;;;;;N;;;;;
10F73;OLD UYGHUR LETTER WAW;Lo;0;R;;;;;N;;;;;
10F74;OLD UYGHUR LETTER ZAYIN;Lo;0;R;;;;;N;;;;;
10F75;OLD UYGHUR LETTER FINAL HETH;Lo;0;R;;;;;N;;;;;
10F76;OLD UYGHUR LETTER YODH;Lo;0;R;;;;;N;;;;;
10F77;OLD UYGHUR LETTER KAPH;Lo;0;R;;;;;N;;;;;
10F78;OLD UYGHUR LETTER LAMEDH;Lo;0;R;;;;;N;;;;;
10F79;OLD UYGHUR LETTER MEM;Lo;0;R;;;;;N;;;;;
10F7A;OLD UYGHUR LETTER NUN;Lo;0;R;;;;;N;;;;;
10F7B;OLD UYGHUR LETTER SAMEKH;Lo;0;R;;;;;N;;;;;
10F7C;OLD UYGHUR LETTER PE;Lo;0;R;;;;;N;;;;;
10F7D;OLD UYGHUR LETTER SADHE;Lo;0;R;;;;;N;;;;;
10F7E;OLD UYGHUR LETTER RESH;Lo;0;R;;;;;N;;;;;
10F7F;OLD UYGHUR LETTER SHIN;Lo;0;R;;;;;N;;;;;
10F80;OLD UYGHUR LETTER TAW;Lo;0;R;;;;;N;;;;;
10F81;OLD UYGHUR LETTER LESH;Lo;0;R;;;;;N;;;;;
10F82;OLD UYGHUR COMBINING DOT ABOVE;Mn;230;NSM;;;;;N;;;;;
10F83;OLD UYGHUR COMBINING DOT BELOW;Mn;220;NSM;;;;;N;;;;;
10F84;OLD UYGHUR COMBINING TWO DOTS ABOVE;Mn;230;NSM;;;;;N;;;;;
10F85;OLD UYGHUR COMBINING TWO DOTS BELOW;Mn;220;NSM;;;;;N;;;;;
10F86;OLD UYGHUR PUNCTUATION BAR;Po;0;R;;;;;N;;;;;
10F87;OLD UYGHUR PUNCTUATION TWO BARS;Po;0;R;;;;;N;;;;;
10F88;OLD UYGHUR PUNCTUATION TWO DOTS;Po;0;R;;;;;N;;;;;
10F89;OLD UYGHUR PUNCTUATION FOUR DOTS;Po;0;R;;;;;N;;;;;
10FB0;CHORASMIAN LETTER ALEPH;Lo;0;R;;;;;N;;;;;
10FB1;CHORASMIAN LETTER SMALL ALEPH;Lo;0;R;;;;;N;;;;;
10FB2;CHORASMIAN LETTER BETH;Lo;0;R;;;;;N;;;;;
10FB3;CHORASMIAN LETTER GIMEL;Lo;0;R;;;;;N;;;;;
10FB4;CHORASMIAN LETTER DALETH;Lo;0;R;;;;;N;;;;;
10FB5;CHORASMIAN LETTER HE;Lo;0;R;;;;;N;;;;;
10FB6;CHORASMIAN LETTER WAW;Lo;0;R;;;;;N;;;;;
10FB7;CHORASMIAN LETTER CURLED WAW;Lo;0;R;;;;;N;;;;;
10FB8;CHORASMIAN LETTER ZAYIN;Lo;0;R;;;;;N;;;;;
10FB9;CHORASMIAN LETTER HETH;Lo;0;R;;;;;N;;;;;
10FBA;CHORASMIAN LETTER YODH;Lo;0;R;;;;;N;;;;;
10FBB;CHORASMIAN LETTER KAPH;Lo;0;R;;;;;N;;;;;
10FBC;CHORASMIAN LETTER LAMEDH;Lo;0;R;;;;;N;;;;;
10FBD;CHORASMIAN LETTER MEM;Lo;0;R;;;;;N;;;;;
10FBE;CHORASMIAN LETTER NUN;Lo;0;R;;;;;N;;;;;
10FBF;CHORASMIAN LETTER SAMEKH;Lo;0;R;;;;;N;;;;;
10FC0;CHORASMIAN LETTER AYIN;Lo;0;R;;;;;N;;;;;
10FC1;CHORASMIAN LETTER PE;Lo;0;R;;;;;N;;;;;
10FC2;CHORASMIAN LETTER RESH;Lo;0;R;;;;;N;;;;;
10FC3;CHORASMIAN LETTER SHIN;Lo;0;R;;;;;N;;;;;
10FC4;CHORASMIAN LETTER TAW;Lo;0;R;;;;;N;;;;;
10FC5;CHORASMIAN NUMBER ONE;No;0;R;;;;1;N;;;;;
10FC6;CHORASMIAN NUMBER TWO;No;0;R;;;;2;N;;;;;
10FC7;CHORASMIAN NUMBER THREE;No;0;R;;;;3;N;;;;;
10FC8;CHORASMIAN NUMBER FOUR;No;0;R;;;;4;N;;;;;
10FC9;CHORASMIAN NUMBER TEN;No;0;R;;;;10;N;;;;;
10FCA;CHORASMIAN NUMBER TWENTY;No;0;R;;;;20;N;;;;;
10FCB;CHORASMIAN NUMBER ONE HUNDRED;No;0;R;;;;100;N;;;;;
10FE0;ELYMAIC LETTER ALEPH;Lo;0;R;;;;;N;;;;;
10FE1;ELYMAIC LETTER BETH;Lo;0;R;;;;;N;;;;;
10FE2;ELYMAIC LETTER GIMEL;Lo;0;R;;;;;N;;;;;
10FE3;ELYMAIC LETTER DALETH;Lo;0;R;;;;;N;;;;;
10FE4;ELYMAIC LETTER HE;Lo;0;R;;;;;N;;;;;
10FE5;ELYMAIC LETTER WAW;Lo;0;R;;;;;N;;;;;
10FE6;ELYMAIC LETTER ZAYIN;Lo;0;R;;;;;N;;;;;
10FE7;ELYMAIC LETTER HETH;Lo;0;R;;;;;N;;;;;
10FE8;ELYMAIC LETTER TETH;Lo;0;R;;;;;N;;;;;
10FE9;ELYMAIC LETTER YODH;Lo;0;R;;;;;N;;;;;
10FEA;ELYMAIC LETTER KAPH;Lo;0;R;;;;;N;;;;;
10FEB;ELYMAIC LETTER LAMEDH;Lo;0;R;;;;;N;;;;;
10FEC;ELYMAIC LETTER MEM;Lo;0;R;;;;;N;;;;;
10FED;ELYMAIC LETTER NUN;Lo;0;R;;;;;N;;;;;
10FEE;ELYMAIC LETTER SAMEKH;Lo;0;R;;;;;N;;;;;
10FEF;ELYMAIC LETTER AYIN;Lo;0;R;;;;;N;;;;;
10FF0;ELYMAIC LETTER PE;Lo;0;R;;;;;N;;;;;
10FF1;ELYMAIC LETTER SADHE;Lo;0;R;;;;;N;;;;;
10FF2;ELYMAIC LETTER QOPH;Lo;0;R;;;;;N;;;;;
10FF3;ELYMAIC LETTER RESH;Lo;0;R;;;;;N;;;;;
10FF4;ELYMAIC LETTER SHIN;Lo;0;R;;;;;N;;;;;
10FF5;ELYMAIC LETTER TAW;Lo;0;R;;;;;N;;;;;
10FF6;ELYMAIC LIGATURE ZAYIN-YODH;Lo;0;R;;;;;N;;;;;
11000;BRAHMI SIGN CANDRABINDU;Mc;0;L;;;;;N;;;;;
11001;BRAHMI SIGN ANUSVARA;Mn;0;NSM;;;;;N;;;;;
11002;BRAHMI SIGN VISARGA;Mc;0;L;;;;;N;;;;;
11003;BRAHMI SIGN JIHVAMULIYA;Lo;0;L;;;;;N;;;;;
11004;BRAHMI SIGN UPADHMANIYA;Lo;0;L;;;;;N;;;;;
11005;BRAHMI LETTER A;Lo;0;L;;;;;N;;;;;
11006;BRAHMI LETTER AA;Lo;0;L;;;;;N;;;;;
11007;BRAHMI LETTER I;Lo;0;L;;;;;N;;;;;
11008;BRAHMI LETTER II;Lo;0;L;;;;;N;;;;;
11009;BRAHMI LETTER U;Lo;0;L;;;;;N;;;;;
1100A;BRAHMI LETTER UU;Lo;0;L;;;;;N;;;;;
1100B;BRAHMI LETTER VOCALIC R;Lo;0;L;;;;;N;;;;;
1100C;BRAHMI LETTER VOCALIC RR;Lo;0;L;;;;;N;;;;;
1100D;BRAHMI LETTER VOCALIC L;Lo;0;L;;;;;N;;;;;
1100E;BRAHMI LETTER VOCALIC LL;Lo;0;L;;;;;N;;;;;
1100F;BRAHMI LETTER E;Lo;0;L;;;;;N;;;;;
11010;BRAHMI LETTER AI;Lo;0;L;;;;;N;;;;;
11011;BRAHMI LETTER O;Lo;0;L;;;;;N;;;;;
11012;BRAHMI LETTER AU;Lo;0;L;;;;;N;;;;;
11013;BRAHMI LETTER KA;Lo;0;L;;;;;N;;;;;
11014;BRAHMI LETTER KHA;Lo;0;L;;;;;N;;;;;
11015;BRAHMI LETTER GA;Lo;0;L;;;;;N;;;;;
11016;BRAHMI LETTER GHA;Lo;0;L;;;;;N;;;;;
11017;BRAHMI LETTER NGA;Lo;0;L;;;;;N;;;;;
11018;BRAHMI LETTER CA;Lo;0;L;;;;;N;;;;;
11019;BRAHMI LETTER CHA;Lo;0;L;;;;;N;;;;;
1101A;BRAHMI LETTER JA;Lo;0;L;;;;;N;;;;;
1101B;BRAHMI LETTER JHA;Lo;0;L;;;;;N;;;;;
1101C;BRAHMI LETTER NYA;Lo;0;L;;;;;N;;;;;
1101D;BRAHMI LETTER TTA;Lo;0;L;;;;;N;;;;;
1101E;BRAHMI LETTER TTHA;Lo;0;L;;;;;N;;;;;
1101F;BRAHMI LETTER DDA;Lo;0;L;;;;;N;;;;;
11020;BRAHMI LETTER DDHA;Lo;0;L;;;;;N;;;;;
11021;BRAHMI LETTER NNA;Lo;0;L;;;;;N;;;;;
11022;BRAHMI LETTER TA;Lo;0;L;;;;;N;;;;;
11023;BRAHMI LETTER THA;Lo;0;L;;;;;N;;;;;
11024;BRAHMI LETTER DA;Lo;0;L;;;;;N;;;;;
11025;BRAHMI LETTER DHA;Lo;0;L;;;;;N;;;;;
11026;BRAHMI LETTER NA;Lo;0;L;;;;;N;;;;;
11027;BRAHMI LETTER PA;Lo;0;L;;;;;N;;;;;
11028;BRAHMI LETTER PHA;Lo;0;L;;;;;N;;;;;
11029;BRAHMI LETTER BA;Lo;0;L;;;;;N;;;;;
1102A;BRAHMI LETTER BHA;Lo;0;L;;;;;N;;;;;
1102B;BRAHMI LETTER MA;Lo;0;L;;;;;N;;;;;
1102C;BRAHMI LETTER YA;Lo;0;L;;;;;N;;;;;
1102D;BRAHMI LETTER RA;Lo;0;L;;;;;N;;;;;
1102E;BRAHMI LETTER LA;Lo;0;L;;;;;N;;;;;
1102F;BRAHMI LETTER VA;Lo;0;L;;;;;N;;;;;
11030;BRAHMI LETTER SHA;Lo;0;L;;;;;N;;;;;
11031;BRAHMI LETTER SSA;Lo;0;L;;;;;N;;;;;
11032;BRAHMI LETTER SA;Lo;0;L;;;;;N;;;;;
11033;BRAHMI LETTER HA;Lo;0;L;;;;;N;;;;;
11034;BRAHMI LETTER LLA;Lo;0;L;;;;;N;;;;;
11035;BRAHMI LETTER OLD TAMIL LLLA;Lo;0;L;;;;;N;;;;;
11036;BRAHMI LETTER OLD TAMIL RRA;Lo;0;L;;;;;N;;;;;
11037;BRAHMI LETTER OLD TAMIL NNNA;Lo;0;L;;;;;N;;;;;
11038;BRAHMI VOWEL SIGN AA;Mn;0;NSM;;;;;N;;;;;
11039;BRAHMI VOWEL SIGN BHATTIPROLU AA;Mn;0;NSM;;;;;N;;;;;
1103A;BRAHMI VOWEL SIGN I;Mn;0;NSM;;;;;N;;;;;
1103B;BRAHMI VOWEL SIGN II;Mn;0;NSM;;;;;N;;;;;
1103C;BRAHMI VOWEL SIGN U;Mn;0;NSM;;;;;N;;;;;
1103D;BRAHMI VOWEL SIGN UU;Mn;0;NSM;;;;;N;;;;;
1103E;BRAHMI VOWEL SIGN VOCALIC R;Mn;0;NSM;;;;;N;;;;;
1103F;BRAHMI VOWEL SIGN VOCALIC RR;Mn;0;NSM;;;;;N;;;;;
11040;BRAHMI VOWEL SIGN VOCALIC L;Mn;0;NSM;;;;;N;;;;;
11041;BRAHMI VOWEL SIGN VOCALIC LL;Mn;0;NSM;;;;;N;;;;;
11042;BRAHMI VOWEL SIGN E;Mn;0;NSM;;;;;N;;;;;
11043;BRAHMI VOWEL SIGN AI;Mn;0;NSM;;;;;N;;;;;
11044;BRAHMI VOWEL SIGN O;Mn;0;NSM;;;;;N;;;;;
11045;BRAHMI VOWEL SIGN AU;Mn;0;NSM;;;;;N;;;;;
11046;BRAHMI VIRAMA;Mn;9;NSM;;;;;N;;;;;
11047;BRAHMI DANDA;Po;0;L;;;;;N;;;;;
11048;BRAHMI DOUBLE DANDA;Po;0;L;;;;;N;;;;;
11049;BRAHMI PUNCTUATION DOT;Po;0;L;;;;;N;;;;;
1104A;BRAHMI PUNCTUATION DOUBLE DOT;Po;0;L;;;;;N;;;;;
1104B;BRAHMI PUNCTUATION LINE;Po;0;L;;;;;N;;;;;
1104C;BRAHMI PUNCTUATION CRESCENT BAR;Po;0;L;;;;;N;;;;;
1104D;BRAHMI PUNCTUATION LOTUS;Po;0;L;;;;;N;;;;;
11052;BRAHMI NUMBER ONE;No;0;ON;;;1;1;N;;;;;
11053;BRAHMI NUMBER TWO;No;0;ON;;;2;2;N;;;;;
11054;BRAHMI NUMBER THREE;No;0;ON;;;3;3;N;;;;;
11055;BRAHMI NUMBER FOUR;No;0;ON;;;4;4;N;;;;;
11056;BRAHMI NUMBER FIVE;No;0;ON;;;5;5;N;;;;;
11057;BRAHMI NUMBER SIX;No;0;ON;;;6;6;N;;;;;
11058;BRAHMI NUMBER SEVEN;No;0;ON;;;7;7;N;;;;;
11059;BRAHMI NUMBER EIGHT;No;0;ON;;;8;8;N;;;;;
1105A;BRAHMI NUMBER NINE;No;0;ON;;;9;9;N;;;;;
1105B;BRAHMI NUMBER TEN;No;0;ON;;;;10;N;;;;;
1105C;BRAHMI NUMBER TWENTY;No;0;ON;;;;20;N;;;;;
1105D;BRAHMI NUMBER THIRTY;No;0;ON;;;;30;N;;;;;
1105E;BRAHMI NUMBER FORTY;No;0;ON;;;;40;N;;;;;
1105F;BRAHMI NUMBER FIFTY;No;0;ON;;;;50;N;;;;;
11060;BRAHMI NUMBER SIXTY;No;0;ON;;;;60;N;;;;;
11061;BRAHMI NUMBER SEVENTY;No;0;ON;;;;70;N;;;;;
11062;BRAHMI NUMBER EIGHTY;No;0;ON;;;;80;N;;;;;
11063;BRAHMI NUMBER NINETY;No;0;ON;;;;90;N;;;;;
11064;BRAHMI NUMBER ONE HUNDRED;No;0;ON;;;;100;N;;;;;
11065;BRAHMI NUMBER ONE THOUSAND;No;0;ON;;;;1000;N;;;;;
11066;BRAHMI DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
11067;BRAHMI DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
11068;BRAHMI DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
11069;BRAHMI DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
1106A;BRAHMI DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
1106B;BRAHMI DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
1106C;BRAHMI DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
1106D;BRAHMI DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
1106E;BRAHMI DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
1106F;BRAHMI DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
11070;BRAHMI SIGN OLD TAMIL VIRAMA;Mn;9;NSM;;;;;N;;;;;
11071;BRAHMI LETTER OLD TAMIL SHORT E;Lo;0;L;;;;;N;;;;;
11072;BRAHMI LETTER OLD TAMIL SHORT O;Lo;0;L;;;;;N;;;;;
11073;BRAHMI VOWEL SIGN OLD TAMIL SHORT E;Mn;0;NSM;;;;;N;;;;;
11074;BRAHMI VOWEL SIGN OLD TAMIL SHORT O;Mn;0;NSM;;;;;N;;;;;
11075;BRAHMI LETTER OLD TAMIL LLA;Lo;0;L;;;;;N;;;;;
1107F;BRAHMI NUMBER JOINER;Mn;9;NSM;;;;;N;;;;;
11080;KAITHI SIGN CANDRABINDU;Mn;0;NSM;;;;;N;;;;;
11081;KAITHI SIGN ANUSVARA;Mn;0;NSM;;;;;N;;;;;
11082;KAITHI SIGN VISARGA;Mc;0;L;;;;;N;;;;;
11083;KAITHI LETTER A;Lo;0;L;;;;;N;;;;;
11084;KAITHI LETTER AA;Lo;0;L;;;;;N;;;;;
11085;KAITHI LETTER I;Lo;0;L;;;;;N;;;;;
11086;KAITHI LETTER II;Lo;0;L;;;;;N;;;;;
11087;KAITHI LETTER U;Lo;0;L;;;;;N;;;;;
11088;KAITHI LETTER UU;Lo;0;L;;;;;N;;;;;
11089;KAITHI LETTER E;Lo;0;L;;;;;N;;;;;
1108A;KAITHI LETTER AI;Lo;0;L;;;;;N;;;;;
1108B;KAITHI LETTER O;Lo;0;L;;;;;N;;;;;
1108C;KAITHI LETTER AU;Lo;0;L;;;;;N;;;;;
1108D;KAITHI LETTER KA;Lo;0;L;;;;;N;;;;;
1108E;KAITHI LETTER KHA;Lo;0;L;;;;;N;;;;;
1108F;KAITHI LETTER GA;Lo;0;L;;;;;N;;;;;
11090;KAITHI LETTER GHA;Lo;0;L;;;;;N;;;;;
11091;KAITHI LETTER NGA;Lo;0;L;;;;;N;;;;;
11092;KAITHI LETTER CA;Lo;0;L;;;;;N;;;;;
11093;KAITHI LETTER CHA;Lo;0;L;;;;;N;;;;;
11094;KAITHI LETTER JA;Lo;0;L;;;;;N;;;;;
11095;KAITHI LETTER JHA;Lo;0;L;;;;;N;;;;;
11096;KAITHI LETTER NYA;Lo;0;L;;;;;N;;;;;
11097;KAITHI LETTER TTA;Lo;0;L;;;;;N;;;;;
11098;KAITHI LETTER TTHA;Lo;0;L;;;;;N;;;;;
11099;KAITHI LETTER DDA;Lo;0;L;;;;;N;;;;;
1109A;KAITHI LETTER DDDHA;Lo;0;L;11099 110BA;;;;N;;;;;
1109B;KAITHI LETTER DDHA;Lo;0;L;;;;;N;;;;;
1109C;KAITHI LETTER RHA;Lo;0;L;1109B 110BA;;;;N;;;;;
1109D;KAITHI LETTER NNA;Lo;0;L;;;;;N;;;;;
1109E;KAITHI LETTER TA;Lo;0;L;;;;;N;;;;;
1109F;KAITHI LETTER THA;Lo;0;L;;;;;N;;;;;
110A0;KAITHI LETTER DA;Lo;0;L;;;;;N;;;;;
110A1;KAITHI LETTER DHA;Lo;0;L;;;;;N;;;;;
110A2;KAITHI LETTER NA;Lo;0;L;;;;;N;;;;;
110A3;KAITHI LETTER PA;Lo;0;L;;;;;N;;;;;
110A4;KAITHI LETTER PHA;Lo;0;L;;;;;N;;;;;
110A5;KAITHI LETTER BA;Lo;0;L;;;;;N;;;;;
110A6;KAITHI LETTER BHA;Lo;0;L;;;;;N;;;;;
110A7;KAITHI LETTER MA;Lo;0;L;;;;;N;;;;;
110A8;KAITHI LETTER YA;Lo;0;L;;;;;N;;;;;
110A9;KAITHI LETTER RA;Lo;0;L;;;;;N;;;;;
110AA;KAITHI LETTER LA;Lo;0;L;;;;;N;;;;;
110AB;KAITHI LETTER VA;Lo;0;L;110A5 110BA;;;;N;;;;;
110AC;KAITHI LETTER SHA;Lo;0;L;;;;;N;;;;;
110AD;KAITHI LETTER SSA;Lo;0;L;;;;;N;;;;;
110AE;KAITHI LETTER SA;Lo;0;L;;;;;N;;;;;
110AF;KAITHI LETTER HA;Lo;0;L;;;;;N;;;;;
110B0;KAITHI VOWEL SIGN AA;Mc;0;L;;;;;N;;;;;
110B1;KAITHI VOWEL SIGN I;Mc;0;L;;;;;N;;;;;
110B2;KAITHI VOWEL SIGN II;Mc;0;L;;;;;N;;;;;
110B3;KAITHI VOWEL SIGN U;Mn;0;NSM;;;;;N;;;;;
110B4;KAITHI VOWEL SIGN UU;Mn;0;NSM;;;;;N;;;;;
110B5;KAITHI VOWEL SIGN E;Mn;0;NSM;;;;;N;;;;;
110B6;KAITHI VOWEL SIGN AI;Mn;0;NSM;;;;;N;;;;;
110B7;KAITHI VOWEL SIGN O;Mc;0;L;;;;;N;;;;;
110B8;KAITHI VOWEL SIGN AU;Mc;0;L;;;;;N;;;;;
110B9;KAITHI SIGN VIRAMA;Mn;9;NSM;;;;;N;;;;;
110BA;KAITHI SIGN NUKTA;Mn;7;NSM;;;;;N;;;;;
110BB;KAITHI ABBREVIATION SIGN;Po;0;L;;;;;N;;;;;
110BC;KAITHI ENUMERATION SIGN;Po;0;L;;;;;N;;;;;
110BD;KAITHI NUMBER SIGN;Cf;0;L;;;;;N;;;;;
110BE;KAITHI SECTION MARK;Po;0;L;;;;;N;;;;;
110BF;KAITHI DOUBLE SECTION MARK;Po;0;L;;;;;N;;;;;
110C0;KAITHI DANDA;Po;0;L;;;;;N;;;;;
110C1;KAITHI DOUBLE DANDA;Po;0;L;;;;;N;;;;;
110C2;KAITHI VOWEL SIGN VOCALIC R;Mn;0;NSM;;;;;N;;;;;
110CD;KAITHI NUMBER SIGN ABOVE;Cf;0;L;;;;;N;;;;;
110D0;SORA SOMPENG LETTER SAH;Lo;0;L;;;;;N;;;;;
110D1;SORA SOMPENG LETTER TAH;Lo;0;L;;;;;N;;;;;
110D2;SORA SOMPENG LETTER BAH;Lo;0;L;;;;;N;;;;;
110D3;SORA SOMPENG LETTER CAH;Lo;0;L;;;;;N;;;;;
110D4;SORA SOMPENG LETTER DAH;Lo;0;L;;;;;N;;;;;
110D5;SORA SOMPENG LETTER GAH;Lo;0;L;;;;;N;;;;;
110D6;SORA SOMPENG LETTER MAH;Lo;0;L;;;;;N;;;;;
110D7;SORA SOMPENG LETTER NGAH;Lo;0;L;;;;;N;;;;;
110D8;SORA SOMPENG LETTER LAH;Lo;0;L;;;;;N;;;;;
110D9;SORA SOMPENG LETTER NAH;Lo;0;L;;;;;N;;;;;
110DA;SORA SOMPENG LETTER VAH;Lo;0;L;;;;;N;;;;;
110DB;SORA SOMPENG LETTER PAH;Lo;0;L;;;;;N;;;;;
110DC;SORA SOMPENG LETTER YAH;Lo;0;L;;;;;N;;;;;
110DD;SORA SOMPENG LETTER RAH;Lo;0;L;;;;;N;;;;;
110DE;SORA SOMPENG LETTER HAH;Lo;0;L;;;;;N;;;;;
110DF;SORA SOMPENG LETTER KAH;Lo;0;L;;;;;N;;;;;
110E0;SORA SOMPENG LETTER JAH;Lo;0;L;;;;;N;;;;;
110E1;SORA SOMPENG LETTER NYAH;Lo;0;L;;;;;N;;;;;
110E2;SORA SOMPENG LETTER AH;Lo;0;L;;;;;N;;;;;
110E3;SORA SOMPENG LETTER EEH;Lo;0;L;;;;;N;;;;;
110E4;SORA SOMPENG LETTER IH;Lo;0;L;;;;;N;;;;;
110E5;SORA SOMPENG LETTER UH;Lo;0;L;;;;;N;;;;;
110E6;SORA SOMPENG LETTER OH;Lo;0;L;;;;;N;;;;;
110E7;SORA SOMPENG LETTER EH;Lo;0;L;;;;;N;;;;;
110E8;SORA SOMPENG LETTER MAE;Lo;0;L;;;;;N;;;;;
110F0;SORA SOMPENG DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
110F1;SORA SOMPENG DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
110F2;SORA SOMPENG DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
110F3;SORA SOMPENG DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
110F4;SORA SOMPENG DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
110F5;SORA SOMPENG DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
110F6;SORA SOMPENG DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
110F7;SORA SOMPENG DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
110F8;SORA SOMPENG DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
110F9;SORA SOMPENG DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
11100;CHAKMA SIGN CANDRABINDU;Mn;230;NSM;;;;;N;;;;;
11101;CHAKMA SIGN ANUSVARA;Mn;230;NSM;;;;;N;;;;;
11102;CHAKMA SIGN VISARGA;Mn;230;NSM;;;;;N;;;;;
11103;CHAKMA LETTER AA;Lo;0;L;;;;;N;;;;;
11104;CHAKMA LETTER I;Lo;0;L;;;;;N;;;;;
11105;CHAKMA LETTER U;Lo;0;L;;;;;N;;;;;
11106;CHAKMA LETTER E;Lo;0;L;;;;;N;;;;;
11107;CHAKMA LETTER KAA;Lo;0;L;;;;;N;;;;;
11108;CHAKMA LETTER KHAA;Lo;0;L;;;;;N;;;;;
11109;CHAKMA LETTER GAA;Lo;0;L;;;;;N;;;;;
1110A;CHAKMA LETTER GHAA;Lo;0;L;;;;;N;;;;;
1110B;CHAKMA LETTER NGAA;Lo;0;L;;;;;N;;;;;
1110C;CHAKMA LETTER CAA;Lo;0;L;;;;;N;;;;;
1110D;CHAKMA LETTER CHAA;Lo;0;L;;;;;N;;;;;
1110E;CHAKMA LETTER JAA;Lo;0;L;;;;;N;;;;;
1110F;CHAKMA LETTER JHAA;Lo;0;L;;;;;N;;;;;
11110;CHAKMA LETTER NYAA;Lo;0;L;;;;;N;;;;;
11111;CHAKMA LETTER TTAA;Lo;0;L;;;;;N;;;;;
11112;CHAKMA LETTER TTHAA;Lo;0;L;;;;;N;;;;;
11113;CHAKMA LETTER DDAA;Lo;0;L;;;;;N;;;;;
11114;CHAKMA LETTER DDHAA;Lo;0;L;;;;;N;;;;;
11115;CHAKMA LETTER NNAA;Lo;0;L;;;;;N;;;;;
11116;CHAKMA LETTER TAA;Lo;0;L;;;;;N;;;;;
11117;CHAKMA LETTER THAA;Lo;0;L;;;;;N;;;;;
11118;CHAKMA LETTER DAA;Lo;0;L;;;;;N;;;;;
11119;CHAKMA LETTER DHAA;Lo;0;L;;;;;N;;;;;
1111A;CHAKMA LETTER NAA;Lo;0;L;;;;;N;;;;;
1111B;CHAKMA LETTER PAA;Lo;0;L;;;;;N;;;;;
1111C;CHAKMA LETTER PHAA;Lo;0;L;;;;;N;;;;;
1111D;CHAKMA LETTER BAA;Lo;0;L;;;;;N;;;;;
1111E;CHAKMA LETTER BHAA;Lo;0;L;;;;;N;;;;;
1111F;CHAKMA LETTER MAA;Lo;0;L;;;;;N;;;;;
11120;CHAKMA LETTER YYAA;Lo;0;L;;;;;N;;;;;
11121;CHAKMA LETTER YAA;Lo;0;L;;;;;N;;;;;
11122;CHAKMA LETTER RAA;Lo;0;L;;;;;N;;;;;
11123;CHAKMA LETTER LAA;Lo;0;L;;;;;N;;;;;
11124;CHAKMA LETTER WAA;Lo;0;L;;;;;N;;;;;
11125;CHAKMA LETTER SAA;Lo;0;L;;;;;N;;;;;
11126;CHAKMA LETTER HAA;Lo;0;L;;;;;N;;;;;
11127;CHAKMA VOWEL SIGN A;Mn;0;NSM;;;;;N;;;;;
11128;CHAKMA VOWEL SIGN I;Mn;0;NSM;;;;;N;;;;;
11129;CHAKMA VOWEL SIGN II;Mn;0;NSM;;;;;N;;;;;
1112A;CHAKMA VOWEL SIGN U;Mn;0;NSM;;;;;N;;;;;
1112B;CHAKMA VOWEL SIGN UU;Mn;0;NSM;;;;;N;;;;;
1112C;CHAKMA VOWEL SIGN E;Mc;0;L;;;;;N;;;;;
1112D;CHAKMA VOWEL SIGN AI;Mn;0;NSM;;;;;N;;;;;
1112E;CHAKMA VOWEL SIGN O;Mn;0;NSM;11131 11127;;;;N;;;;;
1112F;CHAKMA VOWEL SIGN AU;Mn;0;NSM;11132 11127;;;;N;;;;;
11130;CHAKMA VOWEL SIGN OI;Mn;0;NSM;;;;;N;;;;;
11131;CHAKMA O MARK;Mn;0;NSM;;;;;N;;;;;
11132;CHAKMA AU MARK;Mn;0;NSM;;;;;N;;;;;
11133;CHAKMA VIRAMA;Mn;9;NSM;;;;;N;;;;;
11134;CHAKMA MAAYYAA;Mn;9;NSM;;;;;N;;;;;
11136;CHAKMA DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
11137;CHAKMA DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
11138;CHAKMA DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
11139;CHAKMA DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
1113A;CHAKMA DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
1113B;CHAKMA DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
1113C;CHAKMA DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
1113D;CHAKMA DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
1113E;CHAKMA DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
1113F;CHAKMA DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
11140;CHAKMA SECTION MARK;Po;0;L;;;;;N;;;;;
11141;CHAKMA DANDA;Po;0;L;;;;;N;;;;;
11142;CHAKMA DOUBLE DANDA;Po;0;L;;;;;N;;;;;
11143;CHAKMA QUESTION MARK;Po;0;L;;;;;N;;;;;
11144;CHAKMA LETTER LHAA;Lo;0;L;;;;;N;;;;;
11145;CHAKMA VOWEL SIGN AA;Mc;0;L;;;;;N;;;;;
11146;CHAKMA VOWEL SIGN EI;Mc;0;L;;;;;N;;;;;
11147;CHAKMA LETTER VAA;Lo;0;L;;;;;N;;;;;
11150;MAHAJANI LETTER A;Lo;0;L;;;;;N;;;;;
11151;MAHAJANI LETTER I;Lo;0;L;;;;;N;;;;;
11152;MAHAJANI LETTER U;Lo;0;L;;;;;N;;;;;
11153;MAHAJANI LETTER E;Lo;0;L;;;;;N;;;;;
11154;MAHAJANI LETTER O;Lo;0;L;;;;;N;;;;;
11155;MAHAJANI LETTER KA;Lo;0;L;;;;;N;;;;;
11156;MAHAJANI LETTER KHA;Lo;0;L;;;;;N;;;;;
11157;MAHAJANI LETTER GA;Lo;0;L;;;;;N;;;;;
11158;MAHAJANI LETTER GHA;Lo;0;L;;;;;N;;;;;
11159;MAHAJANI LETTER CA;Lo;0;L;;;;;N;;;;;
1115A;MAHAJANI LETTER CHA;Lo;0;L;;;;;N;;;;;
1115B;MAHAJANI LETTER JA;Lo;0;L;;;;;N;;;;;
1115C;MAHAJANI LETTER JHA;Lo;0;L;;;;;N;;;;;
1115D;MAHAJANI LETTER NYA;Lo;0;L;;;;;N;;;;;
1115E;MAHAJANI LETTER TTA;Lo;0;L;;;;;N;;;;;
1115F;MAHAJANI LETTER TTHA;Lo;0;L;;;;;N;;;;;
11160;MAHAJANI LETTER DDA;Lo;0;L;;;;;N;;;;;
11161;MAHAJANI LETTER DDHA;Lo;0;L;;;;;N;;;;;
11162;MAHAJANI LETTER NNA;Lo;0;L;;;;;N;;;;;
11163;MAHAJANI LETTER TA;Lo;0;L;;;;;N;;;;;
11164;MAHAJANI LETTER THA;Lo;0;L;;;;;N;;;;;
11165;MAHAJANI LETTER DA;Lo;0;L;;;;;N;;;;;
11166;MAHAJANI LETTER DHA;Lo;0;L;;;;;N;;;;;
11167;MAHAJANI LETTER NA;Lo;0;L;;;;;N;;;;;
11168;MAHAJANI LETTER PA;Lo;0;L;;;;;N;;;;;
11169;MAHAJANI LETTER PHA;Lo;0;L;;;;;N;;;;;
1116A;MAHAJANI LETTER BA;Lo;0;L;;;;;N;;;;;
1116B;MAHAJANI LETTER BHA;Lo;0;L;;;;;N;;;;;
1116C;MAHAJANI LETTER MA;Lo;0;L;;;;;N;;;;;
1116D;MAHAJANI LETTER RA;Lo;0;L;;;;;N;;;;;
1116E;MAHAJANI LETTER LA;Lo;0;L;;;;;N;;;;;
1116F;MAHAJANI LETTER VA;Lo;0;L;;;;;N;;;;;
11170;MAHAJANI LETTER SA;Lo;0;L;;;;;N;;;;;
11171;MAHAJANI LETTER HA;Lo;0;L;;;;;N;;;;;
11172;MAHAJANI LETTER RRA;Lo;0;L;;;;;N;;;;;
11173;MAHAJANI SIGN NUKTA;Mn;7;NSM;;;;;N;;;;;
11174;MAHAJANI ABBREVIATION SIGN;Po;0;L;;;;;N;;;;;
11175;MAHAJANI SECTION MARK;Po;0;L;;;;;N;;;;;
11176;MAHAJANI LIGATURE SHRI;Lo;0;L;;;;;N;;;;;
11180;SHARADA SIGN CANDRABINDU;Mn;0;NSM;;;;;N;;;;;
11181;SHARADA SIGN ANUSVARA;Mn;0;NSM;;;;;N;;;;;
11182;SHARADA SIGN VISARGA;Mc;0;L;;;;;N;;;;;
11183;SHARADA LETTER A;Lo;0;L;;;;;N;;;;;
11184;SHARADA LETTER AA;Lo;0;L;;;;;N;;;;;
11185;SHARADA LETTER I;Lo;0;L;;;;;N;;;;;
11186;SHARADA LETTER II;Lo;0;L;;;;;N;;;;;
11187;SHARADA LETTER U;Lo;0;L;;;;;N;;;;;
11188;SHARADA LETTER UU;Lo;0;L;;;;;N;;;;;
11189;SHARADA LETTER VOCALIC R;Lo;0;L;;;;;N;;;;;
1118A;SHARADA LETTER VOCALIC RR;Lo;0;L;;;;;N;;;;;
1118B;SHARADA LETTER VOCALIC L;Lo;0;L;;;;;N;;;;;
1118C;SHARADA LETTER VOCALIC LL;Lo;0;L;;;;;N;;;;;
1118D;SHARADA LETTER E;Lo;0;L;;;;;N;;;;;
1118E;SHARADA LETTER AI;Lo;0;L;;;;;N;;;;;
1118F;SHARADA LETTER O;Lo;0;L;;;;;N;;;;;
11190;SHARADA LETTER AU;Lo;0;L;;;;;N;;;;;
11191;SHARADA LETTER KA;Lo;0;L;;;;;N;;;;;
11192;SHARADA LETTER KHA;Lo;0;L;;;;;N;;;;;
11193;SHARADA LETTER GA;Lo;0;L;;;;;N;;;;;
11194;SHARADA LETTER GHA;Lo;0;L;;;;;N;;;;;
11195;SHARADA LETTER NGA;Lo;0;L;;;;;N;;;;;
11196;SHARADA LETTER CA;Lo;0;L;;;;;N;;;;;
11197;SHARADA LETTER CHA;Lo;0;L;;;;;N;;;;;
11198;SHARADA LETTER JA;Lo;0;L;;;;;N;;;;;
11199;SHARADA LETTER JHA;Lo;0;L;;;;;N;;;;;
1119A;SHARADA LETTER NYA;Lo;0;L;;;;;N;;;;;
1119B;SHARADA LETTER TTA;Lo;0;L;;;;;N;;;;;
1119C;SHARADA LETTER TTHA;Lo;0;L;;;;;N;;;;;
1119D;SHARADA LETTER DDA;Lo;0;L;;;;;N;;;;;
1119E;SHARADA LETTER DDHA;Lo;0;L;;;;;N;;;;;
1119F;SHARADA LETTER NNA;Lo;0;L;;;;;N;;;;;
111A0;SHARADA LETTER TA;Lo;0;L;;;;;N;;;;;
111A1;SHARADA LETTER THA;Lo;0;L;;;;;N;;;;;
111A2;SHARADA LETTER DA;Lo;0;L;;;;;N;;;;;
111A3;SHARADA LETTER DHA;Lo;0;L;;;;;N;;;;;
111A4;SHARADA LETTER NA;Lo;0;L;;;;;N;;;;;
111A5;SHARADA LETTER PA;Lo;0;L;;;;;N;;;;;
111A6;SHARADA LETTER PHA;Lo;0;L;;;;;N;;;;;
111A7;SHARADA LETTER BA;Lo;0;L;;;;;N;;;;;
111A8;SHARADA LETTER BHA;Lo;0;L;;;;;N;;;;;
111A9;SHARADA LETTER MA;Lo;0;L;;;;;N;;;;;
111AA;SHARADA LETTER YA;Lo;0;L;;;;;N;;;;;
111AB;SHARADA LETTER RA;Lo;0;L;;;;;N;;;;;
111AC;SHARADA LETTER LA;Lo;0;L;;;;;N;;;;;
111AD;SHARADA LETTER LLA;Lo;0;L;;;;;N;;;;;
111AE;SHARADA LETTER VA;Lo;0;L;;;;;N;;;;;
111AF;SHARADA LETTER SHA;Lo;0;L;;;;;N;;;;;
111B0;SHARADA LETTER SSA;Lo;0;L;;;;;N;;;;;
111B1;SHARADA LETTER SA;Lo;0;L;;;;;N;;;;;
111B2;SHARADA LETTER HA;Lo;0;L;;;;;N;;;;;
111B3;SHARADA VOWEL SIGN AA;Mc;0;L;;;;;N;;;;;
111B4;SHARADA VOWEL SIGN I;Mc;0;L;;;;;N;;;;;
111B5;SHARADA VOWEL SIGN II;Mc;0;L;;;;;N;;;;;
111B6;SHARADA VOWEL SIGN U;Mn;0;NSM;;;;;N;;;;;
111B7;SHARADA VOWEL SIGN UU;Mn;0;NSM;;;;;N;;;;;
111B8;SHARADA VOWEL SIGN VOCALIC R;Mn;0;NSM;;;;;N;;;;;
111B9;SHARADA VOWEL SIGN VOCALIC RR;Mn;0;NSM;;;;;N;;;;;
111BA;SHARADA VOWEL SIGN VOCALIC L;Mn;0;NSM;;;;;N;;;;;
111BB;SHARADA VOWEL SIGN VOCALIC LL;Mn;0;NSM;;;;;N;;;;;
111BC;SHARADA VOWEL SIGN E;Mn;0;NSM;;;;;N;;;;;
111BD;SHARADA VOWEL SIGN AI;Mn;0;NSM;;;;;N;;;;;
111BE;SHARADA VOWEL SIGN O;Mn;0;NSM;;;;;N;;;;;
111BF;SHARADA VOWEL SIGN AU;Mc;0;L;;;;;N;;;;;
111C0;SHARADA SIGN VIRAMA;Mc;9;L;;;;;N;;;;;
111C1;SHARADA SIGN AVAGRAHA;Lo;0;L;;;;;N;;;;;
111C2;SHARADA SIGN JIHVAMULIYA;Lo;0;L;;;;;N;;;;;
111C3;SHARADA SIGN UPADHMANIYA;Lo;0;L;;;;;N;;;;;
111C4;SHARADA OM;Lo;0;L;;;;;N;;;;;
111C5;SHARADA DANDA;Po;0;L;;;;;N;;;;;
111C6;SHARADA DOUBLE DANDA;Po;0;L;;;;;N;;;;;
111C7;SHARADA ABBREVIATION SIGN;Po;0;L;;;;;N;;;;;
111C8;SHARADA SEPARATOR;Po;0;L;;;;;N;;;;;
111C9;SHARADA SANDHI MARK;Mn;0;NSM;;;;;N;;;;;
111CA;SHARADA SIGN NUKTA;Mn;7;NSM;;;;;N;;;;;
111CB;SHARADA VOWEL MODIFIER MARK;Mn;0;NSM;;;;;N;;;;;
111CC;SHARADA EXTRA SHORT VOWEL MARK;Mn;0;NSM;;;;;N;;;;;
111CD;SHARADA SUTRA MARK;Po;0;L;;;;;N;;;;;
111CE;SHARADA VOWEL SIGN PRISHTHAMATRA E;Mc;0;L;;;;;N;;;;;
111CF;SHARADA SIGN INVERTED CANDRABINDU;Mn;0;NSM;;;;;N;;;;;
111D0;SHARADA DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
111D1;SHARADA DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
111D2;SHARADA DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
111D3;SHARADA DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
111D4;SHARADA DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
111D5;SHARADA DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
111D6;SHARADA DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
111D7;SHARADA DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
111D8;SHARADA DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
111D9;SHARADA DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
111DA;SHARADA EKAM;Lo;0;L;;;;;N;;;;;
111DB;SHARADA SIGN SIDDHAM;Po;0;L;;;;;N;;;;;
111DC;SHARADA HEADSTROKE;Lo;0;L;;;;;N;;;;;
111DD;SHARADA CONTINUATION SIGN;Po;0;L;;;;;N;;;;;
111DE;SHARADA SECTION MARK-1;Po;0;L;;;;;N;;;;;
111DF;SHARADA SECTION MARK-2;Po;0;L;;;;;N;;;;;
111E1;SINHALA ARCHAIC DIGIT ONE;No;0;L;;;;1;N;;;;;
111E2;SINHALA ARCHAIC DIGIT TWO;No;0;L;;;;2;N;;;;;
111E3;SINHALA ARCHAIC DIGIT THREE;No;0;L;;;;3;N;;;;;
111E4;SINHALA ARCHAIC DIGIT FOUR;No;0;L;;;;4;N;;;;;
111E5;SINHALA ARCHAIC DIGIT FIVE;No;0;L;;;;5;N;;;;;
111E6;SINHALA ARCHAIC DIGIT SIX;No;0;L;;;;6;N;;;;;
111E7;SINHALA ARCHAIC DIGIT SEVEN;No;0;L;;;;7;N;;;;;
111E8;SINHALA ARCHAIC DIGIT EIGHT;No;0;L;;;;8;N;;;;;
111E9;SINHALA ARCHAIC DIGIT NINE;No;0;L;;;;9;N;;;;;
111EA;SINHALA ARCHAIC NUMBER TEN;No;0;L;;;;10;N;;;;;
111EB;SINHALA ARCHAIC NUMBER TWENTY;No;0;L;;;;20;N;;;;;
111EC;SINHALA ARCHAIC NUMBER THIRTY;No;0;L;;;;30;N;;;;;
111ED;SINHALA ARCHAIC NUMBER FORTY;No;0;L;;;;40;N;;;;;
111EE;SINHALA ARCHAIC NUMBER FIFTY;No;0;L;;;;50;N;;;;;
111EF;SINHALA ARCHAIC NUMBER SIXTY;No;0;L;;;;60;N;;;;;
111F0;SINHALA ARCHAIC NUMBER SEVENTY;No;0;L;;;;70;N;;;;;
111F1;SINHALA ARCHAIC NUMBER EIGHTY;No;0;L;;;;80;N;;;;;
111F2;SINHALA ARCHAIC NUMBER NINETY;No;0;L;;;;90;N;;;;;
111F3;SINHALA ARCHAIC NUMBER ONE HUNDRED;No;0;L;;;;100;N;;;;;
111F4;SINHALA ARCHAIC NUMBER ONE THOUSAND;No;0;L;;;;1000;N;;;;;
11200;KHOJKI LETTER A;Lo;0;L;;;;;N;;;;;
11201;KHOJKI LETTER AA;Lo;0;L;;;;;N;;;;;
11202;KHOJKI LETTER I;Lo;0;L;;;;;N;;;;;
11203;KHOJKI LETTER U;Lo;0;L;;;;;N;;;;;
11204;KHOJKI LETTER E;Lo;0;L;;;;;N;;;;;
11205;KHOJKI LETTER AI;Lo;0;L;;;;;N;;;;;
11206;KHOJKI LETTER O;Lo;0;L;;;;;N;;;;;
11207;KHOJKI LETTER AU;Lo;0;L;;;;;N;;;;;
11208;KHOJKI LETTER KA;Lo;0;L;;;;;N;;;;;
11209;KHOJKI LETTER KHA;Lo;0;L;;;;;N;;;;;
1120A;KHOJKI LETTER GA;Lo;0;L;;;;;N;;;;;
1120B;KHOJKI LETTER GGA;Lo;0;L;;;;;N;;;;;
1120C;KHOJKI LETTER GHA;Lo;0;L;;;;;N;;;;;
1120D;KHOJKI LETTER NGA;Lo;0;L;;;;;N;;;;;
1120E;KHOJKI LETTER CA;Lo;0;L;;;;;N;;;;;
1120F;KHOJKI LETTER CHA;Lo;0;L;;;;;N;;;;;
11210;KHOJKI LETTER JA;Lo;0;L;;;;;N;;;;;
11211;KHOJKI LETTER JJA;Lo;0;L;;;;;N;;;;;
11213;KHOJKI LETTER NYA;Lo;0;L;;;;;N;;;;;
11214;KHOJKI LETTER TTA;Lo;0;L;;;;;N;;;;;
11215;KHOJKI LETTER TTHA;Lo;0;L;;;;;N;;;;;
11216;KHOJKI LETTER DDA;Lo;0;L;;;;;N;;;;;
11217;KHOJKI LETTER DDHA;Lo;0;L;;;;;N;;;;;
11218;KHOJKI LETTER NNA;Lo;0;L;;;;;N;;;;;
11219;KHOJKI LETTER TA;Lo;0;L;;;;;N;;;;;
1121A;KHOJKI LETTER THA;Lo;0;L;;;;;N;;;;;
1121B;KHOJKI LETTER DA;Lo;0;L;;;;;N;;;;;
1121C;KHOJKI LETTER DDDA;Lo;0;L;;;;;N;;;;;
1121D;KHOJKI LETTER DHA;Lo;0;L;;;;;N;;;;;
1121E;KHOJKI LETTER NA;Lo;0;L;;;;;N;;;;;
1121F;KHOJKI LETTER PA;Lo;0;L;;;;;N;;;;;
11220;KHOJKI LETTER PHA;Lo;0;L;;;;;N;;;;;
11221;KHOJKI LETTER BA;Lo;0;L;;;;;N;;;;;
11222;KHOJKI LETTER BBA;Lo;0;L;;;;;N;;;;;
11223;KHOJKI LETTER BHA;Lo;0;L;;;;;N;;;;;
11224;KHOJKI LETTER MA;Lo;0;L;;;;;N;;;;;
11225;KHOJKI LETTER YA;Lo;0;L;;;;;N;;;;;
11226;KHOJKI LETTER RA;Lo;0;L;;;;;N;;;;;
11227;KHOJKI LETTER LA;Lo;0;L;;;;;N;;;;;
11228;KHOJKI LETTER VA;Lo;0;L;;;;;N;;;;;
11229;KHOJKI LETTER SA;Lo;0;L;;;;;N;;;;;
1122A;KHOJKI LETTER HA;Lo;0;L;;;;;N;;;;;
1122B;KHOJKI LETTER LLA;Lo;0;L;;;;;N;;;;;
1122C;KHOJKI VOWEL SIGN AA;Mc;0;L;;;;;N;;;;;
1122D;KHOJKI VOWEL SIGN I;Mc;0;L;;;;;N;;;;;
1122E;KHOJKI VOWEL SIGN II;Mc;0;L;;;;;N;;;;;
1122F;KHOJKI VOWEL SIGN U;Mn;0;NSM;;;;;N;;;;;
11230;KHOJKI VOWEL SIGN E;Mn;0;NSM;;;;;N;;;;;
11231;KHOJKI VOWEL SIGN AI;Mn;0;NSM;;;;;N;;;;;
11232;KHOJKI VOWEL SIGN O;Mc;0;L;;;;;N;;;;;
11233;KHOJKI VOWEL SIGN AU;Mc;0;L;;;;;N;;;;;
11234;KHOJKI SIGN ANUSVARA;Mn;0;NSM;;;;;N;;;;;
11235;KHOJKI SIGN VIRAMA;Mc;9;L;;;;;N;;;;;
11236;KHOJKI SIGN NUKTA;Mn;7;NSM;;;;;N;;;;;
11237;KHOJKI SIGN SHADDA;Mn;0;NSM;;;;;N;;;;;
11238;KHOJKI DANDA;Po;0;L;;;;;N;;;;;
11239;KHOJKI DOUBLE DANDA;Po;0;L;;;;;N;;;;;
1123A;KHOJKI WORD SEPARATOR;Po;0;L;;;;;N;;;;;
1123B;KHOJKI SECTION MARK;Po;0;L;;;;;N;;;;;
1123C;KHOJKI DOUBLE SECTION MARK;Po;0;L;;;;;N;;;;;
1123D;KHOJKI ABBREVIATION SIGN;Po;0;L;;;;;N;;;;;
1123E;KHOJKI SIGN SUKUN;Mn;0;NSM;;;;;N;;;;;
11280;MULTANI LETTER A;Lo;0;L;;;;;N;;;;;
11281;MULTANI LETTER I;Lo;0;L;;;;;N;;;;;
11282;MULTANI LETTER U;Lo;0;L;;;;;N;;;;;
11283;MULTANI LETTER E;Lo;0;L;;;;;N;;;;;
11284;MULTANI LETTER KA;Lo;0;L;;;;;N;;;;;
11285;MULTANI LETTER KHA;Lo;0;L;;;;;N;;;;;
11286;MULTANI LETTER GA;Lo;0;L;;;;;N;;;;;
11288;MULTANI LETTER GHA;Lo;0;L;;;;;N;;;;;
1128A;MULTANI LETTER CA;Lo;0;L;;;;;N;;;;;
1128B;MULTANI LETTER CHA;Lo;0;L;;;;;N;;;;;
1128C;MULTANI LETTER JA;Lo;0;L;;;;;N;;;;;
1128D;MULTANI LETTER JJA;Lo;0;L;;;;;N;;;;;
1128F;MULTANI LETTER NYA;Lo;0;L;;;;;N;;;;;
11290;MULTANI LETTER TTA;Lo;0;L;;;;;N;;;;;
11291;MULTANI LETTER TTHA;Lo;0;L;;;;;N;;;;;
11292;MULTANI LETTER DDA;Lo;0;L;;;;;N;;;;;
11293;MULTANI LETTER DDDA;Lo;0;L;;;;;N;;;;;
11294;MULTANI LETTER DDHA;Lo;0;L;;;;;N;;;;;
11295;MULTANI LETTER NNA;Lo;0;L;;;;;N;;;;;
11296;MULTANI LETTER TA;Lo;0;L;;;;;N;;;;;
11297;MULTANI LETTER THA;Lo;0;L;;;;;N;;;;;
11298;MULTANI LETTER DA;Lo;0;L;;;;;N;;;;;
11299;MULTANI LETTER DHA;Lo;0;L;;;;;N;;;;;
1129A;MULTANI LETTER NA;Lo;0;L;;;;;N;;;;;
1129B;MULTANI LETTER PA;Lo;0;L;;;;;N;;;;;
1129C;MULTANI LETTER PHA;Lo;0;L;;;;;N;;;;;
1129D;MULTANI LETTER BA;Lo;0;L;;;;;N;;;;;
1129F;MULTANI LETTER BHA;Lo;0;L;;;;;N;;;;;
112A0;MULTANI LETTER MA;Lo;0;L;;;;;N;;;;;
112A1;MULTANI LETTER YA;Lo;0;L;;;;;N;;;;;
112A2;MULTANI LETTER RA;Lo;0;L;;;;;N;;;;;
112A3;MULTANI LETTER LA;Lo;0;L;;;;;N;;;;;
112A4;MULTANI LETTER VA;Lo;0;L;;;;;N;;;;;
112A5;MULTANI LETTER SA;Lo;0;L;;;;;N;;;;;
112A6;MULTANI LETTER HA;Lo;0;L;;;;;N;;;;;
112A7;MULTANI LETTER RRA;Lo;0;L;;;;;N;;;;;
112A8;MULTANI LETTER RHA;Lo;0;L;;;;;N;;;;;
112A9;MULTANI SECTION MARK;Po;0;L;;;;;N;;;;;
112B0;KHUDAWADI LETTER A;Lo;0;L;;;;;N;;;;;
112B1;KHUDAWADI LETTER AA;Lo;0;L;;;;;N;;;;;
112B2;KHUDAWADI LETTER I;Lo;0;L;;;;;N;;;;;
112B3;KHUDAWADI LETTER II;Lo;0;L;;;;;N;;;;;
112B4;KHUDAWADI LETTER U;Lo;0;L;;;;;N;;;;;
112B5;KHUDAWADI LETTER UU;Lo;0;L;;;;;N;;;;;
112B6;KHUDAWADI LETTER E;Lo;0;L;;;;;N;;;;;
112B7;KHUDAWADI LETTER AI;Lo;0;L;;;;;N;;;;;
112B8;KHUDAWADI LETTER O;Lo;0;L;;;;;N;;;;;
112B9;KHUDAWADI LETTER AU;Lo;0;L;;;;;N;;;;;
112BA;KHUDAWADI LETTER KA;Lo;0;L;;;;;N;;;;;
112BB;KHUDAWADI LETTER KHA;Lo;0;L;;;;;N;;;;;
112BC;KHUDAWADI LETTER GA;Lo;0;L;;;;;N;;;;;
112BD;KHUDAWADI LETTER GGA;Lo;0;L;;;;;N;;;;;
112BE;KHUDAWADI LETTER GHA;Lo;0;L;;;;;N;;;;;
112BF;KHUDAWADI LETTER NGA;Lo;0;L;;;;;N;;;;;
112C0;KHUDAWADI LETTER CA;Lo;0;L;;;;;N;;;;;
112C1;KHUDAWADI LETTER CHA;Lo;0;L;;;;;N;;;;;
112C2;KHUDAWADI LETTER JA;Lo;0;L;;;;;N;;;;;
112C3;KHUDAWADI LETTER JJA;Lo;0;L;;;;;N;;;;;
112C4;KHUDAWADI LETTER JHA;Lo;0;L;;;;;N;;;;;
112C5;KHUDAWADI LETTER NYA;Lo;0;L;;;;;N;;;;;
112C6;KHUDAWADI LETTER TTA;Lo;0;L;;;;;N;;;;;
112C7;KHUDAWADI LETTER TTHA;Lo;0;L;;;;;N;;;;;
112C8;KHUDAWADI LETTER DDA;Lo;0;L;;;;;N;;;;;
112C9;KHUDAWADI LETTER DDDA;Lo;0;L;;;;;N;;;;;
112CA;KHUDAWADI LETTER RRA;Lo;0;L;;;;;N;;;;;
112CB;KHUDAWADI LETTER DDHA;Lo;0;L;;;;;N;;;;;
112CC;KHUDAWADI LETTER NNA;Lo;0;L;;;;;N;;;;;
112CD;KHUDAWADI LETTER TA;Lo;0;L;;;;;N;;;;;
112CE;KHUDAWADI LETTER THA;Lo;0;L;;;;;N;;;;;
112CF;KHUDAWADI LETTER DA;Lo;0;L;;;;;N;;;;;
112D0;KHUDAWADI LETTER DHA;Lo;0;L;;;;;N;;;;;
112D1;KHUDAWADI LETTER NA;Lo;0;L;;;;;N;;;;;
112D2;KHUDAWADI LETTER PA;Lo;0;L;;;;;N;;;;;
112D3;KHUDAWADI LETTER PHA;Lo;0;L;;;;;N;;;;;
112D4;KHUDAWADI LETTER BA;Lo;0;L;;;;;N;;;;;
112D5;KHUDAWADI LETTER BBA;Lo;0;L;;;;;N;;;;;
112D6;KHUDAWADI LETTER BHA;Lo;0;L;;;;;N;;;;;
112D7;KHUDAWADI LETTER MA;Lo;0;L;;;;;N;;;;;
112D8;KHUDAWADI LETTER YA;Lo;0;L;;;;;N;;;;;
112D9;KHUDAWADI LETTER RA;Lo;0;L;;;;;N;;;;;
112DA;KHUDAWADI LETTER LA;Lo;0;L;;;;;N;;;;;
112DB;KHUDAWADI LETTER VA;Lo;0;L;;;;;N;;;;;
112DC;KHUDAWADI LETTER SHA;Lo;0;L;;;;;N;;;;;
112DD;KHUDAWADI LETTER SA;Lo;0;L;;;;;N;;;;;
112DE;KHUDAWADI LETTER HA;Lo;0;L;;;;;N;;;;;
112DF;KHUDAWADI SIGN ANUSVARA;Mn;0;NSM;;;;;N;;;;;
112E0;KHUDAWADI VOWEL SIGN AA;Mc;0;L;;;;;N;;;;;
112E1;KHUDAWADI VOWEL SIGN I;Mc;0;L;;;;;N;;;;;
112E2;KHUDAWADI VOWEL SIGN II;Mc;0;L;;;;;N;;;;;
112E3;KHUDAWADI VOWEL SIGN U;Mn;0;NSM;;;;;N;;;;;
112E4;KHUDAWADI VOWEL SIGN UU;Mn;0;NSM;;;;;N;;;;;
112E5;KHUDAWADI VOWEL SIGN E;Mn;0;NSM;;;;;N;;;;;
112E6;KHUDAWADI VOWEL SIGN AI;Mn;0;NSM;;;;;N;;;;;
112E7;KHUDAWADI VOWEL SIGN O;Mn;0;NSM;;;;;N;;;;;
112E8;KHUDAWADI VOWEL SIGN AU;Mn;0;NSM;;;;;N;;;;;
112E9;KHUDAWADI SIGN NUKTA;Mn;7;NSM;;;;;N;;;;;
112EA;KHUDAWADI SIGN VIRAMA;Mn;9;NSM;;;;;N;;;;;
112F0;KHUDAWADI DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
112F1;KHUDAWADI DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
112F2;KHUDAWADI DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
112F3;KHUDAWADI DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
112F4;KHUDAWADI DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
112F5;KHUDAWADI DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
112F6;KHUDAWADI DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
112F7;KHUDAWADI DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
112F8;KHUDAWADI DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
112F9;KHUDAWADI DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
11300;GRANTHA SIGN COMBINING ANUSVARA ABOVE;Mn;0;NSM;;;;;N;;;;;
11301;GRANTHA SIGN CANDRABINDU;Mn;0;NSM;;;;;N;;;;;
11302;GRANTHA SIGN ANUSVARA;Mc;0;L;;;;;N;;;;;
11303;GRANTHA SIGN VISARGA;Mc;0;L;;;;;N;;;;;
11305;GRANTHA LETTER A;Lo;0;L;;;;;N;;;;;
11306;GRANTHA LETTER AA;Lo;0;L;;;;;N;;;;;
11307;GRANTHA LETTER I;Lo;0;L;;;;;N;;;;;
11308;GRANTHA LETTER II;Lo;0;L;;;;;N;;;;;
11309;GRANTHA LETTER U;Lo;0;L;;;;;N;;;;;
1130A;GRANTHA LETTER UU;Lo;0;L;;;;;N;;;;;
1130B;GRANTHA LETTER VOCALIC R;Lo;0;L;;;;;N;;;;;
1130C;GRANTHA LETTER VOCALIC L;Lo;0;L;;;;;N;;;;;
1130F;GRANTHA LETTER EE;Lo;0;L;;;;;N;;;;;
11310;GRANTHA LETTER AI;Lo;0;L;;;;;N;;;;;
11313;GRANTHA LETTER OO;Lo;0;L;;;;;N;;;;;
11314;GRANTHA LETTER AU;Lo;0;L;;;;;N;;;;;
11315;GRANTHA LETTER KA;Lo;0;L;;;;;N;;;;;
11316;GRANTHA LETTER KHA;Lo;0;L;;;;;N;;;;;
11317;GRANTHA LETTER GA;Lo;0;L;;;;;N;;;;;
11318;GRANTHA LETTER GHA;Lo;0;L;;;;;N;;;;;
11319;GRANTHA LETTER NGA;Lo;0;L;;;;;N;;;;;
1131A;GRANTHA LETTER CA;Lo;0;L;;;;;N;;;;;
1131B;GRANTHA LETTER CHA;Lo;0;L;;;;;N;;;;;
1131C;GRANTHA LETTER JA;Lo;0;L;;;;;N;;;;;
1131D;GRANTHA LETTER JHA;Lo;0;L;;;;;N;;;;;
1131E;GRANTHA LETTER NYA;Lo;0;L;;;;;N;;;;;
1131F;GRANTHA LETTER TTA;Lo;0;L;;;;;N;;;;;
11320;GRANTHA LETTER TTHA;Lo;0;L;;;;;N;;;;;
11321;GRANTHA LETTER DDA;Lo;0;L;;;;;N;;;;;
11322;GRANTHA LETTER DDHA;Lo;0;L;;;;;N;;;;;
11323;GRANTHA LETTER NNA;Lo;0;L;;;;;N;;;;;
11324;GRANTHA LETTER TA;Lo;0;L;;;;;N;;;;;
11325;GRANTHA LETTER THA;Lo;0;L;;;;;N;;;;;
11326;GRANTHA LETTER DA;Lo;0;L;;;;;N;;;;;
11327;GRANTHA LETTER DHA;Lo;0;L;;;;;N;;;;;
11328;GRANTHA LETTER NA;Lo;0;L;;;;;N;;;;;
1132A;GRANTHA LETTER PA;Lo;0;L;;;;;N;;;;;
1132B;GRANTHA LETTER PHA;Lo;0;L;;;;;N;;;;;
1132C;GRANTHA LETTER BA;Lo;0;L;;;;;N;;;;;
1132D;GRANTHA LETTER BHA;Lo;0;L;;;;;N;;;;;
1132E;GRANTHA LETTER MA;Lo;0;L;;;;;N;;;;;
1132F;GRANTHA LETTER YA;Lo;0;L;;;;;N;;;;;
11330;GRANTHA LETTER RA;Lo;0;L;;;;;N;;;;;
11332;GRANTHA LETTER LA;Lo;0;L;;;;;N;;;;;
11333;GRANTHA LETTER LLA;Lo;0;L;;;;;N;;;;;
11335;GRANTHA LETTER VA;Lo;0;L;;;;;N;;;;;
11336;GRANTHA LETTER SHA;Lo;0;L;;;;;N;;;;;
11337;GRANTHA LETTER SSA;Lo;0;L;;;;;N;;;;;
11338;GRANTHA LETTER SA;Lo;0;L;;;;;N;;;;;
11339;GRANTHA LETTER HA;Lo;0;L;;;;;N;;;;;
1133B;COMBINING BINDU BELOW;Mn;7;NSM;;;;;N;;;;;
1133C;GRANTHA SIGN NUKTA;Mn;7;NSM;;;;;N;;;;;
1133D;GRANTHA SIGN AVAGRAHA;Lo;0;L;;;;;N;;;;;
1133E;GRANTHA VOWEL SIGN AA;Mc;0;L;;;;;N;;;;;
1133F;GRANTHA VOWEL SIGN I;Mc;0;L;;;;;N;;;;;
11340;GRANTHA VOWEL SIGN II;Mn;0;NSM;;;;;N;;;;;
11341;GRANTHA VOWEL SIGN U;Mc;0;L;;;;;N;;;;;
11342;GRANTHA VOWEL SIGN UU;Mc;0;L;;;;;N;;;;;
11343;GRANTHA VOWEL SIGN VOCALIC R;Mc;0;L;;;;;N;;;;;
11344;GRANTHA VOWEL SIGN VOCALIC RR;Mc;0;L;;;;;N;;;;;
11347;GRANTHA VOWEL SIGN EE;Mc;0;L;;;;;N;;;;;
11348;GRANTHA VOWEL SIGN AI;Mc;0;L;;;;;N;;;;;
1134B;GRANTHA VOWEL SIGN OO;Mc;0;L;11347 1133E;;;;N;;;;;
1134C;GRANTHA VOWEL SIGN AU;Mc;0;L;11347 11357;;;;N;;;;;
1134D;GRANTHA SIGN VIRAMA;Mc;9;L;;;;;N;;;;;
11350;GRANTHA OM;Lo;0;L;;;;;N;;;;;
11357;GRANTHA AU LENGTH MARK;Mc;0;L;;;;;N;;;;;
1135D;GRANTHA SIGN PLUTA;Lo;0;L;;;;;N;;;;;
1135E;GRANTHA LETTER VEDIC ANUSVARA;Lo;0;L;;;;;N;;;;;
1135F;GRANTHA LETTER VEDIC DOUBLE ANUSVARA;Lo;0;L;;;;;N;;;;;
11360;GRANTHA LETTER VOCALIC RR;Lo;0;L;;;;;N;;;;;
11361;GRANTHA LETTER VOCALIC LL;Lo;0;L;;;;;N;;;;;
11362;GRANTHA VOWEL SIGN VOCALIC L;Mc;0;L;;;;;N;;;;;
11363;GRANTHA VOWEL SIGN VOCALIC LL;Mc;0;L;;;;;N;;;;;
11366;COMBINING GRANTHA DIGIT ZERO;Mn;230;NSM;;;;;N;;;;;
11367;COMBINING GRANTHA DIGIT ONE;Mn;230;NSM;;;;;N;;;;;
11368;COMBINING GRANTHA DIGIT TWO;Mn;230;NSM;;;;;N;;;;;
11369;COMBINING GRANTHA DIGIT THREE;Mn;230;NSM;;;;;N;;;;;
1136A;COMBINING GRANTHA DIGIT FOUR;Mn;230;NSM;;;;;N;;;;;
1136B;COMBINING GRANTHA DIGIT FIVE;Mn;230;NSM;;;;;N;;;;;
1136C;COMBINING GRANTHA DIGIT SIX;Mn;230;NSM;;;;;N;;;;;
11370;COMBINING GRANTHA LETTER A;Mn;230;NSM;;;;;N;;;;;
11371;COMBINING GRANTHA LETTER KA;Mn;230;NSM;;;;;N;;;;;
11372;COMBINING GRANTHA LETTER NA;Mn;230;NSM;;;;;N;;;;;
11373;COMBINING GRANTHA LETTER VI;Mn;230;NSM;;;;;N;;;;;
11374;COMBINING GRANTHA LETTER PA;Mn;230;NSM;;;;;N;;;;;
11400;NEWA LETTER A;Lo;0;L;;;;;N;;;;;
11401;NEWA LETTER AA;Lo;0;L;;;;;N;;;;;
11402;NEWA LETTER I;Lo;0;L;;;;;N;;;;;
11403;NEWA LETTER II;Lo;0;L;;;;;N;;;;;
11404;NEWA LETTER U;Lo;0;L;;;;;N;;;;;
11405;NEWA LETTER UU;Lo;0;L;;;;;N;;;;;
11406;NEWA LETTER VOCALIC R;Lo;0;L;;;;;N;;;;;
11407;NEWA LETTER VOCALIC RR;Lo;0;L;;;;;N;;;;;
11408;NEWA LETTER VOCALIC L;Lo;0;L;;;;;N;;;;;
11409;NEWA LETTER VOCALIC LL;Lo;0;L;;;;;N;;;;;
1140A;NEWA LETTER E;Lo;0;L;;;;;N;;;;;
1140B;NEWA LETTER AI;Lo;0;L;;;;;N;;;;;
1140C;NEWA LETTER O;Lo;0;L;;;;;N;;;;;
1140D;NEWA LETTER AU;Lo;0;L;;;;;N;;;;;
1140E;NEWA LETTER KA;Lo;0;L;;;;;N;;;;;
1140F;NEWA LETTER KHA;Lo;0;L;;;;;N;;;;;
11410;NEWA LETTER GA;Lo;0;L;;;;;N;;;;;
11411;NEWA LETTER GHA;Lo;0;L;;;;;N;;;;;
11412;NEWA LETTER NGA;Lo;0;L;;;;;N;;;;;
11413;NEWA LETTER NGHA;Lo;0;L;;;;;N;;;;;
11414;NEWA LETTER CA;Lo;0;L;;;;;N;;;;;
11415;NEWA LETTER CHA;Lo;0;L;;;;;N;;;;;
11416;NEWA LETTER JA;Lo;0;L;;;;;N;;;;;
11417;NEWA LETTER JHA;Lo;0;L;;;;;N;;;;;
11418;NEWA LETTER NYA;Lo;0;L;;;;;N;;;;;
11419;NEWA LETTER NYHA;Lo;0;L;;;;;N;;;;;
1141A;NEWA LETTER TTA;Lo;0;L;;;;;N;;;;;
1141B;NEWA LETTER TTHA;Lo;0;L;;;;;N;;;;;
1141C;NEWA LETTER DDA;Lo;0;L;;;;;N;;;;;
1141D;NEWA LETTER DDHA;Lo;0;L;;;;;N;;;;;
1141E;NEWA LETTER NNA;Lo;0;L;;;;;N;;;;;
1141F;NEWA LETTER TA;Lo;0;L;;;;;N;;;;;
11420;NEWA LETTER THA;Lo;0;L;;;;;N;;;;;
11421;NEWA LETTER DA;Lo;0;L;;;;;N;;;;;
11422;NEWA LETTER DHA;Lo;0;L;;;;;N;;;;;
11423;NEWA LETTER NA;Lo;0;L;;;;;N;;;;;
11424;NEWA LETTER NHA;Lo;0;L;;;;;N;;;;;
11425;NEWA LETTER PA;Lo;0;L;;;;;N;;;;;
11426;NEWA LETTER PHA;Lo;0;L;;;;;N;;;;;
11427;NEWA LETTER BA;Lo;0;L;;;;;N;;;;;
11428;NEWA LETTER BHA;Lo;0;L;;;;;N;;;;;
11429;NEWA LETTER MA;Lo;0;L;;;;;N;;;;;
1142A;NEWA LETTER MHA;Lo;0;L;;;;;N;;;;;
1142B;NEWA LETTER YA;Lo;0;L;;;;;N;;;;;
1142C;NEWA LETTER RA;Lo;0;L;;;;;N;;;;;
1142D;NEWA LETTER RHA;Lo;0;L;;;;;N;;;;;
1142E;NEWA LETTER LA;Lo;0;L;;;;;N;;;;;
1142F;NEWA LETTER LHA;Lo;0;L;;;;;N;;;;;
11430;NEWA LETTER WA;Lo;0;L;;;;;N;;;;;
11431;NEWA LETTER SHA;Lo;0;L;;;;;N;;;;;
11432;NEWA LETTER SSA;Lo;0;L;;;;;N;;;;;
11433;NEWA LETTER SA;Lo;0;L;;;;;N;;;;;
11434;NEWA LETTER HA;Lo;0;L;;;;;N;;;;;
11435;NEWA VOWEL SIGN AA;Mc;0;L;;;;;N;;;;;
11436;NEWA VOWEL SIGN I;Mc;0;L;;;;;N;;;;;
11437;NEWA VOWEL SIGN II;Mc;0;L;;;;;N;;;;;
11438;NEWA VOWEL SIGN U;Mn;0;NSM;;;;;N;;;;;
11439;NEWA VOWEL SIGN UU;Mn;0;NSM;;;;;N;;;;;
1143A;NEWA VOWEL SIGN VOCALIC R;Mn;0;NSM;;;;;N;;;;;
1143B;NEWA VOWEL SIGN VOCALIC RR;Mn;0;NSM;;;;;N;;;;;
1143C;NEWA VOWEL SIGN VOCALIC L;Mn;0;NSM;;;;;N;;;;;
1143D;NEWA VOWEL SIGN VOCALIC LL;Mn;0;NSM;;;;;N;;;;;
1143E;NEWA VOWEL SIGN E;Mn;0;NSM;;;;;N;;;;;
1143F;NEWA VOWEL SIGN AI;Mn;0;NSM;;;;;N;;;;;
11440;NEWA VOWEL SIGN O;Mc;0;L;;;;;N;;;;;
11441;NEWA VOWEL SIGN AU;Mc;0;L;;;;;N;;;;;
11442;NEWA SIGN VIRAMA;Mn;9;NSM;;;;;N;;;;;
11443;NEWA SIGN CANDRABINDU;Mn;0;NSM;;;;;N;;;;;
11444;NEWA SIGN ANUSVARA;Mn;0;NSM;;;;;N;;;;;
11445;NEWA SIGN VISARGA;Mc;0;L;;;;;N;;;;;
11446;NEWA SIGN NUKTA;Mn;7;NSM;;;;;N;;;;;
11447;NEWA SIGN AVAGRAHA;Lo;0;L;;;;;N;;;;;
11448;NEWA SIGN FINAL ANUSVARA;Lo;0;L;;;;;N;;;;;
11449;NEWA OM;Lo;0;L;;;;;N;;;;;
1144A;NEWA SIDDHI;Lo;0;L;;;;;N;;;;;
1144B;NEWA DANDA;Po;0;L;;;;;N;;;;;
1144C;NEWA DOUBLE DANDA;Po;0;L;;;;;N;;;;;
1144D;NEWA COMMA;Po;0;L;;;;;N;;;;;
1144E;NEWA GAP FILLER;Po;0;L;;;;;N;;;;;
1144F;NEWA ABBREVIATION SIGN;Po;0;L;;;;;N;;;;;
11450;NEWA DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
11451;NEWA DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
11452;NEWA DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
11453;NEWA DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
11454;NEWA DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
11455;NEWA DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
11456;NEWA DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
11457;NEWA DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
11458;NEWA DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
11459;NEWA DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
1145A;NEWA DOUBLE COMMA;Po;0;L;;;;;N;;;;;
1145B;NEWA PLACEHOLDER MARK;Po;0;L;;;;;N;;;;;
1145D;NEWA INSERTION SIGN;Po;0;L;;;;;N;;;;;
1145E;NEWA SANDHI MARK;Mn;230;NSM;;;;;N;;;;;
1145F;NEWA LETTER VEDIC ANUSVARA;Lo;0;L;;;;;N;;;;;
11460;NEWA SIGN JIHVAMULIYA;Lo;0;L;;;;;N;;;;;
11461;NEWA SIGN UPADHMANIYA;Lo;0;L;;;;;N;;;;;
11480;TIRHUTA ANJI;Lo;0;L;;;;;N;;;;;
11481;TIRHUTA LETTER A;Lo;0;L;;;;;N;;;;;
11482;TIRHUTA LETTER AA;Lo;0;L;;;;;N;;;;;
11483;TIRHUTA LETTER I;Lo;0;L;;;;;N;;;;;
11484;TIRHUTA LETTER II;Lo;0;L;;;;;N;;;;;
11485;TIRHUTA LETTER U;Lo;0;L;;;;;N;;;;;
11486;TIRHUTA LETTER UU;Lo;0;L;;;;;N;;;;;
11487;TIRHUTA LETTER VOCALIC R;Lo;0;L;;;;;N;;;;;
11488;TIRHUTA LETTER VOCALIC RR;Lo;0;L;;;;;N;;;;;
11489;TIRHUTA LETTER VOCALIC L;Lo;0;L;;;;;N;;;;;
1148A;TIRHUTA LETTER VOCALIC LL;Lo;0;L;;;;;N;;;;;
1148B;TIRHUTA LETTER E;Lo;0;L;;;;;N;;;;;
1148C;TIRHUTA LETTER AI;Lo;0;L;;;;;N;;;;;
1148D;TIRHUTA LETTER O;Lo;0;L;;;;;N;;;;;
1148E;TIRHUTA LETTER AU;Lo;0;L;;;;;N;;;;;
1148F;TIRHUTA LETTER KA;Lo;0;L;;;;;N;;;;;
11490;TIRHUTA LETTER KHA;Lo;0;L;;;;;N;;;;;
11491;TIRHUTA LETTER GA;Lo;0;L;;;;;N;;;;;
11492;TIRHUTA LETTER GHA;Lo;0;L;;;;;N;;;;;
11493;TIRHUTA LETTER NGA;Lo;0;L;;;;;N;;;;;
11494;TIRHUTA LETTER CA;Lo;0;L;;;;;N;;;;;
11495;TIRHUTA LETTER CHA;Lo;0;L;;;;;N;;;;;
11496;TIRHUTA LETTER JA;Lo;0;L;;;;;N;;;;;
11497;TIRHUTA LETTER JHA;Lo;0;L;;;;;N;;;;;
11498;TIRHUTA LETTER NYA;Lo;0;L;;;;;N;;;;;
11499;TIRHUTA LETTER TTA;Lo;0;L;;;;;N;;;;;
1149A;TIRHUTA LETTER TTHA;Lo;0;L;;;;;N;;;;;
1149B;TIRHUTA LETTER DDA;Lo;0;L;;;;;N;;;;;
1149C;TIRHUTA LETTER DDHA;Lo;0;L;;;;;N;;;;;
1149D;TIRHUTA LETTER NNA;Lo;0;L;;;;;N;;;;;
1149E;TIRHUTA LETTER TA;Lo;0;L;;;;;N;;;;;
1149F;TIRHUTA LETTER THA;Lo;0;L;;;;;N;;;;;
114A0;TIRHUTA LETTER DA;Lo;0;L;;;;;N;;;;;
114A1;TIRHUTA LETTER DHA;Lo;0;L;;;;;N;;;;;
114A2;TIRHUTA LETTER NA;Lo;0;L;;;;;N;;;;;
114A3;TIRHUTA LETTER PA;Lo;0;L;;;;;N;;;;;
114A4;TIRHUTA LETTER PHA;Lo;0;L;;;;;N;;;;;
114A5;TIRHUTA LETTER BA;Lo;0;L;;;;;N;;;;;
114A6;TIRHUTA LETTER BHA;Lo;0;L;;;;;N;;;;;
114A7;TIRHUTA LETTER MA;Lo;0;L;;;;;N;;;;;
114A8;TIRHUTA LETTER YA;Lo;0;L;;;;;N;;;;;
114A9;TIRHUTA LETTER RA;Lo;0;L;;;;;N;;;;;
114AA;TIRHUTA LETTER LA;Lo;0;L;;;;;N;;;;;
114AB;TIRHUTA LETTER VA;Lo;0;L;;;;;N;;;;;
114AC;TIRHUTA LETTER SHA;Lo;0;L;;;;;N;;;;;
114AD;TIRHUTA LETTER SSA;Lo;0;L;;;;;N;;;;;
114AE;TIRHUTA LETTER SA;Lo;0;L;;;;;N;;;;;
114AF;TIRHUTA LETTER HA;Lo;0;L;;;;;N;;;;;
114B0;TIRHUTA VOWEL SIGN AA;Mc;0;L;;;;;N;;;;;
114B1;TIRHUTA VOWEL SIGN I;Mc;0;L;;;;;N;;;;;
114B2;TIRHUTA VOWEL SIGN II;Mc;0;L;;;;;N;;;;;
114B3;TIRHUTA VOWEL SIGN U;Mn;0;NSM;;;;;N;;;;;
114B4;TIRHUTA VOWEL SIGN UU;Mn;0;NSM;;;;;N;;;;;
114B5;TIRHUTA VOWEL SIGN VOCALIC R;Mn;0;NSM;;;;;N;;;;;
114B6;TIRHUTA VOWEL SIGN VOCALIC RR;Mn;0;NSM;;;;;N;;;;;
114B7;TIRHUTA VOWEL SIGN VOCALIC L;Mn;0;NSM;;;;;N;;;;;
114B8;TIRHUTA VOWEL SIGN VOCALIC LL;Mn;0;NSM;;;;;N;;;;;
114B9;TIRHUTA VOWEL SIGN E;Mc;0;L;;;;;N;;;;;
114BA;TIRHUTA VOWEL SIGN SHORT E;Mn;0;NSM;;;;;N;;;;;
114BB;TIRHUTA VOWEL SIGN AI;Mc;0;L;114B9 114BA;;;;N;;;;;
114BC;TIRHUTA VOWEL SIGN O;Mc;0;L;114B9 114B0;;;;N;;;;;
114BD;TIRHUTA VOWEL SIGN SHORT O;Mc;0;L;;;;;N;;;;;
114BE;TIRHUTA VOWEL SIGN AU;Mc;0;L;114B9 114BD;;;;N;;;;;
114BF;TIRHUTA SIGN CANDRABINDU;Mn;0;NSM;;;;;N;;;;;
114C0;TIRHUTA SIGN ANUSVARA;Mn;0;NSM;;;;;N;;;;;
114C1;TIRHUTA SIGN VISARGA;Mc;0;L;;;;;N;;;;;
114C2;TIRHUTA SIGN VIRAMA;Mn;9;NSM;;;;;N;;;;;
114C3;TIRHUTA SIGN NUKTA;Mn;7;NSM;;;;;N;;;;;
114C4;TIRHUTA SIGN AVAGRAHA;Lo;0;L;;;;;N;;;;;
114C5;TIRHUTA GVANG;Lo;0;L;;;;;N;;;;;
114C6;TIRHUTA ABBREVIATION SIGN;Po;0;L;;;;;N;;;;;
114C7;TIRHUTA OM;Lo;0;L;;;;;N;;;;;
114D0;TIRHUTA DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
114D1;TIRHUTA DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
114D2;TIRHUTA DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
114D3;TIRHUTA DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
114D4;TIRHUTA DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
114D5;TIRHUTA DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
114D6;TIRHUTA DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
114D7;TIRHUTA DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
114D8;TIRHUTA DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
114D9;TIRHUTA DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
11580;SIDDHAM LETTER A;Lo;0;L;;;;;N;;;;;
11581;SIDDHAM LETTER AA;Lo;0;L;;;;;N;;;;;
11582;SIDDHAM LETTER I;Lo;0;L;;;;;N;;;;;
11583;SIDDHAM LETTER II;Lo;0;L;;;;;N;;;;;
11584;SIDDHAM LETTER U;Lo;0;L;;;;;N;;;;;
11585;SIDDHAM LETTER UU;Lo;0;L;;;;;N;;;;;
11586;SIDDHAM LETTER VOCALIC R;Lo;0;L;;;;;N;;;;;
11587;SIDDHAM LETTER VOCALIC RR;Lo;0;L;;;;;N;;;;;
11588;SIDDHAM LETTER VOCALIC L;Lo;0;L;;;;;N;;;;;
11589;SIDDHAM LETTER VOCALIC LL;Lo;0;L;;;;;N;;;;;
1158A;SIDDHAM LETTER E;Lo;0;L;;;;;N;;;;;
1158B;SIDDHAM LETTER AI;Lo;0;L;;;;;N;;;;;
1158C;SIDDHAM LETTER O;Lo;0;L;;;;;N;;;;;
1158D;SIDDHAM LETTER AU;Lo;0;L;;;;;N;;;;;
1158E;SIDDHAM LETTER KA;Lo;0;L;;;;;N;;;;;
1158F;SIDDHAM LETTER KHA;Lo;0;L;;;;;N;;;;;
11590;SIDDHAM LETTER GA;Lo;0;L;;;;;N;;;;;
11591;SIDDHAM LETTER GHA;Lo;0;L;;;;;N;;;;;
11592;SIDDHAM LETTER NGA;Lo;0;L;;;;;N;;;;;
11593;SIDDHAM LETTER CA;Lo;0;L;;;;;N;;;;;
11594;SIDDHAM LETTER CHA;Lo;0;L;;;;;N;;;;;
11595;SIDDHAM LETTER JA;Lo;0;L;;;;;N;;;;;
11596;SIDDHAM LETTER JHA;Lo;0;L;;;;;N;;;;;
11597;SIDDHAM LETTER NYA;Lo;0;L;;;;;N;;;;;
11598;SIDDHAM LETTER TTA;Lo;0;L;;;;;N;;;;;
11599;SIDDHAM LETTER TTHA;Lo;0;L;;;;;N;;;;;
1159A;SIDDHAM LETTER DDA;Lo;0;L;;;;;N;;;;;
1159B;SIDDHAM LETTER DDHA;Lo;0;L;;;;;N;;;;;
1159C;SIDDHAM LETTER NNA;Lo;0;L;;;;;N;;;;;
1159D;SIDDHAM LETTER TA;Lo;0;L;;;;;N;;;;;
1159E;SIDDHAM LETTER THA;Lo;0;L;;;;;N;;;;;
1159F;SIDDHAM LETTER DA;Lo;0;L;;;;;N;;;;;
115A0;SIDDHAM LETTER DHA;Lo;0;L;;;;;N;;;;;
115A1;SIDDHAM LETTER NA;Lo;0;L;;;;;N;;;;;
115A2;SIDDHAM LETTER PA;Lo;0;L;;;;;N;;;;;
115A3;SIDDHAM LETTER PHA;Lo;0;L;;;;;N;;;;;
115A4;SIDDHAM LETTER BA;Lo;0;L;;;;;N;;;;;
115A5;SIDDHAM LETTER BHA;Lo;0;L;;;;;N;;;;;
115A6;SIDDHAM LETTER MA;Lo;0;L;;;;;N;;;;;
115A7;SIDDHAM LETTER YA;Lo;0;L;;;;;N;;;;;
115A8;SIDDHAM LETTER RA;Lo;0;L;;;;;N;;;;;
115A9;SIDDHAM LETTER LA;Lo;0;L;;;;;N;;;;;
115AA;SIDDHAM LETTER VA;Lo;0;L;;;;;N;;;;;
115AB;SIDDHAM LETTER SHA;Lo;0;L;;;;;N;;;;;
115AC;SIDDHAM LETTER SSA;Lo;0;L;;;;;N;;;;;
115AD;SIDDHAM LETTER SA;Lo;0;L;;;;;N;;;;;
115AE;SIDDHAM LETTER HA;Lo;0;L;;;;;N;;;;;
115AF;SIDDHAM VOWEL SIGN AA;Mc;0;L;;;;;N;;;;;
115B0;SIDDHAM VOWEL SIGN I;Mc;0;L;;;;;N;;;;;
115B1;SIDDHAM VOWEL SIGN II;Mc;0;L;;;;;N;;;;;
115B2;SIDDHAM VOWEL SIGN U;Mn;0;NSM;;;;;N;;;;;
115B3;SIDDHAM VOWEL SIGN UU;Mn;0;NSM;;;;;N;;;;;
115B4;SIDDHAM VOWEL SIGN VOCALIC R;Mn;0;NSM;;;;;N;;;;;
115B5;SIDDHAM VOWEL SIGN VOCALIC RR;Mn;0;NSM;;;;;N;;;;;
115B8;SIDDHAM VOWEL SIGN E;Mc;0;L;;;;;N;;;;;
115B9;SIDDHAM VOWEL SIGN AI;Mc;0;L;;;;;N;;;;;
115BA;SIDDHAM VOWEL SIGN O;Mc;0;L;115B8 115AF;;;;N;;;;;
115BB;SIDDHAM VOWEL SIGN AU;Mc;0;L;115B9 115AF;;;;N;;;;;
115BC;SIDDHAM SIGN CANDRABINDU;Mn;0;NSM;;;;;N;;;;;
115BD;SIDDHAM SIGN ANUSVARA;Mn;0;NSM;;;;;N;;;;;
115BE;SIDDHAM SIGN VISARGA;Mc;0;L;;;;;N;;;;;
115BF;SIDDHAM SIGN VIRAMA;Mn;9;NSM;;;;;N;;;;;
115C0;SIDDHAM SIGN NUKTA;Mn;7;NSM;;;;;N;;;;;
115C1;SIDDHAM SIGN SIDDHAM;Po;0;L;;;;;N;;;;;
115C2;SIDDHAM DANDA;Po;0;L;;;;;N;;;;;
115C3;SIDDHAM DOUBLE DANDA;Po;0;L;;;;;N;;;;;
115C4;SIDDHAM SEPARATOR DOT;Po;0;L;;;;;N;;;;;
115C5;SIDDHAM SEPARATOR BAR;Po;0;L;;;;;N;;;;;
115C6;SIDDHAM REPETITION MARK-1;Po;0;L;;;;;N;;;;;
115C7;SIDDHAM REPETITION MARK-2;Po;0;L;;;;;N;;;;;
115C8;SIDDHAM REPETITION MARK-3;Po;0;L;;;;;N;;;;;
115C9;SIDDHAM END OF TEXT MARK;Po;0;L;;;;;N;;;;;
115CA;SIDDHAM SECTION MARK WITH TRIDENT AND U-SHAPED ORNAMENTS;Po;0;L;;;;;N;;;;;
115CB;SIDDHAM SECTION MARK WITH TRIDENT AND DOTTED CRESCENTS;Po;0;L;;;;;N;;;;;
115CC;SIDDHAM SECTION MARK WITH RAYS AND DOTTED CRESCENTS;Po;0;L;;;;;N;;;;;
115CD;SIDDHAM SECTION MARK WITH RAYS AND DOTTED DOUBLE CRESCENTS;Po;0;L;;;;;N;;;;;
115CE;SIDDHAM SECTION MARK WITH RAYS AND DOTTED TRIPLE CRESCENTS;Po;0;L;;;;;N;;;;;
115CF;SIDDHAM SECTION MARK DOUBLE RING;Po;0;L;;;;;N;;;;;
115D0;SIDDHAM SECTION MARK DOUBLE RING WITH RAYS;Po;0;L;;;;;N;;;;;
115D1;SIDDHAM SECTION MARK WITH DOUBLE CRESCENTS;Po;0;L;;;;;N;;;;;
115D2;SIDDHAM SECTION MARK WITH TRIPLE CRESCENTS;Po;0;L;;;;;N;;;;;
115D3;SIDDHAM SECTION MARK WITH QUADRUPLE CRESCENTS;Po;0;L;;;;;N;;;;;
115D4;SIDDHAM SECTION MARK WITH SEPTUPLE CRESCENTS;Po;0;L;;;;;N;;;;;
115D5;SIDDHAM SECTION MARK WITH CIRCLES AND RAYS;Po;0;L;;;;;N;;;;;
115D6;SIDDHAM SECTION MARK WITH CIRCLES AND TWO ENCLOSURES;Po;0;L;;;;;N;;;;;
115D7;SIDDHAM SECTION MARK WITH CIRCLES AND FOUR ENCLOSURES;Po;0;L;;;;;N;;;;;
115D8;SIDDHAM LETTER THREE-CIRCLE ALTERNATE I;Lo;0;L;;;;;N;;;;;
115D9;SIDDHAM LETTER TWO-CIRCLE ALTERNATE I;Lo;0;L;;;;;N;;;;;
115DA;SIDDHAM LETTER TWO-CIRCLE ALTERNATE II;Lo;0;L;;;;;N;;;;;
115DB;SIDDHAM LETTER ALTERNATE U;Lo;0;L;;;;;N;;;;;
115DC;SIDDHAM VOWEL SIGN ALTERNATE U;Mn;0;NSM;;;;;N;;;;;
115DD;SIDDHAM VOWEL SIGN ALTERNATE UU;Mn;0;NSM;;;;;N;;;;;
11600;MODI LETTER A;Lo;0;L;;;;;N;;;;;
11601;MODI LETTER AA;Lo;0;L;;;;;N;;;;;
11602;MODI LETTER I;Lo;0;L;;;;;N;;;;;
11603;MODI LETTER II;Lo;0;L;;;;;N;;;;;
11604;MODI LETTER U;Lo;0;L;;;;;N;;;;;
11605;MODI LETTER UU;Lo;0;L;;;;;N;;;;;
11606;MODI LETTER VOCALIC R;Lo;0;L;;;;;N;;;;;
11607;MODI LETTER VOCALIC RR;Lo;0;L;;;;;N;;;;;
11608;MODI LETTER VOCALIC L;Lo;0;L;;;;;N;;;;;
11609;MODI LETTER VOCALIC LL;Lo;0;L;;;;;N;;;;;
1160A;MODI LETTER E;Lo;0;L;;;;;N;;;;;
1160B;MODI LETTER AI;Lo;0;L;;;;;N;;;;;
1160C;MODI LETTER O;Lo;0;L;;;;;N;;;;;
1160D;MODI LETTER AU;Lo;0;L;;;;;N;;;;;
1160E;MODI LETTER KA;Lo;0;L;;;;;N;;;;;
1160F;MODI LETTER KHA;Lo;0;L;;;;;N;;;;;
11610;MODI LETTER GA;Lo;0;L;;;;;N;;;;;
11611;MODI LETTER GHA;Lo;0;L;;;;;N;;;;;
11612;MODI LETTER NGA;Lo;0;L;;;;;N;;;;;
11613;MODI LETTER CA;Lo;0;L;;;;;N;;;;;
11614;MODI LETTER CHA;Lo;0;L;;;;;N;;;;;
11615;MODI LETTER JA;Lo;0;L;;;;;N;;;;;
11616;MODI LETTER JHA;Lo;0;L;;;;;N;;;;;
11617;MODI LETTER NYA;Lo;0;L;;;;;N;;;;;
11618;MODI LETTER TTA;Lo;0;L;;;;;N;;;;;
11619;MODI LETTER TTHA;Lo;0;L;;;;;N;;;;;
1161A;MODI LETTER DDA;Lo;0;L;;;;;N;;;;;
1161B;MODI LETTER DDHA;Lo;0;L;;;;;N;;;;;
1161C;MODI LETTER NNA;Lo;0;L;;;;;N;;;;;
1161D;MODI LETTER TA;Lo;0;L;;;;;N;;;;;
1161E;MODI LETTER THA;Lo;0;L;;;;;N;;;;;
1161F;MODI LETTER DA;Lo;0;L;;;;;N;;;;;
11620;MODI LETTER DHA;Lo;0;L;;;;;N;;;;;
11621;MODI LETTER NA;Lo;0;L;;;;;N;;;;;
11622;MODI LETTER PA;Lo;0;L;;;;;N;;;;;
11623;MODI LETTER PHA;Lo;0;L;;;;;N;;;;;
11624;MODI LETTER BA;Lo;0;L;;;;;N;;;;;
11625;MODI LETTER BHA;Lo;0;L;;;;;N;;;;;
11626;MODI LETTER MA;Lo;0;L;;;;;N;;;;;
11627;MODI LETTER YA;Lo;0;L;;;;;N;;;;;
11628;MODI LETTER RA;Lo;0;L;;;;;N;;;;;
11629;MODI LETTER LA;Lo;0;L;;;;;N;;;;;
1162A;MODI LETTER VA;Lo;0;L;;;;;N;;;;;
1162B;MODI LETTER SHA;Lo;0;L;;;;;N;;;;;
1162C;MODI LETTER SSA;Lo;0;L;;;;;N;;;;;
1162D;MODI LETTER SA;Lo;0;L;;;;;N;;;;;
1162E;MODI LETTER HA;Lo;0;L;;;;;N;;;;;
1162F;MODI LETTER LLA;Lo;0;L;;;;;N;;;;;
11630;MODI VOWEL SIGN AA;Mc;0;L;;;;;N;;;;;
11631;MODI VOWEL SIGN I;Mc;0;L;;;;;N;;;;;
11632;MODI VOWEL SIGN II;Mc;0;L;;;;;N;;;;;
11633;MODI VOWEL SIGN U;Mn;0;NSM;;;;;N;;;;;
11634;MODI VOWEL SIGN UU;Mn;0;NSM;;;;;N;;;;;
11635;MODI VOWEL SIGN VOCALIC R;Mn;0;NSM;;;;;N;;;;;
11636;MODI VOWEL SIGN VOCALIC RR;Mn;0;NSM;;;;;N;;;;;
11637;MODI VOWEL SIGN VOCALIC L;Mn;0;NSM;;;;;N;;;;;
11638;MODI VOWEL SIGN VOCALIC LL;Mn;0;NSM;;;;;N;;;;;
11639;MODI VOWEL SIGN E;Mn;0;NSM;;;;;N;;;;;
1163A;MODI VOWEL SIGN AI;Mn;0;NSM;;;;;N;;;;;
1163B;MODI VOWEL SIGN O;Mc;0;L;;;;;N;;;;;
1163C;MODI VOWEL SIGN AU;Mc;0;L;;;;;N;;;;;
1163D;MODI SIGN ANUSVARA;Mn;0;NSM;;;;;N;;;;;
1163E;MODI SIGN VISARGA;Mc;0;L;;;;;N;;;;;
1163F;MODI SIGN VIRAMA;Mn;9;NSM;;;;;N;;;;;
11640;MODI SIGN ARDHACANDRA;Mn;0;NSM;;;;;N;;;;;
11641;MODI DANDA;Po;0;L;;;;;N;;;;;
11642;MODI DOUBLE DANDA;Po;0;L;;;;;N;;;;;
11643;MODI ABBREVIATION SIGN;Po;0;L;;;;;N;;;;;
11644;MODI SIGN HUVA;Lo;0;L;;;;;N;;;;;
11650;MODI DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
11651;MODI DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
11652;MODI DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
11653;MODI DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
11654;MODI DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
11655;MODI DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
11656;MODI DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
11657;MODI DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
11658;MODI DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
11659;MODI DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
11660;MONGOLIAN BIRGA WITH ORNAMENT;Po;0;ON;;;;;N;;;;;
11661;MONGOLIAN ROTATED BIRGA;Po;0;ON;;;;;N;;;;;
11662;MONGOLIAN DOUBLE BIRGA WITH ORNAMENT;Po;0;ON;;;;;N;;;;;
11663;MONGOLIAN TRIPLE BIRGA WITH ORNAMENT;Po;0;ON;;;;;N;;;;;
11664;MONGOLIAN BIRGA WITH DOUBLE ORNAMENT;Po;0;ON;;;;;N;;;;;
11665;MONGOLIAN ROTATED BIRGA WITH ORNAMENT;Po;0;ON;;;;;N;;;;;
11666;MONGOLIAN ROTATED BIRGA WITH DOUBLE ORNAMENT;Po;0;ON;;;;;N;;;;;
11667;MONGOLIAN INVERTED BIRGA;Po;0;ON;;;;;N;;;;;
11668;MONGOLIAN INVERTED BIRGA WITH DOUBLE ORNAMENT;Po;0;ON;;;;;N;;;;;
11669;MONGOLIAN SWIRL BIRGA;Po;0;ON;;;;;N;;;;;
1166A;MONGOLIAN SWIRL BIRGA WITH ORNAMENT;Po;0;ON;;;;;N;;;;;
1166B;MONGOLIAN SWIRL BIRGA WITH DOUBLE ORNAMENT;Po;0;ON;;;;;N;;;;;
1166C;MONGOLIAN TURNED SWIRL BIRGA WITH DOUBLE ORNAMENT;Po;0;ON;;;;;N;;;;;
11680;TAKRI LETTER A;Lo;0;L;;;;;N;;;;;
11681;TAKRI LETTER AA;Lo;0;L;;;;;N;;;;;
11682;TAKRI LETTER I;Lo;0;L;;;;;N;;;;;
11683;TAKRI LETTER II;Lo;0;L;;;;;N;;;;;
11684;TAKRI LETTER U;Lo;0;L;;;;;N;;;;;
11685;TAKRI LETTER UU;Lo;0;L;;;;;N;;;;;
11686;TAKRI LETTER E;Lo;0;L;;;;;N;;;;;
11687;TAKRI LETTER AI;Lo;0;L;;;;;N;;;;;
11688;TAKRI LETTER O;Lo;0;L;;;;;N;;;;;
11689;TAKRI LETTER AU;Lo;0;L;;;;;N;;;;;
1168A;TAKRI LETTER KA;Lo;0;L;;;;;N;;;;;
1168B;TAKRI LETTER KHA;Lo;0;L;;;;;N;;;;;
1168C;TAKRI LETTER GA;Lo;0;L;;;;;N;;;;;
1168D;TAKRI LETTER GHA;Lo;0;L;;;;;N;;;;;
1168E;TAKRI LETTER NGA;Lo;0;L;;;;;N;;;;;
1168F;TAKRI LETTER CA;Lo;0;L;;;;;N;;;;;
11690;TAKRI LETTER CHA;Lo;0;L;;;;;N;;;;;
11691;TAKRI LETTER JA;Lo;0;L;;;;;N;;;;;
11692;TAKRI LETTER JHA;Lo;0;L;;;;;N;;;;;
11693;TAKRI LETTER NYA;Lo;0;L;;;;;N;;;;;
11694;TAKRI LETTER TTA;Lo;0;L;;;;;N;;;;;
11695;TAKRI LETTER TTHA;Lo;0;L;;;;;N;;;;;
11696;TAKRI LETTER DDA;Lo;0;L;;;;;N;;;;;
11697;TAKRI LETTER DDHA;Lo;0;L;;;;;N;;;;;
11698;TAKRI LETTER NNA;Lo;0;L;;;;;N;;;;;
11699;TAKRI LETTER TA;Lo;0;L;;;;;N;;;;;
1169A;TAKRI LETTER THA;Lo;0;L;;;;;N;;;;;
1169B;TAKRI LETTER DA;Lo;0;L;;;;;N;;;;;
1169C;TAKRI LETTER DHA;Lo;0;L;;;;;N;;;;;
1169D;TAKRI LETTER NA;Lo;0;L;;;;;N;;;;;
1169E;TAKRI LETTER PA;Lo;0;L;;;;;N;;;;;
1169F;TAKRI LETTER PHA;Lo;0;L;;;;;N;;;;;
116A0;TAKRI LETTER BA;Lo;0;L;;;;;N;;;;;
116A1;TAKRI LETTER BHA;Lo;0;L;;;;;N;;;;;
116A2;TAKRI LETTER MA;Lo;0;L;;;;;N;;;;;
116A3;TAKRI LETTER YA;Lo;0;L;;;;;N;;;;;
116A4;TAKRI LETTER RA;Lo;0;L;;;;;N;;;;;
116A5;TAKRI LETTER LA;Lo;0;L;;;;;N;;;;;
116A6;TAKRI LETTER VA;Lo;0;L;;;;;N;;;;;
116A7;TAKRI LETTER SHA;Lo;0;L;;;;;N;;;;;
116A8;TAKRI LETTER SA;Lo;0;L;;;;;N;;;;;
116A9;TAKRI LETTER HA;Lo;0;L;;;;;N;;;;;
116AA;TAKRI LETTER RRA;Lo;0;L;;;;;N;;;;;
116AB;TAKRI SIGN ANUSVARA;Mn;0;NSM;;;;;N;;;;;
116AC;TAKRI SIGN VISARGA;Mc;0;L;;;;;N;;;;;
116AD;TAKRI VOWEL SIGN AA;Mn;0;NSM;;;;;N;;;;;
116AE;TAKRI VOWEL SIGN I;Mc;0;L;;;;;N;;;;;
116AF;TAKRI VOWEL SIGN II;Mc;0;L;;;;;N;;;;;
116B0;TAKRI VOWEL SIGN U;Mn;0;NSM;;;;;N;;;;;
116B1;TAKRI VOWEL SIGN UU;Mn;0;NSM;;;;;N;;;;;
116B2;TAKRI VOWEL SIGN E;Mn;0;NSM;;;;;N;;;;;
116B3;TAKRI VOWEL SIGN AI;Mn;0;NSM;;;;;N;;;;;
116B4;TAKRI VOWEL SIGN O;Mn;0;NSM;;;;;N;;;;;
116B5;TAKRI VOWEL SIGN AU;Mn;0;NSM;;;;;N;;;;;
116B6;TAKRI SIGN VIRAMA;Mc;9;L;;;;;N;;;;;
116B7;TAKRI SIGN NUKTA;Mn;7;NSM;;;;;N;;;;;
116B8;TAKRI LETTER ARCHAIC KHA;Lo;0;L;;;;;N;;;;;
116B9;TAKRI ABBREVIATION SIGN;Po;0;L;;;;;N;;;;;
116C0;TAKRI DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
116C1;TAKRI DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
116C2;TAKRI DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
116C3;TAKRI DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
116C4;TAKRI DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
116C5;TAKRI DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
116C6;TAKRI DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
116C7;TAKRI DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
116C8;TAKRI DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
116C9;TAKRI DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
11700;AHOM LETTER KA;Lo;0;L;;;;;N;;;;;
11701;AHOM LETTER KHA;Lo;0;L;;;;;N;;;;;
11702;AHOM LETTER NGA;Lo;0;L;;;;;N;;;;;
11703;AHOM LETTER NA;Lo;0;L;;;;;N;;;;;
11704;AHOM LETTER TA;Lo;0;L;;;;;N;;;;;
11705;AHOM LETTER ALTERNATE TA;Lo;0;L;;;;;N;;;;;
11706;AHOM LETTER PA;Lo;0;L;;;;;N;;;;;
11707;AHOM LETTER PHA;Lo;0;L;;;;;N;;;;;
11708;AHOM LETTER BA;Lo;0;L;;;;;N;;;;;
11709;AHOM LETTER MA;Lo;0;L;;;;;N;;;;;
1170A;AHOM LETTER JA;Lo;0;L;;;;;N;;;;;
1170B;AHOM LETTER CHA;Lo;0;L;;;;;N;;;;;
1170C;AHOM LETTER THA;Lo;0;L;;;;;N;;;;;
1170D;AHOM LETTER RA;Lo;0;L;;;;;N;;;;;
1170E;AHOM LETTER LA;Lo;0;L;;;;;N;;;;;
1170F;AHOM LETTER SA;Lo;0;L;;;;;N;;;;;
11710;AHOM LETTER NYA;Lo;0;L;;;;;N;;;;;
11711;AHOM LETTER HA;Lo;0;L;;;;;N;;;;;
11712;AHOM LETTER A;Lo;0;L;;;;;N;;;;;
11713;AHOM LETTER DA;Lo;0;L;;;;;N;;;;;
11714;AHOM LETTER DHA;Lo;0;L;;;;;N;;;;;
11715;AHOM LETTER GA;Lo;0;L;;;;;N;;;;;
11716;AHOM LETTER ALTERNATE GA;Lo;0;L;;;;;N;;;;;
11717;AHOM LETTER GHA;Lo;0;L;;;;;N;;;;;
11718;AHOM LETTER BHA;Lo;0;L;;;;;N;;;;;
11719;AHOM LETTER JHA;Lo;0;L;;;;;N;;;;;
1171A;AHOM LETTER ALTERNATE BA;Lo;0;L;;;;;N;;;;;
1171D;AHOM CONSONANT SIGN MEDIAL LA;Mn;0;NSM;;;;;N;;;;;
1171E;AHOM CONSONANT SIGN MEDIAL RA;Mn;0;NSM;;;;;N;;;;;
1171F;AHOM CONSONANT SIGN MEDIAL LIGATING RA;Mn;0;NSM;;;;;N;;;;;
11720;AHOM VOWEL SIGN A;Mc;0;L;;;;;N;;;;;
11721;AHOM VOWEL SIGN AA;Mc;0;L;;;;;N;;;;;
11722;AHOM VOWEL SIGN I;Mn;0;NSM;;;;;N;;;;;
11723;AHOM VOWEL SIGN II;Mn;0;NSM;;;;;N;;;;;
11724;AHOM VOWEL SIGN U;Mn;0;NSM;;;;;N;;;;;
11725;AHOM VOWEL SIGN UU;Mn;0;NSM;;;;;N;;;;;
11726;AHOM VOWEL SIGN E;Mc;0;L;;;;;N;;;;;
11727;AHOM VOWEL SIGN AW;Mn;0;NSM;;;;;N;;;;;
11728;AHOM VOWEL SIGN O;Mn;0;NSM;;;;;N;;;;;
11729;AHOM VOWEL SIGN AI;Mn;0;NSM;;;;;N;;;;;
1172A;AHOM VOWEL SIGN AM;Mn;0;NSM;;;;;N;;;;;
1172B;AHOM SIGN KILLER;Mn;9;NSM;;;;;N;;;;;
11730;AHOM DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
11731;AHOM DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
11732;AHOM DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
11733;AHOM DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
11734;AHOM DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
11735;AHOM DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
11736;AHOM DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
11737;AHOM DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
11738;AHOM DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
11739;AHOM DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
1173A;AHOM NUMBER TEN;No;0;L;;;;10;N;;;;;
1173B;AHOM NUMBER TWENTY;No;0;L;;;;20;N;;;;;
1173C;AHOM SIGN SMALL SECTION;Po;0;L;;;;;N;;;;;
1173D;AHOM SIGN SECTION;Po;0;L;;;;;N;;;;;
1173E;AHOM SIGN RULAI;Po;0;L;;;;;N;;;;;
1173F;AHOM SYMBOL VI;So;0;L;;;;;N;;;;;
11740;AHOM LETTER CA;Lo;0;L;;;;;N;;;;;
11741;AHOM LETTER TTA;Lo;0;L;;;;;N;;;;;
11742;AHOM LETTER TTHA;Lo;0;L;;;;;N;;;;;
11743;AHOM LETTER DDA;Lo;0;L;;;;;N;;;;;
11744;AHOM LETTER DDHA;Lo;0;L;;;;;N;;;;;
11745;AHOM LETTER NNA;Lo;0;L;;;;;N;;;;;
11746;AHOM LETTER LLA;Lo;0;L;;;;;N;;;;;
11800;DOGRA LETTER A;Lo;0;L;;;;;N;;;;;
11801;DOGRA LETTER AA;Lo;0;L;;;;;N;;;;;
11802;DOGRA LETTER I;Lo;0;L;;;;;N;;;;;
11803;DOGRA LETTER II;Lo;0;L;;;;;N;;;;;
11804;DOGRA LETTER U;Lo;0;L;;;;;N;;;;;
11805;DOGRA LETTER UU;Lo;0;L;;;;;N;;;;;
11806;DOGRA LETTER E;Lo;0;L;;;;;N;;;;;
11807;DOGRA LETTER AI;Lo;0;L;;;;;N;;;;;
11808;DOGRA LETTER O;Lo;0;L;;;;;N;;;;;
11809;DOGRA LETTER AU;Lo;0;L;;;;;N;;;;;
1180A;DOGRA LETTER KA;Lo;0;L;;;;;N;;;;;
1180B;DOGRA LETTER KHA;Lo;0;L;;;;;N;;;;;
1180C;DOGRA LETTER GA;Lo;0;L;;;;;N;;;;;
1180D;DOGRA LETTER GHA;Lo;0;L;;;;;N;;;;;
1180E;DOGRA LETTER NGA;Lo;0;L;;;;;N;;;;;
1180F;DOGRA LETTER CA;Lo;0;L;;;;;N;;;;;
11810;DOGRA LETTER CHA;Lo;0;L;;;;;N;;;;;
11811;DOGRA LETTER JA;Lo;0;L;;;;;N;;;;;
11812;DOGRA LETTER JHA;Lo;0;L;;;;;N;;;;;
11813;DOGRA LETTER NYA;Lo;0;L;;;;;N;;;;;
11814;DOGRA LETTER TTA;Lo;0;L;;;;;N;;;;;
11815;DOGRA LETTER TTHA;Lo;0;L;;;;;N;;;;;
11816;DOGRA LETTER DDA;Lo;0;L;;;;;N;;;;;
11817;DOGRA LETTER DDHA;Lo;0;L;;;;;N;;;;;
11818;DOGRA LETTER NNA;Lo;0;L;;;;;N;;;;;
11819;DOGRA LETTER TA;Lo;0;L;;;;;N;;;;;
1181A;DOGRA LETTER THA;Lo;0;L;;;;;N;;;;;
1181B;DOGRA LETTER DA;Lo;0;L;;;;;N;;;;;
1181C;DOGRA LETTER DHA;Lo;0;L;;;;;N;;;;;
1181D;DOGRA LETTER NA;Lo;0;L;;;;;N;;;;;
1181E;DOGRA LETTER PA;Lo;0;L;;;;;N;;;;;
1181F;DOGRA LETTER PHA;Lo;0;L;;;;;N;;;;;
11820;DOGRA LETTER BA;Lo;0;L;;;;;N;;;;;
11821;DOGRA LETTER BHA;Lo;0;L;;;;;N;;;;;
11822;DOGRA LETTER MA;Lo;0;L;;;;;N;;;;;
11823;DOGRA LETTER YA;Lo;0;L;;;;;N;;;;;
11824;DOGRA LETTER RA;Lo;0;L;;;;;N;;;;;
11825;DOGRA LETTER LA;Lo;0;L;;;;;N;;;;;
11826;DOGRA LETTER VA;Lo;0;L;;;;;N;;;;;
11827;DOGRA LETTER SHA;Lo;0;L;;;;;N;;;;;
11828;DOGRA LETTER SSA;Lo;0;L;;;;;N;;;;;
11829;DOGRA LETTER SA;Lo;0;L;;;;;N;;;;;
1182A;DOGRA LETTER HA;Lo;0;L;;;;;N;;;;;
1182B;DOGRA LETTER RRA;Lo;0;L;;;;;N;;;;;
1182C;DOGRA VOWEL SIGN AA;Mc;0;L;;;;;N;;;;;
1182D;DOGRA VOWEL SIGN I;Mc;0;L;;;;;N;;;;;
1182E;DOGRA VOWEL SIGN II;Mc;0;L;;;;;N;;;;;
1182F;DOGRA VOWEL SIGN U;Mn;0;NSM;;;;;N;;;;;
11830;DOGRA VOWEL SIGN UU;Mn;0;NSM;;;;;N;;;;;
11831;DOGRA VOWEL SIGN VOCALIC R;Mn;0;NSM;;;;;N;;;;;
11832;DOGRA VOWEL SIGN VOCALIC RR;Mn;0;NSM;;;;;N;;;;;
11833;DOGRA VOWEL SIGN E;Mn;0;NSM;;;;;N;;;;;
11834;DOGRA VOWEL SIGN AI;Mn;0;NSM;;;;;N;;;;;
11835;DOGRA VOWEL SIGN O;Mn;0;NSM;;;;;N;;;;;
11836;DOGRA VOWEL SIGN AU;Mn;0;NSM;;;;;N;;;;;
11837;DOGRA SIGN ANUSVARA;Mn;0;NSM;;;;;N;;;;;
11838;DOGRA SIGN VISARGA;Mc;0;L;;;;;N;;;;;
11839;DOGRA SIGN VIRAMA;Mn;9;NSM;;;;;N;;;;;
1183A;DOGRA SIGN NUKTA;Mn;7;NSM;;;;;N;;;;;
1183B;DOGRA ABBREVIATION SIGN;Po;0;L;;;;;N;;;;;
118A0;WARANG CITI CAPITAL LETTER NGAA;Lu;0;L;;;;;N;;;;118C0;
118A1;WARANG CITI CAPITAL LETTER A;Lu;0;L;;;;;N;;;;118C1;
118A2;WARANG CITI CAPITAL LETTER WI;Lu;0;L;;;;;N;;;;118C2;
118A3;WARANG CITI CAPITAL LETTER YU;Lu;0;L;;;;;N;;;;118C3;
118A4;WARANG CITI CAPITAL LETTER YA;Lu;0;L;;;;;N;;;;118C4;
118A5;WARANG CITI CAPITAL LETTER YO;Lu;0;L;;;;;N;;;;118C5;
118A6;WARANG CITI CAPITAL LETTER II;Lu;0;L;;;;;N;;;;118C6;
118A7;WARANG CITI CAPITAL LETTER UU;Lu;0;L;;;;;N;;;;118C7;
118A8;WARANG CITI CAPITAL LETTER E;Lu;0;L;;;;;N;;;;118C8;
118A9;WARANG CITI CAPITAL LETTER O;Lu;0;L;;;;;N;;;;118C9;
118AA;WARANG CITI CAPITAL LETTER ANG;Lu;0;L;;;;;N;;;;118CA;
118AB;WARANG CITI CAPITAL LETTER GA;Lu;0;L;;;;;N;;;;118CB;
118AC;WARANG CITI CAPITAL LETTER KO;Lu;0;L;;;;;N;;;;118CC;
118AD;WARANG CITI CAPITAL LETTER ENY;Lu;0;L;;;;;N;;;;118CD;
118AE;WARANG CITI CAPITAL LETTER YUJ;Lu;0;L;;;;;N;;;;118CE;
118AF;WARANG CITI CAPITAL LETTER UC;Lu;0;L;;;;;N;;;;118CF;
118B0;WARANG CITI CAPITAL LETTER ENN;Lu;0;L;;;;;N;;;;118D0;
118B1;WARANG CITI CAPITAL LETTER ODD;Lu;0;L;;;;;N;;;;118D1;
118B2;WARANG CITI CAPITAL LETTER TTE;Lu;0;L;;;;;N;;;;118D2;
118B3;WARANG CITI CAPITAL LETTER NUNG;Lu;0;L;;;;;N;;;;118D3;
118B4;WARANG CITI CAPITAL LETTER DA;Lu;0;L;;;;;N;;;;118D4;
118B5;WARANG CITI CAPITAL LETTER AT;Lu;0;L;;;;;N;;;;118D5;
118B6;WARANG CITI CAPITAL LETTER AM;Lu;0;L;;;;;N;;;;118D6;
118B7;WARANG CITI CAPITAL LETTER BU;Lu;0;L;;;;;N;;;;118D7;
118B8;WARANG CITI CAPITAL LETTER PU;Lu;0;L;;;;;N;;;;118D8;
118B9;WARANG CITI CAPITAL LETTER HIYO;Lu;0;L;;;;;N;;;;118D9;
118BA;WARANG CITI CAPITAL LETTER HOLO;Lu;0;L;;;;;N;;;;118DA;
118BB;WARANG CITI CAPITAL LETTER HORR;Lu;0;L;;;;;N;;;;118DB;
118BC;WARANG CITI CAPITAL LETTER HAR;Lu;0;L;;;;;N;;;;118DC;
118BD;WARANG CITI CAPITAL LETTER SSUU;Lu;0;L;;;;;N;;;;118DD;
118BE;WARANG CITI CAPITAL LETTER SII;Lu;0;L;;;;;N;;;;118DE;
118BF;WARANG CITI CAPITAL LETTER VIYO;Lu;0;L;;;;;N;;;;118DF;
118C0;WARANG CITI SMALL LETTER NGAA;Ll;0;L;;;;;N;;;118A0;;118A0
118C1;WARANG CITI SMALL LETTER A;Ll;0;L;;;;;N;;;118A1;;118A1
118C2;WARANG CITI SMALL LETTER WI;Ll;0;L;;;;;N;;;118A2;;118A2
118C3;WARANG CITI SMALL LETTER YU;Ll;0;L;;;;;N;;;118A3;;118A3
118C4;WARANG CITI SMALL LETTER YA;Ll;0;L;;;;;N;;;118A4;;118A4
118C5;WARANG CITI SMALL LETTER YO;Ll;0;L;;;;;N;;;118A5;;118A5
118C6;WARANG CITI SMALL LETTER II;Ll;0;L;;;;;N;;;118A6;;118A6
118C7;WARANG CITI SMALL LETTER UU;Ll;0;L;;;;;N;;;118A7;;118A7
118C8;WARANG CITI SMALL LETTER E;Ll;0;L;;;;;N;;;118A8;;118A8
118C9;WARANG CITI SMALL LETTER O;Ll;0;L;;;;;N;;;118A9;;118A9
118CA;WARANG CITI SMALL LETTER ANG;Ll;0;L;;;;;N;;;118AA;;118AA
118CB;WARANG CITI SMALL LETTER GA;Ll;0;L;;;;;N;;;118AB;;118AB
118CC;WARANG CITI SMALL LETTER KO;Ll;0;L;;;;;N;;;118AC;;118AC
118CD;WARANG CITI SMALL LETTER ENY;Ll;0;L;;;;;N;;;118AD;;118AD
118CE;WARANG CITI SMALL LETTER YUJ;Ll;0;L;;;;;N;;;118AE;;118AE
118CF;WARANG CITI SMALL LETTER UC;Ll;0;L;;;;;N;;;118AF;;118AF
118D0;WARANG CITI SMALL LETTER ENN;Ll;0;L;;;;;N;;;118B0;;118B0
118D1;WARANG CITI SMALL LETTER ODD;Ll;0;L;;;;;N;;;118B1;;118B1
118D2;WARANG CITI SMALL LETTER TTE;Ll;0;L;;;;;N;;;118B2;;118B2
118D3;WARANG CITI SMALL LETTER NUNG;Ll;0;L;;;;;N;;;118B3;;118B3
118D4;WARANG CITI SMALL LETTER DA;Ll;0;L;;;;;N;;;118B4;;118B4
118D5;WARANG CITI SMALL LETTER AT;Ll;0;L;;;;;N;;;118B5;;118B5
118D6;WARANG CITI SMALL LETTER AM;Ll;0;L;;;;;N;;;118B6;;118B6
118D7;WARANG CITI SMALL LETTER BU;Ll;0;L;;;;;N;;;118B7;;118B7
118D8;WARANG CITI SMALL LETTER PU;Ll;0;L;;;;;N;;;118B8;;118B8
118D9;WARANG CITI SMALL LETTER HIYO;Ll;0;L;;;;;N;;;118B9;;118B9
118DA;WARANG CITI SMALL LETTER HOLO;Ll;0;L;;;;;N;;;118BA;;118BA
118DB;WARANG CITI SMALL LETTER HORR;Ll;0;L;;;;;N;;;118BB;;118BB
118DC;WARANG CITI SMALL LETTER HAR;Ll;0;L;;;;;N;;;118BC;;118BC
118DD;WARANG CITI SMALL LETTER SSUU;Ll;0;L;;;;;N;;;118BD;;118BD
118DE;WARANG CITI SMALL LETTER SII;Ll;0;L;;;;;N;;;118BE;;118BE
118DF;WARANG CITI SMALL LETTER VIYO;Ll;0;L;;;;;N;;;118BF;;118BF
118E0;WARANG CITI DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
118E1;WARANG CITI DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
118E2;WARANG CITI DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
118E3;WARANG CITI DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
118E4;WARANG CITI DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
118E5;WARANG CITI DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
118E6;WARANG CITI DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
118E7;WARANG CITI DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
118E8;WARANG CITI DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
118E9;WARANG CITI DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
118EA;WARANG CITI NUMBER TEN;No;0;L;;;;10;N;;;;;
118EB;WARANG CITI NUMBER TWENTY;No;0;L;;;;20;N;;;;;
118EC;WARANG CITI NUMBER THIRTY;No;0;L;;;;30;N;;;;;
118ED;WARANG CITI NUMBER FORTY;No;0;L;;;;40;N;;;;;
118EE;WARANG CITI NUMBER FIFTY;No;0;L;;;;50;N;;;;;
118EF;WARANG CITI NUMBER SIXTY;No;0;L;;;;60;N;;;;;
118F0;WARANG CITI NUMBER SEVENTY;No;0;L;;;;70;N;;;;;
118F1;WARANG CITI NUMBER EIGHTY;No;0;L;;;;80;N;;;;;
118F2;WARANG CITI NUMBER NINETY;No;0;L;;;;90;N;;;;;
118FF;WARANG CITI OM;Lo;0;L;;;;;N;;;;;
11900;DIVES AKURU LETTER A;Lo;0;L;;;;;N;;;;;
11901;DIVES AKURU LETTER AA;Lo;0;L;;;;;N;;;;;
11902;DIVES AKURU LETTER I;Lo;0;L;;;;;N;;;;;
11903;DIVES AKURU LETTER II;Lo;0;L;;;;;N;;;;;
11904;DIVES AKURU LETTER U;Lo;0;L;;;;;N;;;;;
11905;DIVES AKURU LETTER UU;Lo;0;L;;;;;N;;;;;
11906;DIVES AKURU LETTER E;Lo;0;L;;;;;N;;;;;
11909;DIVES AKURU LETTER O;Lo;0;L;;;;;N;;;;;
1190C;DIVES AKURU LETTER KA;Lo;0;L;;;;;N;;;;;
1190D;DIVES AKURU LETTER KHA;Lo;0;L;;;;;N;;;;;
1190E;DIVES AKURU LETTER GA;Lo;0;L;;;;;N;;;;;
1190F;DIVES AKURU LETTER GHA;Lo;0;L;;;;;N;;;;;
11910;DIVES AKURU LETTER NGA;Lo;0;L;;;;;N;;;;;
11911;DIVES AKURU LETTER CA;Lo;0;L;;;;;N;;;;;
11912;DIVES AKURU LETTER CHA;Lo;0;L;;;;;N;;;;;
11913;DIVES AKURU LETTER JA;Lo;0;L;;;;;N;;;;;
11915;DIVES AKURU LETTER NYA;Lo;0;L;;;;;N;;;;;
11916;DIVES AKURU LETTER TTA;Lo;0;L;;;;;N;;;;;
11918;DIVES AKURU LETTER DDA;Lo;0;L;;;;;N;;;;;
11919;DIVES AKURU LETTER DDHA;Lo;0;L;;;;;N;;;;;
1191A;DIVES AKURU LETTER NNA;Lo;0;L;;;;;N;;;;;
1191B;DIVES AKURU LETTER TA;Lo;0;L;;;;;N;;;;;
1191C;DIVES AKURU LETTER THA;Lo;0;L;;;;;N;;;;;
1191D;DIVES AKURU LETTER DA;Lo;0;L;;;;;N;;;;;
1191E;DIVES AKURU LETTER DHA;Lo;0;L;;;;;N;;;;;
1191F;DIVES AKURU LETTER NA;Lo;0;L;;;;;N;;;;;
11920;DIVES AKURU LETTER PA;Lo;0;L;;;;;N;;;;;
11921;DIVES AKURU LETTER PHA;Lo;0;L;;;;;N;;;;;
11922;DIVES AKURU LETTER BA;Lo;0;L;;;;;N;;;;;
11923;DIVES AKURU LETTER BHA;Lo;0;L;;;;;N;;;;;
11924;DIVES AKURU LETTER MA;Lo;0;L;;;;;N;;;;;
11925;DIVES AKURU LETTER YA;Lo;0;L;;;;;N;;;;;
11926;DIVES AKURU LETTER YYA;Lo;0;L;;;;;N;;;;;
11927;DIVES AKURU LETTER RA;Lo;0;L;;;;;N;;;;;
11928;DIVES AKURU LETTER LA;Lo;0;L;;;;;N;;;;;
11929;DIVES AKURU LETTER VA;Lo;0;L;;;;;N;;;;;
1192A;DIVES AKURU LETTER SHA;Lo;0;L;;;;;N;;;;;
1192B;DIVES AKURU LETTER SSA;Lo;0;L;;;;;N;;;;;
1192C;DIVES AKURU LETTER SA;Lo;0;L;;;;;N;;;;;
1192D;DIVES AKURU LETTER HA;Lo;0;L;;;;;N;;;;;
1192E;DIVES AKURU LETTER LLA;Lo;0;L;;;;;N;;;;;
1192F;DIVES AKURU LETTER ZA;Lo;0;L;;;;;N;;;;;
11930;DIVES AKURU VOWEL SIGN AA;Mc;0;L;;;;;N;;;;;
11931;DIVES AKURU VOWEL SIGN I;Mc;0;L;;;;;N;;;;;
11932;DIVES AKURU VOWEL SIGN II;Mc;0;L;;;;;N;;;;;
11933;DIVES AKURU VOWEL SIGN U;Mc;0;L;;;;;N;;;;;
11934;DIVES AKURU VOWEL SIGN UU;Mc;0;L;;;;;N;;;;;
11935;DIVES AKURU VOWEL SIGN E;Mc;0;L;;;;;N;;;;;
11937;DIVES AKURU VOWEL SIGN AI;Mc;0;L;;;;;N;;;;;
11938;DIVES AKURU VOWEL SIGN O;Mc;0;L;11935 11930;;;;N;;;;;
1193B;DIVES AKURU SIGN ANUSVARA;Mn;0;NSM;;;;;N;;;;;
1193C;DIVES AKURU SIGN CANDRABINDU;Mn;0;NSM;;;;;N;;;;;
1193D;DIVES AKURU SIGN HALANTA;Mc;9;L;;;;;N;;;;;
1193E;DIVES AKURU VIRAMA;Mn;9;NSM;;;;;N;;;;;
1193F;DIVES AKURU PREFIXED NASAL SIGN;Lo;0;L;;;;;N;;;;;
11940;DIVES AKURU MEDIAL YA;Mc;0;L;;;;;N;;;;;
11941;DIVES AKURU INITIAL RA;Lo;0;L;;;;;N;;;;;
11942;DIVES AKURU MEDIAL RA;Mc;0;L;;;;;N;;;;;
11943;DIVES AKURU SIGN NUKTA;Mn;7;NSM;;;;;N;;;;;
11944;DIVES AKURU DOUBLE DANDA;Po;0;L;;;;;N;;;;;
11945;DIVES AKURU GAP FILLER;Po;0;L;;;;;N;;;;;
11946;DIVES AKURU END OF TEXT MARK;Po;0;L;;;;;N;;;;;
11950;DIVES AKURU DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
11951;DIVES AKURU DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
11952;DIVES AKURU DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
11953;DIVES AKURU DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
11954;DIVES AKURU DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
11955;DIVES AKURU DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
11956;DIVES AKURU DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
11957;DIVES AKURU DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
11958;DIVES AKURU DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
11959;DIVES AKURU DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
119A0;NANDINAGARI LETTER A;Lo;0;L;;;;;N;;;;;
119A1;NANDINAGARI LETTER AA;Lo;0;L;;;;;N;;;;;
119A2;NANDINAGARI LETTER I;Lo;0;L;;;;;N;;;;;
119A3;NANDINAGARI LETTER II;Lo;0;L;;;;;N;;;;;
119A4;NANDINAGARI LETTER U;Lo;0;L;;;;;N;;;;;
119A5;NANDINAGARI LETTER UU;Lo;0;L;;;;;N;;;;;
119A6;NANDINAGARI LETTER VOCALIC R;Lo;0;L;;;;;N;;;;;
119A7;NANDINAGARI LETTER VOCALIC RR;Lo;0;L;;;;;N;;;;;
119AA;NANDINAGARI LETTER E;Lo;0;L;;;;;N;;;;;
119AB;NANDINAGARI LETTER AI;Lo;0;L;;;;;N;;;;;
119AC;NANDINAGARI LETTER O;Lo;0;L;;;;;N;;;;;
119AD;NANDINAGARI LETTER AU;Lo;0;L;;;;;N;;;;;
119AE;NANDINAGARI LETTER KA;Lo;0;L;;;;;N;;;;;
119AF;NANDINAGARI LETTER KHA;Lo;0;L;;;;;N;;;;;
119B0;NANDINAGARI LETTER GA;Lo;0;L;;;;;N;;;;;
119B1;NANDINAGARI LETTER GHA;Lo;0;L;;;;;N;;;;;
119B2;NANDINAGARI LETTER NGA;Lo;0;L;;;;;N;;;;;
119B3;NANDINAGARI LETTER CA;Lo;0;L;;;;;N;;;;;
119B4;NANDINAGARI LETTER CHA;Lo;0;L;;;;;N;;;;;
119B5;NANDINAGARI LETTER JA;Lo;0;L;;;;;N;;;;;
119B6;NANDINAGARI LETTER JHA;Lo;0;L;;;;;N;;;;;
119B7;NANDINAGARI LETTER NYA;Lo;0;L;;;;;N;;;;;
119B8;NANDINAGARI LETTER TTA;Lo;0;L;;;;;N;;;;;
119B9;NANDINAGARI LETTER TTHA;Lo;0;L;;;;;N;;;;;
119BA;NANDINAGARI LETTER DDA;Lo;0;L;;;;;N;;;;;
119BB;NANDINAGARI LETTER DDHA;Lo;0;L;;;;;N;;;;;
119BC;NANDINAGARI LETTER NNA;Lo;0;L;;;;;N;;;;;
119BD;NANDINAGARI LETTER TA;Lo;0;L;;;;;N;;;;;
119BE;NANDINAGARI LETTER THA;Lo;0;L;;;;;N;;;;;
119BF;NANDINAGARI LETTER DA;Lo;0;L;;;;;N;;;;;
119C0;NANDINAGARI LETTER DHA;Lo;0;L;;;;;N;;;;;
119C1;NANDINAGARI LETTER NA;Lo;0;L;;;;;N;;;;;
119C2;NANDINAGARI LETTER PA;Lo;0;L;;;;;N;;;;;
119C3;NANDINAGARI LETTER PHA;Lo;0;L;;;;;N;;;;;
119C4;NANDINAGARI LETTER BA;Lo;0;L;;;;;N;;;;;
119C5;NANDINAGARI LETTER BHA;Lo;0;L;;;;;N;;;;;
119C6;NANDINAGARI LETTER MA;Lo;0;L;;;;;N;;;;;
119C7;NANDINAGARI LETTER YA;Lo;0;L;;;;;N;;;;;
119C8;NANDINAGARI LETTER RA;Lo;0;L;;;;;N;;;;;
119C9;NANDINAGARI LETTER LA;Lo;0;L;;;;;N;;;;;
119CA;NANDINAGARI LETTER VA;Lo;0;L;;;;;N;;;;;
119CB;NANDINAGARI LETTER SHA;Lo;0;L;;;;;N;;;;;
119CC;NANDINAGARI LETTER SSA;Lo;0;L;;;;;N;;;;;
119CD;NANDINAGARI LETTER SA;Lo;0;L;;;;;N;;;;;
119CE;NANDINAGARI LETTER HA;Lo;0;L;;;;;N;;;;;
119CF;NANDINAGARI LETTER LLA;Lo;0;L;;;;;N;;;;;
119D0;NANDINAGARI LETTER RRA;Lo;0;L;;;;;N;;;;;
119D1;NANDINAGARI VOWEL SIGN AA;Mc;0;L;;;;;N;;;;;
119D2;NANDINAGARI VOWEL SIGN I;Mc;0;L;;;;;N;;;;;
119D3;NANDINAGARI VOWEL SIGN II;Mc;0;L;;;;;N;;;;;
119D4;NANDINAGARI VOWEL SIGN U;Mn;0;NSM;;;;;N;;;;;
119D5;NANDINAGARI VOWEL SIGN UU;Mn;0;NSM;;;;;N;;;;;
119D6;NANDINAGARI VOWEL SIGN VOCALIC R;Mn;0;NSM;;;;;N;;;;;
119D7;NANDINAGARI VOWEL SIGN VOCALIC RR;Mn;0;NSM;;;;;N;;;;;
119DA;NANDINAGARI VOWEL SIGN E;Mn;0;NSM;;;;;N;;;;;
119DB;NANDINAGARI VOWEL SIGN AI;Mn;0;NSM;;;;;N;;;;;
119DC;NANDINAGARI VOWEL SIGN O;Mc;0;L;;;;;N;;;;;
119DD;NANDINAGARI VOWEL SIGN AU;Mc;0;L;;;;;N;;;;;
119DE;NANDINAGARI SIGN ANUSVARA;Mc;0;L;;;;;N;;;;;
119DF;NANDINAGARI SIGN VISARGA;Mc;0;L;;;;;N;;;;;
119E0;NANDINAGARI SIGN VIRAMA;Mn;9;NSM;;;;;N;;;;;
119E1;NANDINAGARI SIGN AVAGRAHA;Lo;0;L;;;;;N;;;;;
119E2;NANDINAGARI SIGN SIDDHAM;Po;0;L;;;;;N;;;;;
119E3;NANDINAGARI HEADSTROKE;Lo;0;L;;;;;N;;;;;
119E4;NANDINAGARI VOWEL SIGN PRISHTHAMATRA E;Mc;0;L;;;;;N;;;;;
11A00;ZANABAZAR SQUARE LETTER A;Lo;0;L;;;;;N;;;;;
11A01;ZANABAZAR SQUARE VOWEL SIGN I;Mn;0;NSM;;;;;N;;;;;
11A02;ZANABAZAR SQUARE VOWEL SIGN UE;Mn;0;NSM;;;;;N;;;;;
11A03;ZANABAZAR SQUARE VOWEL SIGN U;Mn;0;NSM;;;;;N;;;;;
11A04;ZANABAZAR SQUARE VOWEL SIGN E;Mn;0;NSM;;;;;N;;;;;
11A05;ZANABAZAR SQUARE VOWEL SIGN OE;Mn;0;NSM;;;;;N;;;;;
11A06;ZANABAZAR SQUARE VOWEL SIGN O;Mn;0;NSM;;;;;N;;;;;
11A07;ZANABAZAR SQUARE VOWEL SIGN AI;Mn;0;L;;;;;N;;;;;
11A08;ZANABAZAR SQUARE VOWEL SIGN AU;Mn;0;L;;;;;N;;;;;
11A09;ZANABAZAR SQUARE VOWEL SIGN REVERSED I;Mn;0;NSM;;;;;N;;;;;
11A0A;ZANABAZAR SQUARE VOWEL LENGTH MARK;Mn;0;NSM;;;;;N;;;;;
11A0B;ZANABAZAR SQUARE LETTER KA;Lo;0;L;;;;;N;;;;;
11A0C;ZANABAZAR SQUARE LETTER KHA;Lo;0;L;;;;;N;;;;;
11A0D;ZANABAZAR SQUARE LETTER GA;Lo;0;L;;;;;N;;;;;
11A0E;ZANABAZAR SQUARE LETTER GHA;Lo;0;L;;;;;N;;;;;
11A0F;ZANABAZAR SQUARE LETTER NGA;Lo;0;L;;;;;N;;;;;
11A10;ZANABAZAR SQUARE LETTER CA;Lo;0;L;;;;;N;;;;;
11A11;ZANABAZAR SQUARE LETTER CHA;Lo;0;L;;;;;N;;;;;
11A12;ZANABAZAR SQUARE LETTER JA;Lo;0;L;;;;;N;;;;;
11A13;ZANABAZAR SQUARE LETTER NYA;Lo;0;L;;;;;N;;;;;
11A14;ZANABAZAR SQUARE LETTER TTA;Lo;0;L;;;;;N;;;;;
11A15;ZANABAZAR SQUARE LETTER TTHA;Lo;0;L;;;;;N;;;;;
11A16;ZANABAZAR SQUARE LETTER DDA;Lo;0;L;;;;;N;;;;;
11A17;ZANABAZAR SQUARE LETTER DDHA;Lo;0;L;;;;;N;;;;;
11A18;ZANABAZAR SQUARE LETTER NNA;Lo;0;L;;;;;N;;;;;
11A19;ZANABAZAR SQUARE LETTER TA;Lo;0;L;;;;;N;;;;;
11A1A;ZANABAZAR SQUARE LETTER THA;Lo;0;L;;;;;N;;;;;
11A1B;ZANABAZAR SQUARE LETTER DA;Lo;0;L;;;;;N;;;;;
11A1C;ZANABAZAR SQUARE LETTER DHA;Lo;0;L;;;;;N;;;;;
11A1D;ZANABAZAR SQUARE LETTER NA;Lo;0;L;;;;;N;;;;;
11A1E;ZANABAZAR SQUARE LETTER PA;Lo;0;L;;;;;N;;;;;
11A1F;ZANABAZAR SQUARE LETTER PHA;Lo;0;L;;;;;N;;;;;
11A20;ZANABAZAR SQUARE LETTER BA;Lo;0;L;;;;;N;;;;;
11A21;ZANABAZAR SQUARE LETTER BHA;Lo;0;L;;;;;N;;;;;
11A22;ZANABAZAR SQUARE LETTER MA;Lo;0;L;;;;;N;;;;;
11A23;ZANABAZAR SQUARE LETTER TSA;Lo;0;L;;;;;N;;;;;
11A24;ZANABAZAR SQUARE LETTER TSHA;Lo;0;L;;;;;N;;;;;
11A25;ZANABAZAR SQUARE LETTER DZA;Lo;0;L;;;;;N;;;;;
11A26;ZANABAZAR SQUARE LETTER DZHA;Lo;0;L;;;;;N;;;;;
11A27;ZANABAZAR SQUARE LETTER ZHA;Lo;0;L;;;;;N;;;;;
11A28;ZANABAZAR SQUARE LETTER ZA;Lo;0;L;;;;;N;;;;;
11A29;ZANABAZAR SQUARE LETTER -A;Lo;0;L;;;;;N;;;;;
11A2A;ZANABAZAR SQUARE LETTER YA;Lo;0;L;;;;;N;;;;;
11A2B;ZANABAZAR SQUARE LETTER RA;Lo;0;L;;;;;N;;;;;
11A2C;ZANABAZAR SQUARE LETTER LA;Lo;0;L;;;;;N;;;;;
11A2D;ZANABAZAR SQUARE LETTER VA;Lo;0;L;;;;;N;;;;;
11A2E;ZANABAZAR SQUARE LETTER SHA;Lo;0;L;;;;;N;;;;;
11A2F;ZANABAZAR SQUARE LETTER SSA;Lo;0;L;;;;;N;;;;;
11A30;ZANABAZAR SQUARE LETTER SA;Lo;0;L;;;;;N;;;;;
11A31;ZANABAZAR SQUARE LETTER HA;Lo;0;L;;;;;N;;;;;
11A32;ZANABAZAR SQUARE LETTER KSSA;Lo;0;L;;;;;N;;;;;
11A33;ZANABAZAR SQUARE FINAL CONSONANT MARK;Mn;0;NSM;;;;;N;;;;;
11A34;ZANABAZAR SQUARE SIGN VIRAMA;Mn;9;NSM;;;;;N;;;;;
11A35;ZANABAZAR SQUARE SIGN CANDRABINDU;Mn;0;NSM;;;;;N;;;;;
11A36;ZANABAZAR SQUARE SIGN CANDRABINDU WITH ORNAMENT;Mn;0;NSM;;;;;N;;;;;
11A37;ZANABAZAR SQUARE SIGN CANDRA WITH ORNAMENT;Mn;0;NSM;;;;;N;;;;;
11A38;ZANABAZAR SQUARE SIGN ANUSVARA;Mn;0;NSM;;;;;N;;;;;
11A39;ZANABAZAR SQUARE SIGN VISARGA;Mc;0;L;;;;;N;;;;;
11A3A;ZANABAZAR SQUARE CLUSTER-INITIAL LETTER RA;Lo;0;L;;;;;N;;;;;
11A3B;ZANABAZAR SQUARE CLUSTER-FINAL LETTER YA;Mn;0;NSM;;;;;N;;;;;
11A3C;ZANABAZAR SQUARE CLUSTER-FINAL LETTER RA;Mn;0;NSM;;;;;N;;;;;
11A3D;ZANABAZAR SQUARE CLUSTER-FINAL LETTER LA;Mn;0;NSM;;;;;N;;;;;
11A3E;ZANABAZAR SQUARE CLUSTER-FINAL LETTER VA;Mn;0;NSM;;;;;N;;;;;
11A3F;ZANABAZAR SQUARE INITIAL HEAD MARK;Po;0;L;;;;;N;;;;;
11A40;ZANABAZAR SQUARE CLOSING HEAD MARK;Po;0;L;;;;;N;;;;;
11A41;ZANABAZAR SQUARE MARK TSHEG;Po;0;L;;;;;N;;;;;
11A42;ZANABAZAR SQUARE MARK SHAD;Po;0;L;;;;;N;;;;;
11A43;ZANABAZAR SQUARE MARK DOUBLE SHAD;Po;0;L;;;;;N;;;;;
11A44;ZANABAZAR SQUARE MARK LONG TSHEG;Po;0;L;;;;;N;;;;;
11A45;ZANABAZAR SQUARE INITIAL DOUBLE-LINED HEAD MARK;Po;0;L;;;;;N;;;;;
11A46;ZANABAZAR SQUARE CLOSING DOUBLE-LINED HEAD MARK;Po;0;L;;;;;N;;;;;
11A47;ZANABAZAR SQUARE SUBJOINER;Mn;9;NSM;;;;;N;;;;;
11A50;SOYOMBO LETTER A;Lo;0;L;;;;;N;;;;;
11A51;SOYOMBO VOWEL SIGN I;Mn;0;NSM;;;;;N;;;;;
11A52;SOYOMBO VOWEL SIGN UE;Mn;0;NSM;;;;;N;;;;;
11A53;SOYOMBO VOWEL SIGN U;Mn;0;NSM;;;;;N;;;;;
11A54;SOYOMBO VOWEL SIGN E;Mn;0;NSM;;;;;N;;;;;
11A55;SOYOMBO VOWEL SIGN O;Mn;0;NSM;;;;;N;;;;;
11A56;SOYOMBO VOWEL SIGN OE;Mn;0;NSM;;;;;N;;;;;
11A57;SOYOMBO VOWEL SIGN AI;Mc;0;L;;;;;N;;;;;
11A58;SOYOMBO VOWEL SIGN AU;Mc;0;L;;;;;N;;;;;
11A59;SOYOMBO VOWEL SIGN VOCALIC R;Mn;0;NSM;;;;;N;;;;;
11A5A;SOYOMBO VOWEL SIGN VOCALIC L;Mn;0;NSM;;;;;N;;;;;
11A5B;SOYOMBO VOWEL LENGTH MARK;Mn;0;NSM;;;;;N;;;;;
11A5C;SOYOMBO LETTER KA;Lo;0;L;;;;;N;;;;;
11A5D;SOYOMBO LETTER KHA;Lo;0;L;;;;;N;;;;;
11A5E;SOYOMBO LETTER GA;Lo;0;L;;;;;N;;;;;
11A5F;SOYOMBO LETTER GHA;Lo;0;L;;;;;N;;;;;
11A60;SOYOMBO LETTER NGA;Lo;0;L;;;;;N;;;;;
11A61;SOYOMBO LETTER CA;Lo;0;L;;;;;N;;;;;
11A62;SOYOMBO LETTER CHA;Lo;0;L;;;;;N;;;;;
11A63;SOYOMBO LETTER JA;Lo;0;L;;;;;N;;;;;
11A64;SOYOMBO LETTER JHA;Lo;0;L;;;;;N;;;;;
11A65;SOYOMBO LETTER NYA;Lo;0;L;;;;;N;;;;;
11A66;SOYOMBO LETTER TTA;Lo;0;L;;;;;N;;;;;
11A67;SOYOMBO LETTER TTHA;Lo;0;L;;;;;N;;;;;
11A68;SOYOMBO LETTER DDA;Lo;0;L;;;;;N;;;;;
11A69;SOYOMBO LETTER DDHA;Lo;0;L;;;;;N;;;;;
11A6A;SOYOMBO LETTER NNA;Lo;0;L;;;;;N;;;;;
11A6B;SOYOMBO LETTER TA;Lo;0;L;;;;;N;;;;;
11A6C;SOYOMBO LETTER THA;Lo;0;L;;;;;N;;;;;
11A6D;SOYOMBO LETTER DA;Lo;0;L;;;;;N;;;;;
11A6E;SOYOMBO LETTER DHA;Lo;0;L;;;;;N;;;;;
11A6F;SOYOMBO LETTER NA;Lo;0;L;;;;;N;;;;;
11A70;SOYOMBO LETTER PA;Lo;0;L;;;;;N;;;;;
11A71;SOYOMBO LETTER PHA;Lo;0;L;;;;;N;;;;;
11A72;SOYOMBO LETTER BA;Lo;0;L;;;;;N;;;;;
11A73;SOYOMBO LETTER BHA;Lo;0;L;;;;;N;;;;;
11A74;SOYOMBO LETTER MA;Lo;0;L;;;;;N;;;;;
11A75;SOYOMBO LETTER TSA;Lo;0;L;;;;;N;;;;;
11A76;SOYOMBO LETTER TSHA;Lo;0;L;;;;;N;;;;;
11A77;SOYOMBO LETTER DZA;Lo;0;L;;;;;N;;;;;
11A78;SOYOMBO LETTER ZHA;Lo;0;L;;;;;N;;;;;
11A79;SOYOMBO LETTER ZA;Lo;0;L;;;;;N;;;;;
11A7A;SOYOMBO LETTER -A;Lo;0;L;;;;;N;;;;;
11A7B;SOYOMBO LETTER YA;Lo;0;L;;;;;N;;;;;
11A7C;SOYOMBO LETTER RA;Lo;0;L;;;;;N;;;;;
11A7D;SOYOMBO LETTER LA;Lo;0;L;;;;;N;;;;;
11A7E;SOYOMBO LETTER VA;Lo;0;L;;;;;N;;;;;
11A7F;SOYOMBO LETTER SHA;Lo;0;L;;;;;N;;;;;
11A80;SOYOMBO LETTER SSA;Lo;0;L;;;;;N;;;;;
11A81;SOYOMBO LETTER SA;Lo;0;L;;;;;N;;;;;
11A82;SOYOMBO LETTER HA;Lo;0;L;;;;;N;;;;;
11A83;SOYOMBO LETTER KSSA;Lo;0;L;;;;;N;;;;;
11A84;SOYOMBO SIGN JIHVAMULIYA;Lo;0;L;;;;;N;;;;;
11A85;SOYOMBO SIGN UPADHMANIYA;Lo;0;L;;;;;N;;;;;
11A86;SOYOMBO CLUSTER-INITIAL LETTER RA;Lo;0;L;;;;;N;;;;;
11A87;SOYOMBO CLUSTER-INITIAL LETTER LA;Lo;0;L;;;;;N;;;;;
11A88;SOYOMBO CLUSTER-INITIAL LETTER SHA;Lo;0;L;;;;;N;;;;;
11A89;SOYOMBO CLUSTER-INITIAL LETTER SA;Lo;0;L;;;;;N;;;;;
11A8A;SOYOMBO FINAL CONSONANT SIGN G;Mn;0;NSM;;;;;N;;;;;
11A8B;SOYOMBO FINAL CONSONANT SIGN K;Mn;0;NSM;;;;;N;;;;;
11A8C;SOYOMBO FINAL CONSONANT SIGN NG;Mn;0;NSM;;;;;N;;;;;
11A8D;SOYOMBO FINAL CONSONANT SIGN D;Mn;0;NSM;;;;;N;;;;;
11A8E;SOYOMBO FINAL CONSONANT SIGN N;Mn;0;NSM;;;;;N;;;;;
11A8F;SOYOMBO FINAL CONSONANT SIGN B;Mn;0;NSM;;;;;N;;;;;
11A90;SOYOMBO FINAL CONSONANT SIGN M;Mn;0;NSM;;;;;N;;;;;
11A91;SOYOMBO FINAL CONSONANT SIGN R;Mn;0;NSM;;;;;N;;;;;
11A92;SOYOMBO FINAL CONSONANT SIGN L;Mn;0;NSM;;;;;N;;;;;
11A93;SOYOMBO FINAL CONSONANT SIGN SH;Mn;0;NSM;;;;;N;;;;;
11A94;SOYOMBO FINAL CONSONANT SIGN S;Mn;0;NSM;;;;;N;;;;;
11A95;SOYOMBO FINAL CONSONANT SIGN -A;Mn;0;NSM;;;;;N;;;;;
11A96;SOYOMBO SIGN ANUSVARA;Mn;0;NSM;;;;;N;;;;;
11A97;SOYOMBO SIGN VISARGA;Mc;0;L;;;;;N;;;;;
11A98;SOYOMBO GEMINATION MARK;Mn;0;NSM;;;;;N;;;;;
11A99;SOYOMBO SUBJOINER;Mn;9;NSM;;;;;N;;;;;
11A9A;SOYOMBO MARK TSHEG;Po;0;L;;;;;N;;;;;
11A9B;SOYOMBO MARK SHAD;Po;0;L;;;;;N;;;;;
11A9C;SOYOMBO MARK DOUBLE SHAD;Po;0;L;;;;;N;;;;;
11A9D;SOYOMBO MARK PLUTA;Lo;0;L;;;;;N;;;;;
11A9E;SOYOMBO HEAD MARK WITH MOON AND SUN AND TRIPLE FLAME;Po;0;L;;;;;N;;;;;
11A9F;SOYOMBO HEAD MARK WITH MOON AND SUN AND FLAME;Po;0;L;;;;;N;;;;;
11AA0;SOYOMBO HEAD MARK WITH MOON AND SUN;Po;0;L;;;;;N;;;;;
11AA1;SOYOMBO TERMINAL MARK-1;Po;0;L;;;;;N;;;;;
11AA2;SOYOMBO TERMINAL MARK-2;Po;0;L;;;;;N;;;;;
11AB0;CANADIAN SYLLABICS NATTILIK HI;Lo;0;L;;;;;N;;;;;
11AB1;CANADIAN SYLLABICS NATTILIK HII;Lo;0;L;;;;;N;;;;;
11AB2;CANADIAN SYLLABICS NATTILIK HO;Lo;0;L;;;;;N;;;;;
11AB3;CANADIAN SYLLABICS NATTILIK HOO;Lo;0;L;;;;;N;;;;;
11AB4;CANADIAN SYLLABICS NATTILIK HA;Lo;0;L;;;;;N;;;;;
11AB5;CANADIAN SYLLABICS NATTILIK HAA;Lo;0;L;;;;;N;;;;;
11AB6;CANADIAN SYLLABICS NATTILIK SHRI;Lo;0;L;;;;;N;;;;;
11AB7;CANADIAN SYLLABICS NATTILIK SHRII;Lo;0;L;;;;;N;;;;;
11AB8;CANADIAN SYLLABICS NATTILIK SHRO;Lo;0;L;;;;;N;;;;;
11AB9;CANADIAN SYLLABICS NATTILIK SHROO;Lo;0;L;;;;;N;;;;;
11ABA;CANADIAN SYLLABICS NATTILIK SHRA;Lo;0;L;;;;;N;;;;;
11ABB;CANADIAN SYLLABICS NATTILIK SHRAA;Lo;0;L;;;;;N;;;;;
11ABC;CANADIAN SYLLABICS SPE;Lo;0;L;;;;;N;;;;;
11ABD;CANADIAN SYLLABICS SPI;Lo;0;L;;;;;N;;;;;
11ABE;CANADIAN SYLLABICS SPO;Lo;0;L;;;;;N;;;;;
11ABF;CANADIAN SYLLABICS SPA;Lo;0;L;;;;;N;;;;;
11AC0;PAU CIN HAU LETTER PA;Lo;0;L;;;;;N;;;;;
11AC1;PAU CIN HAU LETTER KA;Lo;0;L;;;;;N;;;;;
11AC2;PAU CIN HAU LETTER LA;Lo;0;L;;;;;N;;;;;
11AC3;PAU CIN HAU LETTER MA;Lo;0;L;;;;;N;;;;;
11AC4;PAU CIN HAU LETTER DA;Lo;0;L;;;;;N;;;;;
11AC5;PAU CIN HAU LETTER ZA;Lo;0;L;;;;;N;;;;;
11AC6;PAU CIN HAU LETTER VA;Lo;0;L;;;;;N;;;;;
11AC7;PAU CIN HAU LETTER NGA;Lo;0;L;;;;;N;;;;;
11AC8;PAU CIN HAU LETTER HA;Lo;0;L;;;;;N;;;;;
11AC9;PAU CIN HAU LETTER GA;Lo;0;L;;;;;N;;;;;
11ACA;PAU CIN HAU LETTER KHA;Lo;0;L;;;;;N;;;;;
11ACB;PAU CIN HAU LETTER SA;Lo;0;L;;;;;N;;;;;
11ACC;PAU CIN HAU LETTER BA;Lo;0;L;;;;;N;;;;;
11ACD;PAU CIN HAU LETTER CA;Lo;0;L;;;;;N;;;;;
11ACE;PAU CIN HAU LETTER TA;Lo;0;L;;;;;N;;;;;
11ACF;PAU CIN HAU LETTER THA;Lo;0;L;;;;;N;;;;;
11AD0;PAU CIN HAU LETTER NA;Lo;0;L;;;;;N;;;;;
11AD1;PAU CIN HAU LETTER PHA;Lo;0;L;;;;;N;;;;;
11AD2;PAU CIN HAU LETTER RA;Lo;0;L;;;;;N;;;;;
11AD3;PAU CIN HAU LETTER FA;Lo;0;L;;;;;N;;;;;
11AD4;PAU CIN HAU LETTER CHA;Lo;0;L;;;;;N;;;;;
11AD5;PAU CIN HAU LETTER A;Lo;0;L;;;;;N;;;;;
11AD6;PAU CIN HAU LETTER E;Lo;0;L;;;;;N;;;;;
11AD7;PAU CIN HAU LETTER I;Lo;0;L;;;;;N;;;;;
11AD8;PAU CIN HAU LETTER O;Lo;0;L;;;;;N;;;;;
11AD9;PAU CIN HAU LETTER U;Lo;0;L;;;;;N;;;;;
11ADA;PAU CIN HAU LETTER UA;Lo;0;L;;;;;N;;;;;
11ADB;PAU CIN HAU LETTER IA;Lo;0;L;;;;;N;;;;;
11ADC;PAU CIN HAU LETTER FINAL P;Lo;0;L;;;;;N;;;;;
11ADD;PAU CIN HAU LETTER FINAL K;Lo;0;L;;;;;N;;;;;
11ADE;PAU CIN HAU LETTER FINAL T;Lo;0;L;;;;;N;;;;;
11ADF;PAU CIN HAU LETTER FINAL M;Lo;0;L;;;;;N;;;;;
11AE0;PAU CIN HAU LETTER FINAL N;Lo;0;L;;;;;N;;;;;
11AE1;PAU CIN HAU LETTER FINAL L;Lo;0;L;;;;;N;;;;;
11AE2;PAU CIN HAU LETTER FINAL W;Lo;0;L;;;;;N;;;;;
11AE3;PAU CIN HAU LETTER FINAL NG;Lo;0;L;;;;;N;;;;;
11AE4;PAU CIN HAU LETTER FINAL Y;Lo;0;L;;;;;N;;;;;
11AE5;PAU CIN HAU RISING TONE LONG;Lo;0;L;;;;;N;;;;;
11AE6;PAU CIN HAU RISING TONE;Lo;0;L;;;;;N;;;;;
11AE7;PAU CIN HAU SANDHI GLOTTAL STOP;Lo;0;L;;;;;N;;;;;
11AE8;PAU CIN HAU RISING TONE LONG FINAL;Lo;0;L;;;;;N;;;;;
11AE9;PAU CIN HAU RISING TONE FINAL;Lo;0;L;;;;;N;;;;;
11AEA;PAU CIN HAU SANDHI GLOTTAL STOP FINAL;Lo;0;L;;;;;N;;;;;
11AEB;PAU CIN HAU SANDHI TONE LONG;Lo;0;L;;;;;N;;;;;
11AEC;PAU CIN HAU SANDHI TONE;Lo;0;L;;;;;N;;;;;
11AED;PAU CIN HAU SANDHI TONE LONG FINAL;Lo;0;L;;;;;N;;;;;
11AEE;PAU CIN HAU SANDHI TONE FINAL;Lo;0;L;;;;;N;;;;;
11AEF;PAU CIN HAU MID-LEVEL TONE;Lo;0;L;;;;;N;;;;;
11AF0;PAU CIN HAU GLOTTAL STOP VARIANT;Lo;0;L;;;;;N;;;;;
11AF1;PAU CIN HAU MID-LEVEL TONE LONG FINAL;Lo;0;L;;;;;N;;;;;
11AF2;PAU CIN HAU MID-LEVEL TONE FINAL;Lo;0;L;;;;;N;;;;;
11AF3;PAU CIN HAU LOW-FALLING TONE LONG;Lo;0;L;;;;;N;;;;;
11AF4;PAU CIN HAU LOW-FALLING TONE;Lo;0;L;;;;;N;;;;;
11AF5;PAU CIN HAU GLOTTAL STOP;Lo;0;L;;;;;N;;;;;
11AF6;PAU CIN HAU LOW-FALLING TONE LONG FINAL;Lo;0;L;;;;;N;;;;;
11AF7;PAU CIN HAU LOW-FALLING TONE FINAL;Lo;0;L;;;;;N;;;;;
11AF8;PAU CIN HAU GLOTTAL STOP FINAL;Lo;0;L;;;;;N;;;;;
11C00;BHAIKSUKI LETTER A;Lo;0;L;;;;;N;;;;;
11C01;BHAIKSUKI LETTER AA;Lo;0;L;;;;;N;;;;;
11C02;BHAIKSUKI LETTER I;Lo;0;L;;;;;N;;;;;
11C03;BHAIKSUKI LETTER II;Lo;0;L;;;;;N;;;;;
11C04;BHAIKSUKI LETTER U;Lo;0;L;;;;;N;;;;;
11C05;BHAIKSUKI LETTER UU;Lo;0;L;;;;;N;;;;;
11C06;BHAIKSUKI LETTER VOCALIC R;Lo;0;L;;;;;N;;;;;
11C07;BHAIKSUKI LETTER VOCALIC RR;Lo;0;L;;;;;N;;;;;
11C08;BHAIKSUKI LETTER VOCALIC L;Lo;0;L;;;;;N;;;;;
11C0A;BHAIKSUKI LETTER E;Lo;0;L;;;;;N;;;;;
11C0B;BHAIKSUKI LETTER AI;Lo;0;L;;;;;N;;;;;
11C0C;BHAIKSUKI LETTER O;Lo;0;L;;;;;N;;;;;
11C0D;BHAIKSUKI LETTER AU;Lo;0;L;;;;;N;;;;;
11C0E;BHAIKSUKI LETTER KA;Lo;0;L;;;;;N;;;;;
11C0F;BHAIKSUKI LETTER KHA;Lo;0;L;;;;;N;;;;;
11C10;BHAIKSUKI LETTER GA;Lo;0;L;;;;;N;;;;;
11C11;BHAIKSUKI LETTER GHA;Lo;0;L;;;;;N;;;;;
11C12;BHAIKSUKI LETTER NGA;Lo;0;L;;;;;N;;;;;
11C13;BHAIKSUKI LETTER CA;Lo;0;L;;;;;N;;;;;
11C14;BHAIKSUKI LETTER CHA;Lo;0;L;;;;;N;;;;;
11C15;BHAIKSUKI LETTER JA;Lo;0;L;;;;;N;;;;;
11C16;BHAIKSUKI LETTER JHA;Lo;0;L;;;;;N;;;;;
11C17;BHAIKSUKI LETTER NYA;Lo;0;L;;;;;N;;;;;
11C18;BHAIKSUKI LETTER TTA;Lo;0;L;;;;;N;;;;;
11C19;BHAIKSUKI LETTER TTHA;Lo;0;L;;;;;N;;;;;
11C1A;BHAIKSUKI LETTER DDA;Lo;0;L;;;;;N;;;;;
11C1B;BHAIKSUKI LETTER DDHA;Lo;0;L;;;;;N;;;;;
11C1C;BHAIKSUKI LETTER NNA;Lo;0;L;;;;;N;;;;;
11C1D;BHAIKSUKI LETTER TA;Lo;0;L;;;;;N;;;;;
11C1E;BHAIKSUKI LETTER THA;Lo;0;L;;;;;N;;;;;
11C1F;BHAIKSUKI LETTER DA;Lo;0;L;;;;;N;;;;;
11C20;BHAIKSUKI LETTER DHA;Lo;0;L;;;;;N;;;;;
11C21;BHAIKSUKI LETTER NA;Lo;0;L;;;;;N;;;;;
11C22;BHAIKSUKI LETTER PA;Lo;0;L;;;;;N;;;;;
11C23;BHAIKSUKI LETTER PHA;Lo;0;L;;;;;N;;;;;
11C24;BHAIKSUKI LETTER BA;Lo;0;L;;;;;N;;;;;
11C25;BHAIKSUKI LETTER BHA;Lo;0;L;;;;;N;;;;;
11C26;BHAIKSUKI LETTER MA;Lo;0;L;;;;;N;;;;;
11C27;BHAIKSUKI LETTER YA;Lo;0;L;;;;;N;;;;;
11C28;BHAIKSUKI LETTER RA;Lo;0;L;;;;;N;;;;;
11C29;BHAIKSUKI LETTER LA;Lo;0;L;;;;;N;;;;;
11C2A;BHAIKSUKI LETTER VA;Lo;0;L;;;;;N;;;;;
11C2B;BHAIKSUKI LETTER SHA;Lo;0;L;;;;;N;;;;;
11C2C;BHAIKSUKI LETTER SSA;Lo;0;L;;;;;N;;;;;
11C2D;BHAIKSUKI LETTER SA;Lo;0;L;;;;;N;;;;;
11C2E;BHAIKSUKI LETTER HA;Lo;0;L;;;;;N;;;;;
11C2F;BHAIKSUKI VOWEL SIGN AA;Mc;0;L;;;;;N;;;;;
11C30;BHAIKSUKI VOWEL SIGN I;Mn;0;NSM;;;;;N;;;;;
11C31;BHAIKSUKI VOWEL SIGN II;Mn;0;NSM;;;;;N;;;;;
11C32;BHAIKSUKI VOWEL SIGN U;Mn;0;NSM;;;;;N;;;;;
11C33;BHAIKSUKI VOWEL SIGN UU;Mn;0;NSM;;;;;N;;;;;
11C34;BHAIKSUKI VOWEL SIGN VOCALIC R;Mn;0;NSM;;;;;N;;;;;
11C35;BHAIKSUKI VOWEL SIGN VOCALIC RR;Mn;0;NSM;;;;;N;;;;;
11C36;BHAIKSUKI VOWEL SIGN VOCALIC L;Mn;0;NSM;;;;;N;;;;;
11C38;BHAIKSUKI VOWEL SIGN E;Mn;0;NSM;;;;;N;;;;;
11C39;BHAIKSUKI VOWEL SIGN AI;Mn;0;NSM;;;;;N;;;;;
11C3A;BHAIKSUKI VOWEL SIGN O;Mn;0;NSM;;;;;N;;;;;
11C3B;BHAIKSUKI VOWEL SIGN AU;Mn;0;NSM;;;;;N;;;;;
11C3C;BHAIKSUKI SIGN CANDRABINDU;Mn;0;NSM;;;;;N;;;;;
11C3D;BHAIKSUKI SIGN ANUSVARA;Mn;0;NSM;;;;;N;;;;;
11C3E;BHAIKSUKI SIGN VISARGA;Mc;0;L;;;;;N;;;;;
11C3F;BHAIKSUKI SIGN VIRAMA;Mn;9;L;;;;;N;;;;;
11C40;BHAIKSUKI SIGN AVAGRAHA;Lo;0;L;;;;;N;;;;;
11C41;BHAIKSUKI DANDA;Po;0;L;;;;;N;;;;;
11C42;BHAIKSUKI DOUBLE DANDA;Po;0;L;;;;;N;;;;;
11C43;BHAIKSUKI WORD SEPARATOR;Po;0;L;;;;;N;;;;;
11C44;BHAIKSUKI GAP FILLER-1;Po;0;L;;;;;N;;;;;
11C45;BHAIKSUKI GAP FILLER-2;Po;0;L;;;;;N;;;;;
11C50;BHAIKSUKI DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
11C51;BHAIKSUKI DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
11C52;BHAIKSUKI DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
11C53;BHAIKSUKI DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
11C54;BHAIKSUKI DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
11C55;BHAIKSUKI DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
11C56;BHAIKSUKI DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
11C57;BHAIKSUKI DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
11C58;BHAIKSUKI DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
11C59;BHAIKSUKI DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
11C5A;BHAIKSUKI NUMBER ONE;No;0;L;;;;1;N;;;;;
11C5B;BHAIKSUKI NUMBER TWO;No;0;L;;;;2;N;;;;;
11C5C;BHAIKSUKI NUMBER THREE;No;0;L;;;;3;N;;;;;
11C5D;BHAIKSUKI NUMBER FOUR;No;0;L;;;;4;N;;;;;
11C5E;BHAIKSUKI NUMBER FIVE;No;0;L;;;;5;N;;;;;
11C5F;BHAIKSUKI NUMBER SIX;No;0;L;;;;6;N;;;;;
11C60;BHAIKSUKI NUMBER SEVEN;No;0;L;;;;7;N;;;;;
11C61;BHAIKSUKI NUMBER EIGHT;No;0;L;;;;8;N;;;;;
11C62;BHAIKSUKI NUMBER NINE;No;0;L;;;;9;N;;;;;
11C63;BHAIKSUKI NUMBER TEN;No;0;L;;;;10;N;;;;;
11C64;BHAIKSUKI NUMBER TWENTY;No;0;L;;;;20;N;;;;;
11C65;BHAIKSUKI NUMBER THIRTY;No;0;L;;;;30;N;;;;;
11C66;BHAIKSUKI NUMBER FORTY;No;0;L;;;;40;N;;;;;
11C67;BHAIKSUKI NUMBER FIFTY;No;0;L;;;;50;N;;;;;
11C68;BHAIKSUKI NUMBER SIXTY;No;0;L;;;;60;N;;;;;
11C69;BHAIKSUKI NUMBER SEVENTY;No;0;L;;;;70;N;;;;;
11C6A;BHAIKSUKI NUMBER EIGHTY;No;0;L;;;;80;N;;;;;
11C6B;BHAIKSUKI NUMBER NINETY;No;0;L;;;;90;N;;;;;
11C6C;BHAIKSUKI HUNDREDS UNIT MARK;No;0;L;;;;100;N;;;;;
11C70;MARCHEN HEAD MARK;Po;0;L;;;;;N;;;;;
11C71;MARCHEN MARK SHAD;Po;0;L;;;;;N;;;;;
11C72;MARCHEN LETTER KA;Lo;0;L;;;;;N;;;;;
11C73;MARCHEN LETTER KHA;Lo;0;L;;;;;N;;;;;
11C74;MARCHEN LETTER GA;Lo;0;L;;;;;N;;;;;
11C75;MARCHEN LETTER NGA;Lo;0;L;;;;;N;;;;;
11C76;MARCHEN LETTER CA;Lo;0;L;;;;;N;;;;;
11C77;MARCHEN LETTER CHA;Lo;0;L;;;;;N;;;;;
11C78;MARCHEN LETTER JA;Lo;0;L;;;;;N;;;;;
11C79;MARCHEN LETTER NYA;Lo;0;L;;;;;N;;;;;
11C7A;MARCHEN LETTER TA;Lo;0;L;;;;;N;;;;;
11C7B;MARCHEN LETTER THA;Lo;0;L;;;;;N;;;;;
11C7C;MARCHEN LETTER DA;Lo;0;L;;;;;N;;;;;
11C7D;MARCHEN LETTER NA;Lo;0;L;;;;;N;;;;;
11C7E;MARCHEN LETTER PA;Lo;0;L;;;;;N;;;;;
11C7F;MARCHEN LETTER PHA;Lo;0;L;;;;;N;;;;;
11C80;MARCHEN LETTER BA;Lo;0;L;;;;;N;;;;;
11C81;MARCHEN LETTER MA;Lo;0;L;;;;;N;;;;;
11C82;MARCHEN LETTER TSA;Lo;0;L;;;;;N;;;;;
11C83;MARCHEN LETTER TSHA;Lo;0;L;;;;;N;;;;;
11C84;MARCHEN LETTER DZA;Lo;0;L;;;;;N;;;;;
11C85;MARCHEN LETTER WA;Lo;0;L;;;;;N;;;;;
11C86;MARCHEN LETTER ZHA;Lo;0;L;;;;;N;;;;;
11C87;MARCHEN LETTER ZA;Lo;0;L;;;;;N;;;;;
11C88;MARCHEN LETTER -A;Lo;0;L;;;;;N;;;;;
11C89;MARCHEN LETTER YA;Lo;0;L;;;;;N;;;;;
11C8A;MARCHEN LETTER RA;Lo;0;L;;;;;N;;;;;
11C8B;MARCHEN LETTER LA;Lo;0;L;;;;;N;;;;;
11C8C;MARCHEN LETTER SHA;Lo;0;L;;;;;N;;;;;
11C8D;MARCHEN LETTER SA;Lo;0;L;;;;;N;;;;;
11C8E;MARCHEN LETTER HA;Lo;0;L;;;;;N;;;;;
11C8F;MARCHEN LETTER A;Lo;0;L;;;;;N;;;;;
11C92;MARCHEN SUBJOINED LETTER KA;Mn;0;NSM;;;;;N;;;;;
11C93;MARCHEN SUBJOINED LETTER KHA;Mn;0;NSM;;;;;N;;;;;
11C94;MARCHEN SUBJOINED LETTER GA;Mn;0;NSM;;;;;N;;;;;
11C95;MARCHEN SUBJOINED LETTER NGA;Mn;0;NSM;;;;;N;;;;;
11C96;MARCHEN SUBJOINED LETTER CA;Mn;0;NSM;;;;;N;;;;;
11C97;MARCHEN SUBJOINED LETTER CHA;Mn;0;NSM;;;;;N;;;;;
11C98;MARCHEN SUBJOINED LETTER JA;Mn;0;NSM;;;;;N;;;;;
11C99;MARCHEN SUBJOINED LETTER NYA;Mn;0;NSM;;;;;N;;;;;
11C9A;MARCHEN SUBJOINED LETTER TA;Mn;0;NSM;;;;;N;;;;;
11C9B;MARCHEN SUBJOINED LETTER THA;Mn;0;NSM;;;;;N;;;;;
11C9C;MARCHEN SUBJOINED LETTER DA;Mn;0;NSM;;;;;N;;;;;
11C9D;MARCHEN SUBJOINED LETTER NA;Mn;0;NSM;;;;;N;;;;;
11C9E;MARCHEN SUBJOINED LETTER PA;Mn;0;NSM;;;;;N;;;;;
11C9F;MARCHEN SUBJOINED LETTER PHA;Mn;0;NSM;;;;;N;;;;;
11CA0;MARCHEN SUBJOINED LETTER BA;Mn;0;NSM;;;;;N;;;;;
11CA1;MARCHEN SUBJOINED LETTER MA;Mn;0;NSM;;;;;N;;;;;
11CA2;MARCHEN SUBJOINED LETTER TSA;Mn;0;NSM;;;;;N;;;;;
11CA3;MARCHEN SUBJOINED LETTER TSHA;Mn;0;NSM;;;;;N;;;;;
11CA4;MARCHEN SUBJOINED LETTER DZA;Mn;0;NSM;;;;;N;;;;;
11CA5;MARCHEN SUBJOINED LETTER WA;Mn;0;NSM;;;;;N;;;;;
11CA6;MARCHEN SUBJOINED LETTER ZHA;Mn;0;NSM;;;;;N;;;;;
11CA7;MARCHEN SUBJOINED LETTER ZA;Mn;0;NSM;;;;;N;;;;;
11CA9;MARCHEN SUBJOINED LETTER YA;Mc;0;L;;;;;N;;;;;
11CAA;MARCHEN SUBJOINED LETTER RA;Mn;0;NSM;;;;;N;;;;;
11CAB;MARCHEN SUBJOINED LETTER LA;Mn;0;NSM;;;;;N;;;;;
11CAC;MARCHEN SUBJOINED LETTER SHA;Mn;0;NSM;;;;;N;;;;;
11CAD;MARCHEN SUBJOINED LETTER SA;Mn;0;NSM;;;;;N;;;;;
11CAE;MARCHEN SUBJOINED LETTER HA;Mn;0;NSM;;;;;N;;;;;
11CAF;MARCHEN SUBJOINED LETTER A;Mn;0;NSM;;;;;N;;;;;
11CB0;MARCHEN VOWEL SIGN AA;Mn;0;NSM;;;;;N;;;;;
11CB1;MARCHEN VOWEL SIGN I;Mc;0;L;;;;;N;;;;;
11CB2;MARCHEN VOWEL SIGN U;Mn;0;NSM;;;;;N;;;;;
11CB3;MARCHEN VOWEL SIGN E;Mn;0;NSM;;;;;N;;;;;
11CB4;MARCHEN VOWEL SIGN O;Mc;0;L;;;;;N;;;;;
11CB5;MARCHEN SIGN ANUSVARA;Mn;0;NSM;;;;;N;;;;;
11CB6;MARCHEN SIGN CANDRABINDU;Mn;0;NSM;;;;;N;;;;;
11D00;MASARAM GONDI LETTER A;Lo;0;L;;;;;N;;;;;
11D01;MASARAM GONDI LETTER AA;Lo;0;L;;;;;N;;;;;
11D02;MASARAM GONDI LETTER I;Lo;0;L;;;;;N;;;;;
11D03;MASARAM GONDI LETTER II;Lo;0;L;;;;;N;;;;;
11D04;MASARAM GONDI LETTER U;Lo;0;L;;;;;N;;;;;
11D05;MASARAM GONDI LETTER UU;Lo;0;L;;;;;N;;;;;
11D06;MASARAM GONDI LETTER E;Lo;0;L;;;;;N;;;;;
11D08;MASARAM GONDI LETTER AI;Lo;0;L;;;;;N;;;;;
11D09;MASARAM GONDI LETTER O;Lo;0;L;;;;;N;;;;;
11D0B;MASARAM GONDI LETTER AU;Lo;0;L;;;;;N;;;;;
11D0C;MASARAM GONDI LETTER KA;Lo;0;L;;;;;N;;;;;
11D0D;MASARAM GONDI LETTER KHA;Lo;0;L;;;;;N;;;;;
11D0E;MASARAM GONDI LETTER GA;Lo;0;L;;;;;N;;;;;
11D0F;MASARAM GONDI LETTER GHA;Lo;0;L;;;;;N;;;;;
11D10;MASARAM GONDI LETTER NGA;Lo;0;L;;;;;N;;;;;
11D11;MASARAM GONDI LETTER CA;Lo;0;L;;;;;N;;;;;
11D12;MASARAM GONDI LETTER CHA;Lo;0;L;;;;;N;;;;;
11D13;MASARAM GONDI LETTER JA;Lo;0;L;;;;;N;;;;;
11D14;MASARAM GONDI LETTER JHA;Lo;0;L;;;;;N;;;;;
11D15;MASARAM GONDI LETTER NYA;Lo;0;L;;;;;N;;;;;
11D16;MASARAM GONDI LETTER TTA;Lo;0;L;;;;;N;;;;;
11D17;MASARAM GONDI LETTER TTHA;Lo;0;L;;;;;N;;;;;
11D18;MASARAM GONDI LETTER DDA;Lo;0;L;;;;;N;;;;;
11D19;MASARAM GONDI LETTER DDHA;Lo;0;L;;;;;N;;;;;
11D1A;MASARAM GONDI LETTER NNA;Lo;0;L;;;;;N;;;;;
11D1B;MASARAM GONDI LETTER TA;Lo;0;L;;;;;N;;;;;
11D1C;MASARAM GONDI LETTER THA;Lo;0;L;;;;;N;;;;;
11D1D;MASARAM GONDI LETTER DA;Lo;0;L;;;;;N;;;;;
11D1E;MASARAM GONDI LETTER DHA;Lo;0;L;;;;;N;;;;;
11D1F;MASARAM GONDI LETTER NA;Lo;0;L;;;;;N;;;;;
11D20;MASARAM GONDI LETTER PA;Lo;0;L;;;;;N;;;;;
11D21;MASARAM GONDI LETTER PHA;Lo;0;L;;;;;N;;;;;
11D22;MASARAM GONDI LETTER BA;Lo;0;L;;;;;N;;;;;
11D23;MASARAM GONDI LETTER BHA;Lo;0;L;;;;;N;;;;;
11D24;MASARAM GONDI LETTER MA;Lo;0;L;;;;;N;;;;;
11D25;MASARAM GONDI LETTER YA;Lo;0;L;;;;;N;;;;;
11D26;MASARAM GONDI LETTER RA;Lo;0;L;;;;;N;;;;;
11D27;MASARAM GONDI LETTER LA;Lo;0;L;;;;;N;;;;;
11D28;MASARAM GONDI LETTER VA;Lo;0;L;;;;;N;;;;;
11D29;MASARAM GONDI LETTER SHA;Lo;0;L;;;;;N;;;;;
11D2A;MASARAM GONDI LETTER SSA;Lo;0;L;;;;;N;;;;;
11D2B;MASARAM GONDI LETTER SA;Lo;0;L;;;;;N;;;;;
11D2C;MASARAM GONDI LETTER HA;Lo;0;L;;;;;N;;;;;
11D2D;MASARAM GONDI LETTER LLA;Lo;0;L;;;;;N;;;;;
11D2E;MASARAM GONDI LETTER KSSA;Lo;0;L;;;;;N;;;;;
11D2F;MASARAM GONDI LETTER JNYA;Lo;0;L;;;;;N;;;;;
11D30;MASARAM GONDI LETTER TRA;Lo;0;L;;;;;N;;;;;
11D31;MASARAM GONDI VOWEL SIGN AA;Mn;0;NSM;;;;;N;;;;;
11D32;MASARAM GONDI VOWEL SIGN I;Mn;0;NSM;;;;;N;;;;;
11D33;MASARAM GONDI VOWEL SIGN II;Mn;0;NSM;;;;;N;;;;;
11D34;MASARAM GONDI VOWEL SIGN U;Mn;0;NSM;;;;;N;;;;;
11D35;MASARAM GONDI VOWEL SIGN UU;Mn;0;NSM;;;;;N;;;;;
11D36;MASARAM GONDI VOWEL SIGN VOCALIC R;Mn;0;NSM;;;;;N;;;;;
11D3A;MASARAM GONDI VOWEL SIGN E;Mn;0;NSM;;;;;N;;;;;
11D3C;MASARAM GONDI VOWEL SIGN AI;Mn;0;NSM;;;;;N;;;;;
11D3D;MASARAM GONDI VOWEL SIGN O;Mn;0;NSM;;;;;N;;;;;
11D3F;MASARAM GONDI VOWEL SIGN AU;Mn;0;NSM;;;;;N;;;;;
11D40;MASARAM GONDI SIGN ANUSVARA;Mn;0;NSM;;;;;N;;;;;
11D41;MASARAM GONDI SIGN VISARGA;Mn;0;NSM;;;;;N;;;;;
11D42;MASARAM GONDI SIGN NUKTA;Mn;7;NSM;;;;;N;;;;;
11D43;MASARAM GONDI SIGN CANDRA;Mn;0;NSM;;;;;N;;;;;
11D44;MASARAM GONDI SIGN HALANTA;Mn;9;NSM;;;;;N;;;;;
11D45;MASARAM GONDI VIRAMA;Mn;9;NSM;;;;;N;;;;;
11D46;MASARAM GONDI REPHA;Lo;0;L;;;;;N;;;;;
11D47;MASARAM GONDI RA-KARA;Mn;0;NSM;;;;;N;;;;;
11D50;MASARAM GONDI DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
11D51;MASARAM GONDI DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
11D52;MASARAM GONDI DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
11D53;MASARAM GONDI DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
11D54;MASARAM GONDI DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
11D55;MASARAM GONDI DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
11D56;MASARAM GONDI DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
11D57;MASARAM GONDI DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
11D58;MASARAM GONDI DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
11D59;MASARAM GONDI DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
11D60;GUNJALA GONDI LETTER A;Lo;0;L;;;;;N;;;;;
11D61;GUNJALA GONDI LETTER AA;Lo;0;L;;;;;N;;;;;
11D62;GUNJALA GONDI LETTER I;Lo;0;L;;;;;N;;;;;
11D63;GUNJALA GONDI LETTER II;Lo;0;L;;;;;N;;;;;
11D64;GUNJALA GONDI LETTER U;Lo;0;L;;;;;N;;;;;
11D65;GUNJALA GONDI LETTER UU;Lo;0;L;;;;;N;;;;;
11D67;GUNJALA GONDI LETTER EE;Lo;0;L;;;;;N;;;;;
11D68;GUNJALA GONDI LETTER AI;Lo;0;L;;;;;N;;;;;
11D6A;GUNJALA GONDI LETTER OO;Lo;0;L;;;;;N;;;;;
11D6B;GUNJALA GONDI LETTER AU;Lo;0;L;;;;;N;;;;;
11D6C;GUNJALA GONDI LETTER YA;Lo;0;L;;;;;N;;;;;
11D6D;GUNJALA GONDI LETTER VA;Lo;0;L;;;;;N;;;;;
11D6E;GUNJALA GONDI LETTER BA;Lo;0;L;;;;;N;;;;;
11D6F;GUNJALA GONDI LETTER BHA;Lo;0;L;;;;;N;;;;;
11D70;GUNJALA GONDI LETTER MA;Lo;0;L;;;;;N;;;;;
11D71;GUNJALA GONDI LETTER KA;Lo;0;L;;;;;N;;;;;
11D72;GUNJALA GONDI LETTER KHA;Lo;0;L;;;;;N;;;;;
11D73;GUNJALA GONDI LETTER TA;Lo;0;L;;;;;N;;;;;
11D74;GUNJALA GONDI LETTER THA;Lo;0;L;;;;;N;;;;;
11D75;GUNJALA GONDI LETTER LA;Lo;0;L;;;;;N;;;;;
11D76;GUNJALA GONDI LETTER GA;Lo;0;L;;;;;N;;;;;
11D77;GUNJALA GONDI LETTER GHA;Lo;0;L;;;;;N;;;;;
11D78;GUNJALA GONDI LETTER DA;Lo;0;L;;;;;N;;;;;
11D79;GUNJALA GONDI LETTER DHA;Lo;0;L;;;;;N;;;;;
11D7A;GUNJALA GONDI LETTER NA;Lo;0;L;;;;;N;;;;;
11D7B;GUNJALA GONDI LETTER CA;Lo;0;L;;;;;N;;;;;
11D7C;GUNJALA GONDI LETTER CHA;Lo;0;L;;;;;N;;;;;
11D7D;GUNJALA GONDI LETTER TTA;Lo;0;L;;;;;N;;;;;
11D7E;GUNJALA GONDI LETTER TTHA;Lo;0;L;;;;;N;;;;;
11D7F;GUNJALA GONDI LETTER LLA;Lo;0;L;;;;;N;;;;;
11D80;GUNJALA GONDI LETTER JA;Lo;0;L;;;;;N;;;;;
11D81;GUNJALA GONDI LETTER JHA;Lo;0;L;;;;;N;;;;;
11D82;GUNJALA GONDI LETTER DDA;Lo;0;L;;;;;N;;;;;
11D83;GUNJALA GONDI LETTER DDHA;Lo;0;L;;;;;N;;;;;
11D84;GUNJALA GONDI LETTER NGA;Lo;0;L;;;;;N;;;;;
11D85;GUNJALA GONDI LETTER PA;Lo;0;L;;;;;N;;;;;
11D86;GUNJALA GONDI LETTER PHA;Lo;0;L;;;;;N;;;;;
11D87;GUNJALA GONDI LETTER HA;Lo;0;L;;;;;N;;;;;
11D88;GUNJALA GONDI LETTER RA;Lo;0;L;;;;;N;;;;;
11D89;GUNJALA GONDI LETTER SA;Lo;0;L;;;;;N;;;;;
11D8A;GUNJALA GONDI VOWEL SIGN AA;Mc;0;L;;;;;N;;;;;
11D8B;GUNJALA GONDI VOWEL SIGN I;Mc;0;L;;;;;N;;;;;
11D8C;GUNJALA GONDI VOWEL SIGN II;Mc;0;L;;;;;N;;;;;
11D8D;GUNJALA GONDI VOWEL SIGN U;Mc;0;L;;;;;N;;;;;
11D8E;GUNJALA GONDI VOWEL SIGN UU;Mc;0;L;;;;;N;;;;;
11D90;GUNJALA GONDI VOWEL SIGN EE;Mn;0;NSM;;;;;N;;;;;
11D91;GUNJALA GONDI VOWEL SIGN AI;Mn;0;NSM;;;;;N;;;;;
11D93;GUNJALA GONDI VOWEL SIGN OO;Mc;0;L;;;;;N;;;;;
11D94;GUNJALA GONDI VOWEL SIGN AU;Mc;0;L;;;;;N;;;;;
11D95;GUNJALA GONDI SIGN ANUSVARA;Mn;0;NSM;;;;;N;;;;;
11D96;GUNJALA GONDI SIGN VISARGA;Mc;0;L;;;;;N;;;;;
11D97;GUNJALA GONDI VIRAMA;Mn;9;NSM;;;;;N;;;;;
11D98;GUNJALA GONDI OM;Lo;0;L;;;;;N;;;;;
11DA0;GUNJALA GONDI DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
11DA1;GUNJALA GONDI DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
11DA2;GUNJALA GONDI DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
11DA3;GUNJALA GONDI DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
11DA4;GUNJALA GONDI DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
11DA5;GUNJALA GONDI DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
11DA6;GUNJALA GONDI DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
11DA7;GUNJALA GONDI DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
11DA8;GUNJALA GONDI DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
11DA9;GUNJALA GONDI DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
11EE0;MAKASAR LETTER KA;Lo;0;L;;;;;N;;;;;
11EE1;MAKASAR LETTER GA;Lo;0;L;;;;;N;;;;;
11EE2;MAKASAR LETTER NGA;Lo;0;L;;;;;N;;;;;
11EE3;MAKASAR LETTER PA;Lo;0;L;;;;;N;;;;;
11EE4;MAKASAR LETTER BA;Lo;0;L;;;;;N;;;;;
11EE5;MAKASAR LETTER MA;Lo;0;L;;;;;N;;;;;
11EE6;MAKASAR LETTER TA;Lo;0;L;;;;;N;;;;;
11EE7;MAKASAR LETTER DA;Lo;0;L;;;;;N;;;;;
11EE8;MAKASAR LETTER NA;Lo;0;L;;;;;N;;;;;
11EE9;MAKASAR LETTER CA;Lo;0;L;;;;;N;;;;;
11EEA;MAKASAR LETTER JA;Lo;0;L;;;;;N;;;;;
11EEB;MAKASAR LETTER NYA;Lo;0;L;;;;;N;;;;;
11EEC;MAKASAR LETTER YA;Lo;0;L;;;;;N;;;;;
11EED;MAKASAR LETTER RA;Lo;0;L;;;;;N;;;;;
11EEE;MAKASAR LETTER LA;Lo;0;L;;;;;N;;;;;
11EEF;MAKASAR LETTER VA;Lo;0;L;;;;;N;;;;;
11EF0;MAKASAR LETTER SA;Lo;0;L;;;;;N;;;;;
11EF1;MAKASAR LETTER A;Lo;0;L;;;;;N;;;;;
11EF2;MAKASAR ANGKA;Lo;0;L;;;;;N;;;;;
11EF3;MAKASAR VOWEL SIGN I;Mn;0;NSM;;;;;N;;;;;
11EF4;MAKASAR VOWEL SIGN U;Mn;0;NSM;;;;;N;;;;;
11EF5;MAKASAR VOWEL SIGN E;Mc;0;L;;;;;N;;;;;
11EF6;MAKASAR VOWEL SIGN O;Mc;0;L;;;;;N;;;;;
11EF7;MAKASAR PASSIMBANG;Po;0;L;;;;;N;;;;;
11EF8;MAKASAR END OF SECTION;Po;0;L;;;;;N;;;;;
11FB0;LISU LETTER YHA;Lo;0;L;;;;;N;;;;;
11FC0;TAMIL FRACTION ONE THREE-HUNDRED-AND-TWENTIETH;No;0;L;;;;1/320;N;;;;;
11FC1;TAMIL FRACTION ONE ONE-HUNDRED-AND-SIXTIETH;No;0;L;;;;1/160;N;;;;;
11FC2;TAMIL FRACTION ONE EIGHTIETH;No;0;L;;;;1/80;N;;;;;
11FC3;TAMIL FRACTION ONE SIXTY-FOURTH;No;0;L;;;;1/64;N;;;;;
11FC4;TAMIL FRACTION ONE FORTIETH;No;0;L;;;;1/40;N;;;;;
11FC5;TAMIL FRACTION ONE THIRTY-SECOND;No;0;L;;;;1/32;N;;;;;
11FC6;TAMIL FRACTION THREE EIGHTIETHS;No;0;L;;;;3/80;N;;;;;
11FC7;TAMIL FRACTION THREE SIXTY-FOURTHS;No;0;L;;;;3/64;N;;;;;
11FC8;TAMIL FRACTION ONE TWENTIETH;No;0;L;;;;1/20;N;;;;;
11FC9;TAMIL FRACTION ONE SIXTEENTH-1;No;0;L;;;;1/16;N;;;;;
11FCA;TAMIL FRACTION ONE SIXTEENTH-2;No;0;L;;;;1/16;N;;;;;
11FCB;TAMIL FRACTION ONE TENTH;No;0;L;;;;1/10;N;;;;;
11FCC;TAMIL FRACTION ONE EIGHTH;No;0;L;;;;1/8;N;;;;;
11FCD;TAMIL FRACTION THREE TWENTIETHS;No;0;L;;;;3/20;N;;;;;
11FCE;TAMIL FRACTION THREE SIXTEENTHS;No;0;L;;;;3/16;N;;;;;
11FCF;TAMIL FRACTION ONE FIFTH;No;0;L;;;;1/5;N;;;;;
11FD0;TAMIL FRACTION ONE QUARTER;No;0;L;;;;1/4;N;;;;;
11FD1;TAMIL FRACTION ONE HALF-1;No;0;L;;;;1/2;N;;;;;
11FD2;TAMIL FRACTION ONE HALF-2;No;0;L;;;;1/2;N;;;;;
11FD3;TAMIL FRACTION THREE QUARTERS;No;0;L;;;;3/4;N;;;;;
11FD4;TAMIL FRACTION DOWNSCALING FACTOR KIIZH;No;0;L;;;;1/320;N;;;;;
11FD5;TAMIL SIGN NEL;So;0;ON;;;;;N;;;;;
11FD6;TAMIL SIGN CEVITU;So;0;ON;;;;;N;;;;;
11FD7;TAMIL SIGN AAZHAAKKU;So;0;ON;;;;;N;;;;;
11FD8;TAMIL SIGN UZHAKKU;So;0;ON;;;;;N;;;;;
11FD9;TAMIL SIGN MUUVUZHAKKU;So;0;ON;;;;;N;;;;;
11FDA;TAMIL SIGN KURUNI;So;0;ON;;;;;N;;;;;
11FDB;TAMIL SIGN PATHAKKU;So;0;ON;;;;;N;;;;;
11FDC;TAMIL SIGN MUKKURUNI;So;0;ON;;;;;N;;;;;
11FDD;TAMIL SIGN KAACU;Sc;0;ET;;;;;N;;;;;
11FDE;TAMIL SIGN PANAM;Sc;0;ET;;;;;N;;;;;
11FDF;TAMIL SIGN PON;Sc;0;ET;;;;;N;;;;;
11FE0;TAMIL SIGN VARAAKAN;Sc;0;ET;;;;;N;;;;;
11FE1;TAMIL SIGN PAARAM;So;0;ON;;;;;N;;;;;
11FE2;TAMIL SIGN KUZHI;So;0;ON;;;;;N;;;;;
11FE3;TAMIL SIGN VELI;So;0;ON;;;;;N;;;;;
11FE4;TAMIL WET CULTIVATION SIGN;So;0;ON;;;;;N;;;;;
11FE5;TAMIL DRY CULTIVATION SIGN;So;0;ON;;;;;N;;;;;
11FE6;TAMIL LAND SIGN;So;0;ON;;;;;N;;;;;
11FE7;TAMIL SALT PAN SIGN;So;0;ON;;;;;N;;;;;
11FE8;TAMIL TRADITIONAL CREDIT SIGN;So;0;ON;;;;;N;;;;;
11FE9;TAMIL TRADITIONAL NUMBER SIGN;So;0;ON;;;;;N;;;;;
11FEA;TAMIL CURRENT SIGN;So;0;ON;;;;;N;;;;;
11FEB;TAMIL AND ODD SIGN;So;0;ON;;;;;N;;;;;
11FEC;TAMIL SPENT SIGN;So;0;ON;;;;;N;;;;;
11FED;TAMIL TOTAL SIGN;So;0;ON;;;;;N;;;;;
11FEE;TAMIL IN POSSESSION SIGN;So;0;ON;;;;;N;;;;;
11FEF;TAMIL STARTING FROM SIGN;So;0;ON;;;;;N;;;;;
11FF0;TAMIL SIGN MUTHALIYA;So;0;ON;;;;;N;;;;;
11FF1;TAMIL SIGN VAKAIYARAA;So;0;ON;;;;;N;;;;;
11FFF;TAMIL PUNCTUATION END OF TEXT;Po;0;L;;;;;N;;;;;
12000;CUNEIFORM SIGN A;Lo;0;L;;;;;N;;;;;
12001;CUNEIFORM SIGN A TIMES A;Lo;0;L;;;;;N;;;;;
12002;CUNEIFORM SIGN A TIMES BAD;Lo;0;L;;;;;N;;;;;
12003;CUNEIFORM SIGN A TIMES GAN2 TENU;Lo;0;L;;;;;N;;;;;
12004;CUNEIFORM SIGN A TIMES HA;Lo;0;L;;;;;N;;;;;
12005;CUNEIFORM SIGN A TIMES IGI;Lo;0;L;;;;;N;;;;;
12006;CUNEIFORM SIGN A TIMES LAGAR GUNU;Lo;0;L;;;;;N;;;;;
12007;CUNEIFORM SIGN A TIMES MUSH;Lo;0;L;;;;;N;;;;;
12008;CUNEIFORM SIGN A TIMES SAG;Lo;0;L;;;;;N;;;;;
12009;CUNEIFORM SIGN A2;Lo;0;L;;;;;N;;;;;
1200A;CUNEIFORM SIGN AB;Lo;0;L;;;;;N;;;;;
1200B;CUNEIFORM SIGN AB TIMES ASH2;Lo;0;L;;;;;N;;;;;
1200C;CUNEIFORM SIGN AB TIMES DUN3 GUNU;Lo;0;L;;;;;N;;;;;
1200D;CUNEIFORM SIGN AB TIMES GAL;Lo;0;L;;;;;N;;;;;
1200E;CUNEIFORM SIGN AB TIMES GAN2 TENU;Lo;0;L;;;;;N;;;;;
1200F;CUNEIFORM SIGN AB TIMES HA;Lo;0;L;;;;;N;;;;;
12010;CUNEIFORM SIGN AB TIMES IGI GUNU;Lo;0;L;;;;;N;;;;;
12011;CUNEIFORM SIGN AB TIMES IMIN;Lo;0;L;;;;;N;;;;;
12012;CUNEIFORM SIGN AB TIMES LAGAB;Lo;0;L;;;;;N;;;;;
12013;CUNEIFORM SIGN AB TIMES SHESH;Lo;0;L;;;;;N;;;;;
12014;CUNEIFORM SIGN AB TIMES U PLUS U PLUS U;Lo;0;L;;;;;N;;;;;
12015;CUNEIFORM SIGN AB GUNU;Lo;0;L;;;;;N;;;;;
12016;CUNEIFORM SIGN AB2;Lo;0;L;;;;;N;;;;;
12017;CUNEIFORM SIGN AB2 TIMES BALAG;Lo;0;L;;;;;N;;;;;
12018;CUNEIFORM SIGN AB2 TIMES GAN2 TENU;Lo;0;L;;;;;N;;;;;
12019;CUNEIFORM SIGN AB2 TIMES ME PLUS EN;Lo;0;L;;;;;N;;;;;
1201A;CUNEIFORM SIGN AB2 TIMES SHA3;Lo;0;L;;;;;N;;;;;
1201B;CUNEIFORM SIGN AB2 TIMES TAK4;Lo;0;L;;;;;N;;;;;
1201C;CUNEIFORM SIGN AD;Lo;0;L;;;;;N;;;;;
1201D;CUNEIFORM SIGN AK;Lo;0;L;;;;;N;;;;;
1201E;CUNEIFORM SIGN AK TIMES ERIN2;Lo;0;L;;;;;N;;;;;
1201F;CUNEIFORM SIGN AK TIMES SHITA PLUS GISH;Lo;0;L;;;;;N;;;;;
12020;CUNEIFORM SIGN AL;Lo;0;L;;;;;N;;;;;
12021;CUNEIFORM SIGN AL TIMES AL;Lo;0;L;;;;;N;;;;;
12022;CUNEIFORM SIGN AL TIMES DIM2;Lo;0;L;;;;;N;;;;;
12023;CUNEIFORM SIGN AL TIMES GISH;Lo;0;L;;;;;N;;;;;
12024;CUNEIFORM SIGN AL TIMES HA;Lo;0;L;;;;;N;;;;;
12025;CUNEIFORM SIGN AL TIMES KAD3;Lo;0;L;;;;;N;;;;;
12026;CUNEIFORM SIGN AL TIMES KI;Lo;0;L;;;;;N;;;;;
12027;CUNEIFORM SIGN AL TIMES SHE;Lo;0;L;;;;;N;;;;;
12028;CUNEIFORM SIGN AL TIMES USH;Lo;0;L;;;;;N;;;;;
12029;CUNEIFORM SIGN ALAN;Lo;0;L;;;;;N;;;;;
1202A;CUNEIFORM SIGN ALEPH;Lo;0;L;;;;;N;;;;;
1202B;CUNEIFORM SIGN AMAR;Lo;0;L;;;;;N;;;;;
1202C;CUNEIFORM SIGN AMAR TIMES SHE;Lo;0;L;;;;;N;;;;;
1202D;CUNEIFORM SIGN AN;Lo;0;L;;;;;N;;;;;
1202E;CUNEIFORM SIGN AN OVER AN;Lo;0;L;;;;;N;;;;;
1202F;CUNEIFORM SIGN AN THREE TIMES;Lo;0;L;;;;;N;;;;;
12030;CUNEIFORM SIGN AN PLUS NAGA OPPOSING AN PLUS NAGA;Lo;0;L;;;;;N;;;;;
12031;CUNEIFORM SIGN AN PLUS NAGA SQUARED;Lo;0;L;;;;;N;;;;;
12032;CUNEIFORM SIGN ANSHE;Lo;0;L;;;;;N;;;;;
12033;CUNEIFORM SIGN APIN;Lo;0;L;;;;;N;;;;;
12034;CUNEIFORM SIGN ARAD;Lo;0;L;;;;;N;;;;;
12035;CUNEIFORM SIGN ARAD TIMES KUR;Lo;0;L;;;;;N;;;;;
12036;CUNEIFORM SIGN ARKAB;Lo;0;L;;;;;N;;;;;
12037;CUNEIFORM SIGN ASAL2;Lo;0;L;;;;;N;;;;;
12038;CUNEIFORM SIGN ASH;Lo;0;L;;;;;N;;;;;
12039;CUNEIFORM SIGN ASH ZIDA TENU;Lo;0;L;;;;;N;;;;;
1203A;CUNEIFORM SIGN ASH KABA TENU;Lo;0;L;;;;;N;;;;;
1203B;CUNEIFORM SIGN ASH OVER ASH TUG2 OVER TUG2 TUG2 OVER TUG2 PAP;Lo;0;L;;;;;N;;;;;
1203C;CUNEIFORM SIGN ASH OVER ASH OVER ASH;Lo;0;L;;;;;N;;;;;
1203D;CUNEIFORM SIGN ASH OVER ASH OVER ASH CROSSING ASH OVER ASH OVER ASH;Lo;0;L;;;;;N;;;;;
1203E;CUNEIFORM SIGN ASH2;Lo;0;L;;;;;N;;;;;
1203F;CUNEIFORM SIGN ASHGAB;Lo;0;L;;;;;N;;;;;
12040;CUNEIFORM SIGN BA;Lo;0;L;;;;;N;;;;;
12041;CUNEIFORM SIGN BAD;Lo;0;L;;;;;N;;;;;
12042;CUNEIFORM SIGN BAG3;Lo;0;L;;;;;N;;;;;
12043;CUNEIFORM SIGN BAHAR2;Lo;0;L;;;;;N;;;;;
12044;CUNEIFORM SIGN BAL;Lo;0;L;;;;;N;;;;;
12045;CUNEIFORM SIGN BAL OVER BAL;Lo;0;L;;;;;N;;;;;
12046;CUNEIFORM SIGN BALAG;Lo;0;L;;;;;N;;;;;
12047;CUNEIFORM SIGN BAR;Lo;0;L;;;;;N;;;;;
12048;CUNEIFORM SIGN BARA2;Lo;0;L;;;;;N;;;;;
12049;CUNEIFORM SIGN BI;Lo;0;L;;;;;N;;;;;
1204A;CUNEIFORM SIGN BI TIMES A;Lo;0;L;;;;;N;;;;;
1204B;CUNEIFORM SIGN BI TIMES GAR;Lo;0;L;;;;;N;;;;;
1204C;CUNEIFORM SIGN BI TIMES IGI GUNU;Lo;0;L;;;;;N;;;;;
1204D;CUNEIFORM SIGN BU;Lo;0;L;;;;;N;;;;;
1204E;CUNEIFORM SIGN BU OVER BU AB;Lo;0;L;;;;;N;;;;;
1204F;CUNEIFORM SIGN BU OVER BU UN;Lo;0;L;;;;;N;;;;;
12050;CUNEIFORM SIGN BU CROSSING BU;Lo;0;L;;;;;N;;;;;
12051;CUNEIFORM SIGN BULUG;Lo;0;L;;;;;N;;;;;
12052;CUNEIFORM SIGN BULUG OVER BULUG;Lo;0;L;;;;;N;;;;;
12053;CUNEIFORM SIGN BUR;Lo;0;L;;;;;N;;;;;
12054;CUNEIFORM SIGN BUR2;Lo;0;L;;;;;N;;;;;
12055;CUNEIFORM SIGN DA;Lo;0;L;;;;;N;;;;;
12056;CUNEIFORM SIGN DAG;Lo;0;L;;;;;N;;;;;
12057;CUNEIFORM SIGN DAG KISIM5 TIMES A PLUS MASH;Lo;0;L;;;;;N;;;;;
12058;CUNEIFORM SIGN DAG KISIM5 TIMES AMAR;Lo;0;L;;;;;N;;;;;
12059;CUNEIFORM SIGN DAG KISIM5 TIMES BALAG;Lo;0;L;;;;;N;;;;;
1205A;CUNEIFORM SIGN DAG KISIM5 TIMES BI;Lo;0;L;;;;;N;;;;;
1205B;CUNEIFORM SIGN DAG KISIM5 TIMES GA;Lo;0;L;;;;;N;;;;;
1205C;CUNEIFORM SIGN DAG KISIM5 TIMES GA PLUS MASH;Lo;0;L;;;;;N;;;;;
1205D;CUNEIFORM SIGN DAG KISIM5 TIMES GI;Lo;0;L;;;;;N;;;;;
1205E;CUNEIFORM SIGN DAG KISIM5 TIMES GIR2;Lo;0;L;;;;;N;;;;;
1205F;CUNEIFORM SIGN DAG KISIM5 TIMES GUD;Lo;0;L;;;;;N;;;;;
12060;CUNEIFORM SIGN DAG KISIM5 TIMES HA;Lo;0;L;;;;;N;;;;;
12061;CUNEIFORM SIGN DAG KISIM5 TIMES IR;Lo;0;L;;;;;N;;;;;
12062;CUNEIFORM SIGN DAG KISIM5 TIMES IR PLUS LU;Lo;0;L;;;;;N;;;;;
12063;CUNEIFORM SIGN DAG KISIM5 TIMES KAK;Lo;0;L;;;;;N;;;;;
12064;CUNEIFORM SIGN DAG KISIM5 TIMES LA;Lo;0;L;;;;;N;;;;;
12065;CUNEIFORM SIGN DAG KISIM5 TIMES LU;Lo;0;L;;;;;N;;;;;
12066;CUNEIFORM SIGN DAG KISIM5 TIMES LU PLUS MASH2;Lo;0;L;;;;;N;;;;;
12067;CUNEIFORM SIGN DAG KISIM5 TIMES LUM;Lo;0;L;;;;;N;;;;;
12068;CUNEIFORM SIGN DAG KISIM5 TIMES NE;Lo;0;L;;;;;N;;;;;
12069;CUNEIFORM SIGN DAG KISIM5 TIMES PAP PLUS PAP;Lo;0;L;;;;;N;;;;;
1206A;CUNEIFORM SIGN DAG KISIM5 TIMES SI;Lo;0;L;;;;;N;;;;;
1206B;CUNEIFORM SIGN DAG KISIM5 TIMES TAK4;Lo;0;L;;;;;N;;;;;
1206C;CUNEIFORM SIGN DAG KISIM5 TIMES U2 PLUS GIR2;Lo;0;L;;;;;N;;;;;
1206D;CUNEIFORM SIGN DAG KISIM5 TIMES USH;Lo;0;L;;;;;N;;;;;
1206E;CUNEIFORM SIGN DAM;Lo;0;L;;;;;N;;;;;
1206F;CUNEIFORM SIGN DAR;Lo;0;L;;;;;N;;;;;
12070;CUNEIFORM SIGN DARA3;Lo;0;L;;;;;N;;;;;
12071;CUNEIFORM SIGN DARA4;Lo;0;L;;;;;N;;;;;
12072;CUNEIFORM SIGN DI;Lo;0;L;;;;;N;;;;;
12073;CUNEIFORM SIGN DIB;Lo;0;L;;;;;N;;;;;
12074;CUNEIFORM SIGN DIM;Lo;0;L;;;;;N;;;;;
12075;CUNEIFORM SIGN DIM TIMES SHE;Lo;0;L;;;;;N;;;;;
12076;CUNEIFORM SIGN DIM2;Lo;0;L;;;;;N;;;;;
12077;CUNEIFORM SIGN DIN;Lo;0;L;;;;;N;;;;;
12078;CUNEIFORM SIGN DIN KASKAL U GUNU DISH;Lo;0;L;;;;;N;;;;;
12079;CUNEIFORM SIGN DISH;Lo;0;L;;;;;N;;;;;
1207A;CUNEIFORM SIGN DU;Lo;0;L;;;;;N;;;;;
1207B;CUNEIFORM SIGN DU OVER DU;Lo;0;L;;;;;N;;;;;
1207C;CUNEIFORM SIGN DU GUNU;Lo;0;L;;;;;N;;;;;
1207D;CUNEIFORM SIGN DU SHESHIG;Lo;0;L;;;;;N;;;;;
1207E;CUNEIFORM SIGN DUB;Lo;0;L;;;;;N;;;;;
1207F;CUNEIFORM SIGN DUB TIMES ESH2;Lo;0;L;;;;;N;;;;;
12080;CUNEIFORM SIGN DUB2;Lo;0;L;;;;;N;;;;;
12081;CUNEIFORM SIGN DUG;Lo;0;L;;;;;N;;;;;
12082;CUNEIFORM SIGN DUGUD;Lo;0;L;;;;;N;;;;;
12083;CUNEIFORM SIGN DUH;Lo;0;L;;;;;N;;;;;
12084;CUNEIFORM SIGN DUN;Lo;0;L;;;;;N;;;;;
12085;CUNEIFORM SIGN DUN3;Lo;0;L;;;;;N;;;;;
12086;CUNEIFORM SIGN DUN3 GUNU;Lo;0;L;;;;;N;;;;;
12087;CUNEIFORM SIGN DUN3 GUNU GUNU;Lo;0;L;;;;;N;;;;;
12088;CUNEIFORM SIGN DUN4;Lo;0;L;;;;;N;;;;;
12089;CUNEIFORM SIGN DUR2;Lo;0;L;;;;;N;;;;;
1208A;CUNEIFORM SIGN E;Lo;0;L;;;;;N;;;;;
1208B;CUNEIFORM SIGN E TIMES PAP;Lo;0;L;;;;;N;;;;;
1208C;CUNEIFORM SIGN E OVER E NUN OVER NUN;Lo;0;L;;;;;N;;;;;
1208D;CUNEIFORM SIGN E2;Lo;0;L;;;;;N;;;;;
1208E;CUNEIFORM SIGN E2 TIMES A PLUS HA PLUS DA;Lo;0;L;;;;;N;;;;;
1208F;CUNEIFORM SIGN E2 TIMES GAR;Lo;0;L;;;;;N;;;;;
12090;CUNEIFORM SIGN E2 TIMES MI;Lo;0;L;;;;;N;;;;;
12091;CUNEIFORM SIGN E2 TIMES SAL;Lo;0;L;;;;;N;;;;;
12092;CUNEIFORM SIGN E2 TIMES SHE;Lo;0;L;;;;;N;;;;;
12093;CUNEIFORM SIGN E2 TIMES U;Lo;0;L;;;;;N;;;;;
12094;CUNEIFORM SIGN EDIN;Lo;0;L;;;;;N;;;;;
12095;CUNEIFORM SIGN EGIR;Lo;0;L;;;;;N;;;;;
12096;CUNEIFORM SIGN EL;Lo;0;L;;;;;N;;;;;
12097;CUNEIFORM SIGN EN;Lo;0;L;;;;;N;;;;;
12098;CUNEIFORM SIGN EN TIMES GAN2;Lo;0;L;;;;;N;;;;;
12099;CUNEIFORM SIGN EN TIMES GAN2 TENU;Lo;0;L;;;;;N;;;;;
1209A;CUNEIFORM SIGN EN TIMES ME;Lo;0;L;;;;;N;;;;;
1209B;CUNEIFORM SIGN EN CROSSING EN;Lo;0;L;;;;;N;;;;;
1209C;CUNEIFORM SIGN EN OPPOSING EN;Lo;0;L;;;;;N;;;;;
1209D;CUNEIFORM SIGN EN SQUARED;Lo;0;L;;;;;N;;;;;
1209E;CUNEIFORM SIGN EREN;Lo;0;L;;;;;N;;;;;
1209F;CUNEIFORM SIGN ERIN2;Lo;0;L;;;;;N;;;;;
120A0;CUNEIFORM SIGN ESH2;Lo;0;L;;;;;N;;;;;
120A1;CUNEIFORM SIGN EZEN;Lo;0;L;;;;;N;;;;;
120A2;CUNEIFORM SIGN EZEN TIMES A;Lo;0;L;;;;;N;;;;;
120A3;CUNEIFORM SIGN EZEN TIMES A PLUS LAL;Lo;0;L;;;;;N;;;;;
120A4;CUNEIFORM SIGN EZEN TIMES A PLUS LAL TIMES LAL;Lo;0;L;;;;;N;;;;;
120A5;CUNEIFORM SIGN EZEN TIMES AN;Lo;0;L;;;;;N;;;;;
120A6;CUNEIFORM SIGN EZEN TIMES BAD;Lo;0;L;;;;;N;;;;;
120A7;CUNEIFORM SIGN EZEN TIMES DUN3 GUNU;Lo;0;L;;;;;N;;;;;
120A8;CUNEIFORM SIGN EZEN TIMES DUN3 GUNU GUNU;Lo;0;L;;;;;N;;;;;
120A9;CUNEIFORM SIGN EZEN TIMES HA;Lo;0;L;;;;;N;;;;;
120AA;CUNEIFORM SIGN EZEN TIMES HA GUNU;Lo;0;L;;;;;N;;;;;
120AB;CUNEIFORM SIGN EZEN TIMES IGI GUNU;Lo;0;L;;;;;N;;;;;
120AC;CUNEIFORM SIGN EZEN TIMES KASKAL;Lo;0;L;;;;;N;;;;;
120AD;CUNEIFORM SIGN EZEN TIMES KASKAL SQUARED;Lo;0;L;;;;;N;;;;;
120AE;CUNEIFORM SIGN EZEN TIMES KU3;Lo;0;L;;;;;N;;;;;
120AF;CUNEIFORM SIGN EZEN TIMES LA;Lo;0;L;;;;;N;;;;;
120B0;CUNEIFORM SIGN EZEN TIMES LAL TIMES LAL;Lo;0;L;;;;;N;;;;;
120B1;CUNEIFORM SIGN EZEN TIMES LI;Lo;0;L;;;;;N;;;;;
120B2;CUNEIFORM SIGN EZEN TIMES LU;Lo;0;L;;;;;N;;;;;
120B3;CUNEIFORM SIGN EZEN TIMES U2;Lo;0;L;;;;;N;;;;;
120B4;CUNEIFORM SIGN EZEN TIMES UD;Lo;0;L;;;;;N;;;;;
120B5;CUNEIFORM SIGN GA;Lo;0;L;;;;;N;;;;;
120B6;CUNEIFORM SIGN GA GUNU;Lo;0;L;;;;;N;;;;;
120B7;CUNEIFORM SIGN GA2;Lo;0;L;;;;;N;;;;;
120B8;CUNEIFORM SIGN GA2 TIMES A PLUS DA PLUS HA;Lo;0;L;;;;;N;;;;;
120B9;CUNEIFORM SIGN GA2 TIMES A PLUS HA;Lo;0;L;;;;;N;;;;;
120BA;CUNEIFORM SIGN GA2 TIMES A PLUS IGI;Lo;0;L;;;;;N;;;;;
120BB;CUNEIFORM SIGN GA2 TIMES AB2 TENU PLUS TAB;Lo;0;L;;;;;N;;;;;
120BC;CUNEIFORM SIGN GA2 TIMES AN;Lo;0;L;;;;;N;;;;;
120BD;CUNEIFORM SIGN GA2 TIMES ASH;Lo;0;L;;;;;N;;;;;
120BE;CUNEIFORM SIGN GA2 TIMES ASH2 PLUS GAL;Lo;0;L;;;;;N;;;;;
120BF;CUNEIFORM SIGN GA2 TIMES BAD;Lo;0;L;;;;;N;;;;;
120C0;CUNEIFORM SIGN GA2 TIMES BAR PLUS RA;Lo;0;L;;;;;N;;;;;
120C1;CUNEIFORM SIGN GA2 TIMES BUR;Lo;0;L;;;;;N;;;;;
120C2;CUNEIFORM SIGN GA2 TIMES BUR PLUS RA;Lo;0;L;;;;;N;;;;;
120C3;CUNEIFORM SIGN GA2 TIMES DA;Lo;0;L;;;;;N;;;;;
120C4;CUNEIFORM SIGN GA2 TIMES DI;Lo;0;L;;;;;N;;;;;
120C5;CUNEIFORM SIGN GA2 TIMES DIM TIMES SHE;Lo;0;L;;;;;N;;;;;
120C6;CUNEIFORM SIGN GA2 TIMES DUB;Lo;0;L;;;;;N;;;;;
120C7;CUNEIFORM SIGN GA2 TIMES EL;Lo;0;L;;;;;N;;;;;
120C8;CUNEIFORM SIGN GA2 TIMES EL PLUS LA;Lo;0;L;;;;;N;;;;;
120C9;CUNEIFORM SIGN GA2 TIMES EN;Lo;0;L;;;;;N;;;;;
120CA;CUNEIFORM SIGN GA2 TIMES EN TIMES GAN2 TENU;Lo;0;L;;;;;N;;;;;
120CB;CUNEIFORM SIGN GA2 TIMES GAN2 TENU;Lo;0;L;;;;;N;;;;;
120CC;CUNEIFORM SIGN GA2 TIMES GAR;Lo;0;L;;;;;N;;;;;
120CD;CUNEIFORM SIGN GA2 TIMES GI;Lo;0;L;;;;;N;;;;;
120CE;CUNEIFORM SIGN GA2 TIMES GI4;Lo;0;L;;;;;N;;;;;
120CF;CUNEIFORM SIGN GA2 TIMES GI4 PLUS A;Lo;0;L;;;;;N;;;;;
120D0;CUNEIFORM SIGN GA2 TIMES GIR2 PLUS SU;Lo;0;L;;;;;N;;;;;
120D1;CUNEIFORM SIGN GA2 TIMES HA PLUS LU PLUS ESH2;Lo;0;L;;;;;N;;;;;
120D2;CUNEIFORM SIGN GA2 TIMES HAL;Lo;0;L;;;;;N;;;;;
120D3;CUNEIFORM SIGN GA2 TIMES HAL PLUS LA;Lo;0;L;;;;;N;;;;;
120D4;CUNEIFORM SIGN GA2 TIMES HI PLUS LI;Lo;0;L;;;;;N;;;;;
120D5;CUNEIFORM SIGN GA2 TIMES HUB2;Lo;0;L;;;;;N;;;;;
120D6;CUNEIFORM SIGN GA2 TIMES IGI GUNU;Lo;0;L;;;;;N;;;;;
120D7;CUNEIFORM SIGN GA2 TIMES ISH PLUS HU PLUS ASH;Lo;0;L;;;;;N;;;;;
120D8;CUNEIFORM SIGN GA2 TIMES KAK;Lo;0;L;;;;;N;;;;;
120D9;CUNEIFORM SIGN GA2 TIMES KASKAL;Lo;0;L;;;;;N;;;;;
120DA;CUNEIFORM SIGN GA2 TIMES KID;Lo;0;L;;;;;N;;;;;
120DB;CUNEIFORM SIGN GA2 TIMES KID PLUS LAL;Lo;0;L;;;;;N;;;;;
120DC;CUNEIFORM SIGN GA2 TIMES KU3 PLUS AN;Lo;0;L;;;;;N;;;;;
120DD;CUNEIFORM SIGN GA2 TIMES LA;Lo;0;L;;;;;N;;;;;
120DE;CUNEIFORM SIGN GA2 TIMES ME PLUS EN;Lo;0;L;;;;;N;;;;;
120DF;CUNEIFORM SIGN GA2 TIMES MI;Lo;0;L;;;;;N;;;;;
120E0;CUNEIFORM SIGN GA2 TIMES NUN;Lo;0;L;;;;;N;;;;;
120E1;CUNEIFORM SIGN GA2 TIMES NUN OVER NUN;Lo;0;L;;;;;N;;;;;
120E2;CUNEIFORM SIGN GA2 TIMES PA;Lo;0;L;;;;;N;;;;;
120E3;CUNEIFORM SIGN GA2 TIMES SAL;Lo;0;L;;;;;N;;;;;
120E4;CUNEIFORM SIGN GA2 TIMES SAR;Lo;0;L;;;;;N;;;;;
120E5;CUNEIFORM SIGN GA2 TIMES SHE;Lo;0;L;;;;;N;;;;;
120E6;CUNEIFORM SIGN GA2 TIMES SHE PLUS TUR;Lo;0;L;;;;;N;;;;;
120E7;CUNEIFORM SIGN GA2 TIMES SHID;Lo;0;L;;;;;N;;;;;
120E8;CUNEIFORM SIGN GA2 TIMES SUM;Lo;0;L;;;;;N;;;;;
120E9;CUNEIFORM SIGN GA2 TIMES TAK4;Lo;0;L;;;;;N;;;;;
120EA;CUNEIFORM SIGN GA2 TIMES U;Lo;0;L;;;;;N;;;;;
120EB;CUNEIFORM SIGN GA2 TIMES UD;Lo;0;L;;;;;N;;;;;
120EC;CUNEIFORM SIGN GA2 TIMES UD PLUS DU;Lo;0;L;;;;;N;;;;;
120ED;CUNEIFORM SIGN GA2 OVER GA2;Lo;0;L;;;;;N;;;;;
120EE;CUNEIFORM SIGN GABA;Lo;0;L;;;;;N;;;;;
120EF;CUNEIFORM SIGN GABA CROSSING GABA;Lo;0;L;;;;;N;;;;;
120F0;CUNEIFORM SIGN GAD;Lo;0;L;;;;;N;;;;;
120F1;CUNEIFORM SIGN GAD OVER GAD GAR OVER GAR;Lo;0;L;;;;;N;;;;;
120F2;CUNEIFORM SIGN GAL;Lo;0;L;;;;;N;;;;;
120F3;CUNEIFORM SIGN GAL GAD OVER GAD GAR OVER GAR;Lo;0;L;;;;;N;;;;;
120F4;CUNEIFORM SIGN GALAM;Lo;0;L;;;;;N;;;;;
120F5;CUNEIFORM SIGN GAM;Lo;0;L;;;;;N;;;;;
120F6;CUNEIFORM SIGN GAN;Lo;0;L;;;;;N;;;;;
120F7;CUNEIFORM SIGN GAN2;Lo;0;L;;;;;N;;;;;
120F8;CUNEIFORM SIGN GAN2 TENU;Lo;0;L;;;;;N;;;;;
120F9;CUNEIFORM SIGN GAN2 OVER GAN2;Lo;0;L;;;;;N;;;;;
120FA;CUNEIFORM SIGN GAN2 CROSSING GAN2;Lo;0;L;;;;;N;;;;;
120FB;CUNEIFORM SIGN GAR;Lo;0;L;;;;;N;;;;;
120FC;CUNEIFORM SIGN GAR3;Lo;0;L;;;;;N;;;;;
120FD;CUNEIFORM SIGN GASHAN;Lo;0;L;;;;;N;;;;;
120FE;CUNEIFORM SIGN GESHTIN;Lo;0;L;;;;;N;;;;;
120FF;CUNEIFORM SIGN GESHTIN TIMES KUR;Lo;0;L;;;;;N;;;;;
12100;CUNEIFORM SIGN GI;Lo;0;L;;;;;N;;;;;
12101;CUNEIFORM SIGN GI TIMES E;Lo;0;L;;;;;N;;;;;
12102;CUNEIFORM SIGN GI TIMES U;Lo;0;L;;;;;N;;;;;
12103;CUNEIFORM SIGN GI CROSSING GI;Lo;0;L;;;;;N;;;;;
12104;CUNEIFORM SIGN GI4;Lo;0;L;;;;;N;;;;;
12105;CUNEIFORM SIGN GI4 OVER GI4;Lo;0;L;;;;;N;;;;;
12106;CUNEIFORM SIGN GI4 CROSSING GI4;Lo;0;L;;;;;N;;;;;
12107;CUNEIFORM SIGN GIDIM;Lo;0;L;;;;;N;;;;;
12108;CUNEIFORM SIGN GIR2;Lo;0;L;;;;;N;;;;;
12109;CUNEIFORM SIGN GIR2 GUNU;Lo;0;L;;;;;N;;;;;
1210A;CUNEIFORM SIGN GIR3;Lo;0;L;;;;;N;;;;;
1210B;CUNEIFORM SIGN GIR3 TIMES A PLUS IGI;Lo;0;L;;;;;N;;;;;
1210C;CUNEIFORM SIGN GIR3 TIMES GAN2 TENU;Lo;0;L;;;;;N;;;;;
1210D;CUNEIFORM SIGN GIR3 TIMES IGI;Lo;0;L;;;;;N;;;;;
1210E;CUNEIFORM SIGN GIR3 TIMES LU PLUS IGI;Lo;0;L;;;;;N;;;;;
1210F;CUNEIFORM SIGN GIR3 TIMES PA;Lo;0;L;;;;;N;;;;;
12110;CUNEIFORM SIGN GISAL;Lo;0;L;;;;;N;;;;;
12111;CUNEIFORM SIGN GISH;Lo;0;L;;;;;N;;;;;
12112;CUNEIFORM SIGN GISH CROSSING GISH;Lo;0;L;;;;;N;;;;;
12113;CUNEIFORM SIGN GISH TIMES BAD;Lo;0;L;;;;;N;;;;;
12114;CUNEIFORM SIGN GISH TIMES TAK4;Lo;0;L;;;;;N;;;;;
12115;CUNEIFORM SIGN GISH TENU;Lo;0;L;;;;;N;;;;;
12116;CUNEIFORM SIGN GU;Lo;0;L;;;;;N;;;;;
12117;CUNEIFORM SIGN GU CROSSING GU;Lo;0;L;;;;;N;;;;;
12118;CUNEIFORM SIGN GU2;Lo;0;L;;;;;N;;;;;
12119;CUNEIFORM SIGN GU2 TIMES KAK;Lo;0;L;;;;;N;;;;;
1211A;CUNEIFORM SIGN GU2 TIMES KAK TIMES IGI GUNU;Lo;0;L;;;;;N;;;;;
1211B;CUNEIFORM SIGN GU2 TIMES NUN;Lo;0;L;;;;;N;;;;;
1211C;CUNEIFORM SIGN GU2 TIMES SAL PLUS TUG2;Lo;0;L;;;;;N;;;;;
1211D;CUNEIFORM SIGN GU2 GUNU;Lo;0;L;;;;;N;;;;;
1211E;CUNEIFORM SIGN GUD;Lo;0;L;;;;;N;;;;;
1211F;CUNEIFORM SIGN GUD TIMES A PLUS KUR;Lo;0;L;;;;;N;;;;;
12120;CUNEIFORM SIGN GUD TIMES KUR;Lo;0;L;;;;;N;;;;;
12121;CUNEIFORM SIGN GUD OVER GUD LUGAL;Lo;0;L;;;;;N;;;;;
12122;CUNEIFORM SIGN GUL;Lo;0;L;;;;;N;;;;;
12123;CUNEIFORM SIGN GUM;Lo;0;L;;;;;N;;;;;
12124;CUNEIFORM SIGN GUM TIMES SHE;Lo;0;L;;;;;N;;;;;
12125;CUNEIFORM SIGN GUR;Lo;0;L;;;;;N;;;;;
12126;CUNEIFORM SIGN GUR7;Lo;0;L;;;;;N;;;;;
12127;CUNEIFORM SIGN GURUN;Lo;0;L;;;;;N;;;;;
12128;CUNEIFORM SIGN GURUSH;Lo;0;L;;;;;N;;;;;
12129;CUNEIFORM SIGN HA;Lo;0;L;;;;;N;;;;;
1212A;CUNEIFORM SIGN HA TENU;Lo;0;L;;;;;N;;;;;
1212B;CUNEIFORM SIGN HA GUNU;Lo;0;L;;;;;N;;;;;
1212C;CUNEIFORM SIGN HAL;Lo;0;L;;;;;N;;;;;
1212D;CUNEIFORM SIGN HI;Lo;0;L;;;;;N;;;;;
1212E;CUNEIFORM SIGN HI TIMES ASH;Lo;0;L;;;;;N;;;;;
1212F;CUNEIFORM SIGN HI TIMES ASH2;Lo;0;L;;;;;N;;;;;
12130;CUNEIFORM SIGN HI TIMES BAD;Lo;0;L;;;;;N;;;;;
12131;CUNEIFORM SIGN HI TIMES DISH;Lo;0;L;;;;;N;;;;;
12132;CUNEIFORM SIGN HI TIMES GAD;Lo;0;L;;;;;N;;;;;
12133;CUNEIFORM SIGN HI TIMES KIN;Lo;0;L;;;;;N;;;;;
12134;CUNEIFORM SIGN HI TIMES NUN;Lo;0;L;;;;;N;;;;;
12135;CUNEIFORM SIGN HI TIMES SHE;Lo;0;L;;;;;N;;;;;
12136;CUNEIFORM SIGN HI TIMES U;Lo;0;L;;;;;N;;;;;
12137;CUNEIFORM SIGN HU;Lo;0;L;;;;;N;;;;;
12138;CUNEIFORM SIGN HUB2;Lo;0;L;;;;;N;;;;;
12139;CUNEIFORM SIGN HUB2 TIMES AN;Lo;0;L;;;;;N;;;;;
1213A;CUNEIFORM SIGN HUB2 TIMES HAL;Lo;0;L;;;;;N;;;;;
1213B;CUNEIFORM SIGN HUB2 TIMES KASKAL;Lo;0;L;;;;;N;;;;;
1213C;CUNEIFORM SIGN HUB2 TIMES LISH;Lo;0;L;;;;;N;;;;;
1213D;CUNEIFORM SIGN HUB2 TIMES UD;Lo;0;L;;;;;N;;;;;
1213E;CUNEIFORM SIGN HUL2;Lo;0;L;;;;;N;;;;;
1213F;CUNEIFORM SIGN I;Lo;0;L;;;;;N;;;;;
12140;CUNEIFORM SIGN I A;Lo;0;L;;;;;N;;;;;
12141;CUNEIFORM SIGN IB;Lo;0;L;;;;;N;;;;;
12142;CUNEIFORM SIGN IDIM;Lo;0;L;;;;;N;;;;;
12143;CUNEIFORM SIGN IDIM OVER IDIM BUR;Lo;0;L;;;;;N;;;;;
12144;CUNEIFORM SIGN IDIM OVER IDIM SQUARED;Lo;0;L;;;;;N;;;;;
12145;CUNEIFORM SIGN IG;Lo;0;L;;;;;N;;;;;
12146;CUNEIFORM SIGN IGI;Lo;0;L;;;;;N;;;;;
12147;CUNEIFORM SIGN IGI DIB;Lo;0;L;;;;;N;;;;;
12148;CUNEIFORM SIGN IGI RI;Lo;0;L;;;;;N;;;;;
12149;CUNEIFORM SIGN IGI OVER IGI SHIR OVER SHIR UD OVER UD;Lo;0;L;;;;;N;;;;;
1214A;CUNEIFORM SIGN IGI GUNU;Lo;0;L;;;;;N;;;;;
1214B;CUNEIFORM SIGN IL;Lo;0;L;;;;;N;;;;;
1214C;CUNEIFORM SIGN IL TIMES GAN2 TENU;Lo;0;L;;;;;N;;;;;
1214D;CUNEIFORM SIGN IL2;Lo;0;L;;;;;N;;;;;
1214E;CUNEIFORM SIGN IM;Lo;0;L;;;;;N;;;;;
1214F;CUNEIFORM SIGN IM TIMES TAK4;Lo;0;L;;;;;N;;;;;
12150;CUNEIFORM SIGN IM CROSSING IM;Lo;0;L;;;;;N;;;;;
12151;CUNEIFORM SIGN IM OPPOSING IM;Lo;0;L;;;;;N;;;;;
12152;CUNEIFORM SIGN IM SQUARED;Lo;0;L;;;;;N;;;;;
12153;CUNEIFORM SIGN IMIN;Lo;0;L;;;;;N;;;;;
12154;CUNEIFORM SIGN IN;Lo;0;L;;;;;N;;;;;
12155;CUNEIFORM SIGN IR;Lo;0;L;;;;;N;;;;;
12156;CUNEIFORM SIGN ISH;Lo;0;L;;;;;N;;;;;
12157;CUNEIFORM SIGN KA;Lo;0;L;;;;;N;;;;;
12158;CUNEIFORM SIGN KA TIMES A;Lo;0;L;;;;;N;;;;;
12159;CUNEIFORM SIGN KA TIMES AD;Lo;0;L;;;;;N;;;;;
1215A;CUNEIFORM SIGN KA TIMES AD PLUS KU3;Lo;0;L;;;;;N;;;;;
1215B;CUNEIFORM SIGN KA TIMES ASH2;Lo;0;L;;;;;N;;;;;
1215C;CUNEIFORM SIGN KA TIMES BAD;Lo;0;L;;;;;N;;;;;
1215D;CUNEIFORM SIGN KA TIMES BALAG;Lo;0;L;;;;;N;;;;;
1215E;CUNEIFORM SIGN KA TIMES BAR;Lo;0;L;;;;;N;;;;;
1215F;CUNEIFORM SIGN KA TIMES BI;Lo;0;L;;;;;N;;;;;
12160;CUNEIFORM SIGN KA TIMES ERIN2;Lo;0;L;;;;;N;;;;;
12161;CUNEIFORM SIGN KA TIMES ESH2;Lo;0;L;;;;;N;;;;;
12162;CUNEIFORM SIGN KA TIMES GA;Lo;0;L;;;;;N;;;;;
12163;CUNEIFORM SIGN KA TIMES GAL;Lo;0;L;;;;;N;;;;;
12164;CUNEIFORM SIGN KA TIMES GAN2 TENU;Lo;0;L;;;;;N;;;;;
12165;CUNEIFORM SIGN KA TIMES GAR;Lo;0;L;;;;;N;;;;;
12166;CUNEIFORM SIGN KA TIMES GAR PLUS SHA3 PLUS A;Lo;0;L;;;;;N;;;;;
12167;CUNEIFORM SIGN KA TIMES GI;Lo;0;L;;;;;N;;;;;
12168;CUNEIFORM SIGN KA TIMES GIR2;Lo;0;L;;;;;N;;;;;
12169;CUNEIFORM SIGN KA TIMES GISH PLUS SAR;Lo;0;L;;;;;N;;;;;
1216A;CUNEIFORM SIGN KA TIMES GISH CROSSING GISH;Lo;0;L;;;;;N;;;;;
1216B;CUNEIFORM SIGN KA TIMES GU;Lo;0;L;;;;;N;;;;;
1216C;CUNEIFORM SIGN KA TIMES GUR7;Lo;0;L;;;;;N;;;;;
1216D;CUNEIFORM SIGN KA TIMES IGI;Lo;0;L;;;;;N;;;;;
1216E;CUNEIFORM SIGN KA TIMES IM;Lo;0;L;;;;;N;;;;;
1216F;CUNEIFORM SIGN KA TIMES KAK;Lo;0;L;;;;;N;;;;;
12170;CUNEIFORM SIGN KA TIMES KI;Lo;0;L;;;;;N;;;;;
12171;CUNEIFORM SIGN KA TIMES KID;Lo;0;L;;;;;N;;;;;
12172;CUNEIFORM SIGN KA TIMES LI;Lo;0;L;;;;;N;;;;;
12173;CUNEIFORM SIGN KA TIMES LU;Lo;0;L;;;;;N;;;;;
12174;CUNEIFORM SIGN KA TIMES ME;Lo;0;L;;;;;N;;;;;
12175;CUNEIFORM SIGN KA TIMES ME PLUS DU;Lo;0;L;;;;;N;;;;;
12176;CUNEIFORM SIGN KA TIMES ME PLUS GI;Lo;0;L;;;;;N;;;;;
12177;CUNEIFORM SIGN KA TIMES ME PLUS TE;Lo;0;L;;;;;N;;;;;
12178;CUNEIFORM SIGN KA TIMES MI;Lo;0;L;;;;;N;;;;;
12179;CUNEIFORM SIGN KA TIMES MI PLUS NUNUZ;Lo;0;L;;;;;N;;;;;
1217A;CUNEIFORM SIGN KA TIMES NE;Lo;0;L;;;;;N;;;;;
1217B;CUNEIFORM SIGN KA TIMES NUN;Lo;0;L;;;;;N;;;;;
1217C;CUNEIFORM SIGN KA TIMES PI;Lo;0;L;;;;;N;;;;;
1217D;CUNEIFORM SIGN KA TIMES RU;Lo;0;L;;;;;N;;;;;
1217E;CUNEIFORM SIGN KA TIMES SA;Lo;0;L;;;;;N;;;;;
1217F;CUNEIFORM SIGN KA TIMES SAR;Lo;0;L;;;;;N;;;;;
12180;CUNEIFORM SIGN KA TIMES SHA;Lo;0;L;;;;;N;;;;;
12181;CUNEIFORM SIGN KA TIMES SHE;Lo;0;L;;;;;N;;;;;
12182;CUNEIFORM SIGN KA TIMES SHID;Lo;0;L;;;;;N;;;;;
12183;CUNEIFORM SIGN KA TIMES SHU;Lo;0;L;;;;;N;;;;;
12184;CUNEIFORM SIGN KA TIMES SIG;Lo;0;L;;;;;N;;;;;
12185;CUNEIFORM SIGN KA TIMES SUHUR;Lo;0;L;;;;;N;;;;;
12186;CUNEIFORM SIGN KA TIMES TAR;Lo;0;L;;;;;N;;;;;
12187;CUNEIFORM SIGN KA TIMES U;Lo;0;L;;;;;N;;;;;
12188;CUNEIFORM SIGN KA TIMES U2;Lo;0;L;;;;;N;;;;;
12189;CUNEIFORM SIGN KA TIMES UD;Lo;0;L;;;;;N;;;;;
1218A;CUNEIFORM SIGN KA TIMES UMUM TIMES PA;Lo;0;L;;;;;N;;;;;
1218B;CUNEIFORM SIGN KA TIMES USH;Lo;0;L;;;;;N;;;;;
1218C;CUNEIFORM SIGN KA TIMES ZI;Lo;0;L;;;;;N;;;;;
1218D;CUNEIFORM SIGN KA2;Lo;0;L;;;;;N;;;;;
1218E;CUNEIFORM SIGN KA2 CROSSING KA2;Lo;0;L;;;;;N;;;;;
1218F;CUNEIFORM SIGN KAB;Lo;0;L;;;;;N;;;;;
12190;CUNEIFORM SIGN KAD2;Lo;0;L;;;;;N;;;;;
12191;CUNEIFORM SIGN KAD3;Lo;0;L;;;;;N;;;;;
12192;CUNEIFORM SIGN KAD4;Lo;0;L;;;;;N;;;;;
12193;CUNEIFORM SIGN KAD5;Lo;0;L;;;;;N;;;;;
12194;CUNEIFORM SIGN KAD5 OVER KAD5;Lo;0;L;;;;;N;;;;;
12195;CUNEIFORM SIGN KAK;Lo;0;L;;;;;N;;;;;
12196;CUNEIFORM SIGN KAK TIMES IGI GUNU;Lo;0;L;;;;;N;;;;;
12197;CUNEIFORM SIGN KAL;Lo;0;L;;;;;N;;;;;
12198;CUNEIFORM SIGN KAL TIMES BAD;Lo;0;L;;;;;N;;;;;
12199;CUNEIFORM SIGN KAL CROSSING KAL;Lo;0;L;;;;;N;;;;;
1219A;CUNEIFORM SIGN KAM2;Lo;0;L;;;;;N;;;;;
1219B;CUNEIFORM SIGN KAM4;Lo;0;L;;;;;N;;;;;
1219C;CUNEIFORM SIGN KASKAL;Lo;0;L;;;;;N;;;;;
1219D;CUNEIFORM SIGN KASKAL LAGAB TIMES U OVER LAGAB TIMES U;Lo;0;L;;;;;N;;;;;
1219E;CUNEIFORM SIGN KASKAL OVER KASKAL LAGAB TIMES U OVER LAGAB TIMES U;Lo;0;L;;;;;N;;;;;
1219F;CUNEIFORM SIGN KESH2;Lo;0;L;;;;;N;;;;;
121A0;CUNEIFORM SIGN KI;Lo;0;L;;;;;N;;;;;
121A1;CUNEIFORM SIGN KI TIMES BAD;Lo;0;L;;;;;N;;;;;
121A2;CUNEIFORM SIGN KI TIMES U;Lo;0;L;;;;;N;;;;;
121A3;CUNEIFORM SIGN KI TIMES UD;Lo;0;L;;;;;N;;;;;
121A4;CUNEIFORM SIGN KID;Lo;0;L;;;;;N;;;;;
121A5;CUNEIFORM SIGN KIN;Lo;0;L;;;;;N;;;;;
121A6;CUNEIFORM SIGN KISAL;Lo;0;L;;;;;N;;;;;
121A7;CUNEIFORM SIGN KISH;Lo;0;L;;;;;N;;;;;
121A8;CUNEIFORM SIGN KISIM5;Lo;0;L;;;;;N;;;;;
121A9;CUNEIFORM SIGN KISIM5 OVER KISIM5;Lo;0;L;;;;;N;;;;;
121AA;CUNEIFORM SIGN KU;Lo;0;L;;;;;N;;;;;
121AB;CUNEIFORM SIGN KU OVER HI TIMES ASH2 KU OVER HI TIMES ASH2;Lo;0;L;;;;;N;;;;;
121AC;CUNEIFORM SIGN KU3;Lo;0;L;;;;;N;;;;;
121AD;CUNEIFORM SIGN KU4;Lo;0;L;;;;;N;;;;;
121AE;CUNEIFORM SIGN KU4 VARIANT FORM;Lo;0;L;;;;;N;;;;;
121AF;CUNEIFORM SIGN KU7;Lo;0;L;;;;;N;;;;;
121B0;CUNEIFORM SIGN KUL;Lo;0;L;;;;;N;;;;;
121B1;CUNEIFORM SIGN KUL GUNU;Lo;0;L;;;;;N;;;;;
121B2;CUNEIFORM SIGN KUN;Lo;0;L;;;;;N;;;;;
121B3;CUNEIFORM SIGN KUR;Lo;0;L;;;;;N;;;;;
121B4;CUNEIFORM SIGN KUR OPPOSING KUR;Lo;0;L;;;;;N;;;;;
121B5;CUNEIFORM SIGN KUSHU2;Lo;0;L;;;;;N;;;;;
121B6;CUNEIFORM SIGN KWU318;Lo;0;L;;;;;N;;;;;
121B7;CUNEIFORM SIGN LA;Lo;0;L;;;;;N;;;;;
121B8;CUNEIFORM SIGN LAGAB;Lo;0;L;;;;;N;;;;;
121B9;CUNEIFORM SIGN LAGAB TIMES A;Lo;0;L;;;;;N;;;;;
121BA;CUNEIFORM SIGN LAGAB TIMES A PLUS DA PLUS HA;Lo;0;L;;;;;N;;;;;
121BB;CUNEIFORM SIGN LAGAB TIMES A PLUS GAR;Lo;0;L;;;;;N;;;;;
121BC;CUNEIFORM SIGN LAGAB TIMES A PLUS LAL;Lo;0;L;;;;;N;;;;;
121BD;CUNEIFORM SIGN LAGAB TIMES AL;Lo;0;L;;;;;N;;;;;
121BE;CUNEIFORM SIGN LAGAB TIMES AN;Lo;0;L;;;;;N;;;;;
121BF;CUNEIFORM SIGN LAGAB TIMES ASH ZIDA TENU;Lo;0;L;;;;;N;;;;;
121C0;CUNEIFORM SIGN LAGAB TIMES BAD;Lo;0;L;;;;;N;;;;;
121C1;CUNEIFORM SIGN LAGAB TIMES BI;Lo;0;L;;;;;N;;;;;
121C2;CUNEIFORM SIGN LAGAB TIMES DAR;Lo;0;L;;;;;N;;;;;
121C3;CUNEIFORM SIGN LAGAB TIMES EN;Lo;0;L;;;;;N;;;;;
121C4;CUNEIFORM SIGN LAGAB TIMES GA;Lo;0;L;;;;;N;;;;;
121C5;CUNEIFORM SIGN LAGAB TIMES GAR;Lo;0;L;;;;;N;;;;;
121C6;CUNEIFORM SIGN LAGAB TIMES GUD;Lo;0;L;;;;;N;;;;;
121C7;CUNEIFORM SIGN LAGAB TIMES GUD PLUS GUD;Lo;0;L;;;;;N;;;;;
121C8;CUNEIFORM SIGN LAGAB TIMES HA;Lo;0;L;;;;;N;;;;;
121C9;CUNEIFORM SIGN LAGAB TIMES HAL;Lo;0;L;;;;;N;;;;;
121CA;CUNEIFORM SIGN LAGAB TIMES HI TIMES NUN;Lo;0;L;;;;;N;;;;;
121CB;CUNEIFORM SIGN LAGAB TIMES IGI GUNU;Lo;0;L;;;;;N;;;;;
121CC;CUNEIFORM SIGN LAGAB TIMES IM;Lo;0;L;;;;;N;;;;;
121CD;CUNEIFORM SIGN LAGAB TIMES IM PLUS HA;Lo;0;L;;;;;N;;;;;
121CE;CUNEIFORM SIGN LAGAB TIMES IM PLUS LU;Lo;0;L;;;;;N;;;;;
121CF;CUNEIFORM SIGN LAGAB TIMES KI;Lo;0;L;;;;;N;;;;;
121D0;CUNEIFORM SIGN LAGAB TIMES KIN;Lo;0;L;;;;;N;;;;;
121D1;CUNEIFORM SIGN LAGAB TIMES KU3;Lo;0;L;;;;;N;;;;;
121D2;CUNEIFORM SIGN LAGAB TIMES KUL;Lo;0;L;;;;;N;;;;;
121D3;CUNEIFORM SIGN LAGAB TIMES KUL PLUS HI PLUS A;Lo;0;L;;;;;N;;;;;
121D4;CUNEIFORM SIGN LAGAB TIMES LAGAB;Lo;0;L;;;;;N;;;;;
121D5;CUNEIFORM SIGN LAGAB TIMES LISH;Lo;0;L;;;;;N;;;;;
121D6;CUNEIFORM SIGN LAGAB TIMES LU;Lo;0;L;;;;;N;;;;;
121D7;CUNEIFORM SIGN LAGAB TIMES LUL;Lo;0;L;;;;;N;;;;;
121D8;CUNEIFORM SIGN LAGAB TIMES ME;Lo;0;L;;;;;N;;;;;
121D9;CUNEIFORM SIGN LAGAB TIMES ME PLUS EN;Lo;0;L;;;;;N;;;;;
121DA;CUNEIFORM SIGN LAGAB TIMES MUSH;Lo;0;L;;;;;N;;;;;
121DB;CUNEIFORM SIGN LAGAB TIMES NE;Lo;0;L;;;;;N;;;;;
121DC;CUNEIFORM SIGN LAGAB TIMES SHE PLUS SUM;Lo;0;L;;;;;N;;;;;
121DD;CUNEIFORM SIGN LAGAB TIMES SHITA PLUS GISH PLUS ERIN2;Lo;0;L;;;;;N;;;;;
121DE;CUNEIFORM SIGN LAGAB TIMES SHITA PLUS GISH TENU;Lo;0;L;;;;;N;;;;;
121DF;CUNEIFORM SIGN LAGAB TIMES SHU2;Lo;0;L;;;;;N;;;;;
121E0;CUNEIFORM SIGN LAGAB TIMES SHU2 PLUS SHU2;Lo;0;L;;;;;N;;;;;
121E1;CUNEIFORM SIGN LAGAB TIMES SUM;Lo;0;L;;;;;N;;;;;
121E2;CUNEIFORM SIGN LAGAB TIMES TAG;Lo;0;L;;;;;N;;;;;
121E3;CUNEIFORM SIGN LAGAB TIMES TAK4;Lo;0;L;;;;;N;;;;;
121E4;CUNEIFORM SIGN LAGAB TIMES TE PLUS A PLUS SU PLUS NA;Lo;0;L;;;;;N;;;;;
121E5;CUNEIFORM SIGN LAGAB TIMES U;Lo;0;L;;;;;N;;;;;
121E6;CUNEIFORM SIGN LAGAB TIMES U PLUS A;Lo;0;L;;;;;N;;;;;
121E7;CUNEIFORM SIGN LAGAB TIMES U PLUS U PLUS U;Lo;0;L;;;;;N;;;;;
121E8;CUNEIFORM SIGN LAGAB TIMES U2 PLUS ASH;Lo;0;L;;;;;N;;;;;
121E9;CUNEIFORM SIGN LAGAB TIMES UD;Lo;0;L;;;;;N;;;;;
121EA;CUNEIFORM SIGN LAGAB TIMES USH;Lo;0;L;;;;;N;;;;;
121EB;CUNEIFORM SIGN LAGAB SQUARED;Lo;0;L;;;;;N;;;;;
121EC;CUNEIFORM SIGN LAGAR;Lo;0;L;;;;;N;;;;;
121ED;CUNEIFORM SIGN LAGAR TIMES SHE;Lo;0;L;;;;;N;;;;;
121EE;CUNEIFORM SIGN LAGAR TIMES SHE PLUS SUM;Lo;0;L;;;;;N;;;;;
121EF;CUNEIFORM SIGN LAGAR GUNU;Lo;0;L;;;;;N;;;;;
121F0;CUNEIFORM SIGN LAGAR GUNU OVER LAGAR GUNU SHE;Lo;0;L;;;;;N;;;;;
121F1;CUNEIFORM SIGN LAHSHU;Lo;0;L;;;;;N;;;;;
121F2;CUNEIFORM SIGN LAL;Lo;0;L;;;;;N;;;;;
121F3;CUNEIFORM SIGN LAL TIMES LAL;Lo;0;L;;;;;N;;;;;
121F4;CUNEIFORM SIGN LAM;Lo;0;L;;;;;N;;;;;
121F5;CUNEIFORM SIGN LAM TIMES KUR;Lo;0;L;;;;;N;;;;;
121F6;CUNEIFORM SIGN LAM TIMES KUR PLUS RU;Lo;0;L;;;;;N;;;;;
121F7;CUNEIFORM SIGN LI;Lo;0;L;;;;;N;;;;;
121F8;CUNEIFORM SIGN LIL;Lo;0;L;;;;;N;;;;;
121F9;CUNEIFORM SIGN LIMMU2;Lo;0;L;;;;;N;;;;;
121FA;CUNEIFORM SIGN LISH;Lo;0;L;;;;;N;;;;;
121FB;CUNEIFORM SIGN LU;Lo;0;L;;;;;N;;;;;
121FC;CUNEIFORM SIGN LU TIMES BAD;Lo;0;L;;;;;N;;;;;
121FD;CUNEIFORM SIGN LU2;Lo;0;L;;;;;N;;;;;
121FE;CUNEIFORM SIGN LU2 TIMES AL;Lo;0;L;;;;;N;;;;;
121FF;CUNEIFORM SIGN LU2 TIMES BAD;Lo;0;L;;;;;N;;;;;
12200;CUNEIFORM SIGN LU2 TIMES ESH2;Lo;0;L;;;;;N;;;;;
12201;CUNEIFORM SIGN LU2 TIMES ESH2 TENU;Lo;0;L;;;;;N;;;;;
12202;CUNEIFORM SIGN LU2 TIMES GAN2 TENU;Lo;0;L;;;;;N;;;;;
12203;CUNEIFORM SIGN LU2 TIMES HI TIMES BAD;Lo;0;L;;;;;N;;;;;
12204;CUNEIFORM SIGN LU2 TIMES IM;Lo;0;L;;;;;N;;;;;
12205;CUNEIFORM SIGN LU2 TIMES KAD2;Lo;0;L;;;;;N;;;;;
12206;CUNEIFORM SIGN LU2 TIMES KAD3;Lo;0;L;;;;;N;;;;;
12207;CUNEIFORM SIGN LU2 TIMES KAD3 PLUS ASH;Lo;0;L;;;;;N;;;;;
12208;CUNEIFORM SIGN LU2 TIMES KI;Lo;0;L;;;;;N;;;;;
12209;CUNEIFORM SIGN LU2 TIMES LA PLUS ASH;Lo;0;L;;;;;N;;;;;
1220A;CUNEIFORM SIGN LU2 TIMES LAGAB;Lo;0;L;;;;;N;;;;;
1220B;CUNEIFORM SIGN LU2 TIMES ME PLUS EN;Lo;0;L;;;;;N;;;;;
1220C;CUNEIFORM SIGN LU2 TIMES NE;Lo;0;L;;;;;N;;;;;
1220D;CUNEIFORM SIGN LU2 TIMES NU;Lo;0;L;;;;;N;;;;;
1220E;CUNEIFORM SIGN LU2 TIMES SI PLUS ASH;Lo;0;L;;;;;N;;;;;
1220F;CUNEIFORM SIGN LU2 TIMES SIK2 PLUS BU;Lo;0;L;;;;;N;;;;;
12210;CUNEIFORM SIGN LU2 TIMES TUG2;Lo;0;L;;;;;N;;;;;
12211;CUNEIFORM SIGN LU2 TENU;Lo;0;L;;;;;N;;;;;
12212;CUNEIFORM SIGN LU2 CROSSING LU2;Lo;0;L;;;;;N;;;;;
12213;CUNEIFORM SIGN LU2 OPPOSING LU2;Lo;0;L;;;;;N;;;;;
12214;CUNEIFORM SIGN LU2 SQUARED;Lo;0;L;;;;;N;;;;;
12215;CUNEIFORM SIGN LU2 SHESHIG;Lo;0;L;;;;;N;;;;;
12216;CUNEIFORM SIGN LU3;Lo;0;L;;;;;N;;;;;
12217;CUNEIFORM SIGN LUGAL;Lo;0;L;;;;;N;;;;;
12218;CUNEIFORM SIGN LUGAL OVER LUGAL;Lo;0;L;;;;;N;;;;;
12219;CUNEIFORM SIGN LUGAL OPPOSING LUGAL;Lo;0;L;;;;;N;;;;;
1221A;CUNEIFORM SIGN LUGAL SHESHIG;Lo;0;L;;;;;N;;;;;
1221B;CUNEIFORM SIGN LUH;Lo;0;L;;;;;N;;;;;
1221C;CUNEIFORM SIGN LUL;Lo;0;L;;;;;N;;;;;
1221D;CUNEIFORM SIGN LUM;Lo;0;L;;;;;N;;;;;
1221E;CUNEIFORM SIGN LUM OVER LUM;Lo;0;L;;;;;N;;;;;
1221F;CUNEIFORM SIGN LUM OVER LUM GAR OVER GAR;Lo;0;L;;;;;N;;;;;
12220;CUNEIFORM SIGN MA;Lo;0;L;;;;;N;;;;;
12221;CUNEIFORM SIGN MA TIMES TAK4;Lo;0;L;;;;;N;;;;;
12222;CUNEIFORM SIGN MA GUNU;Lo;0;L;;;;;N;;;;;
12223;CUNEIFORM SIGN MA2;Lo;0;L;;;;;N;;;;;
12224;CUNEIFORM SIGN MAH;Lo;0;L;;;;;N;;;;;
12225;CUNEIFORM SIGN MAR;Lo;0;L;;;;;N;;;;;
12226;CUNEIFORM SIGN MASH;Lo;0;L;;;;;N;;;;;
12227;CUNEIFORM SIGN MASH2;Lo;0;L;;;;;N;;;;;
12228;CUNEIFORM SIGN ME;Lo;0;L;;;;;N;;;;;
12229;CUNEIFORM SIGN MES;Lo;0;L;;;;;N;;;;;
1222A;CUNEIFORM SIGN MI;Lo;0;L;;;;;N;;;;;
1222B;CUNEIFORM SIGN MIN;Lo;0;L;;;;;N;;;;;
1222C;CUNEIFORM SIGN MU;Lo;0;L;;;;;N;;;;;
1222D;CUNEIFORM SIGN MU OVER MU;Lo;0;L;;;;;N;;;;;
1222E;CUNEIFORM SIGN MUG;Lo;0;L;;;;;N;;;;;
1222F;CUNEIFORM SIGN MUG GUNU;Lo;0;L;;;;;N;;;;;
12230;CUNEIFORM SIGN MUNSUB;Lo;0;L;;;;;N;;;;;
12231;CUNEIFORM SIGN MURGU2;Lo;0;L;;;;;N;;;;;
12232;CUNEIFORM SIGN MUSH;Lo;0;L;;;;;N;;;;;
12233;CUNEIFORM SIGN MUSH TIMES A;Lo;0;L;;;;;N;;;;;
12234;CUNEIFORM SIGN MUSH TIMES KUR;Lo;0;L;;;;;N;;;;;
12235;CUNEIFORM SIGN MUSH TIMES ZA;Lo;0;L;;;;;N;;;;;
12236;CUNEIFORM SIGN MUSH OVER MUSH;Lo;0;L;;;;;N;;;;;
12237;CUNEIFORM SIGN MUSH OVER MUSH TIMES A PLUS NA;Lo;0;L;;;;;N;;;;;
12238;CUNEIFORM SIGN MUSH CROSSING MUSH;Lo;0;L;;;;;N;;;;;
12239;CUNEIFORM SIGN MUSH3;Lo;0;L;;;;;N;;;;;
1223A;CUNEIFORM SIGN MUSH3 TIMES A;Lo;0;L;;;;;N;;;;;
1223B;CUNEIFORM SIGN MUSH3 TIMES A PLUS DI;Lo;0;L;;;;;N;;;;;
1223C;CUNEIFORM SIGN MUSH3 TIMES DI;Lo;0;L;;;;;N;;;;;
1223D;CUNEIFORM SIGN MUSH3 GUNU;Lo;0;L;;;;;N;;;;;
1223E;CUNEIFORM SIGN NA;Lo;0;L;;;;;N;;;;;
1223F;CUNEIFORM SIGN NA2;Lo;0;L;;;;;N;;;;;
12240;CUNEIFORM SIGN NAGA;Lo;0;L;;;;;N;;;;;
12241;CUNEIFORM SIGN NAGA INVERTED;Lo;0;L;;;;;N;;;;;
12242;CUNEIFORM SIGN NAGA TIMES SHU TENU;Lo;0;L;;;;;N;;;;;
12243;CUNEIFORM SIGN NAGA OPPOSING NAGA;Lo;0;L;;;;;N;;;;;
12244;CUNEIFORM SIGN NAGAR;Lo;0;L;;;;;N;;;;;
12245;CUNEIFORM SIGN NAM NUTILLU;Lo;0;L;;;;;N;;;;;
12246;CUNEIFORM SIGN NAM;Lo;0;L;;;;;N;;;;;
12247;CUNEIFORM SIGN NAM2;Lo;0;L;;;;;N;;;;;
12248;CUNEIFORM SIGN NE;Lo;0;L;;;;;N;;;;;
12249;CUNEIFORM SIGN NE TIMES A;Lo;0;L;;;;;N;;;;;
1224A;CUNEIFORM SIGN NE TIMES UD;Lo;0;L;;;;;N;;;;;
1224B;CUNEIFORM SIGN NE SHESHIG;Lo;0;L;;;;;N;;;;;
1224C;CUNEIFORM SIGN NI;Lo;0;L;;;;;N;;;;;
1224D;CUNEIFORM SIGN NI TIMES E;Lo;0;L;;;;;N;;;;;
1224E;CUNEIFORM SIGN NI2;Lo;0;L;;;;;N;;;;;
1224F;CUNEIFORM SIGN NIM;Lo;0;L;;;;;N;;;;;
12250;CUNEIFORM SIGN NIM TIMES GAN2 TENU;Lo;0;L;;;;;N;;;;;
12251;CUNEIFORM SIGN NIM TIMES GAR PLUS GAN2 TENU;Lo;0;L;;;;;N;;;;;
12252;CUNEIFORM SIGN NINDA2;Lo;0;L;;;;;N;;;;;
12253;CUNEIFORM SIGN NINDA2 TIMES AN;Lo;0;L;;;;;N;;;;;
12254;CUNEIFORM SIGN NINDA2 TIMES ASH;Lo;0;L;;;;;N;;;;;
12255;CUNEIFORM SIGN NINDA2 TIMES ASH PLUS ASH;Lo;0;L;;;;;N;;;;;
12256;CUNEIFORM SIGN NINDA2 TIMES GUD;Lo;0;L;;;;;N;;;;;
12257;CUNEIFORM SIGN NINDA2 TIMES ME PLUS GAN2 TENU;Lo;0;L;;;;;N;;;;;
12258;CUNEIFORM SIGN NINDA2 TIMES NE;Lo;0;L;;;;;N;;;;;
12259;CUNEIFORM SIGN NINDA2 TIMES NUN;Lo;0;L;;;;;N;;;;;
1225A;CUNEIFORM SIGN NINDA2 TIMES SHE;Lo;0;L;;;;;N;;;;;
1225B;CUNEIFORM SIGN NINDA2 TIMES SHE PLUS A AN;Lo;0;L;;;;;N;;;;;
1225C;CUNEIFORM SIGN NINDA2 TIMES SHE PLUS ASH;Lo;0;L;;;;;N;;;;;
1225D;CUNEIFORM SIGN NINDA2 TIMES SHE PLUS ASH PLUS ASH;Lo;0;L;;;;;N;;;;;
1225E;CUNEIFORM SIGN NINDA2 TIMES U2 PLUS ASH;Lo;0;L;;;;;N;;;;;
1225F;CUNEIFORM SIGN NINDA2 TIMES USH;Lo;0;L;;;;;N;;;;;
12260;CUNEIFORM SIGN NISAG;Lo;0;L;;;;;N;;;;;
12261;CUNEIFORM SIGN NU;Lo;0;L;;;;;N;;;;;
12262;CUNEIFORM SIGN NU11;Lo;0;L;;;;;N;;;;;
12263;CUNEIFORM SIGN NUN;Lo;0;L;;;;;N;;;;;
12264;CUNEIFORM SIGN NUN LAGAR TIMES GAR;Lo;0;L;;;;;N;;;;;
12265;CUNEIFORM SIGN NUN LAGAR TIMES MASH;Lo;0;L;;;;;N;;;;;
12266;CUNEIFORM SIGN NUN LAGAR TIMES SAL;Lo;0;L;;;;;N;;;;;
12267;CUNEIFORM SIGN NUN LAGAR TIMES SAL OVER NUN LAGAR TIMES SAL;Lo;0;L;;;;;N;;;;;
12268;CUNEIFORM SIGN NUN LAGAR TIMES USH;Lo;0;L;;;;;N;;;;;
12269;CUNEIFORM SIGN NUN TENU;Lo;0;L;;;;;N;;;;;
1226A;CUNEIFORM SIGN NUN OVER NUN;Lo;0;L;;;;;N;;;;;
1226B;CUNEIFORM SIGN NUN CROSSING NUN;Lo;0;L;;;;;N;;;;;
1226C;CUNEIFORM SIGN NUN CROSSING NUN LAGAR OVER LAGAR;Lo;0;L;;;;;N;;;;;
1226D;CUNEIFORM SIGN NUNUZ;Lo;0;L;;;;;N;;;;;
1226E;CUNEIFORM SIGN NUNUZ AB2 TIMES ASHGAB;Lo;0;L;;;;;N;;;;;
1226F;CUNEIFORM SIGN NUNUZ AB2 TIMES BI;Lo;0;L;;;;;N;;;;;
12270;CUNEIFORM SIGN NUNUZ AB2 TIMES DUG;Lo;0;L;;;;;N;;;;;
12271;CUNEIFORM SIGN NUNUZ AB2 TIMES GUD;Lo;0;L;;;;;N;;;;;
12272;CUNEIFORM SIGN NUNUZ AB2 TIMES IGI GUNU;Lo;0;L;;;;;N;;;;;
12273;CUNEIFORM SIGN NUNUZ AB2 TIMES KAD3;Lo;0;L;;;;;N;;;;;
12274;CUNEIFORM SIGN NUNUZ AB2 TIMES LA;Lo;0;L;;;;;N;;;;;
12275;CUNEIFORM SIGN NUNUZ AB2 TIMES NE;Lo;0;L;;;;;N;;;;;
12276;CUNEIFORM SIGN NUNUZ AB2 TIMES SILA3;Lo;0;L;;;;;N;;;;;
12277;CUNEIFORM SIGN NUNUZ AB2 TIMES U2;Lo;0;L;;;;;N;;;;;
12278;CUNEIFORM SIGN NUNUZ KISIM5 TIMES BI;Lo;0;L;;;;;N;;;;;
12279;CUNEIFORM SIGN NUNUZ KISIM5 TIMES BI U;Lo;0;L;;;;;N;;;;;
1227A;CUNEIFORM SIGN PA;Lo;0;L;;;;;N;;;;;
1227B;CUNEIFORM SIGN PAD;Lo;0;L;;;;;N;;;;;
1227C;CUNEIFORM SIGN PAN;Lo;0;L;;;;;N;;;;;
1227D;CUNEIFORM SIGN PAP;Lo;0;L;;;;;N;;;;;
1227E;CUNEIFORM SIGN PESH2;Lo;0;L;;;;;N;;;;;
1227F;CUNEIFORM SIGN PI;Lo;0;L;;;;;N;;;;;
12280;CUNEIFORM SIGN PI TIMES A;Lo;0;L;;;;;N;;;;;
12281;CUNEIFORM SIGN PI TIMES AB;Lo;0;L;;;;;N;;;;;
12282;CUNEIFORM SIGN PI TIMES BI;Lo;0;L;;;;;N;;;;;
12283;CUNEIFORM SIGN PI TIMES BU;Lo;0;L;;;;;N;;;;;
12284;CUNEIFORM SIGN PI TIMES E;Lo;0;L;;;;;N;;;;;
12285;CUNEIFORM SIGN PI TIMES I;Lo;0;L;;;;;N;;;;;
12286;CUNEIFORM SIGN PI TIMES IB;Lo;0;L;;;;;N;;;;;
12287;CUNEIFORM SIGN PI TIMES U;Lo;0;L;;;;;N;;;;;
12288;CUNEIFORM SIGN PI TIMES U2;Lo;0;L;;;;;N;;;;;
12289;CUNEIFORM SIGN PI CROSSING PI;Lo;0;L;;;;;N;;;;;
1228A;CUNEIFORM SIGN PIRIG;Lo;0;L;;;;;N;;;;;
1228B;CUNEIFORM SIGN PIRIG TIMES KAL;Lo;0;L;;;;;N;;;;;
1228C;CUNEIFORM SIGN PIRIG TIMES UD;Lo;0;L;;;;;N;;;;;
1228D;CUNEIFORM SIGN PIRIG TIMES ZA;Lo;0;L;;;;;N;;;;;
1228E;CUNEIFORM SIGN PIRIG OPPOSING PIRIG;Lo;0;L;;;;;N;;;;;
1228F;CUNEIFORM SIGN RA;Lo;0;L;;;;;N;;;;;
12290;CUNEIFORM SIGN RAB;Lo;0;L;;;;;N;;;;;
12291;CUNEIFORM SIGN RI;Lo;0;L;;;;;N;;;;;
12292;CUNEIFORM SIGN RU;Lo;0;L;;;;;N;;;;;
12293;CUNEIFORM SIGN SA;Lo;0;L;;;;;N;;;;;
12294;CUNEIFORM SIGN SAG NUTILLU;Lo;0;L;;;;;N;;;;;
12295;CUNEIFORM SIGN SAG;Lo;0;L;;;;;N;;;;;
12296;CUNEIFORM SIGN SAG TIMES A;Lo;0;L;;;;;N;;;;;
12297;CUNEIFORM SIGN SAG TIMES DU;Lo;0;L;;;;;N;;;;;
12298;CUNEIFORM SIGN SAG TIMES DUB;Lo;0;L;;;;;N;;;;;
12299;CUNEIFORM SIGN SAG TIMES HA;Lo;0;L;;;;;N;;;;;
1229A;CUNEIFORM SIGN SAG TIMES KAK;Lo;0;L;;;;;N;;;;;
1229B;CUNEIFORM SIGN SAG TIMES KUR;Lo;0;L;;;;;N;;;;;
1229C;CUNEIFORM SIGN SAG TIMES LUM;Lo;0;L;;;;;N;;;;;
1229D;CUNEIFORM SIGN SAG TIMES MI;Lo;0;L;;;;;N;;;;;
1229E;CUNEIFORM SIGN SAG TIMES NUN;Lo;0;L;;;;;N;;;;;
1229F;CUNEIFORM SIGN SAG TIMES SAL;Lo;0;L;;;;;N;;;;;
122A0;CUNEIFORM SIGN SAG TIMES SHID;Lo;0;L;;;;;N;;;;;
122A1;CUNEIFORM SIGN SAG TIMES TAB;Lo;0;L;;;;;N;;;;;
122A2;CUNEIFORM SIGN SAG TIMES U2;Lo;0;L;;;;;N;;;;;
122A3;CUNEIFORM SIGN SAG TIMES UB;Lo;0;L;;;;;N;;;;;
122A4;CUNEIFORM SIGN SAG TIMES UM;Lo;0;L;;;;;N;;;;;
122A5;CUNEIFORM SIGN SAG TIMES UR;Lo;0;L;;;;;N;;;;;
122A6;CUNEIFORM SIGN SAG TIMES USH;Lo;0;L;;;;;N;;;;;
122A7;CUNEIFORM SIGN SAG OVER SAG;Lo;0;L;;;;;N;;;;;
122A8;CUNEIFORM SIGN SAG GUNU;Lo;0;L;;;;;N;;;;;
122A9;CUNEIFORM SIGN SAL;Lo;0;L;;;;;N;;;;;
122AA;CUNEIFORM SIGN SAL LAGAB TIMES ASH2;Lo;0;L;;;;;N;;;;;
122AB;CUNEIFORM SIGN SANGA2;Lo;0;L;;;;;N;;;;;
122AC;CUNEIFORM SIGN SAR;Lo;0;L;;;;;N;;;;;
122AD;CUNEIFORM SIGN SHA;Lo;0;L;;;;;N;;;;;
122AE;CUNEIFORM SIGN SHA3;Lo;0;L;;;;;N;;;;;
122AF;CUNEIFORM SIGN SHA3 TIMES A;Lo;0;L;;;;;N;;;;;
122B0;CUNEIFORM SIGN SHA3 TIMES BAD;Lo;0;L;;;;;N;;;;;
122B1;CUNEIFORM SIGN SHA3 TIMES GISH;Lo;0;L;;;;;N;;;;;
122B2;CUNEIFORM SIGN SHA3 TIMES NE;Lo;0;L;;;;;N;;;;;
122B3;CUNEIFORM SIGN SHA3 TIMES SHU2;Lo;0;L;;;;;N;;;;;
122B4;CUNEIFORM SIGN SHA3 TIMES TUR;Lo;0;L;;;;;N;;;;;
122B5;CUNEIFORM SIGN SHA3 TIMES U;Lo;0;L;;;;;N;;;;;
122B6;CUNEIFORM SIGN SHA3 TIMES U PLUS A;Lo;0;L;;;;;N;;;;;
122B7;CUNEIFORM SIGN SHA6;Lo;0;L;;;;;N;;;;;
122B8;CUNEIFORM SIGN SHAB6;Lo;0;L;;;;;N;;;;;
122B9;CUNEIFORM SIGN SHAR2;Lo;0;L;;;;;N;;;;;
122BA;CUNEIFORM SIGN SHE;Lo;0;L;;;;;N;;;;;
122BB;CUNEIFORM SIGN SHE HU;Lo;0;L;;;;;N;;;;;
122BC;CUNEIFORM SIGN SHE OVER SHE GAD OVER GAD GAR OVER GAR;Lo;0;L;;;;;N;;;;;
122BD;CUNEIFORM SIGN SHE OVER SHE TAB OVER TAB GAR OVER GAR;Lo;0;L;;;;;N;;;;;
122BE;CUNEIFORM SIGN SHEG9;Lo;0;L;;;;;N;;;;;
122BF;CUNEIFORM SIGN SHEN;Lo;0;L;;;;;N;;;;;
122C0;CUNEIFORM SIGN SHESH;Lo;0;L;;;;;N;;;;;
122C1;CUNEIFORM SIGN SHESH2;Lo;0;L;;;;;N;;;;;
122C2;CUNEIFORM SIGN SHESHLAM;Lo;0;L;;;;;N;;;;;
122C3;CUNEIFORM SIGN SHID;Lo;0;L;;;;;N;;;;;
122C4;CUNEIFORM SIGN SHID TIMES A;Lo;0;L;;;;;N;;;;;
122C5;CUNEIFORM SIGN SHID TIMES IM;Lo;0;L;;;;;N;;;;;
122C6;CUNEIFORM SIGN SHIM;Lo;0;L;;;;;N;;;;;
122C7;CUNEIFORM SIGN SHIM TIMES A;Lo;0;L;;;;;N;;;;;
122C8;CUNEIFORM SIGN SHIM TIMES BAL;Lo;0;L;;;;;N;;;;;
122C9;CUNEIFORM SIGN SHIM TIMES BULUG;Lo;0;L;;;;;N;;;;;
122CA;CUNEIFORM SIGN SHIM TIMES DIN;Lo;0;L;;;;;N;;;;;
122CB;CUNEIFORM SIGN SHIM TIMES GAR;Lo;0;L;;;;;N;;;;;
122CC;CUNEIFORM SIGN SHIM TIMES IGI;Lo;0;L;;;;;N;;;;;
122CD;CUNEIFORM SIGN SHIM TIMES IGI GUNU;Lo;0;L;;;;;N;;;;;
122CE;CUNEIFORM SIGN SHIM TIMES KUSHU2;Lo;0;L;;;;;N;;;;;
122CF;CUNEIFORM SIGN SHIM TIMES LUL;Lo;0;L;;;;;N;;;;;
122D0;CUNEIFORM SIGN SHIM TIMES MUG;Lo;0;L;;;;;N;;;;;
122D1;CUNEIFORM SIGN SHIM TIMES SAL;Lo;0;L;;;;;N;;;;;
122D2;CUNEIFORM SIGN SHINIG;Lo;0;L;;;;;N;;;;;
122D3;CUNEIFORM SIGN SHIR;Lo;0;L;;;;;N;;;;;
122D4;CUNEIFORM SIGN SHIR TENU;Lo;0;L;;;;;N;;;;;
122D5;CUNEIFORM SIGN SHIR OVER SHIR BUR OVER BUR;Lo;0;L;;;;;N;;;;;
122D6;CUNEIFORM SIGN SHITA;Lo;0;L;;;;;N;;;;;
122D7;CUNEIFORM SIGN SHU;Lo;0;L;;;;;N;;;;;
122D8;CUNEIFORM SIGN SHU OVER INVERTED SHU;Lo;0;L;;;;;N;;;;;
122D9;CUNEIFORM SIGN SHU2;Lo;0;L;;;;;N;;;;;
122DA;CUNEIFORM SIGN SHUBUR;Lo;0;L;;;;;N;;;;;
122DB;CUNEIFORM SIGN SI;Lo;0;L;;;;;N;;;;;
122DC;CUNEIFORM SIGN SI GUNU;Lo;0;L;;;;;N;;;;;
122DD;CUNEIFORM SIGN SIG;Lo;0;L;;;;;N;;;;;
122DE;CUNEIFORM SIGN SIG4;Lo;0;L;;;;;N;;;;;
122DF;CUNEIFORM SIGN SIG4 OVER SIG4 SHU2;Lo;0;L;;;;;N;;;;;
122E0;CUNEIFORM SIGN SIK2;Lo;0;L;;;;;N;;;;;
122E1;CUNEIFORM SIGN SILA3;Lo;0;L;;;;;N;;;;;
122E2;CUNEIFORM SIGN SU;Lo;0;L;;;;;N;;;;;
122E3;CUNEIFORM SIGN SU OVER SU;Lo;0;L;;;;;N;;;;;
122E4;CUNEIFORM SIGN SUD;Lo;0;L;;;;;N;;;;;
122E5;CUNEIFORM SIGN SUD2;Lo;0;L;;;;;N;;;;;
122E6;CUNEIFORM SIGN SUHUR;Lo;0;L;;;;;N;;;;;
122E7;CUNEIFORM SIGN SUM;Lo;0;L;;;;;N;;;;;
122E8;CUNEIFORM SIGN SUMASH;Lo;0;L;;;;;N;;;;;
122E9;CUNEIFORM SIGN SUR;Lo;0;L;;;;;N;;;;;
122EA;CUNEIFORM SIGN SUR9;Lo;0;L;;;;;N;;;;;
122EB;CUNEIFORM SIGN TA;Lo;0;L;;;;;N;;;;;
122EC;CUNEIFORM SIGN TA ASTERISK;Lo;0;L;;;;;N;;;;;
122ED;CUNEIFORM SIGN TA TIMES HI;Lo;0;L;;;;;N;;;;;
122EE;CUNEIFORM SIGN TA TIMES MI;Lo;0;L;;;;;N;;;;;
122EF;CUNEIFORM SIGN TA GUNU;Lo;0;L;;;;;N;;;;;
122F0;CUNEIFORM SIGN TAB;Lo;0;L;;;;;N;;;;;
122F1;CUNEIFORM SIGN TAB OVER TAB NI OVER NI DISH OVER DISH;Lo;0;L;;;;;N;;;;;
122F2;CUNEIFORM SIGN TAB SQUARED;Lo;0;L;;;;;N;;;;;
122F3;CUNEIFORM SIGN TAG;Lo;0;L;;;;;N;;;;;
122F4;CUNEIFORM SIGN TAG TIMES BI;Lo;0;L;;;;;N;;;;;
122F5;CUNEIFORM SIGN TAG TIMES GUD;Lo;0;L;;;;;N;;;;;
122F6;CUNEIFORM SIGN TAG TIMES SHE;Lo;0;L;;;;;N;;;;;
122F7;CUNEIFORM SIGN TAG TIMES SHU;Lo;0;L;;;;;N;;;;;
122F8;CUNEIFORM SIGN TAG TIMES TUG2;Lo;0;L;;;;;N;;;;;
122F9;CUNEIFORM SIGN TAG TIMES UD;Lo;0;L;;;;;N;;;;;
122FA;CUNEIFORM SIGN TAK4;Lo;0;L;;;;;N;;;;;
122FB;CUNEIFORM SIGN TAR;Lo;0;L;;;;;N;;;;;
122FC;CUNEIFORM SIGN TE;Lo;0;L;;;;;N;;;;;
122FD;CUNEIFORM SIGN TE GUNU;Lo;0;L;;;;;N;;;;;
122FE;CUNEIFORM SIGN TI;Lo;0;L;;;;;N;;;;;
122FF;CUNEIFORM SIGN TI TENU;Lo;0;L;;;;;N;;;;;
12300;CUNEIFORM SIGN TIL;Lo;0;L;;;;;N;;;;;
12301;CUNEIFORM SIGN TIR;Lo;0;L;;;;;N;;;;;
12302;CUNEIFORM SIGN TIR TIMES TAK4;Lo;0;L;;;;;N;;;;;
12303;CUNEIFORM SIGN TIR OVER TIR;Lo;0;L;;;;;N;;;;;
12304;CUNEIFORM SIGN TIR OVER TIR GAD OVER GAD GAR OVER GAR;Lo;0;L;;;;;N;;;;;
12305;CUNEIFORM SIGN TU;Lo;0;L;;;;;N;;;;;
12306;CUNEIFORM SIGN TUG2;Lo;0;L;;;;;N;;;;;
12307;CUNEIFORM SIGN TUK;Lo;0;L;;;;;N;;;;;
12308;CUNEIFORM SIGN TUM;Lo;0;L;;;;;N;;;;;
12309;CUNEIFORM SIGN TUR;Lo;0;L;;;;;N;;;;;
1230A;CUNEIFORM SIGN TUR OVER TUR ZA OVER ZA;Lo;0;L;;;;;N;;;;;
1230B;CUNEIFORM SIGN U;Lo;0;L;;;;;N;;;;;
1230C;CUNEIFORM SIGN U GUD;Lo;0;L;;;;;N;;;;;
1230D;CUNEIFORM SIGN U U U;Lo;0;L;;;;;N;;;;;
1230E;CUNEIFORM SIGN U OVER U PA OVER PA GAR OVER GAR;Lo;0;L;;;;;N;;;;;
1230F;CUNEIFORM SIGN U OVER U SUR OVER SUR;Lo;0;L;;;;;N;;;;;
12310;CUNEIFORM SIGN U OVER U U REVERSED OVER U REVERSED;Lo;0;L;;;;;N;;;;;
12311;CUNEIFORM SIGN U2;Lo;0;L;;;;;N;;;;;
12312;CUNEIFORM SIGN UB;Lo;0;L;;;;;N;;;;;
12313;CUNEIFORM SIGN UD;Lo;0;L;;;;;N;;;;;
12314;CUNEIFORM SIGN UD KUSHU2;Lo;0;L;;;;;N;;;;;
12315;CUNEIFORM SIGN UD TIMES BAD;Lo;0;L;;;;;N;;;;;
12316;CUNEIFORM SIGN UD TIMES MI;Lo;0;L;;;;;N;;;;;
12317;CUNEIFORM SIGN UD TIMES U PLUS U PLUS U;Lo;0;L;;;;;N;;;;;
12318;CUNEIFORM SIGN UD TIMES U PLUS U PLUS U GUNU;Lo;0;L;;;;;N;;;;;
12319;CUNEIFORM SIGN UD GUNU;Lo;0;L;;;;;N;;;;;
1231A;CUNEIFORM SIGN UD SHESHIG;Lo;0;L;;;;;N;;;;;
1231B;CUNEIFORM SIGN UD SHESHIG TIMES BAD;Lo;0;L;;;;;N;;;;;
1231C;CUNEIFORM SIGN UDUG;Lo;0;L;;;;;N;;;;;
1231D;CUNEIFORM SIGN UM;Lo;0;L;;;;;N;;;;;
1231E;CUNEIFORM SIGN UM TIMES LAGAB;Lo;0;L;;;;;N;;;;;
1231F;CUNEIFORM SIGN UM TIMES ME PLUS DA;Lo;0;L;;;;;N;;;;;
12320;CUNEIFORM SIGN UM TIMES SHA3;Lo;0;L;;;;;N;;;;;
12321;CUNEIFORM SIGN UM TIMES U;Lo;0;L;;;;;N;;;;;
12322;CUNEIFORM SIGN UMBIN;Lo;0;L;;;;;N;;;;;
12323;CUNEIFORM SIGN UMUM;Lo;0;L;;;;;N;;;;;
12324;CUNEIFORM SIGN UMUM TIMES KASKAL;Lo;0;L;;;;;N;;;;;
12325;CUNEIFORM SIGN UMUM TIMES PA;Lo;0;L;;;;;N;;;;;
12326;CUNEIFORM SIGN UN;Lo;0;L;;;;;N;;;;;
12327;CUNEIFORM SIGN UN GUNU;Lo;0;L;;;;;N;;;;;
12328;CUNEIFORM SIGN UR;Lo;0;L;;;;;N;;;;;
12329;CUNEIFORM SIGN UR CROSSING UR;Lo;0;L;;;;;N;;;;;
1232A;CUNEIFORM SIGN UR SHESHIG;Lo;0;L;;;;;N;;;;;
1232B;CUNEIFORM SIGN UR2;Lo;0;L;;;;;N;;;;;
1232C;CUNEIFORM SIGN UR2 TIMES A PLUS HA;Lo;0;L;;;;;N;;;;;
1232D;CUNEIFORM SIGN UR2 TIMES A PLUS NA;Lo;0;L;;;;;N;;;;;
1232E;CUNEIFORM SIGN UR2 TIMES AL;Lo;0;L;;;;;N;;;;;
1232F;CUNEIFORM SIGN UR2 TIMES HA;Lo;0;L;;;;;N;;;;;
12330;CUNEIFORM SIGN UR2 TIMES NUN;Lo;0;L;;;;;N;;;;;
12331;CUNEIFORM SIGN UR2 TIMES U2;Lo;0;L;;;;;N;;;;;
12332;CUNEIFORM SIGN UR2 TIMES U2 PLUS ASH;Lo;0;L;;;;;N;;;;;
12333;CUNEIFORM SIGN UR2 TIMES U2 PLUS BI;Lo;0;L;;;;;N;;;;;
12334;CUNEIFORM SIGN UR4;Lo;0;L;;;;;N;;;;;
12335;CUNEIFORM SIGN URI;Lo;0;L;;;;;N;;;;;
12336;CUNEIFORM SIGN URI3;Lo;0;L;;;;;N;;;;;
12337;CUNEIFORM SIGN URU;Lo;0;L;;;;;N;;;;;
12338;CUNEIFORM SIGN URU TIMES A;Lo;0;L;;;;;N;;;;;
12339;CUNEIFORM SIGN URU TIMES ASHGAB;Lo;0;L;;;;;N;;;;;
1233A;CUNEIFORM SIGN URU TIMES BAR;Lo;0;L;;;;;N;;;;;
1233B;CUNEIFORM SIGN URU TIMES DUN;Lo;0;L;;;;;N;;;;;
1233C;CUNEIFORM SIGN URU TIMES GA;Lo;0;L;;;;;N;;;;;
1233D;CUNEIFORM SIGN URU TIMES GAL;Lo;0;L;;;;;N;;;;;
1233E;CUNEIFORM SIGN URU TIMES GAN2 TENU;Lo;0;L;;;;;N;;;;;
1233F;CUNEIFORM SIGN URU TIMES GAR;Lo;0;L;;;;;N;;;;;
12340;CUNEIFORM SIGN URU TIMES GU;Lo;0;L;;;;;N;;;;;
12341;CUNEIFORM SIGN URU TIMES HA;Lo;0;L;;;;;N;;;;;
12342;CUNEIFORM SIGN URU TIMES IGI;Lo;0;L;;;;;N;;;;;
12343;CUNEIFORM SIGN URU TIMES IM;Lo;0;L;;;;;N;;;;;
12344;CUNEIFORM SIGN URU TIMES ISH;Lo;0;L;;;;;N;;;;;
12345;CUNEIFORM SIGN URU TIMES KI;Lo;0;L;;;;;N;;;;;
12346;CUNEIFORM SIGN URU TIMES LUM;Lo;0;L;;;;;N;;;;;
12347;CUNEIFORM SIGN URU TIMES MIN;Lo;0;L;;;;;N;;;;;
12348;CUNEIFORM SIGN URU TIMES PA;Lo;0;L;;;;;N;;;;;
12349;CUNEIFORM SIGN URU TIMES SHE;Lo;0;L;;;;;N;;;;;
1234A;CUNEIFORM SIGN URU TIMES SIG4;Lo;0;L;;;;;N;;;;;
1234B;CUNEIFORM SIGN URU TIMES TU;Lo;0;L;;;;;N;;;;;
1234C;CUNEIFORM SIGN URU TIMES U PLUS GUD;Lo;0;L;;;;;N;;;;;
1234D;CUNEIFORM SIGN URU TIMES UD;Lo;0;L;;;;;N;;;;;
1234E;CUNEIFORM SIGN URU TIMES URUDA;Lo;0;L;;;;;N;;;;;
1234F;CUNEIFORM SIGN URUDA;Lo;0;L;;;;;N;;;;;
12350;CUNEIFORM SIGN URUDA TIMES U;Lo;0;L;;;;;N;;;;;
12351;CUNEIFORM SIGN USH;Lo;0;L;;;;;N;;;;;
12352;CUNEIFORM SIGN USH TIMES A;Lo;0;L;;;;;N;;;;;
12353;CUNEIFORM SIGN USH TIMES KU;Lo;0;L;;;;;N;;;;;
12354;CUNEIFORM SIGN USH TIMES KUR;Lo;0;L;;;;;N;;;;;
12355;CUNEIFORM SIGN USH TIMES TAK4;Lo;0;L;;;;;N;;;;;
12356;CUNEIFORM SIGN USHX;Lo;0;L;;;;;N;;;;;
12357;CUNEIFORM SIGN USH2;Lo;0;L;;;;;N;;;;;
12358;CUNEIFORM SIGN USHUMX;Lo;0;L;;;;;N;;;;;
12359;CUNEIFORM SIGN UTUKI;Lo;0;L;;;;;N;;;;;
1235A;CUNEIFORM SIGN UZ3;Lo;0;L;;;;;N;;;;;
1235B;CUNEIFORM SIGN UZ3 TIMES KASKAL;Lo;0;L;;;;;N;;;;;
1235C;CUNEIFORM SIGN UZU;Lo;0;L;;;;;N;;;;;
1235D;CUNEIFORM SIGN ZA;Lo;0;L;;;;;N;;;;;
1235E;CUNEIFORM SIGN ZA TENU;Lo;0;L;;;;;N;;;;;
1235F;CUNEIFORM SIGN ZA SQUARED TIMES KUR;Lo;0;L;;;;;N;;;;;
12360;CUNEIFORM SIGN ZAG;Lo;0;L;;;;;N;;;;;
12361;CUNEIFORM SIGN ZAMX;Lo;0;L;;;;;N;;;;;
12362;CUNEIFORM SIGN ZE2;Lo;0;L;;;;;N;;;;;
12363;CUNEIFORM SIGN ZI;Lo;0;L;;;;;N;;;;;
12364;CUNEIFORM SIGN ZI OVER ZI;Lo;0;L;;;;;N;;;;;
12365;CUNEIFORM SIGN ZI3;Lo;0;L;;;;;N;;;;;
12366;CUNEIFORM SIGN ZIB;Lo;0;L;;;;;N;;;;;
12367;CUNEIFORM SIGN ZIB KABA TENU;Lo;0;L;;;;;N;;;;;
12368;CUNEIFORM SIGN ZIG;Lo;0;L;;;;;N;;;;;
12369;CUNEIFORM SIGN ZIZ2;Lo;0;L;;;;;N;;;;;
1236A;CUNEIFORM SIGN ZU;Lo;0;L;;;;;N;;;;;
1236B;CUNEIFORM SIGN ZU5;Lo;0;L;;;;;N;;;;;
1236C;CUNEIFORM SIGN ZU5 TIMES A;Lo;0;L;;;;;N;;;;;
1236D;CUNEIFORM SIGN ZUBUR;Lo;0;L;;;;;N;;;;;
1236E;CUNEIFORM SIGN ZUM;Lo;0;L;;;;;N;;;;;
1236F;CUNEIFORM SIGN KAP ELAMITE;Lo;0;L;;;;;N;;;;;
12370;CUNEIFORM SIGN AB TIMES NUN;Lo;0;L;;;;;N;;;;;
12371;CUNEIFORM SIGN AB2 TIMES A;Lo;0;L;;;;;N;;;;;
12372;CUNEIFORM SIGN AMAR TIMES KUG;Lo;0;L;;;;;N;;;;;
12373;CUNEIFORM SIGN DAG KISIM5 TIMES U2 PLUS MASH;Lo;0;L;;;;;N;;;;;
12374;CUNEIFORM SIGN DAG3;Lo;0;L;;;;;N;;;;;
12375;CUNEIFORM SIGN DISH PLUS SHU;Lo;0;L;;;;;N;;;;;
12376;CUNEIFORM SIGN DUB TIMES SHE;Lo;0;L;;;;;N;;;;;
12377;CUNEIFORM SIGN EZEN TIMES GUD;Lo;0;L;;;;;N;;;;;
12378;CUNEIFORM SIGN EZEN TIMES SHE;Lo;0;L;;;;;N;;;;;
12379;CUNEIFORM SIGN GA2 TIMES AN PLUS KAK PLUS A;Lo;0;L;;;;;N;;;;;
1237A;CUNEIFORM SIGN GA2 TIMES ASH2;Lo;0;L;;;;;N;;;;;
1237B;CUNEIFORM SIGN GE22;Lo;0;L;;;;;N;;;;;
1237C;CUNEIFORM SIGN GIG;Lo;0;L;;;;;N;;;;;
1237D;CUNEIFORM SIGN HUSH;Lo;0;L;;;;;N;;;;;
1237E;CUNEIFORM SIGN KA TIMES ANSHE;Lo;0;L;;;;;N;;;;;
1237F;CUNEIFORM SIGN KA TIMES ASH3;Lo;0;L;;;;;N;;;;;
12380;CUNEIFORM SIGN KA TIMES GISH;Lo;0;L;;;;;N;;;;;
12381;CUNEIFORM SIGN KA TIMES GUD;Lo;0;L;;;;;N;;;;;
12382;CUNEIFORM SIGN KA TIMES HI TIMES ASH2;Lo;0;L;;;;;N;;;;;
12383;CUNEIFORM SIGN KA TIMES LUM;Lo;0;L;;;;;N;;;;;
12384;CUNEIFORM SIGN KA TIMES PA;Lo;0;L;;;;;N;;;;;
12385;CUNEIFORM SIGN KA TIMES SHUL;Lo;0;L;;;;;N;;;;;
12386;CUNEIFORM SIGN KA TIMES TU;Lo;0;L;;;;;N;;;;;
12387;CUNEIFORM SIGN KA TIMES UR2;Lo;0;L;;;;;N;;;;;
12388;CUNEIFORM SIGN LAGAB TIMES GI;Lo;0;L;;;;;N;;;;;
12389;CUNEIFORM SIGN LU2 SHESHIG TIMES BAD;Lo;0;L;;;;;N;;;;;
1238A;CUNEIFORM SIGN LU2 TIMES ESH2 PLUS LAL;Lo;0;L;;;;;N;;;;;
1238B;CUNEIFORM SIGN LU2 TIMES SHU;Lo;0;L;;;;;N;;;;;
1238C;CUNEIFORM SIGN MESH;Lo;0;L;;;;;N;;;;;
1238D;CUNEIFORM SIGN MUSH3 TIMES ZA;Lo;0;L;;;;;N;;;;;
1238E;CUNEIFORM SIGN NA4;Lo;0;L;;;;;N;;;;;
1238F;CUNEIFORM SIGN NIN;Lo;0;L;;;;;N;;;;;
12390;CUNEIFORM SIGN NIN9;Lo;0;L;;;;;N;;;;;
12391;CUNEIFORM SIGN NINDA2 TIMES BAL;Lo;0;L;;;;;N;;;;;
12392;CUNEIFORM SIGN NINDA2 TIMES GI;Lo;0;L;;;;;N;;;;;
12393;CUNEIFORM SIGN NU11 ROTATED NINETY DEGREES;Lo;0;L;;;;;N;;;;;
12394;CUNEIFORM SIGN PESH2 ASTERISK;Lo;0;L;;;;;N;;;;;
12395;CUNEIFORM SIGN PIR2;Lo;0;L;;;;;N;;;;;
12396;CUNEIFORM SIGN SAG TIMES IGI GUNU;Lo;0;L;;;;;N;;;;;
12397;CUNEIFORM SIGN TI2;Lo;0;L;;;;;N;;;;;
12398;CUNEIFORM SIGN UM TIMES ME;Lo;0;L;;;;;N;;;;;
12399;CUNEIFORM SIGN U U;Lo;0;L;;;;;N;;;;;
12400;CUNEIFORM NUMERIC SIGN TWO ASH;Nl;0;L;;;;2;N;;;;;
12401;CUNEIFORM NUMERIC SIGN THREE ASH;Nl;0;L;;;;3;N;;;;;
12402;CUNEIFORM NUMERIC SIGN FOUR ASH;Nl;0;L;;;;4;N;;;;;
12403;CUNEIFORM NUMERIC SIGN FIVE ASH;Nl;0;L;;;;5;N;;;;;
12404;CUNEIFORM NUMERIC SIGN SIX ASH;Nl;0;L;;;;6;N;;;;;
12405;CUNEIFORM NUMERIC SIGN SEVEN ASH;Nl;0;L;;;;7;N;;;;;
12406;CUNEIFORM NUMERIC SIGN EIGHT ASH;Nl;0;L;;;;8;N;;;;;
12407;CUNEIFORM NUMERIC SIGN NINE ASH;Nl;0;L;;;;9;N;;;;;
12408;CUNEIFORM NUMERIC SIGN THREE DISH;Nl;0;L;;;;3;N;;;;;
12409;CUNEIFORM NUMERIC SIGN FOUR DISH;Nl;0;L;;;;4;N;;;;;
1240A;CUNEIFORM NUMERIC SIGN FIVE DISH;Nl;0;L;;;;5;N;;;;;
1240B;CUNEIFORM NUMERIC SIGN SIX DISH;Nl;0;L;;;;6;N;;;;;
1240C;CUNEIFORM NUMERIC SIGN SEVEN DISH;Nl;0;L;;;;7;N;;;;;
1240D;CUNEIFORM NUMERIC SIGN EIGHT DISH;Nl;0;L;;;;8;N;;;;;
1240E;CUNEIFORM NUMERIC SIGN NINE DISH;Nl;0;L;;;;9;N;;;;;
1240F;CUNEIFORM NUMERIC SIGN FOUR U;Nl;0;L;;;;4;N;;;;;
12410;CUNEIFORM NUMERIC SIGN FIVE U;Nl;0;L;;;;5;N;;;;;
12411;CUNEIFORM NUMERIC SIGN SIX U;Nl;0;L;;;;6;N;;;;;
12412;CUNEIFORM NUMERIC SIGN SEVEN U;Nl;0;L;;;;7;N;;;;;
12413;CUNEIFORM NUMERIC SIGN EIGHT U;Nl;0;L;;;;8;N;;;;;
12414;CUNEIFORM NUMERIC SIGN NINE U;Nl;0;L;;;;9;N;;;;;
12415;CUNEIFORM NUMERIC SIGN ONE GESH2;Nl;0;L;;;;1;N;;;;;
12416;CUNEIFORM NUMERIC SIGN TWO GESH2;Nl;0;L;;;;2;N;;;;;
12417;CUNEIFORM NUMERIC SIGN THREE GESH2;Nl;0;L;;;;3;N;;;;;
12418;CUNEIFORM NUMERIC SIGN FOUR GESH2;Nl;0;L;;;;4;N;;;;;
12419;CUNEIFORM NUMERIC SIGN FIVE GESH2;Nl;0;L;;;;5;N;;;;;
1241A;CUNEIFORM NUMERIC SIGN SIX GESH2;Nl;0;L;;;;6;N;;;;;
1241B;CUNEIFORM NUMERIC SIGN SEVEN GESH2;Nl;0;L;;;;7;N;;;;;
1241C;CUNEIFORM NUMERIC SIGN EIGHT GESH2;Nl;0;L;;;;8;N;;;;;
1241D;CUNEIFORM NUMERIC SIGN NINE GESH2;Nl;0;L;;;;9;N;;;;;
1241E;CUNEIFORM NUMERIC SIGN ONE GESHU;Nl;0;L;;;;1;N;;;;;
1241F;CUNEIFORM NUMERIC SIGN TWO GESHU;Nl;0;L;;;;2;N;;;;;
12420;CUNEIFORM NUMERIC SIGN THREE GESHU;Nl;0;L;;;;3;N;;;;;
12421;CUNEIFORM NUMERIC SIGN FOUR GESHU;Nl;0;L;;;;4;N;;;;;
12422;CUNEIFORM NUMERIC SIGN FIVE GESHU;Nl;0;L;;;;5;N;;;;;
12423;CUNEIFORM NUMERIC SIGN TWO SHAR2;Nl;0;L;;;;2;N;;;;;
12424;CUNEIFORM NUMERIC SIGN THREE SHAR2;Nl;0;L;;;;3;N;;;;;
12425;CUNEIFORM NUMERIC SIGN THREE SHAR2 VARIANT FORM;Nl;0;L;;;;3;N;;;;;
12426;CUNEIFORM NUMERIC SIGN FOUR SHAR2;Nl;0;L;;;;4;N;;;;;
12427;CUNEIFORM NUMERIC SIGN FIVE SHAR2;Nl;0;L;;;;5;N;;;;;
12428;CUNEIFORM NUMERIC SIGN SIX SHAR2;Nl;0;L;;;;6;N;;;;;
12429;CUNEIFORM NUMERIC SIGN SEVEN SHAR2;Nl;0;L;;;;7;N;;;;;
1242A;CUNEIFORM NUMERIC SIGN EIGHT SHAR2;Nl;0;L;;;;8;N;;;;;
1242B;CUNEIFORM NUMERIC SIGN NINE SHAR2;Nl;0;L;;;;9;N;;;;;
1242C;CUNEIFORM NUMERIC SIGN ONE SHARU;Nl;0;L;;;;1;N;;;;;
1242D;CUNEIFORM NUMERIC SIGN TWO SHARU;Nl;0;L;;;;2;N;;;;;
1242E;CUNEIFORM NUMERIC SIGN THREE SHARU;Nl;0;L;;;;3;N;;;;;
1242F;CUNEIFORM NUMERIC SIGN THREE SHARU VARIANT FORM;Nl;0;L;;;;3;N;;;;;
12430;CUNEIFORM NUMERIC SIGN FOUR SHARU;Nl;0;L;;;;4;N;;;;;
12431;CUNEIFORM NUMERIC SIGN FIVE SHARU;Nl;0;L;;;;5;N;;;;;
12432;CUNEIFORM NUMERIC SIGN SHAR2 TIMES GAL PLUS DISH;Nl;0;L;;;;216000;N;;;;;
12433;CUNEIFORM NUMERIC SIGN SHAR2 TIMES GAL PLUS MIN;Nl;0;L;;;;432000;N;;;;;
12434;CUNEIFORM NUMERIC SIGN ONE BURU;Nl;0;L;;;;1;N;;;;;
12435;CUNEIFORM NUMERIC SIGN TWO BURU;Nl;0;L;;;;2;N;;;;;
12436;CUNEIFORM NUMERIC SIGN THREE BURU;Nl;0;L;;;;3;N;;;;;
12437;CUNEIFORM NUMERIC SIGN THREE BURU VARIANT FORM;Nl;0;L;;;;3;N;;;;;
12438;CUNEIFORM NUMERIC SIGN FOUR BURU;Nl;0;L;;;;4;N;;;;;
12439;CUNEIFORM NUMERIC SIGN FIVE BURU;Nl;0;L;;;;5;N;;;;;
1243A;CUNEIFORM NUMERIC SIGN THREE VARIANT FORM ESH16;Nl;0;L;;;;3;N;;;;;
1243B;CUNEIFORM NUMERIC SIGN THREE VARIANT FORM ESH21;Nl;0;L;;;;3;N;;;;;
1243C;CUNEIFORM NUMERIC SIGN FOUR VARIANT FORM LIMMU;Nl;0;L;;;;4;N;;;;;
1243D;CUNEIFORM NUMERIC SIGN FOUR VARIANT FORM LIMMU4;Nl;0;L;;;;4;N;;;;;
1243E;CUNEIFORM NUMERIC SIGN FOUR VARIANT FORM LIMMU A;Nl;0;L;;;;4;N;;;;;
1243F;CUNEIFORM NUMERIC SIGN FOUR VARIANT FORM LIMMU B;Nl;0;L;;;;4;N;;;;;
12440;CUNEIFORM NUMERIC SIGN SIX VARIANT FORM ASH9;Nl;0;L;;;;6;N;;;;;
12441;CUNEIFORM NUMERIC SIGN SEVEN VARIANT FORM IMIN3;Nl;0;L;;;;7;N;;;;;
12442;CUNEIFORM NUMERIC SIGN SEVEN VARIANT FORM IMIN A;Nl;0;L;;;;7;N;;;;;
12443;CUNEIFORM NUMERIC SIGN SEVEN VARIANT FORM IMIN B;Nl;0;L;;;;7;N;;;;;
12444;CUNEIFORM NUMERIC SIGN EIGHT VARIANT FORM USSU;Nl;0;L;;;;8;N;;;;;
12445;CUNEIFORM NUMERIC SIGN EIGHT VARIANT FORM USSU3;Nl;0;L;;;;8;N;;;;;
12446;CUNEIFORM NUMERIC SIGN NINE VARIANT FORM ILIMMU;Nl;0;L;;;;9;N;;;;;
12447;CUNEIFORM NUMERIC SIGN NINE VARIANT FORM ILIMMU3;Nl;0;L;;;;9;N;;;;;
12448;CUNEIFORM NUMERIC SIGN NINE VARIANT FORM ILIMMU4;Nl;0;L;;;;9;N;;;;;
12449;CUNEIFORM NUMERIC SIGN NINE VARIANT FORM ILIMMU A;Nl;0;L;;;;9;N;;;;;
1244A;CUNEIFORM NUMERIC SIGN TWO ASH TENU;Nl;0;L;;;;2;N;;;;;
1244B;CUNEIFORM NUMERIC SIGN THREE ASH TENU;Nl;0;L;;;;3;N;;;;;
1244C;CUNEIFORM NUMERIC SIGN FOUR ASH TENU;Nl;0;L;;;;4;N;;;;;
1244D;CUNEIFORM NUMERIC SIGN FIVE ASH TENU;Nl;0;L;;;;5;N;;;;;
1244E;CUNEIFORM NUMERIC SIGN SIX ASH TENU;Nl;0;L;;;;6;N;;;;;
1244F;CUNEIFORM NUMERIC SIGN ONE BAN2;Nl;0;L;;;;1;N;;;;;
12450;CUNEIFORM NUMERIC SIGN TWO BAN2;Nl;0;L;;;;2;N;;;;;
12451;CUNEIFORM NUMERIC SIGN THREE BAN2;Nl;0;L;;;;3;N;;;;;
12452;CUNEIFORM NUMERIC SIGN FOUR BAN2;Nl;0;L;;;;4;N;;;;;
12453;CUNEIFORM NUMERIC SIGN FOUR BAN2 VARIANT FORM;Nl;0;L;;;;4;N;;;;;
12454;CUNEIFORM NUMERIC SIGN FIVE BAN2;Nl;0;L;;;;5;N;;;;;
12455;CUNEIFORM NUMERIC SIGN FIVE BAN2 VARIANT FORM;Nl;0;L;;;;5;N;;;;;
12456;CUNEIFORM NUMERIC SIGN NIGIDAMIN;Nl;0;L;;;;2;N;;;;;
12457;CUNEIFORM NUMERIC SIGN NIGIDAESH;Nl;0;L;;;;3;N;;;;;
12458;CUNEIFORM NUMERIC SIGN ONE ESHE3;Nl;0;L;;;;1;N;;;;;
12459;CUNEIFORM NUMERIC SIGN TWO ESHE3;Nl;0;L;;;;2;N;;;;;
1245A;CUNEIFORM NUMERIC SIGN ONE THIRD DISH;Nl;0;L;;;;1/3;N;;;;;
1245B;CUNEIFORM NUMERIC SIGN TWO THIRDS DISH;Nl;0;L;;;;2/3;N;;;;;
1245C;CUNEIFORM NUMERIC SIGN FIVE SIXTHS DISH;Nl;0;L;;;;5/6;N;;;;;
1245D;CUNEIFORM NUMERIC SIGN ONE THIRD VARIANT FORM A;Nl;0;L;;;;1/3;N;;;;;
1245E;CUNEIFORM NUMERIC SIGN TWO THIRDS VARIANT FORM A;Nl;0;L;;;;2/3;N;;;;;
1245F;CUNEIFORM NUMERIC SIGN ONE EIGHTH ASH;Nl;0;L;;;;1/8;N;;;;;
12460;CUNEIFORM NUMERIC SIGN ONE QUARTER ASH;Nl;0;L;;;;1/4;N;;;;;
12461;CUNEIFORM NUMERIC SIGN OLD ASSYRIAN ONE SIXTH;Nl;0;L;;;;1/6;N;;;;;
12462;CUNEIFORM NUMERIC SIGN OLD ASSYRIAN ONE QUARTER;Nl;0;L;;;;1/4;N;;;;;
12463;CUNEIFORM NUMERIC SIGN ONE QUARTER GUR;Nl;0;L;;;;1/4;N;;;;;
12464;CUNEIFORM NUMERIC SIGN ONE HALF GUR;Nl;0;L;;;;1/2;N;;;;;
12465;CUNEIFORM NUMERIC SIGN ELAMITE ONE THIRD;Nl;0;L;;;;1/3;N;;;;;
12466;CUNEIFORM NUMERIC SIGN ELAMITE TWO THIRDS;Nl;0;L;;;;2/3;N;;;;;
12467;CUNEIFORM NUMERIC SIGN ELAMITE FORTY;Nl;0;L;;;;40;N;;;;;
12468;CUNEIFORM NUMERIC SIGN ELAMITE FIFTY;Nl;0;L;;;;50;N;;;;;
12469;CUNEIFORM NUMERIC SIGN FOUR U VARIANT FORM;Nl;0;L;;;;4;N;;;;;
1246A;CUNEIFORM NUMERIC SIGN FIVE U VARIANT FORM;Nl;0;L;;;;5;N;;;;;
1246B;CUNEIFORM NUMERIC SIGN SIX U VARIANT FORM;Nl;0;L;;;;6;N;;;;;
1246C;CUNEIFORM NUMERIC SIGN SEVEN U VARIANT FORM;Nl;0;L;;;;7;N;;;;;
1246D;CUNEIFORM NUMERIC SIGN EIGHT U VARIANT FORM;Nl;0;L;;;;8;N;;;;;
1246E;CUNEIFORM NUMERIC SIGN NINE U VARIANT FORM;Nl;0;L;;;;9;N;;;;;
12470;CUNEIFORM PUNCTUATION SIGN OLD ASSYRIAN WORD DIVIDER;Po;0;L;;;;;N;;;;;
12471;CUNEIFORM PUNCTUATION SIGN VERTICAL COLON;Po;0;L;;;;;N;;;;;
12472;CUNEIFORM PUNCTUATION SIGN DIAGONAL COLON;Po;0;L;;;;;N;;;;;
12473;CUNEIFORM PUNCTUATION SIGN DIAGONAL TRICOLON;Po;0;L;;;;;N;;;;;
12474;CUNEIFORM PUNCTUATION SIGN DIAGONAL QUADCOLON;Po;0;L;;;;;N;;;;;
12480;CUNEIFORM SIGN AB TIMES NUN TENU;Lo;0;L;;;;;N;;;;;
12481;CUNEIFORM SIGN AB TIMES SHU2;Lo;0;L;;;;;N;;;;;
12482;CUNEIFORM SIGN AD TIMES ESH2;Lo;0;L;;;;;N;;;;;
12483;CUNEIFORM SIGN BAD TIMES DISH TENU;Lo;0;L;;;;;N;;;;;
12484;CUNEIFORM SIGN BAHAR2 TIMES AB2;Lo;0;L;;;;;N;;;;;
12485;CUNEIFORM SIGN BAHAR2 TIMES NI;Lo;0;L;;;;;N;;;;;
12486;CUNEIFORM SIGN BAHAR2 TIMES ZA;Lo;0;L;;;;;N;;;;;
12487;CUNEIFORM SIGN BU OVER BU TIMES NA2;Lo;0;L;;;;;N;;;;;
12488;CUNEIFORM SIGN DA TIMES TAK4;Lo;0;L;;;;;N;;;;;
12489;CUNEIFORM SIGN DAG TIMES KUR;Lo;0;L;;;;;N;;;;;
1248A;CUNEIFORM SIGN DIM TIMES IGI;Lo;0;L;;;;;N;;;;;
1248B;CUNEIFORM SIGN DIM TIMES U U U;Lo;0;L;;;;;N;;;;;
1248C;CUNEIFORM SIGN DIM2 TIMES UD;Lo;0;L;;;;;N;;;;;
1248D;CUNEIFORM SIGN DUG TIMES ANSHE;Lo;0;L;;;;;N;;;;;
1248E;CUNEIFORM SIGN DUG TIMES ASH;Lo;0;L;;;;;N;;;;;
1248F;CUNEIFORM SIGN DUG TIMES ASH AT LEFT;Lo;0;L;;;;;N;;;;;
12490;CUNEIFORM SIGN DUG TIMES DIN;Lo;0;L;;;;;N;;;;;
12491;CUNEIFORM SIGN DUG TIMES DUN;Lo;0;L;;;;;N;;;;;
12492;CUNEIFORM SIGN DUG TIMES ERIN2;Lo;0;L;;;;;N;;;;;
12493;CUNEIFORM SIGN DUG TIMES GA;Lo;0;L;;;;;N;;;;;
12494;CUNEIFORM SIGN DUG TIMES GI;Lo;0;L;;;;;N;;;;;
12495;CUNEIFORM SIGN DUG TIMES GIR2 GUNU;Lo;0;L;;;;;N;;;;;
12496;CUNEIFORM SIGN DUG TIMES GISH;Lo;0;L;;;;;N;;;;;
12497;CUNEIFORM SIGN DUG TIMES HA;Lo;0;L;;;;;N;;;;;
12498;CUNEIFORM SIGN DUG TIMES HI;Lo;0;L;;;;;N;;;;;
12499;CUNEIFORM SIGN DUG TIMES IGI GUNU;Lo;0;L;;;;;N;;;;;
1249A;CUNEIFORM SIGN DUG TIMES KASKAL;Lo;0;L;;;;;N;;;;;
1249B;CUNEIFORM SIGN DUG TIMES KUR;Lo;0;L;;;;;N;;;;;
1249C;CUNEIFORM SIGN DUG TIMES KUSHU2;Lo;0;L;;;;;N;;;;;
1249D;CUNEIFORM SIGN DUG TIMES KUSHU2 PLUS KASKAL;Lo;0;L;;;;;N;;;;;
1249E;CUNEIFORM SIGN DUG TIMES LAK-020;Lo;0;L;;;;;N;;;;;
1249F;CUNEIFORM SIGN DUG TIMES LAM;Lo;0;L;;;;;N;;;;;
124A0;CUNEIFORM SIGN DUG TIMES LAM TIMES KUR;Lo;0;L;;;;;N;;;;;
124A1;CUNEIFORM SIGN DUG TIMES LUH PLUS GISH;Lo;0;L;;;;;N;;;;;
124A2;CUNEIFORM SIGN DUG TIMES MASH;Lo;0;L;;;;;N;;;;;
124A3;CUNEIFORM SIGN DUG TIMES MES;Lo;0;L;;;;;N;;;;;
124A4;CUNEIFORM SIGN DUG TIMES MI;Lo;0;L;;;;;N;;;;;
124A5;CUNEIFORM SIGN DUG TIMES NI;Lo;0;L;;;;;N;;;;;
124A6;CUNEIFORM SIGN DUG TIMES PI;Lo;0;L;;;;;N;;;;;
124A7;CUNEIFORM SIGN DUG TIMES SHE;Lo;0;L;;;;;N;;;;;
124A8;CUNEIFORM SIGN DUG TIMES SI GUNU;Lo;0;L;;;;;N;;;;;
124A9;CUNEIFORM SIGN E2 TIMES KUR;Lo;0;L;;;;;N;;;;;
124AA;CUNEIFORM SIGN E2 TIMES PAP;Lo;0;L;;;;;N;;;;;
124AB;CUNEIFORM SIGN ERIN2 X;Lo;0;L;;;;;N;;;;;
124AC;CUNEIFORM SIGN ESH2 CROSSING ESH2;Lo;0;L;;;;;N;;;;;
124AD;CUNEIFORM SIGN EZEN SHESHIG TIMES ASH;Lo;0;L;;;;;N;;;;;
124AE;CUNEIFORM SIGN EZEN SHESHIG TIMES HI;Lo;0;L;;;;;N;;;;;
124AF;CUNEIFORM SIGN EZEN SHESHIG TIMES IGI GUNU;Lo;0;L;;;;;N;;;;;
124B0;CUNEIFORM SIGN EZEN SHESHIG TIMES LA;Lo;0;L;;;;;N;;;;;
124B1;CUNEIFORM SIGN EZEN SHESHIG TIMES LAL;Lo;0;L;;;;;N;;;;;
124B2;CUNEIFORM SIGN EZEN SHESHIG TIMES ME;Lo;0;L;;;;;N;;;;;
124B3;CUNEIFORM SIGN EZEN SHESHIG TIMES MES;Lo;0;L;;;;;N;;;;;
124B4;CUNEIFORM SIGN EZEN SHESHIG TIMES SU;Lo;0;L;;;;;N;;;;;
124B5;CUNEIFORM SIGN EZEN TIMES SU;Lo;0;L;;;;;N;;;;;
124B6;CUNEIFORM SIGN GA2 TIMES BAHAR2;Lo;0;L;;;;;N;;;;;
124B7;CUNEIFORM SIGN GA2 TIMES DIM GUNU;Lo;0;L;;;;;N;;;;;
124B8;CUNEIFORM SIGN GA2 TIMES DUG TIMES IGI GUNU;Lo;0;L;;;;;N;;;;;
124B9;CUNEIFORM SIGN GA2 TIMES DUG TIMES KASKAL;Lo;0;L;;;;;N;;;;;
124BA;CUNEIFORM SIGN GA2 TIMES EREN;Lo;0;L;;;;;N;;;;;
124BB;CUNEIFORM SIGN GA2 TIMES GA;Lo;0;L;;;;;N;;;;;
124BC;CUNEIFORM SIGN GA2 TIMES GAR PLUS DI;Lo;0;L;;;;;N;;;;;
124BD;CUNEIFORM SIGN GA2 TIMES GAR PLUS NE;Lo;0;L;;;;;N;;;;;
124BE;CUNEIFORM SIGN GA2 TIMES HA PLUS A;Lo;0;L;;;;;N;;;;;
124BF;CUNEIFORM SIGN GA2 TIMES KUSHU2 PLUS KASKAL;Lo;0;L;;;;;N;;;;;
124C0;CUNEIFORM SIGN GA2 TIMES LAM;Lo;0;L;;;;;N;;;;;
124C1;CUNEIFORM SIGN GA2 TIMES LAM TIMES KUR;Lo;0;L;;;;;N;;;;;
124C2;CUNEIFORM SIGN GA2 TIMES LUH;Lo;0;L;;;;;N;;;;;
124C3;CUNEIFORM SIGN GA2 TIMES MUSH;Lo;0;L;;;;;N;;;;;
124C4;CUNEIFORM SIGN GA2 TIMES NE;Lo;0;L;;;;;N;;;;;
124C5;CUNEIFORM SIGN GA2 TIMES NE PLUS E2;Lo;0;L;;;;;N;;;;;
124C6;CUNEIFORM SIGN GA2 TIMES NE PLUS GI;Lo;0;L;;;;;N;;;;;
124C7;CUNEIFORM SIGN GA2 TIMES SHIM;Lo;0;L;;;;;N;;;;;
124C8;CUNEIFORM SIGN GA2 TIMES ZIZ2;Lo;0;L;;;;;N;;;;;
124C9;CUNEIFORM SIGN GABA ROTATED NINETY DEGREES;Lo;0;L;;;;;N;;;;;
124CA;CUNEIFORM SIGN GESHTIN TIMES U;Lo;0;L;;;;;N;;;;;
124CB;CUNEIFORM SIGN GISH TIMES GISH CROSSING GISH;Lo;0;L;;;;;N;;;;;
124CC;CUNEIFORM SIGN GU2 TIMES IGI GUNU;Lo;0;L;;;;;N;;;;;
124CD;CUNEIFORM SIGN GUD PLUS GISH TIMES TAK4;Lo;0;L;;;;;N;;;;;
124CE;CUNEIFORM SIGN HA TENU GUNU;Lo;0;L;;;;;N;;;;;
124CF;CUNEIFORM SIGN HI TIMES ASH OVER HI TIMES ASH;Lo;0;L;;;;;N;;;;;
124D0;CUNEIFORM SIGN KA TIMES BU;Lo;0;L;;;;;N;;;;;
124D1;CUNEIFORM SIGN KA TIMES KA;Lo;0;L;;;;;N;;;;;
124D2;CUNEIFORM SIGN KA TIMES U U U;Lo;0;L;;;;;N;;;;;
124D3;CUNEIFORM SIGN KA TIMES UR;Lo;0;L;;;;;N;;;;;
124D4;CUNEIFORM SIGN LAGAB TIMES ZU OVER ZU;Lo;0;L;;;;;N;;;;;
124D5;CUNEIFORM SIGN LAK-003;Lo;0;L;;;;;N;;;;;
124D6;CUNEIFORM SIGN LAK-021;Lo;0;L;;;;;N;;;;;
124D7;CUNEIFORM SIGN LAK-025;Lo;0;L;;;;;N;;;;;
124D8;CUNEIFORM SIGN LAK-030;Lo;0;L;;;;;N;;;;;
124D9;CUNEIFORM SIGN LAK-050;Lo;0;L;;;;;N;;;;;
124DA;CUNEIFORM SIGN LAK-051;Lo;0;L;;;;;N;;;;;
124DB;CUNEIFORM SIGN LAK-062;Lo;0;L;;;;;N;;;;;
124DC;CUNEIFORM SIGN LAK-079 OVER LAK-079 GUNU;Lo;0;L;;;;;N;;;;;
124DD;CUNEIFORM SIGN LAK-080;Lo;0;L;;;;;N;;;;;
124DE;CUNEIFORM SIGN LAK-081 OVER LAK-081;Lo;0;L;;;;;N;;;;;
124DF;CUNEIFORM SIGN LAK-092;Lo;0;L;;;;;N;;;;;
124E0;CUNEIFORM SIGN LAK-130;Lo;0;L;;;;;N;;;;;
124E1;CUNEIFORM SIGN LAK-142;Lo;0;L;;;;;N;;;;;
124E2;CUNEIFORM SIGN LAK-210;Lo;0;L;;;;;N;;;;;
124E3;CUNEIFORM SIGN LAK-219;Lo;0;L;;;;;N;;;;;
124E4;CUNEIFORM SIGN LAK-220;Lo;0;L;;;;;N;;;;;
124E5;CUNEIFORM SIGN LAK-225;Lo;0;L;;;;;N;;;;;
124E6;CUNEIFORM SIGN LAK-228;Lo;0;L;;;;;N;;;;;
124E7;CUNEIFORM SIGN LAK-238;Lo;0;L;;;;;N;;;;;
124E8;CUNEIFORM SIGN LAK-265;Lo;0;L;;;;;N;;;;;
124E9;CUNEIFORM SIGN LAK-266;Lo;0;L;;;;;N;;;;;
124EA;CUNEIFORM SIGN LAK-343;Lo;0;L;;;;;N;;;;;
124EB;CUNEIFORM SIGN LAK-347;Lo;0;L;;;;;N;;;;;
124EC;CUNEIFORM SIGN LAK-348;Lo;0;L;;;;;N;;;;;
124ED;CUNEIFORM SIGN LAK-383;Lo;0;L;;;;;N;;;;;
124EE;CUNEIFORM SIGN LAK-384;Lo;0;L;;;;;N;;;;;
124EF;CUNEIFORM SIGN LAK-390;Lo;0;L;;;;;N;;;;;
124F0;CUNEIFORM SIGN LAK-441;Lo;0;L;;;;;N;;;;;
124F1;CUNEIFORM SIGN LAK-449;Lo;0;L;;;;;N;;;;;
124F2;CUNEIFORM SIGN LAK-449 TIMES GU;Lo;0;L;;;;;N;;;;;
124F3;CUNEIFORM SIGN LAK-449 TIMES IGI;Lo;0;L;;;;;N;;;;;
124F4;CUNEIFORM SIGN LAK-449 TIMES PAP PLUS LU3;Lo;0;L;;;;;N;;;;;
124F5;CUNEIFORM SIGN LAK-449 TIMES PAP PLUS PAP PLUS LU3;Lo;0;L;;;;;N;;;;;
124F6;CUNEIFORM SIGN LAK-449 TIMES U2 PLUS BA;Lo;0;L;;;;;N;;;;;
124F7;CUNEIFORM SIGN LAK-450;Lo;0;L;;;;;N;;;;;
124F8;CUNEIFORM SIGN LAK-457;Lo;0;L;;;;;N;;;;;
124F9;CUNEIFORM SIGN LAK-470;Lo;0;L;;;;;N;;;;;
124FA;CUNEIFORM SIGN LAK-483;Lo;0;L;;;;;N;;;;;
124FB;CUNEIFORM SIGN LAK-490;Lo;0;L;;;;;N;;;;;
124FC;CUNEIFORM SIGN LAK-492;Lo;0;L;;;;;N;;;;;
124FD;CUNEIFORM SIGN LAK-493;Lo;0;L;;;;;N;;;;;
124FE;CUNEIFORM SIGN LAK-495;Lo;0;L;;;;;N;;;;;
124FF;CUNEIFORM SIGN LAK-550;Lo;0;L;;;;;N;;;;;
12500;CUNEIFORM SIGN LAK-608;Lo;0;L;;;;;N;;;;;
12501;CUNEIFORM SIGN LAK-617;Lo;0;L;;;;;N;;;;;
12502;CUNEIFORM SIGN LAK-617 TIMES ASH;Lo;0;L;;;;;N;;;;;
12503;CUNEIFORM SIGN LAK-617 TIMES BAD;Lo;0;L;;;;;N;;;;;
12504;CUNEIFORM SIGN LAK-617 TIMES DUN3 GUNU GUNU;Lo;0;L;;;;;N;;;;;
12505;CUNEIFORM SIGN LAK-617 TIMES KU3;Lo;0;L;;;;;N;;;;;
12506;CUNEIFORM SIGN LAK-617 TIMES LA;Lo;0;L;;;;;N;;;;;
12507;CUNEIFORM SIGN LAK-617 TIMES TAR;Lo;0;L;;;;;N;;;;;
12508;CUNEIFORM SIGN LAK-617 TIMES TE;Lo;0;L;;;;;N;;;;;
12509;CUNEIFORM SIGN LAK-617 TIMES U2;Lo;0;L;;;;;N;;;;;
1250A;CUNEIFORM SIGN LAK-617 TIMES UD;Lo;0;L;;;;;N;;;;;
1250B;CUNEIFORM SIGN LAK-617 TIMES URUDA;Lo;0;L;;;;;N;;;;;
1250C;CUNEIFORM SIGN LAK-636;Lo;0;L;;;;;N;;;;;
1250D;CUNEIFORM SIGN LAK-648;Lo;0;L;;;;;N;;;;;
1250E;CUNEIFORM SIGN LAK-648 TIMES DUB;Lo;0;L;;;;;N;;;;;
1250F;CUNEIFORM SIGN LAK-648 TIMES GA;Lo;0;L;;;;;N;;;;;
12510;CUNEIFORM SIGN LAK-648 TIMES IGI;Lo;0;L;;;;;N;;;;;
12511;CUNEIFORM SIGN LAK-648 TIMES IGI GUNU;Lo;0;L;;;;;N;;;;;
12512;CUNEIFORM SIGN LAK-648 TIMES NI;Lo;0;L;;;;;N;;;;;
12513;CUNEIFORM SIGN LAK-648 TIMES PAP PLUS PAP PLUS LU3;Lo;0;L;;;;;N;;;;;
12514;CUNEIFORM SIGN LAK-648 TIMES SHESH PLUS KI;Lo;0;L;;;;;N;;;;;
12515;CUNEIFORM SIGN LAK-648 TIMES UD;Lo;0;L;;;;;N;;;;;
12516;CUNEIFORM SIGN LAK-648 TIMES URUDA;Lo;0;L;;;;;N;;;;;
12517;CUNEIFORM SIGN LAK-724;Lo;0;L;;;;;N;;;;;
12518;CUNEIFORM SIGN LAK-749;Lo;0;L;;;;;N;;;;;
12519;CUNEIFORM SIGN LU2 GUNU TIMES ASH;Lo;0;L;;;;;N;;;;;
1251A;CUNEIFORM SIGN LU2 TIMES DISH;Lo;0;L;;;;;N;;;;;
1251B;CUNEIFORM SIGN LU2 TIMES HAL;Lo;0;L;;;;;N;;;;;
1251C;CUNEIFORM SIGN LU2 TIMES PAP;Lo;0;L;;;;;N;;;;;
1251D;CUNEIFORM SIGN LU2 TIMES PAP PLUS PAP PLUS LU3;Lo;0;L;;;;;N;;;;;
1251E;CUNEIFORM SIGN LU2 TIMES TAK4;Lo;0;L;;;;;N;;;;;
1251F;CUNEIFORM SIGN MI PLUS ZA7;Lo;0;L;;;;;N;;;;;
12520;CUNEIFORM SIGN MUSH OVER MUSH TIMES GA;Lo;0;L;;;;;N;;;;;
12521;CUNEIFORM SIGN MUSH OVER MUSH TIMES KAK;Lo;0;L;;;;;N;;;;;
12522;CUNEIFORM SIGN NINDA2 TIMES DIM GUNU;Lo;0;L;;;;;N;;;;;
12523;CUNEIFORM SIGN NINDA2 TIMES GISH;Lo;0;L;;;;;N;;;;;
12524;CUNEIFORM SIGN NINDA2 TIMES GUL;Lo;0;L;;;;;N;;;;;
12525;CUNEIFORM SIGN NINDA2 TIMES HI;Lo;0;L;;;;;N;;;;;
12526;CUNEIFORM SIGN NINDA2 TIMES KESH2;Lo;0;L;;;;;N;;;;;
12527;CUNEIFORM SIGN NINDA2 TIMES LAK-050;Lo;0;L;;;;;N;;;;;
12528;CUNEIFORM SIGN NINDA2 TIMES MASH;Lo;0;L;;;;;N;;;;;
12529;CUNEIFORM SIGN NINDA2 TIMES PAP PLUS PAP;Lo;0;L;;;;;N;;;;;
1252A;CUNEIFORM SIGN NINDA2 TIMES U;Lo;0;L;;;;;N;;;;;
1252B;CUNEIFORM SIGN NINDA2 TIMES U PLUS U;Lo;0;L;;;;;N;;;;;
1252C;CUNEIFORM SIGN NINDA2 TIMES URUDA;Lo;0;L;;;;;N;;;;;
1252D;CUNEIFORM SIGN SAG GUNU TIMES HA;Lo;0;L;;;;;N;;;;;
1252E;CUNEIFORM SIGN SAG TIMES EN;Lo;0;L;;;;;N;;;;;
1252F;CUNEIFORM SIGN SAG TIMES SHE AT LEFT;Lo;0;L;;;;;N;;;;;
12530;CUNEIFORM SIGN SAG TIMES TAK4;Lo;0;L;;;;;N;;;;;
12531;CUNEIFORM SIGN SHA6 TENU;Lo;0;L;;;;;N;;;;;
12532;CUNEIFORM SIGN SHE OVER SHE;Lo;0;L;;;;;N;;;;;
12533;CUNEIFORM SIGN SHE PLUS HUB2;Lo;0;L;;;;;N;;;;;
12534;CUNEIFORM SIGN SHE PLUS NAM2;Lo;0;L;;;;;N;;;;;
12535;CUNEIFORM SIGN SHE PLUS SAR;Lo;0;L;;;;;N;;;;;
12536;CUNEIFORM SIGN SHU2 PLUS DUG TIMES NI;Lo;0;L;;;;;N;;;;;
12537;CUNEIFORM SIGN SHU2 PLUS E2 TIMES AN;Lo;0;L;;;;;N;;;;;
12538;CUNEIFORM SIGN SI TIMES TAK4;Lo;0;L;;;;;N;;;;;
12539;CUNEIFORM SIGN TAK4 PLUS SAG;Lo;0;L;;;;;N;;;;;
1253A;CUNEIFORM SIGN TUM TIMES GAN2 TENU;Lo;0;L;;;;;N;;;;;
1253B;CUNEIFORM SIGN TUM TIMES THREE DISH;Lo;0;L;;;;;N;;;;;
1253C;CUNEIFORM SIGN UR2 INVERTED;Lo;0;L;;;;;N;;;;;
1253D;CUNEIFORM SIGN UR2 TIMES UD;Lo;0;L;;;;;N;;;;;
1253E;CUNEIFORM SIGN URU TIMES DARA3;Lo;0;L;;;;;N;;;;;
1253F;CUNEIFORM SIGN URU TIMES LAK-668;Lo;0;L;;;;;N;;;;;
12540;CUNEIFORM SIGN URU TIMES LU3;Lo;0;L;;;;;N;;;;;
12541;CUNEIFORM SIGN ZA7;Lo;0;L;;;;;N;;;;;
12542;CUNEIFORM SIGN ZU OVER ZU PLUS SAR;Lo;0;L;;;;;N;;;;;
12543;CUNEIFORM SIGN ZU5 TIMES THREE DISH TENU;Lo;0;L;;;;;N;;;;;
12F90;CYPRO-MINOAN SIGN CM001;Lo;0;L;;;;;N;;;;;
12F91;CYPRO-MINOAN SIGN CM002;Lo;0;L;;;;;N;;;;;
12F92;CYPRO-MINOAN SIGN CM004;Lo;0;L;;;;;N;;;;;
12F93;CYPRO-MINOAN SIGN CM005;Lo;0;L;;;;;N;;;;;
12F94;CYPRO-MINOAN SIGN CM006;Lo;0;L;;;;;N;;;;;
12F95;CYPRO-MINOAN SIGN CM007;Lo;0;L;;;;;N;;;;;
12F96;CYPRO-MINOAN SIGN CM008;Lo;0;L;;;;;N;;;;;
12F97;CYPRO-MINOAN SIGN CM009;Lo;0;L;;;;;N;;;;;
12F98;CYPRO-MINOAN SIGN CM010;Lo;0;L;;;;;N;;;;;
12F99;CYPRO-MINOAN SIGN CM011;Lo;0;L;;;;;N;;;;;
12F9A;CYPRO-MINOAN SIGN CM012;Lo;0;L;;;;;N;;;;;
12F9B;CYPRO-MINOAN SIGN CM012B;Lo;0;L;;;;;N;;;;;
12F9C;CYPRO-MINOAN SIGN CM013;Lo;0;L;;;;;N;;;;;
12F9D;CYPRO-MINOAN SIGN CM015;Lo;0;L;;;;;N;;;;;
12F9E;CYPRO-MINOAN SIGN CM017;Lo;0;L;;;;;N;;;;;
12F9F;CYPRO-MINOAN SIGN CM019;Lo;0;L;;;;;N;;;;;
12FA0;CYPRO-MINOAN SIGN CM021;Lo;0;L;;;;;N;;;;;
12FA1;CYPRO-MINOAN SIGN CM023;Lo;0;L;;;;;N;;;;;
12FA2;CYPRO-MINOAN SIGN CM024;Lo;0;L;;;;;N;;;;;
12FA3;CYPRO-MINOAN SIGN CM025;Lo;0;L;;;;;N;;;;;
12FA4;CYPRO-MINOAN SIGN CM026;Lo;0;L;;;;;N;;;;;
12FA5;CYPRO-MINOAN SIGN CM027;Lo;0;L;;;;;N;;;;;
12FA6;CYPRO-MINOAN SIGN CM028;Lo;0;L;;;;;N;;;;;
12FA7;CYPRO-MINOAN SIGN CM029;Lo;0;L;;;;;N;;;;;
12FA8;CYPRO-MINOAN SIGN CM030;Lo;0;L;;;;;N;;;;;
12FA9;CYPRO-MINOAN SIGN CM033;Lo;0;L;;;;;N;;;;;
12FAA;CYPRO-MINOAN SIGN CM034;Lo;0;L;;;;;N;;;;;
12FAB;CYPRO-MINOAN SIGN CM035;Lo;0;L;;;;;N;;;;;
12FAC;CYPRO-MINOAN SIGN CM036;Lo;0;L;;;;;N;;;;;
12FAD;CYPRO-MINOAN SIGN CM037;Lo;0;L;;;;;N;;;;;
12FAE;CYPRO-MINOAN SIGN CM038;Lo;0;L;;;;;N;;;;;
12FAF;CYPRO-MINOAN SIGN CM039;Lo;0;L;;;;;N;;;;;
12FB0;CYPRO-MINOAN SIGN CM040;Lo;0;L;;;;;N;;;;;
12FB1;CYPRO-MINOAN SIGN CM041;Lo;0;L;;;;;N;;;;;
12FB2;CYPRO-MINOAN SIGN CM044;Lo;0;L;;;;;N;;;;;
12FB3;CYPRO-MINOAN SIGN CM046;Lo;0;L;;;;;N;;;;;
12FB4;CYPRO-MINOAN SIGN CM047;Lo;0;L;;;;;N;;;;;
12FB5;CYPRO-MINOAN SIGN CM049;Lo;0;L;;;;;N;;;;;
12FB6;CYPRO-MINOAN SIGN CM050;Lo;0;L;;;;;N;;;;;
12FB7;CYPRO-MINOAN SIGN CM051;Lo;0;L;;;;;N;;;;;
12FB8;CYPRO-MINOAN SIGN CM052;Lo;0;L;;;;;N;;;;;
12FB9;CYPRO-MINOAN SIGN CM053;Lo;0;L;;;;;N;;;;;
12FBA;CYPRO-MINOAN SIGN CM054;Lo;0;L;;;;;N;;;;;
12FBB;CYPRO-MINOAN SIGN CM055;Lo;0;L;;;;;N;;;;;
12FBC;CYPRO-MINOAN SIGN CM056;Lo;0;L;;;;;N;;;;;
12FBD;CYPRO-MINOAN SIGN CM058;Lo;0;L;;;;;N;;;;;
12FBE;CYPRO-MINOAN SIGN CM059;Lo;0;L;;;;;N;;;;;
12FBF;CYPRO-MINOAN SIGN CM060;Lo;0;L;;;;;N;;;;;
12FC0;CYPRO-MINOAN SIGN CM061;Lo;0;L;;;;;N;;;;;
12FC1;CYPRO-MINOAN SIGN CM062;Lo;0;L;;;;;N;;;;;
12FC2;CYPRO-MINOAN SIGN CM063;Lo;0;L;;;;;N;;;;;
12FC3;CYPRO-MINOAN SIGN CM064;Lo;0;L;;;;;N;;;;;
12FC4;CYPRO-MINOAN SIGN CM066;Lo;0;L;;;;;N;;;;;
12FC5;CYPRO-MINOAN SIGN CM067;Lo;0;L;;;;;N;;;;;
12FC6;CYPRO-MINOAN SIGN CM068;Lo;0;L;;;;;N;;;;;
12FC7;CYPRO-MINOAN SIGN CM069;Lo;0;L;;;;;N;;;;;
12FC8;CYPRO-MINOAN SIGN CM070;Lo;0;L;;;;;N;;;;;
12FC9;CYPRO-MINOAN SIGN CM071;Lo;0;L;;;;;N;;;;;
12FCA;CYPRO-MINOAN SIGN CM072;Lo;0;L;;;;;N;;;;;
12FCB;CYPRO-MINOAN SIGN CM073;Lo;0;L;;;;;N;;;;;
12FCC;CYPRO-MINOAN SIGN CM074;Lo;0;L;;;;;N;;;;;
12FCD;CYPRO-MINOAN SIGN CM075;Lo;0;L;;;;;N;;;;;
12FCE;CYPRO-MINOAN SIGN CM075B;Lo;0;L;;;;;N;;;;;
12FCF;CYPRO-MINOAN SIGN CM076;Lo;0;L;;;;;N;;;;;
12FD0;CYPRO-MINOAN SIGN CM078;Lo;0;L;;;;;N;;;;;
12FD1;CYPRO-MINOAN SIGN CM079;Lo;0;L;;;;;N;;;;;
12FD2;CYPRO-MINOAN SIGN CM080;Lo;0;L;;;;;N;;;;;
12FD3;CYPRO-MINOAN SIGN CM081;Lo;0;L;;;;;N;;;;;
12FD4;CYPRO-MINOAN SIGN CM082;Lo;0;L;;;;;N;;;;;
12FD5;CYPRO-MINOAN SIGN CM083;Lo;0;L;;;;;N;;;;;
12FD6;CYPRO-MINOAN SIGN CM084;Lo;0;L;;;;;N;;;;;
12FD7;CYPRO-MINOAN SIGN CM085;Lo;0;L;;;;;N;;;;;
12FD8;CYPRO-MINOAN SIGN CM086;Lo;0;L;;;;;N;;;;;
12FD9;CYPRO-MINOAN SIGN CM087;Lo;0;L;;;;;N;;;;;
12FDA;CYPRO-MINOAN SIGN CM088;Lo;0;L;;;;;N;;;;;
12FDB;CYPRO-MINOAN SIGN CM089;Lo;0;L;;;;;N;;;;;
12FDC;CYPRO-MINOAN SIGN CM090;Lo;0;L;;;;;N;;;;;
12FDD;CYPRO-MINOAN SIGN CM091;Lo;0;L;;;;;N;;;;;
12FDE;CYPRO-MINOAN SIGN CM092;Lo;0;L;;;;;N;;;;;
12FDF;CYPRO-MINOAN SIGN CM094;Lo;0;L;;;;;N;;;;;
12FE0;CYPRO-MINOAN SIGN CM095;Lo;0;L;;;;;N;;;;;
12FE1;CYPRO-MINOAN SIGN CM096;Lo;0;L;;;;;N;;;;;
12FE2;CYPRO-MINOAN SIGN CM097;Lo;0;L;;;;;N;;;;;
12FE3;CYPRO-MINOAN SIGN CM098;Lo;0;L;;;;;N;;;;;
12FE4;CYPRO-MINOAN SIGN CM099;Lo;0;L;;;;;N;;;;;
12FE5;CYPRO-MINOAN SIGN CM100;Lo;0;L;;;;;N;;;;;
12FE6;CYPRO-MINOAN SIGN CM101;Lo;0;L;;;;;N;;;;;
12FE7;CYPRO-MINOAN SIGN CM102;Lo;0;L;;;;;N;;;;;
12FE8;CYPRO-MINOAN SIGN CM103;Lo;0;L;;;;;N;;;;;
12FE9;CYPRO-MINOAN SIGN CM104;Lo;0;L;;;;;N;;;;;
12FEA;CYPRO-MINOAN SIGN CM105;Lo;0;L;;;;;N;;;;;
12FEB;CYPRO-MINOAN SIGN CM107;Lo;0;L;;;;;N;;;;;
12FEC;CYPRO-MINOAN SIGN CM108;Lo;0;L;;;;;N;;;;;
12FED;CYPRO-MINOAN SIGN CM109;Lo;0;L;;;;;N;;;;;
12FEE;CYPRO-MINOAN SIGN CM110;Lo;0;L;;;;;N;;;;;
12FEF;CYPRO-MINOAN SIGN CM112;Lo;0;L;;;;;N;;;;;
12FF0;CYPRO-MINOAN SIGN CM114;Lo;0;L;;;;;N;;;;;
12FF1;CYPRO-MINOAN SIGN CM301;Po;0;L;;;;;N;;;;;
12FF2;CYPRO-MINOAN SIGN CM302;Po;0;L;;;;;N;;;;;
13000;EGYPTIAN HIEROGLYPH A001;Lo;0;L;;;;;N;;;;;
13001;EGYPTIAN HIEROGLYPH A002;Lo;0;L;;;;;N;;;;;
13002;EGYPTIAN HIEROGLYPH A003;Lo;0;L;;;;;N;;;;;
13003;EGYPTIAN HIEROGLYPH A004;Lo;0;L;;;;;N;;;;;
13004;EGYPTIAN HIEROGLYPH A005;Lo;0;L;;;;;N;;;;;
13005;EGYPTIAN HIEROGLYPH A005A;Lo;0;L;;;;;N;;;;;
13006;EGYPTIAN HIEROGLYPH A006;Lo;0;L;;;;;N;;;;;
13007;EGYPTIAN HIEROGLYPH A006A;Lo;0;L;;;;;N;;;;;
13008;EGYPTIAN HIEROGLYPH A006B;Lo;0;L;;;;;N;;;;;
13009;EGYPTIAN HIEROGLYPH A007;Lo;0;L;;;;;N;;;;;
1300A;EGYPTIAN HIEROGLYPH A008;Lo;0;L;;;;;N;;;;;
1300B;EGYPTIAN HIEROGLYPH A009;Lo;0;L;;;;;N;;;;;
1300C;EGYPTIAN HIEROGLYPH A010;Lo;0;L;;;;;N;;;;;
1300D;EGYPTIAN HIEROGLYPH A011;Lo;0;L;;;;;N;;;;;
1300E;EGYPTIAN HIEROGLYPH A012;Lo;0;L;;;;;N;;;;;
1300F;EGYPTIAN HIEROGLYPH A013;Lo;0;L;;;;;N;;;;;
13010;EGYPTIAN HIEROGLYPH A014;Lo;0;L;;;;;N;;;;;
13011;EGYPTIAN HIEROGLYPH A014A;Lo;0;L;;;;;N;;;;;
13012;EGYPTIAN HIEROGLYPH A015;Lo;0;L;;;;;N;;;;;
13013;EGYPTIAN HIEROGLYPH A016;Lo;0;L;;;;;N;;;;;
13014;EGYPTIAN HIEROGLYPH A017;Lo;0;L;;;;;N;;;;;
13015;EGYPTIAN HIEROGLYPH A017A;Lo;0;L;;;;;N;;;;;
13016;EGYPTIAN HIEROGLYPH A018;Lo;0;L;;;;;N;;;;;
13017;EGYPTIAN HIEROGLYPH A019;Lo;0;L;;;;;N;;;;;
13018;EGYPTIAN HIEROGLYPH A020;Lo;0;L;;;;;N;;;;;
13019;EGYPTIAN HIEROGLYPH A021;Lo;0;L;;;;;N;;;;;
1301A;EGYPTIAN HIEROGLYPH A022;Lo;0;L;;;;;N;;;;;
1301B;EGYPTIAN HIEROGLYPH A023;Lo;0;L;;;;;N;;;;;
1301C;EGYPTIAN HIEROGLYPH A024;Lo;0;L;;;;;N;;;;;
1301D;EGYPTIAN HIEROGLYPH A025;Lo;0;L;;;;;N;;;;;
1301E;EGYPTIAN HIEROGLYPH A026;Lo;0;L;;;;;N;;;;;
1301F;EGYPTIAN HIEROGLYPH A027;Lo;0;L;;;;;N;;;;;
13020;EGYPTIAN HIEROGLYPH A028;Lo;0;L;;;;;N;;;;;
13021;EGYPTIAN HIEROGLYPH A029;Lo;0;L;;;;;N;;;;;
13022;EGYPTIAN HIEROGLYPH A030;Lo;0;L;;;;;N;;;;;
13023;EGYPTIAN HIEROGLYPH A031;Lo;0;L;;;;;N;;;;;
13024;EGYPTIAN HIEROGLYPH A032;Lo;0;L;;;;;N;;;;;
13025;EGYPTIAN HIEROGLYPH A032A;Lo;0;L;;;;;N;;;;;
13026;EGYPTIAN HIEROGLYPH A033;Lo;0;L;;;;;N;;;;;
13027;EGYPTIAN HIEROGLYPH A034;Lo;0;L;;;;;N;;;;;
13028;EGYPTIAN HIEROGLYPH A035;Lo;0;L;;;;;N;;;;;
13029;EGYPTIAN HIEROGLYPH A036;Lo;0;L;;;;;N;;;;;
1302A;EGYPTIAN HIEROGLYPH A037;Lo;0;L;;;;;N;;;;;
1302B;EGYPTIAN HIEROGLYPH A038;Lo;0;L;;;;;N;;;;;
1302C;EGYPTIAN HIEROGLYPH A039;Lo;0;L;;;;;N;;;;;
1302D;EGYPTIAN HIEROGLYPH A040;Lo;0;L;;;;;N;;;;;
1302E;EGYPTIAN HIEROGLYPH A040A;Lo;0;L;;;;;N;;;;;
1302F;EGYPTIAN HIEROGLYPH A041;Lo;0;L;;;;;N;;;;;
13030;EGYPTIAN HIEROGLYPH A042;Lo;0;L;;;;;N;;;;;
13031;EGYPTIAN HIEROGLYPH A042A;Lo;0;L;;;;;N;;;;;
13032;EGYPTIAN HIEROGLYPH A043;Lo;0;L;;;;;N;;;;;
13033;EGYPTIAN HIEROGLYPH A043A;Lo;0;L;;;;;N;;;;;
13034;EGYPTIAN HIEROGLYPH A044;Lo;0;L;;;;;N;;;;;
13035;EGYPTIAN HIEROGLYPH A045;Lo;0;L;;;;;N;;;;;
13036;EGYPTIAN HIEROGLYPH A045A;Lo;0;L;;;;;N;;;;;
13037;EGYPTIAN HIEROGLYPH A046;Lo;0;L;;;;;N;;;;;
13038;EGYPTIAN HIEROGLYPH A047;Lo;0;L;;;;;N;;;;;
13039;EGYPTIAN HIEROGLYPH A048;Lo;0;L;;;;;N;;;;;
1303A;EGYPTIAN HIEROGLYPH A049;Lo;0;L;;;;;N;;;;;
1303B;EGYPTIAN HIEROGLYPH A050;Lo;0;L;;;;;N;;;;;
1303C;EGYPTIAN HIEROGLYPH A051;Lo;0;L;;;;;N;;;;;
1303D;EGYPTIAN HIEROGLYPH A052;Lo;0;L;;;;;N;;;;;
1303E;EGYPTIAN HIEROGLYPH A053;Lo;0;L;;;;;N;;;;;
1303F;EGYPTIAN HIEROGLYPH A054;Lo;0;L;;;;;N;;;;;
13040;EGYPTIAN HIEROGLYPH A055;Lo;0;L;;;;;N;;;;;
13041;EGYPTIAN HIEROGLYPH A056;Lo;0;L;;;;;N;;;;;
13042;EGYPTIAN HIEROGLYPH A057;Lo;0;L;;;;;N;;;;;
13043;EGYPTIAN HIEROGLYPH A058;Lo;0;L;;;;;N;;;;;
13044;EGYPTIAN HIEROGLYPH A059;Lo;0;L;;;;;N;;;;;
13045;EGYPTIAN HIEROGLYPH A060;Lo;0;L;;;;;N;;;;;
13046;EGYPTIAN HIEROGLYPH A061;Lo;0;L;;;;;N;;;;;
13047;EGYPTIAN HIEROGLYPH A062;Lo;0;L;;;;;N;;;;;
13048;EGYPTIAN HIEROGLYPH A063;Lo;0;L;;;;;N;;;;;
13049;EGYPTIAN HIEROGLYPH A064;Lo;0;L;;;;;N;;;;;
1304A;EGYPTIAN HIEROGLYPH A065;Lo;0;L;;;;;N;;;;;
1304B;EGYPTIAN HIEROGLYPH A066;Lo;0;L;;;;;N;;;;;
1304C;EGYPTIAN HIEROGLYPH A067;Lo;0;L;;;;;N;;;;;
1304D;EGYPTIAN HIEROGLYPH A068;Lo;0;L;;;;;N;;;;;
1304E;EGYPTIAN HIEROGLYPH A069;Lo;0;L;;;;;N;;;;;
1304F;EGYPTIAN HIEROGLYPH A070;Lo;0;L;;;;;N;;;;;
13050;EGYPTIAN HIEROGLYPH B001;Lo;0;L;;;;;N;;;;;
13051;EGYPTIAN HIEROGLYPH B002;Lo;0;L;;;;;N;;;;;
13052;EGYPTIAN HIEROGLYPH B003;Lo;0;L;;;;;N;;;;;
13053;EGYPTIAN HIEROGLYPH B004;Lo;0;L;;;;;N;;;;;
13054;EGYPTIAN HIEROGLYPH B005;Lo;0;L;;;;;N;;;;;
13055;EGYPTIAN HIEROGLYPH B005A;Lo;0;L;;;;;N;;;;;
13056;EGYPTIAN HIEROGLYPH B006;Lo;0;L;;;;;N;;;;;
13057;EGYPTIAN HIEROGLYPH B007;Lo;0;L;;;;;N;;;;;
13058;EGYPTIAN HIEROGLYPH B008;Lo;0;L;;;;;N;;;;;
13059;EGYPTIAN HIEROGLYPH B009;Lo;0;L;;;;;N;;;;;
1305A;EGYPTIAN HIEROGLYPH C001;Lo;0;L;;;;;N;;;;;
1305B;EGYPTIAN HIEROGLYPH C002;Lo;0;L;;;;;N;;;;;
1305C;EGYPTIAN HIEROGLYPH C002A;Lo;0;L;;;;;N;;;;;
1305D;EGYPTIAN HIEROGLYPH C002B;Lo;0;L;;;;;N;;;;;
1305E;EGYPTIAN HIEROGLYPH C002C;Lo;0;L;;;;;N;;;;;
1305F;EGYPTIAN HIEROGLYPH C003;Lo;0;L;;;;;N;;;;;
13060;EGYPTIAN HIEROGLYPH C004;Lo;0;L;;;;;N;;;;;
13061;EGYPTIAN HIEROGLYPH C005;Lo;0;L;;;;;N;;;;;
13062;EGYPTIAN HIEROGLYPH C006;Lo;0;L;;;;;N;;;;;
13063;EGYPTIAN HIEROGLYPH C007;Lo;0;L;;;;;N;;;;;
13064;EGYPTIAN HIEROGLYPH C008;Lo;0;L;;;;;N;;;;;
13065;EGYPTIAN HIEROGLYPH C009;Lo;0;L;;;;;N;;;;;
13066;EGYPTIAN HIEROGLYPH C010;Lo;0;L;;;;;N;;;;;
13067;EGYPTIAN HIEROGLYPH C010A;Lo;0;L;;;;;N;;;;;
13068;EGYPTIAN HIEROGLYPH C011;Lo;0;L;;;;;N;;;;;
13069;EGYPTIAN HIEROGLYPH C012;Lo;0;L;;;;;N;;;;;
1306A;EGYPTIAN HIEROGLYPH C013;Lo;0;L;;;;;N;;;;;
1306B;EGYPTIAN HIEROGLYPH C014;Lo;0;L;;;;;N;;;;;
1306C;EGYPTIAN HIEROGLYPH C015;Lo;0;L;;;;;N;;;;;
1306D;EGYPTIAN HIEROGLYPH C016;Lo;0;L;;;;;N;;;;;
1306E;EGYPTIAN HIEROGLYPH C017;Lo;0;L;;;;;N;;;;;
1306F;EGYPTIAN HIEROGLYPH C018;Lo;0;L;;;;;N;;;;;
13070;EGYPTIAN HIEROGLYPH C019;Lo;0;L;;;;;N;;;;;
13071;EGYPTIAN HIEROGLYPH C020;Lo;0;L;;;;;N;;;;;
13072;EGYPTIAN HIEROGLYPH C021;Lo;0;L;;;;;N;;;;;
13073;EGYPTIAN HIEROGLYPH C022;Lo;0;L;;;;;N;;;;;
13074;EGYPTIAN HIEROGLYPH C023;Lo;0;L;;;;;N;;;;;
13075;EGYPTIAN HIEROGLYPH C024;Lo;0;L;;;;;N;;;;;
13076;EGYPTIAN HIEROGLYPH D001;Lo;0;L;;;;;N;;;;;
13077;EGYPTIAN HIEROGLYPH D002;Lo;0;L;;;;;N;;;;;
13078;EGYPTIAN HIEROGLYPH D003;Lo;0;L;;;;;N;;;;;
13079;EGYPTIAN HIEROGLYPH D004;Lo;0;L;;;;;N;;;;;
1307A;EGYPTIAN HIEROGLYPH D005;Lo;0;L;;;;;N;;;;;
1307B;EGYPTIAN HIEROGLYPH D006;Lo;0;L;;;;;N;;;;;
1307C;EGYPTIAN HIEROGLYPH D007;Lo;0;L;;;;;N;;;;;
1307D;EGYPTIAN HIEROGLYPH D008;Lo;0;L;;;;;N;;;;;
1307E;EGYPTIAN HIEROGLYPH D008A;Lo;0;L;;;;;N;;;;;
1307F;EGYPTIAN HIEROGLYPH D009;Lo;0;L;;;;;N;;;;;
13080;EGYPTIAN HIEROGLYPH D010;Lo;0;L;;;;;N;;;;;
13081;EGYPTIAN HIEROGLYPH D011;Lo;0;L;;;;;N;;;;;
13082;EGYPTIAN HIEROGLYPH D012;Lo;0;L;;;;;N;;;;;
13083;EGYPTIAN HIEROGLYPH D013;Lo;0;L;;;;;N;;;;;
13084;EGYPTIAN HIEROGLYPH D014;Lo;0;L;;;;;N;;;;;
13085;EGYPTIAN HIEROGLYPH D015;Lo;0;L;;;;;N;;;;;
13086;EGYPTIAN HIEROGLYPH D016;Lo;0;L;;;;;N;;;;;
13087;EGYPTIAN HIEROGLYPH D017;Lo;0;L;;;;;N;;;;;
13088;EGYPTIAN HIEROGLYPH D018;Lo;0;L;;;;;N;;;;;
13089;EGYPTIAN HIEROGLYPH D019;Lo;0;L;;;;;N;;;;;
1308A;EGYPTIAN HIEROGLYPH D020;Lo;0;L;;;;;N;;;;;
1308B;EGYPTIAN HIEROGLYPH D021;Lo;0;L;;;;;N;;;;;
1308C;EGYPTIAN HIEROGLYPH D022;Lo;0;L;;;;;N;;;;;
1308D;EGYPTIAN HIEROGLYPH D023;Lo;0;L;;;;;N;;;;;
1308E;EGYPTIAN HIEROGLYPH D024;Lo;0;L;;;;;N;;;;;
1308F;EGYPTIAN HIEROGLYPH D025;Lo;0;L;;;;;N;;;;;
13090;EGYPTIAN HIEROGLYPH D026;Lo;0;L;;;;;N;;;;;
13091;EGYPTIAN HIEROGLYPH D027;Lo;0;L;;;;;N;;;;;
13092;EGYPTIAN HIEROGLYPH D027A;Lo;0;L;;;;;N;;;;;
13093;EGYPTIAN HIEROGLYPH D028;Lo;0;L;;;;;N;;;;;
13094;EGYPTIAN HIEROGLYPH D029;Lo;0;L;;;;;N;;;;;
13095;EGYPTIAN HIEROGLYPH D030;Lo;0;L;;;;;N;;;;;
13096;EGYPTIAN HIEROGLYPH D031;Lo;0;L;;;;;N;;;;;
13097;EGYPTIAN HIEROGLYPH D031A;Lo;0;L;;;;;N;;;;;
13098;EGYPTIAN HIEROGLYPH D032;Lo;0;L;;;;;N;;;;;
13099;EGYPTIAN HIEROGLYPH D033;Lo;0;L;;;;;N;;;;;
1309A;EGYPTIAN HIEROGLYPH D034;Lo;0;L;;;;;N;;;;;
1309B;EGYPTIAN HIEROGLYPH D034A;Lo;0;L;;;;;N;;;;;
1309C;EGYPTIAN HIEROGLYPH D035;Lo;0;L;;;;;N;;;;;
1309D;EGYPTIAN HIEROGLYPH D036;Lo;0;L;;;;;N;;;;;
1309E;EGYPTIAN HIEROGLYPH D037;Lo;0;L;;;;;N;;;;;
1309F;EGYPTIAN HIEROGLYPH D038;Lo;0;L;;;;;N;;;;;
130A0;EGYPTIAN HIEROGLYPH D039;Lo;0;L;;;;;N;;;;;
130A1;EGYPTIAN HIEROGLYPH D040;Lo;0;L;;;;;N;;;;;
130A2;EGYPTIAN HIEROGLYPH D041;Lo;0;L;;;;;N;;;;;
130A3;EGYPTIAN HIEROGLYPH D042;Lo;0;L;;;;;N;;;;;
130A4;EGYPTIAN HIEROGLYPH D043;Lo;0;L;;;;;N;;;;;
130A5;EGYPTIAN HIEROGLYPH D044;Lo;0;L;;;;;N;;;;;
130A6;EGYPTIAN HIEROGLYPH D045;Lo;0;L;;;;;N;;;;;
130A7;EGYPTIAN HIEROGLYPH D046;Lo;0;L;;;;;N;;;;;
130A8;EGYPTIAN HIEROGLYPH D046A;Lo;0;L;;;;;N;;;;;
130A9;EGYPTIAN HIEROGLYPH D047;Lo;0;L;;;;;N;;;;;
130AA;EGYPTIAN HIEROGLYPH D048;Lo;0;L;;;;;N;;;;;
130AB;EGYPTIAN HIEROGLYPH D048A;Lo;0;L;;;;;N;;;;;
130AC;EGYPTIAN HIEROGLYPH D049;Lo;0;L;;;;;N;;;;;
130AD;EGYPTIAN HIEROGLYPH D050;Lo;0;L;;;;;N;;;;;
130AE;EGYPTIAN HIEROGLYPH D050A;Lo;0;L;;;;;N;;;;;
130AF;EGYPTIAN HIEROGLYPH D050B;Lo;0;L;;;;;N;;;;;
130B0;EGYPTIAN HIEROGLYPH D050C;Lo;0;L;;;;;N;;;;;
130B1;EGYPTIAN HIEROGLYPH D050D;Lo;0;L;;;;;N;;;;;
130B2;EGYPTIAN HIEROGLYPH D050E;Lo;0;L;;;;;N;;;;;
130B3;EGYPTIAN HIEROGLYPH D050F;Lo;0;L;;;;;N;;;;;
130B4;EGYPTIAN HIEROGLYPH D050G;Lo;0;L;;;;;N;;;;;
130B5;EGYPTIAN HIEROGLYPH D050H;Lo;0;L;;;;;N;;;;;
130B6;EGYPTIAN HIEROGLYPH D050I;Lo;0;L;;;;;N;;;;;
130B7;EGYPTIAN HIEROGLYPH D051;Lo;0;L;;;;;N;;;;;
130B8;EGYPTIAN HIEROGLYPH D052;Lo;0;L;;;;;N;;;;;
130B9;EGYPTIAN HIEROGLYPH D052A;Lo;0;L;;;;;N;;;;;
130BA;EGYPTIAN HIEROGLYPH D053;Lo;0;L;;;;;N;;;;;
130BB;EGYPTIAN HIEROGLYPH D054;Lo;0;L;;;;;N;;;;;
130BC;EGYPTIAN HIEROGLYPH D054A;Lo;0;L;;;;;N;;;;;
130BD;EGYPTIAN HIEROGLYPH D055;Lo;0;L;;;;;N;;;;;
130BE;EGYPTIAN HIEROGLYPH D056;Lo;0;L;;;;;N;;;;;
130BF;EGYPTIAN HIEROGLYPH D057;Lo;0;L;;;;;N;;;;;
130C0;EGYPTIAN HIEROGLYPH D058;Lo;0;L;;;;;N;;;;;
130C1;EGYPTIAN HIEROGLYPH D059;Lo;0;L;;;;;N;;;;;
130C2;EGYPTIAN HIEROGLYPH D060;Lo;0;L;;;;;N;;;;;
130C3;EGYPTIAN HIEROGLYPH D061;Lo;0;L;;;;;N;;;;;
130C4;EGYPTIAN HIEROGLYPH D062;Lo;0;L;;;;;N;;;;;
130C5;EGYPTIAN HIEROGLYPH D063;Lo;0;L;;;;;N;;;;;
130C6;EGYPTIAN HIEROGLYPH D064;Lo;0;L;;;;;N;;;;;
130C7;EGYPTIAN HIEROGLYPH D065;Lo;0;L;;;;;N;;;;;
130C8;EGYPTIAN HIEROGLYPH D066;Lo;0;L;;;;;N;;;;;
130C9;EGYPTIAN HIEROGLYPH D067;Lo;0;L;;;;;N;;;;;
130CA;EGYPTIAN HIEROGLYPH D067A;Lo;0;L;;;;;N;;;;;
130CB;EGYPTIAN HIEROGLYPH D067B;Lo;0;L;;;;;N;;;;;
130CC;EGYPTIAN HIEROGLYPH D067C;Lo;0;L;;;;;N;;;;;
130CD;EGYPTIAN HIEROGLYPH D067D;Lo;0;L;;;;;N;;;;;
130CE;EGYPTIAN HIEROGLYPH D067E;Lo;0;L;;;;;N;;;;;
130CF;EGYPTIAN HIEROGLYPH D067F;Lo;0;L;;;;;N;;;;;
130D0;EGYPTIAN HIEROGLYPH D067G;Lo;0;L;;;;;N;;;;;
130D1;EGYPTIAN HIEROGLYPH D067H;Lo;0;L;;;;;N;;;;;
130D2;EGYPTIAN HIEROGLYPH E001;Lo;0;L;;;;;N;;;;;
130D3;EGYPTIAN HIEROGLYPH E002;Lo;0;L;;;;;N;;;;;
130D4;EGYPTIAN HIEROGLYPH E003;Lo;0;L;;;;;N;;;;;
130D5;EGYPTIAN HIEROGLYPH E004;Lo;0;L;;;;;N;;;;;
130D6;EGYPTIAN HIEROGLYPH E005;Lo;0;L;;;;;N;;;;;
130D7;EGYPTIAN HIEROGLYPH E006;Lo;0;L;;;;;N;;;;;
130D8;EGYPTIAN HIEROGLYPH E007;Lo;0;L;;;;;N;;;;;
130D9;EGYPTIAN HIEROGLYPH E008;Lo;0;L;;;;;N;;;;;
130DA;EGYPTIAN HIEROGLYPH E008A;Lo;0;L;;;;;N;;;;;
130DB;EGYPTIAN HIEROGLYPH E009;Lo;0;L;;;;;N;;;;;
130DC;EGYPTIAN HIEROGLYPH E009A;Lo;0;L;;;;;N;;;;;
130DD;EGYPTIAN HIEROGLYPH E010;Lo;0;L;;;;;N;;;;;
130DE;EGYPTIAN HIEROGLYPH E011;Lo;0;L;;;;;N;;;;;
130DF;EGYPTIAN HIEROGLYPH E012;Lo;0;L;;;;;N;;;;;
130E0;EGYPTIAN HIEROGLYPH E013;Lo;0;L;;;;;N;;;;;
130E1;EGYPTIAN HIEROGLYPH E014;Lo;0;L;;;;;N;;;;;
130E2;EGYPTIAN HIEROGLYPH E015;Lo;0;L;;;;;N;;;;;
130E3;EGYPTIAN HIEROGLYPH E016;Lo;0;L;;;;;N;;;;;
130E4;EGYPTIAN HIEROGLYPH E016A;Lo;0;L;;;;;N;;;;;
130E5;EGYPTIAN HIEROGLYPH E017;Lo;0;L;;;;;N;;;;;
130E6;EGYPTIAN HIEROGLYPH E017A;Lo;0;L;;;;;N;;;;;
130E7;EGYPTIAN HIEROGLYPH E018;Lo;0;L;;;;;N;;;;;
130E8;EGYPTIAN HIEROGLYPH E019;Lo;0;L;;;;;N;;;;;
130E9;EGYPTIAN HIEROGLYPH E020;Lo;0;L;;;;;N;;;;;
130EA;EGYPTIAN HIEROGLYPH E020A;Lo;0;L;;;;;N;;;;;
130EB;EGYPTIAN HIEROGLYPH E021;Lo;0;L;;;;;N;;;;;
130EC;EGYPTIAN HIEROGLYPH E022;Lo;0;L;;;;;N;;;;;
130ED;EGYPTIAN HIEROGLYPH E023;Lo;0;L;;;;;N;;;;;
130EE;EGYPTIAN HIEROGLYPH E024;Lo;0;L;;;;;N;;;;;
130EF;EGYPTIAN HIEROGLYPH E025;Lo;0;L;;;;;N;;;;;
130F0;EGYPTIAN HIEROGLYPH E026;Lo;0;L;;;;;N;;;;;
130F1;EGYPTIAN HIEROGLYPH E027;Lo;0;L;;;;;N;;;;;
130F2;EGYPTIAN HIEROGLYPH E028;Lo;0;L;;;;;N;;;;;
130F3;EGYPTIAN HIEROGLYPH E028A;Lo;0;L;;;;;N;;;;;
130F4;EGYPTIAN HIEROGLYPH E029;Lo;0;L;;;;;N;;;;;
130F5;EGYPTIAN HIEROGLYPH E030;Lo;0;L;;;;;N;;;;;
130F6;EGYPTIAN HIEROGLYPH E031;Lo;0;L;;;;;N;;;;;
130F7;EGYPTIAN HIEROGLYPH E032;Lo;0;L;;;;;N;;;;;
130F8;EGYPTIAN HIEROGLYPH E033;Lo;0;L;;;;;N;;;;;
130F9;EGYPTIAN HIEROGLYPH E034;Lo;0;L;;;;;N;;;;;
130FA;EGYPTIAN HIEROGLYPH E034A;Lo;0;L;;;;;N;;;;;
130FB;EGYPTIAN HIEROGLYPH E036;Lo;0;L;;;;;N;;;;;
130FC;EGYPTIAN HIEROGLYPH E037;Lo;0;L;;;;;N;;;;;
130FD;EGYPTIAN HIEROGLYPH E038;Lo;0;L;;;;;N;;;;;
130FE;EGYPTIAN HIEROGLYPH F001;Lo;0;L;;;;;N;;;;;
130FF;EGYPTIAN HIEROGLYPH F001A;Lo;0;L;;;;;N;;;;;
13100;EGYPTIAN HIEROGLYPH F002;Lo;0;L;;;;;N;;;;;
13101;EGYPTIAN HIEROGLYPH F003;Lo;0;L;;;;;N;;;;;
13102;EGYPTIAN HIEROGLYPH F004;Lo;0;L;;;;;N;;;;;
13103;EGYPTIAN HIEROGLYPH F005;Lo;0;L;;;;;N;;;;;
13104;EGYPTIAN HIEROGLYPH F006;Lo;0;L;;;;;N;;;;;
13105;EGYPTIAN HIEROGLYPH F007;Lo;0;L;;;;;N;;;;;
13106;EGYPTIAN HIEROGLYPH F008;Lo;0;L;;;;;N;;;;;
13107;EGYPTIAN HIEROGLYPH F009;Lo;0;L;;;;;N;;;;;
13108;EGYPTIAN HIEROGLYPH F010;Lo;0;L;;;;;N;;;;;
13109;EGYPTIAN HIEROGLYPH F011;Lo;0;L;;;;;N;;;;;
1310A;EGYPTIAN HIEROGLYPH F012;Lo;0;L;;;;;N;;;;;
1310B;EGYPTIAN HIEROGLYPH F013;Lo;0;L;;;;;N;;;;;
1310C;EGYPTIAN HIEROGLYPH F013A;Lo;0;L;;;;;N;;;;;
1310D;EGYPTIAN HIEROGLYPH F014;Lo;0;L;;;;;N;;;;;
1310E;EGYPTIAN HIEROGLYPH F015;Lo;0;L;;;;;N;;;;;
1310F;EGYPTIAN HIEROGLYPH F016;Lo;0;L;;;;;N;;;;;
13110;EGYPTIAN HIEROGLYPH F017;Lo;0;L;;;;;N;;;;;
13111;EGYPTIAN HIEROGLYPH F018;Lo;0;L;;;;;N;;;;;
13112;EGYPTIAN HIEROGLYPH F019;Lo;0;L;;;;;N;;;;;
13113;EGYPTIAN HIEROGLYPH F020;Lo;0;L;;;;;N;;;;;
13114;EGYPTIAN HIEROGLYPH F021;Lo;0;L;;;;;N;;;;;
13115;EGYPTIAN HIEROGLYPH F021A;Lo;0;L;;;;;N;;;;;
13116;EGYPTIAN HIEROGLYPH F022;Lo;0;L;;;;;N;;;;;
13117;EGYPTIAN HIEROGLYPH F023;Lo;0;L;;;;;N;;;;;
13118;EGYPTIAN HIEROGLYPH F024;Lo;0;L;;;;;N;;;;;
13119;EGYPTIAN HIEROGLYPH F025;Lo;0;L;;;;;N;;;;;
1311A;EGYPTIAN HIEROGLYPH F026;Lo;0;L;;;;;N;;;;;
1311B;EGYPTIAN HIEROGLYPH F027;Lo;0;L;;;;;N;;;;;
1311C;EGYPTIAN HIEROGLYPH F028;Lo;0;L;;;;;N;;;;;
1311D;EGYPTIAN HIEROGLYPH F029;Lo;0;L;;;;;N;;;;;
1311E;EGYPTIAN HIEROGLYPH F030;Lo;0;L;;;;;N;;;;;
1311F;EGYPTIAN HIEROGLYPH F031;Lo;0;L;;;;;N;;;;;
13120;EGYPTIAN HIEROGLYPH F031A;Lo;0;L;;;;;N;;;;;
13121;EGYPTIAN HIEROGLYPH F032;Lo;0;L;;;;;N;;;;;
13122;EGYPTIAN HIEROGLYPH F033;Lo;0;L;;;;;N;;;;;
13123;EGYPTIAN HIEROGLYPH F034;Lo;0;L;;;;;N;;;;;
13124;EGYPTIAN HIEROGLYPH F035;Lo;0;L;;;;;N;;;;;
13125;EGYPTIAN HIEROGLYPH F036;Lo;0;L;;;;;N;;;;;
13126;EGYPTIAN HIEROGLYPH F037;Lo;0;L;;;;;N;;;;;
13127;EGYPTIAN HIEROGLYPH F037A;Lo;0;L;;;;;N;;;;;
13128;EGYPTIAN HIEROGLYPH F038;Lo;0;L;;;;;N;;;;;
13129;EGYPTIAN HIEROGLYPH F038A;Lo;0;L;;;;;N;;;;;
1312A;EGYPTIAN HIEROGLYPH F039;Lo;0;L;;;;;N;;;;;
1312B;EGYPTIAN HIEROGLYPH F040;Lo;0;L;;;;;N;;;;;
1312C;EGYPTIAN HIEROGLYPH F041;Lo;0;L;;;;;N;;;;;
1312D;EGYPTIAN HIEROGLYPH F042;Lo;0;L;;;;;N;;;;;
1312E;EGYPTIAN HIEROGLYPH F043;Lo;0;L;;;;;N;;;;;
1312F;EGYPTIAN HIEROGLYPH F044;Lo;0;L;;;;;N;;;;;
13130;EGYPTIAN HIEROGLYPH F045;Lo;0;L;;;;;N;;;;;
13131;EGYPTIAN HIEROGLYPH F045A;Lo;0;L;;;;;N;;;;;
13132;EGYPTIAN HIEROGLYPH F046;Lo;0;L;;;;;N;;;;;
13133;EGYPTIAN HIEROGLYPH F046A;Lo;0;L;;;;;N;;;;;
13134;EGYPTIAN HIEROGLYPH F047;Lo;0;L;;;;;N;;;;;
13135;EGYPTIAN HIEROGLYPH F047A;Lo;0;L;;;;;N;;;;;
13136;EGYPTIAN HIEROGLYPH F048;Lo;0;L;;;;;N;;;;;
13137;EGYPTIAN HIEROGLYPH F049;Lo;0;L;;;;;N;;;;;
13138;EGYPTIAN HIEROGLYPH F050;Lo;0;L;;;;;N;;;;;
13139;EGYPTIAN HIEROGLYPH F051;Lo;0;L;;;;;N;;;;;
1313A;EGYPTIAN HIEROGLYPH F051A;Lo;0;L;;;;;N;;;;;
1313B;EGYPTIAN HIEROGLYPH F051B;Lo;0;L;;;;;N;;;;;
1313C;EGYPTIAN HIEROGLYPH F051C;Lo;0;L;;;;;N;;;;;
1313D;EGYPTIAN HIEROGLYPH F052;Lo;0;L;;;;;N;;;;;
1313E;EGYPTIAN HIEROGLYPH F053;Lo;0;L;;;;;N;;;;;
1313F;EGYPTIAN HIEROGLYPH G001;Lo;0;L;;;;;N;;;;;
13140;EGYPTIAN HIEROGLYPH G002;Lo;0;L;;;;;N;;;;;
13141;EGYPTIAN HIEROGLYPH G003;Lo;0;L;;;;;N;;;;;
13142;EGYPTIAN HIEROGLYPH G004;Lo;0;L;;;;;N;;;;;
13143;EGYPTIAN HIEROGLYPH G005;Lo;0;L;;;;;N;;;;;
13144;EGYPTIAN HIEROGLYPH G006;Lo;0;L;;;;;N;;;;;
13145;EGYPTIAN HIEROGLYPH G006A;Lo;0;L;;;;;N;;;;;
13146;EGYPTIAN HIEROGLYPH G007;Lo;0;L;;;;;N;;;;;
13147;EGYPTIAN HIEROGLYPH G007A;Lo;0;L;;;;;N;;;;;
13148;EGYPTIAN HIEROGLYPH G007B;Lo;0;L;;;;;N;;;;;
13149;EGYPTIAN HIEROGLYPH G008;Lo;0;L;;;;;N;;;;;
1314A;EGYPTIAN HIEROGLYPH G009;Lo;0;L;;;;;N;;;;;
1314B;EGYPTIAN HIEROGLYPH G010;Lo;0;L;;;;;N;;;;;
1314C;EGYPTIAN HIEROGLYPH G011;Lo;0;L;;;;;N;;;;;
1314D;EGYPTIAN HIEROGLYPH G011A;Lo;0;L;;;;;N;;;;;
1314E;EGYPTIAN HIEROGLYPH G012;Lo;0;L;;;;;N;;;;;
1314F;EGYPTIAN HIEROGLYPH G013;Lo;0;L;;;;;N;;;;;
13150;EGYPTIAN HIEROGLYPH G014;Lo;0;L;;;;;N;;;;;
13151;EGYPTIAN HIEROGLYPH G015;Lo;0;L;;;;;N;;;;;
13152;EGYPTIAN HIEROGLYPH G016;Lo;0;L;;;;;N;;;;;
13153;EGYPTIAN HIEROGLYPH G017;Lo;0;L;;;;;N;;;;;
13154;EGYPTIAN HIEROGLYPH G018;Lo;0;L;;;;;N;;;;;
13155;EGYPTIAN HIEROGLYPH G019;Lo;0;L;;;;;N;;;;;
13156;EGYPTIAN HIEROGLYPH G020;Lo;0;L;;;;;N;;;;;
13157;EGYPTIAN HIEROGLYPH G020A;Lo;0;L;;;;;N;;;;;
13158;EGYPTIAN HIEROGLYPH G021;Lo;0;L;;;;;N;;;;;
13159;EGYPTIAN HIEROGLYPH G022;Lo;0;L;;;;;N;;;;;
1315A;EGYPTIAN HIEROGLYPH G023;Lo;0;L;;;;;N;;;;;
1315B;EGYPTIAN HIEROGLYPH G024;Lo;0;L;;;;;N;;;;;
1315C;EGYPTIAN HIEROGLYPH G025;Lo;0;L;;;;;N;;;;;
1315D;EGYPTIAN HIEROGLYPH G026;Lo;0;L;;;;;N;;;;;
1315E;EGYPTIAN HIEROGLYPH G026A;Lo;0;L;;;;;N;;;;;
1315F;EGYPTIAN HIEROGLYPH G027;Lo;0;L;;;;;N;;;;;
13160;EGYPTIAN HIEROGLYPH G028;Lo;0;L;;;;;N;;;;;
13161;EGYPTIAN HIEROGLYPH G029;Lo;0;L;;;;;N;;;;;
13162;EGYPTIAN HIEROGLYPH G030;Lo;0;L;;;;;N;;;;;
13163;EGYPTIAN HIEROGLYPH G031;Lo;0;L;;;;;N;;;;;
13164;EGYPTIAN HIEROGLYPH G032;Lo;0;L;;;;;N;;;;;
13165;EGYPTIAN HIEROGLYPH G033;Lo;0;L;;;;;N;;;;;
13166;EGYPTIAN HIEROGLYPH G034;Lo;0;L;;;;;N;;;;;
13167;EGYPTIAN HIEROGLYPH G035;Lo;0;L;;;;;N;;;;;
13168;EGYPTIAN HIEROGLYPH G036;Lo;0;L;;;;;N;;;;;
13169;EGYPTIAN HIEROGLYPH G036A;Lo;0;L;;;;;N;;;;;
1316A;EGYPTIAN HIEROGLYPH G037;Lo;0;L;;;;;N;;;;;
1316B;EGYPTIAN HIEROGLYPH G037A;Lo;0;L;;;;;N;;;;;
1316C;EGYPTIAN HIEROGLYPH G038;Lo;0;L;;;;;N;;;;;
1316D;EGYPTIAN HIEROGLYPH G039;Lo;0;L;;;;;N;;;;;
1316E;EGYPTIAN HIEROGLYPH G040;Lo;0;L;;;;;N;;;;;
1316F;EGYPTIAN HIEROGLYPH G041;Lo;0;L;;;;;N;;;;;
13170;EGYPTIAN HIEROGLYPH G042;Lo;0;L;;;;;N;;;;;
13171;EGYPTIAN HIEROGLYPH G043;Lo;0;L;;;;;N;;;;;
13172;EGYPTIAN HIEROGLYPH G043A;Lo;0;L;;;;;N;;;;;
13173;EGYPTIAN HIEROGLYPH G044;Lo;0;L;;;;;N;;;;;
13174;EGYPTIAN HIEROGLYPH G045;Lo;0;L;;;;;N;;;;;
13175;EGYPTIAN HIEROGLYPH G045A;Lo;0;L;;;;;N;;;;;
13176;EGYPTIAN HIEROGLYPH G046;Lo;0;L;;;;;N;;;;;
13177;EGYPTIAN HIEROGLYPH G047;Lo;0;L;;;;;N;;;;;
13178;EGYPTIAN HIEROGLYPH G048;Lo;0;L;;;;;N;;;;;
13179;EGYPTIAN HIEROGLYPH G049;Lo;0;L;;;;;N;;;;;
1317A;EGYPTIAN HIEROGLYPH G050;Lo;0;L;;;;;N;;;;;
1317B;EGYPTIAN HIEROGLYPH G051;Lo;0;L;;;;;N;;;;;
1317C;EGYPTIAN HIEROGLYPH G052;Lo;0;L;;;;;N;;;;;
1317D;EGYPTIAN HIEROGLYPH G053;Lo;0;L;;;;;N;;;;;
1317E;EGYPTIAN HIEROGLYPH G054;Lo;0;L;;;;;N;;;;;
1317F;EGYPTIAN HIEROGLYPH H001;Lo;0;L;;;;;N;;;;;
13180;EGYPTIAN HIEROGLYPH H002;Lo;0;L;;;;;N;;;;;
13181;EGYPTIAN HIEROGLYPH H003;Lo;0;L;;;;;N;;;;;
13182;EGYPTIAN HIEROGLYPH H004;Lo;0;L;;;;;N;;;;;
13183;EGYPTIAN HIEROGLYPH H005;Lo;0;L;;;;;N;;;;;
13184;EGYPTIAN HIEROGLYPH H006;Lo;0;L;;;;;N;;;;;
13185;EGYPTIAN HIEROGLYPH H006A;Lo;0;L;;;;;N;;;;;
13186;EGYPTIAN HIEROGLYPH H007;Lo;0;L;;;;;N;;;;;
13187;EGYPTIAN HIEROGLYPH H008;Lo;0;L;;;;;N;;;;;
13188;EGYPTIAN HIEROGLYPH I001;Lo;0;L;;;;;N;;;;;
13189;EGYPTIAN HIEROGLYPH I002;Lo;0;L;;;;;N;;;;;
1318A;EGYPTIAN HIEROGLYPH I003;Lo;0;L;;;;;N;;;;;
1318B;EGYPTIAN HIEROGLYPH I004;Lo;0;L;;;;;N;;;;;
1318C;EGYPTIAN HIEROGLYPH I005;Lo;0;L;;;;;N;;;;;
1318D;EGYPTIAN HIEROGLYPH I005A;Lo;0;L;;;;;N;;;;;
1318E;EGYPTIAN HIEROGLYPH I006;Lo;0;L;;;;;N;;;;;
1318F;EGYPTIAN HIEROGLYPH I007;Lo;0;L;;;;;N;;;;;
13190;EGYPTIAN HIEROGLYPH I008;Lo;0;L;;;;;N;;;;;
13191;EGYPTIAN HIEROGLYPH I009;Lo;0;L;;;;;N;;;;;
13192;EGYPTIAN HIEROGLYPH I009A;Lo;0;L;;;;;N;;;;;
13193;EGYPTIAN HIEROGLYPH I010;Lo;0;L;;;;;N;;;;;
13194;EGYPTIAN HIEROGLYPH I010A;Lo;0;L;;;;;N;;;;;
13195;EGYPTIAN HIEROGLYPH I011;Lo;0;L;;;;;N;;;;;
13196;EGYPTIAN HIEROGLYPH I011A;Lo;0;L;;;;;N;;;;;
13197;EGYPTIAN HIEROGLYPH I012;Lo;0;L;;;;;N;;;;;
13198;EGYPTIAN HIEROGLYPH I013;Lo;0;L;;;;;N;;;;;
13199;EGYPTIAN HIEROGLYPH I014;Lo;0;L;;;;;N;;;;;
1319A;EGYPTIAN HIEROGLYPH I015;Lo;0;L;;;;;N;;;;;
1319B;EGYPTIAN HIEROGLYPH K001;Lo;0;L;;;;;N;;;;;
1319C;EGYPTIAN HIEROGLYPH K002;Lo;0;L;;;;;N;;;;;
1319D;EGYPTIAN HIEROGLYPH K003;Lo;0;L;;;;;N;;;;;
1319E;EGYPTIAN HIEROGLYPH K004;Lo;0;L;;;;;N;;;;;
1319F;EGYPTIAN HIEROGLYPH K005;Lo;0;L;;;;;N;;;;;
131A0;EGYPTIAN HIEROGLYPH K006;Lo;0;L;;;;;N;;;;;
131A1;EGYPTIAN HIEROGLYPH K007;Lo;0;L;;;;;N;;;;;
131A2;EGYPTIAN HIEROGLYPH K008;Lo;0;L;;;;;N;;;;;
131A3;EGYPTIAN HIEROGLYPH L001;Lo;0;L;;;;;N;;;;;
131A4;EGYPTIAN HIEROGLYPH L002;Lo;0;L;;;;;N;;;;;
131A5;EGYPTIAN HIEROGLYPH L002A;Lo;0;L;;;;;N;;;;;
131A6;EGYPTIAN HIEROGLYPH L003;Lo;0;L;;;;;N;;;;;
131A7;EGYPTIAN HIEROGLYPH L004;Lo;0;L;;;;;N;;;;;
131A8;EGYPTIAN HIEROGLYPH L005;Lo;0;L;;;;;N;;;;;
131A9;EGYPTIAN HIEROGLYPH L006;Lo;0;L;;;;;N;;;;;
131AA;EGYPTIAN HIEROGLYPH L006A;Lo;0;L;;;;;N;;;;;
131AB;EGYPTIAN HIEROGLYPH L007;Lo;0;L;;;;;N;;;;;
131AC;EGYPTIAN HIEROGLYPH L008;Lo;0;L;;;;;N;;;;;
131AD;EGYPTIAN HIEROGLYPH M001;Lo;0;L;;;;;N;;;;;
131AE;EGYPTIAN HIEROGLYPH M001A;Lo;0;L;;;;;N;;;;;
131AF;EGYPTIAN HIEROGLYPH M001B;Lo;0;L;;;;;N;;;;;
131B0;EGYPTIAN HIEROGLYPH M002;Lo;0;L;;;;;N;;;;;
131B1;EGYPTIAN HIEROGLYPH M003;Lo;0;L;;;;;N;;;;;
131B2;EGYPTIAN HIEROGLYPH M003A;Lo;0;L;;;;;N;;;;;
131B3;EGYPTIAN HIEROGLYPH M004;Lo;0;L;;;;;N;;;;;
131B4;EGYPTIAN HIEROGLYPH M005;Lo;0;L;;;;;N;;;;;
131B5;EGYPTIAN HIEROGLYPH M006;Lo;0;L;;;;;N;;;;;
131B6;EGYPTIAN HIEROGLYPH M007;Lo;0;L;;;;;N;;;;;
131B7;EGYPTIAN HIEROGLYPH M008;Lo;0;L;;;;;N;;;;;
131B8;EGYPTIAN HIEROGLYPH M009;Lo;0;L;;;;;N;;;;;
131B9;EGYPTIAN HIEROGLYPH M010;Lo;0;L;;;;;N;;;;;
131BA;EGYPTIAN HIEROGLYPH M010A;Lo;0;L;;;;;N;;;;;
131BB;EGYPTIAN HIEROGLYPH M011;Lo;0;L;;;;;N;;;;;
131BC;EGYPTIAN HIEROGLYPH M012;Lo;0;L;;;;;N;;;;;
131BD;EGYPTIAN HIEROGLYPH M012A;Lo;0;L;;;;;N;;;;;
131BE;EGYPTIAN HIEROGLYPH M012B;Lo;0;L;;;;;N;;;;;
131BF;EGYPTIAN HIEROGLYPH M012C;Lo;0;L;;;;;N;;;;;
131C0;EGYPTIAN HIEROGLYPH M012D;Lo;0;L;;;;;N;;;;;
131C1;EGYPTIAN HIEROGLYPH M012E;Lo;0;L;;;;;N;;;;;
131C2;EGYPTIAN HIEROGLYPH M012F;Lo;0;L;;;;;N;;;;;
131C3;EGYPTIAN HIEROGLYPH M012G;Lo;0;L;;;;;N;;;;;
131C4;EGYPTIAN HIEROGLYPH M012H;Lo;0;L;;;;;N;;;;;
131C5;EGYPTIAN HIEROGLYPH M013;Lo;0;L;;;;;N;;;;;
131C6;EGYPTIAN HIEROGLYPH M014;Lo;0;L;;;;;N;;;;;
131C7;EGYPTIAN HIEROGLYPH M015;Lo;0;L;;;;;N;;;;;
131C8;EGYPTIAN HIEROGLYPH M015A;Lo;0;L;;;;;N;;;;;
131C9;EGYPTIAN HIEROGLYPH M016;Lo;0;L;;;;;N;;;;;
131CA;EGYPTIAN HIEROGLYPH M016A;Lo;0;L;;;;;N;;;;;
131CB;EGYPTIAN HIEROGLYPH M017;Lo;0;L;;;;;N;;;;;
131CC;EGYPTIAN HIEROGLYPH M017A;Lo;0;L;;;;;N;;;;;
131CD;EGYPTIAN HIEROGLYPH M018;Lo;0;L;;;;;N;;;;;
131CE;EGYPTIAN HIEROGLYPH M019;Lo;0;L;;;;;N;;;;;
131CF;EGYPTIAN HIEROGLYPH M020;Lo;0;L;;;;;N;;;;;
131D0;EGYPTIAN HIEROGLYPH M021;Lo;0;L;;;;;N;;;;;
131D1;EGYPTIAN HIEROGLYPH M022;Lo;0;L;;;;;N;;;;;
131D2;EGYPTIAN HIEROGLYPH M022A;Lo;0;L;;;;;N;;;;;
131D3;EGYPTIAN HIEROGLYPH M023;Lo;0;L;;;;;N;;;;;
131D4;EGYPTIAN HIEROGLYPH M024;Lo;0;L;;;;;N;;;;;
131D5;EGYPTIAN HIEROGLYPH M024A;Lo;0;L;;;;;N;;;;;
131D6;EGYPTIAN HIEROGLYPH M025;Lo;0;L;;;;;N;;;;;
131D7;EGYPTIAN HIEROGLYPH M026;Lo;0;L;;;;;N;;;;;
131D8;EGYPTIAN HIEROGLYPH M027;Lo;0;L;;;;;N;;;;;
131D9;EGYPTIAN HIEROGLYPH M028;Lo;0;L;;;;;N;;;;;
131DA;EGYPTIAN HIEROGLYPH M028A;Lo;0;L;;;;;N;;;;;
131DB;EGYPTIAN HIEROGLYPH M029;Lo;0;L;;;;;N;;;;;
131DC;EGYPTIAN HIEROGLYPH M030;Lo;0;L;;;;;N;;;;;
131DD;EGYPTIAN HIEROGLYPH M031;Lo;0;L;;;;;N;;;;;
131DE;EGYPTIAN HIEROGLYPH M031A;Lo;0;L;;;;;N;;;;;
131DF;EGYPTIAN HIEROGLYPH M032;Lo;0;L;;;;;N;;;;;
131E0;EGYPTIAN HIEROGLYPH M033;Lo;0;L;;;;;N;;;;;
131E1;EGYPTIAN HIEROGLYPH M033A;Lo;0;L;;;;;N;;;;;
131E2;EGYPTIAN HIEROGLYPH M033B;Lo;0;L;;;;;N;;;;;
131E3;EGYPTIAN HIEROGLYPH M034;Lo;0;L;;;;;N;;;;;
131E4;EGYPTIAN HIEROGLYPH M035;Lo;0;L;;;;;N;;;;;
131E5;EGYPTIAN HIEROGLYPH M036;Lo;0;L;;;;;N;;;;;
131E6;EGYPTIAN HIEROGLYPH M037;Lo;0;L;;;;;N;;;;;
131E7;EGYPTIAN HIEROGLYPH M038;Lo;0;L;;;;;N;;;;;
131E8;EGYPTIAN HIEROGLYPH M039;Lo;0;L;;;;;N;;;;;
131E9;EGYPTIAN HIEROGLYPH M040;Lo;0;L;;;;;N;;;;;
131EA;EGYPTIAN HIEROGLYPH M040A;Lo;0;L;;;;;N;;;;;
131EB;EGYPTIAN HIEROGLYPH M041;Lo;0;L;;;;;N;;;;;
131EC;EGYPTIAN HIEROGLYPH M042;Lo;0;L;;;;;N;;;;;
131ED;EGYPTIAN HIEROGLYPH M043;Lo;0;L;;;;;N;;;;;
131EE;EGYPTIAN HIEROGLYPH M044;Lo;0;L;;;;;N;;;;;
131EF;EGYPTIAN HIEROGLYPH N001;Lo;0;L;;;;;N;;;;;
131F0;EGYPTIAN HIEROGLYPH N002;Lo;0;L;;;;;N;;;;;
131F1;EGYPTIAN HIEROGLYPH N003;Lo;0;L;;;;;N;;;;;
131F2;EGYPTIAN HIEROGLYPH N004;Lo;0;L;;;;;N;;;;;
131F3;EGYPTIAN HIEROGLYPH N005;Lo;0;L;;;;;N;;;;;
131F4;EGYPTIAN HIEROGLYPH N006;Lo;0;L;;;;;N;;;;;
131F5;EGYPTIAN HIEROGLYPH N007;Lo;0;L;;;;;N;;;;;
131F6;EGYPTIAN HIEROGLYPH N008;Lo;0;L;;;;;N;;;;;
131F7;EGYPTIAN HIEROGLYPH N009;Lo;0;L;;;;;N;;;;;
131F8;EGYPTIAN HIEROGLYPH N010;Lo;0;L;;;;;N;;;;;
131F9;EGYPTIAN HIEROGLYPH N011;Lo;0;L;;;;;N;;;;;
131FA;EGYPTIAN HIEROGLYPH N012;Lo;0;L;;;;;N;;;;;
131FB;EGYPTIAN HIEROGLYPH N013;Lo;0;L;;;;;N;;;;;
131FC;EGYPTIAN HIEROGLYPH N014;Lo;0;L;;;;;N;;;;;
131FD;EGYPTIAN HIEROGLYPH N015;Lo;0;L;;;;;N;;;;;
131FE;EGYPTIAN HIEROGLYPH N016;Lo;0;L;;;;;N;;;;;
131FF;EGYPTIAN HIEROGLYPH N017;Lo;0;L;;;;;N;;;;;
13200;EGYPTIAN HIEROGLYPH N018;Lo;0;L;;;;;N;;;;;
13201;EGYPTIAN HIEROGLYPH N018A;Lo;0;L;;;;;N;;;;;
13202;EGYPTIAN HIEROGLYPH N018B;Lo;0;L;;;;;N;;;;;
13203;EGYPTIAN HIEROGLYPH N019;Lo;0;L;;;;;N;;;;;
13204;EGYPTIAN HIEROGLYPH N020;Lo;0;L;;;;;N;;;;;
13205;EGYPTIAN HIEROGLYPH N021;Lo;0;L;;;;;N;;;;;
13206;EGYPTIAN HIEROGLYPH N022;Lo;0;L;;;;;N;;;;;
13207;EGYPTIAN HIEROGLYPH N023;Lo;0;L;;;;;N;;;;;
13208;EGYPTIAN HIEROGLYPH N024;Lo;0;L;;;;;N;;;;;
13209;EGYPTIAN HIEROGLYPH N025;Lo;0;L;;;;;N;;;;;
1320A;EGYPTIAN HIEROGLYPH N025A;Lo;0;L;;;;;N;;;;;
1320B;EGYPTIAN HIEROGLYPH N026;Lo;0;L;;;;;N;;;;;
1320C;EGYPTIAN HIEROGLYPH N027;Lo;0;L;;;;;N;;;;;
1320D;EGYPTIAN HIEROGLYPH N028;Lo;0;L;;;;;N;;;;;
1320E;EGYPTIAN HIEROGLYPH N029;Lo;0;L;;;;;N;;;;;
1320F;EGYPTIAN HIEROGLYPH N030;Lo;0;L;;;;;N;;;;;
13210;EGYPTIAN HIEROGLYPH N031;Lo;0;L;;;;;N;;;;;
13211;EGYPTIAN HIEROGLYPH N032;Lo;0;L;;;;;N;;;;;
13212;EGYPTIAN HIEROGLYPH N033;Lo;0;L;;;;;N;;;;;
13213;EGYPTIAN HIEROGLYPH N033A;Lo;0;L;;;;;N;;;;;
13214;EGYPTIAN HIEROGLYPH N034;Lo;0;L;;;;;N;;;;;
13215;EGYPTIAN HIEROGLYPH N034A;Lo;0;L;;;;;N;;;;;
13216;EGYPTIAN HIEROGLYPH N035;Lo;0;L;;;;;N;;;;;
13217;EGYPTIAN HIEROGLYPH N035A;Lo;0;L;;;;;N;;;;;
13218;EGYPTIAN HIEROGLYPH N036;Lo;0;L;;;;;N;;;;;
13219;EGYPTIAN HIEROGLYPH N037;Lo;0;L;;;;;N;;;;;
1321A;EGYPTIAN HIEROGLYPH N037A;Lo;0;L;;;;;N;;;;;
1321B;EGYPTIAN HIEROGLYPH N038;Lo;0;L;;;;;N;;;;;
1321C;EGYPTIAN HIEROGLYPH N039;Lo;0;L;;;;;N;;;;;
1321D;EGYPTIAN HIEROGLYPH N040;Lo;0;L;;;;;N;;;;;
1321E;EGYPTIAN HIEROGLYPH N041;Lo;0;L;;;;;N;;;;;
1321F;EGYPTIAN HIEROGLYPH N042;Lo;0;L;;;;;N;;;;;
13220;EGYPTIAN HIEROGLYPH NL001;Lo;0;L;;;;;N;;;;;
13221;EGYPTIAN HIEROGLYPH NL002;Lo;0;L;;;;;N;;;;;
13222;EGYPTIAN HIEROGLYPH NL003;Lo;0;L;;;;;N;;;;;
13223;EGYPTIAN HIEROGLYPH NL004;Lo;0;L;;;;;N;;;;;
13224;EGYPTIAN HIEROGLYPH NL005;Lo;0;L;;;;;N;;;;;
13225;EGYPTIAN HIEROGLYPH NL005A;Lo;0;L;;;;;N;;;;;
13226;EGYPTIAN HIEROGLYPH NL006;Lo;0;L;;;;;N;;;;;
13227;EGYPTIAN HIEROGLYPH NL007;Lo;0;L;;;;;N;;;;;
13228;EGYPTIAN HIEROGLYPH NL008;Lo;0;L;;;;;N;;;;;
13229;EGYPTIAN HIEROGLYPH NL009;Lo;0;L;;;;;N;;;;;
1322A;EGYPTIAN HIEROGLYPH NL010;Lo;0;L;;;;;N;;;;;
1322B;EGYPTIAN HIEROGLYPH NL011;Lo;0;L;;;;;N;;;;;
1322C;EGYPTIAN HIEROGLYPH NL012;Lo;0;L;;;;;N;;;;;
1322D;EGYPTIAN HIEROGLYPH NL013;Lo;0;L;;;;;N;;;;;
1322E;EGYPTIAN HIEROGLYPH NL014;Lo;0;L;;;;;N;;;;;
1322F;EGYPTIAN HIEROGLYPH NL015;Lo;0;L;;;;;N;;;;;
13230;EGYPTIAN HIEROGLYPH NL016;Lo;0;L;;;;;N;;;;;
13231;EGYPTIAN HIEROGLYPH NL017;Lo;0;L;;;;;N;;;;;
13232;EGYPTIAN HIEROGLYPH NL017A;Lo;0;L;;;;;N;;;;;
13233;EGYPTIAN HIEROGLYPH NL018;Lo;0;L;;;;;N;;;;;
13234;EGYPTIAN HIEROGLYPH NL019;Lo;0;L;;;;;N;;;;;
13235;EGYPTIAN HIEROGLYPH NL020;Lo;0;L;;;;;N;;;;;
13236;EGYPTIAN HIEROGLYPH NU001;Lo;0;L;;;;;N;;;;;
13237;EGYPTIAN HIEROGLYPH NU002;Lo;0;L;;;;;N;;;;;
13238;EGYPTIAN HIEROGLYPH NU003;Lo;0;L;;;;;N;;;;;
13239;EGYPTIAN HIEROGLYPH NU004;Lo;0;L;;;;;N;;;;;
1323A;EGYPTIAN HIEROGLYPH NU005;Lo;0;L;;;;;N;;;;;
1323B;EGYPTIAN HIEROGLYPH NU006;Lo;0;L;;;;;N;;;;;
1323C;EGYPTIAN HIEROGLYPH NU007;Lo;0;L;;;;;N;;;;;
1323D;EGYPTIAN HIEROGLYPH NU008;Lo;0;L;;;;;N;;;;;
1323E;EGYPTIAN HIEROGLYPH NU009;Lo;0;L;;;;;N;;;;;
1323F;EGYPTIAN HIEROGLYPH NU010;Lo;0;L;;;;;N;;;;;
13240;EGYPTIAN HIEROGLYPH NU010A;Lo;0;L;;;;;N;;;;;
13241;EGYPTIAN HIEROGLYPH NU011;Lo;0;L;;;;;N;;;;;
13242;EGYPTIAN HIEROGLYPH NU011A;Lo;0;L;;;;;N;;;;;
13243;EGYPTIAN HIEROGLYPH NU012;Lo;0;L;;;;;N;;;;;
13244;EGYPTIAN HIEROGLYPH NU013;Lo;0;L;;;;;N;;;;;
13245;EGYPTIAN HIEROGLYPH NU014;Lo;0;L;;;;;N;;;;;
13246;EGYPTIAN HIEROGLYPH NU015;Lo;0;L;;;;;N;;;;;
13247;EGYPTIAN HIEROGLYPH NU016;Lo;0;L;;;;;N;;;;;
13248;EGYPTIAN HIEROGLYPH NU017;Lo;0;L;;;;;N;;;;;
13249;EGYPTIAN HIEROGLYPH NU018;Lo;0;L;;;;;N;;;;;
1324A;EGYPTIAN HIEROGLYPH NU018A;Lo;0;L;;;;;N;;;;;
1324B;EGYPTIAN HIEROGLYPH NU019;Lo;0;L;;;;;N;;;;;
1324C;EGYPTIAN HIEROGLYPH NU020;Lo;0;L;;;;;N;;;;;
1324D;EGYPTIAN HIEROGLYPH NU021;Lo;0;L;;;;;N;;;;;
1324E;EGYPTIAN HIEROGLYPH NU022;Lo;0;L;;;;;N;;;;;
1324F;EGYPTIAN HIEROGLYPH NU022A;Lo;0;L;;;;;N;;;;;
13250;EGYPTIAN HIEROGLYPH O001;Lo;0;L;;;;;N;;;;;
13251;EGYPTIAN HIEROGLYPH O001A;Lo;0;L;;;;;N;;;;;
13252;EGYPTIAN HIEROGLYPH O002;Lo;0;L;;;;;N;;;;;
13253;EGYPTIAN HIEROGLYPH O003;Lo;0;L;;;;;N;;;;;
13254;EGYPTIAN HIEROGLYPH O004;Lo;0;L;;;;;N;;;;;
13255;EGYPTIAN HIEROGLYPH O005;Lo;0;L;;;;;N;;;;;
13256;EGYPTIAN HIEROGLYPH O005A;Lo;0;L;;;;;N;;;;;
13257;EGYPTIAN HIEROGLYPH O006;Lo;0;L;;;;;N;;;;;
13258;EGYPTIAN HIEROGLYPH O006A;Lo;0;L;;;;;N;;;;;
13259;EGYPTIAN HIEROGLYPH O006B;Lo;0;L;;;;;N;;;;;
1325A;EGYPTIAN HIEROGLYPH O006C;Lo;0;L;;;;;N;;;;;
1325B;EGYPTIAN HIEROGLYPH O006D;Lo;0;L;;;;;N;;;;;
1325C;EGYPTIAN HIEROGLYPH O006E;Lo;0;L;;;;;N;;;;;
1325D;EGYPTIAN HIEROGLYPH O006F;Lo;0;L;;;;;N;;;;;
1325E;EGYPTIAN HIEROGLYPH O007;Lo;0;L;;;;;N;;;;;
1325F;EGYPTIAN HIEROGLYPH O008;Lo;0;L;;;;;N;;;;;
13260;EGYPTIAN HIEROGLYPH O009;Lo;0;L;;;;;N;;;;;
13261;EGYPTIAN HIEROGLYPH O010;Lo;0;L;;;;;N;;;;;
13262;EGYPTIAN HIEROGLYPH O010A;Lo;0;L;;;;;N;;;;;
13263;EGYPTIAN HIEROGLYPH O010B;Lo;0;L;;;;;N;;;;;
13264;EGYPTIAN HIEROGLYPH O010C;Lo;0;L;;;;;N;;;;;
13265;EGYPTIAN HIEROGLYPH O011;Lo;0;L;;;;;N;;;;;
13266;EGYPTIAN HIEROGLYPH O012;Lo;0;L;;;;;N;;;;;
13267;EGYPTIAN HIEROGLYPH O013;Lo;0;L;;;;;N;;;;;
13268;EGYPTIAN HIEROGLYPH O014;Lo;0;L;;;;;N;;;;;
13269;EGYPTIAN HIEROGLYPH O015;Lo;0;L;;;;;N;;;;;
1326A;EGYPTIAN HIEROGLYPH O016;Lo;0;L;;;;;N;;;;;
1326B;EGYPTIAN HIEROGLYPH O017;Lo;0;L;;;;;N;;;;;
1326C;EGYPTIAN HIEROGLYPH O018;Lo;0;L;;;;;N;;;;;
1326D;EGYPTIAN HIEROGLYPH O019;Lo;0;L;;;;;N;;;;;
1326E;EGYPTIAN HIEROGLYPH O019A;Lo;0;L;;;;;N;;;;;
1326F;EGYPTIAN HIEROGLYPH O020;Lo;0;L;;;;;N;;;;;
13270;EGYPTIAN HIEROGLYPH O020A;Lo;0;L;;;;;N;;;;;
13271;EGYPTIAN HIEROGLYPH O021;Lo;0;L;;;;;N;;;;;
13272;EGYPTIAN HIEROGLYPH O022;Lo;0;L;;;;;N;;;;;
13273;EGYPTIAN HIEROGLYPH O023;Lo;0;L;;;;;N;;;;;
13274;EGYPTIAN HIEROGLYPH O024;Lo;0;L;;;;;N;;;;;
13275;EGYPTIAN HIEROGLYPH O024A;Lo;0;L;;;;;N;;;;;
13276;EGYPTIAN HIEROGLYPH O025;Lo;0;L;;;;;N;;;;;
13277;EGYPTIAN HIEROGLYPH O025A;Lo;0;L;;;;;N;;;;;
13278;EGYPTIAN HIEROGLYPH O026;Lo;0;L;;;;;N;;;;;
13279;EGYPTIAN HIEROGLYPH O027;Lo;0;L;;;;;N;;;;;
1327A;EGYPTIAN HIEROGLYPH O028;Lo;0;L;;;;;N;;;;;
1327B;EGYPTIAN HIEROGLYPH O029;Lo;0;L;;;;;N;;;;;
1327C;EGYPTIAN HIEROGLYPH O029A;Lo;0;L;;;;;N;;;;;
1327D;EGYPTIAN HIEROGLYPH O030;Lo;0;L;;;;;N;;;;;
1327E;EGYPTIAN HIEROGLYPH O030A;Lo;0;L;;;;;N;;;;;
1327F;EGYPTIAN HIEROGLYPH O031;Lo;0;L;;;;;N;;;;;
13280;EGYPTIAN HIEROGLYPH O032;Lo;0;L;;;;;N;;;;;
13281;EGYPTIAN HIEROGLYPH O033;Lo;0;L;;;;;N;;;;;
13282;EGYPTIAN HIEROGLYPH O033A;Lo;0;L;;;;;N;;;;;
13283;EGYPTIAN HIEROGLYPH O034;Lo;0;L;;;;;N;;;;;
13284;EGYPTIAN HIEROGLYPH O035;Lo;0;L;;;;;N;;;;;
13285;EGYPTIAN HIEROGLYPH O036;Lo;0;L;;;;;N;;;;;
13286;EGYPTIAN HIEROGLYPH O036A;Lo;0;L;;;;;N;;;;;
13287;EGYPTIAN HIEROGLYPH O036B;Lo;0;L;;;;;N;;;;;
13288;EGYPTIAN HIEROGLYPH O036C;Lo;0;L;;;;;N;;;;;
13289;EGYPTIAN HIEROGLYPH O036D;Lo;0;L;;;;;N;;;;;
1328A;EGYPTIAN HIEROGLYPH O037;Lo;0;L;;;;;N;;;;;
1328B;EGYPTIAN HIEROGLYPH O038;Lo;0;L;;;;;N;;;;;
1328C;EGYPTIAN HIEROGLYPH O039;Lo;0;L;;;;;N;;;;;
1328D;EGYPTIAN HIEROGLYPH O040;Lo;0;L;;;;;N;;;;;
1328E;EGYPTIAN HIEROGLYPH O041;Lo;0;L;;;;;N;;;;;
1328F;EGYPTIAN HIEROGLYPH O042;Lo;0;L;;;;;N;;;;;
13290;EGYPTIAN HIEROGLYPH O043;Lo;0;L;;;;;N;;;;;
13291;EGYPTIAN HIEROGLYPH O044;Lo;0;L;;;;;N;;;;;
13292;EGYPTIAN HIEROGLYPH O045;Lo;0;L;;;;;N;;;;;
13293;EGYPTIAN HIEROGLYPH O046;Lo;0;L;;;;;N;;;;;
13294;EGYPTIAN HIEROGLYPH O047;Lo;0;L;;;;;N;;;;;
13295;EGYPTIAN HIEROGLYPH O048;Lo;0;L;;;;;N;;;;;
13296;EGYPTIAN HIEROGLYPH O049;Lo;0;L;;;;;N;;;;;
13297;EGYPTIAN HIEROGLYPH O050;Lo;0;L;;;;;N;;;;;
13298;EGYPTIAN HIEROGLYPH O050A;Lo;0;L;;;;;N;;;;;
13299;EGYPTIAN HIEROGLYPH O050B;Lo;0;L;;;;;N;;;;;
1329A;EGYPTIAN HIEROGLYPH O051;Lo;0;L;;;;;N;;;;;
1329B;EGYPTIAN HIEROGLYPH P001;Lo;0;L;;;;;N;;;;;
1329C;EGYPTIAN HIEROGLYPH P001A;Lo;0;L;;;;;N;;;;;
1329D;EGYPTIAN HIEROGLYPH P002;Lo;0;L;;;;;N;;;;;
1329E;EGYPTIAN HIEROGLYPH P003;Lo;0;L;;;;;N;;;;;
1329F;EGYPTIAN HIEROGLYPH P003A;Lo;0;L;;;;;N;;;;;
132A0;EGYPTIAN HIEROGLYPH P004;Lo;0;L;;;;;N;;;;;
132A1;EGYPTIAN HIEROGLYPH P005;Lo;0;L;;;;;N;;;;;
132A2;EGYPTIAN HIEROGLYPH P006;Lo;0;L;;;;;N;;;;;
132A3;EGYPTIAN HIEROGLYPH P007;Lo;0;L;;;;;N;;;;;
132A4;EGYPTIAN HIEROGLYPH P008;Lo;0;L;;;;;N;;;;;
132A5;EGYPTIAN HIEROGLYPH P009;Lo;0;L;;;;;N;;;;;
132A6;EGYPTIAN HIEROGLYPH P010;Lo;0;L;;;;;N;;;;;
132A7;EGYPTIAN HIEROGLYPH P011;Lo;0;L;;;;;N;;;;;
132A8;EGYPTIAN HIEROGLYPH Q001;Lo;0;L;;;;;N;;;;;
132A9;EGYPTIAN HIEROGLYPH Q002;Lo;0;L;;;;;N;;;;;
132AA;EGYPTIAN HIEROGLYPH Q003;Lo;0;L;;;;;N;;;;;
132AB;EGYPTIAN HIEROGLYPH Q004;Lo;0;L;;;;;N;;;;;
132AC;EGYPTIAN HIEROGLYPH Q005;Lo;0;L;;;;;N;;;;;
132AD;EGYPTIAN HIEROGLYPH Q006;Lo;0;L;;;;;N;;;;;
132AE;EGYPTIAN HIEROGLYPH Q007;Lo;0;L;;;;;N;;;;;
132AF;EGYPTIAN HIEROGLYPH R001;Lo;0;L;;;;;N;;;;;
132B0;EGYPTIAN HIEROGLYPH R002;Lo;0;L;;;;;N;;;;;
132B1;EGYPTIAN HIEROGLYPH R002A;Lo;0;L;;;;;N;;;;;
132B2;EGYPTIAN HIEROGLYPH R003;Lo;0;L;;;;;N;;;;;
132B3;EGYPTIAN HIEROGLYPH R003A;Lo;0;L;;;;;N;;;;;
132B4;EGYPTIAN HIEROGLYPH R003B;Lo;0;L;;;;;N;;;;;
132B5;EGYPTIAN HIEROGLYPH R004;Lo;0;L;;;;;N;;;;;
132B6;EGYPTIAN HIEROGLYPH R005;Lo;0;L;;;;;N;;;;;
132B7;EGYPTIAN HIEROGLYPH R006;Lo;0;L;;;;;N;;;;;
132B8;EGYPTIAN HIEROGLYPH R007;Lo;0;L;;;;;N;;;;;
132B9;EGYPTIAN HIEROGLYPH R008;Lo;0;L;;;;;N;;;;;
132BA;EGYPTIAN HIEROGLYPH R009;Lo;0;L;;;;;N;;;;;
132BB;EGYPTIAN HIEROGLYPH R010;Lo;0;L;;;;;N;;;;;
132BC;EGYPTIAN HIEROGLYPH R010A;Lo;0;L;;;;;N;;;;;
132BD;EGYPTIAN HIEROGLYPH R011;Lo;0;L;;;;;N;;;;;
132BE;EGYPTIAN HIEROGLYPH R012;Lo;0;L;;;;;N;;;;;
132BF;EGYPTIAN HIEROGLYPH R013;Lo;0;L;;;;;N;;;;;
132C0;EGYPTIAN HIEROGLYPH R014;Lo;0;L;;;;;N;;;;;
132C1;EGYPTIAN HIEROGLYPH R015;Lo;0;L;;;;;N;;;;;
132C2;EGYPTIAN HIEROGLYPH R016;Lo;0;L;;;;;N;;;;;
132C3;EGYPTIAN HIEROGLYPH R016A;Lo;0;L;;;;;N;;;;;
132C4;EGYPTIAN HIEROGLYPH R017;Lo;0;L;;;;;N;;;;;
132C5;EGYPTIAN HIEROGLYPH R018;Lo;0;L;;;;;N;;;;;
132C6;EGYPTIAN HIEROGLYPH R019;Lo;0;L;;;;;N;;;;;
132C7;EGYPTIAN HIEROGLYPH R020;Lo;0;L;;;;;N;;;;;
132C8;EGYPTIAN HIEROGLYPH R021;Lo;0;L;;;;;N;;;;;
132C9;EGYPTIAN HIEROGLYPH R022;Lo;0;L;;;;;N;;;;;
132CA;EGYPTIAN HIEROGLYPH R023;Lo;0;L;;;;;N;;;;;
132CB;EGYPTIAN HIEROGLYPH R024;Lo;0;L;;;;;N;;;;;
132CC;EGYPTIAN HIEROGLYPH R025;Lo;0;L;;;;;N;;;;;
132CD;EGYPTIAN HIEROGLYPH R026;Lo;0;L;;;;;N;;;;;
132CE;EGYPTIAN HIEROGLYPH R027;Lo;0;L;;;;;N;;;;;
132CF;EGYPTIAN HIEROGLYPH R028;Lo;0;L;;;;;N;;;;;
132D0;EGYPTIAN HIEROGLYPH R029;Lo;0;L;;;;;N;;;;;
132D1;EGYPTIAN HIEROGLYPH S001;Lo;0;L;;;;;N;;;;;
132D2;EGYPTIAN HIEROGLYPH S002;Lo;0;L;;;;;N;;;;;
132D3;EGYPTIAN HIEROGLYPH S002A;Lo;0;L;;;;;N;;;;;
132D4;EGYPTIAN HIEROGLYPH S003;Lo;0;L;;;;;N;;;;;
132D5;EGYPTIAN HIEROGLYPH S004;Lo;0;L;;;;;N;;;;;
132D6;EGYPTIAN HIEROGLYPH S005;Lo;0;L;;;;;N;;;;;
132D7;EGYPTIAN HIEROGLYPH S006;Lo;0;L;;;;;N;;;;;
132D8;EGYPTIAN HIEROGLYPH S006A;Lo;0;L;;;;;N;;;;;
132D9;EGYPTIAN HIEROGLYPH S007;Lo;0;L;;;;;N;;;;;
132DA;EGYPTIAN HIEROGLYPH S008;Lo;0;L;;;;;N;;;;;
132DB;EGYPTIAN HIEROGLYPH S009;Lo;0;L;;;;;N;;;;;
132DC;EGYPTIAN HIEROGLYPH S010;Lo;0;L;;;;;N;;;;;
132DD;EGYPTIAN HIEROGLYPH S011;Lo;0;L;;;;;N;;;;;
132DE;EGYPTIAN HIEROGLYPH S012;Lo;0;L;;;;;N;;;;;
132DF;EGYPTIAN HIEROGLYPH S013;Lo;0;L;;;;;N;;;;;
132E0;EGYPTIAN HIEROGLYPH S014;Lo;0;L;;;;;N;;;;;
132E1;EGYPTIAN HIEROGLYPH S014A;Lo;0;L;;;;;N;;;;;
132E2;EGYPTIAN HIEROGLYPH S014B;Lo;0;L;;;;;N;;;;;
132E3;EGYPTIAN HIEROGLYPH S015;Lo;0;L;;;;;N;;;;;
132E4;EGYPTIAN HIEROGLYPH S016;Lo;0;L;;;;;N;;;;;
132E5;EGYPTIAN HIEROGLYPH S017;Lo;0;L;;;;;N;;;;;
132E6;EGYPTIAN HIEROGLYPH S017A;Lo;0;L;;;;;N;;;;;
132E7;EGYPTIAN HIEROGLYPH S018;Lo;0;L;;;;;N;;;;;
132E8;EGYPTIAN HIEROGLYPH S019;Lo;0;L;;;;;N;;;;;
132E9;EGYPTIAN HIEROGLYPH S020;Lo;0;L;;;;;N;;;;;
132EA;EGYPTIAN HIEROGLYPH S021;Lo;0;L;;;;;N;;;;;
132EB;EGYPTIAN HIEROGLYPH S022;Lo;0;L;;;;;N;;;;;
132EC;EGYPTIAN HIEROGLYPH S023;Lo;0;L;;;;;N;;;;;
132ED;EGYPTIAN HIEROGLYPH S024;Lo;0;L;;;;;N;;;;;
132EE;EGYPTIAN HIEROGLYPH S025;Lo;0;L;;;;;N;;;;;
132EF;EGYPTIAN HIEROGLYPH S026;Lo;0;L;;;;;N;;;;;
132F0;EGYPTIAN HIEROGLYPH S026A;Lo;0;L;;;;;N;;;;;
132F1;EGYPTIAN HIEROGLYPH S026B;Lo;0;L;;;;;N;;;;;
132F2;EGYPTIAN HIEROGLYPH S027;Lo;0;L;;;;;N;;;;;
132F3;EGYPTIAN HIEROGLYPH S028;Lo;0;L;;;;;N;;;;;
132F4;EGYPTIAN HIEROGLYPH S029;Lo;0;L;;;;;N;;;;;
132F5;EGYPTIAN HIEROGLYPH S030;Lo;0;L;;;;;N;;;;;
132F6;EGYPTIAN HIEROGLYPH S031;Lo;0;L;;;;;N;;;;;
132F7;EGYPTIAN HIEROGLYPH S032;Lo;0;L;;;;;N;;;;;
132F8;EGYPTIAN HIEROGLYPH S033;Lo;0;L;;;;;N;;;;;
132F9;EGYPTIAN HIEROGLYPH S034;Lo;0;L;;;;;N;;;;;
132FA;EGYPTIAN HIEROGLYPH S035;Lo;0;L;;;;;N;;;;;
132FB;EGYPTIAN HIEROGLYPH S035A;Lo;0;L;;;;;N;;;;;
132FC;EGYPTIAN HIEROGLYPH S036;Lo;0;L;;;;;N;;;;;
132FD;EGYPTIAN HIEROGLYPH S037;Lo;0;L;;;;;N;;;;;
132FE;EGYPTIAN HIEROGLYPH S038;Lo;0;L;;;;;N;;;;;
132FF;EGYPTIAN HIEROGLYPH S039;Lo;0;L;;;;;N;;;;;
13300;EGYPTIAN HIEROGLYPH S040;Lo;0;L;;;;;N;;;;;
13301;EGYPTIAN HIEROGLYPH S041;Lo;0;L;;;;;N;;;;;
13302;EGYPTIAN HIEROGLYPH S042;Lo;0;L;;;;;N;;;;;
13303;EGYPTIAN HIEROGLYPH S043;Lo;0;L;;;;;N;;;;;
13304;EGYPTIAN HIEROGLYPH S044;Lo;0;L;;;;;N;;;;;
13305;EGYPTIAN HIEROGLYPH S045;Lo;0;L;;;;;N;;;;;
13306;EGYPTIAN HIEROGLYPH S046;Lo;0;L;;;;;N;;;;;
13307;EGYPTIAN HIEROGLYPH T001;Lo;0;L;;;;;N;;;;;
13308;EGYPTIAN HIEROGLYPH T002;Lo;0;L;;;;;N;;;;;
13309;EGYPTIAN HIEROGLYPH T003;Lo;0;L;;;;;N;;;;;
1330A;EGYPTIAN HIEROGLYPH T003A;Lo;0;L;;;;;N;;;;;
1330B;EGYPTIAN HIEROGLYPH T004;Lo;0;L;;;;;N;;;;;
1330C;EGYPTIAN HIEROGLYPH T005;Lo;0;L;;;;;N;;;;;
1330D;EGYPTIAN HIEROGLYPH T006;Lo;0;L;;;;;N;;;;;
1330E;EGYPTIAN HIEROGLYPH T007;Lo;0;L;;;;;N;;;;;
1330F;EGYPTIAN HIEROGLYPH T007A;Lo;0;L;;;;;N;;;;;
13310;EGYPTIAN HIEROGLYPH T008;Lo;0;L;;;;;N;;;;;
13311;EGYPTIAN HIEROGLYPH T008A;Lo;0;L;;;;;N;;;;;
13312;EGYPTIAN HIEROGLYPH T009;Lo;0;L;;;;;N;;;;;
13313;EGYPTIAN HIEROGLYPH T009A;Lo;0;L;;;;;N;;;;;
13314;EGYPTIAN HIEROGLYPH T010;Lo;0;L;;;;;N;;;;;
13315;EGYPTIAN HIEROGLYPH T011;Lo;0;L;;;;;N;;;;;
13316;EGYPTIAN HIEROGLYPH T011A;Lo;0;L;;;;;N;;;;;
13317;EGYPTIAN HIEROGLYPH T012;Lo;0;L;;;;;N;;;;;
13318;EGYPTIAN HIEROGLYPH T013;Lo;0;L;;;;;N;;;;;
13319;EGYPTIAN HIEROGLYPH T014;Lo;0;L;;;;;N;;;;;
1331A;EGYPTIAN HIEROGLYPH T015;Lo;0;L;;;;;N;;;;;
1331B;EGYPTIAN HIEROGLYPH T016;Lo;0;L;;;;;N;;;;;
1331C;EGYPTIAN HIEROGLYPH T016A;Lo;0;L;;;;;N;;;;;
1331D;EGYPTIAN HIEROGLYPH T017;Lo;0;L;;;;;N;;;;;
1331E;EGYPTIAN HIEROGLYPH T018;Lo;0;L;;;;;N;;;;;
1331F;EGYPTIAN HIEROGLYPH T019;Lo;0;L;;;;;N;;;;;
13320;EGYPTIAN HIEROGLYPH T020;Lo;0;L;;;;;N;;;;;
13321;EGYPTIAN HIEROGLYPH T021;Lo;0;L;;;;;N;;;;;
13322;EGYPTIAN HIEROGLYPH T022;Lo;0;L;;;;;N;;;;;
13323;EGYPTIAN HIEROGLYPH T023;Lo;0;L;;;;;N;;;;;
13324;EGYPTIAN HIEROGLYPH T024;Lo;0;L;;;;;N;;;;;
13325;EGYPTIAN HIEROGLYPH T025;Lo;0;L;;;;;N;;;;;
13326;EGYPTIAN HIEROGLYPH T026;Lo;0;L;;;;;N;;;;;
13327;EGYPTIAN HIEROGLYPH T027;Lo;0;L;;;;;N;;;;;
13328;EGYPTIAN HIEROGLYPH T028;Lo;0;L;;;;;N;;;;;
13329;EGYPTIAN HIEROGLYPH T029;Lo;0;L;;;;;N;;;;;
1332A;EGYPTIAN HIEROGLYPH T030;Lo;0;L;;;;;N;;;;;
1332B;EGYPTIAN HIEROGLYPH T031;Lo;0;L;;;;;N;;;;;
1332C;EGYPTIAN HIEROGLYPH T032;Lo;0;L;;;;;N;;;;;
1332D;EGYPTIAN HIEROGLYPH T032A;Lo;0;L;;;;;N;;;;;
1332E;EGYPTIAN HIEROGLYPH T033;Lo;0;L;;;;;N;;;;;
1332F;EGYPTIAN HIEROGLYPH T033A;Lo;0;L;;;;;N;;;;;
13330;EGYPTIAN HIEROGLYPH T034;Lo;0;L;;;;;N;;;;;
13331;EGYPTIAN HIEROGLYPH T035;Lo;0;L;;;;;N;;;;;
13332;EGYPTIAN HIEROGLYPH T036;Lo;0;L;;;;;N;;;;;
13333;EGYPTIAN HIEROGLYPH U001;Lo;0;L;;;;;N;;;;;
13334;EGYPTIAN HIEROGLYPH U002;Lo;0;L;;;;;N;;;;;
13335;EGYPTIAN HIEROGLYPH U003;Lo;0;L;;;;;N;;;;;
13336;EGYPTIAN HIEROGLYPH U004;Lo;0;L;;;;;N;;;;;
13337;EGYPTIAN HIEROGLYPH U005;Lo;0;L;;;;;N;;;;;
13338;EGYPTIAN HIEROGLYPH U006;Lo;0;L;;;;;N;;;;;
13339;EGYPTIAN HIEROGLYPH U006A;Lo;0;L;;;;;N;;;;;
1333A;EGYPTIAN HIEROGLYPH U006B;Lo;0;L;;;;;N;;;;;
1333B;EGYPTIAN HIEROGLYPH U007;Lo;0;L;;;;;N;;;;;
1333C;EGYPTIAN HIEROGLYPH U008;Lo;0;L;;;;;N;;;;;
1333D;EGYPTIAN HIEROGLYPH U009;Lo;0;L;;;;;N;;;;;
1333E;EGYPTIAN HIEROGLYPH U010;Lo;0;L;;;;;N;;;;;
1333F;EGYPTIAN HIEROGLYPH U011;Lo;0;L;;;;;N;;;;;
13340;EGYPTIAN HIEROGLYPH U012;Lo;0;L;;;;;N;;;;;
13341;EGYPTIAN HIEROGLYPH U013;Lo;0;L;;;;;N;;;;;
13342;EGYPTIAN HIEROGLYPH U014;Lo;0;L;;;;;N;;;;;
13343;EGYPTIAN HIEROGLYPH U015;Lo;0;L;;;;;N;;;;;
13344;EGYPTIAN HIEROGLYPH U016;Lo;0;L;;;;;N;;;;;
13345;EGYPTIAN HIEROGLYPH U017;Lo;0;L;;;;;N;;;;;
13346;EGYPTIAN HIEROGLYPH U018;Lo;0;L;;;;;N;;;;;
13347;EGYPTIAN HIEROGLYPH U019;Lo;0;L;;;;;N;;;;;
13348;EGYPTIAN HIEROGLYPH U020;Lo;0;L;;;;;N;;;;;
13349;EGYPTIAN HIEROGLYPH U021;Lo;0;L;;;;;N;;;;;
1334A;EGYPTIAN HIEROGLYPH U022;Lo;0;L;;;;;N;;;;;
1334B;EGYPTIAN HIEROGLYPH U023;Lo;0;L;;;;;N;;;;;
1334C;EGYPTIAN HIEROGLYPH U023A;Lo;0;L;;;;;N;;;;;
1334D;EGYPTIAN HIEROGLYPH U024;Lo;0;L;;;;;N;;;;;
1334E;EGYPTIAN HIEROGLYPH U025;Lo;0;L;;;;;N;;;;;
1334F;EGYPTIAN HIEROGLYPH U026;Lo;0;L;;;;;N;;;;;
13350;EGYPTIAN HIEROGLYPH U027;Lo;0;L;;;;;N;;;;;
13351;EGYPTIAN HIEROGLYPH U028;Lo;0;L;;;;;N;;;;;
13352;EGYPTIAN HIEROGLYPH U029;Lo;0;L;;;;;N;;;;;
13353;EGYPTIAN HIEROGLYPH U029A;Lo;0;L;;;;;N;;;;;
13354;EGYPTIAN HIEROGLYPH U030;Lo;0;L;;;;;N;;;;;
13355;EGYPTIAN HIEROGLYPH U031;Lo;0;L;;;;;N;;;;;
13356;EGYPTIAN HIEROGLYPH U032;Lo;0;L;;;;;N;;;;;
13357;EGYPTIAN HIEROGLYPH U032A;Lo;0;L;;;;;N;;;;;
13358;EGYPTIAN HIEROGLYPH U033;Lo;0;L;;;;;N;;;;;
13359;EGYPTIAN HIEROGLYPH U034;Lo;0;L;;;;;N;;;;;
1335A;EGYPTIAN HIEROGLYPH U035;Lo;0;L;;;;;N;;;;;
1335B;EGYPTIAN HIEROGLYPH U036;Lo;0;L;;;;;N;;;;;
1335C;EGYPTIAN HIEROGLYPH U037;Lo;0;L;;;;;N;;;;;
1335D;EGYPTIAN HIEROGLYPH U038;Lo;0;L;;;;;N;;;;;
1335E;EGYPTIAN HIEROGLYPH U039;Lo;0;L;;;;;N;;;;;
1335F;EGYPTIAN HIEROGLYPH U040;Lo;0;L;;;;;N;;;;;
13360;EGYPTIAN HIEROGLYPH U041;Lo;0;L;;;;;N;;;;;
13361;EGYPTIAN HIEROGLYPH U042;Lo;0;L;;;;;N;;;;;
13362;EGYPTIAN HIEROGLYPH V001;Lo;0;L;;;;;N;;;;;
13363;EGYPTIAN HIEROGLYPH V001A;Lo;0;L;;;;;N;;;;;
13364;EGYPTIAN HIEROGLYPH V001B;Lo;0;L;;;;;N;;;;;
13365;EGYPTIAN HIEROGLYPH V001C;Lo;0;L;;;;;N;;;;;
13366;EGYPTIAN HIEROGLYPH V001D;Lo;0;L;;;;;N;;;;;
13367;EGYPTIAN HIEROGLYPH V001E;Lo;0;L;;;;;N;;;;;
13368;EGYPTIAN HIEROGLYPH V001F;Lo;0;L;;;;;N;;;;;
13369;EGYPTIAN HIEROGLYPH V001G;Lo;0;L;;;;;N;;;;;
1336A;EGYPTIAN HIEROGLYPH V001H;Lo;0;L;;;;;N;;;;;
1336B;EGYPTIAN HIEROGLYPH V001I;Lo;0;L;;;;;N;;;;;
1336C;EGYPTIAN HIEROGLYPH V002;Lo;0;L;;;;;N;;;;;
1336D;EGYPTIAN HIEROGLYPH V002A;Lo;0;L;;;;;N;;;;;
1336E;EGYPTIAN HIEROGLYPH V003;Lo;0;L;;;;;N;;;;;
1336F;EGYPTIAN HIEROGLYPH V004;Lo;0;L;;;;;N;;;;;
13370;EGYPTIAN HIEROGLYPH V005;Lo;0;L;;;;;N;;;;;
13371;EGYPTIAN HIEROGLYPH V006;Lo;0;L;;;;;N;;;;;
13372;EGYPTIAN HIEROGLYPH V007;Lo;0;L;;;;;N;;;;;
13373;EGYPTIAN HIEROGLYPH V007A;Lo;0;L;;;;;N;;;;;
13374;EGYPTIAN HIEROGLYPH V007B;Lo;0;L;;;;;N;;;;;
13375;EGYPTIAN HIEROGLYPH V008;Lo;0;L;;;;;N;;;;;
13376;EGYPTIAN HIEROGLYPH V009;Lo;0;L;;;;;N;;;;;
13377;EGYPTIAN HIEROGLYPH V010;Lo;0;L;;;;;N;;;;;
13378;EGYPTIAN HIEROGLYPH V011;Lo;0;L;;;;;N;;;;;
13379;EGYPTIAN HIEROGLYPH V011A;Lo;0;L;;;;;N;;;;;
1337A;EGYPTIAN HIEROGLYPH V011B;Lo;0;L;;;;;N;;;;;
1337B;EGYPTIAN HIEROGLYPH V011C;Lo;0;L;;;;;N;;;;;
1337C;EGYPTIAN HIEROGLYPH V012;Lo;0;L;;;;;N;;;;;
1337D;EGYPTIAN HIEROGLYPH V012A;Lo;0;L;;;;;N;;;;;
1337E;EGYPTIAN HIEROGLYPH V012B;Lo;0;L;;;;;N;;;;;
1337F;EGYPTIAN HIEROGLYPH V013;Lo;0;L;;;;;N;;;;;
13380;EGYPTIAN HIEROGLYPH V014;Lo;0;L;;;;;N;;;;;
13381;EGYPTIAN HIEROGLYPH V015;Lo;0;L;;;;;N;;;;;
13382;EGYPTIAN HIEROGLYPH V016;Lo;0;L;;;;;N;;;;;
13383;EGYPTIAN HIEROGLYPH V017;Lo;0;L;;;;;N;;;;;
13384;EGYPTIAN HIEROGLYPH V018;Lo;0;L;;;;;N;;;;;
13385;EGYPTIAN HIEROGLYPH V019;Lo;0;L;;;;;N;;;;;
13386;EGYPTIAN HIEROGLYPH V020;Lo;0;L;;;;;N;;;;;
13387;EGYPTIAN HIEROGLYPH V020A;Lo;0;L;;;;;N;;;;;
13388;EGYPTIAN HIEROGLYPH V020B;Lo;0;L;;;;;N;;;;;
13389;EGYPTIAN HIEROGLYPH V020C;Lo;0;L;;;;;N;;;;;
1338A;EGYPTIAN HIEROGLYPH V020D;Lo;0;L;;;;;N;;;;;
1338B;EGYPTIAN HIEROGLYPH V020E;Lo;0;L;;;;;N;;;;;
1338C;EGYPTIAN HIEROGLYPH V020F;Lo;0;L;;;;;N;;;;;
1338D;EGYPTIAN HIEROGLYPH V020G;Lo;0;L;;;;;N;;;;;
1338E;EGYPTIAN HIEROGLYPH V020H;Lo;0;L;;;;;N;;;;;
1338F;EGYPTIAN HIEROGLYPH V020I;Lo;0;L;;;;;N;;;;;
13390;EGYPTIAN HIEROGLYPH V020J;Lo;0;L;;;;;N;;;;;
13391;EGYPTIAN HIEROGLYPH V020K;Lo;0;L;;;;;N;;;;;
13392;EGYPTIAN HIEROGLYPH V020L;Lo;0;L;;;;;N;;;;;
13393;EGYPTIAN HIEROGLYPH V021;Lo;0;L;;;;;N;;;;;
13394;EGYPTIAN HIEROGLYPH V022;Lo;0;L;;;;;N;;;;;
13395;EGYPTIAN HIEROGLYPH V023;Lo;0;L;;;;;N;;;;;
13396;EGYPTIAN HIEROGLYPH V023A;Lo;0;L;;;;;N;;;;;
13397;EGYPTIAN HIEROGLYPH V024;Lo;0;L;;;;;N;;;;;
13398;EGYPTIAN HIEROGLYPH V025;Lo;0;L;;;;;N;;;;;
13399;EGYPTIAN HIEROGLYPH V026;Lo;0;L;;;;;N;;;;;
1339A;EGYPTIAN HIEROGLYPH V027;Lo;0;L;;;;;N;;;;;
1339B;EGYPTIAN HIEROGLYPH V028;Lo;0;L;;;;;N;;;;;
1339C;EGYPTIAN HIEROGLYPH V028A;Lo;0;L;;;;;N;;;;;
1339D;EGYPTIAN HIEROGLYPH V029;Lo;0;L;;;;;N;;;;;
1339E;EGYPTIAN HIEROGLYPH V029A;Lo;0;L;;;;;N;;;;;
1339F;EGYPTIAN HIEROGLYPH V030;Lo;0;L;;;;;N;;;;;
133A0;EGYPTIAN HIEROGLYPH V030A;Lo;0;L;;;;;N;;;;;
133A1;EGYPTIAN HIEROGLYPH V031;Lo;0;L;;;;;N;;;;;
133A2;EGYPTIAN HIEROGLYPH V031A;Lo;0;L;;;;;N;;;;;
133A3;EGYPTIAN HIEROGLYPH V032;Lo;0;L;;;;;N;;;;;
133A4;EGYPTIAN HIEROGLYPH V033;Lo;0;L;;;;;N;;;;;
133A5;EGYPTIAN HIEROGLYPH V033A;Lo;0;L;;;;;N;;;;;
133A6;EGYPTIAN HIEROGLYPH V034;Lo;0;L;;;;;N;;;;;
133A7;EGYPTIAN HIEROGLYPH V035;Lo;0;L;;;;;N;;;;;
133A8;EGYPTIAN HIEROGLYPH V036;Lo;0;L;;;;;N;;;;;
133A9;EGYPTIAN HIEROGLYPH V037;Lo;0;L;;;;;N;;;;;
133AA;EGYPTIAN HIEROGLYPH V037A;Lo;0;L;;;;;N;;;;;
133AB;EGYPTIAN HIEROGLYPH V038;Lo;0;L;;;;;N;;;;;
133AC;EGYPTIAN HIEROGLYPH V039;Lo;0;L;;;;;N;;;;;
133AD;EGYPTIAN HIEROGLYPH V040;Lo;0;L;;;;;N;;;;;
133AE;EGYPTIAN HIEROGLYPH V040A;Lo;0;L;;;;;N;;;;;
133AF;EGYPTIAN HIEROGLYPH W001;Lo;0;L;;;;;N;;;;;
133B0;EGYPTIAN HIEROGLYPH W002;Lo;0;L;;;;;N;;;;;
133B1;EGYPTIAN HIEROGLYPH W003;Lo;0;L;;;;;N;;;;;
133B2;EGYPTIAN HIEROGLYPH W003A;Lo;0;L;;;;;N;;;;;
133B3;EGYPTIAN HIEROGLYPH W004;Lo;0;L;;;;;N;;;;;
133B4;EGYPTIAN HIEROGLYPH W005;Lo;0;L;;;;;N;;;;;
133B5;EGYPTIAN HIEROGLYPH W006;Lo;0;L;;;;;N;;;;;
133B6;EGYPTIAN HIEROGLYPH W007;Lo;0;L;;;;;N;;;;;
133B7;EGYPTIAN HIEROGLYPH W008;Lo;0;L;;;;;N;;;;;
133B8;EGYPTIAN HIEROGLYPH W009;Lo;0;L;;;;;N;;;;;
133B9;EGYPTIAN HIEROGLYPH W009A;Lo;0;L;;;;;N;;;;;
133BA;EGYPTIAN HIEROGLYPH W010;Lo;0;L;;;;;N;;;;;
133BB;EGYPTIAN HIEROGLYPH W010A;Lo;0;L;;;;;N;;;;;
133BC;EGYPTIAN HIEROGLYPH W011;Lo;0;L;;;;;N;;;;;
133BD;EGYPTIAN HIEROGLYPH W012;Lo;0;L;;;;;N;;;;;
133BE;EGYPTIAN HIEROGLYPH W013;Lo;0;L;;;;;N;;;;;
133BF;EGYPTIAN HIEROGLYPH W014;Lo;0;L;;;;;N;;;;;
133C0;EGYPTIAN HIEROGLYPH W014A;Lo;0;L;;;;;N;;;;;
133C1;EGYPTIAN HIEROGLYPH W015;Lo;0;L;;;;;N;;;;;
133C2;EGYPTIAN HIEROGLYPH W016;Lo;0;L;;;;;N;;;;;
133C3;EGYPTIAN HIEROGLYPH W017;Lo;0;L;;;;;N;;;;;
133C4;EGYPTIAN HIEROGLYPH W017A;Lo;0;L;;;;;N;;;;;
133C5;EGYPTIAN HIEROGLYPH W018;Lo;0;L;;;;;N;;;;;
133C6;EGYPTIAN HIEROGLYPH W018A;Lo;0;L;;;;;N;;;;;
133C7;EGYPTIAN HIEROGLYPH W019;Lo;0;L;;;;;N;;;;;
133C8;EGYPTIAN HIEROGLYPH W020;Lo;0;L;;;;;N;;;;;
133C9;EGYPTIAN HIEROGLYPH W021;Lo;0;L;;;;;N;;;;;
133CA;EGYPTIAN HIEROGLYPH W022;Lo;0;L;;;;;N;;;;;
133CB;EGYPTIAN HIEROGLYPH W023;Lo;0;L;;;;;N;;;;;
133CC;EGYPTIAN HIEROGLYPH W024;Lo;0;L;;;;;N;;;;;
133CD;EGYPTIAN HIEROGLYPH W024A;Lo;0;L;;;;;N;;;;;
133CE;EGYPTIAN HIEROGLYPH W025;Lo;0;L;;;;;N;;;;;
133CF;EGYPTIAN HIEROGLYPH X001;Lo;0;L;;;;;N;;;;;
133D0;EGYPTIAN HIEROGLYPH X002;Lo;0;L;;;;;N;;;;;
133D1;EGYPTIAN HIEROGLYPH X003;Lo;0;L;;;;;N;;;;;
133D2;EGYPTIAN HIEROGLYPH X004;Lo;0;L;;;;;N;;;;;
133D3;EGYPTIAN HIEROGLYPH X004A;Lo;0;L;;;;;N;;;;;
133D4;EGYPTIAN HIEROGLYPH X004B;Lo;0;L;;;;;N;;;;;
133D5;EGYPTIAN HIEROGLYPH X005;Lo;0;L;;;;;N;;;;;
133D6;EGYPTIAN HIEROGLYPH X006;Lo;0;L;;;;;N;;;;;
133D7;EGYPTIAN HIEROGLYPH X006A;Lo;0;L;;;;;N;;;;;
133D8;EGYPTIAN HIEROGLYPH X007;Lo;0;L;;;;;N;;;;;
133D9;EGYPTIAN HIEROGLYPH X008;Lo;0;L;;;;;N;;;;;
133DA;EGYPTIAN HIEROGLYPH X008A;Lo;0;L;;;;;N;;;;;
133DB;EGYPTIAN HIEROGLYPH Y001;Lo;0;L;;;;;N;;;;;
133DC;EGYPTIAN HIEROGLYPH Y001A;Lo;0;L;;;;;N;;;;;
133DD;EGYPTIAN HIEROGLYPH Y002;Lo;0;L;;;;;N;;;;;
133DE;EGYPTIAN HIEROGLYPH Y003;Lo;0;L;;;;;N;;;;;
133DF;EGYPTIAN HIEROGLYPH Y004;Lo;0;L;;;;;N;;;;;
133E0;EGYPTIAN HIEROGLYPH Y005;Lo;0;L;;;;;N;;;;;
133E1;EGYPTIAN HIEROGLYPH Y006;Lo;0;L;;;;;N;;;;;
133E2;EGYPTIAN HIEROGLYPH Y007;Lo;0;L;;;;;N;;;;;
133E3;EGYPTIAN HIEROGLYPH Y008;Lo;0;L;;;;;N;;;;;
133E4;EGYPTIAN HIEROGLYPH Z001;Lo;0;L;;;;;N;;;;;
133E5;EGYPTIAN HIEROGLYPH Z002;Lo;0;L;;;;;N;;;;;
133E6;EGYPTIAN HIEROGLYPH Z002A;Lo;0;L;;;;;N;;;;;
133E7;EGYPTIAN HIEROGLYPH Z002B;Lo;0;L;;;;;N;;;;;
133E8;EGYPTIAN HIEROGLYPH Z002C;Lo;0;L;;;;;N;;;;;
133E9;EGYPTIAN HIEROGLYPH Z002D;Lo;0;L;;;;;N;;;;;
133EA;EGYPTIAN HIEROGLYPH Z003;Lo;0;L;;;;;N;;;;;
133EB;EGYPTIAN HIEROGLYPH Z003A;Lo;0;L;;;;;N;;;;;
133EC;EGYPTIAN HIEROGLYPH Z003B;Lo;0;L;;;;;N;;;;;
133ED;EGYPTIAN HIEROGLYPH Z004;Lo;0;L;;;;;N;;;;;
133EE;EGYPTIAN HIEROGLYPH Z004A;Lo;0;L;;;;;N;;;;;
133EF;EGYPTIAN HIEROGLYPH Z005;Lo;0;L;;;;;N;;;;;
133F0;EGYPTIAN HIEROGLYPH Z005A;Lo;0;L;;;;;N;;;;;
133F1;EGYPTIAN HIEROGLYPH Z006;Lo;0;L;;;;;N;;;;;
133F2;EGYPTIAN HIEROGLYPH Z007;Lo;0;L;;;;;N;;;;;
133F3;EGYPTIAN HIEROGLYPH Z008;Lo;0;L;;;;;N;;;;;
133F4;EGYPTIAN HIEROGLYPH Z009;Lo;0;L;;;;;N;;;;;
133F5;EGYPTIAN HIEROGLYPH Z010;Lo;0;L;;;;;N;;;;;
133F6;EGYPTIAN HIEROGLYPH Z011;Lo;0;L;;;;;N;;;;;
133F7;EGYPTIAN HIEROGLYPH Z012;Lo;0;L;;;;;N;;;;;
133F8;EGYPTIAN HIEROGLYPH Z013;Lo;0;L;;;;;N;;;;;
133F9;EGYPTIAN HIEROGLYPH Z014;Lo;0;L;;;;;N;;;;;
133FA;EGYPTIAN HIEROGLYPH Z015;Lo;0;L;;;;;N;;;;;
133FB;EGYPTIAN HIEROGLYPH Z015A;Lo;0;L;;;;;N;;;;;
133FC;EGYPTIAN HIEROGLYPH Z015B;Lo;0;L;;;;;N;;;;;
133FD;EGYPTIAN HIEROGLYPH Z015C;Lo;0;L;;;;;N;;;;;
133FE;EGYPTIAN HIEROGLYPH Z015D;Lo;0;L;;;;;N;;;;;
133FF;EGYPTIAN HIEROGLYPH Z015E;Lo;0;L;;;;;N;;;;;
13400;EGYPTIAN HIEROGLYPH Z015F;Lo;0;L;;;;;N;;;;;
13401;EGYPTIAN HIEROGLYPH Z015G;Lo;0;L;;;;;N;;;;;
13402;EGYPTIAN HIEROGLYPH Z015H;Lo;0;L;;;;;N;;;;;
13403;EGYPTIAN HIEROGLYPH Z015I;Lo;0;L;;;;;N;;;;;
13404;EGYPTIAN HIEROGLYPH Z016;Lo;0;L;;;;;N;;;;;
13405;EGYPTIAN HIEROGLYPH Z016A;Lo;0;L;;;;;N;;;;;
13406;EGYPTIAN HIEROGLYPH Z016B;Lo;0;L;;;;;N;;;;;
13407;EGYPTIAN HIEROGLYPH Z016C;Lo;0;L;;;;;N;;;;;
13408;EGYPTIAN HIEROGLYPH Z016D;Lo;0;L;;;;;N;;;;;
13409;EGYPTIAN HIEROGLYPH Z016E;Lo;0;L;;;;;N;;;;;
1340A;EGYPTIAN HIEROGLYPH Z016F;Lo;0;L;;;;;N;;;;;
1340B;EGYPTIAN HIEROGLYPH Z016G;Lo;0;L;;;;;N;;;;;
1340C;EGYPTIAN HIEROGLYPH Z016H;Lo;0;L;;;;;N;;;;;
1340D;EGYPTIAN HIEROGLYPH AA001;Lo;0;L;;;;;N;;;;;
1340E;EGYPTIAN HIEROGLYPH AA002;Lo;0;L;;;;;N;;;;;
1340F;EGYPTIAN HIEROGLYPH AA003;Lo;0;L;;;;;N;;;;;
13410;EGYPTIAN HIEROGLYPH AA004;Lo;0;L;;;;;N;;;;;
13411;EGYPTIAN HIEROGLYPH AA005;Lo;0;L;;;;;N;;;;;
13412;EGYPTIAN HIEROGLYPH AA006;Lo;0;L;;;;;N;;;;;
13413;EGYPTIAN HIEROGLYPH AA007;Lo;0;L;;;;;N;;;;;
13414;EGYPTIAN HIEROGLYPH AA007A;Lo;0;L;;;;;N;;;;;
13415;EGYPTIAN HIEROGLYPH AA007B;Lo;0;L;;;;;N;;;;;
13416;EGYPTIAN HIEROGLYPH AA008;Lo;0;L;;;;;N;;;;;
13417;EGYPTIAN HIEROGLYPH AA009;Lo;0;L;;;;;N;;;;;
13418;EGYPTIAN HIEROGLYPH AA010;Lo;0;L;;;;;N;;;;;
13419;EGYPTIAN HIEROGLYPH AA011;Lo;0;L;;;;;N;;;;;
1341A;EGYPTIAN HIEROGLYPH AA012;Lo;0;L;;;;;N;;;;;
1341B;EGYPTIAN HIEROGLYPH AA013;Lo;0;L;;;;;N;;;;;
1341C;EGYPTIAN HIEROGLYPH AA014;Lo;0;L;;;;;N;;;;;
1341D;EGYPTIAN HIEROGLYPH AA015;Lo;0;L;;;;;N;;;;;
1341E;EGYPTIAN HIEROGLYPH AA016;Lo;0;L;;;;;N;;;;;
1341F;EGYPTIAN HIEROGLYPH AA017;Lo;0;L;;;;;N;;;;;
13420;EGYPTIAN HIEROGLYPH AA018;Lo;0;L;;;;;N;;;;;
13421;EGYPTIAN HIEROGLYPH AA019;Lo;0;L;;;;;N;;;;;
13422;EGYPTIAN HIEROGLYPH AA020;Lo;0;L;;;;;N;;;;;
13423;EGYPTIAN HIEROGLYPH AA021;Lo;0;L;;;;;N;;;;;
13424;EGYPTIAN HIEROGLYPH AA022;Lo;0;L;;;;;N;;;;;
13425;EGYPTIAN HIEROGLYPH AA023;Lo;0;L;;;;;N;;;;;
13426;EGYPTIAN HIEROGLYPH AA024;Lo;0;L;;;;;N;;;;;
13427;EGYPTIAN HIEROGLYPH AA025;Lo;0;L;;;;;N;;;;;
13428;EGYPTIAN HIEROGLYPH AA026;Lo;0;L;;;;;N;;;;;
13429;EGYPTIAN HIEROGLYPH AA027;Lo;0;L;;;;;N;;;;;
1342A;EGYPTIAN HIEROGLYPH AA028;Lo;0;L;;;;;N;;;;;
1342B;EGYPTIAN HIEROGLYPH AA029;Lo;0;L;;;;;N;;;;;
1342C;EGYPTIAN HIEROGLYPH AA030;Lo;0;L;;;;;N;;;;;
1342D;EGYPTIAN HIEROGLYPH AA031;Lo;0;L;;;;;N;;;;;
1342E;EGYPTIAN HIEROGLYPH AA032;Lo;0;L;;;;;N;;;;;
13430;EGYPTIAN HIEROGLYPH VERTICAL JOINER;Cf;0;L;;;;;N;;;;;
13431;EGYPTIAN HIEROGLYPH HORIZONTAL JOINER;Cf;0;L;;;;;N;;;;;
13432;EGYPTIAN HIEROGLYPH INSERT AT TOP START;Cf;0;L;;;;;N;;;;;
13433;EGYPTIAN HIEROGLYPH INSERT AT BOTTOM START;Cf;0;L;;;;;N;;;;;
13434;EGYPTIAN HIEROGLYPH INSERT AT TOP END;Cf;0;L;;;;;N;;;;;
13435;EGYPTIAN HIEROGLYPH INSERT AT BOTTOM END;Cf;0;L;;;;;N;;;;;
13436;EGYPTIAN HIEROGLYPH OVERLAY MIDDLE;Cf;0;L;;;;;N;;;;;
13437;EGYPTIAN HIEROGLYPH BEGIN SEGMENT;Cf;0;L;;;;;N;;;;;
13438;EGYPTIAN HIEROGLYPH END SEGMENT;Cf;0;L;;;;;N;;;;;
14400;ANATOLIAN HIEROGLYPH A001;Lo;0;L;;;;;N;;;;;
14401;ANATOLIAN HIEROGLYPH A002;Lo;0;L;;;;;N;;;;;
14402;ANATOLIAN HIEROGLYPH A003;Lo;0;L;;;;;N;;;;;
14403;ANATOLIAN HIEROGLYPH A004;Lo;0;L;;;;;N;;;;;
14404;ANATOLIAN HIEROGLYPH A005;Lo;0;L;;;;;N;;;;;
14405;ANATOLIAN HIEROGLYPH A006;Lo;0;L;;;;;N;;;;;
14406;ANATOLIAN HIEROGLYPH A007;Lo;0;L;;;;;N;;;;;
14407;ANATOLIAN HIEROGLYPH A008;Lo;0;L;;;;;N;;;;;
14408;ANATOLIAN HIEROGLYPH A009;Lo;0;L;;;;;N;;;;;
14409;ANATOLIAN HIEROGLYPH A010;Lo;0;L;;;;;N;;;;;
1440A;ANATOLIAN HIEROGLYPH A010A;Lo;0;L;;;;;N;;;;;
1440B;ANATOLIAN HIEROGLYPH A011;Lo;0;L;;;;;N;;;;;
1440C;ANATOLIAN HIEROGLYPH A012;Lo;0;L;;;;;N;;;;;
1440D;ANATOLIAN HIEROGLYPH A013;Lo;0;L;;;;;N;;;;;
1440E;ANATOLIAN HIEROGLYPH A014;Lo;0;L;;;;;N;;;;;
1440F;ANATOLIAN HIEROGLYPH A015;Lo;0;L;;;;;N;;;;;
14410;ANATOLIAN HIEROGLYPH A016;Lo;0;L;;;;;N;;;;;
14411;ANATOLIAN HIEROGLYPH A017;Lo;0;L;;;;;N;;;;;
14412;ANATOLIAN HIEROGLYPH A018;Lo;0;L;;;;;N;;;;;
14413;ANATOLIAN HIEROGLYPH A019;Lo;0;L;;;;;N;;;;;
14414;ANATOLIAN HIEROGLYPH A020;Lo;0;L;;;;;N;;;;;
14415;ANATOLIAN HIEROGLYPH A021;Lo;0;L;;;;;N;;;;;
14416;ANATOLIAN HIEROGLYPH A022;Lo;0;L;;;;;N;;;;;
14417;ANATOLIAN HIEROGLYPH A023;Lo;0;L;;;;;N;;;;;
14418;ANATOLIAN HIEROGLYPH A024;Lo;0;L;;;;;N;;;;;
14419;ANATOLIAN HIEROGLYPH A025;Lo;0;L;;;;;N;;;;;
1441A;ANATOLIAN HIEROGLYPH A026;Lo;0;L;;;;;N;;;;;
1441B;ANATOLIAN HIEROGLYPH A026A;Lo;0;L;;;;;N;;;;;
1441C;ANATOLIAN HIEROGLYPH A027;Lo;0;L;;;;;N;;;;;
1441D;ANATOLIAN HIEROGLYPH A028;Lo;0;L;;;;;N;;;;;
1441E;ANATOLIAN HIEROGLYPH A029;Lo;0;L;;;;;N;;;;;
1441F;ANATOLIAN HIEROGLYPH A030;Lo;0;L;;;;;N;;;;;
14420;ANATOLIAN HIEROGLYPH A031;Lo;0;L;;;;;N;;;;;
14421;ANATOLIAN HIEROGLYPH A032;Lo;0;L;;;;;N;;;;;
14422;ANATOLIAN HIEROGLYPH A033;Lo;0;L;;;;;N;;;;;
14423;ANATOLIAN HIEROGLYPH A034;Lo;0;L;;;;;N;;;;;
14424;ANATOLIAN HIEROGLYPH A035;Lo;0;L;;;;;N;;;;;
14425;ANATOLIAN HIEROGLYPH A036;Lo;0;L;;;;;N;;;;;
14426;ANATOLIAN HIEROGLYPH A037;Lo;0;L;;;;;N;;;;;
14427;ANATOLIAN HIEROGLYPH A038;Lo;0;L;;;;;N;;;;;
14428;ANATOLIAN HIEROGLYPH A039;Lo;0;L;;;;;N;;;;;
14429;ANATOLIAN HIEROGLYPH A039A;Lo;0;L;;;;;N;;;;;
1442A;ANATOLIAN HIEROGLYPH A040;Lo;0;L;;;;;N;;;;;
1442B;ANATOLIAN HIEROGLYPH A041;Lo;0;L;;;;;N;;;;;
1442C;ANATOLIAN HIEROGLYPH A041A;Lo;0;L;;;;;N;;;;;
1442D;ANATOLIAN HIEROGLYPH A042;Lo;0;L;;;;;N;;;;;
1442E;ANATOLIAN HIEROGLYPH A043;Lo;0;L;;;;;N;;;;;
1442F;ANATOLIAN HIEROGLYPH A044;Lo;0;L;;;;;N;;;;;
14430;ANATOLIAN HIEROGLYPH A045;Lo;0;L;;;;;N;;;;;
14431;ANATOLIAN HIEROGLYPH A045A;Lo;0;L;;;;;N;;;;;
14432;ANATOLIAN HIEROGLYPH A046;Lo;0;L;;;;;N;;;;;
14433;ANATOLIAN HIEROGLYPH A046A;Lo;0;L;;;;;N;;;;;
14434;ANATOLIAN HIEROGLYPH A046B;Lo;0;L;;;;;N;;;;;
14435;ANATOLIAN HIEROGLYPH A047;Lo;0;L;;;;;N;;;;;
14436;ANATOLIAN HIEROGLYPH A048;Lo;0;L;;;;;N;;;;;
14437;ANATOLIAN HIEROGLYPH A049;Lo;0;L;;;;;N;;;;;
14438;ANATOLIAN HIEROGLYPH A050;Lo;0;L;;;;;N;;;;;
14439;ANATOLIAN HIEROGLYPH A051;Lo;0;L;;;;;N;;;;;
1443A;ANATOLIAN HIEROGLYPH A052;Lo;0;L;;;;;N;;;;;
1443B;ANATOLIAN HIEROGLYPH A053;Lo;0;L;;;;;N;;;;;
1443C;ANATOLIAN HIEROGLYPH A054;Lo;0;L;;;;;N;;;;;
1443D;ANATOLIAN HIEROGLYPH A055;Lo;0;L;;;;;N;;;;;
1443E;ANATOLIAN HIEROGLYPH A056;Lo;0;L;;;;;N;;;;;
1443F;ANATOLIAN HIEROGLYPH A057;Lo;0;L;;;;;N;;;;;
14440;ANATOLIAN HIEROGLYPH A058;Lo;0;L;;;;;N;;;;;
14441;ANATOLIAN HIEROGLYPH A059;Lo;0;L;;;;;N;;;;;
14442;ANATOLIAN HIEROGLYPH A060;Lo;0;L;;;;;N;;;;;
14443;ANATOLIAN HIEROGLYPH A061;Lo;0;L;;;;;N;;;;;
14444;ANATOLIAN HIEROGLYPH A062;Lo;0;L;;;;;N;;;;;
14445;ANATOLIAN HIEROGLYPH A063;Lo;0;L;;;;;N;;;;;
14446;ANATOLIAN HIEROGLYPH A064;Lo;0;L;;;;;N;;;;;
14447;ANATOLIAN HIEROGLYPH A065;Lo;0;L;;;;;N;;;;;
14448;ANATOLIAN HIEROGLYPH A066;Lo;0;L;;;;;N;;;;;
14449;ANATOLIAN HIEROGLYPH A066A;Lo;0;L;;;;;N;;;;;
1444A;ANATOLIAN HIEROGLYPH A066B;Lo;0;L;;;;;N;;;;;
1444B;ANATOLIAN HIEROGLYPH A066C;Lo;0;L;;;;;N;;;;;
1444C;ANATOLIAN HIEROGLYPH A067;Lo;0;L;;;;;N;;;;;
1444D;ANATOLIAN HIEROGLYPH A068;Lo;0;L;;;;;N;;;;;
1444E;ANATOLIAN HIEROGLYPH A069;Lo;0;L;;;;;N;;;;;
1444F;ANATOLIAN HIEROGLYPH A070;Lo;0;L;;;;;N;;;;;
14450;ANATOLIAN HIEROGLYPH A071;Lo;0;L;;;;;N;;;;;
14451;ANATOLIAN HIEROGLYPH A072;Lo;0;L;;;;;N;;;;;
14452;ANATOLIAN HIEROGLYPH A073;Lo;0;L;;;;;N;;;;;
14453;ANATOLIAN HIEROGLYPH A074;Lo;0;L;;;;;N;;;;;
14454;ANATOLIAN HIEROGLYPH A075;Lo;0;L;;;;;N;;;;;
14455;ANATOLIAN HIEROGLYPH A076;Lo;0;L;;;;;N;;;;;
14456;ANATOLIAN HIEROGLYPH A077;Lo;0;L;;;;;N;;;;;
14457;ANATOLIAN HIEROGLYPH A078;Lo;0;L;;;;;N;;;;;
14458;ANATOLIAN HIEROGLYPH A079;Lo;0;L;;;;;N;;;;;
14459;ANATOLIAN HIEROGLYPH A080;Lo;0;L;;;;;N;;;;;
1445A;ANATOLIAN HIEROGLYPH A081;Lo;0;L;;;;;N;;;;;
1445B;ANATOLIAN HIEROGLYPH A082;Lo;0;L;;;;;N;;;;;
1445C;ANATOLIAN HIEROGLYPH A083;Lo;0;L;;;;;N;;;;;
1445D;ANATOLIAN HIEROGLYPH A084;Lo;0;L;;;;;N;;;;;
1445E;ANATOLIAN HIEROGLYPH A085;Lo;0;L;;;;;N;;;;;
1445F;ANATOLIAN HIEROGLYPH A086;Lo;0;L;;;;;N;;;;;
14460;ANATOLIAN HIEROGLYPH A087;Lo;0;L;;;;;N;;;;;
14461;ANATOLIAN HIEROGLYPH A088;Lo;0;L;;;;;N;;;;;
14462;ANATOLIAN HIEROGLYPH A089;Lo;0;L;;;;;N;;;;;
14463;ANATOLIAN HIEROGLYPH A090;Lo;0;L;;;;;N;;;;;
14464;ANATOLIAN HIEROGLYPH A091;Lo;0;L;;;;;N;;;;;
14465;ANATOLIAN HIEROGLYPH A092;Lo;0;L;;;;;N;;;;;
14466;ANATOLIAN HIEROGLYPH A093;Lo;0;L;;;;;N;;;;;
14467;ANATOLIAN HIEROGLYPH A094;Lo;0;L;;;;;N;;;;;
14468;ANATOLIAN HIEROGLYPH A095;Lo;0;L;;;;;N;;;;;
14469;ANATOLIAN HIEROGLYPH A096;Lo;0;L;;;;;N;;;;;
1446A;ANATOLIAN HIEROGLYPH A097;Lo;0;L;;;;;N;;;;;
1446B;ANATOLIAN HIEROGLYPH A097A;Lo;0;L;;;;;N;;;;;
1446C;ANATOLIAN HIEROGLYPH A098;Lo;0;L;;;;;N;;;;;
1446D;ANATOLIAN HIEROGLYPH A098A;Lo;0;L;;;;;N;;;;;
1446E;ANATOLIAN HIEROGLYPH A099;Lo;0;L;;;;;N;;;;;
1446F;ANATOLIAN HIEROGLYPH A100;Lo;0;L;;;;;N;;;;;
14470;ANATOLIAN HIEROGLYPH A100A;Lo;0;L;;;;;N;;;;;
14471;ANATOLIAN HIEROGLYPH A101;Lo;0;L;;;;;N;;;;;
14472;ANATOLIAN HIEROGLYPH A101A;Lo;0;L;;;;;N;;;;;
14473;ANATOLIAN HIEROGLYPH A102;Lo;0;L;;;;;N;;;;;
14474;ANATOLIAN HIEROGLYPH A102A;Lo;0;L;;;;;N;;;;;
14475;ANATOLIAN HIEROGLYPH A103;Lo;0;L;;;;;N;;;;;
14476;ANATOLIAN HIEROGLYPH A104;Lo;0;L;;;;;N;;;;;
14477;ANATOLIAN HIEROGLYPH A104A;Lo;0;L;;;;;N;;;;;
14478;ANATOLIAN HIEROGLYPH A104B;Lo;0;L;;;;;N;;;;;
14479;ANATOLIAN HIEROGLYPH A104C;Lo;0;L;;;;;N;;;;;
1447A;ANATOLIAN HIEROGLYPH A105;Lo;0;L;;;;;N;;;;;
1447B;ANATOLIAN HIEROGLYPH A105A;Lo;0;L;;;;;N;;;;;
1447C;ANATOLIAN HIEROGLYPH A105B;Lo;0;L;;;;;N;;;;;
1447D;ANATOLIAN HIEROGLYPH A106;Lo;0;L;;;;;N;;;;;
1447E;ANATOLIAN HIEROGLYPH A107;Lo;0;L;;;;;N;;;;;
1447F;ANATOLIAN HIEROGLYPH A107A;Lo;0;L;;;;;N;;;;;
14480;ANATOLIAN HIEROGLYPH A107B;Lo;0;L;;;;;N;;;;;
14481;ANATOLIAN HIEROGLYPH A107C;Lo;0;L;;;;;N;;;;;
14482;ANATOLIAN HIEROGLYPH A108;Lo;0;L;;;;;N;;;;;
14483;ANATOLIAN HIEROGLYPH A109;Lo;0;L;;;;;N;;;;;
14484;ANATOLIAN HIEROGLYPH A110;Lo;0;L;;;;;N;;;;;
14485;ANATOLIAN HIEROGLYPH A110A;Lo;0;L;;;;;N;;;;;
14486;ANATOLIAN HIEROGLYPH A110B;Lo;0;L;;;;;N;;;;;
14487;ANATOLIAN HIEROGLYPH A111;Lo;0;L;;;;;N;;;;;
14488;ANATOLIAN HIEROGLYPH A112;Lo;0;L;;;;;N;;;;;
14489;ANATOLIAN HIEROGLYPH A113;Lo;0;L;;;;;N;;;;;
1448A;ANATOLIAN HIEROGLYPH A114;Lo;0;L;;;;;N;;;;;
1448B;ANATOLIAN HIEROGLYPH A115;Lo;0;L;;;;;N;;;;;
1448C;ANATOLIAN HIEROGLYPH A115A;Lo;0;L;;;;;N;;;;;
1448D;ANATOLIAN HIEROGLYPH A116;Lo;0;L;;;;;N;;;;;
1448E;ANATOLIAN HIEROGLYPH A117;Lo;0;L;;;;;N;;;;;
1448F;ANATOLIAN HIEROGLYPH A118;Lo;0;L;;;;;N;;;;;
14490;ANATOLIAN HIEROGLYPH A119;Lo;0;L;;;;;N;;;;;
14491;ANATOLIAN HIEROGLYPH A120;Lo;0;L;;;;;N;;;;;
14492;ANATOLIAN HIEROGLYPH A121;Lo;0;L;;;;;N;;;;;
14493;ANATOLIAN HIEROGLYPH A122;Lo;0;L;;;;;N;;;;;
14494;ANATOLIAN HIEROGLYPH A123;Lo;0;L;;;;;N;;;;;
14495;ANATOLIAN HIEROGLYPH A124;Lo;0;L;;;;;N;;;;;
14496;ANATOLIAN HIEROGLYPH A125;Lo;0;L;;;;;N;;;;;
14497;ANATOLIAN HIEROGLYPH A125A;Lo;0;L;;;;;N;;;;;
14498;ANATOLIAN HIEROGLYPH A126;Lo;0;L;;;;;N;;;;;
14499;ANATOLIAN HIEROGLYPH A127;Lo;0;L;;;;;N;;;;;
1449A;ANATOLIAN HIEROGLYPH A128;Lo;0;L;;;;;N;;;;;
1449B;ANATOLIAN HIEROGLYPH A129;Lo;0;L;;;;;N;;;;;
1449C;ANATOLIAN HIEROGLYPH A130;Lo;0;L;;;;;N;;;;;
1449D;ANATOLIAN HIEROGLYPH A131;Lo;0;L;;;;;N;;;;;
1449E;ANATOLIAN HIEROGLYPH A132;Lo;0;L;;;;;N;;;;;
1449F;ANATOLIAN HIEROGLYPH A133;Lo;0;L;;;;;N;;;;;
144A0;ANATOLIAN HIEROGLYPH A134;Lo;0;L;;;;;N;;;;;
144A1;ANATOLIAN HIEROGLYPH A135;Lo;0;L;;;;;N;;;;;
144A2;ANATOLIAN HIEROGLYPH A135A;Lo;0;L;;;;;N;;;;;
144A3;ANATOLIAN HIEROGLYPH A136;Lo;0;L;;;;;N;;;;;
144A4;ANATOLIAN HIEROGLYPH A137;Lo;0;L;;;;;N;;;;;
144A5;ANATOLIAN HIEROGLYPH A138;Lo;0;L;;;;;N;;;;;
144A6;ANATOLIAN HIEROGLYPH A139;Lo;0;L;;;;;N;;;;;
144A7;ANATOLIAN HIEROGLYPH A140;Lo;0;L;;;;;N;;;;;
144A8;ANATOLIAN HIEROGLYPH A141;Lo;0;L;;;;;N;;;;;
144A9;ANATOLIAN HIEROGLYPH A142;Lo;0;L;;;;;N;;;;;
144AA;ANATOLIAN HIEROGLYPH A143;Lo;0;L;;;;;N;;;;;
144AB;ANATOLIAN HIEROGLYPH A144;Lo;0;L;;;;;N;;;;;
144AC;ANATOLIAN HIEROGLYPH A145;Lo;0;L;;;;;N;;;;;
144AD;ANATOLIAN HIEROGLYPH A146;Lo;0;L;;;;;N;;;;;
144AE;ANATOLIAN HIEROGLYPH A147;Lo;0;L;;;;;N;;;;;
144AF;ANATOLIAN HIEROGLYPH A148;Lo;0;L;;;;;N;;;;;
144B0;ANATOLIAN HIEROGLYPH A149;Lo;0;L;;;;;N;;;;;
144B1;ANATOLIAN HIEROGLYPH A150;Lo;0;L;;;;;N;;;;;
144B2;ANATOLIAN HIEROGLYPH A151;Lo;0;L;;;;;N;;;;;
144B3;ANATOLIAN HIEROGLYPH A152;Lo;0;L;;;;;N;;;;;
144B4;ANATOLIAN HIEROGLYPH A153;Lo;0;L;;;;;N;;;;;
144B5;ANATOLIAN HIEROGLYPH A154;Lo;0;L;;;;;N;;;;;
144B6;ANATOLIAN HIEROGLYPH A155;Lo;0;L;;;;;N;;;;;
144B7;ANATOLIAN HIEROGLYPH A156;Lo;0;L;;;;;N;;;;;
144B8;ANATOLIAN HIEROGLYPH A157;Lo;0;L;;;;;N;;;;;
144B9;ANATOLIAN HIEROGLYPH A158;Lo;0;L;;;;;N;;;;;
144BA;ANATOLIAN HIEROGLYPH A159;Lo;0;L;;;;;N;;;;;
144BB;ANATOLIAN HIEROGLYPH A160;Lo;0;L;;;;;N;;;;;
144BC;ANATOLIAN HIEROGLYPH A161;Lo;0;L;;;;;N;;;;;
144BD;ANATOLIAN HIEROGLYPH A162;Lo;0;L;;;;;N;;;;;
144BE;ANATOLIAN HIEROGLYPH A163;Lo;0;L;;;;;N;;;;;
144BF;ANATOLIAN HIEROGLYPH A164;Lo;0;L;;;;;N;;;;;
144C0;ANATOLIAN HIEROGLYPH A165;Lo;0;L;;;;;N;;;;;
144C1;ANATOLIAN HIEROGLYPH A166;Lo;0;L;;;;;N;;;;;
144C2;ANATOLIAN HIEROGLYPH A167;Lo;0;L;;;;;N;;;;;
144C3;ANATOLIAN HIEROGLYPH A168;Lo;0;L;;;;;N;;;;;
144C4;ANATOLIAN HIEROGLYPH A169;Lo;0;L;;;;;N;;;;;
144C5;ANATOLIAN HIEROGLYPH A170;Lo;0;L;;;;;N;;;;;
144C6;ANATOLIAN HIEROGLYPH A171;Lo;0;L;;;;;N;;;;;
144C7;ANATOLIAN HIEROGLYPH A172;Lo;0;L;;;;;N;;;;;
144C8;ANATOLIAN HIEROGLYPH A173;Lo;0;L;;;;;N;;;;;
144C9;ANATOLIAN HIEROGLYPH A174;Lo;0;L;;;;;N;;;;;
144CA;ANATOLIAN HIEROGLYPH A175;Lo;0;L;;;;;N;;;;;
144CB;ANATOLIAN HIEROGLYPH A176;Lo;0;L;;;;;N;;;;;
144CC;ANATOLIAN HIEROGLYPH A177;Lo;0;L;;;;;N;;;;;
144CD;ANATOLIAN HIEROGLYPH A178;Lo;0;L;;;;;N;;;;;
144CE;ANATOLIAN HIEROGLYPH A179;Lo;0;L;;;;;N;;;;;
144CF;ANATOLIAN HIEROGLYPH A180;Lo;0;L;;;;;N;;;;;
144D0;ANATOLIAN HIEROGLYPH A181;Lo;0;L;;;;;N;;;;;
144D1;ANATOLIAN HIEROGLYPH A182;Lo;0;L;;;;;N;;;;;
144D2;ANATOLIAN HIEROGLYPH A183;Lo;0;L;;;;;N;;;;;
144D3;ANATOLIAN HIEROGLYPH A184;Lo;0;L;;;;;N;;;;;
144D4;ANATOLIAN HIEROGLYPH A185;Lo;0;L;;;;;N;;;;;
144D5;ANATOLIAN HIEROGLYPH A186;Lo;0;L;;;;;N;;;;;
144D6;ANATOLIAN HIEROGLYPH A187;Lo;0;L;;;;;N;;;;;
144D7;ANATOLIAN HIEROGLYPH A188;Lo;0;L;;;;;N;;;;;
144D8;ANATOLIAN HIEROGLYPH A189;Lo;0;L;;;;;N;;;;;
144D9;ANATOLIAN HIEROGLYPH A190;Lo;0;L;;;;;N;;;;;
144DA;ANATOLIAN HIEROGLYPH A191;Lo;0;L;;;;;N;;;;;
144DB;ANATOLIAN HIEROGLYPH A192;Lo;0;L;;;;;N;;;;;
144DC;ANATOLIAN HIEROGLYPH A193;Lo;0;L;;;;;N;;;;;
144DD;ANATOLIAN HIEROGLYPH A194;Lo;0;L;;;;;N;;;;;
144DE;ANATOLIAN HIEROGLYPH A195;Lo;0;L;;;;;N;;;;;
144DF;ANATOLIAN HIEROGLYPH A196;Lo;0;L;;;;;N;;;;;
144E0;ANATOLIAN HIEROGLYPH A197;Lo;0;L;;;;;N;;;;;
144E1;ANATOLIAN HIEROGLYPH A198;Lo;0;L;;;;;N;;;;;
144E2;ANATOLIAN HIEROGLYPH A199;Lo;0;L;;;;;N;;;;;
144E3;ANATOLIAN HIEROGLYPH A200;Lo;0;L;;;;;N;;;;;
144E4;ANATOLIAN HIEROGLYPH A201;Lo;0;L;;;;;N;;;;;
144E5;ANATOLIAN HIEROGLYPH A202;Lo;0;L;;;;;N;;;;;
144E6;ANATOLIAN HIEROGLYPH A202A;Lo;0;L;;;;;N;;;;;
144E7;ANATOLIAN HIEROGLYPH A202B;Lo;0;L;;;;;N;;;;;
144E8;ANATOLIAN HIEROGLYPH A203;Lo;0;L;;;;;N;;;;;
144E9;ANATOLIAN HIEROGLYPH A204;Lo;0;L;;;;;N;;;;;
144EA;ANATOLIAN HIEROGLYPH A205;Lo;0;L;;;;;N;;;;;
144EB;ANATOLIAN HIEROGLYPH A206;Lo;0;L;;;;;N;;;;;
144EC;ANATOLIAN HIEROGLYPH A207;Lo;0;L;;;;;N;;;;;
144ED;ANATOLIAN HIEROGLYPH A207A;Lo;0;L;;;;;N;;;;;
144EE;ANATOLIAN HIEROGLYPH A208;Lo;0;L;;;;;N;;;;;
144EF;ANATOLIAN HIEROGLYPH A209;Lo;0;L;;;;;N;;;;;
144F0;ANATOLIAN HIEROGLYPH A209A;Lo;0;L;;;;;N;;;;;
144F1;ANATOLIAN HIEROGLYPH A210;Lo;0;L;;;;;N;;;;;
144F2;ANATOLIAN HIEROGLYPH A211;Lo;0;L;;;;;N;;;;;
144F3;ANATOLIAN HIEROGLYPH A212;Lo;0;L;;;;;N;;;;;
144F4;ANATOLIAN HIEROGLYPH A213;Lo;0;L;;;;;N;;;;;
144F5;ANATOLIAN HIEROGLYPH A214;Lo;0;L;;;;;N;;;;;
144F6;ANATOLIAN HIEROGLYPH A215;Lo;0;L;;;;;N;;;;;
144F7;ANATOLIAN HIEROGLYPH A215A;Lo;0;L;;;;;N;;;;;
144F8;ANATOLIAN HIEROGLYPH A216;Lo;0;L;;;;;N;;;;;
144F9;ANATOLIAN HIEROGLYPH A216A;Lo;0;L;;;;;N;;;;;
144FA;ANATOLIAN HIEROGLYPH A217;Lo;0;L;;;;;N;;;;;
144FB;ANATOLIAN HIEROGLYPH A218;Lo;0;L;;;;;N;;;;;
144FC;ANATOLIAN HIEROGLYPH A219;Lo;0;L;;;;;N;;;;;
144FD;ANATOLIAN HIEROGLYPH A220;Lo;0;L;;;;;N;;;;;
144FE;ANATOLIAN HIEROGLYPH A221;Lo;0;L;;;;;N;;;;;
144FF;ANATOLIAN HIEROGLYPH A222;Lo;0;L;;;;;N;;;;;
14500;ANATOLIAN HIEROGLYPH A223;Lo;0;L;;;;;N;;;;;
14501;ANATOLIAN HIEROGLYPH A224;Lo;0;L;;;;;N;;;;;
14502;ANATOLIAN HIEROGLYPH A225;Lo;0;L;;;;;N;;;;;
14503;ANATOLIAN HIEROGLYPH A226;Lo;0;L;;;;;N;;;;;
14504;ANATOLIAN HIEROGLYPH A227;Lo;0;L;;;;;N;;;;;
14505;ANATOLIAN HIEROGLYPH A227A;Lo;0;L;;;;;N;;;;;
14506;ANATOLIAN HIEROGLYPH A228;Lo;0;L;;;;;N;;;;;
14507;ANATOLIAN HIEROGLYPH A229;Lo;0;L;;;;;N;;;;;
14508;ANATOLIAN HIEROGLYPH A230;Lo;0;L;;;;;N;;;;;
14509;ANATOLIAN HIEROGLYPH A231;Lo;0;L;;;;;N;;;;;
1450A;ANATOLIAN HIEROGLYPH A232;Lo;0;L;;;;;N;;;;;
1450B;ANATOLIAN HIEROGLYPH A233;Lo;0;L;;;;;N;;;;;
1450C;ANATOLIAN HIEROGLYPH A234;Lo;0;L;;;;;N;;;;;
1450D;ANATOLIAN HIEROGLYPH A235;Lo;0;L;;;;;N;;;;;
1450E;ANATOLIAN HIEROGLYPH A236;Lo;0;L;;;;;N;;;;;
1450F;ANATOLIAN HIEROGLYPH A237;Lo;0;L;;;;;N;;;;;
14510;ANATOLIAN HIEROGLYPH A238;Lo;0;L;;;;;N;;;;;
14511;ANATOLIAN HIEROGLYPH A239;Lo;0;L;;;;;N;;;;;
14512;ANATOLIAN HIEROGLYPH A240;Lo;0;L;;;;;N;;;;;
14513;ANATOLIAN HIEROGLYPH A241;Lo;0;L;;;;;N;;;;;
14514;ANATOLIAN HIEROGLYPH A242;Lo;0;L;;;;;N;;;;;
14515;ANATOLIAN HIEROGLYPH A243;Lo;0;L;;;;;N;;;;;
14516;ANATOLIAN HIEROGLYPH A244;Lo;0;L;;;;;N;;;;;
14517;ANATOLIAN HIEROGLYPH A245;Lo;0;L;;;;;N;;;;;
14518;ANATOLIAN HIEROGLYPH A246;Lo;0;L;;;;;N;;;;;
14519;ANATOLIAN HIEROGLYPH A247;Lo;0;L;;;;;N;;;;;
1451A;ANATOLIAN HIEROGLYPH A248;Lo;0;L;;;;;N;;;;;
1451B;ANATOLIAN HIEROGLYPH A249;Lo;0;L;;;;;N;;;;;
1451C;ANATOLIAN HIEROGLYPH A250;Lo;0;L;;;;;N;;;;;
1451D;ANATOLIAN HIEROGLYPH A251;Lo;0;L;;;;;N;;;;;
1451E;ANATOLIAN HIEROGLYPH A252;Lo;0;L;;;;;N;;;;;
1451F;ANATOLIAN HIEROGLYPH A253;Lo;0;L;;;;;N;;;;;
14520;ANATOLIAN HIEROGLYPH A254;Lo;0;L;;;;;N;;;;;
14521;ANATOLIAN HIEROGLYPH A255;Lo;0;L;;;;;N;;;;;
14522;ANATOLIAN HIEROGLYPH A256;Lo;0;L;;;;;N;;;;;
14523;ANATOLIAN HIEROGLYPH A257;Lo;0;L;;;;;N;;;;;
14524;ANATOLIAN HIEROGLYPH A258;Lo;0;L;;;;;N;;;;;
14525;ANATOLIAN HIEROGLYPH A259;Lo;0;L;;;;;N;;;;;
14526;ANATOLIAN HIEROGLYPH A260;Lo;0;L;;;;;N;;;;;
14527;ANATOLIAN HIEROGLYPH A261;Lo;0;L;;;;;N;;;;;
14528;ANATOLIAN HIEROGLYPH A262;Lo;0;L;;;;;N;;;;;
14529;ANATOLIAN HIEROGLYPH A263;Lo;0;L;;;;;N;;;;;
1452A;ANATOLIAN HIEROGLYPH A264;Lo;0;L;;;;;N;;;;;
1452B;ANATOLIAN HIEROGLYPH A265;Lo;0;L;;;;;N;;;;;
1452C;ANATOLIAN HIEROGLYPH A266;Lo;0;L;;;;;N;;;;;
1452D;ANATOLIAN HIEROGLYPH A267;Lo;0;L;;;;;N;;;;;
1452E;ANATOLIAN HIEROGLYPH A267A;Lo;0;L;;;;;N;;;;;
1452F;ANATOLIAN HIEROGLYPH A268;Lo;0;L;;;;;N;;;;;
14530;ANATOLIAN HIEROGLYPH A269;Lo;0;L;;;;;N;;;;;
14531;ANATOLIAN HIEROGLYPH A270;Lo;0;L;;;;;N;;;;;
14532;ANATOLIAN HIEROGLYPH A271;Lo;0;L;;;;;N;;;;;
14533;ANATOLIAN HIEROGLYPH A272;Lo;0;L;;;;;N;;;;;
14534;ANATOLIAN HIEROGLYPH A273;Lo;0;L;;;;;N;;;;;
14535;ANATOLIAN HIEROGLYPH A274;Lo;0;L;;;;;N;;;;;
14536;ANATOLIAN HIEROGLYPH A275;Lo;0;L;;;;;N;;;;;
14537;ANATOLIAN HIEROGLYPH A276;Lo;0;L;;;;;N;;;;;
14538;ANATOLIAN HIEROGLYPH A277;Lo;0;L;;;;;N;;;;;
14539;ANATOLIAN HIEROGLYPH A278;Lo;0;L;;;;;N;;;;;
1453A;ANATOLIAN HIEROGLYPH A279;Lo;0;L;;;;;N;;;;;
1453B;ANATOLIAN HIEROGLYPH A280;Lo;0;L;;;;;N;;;;;
1453C;ANATOLIAN HIEROGLYPH A281;Lo;0;L;;;;;N;;;;;
1453D;ANATOLIAN HIEROGLYPH A282;Lo;0;L;;;;;N;;;;;
1453E;ANATOLIAN HIEROGLYPH A283;Lo;0;L;;;;;N;;;;;
1453F;ANATOLIAN HIEROGLYPH A284;Lo;0;L;;;;;N;;;;;
14540;ANATOLIAN HIEROGLYPH A285;Lo;0;L;;;;;N;;;;;
14541;ANATOLIAN HIEROGLYPH A286;Lo;0;L;;;;;N;;;;;
14542;ANATOLIAN HIEROGLYPH A287;Lo;0;L;;;;;N;;;;;
14543;ANATOLIAN HIEROGLYPH A288;Lo;0;L;;;;;N;;;;;
14544;ANATOLIAN HIEROGLYPH A289;Lo;0;L;;;;;N;;;;;
14545;ANATOLIAN HIEROGLYPH A289A;Lo;0;L;;;;;N;;;;;
14546;ANATOLIAN HIEROGLYPH A290;Lo;0;L;;;;;N;;;;;
14547;ANATOLIAN HIEROGLYPH A291;Lo;0;L;;;;;N;;;;;
14548;ANATOLIAN HIEROGLYPH A292;Lo;0;L;;;;;N;;;;;
14549;ANATOLIAN HIEROGLYPH A293;Lo;0;L;;;;;N;;;;;
1454A;ANATOLIAN HIEROGLYPH A294;Lo;0;L;;;;;N;;;;;
1454B;ANATOLIAN HIEROGLYPH A294A;Lo;0;L;;;;;N;;;;;
1454C;ANATOLIAN HIEROGLYPH A295;Lo;0;L;;;;;N;;;;;
1454D;ANATOLIAN HIEROGLYPH A296;Lo;0;L;;;;;N;;;;;
1454E;ANATOLIAN HIEROGLYPH A297;Lo;0;L;;;;;N;;;;;
1454F;ANATOLIAN HIEROGLYPH A298;Lo;0;L;;;;;N;;;;;
14550;ANATOLIAN HIEROGLYPH A299;Lo;0;L;;;;;N;;;;;
14551;ANATOLIAN HIEROGLYPH A299A;Lo;0;L;;;;;N;;;;;
14552;ANATOLIAN HIEROGLYPH A300;Lo;0;L;;;;;N;;;;;
14553;ANATOLIAN HIEROGLYPH A301;Lo;0;L;;;;;N;;;;;
14554;ANATOLIAN HIEROGLYPH A302;Lo;0;L;;;;;N;;;;;
14555;ANATOLIAN HIEROGLYPH A303;Lo;0;L;;;;;N;;;;;
14556;ANATOLIAN HIEROGLYPH A304;Lo;0;L;;;;;N;;;;;
14557;ANATOLIAN HIEROGLYPH A305;Lo;0;L;;;;;N;;;;;
14558;ANATOLIAN HIEROGLYPH A306;Lo;0;L;;;;;N;;;;;
14559;ANATOLIAN HIEROGLYPH A307;Lo;0;L;;;;;N;;;;;
1455A;ANATOLIAN HIEROGLYPH A308;Lo;0;L;;;;;N;;;;;
1455B;ANATOLIAN HIEROGLYPH A309;Lo;0;L;;;;;N;;;;;
1455C;ANATOLIAN HIEROGLYPH A309A;Lo;0;L;;;;;N;;;;;
1455D;ANATOLIAN HIEROGLYPH A310;Lo;0;L;;;;;N;;;;;
1455E;ANATOLIAN HIEROGLYPH A311;Lo;0;L;;;;;N;;;;;
1455F;ANATOLIAN HIEROGLYPH A312;Lo;0;L;;;;;N;;;;;
14560;ANATOLIAN HIEROGLYPH A313;Lo;0;L;;;;;N;;;;;
14561;ANATOLIAN HIEROGLYPH A314;Lo;0;L;;;;;N;;;;;
14562;ANATOLIAN HIEROGLYPH A315;Lo;0;L;;;;;N;;;;;
14563;ANATOLIAN HIEROGLYPH A316;Lo;0;L;;;;;N;;;;;
14564;ANATOLIAN HIEROGLYPH A317;Lo;0;L;;;;;N;;;;;
14565;ANATOLIAN HIEROGLYPH A318;Lo;0;L;;;;;N;;;;;
14566;ANATOLIAN HIEROGLYPH A319;Lo;0;L;;;;;N;;;;;
14567;ANATOLIAN HIEROGLYPH A320;Lo;0;L;;;;;N;;;;;
14568;ANATOLIAN HIEROGLYPH A321;Lo;0;L;;;;;N;;;;;
14569;ANATOLIAN HIEROGLYPH A322;Lo;0;L;;;;;N;;;;;
1456A;ANATOLIAN HIEROGLYPH A323;Lo;0;L;;;;;N;;;;;
1456B;ANATOLIAN HIEROGLYPH A324;Lo;0;L;;;;;N;;;;;
1456C;ANATOLIAN HIEROGLYPH A325;Lo;0;L;;;;;N;;;;;
1456D;ANATOLIAN HIEROGLYPH A326;Lo;0;L;;;;;N;;;;;
1456E;ANATOLIAN HIEROGLYPH A327;Lo;0;L;;;;;N;;;;;
1456F;ANATOLIAN HIEROGLYPH A328;Lo;0;L;;;;;N;;;;;
14570;ANATOLIAN HIEROGLYPH A329;Lo;0;L;;;;;N;;;;;
14571;ANATOLIAN HIEROGLYPH A329A;Lo;0;L;;;;;N;;;;;
14572;ANATOLIAN HIEROGLYPH A330;Lo;0;L;;;;;N;;;;;
14573;ANATOLIAN HIEROGLYPH A331;Lo;0;L;;;;;N;;;;;
14574;ANATOLIAN HIEROGLYPH A332A;Lo;0;L;;;;;N;;;;;
14575;ANATOLIAN HIEROGLYPH A332B;Lo;0;L;;;;;N;;;;;
14576;ANATOLIAN HIEROGLYPH A332C;Lo;0;L;;;;;N;;;;;
14577;ANATOLIAN HIEROGLYPH A333;Lo;0;L;;;;;N;;;;;
14578;ANATOLIAN HIEROGLYPH A334;Lo;0;L;;;;;N;;;;;
14579;ANATOLIAN HIEROGLYPH A335;Lo;0;L;;;;;N;;;;;
1457A;ANATOLIAN HIEROGLYPH A336;Lo;0;L;;;;;N;;;;;
1457B;ANATOLIAN HIEROGLYPH A336A;Lo;0;L;;;;;N;;;;;
1457C;ANATOLIAN HIEROGLYPH A336B;Lo;0;L;;;;;N;;;;;
1457D;ANATOLIAN HIEROGLYPH A336C;Lo;0;L;;;;;N;;;;;
1457E;ANATOLIAN HIEROGLYPH A337;Lo;0;L;;;;;N;;;;;
1457F;ANATOLIAN HIEROGLYPH A338;Lo;0;L;;;;;N;;;;;
14580;ANATOLIAN HIEROGLYPH A339;Lo;0;L;;;;;N;;;;;
14581;ANATOLIAN HIEROGLYPH A340;Lo;0;L;;;;;N;;;;;
14582;ANATOLIAN HIEROGLYPH A341;Lo;0;L;;;;;N;;;;;
14583;ANATOLIAN HIEROGLYPH A342;Lo;0;L;;;;;N;;;;;
14584;ANATOLIAN HIEROGLYPH A343;Lo;0;L;;;;;N;;;;;
14585;ANATOLIAN HIEROGLYPH A344;Lo;0;L;;;;;N;;;;;
14586;ANATOLIAN HIEROGLYPH A345;Lo;0;L;;;;;N;;;;;
14587;ANATOLIAN HIEROGLYPH A346;Lo;0;L;;;;;N;;;;;
14588;ANATOLIAN HIEROGLYPH A347;Lo;0;L;;;;;N;;;;;
14589;ANATOLIAN HIEROGLYPH A348;Lo;0;L;;;;;N;;;;;
1458A;ANATOLIAN HIEROGLYPH A349;Lo;0;L;;;;;N;;;;;
1458B;ANATOLIAN HIEROGLYPH A350;Lo;0;L;;;;;N;;;;;
1458C;ANATOLIAN HIEROGLYPH A351;Lo;0;L;;;;;N;;;;;
1458D;ANATOLIAN HIEROGLYPH A352;Lo;0;L;;;;;N;;;;;
1458E;ANATOLIAN HIEROGLYPH A353;Lo;0;L;;;;;N;;;;;
1458F;ANATOLIAN HIEROGLYPH A354;Lo;0;L;;;;;N;;;;;
14590;ANATOLIAN HIEROGLYPH A355;Lo;0;L;;;;;N;;;;;
14591;ANATOLIAN HIEROGLYPH A356;Lo;0;L;;;;;N;;;;;
14592;ANATOLIAN HIEROGLYPH A357;Lo;0;L;;;;;N;;;;;
14593;ANATOLIAN HIEROGLYPH A358;Lo;0;L;;;;;N;;;;;
14594;ANATOLIAN HIEROGLYPH A359;Lo;0;L;;;;;N;;;;;
14595;ANATOLIAN HIEROGLYPH A359A;Lo;0;L;;;;;N;;;;;
14596;ANATOLIAN HIEROGLYPH A360;Lo;0;L;;;;;N;;;;;
14597;ANATOLIAN HIEROGLYPH A361;Lo;0;L;;;;;N;;;;;
14598;ANATOLIAN HIEROGLYPH A362;Lo;0;L;;;;;N;;;;;
14599;ANATOLIAN HIEROGLYPH A363;Lo;0;L;;;;;N;;;;;
1459A;ANATOLIAN HIEROGLYPH A364;Lo;0;L;;;;;N;;;;;
1459B;ANATOLIAN HIEROGLYPH A364A;Lo;0;L;;;;;N;;;;;
1459C;ANATOLIAN HIEROGLYPH A365;Lo;0;L;;;;;N;;;;;
1459D;ANATOLIAN HIEROGLYPH A366;Lo;0;L;;;;;N;;;;;
1459E;ANATOLIAN HIEROGLYPH A367;Lo;0;L;;;;;N;;;;;
1459F;ANATOLIAN HIEROGLYPH A368;Lo;0;L;;;;;N;;;;;
145A0;ANATOLIAN HIEROGLYPH A368A;Lo;0;L;;;;;N;;;;;
145A1;ANATOLIAN HIEROGLYPH A369;Lo;0;L;;;;;N;;;;;
145A2;ANATOLIAN HIEROGLYPH A370;Lo;0;L;;;;;N;;;;;
145A3;ANATOLIAN HIEROGLYPH A371;Lo;0;L;;;;;N;;;;;
145A4;ANATOLIAN HIEROGLYPH A371A;Lo;0;L;;;;;N;;;;;
145A5;ANATOLIAN HIEROGLYPH A372;Lo;0;L;;;;;N;;;;;
145A6;ANATOLIAN HIEROGLYPH A373;Lo;0;L;;;;;N;;;;;
145A7;ANATOLIAN HIEROGLYPH A374;Lo;0;L;;;;;N;;;;;
145A8;ANATOLIAN HIEROGLYPH A375;Lo;0;L;;;;;N;;;;;
145A9;ANATOLIAN HIEROGLYPH A376;Lo;0;L;;;;;N;;;;;
145AA;ANATOLIAN HIEROGLYPH A377;Lo;0;L;;;;;N;;;;;
145AB;ANATOLIAN HIEROGLYPH A378;Lo;0;L;;;;;N;;;;;
145AC;ANATOLIAN HIEROGLYPH A379;Lo;0;L;;;;;N;;;;;
145AD;ANATOLIAN HIEROGLYPH A380;Lo;0;L;;;;;N;;;;;
145AE;ANATOLIAN HIEROGLYPH A381;Lo;0;L;;;;;N;;;;;
145AF;ANATOLIAN HIEROGLYPH A381A;Lo;0;L;;;;;N;;;;;
145B0;ANATOLIAN HIEROGLYPH A382;Lo;0;L;;;;;N;;;;;
145B1;ANATOLIAN HIEROGLYPH A383 RA OR RI;Lo;0;L;;;;;N;;;;;
145B2;ANATOLIAN HIEROGLYPH A383A;Lo;0;L;;;;;N;;;;;
145B3;ANATOLIAN HIEROGLYPH A384;Lo;0;L;;;;;N;;;;;
145B4;ANATOLIAN HIEROGLYPH A385;Lo;0;L;;;;;N;;;;;
145B5;ANATOLIAN HIEROGLYPH A386;Lo;0;L;;;;;N;;;;;
145B6;ANATOLIAN HIEROGLYPH A386A;Lo;0;L;;;;;N;;;;;
145B7;ANATOLIAN HIEROGLYPH A387;Lo;0;L;;;;;N;;;;;
145B8;ANATOLIAN HIEROGLYPH A388;Lo;0;L;;;;;N;;;;;
145B9;ANATOLIAN HIEROGLYPH A389;Lo;0;L;;;;;N;;;;;
145BA;ANATOLIAN HIEROGLYPH A390;Lo;0;L;;;;;N;;;;;
145BB;ANATOLIAN HIEROGLYPH A391;Lo;0;L;;;;;N;;;;;
145BC;ANATOLIAN HIEROGLYPH A392;Lo;0;L;;;;;N;;;;;
145BD;ANATOLIAN HIEROGLYPH A393 EIGHT;Lo;0;L;;;;;N;;;;;
145BE;ANATOLIAN HIEROGLYPH A394;Lo;0;L;;;;;N;;;;;
145BF;ANATOLIAN HIEROGLYPH A395;Lo;0;L;;;;;N;;;;;
145C0;ANATOLIAN HIEROGLYPH A396;Lo;0;L;;;;;N;;;;;
145C1;ANATOLIAN HIEROGLYPH A397;Lo;0;L;;;;;N;;;;;
145C2;ANATOLIAN HIEROGLYPH A398;Lo;0;L;;;;;N;;;;;
145C3;ANATOLIAN HIEROGLYPH A399;Lo;0;L;;;;;N;;;;;
145C4;ANATOLIAN HIEROGLYPH A400;Lo;0;L;;;;;N;;;;;
145C5;ANATOLIAN HIEROGLYPH A401;Lo;0;L;;;;;N;;;;;
145C6;ANATOLIAN HIEROGLYPH A402;Lo;0;L;;;;;N;;;;;
145C7;ANATOLIAN HIEROGLYPH A403;Lo;0;L;;;;;N;;;;;
145C8;ANATOLIAN HIEROGLYPH A404;Lo;0;L;;;;;N;;;;;
145C9;ANATOLIAN HIEROGLYPH A405;Lo;0;L;;;;;N;;;;;
145CA;ANATOLIAN HIEROGLYPH A406;Lo;0;L;;;;;N;;;;;
145CB;ANATOLIAN HIEROGLYPH A407;Lo;0;L;;;;;N;;;;;
145CC;ANATOLIAN HIEROGLYPH A408;Lo;0;L;;;;;N;;;;;
145CD;ANATOLIAN HIEROGLYPH A409;Lo;0;L;;;;;N;;;;;
145CE;ANATOLIAN HIEROGLYPH A410 BEGIN LOGOGRAM MARK;Lo;0;L;;;;;N;;;;;
145CF;ANATOLIAN HIEROGLYPH A410A END LOGOGRAM MARK;Lo;0;L;;;;;N;;;;;
145D0;ANATOLIAN HIEROGLYPH A411;Lo;0;L;;;;;N;;;;;
145D1;ANATOLIAN HIEROGLYPH A412;Lo;0;L;;;;;N;;;;;
145D2;ANATOLIAN HIEROGLYPH A413;Lo;0;L;;;;;N;;;;;
145D3;ANATOLIAN HIEROGLYPH A414;Lo;0;L;;;;;N;;;;;
145D4;ANATOLIAN HIEROGLYPH A415;Lo;0;L;;;;;N;;;;;
145D5;ANATOLIAN HIEROGLYPH A416;Lo;0;L;;;;;N;;;;;
145D6;ANATOLIAN HIEROGLYPH A417;Lo;0;L;;;;;N;;;;;
145D7;ANATOLIAN HIEROGLYPH A418;Lo;0;L;;;;;N;;;;;
145D8;ANATOLIAN HIEROGLYPH A419;Lo;0;L;;;;;N;;;;;
145D9;ANATOLIAN HIEROGLYPH A420;Lo;0;L;;;;;N;;;;;
145DA;ANATOLIAN HIEROGLYPH A421;Lo;0;L;;;;;N;;;;;
145DB;ANATOLIAN HIEROGLYPH A422;Lo;0;L;;;;;N;;;;;
145DC;ANATOLIAN HIEROGLYPH A423;Lo;0;L;;;;;N;;;;;
145DD;ANATOLIAN HIEROGLYPH A424;Lo;0;L;;;;;N;;;;;
145DE;ANATOLIAN HIEROGLYPH A425;Lo;0;L;;;;;N;;;;;
145DF;ANATOLIAN HIEROGLYPH A426;Lo;0;L;;;;;N;;;;;
145E0;ANATOLIAN HIEROGLYPH A427;Lo;0;L;;;;;N;;;;;
145E1;ANATOLIAN HIEROGLYPH A428;Lo;0;L;;;;;N;;;;;
145E2;ANATOLIAN HIEROGLYPH A429;Lo;0;L;;;;;N;;;;;
145E3;ANATOLIAN HIEROGLYPH A430;Lo;0;L;;;;;N;;;;;
145E4;ANATOLIAN HIEROGLYPH A431;Lo;0;L;;;;;N;;;;;
145E5;ANATOLIAN HIEROGLYPH A432;Lo;0;L;;;;;N;;;;;
145E6;ANATOLIAN HIEROGLYPH A433;Lo;0;L;;;;;N;;;;;
145E7;ANATOLIAN HIEROGLYPH A434;Lo;0;L;;;;;N;;;;;
145E8;ANATOLIAN HIEROGLYPH A435;Lo;0;L;;;;;N;;;;;
145E9;ANATOLIAN HIEROGLYPH A436;Lo;0;L;;;;;N;;;;;
145EA;ANATOLIAN HIEROGLYPH A437;Lo;0;L;;;;;N;;;;;
145EB;ANATOLIAN HIEROGLYPH A438;Lo;0;L;;;;;N;;;;;
145EC;ANATOLIAN HIEROGLYPH A439;Lo;0;L;;;;;N;;;;;
145ED;ANATOLIAN HIEROGLYPH A440;Lo;0;L;;;;;N;;;;;
145EE;ANATOLIAN HIEROGLYPH A441;Lo;0;L;;;;;N;;;;;
145EF;ANATOLIAN HIEROGLYPH A442;Lo;0;L;;;;;N;;;;;
145F0;ANATOLIAN HIEROGLYPH A443;Lo;0;L;;;;;N;;;;;
145F1;ANATOLIAN HIEROGLYPH A444;Lo;0;L;;;;;N;;;;;
145F2;ANATOLIAN HIEROGLYPH A445;Lo;0;L;;;;;N;;;;;
145F3;ANATOLIAN HIEROGLYPH A446;Lo;0;L;;;;;N;;;;;
145F4;ANATOLIAN HIEROGLYPH A447;Lo;0;L;;;;;N;;;;;
145F5;ANATOLIAN HIEROGLYPH A448;Lo;0;L;;;;;N;;;;;
145F6;ANATOLIAN HIEROGLYPH A449;Lo;0;L;;;;;N;;;;;
145F7;ANATOLIAN HIEROGLYPH A450;Lo;0;L;;;;;N;;;;;
145F8;ANATOLIAN HIEROGLYPH A450A;Lo;0;L;;;;;N;;;;;
145F9;ANATOLIAN HIEROGLYPH A451;Lo;0;L;;;;;N;;;;;
145FA;ANATOLIAN HIEROGLYPH A452;Lo;0;L;;;;;N;;;;;
145FB;ANATOLIAN HIEROGLYPH A453;Lo;0;L;;;;;N;;;;;
145FC;ANATOLIAN HIEROGLYPH A454;Lo;0;L;;;;;N;;;;;
145FD;ANATOLIAN HIEROGLYPH A455;Lo;0;L;;;;;N;;;;;
145FE;ANATOLIAN HIEROGLYPH A456;Lo;0;L;;;;;N;;;;;
145FF;ANATOLIAN HIEROGLYPH A457;Lo;0;L;;;;;N;;;;;
14600;ANATOLIAN HIEROGLYPH A457A;Lo;0;L;;;;;N;;;;;
14601;ANATOLIAN HIEROGLYPH A458;Lo;0;L;;;;;N;;;;;
14602;ANATOLIAN HIEROGLYPH A459;Lo;0;L;;;;;N;;;;;
14603;ANATOLIAN HIEROGLYPH A460;Lo;0;L;;;;;N;;;;;
14604;ANATOLIAN HIEROGLYPH A461;Lo;0;L;;;;;N;;;;;
14605;ANATOLIAN HIEROGLYPH A462;Lo;0;L;;;;;N;;;;;
14606;ANATOLIAN HIEROGLYPH A463;Lo;0;L;;;;;N;;;;;
14607;ANATOLIAN HIEROGLYPH A464;Lo;0;L;;;;;N;;;;;
14608;ANATOLIAN HIEROGLYPH A465;Lo;0;L;;;;;N;;;;;
14609;ANATOLIAN HIEROGLYPH A466;Lo;0;L;;;;;N;;;;;
1460A;ANATOLIAN HIEROGLYPH A467;Lo;0;L;;;;;N;;;;;
1460B;ANATOLIAN HIEROGLYPH A468;Lo;0;L;;;;;N;;;;;
1460C;ANATOLIAN HIEROGLYPH A469;Lo;0;L;;;;;N;;;;;
1460D;ANATOLIAN HIEROGLYPH A470;Lo;0;L;;;;;N;;;;;
1460E;ANATOLIAN HIEROGLYPH A471;Lo;0;L;;;;;N;;;;;
1460F;ANATOLIAN HIEROGLYPH A472;Lo;0;L;;;;;N;;;;;
14610;ANATOLIAN HIEROGLYPH A473;Lo;0;L;;;;;N;;;;;
14611;ANATOLIAN HIEROGLYPH A474;Lo;0;L;;;;;N;;;;;
14612;ANATOLIAN HIEROGLYPH A475;Lo;0;L;;;;;N;;;;;
14613;ANATOLIAN HIEROGLYPH A476;Lo;0;L;;;;;N;;;;;
14614;ANATOLIAN HIEROGLYPH A477;Lo;0;L;;;;;N;;;;;
14615;ANATOLIAN HIEROGLYPH A478;Lo;0;L;;;;;N;;;;;
14616;ANATOLIAN HIEROGLYPH A479;Lo;0;L;;;;;N;;;;;
14617;ANATOLIAN HIEROGLYPH A480;Lo;0;L;;;;;N;;;;;
14618;ANATOLIAN HIEROGLYPH A481;Lo;0;L;;;;;N;;;;;
14619;ANATOLIAN HIEROGLYPH A482;Lo;0;L;;;;;N;;;;;
1461A;ANATOLIAN HIEROGLYPH A483;Lo;0;L;;;;;N;;;;;
1461B;ANATOLIAN HIEROGLYPH A484;Lo;0;L;;;;;N;;;;;
1461C;ANATOLIAN HIEROGLYPH A485;Lo;0;L;;;;;N;;;;;
1461D;ANATOLIAN HIEROGLYPH A486;Lo;0;L;;;;;N;;;;;
1461E;ANATOLIAN HIEROGLYPH A487;Lo;0;L;;;;;N;;;;;
1461F;ANATOLIAN HIEROGLYPH A488;Lo;0;L;;;;;N;;;;;
14620;ANATOLIAN HIEROGLYPH A489;Lo;0;L;;;;;N;;;;;
14621;ANATOLIAN HIEROGLYPH A490;Lo;0;L;;;;;N;;;;;
14622;ANATOLIAN HIEROGLYPH A491;Lo;0;L;;;;;N;;;;;
14623;ANATOLIAN HIEROGLYPH A492;Lo;0;L;;;;;N;;;;;
14624;ANATOLIAN HIEROGLYPH A493;Lo;0;L;;;;;N;;;;;
14625;ANATOLIAN HIEROGLYPH A494;Lo;0;L;;;;;N;;;;;
14626;ANATOLIAN HIEROGLYPH A495;Lo;0;L;;;;;N;;;;;
14627;ANATOLIAN HIEROGLYPH A496;Lo;0;L;;;;;N;;;;;
14628;ANATOLIAN HIEROGLYPH A497;Lo;0;L;;;;;N;;;;;
14629;ANATOLIAN HIEROGLYPH A501;Lo;0;L;;;;;N;;;;;
1462A;ANATOLIAN HIEROGLYPH A502;Lo;0;L;;;;;N;;;;;
1462B;ANATOLIAN HIEROGLYPH A503;Lo;0;L;;;;;N;;;;;
1462C;ANATOLIAN HIEROGLYPH A504;Lo;0;L;;;;;N;;;;;
1462D;ANATOLIAN HIEROGLYPH A505;Lo;0;L;;;;;N;;;;;
1462E;ANATOLIAN HIEROGLYPH A506;Lo;0;L;;;;;N;;;;;
1462F;ANATOLIAN HIEROGLYPH A507;Lo;0;L;;;;;N;;;;;
14630;ANATOLIAN HIEROGLYPH A508;Lo;0;L;;;;;N;;;;;
14631;ANATOLIAN HIEROGLYPH A509;Lo;0;L;;;;;N;;;;;
14632;ANATOLIAN HIEROGLYPH A510;Lo;0;L;;;;;N;;;;;
14633;ANATOLIAN HIEROGLYPH A511;Lo;0;L;;;;;N;;;;;
14634;ANATOLIAN HIEROGLYPH A512;Lo;0;L;;;;;N;;;;;
14635;ANATOLIAN HIEROGLYPH A513;Lo;0;L;;;;;N;;;;;
14636;ANATOLIAN HIEROGLYPH A514;Lo;0;L;;;;;N;;;;;
14637;ANATOLIAN HIEROGLYPH A515;Lo;0;L;;;;;N;;;;;
14638;ANATOLIAN HIEROGLYPH A516;Lo;0;L;;;;;N;;;;;
14639;ANATOLIAN HIEROGLYPH A517;Lo;0;L;;;;;N;;;;;
1463A;ANATOLIAN HIEROGLYPH A518;Lo;0;L;;;;;N;;;;;
1463B;ANATOLIAN HIEROGLYPH A519;Lo;0;L;;;;;N;;;;;
1463C;ANATOLIAN HIEROGLYPH A520;Lo;0;L;;;;;N;;;;;
1463D;ANATOLIAN HIEROGLYPH A521;Lo;0;L;;;;;N;;;;;
1463E;ANATOLIAN HIEROGLYPH A522;Lo;0;L;;;;;N;;;;;
1463F;ANATOLIAN HIEROGLYPH A523;Lo;0;L;;;;;N;;;;;
14640;ANATOLIAN HIEROGLYPH A524;Lo;0;L;;;;;N;;;;;
14641;ANATOLIAN HIEROGLYPH A525;Lo;0;L;;;;;N;;;;;
14642;ANATOLIAN HIEROGLYPH A526;Lo;0;L;;;;;N;;;;;
14643;ANATOLIAN HIEROGLYPH A527;Lo;0;L;;;;;N;;;;;
14644;ANATOLIAN HIEROGLYPH A528;Lo;0;L;;;;;N;;;;;
14645;ANATOLIAN HIEROGLYPH A529;Lo;0;L;;;;;N;;;;;
14646;ANATOLIAN HIEROGLYPH A530;Lo;0;L;;;;;N;;;;;
16800;BAMUM LETTER PHASE-A NGKUE MFON;Lo;0;L;;;;;N;;;;;
16801;BAMUM LETTER PHASE-A GBIEE FON;Lo;0;L;;;;;N;;;;;
16802;BAMUM LETTER PHASE-A PON MFON PIPAEMGBIEE;Lo;0;L;;;;;N;;;;;
16803;BAMUM LETTER PHASE-A PON MFON PIPAEMBA;Lo;0;L;;;;;N;;;;;
16804;BAMUM LETTER PHASE-A NAA MFON;Lo;0;L;;;;;N;;;;;
16805;BAMUM LETTER PHASE-A SHUENSHUET;Lo;0;L;;;;;N;;;;;
16806;BAMUM LETTER PHASE-A TITA MFON;Lo;0;L;;;;;N;;;;;
16807;BAMUM LETTER PHASE-A NZA MFON;Lo;0;L;;;;;N;;;;;
16808;BAMUM LETTER PHASE-A SHINDA PA NJI;Lo;0;L;;;;;N;;;;;
16809;BAMUM LETTER PHASE-A PON PA NJI PIPAEMGBIEE;Lo;0;L;;;;;N;;;;;
1680A;BAMUM LETTER PHASE-A PON PA NJI PIPAEMBA;Lo;0;L;;;;;N;;;;;
1680B;BAMUM LETTER PHASE-A MAEMBGBIEE;Lo;0;L;;;;;N;;;;;
1680C;BAMUM LETTER PHASE-A TU MAEMBA;Lo;0;L;;;;;N;;;;;
1680D;BAMUM LETTER PHASE-A NGANGU;Lo;0;L;;;;;N;;;;;
1680E;BAMUM LETTER PHASE-A MAEMVEUX;Lo;0;L;;;;;N;;;;;
1680F;BAMUM LETTER PHASE-A MANSUAE;Lo;0;L;;;;;N;;;;;
16810;BAMUM LETTER PHASE-A MVEUAENGAM;Lo;0;L;;;;;N;;;;;
16811;BAMUM LETTER PHASE-A SEUNYAM;Lo;0;L;;;;;N;;;;;
16812;BAMUM LETTER PHASE-A NTOQPEN;Lo;0;L;;;;;N;;;;;
16813;BAMUM LETTER PHASE-A KEUKEUTNDA;Lo;0;L;;;;;N;;;;;
16814;BAMUM LETTER PHASE-A NKINDI;Lo;0;L;;;;;N;;;;;
16815;BAMUM LETTER PHASE-A SUU;Lo;0;L;;;;;N;;;;;
16816;BAMUM LETTER PHASE-A NGKUENZEUM;Lo;0;L;;;;;N;;;;;
16817;BAMUM LETTER PHASE-A LAPAQ;Lo;0;L;;;;;N;;;;;
16818;BAMUM LETTER PHASE-A LET KUT;Lo;0;L;;;;;N;;;;;
16819;BAMUM LETTER PHASE-A NTAP MFAA;Lo;0;L;;;;;N;;;;;
1681A;BAMUM LETTER PHASE-A MAEKEUP;Lo;0;L;;;;;N;;;;;
1681B;BAMUM LETTER PHASE-A PASHAE;Lo;0;L;;;;;N;;;;;
1681C;BAMUM LETTER PHASE-A GHEUAERAE;Lo;0;L;;;;;N;;;;;
1681D;BAMUM LETTER PHASE-A PAMSHAE;Lo;0;L;;;;;N;;;;;
1681E;BAMUM LETTER PHASE-A MON NGGEUAET;Lo;0;L;;;;;N;;;;;
1681F;BAMUM LETTER PHASE-A NZUN MEUT;Lo;0;L;;;;;N;;;;;
16820;BAMUM LETTER PHASE-A U YUQ NAE;Lo;0;L;;;;;N;;;;;
16821;BAMUM LETTER PHASE-A GHEUAEGHEUAE;Lo;0;L;;;;;N;;;;;
16822;BAMUM LETTER PHASE-A NTAP NTAA;Lo;0;L;;;;;N;;;;;
16823;BAMUM LETTER PHASE-A SISA;Lo;0;L;;;;;N;;;;;
16824;BAMUM LETTER PHASE-A MGBASA;Lo;0;L;;;;;N;;;;;
16825;BAMUM LETTER PHASE-A MEUNJOMNDEUQ;Lo;0;L;;;;;N;;;;;
16826;BAMUM LETTER PHASE-A MOOMPUQ;Lo;0;L;;;;;N;;;;;
16827;BAMUM LETTER PHASE-A KAFA;Lo;0;L;;;;;N;;;;;
16828;BAMUM LETTER PHASE-A PA LEERAEWA;Lo;0;L;;;;;N;;;;;
16829;BAMUM LETTER PHASE-A NDA LEERAEWA;Lo;0;L;;;;;N;;;;;
1682A;BAMUM LETTER PHASE-A PET;Lo;0;L;;;;;N;;;;;
1682B;BAMUM LETTER PHASE-A MAEMKPEN;Lo;0;L;;;;;N;;;;;
1682C;BAMUM LETTER PHASE-A NIKA;Lo;0;L;;;;;N;;;;;
1682D;BAMUM LETTER PHASE-A PUP;Lo;0;L;;;;;N;;;;;
1682E;BAMUM LETTER PHASE-A TUAEP;Lo;0;L;;;;;N;;;;;
1682F;BAMUM LETTER PHASE-A LUAEP;Lo;0;L;;;;;N;;;;;
16830;BAMUM LETTER PHASE-A SONJAM;Lo;0;L;;;;;N;;;;;
16831;BAMUM LETTER PHASE-A TEUTEUWEN;Lo;0;L;;;;;N;;;;;
16832;BAMUM LETTER PHASE-A MAENYI;Lo;0;L;;;;;N;;;;;
16833;BAMUM LETTER PHASE-A KET;Lo;0;L;;;;;N;;;;;
16834;BAMUM LETTER PHASE-A NDAANGGEUAET;Lo;0;L;;;;;N;;;;;
16835;BAMUM LETTER PHASE-A KUOQ;Lo;0;L;;;;;N;;;;;
16836;BAMUM LETTER PHASE-A MOOMEUT;Lo;0;L;;;;;N;;;;;
16837;BAMUM LETTER PHASE-A SHUM;Lo;0;L;;;;;N;;;;;
16838;BAMUM LETTER PHASE-A LOMMAE;Lo;0;L;;;;;N;;;;;
16839;BAMUM LETTER PHASE-A FIRI;Lo;0;L;;;;;N;;;;;
1683A;BAMUM LETTER PHASE-A ROM;Lo;0;L;;;;;N;;;;;
1683B;BAMUM LETTER PHASE-A KPOQ;Lo;0;L;;;;;N;;;;;
1683C;BAMUM LETTER PHASE-A SOQ;Lo;0;L;;;;;N;;;;;
1683D;BAMUM LETTER PHASE-A MAP PIEET;Lo;0;L;;;;;N;;;;;
1683E;BAMUM LETTER PHASE-A SHIRAE;Lo;0;L;;;;;N;;;;;
1683F;BAMUM LETTER PHASE-A NTAP;Lo;0;L;;;;;N;;;;;
16840;BAMUM LETTER PHASE-A SHOQ NSHUT YUM;Lo;0;L;;;;;N;;;;;
16841;BAMUM LETTER PHASE-A NYIT MONGKEUAEQ;Lo;0;L;;;;;N;;;;;
16842;BAMUM LETTER PHASE-A PAARAE;Lo;0;L;;;;;N;;;;;
16843;BAMUM LETTER PHASE-A NKAARAE;Lo;0;L;;;;;N;;;;;
16844;BAMUM LETTER PHASE-A UNKNOWN;Lo;0;L;;;;;N;;;;;
16845;BAMUM LETTER PHASE-A NGGEN;Lo;0;L;;;;;N;;;;;
16846;BAMUM LETTER PHASE-A MAESI;Lo;0;L;;;;;N;;;;;
16847;BAMUM LETTER PHASE-A NJAM;Lo;0;L;;;;;N;;;;;
16848;BAMUM LETTER PHASE-A MBANYI;Lo;0;L;;;;;N;;;;;
16849;BAMUM LETTER PHASE-A NYET;Lo;0;L;;;;;N;;;;;
1684A;BAMUM LETTER PHASE-A TEUAEN;Lo;0;L;;;;;N;;;;;
1684B;BAMUM LETTER PHASE-A SOT;Lo;0;L;;;;;N;;;;;
1684C;BAMUM LETTER PHASE-A PAAM;Lo;0;L;;;;;N;;;;;
1684D;BAMUM LETTER PHASE-A NSHIEE;Lo;0;L;;;;;N;;;;;
1684E;BAMUM LETTER PHASE-A MAEM;Lo;0;L;;;;;N;;;;;
1684F;BAMUM LETTER PHASE-A NYI;Lo;0;L;;;;;N;;;;;
16850;BAMUM LETTER PHASE-A KAQ;Lo;0;L;;;;;N;;;;;
16851;BAMUM LETTER PHASE-A NSHA;Lo;0;L;;;;;N;;;;;
16852;BAMUM LETTER PHASE-A VEE;Lo;0;L;;;;;N;;;;;
16853;BAMUM LETTER PHASE-A LU;Lo;0;L;;;;;N;;;;;
16854;BAMUM LETTER PHASE-A NEN;Lo;0;L;;;;;N;;;;;
16855;BAMUM LETTER PHASE-A NAQ;Lo;0;L;;;;;N;;;;;
16856;BAMUM LETTER PHASE-A MBAQ;Lo;0;L;;;;;N;;;;;
16857;BAMUM LETTER PHASE-B NSHUET;Lo;0;L;;;;;N;;;;;
16858;BAMUM LETTER PHASE-B TU MAEMGBIEE;Lo;0;L;;;;;N;;;;;
16859;BAMUM LETTER PHASE-B SIEE;Lo;0;L;;;;;N;;;;;
1685A;BAMUM LETTER PHASE-B SET TU;Lo;0;L;;;;;N;;;;;
1685B;BAMUM LETTER PHASE-B LOM NTEUM;Lo;0;L;;;;;N;;;;;
1685C;BAMUM LETTER PHASE-B MBA MAELEE;Lo;0;L;;;;;N;;;;;
1685D;BAMUM LETTER PHASE-B KIEEM;Lo;0;L;;;;;N;;;;;
1685E;BAMUM LETTER PHASE-B YEURAE;Lo;0;L;;;;;N;;;;;
1685F;BAMUM LETTER PHASE-B MBAARAE;Lo;0;L;;;;;N;;;;;
16860;BAMUM LETTER PHASE-B KAM;Lo;0;L;;;;;N;;;;;
16861;BAMUM LETTER PHASE-B PEESHI;Lo;0;L;;;;;N;;;;;
16862;BAMUM LETTER PHASE-B YAFU LEERAEWA;Lo;0;L;;;;;N;;;;;
16863;BAMUM LETTER PHASE-B LAM NSHUT NYAM;Lo;0;L;;;;;N;;;;;
16864;BAMUM LETTER PHASE-B NTIEE SHEUOQ;Lo;0;L;;;;;N;;;;;
16865;BAMUM LETTER PHASE-B NDU NJAA;Lo;0;L;;;;;N;;;;;
16866;BAMUM LETTER PHASE-B GHEUGHEUAEM;Lo;0;L;;;;;N;;;;;
16867;BAMUM LETTER PHASE-B PIT;Lo;0;L;;;;;N;;;;;
16868;BAMUM LETTER PHASE-B TU NSIEE;Lo;0;L;;;;;N;;;;;
16869;BAMUM LETTER PHASE-B SHET NJAQ;Lo;0;L;;;;;N;;;;;
1686A;BAMUM LETTER PHASE-B SHEUAEQTU;Lo;0;L;;;;;N;;;;;
1686B;BAMUM LETTER PHASE-B MFON TEUAEQ;Lo;0;L;;;;;N;;;;;
1686C;BAMUM LETTER PHASE-B MBIT MBAAKET;Lo;0;L;;;;;N;;;;;
1686D;BAMUM LETTER PHASE-B NYI NTEUM;Lo;0;L;;;;;N;;;;;
1686E;BAMUM LETTER PHASE-B KEUPUQ;Lo;0;L;;;;;N;;;;;
1686F;BAMUM LETTER PHASE-B GHEUGHEN;Lo;0;L;;;;;N;;;;;
16870;BAMUM LETTER PHASE-B KEUYEUX;Lo;0;L;;;;;N;;;;;
16871;BAMUM LETTER PHASE-B LAANAE;Lo;0;L;;;;;N;;;;;
16872;BAMUM LETTER PHASE-B PARUM;Lo;0;L;;;;;N;;;;;
16873;BAMUM LETTER PHASE-B VEUM;Lo;0;L;;;;;N;;;;;
16874;BAMUM LETTER PHASE-B NGKINDI MVOP;Lo;0;L;;;;;N;;;;;
16875;BAMUM LETTER PHASE-B NGGEU MBU;Lo;0;L;;;;;N;;;;;
16876;BAMUM LETTER PHASE-B WUAET;Lo;0;L;;;;;N;;;;;
16877;BAMUM LETTER PHASE-B SAKEUAE;Lo;0;L;;;;;N;;;;;
16878;BAMUM LETTER PHASE-B TAAM;Lo;0;L;;;;;N;;;;;
16879;BAMUM LETTER PHASE-B MEUQ;Lo;0;L;;;;;N;;;;;
1687A;BAMUM LETTER PHASE-B NGGUOQ;Lo;0;L;;;;;N;;;;;
1687B;BAMUM LETTER PHASE-B NGGUOQ LARGE;Lo;0;L;;;;;N;;;;;
1687C;BAMUM LETTER PHASE-B MFIYAQ;Lo;0;L;;;;;N;;;;;
1687D;BAMUM LETTER PHASE-B SUE;Lo;0;L;;;;;N;;;;;
1687E;BAMUM LETTER PHASE-B MBEURI;Lo;0;L;;;;;N;;;;;
1687F;BAMUM LETTER PHASE-B MONTIEEN;Lo;0;L;;;;;N;;;;;
16880;BAMUM LETTER PHASE-B NYAEMAE;Lo;0;L;;;;;N;;;;;
16881;BAMUM LETTER PHASE-B PUNGAAM;Lo;0;L;;;;;N;;;;;
16882;BAMUM LETTER PHASE-B MEUT NGGEET;Lo;0;L;;;;;N;;;;;
16883;BAMUM LETTER PHASE-B FEUX;Lo;0;L;;;;;N;;;;;
16884;BAMUM LETTER PHASE-B MBUOQ;Lo;0;L;;;;;N;;;;;
16885;BAMUM LETTER PHASE-B FEE;Lo;0;L;;;;;N;;;;;
16886;BAMUM LETTER PHASE-B KEUAEM;Lo;0;L;;;;;N;;;;;
16887;BAMUM LETTER PHASE-B MA NJEUAENA;Lo;0;L;;;;;N;;;;;
16888;BAMUM LETTER PHASE-B MA NJUQA;Lo;0;L;;;;;N;;;;;
16889;BAMUM LETTER PHASE-B LET;Lo;0;L;;;;;N;;;;;
1688A;BAMUM LETTER PHASE-B NGGAAM;Lo;0;L;;;;;N;;;;;
1688B;BAMUM LETTER PHASE-B NSEN;Lo;0;L;;;;;N;;;;;
1688C;BAMUM LETTER PHASE-B MA;Lo;0;L;;;;;N;;;;;
1688D;BAMUM LETTER PHASE-B KIQ;Lo;0;L;;;;;N;;;;;
1688E;BAMUM LETTER PHASE-B NGOM;Lo;0;L;;;;;N;;;;;
1688F;BAMUM LETTER PHASE-C NGKUE MAEMBA;Lo;0;L;;;;;N;;;;;
16890;BAMUM LETTER PHASE-C NZA;Lo;0;L;;;;;N;;;;;
16891;BAMUM LETTER PHASE-C YUM;Lo;0;L;;;;;N;;;;;
16892;BAMUM LETTER PHASE-C WANGKUOQ;Lo;0;L;;;;;N;;;;;
16893;BAMUM LETTER PHASE-C NGGEN;Lo;0;L;;;;;N;;;;;
16894;BAMUM LETTER PHASE-C NDEUAEREE;Lo;0;L;;;;;N;;;;;
16895;BAMUM LETTER PHASE-C NGKAQ;Lo;0;L;;;;;N;;;;;
16896;BAMUM LETTER PHASE-C GHARAE;Lo;0;L;;;;;N;;;;;
16897;BAMUM LETTER PHASE-C MBEEKEET;Lo;0;L;;;;;N;;;;;
16898;BAMUM LETTER PHASE-C GBAYI;Lo;0;L;;;;;N;;;;;
16899;BAMUM LETTER PHASE-C NYIR MKPARAQ MEUN;Lo;0;L;;;;;N;;;;;
1689A;BAMUM LETTER PHASE-C NTU MBIT;Lo;0;L;;;;;N;;;;;
1689B;BAMUM LETTER PHASE-C MBEUM;Lo;0;L;;;;;N;;;;;
1689C;BAMUM LETTER PHASE-C PIRIEEN;Lo;0;L;;;;;N;;;;;
1689D;BAMUM LETTER PHASE-C NDOMBU;Lo;0;L;;;;;N;;;;;
1689E;BAMUM LETTER PHASE-C MBAA CABBAGE-TREE;Lo;0;L;;;;;N;;;;;
1689F;BAMUM LETTER PHASE-C KEUSHEUAEP;Lo;0;L;;;;;N;;;;;
168A0;BAMUM LETTER PHASE-C GHAP;Lo;0;L;;;;;N;;;;;
168A1;BAMUM LETTER PHASE-C KEUKAQ;Lo;0;L;;;;;N;;;;;
168A2;BAMUM LETTER PHASE-C YU MUOMAE;Lo;0;L;;;;;N;;;;;
168A3;BAMUM LETTER PHASE-C NZEUM;Lo;0;L;;;;;N;;;;;
168A4;BAMUM LETTER PHASE-C MBUE;Lo;0;L;;;;;N;;;;;
168A5;BAMUM LETTER PHASE-C NSEUAEN;Lo;0;L;;;;;N;;;;;
168A6;BAMUM LETTER PHASE-C MBIT;Lo;0;L;;;;;N;;;;;
168A7;BAMUM LETTER PHASE-C YEUQ;Lo;0;L;;;;;N;;;;;
168A8;BAMUM LETTER PHASE-C KPARAQ;Lo;0;L;;;;;N;;;;;
168A9;BAMUM LETTER PHASE-C KAA;Lo;0;L;;;;;N;;;;;
168AA;BAMUM LETTER PHASE-C SEUX;Lo;0;L;;;;;N;;;;;
168AB;BAMUM LETTER PHASE-C NDIDA;Lo;0;L;;;;;N;;;;;
168AC;BAMUM LETTER PHASE-C TAASHAE;Lo;0;L;;;;;N;;;;;
168AD;BAMUM LETTER PHASE-C NJUEQ;Lo;0;L;;;;;N;;;;;
168AE;BAMUM LETTER PHASE-C TITA YUE;Lo;0;L;;;;;N;;;;;
168AF;BAMUM LETTER PHASE-C SUAET;Lo;0;L;;;;;N;;;;;
168B0;BAMUM LETTER PHASE-C NGGUAEN NYAM;Lo;0;L;;;;;N;;;;;
168B1;BAMUM LETTER PHASE-C VEUX;Lo;0;L;;;;;N;;;;;
168B2;BAMUM LETTER PHASE-C NANSANAQ;Lo;0;L;;;;;N;;;;;
168B3;BAMUM LETTER PHASE-C MA KEUAERI;Lo;0;L;;;;;N;;;;;
168B4;BAMUM LETTER PHASE-C NTAA;Lo;0;L;;;;;N;;;;;
168B5;BAMUM LETTER PHASE-C NGGUON;Lo;0;L;;;;;N;;;;;
168B6;BAMUM LETTER PHASE-C LAP;Lo;0;L;;;;;N;;;;;
168B7;BAMUM LETTER PHASE-C MBIRIEEN;Lo;0;L;;;;;N;;;;;
168B8;BAMUM LETTER PHASE-C MGBASAQ;Lo;0;L;;;;;N;;;;;
168B9;BAMUM LETTER PHASE-C NTEUNGBA;Lo;0;L;;;;;N;;;;;
168BA;BAMUM LETTER PHASE-C TEUTEUX;Lo;0;L;;;;;N;;;;;
168BB;BAMUM LETTER PHASE-C NGGUM;Lo;0;L;;;;;N;;;;;
168BC;BAMUM LETTER PHASE-C FUE;Lo;0;L;;;;;N;;;;;
168BD;BAMUM LETTER PHASE-C NDEUT;Lo;0;L;;;;;N;;;;;
168BE;BAMUM LETTER PHASE-C NSA;Lo;0;L;;;;;N;;;;;
168BF;BAMUM LETTER PHASE-C NSHAQ;Lo;0;L;;;;;N;;;;;
168C0;BAMUM LETTER PHASE-C BUNG;Lo;0;L;;;;;N;;;;;
168C1;BAMUM LETTER PHASE-C VEUAEPEN;Lo;0;L;;;;;N;;;;;
168C2;BAMUM LETTER PHASE-C MBERAE;Lo;0;L;;;;;N;;;;;
168C3;BAMUM LETTER PHASE-C RU;Lo;0;L;;;;;N;;;;;
168C4;BAMUM LETTER PHASE-C NJAEM;Lo;0;L;;;;;N;;;;;
168C5;BAMUM LETTER PHASE-C LAM;Lo;0;L;;;;;N;;;;;
168C6;BAMUM LETTER PHASE-C TITUAEP;Lo;0;L;;;;;N;;;;;
168C7;BAMUM LETTER PHASE-C NSUOT NGOM;Lo;0;L;;;;;N;;;;;
168C8;BAMUM LETTER PHASE-C NJEEEE;Lo;0;L;;;;;N;;;;;
168C9;BAMUM LETTER PHASE-C KET;Lo;0;L;;;;;N;;;;;
168CA;BAMUM LETTER PHASE-C NGGU;Lo;0;L;;;;;N;;;;;
168CB;BAMUM LETTER PHASE-C MAESI;Lo;0;L;;;;;N;;;;;
168CC;BAMUM LETTER PHASE-C MBUAEM;Lo;0;L;;;;;N;;;;;
168CD;BAMUM LETTER PHASE-C LU;Lo;0;L;;;;;N;;;;;
168CE;BAMUM LETTER PHASE-C KUT;Lo;0;L;;;;;N;;;;;
168CF;BAMUM LETTER PHASE-C NJAM;Lo;0;L;;;;;N;;;;;
168D0;BAMUM LETTER PHASE-C NGOM;Lo;0;L;;;;;N;;;;;
168D1;BAMUM LETTER PHASE-C WUP;Lo;0;L;;;;;N;;;;;
168D2;BAMUM LETTER PHASE-C NGGUEET;Lo;0;L;;;;;N;;;;;
168D3;BAMUM LETTER PHASE-C NSOM;Lo;0;L;;;;;N;;;;;
168D4;BAMUM LETTER PHASE-C NTEN;Lo;0;L;;;;;N;;;;;
168D5;BAMUM LETTER PHASE-C KUOP NKAARAE;Lo;0;L;;;;;N;;;;;
168D6;BAMUM LETTER PHASE-C NSUN;Lo;0;L;;;;;N;;;;;
168D7;BAMUM LETTER PHASE-C NDAM;Lo;0;L;;;;;N;;;;;
168D8;BAMUM LETTER PHASE-C MA NSIEE;Lo;0;L;;;;;N;;;;;
168D9;BAMUM LETTER PHASE-C YAA;Lo;0;L;;;;;N;;;;;
168DA;BAMUM LETTER PHASE-C NDAP;Lo;0;L;;;;;N;;;;;
168DB;BAMUM LETTER PHASE-C SHUEQ;Lo;0;L;;;;;N;;;;;
168DC;BAMUM LETTER PHASE-C SETFON;Lo;0;L;;;;;N;;;;;
168DD;BAMUM LETTER PHASE-C MBI;Lo;0;L;;;;;N;;;;;
168DE;BAMUM LETTER PHASE-C MAEMBA;Lo;0;L;;;;;N;;;;;
168DF;BAMUM LETTER PHASE-C MBANYI;Lo;0;L;;;;;N;;;;;
168E0;BAMUM LETTER PHASE-C KEUSEUX;Lo;0;L;;;;;N;;;;;
168E1;BAMUM LETTER PHASE-C MBEUX;Lo;0;L;;;;;N;;;;;
168E2;BAMUM LETTER PHASE-C KEUM;Lo;0;L;;;;;N;;;;;
168E3;BAMUM LETTER PHASE-C MBAA PICKET;Lo;0;L;;;;;N;;;;;
168E4;BAMUM LETTER PHASE-C YUWOQ;Lo;0;L;;;;;N;;;;;
168E5;BAMUM LETTER PHASE-C NJEUX;Lo;0;L;;;;;N;;;;;
168E6;BAMUM LETTER PHASE-C MIEE;Lo;0;L;;;;;N;;;;;
168E7;BAMUM LETTER PHASE-C MUAE;Lo;0;L;;;;;N;;;;;
168E8;BAMUM LETTER PHASE-C SHIQ;Lo;0;L;;;;;N;;;;;
168E9;BAMUM LETTER PHASE-C KEN LAW;Lo;0;L;;;;;N;;;;;
168EA;BAMUM LETTER PHASE-C KEN FATIGUE;Lo;0;L;;;;;N;;;;;
168EB;BAMUM LETTER PHASE-C NGAQ;Lo;0;L;;;;;N;;;;;
168EC;BAMUM LETTER PHASE-C NAQ;Lo;0;L;;;;;N;;;;;
168ED;BAMUM LETTER PHASE-C LIQ;Lo;0;L;;;;;N;;;;;
168EE;BAMUM LETTER PHASE-C PIN;Lo;0;L;;;;;N;;;;;
168EF;BAMUM LETTER PHASE-C PEN;Lo;0;L;;;;;N;;;;;
168F0;BAMUM LETTER PHASE-C TET;Lo;0;L;;;;;N;;;;;
168F1;BAMUM LETTER PHASE-D MBUO;Lo;0;L;;;;;N;;;;;
168F2;BAMUM LETTER PHASE-D WAP;Lo;0;L;;;;;N;;;;;
168F3;BAMUM LETTER PHASE-D NJI;Lo;0;L;;;;;N;;;;;
168F4;BAMUM LETTER PHASE-D MFON;Lo;0;L;;;;;N;;;;;
168F5;BAMUM LETTER PHASE-D NJIEE;Lo;0;L;;;;;N;;;;;
168F6;BAMUM LETTER PHASE-D LIEE;Lo;0;L;;;;;N;;;;;
168F7;BAMUM LETTER PHASE-D NJEUT;Lo;0;L;;;;;N;;;;;
168F8;BAMUM LETTER PHASE-D NSHEE;Lo;0;L;;;;;N;;;;;
168F9;BAMUM LETTER PHASE-D NGGAAMAE;Lo;0;L;;;;;N;;;;;
168FA;BAMUM LETTER PHASE-D NYAM;Lo;0;L;;;;;N;;;;;
168FB;BAMUM LETTER PHASE-D WUAEN;Lo;0;L;;;;;N;;;;;
168FC;BAMUM LETTER PHASE-D NGKUN;Lo;0;L;;;;;N;;;;;
168FD;BAMUM LETTER PHASE-D SHEE;Lo;0;L;;;;;N;;;;;
168FE;BAMUM LETTER PHASE-D NGKAP;Lo;0;L;;;;;N;;;;;
168FF;BAMUM LETTER PHASE-D KEUAETMEUN;Lo;0;L;;;;;N;;;;;
16900;BAMUM LETTER PHASE-D TEUT;Lo;0;L;;;;;N;;;;;
16901;BAMUM LETTER PHASE-D SHEUAE;Lo;0;L;;;;;N;;;;;
16902;BAMUM LETTER PHASE-D NJAP;Lo;0;L;;;;;N;;;;;
16903;BAMUM LETTER PHASE-D SUE;Lo;0;L;;;;;N;;;;;
16904;BAMUM LETTER PHASE-D KET;Lo;0;L;;;;;N;;;;;
16905;BAMUM LETTER PHASE-D YAEMMAE;Lo;0;L;;;;;N;;;;;
16906;BAMUM LETTER PHASE-D KUOM;Lo;0;L;;;;;N;;;;;
16907;BAMUM LETTER PHASE-D SAP;Lo;0;L;;;;;N;;;;;
16908;BAMUM LETTER PHASE-D MFEUT;Lo;0;L;;;;;N;;;;;
16909;BAMUM LETTER PHASE-D NDEUX;Lo;0;L;;;;;N;;;;;
1690A;BAMUM LETTER PHASE-D MALEERI;Lo;0;L;;;;;N;;;;;
1690B;BAMUM LETTER PHASE-D MEUT;Lo;0;L;;;;;N;;;;;
1690C;BAMUM LETTER PHASE-D SEUAEQ;Lo;0;L;;;;;N;;;;;
1690D;BAMUM LETTER PHASE-D YEN;Lo;0;L;;;;;N;;;;;
1690E;BAMUM LETTER PHASE-D NJEUAEM;Lo;0;L;;;;;N;;;;;
1690F;BAMUM LETTER PHASE-D KEUOT MBUAE;Lo;0;L;;;;;N;;;;;
16910;BAMUM LETTER PHASE-D NGKEURI;Lo;0;L;;;;;N;;;;;
16911;BAMUM LETTER PHASE-D TU;Lo;0;L;;;;;N;;;;;
16912;BAMUM LETTER PHASE-D GHAA;Lo;0;L;;;;;N;;;;;
16913;BAMUM LETTER PHASE-D NGKYEE;Lo;0;L;;;;;N;;;;;
16914;BAMUM LETTER PHASE-D FEUFEUAET;Lo;0;L;;;;;N;;;;;
16915;BAMUM LETTER PHASE-D NDEE;Lo;0;L;;;;;N;;;;;
16916;BAMUM LETTER PHASE-D MGBOFUM;Lo;0;L;;;;;N;;;;;
16917;BAMUM LETTER PHASE-D LEUAEP;Lo;0;L;;;;;N;;;;;
16918;BAMUM LETTER PHASE-D NDON;Lo;0;L;;;;;N;;;;;
16919;BAMUM LETTER PHASE-D MONI;Lo;0;L;;;;;N;;;;;
1691A;BAMUM LETTER PHASE-D MGBEUN;Lo;0;L;;;;;N;;;;;
1691B;BAMUM LETTER PHASE-D PUUT;Lo;0;L;;;;;N;;;;;
1691C;BAMUM LETTER PHASE-D MGBIEE;Lo;0;L;;;;;N;;;;;
1691D;BAMUM LETTER PHASE-D MFO;Lo;0;L;;;;;N;;;;;
1691E;BAMUM LETTER PHASE-D LUM;Lo;0;L;;;;;N;;;;;
1691F;BAMUM LETTER PHASE-D NSIEEP;Lo;0;L;;;;;N;;;;;
16920;BAMUM LETTER PHASE-D MBAA;Lo;0;L;;;;;N;;;;;
16921;BAMUM LETTER PHASE-D KWAET;Lo;0;L;;;;;N;;;;;
16922;BAMUM LETTER PHASE-D NYET;Lo;0;L;;;;;N;;;;;
16923;BAMUM LETTER PHASE-D TEUAEN;Lo;0;L;;;;;N;;;;;
16924;BAMUM LETTER PHASE-D SOT;Lo;0;L;;;;;N;;;;;
16925;BAMUM LETTER PHASE-D YUWOQ;Lo;0;L;;;;;N;;;;;
16926;BAMUM LETTER PHASE-D KEUM;Lo;0;L;;;;;N;;;;;
16927;BAMUM LETTER PHASE-D RAEM;Lo;0;L;;;;;N;;;;;
16928;BAMUM LETTER PHASE-D TEEEE;Lo;0;L;;;;;N;;;;;
16929;BAMUM LETTER PHASE-D NGKEUAEQ;Lo;0;L;;;;;N;;;;;
1692A;BAMUM LETTER PHASE-D MFEUAE;Lo;0;L;;;;;N;;;;;
1692B;BAMUM LETTER PHASE-D NSIEET;Lo;0;L;;;;;N;;;;;
1692C;BAMUM LETTER PHASE-D KEUP;Lo;0;L;;;;;N;;;;;
1692D;BAMUM LETTER PHASE-D PIP;Lo;0;L;;;;;N;;;;;
1692E;BAMUM LETTER PHASE-D PEUTAE;Lo;0;L;;;;;N;;;;;
1692F;BAMUM LETTER PHASE-D NYUE;Lo;0;L;;;;;N;;;;;
16930;BAMUM LETTER PHASE-D LET;Lo;0;L;;;;;N;;;;;
16931;BAMUM LETTER PHASE-D NGGAAM;Lo;0;L;;;;;N;;;;;
16932;BAMUM LETTER PHASE-D MFIEE;Lo;0;L;;;;;N;;;;;
16933;BAMUM LETTER PHASE-D NGGWAEN;Lo;0;L;;;;;N;;;;;
16934;BAMUM LETTER PHASE-D YUOM;Lo;0;L;;;;;N;;;;;
16935;BAMUM LETTER PHASE-D PAP;Lo;0;L;;;;;N;;;;;
16936;BAMUM LETTER PHASE-D YUOP;Lo;0;L;;;;;N;;;;;
16937;BAMUM LETTER PHASE-D NDAM;Lo;0;L;;;;;N;;;;;
16938;BAMUM LETTER PHASE-D NTEUM;Lo;0;L;;;;;N;;;;;
16939;BAMUM LETTER PHASE-D SUAE;Lo;0;L;;;;;N;;;;;
1693A;BAMUM LETTER PHASE-D KUN;Lo;0;L;;;;;N;;;;;
1693B;BAMUM LETTER PHASE-D NGGEUX;Lo;0;L;;;;;N;;;;;
1693C;BAMUM LETTER PHASE-D NGKIEE;Lo;0;L;;;;;N;;;;;
1693D;BAMUM LETTER PHASE-D TUOT;Lo;0;L;;;;;N;;;;;
1693E;BAMUM LETTER PHASE-D MEUN;Lo;0;L;;;;;N;;;;;
1693F;BAMUM LETTER PHASE-D KUQ;Lo;0;L;;;;;N;;;;;
16940;BAMUM LETTER PHASE-D NSUM;Lo;0;L;;;;;N;;;;;
16941;BAMUM LETTER PHASE-D TEUN;Lo;0;L;;;;;N;;;;;
16942;BAMUM LETTER PHASE-D MAENJET;Lo;0;L;;;;;N;;;;;
16943;BAMUM LETTER PHASE-D NGGAP;Lo;0;L;;;;;N;;;;;
16944;BAMUM LETTER PHASE-D LEUM;Lo;0;L;;;;;N;;;;;
16945;BAMUM LETTER PHASE-D NGGUOM;Lo;0;L;;;;;N;;;;;
16946;BAMUM LETTER PHASE-D NSHUT;Lo;0;L;;;;;N;;;;;
16947;BAMUM LETTER PHASE-D NJUEQ;Lo;0;L;;;;;N;;;;;
16948;BAMUM LETTER PHASE-D GHEUAE;Lo;0;L;;;;;N;;;;;
16949;BAMUM LETTER PHASE-D KU;Lo;0;L;;;;;N;;;;;
1694A;BAMUM LETTER PHASE-D REN OLD;Lo;0;L;;;;;N;;;;;
1694B;BAMUM LETTER PHASE-D TAE;Lo;0;L;;;;;N;;;;;
1694C;BAMUM LETTER PHASE-D TOQ;Lo;0;L;;;;;N;;;;;
1694D;BAMUM LETTER PHASE-D NYI;Lo;0;L;;;;;N;;;;;
1694E;BAMUM LETTER PHASE-D RII;Lo;0;L;;;;;N;;;;;
1694F;BAMUM LETTER PHASE-D LEEEE;Lo;0;L;;;;;N;;;;;
16950;BAMUM LETTER PHASE-D MEEEE;Lo;0;L;;;;;N;;;;;
16951;BAMUM LETTER PHASE-D M;Lo;0;L;;;;;N;;;;;
16952;BAMUM LETTER PHASE-D SUU;Lo;0;L;;;;;N;;;;;
16953;BAMUM LETTER PHASE-D MU;Lo;0;L;;;;;N;;;;;
16954;BAMUM LETTER PHASE-D SHII;Lo;0;L;;;;;N;;;;;
16955;BAMUM LETTER PHASE-D SHEUX;Lo;0;L;;;;;N;;;;;
16956;BAMUM LETTER PHASE-D KYEE;Lo;0;L;;;;;N;;;;;
16957;BAMUM LETTER PHASE-D NU;Lo;0;L;;;;;N;;;;;
16958;BAMUM LETTER PHASE-D SHU;Lo;0;L;;;;;N;;;;;
16959;BAMUM LETTER PHASE-D NTEE;Lo;0;L;;;;;N;;;;;
1695A;BAMUM LETTER PHASE-D PEE;Lo;0;L;;;;;N;;;;;
1695B;BAMUM LETTER PHASE-D NI;Lo;0;L;;;;;N;;;;;
1695C;BAMUM LETTER PHASE-D SHOQ;Lo;0;L;;;;;N;;;;;
1695D;BAMUM LETTER PHASE-D PUQ;Lo;0;L;;;;;N;;;;;
1695E;BAMUM LETTER PHASE-D MVOP;Lo;0;L;;;;;N;;;;;
1695F;BAMUM LETTER PHASE-D LOQ;Lo;0;L;;;;;N;;;;;
16960;BAMUM LETTER PHASE-D REN MUCH;Lo;0;L;;;;;N;;;;;
16961;BAMUM LETTER PHASE-D TI;Lo;0;L;;;;;N;;;;;
16962;BAMUM LETTER PHASE-D NTUU;Lo;0;L;;;;;N;;;;;
16963;BAMUM LETTER PHASE-D MBAA SEVEN;Lo;0;L;;;;;N;;;;;
16964;BAMUM LETTER PHASE-D SAQ;Lo;0;L;;;;;N;;;;;
16965;BAMUM LETTER PHASE-D FAA;Lo;0;L;;;;;N;;;;;
16966;BAMUM LETTER PHASE-E NDAP;Lo;0;L;;;;;N;;;;;
16967;BAMUM LETTER PHASE-E TOON;Lo;0;L;;;;;N;;;;;
16968;BAMUM LETTER PHASE-E MBEUM;Lo;0;L;;;;;N;;;;;
16969;BAMUM LETTER PHASE-E LAP;Lo;0;L;;;;;N;;;;;
1696A;BAMUM LETTER PHASE-E VOM;Lo;0;L;;;;;N;;;;;
1696B;BAMUM LETTER PHASE-E LOON;Lo;0;L;;;;;N;;;;;
1696C;BAMUM LETTER PHASE-E PAA;Lo;0;L;;;;;N;;;;;
1696D;BAMUM LETTER PHASE-E SOM;Lo;0;L;;;;;N;;;;;
1696E;BAMUM LETTER PHASE-E RAQ;Lo;0;L;;;;;N;;;;;
1696F;BAMUM LETTER PHASE-E NSHUOP;Lo;0;L;;;;;N;;;;;
16970;BAMUM LETTER PHASE-E NDUN;Lo;0;L;;;;;N;;;;;
16971;BAMUM LETTER PHASE-E PUAE;Lo;0;L;;;;;N;;;;;
16972;BAMUM LETTER PHASE-E TAM;Lo;0;L;;;;;N;;;;;
16973;BAMUM LETTER PHASE-E NGKA;Lo;0;L;;;;;N;;;;;
16974;BAMUM LETTER PHASE-E KPEUX;Lo;0;L;;;;;N;;;;;
16975;BAMUM LETTER PHASE-E WUO;Lo;0;L;;;;;N;;;;;
16976;BAMUM LETTER PHASE-E SEE;Lo;0;L;;;;;N;;;;;
16977;BAMUM LETTER PHASE-E NGGEUAET;Lo;0;L;;;;;N;;;;;
16978;BAMUM LETTER PHASE-E PAAM;Lo;0;L;;;;;N;;;;;
16979;BAMUM LETTER PHASE-E TOO;Lo;0;L;;;;;N;;;;;
1697A;BAMUM LETTER PHASE-E KUOP;Lo;0;L;;;;;N;;;;;
1697B;BAMUM LETTER PHASE-E LOM;Lo;0;L;;;;;N;;;;;
1697C;BAMUM LETTER PHASE-E NSHIEE;Lo;0;L;;;;;N;;;;;
1697D;BAMUM LETTER PHASE-E NGOP;Lo;0;L;;;;;N;;;;;
1697E;BAMUM LETTER PHASE-E MAEM;Lo;0;L;;;;;N;;;;;
1697F;BAMUM LETTER PHASE-E NGKEUX;Lo;0;L;;;;;N;;;;;
16980;BAMUM LETTER PHASE-E NGOQ;Lo;0;L;;;;;N;;;;;
16981;BAMUM LETTER PHASE-E NSHUE;Lo;0;L;;;;;N;;;;;
16982;BAMUM LETTER PHASE-E RIMGBA;Lo;0;L;;;;;N;;;;;
16983;BAMUM LETTER PHASE-E NJEUX;Lo;0;L;;;;;N;;;;;
16984;BAMUM LETTER PHASE-E PEEM;Lo;0;L;;;;;N;;;;;
16985;BAMUM LETTER PHASE-E SAA;Lo;0;L;;;;;N;;;;;
16986;BAMUM LETTER PHASE-E NGGURAE;Lo;0;L;;;;;N;;;;;
16987;BAMUM LETTER PHASE-E MGBA;Lo;0;L;;;;;N;;;;;
16988;BAMUM LETTER PHASE-E GHEUX;Lo;0;L;;;;;N;;;;;
16989;BAMUM LETTER PHASE-E NGKEUAEM;Lo;0;L;;;;;N;;;;;
1698A;BAMUM LETTER PHASE-E NJAEMLI;Lo;0;L;;;;;N;;;;;
1698B;BAMUM LETTER PHASE-E MAP;Lo;0;L;;;;;N;;;;;
1698C;BAMUM LETTER PHASE-E LOOT;Lo;0;L;;;;;N;;;;;
1698D;BAMUM LETTER PHASE-E NGGEEEE;Lo;0;L;;;;;N;;;;;
1698E;BAMUM LETTER PHASE-E NDIQ;Lo;0;L;;;;;N;;;;;
1698F;BAMUM LETTER PHASE-E TAEN NTEUM;Lo;0;L;;;;;N;;;;;
16990;BAMUM LETTER PHASE-E SET;Lo;0;L;;;;;N;;;;;
16991;BAMUM LETTER PHASE-E PUM;Lo;0;L;;;;;N;;;;;
16992;BAMUM LETTER PHASE-E NDAA SOFTNESS;Lo;0;L;;;;;N;;;;;
16993;BAMUM LETTER PHASE-E NGGUAESHAE NYAM;Lo;0;L;;;;;N;;;;;
16994;BAMUM LETTER PHASE-E YIEE;Lo;0;L;;;;;N;;;;;
16995;BAMUM LETTER PHASE-E GHEUN;Lo;0;L;;;;;N;;;;;
16996;BAMUM LETTER PHASE-E TUAE;Lo;0;L;;;;;N;;;;;
16997;BAMUM LETTER PHASE-E YEUAE;Lo;0;L;;;;;N;;;;;
16998;BAMUM LETTER PHASE-E PO;Lo;0;L;;;;;N;;;;;
16999;BAMUM LETTER PHASE-E TUMAE;Lo;0;L;;;;;N;;;;;
1699A;BAMUM LETTER PHASE-E KEUAE;Lo;0;L;;;;;N;;;;;
1699B;BAMUM LETTER PHASE-E SUAEN;Lo;0;L;;;;;N;;;;;
1699C;BAMUM LETTER PHASE-E TEUAEQ;Lo;0;L;;;;;N;;;;;
1699D;BAMUM LETTER PHASE-E VEUAE;Lo;0;L;;;;;N;;;;;
1699E;BAMUM LETTER PHASE-E WEUX;Lo;0;L;;;;;N;;;;;
1699F;BAMUM LETTER PHASE-E LAAM;Lo;0;L;;;;;N;;;;;
169A0;BAMUM LETTER PHASE-E PU;Lo;0;L;;;;;N;;;;;
169A1;BAMUM LETTER PHASE-E TAAQ;Lo;0;L;;;;;N;;;;;
169A2;BAMUM LETTER PHASE-E GHAAMAE;Lo;0;L;;;;;N;;;;;
169A3;BAMUM LETTER PHASE-E NGEUREUT;Lo;0;L;;;;;N;;;;;
169A4;BAMUM LETTER PHASE-E SHEUAEQ;Lo;0;L;;;;;N;;;;;
169A5;BAMUM LETTER PHASE-E MGBEN;Lo;0;L;;;;;N;;;;;
169A6;BAMUM LETTER PHASE-E MBEE;Lo;0;L;;;;;N;;;;;
169A7;BAMUM LETTER PHASE-E NZAQ;Lo;0;L;;;;;N;;;;;
169A8;BAMUM LETTER PHASE-E NKOM;Lo;0;L;;;;;N;;;;;
169A9;BAMUM LETTER PHASE-E GBET;Lo;0;L;;;;;N;;;;;
169AA;BAMUM LETTER PHASE-E TUM;Lo;0;L;;;;;N;;;;;
169AB;BAMUM LETTER PHASE-E KUET;Lo;0;L;;;;;N;;;;;
169AC;BAMUM LETTER PHASE-E YAP;Lo;0;L;;;;;N;;;;;
169AD;BAMUM LETTER PHASE-E NYI CLEAVER;Lo;0;L;;;;;N;;;;;
169AE;BAMUM LETTER PHASE-E YIT;Lo;0;L;;;;;N;;;;;
169AF;BAMUM LETTER PHASE-E MFEUQ;Lo;0;L;;;;;N;;;;;
169B0;BAMUM LETTER PHASE-E NDIAQ;Lo;0;L;;;;;N;;;;;
169B1;BAMUM LETTER PHASE-E PIEEQ;Lo;0;L;;;;;N;;;;;
169B2;BAMUM LETTER PHASE-E YUEQ;Lo;0;L;;;;;N;;;;;
169B3;BAMUM LETTER PHASE-E LEUAEM;Lo;0;L;;;;;N;;;;;
169B4;BAMUM LETTER PHASE-E FUE;Lo;0;L;;;;;N;;;;;
169B5;BAMUM LETTER PHASE-E GBEUX;Lo;0;L;;;;;N;;;;;
169B6;BAMUM LETTER PHASE-E NGKUP;Lo;0;L;;;;;N;;;;;
169B7;BAMUM LETTER PHASE-E KET;Lo;0;L;;;;;N;;;;;
169B8;BAMUM LETTER PHASE-E MAE;Lo;0;L;;;;;N;;;;;
169B9;BAMUM LETTER PHASE-E NGKAAMI;Lo;0;L;;;;;N;;;;;
169BA;BAMUM LETTER PHASE-E GHET;Lo;0;L;;;;;N;;;;;
169BB;BAMUM LETTER PHASE-E FA;Lo;0;L;;;;;N;;;;;
169BC;BAMUM LETTER PHASE-E NTUM;Lo;0;L;;;;;N;;;;;
169BD;BAMUM LETTER PHASE-E PEUT;Lo;0;L;;;;;N;;;;;
169BE;BAMUM LETTER PHASE-E YEUM;Lo;0;L;;;;;N;;;;;
169BF;BAMUM LETTER PHASE-E NGGEUAE;Lo;0;L;;;;;N;;;;;
169C0;BAMUM LETTER PHASE-E NYI BETWEEN;Lo;0;L;;;;;N;;;;;
169C1;BAMUM LETTER PHASE-E NZUQ;Lo;0;L;;;;;N;;;;;
169C2;BAMUM LETTER PHASE-E POON;Lo;0;L;;;;;N;;;;;
169C3;BAMUM LETTER PHASE-E MIEE;Lo;0;L;;;;;N;;;;;
169C4;BAMUM LETTER PHASE-E FUET;Lo;0;L;;;;;N;;;;;
169C5;BAMUM LETTER PHASE-E NAE;Lo;0;L;;;;;N;;;;;
169C6;BAMUM LETTER PHASE-E MUAE;Lo;0;L;;;;;N;;;;;
169C7;BAMUM LETTER PHASE-E GHEUAE;Lo;0;L;;;;;N;;;;;
169C8;BAMUM LETTER PHASE-E FU I;Lo;0;L;;;;;N;;;;;
169C9;BAMUM LETTER PHASE-E MVI;Lo;0;L;;;;;N;;;;;
169CA;BAMUM LETTER PHASE-E PUAQ;Lo;0;L;;;;;N;;;;;
169CB;BAMUM LETTER PHASE-E NGKUM;Lo;0;L;;;;;N;;;;;
169CC;BAMUM LETTER PHASE-E KUT;Lo;0;L;;;;;N;;;;;
169CD;BAMUM LETTER PHASE-E PIET;Lo;0;L;;;;;N;;;;;
169CE;BAMUM LETTER PHASE-E NTAP;Lo;0;L;;;;;N;;;;;
169CF;BAMUM LETTER PHASE-E YEUAET;Lo;0;L;;;;;N;;;;;
169D0;BAMUM LETTER PHASE-E NGGUP;Lo;0;L;;;;;N;;;;;
169D1;BAMUM LETTER PHASE-E PA PEOPLE;Lo;0;L;;;;;N;;;;;
169D2;BAMUM LETTER PHASE-E FU CALL;Lo;0;L;;;;;N;;;;;
169D3;BAMUM LETTER PHASE-E FOM;Lo;0;L;;;;;N;;;;;
169D4;BAMUM LETTER PHASE-E NJEE;Lo;0;L;;;;;N;;;;;
169D5;BAMUM LETTER PHASE-E A;Lo;0;L;;;;;N;;;;;
169D6;BAMUM LETTER PHASE-E TOQ;Lo;0;L;;;;;N;;;;;
169D7;BAMUM LETTER PHASE-E O;Lo;0;L;;;;;N;;;;;
169D8;BAMUM LETTER PHASE-E I;Lo;0;L;;;;;N;;;;;
169D9;BAMUM LETTER PHASE-E LAQ;Lo;0;L;;;;;N;;;;;
169DA;BAMUM LETTER PHASE-E PA PLURAL;Lo;0;L;;;;;N;;;;;
169DB;BAMUM LETTER PHASE-E TAA;Lo;0;L;;;;;N;;;;;
169DC;BAMUM LETTER PHASE-E TAQ;Lo;0;L;;;;;N;;;;;
169DD;BAMUM LETTER PHASE-E NDAA MY HOUSE;Lo;0;L;;;;;N;;;;;
169DE;BAMUM LETTER PHASE-E SHIQ;Lo;0;L;;;;;N;;;;;
169DF;BAMUM LETTER PHASE-E YEUX;Lo;0;L;;;;;N;;;;;
169E0;BAMUM LETTER PHASE-E NGUAE;Lo;0;L;;;;;N;;;;;
169E1;BAMUM LETTER PHASE-E YUAEN;Lo;0;L;;;;;N;;;;;
169E2;BAMUM LETTER PHASE-E YOQ SWIMMING;Lo;0;L;;;;;N;;;;;
169E3;BAMUM LETTER PHASE-E YOQ COVER;Lo;0;L;;;;;N;;;;;
169E4;BAMUM LETTER PHASE-E YUQ;Lo;0;L;;;;;N;;;;;
169E5;BAMUM LETTER PHASE-E YUN;Lo;0;L;;;;;N;;;;;
169E6;BAMUM LETTER PHASE-E KEUX;Lo;0;L;;;;;N;;;;;
169E7;BAMUM LETTER PHASE-E PEUX;Lo;0;L;;;;;N;;;;;
169E8;BAMUM LETTER PHASE-E NJEE EPOCH;Lo;0;L;;;;;N;;;;;
169E9;BAMUM LETTER PHASE-E PUE;Lo;0;L;;;;;N;;;;;
169EA;BAMUM LETTER PHASE-E WUE;Lo;0;L;;;;;N;;;;;
169EB;BAMUM LETTER PHASE-E FEE;Lo;0;L;;;;;N;;;;;
169EC;BAMUM LETTER PHASE-E VEE;Lo;0;L;;;;;N;;;;;
169ED;BAMUM LETTER PHASE-E LU;Lo;0;L;;;;;N;;;;;
169EE;BAMUM LETTER PHASE-E MI;Lo;0;L;;;;;N;;;;;
169EF;BAMUM LETTER PHASE-E REUX;Lo;0;L;;;;;N;;;;;
169F0;BAMUM LETTER PHASE-E RAE;Lo;0;L;;;;;N;;;;;
169F1;BAMUM LETTER PHASE-E NGUAET;Lo;0;L;;;;;N;;;;;
169F2;BAMUM LETTER PHASE-E NGA;Lo;0;L;;;;;N;;;;;
169F3;BAMUM LETTER PHASE-E SHO;Lo;0;L;;;;;N;;;;;
169F4;BAMUM LETTER PHASE-E SHOQ;Lo;0;L;;;;;N;;;;;
169F5;BAMUM LETTER PHASE-E FU REMEDY;Lo;0;L;;;;;N;;;;;
169F6;BAMUM LETTER PHASE-E NA;Lo;0;L;;;;;N;;;;;
169F7;BAMUM LETTER PHASE-E PI;Lo;0;L;;;;;N;;;;;
169F8;BAMUM LETTER PHASE-E LOQ;Lo;0;L;;;;;N;;;;;
169F9;BAMUM LETTER PHASE-E KO;Lo;0;L;;;;;N;;;;;
169FA;BAMUM LETTER PHASE-E MEN;Lo;0;L;;;;;N;;;;;
169FB;BAMUM LETTER PHASE-E MA;Lo;0;L;;;;;N;;;;;
169FC;BAMUM LETTER PHASE-E MAQ;Lo;0;L;;;;;N;;;;;
169FD;BAMUM LETTER PHASE-E TEU;Lo;0;L;;;;;N;;;;;
169FE;BAMUM LETTER PHASE-E KI;Lo;0;L;;;;;N;;;;;
169FF;BAMUM LETTER PHASE-E MON;Lo;0;L;;;;;N;;;;;
16A00;BAMUM LETTER PHASE-E TEN;Lo;0;L;;;;;N;;;;;
16A01;BAMUM LETTER PHASE-E FAQ;Lo;0;L;;;;;N;;;;;
16A02;BAMUM LETTER PHASE-E GHOM;Lo;0;L;;;;;N;;;;;
16A03;BAMUM LETTER PHASE-F KA;Lo;0;L;;;;;N;;;;;
16A04;BAMUM LETTER PHASE-F U;Lo;0;L;;;;;N;;;;;
16A05;BAMUM LETTER PHASE-F KU;Lo;0;L;;;;;N;;;;;
16A06;BAMUM LETTER PHASE-F EE;Lo;0;L;;;;;N;;;;;
16A07;BAMUM LETTER PHASE-F REE;Lo;0;L;;;;;N;;;;;
16A08;BAMUM LETTER PHASE-F TAE;Lo;0;L;;;;;N;;;;;
16A09;BAMUM LETTER PHASE-F NYI;Lo;0;L;;;;;N;;;;;
16A0A;BAMUM LETTER PHASE-F LA;Lo;0;L;;;;;N;;;;;
16A0B;BAMUM LETTER PHASE-F RII;Lo;0;L;;;;;N;;;;;
16A0C;BAMUM LETTER PHASE-F RIEE;Lo;0;L;;;;;N;;;;;
16A0D;BAMUM LETTER PHASE-F MEEEE;Lo;0;L;;;;;N;;;;;
16A0E;BAMUM LETTER PHASE-F TAA;Lo;0;L;;;;;N;;;;;
16A0F;BAMUM LETTER PHASE-F NDAA;Lo;0;L;;;;;N;;;;;
16A10;BAMUM LETTER PHASE-F NJAEM;Lo;0;L;;;;;N;;;;;
16A11;BAMUM LETTER PHASE-F M;Lo;0;L;;;;;N;;;;;
16A12;BAMUM LETTER PHASE-F SUU;Lo;0;L;;;;;N;;;;;
16A13;BAMUM LETTER PHASE-F SHII;Lo;0;L;;;;;N;;;;;
16A14;BAMUM LETTER PHASE-F SI;Lo;0;L;;;;;N;;;;;
16A15;BAMUM LETTER PHASE-F SEUX;Lo;0;L;;;;;N;;;;;
16A16;BAMUM LETTER PHASE-F KYEE;Lo;0;L;;;;;N;;;;;
16A17;BAMUM LETTER PHASE-F KET;Lo;0;L;;;;;N;;;;;
16A18;BAMUM LETTER PHASE-F NUAE;Lo;0;L;;;;;N;;;;;
16A19;BAMUM LETTER PHASE-F NU;Lo;0;L;;;;;N;;;;;
16A1A;BAMUM LETTER PHASE-F NJUAE;Lo;0;L;;;;;N;;;;;
16A1B;BAMUM LETTER PHASE-F YOQ;Lo;0;L;;;;;N;;;;;
16A1C;BAMUM LETTER PHASE-F SHU;Lo;0;L;;;;;N;;;;;
16A1D;BAMUM LETTER PHASE-F YA;Lo;0;L;;;;;N;;;;;
16A1E;BAMUM LETTER PHASE-F NSHA;Lo;0;L;;;;;N;;;;;
16A1F;BAMUM LETTER PHASE-F PEUX;Lo;0;L;;;;;N;;;;;
16A20;BAMUM LETTER PHASE-F NTEE;Lo;0;L;;;;;N;;;;;
16A21;BAMUM LETTER PHASE-F WUE;Lo;0;L;;;;;N;;;;;
16A22;BAMUM LETTER PHASE-F PEE;Lo;0;L;;;;;N;;;;;
16A23;BAMUM LETTER PHASE-F RU;Lo;0;L;;;;;N;;;;;
16A24;BAMUM LETTER PHASE-F NI;Lo;0;L;;;;;N;;;;;
16A25;BAMUM LETTER PHASE-F REUX;Lo;0;L;;;;;N;;;;;
16A26;BAMUM LETTER PHASE-F KEN;Lo;0;L;;;;;N;;;;;
16A27;BAMUM LETTER PHASE-F NGKWAEN;Lo;0;L;;;;;N;;;;;
16A28;BAMUM LETTER PHASE-F NGGA;Lo;0;L;;;;;N;;;;;
16A29;BAMUM LETTER PHASE-F SHO;Lo;0;L;;;;;N;;;;;
16A2A;BAMUM LETTER PHASE-F PUAE;Lo;0;L;;;;;N;;;;;
16A2B;BAMUM LETTER PHASE-F FOM;Lo;0;L;;;;;N;;;;;
16A2C;BAMUM LETTER PHASE-F WA;Lo;0;L;;;;;N;;;;;
16A2D;BAMUM LETTER PHASE-F LI;Lo;0;L;;;;;N;;;;;
16A2E;BAMUM LETTER PHASE-F LOQ;Lo;0;L;;;;;N;;;;;
16A2F;BAMUM LETTER PHASE-F KO;Lo;0;L;;;;;N;;;;;
16A30;BAMUM LETTER PHASE-F MBEN;Lo;0;L;;;;;N;;;;;
16A31;BAMUM LETTER PHASE-F REN;Lo;0;L;;;;;N;;;;;
16A32;BAMUM LETTER PHASE-F MA;Lo;0;L;;;;;N;;;;;
16A33;BAMUM LETTER PHASE-F MO;Lo;0;L;;;;;N;;;;;
16A34;BAMUM LETTER PHASE-F MBAA;Lo;0;L;;;;;N;;;;;
16A35;BAMUM LETTER PHASE-F TET;Lo;0;L;;;;;N;;;;;
16A36;BAMUM LETTER PHASE-F KPA;Lo;0;L;;;;;N;;;;;
16A37;BAMUM LETTER PHASE-F SAMBA;Lo;0;L;;;;;N;;;;;
16A38;BAMUM LETTER PHASE-F VUEQ;Lo;0;L;;;;;N;;;;;
16A40;MRO LETTER TA;Lo;0;L;;;;;N;;;;;
16A41;MRO LETTER NGI;Lo;0;L;;;;;N;;;;;
16A42;MRO LETTER YO;Lo;0;L;;;;;N;;;;;
16A43;MRO LETTER MIM;Lo;0;L;;;;;N;;;;;
16A44;MRO LETTER BA;Lo;0;L;;;;;N;;;;;
16A45;MRO LETTER DA;Lo;0;L;;;;;N;;;;;
16A46;MRO LETTER A;Lo;0;L;;;;;N;;;;;
16A47;MRO LETTER PHI;Lo;0;L;;;;;N;;;;;
16A48;MRO LETTER KHAI;Lo;0;L;;;;;N;;;;;
16A49;MRO LETTER HAO;Lo;0;L;;;;;N;;;;;
16A4A;MRO LETTER DAI;Lo;0;L;;;;;N;;;;;
16A4B;MRO LETTER CHU;Lo;0;L;;;;;N;;;;;
16A4C;MRO LETTER KEAAE;Lo;0;L;;;;;N;;;;;
16A4D;MRO LETTER OL;Lo;0;L;;;;;N;;;;;
16A4E;MRO LETTER MAEM;Lo;0;L;;;;;N;;;;;
16A4F;MRO LETTER NIN;Lo;0;L;;;;;N;;;;;
16A50;MRO LETTER PA;Lo;0;L;;;;;N;;;;;
16A51;MRO LETTER OO;Lo;0;L;;;;;N;;;;;
16A52;MRO LETTER O;Lo;0;L;;;;;N;;;;;
16A53;MRO LETTER RO;Lo;0;L;;;;;N;;;;;
16A54;MRO LETTER SHI;Lo;0;L;;;;;N;;;;;
16A55;MRO LETTER THEA;Lo;0;L;;;;;N;;;;;
16A56;MRO LETTER EA;Lo;0;L;;;;;N;;;;;
16A57;MRO LETTER WA;Lo;0;L;;;;;N;;;;;
16A58;MRO LETTER E;Lo;0;L;;;;;N;;;;;
16A59;MRO LETTER KO;Lo;0;L;;;;;N;;;;;
16A5A;MRO LETTER LAN;Lo;0;L;;;;;N;;;;;
16A5B;MRO LETTER LA;Lo;0;L;;;;;N;;;;;
16A5C;MRO LETTER HAI;Lo;0;L;;;;;N;;;;;
16A5D;MRO LETTER RI;Lo;0;L;;;;;N;;;;;
16A5E;MRO LETTER TEK;Lo;0;L;;;;;N;;;;;
16A60;MRO DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
16A61;MRO DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
16A62;MRO DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
16A63;MRO DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
16A64;MRO DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
16A65;MRO DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
16A66;MRO DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
16A67;MRO DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
16A68;MRO DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
16A69;MRO DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
16A6E;MRO DANDA;Po;0;L;;;;;N;;;;;
16A6F;MRO DOUBLE DANDA;Po;0;L;;;;;N;;;;;
16A70;TANGSA LETTER OZ;Lo;0;L;;;;;N;;;;;
16A71;TANGSA LETTER OC;Lo;0;L;;;;;N;;;;;
16A72;TANGSA LETTER OQ;Lo;0;L;;;;;N;;;;;
16A73;TANGSA LETTER OX;Lo;0;L;;;;;N;;;;;
16A74;TANGSA LETTER AZ;Lo;0;L;;;;;N;;;;;
16A75;TANGSA LETTER AC;Lo;0;L;;;;;N;;;;;
16A76;TANGSA LETTER AQ;Lo;0;L;;;;;N;;;;;
16A77;TANGSA LETTER AX;Lo;0;L;;;;;N;;;;;
16A78;TANGSA LETTER VZ;Lo;0;L;;;;;N;;;;;
16A79;TANGSA LETTER VC;Lo;0;L;;;;;N;;;;;
16A7A;TANGSA LETTER VQ;Lo;0;L;;;;;N;;;;;
16A7B;TANGSA LETTER VX;Lo;0;L;;;;;N;;;;;
16A7C;TANGSA LETTER EZ;Lo;0;L;;;;;N;;;;;
16A7D;TANGSA LETTER EC;Lo;0;L;;;;;N;;;;;
16A7E;TANGSA LETTER EQ;Lo;0;L;;;;;N;;;;;
16A7F;TANGSA LETTER EX;Lo;0;L;;;;;N;;;;;
16A80;TANGSA LETTER IZ;Lo;0;L;;;;;N;;;;;
16A81;TANGSA LETTER IC;Lo;0;L;;;;;N;;;;;
16A82;TANGSA LETTER IQ;Lo;0;L;;;;;N;;;;;
16A83;TANGSA LETTER IX;Lo;0;L;;;;;N;;;;;
16A84;TANGSA LETTER UZ;Lo;0;L;;;;;N;;;;;
16A85;TANGSA LETTER UC;Lo;0;L;;;;;N;;;;;
16A86;TANGSA LETTER UQ;Lo;0;L;;;;;N;;;;;
16A87;TANGSA LETTER UX;Lo;0;L;;;;;N;;;;;
16A88;TANGSA LETTER AWZ;Lo;0;L;;;;;N;;;;;
16A89;TANGSA LETTER AWC;Lo;0;L;;;;;N;;;;;
16A8A;TANGSA LETTER AWQ;Lo;0;L;;;;;N;;;;;
16A8B;TANGSA LETTER AWX;Lo;0;L;;;;;N;;;;;
16A8C;TANGSA LETTER UIZ;Lo;0;L;;;;;N;;;;;
16A8D;TANGSA LETTER UIC;Lo;0;L;;;;;N;;;;;
16A8E;TANGSA LETTER UIQ;Lo;0;L;;;;;N;;;;;
16A8F;TANGSA LETTER UIX;Lo;0;L;;;;;N;;;;;
16A90;TANGSA LETTER FINAL NG;Lo;0;L;;;;;N;;;;;
16A91;TANGSA LETTER LONG UEX;Lo;0;L;;;;;N;;;;;
16A92;TANGSA LETTER SHORT UEZ;Lo;0;L;;;;;N;;;;;
16A93;TANGSA LETTER SHORT AWX;Lo;0;L;;;;;N;;;;;
16A94;TANGSA LETTER UEC;Lo;0;L;;;;;N;;;;;
16A95;TANGSA LETTER UEZ;Lo;0;L;;;;;N;;;;;
16A96;TANGSA LETTER UEQ;Lo;0;L;;;;;N;;;;;
16A97;TANGSA LETTER UEX;Lo;0;L;;;;;N;;;;;
16A98;TANGSA LETTER UIUZ;Lo;0;L;;;;;N;;;;;
16A99;TANGSA LETTER UIUC;Lo;0;L;;;;;N;;;;;
16A9A;TANGSA LETTER UIUQ;Lo;0;L;;;;;N;;;;;
16A9B;TANGSA LETTER UIUX;Lo;0;L;;;;;N;;;;;
16A9C;TANGSA LETTER MZ;Lo;0;L;;;;;N;;;;;
16A9D;TANGSA LETTER MC;Lo;0;L;;;;;N;;;;;
16A9E;TANGSA LETTER MQ;Lo;0;L;;;;;N;;;;;
16A9F;TANGSA LETTER MX;Lo;0;L;;;;;N;;;;;
16AA0;TANGSA LETTER KA;Lo;0;L;;;;;N;;;;;
16AA1;TANGSA LETTER KHA;Lo;0;L;;;;;N;;;;;
16AA2;TANGSA LETTER GA;Lo;0;L;;;;;N;;;;;
16AA3;TANGSA LETTER NGA;Lo;0;L;;;;;N;;;;;
16AA4;TANGSA LETTER SA;Lo;0;L;;;;;N;;;;;
16AA5;TANGSA LETTER YA;Lo;0;L;;;;;N;;;;;
16AA6;TANGSA LETTER WA;Lo;0;L;;;;;N;;;;;
16AA7;TANGSA LETTER PA;Lo;0;L;;;;;N;;;;;
16AA8;TANGSA LETTER NYA;Lo;0;L;;;;;N;;;;;
16AA9;TANGSA LETTER PHA;Lo;0;L;;;;;N;;;;;
16AAA;TANGSA LETTER BA;Lo;0;L;;;;;N;;;;;
16AAB;TANGSA LETTER MA;Lo;0;L;;;;;N;;;;;
16AAC;TANGSA LETTER NA;Lo;0;L;;;;;N;;;;;
16AAD;TANGSA LETTER HA;Lo;0;L;;;;;N;;;;;
16AAE;TANGSA LETTER LA;Lo;0;L;;;;;N;;;;;
16AAF;TANGSA LETTER HTA;Lo;0;L;;;;;N;;;;;
16AB0;TANGSA LETTER TA;Lo;0;L;;;;;N;;;;;
16AB1;TANGSA LETTER DA;Lo;0;L;;;;;N;;;;;
16AB2;TANGSA LETTER RA;Lo;0;L;;;;;N;;;;;
16AB3;TANGSA LETTER NHA;Lo;0;L;;;;;N;;;;;
16AB4;TANGSA LETTER SHA;Lo;0;L;;;;;N;;;;;
16AB5;TANGSA LETTER CA;Lo;0;L;;;;;N;;;;;
16AB6;TANGSA LETTER TSA;Lo;0;L;;;;;N;;;;;
16AB7;TANGSA LETTER GHA;Lo;0;L;;;;;N;;;;;
16AB8;TANGSA LETTER HTTA;Lo;0;L;;;;;N;;;;;
16AB9;TANGSA LETTER THA;Lo;0;L;;;;;N;;;;;
16ABA;TANGSA LETTER XA;Lo;0;L;;;;;N;;;;;
16ABB;TANGSA LETTER FA;Lo;0;L;;;;;N;;;;;
16ABC;TANGSA LETTER DHA;Lo;0;L;;;;;N;;;;;
16ABD;TANGSA LETTER CHA;Lo;0;L;;;;;N;;;;;
16ABE;TANGSA LETTER ZA;Lo;0;L;;;;;N;;;;;
16AC0;TANGSA DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
16AC1;TANGSA DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
16AC2;TANGSA DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
16AC3;TANGSA DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
16AC4;TANGSA DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
16AC5;TANGSA DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
16AC6;TANGSA DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
16AC7;TANGSA DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
16AC8;TANGSA DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
16AC9;TANGSA DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
16AD0;BASSA VAH LETTER ENNI;Lo;0;L;;;;;N;;;;;
16AD1;BASSA VAH LETTER KA;Lo;0;L;;;;;N;;;;;
16AD2;BASSA VAH LETTER SE;Lo;0;L;;;;;N;;;;;
16AD3;BASSA VAH LETTER FA;Lo;0;L;;;;;N;;;;;
16AD4;BASSA VAH LETTER MBE;Lo;0;L;;;;;N;;;;;
16AD5;BASSA VAH LETTER YIE;Lo;0;L;;;;;N;;;;;
16AD6;BASSA VAH LETTER GAH;Lo;0;L;;;;;N;;;;;
16AD7;BASSA VAH LETTER DHII;Lo;0;L;;;;;N;;;;;
16AD8;BASSA VAH LETTER KPAH;Lo;0;L;;;;;N;;;;;
16AD9;BASSA VAH LETTER JO;Lo;0;L;;;;;N;;;;;
16ADA;BASSA VAH LETTER HWAH;Lo;0;L;;;;;N;;;;;
16ADB;BASSA VAH LETTER WA;Lo;0;L;;;;;N;;;;;
16ADC;BASSA VAH LETTER ZO;Lo;0;L;;;;;N;;;;;
16ADD;BASSA VAH LETTER GBU;Lo;0;L;;;;;N;;;;;
16ADE;BASSA VAH LETTER DO;Lo;0;L;;;;;N;;;;;
16ADF;BASSA VAH LETTER CE;Lo;0;L;;;;;N;;;;;
16AE0;BASSA VAH LETTER UWU;Lo;0;L;;;;;N;;;;;
16AE1;BASSA VAH LETTER TO;Lo;0;L;;;;;N;;;;;
16AE2;BASSA VAH LETTER BA;Lo;0;L;;;;;N;;;;;
16AE3;BASSA VAH LETTER VU;Lo;0;L;;;;;N;;;;;
16AE4;BASSA VAH LETTER YEIN;Lo;0;L;;;;;N;;;;;
16AE5;BASSA VAH LETTER PA;Lo;0;L;;;;;N;;;;;
16AE6;BASSA VAH LETTER WADDA;Lo;0;L;;;;;N;;;;;
16AE7;BASSA VAH LETTER A;Lo;0;L;;;;;N;;;;;
16AE8;BASSA VAH LETTER O;Lo;0;L;;;;;N;;;;;
16AE9;BASSA VAH LETTER OO;Lo;0;L;;;;;N;;;;;
16AEA;BASSA VAH LETTER U;Lo;0;L;;;;;N;;;;;
16AEB;BASSA VAH LETTER EE;Lo;0;L;;;;;N;;;;;
16AEC;BASSA VAH LETTER E;Lo;0;L;;;;;N;;;;;
16AED;BASSA VAH LETTER I;Lo;0;L;;;;;N;;;;;
16AF0;BASSA VAH COMBINING HIGH TONE;Mn;1;NSM;;;;;N;;;;;
16AF1;BASSA VAH COMBINING LOW TONE;Mn;1;NSM;;;;;N;;;;;
16AF2;BASSA VAH COMBINING MID TONE;Mn;1;NSM;;;;;N;;;;;
16AF3;BASSA VAH COMBINING LOW-MID TONE;Mn;1;NSM;;;;;N;;;;;
16AF4;BASSA VAH COMBINING HIGH-LOW TONE;Mn;1;NSM;;;;;N;;;;;
16AF5;BASSA VAH FULL STOP;Po;0;L;;;;;N;;;;;
16B00;PAHAWH HMONG VOWEL KEEB;Lo;0;L;;;;;N;;;;;
16B01;PAHAWH HMONG VOWEL KEEV;Lo;0;L;;;;;N;;;;;
16B02;PAHAWH HMONG VOWEL KIB;Lo;0;L;;;;;N;;;;;
16B03;PAHAWH HMONG VOWEL KIV;Lo;0;L;;;;;N;;;;;
16B04;PAHAWH HMONG VOWEL KAUB;Lo;0;L;;;;;N;;;;;
16B05;PAHAWH HMONG VOWEL KAUV;Lo;0;L;;;;;N;;;;;
16B06;PAHAWH HMONG VOWEL KUB;Lo;0;L;;;;;N;;;;;
16B07;PAHAWH HMONG VOWEL KUV;Lo;0;L;;;;;N;;;;;
16B08;PAHAWH HMONG VOWEL KEB;Lo;0;L;;;;;N;;;;;
16B09;PAHAWH HMONG VOWEL KEV;Lo;0;L;;;;;N;;;;;
16B0A;PAHAWH HMONG VOWEL KAIB;Lo;0;L;;;;;N;;;;;
16B0B;PAHAWH HMONG VOWEL KAIV;Lo;0;L;;;;;N;;;;;
16B0C;PAHAWH HMONG VOWEL KOOB;Lo;0;L;;;;;N;;;;;
16B0D;PAHAWH HMONG VOWEL KOOV;Lo;0;L;;;;;N;;;;;
16B0E;PAHAWH HMONG VOWEL KAWB;Lo;0;L;;;;;N;;;;;
16B0F;PAHAWH HMONG VOWEL KAWV;Lo;0;L;;;;;N;;;;;
16B10;PAHAWH HMONG VOWEL KUAB;Lo;0;L;;;;;N;;;;;
16B11;PAHAWH HMONG VOWEL KUAV;Lo;0;L;;;;;N;;;;;
16B12;PAHAWH HMONG VOWEL KOB;Lo;0;L;;;;;N;;;;;
16B13;PAHAWH HMONG VOWEL KOV;Lo;0;L;;;;;N;;;;;
16B14;PAHAWH HMONG VOWEL KIAB;Lo;0;L;;;;;N;;;;;
16B15;PAHAWH HMONG VOWEL KIAV;Lo;0;L;;;;;N;;;;;
16B16;PAHAWH HMONG VOWEL KAB;Lo;0;L;;;;;N;;;;;
16B17;PAHAWH HMONG VOWEL KAV;Lo;0;L;;;;;N;;;;;
16B18;PAHAWH HMONG VOWEL KWB;Lo;0;L;;;;;N;;;;;
16B19;PAHAWH HMONG VOWEL KWV;Lo;0;L;;;;;N;;;;;
16B1A;PAHAWH HMONG VOWEL KAAB;Lo;0;L;;;;;N;;;;;
16B1B;PAHAWH HMONG VOWEL KAAV;Lo;0;L;;;;;N;;;;;
16B1C;PAHAWH HMONG CONSONANT VAU;Lo;0;L;;;;;N;;;;;
16B1D;PAHAWH HMONG CONSONANT NTSAU;Lo;0;L;;;;;N;;;;;
16B1E;PAHAWH HMONG CONSONANT LAU;Lo;0;L;;;;;N;;;;;
16B1F;PAHAWH HMONG CONSONANT HAU;Lo;0;L;;;;;N;;;;;
16B20;PAHAWH HMONG CONSONANT NLAU;Lo;0;L;;;;;N;;;;;
16B21;PAHAWH HMONG CONSONANT RAU;Lo;0;L;;;;;N;;;;;
16B22;PAHAWH HMONG CONSONANT NKAU;Lo;0;L;;;;;N;;;;;
16B23;PAHAWH HMONG CONSONANT QHAU;Lo;0;L;;;;;N;;;;;
16B24;PAHAWH HMONG CONSONANT YAU;Lo;0;L;;;;;N;;;;;
16B25;PAHAWH HMONG CONSONANT HLAU;Lo;0;L;;;;;N;;;;;
16B26;PAHAWH HMONG CONSONANT MAU;Lo;0;L;;;;;N;;;;;
16B27;PAHAWH HMONG CONSONANT CHAU;Lo;0;L;;;;;N;;;;;
16B28;PAHAWH HMONG CONSONANT NCHAU;Lo;0;L;;;;;N;;;;;
16B29;PAHAWH HMONG CONSONANT HNAU;Lo;0;L;;;;;N;;;;;
16B2A;PAHAWH HMONG CONSONANT PLHAU;Lo;0;L;;;;;N;;;;;
16B2B;PAHAWH HMONG CONSONANT NTHAU;Lo;0;L;;;;;N;;;;;
16B2C;PAHAWH HMONG CONSONANT NAU;Lo;0;L;;;;;N;;;;;
16B2D;PAHAWH HMONG CONSONANT AU;Lo;0;L;;;;;N;;;;;
16B2E;PAHAWH HMONG CONSONANT XAU;Lo;0;L;;;;;N;;;;;
16B2F;PAHAWH HMONG CONSONANT CAU;Lo;0;L;;;;;N;;;;;
16B30;PAHAWH HMONG MARK CIM TUB;Mn;230;NSM;;;;;N;;;;;
16B31;PAHAWH HMONG MARK CIM SO;Mn;230;NSM;;;;;N;;;;;
16B32;PAHAWH HMONG MARK CIM KES;Mn;230;NSM;;;;;N;;;;;
16B33;PAHAWH HMONG MARK CIM KHAV;Mn;230;NSM;;;;;N;;;;;
16B34;PAHAWH HMONG MARK CIM SUAM;Mn;230;NSM;;;;;N;;;;;
16B35;PAHAWH HMONG MARK CIM HOM;Mn;230;NSM;;;;;N;;;;;
16B36;PAHAWH HMONG MARK CIM TAUM;Mn;230;NSM;;;;;N;;;;;
16B37;PAHAWH HMONG SIGN VOS THOM;Po;0;L;;;;;N;;;;;
16B38;PAHAWH HMONG SIGN VOS TSHAB CEEB;Po;0;L;;;;;N;;;;;
16B39;PAHAWH HMONG SIGN CIM CHEEM;Po;0;L;;;;;N;;;;;
16B3A;PAHAWH HMONG SIGN VOS THIAB;Po;0;L;;;;;N;;;;;
16B3B;PAHAWH HMONG SIGN VOS FEEM;Po;0;L;;;;;N;;;;;
16B3C;PAHAWH HMONG SIGN XYEEM NTXIV;So;0;L;;;;;N;;;;;
16B3D;PAHAWH HMONG SIGN XYEEM RHO;So;0;L;;;;;N;;;;;
16B3E;PAHAWH HMONG SIGN XYEEM TOV;So;0;L;;;;;N;;;;;
16B3F;PAHAWH HMONG SIGN XYEEM FAIB;So;0;L;;;;;N;;;;;
16B40;PAHAWH HMONG SIGN VOS SEEV;Lm;0;L;;;;;N;;;;;
16B41;PAHAWH HMONG SIGN MEEJ SUAB;Lm;0;L;;;;;N;;;;;
16B42;PAHAWH HMONG SIGN VOS NRUA;Lm;0;L;;;;;N;;;;;
16B43;PAHAWH HMONG SIGN IB YAM;Lm;0;L;;;;;N;;;;;
16B44;PAHAWH HMONG SIGN XAUS;Po;0;L;;;;;N;;;;;
16B45;PAHAWH HMONG SIGN CIM TSOV ROG;So;0;L;;;;;N;;;;;
16B50;PAHAWH HMONG DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
16B51;PAHAWH HMONG DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
16B52;PAHAWH HMONG DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
16B53;PAHAWH HMONG DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
16B54;PAHAWH HMONG DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
16B55;PAHAWH HMONG DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
16B56;PAHAWH HMONG DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
16B57;PAHAWH HMONG DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
16B58;PAHAWH HMONG DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
16B59;PAHAWH HMONG DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
16B5B;PAHAWH HMONG NUMBER TENS;No;0;L;;;;10;N;;;;;
16B5C;PAHAWH HMONG NUMBER HUNDREDS;No;0;L;;;;100;N;;;;;
16B5D;PAHAWH HMONG NUMBER TEN THOUSANDS;No;0;L;;;;10000;N;;;;;
16B5E;PAHAWH HMONG NUMBER MILLIONS;No;0;L;;;;1000000;N;;;;;
16B5F;PAHAWH HMONG NUMBER HUNDRED MILLIONS;No;0;L;;;;100000000;N;;;;;
16B60;PAHAWH HMONG NUMBER TEN BILLIONS;No;0;L;;;;10000000000;N;;;;;
16B61;PAHAWH HMONG NUMBER TRILLIONS;No;0;L;;;;1000000000000;N;;;;;
16B63;PAHAWH HMONG SIGN VOS LUB;Lo;0;L;;;;;N;;;;;
16B64;PAHAWH HMONG SIGN XYOO;Lo;0;L;;;;;N;;;;;
16B65;PAHAWH HMONG SIGN HLI;Lo;0;L;;;;;N;;;;;
16B66;PAHAWH HMONG SIGN THIRD-STAGE HLI;Lo;0;L;;;;;N;;;;;
16B67;PAHAWH HMONG SIGN ZWJ THAJ;Lo;0;L;;;;;N;;;;;
16B68;PAHAWH HMONG SIGN HNUB;Lo;0;L;;;;;N;;;;;
16B69;PAHAWH HMONG SIGN NQIG;Lo;0;L;;;;;N;;;;;
16B6A;PAHAWH HMONG SIGN XIAB;Lo;0;L;;;;;N;;;;;
16B6B;PAHAWH HMONG SIGN NTUJ;Lo;0;L;;;;;N;;;;;
16B6C;PAHAWH HMONG SIGN AV;Lo;0;L;;;;;N;;;;;
16B6D;PAHAWH HMONG SIGN TXHEEJ CEEV;Lo;0;L;;;;;N;;;;;
16B6E;PAHAWH HMONG SIGN MEEJ TSEEB;Lo;0;L;;;;;N;;;;;
16B6F;PAHAWH HMONG SIGN TAU;Lo;0;L;;;;;N;;;;;
16B70;PAHAWH HMONG SIGN LOS;Lo;0;L;;;;;N;;;;;
16B71;PAHAWH HMONG SIGN MUS;Lo;0;L;;;;;N;;;;;
16B72;PAHAWH HMONG SIGN CIM HAIS LUS NTOG NTOG;Lo;0;L;;;;;N;;;;;
16B73;PAHAWH HMONG SIGN CIM CUAM TSHOOJ;Lo;0;L;;;;;N;;;;;
16B74;PAHAWH HMONG SIGN CIM TXWV;Lo;0;L;;;;;N;;;;;
16B75;PAHAWH HMONG SIGN CIM TXWV CHWV;Lo;0;L;;;;;N;;;;;
16B76;PAHAWH HMONG SIGN CIM PUB DAWB;Lo;0;L;;;;;N;;;;;
16B77;PAHAWH HMONG SIGN CIM NRES TOS;Lo;0;L;;;;;N;;;;;
16B7D;PAHAWH HMONG CLAN SIGN TSHEEJ;Lo;0;L;;;;;N;;;;;
16B7E;PAHAWH HMONG CLAN SIGN YEEG;Lo;0;L;;;;;N;;;;;
16B7F;PAHAWH HMONG CLAN SIGN LIS;Lo;0;L;;;;;N;;;;;
16B80;PAHAWH HMONG CLAN SIGN LAUJ;Lo;0;L;;;;;N;;;;;
16B81;PAHAWH HMONG CLAN SIGN XYOOJ;Lo;0;L;;;;;N;;;;;
16B82;PAHAWH HMONG CLAN SIGN KOO;Lo;0;L;;;;;N;;;;;
16B83;PAHAWH HMONG CLAN SIGN HAWJ;Lo;0;L;;;;;N;;;;;
16B84;PAHAWH HMONG CLAN SIGN MUAS;Lo;0;L;;;;;N;;;;;
16B85;PAHAWH HMONG CLAN SIGN THOJ;Lo;0;L;;;;;N;;;;;
16B86;PAHAWH HMONG CLAN SIGN TSAB;Lo;0;L;;;;;N;;;;;
16B87;PAHAWH HMONG CLAN SIGN PHAB;Lo;0;L;;;;;N;;;;;
16B88;PAHAWH HMONG CLAN SIGN KHAB;Lo;0;L;;;;;N;;;;;
16B89;PAHAWH HMONG CLAN SIGN HAM;Lo;0;L;;;;;N;;;;;
16B8A;PAHAWH HMONG CLAN SIGN VAJ;Lo;0;L;;;;;N;;;;;
16B8B;PAHAWH HMONG CLAN SIGN FAJ;Lo;0;L;;;;;N;;;;;
16B8C;PAHAWH HMONG CLAN SIGN YAJ;Lo;0;L;;;;;N;;;;;
16B8D;PAHAWH HMONG CLAN SIGN TSWB;Lo;0;L;;;;;N;;;;;
16B8E;PAHAWH HMONG CLAN SIGN KWM;Lo;0;L;;;;;N;;;;;
16B8F;PAHAWH HMONG CLAN SIGN VWJ;Lo;0;L;;;;;N;;;;;
16E40;MEDEFAIDRIN CAPITAL LETTER M;Lu;0;L;;;;;N;;;;16E60;
16E41;MEDEFAIDRIN CAPITAL LETTER S;Lu;0;L;;;;;N;;;;16E61;
16E42;MEDEFAIDRIN CAPITAL LETTER V;Lu;0;L;;;;;N;;;;16E62;
16E43;MEDEFAIDRIN CAPITAL LETTER W;Lu;0;L;;;;;N;;;;16E63;
16E44;MEDEFAIDRIN CAPITAL LETTER ATIU;Lu;0;L;;;;;N;;;;16E64;
16E45;MEDEFAIDRIN CAPITAL LETTER Z;Lu;0;L;;;;;N;;;;16E65;
16E46;MEDEFAIDRIN CAPITAL LETTER KP;Lu;0;L;;;;;N;;;;16E66;
16E47;MEDEFAIDRIN CAPITAL LETTER P;Lu;0;L;;;;;N;;;;16E67;
16E48;MEDEFAIDRIN CAPITAL LETTER T;Lu;0;L;;;;;N;;;;16E68;
16E49;MEDEFAIDRIN CAPITAL LETTER G;Lu;0;L;;;;;N;;;;16E69;
16E4A;MEDEFAIDRIN CAPITAL LETTER F;Lu;0;L;;;;;N;;;;16E6A;
16E4B;MEDEFAIDRIN CAPITAL LETTER I;Lu;0;L;;;;;N;;;;16E6B;
16E4C;MEDEFAIDRIN CAPITAL LETTER K;Lu;0;L;;;;;N;;;;16E6C;
16E4D;MEDEFAIDRIN CAPITAL LETTER A;Lu;0;L;;;;;N;;;;16E6D;
16E4E;MEDEFAIDRIN CAPITAL LETTER J;Lu;0;L;;;;;N;;;;16E6E;
16E4F;MEDEFAIDRIN CAPITAL LETTER E;Lu;0;L;;;;;N;;;;16E6F;
16E50;MEDEFAIDRIN CAPITAL LETTER B;Lu;0;L;;;;;N;;;;16E70;
16E51;MEDEFAIDRIN CAPITAL LETTER C;Lu;0;L;;;;;N;;;;16E71;
16E52;MEDEFAIDRIN CAPITAL LETTER U;Lu;0;L;;;;;N;;;;16E72;
16E53;MEDEFAIDRIN CAPITAL LETTER YU;Lu;0;L;;;;;N;;;;16E73;
16E54;MEDEFAIDRIN CAPITAL LETTER L;Lu;0;L;;;;;N;;;;16E74;
16E55;MEDEFAIDRIN CAPITAL LETTER Q;Lu;0;L;;;;;N;;;;16E75;
16E56;MEDEFAIDRIN CAPITAL LETTER HP;Lu;0;L;;;;;N;;;;16E76;
16E57;MEDEFAIDRIN CAPITAL LETTER NY;Lu;0;L;;;;;N;;;;16E77;
16E58;MEDEFAIDRIN CAPITAL LETTER X;Lu;0;L;;;;;N;;;;16E78;
16E59;MEDEFAIDRIN CAPITAL LETTER D;Lu;0;L;;;;;N;;;;16E79;
16E5A;MEDEFAIDRIN CAPITAL LETTER OE;Lu;0;L;;;;;N;;;;16E7A;
16E5B;MEDEFAIDRIN CAPITAL LETTER N;Lu;0;L;;;;;N;;;;16E7B;
16E5C;MEDEFAIDRIN CAPITAL LETTER R;Lu;0;L;;;;;N;;;;16E7C;
16E5D;MEDEFAIDRIN CAPITAL LETTER O;Lu;0;L;;;;;N;;;;16E7D;
16E5E;MEDEFAIDRIN CAPITAL LETTER AI;Lu;0;L;;;;;N;;;;16E7E;
16E5F;MEDEFAIDRIN CAPITAL LETTER Y;Lu;0;L;;;;;N;;;;16E7F;
16E60;MEDEFAIDRIN SMALL LETTER M;Ll;0;L;;;;;N;;;16E40;;16E40
16E61;MEDEFAIDRIN SMALL LETTER S;Ll;0;L;;;;;N;;;16E41;;16E41
16E62;MEDEFAIDRIN SMALL LETTER V;Ll;0;L;;;;;N;;;16E42;;16E42
16E63;MEDEFAIDRIN SMALL LETTER W;Ll;0;L;;;;;N;;;16E43;;16E43
16E64;MEDEFAIDRIN SMALL LETTER ATIU;Ll;0;L;;;;;N;;;16E44;;16E44
16E65;MEDEFAIDRIN SMALL LETTER Z;Ll;0;L;;;;;N;;;16E45;;16E45
16E66;MEDEFAIDRIN SMALL LETTER KP;Ll;0;L;;;;;N;;;16E46;;16E46
16E67;MEDEFAIDRIN SMALL LETTER P;Ll;0;L;;;;;N;;;16E47;;16E47
16E68;MEDEFAIDRIN SMALL LETTER T;Ll;0;L;;;;;N;;;16E48;;16E48
16E69;MEDEFAIDRIN SMALL LETTER G;Ll;0;L;;;;;N;;;16E49;;16E49
16E6A;MEDEFAIDRIN SMALL LETTER F;Ll;0;L;;;;;N;;;16E4A;;16E4A
16E6B;MEDEFAIDRIN SMALL LETTER I;Ll;0;L;;;;;N;;;16E4B;;16E4B
16E6C;MEDEFAIDRIN SMALL LETTER K;Ll;0;L;;;;;N;;;16E4C;;16E4C
16E6D;MEDEFAIDRIN SMALL LETTER A;Ll;0;L;;;;;N;;;16E4D;;16E4D
16E6E;MEDEFAIDRIN SMALL LETTER J;Ll;0;L;;;;;N;;;16E4E;;16E4E
16E6F;MEDEFAIDRIN SMALL LETTER E;Ll;0;L;;;;;N;;;16E4F;;16E4F
16E70;MEDEFAIDRIN SMALL LETTER B;Ll;0;L;;;;;N;;;16E50;;16E50
16E71;MEDEFAIDRIN SMALL LETTER C;Ll;0;L;;;;;N;;;16E51;;16E51
16E72;MEDEFAIDRIN SMALL LETTER U;Ll;0;L;;;;;N;;;16E52;;16E52
16E73;MEDEFAIDRIN SMALL LETTER YU;Ll;0;L;;;;;N;;;16E53;;16E53
16E74;MEDEFAIDRIN SMALL LETTER L;Ll;0;L;;;;;N;;;16E54;;16E54
16E75;MEDEFAIDRIN SMALL LETTER Q;Ll;0;L;;;;;N;;;16E55;;16E55
16E76;MEDEFAIDRIN SMALL LETTER HP;Ll;0;L;;;;;N;;;16E56;;16E56
16E77;MEDEFAIDRIN SMALL LETTER NY;Ll;0;L;;;;;N;;;16E57;;16E57
16E78;MEDEFAIDRIN SMALL LETTER X;Ll;0;L;;;;;N;;;16E58;;16E58
16E79;MEDEFAIDRIN SMALL LETTER D;Ll;0;L;;;;;N;;;16E59;;16E59
16E7A;MEDEFAIDRIN SMALL LETTER OE;Ll;0;L;;;;;N;;;16E5A;;16E5A
16E7B;MEDEFAIDRIN SMALL LETTER N;Ll;0;L;;;;;N;;;16E5B;;16E5B
16E7C;MEDEFAIDRIN SMALL LETTER R;Ll;0;L;;;;;N;;;16E5C;;16E5C
16E7D;MEDEFAIDRIN SMALL LETTER O;Ll;0;L;;;;;N;;;16E5D;;16E5D
16E7E;MEDEFAIDRIN SMALL LETTER AI;Ll;0;L;;;;;N;;;16E5E;;16E5E
16E7F;MEDEFAIDRIN SMALL LETTER Y;Ll;0;L;;;;;N;;;16E5F;;16E5F
16E80;MEDEFAIDRIN DIGIT ZERO;No;0;L;;;;0;N;;;;;
16E81;MEDEFAIDRIN DIGIT ONE;No;0;L;;;;1;N;;;;;
16E82;MEDEFAIDRIN DIGIT TWO;No;0;L;;;;2;N;;;;;
16E83;MEDEFAIDRIN DIGIT THREE;No;0;L;;;;3;N;;;;;
16E84;MEDEFAIDRIN DIGIT FOUR;No;0;L;;;;4;N;;;;;
16E85;MEDEFAIDRIN DIGIT FIVE;No;0;L;;;;5;N;;;;;
16E86;MEDEFAIDRIN DIGIT SIX;No;0;L;;;;6;N;;;;;
16E87;MEDEFAIDRIN DIGIT SEVEN;No;0;L;;;;7;N;;;;;
16E88;MEDEFAIDRIN DIGIT EIGHT;No;0;L;;;;8;N;;;;;
16E89;MEDEFAIDRIN DIGIT NINE;No;0;L;;;;9;N;;;;;
16E8A;MEDEFAIDRIN NUMBER TEN;No;0;L;;;;10;N;;;;;
16E8B;MEDEFAIDRIN NUMBER ELEVEN;No;0;L;;;;11;N;;;;;
16E8C;MEDEFAIDRIN NUMBER TWELVE;No;0;L;;;;12;N;;;;;
16E8D;MEDEFAIDRIN NUMBER THIRTEEN;No;0;L;;;;13;N;;;;;
16E8E;MEDEFAIDRIN NUMBER FOURTEEN;No;0;L;;;;14;N;;;;;
16E8F;MEDEFAIDRIN NUMBER FIFTEEN;No;0;L;;;;15;N;;;;;
16E90;MEDEFAIDRIN NUMBER SIXTEEN;No;0;L;;;;16;N;;;;;
16E91;MEDEFAIDRIN NUMBER SEVENTEEN;No;0;L;;;;17;N;;;;;
16E92;MEDEFAIDRIN NUMBER EIGHTEEN;No;0;L;;;;18;N;;;;;
16E93;MEDEFAIDRIN NUMBER NINETEEN;No;0;L;;;;19;N;;;;;
16E94;MEDEFAIDRIN DIGIT ONE ALTERNATE FORM;No;0;L;;;;1;N;;;;;
16E95;MEDEFAIDRIN DIGIT TWO ALTERNATE FORM;No;0;L;;;;2;N;;;;;
16E96;MEDEFAIDRIN DIGIT THREE ALTERNATE FORM;No;0;L;;;;3;N;;;;;
16E97;MEDEFAIDRIN COMMA;Po;0;L;;;;;N;;;;;
16E98;MEDEFAIDRIN FULL STOP;Po;0;L;;;;;N;;;;;
16E99;MEDEFAIDRIN SYMBOL AIVA;Po;0;L;;;;;N;;;;;
16E9A;MEDEFAIDRIN EXCLAMATION OH;Po;0;L;;;;;N;;;;;
16F00;MIAO LETTER PA;Lo;0;L;;;;;N;;;;;
16F01;MIAO LETTER BA;Lo;0;L;;;;;N;;;;;
16F02;MIAO LETTER YI PA;Lo;0;L;;;;;N;;;;;
16F03;MIAO LETTER PLA;Lo;0;L;;;;;N;;;;;
16F04;MIAO LETTER MA;Lo;0;L;;;;;N;;;;;
16F05;MIAO LETTER MHA;Lo;0;L;;;;;N;;;;;
16F06;MIAO LETTER ARCHAIC MA;Lo;0;L;;;;;N;;;;;
16F07;MIAO LETTER FA;Lo;0;L;;;;;N;;;;;
16F08;MIAO LETTER VA;Lo;0;L;;;;;N;;;;;
16F09;MIAO LETTER VFA;Lo;0;L;;;;;N;;;;;
16F0A;MIAO LETTER TA;Lo;0;L;;;;;N;;;;;
16F0B;MIAO LETTER DA;Lo;0;L;;;;;N;;;;;
16F0C;MIAO LETTER YI TTA;Lo;0;L;;;;;N;;;;;
16F0D;MIAO LETTER YI TA;Lo;0;L;;;;;N;;;;;
16F0E;MIAO LETTER TTA;Lo;0;L;;;;;N;;;;;
16F0F;MIAO LETTER DDA;Lo;0;L;;;;;N;;;;;
16F10;MIAO LETTER NA;Lo;0;L;;;;;N;;;;;
16F11;MIAO LETTER NHA;Lo;0;L;;;;;N;;;;;
16F12;MIAO LETTER YI NNA;Lo;0;L;;;;;N;;;;;
16F13;MIAO LETTER ARCHAIC NA;Lo;0;L;;;;;N;;;;;
16F14;MIAO LETTER NNA;Lo;0;L;;;;;N;;;;;
16F15;MIAO LETTER NNHA;Lo;0;L;;;;;N;;;;;
16F16;MIAO LETTER LA;Lo;0;L;;;;;N;;;;;
16F17;MIAO LETTER LYA;Lo;0;L;;;;;N;;;;;
16F18;MIAO LETTER LHA;Lo;0;L;;;;;N;;;;;
16F19;MIAO LETTER LHYA;Lo;0;L;;;;;N;;;;;
16F1A;MIAO LETTER TLHA;Lo;0;L;;;;;N;;;;;
16F1B;MIAO LETTER DLHA;Lo;0;L;;;;;N;;;;;
16F1C;MIAO LETTER TLHYA;Lo;0;L;;;;;N;;;;;
16F1D;MIAO LETTER DLHYA;Lo;0;L;;;;;N;;;;;
16F1E;MIAO LETTER KA;Lo;0;L;;;;;N;;;;;
16F1F;MIAO LETTER GA;Lo;0;L;;;;;N;;;;;
16F20;MIAO LETTER YI KA;Lo;0;L;;;;;N;;;;;
16F21;MIAO LETTER QA;Lo;0;L;;;;;N;;;;;
16F22;MIAO LETTER QGA;Lo;0;L;;;;;N;;;;;
16F23;MIAO LETTER NGA;Lo;0;L;;;;;N;;;;;
16F24;MIAO LETTER NGHA;Lo;0;L;;;;;N;;;;;
16F25;MIAO LETTER ARCHAIC NGA;Lo;0;L;;;;;N;;;;;
16F26;MIAO LETTER HA;Lo;0;L;;;;;N;;;;;
16F27;MIAO LETTER XA;Lo;0;L;;;;;N;;;;;
16F28;MIAO LETTER GHA;Lo;0;L;;;;;N;;;;;
16F29;MIAO LETTER GHHA;Lo;0;L;;;;;N;;;;;
16F2A;MIAO LETTER TSSA;Lo;0;L;;;;;N;;;;;
16F2B;MIAO LETTER DZZA;Lo;0;L;;;;;N;;;;;
16F2C;MIAO LETTER NYA;Lo;0;L;;;;;N;;;;;
16F2D;MIAO LETTER NYHA;Lo;0;L;;;;;N;;;;;
16F2E;MIAO LETTER TSHA;Lo;0;L;;;;;N;;;;;
16F2F;MIAO LETTER DZHA;Lo;0;L;;;;;N;;;;;
16F30;MIAO LETTER YI TSHA;Lo;0;L;;;;;N;;;;;
16F31;MIAO LETTER YI DZHA;Lo;0;L;;;;;N;;;;;
16F32;MIAO LETTER REFORMED TSHA;Lo;0;L;;;;;N;;;;;
16F33;MIAO LETTER SHA;Lo;0;L;;;;;N;;;;;
16F34;MIAO LETTER SSA;Lo;0;L;;;;;N;;;;;
16F35;MIAO LETTER ZHA;Lo;0;L;;;;;N;;;;;
16F36;MIAO LETTER ZSHA;Lo;0;L;;;;;N;;;;;
16F37;MIAO LETTER TSA;Lo;0;L;;;;;N;;;;;
16F38;MIAO LETTER DZA;Lo;0;L;;;;;N;;;;;
16F39;MIAO LETTER YI TSA;Lo;0;L;;;;;N;;;;;
16F3A;MIAO LETTER SA;Lo;0;L;;;;;N;;;;;
16F3B;MIAO LETTER ZA;Lo;0;L;;;;;N;;;;;
16F3C;MIAO LETTER ZSA;Lo;0;L;;;;;N;;;;;
16F3D;MIAO LETTER ZZA;Lo;0;L;;;;;N;;;;;
16F3E;MIAO LETTER ZZSA;Lo;0;L;;;;;N;;;;;
16F3F;MIAO LETTER ARCHAIC ZZA;Lo;0;L;;;;;N;;;;;
16F40;MIAO LETTER ZZYA;Lo;0;L;;;;;N;;;;;
16F41;MIAO LETTER ZZSYA;Lo;0;L;;;;;N;;;;;
16F42;MIAO LETTER WA;Lo;0;L;;;;;N;;;;;
16F43;MIAO LETTER AH;Lo;0;L;;;;;N;;;;;
16F44;MIAO LETTER HHA;Lo;0;L;;;;;N;;;;;
16F45;MIAO LETTER BRI;Lo;0;L;;;;;N;;;;;
16F46;MIAO LETTER SYI;Lo;0;L;;;;;N;;;;;
16F47;MIAO LETTER DZYI;Lo;0;L;;;;;N;;;;;
16F48;MIAO LETTER TE;Lo;0;L;;;;;N;;;;;
16F49;MIAO LETTER TSE;Lo;0;L;;;;;N;;;;;
16F4A;MIAO LETTER RTE;Lo;0;L;;;;;N;;;;;
16F4F;MIAO SIGN CONSONANT MODIFIER BAR;Mn;0;NSM;;;;;N;;;;;
16F50;MIAO LETTER NASALIZATION;Lo;0;L;;;;;N;;;;;
16F51;MIAO SIGN ASPIRATION;Mc;0;L;;;;;N;;;;;
16F52;MIAO SIGN REFORMED VOICING;Mc;0;L;;;;;N;;;;;
16F53;MIAO SIGN REFORMED ASPIRATION;Mc;0;L;;;;;N;;;;;
16F54;MIAO VOWEL SIGN A;Mc;0;L;;;;;N;;;;;
16F55;MIAO VOWEL SIGN AA;Mc;0;L;;;;;N;;;;;
16F56;MIAO VOWEL SIGN AHH;Mc;0;L;;;;;N;;;;;
16F57;MIAO VOWEL SIGN AN;Mc;0;L;;;;;N;;;;;
16F58;MIAO VOWEL SIGN ANG;Mc;0;L;;;;;N;;;;;
16F59;MIAO VOWEL SIGN O;Mc;0;L;;;;;N;;;;;
16F5A;MIAO VOWEL SIGN OO;Mc;0;L;;;;;N;;;;;
16F5B;MIAO VOWEL SIGN WO;Mc;0;L;;;;;N;;;;;
16F5C;MIAO VOWEL SIGN W;Mc;0;L;;;;;N;;;;;
16F5D;MIAO VOWEL SIGN E;Mc;0;L;;;;;N;;;;;
16F5E;MIAO VOWEL SIGN EN;Mc;0;L;;;;;N;;;;;
16F5F;MIAO VOWEL SIGN ENG;Mc;0;L;;;;;N;;;;;
16F60;MIAO VOWEL SIGN OEY;Mc;0;L;;;;;N;;;;;
16F61;MIAO VOWEL SIGN I;Mc;0;L;;;;;N;;;;;
16F62;MIAO VOWEL SIGN IA;Mc;0;L;;;;;N;;;;;
16F63;MIAO VOWEL SIGN IAN;Mc;0;L;;;;;N;;;;;
16F64;MIAO VOWEL SIGN IANG;Mc;0;L;;;;;N;;;;;
16F65;MIAO VOWEL SIGN IO;Mc;0;L;;;;;N;;;;;
16F66;MIAO VOWEL SIGN IE;Mc;0;L;;;;;N;;;;;
16F67;MIAO VOWEL SIGN II;Mc;0;L;;;;;N;;;;;
16F68;MIAO VOWEL SIGN IU;Mc;0;L;;;;;N;;;;;
16F69;MIAO VOWEL SIGN ING;Mc;0;L;;;;;N;;;;;
16F6A;MIAO VOWEL SIGN U;Mc;0;L;;;;;N;;;;;
16F6B;MIAO VOWEL SIGN UA;Mc;0;L;;;;;N;;;;;
16F6C;MIAO VOWEL SIGN UAN;Mc;0;L;;;;;N;;;;;
16F6D;MIAO VOWEL SIGN UANG;Mc;0;L;;;;;N;;;;;
16F6E;MIAO VOWEL SIGN UU;Mc;0;L;;;;;N;;;;;
16F6F;MIAO VOWEL SIGN UEI;Mc;0;L;;;;;N;;;;;
16F70;MIAO VOWEL SIGN UNG;Mc;0;L;;;;;N;;;;;
16F71;MIAO VOWEL SIGN Y;Mc;0;L;;;;;N;;;;;
16F72;MIAO VOWEL SIGN YI;Mc;0;L;;;;;N;;;;;
16F73;MIAO VOWEL SIGN AE;Mc;0;L;;;;;N;;;;;
16F74;MIAO VOWEL SIGN AEE;Mc;0;L;;;;;N;;;;;
16F75;MIAO VOWEL SIGN ERR;Mc;0;L;;;;;N;;;;;
16F76;MIAO VOWEL SIGN ROUNDED ERR;Mc;0;L;;;;;N;;;;;
16F77;MIAO VOWEL SIGN ER;Mc;0;L;;;;;N;;;;;
16F78;MIAO VOWEL SIGN ROUNDED ER;Mc;0;L;;;;;N;;;;;
16F79;MIAO VOWEL SIGN AI;Mc;0;L;;;;;N;;;;;
16F7A;MIAO VOWEL SIGN EI;Mc;0;L;;;;;N;;;;;
16F7B;MIAO VOWEL SIGN AU;Mc;0;L;;;;;N;;;;;
16F7C;MIAO VOWEL SIGN OU;Mc;0;L;;;;;N;;;;;
16F7D;MIAO VOWEL SIGN N;Mc;0;L;;;;;N;;;;;
16F7E;MIAO VOWEL SIGN NG;Mc;0;L;;;;;N;;;;;
16F7F;MIAO VOWEL SIGN UOG;Mc;0;L;;;;;N;;;;;
16F80;MIAO VOWEL SIGN YUI;Mc;0;L;;;;;N;;;;;
16F81;MIAO VOWEL SIGN OG;Mc;0;L;;;;;N;;;;;
16F82;MIAO VOWEL SIGN OER;Mc;0;L;;;;;N;;;;;
16F83;MIAO VOWEL SIGN VW;Mc;0;L;;;;;N;;;;;
16F84;MIAO VOWEL SIGN IG;Mc;0;L;;;;;N;;;;;
16F85;MIAO VOWEL SIGN EA;Mc;0;L;;;;;N;;;;;
16F86;MIAO VOWEL SIGN IONG;Mc;0;L;;;;;N;;;;;
16F87;MIAO VOWEL SIGN UI;Mc;0;L;;;;;N;;;;;
16F8F;MIAO TONE RIGHT;Mn;0;NSM;;;;;N;;;;;
16F90;MIAO TONE TOP RIGHT;Mn;0;NSM;;;;;N;;;;;
16F91;MIAO TONE ABOVE;Mn;0;NSM;;;;;N;;;;;
16F92;MIAO TONE BELOW;Mn;0;NSM;;;;;N;;;;;
16F93;MIAO LETTER TONE-2;Lm;0;L;;;;;N;;;;;
16F94;MIAO LETTER TONE-3;Lm;0;L;;;;;N;;;;;
16F95;MIAO LETTER TONE-4;Lm;0;L;;;;;N;;;;;
16F96;MIAO LETTER TONE-5;Lm;0;L;;;;;N;;;;;
16F97;MIAO LETTER TONE-6;Lm;0;L;;;;;N;;;;;
16F98;MIAO LETTER TONE-7;Lm;0;L;;;;;N;;;;;
16F99;MIAO LETTER TONE-8;Lm;0;L;;;;;N;;;;;
16F9A;MIAO LETTER REFORMED TONE-1;Lm;0;L;;;;;N;;;;;
16F9B;MIAO LETTER REFORMED TONE-2;Lm;0;L;;;;;N;;;;;
16F9C;MIAO LETTER REFORMED TONE-4;Lm;0;L;;;;;N;;;;;
16F9D;MIAO LETTER REFORMED TONE-5;Lm;0;L;;;;;N;;;;;
16F9E;MIAO LETTER REFORMED TONE-6;Lm;0;L;;;;;N;;;;;
16F9F;MIAO LETTER REFORMED TONE-8;Lm;0;L;;;;;N;;;;;
16FE0;TANGUT ITERATION MARK;Lm;0;L;;;;;N;;;;;
16FE1;NUSHU ITERATION MARK;Lm;0;L;;;;;N;;;;;
16FE2;OLD CHINESE HOOK MARK;Po;0;ON;;;;;N;;;;;
16FE3;OLD CHINESE ITERATION MARK;Lm;0;L;;;;;N;;;;;
16FE4;KHITAN SMALL SCRIPT FILLER;Mn;0;NSM;;;;;N;;;;;
16FF0;VIETNAMESE ALTERNATE READING MARK CA;Mc;6;L;;;;;N;;;;;
16FF1;VIETNAMESE ALTERNATE READING MARK NHAY;Mc;6;L;;;;;N;;;;;
17000;<Tangut Ideograph, First>;Lo;0;L;;;;;N;;;;;
187F7;<Tangut Ideograph, Last>;Lo;0;L;;;;;N;;;;;
18800;TANGUT COMPONENT-001;Lo;0;L;;;;;N;;;;;
18801;TANGUT COMPONENT-002;Lo;0;L;;;;;N;;;;;
18802;TANGUT COMPONENT-003;Lo;0;L;;;;;N;;;;;
18803;TANGUT COMPONENT-004;Lo;0;L;;;;;N;;;;;
18804;TANGUT COMPONENT-005;Lo;0;L;;;;;N;;;;;
18805;TANGUT COMPONENT-006;Lo;0;L;;;;;N;;;;;
18806;TANGUT COMPONENT-007;Lo;0;L;;;;;N;;;;;
18807;TANGUT COMPONENT-008;Lo;0;L;;;;;N;;;;;
18808;TANGUT COMPONENT-009;Lo;0;L;;;;;N;;;;;
18809;TANGUT COMPONENT-010;Lo;0;L;;;;;N;;;;;
1880A;TANGUT COMPONENT-011;Lo;0;L;;;;;N;;;;;
1880B;TANGUT COMPONENT-012;Lo;0;L;;;;;N;;;;;
1880C;TANGUT COMPONENT-013;Lo;0;L;;;;;N;;;;;
1880D;TANGUT COMPONENT-014;Lo;0;L;;;;;N;;;;;
1880E;TANGUT COMPONENT-015;Lo;0;L;;;;;N;;;;;
1880F;TANGUT COMPONENT-016;Lo;0;L;;;;;N;;;;;
18810;TANGUT COMPONENT-017;Lo;0;L;;;;;N;;;;;
18811;TANGUT COMPONENT-018;Lo;0;L;;;;;N;;;;;
18812;TANGUT COMPONENT-019;Lo;0;L;;;;;N;;;;;
18813;TANGUT COMPONENT-020;Lo;0;L;;;;;N;;;;;
18814;TANGUT COMPONENT-021;Lo;0;L;;;;;N;;;;;
18815;TANGUT COMPONENT-022;Lo;0;L;;;;;N;;;;;
18816;TANGUT COMPONENT-023;Lo;0;L;;;;;N;;;;;
18817;TANGUT COMPONENT-024;Lo;0;L;;;;;N;;;;;
18818;TANGUT COMPONENT-025;Lo;0;L;;;;;N;;;;;
18819;TANGUT COMPONENT-026;Lo;0;L;;;;;N;;;;;
1881A;TANGUT COMPONENT-027;Lo;0;L;;;;;N;;;;;
1881B;TANGUT COMPONENT-028;Lo;0;L;;;;;N;;;;;
1881C;TANGUT COMPONENT-029;Lo;0;L;;;;;N;;;;;
1881D;TANGUT COMPONENT-030;Lo;0;L;;;;;N;;;;;
1881E;TANGUT COMPONENT-031;Lo;0;L;;;;;N;;;;;
1881F;TANGUT COMPONENT-032;Lo;0;L;;;;;N;;;;;
18820;TANGUT COMPONENT-033;Lo;0;L;;;;;N;;;;;
18821;TANGUT COMPONENT-034;Lo;0;L;;;;;N;;;;;
18822;TANGUT COMPONENT-035;Lo;0;L;;;;;N;;;;;
18823;TANGUT COMPONENT-036;Lo;0;L;;;;;N;;;;;
18824;TANGUT COMPONENT-037;Lo;0;L;;;;;N;;;;;
18825;TANGUT COMPONENT-038;Lo;0;L;;;;;N;;;;;
18826;TANGUT COMPONENT-039;Lo;0;L;;;;;N;;;;;
18827;TANGUT COMPONENT-040;Lo;0;L;;;;;N;;;;;
18828;TANGUT COMPONENT-041;Lo;0;L;;;;;N;;;;;
18829;TANGUT COMPONENT-042;Lo;0;L;;;;;N;;;;;
1882A;TANGUT COMPONENT-043;Lo;0;L;;;;;N;;;;;
1882B;TANGUT COMPONENT-044;Lo;0;L;;;;;N;;;;;
1882C;TANGUT COMPONENT-045;Lo;0;L;;;;;N;;;;;
1882D;TANGUT COMPONENT-046;Lo;0;L;;;;;N;;;;;
1882E;TANGUT COMPONENT-047;Lo;0;L;;;;;N;;;;;
1882F;TANGUT COMPONENT-048;Lo;0;L;;;;;N;;;;;
18830;TANGUT COMPONENT-049;Lo;0;L;;;;;N;;;;;
18831;TANGUT COMPONENT-050;Lo;0;L;;;;;N;;;;;
18832;TANGUT COMPONENT-051;Lo;0;L;;;;;N;;;;;
18833;TANGUT COMPONENT-052;Lo;0;L;;;;;N;;;;;
18834;TANGUT COMPONENT-053;Lo;0;L;;;;;N;;;;;
18835;TANGUT COMPONENT-054;Lo;0;L;;;;;N;;;;;
18836;TANGUT COMPONENT-055;Lo;0;L;;;;;N;;;;;
18837;TANGUT COMPONENT-056;Lo;0;L;;;;;N;;;;;
18838;TANGUT COMPONENT-057;Lo;0;L;;;;;N;;;;;
18839;TANGUT COMPONENT-058;Lo;0;L;;;;;N;;;;;
1883A;TANGUT COMPONENT-059;Lo;0;L;;;;;N;;;;;
1883B;TANGUT COMPONENT-060;Lo;0;L;;;;;N;;;;;
1883C;TANGUT COMPONENT-061;Lo;0;L;;;;;N;;;;;
1883D;TANGUT COMPONENT-062;Lo;0;L;;;;;N;;;;;
1883E;TANGUT COMPONENT-063;Lo;0;L;;;;;N;;;;;
1883F;TANGUT COMPONENT-064;Lo;0;L;;;;;N;;;;;
18840;TANGUT COMPONENT-065;Lo;0;L;;;;;N;;;;;
18841;TANGUT COMPONENT-066;Lo;0;L;;;;;N;;;;;
18842;TANGUT COMPONENT-067;Lo;0;L;;;;;N;;;;;
18843;TANGUT COMPONENT-068;Lo;0;L;;;;;N;;;;;
18844;TANGUT COMPONENT-069;Lo;0;L;;;;;N;;;;;
18845;TANGUT COMPONENT-070;Lo;0;L;;;;;N;;;;;
18846;TANGUT COMPONENT-071;Lo;0;L;;;;;N;;;;;
18847;TANGUT COMPONENT-072;Lo;0;L;;;;;N;;;;;
18848;TANGUT COMPONENT-073;Lo;0;L;;;;;N;;;;;
18849;TANGUT COMPONENT-074;Lo;0;L;;;;;N;;;;;
1884A;TANGUT COMPONENT-075;Lo;0;L;;;;;N;;;;;
1884B;TANGUT COMPONENT-076;Lo;0;L;;;;;N;;;;;
1884C;TANGUT COMPONENT-077;Lo;0;L;;;;;N;;;;;
1884D;TANGUT COMPONENT-078;Lo;0;L;;;;;N;;;;;
1884E;TANGUT COMPONENT-079;Lo;0;L;;;;;N;;;;;
1884F;TANGUT COMPONENT-080;Lo;0;L;;;;;N;;;;;
18850;TANGUT COMPONENT-081;Lo;0;L;;;;;N;;;;;
18851;TANGUT COMPONENT-082;Lo;0;L;;;;;N;;;;;
18852;TANGUT COMPONENT-083;Lo;0;L;;;;;N;;;;;
18853;TANGUT COMPONENT-084;Lo;0;L;;;;;N;;;;;
18854;TANGUT COMPONENT-085;Lo;0;L;;;;;N;;;;;
18855;TANGUT COMPONENT-086;Lo;0;L;;;;;N;;;;;
18856;TANGUT COMPONENT-087;Lo;0;L;;;;;N;;;;;
18857;TANGUT COMPONENT-088;Lo;0;L;;;;;N;;;;;
18858;TANGUT COMPONENT-089;Lo;0;L;;;;;N;;;;;
18859;TANGUT COMPONENT-090;Lo;0;L;;;;;N;;;;;
1885A;TANGUT COMPONENT-091;Lo;0;L;;;;;N;;;;;
1885B;TANGUT COMPONENT-092;Lo;0;L;;;;;N;;;;;
1885C;TANGUT COMPONENT-093;Lo;0;L;;;;;N;;;;;
1885D;TANGUT COMPONENT-094;Lo;0;L;;;;;N;;;;;
1885E;TANGUT COMPONENT-095;Lo;0;L;;;;;N;;;;;
1885F;TANGUT COMPONENT-096;Lo;0;L;;;;;N;;;;;
18860;TANGUT COMPONENT-097;Lo;0;L;;;;;N;;;;;
18861;TANGUT COMPONENT-098;Lo;0;L;;;;;N;;;;;
18862;TANGUT COMPONENT-099;Lo;0;L;;;;;N;;;;;
18863;TANGUT COMPONENT-100;Lo;0;L;;;;;N;;;;;
18864;TANGUT COMPONENT-101;Lo;0;L;;;;;N;;;;;
18865;TANGUT COMPONENT-102;Lo;0;L;;;;;N;;;;;
18866;TANGUT COMPONENT-103;Lo;0;L;;;;;N;;;;;
18867;TANGUT COMPONENT-104;Lo;0;L;;;;;N;;;;;
18868;TANGUT COMPONENT-105;Lo;0;L;;;;;N;;;;;
18869;TANGUT COMPONENT-106;Lo;0;L;;;;;N;;;;;
1886A;TANGUT COMPONENT-107;Lo;0;L;;;;;N;;;;;
1886B;TANGUT COMPONENT-108;Lo;0;L;;;;;N;;;;;
1886C;TANGUT COMPONENT-109;Lo;0;L;;;;;N;;;;;
1886D;TANGUT COMPONENT-110;Lo;0;L;;;;;N;;;;;
1886E;TANGUT COMPONENT-111;Lo;0;L;;;;;N;;;;;
1886F;TANGUT COMPONENT-112;Lo;0;L;;;;;N;;;;;
18870;TANGUT COMPONENT-113;Lo;0;L;;;;;N;;;;;
18871;TANGUT COMPONENT-114;Lo;0;L;;;;;N;;;;;
18872;TANGUT COMPONENT-115;Lo;0;L;;;;;N;;;;;
18873;TANGUT COMPONENT-116;Lo;0;L;;;;;N;;;;;
18874;TANGUT COMPONENT-117;Lo;0;L;;;;;N;;;;;
18875;TANGUT COMPONENT-118;Lo;0;L;;;;;N;;;;;
18876;TANGUT COMPONENT-119;Lo;0;L;;;;;N;;;;;
18877;TANGUT COMPONENT-120;Lo;0;L;;;;;N;;;;;
18878;TANGUT COMPONENT-121;Lo;0;L;;;;;N;;;;;
18879;TANGUT COMPONENT-122;Lo;0;L;;;;;N;;;;;
1887A;TANGUT COMPONENT-123;Lo;0;L;;;;;N;;;;;
1887B;TANGUT COMPONENT-124;Lo;0;L;;;;;N;;;;;
1887C;TANGUT COMPONENT-125;Lo;0;L;;;;;N;;;;;
1887D;TANGUT COMPONENT-126;Lo;0;L;;;;;N;;;;;
1887E;TANGUT COMPONENT-127;Lo;0;L;;;;;N;;;;;
1887F;TANGUT COMPONENT-128;Lo;0;L;;;;;N;;;;;
18880;TANGUT COMPONENT-129;Lo;0;L;;;;;N;;;;;
18881;TANGUT COMPONENT-130;Lo;0;L;;;;;N;;;;;
18882;TANGUT COMPONENT-131;Lo;0;L;;;;;N;;;;;
18883;TANGUT COMPONENT-132;Lo;0;L;;;;;N;;;;;
18884;TANGUT COMPONENT-133;Lo;0;L;;;;;N;;;;;
18885;TANGUT COMPONENT-134;Lo;0;L;;;;;N;;;;;
18886;TANGUT COMPONENT-135;Lo;0;L;;;;;N;;;;;
18887;TANGUT COMPONENT-136;Lo;0;L;;;;;N;;;;;
18888;TANGUT COMPONENT-137;Lo;0;L;;;;;N;;;;;
18889;TANGUT COMPONENT-138;Lo;0;L;;;;;N;;;;;
1888A;TANGUT COMPONENT-139;Lo;0;L;;;;;N;;;;;
1888B;TANGUT COMPONENT-140;Lo;0;L;;;;;N;;;;;
1888C;TANGUT COMPONENT-141;Lo;0;L;;;;;N;;;;;
1888D;TANGUT COMPONENT-142;Lo;0;L;;;;;N;;;;;
1888E;TANGUT COMPONENT-143;Lo;0;L;;;;;N;;;;;
1888F;TANGUT COMPONENT-144;Lo;0;L;;;;;N;;;;;
18890;TANGUT COMPONENT-145;Lo;0;L;;;;;N;;;;;
18891;TANGUT COMPONENT-146;Lo;0;L;;;;;N;;;;;
18892;TANGUT COMPONENT-147;Lo;0;L;;;;;N;;;;;
18893;TANGUT COMPONENT-148;Lo;0;L;;;;;N;;;;;
18894;TANGUT COMPONENT-149;Lo;0;L;;;;;N;;;;;
18895;TANGUT COMPONENT-150;Lo;0;L;;;;;N;;;;;
18896;TANGUT COMPONENT-151;Lo;0;L;;;;;N;;;;;
18897;TANGUT COMPONENT-152;Lo;0;L;;;;;N;;;;;
18898;TANGUT COMPONENT-153;Lo;0;L;;;;;N;;;;;
18899;TANGUT COMPONENT-154;Lo;0;L;;;;;N;;;;;
1889A;TANGUT COMPONENT-155;Lo;0;L;;;;;N;;;;;
1889B;TANGUT COMPONENT-156;Lo;0;L;;;;;N;;;;;
1889C;TANGUT COMPONENT-157;Lo;0;L;;;;;N;;;;;
1889D;TANGUT COMPONENT-158;Lo;0;L;;;;;N;;;;;
1889E;TANGUT COMPONENT-159;Lo;0;L;;;;;N;;;;;
1889F;TANGUT COMPONENT-160;Lo;0;L;;;;;N;;;;;
188A0;TANGUT COMPONENT-161;Lo;0;L;;;;;N;;;;;
188A1;TANGUT COMPONENT-162;Lo;0;L;;;;;N;;;;;
188A2;TANGUT COMPONENT-163;Lo;0;L;;;;;N;;;;;
188A3;TANGUT COMPONENT-164;Lo;0;L;;;;;N;;;;;
188A4;TANGUT COMPONENT-165;Lo;0;L;;;;;N;;;;;
188A5;TANGUT COMPONENT-166;Lo;0;L;;;;;N;;;;;
188A6;TANGUT COMPONENT-167;Lo;0;L;;;;;N;;;;;
188A7;TANGUT COMPONENT-168;Lo;0;L;;;;;N;;;;;
188A8;TANGUT COMPONENT-169;Lo;0;L;;;;;N;;;;;
188A9;TANGUT COMPONENT-170;Lo;0;L;;;;;N;;;;;
188AA;TANGUT COMPONENT-171;Lo;0;L;;;;;N;;;;;
188AB;TANGUT COMPONENT-172;Lo;0;L;;;;;N;;;;;
188AC;TANGUT COMPONENT-173;Lo;0;L;;;;;N;;;;;
188AD;TANGUT COMPONENT-174;Lo;0;L;;;;;N;;;;;
188AE;TANGUT COMPONENT-175;Lo;0;L;;;;;N;;;;;
188AF;TANGUT COMPONENT-176;Lo;0;L;;;;;N;;;;;
188B0;TANGUT COMPONENT-177;Lo;0;L;;;;;N;;;;;
188B1;TANGUT COMPONENT-178;Lo;0;L;;;;;N;;;;;
188B2;TANGUT COMPONENT-179;Lo;0;L;;;;;N;;;;;
188B3;TANGUT COMPONENT-180;Lo;0;L;;;;;N;;;;;
188B4;TANGUT COMPONENT-181;Lo;0;L;;;;;N;;;;;
188B5;TANGUT COMPONENT-182;Lo;0;L;;;;;N;;;;;
188B6;TANGUT COMPONENT-183;Lo;0;L;;;;;N;;;;;
188B7;TANGUT COMPONENT-184;Lo;0;L;;;;;N;;;;;
188B8;TANGUT COMPONENT-185;Lo;0;L;;;;;N;;;;;
188B9;TANGUT COMPONENT-186;Lo;0;L;;;;;N;;;;;
188BA;TANGUT COMPONENT-187;Lo;0;L;;;;;N;;;;;
188BB;TANGUT COMPONENT-188;Lo;0;L;;;;;N;;;;;
188BC;TANGUT COMPONENT-189;Lo;0;L;;;;;N;;;;;
188BD;TANGUT COMPONENT-190;Lo;0;L;;;;;N;;;;;
188BE;TANGUT COMPONENT-191;Lo;0;L;;;;;N;;;;;
188BF;TANGUT COMPONENT-192;Lo;0;L;;;;;N;;;;;
188C0;TANGUT COMPONENT-193;Lo;0;L;;;;;N;;;;;
188C1;TANGUT COMPONENT-194;Lo;0;L;;;;;N;;;;;
188C2;TANGUT COMPONENT-195;Lo;0;L;;;;;N;;;;;
188C3;TANGUT COMPONENT-196;Lo;0;L;;;;;N;;;;;
188C4;TANGUT COMPONENT-197;Lo;0;L;;;;;N;;;;;
188C5;TANGUT COMPONENT-198;Lo;0;L;;;;;N;;;;;
188C6;TANGUT COMPONENT-199;Lo;0;L;;;;;N;;;;;
188C7;TANGUT COMPONENT-200;Lo;0;L;;;;;N;;;;;
188C8;TANGUT COMPONENT-201;Lo;0;L;;;;;N;;;;;
188C9;TANGUT COMPONENT-202;Lo;0;L;;;;;N;;;;;
188CA;TANGUT COMPONENT-203;Lo;0;L;;;;;N;;;;;
188CB;TANGUT COMPONENT-204;Lo;0;L;;;;;N;;;;;
188CC;TANGUT COMPONENT-205;Lo;0;L;;;;;N;;;;;
188CD;TANGUT COMPONENT-206;Lo;0;L;;;;;N;;;;;
188CE;TANGUT COMPONENT-207;Lo;0;L;;;;;N;;;;;
188CF;TANGUT COMPONENT-208;Lo;0;L;;;;;N;;;;;
188D0;TANGUT COMPONENT-209;Lo;0;L;;;;;N;;;;;
188D1;TANGUT COMPONENT-210;Lo;0;L;;;;;N;;;;;
188D2;TANGUT COMPONENT-211;Lo;0;L;;;;;N;;;;;
188D3;TANGUT COMPONENT-212;Lo;0;L;;;;;N;;;;;
188D4;TANGUT COMPONENT-213;Lo;0;L;;;;;N;;;;;
188D5;TANGUT COMPONENT-214;Lo;0;L;;;;;N;;;;;
188D6;TANGUT COMPONENT-215;Lo;0;L;;;;;N;;;;;
188D7;TANGUT COMPONENT-216;Lo;0;L;;;;;N;;;;;
188D8;TANGUT COMPONENT-217;Lo;0;L;;;;;N;;;;;
188D9;TANGUT COMPONENT-218;Lo;0;L;;;;;N;;;;;
188DA;TANGUT COMPONENT-219;Lo;0;L;;;;;N;;;;;
188DB;TANGUT COMPONENT-220;Lo;0;L;;;;;N;;;;;
188DC;TANGUT COMPONENT-221;Lo;0;L;;;;;N;;;;;
188DD;TANGUT COMPONENT-222;Lo;0;L;;;;;N;;;;;
188DE;TANGUT COMPONENT-223;Lo;0;L;;;;;N;;;;;
188DF;TANGUT COMPONENT-224;Lo;0;L;;;;;N;;;;;
188E0;TANGUT COMPONENT-225;Lo;0;L;;;;;N;;;;;
188E1;TANGUT COMPONENT-226;Lo;0;L;;;;;N;;;;;
188E2;TANGUT COMPONENT-227;Lo;0;L;;;;;N;;;;;
188E3;TANGUT COMPONENT-228;Lo;0;L;;;;;N;;;;;
188E4;TANGUT COMPONENT-229;Lo;0;L;;;;;N;;;;;
188E5;TANGUT COMPONENT-230;Lo;0;L;;;;;N;;;;;
188E6;TANGUT COMPONENT-231;Lo;0;L;;;;;N;;;;;
188E7;TANGUT COMPONENT-232;Lo;0;L;;;;;N;;;;;
188E8;TANGUT COMPONENT-233;Lo;0;L;;;;;N;;;;;
188E9;TANGUT COMPONENT-234;Lo;0;L;;;;;N;;;;;
188EA;TANGUT COMPONENT-235;Lo;0;L;;;;;N;;;;;
188EB;TANGUT COMPONENT-236;Lo;0;L;;;;;N;;;;;
188EC;TANGUT COMPONENT-237;Lo;0;L;;;;;N;;;;;
188ED;TANGUT COMPONENT-238;Lo;0;L;;;;;N;;;;;
188EE;TANGUT COMPONENT-239;Lo;0;L;;;;;N;;;;;
188EF;TANGUT COMPONENT-240;Lo;0;L;;;;;N;;;;;
188F0;TANGUT COMPONENT-241;Lo;0;L;;;;;N;;;;;
188F1;TANGUT COMPONENT-242;Lo;0;L;;;;;N;;;;;
188F2;TANGUT COMPONENT-243;Lo;0;L;;;;;N;;;;;
188F3;TANGUT COMPONENT-244;Lo;0;L;;;;;N;;;;;
188F4;TANGUT COMPONENT-245;Lo;0;L;;;;;N;;;;;
188F5;TANGUT COMPONENT-246;Lo;0;L;;;;;N;;;;;
188F6;TANGUT COMPONENT-247;Lo;0;L;;;;;N;;;;;
188F7;TANGUT COMPONENT-248;Lo;0;L;;;;;N;;;;;
188F8;TANGUT COMPONENT-249;Lo;0;L;;;;;N;;;;;
188F9;TANGUT COMPONENT-250;Lo;0;L;;;;;N;;;;;
188FA;TANGUT COMPONENT-251;Lo;0;L;;;;;N;;;;;
188FB;TANGUT COMPONENT-252;Lo;0;L;;;;;N;;;;;
188FC;TANGUT COMPONENT-253;Lo;0;L;;;;;N;;;;;
188FD;TANGUT COMPONENT-254;Lo;0;L;;;;;N;;;;;
188FE;TANGUT COMPONENT-255;Lo;0;L;;;;;N;;;;;
188FF;TANGUT COMPONENT-256;Lo;0;L;;;;;N;;;;;
18900;TANGUT COMPONENT-257;Lo;0;L;;;;;N;;;;;
18901;TANGUT COMPONENT-258;Lo;0;L;;;;;N;;;;;
18902;TANGUT COMPONENT-259;Lo;0;L;;;;;N;;;;;
18903;TANGUT COMPONENT-260;Lo;0;L;;;;;N;;;;;
18904;TANGUT COMPONENT-261;Lo;0;L;;;;;N;;;;;
18905;TANGUT COMPONENT-262;Lo;0;L;;;;;N;;;;;
18906;TANGUT COMPONENT-263;Lo;0;L;;;;;N;;;;;
18907;TANGUT COMPONENT-264;Lo;0;L;;;;;N;;;;;
18908;TANGUT COMPONENT-265;Lo;0;L;;;;;N;;;;;
18909;TANGUT COMPONENT-266;Lo;0;L;;;;;N;;;;;
1890A;TANGUT COMPONENT-267;Lo;0;L;;;;;N;;;;;
1890B;TANGUT COMPONENT-268;Lo;0;L;;;;;N;;;;;
1890C;TANGUT COMPONENT-269;Lo;0;L;;;;;N;;;;;
1890D;TANGUT COMPONENT-270;Lo;0;L;;;;;N;;;;;
1890E;TANGUT COMPONENT-271;Lo;0;L;;;;;N;;;;;
1890F;TANGUT COMPONENT-272;Lo;0;L;;;;;N;;;;;
18910;TANGUT COMPONENT-273;Lo;0;L;;;;;N;;;;;
18911;TANGUT COMPONENT-274;Lo;0;L;;;;;N;;;;;
18912;TANGUT COMPONENT-275;Lo;0;L;;;;;N;;;;;
18913;TANGUT COMPONENT-276;Lo;0;L;;;;;N;;;;;
18914;TANGUT COMPONENT-277;Lo;0;L;;;;;N;;;;;
18915;TANGUT COMPONENT-278;Lo;0;L;;;;;N;;;;;
18916;TANGUT COMPONENT-279;Lo;0;L;;;;;N;;;;;
18917;TANGUT COMPONENT-280;Lo;0;L;;;;;N;;;;;
18918;TANGUT COMPONENT-281;Lo;0;L;;;;;N;;;;;
18919;TANGUT COMPONENT-282;Lo;0;L;;;;;N;;;;;
1891A;TANGUT COMPONENT-283;Lo;0;L;;;;;N;;;;;
1891B;TANGUT COMPONENT-284;Lo;0;L;;;;;N;;;;;
1891C;TANGUT COMPONENT-285;Lo;0;L;;;;;N;;;;;
1891D;TANGUT COMPONENT-286;Lo;0;L;;;;;N;;;;;
1891E;TANGUT COMPONENT-287;Lo;0;L;;;;;N;;;;;
1891F;TANGUT COMPONENT-288;Lo;0;L;;;;;N;;;;;
18920;TANGUT COMPONENT-289;Lo;0;L;;;;;N;;;;;
18921;TANGUT COMPONENT-290;Lo;0;L;;;;;N;;;;;
18922;TANGUT COMPONENT-291;Lo;0;L;;;;;N;;;;;
18923;TANGUT COMPONENT-292;Lo;0;L;;;;;N;;;;;
18924;TANGUT COMPONENT-293;Lo;0;L;;;;;N;;;;;
18925;TANGUT COMPONENT-294;Lo;0;L;;;;;N;;;;;
18926;TANGUT COMPONENT-295;Lo;0;L;;;;;N;;;;;
18927;TANGUT COMPONENT-296;Lo;0;L;;;;;N;;;;;
18928;TANGUT COMPONENT-297;Lo;0;L;;;;;N;;;;;
18929;TANGUT COMPONENT-298;Lo;0;L;;;;;N;;;;;
1892A;TANGUT COMPONENT-299;Lo;0;L;;;;;N;;;;;
1892B;TANGUT COMPONENT-300;Lo;0;L;;;;;N;;;;;
1892C;TANGUT COMPONENT-301;Lo;0;L;;;;;N;;;;;
1892D;TANGUT COMPONENT-302;Lo;0;L;;;;;N;;;;;
1892E;TANGUT COMPONENT-303;Lo;0;L;;;;;N;;;;;
1892F;TANGUT COMPONENT-304;Lo;0;L;;;;;N;;;;;
18930;TANGUT COMPONENT-305;Lo;0;L;;;;;N;;;;;
18931;TANGUT COMPONENT-306;Lo;0;L;;;;;N;;;;;
18932;TANGUT COMPONENT-307;Lo;0;L;;;;;N;;;;;
18933;TANGUT COMPONENT-308;Lo;0;L;;;;;N;;;;;
18934;TANGUT COMPONENT-309;Lo;0;L;;;;;N;;;;;
18935;TANGUT COMPONENT-310;Lo;0;L;;;;;N;;;;;
18936;TANGUT COMPONENT-311;Lo;0;L;;;;;N;;;;;
18937;TANGUT COMPONENT-312;Lo;0;L;;;;;N;;;;;
18938;TANGUT COMPONENT-313;Lo;0;L;;;;;N;;;;;
18939;TANGUT COMPONENT-314;Lo;0;L;;;;;N;;;;;
1893A;TANGUT COMPONENT-315;Lo;0;L;;;;;N;;;;;
1893B;TANGUT COMPONENT-316;Lo;0;L;;;;;N;;;;;
1893C;TANGUT COMPONENT-317;Lo;0;L;;;;;N;;;;;
1893D;TANGUT COMPONENT-318;Lo;0;L;;;;;N;;;;;
1893E;TANGUT COMPONENT-319;Lo;0;L;;;;;N;;;;;
1893F;TANGUT COMPONENT-320;Lo;0;L;;;;;N;;;;;
18940;TANGUT COMPONENT-321;Lo;0;L;;;;;N;;;;;
18941;TANGUT COMPONENT-322;Lo;0;L;;;;;N;;;;;
18942;TANGUT COMPONENT-323;Lo;0;L;;;;;N;;;;;
18943;TANGUT COMPONENT-324;Lo;0;L;;;;;N;;;;;
18944;TANGUT COMPONENT-325;Lo;0;L;;;;;N;;;;;
18945;TANGUT COMPONENT-326;Lo;0;L;;;;;N;;;;;
18946;TANGUT COMPONENT-327;Lo;0;L;;;;;N;;;;;
18947;TANGUT COMPONENT-328;Lo;0;L;;;;;N;;;;;
18948;TANGUT COMPONENT-329;Lo;0;L;;;;;N;;;;;
18949;TANGUT COMPONENT-330;Lo;0;L;;;;;N;;;;;
1894A;TANGUT COMPONENT-331;Lo;0;L;;;;;N;;;;;
1894B;TANGUT COMPONENT-332;Lo;0;L;;;;;N;;;;;
1894C;TANGUT COMPONENT-333;Lo;0;L;;;;;N;;;;;
1894D;TANGUT COMPONENT-334;Lo;0;L;;;;;N;;;;;
1894E;TANGUT COMPONENT-335;Lo;0;L;;;;;N;;;;;
1894F;TANGUT COMPONENT-336;Lo;0;L;;;;;N;;;;;
18950;TANGUT COMPONENT-337;Lo;0;L;;;;;N;;;;;
18951;TANGUT COMPONENT-338;Lo;0;L;;;;;N;;;;;
18952;TANGUT COMPONENT-339;Lo;0;L;;;;;N;;;;;
18953;TANGUT COMPONENT-340;Lo;0;L;;;;;N;;;;;
18954;TANGUT COMPONENT-341;Lo;0;L;;;;;N;;;;;
18955;TANGUT COMPONENT-342;Lo;0;L;;;;;N;;;;;
18956;TANGUT COMPONENT-343;Lo;0;L;;;;;N;;;;;
18957;TANGUT COMPONENT-344;Lo;0;L;;;;;N;;;;;
18958;TANGUT COMPONENT-345;Lo;0;L;;;;;N;;;;;
18959;TANGUT COMPONENT-346;Lo;0;L;;;;;N;;;;;
1895A;TANGUT COMPONENT-347;Lo;0;L;;;;;N;;;;;
1895B;TANGUT COMPONENT-348;Lo;0;L;;;;;N;;;;;
1895C;TANGUT COMPONENT-349;Lo;0;L;;;;;N;;;;;
1895D;TANGUT COMPONENT-350;Lo;0;L;;;;;N;;;;;
1895E;TANGUT COMPONENT-351;Lo;0;L;;;;;N;;;;;
1895F;TANGUT COMPONENT-352;Lo;0;L;;;;;N;;;;;
18960;TANGUT COMPONENT-353;Lo;0;L;;;;;N;;;;;
18961;TANGUT COMPONENT-354;Lo;0;L;;;;;N;;;;;
18962;TANGUT COMPONENT-355;Lo;0;L;;;;;N;;;;;
18963;TANGUT COMPONENT-356;Lo;0;L;;;;;N;;;;;
18964;TANGUT COMPONENT-357;Lo;0;L;;;;;N;;;;;
18965;TANGUT COMPONENT-358;Lo;0;L;;;;;N;;;;;
18966;TANGUT COMPONENT-359;Lo;0;L;;;;;N;;;;;
18967;TANGUT COMPONENT-360;Lo;0;L;;;;;N;;;;;
18968;TANGUT COMPONENT-361;Lo;0;L;;;;;N;;;;;
18969;TANGUT COMPONENT-362;Lo;0;L;;;;;N;;;;;
1896A;TANGUT COMPONENT-363;Lo;0;L;;;;;N;;;;;
1896B;TANGUT COMPONENT-364;Lo;0;L;;;;;N;;;;;
1896C;TANGUT COMPONENT-365;Lo;0;L;;;;;N;;;;;
1896D;TANGUT COMPONENT-366;Lo;0;L;;;;;N;;;;;
1896E;TANGUT COMPONENT-367;Lo;0;L;;;;;N;;;;;
1896F;TANGUT COMPONENT-368;Lo;0;L;;;;;N;;;;;
18970;TANGUT COMPONENT-369;Lo;0;L;;;;;N;;;;;
18971;TANGUT COMPONENT-370;Lo;0;L;;;;;N;;;;;
18972;TANGUT COMPONENT-371;Lo;0;L;;;;;N;;;;;
18973;TANGUT COMPONENT-372;Lo;0;L;;;;;N;;;;;
18974;TANGUT COMPONENT-373;Lo;0;L;;;;;N;;;;;
18975;TANGUT COMPONENT-374;Lo;0;L;;;;;N;;;;;
18976;TANGUT COMPONENT-375;Lo;0;L;;;;;N;;;;;
18977;TANGUT COMPONENT-376;Lo;0;L;;;;;N;;;;;
18978;TANGUT COMPONENT-377;Lo;0;L;;;;;N;;;;;
18979;TANGUT COMPONENT-378;Lo;0;L;;;;;N;;;;;
1897A;TANGUT COMPONENT-379;Lo;0;L;;;;;N;;;;;
1897B;TANGUT COMPONENT-380;Lo;0;L;;;;;N;;;;;
1897C;TANGUT COMPONENT-381;Lo;0;L;;;;;N;;;;;
1897D;TANGUT COMPONENT-382;Lo;0;L;;;;;N;;;;;
1897E;TANGUT COMPONENT-383;Lo;0;L;;;;;N;;;;;
1897F;TANGUT COMPONENT-384;Lo;0;L;;;;;N;;;;;
18980;TANGUT COMPONENT-385;Lo;0;L;;;;;N;;;;;
18981;TANGUT COMPONENT-386;Lo;0;L;;;;;N;;;;;
18982;TANGUT COMPONENT-387;Lo;0;L;;;;;N;;;;;
18983;TANGUT COMPONENT-388;Lo;0;L;;;;;N;;;;;
18984;TANGUT COMPONENT-389;Lo;0;L;;;;;N;;;;;
18985;TANGUT COMPONENT-390;Lo;0;L;;;;;N;;;;;
18986;TANGUT COMPONENT-391;Lo;0;L;;;;;N;;;;;
18987;TANGUT COMPONENT-392;Lo;0;L;;;;;N;;;;;
18988;TANGUT COMPONENT-393;Lo;0;L;;;;;N;;;;;
18989;TANGUT COMPONENT-394;Lo;0;L;;;;;N;;;;;
1898A;TANGUT COMPONENT-395;Lo;0;L;;;;;N;;;;;
1898B;TANGUT COMPONENT-396;Lo;0;L;;;;;N;;;;;
1898C;TANGUT COMPONENT-397;Lo;0;L;;;;;N;;;;;
1898D;TANGUT COMPONENT-398;Lo;0;L;;;;;N;;;;;
1898E;TANGUT COMPONENT-399;Lo;0;L;;;;;N;;;;;
1898F;TANGUT COMPONENT-400;Lo;0;L;;;;;N;;;;;
18990;TANGUT COMPONENT-401;Lo;0;L;;;;;N;;;;;
18991;TANGUT COMPONENT-402;Lo;0;L;;;;;N;;;;;
18992;TANGUT COMPONENT-403;Lo;0;L;;;;;N;;;;;
18993;TANGUT COMPONENT-404;Lo;0;L;;;;;N;;;;;
18994;TANGUT COMPONENT-405;Lo;0;L;;;;;N;;;;;
18995;TANGUT COMPONENT-406;Lo;0;L;;;;;N;;;;;
18996;TANGUT COMPONENT-407;Lo;0;L;;;;;N;;;;;
18997;TANGUT COMPONENT-408;Lo;0;L;;;;;N;;;;;
18998;TANGUT COMPONENT-409;Lo;0;L;;;;;N;;;;;
18999;TANGUT COMPONENT-410;Lo;0;L;;;;;N;;;;;
1899A;TANGUT COMPONENT-411;Lo;0;L;;;;;N;;;;;
1899B;TANGUT COMPONENT-412;Lo;0;L;;;;;N;;;;;
1899C;TANGUT COMPONENT-413;Lo;0;L;;;;;N;;;;;
1899D;TANGUT COMPONENT-414;Lo;0;L;;;;;N;;;;;
1899E;TANGUT COMPONENT-415;Lo;0;L;;;;;N;;;;;
1899F;TANGUT COMPONENT-416;Lo;0;L;;;;;N;;;;;
189A0;TANGUT COMPONENT-417;Lo;0;L;;;;;N;;;;;
189A1;TANGUT COMPONENT-418;Lo;0;L;;;;;N;;;;;
189A2;TANGUT COMPONENT-419;Lo;0;L;;;;;N;;;;;
189A3;TANGUT COMPONENT-420;Lo;0;L;;;;;N;;;;;
189A4;TANGUT COMPONENT-421;Lo;0;L;;;;;N;;;;;
189A5;TANGUT COMPONENT-422;Lo;0;L;;;;;N;;;;;
189A6;TANGUT COMPONENT-423;Lo;0;L;;;;;N;;;;;
189A7;TANGUT COMPONENT-424;Lo;0;L;;;;;N;;;;;
189A8;TANGUT COMPONENT-425;Lo;0;L;;;;;N;;;;;
189A9;TANGUT COMPONENT-426;Lo;0;L;;;;;N;;;;;
189AA;TANGUT COMPONENT-427;Lo;0;L;;;;;N;;;;;
189AB;TANGUT COMPONENT-428;Lo;0;L;;;;;N;;;;;
189AC;TANGUT COMPONENT-429;Lo;0;L;;;;;N;;;;;
189AD;TANGUT COMPONENT-430;Lo;0;L;;;;;N;;;;;
189AE;TANGUT COMPONENT-431;Lo;0;L;;;;;N;;;;;
189AF;TANGUT COMPONENT-432;Lo;0;L;;;;;N;;;;;
189B0;TANGUT COMPONENT-433;Lo;0;L;;;;;N;;;;;
189B1;TANGUT COMPONENT-434;Lo;0;L;;;;;N;;;;;
189B2;TANGUT COMPONENT-435;Lo;0;L;;;;;N;;;;;
189B3;TANGUT COMPONENT-436;Lo;0;L;;;;;N;;;;;
189B4;TANGUT COMPONENT-437;Lo;0;L;;;;;N;;;;;
189B5;TANGUT COMPONENT-438;Lo;0;L;;;;;N;;;;;
189B6;TANGUT COMPONENT-439;Lo;0;L;;;;;N;;;;;
189B7;TANGUT COMPONENT-440;Lo;0;L;;;;;N;;;;;
189B8;TANGUT COMPONENT-441;Lo;0;L;;;;;N;;;;;
189B9;TANGUT COMPONENT-442;Lo;0;L;;;;;N;;;;;
189BA;TANGUT COMPONENT-443;Lo;0;L;;;;;N;;;;;
189BB;TANGUT COMPONENT-444;Lo;0;L;;;;;N;;;;;
189BC;TANGUT COMPONENT-445;Lo;0;L;;;;;N;;;;;
189BD;TANGUT COMPONENT-446;Lo;0;L;;;;;N;;;;;
189BE;TANGUT COMPONENT-447;Lo;0;L;;;;;N;;;;;
189BF;TANGUT COMPONENT-448;Lo;0;L;;;;;N;;;;;
189C0;TANGUT COMPONENT-449;Lo;0;L;;;;;N;;;;;
189C1;TANGUT COMPONENT-450;Lo;0;L;;;;;N;;;;;
189C2;TANGUT COMPONENT-451;Lo;0;L;;;;;N;;;;;
189C3;TANGUT COMPONENT-452;Lo;0;L;;;;;N;;;;;
189C4;TANGUT COMPONENT-453;Lo;0;L;;;;;N;;;;;
189C5;TANGUT COMPONENT-454;Lo;0;L;;;;;N;;;;;
189C6;TANGUT COMPONENT-455;Lo;0;L;;;;;N;;;;;
189C7;TANGUT COMPONENT-456;Lo;0;L;;;;;N;;;;;
189C8;TANGUT COMPONENT-457;Lo;0;L;;;;;N;;;;;
189C9;TANGUT COMPONENT-458;Lo;0;L;;;;;N;;;;;
189CA;TANGUT COMPONENT-459;Lo;0;L;;;;;N;;;;;
189CB;TANGUT COMPONENT-460;Lo;0;L;;;;;N;;;;;
189CC;TANGUT COMPONENT-461;Lo;0;L;;;;;N;;;;;
189CD;TANGUT COMPONENT-462;Lo;0;L;;;;;N;;;;;
189CE;TANGUT COMPONENT-463;Lo;0;L;;;;;N;;;;;
189CF;TANGUT COMPONENT-464;Lo;0;L;;;;;N;;;;;
189D0;TANGUT COMPONENT-465;Lo;0;L;;;;;N;;;;;
189D1;TANGUT COMPONENT-466;Lo;0;L;;;;;N;;;;;
189D2;TANGUT COMPONENT-467;Lo;0;L;;;;;N;;;;;
189D3;TANGUT COMPONENT-468;Lo;0;L;;;;;N;;;;;
189D4;TANGUT COMPONENT-469;Lo;0;L;;;;;N;;;;;
189D5;TANGUT COMPONENT-470;Lo;0;L;;;;;N;;;;;
189D6;TANGUT COMPONENT-471;Lo;0;L;;;;;N;;;;;
189D7;TANGUT COMPONENT-472;Lo;0;L;;;;;N;;;;;
189D8;TANGUT COMPONENT-473;Lo;0;L;;;;;N;;;;;
189D9;TANGUT COMPONENT-474;Lo;0;L;;;;;N;;;;;
189DA;TANGUT COMPONENT-475;Lo;0;L;;;;;N;;;;;
189DB;TANGUT COMPONENT-476;Lo;0;L;;;;;N;;;;;
189DC;TANGUT COMPONENT-477;Lo;0;L;;;;;N;;;;;
189DD;TANGUT COMPONENT-478;Lo;0;L;;;;;N;;;;;
189DE;TANGUT COMPONENT-479;Lo;0;L;;;;;N;;;;;
189DF;TANGUT COMPONENT-480;Lo;0;L;;;;;N;;;;;
189E0;TANGUT COMPONENT-481;Lo;0;L;;;;;N;;;;;
189E1;TANGUT COMPONENT-482;Lo;0;L;;;;;N;;;;;
189E2;TANGUT COMPONENT-483;Lo;0;L;;;;;N;;;;;
189E3;TANGUT COMPONENT-484;Lo;0;L;;;;;N;;;;;
189E4;TANGUT COMPONENT-485;Lo;0;L;;;;;N;;;;;
189E5;TANGUT COMPONENT-486;Lo;0;L;;;;;N;;;;;
189E6;TANGUT COMPONENT-487;Lo;0;L;;;;;N;;;;;
189E7;TANGUT COMPONENT-488;Lo;0;L;;;;;N;;;;;
189E8;TANGUT COMPONENT-489;Lo;0;L;;;;;N;;;;;
189E9;TANGUT COMPONENT-490;Lo;0;L;;;;;N;;;;;
189EA;TANGUT COMPONENT-491;Lo;0;L;;;;;N;;;;;
189EB;TANGUT COMPONENT-492;Lo;0;L;;;;;N;;;;;
189EC;TANGUT COMPONENT-493;Lo;0;L;;;;;N;;;;;
189ED;TANGUT COMPONENT-494;Lo;0;L;;;;;N;;;;;
189EE;TANGUT COMPONENT-495;Lo;0;L;;;;;N;;;;;
189EF;TANGUT COMPONENT-496;Lo;0;L;;;;;N;;;;;
189F0;TANGUT COMPONENT-497;Lo;0;L;;;;;N;;;;;
189F1;TANGUT COMPONENT-498;Lo;0;L;;;;;N;;;;;
189F2;TANGUT COMPONENT-499;Lo;0;L;;;;;N;;;;;
189F3;TANGUT COMPONENT-500;Lo;0;L;;;;;N;;;;;
189F4;TANGUT COMPONENT-501;Lo;0;L;;;;;N;;;;;
189F5;TANGUT COMPONENT-502;Lo;0;L;;;;;N;;;;;
189F6;TANGUT COMPONENT-503;Lo;0;L;;;;;N;;;;;
189F7;TANGUT COMPONENT-504;Lo;0;L;;;;;N;;;;;
189F8;TANGUT COMPONENT-505;Lo;0;L;;;;;N;;;;;
189F9;TANGUT COMPONENT-506;Lo;0;L;;;;;N;;;;;
189FA;TANGUT COMPONENT-507;Lo;0;L;;;;;N;;;;;
189FB;TANGUT COMPONENT-508;Lo;0;L;;;;;N;;;;;
189FC;TANGUT COMPONENT-509;Lo;0;L;;;;;N;;;;;
189FD;TANGUT COMPONENT-510;Lo;0;L;;;;;N;;;;;
189FE;TANGUT COMPONENT-511;Lo;0;L;;;;;N;;;;;
189FF;TANGUT COMPONENT-512;Lo;0;L;;;;;N;;;;;
18A00;TANGUT COMPONENT-513;Lo;0;L;;;;;N;;;;;
18A01;TANGUT COMPONENT-514;Lo;0;L;;;;;N;;;;;
18A02;TANGUT COMPONENT-515;Lo;0;L;;;;;N;;;;;
18A03;TANGUT COMPONENT-516;Lo;0;L;;;;;N;;;;;
18A04;TANGUT COMPONENT-517;Lo;0;L;;;;;N;;;;;
18A05;TANGUT COMPONENT-518;Lo;0;L;;;;;N;;;;;
18A06;TANGUT COMPONENT-519;Lo;0;L;;;;;N;;;;;
18A07;TANGUT COMPONENT-520;Lo;0;L;;;;;N;;;;;
18A08;TANGUT COMPONENT-521;Lo;0;L;;;;;N;;;;;
18A09;TANGUT COMPONENT-522;Lo;0;L;;;;;N;;;;;
18A0A;TANGUT COMPONENT-523;Lo;0;L;;;;;N;;;;;
18A0B;TANGUT COMPONENT-524;Lo;0;L;;;;;N;;;;;
18A0C;TANGUT COMPONENT-525;Lo;0;L;;;;;N;;;;;
18A0D;TANGUT COMPONENT-526;Lo;0;L;;;;;N;;;;;
18A0E;TANGUT COMPONENT-527;Lo;0;L;;;;;N;;;;;
18A0F;TANGUT COMPONENT-528;Lo;0;L;;;;;N;;;;;
18A10;TANGUT COMPONENT-529;Lo;0;L;;;;;N;;;;;
18A11;TANGUT COMPONENT-530;Lo;0;L;;;;;N;;;;;
18A12;TANGUT COMPONENT-531;Lo;0;L;;;;;N;;;;;
18A13;TANGUT COMPONENT-532;Lo;0;L;;;;;N;;;;;
18A14;TANGUT COMPONENT-533;Lo;0;L;;;;;N;;;;;
18A15;TANGUT COMPONENT-534;Lo;0;L;;;;;N;;;;;
18A16;TANGUT COMPONENT-535;Lo;0;L;;;;;N;;;;;
18A17;TANGUT COMPONENT-536;Lo;0;L;;;;;N;;;;;
18A18;TANGUT COMPONENT-537;Lo;0;L;;;;;N;;;;;
18A19;TANGUT COMPONENT-538;Lo;0;L;;;;;N;;;;;
18A1A;TANGUT COMPONENT-539;Lo;0;L;;;;;N;;;;;
18A1B;TANGUT COMPONENT-540;Lo;0;L;;;;;N;;;;;
18A1C;TANGUT COMPONENT-541;Lo;0;L;;;;;N;;;;;
18A1D;TANGUT COMPONENT-542;Lo;0;L;;;;;N;;;;;
18A1E;TANGUT COMPONENT-543;Lo;0;L;;;;;N;;;;;
18A1F;TANGUT COMPONENT-544;Lo;0;L;;;;;N;;;;;
18A20;TANGUT COMPONENT-545;Lo;0;L;;;;;N;;;;;
18A21;TANGUT COMPONENT-546;Lo;0;L;;;;;N;;;;;
18A22;TANGUT COMPONENT-547;Lo;0;L;;;;;N;;;;;
18A23;TANGUT COMPONENT-548;Lo;0;L;;;;;N;;;;;
18A24;TANGUT COMPONENT-549;Lo;0;L;;;;;N;;;;;
18A25;TANGUT COMPONENT-550;Lo;0;L;;;;;N;;;;;
18A26;TANGUT COMPONENT-551;Lo;0;L;;;;;N;;;;;
18A27;TANGUT COMPONENT-552;Lo;0;L;;;;;N;;;;;
18A28;TANGUT COMPONENT-553;Lo;0;L;;;;;N;;;;;
18A29;TANGUT COMPONENT-554;Lo;0;L;;;;;N;;;;;
18A2A;TANGUT COMPONENT-555;Lo;0;L;;;;;N;;;;;
18A2B;TANGUT COMPONENT-556;Lo;0;L;;;;;N;;;;;
18A2C;TANGUT COMPONENT-557;Lo;0;L;;;;;N;;;;;
18A2D;TANGUT COMPONENT-558;Lo;0;L;;;;;N;;;;;
18A2E;TANGUT COMPONENT-559;Lo;0;L;;;;;N;;;;;
18A2F;TANGUT COMPONENT-560;Lo;0;L;;;;;N;;;;;
18A30;TANGUT COMPONENT-561;Lo;0;L;;;;;N;;;;;
18A31;TANGUT COMPONENT-562;Lo;0;L;;;;;N;;;;;
18A32;TANGUT COMPONENT-563;Lo;0;L;;;;;N;;;;;
18A33;TANGUT COMPONENT-564;Lo;0;L;;;;;N;;;;;
18A34;TANGUT COMPONENT-565;Lo;0;L;;;;;N;;;;;
18A35;TANGUT COMPONENT-566;Lo;0;L;;;;;N;;;;;
18A36;TANGUT COMPONENT-567;Lo;0;L;;;;;N;;;;;
18A37;TANGUT COMPONENT-568;Lo;0;L;;;;;N;;;;;
18A38;TANGUT COMPONENT-569;Lo;0;L;;;;;N;;;;;
18A39;TANGUT COMPONENT-570;Lo;0;L;;;;;N;;;;;
18A3A;TANGUT COMPONENT-571;Lo;0;L;;;;;N;;;;;
18A3B;TANGUT COMPONENT-572;Lo;0;L;;;;;N;;;;;
18A3C;TANGUT COMPONENT-573;Lo;0;L;;;;;N;;;;;
18A3D;TANGUT COMPONENT-574;Lo;0;L;;;;;N;;;;;
18A3E;TANGUT COMPONENT-575;Lo;0;L;;;;;N;;;;;
18A3F;TANGUT COMPONENT-576;Lo;0;L;;;;;N;;;;;
18A40;TANGUT COMPONENT-577;Lo;0;L;;;;;N;;;;;
18A41;TANGUT COMPONENT-578;Lo;0;L;;;;;N;;;;;
18A42;TANGUT COMPONENT-579;Lo;0;L;;;;;N;;;;;
18A43;TANGUT COMPONENT-580;Lo;0;L;;;;;N;;;;;
18A44;TANGUT COMPONENT-581;Lo;0;L;;;;;N;;;;;
18A45;TANGUT COMPONENT-582;Lo;0;L;;;;;N;;;;;
18A46;TANGUT COMPONENT-583;Lo;0;L;;;;;N;;;;;
18A47;TANGUT COMPONENT-584;Lo;0;L;;;;;N;;;;;
18A48;TANGUT COMPONENT-585;Lo;0;L;;;;;N;;;;;
18A49;TANGUT COMPONENT-586;Lo;0;L;;;;;N;;;;;
18A4A;TANGUT COMPONENT-587;Lo;0;L;;;;;N;;;;;
18A4B;TANGUT COMPONENT-588;Lo;0;L;;;;;N;;;;;
18A4C;TANGUT COMPONENT-589;Lo;0;L;;;;;N;;;;;
18A4D;TANGUT COMPONENT-590;Lo;0;L;;;;;N;;;;;
18A4E;TANGUT COMPONENT-591;Lo;0;L;;;;;N;;;;;
18A4F;TANGUT COMPONENT-592;Lo;0;L;;;;;N;;;;;
18A50;TANGUT COMPONENT-593;Lo;0;L;;;;;N;;;;;
18A51;TANGUT COMPONENT-594;Lo;0;L;;;;;N;;;;;
18A52;TANGUT COMPONENT-595;Lo;0;L;;;;;N;;;;;
18A53;TANGUT COMPONENT-596;Lo;0;L;;;;;N;;;;;
18A54;TANGUT COMPONENT-597;Lo;0;L;;;;;N;;;;;
18A55;TANGUT COMPONENT-598;Lo;0;L;;;;;N;;;;;
18A56;TANGUT COMPONENT-599;Lo;0;L;;;;;N;;;;;
18A57;TANGUT COMPONENT-600;Lo;0;L;;;;;N;;;;;
18A58;TANGUT COMPONENT-601;Lo;0;L;;;;;N;;;;;
18A59;TANGUT COMPONENT-602;Lo;0;L;;;;;N;;;;;
18A5A;TANGUT COMPONENT-603;Lo;0;L;;;;;N;;;;;
18A5B;TANGUT COMPONENT-604;Lo;0;L;;;;;N;;;;;
18A5C;TANGUT COMPONENT-605;Lo;0;L;;;;;N;;;;;
18A5D;TANGUT COMPONENT-606;Lo;0;L;;;;;N;;;;;
18A5E;TANGUT COMPONENT-607;Lo;0;L;;;;;N;;;;;
18A5F;TANGUT COMPONENT-608;Lo;0;L;;;;;N;;;;;
18A60;TANGUT COMPONENT-609;Lo;0;L;;;;;N;;;;;
18A61;TANGUT COMPONENT-610;Lo;0;L;;;;;N;;;;;
18A62;TANGUT COMPONENT-611;Lo;0;L;;;;;N;;;;;
18A63;TANGUT COMPONENT-612;Lo;0;L;;;;;N;;;;;
18A64;TANGUT COMPONENT-613;Lo;0;L;;;;;N;;;;;
18A65;TANGUT COMPONENT-614;Lo;0;L;;;;;N;;;;;
18A66;TANGUT COMPONENT-615;Lo;0;L;;;;;N;;;;;
18A67;TANGUT COMPONENT-616;Lo;0;L;;;;;N;;;;;
18A68;TANGUT COMPONENT-617;Lo;0;L;;;;;N;;;;;
18A69;TANGUT COMPONENT-618;Lo;0;L;;;;;N;;;;;
18A6A;TANGUT COMPONENT-619;Lo;0;L;;;;;N;;;;;
18A6B;TANGUT COMPONENT-620;Lo;0;L;;;;;N;;;;;
18A6C;TANGUT COMPONENT-621;Lo;0;L;;;;;N;;;;;
18A6D;TANGUT COMPONENT-622;Lo;0;L;;;;;N;;;;;
18A6E;TANGUT COMPONENT-623;Lo;0;L;;;;;N;;;;;
18A6F;TANGUT COMPONENT-624;Lo;0;L;;;;;N;;;;;
18A70;TANGUT COMPONENT-625;Lo;0;L;;;;;N;;;;;
18A71;TANGUT COMPONENT-626;Lo;0;L;;;;;N;;;;;
18A72;TANGUT COMPONENT-627;Lo;0;L;;;;;N;;;;;
18A73;TANGUT COMPONENT-628;Lo;0;L;;;;;N;;;;;
18A74;TANGUT COMPONENT-629;Lo;0;L;;;;;N;;;;;
18A75;TANGUT COMPONENT-630;Lo;0;L;;;;;N;;;;;
18A76;TANGUT COMPONENT-631;Lo;0;L;;;;;N;;;;;
18A77;TANGUT COMPONENT-632;Lo;0;L;;;;;N;;;;;
18A78;TANGUT COMPONENT-633;Lo;0;L;;;;;N;;;;;
18A79;TANGUT COMPONENT-634;Lo;0;L;;;;;N;;;;;
18A7A;TANGUT COMPONENT-635;Lo;0;L;;;;;N;;;;;
18A7B;TANGUT COMPONENT-636;Lo;0;L;;;;;N;;;;;
18A7C;TANGUT COMPONENT-637;Lo;0;L;;;;;N;;;;;
18A7D;TANGUT COMPONENT-638;Lo;0;L;;;;;N;;;;;
18A7E;TANGUT COMPONENT-639;Lo;0;L;;;;;N;;;;;
18A7F;TANGUT COMPONENT-640;Lo;0;L;;;;;N;;;;;
18A80;TANGUT COMPONENT-641;Lo;0;L;;;;;N;;;;;
18A81;TANGUT COMPONENT-642;Lo;0;L;;;;;N;;;;;
18A82;TANGUT COMPONENT-643;Lo;0;L;;;;;N;;;;;
18A83;TANGUT COMPONENT-644;Lo;0;L;;;;;N;;;;;
18A84;TANGUT COMPONENT-645;Lo;0;L;;;;;N;;;;;
18A85;TANGUT COMPONENT-646;Lo;0;L;;;;;N;;;;;
18A86;TANGUT COMPONENT-647;Lo;0;L;;;;;N;;;;;
18A87;TANGUT COMPONENT-648;Lo;0;L;;;;;N;;;;;
18A88;TANGUT COMPONENT-649;Lo;0;L;;;;;N;;;;;
18A89;TANGUT COMPONENT-650;Lo;0;L;;;;;N;;;;;
18A8A;TANGUT COMPONENT-651;Lo;0;L;;;;;N;;;;;
18A8B;TANGUT COMPONENT-652;Lo;0;L;;;;;N;;;;;
18A8C;TANGUT COMPONENT-653;Lo;0;L;;;;;N;;;;;
18A8D;TANGUT COMPONENT-654;Lo;0;L;;;;;N;;;;;
18A8E;TANGUT COMPONENT-655;Lo;0;L;;;;;N;;;;;
18A8F;TANGUT COMPONENT-656;Lo;0;L;;;;;N;;;;;
18A90;TANGUT COMPONENT-657;Lo;0;L;;;;;N;;;;;
18A91;TANGUT COMPONENT-658;Lo;0;L;;;;;N;;;;;
18A92;TANGUT COMPONENT-659;Lo;0;L;;;;;N;;;;;
18A93;TANGUT COMPONENT-660;Lo;0;L;;;;;N;;;;;
18A94;TANGUT COMPONENT-661;Lo;0;L;;;;;N;;;;;
18A95;TANGUT COMPONENT-662;Lo;0;L;;;;;N;;;;;
18A96;TANGUT COMPONENT-663;Lo;0;L;;;;;N;;;;;
18A97;TANGUT COMPONENT-664;Lo;0;L;;;;;N;;;;;
18A98;TANGUT COMPONENT-665;Lo;0;L;;;;;N;;;;;
18A99;TANGUT COMPONENT-666;Lo;0;L;;;;;N;;;;;
18A9A;TANGUT COMPONENT-667;Lo;0;L;;;;;N;;;;;
18A9B;TANGUT COMPONENT-668;Lo;0;L;;;;;N;;;;;
18A9C;TANGUT COMPONENT-669;Lo;0;L;;;;;N;;;;;
18A9D;TANGUT COMPONENT-670;Lo;0;L;;;;;N;;;;;
18A9E;TANGUT COMPONENT-671;Lo;0;L;;;;;N;;;;;
18A9F;TANGUT COMPONENT-672;Lo;0;L;;;;;N;;;;;
18AA0;TANGUT COMPONENT-673;Lo;0;L;;;;;N;;;;;
18AA1;TANGUT COMPONENT-674;Lo;0;L;;;;;N;;;;;
18AA2;TANGUT COMPONENT-675;Lo;0;L;;;;;N;;;;;
18AA3;TANGUT COMPONENT-676;Lo;0;L;;;;;N;;;;;
18AA4;TANGUT COMPONENT-677;Lo;0;L;;;;;N;;;;;
18AA5;TANGUT COMPONENT-678;Lo;0;L;;;;;N;;;;;
18AA6;TANGUT COMPONENT-679;Lo;0;L;;;;;N;;;;;
18AA7;TANGUT COMPONENT-680;Lo;0;L;;;;;N;;;;;
18AA8;TANGUT COMPONENT-681;Lo;0;L;;;;;N;;;;;
18AA9;TANGUT COMPONENT-682;Lo;0;L;;;;;N;;;;;
18AAA;TANGUT COMPONENT-683;Lo;0;L;;;;;N;;;;;
18AAB;TANGUT COMPONENT-684;Lo;0;L;;;;;N;;;;;
18AAC;TANGUT COMPONENT-685;Lo;0;L;;;;;N;;;;;
18AAD;TANGUT COMPONENT-686;Lo;0;L;;;;;N;;;;;
18AAE;TANGUT COMPONENT-687;Lo;0;L;;;;;N;;;;;
18AAF;TANGUT COMPONENT-688;Lo;0;L;;;;;N;;;;;
18AB0;TANGUT COMPONENT-689;Lo;0;L;;;;;N;;;;;
18AB1;TANGUT COMPONENT-690;Lo;0;L;;;;;N;;;;;
18AB2;TANGUT COMPONENT-691;Lo;0;L;;;;;N;;;;;
18AB3;TANGUT COMPONENT-692;Lo;0;L;;;;;N;;;;;
18AB4;TANGUT COMPONENT-693;Lo;0;L;;;;;N;;;;;
18AB5;TANGUT COMPONENT-694;Lo;0;L;;;;;N;;;;;
18AB6;TANGUT COMPONENT-695;Lo;0;L;;;;;N;;;;;
18AB7;TANGUT COMPONENT-696;Lo;0;L;;;;;N;;;;;
18AB8;TANGUT COMPONENT-697;Lo;0;L;;;;;N;;;;;
18AB9;TANGUT COMPONENT-698;Lo;0;L;;;;;N;;;;;
18ABA;TANGUT COMPONENT-699;Lo;0;L;;;;;N;;;;;
18ABB;TANGUT COMPONENT-700;Lo;0;L;;;;;N;;;;;
18ABC;TANGUT COMPONENT-701;Lo;0;L;;;;;N;;;;;
18ABD;TANGUT COMPONENT-702;Lo;0;L;;;;;N;;;;;
18ABE;TANGUT COMPONENT-703;Lo;0;L;;;;;N;;;;;
18ABF;TANGUT COMPONENT-704;Lo;0;L;;;;;N;;;;;
18AC0;TANGUT COMPONENT-705;Lo;0;L;;;;;N;;;;;
18AC1;TANGUT COMPONENT-706;Lo;0;L;;;;;N;;;;;
18AC2;TANGUT COMPONENT-707;Lo;0;L;;;;;N;;;;;
18AC3;TANGUT COMPONENT-708;Lo;0;L;;;;;N;;;;;
18AC4;TANGUT COMPONENT-709;Lo;0;L;;;;;N;;;;;
18AC5;TANGUT COMPONENT-710;Lo;0;L;;;;;N;;;;;
18AC6;TANGUT COMPONENT-711;Lo;0;L;;;;;N;;;;;
18AC7;TANGUT COMPONENT-712;Lo;0;L;;;;;N;;;;;
18AC8;TANGUT COMPONENT-713;Lo;0;L;;;;;N;;;;;
18AC9;TANGUT COMPONENT-714;Lo;0;L;;;;;N;;;;;
18ACA;TANGUT COMPONENT-715;Lo;0;L;;;;;N;;;;;
18ACB;TANGUT COMPONENT-716;Lo;0;L;;;;;N;;;;;
18ACC;TANGUT COMPONENT-717;Lo;0;L;;;;;N;;;;;
18ACD;TANGUT COMPONENT-718;Lo;0;L;;;;;N;;;;;
18ACE;TANGUT COMPONENT-719;Lo;0;L;;;;;N;;;;;
18ACF;TANGUT COMPONENT-720;Lo;0;L;;;;;N;;;;;
18AD0;TANGUT COMPONENT-721;Lo;0;L;;;;;N;;;;;
18AD1;TANGUT COMPONENT-722;Lo;0;L;;;;;N;;;;;
18AD2;TANGUT COMPONENT-723;Lo;0;L;;;;;N;;;;;
18AD3;TANGUT COMPONENT-724;Lo;0;L;;;;;N;;;;;
18AD4;TANGUT COMPONENT-725;Lo;0;L;;;;;N;;;;;
18AD5;TANGUT COMPONENT-726;Lo;0;L;;;;;N;;;;;
18AD6;TANGUT COMPONENT-727;Lo;0;L;;;;;N;;;;;
18AD7;TANGUT COMPONENT-728;Lo;0;L;;;;;N;;;;;
18AD8;TANGUT COMPONENT-729;Lo;0;L;;;;;N;;;;;
18AD9;TANGUT COMPONENT-730;Lo;0;L;;;;;N;;;;;
18ADA;TANGUT COMPONENT-731;Lo;0;L;;;;;N;;;;;
18ADB;TANGUT COMPONENT-732;Lo;0;L;;;;;N;;;;;
18ADC;TANGUT COMPONENT-733;Lo;0;L;;;;;N;;;;;
18ADD;TANGUT COMPONENT-734;Lo;0;L;;;;;N;;;;;
18ADE;TANGUT COMPONENT-735;Lo;0;L;;;;;N;;;;;
18ADF;TANGUT COMPONENT-736;Lo;0;L;;;;;N;;;;;
18AE0;TANGUT COMPONENT-737;Lo;0;L;;;;;N;;;;;
18AE1;TANGUT COMPONENT-738;Lo;0;L;;;;;N;;;;;
18AE2;TANGUT COMPONENT-739;Lo;0;L;;;;;N;;;;;
18AE3;TANGUT COMPONENT-740;Lo;0;L;;;;;N;;;;;
18AE4;TANGUT COMPONENT-741;Lo;0;L;;;;;N;;;;;
18AE5;TANGUT COMPONENT-742;Lo;0;L;;;;;N;;;;;
18AE6;TANGUT COMPONENT-743;Lo;0;L;;;;;N;;;;;
18AE7;TANGUT COMPONENT-744;Lo;0;L;;;;;N;;;;;
18AE8;TANGUT COMPONENT-745;Lo;0;L;;;;;N;;;;;
18AE9;TANGUT COMPONENT-746;Lo;0;L;;;;;N;;;;;
18AEA;TANGUT COMPONENT-747;Lo;0;L;;;;;N;;;;;
18AEB;TANGUT COMPONENT-748;Lo;0;L;;;;;N;;;;;
18AEC;TANGUT COMPONENT-749;Lo;0;L;;;;;N;;;;;
18AED;TANGUT COMPONENT-750;Lo;0;L;;;;;N;;;;;
18AEE;TANGUT COMPONENT-751;Lo;0;L;;;;;N;;;;;
18AEF;TANGUT COMPONENT-752;Lo;0;L;;;;;N;;;;;
18AF0;TANGUT COMPONENT-753;Lo;0;L;;;;;N;;;;;
18AF1;TANGUT COMPONENT-754;Lo;0;L;;;;;N;;;;;
18AF2;TANGUT COMPONENT-755;Lo;0;L;;;;;N;;;;;
18AF3;TANGUT COMPONENT-756;Lo;0;L;;;;;N;;;;;
18AF4;TANGUT COMPONENT-757;Lo;0;L;;;;;N;;;;;
18AF5;TANGUT COMPONENT-758;Lo;0;L;;;;;N;;;;;
18AF6;TANGUT COMPONENT-759;Lo;0;L;;;;;N;;;;;
18AF7;TANGUT COMPONENT-760;Lo;0;L;;;;;N;;;;;
18AF8;TANGUT COMPONENT-761;Lo;0;L;;;;;N;;;;;
18AF9;TANGUT COMPONENT-762;Lo;0;L;;;;;N;;;;;
18AFA;TANGUT COMPONENT-763;Lo;0;L;;;;;N;;;;;
18AFB;TANGUT COMPONENT-764;Lo;0;L;;;;;N;;;;;
18AFC;TANGUT COMPONENT-765;Lo;0;L;;;;;N;;;;;
18AFD;TANGUT COMPONENT-766;Lo;0;L;;;;;N;;;;;
18AFE;TANGUT COMPONENT-767;Lo;0;L;;;;;N;;;;;
18AFF;TANGUT COMPONENT-768;Lo;0;L;;;;;N;;;;;
18B00;KHITAN SMALL SCRIPT CHARACTER-18B00;Lo;0;L;;;;;N;;;;;
18B01;KHITAN SMALL SCRIPT CHARACTER-18B01;Lo;0;L;;;;;N;;;;;
18B02;KHITAN SMALL SCRIPT CHARACTER-18B02;Lo;0;L;;;;;N;;;;;
18B03;KHITAN SMALL SCRIPT CHARACTER-18B03;Lo;0;L;;;;;N;;;;;
18B04;KHITAN SMALL SCRIPT CHARACTER-18B04;Lo;0;L;;;;;N;;;;;
18B05;KHITAN SMALL SCRIPT CHARACTER-18B05;Lo;0;L;;;;;N;;;;;
18B06;KHITAN SMALL SCRIPT CHARACTER-18B06;Lo;0;L;;;;;N;;;;;
18B07;KHITAN SMALL SCRIPT CHARACTER-18B07;Lo;0;L;;;;;N;;;;;
18B08;KHITAN SMALL SCRIPT CHARACTER-18B08;Lo;0;L;;;;;N;;;;;
18B09;KHITAN SMALL SCRIPT CHARACTER-18B09;Lo;0;L;;;;;N;;;;;
18B0A;KHITAN SMALL SCRIPT CHARACTER-18B0A;Lo;0;L;;;;;N;;;;;
18B0B;KHITAN SMALL SCRIPT CHARACTER-18B0B;Lo;0;L;;;;;N;;;;;
18B0C;KHITAN SMALL SCRIPT CHARACTER-18B0C;Lo;0;L;;;;;N;;;;;
18B0D;KHITAN SMALL SCRIPT CHARACTER-18B0D;Lo;0;L;;;;;N;;;;;
18B0E;KHITAN SMALL SCRIPT CHARACTER-18B0E;Lo;0;L;;;;;N;;;;;
18B0F;KHITAN SMALL SCRIPT CHARACTER-18B0F;Lo;0;L;;;;;N;;;;;
18B10;KHITAN SMALL SCRIPT CHARACTER-18B10;Lo;0;L;;;;;N;;;;;
18B11;KHITAN SMALL SCRIPT CHARACTER-18B11;Lo;0;L;;;;;N;;;;;
18B12;KHITAN SMALL SCRIPT CHARACTER-18B12;Lo;0;L;;;;;N;;;;;
18B13;KHITAN SMALL SCRIPT CHARACTER-18B13;Lo;0;L;;;;;N;;;;;
18B14;KHITAN SMALL SCRIPT CHARACTER-18B14;Lo;0;L;;;;;N;;;;;
18B15;KHITAN SMALL SCRIPT CHARACTER-18B15;Lo;0;L;;;;;N;;;;;
18B16;KHITAN SMALL SCRIPT CHARACTER-18B16;Lo;0;L;;;;;N;;;;;
18B17;KHITAN SMALL SCRIPT CHARACTER-18B17;Lo;0;L;;;;;N;;;;;
18B18;KHITAN SMALL SCRIPT CHARACTER-18B18;Lo;0;L;;;;;N;;;;;
18B19;KHITAN SMALL SCRIPT CHARACTER-18B19;Lo;0;L;;;;;N;;;;;
18B1A;KHITAN SMALL SCRIPT CHARACTER-18B1A;Lo;0;L;;;;;N;;;;;
18B1B;KHITAN SMALL SCRIPT CHARACTER-18B1B;Lo;0;L;;;;;N;;;;;
18B1C;KHITAN SMALL SCRIPT CHARACTER-18B1C;Lo;0;L;;;;;N;;;;;
18B1D;KHITAN SMALL SCRIPT CHARACTER-18B1D;Lo;0;L;;;;;N;;;;;
18B1E;KHITAN SMALL SCRIPT CHARACTER-18B1E;Lo;0;L;;;;;N;;;;;
18B1F;KHITAN SMALL SCRIPT CHARACTER-18B1F;Lo;0;L;;;;;N;;;;;
18B20;KHITAN SMALL SCRIPT CHARACTER-18B20;Lo;0;L;;;;;N;;;;;
18B21;KHITAN SMALL SCRIPT CHARACTER-18B21;Lo;0;L;;;;;N;;;;;
18B22;KHITAN SMALL SCRIPT CHARACTER-18B22;Lo;0;L;;;;;N;;;;;
18B23;KHITAN SMALL SCRIPT CHARACTER-18B23;Lo;0;L;;;;;N;;;;;
18B24;KHITAN SMALL SCRIPT CHARACTER-18B24;Lo;0;L;;;;;N;;;;;
18B25;KHITAN SMALL SCRIPT CHARACTER-18B25;Lo;0;L;;;;;N;;;;;
18B26;KHITAN SMALL SCRIPT CHARACTER-18B26;Lo;0;L;;;;;N;;;;;
18B27;KHITAN SMALL SCRIPT CHARACTER-18B27;Lo;0;L;;;;;N;;;;;
18B28;KHITAN SMALL SCRIPT CHARACTER-18B28;Lo;0;L;;;;;N;;;;;
18B29;KHITAN SMALL SCRIPT CHARACTER-18B29;Lo;0;L;;;;;N;;;;;
18B2A;KHITAN SMALL SCRIPT CHARACTER-18B2A;Lo;0;L;;;;;N;;;;;
18B2B;KHITAN SMALL SCRIPT CHARACTER-18B2B;Lo;0;L;;;;;N;;;;;
18B2C;KHITAN SMALL SCRIPT CHARACTER-18B2C;Lo;0;L;;;;;N;;;;;
18B2D;KHITAN SMALL SCRIPT CHARACTER-18B2D;Lo;0;L;;;;;N;;;;;
18B2E;KHITAN SMALL SCRIPT CHARACTER-18B2E;Lo;0;L;;;;;N;;;;;
18B2F;KHITAN SMALL SCRIPT CHARACTER-18B2F;Lo;0;L;;;;;N;;;;;
18B30;KHITAN SMALL SCRIPT CHARACTER-18B30;Lo;0;L;;;;;N;;;;;
18B31;KHITAN SMALL SCRIPT CHARACTER-18B31;Lo;0;L;;;;;N;;;;;
18B32;KHITAN SMALL SCRIPT CHARACTER-18B32;Lo;0;L;;;;;N;;;;;
18B33;KHITAN SMALL SCRIPT CHARACTER-18B33;Lo;0;L;;;;;N;;;;;
18B34;KHITAN SMALL SCRIPT CHARACTER-18B34;Lo;0;L;;;;;N;;;;;
18B35;KHITAN SMALL SCRIPT CHARACTER-18B35;Lo;0;L;;;;;N;;;;;
18B36;KHITAN SMALL SCRIPT CHARACTER-18B36;Lo;0;L;;;;;N;;;;;
18B37;KHITAN SMALL SCRIPT CHARACTER-18B37;Lo;0;L;;;;;N;;;;;
18B38;KHITAN SMALL SCRIPT CHARACTER-18B38;Lo;0;L;;;;;N;;;;;
18B39;KHITAN SMALL SCRIPT CHARACTER-18B39;Lo;0;L;;;;;N;;;;;
18B3A;KHITAN SMALL SCRIPT CHARACTER-18B3A;Lo;0;L;;;;;N;;;;;
18B3B;KHITAN SMALL SCRIPT CHARACTER-18B3B;Lo;0;L;;;;;N;;;;;
18B3C;KHITAN SMALL SCRIPT CHARACTER-18B3C;Lo;0;L;;;;;N;;;;;
18B3D;KHITAN SMALL SCRIPT CHARACTER-18B3D;Lo;0;L;;;;;N;;;;;
18B3E;KHITAN SMALL SCRIPT CHARACTER-18B3E;Lo;0;L;;;;;N;;;;;
18B3F;KHITAN SMALL SCRIPT CHARACTER-18B3F;Lo;0;L;;;;;N;;;;;
18B40;KHITAN SMALL SCRIPT CHARACTER-18B40;Lo;0;L;;;;;N;;;;;
18B41;KHITAN SMALL SCRIPT CHARACTER-18B41;Lo;0;L;;;;;N;;;;;
18B42;KHITAN SMALL SCRIPT CHARACTER-18B42;Lo;0;L;;;;;N;;;;;
18B43;KHITAN SMALL SCRIPT CHARACTER-18B43;Lo;0;L;;;;;N;;;;;
18B44;KHITAN SMALL SCRIPT CHARACTER-18B44;Lo;0;L;;;;;N;;;;;
18B45;KHITAN SMALL SCRIPT CHARACTER-18B45;Lo;0;L;;;;;N;;;;;
18B46;KHITAN SMALL SCRIPT CHARACTER-18B46;Lo;0;L;;;;;N;;;;;
18B47;KHITAN SMALL SCRIPT CHARACTER-18B47;Lo;0;L;;;;;N;;;;;
18B48;KHITAN SMALL SCRIPT CHARACTER-18B48;Lo;0;L;;;;;N;;;;;
18B49;KHITAN SMALL SCRIPT CHARACTER-18B49;Lo;0;L;;;;;N;;;;;
18B4A;KHITAN SMALL SCRIPT CHARACTER-18B4A;Lo;0;L;;;;;N;;;;;
18B4B;KHITAN SMALL SCRIPT CHARACTER-18B4B;Lo;0;L;;;;;N;;;;;
18B4C;KHITAN SMALL SCRIPT CHARACTER-18B4C;Lo;0;L;;;;;N;;;;;
18B4D;KHITAN SMALL SCRIPT CHARACTER-18B4D;Lo;0;L;;;;;N;;;;;
18B4E;KHITAN SMALL SCRIPT CHARACTER-18B4E;Lo;0;L;;;;;N;;;;;
18B4F;KHITAN SMALL SCRIPT CHARACTER-18B4F;Lo;0;L;;;;;N;;;;;
18B50;KHITAN SMALL SCRIPT CHARACTER-18B50;Lo;0;L;;;;;N;;;;;
18B51;KHITAN SMALL SCRIPT CHARACTER-18B51;Lo;0;L;;;;;N;;;;;
18B52;KHITAN SMALL SCRIPT CHARACTER-18B52;Lo;0;L;;;;;N;;;;;
18B53;KHITAN SMALL SCRIPT CHARACTER-18B53;Lo;0;L;;;;;N;;;;;
18B54;KHITAN SMALL SCRIPT CHARACTER-18B54;Lo;0;L;;;;;N;;;;;
18B55;KHITAN SMALL SCRIPT CHARACTER-18B55;Lo;0;L;;;;;N;;;;;
18B56;KHITAN SMALL SCRIPT CHARACTER-18B56;Lo;0;L;;;;;N;;;;;
18B57;KHITAN SMALL SCRIPT CHARACTER-18B57;Lo;0;L;;;;;N;;;;;
18B58;KHITAN SMALL SCRIPT CHARACTER-18B58;Lo;0;L;;;;;N;;;;;
18B59;KHITAN SMALL SCRIPT CHARACTER-18B59;Lo;0;L;;;;;N;;;;;
18B5A;KHITAN SMALL SCRIPT CHARACTER-18B5A;Lo;0;L;;;;;N;;;;;
18B5B;KHITAN SMALL SCRIPT CHARACTER-18B5B;Lo;0;L;;;;;N;;;;;
18B5C;KHITAN SMALL SCRIPT CHARACTER-18B5C;Lo;0;L;;;;;N;;;;;
18B5D;KHITAN SMALL SCRIPT CHARACTER-18B5D;Lo;0;L;;;;;N;;;;;
18B5E;KHITAN SMALL SCRIPT CHARACTER-18B5E;Lo;0;L;;;;;N;;;;;
18B5F;KHITAN SMALL SCRIPT CHARACTER-18B5F;Lo;0;L;;;;;N;;;;;
18B60;KHITAN SMALL SCRIPT CHARACTER-18B60;Lo;0;L;;;;;N;;;;;
18B61;KHITAN SMALL SCRIPT CHARACTER-18B61;Lo;0;L;;;;;N;;;;;
18B62;KHITAN SMALL SCRIPT CHARACTER-18B62;Lo;0;L;;;;;N;;;;;
18B63;KHITAN SMALL SCRIPT CHARACTER-18B63;Lo;0;L;;;;;N;;;;;
18B64;KHITAN SMALL SCRIPT CHARACTER-18B64;Lo;0;L;;;;;N;;;;;
18B65;KHITAN SMALL SCRIPT CHARACTER-18B65;Lo;0;L;;;;;N;;;;;
18B66;KHITAN SMALL SCRIPT CHARACTER-18B66;Lo;0;L;;;;;N;;;;;
18B67;KHITAN SMALL SCRIPT CHARACTER-18B67;Lo;0;L;;;;;N;;;;;
18B68;KHITAN SMALL SCRIPT CHARACTER-18B68;Lo;0;L;;;;;N;;;;;
18B69;KHITAN SMALL SCRIPT CHARACTER-18B69;Lo;0;L;;;;;N;;;;;
18B6A;KHITAN SMALL SCRIPT CHARACTER-18B6A;Lo;0;L;;;;;N;;;;;
18B6B;KHITAN SMALL SCRIPT CHARACTER-18B6B;Lo;0;L;;;;;N;;;;;
18B6C;KHITAN SMALL SCRIPT CHARACTER-18B6C;Lo;0;L;;;;;N;;;;;
18B6D;KHITAN SMALL SCRIPT CHARACTER-18B6D;Lo;0;L;;;;;N;;;;;
18B6E;KHITAN SMALL SCRIPT CHARACTER-18B6E;Lo;0;L;;;;;N;;;;;
18B6F;KHITAN SMALL SCRIPT CHARACTER-18B6F;Lo;0;L;;;;;N;;;;;
18B70;KHITAN SMALL SCRIPT CHARACTER-18B70;Lo;0;L;;;;;N;;;;;
18B71;KHITAN SMALL SCRIPT CHARACTER-18B71;Lo;0;L;;;;;N;;;;;
18B72;KHITAN SMALL SCRIPT CHARACTER-18B72;Lo;0;L;;;;;N;;;;;
18B73;KHITAN SMALL SCRIPT CHARACTER-18B73;Lo;0;L;;;;;N;;;;;
18B74;KHITAN SMALL SCRIPT CHARACTER-18B74;Lo;0;L;;;;;N;;;;;
18B75;KHITAN SMALL SCRIPT CHARACTER-18B75;Lo;0;L;;;;;N;;;;;
18B76;KHITAN SMALL SCRIPT CHARACTER-18B76;Lo;0;L;;;;;N;;;;;
18B77;KHITAN SMALL SCRIPT CHARACTER-18B77;Lo;0;L;;;;;N;;;;;
18B78;KHITAN SMALL SCRIPT CHARACTER-18B78;Lo;0;L;;;;;N;;;;;
18B79;KHITAN SMALL SCRIPT CHARACTER-18B79;Lo;0;L;;;;;N;;;;;
18B7A;KHITAN SMALL SCRIPT CHARACTER-18B7A;Lo;0;L;;;;;N;;;;;
18B7B;KHITAN SMALL SCRIPT CHARACTER-18B7B;Lo;0;L;;;;;N;;;;;
18B7C;KHITAN SMALL SCRIPT CHARACTER-18B7C;Lo;0;L;;;;;N;;;;;
18B7D;KHITAN SMALL SCRIPT CHARACTER-18B7D;Lo;0;L;;;;;N;;;;;
18B7E;KHITAN SMALL SCRIPT CHARACTER-18B7E;Lo;0;L;;;;;N;;;;;
18B7F;KHITAN SMALL SCRIPT CHARACTER-18B7F;Lo;0;L;;;;;N;;;;;
18B80;KHITAN SMALL SCRIPT CHARACTER-18B80;Lo;0;L;;;;;N;;;;;
18B81;KHITAN SMALL SCRIPT CHARACTER-18B81;Lo;0;L;;;;;N;;;;;
18B82;KHITAN SMALL SCRIPT CHARACTER-18B82;Lo;0;L;;;;;N;;;;;
18B83;KHITAN SMALL SCRIPT CHARACTER-18B83;Lo;0;L;;;;;N;;;;;
18B84;KHITAN SMALL SCRIPT CHARACTER-18B84;Lo;0;L;;;;;N;;;;;
18B85;KHITAN SMALL SCRIPT CHARACTER-18B85;Lo;0;L;;;;;N;;;;;
18B86;KHITAN SMALL SCRIPT CHARACTER-18B86;Lo;0;L;;;;;N;;;;;
18B87;KHITAN SMALL SCRIPT CHARACTER-18B87;Lo;0;L;;;;;N;;;;;
18B88;KHITAN SMALL SCRIPT CHARACTER-18B88;Lo;0;L;;;;;N;;;;;
18B89;KHITAN SMALL SCRIPT CHARACTER-18B89;Lo;0;L;;;;;N;;;;;
18B8A;KHITAN SMALL SCRIPT CHARACTER-18B8A;Lo;0;L;;;;;N;;;;;
18B8B;KHITAN SMALL SCRIPT CHARACTER-18B8B;Lo;0;L;;;;;N;;;;;
18B8C;KHITAN SMALL SCRIPT CHARACTER-18B8C;Lo;0;L;;;;;N;;;;;
18B8D;KHITAN SMALL SCRIPT CHARACTER-18B8D;Lo;0;L;;;;;N;;;;;
18B8E;KHITAN SMALL SCRIPT CHARACTER-18B8E;Lo;0;L;;;;;N;;;;;
18B8F;KHITAN SMALL SCRIPT CHARACTER-18B8F;Lo;0;L;;;;;N;;;;;
18B90;KHITAN SMALL SCRIPT CHARACTER-18B90;Lo;0;L;;;;;N;;;;;
18B91;KHITAN SMALL SCRIPT CHARACTER-18B91;Lo;0;L;;;;;N;;;;;
18B92;KHITAN SMALL SCRIPT CHARACTER-18B92;Lo;0;L;;;;;N;;;;;
18B93;KHITAN SMALL SCRIPT CHARACTER-18B93;Lo;0;L;;;;;N;;;;;
18B94;KHITAN SMALL SCRIPT CHARACTER-18B94;Lo;0;L;;;;;N;;;;;
18B95;KHITAN SMALL SCRIPT CHARACTER-18B95;Lo;0;L;;;;;N;;;;;
18B96;KHITAN SMALL SCRIPT CHARACTER-18B96;Lo;0;L;;;;;N;;;;;
18B97;KHITAN SMALL SCRIPT CHARACTER-18B97;Lo;0;L;;;;;N;;;;;
18B98;KHITAN SMALL SCRIPT CHARACTER-18B98;Lo;0;L;;;;;N;;;;;
18B99;KHITAN SMALL SCRIPT CHARACTER-18B99;Lo;0;L;;;;;N;;;;;
18B9A;KHITAN SMALL SCRIPT CHARACTER-18B9A;Lo;0;L;;;;;N;;;;;
18B9B;KHITAN SMALL SCRIPT CHARACTER-18B9B;Lo;0;L;;;;;N;;;;;
18B9C;KHITAN SMALL SCRIPT CHARACTER-18B9C;Lo;0;L;;;;;N;;;;;
18B9D;KHITAN SMALL SCRIPT CHARACTER-18B9D;Lo;0;L;;;;;N;;;;;
18B9E;KHITAN SMALL SCRIPT CHARACTER-18B9E;Lo;0;L;;;;;N;;;;;
18B9F;KHITAN SMALL SCRIPT CHARACTER-18B9F;Lo;0;L;;;;;N;;;;;
18BA0;KHITAN SMALL SCRIPT CHARACTER-18BA0;Lo;0;L;;;;;N;;;;;
18BA1;KHITAN SMALL SCRIPT CHARACTER-18BA1;Lo;0;L;;;;;N;;;;;
18BA2;KHITAN SMALL SCRIPT CHARACTER-18BA2;Lo;0;L;;;;;N;;;;;
18BA3;KHITAN SMALL SCRIPT CHARACTER-18BA3;Lo;0;L;;;;;N;;;;;
18BA4;KHITAN SMALL SCRIPT CHARACTER-18BA4;Lo;0;L;;;;;N;;;;;
18BA5;KHITAN SMALL SCRIPT CHARACTER-18BA5;Lo;0;L;;;;;N;;;;;
18BA6;KHITAN SMALL SCRIPT CHARACTER-18BA6;Lo;0;L;;;;;N;;;;;
18BA7;KHITAN SMALL SCRIPT CHARACTER-18BA7;Lo;0;L;;;;;N;;;;;
18BA8;KHITAN SMALL SCRIPT CHARACTER-18BA8;Lo;0;L;;;;;N;;;;;
18BA9;KHITAN SMALL SCRIPT CHARACTER-18BA9;Lo;0;L;;;;;N;;;;;
18BAA;KHITAN SMALL SCRIPT CHARACTER-18BAA;Lo;0;L;;;;;N;;;;;
18BAB;KHITAN SMALL SCRIPT CHARACTER-18BAB;Lo;0;L;;;;;N;;;;;
18BAC;KHITAN SMALL SCRIPT CHARACTER-18BAC;Lo;0;L;;;;;N;;;;;
18BAD;KHITAN SMALL SCRIPT CHARACTER-18BAD;Lo;0;L;;;;;N;;;;;
18BAE;KHITAN SMALL SCRIPT CHARACTER-18BAE;Lo;0;L;;;;;N;;;;;
18BAF;KHITAN SMALL SCRIPT CHARACTER-18BAF;Lo;0;L;;;;;N;;;;;
18BB0;KHITAN SMALL SCRIPT CHARACTER-18BB0;Lo;0;L;;;;;N;;;;;
18BB1;KHITAN SMALL SCRIPT CHARACTER-18BB1;Lo;0;L;;;;;N;;;;;
18BB2;KHITAN SMALL SCRIPT CHARACTER-18BB2;Lo;0;L;;;;;N;;;;;
18BB3;KHITAN SMALL SCRIPT CHARACTER-18BB3;Lo;0;L;;;;;N;;;;;
18BB4;KHITAN SMALL SCRIPT CHARACTER-18BB4;Lo;0;L;;;;;N;;;;;
18BB5;KHITAN SMALL SCRIPT CHARACTER-18BB5;Lo;0;L;;;;;N;;;;;
18BB6;KHITAN SMALL SCRIPT CHARACTER-18BB6;Lo;0;L;;;;;N;;;;;
18BB7;KHITAN SMALL SCRIPT CHARACTER-18BB7;Lo;0;L;;;;;N;;;;;
18BB8;KHITAN SMALL SCRIPT CHARACTER-18BB8;Lo;0;L;;;;;N;;;;;
18BB9;KHITAN SMALL SCRIPT CHARACTER-18BB9;Lo;0;L;;;;;N;;;;;
18BBA;KHITAN SMALL SCRIPT CHARACTER-18BBA;Lo;0;L;;;;;N;;;;;
18BBB;KHITAN SMALL SCRIPT CHARACTER-18BBB;Lo;0;L;;;;;N;;;;;
18BBC;KHITAN SMALL SCRIPT CHARACTER-18BBC;Lo;0;L;;;;;N;;;;;
18BBD;KHITAN SMALL SCRIPT CHARACTER-18BBD;Lo;0;L;;;;;N;;;;;
18BBE;KHITAN SMALL SCRIPT CHARACTER-18BBE;Lo;0;L;;;;;N;;;;;
18BBF;KHITAN SMALL SCRIPT CHARACTER-18BBF;Lo;0;L;;;;;N;;;;;
18BC0;KHITAN SMALL SCRIPT CHARACTER-18BC0;Lo;0;L;;;;;N;;;;;
18BC1;KHITAN SMALL SCRIPT CHARACTER-18BC1;Lo;0;L;;;;;N;;;;;
18BC2;KHITAN SMALL SCRIPT CHARACTER-18BC2;Lo;0;L;;;;;N;;;;;
18BC3;KHITAN SMALL SCRIPT CHARACTER-18BC3;Lo;0;L;;;;;N;;;;;
18BC4;KHITAN SMALL SCRIPT CHARACTER-18BC4;Lo;0;L;;;;;N;;;;;
18BC5;KHITAN SMALL SCRIPT CHARACTER-18BC5;Lo;0;L;;;;;N;;;;;
18BC6;KHITAN SMALL SCRIPT CHARACTER-18BC6;Lo;0;L;;;;;N;;;;;
18BC7;KHITAN SMALL SCRIPT CHARACTER-18BC7;Lo;0;L;;;;;N;;;;;
18BC8;KHITAN SMALL SCRIPT CHARACTER-18BC8;Lo;0;L;;;;;N;;;;;
18BC9;KHITAN SMALL SCRIPT CHARACTER-18BC9;Lo;0;L;;;;;N;;;;;
18BCA;KHITAN SMALL SCRIPT CHARACTER-18BCA;Lo;0;L;;;;;N;;;;;
18BCB;KHITAN SMALL SCRIPT CHARACTER-18BCB;Lo;0;L;;;;;N;;;;;
18BCC;KHITAN SMALL SCRIPT CHARACTER-18BCC;Lo;0;L;;;;;N;;;;;
18BCD;KHITAN SMALL SCRIPT CHARACTER-18BCD;Lo;0;L;;;;;N;;;;;
18BCE;KHITAN SMALL SCRIPT CHARACTER-18BCE;Lo;0;L;;;;;N;;;;;
18BCF;KHITAN SMALL SCRIPT CHARACTER-18BCF;Lo;0;L;;;;;N;;;;;
18BD0;KHITAN SMALL SCRIPT CHARACTER-18BD0;Lo;0;L;;;;;N;;;;;
18BD1;KHITAN SMALL SCRIPT CHARACTER-18BD1;Lo;0;L;;;;;N;;;;;
18BD2;KHITAN SMALL SCRIPT CHARACTER-18BD2;Lo;0;L;;;;;N;;;;;
18BD3;KHITAN SMALL SCRIPT CHARACTER-18BD3;Lo;0;L;;;;;N;;;;;
18BD4;KHITAN SMALL SCRIPT CHARACTER-18BD4;Lo;0;L;;;;;N;;;;;
18BD5;KHITAN SMALL SCRIPT CHARACTER-18BD5;Lo;0;L;;;;;N;;;;;
18BD6;KHITAN SMALL SCRIPT CHARACTER-18BD6;Lo;0;L;;;;;N;;;;;
18BD7;KHITAN SMALL SCRIPT CHARACTER-18BD7;Lo;0;L;;;;;N;;;;;
18BD8;KHITAN SMALL SCRIPT CHARACTER-18BD8;Lo;0;L;;;;;N;;;;;
18BD9;KHITAN SMALL SCRIPT CHARACTER-18BD9;Lo;0;L;;;;;N;;;;;
18BDA;KHITAN SMALL SCRIPT CHARACTER-18BDA;Lo;0;L;;;;;N;;;;;
18BDB;KHITAN SMALL SCRIPT CHARACTER-18BDB;Lo;0;L;;;;;N;;;;;
18BDC;KHITAN SMALL SCRIPT CHARACTER-18BDC;Lo;0;L;;;;;N;;;;;
18BDD;KHITAN SMALL SCRIPT CHARACTER-18BDD;Lo;0;L;;;;;N;;;;;
18BDE;KHITAN SMALL SCRIPT CHARACTER-18BDE;Lo;0;L;;;;;N;;;;;
18BDF;KHITAN SMALL SCRIPT CHARACTER-18BDF;Lo;0;L;;;;;N;;;;;
18BE0;KHITAN SMALL SCRIPT CHARACTER-18BE0;Lo;0;L;;;;;N;;;;;
18BE1;KHITAN SMALL SCRIPT CHARACTER-18BE1;Lo;0;L;;;;;N;;;;;
18BE2;KHITAN SMALL SCRIPT CHARACTER-18BE2;Lo;0;L;;;;;N;;;;;
18BE3;KHITAN SMALL SCRIPT CHARACTER-18BE3;Lo;0;L;;;;;N;;;;;
18BE4;KHITAN SMALL SCRIPT CHARACTER-18BE4;Lo;0;L;;;;;N;;;;;
18BE5;KHITAN SMALL SCRIPT CHARACTER-18BE5;Lo;0;L;;;;;N;;;;;
18BE6;KHITAN SMALL SCRIPT CHARACTER-18BE6;Lo;0;L;;;;;N;;;;;
18BE7;KHITAN SMALL SCRIPT CHARACTER-18BE7;Lo;0;L;;;;;N;;;;;
18BE8;KHITAN SMALL SCRIPT CHARACTER-18BE8;Lo;0;L;;;;;N;;;;;
18BE9;KHITAN SMALL SCRIPT CHARACTER-18BE9;Lo;0;L;;;;;N;;;;;
18BEA;KHITAN SMALL SCRIPT CHARACTER-18BEA;Lo;0;L;;;;;N;;;;;
18BEB;KHITAN SMALL SCRIPT CHARACTER-18BEB;Lo;0;L;;;;;N;;;;;
18BEC;KHITAN SMALL SCRIPT CHARACTER-18BEC;Lo;0;L;;;;;N;;;;;
18BED;KHITAN SMALL SCRIPT CHARACTER-18BED;Lo;0;L;;;;;N;;;;;
18BEE;KHITAN SMALL SCRIPT CHARACTER-18BEE;Lo;0;L;;;;;N;;;;;
18BEF;KHITAN SMALL SCRIPT CHARACTER-18BEF;Lo;0;L;;;;;N;;;;;
18BF0;KHITAN SMALL SCRIPT CHARACTER-18BF0;Lo;0;L;;;;;N;;;;;
18BF1;KHITAN SMALL SCRIPT CHARACTER-18BF1;Lo;0;L;;;;;N;;;;;
18BF2;KHITAN SMALL SCRIPT CHARACTER-18BF2;Lo;0;L;;;;;N;;;;;
18BF3;KHITAN SMALL SCRIPT CHARACTER-18BF3;Lo;0;L;;;;;N;;;;;
18BF4;KHITAN SMALL SCRIPT CHARACTER-18BF4;Lo;0;L;;;;;N;;;;;
18BF5;KHITAN SMALL SCRIPT CHARACTER-18BF5;Lo;0;L;;;;;N;;;;;
18BF6;KHITAN SMALL SCRIPT CHARACTER-18BF6;Lo;0;L;;;;;N;;;;;
18BF7;KHITAN SMALL SCRIPT CHARACTER-18BF7;Lo;0;L;;;;;N;;;;;
18BF8;KHITAN SMALL SCRIPT CHARACTER-18BF8;Lo;0;L;;;;;N;;;;;
18BF9;KHITAN SMALL SCRIPT CHARACTER-18BF9;Lo;0;L;;;;;N;;;;;
18BFA;KHITAN SMALL SCRIPT CHARACTER-18BFA;Lo;0;L;;;;;N;;;;;
18BFB;KHITAN SMALL SCRIPT CHARACTER-18BFB;Lo;0;L;;;;;N;;;;;
18BFC;KHITAN SMALL SCRIPT CHARACTER-18BFC;Lo;0;L;;;;;N;;;;;
18BFD;KHITAN SMALL SCRIPT CHARACTER-18BFD;Lo;0;L;;;;;N;;;;;
18BFE;KHITAN SMALL SCRIPT CHARACTER-18BFE;Lo;0;L;;;;;N;;;;;
18BFF;KHITAN SMALL SCRIPT CHARACTER-18BFF;Lo;0;L;;;;;N;;;;;
18C00;KHITAN SMALL SCRIPT CHARACTER-18C00;Lo;0;L;;;;;N;;;;;
18C01;KHITAN SMALL SCRIPT CHARACTER-18C01;Lo;0;L;;;;;N;;;;;
18C02;KHITAN SMALL SCRIPT CHARACTER-18C02;Lo;0;L;;;;;N;;;;;
18C03;KHITAN SMALL SCRIPT CHARACTER-18C03;Lo;0;L;;;;;N;;;;;
18C04;KHITAN SMALL SCRIPT CHARACTER-18C04;Lo;0;L;;;;;N;;;;;
18C05;KHITAN SMALL SCRIPT CHARACTER-18C05;Lo;0;L;;;;;N;;;;;
18C06;KHITAN SMALL SCRIPT CHARACTER-18C06;Lo;0;L;;;;;N;;;;;
18C07;KHITAN SMALL SCRIPT CHARACTER-18C07;Lo;0;L;;;;;N;;;;;
18C08;KHITAN SMALL SCRIPT CHARACTER-18C08;Lo;0;L;;;;;N;;;;;
18C09;KHITAN SMALL SCRIPT CHARACTER-18C09;Lo;0;L;;;;;N;;;;;
18C0A;KHITAN SMALL SCRIPT CHARACTER-18C0A;Lo;0;L;;;;;N;;;;;
18C0B;KHITAN SMALL SCRIPT CHARACTER-18C0B;Lo;0;L;;;;;N;;;;;
18C0C;KHITAN SMALL SCRIPT CHARACTER-18C0C;Lo;0;L;;;;;N;;;;;
18C0D;KHITAN SMALL SCRIPT CHARACTER-18C0D;Lo;0;L;;;;;N;;;;;
18C0E;KHITAN SMALL SCRIPT CHARACTER-18C0E;Lo;0;L;;;;;N;;;;;
18C0F;KHITAN SMALL SCRIPT CHARACTER-18C0F;Lo;0;L;;;;;N;;;;;
18C10;KHITAN SMALL SCRIPT CHARACTER-18C10;Lo;0;L;;;;;N;;;;;
18C11;KHITAN SMALL SCRIPT CHARACTER-18C11;Lo;0;L;;;;;N;;;;;
18C12;KHITAN SMALL SCRIPT CHARACTER-18C12;Lo;0;L;;;;;N;;;;;
18C13;KHITAN SMALL SCRIPT CHARACTER-18C13;Lo;0;L;;;;;N;;;;;
18C14;KHITAN SMALL SCRIPT CHARACTER-18C14;Lo;0;L;;;;;N;;;;;
18C15;KHITAN SMALL SCRIPT CHARACTER-18C15;Lo;0;L;;;;;N;;;;;
18C16;KHITAN SMALL SCRIPT CHARACTER-18C16;Lo;0;L;;;;;N;;;;;
18C17;KHITAN SMALL SCRIPT CHARACTER-18C17;Lo;0;L;;;;;N;;;;;
18C18;KHITAN SMALL SCRIPT CHARACTER-18C18;Lo;0;L;;;;;N;;;;;
18C19;KHITAN SMALL SCRIPT CHARACTER-18C19;Lo;0;L;;;;;N;;;;;
18C1A;KHITAN SMALL SCRIPT CHARACTER-18C1A;Lo;0;L;;;;;N;;;;;
18C1B;KHITAN SMALL SCRIPT CHARACTER-18C1B;Lo;0;L;;;;;N;;;;;
18C1C;KHITAN SMALL SCRIPT CHARACTER-18C1C;Lo;0;L;;;;;N;;;;;
18C1D;KHITAN SMALL SCRIPT CHARACTER-18C1D;Lo;0;L;;;;;N;;;;;
18C1E;KHITAN SMALL SCRIPT CHARACTER-18C1E;Lo;0;L;;;;;N;;;;;
18C1F;KHITAN SMALL SCRIPT CHARACTER-18C1F;Lo;0;L;;;;;N;;;;;
18C20;KHITAN SMALL SCRIPT CHARACTER-18C20;Lo;0;L;;;;;N;;;;;
18C21;KHITAN SMALL SCRIPT CHARACTER-18C21;Lo;0;L;;;;;N;;;;;
18C22;KHITAN SMALL SCRIPT CHARACTER-18C22;Lo;0;L;;;;;N;;;;;
18C23;KHITAN SMALL SCRIPT CHARACTER-18C23;Lo;0;L;;;;;N;;;;;
18C24;KHITAN SMALL SCRIPT CHARACTER-18C24;Lo;0;L;;;;;N;;;;;
18C25;KHITAN SMALL SCRIPT CHARACTER-18C25;Lo;0;L;;;;;N;;;;;
18C26;KHITAN SMALL SCRIPT CHARACTER-18C26;Lo;0;L;;;;;N;;;;;
18C27;KHITAN SMALL SCRIPT CHARACTER-18C27;Lo;0;L;;;;;N;;;;;
18C28;KHITAN SMALL SCRIPT CHARACTER-18C28;Lo;0;L;;;;;N;;;;;
18C29;KHITAN SMALL SCRIPT CHARACTER-18C29;Lo;0;L;;;;;N;;;;;
18C2A;KHITAN SMALL SCRIPT CHARACTER-18C2A;Lo;0;L;;;;;N;;;;;
18C2B;KHITAN SMALL SCRIPT CHARACTER-18C2B;Lo;0;L;;;;;N;;;;;
18C2C;KHITAN SMALL SCRIPT CHARACTER-18C2C;Lo;0;L;;;;;N;;;;;
18C2D;KHITAN SMALL SCRIPT CHARACTER-18C2D;Lo;0;L;;;;;N;;;;;
18C2E;KHITAN SMALL SCRIPT CHARACTER-18C2E;Lo;0;L;;;;;N;;;;;
18C2F;KHITAN SMALL SCRIPT CHARACTER-18C2F;Lo;0;L;;;;;N;;;;;
18C30;KHITAN SMALL SCRIPT CHARACTER-18C30;Lo;0;L;;;;;N;;;;;
18C31;KHITAN SMALL SCRIPT CHARACTER-18C31;Lo;0;L;;;;;N;;;;;
18C32;KHITAN SMALL SCRIPT CHARACTER-18C32;Lo;0;L;;;;;N;;;;;
18C33;KHITAN SMALL SCRIPT CHARACTER-18C33;Lo;0;L;;;;;N;;;;;
18C34;KHITAN SMALL SCRIPT CHARACTER-18C34;Lo;0;L;;;;;N;;;;;
18C35;KHITAN SMALL SCRIPT CHARACTER-18C35;Lo;0;L;;;;;N;;;;;
18C36;KHITAN SMALL SCRIPT CHARACTER-18C36;Lo;0;L;;;;;N;;;;;
18C37;KHITAN SMALL SCRIPT CHARACTER-18C37;Lo;0;L;;;;;N;;;;;
18C38;KHITAN SMALL SCRIPT CHARACTER-18C38;Lo;0;L;;;;;N;;;;;
18C39;KHITAN SMALL SCRIPT CHARACTER-18C39;Lo;0;L;;;;;N;;;;;
18C3A;KHITAN SMALL SCRIPT CHARACTER-18C3A;Lo;0;L;;;;;N;;;;;
18C3B;KHITAN SMALL SCRIPT CHARACTER-18C3B;Lo;0;L;;;;;N;;;;;
18C3C;KHITAN SMALL SCRIPT CHARACTER-18C3C;Lo;0;L;;;;;N;;;;;
18C3D;KHITAN SMALL SCRIPT CHARACTER-18C3D;Lo;0;L;;;;;N;;;;;
18C3E;KHITAN SMALL SCRIPT CHARACTER-18C3E;Lo;0;L;;;;;N;;;;;
18C3F;KHITAN SMALL SCRIPT CHARACTER-18C3F;Lo;0;L;;;;;N;;;;;
18C40;KHITAN SMALL SCRIPT CHARACTER-18C40;Lo;0;L;;;;;N;;;;;
18C41;KHITAN SMALL SCRIPT CHARACTER-18C41;Lo;0;L;;;;;N;;;;;
18C42;KHITAN SMALL SCRIPT CHARACTER-18C42;Lo;0;L;;;;;N;;;;;
18C43;KHITAN SMALL SCRIPT CHARACTER-18C43;Lo;0;L;;;;;N;;;;;
18C44;KHITAN SMALL SCRIPT CHARACTER-18C44;Lo;0;L;;;;;N;;;;;
18C45;KHITAN SMALL SCRIPT CHARACTER-18C45;Lo;0;L;;;;;N;;;;;
18C46;KHITAN SMALL SCRIPT CHARACTER-18C46;Lo;0;L;;;;;N;;;;;
18C47;KHITAN SMALL SCRIPT CHARACTER-18C47;Lo;0;L;;;;;N;;;;;
18C48;KHITAN SMALL SCRIPT CHARACTER-18C48;Lo;0;L;;;;;N;;;;;
18C49;KHITAN SMALL SCRIPT CHARACTER-18C49;Lo;0;L;;;;;N;;;;;
18C4A;KHITAN SMALL SCRIPT CHARACTER-18C4A;Lo;0;L;;;;;N;;;;;
18C4B;KHITAN SMALL SCRIPT CHARACTER-18C4B;Lo;0;L;;;;;N;;;;;
18C4C;KHITAN SMALL SCRIPT CHARACTER-18C4C;Lo;0;L;;;;;N;;;;;
18C4D;KHITAN SMALL SCRIPT CHARACTER-18C4D;Lo;0;L;;;;;N;;;;;
18C4E;KHITAN SMALL SCRIPT CHARACTER-18C4E;Lo;0;L;;;;;N;;;;;
18C4F;KHITAN SMALL SCRIPT CHARACTER-18C4F;Lo;0;L;;;;;N;;;;;
18C50;KHITAN SMALL SCRIPT CHARACTER-18C50;Lo;0;L;;;;;N;;;;;
18C51;KHITAN SMALL SCRIPT CHARACTER-18C51;Lo;0;L;;;;;N;;;;;
18C52;KHITAN SMALL SCRIPT CHARACTER-18C52;Lo;0;L;;;;;N;;;;;
18C53;KHITAN SMALL SCRIPT CHARACTER-18C53;Lo;0;L;;;;;N;;;;;
18C54;KHITAN SMALL SCRIPT CHARACTER-18C54;Lo;0;L;;;;;N;;;;;
18C55;KHITAN SMALL SCRIPT CHARACTER-18C55;Lo;0;L;;;;;N;;;;;
18C56;KHITAN SMALL SCRIPT CHARACTER-18C56;Lo;0;L;;;;;N;;;;;
18C57;KHITAN SMALL SCRIPT CHARACTER-18C57;Lo;0;L;;;;;N;;;;;
18C58;KHITAN SMALL SCRIPT CHARACTER-18C58;Lo;0;L;;;;;N;;;;;
18C59;KHITAN SMALL SCRIPT CHARACTER-18C59;Lo;0;L;;;;;N;;;;;
18C5A;KHITAN SMALL SCRIPT CHARACTER-18C5A;Lo;0;L;;;;;N;;;;;
18C5B;KHITAN SMALL SCRIPT CHARACTER-18C5B;Lo;0;L;;;;;N;;;;;
18C5C;KHITAN SMALL SCRIPT CHARACTER-18C5C;Lo;0;L;;;;;N;;;;;
18C5D;KHITAN SMALL SCRIPT CHARACTER-18C5D;Lo;0;L;;;;;N;;;;;
18C5E;KHITAN SMALL SCRIPT CHARACTER-18C5E;Lo;0;L;;;;;N;;;;;
18C5F;KHITAN SMALL SCRIPT CHARACTER-18C5F;Lo;0;L;;;;;N;;;;;
18C60;KHITAN SMALL SCRIPT CHARACTER-18C60;Lo;0;L;;;;;N;;;;;
18C61;KHITAN SMALL SCRIPT CHARACTER-18C61;Lo;0;L;;;;;N;;;;;
18C62;KHITAN SMALL SCRIPT CHARACTER-18C62;Lo;0;L;;;;;N;;;;;
18C63;KHITAN SMALL SCRIPT CHARACTER-18C63;Lo;0;L;;;;;N;;;;;
18C64;KHITAN SMALL SCRIPT CHARACTER-18C64;Lo;0;L;;;;;N;;;;;
18C65;KHITAN SMALL SCRIPT CHARACTER-18C65;Lo;0;L;;;;;N;;;;;
18C66;KHITAN SMALL SCRIPT CHARACTER-18C66;Lo;0;L;;;;;N;;;;;
18C67;KHITAN SMALL SCRIPT CHARACTER-18C67;Lo;0;L;;;;;N;;;;;
18C68;KHITAN SMALL SCRIPT CHARACTER-18C68;Lo;0;L;;;;;N;;;;;
18C69;KHITAN SMALL SCRIPT CHARACTER-18C69;Lo;0;L;;;;;N;;;;;
18C6A;KHITAN SMALL SCRIPT CHARACTER-18C6A;Lo;0;L;;;;;N;;;;;
18C6B;KHITAN SMALL SCRIPT CHARACTER-18C6B;Lo;0;L;;;;;N;;;;;
18C6C;KHITAN SMALL SCRIPT CHARACTER-18C6C;Lo;0;L;;;;;N;;;;;
18C6D;KHITAN SMALL SCRIPT CHARACTER-18C6D;Lo;0;L;;;;;N;;;;;
18C6E;KHITAN SMALL SCRIPT CHARACTER-18C6E;Lo;0;L;;;;;N;;;;;
18C6F;KHITAN SMALL SCRIPT CHARACTER-18C6F;Lo;0;L;;;;;N;;;;;
18C70;KHITAN SMALL SCRIPT CHARACTER-18C70;Lo;0;L;;;;;N;;;;;
18C71;KHITAN SMALL SCRIPT CHARACTER-18C71;Lo;0;L;;;;;N;;;;;
18C72;KHITAN SMALL SCRIPT CHARACTER-18C72;Lo;0;L;;;;;N;;;;;
18C73;KHITAN SMALL SCRIPT CHARACTER-18C73;Lo;0;L;;;;;N;;;;;
18C74;KHITAN SMALL SCRIPT CHARACTER-18C74;Lo;0;L;;;;;N;;;;;
18C75;KHITAN SMALL SCRIPT CHARACTER-18C75;Lo;0;L;;;;;N;;;;;
18C76;KHITAN SMALL SCRIPT CHARACTER-18C76;Lo;0;L;;;;;N;;;;;
18C77;KHITAN SMALL SCRIPT CHARACTER-18C77;Lo;0;L;;;;;N;;;;;
18C78;KHITAN SMALL SCRIPT CHARACTER-18C78;Lo;0;L;;;;;N;;;;;
18C79;KHITAN SMALL SCRIPT CHARACTER-18C79;Lo;0;L;;;;;N;;;;;
18C7A;KHITAN SMALL SCRIPT CHARACTER-18C7A;Lo;0;L;;;;;N;;;;;
18C7B;KHITAN SMALL SCRIPT CHARACTER-18C7B;Lo;0;L;;;;;N;;;;;
18C7C;KHITAN SMALL SCRIPT CHARACTER-18C7C;Lo;0;L;;;;;N;;;;;
18C7D;KHITAN SMALL SCRIPT CHARACTER-18C7D;Lo;0;L;;;;;N;;;;;
18C7E;KHITAN SMALL SCRIPT CHARACTER-18C7E;Lo;0;L;;;;;N;;;;;
18C7F;KHITAN SMALL SCRIPT CHARACTER-18C7F;Lo;0;L;;;;;N;;;;;
18C80;KHITAN SMALL SCRIPT CHARACTER-18C80;Lo;0;L;;;;;N;;;;;
18C81;KHITAN SMALL SCRIPT CHARACTER-18C81;Lo;0;L;;;;;N;;;;;
18C82;KHITAN SMALL SCRIPT CHARACTER-18C82;Lo;0;L;;;;;N;;;;;
18C83;KHITAN SMALL SCRIPT CHARACTER-18C83;Lo;0;L;;;;;N;;;;;
18C84;KHITAN SMALL SCRIPT CHARACTER-18C84;Lo;0;L;;;;;N;;;;;
18C85;KHITAN SMALL SCRIPT CHARACTER-18C85;Lo;0;L;;;;;N;;;;;
18C86;KHITAN SMALL SCRIPT CHARACTER-18C86;Lo;0;L;;;;;N;;;;;
18C87;KHITAN SMALL SCRIPT CHARACTER-18C87;Lo;0;L;;;;;N;;;;;
18C88;KHITAN SMALL SCRIPT CHARACTER-18C88;Lo;0;L;;;;;N;;;;;
18C89;KHITAN SMALL SCRIPT CHARACTER-18C89;Lo;0;L;;;;;N;;;;;
18C8A;KHITAN SMALL SCRIPT CHARACTER-18C8A;Lo;0;L;;;;;N;;;;;
18C8B;KHITAN SMALL SCRIPT CHARACTER-18C8B;Lo;0;L;;;;;N;;;;;
18C8C;KHITAN SMALL SCRIPT CHARACTER-18C8C;Lo;0;L;;;;;N;;;;;
18C8D;KHITAN SMALL SCRIPT CHARACTER-18C8D;Lo;0;L;;;;;N;;;;;
18C8E;KHITAN SMALL SCRIPT CHARACTER-18C8E;Lo;0;L;;;;;N;;;;;
18C8F;KHITAN SMALL SCRIPT CHARACTER-18C8F;Lo;0;L;;;;;N;;;;;
18C90;KHITAN SMALL SCRIPT CHARACTER-18C90;Lo;0;L;;;;;N;;;;;
18C91;KHITAN SMALL SCRIPT CHARACTER-18C91;Lo;0;L;;;;;N;;;;;
18C92;KHITAN SMALL SCRIPT CHARACTER-18C92;Lo;0;L;;;;;N;;;;;
18C93;KHITAN SMALL SCRIPT CHARACTER-18C93;Lo;0;L;;;;;N;;;;;
18C94;KHITAN SMALL SCRIPT CHARACTER-18C94;Lo;0;L;;;;;N;;;;;
18C95;KHITAN SMALL SCRIPT CHARACTER-18C95;Lo;0;L;;;;;N;;;;;
18C96;KHITAN SMALL SCRIPT CHARACTER-18C96;Lo;0;L;;;;;N;;;;;
18C97;KHITAN SMALL SCRIPT CHARACTER-18C97;Lo;0;L;;;;;N;;;;;
18C98;KHITAN SMALL SCRIPT CHARACTER-18C98;Lo;0;L;;;;;N;;;;;
18C99;KHITAN SMALL SCRIPT CHARACTER-18C99;Lo;0;L;;;;;N;;;;;
18C9A;KHITAN SMALL SCRIPT CHARACTER-18C9A;Lo;0;L;;;;;N;;;;;
18C9B;KHITAN SMALL SCRIPT CHARACTER-18C9B;Lo;0;L;;;;;N;;;;;
18C9C;KHITAN SMALL SCRIPT CHARACTER-18C9C;Lo;0;L;;;;;N;;;;;
18C9D;KHITAN SMALL SCRIPT CHARACTER-18C9D;Lo;0;L;;;;;N;;;;;
18C9E;KHITAN SMALL SCRIPT CHARACTER-18C9E;Lo;0;L;;;;;N;;;;;
18C9F;KHITAN SMALL SCRIPT CHARACTER-18C9F;Lo;0;L;;;;;N;;;;;
18CA0;KHITAN SMALL SCRIPT CHARACTER-18CA0;Lo;0;L;;;;;N;;;;;
18CA1;KHITAN SMALL SCRIPT CHARACTER-18CA1;Lo;0;L;;;;;N;;;;;
18CA2;KHITAN SMALL SCRIPT CHARACTER-18CA2;Lo;0;L;;;;;N;;;;;
18CA3;KHITAN SMALL SCRIPT CHARACTER-18CA3;Lo;0;L;;;;;N;;;;;
18CA4;KHITAN SMALL SCRIPT CHARACTER-18CA4;Lo;0;L;;;;;N;;;;;
18CA5;KHITAN SMALL SCRIPT CHARACTER-18CA5;Lo;0;L;;;;;N;;;;;
18CA6;KHITAN SMALL SCRIPT CHARACTER-18CA6;Lo;0;L;;;;;N;;;;;
18CA7;KHITAN SMALL SCRIPT CHARACTER-18CA7;Lo;0;L;;;;;N;;;;;
18CA8;KHITAN SMALL SCRIPT CHARACTER-18CA8;Lo;0;L;;;;;N;;;;;
18CA9;KHITAN SMALL SCRIPT CHARACTER-18CA9;Lo;0;L;;;;;N;;;;;
18CAA;KHITAN SMALL SCRIPT CHARACTER-18CAA;Lo;0;L;;;;;N;;;;;
18CAB;KHITAN SMALL SCRIPT CHARACTER-18CAB;Lo;0;L;;;;;N;;;;;
18CAC;KHITAN SMALL SCRIPT CHARACTER-18CAC;Lo;0;L;;;;;N;;;;;
18CAD;KHITAN SMALL SCRIPT CHARACTER-18CAD;Lo;0;L;;;;;N;;;;;
18CAE;KHITAN SMALL SCRIPT CHARACTER-18CAE;Lo;0;L;;;;;N;;;;;
18CAF;KHITAN SMALL SCRIPT CHARACTER-18CAF;Lo;0;L;;;;;N;;;;;
18CB0;KHITAN SMALL SCRIPT CHARACTER-18CB0;Lo;0;L;;;;;N;;;;;
18CB1;KHITAN SMALL SCRIPT CHARACTER-18CB1;Lo;0;L;;;;;N;;;;;
18CB2;KHITAN SMALL SCRIPT CHARACTER-18CB2;Lo;0;L;;;;;N;;;;;
18CB3;KHITAN SMALL SCRIPT CHARACTER-18CB3;Lo;0;L;;;;;N;;;;;
18CB4;KHITAN SMALL SCRIPT CHARACTER-18CB4;Lo;0;L;;;;;N;;;;;
18CB5;KHITAN SMALL SCRIPT CHARACTER-18CB5;Lo;0;L;;;;;N;;;;;
18CB6;KHITAN SMALL SCRIPT CHARACTER-18CB6;Lo;0;L;;;;;N;;;;;
18CB7;KHITAN SMALL SCRIPT CHARACTER-18CB7;Lo;0;L;;;;;N;;;;;
18CB8;KHITAN SMALL SCRIPT CHARACTER-18CB8;Lo;0;L;;;;;N;;;;;
18CB9;KHITAN SMALL SCRIPT CHARACTER-18CB9;Lo;0;L;;;;;N;;;;;
18CBA;KHITAN SMALL SCRIPT CHARACTER-18CBA;Lo;0;L;;;;;N;;;;;
18CBB;KHITAN SMALL SCRIPT CHARACTER-18CBB;Lo;0;L;;;;;N;;;;;
18CBC;KHITAN SMALL SCRIPT CHARACTER-18CBC;Lo;0;L;;;;;N;;;;;
18CBD;KHITAN SMALL SCRIPT CHARACTER-18CBD;Lo;0;L;;;;;N;;;;;
18CBE;KHITAN SMALL SCRIPT CHARACTER-18CBE;Lo;0;L;;;;;N;;;;;
18CBF;KHITAN SMALL SCRIPT CHARACTER-18CBF;Lo;0;L;;;;;N;;;;;
18CC0;KHITAN SMALL SCRIPT CHARACTER-18CC0;Lo;0;L;;;;;N;;;;;
18CC1;KHITAN SMALL SCRIPT CHARACTER-18CC1;Lo;0;L;;;;;N;;;;;
18CC2;KHITAN SMALL SCRIPT CHARACTER-18CC2;Lo;0;L;;;;;N;;;;;
18CC3;KHITAN SMALL SCRIPT CHARACTER-18CC3;Lo;0;L;;;;;N;;;;;
18CC4;KHITAN SMALL SCRIPT CHARACTER-18CC4;Lo;0;L;;;;;N;;;;;
18CC5;KHITAN SMALL SCRIPT CHARACTER-18CC5;Lo;0;L;;;;;N;;;;;
18CC6;KHITAN SMALL SCRIPT CHARACTER-18CC6;Lo;0;L;;;;;N;;;;;
18CC7;KHITAN SMALL SCRIPT CHARACTER-18CC7;Lo;0;L;;;;;N;;;;;
18CC8;KHITAN SMALL SCRIPT CHARACTER-18CC8;Lo;0;L;;;;;N;;;;;
18CC9;KHITAN SMALL SCRIPT CHARACTER-18CC9;Lo;0;L;;;;;N;;;;;
18CCA;KHITAN SMALL SCRIPT CHARACTER-18CCA;Lo;0;L;;;;;N;;;;;
18CCB;KHITAN SMALL SCRIPT CHARACTER-18CCB;Lo;0;L;;;;;N;;;;;
18CCC;KHITAN SMALL SCRIPT CHARACTER-18CCC;Lo;0;L;;;;;N;;;;;
18CCD;KHITAN SMALL SCRIPT CHARACTER-18CCD;Lo;0;L;;;;;N;;;;;
18CCE;KHITAN SMALL SCRIPT CHARACTER-18CCE;Lo;0;L;;;;;N;;;;;
18CCF;KHITAN SMALL SCRIPT CHARACTER-18CCF;Lo;0;L;;;;;N;;;;;
18CD0;KHITAN SMALL SCRIPT CHARACTER-18CD0;Lo;0;L;;;;;N;;;;;
18CD1;KHITAN SMALL SCRIPT CHARACTER-18CD1;Lo;0;L;;;;;N;;;;;
18CD2;KHITAN SMALL SCRIPT CHARACTER-18CD2;Lo;0;L;;;;;N;;;;;
18CD3;KHITAN SMALL SCRIPT CHARACTER-18CD3;Lo;0;L;;;;;N;;;;;
18CD4;KHITAN SMALL SCRIPT CHARACTER-18CD4;Lo;0;L;;;;;N;;;;;
18CD5;KHITAN SMALL SCRIPT CHARACTER-18CD5;Lo;0;L;;;;;N;;;;;
18D00;<Tangut Ideograph Supplement, First>;Lo;0;L;;;;;N;;;;;
18D08;<Tangut Ideograph Supplement, Last>;Lo;0;L;;;;;N;;;;;
1AFF0;KATAKANA LETTER MINNAN TONE-2;Lm;0;L;;;;;N;;;;;
1AFF1;KATAKANA LETTER MINNAN TONE-3;Lm;0;L;;;;;N;;;;;
1AFF2;KATAKANA LETTER MINNAN TONE-4;Lm;0;L;;;;;N;;;;;
1AFF3;KATAKANA LETTER MINNAN TONE-5;Lm;0;L;;;;;N;;;;;
1AFF5;KATAKANA LETTER MINNAN TONE-7;Lm;0;L;;;;;N;;;;;
1AFF6;KATAKANA LETTER MINNAN TONE-8;Lm;0;L;;;;;N;;;;;
1AFF7;KATAKANA LETTER MINNAN NASALIZED TONE-1;Lm;0;L;;;;;N;;;;;
1AFF8;KATAKANA LETTER MINNAN NASALIZED TONE-2;Lm;0;L;;;;;N;;;;;
1AFF9;KATAKANA LETTER MINNAN NASALIZED TONE-3;Lm;0;L;;;;;N;;;;;
1AFFA;KATAKANA LETTER MINNAN NASALIZED TONE-4;Lm;0;L;;;;;N;;;;;
1AFFB;KATAKANA LETTER MINNAN NASALIZED TONE-5;Lm;0;L;;;;;N;;;;;
1AFFD;KATAKANA LETTER MINNAN NASALIZED TONE-7;Lm;0;L;;;;;N;;;;;
1AFFE;KATAKANA LETTER MINNAN NASALIZED TONE-8;Lm;0;L;;;;;N;;;;;
1B000;KATAKANA LETTER ARCHAIC E;Lo;0;L;;;;;N;;;;;
1B001;HIRAGANA LETTER ARCHAIC YE;Lo;0;L;;;;;N;;;;;
1B002;HENTAIGANA LETTER A-1;Lo;0;L;;;;;N;;;;;
1B003;HENTAIGANA LETTER A-2;Lo;0;L;;;;;N;;;;;
1B004;HENTAIGANA LETTER A-3;Lo;0;L;;;;;N;;;;;
1B005;HENTAIGANA LETTER A-WO;Lo;0;L;;;;;N;;;;;
1B006;HENTAIGANA LETTER I-1;Lo;0;L;;;;;N;;;;;
1B007;HENTAIGANA LETTER I-2;Lo;0;L;;;;;N;;;;;
1B008;HENTAIGANA LETTER I-3;Lo;0;L;;;;;N;;;;;
1B009;HENTAIGANA LETTER I-4;Lo;0;L;;;;;N;;;;;
1B00A;HENTAIGANA LETTER U-1;Lo;0;L;;;;;N;;;;;
1B00B;HENTAIGANA LETTER U-2;Lo;0;L;;;;;N;;;;;
1B00C;HENTAIGANA LETTER U-3;Lo;0;L;;;;;N;;;;;
1B00D;HENTAIGANA LETTER U-4;Lo;0;L;;;;;N;;;;;
1B00E;HENTAIGANA LETTER U-5;Lo;0;L;;;;;N;;;;;
1B00F;HENTAIGANA LETTER E-2;Lo;0;L;;;;;N;;;;;
1B010;HENTAIGANA LETTER E-3;Lo;0;L;;;;;N;;;;;
1B011;HENTAIGANA LETTER E-4;Lo;0;L;;;;;N;;;;;
1B012;HENTAIGANA LETTER E-5;Lo;0;L;;;;;N;;;;;
1B013;HENTAIGANA LETTER E-6;Lo;0;L;;;;;N;;;;;
1B014;HENTAIGANA LETTER O-1;Lo;0;L;;;;;N;;;;;
1B015;HENTAIGANA LETTER O-2;Lo;0;L;;;;;N;;;;;
1B016;HENTAIGANA LETTER O-3;Lo;0;L;;;;;N;;;;;
1B017;HENTAIGANA LETTER KA-1;Lo;0;L;;;;;N;;;;;
1B018;HENTAIGANA LETTER KA-2;Lo;0;L;;;;;N;;;;;
1B019;HENTAIGANA LETTER KA-3;Lo;0;L;;;;;N;;;;;
1B01A;HENTAIGANA LETTER KA-4;Lo;0;L;;;;;N;;;;;
1B01B;HENTAIGANA LETTER KA-5;Lo;0;L;;;;;N;;;;;
1B01C;HENTAIGANA LETTER KA-6;Lo;0;L;;;;;N;;;;;
1B01D;HENTAIGANA LETTER KA-7;Lo;0;L;;;;;N;;;;;
1B01E;HENTAIGANA LETTER KA-8;Lo;0;L;;;;;N;;;;;
1B01F;HENTAIGANA LETTER KA-9;Lo;0;L;;;;;N;;;;;
1B020;HENTAIGANA LETTER KA-10;Lo;0;L;;;;;N;;;;;
1B021;HENTAIGANA LETTER KA-11;Lo;0;L;;;;;N;;;;;
1B022;HENTAIGANA LETTER KA-KE;Lo;0;L;;;;;N;;;;;
1B023;HENTAIGANA LETTER KI-1;Lo;0;L;;;;;N;;;;;
1B024;HENTAIGANA LETTER KI-2;Lo;0;L;;;;;N;;;;;
1B025;HENTAIGANA LETTER KI-3;Lo;0;L;;;;;N;;;;;
1B026;HENTAIGANA LETTER KI-4;Lo;0;L;;;;;N;;;;;
1B027;HENTAIGANA LETTER KI-5;Lo;0;L;;;;;N;;;;;
1B028;HENTAIGANA LETTER KI-6;Lo;0;L;;;;;N;;;;;
1B029;HENTAIGANA LETTER KI-7;Lo;0;L;;;;;N;;;;;
1B02A;HENTAIGANA LETTER KI-8;Lo;0;L;;;;;N;;;;;
1B02B;HENTAIGANA LETTER KU-1;Lo;0;L;;;;;N;;;;;
1B02C;HENTAIGANA LETTER KU-2;Lo;0;L;;;;;N;;;;;
1B02D;HENTAIGANA LETTER KU-3;Lo;0;L;;;;;N;;;;;
1B02E;HENTAIGANA LETTER KU-4;Lo;0;L;;;;;N;;;;;
1B02F;HENTAIGANA LETTER KU-5;Lo;0;L;;;;;N;;;;;
1B030;HENTAIGANA LETTER KU-6;Lo;0;L;;;;;N;;;;;
1B031;HENTAIGANA LETTER KU-7;Lo;0;L;;;;;N;;;;;
1B032;HENTAIGANA LETTER KE-1;Lo;0;L;;;;;N;;;;;
1B033;HENTAIGANA LETTER KE-2;Lo;0;L;;;;;N;;;;;
1B034;HENTAIGANA LETTER KE-3;Lo;0;L;;;;;N;;;;;
1B035;HENTAIGANA LETTER KE-4;Lo;0;L;;;;;N;;;;;
1B036;HENTAIGANA LETTER KE-5;Lo;0;L;;;;;N;;;;;
1B037;HENTAIGANA LETTER KE-6;Lo;0;L;;;;;N;;;;;
1B038;HENTAIGANA LETTER KO-1;Lo;0;L;;;;;N;;;;;
1B039;HENTAIGANA LETTER KO-2;Lo;0;L;;;;;N;;;;;
1B03A;HENTAIGANA LETTER KO-3;Lo;0;L;;;;;N;;;;;
1B03B;HENTAIGANA LETTER KO-KI;Lo;0;L;;;;;N;;;;;
1B03C;HENTAIGANA LETTER SA-1;Lo;0;L;;;;;N;;;;;
1B03D;HENTAIGANA LETTER SA-2;Lo;0;L;;;;;N;;;;;
1B03E;HENTAIGANA LETTER SA-3;Lo;0;L;;;;;N;;;;;
1B03F;HENTAIGANA LETTER SA-4;Lo;0;L;;;;;N;;;;;
1B040;HENTAIGANA LETTER SA-5;Lo;0;L;;;;;N;;;;;
1B041;HENTAIGANA LETTER SA-6;Lo;0;L;;;;;N;;;;;
1B042;HENTAIGANA LETTER SA-7;Lo;0;L;;;;;N;;;;;
1B043;HENTAIGANA LETTER SA-8;Lo;0;L;;;;;N;;;;;
1B044;HENTAIGANA LETTER SI-1;Lo;0;L;;;;;N;;;;;
1B045;HENTAIGANA LETTER SI-2;Lo;0;L;;;;;N;;;;;
1B046;HENTAIGANA LETTER SI-3;Lo;0;L;;;;;N;;;;;
1B047;HENTAIGANA LETTER SI-4;Lo;0;L;;;;;N;;;;;
1B048;HENTAIGANA LETTER SI-5;Lo;0;L;;;;;N;;;;;
1B049;HENTAIGANA LETTER SI-6;Lo;0;L;;;;;N;;;;;
1B04A;HENTAIGANA LETTER SU-1;Lo;0;L;;;;;N;;;;;
1B04B;HENTAIGANA LETTER SU-2;Lo;0;L;;;;;N;;;;;
1B04C;HENTAIGANA LETTER SU-3;Lo;0;L;;;;;N;;;;;
1B04D;HENTAIGANA LETTER SU-4;Lo;0;L;;;;;N;;;;;
1B04E;HENTAIGANA LETTER SU-5;Lo;0;L;;;;;N;;;;;
1B04F;HENTAIGANA LETTER SU-6;Lo;0;L;;;;;N;;;;;
1B050;HENTAIGANA LETTER SU-7;Lo;0;L;;;;;N;;;;;
1B051;HENTAIGANA LETTER SU-8;Lo;0;L;;;;;N;;;;;
1B052;HENTAIGANA LETTER SE-1;Lo;0;L;;;;;N;;;;;
1B053;HENTAIGANA LETTER SE-2;Lo;0;L;;;;;N;;;;;
1B054;HENTAIGANA LETTER SE-3;Lo;0;L;;;;;N;;;;;
1B055;HENTAIGANA LETTER SE-4;Lo;0;L;;;;;N;;;;;
1B056;HENTAIGANA LETTER SE-5;Lo;0;L;;;;;N;;;;;
1B057;HENTAIGANA LETTER SO-1;Lo;0;L;;;;;N;;;;;
1B058;HENTAIGANA LETTER SO-2;Lo;0;L;;;;;N;;;;;
1B059;HENTAIGANA LETTER SO-3;Lo;0;L;;;;;N;;;;;
1B05A;HENTAIGANA LETTER SO-4;Lo;0;L;;;;;N;;;;;
1B05B;HENTAIGANA LETTER SO-5;Lo;0;L;;;;;N;;;;;
1B05C;HENTAIGANA LETTER SO-6;Lo;0;L;;;;;N;;;;;
1B05D;HENTAIGANA LETTER SO-7;Lo;0;L;;;;;N;;;;;
1B05E;HENTAIGANA LETTER TA-1;Lo;0;L;;;;;N;;;;;
1B05F;HENTAIGANA LETTER TA-2;Lo;0;L;;;;;N;;;;;
1B060;HENTAIGANA LETTER TA-3;Lo;0;L;;;;;N;;;;;
1B061;HENTAIGANA LETTER TA-4;Lo;0;L;;;;;N;;;;;
1B062;HENTAIGANA LETTER TI-1;Lo;0;L;;;;;N;;;;;
1B063;HENTAIGANA LETTER TI-2;Lo;0;L;;;;;N;;;;;
1B064;HENTAIGANA LETTER TI-3;Lo;0;L;;;;;N;;;;;
1B065;HENTAIGANA LETTER TI-4;Lo;0;L;;;;;N;;;;;
1B066;HENTAIGANA LETTER TI-5;Lo;0;L;;;;;N;;;;;
1B067;HENTAIGANA LETTER TI-6;Lo;0;L;;;;;N;;;;;
1B068;HENTAIGANA LETTER TI-7;Lo;0;L;;;;;N;;;;;
1B069;HENTAIGANA LETTER TU-1;Lo;0;L;;;;;N;;;;;
1B06A;HENTAIGANA LETTER TU-2;Lo;0;L;;;;;N;;;;;
1B06B;HENTAIGANA LETTER TU-3;Lo;0;L;;;;;N;;;;;
1B06C;HENTAIGANA LETTER TU-4;Lo;0;L;;;;;N;;;;;
1B06D;HENTAIGANA LETTER TU-TO;Lo;0;L;;;;;N;;;;;
1B06E;HENTAIGANA LETTER TE-1;Lo;0;L;;;;;N;;;;;
1B06F;HENTAIGANA LETTER TE-2;Lo;0;L;;;;;N;;;;;
1B070;HENTAIGANA LETTER TE-3;Lo;0;L;;;;;N;;;;;
1B071;HENTAIGANA LETTER TE-4;Lo;0;L;;;;;N;;;;;
1B072;HENTAIGANA LETTER TE-5;Lo;0;L;;;;;N;;;;;
1B073;HENTAIGANA LETTER TE-6;Lo;0;L;;;;;N;;;;;
1B074;HENTAIGANA LETTER TE-7;Lo;0;L;;;;;N;;;;;
1B075;HENTAIGANA LETTER TE-8;Lo;0;L;;;;;N;;;;;
1B076;HENTAIGANA LETTER TE-9;Lo;0;L;;;;;N;;;;;
1B077;HENTAIGANA LETTER TO-1;Lo;0;L;;;;;N;;;;;
1B078;HENTAIGANA LETTER TO-2;Lo;0;L;;;;;N;;;;;
1B079;HENTAIGANA LETTER TO-3;Lo;0;L;;;;;N;;;;;
1B07A;HENTAIGANA LETTER TO-4;Lo;0;L;;;;;N;;;;;
1B07B;HENTAIGANA LETTER TO-5;Lo;0;L;;;;;N;;;;;
1B07C;HENTAIGANA LETTER TO-6;Lo;0;L;;;;;N;;;;;
1B07D;HENTAIGANA LETTER TO-RA;Lo;0;L;;;;;N;;;;;
1B07E;HENTAIGANA LETTER NA-1;Lo;0;L;;;;;N;;;;;
1B07F;HENTAIGANA LETTER NA-2;Lo;0;L;;;;;N;;;;;
1B080;HENTAIGANA LETTER NA-3;Lo;0;L;;;;;N;;;;;
1B081;HENTAIGANA LETTER NA-4;Lo;0;L;;;;;N;;;;;
1B082;HENTAIGANA LETTER NA-5;Lo;0;L;;;;;N;;;;;
1B083;HENTAIGANA LETTER NA-6;Lo;0;L;;;;;N;;;;;
1B084;HENTAIGANA LETTER NA-7;Lo;0;L;;;;;N;;;;;
1B085;HENTAIGANA LETTER NA-8;Lo;0;L;;;;;N;;;;;
1B086;HENTAIGANA LETTER NA-9;Lo;0;L;;;;;N;;;;;
1B087;HENTAIGANA LETTER NI-1;Lo;0;L;;;;;N;;;;;
1B088;HENTAIGANA LETTER NI-2;Lo;0;L;;;;;N;;;;;
1B089;HENTAIGANA LETTER NI-3;Lo;0;L;;;;;N;;;;;
1B08A;HENTAIGANA LETTER NI-4;Lo;0;L;;;;;N;;;;;
1B08B;HENTAIGANA LETTER NI-5;Lo;0;L;;;;;N;;;;;
1B08C;HENTAIGANA LETTER NI-6;Lo;0;L;;;;;N;;;;;
1B08D;HENTAIGANA LETTER NI-7;Lo;0;L;;;;;N;;;;;
1B08E;HENTAIGANA LETTER NI-TE;Lo;0;L;;;;;N;;;;;
1B08F;HENTAIGANA LETTER NU-1;Lo;0;L;;;;;N;;;;;
1B090;HENTAIGANA LETTER NU-2;Lo;0;L;;;;;N;;;;;
1B091;HENTAIGANA LETTER NU-3;Lo;0;L;;;;;N;;;;;
1B092;HENTAIGANA LETTER NE-1;Lo;0;L;;;;;N;;;;;
1B093;HENTAIGANA LETTER NE-2;Lo;0;L;;;;;N;;;;;
1B094;HENTAIGANA LETTER NE-3;Lo;0;L;;;;;N;;;;;
1B095;HENTAIGANA LETTER NE-4;Lo;0;L;;;;;N;;;;;
1B096;HENTAIGANA LETTER NE-5;Lo;0;L;;;;;N;;;;;
1B097;HENTAIGANA LETTER NE-6;Lo;0;L;;;;;N;;;;;
1B098;HENTAIGANA LETTER NE-KO;Lo;0;L;;;;;N;;;;;
1B099;HENTAIGANA LETTER NO-1;Lo;0;L;;;;;N;;;;;
1B09A;HENTAIGANA LETTER NO-2;Lo;0;L;;;;;N;;;;;
1B09B;HENTAIGANA LETTER NO-3;Lo;0;L;;;;;N;;;;;
1B09C;HENTAIGANA LETTER NO-4;Lo;0;L;;;;;N;;;;;
1B09D;HENTAIGANA LETTER NO-5;Lo;0;L;;;;;N;;;;;
1B09E;HENTAIGANA LETTER HA-1;Lo;0;L;;;;;N;;;;;
1B09F;HENTAIGANA LETTER HA-2;Lo;0;L;;;;;N;;;;;
1B0A0;HENTAIGANA LETTER HA-3;Lo;0;L;;;;;N;;;;;
1B0A1;HENTAIGANA LETTER HA-4;Lo;0;L;;;;;N;;;;;
1B0A2;HENTAIGANA LETTER HA-5;Lo;0;L;;;;;N;;;;;
1B0A3;HENTAIGANA LETTER HA-6;Lo;0;L;;;;;N;;;;;
1B0A4;HENTAIGANA LETTER HA-7;Lo;0;L;;;;;N;;;;;
1B0A5;HENTAIGANA LETTER HA-8;Lo;0;L;;;;;N;;;;;
1B0A6;HENTAIGANA LETTER HA-9;Lo;0;L;;;;;N;;;;;
1B0A7;HENTAIGANA LETTER HA-10;Lo;0;L;;;;;N;;;;;
1B0A8;HENTAIGANA LETTER HA-11;Lo;0;L;;;;;N;;;;;
1B0A9;HENTAIGANA LETTER HI-1;Lo;0;L;;;;;N;;;;;
1B0AA;HENTAIGANA LETTER HI-2;Lo;0;L;;;;;N;;;;;
1B0AB;HENTAIGANA LETTER HI-3;Lo;0;L;;;;;N;;;;;
1B0AC;HENTAIGANA LETTER HI-4;Lo;0;L;;;;;N;;;;;
1B0AD;HENTAIGANA LETTER HI-5;Lo;0;L;;;;;N;;;;;
1B0AE;HENTAIGANA LETTER HI-6;Lo;0;L;;;;;N;;;;;
1B0AF;HENTAIGANA LETTER HI-7;Lo;0;L;;;;;N;;;;;
1B0B0;HENTAIGANA LETTER HU-1;Lo;0;L;;;;;N;;;;;
1B0B1;HENTAIGANA LETTER HU-2;Lo;0;L;;;;;N;;;;;
1B0B2;HENTAIGANA LETTER HU-3;Lo;0;L;;;;;N;;;;;
1B0B3;HENTAIGANA LETTER HE-1;Lo;0;L;;;;;N;;;;;
1B0B4;HENTAIGANA LETTER HE-2;Lo;0;L;;;;;N;;;;;
1B0B5;HENTAIGANA LETTER HE-3;Lo;0;L;;;;;N;;;;;
1B0B6;HENTAIGANA LETTER HE-4;Lo;0;L;;;;;N;;;;;
1B0B7;HENTAIGANA LETTER HE-5;Lo;0;L;;;;;N;;;;;
1B0B8;HENTAIGANA LETTER HE-6;Lo;0;L;;;;;N;;;;;
1B0B9;HENTAIGANA LETTER HE-7;Lo;0;L;;;;;N;;;;;
1B0BA;HENTAIGANA LETTER HO-1;Lo;0;L;;;;;N;;;;;
1B0BB;HENTAIGANA LETTER HO-2;Lo;0;L;;;;;N;;;;;
1B0BC;HENTAIGANA LETTER HO-3;Lo;0;L;;;;;N;;;;;
1B0BD;HENTAIGANA LETTER HO-4;Lo;0;L;;;;;N;;;;;
1B0BE;HENTAIGANA LETTER HO-5;Lo;0;L;;;;;N;;;;;
1B0BF;HENTAIGANA LETTER HO-6;Lo;0;L;;;;;N;;;;;
1B0C0;HENTAIGANA LETTER HO-7;Lo;0;L;;;;;N;;;;;
1B0C1;HENTAIGANA LETTER HO-8;Lo;0;L;;;;;N;;;;;
1B0C2;HENTAIGANA LETTER MA-1;Lo;0;L;;;;;N;;;;;
1B0C3;HENTAIGANA LETTER MA-2;Lo;0;L;;;;;N;;;;;
1B0C4;HENTAIGANA LETTER MA-3;Lo;0;L;;;;;N;;;;;
1B0C5;HENTAIGANA LETTER MA-4;Lo;0;L;;;;;N;;;;;
1B0C6;HENTAIGANA LETTER MA-5;Lo;0;L;;;;;N;;;;;
1B0C7;HENTAIGANA LETTER MA-6;Lo;0;L;;;;;N;;;;;
1B0C8;HENTAIGANA LETTER MA-7;Lo;0;L;;;;;N;;;;;
1B0C9;HENTAIGANA LETTER MI-1;Lo;0;L;;;;;N;;;;;
1B0CA;HENTAIGANA LETTER MI-2;Lo;0;L;;;;;N;;;;;
1B0CB;HENTAIGANA LETTER MI-3;Lo;0;L;;;;;N;;;;;
1B0CC;HENTAIGANA LETTER MI-4;Lo;0;L;;;;;N;;;;;
1B0CD;HENTAIGANA LETTER MI-5;Lo;0;L;;;;;N;;;;;
1B0CE;HENTAIGANA LETTER MI-6;Lo;0;L;;;;;N;;;;;
1B0CF;HENTAIGANA LETTER MI-7;Lo;0;L;;;;;N;;;;;
1B0D0;HENTAIGANA LETTER MU-1;Lo;0;L;;;;;N;;;;;
1B0D1;HENTAIGANA LETTER MU-2;Lo;0;L;;;;;N;;;;;
1B0D2;HENTAIGANA LETTER MU-3;Lo;0;L;;;;;N;;;;;
1B0D3;HENTAIGANA LETTER MU-4;Lo;0;L;;;;;N;;;;;
1B0D4;HENTAIGANA LETTER ME-1;Lo;0;L;;;;;N;;;;;
1B0D5;HENTAIGANA LETTER ME-2;Lo;0;L;;;;;N;;;;;
1B0D6;HENTAIGANA LETTER ME-MA;Lo;0;L;;;;;N;;;;;
1B0D7;HENTAIGANA LETTER MO-1;Lo;0;L;;;;;N;;;;;
1B0D8;HENTAIGANA LETTER MO-2;Lo;0;L;;;;;N;;;;;
1B0D9;HENTAIGANA LETTER MO-3;Lo;0;L;;;;;N;;;;;
1B0DA;HENTAIGANA LETTER MO-4;Lo;0;L;;;;;N;;;;;
1B0DB;HENTAIGANA LETTER MO-5;Lo;0;L;;;;;N;;;;;
1B0DC;HENTAIGANA LETTER MO-6;Lo;0;L;;;;;N;;;;;
1B0DD;HENTAIGANA LETTER YA-1;Lo;0;L;;;;;N;;;;;
1B0DE;HENTAIGANA LETTER YA-2;Lo;0;L;;;;;N;;;;;
1B0DF;HENTAIGANA LETTER YA-3;Lo;0;L;;;;;N;;;;;
1B0E0;HENTAIGANA LETTER YA-4;Lo;0;L;;;;;N;;;;;
1B0E1;HENTAIGANA LETTER YA-5;Lo;0;L;;;;;N;;;;;
1B0E2;HENTAIGANA LETTER YA-YO;Lo;0;L;;;;;N;;;;;
1B0E3;HENTAIGANA LETTER YU-1;Lo;0;L;;;;;N;;;;;
1B0E4;HENTAIGANA LETTER YU-2;Lo;0;L;;;;;N;;;;;
1B0E5;HENTAIGANA LETTER YU-3;Lo;0;L;;;;;N;;;;;
1B0E6;HENTAIGANA LETTER YU-4;Lo;0;L;;;;;N;;;;;
1B0E7;HENTAIGANA LETTER YO-1;Lo;0;L;;;;;N;;;;;
1B0E8;HENTAIGANA LETTER YO-2;Lo;0;L;;;;;N;;;;;
1B0E9;HENTAIGANA LETTER YO-3;Lo;0;L;;;;;N;;;;;
1B0EA;HENTAIGANA LETTER YO-4;Lo;0;L;;;;;N;;;;;
1B0EB;HENTAIGANA LETTER YO-5;Lo;0;L;;;;;N;;;;;
1B0EC;HENTAIGANA LETTER YO-6;Lo;0;L;;;;;N;;;;;
1B0ED;HENTAIGANA LETTER RA-1;Lo;0;L;;;;;N;;;;;
1B0EE;HENTAIGANA LETTER RA-2;Lo;0;L;;;;;N;;;;;
1B0EF;HENTAIGANA LETTER RA-3;Lo;0;L;;;;;N;;;;;
1B0F0;HENTAIGANA LETTER RA-4;Lo;0;L;;;;;N;;;;;
1B0F1;HENTAIGANA LETTER RI-1;Lo;0;L;;;;;N;;;;;
1B0F2;HENTAIGANA LETTER RI-2;Lo;0;L;;;;;N;;;;;
1B0F3;HENTAIGANA LETTER RI-3;Lo;0;L;;;;;N;;;;;
1B0F4;HENTAIGANA LETTER RI-4;Lo;0;L;;;;;N;;;;;
1B0F5;HENTAIGANA LETTER RI-5;Lo;0;L;;;;;N;;;;;
1B0F6;HENTAIGANA LETTER RI-6;Lo;0;L;;;;;N;;;;;
1B0F7;HENTAIGANA LETTER RI-7;Lo;0;L;;;;;N;;;;;
1B0F8;HENTAIGANA LETTER RU-1;Lo;0;L;;;;;N;;;;;
1B0F9;HENTAIGANA LETTER RU-2;Lo;0;L;;;;;N;;;;;
1B0FA;HENTAIGANA LETTER RU-3;Lo;0;L;;;;;N;;;;;
1B0FB;HENTAIGANA LETTER RU-4;Lo;0;L;;;;;N;;;;;
1B0FC;HENTAIGANA LETTER RU-5;Lo;0;L;;;;;N;;;;;
1B0FD;HENTAIGANA LETTER RU-6;Lo;0;L;;;;;N;;;;;
1B0FE;HENTAIGANA LETTER RE-1;Lo;0;L;;;;;N;;;;;
1B0FF;HENTAIGANA LETTER RE-2;Lo;0;L;;;;;N;;;;;
1B100;HENTAIGANA LETTER RE-3;Lo;0;L;;;;;N;;;;;
1B101;HENTAIGANA LETTER RE-4;Lo;0;L;;;;;N;;;;;
1B102;HENTAIGANA LETTER RO-1;Lo;0;L;;;;;N;;;;;
1B103;HENTAIGANA LETTER RO-2;Lo;0;L;;;;;N;;;;;
1B104;HENTAIGANA LETTER RO-3;Lo;0;L;;;;;N;;;;;
1B105;HENTAIGANA LETTER RO-4;Lo;0;L;;;;;N;;;;;
1B106;HENTAIGANA LETTER RO-5;Lo;0;L;;;;;N;;;;;
1B107;HENTAIGANA LETTER RO-6;Lo;0;L;;;;;N;;;;;
1B108;HENTAIGANA LETTER WA-1;Lo;0;L;;;;;N;;;;;
1B109;HENTAIGANA LETTER WA-2;Lo;0;L;;;;;N;;;;;
1B10A;HENTAIGANA LETTER WA-3;Lo;0;L;;;;;N;;;;;
1B10B;HENTAIGANA LETTER WA-4;Lo;0;L;;;;;N;;;;;
1B10C;HENTAIGANA LETTER WA-5;Lo;0;L;;;;;N;;;;;
1B10D;HENTAIGANA LETTER WI-1;Lo;0;L;;;;;N;;;;;
1B10E;HENTAIGANA LETTER WI-2;Lo;0;L;;;;;N;;;;;
1B10F;HENTAIGANA LETTER WI-3;Lo;0;L;;;;;N;;;;;
1B110;HENTAIGANA LETTER WI-4;Lo;0;L;;;;;N;;;;;
1B111;HENTAIGANA LETTER WI-5;Lo;0;L;;;;;N;;;;;
1B112;HENTAIGANA LETTER WE-1;Lo;0;L;;;;;N;;;;;
1B113;HENTAIGANA LETTER WE-2;Lo;0;L;;;;;N;;;;;
1B114;HENTAIGANA LETTER WE-3;Lo;0;L;;;;;N;;;;;
1B115;HENTAIGANA LETTER WE-4;Lo;0;L;;;;;N;;;;;
1B116;HENTAIGANA LETTER WO-1;Lo;0;L;;;;;N;;;;;
1B117;HENTAIGANA LETTER WO-2;Lo;0;L;;;;;N;;;;;
1B118;HENTAIGANA LETTER WO-3;Lo;0;L;;;;;N;;;;;
1B119;HENTAIGANA LETTER WO-4;Lo;0;L;;;;;N;;;;;
1B11A;HENTAIGANA LETTER WO-5;Lo;0;L;;;;;N;;;;;
1B11B;HENTAIGANA LETTER WO-6;Lo;0;L;;;;;N;;;;;
1B11C;HENTAIGANA LETTER WO-7;Lo;0;L;;;;;N;;;;;
1B11D;HENTAIGANA LETTER N-MU-MO-1;Lo;0;L;;;;;N;;;;;
1B11E;HENTAIGANA LETTER N-MU-MO-2;Lo;0;L;;;;;N;;;;;
1B11F;HIRAGANA LETTER ARCHAIC WU;Lo;0;L;;;;;N;;;;;
1B120;KATAKANA LETTER ARCHAIC YI;Lo;0;L;;;;;N;;;;;
1B121;KATAKANA LETTER ARCHAIC YE;Lo;0;L;;;;;N;;;;;
1B122;KATAKANA LETTER ARCHAIC WU;Lo;0;L;;;;;N;;;;;
1B150;HIRAGANA LETTER SMALL WI;Lo;0;L;;;;;N;;;;;
1B151;HIRAGANA LETTER SMALL WE;Lo;0;L;;;;;N;;;;;
1B152;HIRAGANA LETTER SMALL WO;Lo;0;L;;;;;N;;;;;
1B164;KATAKANA LETTER SMALL WI;Lo;0;L;;;;;N;;;;;
1B165;KATAKANA LETTER SMALL WE;Lo;0;L;;;;;N;;;;;
1B166;KATAKANA LETTER SMALL WO;Lo;0;L;;;;;N;;;;;
1B167;KATAKANA LETTER SMALL N;Lo;0;L;;;;;N;;;;;
1B170;NUSHU CHARACTER-1B170;Lo;0;L;;;;;N;;;;;
1B171;NUSHU CHARACTER-1B171;Lo;0;L;;;;;N;;;;;
1B172;NUSHU CHARACTER-1B172;Lo;0;L;;;;;N;;;;;
1B173;NUSHU CHARACTER-1B173;Lo;0;L;;;;;N;;;;;
1B174;NUSHU CHARACTER-1B174;Lo;0;L;;;;;N;;;;;
1B175;NUSHU CHARACTER-1B175;Lo;0;L;;;;;N;;;;;
1B176;NUSHU CHARACTER-1B176;Lo;0;L;;;;;N;;;;;
1B177;NUSHU CHARACTER-1B177;Lo;0;L;;;;;N;;;;;
1B178;NUSHU CHARACTER-1B178;Lo;0;L;;;;;N;;;;;
1B179;NUSHU CHARACTER-1B179;Lo;0;L;;;;;N;;;;;
1B17A;NUSHU CHARACTER-1B17A;Lo;0;L;;;;;N;;;;;
1B17B;NUSHU CHARACTER-1B17B;Lo;0;L;;;;;N;;;;;
1B17C;NUSHU CHARACTER-1B17C;Lo;0;L;;;;;N;;;;;
1B17D;NUSHU CHARACTER-1B17D;Lo;0;L;;;;;N;;;;;
1B17E;NUSHU CHARACTER-1B17E;Lo;0;L;;;;;N;;;;;
1B17F;NUSHU CHARACTER-1B17F;Lo;0;L;;;;;N;;;;;
1B180;NUSHU CHARACTER-1B180;Lo;0;L;;;;;N;;;;;
1B181;NUSHU CHARACTER-1B181;Lo;0;L;;;;;N;;;;;
1B182;NUSHU CHARACTER-1B182;Lo;0;L;;;;;N;;;;;
1B183;NUSHU CHARACTER-1B183;Lo;0;L;;;;;N;;;;;
1B184;NUSHU CHARACTER-1B184;Lo;0;L;;;;;N;;;;;
1B185;NUSHU CHARACTER-1B185;Lo;0;L;;;;;N;;;;;
1B186;NUSHU CHARACTER-1B186;Lo;0;L;;;;;N;;;;;
1B187;NUSHU CHARACTER-1B187;Lo;0;L;;;;;N;;;;;
1B188;NUSHU CHARACTER-1B188;Lo;0;L;;;;;N;;;;;
1B189;NUSHU CHARACTER-1B189;Lo;0;L;;;;;N;;;;;
1B18A;NUSHU CHARACTER-1B18A;Lo;0;L;;;;;N;;;;;
1B18B;NUSHU CHARACTER-1B18B;Lo;0;L;;;;;N;;;;;
1B18C;NUSHU CHARACTER-1B18C;Lo;0;L;;;;;N;;;;;
1B18D;NUSHU CHARACTER-1B18D;Lo;0;L;;;;;N;;;;;
1B18E;NUSHU CHARACTER-1B18E;Lo;0;L;;;;;N;;;;;
1B18F;NUSHU CHARACTER-1B18F;Lo;0;L;;;;;N;;;;;
1B190;NUSHU CHARACTER-1B190;Lo;0;L;;;;;N;;;;;
1B191;NUSHU CHARACTER-1B191;Lo;0;L;;;;;N;;;;;
1B192;NUSHU CHARACTER-1B192;Lo;0;L;;;;;N;;;;;
1B193;NUSHU CHARACTER-1B193;Lo;0;L;;;;;N;;;;;
1B194;NUSHU CHARACTER-1B194;Lo;0;L;;;;;N;;;;;
1B195;NUSHU CHARACTER-1B195;Lo;0;L;;;;;N;;;;;
1B196;NUSHU CHARACTER-1B196;Lo;0;L;;;;;N;;;;;
1B197;NUSHU CHARACTER-1B197;Lo;0;L;;;;;N;;;;;
1B198;NUSHU CHARACTER-1B198;Lo;0;L;;;;;N;;;;;
1B199;NUSHU CHARACTER-1B199;Lo;0;L;;;;;N;;;;;
1B19A;NUSHU CHARACTER-1B19A;Lo;0;L;;;;;N;;;;;
1B19B;NUSHU CHARACTER-1B19B;Lo;0;L;;;;;N;;;;;
1B19C;NUSHU CHARACTER-1B19C;Lo;0;L;;;;;N;;;;;
1B19D;NUSHU CHARACTER-1B19D;Lo;0;L;;;;;N;;;;;
1B19E;NUSHU CHARACTER-1B19E;Lo;0;L;;;;;N;;;;;
1B19F;NUSHU CHARACTER-1B19F;Lo;0;L;;;;;N;;;;;
1B1A0;NUSHU CHARACTER-1B1A0;Lo;0;L;;;;;N;;;;;
1B1A1;NUSHU CHARACTER-1B1A1;Lo;0;L;;;;;N;;;;;
1B1A2;NUSHU CHARACTER-1B1A2;Lo;0;L;;;;;N;;;;;
1B1A3;NUSHU CHARACTER-1B1A3;Lo;0;L;;;;;N;;;;;
1B1A4;NUSHU CHARACTER-1B1A4;Lo;0;L;;;;;N;;;;;
1B1A5;NUSHU CHARACTER-1B1A5;Lo;0;L;;;;;N;;;;;
1B1A6;NUSHU CHARACTER-1B1A6;Lo;0;L;;;;;N;;;;;
1B1A7;NUSHU CHARACTER-1B1A7;Lo;0;L;;;;;N;;;;;
1B1A8;NUSHU CHARACTER-1B1A8;Lo;0;L;;;;;N;;;;;
1B1A9;NUSHU CHARACTER-1B1A9;Lo;0;L;;;;;N;;;;;
1B1AA;NUSHU CHARACTER-1B1AA;Lo;0;L;;;;;N;;;;;
1B1AB;NUSHU CHARACTER-1B1AB;Lo;0;L;;;;;N;;;;;
1B1AC;NUSHU CHARACTER-1B1AC;Lo;0;L;;;;;N;;;;;
1B1AD;NUSHU CHARACTER-1B1AD;Lo;0;L;;;;;N;;;;;
1B1AE;NUSHU CHARACTER-1B1AE;Lo;0;L;;;;;N;;;;;
1B1AF;NUSHU CHARACTER-1B1AF;Lo;0;L;;;;;N;;;;;
1B1B0;NUSHU CHARACTER-1B1B0;Lo;0;L;;;;;N;;;;;
1B1B1;NUSHU CHARACTER-1B1B1;Lo;0;L;;;;;N;;;;;
1B1B2;NUSHU CHARACTER-1B1B2;Lo;0;L;;;;;N;;;;;
1B1B3;NUSHU CHARACTER-1B1B3;Lo;0;L;;;;;N;;;;;
1B1B4;NUSHU CHARACTER-1B1B4;Lo;0;L;;;;;N;;;;;
1B1B5;NUSHU CHARACTER-1B1B5;Lo;0;L;;;;;N;;;;;
1B1B6;NUSHU CHARACTER-1B1B6;Lo;0;L;;;;;N;;;;;
1B1B7;NUSHU CHARACTER-1B1B7;Lo;0;L;;;;;N;;;;;
1B1B8;NUSHU CHARACTER-1B1B8;Lo;0;L;;;;;N;;;;;
1B1B9;NUSHU CHARACTER-1B1B9;Lo;0;L;;;;;N;;;;;
1B1BA;NUSHU CHARACTER-1B1BA;Lo;0;L;;;;;N;;;;;
1B1BB;NUSHU CHARACTER-1B1BB;Lo;0;L;;;;;N;;;;;
1B1BC;NUSHU CHARACTER-1B1BC;Lo;0;L;;;;;N;;;;;
1B1BD;NUSHU CHARACTER-1B1BD;Lo;0;L;;;;;N;;;;;
1B1BE;NUSHU CHARACTER-1B1BE;Lo;0;L;;;;;N;;;;;
1B1BF;NUSHU CHARACTER-1B1BF;Lo;0;L;;;;;N;;;;;
1B1C0;NUSHU CHARACTER-1B1C0;Lo;0;L;;;;;N;;;;;
1B1C1;NUSHU CHARACTER-1B1C1;Lo;0;L;;;;;N;;;;;
1B1C2;NUSHU CHARACTER-1B1C2;Lo;0;L;;;;;N;;;;;
1B1C3;NUSHU CHARACTER-1B1C3;Lo;0;L;;;;;N;;;;;
1B1C4;NUSHU CHARACTER-1B1C4;Lo;0;L;;;;;N;;;;;
1B1C5;NUSHU CHARACTER-1B1C5;Lo;0;L;;;;;N;;;;;
1B1C6;NUSHU CHARACTER-1B1C6;Lo;0;L;;;;;N;;;;;
1B1C7;NUSHU CHARACTER-1B1C7;Lo;0;L;;;;;N;;;;;
1B1C8;NUSHU CHARACTER-1B1C8;Lo;0;L;;;;;N;;;;;
1B1C9;NUSHU CHARACTER-1B1C9;Lo;0;L;;;;;N;;;;;
1B1CA;NUSHU CHARACTER-1B1CA;Lo;0;L;;;;;N;;;;;
1B1CB;NUSHU CHARACTER-1B1CB;Lo;0;L;;;;;N;;;;;
1B1CC;NUSHU CHARACTER-1B1CC;Lo;0;L;;;;;N;;;;;
1B1CD;NUSHU CHARACTER-1B1CD;Lo;0;L;;;;;N;;;;;
1B1CE;NUSHU CHARACTER-1B1CE;Lo;0;L;;;;;N;;;;;
1B1CF;NUSHU CHARACTER-1B1CF;Lo;0;L;;;;;N;;;;;
1B1D0;NUSHU CHARACTER-1B1D0;Lo;0;L;;;;;N;;;;;
1B1D1;NUSHU CHARACTER-1B1D1;Lo;0;L;;;;;N;;;;;
1B1D2;NUSHU CHARACTER-1B1D2;Lo;0;L;;;;;N;;;;;
1B1D3;NUSHU CHARACTER-1B1D3;Lo;0;L;;;;;N;;;;;
1B1D4;NUSHU CHARACTER-1B1D4;Lo;0;L;;;;;N;;;;;
1B1D5;NUSHU CHARACTER-1B1D5;Lo;0;L;;;;;N;;;;;
1B1D6;NUSHU CHARACTER-1B1D6;Lo;0;L;;;;;N;;;;;
1B1D7;NUSHU CHARACTER-1B1D7;Lo;0;L;;;;;N;;;;;
1B1D8;NUSHU CHARACTER-1B1D8;Lo;0;L;;;;;N;;;;;
1B1D9;NUSHU CHARACTER-1B1D9;Lo;0;L;;;;;N;;;;;
1B1DA;NUSHU CHARACTER-1B1DA;Lo;0;L;;;;;N;;;;;
1B1DB;NUSHU CHARACTER-1B1DB;Lo;0;L;;;;;N;;;;;
1B1DC;NUSHU CHARACTER-1B1DC;Lo;0;L;;;;;N;;;;;
1B1DD;NUSHU CHARACTER-1B1DD;Lo;0;L;;;;;N;;;;;
1B1DE;NUSHU CHARACTER-1B1DE;Lo;0;L;;;;;N;;;;;
1B1DF;NUSHU CHARACTER-1B1DF;Lo;0;L;;;;;N;;;;;
1B1E0;NUSHU CHARACTER-1B1E0;Lo;0;L;;;;;N;;;;;
1B1E1;NUSHU CHARACTER-1B1E1;Lo;0;L;;;;;N;;;;;
1B1E2;NUSHU CHARACTER-1B1E2;Lo;0;L;;;;;N;;;;;
1B1E3;NUSHU CHARACTER-1B1E3;Lo;0;L;;;;;N;;;;;
1B1E4;NUSHU CHARACTER-1B1E4;Lo;0;L;;;;;N;;;;;
1B1E5;NUSHU CHARACTER-1B1E5;Lo;0;L;;;;;N;;;;;
1B1E6;NUSHU CHARACTER-1B1E6;Lo;0;L;;;;;N;;;;;
1B1E7;NUSHU CHARACTER-1B1E7;Lo;0;L;;;;;N;;;;;
1B1E8;NUSHU CHARACTER-1B1E8;Lo;0;L;;;;;N;;;;;
1B1E9;NUSHU CHARACTER-1B1E9;Lo;0;L;;;;;N;;;;;
1B1EA;NUSHU CHARACTER-1B1EA;Lo;0;L;;;;;N;;;;;
1B1EB;NUSHU CHARACTER-1B1EB;Lo;0;L;;;;;N;;;;;
1B1EC;NUSHU CHARACTER-1B1EC;Lo;0;L;;;;;N;;;;;
1B1ED;NUSHU CHARACTER-1B1ED;Lo;0;L;;;;;N;;;;;
1B1EE;NUSHU CHARACTER-1B1EE;Lo;0;L;;;;;N;;;;;
1B1EF;NUSHU CHARACTER-1B1EF;Lo;0;L;;;;;N;;;;;
1B1F0;NUSHU CHARACTER-1B1F0;Lo;0;L;;;;;N;;;;;
1B1F1;NUSHU CHARACTER-1B1F1;Lo;0;L;;;;;N;;;;;
1B1F2;NUSHU CHARACTER-1B1F2;Lo;0;L;;;;;N;;;;;
1B1F3;NUSHU CHARACTER-1B1F3;Lo;0;L;;;;;N;;;;;
1B1F4;NUSHU CHARACTER-1B1F4;Lo;0;L;;;;;N;;;;;
1B1F5;NUSHU CHARACTER-1B1F5;Lo;0;L;;;;;N;;;;;
1B1F6;NUSHU CHARACTER-1B1F6;Lo;0;L;;;;;N;;;;;
1B1F7;NUSHU CHARACTER-1B1F7;Lo;0;L;;;;;N;;;;;
1B1F8;NUSHU CHARACTER-1B1F8;Lo;0;L;;;;;N;;;;;
1B1F9;NUSHU CHARACTER-1B1F9;Lo;0;L;;;;;N;;;;;
1B1FA;NUSHU CHARACTER-1B1FA;Lo;0;L;;;;;N;;;;;
1B1FB;NUSHU CHARACTER-1B1FB;Lo;0;L;;;;;N;;;;;
1B1FC;NUSHU CHARACTER-1B1FC;Lo;0;L;;;;;N;;;;;
1B1FD;NUSHU CHARACTER-1B1FD;Lo;0;L;;;;;N;;;;;
1B1FE;NUSHU CHARACTER-1B1FE;Lo;0;L;;;;;N;;;;;
1B1FF;NUSHU CHARACTER-1B1FF;Lo;0;L;;;;;N;;;;;
1B200;NUSHU CHARACTER-1B200;Lo;0;L;;;;;N;;;;;
1B201;NUSHU CHARACTER-1B201;Lo;0;L;;;;;N;;;;;
1B202;NUSHU CHARACTER-1B202;Lo;0;L;;;;;N;;;;;
1B203;NUSHU CHARACTER-1B203;Lo;0;L;;;;;N;;;;;
1B204;NUSHU CHARACTER-1B204;Lo;0;L;;;;;N;;;;;
1B205;NUSHU CHARACTER-1B205;Lo;0;L;;;;;N;;;;;
1B206;NUSHU CHARACTER-1B206;Lo;0;L;;;;;N;;;;;
1B207;NUSHU CHARACTER-1B207;Lo;0;L;;;;;N;;;;;
1B208;NUSHU CHARACTER-1B208;Lo;0;L;;;;;N;;;;;
1B209;NUSHU CHARACTER-1B209;Lo;0;L;;;;;N;;;;;
1B20A;NUSHU CHARACTER-1B20A;Lo;0;L;;;;;N;;;;;
1B20B;NUSHU CHARACTER-1B20B;Lo;0;L;;;;;N;;;;;
1B20C;NUSHU CHARACTER-1B20C;Lo;0;L;;;;;N;;;;;
1B20D;NUSHU CHARACTER-1B20D;Lo;0;L;;;;;N;;;;;
1B20E;NUSHU CHARACTER-1B20E;Lo;0;L;;;;;N;;;;;
1B20F;NUSHU CHARACTER-1B20F;Lo;0;L;;;;;N;;;;;
1B210;NUSHU CHARACTER-1B210;Lo;0;L;;;;;N;;;;;
1B211;NUSHU CHARACTER-1B211;Lo;0;L;;;;;N;;;;;
1B212;NUSHU CHARACTER-1B212;Lo;0;L;;;;;N;;;;;
1B213;NUSHU CHARACTER-1B213;Lo;0;L;;;;;N;;;;;
1B214;NUSHU CHARACTER-1B214;Lo;0;L;;;;;N;;;;;
1B215;NUSHU CHARACTER-1B215;Lo;0;L;;;;;N;;;;;
1B216;NUSHU CHARACTER-1B216;Lo;0;L;;;;;N;;;;;
1B217;NUSHU CHARACTER-1B217;Lo;0;L;;;;;N;;;;;
1B218;NUSHU CHARACTER-1B218;Lo;0;L;;;;;N;;;;;
1B219;NUSHU CHARACTER-1B219;Lo;0;L;;;;;N;;;;;
1B21A;NUSHU CHARACTER-1B21A;Lo;0;L;;;;;N;;;;;
1B21B;NUSHU CHARACTER-1B21B;Lo;0;L;;;;;N;;;;;
1B21C;NUSHU CHARACTER-1B21C;Lo;0;L;;;;;N;;;;;
1B21D;NUSHU CHARACTER-1B21D;Lo;0;L;;;;;N;;;;;
1B21E;NUSHU CHARACTER-1B21E;Lo;0;L;;;;;N;;;;;
1B21F;NUSHU CHARACTER-1B21F;Lo;0;L;;;;;N;;;;;
1B220;NUSHU CHARACTER-1B220;Lo;0;L;;;;;N;;;;;
1B221;NUSHU CHARACTER-1B221;Lo;0;L;;;;;N;;;;;
1B222;NUSHU CHARACTER-1B222;Lo;0;L;;;;;N;;;;;
1B223;NUSHU CHARACTER-1B223;Lo;0;L;;;;;N;;;;;
1B224;NUSHU CHARACTER-1B224;Lo;0;L;;;;;N;;;;;
1B225;NUSHU CHARACTER-1B225;Lo;0;L;;;;;N;;;;;
1B226;NUSHU CHARACTER-1B226;Lo;0;L;;;;;N;;;;;
1B227;NUSHU CHARACTER-1B227;Lo;0;L;;;;;N;;;;;
1B228;NUSHU CHARACTER-1B228;Lo;0;L;;;;;N;;;;;
1B229;NUSHU CHARACTER-1B229;Lo;0;L;;;;;N;;;;;
1B22A;NUSHU CHARACTER-1B22A;Lo;0;L;;;;;N;;;;;
1B22B;NUSHU CHARACTER-1B22B;Lo;0;L;;;;;N;;;;;
1B22C;NUSHU CHARACTER-1B22C;Lo;0;L;;;;;N;;;;;
1B22D;NUSHU CHARACTER-1B22D;Lo;0;L;;;;;N;;;;;
1B22E;NUSHU CHARACTER-1B22E;Lo;0;L;;;;;N;;;;;
1B22F;NUSHU CHARACTER-1B22F;Lo;0;L;;;;;N;;;;;
1B230;NUSHU CHARACTER-1B230;Lo;0;L;;;;;N;;;;;
1B231;NUSHU CHARACTER-1B231;Lo;0;L;;;;;N;;;;;
1B232;NUSHU CHARACTER-1B232;Lo;0;L;;;;;N;;;;;
1B233;NUSHU CHARACTER-1B233;Lo;0;L;;;;;N;;;;;
1B234;NUSHU CHARACTER-1B234;Lo;0;L;;;;;N;;;;;
1B235;NUSHU CHARACTER-1B235;Lo;0;L;;;;;N;;;;;
1B236;NUSHU CHARACTER-1B236;Lo;0;L;;;;;N;;;;;
1B237;NUSHU CHARACTER-1B237;Lo;0;L;;;;;N;;;;;
1B238;NUSHU CHARACTER-1B238;Lo;0;L;;;;;N;;;;;
1B239;NUSHU CHARACTER-1B239;Lo;0;L;;;;;N;;;;;
1B23A;NUSHU CHARACTER-1B23A;Lo;0;L;;;;;N;;;;;
1B23B;NUSHU CHARACTER-1B23B;Lo;0;L;;;;;N;;;;;
1B23C;NUSHU CHARACTER-1B23C;Lo;0;L;;;;;N;;;;;
1B23D;NUSHU CHARACTER-1B23D;Lo;0;L;;;;;N;;;;;
1B23E;NUSHU CHARACTER-1B23E;Lo;0;L;;;;;N;;;;;
1B23F;NUSHU CHARACTER-1B23F;Lo;0;L;;;;;N;;;;;
1B240;NUSHU CHARACTER-1B240;Lo;0;L;;;;;N;;;;;
1B241;NUSHU CHARACTER-1B241;Lo;0;L;;;;;N;;;;;
1B242;NUSHU CHARACTER-1B242;Lo;0;L;;;;;N;;;;;
1B243;NUSHU CHARACTER-1B243;Lo;0;L;;;;;N;;;;;
1B244;NUSHU CHARACTER-1B244;Lo;0;L;;;;;N;;;;;
1B245;NUSHU CHARACTER-1B245;Lo;0;L;;;;;N;;;;;
1B246;NUSHU CHARACTER-1B246;Lo;0;L;;;;;N;;;;;
1B247;NUSHU CHARACTER-1B247;Lo;0;L;;;;;N;;;;;
1B248;NUSHU CHARACTER-1B248;Lo;0;L;;;;;N;;;;;
1B249;NUSHU CHARACTER-1B249;Lo;0;L;;;;;N;;;;;
1B24A;NUSHU CHARACTER-1B24A;Lo;0;L;;;;;N;;;;;
1B24B;NUSHU CHARACTER-1B24B;Lo;0;L;;;;;N;;;;;
1B24C;NUSHU CHARACTER-1B24C;Lo;0;L;;;;;N;;;;;
1B24D;NUSHU CHARACTER-1B24D;Lo;0;L;;;;;N;;;;;
1B24E;NUSHU CHARACTER-1B24E;Lo;0;L;;;;;N;;;;;
1B24F;NUSHU CHARACTER-1B24F;Lo;0;L;;;;;N;;;;;
1B250;NUSHU CHARACTER-1B250;Lo;0;L;;;;;N;;;;;
1B251;NUSHU CHARACTER-1B251;Lo;0;L;;;;;N;;;;;
1B252;NUSHU CHARACTER-1B252;Lo;0;L;;;;;N;;;;;
1B253;NUSHU CHARACTER-1B253;Lo;0;L;;;;;N;;;;;
1B254;NUSHU CHARACTER-1B254;Lo;0;L;;;;;N;;;;;
1B255;NUSHU CHARACTER-1B255;Lo;0;L;;;;;N;;;;;
1B256;NUSHU CHARACTER-1B256;Lo;0;L;;;;;N;;;;;
1B257;NUSHU CHARACTER-1B257;Lo;0;L;;;;;N;;;;;
1B258;NUSHU CHARACTER-1B258;Lo;0;L;;;;;N;;;;;
1B259;NUSHU CHARACTER-1B259;Lo;0;L;;;;;N;;;;;
1B25A;NUSHU CHARACTER-1B25A;Lo;0;L;;;;;N;;;;;
1B25B;NUSHU CHARACTER-1B25B;Lo;0;L;;;;;N;;;;;
1B25C;NUSHU CHARACTER-1B25C;Lo;0;L;;;;;N;;;;;
1B25D;NUSHU CHARACTER-1B25D;Lo;0;L;;;;;N;;;;;
1B25E;NUSHU CHARACTER-1B25E;Lo;0;L;;;;;N;;;;;
1B25F;NUSHU CHARACTER-1B25F;Lo;0;L;;;;;N;;;;;
1B260;NUSHU CHARACTER-1B260;Lo;0;L;;;;;N;;;;;
1B261;NUSHU CHARACTER-1B261;Lo;0;L;;;;;N;;;;;
1B262;NUSHU CHARACTER-1B262;Lo;0;L;;;;;N;;;;;
1B263;NUSHU CHARACTER-1B263;Lo;0;L;;;;;N;;;;;
1B264;NUSHU CHARACTER-1B264;Lo;0;L;;;;;N;;;;;
1B265;NUSHU CHARACTER-1B265;Lo;0;L;;;;;N;;;;;
1B266;NUSHU CHARACTER-1B266;Lo;0;L;;;;;N;;;;;
1B267;NUSHU CHARACTER-1B267;Lo;0;L;;;;;N;;;;;
1B268;NUSHU CHARACTER-1B268;Lo;0;L;;;;;N;;;;;
1B269;NUSHU CHARACTER-1B269;Lo;0;L;;;;;N;;;;;
1B26A;NUSHU CHARACTER-1B26A;Lo;0;L;;;;;N;;;;;
1B26B;NUSHU CHARACTER-1B26B;Lo;0;L;;;;;N;;;;;
1B26C;NUSHU CHARACTER-1B26C;Lo;0;L;;;;;N;;;;;
1B26D;NUSHU CHARACTER-1B26D;Lo;0;L;;;;;N;;;;;
1B26E;NUSHU CHARACTER-1B26E;Lo;0;L;;;;;N;;;;;
1B26F;NUSHU CHARACTER-1B26F;Lo;0;L;;;;;N;;;;;
1B270;NUSHU CHARACTER-1B270;Lo;0;L;;;;;N;;;;;
1B271;NUSHU CHARACTER-1B271;Lo;0;L;;;;;N;;;;;
1B272;NUSHU CHARACTER-1B272;Lo;0;L;;;;;N;;;;;
1B273;NUSHU CHARACTER-1B273;Lo;0;L;;;;;N;;;;;
1B274;NUSHU CHARACTER-1B274;Lo;0;L;;;;;N;;;;;
1B275;NUSHU CHARACTER-1B275;Lo;0;L;;;;;N;;;;;
1B276;NUSHU CHARACTER-1B276;Lo;0;L;;;;;N;;;;;
1B277;NUSHU CHARACTER-1B277;Lo;0;L;;;;;N;;;;;
1B278;NUSHU CHARACTER-1B278;Lo;0;L;;;;;N;;;;;
1B279;NUSHU CHARACTER-1B279;Lo;0;L;;;;;N;;;;;
1B27A;NUSHU CHARACTER-1B27A;Lo;0;L;;;;;N;;;;;
1B27B;NUSHU CHARACTER-1B27B;Lo;0;L;;;;;N;;;;;
1B27C;NUSHU CHARACTER-1B27C;Lo;0;L;;;;;N;;;;;
1B27D;NUSHU CHARACTER-1B27D;Lo;0;L;;;;;N;;;;;
1B27E;NUSHU CHARACTER-1B27E;Lo;0;L;;;;;N;;;;;
1B27F;NUSHU CHARACTER-1B27F;Lo;0;L;;;;;N;;;;;
1B280;NUSHU CHARACTER-1B280;Lo;0;L;;;;;N;;;;;
1B281;NUSHU CHARACTER-1B281;Lo;0;L;;;;;N;;;;;
1B282;NUSHU CHARACTER-1B282;Lo;0;L;;;;;N;;;;;
1B283;NUSHU CHARACTER-1B283;Lo;0;L;;;;;N;;;;;
1B284;NUSHU CHARACTER-1B284;Lo;0;L;;;;;N;;;;;
1B285;NUSHU CHARACTER-1B285;Lo;0;L;;;;;N;;;;;
1B286;NUSHU CHARACTER-1B286;Lo;0;L;;;;;N;;;;;
1B287;NUSHU CHARACTER-1B287;Lo;0;L;;;;;N;;;;;
1B288;NUSHU CHARACTER-1B288;Lo;0;L;;;;;N;;;;;
1B289;NUSHU CHARACTER-1B289;Lo;0;L;;;;;N;;;;;
1B28A;NUSHU CHARACTER-1B28A;Lo;0;L;;;;;N;;;;;
1B28B;NUSHU CHARACTER-1B28B;Lo;0;L;;;;;N;;;;;
1B28C;NUSHU CHARACTER-1B28C;Lo;0;L;;;;;N;;;;;
1B28D;NUSHU CHARACTER-1B28D;Lo;0;L;;;;;N;;;;;
1B28E;NUSHU CHARACTER-1B28E;Lo;0;L;;;;;N;;;;;
1B28F;NUSHU CHARACTER-1B28F;Lo;0;L;;;;;N;;;;;
1B290;NUSHU CHARACTER-1B290;Lo;0;L;;;;;N;;;;;
1B291;NUSHU CHARACTER-1B291;Lo;0;L;;;;;N;;;;;
1B292;NUSHU CHARACTER-1B292;Lo;0;L;;;;;N;;;;;
1B293;NUSHU CHARACTER-1B293;Lo;0;L;;;;;N;;;;;
1B294;NUSHU CHARACTER-1B294;Lo;0;L;;;;;N;;;;;
1B295;NUSHU CHARACTER-1B295;Lo;0;L;;;;;N;;;;;
1B296;NUSHU CHARACTER-1B296;Lo;0;L;;;;;N;;;;;
1B297;NUSHU CHARACTER-1B297;Lo;0;L;;;;;N;;;;;
1B298;NUSHU CHARACTER-1B298;Lo;0;L;;;;;N;;;;;
1B299;NUSHU CHARACTER-1B299;Lo;0;L;;;;;N;;;;;
1B29A;NUSHU CHARACTER-1B29A;Lo;0;L;;;;;N;;;;;
1B29B;NUSHU CHARACTER-1B29B;Lo;0;L;;;;;N;;;;;
1B29C;NUSHU CHARACTER-1B29C;Lo;0;L;;;;;N;;;;;
1B29D;NUSHU CHARACTER-1B29D;Lo;0;L;;;;;N;;;;;
1B29E;NUSHU CHARACTER-1B29E;Lo;0;L;;;;;N;;;;;
1B29F;NUSHU CHARACTER-1B29F;Lo;0;L;;;;;N;;;;;
1B2A0;NUSHU CHARACTER-1B2A0;Lo;0;L;;;;;N;;;;;
1B2A1;NUSHU CHARACTER-1B2A1;Lo;0;L;;;;;N;;;;;
1B2A2;NUSHU CHARACTER-1B2A2;Lo;0;L;;;;;N;;;;;
1B2A3;NUSHU CHARACTER-1B2A3;Lo;0;L;;;;;N;;;;;
1B2A4;NUSHU CHARACTER-1B2A4;Lo;0;L;;;;;N;;;;;
1B2A5;NUSHU CHARACTER-1B2A5;Lo;0;L;;;;;N;;;;;
1B2A6;NUSHU CHARACTER-1B2A6;Lo;0;L;;;;;N;;;;;
1B2A7;NUSHU CHARACTER-1B2A7;Lo;0;L;;;;;N;;;;;
1B2A8;NUSHU CHARACTER-1B2A8;Lo;0;L;;;;;N;;;;;
1B2A9;NUSHU CHARACTER-1B2A9;Lo;0;L;;;;;N;;;;;
1B2AA;NUSHU CHARACTER-1B2AA;Lo;0;L;;;;;N;;;;;
1B2AB;NUSHU CHARACTER-1B2AB;Lo;0;L;;;;;N;;;;;
1B2AC;NUSHU CHARACTER-1B2AC;Lo;0;L;;;;;N;;;;;
1B2AD;NUSHU CHARACTER-1B2AD;Lo;0;L;;;;;N;;;;;
1B2AE;NUSHU CHARACTER-1B2AE;Lo;0;L;;;;;N;;;;;
1B2AF;NUSHU CHARACTER-1B2AF;Lo;0;L;;;;;N;;;;;
1B2B0;NUSHU CHARACTER-1B2B0;Lo;0;L;;;;;N;;;;;
1B2B1;NUSHU CHARACTER-1B2B1;Lo;0;L;;;;;N;;;;;
1B2B2;NUSHU CHARACTER-1B2B2;Lo;0;L;;;;;N;;;;;
1B2B3;NUSHU CHARACTER-1B2B3;Lo;0;L;;;;;N;;;;;
1B2B4;NUSHU CHARACTER-1B2B4;Lo;0;L;;;;;N;;;;;
1B2B5;NUSHU CHARACTER-1B2B5;Lo;0;L;;;;;N;;;;;
1B2B6;NUSHU CHARACTER-1B2B6;Lo;0;L;;;;;N;;;;;
1B2B7;NUSHU CHARACTER-1B2B7;Lo;0;L;;;;;N;;;;;
1B2B8;NUSHU CHARACTER-1B2B8;Lo;0;L;;;;;N;;;;;
1B2B9;NUSHU CHARACTER-1B2B9;Lo;0;L;;;;;N;;;;;
1B2BA;NUSHU CHARACTER-1B2BA;Lo;0;L;;;;;N;;;;;
1B2BB;NUSHU CHARACTER-1B2BB;Lo;0;L;;;;;N;;;;;
1B2BC;NUSHU CHARACTER-1B2BC;Lo;0;L;;;;;N;;;;;
1B2BD;NUSHU CHARACTER-1B2BD;Lo;0;L;;;;;N;;;;;
1B2BE;NUSHU CHARACTER-1B2BE;Lo;0;L;;;;;N;;;;;
1B2BF;NUSHU CHARACTER-1B2BF;Lo;0;L;;;;;N;;;;;
1B2C0;NUSHU CHARACTER-1B2C0;Lo;0;L;;;;;N;;;;;
1B2C1;NUSHU CHARACTER-1B2C1;Lo;0;L;;;;;N;;;;;
1B2C2;NUSHU CHARACTER-1B2C2;Lo;0;L;;;;;N;;;;;
1B2C3;NUSHU CHARACTER-1B2C3;Lo;0;L;;;;;N;;;;;
1B2C4;NUSHU CHARACTER-1B2C4;Lo;0;L;;;;;N;;;;;
1B2C5;NUSHU CHARACTER-1B2C5;Lo;0;L;;;;;N;;;;;
1B2C6;NUSHU CHARACTER-1B2C6;Lo;0;L;;;;;N;;;;;
1B2C7;NUSHU CHARACTER-1B2C7;Lo;0;L;;;;;N;;;;;
1B2C8;NUSHU CHARACTER-1B2C8;Lo;0;L;;;;;N;;;;;
1B2C9;NUSHU CHARACTER-1B2C9;Lo;0;L;;;;;N;;;;;
1B2CA;NUSHU CHARACTER-1B2CA;Lo;0;L;;;;;N;;;;;
1B2CB;NUSHU CHARACTER-1B2CB;Lo;0;L;;;;;N;;;;;
1B2CC;NUSHU CHARACTER-1B2CC;Lo;0;L;;;;;N;;;;;
1B2CD;NUSHU CHARACTER-1B2CD;Lo;0;L;;;;;N;;;;;
1B2CE;NUSHU CHARACTER-1B2CE;Lo;0;L;;;;;N;;;;;
1B2CF;NUSHU CHARACTER-1B2CF;Lo;0;L;;;;;N;;;;;
1B2D0;NUSHU CHARACTER-1B2D0;Lo;0;L;;;;;N;;;;;
1B2D1;NUSHU CHARACTER-1B2D1;Lo;0;L;;;;;N;;;;;
1B2D2;NUSHU CHARACTER-1B2D2;Lo;0;L;;;;;N;;;;;
1B2D3;NUSHU CHARACTER-1B2D3;Lo;0;L;;;;;N;;;;;
1B2D4;NUSHU CHARACTER-1B2D4;Lo;0;L;;;;;N;;;;;
1B2D5;NUSHU CHARACTER-1B2D5;Lo;0;L;;;;;N;;;;;
1B2D6;NUSHU CHARACTER-1B2D6;Lo;0;L;;;;;N;;;;;
1B2D7;NUSHU CHARACTER-1B2D7;Lo;0;L;;;;;N;;;;;
1B2D8;NUSHU CHARACTER-1B2D8;Lo;0;L;;;;;N;;;;;
1B2D9;NUSHU CHARACTER-1B2D9;Lo;0;L;;;;;N;;;;;
1B2DA;NUSHU CHARACTER-1B2DA;Lo;0;L;;;;;N;;;;;
1B2DB;NUSHU CHARACTER-1B2DB;Lo;0;L;;;;;N;;;;;
1B2DC;NUSHU CHARACTER-1B2DC;Lo;0;L;;;;;N;;;;;
1B2DD;NUSHU CHARACTER-1B2DD;Lo;0;L;;;;;N;;;;;
1B2DE;NUSHU CHARACTER-1B2DE;Lo;0;L;;;;;N;;;;;
1B2DF;NUSHU CHARACTER-1B2DF;Lo;0;L;;;;;N;;;;;
1B2E0;NUSHU CHARACTER-1B2E0;Lo;0;L;;;;;N;;;;;
1B2E1;NUSHU CHARACTER-1B2E1;Lo;0;L;;;;;N;;;;;
1B2E2;NUSHU CHARACTER-1B2E2;Lo;0;L;;;;;N;;;;;
1B2E3;NUSHU CHARACTER-1B2E3;Lo;0;L;;;;;N;;;;;
1B2E4;NUSHU CHARACTER-1B2E4;Lo;0;L;;;;;N;;;;;
1B2E5;NUSHU CHARACTER-1B2E5;Lo;0;L;;;;;N;;;;;
1B2E6;NUSHU CHARACTER-1B2E6;Lo;0;L;;;;;N;;;;;
1B2E7;NUSHU CHARACTER-1B2E7;Lo;0;L;;;;;N;;;;;
1B2E8;NUSHU CHARACTER-1B2E8;Lo;0;L;;;;;N;;;;;
1B2E9;NUSHU CHARACTER-1B2E9;Lo;0;L;;;;;N;;;;;
1B2EA;NUSHU CHARACTER-1B2EA;Lo;0;L;;;;;N;;;;;
1B2EB;NUSHU CHARACTER-1B2EB;Lo;0;L;;;;;N;;;;;
1B2EC;NUSHU CHARACTER-1B2EC;Lo;0;L;;;;;N;;;;;
1B2ED;NUSHU CHARACTER-1B2ED;Lo;0;L;;;;;N;;;;;
1B2EE;NUSHU CHARACTER-1B2EE;Lo;0;L;;;;;N;;;;;
1B2EF;NUSHU CHARACTER-1B2EF;Lo;0;L;;;;;N;;;;;
1B2F0;NUSHU CHARACTER-1B2F0;Lo;0;L;;;;;N;;;;;
1B2F1;NUSHU CHARACTER-1B2F1;Lo;0;L;;;;;N;;;;;
1B2F2;NUSHU CHARACTER-1B2F2;Lo;0;L;;;;;N;;;;;
1B2F3;NUSHU CHARACTER-1B2F3;Lo;0;L;;;;;N;;;;;
1B2F4;NUSHU CHARACTER-1B2F4;Lo;0;L;;;;;N;;;;;
1B2F5;NUSHU CHARACTER-1B2F5;Lo;0;L;;;;;N;;;;;
1B2F6;NUSHU CHARACTER-1B2F6;Lo;0;L;;;;;N;;;;;
1B2F7;NUSHU CHARACTER-1B2F7;Lo;0;L;;;;;N;;;;;
1B2F8;NUSHU CHARACTER-1B2F8;Lo;0;L;;;;;N;;;;;
1B2F9;NUSHU CHARACTER-1B2F9;Lo;0;L;;;;;N;;;;;
1B2FA;NUSHU CHARACTER-1B2FA;Lo;0;L;;;;;N;;;;;
1B2FB;NUSHU CHARACTER-1B2FB;Lo;0;L;;;;;N;;;;;
1BC00;DUPLOYAN LETTER H;Lo;0;L;;;;;N;;;;;
1BC01;DUPLOYAN LETTER X;Lo;0;L;;;;;N;;;;;
1BC02;DUPLOYAN LETTER P;Lo;0;L;;;;;N;;;;;
1BC03;DUPLOYAN LETTER T;Lo;0;L;;;;;N;;;;;
1BC04;DUPLOYAN LETTER F;Lo;0;L;;;;;N;;;;;
1BC05;DUPLOYAN LETTER K;Lo;0;L;;;;;N;;;;;
1BC06;DUPLOYAN LETTER L;Lo;0;L;;;;;N;;;;;
1BC07;DUPLOYAN LETTER B;Lo;0;L;;;;;N;;;;;
1BC08;DUPLOYAN LETTER D;Lo;0;L;;;;;N;;;;;
1BC09;DUPLOYAN LETTER V;Lo;0;L;;;;;N;;;;;
1BC0A;DUPLOYAN LETTER G;Lo;0;L;;;;;N;;;;;
1BC0B;DUPLOYAN LETTER R;Lo;0;L;;;;;N;;;;;
1BC0C;DUPLOYAN LETTER P N;Lo;0;L;;;;;N;;;;;
1BC0D;DUPLOYAN LETTER D S;Lo;0;L;;;;;N;;;;;
1BC0E;DUPLOYAN LETTER F N;Lo;0;L;;;;;N;;;;;
1BC0F;DUPLOYAN LETTER K M;Lo;0;L;;;;;N;;;;;
1BC10;DUPLOYAN LETTER R S;Lo;0;L;;;;;N;;;;;
1BC11;DUPLOYAN LETTER TH;Lo;0;L;;;;;N;;;;;
1BC12;DUPLOYAN LETTER SLOAN DH;Lo;0;L;;;;;N;;;;;
1BC13;DUPLOYAN LETTER DH;Lo;0;L;;;;;N;;;;;
1BC14;DUPLOYAN LETTER KK;Lo;0;L;;;;;N;;;;;
1BC15;DUPLOYAN LETTER SLOAN J;Lo;0;L;;;;;N;;;;;
1BC16;DUPLOYAN LETTER HL;Lo;0;L;;;;;N;;;;;
1BC17;DUPLOYAN LETTER LH;Lo;0;L;;;;;N;;;;;
1BC18;DUPLOYAN LETTER RH;Lo;0;L;;;;;N;;;;;
1BC19;DUPLOYAN LETTER M;Lo;0;L;;;;;N;;;;;
1BC1A;DUPLOYAN LETTER N;Lo;0;L;;;;;N;;;;;
1BC1B;DUPLOYAN LETTER J;Lo;0;L;;;;;N;;;;;
1BC1C;DUPLOYAN LETTER S;Lo;0;L;;;;;N;;;;;
1BC1D;DUPLOYAN LETTER M N;Lo;0;L;;;;;N;;;;;
1BC1E;DUPLOYAN LETTER N M;Lo;0;L;;;;;N;;;;;
1BC1F;DUPLOYAN LETTER J M;Lo;0;L;;;;;N;;;;;
1BC20;DUPLOYAN LETTER S J;Lo;0;L;;;;;N;;;;;
1BC21;DUPLOYAN LETTER M WITH DOT;Lo;0;L;;;;;N;;;;;
1BC22;DUPLOYAN LETTER N WITH DOT;Lo;0;L;;;;;N;;;;;
1BC23;DUPLOYAN LETTER J WITH DOT;Lo;0;L;;;;;N;;;;;
1BC24;DUPLOYAN LETTER J WITH DOTS INSIDE AND ABOVE;Lo;0;L;;;;;N;;;;;
1BC25;DUPLOYAN LETTER S WITH DOT;Lo;0;L;;;;;N;;;;;
1BC26;DUPLOYAN LETTER S WITH DOT BELOW;Lo;0;L;;;;;N;;;;;
1BC27;DUPLOYAN LETTER M S;Lo;0;L;;;;;N;;;;;
1BC28;DUPLOYAN LETTER N S;Lo;0;L;;;;;N;;;;;
1BC29;DUPLOYAN LETTER J S;Lo;0;L;;;;;N;;;;;
1BC2A;DUPLOYAN LETTER S S;Lo;0;L;;;;;N;;;;;
1BC2B;DUPLOYAN LETTER M N S;Lo;0;L;;;;;N;;;;;
1BC2C;DUPLOYAN LETTER N M S;Lo;0;L;;;;;N;;;;;
1BC2D;DUPLOYAN LETTER J M S;Lo;0;L;;;;;N;;;;;
1BC2E;DUPLOYAN LETTER S J S;Lo;0;L;;;;;N;;;;;
1BC2F;DUPLOYAN LETTER J S WITH DOT;Lo;0;L;;;;;N;;;;;
1BC30;DUPLOYAN LETTER J N;Lo;0;L;;;;;N;;;;;
1BC31;DUPLOYAN LETTER J N S;Lo;0;L;;;;;N;;;;;
1BC32;DUPLOYAN LETTER S T;Lo;0;L;;;;;N;;;;;
1BC33;DUPLOYAN LETTER S T R;Lo;0;L;;;;;N;;;;;
1BC34;DUPLOYAN LETTER S P;Lo;0;L;;;;;N;;;;;
1BC35;DUPLOYAN LETTER S P R;Lo;0;L;;;;;N;;;;;
1BC36;DUPLOYAN LETTER T S;Lo;0;L;;;;;N;;;;;
1BC37;DUPLOYAN LETTER T R S;Lo;0;L;;;;;N;;;;;
1BC38;DUPLOYAN LETTER W;Lo;0;L;;;;;N;;;;;
1BC39;DUPLOYAN LETTER WH;Lo;0;L;;;;;N;;;;;
1BC3A;DUPLOYAN LETTER W R;Lo;0;L;;;;;N;;;;;
1BC3B;DUPLOYAN LETTER S N;Lo;0;L;;;;;N;;;;;
1BC3C;DUPLOYAN LETTER S M;Lo;0;L;;;;;N;;;;;
1BC3D;DUPLOYAN LETTER K R S;Lo;0;L;;;;;N;;;;;
1BC3E;DUPLOYAN LETTER G R S;Lo;0;L;;;;;N;;;;;
1BC3F;DUPLOYAN LETTER S K;Lo;0;L;;;;;N;;;;;
1BC40;DUPLOYAN LETTER S K R;Lo;0;L;;;;;N;;;;;
1BC41;DUPLOYAN LETTER A;Lo;0;L;;;;;N;;;;;
1BC42;DUPLOYAN LETTER SLOAN OW;Lo;0;L;;;;;N;;;;;
1BC43;DUPLOYAN LETTER OA;Lo;0;L;;;;;N;;;;;
1BC44;DUPLOYAN LETTER O;Lo;0;L;;;;;N;;;;;
1BC45;DUPLOYAN LETTER AOU;Lo;0;L;;;;;N;;;;;
1BC46;DUPLOYAN LETTER I;Lo;0;L;;;;;N;;;;;
1BC47;DUPLOYAN LETTER E;Lo;0;L;;;;;N;;;;;
1BC48;DUPLOYAN LETTER IE;Lo;0;L;;;;;N;;;;;
1BC49;DUPLOYAN LETTER SHORT I;Lo;0;L;;;;;N;;;;;
1BC4A;DUPLOYAN LETTER UI;Lo;0;L;;;;;N;;;;;
1BC4B;DUPLOYAN LETTER EE;Lo;0;L;;;;;N;;;;;
1BC4C;DUPLOYAN LETTER SLOAN EH;Lo;0;L;;;;;N;;;;;
1BC4D;DUPLOYAN LETTER ROMANIAN I;Lo;0;L;;;;;N;;;;;
1BC4E;DUPLOYAN LETTER SLOAN EE;Lo;0;L;;;;;N;;;;;
1BC4F;DUPLOYAN LETTER LONG I;Lo;0;L;;;;;N;;;;;
1BC50;DUPLOYAN LETTER YE;Lo;0;L;;;;;N;;;;;
1BC51;DUPLOYAN LETTER U;Lo;0;L;;;;;N;;;;;
1BC52;DUPLOYAN LETTER EU;Lo;0;L;;;;;N;;;;;
1BC53;DUPLOYAN LETTER XW;Lo;0;L;;;;;N;;;;;
1BC54;DUPLOYAN LETTER U N;Lo;0;L;;;;;N;;;;;
1BC55;DUPLOYAN LETTER LONG U;Lo;0;L;;;;;N;;;;;
1BC56;DUPLOYAN LETTER ROMANIAN U;Lo;0;L;;;;;N;;;;;
1BC57;DUPLOYAN LETTER UH;Lo;0;L;;;;;N;;;;;
1BC58;DUPLOYAN LETTER SLOAN U;Lo;0;L;;;;;N;;;;;
1BC59;DUPLOYAN LETTER OOH;Lo;0;L;;;;;N;;;;;
1BC5A;DUPLOYAN LETTER OW;Lo;0;L;;;;;N;;;;;
1BC5B;DUPLOYAN LETTER OU;Lo;0;L;;;;;N;;;;;
1BC5C;DUPLOYAN LETTER WA;Lo;0;L;;;;;N;;;;;
1BC5D;DUPLOYAN LETTER WO;Lo;0;L;;;;;N;;;;;
1BC5E;DUPLOYAN LETTER WI;Lo;0;L;;;;;N;;;;;
1BC5F;DUPLOYAN LETTER WEI;Lo;0;L;;;;;N;;;;;
1BC60;DUPLOYAN LETTER WOW;Lo;0;L;;;;;N;;;;;
1BC61;DUPLOYAN LETTER NASAL U;Lo;0;L;;;;;N;;;;;
1BC62;DUPLOYAN LETTER NASAL O;Lo;0;L;;;;;N;;;;;
1BC63;DUPLOYAN LETTER NASAL I;Lo;0;L;;;;;N;;;;;
1BC64;DUPLOYAN LETTER NASAL A;Lo;0;L;;;;;N;;;;;
1BC65;DUPLOYAN LETTER PERNIN AN;Lo;0;L;;;;;N;;;;;
1BC66;DUPLOYAN LETTER PERNIN AM;Lo;0;L;;;;;N;;;;;
1BC67;DUPLOYAN LETTER SLOAN EN;Lo;0;L;;;;;N;;;;;
1BC68;DUPLOYAN LETTER SLOAN AN;Lo;0;L;;;;;N;;;;;
1BC69;DUPLOYAN LETTER SLOAN ON;Lo;0;L;;;;;N;;;;;
1BC6A;DUPLOYAN LETTER VOCALIC M;Lo;0;L;;;;;N;;;;;
1BC70;DUPLOYAN AFFIX LEFT HORIZONTAL SECANT;Lo;0;L;;;;;N;;;;;
1BC71;DUPLOYAN AFFIX MID HORIZONTAL SECANT;Lo;0;L;;;;;N;;;;;
1BC72;DUPLOYAN AFFIX RIGHT HORIZONTAL SECANT;Lo;0;L;;;;;N;;;;;
1BC73;DUPLOYAN AFFIX LOW VERTICAL SECANT;Lo;0;L;;;;;N;;;;;
1BC74;DUPLOYAN AFFIX MID VERTICAL SECANT;Lo;0;L;;;;;N;;;;;
1BC75;DUPLOYAN AFFIX HIGH VERTICAL SECANT;Lo;0;L;;;;;N;;;;;
1BC76;DUPLOYAN AFFIX ATTACHED SECANT;Lo;0;L;;;;;N;;;;;
1BC77;DUPLOYAN AFFIX ATTACHED LEFT-TO-RIGHT SECANT;Lo;0;L;;;;;N;;;;;
1BC78;DUPLOYAN AFFIX ATTACHED TANGENT;Lo;0;L;;;;;N;;;;;
1BC79;DUPLOYAN AFFIX ATTACHED TAIL;Lo;0;L;;;;;N;;;;;
1BC7A;DUPLOYAN AFFIX ATTACHED E HOOK;Lo;0;L;;;;;N;;;;;
1BC7B;DUPLOYAN AFFIX ATTACHED I HOOK;Lo;0;L;;;;;N;;;;;
1BC7C;DUPLOYAN AFFIX ATTACHED TANGENT HOOK;Lo;0;L;;;;;N;;;;;
1BC80;DUPLOYAN AFFIX HIGH ACUTE;Lo;0;L;;;;;N;;;;;
1BC81;DUPLOYAN AFFIX HIGH TIGHT ACUTE;Lo;0;L;;;;;N;;;;;
1BC82;DUPLOYAN AFFIX HIGH GRAVE;Lo;0;L;;;;;N;;;;;
1BC83;DUPLOYAN AFFIX HIGH LONG GRAVE;Lo;0;L;;;;;N;;;;;
1BC84;DUPLOYAN AFFIX HIGH DOT;Lo;0;L;;;;;N;;;;;
1BC85;DUPLOYAN AFFIX HIGH CIRCLE;Lo;0;L;;;;;N;;;;;
1BC86;DUPLOYAN AFFIX HIGH LINE;Lo;0;L;;;;;N;;;;;
1BC87;DUPLOYAN AFFIX HIGH WAVE;Lo;0;L;;;;;N;;;;;
1BC88;DUPLOYAN AFFIX HIGH VERTICAL;Lo;0;L;;;;;N;;;;;
1BC90;DUPLOYAN AFFIX LOW ACUTE;Lo;0;L;;;;;N;;;;;
1BC91;DUPLOYAN AFFIX LOW TIGHT ACUTE;Lo;0;L;;;;;N;;;;;
1BC92;DUPLOYAN AFFIX LOW GRAVE;Lo;0;L;;;;;N;;;;;
1BC93;DUPLOYAN AFFIX LOW LONG GRAVE;Lo;0;L;;;;;N;;;;;
1BC94;DUPLOYAN AFFIX LOW DOT;Lo;0;L;;;;;N;;;;;
1BC95;DUPLOYAN AFFIX LOW CIRCLE;Lo;0;L;;;;;N;;;;;
1BC96;DUPLOYAN AFFIX LOW LINE;Lo;0;L;;;;;N;;;;;
1BC97;DUPLOYAN AFFIX LOW WAVE;Lo;0;L;;;;;N;;;;;
1BC98;DUPLOYAN AFFIX LOW VERTICAL;Lo;0;L;;;;;N;;;;;
1BC99;DUPLOYAN AFFIX LOW ARROW;Lo;0;L;;;;;N;;;;;
1BC9C;DUPLOYAN SIGN O WITH CROSS;So;0;L;;;;;N;;;;;
1BC9D;DUPLOYAN THICK LETTER SELECTOR;Mn;0;NSM;;;;;N;;;;;
1BC9E;DUPLOYAN DOUBLE MARK;Mn;1;NSM;;;;;N;;;;;
1BC9F;DUPLOYAN PUNCTUATION CHINOOK FULL STOP;Po;0;L;;;;;N;;;;;
1BCA0;SHORTHAND FORMAT LETTER OVERLAP;Cf;0;BN;;;;;N;;;;;
1BCA1;SHORTHAND FORMAT CONTINUING OVERLAP;Cf;0;BN;;;;;N;;;;;
1BCA2;SHORTHAND FORMAT DOWN STEP;Cf;0;BN;;;;;N;;;;;
1BCA3;SHORTHAND FORMAT UP STEP;Cf;0;BN;;;;;N;;;;;
1CF00;ZNAMENNY COMBINING MARK GORAZDO NIZKO S KRYZHEM ON LEFT;Mn;0;NSM;;;;;N;;;;;
1CF01;ZNAMENNY COMBINING MARK NIZKO S KRYZHEM ON LEFT;Mn;0;NSM;;;;;N;;;;;
1CF02;ZNAMENNY COMBINING MARK TSATA ON LEFT;Mn;0;NSM;;;;;N;;;;;
1CF03;ZNAMENNY COMBINING MARK GORAZDO NIZKO ON LEFT;Mn;0;NSM;;;;;N;;;;;
1CF04;ZNAMENNY COMBINING MARK NIZKO ON LEFT;Mn;0;NSM;;;;;N;;;;;
1CF05;ZNAMENNY COMBINING MARK SREDNE ON LEFT;Mn;0;NSM;;;;;N;;;;;
1CF06;ZNAMENNY COMBINING MARK MALO POVYSHE ON LEFT;Mn;0;NSM;;;;;N;;;;;
1CF07;ZNAMENNY COMBINING MARK POVYSHE ON LEFT;Mn;0;NSM;;;;;N;;;;;
1CF08;ZNAMENNY COMBINING MARK VYSOKO ON LEFT;Mn;0;NSM;;;;;N;;;;;
1CF09;ZNAMENNY COMBINING MARK MALO POVYSHE S KHOKHLOM ON LEFT;Mn;0;NSM;;;;;N;;;;;
1CF0A;ZNAMENNY COMBINING MARK POVYSHE S KHOKHLOM ON LEFT;Mn;0;NSM;;;;;N;;;;;
1CF0B;ZNAMENNY COMBINING MARK VYSOKO S KHOKHLOM ON LEFT;Mn;0;NSM;;;;;N;;;;;
1CF0C;ZNAMENNY COMBINING MARK GORAZDO NIZKO S KRYZHEM ON RIGHT;Mn;0;NSM;;;;;N;;;;;
1CF0D;ZNAMENNY COMBINING MARK NIZKO S KRYZHEM ON RIGHT;Mn;0;NSM;;;;;N;;;;;
1CF0E;ZNAMENNY COMBINING MARK TSATA ON RIGHT;Mn;0;NSM;;;;;N;;;;;
1CF0F;ZNAMENNY COMBINING MARK GORAZDO NIZKO ON RIGHT;Mn;0;NSM;;;;;N;;;;;
1CF10;ZNAMENNY COMBINING MARK NIZKO ON RIGHT;Mn;0;NSM;;;;;N;;;;;
1CF11;ZNAMENNY COMBINING MARK SREDNE ON RIGHT;Mn;0;NSM;;;;;N;;;;;
1CF12;ZNAMENNY COMBINING MARK MALO POVYSHE ON RIGHT;Mn;0;NSM;;;;;N;;;;;
1CF13;ZNAMENNY COMBINING MARK POVYSHE ON RIGHT;Mn;0;NSM;;;;;N;;;;;
1CF14;ZNAMENNY COMBINING MARK VYSOKO ON RIGHT;Mn;0;NSM;;;;;N;;;;;
1CF15;ZNAMENNY COMBINING MARK MALO POVYSHE S KHOKHLOM ON RIGHT;Mn;0;NSM;;;;;N;;;;;
1CF16;ZNAMENNY COMBINING MARK POVYSHE S KHOKHLOM ON RIGHT;Mn;0;NSM;;;;;N;;;;;
1CF17;ZNAMENNY COMBINING MARK VYSOKO S KHOKHLOM ON RIGHT;Mn;0;NSM;;;;;N;;;;;
1CF18;ZNAMENNY COMBINING MARK TSATA S KRYZHEM;Mn;0;NSM;;;;;N;;;;;
1CF19;ZNAMENNY COMBINING MARK MALO POVYSHE S KRYZHEM;Mn;0;NSM;;;;;N;;;;;
1CF1A;ZNAMENNY COMBINING MARK STRANNO MALO POVYSHE;Mn;0;NSM;;;;;N;;;;;
1CF1B;ZNAMENNY COMBINING MARK POVYSHE S KRYZHEM;Mn;0;NSM;;;;;N;;;;;
1CF1C;ZNAMENNY COMBINING MARK POVYSHE STRANNO;Mn;0;NSM;;;;;N;;;;;
1CF1D;ZNAMENNY COMBINING MARK VYSOKO S KRYZHEM;Mn;0;NSM;;;;;N;;;;;
1CF1E;ZNAMENNY COMBINING MARK MALO POVYSHE STRANNO;Mn;0;NSM;;;;;N;;;;;
1CF1F;ZNAMENNY COMBINING MARK GORAZDO VYSOKO;Mn;0;NSM;;;;;N;;;;;
1CF20;ZNAMENNY COMBINING MARK ZELO;Mn;0;NSM;;;;;N;;;;;
1CF21;ZNAMENNY COMBINING MARK ON;Mn;0;NSM;;;;;N;;;;;
1CF22;ZNAMENNY COMBINING MARK RAVNO;Mn;0;NSM;;;;;N;;;;;
1CF23;ZNAMENNY COMBINING MARK TIKHAYA;Mn;0;NSM;;;;;N;;;;;
1CF24;ZNAMENNY COMBINING MARK BORZAYA;Mn;0;NSM;;;;;N;;;;;
1CF25;ZNAMENNY COMBINING MARK UDARKA;Mn;0;NSM;;;;;N;;;;;
1CF26;ZNAMENNY COMBINING MARK PODVERTKA;Mn;0;NSM;;;;;N;;;;;
1CF27;ZNAMENNY COMBINING MARK LOMKA;Mn;0;NSM;;;;;N;;;;;
1CF28;ZNAMENNY COMBINING MARK KUPNAYA;Mn;0;NSM;;;;;N;;;;;
1CF29;ZNAMENNY COMBINING MARK KACHKA;Mn;0;NSM;;;;;N;;;;;
1CF2A;ZNAMENNY COMBINING MARK ZEVOK;Mn;0;NSM;;;;;N;;;;;
1CF2B;ZNAMENNY COMBINING MARK SKOBA;Mn;0;NSM;;;;;N;;;;;
1CF2C;ZNAMENNY COMBINING MARK RAZSEKA;Mn;0;NSM;;;;;N;;;;;
1CF2D;ZNAMENNY COMBINING MARK KRYZH ON LEFT;Mn;0;NSM;;;;;N;;;;;
1CF30;ZNAMENNY COMBINING TONAL RANGE MARK MRACHNO;Mn;0;NSM;;;;;N;;;;;
1CF31;ZNAMENNY COMBINING TONAL RANGE MARK SVETLO;Mn;0;NSM;;;;;N;;;;;
1CF32;ZNAMENNY COMBINING TONAL RANGE MARK TRESVETLO;Mn;0;NSM;;;;;N;;;;;
1CF33;ZNAMENNY COMBINING MARK ZADERZHKA;Mn;0;NSM;;;;;N;;;;;
1CF34;ZNAMENNY COMBINING MARK DEMESTVENNY ZADERZHKA;Mn;0;NSM;;;;;N;;;;;
1CF35;ZNAMENNY COMBINING MARK OTSECHKA;Mn;0;NSM;;;;;N;;;;;
1CF36;ZNAMENNY COMBINING MARK PODCHASHIE;Mn;0;NSM;;;;;N;;;;;
1CF37;ZNAMENNY COMBINING MARK PODCHASHIE WITH VERTICAL STROKE;Mn;0;NSM;;;;;N;;;;;
1CF38;ZNAMENNY COMBINING MARK CHASHKA;Mn;0;NSM;;;;;N;;;;;
1CF39;ZNAMENNY COMBINING MARK CHASHKA POLNAYA;Mn;0;NSM;;;;;N;;;;;
1CF3A;ZNAMENNY COMBINING MARK OBLACHKO;Mn;0;NSM;;;;;N;;;;;
1CF3B;ZNAMENNY COMBINING MARK SOROCHYA NOZHKA;Mn;0;NSM;;;;;N;;;;;
1CF3C;ZNAMENNY COMBINING MARK TOCHKA;Mn;0;NSM;;;;;N;;;;;
1CF3D;ZNAMENNY COMBINING MARK DVOETOCHIE;Mn;0;NSM;;;;;N;;;;;
1CF3E;ZNAMENNY COMBINING ATTACHING VERTICAL OMET;Mn;0;NSM;;;;;N;;;;;
1CF3F;ZNAMENNY COMBINING MARK CURVED OMET;Mn;0;NSM;;;;;N;;;;;
1CF40;ZNAMENNY COMBINING MARK KRYZH;Mn;0;NSM;;;;;N;;;;;
1CF41;ZNAMENNY COMBINING LOWER TONAL RANGE INDICATOR;Mn;0;NSM;;;;;N;;;;;
1CF42;ZNAMENNY PRIZNAK MODIFIER LEVEL-2;Mn;0;NSM;;;;;N;;;;;
1CF43;ZNAMENNY PRIZNAK MODIFIER LEVEL-3;Mn;0;NSM;;;;;N;;;;;
1CF44;ZNAMENNY PRIZNAK MODIFIER DIRECTION FLIP;Mn;0;NSM;;;;;N;;;;;
1CF45;ZNAMENNY PRIZNAK MODIFIER KRYZH;Mn;0;NSM;;;;;N;;;;;
1CF46;ZNAMENNY PRIZNAK MODIFIER ROG;Mn;0;NSM;;;;;N;;;;;
1CF50;ZNAMENNY NEUME KRYUK;So;0;L;;;;;N;;;;;
1CF51;ZNAMENNY NEUME KRYUK TIKHY;So;0;L;;;;;N;;;;;
1CF52;ZNAMENNY NEUME PARAKLIT;So;0;L;;;;;N;;;;;
1CF53;ZNAMENNY NEUME DVA V CHELNU;So;0;L;;;;;N;;;;;
1CF54;ZNAMENNY NEUME KLYUCH;So;0;L;;;;;N;;;;;
1CF55;ZNAMENNY NEUME ZANOZHEK;So;0;L;;;;;N;;;;;
1CF56;ZNAMENNY NEUME STOPITSA;So;0;L;;;;;N;;;;;
1CF57;ZNAMENNY NEUME STOPITSA S OCHKOM;So;0;L;;;;;N;;;;;
1CF58;ZNAMENNY NEUME PEREVODKA;So;0;L;;;;;N;;;;;
1CF59;ZNAMENNY NEUME PEREVODKA NEPOSTOYANNAYA;So;0;L;;;;;N;;;;;
1CF5A;ZNAMENNY NEUME STOPITSA WITH SOROCHYA NOZHKA;So;0;L;;;;;N;;;;;
1CF5B;ZNAMENNY NEUME CHELYUSTKA;So;0;L;;;;;N;;;;;
1CF5C;ZNAMENNY NEUME PALKA;So;0;L;;;;;N;;;;;
1CF5D;ZNAMENNY NEUME ZAPYATAYA;So;0;L;;;;;N;;;;;
1CF5E;ZNAMENNY NEUME GOLUBCHIK BORZY;So;0;L;;;;;N;;;;;
1CF5F;ZNAMENNY NEUME GOLUBCHIK TIKHY;So;0;L;;;;;N;;;;;
1CF60;ZNAMENNY NEUME GOLUBCHIK MRACHNY;So;0;L;;;;;N;;;;;
1CF61;ZNAMENNY NEUME GOLUBCHIK SVETLY;So;0;L;;;;;N;;;;;
1CF62;ZNAMENNY NEUME GOLUBCHIK TRESVETLY;So;0;L;;;;;N;;;;;
1CF63;ZNAMENNY NEUME VRAKHIYA PROSTAYA;So;0;L;;;;;N;;;;;
1CF64;ZNAMENNY NEUME VRAKHIYA MRACHNAYA;So;0;L;;;;;N;;;;;
1CF65;ZNAMENNY NEUME VRAKHIYA SVETLAYA;So;0;L;;;;;N;;;;;
1CF66;ZNAMENNY NEUME VRAKHIYA TRESVETLAYA;So;0;L;;;;;N;;;;;
1CF67;ZNAMENNY NEUME VRAKHIYA KLYUCHEVAYA PROSTAYA;So;0;L;;;;;N;;;;;
1CF68;ZNAMENNY NEUME VRAKHIYA KLYUCHEVAYA MRACHNAYA;So;0;L;;;;;N;;;;;
1CF69;ZNAMENNY NEUME VRAKHIYA KLYUCHEVAYA SVETLAYA;So;0;L;;;;;N;;;;;
1CF6A;ZNAMENNY NEUME VRAKHIYA KLYUCHEVAYA TRESVETLAYA;So;0;L;;;;;N;;;;;
1CF6B;ZNAMENNY NEUME DOUBLE ZAPYATAYA;So;0;L;;;;;N;;;;;
1CF6C;ZNAMENNY NEUME REVERSED CHELYUSTKA;So;0;L;;;;;N;;;;;
1CF6D;ZNAMENNY NEUME DERBITSA;So;0;L;;;;;N;;;;;
1CF6E;ZNAMENNY NEUME KHAMILO;So;0;L;;;;;N;;;;;
1CF6F;ZNAMENNY NEUME CHASHKA;So;0;L;;;;;N;;;;;
1CF70;ZNAMENNY NEUME PODCHASHIE;So;0;L;;;;;N;;;;;
1CF71;ZNAMENNY NEUME SKAMEYTSA MRACHNAYA;So;0;L;;;;;N;;;;;
1CF72;ZNAMENNY NEUME SKAMEYTSA SVETLAYA;So;0;L;;;;;N;;;;;
1CF73;ZNAMENNY NEUME SKAMEYTSA TRESVETLAYA;So;0;L;;;;;N;;;;;
1CF74;ZNAMENNY NEUME SKAMEYTSA TIKHAYA;So;0;L;;;;;N;;;;;
1CF75;ZNAMENNY NEUME DEMESTVENNY KLYUCH;So;0;L;;;;;N;;;;;
1CF76;ZNAMENNY NEUME SKAMEYTSA KLYUCHEVAYA SVETLAYA;So;0;L;;;;;N;;;;;
1CF77;ZNAMENNY NEUME SKAMEYTSA KLYUCHENEPOSTOYANNAYA;So;0;L;;;;;N;;;;;
1CF78;ZNAMENNY NEUME SKAMEYTSA KLYUCHEVAYA TIKHAYA;So;0;L;;;;;N;;;;;
1CF79;ZNAMENNY NEUME SKAMEYTSA DVOECHELNAYA PROSTAYA;So;0;L;;;;;N;;;;;
1CF7A;ZNAMENNY NEUME SKAMEYTSA DVOECHELNAYA SVETLAYA;So;0;L;;;;;N;;;;;
1CF7B;ZNAMENNY NEUME SKAMEYTSA DVOECHELNAYA NEPOSTOYANNAYA;So;0;L;;;;;N;;;;;
1CF7C;ZNAMENNY NEUME SKAMEYTSA DVOECHELNAYA KLYUCHEVAYA;So;0;L;;;;;N;;;;;
1CF7D;ZNAMENNY NEUME SLOZHITIE;So;0;L;;;;;N;;;;;
1CF7E;ZNAMENNY NEUME SLOZHITIE S ZAPYATOY;So;0;L;;;;;N;;;;;
1CF7F;ZNAMENNY NEUME SLOZHITIE ZAKRYTOE;So;0;L;;;;;N;;;;;
1CF80;ZNAMENNY NEUME SLOZHITIE S KRYZHEM;So;0;L;;;;;N;;;;;
1CF81;ZNAMENNY NEUME KRYZH;So;0;L;;;;;N;;;;;
1CF82;ZNAMENNY NEUME ROG;So;0;L;;;;;N;;;;;
1CF83;ZNAMENNY NEUME FITA;So;0;L;;;;;N;;;;;
1CF84;ZNAMENNY NEUME KOBYLA;So;0;L;;;;;N;;;;;
1CF85;ZNAMENNY NEUME ZMEYTSA;So;0;L;;;;;N;;;;;
1CF86;ZNAMENNY NEUME STATYA;So;0;L;;;;;N;;;;;
1CF87;ZNAMENNY NEUME STATYA S ZAPYATOY;So;0;L;;;;;N;;;;;
1CF88;ZNAMENNY NEUME STATYA S KRYZHEM;So;0;L;;;;;N;;;;;
1CF89;ZNAMENNY NEUME STATYA S ZAPYATOY I KRYZHEM;So;0;L;;;;;N;;;;;
1CF8A;ZNAMENNY NEUME STATYA S KRYZHEM I ZAPYATOY;So;0;L;;;;;N;;;;;
1CF8B;ZNAMENNY NEUME STATYA ZAKRYTAYA;So;0;L;;;;;N;;;;;
1CF8C;ZNAMENNY NEUME STATYA ZAKRYTAYA S ZAPYATOY;So;0;L;;;;;N;;;;;
1CF8D;ZNAMENNY NEUME STATYA S ROGOM;So;0;L;;;;;N;;;;;
1CF8E;ZNAMENNY NEUME STATYA S DVUMYA ZAPYATYMI;So;0;L;;;;;N;;;;;
1CF8F;ZNAMENNY NEUME STATYA S ZAPYATOY I PODCHASHIEM;So;0;L;;;;;N;;;;;
1CF90;ZNAMENNY NEUME POLKULIZMY;So;0;L;;;;;N;;;;;
1CF91;ZNAMENNY NEUME STATYA NEPOSTOYANNAYA;So;0;L;;;;;N;;;;;
1CF92;ZNAMENNY NEUME STRELA PROSTAYA;So;0;L;;;;;N;;;;;
1CF93;ZNAMENNY NEUME STRELA MRACHNOTIKHAYA;So;0;L;;;;;N;;;;;
1CF94;ZNAMENNY NEUME STRELA KRYZHEVAYA;So;0;L;;;;;N;;;;;
1CF95;ZNAMENNY NEUME STRELA POLUPOVODNAYA;So;0;L;;;;;N;;;;;
1CF96;ZNAMENNY NEUME STRELA POVODNAYA;So;0;L;;;;;N;;;;;
1CF97;ZNAMENNY NEUME STRELA NEPOSTOYANNAYA;So;0;L;;;;;N;;;;;
1CF98;ZNAMENNY NEUME STRELA KLYUCHEPOVODNAYA;So;0;L;;;;;N;;;;;
1CF99;ZNAMENNY NEUME STRELA KLYUCHENEPOSTOYANNAYA;So;0;L;;;;;N;;;;;
1CF9A;ZNAMENNY NEUME STRELA TIKHAYA PUTNAYA;So;0;L;;;;;N;;;;;
1CF9B;ZNAMENNY NEUME STRELA DVOECHELNAYA;So;0;L;;;;;N;;;;;
1CF9C;ZNAMENNY NEUME STRELA DVOECHELNOKRYZHEVAYA;So;0;L;;;;;N;;;;;
1CF9D;ZNAMENNY NEUME STRELA DVOECHELNOPOVODNAYA;So;0;L;;;;;N;;;;;
1CF9E;ZNAMENNY NEUME STRELA DVOECHELNAYA KLYUCHEVAYA;So;0;L;;;;;N;;;;;
1CF9F;ZNAMENNY NEUME STRELA DVOECHELNOPOVODNAYA KLYUCHEVAYA;So;0;L;;;;;N;;;;;
1CFA0;ZNAMENNY NEUME STRELA GROMNAYA WITH SINGLE ZAPYATAYA;So;0;L;;;;;N;;;;;
1CFA1;ZNAMENNY NEUME STRELA GROMOPOVODNAYA WITH SINGLE ZAPYATAYA;So;0;L;;;;;N;;;;;
1CFA2;ZNAMENNY NEUME STRELA GROMNAYA;So;0;L;;;;;N;;;;;
1CFA3;ZNAMENNY NEUME STRELA GROMOPOVODNAYA;So;0;L;;;;;N;;;;;
1CFA4;ZNAMENNY NEUME STRELA GROMOPOVODNAYA WITH DOUBLE ZAPYATAYA;So;0;L;;;;;N;;;;;
1CFA5;ZNAMENNY NEUME STRELA GROMOKRYZHEVAYA;So;0;L;;;;;N;;;;;
1CFA6;ZNAMENNY NEUME STRELA GROMOKRYZHEVAYA POVODNAYA;So;0;L;;;;;N;;;;;
1CFA7;ZNAMENNY NEUME MECHIK;So;0;L;;;;;N;;;;;
1CFA8;ZNAMENNY NEUME MECHIK POVODNY;So;0;L;;;;;N;;;;;
1CFA9;ZNAMENNY NEUME MECHIK KLYUCHEVOY;So;0;L;;;;;N;;;;;
1CFAA;ZNAMENNY NEUME MECHIK KLYUCHEPOVODNY;So;0;L;;;;;N;;;;;
1CFAB;ZNAMENNY NEUME MECHIK KLYUCHENEPOSTOYANNY;So;0;L;;;;;N;;;;;
1CFAC;ZNAMENNY NEUME STRELA TRYASOGLASNAYA;So;0;L;;;;;N;;;;;
1CFAD;ZNAMENNY NEUME STRELA TRYASOPOVODNAYA;So;0;L;;;;;N;;;;;
1CFAE;ZNAMENNY NEUME STRELA TRYASOSTRELNAYA;So;0;L;;;;;N;;;;;
1CFAF;ZNAMENNY NEUME OSOKA;So;0;L;;;;;N;;;;;
1CFB0;ZNAMENNY NEUME OSOKA SVETLAYA;So;0;L;;;;;N;;;;;
1CFB1;ZNAMENNY NEUME OSOKA TRESVETLAYA;So;0;L;;;;;N;;;;;
1CFB2;ZNAMENNY NEUME OSOKA KRYUKOVAYA SVETLAYA;So;0;L;;;;;N;;;;;
1CFB3;ZNAMENNY NEUME OSOKA KLYUCHEVAYA SVETLAYA;So;0;L;;;;;N;;;;;
1CFB4;ZNAMENNY NEUME OSOKA KLYUCHEVAYA NEPOSTOYANNAYA;So;0;L;;;;;N;;;;;
1CFB5;ZNAMENNY NEUME STRELA KRYUKOVAYA;So;0;L;;;;;N;;;;;
1CFB6;ZNAMENNY NEUME STRELA KRYUKOVAYA POVODNAYA;So;0;L;;;;;N;;;;;
1CFB7;ZNAMENNY NEUME STRELA KRYUKOVAYA GROMNAYA WITH SINGLE ZAPYATAYA;So;0;L;;;;;N;;;;;
1CFB8;ZNAMENNY NEUME STRELA KRYUKOVAYA GROMOPOVODNAYA WITH SINGLE ZAPYATAYA;So;0;L;;;;;N;;;;;
1CFB9;ZNAMENNY NEUME STRELA KRYUKOVAYA GROMNAYA;So;0;L;;;;;N;;;;;
1CFBA;ZNAMENNY NEUME STRELA KRYUKOVAYA GROMOPOVODNAYA;So;0;L;;;;;N;;;;;
1CFBB;ZNAMENNY NEUME STRELA KRYUKOVAYA GROMOPOVODNAYA WITH DOUBLE ZAPYATAYA;So;0;L;;;;;N;;;;;
1CFBC;ZNAMENNY NEUME STRELA KRYUKOVAYA GROMOKRYZHEVAYA;So;0;L;;;;;N;;;;;
1CFBD;ZNAMENNY NEUME STRELA KRYUKOVAYA GROMOKRYZHEVAYA POVODNAYA;So;0;L;;;;;N;;;;;
1CFBE;ZNAMENNY NEUME STRELA KRYUKOVAYA TRYASKA;So;0;L;;;;;N;;;;;
1CFBF;ZNAMENNY NEUME KUFISMA;So;0;L;;;;;N;;;;;
1CFC0;ZNAMENNY NEUME OBLAKO;So;0;L;;;;;N;;;;;
1CFC1;ZNAMENNY NEUME DUDA;So;0;L;;;;;N;;;;;
1CFC2;ZNAMENNY NEUME NEMKA;So;0;L;;;;;N;;;;;
1CFC3;ZNAMENNY NEUME PAUK;So;0;L;;;;;N;;;;;
1D000;BYZANTINE MUSICAL SYMBOL PSILI;So;0;L;;;;;N;;;;;
1D001;BYZANTINE MUSICAL SYMBOL DASEIA;So;0;L;;;;;N;;;;;
1D002;BYZANTINE MUSICAL SYMBOL PERISPOMENI;So;0;L;;;;;N;;;;;
1D003;BYZANTINE MUSICAL SYMBOL OXEIA EKFONITIKON;So;0;L;;;;;N;;;;;
1D004;BYZANTINE MUSICAL SYMBOL OXEIA DIPLI;So;0;L;;;;;N;;;;;
1D005;BYZANTINE MUSICAL SYMBOL VAREIA EKFONITIKON;So;0;L;;;;;N;;;;;
1D006;BYZANTINE MUSICAL SYMBOL VAREIA DIPLI;So;0;L;;;;;N;;;;;
1D007;BYZANTINE MUSICAL SYMBOL KATHISTI;So;0;L;;;;;N;;;;;
1D008;BYZANTINE MUSICAL SYMBOL SYRMATIKI;So;0;L;;;;;N;;;;;
1D009;BYZANTINE MUSICAL SYMBOL PARAKLITIKI;So;0;L;;;;;N;;;;;
1D00A;BYZANTINE MUSICAL SYMBOL YPOKRISIS;So;0;L;;;;;N;;;;;
1D00B;BYZANTINE MUSICAL SYMBOL YPOKRISIS DIPLI;So;0;L;;;;;N;;;;;
1D00C;BYZANTINE MUSICAL SYMBOL KREMASTI;So;0;L;;;;;N;;;;;
1D00D;BYZANTINE MUSICAL SYMBOL APESO EKFONITIKON;So;0;L;;;;;N;;;;;
1D00E;BYZANTINE MUSICAL SYMBOL EXO EKFONITIKON;So;0;L;;;;;N;;;;;
1D00F;BYZANTINE MUSICAL SYMBOL TELEIA;So;0;L;;;;;N;;;;;
1D010;BYZANTINE MUSICAL SYMBOL KENTIMATA;So;0;L;;;;;N;;;;;
1D011;BYZANTINE MUSICAL SYMBOL APOSTROFOS;So;0;L;;;;;N;;;;;
1D012;BYZANTINE MUSICAL SYMBOL APOSTROFOS DIPLI;So;0;L;;;;;N;;;;;
1D013;BYZANTINE MUSICAL SYMBOL SYNEVMA;So;0;L;;;;;N;;;;;
1D014;BYZANTINE MUSICAL SYMBOL THITA;So;0;L;;;;;N;;;;;
1D015;BYZANTINE MUSICAL SYMBOL OLIGON ARCHAION;So;0;L;;;;;N;;;;;
1D016;BYZANTINE MUSICAL SYMBOL GORGON ARCHAION;So;0;L;;;;;N;;;;;
1D017;BYZANTINE MUSICAL SYMBOL PSILON;So;0;L;;;;;N;;;;;
1D018;BYZANTINE MUSICAL SYMBOL CHAMILON;So;0;L;;;;;N;;;;;
1D019;BYZANTINE MUSICAL SYMBOL VATHY;So;0;L;;;;;N;;;;;
1D01A;BYZANTINE MUSICAL SYMBOL ISON ARCHAION;So;0;L;;;;;N;;;;;
1D01B;BYZANTINE MUSICAL SYMBOL KENTIMA ARCHAION;So;0;L;;;;;N;;;;;
1D01C;BYZANTINE MUSICAL SYMBOL KENTIMATA ARCHAION;So;0;L;;;;;N;;;;;
1D01D;BYZANTINE MUSICAL SYMBOL SAXIMATA;So;0;L;;;;;N;;;;;
1D01E;BYZANTINE MUSICAL SYMBOL PARICHON;So;0;L;;;;;N;;;;;
1D01F;BYZANTINE MUSICAL SYMBOL STAVROS APODEXIA;So;0;L;;;;;N;;;;;
1D020;BYZANTINE MUSICAL SYMBOL OXEIAI ARCHAION;So;0;L;;;;;N;;;;;
1D021;BYZANTINE MUSICAL SYMBOL VAREIAI ARCHAION;So;0;L;;;;;N;;;;;
1D022;BYZANTINE MUSICAL SYMBOL APODERMA ARCHAION;So;0;L;;;;;N;;;;;
1D023;BYZANTINE MUSICAL SYMBOL APOTHEMA;So;0;L;;;;;N;;;;;
1D024;BYZANTINE MUSICAL SYMBOL KLASMA;So;0;L;;;;;N;;;;;
1D025;BYZANTINE MUSICAL SYMBOL REVMA;So;0;L;;;;;N;;;;;
1D026;BYZANTINE MUSICAL SYMBOL PIASMA ARCHAION;So;0;L;;;;;N;;;;;
1D027;BYZANTINE MUSICAL SYMBOL TINAGMA;So;0;L;;;;;N;;;;;
1D028;BYZANTINE MUSICAL SYMBOL ANATRICHISMA;So;0;L;;;;;N;;;;;
1D029;BYZANTINE MUSICAL SYMBOL SEISMA;So;0;L;;;;;N;;;;;
1D02A;BYZANTINE MUSICAL SYMBOL SYNAGMA ARCHAION;So;0;L;;;;;N;;;;;
1D02B;BYZANTINE MUSICAL SYMBOL SYNAGMA META STAVROU;So;0;L;;;;;N;;;;;
1D02C;BYZANTINE MUSICAL SYMBOL OYRANISMA ARCHAION;So;0;L;;;;;N;;;;;
1D02D;BYZANTINE MUSICAL SYMBOL THEMA;So;0;L;;;;;N;;;;;
1D02E;BYZANTINE MUSICAL SYMBOL LEMOI;So;0;L;;;;;N;;;;;
1D02F;BYZANTINE MUSICAL SYMBOL DYO;So;0;L;;;;;N;;;;;
1D030;BYZANTINE MUSICAL SYMBOL TRIA;So;0;L;;;;;N;;;;;
1D031;BYZANTINE MUSICAL SYMBOL TESSERA;So;0;L;;;;;N;;;;;
1D032;BYZANTINE MUSICAL SYMBOL KRATIMATA;So;0;L;;;;;N;;;;;
1D033;BYZANTINE MUSICAL SYMBOL APESO EXO NEO;So;0;L;;;;;N;;;;;
1D034;BYZANTINE MUSICAL SYMBOL FTHORA ARCHAION;So;0;L;;;;;N;;;;;
1D035;BYZANTINE MUSICAL SYMBOL IMIFTHORA;So;0;L;;;;;N;;;;;
1D036;BYZANTINE MUSICAL SYMBOL TROMIKON ARCHAION;So;0;L;;;;;N;;;;;
1D037;BYZANTINE MUSICAL SYMBOL KATAVA TROMIKON;So;0;L;;;;;N;;;;;
1D038;BYZANTINE MUSICAL SYMBOL PELASTON;So;0;L;;;;;N;;;;;
1D039;BYZANTINE MUSICAL SYMBOL PSIFISTON;So;0;L;;;;;N;;;;;
1D03A;BYZANTINE MUSICAL SYMBOL KONTEVMA;So;0;L;;;;;N;;;;;
1D03B;BYZANTINE MUSICAL SYMBOL CHOREVMA ARCHAION;So;0;L;;;;;N;;;;;
1D03C;BYZANTINE MUSICAL SYMBOL RAPISMA;So;0;L;;;;;N;;;;;
1D03D;BYZANTINE MUSICAL SYMBOL PARAKALESMA ARCHAION;So;0;L;;;;;N;;;;;
1D03E;BYZANTINE MUSICAL SYMBOL PARAKLITIKI ARCHAION;So;0;L;;;;;N;;;;;
1D03F;BYZANTINE MUSICAL SYMBOL ICHADIN;So;0;L;;;;;N;;;;;
1D040;BYZANTINE MUSICAL SYMBOL NANA;So;0;L;;;;;N;;;;;
1D041;BYZANTINE MUSICAL SYMBOL PETASMA;So;0;L;;;;;N;;;;;
1D042;BYZANTINE MUSICAL SYMBOL KONTEVMA ALLO;So;0;L;;;;;N;;;;;
1D043;BYZANTINE MUSICAL SYMBOL TROMIKON ALLO;So;0;L;;;;;N;;;;;
1D044;BYZANTINE MUSICAL SYMBOL STRAGGISMATA;So;0;L;;;;;N;;;;;
1D045;BYZANTINE MUSICAL SYMBOL GRONTHISMATA;So;0;L;;;;;N;;;;;
1D046;BYZANTINE MUSICAL SYMBOL ISON NEO;So;0;L;;;;;N;;;;;
1D047;BYZANTINE MUSICAL SYMBOL OLIGON NEO;So;0;L;;;;;N;;;;;
1D048;BYZANTINE MUSICAL SYMBOL OXEIA NEO;So;0;L;;;;;N;;;;;
1D049;BYZANTINE MUSICAL SYMBOL PETASTI;So;0;L;;;;;N;;;;;
1D04A;BYZANTINE MUSICAL SYMBOL KOUFISMA;So;0;L;;;;;N;;;;;
1D04B;BYZANTINE MUSICAL SYMBOL PETASTOKOUFISMA;So;0;L;;;;;N;;;;;
1D04C;BYZANTINE MUSICAL SYMBOL KRATIMOKOUFISMA;So;0;L;;;;;N;;;;;
1D04D;BYZANTINE MUSICAL SYMBOL PELASTON NEO;So;0;L;;;;;N;;;;;
1D04E;BYZANTINE MUSICAL SYMBOL KENTIMATA NEO ANO;So;0;L;;;;;N;;;;;
1D04F;BYZANTINE MUSICAL SYMBOL KENTIMA NEO ANO;So;0;L;;;;;N;;;;;
1D050;BYZANTINE MUSICAL SYMBOL YPSILI;So;0;L;;;;;N;;;;;
1D051;BYZANTINE MUSICAL SYMBOL APOSTROFOS NEO;So;0;L;;;;;N;;;;;
1D052;BYZANTINE MUSICAL SYMBOL APOSTROFOI SYNDESMOS NEO;So;0;L;;;;;N;;;;;
1D053;BYZANTINE MUSICAL SYMBOL YPORROI;So;0;L;;;;;N;;;;;
1D054;BYZANTINE MUSICAL SYMBOL KRATIMOYPORROON;So;0;L;;;;;N;;;;;
1D055;BYZANTINE MUSICAL SYMBOL ELAFRON;So;0;L;;;;;N;;;;;
1D056;BYZANTINE MUSICAL SYMBOL CHAMILI;So;0;L;;;;;N;;;;;
1D057;BYZANTINE MUSICAL SYMBOL MIKRON ISON;So;0;L;;;;;N;;;;;
1D058;BYZANTINE MUSICAL SYMBOL VAREIA NEO;So;0;L;;;;;N;;;;;
1D059;BYZANTINE MUSICAL SYMBOL PIASMA NEO;So;0;L;;;;;N;;;;;
1D05A;BYZANTINE MUSICAL SYMBOL PSIFISTON NEO;So;0;L;;;;;N;;;;;
1D05B;BYZANTINE MUSICAL SYMBOL OMALON;So;0;L;;;;;N;;;;;
1D05C;BYZANTINE MUSICAL SYMBOL ANTIKENOMA;So;0;L;;;;;N;;;;;
1D05D;BYZANTINE MUSICAL SYMBOL LYGISMA;So;0;L;;;;;N;;;;;
1D05E;BYZANTINE MUSICAL SYMBOL PARAKLITIKI NEO;So;0;L;;;;;N;;;;;
1D05F;BYZANTINE MUSICAL SYMBOL PARAKALESMA NEO;So;0;L;;;;;N;;;;;
1D060;BYZANTINE MUSICAL SYMBOL ETERON PARAKALESMA;So;0;L;;;;;N;;;;;
1D061;BYZANTINE MUSICAL SYMBOL KYLISMA;So;0;L;;;;;N;;;;;
1D062;BYZANTINE MUSICAL SYMBOL ANTIKENOKYLISMA;So;0;L;;;;;N;;;;;
1D063;BYZANTINE MUSICAL SYMBOL TROMIKON NEO;So;0;L;;;;;N;;;;;
1D064;BYZANTINE MUSICAL SYMBOL EKSTREPTON;So;0;L;;;;;N;;;;;
1D065;BYZANTINE MUSICAL SYMBOL SYNAGMA NEO;So;0;L;;;;;N;;;;;
1D066;BYZANTINE MUSICAL SYMBOL SYRMA;So;0;L;;;;;N;;;;;
1D067;BYZANTINE MUSICAL SYMBOL CHOREVMA NEO;So;0;L;;;;;N;;;;;
1D068;BYZANTINE MUSICAL SYMBOL EPEGERMA;So;0;L;;;;;N;;;;;
1D069;BYZANTINE MUSICAL SYMBOL SEISMA NEO;So;0;L;;;;;N;;;;;
1D06A;BYZANTINE MUSICAL SYMBOL XIRON KLASMA;So;0;L;;;;;N;;;;;
1D06B;BYZANTINE MUSICAL SYMBOL TROMIKOPSIFISTON;So;0;L;;;;;N;;;;;
1D06C;BYZANTINE MUSICAL SYMBOL PSIFISTOLYGISMA;So;0;L;;;;;N;;;;;
1D06D;BYZANTINE MUSICAL SYMBOL TROMIKOLYGISMA;So;0;L;;;;;N;;;;;
1D06E;BYZANTINE MUSICAL SYMBOL TROMIKOPARAKALESMA;So;0;L;;;;;N;;;;;
1D06F;BYZANTINE MUSICAL SYMBOL PSIFISTOPARAKALESMA;So;0;L;;;;;N;;;;;
1D070;BYZANTINE MUSICAL SYMBOL TROMIKOSYNAGMA;So;0;L;;;;;N;;;;;
1D071;BYZANTINE MUSICAL SYMBOL PSIFISTOSYNAGMA;So;0;L;;;;;N;;;;;
1D072;BYZANTINE MUSICAL SYMBOL GORGOSYNTHETON;So;0;L;;;;;N;;;;;
1D073;BYZANTINE MUSICAL SYMBOL ARGOSYNTHETON;So;0;L;;;;;N;;;;;
1D074;BYZANTINE MUSICAL SYMBOL ETERON ARGOSYNTHETON;So;0;L;;;;;N;;;;;
1D075;BYZANTINE MUSICAL SYMBOL OYRANISMA NEO;So;0;L;;;;;N;;;;;
1D076;BYZANTINE MUSICAL SYMBOL THEMATISMOS ESO;So;0;L;;;;;N;;;;;
1D077;BYZANTINE MUSICAL SYMBOL THEMATISMOS EXO;So;0;L;;;;;N;;;;;
1D078;BYZANTINE MUSICAL SYMBOL THEMA APLOUN;So;0;L;;;;;N;;;;;
1D079;BYZANTINE MUSICAL SYMBOL THES KAI APOTHES;So;0;L;;;;;N;;;;;
1D07A;BYZANTINE MUSICAL SYMBOL KATAVASMA;So;0;L;;;;;N;;;;;
1D07B;BYZANTINE MUSICAL SYMBOL ENDOFONON;So;0;L;;;;;N;;;;;
1D07C;BYZANTINE MUSICAL SYMBOL YFEN KATO;So;0;L;;;;;N;;;;;
1D07D;BYZANTINE MUSICAL SYMBOL YFEN ANO;So;0;L;;;;;N;;;;;
1D07E;BYZANTINE MUSICAL SYMBOL STAVROS;So;0;L;;;;;N;;;;;
1D07F;BYZANTINE MUSICAL SYMBOL KLASMA ANO;So;0;L;;;;;N;;;;;
1D080;BYZANTINE MUSICAL SYMBOL DIPLI ARCHAION;So;0;L;;;;;N;;;;;
1D081;BYZANTINE MUSICAL SYMBOL KRATIMA ARCHAION;So;0;L;;;;;N;;;;;
1D082;BYZANTINE MUSICAL SYMBOL KRATIMA ALLO;So;0;L;;;;;N;;;;;
1D083;BYZANTINE MUSICAL SYMBOL KRATIMA NEO;So;0;L;;;;;N;;;;;
1D084;BYZANTINE MUSICAL SYMBOL APODERMA NEO;So;0;L;;;;;N;;;;;
1D085;BYZANTINE MUSICAL SYMBOL APLI;So;0;L;;;;;N;;;;;
1D086;BYZANTINE MUSICAL SYMBOL DIPLI;So;0;L;;;;;N;;;;;
1D087;BYZANTINE MUSICAL SYMBOL TRIPLI;So;0;L;;;;;N;;;;;
1D088;BYZANTINE MUSICAL SYMBOL TETRAPLI;So;0;L;;;;;N;;;;;
1D089;BYZANTINE MUSICAL SYMBOL KORONIS;So;0;L;;;;;N;;;;;
1D08A;BYZANTINE MUSICAL SYMBOL LEIMMA ENOS CHRONOU;So;0;L;;;;;N;;;;;
1D08B;BYZANTINE MUSICAL SYMBOL LEIMMA DYO CHRONON;So;0;L;;;;;N;;;;;
1D08C;BYZANTINE MUSICAL SYMBOL LEIMMA TRION CHRONON;So;0;L;;;;;N;;;;;
1D08D;BYZANTINE MUSICAL SYMBOL LEIMMA TESSARON CHRONON;So;0;L;;;;;N;;;;;
1D08E;BYZANTINE MUSICAL SYMBOL LEIMMA IMISEOS CHRONOU;So;0;L;;;;;N;;;;;
1D08F;BYZANTINE MUSICAL SYMBOL GORGON NEO ANO;So;0;L;;;;;N;;;;;
1D090;BYZANTINE MUSICAL SYMBOL GORGON PARESTIGMENON ARISTERA;So;0;L;;;;;N;;;;;
1D091;BYZANTINE MUSICAL SYMBOL GORGON PARESTIGMENON DEXIA;So;0;L;;;;;N;;;;;
1D092;BYZANTINE MUSICAL SYMBOL DIGORGON;So;0;L;;;;;N;;;;;
1D093;BYZANTINE MUSICAL SYMBOL DIGORGON PARESTIGMENON ARISTERA KATO;So;0;L;;;;;N;;;;;
1D094;BYZANTINE MUSICAL SYMBOL DIGORGON PARESTIGMENON ARISTERA ANO;So;0;L;;;;;N;;;;;
1D095;BYZANTINE MUSICAL SYMBOL DIGORGON PARESTIGMENON DEXIA;So;0;L;;;;;N;;;;;
1D096;BYZANTINE MUSICAL SYMBOL TRIGORGON;So;0;L;;;;;N;;;;;
1D097;BYZANTINE MUSICAL SYMBOL ARGON;So;0;L;;;;;N;;;;;
1D098;BYZANTINE MUSICAL SYMBOL IMIDIARGON;So;0;L;;;;;N;;;;;
1D099;BYZANTINE MUSICAL SYMBOL DIARGON;So;0;L;;;;;N;;;;;
1D09A;BYZANTINE MUSICAL SYMBOL AGOGI POLI ARGI;So;0;L;;;;;N;;;;;
1D09B;BYZANTINE MUSICAL SYMBOL AGOGI ARGOTERI;So;0;L;;;;;N;;;;;
1D09C;BYZANTINE MUSICAL SYMBOL AGOGI ARGI;So;0;L;;;;;N;;;;;
1D09D;BYZANTINE MUSICAL SYMBOL AGOGI METRIA;So;0;L;;;;;N;;;;;
1D09E;BYZANTINE MUSICAL SYMBOL AGOGI MESI;So;0;L;;;;;N;;;;;
1D09F;BYZANTINE MUSICAL SYMBOL AGOGI GORGI;So;0;L;;;;;N;;;;;
1D0A0;BYZANTINE MUSICAL SYMBOL AGOGI GORGOTERI;So;0;L;;;;;N;;;;;
1D0A1;BYZANTINE MUSICAL SYMBOL AGOGI POLI GORGI;So;0;L;;;;;N;;;;;
1D0A2;BYZANTINE MUSICAL SYMBOL MARTYRIA PROTOS ICHOS;So;0;L;;;;;N;;;;;
1D0A3;BYZANTINE MUSICAL SYMBOL MARTYRIA ALLI PROTOS ICHOS;So;0;L;;;;;N;;;;;
1D0A4;BYZANTINE MUSICAL SYMBOL MARTYRIA DEYTEROS ICHOS;So;0;L;;;;;N;;;;;
1D0A5;BYZANTINE MUSICAL SYMBOL MARTYRIA ALLI DEYTEROS ICHOS;So;0;L;;;;;N;;;;;
1D0A6;BYZANTINE MUSICAL SYMBOL MARTYRIA TRITOS ICHOS;So;0;L;;;;;N;;;;;
1D0A7;BYZANTINE MUSICAL SYMBOL MARTYRIA TRIFONIAS;So;0;L;;;;;N;;;;;
1D0A8;BYZANTINE MUSICAL SYMBOL MARTYRIA TETARTOS ICHOS;So;0;L;;;;;N;;;;;
1D0A9;BYZANTINE MUSICAL SYMBOL MARTYRIA TETARTOS LEGETOS ICHOS;So;0;L;;;;;N;;;;;
1D0AA;BYZANTINE MUSICAL SYMBOL MARTYRIA LEGETOS ICHOS;So;0;L;;;;;N;;;;;
1D0AB;BYZANTINE MUSICAL SYMBOL MARTYRIA PLAGIOS ICHOS;So;0;L;;;;;N;;;;;
1D0AC;BYZANTINE MUSICAL SYMBOL ISAKIA TELOUS ICHIMATOS;So;0;L;;;;;N;;;;;
1D0AD;BYZANTINE MUSICAL SYMBOL APOSTROFOI TELOUS ICHIMATOS;So;0;L;;;;;N;;;;;
1D0AE;BYZANTINE MUSICAL SYMBOL FANEROSIS TETRAFONIAS;So;0;L;;;;;N;;;;;
1D0AF;BYZANTINE MUSICAL SYMBOL FANEROSIS MONOFONIAS;So;0;L;;;;;N;;;;;
1D0B0;BYZANTINE MUSICAL SYMBOL FANEROSIS DIFONIAS;So;0;L;;;;;N;;;;;
1D0B1;BYZANTINE MUSICAL SYMBOL MARTYRIA VARYS ICHOS;So;0;L;;;;;N;;;;;
1D0B2;BYZANTINE MUSICAL SYMBOL MARTYRIA PROTOVARYS ICHOS;So;0;L;;;;;N;;;;;
1D0B3;BYZANTINE MUSICAL SYMBOL MARTYRIA PLAGIOS TETARTOS ICHOS;So;0;L;;;;;N;;;;;
1D0B4;BYZANTINE MUSICAL SYMBOL GORTHMIKON N APLOUN;So;0;L;;;;;N;;;;;
1D0B5;BYZANTINE MUSICAL SYMBOL GORTHMIKON N DIPLOUN;So;0;L;;;;;N;;;;;
1D0B6;BYZANTINE MUSICAL SYMBOL ENARXIS KAI FTHORA VOU;So;0;L;;;;;N;;;;;
1D0B7;BYZANTINE MUSICAL SYMBOL IMIFONON;So;0;L;;;;;N;;;;;
1D0B8;BYZANTINE MUSICAL SYMBOL IMIFTHORON;So;0;L;;;;;N;;;;;
1D0B9;BYZANTINE MUSICAL SYMBOL FTHORA ARCHAION DEYTEROU ICHOU;So;0;L;;;;;N;;;;;
1D0BA;BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI PA;So;0;L;;;;;N;;;;;
1D0BB;BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI NANA;So;0;L;;;;;N;;;;;
1D0BC;BYZANTINE MUSICAL SYMBOL FTHORA NAOS ICHOS;So;0;L;;;;;N;;;;;
1D0BD;BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI DI;So;0;L;;;;;N;;;;;
1D0BE;BYZANTINE MUSICAL SYMBOL FTHORA SKLIRON DIATONON DI;So;0;L;;;;;N;;;;;
1D0BF;BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI KE;So;0;L;;;;;N;;;;;
1D0C0;BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI ZO;So;0;L;;;;;N;;;;;
1D0C1;BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI NI KATO;So;0;L;;;;;N;;;;;
1D0C2;BYZANTINE MUSICAL SYMBOL FTHORA DIATONIKI NI ANO;So;0;L;;;;;N;;;;;
1D0C3;BYZANTINE MUSICAL SYMBOL FTHORA MALAKON CHROMA DIFONIAS;So;0;L;;;;;N;;;;;
1D0C4;BYZANTINE MUSICAL SYMBOL FTHORA MALAKON CHROMA MONOFONIAS;So;0;L;;;;;N;;;;;
1D0C5;BYZANTINE MUSICAL SYMBOL FHTORA SKLIRON CHROMA VASIS;So;0;L;;;;;N;;;;;
1D0C6;BYZANTINE MUSICAL SYMBOL FTHORA SKLIRON CHROMA SYNAFI;So;0;L;;;;;N;;;;;
1D0C7;BYZANTINE MUSICAL SYMBOL FTHORA NENANO;So;0;L;;;;;N;;;;;
1D0C8;BYZANTINE MUSICAL SYMBOL CHROA ZYGOS;So;0;L;;;;;N;;;;;
1D0C9;BYZANTINE MUSICAL SYMBOL CHROA KLITON;So;0;L;;;;;N;;;;;
1D0CA;BYZANTINE MUSICAL SYMBOL CHROA SPATHI;So;0;L;;;;;N;;;;;
1D0CB;BYZANTINE MUSICAL SYMBOL FTHORA I YFESIS TETARTIMORION;So;0;L;;;;;N;;;;;
1D0CC;BYZANTINE MUSICAL SYMBOL FTHORA ENARMONIOS ANTIFONIA;So;0;L;;;;;N;;;;;
1D0CD;BYZANTINE MUSICAL SYMBOL YFESIS TRITIMORION;So;0;L;;;;;N;;;;;
1D0CE;BYZANTINE MUSICAL SYMBOL DIESIS TRITIMORION;So;0;L;;;;;N;;;;;
1D0CF;BYZANTINE MUSICAL SYMBOL DIESIS TETARTIMORION;So;0;L;;;;;N;;;;;
1D0D0;BYZANTINE MUSICAL SYMBOL DIESIS APLI DYO DODEKATA;So;0;L;;;;;N;;;;;
1D0D1;BYZANTINE MUSICAL SYMBOL DIESIS MONOGRAMMOS TESSERA DODEKATA;So;0;L;;;;;N;;;;;
1D0D2;BYZANTINE MUSICAL SYMBOL DIESIS DIGRAMMOS EX DODEKATA;So;0;L;;;;;N;;;;;
1D0D3;BYZANTINE MUSICAL SYMBOL DIESIS TRIGRAMMOS OKTO DODEKATA;So;0;L;;;;;N;;;;;
1D0D4;BYZANTINE MUSICAL SYMBOL YFESIS APLI DYO DODEKATA;So;0;L;;;;;N;;;;;
1D0D5;BYZANTINE MUSICAL SYMBOL YFESIS MONOGRAMMOS TESSERA DODEKATA;So;0;L;;;;;N;;;;;
1D0D6;BYZANTINE MUSICAL SYMBOL YFESIS DIGRAMMOS EX DODEKATA;So;0;L;;;;;N;;;;;
1D0D7;BYZANTINE MUSICAL SYMBOL YFESIS TRIGRAMMOS OKTO DODEKATA;So;0;L;;;;;N;;;;;
1D0D8;BYZANTINE MUSICAL SYMBOL GENIKI DIESIS;So;0;L;;;;;N;;;;;
1D0D9;BYZANTINE MUSICAL SYMBOL GENIKI YFESIS;So;0;L;;;;;N;;;;;
1D0DA;BYZANTINE MUSICAL SYMBOL DIASTOLI APLI MIKRI;So;0;L;;;;;N;;;;;
1D0DB;BYZANTINE MUSICAL SYMBOL DIASTOLI APLI MEGALI;So;0;L;;;;;N;;;;;
1D0DC;BYZANTINE MUSICAL SYMBOL DIASTOLI DIPLI;So;0;L;;;;;N;;;;;
1D0DD;BYZANTINE MUSICAL SYMBOL DIASTOLI THESEOS;So;0;L;;;;;N;;;;;
1D0DE;BYZANTINE MUSICAL SYMBOL SIMANSIS THESEOS;So;0;L;;;;;N;;;;;
1D0DF;BYZANTINE MUSICAL SYMBOL SIMANSIS THESEOS DISIMOU;So;0;L;;;;;N;;;;;
1D0E0;BYZANTINE MUSICAL SYMBOL SIMANSIS THESEOS TRISIMOU;So;0;L;;;;;N;;;;;
1D0E1;BYZANTINE MUSICAL SYMBOL SIMANSIS THESEOS TETRASIMOU;So;0;L;;;;;N;;;;;
1D0E2;BYZANTINE MUSICAL SYMBOL SIMANSIS ARSEOS;So;0;L;;;;;N;;;;;
1D0E3;BYZANTINE MUSICAL SYMBOL SIMANSIS ARSEOS DISIMOU;So;0;L;;;;;N;;;;;
1D0E4;BYZANTINE MUSICAL SYMBOL SIMANSIS ARSEOS TRISIMOU;So;0;L;;;;;N;;;;;
1D0E5;BYZANTINE MUSICAL SYMBOL SIMANSIS ARSEOS TETRASIMOU;So;0;L;;;;;N;;;;;
1D0E6;BYZANTINE MUSICAL SYMBOL DIGRAMMA GG;So;0;L;;;;;N;;;;;
1D0E7;BYZANTINE MUSICAL SYMBOL DIFTOGGOS OU;So;0;L;;;;;N;;;;;
1D0E8;BYZANTINE MUSICAL SYMBOL STIGMA;So;0;L;;;;;N;;;;;
1D0E9;BYZANTINE MUSICAL SYMBOL ARKTIKO PA;So;0;L;;;;;N;;;;;
1D0EA;BYZANTINE MUSICAL SYMBOL ARKTIKO VOU;So;0;L;;;;;N;;;;;
1D0EB;BYZANTINE MUSICAL SYMBOL ARKTIKO GA;So;0;L;;;;;N;;;;;
1D0EC;BYZANTINE MUSICAL SYMBOL ARKTIKO DI;So;0;L;;;;;N;;;;;
1D0ED;BYZANTINE MUSICAL SYMBOL ARKTIKO KE;So;0;L;;;;;N;;;;;
1D0EE;BYZANTINE MUSICAL SYMBOL ARKTIKO ZO;So;0;L;;;;;N;;;;;
1D0EF;BYZANTINE MUSICAL SYMBOL ARKTIKO NI;So;0;L;;;;;N;;;;;
1D0F0;BYZANTINE MUSICAL SYMBOL KENTIMATA NEO MESO;So;0;L;;;;;N;;;;;
1D0F1;BYZANTINE MUSICAL SYMBOL KENTIMA NEO MESO;So;0;L;;;;;N;;;;;
1D0F2;BYZANTINE MUSICAL SYMBOL KENTIMATA NEO KATO;So;0;L;;;;;N;;;;;
1D0F3;BYZANTINE MUSICAL SYMBOL KENTIMA NEO KATO;So;0;L;;;;;N;;;;;
1D0F4;BYZANTINE MUSICAL SYMBOL KLASMA KATO;So;0;L;;;;;N;;;;;
1D0F5;BYZANTINE MUSICAL SYMBOL GORGON NEO KATO;So;0;L;;;;;N;;;;;
1D100;MUSICAL SYMBOL SINGLE BARLINE;So;0;L;;;;;N;;;;;
1D101;MUSICAL SYMBOL DOUBLE BARLINE;So;0;L;;;;;N;;;;;
1D102;MUSICAL SYMBOL FINAL BARLINE;So;0;L;;;;;N;;;;;
1D103;MUSICAL SYMBOL REVERSE FINAL BARLINE;So;0;L;;;;;N;;;;;
1D104;MUSICAL SYMBOL DASHED BARLINE;So;0;L;;;;;N;;;;;
1D105;MUSICAL SYMBOL SHORT BARLINE;So;0;L;;;;;N;;;;;
1D106;MUSICAL SYMBOL LEFT REPEAT SIGN;So;0;L;;;;;N;;;;;
1D107;MUSICAL SYMBOL RIGHT REPEAT SIGN;So;0;L;;;;;N;;;;;
1D108;MUSICAL SYMBOL REPEAT DOTS;So;0;L;;;;;N;;;;;
1D109;MUSICAL SYMBOL DAL SEGNO;So;0;L;;;;;N;;;;;
1D10A;MUSICAL SYMBOL DA CAPO;So;0;L;;;;;N;;;;;
1D10B;MUSICAL SYMBOL SEGNO;So;0;L;;;;;N;;;;;
1D10C;MUSICAL SYMBOL CODA;So;0;L;;;;;N;;;;;
1D10D;MUSICAL SYMBOL REPEATED FIGURE-1;So;0;L;;;;;N;;;;;
1D10E;MUSICAL SYMBOL REPEATED FIGURE-2;So;0;L;;;;;N;;;;;
1D10F;MUSICAL SYMBOL REPEATED FIGURE-3;So;0;L;;;;;N;;;;;
1D110;MUSICAL SYMBOL FERMATA;So;0;L;;;;;N;;;;;
1D111;MUSICAL SYMBOL FERMATA BELOW;So;0;L;;;;;N;;;;;
1D112;MUSICAL SYMBOL BREATH MARK;So;0;L;;;;;N;;;;;
1D113;MUSICAL SYMBOL CAESURA;So;0;L;;;;;N;;;;;
1D114;MUSICAL SYMBOL BRACE;So;0;L;;;;;N;;;;;
1D115;MUSICAL SYMBOL BRACKET;So;0;L;;;;;N;;;;;
1D116;MUSICAL SYMBOL ONE-LINE STAFF;So;0;L;;;;;N;;;;;
1D117;MUSICAL SYMBOL TWO-LINE STAFF;So;0;L;;;;;N;;;;;
1D118;MUSICAL SYMBOL THREE-LINE STAFF;So;0;L;;;;;N;;;;;
1D119;MUSICAL SYMBOL FOUR-LINE STAFF;So;0;L;;;;;N;;;;;
1D11A;MUSICAL SYMBOL FIVE-LINE STAFF;So;0;L;;;;;N;;;;;
1D11B;MUSICAL SYMBOL SIX-LINE STAFF;So;0;L;;;;;N;;;;;
1D11C;MUSICAL SYMBOL SIX-STRING FRETBOARD;So;0;L;;;;;N;;;;;
1D11D;MUSICAL SYMBOL FOUR-STRING FRETBOARD;So;0;L;;;;;N;;;;;
1D11E;MUSICAL SYMBOL G CLEF;So;0;L;;;;;N;;;;;
1D11F;MUSICAL SYMBOL G CLEF OTTAVA ALTA;So;0;L;;;;;N;;;;;
1D120;MUSICAL SYMBOL G CLEF OTTAVA BASSA;So;0;L;;;;;N;;;;;
1D121;MUSICAL SYMBOL C CLEF;So;0;L;;;;;N;;;;;
1D122;MUSICAL SYMBOL F CLEF;So;0;L;;;;;N;;;;;
1D123;MUSICAL SYMBOL F CLEF OTTAVA ALTA;So;0;L;;;;;N;;;;;
1D124;MUSICAL SYMBOL F CLEF OTTAVA BASSA;So;0;L;;;;;N;;;;;
1D125;MUSICAL SYMBOL DRUM CLEF-1;So;0;L;;;;;N;;;;;
1D126;MUSICAL SYMBOL DRUM CLEF-2;So;0;L;;;;;N;;;;;
1D129;MUSICAL SYMBOL MULTIPLE MEASURE REST;So;0;L;;;;;N;;;;;
1D12A;MUSICAL SYMBOL DOUBLE SHARP;So;0;L;;;;;N;;;;;
1D12B;MUSICAL SYMBOL DOUBLE FLAT;So;0;L;;;;;N;;;;;
1D12C;MUSICAL SYMBOL FLAT UP;So;0;L;;;;;N;;;;;
1D12D;MUSICAL SYMBOL FLAT DOWN;So;0;L;;;;;N;;;;;
1D12E;MUSICAL SYMBOL NATURAL UP;So;0;L;;;;;N;;;;;
1D12F;MUSICAL SYMBOL NATURAL DOWN;So;0;L;;;;;N;;;;;
1D130;MUSICAL SYMBOL SHARP UP;So;0;L;;;;;N;;;;;
1D131;MUSICAL SYMBOL SHARP DOWN;So;0;L;;;;;N;;;;;
1D132;MUSICAL SYMBOL QUARTER TONE SHARP;So;0;L;;;;;N;;;;;
1D133;MUSICAL SYMBOL QUARTER TONE FLAT;So;0;L;;;;;N;;;;;
1D134;MUSICAL SYMBOL COMMON TIME;So;0;L;;;;;N;;;;;
1D135;MUSICAL SYMBOL CUT TIME;So;0;L;;;;;N;;;;;
1D136;MUSICAL SYMBOL OTTAVA ALTA;So;0;L;;;;;N;;;;;
1D137;MUSICAL SYMBOL OTTAVA BASSA;So;0;L;;;;;N;;;;;
1D138;MUSICAL SYMBOL QUINDICESIMA ALTA;So;0;L;;;;;N;;;;;
1D139;MUSICAL SYMBOL QUINDICESIMA BASSA;So;0;L;;;;;N;;;;;
1D13A;MUSICAL SYMBOL MULTI REST;So;0;L;;;;;N;;;;;
1D13B;MUSICAL SYMBOL WHOLE REST;So;0;L;;;;;N;;;;;
1D13C;MUSICAL SYMBOL HALF REST;So;0;L;;;;;N;;;;;
1D13D;MUSICAL SYMBOL QUARTER REST;So;0;L;;;;;N;;;;;
1D13E;MUSICAL SYMBOL EIGHTH REST;So;0;L;;;;;N;;;;;
1D13F;MUSICAL SYMBOL SIXTEENTH REST;So;0;L;;;;;N;;;;;
1D140;MUSICAL SYMBOL THIRTY-SECOND REST;So;0;L;;;;;N;;;;;
1D141;MUSICAL SYMBOL SIXTY-FOURTH REST;So;0;L;;;;;N;;;;;
1D142;MUSICAL SYMBOL ONE HUNDRED TWENTY-EIGHTH REST;So;0;L;;;;;N;;;;;
1D143;MUSICAL SYMBOL X NOTEHEAD;So;0;L;;;;;N;;;;;
1D144;MUSICAL SYMBOL PLUS NOTEHEAD;So;0;L;;;;;N;;;;;
1D145;MUSICAL SYMBOL CIRCLE X NOTEHEAD;So;0;L;;;;;N;;;;;
1D146;MUSICAL SYMBOL SQUARE NOTEHEAD WHITE;So;0;L;;;;;N;;;;;
1D147;MUSICAL SYMBOL SQUARE NOTEHEAD BLACK;So;0;L;;;;;N;;;;;
1D148;MUSICAL SYMBOL TRIANGLE NOTEHEAD UP WHITE;So;0;L;;;;;N;;;;;
1D149;MUSICAL SYMBOL TRIANGLE NOTEHEAD UP BLACK;So;0;L;;;;;N;;;;;
1D14A;MUSICAL SYMBOL TRIANGLE NOTEHEAD LEFT WHITE;So;0;L;;;;;N;;;;;
1D14B;MUSICAL SYMBOL TRIANGLE NOTEHEAD LEFT BLACK;So;0;L;;;;;N;;;;;
1D14C;MUSICAL SYMBOL TRIANGLE NOTEHEAD RIGHT WHITE;So;0;L;;;;;N;;;;;
1D14D;MUSICAL SYMBOL TRIANGLE NOTEHEAD RIGHT BLACK;So;0;L;;;;;N;;;;;
1D14E;MUSICAL SYMBOL TRIANGLE NOTEHEAD DOWN WHITE;So;0;L;;;;;N;;;;;
1D14F;MUSICAL SYMBOL TRIANGLE NOTEHEAD DOWN BLACK;So;0;L;;;;;N;;;;;
1D150;MUSICAL SYMBOL TRIANGLE NOTEHEAD UP RIGHT WHITE;So;0;L;;;;;N;;;;;
1D151;MUSICAL SYMBOL TRIANGLE NOTEHEAD UP RIGHT BLACK;So;0;L;;;;;N;;;;;
1D152;MUSICAL SYMBOL MOON NOTEHEAD WHITE;So;0;L;;;;;N;;;;;
1D153;MUSICAL SYMBOL MOON NOTEHEAD BLACK;So;0;L;;;;;N;;;;;
1D154;MUSICAL SYMBOL TRIANGLE-ROUND NOTEHEAD DOWN WHITE;So;0;L;;;;;N;;;;;
1D155;MUSICAL SYMBOL TRIANGLE-ROUND NOTEHEAD DOWN BLACK;So;0;L;;;;;N;;;;;
1D156;MUSICAL SYMBOL PARENTHESIS NOTEHEAD;So;0;L;;;;;N;;;;;
1D157;MUSICAL SYMBOL VOID NOTEHEAD;So;0;L;;;;;N;;;;;
1D158;MUSICAL SYMBOL NOTEHEAD BLACK;So;0;L;;;;;N;;;;;
1D159;MUSICAL SYMBOL NULL NOTEHEAD;So;0;L;;;;;N;;;;;
1D15A;MUSICAL SYMBOL CLUSTER NOTEHEAD WHITE;So;0;L;;;;;N;;;;;
1D15B;MUSICAL SYMBOL CLUSTER NOTEHEAD BLACK;So;0;L;;;;;N;;;;;
1D15C;MUSICAL SYMBOL BREVE;So;0;L;;;;;N;;;;;
1D15D;MUSICAL SYMBOL WHOLE NOTE;So;0;L;;;;;N;;;;;
1D15E;MUSICAL SYMBOL HALF NOTE;So;0;L;1D157 1D165;;;;N;;;;;
1D15F;MUSICAL SYMBOL QUARTER NOTE;So;0;L;1D158 1D165;;;;N;;;;;
1D160;MUSICAL SYMBOL EIGHTH NOTE;So;0;L;1D15F 1D16E;;;;N;;;;;
1D161;MUSICAL SYMBOL SIXTEENTH NOTE;So;0;L;1D15F 1D16F;;;;N;;;;;
1D162;MUSICAL SYMBOL THIRTY-SECOND NOTE;So;0;L;1D15F 1D170;;;;N;;;;;
1D163;MUSICAL SYMBOL SIXTY-FOURTH NOTE;So;0;L;1D15F 1D171;;;;N;;;;;
1D164;MUSICAL SYMBOL ONE HUNDRED TWENTY-EIGHTH NOTE;So;0;L;1D15F 1D172;;;;N;;;;;
1D165;MUSICAL SYMBOL COMBINING STEM;Mc;216;L;;;;;N;;;;;
1D166;MUSICAL SYMBOL COMBINING SPRECHGESANG STEM;Mc;216;L;;;;;N;;;;;
1D167;MUSICAL SYMBOL COMBINING TREMOLO-1;Mn;1;NSM;;;;;N;;;;;
1D168;MUSICAL SYMBOL COMBINING TREMOLO-2;Mn;1;NSM;;;;;N;;;;;
1D169;MUSICAL SYMBOL COMBINING TREMOLO-3;Mn;1;NSM;;;;;N;;;;;
1D16A;MUSICAL SYMBOL FINGERED TREMOLO-1;So;0;L;;;;;N;;;;;
1D16B;MUSICAL SYMBOL FINGERED TREMOLO-2;So;0;L;;;;;N;;;;;
1D16C;MUSICAL SYMBOL FINGERED TREMOLO-3;So;0;L;;;;;N;;;;;
1D16D;MUSICAL SYMBOL COMBINING AUGMENTATION DOT;Mc;226;L;;;;;N;;;;;
1D16E;MUSICAL SYMBOL COMBINING FLAG-1;Mc;216;L;;;;;N;;;;;
1D16F;MUSICAL SYMBOL COMBINING FLAG-2;Mc;216;L;;;;;N;;;;;
1D170;MUSICAL SYMBOL COMBINING FLAG-3;Mc;216;L;;;;;N;;;;;
1D171;MUSICAL SYMBOL COMBINING FLAG-4;Mc;216;L;;;;;N;;;;;
1D172;MUSICAL SYMBOL COMBINING FLAG-5;Mc;216;L;;;;;N;;;;;
1D173;MUSICAL SYMBOL BEGIN BEAM;Cf;0;BN;;;;;N;;;;;
1D174;MUSICAL SYMBOL END BEAM;Cf;0;BN;;;;;N;;;;;
1D175;MUSICAL SYMBOL BEGIN TIE;Cf;0;BN;;;;;N;;;;;
1D176;MUSICAL SYMBOL END TIE;Cf;0;BN;;;;;N;;;;;
1D177;MUSICAL SYMBOL BEGIN SLUR;Cf;0;BN;;;;;N;;;;;
1D178;MUSICAL SYMBOL END SLUR;Cf;0;BN;;;;;N;;;;;
1D179;MUSICAL SYMBOL BEGIN PHRASE;Cf;0;BN;;;;;N;;;;;
1D17A;MUSICAL SYMBOL END PHRASE;Cf;0;BN;;;;;N;;;;;
1D17B;MUSICAL SYMBOL COMBINING ACCENT;Mn;220;NSM;;;;;N;;;;;
1D17C;MUSICAL SYMBOL COMBINING STACCATO;Mn;220;NSM;;;;;N;;;;;
1D17D;MUSICAL SYMBOL COMBINING TENUTO;Mn;220;NSM;;;;;N;;;;;
1D17E;MUSICAL SYMBOL COMBINING STACCATISSIMO;Mn;220;NSM;;;;;N;;;;;
1D17F;MUSICAL SYMBOL COMBINING MARCATO;Mn;220;NSM;;;;;N;;;;;
1D180;MUSICAL SYMBOL COMBINING MARCATO-STACCATO;Mn;220;NSM;;;;;N;;;;;
1D181;MUSICAL SYMBOL COMBINING ACCENT-STACCATO;Mn;220;NSM;;;;;N;;;;;
1D182;MUSICAL SYMBOL COMBINING LOURE;Mn;220;NSM;;;;;N;;;;;
1D183;MUSICAL SYMBOL ARPEGGIATO UP;So;0;L;;;;;N;;;;;
1D184;MUSICAL SYMBOL ARPEGGIATO DOWN;So;0;L;;;;;N;;;;;
1D185;MUSICAL SYMBOL COMBINING DOIT;Mn;230;NSM;;;;;N;;;;;
1D186;MUSICAL SYMBOL COMBINING RIP;Mn;230;NSM;;;;;N;;;;;
1D187;MUSICAL SYMBOL COMBINING FLIP;Mn;230;NSM;;;;;N;;;;;
1D188;MUSICAL SYMBOL COMBINING SMEAR;Mn;230;NSM;;;;;N;;;;;
1D189;MUSICAL SYMBOL COMBINING BEND;Mn;230;NSM;;;;;N;;;;;
1D18A;MUSICAL SYMBOL COMBINING DOUBLE TONGUE;Mn;220;NSM;;;;;N;;;;;
1D18B;MUSICAL SYMBOL COMBINING TRIPLE TONGUE;Mn;220;NSM;;;;;N;;;;;
1D18C;MUSICAL SYMBOL RINFORZANDO;So;0;L;;;;;N;;;;;
1D18D;MUSICAL SYMBOL SUBITO;So;0;L;;;;;N;;;;;
1D18E;MUSICAL SYMBOL Z;So;0;L;;;;;N;;;;;
1D18F;MUSICAL SYMBOL PIANO;So;0;L;;;;;N;;;;;
1D190;MUSICAL SYMBOL MEZZO;So;0;L;;;;;N;;;;;
1D191;MUSICAL SYMBOL FORTE;So;0;L;;;;;N;;;;;
1D192;MUSICAL SYMBOL CRESCENDO;So;0;L;;;;;N;;;;;
1D193;MUSICAL SYMBOL DECRESCENDO;So;0;L;;;;;N;;;;;
1D194;MUSICAL SYMBOL GRACE NOTE SLASH;So;0;L;;;;;N;;;;;
1D195;MUSICAL SYMBOL GRACE NOTE NO SLASH;So;0;L;;;;;N;;;;;
1D196;MUSICAL SYMBOL TR;So;0;L;;;;;N;;;;;
1D197;MUSICAL SYMBOL TURN;So;0;L;;;;;N;;;;;
1D198;MUSICAL SYMBOL INVERTED TURN;So;0;L;;;;;N;;;;;
1D199;MUSICAL SYMBOL TURN SLASH;So;0;L;;;;;N;;;;;
1D19A;MUSICAL SYMBOL TURN UP;So;0;L;;;;;N;;;;;
1D19B;MUSICAL SYMBOL ORNAMENT STROKE-1;So;0;L;;;;;N;;;;;
1D19C;MUSICAL SYMBOL ORNAMENT STROKE-2;So;0;L;;;;;N;;;;;
1D19D;MUSICAL SYMBOL ORNAMENT STROKE-3;So;0;L;;;;;N;;;;;
1D19E;MUSICAL SYMBOL ORNAMENT STROKE-4;So;0;L;;;;;N;;;;;
1D19F;MUSICAL SYMBOL ORNAMENT STROKE-5;So;0;L;;;;;N;;;;;
1D1A0;MUSICAL SYMBOL ORNAMENT STROKE-6;So;0;L;;;;;N;;;;;
1D1A1;MUSICAL SYMBOL ORNAMENT STROKE-7;So;0;L;;;;;N;;;;;
1D1A2;MUSICAL SYMBOL ORNAMENT STROKE-8;So;0;L;;;;;N;;;;;
1D1A3;MUSICAL SYMBOL ORNAMENT STROKE-9;So;0;L;;;;;N;;;;;
1D1A4;MUSICAL SYMBOL ORNAMENT STROKE-10;So;0;L;;;;;N;;;;;
1D1A5;MUSICAL SYMBOL ORNAMENT STROKE-11;So;0;L;;;;;N;;;;;
1D1A6;MUSICAL SYMBOL HAUPTSTIMME;So;0;L;;;;;N;;;;;
1D1A7;MUSICAL SYMBOL NEBENSTIMME;So;0;L;;;;;N;;;;;
1D1A8;MUSICAL SYMBOL END OF STIMME;So;0;L;;;;;N;;;;;
1D1A9;MUSICAL SYMBOL DEGREE SLASH;So;0;L;;;;;N;;;;;
1D1AA;MUSICAL SYMBOL COMBINING DOWN BOW;Mn;230;NSM;;;;;N;;;;;
1D1AB;MUSICAL SYMBOL COMBINING UP BOW;Mn;230;NSM;;;;;N;;;;;
1D1AC;MUSICAL SYMBOL COMBINING HARMONIC;Mn;230;NSM;;;;;N;;;;;
1D1AD;MUSICAL SYMBOL COMBINING SNAP PIZZICATO;Mn;230;NSM;;;;;N;;;;;
1D1AE;MUSICAL SYMBOL PEDAL MARK;So;0;L;;;;;N;;;;;
1D1AF;MUSICAL SYMBOL PEDAL UP MARK;So;0;L;;;;;N;;;;;
1D1B0;MUSICAL SYMBOL HALF PEDAL MARK;So;0;L;;;;;N;;;;;
1D1B1;MUSICAL SYMBOL GLISSANDO UP;So;0;L;;;;;N;;;;;
1D1B2;MUSICAL SYMBOL GLISSANDO DOWN;So;0;L;;;;;N;;;;;
1D1B3;MUSICAL SYMBOL WITH FINGERNAILS;So;0;L;;;;;N;;;;;
1D1B4;MUSICAL SYMBOL DAMP;So;0;L;;;;;N;;;;;
1D1B5;MUSICAL SYMBOL DAMP ALL;So;0;L;;;;;N;;;;;
1D1B6;MUSICAL SYMBOL MAXIMA;So;0;L;;;;;N;;;;;
1D1B7;MUSICAL SYMBOL LONGA;So;0;L;;;;;N;;;;;
1D1B8;MUSICAL SYMBOL BREVIS;So;0;L;;;;;N;;;;;
1D1B9;MUSICAL SYMBOL SEMIBREVIS WHITE;So;0;L;;;;;N;;;;;
1D1BA;MUSICAL SYMBOL SEMIBREVIS BLACK;So;0;L;;;;;N;;;;;
1D1BB;MUSICAL SYMBOL MINIMA;So;0;L;1D1B9 1D165;;;;N;;;;;
1D1BC;MUSICAL SYMBOL MINIMA BLACK;So;0;L;1D1BA 1D165;;;;N;;;;;
1D1BD;MUSICAL SYMBOL SEMIMINIMA WHITE;So;0;L;1D1BB 1D16E;;;;N;;;;;
1D1BE;MUSICAL SYMBOL SEMIMINIMA BLACK;So;0;L;1D1BC 1D16E;;;;N;;;;;
1D1BF;MUSICAL SYMBOL FUSA WHITE;So;0;L;1D1BB 1D16F;;;;N;;;;;
1D1C0;MUSICAL SYMBOL FUSA BLACK;So;0;L;1D1BC 1D16F;;;;N;;;;;
1D1C1;MUSICAL SYMBOL LONGA PERFECTA REST;So;0;L;;;;;N;;;;;
1D1C2;MUSICAL SYMBOL LONGA IMPERFECTA REST;So;0;L;;;;;N;;;;;
1D1C3;MUSICAL SYMBOL BREVIS REST;So;0;L;;;;;N;;;;;
1D1C4;MUSICAL SYMBOL SEMIBREVIS REST;So;0;L;;;;;N;;;;;
1D1C5;MUSICAL SYMBOL MINIMA REST;So;0;L;;;;;N;;;;;
1D1C6;MUSICAL SYMBOL SEMIMINIMA REST;So;0;L;;;;;N;;;;;
1D1C7;MUSICAL SYMBOL TEMPUS PERFECTUM CUM PROLATIONE PERFECTA;So;0;L;;;;;N;;;;;
1D1C8;MUSICAL SYMBOL TEMPUS PERFECTUM CUM PROLATIONE IMPERFECTA;So;0;L;;;;;N;;;;;
1D1C9;MUSICAL SYMBOL TEMPUS PERFECTUM CUM PROLATIONE PERFECTA DIMINUTION-1;So;0;L;;;;;N;;;;;
1D1CA;MUSICAL SYMBOL TEMPUS IMPERFECTUM CUM PROLATIONE PERFECTA;So;0;L;;;;;N;;;;;
1D1CB;MUSICAL SYMBOL TEMPUS IMPERFECTUM CUM PROLATIONE IMPERFECTA;So;0;L;;;;;N;;;;;
1D1CC;MUSICAL SYMBOL TEMPUS IMPERFECTUM CUM PROLATIONE IMPERFECTA DIMINUTION-1;So;0;L;;;;;N;;;;;
1D1CD;MUSICAL SYMBOL TEMPUS IMPERFECTUM CUM PROLATIONE IMPERFECTA DIMINUTION-2;So;0;L;;;;;N;;;;;
1D1CE;MUSICAL SYMBOL TEMPUS IMPERFECTUM CUM PROLATIONE IMPERFECTA DIMINUTION-3;So;0;L;;;;;N;;;;;
1D1CF;MUSICAL SYMBOL CROIX;So;0;L;;;;;N;;;;;
1D1D0;MUSICAL SYMBOL GREGORIAN C CLEF;So;0;L;;;;;N;;;;;
1D1D1;MUSICAL SYMBOL GREGORIAN F CLEF;So;0;L;;;;;N;;;;;
1D1D2;MUSICAL SYMBOL SQUARE B;So;0;L;;;;;N;;;;;
1D1D3;MUSICAL SYMBOL VIRGA;So;0;L;;;;;N;;;;;
1D1D4;MUSICAL SYMBOL PODATUS;So;0;L;;;;;N;;;;;
1D1D5;MUSICAL SYMBOL CLIVIS;So;0;L;;;;;N;;;;;
1D1D6;MUSICAL SYMBOL SCANDICUS;So;0;L;;;;;N;;;;;
1D1D7;MUSICAL SYMBOL CLIMACUS;So;0;L;;;;;N;;;;;
1D1D8;MUSICAL SYMBOL TORCULUS;So;0;L;;;;;N;;;;;
1D1D9;MUSICAL SYMBOL PORRECTUS;So;0;L;;;;;N;;;;;
1D1DA;MUSICAL SYMBOL PORRECTUS FLEXUS;So;0;L;;;;;N;;;;;
1D1DB;MUSICAL SYMBOL SCANDICUS FLEXUS;So;0;L;;;;;N;;;;;
1D1DC;MUSICAL SYMBOL TORCULUS RESUPINUS;So;0;L;;;;;N;;;;;
1D1DD;MUSICAL SYMBOL PES SUBPUNCTIS;So;0;L;;;;;N;;;;;
1D1DE;MUSICAL SYMBOL KIEVAN C CLEF;So;0;L;;;;;N;;;;;
1D1DF;MUSICAL SYMBOL KIEVAN END OF PIECE;So;0;L;;;;;N;;;;;
1D1E0;MUSICAL SYMBOL KIEVAN FINAL NOTE;So;0;L;;;;;N;;;;;
1D1E1;MUSICAL SYMBOL KIEVAN RECITATIVE MARK;So;0;L;;;;;N;;;;;
1D1E2;MUSICAL SYMBOL KIEVAN WHOLE NOTE;So;0;L;;;;;N;;;;;
1D1E3;MUSICAL SYMBOL KIEVAN HALF NOTE;So;0;L;;;;;N;;;;;
1D1E4;MUSICAL SYMBOL KIEVAN QUARTER NOTE STEM DOWN;So;0;L;;;;;N;;;;;
1D1E5;MUSICAL SYMBOL KIEVAN QUARTER NOTE STEM UP;So;0;L;;;;;N;;;;;
1D1E6;MUSICAL SYMBOL KIEVAN EIGHTH NOTE STEM DOWN;So;0;L;;;;;N;;;;;
1D1E7;MUSICAL SYMBOL KIEVAN EIGHTH NOTE STEM UP;So;0;L;;;;;N;;;;;
1D1E8;MUSICAL SYMBOL KIEVAN FLAT SIGN;So;0;L;;;;;N;;;;;
1D1E9;MUSICAL SYMBOL SORI;So;0;ON;;;;;N;;;;;
1D1EA;MUSICAL SYMBOL KORON;So;0;ON;;;;;N;;;;;
1D200;GREEK VOCAL NOTATION SYMBOL-1;So;0;ON;;;;;N;;;;;
1D201;GREEK VOCAL NOTATION SYMBOL-2;So;0;ON;;;;;N;;;;;
1D202;GREEK VOCAL NOTATION SYMBOL-3;So;0;ON;;;;;N;;;;;
1D203;GREEK VOCAL NOTATION SYMBOL-4;So;0;ON;;;;;N;;;;;
1D204;GREEK VOCAL NOTATION SYMBOL-5;So;0;ON;;;;;N;;;;;
1D205;GREEK VOCAL NOTATION SYMBOL-6;So;0;ON;;;;;N;;;;;
1D206;GREEK VOCAL NOTATION SYMBOL-7;So;0;ON;;;;;N;;;;;
1D207;GREEK VOCAL NOTATION SYMBOL-8;So;0;ON;;;;;N;;;;;
1D208;GREEK VOCAL NOTATION SYMBOL-9;So;0;ON;;;;;N;;;;;
1D209;GREEK VOCAL NOTATION SYMBOL-10;So;0;ON;;;;;N;;;;;
1D20A;GREEK VOCAL NOTATION SYMBOL-11;So;0;ON;;;;;N;;;;;
1D20B;GREEK VOCAL NOTATION SYMBOL-12;So;0;ON;;;;;N;;;;;
1D20C;GREEK VOCAL NOTATION SYMBOL-13;So;0;ON;;;;;N;;;;;
1D20D;GREEK VOCAL NOTATION SYMBOL-14;So;0;ON;;;;;N;;;;;
1D20E;GREEK VOCAL NOTATION SYMBOL-15;So;0;ON;;;;;N;;;;;
1D20F;GREEK VOCAL NOTATION SYMBOL-16;So;0;ON;;;;;N;;;;;
1D210;GREEK VOCAL NOTATION SYMBOL-17;So;0;ON;;;;;N;;;;;
1D211;GREEK VOCAL NOTATION SYMBOL-18;So;0;ON;;;;;N;;;;;
1D212;GREEK VOCAL NOTATION SYMBOL-19;So;0;ON;;;;;N;;;;;
1D213;GREEK VOCAL NOTATION SYMBOL-20;So;0;ON;;;;;N;;;;;
1D214;GREEK VOCAL NOTATION SYMBOL-21;So;0;ON;;;;;N;;;;;
1D215;GREEK VOCAL NOTATION SYMBOL-22;So;0;ON;;;;;N;;;;;
1D216;GREEK VOCAL NOTATION SYMBOL-23;So;0;ON;;;;;N;;;;;
1D217;GREEK VOCAL NOTATION SYMBOL-24;So;0;ON;;;;;N;;;;;
1D218;GREEK VOCAL NOTATION SYMBOL-50;So;0;ON;;;;;N;;;;;
1D219;GREEK VOCAL NOTATION SYMBOL-51;So;0;ON;;;;;N;;;;;
1D21A;GREEK VOCAL NOTATION SYMBOL-52;So;0;ON;;;;;N;;;;;
1D21B;GREEK VOCAL NOTATION SYMBOL-53;So;0;ON;;;;;N;;;;;
1D21C;GREEK VOCAL NOTATION SYMBOL-54;So;0;ON;;;;;N;;;;;
1D21D;GREEK INSTRUMENTAL NOTATION SYMBOL-1;So;0;ON;;;;;N;;;;;
1D21E;GREEK INSTRUMENTAL NOTATION SYMBOL-2;So;0;ON;;;;;N;;;;;
1D21F;GREEK INSTRUMENTAL NOTATION SYMBOL-4;So;0;ON;;;;;N;;;;;
1D220;GREEK INSTRUMENTAL NOTATION SYMBOL-5;So;0;ON;;;;;N;;;;;
1D221;GREEK INSTRUMENTAL NOTATION SYMBOL-7;So;0;ON;;;;;N;;;;;
1D222;GREEK INSTRUMENTAL NOTATION SYMBOL-8;So;0;ON;;;;;N;;;;;
1D223;GREEK INSTRUMENTAL NOTATION SYMBOL-11;So;0;ON;;;;;N;;;;;
1D224;GREEK INSTRUMENTAL NOTATION SYMBOL-12;So;0;ON;;;;;N;;;;;
1D225;GREEK INSTRUMENTAL NOTATION SYMBOL-13;So;0;ON;;;;;N;;;;;
1D226;GREEK INSTRUMENTAL NOTATION SYMBOL-14;So;0;ON;;;;;N;;;;;
1D227;GREEK INSTRUMENTAL NOTATION SYMBOL-17;So;0;ON;;;;;N;;;;;
1D228;GREEK INSTRUMENTAL NOTATION SYMBOL-18;So;0;ON;;;;;N;;;;;
1D229;GREEK INSTRUMENTAL NOTATION SYMBOL-19;So;0;ON;;;;;N;;;;;
1D22A;GREEK INSTRUMENTAL NOTATION SYMBOL-23;So;0;ON;;;;;N;;;;;
1D22B;GREEK INSTRUMENTAL NOTATION SYMBOL-24;So;0;ON;;;;;N;;;;;
1D22C;GREEK INSTRUMENTAL NOTATION SYMBOL-25;So;0;ON;;;;;N;;;;;
1D22D;GREEK INSTRUMENTAL NOTATION SYMBOL-26;So;0;ON;;;;;N;;;;;
1D22E;GREEK INSTRUMENTAL NOTATION SYMBOL-27;So;0;ON;;;;;N;;;;;
1D22F;GREEK INSTRUMENTAL NOTATION SYMBOL-29;So;0;ON;;;;;N;;;;;
1D230;GREEK INSTRUMENTAL NOTATION SYMBOL-30;So;0;ON;;;;;N;;;;;
1D231;GREEK INSTRUMENTAL NOTATION SYMBOL-32;So;0;ON;;;;;N;;;;;
1D232;GREEK INSTRUMENTAL NOTATION SYMBOL-36;So;0;ON;;;;;N;;;;;
1D233;GREEK INSTRUMENTAL NOTATION SYMBOL-37;So;0;ON;;;;;N;;;;;
1D234;GREEK INSTRUMENTAL NOTATION SYMBOL-38;So;0;ON;;;;;N;;;;;
1D235;GREEK INSTRUMENTAL NOTATION SYMBOL-39;So;0;ON;;;;;N;;;;;
1D236;GREEK INSTRUMENTAL NOTATION SYMBOL-40;So;0;ON;;;;;N;;;;;
1D237;GREEK INSTRUMENTAL NOTATION SYMBOL-42;So;0;ON;;;;;N;;;;;
1D238;GREEK INSTRUMENTAL NOTATION SYMBOL-43;So;0;ON;;;;;N;;;;;
1D239;GREEK INSTRUMENTAL NOTATION SYMBOL-45;So;0;ON;;;;;N;;;;;
1D23A;GREEK INSTRUMENTAL NOTATION SYMBOL-47;So;0;ON;;;;;N;;;;;
1D23B;GREEK INSTRUMENTAL NOTATION SYMBOL-48;So;0;ON;;;;;N;;;;;
1D23C;GREEK INSTRUMENTAL NOTATION SYMBOL-49;So;0;ON;;;;;N;;;;;
1D23D;GREEK INSTRUMENTAL NOTATION SYMBOL-50;So;0;ON;;;;;N;;;;;
1D23E;GREEK INSTRUMENTAL NOTATION SYMBOL-51;So;0;ON;;;;;N;;;;;
1D23F;GREEK INSTRUMENTAL NOTATION SYMBOL-52;So;0;ON;;;;;N;;;;;
1D240;GREEK INSTRUMENTAL NOTATION SYMBOL-53;So;0;ON;;;;;N;;;;;
1D241;GREEK INSTRUMENTAL NOTATION SYMBOL-54;So;0;ON;;;;;N;;;;;
1D242;COMBINING GREEK MUSICAL TRISEME;Mn;230;NSM;;;;;N;;;;;
1D243;COMBINING GREEK MUSICAL TETRASEME;Mn;230;NSM;;;;;N;;;;;
1D244;COMBINING GREEK MUSICAL PENTASEME;Mn;230;NSM;;;;;N;;;;;
1D245;GREEK MUSICAL LEIMMA;So;0;ON;;;;;N;;;;;
1D2E0;MAYAN NUMERAL ZERO;No;0;L;;;;0;N;;;;;
1D2E1;MAYAN NUMERAL ONE;No;0;L;;;;1;N;;;;;
1D2E2;MAYAN NUMERAL TWO;No;0;L;;;;2;N;;;;;
1D2E3;MAYAN NUMERAL THREE;No;0;L;;;;3;N;;;;;
1D2E4;MAYAN NUMERAL FOUR;No;0;L;;;;4;N;;;;;
1D2E5;MAYAN NUMERAL FIVE;No;0;L;;;;5;N;;;;;
1D2E6;MAYAN NUMERAL SIX;No;0;L;;;;6;N;;;;;
1D2E7;MAYAN NUMERAL SEVEN;No;0;L;;;;7;N;;;;;
1D2E8;MAYAN NUMERAL EIGHT;No;0;L;;;;8;N;;;;;
1D2E9;MAYAN NUMERAL NINE;No;0;L;;;;9;N;;;;;
1D2EA;MAYAN NUMERAL TEN;No;0;L;;;;10;N;;;;;
1D2EB;MAYAN NUMERAL ELEVEN;No;0;L;;;;11;N;;;;;
1D2EC;MAYAN NUMERAL TWELVE;No;0;L;;;;12;N;;;;;
1D2ED;MAYAN NUMERAL THIRTEEN;No;0;L;;;;13;N;;;;;
1D2EE;MAYAN NUMERAL FOURTEEN;No;0;L;;;;14;N;;;;;
1D2EF;MAYAN NUMERAL FIFTEEN;No;0;L;;;;15;N;;;;;
1D2F0;MAYAN NUMERAL SIXTEEN;No;0;L;;;;16;N;;;;;
1D2F1;MAYAN NUMERAL SEVENTEEN;No;0;L;;;;17;N;;;;;
1D2F2;MAYAN NUMERAL EIGHTEEN;No;0;L;;;;18;N;;;;;
1D2F3;MAYAN NUMERAL NINETEEN;No;0;L;;;;19;N;;;;;
1D300;MONOGRAM FOR EARTH;So;0;ON;;;;;N;;;;;
1D301;DIGRAM FOR HEAVENLY EARTH;So;0;ON;;;;;N;;;;;
1D302;DIGRAM FOR HUMAN EARTH;So;0;ON;;;;;N;;;;;
1D303;DIGRAM FOR EARTHLY HEAVEN;So;0;ON;;;;;N;;;;;
1D304;DIGRAM FOR EARTHLY HUMAN;So;0;ON;;;;;N;;;;;
1D305;DIGRAM FOR EARTH;So;0;ON;;;;;N;;;;;
1D306;TETRAGRAM FOR CENTRE;So;0;ON;;;;;N;;;;;
1D307;TETRAGRAM FOR FULL CIRCLE;So;0;ON;;;;;N;;;;;
1D308;TETRAGRAM FOR MIRED;So;0;ON;;;;;N;;;;;
1D309;TETRAGRAM FOR BARRIER;So;0;ON;;;;;N;;;;;
1D30A;TETRAGRAM FOR KEEPING SMALL;So;0;ON;;;;;N;;;;;
1D30B;TETRAGRAM FOR CONTRARIETY;So;0;ON;;;;;N;;;;;
1D30C;TETRAGRAM FOR ASCENT;So;0;ON;;;;;N;;;;;
1D30D;TETRAGRAM FOR OPPOSITION;So;0;ON;;;;;N;;;;;
1D30E;TETRAGRAM FOR BRANCHING OUT;So;0;ON;;;;;N;;;;;
1D30F;TETRAGRAM FOR DEFECTIVENESS OR DISTORTION;So;0;ON;;;;;N;;;;;
1D310;TETRAGRAM FOR DIVERGENCE;So;0;ON;;;;;N;;;;;
1D311;TETRAGRAM FOR YOUTHFULNESS;So;0;ON;;;;;N;;;;;
1D312;TETRAGRAM FOR INCREASE;So;0;ON;;;;;N;;;;;
1D313;TETRAGRAM FOR PENETRATION;So;0;ON;;;;;N;;;;;
1D314;TETRAGRAM FOR REACH;So;0;ON;;;;;N;;;;;
1D315;TETRAGRAM FOR CONTACT;So;0;ON;;;;;N;;;;;
1D316;TETRAGRAM FOR HOLDING BACK;So;0;ON;;;;;N;;;;;
1D317;TETRAGRAM FOR WAITING;So;0;ON;;;;;N;;;;;
1D318;TETRAGRAM FOR FOLLOWING;So;0;ON;;;;;N;;;;;
1D319;TETRAGRAM FOR ADVANCE;So;0;ON;;;;;N;;;;;
1D31A;TETRAGRAM FOR RELEASE;So;0;ON;;;;;N;;;;;
1D31B;TETRAGRAM FOR RESISTANCE;So;0;ON;;;;;N;;;;;
1D31C;TETRAGRAM FOR EASE;So;0;ON;;;;;N;;;;;
1D31D;TETRAGRAM FOR JOY;So;0;ON;;;;;N;;;;;
1D31E;TETRAGRAM FOR CONTENTION;So;0;ON;;;;;N;;;;;
1D31F;TETRAGRAM FOR ENDEAVOUR;So;0;ON;;;;;N;;;;;
1D320;TETRAGRAM FOR DUTIES;So;0;ON;;;;;N;;;;;
1D321;TETRAGRAM FOR CHANGE;So;0;ON;;;;;N;;;;;
1D322;TETRAGRAM FOR DECISIVENESS;So;0;ON;;;;;N;;;;;
1D323;TETRAGRAM FOR BOLD RESOLUTION;So;0;ON;;;;;N;;;;;
1D324;TETRAGRAM FOR PACKING;So;0;ON;;;;;N;;;;;
1D325;TETRAGRAM FOR LEGION;So;0;ON;;;;;N;;;;;
1D326;TETRAGRAM FOR CLOSENESS;So;0;ON;;;;;N;;;;;
1D327;TETRAGRAM FOR KINSHIP;So;0;ON;;;;;N;;;;;
1D328;TETRAGRAM FOR GATHERING;So;0;ON;;;;;N;;;;;
1D329;TETRAGRAM FOR STRENGTH;So;0;ON;;;;;N;;;;;
1D32A;TETRAGRAM FOR PURITY;So;0;ON;;;;;N;;;;;
1D32B;TETRAGRAM FOR FULLNESS;So;0;ON;;;;;N;;;;;
1D32C;TETRAGRAM FOR RESIDENCE;So;0;ON;;;;;N;;;;;
1D32D;TETRAGRAM FOR LAW OR MODEL;So;0;ON;;;;;N;;;;;
1D32E;TETRAGRAM FOR RESPONSE;So;0;ON;;;;;N;;;;;
1D32F;TETRAGRAM FOR GOING TO MEET;So;0;ON;;;;;N;;;;;
1D330;TETRAGRAM FOR ENCOUNTERS;So;0;ON;;;;;N;;;;;
1D331;TETRAGRAM FOR STOVE;So;0;ON;;;;;N;;;;;
1D332;TETRAGRAM FOR GREATNESS;So;0;ON;;;;;N;;;;;
1D333;TETRAGRAM FOR ENLARGEMENT;So;0;ON;;;;;N;;;;;
1D334;TETRAGRAM FOR PATTERN;So;0;ON;;;;;N;;;;;
1D335;TETRAGRAM FOR RITUAL;So;0;ON;;;;;N;;;;;
1D336;TETRAGRAM FOR FLIGHT;So;0;ON;;;;;N;;;;;
1D337;TETRAGRAM FOR VASTNESS OR WASTING;So;0;ON;;;;;N;;;;;
1D338;TETRAGRAM FOR CONSTANCY;So;0;ON;;;;;N;;;;;
1D339;TETRAGRAM FOR MEASURE;So;0;ON;;;;;N;;;;;
1D33A;TETRAGRAM FOR ETERNITY;So;0;ON;;;;;N;;;;;
1D33B;TETRAGRAM FOR UNITY;So;0;ON;;;;;N;;;;;
1D33C;TETRAGRAM FOR DIMINISHMENT;So;0;ON;;;;;N;;;;;
1D33D;TETRAGRAM FOR CLOSED MOUTH;So;0;ON;;;;;N;;;;;
1D33E;TETRAGRAM FOR GUARDEDNESS;So;0;ON;;;;;N;;;;;
1D33F;TETRAGRAM FOR GATHERING IN;So;0;ON;;;;;N;;;;;
1D340;TETRAGRAM FOR MASSING;So;0;ON;;;;;N;;;;;
1D341;TETRAGRAM FOR ACCUMULATION;So;0;ON;;;;;N;;;;;
1D342;TETRAGRAM FOR EMBELLISHMENT;So;0;ON;;;;;N;;;;;
1D343;TETRAGRAM FOR DOUBT;So;0;ON;;;;;N;;;;;
1D344;TETRAGRAM FOR WATCH;So;0;ON;;;;;N;;;;;
1D345;TETRAGRAM FOR SINKING;So;0;ON;;;;;N;;;;;
1D346;TETRAGRAM FOR INNER;So;0;ON;;;;;N;;;;;
1D347;TETRAGRAM FOR DEPARTURE;So;0;ON;;;;;N;;;;;
1D348;TETRAGRAM FOR DARKENING;So;0;ON;;;;;N;;;;;
1D349;TETRAGRAM FOR DIMMING;So;0;ON;;;;;N;;;;;
1D34A;TETRAGRAM FOR EXHAUSTION;So;0;ON;;;;;N;;;;;
1D34B;TETRAGRAM FOR SEVERANCE;So;0;ON;;;;;N;;;;;
1D34C;TETRAGRAM FOR STOPPAGE;So;0;ON;;;;;N;;;;;
1D34D;TETRAGRAM FOR HARDNESS;So;0;ON;;;;;N;;;;;
1D34E;TETRAGRAM FOR COMPLETION;So;0;ON;;;;;N;;;;;
1D34F;TETRAGRAM FOR CLOSURE;So;0;ON;;;;;N;;;;;
1D350;TETRAGRAM FOR FAILURE;So;0;ON;;;;;N;;;;;
1D351;TETRAGRAM FOR AGGRAVATION;So;0;ON;;;;;N;;;;;
1D352;TETRAGRAM FOR COMPLIANCE;So;0;ON;;;;;N;;;;;
1D353;TETRAGRAM FOR ON THE VERGE;So;0;ON;;;;;N;;;;;
1D354;TETRAGRAM FOR DIFFICULTIES;So;0;ON;;;;;N;;;;;
1D355;TETRAGRAM FOR LABOURING;So;0;ON;;;;;N;;;;;
1D356;TETRAGRAM FOR FOSTERING;So;0;ON;;;;;N;;;;;
1D360;COUNTING ROD UNIT DIGIT ONE;No;0;L;;;;1;N;;;;;
1D361;COUNTING ROD UNIT DIGIT TWO;No;0;L;;;;2;N;;;;;
1D362;COUNTING ROD UNIT DIGIT THREE;No;0;L;;;;3;N;;;;;
1D363;COUNTING ROD UNIT DIGIT FOUR;No;0;L;;;;4;N;;;;;
1D364;COUNTING ROD UNIT DIGIT FIVE;No;0;L;;;;5;N;;;;;
1D365;COUNTING ROD UNIT DIGIT SIX;No;0;L;;;;6;N;;;;;
1D366;COUNTING ROD UNIT DIGIT SEVEN;No;0;L;;;;7;N;;;;;
1D367;COUNTING ROD UNIT DIGIT EIGHT;No;0;L;;;;8;N;;;;;
1D368;COUNTING ROD UNIT DIGIT NINE;No;0;L;;;;9;N;;;;;
1D369;COUNTING ROD TENS DIGIT ONE;No;0;L;;;;10;N;;;;;
1D36A;COUNTING ROD TENS DIGIT TWO;No;0;L;;;;20;N;;;;;
1D36B;COUNTING ROD TENS DIGIT THREE;No;0;L;;;;30;N;;;;;
1D36C;COUNTING ROD TENS DIGIT FOUR;No;0;L;;;;40;N;;;;;
1D36D;COUNTING ROD TENS DIGIT FIVE;No;0;L;;;;50;N;;;;;
1D36E;COUNTING ROD TENS DIGIT SIX;No;0;L;;;;60;N;;;;;
1D36F;COUNTING ROD TENS DIGIT SEVEN;No;0;L;;;;70;N;;;;;
1D370;COUNTING ROD TENS DIGIT EIGHT;No;0;L;;;;80;N;;;;;
1D371;COUNTING ROD TENS DIGIT NINE;No;0;L;;;;90;N;;;;;
1D372;IDEOGRAPHIC TALLY MARK ONE;No;0;L;;;;1;N;;;;;
1D373;IDEOGRAPHIC TALLY MARK TWO;No;0;L;;;;2;N;;;;;
1D374;IDEOGRAPHIC TALLY MARK THREE;No;0;L;;;;3;N;;;;;
1D375;IDEOGRAPHIC TALLY MARK FOUR;No;0;L;;;;4;N;;;;;
1D376;IDEOGRAPHIC TALLY MARK FIVE;No;0;L;;;;5;N;;;;;
1D377;TALLY MARK ONE;No;0;L;;;;1;N;;;;;
1D378;TALLY MARK FIVE;No;0;L;;;;5;N;;;;;
1D400;MATHEMATICAL BOLD CAPITAL A;Lu;0;L;<font> 0041;;;;N;;;;;
1D401;MATHEMATICAL BOLD CAPITAL B;Lu;0;L;<font> 0042;;;;N;;;;;
1D402;MATHEMATICAL BOLD CAPITAL C;Lu;0;L;<font> 0043;;;;N;;;;;
1D403;MATHEMATICAL BOLD CAPITAL D;Lu;0;L;<font> 0044;;;;N;;;;;
1D404;MATHEMATICAL BOLD CAPITAL E;Lu;0;L;<font> 0045;;;;N;;;;;
1D405;MATHEMATICAL BOLD CAPITAL F;Lu;0;L;<font> 0046;;;;N;;;;;
1D406;MATHEMATICAL BOLD CAPITAL G;Lu;0;L;<font> 0047;;;;N;;;;;
1D407;MATHEMATICAL BOLD CAPITAL H;Lu;0;L;<font> 0048;;;;N;;;;;
1D408;MATHEMATICAL BOLD CAPITAL I;Lu;0;L;<font> 0049;;;;N;;;;;
1D409;MATHEMATICAL BOLD CAPITAL J;Lu;0;L;<font> 004A;;;;N;;;;;
1D40A;MATHEMATICAL BOLD CAPITAL K;Lu;0;L;<font> 004B;;;;N;;;;;
1D40B;MATHEMATICAL BOLD CAPITAL L;Lu;0;L;<font> 004C;;;;N;;;;;
1D40C;MATHEMATICAL BOLD CAPITAL M;Lu;0;L;<font> 004D;;;;N;;;;;
1D40D;MATHEMATICAL BOLD CAPITAL N;Lu;0;L;<font> 004E;;;;N;;;;;
1D40E;MATHEMATICAL BOLD CAPITAL O;Lu;0;L;<font> 004F;;;;N;;;;;
1D40F;MATHEMATICAL BOLD CAPITAL P;Lu;0;L;<font> 0050;;;;N;;;;;
1D410;MATHEMATICAL BOLD CAPITAL Q;Lu;0;L;<font> 0051;;;;N;;;;;
1D411;MATHEMATICAL BOLD CAPITAL R;Lu;0;L;<font> 0052;;;;N;;;;;
1D412;MATHEMATICAL BOLD CAPITAL S;Lu;0;L;<font> 0053;;;;N;;;;;
1D413;MATHEMATICAL BOLD CAPITAL T;Lu;0;L;<font> 0054;;;;N;;;;;
1D414;MATHEMATICAL BOLD CAPITAL U;Lu;0;L;<font> 0055;;;;N;;;;;
1D415;MATHEMATICAL BOLD CAPITAL V;Lu;0;L;<font> 0056;;;;N;;;;;
1D416;MATHEMATICAL BOLD CAPITAL W;Lu;0;L;<font> 0057;;;;N;;;;;
1D417;MATHEMATICAL BOLD CAPITAL X;Lu;0;L;<font> 0058;;;;N;;;;;
1D418;MATHEMATICAL BOLD CAPITAL Y;Lu;0;L;<font> 0059;;;;N;;;;;
1D419;MATHEMATICAL BOLD CAPITAL Z;Lu;0;L;<font> 005A;;;;N;;;;;
1D41A;MATHEMATICAL BOLD SMALL A;Ll;0;L;<font> 0061;;;;N;;;;;
1D41B;MATHEMATICAL BOLD SMALL B;Ll;0;L;<font> 0062;;;;N;;;;;
1D41C;MATHEMATICAL BOLD SMALL C;Ll;0;L;<font> 0063;;;;N;;;;;
1D41D;MATHEMATICAL BOLD SMALL D;Ll;0;L;<font> 0064;;;;N;;;;;
1D41E;MATHEMATICAL BOLD SMALL E;Ll;0;L;<font> 0065;;;;N;;;;;
1D41F;MATHEMATICAL BOLD SMALL F;Ll;0;L;<font> 0066;;;;N;;;;;
1D420;MATHEMATICAL BOLD SMALL G;Ll;0;L;<font> 0067;;;;N;;;;;
1D421;MATHEMATICAL BOLD SMALL H;Ll;0;L;<font> 0068;;;;N;;;;;
1D422;MATHEMATICAL BOLD SMALL I;Ll;0;L;<font> 0069;;;;N;;;;;
1D423;MATHEMATICAL BOLD SMALL J;Ll;0;L;<font> 006A;;;;N;;;;;
1D424;MATHEMATICAL BOLD SMALL K;Ll;0;L;<font> 006B;;;;N;;;;;
1D425;MATHEMATICAL BOLD SMALL L;Ll;0;L;<font> 006C;;;;N;;;;;
1D426;MATHEMATICAL BOLD SMALL M;Ll;0;L;<font> 006D;;;;N;;;;;
1D427;MATHEMATICAL BOLD SMALL N;Ll;0;L;<font> 006E;;;;N;;;;;
1D428;MATHEMATICAL BOLD SMALL O;Ll;0;L;<font> 006F;;;;N;;;;;
1D429;MATHEMATICAL BOLD SMALL P;Ll;0;L;<font> 0070;;;;N;;;;;
1D42A;MATHEMATICAL BOLD SMALL Q;Ll;0;L;<font> 0071;;;;N;;;;;
1D42B;MATHEMATICAL BOLD SMALL R;Ll;0;L;<font> 0072;;;;N;;;;;
1D42C;MATHEMATICAL BOLD SMALL S;Ll;0;L;<font> 0073;;;;N;;;;;
1D42D;MATHEMATICAL BOLD SMALL T;Ll;0;L;<font> 0074;;;;N;;;;;
1D42E;MATHEMATICAL BOLD SMALL U;Ll;0;L;<font> 0075;;;;N;;;;;
1D42F;MATHEMATICAL BOLD SMALL V;Ll;0;L;<font> 0076;;;;N;;;;;
1D430;MATHEMATICAL BOLD SMALL W;Ll;0;L;<font> 0077;;;;N;;;;;
1D431;MATHEMATICAL BOLD SMALL X;Ll;0;L;<font> 0078;;;;N;;;;;
1D432;MATHEMATICAL BOLD SMALL Y;Ll;0;L;<font> 0079;;;;N;;;;;
1D433;MATHEMATICAL BOLD SMALL Z;Ll;0;L;<font> 007A;;;;N;;;;;
1D434;MATHEMATICAL ITALIC CAPITAL A;Lu;0;L;<font> 0041;;;;N;;;;;
1D435;MATHEMATICAL ITALIC CAPITAL B;Lu;0;L;<font> 0042;;;;N;;;;;
1D436;MATHEMATICAL ITALIC CAPITAL C;Lu;0;L;<font> 0043;;;;N;;;;;
1D437;MATHEMATICAL ITALIC CAPITAL D;Lu;0;L;<font> 0044;;;;N;;;;;
1D438;MATHEMATICAL ITALIC CAPITAL E;Lu;0;L;<font> 0045;;;;N;;;;;
1D439;MATHEMATICAL ITALIC CAPITAL F;Lu;0;L;<font> 0046;;;;N;;;;;
1D43A;MATHEMATICAL ITALIC CAPITAL G;Lu;0;L;<font> 0047;;;;N;;;;;
1D43B;MATHEMATICAL ITALIC CAPITAL H;Lu;0;L;<font> 0048;;;;N;;;;;
1D43C;MATHEMATICAL ITALIC CAPITAL I;Lu;0;L;<font> 0049;;;;N;;;;;
1D43D;MATHEMATICAL ITALIC CAPITAL J;Lu;0;L;<font> 004A;;;;N;;;;;
1D43E;MATHEMATICAL ITALIC CAPITAL K;Lu;0;L;<font> 004B;;;;N;;;;;
1D43F;MATHEMATICAL ITALIC CAPITAL L;Lu;0;L;<font> 004C;;;;N;;;;;
1D440;MATHEMATICAL ITALIC CAPITAL M;Lu;0;L;<font> 004D;;;;N;;;;;
1D441;MATHEMATICAL ITALIC CAPITAL N;Lu;0;L;<font> 004E;;;;N;;;;;
1D442;MATHEMATICAL ITALIC CAPITAL O;Lu;0;L;<font> 004F;;;;N;;;;;
1D443;MATHEMATICAL ITALIC CAPITAL P;Lu;0;L;<font> 0050;;;;N;;;;;
1D444;MATHEMATICAL ITALIC CAPITAL Q;Lu;0;L;<font> 0051;;;;N;;;;;
1D445;MATHEMATICAL ITALIC CAPITAL R;Lu;0;L;<font> 0052;;;;N;;;;;
1D446;MATHEMATICAL ITALIC CAPITAL S;Lu;0;L;<font> 0053;;;;N;;;;;
1D447;MATHEMATICAL ITALIC CAPITAL T;Lu;0;L;<font> 0054;;;;N;;;;;
1D448;MATHEMATICAL ITALIC CAPITAL U;Lu;0;L;<font> 0055;;;;N;;;;;
1D449;MATHEMATICAL ITALIC CAPITAL V;Lu;0;L;<font> 0056;;;;N;;;;;
1D44A;MATHEMATICAL ITALIC CAPITAL W;Lu;0;L;<font> 0057;;;;N;;;;;
1D44B;MATHEMATICAL ITALIC CAPITAL X;Lu;0;L;<font> 0058;;;;N;;;;;
1D44C;MATHEMATICAL ITALIC CAPITAL Y;Lu;0;L;<font> 0059;;;;N;;;;;
1D44D;MATHEMATICAL ITALIC CAPITAL Z;Lu;0;L;<font> 005A;;;;N;;;;;
1D44E;MATHEMATICAL ITALIC SMALL A;Ll;0;L;<font> 0061;;;;N;;;;;
1D44F;MATHEMATICAL ITALIC SMALL B;Ll;0;L;<font> 0062;;;;N;;;;;
1D450;MATHEMATICAL ITALIC SMALL C;Ll;0;L;<font> 0063;;;;N;;;;;
1D451;MATHEMATICAL ITALIC SMALL D;Ll;0;L;<font> 0064;;;;N;;;;;
1D452;MATHEMATICAL ITALIC SMALL E;Ll;0;L;<font> 0065;;;;N;;;;;
1D453;MATHEMATICAL ITALIC SMALL F;Ll;0;L;<font> 0066;;;;N;;;;;
1D454;MATHEMATICAL ITALIC SMALL G;Ll;0;L;<font> 0067;;;;N;;;;;
1D456;MATHEMATICAL ITALIC SMALL I;Ll;0;L;<font> 0069;;;;N;;;;;
1D457;MATHEMATICAL ITALIC SMALL J;Ll;0;L;<font> 006A;;;;N;;;;;
1D458;MATHEMATICAL ITALIC SMALL K;Ll;0;L;<font> 006B;;;;N;;;;;
1D459;MATHEMATICAL ITALIC SMALL L;Ll;0;L;<font> 006C;;;;N;;;;;
1D45A;MATHEMATICAL ITALIC SMALL M;Ll;0;L;<font> 006D;;;;N;;;;;
1D45B;MATHEMATICAL ITALIC SMALL N;Ll;0;L;<font> 006E;;;;N;;;;;
1D45C;MATHEMATICAL ITALIC SMALL O;Ll;0;L;<font> 006F;;;;N;;;;;
1D45D;MATHEMATICAL ITALIC SMALL P;Ll;0;L;<font> 0070;;;;N;;;;;
1D45E;MATHEMATICAL ITALIC SMALL Q;Ll;0;L;<font> 0071;;;;N;;;;;
1D45F;MATHEMATICAL ITALIC SMALL R;Ll;0;L;<font> 0072;;;;N;;;;;
1D460;MATHEMATICAL ITALIC SMALL S;Ll;0;L;<font> 0073;;;;N;;;;;
1D461;MATHEMATICAL ITALIC SMALL T;Ll;0;L;<font> 0074;;;;N;;;;;
1D462;MATHEMATICAL ITALIC SMALL U;Ll;0;L;<font> 0075;;;;N;;;;;
1D463;MATHEMATICAL ITALIC SMALL V;Ll;0;L;<font> 0076;;;;N;;;;;
1D464;MATHEMATICAL ITALIC SMALL W;Ll;0;L;<font> 0077;;;;N;;;;;
1D465;MATHEMATICAL ITALIC SMALL X;Ll;0;L;<font> 0078;;;;N;;;;;
1D466;MATHEMATICAL ITALIC SMALL Y;Ll;0;L;<font> 0079;;;;N;;;;;
1D467;MATHEMATICAL ITALIC SMALL Z;Ll;0;L;<font> 007A;;;;N;;;;;
1D468;MATHEMATICAL BOLD ITALIC CAPITAL A;Lu;0;L;<font> 0041;;;;N;;;;;
1D469;MATHEMATICAL BOLD ITALIC CAPITAL B;Lu;0;L;<font> 0042;;;;N;;;;;
1D46A;MATHEMATICAL BOLD ITALIC CAPITAL C;Lu;0;L;<font> 0043;;;;N;;;;;
1D46B;MATHEMATICAL BOLD ITALIC CAPITAL D;Lu;0;L;<font> 0044;;;;N;;;;;
1D46C;MATHEMATICAL BOLD ITALIC CAPITAL E;Lu;0;L;<font> 0045;;;;N;;;;;
1D46D;MATHEMATICAL BOLD ITALIC CAPITAL F;Lu;0;L;<font> 0046;;;;N;;;;;
1D46E;MATHEMATICAL BOLD ITALIC CAPITAL G;Lu;0;L;<font> 0047;;;;N;;;;;
1D46F;MATHEMATICAL BOLD ITALIC CAPITAL H;Lu;0;L;<font> 0048;;;;N;;;;;
1D470;MATHEMATICAL BOLD ITALIC CAPITAL I;Lu;0;L;<font> 0049;;;;N;;;;;
1D471;MATHEMATICAL BOLD ITALIC CAPITAL J;Lu;0;L;<font> 004A;;;;N;;;;;
1D472;MATHEMATICAL BOLD ITALIC CAPITAL K;Lu;0;L;<font> 004B;;;;N;;;;;
1D473;MATHEMATICAL BOLD ITALIC CAPITAL L;Lu;0;L;<font> 004C;;;;N;;;;;
1D474;MATHEMATICAL BOLD ITALIC CAPITAL M;Lu;0;L;<font> 004D;;;;N;;;;;
1D475;MATHEMATICAL BOLD ITALIC CAPITAL N;Lu;0;L;<font> 004E;;;;N;;;;;
1D476;MATHEMATICAL BOLD ITALIC CAPITAL O;Lu;0;L;<font> 004F;;;;N;;;;;
1D477;MATHEMATICAL BOLD ITALIC CAPITAL P;Lu;0;L;<font> 0050;;;;N;;;;;
1D478;MATHEMATICAL BOLD ITALIC CAPITAL Q;Lu;0;L;<font> 0051;;;;N;;;;;
1D479;MATHEMATICAL BOLD ITALIC CAPITAL R;Lu;0;L;<font> 0052;;;;N;;;;;
1D47A;MATHEMATICAL BOLD ITALIC CAPITAL S;Lu;0;L;<font> 0053;;;;N;;;;;
1D47B;MATHEMATICAL BOLD ITALIC CAPITAL T;Lu;0;L;<font> 0054;;;;N;;;;;
1D47C;MATHEMATICAL BOLD ITALIC CAPITAL U;Lu;0;L;<font> 0055;;;;N;;;;;
1D47D;MATHEMATICAL BOLD ITALIC CAPITAL V;Lu;0;L;<font> 0056;;;;N;;;;;
1D47E;MATHEMATICAL BOLD ITALIC CAPITAL W;Lu;0;L;<font> 0057;;;;N;;;;;
1D47F;MATHEMATICAL BOLD ITALIC CAPITAL X;Lu;0;L;<font> 0058;;;;N;;;;;
1D480;MATHEMATICAL BOLD ITALIC CAPITAL Y;Lu;0;L;<font> 0059;;;;N;;;;;
1D481;MATHEMATICAL BOLD ITALIC CAPITAL Z;Lu;0;L;<font> 005A;;;;N;;;;;
1D482;MATHEMATICAL BOLD ITALIC SMALL A;Ll;0;L;<font> 0061;;;;N;;;;;
1D483;MATHEMATICAL BOLD ITALIC SMALL B;Ll;0;L;<font> 0062;;;;N;;;;;
1D484;MATHEMATICAL BOLD ITALIC SMALL C;Ll;0;L;<font> 0063;;;;N;;;;;
1D485;MATHEMATICAL BOLD ITALIC SMALL D;Ll;0;L;<font> 0064;;;;N;;;;;
1D486;MATHEMATICAL BOLD ITALIC SMALL E;Ll;0;L;<font> 0065;;;;N;;;;;
1D487;MATHEMATICAL BOLD ITALIC SMALL F;Ll;0;L;<font> 0066;;;;N;;;;;
1D488;MATHEMATICAL BOLD ITALIC SMALL G;Ll;0;L;<font> 0067;;;;N;;;;;
1D489;MATHEMATICAL BOLD ITALIC SMALL H;Ll;0;L;<font> 0068;;;;N;;;;;
1D48A;MATHEMATICAL BOLD ITALIC SMALL I;Ll;0;L;<font> 0069;;;;N;;;;;
1D48B;MATHEMATICAL BOLD ITALIC SMALL J;Ll;0;L;<font> 006A;;;;N;;;;;
1D48C;MATHEMATICAL BOLD ITALIC SMALL K;Ll;0;L;<font> 006B;;;;N;;;;;
1D48D;MATHEMATICAL BOLD ITALIC SMALL L;Ll;0;L;<font> 006C;;;;N;;;;;
1D48E;MATHEMATICAL BOLD ITALIC SMALL M;Ll;0;L;<font> 006D;;;;N;;;;;
1D48F;MATHEMATICAL BOLD ITALIC SMALL N;Ll;0;L;<font> 006E;;;;N;;;;;
1D490;MATHEMATICAL BOLD ITALIC SMALL O;Ll;0;L;<font> 006F;;;;N;;;;;
1D491;MATHEMATICAL BOLD ITALIC SMALL P;Ll;0;L;<font> 0070;;;;N;;;;;
1D492;MATHEMATICAL BOLD ITALIC SMALL Q;Ll;0;L;<font> 0071;;;;N;;;;;
1D493;MATHEMATICAL BOLD ITALIC SMALL R;Ll;0;L;<font> 0072;;;;N;;;;;
1D494;MATHEMATICAL BOLD ITALIC SMALL S;Ll;0;L;<font> 0073;;;;N;;;;;
1D495;MATHEMATICAL BOLD ITALIC SMALL T;Ll;0;L;<font> 0074;;;;N;;;;;
1D496;MATHEMATICAL BOLD ITALIC SMALL U;Ll;0;L;<font> 0075;;;;N;;;;;
1D497;MATHEMATICAL BOLD ITALIC SMALL V;Ll;0;L;<font> 0076;;;;N;;;;;
1D498;MATHEMATICAL BOLD ITALIC SMALL W;Ll;0;L;<font> 0077;;;;N;;;;;
1D499;MATHEMATICAL BOLD ITALIC SMALL X;Ll;0;L;<font> 0078;;;;N;;;;;
1D49A;MATHEMATICAL BOLD ITALIC SMALL Y;Ll;0;L;<font> 0079;;;;N;;;;;
1D49B;MATHEMATICAL BOLD ITALIC SMALL Z;Ll;0;L;<font> 007A;;;;N;;;;;
1D49C;MATHEMATICAL SCRIPT CAPITAL A;Lu;0;L;<font> 0041;;;;N;;;;;
1D49E;MATHEMATICAL SCRIPT CAPITAL C;Lu;0;L;<font> 0043;;;;N;;;;;
1D49F;MATHEMATICAL SCRIPT CAPITAL D;Lu;0;L;<font> 0044;;;;N;;;;;
1D4A2;MATHEMATICAL SCRIPT CAPITAL G;Lu;0;L;<font> 0047;;;;N;;;;;
1D4A5;MATHEMATICAL SCRIPT CAPITAL J;Lu;0;L;<font> 004A;;;;N;;;;;
1D4A6;MATHEMATICAL SCRIPT CAPITAL K;Lu;0;L;<font> 004B;;;;N;;;;;
1D4A9;MATHEMATICAL SCRIPT CAPITAL N;Lu;0;L;<font> 004E;;;;N;;;;;
1D4AA;MATHEMATICAL SCRIPT CAPITAL O;Lu;0;L;<font> 004F;;;;N;;;;;
1D4AB;MATHEMATICAL SCRIPT CAPITAL P;Lu;0;L;<font> 0050;;;;N;;;;;
1D4AC;MATHEMATICAL SCRIPT CAPITAL Q;Lu;0;L;<font> 0051;;;;N;;;;;
1D4AE;MATHEMATICAL SCRIPT CAPITAL S;Lu;0;L;<font> 0053;;;;N;;;;;
1D4AF;MATHEMATICAL SCRIPT CAPITAL T;Lu;0;L;<font> 0054;;;;N;;;;;
1D4B0;MATHEMATICAL SCRIPT CAPITAL U;Lu;0;L;<font> 0055;;;;N;;;;;
1D4B1;MATHEMATICAL SCRIPT CAPITAL V;Lu;0;L;<font> 0056;;;;N;;;;;
1D4B2;MATHEMATICAL SCRIPT CAPITAL W;Lu;0;L;<font> 0057;;;;N;;;;;
1D4B3;MATHEMATICAL SCRIPT CAPITAL X;Lu;0;L;<font> 0058;;;;N;;;;;
1D4B4;MATHEMATICAL SCRIPT CAPITAL Y;Lu;0;L;<font> 0059;;;;N;;;;;
1D4B5;MATHEMATICAL SCRIPT CAPITAL Z;Lu;0;L;<font> 005A;;;;N;;;;;
1D4B6;MATHEMATICAL SCRIPT SMALL A;Ll;0;L;<font> 0061;;;;N;;;;;
1D4B7;MATHEMATICAL SCRIPT SMALL B;Ll;0;L;<font> 0062;;;;N;;;;;
1D4B8;MATHEMATICAL SCRIPT SMALL C;Ll;0;L;<font> 0063;;;;N;;;;;
1D4B9;MATHEMATICAL SCRIPT SMALL D;Ll;0;L;<font> 0064;;;;N;;;;;
1D4BB;MATHEMATICAL SCRIPT SMALL F;Ll;0;L;<font> 0066;;;;N;;;;;
1D4BD;MATHEMATICAL SCRIPT SMALL H;Ll;0;L;<font> 0068;;;;N;;;;;
1D4BE;MATHEMATICAL SCRIPT SMALL I;Ll;0;L;<font> 0069;;;;N;;;;;
1D4BF;MATHEMATICAL SCRIPT SMALL J;Ll;0;L;<font> 006A;;;;N;;;;;
1D4C0;MATHEMATICAL SCRIPT SMALL K;Ll;0;L;<font> 006B;;;;N;;;;;
1D4C1;MATHEMATICAL SCRIPT SMALL L;Ll;0;L;<font> 006C;;;;N;;;;;
1D4C2;MATHEMATICAL SCRIPT SMALL M;Ll;0;L;<font> 006D;;;;N;;;;;
1D4C3;MATHEMATICAL SCRIPT SMALL N;Ll;0;L;<font> 006E;;;;N;;;;;
1D4C5;MATHEMATICAL SCRIPT SMALL P;Ll;0;L;<font> 0070;;;;N;;;;;
1D4C6;MATHEMATICAL SCRIPT SMALL Q;Ll;0;L;<font> 0071;;;;N;;;;;
1D4C7;MATHEMATICAL SCRIPT SMALL R;Ll;0;L;<font> 0072;;;;N;;;;;
1D4C8;MATHEMATICAL SCRIPT SMALL S;Ll;0;L;<font> 0073;;;;N;;;;;
1D4C9;MATHEMATICAL SCRIPT SMALL T;Ll;0;L;<font> 0074;;;;N;;;;;
1D4CA;MATHEMATICAL SCRIPT SMALL U;Ll;0;L;<font> 0075;;;;N;;;;;
1D4CB;MATHEMATICAL SCRIPT SMALL V;Ll;0;L;<font> 0076;;;;N;;;;;
1D4CC;MATHEMATICAL SCRIPT SMALL W;Ll;0;L;<font> 0077;;;;N;;;;;
1D4CD;MATHEMATICAL SCRIPT SMALL X;Ll;0;L;<font> 0078;;;;N;;;;;
1D4CE;MATHEMATICAL SCRIPT SMALL Y;Ll;0;L;<font> 0079;;;;N;;;;;
1D4CF;MATHEMATICAL SCRIPT SMALL Z;Ll;0;L;<font> 007A;;;;N;;;;;
1D4D0;MATHEMATICAL BOLD SCRIPT CAPITAL A;Lu;0;L;<font> 0041;;;;N;;;;;
1D4D1;MATHEMATICAL BOLD SCRIPT CAPITAL B;Lu;0;L;<font> 0042;;;;N;;;;;
1D4D2;MATHEMATICAL BOLD SCRIPT CAPITAL C;Lu;0;L;<font> 0043;;;;N;;;;;
1D4D3;MATHEMATICAL BOLD SCRIPT CAPITAL D;Lu;0;L;<font> 0044;;;;N;;;;;
1D4D4;MATHEMATICAL BOLD SCRIPT CAPITAL E;Lu;0;L;<font> 0045;;;;N;;;;;
1D4D5;MATHEMATICAL BOLD SCRIPT CAPITAL F;Lu;0;L;<font> 0046;;;;N;;;;;
1D4D6;MATHEMATICAL BOLD SCRIPT CAPITAL G;Lu;0;L;<font> 0047;;;;N;;;;;
1D4D7;MATHEMATICAL BOLD SCRIPT CAPITAL H;Lu;0;L;<font> 0048;;;;N;;;;;
1D4D8;MATHEMATICAL BOLD SCRIPT CAPITAL I;Lu;0;L;<font> 0049;;;;N;;;;;
1D4D9;MATHEMATICAL BOLD SCRIPT CAPITAL J;Lu;0;L;<font> 004A;;;;N;;;;;
1D4DA;MATHEMATICAL BOLD SCRIPT CAPITAL K;Lu;0;L;<font> 004B;;;;N;;;;;
1D4DB;MATHEMATICAL BOLD SCRIPT CAPITAL L;Lu;0;L;<font> 004C;;;;N;;;;;
1D4DC;MATHEMATICAL BOLD SCRIPT CAPITAL M;Lu;0;L;<font> 004D;;;;N;;;;;
1D4DD;MATHEMATICAL BOLD SCRIPT CAPITAL N;Lu;0;L;<font> 004E;;;;N;;;;;
1D4DE;MATHEMATICAL BOLD SCRIPT CAPITAL O;Lu;0;L;<font> 004F;;;;N;;;;;
1D4DF;MATHEMATICAL BOLD SCRIPT CAPITAL P;Lu;0;L;<font> 0050;;;;N;;;;;
1D4E0;MATHEMATICAL BOLD SCRIPT CAPITAL Q;Lu;0;L;<font> 0051;;;;N;;;;;
1D4E1;MATHEMATICAL BOLD SCRIPT CAPITAL R;Lu;0;L;<font> 0052;;;;N;;;;;
1D4E2;MATHEMATICAL BOLD SCRIPT CAPITAL S;Lu;0;L;<font> 0053;;;;N;;;;;
1D4E3;MATHEMATICAL BOLD SCRIPT CAPITAL T;Lu;0;L;<font> 0054;;;;N;;;;;
1D4E4;MATHEMATICAL BOLD SCRIPT CAPITAL U;Lu;0;L;<font> 0055;;;;N;;;;;
1D4E5;MATHEMATICAL BOLD SCRIPT CAPITAL V;Lu;0;L;<font> 0056;;;;N;;;;;
1D4E6;MATHEMATICAL BOLD SCRIPT CAPITAL W;Lu;0;L;<font> 0057;;;;N;;;;;
1D4E7;MATHEMATICAL BOLD SCRIPT CAPITAL X;Lu;0;L;<font> 0058;;;;N;;;;;
1D4E8;MATHEMATICAL BOLD SCRIPT CAPITAL Y;Lu;0;L;<font> 0059;;;;N;;;;;
1D4E9;MATHEMATICAL BOLD SCRIPT CAPITAL Z;Lu;0;L;<font> 005A;;;;N;;;;;
1D4EA;MATHEMATICAL BOLD SCRIPT SMALL A;Ll;0;L;<font> 0061;;;;N;;;;;
1D4EB;MATHEMATICAL BOLD SCRIPT SMALL B;Ll;0;L;<font> 0062;;;;N;;;;;
1D4EC;MATHEMATICAL BOLD SCRIPT SMALL C;Ll;0;L;<font> 0063;;;;N;;;;;
1D4ED;MATHEMATICAL BOLD SCRIPT SMALL D;Ll;0;L;<font> 0064;;;;N;;;;;
1D4EE;MATHEMATICAL BOLD SCRIPT SMALL E;Ll;0;L;<font> 0065;;;;N;;;;;
1D4EF;MATHEMATICAL BOLD SCRIPT SMALL F;Ll;0;L;<font> 0066;;;;N;;;;;
1D4F0;MATHEMATICAL BOLD SCRIPT SMALL G;Ll;0;L;<font> 0067;;;;N;;;;;
1D4F1;MATHEMATICAL BOLD SCRIPT SMALL H;Ll;0;L;<font> 0068;;;;N;;;;;
1D4F2;MATHEMATICAL BOLD SCRIPT SMALL I;Ll;0;L;<font> 0069;;;;N;;;;;
1D4F3;MATHEMATICAL BOLD SCRIPT SMALL J;Ll;0;L;<font> 006A;;;;N;;;;;
1D4F4;MATHEMATICAL BOLD SCRIPT SMALL K;Ll;0;L;<font> 006B;;;;N;;;;;
1D4F5;MATHEMATICAL BOLD SCRIPT SMALL L;Ll;0;L;<font> 006C;;;;N;;;;;
1D4F6;MATHEMATICAL BOLD SCRIPT SMALL M;Ll;0;L;<font> 006D;;;;N;;;;;
1D4F7;MATHEMATICAL BOLD SCRIPT SMALL N;Ll;0;L;<font> 006E;;;;N;;;;;
1D4F8;MATHEMATICAL BOLD SCRIPT SMALL O;Ll;0;L;<font> 006F;;;;N;;;;;
1D4F9;MATHEMATICAL BOLD SCRIPT SMALL P;Ll;0;L;<font> 0070;;;;N;;;;;
1D4FA;MATHEMATICAL BOLD SCRIPT SMALL Q;Ll;0;L;<font> 0071;;;;N;;;;;
1D4FB;MATHEMATICAL BOLD SCRIPT SMALL R;Ll;0;L;<font> 0072;;;;N;;;;;
1D4FC;MATHEMATICAL BOLD SCRIPT SMALL S;Ll;0;L;<font> 0073;;;;N;;;;;
1D4FD;MATHEMATICAL BOLD SCRIPT SMALL T;Ll;0;L;<font> 0074;;;;N;;;;;
1D4FE;MATHEMATICAL BOLD SCRIPT SMALL U;Ll;0;L;<font> 0075;;;;N;;;;;
1D4FF;MATHEMATICAL BOLD SCRIPT SMALL V;Ll;0;L;<font> 0076;;;;N;;;;;
1D500;MATHEMATICAL BOLD SCRIPT SMALL W;Ll;0;L;<font> 0077;;;;N;;;;;
1D501;MATHEMATICAL BOLD SCRIPT SMALL X;Ll;0;L;<font> 0078;;;;N;;;;;
1D502;MATHEMATICAL BOLD SCRIPT SMALL Y;Ll;0;L;<font> 0079;;;;N;;;;;
1D503;MATHEMATICAL BOLD SCRIPT SMALL Z;Ll;0;L;<font> 007A;;;;N;;;;;
1D504;MATHEMATICAL FRAKTUR CAPITAL A;Lu;0;L;<font> 0041;;;;N;;;;;
1D505;MATHEMATICAL FRAKTUR CAPITAL B;Lu;0;L;<font> 0042;;;;N;;;;;
1D507;MATHEMATICAL FRAKTUR CAPITAL D;Lu;0;L;<font> 0044;;;;N;;;;;
1D508;MATHEMATICAL FRAKTUR CAPITAL E;Lu;0;L;<font> 0045;;;;N;;;;;
1D509;MATHEMATICAL FRAKTUR CAPITAL F;Lu;0;L;<font> 0046;;;;N;;;;;
1D50A;MATHEMATICAL FRAKTUR CAPITAL G;Lu;0;L;<font> 0047;;;;N;;;;;
1D50D;MATHEMATICAL FRAKTUR CAPITAL J;Lu;0;L;<font> 004A;;;;N;;;;;
1D50E;MATHEMATICAL FRAKTUR CAPITAL K;Lu;0;L;<font> 004B;;;;N;;;;;
1D50F;MATHEMATICAL FRAKTUR CAPITAL L;Lu;0;L;<font> 004C;;;;N;;;;;
1D510;MATHEMATICAL FRAKTUR CAPITAL M;Lu;0;L;<font> 004D;;;;N;;;;;
1D511;MATHEMATICAL FRAKTUR CAPITAL N;Lu;0;L;<font> 004E;;;;N;;;;;
1D512;MATHEMATICAL FRAKTUR CAPITAL O;Lu;0;L;<font> 004F;;;;N;;;;;
1D513;MATHEMATICAL FRAKTUR CAPITAL P;Lu;0;L;<font> 0050;;;;N;;;;;
1D514;MATHEMATICAL FRAKTUR CAPITAL Q;Lu;0;L;<font> 0051;;;;N;;;;;
1D516;MATHEMATICAL FRAKTUR CAPITAL S;Lu;0;L;<font> 0053;;;;N;;;;;
1D517;MATHEMATICAL FRAKTUR CAPITAL T;Lu;0;L;<font> 0054;;;;N;;;;;
1D518;MATHEMATICAL FRAKTUR CAPITAL U;Lu;0;L;<font> 0055;;;;N;;;;;
1D519;MATHEMATICAL FRAKTUR CAPITAL V;Lu;0;L;<font> 0056;;;;N;;;;;
1D51A;MATHEMATICAL FRAKTUR CAPITAL W;Lu;0;L;<font> 0057;;;;N;;;;;
1D51B;MATHEMATICAL FRAKTUR CAPITAL X;Lu;0;L;<font> 0058;;;;N;;;;;
1D51C;MATHEMATICAL FRAKTUR CAPITAL Y;Lu;0;L;<font> 0059;;;;N;;;;;
1D51E;MATHEMATICAL FRAKTUR SMALL A;Ll;0;L;<font> 0061;;;;N;;;;;
1D51F;MATHEMATICAL FRAKTUR SMALL B;Ll;0;L;<font> 0062;;;;N;;;;;
1D520;MATHEMATICAL FRAKTUR SMALL C;Ll;0;L;<font> 0063;;;;N;;;;;
1D521;MATHEMATICAL FRAKTUR SMALL D;Ll;0;L;<font> 0064;;;;N;;;;;
1D522;MATHEMATICAL FRAKTUR SMALL E;Ll;0;L;<font> 0065;;;;N;;;;;
1D523;MATHEMATICAL FRAKTUR SMALL F;Ll;0;L;<font> 0066;;;;N;;;;;
1D524;MATHEMATICAL FRAKTUR SMALL G;Ll;0;L;<font> 0067;;;;N;;;;;
1D525;MATHEMATICAL FRAKTUR SMALL H;Ll;0;L;<font> 0068;;;;N;;;;;
1D526;MATHEMATICAL FRAKTUR SMALL I;Ll;0;L;<font> 0069;;;;N;;;;;
1D527;MATHEMATICAL FRAKTUR SMALL J;Ll;0;L;<font> 006A;;;;N;;;;;
1D528;MATHEMATICAL FRAKTUR SMALL K;Ll;0;L;<font> 006B;;;;N;;;;;
1D529;MATHEMATICAL FRAKTUR SMALL L;Ll;0;L;<font> 006C;;;;N;;;;;
1D52A;MATHEMATICAL FRAKTUR SMALL M;Ll;0;L;<font> 006D;;;;N;;;;;
1D52B;MATHEMATICAL FRAKTUR SMALL N;Ll;0;L;<font> 006E;;;;N;;;;;
1D52C;MATHEMATICAL FRAKTUR SMALL O;Ll;0;L;<font> 006F;;;;N;;;;;
1D52D;MATHEMATICAL FRAKTUR SMALL P;Ll;0;L;<font> 0070;;;;N;;;;;
1D52E;MATHEMATICAL FRAKTUR SMALL Q;Ll;0;L;<font> 0071;;;;N;;;;;
1D52F;MATHEMATICAL FRAKTUR SMALL R;Ll;0;L;<font> 0072;;;;N;;;;;
1D530;MATHEMATICAL FRAKTUR SMALL S;Ll;0;L;<font> 0073;;;;N;;;;;
1D531;MATHEMATICAL FRAKTUR SMALL T;Ll;0;L;<font> 0074;;;;N;;;;;
1D532;MATHEMATICAL FRAKTUR SMALL U;Ll;0;L;<font> 0075;;;;N;;;;;
1D533;MATHEMATICAL FRAKTUR SMALL V;Ll;0;L;<font> 0076;;;;N;;;;;
1D534;MATHEMATICAL FRAKTUR SMALL W;Ll;0;L;<font> 0077;;;;N;;;;;
1D535;MATHEMATICAL FRAKTUR SMALL X;Ll;0;L;<font> 0078;;;;N;;;;;
1D536;MATHEMATICAL FRAKTUR SMALL Y;Ll;0;L;<font> 0079;;;;N;;;;;
1D537;MATHEMATICAL FRAKTUR SMALL Z;Ll;0;L;<font> 007A;;;;N;;;;;
1D538;MATHEMATICAL DOUBLE-STRUCK CAPITAL A;Lu;0;L;<font> 0041;;;;N;;;;;
1D539;MATHEMATICAL DOUBLE-STRUCK CAPITAL B;Lu;0;L;<font> 0042;;;;N;;;;;
1D53B;MATHEMATICAL DOUBLE-STRUCK CAPITAL D;Lu;0;L;<font> 0044;;;;N;;;;;
1D53C;MATHEMATICAL DOUBLE-STRUCK CAPITAL E;Lu;0;L;<font> 0045;;;;N;;;;;
1D53D;MATHEMATICAL DOUBLE-STRUCK CAPITAL F;Lu;0;L;<font> 0046;;;;N;;;;;
1D53E;MATHEMATICAL DOUBLE-STRUCK CAPITAL G;Lu;0;L;<font> 0047;;;;N;;;;;
1D540;MATHEMATICAL DOUBLE-STRUCK CAPITAL I;Lu;0;L;<font> 0049;;;;N;;;;;
1D541;MATHEMATICAL DOUBLE-STRUCK CAPITAL J;Lu;0;L;<font> 004A;;;;N;;;;;
1D542;MATHEMATICAL DOUBLE-STRUCK CAPITAL K;Lu;0;L;<font> 004B;;;;N;;;;;
1D543;MATHEMATICAL DOUBLE-STRUCK CAPITAL L;Lu;0;L;<font> 004C;;;;N;;;;;
1D544;MATHEMATICAL DOUBLE-STRUCK CAPITAL M;Lu;0;L;<font> 004D;;;;N;;;;;
1D546;MATHEMATICAL DOUBLE-STRUCK CAPITAL O;Lu;0;L;<font> 004F;;;;N;;;;;
1D54A;MATHEMATICAL DOUBLE-STRUCK CAPITAL S;Lu;0;L;<font> 0053;;;;N;;;;;
1D54B;MATHEMATICAL DOUBLE-STRUCK CAPITAL T;Lu;0;L;<font> 0054;;;;N;;;;;
1D54C;MATHEMATICAL DOUBLE-STRUCK CAPITAL U;Lu;0;L;<font> 0055;;;;N;;;;;
1D54D;MATHEMATICAL DOUBLE-STRUCK CAPITAL V;Lu;0;L;<font> 0056;;;;N;;;;;
1D54E;MATHEMATICAL DOUBLE-STRUCK CAPITAL W;Lu;0;L;<font> 0057;;;;N;;;;;
1D54F;MATHEMATICAL DOUBLE-STRUCK CAPITAL X;Lu;0;L;<font> 0058;;;;N;;;;;
1D550;MATHEMATICAL DOUBLE-STRUCK CAPITAL Y;Lu;0;L;<font> 0059;;;;N;;;;;
1D552;MATHEMATICAL DOUBLE-STRUCK SMALL A;Ll;0;L;<font> 0061;;;;N;;;;;
1D553;MATHEMATICAL DOUBLE-STRUCK SMALL B;Ll;0;L;<font> 0062;;;;N;;;;;
1D554;MATHEMATICAL DOUBLE-STRUCK SMALL C;Ll;0;L;<font> 0063;;;;N;;;;;
1D555;MATHEMATICAL DOUBLE-STRUCK SMALL D;Ll;0;L;<font> 0064;;;;N;;;;;
1D556;MATHEMATICAL DOUBLE-STRUCK SMALL E;Ll;0;L;<font> 0065;;;;N;;;;;
1D557;MATHEMATICAL DOUBLE-STRUCK SMALL F;Ll;0;L;<font> 0066;;;;N;;;;;
1D558;MATHEMATICAL DOUBLE-STRUCK SMALL G;Ll;0;L;<font> 0067;;;;N;;;;;
1D559;MATHEMATICAL DOUBLE-STRUCK SMALL H;Ll;0;L;<font> 0068;;;;N;;;;;
1D55A;MATHEMATICAL DOUBLE-STRUCK SMALL I;Ll;0;L;<font> 0069;;;;N;;;;;
1D55B;MATHEMATICAL DOUBLE-STRUCK SMALL J;Ll;0;L;<font> 006A;;;;N;;;;;
1D55C;MATHEMATICAL DOUBLE-STRUCK SMALL K;Ll;0;L;<font> 006B;;;;N;;;;;
1D55D;MATHEMATICAL DOUBLE-STRUCK SMALL L;Ll;0;L;<font> 006C;;;;N;;;;;
1D55E;MATHEMATICAL DOUBLE-STRUCK SMALL M;Ll;0;L;<font> 006D;;;;N;;;;;
1D55F;MATHEMATICAL DOUBLE-STRUCK SMALL N;Ll;0;L;<font> 006E;;;;N;;;;;
1D560;MATHEMATICAL DOUBLE-STRUCK SMALL O;Ll;0;L;<font> 006F;;;;N;;;;;
1D561;MATHEMATICAL DOUBLE-STRUCK SMALL P;Ll;0;L;<font> 0070;;;;N;;;;;
1D562;MATHEMATICAL DOUBLE-STRUCK SMALL Q;Ll;0;L;<font> 0071;;;;N;;;;;
1D563;MATHEMATICAL DOUBLE-STRUCK SMALL R;Ll;0;L;<font> 0072;;;;N;;;;;
1D564;MATHEMATICAL DOUBLE-STRUCK SMALL S;Ll;0;L;<font> 0073;;;;N;;;;;
1D565;MATHEMATICAL DOUBLE-STRUCK SMALL T;Ll;0;L;<font> 0074;;;;N;;;;;
1D566;MATHEMATICAL DOUBLE-STRUCK SMALL U;Ll;0;L;<font> 0075;;;;N;;;;;
1D567;MATHEMATICAL DOUBLE-STRUCK SMALL V;Ll;0;L;<font> 0076;;;;N;;;;;
1D568;MATHEMATICAL DOUBLE-STRUCK SMALL W;Ll;0;L;<font> 0077;;;;N;;;;;
1D569;MATHEMATICAL DOUBLE-STRUCK SMALL X;Ll;0;L;<font> 0078;;;;N;;;;;
1D56A;MATHEMATICAL DOUBLE-STRUCK SMALL Y;Ll;0;L;<font> 0079;;;;N;;;;;
1D56B;MATHEMATICAL DOUBLE-STRUCK SMALL Z;Ll;0;L;<font> 007A;;;;N;;;;;
1D56C;MATHEMATICAL BOLD FRAKTUR CAPITAL A;Lu;0;L;<font> 0041;;;;N;;;;;
1D56D;MATHEMATICAL BOLD FRAKTUR CAPITAL B;Lu;0;L;<font> 0042;;;;N;;;;;
1D56E;MATHEMATICAL BOLD FRAKTUR CAPITAL C;Lu;0;L;<font> 0043;;;;N;;;;;
1D56F;MATHEMATICAL BOLD FRAKTUR CAPITAL D;Lu;0;L;<font> 0044;;;;N;;;;;
1D570;MATHEMATICAL BOLD FRAKTUR CAPITAL E;Lu;0;L;<font> 0045;;;;N;;;;;
1D571;MATHEMATICAL BOLD FRAKTUR CAPITAL F;Lu;0;L;<font> 0046;;;;N;;;;;
1D572;MATHEMATICAL BOLD FRAKTUR CAPITAL G;Lu;0;L;<font> 0047;;;;N;;;;;
1D573;MATHEMATICAL BOLD FRAKTUR CAPITAL H;Lu;0;L;<font> 0048;;;;N;;;;;
1D574;MATHEMATICAL BOLD FRAKTUR CAPITAL I;Lu;0;L;<font> 0049;;;;N;;;;;
1D575;MATHEMATICAL BOLD FRAKTUR CAPITAL J;Lu;0;L;<font> 004A;;;;N;;;;;
1D576;MATHEMATICAL BOLD FRAKTUR CAPITAL K;Lu;0;L;<font> 004B;;;;N;;;;;
1D577;MATHEMATICAL BOLD FRAKTUR CAPITAL L;Lu;0;L;<font> 004C;;;;N;;;;;
1D578;MATHEMATICAL BOLD FRAKTUR CAPITAL M;Lu;0;L;<font> 004D;;;;N;;;;;
1D579;MATHEMATICAL BOLD FRAKTUR CAPITAL N;Lu;0;L;<font> 004E;;;;N;;;;;
1D57A;MATHEMATICAL BOLD FRAKTUR CAPITAL O;Lu;0;L;<font> 004F;;;;N;;;;;
1D57B;MATHEMATICAL BOLD FRAKTUR CAPITAL P;Lu;0;L;<font> 0050;;;;N;;;;;
1D57C;MATHEMATICAL BOLD FRAKTUR CAPITAL Q;Lu;0;L;<font> 0051;;;;N;;;;;
1D57D;MATHEMATICAL BOLD FRAKTUR CAPITAL R;Lu;0;L;<font> 0052;;;;N;;;;;
1D57E;MATHEMATICAL BOLD FRAKTUR CAPITAL S;Lu;0;L;<font> 0053;;;;N;;;;;
1D57F;MATHEMATICAL BOLD FRAKTUR CAPITAL T;Lu;0;L;<font> 0054;;;;N;;;;;
1D580;MATHEMATICAL BOLD FRAKTUR CAPITAL U;Lu;0;L;<font> 0055;;;;N;;;;;
1D581;MATHEMATICAL BOLD FRAKTUR CAPITAL V;Lu;0;L;<font> 0056;;;;N;;;;;
1D582;MATHEMATICAL BOLD FRAKTUR CAPITAL W;Lu;0;L;<font> 0057;;;;N;;;;;
1D583;MATHEMATICAL BOLD FRAKTUR CAPITAL X;Lu;0;L;<font> 0058;;;;N;;;;;
1D584;MATHEMATICAL BOLD FRAKTUR CAPITAL Y;Lu;0;L;<font> 0059;;;;N;;;;;
1D585;MATHEMATICAL BOLD FRAKTUR CAPITAL Z;Lu;0;L;<font> 005A;;;;N;;;;;
1D586;MATHEMATICAL BOLD FRAKTUR SMALL A;Ll;0;L;<font> 0061;;;;N;;;;;
1D587;MATHEMATICAL BOLD FRAKTUR SMALL B;Ll;0;L;<font> 0062;;;;N;;;;;
1D588;MATHEMATICAL BOLD FRAKTUR SMALL C;Ll;0;L;<font> 0063;;;;N;;;;;
1D589;MATHEMATICAL BOLD FRAKTUR SMALL D;Ll;0;L;<font> 0064;;;;N;;;;;
1D58A;MATHEMATICAL BOLD FRAKTUR SMALL E;Ll;0;L;<font> 0065;;;;N;;;;;
1D58B;MATHEMATICAL BOLD FRAKTUR SMALL F;Ll;0;L;<font> 0066;;;;N;;;;;
1D58C;MATHEMATICAL BOLD FRAKTUR SMALL G;Ll;0;L;<font> 0067;;;;N;;;;;
1D58D;MATHEMATICAL BOLD FRAKTUR SMALL H;Ll;0;L;<font> 0068;;;;N;;;;;
1D58E;MATHEMATICAL BOLD FRAKTUR SMALL I;Ll;0;L;<font> 0069;;;;N;;;;;
1D58F;MATHEMATICAL BOLD FRAKTUR SMALL J;Ll;0;L;<font> 006A;;;;N;;;;;
1D590;MATHEMATICAL BOLD FRAKTUR SMALL K;Ll;0;L;<font> 006B;;;;N;;;;;
1D591;MATHEMATICAL BOLD FRAKTUR SMALL L;Ll;0;L;<font> 006C;;;;N;;;;;
1D592;MATHEMATICAL BOLD FRAKTUR SMALL M;Ll;0;L;<font> 006D;;;;N;;;;;
1D593;MATHEMATICAL BOLD FRAKTUR SMALL N;Ll;0;L;<font> 006E;;;;N;;;;;
1D594;MATHEMATICAL BOLD FRAKTUR SMALL O;Ll;0;L;<font> 006F;;;;N;;;;;
1D595;MATHEMATICAL BOLD FRAKTUR SMALL P;Ll;0;L;<font> 0070;;;;N;;;;;
1D596;MATHEMATICAL BOLD FRAKTUR SMALL Q;Ll;0;L;<font> 0071;;;;N;;;;;
1D597;MATHEMATICAL BOLD FRAKTUR SMALL R;Ll;0;L;<font> 0072;;;;N;;;;;
1D598;MATHEMATICAL BOLD FRAKTUR SMALL S;Ll;0;L;<font> 0073;;;;N;;;;;
1D599;MATHEMATICAL BOLD FRAKTUR SMALL T;Ll;0;L;<font> 0074;;;;N;;;;;
1D59A;MATHEMATICAL BOLD FRAKTUR SMALL U;Ll;0;L;<font> 0075;;;;N;;;;;
1D59B;MATHEMATICAL BOLD FRAKTUR SMALL V;Ll;0;L;<font> 0076;;;;N;;;;;
1D59C;MATHEMATICAL BOLD FRAKTUR SMALL W;Ll;0;L;<font> 0077;;;;N;;;;;
1D59D;MATHEMATICAL BOLD FRAKTUR SMALL X;Ll;0;L;<font> 0078;;;;N;;;;;
1D59E;MATHEMATICAL BOLD FRAKTUR SMALL Y;Ll;0;L;<font> 0079;;;;N;;;;;
1D59F;MATHEMATICAL BOLD FRAKTUR SMALL Z;Ll;0;L;<font> 007A;;;;N;;;;;
1D5A0;MATHEMATICAL SANS-SERIF CAPITAL A;Lu;0;L;<font> 0041;;;;N;;;;;
1D5A1;MATHEMATICAL SANS-SERIF CAPITAL B;Lu;0;L;<font> 0042;;;;N;;;;;
1D5A2;MATHEMATICAL SANS-SERIF CAPITAL C;Lu;0;L;<font> 0043;;;;N;;;;;
1D5A3;MATHEMATICAL SANS-SERIF CAPITAL D;Lu;0;L;<font> 0044;;;;N;;;;;
1D5A4;MATHEMATICAL SANS-SERIF CAPITAL E;Lu;0;L;<font> 0045;;;;N;;;;;
1D5A5;MATHEMATICAL SANS-SERIF CAPITAL F;Lu;0;L;<font> 0046;;;;N;;;;;
1D5A6;MATHEMATICAL SANS-SERIF CAPITAL G;Lu;0;L;<font> 0047;;;;N;;;;;
1D5A7;MATHEMATICAL SANS-SERIF CAPITAL H;Lu;0;L;<font> 0048;;;;N;;;;;
1D5A8;MATHEMATICAL SANS-SERIF CAPITAL I;Lu;0;L;<font> 0049;;;;N;;;;;
1D5A9;MATHEMATICAL SANS-SERIF CAPITAL J;Lu;0;L;<font> 004A;;;;N;;;;;
1D5AA;MATHEMATICAL SANS-SERIF CAPITAL K;Lu;0;L;<font> 004B;;;;N;;;;;
1D5AB;MATHEMATICAL SANS-SERIF CAPITAL L;Lu;0;L;<font> 004C;;;;N;;;;;
1D5AC;MATHEMATICAL SANS-SERIF CAPITAL M;Lu;0;L;<font> 004D;;;;N;;;;;
1D5AD;MATHEMATICAL SANS-SERIF CAPITAL N;Lu;0;L;<font> 004E;;;;N;;;;;
1D5AE;MATHEMATICAL SANS-SERIF CAPITAL O;Lu;0;L;<font> 004F;;;;N;;;;;
1D5AF;MATHEMATICAL SANS-SERIF CAPITAL P;Lu;0;L;<font> 0050;;;;N;;;;;
1D5B0;MATHEMATICAL SANS-SERIF CAPITAL Q;Lu;0;L;<font> 0051;;;;N;;;;;
1D5B1;MATHEMATICAL SANS-SERIF CAPITAL R;Lu;0;L;<font> 0052;;;;N;;;;;
1D5B2;MATHEMATICAL SANS-SERIF CAPITAL S;Lu;0;L;<font> 0053;;;;N;;;;;
1D5B3;MATHEMATICAL SANS-SERIF CAPITAL T;Lu;0;L;<font> 0054;;;;N;;;;;
1D5B4;MATHEMATICAL SANS-SERIF CAPITAL U;Lu;0;L;<font> 0055;;;;N;;;;;
1D5B5;MATHEMATICAL SANS-SERIF CAPITAL V;Lu;0;L;<font> 0056;;;;N;;;;;
1D5B6;MATHEMATICAL SANS-SERIF CAPITAL W;Lu;0;L;<font> 0057;;;;N;;;;;
1D5B7;MATHEMATICAL SANS-SERIF CAPITAL X;Lu;0;L;<font> 0058;;;;N;;;;;
1D5B8;MATHEMATICAL SANS-SERIF CAPITAL Y;Lu;0;L;<font> 0059;;;;N;;;;;
1D5B9;MATHEMATICAL SANS-SERIF CAPITAL Z;Lu;0;L;<font> 005A;;;;N;;;;;
1D5BA;MATHEMATICAL SANS-SERIF SMALL A;Ll;0;L;<font> 0061;;;;N;;;;;
1D5BB;MATHEMATICAL SANS-SERIF SMALL B;Ll;0;L;<font> 0062;;;;N;;;;;
1D5BC;MATHEMATICAL SANS-SERIF SMALL C;Ll;0;L;<font> 0063;;;;N;;;;;
1D5BD;MATHEMATICAL SANS-SERIF SMALL D;Ll;0;L;<font> 0064;;;;N;;;;;
1D5BE;MATHEMATICAL SANS-SERIF SMALL E;Ll;0;L;<font> 0065;;;;N;;;;;
1D5BF;MATHEMATICAL SANS-SERIF SMALL F;Ll;0;L;<font> 0066;;;;N;;;;;
1D5C0;MATHEMATICAL SANS-SERIF SMALL G;Ll;0;L;<font> 0067;;;;N;;;;;
1D5C1;MATHEMATICAL SANS-SERIF SMALL H;Ll;0;L;<font> 0068;;;;N;;;;;
1D5C2;MATHEMATICAL SANS-SERIF SMALL I;Ll;0;L;<font> 0069;;;;N;;;;;
1D5C3;MATHEMATICAL SANS-SERIF SMALL J;Ll;0;L;<font> 006A;;;;N;;;;;
1D5C4;MATHEMATICAL SANS-SERIF SMALL K;Ll;0;L;<font> 006B;;;;N;;;;;
1D5C5;MATHEMATICAL SANS-SERIF SMALL L;Ll;0;L;<font> 006C;;;;N;;;;;
1D5C6;MATHEMATICAL SANS-SERIF SMALL M;Ll;0;L;<font> 006D;;;;N;;;;;
1D5C7;MATHEMATICAL SANS-SERIF SMALL N;Ll;0;L;<font> 006E;;;;N;;;;;
1D5C8;MATHEMATICAL SANS-SERIF SMALL O;Ll;0;L;<font> 006F;;;;N;;;;;
1D5C9;MATHEMATICAL SANS-SERIF SMALL P;Ll;0;L;<font> 0070;;;;N;;;;;
1D5CA;MATHEMATICAL SANS-SERIF SMALL Q;Ll;0;L;<font> 0071;;;;N;;;;;
1D5CB;MATHEMATICAL SANS-SERIF SMALL R;Ll;0;L;<font> 0072;;;;N;;;;;
1D5CC;MATHEMATICAL SANS-SERIF SMALL S;Ll;0;L;<font> 0073;;;;N;;;;;
1D5CD;MATHEMATICAL SANS-SERIF SMALL T;Ll;0;L;<font> 0074;;;;N;;;;;
1D5CE;MATHEMATICAL SANS-SERIF SMALL U;Ll;0;L;<font> 0075;;;;N;;;;;
1D5CF;MATHEMATICAL SANS-SERIF SMALL V;Ll;0;L;<font> 0076;;;;N;;;;;
1D5D0;MATHEMATICAL SANS-SERIF SMALL W;Ll;0;L;<font> 0077;;;;N;;;;;
1D5D1;MATHEMATICAL SANS-SERIF SMALL X;Ll;0;L;<font> 0078;;;;N;;;;;
1D5D2;MATHEMATICAL SANS-SERIF SMALL Y;Ll;0;L;<font> 0079;;;;N;;;;;
1D5D3;MATHEMATICAL SANS-SERIF SMALL Z;Ll;0;L;<font> 007A;;;;N;;;;;
1D5D4;MATHEMATICAL SANS-SERIF BOLD CAPITAL A;Lu;0;L;<font> 0041;;;;N;;;;;
1D5D5;MATHEMATICAL SANS-SERIF BOLD CAPITAL B;Lu;0;L;<font> 0042;;;;N;;;;;
1D5D6;MATHEMATICAL SANS-SERIF BOLD CAPITAL C;Lu;0;L;<font> 0043;;;;N;;;;;
1D5D7;MATHEMATICAL SANS-SERIF BOLD CAPITAL D;Lu;0;L;<font> 0044;;;;N;;;;;
1D5D8;MATHEMATICAL SANS-SERIF BOLD CAPITAL E;Lu;0;L;<font> 0045;;;;N;;;;;
1D5D9;MATHEMATICAL SANS-SERIF BOLD CAPITAL F;Lu;0;L;<font> 0046;;;;N;;;;;
1D5DA;MATHEMATICAL SANS-SERIF BOLD CAPITAL G;Lu;0;L;<font> 0047;;;;N;;;;;
1D5DB;MATHEMATICAL SANS-SERIF BOLD CAPITAL H;Lu;0;L;<font> 0048;;;;N;;;;;
1D5DC;MATHEMATICAL SANS-SERIF BOLD CAPITAL I;Lu;0;L;<font> 0049;;;;N;;;;;
1D5DD;MATHEMATICAL SANS-SERIF BOLD CAPITAL J;Lu;0;L;<font> 004A;;;;N;;;;;
1D5DE;MATHEMATICAL SANS-SERIF BOLD CAPITAL K;Lu;0;L;<font> 004B;;;;N;;;;;
1D5DF;MATHEMATICAL SANS-SERIF BOLD CAPITAL L;Lu;0;L;<font> 004C;;;;N;;;;;
1D5E0;MATHEMATICAL SANS-SERIF BOLD CAPITAL M;Lu;0;L;<font> 004D;;;;N;;;;;
1D5E1;MATHEMATICAL SANS-SERIF BOLD CAPITAL N;Lu;0;L;<font> 004E;;;;N;;;;;
1D5E2;MATHEMATICAL SANS-SERIF BOLD CAPITAL O;Lu;0;L;<font> 004F;;;;N;;;;;
1D5E3;MATHEMATICAL SANS-SERIF BOLD CAPITAL P;Lu;0;L;<font> 0050;;;;N;;;;;
1D5E4;MATHEMATICAL SANS-SERIF BOLD CAPITAL Q;Lu;0;L;<font> 0051;;;;N;;;;;
1D5E5;MATHEMATICAL SANS-SERIF BOLD CAPITAL R;Lu;0;L;<font> 0052;;;;N;;;;;
1D5E6;MATHEMATICAL SANS-SERIF BOLD CAPITAL S;Lu;0;L;<font> 0053;;;;N;;;;;
1D5E7;MATHEMATICAL SANS-SERIF BOLD CAPITAL T;Lu;0;L;<font> 0054;;;;N;;;;;
1D5E8;MATHEMATICAL SANS-SERIF BOLD CAPITAL U;Lu;0;L;<font> 0055;;;;N;;;;;
1D5E9;MATHEMATICAL SANS-SERIF BOLD CAPITAL V;Lu;0;L;<font> 0056;;;;N;;;;;
1D5EA;MATHEMATICAL SANS-SERIF BOLD CAPITAL W;Lu;0;L;<font> 0057;;;;N;;;;;
1D5EB;MATHEMATICAL SANS-SERIF BOLD CAPITAL X;Lu;0;L;<font> 0058;;;;N;;;;;
1D5EC;MATHEMATICAL SANS-SERIF BOLD CAPITAL Y;Lu;0;L;<font> 0059;;;;N;;;;;
1D5ED;MATHEMATICAL SANS-SERIF BOLD CAPITAL Z;Lu;0;L;<font> 005A;;;;N;;;;;
1D5EE;MATHEMATICAL SANS-SERIF BOLD SMALL A;Ll;0;L;<font> 0061;;;;N;;;;;
1D5EF;MATHEMATICAL SANS-SERIF BOLD SMALL B;Ll;0;L;<font> 0062;;;;N;;;;;
1D5F0;MATHEMATICAL SANS-SERIF BOLD SMALL C;Ll;0;L;<font> 0063;;;;N;;;;;
1D5F1;MATHEMATICAL SANS-SERIF BOLD SMALL D;Ll;0;L;<font> 0064;;;;N;;;;;
1D5F2;MATHEMATICAL SANS-SERIF BOLD SMALL E;Ll;0;L;<font> 0065;;;;N;;;;;
1D5F3;MATHEMATICAL SANS-SERIF BOLD SMALL F;Ll;0;L;<font> 0066;;;;N;;;;;
1D5F4;MATHEMATICAL SANS-SERIF BOLD SMALL G;Ll;0;L;<font> 0067;;;;N;;;;;
1D5F5;MATHEMATICAL SANS-SERIF BOLD SMALL H;Ll;0;L;<font> 0068;;;;N;;;;;
1D5F6;MATHEMATICAL SANS-SERIF BOLD SMALL I;Ll;0;L;<font> 0069;;;;N;;;;;
1D5F7;MATHEMATICAL SANS-SERIF BOLD SMALL J;Ll;0;L;<font> 006A;;;;N;;;;;
1D5F8;MATHEMATICAL SANS-SERIF BOLD SMALL K;Ll;0;L;<font> 006B;;;;N;;;;;
1D5F9;MATHEMATICAL SANS-SERIF BOLD SMALL L;Ll;0;L;<font> 006C;;;;N;;;;;
1D5FA;MATHEMATICAL SANS-SERIF BOLD SMALL M;Ll;0;L;<font> 006D;;;;N;;;;;
1D5FB;MATHEMATICAL SANS-SERIF BOLD SMALL N;Ll;0;L;<font> 006E;;;;N;;;;;
1D5FC;MATHEMATICAL SANS-SERIF BOLD SMALL O;Ll;0;L;<font> 006F;;;;N;;;;;
1D5FD;MATHEMATICAL SANS-SERIF BOLD SMALL P;Ll;0;L;<font> 0070;;;;N;;;;;
1D5FE;MATHEMATICAL SANS-SERIF BOLD SMALL Q;Ll;0;L;<font> 0071;;;;N;;;;;
1D5FF;MATHEMATICAL SANS-SERIF BOLD SMALL R;Ll;0;L;<font> 0072;;;;N;;;;;
1D600;MATHEMATICAL SANS-SERIF BOLD SMALL S;Ll;0;L;<font> 0073;;;;N;;;;;
1D601;MATHEMATICAL SANS-SERIF BOLD SMALL T;Ll;0;L;<font> 0074;;;;N;;;;;
1D602;MATHEMATICAL SANS-SERIF BOLD SMALL U;Ll;0;L;<font> 0075;;;;N;;;;;
1D603;MATHEMATICAL SANS-SERIF BOLD SMALL V;Ll;0;L;<font> 0076;;;;N;;;;;
1D604;MATHEMATICAL SANS-SERIF BOLD SMALL W;Ll;0;L;<font> 0077;;;;N;;;;;
1D605;MATHEMATICAL SANS-SERIF BOLD SMALL X;Ll;0;L;<font> 0078;;;;N;;;;;
1D606;MATHEMATICAL SANS-SERIF BOLD SMALL Y;Ll;0;L;<font> 0079;;;;N;;;;;
1D607;MATHEMATICAL SANS-SERIF BOLD SMALL Z;Ll;0;L;<font> 007A;;;;N;;;;;
1D608;MATHEMATICAL SANS-SERIF ITALIC CAPITAL A;Lu;0;L;<font> 0041;;;;N;;;;;
1D609;MATHEMATICAL SANS-SERIF ITALIC CAPITAL B;Lu;0;L;<font> 0042;;;;N;;;;;
1D60A;MATHEMATICAL SANS-SERIF ITALIC CAPITAL C;Lu;0;L;<font> 0043;;;;N;;;;;
1D60B;MATHEMATICAL SANS-SERIF ITALIC CAPITAL D;Lu;0;L;<font> 0044;;;;N;;;;;
1D60C;MATHEMATICAL SANS-SERIF ITALIC CAPITAL E;Lu;0;L;<font> 0045;;;;N;;;;;
1D60D;MATHEMATICAL SANS-SERIF ITALIC CAPITAL F;Lu;0;L;<font> 0046;;;;N;;;;;
1D60E;MATHEMATICAL SANS-SERIF ITALIC CAPITAL G;Lu;0;L;<font> 0047;;;;N;;;;;
1D60F;MATHEMATICAL SANS-SERIF ITALIC CAPITAL H;Lu;0;L;<font> 0048;;;;N;;;;;
1D610;MATHEMATICAL SANS-SERIF ITALIC CAPITAL I;Lu;0;L;<font> 0049;;;;N;;;;;
1D611;MATHEMATICAL SANS-SERIF ITALIC CAPITAL J;Lu;0;L;<font> 004A;;;;N;;;;;
1D612;MATHEMATICAL SANS-SERIF ITALIC CAPITAL K;Lu;0;L;<font> 004B;;;;N;;;;;
1D613;MATHEMATICAL SANS-SERIF ITALIC CAPITAL L;Lu;0;L;<font> 004C;;;;N;;;;;
1D614;MATHEMATICAL SANS-SERIF ITALIC CAPITAL M;Lu;0;L;<font> 004D;;;;N;;;;;
1D615;MATHEMATICAL SANS-SERIF ITALIC CAPITAL N;Lu;0;L;<font> 004E;;;;N;;;;;
1D616;MATHEMATICAL SANS-SERIF ITALIC CAPITAL O;Lu;0;L;<font> 004F;;;;N;;;;;
1D617;MATHEMATICAL SANS-SERIF ITALIC CAPITAL P;Lu;0;L;<font> 0050;;;;N;;;;;
1D618;MATHEMATICAL SANS-SERIF ITALIC CAPITAL Q;Lu;0;L;<font> 0051;;;;N;;;;;
1D619;MATHEMATICAL SANS-SERIF ITALIC CAPITAL R;Lu;0;L;<font> 0052;;;;N;;;;;
1D61A;MATHEMATICAL SANS-SERIF ITALIC CAPITAL S;Lu;0;L;<font> 0053;;;;N;;;;;
1D61B;MATHEMATICAL SANS-SERIF ITALIC CAPITAL T;Lu;0;L;<font> 0054;;;;N;;;;;
1D61C;MATHEMATICAL SANS-SERIF ITALIC CAPITAL U;Lu;0;L;<font> 0055;;;;N;;;;;
1D61D;MATHEMATICAL SANS-SERIF ITALIC CAPITAL V;Lu;0;L;<font> 0056;;;;N;;;;;
1D61E;MATHEMATICAL SANS-SERIF ITALIC CAPITAL W;Lu;0;L;<font> 0057;;;;N;;;;;
1D61F;MATHEMATICAL SANS-SERIF ITALIC CAPITAL X;Lu;0;L;<font> 0058;;;;N;;;;;
1D620;MATHEMATICAL SANS-SERIF ITALIC CAPITAL Y;Lu;0;L;<font> 0059;;;;N;;;;;
1D621;MATHEMATICAL SANS-SERIF ITALIC CAPITAL Z;Lu;0;L;<font> 005A;;;;N;;;;;
1D622;MATHEMATICAL SANS-SERIF ITALIC SMALL A;Ll;0;L;<font> 0061;;;;N;;;;;
1D623;MATHEMATICAL SANS-SERIF ITALIC SMALL B;Ll;0;L;<font> 0062;;;;N;;;;;
1D624;MATHEMATICAL SANS-SERIF ITALIC SMALL C;Ll;0;L;<font> 0063;;;;N;;;;;
1D625;MATHEMATICAL SANS-SERIF ITALIC SMALL D;Ll;0;L;<font> 0064;;;;N;;;;;
1D626;MATHEMATICAL SANS-SERIF ITALIC SMALL E;Ll;0;L;<font> 0065;;;;N;;;;;
1D627;MATHEMATICAL SANS-SERIF ITALIC SMALL F;Ll;0;L;<font> 0066;;;;N;;;;;
1D628;MATHEMATICAL SANS-SERIF ITALIC SMALL G;Ll;0;L;<font> 0067;;;;N;;;;;
1D629;MATHEMATICAL SANS-SERIF ITALIC SMALL H;Ll;0;L;<font> 0068;;;;N;;;;;
1D62A;MATHEMATICAL SANS-SERIF ITALIC SMALL I;Ll;0;L;<font> 0069;;;;N;;;;;
1D62B;MATHEMATICAL SANS-SERIF ITALIC SMALL J;Ll;0;L;<font> 006A;;;;N;;;;;
1D62C;MATHEMATICAL SANS-SERIF ITALIC SMALL K;Ll;0;L;<font> 006B;;;;N;;;;;
1D62D;MATHEMATICAL SANS-SERIF ITALIC SMALL L;Ll;0;L;<font> 006C;;;;N;;;;;
1D62E;MATHEMATICAL SANS-SERIF ITALIC SMALL M;Ll;0;L;<font> 006D;;;;N;;;;;
1D62F;MATHEMATICAL SANS-SERIF ITALIC SMALL N;Ll;0;L;<font> 006E;;;;N;;;;;
1D630;MATHEMATICAL SANS-SERIF ITALIC SMALL O;Ll;0;L;<font> 006F;;;;N;;;;;
1D631;MATHEMATICAL SANS-SERIF ITALIC SMALL P;Ll;0;L;<font> 0070;;;;N;;;;;
1D632;MATHEMATICAL SANS-SERIF ITALIC SMALL Q;Ll;0;L;<font> 0071;;;;N;;;;;
1D633;MATHEMATICAL SANS-SERIF ITALIC SMALL R;Ll;0;L;<font> 0072;;;;N;;;;;
1D634;MATHEMATICAL SANS-SERIF ITALIC SMALL S;Ll;0;L;<font> 0073;;;;N;;;;;
1D635;MATHEMATICAL SANS-SERIF ITALIC SMALL T;Ll;0;L;<font> 0074;;;;N;;;;;
1D636;MATHEMATICAL SANS-SERIF ITALIC SMALL U;Ll;0;L;<font> 0075;;;;N;;;;;
1D637;MATHEMATICAL SANS-SERIF ITALIC SMALL V;Ll;0;L;<font> 0076;;;;N;;;;;
1D638;MATHEMATICAL SANS-SERIF ITALIC SMALL W;Ll;0;L;<font> 0077;;;;N;;;;;
1D639;MATHEMATICAL SANS-SERIF ITALIC SMALL X;Ll;0;L;<font> 0078;;;;N;;;;;
1D63A;MATHEMATICAL SANS-SERIF ITALIC SMALL Y;Ll;0;L;<font> 0079;;;;N;;;;;
1D63B;MATHEMATICAL SANS-SERIF ITALIC SMALL Z;Ll;0;L;<font> 007A;;;;N;;;;;
1D63C;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL A;Lu;0;L;<font> 0041;;;;N;;;;;
1D63D;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL B;Lu;0;L;<font> 0042;;;;N;;;;;
1D63E;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL C;Lu;0;L;<font> 0043;;;;N;;;;;
1D63F;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL D;Lu;0;L;<font> 0044;;;;N;;;;;
1D640;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL E;Lu;0;L;<font> 0045;;;;N;;;;;
1D641;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL F;Lu;0;L;<font> 0046;;;;N;;;;;
1D642;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL G;Lu;0;L;<font> 0047;;;;N;;;;;
1D643;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL H;Lu;0;L;<font> 0048;;;;N;;;;;
1D644;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL I;Lu;0;L;<font> 0049;;;;N;;;;;
1D645;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL J;Lu;0;L;<font> 004A;;;;N;;;;;
1D646;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL K;Lu;0;L;<font> 004B;;;;N;;;;;
1D647;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL L;Lu;0;L;<font> 004C;;;;N;;;;;
1D648;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL M;Lu;0;L;<font> 004D;;;;N;;;;;
1D649;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL N;Lu;0;L;<font> 004E;;;;N;;;;;
1D64A;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL O;Lu;0;L;<font> 004F;;;;N;;;;;
1D64B;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL P;Lu;0;L;<font> 0050;;;;N;;;;;
1D64C;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL Q;Lu;0;L;<font> 0051;;;;N;;;;;
1D64D;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL R;Lu;0;L;<font> 0052;;;;N;;;;;
1D64E;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL S;Lu;0;L;<font> 0053;;;;N;;;;;
1D64F;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL T;Lu;0;L;<font> 0054;;;;N;;;;;
1D650;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL U;Lu;0;L;<font> 0055;;;;N;;;;;
1D651;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL V;Lu;0;L;<font> 0056;;;;N;;;;;
1D652;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL W;Lu;0;L;<font> 0057;;;;N;;;;;
1D653;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL X;Lu;0;L;<font> 0058;;;;N;;;;;
1D654;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL Y;Lu;0;L;<font> 0059;;;;N;;;;;
1D655;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL Z;Lu;0;L;<font> 005A;;;;N;;;;;
1D656;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL A;Ll;0;L;<font> 0061;;;;N;;;;;
1D657;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL B;Ll;0;L;<font> 0062;;;;N;;;;;
1D658;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL C;Ll;0;L;<font> 0063;;;;N;;;;;
1D659;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL D;Ll;0;L;<font> 0064;;;;N;;;;;
1D65A;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL E;Ll;0;L;<font> 0065;;;;N;;;;;
1D65B;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL F;Ll;0;L;<font> 0066;;;;N;;;;;
1D65C;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL G;Ll;0;L;<font> 0067;;;;N;;;;;
1D65D;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL H;Ll;0;L;<font> 0068;;;;N;;;;;
1D65E;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL I;Ll;0;L;<font> 0069;;;;N;;;;;
1D65F;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL J;Ll;0;L;<font> 006A;;;;N;;;;;
1D660;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL K;Ll;0;L;<font> 006B;;;;N;;;;;
1D661;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL L;Ll;0;L;<font> 006C;;;;N;;;;;
1D662;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL M;Ll;0;L;<font> 006D;;;;N;;;;;
1D663;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL N;Ll;0;L;<font> 006E;;;;N;;;;;
1D664;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL O;Ll;0;L;<font> 006F;;;;N;;;;;
1D665;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL P;Ll;0;L;<font> 0070;;;;N;;;;;
1D666;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL Q;Ll;0;L;<font> 0071;;;;N;;;;;
1D667;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL R;Ll;0;L;<font> 0072;;;;N;;;;;
1D668;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL S;Ll;0;L;<font> 0073;;;;N;;;;;
1D669;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL T;Ll;0;L;<font> 0074;;;;N;;;;;
1D66A;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL U;Ll;0;L;<font> 0075;;;;N;;;;;
1D66B;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL V;Ll;0;L;<font> 0076;;;;N;;;;;
1D66C;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL W;Ll;0;L;<font> 0077;;;;N;;;;;
1D66D;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL X;Ll;0;L;<font> 0078;;;;N;;;;;
1D66E;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL Y;Ll;0;L;<font> 0079;;;;N;;;;;
1D66F;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL Z;Ll;0;L;<font> 007A;;;;N;;;;;
1D670;MATHEMATICAL MONOSPACE CAPITAL A;Lu;0;L;<font> 0041;;;;N;;;;;
1D671;MATHEMATICAL MONOSPACE CAPITAL B;Lu;0;L;<font> 0042;;;;N;;;;;
1D672;MATHEMATICAL MONOSPACE CAPITAL C;Lu;0;L;<font> 0043;;;;N;;;;;
1D673;MATHEMATICAL MONOSPACE CAPITAL D;Lu;0;L;<font> 0044;;;;N;;;;;
1D674;MATHEMATICAL MONOSPACE CAPITAL E;Lu;0;L;<font> 0045;;;;N;;;;;
1D675;MATHEMATICAL MONOSPACE CAPITAL F;Lu;0;L;<font> 0046;;;;N;;;;;
1D676;MATHEMATICAL MONOSPACE CAPITAL G;Lu;0;L;<font> 0047;;;;N;;;;;
1D677;MATHEMATICAL MONOSPACE CAPITAL H;Lu;0;L;<font> 0048;;;;N;;;;;
1D678;MATHEMATICAL MONOSPACE CAPITAL I;Lu;0;L;<font> 0049;;;;N;;;;;
1D679;MATHEMATICAL MONOSPACE CAPITAL J;Lu;0;L;<font> 004A;;;;N;;;;;
1D67A;MATHEMATICAL MONOSPACE CAPITAL K;Lu;0;L;<font> 004B;;;;N;;;;;
1D67B;MATHEMATICAL MONOSPACE CAPITAL L;Lu;0;L;<font> 004C;;;;N;;;;;
1D67C;MATHEMATICAL MONOSPACE CAPITAL M;Lu;0;L;<font> 004D;;;;N;;;;;
1D67D;MATHEMATICAL MONOSPACE CAPITAL N;Lu;0;L;<font> 004E;;;;N;;;;;
1D67E;MATHEMATICAL MONOSPACE CAPITAL O;Lu;0;L;<font> 004F;;;;N;;;;;
1D67F;MATHEMATICAL MONOSPACE CAPITAL P;Lu;0;L;<font> 0050;;;;N;;;;;
1D680;MATHEMATICAL MONOSPACE CAPITAL Q;Lu;0;L;<font> 0051;;;;N;;;;;
1D681;MATHEMATICAL MONOSPACE CAPITAL R;Lu;0;L;<font> 0052;;;;N;;;;;
1D682;MATHEMATICAL MONOSPACE CAPITAL S;Lu;0;L;<font> 0053;;;;N;;;;;
1D683;MATHEMATICAL MONOSPACE CAPITAL T;Lu;0;L;<font> 0054;;;;N;;;;;
1D684;MATHEMATICAL MONOSPACE CAPITAL U;Lu;0;L;<font> 0055;;;;N;;;;;
1D685;MATHEMATICAL MONOSPACE CAPITAL V;Lu;0;L;<font> 0056;;;;N;;;;;
1D686;MATHEMATICAL MONOSPACE CAPITAL W;Lu;0;L;<font> 0057;;;;N;;;;;
1D687;MATHEMATICAL MONOSPACE CAPITAL X;Lu;0;L;<font> 0058;;;;N;;;;;
1D688;MATHEMATICAL MONOSPACE CAPITAL Y;Lu;0;L;<font> 0059;;;;N;;;;;
1D689;MATHEMATICAL MONOSPACE CAPITAL Z;Lu;0;L;<font> 005A;;;;N;;;;;
1D68A;MATHEMATICAL MONOSPACE SMALL A;Ll;0;L;<font> 0061;;;;N;;;;;
1D68B;MATHEMATICAL MONOSPACE SMALL B;Ll;0;L;<font> 0062;;;;N;;;;;
1D68C;MATHEMATICAL MONOSPACE SMALL C;Ll;0;L;<font> 0063;;;;N;;;;;
1D68D;MATHEMATICAL MONOSPACE SMALL D;Ll;0;L;<font> 0064;;;;N;;;;;
1D68E;MATHEMATICAL MONOSPACE SMALL E;Ll;0;L;<font> 0065;;;;N;;;;;
1D68F;MATHEMATICAL MONOSPACE SMALL F;Ll;0;L;<font> 0066;;;;N;;;;;
1D690;MATHEMATICAL MONOSPACE SMALL G;Ll;0;L;<font> 0067;;;;N;;;;;
1D691;MATHEMATICAL MONOSPACE SMALL H;Ll;0;L;<font> 0068;;;;N;;;;;
1D692;MATHEMATICAL MONOSPACE SMALL I;Ll;0;L;<font> 0069;;;;N;;;;;
1D693;MATHEMATICAL MONOSPACE SMALL J;Ll;0;L;<font> 006A;;;;N;;;;;
1D694;MATHEMATICAL MONOSPACE SMALL K;Ll;0;L;<font> 006B;;;;N;;;;;
1D695;MATHEMATICAL MONOSPACE SMALL L;Ll;0;L;<font> 006C;;;;N;;;;;
1D696;MATHEMATICAL MONOSPACE SMALL M;Ll;0;L;<font> 006D;;;;N;;;;;
1D697;MATHEMATICAL MONOSPACE SMALL N;Ll;0;L;<font> 006E;;;;N;;;;;
1D698;MATHEMATICAL MONOSPACE SMALL O;Ll;0;L;<font> 006F;;;;N;;;;;
1D699;MATHEMATICAL MONOSPACE SMALL P;Ll;0;L;<font> 0070;;;;N;;;;;
1D69A;MATHEMATICAL MONOSPACE SMALL Q;Ll;0;L;<font> 0071;;;;N;;;;;
1D69B;MATHEMATICAL MONOSPACE SMALL R;Ll;0;L;<font> 0072;;;;N;;;;;
1D69C;MATHEMATICAL MONOSPACE SMALL S;Ll;0;L;<font> 0073;;;;N;;;;;
1D69D;MATHEMATICAL MONOSPACE SMALL T;Ll;0;L;<font> 0074;;;;N;;;;;
1D69E;MATHEMATICAL MONOSPACE SMALL U;Ll;0;L;<font> 0075;;;;N;;;;;
1D69F;MATHEMATICAL MONOSPACE SMALL V;Ll;0;L;<font> 0076;;;;N;;;;;
1D6A0;MATHEMATICAL MONOSPACE SMALL W;Ll;0;L;<font> 0077;;;;N;;;;;
1D6A1;MATHEMATICAL MONOSPACE SMALL X;Ll;0;L;<font> 0078;;;;N;;;;;
1D6A2;MATHEMATICAL MONOSPACE SMALL Y;Ll;0;L;<font> 0079;;;;N;;;;;
1D6A3;MATHEMATICAL MONOSPACE SMALL Z;Ll;0;L;<font> 007A;;;;N;;;;;
1D6A4;MATHEMATICAL ITALIC SMALL DOTLESS I;Ll;0;L;<font> 0131;;;;N;;;;;
1D6A5;MATHEMATICAL ITALIC SMALL DOTLESS J;Ll;0;L;<font> 0237;;;;N;;;;;
1D6A8;MATHEMATICAL BOLD CAPITAL ALPHA;Lu;0;L;<font> 0391;;;;N;;;;;
1D6A9;MATHEMATICAL BOLD CAPITAL BETA;Lu;0;L;<font> 0392;;;;N;;;;;
1D6AA;MATHEMATICAL BOLD CAPITAL GAMMA;Lu;0;L;<font> 0393;;;;N;;;;;
1D6AB;MATHEMATICAL BOLD CAPITAL DELTA;Lu;0;L;<font> 0394;;;;N;;;;;
1D6AC;MATHEMATICAL BOLD CAPITAL EPSILON;Lu;0;L;<font> 0395;;;;N;;;;;
1D6AD;MATHEMATICAL BOLD CAPITAL ZETA;Lu;0;L;<font> 0396;;;;N;;;;;
1D6AE;MATHEMATICAL BOLD CAPITAL ETA;Lu;0;L;<font> 0397;;;;N;;;;;
1D6AF;MATHEMATICAL BOLD CAPITAL THETA;Lu;0;L;<font> 0398;;;;N;;;;;
1D6B0;MATHEMATICAL BOLD CAPITAL IOTA;Lu;0;L;<font> 0399;;;;N;;;;;
1D6B1;MATHEMATICAL BOLD CAPITAL KAPPA;Lu;0;L;<font> 039A;;;;N;;;;;
1D6B2;MATHEMATICAL BOLD CAPITAL LAMDA;Lu;0;L;<font> 039B;;;;N;;;;;
1D6B3;MATHEMATICAL BOLD CAPITAL MU;Lu;0;L;<font> 039C;;;;N;;;;;
1D6B4;MATHEMATICAL BOLD CAPITAL NU;Lu;0;L;<font> 039D;;;;N;;;;;
1D6B5;MATHEMATICAL BOLD CAPITAL XI;Lu;0;L;<font> 039E;;;;N;;;;;
1D6B6;MATHEMATICAL BOLD CAPITAL OMICRON;Lu;0;L;<font> 039F;;;;N;;;;;
1D6B7;MATHEMATICAL BOLD CAPITAL PI;Lu;0;L;<font> 03A0;;;;N;;;;;
1D6B8;MATHEMATICAL BOLD CAPITAL RHO;Lu;0;L;<font> 03A1;;;;N;;;;;
1D6B9;MATHEMATICAL BOLD CAPITAL THETA SYMBOL;Lu;0;L;<font> 03F4;;;;N;;;;;
1D6BA;MATHEMATICAL BOLD CAPITAL SIGMA;Lu;0;L;<font> 03A3;;;;N;;;;;
1D6BB;MATHEMATICAL BOLD CAPITAL TAU;Lu;0;L;<font> 03A4;;;;N;;;;;
1D6BC;MATHEMATICAL BOLD CAPITAL UPSILON;Lu;0;L;<font> 03A5;;;;N;;;;;
1D6BD;MATHEMATICAL BOLD CAPITAL PHI;Lu;0;L;<font> 03A6;;;;N;;;;;
1D6BE;MATHEMATICAL BOLD CAPITAL CHI;Lu;0;L;<font> 03A7;;;;N;;;;;
1D6BF;MATHEMATICAL BOLD CAPITAL PSI;Lu;0;L;<font> 03A8;;;;N;;;;;
1D6C0;MATHEMATICAL BOLD CAPITAL OMEGA;Lu;0;L;<font> 03A9;;;;N;;;;;
1D6C1;MATHEMATICAL BOLD NABLA;Sm;0;L;<font> 2207;;;;N;;;;;
1D6C2;MATHEMATICAL BOLD SMALL ALPHA;Ll;0;L;<font> 03B1;;;;N;;;;;
1D6C3;MATHEMATICAL BOLD SMALL BETA;Ll;0;L;<font> 03B2;;;;N;;;;;
1D6C4;MATHEMATICAL BOLD SMALL GAMMA;Ll;0;L;<font> 03B3;;;;N;;;;;
1D6C5;MATHEMATICAL BOLD SMALL DELTA;Ll;0;L;<font> 03B4;;;;N;;;;;
1D6C6;MATHEMATICAL BOLD SMALL EPSILON;Ll;0;L;<font> 03B5;;;;N;;;;;
1D6C7;MATHEMATICAL BOLD SMALL ZETA;Ll;0;L;<font> 03B6;;;;N;;;;;
1D6C8;MATHEMATICAL BOLD SMALL ETA;Ll;0;L;<font> 03B7;;;;N;;;;;
1D6C9;MATHEMATICAL BOLD SMALL THETA;Ll;0;L;<font> 03B8;;;;N;;;;;
1D6CA;MATHEMATICAL BOLD SMALL IOTA;Ll;0;L;<font> 03B9;;;;N;;;;;
1D6CB;MATHEMATICAL BOLD SMALL KAPPA;Ll;0;L;<font> 03BA;;;;N;;;;;
1D6CC;MATHEMATICAL BOLD SMALL LAMDA;Ll;0;L;<font> 03BB;;;;N;;;;;
1D6CD;MATHEMATICAL BOLD SMALL MU;Ll;0;L;<font> 03BC;;;;N;;;;;
1D6CE;MATHEMATICAL BOLD SMALL NU;Ll;0;L;<font> 03BD;;;;N;;;;;
1D6CF;MATHEMATICAL BOLD SMALL XI;Ll;0;L;<font> 03BE;;;;N;;;;;
1D6D0;MATHEMATICAL BOLD SMALL OMICRON;Ll;0;L;<font> 03BF;;;;N;;;;;
1D6D1;MATHEMATICAL BOLD SMALL PI;Ll;0;L;<font> 03C0;;;;N;;;;;
1D6D2;MATHEMATICAL BOLD SMALL RHO;Ll;0;L;<font> 03C1;;;;N;;;;;
1D6D3;MATHEMATICAL BOLD SMALL FINAL SIGMA;Ll;0;L;<font> 03C2;;;;N;;;;;
1D6D4;MATHEMATICAL BOLD SMALL SIGMA;Ll;0;L;<font> 03C3;;;;N;;;;;
1D6D5;MATHEMATICAL BOLD SMALL TAU;Ll;0;L;<font> 03C4;;;;N;;;;;
1D6D6;MATHEMATICAL BOLD SMALL UPSILON;Ll;0;L;<font> 03C5;;;;N;;;;;
1D6D7;MATHEMATICAL BOLD SMALL PHI;Ll;0;L;<font> 03C6;;;;N;;;;;
1D6D8;MATHEMATICAL BOLD SMALL CHI;Ll;0;L;<font> 03C7;;;;N;;;;;
1D6D9;MATHEMATICAL BOLD SMALL PSI;Ll;0;L;<font> 03C8;;;;N;;;;;
1D6DA;MATHEMATICAL BOLD SMALL OMEGA;Ll;0;L;<font> 03C9;;;;N;;;;;
1D6DB;MATHEMATICAL BOLD PARTIAL DIFFERENTIAL;Sm;0;ON;<font> 2202;;;;Y;;;;;
1D6DC;MATHEMATICAL BOLD EPSILON SYMBOL;Ll;0;L;<font> 03F5;;;;N;;;;;
1D6DD;MATHEMATICAL BOLD THETA SYMBOL;Ll;0;L;<font> 03D1;;;;N;;;;;
1D6DE;MATHEMATICAL BOLD KAPPA SYMBOL;Ll;0;L;<font> 03F0;;;;N;;;;;
1D6DF;MATHEMATICAL BOLD PHI SYMBOL;Ll;0;L;<font> 03D5;;;;N;;;;;
1D6E0;MATHEMATICAL BOLD RHO SYMBOL;Ll;0;L;<font> 03F1;;;;N;;;;;
1D6E1;MATHEMATICAL BOLD PI SYMBOL;Ll;0;L;<font> 03D6;;;;N;;;;;
1D6E2;MATHEMATICAL ITALIC CAPITAL ALPHA;Lu;0;L;<font> 0391;;;;N;;;;;
1D6E3;MATHEMATICAL ITALIC CAPITAL BETA;Lu;0;L;<font> 0392;;;;N;;;;;
1D6E4;MATHEMATICAL ITALIC CAPITAL GAMMA;Lu;0;L;<font> 0393;;;;N;;;;;
1D6E5;MATHEMATICAL ITALIC CAPITAL DELTA;Lu;0;L;<font> 0394;;;;N;;;;;
1D6E6;MATHEMATICAL ITALIC CAPITAL EPSILON;Lu;0;L;<font> 0395;;;;N;;;;;
1D6E7;MATHEMATICAL ITALIC CAPITAL ZETA;Lu;0;L;<font> 0396;;;;N;;;;;
1D6E8;MATHEMATICAL ITALIC CAPITAL ETA;Lu;0;L;<font> 0397;;;;N;;;;;
1D6E9;MATHEMATICAL ITALIC CAPITAL THETA;Lu;0;L;<font> 0398;;;;N;;;;;
1D6EA;MATHEMATICAL ITALIC CAPITAL IOTA;Lu;0;L;<font> 0399;;;;N;;;;;
1D6EB;MATHEMATICAL ITALIC CAPITAL KAPPA;Lu;0;L;<font> 039A;;;;N;;;;;
1D6EC;MATHEMATICAL ITALIC CAPITAL LAMDA;Lu;0;L;<font> 039B;;;;N;;;;;
1D6ED;MATHEMATICAL ITALIC CAPITAL MU;Lu;0;L;<font> 039C;;;;N;;;;;
1D6EE;MATHEMATICAL ITALIC CAPITAL NU;Lu;0;L;<font> 039D;;;;N;;;;;
1D6EF;MATHEMATICAL ITALIC CAPITAL XI;Lu;0;L;<font> 039E;;;;N;;;;;
1D6F0;MATHEMATICAL ITALIC CAPITAL OMICRON;Lu;0;L;<font> 039F;;;;N;;;;;
1D6F1;MATHEMATICAL ITALIC CAPITAL PI;Lu;0;L;<font> 03A0;;;;N;;;;;
1D6F2;MATHEMATICAL ITALIC CAPITAL RHO;Lu;0;L;<font> 03A1;;;;N;;;;;
1D6F3;MATHEMATICAL ITALIC CAPITAL THETA SYMBOL;Lu;0;L;<font> 03F4;;;;N;;;;;
1D6F4;MATHEMATICAL ITALIC CAPITAL SIGMA;Lu;0;L;<font> 03A3;;;;N;;;;;
1D6F5;MATHEMATICAL ITALIC CAPITAL TAU;Lu;0;L;<font> 03A4;;;;N;;;;;
1D6F6;MATHEMATICAL ITALIC CAPITAL UPSILON;Lu;0;L;<font> 03A5;;;;N;;;;;
1D6F7;MATHEMATICAL ITALIC CAPITAL PHI;Lu;0;L;<font> 03A6;;;;N;;;;;
1D6F8;MATHEMATICAL ITALIC CAPITAL CHI;Lu;0;L;<font> 03A7;;;;N;;;;;
1D6F9;MATHEMATICAL ITALIC CAPITAL PSI;Lu;0;L;<font> 03A8;;;;N;;;;;
1D6FA;MATHEMATICAL ITALIC CAPITAL OMEGA;Lu;0;L;<font> 03A9;;;;N;;;;;
1D6FB;MATHEMATICAL ITALIC NABLA;Sm;0;L;<font> 2207;;;;N;;;;;
1D6FC;MATHEMATICAL ITALIC SMALL ALPHA;Ll;0;L;<font> 03B1;;;;N;;;;;
1D6FD;MATHEMATICAL ITALIC SMALL BETA;Ll;0;L;<font> 03B2;;;;N;;;;;
1D6FE;MATHEMATICAL ITALIC SMALL GAMMA;Ll;0;L;<font> 03B3;;;;N;;;;;
1D6FF;MATHEMATICAL ITALIC SMALL DELTA;Ll;0;L;<font> 03B4;;;;N;;;;;
1D700;MATHEMATICAL ITALIC SMALL EPSILON;Ll;0;L;<font> 03B5;;;;N;;;;;
1D701;MATHEMATICAL ITALIC SMALL ZETA;Ll;0;L;<font> 03B6;;;;N;;;;;
1D702;MATHEMATICAL ITALIC SMALL ETA;Ll;0;L;<font> 03B7;;;;N;;;;;
1D703;MATHEMATICAL ITALIC SMALL THETA;Ll;0;L;<font> 03B8;;;;N;;;;;
1D704;MATHEMATICAL ITALIC SMALL IOTA;Ll;0;L;<font> 03B9;;;;N;;;;;
1D705;MATHEMATICAL ITALIC SMALL KAPPA;Ll;0;L;<font> 03BA;;;;N;;;;;
1D706;MATHEMATICAL ITALIC SMALL LAMDA;Ll;0;L;<font> 03BB;;;;N;;;;;
1D707;MATHEMATICAL ITALIC SMALL MU;Ll;0;L;<font> 03BC;;;;N;;;;;
1D708;MATHEMATICAL ITALIC SMALL NU;Ll;0;L;<font> 03BD;;;;N;;;;;
1D709;MATHEMATICAL ITALIC SMALL XI;Ll;0;L;<font> 03BE;;;;N;;;;;
1D70A;MATHEMATICAL ITALIC SMALL OMICRON;Ll;0;L;<font> 03BF;;;;N;;;;;
1D70B;MATHEMATICAL ITALIC SMALL PI;Ll;0;L;<font> 03C0;;;;N;;;;;
1D70C;MATHEMATICAL ITALIC SMALL RHO;Ll;0;L;<font> 03C1;;;;N;;;;;
1D70D;MATHEMATICAL ITALIC SMALL FINAL SIGMA;Ll;0;L;<font> 03C2;;;;N;;;;;
1D70E;MATHEMATICAL ITALIC SMALL SIGMA;Ll;0;L;<font> 03C3;;;;N;;;;;
1D70F;MATHEMATICAL ITALIC SMALL TAU;Ll;0;L;<font> 03C4;;;;N;;;;;
1D710;MATHEMATICAL ITALIC SMALL UPSILON;Ll;0;L;<font> 03C5;;;;N;;;;;
1D711;MATHEMATICAL ITALIC SMALL PHI;Ll;0;L;<font> 03C6;;;;N;;;;;
1D712;MATHEMATICAL ITALIC SMALL CHI;Ll;0;L;<font> 03C7;;;;N;;;;;
1D713;MATHEMATICAL ITALIC SMALL PSI;Ll;0;L;<font> 03C8;;;;N;;;;;
1D714;MATHEMATICAL ITALIC SMALL OMEGA;Ll;0;L;<font> 03C9;;;;N;;;;;
1D715;MATHEMATICAL ITALIC PARTIAL DIFFERENTIAL;Sm;0;ON;<font> 2202;;;;Y;;;;;
1D716;MATHEMATICAL ITALIC EPSILON SYMBOL;Ll;0;L;<font> 03F5;;;;N;;;;;
1D717;MATHEMATICAL ITALIC THETA SYMBOL;Ll;0;L;<font> 03D1;;;;N;;;;;
1D718;MATHEMATICAL ITALIC KAPPA SYMBOL;Ll;0;L;<font> 03F0;;;;N;;;;;
1D719;MATHEMATICAL ITALIC PHI SYMBOL;Ll;0;L;<font> 03D5;;;;N;;;;;
1D71A;MATHEMATICAL ITALIC RHO SYMBOL;Ll;0;L;<font> 03F1;;;;N;;;;;
1D71B;MATHEMATICAL ITALIC PI SYMBOL;Ll;0;L;<font> 03D6;;;;N;;;;;
1D71C;MATHEMATICAL BOLD ITALIC CAPITAL ALPHA;Lu;0;L;<font> 0391;;;;N;;;;;
1D71D;MATHEMATICAL BOLD ITALIC CAPITAL BETA;Lu;0;L;<font> 0392;;;;N;;;;;
1D71E;MATHEMATICAL BOLD ITALIC CAPITAL GAMMA;Lu;0;L;<font> 0393;;;;N;;;;;
1D71F;MATHEMATICAL BOLD ITALIC CAPITAL DELTA;Lu;0;L;<font> 0394;;;;N;;;;;
1D720;MATHEMATICAL BOLD ITALIC CAPITAL EPSILON;Lu;0;L;<font> 0395;;;;N;;;;;
1D721;MATHEMATICAL BOLD ITALIC CAPITAL ZETA;Lu;0;L;<font> 0396;;;;N;;;;;
1D722;MATHEMATICAL BOLD ITALIC CAPITAL ETA;Lu;0;L;<font> 0397;;;;N;;;;;
1D723;MATHEMATICAL BOLD ITALIC CAPITAL THETA;Lu;0;L;<font> 0398;;;;N;;;;;
1D724;MATHEMATICAL BOLD ITALIC CAPITAL IOTA;Lu;0;L;<font> 0399;;;;N;;;;;
1D725;MATHEMATICAL BOLD ITALIC CAPITAL KAPPA;Lu;0;L;<font> 039A;;;;N;;;;;
1D726;MATHEMATICAL BOLD ITALIC CAPITAL LAMDA;Lu;0;L;<font> 039B;;;;N;;;;;
1D727;MATHEMATICAL BOLD ITALIC CAPITAL MU;Lu;0;L;<font> 039C;;;;N;;;;;
1D728;MATHEMATICAL BOLD ITALIC CAPITAL NU;Lu;0;L;<font> 039D;;;;N;;;;;
1D729;MATHEMATICAL BOLD ITALIC CAPITAL XI;Lu;0;L;<font> 039E;;;;N;;;;;
1D72A;MATHEMATICAL BOLD ITALIC CAPITAL OMICRON;Lu;0;L;<font> 039F;;;;N;;;;;
1D72B;MATHEMATICAL BOLD ITALIC CAPITAL PI;Lu;0;L;<font> 03A0;;;;N;;;;;
1D72C;MATHEMATICAL BOLD ITALIC CAPITAL RHO;Lu;0;L;<font> 03A1;;;;N;;;;;
1D72D;MATHEMATICAL BOLD ITALIC CAPITAL THETA SYMBOL;Lu;0;L;<font> 03F4;;;;N;;;;;
1D72E;MATHEMATICAL BOLD ITALIC CAPITAL SIGMA;Lu;0;L;<font> 03A3;;;;N;;;;;
1D72F;MATHEMATICAL BOLD ITALIC CAPITAL TAU;Lu;0;L;<font> 03A4;;;;N;;;;;
1D730;MATHEMATICAL BOLD ITALIC CAPITAL UPSILON;Lu;0;L;<font> 03A5;;;;N;;;;;
1D731;MATHEMATICAL BOLD ITALIC CAPITAL PHI;Lu;0;L;<font> 03A6;;;;N;;;;;
1D732;MATHEMATICAL BOLD ITALIC CAPITAL CHI;Lu;0;L;<font> 03A7;;;;N;;;;;
1D733;MATHEMATICAL BOLD ITALIC CAPITAL PSI;Lu;0;L;<font> 03A8;;;;N;;;;;
1D734;MATHEMATICAL BOLD ITALIC CAPITAL OMEGA;Lu;0;L;<font> 03A9;;;;N;;;;;
1D735;MATHEMATICAL BOLD ITALIC NABLA;Sm;0;L;<font> 2207;;;;N;;;;;
1D736;MATHEMATICAL BOLD ITALIC SMALL ALPHA;Ll;0;L;<font> 03B1;;;;N;;;;;
1D737;MATHEMATICAL BOLD ITALIC SMALL BETA;Ll;0;L;<font> 03B2;;;;N;;;;;
1D738;MATHEMATICAL BOLD ITALIC SMALL GAMMA;Ll;0;L;<font> 03B3;;;;N;;;;;
1D739;MATHEMATICAL BOLD ITALIC SMALL DELTA;Ll;0;L;<font> 03B4;;;;N;;;;;
1D73A;MATHEMATICAL BOLD ITALIC SMALL EPSILON;Ll;0;L;<font> 03B5;;;;N;;;;;
1D73B;MATHEMATICAL BOLD ITALIC SMALL ZETA;Ll;0;L;<font> 03B6;;;;N;;;;;
1D73C;MATHEMATICAL BOLD ITALIC SMALL ETA;Ll;0;L;<font> 03B7;;;;N;;;;;
1D73D;MATHEMATICAL BOLD ITALIC SMALL THETA;Ll;0;L;<font> 03B8;;;;N;;;;;
1D73E;MATHEMATICAL BOLD ITALIC SMALL IOTA;Ll;0;L;<font> 03B9;;;;N;;;;;
1D73F;MATHEMATICAL BOLD ITALIC SMALL KAPPA;Ll;0;L;<font> 03BA;;;;N;;;;;
1D740;MATHEMATICAL BOLD ITALIC SMALL LAMDA;Ll;0;L;<font> 03BB;;;;N;;;;;
1D741;MATHEMATICAL BOLD ITALIC SMALL MU;Ll;0;L;<font> 03BC;;;;N;;;;;
1D742;MATHEMATICAL BOLD ITALIC SMALL NU;Ll;0;L;<font> 03BD;;;;N;;;;;
1D743;MATHEMATICAL BOLD ITALIC SMALL XI;Ll;0;L;<font> 03BE;;;;N;;;;;
1D744;MATHEMATICAL BOLD ITALIC SMALL OMICRON;Ll;0;L;<font> 03BF;;;;N;;;;;
1D745;MATHEMATICAL BOLD ITALIC SMALL PI;Ll;0;L;<font> 03C0;;;;N;;;;;
1D746;MATHEMATICAL BOLD ITALIC SMALL RHO;Ll;0;L;<font> 03C1;;;;N;;;;;
1D747;MATHEMATICAL BOLD ITALIC SMALL FINAL SIGMA;Ll;0;L;<font> 03C2;;;;N;;;;;
1D748;MATHEMATICAL BOLD ITALIC SMALL SIGMA;Ll;0;L;<font> 03C3;;;;N;;;;;
1D749;MATHEMATICAL BOLD ITALIC SMALL TAU;Ll;0;L;<font> 03C4;;;;N;;;;;
1D74A;MATHEMATICAL BOLD ITALIC SMALL UPSILON;Ll;0;L;<font> 03C5;;;;N;;;;;
1D74B;MATHEMATICAL BOLD ITALIC SMALL PHI;Ll;0;L;<font> 03C6;;;;N;;;;;
1D74C;MATHEMATICAL BOLD ITALIC SMALL CHI;Ll;0;L;<font> 03C7;;;;N;;;;;
1D74D;MATHEMATICAL BOLD ITALIC SMALL PSI;Ll;0;L;<font> 03C8;;;;N;;;;;
1D74E;MATHEMATICAL BOLD ITALIC SMALL OMEGA;Ll;0;L;<font> 03C9;;;;N;;;;;
1D74F;MATHEMATICAL BOLD ITALIC PARTIAL DIFFERENTIAL;Sm;0;ON;<font> 2202;;;;Y;;;;;
1D750;MATHEMATICAL BOLD ITALIC EPSILON SYMBOL;Ll;0;L;<font> 03F5;;;;N;;;;;
1D751;MATHEMATICAL BOLD ITALIC THETA SYMBOL;Ll;0;L;<font> 03D1;;;;N;;;;;
1D752;MATHEMATICAL BOLD ITALIC KAPPA SYMBOL;Ll;0;L;<font> 03F0;;;;N;;;;;
1D753;MATHEMATICAL BOLD ITALIC PHI SYMBOL;Ll;0;L;<font> 03D5;;;;N;;;;;
1D754;MATHEMATICAL BOLD ITALIC RHO SYMBOL;Ll;0;L;<font> 03F1;;;;N;;;;;
1D755;MATHEMATICAL BOLD ITALIC PI SYMBOL;Ll;0;L;<font> 03D6;;;;N;;;;;
1D756;MATHEMATICAL SANS-SERIF BOLD CAPITAL ALPHA;Lu;0;L;<font> 0391;;;;N;;;;;
1D757;MATHEMATICAL SANS-SERIF BOLD CAPITAL BETA;Lu;0;L;<font> 0392;;;;N;;;;;
1D758;MATHEMATICAL SANS-SERIF BOLD CAPITAL GAMMA;Lu;0;L;<font> 0393;;;;N;;;;;
1D759;MATHEMATICAL SANS-SERIF BOLD CAPITAL DELTA;Lu;0;L;<font> 0394;;;;N;;;;;
1D75A;MATHEMATICAL SANS-SERIF BOLD CAPITAL EPSILON;Lu;0;L;<font> 0395;;;;N;;;;;
1D75B;MATHEMATICAL SANS-SERIF BOLD CAPITAL ZETA;Lu;0;L;<font> 0396;;;;N;;;;;
1D75C;MATHEMATICAL SANS-SERIF BOLD CAPITAL ETA;Lu;0;L;<font> 0397;;;;N;;;;;
1D75D;MATHEMATICAL SANS-SERIF BOLD CAPITAL THETA;Lu;0;L;<font> 0398;;;;N;;;;;
1D75E;MATHEMATICAL SANS-SERIF BOLD CAPITAL IOTA;Lu;0;L;<font> 0399;;;;N;;;;;
1D75F;MATHEMATICAL SANS-SERIF BOLD CAPITAL KAPPA;Lu;0;L;<font> 039A;;;;N;;;;;
1D760;MATHEMATICAL SANS-SERIF BOLD CAPITAL LAMDA;Lu;0;L;<font> 039B;;;;N;;;;;
1D761;MATHEMATICAL SANS-SERIF BOLD CAPITAL MU;Lu;0;L;<font> 039C;;;;N;;;;;
1D762;MATHEMATICAL SANS-SERIF BOLD CAPITAL NU;Lu;0;L;<font> 039D;;;;N;;;;;
1D763;MATHEMATICAL SANS-SERIF BOLD CAPITAL XI;Lu;0;L;<font> 039E;;;;N;;;;;
1D764;MATHEMATICAL SANS-SERIF BOLD CAPITAL OMICRON;Lu;0;L;<font> 039F;;;;N;;;;;
1D765;MATHEMATICAL SANS-SERIF BOLD CAPITAL PI;Lu;0;L;<font> 03A0;;;;N;;;;;
1D766;MATHEMATICAL SANS-SERIF BOLD CAPITAL RHO;Lu;0;L;<font> 03A1;;;;N;;;;;
1D767;MATHEMATICAL SANS-SERIF BOLD CAPITAL THETA SYMBOL;Lu;0;L;<font> 03F4;;;;N;;;;;
1D768;MATHEMATICAL SANS-SERIF BOLD CAPITAL SIGMA;Lu;0;L;<font> 03A3;;;;N;;;;;
1D769;MATHEMATICAL SANS-SERIF BOLD CAPITAL TAU;Lu;0;L;<font> 03A4;;;;N;;;;;
1D76A;MATHEMATICAL SANS-SERIF BOLD CAPITAL UPSILON;Lu;0;L;<font> 03A5;;;;N;;;;;
1D76B;MATHEMATICAL SANS-SERIF BOLD CAPITAL PHI;Lu;0;L;<font> 03A6;;;;N;;;;;
1D76C;MATHEMATICAL SANS-SERIF BOLD CAPITAL CHI;Lu;0;L;<font> 03A7;;;;N;;;;;
1D76D;MATHEMATICAL SANS-SERIF BOLD CAPITAL PSI;Lu;0;L;<font> 03A8;;;;N;;;;;
1D76E;MATHEMATICAL SANS-SERIF BOLD CAPITAL OMEGA;Lu;0;L;<font> 03A9;;;;N;;;;;
1D76F;MATHEMATICAL SANS-SERIF BOLD NABLA;Sm;0;L;<font> 2207;;;;N;;;;;
1D770;MATHEMATICAL SANS-SERIF BOLD SMALL ALPHA;Ll;0;L;<font> 03B1;;;;N;;;;;
1D771;MATHEMATICAL SANS-SERIF BOLD SMALL BETA;Ll;0;L;<font> 03B2;;;;N;;;;;
1D772;MATHEMATICAL SANS-SERIF BOLD SMALL GAMMA;Ll;0;L;<font> 03B3;;;;N;;;;;
1D773;MATHEMATICAL SANS-SERIF BOLD SMALL DELTA;Ll;0;L;<font> 03B4;;;;N;;;;;
1D774;MATHEMATICAL SANS-SERIF BOLD SMALL EPSILON;Ll;0;L;<font> 03B5;;;;N;;;;;
1D775;MATHEMATICAL SANS-SERIF BOLD SMALL ZETA;Ll;0;L;<font> 03B6;;;;N;;;;;
1D776;MATHEMATICAL SANS-SERIF BOLD SMALL ETA;Ll;0;L;<font> 03B7;;;;N;;;;;
1D777;MATHEMATICAL SANS-SERIF BOLD SMALL THETA;Ll;0;L;<font> 03B8;;;;N;;;;;
1D778;MATHEMATICAL SANS-SERIF BOLD SMALL IOTA;Ll;0;L;<font> 03B9;;;;N;;;;;
1D779;MATHEMATICAL SANS-SERIF BOLD SMALL KAPPA;Ll;0;L;<font> 03BA;;;;N;;;;;
1D77A;MATHEMATICAL SANS-SERIF BOLD SMALL LAMDA;Ll;0;L;<font> 03BB;;;;N;;;;;
1D77B;MATHEMATICAL SANS-SERIF BOLD SMALL MU;Ll;0;L;<font> 03BC;;;;N;;;;;
1D77C;MATHEMATICAL SANS-SERIF BOLD SMALL NU;Ll;0;L;<font> 03BD;;;;N;;;;;
1D77D;MATHEMATICAL SANS-SERIF BOLD SMALL XI;Ll;0;L;<font> 03BE;;;;N;;;;;
1D77E;MATHEMATICAL SANS-SERIF BOLD SMALL OMICRON;Ll;0;L;<font> 03BF;;;;N;;;;;
1D77F;MATHEMATICAL SANS-SERIF BOLD SMALL PI;Ll;0;L;<font> 03C0;;;;N;;;;;
1D780;MATHEMATICAL SANS-SERIF BOLD SMALL RHO;Ll;0;L;<font> 03C1;;;;N;;;;;
1D781;MATHEMATICAL SANS-SERIF BOLD SMALL FINAL SIGMA;Ll;0;L;<font> 03C2;;;;N;;;;;
1D782;MATHEMATICAL SANS-SERIF BOLD SMALL SIGMA;Ll;0;L;<font> 03C3;;;;N;;;;;
1D783;MATHEMATICAL SANS-SERIF BOLD SMALL TAU;Ll;0;L;<font> 03C4;;;;N;;;;;
1D784;MATHEMATICAL SANS-SERIF BOLD SMALL UPSILON;Ll;0;L;<font> 03C5;;;;N;;;;;
1D785;MATHEMATICAL SANS-SERIF BOLD SMALL PHI;Ll;0;L;<font> 03C6;;;;N;;;;;
1D786;MATHEMATICAL SANS-SERIF BOLD SMALL CHI;Ll;0;L;<font> 03C7;;;;N;;;;;
1D787;MATHEMATICAL SANS-SERIF BOLD SMALL PSI;Ll;0;L;<font> 03C8;;;;N;;;;;
1D788;MATHEMATICAL SANS-SERIF BOLD SMALL OMEGA;Ll;0;L;<font> 03C9;;;;N;;;;;
1D789;MATHEMATICAL SANS-SERIF BOLD PARTIAL DIFFERENTIAL;Sm;0;ON;<font> 2202;;;;Y;;;;;
1D78A;MATHEMATICAL SANS-SERIF BOLD EPSILON SYMBOL;Ll;0;L;<font> 03F5;;;;N;;;;;
1D78B;MATHEMATICAL SANS-SERIF BOLD THETA SYMBOL;Ll;0;L;<font> 03D1;;;;N;;;;;
1D78C;MATHEMATICAL SANS-SERIF BOLD KAPPA SYMBOL;Ll;0;L;<font> 03F0;;;;N;;;;;
1D78D;MATHEMATICAL SANS-SERIF BOLD PHI SYMBOL;Ll;0;L;<font> 03D5;;;;N;;;;;
1D78E;MATHEMATICAL SANS-SERIF BOLD RHO SYMBOL;Ll;0;L;<font> 03F1;;;;N;;;;;
1D78F;MATHEMATICAL SANS-SERIF BOLD PI SYMBOL;Ll;0;L;<font> 03D6;;;;N;;;;;
1D790;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL ALPHA;Lu;0;L;<font> 0391;;;;N;;;;;
1D791;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL BETA;Lu;0;L;<font> 0392;;;;N;;;;;
1D792;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL GAMMA;Lu;0;L;<font> 0393;;;;N;;;;;
1D793;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL DELTA;Lu;0;L;<font> 0394;;;;N;;;;;
1D794;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL EPSILON;Lu;0;L;<font> 0395;;;;N;;;;;
1D795;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL ZETA;Lu;0;L;<font> 0396;;;;N;;;;;
1D796;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL ETA;Lu;0;L;<font> 0397;;;;N;;;;;
1D797;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL THETA;Lu;0;L;<font> 0398;;;;N;;;;;
1D798;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL IOTA;Lu;0;L;<font> 0399;;;;N;;;;;
1D799;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL KAPPA;Lu;0;L;<font> 039A;;;;N;;;;;
1D79A;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL LAMDA;Lu;0;L;<font> 039B;;;;N;;;;;
1D79B;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL MU;Lu;0;L;<font> 039C;;;;N;;;;;
1D79C;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL NU;Lu;0;L;<font> 039D;;;;N;;;;;
1D79D;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL XI;Lu;0;L;<font> 039E;;;;N;;;;;
1D79E;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL OMICRON;Lu;0;L;<font> 039F;;;;N;;;;;
1D79F;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL PI;Lu;0;L;<font> 03A0;;;;N;;;;;
1D7A0;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL RHO;Lu;0;L;<font> 03A1;;;;N;;;;;
1D7A1;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL THETA SYMBOL;Lu;0;L;<font> 03F4;;;;N;;;;;
1D7A2;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL SIGMA;Lu;0;L;<font> 03A3;;;;N;;;;;
1D7A3;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL TAU;Lu;0;L;<font> 03A4;;;;N;;;;;
1D7A4;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL UPSILON;Lu;0;L;<font> 03A5;;;;N;;;;;
1D7A5;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL PHI;Lu;0;L;<font> 03A6;;;;N;;;;;
1D7A6;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL CHI;Lu;0;L;<font> 03A7;;;;N;;;;;
1D7A7;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL PSI;Lu;0;L;<font> 03A8;;;;N;;;;;
1D7A8;MATHEMATICAL SANS-SERIF BOLD ITALIC CAPITAL OMEGA;Lu;0;L;<font> 03A9;;;;N;;;;;
1D7A9;MATHEMATICAL SANS-SERIF BOLD ITALIC NABLA;Sm;0;L;<font> 2207;;;;N;;;;;
1D7AA;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL ALPHA;Ll;0;L;<font> 03B1;;;;N;;;;;
1D7AB;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL BETA;Ll;0;L;<font> 03B2;;;;N;;;;;
1D7AC;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL GAMMA;Ll;0;L;<font> 03B3;;;;N;;;;;
1D7AD;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL DELTA;Ll;0;L;<font> 03B4;;;;N;;;;;
1D7AE;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL EPSILON;Ll;0;L;<font> 03B5;;;;N;;;;;
1D7AF;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL ZETA;Ll;0;L;<font> 03B6;;;;N;;;;;
1D7B0;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL ETA;Ll;0;L;<font> 03B7;;;;N;;;;;
1D7B1;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL THETA;Ll;0;L;<font> 03B8;;;;N;;;;;
1D7B2;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL IOTA;Ll;0;L;<font> 03B9;;;;N;;;;;
1D7B3;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL KAPPA;Ll;0;L;<font> 03BA;;;;N;;;;;
1D7B4;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL LAMDA;Ll;0;L;<font> 03BB;;;;N;;;;;
1D7B5;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL MU;Ll;0;L;<font> 03BC;;;;N;;;;;
1D7B6;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL NU;Ll;0;L;<font> 03BD;;;;N;;;;;
1D7B7;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL XI;Ll;0;L;<font> 03BE;;;;N;;;;;
1D7B8;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL OMICRON;Ll;0;L;<font> 03BF;;;;N;;;;;
1D7B9;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL PI;Ll;0;L;<font> 03C0;;;;N;;;;;
1D7BA;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL RHO;Ll;0;L;<font> 03C1;;;;N;;;;;
1D7BB;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL FINAL SIGMA;Ll;0;L;<font> 03C2;;;;N;;;;;
1D7BC;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL SIGMA;Ll;0;L;<font> 03C3;;;;N;;;;;
1D7BD;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL TAU;Ll;0;L;<font> 03C4;;;;N;;;;;
1D7BE;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL UPSILON;Ll;0;L;<font> 03C5;;;;N;;;;;
1D7BF;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL PHI;Ll;0;L;<font> 03C6;;;;N;;;;;
1D7C0;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL CHI;Ll;0;L;<font> 03C7;;;;N;;;;;
1D7C1;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL PSI;Ll;0;L;<font> 03C8;;;;N;;;;;
1D7C2;MATHEMATICAL SANS-SERIF BOLD ITALIC SMALL OMEGA;Ll;0;L;<font> 03C9;;;;N;;;;;
1D7C3;MATHEMATICAL SANS-SERIF BOLD ITALIC PARTIAL DIFFERENTIAL;Sm;0;ON;<font> 2202;;;;Y;;;;;
1D7C4;MATHEMATICAL SANS-SERIF BOLD ITALIC EPSILON SYMBOL;Ll;0;L;<font> 03F5;;;;N;;;;;
1D7C5;MATHEMATICAL SANS-SERIF BOLD ITALIC THETA SYMBOL;Ll;0;L;<font> 03D1;;;;N;;;;;
1D7C6;MATHEMATICAL SANS-SERIF BOLD ITALIC KAPPA SYMBOL;Ll;0;L;<font> 03F0;;;;N;;;;;
1D7C7;MATHEMATICAL SANS-SERIF BOLD ITALIC PHI SYMBOL;Ll;0;L;<font> 03D5;;;;N;;;;;
1D7C8;MATHEMATICAL SANS-SERIF BOLD ITALIC RHO SYMBOL;Ll;0;L;<font> 03F1;;;;N;;;;;
1D7C9;MATHEMATICAL SANS-SERIF BOLD ITALIC PI SYMBOL;Ll;0;L;<font> 03D6;;;;N;;;;;
1D7CA;MATHEMATICAL BOLD CAPITAL DIGAMMA;Lu;0;L;<font> 03DC;;;;N;;;;;
1D7CB;MATHEMATICAL BOLD SMALL DIGAMMA;Ll;0;L;<font> 03DD;;;;N;;;;;
1D7CE;MATHEMATICAL BOLD DIGIT ZERO;Nd;0;EN;<font> 0030;0;0;0;N;;;;;
1D7CF;MATHEMATICAL BOLD DIGIT ONE;Nd;0;EN;<font> 0031;1;1;1;N;;;;;
1D7D0;MATHEMATICAL BOLD DIGIT TWO;Nd;0;EN;<font> 0032;2;2;2;N;;;;;
1D7D1;MATHEMATICAL BOLD DIGIT THREE;Nd;0;EN;<font> 0033;3;3;3;N;;;;;
1D7D2;MATHEMATICAL BOLD DIGIT FOUR;Nd;0;EN;<font> 0034;4;4;4;N;;;;;
1D7D3;MATHEMATICAL BOLD DIGIT FIVE;Nd;0;EN;<font> 0035;5;5;5;N;;;;;
1D7D4;MATHEMATICAL BOLD DIGIT SIX;Nd;0;EN;<font> 0036;6;6;6;N;;;;;
1D7D5;MATHEMATICAL BOLD DIGIT SEVEN;Nd;0;EN;<font> 0037;7;7;7;N;;;;;
1D7D6;MATHEMATICAL BOLD DIGIT EIGHT;Nd;0;EN;<font> 0038;8;8;8;N;;;;;
1D7D7;MATHEMATICAL BOLD DIGIT NINE;Nd;0;EN;<font> 0039;9;9;9;N;;;;;
1D7D8;MATHEMATICAL DOUBLE-STRUCK DIGIT ZERO;Nd;0;EN;<font> 0030;0;0;0;N;;;;;
1D7D9;MATHEMATICAL DOUBLE-STRUCK DIGIT ONE;Nd;0;EN;<font> 0031;1;1;1;N;;;;;
1D7DA;MATHEMATICAL DOUBLE-STRUCK DIGIT TWO;Nd;0;EN;<font> 0032;2;2;2;N;;;;;
1D7DB;MATHEMATICAL DOUBLE-STRUCK DIGIT THREE;Nd;0;EN;<font> 0033;3;3;3;N;;;;;
1D7DC;MATHEMATICAL DOUBLE-STRUCK DIGIT FOUR;Nd;0;EN;<font> 0034;4;4;4;N;;;;;
1D7DD;MATHEMATICAL DOUBLE-STRUCK DIGIT FIVE;Nd;0;EN;<font> 0035;5;5;5;N;;;;;
1D7DE;MATHEMATICAL DOUBLE-STRUCK DIGIT SIX;Nd;0;EN;<font> 0036;6;6;6;N;;;;;
1D7DF;MATHEMATICAL DOUBLE-STRUCK DIGIT SEVEN;Nd;0;EN;<font> 0037;7;7;7;N;;;;;
1D7E0;MATHEMATICAL DOUBLE-STRUCK DIGIT EIGHT;Nd;0;EN;<font> 0038;8;8;8;N;;;;;
1D7E1;MATHEMATICAL DOUBLE-STRUCK DIGIT NINE;Nd;0;EN;<font> 0039;9;9;9;N;;;;;
1D7E2;MATHEMATICAL SANS-SERIF DIGIT ZERO;Nd;0;EN;<font> 0030;0;0;0;N;;;;;
1D7E3;MATHEMATICAL SANS-SERIF DIGIT ONE;Nd;0;EN;<font> 0031;1;1;1;N;;;;;
1D7E4;MATHEMATICAL SANS-SERIF DIGIT TWO;Nd;0;EN;<font> 0032;2;2;2;N;;;;;
1D7E5;MATHEMATICAL SANS-SERIF DIGIT THREE;Nd;0;EN;<font> 0033;3;3;3;N;;;;;
1D7E6;MATHEMATICAL SANS-SERIF DIGIT FOUR;Nd;0;EN;<font> 0034;4;4;4;N;;;;;
1D7E7;MATHEMATICAL SANS-SERIF DIGIT FIVE;Nd;0;EN;<font> 0035;5;5;5;N;;;;;
1D7E8;MATHEMATICAL SANS-SERIF DIGIT SIX;Nd;0;EN;<font> 0036;6;6;6;N;;;;;
1D7E9;MATHEMATICAL SANS-SERIF DIGIT SEVEN;Nd;0;EN;<font> 0037;7;7;7;N;;;;;
1D7EA;MATHEMATICAL SANS-SERIF DIGIT EIGHT;Nd;0;EN;<font> 0038;8;8;8;N;;;;;
1D7EB;MATHEMATICAL SANS-SERIF DIGIT NINE;Nd;0;EN;<font> 0039;9;9;9;N;;;;;
1D7EC;MATHEMATICAL SANS-SERIF BOLD DIGIT ZERO;Nd;0;EN;<font> 0030;0;0;0;N;;;;;
1D7ED;MATHEMATICAL SANS-SERIF BOLD DIGIT ONE;Nd;0;EN;<font> 0031;1;1;1;N;;;;;
1D7EE;MATHEMATICAL SANS-SERIF BOLD DIGIT TWO;Nd;0;EN;<font> 0032;2;2;2;N;;;;;
1D7EF;MATHEMATICAL SANS-SERIF BOLD DIGIT THREE;Nd;0;EN;<font> 0033;3;3;3;N;;;;;
1D7F0;MATHEMATICAL SANS-SERIF BOLD DIGIT FOUR;Nd;0;EN;<font> 0034;4;4;4;N;;;;;
1D7F1;MATHEMATICAL SANS-SERIF BOLD DIGIT FIVE;Nd;0;EN;<font> 0035;5;5;5;N;;;;;
1D7F2;MATHEMATICAL SANS-SERIF BOLD DIGIT SIX;Nd;0;EN;<font> 0036;6;6;6;N;;;;;
1D7F3;MATHEMATICAL SANS-SERIF BOLD DIGIT SEVEN;Nd;0;EN;<font> 0037;7;7;7;N;;;;;
1D7F4;MATHEMATICAL SANS-SERIF BOLD DIGIT EIGHT;Nd;0;EN;<font> 0038;8;8;8;N;;;;;
1D7F5;MATHEMATICAL SANS-SERIF BOLD DIGIT NINE;Nd;0;EN;<font> 0039;9;9;9;N;;;;;
1D7F6;MATHEMATICAL MONOSPACE DIGIT ZERO;Nd;0;EN;<font> 0030;0;0;0;N;;;;;
1D7F7;MATHEMATICAL MONOSPACE DIGIT ONE;Nd;0;EN;<font> 0031;1;1;1;N;;;;;
1D7F8;MATHEMATICAL MONOSPACE DIGIT TWO;Nd;0;EN;<font> 0032;2;2;2;N;;;;;
1D7F9;MATHEMATICAL MONOSPACE DIGIT THREE;Nd;0;EN;<font> 0033;3;3;3;N;;;;;
1D7FA;MATHEMATICAL MONOSPACE DIGIT FOUR;Nd;0;EN;<font> 0034;4;4;4;N;;;;;
1D7FB;MATHEMATICAL MONOSPACE DIGIT FIVE;Nd;0;EN;<font> 0035;5;5;5;N;;;;;
1D7FC;MATHEMATICAL MONOSPACE DIGIT SIX;Nd;0;EN;<font> 0036;6;6;6;N;;;;;
1D7FD;MATHEMATICAL MONOSPACE DIGIT SEVEN;Nd;0;EN;<font> 0037;7;7;7;N;;;;;
1D7FE;MATHEMATICAL MONOSPACE DIGIT EIGHT;Nd;0;EN;<font> 0038;8;8;8;N;;;;;
1D7FF;MATHEMATICAL MONOSPACE DIGIT NINE;Nd;0;EN;<font> 0039;9;9;9;N;;;;;
1D800;SIGNWRITING HAND-FIST INDEX;So;0;L;;;;;N;;;;;
1D801;SIGNWRITING HAND-CIRCLE INDEX;So;0;L;;;;;N;;;;;
1D802;SIGNWRITING HAND-CUP INDEX;So;0;L;;;;;N;;;;;
1D803;SIGNWRITING HAND-OVAL INDEX;So;0;L;;;;;N;;;;;
1D804;SIGNWRITING HAND-HINGE INDEX;So;0;L;;;;;N;;;;;
1D805;SIGNWRITING HAND-ANGLE INDEX;So;0;L;;;;;N;;;;;
1D806;SIGNWRITING HAND-FIST INDEX BENT;So;0;L;;;;;N;;;;;
1D807;SIGNWRITING HAND-CIRCLE INDEX BENT;So;0;L;;;;;N;;;;;
1D808;SIGNWRITING HAND-FIST THUMB UNDER INDEX BENT;So;0;L;;;;;N;;;;;
1D809;SIGNWRITING HAND-FIST INDEX RAISED KNUCKLE;So;0;L;;;;;N;;;;;
1D80A;SIGNWRITING HAND-FIST INDEX CUPPED;So;0;L;;;;;N;;;;;
1D80B;SIGNWRITING HAND-FIST INDEX HINGED;So;0;L;;;;;N;;;;;
1D80C;SIGNWRITING HAND-FIST INDEX HINGED LOW;So;0;L;;;;;N;;;;;
1D80D;SIGNWRITING HAND-CIRCLE INDEX HINGE;So;0;L;;;;;N;;;;;
1D80E;SIGNWRITING HAND-FIST INDEX MIDDLE;So;0;L;;;;;N;;;;;
1D80F;SIGNWRITING HAND-CIRCLE INDEX MIDDLE;So;0;L;;;;;N;;;;;
1D810;SIGNWRITING HAND-FIST INDEX MIDDLE BENT;So;0;L;;;;;N;;;;;
1D811;SIGNWRITING HAND-FIST INDEX MIDDLE RAISED KNUCKLES;So;0;L;;;;;N;;;;;
1D812;SIGNWRITING HAND-FIST INDEX MIDDLE HINGED;So;0;L;;;;;N;;;;;
1D813;SIGNWRITING HAND-FIST INDEX UP MIDDLE HINGED;So;0;L;;;;;N;;;;;
1D814;SIGNWRITING HAND-FIST INDEX HINGED MIDDLE UP;So;0;L;;;;;N;;;;;
1D815;SIGNWRITING HAND-FIST INDEX MIDDLE CONJOINED;So;0;L;;;;;N;;;;;
1D816;SIGNWRITING HAND-FIST INDEX MIDDLE CONJOINED INDEX BENT;So;0;L;;;;;N;;;;;
1D817;SIGNWRITING HAND-FIST INDEX MIDDLE CONJOINED MIDDLE BENT;So;0;L;;;;;N;;;;;
1D818;SIGNWRITING HAND-FIST INDEX MIDDLE CONJOINED CUPPED;So;0;L;;;;;N;;;;;
1D819;SIGNWRITING HAND-FIST INDEX MIDDLE CONJOINED HINGED;So;0;L;;;;;N;;;;;
1D81A;SIGNWRITING HAND-FIST INDEX MIDDLE CROSSED;So;0;L;;;;;N;;;;;
1D81B;SIGNWRITING HAND-CIRCLE INDEX MIDDLE CROSSED;So;0;L;;;;;N;;;;;
1D81C;SIGNWRITING HAND-FIST MIDDLE BENT OVER INDEX;So;0;L;;;;;N;;;;;
1D81D;SIGNWRITING HAND-FIST INDEX BENT OVER MIDDLE;So;0;L;;;;;N;;;;;
1D81E;SIGNWRITING HAND-FIST INDEX MIDDLE THUMB;So;0;L;;;;;N;;;;;
1D81F;SIGNWRITING HAND-CIRCLE INDEX MIDDLE THUMB;So;0;L;;;;;N;;;;;
1D820;SIGNWRITING HAND-FIST INDEX MIDDLE STRAIGHT THUMB BENT;So;0;L;;;;;N;;;;;
1D821;SIGNWRITING HAND-FIST INDEX MIDDLE BENT THUMB STRAIGHT;So;0;L;;;;;N;;;;;
1D822;SIGNWRITING HAND-FIST INDEX MIDDLE THUMB BENT;So;0;L;;;;;N;;;;;
1D823;SIGNWRITING HAND-FIST INDEX MIDDLE HINGED SPREAD THUMB SIDE;So;0;L;;;;;N;;;;;
1D824;SIGNWRITING HAND-FIST INDEX UP MIDDLE HINGED THUMB SIDE;So;0;L;;;;;N;;;;;
1D825;SIGNWRITING HAND-FIST INDEX UP MIDDLE HINGED THUMB CONJOINED;So;0;L;;;;;N;;;;;
1D826;SIGNWRITING HAND-FIST INDEX HINGED MIDDLE UP THUMB SIDE;So;0;L;;;;;N;;;;;
1D827;SIGNWRITING HAND-FIST INDEX MIDDLE UP SPREAD THUMB FORWARD;So;0;L;;;;;N;;;;;
1D828;SIGNWRITING HAND-FIST INDEX MIDDLE THUMB CUPPED;So;0;L;;;;;N;;;;;
1D829;SIGNWRITING HAND-FIST INDEX MIDDLE THUMB CIRCLED;So;0;L;;;;;N;;;;;
1D82A;SIGNWRITING HAND-FIST INDEX MIDDLE THUMB HOOKED;So;0;L;;;;;N;;;;;
1D82B;SIGNWRITING HAND-FIST INDEX MIDDLE THUMB HINGED;So;0;L;;;;;N;;;;;
1D82C;SIGNWRITING HAND-FIST THUMB BETWEEN INDEX MIDDLE STRAIGHT;So;0;L;;;;;N;;;;;
1D82D;SIGNWRITING HAND-FIST INDEX MIDDLE CONJOINED THUMB SIDE;So;0;L;;;;;N;;;;;
1D82E;SIGNWRITING HAND-FIST INDEX MIDDLE CONJOINED THUMB SIDE CONJOINED;So;0;L;;;;;N;;;;;
1D82F;SIGNWRITING HAND-FIST INDEX MIDDLE CONJOINED THUMB SIDE BENT;So;0;L;;;;;N;;;;;
1D830;SIGNWRITING HAND-FIST MIDDLE THUMB HOOKED INDEX UP;So;0;L;;;;;N;;;;;
1D831;SIGNWRITING HAND-FIST INDEX THUMB HOOKED MIDDLE UP;So;0;L;;;;;N;;;;;
1D832;SIGNWRITING HAND-FIST INDEX MIDDLE CONJOINED HINGED THUMB SIDE;So;0;L;;;;;N;;;;;
1D833;SIGNWRITING HAND-FIST INDEX MIDDLE CROSSED THUMB SIDE;So;0;L;;;;;N;;;;;
1D834;SIGNWRITING HAND-FIST INDEX MIDDLE CONJOINED THUMB FORWARD;So;0;L;;;;;N;;;;;
1D835;SIGNWRITING HAND-FIST INDEX MIDDLE CONJOINED CUPPED THUMB FORWARD;So;0;L;;;;;N;;;;;
1D836;SIGNWRITING HAND-FIST MIDDLE THUMB CUPPED INDEX UP;So;0;L;;;;;N;;;;;
1D837;SIGNWRITING HAND-FIST INDEX THUMB CUPPED MIDDLE UP;So;0;L;;;;;N;;;;;
1D838;SIGNWRITING HAND-FIST MIDDLE THUMB CIRCLED INDEX UP;So;0;L;;;;;N;;;;;
1D839;SIGNWRITING HAND-FIST MIDDLE THUMB CIRCLED INDEX HINGED;So;0;L;;;;;N;;;;;
1D83A;SIGNWRITING HAND-FIST INDEX THUMB ANGLED OUT MIDDLE UP;So;0;L;;;;;N;;;;;
1D83B;SIGNWRITING HAND-FIST INDEX THUMB ANGLED IN MIDDLE UP;So;0;L;;;;;N;;;;;
1D83C;SIGNWRITING HAND-FIST INDEX THUMB CIRCLED MIDDLE UP;So;0;L;;;;;N;;;;;
1D83D;SIGNWRITING HAND-FIST INDEX MIDDLE THUMB CONJOINED HINGED;So;0;L;;;;;N;;;;;
1D83E;SIGNWRITING HAND-FIST INDEX MIDDLE THUMB ANGLED OUT;So;0;L;;;;;N;;;;;
1D83F;SIGNWRITING HAND-FIST INDEX MIDDLE THUMB ANGLED;So;0;L;;;;;N;;;;;
1D840;SIGNWRITING HAND-FIST MIDDLE THUMB ANGLED OUT INDEX UP;So;0;L;;;;;N;;;;;
1D841;SIGNWRITING HAND-FIST MIDDLE THUMB ANGLED OUT INDEX CROSSED;So;0;L;;;;;N;;;;;
1D842;SIGNWRITING HAND-FIST MIDDLE THUMB ANGLED INDEX UP;So;0;L;;;;;N;;;;;
1D843;SIGNWRITING HAND-FIST INDEX THUMB HOOKED MIDDLE HINGED;So;0;L;;;;;N;;;;;
1D844;SIGNWRITING HAND-FLAT FOUR FINGERS;So;0;L;;;;;N;;;;;
1D845;SIGNWRITING HAND-FLAT FOUR FINGERS BENT;So;0;L;;;;;N;;;;;
1D846;SIGNWRITING HAND-FLAT FOUR FINGERS HINGED;So;0;L;;;;;N;;;;;
1D847;SIGNWRITING HAND-FLAT FOUR FINGERS CONJOINED;So;0;L;;;;;N;;;;;
1D848;SIGNWRITING HAND-FLAT FOUR FINGERS CONJOINED SPLIT;So;0;L;;;;;N;;;;;
1D849;SIGNWRITING HAND-CLAW FOUR FINGERS CONJOINED;So;0;L;;;;;N;;;;;
1D84A;SIGNWRITING HAND-FIST FOUR FINGERS CONJOINED BENT;So;0;L;;;;;N;;;;;
1D84B;SIGNWRITING HAND-HINGE FOUR FINGERS CONJOINED;So;0;L;;;;;N;;;;;
1D84C;SIGNWRITING HAND-FLAT FIVE FINGERS SPREAD;So;0;L;;;;;N;;;;;
1D84D;SIGNWRITING HAND-FLAT HEEL FIVE FINGERS SPREAD;So;0;L;;;;;N;;;;;
1D84E;SIGNWRITING HAND-FLAT FIVE FINGERS SPREAD FOUR BENT;So;0;L;;;;;N;;;;;
1D84F;SIGNWRITING HAND-FLAT HEEL FIVE FINGERS SPREAD FOUR BENT;So;0;L;;;;;N;;;;;
1D850;SIGNWRITING HAND-FLAT FIVE FINGERS SPREAD BENT;So;0;L;;;;;N;;;;;
1D851;SIGNWRITING HAND-FLAT HEEL FIVE FINGERS SPREAD BENT;So;0;L;;;;;N;;;;;
1D852;SIGNWRITING HAND-FLAT FIVE FINGERS SPREAD THUMB FORWARD;So;0;L;;;;;N;;;;;
1D853;SIGNWRITING HAND-CUP FIVE FINGERS SPREAD;So;0;L;;;;;N;;;;;
1D854;SIGNWRITING HAND-CUP FIVE FINGERS SPREAD OPEN;So;0;L;;;;;N;;;;;
1D855;SIGNWRITING HAND-HINGE FIVE FINGERS SPREAD OPEN;So;0;L;;;;;N;;;;;
1D856;SIGNWRITING HAND-OVAL FIVE FINGERS SPREAD;So;0;L;;;;;N;;;;;
1D857;SIGNWRITING HAND-FLAT FIVE FINGERS SPREAD HINGED;So;0;L;;;;;N;;;;;
1D858;SIGNWRITING HAND-FLAT FIVE FINGERS SPREAD HINGED THUMB SIDE;So;0;L;;;;;N;;;;;
1D859;SIGNWRITING HAND-FLAT FIVE FINGERS SPREAD HINGED NO THUMB;So;0;L;;;;;N;;;;;
1D85A;SIGNWRITING HAND-FLAT;So;0;L;;;;;N;;;;;
1D85B;SIGNWRITING HAND-FLAT BETWEEN PALM FACINGS;So;0;L;;;;;N;;;;;
1D85C;SIGNWRITING HAND-FLAT HEEL;So;0;L;;;;;N;;;;;
1D85D;SIGNWRITING HAND-FLAT THUMB SIDE;So;0;L;;;;;N;;;;;
1D85E;SIGNWRITING HAND-FLAT HEEL THUMB SIDE;So;0;L;;;;;N;;;;;
1D85F;SIGNWRITING HAND-FLAT THUMB BENT;So;0;L;;;;;N;;;;;
1D860;SIGNWRITING HAND-FLAT THUMB FORWARD;So;0;L;;;;;N;;;;;
1D861;SIGNWRITING HAND-FLAT SPLIT INDEX THUMB SIDE;So;0;L;;;;;N;;;;;
1D862;SIGNWRITING HAND-FLAT SPLIT CENTRE;So;0;L;;;;;N;;;;;
1D863;SIGNWRITING HAND-FLAT SPLIT CENTRE THUMB SIDE;So;0;L;;;;;N;;;;;
1D864;SIGNWRITING HAND-FLAT SPLIT CENTRE THUMB SIDE BENT;So;0;L;;;;;N;;;;;
1D865;SIGNWRITING HAND-FLAT SPLIT LITTLE;So;0;L;;;;;N;;;;;
1D866;SIGNWRITING HAND-CLAW;So;0;L;;;;;N;;;;;
1D867;SIGNWRITING HAND-CLAW THUMB SIDE;So;0;L;;;;;N;;;;;
1D868;SIGNWRITING HAND-CLAW NO THUMB;So;0;L;;;;;N;;;;;
1D869;SIGNWRITING HAND-CLAW THUMB FORWARD;So;0;L;;;;;N;;;;;
1D86A;SIGNWRITING HAND-HOOK CURLICUE;So;0;L;;;;;N;;;;;
1D86B;SIGNWRITING HAND-HOOK;So;0;L;;;;;N;;;;;
1D86C;SIGNWRITING HAND-CUP OPEN;So;0;L;;;;;N;;;;;
1D86D;SIGNWRITING HAND-CUP;So;0;L;;;;;N;;;;;
1D86E;SIGNWRITING HAND-CUP OPEN THUMB SIDE;So;0;L;;;;;N;;;;;
1D86F;SIGNWRITING HAND-CUP THUMB SIDE;So;0;L;;;;;N;;;;;
1D870;SIGNWRITING HAND-CUP OPEN NO THUMB;So;0;L;;;;;N;;;;;
1D871;SIGNWRITING HAND-CUP NO THUMB;So;0;L;;;;;N;;;;;
1D872;SIGNWRITING HAND-CUP OPEN THUMB FORWARD;So;0;L;;;;;N;;;;;
1D873;SIGNWRITING HAND-CUP THUMB FORWARD;So;0;L;;;;;N;;;;;
1D874;SIGNWRITING HAND-CURLICUE OPEN;So;0;L;;;;;N;;;;;
1D875;SIGNWRITING HAND-CURLICUE;So;0;L;;;;;N;;;;;
1D876;SIGNWRITING HAND-CIRCLE;So;0;L;;;;;N;;;;;
1D877;SIGNWRITING HAND-OVAL;So;0;L;;;;;N;;;;;
1D878;SIGNWRITING HAND-OVAL THUMB SIDE;So;0;L;;;;;N;;;;;
1D879;SIGNWRITING HAND-OVAL NO THUMB;So;0;L;;;;;N;;;;;
1D87A;SIGNWRITING HAND-OVAL THUMB FORWARD;So;0;L;;;;;N;;;;;
1D87B;SIGNWRITING HAND-HINGE OPEN;So;0;L;;;;;N;;;;;
1D87C;SIGNWRITING HAND-HINGE OPEN THUMB FORWARD;So;0;L;;;;;N;;;;;
1D87D;SIGNWRITING HAND-HINGE;So;0;L;;;;;N;;;;;
1D87E;SIGNWRITING HAND-HINGE SMALL;So;0;L;;;;;N;;;;;
1D87F;SIGNWRITING HAND-HINGE OPEN THUMB SIDE;So;0;L;;;;;N;;;;;
1D880;SIGNWRITING HAND-HINGE THUMB SIDE;So;0;L;;;;;N;;;;;
1D881;SIGNWRITING HAND-HINGE OPEN NO THUMB;So;0;L;;;;;N;;;;;
1D882;SIGNWRITING HAND-HINGE NO THUMB;So;0;L;;;;;N;;;;;
1D883;SIGNWRITING HAND-HINGE THUMB SIDE TOUCHING INDEX;So;0;L;;;;;N;;;;;
1D884;SIGNWRITING HAND-HINGE THUMB BETWEEN MIDDLE RING;So;0;L;;;;;N;;;;;
1D885;SIGNWRITING HAND-ANGLE;So;0;L;;;;;N;;;;;
1D886;SIGNWRITING HAND-FIST INDEX MIDDLE RING;So;0;L;;;;;N;;;;;
1D887;SIGNWRITING HAND-CIRCLE INDEX MIDDLE RING;So;0;L;;;;;N;;;;;
1D888;SIGNWRITING HAND-HINGE INDEX MIDDLE RING;So;0;L;;;;;N;;;;;
1D889;SIGNWRITING HAND-ANGLE INDEX MIDDLE RING;So;0;L;;;;;N;;;;;
1D88A;SIGNWRITING HAND-HINGE LITTLE;So;0;L;;;;;N;;;;;
1D88B;SIGNWRITING HAND-FIST INDEX MIDDLE RING BENT;So;0;L;;;;;N;;;;;
1D88C;SIGNWRITING HAND-FIST INDEX MIDDLE RING CONJOINED;So;0;L;;;;;N;;;;;
1D88D;SIGNWRITING HAND-HINGE INDEX MIDDLE RING CONJOINED;So;0;L;;;;;N;;;;;
1D88E;SIGNWRITING HAND-FIST LITTLE DOWN;So;0;L;;;;;N;;;;;
1D88F;SIGNWRITING HAND-FIST LITTLE DOWN RIPPLE STRAIGHT;So;0;L;;;;;N;;;;;
1D890;SIGNWRITING HAND-FIST LITTLE DOWN RIPPLE CURVED;So;0;L;;;;;N;;;;;
1D891;SIGNWRITING HAND-FIST LITTLE DOWN OTHERS CIRCLED;So;0;L;;;;;N;;;;;
1D892;SIGNWRITING HAND-FIST LITTLE UP;So;0;L;;;;;N;;;;;
1D893;SIGNWRITING HAND-FIST THUMB UNDER LITTLE UP;So;0;L;;;;;N;;;;;
1D894;SIGNWRITING HAND-CIRCLE LITTLE UP;So;0;L;;;;;N;;;;;
1D895;SIGNWRITING HAND-OVAL LITTLE UP;So;0;L;;;;;N;;;;;
1D896;SIGNWRITING HAND-ANGLE LITTLE UP;So;0;L;;;;;N;;;;;
1D897;SIGNWRITING HAND-FIST LITTLE RAISED KNUCKLE;So;0;L;;;;;N;;;;;
1D898;SIGNWRITING HAND-FIST LITTLE BENT;So;0;L;;;;;N;;;;;
1D899;SIGNWRITING HAND-FIST LITTLE TOUCHES THUMB;So;0;L;;;;;N;;;;;
1D89A;SIGNWRITING HAND-FIST LITTLE THUMB;So;0;L;;;;;N;;;;;
1D89B;SIGNWRITING HAND-HINGE LITTLE THUMB;So;0;L;;;;;N;;;;;
1D89C;SIGNWRITING HAND-FIST LITTLE INDEX THUMB;So;0;L;;;;;N;;;;;
1D89D;SIGNWRITING HAND-HINGE LITTLE INDEX THUMB;So;0;L;;;;;N;;;;;
1D89E;SIGNWRITING HAND-ANGLE LITTLE INDEX THUMB INDEX THUMB OUT;So;0;L;;;;;N;;;;;
1D89F;SIGNWRITING HAND-ANGLE LITTLE INDEX THUMB INDEX THUMB;So;0;L;;;;;N;;;;;
1D8A0;SIGNWRITING HAND-FIST LITTLE INDEX;So;0;L;;;;;N;;;;;
1D8A1;SIGNWRITING HAND-CIRCLE LITTLE INDEX;So;0;L;;;;;N;;;;;
1D8A2;SIGNWRITING HAND-HINGE LITTLE INDEX;So;0;L;;;;;N;;;;;
1D8A3;SIGNWRITING HAND-ANGLE LITTLE INDEX;So;0;L;;;;;N;;;;;
1D8A4;SIGNWRITING HAND-FIST INDEX MIDDLE LITTLE;So;0;L;;;;;N;;;;;
1D8A5;SIGNWRITING HAND-CIRCLE INDEX MIDDLE LITTLE;So;0;L;;;;;N;;;;;
1D8A6;SIGNWRITING HAND-HINGE INDEX MIDDLE LITTLE;So;0;L;;;;;N;;;;;
1D8A7;SIGNWRITING HAND-HINGE RING;So;0;L;;;;;N;;;;;
1D8A8;SIGNWRITING HAND-ANGLE INDEX MIDDLE LITTLE;So;0;L;;;;;N;;;;;
1D8A9;SIGNWRITING HAND-FIST INDEX MIDDLE CROSS LITTLE;So;0;L;;;;;N;;;;;
1D8AA;SIGNWRITING HAND-CIRCLE INDEX MIDDLE CROSS LITTLE;So;0;L;;;;;N;;;;;
1D8AB;SIGNWRITING HAND-FIST RING DOWN;So;0;L;;;;;N;;;;;
1D8AC;SIGNWRITING HAND-HINGE RING DOWN INDEX THUMB HOOK MIDDLE;So;0;L;;;;;N;;;;;
1D8AD;SIGNWRITING HAND-ANGLE RING DOWN MIDDLE THUMB INDEX CROSS;So;0;L;;;;;N;;;;;
1D8AE;SIGNWRITING HAND-FIST RING UP;So;0;L;;;;;N;;;;;
1D8AF;SIGNWRITING HAND-FIST RING RAISED KNUCKLE;So;0;L;;;;;N;;;;;
1D8B0;SIGNWRITING HAND-FIST RING LITTLE;So;0;L;;;;;N;;;;;
1D8B1;SIGNWRITING HAND-CIRCLE RING LITTLE;So;0;L;;;;;N;;;;;
1D8B2;SIGNWRITING HAND-OVAL RING LITTLE;So;0;L;;;;;N;;;;;
1D8B3;SIGNWRITING HAND-ANGLE RING LITTLE;So;0;L;;;;;N;;;;;
1D8B4;SIGNWRITING HAND-FIST RING MIDDLE;So;0;L;;;;;N;;;;;
1D8B5;SIGNWRITING HAND-FIST RING MIDDLE CONJOINED;So;0;L;;;;;N;;;;;
1D8B6;SIGNWRITING HAND-FIST RING MIDDLE RAISED KNUCKLES;So;0;L;;;;;N;;;;;
1D8B7;SIGNWRITING HAND-FIST RING INDEX;So;0;L;;;;;N;;;;;
1D8B8;SIGNWRITING HAND-FIST RING THUMB;So;0;L;;;;;N;;;;;
1D8B9;SIGNWRITING HAND-HOOK RING THUMB;So;0;L;;;;;N;;;;;
1D8BA;SIGNWRITING HAND-FIST INDEX RING LITTLE;So;0;L;;;;;N;;;;;
1D8BB;SIGNWRITING HAND-CIRCLE INDEX RING LITTLE;So;0;L;;;;;N;;;;;
1D8BC;SIGNWRITING HAND-CURLICUE INDEX RING LITTLE ON;So;0;L;;;;;N;;;;;
1D8BD;SIGNWRITING HAND-HOOK INDEX RING LITTLE OUT;So;0;L;;;;;N;;;;;
1D8BE;SIGNWRITING HAND-HOOK INDEX RING LITTLE IN;So;0;L;;;;;N;;;;;
1D8BF;SIGNWRITING HAND-HOOK INDEX RING LITTLE UNDER;So;0;L;;;;;N;;;;;
1D8C0;SIGNWRITING HAND-CUP INDEX RING LITTLE;So;0;L;;;;;N;;;;;
1D8C1;SIGNWRITING HAND-HINGE INDEX RING LITTLE;So;0;L;;;;;N;;;;;
1D8C2;SIGNWRITING HAND-ANGLE INDEX RING LITTLE OUT;So;0;L;;;;;N;;;;;
1D8C3;SIGNWRITING HAND-ANGLE INDEX RING LITTLE;So;0;L;;;;;N;;;;;
1D8C4;SIGNWRITING HAND-FIST MIDDLE DOWN;So;0;L;;;;;N;;;;;
1D8C5;SIGNWRITING HAND-HINGE MIDDLE;So;0;L;;;;;N;;;;;
1D8C6;SIGNWRITING HAND-FIST MIDDLE UP;So;0;L;;;;;N;;;;;
1D8C7;SIGNWRITING HAND-CIRCLE MIDDLE UP;So;0;L;;;;;N;;;;;
1D8C8;SIGNWRITING HAND-FIST MIDDLE RAISED KNUCKLE;So;0;L;;;;;N;;;;;
1D8C9;SIGNWRITING HAND-FIST MIDDLE UP THUMB SIDE;So;0;L;;;;;N;;;;;
1D8CA;SIGNWRITING HAND-HOOK MIDDLE THUMB;So;0;L;;;;;N;;;;;
1D8CB;SIGNWRITING HAND-FIST MIDDLE THUMB LITTLE;So;0;L;;;;;N;;;;;
1D8CC;SIGNWRITING HAND-FIST MIDDLE LITTLE;So;0;L;;;;;N;;;;;
1D8CD;SIGNWRITING HAND-FIST MIDDLE RING LITTLE;So;0;L;;;;;N;;;;;
1D8CE;SIGNWRITING HAND-CIRCLE MIDDLE RING LITTLE;So;0;L;;;;;N;;;;;
1D8CF;SIGNWRITING HAND-CURLICUE MIDDLE RING LITTLE ON;So;0;L;;;;;N;;;;;
1D8D0;SIGNWRITING HAND-CUP MIDDLE RING LITTLE;So;0;L;;;;;N;;;;;
1D8D1;SIGNWRITING HAND-HINGE MIDDLE RING LITTLE;So;0;L;;;;;N;;;;;
1D8D2;SIGNWRITING HAND-ANGLE MIDDLE RING LITTLE OUT;So;0;L;;;;;N;;;;;
1D8D3;SIGNWRITING HAND-ANGLE MIDDLE RING LITTLE IN;So;0;L;;;;;N;;;;;
1D8D4;SIGNWRITING HAND-ANGLE MIDDLE RING LITTLE;So;0;L;;;;;N;;;;;
1D8D5;SIGNWRITING HAND-CIRCLE MIDDLE RING LITTLE BENT;So;0;L;;;;;N;;;;;
1D8D6;SIGNWRITING HAND-CLAW MIDDLE RING LITTLE CONJOINED;So;0;L;;;;;N;;;;;
1D8D7;SIGNWRITING HAND-CLAW MIDDLE RING LITTLE CONJOINED SIDE;So;0;L;;;;;N;;;;;
1D8D8;SIGNWRITING HAND-HOOK MIDDLE RING LITTLE CONJOINED OUT;So;0;L;;;;;N;;;;;
1D8D9;SIGNWRITING HAND-HOOK MIDDLE RING LITTLE CONJOINED IN;So;0;L;;;;;N;;;;;
1D8DA;SIGNWRITING HAND-HOOK MIDDLE RING LITTLE CONJOINED;So;0;L;;;;;N;;;;;
1D8DB;SIGNWRITING HAND-HINGE INDEX HINGED;So;0;L;;;;;N;;;;;
1D8DC;SIGNWRITING HAND-FIST INDEX THUMB SIDE;So;0;L;;;;;N;;;;;
1D8DD;SIGNWRITING HAND-HINGE INDEX THUMB SIDE;So;0;L;;;;;N;;;;;
1D8DE;SIGNWRITING HAND-FIST INDEX THUMB SIDE THUMB DIAGONAL;So;0;L;;;;;N;;;;;
1D8DF;SIGNWRITING HAND-FIST INDEX THUMB SIDE THUMB CONJOINED;So;0;L;;;;;N;;;;;
1D8E0;SIGNWRITING HAND-FIST INDEX THUMB SIDE THUMB BENT;So;0;L;;;;;N;;;;;
1D8E1;SIGNWRITING HAND-FIST INDEX THUMB SIDE INDEX BENT;So;0;L;;;;;N;;;;;
1D8E2;SIGNWRITING HAND-FIST INDEX THUMB SIDE BOTH BENT;So;0;L;;;;;N;;;;;
1D8E3;SIGNWRITING HAND-FIST INDEX THUMB SIDE INDEX HINGE;So;0;L;;;;;N;;;;;
1D8E4;SIGNWRITING HAND-FIST INDEX THUMB FORWARD INDEX STRAIGHT;So;0;L;;;;;N;;;;;
1D8E5;SIGNWRITING HAND-FIST INDEX THUMB FORWARD INDEX BENT;So;0;L;;;;;N;;;;;
1D8E6;SIGNWRITING HAND-FIST INDEX THUMB HOOK;So;0;L;;;;;N;;;;;
1D8E7;SIGNWRITING HAND-FIST INDEX THUMB CURLICUE;So;0;L;;;;;N;;;;;
1D8E8;SIGNWRITING HAND-FIST INDEX THUMB CURVE THUMB INSIDE;So;0;L;;;;;N;;;;;
1D8E9;SIGNWRITING HAND-CLAW INDEX THUMB CURVE THUMB INSIDE;So;0;L;;;;;N;;;;;
1D8EA;SIGNWRITING HAND-FIST INDEX THUMB CURVE THUMB UNDER;So;0;L;;;;;N;;;;;
1D8EB;SIGNWRITING HAND-FIST INDEX THUMB CIRCLE;So;0;L;;;;;N;;;;;
1D8EC;SIGNWRITING HAND-CUP INDEX THUMB;So;0;L;;;;;N;;;;;
1D8ED;SIGNWRITING HAND-CUP INDEX THUMB OPEN;So;0;L;;;;;N;;;;;
1D8EE;SIGNWRITING HAND-HINGE INDEX THUMB OPEN;So;0;L;;;;;N;;;;;
1D8EF;SIGNWRITING HAND-HINGE INDEX THUMB LARGE;So;0;L;;;;;N;;;;;
1D8F0;SIGNWRITING HAND-HINGE INDEX THUMB;So;0;L;;;;;N;;;;;
1D8F1;SIGNWRITING HAND-HINGE INDEX THUMB SMALL;So;0;L;;;;;N;;;;;
1D8F2;SIGNWRITING HAND-ANGLE INDEX THUMB OUT;So;0;L;;;;;N;;;;;
1D8F3;SIGNWRITING HAND-ANGLE INDEX THUMB IN;So;0;L;;;;;N;;;;;
1D8F4;SIGNWRITING HAND-ANGLE INDEX THUMB;So;0;L;;;;;N;;;;;
1D8F5;SIGNWRITING HAND-FIST THUMB;So;0;L;;;;;N;;;;;
1D8F6;SIGNWRITING HAND-FIST THUMB HEEL;So;0;L;;;;;N;;;;;
1D8F7;SIGNWRITING HAND-FIST THUMB SIDE DIAGONAL;So;0;L;;;;;N;;;;;
1D8F8;SIGNWRITING HAND-FIST THUMB SIDE CONJOINED;So;0;L;;;;;N;;;;;
1D8F9;SIGNWRITING HAND-FIST THUMB SIDE BENT;So;0;L;;;;;N;;;;;
1D8FA;SIGNWRITING HAND-FIST THUMB FORWARD;So;0;L;;;;;N;;;;;
1D8FB;SIGNWRITING HAND-FIST THUMB BETWEEN INDEX MIDDLE;So;0;L;;;;;N;;;;;
1D8FC;SIGNWRITING HAND-FIST THUMB BETWEEN MIDDLE RING;So;0;L;;;;;N;;;;;
1D8FD;SIGNWRITING HAND-FIST THUMB BETWEEN RING LITTLE;So;0;L;;;;;N;;;;;
1D8FE;SIGNWRITING HAND-FIST THUMB UNDER TWO FINGERS;So;0;L;;;;;N;;;;;
1D8FF;SIGNWRITING HAND-FIST THUMB OVER TWO FINGERS;So;0;L;;;;;N;;;;;
1D900;SIGNWRITING HAND-FIST THUMB UNDER THREE FINGERS;So;0;L;;;;;N;;;;;
1D901;SIGNWRITING HAND-FIST THUMB UNDER FOUR FINGERS;So;0;L;;;;;N;;;;;
1D902;SIGNWRITING HAND-FIST THUMB OVER FOUR RAISED KNUCKLES;So;0;L;;;;;N;;;;;
1D903;SIGNWRITING HAND-FIST;So;0;L;;;;;N;;;;;
1D904;SIGNWRITING HAND-FIST HEEL;So;0;L;;;;;N;;;;;
1D905;SIGNWRITING TOUCH SINGLE;So;0;L;;;;;N;;;;;
1D906;SIGNWRITING TOUCH MULTIPLE;So;0;L;;;;;N;;;;;
1D907;SIGNWRITING TOUCH BETWEEN;So;0;L;;;;;N;;;;;
1D908;SIGNWRITING GRASP SINGLE;So;0;L;;;;;N;;;;;
1D909;SIGNWRITING GRASP MULTIPLE;So;0;L;;;;;N;;;;;
1D90A;SIGNWRITING GRASP BETWEEN;So;0;L;;;;;N;;;;;
1D90B;SIGNWRITING STRIKE SINGLE;So;0;L;;;;;N;;;;;
1D90C;SIGNWRITING STRIKE MULTIPLE;So;0;L;;;;;N;;;;;
1D90D;SIGNWRITING STRIKE BETWEEN;So;0;L;;;;;N;;;;;
1D90E;SIGNWRITING BRUSH SINGLE;So;0;L;;;;;N;;;;;
1D90F;SIGNWRITING BRUSH MULTIPLE;So;0;L;;;;;N;;;;;
1D910;SIGNWRITING BRUSH BETWEEN;So;0;L;;;;;N;;;;;
1D911;SIGNWRITING RUB SINGLE;So;0;L;;;;;N;;;;;
1D912;SIGNWRITING RUB MULTIPLE;So;0;L;;;;;N;;;;;
1D913;SIGNWRITING RUB BETWEEN;So;0;L;;;;;N;;;;;
1D914;SIGNWRITING SURFACE SYMBOLS;So;0;L;;;;;N;;;;;
1D915;SIGNWRITING SURFACE BETWEEN;So;0;L;;;;;N;;;;;
1D916;SIGNWRITING SQUEEZE LARGE SINGLE;So;0;L;;;;;N;;;;;
1D917;SIGNWRITING SQUEEZE SMALL SINGLE;So;0;L;;;;;N;;;;;
1D918;SIGNWRITING SQUEEZE LARGE MULTIPLE;So;0;L;;;;;N;;;;;
1D919;SIGNWRITING SQUEEZE SMALL MULTIPLE;So;0;L;;;;;N;;;;;
1D91A;SIGNWRITING SQUEEZE SEQUENTIAL;So;0;L;;;;;N;;;;;
1D91B;SIGNWRITING FLICK LARGE SINGLE;So;0;L;;;;;N;;;;;
1D91C;SIGNWRITING FLICK SMALL SINGLE;So;0;L;;;;;N;;;;;
1D91D;SIGNWRITING FLICK LARGE MULTIPLE;So;0;L;;;;;N;;;;;
1D91E;SIGNWRITING FLICK SMALL MULTIPLE;So;0;L;;;;;N;;;;;
1D91F;SIGNWRITING FLICK SEQUENTIAL;So;0;L;;;;;N;;;;;
1D920;SIGNWRITING SQUEEZE FLICK ALTERNATING;So;0;L;;;;;N;;;;;
1D921;SIGNWRITING MOVEMENT-HINGE UP DOWN LARGE;So;0;L;;;;;N;;;;;
1D922;SIGNWRITING MOVEMENT-HINGE UP DOWN SMALL;So;0;L;;;;;N;;;;;
1D923;SIGNWRITING MOVEMENT-HINGE UP SEQUENTIAL;So;0;L;;;;;N;;;;;
1D924;SIGNWRITING MOVEMENT-HINGE DOWN SEQUENTIAL;So;0;L;;;;;N;;;;;
1D925;SIGNWRITING MOVEMENT-HINGE UP DOWN ALTERNATING LARGE;So;0;L;;;;;N;;;;;
1D926;SIGNWRITING MOVEMENT-HINGE UP DOWN ALTERNATING SMALL;So;0;L;;;;;N;;;;;
1D927;SIGNWRITING MOVEMENT-HINGE SIDE TO SIDE SCISSORS;So;0;L;;;;;N;;;;;
1D928;SIGNWRITING MOVEMENT-WALLPLANE FINGER CONTACT;So;0;L;;;;;N;;;;;
1D929;SIGNWRITING MOVEMENT-FLOORPLANE FINGER CONTACT;So;0;L;;;;;N;;;;;
1D92A;SIGNWRITING MOVEMENT-WALLPLANE SINGLE STRAIGHT SMALL;So;0;L;;;;;N;;;;;
1D92B;SIGNWRITING MOVEMENT-WALLPLANE SINGLE STRAIGHT MEDIUM;So;0;L;;;;;N;;;;;
1D92C;SIGNWRITING MOVEMENT-WALLPLANE SINGLE STRAIGHT LARGE;So;0;L;;;;;N;;;;;
1D92D;SIGNWRITING MOVEMENT-WALLPLANE SINGLE STRAIGHT LARGEST;So;0;L;;;;;N;;;;;
1D92E;SIGNWRITING MOVEMENT-WALLPLANE SINGLE WRIST FLEX;So;0;L;;;;;N;;;;;
1D92F;SIGNWRITING MOVEMENT-WALLPLANE DOUBLE STRAIGHT;So;0;L;;;;;N;;;;;
1D930;SIGNWRITING MOVEMENT-WALLPLANE DOUBLE WRIST FLEX;So;0;L;;;;;N;;;;;
1D931;SIGNWRITING MOVEMENT-WALLPLANE DOUBLE ALTERNATING;So;0;L;;;;;N;;;;;
1D932;SIGNWRITING MOVEMENT-WALLPLANE DOUBLE ALTERNATING WRIST FLEX;So;0;L;;;;;N;;;;;
1D933;SIGNWRITING MOVEMENT-WALLPLANE CROSS;So;0;L;;;;;N;;;;;
1D934;SIGNWRITING MOVEMENT-WALLPLANE TRIPLE STRAIGHT MOVEMENT;So;0;L;;;;;N;;;;;
1D935;SIGNWRITING MOVEMENT-WALLPLANE TRIPLE WRIST FLEX;So;0;L;;;;;N;;;;;
1D936;SIGNWRITING MOVEMENT-WALLPLANE TRIPLE ALTERNATING;So;0;L;;;;;N;;;;;
1D937;SIGNWRITING MOVEMENT-WALLPLANE TRIPLE ALTERNATING WRIST FLEX;So;0;L;;;;;N;;;;;
1D938;SIGNWRITING MOVEMENT-WALLPLANE BEND SMALL;So;0;L;;;;;N;;;;;
1D939;SIGNWRITING MOVEMENT-WALLPLANE BEND MEDIUM;So;0;L;;;;;N;;;;;
1D93A;SIGNWRITING MOVEMENT-WALLPLANE BEND LARGE;So;0;L;;;;;N;;;;;
1D93B;SIGNWRITING MOVEMENT-WALLPLANE CORNER SMALL;So;0;L;;;;;N;;;;;
1D93C;SIGNWRITING MOVEMENT-WALLPLANE CORNER MEDIUM;So;0;L;;;;;N;;;;;
1D93D;SIGNWRITING MOVEMENT-WALLPLANE CORNER LARGE;So;0;L;;;;;N;;;;;
1D93E;SIGNWRITING MOVEMENT-WALLPLANE CORNER ROTATION;So;0;L;;;;;N;;;;;
1D93F;SIGNWRITING MOVEMENT-WALLPLANE CHECK SMALL;So;0;L;;;;;N;;;;;
1D940;SIGNWRITING MOVEMENT-WALLPLANE CHECK MEDIUM;So;0;L;;;;;N;;;;;
1D941;SIGNWRITING MOVEMENT-WALLPLANE CHECK LARGE;So;0;L;;;;;N;;;;;
1D942;SIGNWRITING MOVEMENT-WALLPLANE BOX SMALL;So;0;L;;;;;N;;;;;
1D943;SIGNWRITING MOVEMENT-WALLPLANE BOX MEDIUM;So;0;L;;;;;N;;;;;
1D944;SIGNWRITING MOVEMENT-WALLPLANE BOX LARGE;So;0;L;;;;;N;;;;;
1D945;SIGNWRITING MOVEMENT-WALLPLANE ZIGZAG SMALL;So;0;L;;;;;N;;;;;
1D946;SIGNWRITING MOVEMENT-WALLPLANE ZIGZAG MEDIUM;So;0;L;;;;;N;;;;;
1D947;SIGNWRITING MOVEMENT-WALLPLANE ZIGZAG LARGE;So;0;L;;;;;N;;;;;
1D948;SIGNWRITING MOVEMENT-WALLPLANE PEAKS SMALL;So;0;L;;;;;N;;;;;
1D949;SIGNWRITING MOVEMENT-WALLPLANE PEAKS MEDIUM;So;0;L;;;;;N;;;;;
1D94A;SIGNWRITING MOVEMENT-WALLPLANE PEAKS LARGE;So;0;L;;;;;N;;;;;
1D94B;SIGNWRITING TRAVEL-WALLPLANE ROTATION-WALLPLANE SINGLE;So;0;L;;;;;N;;;;;
1D94C;SIGNWRITING TRAVEL-WALLPLANE ROTATION-WALLPLANE DOUBLE;So;0;L;;;;;N;;;;;
1D94D;SIGNWRITING TRAVEL-WALLPLANE ROTATION-WALLPLANE ALTERNATING;So;0;L;;;;;N;;;;;
1D94E;SIGNWRITING TRAVEL-WALLPLANE ROTATION-FLOORPLANE SINGLE;So;0;L;;;;;N;;;;;
1D94F;SIGNWRITING TRAVEL-WALLPLANE ROTATION-FLOORPLANE DOUBLE;So;0;L;;;;;N;;;;;
1D950;SIGNWRITING TRAVEL-WALLPLANE ROTATION-FLOORPLANE ALTERNATING;So;0;L;;;;;N;;;;;
1D951;SIGNWRITING TRAVEL-WALLPLANE SHAKING;So;0;L;;;;;N;;;;;
1D952;SIGNWRITING TRAVEL-WALLPLANE ARM SPIRAL SINGLE;So;0;L;;;;;N;;;;;
1D953;SIGNWRITING TRAVEL-WALLPLANE ARM SPIRAL DOUBLE;So;0;L;;;;;N;;;;;
1D954;SIGNWRITING TRAVEL-WALLPLANE ARM SPIRAL TRIPLE;So;0;L;;;;;N;;;;;
1D955;SIGNWRITING MOVEMENT-DIAGONAL AWAY SMALL;So;0;L;;;;;N;;;;;
1D956;SIGNWRITING MOVEMENT-DIAGONAL AWAY MEDIUM;So;0;L;;;;;N;;;;;
1D957;SIGNWRITING MOVEMENT-DIAGONAL AWAY LARGE;So;0;L;;;;;N;;;;;
1D958;SIGNWRITING MOVEMENT-DIAGONAL AWAY LARGEST;So;0;L;;;;;N;;;;;
1D959;SIGNWRITING MOVEMENT-DIAGONAL TOWARDS SMALL;So;0;L;;;;;N;;;;;
1D95A;SIGNWRITING MOVEMENT-DIAGONAL TOWARDS MEDIUM;So;0;L;;;;;N;;;;;
1D95B;SIGNWRITING MOVEMENT-DIAGONAL TOWARDS LARGE;So;0;L;;;;;N;;;;;
1D95C;SIGNWRITING MOVEMENT-DIAGONAL TOWARDS LARGEST;So;0;L;;;;;N;;;;;
1D95D;SIGNWRITING MOVEMENT-DIAGONAL BETWEEN AWAY SMALL;So;0;L;;;;;N;;;;;
1D95E;SIGNWRITING MOVEMENT-DIAGONAL BETWEEN AWAY MEDIUM;So;0;L;;;;;N;;;;;
1D95F;SIGNWRITING MOVEMENT-DIAGONAL BETWEEN AWAY LARGE;So;0;L;;;;;N;;;;;
1D960;SIGNWRITING MOVEMENT-DIAGONAL BETWEEN AWAY LARGEST;So;0;L;;;;;N;;;;;
1D961;SIGNWRITING MOVEMENT-DIAGONAL BETWEEN TOWARDS SMALL;So;0;L;;;;;N;;;;;
1D962;SIGNWRITING MOVEMENT-DIAGONAL BETWEEN TOWARDS MEDIUM;So;0;L;;;;;N;;;;;
1D963;SIGNWRITING MOVEMENT-DIAGONAL BETWEEN TOWARDS LARGE;So;0;L;;;;;N;;;;;
1D964;SIGNWRITING MOVEMENT-DIAGONAL BETWEEN TOWARDS LARGEST;So;0;L;;;;;N;;;;;
1D965;SIGNWRITING MOVEMENT-FLOORPLANE SINGLE STRAIGHT SMALL;So;0;L;;;;;N;;;;;
1D966;SIGNWRITING MOVEMENT-FLOORPLANE SINGLE STRAIGHT MEDIUM;So;0;L;;;;;N;;;;;
1D967;SIGNWRITING MOVEMENT-FLOORPLANE SINGLE STRAIGHT LARGE;So;0;L;;;;;N;;;;;
1D968;SIGNWRITING MOVEMENT-FLOORPLANE SINGLE STRAIGHT LARGEST;So;0;L;;;;;N;;;;;
1D969;SIGNWRITING MOVEMENT-FLOORPLANE SINGLE WRIST FLEX;So;0;L;;;;;N;;;;;
1D96A;SIGNWRITING MOVEMENT-FLOORPLANE DOUBLE STRAIGHT;So;0;L;;;;;N;;;;;
1D96B;SIGNWRITING MOVEMENT-FLOORPLANE DOUBLE WRIST FLEX;So;0;L;;;;;N;;;;;
1D96C;SIGNWRITING MOVEMENT-FLOORPLANE DOUBLE ALTERNATING;So;0;L;;;;;N;;;;;
1D96D;SIGNWRITING MOVEMENT-FLOORPLANE DOUBLE ALTERNATING WRIST FLEX;So;0;L;;;;;N;;;;;
1D96E;SIGNWRITING MOVEMENT-FLOORPLANE CROSS;So;0;L;;;;;N;;;;;
1D96F;SIGNWRITING MOVEMENT-FLOORPLANE TRIPLE STRAIGHT MOVEMENT;So;0;L;;;;;N;;;;;
1D970;SIGNWRITING MOVEMENT-FLOORPLANE TRIPLE WRIST FLEX;So;0;L;;;;;N;;;;;
1D971;SIGNWRITING MOVEMENT-FLOORPLANE TRIPLE ALTERNATING MOVEMENT;So;0;L;;;;;N;;;;;
1D972;SIGNWRITING MOVEMENT-FLOORPLANE TRIPLE ALTERNATING WRIST FLEX;So;0;L;;;;;N;;;;;
1D973;SIGNWRITING MOVEMENT-FLOORPLANE BEND;So;0;L;;;;;N;;;;;
1D974;SIGNWRITING MOVEMENT-FLOORPLANE CORNER SMALL;So;0;L;;;;;N;;;;;
1D975;SIGNWRITING MOVEMENT-FLOORPLANE CORNER MEDIUM;So;0;L;;;;;N;;;;;
1D976;SIGNWRITING MOVEMENT-FLOORPLANE CORNER LARGE;So;0;L;;;;;N;;;;;
1D977;SIGNWRITING MOVEMENT-FLOORPLANE CHECK;So;0;L;;;;;N;;;;;
1D978;SIGNWRITING MOVEMENT-FLOORPLANE BOX SMALL;So;0;L;;;;;N;;;;;
1D979;SIGNWRITING MOVEMENT-FLOORPLANE BOX MEDIUM;So;0;L;;;;;N;;;;;
1D97A;SIGNWRITING MOVEMENT-FLOORPLANE BOX LARGE;So;0;L;;;;;N;;;;;
1D97B;SIGNWRITING MOVEMENT-FLOORPLANE ZIGZAG SMALL;So;0;L;;;;;N;;;;;
1D97C;SIGNWRITING MOVEMENT-FLOORPLANE ZIGZAG MEDIUM;So;0;L;;;;;N;;;;;
1D97D;SIGNWRITING MOVEMENT-FLOORPLANE ZIGZAG LARGE;So;0;L;;;;;N;;;;;
1D97E;SIGNWRITING MOVEMENT-FLOORPLANE PEAKS SMALL;So;0;L;;;;;N;;;;;
1D97F;SIGNWRITING MOVEMENT-FLOORPLANE PEAKS MEDIUM;So;0;L;;;;;N;;;;;
1D980;SIGNWRITING MOVEMENT-FLOORPLANE PEAKS LARGE;So;0;L;;;;;N;;;;;
1D981;SIGNWRITING TRAVEL-FLOORPLANE ROTATION-FLOORPLANE SINGLE;So;0;L;;;;;N;;;;;
1D982;SIGNWRITING TRAVEL-FLOORPLANE ROTATION-FLOORPLANE DOUBLE;So;0;L;;;;;N;;;;;
1D983;SIGNWRITING TRAVEL-FLOORPLANE ROTATION-FLOORPLANE ALTERNATING;So;0;L;;;;;N;;;;;
1D984;SIGNWRITING TRAVEL-FLOORPLANE ROTATION-WALLPLANE SINGLE;So;0;L;;;;;N;;;;;
1D985;SIGNWRITING TRAVEL-FLOORPLANE ROTATION-WALLPLANE DOUBLE;So;0;L;;;;;N;;;;;
1D986;SIGNWRITING TRAVEL-FLOORPLANE ROTATION-WALLPLANE ALTERNATING;So;0;L;;;;;N;;;;;
1D987;SIGNWRITING TRAVEL-FLOORPLANE SHAKING;So;0;L;;;;;N;;;;;
1D988;SIGNWRITING MOVEMENT-WALLPLANE CURVE QUARTER SMALL;So;0;L;;;;;N;;;;;
1D989;SIGNWRITING MOVEMENT-WALLPLANE CURVE QUARTER MEDIUM;So;0;L;;;;;N;;;;;
1D98A;SIGNWRITING MOVEMENT-WALLPLANE CURVE QUARTER LARGE;So;0;L;;;;;N;;;;;
1D98B;SIGNWRITING MOVEMENT-WALLPLANE CURVE QUARTER LARGEST;So;0;L;;;;;N;;;;;
1D98C;SIGNWRITING MOVEMENT-WALLPLANE CURVE HALF-CIRCLE SMALL;So;0;L;;;;;N;;;;;
1D98D;SIGNWRITING MOVEMENT-WALLPLANE CURVE HALF-CIRCLE MEDIUM;So;0;L;;;;;N;;;;;
1D98E;SIGNWRITING MOVEMENT-WALLPLANE CURVE HALF-CIRCLE LARGE;So;0;L;;;;;N;;;;;
1D98F;SIGNWRITING MOVEMENT-WALLPLANE CURVE HALF-CIRCLE LARGEST;So;0;L;;;;;N;;;;;
1D990;SIGNWRITING MOVEMENT-WALLPLANE CURVE THREE-QUARTER CIRCLE SMALL;So;0;L;;;;;N;;;;;
1D991;SIGNWRITING MOVEMENT-WALLPLANE CURVE THREE-QUARTER CIRCLE MEDIUM;So;0;L;;;;;N;;;;;
1D992;SIGNWRITING MOVEMENT-WALLPLANE HUMP SMALL;So;0;L;;;;;N;;;;;
1D993;SIGNWRITING MOVEMENT-WALLPLANE HUMP MEDIUM;So;0;L;;;;;N;;;;;
1D994;SIGNWRITING MOVEMENT-WALLPLANE HUMP LARGE;So;0;L;;;;;N;;;;;
1D995;SIGNWRITING MOVEMENT-WALLPLANE LOOP SMALL;So;0;L;;;;;N;;;;;
1D996;SIGNWRITING MOVEMENT-WALLPLANE LOOP MEDIUM;So;0;L;;;;;N;;;;;
1D997;SIGNWRITING MOVEMENT-WALLPLANE LOOP LARGE;So;0;L;;;;;N;;;;;
1D998;SIGNWRITING MOVEMENT-WALLPLANE LOOP SMALL DOUBLE;So;0;L;;;;;N;;;;;
1D999;SIGNWRITING MOVEMENT-WALLPLANE WAVE CURVE DOUBLE SMALL;So;0;L;;;;;N;;;;;
1D99A;SIGNWRITING MOVEMENT-WALLPLANE WAVE CURVE DOUBLE MEDIUM;So;0;L;;;;;N;;;;;
1D99B;SIGNWRITING MOVEMENT-WALLPLANE WAVE CURVE DOUBLE LARGE;So;0;L;;;;;N;;;;;
1D99C;SIGNWRITING MOVEMENT-WALLPLANE WAVE CURVE TRIPLE SMALL;So;0;L;;;;;N;;;;;
1D99D;SIGNWRITING MOVEMENT-WALLPLANE WAVE CURVE TRIPLE MEDIUM;So;0;L;;;;;N;;;;;
1D99E;SIGNWRITING MOVEMENT-WALLPLANE WAVE CURVE TRIPLE LARGE;So;0;L;;;;;N;;;;;
1D99F;SIGNWRITING MOVEMENT-WALLPLANE CURVE THEN STRAIGHT;So;0;L;;;;;N;;;;;
1D9A0;SIGNWRITING MOVEMENT-WALLPLANE CURVED CROSS SMALL;So;0;L;;;;;N;;;;;
1D9A1;SIGNWRITING MOVEMENT-WALLPLANE CURVED CROSS MEDIUM;So;0;L;;;;;N;;;;;
1D9A2;SIGNWRITING ROTATION-WALLPLANE SINGLE;So;0;L;;;;;N;;;;;
1D9A3;SIGNWRITING ROTATION-WALLPLANE DOUBLE;So;0;L;;;;;N;;;;;
1D9A4;SIGNWRITING ROTATION-WALLPLANE ALTERNATE;So;0;L;;;;;N;;;;;
1D9A5;SIGNWRITING MOVEMENT-WALLPLANE SHAKING;So;0;L;;;;;N;;;;;
1D9A6;SIGNWRITING MOVEMENT-WALLPLANE CURVE HITTING FRONT WALL;So;0;L;;;;;N;;;;;
1D9A7;SIGNWRITING MOVEMENT-WALLPLANE HUMP HITTING FRONT WALL;So;0;L;;;;;N;;;;;
1D9A8;SIGNWRITING MOVEMENT-WALLPLANE LOOP HITTING FRONT WALL;So;0;L;;;;;N;;;;;
1D9A9;SIGNWRITING MOVEMENT-WALLPLANE WAVE HITTING FRONT WALL;So;0;L;;;;;N;;;;;
1D9AA;SIGNWRITING ROTATION-WALLPLANE SINGLE HITTING FRONT WALL;So;0;L;;;;;N;;;;;
1D9AB;SIGNWRITING ROTATION-WALLPLANE DOUBLE HITTING FRONT WALL;So;0;L;;;;;N;;;;;
1D9AC;SIGNWRITING ROTATION-WALLPLANE ALTERNATING HITTING FRONT WALL;So;0;L;;;;;N;;;;;
1D9AD;SIGNWRITING MOVEMENT-WALLPLANE CURVE HITTING CHEST;So;0;L;;;;;N;;;;;
1D9AE;SIGNWRITING MOVEMENT-WALLPLANE HUMP HITTING CHEST;So;0;L;;;;;N;;;;;
1D9AF;SIGNWRITING MOVEMENT-WALLPLANE LOOP HITTING CHEST;So;0;L;;;;;N;;;;;
1D9B0;SIGNWRITING MOVEMENT-WALLPLANE WAVE HITTING CHEST;So;0;L;;;;;N;;;;;
1D9B1;SIGNWRITING ROTATION-WALLPLANE SINGLE HITTING CHEST;So;0;L;;;;;N;;;;;
1D9B2;SIGNWRITING ROTATION-WALLPLANE DOUBLE HITTING CHEST;So;0;L;;;;;N;;;;;
1D9B3;SIGNWRITING ROTATION-WALLPLANE ALTERNATING HITTING CHEST;So;0;L;;;;;N;;;;;
1D9B4;SIGNWRITING MOVEMENT-WALLPLANE WAVE DIAGONAL PATH SMALL;So;0;L;;;;;N;;;;;
1D9B5;SIGNWRITING MOVEMENT-WALLPLANE WAVE DIAGONAL PATH MEDIUM;So;0;L;;;;;N;;;;;
1D9B6;SIGNWRITING MOVEMENT-WALLPLANE WAVE DIAGONAL PATH LARGE;So;0;L;;;;;N;;;;;
1D9B7;SIGNWRITING MOVEMENT-FLOORPLANE CURVE HITTING CEILING SMALL;So;0;L;;;;;N;;;;;
1D9B8;SIGNWRITING MOVEMENT-FLOORPLANE CURVE HITTING CEILING LARGE;So;0;L;;;;;N;;;;;
1D9B9;SIGNWRITING MOVEMENT-FLOORPLANE HUMP HITTING CEILING SMALL DOUBLE;So;0;L;;;;;N;;;;;
1D9BA;SIGNWRITING MOVEMENT-FLOORPLANE HUMP HITTING CEILING LARGE DOUBLE;So;0;L;;;;;N;;;;;
1D9BB;SIGNWRITING MOVEMENT-FLOORPLANE HUMP HITTING CEILING SMALL TRIPLE;So;0;L;;;;;N;;;;;
1D9BC;SIGNWRITING MOVEMENT-FLOORPLANE HUMP HITTING CEILING LARGE TRIPLE;So;0;L;;;;;N;;;;;
1D9BD;SIGNWRITING MOVEMENT-FLOORPLANE LOOP HITTING CEILING SMALL SINGLE;So;0;L;;;;;N;;;;;
1D9BE;SIGNWRITING MOVEMENT-FLOORPLANE LOOP HITTING CEILING LARGE SINGLE;So;0;L;;;;;N;;;;;
1D9BF;SIGNWRITING MOVEMENT-FLOORPLANE LOOP HITTING CEILING SMALL DOUBLE;So;0;L;;;;;N;;;;;
1D9C0;SIGNWRITING MOVEMENT-FLOORPLANE LOOP HITTING CEILING LARGE DOUBLE;So;0;L;;;;;N;;;;;
1D9C1;SIGNWRITING MOVEMENT-FLOORPLANE WAVE HITTING CEILING SMALL;So;0;L;;;;;N;;;;;
1D9C2;SIGNWRITING MOVEMENT-FLOORPLANE WAVE HITTING CEILING LARGE;So;0;L;;;;;N;;;;;
1D9C3;SIGNWRITING ROTATION-FLOORPLANE SINGLE HITTING CEILING;So;0;L;;;;;N;;;;;
1D9C4;SIGNWRITING ROTATION-FLOORPLANE DOUBLE HITTING CEILING;So;0;L;;;;;N;;;;;
1D9C5;SIGNWRITING ROTATION-FLOORPLANE ALTERNATING HITTING CEILING;So;0;L;;;;;N;;;;;
1D9C6;SIGNWRITING MOVEMENT-FLOORPLANE CURVE HITTING FLOOR SMALL;So;0;L;;;;;N;;;;;
1D9C7;SIGNWRITING MOVEMENT-FLOORPLANE CURVE HITTING FLOOR LARGE;So;0;L;;;;;N;;;;;
1D9C8;SIGNWRITING MOVEMENT-FLOORPLANE HUMP HITTING FLOOR SMALL DOUBLE;So;0;L;;;;;N;;;;;
1D9C9;SIGNWRITING MOVEMENT-FLOORPLANE HUMP HITTING FLOOR LARGE DOUBLE;So;0;L;;;;;N;;;;;
1D9CA;SIGNWRITING MOVEMENT-FLOORPLANE HUMP HITTING FLOOR TRIPLE SMALL TRIPLE;So;0;L;;;;;N;;;;;
1D9CB;SIGNWRITING MOVEMENT-FLOORPLANE HUMP HITTING FLOOR TRIPLE LARGE TRIPLE;So;0;L;;;;;N;;;;;
1D9CC;SIGNWRITING MOVEMENT-FLOORPLANE LOOP HITTING FLOOR SMALL SINGLE;So;0;L;;;;;N;;;;;
1D9CD;SIGNWRITING MOVEMENT-FLOORPLANE LOOP HITTING FLOOR LARGE SINGLE;So;0;L;;;;;N;;;;;
1D9CE;SIGNWRITING MOVEMENT-FLOORPLANE LOOP HITTING FLOOR SMALL DOUBLE;So;0;L;;;;;N;;;;;
1D9CF;SIGNWRITING MOVEMENT-FLOORPLANE LOOP HITTING FLOOR LARGE DOUBLE;So;0;L;;;;;N;;;;;
1D9D0;SIGNWRITING MOVEMENT-FLOORPLANE WAVE HITTING FLOOR SMALL;So;0;L;;;;;N;;;;;
1D9D1;SIGNWRITING MOVEMENT-FLOORPLANE WAVE HITTING FLOOR LARGE;So;0;L;;;;;N;;;;;
1D9D2;SIGNWRITING ROTATION-FLOORPLANE SINGLE HITTING FLOOR;So;0;L;;;;;N;;;;;
1D9D3;SIGNWRITING ROTATION-FLOORPLANE DOUBLE HITTING FLOOR;So;0;L;;;;;N;;;;;
1D9D4;SIGNWRITING ROTATION-FLOORPLANE ALTERNATING HITTING FLOOR;So;0;L;;;;;N;;;;;
1D9D5;SIGNWRITING MOVEMENT-FLOORPLANE CURVE SMALL;So;0;L;;;;;N;;;;;
1D9D6;SIGNWRITING MOVEMENT-FLOORPLANE CURVE MEDIUM;So;0;L;;;;;N;;;;;
1D9D7;SIGNWRITING MOVEMENT-FLOORPLANE CURVE LARGE;So;0;L;;;;;N;;;;;
1D9D8;SIGNWRITING MOVEMENT-FLOORPLANE CURVE LARGEST;So;0;L;;;;;N;;;;;
1D9D9;SIGNWRITING MOVEMENT-FLOORPLANE CURVE COMBINED;So;0;L;;;;;N;;;;;
1D9DA;SIGNWRITING MOVEMENT-FLOORPLANE HUMP SMALL;So;0;L;;;;;N;;;;;
1D9DB;SIGNWRITING MOVEMENT-FLOORPLANE LOOP SMALL;So;0;L;;;;;N;;;;;
1D9DC;SIGNWRITING MOVEMENT-FLOORPLANE WAVE SNAKE;So;0;L;;;;;N;;;;;
1D9DD;SIGNWRITING MOVEMENT-FLOORPLANE WAVE SMALL;So;0;L;;;;;N;;;;;
1D9DE;SIGNWRITING MOVEMENT-FLOORPLANE WAVE LARGE;So;0;L;;;;;N;;;;;
1D9DF;SIGNWRITING ROTATION-FLOORPLANE SINGLE;So;0;L;;;;;N;;;;;
1D9E0;SIGNWRITING ROTATION-FLOORPLANE DOUBLE;So;0;L;;;;;N;;;;;
1D9E1;SIGNWRITING ROTATION-FLOORPLANE ALTERNATING;So;0;L;;;;;N;;;;;
1D9E2;SIGNWRITING MOVEMENT-FLOORPLANE SHAKING PARALLEL;So;0;L;;;;;N;;;;;
1D9E3;SIGNWRITING MOVEMENT-WALLPLANE ARM CIRCLE SMALL SINGLE;So;0;L;;;;;N;;;;;
1D9E4;SIGNWRITING MOVEMENT-WALLPLANE ARM CIRCLE MEDIUM SINGLE;So;0;L;;;;;N;;;;;
1D9E5;SIGNWRITING MOVEMENT-WALLPLANE ARM CIRCLE SMALL DOUBLE;So;0;L;;;;;N;;;;;
1D9E6;SIGNWRITING MOVEMENT-WALLPLANE ARM CIRCLE MEDIUM DOUBLE;So;0;L;;;;;N;;;;;
1D9E7;SIGNWRITING MOVEMENT-FLOORPLANE ARM CIRCLE HITTING WALL SMALL SINGLE;So;0;L;;;;;N;;;;;
1D9E8;SIGNWRITING MOVEMENT-FLOORPLANE ARM CIRCLE HITTING WALL MEDIUM SINGLE;So;0;L;;;;;N;;;;;
1D9E9;SIGNWRITING MOVEMENT-FLOORPLANE ARM CIRCLE HITTING WALL LARGE SINGLE;So;0;L;;;;;N;;;;;
1D9EA;SIGNWRITING MOVEMENT-FLOORPLANE ARM CIRCLE HITTING WALL SMALL DOUBLE;So;0;L;;;;;N;;;;;
1D9EB;SIGNWRITING MOVEMENT-FLOORPLANE ARM CIRCLE HITTING WALL MEDIUM DOUBLE;So;0;L;;;;;N;;;;;
1D9EC;SIGNWRITING MOVEMENT-FLOORPLANE ARM CIRCLE HITTING WALL LARGE DOUBLE;So;0;L;;;;;N;;;;;
1D9ED;SIGNWRITING MOVEMENT-WALLPLANE WRIST CIRCLE FRONT SINGLE;So;0;L;;;;;N;;;;;
1D9EE;SIGNWRITING MOVEMENT-WALLPLANE WRIST CIRCLE FRONT DOUBLE;So;0;L;;;;;N;;;;;
1D9EF;SIGNWRITING MOVEMENT-FLOORPLANE WRIST CIRCLE HITTING WALL SINGLE;So;0;L;;;;;N;;;;;
1D9F0;SIGNWRITING MOVEMENT-FLOORPLANE WRIST CIRCLE HITTING WALL DOUBLE;So;0;L;;;;;N;;;;;
1D9F1;SIGNWRITING MOVEMENT-WALLPLANE FINGER CIRCLES SINGLE;So;0;L;;;;;N;;;;;
1D9F2;SIGNWRITING MOVEMENT-WALLPLANE FINGER CIRCLES DOUBLE;So;0;L;;;;;N;;;;;
1D9F3;SIGNWRITING MOVEMENT-FLOORPLANE FINGER CIRCLES HITTING WALL SINGLE;So;0;L;;;;;N;;;;;
1D9F4;SIGNWRITING MOVEMENT-FLOORPLANE FINGER CIRCLES HITTING WALL DOUBLE;So;0;L;;;;;N;;;;;
1D9F5;SIGNWRITING DYNAMIC ARROWHEAD SMALL;So;0;L;;;;;N;;;;;
1D9F6;SIGNWRITING DYNAMIC ARROWHEAD LARGE;So;0;L;;;;;N;;;;;
1D9F7;SIGNWRITING DYNAMIC FAST;So;0;L;;;;;N;;;;;
1D9F8;SIGNWRITING DYNAMIC SLOW;So;0;L;;;;;N;;;;;
1D9F9;SIGNWRITING DYNAMIC TENSE;So;0;L;;;;;N;;;;;
1D9FA;SIGNWRITING DYNAMIC RELAXED;So;0;L;;;;;N;;;;;
1D9FB;SIGNWRITING DYNAMIC SIMULTANEOUS;So;0;L;;;;;N;;;;;
1D9FC;SIGNWRITING DYNAMIC SIMULTANEOUS ALTERNATING;So;0;L;;;;;N;;;;;
1D9FD;SIGNWRITING DYNAMIC EVERY OTHER TIME;So;0;L;;;;;N;;;;;
1D9FE;SIGNWRITING DYNAMIC GRADUAL;So;0;L;;;;;N;;;;;
1D9FF;SIGNWRITING HEAD;So;0;L;;;;;N;;;;;
1DA00;SIGNWRITING HEAD RIM;Mn;0;NSM;;;;;N;;;;;
1DA01;SIGNWRITING HEAD MOVEMENT-WALLPLANE STRAIGHT;Mn;0;NSM;;;;;N;;;;;
1DA02;SIGNWRITING HEAD MOVEMENT-WALLPLANE TILT;Mn;0;NSM;;;;;N;;;;;
1DA03;SIGNWRITING HEAD MOVEMENT-FLOORPLANE STRAIGHT;Mn;0;NSM;;;;;N;;;;;
1DA04;SIGNWRITING HEAD MOVEMENT-WALLPLANE CURVE;Mn;0;NSM;;;;;N;;;;;
1DA05;SIGNWRITING HEAD MOVEMENT-FLOORPLANE CURVE;Mn;0;NSM;;;;;N;;;;;
1DA06;SIGNWRITING HEAD MOVEMENT CIRCLE;Mn;0;NSM;;;;;N;;;;;
1DA07;SIGNWRITING FACE DIRECTION POSITION NOSE FORWARD TILTING;Mn;0;NSM;;;;;N;;;;;
1DA08;SIGNWRITING FACE DIRECTION POSITION NOSE UP OR DOWN;Mn;0;NSM;;;;;N;;;;;
1DA09;SIGNWRITING FACE DIRECTION POSITION NOSE UP OR DOWN TILTING;Mn;0;NSM;;;;;N;;;;;
1DA0A;SIGNWRITING EYEBROWS STRAIGHT UP;Mn;0;NSM;;;;;N;;;;;
1DA0B;SIGNWRITING EYEBROWS STRAIGHT NEUTRAL;Mn;0;NSM;;;;;N;;;;;
1DA0C;SIGNWRITING EYEBROWS STRAIGHT DOWN;Mn;0;NSM;;;;;N;;;;;
1DA0D;SIGNWRITING DREAMY EYEBROWS NEUTRAL DOWN;Mn;0;NSM;;;;;N;;;;;
1DA0E;SIGNWRITING DREAMY EYEBROWS DOWN NEUTRAL;Mn;0;NSM;;;;;N;;;;;
1DA0F;SIGNWRITING DREAMY EYEBROWS UP NEUTRAL;Mn;0;NSM;;;;;N;;;;;
1DA10;SIGNWRITING DREAMY EYEBROWS NEUTRAL UP;Mn;0;NSM;;;;;N;;;;;
1DA11;SIGNWRITING FOREHEAD NEUTRAL;Mn;0;NSM;;;;;N;;;;;
1DA12;SIGNWRITING FOREHEAD CONTACT;Mn;0;NSM;;;;;N;;;;;
1DA13;SIGNWRITING FOREHEAD WRINKLED;Mn;0;NSM;;;;;N;;;;;
1DA14;SIGNWRITING EYES OPEN;Mn;0;NSM;;;;;N;;;;;
1DA15;SIGNWRITING EYES SQUEEZED;Mn;0;NSM;;;;;N;;;;;
1DA16;SIGNWRITING EYES CLOSED;Mn;0;NSM;;;;;N;;;;;
1DA17;SIGNWRITING EYE BLINK SINGLE;Mn;0;NSM;;;;;N;;;;;
1DA18;SIGNWRITING EYE BLINK MULTIPLE;Mn;0;NSM;;;;;N;;;;;
1DA19;SIGNWRITING EYES HALF OPEN;Mn;0;NSM;;;;;N;;;;;
1DA1A;SIGNWRITING EYES WIDE OPEN;Mn;0;NSM;;;;;N;;;;;
1DA1B;SIGNWRITING EYES HALF CLOSED;Mn;0;NSM;;;;;N;;;;;
1DA1C;SIGNWRITING EYES WIDENING MOVEMENT;Mn;0;NSM;;;;;N;;;;;
1DA1D;SIGNWRITING EYE WINK;Mn;0;NSM;;;;;N;;;;;
1DA1E;SIGNWRITING EYELASHES UP;Mn;0;NSM;;;;;N;;;;;
1DA1F;SIGNWRITING EYELASHES DOWN;Mn;0;NSM;;;;;N;;;;;
1DA20;SIGNWRITING EYELASHES FLUTTERING;Mn;0;NSM;;;;;N;;;;;
1DA21;SIGNWRITING EYEGAZE-WALLPLANE STRAIGHT;Mn;0;NSM;;;;;N;;;;;
1DA22;SIGNWRITING EYEGAZE-WALLPLANE STRAIGHT DOUBLE;Mn;0;NSM;;;;;N;;;;;
1DA23;SIGNWRITING EYEGAZE-WALLPLANE STRAIGHT ALTERNATING;Mn;0;NSM;;;;;N;;;;;
1DA24;SIGNWRITING EYEGAZE-FLOORPLANE STRAIGHT;Mn;0;NSM;;;;;N;;;;;
1DA25;SIGNWRITING EYEGAZE-FLOORPLANE STRAIGHT DOUBLE;Mn;0;NSM;;;;;N;;;;;
1DA26;SIGNWRITING EYEGAZE-FLOORPLANE STRAIGHT ALTERNATING;Mn;0;NSM;;;;;N;;;;;
1DA27;SIGNWRITING EYEGAZE-WALLPLANE CURVED;Mn;0;NSM;;;;;N;;;;;
1DA28;SIGNWRITING EYEGAZE-FLOORPLANE CURVED;Mn;0;NSM;;;;;N;;;;;
1DA29;SIGNWRITING EYEGAZE-WALLPLANE CIRCLING;Mn;0;NSM;;;;;N;;;;;
1DA2A;SIGNWRITING CHEEKS PUFFED;Mn;0;NSM;;;;;N;;;;;
1DA2B;SIGNWRITING CHEEKS NEUTRAL;Mn;0;NSM;;;;;N;;;;;
1DA2C;SIGNWRITING CHEEKS SUCKED;Mn;0;NSM;;;;;N;;;;;
1DA2D;SIGNWRITING TENSE CHEEKS HIGH;Mn;0;NSM;;;;;N;;;;;
1DA2E;SIGNWRITING TENSE CHEEKS MIDDLE;Mn;0;NSM;;;;;N;;;;;
1DA2F;SIGNWRITING TENSE CHEEKS LOW;Mn;0;NSM;;;;;N;;;;;
1DA30;SIGNWRITING EARS;Mn;0;NSM;;;;;N;;;;;
1DA31;SIGNWRITING NOSE NEUTRAL;Mn;0;NSM;;;;;N;;;;;
1DA32;SIGNWRITING NOSE CONTACT;Mn;0;NSM;;;;;N;;;;;
1DA33;SIGNWRITING NOSE WRINKLES;Mn;0;NSM;;;;;N;;;;;
1DA34;SIGNWRITING NOSE WIGGLES;Mn;0;NSM;;;;;N;;;;;
1DA35;SIGNWRITING AIR BLOWING OUT;Mn;0;NSM;;;;;N;;;;;
1DA36;SIGNWRITING AIR SUCKING IN;Mn;0;NSM;;;;;N;;;;;
1DA37;SIGNWRITING AIR BLOW SMALL ROTATIONS;So;0;L;;;;;N;;;;;
1DA38;SIGNWRITING AIR SUCK SMALL ROTATIONS;So;0;L;;;;;N;;;;;
1DA39;SIGNWRITING BREATH INHALE;So;0;L;;;;;N;;;;;
1DA3A;SIGNWRITING BREATH EXHALE;So;0;L;;;;;N;;;;;
1DA3B;SIGNWRITING MOUTH CLOSED NEUTRAL;Mn;0;NSM;;;;;N;;;;;
1DA3C;SIGNWRITING MOUTH CLOSED FORWARD;Mn;0;NSM;;;;;N;;;;;
1DA3D;SIGNWRITING MOUTH CLOSED CONTACT;Mn;0;NSM;;;;;N;;;;;
1DA3E;SIGNWRITING MOUTH SMILE;Mn;0;NSM;;;;;N;;;;;
1DA3F;SIGNWRITING MOUTH SMILE WRINKLED;Mn;0;NSM;;;;;N;;;;;
1DA40;SIGNWRITING MOUTH SMILE OPEN;Mn;0;NSM;;;;;N;;;;;
1DA41;SIGNWRITING MOUTH FROWN;Mn;0;NSM;;;;;N;;;;;
1DA42;SIGNWRITING MOUTH FROWN WRINKLED;Mn;0;NSM;;;;;N;;;;;
1DA43;SIGNWRITING MOUTH FROWN OPEN;Mn;0;NSM;;;;;N;;;;;
1DA44;SIGNWRITING MOUTH OPEN CIRCLE;Mn;0;NSM;;;;;N;;;;;
1DA45;SIGNWRITING MOUTH OPEN FORWARD;Mn;0;NSM;;;;;N;;;;;
1DA46;SIGNWRITING MOUTH OPEN WRINKLED;Mn;0;NSM;;;;;N;;;;;
1DA47;SIGNWRITING MOUTH OPEN OVAL;Mn;0;NSM;;;;;N;;;;;
1DA48;SIGNWRITING MOUTH OPEN OVAL WRINKLED;Mn;0;NSM;;;;;N;;;;;
1DA49;SIGNWRITING MOUTH OPEN OVAL YAWN;Mn;0;NSM;;;;;N;;;;;
1DA4A;SIGNWRITING MOUTH OPEN RECTANGLE;Mn;0;NSM;;;;;N;;;;;
1DA4B;SIGNWRITING MOUTH OPEN RECTANGLE WRINKLED;Mn;0;NSM;;;;;N;;;;;
1DA4C;SIGNWRITING MOUTH OPEN RECTANGLE YAWN;Mn;0;NSM;;;;;N;;;;;
1DA4D;SIGNWRITING MOUTH KISS;Mn;0;NSM;;;;;N;;;;;
1DA4E;SIGNWRITING MOUTH KISS FORWARD;Mn;0;NSM;;;;;N;;;;;
1DA4F;SIGNWRITING MOUTH KISS WRINKLED;Mn;0;NSM;;;;;N;;;;;
1DA50;SIGNWRITING MOUTH TENSE;Mn;0;NSM;;;;;N;;;;;
1DA51;SIGNWRITING MOUTH TENSE FORWARD;Mn;0;NSM;;;;;N;;;;;
1DA52;SIGNWRITING MOUTH TENSE SUCKED;Mn;0;NSM;;;;;N;;;;;
1DA53;SIGNWRITING LIPS PRESSED TOGETHER;Mn;0;NSM;;;;;N;;;;;
1DA54;SIGNWRITING LIP LOWER OVER UPPER;Mn;0;NSM;;;;;N;;;;;
1DA55;SIGNWRITING LIP UPPER OVER LOWER;Mn;0;NSM;;;;;N;;;;;
1DA56;SIGNWRITING MOUTH CORNERS;Mn;0;NSM;;;;;N;;;;;
1DA57;SIGNWRITING MOUTH WRINKLES SINGLE;Mn;0;NSM;;;;;N;;;;;
1DA58;SIGNWRITING MOUTH WRINKLES DOUBLE;Mn;0;NSM;;;;;N;;;;;
1DA59;SIGNWRITING TONGUE STICKING OUT FAR;Mn;0;NSM;;;;;N;;;;;
1DA5A;SIGNWRITING TONGUE LICKING LIPS;Mn;0;NSM;;;;;N;;;;;
1DA5B;SIGNWRITING TONGUE TIP BETWEEN LIPS;Mn;0;NSM;;;;;N;;;;;
1DA5C;SIGNWRITING TONGUE TIP TOUCHING INSIDE MOUTH;Mn;0;NSM;;;;;N;;;;;
1DA5D;SIGNWRITING TONGUE INSIDE MOUTH RELAXED;Mn;0;NSM;;;;;N;;;;;
1DA5E;SIGNWRITING TONGUE MOVES AGAINST CHEEK;Mn;0;NSM;;;;;N;;;;;
1DA5F;SIGNWRITING TONGUE CENTRE STICKING OUT;Mn;0;NSM;;;;;N;;;;;
1DA60;SIGNWRITING TONGUE CENTRE INSIDE MOUTH;Mn;0;NSM;;;;;N;;;;;
1DA61;SIGNWRITING TEETH;Mn;0;NSM;;;;;N;;;;;
1DA62;SIGNWRITING TEETH MOVEMENT;Mn;0;NSM;;;;;N;;;;;
1DA63;SIGNWRITING TEETH ON TONGUE;Mn;0;NSM;;;;;N;;;;;
1DA64;SIGNWRITING TEETH ON TONGUE MOVEMENT;Mn;0;NSM;;;;;N;;;;;
1DA65;SIGNWRITING TEETH ON LIPS;Mn;0;NSM;;;;;N;;;;;
1DA66;SIGNWRITING TEETH ON LIPS MOVEMENT;Mn;0;NSM;;;;;N;;;;;
1DA67;SIGNWRITING TEETH BITE LIPS;Mn;0;NSM;;;;;N;;;;;
1DA68;SIGNWRITING MOVEMENT-WALLPLANE JAW;Mn;0;NSM;;;;;N;;;;;
1DA69;SIGNWRITING MOVEMENT-FLOORPLANE JAW;Mn;0;NSM;;;;;N;;;;;
1DA6A;SIGNWRITING NECK;Mn;0;NSM;;;;;N;;;;;
1DA6B;SIGNWRITING HAIR;Mn;0;NSM;;;;;N;;;;;
1DA6C;SIGNWRITING EXCITEMENT;Mn;0;NSM;;;;;N;;;;;
1DA6D;SIGNWRITING SHOULDER HIP SPINE;So;0;L;;;;;N;;;;;
1DA6E;SIGNWRITING SHOULDER HIP POSITIONS;So;0;L;;;;;N;;;;;
1DA6F;SIGNWRITING WALLPLANE SHOULDER HIP MOVE;So;0;L;;;;;N;;;;;
1DA70;SIGNWRITING FLOORPLANE SHOULDER HIP MOVE;So;0;L;;;;;N;;;;;
1DA71;SIGNWRITING SHOULDER TILTING FROM WAIST;So;0;L;;;;;N;;;;;
1DA72;SIGNWRITING TORSO-WALLPLANE STRAIGHT STRETCH;So;0;L;;;;;N;;;;;
1DA73;SIGNWRITING TORSO-WALLPLANE CURVED BEND;So;0;L;;;;;N;;;;;
1DA74;SIGNWRITING TORSO-FLOORPLANE TWISTING;So;0;L;;;;;N;;;;;
1DA75;SIGNWRITING UPPER BODY TILTING FROM HIP JOINTS;Mn;0;NSM;;;;;N;;;;;
1DA76;SIGNWRITING LIMB COMBINATION;So;0;L;;;;;N;;;;;
1DA77;SIGNWRITING LIMB LENGTH-1;So;0;L;;;;;N;;;;;
1DA78;SIGNWRITING LIMB LENGTH-2;So;0;L;;;;;N;;;;;
1DA79;SIGNWRITING LIMB LENGTH-3;So;0;L;;;;;N;;;;;
1DA7A;SIGNWRITING LIMB LENGTH-4;So;0;L;;;;;N;;;;;
1DA7B;SIGNWRITING LIMB LENGTH-5;So;0;L;;;;;N;;;;;
1DA7C;SIGNWRITING LIMB LENGTH-6;So;0;L;;;;;N;;;;;
1DA7D;SIGNWRITING LIMB LENGTH-7;So;0;L;;;;;N;;;;;
1DA7E;SIGNWRITING FINGER;So;0;L;;;;;N;;;;;
1DA7F;SIGNWRITING LOCATION-WALLPLANE SPACE;So;0;L;;;;;N;;;;;
1DA80;SIGNWRITING LOCATION-FLOORPLANE SPACE;So;0;L;;;;;N;;;;;
1DA81;SIGNWRITING LOCATION HEIGHT;So;0;L;;;;;N;;;;;
1DA82;SIGNWRITING LOCATION WIDTH;So;0;L;;;;;N;;;;;
1DA83;SIGNWRITING LOCATION DEPTH;So;0;L;;;;;N;;;;;
1DA84;SIGNWRITING LOCATION HEAD NECK;Mn;0;NSM;;;;;N;;;;;
1DA85;SIGNWRITING LOCATION TORSO;So;0;L;;;;;N;;;;;
1DA86;SIGNWRITING LOCATION LIMBS DIGITS;So;0;L;;;;;N;;;;;
1DA87;SIGNWRITING COMMA;Po;0;L;;;;;N;;;;;
1DA88;SIGNWRITING FULL STOP;Po;0;L;;;;;N;;;;;
1DA89;SIGNWRITING SEMICOLON;Po;0;L;;;;;N;;;;;
1DA8A;SIGNWRITING COLON;Po;0;L;;;;;N;;;;;
1DA8B;SIGNWRITING PARENTHESIS;Po;0;L;;;;;N;;;;;
1DA9B;SIGNWRITING FILL MODIFIER-2;Mn;0;NSM;;;;;N;;;;;
1DA9C;SIGNWRITING FILL MODIFIER-3;Mn;0;NSM;;;;;N;;;;;
1DA9D;SIGNWRITING FILL MODIFIER-4;Mn;0;NSM;;;;;N;;;;;
1DA9E;SIGNWRITING FILL MODIFIER-5;Mn;0;NSM;;;;;N;;;;;
1DA9F;SIGNWRITING FILL MODIFIER-6;Mn;0;NSM;;;;;N;;;;;
1DAA1;SIGNWRITING ROTATION MODIFIER-2;Mn;0;NSM;;;;;N;;;;;
1DAA2;SIGNWRITING ROTATION MODIFIER-3;Mn;0;NSM;;;;;N;;;;;
1DAA3;SIGNWRITING ROTATION MODIFIER-4;Mn;0;NSM;;;;;N;;;;;
1DAA4;SIGNWRITING ROTATION MODIFIER-5;Mn;0;NSM;;;;;N;;;;;
1DAA5;SIGNWRITING ROTATION MODIFIER-6;Mn;0;NSM;;;;;N;;;;;
1DAA6;SIGNWRITING ROTATION MODIFIER-7;Mn;0;NSM;;;;;N;;;;;
1DAA7;SIGNWRITING ROTATION MODIFIER-8;Mn;0;NSM;;;;;N;;;;;
1DAA8;SIGNWRITING ROTATION MODIFIER-9;Mn;0;NSM;;;;;N;;;;;
1DAA9;SIGNWRITING ROTATION MODIFIER-10;Mn;0;NSM;;;;;N;;;;;
1DAAA;SIGNWRITING ROTATION MODIFIER-11;Mn;0;NSM;;;;;N;;;;;
1DAAB;SIGNWRITING ROTATION MODIFIER-12;Mn;0;NSM;;;;;N;;;;;
1DAAC;SIGNWRITING ROTATION MODIFIER-13;Mn;0;NSM;;;;;N;;;;;
1DAAD;SIGNWRITING ROTATION MODIFIER-14;Mn;0;NSM;;;;;N;;;;;
1DAAE;SIGNWRITING ROTATION MODIFIER-15;Mn;0;NSM;;;;;N;;;;;
1DAAF;SIGNWRITING ROTATION MODIFIER-16;Mn;0;NSM;;;;;N;;;;;
1DF00;LATIN SMALL LETTER FENG DIGRAPH WITH TRILL;Ll;0;L;;;;;N;;;;;
1DF01;LATIN SMALL LETTER REVERSED SCRIPT G;Ll;0;L;;;;;N;;;;;
1DF02;LATIN LETTER SMALL CAPITAL TURNED G;Ll;0;L;;;;;N;;;;;
1DF03;LATIN SMALL LETTER REVERSED K;Ll;0;L;;;;;N;;;;;
1DF04;LATIN LETTER SMALL CAPITAL L WITH BELT;Ll;0;L;;;;;N;;;;;
1DF05;LATIN SMALL LETTER LEZH WITH RETROFLEX HOOK;Ll;0;L;;;;;N;;;;;
1DF06;LATIN SMALL LETTER TURNED Y WITH BELT;Ll;0;L;;;;;N;;;;;
1DF07;LATIN SMALL LETTER REVERSED ENG;Ll;0;L;;;;;N;;;;;
1DF08;LATIN SMALL LETTER TURNED R WITH LONG LEG AND RETROFLEX HOOK;Ll;0;L;;;;;N;;;;;
1DF09;LATIN SMALL LETTER T WITH HOOK AND RETROFLEX HOOK;Ll;0;L;;;;;N;;;;;
1DF0A;LATIN LETTER RETROFLEX CLICK WITH RETROFLEX HOOK;Lo;0;L;;;;;N;;;;;
1DF0B;LATIN SMALL LETTER ESH WITH DOUBLE BAR;Ll;0;L;;;;;N;;;;;
1DF0C;LATIN SMALL LETTER ESH WITH DOUBLE BAR AND CURL;Ll;0;L;;;;;N;;;;;
1DF0D;LATIN SMALL LETTER TURNED T WITH CURL;Ll;0;L;;;;;N;;;;;
1DF0E;LATIN LETTER INVERTED GLOTTAL STOP WITH CURL;Ll;0;L;;;;;N;;;;;
1DF0F;LATIN LETTER STRETCHED C WITH CURL;Ll;0;L;;;;;N;;;;;
1DF10;LATIN LETTER SMALL CAPITAL TURNED K;Ll;0;L;;;;;N;;;;;
1DF11;LATIN SMALL LETTER L WITH FISHHOOK;Ll;0;L;;;;;N;;;;;
1DF12;LATIN SMALL LETTER DEZH DIGRAPH WITH PALATAL HOOK;Ll;0;L;;;;;N;;;;;
1DF13;LATIN SMALL LETTER L WITH BELT AND PALATAL HOOK;Ll;0;L;;;;;N;;;;;
1DF14;LATIN SMALL LETTER ENG WITH PALATAL HOOK;Ll;0;L;;;;;N;;;;;
1DF15;LATIN SMALL LETTER TURNED R WITH PALATAL HOOK;Ll;0;L;;;;;N;;;;;
1DF16;LATIN SMALL LETTER R WITH FISHHOOK AND PALATAL HOOK;Ll;0;L;;;;;N;;;;;
1DF17;LATIN SMALL LETTER TESH DIGRAPH WITH PALATAL HOOK;Ll;0;L;;;;;N;;;;;
1DF18;LATIN SMALL LETTER EZH WITH PALATAL HOOK;Ll;0;L;;;;;N;;;;;
1DF19;LATIN SMALL LETTER DEZH DIGRAPH WITH RETROFLEX HOOK;Ll;0;L;;;;;N;;;;;
1DF1A;LATIN SMALL LETTER I WITH STROKE AND RETROFLEX HOOK;Ll;0;L;;;;;N;;;;;
1DF1B;LATIN SMALL LETTER O WITH RETROFLEX HOOK;Ll;0;L;;;;;N;;;;;
1DF1C;LATIN SMALL LETTER TESH DIGRAPH WITH RETROFLEX HOOK;Ll;0;L;;;;;N;;;;;
1DF1D;LATIN SMALL LETTER C WITH RETROFLEX HOOK;Ll;0;L;;;;;N;;;;;
1DF1E;LATIN SMALL LETTER S WITH CURL;Ll;0;L;;;;;N;;;;;
1E000;COMBINING GLAGOLITIC LETTER AZU;Mn;230;NSM;;;;;N;;;;;
1E001;COMBINING GLAGOLITIC LETTER BUKY;Mn;230;NSM;;;;;N;;;;;
1E002;COMBINING GLAGOLITIC LETTER VEDE;Mn;230;NSM;;;;;N;;;;;
1E003;COMBINING GLAGOLITIC LETTER GLAGOLI;Mn;230;NSM;;;;;N;;;;;
1E004;COMBINING GLAGOLITIC LETTER DOBRO;Mn;230;NSM;;;;;N;;;;;
1E005;COMBINING GLAGOLITIC LETTER YESTU;Mn;230;NSM;;;;;N;;;;;
1E006;COMBINING GLAGOLITIC LETTER ZHIVETE;Mn;230;NSM;;;;;N;;;;;
1E008;COMBINING GLAGOLITIC LETTER ZEMLJA;Mn;230;NSM;;;;;N;;;;;
1E009;COMBINING GLAGOLITIC LETTER IZHE;Mn;230;NSM;;;;;N;;;;;
1E00A;COMBINING GLAGOLITIC LETTER INITIAL IZHE;Mn;230;NSM;;;;;N;;;;;
1E00B;COMBINING GLAGOLITIC LETTER I;Mn;230;NSM;;;;;N;;;;;
1E00C;COMBINING GLAGOLITIC LETTER DJERVI;Mn;230;NSM;;;;;N;;;;;
1E00D;COMBINING GLAGOLITIC LETTER KAKO;Mn;230;NSM;;;;;N;;;;;
1E00E;COMBINING GLAGOLITIC LETTER LJUDIJE;Mn;230;NSM;;;;;N;;;;;
1E00F;COMBINING GLAGOLITIC LETTER MYSLITE;Mn;230;NSM;;;;;N;;;;;
1E010;COMBINING GLAGOLITIC LETTER NASHI;Mn;230;NSM;;;;;N;;;;;
1E011;COMBINING GLAGOLITIC LETTER ONU;Mn;230;NSM;;;;;N;;;;;
1E012;COMBINING GLAGOLITIC LETTER POKOJI;Mn;230;NSM;;;;;N;;;;;
1E013;COMBINING GLAGOLITIC LETTER RITSI;Mn;230;NSM;;;;;N;;;;;
1E014;COMBINING GLAGOLITIC LETTER SLOVO;Mn;230;NSM;;;;;N;;;;;
1E015;COMBINING GLAGOLITIC LETTER TVRIDO;Mn;230;NSM;;;;;N;;;;;
1E016;COMBINING GLAGOLITIC LETTER UKU;Mn;230;NSM;;;;;N;;;;;
1E017;COMBINING GLAGOLITIC LETTER FRITU;Mn;230;NSM;;;;;N;;;;;
1E018;COMBINING GLAGOLITIC LETTER HERU;Mn;230;NSM;;;;;N;;;;;
1E01B;COMBINING GLAGOLITIC LETTER SHTA;Mn;230;NSM;;;;;N;;;;;
1E01C;COMBINING GLAGOLITIC LETTER TSI;Mn;230;NSM;;;;;N;;;;;
1E01D;COMBINING GLAGOLITIC LETTER CHRIVI;Mn;230;NSM;;;;;N;;;;;
1E01E;COMBINING GLAGOLITIC LETTER SHA;Mn;230;NSM;;;;;N;;;;;
1E01F;COMBINING GLAGOLITIC LETTER YERU;Mn;230;NSM;;;;;N;;;;;
1E020;COMBINING GLAGOLITIC LETTER YERI;Mn;230;NSM;;;;;N;;;;;
1E021;COMBINING GLAGOLITIC LETTER YATI;Mn;230;NSM;;;;;N;;;;;
1E023;COMBINING GLAGOLITIC LETTER YU;Mn;230;NSM;;;;;N;;;;;
1E024;COMBINING GLAGOLITIC LETTER SMALL YUS;Mn;230;NSM;;;;;N;;;;;
1E026;COMBINING GLAGOLITIC LETTER YO;Mn;230;NSM;;;;;N;;;;;
1E027;COMBINING GLAGOLITIC LETTER IOTATED SMALL YUS;Mn;230;NSM;;;;;N;;;;;
1E028;COMBINING GLAGOLITIC LETTER BIG YUS;Mn;230;NSM;;;;;N;;;;;
1E029;COMBINING GLAGOLITIC LETTER IOTATED BIG YUS;Mn;230;NSM;;;;;N;;;;;
1E02A;COMBINING GLAGOLITIC LETTER FITA;Mn;230;NSM;;;;;N;;;;;
1E100;NYIAKENG PUACHUE HMONG LETTER MA;Lo;0;L;;;;;N;;;;;
1E101;NYIAKENG PUACHUE HMONG LETTER TSA;Lo;0;L;;;;;N;;;;;
1E102;NYIAKENG PUACHUE HMONG LETTER NTA;Lo;0;L;;;;;N;;;;;
1E103;NYIAKENG PUACHUE HMONG LETTER TA;Lo;0;L;;;;;N;;;;;
1E104;NYIAKENG PUACHUE HMONG LETTER HA;Lo;0;L;;;;;N;;;;;
1E105;NYIAKENG PUACHUE HMONG LETTER NA;Lo;0;L;;;;;N;;;;;
1E106;NYIAKENG PUACHUE HMONG LETTER XA;Lo;0;L;;;;;N;;;;;
1E107;NYIAKENG PUACHUE HMONG LETTER NKA;Lo;0;L;;;;;N;;;;;
1E108;NYIAKENG PUACHUE HMONG LETTER CA;Lo;0;L;;;;;N;;;;;
1E109;NYIAKENG PUACHUE HMONG LETTER LA;Lo;0;L;;;;;N;;;;;
1E10A;NYIAKENG PUACHUE HMONG LETTER SA;Lo;0;L;;;;;N;;;;;
1E10B;NYIAKENG PUACHUE HMONG LETTER ZA;Lo;0;L;;;;;N;;;;;
1E10C;NYIAKENG PUACHUE HMONG LETTER NCA;Lo;0;L;;;;;N;;;;;
1E10D;NYIAKENG PUACHUE HMONG LETTER NTSA;Lo;0;L;;;;;N;;;;;
1E10E;NYIAKENG PUACHUE HMONG LETTER KA;Lo;0;L;;;;;N;;;;;
1E10F;NYIAKENG PUACHUE HMONG LETTER DA;Lo;0;L;;;;;N;;;;;
1E110;NYIAKENG PUACHUE HMONG LETTER NYA;Lo;0;L;;;;;N;;;;;
1E111;NYIAKENG PUACHUE HMONG LETTER NRA;Lo;0;L;;;;;N;;;;;
1E112;NYIAKENG PUACHUE HMONG LETTER VA;Lo;0;L;;;;;N;;;;;
1E113;NYIAKENG PUACHUE HMONG LETTER NTXA;Lo;0;L;;;;;N;;;;;
1E114;NYIAKENG PUACHUE HMONG LETTER TXA;Lo;0;L;;;;;N;;;;;
1E115;NYIAKENG PUACHUE HMONG LETTER FA;Lo;0;L;;;;;N;;;;;
1E116;NYIAKENG PUACHUE HMONG LETTER RA;Lo;0;L;;;;;N;;;;;
1E117;NYIAKENG PUACHUE HMONG LETTER QA;Lo;0;L;;;;;N;;;;;
1E118;NYIAKENG PUACHUE HMONG LETTER YA;Lo;0;L;;;;;N;;;;;
1E119;NYIAKENG PUACHUE HMONG LETTER NQA;Lo;0;L;;;;;N;;;;;
1E11A;NYIAKENG PUACHUE HMONG LETTER PA;Lo;0;L;;;;;N;;;;;
1E11B;NYIAKENG PUACHUE HMONG LETTER XYA;Lo;0;L;;;;;N;;;;;
1E11C;NYIAKENG PUACHUE HMONG LETTER NPA;Lo;0;L;;;;;N;;;;;
1E11D;NYIAKENG PUACHUE HMONG LETTER DLA;Lo;0;L;;;;;N;;;;;
1E11E;NYIAKENG PUACHUE HMONG LETTER NPLA;Lo;0;L;;;;;N;;;;;
1E11F;NYIAKENG PUACHUE HMONG LETTER HAH;Lo;0;L;;;;;N;;;;;
1E120;NYIAKENG PUACHUE HMONG LETTER MLA;Lo;0;L;;;;;N;;;;;
1E121;NYIAKENG PUACHUE HMONG LETTER PLA;Lo;0;L;;;;;N;;;;;
1E122;NYIAKENG PUACHUE HMONG LETTER GA;Lo;0;L;;;;;N;;;;;
1E123;NYIAKENG PUACHUE HMONG LETTER RRA;Lo;0;L;;;;;N;;;;;
1E124;NYIAKENG PUACHUE HMONG LETTER A;Lo;0;L;;;;;N;;;;;
1E125;NYIAKENG PUACHUE HMONG LETTER AA;Lo;0;L;;;;;N;;;;;
1E126;NYIAKENG PUACHUE HMONG LETTER I;Lo;0;L;;;;;N;;;;;
1E127;NYIAKENG PUACHUE HMONG LETTER U;Lo;0;L;;;;;N;;;;;
1E128;NYIAKENG PUACHUE HMONG LETTER O;Lo;0;L;;;;;N;;;;;
1E129;NYIAKENG PUACHUE HMONG LETTER OO;Lo;0;L;;;;;N;;;;;
1E12A;NYIAKENG PUACHUE HMONG LETTER E;Lo;0;L;;;;;N;;;;;
1E12B;NYIAKENG PUACHUE HMONG LETTER EE;Lo;0;L;;;;;N;;;;;
1E12C;NYIAKENG PUACHUE HMONG LETTER W;Lo;0;L;;;;;N;;;;;
1E130;NYIAKENG PUACHUE HMONG TONE-B;Mn;230;NSM;;;;;N;;;;;
1E131;NYIAKENG PUACHUE HMONG TONE-M;Mn;230;NSM;;;;;N;;;;;
1E132;NYIAKENG PUACHUE HMONG TONE-J;Mn;230;NSM;;;;;N;;;;;
1E133;NYIAKENG PUACHUE HMONG TONE-V;Mn;230;NSM;;;;;N;;;;;
1E134;NYIAKENG PUACHUE HMONG TONE-S;Mn;230;NSM;;;;;N;;;;;
1E135;NYIAKENG PUACHUE HMONG TONE-G;Mn;230;NSM;;;;;N;;;;;
1E136;NYIAKENG PUACHUE HMONG TONE-D;Mn;230;NSM;;;;;N;;;;;
1E137;NYIAKENG PUACHUE HMONG SIGN FOR PERSON;Lm;0;L;;;;;N;;;;;
1E138;NYIAKENG PUACHUE HMONG SIGN FOR THING;Lm;0;L;;;;;N;;;;;
1E139;NYIAKENG PUACHUE HMONG SIGN FOR LOCATION;Lm;0;L;;;;;N;;;;;
1E13A;NYIAKENG PUACHUE HMONG SIGN FOR ANIMAL;Lm;0;L;;;;;N;;;;;
1E13B;NYIAKENG PUACHUE HMONG SIGN FOR INVERTEBRATE;Lm;0;L;;;;;N;;;;;
1E13C;NYIAKENG PUACHUE HMONG SIGN XW XW;Lm;0;L;;;;;N;;;;;
1E13D;NYIAKENG PUACHUE HMONG SYLLABLE LENGTHENER;Lm;0;L;;;;;N;;;;;
1E140;NYIAKENG PUACHUE HMONG DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
1E141;NYIAKENG PUACHUE HMONG DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
1E142;NYIAKENG PUACHUE HMONG DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
1E143;NYIAKENG PUACHUE HMONG DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
1E144;NYIAKENG PUACHUE HMONG DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
1E145;NYIAKENG PUACHUE HMONG DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
1E146;NYIAKENG PUACHUE HMONG DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
1E147;NYIAKENG PUACHUE HMONG DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
1E148;NYIAKENG PUACHUE HMONG DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
1E149;NYIAKENG PUACHUE HMONG DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
1E14E;NYIAKENG PUACHUE HMONG LOGOGRAM NYAJ;Lo;0;L;;;;;N;;;;;
1E14F;NYIAKENG PUACHUE HMONG CIRCLED CA;So;0;L;;;;;N;;;;;
1E290;TOTO LETTER PA;Lo;0;L;;;;;N;;;;;
1E291;TOTO LETTER BA;Lo;0;L;;;;;N;;;;;
1E292;TOTO LETTER TA;Lo;0;L;;;;;N;;;;;
1E293;TOTO LETTER DA;Lo;0;L;;;;;N;;;;;
1E294;TOTO LETTER KA;Lo;0;L;;;;;N;;;;;
1E295;TOTO LETTER GA;Lo;0;L;;;;;N;;;;;
1E296;TOTO LETTER MA;Lo;0;L;;;;;N;;;;;
1E297;TOTO LETTER NA;Lo;0;L;;;;;N;;;;;
1E298;TOTO LETTER NGA;Lo;0;L;;;;;N;;;;;
1E299;TOTO LETTER SA;Lo;0;L;;;;;N;;;;;
1E29A;TOTO LETTER CHA;Lo;0;L;;;;;N;;;;;
1E29B;TOTO LETTER YA;Lo;0;L;;;;;N;;;;;
1E29C;TOTO LETTER WA;Lo;0;L;;;;;N;;;;;
1E29D;TOTO LETTER JA;Lo;0;L;;;;;N;;;;;
1E29E;TOTO LETTER HA;Lo;0;L;;;;;N;;;;;
1E29F;TOTO LETTER RA;Lo;0;L;;;;;N;;;;;
1E2A0;TOTO LETTER LA;Lo;0;L;;;;;N;;;;;
1E2A1;TOTO LETTER I;Lo;0;L;;;;;N;;;;;
1E2A2;TOTO LETTER BREATHY I;Lo;0;L;;;;;N;;;;;
1E2A3;TOTO LETTER IU;Lo;0;L;;;;;N;;;;;
1E2A4;TOTO LETTER BREATHY IU;Lo;0;L;;;;;N;;;;;
1E2A5;TOTO LETTER U;Lo;0;L;;;;;N;;;;;
1E2A6;TOTO LETTER E;Lo;0;L;;;;;N;;;;;
1E2A7;TOTO LETTER BREATHY E;Lo;0;L;;;;;N;;;;;
1E2A8;TOTO LETTER EO;Lo;0;L;;;;;N;;;;;
1E2A9;TOTO LETTER BREATHY EO;Lo;0;L;;;;;N;;;;;
1E2AA;TOTO LETTER O;Lo;0;L;;;;;N;;;;;
1E2AB;TOTO LETTER AE;Lo;0;L;;;;;N;;;;;
1E2AC;TOTO LETTER BREATHY AE;Lo;0;L;;;;;N;;;;;
1E2AD;TOTO LETTER A;Lo;0;L;;;;;N;;;;;
1E2AE;TOTO SIGN RISING TONE;Mn;230;NSM;;;;;N;;;;;
1E2C0;WANCHO LETTER AA;Lo;0;L;;;;;N;;;;;
1E2C1;WANCHO LETTER A;Lo;0;L;;;;;N;;;;;
1E2C2;WANCHO LETTER BA;Lo;0;L;;;;;N;;;;;
1E2C3;WANCHO LETTER CA;Lo;0;L;;;;;N;;;;;
1E2C4;WANCHO LETTER DA;Lo;0;L;;;;;N;;;;;
1E2C5;WANCHO LETTER GA;Lo;0;L;;;;;N;;;;;
1E2C6;WANCHO LETTER YA;Lo;0;L;;;;;N;;;;;
1E2C7;WANCHO LETTER PHA;Lo;0;L;;;;;N;;;;;
1E2C8;WANCHO LETTER LA;Lo;0;L;;;;;N;;;;;
1E2C9;WANCHO LETTER NA;Lo;0;L;;;;;N;;;;;
1E2CA;WANCHO LETTER PA;Lo;0;L;;;;;N;;;;;
1E2CB;WANCHO LETTER TA;Lo;0;L;;;;;N;;;;;
1E2CC;WANCHO LETTER THA;Lo;0;L;;;;;N;;;;;
1E2CD;WANCHO LETTER FA;Lo;0;L;;;;;N;;;;;
1E2CE;WANCHO LETTER SA;Lo;0;L;;;;;N;;;;;
1E2CF;WANCHO LETTER SHA;Lo;0;L;;;;;N;;;;;
1E2D0;WANCHO LETTER JA;Lo;0;L;;;;;N;;;;;
1E2D1;WANCHO LETTER ZA;Lo;0;L;;;;;N;;;;;
1E2D2;WANCHO LETTER WA;Lo;0;L;;;;;N;;;;;
1E2D3;WANCHO LETTER VA;Lo;0;L;;;;;N;;;;;
1E2D4;WANCHO LETTER KA;Lo;0;L;;;;;N;;;;;
1E2D5;WANCHO LETTER O;Lo;0;L;;;;;N;;;;;
1E2D6;WANCHO LETTER AU;Lo;0;L;;;;;N;;;;;
1E2D7;WANCHO LETTER RA;Lo;0;L;;;;;N;;;;;
1E2D8;WANCHO LETTER MA;Lo;0;L;;;;;N;;;;;
1E2D9;WANCHO LETTER KHA;Lo;0;L;;;;;N;;;;;
1E2DA;WANCHO LETTER HA;Lo;0;L;;;;;N;;;;;
1E2DB;WANCHO LETTER E;Lo;0;L;;;;;N;;;;;
1E2DC;WANCHO LETTER I;Lo;0;L;;;;;N;;;;;
1E2DD;WANCHO LETTER NGA;Lo;0;L;;;;;N;;;;;
1E2DE;WANCHO LETTER U;Lo;0;L;;;;;N;;;;;
1E2DF;WANCHO LETTER LLHA;Lo;0;L;;;;;N;;;;;
1E2E0;WANCHO LETTER TSA;Lo;0;L;;;;;N;;;;;
1E2E1;WANCHO LETTER TRA;Lo;0;L;;;;;N;;;;;
1E2E2;WANCHO LETTER ONG;Lo;0;L;;;;;N;;;;;
1E2E3;WANCHO LETTER AANG;Lo;0;L;;;;;N;;;;;
1E2E4;WANCHO LETTER ANG;Lo;0;L;;;;;N;;;;;
1E2E5;WANCHO LETTER ING;Lo;0;L;;;;;N;;;;;
1E2E6;WANCHO LETTER ON;Lo;0;L;;;;;N;;;;;
1E2E7;WANCHO LETTER EN;Lo;0;L;;;;;N;;;;;
1E2E8;WANCHO LETTER AAN;Lo;0;L;;;;;N;;;;;
1E2E9;WANCHO LETTER NYA;Lo;0;L;;;;;N;;;;;
1E2EA;WANCHO LETTER UEN;Lo;0;L;;;;;N;;;;;
1E2EB;WANCHO LETTER YIH;Lo;0;L;;;;;N;;;;;
1E2EC;WANCHO TONE TUP;Mn;230;NSM;;;;;N;;;;;
1E2ED;WANCHO TONE TUPNI;Mn;230;NSM;;;;;N;;;;;
1E2EE;WANCHO TONE KOI;Mn;230;NSM;;;;;N;;;;;
1E2EF;WANCHO TONE KOINI;Mn;230;NSM;;;;;N;;;;;
1E2F0;WANCHO DIGIT ZERO;Nd;0;L;;0;0;0;N;;;;;
1E2F1;WANCHO DIGIT ONE;Nd;0;L;;1;1;1;N;;;;;
1E2F2;WANCHO DIGIT TWO;Nd;0;L;;2;2;2;N;;;;;
1E2F3;WANCHO DIGIT THREE;Nd;0;L;;3;3;3;N;;;;;
1E2F4;WANCHO DIGIT FOUR;Nd;0;L;;4;4;4;N;;;;;
1E2F5;WANCHO DIGIT FIVE;Nd;0;L;;5;5;5;N;;;;;
1E2F6;WANCHO DIGIT SIX;Nd;0;L;;6;6;6;N;;;;;
1E2F7;WANCHO DIGIT SEVEN;Nd;0;L;;7;7;7;N;;;;;
1E2F8;WANCHO DIGIT EIGHT;Nd;0;L;;8;8;8;N;;;;;
1E2F9;WANCHO DIGIT NINE;Nd;0;L;;9;9;9;N;;;;;
1E2FF;WANCHO NGUN SIGN;Sc;0;ET;;;;;N;;;;;
1E7E0;ETHIOPIC SYLLABLE HHYA;Lo;0;L;;;;;N;;;;;
1E7E1;ETHIOPIC SYLLABLE HHYU;Lo;0;L;;;;;N;;;;;
1E7E2;ETHIOPIC SYLLABLE HHYI;Lo;0;L;;;;;N;;;;;
1E7E3;ETHIOPIC SYLLABLE HHYAA;Lo;0;L;;;;;N;;;;;
1E7E4;ETHIOPIC SYLLABLE HHYEE;Lo;0;L;;;;;N;;;;;
1E7E5;ETHIOPIC SYLLABLE HHYE;Lo;0;L;;;;;N;;;;;
1E7E6;ETHIOPIC SYLLABLE HHYO;Lo;0;L;;;;;N;;;;;
1E7E8;ETHIOPIC SYLLABLE GURAGE HHWA;Lo;0;L;;;;;N;;;;;
1E7E9;ETHIOPIC SYLLABLE HHWI;Lo;0;L;;;;;N;;;;;
1E7EA;ETHIOPIC SYLLABLE HHWEE;Lo;0;L;;;;;N;;;;;
1E7EB;ETHIOPIC SYLLABLE HHWE;Lo;0;L;;;;;N;;;;;
1E7ED;ETHIOPIC SYLLABLE GURAGE MWI;Lo;0;L;;;;;N;;;;;
1E7EE;ETHIOPIC SYLLABLE GURAGE MWEE;Lo;0;L;;;;;N;;;;;
1E7F0;ETHIOPIC SYLLABLE GURAGE QWI;Lo;0;L;;;;;N;;;;;
1E7F1;ETHIOPIC SYLLABLE GURAGE QWEE;Lo;0;L;;;;;N;;;;;
1E7F2;ETHIOPIC SYLLABLE GURAGE QWE;Lo;0;L;;;;;N;;;;;
1E7F3;ETHIOPIC SYLLABLE GURAGE BWI;Lo;0;L;;;;;N;;;;;
1E7F4;ETHIOPIC SYLLABLE GURAGE BWEE;Lo;0;L;;;;;N;;;;;
1E7F5;ETHIOPIC SYLLABLE GURAGE KWI;Lo;0;L;;;;;N;;;;;
1E7F6;ETHIOPIC SYLLABLE GURAGE KWEE;Lo;0;L;;;;;N;;;;;
1E7F7;ETHIOPIC SYLLABLE GURAGE KWE;Lo;0;L;;;;;N;;;;;
1E7F8;ETHIOPIC SYLLABLE GURAGE GWI;Lo;0;L;;;;;N;;;;;
1E7F9;ETHIOPIC SYLLABLE GURAGE GWEE;Lo;0;L;;;;;N;;;;;
1E7FA;ETHIOPIC SYLLABLE GURAGE GWE;Lo;0;L;;;;;N;;;;;
1E7FB;ETHIOPIC SYLLABLE GURAGE FWI;Lo;0;L;;;;;N;;;;;
1E7FC;ETHIOPIC SYLLABLE GURAGE FWEE;Lo;0;L;;;;;N;;;;;
1E7FD;ETHIOPIC SYLLABLE GURAGE PWI;Lo;0;L;;;;;N;;;;;
1E7FE;ETHIOPIC SYLLABLE GURAGE PWEE;Lo;0;L;;;;;N;;;;;
1E800;MENDE KIKAKUI SYLLABLE M001 KI;Lo;0;R;;;;;N;;;;;
1E801;MENDE KIKAKUI SYLLABLE M002 KA;Lo;0;R;;;;;N;;;;;
1E802;MENDE KIKAKUI SYLLABLE M003 KU;Lo;0;R;;;;;N;;;;;
1E803;MENDE KIKAKUI SYLLABLE M065 KEE;Lo;0;R;;;;;N;;;;;
1E804;MENDE KIKAKUI SYLLABLE M095 KE;Lo;0;R;;;;;N;;;;;
1E805;MENDE KIKAKUI SYLLABLE M076 KOO;Lo;0;R;;;;;N;;;;;
1E806;MENDE KIKAKUI SYLLABLE M048 KO;Lo;0;R;;;;;N;;;;;
1E807;MENDE KIKAKUI SYLLABLE M179 KUA;Lo;0;R;;;;;N;;;;;
1E808;MENDE KIKAKUI SYLLABLE M004 WI;Lo;0;R;;;;;N;;;;;
1E809;MENDE KIKAKUI SYLLABLE M005 WA;Lo;0;R;;;;;N;;;;;
1E80A;MENDE KIKAKUI SYLLABLE M006 WU;Lo;0;R;;;;;N;;;;;
1E80B;MENDE KIKAKUI SYLLABLE M126 WEE;Lo;0;R;;;;;N;;;;;
1E80C;MENDE KIKAKUI SYLLABLE M118 WE;Lo;0;R;;;;;N;;;;;
1E80D;MENDE KIKAKUI SYLLABLE M114 WOO;Lo;0;R;;;;;N;;;;;
1E80E;MENDE KIKAKUI SYLLABLE M045 WO;Lo;0;R;;;;;N;;;;;
1E80F;MENDE KIKAKUI SYLLABLE M194 WUI;Lo;0;R;;;;;N;;;;;
1E810;MENDE KIKAKUI SYLLABLE M143 WEI;Lo;0;R;;;;;N;;;;;
1E811;MENDE KIKAKUI SYLLABLE M061 WVI;Lo;0;R;;;;;N;;;;;
1E812;MENDE KIKAKUI SYLLABLE M049 WVA;Lo;0;R;;;;;N;;;;;
1E813;MENDE KIKAKUI SYLLABLE M139 WVE;Lo;0;R;;;;;N;;;;;
1E814;MENDE KIKAKUI SYLLABLE M007 MIN;Lo;0;R;;;;;N;;;;;
1E815;MENDE KIKAKUI SYLLABLE M008 MAN;Lo;0;R;;;;;N;;;;;
1E816;MENDE KIKAKUI SYLLABLE M009 MUN;Lo;0;R;;;;;N;;;;;
1E817;MENDE KIKAKUI SYLLABLE M059 MEN;Lo;0;R;;;;;N;;;;;
1E818;MENDE KIKAKUI SYLLABLE M094 MON;Lo;0;R;;;;;N;;;;;
1E819;MENDE KIKAKUI SYLLABLE M154 MUAN;Lo;0;R;;;;;N;;;;;
1E81A;MENDE KIKAKUI SYLLABLE M189 MUEN;Lo;0;R;;;;;N;;;;;
1E81B;MENDE KIKAKUI SYLLABLE M010 BI;Lo;0;R;;;;;N;;;;;
1E81C;MENDE KIKAKUI SYLLABLE M011 BA;Lo;0;R;;;;;N;;;;;
1E81D;MENDE KIKAKUI SYLLABLE M012 BU;Lo;0;R;;;;;N;;;;;
1E81E;MENDE KIKAKUI SYLLABLE M150 BEE;Lo;0;R;;;;;N;;;;;
1E81F;MENDE KIKAKUI SYLLABLE M097 BE;Lo;0;R;;;;;N;;;;;
1E820;MENDE KIKAKUI SYLLABLE M103 BOO;Lo;0;R;;;;;N;;;;;
1E821;MENDE KIKAKUI SYLLABLE M138 BO;Lo;0;R;;;;;N;;;;;
1E822;MENDE KIKAKUI SYLLABLE M013 I;Lo;0;R;;;;;N;;;;;
1E823;MENDE KIKAKUI SYLLABLE M014 A;Lo;0;R;;;;;N;;;;;
1E824;MENDE KIKAKUI SYLLABLE M015 U;Lo;0;R;;;;;N;;;;;
1E825;MENDE KIKAKUI SYLLABLE M163 EE;Lo;0;R;;;;;N;;;;;
1E826;MENDE KIKAKUI SYLLABLE M100 E;Lo;0;R;;;;;N;;;;;
1E827;MENDE KIKAKUI SYLLABLE M165 OO;Lo;0;R;;;;;N;;;;;
1E828;MENDE KIKAKUI SYLLABLE M147 O;Lo;0;R;;;;;N;;;;;
1E829;MENDE KIKAKUI SYLLABLE M137 EI;Lo;0;R;;;;;N;;;;;
1E82A;MENDE KIKAKUI SYLLABLE M131 IN;Lo;0;R;;;;;N;;;;;
1E82B;MENDE KIKAKUI SYLLABLE M135 IN;Lo;0;R;;;;;N;;;;;
1E82C;MENDE KIKAKUI SYLLABLE M195 AN;Lo;0;R;;;;;N;;;;;
1E82D;MENDE KIKAKUI SYLLABLE M178 EN;Lo;0;R;;;;;N;;;;;
1E82E;MENDE KIKAKUI SYLLABLE M019 SI;Lo;0;R;;;;;N;;;;;
1E82F;MENDE KIKAKUI SYLLABLE M020 SA;Lo;0;R;;;;;N;;;;;
1E830;MENDE KIKAKUI SYLLABLE M021 SU;Lo;0;R;;;;;N;;;;;
1E831;MENDE KIKAKUI SYLLABLE M162 SEE;Lo;0;R;;;;;N;;;;;
1E832;MENDE KIKAKUI SYLLABLE M116 SE;Lo;0;R;;;;;N;;;;;
1E833;MENDE KIKAKUI SYLLABLE M136 SOO;Lo;0;R;;;;;N;;;;;
1E834;MENDE KIKAKUI SYLLABLE M079 SO;Lo;0;R;;;;;N;;;;;
1E835;MENDE KIKAKUI SYLLABLE M196 SIA;Lo;0;R;;;;;N;;;;;
1E836;MENDE KIKAKUI SYLLABLE M025 LI;Lo;0;R;;;;;N;;;;;
1E837;MENDE KIKAKUI SYLLABLE M026 LA;Lo;0;R;;;;;N;;;;;
1E838;MENDE KIKAKUI SYLLABLE M027 LU;Lo;0;R;;;;;N;;;;;
1E839;MENDE KIKAKUI SYLLABLE M084 LEE;Lo;0;R;;;;;N;;;;;
1E83A;MENDE KIKAKUI SYLLABLE M073 LE;Lo;0;R;;;;;N;;;;;
1E83B;MENDE KIKAKUI SYLLABLE M054 LOO;Lo;0;R;;;;;N;;;;;
1E83C;MENDE KIKAKUI SYLLABLE M153 LO;Lo;0;R;;;;;N;;;;;
1E83D;MENDE KIKAKUI SYLLABLE M110 LONG LE;Lo;0;R;;;;;N;;;;;
1E83E;MENDE KIKAKUI SYLLABLE M016 DI;Lo;0;R;;;;;N;;;;;
1E83F;MENDE KIKAKUI SYLLABLE M017 DA;Lo;0;R;;;;;N;;;;;
1E840;MENDE KIKAKUI SYLLABLE M018 DU;Lo;0;R;;;;;N;;;;;
1E841;MENDE KIKAKUI SYLLABLE M089 DEE;Lo;0;R;;;;;N;;;;;
1E842;MENDE KIKAKUI SYLLABLE M180 DOO;Lo;0;R;;;;;N;;;;;
1E843;MENDE KIKAKUI SYLLABLE M181 DO;Lo;0;R;;;;;N;;;;;
1E844;MENDE KIKAKUI SYLLABLE M022 TI;Lo;0;R;;;;;N;;;;;
1E845;MENDE KIKAKUI SYLLABLE M023 TA;Lo;0;R;;;;;N;;;;;
1E846;MENDE KIKAKUI SYLLABLE M024 TU;Lo;0;R;;;;;N;;;;;
1E847;MENDE KIKAKUI SYLLABLE M091 TEE;Lo;0;R;;;;;N;;;;;
1E848;MENDE KIKAKUI SYLLABLE M055 TE;Lo;0;R;;;;;N;;;;;
1E849;MENDE KIKAKUI SYLLABLE M104 TOO;Lo;0;R;;;;;N;;;;;
1E84A;MENDE KIKAKUI SYLLABLE M069 TO;Lo;0;R;;;;;N;;;;;
1E84B;MENDE KIKAKUI SYLLABLE M028 JI;Lo;0;R;;;;;N;;;;;
1E84C;MENDE KIKAKUI SYLLABLE M029 JA;Lo;0;R;;;;;N;;;;;
1E84D;MENDE KIKAKUI SYLLABLE M030 JU;Lo;0;R;;;;;N;;;;;
1E84E;MENDE KIKAKUI SYLLABLE M157 JEE;Lo;0;R;;;;;N;;;;;
1E84F;MENDE KIKAKUI SYLLABLE M113 JE;Lo;0;R;;;;;N;;;;;
1E850;MENDE KIKAKUI SYLLABLE M160 JOO;Lo;0;R;;;;;N;;;;;
1E851;MENDE KIKAKUI SYLLABLE M063 JO;Lo;0;R;;;;;N;;;;;
1E852;MENDE KIKAKUI SYLLABLE M175 LONG JO;Lo;0;R;;;;;N;;;;;
1E853;MENDE KIKAKUI SYLLABLE M031 YI;Lo;0;R;;;;;N;;;;;
1E854;MENDE KIKAKUI SYLLABLE M032 YA;Lo;0;R;;;;;N;;;;;
1E855;MENDE KIKAKUI SYLLABLE M033 YU;Lo;0;R;;;;;N;;;;;
1E856;MENDE KIKAKUI SYLLABLE M109 YEE;Lo;0;R;;;;;N;;;;;
1E857;MENDE KIKAKUI SYLLABLE M080 YE;Lo;0;R;;;;;N;;;;;
1E858;MENDE KIKAKUI SYLLABLE M141 YOO;Lo;0;R;;;;;N;;;;;
1E859;MENDE KIKAKUI SYLLABLE M121 YO;Lo;0;R;;;;;N;;;;;
1E85A;MENDE KIKAKUI SYLLABLE M034 FI;Lo;0;R;;;;;N;;;;;
1E85B;MENDE KIKAKUI SYLLABLE M035 FA;Lo;0;R;;;;;N;;;;;
1E85C;MENDE KIKAKUI SYLLABLE M036 FU;Lo;0;R;;;;;N;;;;;
1E85D;MENDE KIKAKUI SYLLABLE M078 FEE;Lo;0;R;;;;;N;;;;;
1E85E;MENDE KIKAKUI SYLLABLE M075 FE;Lo;0;R;;;;;N;;;;;
1E85F;MENDE KIKAKUI SYLLABLE M133 FOO;Lo;0;R;;;;;N;;;;;
1E860;MENDE KIKAKUI SYLLABLE M088 FO;Lo;0;R;;;;;N;;;;;
1E861;MENDE KIKAKUI SYLLABLE M197 FUA;Lo;0;R;;;;;N;;;;;
1E862;MENDE KIKAKUI SYLLABLE M101 FAN;Lo;0;R;;;;;N;;;;;
1E863;MENDE KIKAKUI SYLLABLE M037 NIN;Lo;0;R;;;;;N;;;;;
1E864;MENDE KIKAKUI SYLLABLE M038 NAN;Lo;0;R;;;;;N;;;;;
1E865;MENDE KIKAKUI SYLLABLE M039 NUN;Lo;0;R;;;;;N;;;;;
1E866;MENDE KIKAKUI SYLLABLE M117 NEN;Lo;0;R;;;;;N;;;;;
1E867;MENDE KIKAKUI SYLLABLE M169 NON;Lo;0;R;;;;;N;;;;;
1E868;MENDE KIKAKUI SYLLABLE M176 HI;Lo;0;R;;;;;N;;;;;
1E869;MENDE KIKAKUI SYLLABLE M041 HA;Lo;0;R;;;;;N;;;;;
1E86A;MENDE KIKAKUI SYLLABLE M186 HU;Lo;0;R;;;;;N;;;;;
1E86B;MENDE KIKAKUI SYLLABLE M040 HEE;Lo;0;R;;;;;N;;;;;
1E86C;MENDE KIKAKUI SYLLABLE M096 HE;Lo;0;R;;;;;N;;;;;
1E86D;MENDE KIKAKUI SYLLABLE M042 HOO;Lo;0;R;;;;;N;;;;;
1E86E;MENDE KIKAKUI SYLLABLE M140 HO;Lo;0;R;;;;;N;;;;;
1E86F;MENDE KIKAKUI SYLLABLE M083 HEEI;Lo;0;R;;;;;N;;;;;
1E870;MENDE KIKAKUI SYLLABLE M128 HOOU;Lo;0;R;;;;;N;;;;;
1E871;MENDE KIKAKUI SYLLABLE M053 HIN;Lo;0;R;;;;;N;;;;;
1E872;MENDE KIKAKUI SYLLABLE M130 HAN;Lo;0;R;;;;;N;;;;;
1E873;MENDE KIKAKUI SYLLABLE M087 HUN;Lo;0;R;;;;;N;;;;;
1E874;MENDE KIKAKUI SYLLABLE M052 HEN;Lo;0;R;;;;;N;;;;;
1E875;MENDE KIKAKUI SYLLABLE M193 HON;Lo;0;R;;;;;N;;;;;
1E876;MENDE KIKAKUI SYLLABLE M046 HUAN;Lo;0;R;;;;;N;;;;;
1E877;MENDE KIKAKUI SYLLABLE M090 NGGI;Lo;0;R;;;;;N;;;;;
1E878;MENDE KIKAKUI SYLLABLE M043 NGGA;Lo;0;R;;;;;N;;;;;
1E879;MENDE KIKAKUI SYLLABLE M082 NGGU;Lo;0;R;;;;;N;;;;;
1E87A;MENDE KIKAKUI SYLLABLE M115 NGGEE;Lo;0;R;;;;;N;;;;;
1E87B;MENDE KIKAKUI SYLLABLE M146 NGGE;Lo;0;R;;;;;N;;;;;
1E87C;MENDE KIKAKUI SYLLABLE M156 NGGOO;Lo;0;R;;;;;N;;;;;
1E87D;MENDE KIKAKUI SYLLABLE M120 NGGO;Lo;0;R;;;;;N;;;;;
1E87E;MENDE KIKAKUI SYLLABLE M159 NGGAA;Lo;0;R;;;;;N;;;;;
1E87F;MENDE KIKAKUI SYLLABLE M127 NGGUA;Lo;0;R;;;;;N;;;;;
1E880;MENDE KIKAKUI SYLLABLE M086 LONG NGGE;Lo;0;R;;;;;N;;;;;
1E881;MENDE KIKAKUI SYLLABLE M106 LONG NGGOO;Lo;0;R;;;;;N;;;;;
1E882;MENDE KIKAKUI SYLLABLE M183 LONG NGGO;Lo;0;R;;;;;N;;;;;
1E883;MENDE KIKAKUI SYLLABLE M155 GI;Lo;0;R;;;;;N;;;;;
1E884;MENDE KIKAKUI SYLLABLE M111 GA;Lo;0;R;;;;;N;;;;;
1E885;MENDE KIKAKUI SYLLABLE M168 GU;Lo;0;R;;;;;N;;;;;
1E886;MENDE KIKAKUI SYLLABLE M190 GEE;Lo;0;R;;;;;N;;;;;
1E887;MENDE KIKAKUI SYLLABLE M166 GUEI;Lo;0;R;;;;;N;;;;;
1E888;MENDE KIKAKUI SYLLABLE M167 GUAN;Lo;0;R;;;;;N;;;;;
1E889;MENDE KIKAKUI SYLLABLE M184 NGEN;Lo;0;R;;;;;N;;;;;
1E88A;MENDE KIKAKUI SYLLABLE M057 NGON;Lo;0;R;;;;;N;;;;;
1E88B;MENDE KIKAKUI SYLLABLE M177 NGUAN;Lo;0;R;;;;;N;;;;;
1E88C;MENDE KIKAKUI SYLLABLE M068 PI;Lo;0;R;;;;;N;;;;;
1E88D;MENDE KIKAKUI SYLLABLE M099 PA;Lo;0;R;;;;;N;;;;;
1E88E;MENDE KIKAKUI SYLLABLE M050 PU;Lo;0;R;;;;;N;;;;;
1E88F;MENDE KIKAKUI SYLLABLE M081 PEE;Lo;0;R;;;;;N;;;;;
1E890;MENDE KIKAKUI SYLLABLE M051 PE;Lo;0;R;;;;;N;;;;;
1E891;MENDE KIKAKUI SYLLABLE M102 POO;Lo;0;R;;;;;N;;;;;
1E892;MENDE KIKAKUI SYLLABLE M066 PO;Lo;0;R;;;;;N;;;;;
1E893;MENDE KIKAKUI SYLLABLE M145 MBI;Lo;0;R;;;;;N;;;;;
1E894;MENDE KIKAKUI SYLLABLE M062 MBA;Lo;0;R;;;;;N;;;;;
1E895;MENDE KIKAKUI SYLLABLE M122 MBU;Lo;0;R;;;;;N;;;;;
1E896;MENDE KIKAKUI SYLLABLE M047 MBEE;Lo;0;R;;;;;N;;;;;
1E897;MENDE KIKAKUI SYLLABLE M188 MBEE;Lo;0;R;;;;;N;;;;;
1E898;MENDE KIKAKUI SYLLABLE M072 MBE;Lo;0;R;;;;;N;;;;;
1E899;MENDE KIKAKUI SYLLABLE M172 MBOO;Lo;0;R;;;;;N;;;;;
1E89A;MENDE KIKAKUI SYLLABLE M174 MBO;Lo;0;R;;;;;N;;;;;
1E89B;MENDE KIKAKUI SYLLABLE M187 MBUU;Lo;0;R;;;;;N;;;;;
1E89C;MENDE KIKAKUI SYLLABLE M161 LONG MBE;Lo;0;R;;;;;N;;;;;
1E89D;MENDE KIKAKUI SYLLABLE M105 LONG MBOO;Lo;0;R;;;;;N;;;;;
1E89E;MENDE KIKAKUI SYLLABLE M142 LONG MBO;Lo;0;R;;;;;N;;;;;
1E89F;MENDE KIKAKUI SYLLABLE M132 KPI;Lo;0;R;;;;;N;;;;;
1E8A0;MENDE KIKAKUI SYLLABLE M092 KPA;Lo;0;R;;;;;N;;;;;
1E8A1;MENDE KIKAKUI SYLLABLE M074 KPU;Lo;0;R;;;;;N;;;;;
1E8A2;MENDE KIKAKUI SYLLABLE M044 KPEE;Lo;0;R;;;;;N;;;;;
1E8A3;MENDE KIKAKUI SYLLABLE M108 KPE;Lo;0;R;;;;;N;;;;;
1E8A4;MENDE KIKAKUI SYLLABLE M112 KPOO;Lo;0;R;;;;;N;;;;;
1E8A5;MENDE KIKAKUI SYLLABLE M158 KPO;Lo;0;R;;;;;N;;;;;
1E8A6;MENDE KIKAKUI SYLLABLE M124 GBI;Lo;0;R;;;;;N;;;;;
1E8A7;MENDE KIKAKUI SYLLABLE M056 GBA;Lo;0;R;;;;;N;;;;;
1E8A8;MENDE KIKAKUI SYLLABLE M148 GBU;Lo;0;R;;;;;N;;;;;
1E8A9;MENDE KIKAKUI SYLLABLE M093 GBEE;Lo;0;R;;;;;N;;;;;
1E8AA;MENDE KIKAKUI SYLLABLE M107 GBE;Lo;0;R;;;;;N;;;;;
1E8AB;MENDE KIKAKUI SYLLABLE M071 GBOO;Lo;0;R;;;;;N;;;;;
1E8AC;MENDE KIKAKUI SYLLABLE M070 GBO;Lo;0;R;;;;;N;;;;;
1E8AD;MENDE KIKAKUI SYLLABLE M171 RA;Lo;0;R;;;;;N;;;;;
1E8AE;MENDE KIKAKUI SYLLABLE M123 NDI;Lo;0;R;;;;;N;;;;;
1E8AF;MENDE KIKAKUI SYLLABLE M129 NDA;Lo;0;R;;;;;N;;;;;
1E8B0;MENDE KIKAKUI SYLLABLE M125 NDU;Lo;0;R;;;;;N;;;;;
1E8B1;MENDE KIKAKUI SYLLABLE M191 NDEE;Lo;0;R;;;;;N;;;;;
1E8B2;MENDE KIKAKUI SYLLABLE M119 NDE;Lo;0;R;;;;;N;;;;;
1E8B3;MENDE KIKAKUI SYLLABLE M067 NDOO;Lo;0;R;;;;;N;;;;;
1E8B4;MENDE KIKAKUI SYLLABLE M064 NDO;Lo;0;R;;;;;N;;;;;
1E8B5;MENDE KIKAKUI SYLLABLE M152 NJA;Lo;0;R;;;;;N;;;;;
1E8B6;MENDE KIKAKUI SYLLABLE M192 NJU;Lo;0;R;;;;;N;;;;;
1E8B7;MENDE KIKAKUI SYLLABLE M149 NJEE;Lo;0;R;;;;;N;;;;;
1E8B8;MENDE KIKAKUI SYLLABLE M134 NJOO;Lo;0;R;;;;;N;;;;;
1E8B9;MENDE KIKAKUI SYLLABLE M182 VI;Lo;0;R;;;;;N;;;;;
1E8BA;MENDE KIKAKUI SYLLABLE M185 VA;Lo;0;R;;;;;N;;;;;
1E8BB;MENDE KIKAKUI SYLLABLE M151 VU;Lo;0;R;;;;;N;;;;;
1E8BC;MENDE KIKAKUI SYLLABLE M173 VEE;Lo;0;R;;;;;N;;;;;
1E8BD;MENDE KIKAKUI SYLLABLE M085 VE;Lo;0;R;;;;;N;;;;;
1E8BE;MENDE KIKAKUI SYLLABLE M144 VOO;Lo;0;R;;;;;N;;;;;
1E8BF;MENDE KIKAKUI SYLLABLE M077 VO;Lo;0;R;;;;;N;;;;;
1E8C0;MENDE KIKAKUI SYLLABLE M164 NYIN;Lo;0;R;;;;;N;;;;;
1E8C1;MENDE KIKAKUI SYLLABLE M058 NYAN;Lo;0;R;;;;;N;;;;;
1E8C2;MENDE KIKAKUI SYLLABLE M170 NYUN;Lo;0;R;;;;;N;;;;;
1E8C3;MENDE KIKAKUI SYLLABLE M098 NYEN;Lo;0;R;;;;;N;;;;;
1E8C4;MENDE KIKAKUI SYLLABLE M060 NYON;Lo;0;R;;;;;N;;;;;
1E8C7;MENDE KIKAKUI DIGIT ONE;No;0;R;;;;1;N;;;;;
1E8C8;MENDE KIKAKUI DIGIT TWO;No;0;R;;;;2;N;;;;;
1E8C9;MENDE KIKAKUI DIGIT THREE;No;0;R;;;;3;N;;;;;
1E8CA;MENDE KIKAKUI DIGIT FOUR;No;0;R;;;;4;N;;;;;
1E8CB;MENDE KIKAKUI DIGIT FIVE;No;0;R;;;;5;N;;;;;
1E8CC;MENDE KIKAKUI DIGIT SIX;No;0;R;;;;6;N;;;;;
1E8CD;MENDE KIKAKUI DIGIT SEVEN;No;0;R;;;;7;N;;;;;
1E8CE;MENDE KIKAKUI DIGIT EIGHT;No;0;R;;;;8;N;;;;;
1E8CF;MENDE KIKAKUI DIGIT NINE;No;0;R;;;;9;N;;;;;
1E8D0;MENDE KIKAKUI COMBINING NUMBER TEENS;Mn;220;NSM;;;;;N;;;;;
1E8D1;MENDE KIKAKUI COMBINING NUMBER TENS;Mn;220;NSM;;;;;N;;;;;
1E8D2;MENDE KIKAKUI COMBINING NUMBER HUNDREDS;Mn;220;NSM;;;;;N;;;;;
1E8D3;MENDE KIKAKUI COMBINING NUMBER THOUSANDS;Mn;220;NSM;;;;;N;;;;;
1E8D4;MENDE KIKAKUI COMBINING NUMBER TEN THOUSANDS;Mn;220;NSM;;;;;N;;;;;
1E8D5;MENDE KIKAKUI COMBINING NUMBER HUNDRED THOUSANDS;Mn;220;NSM;;;;;N;;;;;
1E8D6;MENDE KIKAKUI COMBINING NUMBER MILLIONS;Mn;220;NSM;;;;;N;;;;;
1E900;ADLAM CAPITAL LETTER ALIF;Lu;0;R;;;;;N;;;;1E922;
1E901;ADLAM CAPITAL LETTER DAALI;Lu;0;R;;;;;N;;;;1E923;
1E902;ADLAM CAPITAL LETTER LAAM;Lu;0;R;;;;;N;;;;1E924;
1E903;ADLAM CAPITAL LETTER MIIM;Lu;0;R;;;;;N;;;;1E925;
1E904;ADLAM CAPITAL LETTER BA;Lu;0;R;;;;;N;;;;1E926;
1E905;ADLAM CAPITAL LETTER SINNYIIYHE;Lu;0;R;;;;;N;;;;1E927;
1E906;ADLAM CAPITAL LETTER PE;Lu;0;R;;;;;N;;;;1E928;
1E907;ADLAM CAPITAL LETTER BHE;Lu;0;R;;;;;N;;;;1E929;
1E908;ADLAM CAPITAL LETTER RA;Lu;0;R;;;;;N;;;;1E92A;
1E909;ADLAM CAPITAL LETTER E;Lu;0;R;;;;;N;;;;1E92B;
1E90A;ADLAM CAPITAL LETTER FA;Lu;0;R;;;;;N;;;;1E92C;
1E90B;ADLAM CAPITAL LETTER I;Lu;0;R;;;;;N;;;;1E92D;
1E90C;ADLAM CAPITAL LETTER O;Lu;0;R;;;;;N;;;;1E92E;
1E90D;ADLAM CAPITAL LETTER DHA;Lu;0;R;;;;;N;;;;1E92F;
1E90E;ADLAM CAPITAL LETTER YHE;Lu;0;R;;;;;N;;;;1E930;
1E90F;ADLAM CAPITAL LETTER WAW;Lu;0;R;;;;;N;;;;1E931;
1E910;ADLAM CAPITAL LETTER NUN;Lu;0;R;;;;;N;;;;1E932;
1E911;ADLAM CAPITAL LETTER KAF;Lu;0;R;;;;;N;;;;1E933;
1E912;ADLAM CAPITAL LETTER YA;Lu;0;R;;;;;N;;;;1E934;
1E913;ADLAM CAPITAL LETTER U;Lu;0;R;;;;;N;;;;1E935;
1E914;ADLAM CAPITAL LETTER JIIM;Lu;0;R;;;;;N;;;;1E936;
1E915;ADLAM CAPITAL LETTER CHI;Lu;0;R;;;;;N;;;;1E937;
1E916;ADLAM CAPITAL LETTER HA;Lu;0;R;;;;;N;;;;1E938;
1E917;ADLAM CAPITAL LETTER QAAF;Lu;0;R;;;;;N;;;;1E939;
1E918;ADLAM CAPITAL LETTER GA;Lu;0;R;;;;;N;;;;1E93A;
1E919;ADLAM CAPITAL LETTER NYA;Lu;0;R;;;;;N;;;;1E93B;
1E91A;ADLAM CAPITAL LETTER TU;Lu;0;R;;;;;N;;;;1E93C;
1E91B;ADLAM CAPITAL LETTER NHA;Lu;0;R;;;;;N;;;;1E93D;
1E91C;ADLAM CAPITAL LETTER VA;Lu;0;R;;;;;N;;;;1E93E;
1E91D;ADLAM CAPITAL LETTER KHA;Lu;0;R;;;;;N;;;;1E93F;
1E91E;ADLAM CAPITAL LETTER GBE;Lu;0;R;;;;;N;;;;1E940;
1E91F;ADLAM CAPITAL LETTER ZAL;Lu;0;R;;;;;N;;;;1E941;
1E920;ADLAM CAPITAL LETTER KPO;Lu;0;R;;;;;N;;;;1E942;
1E921;ADLAM CAPITAL LETTER SHA;Lu;0;R;;;;;N;;;;1E943;
1E922;ADLAM SMALL LETTER ALIF;Ll;0;R;;;;;N;;;1E900;;1E900
1E923;ADLAM SMALL LETTER DAALI;Ll;0;R;;;;;N;;;1E901;;1E901
1E924;ADLAM SMALL LETTER LAAM;Ll;0;R;;;;;N;;;1E902;;1E902
1E925;ADLAM SMALL LETTER MIIM;Ll;0;R;;;;;N;;;1E903;;1E903
1E926;ADLAM SMALL LETTER BA;Ll;0;R;;;;;N;;;1E904;;1E904
1E927;ADLAM SMALL LETTER SINNYIIYHE;Ll;0;R;;;;;N;;;1E905;;1E905
1E928;ADLAM SMALL LETTER PE;Ll;0;R;;;;;N;;;1E906;;1E906
1E929;ADLAM SMALL LETTER BHE;Ll;0;R;;;;;N;;;1E907;;1E907
1E92A;ADLAM SMALL LETTER RA;Ll;0;R;;;;;N;;;1E908;;1E908
1E92B;ADLAM SMALL LETTER E;Ll;0;R;;;;;N;;;1E909;;1E909
1E92C;ADLAM SMALL LETTER FA;Ll;0;R;;;;;N;;;1E90A;;1E90A
1E92D;ADLAM SMALL LETTER I;Ll;0;R;;;;;N;;;1E90B;;1E90B
1E92E;ADLAM SMALL LETTER O;Ll;0;R;;;;;N;;;1E90C;;1E90C
1E92F;ADLAM SMALL LETTER DHA;Ll;0;R;;;;;N;;;1E90D;;1E90D
1E930;ADLAM SMALL LETTER YHE;Ll;0;R;;;;;N;;;1E90E;;1E90E
1E931;ADLAM SMALL LETTER WAW;Ll;0;R;;;;;N;;;1E90F;;1E90F
1E932;ADLAM SMALL LETTER NUN;Ll;0;R;;;;;N;;;1E910;;1E910
1E933;ADLAM SMALL LETTER KAF;Ll;0;R;;;;;N;;;1E911;;1E911
1E934;ADLAM SMALL LETTER YA;Ll;0;R;;;;;N;;;1E912;;1E912
1E935;ADLAM SMALL LETTER U;Ll;0;R;;;;;N;;;1E913;;1E913
1E936;ADLAM SMALL LETTER JIIM;Ll;0;R;;;;;N;;;1E914;;1E914
1E937;ADLAM SMALL LETTER CHI;Ll;0;R;;;;;N;;;1E915;;1E915
1E938;ADLAM SMALL LETTER HA;Ll;0;R;;;;;N;;;1E916;;1E916
1E939;ADLAM SMALL LETTER QAAF;Ll;0;R;;;;;N;;;1E917;;1E917
1E93A;ADLAM SMALL LETTER GA;Ll;0;R;;;;;N;;;1E918;;1E918
1E93B;ADLAM SMALL LETTER NYA;Ll;0;R;;;;;N;;;1E919;;1E919
1E93C;ADLAM SMALL LETTER TU;Ll;0;R;;;;;N;;;1E91A;;1E91A
1E93D;ADLAM SMALL LETTER NHA;Ll;0;R;;;;;N;;;1E91B;;1E91B
1E93E;ADLAM SMALL LETTER VA;Ll;0;R;;;;;N;;;1E91C;;1E91C
1E93F;ADLAM SMALL LETTER KHA;Ll;0;R;;;;;N;;;1E91D;;1E91D
1E940;ADLAM SMALL LETTER GBE;Ll;0;R;;;;;N;;;1E91E;;1E91E
1E941;ADLAM SMALL LETTER ZAL;Ll;0;R;;;;;N;;;1E91F;;1E91F
1E942;ADLAM SMALL LETTER KPO;Ll;0;R;;;;;N;;;1E920;;1E920
1E943;ADLAM SMALL LETTER SHA;Ll;0;R;;;;;N;;;1E921;;1E921
1E944;ADLAM ALIF LENGTHENER;Mn;230;NSM;;;;;N;;;;;
1E945;ADLAM VOWEL LENGTHENER;Mn;230;NSM;;;;;N;;;;;
1E946;ADLAM GEMINATION MARK;Mn;230;NSM;;;;;N;;;;;
1E947;ADLAM HAMZA;Mn;230;NSM;;;;;N;;;;;
1E948;ADLAM CONSONANT MODIFIER;Mn;230;NSM;;;;;N;;;;;
1E949;ADLAM GEMINATE CONSONANT MODIFIER;Mn;230;NSM;;;;;N;;;;;
1E94A;ADLAM NUKTA;Mn;7;NSM;;;;;N;;;;;
1E94B;ADLAM NASALIZATION MARK;Lm;0;R;;;;;N;;;;;
1E950;ADLAM DIGIT ZERO;Nd;0;R;;0;0;0;N;;;;;
1E951;ADLAM DIGIT ONE;Nd;0;R;;1;1;1;N;;;;;
1E952;ADLAM DIGIT TWO;Nd;0;R;;2;2;2;N;;;;;
1E953;ADLAM DIGIT THREE;Nd;0;R;;3;3;3;N;;;;;
1E954;ADLAM DIGIT FOUR;Nd;0;R;;4;4;4;N;;;;;
1E955;ADLAM DIGIT FIVE;Nd;0;R;;5;5;5;N;;;;;
1E956;ADLAM DIGIT SIX;Nd;0;R;;6;6;6;N;;;;;
1E957;ADLAM DIGIT SEVEN;Nd;0;R;;7;7;7;N;;;;;
1E958;ADLAM DIGIT EIGHT;Nd;0;R;;8;8;8;N;;;;;
1E959;ADLAM DIGIT NINE;Nd;0;R;;9;9;9;N;;;;;
1E95E;ADLAM INITIAL EXCLAMATION MARK;Po;0;R;;;;;N;;;;;
1E95F;ADLAM INITIAL QUESTION MARK;Po;0;R;;;;;N;;;;;
1EC71;INDIC SIYAQ NUMBER ONE;No;0;AL;;;;1;N;;;;;
1EC72;INDIC SIYAQ NUMBER TWO;No;0;AL;;;;2;N;;;;;
1EC73;INDIC SIYAQ NUMBER THREE;No;0;AL;;;;3;N;;;;;
1EC74;INDIC SIYAQ NUMBER FOUR;No;0;AL;;;;4;N;;;;;
1EC75;INDIC SIYAQ NUMBER FIVE;No;0;AL;;;;5;N;;;;;
1EC76;INDIC SIYAQ NUMBER SIX;No;0;AL;;;;6;N;;;;;
1EC77;INDIC SIYAQ NUMBER SEVEN;No;0;AL;;;;7;N;;;;;
1EC78;INDIC SIYAQ NUMBER EIGHT;No;0;AL;;;;8;N;;;;;
1EC79;INDIC SIYAQ NUMBER NINE;No;0;AL;;;;9;N;;;;;
1EC7A;INDIC SIYAQ NUMBER TEN;No;0;AL;;;;10;N;;;;;
1EC7B;INDIC SIYAQ NUMBER TWENTY;No;0;AL;;;;20;N;;;;;
1EC7C;INDIC SIYAQ NUMBER THIRTY;No;0;AL;;;;30;N;;;;;
1EC7D;INDIC SIYAQ NUMBER FORTY;No;0;AL;;;;40;N;;;;;
1EC7E;INDIC SIYAQ NUMBER FIFTY;No;0;AL;;;;50;N;;;;;
1EC7F;INDIC SIYAQ NUMBER SIXTY;No;0;AL;;;;60;N;;;;;
1EC80;INDIC SIYAQ NUMBER SEVENTY;No;0;AL;;;;70;N;;;;;
1EC81;INDIC SIYAQ NUMBER EIGHTY;No;0;AL;;;;80;N;;;;;
1EC82;INDIC SIYAQ NUMBER NINETY;No;0;AL;;;;90;N;;;;;
1EC83;INDIC SIYAQ NUMBER ONE HUNDRED;No;0;AL;;;;100;N;;;;;
1EC84;INDIC SIYAQ NUMBER TWO HUNDRED;No;0;AL;;;;200;N;;;;;
1EC85;INDIC SIYAQ NUMBER THREE HUNDRED;No;0;AL;;;;300;N;;;;;
1EC86;INDIC SIYAQ NUMBER FOUR HUNDRED;No;0;AL;;;;400;N;;;;;
1EC87;INDIC SIYAQ NUMBER FIVE HUNDRED;No;0;AL;;;;500;N;;;;;
1EC88;INDIC SIYAQ NUMBER SIX HUNDRED;No;0;AL;;;;600;N;;;;;
1EC89;INDIC SIYAQ NUMBER SEVEN HUNDRED;No;0;AL;;;;700;N;;;;;
1EC8A;INDIC SIYAQ NUMBER EIGHT HUNDRED;No;0;AL;;;;800;N;;;;;
1EC8B;INDIC SIYAQ NUMBER NINE HUNDRED;No;0;AL;;;;900;N;;;;;
1EC8C;INDIC SIYAQ NUMBER ONE THOUSAND;No;0;AL;;;;1000;N;;;;;
1EC8D;INDIC SIYAQ NUMBER TWO THOUSAND;No;0;AL;;;;2000;N;;;;;
1EC8E;INDIC SIYAQ NUMBER THREE THOUSAND;No;0;AL;;;;3000;N;;;;;
1EC8F;INDIC SIYAQ NUMBER FOUR THOUSAND;No;0;AL;;;;4000;N;;;;;
1EC90;INDIC SIYAQ NUMBER FIVE THOUSAND;No;0;AL;;;;5000;N;;;;;
1EC91;INDIC SIYAQ NUMBER SIX THOUSAND;No;0;AL;;;;6000;N;;;;;
1EC92;INDIC SIYAQ NUMBER SEVEN THOUSAND;No;0;AL;;;;7000;N;;;;;
1EC93;INDIC SIYAQ NUMBER EIGHT THOUSAND;No;0;AL;;;;8000;N;;;;;
1EC94;INDIC SIYAQ NUMBER NINE THOUSAND;No;0;AL;;;;9000;N;;;;;
1EC95;INDIC SIYAQ NUMBER TEN THOUSAND;No;0;AL;;;;10000;N;;;;;
1EC96;INDIC SIYAQ NUMBER TWENTY THOUSAND;No;0;AL;;;;20000;N;;;;;
1EC97;INDIC SIYAQ NUMBER THIRTY THOUSAND;No;0;AL;;;;30000;N;;;;;
1EC98;INDIC SIYAQ NUMBER FORTY THOUSAND;No;0;AL;;;;40000;N;;;;;
1EC99;INDIC SIYAQ NUMBER FIFTY THOUSAND;No;0;AL;;;;50000;N;;;;;
1EC9A;INDIC SIYAQ NUMBER SIXTY THOUSAND;No;0;AL;;;;60000;N;;;;;
1EC9B;INDIC SIYAQ NUMBER SEVENTY THOUSAND;No;0;AL;;;;70000;N;;;;;
1EC9C;INDIC SIYAQ NUMBER EIGHTY THOUSAND;No;0;AL;;;;80000;N;;;;;
1EC9D;INDIC SIYAQ NUMBER NINETY THOUSAND;No;0;AL;;;;90000;N;;;;;
1EC9E;INDIC SIYAQ NUMBER LAKH;No;0;AL;;;;100000;N;;;;;
1EC9F;INDIC SIYAQ NUMBER LAKHAN;No;0;AL;;;;200000;N;;;;;
1ECA0;INDIC SIYAQ LAKH MARK;No;0;AL;;;;100000;N;;;;;
1ECA1;INDIC SIYAQ NUMBER KAROR;No;0;AL;;;;10000000;N;;;;;
1ECA2;INDIC SIYAQ NUMBER KARORAN;No;0;AL;;;;20000000;N;;;;;
1ECA3;INDIC SIYAQ NUMBER PREFIXED ONE;No;0;AL;;;;1;N;;;;;
1ECA4;INDIC SIYAQ NUMBER PREFIXED TWO;No;0;AL;;;;2;N;;;;;
1ECA5;INDIC SIYAQ NUMBER PREFIXED THREE;No;0;AL;;;;3;N;;;;;
1ECA6;INDIC SIYAQ NUMBER PREFIXED FOUR;No;0;AL;;;;4;N;;;;;
1ECA7;INDIC SIYAQ NUMBER PREFIXED FIVE;No;0;AL;;;;5;N;;;;;
1ECA8;INDIC SIYAQ NUMBER PREFIXED SIX;No;0;AL;;;;6;N;;;;;
1ECA9;INDIC SIYAQ NUMBER PREFIXED SEVEN;No;0;AL;;;;7;N;;;;;
1ECAA;INDIC SIYAQ NUMBER PREFIXED EIGHT;No;0;AL;;;;8;N;;;;;
1ECAB;INDIC SIYAQ NUMBER PREFIXED NINE;No;0;AL;;;;9;N;;;;;
1ECAC;INDIC SIYAQ PLACEHOLDER;So;0;AL;;;;;N;;;;;
1ECAD;INDIC SIYAQ FRACTION ONE QUARTER;No;0;AL;;;;1/4;N;;;;;
1ECAE;INDIC SIYAQ FRACTION ONE HALF;No;0;AL;;;;1/2;N;;;;;
1ECAF;INDIC SIYAQ FRACTION THREE QUARTERS;No;0;AL;;;;3/4;N;;;;;
1ECB0;INDIC SIYAQ RUPEE MARK;Sc;0;AL;;;;;N;;;;;
1ECB1;INDIC SIYAQ NUMBER ALTERNATE ONE;No;0;AL;;;;1;N;;;;;
1ECB2;INDIC SIYAQ NUMBER ALTERNATE TWO;No;0;AL;;;;2;N;;;;;
1ECB3;INDIC SIYAQ NUMBER ALTERNATE TEN THOUSAND;No;0;AL;;;;10000;N;;;;;
1ECB4;INDIC SIYAQ ALTERNATE LAKH MARK;No;0;AL;;;;100000;N;;;;;
1ED01;OTTOMAN SIYAQ NUMBER ONE;No;0;AL;;;;1;N;;;;;
1ED02;OTTOMAN SIYAQ NUMBER TWO;No;0;AL;;;;2;N;;;;;
1ED03;OTTOMAN SIYAQ NUMBER THREE;No;0;AL;;;;3;N;;;;;
1ED04;OTTOMAN SIYAQ NUMBER FOUR;No;0;AL;;;;4;N;;;;;
1ED05;OTTOMAN SIYAQ NUMBER FIVE;No;0;AL;;;;5;N;;;;;
1ED06;OTTOMAN SIYAQ NUMBER SIX;No;0;AL;;;;6;N;;;;;
1ED07;OTTOMAN SIYAQ NUMBER SEVEN;No;0;AL;;;;7;N;;;;;
1ED08;OTTOMAN SIYAQ NUMBER EIGHT;No;0;AL;;;;8;N;;;;;
1ED09;OTTOMAN SIYAQ NUMBER NINE;No;0;AL;;;;9;N;;;;;
1ED0A;OTTOMAN SIYAQ NUMBER TEN;No;0;AL;;;;10;N;;;;;
1ED0B;OTTOMAN SIYAQ NUMBER TWENTY;No;0;AL;;;;20;N;;;;;
1ED0C;OTTOMAN SIYAQ NUMBER THIRTY;No;0;AL;;;;30;N;;;;;
1ED0D;OTTOMAN SIYAQ NUMBER FORTY;No;0;AL;;;;40;N;;;;;
1ED0E;OTTOMAN SIYAQ NUMBER FIFTY;No;0;AL;;;;50;N;;;;;
1ED0F;OTTOMAN SIYAQ NUMBER SIXTY;No;0;AL;;;;60;N;;;;;
1ED10;OTTOMAN SIYAQ NUMBER SEVENTY;No;0;AL;;;;70;N;;;;;
1ED11;OTTOMAN SIYAQ NUMBER EIGHTY;No;0;AL;;;;80;N;;;;;
1ED12;OTTOMAN SIYAQ NUMBER NINETY;No;0;AL;;;;90;N;;;;;
1ED13;OTTOMAN SIYAQ NUMBER ONE HUNDRED;No;0;AL;;;;100;N;;;;;
1ED14;OTTOMAN SIYAQ NUMBER TWO HUNDRED;No;0;AL;;;;200;N;;;;;
1ED15;OTTOMAN SIYAQ NUMBER THREE HUNDRED;No;0;AL;;;;300;N;;;;;
1ED16;OTTOMAN SIYAQ NUMBER FOUR HUNDRED;No;0;AL;;;;400;N;;;;;
1ED17;OTTOMAN SIYAQ NUMBER FIVE HUNDRED;No;0;AL;;;;500;N;;;;;
1ED18;OTTOMAN SIYAQ NUMBER SIX HUNDRED;No;0;AL;;;;600;N;;;;;
1ED19;OTTOMAN SIYAQ NUMBER SEVEN HUNDRED;No;0;AL;;;;700;N;;;;;
1ED1A;OTTOMAN SIYAQ NUMBER EIGHT HUNDRED;No;0;AL;;;;800;N;;;;;
1ED1B;OTTOMAN SIYAQ NUMBER NINE HUNDRED;No;0;AL;;;;900;N;;;;;
1ED1C;OTTOMAN SIYAQ NUMBER ONE THOUSAND;No;0;AL;;;;1000;N;;;;;
1ED1D;OTTOMAN SIYAQ NUMBER TWO THOUSAND;No;0;AL;;;;2000;N;;;;;
1ED1E;OTTOMAN SIYAQ NUMBER THREE THOUSAND;No;0;AL;;;;3000;N;;;;;
1ED1F;OTTOMAN SIYAQ NUMBER FOUR THOUSAND;No;0;AL;;;;4000;N;;;;;
1ED20;OTTOMAN SIYAQ NUMBER FIVE THOUSAND;No;0;AL;;;;5000;N;;;;;
1ED21;OTTOMAN SIYAQ NUMBER SIX THOUSAND;No;0;AL;;;;6000;N;;;;;
1ED22;OTTOMAN SIYAQ NUMBER SEVEN THOUSAND;No;0;AL;;;;7000;N;;;;;
1ED23;OTTOMAN SIYAQ NUMBER EIGHT THOUSAND;No;0;AL;;;;8000;N;;;;;
1ED24;OTTOMAN SIYAQ NUMBER NINE THOUSAND;No;0;AL;;;;9000;N;;;;;
1ED25;OTTOMAN SIYAQ NUMBER TEN THOUSAND;No;0;AL;;;;10000;N;;;;;
1ED26;OTTOMAN SIYAQ NUMBER TWENTY THOUSAND;No;0;AL;;;;20000;N;;;;;
1ED27;OTTOMAN SIYAQ NUMBER THIRTY THOUSAND;No;0;AL;;;;30000;N;;;;;
1ED28;OTTOMAN SIYAQ NUMBER FORTY THOUSAND;No;0;AL;;;;40000;N;;;;;
1ED29;OTTOMAN SIYAQ NUMBER FIFTY THOUSAND;No;0;AL;;;;50000;N;;;;;
1ED2A;OTTOMAN SIYAQ NUMBER SIXTY THOUSAND;No;0;AL;;;;60000;N;;;;;
1ED2B;OTTOMAN SIYAQ NUMBER SEVENTY THOUSAND;No;0;AL;;;;70000;N;;;;;
1ED2C;OTTOMAN SIYAQ NUMBER EIGHTY THOUSAND;No;0;AL;;;;80000;N;;;;;
1ED2D;OTTOMAN SIYAQ NUMBER NINETY THOUSAND;No;0;AL;;;;90000;N;;;;;
1ED2E;OTTOMAN SIYAQ MARRATAN;So;0;AL;;;;;N;;;;;
1ED2F;OTTOMAN SIYAQ ALTERNATE NUMBER TWO;No;0;AL;;;;2;N;;;;;
1ED30;OTTOMAN SIYAQ ALTERNATE NUMBER THREE;No;0;AL;;;;3;N;;;;;
1ED31;OTTOMAN SIYAQ ALTERNATE NUMBER FOUR;No;0;AL;;;;4;N;;;;;
1ED32;OTTOMAN SIYAQ ALTERNATE NUMBER FIVE;No;0;AL;;;;5;N;;;;;
1ED33;OTTOMAN SIYAQ ALTERNATE NUMBER SIX;No;0;AL;;;;6;N;;;;;
1ED34;OTTOMAN SIYAQ ALTERNATE NUMBER SEVEN;No;0;AL;;;;7;N;;;;;
1ED35;OTTOMAN SIYAQ ALTERNATE NUMBER EIGHT;No;0;AL;;;;8;N;;;;;
1ED36;OTTOMAN SIYAQ ALTERNATE NUMBER NINE;No;0;AL;;;;9;N;;;;;
1ED37;OTTOMAN SIYAQ ALTERNATE NUMBER TEN;No;0;AL;;;;10;N;;;;;
1ED38;OTTOMAN SIYAQ ALTERNATE NUMBER FOUR HUNDRED;No;0;AL;;;;400;N;;;;;
1ED39;OTTOMAN SIYAQ ALTERNATE NUMBER SIX HUNDRED;No;0;AL;;;;600;N;;;;;
1ED3A;OTTOMAN SIYAQ ALTERNATE NUMBER TWO THOUSAND;No;0;AL;;;;2000;N;;;;;
1ED3B;OTTOMAN SIYAQ ALTERNATE NUMBER TEN THOUSAND;No;0;AL;;;;10000;N;;;;;
1ED3C;OTTOMAN SIYAQ FRACTION ONE HALF;No;0;AL;;;;1/2;N;;;;;
1ED3D;OTTOMAN SIYAQ FRACTION ONE SIXTH;No;0;AL;;;;1/6;N;;;;;
1EE00;ARABIC MATHEMATICAL ALEF;Lo;0;AL;<font> 0627;;;;N;;;;;
1EE01;ARABIC MATHEMATICAL BEH;Lo;0;AL;<font> 0628;;;;N;;;;;
1EE02;ARABIC MATHEMATICAL JEEM;Lo;0;AL;<font> 062C;;;;N;;;;;
1EE03;ARABIC MATHEMATICAL DAL;Lo;0;AL;<font> 062F;;;;N;;;;;
1EE05;ARABIC MATHEMATICAL WAW;Lo;0;AL;<font> 0648;;;;N;;;;;
1EE06;ARABIC MATHEMATICAL ZAIN;Lo;0;AL;<font> 0632;;;;N;;;;;
1EE07;ARABIC MATHEMATICAL HAH;Lo;0;AL;<font> 062D;;;;N;;;;;
1EE08;ARABIC MATHEMATICAL TAH;Lo;0;AL;<font> 0637;;;;N;;;;;
1EE09;ARABIC MATHEMATICAL YEH;Lo;0;AL;<font> 064A;;;;N;;;;;
1EE0A;ARABIC MATHEMATICAL KAF;Lo;0;AL;<font> 0643;;;;N;;;;;
1EE0B;ARABIC MATHEMATICAL LAM;Lo;0;AL;<font> 0644;;;;N;;;;;
1EE0C;ARABIC MATHEMATICAL MEEM;Lo;0;AL;<font> 0645;;;;N;;;;;
1EE0D;ARABIC MATHEMATICAL NOON;Lo;0;AL;<font> 0646;;;;N;;;;;
1EE0E;ARABIC MATHEMATICAL SEEN;Lo;0;AL;<font> 0633;;;;N;;;;;
1EE0F;ARABIC MATHEMATICAL AIN;Lo;0;AL;<font> 0639;;;;N;;;;;
1EE10;ARABIC MATHEMATICAL FEH;Lo;0;AL;<font> 0641;;;;N;;;;;
1EE11;ARABIC MATHEMATICAL SAD;Lo;0;AL;<font> 0635;;;;N;;;;;
1EE12;ARABIC MATHEMATICAL QAF;Lo;0;AL;<font> 0642;;;;N;;;;;
1EE13;ARABIC MATHEMATICAL REH;Lo;0;AL;<font> 0631;;;;N;;;;;
1EE14;ARABIC MATHEMATICAL SHEEN;Lo;0;AL;<font> 0634;;;;N;;;;;
1EE15;ARABIC MATHEMATICAL TEH;Lo;0;AL;<font> 062A;;;;N;;;;;
1EE16;ARABIC MATHEMATICAL THEH;Lo;0;AL;<font> 062B;;;;N;;;;;
1EE17;ARABIC MATHEMATICAL KHAH;Lo;0;AL;<font> 062E;;;;N;;;;;
1EE18;ARABIC MATHEMATICAL THAL;Lo;0;AL;<font> 0630;;;;N;;;;;
1EE19;ARABIC MATHEMATICAL DAD;Lo;0;AL;<font> 0636;;;;N;;;;;
1EE1A;ARABIC MATHEMATICAL ZAH;Lo;0;AL;<font> 0638;;;;N;;;;;
1EE1B;ARABIC MATHEMATICAL GHAIN;Lo;0;AL;<font> 063A;;;;N;;;;;
1EE1C;ARABIC MATHEMATICAL DOTLESS BEH;Lo;0;AL;<font> 066E;;;;N;;;;;
1EE1D;ARABIC MATHEMATICAL DOTLESS NOON;Lo;0;AL;<font> 06BA;;;;N;;;;;
1EE1E;ARABIC MATHEMATICAL DOTLESS FEH;Lo;0;AL;<font> 06A1;;;;N;;;;;
1EE1F;ARABIC MATHEMATICAL DOTLESS QAF;Lo;0;AL;<font> 066F;;;;N;;;;;
1EE21;ARABIC MATHEMATICAL INITIAL BEH;Lo;0;AL;<font> 0628;;;;N;;;;;
1EE22;ARABIC MATHEMATICAL INITIAL JEEM;Lo;0;AL;<font> 062C;;;;N;;;;;
1EE24;ARABIC MATHEMATICAL INITIAL HEH;Lo;0;AL;<font> 0647;;;;N;;;;;
1EE27;ARABIC MATHEMATICAL INITIAL HAH;Lo;0;AL;<font> 062D;;;;N;;;;;
1EE29;ARABIC MATHEMATICAL INITIAL YEH;Lo;0;AL;<font> 064A;;;;N;;;;;
1EE2A;ARABIC MATHEMATICAL INITIAL KAF;Lo;0;AL;<font> 0643;;;;N;;;;;
1EE2B;ARABIC MATHEMATICAL INITIAL LAM;Lo;0;AL;<font> 0644;;;;N;;;;;
1EE2C;ARABIC MATHEMATICAL INITIAL MEEM;Lo;0;AL;<font> 0645;;;;N;;;;;
1EE2D;ARABIC MATHEMATICAL INITIAL NOON;Lo;0;AL;<font> 0646;;;;N;;;;;
1EE2E;ARABIC MATHEMATICAL INITIAL SEEN;Lo;0;AL;<font> 0633;;;;N;;;;;
1EE2F;ARABIC MATHEMATICAL INITIAL AIN;Lo;0;AL;<font> 0639;;;;N;;;;;
1EE30;ARABIC MATHEMATICAL INITIAL FEH;Lo;0;AL;<font> 0641;;;;N;;;;;
1EE31;ARABIC MATHEMATICAL INITIAL SAD;Lo;0;AL;<font> 0635;;;;N;;;;;
1EE32;ARABIC MATHEMATICAL INITIAL QAF;Lo;0;AL;<font> 0642;;;;N;;;;;
1EE34;ARABIC MATHEMATICAL INITIAL SHEEN;Lo;0;AL;<font> 0634;;;;N;;;;;
1EE35;ARABIC MATHEMATICAL INITIAL TEH;Lo;0;AL;<font> 062A;;;;N;;;;;
1EE36;ARABIC MATHEMATICAL INITIAL THEH;Lo;0;AL;<font> 062B;;;;N;;;;;
1EE37;ARABIC MATHEMATICAL INITIAL KHAH;Lo;0;AL;<font> 062E;;;;N;;;;;
1EE39;ARABIC MATHEMATICAL INITIAL DAD;Lo;0;AL;<font> 0636;;;;N;;;;;
1EE3B;ARABIC MATHEMATICAL INITIAL GHAIN;Lo;0;AL;<font> 063A;;;;N;;;;;
1EE42;ARABIC MATHEMATICAL TAILED JEEM;Lo;0;AL;<font> 062C;;;;N;;;;;
1EE47;ARABIC MATHEMATICAL TAILED HAH;Lo;0;AL;<font> 062D;;;;N;;;;;
1EE49;ARABIC MATHEMATICAL TAILED YEH;Lo;0;AL;<font> 064A;;;;N;;;;;
1EE4B;ARABIC MATHEMATICAL TAILED LAM;Lo;0;AL;<font> 0644;;;;N;;;;;
1EE4D;ARABIC MATHEMATICAL TAILED NOON;Lo;0;AL;<font> 0646;;;;N;;;;;
1EE4E;ARABIC MATHEMATICAL TAILED SEEN;Lo;0;AL;<font> 0633;;;;N;;;;;
1EE4F;ARABIC MATHEMATICAL TAILED AIN;Lo;0;AL;<font> 0639;;;;N;;;;;
1EE51;ARABIC MATHEMATICAL TAILED SAD;Lo;0;AL;<font> 0635;;;;N;;;;;
1EE52;ARABIC MATHEMATICAL TAILED QAF;Lo;0;AL;<font> 0642;;;;N;;;;;
1EE54;ARABIC MATHEMATICAL TAILED SHEEN;Lo;0;AL;<font> 0634;;;;N;;;;;
1EE57;ARABIC MATHEMATICAL TAILED KHAH;Lo;0;AL;<font> 062E;;;;N;;;;;
1EE59;ARABIC MATHEMATICAL TAILED DAD;Lo;0;AL;<font> 0636;;;;N;;;;;
1EE5B;ARABIC MATHEMATICAL TAILED GHAIN;Lo;0;AL;<font> 063A;;;;N;;;;;
1EE5D;ARABIC MATHEMATICAL TAILED DOTLESS NOON;Lo;0;AL;<font> 06BA;;;;N;;;;;
1EE5F;ARABIC MATHEMATICAL TAILED DOTLESS QAF;Lo;0;AL;<font> 066F;;;;N;;;;;
1EE61;ARABIC MATHEMATICAL STRETCHED BEH;Lo;0;AL;<font> 0628;;;;N;;;;;
1EE62;ARABIC MATHEMATICAL STRETCHED JEEM;Lo;0;AL;<font> 062C;;;;N;;;;;
1EE64;ARABIC MATHEMATICAL STRETCHED HEH;Lo;0;AL;<font> 0647;;;;N;;;;;
1EE67;ARABIC MATHEMATICAL STRETCHED HAH;Lo;0;AL;<font> 062D;;;;N;;;;;
1EE68;ARABIC MATHEMATICAL STRETCHED TAH;Lo;0;AL;<font> 0637;;;;N;;;;;
1EE69;ARABIC MATHEMATICAL STRETCHED YEH;Lo;0;AL;<font> 064A;;;;N;;;;;
1EE6A;ARABIC MATHEMATICAL STRETCHED KAF;Lo;0;AL;<font> 0643;;;;N;;;;;
1EE6C;ARABIC MATHEMATICAL STRETCHED MEEM;Lo;0;AL;<font> 0645;;;;N;;;;;
1EE6D;ARABIC MATHEMATICAL STRETCHED NOON;Lo;0;AL;<font> 0646;;;;N;;;;;
1EE6E;ARABIC MATHEMATICAL STRETCHED SEEN;Lo;0;AL;<font> 0633;;;;N;;;;;
1EE6F;ARABIC MATHEMATICAL STRETCHED AIN;Lo;0;AL;<font> 0639;;;;N;;;;;
1EE70;ARABIC MATHEMATICAL STRETCHED FEH;Lo;0;AL;<font> 0641;;;;N;;;;;
1EE71;ARABIC MATHEMATICAL STRETCHED SAD;Lo;0;AL;<font> 0635;;;;N;;;;;
1EE72;ARABIC MATHEMATICAL STRETCHED QAF;Lo;0;AL;<font> 0642;;;;N;;;;;
1EE74;ARABIC MATHEMATICAL STRETCHED SHEEN;Lo;0;AL;<font> 0634;;;;N;;;;;
1EE75;ARABIC MATHEMATICAL STRETCHED TEH;Lo;0;AL;<font> 062A;;;;N;;;;;
1EE76;ARABIC MATHEMATICAL STRETCHED THEH;Lo;0;AL;<font> 062B;;;;N;;;;;
1EE77;ARABIC MATHEMATICAL STRETCHED KHAH;Lo;0;AL;<font> 062E;;;;N;;;;;
1EE79;ARABIC MATHEMATICAL STRETCHED DAD;Lo;0;AL;<font> 0636;;;;N;;;;;
1EE7A;ARABIC MATHEMATICAL STRETCHED ZAH;Lo;0;AL;<font> 0638;;;;N;;;;;
1EE7B;ARABIC MATHEMATICAL STRETCHED GHAIN;Lo;0;AL;<font> 063A;;;;N;;;;;
1EE7C;ARABIC MATHEMATICAL STRETCHED DOTLESS BEH;Lo;0;AL;<font> 066E;;;;N;;;;;
1EE7E;ARABIC MATHEMATICAL STRETCHED DOTLESS FEH;Lo;0;AL;<font> 06A1;;;;N;;;;;
1EE80;ARABIC MATHEMATICAL LOOPED ALEF;Lo;0;AL;<font> 0627;;;;N;;;;;
1EE81;ARABIC MATHEMATICAL LOOPED BEH;Lo;0;AL;<font> 0628;;;;N;;;;;
1EE82;ARABIC MATHEMATICAL LOOPED JEEM;Lo;0;AL;<font> 062C;;;;N;;;;;
1EE83;ARABIC MATHEMATICAL LOOPED DAL;Lo;0;AL;<font> 062F;;;;N;;;;;
1EE84;ARABIC MATHEMATICAL LOOPED HEH;Lo;0;AL;<font> 0647;;;;N;;;;;
1EE85;ARABIC MATHEMATICAL LOOPED WAW;Lo;0;AL;<font> 0648;;;;N;;;;;
1EE86;ARABIC MATHEMATICAL LOOPED ZAIN;Lo;0;AL;<font> 0632;;;;N;;;;;
1EE87;ARABIC MATHEMATICAL LOOPED HAH;Lo;0;AL;<font> 062D;;;;N;;;;;
1EE88;ARABIC MATHEMATICAL LOOPED TAH;Lo;0;AL;<font> 0637;;;;N;;;;;
1EE89;ARABIC MATHEMATICAL LOOPED YEH;Lo;0;AL;<font> 064A;;;;N;;;;;
1EE8B;ARABIC MATHEMATICAL LOOPED LAM;Lo;0;AL;<font> 0644;;;;N;;;;;
1EE8C;ARABIC MATHEMATICAL LOOPED MEEM;Lo;0;AL;<font> 0645;;;;N;;;;;
1EE8D;ARABIC MATHEMATICAL LOOPED NOON;Lo;0;AL;<font> 0646;;;;N;;;;;
1EE8E;ARABIC MATHEMATICAL LOOPED SEEN;Lo;0;AL;<font> 0633;;;;N;;;;;
1EE8F;ARABIC MATHEMATICAL LOOPED AIN;Lo;0;AL;<font> 0639;;;;N;;;;;
1EE90;ARABIC MATHEMATICAL LOOPED FEH;Lo;0;AL;<font> 0641;;;;N;;;;;
1EE91;ARABIC MATHEMATICAL LOOPED SAD;Lo;0;AL;<font> 0635;;;;N;;;;;
1EE92;ARABIC MATHEMATICAL LOOPED QAF;Lo;0;AL;<font> 0642;;;;N;;;;;
1EE93;ARABIC MATHEMATICAL LOOPED REH;Lo;0;AL;<font> 0631;;;;N;;;;;
1EE94;ARABIC MATHEMATICAL LOOPED SHEEN;Lo;0;AL;<font> 0634;;;;N;;;;;
1EE95;ARABIC MATHEMATICAL LOOPED TEH;Lo;0;AL;<font> 062A;;;;N;;;;;
1EE96;ARABIC MATHEMATICAL LOOPED THEH;Lo;0;AL;<font> 062B;;;;N;;;;;
1EE97;ARABIC MATHEMATICAL LOOPED KHAH;Lo;0;AL;<font> 062E;;;;N;;;;;
1EE98;ARABIC MATHEMATICAL LOOPED THAL;Lo;0;AL;<font> 0630;;;;N;;;;;
1EE99;ARABIC MATHEMATICAL LOOPED DAD;Lo;0;AL;<font> 0636;;;;N;;;;;
1EE9A;ARABIC MATHEMATICAL LOOPED ZAH;Lo;0;AL;<font> 0638;;;;N;;;;;
1EE9B;ARABIC MATHEMATICAL LOOPED GHAIN;Lo;0;AL;<font> 063A;;;;N;;;;;
1EEA1;ARABIC MATHEMATICAL DOUBLE-STRUCK BEH;Lo;0;AL;<font> 0628;;;;N;;;;;
1EEA2;ARABIC MATHEMATICAL DOUBLE-STRUCK JEEM;Lo;0;AL;<font> 062C;;;;N;;;;;
1EEA3;ARABIC MATHEMATICAL DOUBLE-STRUCK DAL;Lo;0;AL;<font> 062F;;;;N;;;;;
1EEA5;ARABIC MATHEMATICAL DOUBLE-STRUCK WAW;Lo;0;AL;<font> 0648;;;;N;;;;;
1EEA6;ARABIC MATHEMATICAL DOUBLE-STRUCK ZAIN;Lo;0;AL;<font> 0632;;;;N;;;;;
1EEA7;ARABIC MATHEMATICAL DOUBLE-STRUCK HAH;Lo;0;AL;<font> 062D;;;;N;;;;;
1EEA8;ARABIC MATHEMATICAL DOUBLE-STRUCK TAH;Lo;0;AL;<font> 0637;;;;N;;;;;
1EEA9;ARABIC MATHEMATICAL DOUBLE-STRUCK YEH;Lo;0;AL;<font> 064A;;;;N;;;;;
1EEAB;ARABIC MATHEMATICAL DOUBLE-STRUCK LAM;Lo;0;AL;<font> 0644;;;;N;;;;;
1EEAC;ARABIC MATHEMATICAL DOUBLE-STRUCK MEEM;Lo;0;AL;<font> 0645;;;;N;;;;;
1EEAD;ARABIC MATHEMATICAL DOUBLE-STRUCK NOON;Lo;0;AL;<font> 0646;;;;N;;;;;
1EEAE;ARABIC MATHEMATICAL DOUBLE-STRUCK SEEN;Lo;0;AL;<font> 0633;;;;N;;;;;
1EEAF;ARABIC MATHEMATICAL DOUBLE-STRUCK AIN;Lo;0;AL;<font> 0639;;;;N;;;;;
1EEB0;ARABIC MATHEMATICAL DOUBLE-STRUCK FEH;Lo;0;AL;<font> 0641;;;;N;;;;;
1EEB1;ARABIC MATHEMATICAL DOUBLE-STRUCK SAD;Lo;0;AL;<font> 0635;;;;N;;;;;
1EEB2;ARABIC MATHEMATICAL DOUBLE-STRUCK QAF;Lo;0;AL;<font> 0642;;;;N;;;;;
1EEB3;ARABIC MATHEMATICAL DOUBLE-STRUCK REH;Lo;0;AL;<font> 0631;;;;N;;;;;
1EEB4;ARABIC MATHEMATICAL DOUBLE-STRUCK SHEEN;Lo;0;AL;<font> 0634;;;;N;;;;;
1EEB5;ARABIC MATHEMATICAL DOUBLE-STRUCK TEH;Lo;0;AL;<font> 062A;;;;N;;;;;
1EEB6;ARABIC MATHEMATICAL DOUBLE-STRUCK THEH;Lo;0;AL;<font> 062B;;;;N;;;;;
1EEB7;ARABIC MATHEMATICAL DOUBLE-STRUCK KHAH;Lo;0;AL;<font> 062E;;;;N;;;;;
1EEB8;ARABIC MATHEMATICAL DOUBLE-STRUCK THAL;Lo;0;AL;<font> 0630;;;;N;;;;;
1EEB9;ARABIC MATHEMATICAL DOUBLE-STRUCK DAD;Lo;0;AL;<font> 0636;;;;N;;;;;
1EEBA;ARABIC MATHEMATICAL DOUBLE-STRUCK ZAH;Lo;0;AL;<font> 0638;;;;N;;;;;
1EEBB;ARABIC MATHEMATICAL DOUBLE-STRUCK GHAIN;Lo;0;AL;<font> 063A;;;;N;;;;;
1EEF0;ARABIC MATHEMATICAL OPERATOR MEEM WITH HAH WITH TATWEEL;Sm;0;ON;;;;;N;;;;;
1EEF1;ARABIC MATHEMATICAL OPERATOR HAH WITH DAL;Sm;0;ON;;;;;N;;;;;
1F000;MAHJONG TILE EAST WIND;So;0;ON;;;;;N;;;;;
1F001;MAHJONG TILE SOUTH WIND;So;0;ON;;;;;N;;;;;
1F002;MAHJONG TILE WEST WIND;So;0;ON;;;;;N;;;;;
1F003;MAHJONG TILE NORTH WIND;So;0;ON;;;;;N;;;;;
1F004;MAHJONG TILE RED DRAGON;So;0;ON;;;;;N;;;;;
1F005;MAHJONG TILE GREEN DRAGON;So;0;ON;;;;;N;;;;;
1F006;MAHJONG TILE WHITE DRAGON;So;0;ON;;;;;N;;;;;
1F007;MAHJONG TILE ONE OF CHARACTERS;So;0;ON;;;;;N;;;;;
1F008;MAHJONG TILE TWO OF CHARACTERS;So;0;ON;;;;;N;;;;;
1F009;MAHJONG TILE THREE OF CHARACTERS;So;0;ON;;;;;N;;;;;
1F00A;MAHJONG TILE FOUR OF CHARACTERS;So;0;ON;;;;;N;;;;;
1F00B;MAHJONG TILE FIVE OF CHARACTERS;So;0;ON;;;;;N;;;;;
1F00C;MAHJONG TILE SIX OF CHARACTERS;So;0;ON;;;;;N;;;;;
1F00D;MAHJONG TILE SEVEN OF CHARACTERS;So;0;ON;;;;;N;;;;;
1F00E;MAHJONG TILE EIGHT OF CHARACTERS;So;0;ON;;;;;N;;;;;
1F00F;MAHJONG TILE NINE OF CHARACTERS;So;0;ON;;;;;N;;;;;
1F010;MAHJONG TILE ONE OF BAMBOOS;So;0;ON;;;;;N;;;;;
1F011;MAHJONG TILE TWO OF BAMBOOS;So;0;ON;;;;;N;;;;;
1F012;MAHJONG TILE THREE OF BAMBOOS;So;0;ON;;;;;N;;;;;
1F013;MAHJONG TILE FOUR OF BAMBOOS;So;0;ON;;;;;N;;;;;
1F014;MAHJONG TILE FIVE OF BAMBOOS;So;0;ON;;;;;N;;;;;
1F015;MAHJONG TILE SIX OF BAMBOOS;So;0;ON;;;;;N;;;;;
1F016;MAHJONG TILE SEVEN OF BAMBOOS;So;0;ON;;;;;N;;;;;
1F017;MAHJONG TILE EIGHT OF BAMBOOS;So;0;ON;;;;;N;;;;;
1F018;MAHJONG TILE NINE OF BAMBOOS;So;0;ON;;;;;N;;;;;
1F019;MAHJONG TILE ONE OF CIRCLES;So;0;ON;;;;;N;;;;;
1F01A;MAHJONG TILE TWO OF CIRCLES;So;0;ON;;;;;N;;;;;
1F01B;MAHJONG TILE THREE OF CIRCLES;So;0;ON;;;;;N;;;;;
1F01C;MAHJONG TILE FOUR OF CIRCLES;So;0;ON;;;;;N;;;;;
1F01D;MAHJONG TILE FIVE OF CIRCLES;So;0;ON;;;;;N;;;;;
1F01E;MAHJONG TILE SIX OF CIRCLES;So;0;ON;;;;;N;;;;;
1F01F;MAHJONG TILE SEVEN OF CIRCLES;So;0;ON;;;;;N;;;;;
1F020;MAHJONG TILE EIGHT OF CIRCLES;So;0;ON;;;;;N;;;;;
1F021;MAHJONG TILE NINE OF CIRCLES;So;0;ON;;;;;N;;;;;
1F022;MAHJONG TILE PLUM;So;0;ON;;;;;N;;;;;
1F023;MAHJONG TILE ORCHID;So;0;ON;;;;;N;;;;;
1F024;MAHJONG TILE BAMBOO;So;0;ON;;;;;N;;;;;
1F025;MAHJONG TILE CHRYSANTHEMUM;So;0;ON;;;;;N;;;;;
1F026;MAHJONG TILE SPRING;So;0;ON;;;;;N;;;;;
1F027;MAHJONG TILE SUMMER;So;0;ON;;;;;N;;;;;
1F028;MAHJONG TILE AUTUMN;So;0;ON;;;;;N;;;;;
1F029;MAHJONG TILE WINTER;So;0;ON;;;;;N;;;;;
1F02A;MAHJONG TILE JOKER;So;0;ON;;;;;N;;;;;
1F02B;MAHJONG TILE BACK;So;0;ON;;;;;N;;;;;
1F030;DOMINO TILE HORIZONTAL BACK;So;0;ON;;;;;N;;;;;
1F031;DOMINO TILE HORIZONTAL-00-00;So;0;ON;;;;;N;;;;;
1F032;DOMINO TILE HORIZONTAL-00-01;So;0;ON;;;;;N;;;;;
1F033;DOMINO TILE HORIZONTAL-00-02;So;0;ON;;;;;N;;;;;
1F034;DOMINO TILE HORIZONTAL-00-03;So;0;ON;;;;;N;;;;;
1F035;DOMINO TILE HORIZONTAL-00-04;So;0;ON;;;;;N;;;;;
1F036;DOMINO TILE HORIZONTAL-00-05;So;0;ON;;;;;N;;;;;
1F037;DOMINO TILE HORIZONTAL-00-06;So;0;ON;;;;;N;;;;;
1F038;DOMINO TILE HORIZONTAL-01-00;So;0;ON;;;;;N;;;;;
1F039;DOMINO TILE HORIZONTAL-01-01;So;0;ON;;;;;N;;;;;
1F03A;DOMINO TILE HORIZONTAL-01-02;So;0;ON;;;;;N;;;;;
1F03B;DOMINO TILE HORIZONTAL-01-03;So;0;ON;;;;;N;;;;;
1F03C;DOMINO TILE HORIZONTAL-01-04;So;0;ON;;;;;N;;;;;
1F03D;DOMINO TILE HORIZONTAL-01-05;So;0;ON;;;;;N;;;;;
1F03E;DOMINO TILE HORIZONTAL-01-06;So;0;ON;;;;;N;;;;;
1F03F;DOMINO TILE HORIZONTAL-02-00;So;0;ON;;;;;N;;;;;
1F040;DOMINO TILE HORIZONTAL-02-01;So;0;ON;;;;;N;;;;;
1F041;DOMINO TILE HORIZONTAL-02-02;So;0;ON;;;;;N;;;;;
1F042;DOMINO TILE HORIZONTAL-02-03;So;0;ON;;;;;N;;;;;
1F043;DOMINO TILE HORIZONTAL-02-04;So;0;ON;;;;;N;;;;;
1F044;DOMINO TILE HORIZONTAL-02-05;So;0;ON;;;;;N;;;;;
1F045;DOMINO TILE HORIZONTAL-02-06;So;0;ON;;;;;N;;;;;
1F046;DOMINO TILE HORIZONTAL-03-00;So;0;ON;;;;;N;;;;;
1F047;DOMINO TILE HORIZONTAL-03-01;So;0;ON;;;;;N;;;;;
1F048;DOMINO TILE HORIZONTAL-03-02;So;0;ON;;;;;N;;;;;
1F049;DOMINO TILE HORIZONTAL-03-03;So;0;ON;;;;;N;;;;;
1F04A;DOMINO TILE HORIZONTAL-03-04;So;0;ON;;;;;N;;;;;
1F04B;DOMINO TILE HORIZONTAL-03-05;So;0;ON;;;;;N;;;;;
1F04C;DOMINO TILE HORIZONTAL-03-06;So;0;ON;;;;;N;;;;;
1F04D;DOMINO TILE HORIZONTAL-04-00;So;0;ON;;;;;N;;;;;
1F04E;DOMINO TILE HORIZONTAL-04-01;So;0;ON;;;;;N;;;;;
1F04F;DOMINO TILE HORIZONTAL-04-02;So;0;ON;;;;;N;;;;;
1F050;DOMINO TILE HORIZONTAL-04-03;So;0;ON;;;;;N;;;;;
1F051;DOMINO TILE HORIZONTAL-04-04;So;0;ON;;;;;N;;;;;
1F052;DOMINO TILE HORIZONTAL-04-05;So;0;ON;;;;;N;;;;;
1F053;DOMINO TILE HORIZONTAL-04-06;So;0;ON;;;;;N;;;;;
1F054;DOMINO TILE HORIZONTAL-05-00;So;0;ON;;;;;N;;;;;
1F055;DOMINO TILE HORIZONTAL-05-01;So;0;ON;;;;;N;;;;;
1F056;DOMINO TILE HORIZONTAL-05-02;So;0;ON;;;;;N;;;;;
1F057;DOMINO TILE HORIZONTAL-05-03;So;0;ON;;;;;N;;;;;
1F058;DOMINO TILE HORIZONTAL-05-04;So;0;ON;;;;;N;;;;;
1F059;DOMINO TILE HORIZONTAL-05-05;So;0;ON;;;;;N;;;;;
1F05A;DOMINO TILE HORIZONTAL-05-06;So;0;ON;;;;;N;;;;;
1F05B;DOMINO TILE HORIZONTAL-06-00;So;0;ON;;;;;N;;;;;
1F05C;DOMINO TILE HORIZONTAL-06-01;So;0;ON;;;;;N;;;;;
1F05D;DOMINO TILE HORIZONTAL-06-02;So;0;ON;;;;;N;;;;;
1F05E;DOMINO TILE HORIZONTAL-06-03;So;0;ON;;;;;N;;;;;
1F05F;DOMINO TILE HORIZONTAL-06-04;So;0;ON;;;;;N;;;;;
1F060;DOMINO TILE HORIZONTAL-06-05;So;0;ON;;;;;N;;;;;
1F061;DOMINO TILE HORIZONTAL-06-06;So;0;ON;;;;;N;;;;;
1F062;DOMINO TILE VERTICAL BACK;So;0;ON;;;;;N;;;;;
1F063;DOMINO TILE VERTICAL-00-00;So;0;ON;;;;;N;;;;;
1F064;DOMINO TILE VERTICAL-00-01;So;0;ON;;;;;N;;;;;
1F065;DOMINO TILE VERTICAL-00-02;So;0;ON;;;;;N;;;;;
1F066;DOMINO TILE VERTICAL-00-03;So;0;ON;;;;;N;;;;;
1F067;DOMINO TILE VERTICAL-00-04;So;0;ON;;;;;N;;;;;
1F068;DOMINO TILE VERTICAL-00-05;So;0;ON;;;;;N;;;;;
1F069;DOMINO TILE VERTICAL-00-06;So;0;ON;;;;;N;;;;;
1F06A;DOMINO TILE VERTICAL-01-00;So;0;ON;;;;;N;;;;;
1F06B;DOMINO TILE VERTICAL-01-01;So;0;ON;;;;;N;;;;;
1F06C;DOMINO TILE VERTICAL-01-02;So;0;ON;;;;;N;;;;;
1F06D;DOMINO TILE VERTICAL-01-03;So;0;ON;;;;;N;;;;;
1F06E;DOMINO TILE VERTICAL-01-04;So;0;ON;;;;;N;;;;;
1F06F;DOMINO TILE VERTICAL-01-05;So;0;ON;;;;;N;;;;;
1F070;DOMINO TILE VERTICAL-01-06;So;0;ON;;;;;N;;;;;
1F071;DOMINO TILE VERTICAL-02-00;So;0;ON;;;;;N;;;;;
1F072;DOMINO TILE VERTICAL-02-01;So;0;ON;;;;;N;;;;;
1F073;DOMINO TILE VERTICAL-02-02;So;0;ON;;;;;N;;;;;
1F074;DOMINO TILE VERTICAL-02-03;So;0;ON;;;;;N;;;;;
1F075;DOMINO TILE VERTICAL-02-04;So;0;ON;;;;;N;;;;;
1F076;DOMINO TILE VERTICAL-02-05;So;0;ON;;;;;N;;;;;
1F077;DOMINO TILE VERTICAL-02-06;So;0;ON;;;;;N;;;;;
1F078;DOMINO TILE VERTICAL-03-00;So;0;ON;;;;;N;;;;;
1F079;DOMINO TILE VERTICAL-03-01;So;0;ON;;;;;N;;;;;
1F07A;DOMINO TILE VERTICAL-03-02;So;0;ON;;;;;N;;;;;
1F07B;DOMINO TILE VERTICAL-03-03;So;0;ON;;;;;N;;;;;
1F07C;DOMINO TILE VERTICAL-03-04;So;0;ON;;;;;N;;;;;
1F07D;DOMINO TILE VERTICAL-03-05;So;0;ON;;;;;N;;;;;
1F07E;DOMINO TILE VERTICAL-03-06;So;0;ON;;;;;N;;;;;
1F07F;DOMINO TILE VERTICAL-04-00;So;0;ON;;;;;N;;;;;
1F080;DOMINO TILE VERTICAL-04-01;So;0;ON;;;;;N;;;;;
1F081;DOMINO TILE VERTICAL-04-02;So;0;ON;;;;;N;;;;;
1F082;DOMINO TILE VERTICAL-04-03;So;0;ON;;;;;N;;;;;
1F083;DOMINO TILE VERTICAL-04-04;So;0;ON;;;;;N;;;;;
1F084;DOMINO TILE VERTICAL-04-05;So;0;ON;;;;;N;;;;;
1F085;DOMINO TILE VERTICAL-04-06;So;0;ON;;;;;N;;;;;
1F086;DOMINO TILE VERTICAL-05-00;So;0;ON;;;;;N;;;;;
1F087;DOMINO TILE VERTICAL-05-01;So;0;ON;;;;;N;;;;;
1F088;DOMINO TILE VERTICAL-05-02;So;0;ON;;;;;N;;;;;
1F089;DOMINO TILE VERTICAL-05-03;So;0;ON;;;;;N;;;;;
1F08A;DOMINO TILE VERTICAL-05-04;So;0;ON;;;;;N;;;;;
1F08B;DOMINO TILE VERTICAL-05-05;So;0;ON;;;;;N;;;;;
1F08C;DOMINO TILE VERTICAL-05-06;So;0;ON;;;;;N;;;;;
1F08D;DOMINO TILE VERTICAL-06-00;So;0;ON;;;;;N;;;;;
1F08E;DOMINO TILE VERTICAL-06-01;So;0;ON;;;;;N;;;;;
1F08F;DOMINO TILE VERTICAL-06-02;So;0;ON;;;;;N;;;;;
1F090;DOMINO TILE VERTICAL-06-03;So;0;ON;;;;;N;;;;;
1F091;DOMINO TILE VERTICAL-06-04;So;0;ON;;;;;N;;;;;
1F092;DOMINO TILE VERTICAL-06-05;So;0;ON;;;;;N;;;;;
1F093;DOMINO TILE VERTICAL-06-06;So;0;ON;;;;;N;;;;;
1F0A0;PLAYING CARD BACK;So;0;ON;;;;;N;;;;;
1F0A1;PLAYING CARD ACE OF SPADES;So;0;ON;;;;;N;;;;;
1F0A2;PLAYING CARD TWO OF SPADES;So;0;ON;;;;;N;;;;;
1F0A3;PLAYING CARD THREE OF SPADES;So;0;ON;;;;;N;;;;;
1F0A4;PLAYING CARD FOUR OF SPADES;So;0;ON;;;;;N;;;;;
1F0A5;PLAYING CARD FIVE OF SPADES;So;0;ON;;;;;N;;;;;
1F0A6;PLAYING CARD SIX OF SPADES;So;0;ON;;;;;N;;;;;
1F0A7;PLAYING CARD SEVEN OF SPADES;So;0;ON;;;;;N;;;;;
1F0A8;PLAYING CARD EIGHT OF SPADES;So;0;ON;;;;;N;;;;;
1F0A9;PLAYING CARD NINE OF SPADES;So;0;ON;;;;;N;;;;;
1F0AA;PLAYING CARD TEN OF SPADES;So;0;ON;;;;;N;;;;;
1F0AB;PLAYING CARD JACK OF SPADES;So;0;ON;;;;;N;;;;;
1F0AC;PLAYING CARD KNIGHT OF SPADES;So;0;ON;;;;;N;;;;;
1F0AD;PLAYING CARD QUEEN OF SPADES;So;0;ON;;;;;N;;;;;
1F0AE;PLAYING CARD KING OF SPADES;So;0;ON;;;;;N;;;;;
1F0B1;PLAYING CARD ACE OF HEARTS;So;0;ON;;;;;N;;;;;
1F0B2;PLAYING CARD TWO OF HEARTS;So;0;ON;;;;;N;;;;;
1F0B3;PLAYING CARD THREE OF HEARTS;So;0;ON;;;;;N;;;;;
1F0B4;PLAYING CARD FOUR OF HEARTS;So;0;ON;;;;;N;;;;;
1F0B5;PLAYING CARD FIVE OF HEARTS;So;0;ON;;;;;N;;;;;
1F0B6;PLAYING CARD SIX OF HEARTS;So;0;ON;;;;;N;;;;;
1F0B7;PLAYING CARD SEVEN OF HEARTS;So;0;ON;;;;;N;;;;;
1F0B8;PLAYING CARD EIGHT OF HEARTS;So;0;ON;;;;;N;;;;;
1F0B9;PLAYING CARD NINE OF HEARTS;So;0;ON;;;;;N;;;;;
1F0BA;PLAYING CARD TEN OF HEARTS;So;0;ON;;;;;N;;;;;
1F0BB;PLAYING CARD JACK OF HEARTS;So;0;ON;;;;;N;;;;;
1F0BC;PLAYING CARD KNIGHT OF HEARTS;So;0;ON;;;;;N;;;;;
1F0BD;PLAYING CARD QUEEN OF HEARTS;So;0;ON;;;;;N;;;;;
1F0BE;PLAYING CARD KING OF HEARTS;So;0;ON;;;;;N;;;;;
1F0BF;PLAYING CARD RED JOKER;So;0;ON;;;;;N;;;;;
1F0C1;PLAYING CARD ACE OF DIAMONDS;So;0;ON;;;;;N;;;;;
1F0C2;PLAYING CARD TWO OF DIAMONDS;So;0;ON;;;;;N;;;;;
1F0C3;PLAYING CARD THREE OF DIAMONDS;So;0;ON;;;;;N;;;;;
1F0C4;PLAYING CARD FOUR OF DIAMONDS;So;0;ON;;;;;N;;;;;
1F0C5;PLAYING CARD FIVE OF DIAMONDS;So;0;ON;;;;;N;;;;;
1F0C6;PLAYING CARD SIX OF DIAMONDS;So;0;ON;;;;;N;;;;;
1F0C7;PLAYING CARD SEVEN OF DIAMONDS;So;0;ON;;;;;N;;;;;
1F0C8;PLAYING CARD EIGHT OF DIAMONDS;So;0;ON;;;;;N;;;;;
1F0C9;PLAYING CARD NINE OF DIAMONDS;So;0;ON;;;;;N;;;;;
1F0CA;PLAYING CARD TEN OF DIAMONDS;So;0;ON;;;;;N;;;;;
1F0CB;PLAYING CARD JACK OF DIAMONDS;So;0;ON;;;;;N;;;;;
1F0CC;PLAYING CARD KNIGHT OF DIAMONDS;So;0;ON;;;;;N;;;;;
1F0CD;PLAYING CARD QUEEN OF DIAMONDS;So;0;ON;;;;;N;;;;;
1F0CE;PLAYING CARD KING OF DIAMONDS;So;0;ON;;;;;N;;;;;
1F0CF;PLAYING CARD BLACK JOKER;So;0;ON;;;;;N;;;;;
1F0D1;PLAYING CARD ACE OF CLUBS;So;0;ON;;;;;N;;;;;
1F0D2;PLAYING CARD TWO OF CLUBS;So;0;ON;;;;;N;;;;;
1F0D3;PLAYING CARD THREE OF CLUBS;So;0;ON;;;;;N;;;;;
1F0D4;PLAYING CARD FOUR OF CLUBS;So;0;ON;;;;;N;;;;;
1F0D5;PLAYING CARD FIVE OF CLUBS;So;0;ON;;;;;N;;;;;
1F0D6;PLAYING CARD SIX OF CLUBS;So;0;ON;;;;;N;;;;;
1F0D7;PLAYING CARD SEVEN OF CLUBS;So;0;ON;;;;;N;;;;;
1F0D8;PLAYING CARD EIGHT OF CLUBS;So;0;ON;;;;;N;;;;;
1F0D9;PLAYING CARD NINE OF CLUBS;So;0;ON;;;;;N;;;;;
1F0DA;PLAYING CARD TEN OF CLUBS;So;0;ON;;;;;N;;;;;
1F0DB;PLAYING CARD JACK OF CLUBS;So;0;ON;;;;;N;;;;;
1F0DC;PLAYING CARD KNIGHT OF CLUBS;So;0;ON;;;;;N;;;;;
1F0DD;PLAYING CARD QUEEN OF CLUBS;So;0;ON;;;;;N;;;;;
1F0DE;PLAYING CARD KING OF CLUBS;So;0;ON;;;;;N;;;;;
1F0DF;PLAYING CARD WHITE JOKER;So;0;ON;;;;;N;;;;;
1F0E0;PLAYING CARD FOOL;So;0;ON;;;;;N;;;;;
1F0E1;PLAYING CARD TRUMP-1;So;0;ON;;;;;N;;;;;
1F0E2;PLAYING CARD TRUMP-2;So;0;ON;;;;;N;;;;;
1F0E3;PLAYING CARD TRUMP-3;So;0;ON;;;;;N;;;;;
1F0E4;PLAYING CARD TRUMP-4;So;0;ON;;;;;N;;;;;
1F0E5;PLAYING CARD TRUMP-5;So;0;ON;;;;;N;;;;;
1F0E6;PLAYING CARD TRUMP-6;So;0;ON;;;;;N;;;;;
1F0E7;PLAYING CARD TRUMP-7;So;0;ON;;;;;N;;;;;
1F0E8;PLAYING CARD TRUMP-8;So;0;ON;;;;;N;;;;;
1F0E9;PLAYING CARD TRUMP-9;So;0;ON;;;;;N;;;;;
1F0EA;PLAYING CARD TRUMP-10;So;0;ON;;;;;N;;;;;
1F0EB;PLAYING CARD TRUMP-11;So;0;ON;;;;;N;;;;;
1F0EC;PLAYING CARD TRUMP-12;So;0;ON;;;;;N;;;;;
1F0ED;PLAYING CARD TRUMP-13;So;0;ON;;;;;N;;;;;
1F0EE;PLAYING CARD TRUMP-14;So;0;ON;;;;;N;;;;;
1F0EF;PLAYING CARD TRUMP-15;So;0;ON;;;;;N;;;;;
1F0F0;PLAYING CARD TRUMP-16;So;0;ON;;;;;N;;;;;
1F0F1;PLAYING CARD TRUMP-17;So;0;ON;;;;;N;;;;;
1F0F2;PLAYING CARD TRUMP-18;So;0;ON;;;;;N;;;;;
1F0F3;PLAYING CARD TRUMP-19;So;0;ON;;;;;N;;;;;
1F0F4;PLAYING CARD TRUMP-20;So;0;ON;;;;;N;;;;;
1F0F5;PLAYING CARD TRUMP-21;So;0;ON;;;;;N;;;;;
1F100;DIGIT ZERO FULL STOP;No;0;EN;<compat> 0030 002E;;0;0;N;;;;;
1F101;DIGIT ZERO COMMA;No;0;EN;<compat> 0030 002C;;0;0;N;;;;;
1F102;DIGIT ONE COMMA;No;0;EN;<compat> 0031 002C;;1;1;N;;;;;
1F103;DIGIT TWO COMMA;No;0;EN;<compat> 0032 002C;;2;2;N;;;;;
1F104;DIGIT THREE COMMA;No;0;EN;<compat> 0033 002C;;3;3;N;;;;;
1F105;DIGIT FOUR COMMA;No;0;EN;<compat> 0034 002C;;4;4;N;;;;;
1F106;DIGIT FIVE COMMA;No;0;EN;<compat> 0035 002C;;5;5;N;;;;;
1F107;DIGIT SIX COMMA;No;0;EN;<compat> 0036 002C;;6;6;N;;;;;
1F108;DIGIT SEVEN COMMA;No;0;EN;<compat> 0037 002C;;7;7;N;;;;;
1F109;DIGIT EIGHT COMMA;No;0;EN;<compat> 0038 002C;;8;8;N;;;;;
1F10A;DIGIT NINE COMMA;No;0;EN;<compat> 0039 002C;;9;9;N;;;;;
1F10B;DINGBAT CIRCLED SANS-SERIF DIGIT ZERO;No;0;ON;;;;0;N;;;;;
1F10C;DINGBAT NEGATIVE CIRCLED SANS-SERIF DIGIT ZERO;No;0;ON;;;;0;N;;;;;
1F10D;CIRCLED ZERO WITH SLASH;So;0;ON;;;;;N;;;;;
1F10E;CIRCLED ANTICLOCKWISE ARROW;So;0;ON;;;;;N;;;;;
1F10F;CIRCLED DOLLAR SIGN WITH OVERLAID BACKSLASH;So;0;ON;;;;;N;;;;;
1F110;PARENTHESIZED LATIN CAPITAL LETTER A;So;0;L;<compat> 0028 0041 0029;;;;N;;;;;
1F111;PARENTHESIZED LATIN CAPITAL LETTER B;So;0;L;<compat> 0028 0042 0029;;;;N;;;;;
1F112;PARENTHESIZED LATIN CAPITAL LETTER C;So;0;L;<compat> 0028 0043 0029;;;;N;;;;;
1F113;PARENTHESIZED LATIN CAPITAL LETTER D;So;0;L;<compat> 0028 0044 0029;;;;N;;;;;
1F114;PARENTHESIZED LATIN CAPITAL LETTER E;So;0;L;<compat> 0028 0045 0029;;;;N;;;;;
1F115;PARENTHESIZED LATIN CAPITAL LETTER F;So;0;L;<compat> 0028 0046 0029;;;;N;;;;;
1F116;PARENTHESIZED LATIN CAPITAL LETTER G;So;0;L;<compat> 0028 0047 0029;;;;N;;;;;
1F117;PARENTHESIZED LATIN CAPITAL LETTER H;So;0;L;<compat> 0028 0048 0029;;;;N;;;;;
1F118;PARENTHESIZED LATIN CAPITAL LETTER I;So;0;L;<compat> 0028 0049 0029;;;;N;;;;;
1F119;PARENTHESIZED LATIN CAPITAL LETTER J;So;0;L;<compat> 0028 004A 0029;;;;N;;;;;
1F11A;PARENTHESIZED LATIN CAPITAL LETTER K;So;0;L;<compat> 0028 004B 0029;;;;N;;;;;
1F11B;PARENTHESIZED LATIN CAPITAL LETTER L;So;0;L;<compat> 0028 004C 0029;;;;N;;;;;
1F11C;PARENTHESIZED LATIN CAPITAL LETTER M;So;0;L;<compat> 0028 004D 0029;;;;N;;;;;
1F11D;PARENTHESIZED LATIN CAPITAL LETTER N;So;0;L;<compat> 0028 004E 0029;;;;N;;;;;
1F11E;PARENTHESIZED LATIN CAPITAL LETTER O;So;0;L;<compat> 0028 004F 0029;;;;N;;;;;
1F11F;PARENTHESIZED LATIN CAPITAL LETTER P;So;0;L;<compat> 0028 0050 0029;;;;N;;;;;
1F120;PARENTHESIZED LATIN CAPITAL LETTER Q;So;0;L;<compat> 0028 0051 0029;;;;N;;;;;
1F121;PARENTHESIZED LATIN CAPITAL LETTER R;So;0;L;<compat> 0028 0052 0029;;;;N;;;;;
1F122;PARENTHESIZED LATIN CAPITAL LETTER S;So;0;L;<compat> 0028 0053 0029;;;;N;;;;;
1F123;PARENTHESIZED LATIN CAPITAL LETTER T;So;0;L;<compat> 0028 0054 0029;;;;N;;;;;
1F124;PARENTHESIZED LATIN CAPITAL LETTER U;So;0;L;<compat> 0028 0055 0029;;;;N;;;;;
1F125;PARENTHESIZED LATIN CAPITAL LETTER V;So;0;L;<compat> 0028 0056 0029;;;;N;;;;;
1F126;PARENTHESIZED LATIN CAPITAL LETTER W;So;0;L;<compat> 0028 0057 0029;;;;N;;;;;
1F127;PARENTHESIZED LATIN CAPITAL LETTER X;So;0;L;<compat> 0028 0058 0029;;;;N;;;;;
1F128;PARENTHESIZED LATIN CAPITAL LETTER Y;So;0;L;<compat> 0028 0059 0029;;;;N;;;;;
1F129;PARENTHESIZED LATIN CAPITAL LETTER Z;So;0;L;<compat> 0028 005A 0029;;;;N;;;;;
1F12A;TORTOISE SHELL BRACKETED LATIN CAPITAL LETTER S;So;0;L;<compat> 3014 0053 3015;;;;N;;;;;
1F12B;CIRCLED ITALIC LATIN CAPITAL LETTER C;So;0;L;<circle> 0043;;;;N;;;;;
1F12C;CIRCLED ITALIC LATIN CAPITAL LETTER R;So;0;L;<circle> 0052;;;;N;;;;;
1F12D;CIRCLED CD;So;0;L;<circle> 0043 0044;;;;N;;;;;
1F12E;CIRCLED WZ;So;0;L;<circle> 0057 005A;;;;N;;;;;
1F12F;COPYLEFT SYMBOL;So;0;ON;;;;;N;;;;;
1F130;SQUARED LATIN CAPITAL LETTER A;So;0;L;<square> 0041;;;;N;;;;;
1F131;SQUARED LATIN CAPITAL LETTER B;So;0;L;<square> 0042;;;;N;;;;;
1F132;SQUARED LATIN CAPITAL LETTER C;So;0;L;<square> 0043;;;;N;;;;;
1F133;SQUARED LATIN CAPITAL LETTER D;So;0;L;<square> 0044;;;;N;;;;;
1F134;SQUARED LATIN CAPITAL LETTER E;So;0;L;<square> 0045;;;;N;;;;;
1F135;SQUARED LATIN CAPITAL LETTER F;So;0;L;<square> 0046;;;;N;;;;;
1F136;SQUARED LATIN CAPITAL LETTER G;So;0;L;<square> 0047;;;;N;;;;;
1F137;SQUARED LATIN CAPITAL LETTER H;So;0;L;<square> 0048;;;;N;;;;;
1F138;SQUARED LATIN CAPITAL LETTER I;So;0;L;<square> 0049;;;;N;;;;;
1F139;SQUARED LATIN CAPITAL LETTER J;So;0;L;<square> 004A;;;;N;;;;;
1F13A;SQUARED LATIN CAPITAL LETTER K;So;0;L;<square> 004B;;;;N;;;;;
1F13B;SQUARED LATIN CAPITAL LETTER L;So;0;L;<square> 004C;;;;N;;;;;
1F13C;SQUARED LATIN CAPITAL LETTER M;So;0;L;<square> 004D;;;;N;;;;;
1F13D;SQUARED LATIN CAPITAL LETTER N;So;0;L;<square> 004E;;;;N;;;;;
1F13E;SQUARED LATIN CAPITAL LETTER O;So;0;L;<square> 004F;;;;N;;;;;
1F13F;SQUARED LATIN CAPITAL LETTER P;So;0;L;<square> 0050;;;;N;;;;;
1F140;SQUARED LATIN CAPITAL LETTER Q;So;0;L;<square> 0051;;;;N;;;;;
1F141;SQUARED LATIN CAPITAL LETTER R;So;0;L;<square> 0052;;;;N;;;;;
1F142;SQUARED LATIN CAPITAL LETTER S;So;0;L;<square> 0053;;;;N;;;;;
1F143;SQUARED LATIN CAPITAL LETTER T;So;0;L;<square> 0054;;;;N;;;;;
1F144;SQUARED LATIN CAPITAL LETTER U;So;0;L;<square> 0055;;;;N;;;;;
1F145;SQUARED LATIN CAPITAL LETTER V;So;0;L;<square> 0056;;;;N;;;;;
1F146;SQUARED LATIN CAPITAL LETTER W;So;0;L;<square> 0057;;;;N;;;;;
1F147;SQUARED LATIN CAPITAL LETTER X;So;0;L;<square> 0058;;;;N;;;;;
1F148;SQUARED LATIN CAPITAL LETTER Y;So;0;L;<square> 0059;;;;N;;;;;
1F149;SQUARED LATIN CAPITAL LETTER Z;So;0;L;<square> 005A;;;;N;;;;;
1F14A;SQUARED HV;So;0;L;<square> 0048 0056;;;;N;;;;;
1F14B;SQUARED MV;So;0;L;<square> 004D 0056;;;;N;;;;;
1F14C;SQUARED SD;So;0;L;<square> 0053 0044;;;;N;;;;;
1F14D;SQUARED SS;So;0;L;<square> 0053 0053;;;;N;;;;;
1F14E;SQUARED PPV;So;0;L;<square> 0050 0050 0056;;;;N;;;;;
1F14F;SQUARED WC;So;0;L;<square> 0057 0043;;;;N;;;;;
1F150;NEGATIVE CIRCLED LATIN CAPITAL LETTER A;So;0;L;;;;;N;;;;;
1F151;NEGATIVE CIRCLED LATIN CAPITAL LETTER B;So;0;L;;;;;N;;;;;
1F152;NEGATIVE CIRCLED LATIN CAPITAL LETTER C;So;0;L;;;;;N;;;;;
1F153;NEGATIVE CIRCLED LATIN CAPITAL LETTER D;So;0;L;;;;;N;;;;;
1F154;NEGATIVE CIRCLED LATIN CAPITAL LETTER E;So;0;L;;;;;N;;;;;
1F155;NEGATIVE CIRCLED LATIN CAPITAL LETTER F;So;0;L;;;;;N;;;;;
1F156;NEGATIVE CIRCLED LATIN CAPITAL LETTER G;So;0;L;;;;;N;;;;;
1F157;NEGATIVE CIRCLED LATIN CAPITAL LETTER H;So;0;L;;;;;N;;;;;
1F158;NEGATIVE CIRCLED LATIN CAPITAL LETTER I;So;0;L;;;;;N;;;;;
1F159;NEGATIVE CIRCLED LATIN CAPITAL LETTER J;So;0;L;;;;;N;;;;;
1F15A;NEGATIVE CIRCLED LATIN CAPITAL LETTER K;So;0;L;;;;;N;;;;;
1F15B;NEGATIVE CIRCLED LATIN CAPITAL LETTER L;So;0;L;;;;;N;;;;;
1F15C;NEGATIVE CIRCLED LATIN CAPITAL LETTER M;So;0;L;;;;;N;;;;;
1F15D;NEGATIVE CIRCLED LATIN CAPITAL LETTER N;So;0;L;;;;;N;;;;;
1F15E;NEGATIVE CIRCLED LATIN CAPITAL LETTER O;So;0;L;;;;;N;;;;;
1F15F;NEGATIVE CIRCLED LATIN CAPITAL LETTER P;So;0;L;;;;;N;;;;;
1F160;NEGATIVE CIRCLED LATIN CAPITAL LETTER Q;So;0;L;;;;;N;;;;;
1F161;NEGATIVE CIRCLED LATIN CAPITAL LETTER R;So;0;L;;;;;N;;;;;
1F162;NEGATIVE CIRCLED LATIN CAPITAL LETTER S;So;0;L;;;;;N;;;;;
1F163;NEGATIVE CIRCLED LATIN CAPITAL LETTER T;So;0;L;;;;;N;;;;;
1F164;NEGATIVE CIRCLED LATIN CAPITAL LETTER U;So;0;L;;;;;N;;;;;
1F165;NEGATIVE CIRCLED LATIN CAPITAL LETTER V;So;0;L;;;;;N;;;;;
1F166;NEGATIVE CIRCLED LATIN CAPITAL LETTER W;So;0;L;;;;;N;;;;;
1F167;NEGATIVE CIRCLED LATIN CAPITAL LETTER X;So;0;L;;;;;N;;;;;
1F168;NEGATIVE CIRCLED LATIN CAPITAL LETTER Y;So;0;L;;;;;N;;;;;
1F169;NEGATIVE CIRCLED LATIN CAPITAL LETTER Z;So;0;L;;;;;N;;;;;
1F16A;RAISED MC SIGN;So;0;ON;<super> 004D 0043;;;;N;;;;;
1F16B;RAISED MD SIGN;So;0;ON;<super> 004D 0044;;;;N;;;;;
1F16C;RAISED MR SIGN;So;0;ON;<super> 004D 0052;;;;N;;;;;
1F16D;CIRCLED CC;So;0;ON;;;;;N;;;;;
1F16E;CIRCLED C WITH OVERLAID BACKSLASH;So;0;ON;;;;;N;;;;;
1F16F;CIRCLED HUMAN FIGURE;So;0;ON;;;;;N;;;;;
1F170;NEGATIVE SQUARED LATIN CAPITAL LETTER A;So;0;L;;;;;N;;;;;
1F171;NEGATIVE SQUARED LATIN CAPITAL LETTER B;So;0;L;;;;;N;;;;;
1F172;NEGATIVE SQUARED LATIN CAPITAL LETTER C;So;0;L;;;;;N;;;;;
1F173;NEGATIVE SQUARED LATIN CAPITAL LETTER D;So;0;L;;;;;N;;;;;
1F174;NEGATIVE SQUARED LATIN CAPITAL LETTER E;So;0;L;;;;;N;;;;;
1F175;NEGATIVE SQUARED LATIN CAPITAL LETTER F;So;0;L;;;;;N;;;;;
1F176;NEGATIVE SQUARED LATIN CAPITAL LETTER G;So;0;L;;;;;N;;;;;
1F177;NEGATIVE SQUARED LATIN CAPITAL LETTER H;So;0;L;;;;;N;;;;;
1F178;NEGATIVE SQUARED LATIN CAPITAL LETTER I;So;0;L;;;;;N;;;;;
1F179;NEGATIVE SQUARED LATIN CAPITAL LETTER J;So;0;L;;;;;N;;;;;
1F17A;NEGATIVE SQUARED LATIN CAPITAL LETTER K;So;0;L;;;;;N;;;;;
1F17B;NEGATIVE SQUARED LATIN CAPITAL LETTER L;So;0;L;;;;;N;;;;;
1F17C;NEGATIVE SQUARED LATIN CAPITAL LETTER M;So;0;L;;;;;N;;;;;
1F17D;NEGATIVE SQUARED LATIN CAPITAL LETTER N;So;0;L;;;;;N;;;;;
1F17E;NEGATIVE SQUARED LATIN CAPITAL LETTER O;So;0;L;;;;;N;;;;;
1F17F;NEGATIVE SQUARED LATIN CAPITAL LETTER P;So;0;L;;;;;N;;;;;
1F180;NEGATIVE SQUARED LATIN CAPITAL LETTER Q;So;0;L;;;;;N;;;;;
1F181;NEGATIVE SQUARED LATIN CAPITAL LETTER R;So;0;L;;;;;N;;;;;
1F182;NEGATIVE SQUARED LATIN CAPITAL LETTER S;So;0;L;;;;;N;;;;;
1F183;NEGATIVE SQUARED LATIN CAPITAL LETTER T;So;0;L;;;;;N;;;;;
1F184;NEGATIVE SQUARED LATIN CAPITAL LETTER U;So;0;L;;;;;N;;;;;
1F185;NEGATIVE SQUARED LATIN CAPITAL LETTER V;So;0;L;;;;;N;;;;;
1F186;NEGATIVE SQUARED LATIN CAPITAL LETTER W;So;0;L;;;;;N;;;;;
1F187;NEGATIVE SQUARED LATIN CAPITAL LETTER X;So;0;L;;;;;N;;;;;
1F188;NEGATIVE SQUARED LATIN CAPITAL LETTER Y;So;0;L;;;;;N;;;;;
1F189;NEGATIVE SQUARED LATIN CAPITAL LETTER Z;So;0;L;;;;;N;;;;;
1F18A;CROSSED NEGATIVE SQUARED LATIN CAPITAL LETTER P;So;0;L;;;;;N;;;;;
1F18B;NEGATIVE SQUARED IC;So;0;L;;;;;N;;;;;
1F18C;NEGATIVE SQUARED PA;So;0;L;;;;;N;;;;;
1F18D;NEGATIVE SQUARED SA;So;0;L;;;;;N;;;;;
1F18E;NEGATIVE SQUARED AB;So;0;L;;;;;N;;;;;
1F18F;NEGATIVE SQUARED WC;So;0;L;;;;;N;;;;;
1F190;SQUARE DJ;So;0;L;<square> 0044 004A;;;;N;;;;;
1F191;SQUARED CL;So;0;L;;;;;N;;;;;
1F192;SQUARED COOL;So;0;L;;;;;N;;;;;
1F193;SQUARED FREE;So;0;L;;;;;N;;;;;
1F194;SQUARED ID;So;0;L;;;;;N;;;;;
1F195;SQUARED NEW;So;0;L;;;;;N;;;;;
1F196;SQUARED NG;So;0;L;;;;;N;;;;;
1F197;SQUARED OK;So;0;L;;;;;N;;;;;
1F198;SQUARED SOS;So;0;L;;;;;N;;;;;
1F199;SQUARED UP WITH EXCLAMATION MARK;So;0;L;;;;;N;;;;;
1F19A;SQUARED VS;So;0;L;;;;;N;;;;;
1F19B;SQUARED THREE D;So;0;L;;;;;N;;;;;
1F19C;SQUARED SECOND SCREEN;So;0;L;;;;;N;;;;;
1F19D;SQUARED TWO K;So;0;L;;;;;N;;;;;
1F19E;SQUARED FOUR K;So;0;L;;;;;N;;;;;
1F19F;SQUARED EIGHT K;So;0;L;;;;;N;;;;;
1F1A0;SQUARED FIVE POINT ONE;So;0;L;;;;;N;;;;;
1F1A1;SQUARED SEVEN POINT ONE;So;0;L;;;;;N;;;;;
1F1A2;SQUARED TWENTY-TWO POINT TWO;So;0;L;;;;;N;;;;;
1F1A3;SQUARED SIXTY P;So;0;L;;;;;N;;;;;
1F1A4;SQUARED ONE HUNDRED TWENTY P;So;0;L;;;;;N;;;;;
1F1A5;SQUARED LATIN SMALL LETTER D;So;0;L;;;;;N;;;;;
1F1A6;SQUARED HC;So;0;L;;;;;N;;;;;
1F1A7;SQUARED HDR;So;0;L;;;;;N;;;;;
1F1A8;SQUARED HI-RES;So;0;L;;;;;N;;;;;
1F1A9;SQUARED LOSSLESS;So;0;L;;;;;N;;;;;
1F1AA;SQUARED SHV;So;0;L;;;;;N;;;;;
1F1AB;SQUARED UHD;So;0;L;;;;;N;;;;;
1F1AC;SQUARED VOD;So;0;L;;;;;N;;;;;
1F1AD;MASK WORK SYMBOL;So;0;ON;;;;;N;;;;;
1F1E6;REGIONAL INDICATOR SYMBOL LETTER A;So;0;L;;;;;N;;;;;
1F1E7;REGIONAL INDICATOR SYMBOL LETTER B;So;0;L;;;;;N;;;;;
1F1E8;REGIONAL INDICATOR SYMBOL LETTER C;So;0;L;;;;;N;;;;;
1F1E9;REGIONAL INDICATOR SYMBOL LETTER D;So;0;L;;;;;N;;;;;
1F1EA;REGIONAL INDICATOR SYMBOL LETTER E;So;0;L;;;;;N;;;;;
1F1EB;REGIONAL INDICATOR SYMBOL LETTER F;So;0;L;;;;;N;;;;;
1F1EC;REGIONAL INDICATOR SYMBOL LETTER G;So;0;L;;;;;N;;;;;
1F1ED;REGIONAL INDICATOR SYMBOL LETTER H;So;0;L;;;;;N;;;;;
1F1EE;REGIONAL INDICATOR SYMBOL LETTER I;So;0;L;;;;;N;;;;;
1F1EF;REGIONAL INDICATOR SYMBOL LETTER J;So;0;L;;;;;N;;;;;
1F1F0;REGIONAL INDICATOR SYMBOL LETTER K;So;0;L;;;;;N;;;;;
1F1F1;REGIONAL INDICATOR SYMBOL LETTER L;So;0;L;;;;;N;;;;;
1F1F2;REGIONAL INDICATOR SYMBOL LETTER M;So;0;L;;;;;N;;;;;
1F1F3;REGIONAL INDICATOR SYMBOL LETTER N;So;0;L;;;;;N;;;;;
1F1F4;REGIONAL INDICATOR SYMBOL LETTER O;So;0;L;;;;;N;;;;;
1F1F5;REGIONAL INDICATOR SYMBOL LETTER P;So;0;L;;;;;N;;;;;
1F1F6;REGIONAL INDICATOR SYMBOL LETTER Q;So;0;L;;;;;N;;;;;
1F1F7;REGIONAL INDICATOR SYMBOL LETTER R;So;0;L;;;;;N;;;;;
1F1F8;REGIONAL INDICATOR SYMBOL LETTER S;So;0;L;;;;;N;;;;;
1F1F9;REGIONAL INDICATOR SYMBOL LETTER T;So;0;L;;;;;N;;;;;
1F1FA;REGIONAL INDICATOR SYMBOL LETTER U;So;0;L;;;;;N;;;;;
1F1FB;REGIONAL INDICATOR SYMBOL LETTER V;So;0;L;;;;;N;;;;;
1F1FC;REGIONAL INDICATOR SYMBOL LETTER W;So;0;L;;;;;N;;;;;
1F1FD;REGIONAL INDICATOR SYMBOL LETTER X;So;0;L;;;;;N;;;;;
1F1FE;REGIONAL INDICATOR SYMBOL LETTER Y;So;0;L;;;;;N;;;;;
1F1FF;REGIONAL INDICATOR SYMBOL LETTER Z;So;0;L;;;;;N;;;;;
1F200;SQUARE HIRAGANA HOKA;So;0;L;<square> 307B 304B;;;;N;;;;;
1F201;SQUARED KATAKANA KOKO;So;0;L;<square> 30B3 30B3;;;;N;;;;;
1F202;SQUARED KATAKANA SA;So;0;L;<square> 30B5;;;;N;;;;;
1F210;SQUARED CJK UNIFIED IDEOGRAPH-624B;So;0;L;<square> 624B;;;;N;;;;;
1F211;SQUARED CJK UNIFIED IDEOGRAPH-5B57;So;0;L;<square> 5B57;;;;N;;;;;
1F212;SQUARED CJK UNIFIED IDEOGRAPH-53CC;So;0;L;<square> 53CC;;;;N;;;;;
1F213;SQUARED KATAKANA DE;So;0;L;<square> 30C7;;;;N;;;;;
1F214;SQUARED CJK UNIFIED IDEOGRAPH-4E8C;So;0;L;<square> 4E8C;;;;N;;;;;
1F215;SQUARED CJK UNIFIED IDEOGRAPH-591A;So;0;L;<square> 591A;;;;N;;;;;
1F216;SQUARED CJK UNIFIED IDEOGRAPH-89E3;So;0;L;<square> 89E3;;;;N;;;;;
1F217;SQUARED CJK UNIFIED IDEOGRAPH-5929;So;0;L;<square> 5929;;;;N;;;;;
1F218;SQUARED CJK UNIFIED IDEOGRAPH-4EA4;So;0;L;<square> 4EA4;;;;N;;;;;
1F219;SQUARED CJK UNIFIED IDEOGRAPH-6620;So;0;L;<square> 6620;;;;N;;;;;
1F21A;SQUARED CJK UNIFIED IDEOGRAPH-7121;So;0;L;<square> 7121;;;;N;;;;;
1F21B;SQUARED CJK UNIFIED IDEOGRAPH-6599;So;0;L;<square> 6599;;;;N;;;;;
1F21C;SQUARED CJK UNIFIED IDEOGRAPH-524D;So;0;L;<square> 524D;;;;N;;;;;
1F21D;SQUARED CJK UNIFIED IDEOGRAPH-5F8C;So;0;L;<square> 5F8C;;;;N;;;;;
1F21E;SQUARED CJK UNIFIED IDEOGRAPH-518D;So;0;L;<square> 518D;;;;N;;;;;
1F21F;SQUARED CJK UNIFIED IDEOGRAPH-65B0;So;0;L;<square> 65B0;;;;N;;;;;
1F220;SQUARED CJK UNIFIED IDEOGRAPH-521D;So;0;L;<square> 521D;;;;N;;;;;
1F221;SQUARED CJK UNIFIED IDEOGRAPH-7D42;So;0;L;<square> 7D42;;;;N;;;;;
1F222;SQUARED CJK UNIFIED IDEOGRAPH-751F;So;0;L;<square> 751F;;;;N;;;;;
1F223;SQUARED CJK UNIFIED IDEOGRAPH-8CA9;So;0;L;<square> 8CA9;;;;N;;;;;
1F224;SQUARED CJK UNIFIED IDEOGRAPH-58F0;So;0;L;<square> 58F0;;;;N;;;;;
1F225;SQUARED CJK UNIFIED IDEOGRAPH-5439;So;0;L;<square> 5439;;;;N;;;;;
1F226;SQUARED CJK UNIFIED IDEOGRAPH-6F14;So;0;L;<square> 6F14;;;;N;;;;;
1F227;SQUARED CJK UNIFIED IDEOGRAPH-6295;So;0;L;<square> 6295;;;;N;;;;;
1F228;SQUARED CJK UNIFIED IDEOGRAPH-6355;So;0;L;<square> 6355;;;;N;;;;;
1F229;SQUARED CJK UNIFIED IDEOGRAPH-4E00;So;0;L;<square> 4E00;;;;N;;;;;
1F22A;SQUARED CJK UNIFIED IDEOGRAPH-4E09;So;0;L;<square> 4E09;;;;N;;;;;
1F22B;SQUARED CJK UNIFIED IDEOGRAPH-904A;So;0;L;<square> 904A;;;;N;;;;;
1F22C;SQUARED CJK UNIFIED IDEOGRAPH-5DE6;So;0;L;<square> 5DE6;;;;N;;;;;
1F22D;SQUARED CJK UNIFIED IDEOGRAPH-4E2D;So;0;L;<square> 4E2D;;;;N;;;;;
1F22E;SQUARED CJK UNIFIED IDEOGRAPH-53F3;So;0;L;<square> 53F3;;;;N;;;;;
1F22F;SQUARED CJK UNIFIED IDEOGRAPH-6307;So;0;L;<square> 6307;;;;N;;;;;
1F230;SQUARED CJK UNIFIED IDEOGRAPH-8D70;So;0;L;<square> 8D70;;;;N;;;;;
1F231;SQUARED CJK UNIFIED IDEOGRAPH-6253;So;0;L;<square> 6253;;;;N;;;;;
1F232;SQUARED CJK UNIFIED IDEOGRAPH-7981;So;0;L;<square> 7981;;;;N;;;;;
1F233;SQUARED CJK UNIFIED IDEOGRAPH-7A7A;So;0;L;<square> 7A7A;;;;N;;;;;
1F234;SQUARED CJK UNIFIED IDEOGRAPH-5408;So;0;L;<square> 5408;;;;N;;;;;
1F235;SQUARED CJK UNIFIED IDEOGRAPH-6E80;So;0;L;<square> 6E80;;;;N;;;;;
1F236;SQUARED CJK UNIFIED IDEOGRAPH-6709;So;0;L;<square> 6709;;;;N;;;;;
1F237;SQUARED CJK UNIFIED IDEOGRAPH-6708;So;0;L;<square> 6708;;;;N;;;;;
1F238;SQUARED CJK UNIFIED IDEOGRAPH-7533;So;0;L;<square> 7533;;;;N;;;;;
1F239;SQUARED CJK UNIFIED IDEOGRAPH-5272;So;0;L;<square> 5272;;;;N;;;;;
1F23A;SQUARED CJK UNIFIED IDEOGRAPH-55B6;So;0;L;<square> 55B6;;;;N;;;;;
1F23B;SQUARED CJK UNIFIED IDEOGRAPH-914D;So;0;L;<square> 914D;;;;N;;;;;
1F240;TORTOISE SHELL BRACKETED CJK UNIFIED IDEOGRAPH-672C;So;0;L;<compat> 3014 672C 3015;;;;N;;;;;
1F241;TORTOISE SHELL BRACKETED CJK UNIFIED IDEOGRAPH-4E09;So;0;L;<compat> 3014 4E09 3015;;;;N;;;;;
1F242;TORTOISE SHELL BRACKETED CJK UNIFIED IDEOGRAPH-4E8C;So;0;L;<compat> 3014 4E8C 3015;;;;N;;;;;
1F243;TORTOISE SHELL BRACKETED CJK UNIFIED IDEOGRAPH-5B89;So;0;L;<compat> 3014 5B89 3015;;;;N;;;;;
1F244;TORTOISE SHELL BRACKETED CJK UNIFIED IDEOGRAPH-70B9;So;0;L;<compat> 3014 70B9 3015;;;;N;;;;;
1F245;TORTOISE SHELL BRACKETED CJK UNIFIED IDEOGRAPH-6253;So;0;L;<compat> 3014 6253 3015;;;;N;;;;;
1F246;TORTOISE SHELL BRACKETED CJK UNIFIED IDEOGRAPH-76D7;So;0;L;<compat> 3014 76D7 3015;;;;N;;;;;
1F247;TORTOISE SHELL BRACKETED CJK UNIFIED IDEOGRAPH-52DD;So;0;L;<compat> 3014 52DD 3015;;;;N;;;;;
1F248;TORTOISE SHELL BRACKETED CJK UNIFIED IDEOGRAPH-6557;So;0;L;<compat> 3014 6557 3015;;;;N;;;;;
1F250;CIRCLED IDEOGRAPH ADVANTAGE;So;0;L;<circle> 5F97;;;;N;;;;;
1F251;CIRCLED IDEOGRAPH ACCEPT;So;0;L;<circle> 53EF;;;;N;;;;;
1F260;ROUNDED SYMBOL FOR FU;So;0;ON;;;;;N;;;;;
1F261;ROUNDED SYMBOL FOR LU;So;0;ON;;;;;N;;;;;
1F262;ROUNDED SYMBOL FOR SHOU;So;0;ON;;;;;N;;;;;
1F263;ROUNDED SYMBOL FOR XI;So;0;ON;;;;;N;;;;;
1F264;ROUNDED SYMBOL FOR SHUANGXI;So;0;ON;;;;;N;;;;;
1F265;ROUNDED SYMBOL FOR CAI;So;0;ON;;;;;N;;;;;
1F300;CYCLONE;So;0;ON;;;;;N;;;;;
1F301;FOGGY;So;0;ON;;;;;N;;;;;
1F302;CLOSED UMBRELLA;So;0;ON;;;;;N;;;;;
1F303;NIGHT WITH STARS;So;0;ON;;;;;N;;;;;
1F304;SUNRISE OVER MOUNTAINS;So;0;ON;;;;;N;;;;;
1F305;SUNRISE;So;0;ON;;;;;N;;;;;
1F306;CITYSCAPE AT DUSK;So;0;ON;;;;;N;;;;;
1F307;SUNSET OVER BUILDINGS;So;0;ON;;;;;N;;;;;
1F308;RAINBOW;So;0;ON;;;;;N;;;;;
1F309;BRIDGE AT NIGHT;So;0;ON;;;;;N;;;;;
1F30A;WATER WAVE;So;0;ON;;;;;N;;;;;
1F30B;VOLCANO;So;0;ON;;;;;N;;;;;
1F30C;MILKY WAY;So;0;ON;;;;;N;;;;;
1F30D;EARTH GLOBE EUROPE-AFRICA;So;0;ON;;;;;N;;;;;
1F30E;EARTH GLOBE AMERICAS;So;0;ON;;;;;N;;;;;
1F30F;EARTH GLOBE ASIA-AUSTRALIA;So;0;ON;;;;;N;;;;;
1F310;GLOBE WITH MERIDIANS;So;0;ON;;;;;N;;;;;
1F311;NEW MOON SYMBOL;So;0;ON;;;;;N;;;;;
1F312;WAXING CRESCENT MOON SYMBOL;So;0;ON;;;;;N;;;;;
1F313;FIRST QUARTER MOON SYMBOL;So;0;ON;;;;;N;;;;;
1F314;WAXING GIBBOUS MOON SYMBOL;So;0;ON;;;;;N;;;;;
1F315;FULL MOON SYMBOL;So;0;ON;;;;;N;;;;;
1F316;WANING GIBBOUS MOON SYMBOL;So;0;ON;;;;;N;;;;;
1F317;LAST QUARTER MOON SYMBOL;So;0;ON;;;;;N;;;;;
1F318;WANING CRESCENT MOON SYMBOL;So;0;ON;;;;;N;;;;;
1F319;CRESCENT MOON;So;0;ON;;;;;N;;;;;
1F31A;NEW MOON WITH FACE;So;0;ON;;;;;N;;;;;
1F31B;FIRST QUARTER MOON WITH FACE;So;0;ON;;;;;N;;;;;
1F31C;LAST QUARTER MOON WITH FACE;So;0;ON;;;;;N;;;;;
1F31D;FULL MOON WITH FACE;So;0;ON;;;;;N;;;;;
1F31E;SUN WITH FACE;So;0;ON;;;;;N;;;;;
1F31F;GLOWING STAR;So;0;ON;;;;;N;;;;;
1F320;SHOOTING STAR;So;0;ON;;;;;N;;;;;
1F321;THERMOMETER;So;0;ON;;;;;N;;;;;
1F322;BLACK DROPLET;So;0;ON;;;;;N;;;;;
1F323;WHITE SUN;So;0;ON;;;;;N;;;;;
1F324;WHITE SUN WITH SMALL CLOUD;So;0;ON;;;;;N;;;;;
1F325;WHITE SUN BEHIND CLOUD;So;0;ON;;;;;N;;;;;
1F326;WHITE SUN BEHIND CLOUD WITH RAIN;So;0;ON;;;;;N;;;;;
1F327;CLOUD WITH RAIN;So;0;ON;;;;;N;;;;;
1F328;CLOUD WITH SNOW;So;0;ON;;;;;N;;;;;
1F329;CLOUD WITH LIGHTNING;So;0;ON;;;;;N;;;;;
1F32A;CLOUD WITH TORNADO;So;0;ON;;;;;N;;;;;
1F32B;FOG;So;0;ON;;;;;N;;;;;
1F32C;WIND BLOWING FACE;So;0;ON;;;;;N;;;;;
1F32D;HOT DOG;So;0;ON;;;;;N;;;;;
1F32E;TACO;So;0;ON;;;;;N;;;;;
1F32F;BURRITO;So;0;ON;;;;;N;;;;;
1F330;CHESTNUT;So;0;ON;;;;;N;;;;;
1F331;SEEDLING;So;0;ON;;;;;N;;;;;
1F332;EVERGREEN TREE;So;0;ON;;;;;N;;;;;
1F333;DECIDUOUS TREE;So;0;ON;;;;;N;;;;;
1F334;PALM TREE;So;0;ON;;;;;N;;;;;
1F335;CACTUS;So;0;ON;;;;;N;;;;;
1F336;HOT PEPPER;So;0;ON;;;;;N;;;;;
1F337;TULIP;So;0;ON;;;;;N;;;;;
1F338;CHERRY BLOSSOM;So;0;ON;;;;;N;;;;;
1F339;ROSE;So;0;ON;;;;;N;;;;;
1F33A;HIBISCUS;So;0;ON;;;;;N;;;;;
1F33B;SUNFLOWER;So;0;ON;;;;;N;;;;;
1F33C;BLOSSOM;So;0;ON;;;;;N;;;;;
1F33D;EAR OF MAIZE;So;0;ON;;;;;N;;;;;
1F33E;EAR OF RICE;So;0;ON;;;;;N;;;;;
1F33F;HERB;So;0;ON;;;;;N;;;;;
1F340;FOUR LEAF CLOVER;So;0;ON;;;;;N;;;;;
1F341;MAPLE LEAF;So;0;ON;;;;;N;;;;;
1F342;FALLEN LEAF;So;0;ON;;;;;N;;;;;
1F343;LEAF FLUTTERING IN WIND;So;0;ON;;;;;N;;;;;
1F344;MUSHROOM;So;0;ON;;;;;N;;;;;
1F345;TOMATO;So;0;ON;;;;;N;;;;;
1F346;AUBERGINE;So;0;ON;;;;;N;;;;;
1F347;GRAPES;So;0;ON;;;;;N;;;;;
1F348;MELON;So;0;ON;;;;;N;;;;;
1F349;WATERMELON;So;0;ON;;;;;N;;;;;
1F34A;TANGERINE;So;0;ON;;;;;N;;;;;
1F34B;LEMON;So;0;ON;;;;;N;;;;;
1F34C;BANANA;So;0;ON;;;;;N;;;;;
1F34D;PINEAPPLE;So;0;ON;;;;;N;;;;;
1F34E;RED APPLE;So;0;ON;;;;;N;;;;;
1F34F;GREEN APPLE;So;0;ON;;;;;N;;;;;
1F350;PEAR;So;0;ON;;;;;N;;;;;
1F351;PEACH;So;0;ON;;;;;N;;;;;
1F352;CHERRIES;So;0;ON;;;;;N;;;;;
1F353;STRAWBERRY;So;0;ON;;;;;N;;;;;
1F354;HAMBURGER;So;0;ON;;;;;N;;;;;
1F355;SLICE OF PIZZA;So;0;ON;;;;;N;;;;;
1F356;MEAT ON BONE;So;0;ON;;;;;N;;;;;
1F357;POULTRY LEG;So;0;ON;;;;;N;;;;;
1F358;RICE CRACKER;So;0;ON;;;;;N;;;;;
1F359;RICE BALL;So;0;ON;;;;;N;;;;;
1F35A;COOKED RICE;So;0;ON;;;;;N;;;;;
1F35B;CURRY AND RICE;So;0;ON;;;;;N;;;;;
1F35C;STEAMING BOWL;So;0;ON;;;;;N;;;;;
1F35D;SPAGHETTI;So;0;ON;;;;;N;;;;;
1F35E;BREAD;So;0;ON;;;;;N;;;;;
1F35F;FRENCH FRIES;So;0;ON;;;;;N;;;;;
1F360;ROASTED SWEET POTATO;So;0;ON;;;;;N;;;;;
1F361;DANGO;So;0;ON;;;;;N;;;;;
1F362;ODEN;So;0;ON;;;;;N;;;;;
1F363;SUSHI;So;0;ON;;;;;N;;;;;
1F364;FRIED SHRIMP;So;0;ON;;;;;N;;;;;
1F365;FISH CAKE WITH SWIRL DESIGN;So;0;ON;;;;;N;;;;;
1F366;SOFT ICE CREAM;So;0;ON;;;;;N;;;;;
1F367;SHAVED ICE;So;0;ON;;;;;N;;;;;
1F368;ICE CREAM;So;0;ON;;;;;N;;;;;
1F369;DOUGHNUT;So;0;ON;;;;;N;;;;;
1F36A;COOKIE;So;0;ON;;;;;N;;;;;
1F36B;CHOCOLATE BAR;So;0;ON;;;;;N;;;;;
1F36C;CANDY;So;0;ON;;;;;N;;;;;
1F36D;LOLLIPOP;So;0;ON;;;;;N;;;;;
1F36E;CUSTARD;So;0;ON;;;;;N;;;;;
1F36F;HONEY POT;So;0;ON;;;;;N;;;;;
1F370;SHORTCAKE;So;0;ON;;;;;N;;;;;
1F371;BENTO BOX;So;0;ON;;;;;N;;;;;
1F372;POT OF FOOD;So;0;ON;;;;;N;;;;;
1F373;COOKING;So;0;ON;;;;;N;;;;;
1F374;FORK AND KNIFE;So;0;ON;;;;;N;;;;;
1F375;TEACUP WITHOUT HANDLE;So;0;ON;;;;;N;;;;;
1F376;SAKE BOTTLE AND CUP;So;0;ON;;;;;N;;;;;
1F377;WINE GLASS;So;0;ON;;;;;N;;;;;
1F378;COCKTAIL GLASS;So;0;ON;;;;;N;;;;;
1F379;TROPICAL DRINK;So;0;ON;;;;;N;;;;;
1F37A;BEER MUG;So;0;ON;;;;;N;;;;;
1F37B;CLINKING BEER MUGS;So;0;ON;;;;;N;;;;;
1F37C;BABY BOTTLE;So;0;ON;;;;;N;;;;;
1F37D;FORK AND KNIFE WITH PLATE;So;0;ON;;;;;N;;;;;
1F37E;BOTTLE WITH POPPING CORK;So;0;ON;;;;;N;;;;;
1F37F;POPCORN;So;0;ON;;;;;N;;;;;
1F380;RIBBON;So;0;ON;;;;;N;;;;;
1F381;WRAPPED PRESENT;So;0;ON;;;;;N;;;;;
1F382;BIRTHDAY CAKE;So;0;ON;;;;;N;;;;;
1F383;JACK-O-LANTERN;So;0;ON;;;;;N;;;;;
1F384;CHRISTMAS TREE;So;0;ON;;;;;N;;;;;
1F385;FATHER CHRISTMAS;So;0;ON;;;;;N;;;;;
1F386;FIREWORKS;So;0;ON;;;;;N;;;;;
1F387;FIREWORK SPARKLER;So;0;ON;;;;;N;;;;;
1F388;BALLOON;So;0;ON;;;;;N;;;;;
1F389;PARTY POPPER;So;0;ON;;;;;N;;;;;
1F38A;CONFETTI BALL;So;0;ON;;;;;N;;;;;
1F38B;TANABATA TREE;So;0;ON;;;;;N;;;;;
1F38C;CROSSED FLAGS;So;0;ON;;;;;N;;;;;
1F38D;PINE DECORATION;So;0;ON;;;;;N;;;;;
1F38E;JAPANESE DOLLS;So;0;ON;;;;;N;;;;;
1F38F;CARP STREAMER;So;0;ON;;;;;N;;;;;
1F390;WIND CHIME;So;0;ON;;;;;N;;;;;
1F391;MOON VIEWING CEREMONY;So;0;ON;;;;;N;;;;;
1F392;SCHOOL SATCHEL;So;0;ON;;;;;N;;;;;
1F393;GRADUATION CAP;So;0;ON;;;;;N;;;;;
1F394;HEART WITH TIP ON THE LEFT;So;0;ON;;;;;N;;;;;
1F395;BOUQUET OF FLOWERS;So;0;ON;;;;;N;;;;;
1F396;MILITARY MEDAL;So;0;ON;;;;;N;;;;;
1F397;REMINDER RIBBON;So;0;ON;;;;;N;;;;;
1F398;MUSICAL KEYBOARD WITH JACKS;So;0;ON;;;;;N;;;;;
1F399;STUDIO MICROPHONE;So;0;ON;;;;;N;;;;;
1F39A;LEVEL SLIDER;So;0;ON;;;;;N;;;;;
1F39B;CONTROL KNOBS;So;0;ON;;;;;N;;;;;
1F39C;BEAMED ASCENDING MUSICAL NOTES;So;0;ON;;;;;N;;;;;
1F39D;BEAMED DESCENDING MUSICAL NOTES;So;0;ON;;;;;N;;;;;
1F39E;FILM FRAMES;So;0;ON;;;;;N;;;;;
1F39F;ADMISSION TICKETS;So;0;ON;;;;;N;;;;;
1F3A0;CAROUSEL HORSE;So;0;ON;;;;;N;;;;;
1F3A1;FERRIS WHEEL;So;0;ON;;;;;N;;;;;
1F3A2;ROLLER COASTER;So;0;ON;;;;;N;;;;;
1F3A3;FISHING POLE AND FISH;So;0;ON;;;;;N;;;;;
1F3A4;MICROPHONE;So;0;ON;;;;;N;;;;;
1F3A5;MOVIE CAMERA;So;0;ON;;;;;N;;;;;
1F3A6;CINEMA;So;0;ON;;;;;N;;;;;
1F3A7;HEADPHONE;So;0;ON;;;;;N;;;;;
1F3A8;ARTIST PALETTE;So;0;ON;;;;;N;;;;;
1F3A9;TOP HAT;So;0;ON;;;;;N;;;;;
1F3AA;CIRCUS TENT;So;0;ON;;;;;N;;;;;
1F3AB;TICKET;So;0;ON;;;;;N;;;;;
1F3AC;CLAPPER BOARD;So;0;ON;;;;;N;;;;;
1F3AD;PERFORMING ARTS;So;0;ON;;;;;N;;;;;
1F3AE;VIDEO GAME;So;0;ON;;;;;N;;;;;
1F3AF;DIRECT HIT;So;0;ON;;;;;N;;;;;
1F3B0;SLOT MACHINE;So;0;ON;;;;;N;;;;;
1F3B1;BILLIARDS;So;0;ON;;;;;N;;;;;
1F3B2;GAME DIE;So;0;ON;;;;;N;;;;;
1F3B3;BOWLING;So;0;ON;;;;;N;;;;;
1F3B4;FLOWER PLAYING CARDS;So;0;ON;;;;;N;;;;;
1F3B5;MUSICAL NOTE;So;0;ON;;;;;N;;;;;
1F3B6;MULTIPLE MUSICAL NOTES;So;0;ON;;;;;N;;;;;
1F3B7;SAXOPHONE;So;0;ON;;;;;N;;;;;
1F3B8;GUITAR;So;0;ON;;;;;N;;;;;
1F3B9;MUSICAL KEYBOARD;So;0;ON;;;;;N;;;;;
1F3BA;TRUMPET;So;0;ON;;;;;N;;;;;
1F3BB;VIOLIN;So;0;ON;;;;;N;;;;;
1F3BC;MUSICAL SCORE;So;0;ON;;;;;N;;;;;
1F3BD;RUNNING SHIRT WITH SASH;So;0;ON;;;;;N;;;;;
1F3BE;TENNIS RACQUET AND BALL;So;0;ON;;;;;N;;;;;
1F3BF;SKI AND SKI BOOT;So;0;ON;;;;;N;;;;;
1F3C0;BASKETBALL AND HOOP;So;0;ON;;;;;N;;;;;
1F3C1;CHEQUERED FLAG;So;0;ON;;;;;N;;;;;
1F3C2;SNOWBOARDER;So;0;ON;;;;;N;;;;;
1F3C3;RUNNER;So;0;ON;;;;;N;;;;;
1F3C4;SURFER;So;0;ON;;;;;N;;;;;
1F3C5;SPORTS MEDAL;So;0;ON;;;;;N;;;;;
1F3C6;TROPHY;So;0;ON;;;;;N;;;;;
1F3C7;HORSE RACING;So;0;ON;;;;;N;;;;;
1F3C8;AMERICAN FOOTBALL;So;0;ON;;;;;N;;;;;
1F3C9;RUGBY FOOTBALL;So;0;ON;;;;;N;;;;;
1F3CA;SWIMMER;So;0;ON;;;;;N;;;;;
1F3CB;WEIGHT LIFTER;So;0;ON;;;;;N;;;;;
1F3CC;GOLFER;So;0;ON;;;;;N;;;;;
1F3CD;RACING MOTORCYCLE;So;0;ON;;;;;N;;;;;
1F3CE;RACING CAR;So;0;ON;;;;;N;;;;;
1F3CF;CRICKET BAT AND BALL;So;0;ON;;;;;N;;;;;
1F3D0;VOLLEYBALL;So;0;ON;;;;;N;;;;;
1F3D1;FIELD HOCKEY STICK AND BALL;So;0;ON;;;;;N;;;;;
1F3D2;ICE HOCKEY STICK AND PUCK;So;0;ON;;;;;N;;;;;
1F3D3;TABLE TENNIS PADDLE AND BALL;So;0;ON;;;;;N;;;;;
1F3D4;SNOW CAPPED MOUNTAIN;So;0;ON;;;;;N;;;;;
1F3D5;CAMPING;So;0;ON;;;;;N;;;;;
1F3D6;BEACH WITH UMBRELLA;So;0;ON;;;;;N;;;;;
1F3D7;BUILDING CONSTRUCTION;So;0;ON;;;;;N;;;;;
1F3D8;HOUSE BUILDINGS;So;0;ON;;;;;N;;;;;
1F3D9;CITYSCAPE;So;0;ON;;;;;N;;;;;
1F3DA;DERELICT HOUSE BUILDING;So;0;ON;;;;;N;;;;;
1F3DB;CLASSICAL BUILDING;So;0;ON;;;;;N;;;;;
1F3DC;DESERT;So;0;ON;;;;;N;;;;;
1F3DD;DESERT ISLAND;So;0;ON;;;;;N;;;;;
1F3DE;NATIONAL PARK;So;0;ON;;;;;N;;;;;
1F3DF;STADIUM;So;0;ON;;;;;N;;;;;
1F3E0;HOUSE BUILDING;So;0;ON;;;;;N;;;;;
1F3E1;HOUSE WITH GARDEN;So;0;ON;;;;;N;;;;;
1F3E2;OFFICE BUILDING;So;0;ON;;;;;N;;;;;
1F3E3;JAPANESE POST OFFICE;So;0;ON;;;;;N;;;;;
1F3E4;EUROPEAN POST OFFICE;So;0;ON;;;;;N;;;;;
1F3E5;HOSPITAL;So;0;ON;;;;;N;;;;;
1F3E6;BANK;So;0;ON;;;;;N;;;;;
1F3E7;AUTOMATED TELLER MACHINE;So;0;ON;;;;;N;;;;;
1F3E8;HOTEL;So;0;ON;;;;;N;;;;;
1F3E9;LOVE HOTEL;So;0;ON;;;;;N;;;;;
1F3EA;CONVENIENCE STORE;So;0;ON;;;;;N;;;;;
1F3EB;SCHOOL;So;0;ON;;;;;N;;;;;
1F3EC;DEPARTMENT STORE;So;0;ON;;;;;N;;;;;
1F3ED;FACTORY;So;0;ON;;;;;N;;;;;
1F3EE;IZAKAYA LANTERN;So;0;ON;;;;;N;;;;;
1F3EF;JAPANESE CASTLE;So;0;ON;;;;;N;;;;;
1F3F0;EUROPEAN CASTLE;So;0;ON;;;;;N;;;;;
1F3F1;WHITE PENNANT;So;0;ON;;;;;N;;;;;
1F3F2;BLACK PENNANT;So;0;ON;;;;;N;;;;;
1F3F3;WAVING WHITE FLAG;So;0;ON;;;;;N;;;;;
1F3F4;WAVING BLACK FLAG;So;0;ON;;;;;N;;;;;
1F3F5;ROSETTE;So;0;ON;;;;;N;;;;;
1F3F6;BLACK ROSETTE;So;0;ON;;;;;N;;;;;
1F3F7;LABEL;So;0;ON;;;;;N;;;;;
1F3F8;BADMINTON RACQUET AND SHUTTLECOCK;So;0;ON;;;;;N;;;;;
1F3F9;BOW AND ARROW;So;0;ON;;;;;N;;;;;
1F3FA;AMPHORA;So;0;ON;;;;;N;;;;;
1F3FB;EMOJI MODIFIER FITZPATRICK TYPE-1-2;Sk;0;ON;;;;;N;;;;;
1F3FC;EMOJI MODIFIER FITZPATRICK TYPE-3;Sk;0;ON;;;;;N;;;;;
1F3FD;EMOJI MODIFIER FITZPATRICK TYPE-4;Sk;0;ON;;;;;N;;;;;
1F3FE;EMOJI MODIFIER FITZPATRICK TYPE-5;Sk;0;ON;;;;;N;;;;;
1F3FF;EMOJI MODIFIER FITZPATRICK TYPE-6;Sk;0;ON;;;;;N;;;;;
1F400;RAT;So;0;ON;;;;;N;;;;;
1F401;MOUSE;So;0;ON;;;;;N;;;;;
1F402;OX;So;0;ON;;;;;N;;;;;
1F403;WATER BUFFALO;So;0;ON;;;;;N;;;;;
1F404;COW;So;0;ON;;;;;N;;;;;
1F405;TIGER;So;0;ON;;;;;N;;;;;
1F406;LEOPARD;So;0;ON;;;;;N;;;;;
1F407;RABBIT;So;0;ON;;;;;N;;;;;
1F408;CAT;So;0;ON;;;;;N;;;;;
1F409;DRAGON;So;0;ON;;;;;N;;;;;
1F40A;CROCODILE;So;0;ON;;;;;N;;;;;
1F40B;WHALE;So;0;ON;;;;;N;;;;;
1F40C;SNAIL;So;0;ON;;;;;N;;;;;
1F40D;SNAKE;So;0;ON;;;;;N;;;;;
1F40E;HORSE;So;0;ON;;;;;N;;;;;
1F40F;RAM;So;0;ON;;;;;N;;;;;
1F410;GOAT;So;0;ON;;;;;N;;;;;
1F411;SHEEP;So;0;ON;;;;;N;;;;;
1F412;MONKEY;So;0;ON;;;;;N;;;;;
1F413;ROOSTER;So;0;ON;;;;;N;;;;;
1F414;CHICKEN;So;0;ON;;;;;N;;;;;
1F415;DOG;So;0;ON;;;;;N;;;;;
1F416;PIG;So;0;ON;;;;;N;;;;;
1F417;BOAR;So;0;ON;;;;;N;;;;;
1F418;ELEPHANT;So;0;ON;;;;;N;;;;;
1F419;OCTOPUS;So;0;ON;;;;;N;;;;;
1F41A;SPIRAL SHELL;So;0;ON;;;;;N;;;;;
1F41B;BUG;So;0;ON;;;;;N;;;;;
1F41C;ANT;So;0;ON;;;;;N;;;;;
1F41D;HONEYBEE;So;0;ON;;;;;N;;;;;
1F41E;LADY BEETLE;So;0;ON;;;;;N;;;;;
1F41F;FISH;So;0;ON;;;;;N;;;;;
1F420;TROPICAL FISH;So;0;ON;;;;;N;;;;;
1F421;BLOWFISH;So;0;ON;;;;;N;;;;;
1F422;TURTLE;So;0;ON;;;;;N;;;;;
1F423;HATCHING CHICK;So;0;ON;;;;;N;;;;;
1F424;BABY CHICK;So;0;ON;;;;;N;;;;;
1F425;FRONT-FACING BABY CHICK;So;0;ON;;;;;N;;;;;
1F426;BIRD;So;0;ON;;;;;N;;;;;
1F427;PENGUIN;So;0;ON;;;;;N;;;;;
1F428;KOALA;So;0;ON;;;;;N;;;;;
1F429;POODLE;So;0;ON;;;;;N;;;;;
1F42A;DROMEDARY CAMEL;So;0;ON;;;;;N;;;;;
1F42B;BACTRIAN CAMEL;So;0;ON;;;;;N;;;;;
1F42C;DOLPHIN;So;0;ON;;;;;N;;;;;
1F42D;MOUSE FACE;So;0;ON;;;;;N;;;;;
1F42E;COW FACE;So;0;ON;;;;;N;;;;;
1F42F;TIGER FACE;So;0;ON;;;;;N;;;;;
1F430;RABBIT FACE;So;0;ON;;;;;N;;;;;
1F431;CAT FACE;So;0;ON;;;;;N;;;;;
1F432;DRAGON FACE;So;0;ON;;;;;N;;;;;
1F433;SPOUTING WHALE;So;0;ON;;;;;N;;;;;
1F434;HORSE FACE;So;0;ON;;;;;N;;;;;
1F435;MONKEY FACE;So;0;ON;;;;;N;;;;;
1F436;DOG FACE;So;0;ON;;;;;N;;;;;
1F437;PIG FACE;So;0;ON;;;;;N;;;;;
1F438;FROG FACE;So;0;ON;;;;;N;;;;;
1F439;HAMSTER FACE;So;0;ON;;;;;N;;;;;
1F43A;WOLF FACE;So;0;ON;;;;;N;;;;;
1F43B;BEAR FACE;So;0;ON;;;;;N;;;;;
1F43C;PANDA FACE;So;0;ON;;;;;N;;;;;
1F43D;PIG NOSE;So;0;ON;;;;;N;;;;;
1F43E;PAW PRINTS;So;0;ON;;;;;N;;;;;
1F43F;CHIPMUNK;So;0;ON;;;;;N;;;;;
1F440;EYES;So;0;ON;;;;;N;;;;;
1F441;EYE;So;0;ON;;;;;N;;;;;
1F442;EAR;So;0;ON;;;;;N;;;;;
1F443;NOSE;So;0;ON;;;;;N;;;;;
1F444;MOUTH;So;0;ON;;;;;N;;;;;
1F445;TONGUE;So;0;ON;;;;;N;;;;;
1F446;WHITE UP POINTING BACKHAND INDEX;So;0;ON;;;;;N;;;;;
1F447;WHITE DOWN POINTING BACKHAND INDEX;So;0;ON;;;;;N;;;;;
1F448;WHITE LEFT POINTING BACKHAND INDEX;So;0;ON;;;;;N;;;;;
1F449;WHITE RIGHT POINTING BACKHAND INDEX;So;0;ON;;;;;N;;;;;
1F44A;FISTED HAND SIGN;So;0;ON;;;;;N;;;;;
1F44B;WAVING HAND SIGN;So;0;ON;;;;;N;;;;;
1F44C;OK HAND SIGN;So;0;ON;;;;;N;;;;;
1F44D;THUMBS UP SIGN;So;0;ON;;;;;N;;;;;
1F44E;THUMBS DOWN SIGN;So;0;ON;;;;;N;;;;;
1F44F;CLAPPING HANDS SIGN;So;0;ON;;;;;N;;;;;
1F450;OPEN HANDS SIGN;So;0;ON;;;;;N;;;;;
1F451;CROWN;So;0;ON;;;;;N;;;;;
1F452;WOMANS HAT;So;0;ON;;;;;N;;;;;
1F453;EYEGLASSES;So;0;ON;;;;;N;;;;;
1F454;NECKTIE;So;0;ON;;;;;N;;;;;
1F455;T-SHIRT;So;0;ON;;;;;N;;;;;
1F456;JEANS;So;0;ON;;;;;N;;;;;
1F457;DRESS;So;0;ON;;;;;N;;;;;
1F458;KIMONO;So;0;ON;;;;;N;;;;;
1F459;BIKINI;So;0;ON;;;;;N;;;;;
1F45A;WOMANS CLOTHES;So;0;ON;;;;;N;;;;;
1F45B;PURSE;So;0;ON;;;;;N;;;;;
1F45C;HANDBAG;So;0;ON;;;;;N;;;;;
1F45D;POUCH;So;0;ON;;;;;N;;;;;
1F45E;MANS SHOE;So;0;ON;;;;;N;;;;;
1F45F;ATHLETIC SHOE;So;0;ON;;;;;N;;;;;
1F460;HIGH-HEELED SHOE;So;0;ON;;;;;N;;;;;
1F461;WOMANS SANDAL;So;0;ON;;;;;N;;;;;
1F462;WOMANS BOOTS;So;0;ON;;;;;N;;;;;
1F463;FOOTPRINTS;So;0;ON;;;;;N;;;;;
1F464;BUST IN SILHOUETTE;So;0;ON;;;;;N;;;;;
1F465;BUSTS IN SILHOUETTE;So;0;ON;;;;;N;;;;;
1F466;BOY;So;0;ON;;;;;N;;;;;
1F467;GIRL;So;0;ON;;;;;N;;;;;
1F468;MAN;So;0;ON;;;;;N;;;;;
1F469;WOMAN;So;0;ON;;;;;N;;;;;
1F46A;FAMILY;So;0;ON;;;;;N;;;;;
1F46B;MAN AND WOMAN HOLDING HANDS;So;0;ON;;;;;N;;;;;
1F46C;TWO MEN HOLDING HANDS;So;0;ON;;;;;N;;;;;
1F46D;TWO WOMEN HOLDING HANDS;So;0;ON;;;;;N;;;;;
1F46E;POLICE OFFICER;So;0;ON;;;;;N;;;;;
1F46F;WOMAN WITH BUNNY EARS;So;0;ON;;;;;N;;;;;
1F470;BRIDE WITH VEIL;So;0;ON;;;;;N;;;;;
1F471;PERSON WITH BLOND HAIR;So;0;ON;;;;;N;;;;;
1F472;MAN WITH GUA PI MAO;So;0;ON;;;;;N;;;;;
1F473;MAN WITH TURBAN;So;0;ON;;;;;N;;;;;
1F474;OLDER MAN;So;0;ON;;;;;N;;;;;
1F475;OLDER WOMAN;So;0;ON;;;;;N;;;;;
1F476;BABY;So;0;ON;;;;;N;;;;;
1F477;CONSTRUCTION WORKER;So;0;ON;;;;;N;;;;;
1F478;PRINCESS;So;0;ON;;;;;N;;;;;
1F479;JAPANESE OGRE;So;0;ON;;;;;N;;;;;
1F47A;JAPANESE GOBLIN;So;0;ON;;;;;N;;;;;
1F47B;GHOST;So;0;ON;;;;;N;;;;;
1F47C;BABY ANGEL;So;0;ON;;;;;N;;;;;
1F47D;EXTRATERRESTRIAL ALIEN;So;0;ON;;;;;N;;;;;
1F47E;ALIEN MONSTER;So;0;ON;;;;;N;;;;;
1F47F;IMP;So;0;ON;;;;;N;;;;;
1F480;SKULL;So;0;ON;;;;;N;;;;;
1F481;INFORMATION DESK PERSON;So;0;ON;;;;;N;;;;;
1F482;GUARDSMAN;So;0;ON;;;;;N;;;;;
1F483;DANCER;So;0;ON;;;;;N;;;;;
1F484;LIPSTICK;So;0;ON;;;;;N;;;;;
1F485;NAIL POLISH;So;0;ON;;;;;N;;;;;
1F486;FACE MASSAGE;So;0;ON;;;;;N;;;;;
1F487;HAIRCUT;So;0;ON;;;;;N;;;;;
1F488;BARBER POLE;So;0;ON;;;;;N;;;;;
1F489;SYRINGE;So;0;ON;;;;;N;;;;;
1F48A;PILL;So;0;ON;;;;;N;;;;;
1F48B;KISS MARK;So;0;ON;;;;;N;;;;;
1F48C;LOVE LETTER;So;0;ON;;;;;N;;;;;
1F48D;RING;So;0;ON;;;;;N;;;;;
1F48E;GEM STONE;So;0;ON;;;;;N;;;;;
1F48F;KISS;So;0;ON;;;;;N;;;;;
1F490;BOUQUET;So;0;ON;;;;;N;;;;;
1F491;COUPLE WITH HEART;So;0;ON;;;;;N;;;;;
1F492;WEDDING;So;0;ON;;;;;N;;;;;
1F493;BEATING HEART;So;0;ON;;;;;N;;;;;
1F494;BROKEN HEART;So;0;ON;;;;;N;;;;;
1F495;TWO HEARTS;So;0;ON;;;;;N;;;;;
1F496;SPARKLING HEART;So;0;ON;;;;;N;;;;;
1F497;GROWING HEART;So;0;ON;;;;;N;;;;;
1F498;HEART WITH ARROW;So;0;ON;;;;;N;;;;;
1F499;BLUE HEART;So;0;ON;;;;;N;;;;;
1F49A;GREEN HEART;So;0;ON;;;;;N;;;;;
1F49B;YELLOW HEART;So;0;ON;;;;;N;;;;;
1F49C;PURPLE HEART;So;0;ON;;;;;N;;;;;
1F49D;HEART WITH RIBBON;So;0;ON;;;;;N;;;;;
1F49E;REVOLVING HEARTS;So;0;ON;;;;;N;;;;;
1F49F;HEART DECORATION;So;0;ON;;;;;N;;;;;
1F4A0;DIAMOND SHAPE WITH A DOT INSIDE;So;0;ON;;;;;N;;;;;
1F4A1;ELECTRIC LIGHT BULB;So;0;ON;;;;;N;;;;;
1F4A2;ANGER SYMBOL;So;0;ON;;;;;N;;;;;
1F4A3;BOMB;So;0;ON;;;;;N;;;;;
1F4A4;SLEEPING SYMBOL;So;0;ON;;;;;N;;;;;
1F4A5;COLLISION SYMBOL;So;0;ON;;;;;N;;;;;
1F4A6;SPLASHING SWEAT SYMBOL;So;0;ON;;;;;N;;;;;
1F4A7;DROPLET;So;0;ON;;;;;N;;;;;
1F4A8;DASH SYMBOL;So;0;ON;;;;;N;;;;;
1F4A9;PILE OF POO;So;0;ON;;;;;N;;;;;
1F4AA;FLEXED BICEPS;So;0;ON;;;;;N;;;;;
1F4AB;DIZZY SYMBOL;So;0;ON;;;;;N;;;;;
1F4AC;SPEECH BALLOON;So;0;ON;;;;;N;;;;;
1F4AD;THOUGHT BALLOON;So;0;ON;;;;;N;;;;;
1F4AE;WHITE FLOWER;So;0;ON;;;;;N;;;;;
1F4AF;HUNDRED POINTS SYMBOL;So;0;ON;;;;;N;;;;;
1F4B0;MONEY BAG;So;0;ON;;;;;N;;;;;
1F4B1;CURRENCY EXCHANGE;So;0;ON;;;;;N;;;;;
1F4B2;HEAVY DOLLAR SIGN;So;0;ON;;;;;N;;;;;
1F4B3;CREDIT CARD;So;0;ON;;;;;N;;;;;
1F4B4;BANKNOTE WITH YEN SIGN;So;0;ON;;;;;N;;;;;
1F4B5;BANKNOTE WITH DOLLAR SIGN;So;0;ON;;;;;N;;;;;
1F4B6;BANKNOTE WITH EURO SIGN;So;0;ON;;;;;N;;;;;
1F4B7;BANKNOTE WITH POUND SIGN;So;0;ON;;;;;N;;;;;
1F4B8;MONEY WITH WINGS;So;0;ON;;;;;N;;;;;
1F4B9;CHART WITH UPWARDS TREND AND YEN SIGN;So;0;ON;;;;;N;;;;;
1F4BA;SEAT;So;0;ON;;;;;N;;;;;
1F4BB;PERSONAL COMPUTER;So;0;ON;;;;;N;;;;;
1F4BC;BRIEFCASE;So;0;ON;;;;;N;;;;;
1F4BD;MINIDISC;So;0;ON;;;;;N;;;;;
1F4BE;FLOPPY DISK;So;0;ON;;;;;N;;;;;
1F4BF;OPTICAL DISC;So;0;ON;;;;;N;;;;;
1F4C0;DVD;So;0;ON;;;;;N;;;;;
1F4C1;FILE FOLDER;So;0;ON;;;;;N;;;;;
1F4C2;OPEN FILE FOLDER;So;0;ON;;;;;N;;;;;
1F4C3;PAGE WITH CURL;So;0;ON;;;;;N;;;;;
1F4C4;PAGE FACING UP;So;0;ON;;;;;N;;;;;
1F4C5;CALENDAR;So;0;ON;;;;;N;;;;;
1F4C6;TEAR-OFF CALENDAR;So;0;ON;;;;;N;;;;;
1F4C7;CARD INDEX;So;0;ON;;;;;N;;;;;
1F4C8;CHART WITH UPWARDS TREND;So;0;ON;;;;;N;;;;;
1F4C9;CHART WITH DOWNWARDS TREND;So;0;ON;;;;;N;;;;;
1F4CA;BAR CHART;So;0;ON;;;;;N;;;;;
1F4CB;CLIPBOARD;So;0;ON;;;;;N;;;;;
1F4CC;PUSHPIN;So;0;ON;;;;;N;;;;;
1F4CD;ROUND PUSHPIN;So;0;ON;;;;;N;;;;;
1F4CE;PAPERCLIP;So;0;ON;;;;;N;;;;;
1F4CF;STRAIGHT RULER;So;0;ON;;;;;N;;;;;
1F4D0;TRIANGULAR RULER;So;0;ON;;;;;N;;;;;
1F4D1;BOOKMARK TABS;So;0;ON;;;;;N;;;;;
1F4D2;LEDGER;So;0;ON;;;;;N;;;;;
1F4D3;NOTEBOOK;So;0;ON;;;;;N;;;;;
1F4D4;NOTEBOOK WITH DECORATIVE COVER;So;0;ON;;;;;N;;;;;
1F4D5;CLOSED BOOK;So;0;ON;;;;;N;;;;;
1F4D6;OPEN BOOK;So;0;ON;;;;;N;;;;;
1F4D7;GREEN BOOK;So;0;ON;;;;;N;;;;;
1F4D8;BLUE BOOK;So;0;ON;;;;;N;;;;;
1F4D9;ORANGE BOOK;So;0;ON;;;;;N;;;;;
1F4DA;BOOKS;So;0;ON;;;;;N;;;;;
1F4DB;NAME BADGE;So;0;ON;;;;;N;;;;;
1F4DC;SCROLL;So;0;ON;;;;;N;;;;;
1F4DD;MEMO;So;0;ON;;;;;N;;;;;
1F4DE;TELEPHONE RECEIVER;So;0;ON;;;;;N;;;;;
1F4DF;PAGER;So;0;ON;;;;;N;;;;;
1F4E0;FAX MACHINE;So;0;ON;;;;;N;;;;;
1F4E1;SATELLITE ANTENNA;So;0;ON;;;;;N;;;;;
1F4E2;PUBLIC ADDRESS LOUDSPEAKER;So;0;ON;;;;;N;;;;;
1F4E3;CHEERING MEGAPHONE;So;0;ON;;;;;N;;;;;
1F4E4;OUTBOX TRAY;So;0;ON;;;;;N;;;;;
1F4E5;INBOX TRAY;So;0;ON;;;;;N;;;;;
1F4E6;PACKAGE;So;0;ON;;;;;N;;;;;
1F4E7;E-MAIL SYMBOL;So;0;ON;;;;;N;;;;;
1F4E8;INCOMING ENVELOPE;So;0;ON;;;;;N;;;;;
1F4E9;ENVELOPE WITH DOWNWARDS ARROW ABOVE;So;0;ON;;;;;N;;;;;
1F4EA;CLOSED MAILBOX WITH LOWERED FLAG;So;0;ON;;;;;N;;;;;
1F4EB;CLOSED MAILBOX WITH RAISED FLAG;So;0;ON;;;;;N;;;;;
1F4EC;OPEN MAILBOX WITH RAISED FLAG;So;0;ON;;;;;N;;;;;
1F4ED;OPEN MAILBOX WITH LOWERED FLAG;So;0;ON;;;;;N;;;;;
1F4EE;POSTBOX;So;0;ON;;;;;N;;;;;
1F4EF;POSTAL HORN;So;0;ON;;;;;N;;;;;
1F4F0;NEWSPAPER;So;0;ON;;;;;N;;;;;
1F4F1;MOBILE PHONE;So;0;ON;;;;;N;;;;;
1F4F2;MOBILE PHONE WITH RIGHTWARDS ARROW AT LEFT;So;0;ON;;;;;N;;;;;
1F4F3;VIBRATION MODE;So;0;ON;;;;;N;;;;;
1F4F4;MOBILE PHONE OFF;So;0;ON;;;;;N;;;;;
1F4F5;NO MOBILE PHONES;So;0;ON;;;;;N;;;;;
1F4F6;ANTENNA WITH BARS;So;0;ON;;;;;N;;;;;
1F4F7;CAMERA;So;0;ON;;;;;N;;;;;
1F4F8;CAMERA WITH FLASH;So;0;ON;;;;;N;;;;;
1F4F9;VIDEO CAMERA;So;0;ON;;;;;N;;;;;
1F4FA;TELEVISION;So;0;ON;;;;;N;;;;;
1F4FB;RADIO;So;0;ON;;;;;N;;;;;
1F4FC;VIDEOCASSETTE;So;0;ON;;;;;N;;;;;
1F4FD;FILM PROJECTOR;So;0;ON;;;;;N;;;;;
1F4FE;PORTABLE STEREO;So;0;ON;;;;;N;;;;;
1F4FF;PRAYER BEADS;So;0;ON;;;;;N;;;;;
1F500;TWISTED RIGHTWARDS ARROWS;So;0;ON;;;;;N;;;;;
1F501;CLOCKWISE RIGHTWARDS AND LEFTWARDS OPEN CIRCLE ARROWS;So;0;ON;;;;;N;;;;;
1F502;CLOCKWISE RIGHTWARDS AND LEFTWARDS OPEN CIRCLE ARROWS WITH CIRCLED ONE OVERLAY;So;0;ON;;;;;N;;;;;
1F503;CLOCKWISE DOWNWARDS AND UPWARDS OPEN CIRCLE ARROWS;So;0;ON;;;;;N;;;;;
1F504;ANTICLOCKWISE DOWNWARDS AND UPWARDS OPEN CIRCLE ARROWS;So;0;ON;;;;;N;;;;;
1F505;LOW BRIGHTNESS SYMBOL;So;0;ON;;;;;N;;;;;
1F506;HIGH BRIGHTNESS SYMBOL;So;0;ON;;;;;N;;;;;
1F507;SPEAKER WITH CANCELLATION STROKE;So;0;ON;;;;;N;;;;;
1F508;SPEAKER;So;0;ON;;;;;N;;;;;
1F509;SPEAKER WITH ONE SOUND WAVE;So;0;ON;;;;;N;;;;;
1F50A;SPEAKER WITH THREE SOUND WAVES;So;0;ON;;;;;N;;;;;
1F50B;BATTERY;So;0;ON;;;;;N;;;;;
1F50C;ELECTRIC PLUG;So;0;ON;;;;;N;;;;;
1F50D;LEFT-POINTING MAGNIFYING GLASS;So;0;ON;;;;;N;;;;;
1F50E;RIGHT-POINTING MAGNIFYING GLASS;So;0;ON;;;;;N;;;;;
1F50F;LOCK WITH INK PEN;So;0;ON;;;;;N;;;;;
1F510;CLOSED LOCK WITH KEY;So;0;ON;;;;;N;;;;;
1F511;KEY;So;0;ON;;;;;N;;;;;
1F512;LOCK;So;0;ON;;;;;N;;;;;
1F513;OPEN LOCK;So;0;ON;;;;;N;;;;;
1F514;BELL;So;0;ON;;;;;N;;;;;
1F515;BELL WITH CANCELLATION STROKE;So;0;ON;;;;;N;;;;;
1F516;BOOKMARK;So;0;ON;;;;;N;;;;;
1F517;LINK SYMBOL;So;0;ON;;;;;N;;;;;
1F518;RADIO BUTTON;So;0;ON;;;;;N;;;;;
1F519;BACK WITH LEFTWARDS ARROW ABOVE;So;0;ON;;;;;N;;;;;
1F51A;END WITH LEFTWARDS ARROW ABOVE;So;0;ON;;;;;N;;;;;
1F51B;ON WITH EXCLAMATION MARK WITH LEFT RIGHT ARROW ABOVE;So;0;ON;;;;;N;;;;;
1F51C;SOON WITH RIGHTWARDS ARROW ABOVE;So;0;ON;;;;;N;;;;;
1F51D;TOP WITH UPWARDS ARROW ABOVE;So;0;ON;;;;;N;;;;;
1F51E;NO ONE UNDER EIGHTEEN SYMBOL;So;0;ON;;;;;N;;;;;
1F51F;KEYCAP TEN;So;0;ON;;;;;N;;;;;
1F520;INPUT SYMBOL FOR LATIN CAPITAL LETTERS;So;0;ON;;;;;N;;;;;
1F521;INPUT SYMBOL FOR LATIN SMALL LETTERS;So;0;ON;;;;;N;;;;;
1F522;INPUT SYMBOL FOR NUMBERS;So;0;ON;;;;;N;;;;;
1F523;INPUT SYMBOL FOR SYMBOLS;So;0;ON;;;;;N;;;;;
1F524;INPUT SYMBOL FOR LATIN LETTERS;So;0;ON;;;;;N;;;;;
1F525;FIRE;So;0;ON;;;;;N;;;;;
1F526;ELECTRIC TORCH;So;0;ON;;;;;N;;;;;
1F527;WRENCH;So;0;ON;;;;;N;;;;;
1F528;HAMMER;So;0;ON;;;;;N;;;;;
1F529;NUT AND BOLT;So;0;ON;;;;;N;;;;;
1F52A;HOCHO;So;0;ON;;;;;N;;;;;
1F52B;PISTOL;So;0;ON;;;;;N;;;;;
1F52C;MICROSCOPE;So;0;ON;;;;;N;;;;;
1F52D;TELESCOPE;So;0;ON;;;;;N;;;;;
1F52E;CRYSTAL BALL;So;0;ON;;;;;N;;;;;
1F52F;SIX POINTED STAR WITH MIDDLE DOT;So;0;ON;;;;;N;;;;;
1F530;JAPANESE SYMBOL FOR BEGINNER;So;0;ON;;;;;N;;;;;
1F531;TRIDENT EMBLEM;So;0;ON;;;;;N;;;;;
1F532;BLACK SQUARE BUTTON;So;0;ON;;;;;N;;;;;
1F533;WHITE SQUARE BUTTON;So;0;ON;;;;;N;;;;;
1F534;LARGE RED CIRCLE;So;0;ON;;;;;N;;;;;
1F535;LARGE BLUE CIRCLE;So;0;ON;;;;;N;;;;;
1F536;LARGE ORANGE DIAMOND;So;0;ON;;;;;N;;;;;
1F537;LARGE BLUE DIAMOND;So;0;ON;;;;;N;;;;;
1F538;SMALL ORANGE DIAMOND;So;0;ON;;;;;N;;;;;
1F539;SMALL BLUE DIAMOND;So;0;ON;;;;;N;;;;;
1F53A;UP-POINTING RED TRIANGLE;So;0;ON;;;;;N;;;;;
1F53B;DOWN-POINTING RED TRIANGLE;So;0;ON;;;;;N;;;;;
1F53C;UP-POINTING SMALL RED TRIANGLE;So;0;ON;;;;;N;;;;;
1F53D;DOWN-POINTING SMALL RED TRIANGLE;So;0;ON;;;;;N;;;;;
1F53E;LOWER RIGHT SHADOWED WHITE CIRCLE;So;0;ON;;;;;N;;;;;
1F53F;UPPER RIGHT SHADOWED WHITE CIRCLE;So;0;ON;;;;;N;;;;;
1F540;CIRCLED CROSS POMMEE;So;0;ON;;;;;N;;;;;
1F541;CROSS POMMEE WITH HALF-CIRCLE BELOW;So;0;ON;;;;;N;;;;;
1F542;CROSS POMMEE;So;0;ON;;;;;N;;;;;
1F543;NOTCHED LEFT SEMICIRCLE WITH THREE DOTS;So;0;ON;;;;;N;;;;;
1F544;NOTCHED RIGHT SEMICIRCLE WITH THREE DOTS;So;0;ON;;;;;N;;;;;
1F545;SYMBOL FOR MARKS CHAPTER;So;0;ON;;;;;N;;;;;
1F546;WHITE LATIN CROSS;So;0;ON;;;;;N;;;;;
1F547;HEAVY LATIN CROSS;So;0;ON;;;;;N;;;;;
1F548;CELTIC CROSS;So;0;ON;;;;;N;;;;;
1F549;OM SYMBOL;So;0;ON;;;;;N;;;;;
1F54A;DOVE OF PEACE;So;0;ON;;;;;N;;;;;
1F54B;KAABA;So;0;ON;;;;;N;;;;;
1F54C;MOSQUE;So;0;ON;;;;;N;;;;;
1F54D;SYNAGOGUE;So;0;ON;;;;;N;;;;;
1F54E;MENORAH WITH NINE BRANCHES;So;0;ON;;;;;N;;;;;
1F54F;BOWL OF HYGIEIA;So;0;ON;;;;;N;;;;;
1F550;CLOCK FACE ONE OCLOCK;So;0;ON;;;;;N;;;;;
1F551;CLOCK FACE TWO OCLOCK;So;0;ON;;;;;N;;;;;
1F552;CLOCK FACE THREE OCLOCK;So;0;ON;;;;;N;;;;;
1F553;CLOCK FACE FOUR OCLOCK;So;0;ON;;;;;N;;;;;
1F554;CLOCK FACE FIVE OCLOCK;So;0;ON;;;;;N;;;;;
1F555;CLOCK FACE SIX OCLOCK;So;0;ON;;;;;N;;;;;
1F556;CLOCK FACE SEVEN OCLOCK;So;0;ON;;;;;N;;;;;
1F557;CLOCK FACE EIGHT OCLOCK;So;0;ON;;;;;N;;;;;
1F558;CLOCK FACE NINE OCLOCK;So;0;ON;;;;;N;;;;;
1F559;CLOCK FACE TEN OCLOCK;So;0;ON;;;;;N;;;;;
1F55A;CLOCK FACE ELEVEN OCLOCK;So;0;ON;;;;;N;;;;;
1F55B;CLOCK FACE TWELVE OCLOCK;So;0;ON;;;;;N;;;;;
1F55C;CLOCK FACE ONE-THIRTY;So;0;ON;;;;;N;;;;;
1F55D;CLOCK FACE TWO-THIRTY;So;0;ON;;;;;N;;;;;
1F55E;CLOCK FACE THREE-THIRTY;So;0;ON;;;;;N;;;;;
1F55F;CLOCK FACE FOUR-THIRTY;So;0;ON;;;;;N;;;;;
1F560;CLOCK FACE FIVE-THIRTY;So;0;ON;;;;;N;;;;;
1F561;CLOCK FACE SIX-THIRTY;So;0;ON;;;;;N;;;;;
1F562;CLOCK FACE SEVEN-THIRTY;So;0;ON;;;;;N;;;;;
1F563;CLOCK FACE EIGHT-THIRTY;So;0;ON;;;;;N;;;;;
1F564;CLOCK FACE NINE-THIRTY;So;0;ON;;;;;N;;;;;
1F565;CLOCK FACE TEN-THIRTY;So;0;ON;;;;;N;;;;;
1F566;CLOCK FACE ELEVEN-THIRTY;So;0;ON;;;;;N;;;;;
1F567;CLOCK FACE TWELVE-THIRTY;So;0;ON;;;;;N;;;;;
1F568;RIGHT SPEAKER;So;0;ON;;;;;N;;;;;
1F569;RIGHT SPEAKER WITH ONE SOUND WAVE;So;0;ON;;;;;N;;;;;
1F56A;RIGHT SPEAKER WITH THREE SOUND WAVES;So;0;ON;;;;;N;;;;;
1F56B;BULLHORN;So;0;ON;;;;;N;;;;;
1F56C;BULLHORN WITH SOUND WAVES;So;0;ON;;;;;N;;;;;
1F56D;RINGING BELL;So;0;ON;;;;;N;;;;;
1F56E;BOOK;So;0;ON;;;;;N;;;;;
1F56F;CANDLE;So;0;ON;;;;;N;;;;;
1F570;MANTELPIECE CLOCK;So;0;ON;;;;;N;;;;;
1F571;BLACK SKULL AND CROSSBONES;So;0;ON;;;;;N;;;;;
1F572;NO PIRACY;So;0;ON;;;;;N;;;;;
1F573;HOLE;So;0;ON;;;;;N;;;;;
1F574;MAN IN BUSINESS SUIT LEVITATING;So;0;ON;;;;;N;;;;;
1F575;SLEUTH OR SPY;So;0;ON;;;;;N;;;;;
1F576;DARK SUNGLASSES;So;0;ON;;;;;N;;;;;
1F577;SPIDER;So;0;ON;;;;;N;;;;;
1F578;SPIDER WEB;So;0;ON;;;;;N;;;;;
1F579;JOYSTICK;So;0;ON;;;;;N;;;;;
1F57A;MAN DANCING;So;0;ON;;;;;N;;;;;
1F57B;LEFT HAND TELEPHONE RECEIVER;So;0;ON;;;;;N;;;;;
1F57C;TELEPHONE RECEIVER WITH PAGE;So;0;ON;;;;;N;;;;;
1F57D;RIGHT HAND TELEPHONE RECEIVER;So;0;ON;;;;;N;;;;;
1F57E;WHITE TOUCHTONE TELEPHONE;So;0;ON;;;;;N;;;;;
1F57F;BLACK TOUCHTONE TELEPHONE;So;0;ON;;;;;N;;;;;
1F580;TELEPHONE ON TOP OF MODEM;So;0;ON;;;;;N;;;;;
1F581;CLAMSHELL MOBILE PHONE;So;0;ON;;;;;N;;;;;
1F582;BACK OF ENVELOPE;So;0;ON;;;;;N;;;;;
1F583;STAMPED ENVELOPE;So;0;ON;;;;;N;;;;;
1F584;ENVELOPE WITH LIGHTNING;So;0;ON;;;;;N;;;;;
1F585;FLYING ENVELOPE;So;0;ON;;;;;N;;;;;
1F586;PEN OVER STAMPED ENVELOPE;So;0;ON;;;;;N;;;;;
1F587;LINKED PAPERCLIPS;So;0;ON;;;;;N;;;;;
1F588;BLACK PUSHPIN;So;0;ON;;;;;N;;;;;
1F589;LOWER LEFT PENCIL;So;0;ON;;;;;N;;;;;
1F58A;LOWER LEFT BALLPOINT PEN;So;0;ON;;;;;N;;;;;
1F58B;LOWER LEFT FOUNTAIN PEN;So;0;ON;;;;;N;;;;;
1F58C;LOWER LEFT PAINTBRUSH;So;0;ON;;;;;N;;;;;
1F58D;LOWER LEFT CRAYON;So;0;ON;;;;;N;;;;;
1F58E;LEFT WRITING HAND;So;0;ON;;;;;N;;;;;
1F58F;TURNED OK HAND SIGN;So;0;ON;;;;;N;;;;;
1F590;RAISED HAND WITH FINGERS SPLAYED;So;0;ON;;;;;N;;;;;
1F591;REVERSED RAISED HAND WITH FINGERS SPLAYED;So;0;ON;;;;;N;;;;;
1F592;REVERSED THUMBS UP SIGN;So;0;ON;;;;;N;;;;;
1F593;REVERSED THUMBS DOWN SIGN;So;0;ON;;;;;N;;;;;
1F594;REVERSED VICTORY HAND;So;0;ON;;;;;N;;;;;
1F595;REVERSED HAND WITH MIDDLE FINGER EXTENDED;So;0;ON;;;;;N;;;;;
1F596;RAISED HAND WITH PART BETWEEN MIDDLE AND RING FINGERS;So;0;ON;;;;;N;;;;;
1F597;WHITE DOWN POINTING LEFT HAND INDEX;So;0;ON;;;;;N;;;;;
1F598;SIDEWAYS WHITE LEFT POINTING INDEX;So;0;ON;;;;;N;;;;;
1F599;SIDEWAYS WHITE RIGHT POINTING INDEX;So;0;ON;;;;;N;;;;;
1F59A;SIDEWAYS BLACK LEFT POINTING INDEX;So;0;ON;;;;;N;;;;;
1F59B;SIDEWAYS BLACK RIGHT POINTING INDEX;So;0;ON;;;;;N;;;;;
1F59C;BLACK LEFT POINTING BACKHAND INDEX;So;0;ON;;;;;N;;;;;
1F59D;BLACK RIGHT POINTING BACKHAND INDEX;So;0;ON;;;;;N;;;;;
1F59E;SIDEWAYS WHITE UP POINTING INDEX;So;0;ON;;;;;N;;;;;
1F59F;SIDEWAYS WHITE DOWN POINTING INDEX;So;0;ON;;;;;N;;;;;
1F5A0;SIDEWAYS BLACK UP POINTING INDEX;So;0;ON;;;;;N;;;;;
1F5A1;SIDEWAYS BLACK DOWN POINTING INDEX;So;0;ON;;;;;N;;;;;
1F5A2;BLACK UP POINTING BACKHAND INDEX;So;0;ON;;;;;N;;;;;
1F5A3;BLACK DOWN POINTING BACKHAND INDEX;So;0;ON;;;;;N;;;;;
1F5A4;BLACK HEART;So;0;ON;;;;;N;;;;;
1F5A5;DESKTOP COMPUTER;So;0;ON;;;;;N;;;;;
1F5A6;KEYBOARD AND MOUSE;So;0;ON;;;;;N;;;;;
1F5A7;THREE NETWORKED COMPUTERS;So;0;ON;;;;;N;;;;;
1F5A8;PRINTER;So;0;ON;;;;;N;;;;;
1F5A9;POCKET CALCULATOR;So;0;ON;;;;;N;;;;;
1F5AA;BLACK HARD SHELL FLOPPY DISK;So;0;ON;;;;;N;;;;;
1F5AB;WHITE HARD SHELL FLOPPY DISK;So;0;ON;;;;;N;;;;;
1F5AC;SOFT SHELL FLOPPY DISK;So;0;ON;;;;;N;;;;;
1F5AD;TAPE CARTRIDGE;So;0;ON;;;;;N;;;;;
1F5AE;WIRED KEYBOARD;So;0;ON;;;;;N;;;;;
1F5AF;ONE BUTTON MOUSE;So;0;ON;;;;;N;;;;;
1F5B0;TWO BUTTON MOUSE;So;0;ON;;;;;N;;;;;
1F5B1;THREE BUTTON MOUSE;So;0;ON;;;;;N;;;;;
1F5B2;TRACKBALL;So;0;ON;;;;;N;;;;;
1F5B3;OLD PERSONAL COMPUTER;So;0;ON;;;;;N;;;;;
1F5B4;HARD DISK;So;0;ON;;;;;N;;;;;
1F5B5;SCREEN;So;0;ON;;;;;N;;;;;
1F5B6;PRINTER ICON;So;0;ON;;;;;N;;;;;
1F5B7;FAX ICON;So;0;ON;;;;;N;;;;;
1F5B8;OPTICAL DISC ICON;So;0;ON;;;;;N;;;;;
1F5B9;DOCUMENT WITH TEXT;So;0;ON;;;;;N;;;;;
1F5BA;DOCUMENT WITH TEXT AND PICTURE;So;0;ON;;;;;N;;;;;
1F5BB;DOCUMENT WITH PICTURE;So;0;ON;;;;;N;;;;;
1F5BC;FRAME WITH PICTURE;So;0;ON;;;;;N;;;;;
1F5BD;FRAME WITH TILES;So;0;ON;;;;;N;;;;;
1F5BE;FRAME WITH AN X;So;0;ON;;;;;N;;;;;
1F5BF;BLACK FOLDER;So;0;ON;;;;;N;;;;;
1F5C0;FOLDER;So;0;ON;;;;;N;;;;;
1F5C1;OPEN FOLDER;So;0;ON;;;;;N;;;;;
1F5C2;CARD INDEX DIVIDERS;So;0;ON;;;;;N;;;;;
1F5C3;CARD FILE BOX;So;0;ON;;;;;N;;;;;
1F5C4;FILE CABINET;So;0;ON;;;;;N;;;;;
1F5C5;EMPTY NOTE;So;0;ON;;;;;N;;;;;
1F5C6;EMPTY NOTE PAGE;So;0;ON;;;;;N;;;;;
1F5C7;EMPTY NOTE PAD;So;0;ON;;;;;N;;;;;
1F5C8;NOTE;So;0;ON;;;;;N;;;;;
1F5C9;NOTE PAGE;So;0;ON;;;;;N;;;;;
1F5CA;NOTE PAD;So;0;ON;;;;;N;;;;;
1F5CB;EMPTY DOCUMENT;So;0;ON;;;;;N;;;;;
1F5CC;EMPTY PAGE;So;0;ON;;;;;N;;;;;
1F5CD;EMPTY PAGES;So;0;ON;;;;;N;;;;;
1F5CE;DOCUMENT;So;0;ON;;;;;N;;;;;
1F5CF;PAGE;So;0;ON;;;;;N;;;;;
1F5D0;PAGES;So;0;ON;;;;;N;;;;;
1F5D1;WASTEBASKET;So;0;ON;;;;;N;;;;;
1F5D2;SPIRAL NOTE PAD;So;0;ON;;;;;N;;;;;
1F5D3;SPIRAL CALENDAR PAD;So;0;ON;;;;;N;;;;;
1F5D4;DESKTOP WINDOW;So;0;ON;;;;;N;;;;;
1F5D5;MINIMIZE;So;0;ON;;;;;N;;;;;
1F5D6;MAXIMIZE;So;0;ON;;;;;N;;;;;
1F5D7;OVERLAP;So;0;ON;;;;;N;;;;;
1F5D8;CLOCKWISE RIGHT AND LEFT SEMICIRCLE ARROWS;So;0;ON;;;;;N;;;;;
1F5D9;CANCELLATION X;So;0;ON;;;;;N;;;;;
1F5DA;INCREASE FONT SIZE SYMBOL;So;0;ON;;;;;N;;;;;
1F5DB;DECREASE FONT SIZE SYMBOL;So;0;ON;;;;;N;;;;;
1F5DC;COMPRESSION;So;0;ON;;;;;N;;;;;
1F5DD;OLD KEY;So;0;ON;;;;;N;;;;;
1F5DE;ROLLED-UP NEWSPAPER;So;0;ON;;;;;N;;;;;
1F5DF;PAGE WITH CIRCLED TEXT;So;0;ON;;;;;N;;;;;
1F5E0;STOCK CHART;So;0;ON;;;;;N;;;;;
1F5E1;DAGGER KNIFE;So;0;ON;;;;;N;;;;;
1F5E2;LIPS;So;0;ON;;;;;N;;;;;
1F5E3;SPEAKING HEAD IN SILHOUETTE;So;0;ON;;;;;N;;;;;
1F5E4;THREE RAYS ABOVE;So;0;ON;;;;;N;;;;;
1F5E5;THREE RAYS BELOW;So;0;ON;;;;;N;;;;;
1F5E6;THREE RAYS LEFT;So;0;ON;;;;;N;;;;;
1F5E7;THREE RAYS RIGHT;So;0;ON;;;;;N;;;;;
1F5E8;LEFT SPEECH BUBBLE;So;0;ON;;;;;N;;;;;
1F5E9;RIGHT SPEECH BUBBLE;So;0;ON;;;;;N;;;;;
1F5EA;TWO SPEECH BUBBLES;So;0;ON;;;;;N;;;;;
1F5EB;THREE SPEECH BUBBLES;So;0;ON;;;;;N;;;;;
1F5EC;LEFT THOUGHT BUBBLE;So;0;ON;;;;;N;;;;;
1F5ED;RIGHT THOUGHT BUBBLE;So;0;ON;;;;;N;;;;;
1F5EE;LEFT ANGER BUBBLE;So;0;ON;;;;;N;;;;;
1F5EF;RIGHT ANGER BUBBLE;So;0;ON;;;;;N;;;;;
1F5F0;MOOD BUBBLE;So;0;ON;;;;;N;;;;;
1F5F1;LIGHTNING MOOD BUBBLE;So;0;ON;;;;;N;;;;;
1F5F2;LIGHTNING MOOD;So;0;ON;;;;;N;;;;;
1F5F3;BALLOT BOX WITH BALLOT;So;0;ON;;;;;N;;;;;
1F5F4;BALLOT SCRIPT X;So;0;ON;;;;;N;;;;;
1F5F5;BALLOT BOX WITH SCRIPT X;So;0;ON;;;;;N;;;;;
1F5F6;BALLOT BOLD SCRIPT X;So;0;ON;;;;;N;;;;;
1F5F7;BALLOT BOX WITH BOLD SCRIPT X;So;0;ON;;;;;N;;;;;
1F5F8;LIGHT CHECK MARK;So;0;ON;;;;;N;;;;;
1F5F9;BALLOT BOX WITH BOLD CHECK;So;0;ON;;;;;N;;;;;
1F5FA;WORLD MAP;So;0;ON;;;;;N;;;;;
1F5FB;MOUNT FUJI;So;0;ON;;;;;N;;;;;
1F5FC;TOKYO TOWER;So;0;ON;;;;;N;;;;;
1F5FD;STATUE OF LIBERTY;So;0;ON;;;;;N;;;;;
1F5FE;SILHOUETTE OF JAPAN;So;0;ON;;;;;N;;;;;
1F5FF;MOYAI;So;0;ON;;;;;N;;;;;
1F600;GRINNING FACE;So;0;ON;;;;;N;;;;;
1F601;GRINNING FACE WITH SMILING EYES;So;0;ON;;;;;N;;;;;
1F602;FACE WITH TEARS OF JOY;So;0;ON;;;;;N;;;;;
1F603;SMILING FACE WITH OPEN MOUTH;So;0;ON;;;;;N;;;;;
1F604;SMILING FACE WITH OPEN MOUTH AND SMILING EYES;So;0;ON;;;;;N;;;;;
1F605;SMILING FACE WITH OPEN MOUTH AND COLD SWEAT;So;0;ON;;;;;N;;;;;
1F606;SMILING FACE WITH OPEN MOUTH AND TIGHTLY-CLOSED EYES;So;0;ON;;;;;N;;;;;
1F607;SMILING FACE WITH HALO;So;0;ON;;;;;N;;;;;
1F608;SMILING FACE WITH HORNS;So;0;ON;;;;;N;;;;;
1F609;WINKING FACE;So;0;ON;;;;;N;;;;;
1F60A;SMILING FACE WITH SMILING EYES;So;0;ON;;;;;N;;;;;
1F60B;FACE SAVOURING DELICIOUS FOOD;So;0;ON;;;;;N;;;;;
1F60C;RELIEVED FACE;So;0;ON;;;;;N;;;;;
1F60D;SMILING FACE WITH HEART-SHAPED EYES;So;0;ON;;;;;N;;;;;
1F60E;SMILING FACE WITH SUNGLASSES;So;0;ON;;;;;N;;;;;
1F60F;SMIRKING FACE;So;0;ON;;;;;N;;;;;
1F610;NEUTRAL FACE;So;0;ON;;;;;N;;;;;
1F611;EXPRESSIONLESS FACE;So;0;ON;;;;;N;;;;;
1F612;UNAMUSED FACE;So;0;ON;;;;;N;;;;;
1F613;FACE WITH COLD SWEAT;So;0;ON;;;;;N;;;;;
1F614;PENSIVE FACE;So;0;ON;;;;;N;;;;;
1F615;CONFUSED FACE;So;0;ON;;;;;N;;;;;
1F616;CONFOUNDED FACE;So;0;ON;;;;;N;;;;;
1F617;KISSING FACE;So;0;ON;;;;;N;;;;;
1F618;FACE THROWING A KISS;So;0;ON;;;;;N;;;;;
1F619;KISSING FACE WITH SMILING EYES;So;0;ON;;;;;N;;;;;
1F61A;KISSING FACE WITH CLOSED EYES;So;0;ON;;;;;N;;;;;
1F61B;FACE WITH STUCK-OUT TONGUE;So;0;ON;;;;;N;;;;;
1F61C;FACE WITH STUCK-OUT TONGUE AND WINKING EYE;So;0;ON;;;;;N;;;;;
1F61D;FACE WITH STUCK-OUT TONGUE AND TIGHTLY-CLOSED EYES;So;0;ON;;;;;N;;;;;
1F61E;DISAPPOINTED FACE;So;0;ON;;;;;N;;;;;
1F61F;WORRIED FACE;So;0;ON;;;;;N;;;;;
1F620;ANGRY FACE;So;0;ON;;;;;N;;;;;
1F621;POUTING FACE;So;0;ON;;;;;N;;;;;
1F622;CRYING FACE;So;0;ON;;;;;N;;;;;
1F623;PERSEVERING FACE;So;0;ON;;;;;N;;;;;
1F624;FACE WITH LOOK OF TRIUMPH;So;0;ON;;;;;N;;;;;
1F625;DISAPPOINTED BUT RELIEVED FACE;So;0;ON;;;;;N;;;;;
1F626;FROWNING FACE WITH OPEN MOUTH;So;0;ON;;;;;N;;;;;
1F627;ANGUISHED FACE;So;0;ON;;;;;N;;;;;
1F628;FEARFUL FACE;So;0;ON;;;;;N;;;;;
1F629;WEARY FACE;So;0;ON;;;;;N;;;;;
1F62A;SLEEPY FACE;So;0;ON;;;;;N;;;;;
1F62B;TIRED FACE;So;0;ON;;;;;N;;;;;
1F62C;GRIMACING FACE;So;0;ON;;;;;N;;;;;
1F62D;LOUDLY CRYING FACE;So;0;ON;;;;;N;;;;;
1F62E;FACE WITH OPEN MOUTH;So;0;ON;;;;;N;;;;;
1F62F;HUSHED FACE;So;0;ON;;;;;N;;;;;
1F630;FACE WITH OPEN MOUTH AND COLD SWEAT;So;0;ON;;;;;N;;;;;
1F631;FACE SCREAMING IN FEAR;So;0;ON;;;;;N;;;;;
1F632;ASTONISHED FACE;So;0;ON;;;;;N;;;;;
1F633;FLUSHED FACE;So;0;ON;;;;;N;;;;;
1F634;SLEEPING FACE;So;0;ON;;;;;N;;;;;
1F635;DIZZY FACE;So;0;ON;;;;;N;;;;;
1F636;FACE WITHOUT MOUTH;So;0;ON;;;;;N;;;;;
1F637;FACE WITH MEDICAL MASK;So;0;ON;;;;;N;;;;;
1F638;GRINNING CAT FACE WITH SMILING EYES;So;0;ON;;;;;N;;;;;
1F639;CAT FACE WITH TEARS OF JOY;So;0;ON;;;;;N;;;;;
1F63A;SMILING CAT FACE WITH OPEN MOUTH;So;0;ON;;;;;N;;;;;
1F63B;SMILING CAT FACE WITH HEART-SHAPED EYES;So;0;ON;;;;;N;;;;;
1F63C;CAT FACE WITH WRY SMILE;So;0;ON;;;;;N;;;;;
1F63D;KISSING CAT FACE WITH CLOSED EYES;So;0;ON;;;;;N;;;;;
1F63E;POUTING CAT FACE;So;0;ON;;;;;N;;;;;
1F63F;CRYING CAT FACE;So;0;ON;;;;;N;;;;;
1F640;WEARY CAT FACE;So;0;ON;;;;;N;;;;;
1F641;SLIGHTLY FROWNING FACE;So;0;ON;;;;;N;;;;;
1F642;SLIGHTLY SMILING FACE;So;0;ON;;;;;N;;;;;
1F643;UPSIDE-DOWN FACE;So;0;ON;;;;;N;;;;;
1F644;FACE WITH ROLLING EYES;So;0;ON;;;;;N;;;;;
1F645;FACE WITH NO GOOD GESTURE;So;0;ON;;;;;N;;;;;
1F646;FACE WITH OK GESTURE;So;0;ON;;;;;N;;;;;
1F647;PERSON BOWING DEEPLY;So;0;ON;;;;;N;;;;;
1F648;SEE-NO-EVIL MONKEY;So;0;ON;;;;;N;;;;;
1F649;HEAR-NO-EVIL MONKEY;So;0;ON;;;;;N;;;;;
1F64A;SPEAK-NO-EVIL MONKEY;So;0;ON;;;;;N;;;;;
1F64B;HAPPY PERSON RAISING ONE HAND;So;0;ON;;;;;N;;;;;
1F64C;PERSON RAISING BOTH HANDS IN CELEBRATION;So;0;ON;;;;;N;;;;;
1F64D;PERSON FROWNING;So;0;ON;;;;;N;;;;;
1F64E;PERSON WITH POUTING FACE;So;0;ON;;;;;N;;;;;
1F64F;PERSON WITH FOLDED HANDS;So;0;ON;;;;;N;;;;;
1F650;NORTH WEST POINTING LEAF;So;0;ON;;;;;N;;;;;
1F651;SOUTH WEST POINTING LEAF;So;0;ON;;;;;N;;;;;
1F652;NORTH EAST POINTING LEAF;So;0;ON;;;;;N;;;;;
1F653;SOUTH EAST POINTING LEAF;So;0;ON;;;;;N;;;;;
1F654;TURNED NORTH WEST POINTING LEAF;So;0;ON;;;;;N;;;;;
1F655;TURNED SOUTH WEST POINTING LEAF;So;0;ON;;;;;N;;;;;
1F656;TURNED NORTH EAST POINTING LEAF;So;0;ON;;;;;N;;;;;
1F657;TURNED SOUTH EAST POINTING LEAF;So;0;ON;;;;;N;;;;;
1F658;NORTH WEST POINTING VINE LEAF;So;0;ON;;;;;N;;;;;
1F659;SOUTH WEST POINTING VINE LEAF;So;0;ON;;;;;N;;;;;
1F65A;NORTH EAST POINTING VINE LEAF;So;0;ON;;;;;N;;;;;
1F65B;SOUTH EAST POINTING VINE LEAF;So;0;ON;;;;;N;;;;;
1F65C;HEAVY NORTH WEST POINTING VINE LEAF;So;0;ON;;;;;N;;;;;
1F65D;HEAVY SOUTH WEST POINTING VINE LEAF;So;0;ON;;;;;N;;;;;
1F65E;HEAVY NORTH EAST POINTING VINE LEAF;So;0;ON;;;;;N;;;;;
1F65F;HEAVY SOUTH EAST POINTING VINE LEAF;So;0;ON;;;;;N;;;;;
1F660;NORTH WEST POINTING BUD;So;0;ON;;;;;N;;;;;
1F661;SOUTH WEST POINTING BUD;So;0;ON;;;;;N;;;;;
1F662;NORTH EAST POINTING BUD;So;0;ON;;;;;N;;;;;
1F663;SOUTH EAST POINTING BUD;So;0;ON;;;;;N;;;;;
1F664;HEAVY NORTH WEST POINTING BUD;So;0;ON;;;;;N;;;;;
1F665;HEAVY SOUTH WEST POINTING BUD;So;0;ON;;;;;N;;;;;
1F666;HEAVY NORTH EAST POINTING BUD;So;0;ON;;;;;N;;;;;
1F667;HEAVY SOUTH EAST POINTING BUD;So;0;ON;;;;;N;;;;;
1F668;HOLLOW QUILT SQUARE ORNAMENT;So;0;ON;;;;;N;;;;;
1F669;HOLLOW QUILT SQUARE ORNAMENT IN BLACK SQUARE;So;0;ON;;;;;N;;;;;
1F66A;SOLID QUILT SQUARE ORNAMENT;So;0;ON;;;;;N;;;;;
1F66B;SOLID QUILT SQUARE ORNAMENT IN BLACK SQUARE;So;0;ON;;;;;N;;;;;
1F66C;LEFTWARDS ROCKET;So;0;ON;;;;;N;;;;;
1F66D;UPWARDS ROCKET;So;0;ON;;;;;N;;;;;
1F66E;RIGHTWARDS ROCKET;So;0;ON;;;;;N;;;;;
1F66F;DOWNWARDS ROCKET;So;0;ON;;;;;N;;;;;
1F670;SCRIPT LIGATURE ET ORNAMENT;So;0;ON;;;;;N;;;;;
1F671;HEAVY SCRIPT LIGATURE ET ORNAMENT;So;0;ON;;;;;N;;;;;
1F672;LIGATURE OPEN ET ORNAMENT;So;0;ON;;;;;N;;;;;
1F673;HEAVY LIGATURE OPEN ET ORNAMENT;So;0;ON;;;;;N;;;;;
1F674;HEAVY AMPERSAND ORNAMENT;So;0;ON;;;;;N;;;;;
1F675;SWASH AMPERSAND ORNAMENT;So;0;ON;;;;;N;;;;;
1F676;SANS-SERIF HEAVY DOUBLE TURNED COMMA QUOTATION MARK ORNAMENT;So;0;ON;;;;;N;;;;;
1F677;SANS-SERIF HEAVY DOUBLE COMMA QUOTATION MARK ORNAMENT;So;0;ON;;;;;N;;;;;
1F678;SANS-SERIF HEAVY LOW DOUBLE COMMA QUOTATION MARK ORNAMENT;So;0;ON;;;;;N;;;;;
1F679;HEAVY INTERROBANG ORNAMENT;So;0;ON;;;;;N;;;;;
1F67A;SANS-SERIF INTERROBANG ORNAMENT;So;0;ON;;;;;N;;;;;
1F67B;HEAVY SANS-SERIF INTERROBANG ORNAMENT;So;0;ON;;;;;N;;;;;
1F67C;VERY HEAVY SOLIDUS;So;0;ON;;;;;N;;;;;
1F67D;VERY HEAVY REVERSE SOLIDUS;So;0;ON;;;;;N;;;;;
1F67E;CHECKER BOARD;So;0;ON;;;;;N;;;;;
1F67F;REVERSE CHECKER BOARD;So;0;ON;;;;;N;;;;;
1F680;ROCKET;So;0;ON;;;;;N;;;;;
1F681;HELICOPTER;So;0;ON;;;;;N;;;;;
1F682;STEAM LOCOMOTIVE;So;0;ON;;;;;N;;;;;
1F683;RAILWAY CAR;So;0;ON;;;;;N;;;;;
1F684;HIGH-SPEED TRAIN;So;0;ON;;;;;N;;;;;
1F685;HIGH-SPEED TRAIN WITH BULLET NOSE;So;0;ON;;;;;N;;;;;
1F686;TRAIN;So;0;ON;;;;;N;;;;;
1F687;METRO;So;0;ON;;;;;N;;;;;
1F688;LIGHT RAIL;So;0;ON;;;;;N;;;;;
1F689;STATION;So;0;ON;;;;;N;;;;;
1F68A;TRAM;So;0;ON;;;;;N;;;;;
1F68B;TRAM CAR;So;0;ON;;;;;N;;;;;
1F68C;BUS;So;0;ON;;;;;N;;;;;
1F68D;ONCOMING BUS;So;0;ON;;;;;N;;;;;
1F68E;TROLLEYBUS;So;0;ON;;;;;N;;;;;
1F68F;BUS STOP;So;0;ON;;;;;N;;;;;
1F690;MINIBUS;So;0;ON;;;;;N;;;;;
1F691;AMBULANCE;So;0;ON;;;;;N;;;;;
1F692;FIRE ENGINE;So;0;ON;;;;;N;;;;;
1F693;POLICE CAR;So;0;ON;;;;;N;;;;;
1F694;ONCOMING POLICE CAR;So;0;ON;;;;;N;;;;;
1F695;TAXI;So;0;ON;;;;;N;;;;;
1F696;ONCOMING TAXI;So;0;ON;;;;;N;;;;;
1F697;AUTOMOBILE;So;0;ON;;;;;N;;;;;
1F698;ONCOMING AUTOMOBILE;So;0;ON;;;;;N;;;;;
1F699;RECREATIONAL VEHICLE;So;0;ON;;;;;N;;;;;
1F69A;DELIVERY TRUCK;So;0;ON;;;;;N;;;;;
1F69B;ARTICULATED LORRY;So;0;ON;;;;;N;;;;;
1F69C;TRACTOR;So;0;ON;;;;;N;;;;;
1F69D;MONORAIL;So;0;ON;;;;;N;;;;;
1F69E;MOUNTAIN RAILWAY;So;0;ON;;;;;N;;;;;
1F69F;SUSPENSION RAILWAY;So;0;ON;;;;;N;;;;;
1F6A0;MOUNTAIN CABLEWAY;So;0;ON;;;;;N;;;;;
1F6A1;AERIAL TRAMWAY;So;0;ON;;;;;N;;;;;
1F6A2;SHIP;So;0;ON;;;;;N;;;;;
1F6A3;ROWBOAT;So;0;ON;;;;;N;;;;;
1F6A4;SPEEDBOAT;So;0;ON;;;;;N;;;;;
1F6A5;HORIZONTAL TRAFFIC LIGHT;So;0;ON;;;;;N;;;;;
1F6A6;VERTICAL TRAFFIC LIGHT;So;0;ON;;;;;N;;;;;
1F6A7;CONSTRUCTION SIGN;So;0;ON;;;;;N;;;;;
1F6A8;POLICE CARS REVOLVING LIGHT;So;0;ON;;;;;N;;;;;
1F6A9;TRIANGULAR FLAG ON POST;So;0;ON;;;;;N;;;;;
1F6AA;DOOR;So;0;ON;;;;;N;;;;;
1F6AB;NO ENTRY SIGN;So;0;ON;;;;;N;;;;;
1F6AC;SMOKING SYMBOL;So;0;ON;;;;;N;;;;;
1F6AD;NO SMOKING SYMBOL;So;0;ON;;;;;N;;;;;
1F6AE;PUT LITTER IN ITS PLACE SYMBOL;So;0;ON;;;;;N;;;;;
1F6AF;DO NOT LITTER SYMBOL;So;0;ON;;;;;N;;;;;
1F6B0;POTABLE WATER SYMBOL;So;0;ON;;;;;N;;;;;
1F6B1;NON-POTABLE WATER SYMBOL;So;0;ON;;;;;N;;;;;
1F6B2;BICYCLE;So;0;ON;;;;;N;;;;;
1F6B3;NO BICYCLES;So;0;ON;;;;;N;;;;;
1F6B4;BICYCLIST;So;0;ON;;;;;N;;;;;
1F6B5;MOUNTAIN BICYCLIST;So;0;ON;;;;;N;;;;;
1F6B6;PEDESTRIAN;So;0;ON;;;;;N;;;;;
1F6B7;NO PEDESTRIANS;So;0;ON;;;;;N;;;;;
1F6B8;CHILDREN CROSSING;So;0;ON;;;;;N;;;;;
1F6B9;MENS SYMBOL;So;0;ON;;;;;N;;;;;
1F6BA;WOMENS SYMBOL;So;0;ON;;;;;N;;;;;
1F6BB;RESTROOM;So;0;ON;;;;;N;;;;;
1F6BC;BABY SYMBOL;So;0;ON;;;;;N;;;;;
1F6BD;TOILET;So;0;ON;;;;;N;;;;;
1F6BE;WATER CLOSET;So;0;ON;;;;;N;;;;;
1F6BF;SHOWER;So;0;ON;;;;;N;;;;;
1F6C0;BATH;So;0;ON;;;;;N;;;;;
1F6C1;BATHTUB;So;0;ON;;;;;N;;;;;
1F6C2;PASSPORT CONTROL;So;0;ON;;;;;N;;;;;
1F6C3;CUSTOMS;So;0;ON;;;;;N;;;;;
1F6C4;BAGGAGE CLAIM;So;0;ON;;;;;N;;;;;
1F6C5;LEFT LUGGAGE;So;0;ON;;;;;N;;;;;
1F6C6;TRIANGLE WITH ROUNDED CORNERS;So;0;ON;;;;;N;;;;;
1F6C7;PROHIBITED SIGN;So;0;ON;;;;;N;;;;;
1F6C8;CIRCLED INFORMATION SOURCE;So;0;ON;;;;;N;;;;;
1F6C9;BOYS SYMBOL;So;0;ON;;;;;N;;;;;
1F6CA;GIRLS SYMBOL;So;0;ON;;;;;N;;;;;
1F6CB;COUCH AND LAMP;So;0;ON;;;;;N;;;;;
1F6CC;SLEEPING ACCOMMODATION;So;0;ON;;;;;N;;;;;
1F6CD;SHOPPING BAGS;So;0;ON;;;;;N;;;;;
1F6CE;BELLHOP BELL;So;0;ON;;;;;N;;;;;
1F6CF;BED;So;0;ON;;;;;N;;;;;
1F6D0;PLACE OF WORSHIP;So;0;ON;;;;;N;;;;;
1F6D1;OCTAGONAL SIGN;So;0;ON;;;;;N;;;;;
1F6D2;SHOPPING TROLLEY;So;0;ON;;;;;N;;;;;
1F6D3;STUPA;So;0;ON;;;;;N;;;;;
1F6D4;PAGODA;So;0;ON;;;;;N;;;;;
1F6D5;HINDU TEMPLE;So;0;ON;;;;;N;;;;;
1F6D6;HUT;So;0;ON;;;;;N;;;;;
1F6D7;ELEVATOR;So;0;ON;;;;;N;;;;;
1F6DD;PLAYGROUND SLIDE;So;0;ON;;;;;N;;;;;
1F6DE;WHEEL;So;0;ON;;;;;N;;;;;
1F6DF;RING BUOY;So;0;ON;;;;;N;;;;;
1F6E0;HAMMER AND WRENCH;So;0;ON;;;;;N;;;;;
1F6E1;SHIELD;So;0;ON;;;;;N;;;;;
1F6E2;OIL DRUM;So;0;ON;;;;;N;;;;;
1F6E3;MOTORWAY;So;0;ON;;;;;N;;;;;
1F6E4;RAILWAY TRACK;So;0;ON;;;;;N;;;;;
1F6E5;MOTOR BOAT;So;0;ON;;;;;N;;;;;
1F6E6;UP-POINTING MILITARY AIRPLANE;So;0;ON;;;;;N;;;;;
1F6E7;UP-POINTING AIRPLANE;So;0;ON;;;;;N;;;;;
1F6E8;UP-POINTING SMALL AIRPLANE;So;0;ON;;;;;N;;;;;
1F6E9;SMALL AIRPLANE;So;0;ON;;;;;N;;;;;
1F6EA;NORTHEAST-POINTING AIRPLANE;So;0;ON;;;;;N;;;;;
1F6EB;AIRPLANE DEPARTURE;So;0;ON;;;;;N;;;;;
1F6EC;AIRPLANE ARRIVING;So;0;ON;;;;;N;;;;;
1F6F0;SATELLITE;So;0;ON;;;;;N;;;;;
1F6F1;ONCOMING FIRE ENGINE;So;0;ON;;;;;N;;;;;
1F6F2;DIESEL LOCOMOTIVE;So;0;ON;;;;;N;;;;;
1F6F3;PASSENGER SHIP;So;0;ON;;;;;N;;;;;
1F6F4;SCOOTER;So;0;ON;;;;;N;;;;;
1F6F5;MOTOR SCOOTER;So;0;ON;;;;;N;;;;;
1F6F6;CANOE;So;0;ON;;;;;N;;;;;
1F6F7;SLED;So;0;ON;;;;;N;;;;;
1F6F8;FLYING SAUCER;So;0;ON;;;;;N;;;;;
1F6F9;SKATEBOARD;So;0;ON;;;;;N;;;;;
1F6FA;AUTO RICKSHAW;So;0;ON;;;;;N;;;;;
1F6FB;PICKUP TRUCK;So;0;ON;;;;;N;;;;;
1F6FC;ROLLER SKATE;So;0;ON;;;;;N;;;;;
1F700;ALCHEMICAL SYMBOL FOR QUINTESSENCE;So;0;ON;;;;;N;;;;;
1F701;ALCHEMICAL SYMBOL FOR AIR;So;0;ON;;;;;N;;;;;
1F702;ALCHEMICAL SYMBOL FOR FIRE;So;0;ON;;;;;N;;;;;
1F703;ALCHEMICAL SYMBOL FOR EARTH;So;0;ON;;;;;N;;;;;
1F704;ALCHEMICAL SYMBOL FOR WATER;So;0;ON;;;;;N;;;;;
1F705;ALCHEMICAL SYMBOL FOR AQUAFORTIS;So;0;ON;;;;;N;;;;;
1F706;ALCHEMICAL SYMBOL FOR AQUA REGIA;So;0;ON;;;;;N;;;;;
1F707;ALCHEMICAL SYMBOL FOR AQUA REGIA-2;So;0;ON;;;;;N;;;;;
1F708;ALCHEMICAL SYMBOL FOR AQUA VITAE;So;0;ON;;;;;N;;;;;
1F709;ALCHEMICAL SYMBOL FOR AQUA VITAE-2;So;0;ON;;;;;N;;;;;
1F70A;ALCHEMICAL SYMBOL FOR VINEGAR;So;0;ON;;;;;N;;;;;
1F70B;ALCHEMICAL SYMBOL FOR VINEGAR-2;So;0;ON;;;;;N;;;;;
1F70C;ALCHEMICAL SYMBOL FOR VINEGAR-3;So;0;ON;;;;;N;;;;;
1F70D;ALCHEMICAL SYMBOL FOR SULFUR;So;0;ON;;;;;N;;;;;
1F70E;ALCHEMICAL SYMBOL FOR PHILOSOPHERS SULFUR;So;0;ON;;;;;N;;;;;
1F70F;ALCHEMICAL SYMBOL FOR BLACK SULFUR;So;0;ON;;;;;N;;;;;
1F710;ALCHEMICAL SYMBOL FOR MERCURY SUBLIMATE;So;0;ON;;;;;N;;;;;
1F711;ALCHEMICAL SYMBOL FOR MERCURY SUBLIMATE-2;So;0;ON;;;;;N;;;;;
1F712;ALCHEMICAL SYMBOL FOR MERCURY SUBLIMATE-3;So;0;ON;;;;;N;;;;;
1F713;ALCHEMICAL SYMBOL FOR CINNABAR;So;0;ON;;;;;N;;;;;
1F714;ALCHEMICAL SYMBOL FOR SALT;So;0;ON;;;;;N;;;;;
1F715;ALCHEMICAL SYMBOL FOR NITRE;So;0;ON;;;;;N;;;;;
1F716;ALCHEMICAL SYMBOL FOR VITRIOL;So;0;ON;;;;;N;;;;;
1F717;ALCHEMICAL SYMBOL FOR VITRIOL-2;So;0;ON;;;;;N;;;;;
1F718;ALCHEMICAL SYMBOL FOR ROCK SALT;So;0;ON;;;;;N;;;;;
1F719;ALCHEMICAL SYMBOL FOR ROCK SALT-2;So;0;ON;;;;;N;;;;;
1F71A;ALCHEMICAL SYMBOL FOR GOLD;So;0;ON;;;;;N;;;;;
1F71B;ALCHEMICAL SYMBOL FOR SILVER;So;0;ON;;;;;N;;;;;
1F71C;ALCHEMICAL SYMBOL FOR IRON ORE;So;0;ON;;;;;N;;;;;
1F71D;ALCHEMICAL SYMBOL FOR IRON ORE-2;So;0;ON;;;;;N;;;;;
1F71E;ALCHEMICAL SYMBOL FOR CROCUS OF IRON;So;0;ON;;;;;N;;;;;
1F71F;ALCHEMICAL SYMBOL FOR REGULUS OF IRON;So;0;ON;;;;;N;;;;;
1F720;ALCHEMICAL SYMBOL FOR COPPER ORE;So;0;ON;;;;;N;;;;;
1F721;ALCHEMICAL SYMBOL FOR IRON-COPPER ORE;So;0;ON;;;;;N;;;;;
1F722;ALCHEMICAL SYMBOL FOR SUBLIMATE OF COPPER;So;0;ON;;;;;N;;;;;
1F723;ALCHEMICAL SYMBOL FOR CROCUS OF COPPER;So;0;ON;;;;;N;;;;;
1F724;ALCHEMICAL SYMBOL FOR CROCUS OF COPPER-2;So;0;ON;;;;;N;;;;;
1F725;ALCHEMICAL SYMBOL FOR COPPER ANTIMONIATE;So;0;ON;;;;;N;;;;;
1F726;ALCHEMICAL SYMBOL FOR SALT OF COPPER ANTIMONIATE;So;0;ON;;;;;N;;;;;
1F727;ALCHEMICAL SYMBOL FOR SUBLIMATE OF SALT OF COPPER;So;0;ON;;;;;N;;;;;
1F728;ALCHEMICAL SYMBOL FOR VERDIGRIS;So;0;ON;;;;;N;;;;;
1F729;ALCHEMICAL SYMBOL FOR TIN ORE;So;0;ON;;;;;N;;;;;
1F72A;ALCHEMICAL SYMBOL FOR LEAD ORE;So;0;ON;;;;;N;;;;;
1F72B;ALCHEMICAL SYMBOL FOR ANTIMONY ORE;So;0;ON;;;;;N;;;;;
1F72C;ALCHEMICAL SYMBOL FOR SUBLIMATE OF ANTIMONY;So;0;ON;;;;;N;;;;;
1F72D;ALCHEMICAL SYMBOL FOR SALT OF ANTIMONY;So;0;ON;;;;;N;;;;;
1F72E;ALCHEMICAL SYMBOL FOR SUBLIMATE OF SALT OF ANTIMONY;So;0;ON;;;;;N;;;;;
1F72F;ALCHEMICAL SYMBOL FOR VINEGAR OF ANTIMONY;So;0;ON;;;;;N;;;;;
1F730;ALCHEMICAL SYMBOL FOR REGULUS OF ANTIMONY;So;0;ON;;;;;N;;;;;
1F731;ALCHEMICAL SYMBOL FOR REGULUS OF ANTIMONY-2;So;0;ON;;;;;N;;;;;
1F732;ALCHEMICAL SYMBOL FOR REGULUS;So;0;ON;;;;;N;;;;;
1F733;ALCHEMICAL SYMBOL FOR REGULUS-2;So;0;ON;;;;;N;;;;;
1F734;ALCHEMICAL SYMBOL FOR REGULUS-3;So;0;ON;;;;;N;;;;;
1F735;ALCHEMICAL SYMBOL FOR REGULUS-4;So;0;ON;;;;;N;;;;;
1F736;ALCHEMICAL SYMBOL FOR ALKALI;So;0;ON;;;;;N;;;;;
1F737;ALCHEMICAL SYMBOL FOR ALKALI-2;So;0;ON;;;;;N;;;;;
1F738;ALCHEMICAL SYMBOL FOR MARCASITE;So;0;ON;;;;;N;;;;;
1F739;ALCHEMICAL SYMBOL FOR SAL-AMMONIAC;So;0;ON;;;;;N;;;;;
1F73A;ALCHEMICAL SYMBOL FOR ARSENIC;So;0;ON;;;;;N;;;;;
1F73B;ALCHEMICAL SYMBOL FOR REALGAR;So;0;ON;;;;;N;;;;;
1F73C;ALCHEMICAL SYMBOL FOR REALGAR-2;So;0;ON;;;;;N;;;;;
1F73D;ALCHEMICAL SYMBOL FOR AURIPIGMENT;So;0;ON;;;;;N;;;;;
1F73E;ALCHEMICAL SYMBOL FOR BISMUTH ORE;So;0;ON;;;;;N;;;;;
1F73F;ALCHEMICAL SYMBOL FOR TARTAR;So;0;ON;;;;;N;;;;;
1F740;ALCHEMICAL SYMBOL FOR TARTAR-2;So;0;ON;;;;;N;;;;;
1F741;ALCHEMICAL SYMBOL FOR QUICK LIME;So;0;ON;;;;;N;;;;;
1F742;ALCHEMICAL SYMBOL FOR BORAX;So;0;ON;;;;;N;;;;;
1F743;ALCHEMICAL SYMBOL FOR BORAX-2;So;0;ON;;;;;N;;;;;
1F744;ALCHEMICAL SYMBOL FOR BORAX-3;So;0;ON;;;;;N;;;;;
1F745;ALCHEMICAL SYMBOL FOR ALUM;So;0;ON;;;;;N;;;;;
1F746;ALCHEMICAL SYMBOL FOR OIL;So;0;ON;;;;;N;;;;;
1F747;ALCHEMICAL SYMBOL FOR SPIRIT;So;0;ON;;;;;N;;;;;
1F748;ALCHEMICAL SYMBOL FOR TINCTURE;So;0;ON;;;;;N;;;;;
1F749;ALCHEMICAL SYMBOL FOR GUM;So;0;ON;;;;;N;;;;;
1F74A;ALCHEMICAL SYMBOL FOR WAX;So;0;ON;;;;;N;;;;;
1F74B;ALCHEMICAL SYMBOL FOR POWDER;So;0;ON;;;;;N;;;;;
1F74C;ALCHEMICAL SYMBOL FOR CALX;So;0;ON;;;;;N;;;;;
1F74D;ALCHEMICAL SYMBOL FOR TUTTY;So;0;ON;;;;;N;;;;;
1F74E;ALCHEMICAL SYMBOL FOR CAPUT MORTUUM;So;0;ON;;;;;N;;;;;
1F74F;ALCHEMICAL SYMBOL FOR SCEPTER OF JOVE;So;0;ON;;;;;N;;;;;
1F750;ALCHEMICAL SYMBOL FOR CADUCEUS;So;0;ON;;;;;N;;;;;
1F751;ALCHEMICAL SYMBOL FOR TRIDENT;So;0;ON;;;;;N;;;;;
1F752;ALCHEMICAL SYMBOL FOR STARRED TRIDENT;So;0;ON;;;;;N;;;;;
1F753;ALCHEMICAL SYMBOL FOR LODESTONE;So;0;ON;;;;;N;;;;;
1F754;ALCHEMICAL SYMBOL FOR SOAP;So;0;ON;;;;;N;;;;;
1F755;ALCHEMICAL SYMBOL FOR URINE;So;0;ON;;;;;N;;;;;
1F756;ALCHEMICAL SYMBOL FOR HORSE DUNG;So;0;ON;;;;;N;;;;;
1F757;ALCHEMICAL SYMBOL FOR ASHES;So;0;ON;;;;;N;;;;;
1F758;ALCHEMICAL SYMBOL FOR POT ASHES;So;0;ON;;;;;N;;;;;
1F759;ALCHEMICAL SYMBOL FOR BRICK;So;0;ON;;;;;N;;;;;
1F75A;ALCHEMICAL SYMBOL FOR POWDERED BRICK;So;0;ON;;;;;N;;;;;
1F75B;ALCHEMICAL SYMBOL FOR AMALGAM;So;0;ON;;;;;N;;;;;
1F75C;ALCHEMICAL SYMBOL FOR STRATUM SUPER STRATUM;So;0;ON;;;;;N;;;;;
1F75D;ALCHEMICAL SYMBOL FOR STRATUM SUPER STRATUM-2;So;0;ON;;;;;N;;;;;
1F75E;ALCHEMICAL SYMBOL FOR SUBLIMATION;So;0;ON;;;;;N;;;;;
1F75F;ALCHEMICAL SYMBOL FOR PRECIPITATE;So;0;ON;;;;;N;;;;;
1F760;ALCHEMICAL SYMBOL FOR DISTILL;So;0;ON;;;;;N;;;;;
1F761;ALCHEMICAL SYMBOL FOR DISSOLVE;So;0;ON;;;;;N;;;;;
1F762;ALCHEMICAL SYMBOL FOR DISSOLVE-2;So;0;ON;;;;;N;;;;;
1F763;ALCHEMICAL SYMBOL FOR PURIFY;So;0;ON;;;;;N;;;;;
1F764;ALCHEMICAL SYMBOL FOR PUTREFACTION;So;0;ON;;;;;N;;;;;
1F765;ALCHEMICAL SYMBOL FOR CRUCIBLE;So;0;ON;;;;;N;;;;;
1F766;ALCHEMICAL SYMBOL FOR CRUCIBLE-2;So;0;ON;;;;;N;;;;;
1F767;ALCHEMICAL SYMBOL FOR CRUCIBLE-3;So;0;ON;;;;;N;;;;;
1F768;ALCHEMICAL SYMBOL FOR CRUCIBLE-4;So;0;ON;;;;;N;;;;;
1F769;ALCHEMICAL SYMBOL FOR CRUCIBLE-5;So;0;ON;;;;;N;;;;;
1F76A;ALCHEMICAL SYMBOL FOR ALEMBIC;So;0;ON;;;;;N;;;;;
1F76B;ALCHEMICAL SYMBOL FOR BATH OF MARY;So;0;ON;;;;;N;;;;;
1F76C;ALCHEMICAL SYMBOL FOR BATH OF VAPOURS;So;0;ON;;;;;N;;;;;
1F76D;ALCHEMICAL SYMBOL FOR RETORT;So;0;ON;;;;;N;;;;;
1F76E;ALCHEMICAL SYMBOL FOR HOUR;So;0;ON;;;;;N;;;;;
1F76F;ALCHEMICAL SYMBOL FOR NIGHT;So;0;ON;;;;;N;;;;;
1F770;ALCHEMICAL SYMBOL FOR DAY-NIGHT;So;0;ON;;;;;N;;;;;
1F771;ALCHEMICAL SYMBOL FOR MONTH;So;0;ON;;;;;N;;;;;
1F772;ALCHEMICAL SYMBOL FOR HALF DRAM;So;0;ON;;;;;N;;;;;
1F773;ALCHEMICAL SYMBOL FOR HALF OUNCE;So;0;ON;;;;;N;;;;;
1F780;BLACK LEFT-POINTING ISOSCELES RIGHT TRIANGLE;So;0;ON;;;;;N;;;;;
1F781;BLACK UP-POINTING ISOSCELES RIGHT TRIANGLE;So;0;ON;;;;;N;;;;;
1F782;BLACK RIGHT-POINTING ISOSCELES RIGHT TRIANGLE;So;0;ON;;;;;N;;;;;
1F783;BLACK DOWN-POINTING ISOSCELES RIGHT TRIANGLE;So;0;ON;;;;;N;;;;;
1F784;BLACK SLIGHTLY SMALL CIRCLE;So;0;ON;;;;;N;;;;;
1F785;MEDIUM BOLD WHITE CIRCLE;So;0;ON;;;;;N;;;;;
1F786;BOLD WHITE CIRCLE;So;0;ON;;;;;N;;;;;
1F787;HEAVY WHITE CIRCLE;So;0;ON;;;;;N;;;;;
1F788;VERY HEAVY WHITE CIRCLE;So;0;ON;;;;;N;;;;;
1F789;EXTREMELY HEAVY WHITE CIRCLE;So;0;ON;;;;;N;;;;;
1F78A;WHITE CIRCLE CONTAINING BLACK SMALL CIRCLE;So;0;ON;;;;;N;;;;;
1F78B;ROUND TARGET;So;0;ON;;;;;N;;;;;
1F78C;BLACK TINY SQUARE;So;0;ON;;;;;N;;;;;
1F78D;BLACK SLIGHTLY SMALL SQUARE;So;0;ON;;;;;N;;;;;
1F78E;LIGHT WHITE SQUARE;So;0;ON;;;;;N;;;;;
1F78F;MEDIUM WHITE SQUARE;So;0;ON;;;;;N;;;;;
1F790;BOLD WHITE SQUARE;So;0;ON;;;;;N;;;;;
1F791;HEAVY WHITE SQUARE;So;0;ON;;;;;N;;;;;
1F792;VERY HEAVY WHITE SQUARE;So;0;ON;;;;;N;;;;;
1F793;EXTREMELY HEAVY WHITE SQUARE;So;0;ON;;;;;N;;;;;
1F794;WHITE SQUARE CONTAINING BLACK VERY SMALL SQUARE;So;0;ON;;;;;N;;;;;
1F795;WHITE SQUARE CONTAINING BLACK MEDIUM SQUARE;So;0;ON;;;;;N;;;;;
1F796;SQUARE TARGET;So;0;ON;;;;;N;;;;;
1F797;BLACK TINY DIAMOND;So;0;ON;;;;;N;;;;;
1F798;BLACK VERY SMALL DIAMOND;So;0;ON;;;;;N;;;;;
1F799;BLACK MEDIUM SMALL DIAMOND;So;0;ON;;;;;N;;;;;
1F79A;WHITE DIAMOND CONTAINING BLACK VERY SMALL DIAMOND;So;0;ON;;;;;N;;;;;
1F79B;WHITE DIAMOND CONTAINING BLACK MEDIUM DIAMOND;So;0;ON;;;;;N;;;;;
1F79C;DIAMOND TARGET;So;0;ON;;;;;N;;;;;
1F79D;BLACK TINY LOZENGE;So;0;ON;;;;;N;;;;;
1F79E;BLACK VERY SMALL LOZENGE;So;0;ON;;;;;N;;;;;
1F79F;BLACK MEDIUM SMALL LOZENGE;So;0;ON;;;;;N;;;;;
1F7A0;WHITE LOZENGE CONTAINING BLACK SMALL LOZENGE;So;0;ON;;;;;N;;;;;
1F7A1;THIN GREEK CROSS;So;0;ON;;;;;N;;;;;
1F7A2;LIGHT GREEK CROSS;So;0;ON;;;;;N;;;;;
1F7A3;MEDIUM GREEK CROSS;So;0;ON;;;;;N;;;;;
1F7A4;BOLD GREEK CROSS;So;0;ON;;;;;N;;;;;
1F7A5;VERY BOLD GREEK CROSS;So;0;ON;;;;;N;;;;;
1F7A6;VERY HEAVY GREEK CROSS;So;0;ON;;;;;N;;;;;
1F7A7;EXTREMELY HEAVY GREEK CROSS;So;0;ON;;;;;N;;;;;
1F7A8;THIN SALTIRE;So;0;ON;;;;;N;;;;;
1F7A9;LIGHT SALTIRE;So;0;ON;;;;;N;;;;;
1F7AA;MEDIUM SALTIRE;So;0;ON;;;;;N;;;;;
1F7AB;BOLD SALTIRE;So;0;ON;;;;;N;;;;;
1F7AC;HEAVY SALTIRE;So;0;ON;;;;;N;;;;;
1F7AD;VERY HEAVY SALTIRE;So;0;ON;;;;;N;;;;;
1F7AE;EXTREMELY HEAVY SALTIRE;So;0;ON;;;;;N;;;;;
1F7AF;LIGHT FIVE SPOKED ASTERISK;So;0;ON;;;;;N;;;;;
1F7B0;MEDIUM FIVE SPOKED ASTERISK;So;0;ON;;;;;N;;;;;
1F7B1;BOLD FIVE SPOKED ASTERISK;So;0;ON;;;;;N;;;;;
1F7B2;HEAVY FIVE SPOKED ASTERISK;So;0;ON;;;;;N;;;;;
1F7B3;VERY HEAVY FIVE SPOKED ASTERISK;So;0;ON;;;;;N;;;;;
1F7B4;EXTREMELY HEAVY FIVE SPOKED ASTERISK;So;0;ON;;;;;N;;;;;
1F7B5;LIGHT SIX SPOKED ASTERISK;So;0;ON;;;;;N;;;;;
1F7B6;MEDIUM SIX SPOKED ASTERISK;So;0;ON;;;;;N;;;;;
1F7B7;BOLD SIX SPOKED ASTERISK;So;0;ON;;;;;N;;;;;
1F7B8;HEAVY SIX SPOKED ASTERISK;So;0;ON;;;;;N;;;;;
1F7B9;VERY HEAVY SIX SPOKED ASTERISK;So;0;ON;;;;;N;;;;;
1F7BA;EXTREMELY HEAVY SIX SPOKED ASTERISK;So;0;ON;;;;;N;;;;;
1F7BB;LIGHT EIGHT SPOKED ASTERISK;So;0;ON;;;;;N;;;;;
1F7BC;MEDIUM EIGHT SPOKED ASTERISK;So;0;ON;;;;;N;;;;;
1F7BD;BOLD EIGHT SPOKED ASTERISK;So;0;ON;;;;;N;;;;;
1F7BE;HEAVY EIGHT SPOKED ASTERISK;So;0;ON;;;;;N;;;;;
1F7BF;VERY HEAVY EIGHT SPOKED ASTERISK;So;0;ON;;;;;N;;;;;
1F7C0;LIGHT THREE POINTED BLACK STAR;So;0;ON;;;;;N;;;;;
1F7C1;MEDIUM THREE POINTED BLACK STAR;So;0;ON;;;;;N;;;;;
1F7C2;THREE POINTED BLACK STAR;So;0;ON;;;;;N;;;;;
1F7C3;MEDIUM THREE POINTED PINWHEEL STAR;So;0;ON;;;;;N;;;;;
1F7C4;LIGHT FOUR POINTED BLACK STAR;So;0;ON;;;;;N;;;;;
1F7C5;MEDIUM FOUR POINTED BLACK STAR;So;0;ON;;;;;N;;;;;
1F7C6;FOUR POINTED BLACK STAR;So;0;ON;;;;;N;;;;;
1F7C7;MEDIUM FOUR POINTED PINWHEEL STAR;So;0;ON;;;;;N;;;;;
1F7C8;REVERSE LIGHT FOUR POINTED PINWHEEL STAR;So;0;ON;;;;;N;;;;;
1F7C9;LIGHT FIVE POINTED BLACK STAR;So;0;ON;;;;;N;;;;;
1F7CA;HEAVY FIVE POINTED BLACK STAR;So;0;ON;;;;;N;;;;;
1F7CB;MEDIUM SIX POINTED BLACK STAR;So;0;ON;;;;;N;;;;;
1F7CC;HEAVY SIX POINTED BLACK STAR;So;0;ON;;;;;N;;;;;
1F7CD;SIX POINTED PINWHEEL STAR;So;0;ON;;;;;N;;;;;
1F7CE;MEDIUM EIGHT POINTED BLACK STAR;So;0;ON;;;;;N;;;;;
1F7CF;HEAVY EIGHT POINTED BLACK STAR;So;0;ON;;;;;N;;;;;
1F7D0;VERY HEAVY EIGHT POINTED BLACK STAR;So;0;ON;;;;;N;;;;;
1F7D1;HEAVY EIGHT POINTED PINWHEEL STAR;So;0;ON;;;;;N;;;;;
1F7D2;LIGHT TWELVE POINTED BLACK STAR;So;0;ON;;;;;N;;;;;
1F7D3;HEAVY TWELVE POINTED BLACK STAR;So;0;ON;;;;;N;;;;;
1F7D4;HEAVY TWELVE POINTED PINWHEEL STAR;So;0;ON;;;;;N;;;;;
1F7D5;CIRCLED TRIANGLE;So;0;ON;;;;;N;;;;;
1F7D6;NEGATIVE CIRCLED TRIANGLE;So;0;ON;;;;;N;;;;;
1F7D7;CIRCLED SQUARE;So;0;ON;;;;;N;;;;;
1F7D8;NEGATIVE CIRCLED SQUARE;So;0;ON;;;;;N;;;;;
1F7E0;LARGE ORANGE CIRCLE;So;0;ON;;;;;N;;;;;
1F7E1;LARGE YELLOW CIRCLE;So;0;ON;;;;;N;;;;;
1F7E2;LARGE GREEN CIRCLE;So;0;ON;;;;;N;;;;;
1F7E3;LARGE PURPLE CIRCLE;So;0;ON;;;;;N;;;;;
1F7E4;LARGE BROWN CIRCLE;So;0;ON;;;;;N;;;;;
1F7E5;LARGE RED SQUARE;So;0;ON;;;;;N;;;;;
1F7E6;LARGE BLUE SQUARE;So;0;ON;;;;;N;;;;;
1F7E7;LARGE ORANGE SQUARE;So;0;ON;;;;;N;;;;;
1F7E8;LARGE YELLOW SQUARE;So;0;ON;;;;;N;;;;;
1F7E9;LARGE GREEN SQUARE;So;0;ON;;;;;N;;;;;
1F7EA;LARGE PURPLE SQUARE;So;0;ON;;;;;N;;;;;
1F7EB;LARGE BROWN SQUARE;So;0;ON;;;;;N;;;;;
1F7F0;HEAVY EQUALS SIGN;So;0;ON;;;;;N;;;;;
1F800;LEFTWARDS ARROW WITH SMALL TRIANGLE ARROWHEAD;So;0;ON;;;;;N;;;;;
1F801;UPWARDS ARROW WITH SMALL TRIANGLE ARROWHEAD;So;0;ON;;;;;N;;;;;
1F802;RIGHTWARDS ARROW WITH SMALL TRIANGLE ARROWHEAD;So;0;ON;;;;;N;;;;;
1F803;DOWNWARDS ARROW WITH SMALL TRIANGLE ARROWHEAD;So;0;ON;;;;;N;;;;;
1F804;LEFTWARDS ARROW WITH MEDIUM TRIANGLE ARROWHEAD;So;0;ON;;;;;N;;;;;
1F805;UPWARDS ARROW WITH MEDIUM TRIANGLE ARROWHEAD;So;0;ON;;;;;N;;;;;
1F806;RIGHTWARDS ARROW WITH MEDIUM TRIANGLE ARROWHEAD;So;0;ON;;;;;N;;;;;
1F807;DOWNWARDS ARROW WITH MEDIUM TRIANGLE ARROWHEAD;So;0;ON;;;;;N;;;;;
1F808;LEFTWARDS ARROW WITH LARGE TRIANGLE ARROWHEAD;So;0;ON;;;;;N;;;;;
1F809;UPWARDS ARROW WITH LARGE TRIANGLE ARROWHEAD;So;0;ON;;;;;N;;;;;
1F80A;RIGHTWARDS ARROW WITH LARGE TRIANGLE ARROWHEAD;So;0;ON;;;;;N;;;;;
1F80B;DOWNWARDS ARROW WITH LARGE TRIANGLE ARROWHEAD;So;0;ON;;;;;N;;;;;
1F810;LEFTWARDS ARROW WITH SMALL EQUILATERAL ARROWHEAD;So;0;ON;;;;;N;;;;;
1F811;UPWARDS ARROW WITH SMALL EQUILATERAL ARROWHEAD;So;0;ON;;;;;N;;;;;
1F812;RIGHTWARDS ARROW WITH SMALL EQUILATERAL ARROWHEAD;So;0;ON;;;;;N;;;;;
1F813;DOWNWARDS ARROW WITH SMALL EQUILATERAL ARROWHEAD;So;0;ON;;;;;N;;;;;
1F814;LEFTWARDS ARROW WITH EQUILATERAL ARROWHEAD;So;0;ON;;;;;N;;;;;
1F815;UPWARDS ARROW WITH EQUILATERAL ARROWHEAD;So;0;ON;;;;;N;;;;;
1F816;RIGHTWARDS ARROW WITH EQUILATERAL ARROWHEAD;So;0;ON;;;;;N;;;;;
1F817;DOWNWARDS ARROW WITH EQUILATERAL ARROWHEAD;So;0;ON;;;;;N;;;;;
1F818;HEAVY LEFTWARDS ARROW WITH EQUILATERAL ARROWHEAD;So;0;ON;;;;;N;;;;;
1F819;HEAVY UPWARDS ARROW WITH EQUILATERAL ARROWHEAD;So;0;ON;;;;;N;;;;;
1F81A;HEAVY RIGHTWARDS ARROW WITH EQUILATERAL ARROWHEAD;So;0;ON;;;;;N;;;;;
1F81B;HEAVY DOWNWARDS ARROW WITH EQUILATERAL ARROWHEAD;So;0;ON;;;;;N;;;;;
1F81C;HEAVY LEFTWARDS ARROW WITH LARGE EQUILATERAL ARROWHEAD;So;0;ON;;;;;N;;;;;
1F81D;HEAVY UPWARDS ARROW WITH LARGE EQUILATERAL ARROWHEAD;So;0;ON;;;;;N;;;;;
1F81E;HEAVY RIGHTWARDS ARROW WITH LARGE EQUILATERAL ARROWHEAD;So;0;ON;;;;;N;;;;;
1F81F;HEAVY DOWNWARDS ARROW WITH LARGE EQUILATERAL ARROWHEAD;So;0;ON;;;;;N;;;;;
1F820;LEFTWARDS TRIANGLE-HEADED ARROW WITH NARROW SHAFT;So;0;ON;;;;;N;;;;;
1F821;UPWARDS TRIANGLE-HEADED ARROW WITH NARROW SHAFT;So;0;ON;;;;;N;;;;;
1F822;RIGHTWARDS TRIANGLE-HEADED ARROW WITH NARROW SHAFT;So;0;ON;;;;;N;;;;;
1F823;DOWNWARDS TRIANGLE-HEADED ARROW WITH NARROW SHAFT;So;0;ON;;;;;N;;;;;
1F824;LEFTWARDS TRIANGLE-HEADED ARROW WITH MEDIUM SHAFT;So;0;ON;;;;;N;;;;;
1F825;UPWARDS TRIANGLE-HEADED ARROW WITH MEDIUM SHAFT;So;0;ON;;;;;N;;;;;
1F826;RIGHTWARDS TRIANGLE-HEADED ARROW WITH MEDIUM SHAFT;So;0;ON;;;;;N;;;;;
1F827;DOWNWARDS TRIANGLE-HEADED ARROW WITH MEDIUM SHAFT;So;0;ON;;;;;N;;;;;
1F828;LEFTWARDS TRIANGLE-HEADED ARROW WITH BOLD SHAFT;So;0;ON;;;;;N;;;;;
1F829;UPWARDS TRIANGLE-HEADED ARROW WITH BOLD SHAFT;So;0;ON;;;;;N;;;;;
1F82A;RIGHTWARDS TRIANGLE-HEADED ARROW WITH BOLD SHAFT;So;0;ON;;;;;N;;;;;
1F82B;DOWNWARDS TRIANGLE-HEADED ARROW WITH BOLD SHAFT;So;0;ON;;;;;N;;;;;
1F82C;LEFTWARDS TRIANGLE-HEADED ARROW WITH HEAVY SHAFT;So;0;ON;;;;;N;;;;;
1F82D;UPWARDS TRIANGLE-HEADED ARROW WITH HEAVY SHAFT;So;0;ON;;;;;N;;;;;
1F82E;RIGHTWARDS TRIANGLE-HEADED ARROW WITH HEAVY SHAFT;So;0;ON;;;;;N;;;;;
1F82F;DOWNWARDS TRIANGLE-HEADED ARROW WITH HEAVY SHAFT;So;0;ON;;;;;N;;;;;
1F830;LEFTWARDS TRIANGLE-HEADED ARROW WITH VERY HEAVY SHAFT;So;0;ON;;;;;N;;;;;
1F831;UPWARDS TRIANGLE-HEADED ARROW WITH VERY HEAVY SHAFT;So;0;ON;;;;;N;;;;;
1F832;RIGHTWARDS TRIANGLE-HEADED ARROW WITH VERY HEAVY SHAFT;So;0;ON;;;;;N;;;;;
1F833;DOWNWARDS TRIANGLE-HEADED ARROW WITH VERY HEAVY SHAFT;So;0;ON;;;;;N;;;;;
1F834;LEFTWARDS FINGER-POST ARROW;So;0;ON;;;;;N;;;;;
1F835;UPWARDS FINGER-POST ARROW;So;0;ON;;;;;N;;;;;
1F836;RIGHTWARDS FINGER-POST ARROW;So;0;ON;;;;;N;;;;;
1F837;DOWNWARDS FINGER-POST ARROW;So;0;ON;;;;;N;;;;;
1F838;LEFTWARDS SQUARED ARROW;So;0;ON;;;;;N;;;;;
1F839;UPWARDS SQUARED ARROW;So;0;ON;;;;;N;;;;;
1F83A;RIGHTWARDS SQUARED ARROW;So;0;ON;;;;;N;;;;;
1F83B;DOWNWARDS SQUARED ARROW;So;0;ON;;;;;N;;;;;
1F83C;LEFTWARDS COMPRESSED ARROW;So;0;ON;;;;;N;;;;;
1F83D;UPWARDS COMPRESSED ARROW;So;0;ON;;;;;N;;;;;
1F83E;RIGHTWARDS COMPRESSED ARROW;So;0;ON;;;;;N;;;;;
1F83F;DOWNWARDS COMPRESSED ARROW;So;0;ON;;;;;N;;;;;
1F840;LEFTWARDS HEAVY COMPRESSED ARROW;So;0;ON;;;;;N;;;;;
1F841;UPWARDS HEAVY COMPRESSED ARROW;So;0;ON;;;;;N;;;;;
1F842;RIGHTWARDS HEAVY COMPRESSED ARROW;So;0;ON;;;;;N;;;;;
1F843;DOWNWARDS HEAVY COMPRESSED ARROW;So;0;ON;;;;;N;;;;;
1F844;LEFTWARDS HEAVY ARROW;So;0;ON;;;;;N;;;;;
1F845;UPWARDS HEAVY ARROW;So;0;ON;;;;;N;;;;;
1F846;RIGHTWARDS HEAVY ARROW;So;0;ON;;;;;N;;;;;
1F847;DOWNWARDS HEAVY ARROW;So;0;ON;;;;;N;;;;;
1F850;LEFTWARDS SANS-SERIF ARROW;So;0;ON;;;;;N;;;;;
1F851;UPWARDS SANS-SERIF ARROW;So;0;ON;;;;;N;;;;;
1F852;RIGHTWARDS SANS-SERIF ARROW;So;0;ON;;;;;N;;;;;
1F853;DOWNWARDS SANS-SERIF ARROW;So;0;ON;;;;;N;;;;;
1F854;NORTH WEST SANS-SERIF ARROW;So;0;ON;;;;;N;;;;;
1F855;NORTH EAST SANS-SERIF ARROW;So;0;ON;;;;;N;;;;;
1F856;SOUTH EAST SANS-SERIF ARROW;So;0;ON;;;;;N;;;;;
1F857;SOUTH WEST SANS-SERIF ARROW;So;0;ON;;;;;N;;;;;
1F858;LEFT RIGHT SANS-SERIF ARROW;So;0;ON;;;;;N;;;;;
1F859;UP DOWN SANS-SERIF ARROW;So;0;ON;;;;;N;;;;;
1F860;WIDE-HEADED LEFTWARDS LIGHT BARB ARROW;So;0;ON;;;;;N;;;;;
1F861;WIDE-HEADED UPWARDS LIGHT BARB ARROW;So;0;ON;;;;;N;;;;;
1F862;WIDE-HEADED RIGHTWARDS LIGHT BARB ARROW;So;0;ON;;;;;N;;;;;
1F863;WIDE-HEADED DOWNWARDS LIGHT BARB ARROW;So;0;ON;;;;;N;;;;;
1F864;WIDE-HEADED NORTH WEST LIGHT BARB ARROW;So;0;ON;;;;;N;;;;;
1F865;WIDE-HEADED NORTH EAST LIGHT BARB ARROW;So;0;ON;;;;;N;;;;;
1F866;WIDE-HEADED SOUTH EAST LIGHT BARB ARROW;So;0;ON;;;;;N;;;;;
1F867;WIDE-HEADED SOUTH WEST LIGHT BARB ARROW;So;0;ON;;;;;N;;;;;
1F868;WIDE-HEADED LEFTWARDS BARB ARROW;So;0;ON;;;;;N;;;;;
1F869;WIDE-HEADED UPWARDS BARB ARROW;So;0;ON;;;;;N;;;;;
1F86A;WIDE-HEADED RIGHTWARDS BARB ARROW;So;0;ON;;;;;N;;;;;
1F86B;WIDE-HEADED DOWNWARDS BARB ARROW;So;0;ON;;;;;N;;;;;
1F86C;WIDE-HEADED NORTH WEST BARB ARROW;So;0;ON;;;;;N;;;;;
1F86D;WIDE-HEADED NORTH EAST BARB ARROW;So;0;ON;;;;;N;;;;;
1F86E;WIDE-HEADED SOUTH EAST BARB ARROW;So;0;ON;;;;;N;;;;;
1F86F;WIDE-HEADED SOUTH WEST BARB ARROW;So;0;ON;;;;;N;;;;;
1F870;WIDE-HEADED LEFTWARDS MEDIUM BARB ARROW;So;0;ON;;;;;N;;;;;
1F871;WIDE-HEADED UPWARDS MEDIUM BARB ARROW;So;0;ON;;;;;N;;;;;
1F872;WIDE-HEADED RIGHTWARDS MEDIUM BARB ARROW;So;0;ON;;;;;N;;;;;
1F873;WIDE-HEADED DOWNWARDS MEDIUM BARB ARROW;So;0;ON;;;;;N;;;;;
1F874;WIDE-HEADED NORTH WEST MEDIUM BARB ARROW;So;0;ON;;;;;N;;;;;
1F875;WIDE-HEADED NORTH EAST MEDIUM BARB ARROW;So;0;ON;;;;;N;;;;;
1F876;WIDE-HEADED SOUTH EAST MEDIUM BARB ARROW;So;0;ON;;;;;N;;;;;
1F877;WIDE-HEADED SOUTH WEST MEDIUM BARB ARROW;So;0;ON;;;;;N;;;;;
1F878;WIDE-HEADED LEFTWARDS HEAVY BARB ARROW;So;0;ON;;;;;N;;;;;
1F879;WIDE-HEADED UPWARDS HEAVY BARB ARROW;So;0;ON;;;;;N;;;;;
1F87A;WIDE-HEADED RIGHTWARDS HEAVY BARB ARROW;So;0;ON;;;;;N;;;;;
1F87B;WIDE-HEADED DOWNWARDS HEAVY BARB ARROW;So;0;ON;;;;;N;;;;;
1F87C;WIDE-HEADED NORTH WEST HEAVY BARB ARROW;So;0;ON;;;;;N;;;;;
1F87D;WIDE-HEADED NORTH EAST HEAVY BARB ARROW;So;0;ON;;;;;N;;;;;
1F87E;WIDE-HEADED SOUTH EAST HEAVY BARB ARROW;So;0;ON;;;;;N;;;;;
1F87F;WIDE-HEADED SOUTH WEST HEAVY BARB ARROW;So;0;ON;;;;;N;;;;;
1F880;WIDE-HEADED LEFTWARDS VERY HEAVY BARB ARROW;So;0;ON;;;;;N;;;;;
1F881;WIDE-HEADED UPWARDS VERY HEAVY BARB ARROW;So;0;ON;;;;;N;;;;;
1F882;WIDE-HEADED RIGHTWARDS VERY HEAVY BARB ARROW;So;0;ON;;;;;N;;;;;
1F883;WIDE-HEADED DOWNWARDS VERY HEAVY BARB ARROW;So;0;ON;;;;;N;;;;;
1F884;WIDE-HEADED NORTH WEST VERY HEAVY BARB ARROW;So;0;ON;;;;;N;;;;;
1F885;WIDE-HEADED NORTH EAST VERY HEAVY BARB ARROW;So;0;ON;;;;;N;;;;;
1F886;WIDE-HEADED SOUTH EAST VERY HEAVY BARB ARROW;So;0;ON;;;;;N;;;;;
1F887;WIDE-HEADED SOUTH WEST VERY HEAVY BARB ARROW;So;0;ON;;;;;N;;;;;
1F890;LEFTWARDS TRIANGLE ARROWHEAD;So;0;ON;;;;;N;;;;;
1F891;UPWARDS TRIANGLE ARROWHEAD;So;0;ON;;;;;N;;;;;
1F892;RIGHTWARDS TRIANGLE ARROWHEAD;So;0;ON;;;;;N;;;;;
1F893;DOWNWARDS TRIANGLE ARROWHEAD;So;0;ON;;;;;N;;;;;
1F894;LEFTWARDS WHITE ARROW WITHIN TRIANGLE ARROWHEAD;So;0;ON;;;;;N;;;;;
1F895;UPWARDS WHITE ARROW WITHIN TRIANGLE ARROWHEAD;So;0;ON;;;;;N;;;;;
1F896;RIGHTWARDS WHITE ARROW WITHIN TRIANGLE ARROWHEAD;So;0;ON;;;;;N;;;;;
1F897;DOWNWARDS WHITE ARROW WITHIN TRIANGLE ARROWHEAD;So;0;ON;;;;;N;;;;;
1F898;LEFTWARDS ARROW WITH NOTCHED TAIL;So;0;ON;;;;;N;;;;;
1F899;UPWARDS ARROW WITH NOTCHED TAIL;So;0;ON;;;;;N;;;;;
1F89A;RIGHTWARDS ARROW WITH NOTCHED TAIL;So;0;ON;;;;;N;;;;;
1F89B;DOWNWARDS ARROW WITH NOTCHED TAIL;So;0;ON;;;;;N;;;;;
1F89C;HEAVY ARROW SHAFT WIDTH ONE;So;0;ON;;;;;N;;;;;
1F89D;HEAVY ARROW SHAFT WIDTH TWO THIRDS;So;0;ON;;;;;N;;;;;
1F89E;HEAVY ARROW SHAFT WIDTH ONE HALF;So;0;ON;;;;;N;;;;;
1F89F;HEAVY ARROW SHAFT WIDTH ONE THIRD;So;0;ON;;;;;N;;;;;
1F8A0;LEFTWARDS BOTTOM-SHADED WHITE ARROW;So;0;ON;;;;;N;;;;;
1F8A1;RIGHTWARDS BOTTOM SHADED WHITE ARROW;So;0;ON;;;;;N;;;;;
1F8A2;LEFTWARDS TOP SHADED WHITE ARROW;So;0;ON;;;;;N;;;;;
1F8A3;RIGHTWARDS TOP SHADED WHITE ARROW;So;0;ON;;;;;N;;;;;
1F8A4;LEFTWARDS LEFT-SHADED WHITE ARROW;So;0;ON;;;;;N;;;;;
1F8A5;RIGHTWARDS RIGHT-SHADED WHITE ARROW;So;0;ON;;;;;N;;;;;
1F8A6;LEFTWARDS RIGHT-SHADED WHITE ARROW;So;0;ON;;;;;N;;;;;
1F8A7;RIGHTWARDS LEFT-SHADED WHITE ARROW;So;0;ON;;;;;N;;;;;
1F8A8;LEFTWARDS BACK-TILTED SHADOWED WHITE ARROW;So;0;ON;;;;;N;;;;;
1F8A9;RIGHTWARDS BACK-TILTED SHADOWED WHITE ARROW;So;0;ON;;;;;N;;;;;
1F8AA;LEFTWARDS FRONT-TILTED SHADOWED WHITE ARROW;So;0;ON;;;;;N;;;;;
1F8AB;RIGHTWARDS FRONT-TILTED SHADOWED WHITE ARROW;So;0;ON;;;;;N;;;;;
1F8AC;WHITE ARROW SHAFT WIDTH ONE;So;0;ON;;;;;N;;;;;
1F8AD;WHITE ARROW SHAFT WIDTH TWO THIRDS;So;0;ON;;;;;N;;;;;
1F8B0;ARROW POINTING UPWARDS THEN NORTH WEST;So;0;ON;;;;;N;;;;;
1F8B1;ARROW POINTING RIGHTWARDS THEN CURVING SOUTH WEST;So;0;ON;;;;;N;;;;;
1F900;CIRCLED CROSS FORMEE WITH FOUR DOTS;So;0;ON;;;;;N;;;;;
1F901;CIRCLED CROSS FORMEE WITH TWO DOTS;So;0;ON;;;;;N;;;;;
1F902;CIRCLED CROSS FORMEE;So;0;ON;;;;;N;;;;;
1F903;LEFT HALF CIRCLE WITH FOUR DOTS;So;0;ON;;;;;N;;;;;
1F904;LEFT HALF CIRCLE WITH THREE DOTS;So;0;ON;;;;;N;;;;;
1F905;LEFT HALF CIRCLE WITH TWO DOTS;So;0;ON;;;;;N;;;;;
1F906;LEFT HALF CIRCLE WITH DOT;So;0;ON;;;;;N;;;;;
1F907;LEFT HALF CIRCLE;So;0;ON;;;;;N;;;;;
1F908;DOWNWARD FACING HOOK;So;0;ON;;;;;N;;;;;
1F909;DOWNWARD FACING NOTCHED HOOK;So;0;ON;;;;;N;;;;;
1F90A;DOWNWARD FACING HOOK WITH DOT;So;0;ON;;;;;N;;;;;
1F90B;DOWNWARD FACING NOTCHED HOOK WITH DOT;So;0;ON;;;;;N;;;;;
1F90C;PINCHED FINGERS;So;0;ON;;;;;N;;;;;
1F90D;WHITE HEART;So;0;ON;;;;;N;;;;;
1F90E;BROWN HEART;So;0;ON;;;;;N;;;;;
1F90F;PINCHING HAND;So;0;ON;;;;;N;;;;;
1F910;ZIPPER-MOUTH FACE;So;0;ON;;;;;N;;;;;
1F911;MONEY-MOUTH FACE;So;0;ON;;;;;N;;;;;
1F912;FACE WITH THERMOMETER;So;0;ON;;;;;N;;;;;
1F913;NERD FACE;So;0;ON;;;;;N;;;;;
1F914;THINKING FACE;So;0;ON;;;;;N;;;;;
1F915;FACE WITH HEAD-BANDAGE;So;0;ON;;;;;N;;;;;
1F916;ROBOT FACE;So;0;ON;;;;;N;;;;;
1F917;HUGGING FACE;So;0;ON;;;;;N;;;;;
1F918;SIGN OF THE HORNS;So;0;ON;;;;;N;;;;;
1F919;CALL ME HAND;So;0;ON;;;;;N;;;;;
1F91A;RAISED BACK OF HAND;So;0;ON;;;;;N;;;;;
1F91B;LEFT-FACING FIST;So;0;ON;;;;;N;;;;;
1F91C;RIGHT-FACING FIST;So;0;ON;;;;;N;;;;;
1F91D;HANDSHAKE;So;0;ON;;;;;N;;;;;
1F91E;HAND WITH INDEX AND MIDDLE FINGERS CROSSED;So;0;ON;;;;;N;;;;;
1F91F;I LOVE YOU HAND SIGN;So;0;ON;;;;;N;;;;;
1F920;FACE WITH COWBOY HAT;So;0;ON;;;;;N;;;;;
1F921;CLOWN FACE;So;0;ON;;;;;N;;;;;
1F922;NAUSEATED FACE;So;0;ON;;;;;N;;;;;
1F923;ROLLING ON THE FLOOR LAUGHING;So;0;ON;;;;;N;;;;;
1F924;DROOLING FACE;So;0;ON;;;;;N;;;;;
1F925;LYING FACE;So;0;ON;;;;;N;;;;;
1F926;FACE PALM;So;0;ON;;;;;N;;;;;
1F927;SNEEZING FACE;So;0;ON;;;;;N;;;;;
1F928;FACE WITH ONE EYEBROW RAISED;So;0;ON;;;;;N;;;;;
1F929;GRINNING FACE WITH STAR EYES;So;0;ON;;;;;N;;;;;
1F92A;GRINNING FACE WITH ONE LARGE AND ONE SMALL EYE;So;0;ON;;;;;N;;;;;
1F92B;FACE WITH FINGER COVERING CLOSED LIPS;So;0;ON;;;;;N;;;;;
1F92C;SERIOUS FACE WITH SYMBOLS COVERING MOUTH;So;0;ON;;;;;N;;;;;
1F92D;SMILING FACE WITH SMILING EYES AND HAND COVERING MOUTH;So;0;ON;;;;;N;;;;;
1F92E;FACE WITH OPEN MOUTH VOMITING;So;0;ON;;;;;N;;;;;
1F92F;SHOCKED FACE WITH EXPLODING HEAD;So;0;ON;;;;;N;;;;;
1F930;PREGNANT WOMAN;So;0;ON;;;;;N;;;;;
1F931;BREAST-FEEDING;So;0;ON;;;;;N;;;;;
1F932;PALMS UP TOGETHER;So;0;ON;;;;;N;;;;;
1F933;SELFIE;So;0;ON;;;;;N;;;;;
1F934;PRINCE;So;0;ON;;;;;N;;;;;
1F935;MAN IN TUXEDO;So;0;ON;;;;;N;;;;;
1F936;MOTHER CHRISTMAS;So;0;ON;;;;;N;;;;;
1F937;SHRUG;So;0;ON;;;;;N;;;;;
1F938;PERSON DOING CARTWHEEL;So;0;ON;;;;;N;;;;;
1F939;JUGGLING;So;0;ON;;;;;N;;;;;
1F93A;FENCER;So;0;ON;;;;;N;;;;;
1F93B;MODERN PENTATHLON;So;0;ON;;;;;N;;;;;
1F93C;WRESTLERS;So;0;ON;;;;;N;;;;;
1F93D;WATER POLO;So;0;ON;;;;;N;;;;;
1F93E;HANDBALL;So;0;ON;;;;;N;;;;;
1F93F;DIVING MASK;So;0;ON;;;;;N;;;;;
1F940;WILTED FLOWER;So;0;ON;;;;;N;;;;;
1F941;DRUM WITH DRUMSTICKS;So;0;ON;;;;;N;;;;;
1F942;CLINKING GLASSES;So;0;ON;;;;;N;;;;;
1F943;TUMBLER GLASS;So;0;ON;;;;;N;;;;;
1F944;SPOON;So;0;ON;;;;;N;;;;;
1F945;GOAL NET;So;0;ON;;;;;N;;;;;
1F946;RIFLE;So;0;ON;;;;;N;;;;;
1F947;FIRST PLACE MEDAL;So;0;ON;;;;;N;;;;;
1F948;SECOND PLACE MEDAL;So;0;ON;;;;;N;;;;;
1F949;THIRD PLACE MEDAL;So;0;ON;;;;;N;;;;;
1F94A;BOXING GLOVE;So;0;ON;;;;;N;;;;;
1F94B;MARTIAL ARTS UNIFORM;So;0;ON;;;;;N;;;;;
1F94C;CURLING STONE;So;0;ON;;;;;N;;;;;
1F94D;LACROSSE STICK AND BALL;So;0;ON;;;;;N;;;;;
1F94E;SOFTBALL;So;0;ON;;;;;N;;;;;
1F94F;FLYING DISC;So;0;ON;;;;;N;;;;;
1F950;CROISSANT;So;0;ON;;;;;N;;;;;
1F951;AVOCADO;So;0;ON;;;;;N;;;;;
1F952;CUCUMBER;So;0;ON;;;;;N;;;;;
1F953;BACON;So;0;ON;;;;;N;;;;;
1F954;POTATO;So;0;ON;;;;;N;;;;;
1F955;CARROT;So;0;ON;;;;;N;;;;;
1F956;BAGUETTE BREAD;So;0;ON;;;;;N;;;;;
1F957;GREEN SALAD;So;0;ON;;;;;N;;;;;
1F958;SHALLOW PAN OF FOOD;So;0;ON;;;;;N;;;;;
1F959;STUFFED FLATBREAD;So;0;ON;;;;;N;;;;;
1F95A;EGG;So;0;ON;;;;;N;;;;;
1F95B;GLASS OF MILK;So;0;ON;;;;;N;;;;;
1F95C;PEANUTS;So;0;ON;;;;;N;;;;;
1F95D;KIWIFRUIT;So;0;ON;;;;;N;;;;;
1F95E;PANCAKES;So;0;ON;;;;;N;;;;;
1F95F;DUMPLING;So;0;ON;;;;;N;;;;;
1F960;FORTUNE COOKIE;So;0;ON;;;;;N;;;;;
1F961;TAKEOUT BOX;So;0;ON;;;;;N;;;;;
1F962;CHOPSTICKS;So;0;ON;;;;;N;;;;;
1F963;BOWL WITH SPOON;So;0;ON;;;;;N;;;;;
1F964;CUP WITH STRAW;So;0;ON;;;;;N;;;;;
1F965;COCONUT;So;0;ON;;;;;N;;;;;
1F966;BROCCOLI;So;0;ON;;;;;N;;;;;
1F967;PIE;So;0;ON;;;;;N;;;;;
1F968;PRETZEL;So;0;ON;;;;;N;;;;;
1F969;CUT OF MEAT;So;0;ON;;;;;N;;;;;
1F96A;SANDWICH;So;0;ON;;;;;N;;;;;
1F96B;CANNED FOOD;So;0;ON;;;;;N;;;;;
1F96C;LEAFY GREEN;So;0;ON;;;;;N;;;;;
1F96D;MANGO;So;0;ON;;;;;N;;;;;
1F96E;MOON CAKE;So;0;ON;;;;;N;;;;;
1F96F;BAGEL;So;0;ON;;;;;N;;;;;
1F970;SMILING FACE WITH SMILING EYES AND THREE HEARTS;So;0;ON;;;;;N;;;;;
1F971;YAWNING FACE;So;0;ON;;;;;N;;;;;
1F972;SMILING FACE WITH TEAR;So;0;ON;;;;;N;;;;;
1F973;FACE WITH PARTY HORN AND PARTY HAT;So;0;ON;;;;;N;;;;;
1F974;FACE WITH UNEVEN EYES AND WAVY MOUTH;So;0;ON;;;;;N;;;;;
1F975;OVERHEATED FACE;So;0;ON;;;;;N;;;;;
1F976;FREEZING FACE;So;0;ON;;;;;N;;;;;
1F977;NINJA;So;0;ON;;;;;N;;;;;
1F978;DISGUISED FACE;So;0;ON;;;;;N;;;;;
1F979;FACE HOLDING BACK TEARS;So;0;ON;;;;;N;;;;;
1F97A;FACE WITH PLEADING EYES;So;0;ON;;;;;N;;;;;
1F97B;SARI;So;0;ON;;;;;N;;;;;
1F97C;LAB COAT;So;0;ON;;;;;N;;;;;
1F97D;GOGGLES;So;0;ON;;;;;N;;;;;
1F97E;HIKING BOOT;So;0;ON;;;;;N;;;;;
1F97F;FLAT SHOE;So;0;ON;;;;;N;;;;;
1F980;CRAB;So;0;ON;;;;;N;;;;;
1F981;LION FACE;So;0;ON;;;;;N;;;;;
1F982;SCORPION;So;0;ON;;;;;N;;;;;
1F983;TURKEY;So;0;ON;;;;;N;;;;;
1F984;UNICORN FACE;So;0;ON;;;;;N;;;;;
1F985;EAGLE;So;0;ON;;;;;N;;;;;
1F986;DUCK;So;0;ON;;;;;N;;;;;
1F987;BAT;So;0;ON;;;;;N;;;;;
1F988;SHARK;So;0;ON;;;;;N;;;;;
1F989;OWL;So;0;ON;;;;;N;;;;;
1F98A;FOX FACE;So;0;ON;;;;;N;;;;;
1F98B;BUTTERFLY;So;0;ON;;;;;N;;;;;
1F98C;DEER;So;0;ON;;;;;N;;;;;
1F98D;GORILLA;So;0;ON;;;;;N;;;;;
1F98E;LIZARD;So;0;ON;;;;;N;;;;;
1F98F;RHINOCEROS;So;0;ON;;;;;N;;;;;
1F990;SHRIMP;So;0;ON;;;;;N;;;;;
1F991;SQUID;So;0;ON;;;;;N;;;;;
1F992;GIRAFFE FACE;So;0;ON;;;;;N;;;;;
1F993;ZEBRA FACE;So;0;ON;;;;;N;;;;;
1F994;HEDGEHOG;So;0;ON;;;;;N;;;;;
1F995;SAUROPOD;So;0;ON;;;;;N;;;;;
1F996;T-REX;So;0;ON;;;;;N;;;;;
1F997;CRICKET;So;0;ON;;;;;N;;;;;
1F998;KANGAROO;So;0;ON;;;;;N;;;;;
1F999;LLAMA;So;0;ON;;;;;N;;;;;
1F99A;PEACOCK;So;0;ON;;;;;N;;;;;
1F99B;HIPPOPOTAMUS;So;0;ON;;;;;N;;;;;
1F99C;PARROT;So;0;ON;;;;;N;;;;;
1F99D;RACCOON;So;0;ON;;;;;N;;;;;
1F99E;LOBSTER;So;0;ON;;;;;N;;;;;
1F99F;MOSQUITO;So;0;ON;;;;;N;;;;;
1F9A0;MICROBE;So;0;ON;;;;;N;;;;;
1F9A1;BADGER;So;0;ON;;;;;N;;;;;
1F9A2;SWAN;So;0;ON;;;;;N;;;;;
1F9A3;MAMMOTH;So;0;ON;;;;;N;;;;;
1F9A4;DODO;So;0;ON;;;;;N;;;;;
1F9A5;SLOTH;So;0;ON;;;;;N;;;;;
1F9A6;OTTER;So;0;ON;;;;;N;;;;;
1F9A7;ORANGUTAN;So;0;ON;;;;;N;;;;;
1F9A8;SKUNK;So;0;ON;;;;;N;;;;;
1F9A9;FLAMINGO;So;0;ON;;;;;N;;;;;
1F9AA;OYSTER;So;0;ON;;;;;N;;;;;
1F9AB;BEAVER;So;0;ON;;;;;N;;;;;
1F9AC;BISON;So;0;ON;;;;;N;;;;;
1F9AD;SEAL;So;0;ON;;;;;N;;;;;
1F9AE;GUIDE DOG;So;0;ON;;;;;N;;;;;
1F9AF;PROBING CANE;So;0;ON;;;;;N;;;;;
1F9B0;EMOJI COMPONENT RED HAIR;So;0;ON;;;;;N;;;;;
1F9B1;EMOJI COMPONENT CURLY HAIR;So;0;ON;;;;;N;;;;;
1F9B2;EMOJI COMPONENT BALD;So;0;ON;;;;;N;;;;;
1F9B3;EMOJI COMPONENT WHITE HAIR;So;0;ON;;;;;N;;;;;
1F9B4;BONE;So;0;ON;;;;;N;;;;;
1F9B5;LEG;So;0;ON;;;;;N;;;;;
1F9B6;FOOT;So;0;ON;;;;;N;;;;;
1F9B7;TOOTH;So;0;ON;;;;;N;;;;;
1F9B8;SUPERHERO;So;0;ON;;;;;N;;;;;
1F9B9;SUPERVILLAIN;So;0;ON;;;;;N;;;;;
1F9BA;SAFETY VEST;So;0;ON;;;;;N;;;;;
1F9BB;EAR WITH HEARING AID;So;0;ON;;;;;N;;;;;
1F9BC;MOTORIZED WHEELCHAIR;So;0;ON;;;;;N;;;;;
1F9BD;MANUAL WHEELCHAIR;So;0;ON;;;;;N;;;;;
1F9BE;MECHANICAL ARM;So;0;ON;;;;;N;;;;;
1F9BF;MECHANICAL LEG;So;0;ON;;;;;N;;;;;
1F9C0;CHEESE WEDGE;So;0;ON;;;;;N;;;;;
1F9C1;CUPCAKE;So;0;ON;;;;;N;;;;;
1F9C2;SALT SHAKER;So;0;ON;;;;;N;;;;;
1F9C3;BEVERAGE BOX;So;0;ON;;;;;N;;;;;
1F9C4;GARLIC;So;0;ON;;;;;N;;;;;
1F9C5;ONION;So;0;ON;;;;;N;;;;;
1F9C6;FALAFEL;So;0;ON;;;;;N;;;;;
1F9C7;WAFFLE;So;0;ON;;;;;N;;;;;
1F9C8;BUTTER;So;0;ON;;;;;N;;;;;
1F9C9;MATE DRINK;So;0;ON;;;;;N;;;;;
1F9CA;ICE CUBE;So;0;ON;;;;;N;;;;;
1F9CB;BUBBLE TEA;So;0;ON;;;;;N;;;;;
1F9CC;TROLL;So;0;ON;;;;;N;;;;;
1F9CD;STANDING PERSON;So;0;ON;;;;;N;;;;;
1F9CE;KNEELING PERSON;So;0;ON;;;;;N;;;;;
1F9CF;DEAF PERSON;So;0;ON;;;;;N;;;;;
1F9D0;FACE WITH MONOCLE;So;0;ON;;;;;N;;;;;
1F9D1;ADULT;So;0;ON;;;;;N;;;;;
1F9D2;CHILD;So;0;ON;;;;;N;;;;;
1F9D3;OLDER ADULT;So;0;ON;;;;;N;;;;;
1F9D4;BEARDED PERSON;So;0;ON;;;;;N;;;;;
1F9D5;PERSON WITH HEADSCARF;So;0;ON;;;;;N;;;;;
1F9D6;PERSON IN STEAMY ROOM;So;0;ON;;;;;N;;;;;
1F9D7;PERSON CLIMBING;So;0;ON;;;;;N;;;;;
1F9D8;PERSON IN LOTUS POSITION;So;0;ON;;;;;N;;;;;
1F9D9;MAGE;So;0;ON;;;;;N;;;;;
1F9DA;FAIRY;So;0;ON;;;;;N;;;;;
1F9DB;VAMPIRE;So;0;ON;;;;;N;;;;;
1F9DC;MERPERSON;So;0;ON;;;;;N;;;;;
1F9DD;ELF;So;0;ON;;;;;N;;;;;
1F9DE;GENIE;So;0;ON;;;;;N;;;;;
1F9DF;ZOMBIE;So;0;ON;;;;;N;;;;;
1F9E0;BRAIN;So;0;ON;;;;;N;;;;;
1F9E1;ORANGE HEART;So;0;ON;;;;;N;;;;;
1F9E2;BILLED CAP;So;0;ON;;;;;N;;;;;
1F9E3;SCARF;So;0;ON;;;;;N;;;;;
1F9E4;GLOVES;So;0;ON;;;;;N;;;;;
1F9E5;COAT;So;0;ON;;;;;N;;;;;
1F9E6;SOCKS;So;0;ON;;;;;N;;;;;
1F9E7;RED GIFT ENVELOPE;So;0;ON;;;;;N;;;;;
1F9E8;FIRECRACKER;So;0;ON;;;;;N;;;;;
1F9E9;JIGSAW PUZZLE PIECE;So;0;ON;;;;;N;;;;;
1F9EA;TEST TUBE;So;0;ON;;;;;N;;;;;
1F9EB;PETRI DISH;So;0;ON;;;;;N;;;;;
1F9EC;DNA DOUBLE HELIX;So;0;ON;;;;;N;;;;;
1F9ED;COMPASS;So;0;ON;;;;;N;;;;;
1F9EE;ABACUS;So;0;ON;;;;;N;;;;;
1F9EF;FIRE EXTINGUISHER;So;0;ON;;;;;N;;;;;
1F9F0;TOOLBOX;So;0;ON;;;;;N;;;;;
1F9F1;BRICK;So;0;ON;;;;;N;;;;;
1F9F2;MAGNET;So;0;ON;;;;;N;;;;;
1F9F3;LUGGAGE;So;0;ON;;;;;N;;;;;
1F9F4;LOTION BOTTLE;So;0;ON;;;;;N;;;;;
1F9F5;SPOOL OF THREAD;So;0;ON;;;;;N;;;;;
1F9F6;BALL OF YARN;So;0;ON;;;;;N;;;;;
1F9F7;SAFETY PIN;So;0;ON;;;;;N;;;;;
1F9F8;TEDDY BEAR;So;0;ON;;;;;N;;;;;
1F9F9;BROOM;So;0;ON;;;;;N;;;;;
1F9FA;BASKET;So;0;ON;;;;;N;;;;;
1F9FB;ROLL OF PAPER;So;0;ON;;;;;N;;;;;
1F9FC;BAR OF SOAP;So;0;ON;;;;;N;;;;;
1F9FD;SPONGE;So;0;ON;;;;;N;;;;;
1F9FE;RECEIPT;So;0;ON;;;;;N;;;;;
1F9FF;NAZAR AMULET;So;0;ON;;;;;N;;;;;
1FA00;NEUTRAL CHESS KING;So;0;ON;;;;;N;;;;;
1FA01;NEUTRAL CHESS QUEEN;So;0;ON;;;;;N;;;;;
1FA02;NEUTRAL CHESS ROOK;So;0;ON;;;;;N;;;;;
1FA03;NEUTRAL CHESS BISHOP;So;0;ON;;;;;N;;;;;
1FA04;NEUTRAL CHESS KNIGHT;So;0;ON;;;;;N;;;;;
1FA05;NEUTRAL CHESS PAWN;So;0;ON;;;;;N;;;;;
1FA06;WHITE CHESS KNIGHT ROTATED FORTY-FIVE DEGREES;So;0;ON;;;;;N;;;;;
1FA07;BLACK CHESS KNIGHT ROTATED FORTY-FIVE DEGREES;So;0;ON;;;;;N;;;;;
1FA08;NEUTRAL CHESS KNIGHT ROTATED FORTY-FIVE DEGREES;So;0;ON;;;;;N;;;;;
1FA09;WHITE CHESS KING ROTATED NINETY DEGREES;So;0;ON;;;;;N;;;;;
1FA0A;WHITE CHESS QUEEN ROTATED NINETY DEGREES;So;0;ON;;;;;N;;;;;
1FA0B;WHITE CHESS ROOK ROTATED NINETY DEGREES;So;0;ON;;;;;N;;;;;
1FA0C;WHITE CHESS BISHOP ROTATED NINETY DEGREES;So;0;ON;;;;;N;;;;;
1FA0D;WHITE CHESS KNIGHT ROTATED NINETY DEGREES;So;0;ON;;;;;N;;;;;
1FA0E;WHITE CHESS PAWN ROTATED NINETY DEGREES;So;0;ON;;;;;N;;;;;
1FA0F;BLACK CHESS KING ROTATED NINETY DEGREES;So;0;ON;;;;;N;;;;;
1FA10;BLACK CHESS QUEEN ROTATED NINETY DEGREES;So;0;ON;;;;;N;;;;;
1FA11;BLACK CHESS ROOK ROTATED NINETY DEGREES;So;0;ON;;;;;N;;;;;
1FA12;BLACK CHESS BISHOP ROTATED NINETY DEGREES;So;0;ON;;;;;N;;;;;
1FA13;BLACK CHESS KNIGHT ROTATED NINETY DEGREES;So;0;ON;;;;;N;;;;;
1FA14;BLACK CHESS PAWN ROTATED NINETY DEGREES;So;0;ON;;;;;N;;;;;
1FA15;NEUTRAL CHESS KING ROTATED NINETY DEGREES;So;0;ON;;;;;N;;;;;
1FA16;NEUTRAL CHESS QUEEN ROTATED NINETY DEGREES;So;0;ON;;;;;N;;;;;
1FA17;NEUTRAL CHESS ROOK ROTATED NINETY DEGREES;So;0;ON;;;;;N;;;;;
1FA18;NEUTRAL CHESS BISHOP ROTATED NINETY DEGREES;So;0;ON;;;;;N;;;;;
1FA19;NEUTRAL CHESS KNIGHT ROTATED NINETY DEGREES;So;0;ON;;;;;N;;;;;
1FA1A;NEUTRAL CHESS PAWN ROTATED NINETY DEGREES;So;0;ON;;;;;N;;;;;
1FA1B;WHITE CHESS KNIGHT ROTATED ONE HUNDRED THIRTY-FIVE DEGREES;So;0;ON;;;;;N;;;;;
1FA1C;BLACK CHESS KNIGHT ROTATED ONE HUNDRED THIRTY-FIVE DEGREES;So;0;ON;;;;;N;;;;;
1FA1D;NEUTRAL CHESS KNIGHT ROTATED ONE HUNDRED THIRTY-FIVE DEGREES;So;0;ON;;;;;N;;;;;
1FA1E;WHITE CHESS TURNED KING;So;0;ON;;;;;N;;;;;
1FA1F;WHITE CHESS TURNED QUEEN;So;0;ON;;;;;N;;;;;
1FA20;WHITE CHESS TURNED ROOK;So;0;ON;;;;;N;;;;;
1FA21;WHITE CHESS TURNED BISHOP;So;0;ON;;;;;N;;;;;
1FA22;WHITE CHESS TURNED KNIGHT;So;0;ON;;;;;N;;;;;
1FA23;WHITE CHESS TURNED PAWN;So;0;ON;;;;;N;;;;;
1FA24;BLACK CHESS TURNED KING;So;0;ON;;;;;N;;;;;
1FA25;BLACK CHESS TURNED QUEEN;So;0;ON;;;;;N;;;;;
1FA26;BLACK CHESS TURNED ROOK;So;0;ON;;;;;N;;;;;
1FA27;BLACK CHESS TURNED BISHOP;So;0;ON;;;;;N;;;;;
1FA28;BLACK CHESS TURNED KNIGHT;So;0;ON;;;;;N;;;;;
1FA29;BLACK CHESS TURNED PAWN;So;0;ON;;;;;N;;;;;
1FA2A;NEUTRAL CHESS TURNED KING;So;0;ON;;;;;N;;;;;
1FA2B;NEUTRAL CHESS TURNED QUEEN;So;0;ON;;;;;N;;;;;
1FA2C;NEUTRAL CHESS TURNED ROOK;So;0;ON;;;;;N;;;;;
1FA2D;NEUTRAL CHESS TURNED BISHOP;So;0;ON;;;;;N;;;;;
1FA2E;NEUTRAL CHESS TURNED KNIGHT;So;0;ON;;;;;N;;;;;
1FA2F;NEUTRAL CHESS TURNED PAWN;So;0;ON;;;;;N;;;;;
1FA30;WHITE CHESS KNIGHT ROTATED TWO HUNDRED TWENTY-FIVE DEGREES;So;0;ON;;;;;N;;;;;
1FA31;BLACK CHESS KNIGHT ROTATED TWO HUNDRED TWENTY-FIVE DEGREES;So;0;ON;;;;;N;;;;;
1FA32;NEUTRAL CHESS KNIGHT ROTATED TWO HUNDRED TWENTY-FIVE DEGREES;So;0;ON;;;;;N;;;;;
1FA33;WHITE CHESS KING ROTATED TWO HUNDRED SEVENTY DEGREES;So;0;ON;;;;;N;;;;;
1FA34;WHITE CHESS QUEEN ROTATED TWO HUNDRED SEVENTY DEGREES;So;0;ON;;;;;N;;;;;
1FA35;WHITE CHESS ROOK ROTATED TWO HUNDRED SEVENTY DEGREES;So;0;ON;;;;;N;;;;;
1FA36;WHITE CHESS BISHOP ROTATED TWO HUNDRED SEVENTY DEGREES;So;0;ON;;;;;N;;;;;
1FA37;WHITE CHESS KNIGHT ROTATED TWO HUNDRED SEVENTY DEGREES;So;0;ON;;;;;N;;;;;
1FA38;WHITE CHESS PAWN ROTATED TWO HUNDRED SEVENTY DEGREES;So;0;ON;;;;;N;;;;;
1FA39;BLACK CHESS KING ROTATED TWO HUNDRED SEVENTY DEGREES;So;0;ON;;;;;N;;;;;
1FA3A;BLACK CHESS QUEEN ROTATED TWO HUNDRED SEVENTY DEGREES;So;0;ON;;;;;N;;;;;
1FA3B;BLACK CHESS ROOK ROTATED TWO HUNDRED SEVENTY DEGREES;So;0;ON;;;;;N;;;;;
1FA3C;BLACK CHESS BISHOP ROTATED TWO HUNDRED SEVENTY DEGREES;So;0;ON;;;;;N;;;;;
1FA3D;BLACK CHESS KNIGHT ROTATED TWO HUNDRED SEVENTY DEGREES;So;0;ON;;;;;N;;;;;
1FA3E;BLACK CHESS PAWN ROTATED TWO HUNDRED SEVENTY DEGREES;So;0;ON;;;;;N;;;;;
1FA3F;NEUTRAL CHESS KING ROTATED TWO HUNDRED SEVENTY DEGREES;So;0;ON;;;;;N;;;;;
1FA40;NEUTRAL CHESS QUEEN ROTATED TWO HUNDRED SEVENTY DEGREES;So;0;ON;;;;;N;;;;;
1FA41;NEUTRAL CHESS ROOK ROTATED TWO HUNDRED SEVENTY DEGREES;So;0;ON;;;;;N;;;;;
1FA42;NEUTRAL CHESS BISHOP ROTATED TWO HUNDRED SEVENTY DEGREES;So;0;ON;;;;;N;;;;;
1FA43;NEUTRAL CHESS KNIGHT ROTATED TWO HUNDRED SEVENTY DEGREES;So;0;ON;;;;;N;;;;;
1FA44;NEUTRAL CHESS PAWN ROTATED TWO HUNDRED SEVENTY DEGREES;So;0;ON;;;;;N;;;;;
1FA45;WHITE CHESS KNIGHT ROTATED THREE HUNDRED FIFTEEN DEGREES;So;0;ON;;;;;N;;;;;
1FA46;BLACK CHESS KNIGHT ROTATED THREE HUNDRED FIFTEEN DEGREES;So;0;ON;;;;;N;;;;;
1FA47;NEUTRAL CHESS KNIGHT ROTATED THREE HUNDRED FIFTEEN DEGREES;So;0;ON;;;;;N;;;;;
1FA48;WHITE CHESS EQUIHOPPER;So;0;ON;;;;;N;;;;;
1FA49;BLACK CHESS EQUIHOPPER;So;0;ON;;;;;N;;;;;
1FA4A;NEUTRAL CHESS EQUIHOPPER;So;0;ON;;;;;N;;;;;
1FA4B;WHITE CHESS EQUIHOPPER ROTATED NINETY DEGREES;So;0;ON;;;;;N;;;;;
1FA4C;BLACK CHESS EQUIHOPPER ROTATED NINETY DEGREES;So;0;ON;;;;;N;;;;;
1FA4D;NEUTRAL CHESS EQUIHOPPER ROTATED NINETY DEGREES;So;0;ON;;;;;N;;;;;
1FA4E;WHITE CHESS KNIGHT-QUEEN;So;0;ON;;;;;N;;;;;
1FA4F;WHITE CHESS KNIGHT-ROOK;So;0;ON;;;;;N;;;;;
1FA50;WHITE CHESS KNIGHT-BISHOP;So;0;ON;;;;;N;;;;;
1FA51;BLACK CHESS KNIGHT-QUEEN;So;0;ON;;;;;N;;;;;
1FA52;BLACK CHESS KNIGHT-ROOK;So;0;ON;;;;;N;;;;;
1FA53;BLACK CHESS KNIGHT-BISHOP;So;0;ON;;;;;N;;;;;
1FA60;XIANGQI RED GENERAL;So;0;ON;;;;;N;;;;;
1FA61;XIANGQI RED MANDARIN;So;0;ON;;;;;N;;;;;
1FA62;XIANGQI RED ELEPHANT;So;0;ON;;;;;N;;;;;
1FA63;XIANGQI RED HORSE;So;0;ON;;;;;N;;;;;
1FA64;XIANGQI RED CHARIOT;So;0;ON;;;;;N;;;;;
1FA65;XIANGQI RED CANNON;So;0;ON;;;;;N;;;;;
1FA66;XIANGQI RED SOLDIER;So;0;ON;;;;;N;;;;;
1FA67;XIANGQI BLACK GENERAL;So;0;ON;;;;;N;;;;;
1FA68;XIANGQI BLACK MANDARIN;So;0;ON;;;;;N;;;;;
1FA69;XIANGQI BLACK ELEPHANT;So;0;ON;;;;;N;;;;;
1FA6A;XIANGQI BLACK HORSE;So;0;ON;;;;;N;;;;;
1FA6B;XIANGQI BLACK CHARIOT;So;0;ON;;;;;N;;;;;
1FA6C;XIANGQI BLACK CANNON;So;0;ON;;;;;N;;;;;
1FA6D;XIANGQI BLACK SOLDIER;So;0;ON;;;;;N;;;;;
1FA70;BALLET SHOES;So;0;ON;;;;;N;;;;;
1FA71;ONE-PIECE SWIMSUIT;So;0;ON;;;;;N;;;;;
1FA72;BRIEFS;So;0;ON;;;;;N;;;;;
1FA73;SHORTS;So;0;ON;;;;;N;;;;;
1FA74;THONG SANDAL;So;0;ON;;;;;N;;;;;
1FA78;DROP OF BLOOD;So;0;ON;;;;;N;;;;;
1FA79;ADHESIVE BANDAGE;So;0;ON;;;;;N;;;;;
1FA7A;STETHOSCOPE;So;0;ON;;;;;N;;;;;
1FA7B;X-RAY;So;0;ON;;;;;N;;;;;
1FA7C;CRUTCH;So;0;ON;;;;;N;;;;;
1FA80;YO-YO;So;0;ON;;;;;N;;;;;
1FA81;KITE;So;0;ON;;;;;N;;;;;
1FA82;PARACHUTE;So;0;ON;;;;;N;;;;;
1FA83;BOOMERANG;So;0;ON;;;;;N;;;;;
1FA84;MAGIC WAND;So;0;ON;;;;;N;;;;;
1FA85;PINATA;So;0;ON;;;;;N;;;;;
1FA86;NESTING DOLLS;So;0;ON;;;;;N;;;;;
1FA90;RINGED PLANET;So;0;ON;;;;;N;;;;;
1FA91;CHAIR;So;0;ON;;;;;N;;;;;
1FA92;RAZOR;So;0;ON;;;;;N;;;;;
1FA93;AXE;So;0;ON;;;;;N;;;;;
1FA94;DIYA LAMP;So;0;ON;;;;;N;;;;;
1FA95;BANJO;So;0;ON;;;;;N;;;;;
1FA96;MILITARY HELMET;So;0;ON;;;;;N;;;;;
1FA97;ACCORDION;So;0;ON;;;;;N;;;;;
1FA98;LONG DRUM;So;0;ON;;;;;N;;;;;
1FA99;COIN;So;0;ON;;;;;N;;;;;
1FA9A;CARPENTRY SAW;So;0;ON;;;;;N;;;;;
1FA9B;SCREWDRIVER;So;0;ON;;;;;N;;;;;
1FA9C;LADDER;So;0;ON;;;;;N;;;;;
1FA9D;HOOK;So;0;ON;;;;;N;;;;;
1FA9E;MIRROR;So;0;ON;;;;;N;;;;;
1FA9F;WINDOW;So;0;ON;;;;;N;;;;;
1FAA0;PLUNGER;So;0;ON;;;;;N;;;;;
1FAA1;SEWING NEEDLE;So;0;ON;;;;;N;;;;;
1FAA2;KNOT;So;0;ON;;;;;N;;;;;
1FAA3;BUCKET;So;0;ON;;;;;N;;;;;
1FAA4;MOUSE TRAP;So;0;ON;;;;;N;;;;;
1FAA5;TOOTHBRUSH;So;0;ON;;;;;N;;;;;
1FAA6;HEADSTONE;So;0;ON;;;;;N;;;;;
1FAA7;PLACARD;So;0;ON;;;;;N;;;;;
1FAA8;ROCK;So;0;ON;;;;;N;;;;;
1FAA9;MIRROR BALL;So;0;ON;;;;;N;;;;;
1FAAA;IDENTIFICATION CARD;So;0;ON;;;;;N;;;;;
1FAAB;LOW BATTERY;So;0;ON;;;;;N;;;;;
1FAAC;HAMSA;So;0;ON;;;;;N;;;;;
1FAB0;FLY;So;0;ON;;;;;N;;;;;
1FAB1;WORM;So;0;ON;;;;;N;;;;;
1FAB2;BEETLE;So;0;ON;;;;;N;;;;;
1FAB3;COCKROACH;So;0;ON;;;;;N;;;;;
1FAB4;POTTED PLANT;So;0;ON;;;;;N;;;;;
1FAB5;WOOD;So;0;ON;;;;;N;;;;;
1FAB6;FEATHER;So;0;ON;;;;;N;;;;;
1FAB7;LOTUS;So;0;ON;;;;;N;;;;;
1FAB8;CORAL;So;0;ON;;;;;N;;;;;
1FAB9;EMPTY NEST;So;0;ON;;;;;N;;;;;
1FABA;NEST WITH EGGS;So;0;ON;;;;;N;;;;;
1FAC0;ANATOMICAL HEART;So;0;ON;;;;;N;;;;;
1FAC1;LUNGS;So;0;ON;;;;;N;;;;;
1FAC2;PEOPLE HUGGING;So;0;ON;;;;;N;;;;;
1FAC3;PREGNANT MAN;So;0;ON;;;;;N;;;;;
1FAC4;PREGNANT PERSON;So;0;ON;;;;;N;;;;;
1FAC5;PERSON WITH CROWN;So;0;ON;;;;;N;;;;;
1FAD0;BLUEBERRIES;So;0;ON;;;;;N;;;;;
1FAD1;BELL PEPPER;So;0;ON;;;;;N;;;;;
1FAD2;OLIVE;So;0;ON;;;;;N;;;;;
1FAD3;FLATBREAD;So;0;ON;;;;;N;;;;;
1FAD4;TAMALE;So;0;ON;;;;;N;;;;;
1FAD5;FONDUE;So;0;ON;;;;;N;;;;;
1FAD6;TEAPOT;So;0;ON;;;;;N;;;;;
1FAD7;POURING LIQUID;So;0;ON;;;;;N;;;;;
1FAD8;BEANS;So;0;ON;;;;;N;;;;;
1FAD9;JAR;So;0;ON;;;;;N;;;;;
1FAE0;MELTING FACE;So;0;ON;;;;;N;;;;;
1FAE1;SALUTING FACE;So;0;ON;;;;;N;;;;;
1FAE2;FACE WITH OPEN EYES AND HAND OVER MOUTH;So;0;ON;;;;;N;;;;;
1FAE3;FACE WITH PEEKING EYE;So;0;ON;;;;;N;;;;;
1FAE4;FACE WITH DIAGONAL MOUTH;So;0;ON;;;;;N;;;;;
1FAE5;DOTTED LINE FACE;So;0;ON;;;;;N;;;;;
1FAE6;BITING LIP;So;0;ON;;;;;N;;;;;
1FAE7;BUBBLES;So;0;ON;;;;;N;;;;;
1FAF0;HAND WITH INDEX FINGER AND THUMB CROSSED;So;0;ON;;;;;N;;;;;
1FAF1;RIGHTWARDS HAND;So;0;ON;;;;;N;;;;;
1FAF2;LEFTWARDS HAND;So;0;ON;;;;;N;;;;;
1FAF3;PALM DOWN HAND;So;0;ON;;;;;N;;;;;
1FAF4;PALM UP HAND;So;0;ON;;;;;N;;;;;
1FAF5;INDEX POINTING AT THE VIEWER;So;0;ON;;;;;N;;;;;
1FAF6;HEART HANDS;So;0;ON;;;;;N;;;;;
1FB00;BLOCK SEXTANT-1;So;0;ON;;;;;N;;;;;
1FB01;BLOCK SEXTANT-2;So;0;ON;;;;;N;;;;;
1FB02;BLOCK SEXTANT-12;So;0;ON;;;;;N;;;;;
1FB03;BLOCK SEXTANT-3;So;0;ON;;;;;N;;;;;
1FB04;BLOCK SEXTANT-13;So;0;ON;;;;;N;;;;;
1FB05;BLOCK SEXTANT-23;So;0;ON;;;;;N;;;;;
1FB06;BLOCK SEXTANT-123;So;0;ON;;;;;N;;;;;
1FB07;BLOCK SEXTANT-4;So;0;ON;;;;;N;;;;;
1FB08;BLOCK SEXTANT-14;So;0;ON;;;;;N;;;;;
1FB09;BLOCK SEXTANT-24;So;0;ON;;;;;N;;;;;
1FB0A;BLOCK SEXTANT-124;So;0;ON;;;;;N;;;;;
1FB0B;BLOCK SEXTANT-34;So;0;ON;;;;;N;;;;;
1FB0C;BLOCK SEXTANT-134;So;0;ON;;;;;N;;;;;
1FB0D;BLOCK SEXTANT-234;So;0;ON;;;;;N;;;;;
1FB0E;BLOCK SEXTANT-1234;So;0;ON;;;;;N;;;;;
1FB0F;BLOCK SEXTANT-5;So;0;ON;;;;;N;;;;;
1FB10;BLOCK SEXTANT-15;So;0;ON;;;;;N;;;;;
1FB11;BLOCK SEXTANT-25;So;0;ON;;;;;N;;;;;
1FB12;BLOCK SEXTANT-125;So;0;ON;;;;;N;;;;;
1FB13;BLOCK SEXTANT-35;So;0;ON;;;;;N;;;;;
1FB14;BLOCK SEXTANT-235;So;0;ON;;;;;N;;;;;
1FB15;BLOCK SEXTANT-1235;So;0;ON;;;;;N;;;;;
1FB16;BLOCK SEXTANT-45;So;0;ON;;;;;N;;;;;
1FB17;BLOCK SEXTANT-145;So;0;ON;;;;;N;;;;;
1FB18;BLOCK SEXTANT-245;So;0;ON;;;;;N;;;;;
1FB19;BLOCK SEXTANT-1245;So;0;ON;;;;;N;;;;;
1FB1A;BLOCK SEXTANT-345;So;0;ON;;;;;N;;;;;
1FB1B;BLOCK SEXTANT-1345;So;0;ON;;;;;N;;;;;
1FB1C;BLOCK SEXTANT-2345;So;0;ON;;;;;N;;;;;
1FB1D;BLOCK SEXTANT-12345;So;0;ON;;;;;N;;;;;
1FB1E;BLOCK SEXTANT-6;So;0;ON;;;;;N;;;;;
1FB1F;BLOCK SEXTANT-16;So;0;ON;;;;;N;;;;;
1FB20;BLOCK SEXTANT-26;So;0;ON;;;;;N;;;;;
1FB21;BLOCK SEXTANT-126;So;0;ON;;;;;N;;;;;
1FB22;BLOCK SEXTANT-36;So;0;ON;;;;;N;;;;;
1FB23;BLOCK SEXTANT-136;So;0;ON;;;;;N;;;;;
1FB24;BLOCK SEXTANT-236;So;0;ON;;;;;N;;;;;
1FB25;BLOCK SEXTANT-1236;So;0;ON;;;;;N;;;;;
1FB26;BLOCK SEXTANT-46;So;0;ON;;;;;N;;;;;
1FB27;BLOCK SEXTANT-146;So;0;ON;;;;;N;;;;;
1FB28;BLOCK SEXTANT-1246;So;0;ON;;;;;N;;;;;
1FB29;BLOCK SEXTANT-346;So;0;ON;;;;;N;;;;;
1FB2A;BLOCK SEXTANT-1346;So;0;ON;;;;;N;;;;;
1FB2B;BLOCK SEXTANT-2346;So;0;ON;;;;;N;;;;;
1FB2C;BLOCK SEXTANT-12346;So;0;ON;;;;;N;;;;;
1FB2D;BLOCK SEXTANT-56;So;0;ON;;;;;N;;;;;
1FB2E;BLOCK SEXTANT-156;So;0;ON;;;;;N;;;;;
1FB2F;BLOCK SEXTANT-256;So;0;ON;;;;;N;;;;;
1FB30;BLOCK SEXTANT-1256;So;0;ON;;;;;N;;;;;
1FB31;BLOCK SEXTANT-356;So;0;ON;;;;;N;;;;;
1FB32;BLOCK SEXTANT-1356;So;0;ON;;;;;N;;;;;
1FB33;BLOCK SEXTANT-2356;So;0;ON;;;;;N;;;;;
1FB34;BLOCK SEXTANT-12356;So;0;ON;;;;;N;;;;;
1FB35;BLOCK SEXTANT-456;So;0;ON;;;;;N;;;;;
1FB36;BLOCK SEXTANT-1456;So;0;ON;;;;;N;;;;;
1FB37;BLOCK SEXTANT-2456;So;0;ON;;;;;N;;;;;
1FB38;BLOCK SEXTANT-12456;So;0;ON;;;;;N;;;;;
1FB39;BLOCK SEXTANT-3456;So;0;ON;;;;;N;;;;;
1FB3A;BLOCK SEXTANT-13456;So;0;ON;;;;;N;;;;;
1FB3B;BLOCK SEXTANT-23456;So;0;ON;;;;;N;;;;;
1FB3C;LOWER LEFT BLOCK DIAGONAL LOWER MIDDLE LEFT TO LOWER CENTRE;So;0;ON;;;;;N;;;;;
1FB3D;LOWER LEFT BLOCK DIAGONAL LOWER MIDDLE LEFT TO LOWER RIGHT;So;0;ON;;;;;N;;;;;
1FB3E;LOWER LEFT BLOCK DIAGONAL UPPER MIDDLE LEFT TO LOWER CENTRE;So;0;ON;;;;;N;;;;;
1FB3F;LOWER LEFT BLOCK DIAGONAL UPPER MIDDLE LEFT TO LOWER RIGHT;So;0;ON;;;;;N;;;;;
1FB40;LOWER LEFT BLOCK DIAGONAL UPPER LEFT TO LOWER CENTRE;So;0;ON;;;;;N;;;;;
1FB41;LOWER RIGHT BLOCK DIAGONAL UPPER MIDDLE LEFT TO UPPER CENTRE;So;0;ON;;;;;N;;;;;
1FB42;LOWER RIGHT BLOCK DIAGONAL UPPER MIDDLE LEFT TO UPPER RIGHT;So;0;ON;;;;;N;;;;;
1FB43;LOWER RIGHT BLOCK DIAGONAL LOWER MIDDLE LEFT TO UPPER CENTRE;So;0;ON;;;;;N;;;;;
1FB44;LOWER RIGHT BLOCK DIAGONAL LOWER MIDDLE LEFT TO UPPER RIGHT;So;0;ON;;;;;N;;;;;
1FB45;LOWER RIGHT BLOCK DIAGONAL LOWER LEFT TO UPPER CENTRE;So;0;ON;;;;;N;;;;;
1FB46;LOWER RIGHT BLOCK DIAGONAL LOWER MIDDLE LEFT TO UPPER MIDDLE RIGHT;So;0;ON;;;;;N;;;;;
1FB47;LOWER RIGHT BLOCK DIAGONAL LOWER CENTRE TO LOWER MIDDLE RIGHT;So;0;ON;;;;;N;;;;;
1FB48;LOWER RIGHT BLOCK DIAGONAL LOWER LEFT TO LOWER MIDDLE RIGHT;So;0;ON;;;;;N;;;;;
1FB49;LOWER RIGHT BLOCK DIAGONAL LOWER CENTRE TO UPPER MIDDLE RIGHT;So;0;ON;;;;;N;;;;;
1FB4A;LOWER RIGHT BLOCK DIAGONAL LOWER LEFT TO UPPER MIDDLE RIGHT;So;0;ON;;;;;N;;;;;
1FB4B;LOWER RIGHT BLOCK DIAGONAL LOWER CENTRE TO UPPER RIGHT;So;0;ON;;;;;N;;;;;
1FB4C;LOWER LEFT BLOCK DIAGONAL UPPER CENTRE TO UPPER MIDDLE RIGHT;So;0;ON;;;;;N;;;;;
1FB4D;LOWER LEFT BLOCK DIAGONAL UPPER LEFT TO UPPER MIDDLE RIGHT;So;0;ON;;;;;N;;;;;
1FB4E;LOWER LEFT BLOCK DIAGONAL UPPER CENTRE TO LOWER MIDDLE RIGHT;So;0;ON;;;;;N;;;;;
1FB4F;LOWER LEFT BLOCK DIAGONAL UPPER LEFT TO LOWER MIDDLE RIGHT;So;0;ON;;;;;N;;;;;
1FB50;LOWER LEFT BLOCK DIAGONAL UPPER CENTRE TO LOWER RIGHT;So;0;ON;;;;;N;;;;;
1FB51;LOWER LEFT BLOCK DIAGONAL UPPER MIDDLE LEFT TO LOWER MIDDLE RIGHT;So;0;ON;;;;;N;;;;;
1FB52;UPPER RIGHT BLOCK DIAGONAL LOWER MIDDLE LEFT TO LOWER CENTRE;So;0;ON;;;;;N;;;;;
1FB53;UPPER RIGHT BLOCK DIAGONAL LOWER MIDDLE LEFT TO LOWER RIGHT;So;0;ON;;;;;N;;;;;
1FB54;UPPER RIGHT BLOCK DIAGONAL UPPER MIDDLE LEFT TO LOWER CENTRE;So;0;ON;;;;;N;;;;;
1FB55;UPPER RIGHT BLOCK DIAGONAL UPPER MIDDLE LEFT TO LOWER RIGHT;So;0;ON;;;;;N;;;;;
1FB56;UPPER RIGHT BLOCK DIAGONAL UPPER LEFT TO LOWER CENTRE;So;0;ON;;;;;N;;;;;
1FB57;UPPER LEFT BLOCK DIAGONAL UPPER MIDDLE LEFT TO UPPER CENTRE;So;0;ON;;;;;N;;;;;
1FB58;UPPER LEFT BLOCK DIAGONAL UPPER MIDDLE LEFT TO UPPER RIGHT;So;0;ON;;;;;N;;;;;
1FB59;UPPER LEFT BLOCK DIAGONAL LOWER MIDDLE LEFT TO UPPER CENTRE;So;0;ON;;;;;N;;;;;
1FB5A;UPPER LEFT BLOCK DIAGONAL LOWER MIDDLE LEFT TO UPPER RIGHT;So;0;ON;;;;;N;;;;;
1FB5B;UPPER LEFT BLOCK DIAGONAL LOWER LEFT TO UPPER CENTRE;So;0;ON;;;;;N;;;;;
1FB5C;UPPER LEFT BLOCK DIAGONAL LOWER MIDDLE LEFT TO UPPER MIDDLE RIGHT;So;0;ON;;;;;N;;;;;
1FB5D;UPPER LEFT BLOCK DIAGONAL LOWER CENTRE TO LOWER MIDDLE RIGHT;So;0;ON;;;;;N;;;;;
1FB5E;UPPER LEFT BLOCK DIAGONAL LOWER LEFT TO LOWER MIDDLE RIGHT;So;0;ON;;;;;N;;;;;
1FB5F;UPPER LEFT BLOCK DIAGONAL LOWER CENTRE TO UPPER MIDDLE RIGHT;So;0;ON;;;;;N;;;;;
1FB60;UPPER LEFT BLOCK DIAGONAL LOWER LEFT TO UPPER MIDDLE RIGHT;So;0;ON;;;;;N;;;;;
1FB61;UPPER LEFT BLOCK DIAGONAL LOWER CENTRE TO UPPER RIGHT;So;0;ON;;;;;N;;;;;
1FB62;UPPER RIGHT BLOCK DIAGONAL UPPER CENTRE TO UPPER MIDDLE RIGHT;So;0;ON;;;;;N;;;;;
1FB63;UPPER RIGHT BLOCK DIAGONAL UPPER LEFT TO UPPER MIDDLE RIGHT;So;0;ON;;;;;N;;;;;
1FB64;UPPER RIGHT BLOCK DIAGONAL UPPER CENTRE TO LOWER MIDDLE RIGHT;So;0;ON;;;;;N;;;;;
1FB65;UPPER RIGHT BLOCK DIAGONAL UPPER LEFT TO LOWER MIDDLE RIGHT;So;0;ON;;;;;N;;;;;
1FB66;UPPER RIGHT BLOCK DIAGONAL UPPER CENTRE TO LOWER RIGHT;So;0;ON;;;;;N;;;;;
1FB67;UPPER RIGHT BLOCK DIAGONAL UPPER MIDDLE LEFT TO LOWER MIDDLE RIGHT;So;0;ON;;;;;N;;;;;
1FB68;UPPER AND RIGHT AND LOWER TRIANGULAR THREE QUARTERS BLOCK;So;0;ON;;;;;N;;;;;
1FB69;LEFT AND LOWER AND RIGHT TRIANGULAR THREE QUARTERS BLOCK;So;0;ON;;;;;N;;;;;
1FB6A;UPPER AND LEFT AND LOWER TRIANGULAR THREE QUARTERS BLOCK;So;0;ON;;;;;N;;;;;
1FB6B;LEFT AND UPPER AND RIGHT TRIANGULAR THREE QUARTERS BLOCK;So;0;ON;;;;;N;;;;;
1FB6C;LEFT TRIANGULAR ONE QUARTER BLOCK;So;0;ON;;;;;N;;;;;
1FB6D;UPPER TRIANGULAR ONE QUARTER BLOCK;So;0;ON;;;;;N;;;;;
1FB6E;RIGHT TRIANGULAR ONE QUARTER BLOCK;So;0;ON;;;;;N;;;;;
1FB6F;LOWER TRIANGULAR ONE QUARTER BLOCK;So;0;ON;;;;;N;;;;;
1FB70;VERTICAL ONE EIGHTH BLOCK-2;So;0;ON;;;;;N;;;;;
1FB71;VERTICAL ONE EIGHTH BLOCK-3;So;0;ON;;;;;N;;;;;
1FB72;VERTICAL ONE EIGHTH BLOCK-4;So;0;ON;;;;;N;;;;;
1FB73;VERTICAL ONE EIGHTH BLOCK-5;So;0;ON;;;;;N;;;;;
1FB74;VERTICAL ONE EIGHTH BLOCK-6;So;0;ON;;;;;N;;;;;
1FB75;VERTICAL ONE EIGHTH BLOCK-7;So;0;ON;;;;;N;;;;;
1FB76;HORIZONTAL ONE EIGHTH BLOCK-2;So;0;ON;;;;;N;;;;;
1FB77;HORIZONTAL ONE EIGHTH BLOCK-3;So;0;ON;;;;;N;;;;;
1FB78;HORIZONTAL ONE EIGHTH BLOCK-4;So;0;ON;;;;;N;;;;;
1FB79;HORIZONTAL ONE EIGHTH BLOCK-5;So;0;ON;;;;;N;;;;;
1FB7A;HORIZONTAL ONE EIGHTH BLOCK-6;So;0;ON;;;;;N;;;;;
1FB7B;HORIZONTAL ONE EIGHTH BLOCK-7;So;0;ON;;;;;N;;;;;
1FB7C;LEFT AND LOWER ONE EIGHTH BLOCK;So;0;ON;;;;;N;;;;;
1FB7D;LEFT AND UPPER ONE EIGHTH BLOCK;So;0;ON;;;;;N;;;;;
1FB7E;RIGHT AND UPPER ONE EIGHTH BLOCK;So;0;ON;;;;;N;;;;;
1FB7F;RIGHT AND LOWER ONE EIGHTH BLOCK;So;0;ON;;;;;N;;;;;
1FB80;UPPER AND LOWER ONE EIGHTH BLOCK;So;0;ON;;;;;N;;;;;
1FB81;HORIZONTAL ONE EIGHTH BLOCK-1358;So;0;ON;;;;;N;;;;;
1FB82;UPPER ONE QUARTER BLOCK;So;0;ON;;;;;N;;;;;
1FB83;UPPER THREE EIGHTHS BLOCK;So;0;ON;;;;;N;;;;;
1FB84;UPPER FIVE EIGHTHS BLOCK;So;0;ON;;;;;N;;;;;
1FB85;UPPER THREE QUARTERS BLOCK;So;0;ON;;;;;N;;;;;
1FB86;UPPER SEVEN EIGHTHS BLOCK;So;0;ON;;;;;N;;;;;
1FB87;RIGHT ONE QUARTER BLOCK;So;0;ON;;;;;N;;;;;
1FB88;RIGHT THREE EIGHTHS BLOCK;So;0;ON;;;;;N;;;;;
1FB89;RIGHT FIVE EIGHTHS BLOCK;So;0;ON;;;;;N;;;;;
1FB8A;RIGHT THREE QUARTERS BLOCK;So;0;ON;;;;;N;;;;;
1FB8B;RIGHT SEVEN EIGHTHS BLOCK;So;0;ON;;;;;N;;;;;
1FB8C;LEFT HALF MEDIUM SHADE;So;0;ON;;;;;N;;;;;
1FB8D;RIGHT HALF MEDIUM SHADE;So;0;ON;;;;;N;;;;;
1FB8E;UPPER HALF MEDIUM SHADE;So;0;ON;;;;;N;;;;;
1FB8F;LOWER HALF MEDIUM SHADE;So;0;ON;;;;;N;;;;;
1FB90;INVERSE MEDIUM SHADE;So;0;ON;;;;;N;;;;;
1FB91;UPPER HALF BLOCK AND LOWER HALF INVERSE MEDIUM SHADE;So;0;ON;;;;;N;;;;;
1FB92;UPPER HALF INVERSE MEDIUM SHADE AND LOWER HALF BLOCK;So;0;ON;;;;;N;;;;;
1FB94;LEFT HALF INVERSE MEDIUM SHADE AND RIGHT HALF BLOCK;So;0;ON;;;;;N;;;;;
1FB95;CHECKER BOARD FILL;So;0;ON;;;;;N;;;;;
1FB96;INVERSE CHECKER BOARD FILL;So;0;ON;;;;;N;;;;;
1FB97;HEAVY HORIZONTAL FILL;So;0;ON;;;;;N;;;;;
1FB98;UPPER LEFT TO LOWER RIGHT FILL;So;0;ON;;;;;N;;;;;
1FB99;UPPER RIGHT TO LOWER LEFT FILL;So;0;ON;;;;;N;;;;;
1FB9A;UPPER AND LOWER TRIANGULAR HALF BLOCK;So;0;ON;;;;;N;;;;;
1FB9B;LEFT AND RIGHT TRIANGULAR HALF BLOCK;So;0;ON;;;;;N;;;;;
1FB9C;UPPER LEFT TRIANGULAR MEDIUM SHADE;So;0;ON;;;;;N;;;;;
1FB9D;UPPER RIGHT TRIANGULAR MEDIUM SHADE;So;0;ON;;;;;N;;;;;
1FB9E;LOWER RIGHT TRIANGULAR MEDIUM SHADE;So;0;ON;;;;;N;;;;;
1FB9F;LOWER LEFT TRIANGULAR MEDIUM SHADE;So;0;ON;;;;;N;;;;;
1FBA0;BOX DRAWINGS LIGHT DIAGONAL UPPER CENTRE TO MIDDLE LEFT;So;0;ON;;;;;N;;;;;
1FBA1;BOX DRAWINGS LIGHT DIAGONAL UPPER CENTRE TO MIDDLE RIGHT;So;0;ON;;;;;N;;;;;
1FBA2;BOX DRAWINGS LIGHT DIAGONAL MIDDLE LEFT TO LOWER CENTRE;So;0;ON;;;;;N;;;;;
1FBA3;BOX DRAWINGS LIGHT DIAGONAL MIDDLE RIGHT TO LOWER CENTRE;So;0;ON;;;;;N;;;;;
1FBA4;BOX DRAWINGS LIGHT DIAGONAL UPPER CENTRE TO MIDDLE LEFT TO LOWER CENTRE;So;0;ON;;;;;N;;;;;
1FBA5;BOX DRAWINGS LIGHT DIAGONAL UPPER CENTRE TO MIDDLE RIGHT TO LOWER CENTRE;So;0;ON;;;;;N;;;;;
1FBA6;BOX DRAWINGS LIGHT DIAGONAL MIDDLE LEFT TO LOWER CENTRE TO MIDDLE RIGHT;So;0;ON;;;;;N;;;;;
1FBA7;BOX DRAWINGS LIGHT DIAGONAL MIDDLE LEFT TO UPPER CENTRE TO MIDDLE RIGHT;So;0;ON;;;;;N;;;;;
1FBA8;BOX DRAWINGS LIGHT DIAGONAL UPPER CENTRE TO MIDDLE LEFT AND MIDDLE RIGHT TO LOWER CENTRE;So;0;ON;;;;;N;;;;;
1FBA9;BOX DRAWINGS LIGHT DIAGONAL UPPER CENTRE TO MIDDLE RIGHT AND MIDDLE LEFT TO LOWER CENTRE;So;0;ON;;;;;N;;;;;
1FBAA;BOX DRAWINGS LIGHT DIAGONAL UPPER CENTRE TO MIDDLE RIGHT TO LOWER CENTRE TO MIDDLE LEFT;So;0;ON;;;;;N;;;;;
1FBAB;BOX DRAWINGS LIGHT DIAGONAL UPPER CENTRE TO MIDDLE LEFT TO LOWER CENTRE TO MIDDLE RIGHT;So;0;ON;;;;;N;;;;;
1FBAC;BOX DRAWINGS LIGHT DIAGONAL MIDDLE LEFT TO UPPER CENTRE TO MIDDLE RIGHT TO LOWER CENTRE;So;0;ON;;;;;N;;;;;
1FBAD;BOX DRAWINGS LIGHT DIAGONAL MIDDLE RIGHT TO UPPER CENTRE TO MIDDLE LEFT TO LOWER CENTRE;So;0;ON;;;;;N;;;;;
1FBAE;BOX DRAWINGS LIGHT DIAGONAL DIAMOND;So;0;ON;;;;;N;;;;;
1FBAF;BOX DRAWINGS LIGHT HORIZONTAL WITH VERTICAL STROKE;So;0;ON;;;;;N;;;;;
1FBB0;ARROWHEAD-SHAPED POINTER;So;0;ON;;;;;N;;;;;
1FBB1;INVERSE CHECK MARK;So;0;ON;;;;;N;;;;;
1FBB2;LEFT HALF RUNNING MAN;So;0;ON;;;;;N;;;;;
1FBB3;RIGHT HALF RUNNING MAN;So;0;ON;;;;;N;;;;;
1FBB4;INVERSE DOWNWARDS ARROW WITH TIP LEFTWARDS;So;0;ON;;;;;N;;;;;
1FBB5;LEFTWARDS ARROW AND UPPER AND LOWER ONE EIGHTH BLOCK;So;0;ON;;;;;N;;;;;
1FBB6;RIGHTWARDS ARROW AND UPPER AND LOWER ONE EIGHTH BLOCK;So;0;ON;;;;;N;;;;;
1FBB7;DOWNWARDS ARROW AND RIGHT ONE EIGHTH BLOCK;So;0;ON;;;;;N;;;;;
1FBB8;UPWARDS ARROW AND RIGHT ONE EIGHTH BLOCK;So;0;ON;;;;;N;;;;;
1FBB9;LEFT HALF FOLDER;So;0;ON;;;;;N;;;;;
1FBBA;RIGHT HALF FOLDER;So;0;ON;;;;;N;;;;;
1FBBB;VOIDED GREEK CROSS;So;0;ON;;;;;N;;;;;
1FBBC;RIGHT OPEN SQUARED DOT;So;0;ON;;;;;N;;;;;
1FBBD;NEGATIVE DIAGONAL CROSS;So;0;ON;;;;;N;;;;;
1FBBE;NEGATIVE DIAGONAL MIDDLE RIGHT TO LOWER CENTRE;So;0;ON;;;;;N;;;;;
1FBBF;NEGATIVE DIAGONAL DIAMOND;So;0;ON;;;;;N;;;;;
1FBC0;WHITE HEAVY SALTIRE WITH ROUNDED CORNERS;So;0;ON;;;;;N;;;;;
1FBC1;LEFT THIRD WHITE RIGHT POINTING INDEX;So;0;ON;;;;;N;;;;;
1FBC2;MIDDLE THIRD WHITE RIGHT POINTING INDEX;So;0;ON;;;;;N;;;;;
1FBC3;RIGHT THIRD WHITE RIGHT POINTING INDEX;So;0;ON;;;;;N;;;;;
1FBC4;NEGATIVE SQUARED QUESTION MARK;So;0;ON;;;;;N;;;;;
1FBC5;STICK FIGURE;So;0;ON;;;;;N;;;;;
1FBC6;STICK FIGURE WITH ARMS RAISED;So;0;ON;;;;;N;;;;;
1FBC7;STICK FIGURE LEANING LEFT;So;0;ON;;;;;N;;;;;
1FBC8;STICK FIGURE LEANING RIGHT;So;0;ON;;;;;N;;;;;
1FBC9;STICK FIGURE WITH DRESS;So;0;ON;;;;;N;;;;;
1FBCA;WHITE UP-POINTING CHEVRON;So;0;ON;;;;;N;;;;;
1FBF0;SEGMENTED DIGIT ZERO;Nd;0;EN;<font> 0030;0;0;0;N;;;;;
1FBF1;SEGMENTED DIGIT ONE;Nd;0;EN;<font> 0031;1;1;1;N;;;;;
1FBF2;SEGMENTED DIGIT TWO;Nd;0;EN;<font> 0032;2;2;2;N;;;;;
1FBF3;SEGMENTED DIGIT THREE;Nd;0;EN;<font> 0033;3;3;3;N;;;;;
1FBF4;SEGMENTED DIGIT FOUR;Nd;0;EN;<font> 0034;4;4;4;N;;;;;
1FBF5;SEGMENTED DIGIT FIVE;Nd;0;EN;<font> 0035;5;5;5;N;;;;;
1FBF6;SEGMENTED DIGIT SIX;Nd;0;EN;<font> 0036;6;6;6;N;;;;;
1FBF7;SEGMENTED DIGIT SEVEN;Nd;0;EN;<font> 0037;7;7;7;N;;;;;
1FBF8;SEGMENTED DIGIT EIGHT;Nd;0;EN;<font> 0038;8;8;8;N;;;;;
1FBF9;SEGMENTED DIGIT NINE;Nd;0;EN;<font> 0039;9;9;9;N;;;;;
20000;<CJK Ideograph Extension B, First>;Lo;0;L;;;;;N;;;;;
2A6DF;<CJK Ideograph Extension B, Last>;Lo;0;L;;;;;N;;;;;
2A700;<CJK Ideograph Extension C, First>;Lo;0;L;;;;;N;;;;;
2B738;<CJK Ideograph Extension C, Last>;Lo;0;L;;;;;N;;;;;
2B740;<CJK Ideograph Extension D, First>;Lo;0;L;;;;;N;;;;;
2B81D;<CJK Ideograph Extension D, Last>;Lo;0;L;;;;;N;;;;;
2B820;<CJK Ideograph Extension E, First>;Lo;0;L;;;;;N;;;;;
2CEA1;<CJK Ideograph Extension E, Last>;Lo;0;L;;;;;N;;;;;
2CEB0;<CJK Ideograph Extension F, First>;Lo;0;L;;;;;N;;;;;
2EBE0;<CJK Ideograph Extension F, Last>;Lo;0;L;;;;;N;;;;;
2F800;CJK COMPATIBILITY IDEOGRAPH-2F800;Lo;0;L;4E3D;;;;N;;;;;
2F801;CJK COMPATIBILITY IDEOGRAPH-2F801;Lo;0;L;4E38;;;;N;;;;;
2F802;CJK COMPATIBILITY IDEOGRAPH-2F802;Lo;0;L;4E41;;;;N;;;;;
2F803;CJK COMPATIBILITY IDEOGRAPH-2F803;Lo;0;L;20122;;;;N;;;;;
2F804;CJK COMPATIBILITY IDEOGRAPH-2F804;Lo;0;L;4F60;;;;N;;;;;
2F805;CJK COMPATIBILITY IDEOGRAPH-2F805;Lo;0;L;4FAE;;;;N;;;;;
2F806;CJK COMPATIBILITY IDEOGRAPH-2F806;Lo;0;L;4FBB;;;;N;;;;;
2F807;CJK COMPATIBILITY IDEOGRAPH-2F807;Lo;0;L;5002;;;;N;;;;;
2F808;CJK COMPATIBILITY IDEOGRAPH-2F808;Lo;0;L;507A;;;;N;;;;;
2F809;CJK COMPATIBILITY IDEOGRAPH-2F809;Lo;0;L;5099;;;;N;;;;;
2F80A;CJK COMPATIBILITY IDEOGRAPH-2F80A;Lo;0;L;50E7;;;;N;;;;;
2F80B;CJK COMPATIBILITY IDEOGRAPH-2F80B;Lo;0;L;50CF;;;;N;;;;;
2F80C;CJK COMPATIBILITY IDEOGRAPH-2F80C;Lo;0;L;349E;;;;N;;;;;
2F80D;CJK COMPATIBILITY IDEOGRAPH-2F80D;Lo;0;L;2063A;;;;N;;;;;
2F80E;CJK COMPATIBILITY IDEOGRAPH-2F80E;Lo;0;L;514D;;;;N;;;;;
2F80F;CJK COMPATIBILITY IDEOGRAPH-2F80F;Lo;0;L;5154;;;;N;;;;;
2F810;CJK COMPATIBILITY IDEOGRAPH-2F810;Lo;0;L;5164;;;;N;;;;;
2F811;CJK COMPATIBILITY IDEOGRAPH-2F811;Lo;0;L;5177;;;;N;;;;;
2F812;CJK COMPATIBILITY IDEOGRAPH-2F812;Lo;0;L;2051C;;;;N;;;;;
2F813;CJK COMPATIBILITY IDEOGRAPH-2F813;Lo;0;L;34B9;;;;N;;;;;
2F814;CJK COMPATIBILITY IDEOGRAPH-2F814;Lo;0;L;5167;;;;N;;;;;
2F815;CJK COMPATIBILITY IDEOGRAPH-2F815;Lo;0;L;518D;;;;N;;;;;
2F816;CJK COMPATIBILITY IDEOGRAPH-2F816;Lo;0;L;2054B;;;;N;;;;;
2F817;CJK COMPATIBILITY IDEOGRAPH-2F817;Lo;0;L;5197;;;;N;;;;;
2F818;CJK COMPATIBILITY IDEOGRAPH-2F818;Lo;0;L;51A4;;;;N;;;;;
2F819;CJK COMPATIBILITY IDEOGRAPH-2F819;Lo;0;L;4ECC;;;;N;;;;;
2F81A;CJK COMPATIBILITY IDEOGRAPH-2F81A;Lo;0;L;51AC;;;;N;;;;;
2F81B;CJK COMPATIBILITY IDEOGRAPH-2F81B;Lo;0;L;51B5;;;;N;;;;;
2F81C;CJK COMPATIBILITY IDEOGRAPH-2F81C;Lo;0;L;291DF;;;;N;;;;;
2F81D;CJK COMPATIBILITY IDEOGRAPH-2F81D;Lo;0;L;51F5;;;;N;;;;;
2F81E;CJK COMPATIBILITY IDEOGRAPH-2F81E;Lo;0;L;5203;;;;N;;;;;
2F81F;CJK COMPATIBILITY IDEOGRAPH-2F81F;Lo;0;L;34DF;;;;N;;;;;
2F820;CJK COMPATIBILITY IDEOGRAPH-2F820;Lo;0;L;523B;;;;N;;;;;
2F821;CJK COMPATIBILITY IDEOGRAPH-2F821;Lo;0;L;5246;;;;N;;;;;
2F822;CJK COMPATIBILITY IDEOGRAPH-2F822;Lo;0;L;5272;;;;N;;;;;
2F823;CJK COMPATIBILITY IDEOGRAPH-2F823;Lo;0;L;5277;;;;N;;;;;
2F824;CJK COMPATIBILITY IDEOGRAPH-2F824;Lo;0;L;3515;;;;N;;;;;
2F825;CJK COMPATIBILITY IDEOGRAPH-2F825;Lo;0;L;52C7;;;;N;;;;;
2F826;CJK COMPATIBILITY IDEOGRAPH-2F826;Lo;0;L;52C9;;;;N;;;;;
2F827;CJK COMPATIBILITY IDEOGRAPH-2F827;Lo;0;L;52E4;;;;N;;;;;
2F828;CJK COMPATIBILITY IDEOGRAPH-2F828;Lo;0;L;52FA;;;;N;;;;;
2F829;CJK COMPATIBILITY IDEOGRAPH-2F829;Lo;0;L;5305;;;;N;;;;;
2F82A;CJK COMPATIBILITY IDEOGRAPH-2F82A;Lo;0;L;5306;;;;N;;;;;
2F82B;CJK COMPATIBILITY IDEOGRAPH-2F82B;Lo;0;L;5317;;;;N;;;;;
2F82C;CJK COMPATIBILITY IDEOGRAPH-2F82C;Lo;0;L;5349;;;;N;;;;;
2F82D;CJK COMPATIBILITY IDEOGRAPH-2F82D;Lo;0;L;5351;;;;N;;;;;
2F82E;CJK COMPATIBILITY IDEOGRAPH-2F82E;Lo;0;L;535A;;;;N;;;;;
2F82F;CJK COMPATIBILITY IDEOGRAPH-2F82F;Lo;0;L;5373;;;;N;;;;;
2F830;CJK COMPATIBILITY IDEOGRAPH-2F830;Lo;0;L;537D;;;;N;;;;;
2F831;CJK COMPATIBILITY IDEOGRAPH-2F831;Lo;0;L;537F;;;;N;;;;;
2F832;CJK COMPATIBILITY IDEOGRAPH-2F832;Lo;0;L;537F;;;;N;;;;;
2F833;CJK COMPATIBILITY IDEOGRAPH-2F833;Lo;0;L;537F;;;;N;;;;;
2F834;CJK COMPATIBILITY IDEOGRAPH-2F834;Lo;0;L;20A2C;;;;N;;;;;
2F835;CJK COMPATIBILITY IDEOGRAPH-2F835;Lo;0;L;7070;;;;N;;;;;
2F836;CJK COMPATIBILITY IDEOGRAPH-2F836;Lo;0;L;53CA;;;;N;;;;;
2F837;CJK COMPATIBILITY IDEOGRAPH-2F837;Lo;0;L;53DF;;;;N;;;;;
2F838;CJK COMPATIBILITY IDEOGRAPH-2F838;Lo;0;L;20B63;;;;N;;;;;
2F839;CJK COMPATIBILITY IDEOGRAPH-2F839;Lo;0;L;53EB;;;;N;;;;;
2F83A;CJK COMPATIBILITY IDEOGRAPH-2F83A;Lo;0;L;53F1;;;;N;;;;;
2F83B;CJK COMPATIBILITY IDEOGRAPH-2F83B;Lo;0;L;5406;;;;N;;;;;
2F83C;CJK COMPATIBILITY IDEOGRAPH-2F83C;Lo;0;L;549E;;;;N;;;;;
2F83D;CJK COMPATIBILITY IDEOGRAPH-2F83D;Lo;0;L;5438;;;;N;;;;;
2F83E;CJK COMPATIBILITY IDEOGRAPH-2F83E;Lo;0;L;5448;;;;N;;;;;
2F83F;CJK COMPATIBILITY IDEOGRAPH-2F83F;Lo;0;L;5468;;;;N;;;;;
2F840;CJK COMPATIBILITY IDEOGRAPH-2F840;Lo;0;L;54A2;;;;N;;;;;
2F841;CJK COMPATIBILITY IDEOGRAPH-2F841;Lo;0;L;54F6;;;;N;;;;;
2F842;CJK COMPATIBILITY IDEOGRAPH-2F842;Lo;0;L;5510;;;;N;;;;;
2F843;CJK COMPATIBILITY IDEOGRAPH-2F843;Lo;0;L;5553;;;;N;;;;;
2F844;CJK COMPATIBILITY IDEOGRAPH-2F844;Lo;0;L;5563;;;;N;;;;;
2F845;CJK COMPATIBILITY IDEOGRAPH-2F845;Lo;0;L;5584;;;;N;;;;;
2F846;CJK COMPATIBILITY IDEOGRAPH-2F846;Lo;0;L;5584;;;;N;;;;;
2F847;CJK COMPATIBILITY IDEOGRAPH-2F847;Lo;0;L;5599;;;;N;;;;;
2F848;CJK COMPATIBILITY IDEOGRAPH-2F848;Lo;0;L;55AB;;;;N;;;;;
2F849;CJK COMPATIBILITY IDEOGRAPH-2F849;Lo;0;L;55B3;;;;N;;;;;
2F84A;CJK COMPATIBILITY IDEOGRAPH-2F84A;Lo;0;L;55C2;;;;N;;;;;
2F84B;CJK COMPATIBILITY IDEOGRAPH-2F84B;Lo;0;L;5716;;;;N;;;;;
2F84C;CJK COMPATIBILITY IDEOGRAPH-2F84C;Lo;0;L;5606;;;;N;;;;;
2F84D;CJK COMPATIBILITY IDEOGRAPH-2F84D;Lo;0;L;5717;;;;N;;;;;
2F84E;CJK COMPATIBILITY IDEOGRAPH-2F84E;Lo;0;L;5651;;;;N;;;;;
2F84F;CJK COMPATIBILITY IDEOGRAPH-2F84F;Lo;0;L;5674;;;;N;;;;;
2F850;CJK COMPATIBILITY IDEOGRAPH-2F850;Lo;0;L;5207;;;;N;;;;;
2F851;CJK COMPATIBILITY IDEOGRAPH-2F851;Lo;0;L;58EE;;;;N;;;;;
2F852;CJK COMPATIBILITY IDEOGRAPH-2F852;Lo;0;L;57CE;;;;N;;;;;
2F853;CJK COMPATIBILITY IDEOGRAPH-2F853;Lo;0;L;57F4;;;;N;;;;;
2F854;CJK COMPATIBILITY IDEOGRAPH-2F854;Lo;0;L;580D;;;;N;;;;;
2F855;CJK COMPATIBILITY IDEOGRAPH-2F855;Lo;0;L;578B;;;;N;;;;;
2F856;CJK COMPATIBILITY IDEOGRAPH-2F856;Lo;0;L;5832;;;;N;;;;;
2F857;CJK COMPATIBILITY IDEOGRAPH-2F857;Lo;0;L;5831;;;;N;;;;;
2F858;CJK COMPATIBILITY IDEOGRAPH-2F858;Lo;0;L;58AC;;;;N;;;;;
2F859;CJK COMPATIBILITY IDEOGRAPH-2F859;Lo;0;L;214E4;;;;N;;;;;
2F85A;CJK COMPATIBILITY IDEOGRAPH-2F85A;Lo;0;L;58F2;;;;N;;;;;
2F85B;CJK COMPATIBILITY IDEOGRAPH-2F85B;Lo;0;L;58F7;;;;N;;;;;
2F85C;CJK COMPATIBILITY IDEOGRAPH-2F85C;Lo;0;L;5906;;;;N;;;;;
2F85D;CJK COMPATIBILITY IDEOGRAPH-2F85D;Lo;0;L;591A;;;;N;;;;;
2F85E;CJK COMPATIBILITY IDEOGRAPH-2F85E;Lo;0;L;5922;;;;N;;;;;
2F85F;CJK COMPATIBILITY IDEOGRAPH-2F85F;Lo;0;L;5962;;;;N;;;;;
2F860;CJK COMPATIBILITY IDEOGRAPH-2F860;Lo;0;L;216A8;;;;N;;;;;
2F861;CJK COMPATIBILITY IDEOGRAPH-2F861;Lo;0;L;216EA;;;;N;;;;;
2F862;CJK COMPATIBILITY IDEOGRAPH-2F862;Lo;0;L;59EC;;;;N;;;;;
2F863;CJK COMPATIBILITY IDEOGRAPH-2F863;Lo;0;L;5A1B;;;;N;;;;;
2F864;CJK COMPATIBILITY IDEOGRAPH-2F864;Lo;0;L;5A27;;;;N;;;;;
2F865;CJK COMPATIBILITY IDEOGRAPH-2F865;Lo;0;L;59D8;;;;N;;;;;
2F866;CJK COMPATIBILITY IDEOGRAPH-2F866;Lo;0;L;5A66;;;;N;;;;;
2F867;CJK COMPATIBILITY IDEOGRAPH-2F867;Lo;0;L;36EE;;;;N;;;;;
2F868;CJK COMPATIBILITY IDEOGRAPH-2F868;Lo;0;L;36FC;;;;N;;;;;
2F869;CJK COMPATIBILITY IDEOGRAPH-2F869;Lo;0;L;5B08;;;;N;;;;;
2F86A;CJK COMPATIBILITY IDEOGRAPH-2F86A;Lo;0;L;5B3E;;;;N;;;;;
2F86B;CJK COMPATIBILITY IDEOGRAPH-2F86B;Lo;0;L;5B3E;;;;N;;;;;
2F86C;CJK COMPATIBILITY IDEOGRAPH-2F86C;Lo;0;L;219C8;;;;N;;;;;
2F86D;CJK COMPATIBILITY IDEOGRAPH-2F86D;Lo;0;L;5BC3;;;;N;;;;;
2F86E;CJK COMPATIBILITY IDEOGRAPH-2F86E;Lo;0;L;5BD8;;;;N;;;;;
2F86F;CJK COMPATIBILITY IDEOGRAPH-2F86F;Lo;0;L;5BE7;;;;N;;;;;
2F870;CJK COMPATIBILITY IDEOGRAPH-2F870;Lo;0;L;5BF3;;;;N;;;;;
2F871;CJK COMPATIBILITY IDEOGRAPH-2F871;Lo;0;L;21B18;;;;N;;;;;
2F872;CJK COMPATIBILITY IDEOGRAPH-2F872;Lo;0;L;5BFF;;;;N;;;;;
2F873;CJK COMPATIBILITY IDEOGRAPH-2F873;Lo;0;L;5C06;;;;N;;;;;
2F874;CJK COMPATIBILITY IDEOGRAPH-2F874;Lo;0;L;5F53;;;;N;;;;;
2F875;CJK COMPATIBILITY IDEOGRAPH-2F875;Lo;0;L;5C22;;;;N;;;;;
2F876;CJK COMPATIBILITY IDEOGRAPH-2F876;Lo;0;L;3781;;;;N;;;;;
2F877;CJK COMPATIBILITY IDEOGRAPH-2F877;Lo;0;L;5C60;;;;N;;;;;
2F878;CJK COMPATIBILITY IDEOGRAPH-2F878;Lo;0;L;5C6E;;;;N;;;;;
2F879;CJK COMPATIBILITY IDEOGRAPH-2F879;Lo;0;L;5CC0;;;;N;;;;;
2F87A;CJK COMPATIBILITY IDEOGRAPH-2F87A;Lo;0;L;5C8D;;;;N;;;;;
2F87B;CJK COMPATIBILITY IDEOGRAPH-2F87B;Lo;0;L;21DE4;;;;N;;;;;
2F87C;CJK COMPATIBILITY IDEOGRAPH-2F87C;Lo;0;L;5D43;;;;N;;;;;
2F87D;CJK COMPATIBILITY IDEOGRAPH-2F87D;Lo;0;L;21DE6;;;;N;;;;;
2F87E;CJK COMPATIBILITY IDEOGRAPH-2F87E;Lo;0;L;5D6E;;;;N;;;;;
2F87F;CJK COMPATIBILITY IDEOGRAPH-2F87F;Lo;0;L;5D6B;;;;N;;;;;
2F880;CJK COMPATIBILITY IDEOGRAPH-2F880;Lo;0;L;5D7C;;;;N;;;;;
2F881;CJK COMPATIBILITY IDEOGRAPH-2F881;Lo;0;L;5DE1;;;;N;;;;;
2F882;CJK COMPATIBILITY IDEOGRAPH-2F882;Lo;0;L;5DE2;;;;N;;;;;
2F883;CJK COMPATIBILITY IDEOGRAPH-2F883;Lo;0;L;382F;;;;N;;;;;
2F884;CJK COMPATIBILITY IDEOGRAPH-2F884;Lo;0;L;5DFD;;;;N;;;;;
2F885;CJK COMPATIBILITY IDEOGRAPH-2F885;Lo;0;L;5E28;;;;N;;;;;
2F886;CJK COMPATIBILITY IDEOGRAPH-2F886;Lo;0;L;5E3D;;;;N;;;;;
2F887;CJK COMPATIBILITY IDEOGRAPH-2F887;Lo;0;L;5E69;;;;N;;;;;
2F888;CJK COMPATIBILITY IDEOGRAPH-2F888;Lo;0;L;3862;;;;N;;;;;
2F889;CJK COMPATIBILITY IDEOGRAPH-2F889;Lo;0;L;22183;;;;N;;;;;
2F88A;CJK COMPATIBILITY IDEOGRAPH-2F88A;Lo;0;L;387C;;;;N;;;;;
2F88B;CJK COMPATIBILITY IDEOGRAPH-2F88B;Lo;0;L;5EB0;;;;N;;;;;
2F88C;CJK COMPATIBILITY IDEOGRAPH-2F88C;Lo;0;L;5EB3;;;;N;;;;;
2F88D;CJK COMPATIBILITY IDEOGRAPH-2F88D;Lo;0;L;5EB6;;;;N;;;;;
2F88E;CJK COMPATIBILITY IDEOGRAPH-2F88E;Lo;0;L;5ECA;;;;N;;;;;
2F88F;CJK COMPATIBILITY IDEOGRAPH-2F88F;Lo;0;L;2A392;;;;N;;;;;
2F890;CJK COMPATIBILITY IDEOGRAPH-2F890;Lo;0;L;5EFE;;;9;N;;;;;
2F891;CJK COMPATIBILITY IDEOGRAPH-2F891;Lo;0;L;22331;;;;N;;;;;
2F892;CJK COMPATIBILITY IDEOGRAPH-2F892;Lo;0;L;22331;;;;N;;;;;
2F893;CJK COMPATIBILITY IDEOGRAPH-2F893;Lo;0;L;8201;;;;N;;;;;
2F894;CJK COMPATIBILITY IDEOGRAPH-2F894;Lo;0;L;5F22;;;;N;;;;;
2F895;CJK COMPATIBILITY IDEOGRAPH-2F895;Lo;0;L;5F22;;;;N;;;;;
2F896;CJK COMPATIBILITY IDEOGRAPH-2F896;Lo;0;L;38C7;;;;N;;;;;
2F897;CJK COMPATIBILITY IDEOGRAPH-2F897;Lo;0;L;232B8;;;;N;;;;;
2F898;CJK COMPATIBILITY IDEOGRAPH-2F898;Lo;0;L;261DA;;;;N;;;;;
2F899;CJK COMPATIBILITY IDEOGRAPH-2F899;Lo;0;L;5F62;;;;N;;;;;
2F89A;CJK COMPATIBILITY IDEOGRAPH-2F89A;Lo;0;L;5F6B;;;;N;;;;;
2F89B;CJK COMPATIBILITY IDEOGRAPH-2F89B;Lo;0;L;38E3;;;;N;;;;;
2F89C;CJK COMPATIBILITY IDEOGRAPH-2F89C;Lo;0;L;5F9A;;;;N;;;;;
2F89D;CJK COMPATIBILITY IDEOGRAPH-2F89D;Lo;0;L;5FCD;;;;N;;;;;
2F89E;CJK COMPATIBILITY IDEOGRAPH-2F89E;Lo;0;L;5FD7;;;;N;;;;;
2F89F;CJK COMPATIBILITY IDEOGRAPH-2F89F;Lo;0;L;5FF9;;;;N;;;;;
2F8A0;CJK COMPATIBILITY IDEOGRAPH-2F8A0;Lo;0;L;6081;;;;N;;;;;
2F8A1;CJK COMPATIBILITY IDEOGRAPH-2F8A1;Lo;0;L;393A;;;;N;;;;;
2F8A2;CJK COMPATIBILITY IDEOGRAPH-2F8A2;Lo;0;L;391C;;;;N;;;;;
2F8A3;CJK COMPATIBILITY IDEOGRAPH-2F8A3;Lo;0;L;6094;;;;N;;;;;
2F8A4;CJK COMPATIBILITY IDEOGRAPH-2F8A4;Lo;0;L;226D4;;;;N;;;;;
2F8A5;CJK COMPATIBILITY IDEOGRAPH-2F8A5;Lo;0;L;60C7;;;;N;;;;;
2F8A6;CJK COMPATIBILITY IDEOGRAPH-2F8A6;Lo;0;L;6148;;;;N;;;;;
2F8A7;CJK COMPATIBILITY IDEOGRAPH-2F8A7;Lo;0;L;614C;;;;N;;;;;
2F8A8;CJK COMPATIBILITY IDEOGRAPH-2F8A8;Lo;0;L;614E;;;;N;;;;;
2F8A9;CJK COMPATIBILITY IDEOGRAPH-2F8A9;Lo;0;L;614C;;;;N;;;;;
2F8AA;CJK COMPATIBILITY IDEOGRAPH-2F8AA;Lo;0;L;617A;;;;N;;;;;
2F8AB;CJK COMPATIBILITY IDEOGRAPH-2F8AB;Lo;0;L;618E;;;;N;;;;;
2F8AC;CJK COMPATIBILITY IDEOGRAPH-2F8AC;Lo;0;L;61B2;;;;N;;;;;
2F8AD;CJK COMPATIBILITY IDEOGRAPH-2F8AD;Lo;0;L;61A4;;;;N;;;;;
2F8AE;CJK COMPATIBILITY IDEOGRAPH-2F8AE;Lo;0;L;61AF;;;;N;;;;;
2F8AF;CJK COMPATIBILITY IDEOGRAPH-2F8AF;Lo;0;L;61DE;;;;N;;;;;
2F8B0;CJK COMPATIBILITY IDEOGRAPH-2F8B0;Lo;0;L;61F2;;;;N;;;;;
2F8B1;CJK COMPATIBILITY IDEOGRAPH-2F8B1;Lo;0;L;61F6;;;;N;;;;;
2F8B2;CJK COMPATIBILITY IDEOGRAPH-2F8B2;Lo;0;L;6210;;;;N;;;;;
2F8B3;CJK COMPATIBILITY IDEOGRAPH-2F8B3;Lo;0;L;621B;;;;N;;;;;
2F8B4;CJK COMPATIBILITY IDEOGRAPH-2F8B4;Lo;0;L;625D;;;;N;;;;;
2F8B5;CJK COMPATIBILITY IDEOGRAPH-2F8B5;Lo;0;L;62B1;;;;N;;;;;
2F8B6;CJK COMPATIBILITY IDEOGRAPH-2F8B6;Lo;0;L;62D4;;;;N;;;;;
2F8B7;CJK COMPATIBILITY IDEOGRAPH-2F8B7;Lo;0;L;6350;;;;N;;;;;
2F8B8;CJK COMPATIBILITY IDEOGRAPH-2F8B8;Lo;0;L;22B0C;;;;N;;;;;
2F8B9;CJK COMPATIBILITY IDEOGRAPH-2F8B9;Lo;0;L;633D;;;;N;;;;;
2F8BA;CJK COMPATIBILITY IDEOGRAPH-2F8BA;Lo;0;L;62FC;;;;N;;;;;
2F8BB;CJK COMPATIBILITY IDEOGRAPH-2F8BB;Lo;0;L;6368;;;;N;;;;;
2F8BC;CJK COMPATIBILITY IDEOGRAPH-2F8BC;Lo;0;L;6383;;;;N;;;;;
2F8BD;CJK COMPATIBILITY IDEOGRAPH-2F8BD;Lo;0;L;63E4;;;;N;;;;;
2F8BE;CJK COMPATIBILITY IDEOGRAPH-2F8BE;Lo;0;L;22BF1;;;;N;;;;;
2F8BF;CJK COMPATIBILITY IDEOGRAPH-2F8BF;Lo;0;L;6422;;;;N;;;;;
2F8C0;CJK COMPATIBILITY IDEOGRAPH-2F8C0;Lo;0;L;63C5;;;;N;;;;;
2F8C1;CJK COMPATIBILITY IDEOGRAPH-2F8C1;Lo;0;L;63A9;;;;N;;;;;
2F8C2;CJK COMPATIBILITY IDEOGRAPH-2F8C2;Lo;0;L;3A2E;;;;N;;;;;
2F8C3;CJK COMPATIBILITY IDEOGRAPH-2F8C3;Lo;0;L;6469;;;;N;;;;;
2F8C4;CJK COMPATIBILITY IDEOGRAPH-2F8C4;Lo;0;L;647E;;;;N;;;;;
2F8C5;CJK COMPATIBILITY IDEOGRAPH-2F8C5;Lo;0;L;649D;;;;N;;;;;
2F8C6;CJK COMPATIBILITY IDEOGRAPH-2F8C6;Lo;0;L;6477;;;;N;;;;;
2F8C7;CJK COMPATIBILITY IDEOGRAPH-2F8C7;Lo;0;L;3A6C;;;;N;;;;;
2F8C8;CJK COMPATIBILITY IDEOGRAPH-2F8C8;Lo;0;L;654F;;;;N;;;;;
2F8C9;CJK COMPATIBILITY IDEOGRAPH-2F8C9;Lo;0;L;656C;;;;N;;;;;
2F8CA;CJK COMPATIBILITY IDEOGRAPH-2F8CA;Lo;0;L;2300A;;;;N;;;;;
2F8CB;CJK COMPATIBILITY IDEOGRAPH-2F8CB;Lo;0;L;65E3;;;;N;;;;;
2F8CC;CJK COMPATIBILITY IDEOGRAPH-2F8CC;Lo;0;L;66F8;;;;N;;;;;
2F8CD;CJK COMPATIBILITY IDEOGRAPH-2F8CD;Lo;0;L;6649;;;;N;;;;;
2F8CE;CJK COMPATIBILITY IDEOGRAPH-2F8CE;Lo;0;L;3B19;;;;N;;;;;
2F8CF;CJK COMPATIBILITY IDEOGRAPH-2F8CF;Lo;0;L;6691;;;;N;;;;;
2F8D0;CJK COMPATIBILITY IDEOGRAPH-2F8D0;Lo;0;L;3B08;;;;N;;;;;
2F8D1;CJK COMPATIBILITY IDEOGRAPH-2F8D1;Lo;0;L;3AE4;;;;N;;;;;
2F8D2;CJK COMPATIBILITY IDEOGRAPH-2F8D2;Lo;0;L;5192;;;;N;;;;;
2F8D3;CJK COMPATIBILITY IDEOGRAPH-2F8D3;Lo;0;L;5195;;;;N;;;;;
2F8D4;CJK COMPATIBILITY IDEOGRAPH-2F8D4;Lo;0;L;6700;;;;N;;;;;
2F8D5;CJK COMPATIBILITY IDEOGRAPH-2F8D5;Lo;0;L;669C;;;;N;;;;;
2F8D6;CJK COMPATIBILITY IDEOGRAPH-2F8D6;Lo;0;L;80AD;;;;N;;;;;
2F8D7;CJK COMPATIBILITY IDEOGRAPH-2F8D7;Lo;0;L;43D9;;;;N;;;;;
2F8D8;CJK COMPATIBILITY IDEOGRAPH-2F8D8;Lo;0;L;6717;;;;N;;;;;
2F8D9;CJK COMPATIBILITY IDEOGRAPH-2F8D9;Lo;0;L;671B;;;;N;;;;;
2F8DA;CJK COMPATIBILITY IDEOGRAPH-2F8DA;Lo;0;L;6721;;;;N;;;;;
2F8DB;CJK COMPATIBILITY IDEOGRAPH-2F8DB;Lo;0;L;675E;;;;N;;;;;
2F8DC;CJK COMPATIBILITY IDEOGRAPH-2F8DC;Lo;0;L;6753;;;;N;;;;;
2F8DD;CJK COMPATIBILITY IDEOGRAPH-2F8DD;Lo;0;L;233C3;;;;N;;;;;
2F8DE;CJK COMPATIBILITY IDEOGRAPH-2F8DE;Lo;0;L;3B49;;;;N;;;;;
2F8DF;CJK COMPATIBILITY IDEOGRAPH-2F8DF;Lo;0;L;67FA;;;;N;;;;;
2F8E0;CJK COMPATIBILITY IDEOGRAPH-2F8E0;Lo;0;L;6785;;;;N;;;;;
2F8E1;CJK COMPATIBILITY IDEOGRAPH-2F8E1;Lo;0;L;6852;;;;N;;;;;
2F8E2;CJK COMPATIBILITY IDEOGRAPH-2F8E2;Lo;0;L;6885;;;;N;;;;;
2F8E3;CJK COMPATIBILITY IDEOGRAPH-2F8E3;Lo;0;L;2346D;;;;N;;;;;
2F8E4;CJK COMPATIBILITY IDEOGRAPH-2F8E4;Lo;0;L;688E;;;;N;;;;;
2F8E5;CJK COMPATIBILITY IDEOGRAPH-2F8E5;Lo;0;L;681F;;;;N;;;;;
2F8E6;CJK COMPATIBILITY IDEOGRAPH-2F8E6;Lo;0;L;6914;;;;N;;;;;
2F8E7;CJK COMPATIBILITY IDEOGRAPH-2F8E7;Lo;0;L;3B9D;;;;N;;;;;
2F8E8;CJK COMPATIBILITY IDEOGRAPH-2F8E8;Lo;0;L;6942;;;;N;;;;;
2F8E9;CJK COMPATIBILITY IDEOGRAPH-2F8E9;Lo;0;L;69A3;;;;N;;;;;
2F8EA;CJK COMPATIBILITY IDEOGRAPH-2F8EA;Lo;0;L;69EA;;;;N;;;;;
2F8EB;CJK COMPATIBILITY IDEOGRAPH-2F8EB;Lo;0;L;6AA8;;;;N;;;;;
2F8EC;CJK COMPATIBILITY IDEOGRAPH-2F8EC;Lo;0;L;236A3;;;;N;;;;;
2F8ED;CJK COMPATIBILITY IDEOGRAPH-2F8ED;Lo;0;L;6ADB;;;;N;;;;;
2F8EE;CJK COMPATIBILITY IDEOGRAPH-2F8EE;Lo;0;L;3C18;;;;N;;;;;
2F8EF;CJK COMPATIBILITY IDEOGRAPH-2F8EF;Lo;0;L;6B21;;;;N;;;;;
2F8F0;CJK COMPATIBILITY IDEOGRAPH-2F8F0;Lo;0;L;238A7;;;;N;;;;;
2F8F1;CJK COMPATIBILITY IDEOGRAPH-2F8F1;Lo;0;L;6B54;;;;N;;;;;
2F8F2;CJK COMPATIBILITY IDEOGRAPH-2F8F2;Lo;0;L;3C4E;;;;N;;;;;
2F8F3;CJK COMPATIBILITY IDEOGRAPH-2F8F3;Lo;0;L;6B72;;;;N;;;;;
2F8F4;CJK COMPATIBILITY IDEOGRAPH-2F8F4;Lo;0;L;6B9F;;;;N;;;;;
2F8F5;CJK COMPATIBILITY IDEOGRAPH-2F8F5;Lo;0;L;6BBA;;;;N;;;;;
2F8F6;CJK COMPATIBILITY IDEOGRAPH-2F8F6;Lo;0;L;6BBB;;;;N;;;;;
2F8F7;CJK COMPATIBILITY IDEOGRAPH-2F8F7;Lo;0;L;23A8D;;;;N;;;;;
2F8F8;CJK COMPATIBILITY IDEOGRAPH-2F8F8;Lo;0;L;21D0B;;;;N;;;;;
2F8F9;CJK COMPATIBILITY IDEOGRAPH-2F8F9;Lo;0;L;23AFA;;;;N;;;;;
2F8FA;CJK COMPATIBILITY IDEOGRAPH-2F8FA;Lo;0;L;6C4E;;;;N;;;;;
2F8FB;CJK COMPATIBILITY IDEOGRAPH-2F8FB;Lo;0;L;23CBC;;;;N;;;;;
2F8FC;CJK COMPATIBILITY IDEOGRAPH-2F8FC;Lo;0;L;6CBF;;;;N;;;;;
2F8FD;CJK COMPATIBILITY IDEOGRAPH-2F8FD;Lo;0;L;6CCD;;;;N;;;;;
2F8FE;CJK COMPATIBILITY IDEOGRAPH-2F8FE;Lo;0;L;6C67;;;;N;;;;;
2F8FF;CJK COMPATIBILITY IDEOGRAPH-2F8FF;Lo;0;L;6D16;;;;N;;;;;
2F900;CJK COMPATIBILITY IDEOGRAPH-2F900;Lo;0;L;6D3E;;;;N;;;;;
2F901;CJK COMPATIBILITY IDEOGRAPH-2F901;Lo;0;L;6D77;;;;N;;;;;
2F902;CJK COMPATIBILITY IDEOGRAPH-2F902;Lo;0;L;6D41;;;;N;;;;;
2F903;CJK COMPATIBILITY IDEOGRAPH-2F903;Lo;0;L;6D69;;;;N;;;;;
2F904;CJK COMPATIBILITY IDEOGRAPH-2F904;Lo;0;L;6D78;;;;N;;;;;
2F905;CJK COMPATIBILITY IDEOGRAPH-2F905;Lo;0;L;6D85;;;;N;;;;;
2F906;CJK COMPATIBILITY IDEOGRAPH-2F906;Lo;0;L;23D1E;;;;N;;;;;
2F907;CJK COMPATIBILITY IDEOGRAPH-2F907;Lo;0;L;6D34;;;;N;;;;;
2F908;CJK COMPATIBILITY IDEOGRAPH-2F908;Lo;0;L;6E2F;;;;N;;;;;
2F909;CJK COMPATIBILITY IDEOGRAPH-2F909;Lo;0;L;6E6E;;;;N;;;;;
2F90A;CJK COMPATIBILITY IDEOGRAPH-2F90A;Lo;0;L;3D33;;;;N;;;;;
2F90B;CJK COMPATIBILITY IDEOGRAPH-2F90B;Lo;0;L;6ECB;;;;N;;;;;
2F90C;CJK COMPATIBILITY IDEOGRAPH-2F90C;Lo;0;L;6EC7;;;;N;;;;;
2F90D;CJK COMPATIBILITY IDEOGRAPH-2F90D;Lo;0;L;23ED1;;;;N;;;;;
2F90E;CJK COMPATIBILITY IDEOGRAPH-2F90E;Lo;0;L;6DF9;;;;N;;;;;
2F90F;CJK COMPATIBILITY IDEOGRAPH-2F90F;Lo;0;L;6F6E;;;;N;;;;;
2F910;CJK COMPATIBILITY IDEOGRAPH-2F910;Lo;0;L;23F5E;;;;N;;;;;
2F911;CJK COMPATIBILITY IDEOGRAPH-2F911;Lo;0;L;23F8E;;;;N;;;;;
2F912;CJK COMPATIBILITY IDEOGRAPH-2F912;Lo;0;L;6FC6;;;;N;;;;;
2F913;CJK COMPATIBILITY IDEOGRAPH-2F913;Lo;0;L;7039;;;;N;;;;;
2F914;CJK COMPATIBILITY IDEOGRAPH-2F914;Lo;0;L;701E;;;;N;;;;;
2F915;CJK COMPATIBILITY IDEOGRAPH-2F915;Lo;0;L;701B;;;;N;;;;;
2F916;CJK COMPATIBILITY IDEOGRAPH-2F916;Lo;0;L;3D96;;;;N;;;;;
2F917;CJK COMPATIBILITY IDEOGRAPH-2F917;Lo;0;L;704A;;;;N;;;;;
2F918;CJK COMPATIBILITY IDEOGRAPH-2F918;Lo;0;L;707D;;;;N;;;;;
2F919;CJK COMPATIBILITY IDEOGRAPH-2F919;Lo;0;L;7077;;;;N;;;;;
2F91A;CJK COMPATIBILITY IDEOGRAPH-2F91A;Lo;0;L;70AD;;;;N;;;;;
2F91B;CJK COMPATIBILITY IDEOGRAPH-2F91B;Lo;0;L;20525;;;;N;;;;;
2F91C;CJK COMPATIBILITY IDEOGRAPH-2F91C;Lo;0;L;7145;;;;N;;;;;
2F91D;CJK COMPATIBILITY IDEOGRAPH-2F91D;Lo;0;L;24263;;;;N;;;;;
2F91E;CJK COMPATIBILITY IDEOGRAPH-2F91E;Lo;0;L;719C;;;;N;;;;;
2F91F;CJK COMPATIBILITY IDEOGRAPH-2F91F;Lo;0;L;243AB;;;;N;;;;;
2F920;CJK COMPATIBILITY IDEOGRAPH-2F920;Lo;0;L;7228;;;;N;;;;;
2F921;CJK COMPATIBILITY IDEOGRAPH-2F921;Lo;0;L;7235;;;;N;;;;;
2F922;CJK COMPATIBILITY IDEOGRAPH-2F922;Lo;0;L;7250;;;;N;;;;;
2F923;CJK COMPATIBILITY IDEOGRAPH-2F923;Lo;0;L;24608;;;;N;;;;;
2F924;CJK COMPATIBILITY IDEOGRAPH-2F924;Lo;0;L;7280;;;;N;;;;;
2F925;CJK COMPATIBILITY IDEOGRAPH-2F925;Lo;0;L;7295;;;;N;;;;;
2F926;CJK COMPATIBILITY IDEOGRAPH-2F926;Lo;0;L;24735;;;;N;;;;;
2F927;CJK COMPATIBILITY IDEOGRAPH-2F927;Lo;0;L;24814;;;;N;;;;;
2F928;CJK COMPATIBILITY IDEOGRAPH-2F928;Lo;0;L;737A;;;;N;;;;;
2F929;CJK COMPATIBILITY IDEOGRAPH-2F929;Lo;0;L;738B;;;;N;;;;;
2F92A;CJK COMPATIBILITY IDEOGRAPH-2F92A;Lo;0;L;3EAC;;;;N;;;;;
2F92B;CJK COMPATIBILITY IDEOGRAPH-2F92B;Lo;0;L;73A5;;;;N;;;;;
2F92C;CJK COMPATIBILITY IDEOGRAPH-2F92C;Lo;0;L;3EB8;;;;N;;;;;
2F92D;CJK COMPATIBILITY IDEOGRAPH-2F92D;Lo;0;L;3EB8;;;;N;;;;;
2F92E;CJK COMPATIBILITY IDEOGRAPH-2F92E;Lo;0;L;7447;;;;N;;;;;
2F92F;CJK COMPATIBILITY IDEOGRAPH-2F92F;Lo;0;L;745C;;;;N;;;;;
2F930;CJK COMPATIBILITY IDEOGRAPH-2F930;Lo;0;L;7471;;;;N;;;;;
2F931;CJK COMPATIBILITY IDEOGRAPH-2F931;Lo;0;L;7485;;;;N;;;;;
2F932;CJK COMPATIBILITY IDEOGRAPH-2F932;Lo;0;L;74CA;;;;N;;;;;
2F933;CJK COMPATIBILITY IDEOGRAPH-2F933;Lo;0;L;3F1B;;;;N;;;;;
2F934;CJK COMPATIBILITY IDEOGRAPH-2F934;Lo;0;L;7524;;;;N;;;;;
2F935;CJK COMPATIBILITY IDEOGRAPH-2F935;Lo;0;L;24C36;;;;N;;;;;
2F936;CJK COMPATIBILITY IDEOGRAPH-2F936;Lo;0;L;753E;;;;N;;;;;
2F937;CJK COMPATIBILITY IDEOGRAPH-2F937;Lo;0;L;24C92;;;;N;;;;;
2F938;CJK COMPATIBILITY IDEOGRAPH-2F938;Lo;0;L;7570;;;;N;;;;;
2F939;CJK COMPATIBILITY IDEOGRAPH-2F939;Lo;0;L;2219F;;;;N;;;;;
2F93A;CJK COMPATIBILITY IDEOGRAPH-2F93A;Lo;0;L;7610;;;;N;;;;;
2F93B;CJK COMPATIBILITY IDEOGRAPH-2F93B;Lo;0;L;24FA1;;;;N;;;;;
2F93C;CJK COMPATIBILITY IDEOGRAPH-2F93C;Lo;0;L;24FB8;;;;N;;;;;
2F93D;CJK COMPATIBILITY IDEOGRAPH-2F93D;Lo;0;L;25044;;;;N;;;;;
2F93E;CJK COMPATIBILITY IDEOGRAPH-2F93E;Lo;0;L;3FFC;;;;N;;;;;
2F93F;CJK COMPATIBILITY IDEOGRAPH-2F93F;Lo;0;L;4008;;;;N;;;;;
2F940;CJK COMPATIBILITY IDEOGRAPH-2F940;Lo;0;L;76F4;;;;N;;;;;
2F941;CJK COMPATIBILITY IDEOGRAPH-2F941;Lo;0;L;250F3;;;;N;;;;;
2F942;CJK COMPATIBILITY IDEOGRAPH-2F942;Lo;0;L;250F2;;;;N;;;;;
2F943;CJK COMPATIBILITY IDEOGRAPH-2F943;Lo;0;L;25119;;;;N;;;;;
2F944;CJK COMPATIBILITY IDEOGRAPH-2F944;Lo;0;L;25133;;;;N;;;;;
2F945;CJK COMPATIBILITY IDEOGRAPH-2F945;Lo;0;L;771E;;;;N;;;;;
2F946;CJK COMPATIBILITY IDEOGRAPH-2F946;Lo;0;L;771F;;;;N;;;;;
2F947;CJK COMPATIBILITY IDEOGRAPH-2F947;Lo;0;L;771F;;;;N;;;;;
2F948;CJK COMPATIBILITY IDEOGRAPH-2F948;Lo;0;L;774A;;;;N;;;;;
2F949;CJK COMPATIBILITY IDEOGRAPH-2F949;Lo;0;L;4039;;;;N;;;;;
2F94A;CJK COMPATIBILITY IDEOGRAPH-2F94A;Lo;0;L;778B;;;;N;;;;;
2F94B;CJK COMPATIBILITY IDEOGRAPH-2F94B;Lo;0;L;4046;;;;N;;;;;
2F94C;CJK COMPATIBILITY IDEOGRAPH-2F94C;Lo;0;L;4096;;;;N;;;;;
2F94D;CJK COMPATIBILITY IDEOGRAPH-2F94D;Lo;0;L;2541D;;;;N;;;;;
2F94E;CJK COMPATIBILITY IDEOGRAPH-2F94E;Lo;0;L;784E;;;;N;;;;;
2F94F;CJK COMPATIBILITY IDEOGRAPH-2F94F;Lo;0;L;788C;;;;N;;;;;
2F950;CJK COMPATIBILITY IDEOGRAPH-2F950;Lo;0;L;78CC;;;;N;;;;;
2F951;CJK COMPATIBILITY IDEOGRAPH-2F951;Lo;0;L;40E3;;;;N;;;;;
2F952;CJK COMPATIBILITY IDEOGRAPH-2F952;Lo;0;L;25626;;;;N;;;;;
2F953;CJK COMPATIBILITY IDEOGRAPH-2F953;Lo;0;L;7956;;;;N;;;;;
2F954;CJK COMPATIBILITY IDEOGRAPH-2F954;Lo;0;L;2569A;;;;N;;;;;
2F955;CJK COMPATIBILITY IDEOGRAPH-2F955;Lo;0;L;256C5;;;;N;;;;;
2F956;CJK COMPATIBILITY IDEOGRAPH-2F956;Lo;0;L;798F;;;;N;;;;;
2F957;CJK COMPATIBILITY IDEOGRAPH-2F957;Lo;0;L;79EB;;;;N;;;;;
2F958;CJK COMPATIBILITY IDEOGRAPH-2F958;Lo;0;L;412F;;;;N;;;;;
2F959;CJK COMPATIBILITY IDEOGRAPH-2F959;Lo;0;L;7A40;;;;N;;;;;
2F95A;CJK COMPATIBILITY IDEOGRAPH-2F95A;Lo;0;L;7A4A;;;;N;;;;;
2F95B;CJK COMPATIBILITY IDEOGRAPH-2F95B;Lo;0;L;7A4F;;;;N;;;;;
2F95C;CJK COMPATIBILITY IDEOGRAPH-2F95C;Lo;0;L;2597C;;;;N;;;;;
2F95D;CJK COMPATIBILITY IDEOGRAPH-2F95D;Lo;0;L;25AA7;;;;N;;;;;
2F95E;CJK COMPATIBILITY IDEOGRAPH-2F95E;Lo;0;L;25AA7;;;;N;;;;;
2F95F;CJK COMPATIBILITY IDEOGRAPH-2F95F;Lo;0;L;7AEE;;;;N;;;;;
2F960;CJK COMPATIBILITY IDEOGRAPH-2F960;Lo;0;L;4202;;;;N;;;;;
2F961;CJK COMPATIBILITY IDEOGRAPH-2F961;Lo;0;L;25BAB;;;;N;;;;;
2F962;CJK COMPATIBILITY IDEOGRAPH-2F962;Lo;0;L;7BC6;;;;N;;;;;
2F963;CJK COMPATIBILITY IDEOGRAPH-2F963;Lo;0;L;7BC9;;;;N;;;;;
2F964;CJK COMPATIBILITY IDEOGRAPH-2F964;Lo;0;L;4227;;;;N;;;;;
2F965;CJK COMPATIBILITY IDEOGRAPH-2F965;Lo;0;L;25C80;;;;N;;;;;
2F966;CJK COMPATIBILITY IDEOGRAPH-2F966;Lo;0;L;7CD2;;;;N;;;;;
2F967;CJK COMPATIBILITY IDEOGRAPH-2F967;Lo;0;L;42A0;;;;N;;;;;
2F968;CJK COMPATIBILITY IDEOGRAPH-2F968;Lo;0;L;7CE8;;;;N;;;;;
2F969;CJK COMPATIBILITY IDEOGRAPH-2F969;Lo;0;L;7CE3;;;;N;;;;;
2F96A;CJK COMPATIBILITY IDEOGRAPH-2F96A;Lo;0;L;7D00;;;;N;;;;;
2F96B;CJK COMPATIBILITY IDEOGRAPH-2F96B;Lo;0;L;25F86;;;;N;;;;;
2F96C;CJK COMPATIBILITY IDEOGRAPH-2F96C;Lo;0;L;7D63;;;;N;;;;;
2F96D;CJK COMPATIBILITY IDEOGRAPH-2F96D;Lo;0;L;4301;;;;N;;;;;
2F96E;CJK COMPATIBILITY IDEOGRAPH-2F96E;Lo;0;L;7DC7;;;;N;;;;;
2F96F;CJK COMPATIBILITY IDEOGRAPH-2F96F;Lo;0;L;7E02;;;;N;;;;;
2F970;CJK COMPATIBILITY IDEOGRAPH-2F970;Lo;0;L;7E45;;;;N;;;;;
2F971;CJK COMPATIBILITY IDEOGRAPH-2F971;Lo;0;L;4334;;;;N;;;;;
2F972;CJK COMPATIBILITY IDEOGRAPH-2F972;Lo;0;L;26228;;;;N;;;;;
2F973;CJK COMPATIBILITY IDEOGRAPH-2F973;Lo;0;L;26247;;;;N;;;;;
2F974;CJK COMPATIBILITY IDEOGRAPH-2F974;Lo;0;L;4359;;;;N;;;;;
2F975;CJK COMPATIBILITY IDEOGRAPH-2F975;Lo;0;L;262D9;;;;N;;;;;
2F976;CJK COMPATIBILITY IDEOGRAPH-2F976;Lo;0;L;7F7A;;;;N;;;;;
2F977;CJK COMPATIBILITY IDEOGRAPH-2F977;Lo;0;L;2633E;;;;N;;;;;
2F978;CJK COMPATIBILITY IDEOGRAPH-2F978;Lo;0;L;7F95;;;;N;;;;;
2F979;CJK COMPATIBILITY IDEOGRAPH-2F979;Lo;0;L;7FFA;;;;N;;;;;
2F97A;CJK COMPATIBILITY IDEOGRAPH-2F97A;Lo;0;L;8005;;;;N;;;;;
2F97B;CJK COMPATIBILITY IDEOGRAPH-2F97B;Lo;0;L;264DA;;;;N;;;;;
2F97C;CJK COMPATIBILITY IDEOGRAPH-2F97C;Lo;0;L;26523;;;;N;;;;;
2F97D;CJK COMPATIBILITY IDEOGRAPH-2F97D;Lo;0;L;8060;;;;N;;;;;
2F97E;CJK COMPATIBILITY IDEOGRAPH-2F97E;Lo;0;L;265A8;;;;N;;;;;
2F97F;CJK COMPATIBILITY IDEOGRAPH-2F97F;Lo;0;L;8070;;;;N;;;;;
2F980;CJK COMPATIBILITY IDEOGRAPH-2F980;Lo;0;L;2335F;;;;N;;;;;
2F981;CJK COMPATIBILITY IDEOGRAPH-2F981;Lo;0;L;43D5;;;;N;;;;;
2F982;CJK COMPATIBILITY IDEOGRAPH-2F982;Lo;0;L;80B2;;;;N;;;;;
2F983;CJK COMPATIBILITY IDEOGRAPH-2F983;Lo;0;L;8103;;;;N;;;;;
2F984;CJK COMPATIBILITY IDEOGRAPH-2F984;Lo;0;L;440B;;;;N;;;;;
2F985;CJK COMPATIBILITY IDEOGRAPH-2F985;Lo;0;L;813E;;;;N;;;;;
2F986;CJK COMPATIBILITY IDEOGRAPH-2F986;Lo;0;L;5AB5;;;;N;;;;;
2F987;CJK COMPATIBILITY IDEOGRAPH-2F987;Lo;0;L;267A7;;;;N;;;;;
2F988;CJK COMPATIBILITY IDEOGRAPH-2F988;Lo;0;L;267B5;;;;N;;;;;
2F989;CJK COMPATIBILITY IDEOGRAPH-2F989;Lo;0;L;23393;;;;N;;;;;
2F98A;CJK COMPATIBILITY IDEOGRAPH-2F98A;Lo;0;L;2339C;;;;N;;;;;
2F98B;CJK COMPATIBILITY IDEOGRAPH-2F98B;Lo;0;L;8201;;;;N;;;;;
2F98C;CJK COMPATIBILITY IDEOGRAPH-2F98C;Lo;0;L;8204;;;;N;;;;;
2F98D;CJK COMPATIBILITY IDEOGRAPH-2F98D;Lo;0;L;8F9E;;;;N;;;;;
2F98E;CJK COMPATIBILITY IDEOGRAPH-2F98E;Lo;0;L;446B;;;;N;;;;;
2F98F;CJK COMPATIBILITY IDEOGRAPH-2F98F;Lo;0;L;8291;;;;N;;;;;
2F990;CJK COMPATIBILITY IDEOGRAPH-2F990;Lo;0;L;828B;;;;N;;;;;
2F991;CJK COMPATIBILITY IDEOGRAPH-2F991;Lo;0;L;829D;;;;N;;;;;
2F992;CJK COMPATIBILITY IDEOGRAPH-2F992;Lo;0;L;52B3;;;;N;;;;;
2F993;CJK COMPATIBILITY IDEOGRAPH-2F993;Lo;0;L;82B1;;;;N;;;;;
2F994;CJK COMPATIBILITY IDEOGRAPH-2F994;Lo;0;L;82B3;;;;N;;;;;
2F995;CJK COMPATIBILITY IDEOGRAPH-2F995;Lo;0;L;82BD;;;;N;;;;;
2F996;CJK COMPATIBILITY IDEOGRAPH-2F996;Lo;0;L;82E6;;;;N;;;;;
2F997;CJK COMPATIBILITY IDEOGRAPH-2F997;Lo;0;L;26B3C;;;;N;;;;;
2F998;CJK COMPATIBILITY IDEOGRAPH-2F998;Lo;0;L;82E5;;;;N;;;;;
2F999;CJK COMPATIBILITY IDEOGRAPH-2F999;Lo;0;L;831D;;;;N;;;;;
2F99A;CJK COMPATIBILITY IDEOGRAPH-2F99A;Lo;0;L;8363;;;;N;;;;;
2F99B;CJK COMPATIBILITY IDEOGRAPH-2F99B;Lo;0;L;83AD;;;;N;;;;;
2F99C;CJK COMPATIBILITY IDEOGRAPH-2F99C;Lo;0;L;8323;;;;N;;;;;
2F99D;CJK COMPATIBILITY IDEOGRAPH-2F99D;Lo;0;L;83BD;;;;N;;;;;
2F99E;CJK COMPATIBILITY IDEOGRAPH-2F99E;Lo;0;L;83E7;;;;N;;;;;
2F99F;CJK COMPATIBILITY IDEOGRAPH-2F99F;Lo;0;L;8457;;;;N;;;;;
2F9A0;CJK COMPATIBILITY IDEOGRAPH-2F9A0;Lo;0;L;8353;;;;N;;;;;
2F9A1;CJK COMPATIBILITY IDEOGRAPH-2F9A1;Lo;0;L;83CA;;;;N;;;;;
2F9A2;CJK COMPATIBILITY IDEOGRAPH-2F9A2;Lo;0;L;83CC;;;;N;;;;;
2F9A3;CJK COMPATIBILITY IDEOGRAPH-2F9A3;Lo;0;L;83DC;;;;N;;;;;
2F9A4;CJK COMPATIBILITY IDEOGRAPH-2F9A4;Lo;0;L;26C36;;;;N;;;;;
2F9A5;CJK COMPATIBILITY IDEOGRAPH-2F9A5;Lo;0;L;26D6B;;;;N;;;;;
2F9A6;CJK COMPATIBILITY IDEOGRAPH-2F9A6;Lo;0;L;26CD5;;;;N;;;;;
2F9A7;CJK COMPATIBILITY IDEOGRAPH-2F9A7;Lo;0;L;452B;;;;N;;;;;
2F9A8;CJK COMPATIBILITY IDEOGRAPH-2F9A8;Lo;0;L;84F1;;;;N;;;;;
2F9A9;CJK COMPATIBILITY IDEOGRAPH-2F9A9;Lo;0;L;84F3;;;;N;;;;;
2F9AA;CJK COMPATIBILITY IDEOGRAPH-2F9AA;Lo;0;L;8516;;;;N;;;;;
2F9AB;CJK COMPATIBILITY IDEOGRAPH-2F9AB;Lo;0;L;273CA;;;;N;;;;;
2F9AC;CJK COMPATIBILITY IDEOGRAPH-2F9AC;Lo;0;L;8564;;;;N;;;;;
2F9AD;CJK COMPATIBILITY IDEOGRAPH-2F9AD;Lo;0;L;26F2C;;;;N;;;;;
2F9AE;CJK COMPATIBILITY IDEOGRAPH-2F9AE;Lo;0;L;455D;;;;N;;;;;
2F9AF;CJK COMPATIBILITY IDEOGRAPH-2F9AF;Lo;0;L;4561;;;;N;;;;;
2F9B0;CJK COMPATIBILITY IDEOGRAPH-2F9B0;Lo;0;L;26FB1;;;;N;;;;;
2F9B1;CJK COMPATIBILITY IDEOGRAPH-2F9B1;Lo;0;L;270D2;;;;N;;;;;
2F9B2;CJK COMPATIBILITY IDEOGRAPH-2F9B2;Lo;0;L;456B;;;;N;;;;;
2F9B3;CJK COMPATIBILITY IDEOGRAPH-2F9B3;Lo;0;L;8650;;;;N;;;;;
2F9B4;CJK COMPATIBILITY IDEOGRAPH-2F9B4;Lo;0;L;865C;;;;N;;;;;
2F9B5;CJK COMPATIBILITY IDEOGRAPH-2F9B5;Lo;0;L;8667;;;;N;;;;;
2F9B6;CJK COMPATIBILITY IDEOGRAPH-2F9B6;Lo;0;L;8669;;;;N;;;;;
2F9B7;CJK COMPATIBILITY IDEOGRAPH-2F9B7;Lo;0;L;86A9;;;;N;;;;;
2F9B8;CJK COMPATIBILITY IDEOGRAPH-2F9B8;Lo;0;L;8688;;;;N;;;;;
2F9B9;CJK COMPATIBILITY IDEOGRAPH-2F9B9;Lo;0;L;870E;;;;N;;;;;
2F9BA;CJK COMPATIBILITY IDEOGRAPH-2F9BA;Lo;0;L;86E2;;;;N;;;;;
2F9BB;CJK COMPATIBILITY IDEOGRAPH-2F9BB;Lo;0;L;8779;;;;N;;;;;
2F9BC;CJK COMPATIBILITY IDEOGRAPH-2F9BC;Lo;0;L;8728;;;;N;;;;;
2F9BD;CJK COMPATIBILITY IDEOGRAPH-2F9BD;Lo;0;L;876B;;;;N;;;;;
2F9BE;CJK COMPATIBILITY IDEOGRAPH-2F9BE;Lo;0;L;8786;;;;N;;;;;
2F9BF;CJK COMPATIBILITY IDEOGRAPH-2F9BF;Lo;0;L;45D7;;;;N;;;;;
2F9C0;CJK COMPATIBILITY IDEOGRAPH-2F9C0;Lo;0;L;87E1;;;;N;;;;;
2F9C1;CJK COMPATIBILITY IDEOGRAPH-2F9C1;Lo;0;L;8801;;;;N;;;;;
2F9C2;CJK COMPATIBILITY IDEOGRAPH-2F9C2;Lo;0;L;45F9;;;;N;;;;;
2F9C3;CJK COMPATIBILITY IDEOGRAPH-2F9C3;Lo;0;L;8860;;;;N;;;;;
2F9C4;CJK COMPATIBILITY IDEOGRAPH-2F9C4;Lo;0;L;8863;;;;N;;;;;
2F9C5;CJK COMPATIBILITY IDEOGRAPH-2F9C5;Lo;0;L;27667;;;;N;;;;;
2F9C6;CJK COMPATIBILITY IDEOGRAPH-2F9C6;Lo;0;L;88D7;;;;N;;;;;
2F9C7;CJK COMPATIBILITY IDEOGRAPH-2F9C7;Lo;0;L;88DE;;;;N;;;;;
2F9C8;CJK COMPATIBILITY IDEOGRAPH-2F9C8;Lo;0;L;4635;;;;N;;;;;
2F9C9;CJK COMPATIBILITY IDEOGRAPH-2F9C9;Lo;0;L;88FA;;;;N;;;;;
2F9CA;CJK COMPATIBILITY IDEOGRAPH-2F9CA;Lo;0;L;34BB;;;;N;;;;;
2F9CB;CJK COMPATIBILITY IDEOGRAPH-2F9CB;Lo;0;L;278AE;;;;N;;;;;
2F9CC;CJK COMPATIBILITY IDEOGRAPH-2F9CC;Lo;0;L;27966;;;;N;;;;;
2F9CD;CJK COMPATIBILITY IDEOGRAPH-2F9CD;Lo;0;L;46BE;;;;N;;;;;
2F9CE;CJK COMPATIBILITY IDEOGRAPH-2F9CE;Lo;0;L;46C7;;;;N;;;;;
2F9CF;CJK COMPATIBILITY IDEOGRAPH-2F9CF;Lo;0;L;8AA0;;;;N;;;;;
2F9D0;CJK COMPATIBILITY IDEOGRAPH-2F9D0;Lo;0;L;8AED;;;;N;;;;;
2F9D1;CJK COMPATIBILITY IDEOGRAPH-2F9D1;Lo;0;L;8B8A;;;;N;;;;;
2F9D2;CJK COMPATIBILITY IDEOGRAPH-2F9D2;Lo;0;L;8C55;;;;N;;;;;
2F9D3;CJK COMPATIBILITY IDEOGRAPH-2F9D3;Lo;0;L;27CA8;;;;N;;;;;
2F9D4;CJK COMPATIBILITY IDEOGRAPH-2F9D4;Lo;0;L;8CAB;;;;N;;;;;
2F9D5;CJK COMPATIBILITY IDEOGRAPH-2F9D5;Lo;0;L;8CC1;;;;N;;;;;
2F9D6;CJK COMPATIBILITY IDEOGRAPH-2F9D6;Lo;0;L;8D1B;;;;N;;;;;
2F9D7;CJK COMPATIBILITY IDEOGRAPH-2F9D7;Lo;0;L;8D77;;;;N;;;;;
2F9D8;CJK COMPATIBILITY IDEOGRAPH-2F9D8;Lo;0;L;27F2F;;;;N;;;;;
2F9D9;CJK COMPATIBILITY IDEOGRAPH-2F9D9;Lo;0;L;20804;;;;N;;;;;
2F9DA;CJK COMPATIBILITY IDEOGRAPH-2F9DA;Lo;0;L;8DCB;;;;N;;;;;
2F9DB;CJK COMPATIBILITY IDEOGRAPH-2F9DB;Lo;0;L;8DBC;;;;N;;;;;
2F9DC;CJK COMPATIBILITY IDEOGRAPH-2F9DC;Lo;0;L;8DF0;;;;N;;;;;
2F9DD;CJK COMPATIBILITY IDEOGRAPH-2F9DD;Lo;0;L;208DE;;;;N;;;;;
2F9DE;CJK COMPATIBILITY IDEOGRAPH-2F9DE;Lo;0;L;8ED4;;;;N;;;;;
2F9DF;CJK COMPATIBILITY IDEOGRAPH-2F9DF;Lo;0;L;8F38;;;;N;;;;;
2F9E0;CJK COMPATIBILITY IDEOGRAPH-2F9E0;Lo;0;L;285D2;;;;N;;;;;
2F9E1;CJK COMPATIBILITY IDEOGRAPH-2F9E1;Lo;0;L;285ED;;;;N;;;;;
2F9E2;CJK COMPATIBILITY IDEOGRAPH-2F9E2;Lo;0;L;9094;;;;N;;;;;
2F9E3;CJK COMPATIBILITY IDEOGRAPH-2F9E3;Lo;0;L;90F1;;;;N;;;;;
2F9E4;CJK COMPATIBILITY IDEOGRAPH-2F9E4;Lo;0;L;9111;;;;N;;;;;
2F9E5;CJK COMPATIBILITY IDEOGRAPH-2F9E5;Lo;0;L;2872E;;;;N;;;;;
2F9E6;CJK COMPATIBILITY IDEOGRAPH-2F9E6;Lo;0;L;911B;;;;N;;;;;
2F9E7;CJK COMPATIBILITY IDEOGRAPH-2F9E7;Lo;0;L;9238;;;;N;;;;;
2F9E8;CJK COMPATIBILITY IDEOGRAPH-2F9E8;Lo;0;L;92D7;;;;N;;;;;
2F9E9;CJK COMPATIBILITY IDEOGRAPH-2F9E9;Lo;0;L;92D8;;;;N;;;;;
2F9EA;CJK COMPATIBILITY IDEOGRAPH-2F9EA;Lo;0;L;927C;;;;N;;;;;
2F9EB;CJK COMPATIBILITY IDEOGRAPH-2F9EB;Lo;0;L;93F9;;;;N;;;;;
2F9EC;CJK COMPATIBILITY IDEOGRAPH-2F9EC;Lo;0;L;9415;;;;N;;;;;
2F9ED;CJK COMPATIBILITY IDEOGRAPH-2F9ED;Lo;0;L;28BFA;;;;N;;;;;
2F9EE;CJK COMPATIBILITY IDEOGRAPH-2F9EE;Lo;0;L;958B;;;;N;;;;;
2F9EF;CJK COMPATIBILITY IDEOGRAPH-2F9EF;Lo;0;L;4995;;;;N;;;;;
2F9F0;CJK COMPATIBILITY IDEOGRAPH-2F9F0;Lo;0;L;95B7;;;;N;;;;;
2F9F1;CJK COMPATIBILITY IDEOGRAPH-2F9F1;Lo;0;L;28D77;;;;N;;;;;
2F9F2;CJK COMPATIBILITY IDEOGRAPH-2F9F2;Lo;0;L;49E6;;;;N;;;;;
2F9F3;CJK COMPATIBILITY IDEOGRAPH-2F9F3;Lo;0;L;96C3;;;;N;;;;;
2F9F4;CJK COMPATIBILITY IDEOGRAPH-2F9F4;Lo;0;L;5DB2;;;;N;;;;;
2F9F5;CJK COMPATIBILITY IDEOGRAPH-2F9F5;Lo;0;L;9723;;;;N;;;;;
2F9F6;CJK COMPATIBILITY IDEOGRAPH-2F9F6;Lo;0;L;29145;;;;N;;;;;
2F9F7;CJK COMPATIBILITY IDEOGRAPH-2F9F7;Lo;0;L;2921A;;;;N;;;;;
2F9F8;CJK COMPATIBILITY IDEOGRAPH-2F9F8;Lo;0;L;4A6E;;;;N;;;;;
2F9F9;CJK COMPATIBILITY IDEOGRAPH-2F9F9;Lo;0;L;4A76;;;;N;;;;;
2F9FA;CJK COMPATIBILITY IDEOGRAPH-2F9FA;Lo;0;L;97E0;;;;N;;;;;
2F9FB;CJK COMPATIBILITY IDEOGRAPH-2F9FB;Lo;0;L;2940A;;;;N;;;;;
2F9FC;CJK COMPATIBILITY IDEOGRAPH-2F9FC;Lo;0;L;4AB2;;;;N;;;;;
2F9FD;CJK COMPATIBILITY IDEOGRAPH-2F9FD;Lo;0;L;29496;;;;N;;;;;
2F9FE;CJK COMPATIBILITY IDEOGRAPH-2F9FE;Lo;0;L;980B;;;;N;;;;;
2F9FF;CJK COMPATIBILITY IDEOGRAPH-2F9FF;Lo;0;L;980B;;;;N;;;;;
2FA00;CJK COMPATIBILITY IDEOGRAPH-2FA00;Lo;0;L;9829;;;;N;;;;;
2FA01;CJK COMPATIBILITY IDEOGRAPH-2FA01;Lo;0;L;295B6;;;;N;;;;;
2FA02;CJK COMPATIBILITY IDEOGRAPH-2FA02;Lo;0;L;98E2;;;;N;;;;;
2FA03;CJK COMPATIBILITY IDEOGRAPH-2FA03;Lo;0;L;4B33;;;;N;;;;;
2FA04;CJK COMPATIBILITY IDEOGRAPH-2FA04;Lo;0;L;9929;;;;N;;;;;
2FA05;CJK COMPATIBILITY IDEOGRAPH-2FA05;Lo;0;L;99A7;;;;N;;;;;
2FA06;CJK COMPATIBILITY IDEOGRAPH-2FA06;Lo;0;L;99C2;;;;N;;;;;
2FA07;CJK COMPATIBILITY IDEOGRAPH-2FA07;Lo;0;L;99FE;;;;N;;;;;
2FA08;CJK COMPATIBILITY IDEOGRAPH-2FA08;Lo;0;L;4BCE;;;;N;;;;;
2FA09;CJK COMPATIBILITY IDEOGRAPH-2FA09;Lo;0;L;29B30;;;;N;;;;;
2FA0A;CJK COMPATIBILITY IDEOGRAPH-2FA0A;Lo;0;L;9B12;;;;N;;;;;
2FA0B;CJK COMPATIBILITY IDEOGRAPH-2FA0B;Lo;0;L;9C40;;;;N;;;;;
2FA0C;CJK COMPATIBILITY IDEOGRAPH-2FA0C;Lo;0;L;9CFD;;;;N;;;;;
2FA0D;CJK COMPATIBILITY IDEOGRAPH-2FA0D;Lo;0;L;4CCE;;;;N;;;;;
2FA0E;CJK COMPATIBILITY IDEOGRAPH-2FA0E;Lo;0;L;4CED;;;;N;;;;;
2FA0F;CJK COMPATIBILITY IDEOGRAPH-2FA0F;Lo;0;L;9D67;;;;N;;;;;
2FA10;CJK COMPATIBILITY IDEOGRAPH-2FA10;Lo;0;L;2A0CE;;;;N;;;;;
2FA11;CJK COMPATIBILITY IDEOGRAPH-2FA11;Lo;0;L;4CF8;;;;N;;;;;
2FA12;CJK COMPATIBILITY IDEOGRAPH-2FA12;Lo;0;L;2A105;;;;N;;;;;
2FA13;CJK COMPATIBILITY IDEOGRAPH-2FA13;Lo;0;L;2A20E;;;;N;;;;;
2FA14;CJK COMPATIBILITY IDEOGRAPH-2FA14;Lo;0;L;2A291;;;;N;;;;;
2FA15;CJK COMPATIBILITY IDEOGRAPH-2FA15;Lo;0;L;9EBB;;;;N;;;;;
2FA16;CJK COMPATIBILITY IDEOGRAPH-2FA16;Lo;0;L;4D56;;;;N;;;;;
2FA17;CJK COMPATIBILITY IDEOGRAPH-2FA17;Lo;0;L;9EF9;;;;N;;;;;
2FA18;CJK COMPATIBILITY IDEOGRAPH-2FA18;Lo;0;L;9EFE;;;;N;;;;;
2FA19;CJK COMPATIBILITY IDEOGRAPH-2FA19;Lo;0;L;9F05;;;;N;;;;;
2FA1A;CJK COMPATIBILITY IDEOGRAPH-2FA1A;Lo;0;L;9F0F;;;;N;;;;;
2FA1B;CJK COMPATIBILITY IDEOGRAPH-2FA1B;Lo;0;L;9F16;;;;N;;;;;
2FA1C;CJK COMPATIBILITY IDEOGRAPH-2FA1C;Lo;0;L;9F3B;;;;N;;;;;
2FA1D;CJK COMPATIBILITY IDEOGRAPH-2FA1D;Lo;0;L;2A600;;;;N;;;;;
30000;<CJK Ideograph Extension G, First>;Lo;0;L;;;;;N;;;;;
3134A;<CJK Ideograph Extension G, Last>;Lo;0;L;;;;;N;;;;;
E0001;LANGUAGE TAG;Cf;0;BN;;;;;N;;;;;
E0020;TAG SPACE;Cf;0;BN;;;;;N;;;;;
E0021;TAG EXCLAMATION MARK;Cf;0;BN;;;;;N;;;;;
E0022;TAG QUOTATION MARK;Cf;0;BN;;;;;N;;;;;
E0023;TAG NUMBER SIGN;Cf;0;BN;;;;;N;;;;;
E0024;TAG DOLLAR SIGN;Cf;0;BN;;;;;N;;;;;
E0025;TAG PERCENT SIGN;Cf;0;BN;;;;;N;;;;;
E0026;TAG AMPERSAND;Cf;0;BN;;;;;N;;;;;
E0027;TAG APOSTROPHE;Cf;0;BN;;;;;N;;;;;
E0028;TAG LEFT PARENTHESIS;Cf;0;BN;;;;;N;;;;;
E0029;TAG RIGHT PARENTHESIS;Cf;0;BN;;;;;N;;;;;
E002A;TAG ASTERISK;Cf;0;BN;;;;;N;;;;;
E002B;TAG PLUS SIGN;Cf;0;BN;;;;;N;;;;;
E002C;TAG COMMA;Cf;0;BN;;;;;N;;;;;
E002D;TAG HYPHEN-MINUS;Cf;0;BN;;;;;N;;;;;
E002E;TAG FULL STOP;Cf;0;BN;;;;;N;;;;;
E002F;TAG SOLIDUS;Cf;0;BN;;;;;N;;;;;
E0030;TAG DIGIT ZERO;Cf;0;BN;;;;;N;;;;;
E0031;TAG DIGIT ONE;Cf;0;BN;;;;;N;;;;;
E0032;TAG DIGIT TWO;Cf;0;BN;;;;;N;;;;;
E0033;TAG DIGIT THREE;Cf;0;BN;;;;;N;;;;;
E0034;TAG DIGIT FOUR;Cf;0;BN;;;;;N;;;;;
E0035;TAG DIGIT FIVE;Cf;0;BN;;;;;N;;;;;
E0036;TAG DIGIT SIX;Cf;0;BN;;;;;N;;;;;
E0037;TAG DIGIT SEVEN;Cf;0;BN;;;;;N;;;;;
E0038;TAG DIGIT EIGHT;Cf;0;BN;;;;;N;;;;;
E0039;TAG DIGIT NINE;Cf;0;BN;;;;;N;;;;;
E003A;TAG COLON;Cf;0;BN;;;;;N;;;;;
E003B;TAG SEMICOLON;Cf;0;BN;;;;;N;;;;;
E003C;TAG LESS-THAN SIGN;Cf;0;BN;;;;;N;;;;;
E003D;TAG EQUALS SIGN;Cf;0;BN;;;;;N;;;;;
E003E;TAG GREATER-THAN SIGN;Cf;0;BN;;;;;N;;;;;
E003F;TAG QUESTION MARK;Cf;0;BN;;;;;N;;;;;
E0040;TAG COMMERCIAL AT;Cf;0;BN;;;;;N;;;;;
E0041;TAG LATIN CAPITAL LETTER A;Cf;0;BN;;;;;N;;;;;
E0042;TAG LATIN CAPITAL LETTER B;Cf;0;BN;;;;;N;;;;;
E0043;TAG LATIN CAPITAL LETTER C;Cf;0;BN;;;;;N;;;;;
E0044;TAG LATIN CAPITAL LETTER D;Cf;0;BN;;;;;N;;;;;
E0045;TAG LATIN CAPITAL LETTER E;Cf;0;BN;;;;;N;;;;;
E0046;TAG LATIN CAPITAL LETTER F;Cf;0;BN;;;;;N;;;;;
E0047;TAG LATIN CAPITAL LETTER G;Cf;0;BN;;;;;N;;;;;
E0048;TAG LATIN CAPITAL LETTER H;Cf;0;BN;;;;;N;;;;;
E0049;TAG LATIN CAPITAL LETTER I;Cf;0;BN;;;;;N;;;;;
E004A;TAG LATIN CAPITAL LETTER J;Cf;0;BN;;;;;N;;;;;
E004B;TAG LATIN CAPITAL LETTER K;Cf;0;BN;;;;;N;;;;;
E004C;TAG LATIN CAPITAL LETTER L;Cf;0;BN;;;;;N;;;;;
E004D;TAG LATIN CAPITAL LETTER M;Cf;0;BN;;;;;N;;;;;
E004E;TAG LATIN CAPITAL LETTER N;Cf;0;BN;;;;;N;;;;;
E004F;TAG LATIN CAPITAL LETTER O;Cf;0;BN;;;;;N;;;;;
E0050;TAG LATIN CAPITAL LETTER P;Cf;0;BN;;;;;N;;;;;
E0051;TAG LATIN CAPITAL LETTER Q;Cf;0;BN;;;;;N;;;;;
E0052;TAG LATIN CAPITAL LETTER R;Cf;0;BN;;;;;N;;;;;
E0053;TAG LATIN CAPITAL LETTER S;Cf;0;BN;;;;;N;;;;;
E0054;TAG LATIN CAPITAL LETTER T;Cf;0;BN;;;;;N;;;;;
E0055;TAG LATIN CAPITAL LETTER U;Cf;0;BN;;;;;N;;;;;
E0056;TAG LATIN CAPITAL LETTER V;Cf;0;BN;;;;;N;;;;;
E0057;TAG LATIN CAPITAL LETTER W;Cf;0;BN;;;;;N;;;;;
E0058;TAG LATIN CAPITAL LETTER X;Cf;0;BN;;;;;N;;;;;
E0059;TAG LATIN CAPITAL LETTER Y;Cf;0;BN;;;;;N;;;;;
E005A;TAG LATIN CAPITAL LETTER Z;Cf;0;BN;;;;;N;;;;;
E005B;TAG LEFT SQUARE BRACKET;Cf;0;BN;;;;;N;;;;;
E005C;TAG REVERSE SOLIDUS;Cf;0;BN;;;;;N;;;;;
E005D;TAG RIGHT SQUARE BRACKET;Cf;0;BN;;;;;N;;;;;
E005E;TAG CIRCUMFLEX ACCENT;Cf;0;BN;;;;;N;;;;;
E005F;TAG LOW LINE;Cf;0;BN;;;;;N;;;;;
E0060;TAG GRAVE ACCENT;Cf;0;BN;;;;;N;;;;;
E0061;TAG LATIN SMALL LETTER A;Cf;0;BN;;;;;N;;;;;
E0062;TAG LATIN SMALL LETTER B;Cf;0;BN;;;;;N;;;;;
E0063;TAG LATIN SMALL LETTER C;Cf;0;BN;;;;;N;;;;;
E0064;TAG LATIN SMALL LETTER D;Cf;0;BN;;;;;N;;;;;
E0065;TAG LATIN SMALL LETTER E;Cf;0;BN;;;;;N;;;;;
E0066;TAG LATIN SMALL LETTER F;Cf;0;BN;;;;;N;;;;;
E0067;TAG LATIN SMALL LETTER G;Cf;0;BN;;;;;N;;;;;
E0068;TAG LATIN SMALL LETTER H;Cf;0;BN;;;;;N;;;;;
E0069;TAG LATIN SMALL LETTER I;Cf;0;BN;;;;;N;;;;;
E006A;TAG LATIN SMALL LETTER J;Cf;0;BN;;;;;N;;;;;
E006B;TAG LATIN SMALL LETTER K;Cf;0;BN;;;;;N;;;;;
E006C;TAG LATIN SMALL LETTER L;Cf;0;BN;;;;;N;;;;;
E006D;TAG LATIN SMALL LETTER M;Cf;0;BN;;;;;N;;;;;
E006E;TAG LATIN SMALL LETTER N;Cf;0;BN;;;;;N;;;;;
E006F;TAG LATIN SMALL LETTER O;Cf;0;BN;;;;;N;;;;;
E0070;TAG LATIN SMALL LETTER P;Cf;0;BN;;;;;N;;;;;
E0071;TAG LATIN SMALL LETTER Q;Cf;0;BN;;;;;N;;;;;
E0072;TAG LATIN SMALL LETTER R;Cf;0;BN;;;;;N;;;;;
E0073;TAG LATIN SMALL LETTER S;Cf;0;BN;;;;;N;;;;;
E0074;TAG LATIN SMALL LETTER T;Cf;0;BN;;;;;N;;;;;
E0075;TAG LATIN SMALL LETTER U;Cf;0;BN;;;;;N;;;;;
E0076;TAG LATIN SMALL LETTER V;Cf;0;BN;;;;;N;;;;;
E0077;TAG LATIN SMALL LETTER W;Cf;0;BN;;;;;N;;;;;
E0078;TAG LATIN SMALL LETTER X;Cf;0;BN;;;;;N;;;;;
E0079;TAG LATIN SMALL LETTER Y;Cf;0;BN;;;;;N;;;;;
E007A;TAG LATIN SMALL LETTER Z;Cf;0;BN;;;;;N;;;;;
E007B;TAG LEFT CURLY BRACKET;Cf;0;BN;;;;;N;;;;;
E007C;TAG VERTICAL LINE;Cf;0;BN;;;;;N;;;;;
E007D;TAG RIGHT CURLY BRACKET;Cf;0;BN;;;;;N;;;;;
E007E;TAG TILDE;Cf;0;BN;;;;;N;;;;;
E007F;CANCEL TAG;Cf;0;BN;;;;;N;;;;;
E0100;VARIATION SELECTOR-17;Mn;0;NSM;;;;;N;;;;;
E0101;VARIATION SELECTOR-18;Mn;0;NSM;;;;;N;;;;;
E0102;VARIATION SELECTOR-19;Mn;0;NSM;;;;;N;;;;;
E0103;VARIATION SELECTOR-20;Mn;0;NSM;;;;;N;;;;;
E0104;VARIATION SELECTOR-21;Mn;0;NSM;;;;;N;;;;;
E0105;VARIATION SELECTOR-22;Mn;0;NSM;;;;;N;;;;;
E0106;VARIATION SELECTOR-23;Mn;0;NSM;;;;;N;;;;;
E0107;VARIATION SELECTOR-24;Mn;0;NSM;;;;;N;;;;;
E0108;VARIATION SELECTOR-25;Mn;0;NSM;;;;;N;;;;;
E0109;VARIATION SELECTOR-26;Mn;0;NSM;;;;;N;;;;;
E010A;VARIATION SELECTOR-27;Mn;0;NSM;;;;;N;;;;;
E010B;VARIATION SELECTOR-28;Mn;0;NSM;;;;;N;;;;;
E010C;VARIATION SELECTOR-29;Mn;0;NSM;;;;;N;;;;;
E010D;VARIATION SELECTOR-30;Mn;0;NSM;;;;;N;;;;;
E010E;VARIATION SELECTOR-31;Mn;0;NSM;;;;;N;;;;;
E010F;VARIATION SELECTOR-32;Mn;0;NSM;;;;;N;;;;;
E0110;VARIATION SELECTOR-33;Mn;0;NSM;;;;;N;;;;;
E0111;VARIATION SELECTOR-34;Mn;0;NSM;;;;;N;;;;;
E0112;VARIATION SELECTOR-35;Mn;0;NSM;;;;;N;;;;;
E0113;VARIATION SELECTOR-36;Mn;0;NSM;;;;;N;;;;;
E0114;VARIATION SELECTOR-37;Mn;0;NSM;;;;;N;;;;;
E0115;VARIATION SELECTOR-38;Mn;0;NSM;;;;;N;;;;;
E0116;VARIATION SELECTOR-39;Mn;0;NSM;;;;;N;;;;;
E0117;VARIATION SELECTOR-40;Mn;0;NSM;;;;;N;;;;;
E0118;VARIATION SELECTOR-41;Mn;0;NSM;;;;;N;;;;;
E0119;VARIATION SELECTOR-42;Mn;0;NSM;;;;;N;;;;;
E011A;VARIATION SELECTOR-43;Mn;0;NSM;;;;;N;;;;;
E011B;VARIATION SELECTOR-44;Mn;0;NSM;;;;;N;;;;;
E011C;VARIATION SELECTOR-45;Mn;0;NSM;;;;;N;;;;;
E011D;VARIATION SELECTOR-46;Mn;0;NSM;;;;;N;;;;;
E011E;VARIATION SELECTOR-47;Mn;0;NSM;;;;;N;;;;;
E011F;VARIATION SELECTOR-48;Mn;0;NSM;;;;;N;;;;;
E0120;VARIATION SELECTOR-49;Mn;0;NSM;;;;;N;;;;;
E0121;VARIATION SELECTOR-50;Mn;0;NSM;;;;;N;;;;;
E0122;VARIATION SELECTOR-51;Mn;0;NSM;;;;;N;;;;;
E0123;VARIATION SELECTOR-52;Mn;0;NSM;;;;;N;;;;;
E0124;VARIATION SELECTOR-53;Mn;0;NSM;;;;;N;;;;;
E0125;VARIATION SELECTOR-54;Mn;0;NSM;;;;;N;;;;;
E0126;VARIATION SELECTOR-55;Mn;0;NSM;;;;;N;;;;;
E0127;VARIATION SELECTOR-56;Mn;0;NSM;;;;;N;;;;;
E0128;VARIATION SELECTOR-57;Mn;0;NSM;;;;;N;;;;;
E0129;VARIATION SELECTOR-58;Mn;0;NSM;;;;;N;;;;;
E012A;VARIATION SELECTOR-59;Mn;0;NSM;;;;;N;;;;;
E012B;VARIATION SELECTOR-60;Mn;0;NSM;;;;;N;;;;;
E012C;VARIATION SELECTOR-61;Mn;0;NSM;;;;;N;;;;;
E012D;VARIATION SELECTOR-62;Mn;0;NSM;;;;;N;;;;;
E012E;VARIATION SELECTOR-63;Mn;0;NSM;;;;;N;;;;;
E012F;VARIATION SELECTOR-64;Mn;0;NSM;;;;;N;;;;;
E0130;VARIATION SELECTOR-65;Mn;0;NSM;;;;;N;;;;;
E0131;VARIATION SELECTOR-66;Mn;0;NSM;;;;;N;;;;;
E0132;VARIATION SELECTOR-67;Mn;0;NSM;;;;;N;;;;;
E0133;VARIATION SELECTOR-68;Mn;0;NSM;;;;;N;;;;;
E0134;VARIATION SELECTOR-69;Mn;0;NSM;;;;;N;;;;;
E0135;VARIATION SELECTOR-70;Mn;0;NSM;;;;;N;;;;;
E0136;VARIATION SELECTOR-71;Mn;0;NSM;;;;;N;;;;;
E0137;VARIATION SELECTOR-72;Mn;0;NSM;;;;;N;;;;;
E0138;VARIATION SELECTOR-73;Mn;0;NSM;;;;;N;;;;;
E0139;VARIATION SELECTOR-74;Mn;0;NSM;;;;;N;;;;;
E013A;VARIATION SELECTOR-75;Mn;0;NSM;;;;;N;;;;;
E013B;VARIATION SELECTOR-76;Mn;0;NSM;;;;;N;;;;;
E013C;VARIATION SELECTOR-77;Mn;0;NSM;;;;;N;;;;;
E013D;VARIATION SELECTOR-78;Mn;0;NSM;;;;;N;;;;;
E013E;VARIATION SELECTOR-79;Mn;0;NSM;;;;;N;;;;;
E013F;VARIATION SELECTOR-80;Mn;0;NSM;;;;;N;;;;;
E0140;VARIATION SELECTOR-81;Mn;0;NSM;;;;;N;;;;;
E0141;VARIATION SELECTOR-82;Mn;0;NSM;;;;;N;;;;;
E0142;VARIATION SELECTOR-83;Mn;0;NSM;;;;;N;;;;;
E0143;VARIATION SELECTOR-84;Mn;0;NSM;;;;;N;;;;;
E0144;VARIATION SELECTOR-85;Mn;0;NSM;;;;;N;;;;;
E0145;VARIATION SELECTOR-86;Mn;0;NSM;;;;;N;;;;;
E0146;VARIATION SELECTOR-87;Mn;0;NSM;;;;;N;;;;;
E0147;VARIATION SELECTOR-88;Mn;0;NSM;;;;;N;;;;;
E0148;VARIATION SELECTOR-89;Mn;0;NSM;;;;;N;;;;;
E0149;VARIATION SELECTOR-90;Mn;0;NSM;;;;;N;;;;;
E014A;VARIATION SELECTOR-91;Mn;0;NSM;;;;;N;;;;;
E014B;VARIATION SELECTOR-92;Mn;0;NSM;;;;;N;;;;;
E014C;VARIATION SELECTOR-93;Mn;0;NSM;;;;;N;;;;;
E014D;VARIATION SELECTOR-94;Mn;0;NSM;;;;;N;;;;;
E014E;VARIATION SELECTOR-95;Mn;0;NSM;;;;;N;;;;;
E014F;VARIATION SELECTOR-96;Mn;0;NSM;;;;;N;;;;;
E0150;VARIATION SELECTOR-97;Mn;0;NSM;;;;;N;;;;;
E0151;VARIATION SELECTOR-98;Mn;0;NSM;;;;;N;;;;;
E0152;VARIATION SELECTOR-99;Mn;0;NSM;;;;;N;;;;;
E0153;VARIATION SELECTOR-100;Mn;0;NSM;;;;;N;;;;;
E0154;VARIATION SELECTOR-101;Mn;0;NSM;;;;;N;;;;;
E0155;VARIATION SELECTOR-102;Mn;0;NSM;;;;;N;;;;;
E0156;VARIATION SELECTOR-103;Mn;0;NSM;;;;;N;;;;;
E0157;VARIATION SELECTOR-104;Mn;0;NSM;;;;;N;;;;;
E0158;VARIATION SELECTOR-105;Mn;0;NSM;;;;;N;;;;;
E0159;VARIATION SELECTOR-106;Mn;0;NSM;;;;;N;;;;;
E015A;VARIATION SELECTOR-107;Mn;0;NSM;;;;;N;;;;;
E015B;VARIATION SELECTOR-108;Mn;0;NSM;;;;;N;;;;;
E015C;VARIATION SELECTOR-109;Mn;0;NSM;;;;;N;;;;;
E015D;VARIATION SELECTOR-110;Mn;0;NSM;;;;;N;;;;;
E015E;VARIATION SELECTOR-111;Mn;0;NSM;;;;;N;;;;;
E015F;VARIATION SELECTOR-112;Mn;0;NSM;;;;;N;;;;;
E0160;VARIATION SELECTOR-113;Mn;0;NSM;;;;;N;;;;;
E0161;VARIATION SELECTOR-114;Mn;0;NSM;;;;;N;;;;;
E0162;VARIATION SELECTOR-115;Mn;0;NSM;;;;;N;;;;;
E0163;VARIATION SELECTOR-116;Mn;0;NSM;;;;;N;;;;;
E0164;VARIATION SELECTOR-117;Mn;0;NSM;;;;;N;;;;;
E0165;VARIATION SELECTOR-118;Mn;0;NSM;;;;;N;;;;;
E0166;VARIATION SELECTOR-119;Mn;0;NSM;;;;;N;;;;;
E0167;VARIATION SELECTOR-120;Mn;0;NSM;;;;;N;;;;;
E0168;VARIATION SELECTOR-121;Mn;0;NSM;;;;;N;;;;;
E0169;VARIATION SELECTOR-122;Mn;0;NSM;;;;;N;;;;;
E016A;VARIATION SELECTOR-123;Mn;0;NSM;;;;;N;;;;;
E016B;VARIATION SELECTOR-124;Mn;0;NSM;;;;;N;;;;;
E016C;VARIATION SELECTOR-125;Mn;0;NSM;;;;;N;;;;;
E016D;VARIATION SELECTOR-126;Mn;0;NSM;;;;;N;;;;;
E016E;VARIATION SELECTOR-127;Mn;0;NSM;;;;;N;;;;;
E016F;VARIATION SELECTOR-128;Mn;0;NSM;;;;;N;;;;;
E0170;VARIATION SELECTOR-129;Mn;0;NSM;;;;;N;;;;;
E0171;VARIATION SELECTOR-130;Mn;0;NSM;;;;;N;;;;;
E0172;VARIATION SELECTOR-131;Mn;0;NSM;;;;;N;;;;;
E0173;VARIATION SELECTOR-132;Mn;0;NSM;;;;;N;;;;;
E0174;VARIATION SELECTOR-133;Mn;0;NSM;;;;;N;;;;;
E0175;VARIATION SELECTOR-134;Mn;0;NSM;;;;;N;;;;;
E0176;VARIATION SELECTOR-135;Mn;0;NSM;;;;;N;;;;;
E0177;VARIATION SELECTOR-136;Mn;0;NSM;;;;;N;;;;;
E0178;VARIATION SELECTOR-137;Mn;0;NSM;;;;;N;;;;;
E0179;VARIATION SELECTOR-138;Mn;0;NSM;;;;;N;;;;;
E017A;VARIATION SELECTOR-139;Mn;0;NSM;;;;;N;;;;;
E017B;VARIATION SELECTOR-140;Mn;0;NSM;;;;;N;;;;;
E017C;VARIATION SELECTOR-141;Mn;0;NSM;;;;;N;;;;;
E017D;VARIATION SELECTOR-142;Mn;0;NSM;;;;;N;;;;;
E017E;VARIATION SELECTOR-143;Mn;0;NSM;;;;;N;;;;;
E017F;VARIATION SELECTOR-144;Mn;0;NSM;;;;;N;;;;;
E0180;VARIATION SELECTOR-145;Mn;0;NSM;;;;;N;;;;;
E0181;VARIATION SELECTOR-146;Mn;0;NSM;;;;;N;;;;;
E0182;VARIATION SELECTOR-147;Mn;0;NSM;;;;;N;;;;;
E0183;VARIATION SELECTOR-148;Mn;0;NSM;;;;;N;;;;;
E0184;VARIATION SELECTOR-149;Mn;0;NSM;;;;;N;;;;;
E0185;VARIATION SELECTOR-150;Mn;0;NSM;;;;;N;;;;;
E0186;VARIATION SELECTOR-151;Mn;0;NSM;;;;;N;;;;;
E0187;VARIATION SELECTOR-152;Mn;0;NSM;;;;;N;;;;;
E0188;VARIATION SELECTOR-153;Mn;0;NSM;;;;;N;;;;;
E0189;VARIATION SELECTOR-154;Mn;0;NSM;;;;;N;;;;;
E018A;VARIATION SELECTOR-155;Mn;0;NSM;;;;;N;;;;;
E018B;VARIATION SELECTOR-156;Mn;0;NSM;;;;;N;;;;;
E018C;VARIATION SELECTOR-157;Mn;0;NSM;;;;;N;;;;;
E018D;VARIATION SELECTOR-158;Mn;0;NSM;;;;;N;;;;;
E018E;VARIATION SELECTOR-159;Mn;0;NSM;;;;;N;;;;;
E018F;VARIATION SELECTOR-160;Mn;0;NSM;;;;;N;;;;;
E0190;VARIATION SELECTOR-161;Mn;0;NSM;;;;;N;;;;;
E0191;VARIATION SELECTOR-162;Mn;0;NSM;;;;;N;;;;;
E0192;VARIATION SELECTOR-163;Mn;0;NSM;;;;;N;;;;;
E0193;VARIATION SELECTOR-164;Mn;0;NSM;;;;;N;;;;;
E0194;VARIATION SELECTOR-165;Mn;0;NSM;;;;;N;;;;;
E0195;VARIATION SELECTOR-166;Mn;0;NSM;;;;;N;;;;;
E0196;VARIATION SELECTOR-167;Mn;0;NSM;;;;;N;;;;;
E0197;VARIATION SELECTOR-168;Mn;0;NSM;;;;;N;;;;;
E0198;VARIATION SELECTOR-169;Mn;0;NSM;;;;;N;;;;;
E0199;VARIATION SELECTOR-170;Mn;0;NSM;;;;;N;;;;;
E019A;VARIATION SELECTOR-171;Mn;0;NSM;;;;;N;;;;;
E019B;VARIATION SELECTOR-172;Mn;0;NSM;;;;;N;;;;;
E019C;VARIATION SELECTOR-173;Mn;0;NSM;;;;;N;;;;;
E019D;VARIATION SELECTOR-174;Mn;0;NSM;;;;;N;;;;;
E019E;VARIATION SELECTOR-175;Mn;0;NSM;;;;;N;;;;;
E019F;VARIATION SELECTOR-176;Mn;0;NSM;;;;;N;;;;;
E01A0;VARIATION SELECTOR-177;Mn;0;NSM;;;;;N;;;;;
E01A1;VARIATION SELECTOR-178;Mn;0;NSM;;;;;N;;;;;
E01A2;VARIATION SELECTOR-179;Mn;0;NSM;;;;;N;;;;;
E01A3;VARIATION SELECTOR-180;Mn;0;NSM;;;;;N;;;;;
E01A4;VARIATION SELECTOR-181;Mn;0;NSM;;;;;N;;;;;
E01A5;VARIATION SELECTOR-182;Mn;0;NSM;;;;;N;;;;;
E01A6;VARIATION SELECTOR-183;Mn;0;NSM;;;;;N;;;;;
E01A7;VARIATION SELECTOR-184;Mn;0;NSM;;;;;N;;;;;
E01A8;VARIATION SELECTOR-185;Mn;0;NSM;;;;;N;;;;;
E01A9;VARIATION SELECTOR-186;Mn;0;NSM;;;;;N;;;;;
E01AA;VARIATION SELECTOR-187;Mn;0;NSM;;;;;N;;;;;
E01AB;VARIATION SELECTOR-188;Mn;0;NSM;;;;;N;;;;;
E01AC;VARIATION SELECTOR-189;Mn;0;NSM;;;;;N;;;;;
E01AD;VARIATION SELECTOR-190;Mn;0;NSM;;;;;N;;;;;
E01AE;VARIATION SELECTOR-191;Mn;0;NSM;;;;;N;;;;;
E01AF;VARIATION SELECTOR-192;Mn;0;NSM;;;;;N;;;;;
E01B0;VARIATION SELECTOR-193;Mn;0;NSM;;;;;N;;;;;
E01B1;VARIATION SELECTOR-194;Mn;0;NSM;;;;;N;;;;;
E01B2;VARIATION SELECTOR-195;Mn;0;NSM;;;;;N;;;;;
E01B3;VARIATION SELECTOR-196;Mn;0;NSM;;;;;N;;;;;
E01B4;VARIATION SELECTOR-197;Mn;0;NSM;;;;;N;;;;;
E01B5;VARIATION SELECTOR-198;Mn;0;NSM;;;;;N;;;;;
E01B6;VARIATION SELECTOR-199;Mn;0;NSM;;;;;N;;;;;
E01B7;VARIATION SELECTOR-200;Mn;0;NSM;;;;;N;;;;;
E01B8;VARIATION SELECTOR-201;Mn;0;NSM;;;;;N;;;;;
E01B9;VARIATION SELECTOR-202;Mn;0;NSM;;;;;N;;;;;
E01BA;VARIATION SELECTOR-203;Mn;0;NSM;;;;;N;;;;;
E01BB;VARIATION SELECTOR-204;Mn;0;NSM;;;;;N;;;;;
E01BC;VARIATION SELECTOR-205;Mn;0;NSM;;;;;N;;;;;
E01BD;VARIATION SELECTOR-206;Mn;0;NSM;;;;;N;;;;;
E01BE;VARIATION SELECTOR-207;Mn;0;NSM;;;;;N;;;;;
E01BF;VARIATION SELECTOR-208;Mn;0;NSM;;;;;N;;;;;
E01C0;VARIATION SELECTOR-209;Mn;0;NSM;;;;;N;;;;;
E01C1;VARIATION SELECTOR-210;Mn;0;NSM;;;;;N;;;;;
E01C2;VARIATION SELECTOR-211;Mn;0;NSM;;;;;N;;;;;
E01C3;VARIATION SELECTOR-212;Mn;0;NSM;;;;;N;;;;;
E01C4;VARIATION SELECTOR-213;Mn;0;NSM;;;;;N;;;;;
E01C5;VARIATION SELECTOR-214;Mn;0;NSM;;;;;N;;;;;
E01C6;VARIATION SELECTOR-215;Mn;0;NSM;;;;;N;;;;;
E01C7;VARIATION SELECTOR-216;Mn;0;NSM;;;;;N;;;;;
E01C8;VARIATION SELECTOR-217;Mn;0;NSM;;;;;N;;;;;
E01C9;VARIATION SELECTOR-218;Mn;0;NSM;;;;;N;;;;;
E01CA;VARIATION SELECTOR-219;Mn;0;NSM;;;;;N;;;;;
E01CB;VARIATION SELECTOR-220;Mn;0;NSM;;;;;N;;;;;
E01CC;VARIATION SELECTOR-221;Mn;0;NSM;;;;;N;;;;;
E01CD;VARIATION SELECTOR-222;Mn;0;NSM;;;;;N;;;;;
E01CE;VARIATION SELECTOR-223;Mn;0;NSM;;;;;N;;;;;
E01CF;VARIATION SELECTOR-224;Mn;0;NSM;;;;;N;;;;;
E01D0;VARIATION SELECTOR-225;Mn;0;NSM;;;;;N;;;;;
E01D1;VARIATION SELECTOR-226;Mn;0;NSM;;;;;N;;;;;
E01D2;VARIATION SELECTOR-227;Mn;0;NSM;;;;;N;;;;;
E01D3;VARIATION SELECTOR-228;Mn;0;NSM;;;;;N;;;;;
E01D4;VARIATION SELECTOR-229;Mn;0;NSM;;;;;N;;;;;
E01D5;VARIATION SELECTOR-230;Mn;0;NSM;;;;;N;;;;;
E01D6;VARIATION SELECTOR-231;Mn;0;NSM;;;;;N;;;;;
E01D7;VARIATION SELECTOR-232;Mn;0;NSM;;;;;N;;;;;
E01D8;VARIATION SELECTOR-233;Mn;0;NSM;;;;;N;;;;;
E01D9;VARIATION SELECTOR-234;Mn;0;NSM;;;;;N;;;;;
E01DA;VARIATION SELECTOR-235;Mn;0;NSM;;;;;N;;;;;
E01DB;VARIATION SELECTOR-236;Mn;0;NSM;;;;;N;;;;;
E01DC;VARIATION SELECTOR-237;Mn;0;NSM;;;;;N;;;;;
E01DD;VARIATION SELECTOR-238;Mn;0;NSM;;;;;N;;;;;
E01DE;VARIATION SELECTOR-239;Mn;0;NSM;;;;;N;;;;;
E01DF;VARIATION SELECTOR-240;Mn;0;NSM;;;;;N;;;;;
E01E0;VARIATION SELECTOR-241;Mn;0;NSM;;;;;N;;;;;
E01E1;VARIATION SELECTOR-242;Mn;0;NSM;;;;;N;;;;;
E01E2;VARIATION SELECTOR-243;Mn;0;NSM;;;;;N;;;;;
E01E3;VARIATION SELECTOR-244;Mn;0;NSM;;;;;N;;;;;
E01E4;VARIATION SELECTOR-245;Mn;0;NSM;;;;;N;;;;;
E01E5;VARIATION SELECTOR-246;Mn;0;NSM;;;;;N;;;;;
E01E6;VARIATION SELECTOR-247;Mn;0;NSM;;;;;N;;;;;
E01E7;VARIATION SELECTOR-248;Mn;0;NSM;;;;;N;;;;;
E01E8;VARIATION SELECTOR-249;Mn;0;NSM;;;;;N;;;;;
E01E9;VARIATION SELECTOR-250;Mn;0;NSM;;;;;N;;;;;
E01EA;VARIATION SELECTOR-251;Mn;0;NSM;;;;;N;;;;;
E01EB;VARIATION SELECTOR-252;Mn;0;NSM;;;;;N;;;;;
E01EC;VARIATION SELECTOR-253;Mn;0;NSM;;;;;N;;;;;
E01ED;VARIATION SELECTOR-254;Mn;0;NSM;;;;;N;;;;;
E01EE;VARIATION SELECTOR-255;Mn;0;NSM;;;;;N;;;;;
E01EF;VARIATION SELECTOR-256;Mn;0;NSM;;;;;N;;;;;
F0000;<Plane 15 Private Use, First>;Co;0;L;;;;;N;;;;;
FFFFD;<Plane 15 Private Use, Last>;Co;0;L;;;;;N;;;;;
100000;<Plane 16 Private Use, First>;Co;0;L;;;;;N;;;;;
10FFFD;<Plane 16 Private Use, Last>;Co;0;L;;;;;N;;;;;
"""
